/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(K){for(var e=[],I=0,L=K.length;I<L;I++)e[I]=ae[K[I]];return e};define(ae[135],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function I(y,E,u){const d=L(y,E);if(d!==-1)return y[d]}e.findLast=I;function L(y,E,u=y.length-1){for(let d=u;d>=0;d--){const f=y[d];if(E(f))return d}return-1}e.findLastIdx=L;function r(y,E){const u=O(y,E);return u===-1?void 0:y[u]}e.findLastMonotonous=r;function O(y,E,u=0,d=y.length){let f=u,m=d;for(;f<m;){const a=Math.floor((f+m)/2);E(y[a])?f=a+1:m=a}return f-1}e.findLastIdxMonotonous=O;function M(y,E){const u=C(y,E);return u===y.length?void 0:y[u]}e.findFirstMonotonous=M;function C(y,E,u=0,d=y.length){let f=u,m=d;for(;f<m;){const a=Math.floor((f+m)/2);E(y[a])?m=a:f=a+1}return f}e.findFirstIdxMonotonousOrArrLen=C;function g(y,E,u=0,d=y.length){const f=C(y,E,u,d);return f===y.length?-1:f}e.findFirstIdxMonotonous=g;class c{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(c.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!E(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const u=O(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}e.MonotonousArray=c;function v(y,E){if(y.length===0)return;let u=y[0];for(let d=1;d<y.length;d++){const f=y[d];E(f,u)>0&&(u=f)}return u}e.findFirstMaxBy=v;function b(y,E){if(y.length===0)return;let u=y[0];for(let d=1;d<y.length;d++){const f=y[d];E(f,u)>=0&&(u=f)}return u}e.findLastMaxBy=b;function w(y,E){return v(y,(u,d)=>-E(u,d))}e.findFirstMinBy=w;function h(y,E){if(y.length===0)return-1;let u=0;for(let d=1;d<y.length;d++){const f=y[d];E(f,y[u])>0&&(u=d)}return u}e.findMaxIdxBy=h;function p(y,E){for(const u of y){const d=E(u);if(d!==void 0)return d}}e.mapFindFirst=p}),define(ae[136],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function I(M,C){const g=Object.create(null);for(const c of M){const v=C(c);let b=g[v];b||(b=g[v]=[]),b.push(c)}return g}e.groupBy=I;function L(M,C){const g=[],c=[];for(const v of M)C.has(v)||g.push(v);for(const v of C)M.has(v)||c.push(v);return{removed:g,added:c}}e.diffSets=L;function r(M,C){const g=[],c=[];for(const[v,b]of M)C.has(v)||g.push(b);for(const[v,b]of C)M.has(v)||c.push(b);return{removed:g,added:c}}e.diffMaps=r;function O(M,C){const g=new Set;for(const c of C)M.has(c)&&g.add(c);return g}e.intersection=O}),define(ae[137],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(C,g){const c=Math.pow(10,g);return Math.round(C*c)/c}class L{constructor(g,c,v,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=I(Math.max(Math.min(1,b),0),3)}static equals(g,c){return g.r===c.r&&g.g===c.g&&g.b===c.b&&g.a===c.a}}e.RGBA=L;class r{constructor(g,c,v,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=I(Math.max(Math.min(1,c),0),3),this.l=I(Math.max(Math.min(1,v),0),3),this.a=I(Math.max(Math.min(1,b),0),3)}static equals(g,c){return g.h===c.h&&g.s===c.s&&g.l===c.l&&g.a===c.a}static fromRGBA(g){const c=g.r/255,v=g.g/255,b=g.b/255,w=g.a,h=Math.max(c,v,b),p=Math.min(c,v,b);let y=0,E=0;const u=(p+h)/2,d=h-p;if(d>0){switch(E=Math.min(u<=.5?d/(2*u):d/(2-2*u),1),h){case c:y=(v-b)/d+(v<b?6:0);break;case v:y=(b-c)/d+2;break;case b:y=(c-v)/d+4;break}y*=60,y=Math.round(y)}return new r(y,E,u,w)}static _hue2rgb(g,c,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?g+(c-g)*6*v:v<1/2?c:v<2/3?g+(c-g)*(2/3-v)*6:g}static toRGBA(g){const c=g.h/360,{s:v,l:b,a:w}=g;let h,p,y;if(v===0)h=p=y=b;else{const E=b<.5?b*(1+v):b+v-b*v,u=2*b-E;h=r._hue2rgb(u,E,c+1/3),p=r._hue2rgb(u,E,c),y=r._hue2rgb(u,E,c-1/3)}return new L(Math.round(h*255),Math.round(p*255),Math.round(y*255),w)}}e.HSLA=r;class O{constructor(g,c,v,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=I(Math.max(Math.min(1,c),0),3),this.v=I(Math.max(Math.min(1,v),0),3),this.a=I(Math.max(Math.min(1,b),0),3)}static equals(g,c){return g.h===c.h&&g.s===c.s&&g.v===c.v&&g.a===c.a}static fromRGBA(g){const c=g.r/255,v=g.g/255,b=g.b/255,w=Math.max(c,v,b),h=Math.min(c,v,b),p=w-h,y=w===0?0:p/w;let E;return p===0?E=0:w===c?E=((v-b)/p%6+6)%6:w===v?E=(b-c)/p+2:E=(c-v)/p+4,new O(Math.round(E*60),y,w,g.a)}static toRGBA(g){const{h:c,s:v,v:b,a:w}=g,h=b*v,p=h*(1-Math.abs(c/60%2-1)),y=b-h;let[E,u,d]=[0,0,0];return c<60?(E=h,u=p):c<120?(E=p,u=h):c<180?(u=h,d=p):c<240?(u=p,d=h):c<300?(E=p,d=h):c<=360&&(E=h,d=p),E=Math.round((E+y)*255),u=Math.round((u+y)*255),d=Math.round((d+y)*255),new L(E,u,d,w)}}e.HSVA=O;class M{static fromHex(g){return M.Format.CSS.parseHex(g)||M.red}static equals(g,c){return!g&&!c?!0:!g||!c?!1:g.equals(c)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof L)this.rgba=g;else if(g instanceof r)this._hsla=g,this.rgba=r.toRGBA(g);else if(g instanceof O)this._hsva=g,this.rgba=O.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&L.equals(this.rgba,g.rgba)&&r.equals(this.hsla,g.hsla)&&O.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=M._relativeLuminanceForComponent(this.rgba.r),c=M._relativeLuminanceForComponent(this.rgba.g),v=M._relativeLuminanceForComponent(this.rgba.b),b=.2126*g+.7152*c+.0722*v;return I(b,4)}static _relativeLuminanceForComponent(g){const c=g/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(g){const c=this.getRelativeLuminance(),v=g.getRelativeLuminance();return c>v?(c+.05)/(v+.05):(v+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const c=this.getRelativeLuminance(),v=g.getRelativeLuminance();return c>v}isDarkerThan(g){const c=this.getRelativeLuminance(),v=g.getRelativeLuminance();return c<v}lighten(g){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new M(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:c,g:v,b,a:w}=this.rgba;return new M(new L(c,v,b,w*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const c=g.rgba,v=this.rgba.a,b=c.a,w=v+b*(1-v);if(w<1e-6)return M.transparent;const h=this.rgba.r*v/w+c.r*b*(1-v)/w,p=this.rgba.g*v/w+c.g*b*(1-v)/w,y=this.rgba.b*v/w+c.b*b*(1-v)/w;return new M(new L(h,p,y,w))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:c,g:v,b,a:w}=this.rgba;return new M(new L(g.rgba.r-w*(g.rgba.r-c),g.rgba.g-w*(g.rgba.g-v),g.rgba.b-w*(g.rgba.b-b),1))}flatten(...g){const c=g.reduceRight((v,b)=>M._flatten(b,v));return M._flatten(this,c)}static _flatten(g,c){const v=1-g.rgba.a;return new M(new L(v*c.rgba.r+g.rgba.a*g.rgba.r,v*c.rgba.g+g.rgba.a*g.rgba.g,v*c.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(g,c,v){if(g.isLighterThan(c))return g;v=v||.5;const b=g.getRelativeLuminance(),w=c.getRelativeLuminance();return v=v*(w-b)/w,g.lighten(v)}static getDarkerColor(g,c,v){if(g.isDarkerThan(c))return g;v=v||.5;const b=g.getRelativeLuminance(),w=c.getRelativeLuminance();return v=v*(b-w)/b,g.darken(v)}static{this.white=new M(new L(255,255,255,1))}static{this.black=new M(new L(0,0,0,1))}static{this.red=new M(new L(255,0,0,1))}static{this.blue=new M(new L(0,0,255,1))}static{this.green=new M(new L(0,255,0,1))}static{this.cyan=new M(new L(0,255,255,1))}static{this.lightgrey=new M(new L(211,211,211,1))}static{this.transparent=new M(new L(0,0,0,0))}}e.Color=M,function(C){let g;(function(c){let v;(function(b){function w(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:C.Format.CSS.formatRGBA(t)}b.formatRGB=w;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=h;function p(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(t)}b.formatHSL=p;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=y;function E(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function u(t){return`#${E(t.rgba.r)}${E(t.rgba.g)}${E(t.rgba.b)}`}b.formatHex=u;function d(t,o=!1){return o&&t.rgba.a===1?C.Format.CSS.formatHex(t):`#${E(t.rgba.r)}${E(t.rgba.g)}${E(t.rgba.b)}${E(Math.round(t.rgba.a*255))}`}b.formatHexA=d;function f(t){return t.isOpaque()?C.Format.CSS.formatHex(t):C.Format.CSS.formatRGBA(t)}b.format=f;function m(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new C(new L(s,i,n,1))}if(o===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new C(new L(s,i,n,l/255))}if(o===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3));return new C(new L(16*s+s,16*i+i,16*n+n))}if(o===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new C(new L(16*s+s,16*i+i,16*n+n,(16*l+l)/255))}return null}b.parseHex=m;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=c.CSS||(c.CSS={}))})(g=C.Format||(C.Format={}))}(M||(e.Color=M={}))}),define(ae[50],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(M){return(C,g,c)=>{let v=null,b=null;if(typeof c.value=="function"?(v="value",b=c.value):typeof c.get=="function"&&(v="get",b=c.get),!b)throw new Error("not supported");c[v]=M(b,g)}}function L(M,C,g){let c=null,v=null;if(typeof g.value=="function"?(c="value",v=g.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",v=g.get),!v)throw new Error("not supported");const b=`$memoize$${C}`;g[c]=function(...w){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,w)}),this[b]}}e.memoize=L;function r(M,C,g){return I((c,v)=>{const b=`$debounce$${v}`,w=`$debounce$result$${v}`;return function(...h){this[w]||(this[w]=g?g():void 0),clearTimeout(this[b]),C&&(this[w]=C(this[w],...h),h=[this[w]]),this[b]=setTimeout(()=>{c.apply(this,h),this[w]=g?g():void 0},M)}})}e.debounce=r;function O(M,C,g){return I((c,v)=>{const b=`$throttle$timer$${v}`,w=`$throttle$result$${v}`,h=`$throttle$lastRun$${v}`,p=`$throttle$pending$${v}`;return function(...y){if(this[w]||(this[w]=g?g():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),C&&(this[w]=C(this[w],...y)),this[p])return;const E=this[h]+M;E<=Date.now()?(this[h]=Date.now(),c.apply(this,[this[w]]),this[w]=g?g():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[h]=Date.now(),c.apply(this,[this[w]]),this[w]=g?g():void 0},E-Date.now()))}})}e.throttle=O}),define(ae[15],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?f.isErrorNoTelemetry(t)?new f(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=I,e.errorHandler=new I;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function r(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function O(a){c(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=O;function M(a){c(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=M;function C(a){if(a instanceof Error){const{name:t,message:o}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:f.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=C;const g="Canceled";function c(a){return a instanceof v?!0:a instanceof Error&&a.name===g&&a.message===g}e.isCancellationError=c;class v extends Error{constructor(){super(g),this.name=this.message}}e.CancellationError=v;function b(){const a=new Error(g);return a.name=a.message,a}e.canceled=b;function w(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=w;function h(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=h;class p extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=p;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=y;class E extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=E;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class f extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof f)return t;const o=new f;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.BugIndicatingError=m}),define(ae[22],ce([0,1,15,135]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(B,X=0){return B[B.length-(1+X)]}e.tail=r;function O(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=O;function M(B,X,x=(Z,z)=>Z===z){if(B===X)return!0;if(!B||!X||B.length!==X.length)return!1;for(let Z=0,z=B.length;Z<z;Z++)if(!x(B[Z],X[Z]))return!1;return!0}e.equals=M;function C(B,X){const x=B.length-1;X<x&&(B[X]=B[x]),B.pop()}e.removeFastWithoutKeepingOrder=C;function g(B,X,x){return c(B.length,Z=>x(B[Z],X))}e.binarySearch=g;function c(B,X){let x=0,Z=B-1;for(;x<=Z;){const z=(x+Z)/2|0,ee=X(z);if(ee<0)x=z+1;else if(ee>0)Z=z-1;else return z}return-(x+1)}e.binarySearch2=c;function v(B,X,x){if(B=B|0,B>=X.length)throw new TypeError("invalid index");const Z=X[Math.floor(X.length*Math.random())],z=[],ee=[],ie=[];for(const fe of X){const pe=x(fe,Z);pe<0?z.push(fe):pe>0?ee.push(fe):ie.push(fe)}return B<z.length?v(B,z,x):B<z.length+ie.length?ie[0]:v(B-(z.length+ie.length),ee,x)}e.quickSelect=v;function b(B,X){const x=[];let Z;for(const z of B.slice(0).sort(X))!Z||X(Z[0],z)!==0?(Z=[z],x.push(Z)):Z.push(z);return x}e.groupBy=b;function*w(B,X){let x,Z;for(const z of B)Z!==void 0&&X(Z,z)?x.push(z):(x&&(yield x),x=[z]),Z=z;x&&(yield x)}e.groupAdjacentBy=w;function h(B,X){for(let x=0;x<=B.length;x++)X(x===0?void 0:B[x-1],x===B.length?void 0:B[x])}e.forEachAdjacent=h;function p(B,X){for(let x=0;x<B.length;x++)X(x===0?void 0:B[x-1],B[x],x+1===B.length?void 0:B[x+1])}e.forEachWithNeighbors=p;function y(B,X,x){const Z=[];function z(fe,pe,Pe){if(pe===0&&Pe.length===0)return;const Ce=Z[Z.length-1];Ce&&Ce.start+Ce.deleteCount===fe?(Ce.deleteCount+=pe,Ce.toInsert.push(...Pe)):Z.push({start:fe,deleteCount:pe,toInsert:Pe})}let ee=0,ie=0;for(;;){if(ee===B.length){z(ee,0,X.slice(ie));break}if(ie===X.length){z(ee,B.length-ee,[]);break}const fe=B[ee],pe=X[ie],Pe=x(fe,pe);Pe===0?(ee+=1,ie+=1):Pe<0?(z(ee,1,[]),ee+=1):Pe>0&&(z(ee,0,[pe]),ie+=1)}return Z}e.sortedDiff=y;function E(B,X,x){const Z=y(B,X,x),z=[],ee=[];for(const ie of Z)z.push(...B.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:z,added:ee}}e.delta=E;function u(B,X,x){if(x===0)return[];const Z=B.slice(0,x).sort(X);return f(B,X,Z,x,B.length),Z}e.top=u;function d(B,X,x,Z,z){return x===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const fe=B.length,pe=B.slice(0,x).sort(X);for(let Pe=x,Ce=Math.min(x+Z,fe);Pe<fe;Pe=Ce,Ce=Math.min(Ce+Z,fe)){if(Pe>x&&await new Promise(We=>setTimeout(We)),z&&z.isCancellationRequested)throw new I.CancellationError;f(B,X,pe,Pe,Ce)}return pe})().then(ee,ie)})}e.topAsync=d;function f(B,X,x,Z,z){for(const ee=x.length;Z<z;Z++){const ie=B[Z];if(X(ie,x[ee-1])<0){x.pop();const fe=(0,L.findFirstIdxMonotonousOrArrLen)(x,pe=>X(ie,pe)<0);x.splice(fe,0,ie)}}}function m(B){return B.filter(X=>!!X)}e.coalesce=m;function a(B){let X=0;for(let x=0;x<B.length;x++)B[x]&&(B[X]=B[x],X+=1);B.length=X}e.coalesceInPlace=a;function t(B,X,x){B.splice(x,0,B.splice(X,1)[0])}e.move=t;function o(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=o;function s(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=s;function i(B,X=x=>x){const x=new Set;return B.filter(Z=>{const z=X(Z);return x.has(z)?!1:(x.add(z),!0)})}e.distinct=i;function n(B){const X=new Set;return x=>{const Z=B(x);return X.has(Z)?!1:(X.add(Z),!0)}}e.uniqueFilter=n;function l(B,X){return B.length>0?B[0]:X}e.firstOrDefault=l;function S(B,X){return B.length>0?B[B.length-1]:X}e.lastOrDefault=S;function R(B,X,x=(Z,z)=>Z===z){let Z=0;for(let z=0,ee=Math.min(B.length,X.length);z<ee&&x(B[z],X[z]);z++)Z++;return Z}e.commonPrefixLength=R;function k(B){return[].concat(...B)}e.flatten=k;function P(B,X){let x=typeof X=="number"?B:0;typeof X=="number"?x=B:(x=0,X=B);const Z=[];if(x<=X)for(let z=x;z<X;z++)Z.push(z);else for(let z=x;z>X;z--)Z.push(z);return Z}e.range=P;function D(B,X,x){return B.reduce((Z,z)=>(Z[X(z)]=x?x(z):z,Z),Object.create(null))}e.index=D;function _(B,X){return B.push(X),()=>U(B,X)}e.insert=_;function U(B,X){const x=B.indexOf(X);if(x>-1)return B.splice(x,1),X}e.remove=U;function F(B,X,x){const Z=B.slice(0,X),z=B.slice(X);return Z.concat(x,z)}e.arrayInsert=F;function H(B,X){let x;if(typeof X=="number"){let Z=X;x=()=>{const z=Math.sin(Z++)*179426549;return z-Math.floor(z)}}else x=Math.random;for(let Z=B.length-1;Z>0;Z-=1){const z=Math.floor(x()*(Z+1)),ee=B[Z];B[Z]=B[z],B[z]=ee}}e.shuffle=H;function j(B,X){const x=B.indexOf(X);x>-1&&(B.splice(x,1),B.unshift(X))}e.pushToStart=j;function le(B,X){const x=B.indexOf(X);x>-1&&(B.splice(x,1),B.push(X))}e.pushToEnd=le;function se(B,X){for(const x of X)B.push(x)}e.pushMany=se;function ue(B,X){return Array.isArray(B)?B.map(X):X(B)}e.mapArrayOrNot=ue;function Y(B){return Array.isArray(B)?B:[B]}e.asArray=Y;function Q(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=Q;function q(B,X,x){const Z=N(B,X),z=B.length,ee=x.length;B.length=z+ee;for(let ie=z-1;ie>=Z;ie--)B[ie+ee]=B[ie];for(let ie=0;ie<ee;ie++)B[ie+Z]=x[ie]}e.insertInto=q;function W(B,X,x,Z){const z=N(B,X);let ee=B.splice(z,x);return ee===void 0&&(ee=[]),q(B,z,Z),ee}e.splice=W;function N(B,X){return X<0?Math.max(X+B.length,0):Math.min(X,B.length)}var V;(function(B){function X(ee){return ee<0}B.isLessThan=X;function x(ee){return ee<=0}B.isLessThanOrEqual=x;function Z(ee){return ee>0}B.isGreaterThan=Z;function z(ee){return ee===0}B.isNeitherLessOrGreaterThan=z,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function $(B,X){return(x,Z)=>X(B(x),B(Z))}e.compareBy=$;function oe(...B){return(X,x)=>{for(const Z of B){const z=Z(X,x);if(!V.isNeitherLessOrGreaterThan(z))return z}return V.neitherLessOrGreaterThan}}e.tieBreakComparators=oe;const de=(B,X)=>B-X;e.numberComparator=de;const G=(B,X)=>(0,e.numberComparator)(B?1:0,X?1:0);e.booleanComparator=G;function A(B){return(X,x)=>-B(X,x)}e.reverseOrder=A;class T{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let x=this.firstIdx;for(;x<this.items.length&&X(this.items[x]);)x++;const Z=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,Z}takeFromEndWhile(X){let x=this.lastIdx;for(;x>=0&&X(this.items[x]);)x--;const Z=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}removeLast(){const X=this.items[this.lastIdx];return this.lastIdx--,X}takeCount(X){const x=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,x}}e.ArrayQueue=T;class J{static{this.empty=new J(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(x=>(X(x),!0))}toArray(){const X=[];return this.iterate(x=>(X.push(x),!0)),X}filter(X){return new J(x=>this.iterate(Z=>X(Z)?x(Z):!0))}map(X){return new J(x=>this.iterate(Z=>x(X(Z))))}some(X){let x=!1;return this.iterate(Z=>(x=X(Z),!x)),x}findFirst(X){let x;return this.iterate(Z=>X(Z)?(x=Z,!1):!0),x}findLast(X){let x;return this.iterate(Z=>(X(Z)&&(x=Z),!0)),x}findLastMaxBy(X){let x,Z=!0;return this.iterate(z=>((Z||V.isGreaterThan(X(z,x)))&&(Z=!1,x=z),!0)),x}}e.CallbackIterable=J}),define(ae[138],ce([0,1,15]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function L(c,v){if(!c)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=L;function r(c,v="Unreachable"){throw new Error(v)}e.assertNever=r;function O(c){if(!c)throw new I.BugIndicatingError("Assertion Failed")}e.assert=O;function M(c){c||(0,I.onUnexpectedError)(new I.BugIndicatingError("Soft Assertion Failed"))}e.softAssert=M;function C(c){if(!c()){debugger;c(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function g(c,v){let b=0;for(;b<c.length-1;){const w=c[b],h=c[b+1];if(!v(w,h))return!1;b++}return!0}e.checkAdjacentItems=g}),define(ae[85],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function I(L,r){const O=this;let M=!1,C;return function(){if(M)return C;if(M=!0,r)try{C=L.apply(O,arguments)}finally{r()}else C=L.apply(O,arguments);return C}}e.createSingleCallFunction=I}),define(ae[71],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(L){function r(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=r;const O=Object.freeze([]);function M(){return O}L.empty=M;function*C(t){yield t}L.single=C;function g(t){return r(t)?t:C(t)}L.wrap=g;function c(t){return t||O}L.from=c;function*v(t){for(let o=t.length-1;o>=0;o--)yield t[o]}L.reverse=v;function b(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=b;function w(t){return t[Symbol.iterator]().next().value}L.first=w;function h(t,o){for(const s of t)if(o(s))return!0;return!1}L.some=h;function p(t,o){for(const s of t)if(o(s))return s}L.find=p;function*y(t,o){for(const s of t)o(s)&&(yield s)}L.filter=y;function*E(t,o){let s=0;for(const i of t)yield o(i,s++)}L.map=E;function*u(...t){for(const o of t)yield*o}L.concat=u;function d(t,o,s){let i=s;for(const n of t)i=o(i,n);return i}L.reduce=d;function*f(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}L.slice=f;function m(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const l=i.next();if(l.done)return[s,L.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return i}}]}L.consume=m;async function a(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}L.asyncToArray=a})(I||(e.Iterable=I={}))}),define(ae[42],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(t,o=!1){let s=0;const i=t.length;let n="",l=0,S=16,R=0;function k(j){let le=0,se=0;for(;le<j;){const ue=t.charCodeAt(s);if(ue>=48&&ue<=57)se=se*16+ue-48;else if(ue>=65&&ue<=70)se=se*16+ue-65+10;else if(ue>=97&&ue<=102)se=se*16+ue-97+10;else break;s++,le++}return le<j&&(se=-1),se}function P(j){s=j,n="",l=0,S=16,R=0}function D(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&c(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&c(t.charCodeAt(s)))for(s++;s<t.length&&c(t.charCodeAt(s));)s++;else return R=3,t.substring(j,s);let le=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&c(t.charCodeAt(s))){for(s++;s<t.length&&c(t.charCodeAt(s));)s++;le=s}else R=3;return t.substring(j,le)}function _(){let j="",le=s;for(;;){if(s>=i){j+=t.substring(le,s),R=2;break}const se=t.charCodeAt(s);if(se===34){j+=t.substring(le,s),s++;break}if(se===92){if(j+=t.substring(le,s),s++,s>=i){R=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=k(4);Y>=0?j+=String.fromCharCode(Y):R=4;break}default:R=5}le=s;continue}if(se>=0&&se<=31)if(g(se)){j+=t.substring(le,s),R=2;break}else R=6;s++}return j}function U(){if(n="",R=0,l=s,s>=i)return l=i,S=17;let j=t.charCodeAt(s);if(C(j)){do s++,n+=String.fromCharCode(j),j=t.charCodeAt(s);while(C(j));return S=15}if(g(j))return s++,n+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),S=14;switch(j){case 123:return s++,S=1;case 125:return s++,S=2;case 91:return s++,S=3;case 93:return s++,S=4;case 58:return s++,S=6;case 44:return s++,S=5;case 34:return s++,n=_(),S=10;case 47:{const le=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!g(t.charCodeAt(s));)s++;return n=t.substring(le,s),S=12}if(t.charCodeAt(s+1)===42){s+=2;const se=i-1;let ue=!1;for(;s<se;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ue=!0;break}s++}return ue||(s++,R=1),n=t.substring(le,s),S=13}return n+=String.fromCharCode(j),s++,S=16}case 45:if(n+=String.fromCharCode(j),s++,s===i||!c(t.charCodeAt(s)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),S=11;default:for(;s<i&&F(j);)s++,j=t.charCodeAt(s);if(l!==s){switch(n=t.substring(l,s),n){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return n+=String.fromCharCode(j),s++,S=16}}function F(j){if(C(j)||g(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let j;do j=U();while(j>=12&&j<=15);return j}return{setPosition:P,getPosition:()=>s,scan:o?H:U,getToken:()=>S,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>R}}e.createScanner=M;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var v;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(v||(v={}));function b(t,o){const s=[],i=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function R(k,P,D,_){l.value=k,l.offset=P,l.length=D,l.type=_,l.colonOffset=void 0,n=l}try{f(t,{onObjectBegin:(k,P)=>{if(o<=k)throw i;n=void 0,S=o>k,s.push("")},onObjectProperty:(k,P,D)=>{if(o<P||(R(k,P,D,"property"),s[s.length-1]=k,o<=P+D))throw i},onObjectEnd:(k,P)=>{if(o<=k)throw i;n=void 0,s.pop()},onArrayBegin:(k,P)=>{if(o<=k)throw i;n=void 0,s.push(0)},onArrayEnd:(k,P)=>{if(o<=k)throw i;n=void 0,s.pop()},onLiteralValue:(k,P,D)=>{if(o<P||(R(k,P,D,a(k)),o<=P+D))throw i},onSeparator:(k,P,D)=>{if(o<=P)throw i;if(k===":"&&n&&n.type==="property")n.colonOffset=P,S=!1,n=void 0;else if(k===","){const _=s[s.length-1];typeof _=="number"?s[s.length-1]=_+1:(S=!0,s[s.length-1]=""),n=void 0}}})}catch(k){if(k!==i)throw k}return{path:s,previousNode:n,isAtPropertyKey:S,matches:k=>{let P=0;for(let D=0;P<k.length&&D<s.length;D++)if(k[P]===s[D]||k[P]==="*")P++;else if(k[P]!=="**")return!1;return P===k.length}}}e.getLocation=b;function w(t,o=[],s=O.DEFAULT){let i=null,n=[];const l=[];function S(k){Array.isArray(n)?n.push(k):i!==null&&(n[i]=k)}return f(t,{onObjectBegin:()=>{const k={};S(k),l.push(n),n=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const k=[];S(k),l.push(n),n=k,i=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:S,onError:(k,P,D)=>{o.push({error:k,offset:P,length:D})}},s),n[0]}e.parse=w;function h(t,o=[],s=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function l(k){return i.children.push(k),k}f(t,{onObjectBegin:k=>{i=l({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,P,D)=>{i=l({type:"property",offset:P,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:P,length:D,parent:i})},onObjectEnd:(k,P)=>{i.length=k+P-i.offset,i=i.parent,n(k+P)},onArrayBegin:(k,P)=>{i=l({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,P)=>{i.length=k+P-i.offset,i=i.parent,n(k+P)},onLiteralValue:(k,P,D)=>{l({type:a(k),offset:P,length:D,parent:i,value:k}),n(P+D)},onSeparator:(k,P,D)=>{i.type==="property"&&(k===":"?i.colonOffset=P:k===","&&n(P))},onError:(k,P,D)=>{o.push({error:k,offset:P,length:D})}},s);const R=i.children[0];return R&&delete R.parent,R}e.parseTree=h;function p(t,o){if(!t)return;let s=t;for(const i of o)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],n=!0;break}if(!n)return}else{const n=i;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=p;function y(t){if(!t.parent||!t.parent.children)return[];const o=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.getNodePath=y;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":{const o=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(o[s.children[0].value]=E(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function u(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.contains=u;function d(t,o,s=!1){if(u(t,o,s)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const l=d(i[n],o,s);if(l)return l}return t}}e.findNodeAtOffset=d;function f(t,o,s=O.DEFAULT){const i=M(t,!1);function n($){return $?()=>$(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l($){return $?oe=>$(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const S=n(o.onObjectBegin),R=l(o.onObjectProperty),k=n(o.onObjectEnd),P=n(o.onArrayBegin),D=n(o.onArrayEnd),_=l(o.onLiteralValue),U=l(o.onSeparator),F=n(o.onComment),H=l(o.onError),j=s&&s.disallowComments,le=s&&s.allowTrailingComma;function se(){for(;;){const $=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:j||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch($){case 12:case 13:j?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return $}}}function ue($,oe=[],de=[]){if(H($),oe.length+de.length>0){let G=i.getToken();for(;G!==17;){if(oe.indexOf(G)!==-1){se();break}else if(de.indexOf(G)!==-1)break;G=se()}}}function Y($){const oe=i.getTokenValue();return $?_(oe):R(oe),se(),!0}function Q(){switch(i.getToken()){case 11:{let $=0;try{$=JSON.parse(i.getTokenValue()),typeof $!="number"&&(ue(2),$=0)}catch{ue(2)}_($);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return se(),!0}function q(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(U(":"),se(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function W(){S(),se();let $=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if($||ue(4,[],[]),U(","),se(),i.getToken()===2&&le)break}else $&&ue(6,[],[]);q()||ue(4,[],[2,5]),$=!0}return k(),i.getToken()!==2?ue(7,[2],[]):se(),!0}function N(){P(),se();let $=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if($||ue(4,[],[]),U(","),se(),i.getToken()===4&&le)break}else $&&ue(6,[],[]);V()||ue(4,[],[4,5]),$=!0}return D(),i.getToken()!==4?ue(8,[4],[]):se(),!0}function V(){switch(i.getToken()){case 3:return N();case 1:return W();case 10:return Y(!0);default:return Q()}}return se(),i.getToken()===17?s.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.visit=f;function m(t,o){const s=M(t),i=[];let n,l=0,S;do switch(S=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:l!==S&&i.push(t.substring(l,S)),o!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,o)),l=s.getPosition();break}while(n!==17);return i.join("")}e.stripComments=m;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ae[139],ce([0,1,42]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(c,v,b){let w,h,p,y,E;if(v){for(y=v.offset,E=y+v.length,p=y;p>0&&!g(c,p-1);)p--;let S=E;for(;S<c.length&&!g(c,S);)S++;h=c.substring(p,S),w=M(h,b)}else h=c,w=0,p=0,y=0,E=c.length;const u=C(b,c);let d=!1,f=0,m;b.insertSpaces?m=O(" ",b.tabSize||4):m="	";const a=(0,I.createScanner)(h,!1);let t=!1;function o(){return u+O(m,w+f)}function s(){let S=a.scan();for(d=!1;S===15||S===14;)d=d||S===14,S=a.scan();return t=S===16||a.getTokenError()!==0,S}const i=[];function n(S,R,k){!t&&R<E&&k>y&&c.substring(R,k)!==S&&i.push({offset:R,length:k-R,content:S})}let l=s();if(l!==17){const S=a.getTokenOffset()+p,R=O(m,w);n(R,p,S)}for(;l!==17;){let S=a.getTokenOffset()+a.getTokenLength()+p,R=s(),k="";for(;!d&&(R===12||R===13);){const D=a.getTokenOffset()+p;n(" ",S,D),S=a.getTokenOffset()+a.getTokenLength()+p,k=R===12?o():"",R=s()}if(R===2)l!==1&&(f--,k=o());else if(R===4)l!==3&&(f--,k=o());else{switch(l){case 3:case 1:f++,k=o();break;case 5:case 12:k=o();break;case 13:d?k=o():k=" ";break;case 6:k=" ";break;case 10:if(R===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?k=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}d&&(R===12||R===13)&&(k=o())}const P=a.getTokenOffset()+p;n(k,S,P),l=R}return i}e.format=L;function r(c,v){const b=JSON.stringify(c,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?b.replace(/\r\n|\r|\n/g,v.eol):b}e.toFormattedString=r;function O(c,v){let b="";for(let w=0;w<v;w++)b+=c;return b}function M(c,v){let b=0,w=0;const h=v.tabSize||4;for(;b<c.length;){const p=c.charAt(b);if(p===" ")w++;else if(p==="	")w+=h;else break;b++}return Math.floor(w/h)}function C(c,v){for(let b=0;b<v.length;b++){const w=v.charAt(b);if(w==="\r")return b+1<v.length&&v.charAt(b+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return c&&c.eol||`
`}e.getEOL=C;function g(c,v){return`\r
`.indexOf(c.charAt(v))!==-1}e.isEOL=g}),define(ae[102],ce([0,1,42,139]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(c,v,b){return O(c,v,void 0,b)}e.removeProperty=r;function O(c,v,b,w,h){const p=v.slice(),y=[],E=(0,I.parseTree)(c,y);let u,d;for(;p.length>0&&(d=p.pop(),u=(0,I.findNodeAtLocation)(E,p),u===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const f=(0,I.findNodeAtLocation)(u,[d]);if(f!==void 0)if(b===void 0){if(!f.parent)throw new Error("Malformed AST");const m=u.children.indexOf(f.parent);let a,t=f.parent.offset+f.parent.length;if(m>0){const o=u.children[m-1];a=o.offset+o.length}else a=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return M(c,{offset:a,length:t-a,content:""},w)}else return M(c,{offset:f.offset,length:f.length,content:JSON.stringify(b)},w);else{if(b===void 0)return[];const m=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,a=h?h(u.children.map(o=>o.children[0].value)):u.children.length;let t;if(a>0){const o=u.children[a-1];t={offset:o.offset+o.length,length:0,content:","+m}}else u.children.length===0?t={offset:u.offset+1,length:0,content:m}:t={offset:u.offset+1,length:0,content:m+","};return M(c,t,w)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(b!==void 0){const f=`${JSON.stringify(b)}`;let m;if(u.children.length===0||d===0)m={offset:u.offset+1,length:0,content:u.children.length===0?f:f+","};else{const a=d===-1||d>u.children.length?u.children.length:d,t=u.children[a-1];m={offset:t.offset+t.length,length:0,content:","+f}}return M(c,m,w)}else{const f=d,m=u.children[f];let a;if(u.children.length===1)a={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===f){const t=u.children[f-1],o=t.offset+t.length,s=u.offset+u.length;a={offset:o,length:s-2-o,content:""}}else a={offset:m.offset,length:u.children[f+1].offset-m.offset,content:""};return M(c,a,w)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return M(c,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(b)},w)}}e.setProperty=O;function M(c,v,b){let w=C(c,v),h=v.offset,p=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;h>0&&!(0,L.isEOL)(w,h-1);)h--;for(;p<w.length&&!(0,L.isEOL)(w,p);)p++}const y=(0,L.format)(w,{offset:h,length:p-h},b);for(let u=y.length-1;u>=0;u--){const d=y[u];w=C(w,d),h=Math.min(h,d.offset),p=Math.max(p,d.offset+d.length),p+=d.content.length-d.length}const E=c.length-(w.length-p)-h;return[{offset:h,length:E,content:w.substring(h,p)}]}e.withFormatting=M;function C(c,v){return c.substring(0,v.offset)+v.content+c.substring(v.offset+v.length)}e.applyEdit=C;function g(c,v){const b=v.slice(0).sort((h,p)=>{const y=h.offset-p.offset;return y===0?h.length-p.length:y});let w=c.length;for(let h=b.length-1;h>=0;h--){const p=b[h];if(p.offset+p.length<=w)c=C(c,p);else throw new Error("Overlapping edit");w=p.offset}return c}e.applyEdits=g}),define(ae[62],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=I}),define(ae[103],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{static{this.Undefined=new I(void 0)}constructor(O){this.element=O,this.next=I.Undefined,this.prev=I.Undefined}}class L{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let O=this._first;for(;O!==I.Undefined;){const M=O.next;O.prev=I.Undefined,O.next=I.Undefined,O=M}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,M){const C=new I(O);if(this._first===I.Undefined)this._first=C,this._last=C;else if(M){const c=this._last;this._last=C,C.prev=c,c.next=C}else{const c=this._first;this._first=C,C.next=c,c.prev=C}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(C))}}shift(){if(this._first!==I.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==I.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==I.Undefined&&O.next!==I.Undefined){const M=O.prev;M.next=O.next,O.next.prev=M}else O.prev===I.Undefined&&O.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):O.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):O.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==I.Undefined;)yield O.element,O=O.next}}e.LinkedList=L}),define(ae[31],ce([0,1]),function(K,e){"use strict";var I,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(f,m,a){let t=f.get(m);return t===void 0&&(t=a,f.set(m,t)),t}e.getOrSet=O;function M(f){const m=[];return f.forEach((a,t)=>{m.push(`${t} => ${a}`)}),`Map(${f.size}) {${m.join(", ")}}`}e.mapToString=M;function C(f){const m=[];return f.forEach(a=>{m.push(a)}),`Set(${f.size}) {${m.join(", ")}}`}e.setToString=C;class g{constructor(m,a){this.uri=m,this.value=a}}function c(f){return Array.isArray(f)}class v{static{this.defaultToKey=m=>m.toString()}constructor(m,a){if(this[I]="ResourceMap",m instanceof v)this.map=new Map(m.map),this.toKey=a??v.defaultToKey;else if(c(m)){this.map=new Map,this.toKey=a??v.defaultToKey;for(const[t,o]of m)this.set(t,o)}else this.map=new Map,this.toKey=m??v.defaultToKey}set(m,a){return this.map.set(this.toKey(m),new g(m,a)),this}get(m){return this.map.get(this.toKey(m))?.value}has(m){return this.map.has(this.toKey(m))}get size(){return this.map.size}clear(){this.map.clear()}delete(m){return this.map.delete(this.toKey(m))}forEach(m,a){typeof a<"u"&&(m=m.bind(a));for(const[t,o]of this.map)m(o.value,o.uri,this)}*values(){for(const m of this.map.values())yield m.value}*keys(){for(const m of this.map.values())yield m.uri}*entries(){for(const m of this.map.values())yield[m.uri,m.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.map)yield[m.uri,m.value]}}e.ResourceMap=v;class b{constructor(m,a){this[L]="ResourceSet",!m||typeof m=="function"?this._map=new v(m):(this._map=new v(a),m.forEach(this.add,this))}get size(){return this._map.size}add(m){return this._map.set(m,m),this}clear(){this._map.clear()}delete(m){return this._map.delete(m)}forEach(m,a){this._map.forEach((t,o)=>m.call(a,o,o,this))}has(m){return this._map.has(m)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class h{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(m){return this._map.has(m)}get(m,a=0){const t=this._map.get(m);if(t)return a!==0&&this.touch(t,a),t.value}set(m,a,t=0){let o=this._map.get(m);if(o)o.value=a,t!==0&&this.touch(o,t);else{switch(o={key:m,value:a,next:void 0,previous:void 0},t){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(m,o),this._size++}return this}delete(m){return!!this.remove(m)}remove(m){const a=this._map.get(m);if(a)return this._map.delete(m),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const m=this._head;return this._map.delete(m.key),this.removeItem(m),this._size--,m.value}forEach(m,a){const t=this._state;let o=this._head;for(;o;){if(a?m.bind(a)(o.value,o.key,this):m(o.value,o.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const m=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(m._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}values(){const m=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(m._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}entries(){const m=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(m._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(m){if(m>=this.size)return;if(m===0){this.clear();return}let a=this._head,t=this.size;for(;a&&t>m;)this._map.delete(a.key),a=a.next,t--;this._head=a,this._size=t,a&&(a.previous=void 0),this._state++}addItemFirst(m){if(!this._head&&!this._tail)this._tail=m;else if(this._head)m.next=this._head,this._head.previous=m;else throw new Error("Invalid list");this._head=m,this._state++}addItemLast(m){if(!this._head&&!this._tail)this._head=m;else if(this._tail)m.previous=this._tail,this._tail.next=m;else throw new Error("Invalid list");this._tail=m,this._state++}removeItem(m){if(m===this._head&&m===this._tail)this._head=void 0,this._tail=void 0;else if(m===this._head){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this._head=m.next}else if(m===this._tail){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this._tail=m.previous}else{const a=m.next,t=m.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}m.next=void 0,m.previous=void 0,this._state++}touch(m,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(m===this._head)return;const t=m.next,o=m.previous;m===this._tail?(o.next=void 0,this._tail=o):(t.previous=o,o.next=t),m.previous=void 0,m.next=this._head,this._head.previous=m,this._head=m,this._state++}else if(a===2){if(m===this._tail)return;const t=m.next,o=m.previous;m===this._head?(t.previous=void 0,this._head=t):(t.previous=o,o.next=t),m.next=void 0,m.previous=this._tail,this._tail.next=m,this._tail=m,this._state++}}}toJSON(){const m=[];return this.forEach((a,t)=>{m.push([t,a])}),m}fromJSON(m){this.clear();for(const[a,t]of m)this.set(a,t)}}e.LinkedMap=h;class p extends h{constructor(m,a=1){super(),this._limit=m,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(m){this._limit=m,this.checkTrim()}get ratio(){return this._ratio}set ratio(m){this._ratio=Math.min(Math.max(0,m),1),this.checkTrim()}get(m,a=2){return super.get(m,a)}peek(m){return super.get(m,0)}set(m,a){return super.set(m,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class y{constructor(){this.map=new Map}add(m){return this.map.set(m,(this.map.get(m)||0)+1),this}delete(m){let a=this.map.get(m)||0;return a===0?!1:(a--,a===0?this.map.delete(m):this.map.set(m,a),!0)}has(m){return this.map.has(m)}}e.CounterSet=y;class E{constructor(m){if(this._m1=new Map,this._m2=new Map,m)for(const[a,t]of m)this.set(a,t)}clear(){this._m1.clear(),this._m2.clear()}set(m,a){this._m1.set(m,a),this._m2.set(a,m)}get(m){return this._m1.get(m)}getKey(m){return this._m2.get(m)}delete(m){const a=this._m1.get(m);return a===void 0?!1:(this._m1.delete(m),this._m2.delete(a),!0)}forEach(m,a){this._m1.forEach((t,o)=>{m.call(a,t,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=E;class u{constructor(){this.map=new Map}add(m,a){let t=this.map.get(m);t||(t=new Set,this.map.set(m,t)),t.add(a)}delete(m,a){const t=this.map.get(m);t&&(t.delete(a),t.size===0&&this.map.delete(m))}forEach(m,a){const t=this.map.get(m);t&&t.forEach(a)}get(m){const a=this.map.get(m);return a||new Set}}e.SetMap=u;function d(f,m){if(f===m)return!0;if(f.size!==m.size)return!1;for(const[a,t]of f)if(!m.has(a)||m.get(a)!==t)return!1;for(const[a]of m)if(!f.has(a))return!1;return!0}e.mapsStrictEqualIgnoreOrder=d}),define(ae[2],ce([0,1,22,136,31,85,71]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const C=!1;let g=null;class c{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(_){let U=this.livingDisposables.get(_);return U||(U={parent:null,source:null,isSingleton:!1,value:_,idx:c.idx++},this.livingDisposables.set(_,U)),U}trackDisposable(_){const U=this.getDisposableData(_);U.source||(U.source=new Error().stack)}setParent(_,U){const F=this.getDisposableData(_);F.parent=U}markAsDisposed(_){this.livingDisposables.delete(_)}markAsSingleton(_){this.getDisposableData(_).isSingleton=!0}getRootParent(_,U){const F=U.get(_);if(F)return F;const H=_.parent?this.getRootParent(this.getDisposableData(_.parent),U):_;return U.set(_,H),H}getTrackedDisposables(){const _=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,_).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(_=10,U){let F;if(U)F=U;else{const ue=new Map,Y=[...this.livingDisposables.values()].filter(q=>q.source!==null&&!this.getRootParent(q,ue).isSingleton);if(Y.length===0)return;const Q=new Set(Y.map(q=>q.value));if(F=Y.filter(q=>!(q.parent&&Q.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function H(ue){function Y(q,W){for(;q.length>0&&W.some(N=>typeof N=="string"?N===q[0]:q[0].match(N));)q.shift()}const Q=ue.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Y(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const j=new r.SetMap;for(const ue of F){const Y=H(ue);for(let Q=0;Q<=Y.length;Q++)j.add(Y.slice(0,Q).join(`
`),ue)}F.sort((0,I.compareBy)(ue=>ue.idx,I.numberComparator));let le="",se=0;for(const ue of F.slice(0,_)){se++;const Y=H(ue),Q=[];for(let q=0;q<Y.length;q++){let W=Y[q];W=`(shared with ${j.get(Y.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${W}`;const V=j.get(Y.slice(0,q).join(`
`)),$=(0,L.groupBy)([...V].map(oe=>H(oe)[q]),oe=>oe);delete $[Y[q]];for(const[oe,de]of Object.entries($))Q.unshift(`    - stacktraces of ${de.length} other leaks continue with ${oe}`);Q.unshift(W)}le+=`


==================== Leaking disposable ${se}/${F.length}: ${ue.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return F.length>_&&(le+=`


... and ${F.length-_} more leaking disposables

`),{leaks:F,details:le}}}e.DisposableTracker=c;function v(D){g=D}if(e.setDisposableTracker=v,C){const D="__is_disposable_tracked__";v(new class{trackDisposable(_){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[D]||console.log(U)},3e3)}setParent(_,U){if(_&&_!==t.None)try{_[D]=!0}catch{}}markAsDisposed(_){if(_&&_!==t.None)try{_[D]=!0}catch{}}markAsSingleton(_){}})}function b(D){return g?.trackDisposable(D),D}e.trackDisposable=b;function w(D){g?.markAsDisposed(D)}e.markAsDisposed=w;function h(D,_){g?.setParent(D,_)}function p(D,_){if(g)for(const U of D)g.setParent(U,_)}function y(D){return g?.markAsSingleton(D),D}e.markAsSingleton=y;function E(D){return typeof D.dispose=="function"&&D.dispose.length===0}e.isDisposable=E;function u(D){if(M.Iterable.is(D)){const _=[];for(const U of D)if(U)try{U.dispose()}catch(F){_.push(F)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}e.dispose=u;function d(D){for(const _ of D)E(_)&&_.dispose();return[]}e.disposeIfDisposable=d;function f(...D){const _=m(()=>u(D));return p(D,_),_}e.combinedDisposable=f;function m(D){const _=b({dispose:(0,O.createSingleCallFunction)(()=>{w(_),D()})});return _}e.toDisposable=m;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return h(_,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(_),_.dispose()}}deleteAndLeak(_){_&&this._toDispose.has(_)&&(this._toDispose.delete(_),h(_,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,b(this),h(this._store,this)}dispose(){w(this),this._store.dispose()}_register(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(_)}}e.Disposable=t;class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(_){this._isDisposed||_===this._value||(this._value?.dispose(),_&&h(_,this),this._value=_)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const _=this._value;return this._value=void 0,_&&h(_,null),_}}e.MutableDisposable=o;class s{constructor(_){this._disposable=new o,this._isDisposed=!1,this._disposable.value=_}get value(){return this._disposable.value}set value(_){this._isDisposed||_===this._disposable.value||(this._disposable.value=_)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class i{constructor(_){this._disposable=_,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(_){let U=_;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,w(this))},this}}e.SafeDisposable=n;class l{constructor(){this.references=new Map}acquire(_,...U){let F=this.references.get(_);F||(F={counter:0,object:this.createReferencedObject(_,...U)},this.references.set(_,F));const{object:H}=F,j=(0,O.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(_,F.object),this.references.delete(_))});return F.counter++,{object:H,dispose:j}}}e.ReferenceCollection=l;class S{constructor(_){this.referenceCollection=_}async acquire(_,...U){const F=this.referenceCollection.acquire(_,...U);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(H){throw F.dispose(),H}}}e.AsyncReferenceCollection=S;class R{constructor(_){this.object=_}dispose(){}}e.ImmortalReference=R;function k(D){const _=new a;try{D(_)}finally{_.dispose()}}e.disposeOnReturn=k;class P{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){w(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(_){return this._store.has(_)}get size(){return this._store.size}get(_){return this._store.get(_)}set(_,U,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(_)?.dispose(),this._store.set(_,U)}deleteAndDispose(_){this._store.get(_)?.dispose(),this._store.delete(_)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=P}),define(ae[86],ce([0,1,31]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new I.LRUCache(1e4);function r(c){return g(c,"NFC",L)}e.normalizeNFC=r;const O=new I.LRUCache(1e4);function M(c){return g(c,"NFD",O)}e.normalizeNFD=M;const C=/[^\u0000-\u0080]/;function g(c,v,b){if(!c)return c;const w=b.get(c);if(w)return w;let h;return C.test(c)?h=c.normalize(v):h=c,b.set(c,h),h}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(v){return M(v).replace(c,"")}}()}),define(ae[140],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(C,g,c){return Math.min(Math.max(C,g),c)}e.clamp=I;function L(C,g){return(g+C%g)%g}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class O{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class M{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const c=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=M}),function(){function K(r){const O=[];typeof r=="number"&&O.push("code/timeOrigin",r);function M(g){O.push(g,Date.now())}function C(){const g=[];for(let c=0;c<O.length;c+=2)g.push({name:O[c],startTime:O[c+1]});return g}return{mark:M,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(r+M.startTime)});return O}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function I(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:K)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function I(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return K[L].call(r.exports,r,r.exports,I),r.l=!0,r.exports}return I.m=K,I.c=e,I.d=function(L,r,O){I.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:O})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,r){if(1&r&&(L=I(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var M in L)I.d(O,M,function(C){return L[C]}.bind(null,M));return O},I.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(r,"a",r),r},I.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},I.p="",I(I.s=0)}([function(K,e,I){(function(L){var r;e=K.exports=de,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],g=e.src=[],c=0,v=c++;g[v]="0|[1-9]\\d*";var b=c++;g[b]="[0-9]+";var w=c++;g[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=c++;g[h]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var p=c++;g[p]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var y=c++;g[y]="(?:"+g[v]+"|"+g[w]+")";var E=c++;g[E]="(?:"+g[b]+"|"+g[w]+")";var u=c++;g[u]="(?:-("+g[y]+"(?:\\."+g[y]+")*))";var d=c++;g[d]="(?:-?("+g[E]+"(?:\\."+g[E]+")*))";var f=c++;g[f]="[0-9A-Za-z-]+";var m=c++;g[m]="(?:\\+("+g[f]+"(?:\\."+g[f]+")*))";var a=c++,t="v?"+g[h]+g[u]+"?"+g[m]+"?";g[a]="^"+t+"$";var o="[v=\\s]*"+g[p]+g[d]+"?"+g[m]+"?",s=c++;g[s]="^"+o+"$";var i=c++;g[i]="((?:<|>)?=?)";var n=c++;g[n]=g[b]+"|x|X|\\*";var l=c++;g[l]=g[v]+"|x|X|\\*";var S=c++;g[S]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[u]+")?"+g[m]+"?)?)?";var R=c++;g[R]="[v=\\s]*("+g[n]+")(?:\\.("+g[n]+")(?:\\.("+g[n]+")(?:"+g[d]+")?"+g[m]+"?)?)?";var k=c++;g[k]="^"+g[i]+"\\s*"+g[S]+"$";var P=c++;g[P]="^"+g[i]+"\\s*"+g[R]+"$";var D=c++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=c++;g[_]="(?:~>?)";var U=c++;g[U]="(\\s*)"+g[_]+"\\s+",C[U]=new RegExp(g[U],"g");var F=c++;g[F]="^"+g[_]+g[S]+"$";var H=c++;g[H]="^"+g[_]+g[R]+"$";var j=c++;g[j]="(?:\\^)";var le=c++;g[le]="(\\s*)"+g[j]+"\\s+",C[le]=new RegExp(g[le],"g");var se=c++;g[se]="^"+g[j]+g[S]+"$";var ue=c++;g[ue]="^"+g[j]+g[R]+"$";var Y=c++;g[Y]="^"+g[i]+"\\s*("+o+")$|^$";var Q=c++;g[Q]="^"+g[i]+"\\s*("+t+")$|^$";var q=c++;g[q]="(\\s*)"+g[i]+"\\s*("+o+"|"+g[S]+")",C[q]=new RegExp(g[q],"g");var W=c++;g[W]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var N=c++;g[N]="^\\s*("+g[R]+")\\s+-\\s+("+g[R]+")\\s*$";var V=c++;g[V]="(<|>)?=?\\s*\\*";for(var $=0;$<35;$++)r($,g[$]),C[$]||(C[$]=new RegExp(g[$]));function oe(te,he){if(te instanceof de)return te;if(typeof te!="string"||te.length>O||!(he?C[s]:C[a]).test(te))return null;try{return new de(te,he)}catch{return null}}function de(te,he){if(te instanceof de){if(te.loose===he)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof de))return new de(te,he);r("SemVer",te,he),this.loose=he;var me=te.trim().match(he?C[s]:C[a]);if(!me)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(De){if(/^[0-9]+$/.test(De)){var Ae=+De;if(Ae>=0&&Ae<M)return Ae}return De}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=oe,e.valid=function(te,he){var me=oe(te,he);return me?me.version:null},e.clean=function(te,he){var me=oe(te.trim().replace(/^[=v]+/,""),he);return me?me.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(te){return r("SemVer.compare",this.version,this.loose,te),te instanceof de||(te=new de(te,this.loose)),this.compareMain(te)||this.comparePre(te)},de.prototype.compareMain=function(te){return te instanceof de||(te=new de(te,this.loose)),A(this.major,te.major)||A(this.minor,te.minor)||A(this.patch,te.patch)},de.prototype.comparePre=function(te){if(te instanceof de||(te=new de(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var he=0;do{var me=this.prerelease[he],De=te.prerelease[he];if(r("prerelease compare",he,me,De),me===void 0&&De===void 0)return 0;if(De===void 0)return 1;if(me===void 0)return-1;if(me!==De)return A(me,De)}while(++he)},de.prototype.inc=function(te,he){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,he,me,De){typeof me=="string"&&(De=me,me=void 0);try{return new de(te,me).inc(he,De).version}catch{return null}},e.diff=function(te,he){if(X(te,he))return null;var me=oe(te),De=oe(he);if(me.prerelease.length||De.prerelease.length){for(var Ae in me)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&me[Ae]!==De[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in me)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&me[Ae]!==De[Ae])return Ae},e.compareIdentifiers=A;var G=/^[0-9]+$/;function A(te,he){var me=G.test(te),De=G.test(he);return me&&De&&(te=+te,he=+he),me&&!De?-1:De&&!me?1:te<he?-1:te>he?1:0}function T(te,he,me){return new de(te,me).compare(new de(he,me))}function J(te,he,me){return T(te,he,me)>0}function B(te,he,me){return T(te,he,me)<0}function X(te,he,me){return T(te,he,me)===0}function x(te,he,me){return T(te,he,me)!==0}function Z(te,he,me){return T(te,he,me)>=0}function z(te,he,me){return T(te,he,me)<=0}function ee(te,he,me,De){var Ae;switch(he){case"===":typeof te=="object"&&(te=te.version),typeof me=="object"&&(me=me.version),Ae=te===me;break;case"!==":typeof te=="object"&&(te=te.version),typeof me=="object"&&(me=me.version),Ae=te!==me;break;case"":case"=":case"==":Ae=X(te,me,De);break;case"!=":Ae=x(te,me,De);break;case">":Ae=J(te,me,De);break;case">=":Ae=Z(te,me,De);break;case"<":Ae=B(te,me,De);break;case"<=":Ae=z(te,me,De);break;default:throw new TypeError("Invalid operator: "+he)}return Ae}function ie(te,he){if(te instanceof ie){if(te.loose===he)return te;te=te.value}if(!(this instanceof ie))return new ie(te,he);r("comparator",te,he),this.loose=he,this.parse(te),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(te,he){return A(he,te)},e.major=function(te,he){return new de(te,he).major},e.minor=function(te,he){return new de(te,he).minor},e.patch=function(te,he){return new de(te,he).patch},e.compare=T,e.compareLoose=function(te,he){return T(te,he,!0)},e.rcompare=function(te,he,me){return T(he,te,me)},e.sort=function(te,he){return te.sort(function(me,De){return e.compare(me,De,he)})},e.rsort=function(te,he){return te.sort(function(me,De){return e.rcompare(me,De,he)})},e.gt=J,e.lt=B,e.eq=X,e.neq=x,e.gte=Z,e.lte=z,e.cmp=ee,e.Comparator=ie;var fe={};function pe(te,he){if(te instanceof pe)return te.loose===he?te:new pe(te.raw,he);if(te instanceof ie)return new pe(te.value,he);if(!(this instanceof pe))return new pe(te,he);if(this.loose=he,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Pe(te){return!te||te.toLowerCase()==="x"||te==="*"}function Ce(te,he,me,De,Ae,Ue,_e,je,qe,Ge,xe,$e,ne){return((he=Pe(me)?"":Pe(De)?">="+me+".0.0":Pe(Ae)?">="+me+"."+De+".0":">="+he)+" "+(je=Pe(qe)?"":Pe(Ge)?"<"+(+qe+1)+".0.0":Pe(xe)?"<"+qe+"."+(+Ge+1)+".0":$e?"<="+qe+"."+Ge+"."+xe+"-"+$e:"<="+je)).trim()}function We(te,he){for(var me=0;me<te.length;me++)if(!te[me].test(he))return!1;if(he.prerelease.length){for(me=0;me<te.length;me++)if(r(te[me].semver),te[me].semver!==fe&&te[me].semver.prerelease.length>0){var De=te[me].semver;if(De.major===he.major&&De.minor===he.minor&&De.patch===he.patch)return!0}return!1}return!0}function Ee(te,he,me){try{he=new pe(he,me)}catch{return!1}return he.test(te)}function ye(te,he,me,De){var Ae,Ue,_e,je,qe;switch(te=new de(te,De),he=new pe(he,De),me){case">":Ae=J,Ue=z,_e=B,je=">",qe=">=";break;case"<":Ae=B,Ue=Z,_e=J,je="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(te,he,De))return!1;for(var Ge=0;Ge<he.set.length;++Ge){var xe=he.set[Ge],$e=null,ne=null;if(xe.forEach(function(ge){ge.semver===fe&&(ge=new ie(">=0.0.0")),$e=$e||ge,ne=ne||ge,Ae(ge.semver,$e.semver,De)?$e=ge:_e(ge.semver,ne.semver,De)&&(ne=ge)}),$e.operator===je||$e.operator===qe||(!ne.operator||ne.operator===je)&&Ue(te,ne.semver)||ne.operator===qe&&_e(te,ne.semver))return!1}return!0}ie.prototype.parse=function(te){var he=this.loose?C[Y]:C[Q],me=te.match(he);if(!me)throw new TypeError("Invalid comparator: "+te);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new de(me[2],this.loose):this.semver=fe},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(te){return r("Comparator.test",te,this.loose),this.semver===fe||(typeof te=="string"&&(te=new de(te,this.loose)),ee(te,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(te,he){if(!(te instanceof ie))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(te.value,he),Ee(this.value,me,he);if(te.operator==="")return me=new pe(this.value,he),Ee(te.semver,me,he);var De=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Ue=this.semver.version===te.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),je=ee(this.semver,"<",te.semver,he)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),qe=ee(this.semver,">",te.semver,he)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return De||Ae||Ue&&_e||je||qe},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(te){var he=this.loose;te=te.trim(),r("range",te,he);var me=he?C[N]:C[W];te=te.replace(me,Ce),r("hyphen replace",te),te=te.replace(C[q],"$1$2$3"),r("comparator trim",te,C[q]),te=(te=(te=te.replace(C[U],"$1~")).replace(C[le],"$1^")).split(/\s+/).join(" ");var De=he?C[Y]:C[Q],Ae=te.split(" ").map(function(Ue){return function(_e,je){return r("comp",_e),_e=function(qe,Ge){return qe.trim().split(/\s+/).map(function(xe){return function($e,ne){r("caret",$e,ne);var ge=ne?C[ue]:C[se];return $e.replace(ge,function(Se,we,Ie,Oe,Ne){var Ke;return r("caret",$e,Se,we,Ie,Oe,Ne),Pe(we)?Ke="":Pe(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Pe(Oe)?Ke=we==="0"?">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+".0 <"+(+we+1)+".0.0":Ne?(r("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+Oe+Ne+" <"+we+"."+Ie+"."+(+Oe+1):">="+we+"."+Ie+"."+Oe+Ne+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+Oe+Ne+" <"+(+we+1)+".0.0"):(r("no pr"),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+Oe+" <"+we+"."+Ie+"."+(+Oe+1):">="+we+"."+Ie+"."+Oe+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+Oe+" <"+(+we+1)+".0.0"),r("caret return",Ke),Ke})}(xe,Ge)}).join(" ")}(_e,je),r("caret",_e),_e=function(qe,Ge){return qe.trim().split(/\s+/).map(function(xe){return function($e,ne){var ge=ne?C[H]:C[F];return $e.replace(ge,function(Se,we,Ie,Oe,Ne){var Ke;return r("tilde",$e,Se,we,Ie,Oe,Ne),Pe(we)?Ke="":Pe(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Pe(Oe)?Ke=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":Ne?(r("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ke=">="+we+"."+Ie+"."+Oe+Ne+" <"+we+"."+(+Ie+1)+".0"):Ke=">="+we+"."+Ie+"."+Oe+" <"+we+"."+(+Ie+1)+".0",r("tilde return",Ke),Ke})}(xe,Ge)}).join(" ")}(_e,je),r("tildes",_e),_e=function(qe,Ge){return r("replaceXRanges",qe,Ge),qe.split(/\s+/).map(function(xe){return function($e,ne){$e=$e.trim();var ge=ne?C[P]:C[k];return $e.replace(ge,function(Se,we,Ie,Oe,Ne,Ke){r("xRange",$e,Se,we,Ie,Oe,Ne,Ke);var Je=Pe(Ie),Xe=Je||Pe(Oe),Ye=Xe||Pe(Ne);return we==="="&&Ye&&(we=""),Je?Se=we===">"||we==="<"?"<0.0.0":"*":we&&Ye?(Xe&&(Oe=0),Ye&&(Ne=0),we===">"?(we=">=",Xe?(Ie=+Ie+1,Oe=0,Ne=0):Ye&&(Oe=+Oe+1,Ne=0)):we==="<="&&(we="<",Xe?Ie=+Ie+1:Oe=+Oe+1),Se=we+Ie+"."+Oe+"."+Ne):Xe?Se=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ye&&(Se=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),r("xRange return",Se),Se})}(xe,Ge)}).join(" ")}(_e,je),r("xrange",_e),_e=function(qe,Ge){return r("replaceStars",qe,Ge),qe.trim().replace(C[V],"")}(_e,je),r("stars",_e),_e}(Ue,he)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Ue){return!!Ue.match(De)})),Ae=Ae.map(function(Ue){return new ie(Ue,he)})},pe.prototype.intersects=function(te,he){if(!(te instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(De){return te.set.some(function(Ae){return Ae.every(function(Ue){return De.intersects(Ue,he)})})})})},e.toComparators=function(te,he){return new pe(te,he).set.map(function(me){return me.map(function(De){return De.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new de(te,this.loose));for(var he=0;he<this.set.length;he++)if(We(this.set[he],te))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(te,he,me){var De=null,Ae=null;try{var Ue=new pe(he,me)}catch{return null}return te.forEach(function(_e){Ue.test(_e)&&(De&&Ae.compare(_e)!==-1||(Ae=new de(De=_e,me)))}),De},e.minSatisfying=function(te,he,me){var De=null,Ae=null;try{var Ue=new pe(he,me)}catch{return null}return te.forEach(function(_e){Ue.test(_e)&&(De&&Ae.compare(_e)!==1||(Ae=new de(De=_e,me)))}),De},e.validRange=function(te,he){try{return new pe(te,he).range||"*"}catch{return null}},e.ltr=function(te,he,me){return ye(te,he,"<",me)},e.gtr=function(te,he,me){return ye(te,he,">",me)},e.outside=ye,e.prerelease=function(te,he){var me=oe(te,he);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(te,he,me){return te=new pe(te,me),he=new pe(he,me),te.intersects(he)},e.coerce=function(te){if(te instanceof de)return te;if(typeof te!="string")return null;var he=te.match(C[D]);return he==null?null:oe((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,I(1))},function(K,e){var I,L,r=K.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function C(E){if(I===setTimeout)return setTimeout(E,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(E,0);try{return I(E,0)}catch{try{return I.call(null,E,0)}catch{return I.call(this,E,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{L=typeof clearTimeout=="function"?clearTimeout:M}catch{L=M}})();var g,c=[],v=!1,b=-1;function w(){v&&g&&(v=!1,g.length?c=g.concat(c):b=-1,c.length&&h())}function h(){if(!v){var E=C(w);v=!0;for(var u=c.length;u;){for(g=c,c=[];++b<u;)g&&g[b].run();b=-1,u=c.length}g=null,v=!1,function(d){if(L===clearTimeout)return clearTimeout(d);if((L===M||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(d);try{L(d)}catch{try{return L.call(null,d)}catch{return L.call(this,d)}}}(E)}}function p(E,u){this.fun=E,this.array=u}function y(){}r.nextTick=function(E){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];c.push(new p(E,u)),c.length!==1||v||C(h)},p.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=y,r.addListener=y,r.once=y,r.off=y,r.removeListener=y,r.removeAllListeners=y,r.emit=y,r.prependListener=y,r.prependOnceListener=y,r.listeners=function(E){return[]},r.binding=function(E){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(E){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(ae[141],ce([0,1]),function(K,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(C,g,c){this.level=C,this.key=g,this.value=c,this.forward=[]}}const r=void 0;class O{constructor(C,g=2**16){this.comparator=C,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(g)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r),this._size=0}has(C){return!!O._search(this,C,this.comparator)}get(C){return O._search(this,C,this.comparator)?.value}set(C,g){return O._insert(this,C,g,this.comparator)&&(this._size+=1),this}delete(C){const g=O._delete(this,C,this.comparator);return g&&(this._size-=1),g}forEach(C,g){let c=this._header.forward[0];for(;c;)C.call(g,c.value,c.key,this),c=c.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",g=this._header.forward[0];for(;g;)C+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return C}static _search(C,g,c){let v=C._header;for(let b=C._level-1;b>=0;b--)for(;v.forward[b]&&c(v.forward[b].key,g)<0;)v=v.forward[b];if(v=v.forward[0],v&&c(v.key,g)===0)return v}static _insert(C,g,c,v){const b=[];let w=C._header;for(let h=C._level-1;h>=0;h--){for(;w.forward[h]&&v(w.forward[h].key,g)<0;)w=w.forward[h];b[h]=w}if(w=w.forward[0],w&&v(w.key,g)===0)return w.value=c,!1;{const h=O._randomLevel(C);if(h>C._level){for(let p=C._level;p<h;p++)b[p]=C._header;C._level=h}w=new L(h,g,c);for(let p=0;p<h;p++)w.forward[p]=b[p].forward[p],b[p].forward[p]=w;return!0}}static _randomLevel(C,g=.5){let c=1;for(;Math.random()<g&&c<C._maxLevel;)c+=1;return c}static _delete(C,g,c){const v=[];let b=C._header;for(let w=C._level-1;w>=0;w--){for(;b.forward[w]&&c(b.forward[w].key,g)<0;)b=b.forward[w];v[w]=b}if(b=b.forward[0],!b||c(b.key,g)!==0)return!1;for(let w=0;w<C._level&&v[w].forward[w]===b;w++)v[w].forward[w]=b.forward[w];for(;C._level>0&&C._header.forward[C._level-1]===r;)C._level-=1;return!0}}e.SkipList=O}),define(ae[72],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(O){return new L(O)}constructor(O){this._now=I&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(ae[3],ce([0,1,15,85,2,103,72]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const C=!1,g=!1;var c;(function(k){k.None=()=>r.Disposable.None;function P(z){if(g){const{onDidAddListener:ee}=z,ie=p.create();let fe=0;z.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),ee?.()}}}function D(z,ee){return Q(z,()=>{},0,void 0,!0,void 0,ee)}k.defer=D;function _(z){return(ee,ie=null,fe)=>{let pe=!1,Pe;return Pe=z(Ce=>{if(!pe)return Pe?Pe.dispose():pe=!0,ee.call(ie,Ce)},null,fe),pe&&Pe.dispose(),Pe}}k.once=_;function U(z,ee,ie){return ue((fe,pe=null,Pe)=>z(Ce=>fe.call(pe,ee(Ce)),null,Pe),ie)}k.map=U;function F(z,ee,ie){return ue((fe,pe=null,Pe)=>z(Ce=>{ee(Ce),fe.call(pe,Ce)},null,Pe),ie)}k.forEach=F;function H(z,ee,ie){return ue((fe,pe=null,Pe)=>z(Ce=>ee(Ce)&&fe.call(pe,Ce),null,Pe),ie)}k.filter=H;function j(z){return z}k.signal=j;function le(...z){return(ee,ie=null,fe)=>{const pe=(0,r.combinedDisposable)(...z.map(Pe=>Pe(Ce=>ee.call(ie,Ce))));return Y(pe,fe)}}k.any=le;function se(z,ee,ie,fe){let pe=ie;return U(z,Pe=>(pe=ee(pe,Pe),pe),fe)}k.reduce=se;function ue(z,ee){let ie;const fe={onWillAddFirstListener(){ie=z(pe.fire,pe)},onDidRemoveLastListener(){ie?.dispose()}};ee||P(fe);const pe=new f(fe);return ee?.add(pe),pe.event}function Y(z,ee){return ee instanceof Array?ee.push(z):ee&&ee.add(z),z}function Q(z,ee,ie=100,fe=!1,pe=!1,Pe,Ce){let We,Ee,ye,te=0,he;const me={leakWarningThreshold:Pe,onWillAddFirstListener(){We=z(Ae=>{te++,Ee=ee(Ee,Ae),fe&&!ye&&(De.fire(Ee),Ee=void 0),he=()=>{const Ue=Ee;Ee=void 0,ye=void 0,(!fe||te>1)&&De.fire(Ue),te=0},typeof ie=="number"?(clearTimeout(ye),ye=setTimeout(he,ie)):ye===void 0&&(ye=0,queueMicrotask(he))})},onWillRemoveListener(){pe&&te>0&&he?.()},onDidRemoveLastListener(){he=void 0,We.dispose()}};Ce||P(me);const De=new f(me);return Ce?.add(De),De.event}k.debounce=Q;function q(z,ee=0,ie){return k.debounce(z,(fe,pe)=>fe?(fe.push(pe),fe):[pe],ee,void 0,!0,void 0,ie)}k.accumulate=q;function W(z,ee=(fe,pe)=>fe===pe,ie){let fe=!0,pe;return H(z,Pe=>{const Ce=fe||!ee(Pe,pe);return fe=!1,pe=Pe,Ce},ie)}k.latch=W;function N(z,ee,ie){return[k.filter(z,ee,ie),k.filter(z,fe=>!ee(fe),ie)]}k.split=N;function V(z,ee=!1,ie=[],fe){let pe=ie.slice(),Pe=z(Ee=>{pe?pe.push(Ee):We.fire(Ee)});fe&&fe.add(Pe);const Ce=()=>{pe?.forEach(Ee=>We.fire(Ee)),pe=null},We=new f({onWillAddFirstListener(){Pe||(Pe=z(Ee=>We.fire(Ee)),fe&&fe.add(Pe))},onDidAddFirstListener(){pe&&(ee?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Pe&&Pe.dispose(),Pe=null}});return fe&&fe.add(We),We.event}k.buffer=V;function $(z,ee){return(fe,pe,Pe)=>{const Ce=ee(new de);return z(function(We){const Ee=Ce.evaluate(We);Ee!==oe&&fe.call(pe,Ee)},void 0,Pe)}}k.chain=$;const oe=Symbol("HaltChainable");class de{constructor(){this.steps=[]}map(ee){return this.steps.push(ee),this}forEach(ee){return this.steps.push(ie=>(ee(ie),ie)),this}filter(ee){return this.steps.push(ie=>ee(ie)?ie:oe),this}reduce(ee,ie){let fe=ie;return this.steps.push(pe=>(fe=ee(fe,pe),fe)),this}latch(ee=(ie,fe)=>ie===fe){let ie=!0,fe;return this.steps.push(pe=>{const Pe=ie||!ee(pe,fe);return ie=!1,fe=pe,Pe?pe:oe}),this}evaluate(ee){for(const ie of this.steps)if(ee=ie(ee),ee===oe)break;return ee}}function G(z,ee,ie=fe=>fe){const fe=(...We)=>Ce.fire(ie(...We)),pe=()=>z.on(ee,fe),Pe=()=>z.removeListener(ee,fe),Ce=new f({onWillAddFirstListener:pe,onDidRemoveLastListener:Pe});return Ce.event}k.fromNodeEventEmitter=G;function A(z,ee,ie=fe=>fe){const fe=(...We)=>Ce.fire(ie(...We)),pe=()=>z.addEventListener(ee,fe),Pe=()=>z.removeEventListener(ee,fe),Ce=new f({onWillAddFirstListener:pe,onDidRemoveLastListener:Pe});return Ce.event}k.fromDOMEventEmitter=A;function T(z){return new Promise(ee=>_(z)(ee))}k.toPromise=T;function J(z){const ee=new f;return z.then(ie=>{ee.fire(ie)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}k.fromPromise=J;function B(z,ee,ie){return ee(ie),z(fe=>ee(fe))}k.runAndSubscribe=B;class X{constructor(ee,ie){this._observable=ee,this._counter=0,this._hasChanged=!1;const fe={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ie||P(fe),this.emitter=new f(fe),ie&&ie.add(this.emitter)}beginUpdate(ee){this._counter++}handlePossibleChange(ee){}handleChange(ee,ie){this._hasChanged=!0}endUpdate(ee){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function x(z,ee){return new X(z,ee).emitter.event}k.fromObservable=x;function Z(z){return(ee,ie,fe)=>{let pe=0,Pe=!1;const Ce={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(z.reportChanges(),Pe&&(Pe=!1,ee.call(ie)))},handlePossibleChange(){},handleChange(){Pe=!0}};z.addObserver(Ce),z.reportChanges();const We={dispose(){z.removeObserver(Ce)}};return fe instanceof r.DisposableStore?fe.add(We):Array.isArray(fe)&&fe.push(We),We}}k.fromObservableLight=Z})(c||(e.Event=c={}));class v{static{this.all=new Set}static{this._idPool=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${v._idPool++}`,v.all.add(this)}start(P){this._stopWatch=new M.StopWatch,this.listenerCount=P}stop(){if(this._stopWatch){const P=this._stopWatch.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=v;let b=-1;function w(k){const P=b;return b=k,{dispose(){b=P}}}e.setGlobalLeakWarningThreshold=w;class h{constructor(P,D=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=D,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(P,D){const _=this.threshold;if(_<=0||D<_)return;this._stacks||(this._stacks=new Map);const U=this._stacks.get(P.value)||0;if(this._stacks.set(P.value,U+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let F,H=0;for(const[j,le]of this._stacks)(!F||H<le)&&(F=j,H=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${H}):`),console.warn(F)}return()=>{const F=this._stacks.get(P.value)||0;this._stacks.set(P.value,F-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class E{constructor(P){this.value=P,this.id=y++}}const u=2,d=(k,P)=>{if(k instanceof E)P(k);else for(let D=0;D<k.length;D++){const _=k[D];_&&P(_)}};class f{constructor(P){this._size=0,this._options=P,this._leakageMon=b>0||this._options?.leakWarningThreshold?new h(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(C){const P=this._listeners;queueMicrotask(()=>{d(P,D=>D.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(P,D,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;D&&(P=P.bind(D));const U=new E(P);let F,H;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(U.stack=p.create(),F=this._leakageMon.check(U.stack,this._size+1)),C&&(U.stack=H??p.create()),this._listeners?this._listeners instanceof E?(this._deliveryQueue??=new a,this._listeners=[this._listeners,U]):this._listeners.push(U):(this._options?.onWillAddFirstListener?.(this),this._listeners=U,this._options?.onDidAddFirstListener?.(this)),this._size++;const j=(0,r.toDisposable)(()=>{F?.(),this._removeListener(U)});return _ instanceof r.DisposableStore?_.add(j):Array.isArray(_)&&_.push(j),j},this._event}_removeListener(P){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const D=this._listeners,_=D.indexOf(P);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,D[_]=void 0;const U=this._deliveryQueue.current===this;if(this._size*u<=D.length){let F=0;for(let H=0;H<D.length;H++)D[H]?D[F++]=D[H]:U&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);D.length=F}}_deliver(P,D){if(!P)return;const _=this._options?.onListenerError||I.onUnexpectedError;if(!_){P.value(D);return}try{P.value(D)}catch(U){_(U)}}_deliverQueue(P){const D=P.current._listeners;for(;P.i<P.end;)this._deliver(D[P.i++],P.value);P.reset()}fire(P){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof E)this._deliver(this._listeners,P);else{const D=this._deliveryQueue;D.enqueue(this,P,this._listeners.length),this._deliverQueue(D)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=f;const m=()=>new a;e.createEventDeliveryQueue=m;class a{constructor(){this.i=-1,this.end=0}enqueue(P,D,_){this.i=0,this.end=_,this.current=P,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends f{async fireAsync(P,D,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),d(this._listeners,U=>this._asyncDeliveryQueue.push([U.value,P]));this._asyncDeliveryQueue.size>0&&!D.isCancellationRequested;){const[U,F]=this._asyncDeliveryQueue.shift(),H=[],j={...F,token:D,waitUntil:le=>{if(Object.isFrozen(H))throw new Error("waitUntil can NOT be called asynchronous");_&&(le=_(le,U)),H.push(le)}};try{U(j)}catch(le){(0,I.onUnexpectedError)(le);continue}Object.freeze(H),await Promise.allSettled(H).then(le=>{for(const se of le)se.status==="rejected"&&(0,I.onUnexpectedError)(se.reason)})}}}e.AsyncEmitter=t;class o extends f{get isPaused(){return this._isPaused!==0}constructor(P){super(P),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=P?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const P=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(P))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(P){this._size&&(this._isPaused!==0?this._eventQueue.push(P):super.fire(P))}}e.PauseableEmitter=o;class s extends o{constructor(P){super(P),this._delay=P.delay??100}fire(P){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(P)}}e.DebounceEmitter=s;class i extends f{constructor(P){super(P),this._queuedEvents=[],this._mergeFn=P?.merge}fire(P){this.hasListeners()&&(this._queuedEvents.push(P),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(D=>super.fire(D)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(P){const D={event:P,listener:null};this.events.push(D),this.hasListeners&&this.hook(D);const _=()=>{this.hasListeners&&this.unhook(D);const U=this.events.indexOf(D);this.events.splice(U,1)};return(0,r.toDisposable)((0,L.createSingleCallFunction)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(P=>this.hook(P))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(P=>this.unhook(P))}hook(P){P.listener=P.event(D=>this.emitter.fire(D))}unhook(P){P.listener?.dispose(),P.listener=null}dispose(){this.emitter.dispose();for(const P of this.events)P.listener?.dispose();this.events=[]}}e.EventMultiplexer=n;class l{constructor(P,D,_,U){this._store=new r.DisposableStore;const F=this._store.add(new n),H=this._store.add(new r.DisposableMap);function j(le){H.set(le,F.add(U(le)))}for(const le of P)j(le);this._store.add(D(le=>{j(le)})),this._store.add(_(le=>{H.deleteAndDispose(le)})),this.event=F.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=l;class S{constructor(){this.buffers=[]}wrapEvent(P){return(D,_,U)=>P(F=>{const H=this.buffers[this.buffers.length-1];H?H.push(()=>D.call(_,F)):D.call(_,F)},void 0,U)}bufferEvents(P){const D=[];this.buffers.push(D);const _=P();return this.buffers.pop(),D.forEach(U=>U()),_}}e.EventBufferer=S;class R{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=r.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(P){this.inputEvent=P,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=P(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=R}),define(ae[23],ce([0,1,3]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,g){const c=setTimeout(C.bind(g),0);return{dispose(){clearTimeout(c)}}});var r;(function(C){function g(c){return c===C.None||c===C.Cancelled||c instanceof O?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}C.isCancellationToken=g,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=r.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=M}),define(ae[142],ce([0,1,23]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new I.CancellationTokenSource,g=this.task(C.token);return this.result={promise:g,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=L;class r{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const g=JSON.stringify(C);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=r;class O{get cachedValues(){return this._map}constructor(C){this.fn=C,this._map=new Map}get(C){if(this._map.has(C))return this._map.get(C);const g=this.fn(C);return this._map.set(C,g),g}}e.CachedFunction=O}),define(ae[63],ce([0,1,15,2]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(m){const a=m;return a?typeof a.read=="function":!1}e.isReadable=r;function O(m){const a=m;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=O;function M(m){const a=m;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function C(m,a){return new g(m,a)}e.newWriteableStream=C;class g{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,I.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(m,a){const t=[];let o;for(;(o=m.read())!==null;)t.push(o);return a(t)}e.consumeReadable=c;function v(m,a,t){const o=[];let s;for(;(s=m.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return m.read()}}}e.peekReadable=v;function b(m,a){return new Promise((t,o)=>{const s=[];w(m,{onData:i=>{a&&s.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.consumeStream=b;function w(m,a,t){m.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),m.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),m.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}e.listenStream=w;function h(m,a){return new Promise((t,o)=>{const s=new L.DisposableStore,i=[],n=R=>{if(i.push(R),i.length>a)return s.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},l=R=>(s.dispose(),o(R)),S=()=>(s.dispose(),t({stream:m,buffer:i,ended:!0}));s.add((0,L.toDisposable)(()=>m.removeListener("error",l))),m.on("error",l),s.add((0,L.toDisposable)(()=>m.removeListener("end",S))),m.on("end",S),s.add((0,L.toDisposable)(()=>m.removeListener("data",n))),m.on("data",n)})}e.peekStream=h;function p(m,a){const t=C(a);return t.end(m),t}e.toStream=p;function y(){const m=C(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=y;function E(m){let a=!1;return{read:()=>a?null:(a=!0,m)}}e.toReadable=E;function u(m,a,t){const o=C(t);return w(m,{onData:s=>o.write(a.data(s)),onError:s=>o.error(a.error?a.error(s):s),onEnd:()=>o.end()}),o}e.transform=u;function d(m,a,t){let o=!1;return{read:()=>{const s=a.read();return o?s:(o=!0,s!==null?t([m,s]):m)}}}e.prefixedReadable=d;function f(m,a,t){let o=!1;const s=C(t);return w(a,{onData:i=>o?s.write(i):(o=!0,s.write(t([m,i]))),onError:i=>s.error(i),onEnd:()=>{o||(o=!0,s.write(m)),s.end()}}),s}e.prefixedStream=f}),define(ae[17],ce([0,1,62,63]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const r=typeof Buffer<"u",O=new I.Lazy(()=>new Uint8Array(256));let M,C;class g{static alloc(D){return r?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return r&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,_){return!(_?.dontUseNodeBuffer||!1)&&r?new g(Buffer.from(D)):(M||(M=new TextEncoder),new g(M.encode(D)))}static fromByteArray(D){const _=g.alloc(D.length);for(let U=0,F=D.length;U<F;U++)_.buffer[U]=D[U];return _}static concat(D,_){if(typeof _>"u"){_=0;for(let H=0,j=D.length;H<j;H++)_+=D[H].byteLength}const U=g.alloc(_);let F=0;for(let H=0,j=D.length;H<j;H++){const le=D[H];U.set(le,F),F+=le.byteLength}return U}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(D,_){return new g(this.buffer.subarray(D,_))}set(D,_){if(D instanceof g)this.buffer.set(D.buffer,_);else if(D instanceof Uint8Array)this.buffer.set(D,_);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),_);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return w(this.buffer,D)}writeUInt32BE(D,_){h(this.buffer,D,_)}readUInt32LE(D){return p(this.buffer,D)}writeUInt32LE(D,_){y(this.buffer,D,_)}readUInt8(D){return E(this.buffer,D)}writeUInt8(D,_){u(this.buffer,D,_)}indexOf(D,_=0){return c(this.buffer,D instanceof g?D.buffer:D,_)}}e.VSBuffer=g;function c(P,D,_=0){const U=D.byteLength,F=P.byteLength;if(U===0)return 0;if(U===1)return P.indexOf(D[0]);if(U>F-_)return-1;const H=O.value;H.fill(D.length);for(let ue=0;ue<D.length;ue++)H[D[ue]]=D.length-ue-1;let j=_+D.length-1,le=j,se=-1;for(;j<F;)if(P[j]===D[le]){if(le===0){se=j;break}j--,le--}else j+=Math.max(D.length-le,H[P[j]]),le=D.length-1;return se}e.binaryIndexOf=c;function v(P,D){return P[D+0]<<0>>>0|P[D+1]<<8>>>0}e.readUInt16LE=v;function b(P,D,_){P[_+0]=D&255,D=D>>>8,P[_+1]=D&255}e.writeUInt16LE=b;function w(P,D){return P[D]*2**24+P[D+1]*2**16+P[D+2]*2**8+P[D+3]}e.readUInt32BE=w;function h(P,D,_){P[_+3]=D,D=D>>>8,P[_+2]=D,D=D>>>8,P[_+1]=D,D=D>>>8,P[_]=D}e.writeUInt32BE=h;function p(P,D){return P[D+0]<<0>>>0|P[D+1]<<8>>>0|P[D+2]<<16>>>0|P[D+3]<<24>>>0}e.readUInt32LE=p;function y(P,D,_){P[_+0]=D&255,D=D>>>8,P[_+1]=D&255,D=D>>>8,P[_+2]=D&255,D=D>>>8,P[_+3]=D&255}e.writeUInt32LE=y;function E(P,D){return P[D]}e.readUInt8=E;function u(P,D,_){P[_]=D}e.writeUInt8=u;function d(P){return L.consumeReadable(P,D=>g.concat(D))}e.readableToBuffer=d;function f(P){return L.toReadable(P)}e.bufferToReadable=f;function m(P){return L.consumeStream(P,D=>g.concat(D))}e.streamToBuffer=m;async function a(P){return P.ended?g.concat(P.buffer):g.concat([...P.buffer,await m(P.stream)])}e.bufferedStreamToBuffer=a;function t(P){return L.toStream(P,D=>g.concat(D))}e.bufferToStream=t;function o(P){return L.transform(P,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.streamToBufferReadableStream=o;function s(P){return L.newWriteableStream(D=>g.concat(D),P)}e.newWriteableBufferStream=s;function i(P,D){return L.prefixedReadable(P,D,_=>g.concat(_))}e.prefixedBufferReadable=i;function n(P,D){return L.prefixedStream(P,D,_=>g.concat(_))}e.prefixedBufferStream=n;function l(P){let D=0,_=0,U=0;const F=new Uint8Array(Math.floor(P.length/4*3)),H=le=>{switch(_){case 3:F[U++]=D|le,_=0;break;case 2:F[U++]=D|le>>>2,D=le<<6,_=3;break;case 1:F[U++]=D|le>>>4,D=le<<4,_=2;break;default:D=le<<2,_=1}};for(let le=0;le<P.length;le++){const se=P.charCodeAt(le);if(se>=65&&se<=90)H(se-65);else if(se>=97&&se<=122)H(se-97+26);else if(se>=48&&se<=57)H(se-48+52);else if(se===43||se===45)H(62);else if(se===47||se===95)H(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${P[le]}`)}}const j=U;for(;_>0;)H(0);return g.wrap(F).slice(0,j)}e.decodeBase64=l;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:P},D=!0,_=!1){const U=_?R:S;let F="";const H=P.byteLength%3;let j=0;for(;j<P.byteLength-H;j+=3){const le=P[j+0],se=P[j+1],ue=P[j+2];F+=U[le>>>2],F+=U[(le<<4|se>>>4)&63],F+=U[(se<<2|ue>>>6)&63],F+=U[ue&63]}if(H===1){const le=P[j+0];F+=U[le>>>2],F+=U[le<<4&63],D&&(F+="==")}else if(H===2){const le=P[j+0],se=P[j+1];F+=U[le>>>2],F+=U[(le<<4|se>>>4)&63],F+=U[se<<2&63],D&&(F+="=")}return F}e.encodeBase64=k}),define(ae[25],ce([0,1,142,62]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLinesIncludeSeparators=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=r;const O=/{(\d+)}/g;function M(ne,...ge){return ge.length===0?ne:ne.replace(O,function(Se,we){const Ie=parseInt(we,10);return isNaN(Ie)||Ie<0||Ie>=ge.length?Se:ge[Ie]})}e.format=M;const C=/{([^}]+)}/g;function g(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(C,(Se,we)=>ge[we]??Se)}e.format2=g;function c(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}e.htmlAttributeEncodeValue=c;function v(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=v;function b(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function w(ne,ge){let Se=0;const we=ge.charCodeAt(0);for(let Ie=ne.length-1;Ie>=0;Ie--)ne.charCodeAt(Ie)===we&&Se++;return Se}e.count=w;function h(ne,ge,Se="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${Se}`}e.truncate=h;function p(ne,ge,Se="\u2026"){if(ne.length<=ge)return ne;const we=Math.ceil(ge/2)-Se.length/2,Ie=Math.floor(ge/2)-Se.length/2;return`${ne.substr(0,we)}${Se}${ne.substr(ne.length-Ie)}`}e.truncateMiddle=p;function y(ne,ge=" "){const Se=E(ne,ge);return u(Se,ge)}e.trim=y;function E(ne,ge){if(!ne||!ge)return ne;const Se=ge.length;if(Se===0||ne.length===0)return ne;let we=0;for(;ne.indexOf(ge,we)===we;)we=we+Se;return ne.substring(we)}e.ltrim=E;function u(ne,ge){if(!ne||!ge)return ne;const Se=ge.length,we=ne.length;if(Se===0||we===0)return ne;let Ie=we,Oe=-1;for(;Oe=ne.lastIndexOf(ge,Ie-1),!(Oe===-1||Oe+Se!==Ie);){if(Oe===0)return"";Ie=Oe}return ne.substring(0,Ie)}e.rtrim=u;function d(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(ne){return ne.replace(/\*/g,"")}e.stripWildcards=f;function m(ne,ge,Se={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=b(ne)),Se.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let we="";return Se.global&&(we+="g"),Se.matchCase||(we+="i"),Se.multiline&&(we+="m"),Se.unicode&&(we+="u"),new RegExp(ne,we)}e.createRegExp=m;function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function t(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=t;function o(ne){const ge=[],Se=ne.split(/(\r\n|\r|\n)/);for(let we=0;we<Math.ceil(Se.length/2);we++)ge.push(Se[2*we]+(Se[2*we+1]??""));return ge}e.splitLinesIncludeSeparators=o;function s(ne){for(let ge=0,Se=ne.length;ge<Se;ge++){const we=ne.charCodeAt(ge);if(we!==32&&we!==9)return ge}return-1}e.firstNonWhitespaceIndex=s;function i(ne,ge=0,Se=ne.length){for(let we=ge;we<Se;we++){const Ie=ne.charCodeAt(we);if(Ie!==32&&Ie!==9)return ne.substring(ge,we)}return ne.substring(ge,Se)}e.getLeadingWhitespace=i;function n(ne,ge=ne.length-1){for(let Se=ge;Se>=0;Se--){const we=ne.charCodeAt(Se);if(we!==32&&we!==9)return Se}return-1}e.lastNonWhitespaceIndex=n;function l(ne,ge,Se){const we=[];let Ie=0;for(const Oe of ne.matchAll(ge)){if(we.push(ne.slice(Ie,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Ie=Oe.index+Oe[0].length,we.push(Se(Oe[0],...Oe.slice(1),Oe.index,ne,Oe.groups))}return we.push(ne.slice(Ie)),Promise.all(we).then(Oe=>Oe.join(""))}e.replaceAsync=l;function S(ne,ge){return ne<ge?-1:ne>ge?1:0}e.compare=S;function R(ne,ge,Se=0,we=ne.length,Ie=0,Oe=ge.length){for(;Se<we&&Ie<Oe;Se++,Ie++){const Je=ne.charCodeAt(Se),Xe=ge.charCodeAt(Ie);if(Je<Xe)return-1;if(Je>Xe)return 1}const Ne=we-Se,Ke=Oe-Ie;return Ne<Ke?-1:Ne>Ke?1:0}e.compareSubstring=R;function k(ne,ge){return P(ne,ge,0,ne.length,0,ge.length)}e.compareIgnoreCase=k;function P(ne,ge,Se=0,we=ne.length,Ie=0,Oe=ge.length){for(;Se<we&&Ie<Oe;Se++,Ie++){let Je=ne.charCodeAt(Se),Xe=ge.charCodeAt(Ie);if(Je===Xe)continue;if(Je>=128||Xe>=128)return R(ne.toLowerCase(),ge.toLowerCase(),Se,we,Ie,Oe);_(Je)&&(Je-=32),_(Xe)&&(Xe-=32);const Ye=Je-Xe;if(Ye!==0)return Ye}const Ne=we-Se,Ke=Oe-Ie;return Ne<Ke?-1:Ne>Ke?1:0}e.compareSubstringIgnoreCase=P;function D(ne){return ne>=48&&ne<=57}e.isAsciiDigit=D;function _(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=_;function U(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=U;function F(ne,ge){return ne.length===ge.length&&P(ne,ge)===0}e.equalsIgnoreCase=F;function H(ne,ge){const Se=ge.length;return ge.length>ne.length?!1:P(ne,ge,0,Se)===0}e.startsWithIgnoreCase=H;function j(ne,ge){const Se=Math.min(ne.length,ge.length);let we;for(we=0;we<Se;we++)if(ne.charCodeAt(we)!==ge.charCodeAt(we))return we;return Se}e.commonPrefixLength=j;function le(ne,ge){const Se=Math.min(ne.length,ge.length);let we;const Ie=ne.length-1,Oe=ge.length-1;for(we=0;we<Se;we++)if(ne.charCodeAt(Ie-we)!==ge.charCodeAt(Oe-we))return we;return Se}e.commonSuffixLength=le;function se(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=se;function ue(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=ue;function Y(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}e.computeCodePoint=Y;function Q(ne,ge,Se){const we=ne.charCodeAt(Se);if(se(we)&&Se+1<ge){const Ie=ne.charCodeAt(Se+1);if(ue(Ie))return Y(we,Ie)}return we}e.getNextCodePoint=Q;function q(ne,ge){const Se=ne.charCodeAt(ge-1);if(ue(Se)&&ge>1){const we=ne.charCodeAt(ge-2);if(se(we))return Y(we,Se)}return Se}class W{get offset(){return this._offset}constructor(ge,Se=0){this._str=ge,this._len=ge.length,this._offset=Se}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=q(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Q(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class N{get offset(){return this._iterator.offset}constructor(ge,Se=0){this._iterator=new W(ge,Se)}nextGraphemeLength(){const ge=Ae.getInstance(),Se=this._iterator,we=Se.offset;let Ie=ge.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Oe=Se.offset,Ne=ge.getGraphemeBreakType(Se.nextCodePoint());if(me(Ie,Ne)){Se.setOffset(Oe);break}Ie=Ne}return Se.offset-we}prevGraphemeLength(){const ge=Ae.getInstance(),Se=this._iterator,we=Se.offset;let Ie=ge.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Oe=Se.offset,Ne=ge.getGraphemeBreakType(Se.prevCodePoint());if(me(Ne,Ie)){Se.setOffset(Oe);break}Ie=Ne}return we-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=N;function V(ne,ge){return new N(ne,ge).nextGraphemeLength()}e.nextCharLength=V;function $(ne,ge){return new N(ne,ge).prevGraphemeLength()}e.prevCharLength=$;function oe(ne,ge){ge>0&&ue(ne.charCodeAt(ge))&&ge--;const Se=ge+V(ne,ge);return[Se-$(ne,Se),Se]}e.getCharContainingOffset=oe;function de(ne){const ge=new N(ne);let Se=0;for(;!ge.eol();)Se++,ge.nextGraphemeLength();return Se}e.charCount=de;let G;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(ne){return G||(G=A()),G.test(ne)}e.containsRTL=T;const J=/^[\t\n\r\x20-\x7E]*$/;function B(ne){return J.test(ne)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=X;function x(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=x;function Z(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=Z;function z(ne,ge,Se=""){const we=ne.trimStart();if(we.length<ge)return we;const Ie=/\b/g;let Oe=0;for(;Ie.test(we)&&!(we.length-Ie.lastIndex<ge);)Oe=Ie.lastIndex,Ie.lastIndex+=1;return Oe===0?we:Se+we.substring(Oe).trimStart()}e.lcut=z;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function fe(ne){return ne&&(ne=ne.replace(ee,"").replace(ie,"")),ne}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER="\uFEFF";function pe(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Pe(ne){return pe(ne)?ne.substr(1):ne}e.stripUTF8BOM=Pe;function Ce(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const Se=ge.length,we=ne.toLowerCase();let Ie=0,Oe=-1;for(;Ie<Se;){const Ne=we.indexOf(ge[Ie],Oe+1);if(Ne<0)return!1;Oe=Ne,Ie++}return!0}e.fuzzyContains=Ce;function We(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=We;function Ee(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Ee;function ye(ne,ge=1){if(ge===0)return"";let Se=-1;do Se=ne.indexOf(`
`,Se+1),ge--;while(ge>0&&Se>=0);return Se===-1?ne:(ne[Se-1]==="\r"&&Se--,ne.substr(0,Se))}e.getNLines=ye;function te(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=te;function he(ne){return Ae.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=he;function me(ne,ge){return ne===0?ge!==5&&ge!==7:ne===2&&ge===3?!1:ne===4||ne===2||ne===3||ge===4||ge===2||ge===3?!0:!(ne===8&&(ge===8||ge===9||ge===11||ge===12)||(ne===11||ne===9)&&(ge===9||ge===10)||(ne===12||ne===10)&&ge===10||ge===5||ge===13||ge===7||ne===1||ne===13&&ge===14||ne===6&&ge===6)}var De;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class Ae{static{this._INSTANCE=null}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}constructor(){this._data=Ue()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const Se=this._data,we=Se.length/3;let Ie=1;for(;Ie<=we;)if(ge<Se[3*Ie])Ie=2*Ie;else if(ge>Se[3*Ie+1])Ie=2*Ie+1;else return Se[3*Ie+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function _e(ne,ge){if(ne===0)return 0;const Se=je(ne,ge);if(Se!==void 0)return Se;const we=new W(ge,ne);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=_e;function je(ne,ge){const Se=new W(ge,ne);let we=Se.prevCodePoint();for(;qe(we)||we===65039||we===8419;){if(Se.offset===0)return;we=Se.prevCodePoint()}if(!Z(we))return;let Ie=Se.offset;return Ie>0&&Se.prevCodePoint()===8205&&(Ie=Se.offset),Ie}function qe(ne){return 127995<=ne&&ne<=127999}var Ge;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class xe{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new I.LRUCachedFunction(ge=>{function Se(Ye){const rt=new Map;for(let tt=0;tt<Ye.length;tt+=2)rt.set(Ye[tt],Ye[tt+1]);return rt}function we(Ye,rt){const tt=new Map(Ye);for(const[ot,at]of rt)tt.set(ot,at);return tt}function Ie(Ye,rt){if(!Ye)return rt;const tt=new Map;for(const[ot,at]of Ye)rt.has(ot)&&tt.set(ot,at);return tt}const Oe=this.ambiguousCharacterData.value;let Ne=ge.filter(Ye=>!Ye.startsWith("_")&&Ye in Oe);Ne.length===0&&(Ne=["_default"]);let Ke;for(const Ye of Ne){const rt=Se(Oe[Ye]);Ke=Ie(Ke,rt)}const Je=Se(Oe._common),Xe=we(Je,Ke);return new xe(Xe)})}static getInstance(ge){return xe.cache.get(Array.from(ge))}static{this._locales=new L.Lazy(()=>Object.keys(xe.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return xe._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=xe;class $e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set($e.getRawData())),this._data}static isInvisibleCharacter(ge){return $e.getData().has(ge)}static get codePoints(){return $e.getData()}}e.InvisibleCharacters=$e}),define(ae[45],ce([0,1,25]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(u){return r(u,0)}e.hash=L;function r(u,d){switch(typeof u){case"object":return u===null?O(349,d):Array.isArray(u)?g(u,d):c(u,d);case"string":return C(u,d);case"boolean":return M(u,d);case"number":return O(u,d);case"undefined":return O(937,d);default:return O(617,d)}}e.doHash=r;function O(u,d){return(d<<5)-d+u|0}e.numberHash=O;function M(u,d){return O(u?433:863,d)}function C(u,d){d=O(149417,d);for(let f=0,m=u.length;f<m;f++)d=O(u.charCodeAt(f),d);return d}e.stringHash=C;function g(u,d){return d=O(104579,d),u.reduce((f,m)=>r(m,f),d)}function c(u,d){return d=O(181387,d),Object.keys(u).sort().reduce((f,m)=>(f=C(m,f),r(u[m],f)),d)}class v{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=r(d,this._value),this._value}}e.Hasher=v;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function w(u,d,f=32){const m=f-d,a=~((1<<m)-1);return(u<<d|(a&u)>>>m)>>>0}function h(u,d=0,f=u.byteLength,m=0){for(let a=0;a<f;a++)u[d+a]=m}function p(u,d,f="0"){for(;u.length<d;)u=f+u;return u}function y(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(f=>f.toString(16).padStart(2,"0")).join(""):p((u>>>0).toString(16),d/4)}e.toHexString=y;class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const f=d.length;if(f===0)return;const m=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,o,s;for(t!==0?(o=t,s=-1,t=0):(o=d.charCodeAt(0),s=0);;){let i=o;if(I.isHighSurrogate(o))if(s+1<f){const n=d.charCodeAt(s+1);I.isLowSurrogate(n)?(s++,i=I.computeCodePoint(o,n)):i=65533}else{t=o;break}else I.isLowSurrogate(o)&&(i=65533);if(a=this._push(m,a,i),s++,s<f)o=d.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(d,f,m){return m<128?d[f++]=m:m<2048?(d[f++]=192|(m&1984)>>>6,d[f++]=128|(m&63)>>>0):m<65536?(d[f++]=224|(m&61440)>>>12,d[f++]=128|(m&4032)>>>6,d[f++]=128|(m&63)>>>0):(d[f++]=240|(m&1835008)>>>18,d[f++]=128|(m&258048)>>>12,d[f++]=128|(m&4032)>>>6,d[f++]=128|(m&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=E._bigBlock32,f=this._buffDV;for(let S=0;S<64;S+=4)d.setUint32(S,f.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)d.setUint32(S,w(d.getUint32(S-12,!1)^d.getUint32(S-32,!1)^d.getUint32(S-56,!1)^d.getUint32(S-64,!1),1),!1);let m=this._h0,a=this._h1,t=this._h2,o=this._h3,s=this._h4,i,n,l;for(let S=0;S<80;S++)S<20?(i=a&t|~a&o,n=1518500249):S<40?(i=a^t^o,n=1859775393):S<60?(i=a&t|a&o|t&o,n=2400959708):(i=a^t^o,n=3395469782),l=w(m,5)+i+s+n+d.getUint32(S*4,!1)&4294967295,s=o,o=t,t=w(a,30),a=m,m=l;this._h0=this._h0+m&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E}),define(ae[73],ce([0,1,25]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const O="error",M="warning",C="warn",g="info",c="ignore";function v(w){return w?I.equalsIgnoreCase(O,w)?r.Error:I.equalsIgnoreCase(M,w)||I.equalsIgnoreCase(C,w)?r.Warning:I.equalsIgnoreCase(g,w)?r.Info:r.Ignore:r.Ignore}r.fromValue=v;function b(w){switch(w){case r.Error:return O;case r.Warning:return M;case r.Info:return g;default:return c}}r.toString=b}(L||(L={})),e.default=L}),define(ae[143],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const p=h.charCodeAt(0),y=this._value.charCodeAt(this._pos);return p-y}value(){return this._value[this._pos]}}e.StringIterator=r;class O{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,L.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class M{constructor(h=!0,p=!0){this._splitOnBackslash=h,this._caseSensitive=p}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let p=h.length-1;p>=0;p--,this._valueLen--){const y=this._value.charCodeAt(p);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,L.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var C;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(C||(C={}));class g{constructor(h,p){this._ignorePathCasing=h,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===4)return(0,L.compare)(h,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(v||(v={}));class b{static forUris(h=()=>!1,p=()=>!1){return new b(new g(h,p))}static forPaths(h=!1){return new b(new M(void 0,!h))}static forStrings(){return new b(new r)}static forConfigKeys(){return new b(new O)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,p){if(p){const y=p.slice(0);(0,I.shuffle)(y);for(const E of y)this.set(E,h)}else{const y=h.slice(0);(0,I.shuffle)(y);for(const E of y)this.set(E[0],E[1])}}set(h,p){const y=this._iter.reset(h);let E;this._root||(this._root=new c,this._root.segment=y.value());const u=[];for(E=this._root;;){const f=y.cmp(E.segment);if(f>0)E.left||(E.left=new c,E.left.segment=y.value()),u.push([-1,E]),E=E.left;else if(f<0)E.right||(E.right=new c,E.right.segment=y.value()),u.push([1,E]),E=E.right;else if(y.hasNext())y.next(),E.mid||(E.mid=new c,E.mid.segment=y.value()),u.push([0,E]),E=E.mid;else break}const d=E.value;E.value=p,E.key=h;for(let f=u.length-1;f>=0;f--){const m=u[f][1];m.updateHeight();const a=m.balanceFactor();if(a<-1||a>1){const t=u[f][0],o=u[f+1][0];if(t===1&&o===1)u[f][1]=m.rotateLeft();else if(t===-1&&o===-1)u[f][1]=m.rotateRight();else if(t===1&&o===-1)m.right=u[f+1][1]=u[f+1][1].rotateRight(),u[f][1]=m.rotateLeft();else if(t===-1&&o===1)m.left=u[f+1][1]=u[f+1][1].rotateLeft(),u[f][1]=m.rotateRight();else throw new Error;if(f>0)switch(u[f-1][0]){case-1:u[f-1][1].left=u[f][1];break;case 1:u[f-1][1].right=u[f][1];break;case 0:u[f-1][1].mid=u[f][1];break}else this._root=u[0][1]}}return d}get(h){return this._getNode(h)?.value}_getNode(h){const p=this._iter.reset(h);let y=this._root;for(;y;){const E=p.cmp(y.segment);if(E>0)y=y.left;else if(E<0)y=y.right;else if(p.hasNext())p.next(),y=y.mid;else break}return y}has(h){const p=this._getNode(h);return!(p?.value===void 0&&p?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,p){const y=this._iter.reset(h),E=[];let u=this._root;for(;u;){const d=y.cmp(u.segment);if(d>0)E.push([-1,u]),u=u.left;else if(d<0)E.push([1,u]),u=u.right;else if(y.hasNext())y.next(),E.push([0,u]),u=u.mid;else break}if(u){if(p?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this._min(u.right);if(d.key){const{key:f,value:m,segment:a}=d;this._delete(d.key,!1),u.key=f,u.value=m,u.segment=a}}else{const d=u.left??u.right;if(E.length>0){const[f,m]=E[E.length-1];switch(f){case-1:m.left=d;break;case 0:m.mid=d;break;case 1:m.right=d;break}}else this._root=d}for(let d=E.length-1;d>=0;d--){const f=E[d][1];f.updateHeight();const m=f.balanceFactor();if(m>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),E[d][1]=f.rotateLeft()):m<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),E[d][1]=f.rotateRight()),d>0)switch(E[d-1][0]){case-1:E[d-1][1].left=E[d][1];break;case 1:E[d-1][1].right=E[d][1];break;case 0:E[d-1][1].mid=E[d][1];break}else this._root=E[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const p=this._iter.reset(h);let y=this._root,E;for(;y;){const u=p.cmp(y.segment);if(u>0)y=y.left;else if(u<0)y=y.right;else if(p.hasNext())p.next(),E=y.value||E,y=y.mid;else break}return y&&y.value||E}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,p){const y=this._iter.reset(h);let E=this._root;for(;E;){const u=y.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(y.hasNext())y.next(),E=E.mid;else return E.mid?this._entries(E.mid):p?E.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[p,y]of this)h(y,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const p=[];return this._dfsEntries(h,p),p[Symbol.iterator]()}_dfsEntries(h,p){h&&(h.left&&this._dfsEntries(h.left,p),h.value&&p.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,p),h.right&&this._dfsEntries(h.right,p))}_isBalanced(){const h=p=>{if(!p)return!0;const y=p.balanceFactor();return y<-1||y>1?!1:h(p.left)&&h(p.right)};return h(this._root)}}e.TernarySearchTree=b}),define(ae[12],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(a){return typeof a=="string"}e.isString=I;function L(a){return Array.isArray(a)&&a.every(t=>I(t))}e.isStringArray=L;function r(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=r;function O(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.isTypedArray=O;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function C(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=C;function g(a){return a===!0||a===!1}e.isBoolean=g;function c(a){return typeof a>"u"}e.isUndefined=c;function v(a){return!b(a)}e.isDefined=v;function b(a){return c(a)||a===null}e.isUndefinedOrNull=b;function w(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=w;function h(a){if(b(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=h;function p(...a){const t=[];for(let o=0;o<a.length;o++){const s=a[o];if(b(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}e.assertAllDefined=p;const y=Object.prototype.hasOwnProperty;function E(a){if(!r(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}e.isEmptyObject=E;function u(a){return typeof a=="function"}e.isFunction=u;function d(...a){return a.length>0&&a.every(u)}e.areFunctions=d;function f(a,t){const o=Math.min(a.length,t.length);for(let s=0;s<o;s++)m(a[s],t[s])}e.validateConstraints=f;function m(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(a instanceof t)return}catch{}if(!b(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m}),define(ae[74],ce([0,1,12]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(C,g){if((0,I.isString)(g)){const c=L[g];if(c===void 0)throw new Error(`${C} references an unknown codicon: ${g}`);g=c}return L[C]=g,{id:C}}function O(){return L}e.getCodiconFontCharacters=O;function M(){return Object.values(e.Codicon)}e.getAllCodicons=M,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),runAllCoverage:r("run-all-coverage",60461),runCoverage:r("run-all-coverage",60460),coverage:r("coverage",60462),githubProject:r("github-project",60463),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(ae[35],ce([0,1,12]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([f,m])=>{d[f]=m&&typeof m=="object"?L(m):m}),d}e.deepClone=L;function r(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const f=d.shift();Object.freeze(f);for(const m in f)if(O.call(f,m)){const a=f[m];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.isTypedArray)(a)&&d.push(a)}}return u}e.deepFreeze=r;const O=Object.prototype.hasOwnProperty;function M(u,d){return C(u,d,new Set)}e.cloneAndChange=M;function C(u,d,f){if((0,I.isUndefinedOrNull)(u))return u;const m=d(u);if(typeof m<"u")return m;if(Array.isArray(u)){const a=[];for(const t of u)a.push(C(t,d,f));return a}if((0,I.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const a={};for(const t in u)O.call(u,t)&&(a[t]=C(u[t],d,f));return f.delete(u),a}return u}function g(u,d,f=!0){return(0,I.isObject)(u)?((0,I.isObject)(d)&&Object.keys(d).forEach(m=>{m in u?f&&((0,I.isObject)(u[m])&&(0,I.isObject)(d[m])?g(u[m],d[m],f):u[m]=d[m]):u[m]=d[m]}),u):d}e.mixin=g;function c(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let f,m;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(f=0;f<u.length;f++)if(!c(u[f],d[f]))return!1}else{const a=[];for(m in u)a.push(m);a.sort();const t=[];for(m in d)t.push(m);if(t.sort(),!c(a,t))return!1;for(f=0;f<a.length;f++)if(!c(u[a[f]],d[a[f]]))return!1}return!0}e.equals=c;function v(u){const d=new Set;return JSON.stringify(u,(f,m)=>{if((0,I.isObject)(m)||Array.isArray(m)){if(d.has(m))return"[Circular]";d.add(m)}return m})}e.safeStringify=v;function b(u,d){const f=Object.create(null);return!u||!d||Object.keys(d).forEach(a=>{const t=u[a],o=d[a];c(t,o)||(f[a]=o)}),f}e.distinct=b;function w(u,d){const f=d.toLowerCase(),m=Object.keys(u).find(a=>a.toLowerCase()===f);return m?u[m]:u[d]}e.getCaseInsensitive=w;function h(u,d){const f=Object.create(null);for(const[m,a]of Object.entries(u))d(m,a)&&(f[m]=a);return f}e.filter=h;function p(u){let d=[];for(;Object.prototype!==u;)d=d.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return d}e.getAllPropertyNames=p;function y(u){const d=[];for(const f of p(u))typeof u[f]=="function"&&d.push(f);return d}e.getAllMethodNames=y;function E(u,d){const f=a=>function(){const t=Array.prototype.slice.call(arguments,0);return d(a,t)},m={};for(const a of u)m[a]=f(a);return m}e.createProxyObject=E}),define(ae[104],ce([0,1,74]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(M){function C(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=C})(L||(e.ThemeColor=L={}));function r(M){return{id:M}}e.themeColorFromId=r;var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(d){const f=C.exec(d.id);if(!f)return g(I.Codicon.error);const[,m,a]=f,t=["codicon","codicon-"+m];return a&&t.push("codicon-modifier-"+a.substring(1)),t}M.asClassNameArray=g;function c(d){return g(d).join(" ")}M.asClassName=c;function v(d){return"."+g(d).join(".")}M.asCSSSelector=v;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||L.isThemeColor(d.color))}M.isThemeIcon=b;const w=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function h(d){const f=w.exec(d);if(!f)return;const[,m]=f;return{id:m}}M.fromString=h;function p(d){return{id:d}}M.fromId=p;function y(d,f){let m=d.id;const a=m.lastIndexOf("~");return a!==-1&&(m=m.substring(0,a)),f&&(m=`${m}~${f}`),{id:m}}M.modify=y;function E(d){const f=d.id.lastIndexOf("~");if(f!==-1)return d.id.substring(f+1)}M.getModifier=E;function u(d,f){return d.id===f.id&&d.color?.id===f.color?.id}M.isEqual=u})(O||(e.ThemeIcon=O={}))}),define(ae[32],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return I.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(C){for(let g=0;g<C.length;g++)C[g]=Math.floor(Math.random()*256);return C};const O=new Uint8Array(16),M=[];for(let C=0;C<256;C++)M.push(C.toString(16).padStart(2,"0"));return function(){r(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,c="";return c+=M[O[g++]],c+=M[O[g++]],c+=M[O[g++]],c+=M[O[g++]],c+="-",c+=M[O[g++]],c+=M[O[g++]],c+="-",c+=M[O[g++]],c+=M[O[g++]],c+="-",c+=M[O[g++]],c+=M[O[g++]],c+="-",c+=M[O[g++]],c+=M[O[g++]],c+=M[O[g++]],c+=M[O[g++]],c+=M[O[g++]],c+=M[O[g++]],c}}()}),define(ae[144],ce([0,1,87,46,85]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function O(M,C){if(await new Promise((v,b)=>{const w=L.createReadStream(M),h=I.createHash("sha256");w.pipe(h);const p=(0,r.createSingleCallFunction)((y,E)=>{w.removeAllListeners(),h.removeAllListeners(),y?b(y):v(E)});w.once("error",p),w.once("end",p),h.once("error",p),h.once("data",y=>p(void 0,y.toString("hex")))})!==C)throw new Error("Hash mismatch")}e.checksum=O}),define(ae[145],ce([0,1,26]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(M){const C=M.replace(/\-/g,":").toLowerCase();return!L.has(C)}function O(){const M=(0,I.networkInterfaces)();for(const C in M){const g=M[C];if(g){for(const{mac:c}of g)if(r(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(ae[105],ce([0,1,88]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(C,g,c,v=1){let b=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!b)return b=!0,w(0)},c);r(C,g,v,p=>{if(!b)return b=!0,clearTimeout(h),w(p)})})}e.findFreePort=L;function r(C,g,c,v){if(g===0)return v(0);const b=new I.Socket;b.once("connect",()=>(M(b),r(C+c,g-1,c,v))),b.once("data",()=>{}),b.once("error",w=>(M(b),w.code!=="ECONNREFUSED"?r(C+c,g-1,c,v):v(C))),b.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(C,g,c,v="127.0.0.1"){let b=!1,w,h=1;const p=I.createServer({pauseOnConnect:!0});function y(E,u){b||(b=!0,p.removeAllListeners(),p.close(),w&&clearTimeout(w),u(E))}return new Promise(E=>{w=setTimeout(()=>{y(0,E)},c),p.on("listening",()=>{y(C,E)}),p.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<g?(C++,h++,p.listen(C,v)):y(0,E)}),p.on("close",()=>{y(0,E)}),p.listen(C,v)})}e.findFreePortFaster=O;function M(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(g){console.error(g)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function I(g){const c=new Set;if(Array.isArray(g))for(const v of g)typeof v=="string"&&c.add(v);return Array.from(c)}function L(){const g=e();return g?Array.from(g):[]}function r(g){if(process.platform!=="win32")return;const c=e();if(c)if(typeof g=="string")c.add(g.toLowerCase());else for(const v of I(g))r(v)}function O(g){if(typeof g!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let v;for(const b of c){if(g.indexOf(b)!==0)continue;const h=g.indexOf("\\",b.length);if(h===-1)continue;const p=g.substring(b.length,h);if(p){v=p;break}}return v}function M(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function C(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:O,disableUNCAccessRestrictions:M,isUNCAccessRestrictionsDisabled:C}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[146],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ae[147],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(r,O){this.sender=r,this.onMessage=O}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=I}),define(ae[148],ce([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(ae[149],ce([0,1,148]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.getDurationString=e.fromNow=void 0;const L=60,r=L*60,O=r*24,M=O*7,C=O*30,g=O*365;function c(w,h,p,y){typeof w!="number"&&(w=w.getTime());const E=Math.round((new Date().getTime()-w)/1e3);if(E<-30)return(0,I.localize)(0,null,c(new Date().getTime()+E*1e3,!1));if(!y&&E<30)return(0,I.localize)(1,null);let u;return E<L?(u=E,h?u===1?p?(0,I.localize)(2,null,u):(0,I.localize)(3,null,u):p?(0,I.localize)(4,null,u):(0,I.localize)(5,null,u):u===1?p?(0,I.localize)(6,null,u):(0,I.localize)(7,null,u):p?(0,I.localize)(8,null,u):(0,I.localize)(9,null,u)):E<r?(u=Math.floor(E/L),h?u===1?p?(0,I.localize)(10,null,u):(0,I.localize)(11,null,u):p?(0,I.localize)(12,null,u):(0,I.localize)(13,null,u):u===1?p?(0,I.localize)(14,null,u):(0,I.localize)(15,null,u):p?(0,I.localize)(16,null,u):(0,I.localize)(17,null,u)):E<O?(u=Math.floor(E/r),h?u===1?p?(0,I.localize)(18,null,u):(0,I.localize)(19,null,u):p?(0,I.localize)(20,null,u):(0,I.localize)(21,null,u):u===1?p?(0,I.localize)(22,null,u):(0,I.localize)(23,null,u):p?(0,I.localize)(24,null,u):(0,I.localize)(25,null,u)):E<M?(u=Math.floor(E/O),h?u===1?(0,I.localize)(26,null,u):(0,I.localize)(27,null,u):u===1?(0,I.localize)(28,null,u):(0,I.localize)(29,null,u)):E<C?(u=Math.floor(E/M),h?u===1?p?(0,I.localize)(30,null,u):(0,I.localize)(31,null,u):p?(0,I.localize)(32,null,u):(0,I.localize)(33,null,u):u===1?p?(0,I.localize)(34,null,u):(0,I.localize)(35,null,u):p?(0,I.localize)(36,null,u):(0,I.localize)(37,null,u)):E<g?(u=Math.floor(E/C),h?u===1?p?(0,I.localize)(38,null,u):(0,I.localize)(39,null,u):p?(0,I.localize)(40,null,u):(0,I.localize)(41,null,u):u===1?p?(0,I.localize)(42,null,u):(0,I.localize)(43,null,u):p?(0,I.localize)(44,null,u):(0,I.localize)(45,null,u)):(u=Math.floor(E/g),h?u===1?p?(0,I.localize)(46,null,u):(0,I.localize)(47,null,u):p?(0,I.localize)(48,null,u):(0,I.localize)(49,null,u):u===1?p?(0,I.localize)(50,null,u):(0,I.localize)(51,null,u):p?(0,I.localize)(52,null,u):(0,I.localize)(53,null,u))}e.fromNow=c;function v(w,h){const p=Math.abs(w/1e3);return p<1?h?(0,I.localize)(54,null,w):(0,I.localize)(55,null,w):p<L?h?(0,I.localize)(56,null,Math.round(w)/1e3):(0,I.localize)(57,null,Math.round(w)/1e3):p<r?h?(0,I.localize)(58,null,Math.round(w/(1e3*L))):(0,I.localize)(59,null,Math.round(w/(1e3*L))):p<O?h?(0,I.localize)(60,null,Math.round(w/(1e3*r))):(0,I.localize)(61,null,Math.round(w/(1e3*r))):(0,I.localize)(62,null,Math.round(w/(1e3*O)))}e.getDurationString=v;function b(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ae[150],ce([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,150]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(b,w){return w&&(b.stack||b.stacktrace)?r.localize(0,null,C(b),M(b.stack)||M(b.stacktrace)):C(b)}function M(b){return Array.isArray(b)?b.join(`
`):b}function C(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?r.localize(1,null,b.message):b.message||r.localize(2,null)}function g(b=null,w=!1){if(!b)return r.localize(3,null);if(Array.isArray(b)){const h=I.coalesce(b),p=g(h[0],w);return h.length>1?r.localize(4,null,p,h.length):p}if(L.isString(b))return b;if(b.detail){const h=b.detail;if(h.error)return O(h.error,w);if(h.exception)return O(h.exception,w)}return b.stack?O(b,w):b.message?b.message:r.localize(5,null)}e.toErrorMessage=g;function c(b){const w=b;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=c;function v(b,w){let h;return typeof b=="string"?h=new Error(b):h=b,h.actions=w,h}e.createErrorWithActions=v}),define(ae[151],ce([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(ae[152],ce([0,1,151]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ae[153],ce([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,153]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,O=!1,M=!1,C=!1,g=!1,c=!1,v=!1,b=!1,w=!1,h,p=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,E,u;const d=globalThis;let f;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?f=d.vscode.process:typeof process<"u"&&(f=process);const m=typeof f?.versions?.electron=="string",a=m&&f?.type==="renderer";if(typeof f=="object"){L=f.platform==="win32",r=f.platform==="darwin",O=f.platform==="linux",M=O&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,c=m,b=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const P=f.env.VSCODE_NLS_CONFIG;if(P)try{const D=JSON.parse(P),_=D.availableLanguages["*"];h=D.locale,y=D.osLocale,p=_||e.LANGUAGE_DEFAULT,E=D._translationsConfigFile}catch{}C=!0}else typeof navigator=="object"&&!a?(u=navigator.userAgent,L=u.indexOf("Windows")>=0,r=u.indexOf("Macintosh")>=0,v=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=u.indexOf("Linux")>=0,w=u?.indexOf("Mobi")>=0,g=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,p=h,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let s=0;r?s=1:L?s=3:O&&(s=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=O,e.isLinuxSnap=M,e.isNative=C,e.isElectron=c,e.isWeb=g,e.isWebWorker=g&&typeof d.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?d.origin:void 0,e.isIOS=v,e.isMobile=w,e.isCI=b,e.platform=s,e.userAgent=u,e.language=p;var i;(function(P){function D(){return e.language}P.value=D;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}P.isDefaultVariant=_;function U(){return e.language==="en"}P.isDefault=U})(i||(e.Language=i={})),e.locale=h,e.platformLocale=y,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const P=[];d.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let U=0,F=P.length;U<F;U++){const H=P[U];if(H.id===_.data.vscodeScheduleAsyncWork){P.splice(U,1),H.callback();return}}});let D=0;return _=>{const U=++D;P.push({id:U,callback:_}),d.postMessage({vscodeScheduleAsyncWork:U},"*")}}return P=>setTimeout(P)})();var n;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||v?2:L?1:3;let l=!0,S=!1;function R(){if(!S){S=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,l=new Uint16Array(P.buffer)[0]===513}return l}e.isLittleEndian=R,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function k(P){return parseFloat(P)>=20}e.isBigSurOrNewer=k}),define(ae[36],ce([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const O=r.process;L={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ae[9],ce([0,1,36]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,O=90,M=122,C=46,g=47,c=92,v=58,b=63;class w extends Error{constructor(o,s,i){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const l=o.indexOf(".")!==-1?"property":"argument";let S=`The "${o}" ${l} ${n} of type ${s}`;S+=`. Received type ${typeof i}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new w(o,"Object",t)}function p(t,o){if(typeof t!="string")throw new w(o,"string",t)}const y=I.platform==="win32";function E(t){return t===g||t===c}function u(t){return t===g}function d(t){return t>=L&&t<=O||t>=r&&t<=M}function f(t,o,s,i){let n="",l=0,S=-1,R=0,k=0;for(let P=0;P<=t.length;++P){if(P<t.length)k=t.charCodeAt(P);else{if(i(k))break;k=g}if(i(k)){if(!(S===P-1||R===1))if(R===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const D=n.lastIndexOf(s);D===-1?(n="",l=0):(n=n.slice(0,D),l=n.length-1-n.lastIndexOf(s)),S=P,R=0;continue}else if(n.length!==0){n="",l=0,S=P,R=0;continue}}o&&(n+=n.length>0?`${s}..`:"..",l=2)}else n.length>0?n+=`${s}${t.slice(S+1,P)}`:n=t.slice(S+1,P),l=P-S-1;S=P,R=0}else k===C&&R!==-1?++R:R=-1}return n}function m(t,o){h(o,"pathObject");const s=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let o="",s="",i=!1;for(let n=t.length-1;n>=-1;n--){let l;if(n>=0){if(l=t[n],p(l,"path"),l.length===0)continue}else o.length===0?l=I.cwd():(l=I.env[`=${o}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${o}\\`));const S=l.length;let R=0,k="",P=!1;const D=l.charCodeAt(0);if(S===1)E(D)&&(R=1,P=!0);else if(E(D))if(P=!0,E(l.charCodeAt(1))){let _=2,U=_;for(;_<S&&!E(l.charCodeAt(_));)_++;if(_<S&&_!==U){const F=l.slice(U,_);for(U=_;_<S&&E(l.charCodeAt(_));)_++;if(_<S&&_!==U){for(U=_;_<S&&!E(l.charCodeAt(_));)_++;(_===S||_!==U)&&(k=`\\\\${F}\\${l.slice(U,_)}`,R=_)}}}else R=1;else d(D)&&l.charCodeAt(1)===v&&(k=l.slice(0,2),R=2,S>2&&E(l.charCodeAt(2))&&(P=!0,R=3));if(k.length>0)if(o.length>0){if(k.toLowerCase()!==o.toLowerCase())continue}else o=k;if(i){if(o.length>0)break}else if(s=`${l.slice(R)}\\${s}`,i=P,P&&o.length>0)break}return s=f(s,!i,"\\",E),i?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){p(t,"path");const o=t.length;if(o===0)return".";let s=0,i,n=!1;const l=t.charCodeAt(0);if(o===1)return u(l)?"\\":t;if(E(l))if(n=!0,E(t.charCodeAt(1))){let R=2,k=R;for(;R<o&&!E(t.charCodeAt(R));)R++;if(R<o&&R!==k){const P=t.slice(k,R);for(k=R;R<o&&E(t.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&!E(t.charCodeAt(R));)R++;if(R===o)return`\\\\${P}\\${t.slice(k)}\\`;R!==k&&(i=`\\\\${P}\\${t.slice(k,R)}`,s=R)}}}else s=1;else d(l)&&t.charCodeAt(1)===v&&(i=t.slice(0,2),s=2,o>2&&E(t.charCodeAt(2))&&(n=!0,s=3));let S=s<o?f(t.slice(s),!n,"\\",E):"";return S.length===0&&!n&&(S="."),S.length>0&&E(t.charCodeAt(o-1))&&(S+="\\"),i===void 0?n?`\\${S}`:S:n?`${i}\\${S}`:`${i}${S}`},isAbsolute(t){p(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return E(s)||o>2&&d(s)&&t.charCodeAt(1)===v&&E(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let l=0;l<t.length;++l){const S=t[l];p(S,"path"),S.length>0&&(o===void 0?o=s=S:o+=`\\${S}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof s=="string"&&E(s.charCodeAt(0))){++n;const l=s.length;l>1&&E(s.charCodeAt(1))&&(++n,l>2&&(E(s.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&E(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(t,o){if(p(t,"from"),p(o,"to"),t===o)return"";const s=e.win32.resolve(t),i=e.win32.resolve(o);if(s===i||(t=s.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===c;)n++;let l=t.length;for(;l-1>n&&t.charCodeAt(l-1)===c;)l--;const S=l-n;let R=0;for(;R<o.length&&o.charCodeAt(R)===c;)R++;let k=o.length;for(;k-1>R&&o.charCodeAt(k-1)===c;)k--;const P=k-R,D=S<P?S:P;let _=-1,U=0;for(;U<D;U++){const H=t.charCodeAt(n+U);if(H!==o.charCodeAt(R+U))break;H===c&&(_=U)}if(U!==D){if(_===-1)return i}else{if(P>D){if(o.charCodeAt(R+U)===c)return i.slice(R+U+1);if(U===2)return i.slice(R+U)}S>D&&(t.charCodeAt(n+U)===c?_=U:U===2&&(_=3)),_===-1&&(_=0)}let F="";for(U=n+_+1;U<=l;++U)(U===l||t.charCodeAt(U)===c)&&(F+=F.length===0?"..":"\\..");return R+=_,F.length>0?`${F}${i.slice(R,k)}`:(i.charCodeAt(R)===c&&++R,i.slice(R,k))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==b&&s!==C)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===v&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){p(t,"path");const o=t.length;if(o===0)return".";let s=-1,i=0;const n=t.charCodeAt(0);if(o===1)return E(n)?t:".";if(E(n)){if(s=i=1,E(t.charCodeAt(1))){let R=2,k=R;for(;R<o&&!E(t.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&E(t.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&!E(t.charCodeAt(R));)R++;if(R===o)return t;R!==k&&(s=i=R+1)}}}}else d(n)&&t.charCodeAt(1)===v&&(s=o>2&&E(t.charCodeAt(2))?3:2,i=s);let l=-1,S=!0;for(let R=o-1;R>=i;--R)if(E(t.charCodeAt(R))){if(!S){l=R;break}}else S=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,o){o!==void 0&&p(o,"ext"),p(t,"path");let s=0,i=-1,n=!0,l;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===v&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let S=o.length-1,R=-1;for(l=t.length-1;l>=s;--l){const k=t.charCodeAt(l);if(E(k)){if(!n){s=l+1;break}}else R===-1&&(n=!1,R=l+1),S>=0&&(k===o.charCodeAt(S)?--S===-1&&(i=l):(S=-1,i=R))}return s===i?i=R:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(E(t.charCodeAt(l))){if(!n){s=l+1;break}}else i===-1&&(n=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){p(t,"path");let o=0,s=-1,i=0,n=-1,l=!0,S=0;t.length>=2&&t.charCodeAt(1)===v&&d(t.charCodeAt(0))&&(o=i=2);for(let R=t.length-1;R>=o;--R){const k=t.charCodeAt(R);if(E(k)){if(!l){i=R+1;break}continue}n===-1&&(l=!1,n=R+1),k===C?s===-1?s=R:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||n===-1||S===0||S===1&&s===n-1&&s===i+1?"":t.slice(s,n)},format:m.bind(null,"\\"),parse(t){p(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let i=0,n=t.charCodeAt(0);if(s===1)return E(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(E(n)){if(i=1,E(t.charCodeAt(1))){let _=2,U=_;for(;_<s&&!E(t.charCodeAt(_));)_++;if(_<s&&_!==U){for(U=_;_<s&&E(t.charCodeAt(_));)_++;if(_<s&&_!==U){for(U=_;_<s&&!E(t.charCodeAt(_));)_++;_===s?i=_:_!==U&&(i=_+1)}}}}else if(d(n)&&t.charCodeAt(1)===v){if(s<=2)return o.root=o.dir=t,o;if(i=2,E(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let l=-1,S=i,R=-1,k=!0,P=t.length-1,D=0;for(;P>=i;--P){if(n=t.charCodeAt(P),E(n)){if(!k){S=P+1;break}continue}R===-1&&(k=!1,R=P+1),n===C?l===-1?l=P:D!==1&&(D=1):l!==-1&&(D=-1)}return R!==-1&&(l===-1||D===0||D===1&&l===R-1&&l===S+1?o.base=o.name=t.slice(S,R):(o.name=t.slice(S,l),o.base=t.slice(S,R),o.ext=t.slice(l,R))),S>0&&S!==i?o.dir=t.slice(0,S-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const o=I.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const n=i>=0?t[i]:a();p(n,"path"),n.length!==0&&(o=`${n}/${o}`,s=n.charCodeAt(0)===g)}return o=f(o,!s,"/",u),s?`/${o}`:o.length>0?o:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===g,s=t.charCodeAt(t.length-1)===g;return t=f(t,!o,"/",u),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const i=t[s];p(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(p(t,"from"),p(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,i=t.length,n=i-s,l=1,S=o.length-l,R=n<S?n:S;let k=-1,P=0;for(;P<R;P++){const _=t.charCodeAt(s+P);if(_!==o.charCodeAt(l+P))break;_===g&&(k=P)}if(P===R)if(S>R){if(o.charCodeAt(l+P)===g)return o.slice(l+P+1);if(P===0)return o.slice(l+P)}else n>R&&(t.charCodeAt(s+P)===g?k=P:P===0&&(k=0));let D="";for(P=s+k+1;P<=i;++P)(P===i||t.charCodeAt(P)===g)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(l+k)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===g;let s=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===g){if(!i){s=n;break}}else i=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&p(o,"ext"),p(t,"path");let s=0,i=-1,n=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let S=o.length-1,R=-1;for(l=t.length-1;l>=0;--l){const k=t.charCodeAt(l);if(k===g){if(!n){s=l+1;break}}else R===-1&&(n=!1,R=l+1),S>=0&&(k===o.charCodeAt(S)?--S===-1&&(i=l):(S=-1,i=R))}return s===i?i=R:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===g){if(!n){s=l+1;break}}else i===-1&&(n=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){p(t,"path");let o=-1,s=0,i=-1,n=!0,l=0;for(let S=t.length-1;S>=0;--S){const R=t.charCodeAt(S);if(R===g){if(!n){s=S+1;break}continue}i===-1&&(n=!1,i=S+1),R===C?o===-1?o=S:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===s+1?"":t.slice(o,i)},format:m.bind(null,"/"),parse(t){p(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===g;let i;s?(o.root="/",i=1):i=0;let n=-1,l=0,S=-1,R=!0,k=t.length-1,P=0;for(;k>=i;--k){const D=t.charCodeAt(k);if(D===g){if(!R){l=k+1;break}continue}S===-1&&(R=!1,S=k+1),D===C?n===-1?n=k:P!==1&&(P=1):n!==-1&&(P=-1)}if(S!==-1){const D=l===0&&s?1:l;n===-1||P===0||P===1&&n===S-1&&n===l+1?o.base=o.name=t.slice(D,S):(o.name=t.slice(D,n),o.base=t.slice(D,S),o.ext=t.slice(n,S))}return l>0?o.dir=t.slice(0,l-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(l){return l===47||l===92}e.isPathSeparator=M;function C(l){return l.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=C;function g(l){return l.indexOf("/")===-1&&(l=C(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=g;function c(l,S=I.posix.sep){if(!l)return"";const R=l.length,k=l.charCodeAt(0);if(M(k)){if(M(l.charCodeAt(1))&&!M(l.charCodeAt(2))){let D=3;const _=D;for(;D<R&&!M(l.charCodeAt(D));D++);if(_!==D&&!M(l.charCodeAt(D+1))){for(D+=1;D<R;D++)if(M(l.charCodeAt(D)))return l.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(u(k)&&l.charCodeAt(1)===58)return M(l.charCodeAt(2))?l.slice(0,2)+S:l.slice(0,2);let P=l.indexOf("://");if(P!==-1){for(P+=3;P<R;P++)if(M(l.charCodeAt(P)))return l.slice(0,P+1)}return""}e.getRoot=c;function v(l){if(!L.isWindows||!l||l.length<5)return!1;let S=l.charCodeAt(0);if(S!==92||(S=l.charCodeAt(1),S!==92))return!1;let R=2;const k=R;for(;R<l.length&&(S=l.charCodeAt(R),S!==92);R++);return!(k===R||(S=l.charCodeAt(R+1),isNaN(S)||S===92))}e.isUNC=v;const b=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(l,S=L.isWindows){const R=S?b:w;return!(!l||l.length===0||/^\s+$/.test(l)||(R.lastIndex=0,R.test(l))||S&&h.test(l)||l==="."||l===".."||S&&l[l.length-1]==="."||S&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=p;function y(l,S,R){const k=l===S;return!R||k?k:!l||!S?!1:(0,r.equalsIgnoreCase)(l,S)}e.isEqual=y;function E(l,S,R,k=I.sep){if(l===S)return!0;if(!l||!S||S.length>l.length)return!1;if(R){if(!(0,r.startsWithIgnoreCase)(l,S))return!1;if(S.length===l.length)return!0;let D=S.length;return S.charAt(S.length-1)===k&&D--,l.charAt(D)===k}return S.charAt(S.length-1)!==k&&(S+=k),l.indexOf(S)===0}e.isEqualOrParent=E;function u(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=u;function d(l,S){return L.isWindows&&l.endsWith(":")&&(l+=I.sep),(0,I.isAbsolute)(l)||(l=(0,I.join)(S,l)),l=(0,I.normalize)(l),L.isWindows?(l=(0,r.rtrim)(l,I.sep),l.endsWith(":")&&(l+=I.sep)):(l=(0,r.rtrim)(l,I.sep),l||(l=I.sep)),l}e.sanitizeFilePath=d;function f(l){const S=(0,I.normalize)(l);return L.isWindows?l.length>3?!1:m(S)&&(l.length===2||S.charCodeAt(2)===92):S===I.posix.sep}e.isRootOrDriveLetter=f;function m(l,S=L.isWindows){return S?u(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function a(l,S=L.isWindows){return m(l,S)?l[0]:void 0}e.getDriveLetter=a;function t(l,S,R){return S.length>l.length?-1:l===S?0:(R&&(l=l.toLowerCase(),S=S.toLowerCase()),l.indexOf(S))}e.indexOfPath=t;function o(l){const S=l.split(":");let R,k,P;for(const D of S){const _=Number(D);(0,O.isNumber)(_)?k===void 0?k=_:P===void 0&&(P=_):R=R?[R,D].join(":"):D}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:k!==void 0?k:void 0,column:P!==void 0?P:k!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(l,S,R=8){let k="";for(let D=0;D<R;D++){let _;D===0&&L.isWindows&&!S&&(R===3||R===4)?_=i:_=s,k+=_.charAt(Math.floor(Math.random()*_.length))}let P;return S?P=`${S}-${k}`:P=k,l?(0,I.join)(l,P):P}e.randomPath=n}),define(ae[75],ce([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function O(C,...g){const c=g.reduce((w,h)=>(w[h]=!0,w),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(w=>!c[w]).forEach(w=>{for(let h=0;h<v.length;h++)if(w.search(v[h])!==-1){delete C[w];break}})}e.sanitizeProcessEnvironment=O;function M(C){C&&(delete C.DEBUG,I.isMacintosh&&delete C.DYLD_LIBRARY_PATH,I.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ae[7],ce([0,1,9,4]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,O=/^\//,M=/^\/\//;function C(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,n){return!i&&!n?"file":i}function c(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const v="",b="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,S,R,k,P=!1){typeof n=="object"?(this.scheme=n.scheme||v,this.authority=n.authority||v,this.path=n.path||v,this.query=n.query||v,this.fragment=n.fragment||v):(this.scheme=g(n,P),this.authority=l||v,this.path=c(this.scheme,S||v),this.query=R||v,this.fragment=k||v,C(this,P))}get fsPath(){return m(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:S,path:R,query:k,fragment:P}=n;return l===void 0?l=this.scheme:l===null&&(l=v),S===void 0?S=this.authority:S===null&&(S=v),R===void 0?R=this.path:R===null&&(R=v),k===void 0?k=this.query:k===null&&(k=v),P===void 0?P=this.fragment:P===null&&(P=v),l===this.scheme&&S===this.authority&&R===this.path&&k===this.query&&P===this.fragment?this:new E(l,S,R,k,P)}static parse(n,l=!1){const S=w.exec(n);return S?new E(S[2]||v,s(S[4]||v),s(S[5]||v),s(S[7]||v),s(S[9]||v),l):new E(v,v,v,v,v)}static file(n){let l=v;if(L.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const S=n.indexOf(b,2);S===-1?(l=n.substring(2),n=b):(l=n.substring(2,S),n=n.substring(S)||b)}return new E("file",l,n,v,v)}static from(n,l){return new E(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return L.isWindows&&n.scheme==="file"?S=h.file(I.win32.join(m(n,!0),...l)).path:S=I.posix.join(n.path,...l),n.with({path:S})}toString(n=!1){return a(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const l=new E(n);return l._formatted=n.external??null,l._fsPath=n._sep===y?n.fsPath??null:null,l}}else return n}}e.URI=h;function p(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=p;const y=L.isWindows?1:void 0;class E extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(n=!1){return n?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=y),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(i,n,l){let S,R=-1;for(let k=0;k<i.length;k++){const P=i.charCodeAt(k);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47||l&&P===91||l&&P===93||l&&P===58)R!==-1&&(S+=encodeURIComponent(i.substring(R,k)),R=-1),S!==void 0&&(S+=i.charAt(k));else{S===void 0&&(S=i.substr(0,k));const D=u[P];D!==void 0?(R!==-1&&(S+=encodeURIComponent(i.substring(R,k)),R=-1),S+=D):R===-1&&(R=k)}}return R!==-1&&(S+=encodeURIComponent(i.substring(R))),S!==void 0?S:i}function f(i){let n;for(let l=0;l<i.length;l++){const S=i.charCodeAt(l);S===35||S===63?(n===void 0&&(n=i.substr(0,l)),n+=u[S]):n!==void 0&&(n+=i[l])}return n!==void 0?n:i}function m(i,n){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=m;function a(i,n){const l=n?f:d;let S="",{scheme:R,authority:k,path:P,query:D,fragment:_}=i;if(R&&(S+=R,S+=":"),(k||R==="file")&&(S+=b,S+=b),k){let U=k.indexOf("@");if(U!==-1){const F=k.substr(0,U);k=k.substr(U+1),U=F.lastIndexOf(":"),U===-1?S+=l(F,!1,!1):(S+=l(F.substr(0,U),!1,!1),S+=":",S+=l(F.substr(U+1),!1,!0)),S+="@"}k=k.toLowerCase(),U=k.lastIndexOf(":"),U===-1?S+=l(k,!1,!0):(S+=l(k.substr(0,U),!1,!0),S+=k.substr(U))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const U=P.charCodeAt(1);U>=65&&U<=90&&(P=`/${String.fromCharCode(U+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const U=P.charCodeAt(0);U>=65&&U<=90&&(P=`${String.fromCharCode(U+32)}:${P.substr(2)}`)}S+=l(P,!0,!1)}return D&&(S+="?",S+=l(D,!1,!1)),_&&(S+="#",S+=n?_:d(_,!1,!1)),S}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(ae[154],ce([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(c){const v=c;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=L;function r(c){const v=[];let b;try{const w=JSON.parse(c.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),b=h.__$stack),v.push(...w)}catch{v.push("Unable to log remote console arguments",c.arguments)}return{args:v,stack:b}}e.parse=r;function O(c){if(typeof c!="string")return O(r(c).stack);const v=c;if(v){const b=M(v),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(w&&w.length===4)return{uri:I.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=O;function M(c){if(!c)return c;const v=c.indexOf(`
`);return v===-1?c:c.substring(0,v)}function C(c,v){const{args:b,stack:w}=r(c),h=typeof b[0]=="string"&&b.length===1;let p=M(w);p&&(p=`(${p.trim()})`);let y=[];if(typeof b[0]=="string"?p&&h?y=[`%c[${v}] %c${b[0]} %c${p}`,g("blue"),g(""),g("grey")]:y=[`%c[${v}] %c${b[0]}`,g("blue"),g(""),...b.slice(1)]:y=[`%c[${v}]%`,g("blue"),...b],p&&!h&&y.push(p),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=C;function g(c){return`color: ${c}`}}),define(ae[76],ce([0,1,17,7]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function r(g){return JSON.stringify(g,M)}e.stringify=r;function O(g){let c=JSON.parse(g);return c=C(c),c}e.parse=O;function M(g,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function C(g,c=0){if(!g||c>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return L.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof I.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let v=0;v<g.length;++v)g[v]=C(g[v],c+1);else for(const v in g)Object.hasOwnProperty.call(g,v)&&(g[v]=C(g[v],c+1))}return g}e.revive=C}),define(ae[13],ce([0,1,15,4,25,7]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var M;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.codeSetting="code-setting",w.codeFeature="code-feature"})(M||(e.Schemas=M={}));function C(w,h){return O.URI.isUri(w)?(0,r.equalsIgnoreCase)(w.scheme,h):(0,r.startsWithIgnoreCase)(w,h+":")}e.matchesScheme=C;function g(w,...h){return h.some(p=>C(w,p))}e.matchesSomeScheme=g,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class c{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${M.vscodeRemoteResource}`}set(h,p,y){this._hosts[h]=p,this._ports[h]=y}setConnectionToken(h,p){this._connectionTokens[h]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(f){return I.onUnexpectedError(f),h}const p=h.authority;let y=this._hosts[p];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const E=this._ports[p],u=this._connectionTokens[p];let d=`path=${encodeURIComponent(h.path)}`;return typeof u=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),O.URI.from({scheme:L.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${y}:${E}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new c,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class v{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(h){const p=this.toUri(h,K);return this.uriToBrowserUri(p)}uriToBrowserUri(h){return h.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(h):h.scheme===M.file&&(L.isNative||L.webWorkerOrigin===`${M.vscodeFileResource}://${v.FALLBACK_AUTHORITY}`)?h.with({scheme:M.vscodeFileResource,authority:h.authority||v.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const p=this.toUri(h,K);return this.uriToFileUri(p)}uriToFileUri(h){return h.scheme===M.vscodeFileResource?h.with({scheme:M.file,authority:h.authority!==v.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,p){return O.URI.isUri(h)?h:O.URI.parse(p.toUrl(h))}}e.FileAccess=new v;var b;(function(w){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(h.get("3"));const p="vscode-coi";function y(u){let d;typeof u=="string"?d=new URL(u).searchParams:u instanceof URL?d=u.searchParams:O.URI.isUri(u)&&(d=new URL(u.toString(!0)).searchParams);const f=d?.get(p);if(f)return h.get(f)}w.getHeadersFromQuery=y;function E(u,d,f){if(!globalThis.crossOriginIsolated)return;const m=d&&f?"3":f?"2":"1";u instanceof URLSearchParams?u.set(p,m):u[p]=m}w.addSearchParam=E})(b||(e.COI=b={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(h){return(0,C.uriToFsPath)(h,!0)}e.originalFSPath=g;class c{constructor(p){this._ignorePathCasing=p}compare(p,y,E=!1){return p===y?0:(0,M.compare)(this.getComparisonKey(p,E),this.getComparisonKey(y,E))}isEqual(p,y,E=!1){return p===y?!0:!p||!y?!1:this.getComparisonKey(p,E)===this.getComparisonKey(y,E)}getComparisonKey(p,y=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,y,E=!1){if(p.scheme===y.scheme){if(p.scheme===L.Schemas.file)return I.isEqualOrParent(g(p),g(y),this._ignorePathCasing(p))&&p.query===y.query&&(E||p.fragment===y.fragment);if((0,e.isEqualAuthority)(p.authority,y.authority))return I.isEqualOrParent(p.path,y.path,this._ignorePathCasing(p),"/")&&p.query===y.query&&(E||p.fragment===y.fragment)}return!1}joinPath(p,...y){return C.URI.joinPath(p,...y)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return r.posix.basename(p.path)}extname(p){return r.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let y;return p.scheme===L.Schemas.file?y=C.URI.file(r.dirname(g(p))).path:(y=r.posix.dirname(p.path),p.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),y="/")),p.with({path:y})}normalizePath(p){if(!p.path.length)return p;let y;return p.scheme===L.Schemas.file?y=C.URI.file(r.normalize(g(p))).path:y=r.posix.normalize(p.path),p.with({path:y})}relativePath(p,y){if(p.scheme!==y.scheme||!(0,e.isEqualAuthority)(p.authority,y.authority))return;if(p.scheme===L.Schemas.file){const d=r.relative(g(p),g(y));return O.isWindows?I.toSlashes(d):d}let E=p.path||"/";const u=y.path||"/";if(this._ignorePathCasing(p)){let d=0;for(const f=Math.min(E.length,u.length);d<f&&!(E.charCodeAt(d)!==u.charCodeAt(d)&&E.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);E=u.substr(0,d)+E.substr(d)}return r.posix.relative(E,u)}resolvePath(p,y){if(p.scheme===L.Schemas.file){const E=C.URI.file(r.resolve(g(p),y));return p.with({authority:E.authority,path:E.path})}return y=I.toPosixPath(y),p.with({path:r.posix.resolve(p.path,y)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,y){return p===y||p!==void 0&&y!==void 0&&(0,M.equalsIgnoreCase)(p,y)}hasTrailingPathSeparator(p,y=r.sep){if(p.scheme===L.Schemas.file){const E=g(p);return E.length>I.getRoot(E).length&&E[E.length-1]===y}else{const E=p.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,y=r.sep){return(0,e.hasTrailingPathSeparator)(p,y)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,y=r.sep){let E=!1;if(p.scheme===L.Schemas.file){const u=g(p);E=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===y}else{y="/";const u=p.path;E=u.length===1&&u.charCodeAt(u.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(p,y)?p.with({path:p.path+"/"}):p}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(h=>h.scheme===L.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new c(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(h,p){const y=[];for(let E=0;E<h.length;E++){const u=p(h[E]);h.some((d,f)=>f===E?!1:(0,e.isEqualOrParent)(u,p(d)))||y.push(h[E])}return y}e.distinctParents=v;var b;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function p(y){const E=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(f=>{const[m,a]=f.split(":");m&&a&&E.set(m,a)});const d=y.path.substring(0,y.path.indexOf(";"));return d&&E.set(h.META_DATA_MIME,d),E}h.parseMetaData=p})(b||(e.DataUri=b={}));function w(h,p,y){if(p){let E=h.path;return E&&E[0]!==r.posix.sep&&(E=r.posix.sep+E),h.with({scheme:y,authority:p,path:E})}return h.with({scheme:y})}e.toLocalResource=w}),define(ae[8],ce([0,1,23,15,3,2,19,4,143,62]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=v;function b(Z){const z=new I.CancellationTokenSource,ee=Z(z.token),ie=new Promise((fe,pe)=>{const Pe=z.token.onCancellationRequested(()=>{Pe.dispose(),pe(new L.CancellationError)});Promise.resolve(ee).then(Ce=>{Pe.dispose(),z.dispose(),fe(Ce)},Ce=>{Pe.dispose(),z.dispose(),pe(Ce)})});return new class{cancel(){z.cancel(),z.dispose()}then(fe,pe){return ie.then(fe,pe)}catch(fe){return this.then(void 0,fe)}finally(fe){return ie.finally(fe)}}}e.createCancelablePromise=b;function w(Z,z,ee){return new Promise((ie,fe)=>{const pe=z.onCancellationRequested(()=>{pe.dispose(),ie(ee)});Z.then(ie,fe).finally(()=>pe.dispose())})}e.raceCancellation=w;function h(Z,z){return new Promise((ee,ie)=>{const fe=z.onCancellationRequested(()=>{fe.dispose(),ie(new L.CancellationError)});Z.then(ee,ie).finally(()=>fe.dispose())})}e.raceCancellationError=h;async function p(Z){let z=-1;const ee=Z.map((ie,fe)=>ie.then(pe=>(z=fe,pe)));try{return await Promise.race(ee)}finally{Z.forEach((ie,fe)=>{fe!==z&&ie.cancel()})}}e.raceCancellablePromises=p;function y(Z,z,ee){let ie;const fe=setTimeout(()=>{ie?.(void 0),ee?.()},z);return Promise.race([Z.finally(()=>clearTimeout(fe)),new Promise(pe=>ie=pe)])}e.raceTimeout=y;function E(Z){return new Promise((z,ee)=>{const ie=Z();v(ie)?ie.then(z,ee):z(ie)})}e.asPromise=E;function u(){let Z,z;return{promise:new Promise((ie,fe)=>{Z=ie,z=fe}),resolve:Z,reject:z}}e.promiseWithResolvers=u;class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const ee=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ie=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ie};this.queuedPromise=new Promise(ie=>{this.activePromise.then(ee,ee).then(ie)})}return new Promise((ee,ie)=>{this.queuedPromise.then(ee,ie)})}return this.activePromise=z(),new Promise((ee,ie)=>{this.activePromise.then(fe=>{this.activePromise=null,ee(fe)},fe=>{this.activePromise=null,ie(fe)})})}dispose(){this.isDisposed=!0}}e.Throttler=d;class f{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=f;class m{constructor(){this.promiseMap=new Map}queue(z,ee){const fe=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(z)===fe&&this.promiseMap.delete(z)});return this.promiseMap.set(z,fe),fe}}e.SequencerByKey=m;const a=(Z,z)=>{let ee=!0;const ie=setTimeout(()=>{ee=!1,z()},Z);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(ie),ee=!1}}},t=Z=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,Z())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class o{constructor(z){this.defaultDelay=z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,ee=this.defaultDelay){this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((fe,pe)=>{this.doResolve=fe,this.doReject=pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const fe=this.task;return this.task=null,fe()}}));const ie=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===g.MicrotaskDelay?t(ie):a(ee,ie),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class s{constructor(z){this.delayer=new o(z),this.throttler=new d}trigger(z,ee){return this.delayer.trigger(()=>this.throttler.queue(z),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class i{constructor(){this._isOpen=!1,this._promise=new Promise((z,ee)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class n extends i{constructor(z){super(),this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=n;function l(Z,z){return z?new Promise((ee,ie)=>{const fe=setTimeout(()=>{pe.dispose(),ee()},Z),pe=z.onCancellationRequested(()=>{clearTimeout(fe),pe.dispose(),ie(new L.CancellationError)})}):b(ee=>l(Z,ee))}e.timeout=l;function S(Z,z=0,ee){const ie=setTimeout(()=>{Z(),ee&&fe.dispose()},z),fe=(0,O.toDisposable)(()=>{clearTimeout(ie),ee?.deleteAndLeak(fe)});return ee?.add(fe),fe}e.disposableTimeout=S;function R(Z){const z=[];let ee=0;const ie=Z.length;function fe(){return ee<ie?Z[ee++]():null}function pe(Pe){Pe!=null&&z.push(Pe);const Ce=fe();return Ce?Ce.then(pe):Promise.resolve(z)}return Promise.resolve(null).then(pe)}e.sequence=R;function k(Z,z=ie=>!!ie,ee=null){let ie=0;const fe=Z.length,pe=()=>{if(ie>=fe)return Promise.resolve(ee);const Pe=Z[ie++];return Promise.resolve(Pe()).then(We=>z(We)?Promise.resolve(We):pe())};return pe()}e.first=k;function P(Z,z=ie=>!!ie,ee=null){if(Z.length===0)return Promise.resolve(ee);let ie=Z.length;const fe=()=>{ie=-1;for(const pe of Z)pe.cancel?.()};return new Promise((pe,Pe)=>{for(const Ce of Z)Ce.then(We=>{--ie>=0&&z(We)?(fe(),pe(We)):ie===0&&pe(ee)}).catch(We=>{--ie>=0&&(fe(),Pe(We))})})}e.firstParallel=P;class D{constructor(z){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}whenIdle(){return this.size>0?r.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(z){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ee,ie)=>{this.outstandingPromises.push({factory:z,c:ee,e:ie}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=D;class _ extends D{constructor(){super(1)}}e.Queue=_;class U{constructor(){this.sequentializer=new N,this.tasks=0}queue(z){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,z())):this.sequentializer.run(this.tasks++,z())}}e.LimitedQueue=U;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const z=new oe;return this.drainers.add(z),z.p}isDrained(){for(const[,z]of this.queues)if(z.size>0)return!1;return!0}queueSize(z,ee=M.extUri){const ie=ee.getComparisonKey(z);return this.queues.get(ie)?.size??0}queueFor(z,ee,ie=M.extUri){const fe=ie.getComparisonKey(z);let pe=this.queues.get(fe);if(!pe){pe=new _;const Pe=this.drainListenerCount++,Ce=r.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(fe),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Pe),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(Pe,Ce),this.queues.set(fe,pe)}return pe.queue(ee)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const z of this.drainers)z.complete();this.drainers.clear()}dispose(){for(const[,z]of this.queues)z.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class H{constructor(z,ee){this._token=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},ee)}setIfNotSet(z,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},ee))}}e.TimeoutTimer=H;class j{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(z,ee,ie=globalThis){this.cancel();const fe=ie.setInterval(()=>{z()},ee);this.disposable=(0,O.toDisposable)(()=>{ie.clearInterval(fe),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=j;class le{constructor(z,ee){this.timeoutToken=-1,this.runner=z,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=le;class se{constructor(z,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=se;class ue extends le{constructor(z,ee){super(z,ee),this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner?.(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ue;class Y extends O.Disposable{constructor(z,ee){super(),this.options=z,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.options.maxBufferedWork)return!1}else if(this.pending+z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ee of z)this.pendingWork.push(ee);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new le(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Z,z)=>{(0,C.setTimeout0)(()=>{if(ee)return;const ie=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e._runWhenIdle=(Z,z,ee)=>{const ie=Z.requestIdleCallback(z,typeof ee=="number"?{timeout:ee}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,Z.cancelIdleCallback(ie))}}},e.runWhenGlobalIdle=Z=>(0,e._runWhenIdle)(globalThis,Z)}();class Q{constructor(z,ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(z,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=Q;class q extends Q{constructor(z){super(globalThis,z)}}e.GlobalIdleValue=q;async function W(Z,z,ee){let ie;for(let fe=0;fe<ee;fe++)try{return await Z()}catch(pe){ie=pe,await l(z)}throw ie}e.retry=W;class N{isRunning(z){return typeof z=="number"?this._running?.taskId===z:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(z,ee,ie){return this._running={taskId:z,cancel:()=>ie?.(),promise:ee},ee.then(()=>this.doneRunning(z),()=>this.doneRunning(z)),ee}doneRunning(z){this._running&&z===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const z=this._queued;this._queued=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this._queued)this._queued.run=z;else{const{promise:ee,resolve:ie,reject:fe}=u();this._queued={run:z,promise:ee,promiseResolve:ie,promiseReject:fe}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=N;class V{constructor(z,ee=()=>Date.now()){this.interval=z,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const z=this.nowFn();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=V;var $;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})($||($={}));class oe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((z,ee)=>{this.completeCallback=z,this.errorCallback=ee})}complete(z){return new Promise(ee=>{this.completeCallback(z),this.outcome={outcome:0,value:z},ee()})}error(z){return new Promise(ee=>{this.errorCallback(z),this.outcome={outcome:1,value:z},ee()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=oe;var de;(function(Z){async function z(ie){let fe;const pe=await Promise.all(ie.map(Pe=>Pe.then(Ce=>Ce,Ce=>{fe||(fe=Ce)})));if(typeof fe<"u")throw fe;return pe}Z.settled=z;function ee(ie){return new Promise(async(fe,pe)=>{try{await ie(fe,pe)}catch(Pe){pe(Pe)}})}Z.withAsyncBody=ee})(de||(e.Promises=de={}));class G{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(z){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=z.then(ee=>(this._value=ee,this._isResolved=!0,ee),ee=>{throw this._error=ee,this._isResolved=!0,ee})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=G;class A{constructor(z){this._compute=z,this._promise=new c.Lazy(()=>new G(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=A;var T;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(T||(T={}));class J{static fromArray(z){return new J(ee=>{ee.emitMany(z)})}static fromPromise(z){return new J(async ee=>{ee.emitMany(await z)})}static fromPromises(z){return new J(async ee=>{await Promise.all(z.map(async ie=>ee.emitOne(await ie)))})}static merge(z){return new J(async ee=>{await Promise.all(z.map(async ie=>{for await(const fe of ie)ee.emitOne(fe)}))})}static{this.EMPTY=J.fromArray([])}constructor(z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const ee={emitOne:ie=>this.emitOne(ie),emitMany:ie=>this.emitMany(ie),reject:ie=>this.reject(ie)};try{await Promise.resolve(z(ee)),this.resolve()}catch(ie){this.reject(ie)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(z<this._results.length)return{done:!1,value:this._results[z++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(z,ee){return new J(async ie=>{for await(const fe of z)ie.emitOne(ee(fe))})}map(z){return J.map(this,z)}static filter(z,ee){return new J(async ie=>{for await(const fe of z)ee(fe)&&ie.emitOne(fe)})}filter(z){return J.filter(this,z)}static coalesce(z){return J.filter(z,ee=>!!ee)}coalesce(){return J.coalesce(this)}static async toPromise(z){const ee=[];for await(const ie of z)ee.push(ie);return ee}toPromise(){return J.toPromise(this)}emitOne(z){this._state===0&&(this._results.push(z),this._onStateChanged.fire())}emitMany(z){this._state===0&&(this._results=this._results.concat(z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(z){this._state===0&&(this._state=2,this._error=z,this._onStateChanged.fire())}}e.AsyncIterableObject=J;class B extends J{constructor(z,ee){super(ee),this._source=z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=B;function X(Z){const z=new I.CancellationTokenSource,ee=Z(z.token);return new B(z,async ie=>{const fe=z.token.onCancellationRequested(()=>{fe.dispose(),z.dispose(),ie.reject(new L.CancellationError)});try{for await(const pe of ee){if(z.token.isCancellationRequested)return;ie.emitOne(pe)}fe.dispose(),z.dispose()}catch(pe){fe.dispose(),z.dispose(),ie.reject(pe)}})}e.createCancelableAsyncIterable=X;class x{constructor(){this._deferred=new oe,this._asyncIterable=new J(ie=>{if(z){ie.reject(z);return}return ee&&ie.emitMany(ee),this._errorFn=fe=>ie.reject(fe),this._emitFn=fe=>ie.emitOne(fe),this._deferred.p});let z,ee;this._emitFn=ie=>{ee||(ee=[]),ee.push(ie)},this._errorFn=ie=>{z||(z=ie)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(z){this._errorFn(z),this._deferred.complete()}emitOne(z){this._emitFn(z)}}e.AsyncIterableSource=x}),define(ae[106],ce([0,1,22,8,33,31,9,4,25]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function c(){return Object.create(null)}e.getEmptyExpression=c,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const v="[/\\\\]",b="[^/\\\\]",w=/\//g;function h(Q,q){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${v}|${b}+${v}${q?`|${v}${b}+`:""})*?`}}function p(Q,q){if(!Q)return[];const W=[];let N=!1,V=!1,$="";for(const oe of Q){switch(oe){case q:if(!N&&!V){W.push($),$="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":V=!0;break;case"]":V=!1;break}$+=oe}return $&&W.push($),W}e.splitGlobAware=p;function y(Q){if(!Q)return"";let q="";const W=p(Q,e.GLOB_SPLIT);if(W.every(N=>N===e.GLOBSTAR))q=".*";else{let N=!1;W.forEach((V,$)=>{if(V===e.GLOBSTAR){if(N)return;q+=h(2,$===W.length-1)}else{let oe=!1,de="",G=!1,A="";for(const T of V){if(T!=="}"&&oe){de+=T;continue}if(G&&(T!=="]"||!A)){let J;T==="-"?J=T:(T==="^"||T==="!")&&!A?J="^":T===e.GLOB_SPLIT?J="":J=(0,g.escapeRegExpCharacters)(T),A+=J;continue}switch(T){case"{":oe=!0;continue;case"[":G=!0;continue;case"}":{const B=`(?:${p(de,",").map(X=>y(X)).join("|")})`;q+=B,oe=!1,de="";break}case"]":{q+="["+A+"]",G=!1,A="";break}case"?":q+=b;continue;case"*":q+=h(1);continue;default:q+=(0,g.escapeRegExpCharacters)(T)}}$<W.length-1&&(W[$+1]!==e.GLOBSTAR||$+2<W.length)&&(q+=v)}N=V===e.GLOBSTAR})}return q}const E=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),o=function(){return!1},s=function(){return null};function i(Q,q){if(!Q)return s;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const N=`${W}_${!!q.trimForExclusions}`;let V=t.get(N);if(V)return n(V,Q);let $;return E.test(W)?V=S(W.substr(4),W):($=u.exec(l(W,q)))?V=R($[1],W):(q.trimForExclusions?f:d).test(W)?V=k(W,q):($=m.exec(l(W,q)))?V=P($[1].substr(1),W,!0):($=a.exec(l(W,q)))?V=P($[1],W,!1):V=D(W),t.set(N,V),n(V,Q)}function n(Q,q){if(typeof q=="string")return Q;const W=function(N,V){return(0,r.isEqualOrParent)(N,q.base,!C.isLinux)?Q((0,g.ltrim)(N.substr(q.base.length),M.sep),V):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function l(Q,q){return q.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function S(Q,q){return function(W,N){return typeof W=="string"&&W.endsWith(Q)?q:null}}function R(Q,q){const W=`/${Q}`,N=`\\${Q}`,V=function(oe,de){return typeof oe!="string"?null:de?de===Q?q:null:oe===Q||oe.endsWith(W)||oe.endsWith(N)?q:null},$=[Q];return V.basenames=$,V.patterns=[q],V.allBasenames=$,V}function k(Q,q){const W=ue(Q.slice(1,-1).split(",").map(de=>i(de,q)).filter(de=>de!==s),Q),N=W.length;if(!N)return s;if(N===1)return W[0];const V=function(de,G){for(let A=0,T=W.length;A<T;A++)if(W[A](de,G))return Q;return null},$=W.find(de=>!!de.allBasenames);$&&(V.allBasenames=$.allBasenames);const oe=W.reduce((de,G)=>G.allPaths?de.concat(G.allPaths):de,[]);return oe.length&&(V.allPaths=oe),V}function P(Q,q,W){const N=M.sep===M.posix.sep,V=N?Q:Q.replace(w,M.sep),$=M.sep+V,oe=M.posix.sep+Q;let de;return W?de=function(G,A){return typeof G=="string"&&(G===V||G.endsWith($)||!N&&(G===Q||G.endsWith(oe)))?q:null}:de=function(G,A){return typeof G=="string"&&(G===V||!N&&G===Q)?q:null},de.allPaths=[(W?"*/":"./")+Q],de}function D(Q){try{const q=new RegExp(`^${y(Q)}$`);return function(W){return q.lastIndex=0,typeof W=="string"&&q.test(W)?Q:null}}catch{return s}}function _(Q,q,W){return!Q||typeof q!="string"?!1:U(Q)(q,void 0,W)}e.match=_;function U(Q,q={}){if(!Q)return o;if(typeof Q=="string"||F(Q)){const W=i(Q,q);if(W===s)return o;const N=function(V,$){return!!W(V,$)};return W.allBasenames&&(N.allBasenames=W.allBasenames),W.allPaths&&(N.allPaths=W.allPaths),N}return le(Q,q)}e.parse=U;function F(Q){const q=Q;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=F;function H(Q){return Q.allBasenames||[]}e.getBasenameTerms=H;function j(Q){return Q.allPaths||[]}e.getPathTerms=j;function le(Q,q){const W=ue(Object.getOwnPropertyNames(Q).map(de=>se(de,Q[de],q)).filter(de=>de!==s)),N=W.length;if(!N)return s;if(!W.some(de=>!!de.requiresSiblings)){if(N===1)return W[0];const de=function(T,J){let B;for(let X=0,x=W.length;X<x;X++){const Z=W[X](T,J);if(typeof Z=="string")return Z;(0,L.isThenable)(Z)&&(B||(B=[]),B.push(Z))}return B?(async()=>{for(const X of B){const x=await X;if(typeof x=="string")return x}return null})():null},G=W.find(T=>!!T.allBasenames);G&&(de.allBasenames=G.allBasenames);const A=W.reduce((T,J)=>J.allPaths?T.concat(J.allPaths):T,[]);return A.length&&(de.allPaths=A),de}const V=function(de,G,A){let T,J;for(let B=0,X=W.length;B<X;B++){const x=W[B];x.requiresSiblings&&A&&(G||(G=(0,M.basename)(de)),T||(T=G.substr(0,G.length-(0,M.extname)(de).length)));const Z=x(de,G,T,A);if(typeof Z=="string")return Z;(0,L.isThenable)(Z)&&(J||(J=[]),J.push(Z))}return J?(async()=>{for(const B of J){const X=await B;if(typeof X=="string")return X}return null})():null},$=W.find(de=>!!de.allBasenames);$&&(V.allBasenames=$.allBasenames);const oe=W.reduce((de,G)=>G.allPaths?de.concat(G.allPaths):de,[]);return oe.length&&(V.allPaths=oe),V}function se(Q,q,W){if(q===!1)return s;const N=i(Q,W);if(N===s)return s;if(typeof q=="boolean")return N;if(q){const V=q.when;if(typeof V=="string"){const $=(oe,de,G,A)=>{if(!A||!N(oe,de))return null;const T=V.replace("$(basename)",()=>G),J=A(T);return(0,L.isThenable)(J)?J.then(B=>B?Q:null):J?Q:null};return $.requiresSiblings=!0,$}}return N}function ue(Q,q){const W=Q.filter(de=>!!de.basenames);if(W.length<2)return Q;const N=W.reduce((de,G)=>{const A=G.basenames;return A?de.concat(A):de},[]);let V;if(q){V=[];for(let de=0,G=N.length;de<G;de++)V.push(q)}else V=W.reduce((de,G)=>{const A=G.patterns;return A?de.concat(A):de},[]);const $=function(de,G){if(typeof de!="string")return null;if(!G){let T;for(T=de.length;T>0;T--){const J=de.charCodeAt(T-1);if(J===47||J===92)break}G=de.substr(T)}const A=N.indexOf(G);return A!==-1?V[A]:null};$.basenames=N,$.patterns=V,$.allBasenames=N;const oe=Q.filter(de=>!de.basenames);return oe.push($),oe}function Y(Q,q){return(0,I.equals)(Q,q,(W,N)=>typeof W=="string"&&typeof N=="string"?W===N:typeof W!="string"&&typeof N!="string"?W.base===N.base&&W.pattern===N.pattern:!1)}e.patternsEquals=Y}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(i,n){const{os:l,tildify:S,relative:R}=n;if(R){const D=c(i,R,l);if(typeof D=="string")return D}let k=i.fsPath;if(l===1&&!O.isWindows?k=k.replace(/\//g,"\\"):l!==1&&O.isWindows&&(k=k.replace(/\\/g,"/")),l!==1&&S?.userHome){const D=S.userHome.fsPath;let _;i.scheme!==S.userHome.scheme&&i.path[0]===r.posix.sep&&i.path[1]!==r.posix.sep?_=S.userHome.with({path:i.path}).fsPath:_=k,k=w(_,D,l)}return(l===1?r.win32:r.posix).normalize(v(k,l===1))}e.getPathLabel=g;function c(i,n,l){const S=l===1?r.win32:r.posix,R=l===3?M.extUri:M.extUriIgnorePathCase,k=n.getWorkspace(),P=(0,I.firstOrDefault)(k.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path[0]===r.posix.sep&&i.path[1]!==r.posix.sep&&(i=P.uri.with({path:i.path}));const D=n.getWorkspaceFolder(i);if(!D)return;let _;if(R.isEqual(D.uri,i)?_="":_=R.relativePath(D.uri,i)??"",_&&(_=S.normalize(_)),k.folders.length>1&&!n.noPrefix){const U=D.name?D.name:R.basenameOrAuthority(D.uri);_=_?`${U} \u2022 ${_}`:U}return _}function v(i,n=O.isWindows){return(0,L.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=v;let b=Object.create(null);function w(i,n,l=O.OS){if(l===1||!i||!n)return i;let S=b.original===n?b.normalized:void 0;S||(S=n,O.isWindows&&(S=(0,L.toSlashes)(S)),S=`${(0,C.rtrim)(S,r.posix.sep)}${r.posix.sep}`,b={original:n,normalized:S});let R=i;return O.isWindows&&(R=(0,L.toSlashes)(R)),(l===3?R.startsWith(S):(0,C.startsWithIgnoreCase)(R,S))?`~/${R.substr(S.length)}`:i}e.tildify=w;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=h;const p="\u2026",y="\\\\",E="~";function u(i,n=r.sep){const l=new Array(i.length);let S=!1;for(let R=0;R<i.length;R++){const k=i[R];if(k===""){l[R]=`.${n}`;continue}if(!k){l[R]=k;continue}S=!0;let P="",D=k;D.indexOf(y)===0?(P=D.substr(0,D.indexOf(y)+y.length),D=D.substr(D.indexOf(y)+y.length)):D.indexOf(n)===0?(P=D.substr(0,D.indexOf(n)+n.length),D=D.substr(D.indexOf(n)+n.length)):D.indexOf(E)===0&&(P=D.substr(0,D.indexOf(E)+E.length),D=D.substr(D.indexOf(E)+E.length));const _=D.split(n);for(let U=1;S&&U<=_.length;U++)for(let F=_.length-U;S&&F>=0;F--){S=!1;let H=_.slice(F,F+U).join(n);for(let j=0;!S&&j<i.length;j++)if(j!==R&&i[j]&&i[j].indexOf(H)>-1){const le=F+U===_.length,se=F>0&&i[j].indexOf(n)>-1?n+H:H,ue=i[j].endsWith(se);S=!le||ue}if(!S){let j="";(_[0].endsWith(":")||P!=="")&&(F===1&&(F=0,U++,H=_[0]+n+H),F>0&&(j=_[0]+n),j=P+j),F>0&&(j=j+p+n),j=j+H,F+U<_.length&&(j=j+n+p),l[R]=j}}S&&(l[R]=k)}return l}e.shorten=u;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function f(i,n=Object.create(null)){const l=[];let S=!1,R="";for(const k of i)if(k==="$"||S&&k==="{")R&&l.push({value:R,type:d.TEXT}),R="",S=!0;else if(k==="}"&&S){const P=n[R];if(typeof P=="string")P.length&&l.push({value:P,type:d.VARIABLE});else if(P){const D=l[l.length-1];(!D||D.type!==d.SEPARATOR)&&l.push({value:P.label,type:d.SEPARATOR})}R="",S=!1}else R+=k;return R&&!S&&l.push({value:R,type:d.TEXT}),l.filter((k,P)=>{if(k.type===d.SEPARATOR){const D=l[P-1],_=l[P+1];return[D,_].every(U=>U&&(U.type===d.VARIABLE||U.type===d.TEXT)&&U.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=f;function m(i,n){return O.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function a(i,n){return O.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):O.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const l=s(i.substring(0,n)),S=i.substring(n);return{name:l.name+S,parentPath:l.parentPath}}}return s(i)}e.splitRecentLabel=o;function s(i){const n=i.indexOf("/")!==-1?r.posix:r.win32,l=n.basename(i),S=n.dirname(i);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(ae[155],ce([0,1,17,7]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(b){return b.toJSON()}class O{constructor(w){this._uriTransformer=w}transformIncoming(w){const h=this._uriTransformer.transformIncoming(w);return h===w?w:r(L.URI.from(h))}transformOutgoing(w){const h=this._uriTransformer.transformOutgoing(w);return h===w?w:r(L.URI.from(h))}transformOutgoingURI(w){const h=this._uriTransformer.transformOutgoing(w);return h===w?w:L.URI.from(h)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function M(b,w,h){if(!b||h>200)return null;if(typeof b=="object"){if(b instanceof L.URI)return w.transformOutgoing(b);for(const p in b)if(Object.hasOwnProperty.call(b,p)){const y=M(b[p],w,h+1);y!==null&&(b[p]=y)}}return null}function C(b,w){const h=M(b,w,0);return h===null?b:h}e.transformOutgoingURIs=C;function g(b,w,h,p){if(!b||p>200)return null;if(typeof b=="object"){if(b.$mid===1)return h?L.URI.revive(w.transformIncoming(b)):w.transformIncoming(b);if(b instanceof I.VSBuffer)return null;for(const y in b)if(Object.hasOwnProperty.call(b,y)){const E=g(b[y],w,h,p+1);E!==null&&(b[y]=E)}}return null}function c(b,w){const h=g(b,w,!1,0);return h===null?b:h}e.transformIncomingURIs=c;function v(b,w){const h=g(b,w,!0,0);return h===null?b:h}e.transformAndReviveIncomingURIs=v}),define(ae[89],ce([0,1,26,59,32,145,4]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(w){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(w)}value(){if(this._value===void 0){let w=0,h=0;const p=(0,I.networkInterfaces)();for(const y in p){const E=p[y];if(E)for(const{mac:u,internal:d}of E)d||(h+=1,this._isVirtualMachineMacAddress(u.toUpperCase())&&(w+=1))}this._value=h>0?w/h:0}return this._value}};let C;async function g(w){return C||(C=(async()=>await c(w)||r.generateUuid())()),C}e.getMachineId=g;async function c(w){try{const h=await new Promise((y,E)=>{K(["crypto"],y,E)}),p=(0,O.getMac)();return h.createHash("sha256").update(p,"utf8").digest("hex")}catch(h){w(h);return}}const v="Software\\Microsoft\\SQMClient";async function b(w){if(M.isWindows){const h=await new Promise((p,y)=>{K(["@vscode/windows-registry"],p,y)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",v,"MachineId")||""}catch(p){return w(p),""}}return""}e.getSqmMachineId=b}),define(ae[21],ce([0,1,46,26,156,8,33,86,9,4,19,7]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(se,ue=w.UNLINK,Y){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===w.UNLINK?y(se):p(se,Y)}async function p(se,ue=(0,M.randomPath)((0,L.tmpdir)())){try{try{await I.promises.rename(se,ue)}catch(Y){return Y.code==="ENOENT"?void 0:y(se)}y(ue).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function y(se){return(0,r.promisify)(I.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function E(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function u(se,ue){return m(await(ue?d(se):(0,r.promisify)(I.readdir)(se)))}async function d(se){try{return await(0,r.promisify)(I.readdir)(se,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const ue=[],Y=await u(se);for(const Q of Y){let q=!1,W=!1,N=!1;try{const V=await e.Promises.lstat((0,g.join)(se,Q));q=V.isFile(),W=V.isDirectory(),N=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ue.push({name:Q,isFile:()=>q,isDirectory:()=>W,isSymbolicLink:()=>N})}return ue}function f(se){return m(I.readdirSync(se))}e.readdirSync=f;function m(se){return se.map(ue=>typeof ue=="string"?c.isMacintosh?(0,C.normalizeNFC)(ue):ue:(ue.name=c.isMacintosh?(0,C.normalizeNFC)(ue.name):ue.name,ue))}async function a(se){const ue=await u(se),Y=[];for(const Q of ue)await o.existsDirectory((0,g.join)(se,Q))&&Y.push(Q);return Y}function t(se,ue=1e3){return new Promise(Y=>{let Q=!1;const q=setInterval(()=>{Q||(Q=!0,I.access(se,W=>{Q=!1,W&&(clearInterval(q),Y(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(se){async function ue(q){let W;try{if(W=await e.Promises.lstat(q),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(c.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw V}throw N}}se.stat=ue;async function Y(q){try{const{stat:W,symbolicLink:N}=await se.stat(q);return W.isFile()&&N?.dangling!==!0}catch{}return!1}se.existsFile=Y;async function Q(q){try{const{stat:W,symbolicLink:N}=await se.stat(q);return W.isDirectory()&&N?.dangling!==!0}catch{}return!1}se.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const s=new O.ResourceQueue;function i(se,ue,Y){return s.queueFor(b.URI.file(se),()=>{const Q=k(Y);return new Promise((q,W)=>S(se,ue,Q,N=>N?W(N):q()))},v.extUriBiasedIgnorePathCase)}let n=!0;function l(se){n=se}e.configureFlushOnWrite=l;function S(se,ue,Y,Q){if(!n)return I.writeFile(se,ue,{mode:Y.mode,flag:Y.flag},Q);I.open(se,Y.flag,Y.mode,(q,W)=>{if(q)return Q(q);I.writeFile(W,ue,N=>{if(N)return I.close(W,()=>Q(N));I.fdatasync(W,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),l(!1)),I.close(W,$=>Q($))))})})}function R(se,ue,Y){const Q=k(Y);if(!n)return I.writeFileSync(se,ue,{mode:Q.mode,flag:Q.flag});const q=I.openSync(se,Q.flag,Q.mode);try{I.writeFileSync(q,ue);try{I.fdatasyncSync(q)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),l(!1)}}finally{I.closeSync(q)}}e.writeFileSync=R;function k(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function P(se,ue,Y=6e4){if(se!==ue)try{c.isWindows&&typeof Y=="number"?await D(se,ue,Date.now(),Y):await(0,r.promisify)(I.rename)(se,ue)}catch(Q){if(se.toLowerCase()!==ue.toLowerCase()&&Q.code==="EXDEV"||se.endsWith("."))await _(se,ue,{preserveSymlinks:!1}),await h(se,w.MOVE);else throw Q}}async function D(se,ue,Y,Q,q=0){try{return await(0,r.promisify)(I.rename)(se,ue)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-Y>=Q)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${W}`),W;if(q===0){let N=!1;try{const{stat:V}=await o.stat(ue);V.isFile()||(N=!0)}catch{}if(N)throw W}return await(0,O.timeout)(Math.min(100,q*10)),D(se,ue,Y,Q,q+1)}}async function _(se,ue,Y){return F(se,ue,{root:{source:se,target:ue},options:Y,handledSourcePaths:new Set})}const U=511;async function F(se,ue,Y){if(Y.handledSourcePaths.has(se))return;Y.handledSourcePaths.add(se);const{stat:Q,symbolicLink:q}=await o.stat(se);if(q){if(Y.options.preserveSymlinks)try{return await le(se,ue,Y)}catch{}if(q.dangling)return}return Q.isDirectory()?H(se,ue,Q.mode&U,Y):j(se,ue,Q.mode&U)}async function H(se,ue,Y,Q){await e.Promises.mkdir(ue,{recursive:!0,mode:Y});const q=await u(se);for(const W of q)await F((0,g.join)(se,W),(0,g.join)(ue,W),Q)}async function j(se,ue,Y){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,Y)}async function le(se,ue,Y){let Q=await e.Promises.readlink(se);(0,M.isEqualOrParent)(Q,Y.root.source,!c.isLinux)&&(Q=(0,g.join)(Y.root.target,Q.substr(Y.root.source.length+1))),await e.Promises.symlink(Q,ue)}e.Promises=new class{get access(){return(0,r.promisify)(I.access)}get stat(){return(0,r.promisify)(I.stat)}get lstat(){return(0,r.promisify)(I.lstat)}get utimes(){return(0,r.promisify)(I.utimes)}get read(){return(se,ue,Y,Q,q)=>new Promise((W,N)=>{I.read(se,ue,Y,Q,q,(V,$,oe)=>V?N(V):W({bytesRead:$,buffer:oe}))})}get readFile(){return(0,r.promisify)(I.readFile)}get write(){return(se,ue,Y,Q,q)=>new Promise((W,N)=>{I.write(se,ue,Y,Q,q,(V,$,oe)=>V?N(V):W({bytesWritten:$,buffer:oe}))})}get appendFile(){return(0,r.promisify)(I.appendFile)}get fdatasync(){return(0,r.promisify)(I.fdatasync)}get truncate(){return(0,r.promisify)(I.truncate)}get copyFile(){return(0,r.promisify)(I.copyFile)}get open(){return(0,r.promisify)(I.open)}get close(){return(0,r.promisify)(I.close)}get symlink(){return(0,r.promisify)(I.symlink)}get readlink(){return(0,r.promisify)(I.readlink)}get chmod(){return(0,r.promisify)(I.chmod)}get mkdir(){return(0,r.promisify)(I.mkdir)}get unlink(){return(0,r.promisify)(I.unlink)}get rmdir(){return(0,r.promisify)(I.rmdir)}get realpath(){return(0,r.promisify)(I.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return h}get rename(){return P}get copy(){return _}}}),define(ae[107],ce([0,1,46,9,4,25,21]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(w){if(r.isLinux)return w;const h=(0,L.dirname)(w);if(w===h)return w;const p=((0,L.basename)(w)||w).toLowerCase();try{const E=(0,M.readdirSync)(h).filter(u=>u.toLowerCase()===p);if(E.length===1){const u=C(h);if(u)return(0,L.join)(u,E[0])}else if(E.length>1){const u=E.indexOf(p);if(u>=0){const d=C(h);if(d)return(0,L.join)(d,E[u])}}}catch{}return null}e.realcaseSync=C;async function g(w){if(r.isLinux)return w;const h=(0,L.dirname)(w);if(w===h)return w;const p=((0,L.basename)(w)||w).toLowerCase();try{const E=(await M.Promises.readdir(h)).filter(u=>u.toLowerCase()===p);if(E.length===1){const u=await g(h);if(u)return(0,L.join)(u,E[0])}else if(E.length>1){const u=E.indexOf(p);if(u>=0){const d=await g(h);if(d)return(0,L.join)(d,E[u])}}}catch{}return null}e.realcase=g;async function c(w){try{return await M.Promises.realpath(w)}catch{const p=b(w);return await M.Promises.access(p,I.constants.R_OK),p}}e.realpath=c;function v(w){try{return I.realpathSync(w)}catch{const p=b(w);return I.accessSync(p,I.constants.R_OK),p}}e.realpathSync=v;function b(w){return(0,O.rtrim)((0,L.normalize)(w),L.sep)}}),define(ae[108],ce([0,1,26,9,21]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,M=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var g;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class b{constructor(a,t,o){this.exePath=a,this.displayName=t,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:m=!1}={}){return m?c===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:m=!1,findPreview:a=!1}={}){const t=w({useAlternateBitness:m});if(!t)return null;const o=L.join(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(o))return null;let s=-1,i=null;for(const S of await r.Promises.readdir(o)){let R=-1;if(a){const P=S.indexOf("-");if(P<0)continue;const D=S.substring(0,P);if(!O.test(D)||S.substring(P+1)!=="preview")continue;R=parseInt(D,10)}else{if(!O.test(S))continue;R=parseInt(S,10)}if(R<=s)continue;const k=L.join(o,S,"pwsh.exe");await r.SymlinkSupport.existsFile(k)&&(i=k,s=R)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new b(i,`PowerShell${l}${n}`,!0)}async function p({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=m?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(a))if(t.test(s)){const i=L.join(a,s,"pwsh.exe");return new b(i,o)}return null}function y(){const m=L.join(I.homedir(),".dotnet","tools","pwsh.exe");return new b(m,".NET Core PowerShell Global Tool")}function E(){const m=L.join(process.env.windir,c===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(m,"Windows PowerShell",!0)}async function*u(){let m=await h();m&&(yield m),m=await h({useAlternateBitness:!0}),m&&(yield m),m=await p(),m&&(yield m),m=y(),m&&(yield m),m=await h({findPreview:!0}),m&&(yield m),m=await p({findPreview:!0}),m&&(yield m),m=await h({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=E(),m&&(yield m)}async function*d(){for await(const m of u())await m.exists()&&(yield m)}e.enumeratePowerShellInstallations=d;async function f(){for await(const m of d())return m;return null}e.getFirstAvailablePowerShellInstallation=f}),define(ae[90],ce([0,1,9,4,36,75,12,21]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function g(b=r.env){return b.comspec||"cmd.exe"}e.getWindowsShell=g;function c(b){let w=[],h=!1;const p=function(y){if(h){w.push(y);return}(!b.send(y,u=>{if(u&&console.error(u),h=!1,w.length>0){const d=w.slice(0);w=[],d.forEach(f=>p(f))}})||L.isWindows)&&(h=!0)};return{send:p}}e.createQueuedSender=c;var v;(function(b){async function w(h,p,y){if(I.isAbsolute(h))return h;if(p===void 0&&(p=r.cwd()),I.dirname(h)!=="."||(y===void 0&&M.isString(r.env.PATH)&&(y=r.env.PATH.split(I.delimiter)),y===void 0||y.length===0))return I.join(p,h);async function u(d){if(await C.Promises.exists(d)){let f;try{f=await C.Promises.stat(d)}catch(m){m.message.startsWith("EACCES")&&(f=await C.Promises.lstat(d))}return f?!f.isDirectory():!1}return!1}for(const d of y){let f;if(I.isAbsolute(d)?f=I.join(d,h):f=I.join(p,d,h),await u(f))return f;let m=f+".com";if(await u(m)||(m=f+".exe",await u(m)))return m}return I.join(p,h)}b.findExecutable=w})(v||(e.win32=v={}))}),define(ae[109],ce([0,1,48,13]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(M){return new Promise((C,g)=>{let c;const v=new Map;function b(h,p,y,E,u){const d=v.get(p);if(h===M||d){const f={name:w(y),cmd:y,pid:h,ppid:p,load:E,mem:u};v.set(h,f),h===M&&(c=f),d&&(d.children||(d.children=[]),d.children.push(f),d.children.length>1&&(d.children=d.children.sort((m,a)=>m.pid-a.pid)))}}function w(h){const p=/--utility-sub-type=network/i,y=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(y.exec(h))return"electron-crash-reporter";if(E.exec(h))return"winpty-agent";if(u.exec(h))return"conpty-agent";let f=d.exec(h);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?p.exec(h)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const m=/[a-zA-Z-]+\.js/g;let a="";do f=m.exec(h),f&&(a+=f+" ");while(f);return a&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${a})`:h}if(process.platform==="win32"){const h=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substring(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substring(5):p;new Promise((p,y)=>{K(["@vscode/windows-process-tree"],p,y)}).then(p=>{p.getProcessList(M,y=>{if(!y){g(new Error(`Root process ${M} not found`));return}p.getProcessCpuUsage(y,E=>{const u=new Map;E.forEach(d=>{const f=h(d.commandLine||"");u.set(d.pid,{name:w(f),cmd:f,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),c=u.get(M),c?(u.forEach(d=>{const f=u.get(d.ppid);f&&(f.children||(f.children=[]),f.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((f,m)=>f.pid-m.pid))}),C(c)):g(new Error(`Root process ${M} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let h=function(){let p=[c];const y=[];for(;p.length;){const u=p.shift();u&&(y.push(u.pid),u.children&&(p=p.concat(u.children)))}let E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+y.join(" "),(0,I.exec)(E,{},(u,d,f)=>{if(u||f)g(u||new Error(f.toString()));else{const m=d.toString().split(`
`);for(let a=0;a<y.length;a++){const t=v.get(y[a]);t.load=parseFloat(m[a])}if(!c){g(new Error(`Root process ${M} not found`));return}C(c)}})};(0,I.exec)("which ps",{},(p,y,E)=>{if(p||E)if(process.platform!=="linux")g(p||new Error(E.toString()));else{const u=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(d,f,m)=>{d||m?g(d||new Error(m.toString())):(O(f,b),h())})}else{const u=y.toString().trim();(0,I.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,m,a)=>{f||a&&!a.includes("screen size is bogus")?g(f||new Error(a.toString())):(O(m,b),process.platform==="linux"?h():c?C(c):g(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=r;function O(M,C){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=M.toString().split(`
`);for(const v of c){const b=g.exec(v.trim());b&&b.length===6&&C(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ae[110],ce([0,1,26,4,108,90]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(b,w){return b===1?L.isWindows?v():O.getWindowsShell(w):g(b,w)}e.getSystemShell=M;let C=null;function g(b,w){if(L.isLinux&&b===2||L.isMacintosh&&b===3)return"/bin/bash";if(!C){let h;if(L.isWindows)h="/bin/bash";else{if(h=w.SHELL,!h)try{h=(0,I.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}C=h}return C}let c=null;async function v(){return c||(c=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),c}});var be=this&&this.__decorate||function(K,e,I,L){var r=arguments.length,O=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(K,e,I,L);else for(var C=K.length-1;C>=0;C--)(M=K[C])&&(O=(r<3?M(O):r>3?M(e,I,O):M(e,I))||O);return r>3&&O&&Object.defineProperty(e,I,O),O};define(ae[43],ce([0,1,22,8,17,23,50,15,3,2,76,25,12]),function(K,e,I,L,r,O,M,C,g,c,v,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(h||(h={}));function p(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y||(y={}));function E(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(u||(u={}));function d(q){let W=0;for(let N=0;;N+=7){const V=q.read(1);if(W|=(V.buffer[0]&127)<<N,!(V.buffer[0]&128))return W}}const f=s(0);function m(q,W){if(W===0){q.write(f);return}let N=0;for(let $=W;$!==0;$=$>>>7)N++;const V=r.VSBuffer.alloc(N);for(let $=0;W!==0;$++)V.buffer[$]=W&127,W=W>>>7,W>0&&(V.buffer[$]|=128);q.write(V)}class a{constructor(W){this.buffer=W,this.pos=0}read(W){const N=this.buffer.slice(this.pos,this.pos+W);return this.pos+=N.byteLength,N}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=t;var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(o||(o={}));function s(q){const W=r.VSBuffer.alloc(1);return W.writeUInt8(q,0),W}const i={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},n=typeof Buffer<"u";function l(q,W){if(typeof W>"u")q.write(i.Undefined);else if(typeof W=="string"){const N=r.VSBuffer.fromString(W);q.write(i.String),m(q,N.byteLength),q.write(N)}else if(n&&Buffer.isBuffer(W)){const N=r.VSBuffer.wrap(W);q.write(i.Buffer),m(q,N.byteLength),q.write(N)}else if(W instanceof r.VSBuffer)q.write(i.VSBuffer),m(q,W.byteLength),q.write(W);else if(Array.isArray(W)){q.write(i.Array),m(q,W.length);for(const N of W)l(q,N)}else if(typeof W=="number"&&(W|0)===W)q.write(i.Uint),m(q,W);else{const N=r.VSBuffer.fromString(JSON.stringify(W));q.write(i.Object),m(q,N.byteLength),q.write(N)}}e.serialize=l;function S(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(d(q)).toString();case o.Buffer:return q.read(d(q)).buffer;case o.VSBuffer:return q.read(d(q));case o.Array:{const N=d(q),V=[];for(let $=0;$<N;$++)V.push(S(q));return V}case o.Object:return JSON.parse(q.read(d(q)).toString());case o.Int:return d(q)}}e.deserialize=S;class R{constructor(W,N,V=null,$=1e3){this.protocol=W,this.ctx=N,this.logger=V,this.timeoutDelay=$,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(oe=>this.onRawMessage(oe)),this.sendResponse({type:200})}registerChannel(W,N){this.channels.set(W,N),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const N=this.send([W.type]);this.logger?.logOutgoing(N,0,1,E(W.type));return}case 201:case 202:case 204:case 203:{const N=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(N,W.id,1,E(W.type),W.data);return}}}send(W,N=void 0){const V=new t;return l(V,W),l(V,N),this.sendBuffer(V.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const N=new a(W),V=S(N),$=S(N),oe=V[0];switch(oe){case 100:return this.logger?.logIncoming(W.byteLength,V[1],1,`${p(oe)}: ${V[2]}.${V[3]}`,$),this.onPromise({type:oe,id:V[1],channelName:V[2],name:V[3],arg:$});case 102:return this.logger?.logIncoming(W.byteLength,V[1],1,`${p(oe)}: ${V[2]}.${V[3]}`,$),this.onEventListen({type:oe,id:V[1],channelName:V[2],name:V[3],arg:$});case 101:return this.logger?.logIncoming(W.byteLength,V[1],1,`${p(oe)}`),this.disposeActiveRequest({type:oe,id:V[1]});case 103:return this.logger?.logIncoming(W.byteLength,V[1],1,`${p(oe)}`),this.disposeActiveRequest({type:oe,id:V[1]})}}onPromise(W){const N=this.channels.get(W.channelName);if(!N){this.collectPendingRequest(W);return}const V=new O.CancellationTokenSource;let $;try{$=N.call(this.ctx,W.name,W.arg,V.token)}catch(G){$=Promise.reject(G)}const oe=W.id;$.then(G=>{this.sendResponse({id:oe,data:G,type:201})},G=>{G instanceof Error?this.sendResponse({id:oe,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:oe,data:G,type:203})}).finally(()=>{de.dispose(),this.activeRequests.delete(W.id)});const de=(0,c.toDisposable)(()=>V.cancel());this.activeRequests.set(W.id,de)}onEventListen(W){const N=this.channels.get(W.channelName);if(!N){this.collectPendingRequest(W);return}const V=W.id,oe=N.listen(this.ctx,W.name,W.arg)(de=>this.sendResponse({id:V,data:de,type:204}));this.activeRequests.set(W.id,oe)}disposeActiveRequest(W){const N=this.activeRequests.get(W.id);N&&(N.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let N=this.pendingRequests.get(W.channelName);N||(N=[],this.pendingRequests.set(W.channelName,N));const V=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:W,timeoutTimer:V})}flushPendingRequests(W){const N=this.pendingRequests.get(W);if(N){for(const V of N)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=R;var k;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class P{constructor(W,N=null){this.protocol=W,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=N}getChannel(W){const N=this;return{call(V,$,oe){return N.isDisposed?Promise.reject(new C.CancellationError):N.requestPromise(W,V,$,oe)},listen(V,$){return N.isDisposed?g.Event.None:N.requestEvent(W,V,$)}}}requestPromise(W,N,V,$=O.CancellationToken.None){const oe=this.lastRequestId++,G={id:oe,type:100,channelName:W,name:N,arg:V};if($.isCancellationRequested)return Promise.reject(new C.CancellationError);let A;return new Promise((J,B)=>{if($.isCancellationRequested)return B(new C.CancellationError);const X=()=>{const ee=ie=>{switch(ie.type){case 201:this.handlers.delete(oe),J(ie.data);break;case 202:{this.handlers.delete(oe);const fe=new Error(ie.data.message);fe.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,fe.name=ie.data.name,B(fe);break}case 203:this.handlers.delete(oe),B(ie.data);break}};this.handlers.set(oe,ee),this.sendRequest(G)};let x=null;this.state===u.Idle?X():(x=(0,L.createCancelablePromise)(ee=>this.whenInitialized()),x.then(()=>{x=null,X()}));const Z=()=>{x?(x.cancel(),x=null):this.sendRequest({id:oe,type:101}),B(new C.CancellationError)},z=$.onCancellationRequested(Z);A=(0,c.combinedDisposable)((0,c.toDisposable)(Z),z),this.activeRequests.add(A)}).finally(()=>{A.dispose(),this.activeRequests.delete(A)})}requestEvent(W,N,V){const $=this.lastRequestId++,de={id:$,type:102,channelName:W,name:N,arg:V};let G=null;const A=new g.Emitter({onWillAddFirstListener:()=>{G=(0,L.createCancelablePromise)(J=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(A),this.sendRequest(de)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(A),this.sendRequest({id:$,type:103}))}}),T=J=>A.fire(J.data);return this.handlers.set($,T),A.event}sendRequest(W){switch(W.type){case 100:case 102:{const N=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(N,W.id,0,`${p(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const N=this.send([W.type,W.id]);this.logger?.logOutgoing(N,W.id,0,p(W.type));return}}}send(W,N=void 0){const V=new t;return l(V,W),l(V,N),this.sendBuffer(V.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const N=new a(W),V=S(N),$=S(N),oe=V[0];switch(oe){case 200:return this.logger?.logIncoming(W.byteLength,0,0,E(oe)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,V[1],0,E(oe),$),this.onResponse({type:V[0],id:V[1],data:$})}}onResponse(W){if(W.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=P,be([M.memoize],P.prototype,"onDidInitializePromise",null);class D{get connections(){const W=[];return this._connections.forEach(N=>W.push(N)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new c.DisposableStore,this.disposables.add(W(({protocol:N,onDidClientDisconnect:V})=>{const $=g.Event.once(N.onMessage);this.disposables.add($(oe=>{const de=new a(oe),G=S(de),A=new R(N,G),T=new P(N);this.channels.forEach((B,X)=>A.registerChannel(X,B));const J={channelServer:A,channelClient:T,ctx:G};this._connections.add(J),this._onDidAddConnection.fire(J),this.disposables.add(V(()=>{A.dispose(),T.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)}))}))}))}getChannel(W,N){const V=this;return{call($,oe,de){let G;if((0,w.isFunction)(N)){const T=(0,I.getRandomElement)(V.connections.filter(N));G=T?Promise.resolve(T):g.Event.toPromise(g.Event.filter(V.onDidAddConnection,N))}else G=N.routeCall(V,$,oe);const A=G.then(T=>T.channelClient.getChannel(W));return U(A).call($,oe,de)},listen($,oe){if((0,w.isFunction)(N))return V.getMulticastEvent(W,N,$,oe);const de=N.routeEvent(V,$,oe).then(G=>G.channelClient.getChannel(W));return U(de).listen($,oe)}}}getMulticastEvent(W,N,V,$){const oe=this;let de;const G=new g.Emitter({onWillAddFirstListener:()=>{de=new c.DisposableStore;const A=new g.EventMultiplexer,T=new Map,J=X=>{const Z=X.channelClient.getChannel(W).listen(V,$),z=A.add(Z);T.set(X,z)},B=X=>{const x=T.get(X);x&&(x.dispose(),T.delete(X))};oe.connections.filter(N).forEach(J),g.Event.filter(oe.onDidAddConnection,N)(J,void 0,de),oe.onDidRemoveConnection(B,void 0,de),A.event(G.fire,G,de),de.add(A)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return G.event}registerChannel(W,N){this.channels.set(W,N);for(const V of this._connections)V.channelServer.registerChannel(W,N)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class _{constructor(W,N,V=null){const $=new t;l($,N),W.send($.buffer),this.channelClient=new P(W,V),this.channelServer=new R(W,N,V)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,N){this.channelServer.registerChannel(W,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function U(q){return{call(W,N,V){return q.then($=>$.call(W,N,V))},listen(W,N){const V=new g.Relay;return q.then($=>V.input=$.listen(W,N)),V.event}}}e.getDelayedChannel=U;function F(q){let W=!1;return{call(N,V,$){return W?q.call(N,V,$):(0,L.timeout)(0).then(()=>W=!0).then(()=>q.call(N,V,$))},listen(N,V){if(W)return q.listen(N,V);const $=new g.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>$.input=q.listen(N,V)),$.event}}}e.getNextTickChannel=F;class H{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const N of W.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await g.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=H;var j;(function(q){function W(oe,de,G){const A=oe,T=G&&G.disableMarshalling,J=new Map;for(const B in A)V(B)&&J.set(B,g.Event.buffer(A[B],!0,void 0,de));return new class{listen(B,X,x){const Z=J.get(X);if(Z)return Z;if($(X)){const z=A[X];if(typeof z=="function")return z.call(A,x)}throw new C.ErrorNoTelemetry(`Event not found: ${X}`)}call(B,X,x){const Z=A[X];if(typeof Z=="function"){if(!T&&Array.isArray(x))for(let ee=0;ee<x.length;ee++)x[ee]=(0,v.revive)(x[ee]);let z=Z.apply(A,x);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new C.ErrorNoTelemetry(`Method not found: ${X}`)}}}q.fromService=W;function N(oe,de){const G=de&&de.disableMarshalling;return new Proxy({},{get(A,T){if(typeof T=="string")return de?.properties?.has(T)?de.properties.get(T):$(T)?function(J){return oe.listen(T,J)}:V(T)?oe.listen(T):async function(...J){let B;de&&!(0,w.isUndefinedOrNull)(de.context)?B=[de.context,...J]:B=J;const X=await oe.call(T,B);return G?X:(0,v.revive)(X)};throw new C.ErrorNoTelemetry(`Property not found: ${String(T)}`)}})}q.toService=N;function V(oe){return oe[0]==="o"&&oe[1]==="n"&&b.isUpperAsciiLetter(oe.charCodeAt(2))}function $(oe){return/^onDynamic/.test(oe)&&b.isUpperAsciiLetter(oe.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const W=q.toString();if(W!=="[object Object]")return W}return q}function ue(q){return Array.isArray(q)?q.map(se):se(q)}function Y(q,W,N,V,$,oe,de){de=ue(de);const G=le[$],A=G[V%G.length];let T=[`%c[${q}]%c[${String(W).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(oe)?(T=T.concat(de),T.push(")")):T.push(de),console.log.apply(console,T)}class Q{constructor(W,N){this._outgoingPrefix=W,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,N,V,$,oe){this._totalOutgoing+=W,Y(this._outgoingPrefix,this._totalOutgoing,W,N,V,$,oe)}logIncoming(W,N,V,$,oe){this._totalIncoming+=W,Y(this._incomingPrefix,this._totalIncoming,W,N,V,$,oe)}}e.IPCLogger=Q}),define(ae[157],ce([0,1,17,3,43]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(g){this.port=g,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",c=>c.data?I.VSBuffer.wrap(c.data):I.VSBuffer.alloc(0)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=O;class M extends r.IPCClient{constructor(g,c){const v=new O(g);super(v,c),this.protocol=v}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=M}),define(ae[111],ce([0,1,17,3,2,43]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let l=0;function S(k,P){if(!n.has(k)){const D=String(++l);n.set(k,D)}return n.get(k)}function R(k,P,D,_){if(!i.enableDiagnostics)return;const U=S(k,P);if(_ instanceof I.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const F=I.VSBuffer.alloc(_.byteLength);F.set(_),i.records.push({timestamp:Date.now(),id:U,label:P,type:D,buff:F})}else i.records.push({timestamp:Date.now(),id:U,label:P,type:D,data:_})}i.traceSocketEvent=R})(C||(e.SocketDiagnostics=C={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g||(e.SocketCloseEventType=g={}));let c=null;function v(){return c||(c=I.VSBuffer.alloc(0)),c}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,l){if(n===0)return v();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const P=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=n),P}if(this._chunks[0].byteLength>n){const P=this._chunks[0].slice(0,n);return l&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),P}const S=I.VSBuffer.alloc(n);let R=0,k=0;for(;n>0;){const P=this._chunks[k];if(P.byteLength>n){const D=P.slice(0,n);S.set(D,R),R+=n,l&&(this._chunks[k]=P.slice(n),this._totalLength-=n),n-=n}else S.set(P,R),R+=P.byteLength,l?(this._chunks.shift(),this._totalLength-=P.byteLength):k++,n-=P.byteLength}return S}}e.ChunkStream=b;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class y{constructor(n,l,S,R){this.type=n,this.id=l,this.ack=S,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends r.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const S=this._state.messageType,R=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new y(S,R,k,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=I.VSBuffer.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(l,n.data)}_bufferAdd(n,l){const S=this._totalLength===0;return this._data.push(n,l),this._totalLength+=n.byteLength+l.byteLength,S}_bufferTake(){const n=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,l){this._bufferAdd(n,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class d extends r.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new y(1,0,0,n))}}e.Protocol=d;class f extends O.IPCClient{static fromSocket(n,l){return new f(new d(n),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,l,S=null){super(n,l,S),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=f;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class a{constructor(n){this.data=n,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let n=0,l=this._first;for(;l;)l=l.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let l=0,S=this._first;for(;S;)n[l++]=S.data,S=S.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const l=new a(n);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=n-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let S=0;for(let R=0;R<o._HISTORY_LENGTH;R++)n-this.lastRuns[R]<=l&&S++;return 1-S/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new r.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.add(this._socket.onClose(l=>this._onSocketClose.fire(l))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new y(5,0,0,v());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new y(7,0,0,v());this._socketWriter.write(n)}sendResume(){const n=new y(8,0,0,v());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,l){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new r.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.add(this._socket.onClose(S=>this._onSocketClose.fire(S))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new y(3,0,this._incomingAckId,v());this._socketWriter.write(n);const l=this._outgoingUnackMsg.toArray();for(let S=0,R=l.length;S<R;S++)this._socketWriter.write(l[S]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new y(6,0,0,v())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let S=0,R=l.length;S<R;S++)this._socketWriter.write(l[S]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const S=new y(1,l,this._incomingAckId,n);this._outgoingUnackMsg.push(S),this._isReconnecting||(this._socketWriter.write(S),this._recvAckCheck())}sendControl(n){const l=new y(2,0,0,n);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),l=Date.now()-n.writtenTime,S=Date.now()-this._socketReader.lastReadTime,R=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&S>=2e4&&R>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const k=Math.max(2e4-l,2e4-S,2e4-R,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new y(3,0,this._incomingAckId,v());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new y(9,0,this._incomingAckId,v());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(ae[37],ce([0,1,14,15,13]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class O{constructor(){this.mapListenerToWrapper=new WeakMap}on(C,g){const c=(v,...b)=>{this.validateEvent(C,v)&&g(v,...b)};return this.mapListenerToWrapper.set(g,c),I.ipcMain.on(C,c),this}once(C,g){return I.ipcMain.once(C,(c,...v)=>{this.validateEvent(C,c)&&g(c,...v)}),this}handle(C,g){return I.ipcMain.handle(C,(c,...v)=>this.validateEvent(C,c)?g(c,...v):Promise.reject(`Invalid channel '${C}' or sender for ipcMain.handle() usage.`)),this}removeHandler(C){return I.ipcMain.removeHandler(C),this}removeListener(C,g){const c=this.mapListenerToWrapper.get(g);return c&&(I.ipcMain.removeListener(C,c),this.mapListenerToWrapper.delete(g)),this}validateEvent(C,g){if(!C||!C.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because the channel is unknown.`),!1;const c=g.senderFrame,v=c.url;if(!v||v==="about:blank")return!0;let b="unknown";try{b=new URL(v).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a malformed URL '${v}'.`),!1}return b!==r.VSCODE_AUTHORITY?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a bad origin of '${b}'.`),!1):c.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new O}),define(ae[158],ce([0,1,14,37,146]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function O(){L.validatedIpcMain.on(r.CONTEXT_MENU_CHANNEL,(C,g,c,v,b)=>{const w=M(C,v,c);w.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{w&&C.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=O;function M(C,g,c){const v=new I.Menu;return c.forEach(b=>{let w;b.type==="separator"?w=new I.MenuItem({type:b.type}):Array.isArray(b.submenu)?w=new I.MenuItem({submenu:M(C,g,b.submenu),label:b.label}):w=new I.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(h,p,y)=>C.sender.send(g,b.id,y)}),v.append(w)}),v}}),define(ae[159],ce([0,1,37,17,3,2,43,147]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(v,b){const w=r.Event.fromNodeEventEmitter(I.validatedIpcMain,b,(p,y)=>({event:p,message:y})),h=r.Event.filter(w,({event:p})=>p.sender.id===v);return r.Event.map(h,({message:p})=>p&&L.VSBuffer.wrap(p))}class c extends M.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const b=r.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:w})=>w);return r.Event.map(b,w=>{const h=w.id;c.Clients.get(h)?.dispose();const y=new r.Emitter;c.Clients.set(h,(0,O.toDisposable)(()=>y.fire()));const E=g(h,"vscode:message"),u=r.Event.any(r.Event.signal(g(h,"vscode:disconnect")),y.event);return{protocol:new C.Protocol(w,E),onDidClientDisconnect:u}})}constructor(){super(c.getOnDidClientConnect())}}e.Server=c}),define(ae[112],ce([0,1,37,3,32,157]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends O.Client{constructor(c,v){super({addEventListener:(b,w)=>c.addListener(b,w),removeEventListener:(b,w)=>c.removeListener(b,w),postMessage:b=>c.postMessage(b),start:()=>c.start(),close:()=>c.close()},v)}}e.Client=M;async function C(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,r.generateUuid)();g.webContents.send("vscode:createMessageChannel",c);const v=L.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(w,h)=>({nonce:h,port:w.ports[0]})),{port:b}=await L.Event.toPromise(L.Event.once(L.Event.filter(v,w=>w.nonce===c)));return b}e.connect=C}),define(ae[160],ce([0,1,48,8,17,23,154,15,3,2,35,90,75,43]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends h.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",d=>r.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=p;class y{constructor(u,d){this.modulePath=u,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new L.Delayer(f),this.child=null,this._client=null}getChannel(u){const d=this;return{call(f,m,a){return d.requestPromise(u,f,m,a)},listen(f,m){return d.requestEvent(u,f,m)}}}requestPromise(u,d,f,m=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(u),t=(0,L.createCancelablePromise)(i=>a.call(d,f,i)),o=m.onCancellationRequested(()=>t.cancel()),s=(0,c.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(u,d,f){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let m;const a=new g.Emitter({onWillAddFirstListener:()=>{m=this.getCachedChannel(u).listen(d,f)(a.fire,a),this.activeRequests.add(m)},onDidRemoveLastListener:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,w.removeDangerousEnvVariables)(d.env),this.child=(0,I.fork)(this.modulePath,u,d);const f=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,M.isRemoteConsoleLog)(n)){(0,M.log)(n,`IPC Library: ${this.options.serverName}`);return}f.fire(r.VSBuffer.wrap(Buffer.from(n,"base64")))});const a=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,t=n=>this.child&&this.child.connected&&a.send(n.buffer.toString("base64")),o=f.event,s={send:t,onMessage:o};this._client=new h.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,l)=>{process.removeListener("exit",i),this.activeRequests.forEach(S=>(0,c.dispose)(S)),this.activeRequests.clear(),n!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:l})})}return this._client}getCachedChannel(u){let d=this.channels.get(u);return d||(d=this.client.getChannel(u),this.channels.set(u,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(ae[113],ce([0,1,8,3,2,76,12]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function g(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=g;var c;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(c||(e.StorageState=c={}));class v extends r.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,p=Object.create(null)){super(),this.database=h,this.options=p,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((p,y)=>this.acceptExternal(y,p)),h.deleted?.forEach(p=>this.acceptExternal(p,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,p){if(this.state===c.Closed)return;let y=!1;(0,M.isUndefinedOrNull)(p)?y=this.cache.delete(h):this.cache.get(h)!==p&&(this.cache.set(h,p),y=!0),y&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,p){const y=this.cache.get(h);return(0,M.isUndefinedOrNull)(y)?p:y}getBoolean(h,p){const y=this.get(h);return(0,M.isUndefinedOrNull)(y)?p:y==="true"}getNumber(h,p){const y=this.get(h);return(0,M.isUndefinedOrNull)(y)?p:parseInt(y,10)}getObject(h,p){const y=this.get(h);return(0,M.isUndefinedOrNull)(y)?p:(0,O.parse)(y)}async set(h,p,y=!1){if(this.state===c.Closed)return;if((0,M.isUndefinedOrNull)(p))return this.delete(h,y);const E=(0,M.isObject)(p)||Array.isArray(p)?(0,O.stringify)(p):String(p);if(this.cache.get(h)!==E)return this.cache.set(h,E),this.pendingInserts.set(h,E),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:y}),this.doFlush()}async delete(h,p=!1){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:p}),this.doFlush()}async optimize(){if(this.state!==c.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.options.hint===C.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===C.STORAGE_IN_MEMORY}}e.Storage=v;class b{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((p,y)=>this.items.set(y,p)),h.delete?.forEach(p=>this.items.delete(p))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(ae[161],ce([0,1,8,3,31,9,21]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class C{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(v,b=Object.create(null)){this.path=v,this.options=b,this.name=(0,O.basename)(this.path),this.logger=new g(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const v=await this.whenConnected,b=new Map;return(await this.all(v,"SELECT * FROM ItemTable")).forEach(h=>b.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(v){const b=await this.whenConnected;return this.doUpdateItems(b,v)}doUpdateItems(v,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,r.mapToString)(b.insert):"0"}), delete(${b.delete?(0,r.setToString)(b.delete):"0"})`),this.transaction(v,()=>{const w=b.insert,h=b.delete;if(w&&w.size>0){const p=[];p.push([]);let y=0;w.forEach((E,u)=>{let d=p[y];d.length>C.MAX_HOST_PARAMETERS&&(y++,d=[],p.push(d)),d.push(u,E)}),p.forEach(E=>{this.prepare(v,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,u=>u.run(E),()=>{const u=[];let d=0;return w.forEach((f,m)=>{u.push(m),d+=f.length}),`Keys: ${u.join(", ")} Length: ${d}`})})}if(h&&h.size){const p=[];p.push([]);let y=0;h.forEach(E=>{let u=p[y];u.length>C.MAX_HOST_PARAMETERS&&(y++,u=[],p.push(u)),u.push(E)}),p.forEach(E=>{this.prepare(v,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,u=>u.run(E),()=>{const u=[];return h.forEach(d=>{u.push(d)}),`Keys: ${u.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const v=await this.whenConnected;return this.exec(v,"VACUUM")}async close(v){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,v)}doClose(v,b){return new Promise((w,h)=>{v.db.close(p=>(p&&this.handleSQLiteError(v,`[storage ${this.name}] close(): ${p}`),this.path===C.IN_MEMORY_PATH?w():!v.isErroneous&&!v.isInMemory?this.backup().then(w,y=>(this.logger.error(`[storage ${this.name}] backup(): ${y}`),w())):typeof b=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(y=>{const E=()=>this.doClose(y,void 0);return this.doUpdateItems(y,{insert:b()}).then(()=>E(),u=>(E(),Promise.reject(u)))})).then(w,h):h(p||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const v=this.toBackupPath(this.path);return M.Promises.copy(this.path,v,{preserveSymlinks:!1})}toBackupPath(v){return`${v}.backup`}async checkIntegrity(v){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${v})`);const b=await this.whenConnected,w=await this.get(b,v?"PRAGMA integrity_check":"PRAGMA quick_check"),h=v?w.integrity_check:w.quick_check;return b.isErroneous?`${h} (last error: ${b.lastError})`:b.isInMemory?`${h} (in-memory!)`:h}async connect(v,b=!0){this.logger.trace(`[storage ${this.name}] open(${v}, retryOnBusy: ${b})`);try{return await this.doConnect(v)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&b)return await(0,I.timeout)(C.BUSY_OPEN_TIMEOUT),this.connect(v,!1);try{await M.Promises.unlink(v);try{await M.Promises.rename(this.toBackupPath(v),v,!1)}catch{}return await this.doConnect(v)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(C.IN_MEMORY_PATH)}}}handleSQLiteError(v,b){v.isErroneous=!0,v.lastError=b,this.logger.error(b)}doConnect(v){return new Promise((b,w)=>{new Promise((h,p)=>{K(["@vscode/sqlite3"],h,p)}).then(h=>{const p={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(v,y=>y?p.db&&y.code!=="SQLITE_CANTOPEN"?p.db.close(()=>w(y)):w(y):this.exec(p,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(p),E=>p.db.close(()=>w(E)))),isInMemory:v===C.IN_MEMORY_PATH};p.db.on("error",y=>this.handleSQLiteError(p,`[storage ${this.name}] Error (event): ${y}`)),this.logger.isTracing&&p.db.on("trace",y=>this.logger.trace(`[storage ${this.name}] Trace (event): ${y}`))},w)})}exec(v,b){return new Promise((w,h)=>{v.db.exec(b,p=>p?(this.handleSQLiteError(v,`[storage ${this.name}] exec(): ${p}`),h(p)):w())})}get(v,b){return new Promise((w,h)=>{v.db.get(b,(p,y)=>p?(this.handleSQLiteError(v,`[storage ${this.name}] get(): ${p}`),h(p)):w(y))})}all(v,b){return new Promise((w,h)=>{v.db.all(b,(p,y)=>p?(this.handleSQLiteError(v,`[storage ${this.name}] all(): ${p}`),h(p)):w(y))})}transaction(v,b){return new Promise((w,h)=>{v.db.serialize(()=>{v.db.run("BEGIN TRANSACTION"),b(),v.db.run("END TRANSACTION",p=>p?(this.handleSQLiteError(v,`[storage ${this.name}] transaction(): ${p}`),h(p)):w())})})}prepare(v,b,w,h){const p=v.db.prepare(b),y=E=>{this.handleSQLiteError(v,`[storage ${this.name}] prepare(): ${E} (${b}). Details: ${h()}`)};p.on("error",y),w(p),p.finalize(E=>{E&&y(E),p.removeListener("error",y)})}}e.SQLiteStorageDatabase=C;class g{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(v){v&&typeof v.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.logTrace=v.logTrace),v&&typeof v.logError=="function"&&(this.logError=v.logError)}get isTracing(){return!!this.logTrace}trace(v){this.logTrace?.(v)}error(v){this.logError?.(v)}}}),define(ae[162],ce([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(ae[163],ce([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[164],ce([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[165],ce([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(ae[166],ce([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[167],ce([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[168],ce([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(ae[169],ce([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(ae[170],ce([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[171],ce([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[172],ce([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[173],ce([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[174],ce([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[175],ce([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ae[176],ce([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ae[177],ce([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ae[178],ce([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[179],ce([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[180],ce([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[181],ce([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[182],ce([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[183],ce([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ae[184],ce([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(ae[185],ce([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[186],ce([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[187],ce([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[188],ce([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[189],ce([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[190],ce([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[191],ce([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[192],ce([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(ae[193],ce([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[194],ce([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[195],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(ae[196],ce([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(M){let C=[];try{Array.isArray(M.workspaces)&&(C=M.workspaces.map(g=>({workspace:{id:g.id,configPath:I.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return C}e.deserializeWorkspaceInfos=r;function O(M){let C=[];try{Array.isArray(M.folders)&&(C=M.folders.map(g=>({folderUri:I.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return C}e.deserializeFolderInfos=O}),define(ae[197],ce([0,1,15,165]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(r||(e.TokenType=r={}));function O(...c){switch(c.length){case 1:return(0,L.localize)(0,null,c[0]);case 2:return(0,L.localize)(1,null,c[0],c[1]);case 3:return(0,L.localize)(2,null,c[0],c[1],c[2]);default:return}}const M=(0,L.localize)(3,null),C=(0,L.localize)(4,null);class g{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(v){return this._input=v,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(v){return this._isAtEnd()||this._input.charCodeAt(this._current)!==v?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(v){this._tokens.push({type:v,offset:this._start})}_error(v){const b=this._start,w=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:w};this._errors.push({offset:b,lexeme:w,additionalInfo:v}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const v=this.stringRe.exec(this._input);if(v){this._current=this._start+v[0].length;const b=this._input.substring(this._start,this._current),w=g._keywords.get(b);w?this._addToken(w):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let v=this._current,b=!1,w=!1;for(;;){if(v>=this._input.length){this._current=v,this._error(C);return}const p=this._input.charCodeAt(v);if(b)b=!1;else if(p===47&&!w){v++;break}else p===91?w=!0:p===92?b=!0:p===93&&(w=!1);v++}for(;v<this._input.length&&g._regexFlags.has(this._input.charCodeAt(v));)v++;this._current=v;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=g}),define(ae[198],ce([0,1,3,2]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(C,g,c){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(C,g,c){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r;class O extends L.Disposable{constructor(C){super(),this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,g,c){this.channel.call("attach",[C,g,c])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,g){this.channel.call("terminate",[C,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,g){return this.channel.call("openExtensionDevelopmentHostWindow",[C,g])}}e.ExtensionHostDebugChannelClient=O}),define(ae[199],ce([0,1,149,50,13,9,36,19,7]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,O.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",h)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(g.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=M.env.VSCODE_PORTABLE;return h?g.URI.file((0,O.join)(h,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,O.resolve)(h):(0,O.normalize)((0,O.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?g.URI.file((0,O.resolve)(h)):g.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,O.resolve)(h);const p=M.env.VSCODE_EXTENSIONS;if(p)return p;const y=M.env.VSCODE_PORTABLE;return y?(0,O.join)(y,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,O.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?g.URI.parse(h):g.URI.file((0,O.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const p of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=M.env.VSCODE_PORTABLE;return h?g.URI.file((0,O.join)(h,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,p,y){this._args=h,this.paths=p,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,be([L.memoize],c.prototype,"appRoot",null),be([L.memoize],c.prototype,"userHome",null),be([L.memoize],c.prototype,"userDataPath",null),be([L.memoize],c.prototype,"appSettingsHome",null),be([L.memoize],c.prototype,"tmpDir",null),be([L.memoize],c.prototype,"cacheHome",null),be([L.memoize],c.prototype,"stateResource",null),be([L.memoize],c.prototype,"userRoamingDataHome",null),be([L.memoize],c.prototype,"userDataSyncHome",null),be([L.memoize],c.prototype,"sync",null),be([L.memoize],c.prototype,"machineSettingsResource",null),be([L.memoize],c.prototype,"workspaceStorageHome",null),be([L.memoize],c.prototype,"localHistoryHome",null),be([L.memoize],c.prototype,"keyboardLayoutResource",null),be([L.memoize],c.prototype,"argvResource",null),be([L.memoize],c.prototype,"isExtensionDevelopment",null),be([L.memoize],c.prototype,"untitledWorkspacesHome",null),be([L.memoize],c.prototype,"builtinExtensionsPath",null),be([L.memoize],c.prototype,"extensionsPath",null),be([L.memoize],c.prototype,"extensionDevelopmentLocationURI",null),be([L.memoize],c.prototype,"extensionDevelopmentKind",null),be([L.memoize],c.prototype,"extensionTestsLocationURI",null),be([L.memoize],c.prototype,"debugExtensionHost",null),be([L.memoize],c.prototype,"logLevel",null),be([L.memoize],c.prototype,"extensionLogLevel",null),be([L.memoize],c.prototype,"serviceMachineIdResource",null),be([L.memoize],c.prototype,"disableTelemetry",null),be([L.memoize],c.prototype,"disableWorkspaceTrust",null),be([L.memoize],c.prototype,"useInMemorySecretStorage",null),be([L.memoize],c.prototype,"policyFile",null);function v(w,h){return b(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}e.parseExtensionHostDebugPort=v;function b(w,h,p,y,E,u){const f=Number(h||w)||(y?null:p),m=f?!!h:!1;let a;if(u)try{a=JSON.parse(u)}catch{}return{port:f,break:m,debugId:E,env:a}}e.parseDebugParams=b}),define(ae[114],ce([0,1,309,4,168]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const O={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(y,E,u=M){const d=y.find(l=>l.length>0&&l[0]!=="-"),f={},m=["_"],a=[],t={};let o;for(const l in E){const S=E[l];S.type==="subcommand"?l===d&&(o=S):(S.alias&&(f[l]=S.alias),S.type==="string"||S.type==="string[]"?(m.push(l),S.deprecates&&m.push(...S.deprecates)):S.type==="boolean"&&(a.push(l),S.deprecates&&a.push(...S.deprecates)),S.global&&(t[l]=S))}if(o&&d){const l=t;for(const P in o.options)l[P]=o.options[P];const S=y.filter(P=>P!==d),R=u.getSubcommandReporter?u.getSubcommandReporter(d):void 0,k=C(S,l,R);return{[d]:k,_:[]}}const s=I(y,{string:m,boolean:a,alias:f}),i={},n=s;i._=s._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in E){const S=E[l];if(S.type==="subcommand")continue;S.alias&&delete n[S.alias];let R=n[l];if(S.deprecates)for(const k of S.deprecates)n.hasOwnProperty(k)&&(R||(R=n[k],R&&u.onDeprecatedOption(k,S.deprecationMessage||(0,r.localize)(38,null,l))),delete n[k]);if(typeof R<"u"){if(S.type==="string[]"){if(Array.isArray(R)||(R=[R]),!S.allowEmptyValue){const k=R.filter(P=>P.length>0);k.length!==R.length&&(u.onEmptyValue(l),R=k.length>0?k:void 0)}}else S.type==="string"&&(Array.isArray(R)?(R=R.pop(),u.onMultipleValues(l,R)):!R&&!S.allowEmptyValue&&(u.onEmptyValue(l),R=void 0));i[l]=R,S.deprecationMessage&&u.onDeprecatedOption(l,S.deprecationMessage)}delete n[l]}for(const l in n)u.onUnknownOption(l);return i}e.parseArgs=C;function g(y,E){let u="";return E.args&&(Array.isArray(E.args)?u=` <${E.args.join("> <")}>`:u=` <${E.args}>`),E.alias?`-${E.alias} --${y}${u}`:`--${y}${u}`}function c(y,E){const u=[];for(const d in y){const f=y[d],m=g(d,f);u.push([m,f.description])}return v(u,E)}e.formatOptions=c;function v(y,E){const d=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(E-d<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=E-d-1,m=[];for(const a of y){const t=a[0],o=w(a[1],f),s=b(d-t.length-2);m.push("  "+t+s+o[0]);for(let i=1;i<o.length;i++)m.push(b(d)+o[i])}return m}function b(y){return" ".repeat(y)}function w(y,E){const u=[];for(;y.length;){const d=y.length<E?y.length:y.lastIndexOf(" ",E),f=y.slice(0,d).trim();y=y.slice(d),u.push(f)}return u}function h(y,E,u,d,f){const m=process.stdout.isTTY&&process.stdout.columns||80,a=f?.noInputFiles!==!0?`[${(0,r.localize)(39,null)}...]`:"",t=[`${y} ${u}`];t.push(""),t.push(`${(0,r.localize)(40,null)}: ${E} [${(0,r.localize)(41,null)}]${a}`),t.push(""),f?.noPipe!==!0&&(L.isWindows?t.push((0,r.localize)(42,null,E)):t.push((0,r.localize)(43,null,E)),t.push(""));const o={},s=[];for(const i in d){const n=d[i];if(n.type==="subcommand")n.description&&s.push({command:i,description:n.description});else if(n.description&&n.cat){let l=o[n.cat];l||(o[n.cat]=l={}),l[i]=n}}for(const i in o){const n=i,l=o[n];l&&(t.push(O[n]),t.push(...c(l,m)),t.push(""))}return s.length&&(t.push((0,r.localize)(44,null)),t.push(...v(s.map(i=>[i.command,i.description]),m)),t.push("")),t.join(`
`)}e.buildHelpMessage=h;function p(y,E){return`${y||(0,r.localize)(45,null)}
${E||(0,r.localize)(46,null)}
${process.arch}`}e.buildVersionMessage=p}),define(ae[200],ce([0,1,88,198,114]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class O extends L.ExtensionHostDebugBroadcastChannel{constructor(C){super(),this.windowsMainService=C}call(C,g,c){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(c[0],c[1]):super.call(C,g,c)}async openExtensionDevelopmentHostWindow(C,g){const c=(0,r.parseArgs)(C,r.OPTIONS);c.debugRenderer=g;const v=c.extensionDevelopmentPath;if(!v)return{success:!1};const[b]=await this.windowsMainService.openExtensionDevelopmentHostWindow(v,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!g)return{success:!0};const w=b.win;if(!w)return{success:!0};const h=w.webContents.debugger;let p=h.isAttached()?1/0:0;const y=(0,I.createServer)(E=>{p++===0&&h.attach();let u=!1;const d=a=>{u||E.write(JSON.stringify(a)+"\0")},f=(a,t,o,s)=>d({method:t,params:o,sessionId:s});w.on("close",()=>{h.removeListener("message",f),E.end(),u=!0}),h.addListener("message",f);let m=Buffer.alloc(0);E.on("data",a=>{m=Buffer.concat([m,a]);for(let t=m.indexOf(0);t!==-1;t=m.indexOf(0)){let o;try{const s=m.slice(0,t).toString("utf8");m=m.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(o.method,o.params,o.sessionId).then(s=>d({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>d({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),E.on("error",a=>{console.error("error on cdp pipe:",a)}),E.on("close",()=>{u=!0,--p===0&&h.detach()})});return await new Promise(E=>y.listen(0,E)),w.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=O}),define(ae[64],ce([0,1,310,169,114]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function O(b,w){const h=(f,m)=>{console.warn((0,L.localize)(0,null,f,m))},p=f=>{console.warn((0,L.localize)(1,null,f))},y=(f,m)=>{console.warn((0,L.localize)(2,null,f,m))},E=f=>({onUnknownOption:m=>{r.NATIVE_CLI_COMMANDS.includes(f)||console.warn((0,L.localize)(3,null,m,f))},onMultipleValues:h,onEmptyValue:p,onDeprecatedOption:y,getSubcommandReporter:r.NATIVE_CLI_COMMANDS.includes(f)?E:void 0}),u={onUnknownOption:f=>{console.warn((0,L.localize)(4,null,f))},onMultipleValues:h,onEmptyValue:p,onDeprecatedOption:y,getSubcommandReporter:E},d=(0,r.parseArgs)(b,r.OPTIONS,w?u:void 0);return d.goto&&d._.forEach(f=>I(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(f),(0,L.localize)(5,null))),d}function M(b){const w=b.findIndex(h=>!/^-/.test(h));if(w>-1)return[...b.slice(0,w),...b.slice(w+1)]}function C(b){let[,...w]=b;process.env.VSCODE_DEV&&(w=M(w)||[]);const h=!v(process.env);return O(w,h)}e.parseMainProcessArgv=C;function g(b){let[,,...w]=b;return process.env.VSCODE_DEV&&(w=M(w)||[]),O(w,!0)}e.parseCLIProcessArgv=g;function c(b,...w){const h=b.indexOf("--");return h===-1?b.push(...w):b.splice(h,0,...w),b}e.addArg=c;function v(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function K(e,I,L){function r(M,C){const g=O(M,C),c=[g];return e.isAbsolute(g)||c.unshift(L),e.resolve(...c)}function O(M,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,C);const v=M["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(b,"AppData","Roaming")}break;case"darwin":c=e.join(I.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,C)}return{getUserDataPath:r}}if(typeof define=="function")define(ae[201],ce([115,26,36]),function(e,I,L){return K(e,I,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=K(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[91],ce([0,1,26,199,201]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends L.AbstractNativeEnvironmentService{constructor(c,v){super(c,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,r.getUserDataPath)(c,v.nameShort)},v)}}e.NativeEnvironmentService=O;function M(g,c){return(0,L.parseDebugParams)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,c,g.extensionEnvironment)}e.parsePtyHostDebugPort=M;function C(g,c){return(0,L.parseDebugParams)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,c,g.extensionEnvironment)}e.parseSharedProcessDebugPort=C}),define(ae[202],ce([0,1,46,26,33]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function O(M){const C=(0,r.randomPath)((0,L.tmpdir)());try{return(0,I.writeFileSync)(C,""),M&&console.log(`Marker file for --wait created: ${C}`),C}catch(g){M&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=O}),define(ae[203],ce([0,1,12,171]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(M,C,g,c){try{O(M,C,g,c)}catch(v){M.error(v?.message??v)}return C}e.localizeManifest=r;function O(M,C,g,c){const v=(b,w,h)=>{const p=b[w];if((0,I.isString)(p)){const y=p,E=y.length;if(E>1&&y[0]==="%"&&y[E-1]==="%"){const u=y.substr(1,E-2);let d=g[u];d===void 0&&c&&(d=c[u]);const f=typeof d=="string"?d:d?.message,m=c?.[u],a=typeof m=="string"?m:m?.message;if(!f){a||M.warn(`[${C.name}]: ${(0,L.localize)(0,null,u)}`);return}if(h&&(w==="title"||w==="category")&&a&&a!==f){const t={value:f,original:a};b[w]=t}else b[w]=f}}else if((0,I.isObject)(p))for(const y in p)p.hasOwnProperty(y)&&(y==="commands"?v(p,y,!0):v(p,y,h));else if(Array.isArray(p))for(let y=0;y<p.length;y++)v(p,y,h)};for(const b in C)C.hasOwnProperty(b)&&v(C,b)}}),define(ae[204],ce([0,1,19,73,173,205]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function g(u){return u=u.trim(),u==="*"||M.test(u)}e.isValidVersionStr=g;function c(u){if(!g(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(M);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=c;function v(u){if(!u)return null;const d=u.majorBase,f=u.majorMustEqual,m=u.minorBase;let a=u.minorMustEqual;const t=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(d===0||(a=!1),o=!1);let s=0;if(u.preRelease){const i=C.exec(u.preRelease);if(i){const[,n,l,S]=i;s=Date.UTC(Number(n),Number(l)-1,Number(S))}}return{majorBase:d,majorMustEqual:f,minorBase:m,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:s}}e.normalizeVersion=v;function b(u,d,f){let m;typeof u=="string"?m=v(c(u)):m=u;let a;d instanceof Date?a=d.getTime():typeof d=="string"&&(a=new Date(d).getTime());let t;if(typeof f=="string"?t=v(c(f)):t=f,!m||!t)return!1;const o=m.majorBase,s=m.minorBase,i=m.patchBase;let n=t.majorBase,l=t.minorBase,S=t.patchBase;const R=t.notBefore;let k=t.majorMustEqual,P=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:s>l?!0:s<l||a&&a<R?!1:i>=S:(o===1&&n===0&&(!k||!P||!D)&&(n=1,l=0,S=0,k=!0,P=!1,D=!1),o<n?!1:o>n?!k:s<l?!1:s>l?!P:i<S?!1:i>S?!D:!(a&&a<R))}e.isValidVersion=b;function w(u,d,f,m,a){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([L.default.Error,r.localize(0,null)]),t;if(typeof m.name!="string")return t.push([L.default.Error,r.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([L.default.Error,r.localize(2,null,"version")]),t;if(!m.engines)return t.push([L.default.Error,r.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([L.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!E(m.extensionDependencies))return t.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!E(m.activationEvents))return t.push([L.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([L.default.Error,r.localize(9,null,"main")]),t;{const i=(0,I.joinPath)(f,m.main);(0,I.isEqualOrParent)(i,f)||t.push([L.default.Warning,r.localize(10,null,i.path,f.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([L.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,I.joinPath)(f,m.browser);(0,I.isEqualOrParent)(i,f)||t.push([L.default.Warning,r.localize(12,null,i.path,f.path)])}}if(!O.valid(m.version))return t.push([L.default.Error,r.localize(13,null)]),t;const o=[];if(!h(u,d,m,a,o))for(const i of o)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=w;function h(u,d,f,m,a){return m||typeof f.main>"u"&&typeof f.browser>"u"?!0:y(u,d,f.engines.vscode,a)}e.isValidExtensionVersion=h;function p(u,d,f){return u==="*"||y(d,f,u)}e.isEngineValid=p;function y(u,d,f,m=[]){const a=v(c(f));if(!a)return m.push(r.localize(14,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return m.push(r.localize(15,null,f)),!1}else if(!a.majorMustEqual)return m.push(r.localize(16,null,f)),!1;return b(u,d,a)?!0:(m.push(r.localize(17,null,u,f)),!1)}function E(u){if(!Array.isArray(u))return!1;for(let d=0,f=u.length;d<f;d++)if(typeof u[d]!="string")return!1;return!0}}),define(ae[206],ce([0,1,17,32]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(O,M,C){let g=C&&C.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const v=(await M.readFile(O.serviceMachineIdResource)).value.toString();g=(0,L.isUUID)(v)?v:null}catch{g=null}if(!g){g=(0,L.generateUuid)();try{await M.writeFile(O.serviceMachineIdResource,I.VSBuffer.fromString(g))}catch{}}return C?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=r}),define(ae[77],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(r,O=[],M=!1){this.ctor=r,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=I}),define(ae[207],ce([0,1,77]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function O(C,g,c){g instanceof I.SyncDescriptor||(g=new I.SyncDescriptor(g,[],!!c)),L.push([C,g])}e.registerSingleton=O;function M(){return L}e.getSingletonServiceDescriptors=M}),define(ae[208],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const M of this._nodes.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const C=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(M);C.outgoing.set(g.key,g),g.incoming.set(C.key,C)}removeNode(O){const M=this._hashFn(O);this._nodes.delete(M);for(const C of this._nodes.values())C.outgoing.delete(M),C.incoming.delete(M)}lookupOrInsertNode(O){const M=this._hashFn(O);let C=this._nodes.get(M);return C||(C=new I(M,O),this._nodes.set(M,C)),C}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[M,C]of this._nodes)O.push(`${M}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this._nodes){const C=new Set([O]),g=this._findCycle(M,C);if(g)return g}}_findCycle(O,M){for(const[C,g]of O.outgoing){if(M.has(C))return[...M,C].join(" -> ");M.add(C);const c=this._findCycle(g,M);if(c)return c;M.delete(C)}}}e.Graph=L}),define(ae[6],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function C(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=C})(I||(e._util=I={})),e.IInstantiationService=r("instantiationService");function L(M,C,g){C[I.DI_TARGET]===C?C[I.DI_DEPENDENCIES].push({id:M,index:g}):(C[I.DI_DEPENDENCIES]=[{id:M,index:g}],C[I.DI_TARGET]=C)}function r(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const C=function(g,c,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(C,g,v)};return C.toString=()=>M,I.serviceIds.set(M,C),C}e.createDecorator=r;function O(M){return M}e.refineServiceDecorator=O}),define(ae[78],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,I.createDecorator)("auxiliaryWindowsMainService")}),define(ae[65],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationOverrides=O;function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=M;var C;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.isConfigured=c;function v(u,d){const f=Object.create(null);for(const m in u)b(f,m,u[m],d);return f}e.toValuesTree=v;function b(u,d,f,m){const a=d.split("."),t=a.pop();let o=u;for(let s=0;s<a.length;s++){const i=a[s];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${d} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=f}catch{m(`Ignoring ${d} as ${a.join(".")} is ${JSON.stringify(o)}`)}else m(`Ignoring ${d} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function w(u,d){const f=d.split(".");h(u,f)}e.removeFromValueTree=w;function h(u,d){const f=d.shift();if(d.length===0){delete u[f];return}if(Object.keys(u).indexOf(f)!==-1){const m=u[f];typeof m=="object"&&!Array.isArray(m)&&(h(m,d),Object.keys(m).length===0&&delete u[f])}}function p(u,d,f){function m(o,s){let i=o;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const a=d.split("."),t=m(u,a);return typeof t>"u"?f:t}e.getConfigurationValue=p;function y(u,d,f){Object.keys(d).forEach(m=>{m!=="__proto__"&&(m in u?I.isObject(u[m])&&I.isObject(d[m])?y(u[m],d[m],f):f&&(u[m]=d[m]):u[m]=d[m])})}e.merge=y;function E(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(ae[116],ce([0,1,4,25,197,6,164,15]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",I.isMacintosh),g.set("isLinux",I.isLinux),g.set("isWindows",I.isWindows),g.set("isWeb",I.isWeb),g.set("isMacNative",I.isMacintosh&&!I.isWeb),g.set("isEdge",I.isEdge),g.set("isFirefox",I.isFirefox),g.set("isChrome",I.isChrome),g.set("isSafari",I.isSafari);function c(G,A){if(g.get(G)!==void 0)throw(0,C.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(G,A)}e.setConstant=c;const v=Object.prototype.hasOwnProperty;var b;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const w={regexParsingWithErrorRecovery:!0},h=(0,M.localize)(0,null),p=(0,M.localize)(1,null),y=(0,M.localize)(2,null),E=(0,M.localize)(3,null),u=(0,M.localize)(4,null),d=(0,M.localize)(5,null),f=(0,M.localize)(6,null),m=(0,M.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(A=w){this._config=A,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(A){if(A===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(A).scan(),this._current=0,this._parsingErrors=[];try{const T=this._expr();if(!this._isAtEnd()){const J=this._peek(),B=J.type===17?d:void 0;throw this._parsingErrors.push({message:u,offset:J.offset,lexeme:r.Scanner.getLexeme(J),additionalInfo:B}),a._parseError}return T}catch(T){if(T!==a._parseError)throw T;return}}_expr(){return this._or()}_or(){const A=[this._and()];for(;this._matchOne(16);){const T=this._and();A.push(T)}return A.length===1?A[0]:t.or(...A)}_and(){const A=[this._term()];for(;this._matchOne(15);){const T=this._term();A.push(T)}return A.length===1?A[0]:t.and(...A)}_term(){if(this._matchOne(2)){const A=this._peek();switch(A.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),l.INSTANCE;case 0:{this._advance();const T=this._expr();return this._consume(1,E),T?.negate()}case 17:return this._advance(),_.create(A.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",A)}}return this._primary()}_primary(){const A=this._peek();switch(A.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const T=this._expr();return this._consume(1,E),T}case 17:{const T=A.lexeme;if(this._advance(),this._matchOne(9)){const B=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),B.type!==10)throw this._errExpectedButGot("REGEX",B);const X=B.lexeme,x=X.lastIndexOf("/"),Z=x===X.length-1?void 0:this._removeFlagsGY(X.substring(x+1));let z;try{z=new RegExp(X.substring(1,x),Z)}catch{throw this._errExpectedButGot("REGEX",B)}return se.create(T,z)}switch(B.type){case 10:case 19:{const X=[B.lexeme];this._advance();let x=this._peek(),Z=0;for(let pe=0;pe<B.lexeme.length;pe++)B.lexeme.charCodeAt(pe)===40?Z++:B.lexeme.charCodeAt(pe)===41&&Z--;for(;!this._isAtEnd()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:Z++;break;case 1:Z--;break;case 10:case 18:for(let pe=0;pe<x.lexeme.length;pe++)x.lexeme.charCodeAt(pe)===40?Z++:B.lexeme.charCodeAt(pe)===41&&Z--}if(Z<0)break;X.push(r.Scanner.getLexeme(x)),this._advance(),x=this._peek()}const z=X.join(""),ee=z.lastIndexOf("/"),ie=ee===z.length-1?void 0:this._removeFlagsGY(z.substring(ee+1));let fe;try{fe=new RegExp(z.substring(1,ee),ie)}catch{throw this._errExpectedButGot("REGEX",B)}return t.regex(T,fe)}case 18:{const X=B.lexeme;this._advance();let x=null;if(!(0,L.isFalsyOrWhitespace)(X)){const Z=X.indexOf("/"),z=X.lastIndexOf("/");if(Z!==z&&Z>=0){const ee=X.slice(Z+1,z),ie=X[z+1]==="i"?"i":"";try{x=new RegExp(ee,ie)}catch{throw this._errExpectedButGot("REGEX",B)}}}if(x===null)throw this._errExpectedButGot("REGEX",B);return se.create(T,x)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const B=this._value();return t.notIn(T,B)}switch(this._peek().type){case 3:{this._advance();const B=this._value();if(this._previous().type===18)return t.equals(T,B);switch(B){case"true":return t.has(T);case"false":return t.not(T);default:return t.equals(T,B)}}case 4:{this._advance();const B=this._value();if(this._previous().type===18)return t.notEquals(T,B);switch(B){case"true":return t.not(T);case"false":return t.has(T);default:return t.notEquals(T,B)}}case 5:return this._advance(),j.create(T,this._value());case 6:return this._advance(),le.create(T,this._value());case 7:return this._advance(),F.create(T,this._value());case 8:return this._advance(),H.create(T,this._value());case 13:return this._advance(),t.in(T,this._value());default:return t.has(T)}}case 20:throw this._parsingErrors.push({message:f,offset:A.offset,lexeme:"",additionalInfo:m}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const A=this._peek();switch(A.type){case 17:case 18:return this._advance(),A.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(A){return A.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(A){return this._check(A)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(A,T){if(this._check(A))return this._advance();throw this._errExpectedButGot(T,this._peek())}_errExpectedButGot(A,T,J){const B=(0,M.localize)(8,null,A,r.Scanner.getLexeme(T)),X=T.offset,x=r.Scanner.getLexeme(T);return this._parsingErrors.push({message:B,offset:X,lexeme:x,additionalInfo:J}),a._parseError}_check(A){return this._peek().type===A}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(A){return S.create(A)}static equals(A,T){return R.create(A,T)}static notEquals(A,T){return D.create(A,T)}static regex(A,T){return se.create(A,T)}static in(A,T){return k.create(A,T)}static notIn(A,T){return P.create(A,T)}static not(A){return _.create(A)}static and(...A){return Q.create(A,null,!0)}static or(...A){return q.create(A,null,!0)}static greater(A,T){return F.create(A,T)}static greaterEquals(A,T){return H.create(A,T)}static smaller(A,T){return j.create(A,T)}static smallerEquals(A,T){return le.create(A,T)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this._parser.parse(A)}}e.ContextKeyExpr=t;function o(G){const A=new a({regexParsingWithErrorRecovery:!1});return G.map(T=>(A.parse(T),A.lexingErrors.length>0?A.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,M.localize)(9,null,J.additionalInfo):(0,M.localize)(10,null),offset:J.offset,length:J.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}e.validateWhenClauses=o;function s(G,A){const T=G?G.substituteConstants():void 0,J=A?A.substituteConstants():void 0;return!T&&!J?!0:!T||!J?!1:T.equals(J)}e.expressionsAreEqualWithConstantSubstitution=s;function i(G,A){return G.cmp(A)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=n;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=l;class S{static create(A,T=null){const J=g.get(A);return typeof J=="boolean"?J?l.INSTANCE:n.INSTANCE:new S(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:N(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=g.get(this.key);return typeof A=="boolean"?A?l.INSTANCE:n.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class R{static create(A,T,J=null){if(typeof T=="boolean")return T?S.create(A,J):_.create(A,J);const B=g.get(A);return typeof B=="boolean"?T===(B?"true":"false")?l.INSTANCE:n.INSTANCE:new R(A,T,J)}constructor(A,T,J){this.key=A,this.value=T,this.negated=J,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=g.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?l.INSTANCE:n.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=R;class k{static create(A,T){return new k(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.valueKey),J=A.getValue(this.key);return Array.isArray(T)?T.includes(J):typeof J=="string"&&typeof T=="object"&&T!==null?v.call(T,J):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class P{static create(A,T){return new P(A,T)}constructor(A,T){this.key=A,this.valueKey=T,this.type=11,this._negated=k.create(A,T)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class D{static create(A,T,J=null){if(typeof T=="boolean")return T?_.create(A,J):S.create(A,J);const B=g.get(A);return typeof B=="boolean"?T===(B?"true":"false")?n.INSTANCE:l.INSTANCE:new D(A,T,J)}constructor(A,T,J){this.key=A,this.value=T,this.negated=J,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=g.get(this.key);if(typeof A=="boolean"){const T=A?"true":"false";return this.value===T?n.INSTANCE:l.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class _{static create(A,T=null){const J=g.get(A);return typeof J=="boolean"?J?n.INSTANCE:l.INSTANCE:new _(A,T)}constructor(A,T){this.key=A,this.negated=T,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:N(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=g.get(this.key);return typeof A=="boolean"?A?n.INSTANCE:l.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function U(G,A){if(typeof G=="string"){const T=parseFloat(G);isNaN(T)||(G=T)}return typeof G=="string"||typeof G=="number"?A(G):n.INSTANCE}class F{static create(A,T,J=null){return U(T,B=>new F(A,B,J))}constructor(A,T,J){this.key=A,this.value=T,this.negated=J,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=le.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class H{static create(A,T,J=null){return U(T,B=>new H(A,B,J))}constructor(A,T,J){this.key=A,this.value=T,this.negated=J,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=H;class j{static create(A,T,J=null){return U(T,B=>new j(A,B,J))}constructor(A,T,J){this.key=A,this.value=T,this.negated=J,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=j;class le{static create(A,T,J=null){return U(T,B=>new le(A,B,J))}constructor(A,T,J){this.key=A,this.value=T,this.negated=J,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:V(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=le;class se{static create(A,T){return new se(A,T)}constructor(A,T){this.key=A,this.regexp=T,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const T=this.regexp?this.regexp.source:"",J=A.regexp?A.regexp.source:"";return T<J?-1:T>J?1:0}equals(A){if(A.type===this.type){const T=this.regexp?this.regexp.source:"",J=A.regexp?A.regexp.source:"";return this.key===A.key&&T===J}return!1}substituteConstants(){return this}evaluate(A){const T=A.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ue.create(this)),this.negated}}e.ContextKeyRegexExpr=se;class ue{static create(A){return new ue(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(A){return new ue(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ue;function Y(G){let A=null;for(let T=0,J=G.length;T<J;T++){const B=G[T].substituteConstants();if(G[T]!==B&&A===null){A=[];for(let X=0;X<T;X++)A[X]=G[X]}A!==null&&(A[T]=B)}return A===null?G:A}class Q{static create(A,T,J){return Q._normalizeArr(A,T,J)}constructor(A,T){this.expr=A,this.negated=T,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,J=this.expr.length;T<J;T++){const B=i(this.expr[T],A.expr[T]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,J=this.expr.length;T<J;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=Y(this.expr);return A===this.expr?this:Q.create(A,this.negated,!1)}evaluate(A){for(let T=0,J=this.expr.length;T<J;T++)if(!this.expr[T].evaluate(A))return!1;return!0}static _normalizeArr(A,T,J){const B=[];let X=!1;for(const x of A)if(x){if(x.type===1){X=!0;continue}if(x.type===0)return n.INSTANCE;if(x.type===6){B.push(...x.expr);continue}B.push(x)}if(B.length===0&&X)return l.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let x=1;x<B.length;x++)B[x-1].equals(B[x])&&(B.splice(x,1),x--);if(B.length===1)return B[0];for(;B.length>1;){const x=B[B.length-1];if(x.type!==9)break;B.pop();const Z=B.pop(),z=B.length===0,ee=q.create(x.expr.map(ie=>Q.create([ie,Z],null,J)),null,z);ee&&(B.push(ee),B.sort(i))}if(B.length===1)return B[0];if(J){for(let x=0;x<B.length;x++)for(let Z=x+1;Z<B.length;Z++)if(B[x].negate().equals(B[Z]))return n.INSTANCE;if(B.length===1)return B[0]}return new Q(B,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new Q(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());this.negated=q.create(A,this,!0)}return this.negated}}e.ContextKeyAndExpr=Q;class q{static create(A,T,J){return q._normalizeArr(A,T,J)}constructor(A,T){this.expr=A,this.negated=T,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let T=0,J=this.expr.length;T<J;T++){const B=i(this.expr[T],A.expr[T]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let T=0,J=this.expr.length;T<J;T++)if(!this.expr[T].equals(A.expr[T]))return!1;return!0}return!1}substituteConstants(){const A=Y(this.expr);return A===this.expr?this:q.create(A,this.negated,!1)}evaluate(A){for(let T=0,J=this.expr.length;T<J;T++)if(this.expr[T].evaluate(A))return!0;return!1}static _normalizeArr(A,T,J){let B=[],X=!1;if(A){for(let x=0,Z=A.length;x<Z;x++){const z=A[x];if(z){if(z.type===0){X=!0;continue}if(z.type===1)return l.INSTANCE;if(z.type===9){B=B.concat(z.expr);continue}B.push(z)}}if(B.length===0&&X)return n.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let x=1;x<B.length;x++)B[x-1].equals(B[x])&&(B.splice(x,1),x--);if(B.length===1)return B[0];if(J){for(let x=0;x<B.length;x++)for(let Z=x+1;Z<B.length;Z++)if(B[x].negate().equals(B[Z]))return l.INSTANCE;if(B.length===1)return B[0]}return new q(B,T)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const T of this.expr)A.push(...T.keys());return A}map(A){return new q(this.expr.map(T=>T.map(A)),null)}negate(){if(!this.negated){const A=[];for(const T of this.expr)A.push(T.negate());for(;A.length>1;){const T=A.shift(),J=A.shift(),B=[];for(const X of de(T))for(const x of de(J))B.push(Q.create([X,x],null,!1));A.unshift(q.create(B,null,!1))}this.negated=q.create(A,this,!0)}return this.negated}}e.ContextKeyOrExpr=q;class W extends S{static{this._info=[]}static all(){return W._info.values()}constructor(A,T,J){super(A,null),this._defaultValue=T,typeof J=="object"?W._info.push({...J,key:A}):J!==!0&&W._info.push({key:A,description:J,type:T!=null?typeof T:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return R.create(this.key,A)}notEqualsTo(A){return D.create(this.key,A)}}e.RawContextKey=W,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function N(G,A){return G<A?-1:G>A?1:0}function V(G,A,T,J){return G<T?-1:G>T?1:A<J?-1:A>J?1:0}function $(G,A){if(G.type===0||A.type===1)return!0;if(G.type===9)return A.type===9?oe(G.expr,A.expr):!1;if(A.type===9){for(const T of A.expr)if($(G,T))return!0;return!1}if(G.type===6){if(A.type===6)return oe(A.expr,G.expr);for(const T of G.expr)if($(T,A))return!0;return!1}return G.equals(A)}e.implies=$;function oe(G,A){let T=0,J=0;for(;T<G.length&&J<A.length;){const B=G[T].cmp(A[J]);if(B<0)return!1;B===0&&T++,J++}return T===G.length}function de(G){return G.type===9?G.expr:[G]}}),define(ae[92],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function L(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(M,C){return{}}async getSystemInfo(M,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,C){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=r}),define(ae[117],ce([0,1,19,73,166,6,47,4,35]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,O.createDecorator)("dialogService");var c;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(c||(c={}));class v{getConfirmationButtons(E){return this.getButtons(E,c.Confirmation)}getPromptButtons(E){return this.getButtons(E,c.Prompt)}getInputButtons(E){return this.getButtons(E,c.Input)}getButtons(E,u){const d=[];switch(u){case c.Confirmation:{const f=E;f.primaryButton?d.push(f.primaryButton):d.push((0,r.localize)(0,null)),f.cancelButton?d.push(f.cancelButton):d.push((0,r.localize)(1,null));break}case c.Prompt:{const f=E;Array.isArray(f.buttons)&&f.buttons.length>0&&d.push(...f.buttons.map(m=>m.label)),f.cancelButton&&(f.cancelButton===!0?d.push((0,r.localize)(2,null)):typeof f.cancelButton=="string"?d.push(f.cancelButton):f.cancelButton.label?d.push(f.cancelButton.label):d.push((0,r.localize)(3,null))),d.length===0&&d.push((0,r.localize)(4,null));break}case c.Input:{const f=E;f.primaryButton?d.push(f.primaryButton):d.push((0,r.localize)(5,null)),f.cancelButton?d.push(f.cancelButton):d.push((0,r.localize)(6,null));break}}return d}getDialogType(E){if(typeof E=="string")return E;if(typeof E=="number")return E===L.default.Info?"info":E===L.default.Error?"error":E===L.default.Warning?"warning":"none"}getPromptResult(E,u,d){const f=[...E.buttons??[]];E.cancelButton&&typeof E.cancelButton!="string"&&typeof E.cancelButton!="boolean"&&f.push(E.cancelButton);let m=f[u]?.run({checkboxChecked:d});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:d}}}e.AbstractDialogHandler=v,e.IFileDialogService=(0,O.createDecorator)("fileDialogService");var b;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const w=10;function h(y){const E=[];return E.push(...y.slice(0,w).map(u=>typeof u=="string"?u:(0,I.basename)(u))),y.length>w&&(y.length-w===1?E.push((0,r.localize)(7,null)):E.push((0,r.localize)(8,null,y.length-w))),E.push(""),E.join(`
`)}e.getFileNamesMessage=h;function p(y,E){const u=(0,g.deepClone)(y);let d=(u.buttons??[]).map(t=>(0,M.mnemonicButtonLabel)(t)),f=(y.buttons||[]).map((t,o)=>o),m=0,a=u.cancelId??d.length-1;if(d.length>1){const t=typeof a=="number"?d[a]:void 0;if(C.isLinux||C.isMacintosh){if(typeof t=="string"&&d.length>1&&a!==1){d.splice(a,1),d.splice(1,0,t);const o=f[a];f.splice(a,1),f.splice(1,0,o),a=1}C.isLinux&&d.length>1&&(d=d.reverse(),f=f.reverse(),m=d.length-1,typeof t=="string"&&(a=m-1))}else if(C.isWindows&&typeof t=="string"&&d.length>1&&a!==d.length-1){d.splice(a,1),d.push(t);const o=f[a];f.splice(a,1),f.push(o),a=d.length-1}}return u.buttons=d,u.defaultId=m,u.cancelId=a,u.noLink=!0,u.title=u.title||E.nameLong,{options:u,buttonIndeces:f}}e.massageMessageBoxOptions=p}),define(ae[118],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,I.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService");var L;(function(C){C.kwallet="kwallet",C.kwallet5="kwallet5",C.gnomeLibsecret="gnome-libsecret",C.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var r;(function(C){C.unknown="unknown",C.basicText="basic_text",C.gnomeAny="gnome_any",C.gnomeLibsecret="gnome_libsecret",C.gnomeKeyring="gnome_keyring",C.kwallet="kwallet",C.kwallet5="kwallet5",C.kwallet6="kwallet6",C.dplib="dpapi",C.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function O(C){return C==="kwallet"||C==="kwallet5"||C==="kwallet6"}e.isKwallet=O;function M(C){return C==="gnome_any"||C==="gnome_libsecret"||C==="gnome_keyring"}e.isGnome=M}),define(ae[38],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ae[119],ce([0,1,170,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function r(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function O(f){switch(f){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function M(f,m){switch(f){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":m==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function C(f,m){return m==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function g(f,m,a){return C(m,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a}e.isTargetPlatformCompatible=g;function c(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=c;var v;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var b;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var w;(function(f){f.Install="install",f.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var h;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.DownloadSignature="DownloadSignature",f.UpdateMetadata="UpdateMetadata",f.Extract="Extract",f.Scanning="Scanning",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.NotAllowed="NotAllowed",f.Gallery="Gallery",f.Unknown="Unknown",f.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var y;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class E extends Error{constructor(m,a){super(m),this.code=a,this.name=a}}e.ExtensionManagementError=E;var u;(function(f){f.Timeout="Timeout",f.Cancelled="Cancelled",f.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class d extends Error{constructor(m,a){super(m),this.code=a,this.name=a}}e.ExtensionGalleryError=d,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,I.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,I.localize2)(1,"Preferences")}),define(ae[209],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ae[210],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ae[211],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ae[212],ce([0,1,48,50,13,9,4,75,21,90,174,210]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=v.localize(0,null);class h{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends h{static{this.CMD="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(I,a,c.getWindowsShell(),t)}spawnTerminal(a,t,o,s){const i=t.windowsExec||p.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=O.basename(i,".exe").toLowerCase();if(n==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),n==="wt"&&l.push("-d ."),new Promise((S,R)=>{const k=u(process),P=a.spawn(o,l,{cwd:s,env:k,detached:!0});P.on("error",R),P.on("exit",()=>S())})}async runInTerminal(a,t,o,s,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:p.getDefaultTerminalWindows(),l=await p.getWtExePath();return new Promise((S,R)=>{const k=`"${t} - ${w}"`,P=`""${o.join('" "')}" & pause"`,D=Object.assign({},u(process),s);Object.keys(D).filter(j=>D[j]===null).forEach(j=>delete D[j]);const _={cwd:t,env:D,windowsVerbatimArguments:!0};let U,F;O.basename(n,".exe")==="wt"?(U=n,F=["-d",".",p.CMD,"/c",P]):l?(U=l,F=["-d",".",n,"/c",P]):(U=p.CMD,F=["/c","start",k,"/wait",n,"/c",P]),I.spawn(U,F,_).on("error",j=>{R(d(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const a=await c.win32.findExecutable("wt");return await g.Promises.exists(a)?a:void 0}catch{return}}}e.WindowsExternalTerminalService=p,be([L.memoize],p,"getWtExePath",null);class y extends h{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,o,s,i){const n=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((l,S)=>{if(n===b.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const R=n===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[r.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${R}.scpt`).fsPath,"-t",a||w,"-w",t];for(const U of o)P.push("-a"),P.push(U);if(s){const U=Object.assign({},u(process),s);for(const F in U){const H=U[F];H===null?(P.push("-u"),P.push(F)):(P.push("-e"),P.push(`${F}=${H}`))}}let D="";const _=I.spawn(y.OSASCRIPT,P);_.on("error",U=>{S(d(U))}),_.stderr.on("data",U=>{D+=U.toString()}),_.on("exit",U=>{if(U===0)l(void 0);else if(D){const F=D.split(`
`,1);S(new Error(F[0]))}else S(new Error(v.localize(1,null,R,U)))})}else S(new Error(v.localize(2,null,n)))})}spawnTerminal(a,t,o){const s=t.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const l=["-a",s];o&&l.push(o);const S=u(process),R=a.spawn("/usr/bin/open",l,{cwd:o,env:S});R.on("error",n),R.on("exit",()=>i())})}}e.MacExternalTerminalService=y;class E extends h{static{this.WAIT_MESSAGE=v.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,o,s,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((l,S)=>{const R=[];n.then(k=>{k.indexOf("gnome-terminal")>=0?R.push("-x"):R.push("-e"),R.push("bash"),R.push("-c");const P=`${f(o)}; echo; read -p "${E.WAIT_MESSAGE}" -n1;`;R.push(`''${P}''`);const D=Object.assign({},u(process),s);Object.keys(D).filter(H=>D[H]===null).forEach(H=>delete D[H]);const _={cwd:t,env:D};let U="";const F=I.spawn(k,R,_);F.on("error",H=>{S(d(H))}),F.stderr.on("data",H=>{U+=H.toString()}),F.on("exit",H=>{if(H===0)l(void 0);else if(U){const j=U.split(`
`,1);S(new Error(j[0]))}else S(new Error(v.localize(4,null,k,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!E._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)E._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await g.Promises.exists("/etc/debian_version");E._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return E._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,t,o){const s=t.linuxExec?Promise.resolve(t.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{s.then(l=>{const S=u(process),R=a.spawn(l,[],{cwd:o,env:S});R.on("error",n),R.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=E;function u(m){const a={...m.env};return(0,C.sanitizeProcessEnvironment)(a),a}function d(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(v.localize(5,null,m.path)):m}function f(m){let a="";for(const t of m)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,176,6,4,13,62]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function w($){return $.create===!0}e.isFileOpenForWriteOptions=w;var h;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var p;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function y($){const oe=$;return!!oe&&typeof oe.onDidChange=="function"}e.isFileSystemWatcher=y;var E;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function u($){return!!($.capabilities&2)}e.hasReadWriteCapability=u;function d($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=d;function f($){return!!($.capabilities&131072)}e.hasFileCloneCapability=f;function m($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function a($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=a;function t($){return u($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function o($){return u($)?!!($.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function s($){return!!($.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function i($){return!!($.capabilities&2048)}e.hasReadonlyCapability=i;var n;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class l extends Error{static create(oe,de){const G=new l(oe.toString(),de);return k(G,de),G}constructor(oe,de){super(oe),this.code=de}}e.FileSystemProviderError=l;function S($,oe){return l.create($,oe)}e.createFileSystemProviderError=S;function R($){return $||S((0,C.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=R;function k($,oe){return $.name=oe?`${oe} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=k;function P($){if(!$)return n.Unknown;if($ instanceof l)return $.code;const oe=/^(.+) \(FileSystemError\)$/.exec($.name);if(!oe)return n.Unknown;switch(oe[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=P;function D($){if($ instanceof le)return $.fileOperationResult;switch(P($)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=D;var _;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class U{constructor(oe,de,G){this.resource=oe,this.operation=de,this.target=G}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=U;var F;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class H{static{this.MIXED_CORRELATION=null}constructor(oe,de){this.ignorePathCasing=de,this.correlationId=void 0,this.added=new b.Lazy(()=>{const G=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawAdded.map(A=>[A,!0])),G}),this.updated=new b.Lazy(()=>{const G=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawUpdated.map(A=>[A,!0])),G}),this.deleted=new b.Lazy(()=>{const G=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawDeleted.map(A=>[A,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of oe){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.correlationId!==H.MIXED_CORRELATION&&(typeof G.cId=="number"?this.correlationId===void 0?this.correlationId=G.cId:this.correlationId!==G.cId&&(this.correlationId=H.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=H.MIXED_CORRELATION))}}contains(oe,...de){return this.doContains(oe,{includeChildren:!1},...de)}affects(oe,...de){return this.doContains(oe,{includeChildren:!0},...de)}doContains(oe,de,...G){if(!oe)return!1;const A=G.length>0;return!!((!A||G.includes(1))&&(this.added.value.get(oe)||de.includeChildren&&this.added.value.findSuperstr(oe))||(!A||G.includes(0))&&(this.updated.value.get(oe)||de.includeChildren&&this.updated.value.findSuperstr(oe))||(!A||G.includes(2))&&(this.deleted.value.findSubstr(oe)||de.includeChildren&&this.deleted.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.correlationId===oe}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=H;function j($,oe,de){return!$||!oe||$===oe||oe.length>$.length?!1:(oe.charAt(oe.length-1)!==L.sep&&(oe+=L.sep),de?(0,r.startsWithIgnoreCase)($,oe):$.indexOf(oe)===0)}e.isParent=j;class le extends Error{constructor(oe,de,G){super(oe),this.fileOperationResult=de,this.options=G}}e.FileOperationError=le;class se extends le{constructor(oe,de,G,A){super(oe,de,A),this.fileOperationResult=de,this.size=G}}e.TooLargeFileOperationError=se;class ue extends le{constructor(oe,de,G){super(oe,2,G),this.stat=de}}e.NotModifiedSinceFileOperationError=ue;var Y;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Q;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.ETAG_DISABLED="";function q($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=q;async function W($,oe){if(!oe.hasProvider(M.URI.from({scheme:$.scheme})))return new Promise(de=>{const G=oe.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===$.scheme&&A.added&&(G.dispose(),de())})})}e.whenProviderRegistered=W;class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(oe){return(0,O.isNumber)(oe)||(oe=0),oe<N.KB?(0,C.localize)(1,null,oe.toFixed(0)):oe<N.MB?(0,C.localize)(2,null,(oe/N.KB).toFixed(2)):oe<N.GB?(0,C.localize)(3,null,(oe/N.MB).toFixed(2)):oe<N.TB?(0,C.localize)(4,null,(oe/N.GB).toFixed(2)):(0,C.localize)(5,null,(oe/N.TB).toFixed(2))}}e.ByteSize=N;function V($){const oe=typeof $=="string"||$?.scheme===v.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===v.Schemas.file?1024*N.MB:oe?10*N.MB:c.isWeb?50*N.MB:1024*N.MB}e.getLargeFileConfirmationLimit=V}),define(ae[120],ce([0,1,17,15,177,16]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(v,b,w,h,p,y){let E;try{await C(v,b,w,h,p,y)}catch(u){E=u}finally{E&&p.errorTransformer&&(E=p.errorTransformer(E)),typeof E<"u"&&w.error(E),w.end()}}e.readFileIntoStream=M;async function C(v,b,w,h,p,y){g(y);const E=await v.open(b,{create:!1});try{g(y);let u=0,d=0,f=p&&typeof p.length=="number"?p.length:void 0,m=I.VSBuffer.alloc(Math.min(p.bufferSize,typeof f=="number"?f:p.bufferSize)),a=p&&typeof p.position=="number"?p.position:0,t=0;do d=await v.read(E,a,m.buffer,t,m.byteLength-t),a+=d,t+=d,u+=d,typeof f=="number"&&(f-=d),t===m.byteLength&&(await w.write(h(m)),m=I.VSBuffer.alloc(Math.min(p.bufferSize,typeof f=="number"?f:p.bufferSize)),t=0);while(d>0&&(typeof f!="number"||f>0)&&g(y)&&c(u,p));if(t>0){let o=t;typeof f=="number"&&(o=Math.min(t,f)),w.write(h(m.slice(0,o)))}}catch(u){throw(0,O.ensureFileSystemProviderError)(u)}finally{await v.close(E)}}function g(v){if(v.isCancellationRequested)throw(0,L.canceled)();return!0}function c(v,b){if(typeof b?.limits?.size=="number"&&v>b.limits.size)throw(0,O.createFileSystemProviderError)((0,r.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[66],ce([0,1,106,2,9,4,7,16]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(u){return u.recursive===!0}e.isRecursiveWatchRequest=g;class c extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(d,f,m,a){super(),this.onFileChanges=d,this.onLogMessage=f,this.verboseLogging=m,this.options=a,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new L.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),d.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),d.add(this.watcher.onDidError(f=>this.onError(f)))}onError(d){this.options.restartOnError?this.restartCounter<c.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=c;class v extends c{constructor(d,f,m){super(d,f,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class b extends c{constructor(d,f,m){super(d,f,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function w(u){return u.map(d=>({type:d.type,resource:M.URI.revive(d.resource),cId:d.cId}))}e.reviveFileChanges=w;function h(u){const d=new E;for(const f of u)d.processEvent(f);return d.coalesce()}e.coalesceEvents=h;function p(u,d){return typeof d=="string"&&!d.startsWith(I.GLOBSTAR)&&!(0,r.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=p;function y(u,d){const f=[];for(const m of d)f.push((0,I.parse)(p(u,m)));return f}e.parseWatcherPatterns=y;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return O.isLinux?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const f=this.mapPathToChange.get(this.toKey(d));let m=!1;if(f){const a=f.type,t=d.type;f.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?m=!0:a===1&&t===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(f)):a===2&&t===1?f.type=0:a===1&&t===0||(f.type=t)}else m=!0;m&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],f=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(d.push(m),!1):!0).sort((m,a)=>m.resource.fsPath.length-a.resource.fsPath.length).filter(m=>f.some(a=>(0,C.isParent)(m.resource.fsPath,a,!O.isLinux))?!1:(f.push(m.resource.fsPath),!0)).concat(d)}}}),define(ae[213],ce([0,1,17,51,15,3,2,63,32,16,66]),function(K,e,I,L,r,O,M,C,g,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends M.Disposable{constructor(h,p){super(),this.channel=h,this.extraCapabilities=p,this.onDidChangeCapabilities=O.Event.None,this._onDidChange=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,g.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,p){const{buffer:y}=await this.channel.call("readFile",[h,p]);return y}readFileStream(h,p,y){const E=(0,C.newWriteableStream)(d=>I.VSBuffer.concat(d.map(f=>I.VSBuffer.wrap(f))).buffer),u=new M.DisposableStore;return u.add(this.channel.listen("readFileStream",[h,p])(d=>{if(d instanceof I.VSBuffer)E.write(d.buffer);else{if(d==="end")E.end();else{let f;if(d instanceof Error)f=d;else{const m=d;f=(0,c.createFileSystemProviderError)(m.message??(0,L.toErrorMessage)(m),m.code??c.FileSystemProviderErrorCode.Unknown)}E.error(f),E.end()}u.dispose()}})),u.add(y.onCancellationRequested(()=>{E.error((0,r.canceled)()),E.end(),u.dispose()})),E}writeFile(h,p,y){return this.channel.call("writeFile",[h,I.VSBuffer.wrap(p),y])}open(h,p){return this.channel.call("open",[h,p])}close(h){return this.channel.call("close",[h])}async read(h,p,y,E,u){const[d,f]=await this.channel.call("read",[h,p,u]);return y.set(d.buffer.slice(0,f),E),f}write(h,p,y,E,u){return this.channel.call("write",[h,p,I.VSBuffer.wrap(y),E,u])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,p){return this.channel.call("delete",[h,p])}rename(h,p,y){return this.channel.call("rename",[h,p,y])}copy(h,p,y){return this.channel.call("copy",[h,p,y])}cloneFile(h,p){return this.channel.call("cloneFile",[h,p])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const p=h;this._onDidChange.fire((0,v.reviveFileChanges)(p))}else{const p=h;this._onDidWatchError.fire(p)}}))}watch(h,p){const y=(0,g.generateUuid)();return this.channel.call("watch",[this.sessionId,y,h,p]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=b}),define(ae[214],ce([0,1,46,8,23,33,2,86,9,4,19,7,107,21,66]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends M.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(d,f,m,a){super(),this.request=d,this.onDidFilesChange=f,this.onLogMessage=m,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(t=>this.handleFileChanges(t),y.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const f=await h.Promises.stat(d);this._register(await this.doWatch(d,f.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let f=d.path;try{f=await h.Promises.realpath(d.path),d.path===f&&(f=await(0,w.realcase)(d.path)??d.path),d.path!==f&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${f})`)}catch{}return f}async doWatch(d,f){if(c.isMacintosh&&(0,O.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const m=new r.CancellationTokenSource(this.cts.token),a=new M.DisposableStore;try{const t=b.URI.file(this.request.path),o=(0,g.basename)(d),s=(0,I.watch)(d);a.add((0,M.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${d}'`);const i=new Set;if(f)try{for(const l of await h.Promises.readdir(d))i.add(l)}catch(l){this.error(l)}const n=new Map;a.add((0,M.toDisposable)(()=>{for(const[,l]of n)l.dispose();n.clear()})),s.on("error",(l,S)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${l}, ${S})`),this.dispose()}),s.on("change",(l,S)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${l}"] ${S}`);let R="";if(S&&(R=S.toString(),c.isMacintosh&&(R=(0,C.normalizeNFC)(R))),!(!R||l!=="change"&&l!=="rename"))if(f)if(l==="rename"){n.get(R)?.dispose();const k=setTimeout(async()=>{if(n.delete(R),R===o&&!await h.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const P=await this.existsChildStrictCase((0,g.join)(d,R));if(m.token.isCancellationRequested)return;let D;P?i.has(R)?D=0:(D=1,i.add(R)):(i.delete(R),D=2),this.onFileChange({resource:(0,v.joinPath)(t,R),type:D,cId:this.request.correlationId})},y.FILE_DELETE_HANDLER_DELAY);n.set(R,(0,M.toDisposable)(()=>clearTimeout(k)))}else{let k;i.has(R)?k=0:(k=1,i.add(R)),this.onFileChange({resource:(0,v.joinPath)(t,R),type:k,cId:this.request.correlationId})}else if(l==="rename"||R!==o){const k=setTimeout(async()=>{const P=await h.Promises.exists(d);m.token.isCancellationRequested||(P?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(d,!1))):(this.onFileChange({resource:t,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,M.toDisposable)(()=>clearTimeout(k)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){await h.Promises.exists(d)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${t.toString()})`)}return(0,M.toDisposable)(()=>{m.dispose(!0),a.dispose()})}onFileChange(d,f=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!f&&this.excludes.some(m=>m(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.resource.fsPath}`):!f&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.resource.fsPath}`):this.fileChangesAggregator.work(d))}handleFileChanges(d){const f=(0,p.coalesceEvents)(d);if(f.length>0){if(this.verboseLogging)for(const a of f)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(f)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(d){if(c.isLinux)return h.Promises.exists(d);try{const f=(0,g.basename)(d);return(await h.Promises.readdir((0,g.dirname)(d))).some(a=>a===f)}catch(f){return this.trace(f),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y;async function E(u,d,f,m,a=512){const t=await h.Promises.open(u,"r"),o=Buffer.allocUnsafe(a),s=new r.CancellationTokenSource(m);let i,n=!1;const l={path:u,excludes:[],recursive:!1},S=new y(l,R=>{(async()=>{for(const{type:k}of R)if(k===0){if(n)return;n=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:P}=await h.Promises.read(t,o,0,a,null);if(!P||s.token.isCancellationRequested)break;d(o.slice(0,P))}}catch(P){i=new Error(P),s.dispose(!0)}finally{n=!1}}})()});return await S.ready,f(),new Promise((R,k)=>{s.token.onCancellationRequested(async()=>{S.dispose();try{await h.Promises.close(t)}catch(P){i=new Error(P)}i?k(i):R()})})}e.watchFileContents=E}),define(ae[215],ce([0,1,3,106,2,4,214]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(c){const v=this.normalizeRequests(c),b=v.filter(h=>{const p=this.watchers.get(h.path);return p?!(0,L.patternsEquals)(p.request.excludes,h.excludes)||!(0,L.patternsEquals)(p.request.includes,h.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:h})=>!v.find(p=>p.path===h.path&&(0,L.patternsEquals)(p.excludes,h.excludes)&&(0,L.patternsEquals)(p.includes,h.includes))).map(({request:h})=>h.path);b.length&&this.trace(`Request to start watching: ${b.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const h of w)this.stopWatching(h);for(const h of b)this.startWatching(h)}startWatching(c){const v=new M.NodeJSFileWatcherLibrary(c,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),b={request:c,instance:v};this.watchers.set(c.path,b)}async stop(){for(const[c]of this.watchers)this.stopWatching(c);this.watchers.clear()}stopWatching(c){const v=this.watchers.get(c);v&&(this.watchers.delete(c),v.instance.dispose())}normalizeRequests(c){const v=new Map;for(const b of c){const w=O.isLinux?b.path:b.path.toLowerCase();let h=v.get(b.correlationId);h||(h=new Map,v.set(b.correlationId,h)),h.set(w,b)}return Array.from(v.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(c){this.verboseLogging=c;for(const[,v]of this.watchers)v.instance.setVerboseLogging(c)}trace(c){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(c)})}toMessage(c,v){return v?`[File Watcher (node.js)] ${c} (path: ${v.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=C}),define(ae[216],ce([0,1,66,215]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends I.AbstractNonRecursiveWatcherClient{constructor(M,C,g){super(M,C,g),this.init()}createWatcher(M){return M.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=r}),define(ae[217],ce([0,1,13,43,160,66]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends O.AbstractUniversalWatcherClient{constructor(g,c,v){super(g,c,v),this.init()}createWatcher(g){const c=g.add(new r.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:v,signal:b})=>this.onError(`terminated by itself with code ${v}, signal: ${b}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ae[93],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...r){this._entries=new Map;for(const[O,M]of r)this.set(O,M)}set(r,O){const M=this._entries.get(r);return this._entries.set(r,O),M}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=I}),define(ae[218],ce([0,1,8,15,2,77,208,6,93,103]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class b extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class w{constructor(E=new g.ServiceCollection,u=!1,d,f=v){this._services=E,this._strict=u,this._parent=d,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(C.IInstantiationService,this),this._globalGraph=f?d?._globalGraph??new M.Graph(m=>m):void 0}createChild(E){return new w(E,this._strict,this,this._enableTracing)}invokeFunction(E,...u){const d=p.traceInvocation(this._enableTracing,E);let f=!1;try{return E({get:a=>{if(f)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,d);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...u)}finally{f=!0,d.stop()}}createInstance(E,...u){let d,f;return E instanceof O.SyncDescriptor?(d=p.traceCreation(this._enableTracing,E.ctor),f=this._createInstance(E.ctor,E.staticArguments.concat(u),d)):(d=p.traceCreation(this._enableTracing,E),f=this._createInstance(E,u,d)),d.stop(),f}_createInstance(E,u=[],d){const f=C._util.getServiceDependencies(E).sort((t,o)=>t.index-o.index),m=[];for(const t of f){const o=this._getOrCreateServiceInstance(t.id,d);o||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(o)}const a=f.length>0?f[0].index:u.length;if(u.length!==a){console.trace(`[createInstance] First service dependency of ${E.name} at position ${a+1} conflicts with ${u.length} static arguments`);const t=a-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,a)}return Reflect.construct(E,u.concat(m))}_setServiceInstance(E,u){if(this._services.get(E)instanceof O.SyncDescriptor)this._services.set(E,u);else if(this._parent)this._parent._setServiceInstance(E,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const u=this._services.get(E);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):u}_getOrCreateServiceInstance(E,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const d=this._getServiceInstanceOrDescriptor(E);return d instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,d,u.branch(E,!0)):(u.branch(E,!1),d)}_safeCreateAndCacheServiceInstance(E,u,d){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,u,d)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,u,d){const f=new M.Graph(t=>t.id.toString());let m=0;const a=[{id:E,desc:u,_trace:d}];for(;a.length;){const t=a.pop();if(f.lookupOrInsertNode(t),m++>1e3)throw new b(f);for(const o of C._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof O.SyncDescriptor){const i={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};f.insertEdge(t,i),a.push(i)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new b(f);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof O.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,u,d=[],f,m){if(this._services.get(E)instanceof O.SyncDescriptor)return this._createServiceInstance(E,u,d,f,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,u,d,f,m);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(E,u,d=[],f,m){if(f){const a=new w(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(E);const t=new Map,o=new I.GlobalIdleValue(()=>{const s=a._createInstance(u,d,m);for(const[i,n]of t){const l=s[i];if(typeof l=="function")for(const S of n)S.disposable=l.apply(s,S.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let S=t.get(i);return S||(S=new c.LinkedList,t.set(i,S)),(k,P,D)=>{if(o.isInitialized)return o.value[i](k,P,D);{const _={listener:[k,P,D],disposable:void 0},U=S.push(_);return(0,r.toDisposable)(()=>{U(),_.disposable?.dispose()})}}}if(i in s)return s[i];const n=o.value;let l=n[i];return typeof l!="function"||(l=l.bind(n),s[i]=l),l},set(s,i,n){return o.value[i]=n,!0},getPrototypeOf(s){return u.prototype}})}else return this._createInstance(u,d,m)}_throwIfStrict(E,u){if(u&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=w;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class p{static{this.all=new Set}static{this._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(E,u){return E?new p(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(E,u){return E?new p(1,u.name):p._None}static{this._totals=0}constructor(E,u){this.type=E,this.name=u,this._start=Date.now(),this._dep=[]}branch(E,u){const d=new p(3,E.toString());return this._dep.push([E,u,d]),d}stop(){const E=Date.now()-this._start;p._totals+=E;let u=!1;function d(m,a){const t=[],o=new Array(m+1).join("	");for(const[s,i,n]of a._dep)if(i&&n){u=!0,t.push(`${o}CREATES -> ${s}`);const l=d(m+1,n);l&&t.push(l)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(E>2||u)&&p.all.add(f.join(`
`))}}e.Trace=p}),define(ae[219],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,I.createDecorator)("issueService")}),define(ae[5],ce([0,1,51,3,45,2,31,4,19,12,7,116,6]),function(K,e,I,L,r,O,M,C,g,c,v,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function h(){return new Date().toISOString()}function p(k){return(0,c.isNumber)(k)}e.isLogLevel=p;var y;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function E(k,P,D){switch(P){case y.Trace:k.trace(D);break;case y.Debug:k.debug(D);break;case y.Info:k.info(D);break;case y.Warning:k.warn(D);break;case y.Error:k.error(D);break;case y.Off:break;default:throw new Error(`Invalid log level ${P}`)}}e.log=E;function u(k,P=!1){let D="";for(let _=0;_<k.length;_++){let U=k[_];if(U instanceof Error&&(U=(0,I.toErrorMessage)(U,P)),typeof U=="object")try{U=JSON.stringify(U)}catch{}D+=(_>0?" ":"")+U}return D}class d extends O.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==y.Off&&this.level<=P}}e.AbstractLogger=d;class f extends d{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...D){this.checkLogLevel(y.Trace)&&this.log(y.Trace,u([P,...D],!0))}debug(P,...D){this.checkLogLevel(y.Debug)&&this.log(y.Debug,u([P,...D]))}info(P,...D){this.checkLogLevel(y.Info)&&this.log(y.Info,u([P,...D]))}warn(P,...D){this.checkLogLevel(y.Warning)&&this.log(y.Warning,u([P,...D]))}error(P,...D){if(this.checkLogLevel(y.Error))if(P instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=P.stack,this.log(y.Error,u(_))}else this.log(y.Error,u([P,...D]))}flush(){}}e.AbstractMessageLogger=f;class m extends d{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!C.isWindows}trace(P,...D){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...D):console.log(`[main ${h()}]`,P,...D))}debug(P,...D){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...D):console.log(`[main ${h()}]`,P,...D))}info(P,...D){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,P,...D):console.log(`[main ${h()}]`,P,...D))}warn(P,...D){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,P,...D):console.warn(`[main ${h()}]`,P,...D))}error(P,...D){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,P,...D):console.error(`[main ${h()}]`,P,...D))}flush(){}}e.ConsoleMainLogger=m;class a extends d{constructor(P=e.DEFAULT_LOG_LEVEL,D=!0){super(),this.useColors=D,this.setLevel(P)}trace(P,...D){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...D):console.log(P,...D))}debug(P,...D){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...D):console.log(P,...D))}info(P,...D){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...D):console.log(P,...D))}warn(P,...D){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...D):console.log(P,...D))}error(P,...D){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...D):console.error(P,...D))}flush(){}}e.ConsoleLogger=a;class t extends d{constructor(P,D=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(D)}trace(P,...D){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(P),...D])}debug(P,...D){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(P),...D])}info(P,...D){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(P),...D])}warn(P,...D){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(P),...D])}error(P,...D){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(P),...D])}extractMessage(P){return typeof P=="string"?P:(0,I.toErrorMessage)(P,this.checkLogLevel(y.Trace))}flush(){}}e.AdapterLogger=t;class o extends d{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const D of this.loggers)D.setLevel(P);super.setLevel(P)}trace(P,...D){for(const _ of this.loggers)_.trace(P,...D)}debug(P,...D){for(const _ of this.loggers)_.debug(P,...D)}info(P,...D){for(const _ of this.loggers)_.info(P,...D)}warn(P,...D){for(const _ of this.loggers)_.warn(P,...D)}error(P,...D){for(const _ of this.loggers)_.error(P,...D)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose();super.dispose()}}e.MultiplexLogger=o;class s extends O.Disposable{constructor(P,D,_){if(super(),this.logLevel=P,this.logsHome=D,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,_)for(const U of _)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(P){return(0,c.isString)(P)?[...this._loggers.values()].find(D=>D.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,D){const _=this.toResource(P),U=(0,c.isString)(P)?P:D?.id??(0,r.hash)(_.toString()).toString(16);let F=this._loggers.get(_)?.logger;const H=D?.logLevel==="always"?y.Trace:D?.logLevel;F||(F=this.doCreateLogger(_,H??this.getLogLevel(_)??this.logLevel,{...D,id:U}));const j={logger:F,info:{resource:_,id:U,logLevel:H,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(j.info),this._loggers.set(_,j),F}toResource(P){return(0,c.isString)(P)?(0,g.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,D){if(v.URI.isUri(P)){const _=P,U=D,F=this._loggers.get(_);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.logLevel?void 0:U,F.logger?.setLevel(U),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([_,U]))}else{this.logLevel=P;for(const[_,U]of this._loggers.entries())this._loggers.get(_)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,D){const _=this.getLoggerEntry(P);_&&D!==!_.info.hidden&&(_.info.hidden=!D,this._loggers.set(_.info.resource,_),this._onDidChangeVisibility.fire([_.info.resource,D]))}getLogLevel(P){let D;return P&&(D=this._loggers.get(P)?.info.logLevel),D??this.logLevel}registerLogger(P){const D=this._loggers.get(P.resource);D?D.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const D=this._loggers.get(P);D&&(D.logger&&D.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(P){}getLevel(){return y.Info}trace(P,...D){}debug(P,...D){}info(P,...D){}warn(P,...D){}error(P,...D){}critical(P,...D){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function l(k){if(k.verbose)return y.Trace;if(typeof k.logLevel=="string"){const P=R(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function S(k){switch(k){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=S;function R(k){switch(k){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=R,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",S(y.Info))});var re=this&&this.__param||function(K,e){return function(I,L){e(I,L,K)}};define(ae[220],ce([0,1,14,4,5]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const O=I.safeStorage;let M=class{constructor(g){this.logService=g,I.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(g){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(O.encryptString(g));return this.logService.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.logService.error(c),c}}async decrypt(g){let c;try{if(c=JSON.parse(g),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${g}`);const v=Buffer.from(c.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const b=O.decryptString(v);return this.logService.trace("[EncryptionMainService] Decrypted value."),b}catch(v){throw this.logService.error(v),v}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const g=O.getSelectedStorageBackend();return Promise.resolve(g)}catch(g){this.logService.error(g)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=M,e.EncryptionMainService=M=be([re(0,r.ILogService)],M)}),define(ae[221],ce([0,1,22,8,15,3,2,9,66,5]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends M.Disposable{constructor(w,h){super(),this.logService=w,this.options=h,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(w,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,h):this.watchNonRecursive(w,h)}watchUniversal(w,h){const p={path:this.toFilePath(w),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},y=(0,I.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,r.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,g.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const h of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const h of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(h)&&w.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,h){const p={path:this.toFilePath(w),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},y=(0,I.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,r.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,g.reviveFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,C.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(ae[222],ce([0,1,22,8,17,23,3,45,71,2,59,13,67,19,63,175,16,120,5,15]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends c.Disposable{static{m=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new M.Emitter),this._onDidUncorrelatedFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${o}`);const i=new c.DisposableStore;return this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s}),i.add(s.onDidChangeFile(n=>{const l=new E.FileChangesEvent(n,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(l),l.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(l)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,c.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){s.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new E.FileOperationError((0,y.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const i=new f.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,o.toString()),i}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasReadWriteCapability)(s)||(0,E.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(i){throw(0,E.toFileSystemProviderErrorCode)(i)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,y.localize)(2,null,this.resourceForError(o)),1):(0,E.ensureFileSystemProviderError)(i)}}async doResolveFile(o,s){const i=await this.withProvider(o),n=this.isPathCaseSensitive(i),l=s?.resolveTo,S=s?.resolveSingleChildDescendants,R=s?.resolveMetadata,k=await i.stat(o);let P;return this.toFileStat(i,o,k,void 0,!!R,(D,_)=>(P||(P=v.TernarySearchTree.forUris(()=>!n),P.set(o,!0),l&&P.fill(!0,l)),P.get(D.resource)||P.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&S?_===1:!1))}async toFileStat(o,s,i,n,l,S){const{providerExtUri:R}=this.getExtUri(o),k={resource:s,name:R.basename(s),isFile:(i.type&E.FileType.File)!==0,isDirectory:(i.type&E.FileType.Directory)!==0,isSymbolicLink:(i.type&E.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&E.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&E.FilePermission.Locked),etag:(0,E.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&S(k,n)){try{const P=await o.readdir(s),D=await L.Promises.settled(P.map(async([_,U])=>{try{const F=R.joinPath(s,_),H=l?await o.stat(F):{type:U};return await this.toFileStat(o,F,H,P.length,l,S)}catch(F){return this.logService.trace(F),null}}));k.children=(0,I.coalesce)(D)}catch(P){this.logService.trace(P),k.children=[]}return k}return k}async resolveAll(o){return L.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.withProvider(o),i=await s.stat(o);return this.toFileStat(s,o,i,void 0,!0,()=>!1)}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(i){return i}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new E.FileOperationError((0,y.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=r.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,n)),n}async writeFile(o,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:l}=this.getExtUri(n);let S=i;if((0,E.hasFileAtomicWriteCapability)(n)&&!S?.atomic){const R=n.enforceAtomicWriteFile?.(o);R&&(S={...i,atomic:R})}try{await this.validateWriteFile(n,o,S)||await this.mkdirp(n,l.dirname(o));let k;if((0,E.hasReadWriteCapability)(n)&&!(s instanceof r.VSBuffer))if((0,p.isReadableStream)(s)){const P=await(0,p.peekStream)(s,3);P.ended?k=r.VSBuffer.concat(P.buffer):k=P}else k=(0,p.peekReadable)(s,P=>r.VSBuffer.concat(P),3);else k=s;!(0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)&&k instanceof r.VSBuffer||(0,E.hasReadWriteCapability)(n)&&(0,E.hasFileAtomicWriteCapability)(n)&&S?.atomic?await this.doWriteUnbuffered(n,o,S,k):await this.doWriteBuffered(n,o,S,k instanceof r.VSBuffer?(0,r.bufferToReadable)(k):k),this._onDidRunOperation.fire(new E.FileOperationEvent(o,4))}catch(R){throw new E.FileOperationError((0,y.localize)(4,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(R).toString()),(0,E.toFileOperationResult)(R),S)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(s)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(s)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.resourceForError(s)));if(n)throw new Error((0,y.localize)(8,null,this.resourceForError(s)))}let S;try{S=await o.stat(s)}catch{return}if(S.type&E.FileType.Directory)throw new E.FileOperationError((0,y.localize)(9,null,this.resourceForError(s)),0,i);if(this.throwIfFileIsReadonly(s,S),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==E.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&i.mtime<S.mtime&&i.etag!==(0,E.etag)({mtime:i.mtime,size:S.size}))throw new E.FileOperationError((0,y.localize)(10,null),3,i);return S}async readFile(o,s,i){const n=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(n,o,s,i):this.doReadFile(n,o,s,i)}async doReadFileAtomic(o,s,i,n){return new Promise((l,S)=>{this.writeQueue.queueFor(s,async()=>{try{const R=await this.doReadFile(o,s,i,n);l(R)}catch(R){S(R)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,s,i,n){const l=await this.doReadFileStream(o,s,{...i,preferUnbuffered:!0},n);return{...l,value:await(0,r.streamToBuffer)(l.value)}}async readFileStream(o,s,i){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,s,i)}async doReadFileStream(o,s,i,n){const l=new O.CancellationTokenSource(n);let S=i;(0,E.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(s)&&(S={...i,atomic:!0});const R=this.validateReadFile(s,S).then(P=>P,P=>{throw l.dispose(!0),P});let k;try{return typeof S?.etag=="string"&&S.etag!==E.ETAG_DISABLED&&await R,S?.atomic&&(0,E.hasFileAtomicReadCapability)(o)||!((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasFileReadStreamCapability)(o))||(0,E.hasReadWriteCapability)(o)&&S?.preferUnbuffered?k=this.readFileUnbuffered(o,s,S):(0,E.hasFileReadStreamCapability)(o)?k=this.readFileStreamed(o,s,l.token,S):k=this.readFileBuffered(o,s,l.token,S),k.on("end",()=>l.dispose()),k.on("error",()=>l.dispose()),{...await R,value:k}}catch(P){throw k&&await(0,p.consumeStream)(k),this.restoreReadError(P,s,S)}}restoreReadError(o,s,i){const n=(0,y.localize)(11,null,this.resourceForError(s),(0,E.ensureFileSystemProviderError)(o).toString());return o instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(n,o.stat,i):o instanceof E.TooLargeFileOperationError?new E.TooLargeFileOperationError(n,o.fileOperationResult,o.size,o.options):new E.FileOperationError(n,(0,E.toFileOperationResult)(o),i)}readFileStreamed(o,s,i,n=Object.create(null)){const l=o.readFileStream(s,n,i);return(0,p.transform)(l,{data:S=>S instanceof r.VSBuffer?S:r.VSBuffer.wrap(S),error:S=>this.restoreReadError(S,s,n)},S=>r.VSBuffer.concat(S))}readFileBuffered(o,s,i,n=Object.create(null)){const l=(0,r.newWriteableBufferStream)();return(0,u.readFileIntoStream)(o,s,l,S=>S,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:S=>this.restoreReadError(S,s,n)},i),l}readFileUnbuffered(o,s,i){const n=(0,p.newWriteableStream)(l=>r.VSBuffer.concat(l));return(async()=>{try{let l;i?.atomic&&(0,E.hasFileAtomicReadCapability)(o)?l=await o.readFile(s,{atomic:!0}):l=await o.readFile(s),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.validateReadFileLimits(s,l.byteLength,i),n.end(r.VSBuffer.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async validateReadFile(o,s){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new E.FileOperationError((0,y.localize)(12,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==E.ETAG_DISABLED&&s.etag===i.etag)throw new E.NotModifiedSinceFileOperationError((0,y.localize)(13,null),i,s);return this.validateReadFileLimits(o,i.size,s),i}validateReadFileLimits(o,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new E.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(o)),7,s,i)}async canMove(o,s,i){return this.doCanMoveCopy(o,s,"move",i)}async canCopy(o,s,i){return this.doCanMoveCopy(o,s,"copy",i)}async doCanMoveCopy(o,s,i,n){if(o.toString()!==s.toString())try{const l=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),S=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(l,o,S,s,i,n)}catch(l){return l}return!0}async move(o,s,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(n,o,l,s,"move",!!i),R=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,S==="move"?2:3,R)),R}async copy(o,s,i){const n=await this.withReadProvider(o),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(n,o,l,s,"copy",!!i),R=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,S==="copy"?3:2,R)),R}async doMoveCopy(o,s,i,n,l,S){if(s.toString()===n.toString())return l;const{exists:R,isSameResourceWithDifferentPathCase:k}=await this.doValidateMoveCopy(o,s,i,n,l,S);if(R&&!k&&S&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),l==="copy"){if(o===i&&(0,E.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:S});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,i,n):await this.doCopyFile(o,s,i,n)}return l}else return o===i?(await o.rename(s,n,{overwrite:S}),l):(await this.doMoveCopy(o,s,i,n,"copy",S),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,i,n){if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,s,i,n);if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,s,i,n);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,s,i,n);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,s,i,n)}async doCopyFolder(o,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async l=>{const S=this.getExtUri(i).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.doCopyFolder(o,await this.resolve(l.resource),i,S):this.doCopyFile(o,l.resource,i,S)}))}async doValidateMoveCopy(o,s,i,n,l,S){let R=!1;if(o===i){const{providerExtUri:P,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(R=P.isEqual(s,n)),R&&l==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(s),this.resourceForError(n)));if(!R&&P.isEqualOrParent(n,s))throw new Error((0,y.localize)(16,null,this.resourceForError(s),this.resourceForError(n)))}const k=await this.exists(n);if(k&&!R){if(!S)throw new E.FileOperationError((0,y.localize)(17,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===i){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,n))throw new Error((0,y.localize)(18,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:R}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,i)),i}async mkdirp(o,s){const i=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await o.stat(s)).type&E.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(s)));break}catch(l){if((0,E.toFileSystemProviderErrorCode)(l)!==E.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(n.basename(s)),s=n.dirname(s)}for(let l=i.length-1;l>=0;l--){s=n.joinPath(s,i[l]);try{await o.mkdir(s)}catch(S){if((0,E.toFileSystemProviderErrorCode)(S)!==E.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(i){return i}return!0}async doValidateDelete(o,s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),n=!!s?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.resourceForError(o)));const l=s?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.resourceForError(o)));if(n&&l)throw new Error((0,y.localize)(22,null,this.resourceForError(o)));let S;try{S=await i.stat(o)}catch{}if(S)this.throwIfFileIsReadonly(o,S);else throw new E.FileOperationError((0,y.localize)(23,null,this.resourceForError(o)),1);if(!!!s?.recursive){const k=await this.resolve(o);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(o)))}return i}async del(o,s){const i=await this.doValidateDelete(o,s);let n=s;if((0,E.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const k=i.enforceAtomicDelete?.(o);k&&(n={...s,atomic:k})}const l=!!n?.useTrash,S=!!n?.recursive,R=n?.atomic??!1;await i.delete(o,{recursive:S,useTrash:l,atomic:R}),this._onDidRunOperation.fire(new E.FileOperationEvent(o,1))}async cloneFile(o,s){const i=await this.withProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(!(i===n&&this.getExtUri(i).providerExtUri.isEqual(o,s)))return i===n&&(0,E.hasFileCloneCapability)(i)?i.cloneFile(o,s):(await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),i===n&&(0,E.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(o,()=>i.copy(o,s,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(i,o,n,s),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:m.WATCHER_CORRELATION_IDS++})}watch(o,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,l=()=>{n=!0};i.add((0,c.toDisposable)(()=>l())),(async()=>{try{const R=await this.doWatch(o,s);n?(0,c.dispose)(R):l=()=>(0,c.dispose)(R)}catch(R){this.logService.error(R)}})();const S=s.correlationId;if(typeof S=="number"){const R=i.add(new M.Emitter);return i.add(this.internalOnDidFilesChange.event(P=>{P.correlates(S)&&R.fire(P)})),{onDidChange:R.event,dispose:()=>i.dispose()}}return i}async doWatch(o,s){const i=await this.withProvider(o),n=(0,C.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(o),s]);let l=this.activeWatchers.get(n);return l||(l={count:0,disposable:i.watch(o,s)},this.activeWatchers.set(n,l)),l.count+=1,(0,c.toDisposable)(()=>{l&&(l.count--,l.count===0&&((0,c.dispose)(l.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,i,n){return this.writeQueue.queueFor(s,async()=>{const l=await o.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(n)||(0,p.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,l,n):await this.doWriteReadableBufferedQueued(o,l,n)}catch(S){throw(0,E.ensureFileSystemProviderError)(S)}finally{await o.close(l)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,s,i){let n=0,l;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const S=r.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,s,S,S.byteLength,n,0),n+=S.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((S,R)=>{(0,p.listenStream)(l,{onData:async k=>{l.pause();try{await this.doWriteBuffer(o,s,k,k.byteLength,n,0)}catch(P){return R(P)}n+=k.byteLength,setTimeout(()=>l.resume())},onError:k=>R(k),onEnd:()=>S()})})}async doWriteReadableBufferedQueued(o,s,i){let n=0,l;for(;(l=i.read())!==null;)await this.doWriteBuffer(o,s,l,l.byteLength,n,0),n+=l.byteLength}async doWriteBuffer(o,s,i,n,l,S){let R=0;for(;R<n;){const k=await o.write(s,l+R,i.buffer,S+R,n-R);R+=k}}async doWriteUnbuffered(o,s,i,n){return this.writeQueue.queueFor(s,()=>this.doWriteUnbufferedQueued(o,s,i,n),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,s,i,n){let l;n instanceof r.VSBuffer?l=n:(0,p.isReadableStream)(n)?l=await(0,r.streamToBuffer)(n):(0,p.isReadableBufferedStream)(n)?l=await(0,r.bufferedStreamToBuffer)(n):l=(0,r.readableToBuffer)(n),await o.writeFile(s,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(o,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeBufferedQueued(o,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(o,s,i,n){let l,S;try{l=await o.open(s,{create:!1}),S=await i.open(n,{create:!0,unlock:!1});const R=r.VSBuffer.alloc(this.BUFFER_SIZE);let k=0,P=0,D=0;do D=await o.read(l,k,R.buffer,P,R.byteLength-P),await this.doWriteBuffer(i,S,R,D,k,P),k+=D,P+=D,P===R.byteLength&&(P=0);while(D>0)}catch(R){throw(0,E.ensureFileSystemProviderError)(R)}finally{await L.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof S=="number"?i.close(S):Promise.resolve()])}}async doPipeUnbuffered(o,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedQueued(o,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(o,s,i,n){return i.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,s,i,n){return this.writeQueue.queueFor(n,()=>this.doPipeUnbufferedToBufferedQueued(o,s,i,n),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,s,i,n){const l=await i.open(n,{create:!0,unlock:!1});try{const S=await o.readFile(s);await this.doWriteBuffer(i,l,r.VSBuffer.wrap(S),S.byteLength,0,0)}catch(S){throw(0,E.ensureFileSystemProviderError)(S)}finally{await i.close(l)}}async doPipeBufferedToUnbuffered(o,s,i,n){const l=await(0,r.streamToBuffer)(this.readFileBuffered(o,s,O.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,l)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new E.FileOperationError((0,y.localize)(25,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,y.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=a,e.FileService=a=m=be([re(0,d.ILogService)],a)}),define(ae[94],ce([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,120,221,51,217,216]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class t extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new O.ResourceMap(n=>w.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:n}=await p.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:E.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await p.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async l=>{try{let S;l.isSymbolicLink()?S=(await this.stat((0,w.joinPath)(s,l.name))).type:S=this.toType(l),n.push([l.name,S])}catch(S){this.logService.trace(S)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let n;return i?.dangling?n=E.FileType.Unknown:s.isFile()?n=E.FileType.File:s.isDirectory()?n=E.FileType.Directory:n=E.FileType.Unknown,i&&(n|=E.FileType.SymbolicLink),n}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const l=new r.Barrier;return this.resourceLocks.set(s,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const l=this.toFilePath(s);return await p.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{n?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,n){const l=(0,h.newWriteableStream)(S=>M.VSBuffer.concat(S.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,u.readFileIntoStream)(this,s,l,S=>S.buffer,{...i,bufferSize:256*1024},n),l}async writeFile(s,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,w.joinPath)((0,w.dirname)(s),`${(0,w.basename)(s)}${n.atomic.postfix}`),i,n):this.doWriteFile(s,i,n)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:n}=await p.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,i,n,l){const S=new c.DisposableStore;try{S.add(await this.createResourceLock(s)),S.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,l,!0);try{await this.rename(i,s,{overwrite:!0})}catch(R){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{S.dispose()}}async doWriteFile(s,i,n,l){let S;try{const R=this.toFilePath(s);if(!n.create||!n.overwrite){if(await p.Promises.exists(R)){if(!n.overwrite)throw(0,E.createFileSystemProviderError)((0,y.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,E.createFileSystemProviderError)((0,y.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:n.unlock},l),await this.write(S,0,i,0,i.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(s,R)}finally{typeof S=="number"&&await this.close(S)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,n){const l=this.toFilePath(s);let S;(0,E.isFileOpenForWriteOptions)(i)&&!n&&(S=await this.createResourceLock(s));let R;try{if((0,E.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await p.SymlinkSupport.stat(l);P.mode&128||await p.Promises.chmod(l,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}let k;if((0,E.isFileOpenForWriteOptions)(i)){if(b.isWindows)try{await p.Promises.truncate(l,0),k="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}k||(k="w")}else k="r";R=await p.Promises.open(l,k)}catch(k){throw S?.dispose(),(0,E.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,k):this.toFileSystemProviderError(k)}if(this.mapHandleToPos.set(R,0),(0,E.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(R,s),S){const k=this.mapHandleToLock.get(R);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${l})`),this.mapHandleToLock.set(R,S),k&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${l})`),k.dispose())}return R}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await p.Promises.fdatasync(s)}catch(n){t.configureFlushOnWrite(!1),this.logService.error(n)}return await p.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,n,l,S){const R=this.normalizePos(s,i);let k=null;try{k=(await p.Promises.read(s,n,l,S,R)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(s,R,k)}return k}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,n){const l=this.mapHandleToPos.get(s);typeof l=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,l+n):this.mapHandleToPos.delete(s)))}async write(s,i,n,l,S){return(0,r.retry)(()=>this.doWrite(s,i,n,l,S),100,3)}async doWrite(s,i,n,l,S){const R=this.normalizePos(s,i);let k=null;try{k=(await p.Promises.write(s,n,l,S,R)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),P)}finally{this.updatePos(s,R,k)}return k}async mkdir(s){try{await p.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const n=this.toFilePath(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,v.join)((0,v.dirname)(n),`${(0,v.basename)(n)}${i.atomic.postfix}`)),await p.Promises.rm(n,p.RimRafMode.MOVE,l)}else try{await p.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let S=!1;try{const{stat:R,symbolicLink:k}=await p.SymlinkSupport.stat(n);S=R.isDirectory()&&!k}catch{}if(S)await p.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,i,n){const l=this.toFilePath(s),S=this.toFilePath(i);if(l!==S)try{await this.validateMoveCopy(s,i,"move",n.overwrite),await p.Promises.rename(l,S)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(2,null,(0,v.basename)(l),(0,v.basename)((0,v.dirname)(S)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,i,n){const l=this.toFilePath(s),S=this.toFilePath(i);if(l!==S)try{await this.validateMoveCopy(s,i,"copy",n.overwrite),await p.Promises.copy(l,S,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(3,null,(0,v.basename)(l),(0,v.basename)((0,v.dirname)(S)),R.toString()))),this.toFileSystemProviderError(R)}}async validateMoveCopy(s,i,n,l){const S=this.toFilePath(s),R=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,g.isEqual)(S,R,!0)),k){if(n==="copy")throw(0,E.createFileSystemProviderError)((0,y.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const D=await this.statIgnoreError(s);if(!D)throw(0,E.createFileSystemProviderError)((0,y.localize)(5,null),E.FileSystemProviderErrorCode.FileNotFound);const _=await this.statIgnoreError(i);if(_){if(!l)throw(0,E.createFileSystemProviderError)((0,y.localize)(6,null),E.FileSystemProviderErrorCode.FileExists);D.type&E.FileType.File&&_.type&E.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,n){const l=this.toFilePath(s),S=this.toFilePath(i),R=!!(this.capabilities&1024);if((0,g.isEqual)(l,S,!R))return;const k=new c.DisposableStore;try{k.add(await this.createResourceLock(s)),k.add(await this.createResourceLock(i)),n&&await p.Promises.mkdir((0,v.dirname)(S),{recursive:!0}),await p.Promises.copyFile(l,S)}catch(P){if(P.code==="ENOENT"&&!n)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(P)}finally{k.dispose()}}createUniversalWatcher(s,i,n){return new m.UniversalWatcherClient(l=>s(l),l=>i(l),n)}createNonRecursiveWatcher(s,i,n){return new a.NodeJSWatcherClient(l=>s(l),l=>i(l),n)}toFileSystemProviderError(s){if(s instanceof E.FileSystemProviderError)return s;let i=s,n;switch(s.code){case"ENOENT":n=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=E.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=E.FileSystemProviderErrorCode.Unknown;break;default:n=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(s,i){let n=this.toFileSystemProviderError(i);if(s&&n.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.toFilePath(s));l.mode&128||(n=(0,E.createFileSystemProviderError)(i,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return n}}e.DiskFileSystemProvider=t}),define(ae[223],ce([0,1,3,94,2,17,63,23]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends r.Disposable{constructor(b,w){super(),this.provider=b,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(b,w,h){const p=this.getUriTransformer(b);switch(w){case"stat":return this.stat(p,h[0]);case"readdir":return this.readdir(p,h[0]);case"open":return this.open(p,h[0],h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(p,h[0],h[1]);case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(p,h[0],h[1],h[2]);case"rename":return this.rename(p,h[0],h[1],h[2]);case"copy":return this.copy(p,h[0],h[1],h[2]);case"cloneFile":return this.cloneFile(p,h[0],h[1]);case"mkdir":return this.mkdir(p,h[0]);case"delete":return this.delete(p,h[0],h[1]);case"watch":return this.watch(p,h[0],h[1],h[2],h[3]);case"unwatch":return this.unwatch(h[0],h[1])}throw new Error(`IPC Command ${w} not found`)}listen(b,w,h){const p=this.getUriTransformer(b);switch(w){case"fileChange":return this.onFileChange(p,h[0]);case"readFileStream":return this.onReadFileStream(p,h[0],h[1])}throw new Error(`Unknown event ${w}`)}stat(b,w){const h=this.transformIncoming(b,w,!0);return this.provider.stat(h)}readdir(b,w){const h=this.transformIncoming(b,w);return this.provider.readdir(h)}async readFile(b,w,h){const p=this.transformIncoming(b,w,!0),y=await this.provider.readFile(p,h);return O.VSBuffer.wrap(y)}onReadFileStream(b,w,h){const p=this.transformIncoming(b,w,!0),y=new C.CancellationTokenSource,E=new I.Emitter({onDidRemoveLastListener:()=>{y.cancel()}}),u=this.provider.readFileStream(p,h,y.token);return(0,M.listenStream)(u,{onData:d=>E.fire(O.VSBuffer.wrap(d)),onError:d=>E.fire(d),onEnd:()=>{E.fire("end"),E.dispose(),y.dispose()}}),E.event}writeFile(b,w,h,p){const y=this.transformIncoming(b,w);return this.provider.writeFile(y,h.buffer,p)}open(b,w,h){const p=this.transformIncoming(b,w,!0);return this.provider.open(p,h)}close(b){return this.provider.close(b)}async read(b,w,h){const p=O.VSBuffer.alloc(h),E=await this.provider.read(b,w,p.buffer,0,h);return[p,E]}write(b,w,h,p,y){return this.provider.write(b,w,h.buffer,p,y)}mkdir(b,w){const h=this.transformIncoming(b,w);return this.provider.mkdir(h)}delete(b,w,h){const p=this.transformIncoming(b,w);return this.provider.delete(p,h)}rename(b,w,h,p){const y=this.transformIncoming(b,w),E=this.transformIncoming(b,h);return this.provider.rename(y,E,p)}copy(b,w,h,p){const y=this.transformIncoming(b,w),E=this.transformIncoming(b,h);return this.provider.copy(y,E,p)}cloneFile(b,w,h){const p=this.transformIncoming(b,w),y=this.transformIncoming(b,h);return this.provider.cloneFile(p,y)}onFileChange(b,w){const h=new I.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(b,h))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return h.event}async watch(b,w,h,p,y){const E=this.sessionToWatcher.get(w);if(E){const u=this.transformIncoming(b,p),d=E.watch(h,u,y);this.watchRequests.set(w+h,d)}}async unwatch(b,w){const h=b+w,p=this.watchRequests.get(h);p&&((0,r.dispose)(p),this.watchRequests.delete(h))}dispose(){super.dispose();for(const[,b]of this.watchRequests)b.dispose();this.watchRequests.clear();for(const[,b]of this.sessionToWatcher)b.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class c extends r.Disposable{constructor(b,w,h,p){super(),this.uriTransformer=b,this.logService=h,this.environmentService=p,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(b){const w=this._register(new I.Emitter);this._register(w.event(h=>{b.fire(h.map(p=>({resource:this.uriTransformer.transformOutgoingURI(p.resource),type:p.type,cId:p.cId})))})),this._register(this.fileWatcher.onDidChangeFile(h=>w.fire(h))),this._register(this.fileWatcher.onDidWatchError(h=>b.fire(h)))}getRecursiveWatcherOptions(b){}getExtraExcludes(b){}watch(b,w,h){const p=this.getExtraExcludes(this.environmentService);return Array.isArray(p)&&(h.excludes=[...h.excludes,...p]),this.watcherRequests.set(b,this.fileWatcher.watch(w,h)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(b)),this.watcherRequests.delete(b)})}dispose(){for(const[,b]of this.watcherRequests)b.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=c}),define(ae[224],ce([0,1,14,178,4,7,16,9,223,155]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class v extends g.AbstractDiskFileSystemProviderChannel{constructor(h,p,y){super(h,p),this.environmentService=y}getUriTransformer(h){return c.DefaultURITransformer}transformIncoming(h,p){return O.URI.revive(p)}async delete(h,p,y){if(!y.useTrash)return super.delete(h,p,y);const E=this.transformIncoming(h,p),u=(0,C.normalize)(E.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,M.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,C.basename)(u)):(0,L.localize)(1,null,(0,C.basename)(u)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,p){return new b(h,p,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=v;class b extends g.AbstractSessionFileWatcher{watch(h,p,y){if(y.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(h,p,y)}}}),define(ae[225],ce([0,1,5]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends I.AbstractMessageLogger{constructor(O=I.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(O),this._register(this.onDidChangeLogLevel(M=>{this._logger?.setLevel(M)}))}set logger(O){this._logger=O;for(const{level:M,message:C}of this.buffer)(0,I.log)(O,M,C);this.buffer=[]}log(O,M){this._logger?(0,I.log)(this._logger,O,M):this.getLevel()<=O&&this.buffer.push({level:O,message:M})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(ae[226],ce([0,1,7,3,5,2]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends r.AbstractLoggerService{constructor(b,w,h,p,y){super(w,h,p),this.windowId=b,this.channel=y,this._register(y.listen("onDidChangeLogLevel",b)(E=>{(0,r.isLogLevel)(E)?super.setLogLevel(E):super.setLogLevel(I.URI.revive(E[0]),E[1])})),this._register(y.listen("onDidChangeVisibility",b)(([E,u])=>super.setVisibility(I.URI.revive(E),u))),this._register(y.listen("onDidChangeLoggers",b)(({added:E,removed:u})=>{for(const d of E)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(b,w)=>{this.channel.call("consoleLog",[b,w])}})}registerLogger(b){super.registerLogger(b),this.channel.call("registerLogger",[b,this.windowId])}deregisterLogger(b){super.deregisterLogger(b),this.channel.call("deregisterLogger",[b,this.windowId])}setLogLevel(b,w){super.setLogLevel(b,w),this.channel.call("setLogLevel",[b,w])}setVisibility(b,w){super.setVisibility(b,w),this.channel.call("setVisibility",[this.toResource(b),w])}doCreateLogger(b,w,h){return new C(this.channel,b,w,h,this.windowId)}static setLogLevel(b,w,h){return b.call("setLogLevel",[w,h])}}e.LoggerChannelClient=M;class C extends r.AbstractMessageLogger{constructor(b,w,h,p,y){super(p?.logLevel==="always"),this.channel=b,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[w,p,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,w){const h=[[b,w]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(b){this.channel.call("log",[this.file,b])}}class g{constructor(b,w){this.loggerService=b,this.getUriTransformer=w}listen(b,w){const h=this.getUriTransformer(b);switch(w){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,p=>({added:[...p.added].map(y=>this.transformLogger(y,h)),removed:[...p.removed].map(y=>this.transformLogger(y,h))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,p=>[h.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,p=>(0,r.isLogLevel)(p)?p:[h.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${w}`)}async call(b,w,h){const p=this.getUriTransformer(b);switch(w){case"setLogLevel":return(0,r.isLogLevel)(h[0])?this.loggerService.setLogLevel(h[0]):this.loggerService.setLogLevel(I.URI.revive(p.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,p)))}throw new Error(`Call not found: ${w}`)}transformLogger(b,w){return{...b,resource:w.transformOutgoingURI(b.resource)}}}e.LoggerChannel=g;class c extends O.Disposable{constructor(b,w){super(),w.call("setLogLevel",[b.getLogLevel()]),this._register(b.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const p of h)b.registerLogger({...p,resource:I.URI.revive(p.resource)})}),this._register(w.listen("onDidChangeVisibility")(([h,p])=>b.setVisibility(I.URI.revive(h),p))),this._register(w.listen("onDidChangeLoggers")(({added:h,removed:p})=>{for(const y of h)b.registerLogger({...y,resource:I.URI.revive(y.resource)});for(const y of p)b.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=c}),define(ae[227],ce([0,1,2,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends I.Disposable{constructor(M,C=[]){super(),this.logger=new L.MultiplexLogger([M,...C]),this._register(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...C){this.logger.trace(M,...C)}debug(M,...C){this.logger.debug(M,...C)}info(M,...C){this.logger.info(M,...C)}warn(M,...C){this.logger.warn(M,...C)}error(M,...C){this.logger.error(M,...C)}flush(){this.logger.flush()}}e.LogService=r}),define(ae[228],ce([0,1,31,7,5]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class O{constructor(C){this.loggerService=C,this.loggers=new I.ResourceMap}listen(C,g,c){switch(g){case"onDidChangeLoggers":return c?this.loggerService.getOnDidChangeLoggersEvent(c):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.loggerService.getOnDidChangeLogLevelEvent(c):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.loggerService.getOnDidChangeVisibilityEvent(c):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(C,g,c){switch(g){case"createLogger":this.createLogger(L.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.log(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1]);case"setLogLevel":return(0,r.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(L.URI.revive(c[0]),c[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(c[0]),c[1]);case"registerLogger":return this.loggerService.registerLogger({...c[0],resource:L.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(c[0]))}throw new Error(`Call not found: ${g}`)}createLogger(C,g,c){this.loggers.set(C,this.loggerService.createLogger(C,g,c))}consoleLog(C,g){let c=console.log;switch(C){case r.LogLevel.Error:c=console.error;break;case r.LogLevel.Warning:c=console.warn;break;case r.LogLevel.Info:c=console.info;break}c.call(console,...g)}log(C,g){const c=this.loggers.get(C);if(!c)throw new Error("Create the logger before logging");for(const[v,b]of g)(0,r.log)(c,v,b)}}e.LoggerChannel=O}),define(ae[229],ce([0,1,16,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(r||(r={}));async function O(c,v,b,w,h){try{const p=await new Promise((E,u)=>{K(["@vscode/spdlog"],E,u)});p.setFlushOn(r.Trace);const y=await p.createAsyncRotatingLogger(c,v,b,w);return h?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(p){console.error(p)}return null}function M(c,v,b){switch(v){case L.LogLevel.Trace:c.trace(b);break;case L.LogLevel.Debug:c.debug(b);break;case L.LogLevel.Info:c.info(b);break;case L.LogLevel.Warning:c.warn(b);break;case L.LogLevel.Error:c.error(b);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function C(c,v){switch(v){case L.LogLevel.Trace:c.setLevel(r.Trace);break;case L.LogLevel.Debug:c.setLevel(r.Debug);break;case L.LogLevel.Info:c.setLevel(r.Info);break;case L.LogLevel.Warning:c.setLevel(r.Warning);break;case L.LogLevel.Error:c.setLevel(r.Error);break;case L.LogLevel.Off:c.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class g extends L.AbstractMessageLogger{constructor(v,b,w,h,p){super(),this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(v,b,w,h),this._register(this.onDidChangeLogLevel(y=>{this._logger&&C(this._logger,y)}))}async _createSpdLogLogger(v,b,w,h){const p=w?6:1,y=30/p*I.ByteSize.MB,E=await O(v,b,y,p,h);if(E){this._logger=E,C(this._logger,this.getLevel());for(const{level:u,message:d}of this.buffer)M(this._logger,u,d);this.buffer=[]}}log(v,b){this._logger?M(this._logger,v,b):this.getLevel()<=v&&this.buffer.push({level:v,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=g}),define(ae[230],ce([0,1,32,5,229]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class O extends L.AbstractLoggerService{doCreateLogger(C,g,c){return new r.SpdLogLogger((0,I.generateUuid)(),C.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,g)}}e.LoggerService=O}),define(ae[68],ce([0,1,31,3,6,5,230]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(O.ILoggerService);class C extends M.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new I.ResourceMap}createLogger(c,v,b){b!==void 0&&this.loggerResourcesByWindow.set(this.toResource(c),b);try{return super.createLogger(c,v)}catch(w){throw this.loggerResourcesByWindow.delete(this.toResource(c)),w}}registerLogger(c,v){v!==void 0&&this.loggerResourcesByWindow.set(c.resource,v),super.registerLogger(c)}deregisterLogger(c){this.loggerResourcesByWindow.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const v=[];for(const b of super.getRegisteredLoggers())c===this.loggerResourcesByWindow.get(b.resource)&&v.push(b);return v}getOnDidChangeLogLevelEvent(c){return L.Event.filter(this.onDidChangeLogLevel,v=>(0,O.isLogLevel)(v)||this.isInterestedLoggerResource(v[0],c))}getOnDidChangeVisibilityEvent(c){return L.Event.filter(this.onDidChangeVisibility,([v])=>this.isInterestedLoggerResource(v,c))}getOnDidChangeLoggersEvent(c){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,v=>({added:[...v.added].filter(w=>this.isInterestedLoggerResource(w.resource,c)),removed:[...v.removed].filter(w=>this.isInterestedLoggerResource(w.resource,c))})),v=>v.added.length>0||v.removed.length>0)}deregisterLoggers(c){for(const[v,b]of this.loggerResourcesByWindow)b===c&&this.deregisterLogger(v)}isInterestedLoggerResource(c,v){const b=this.loggerResourcesByWindow.get(c);return b===void 0||b===v}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=C}),define(ae[231],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function L(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function O(M){return!I(M)&&!L(M)&&!r(M)}e.isMenubarMenuItemAction=O}),define(ae[39],ce([0,1,3,71,2,6]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class M extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(c){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...c,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(c),L.Iterable.reduce(this.policies.entries(),(b,[w,h])=>({...b,[w]:h}),{})}getPolicyValue(c){return this.policies.get(c)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(c,[v,b])=>({...c,[v]:{definition:b,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=M;class C{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(ae[232],ce([0,1,8,3,71,12,16,5,39]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(b,w){const h=[];for(const p of new Set(r.Iterable.concat(b.keys(),w.keys())))b.get(p)!==w.get(p)&&h.push(p);return h}let v=class extends g.AbstractPolicyService{constructor(w,h,p){super(),this.file=w,this.fileService=h,this.logService=p,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const y=L.Event.filter(h.onDidFilesChange,E=>E.affects(w));this._register(h.watch(w)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const w=new Map;try{const h=await this.fileService.readFile(this.file),p=JSON.parse(h.value.toString());if(!(0,O.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(p))this.policyDefinitions[y]&&w.set(y,p[y])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return w}async refresh(){const w=await this.read(),h=c(this.policies,w);this.policies=w,h.length>0&&this._onDidChange.fire(h)}};e.FilePolicyService=v,e.FilePolicyService=v=be([re(1,M.IFileService),re(2,C.ILogService)],v)}),define(ae[233],ce([0,1,3,2,39]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(g){this.service=g,this.disposables=new L.DisposableStore}listen(g,c){switch(c){case"onDidChange":return I.Event.map(this.service.onDidChange,v=>v.reduce((b,w)=>({...b,[w]:this.service.getPolicyValue(w)??null}),{}),this.disposables)}throw new Error(`Event not found: ${c}`)}call(g,c,v){switch(c){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(v)}throw new Error(`Call not found: ${c}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=O;class M extends r.AbstractPolicyService{constructor(g,c){super(),this.channel=c;for(const v in g){const{definition:b,value:w}=g[v];this.policyDefinitions[v]=b,w!==void 0&&this.policies.set(v,w)}this.channel.listen("onDidChange")(v=>{for(const b in v){const w=v[b];w===null?this.policies.delete(b):this.policies.set(b,w)}this._onDidChange.fire(Object.keys(v))})}async _updatePolicyDefinitions(g){const c=await this.channel.call("updatePolicyDefinitions",g);for(const v in c)this.policies.set(v,c[v])}}e.PolicyChannelClient=M}),define(ae[234],ce([0,1,39,8,2,5]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let M=class extends I.AbstractPolicyService{constructor(g,c){super(),this.logService=g,this.productName=c,this.throttler=new L.Throttler,this.watcher=this._register(new r.MutableDisposable)}async _updatePolicyDefinitions(g){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:c}=await new Promise((v,b)=>{K(["@vscode/policy-watcher"],v,b)});await this.throttler.queue(()=>new Promise((v,b)=>{try{this.watcher.value=c(this.productName,g,w=>{this._onDidPolicyChange(w),v()})}catch(w){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",w),b(w)}}))}_onDidPolicyChange(g){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const c in g){const v=g[c];v===void 0?this.policies.delete(c):this.policies.set(c,v)}this._onDidChange.fire(Object.keys(g))}};e.NativePolicyService=M,e.NativePolicyService=M=be([re(0,O.ILogService)],M)}),define(ae[79],ce([0,1,36]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.context<"u"){const O=r.context.configuration();if(O)L=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){L=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:O,searchUrl:M,itemUrl:C,controlUrl:g}=L.extensionsGallery||{};Object.assign(L,{extensionsGallery:{serviceUrl:I.env.VSCODE_GALLERY_SERVICE_URL||O,searchUrl:I.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:I.env.VSCODE_GALLERY_ITEM_URL||C,controlUrl:I.env.VSCODE_GALLERY_CONTROL_URL||g}});try{const c=(...b)=>b.reduce((w,h)=>(Object.keys(h).forEach(p=>{Array.isArray(w[p])&&Array.isArray(h[p])?w[p]=h[p]:typeof w[p]=="object"&&typeof h[p]=="object"?w[p]=c(w[p],h[p]):w[p]=h[p]}),w),{}),v=globalThis._VSCODE_USER_PRODUCT_JSON||{};L=c(L,v)}catch{}if(I.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:c.version,release:c.release})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ae[27],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ae[235],ce([0,1,8,5]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(M,C,g){this._window=M,this._sessionId=C,this._logService=g}async inspect(M){await this._connect();const C=this._window.webContents.debugger;await C.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,I.timeout)(M);const g=await C.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),g.profile}async _connect(){const M=this._window.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async _disconnect(){const M=this._window.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};e.WindowProfiler=r,e.WindowProfiler=r=be([re(2,L.ILogService)],r)}),define(ae[80],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ae[44],ce([0,1,138,12]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(M,C){I.ok(L.isString(M)),I.ok(L.isObject(C)),I.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,C)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new r}),define(ae[236],ce([0,1,3,44]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class O{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,c){this.schemasById[r(g)]=c,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new O;L.Registry.add(e.Extensions.JSONContribution,M)}),define(ae[52],ce([0,1,22,3,12,163,18,236,44]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v||(e.ConfigurationScope=v={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=g.Registry.as(C.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.doRegisterConfigurations(t,o,s),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(t,!1,s),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const s=[];for(const{overrides:i,source:n}of t)for(const l in i)if(o.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const S=this.configurationDefaultsOverrides.get(l),R=S?.valuesSources??new Map;if(n)for(const _ of Object.keys(i[l]))R.set(_,n);const k={...S?.value||{},...i[l]};this.configurationDefaultsOverrides.set(l,{source:n,value:k,valuesSources:R});const P=(0,M.getLanguageTagSettingPlainKey)(l),D={type:"object",default:k,description:O.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:r.isString(n)?void 0:n,defaultValueSource:n};s.push(...y(l)),this.configurationProperties[l]=D,this.defaultLanguageConfigurationOverridesNode.properties[l]=D}else{this.configurationDefaultsOverrides.set(l,{value:i[l],source:n});const S=this.configurationProperties[l];S&&(this.updatePropertyDefaultValue(l,S),this.updateSchema(l,S))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:s,source:i}of t)for(const n in s){const l=this.configurationDefaultsOverrides.get(n),S=r.isString(i)?i:i?.id,R=r.isString(l?.source)?l?.source:l?.source?.id;if(S===R)if(o.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const k=this.configurationProperties[n];k&&(this.updatePropertyDefaultValue(n,k),this.updateSchema(n,k))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,s){t.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,o){const s=i=>{if(i.properties)for(const n in i.properties){o.add(n);const l=this.configurationProperties[n];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>s(n))};for(const i of t){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(t,o=!0,s,i,n=3,l){n=r.isUndefinedOrNull(t.scope)?n:t.scope;const S=t.properties;if(S)for(const k in S){const P=S[k];if(o&&f(k,P)){delete S[k];continue}if(P.source=s,P.defaultDefaultValue=S[k].default,this.updatePropertyDefaultValue(k,P),e.OVERRIDE_PROPERTY_REGEX.test(k)?P.scope=void 0:(P.scope=r.isUndefinedOrNull(P.scope)?n:P.scope,P.restricted=r.isUndefinedOrNull(P.restricted)?!!i?.includes(k):P.restricted),S[k].hasOwnProperty("included")&&!S[k].included){this.excludedConfigurationProperties[k]=S[k],delete S[k];continue}else this.configurationProperties[k]=S[k],S[k].policy?.name&&this.policyConfigurations.set(S[k].policy.name,k);!S[k].deprecationMessage&&S[k].markdownDeprecationMessage&&(S[k].deprecationMessage=S[k].markdownDeprecationMessage),l.add(k)}const R=t.allOf;if(R)for(const k of R)this.validateAndRegisterProperties(k,o,s,i,n,l)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=s=>{const i=s.properties;if(i)for(const l in i)this.updateSchema(l,i[l]);s.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,n=s?.source;r.isUndefined(i)&&(i=o.defaultDefaultValue,n=void 0),r.isUndefined(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",p=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=p.exec(a);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=p.exec(a)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=y;function E(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=E;function u(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new w;g.Registry.add(e.Extensions.Configuration,d);function f(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?O.localize(7,null,a):d.getConfigurationProperties()[a]!==void 0?O.localize(8,null,a):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,a,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.validateProperty=f;function m(){const a=[],t=d.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=m}),define(ae[121],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(K,e,I,L,r,O,M,C,g,c,v,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(o){return Object.isFrozen(o)?o:C.deepFreeze(o)}class p{constructor(s={},i=[],n=[],l){this._contents=s,this._keys=i,this._overrides=n,this.raw=l,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof p)return i;const n=new y("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=s.reduce((i,n)=>n===i?n:i.merge(n),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,v.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const n=this;return{get value(){return h(n.rawConfiguration.getValue(s))},get override(){return i?h(n.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return h(i?n.rawConfiguration.override(i).getValue(s):n.rawConfiguration.getValue(s))},get overrides(){const l=[];for(const{contents:S,identifiers:R,keys:k}of n.rawConfiguration.overrides){const P=new p(S,k).getValue(s);P!==void 0&&l.push({identifiers:R,value:P})}return l.length?h(l):void 0}}}getOverrideValue(s,i){const n=this.getContentsForOverrideIdentifer(i);return n?s?(0,v.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const n of this.overrides)n.identifiers.includes(s)&&i.push(...n.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return I.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=C.deepClone(this.contents),n=C.deepClone(this.overrides),l=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const R of s)if(S.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.mergeContents(i,R.contents);for(const k of R.overrides){const[P]=n.filter(D=>I.equals(D.identifiers,k.identifiers));P?(this.mergeContents(P.contents,k.contents),P.keys.push(...k.keys),P.keys=I.distinct(P.keys)):n.push(C.deepClone(k))}for(const k of R.keys)l.indexOf(k)===-1&&l.push(k)}return new p(i,l,n,S.every(R=>R instanceof p)?void 0:S)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let S=this.contents[l];const R=i[l];R&&(typeof S=="object"&&typeof R=="object"?(S=C.deepClone(S),this.mergeContents(S,R)):S=R),n[l]=S}return new p(n,this.keys,this.overrides)}mergeContents(s,i){for(const n of Object.keys(i)){if(n in s&&g.isObject(s[n])&&g.isObject(i[n])){this.mergeContents(s[n],i[n]);continue}s[n]=C.deepClone(i[n])}}getContentsForOverrideIdentifer(s){let i=null,n=null;const l=S=>{S&&(n?this.mergeContents(n,S):n=C.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===s?i=S.contents:S.identifiers.includes(s)&&l(S.contents);return l(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,v.removeFromValueTree)(this.contents,s),b.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>I.equals(n.identifiers,(0,b.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,n){(0,v.addToValueTree)(this.contents,s,i,l=>console.error(l)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),b.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,v.toValuesTree)(this.contents[s],l=>console.error(l))})}}e.ConfigurationModel=p;class y{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!g.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:n,keys:l,overrides:S,restricted:R,hasExcludedProperties:k}=this.doParseRaw(s,i);this._configurationModel=new p(n,l,S,k?[s]:void 0),this._restrictedConfigurations=R||[]}doParseContent(s){let i={},n=null,l=[];const S=[],R=[];function k(D){Array.isArray(l)?l.push(D):n!==null&&(l[n]=D)}const P={onObjectBegin:()=>{const D={};k(D),S.push(l),l=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{l=S.pop()},onArrayBegin:()=>{const D=[];k(D),S.push(l),l=D,n=null},onArrayEnd:()=>{l=S.pop()},onLiteralValue:k,onError:(D,_,U)=>{R.push({error:D,offset:_,length:U})}};if(s)try{r.visit(s,P),i=l[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(s,i){const n=w.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=this.filter(s,n,!0,i);s=l.raw;const S=(0,v.toValuesTree)(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),R=Object.keys(s),k=this.toOverrides(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:S,keys:R,overrides:k,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(s,i,n,l){let S=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:S};const R={},k=[];for(const P in s)if(b.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const D=this.filter(s[P],i,!1,l);R[P]=D.raw,S=S||D.hasExcludedProperties,k.push(...D.restricted)}else{const D=i[P],_=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&k.push(P),!l.exclude?.includes(P)&&(l.include?.includes(P)||(_===void 0||l.scopes===void 0||l.scopes.includes(_))&&!(l.skipRestricted&&D?.restricted))?R[P]=s[P]:S=!0}return{raw:R,restricted:k,hasExcludedProperties:S}}toOverrides(s,i){const n=[];for(const l of Object.keys(s))if(b.OVERRIDE_PROPERTY_REGEX.test(l)){const S={};for(const R in s[l])S[R]=s[l][R];n.push({identifiers:(0,b.overrideIdentifiersFromKey)(l),keys:Object.keys(S),contents:(0,v.toValuesTree)(S,i)})}return n}}e.ConfigurationModelParser=y;class E extends O.Disposable{constructor(s,i,n,l){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=l,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&n.isEqual(S.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class u{constructor(s,i,n,l,S,R,k,P,D,_,U,F,H){this.key=s,this.overrides=i,this._value=n,this.overrideIdentifiers=l,this.defaultConfiguration=S,this.policyConfiguration=R,this.applicationConfiguration=k,this.userConfiguration=P,this.localUserConfiguration=D,this.remoteUserConfiguration=_,this.workspaceConfiguration=U,this.folderConfigurationModel=F,this.memoryConfigurationModel=H}get value(){return h(this._value)}toInspectValue(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class d{constructor(s,i,n,l,S=new p,R=new p,k=new M.ResourceMap,P=new p,D=new M.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=l,this._remoteUserConfiguration=S,this._workspaceConfiguration=R,this._folderConfigurations=k,this._memoryConfiguration=P,this._memoryConfigurationByResource=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,n){return this.getConsolidatedConfigurationModel(s,i,n).getValue(s)}updateValue(s,i,n={}){let l;n.resource?(l=this._memoryConfigurationByResource.get(n.resource),l||(l=new p,this._memoryConfigurationByResource.set(n.resource,l))):l=this._memoryConfiguration,i===void 0?l.removeValue(s):l.setValue(s,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,n){const l=this.getConsolidatedConfigurationModel(s,i,n),S=this.getFolderConfigurationModelForResource(i.resource,n),R=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const P of l.overrides)for(const D of P.identifiers)l.getOverrideValue(s,D)!==void 0&&k.add(D);return new u(s,i,l.getValue(s),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,S||void 0,R)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const n=[];if(!i){const{added:l,updated:S,removed:R}=a(this._defaultConfiguration,s);i=[...l,...S,...R]}for(const l of i)for(const S of(0,b.overrideIdentifiersFromKey)(l)){const R=this._defaultConfiguration.getKeysForOverrideIdentifier(S),k=s.getKeysForOverrideIdentifier(S),P=[...k.filter(D=>R.indexOf(D)===-1),...R.filter(D=>k.indexOf(D)===-1),...R.filter(D=>!C.equals(this._defaultConfiguration.override(S).getValue(D),s.override(S).getValue(D)))];n.push([S,P])}return this.updateDefaultConfiguration(s),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:n,removed:l}=a(this._policyConfiguration,s),S=[...i,...n,...l];return S.length&&this.updatePolicyConfiguration(s),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:n,removed:l,overrides:S}=a(this.applicationConfiguration,s),R=[...i,...n,...l];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:S}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:n,removed:l,overrides:S}=a(this.localUserConfiguration,s),R=[...i,...n,...l];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:S}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:n,removed:l,overrides:S}=a(this.remoteUserConfiguration,s),R=[...i,...n,...l];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:S}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:n,removed:l,overrides:S}=a(this.workspaceConfiguration,s),R=[...i,...n,...l];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:S}}compareAndUpdateFolderConfiguration(s,i){const n=this.folderConfigurations.get(s),{added:l,updated:S,removed:R,overrides:k}=a(n,i),P=[...l,...S,...R];return(P.length||!n)&&this.updateFolderConfiguration(s,i),{keys:P,overrides:k}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:l,removed:S,overrides:R}=a(i,void 0);return{keys:[...n,...l,...S],overrides:R}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,n){let l=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:s},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const l=i.getFolder(s);l&&(n=this.getFolderConsolidatedConfiguration(l.uri)||n);const S=this._memoryConfigurationByResource.get(s);S&&(n=n.merge(S))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(s);l?(i=n.merge(l),this._foldersConsolidatedConfigurations.set(s,i)):i=n}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const n=i.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:n,overrides:l,keys:S}=this._folderConfigurations.get(i);return s.push([i,{contents:n,overrides:l,keys:S}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),l=this.parseConfigurationModel(s.application),S=this.parseConfigurationModel(s.user),R=this.parseConfigurationModel(s.workspace),k=s.folders.reduce((P,D)=>(P.set(c.URI.revive(D[0]),this.parseConfigurationModel(D[1])),P),new M.ResourceMap);return new d(i,n,l,S,new p,R,k,new p,new M.ResourceMap)}static parseConfigurationModel(s){return new p(s.contents,s.keys,s.overrides)}}e.Configuration=d;function f(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,i=new Map;for(const l of o)l.keys.forEach(S=>s.add(S)),l.overrides.forEach(([S,R])=>{const k=(0,M.getOrSet)(i,S,new Set);R.forEach(P=>k.add(P))});const n=[];return i.forEach((l,S)=>n.push([S,[...l.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=f;class m{constructor(s,i,n,l){this.change=s,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=l,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const S of s.keys)this.affectedKeys.add(S);for(const[,S]of s.overrides)for(const R of S)this.affectedKeys.add(R);this._affectsConfigStr=this._marker;for(const S of this.affectedKeys)this._affectsConfigStr+=S+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const n=this._marker+s,l=this._affectsConfigStr.indexOf(n);if(l<0)return!1;const S=l+n.length;if(S>=this._affectsConfigStr.length)return!1;const R=this._affectsConfigStr.charCodeAt(S);if(R!==this._markerCode1&&R!==this._markerCode2)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,P=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!C.equals(k,P)}return!0}}e.ConfigurationChangeEvent=m;function a(o,s){const{added:i,removed:n,updated:l}=t(s?.rawConfiguration,o?.rawConfiguration),S=[],R=o?.getAllOverrideIdentifiers()||[],k=s?.getAllOverrideIdentifiers()||[];if(s){const P=k.filter(D=>!R.includes(D));for(const D of P)S.push([D,s.getKeysForOverrideIdentifier(D)])}if(o){const P=R.filter(D=>!k.includes(D));for(const D of P)S.push([D,o.getKeysForOverrideIdentifier(D)])}if(s&&o){for(const P of R)if(k.includes(P)){const D=t({contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)},{contents:s.getOverrideValue(void 0,P)||{},keys:s.getKeysForOverrideIdentifier(P)});S.push([P,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:n,updated:l,overrides:S}}function t(o,s){const i=o?s?o.keys.filter(S=>s.keys.indexOf(S)===-1):[...o.keys]:[],n=s?o?s.keys.filter(S=>o.keys.indexOf(S)===-1):[...s.keys]:[],l=[];if(o&&s){for(const S of s.keys)if(o.keys.indexOf(S)!==-1){const R=(0,v.getConfigurationValue)(s.contents,S),k=(0,v.getConfigurationValue)(o.contents,S);C.equals(R,k)||l.push(S)}}return{added:i,removed:n,updated:l}}}),define(ae[237],ce([0,1,22,3,2,35,12,121,52,5,39,44]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class w extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(b.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(E),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(E,u){this.updateConfigurationModel(E,b.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:E})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new C.ConfigurationModel;const E=b.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(E),E)}updateConfigurationModel(E,u){const d=this.getConfigurationDefaultOverrides();for(const f of E){const m=d[f],a=u[f];m!==void 0?this._configurationModel.addValue(f,m):a?this._configurationModel.addValue(f,a.default):this._configurationModel.removeValue(f)}}}e.DefaultConfiguration=w;class h{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new C.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let p=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(E,u,d){super(),this.defaultConfiguration=E,this.policyService=u,this.logService=d,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(E=>this.onDidChangePolicies(E))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:E})=>this.update(await this.updatePolicyDefinitions(E),!0))),this._configurationModel}async updatePolicyDefinitions(E){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",E);const u={},d=[],f=b.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const m of E){const a=f[m];if(!a){d.push(m);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}d.push(m),u[a.policy.name]={type:a.type}}}return(0,M.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),d}onDidChangePolicies(E){this.logService.trace("PolicyConfiguration#onDidChangePolicies",E);const u=b.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),d=(0,I.coalesce)(E.map(f=>u.get(f)));this.update(d,!0)}update(E,u){this.logService.trace("PolicyConfiguration#update",E);const d=b.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),f=[],m=this._configurationModel.isEmpty();for(const a of E){const t=d[a]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(m?o!==void 0:!(0,O.equals)(this._configurationModel.getValue(a),o))&&f.push([a,o])}else this._configurationModel.getValue(a)!==void 0&&f.push([a,void 0])}if(f.length){this.logService.trace("PolicyConfiguration#changed",f);const a=this._configurationModel;this._configurationModel=new C.ConfigurationModel;for(const t of a.keys)this._configurationModel.setValue(t,a.getValue(t));for(const[t,o]of f)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=p,e.PolicyConfiguration=p=be([re(1,v.IPolicyService),re(2,c.ILogService)],p)}),define(ae[238],ce([0,1,22,8,17,3,42,102,2,35,4,19,18,121,52,237,39]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class u extends g.Disposable{constructor(m,a,t,o){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new y.DefaultConfiguration),this.policyConfiguration=t instanceof E.NullPolicyService?new y.NullPolicyConfiguration:this._register(new y.PolicyConfiguration(this.defaultConfiguration,t,o)),this.userConfiguration=this._register(new h.UserSettings(this.settingsResource,{},b.extUriBiasedIgnorePathCase,a)),this.configuration=new h.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new h.ConfigurationModel,new h.ConfigurationModel),this.configurationEditing=new d(m,a,this),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:i})=>this.onDidDefaultConfigurationChange(s,i))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,a,t]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new h.Configuration(m,a,new h.ConfigurationModel,t)}getConfigurationData(){return this.configuration.toData()}getValue(m,a){const t=typeof m=="string"?m:void 0,o=(0,w.isConfigurationOverrides)(m)?m:(0,w.isConfigurationOverrides)(a)?a:{};return this.configuration.getValue(t,o,void 0)}async updateValue(m,a,t,o,s){const i=(0,w.isConfigurationUpdateOverrides)(t)?t:(0,w.isConfigurationOverrides)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${m} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,I.distinct)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const l=this.inspect(m,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(l.policyValue!==void 0)throw new Error(`Unable to write ${m} because it is configured in system policy.`);if((0,c.equals)(a,l.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const R=i.overrideIdentifiers.sort(),k=this.configuration.localUserConfiguration.overrides.find(P=>(0,I.equals)([...P.identifiers].sort(),R));k&&(i.overrideIdentifiers=k.identifiers)}const S=i?.overrideIdentifiers?.length?[(0,p.keyFromOverrideIdentifiers)(i.overrideIdentifiers),m]:[m];await this.configurationEditing.write(S,a),await this.reloadConfiguration()}inspect(m,a={}){return this.configuration.inspect(m,a,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const a=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,a,2)}onDidDefaultConfigurationChange(m,a){const t=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(m,a);this.trigger(o,t,7)}onDidPolicyConfigurationChange(m){const a=this.configuration.toData(),t=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(t,a,7)}trigger(m,a,t){const o=new h.ConfigurationChangeEvent(m,{data:a},this.configuration);o.source=t,this._onDidChangeConfiguration.fire(o)}}e.ConfigurationService=u;class d{constructor(m,a,t){this.settingsResource=m,this.fileService=a,this.configurationService=t,this.queue=new L.Queue}write(m,a){return this.queue.queue(()=>this.doWriteConfiguration(m,a))}async doWriteConfiguration(m,a){let t;try{t=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,M.parse)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(t,m,a);t=(0,C.applyEdits)(t,s),await this.fileService.writeFile(this.settingsResource,r.VSBuffer.fromString(t))}getEdits(m,a,t){const{tabSize:o,insertSpaces:s,eol:i}=this.formattingOptions;if(!a.length){const n=JSON.stringify(t,null,s?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,C.setProperty)(m,a,t,{tabSize:o,insertSpaces:s,eol:i})}get formattingOptions(){if(!this._formattingOptions){let m=v.OS===3||v.OS===2?`
`:`\r
`;const a=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(m=a),this._formattingOptions={eol:m,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ae[239],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class I{async routeCall(r,O,M){if(O!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${O}`);const C=M[0];if(C?.authority){const g=r.connections.find(c=>c.ctx===C.authority);if(g)return g}throw new Error("Caller not found")}routeEvent(r,O){throw new Error(`Event not found: ${O}`)}}e.NodeRemoteResourceRouter=I}),define(ae[240],ce([0,1,15,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(v){v[v.WebSocket=0]="WebSocket",v[v.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class O{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class M{constructor(b,w){this.host=b,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=M;var C;(function(v){v.Unknown="Unknown",v.NotAvailable="NotAvailable",v.TemporarilyNotAvailable="TemporarilyNotAvailable",v.NoResolverFound="NoResolverFound",v.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class g extends I.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof g&&b._code===C.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof g&&b._code===C.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof g&&b._code===C.NoResolverFound}static isInvalidAuthority(b){return b instanceof g&&b._code===C.InvalidAuthority}static isHandled(b){return b instanceof g&&b.isHandled}constructor(b,w=C.Unknown,h){super(b),this._message=b,this._code=w,this._detail=h,this.isHandled=w===C.NotAvailable&&h===!0,Object.setPrototypeOf(this,g.prototype)}}e.RemoteAuthorityResolverError=g;function c(v){const b=v.indexOf("+");return b===-1?v:v.substring(0,b)}e.getRemoteAuthorityPrefix=c}),define(ae[60],ce([0,1,13]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(c){return c.scheme===I.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=L;function r(c){if(!c)return;const v=c.indexOf("+");return v<0?c:c.substr(0,v)}e.getRemoteName=r;function O(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=O;function M(c){const{host:v,port:b}=g(c);if(typeof b>"u")throw new Error(`Invalid remote authority: ${c}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:v,port:b}}e.parseAuthorityWithPort=M;function C(c,v){let{host:b,port:w}=g(c);return typeof w>"u"&&(w=v),{host:b,port:w}}e.parseAuthorityWithOptionalPort=C;function g(c){const v=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const b=c.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const w=c.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:c,port:void 0}}}),define(ae[122],ce([0,1,25,6,60]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(M||(e.ExtensionType=M={}));var C;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class g{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,u){if(typeof E>"u"||E===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof E=="string"||typeof u=="string"){const d=typeof E=="string"?E:E.value,f=typeof u=="string"?u:u.value;return I.equalsIgnoreCase(d,f)}return E._lower===u._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=g;class c{get size(){return this._set.size}constructor(E){if(this._set=new Set,E)for(const u of E)this.add(u)}add(E){this._set.add(g.toKey(E))}delete(E){return this._set.delete(g.toKey(E))}has(E){return this._set.has(g.toKey(E))}}e.ExtensionIdentifierSet=c;class v{constructor(){this._map=new Map}clear(){this._map.clear()}delete(E){this._map.delete(g.toKey(E))}get(E){return this._map.get(g.toKey(E))}has(E){return this._map.has(g.toKey(E))}set(E,u){this._map.set(g.toKey(E),u)}values(){return this._map.values()}forEach(E){this._map.forEach(E)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=v;function b(y){return w(y)}e.isApplicationScopedExtension=b;function w(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function p(y,E){if(E){const u=`onResolveRemoteAuthority:${(0,r.getRemoteName)(E)}`;return!!y.activationEvents?.includes(u)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ae[241],ce([0,1,8,17,23,15,3,2,67,72,32,111,240,60]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var y;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function E(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(G){const A=new r.CancellationTokenSource;return setTimeout(()=>A.cancel(),G),A.token}function d(G,A){if(G.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const T=new r.CancellationTokenSource;return G.onCancellationRequested(()=>T.cancel()),A.onCancellationRequested(()=>T.cancel()),T.token}class f{get didTimeout(){return this._state==="timedout"}constructor(A){this._state="pending",this._disposables=new C.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,I.promiseWithResolvers)(),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function m(G,A){const T=new f(A);return T.registerDisposable(G.onControlMessage(J=>{const B=JSON.parse(J.toString()),X=W(B);X?T.reject(X):T.resolve(B)})),T.promise}function a(G,A,T,J,B,X,x,Z){const z=new f(Z),ee=c.StopWatch.create(!1);return G.info(`Creating a socket (${x})...`),g.mark(`code/willCreateSocket/${X}`),A.connect(T,J,B,x).then(ie=>{z.didTimeout?(g.mark(`code/didCreateSocketError/${X}`),G.info(`Creating a socket (${x}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(g.mark(`code/didCreateSocketOK/${X}`),G.info(`Creating a socket (${x}) was successful after ${ee.elapsed()} ms.`),z.resolve(ie))},ie=>{g.mark(`code/didCreateSocketError/${X}`),G.info(`Creating a socket (${x}) returned an error after ${ee.elapsed()} ms.`),G.error(ie),z.reject(ie)}),z.promise}function t(G,A){const T=new f(A);return G.then(J=>{T.didTimeout||T.resolve(J)},J=>{T.didTimeout||T.reject(J)}),T.promise}async function o(G,A,T,J){const B=oe(G,A);G.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let X;try{X=await a(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,h.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,E(A),`renderer-${E(A)}-${G.reconnectionToken}`,J)}catch(ie){throw G.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ie),ie}G.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let x,Z;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(X,null),x=G.reconnectionProtocol,Z=!1):(x=new b.PersistentProtocol({socket:X}),Z=!0),G.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const z=await t(G.signService.createNewMessage((0,v.generateUuid)()),J),ee={type:"auth",auth:G.connectionToken||"00000000000000000000",data:z.data};x.sendControl(L.VSBuffer.fromString(JSON.stringify(ee)));try{const ie=await m(x,d(J,u(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(G.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(G.signService.validate(z,ie.signedData),J)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const pe=await t(G.signService.sign(ie.data),J),Pe={type:"connectionType",commit:G.commit,signedData:pe,desiredConnectionType:A};return T&&(Pe.args=T),G.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(L.VSBuffer.fromString(JSON.stringify(Pe))),{protocol:x,ownsProtocol:Z}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(G.logService.error(`${B} the handshake timed out. Error:`),G.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${B} received error control message when negotiating connection. Error:`),G.logService.error(ie)),Z&&q(x),ie}}async function s(G,A,T,J){const B=Date.now(),X=oe(G,A),{protocol:x,ownsProtocol:Z}=await o(G,A,T,J),z=new f(J);return z.registerDisposable(x.onControlMessage(ee=>{const ie=JSON.parse(ee.toString()),fe=W(ie);fe?(G.logService.error(`${X} received error control message when negotiating connection. Error:`),G.logService.error(fe),Z&&q(x),z.reject(fe)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${de(B)}!`),z.resolve({protocol:x,firstMessage:ie}))})),z.promise}async function i(G,A){const{protocol:T}=await s(G,1,void 0,A);return{protocol:T}}async function n(G,A,T){const{protocol:J,firstMessage:B}=await s(G,2,A,T),X=B&&B.debugPort;return{protocol:J,debugPort:X}}async function l(G,A,T){const J=Date.now(),B=oe(G,3),{protocol:X}=await o(G,3,A,T);return G.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${de(J)}!`),X}async function S(G,A,T){const{connectTo:J,connectionToken:B}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:J,connectionToken:B,reconnectionToken:A,reconnectionProtocol:T,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function R(G,A,T){return P(G,async J=>{const{protocol:B}=await i(J,r.CancellationToken.None);return new Y(G,A,T,J.reconnectionToken,B)})}e.connectRemoteAgentManagement=R;async function k(G,A){return P(G,async T=>{const{protocol:J,debugPort:B}=await n(T,A,r.CancellationToken.None);return new Q(G,A,T.reconnectionToken,J,B)})}e.connectRemoteAgentExtensionHost=k;async function P(G,A){for(let J=1;;J++)try{const B=(0,v.generateUuid)(),X=await S(G,B,null);return await A(X)}catch(B){if(J<5)G.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(B);else throw G.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(B),ue.triggerPermanentFailure(0,0,w.RemoteAuthorityResolverError.isHandled(B)),B}}async function D(G,A,T){const J=await S(G,(0,v.generateUuid)(),null);return await l(J,{host:A,port:T},r.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function _(G){return(0,I.createCancelablePromise)(A=>new Promise((T,J)=>{const B=setTimeout(T,G*1e3);A.onCancellationRequested(()=>{clearTimeout(B),T()})}))}var U;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class F{constructor(A,T){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=F;class H{constructor(A,T,J,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.durationSeconds=J,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class j{constructor(A,T,J){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=J,this.type=2}}e.ReconnectionRunningEvent=j;class le{constructor(A,T,J){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=J,this.type=4}}e.ConnectionGainEvent=le;class se{constructor(A,T,J,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=T,this.attempt=J,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ue extends C.Disposable{static triggerPermanentFailure(A,T,J){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=T,this._permanentFailureHandled=J,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ue._permanentFailure}constructor(A,T,J,B,X){super(),this._connectionType=A,this._options=T,this.reconnectionToken=J,this.protocol=B,this._reconnectionFailureIsFatal=X,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(B.onSocketClose(x=>{const Z=$(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${Z} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${Z} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${Z} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(x=>{const Z=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ue._instances.push(this),this._register((0,C.toDisposable)(()=>{const x=ue._instances.indexOf(this);x>=0&&ue._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ue._permanentFailureMillisSinceLastIncomingData,ue._permanentFailureAttempt,ue._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const A=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const B=J<T.length?T[J]:T[T.length-1];try{if(B>0){const x=_(B);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,x)),this._options.logService.info(`${A} waiting for ${B} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this._options.logService.info(`${A} resolving connection...`);const X=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${X.connectTo}...`),await this._reconnect(X,u(p)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(w.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if((0,O.isCancellationError)(X)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(X);continue}if(X instanceof w.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,w.RemoteAuthorityResolverError.isHandled(X));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(X),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(A,T,J){this._reconnectionFailureIsFatal?ue.triggerPermanentFailure(A,T,J):this._gotoPermanentFailure(A,T,J)}_gotoPermanentFailure(A,T,J){this._onDidStateChange.fire(new se(this.reconnectionToken,A,T,J)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ue;class Y extends ue{constructor(A,T,J,B,X){super(1,A,B,X,!0),this.client=this._register(new b.Client(X,{remoteAuthority:T,clientId:J},A.ipcLogger))}async _reconnect(A,T){await i(A,T)}}e.ManagementPersistentConnection=Y;class Q extends ue{constructor(A,T,J,B,X){super(2,A,J,B,!1),this._startArguments=T,this.debugPort=X}async _reconnect(A,T){await n(A,this._startArguments,T)}}e.ExtensionHostPersistentConnection=Q;function q(G){try{G.acceptDisconnect();const A=G.getSocket();G.dispose(),A.dispose()}catch(A){(0,O.onUnexpectedError)(A)}}function W(G){if(G&&G.type==="error"){const A=new Error(`Connection error: ${G.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function N(G,A){for(;G.length<A;)G+=" ";return G}function V(G,A){return`[remote-connection][${N(E(G),13)}][${A.substr(0,5)}\u2026]`}function $(G,A,T){return`${V(G,A)}[${T?"reconnect":"initial"}]`}function oe(G,A){return`${$(A,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function de(G){return`${Date.now()-G} ms`}}),define(ae[242],ce([0,1,2,6]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(M,C){return this.factories[M]??=[],this.factories[M].push(C),(0,I.toDisposable)(()=>{const g=this.factories[M]?.indexOf(C);typeof g=="number"&&g>=0&&this.factories[M]?.splice(g,1)})}getSocketFactory(M){return(this.factories[M.type]||[]).find(g=>g.supports(M))}connect(M,C,g,c){const v=this.getSocketFactory(M);if(!v)throw new Error(`No socket factory found for ${M}`);return v.connect(M,C,g,c)}}e.RemoteSocketFactoryService=r}),define(ae[243],ce([0,1,26,48,21,115]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function C(h=!1){return(M===void 0||h)&&(M=g()),M}e.hasWSLFeatureInstalled=C;async function g(){const h=c();if(h===void 0)return!1;if(h>=22e3){const p=b();if(p)return new Promise(y=>{L.execFile(p,["--status"],E=>y(!E))})}else{const p=w();if(p)try{if((await r.Promises.stat(p)).isFile())return!0}catch{}}return!1}function c(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(h)return parseInt(h[3])}function v(h){const p=process.env.SystemRoot;if(p){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(p,y?"Sysnative":"System32",h)}}function b(){return v("wsl.exe")}function w(){return v("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,15,2,183,52,6,5,44]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");class v{constructor(a){this.original=a}toJSON(){if(!this.headers){const a=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.original[t];this.headers=a}return this.headers}}class b extends r.Disposable{constructor(a){super(),this.counter=0,this.logger=a.createLogger("network",{name:(0,O.localize)(0,null),when:g.CONTEXT_LOG_LEVEL.isEqualTo((0,g.LogLevelToString)(g.LogLevel.Trace)).serialize()})}async logAndRequest(a,t,o){const s=`${a} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new v(t.headers??{}));try{const i=await o();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=b;function w(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=w;function h(m){return m.res.statusCode===204}e.hasNoContent=h;async function p(m){return h(m)?null:(await(0,I.streamToBuffer)(m.stream)).toString()}e.asText=p;async function y(m){if(!w(m))throw new Error("Server returned "+m.res.statusCode);return p(m)}e.asTextOrError=y;async function E(m){if(!w(m))throw new Error("Server returned "+m.res.statusCode);if(h(m))return null;const t=(await(0,I.streamToBuffer)(m.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.asJson=E;function u(m){f(m)}e.updateProxyConfigurationsScope=u;let d;function f(m){const a=c.Registry.as(M.Extensions.Configuration),t=d;d={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[d],remove:t?[t]:[]})}f(1)}),define(ae[244],ce([0,1,17,23]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(C){this.service=C}listen(C,g){throw new Error("Invalid listen")}call(C,g,c,v=L.CancellationToken.None){switch(g){case"request":return this.service.request(c[0],v).then(async({res:b,stream:w})=>{const h=await(0,I.streamToBuffer)(w);return[{statusCode:b.statusCode,headers:b.headers},h]});case"resolveProxy":return this.service.resolveProxy(c[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=r;class O{constructor(C){this.channel=C}async request(C,g){const[c,v]=await this.channel.call("request",[C],g);return{res:c,stream:(0,I.bufferToStream)(v)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=O}),define(ae[245],ce([0,1,246,12]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(M,C){return M.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:M.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function O(M,C,g={}){const c=(0,I.parse)(M),v=g.proxyUrl||r(c,C);if(!v)return null;const b=(0,I.parse)(v);if(!/^https?:$/.test(b.protocol||""))return null;const w={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,L.isBoolean)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((h,p)=>{K(["http-proxy-agent"],h,p)})).HttpProxyAgent(v,w):new(await new Promise((h,p)=>{K(["https-proxy-agent"],h,p)})).HttpsProxyAgent(v,w)}e.getProxyAgent=O}),define(ae[247],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[95],ce([0,1,48,9,184,23,51,15,4,32,110,64,8,140]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function y(u,d,f,m){return f["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(m)&&!f["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(m)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=w.Promises.withAsyncBody(async(a,t)=>{const o=new O.CancellationTokenSource;let s=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,h.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{a(await E(d,o.token))}catch(l){!(0,C.isCancellationError)(l)&&!o.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,M.toErrorMessage)(l)))):a({})}finally{clearTimeout(n),o.dispose()}})),p)}e.getResolvedShellEnv=y;async function E(u,d){const f=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",f);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",m);const a=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const s=await(0,v.getSystemShell)(g.OS,o);return u.trace("getUnixShellEnvironment#shell",s),new Promise((i,n)=>{if(d.isCancellationRequested)return n(new C.CancellationError);const l=(0,L.basename)(s);let S,R;const k="";/^pwsh(-preview)?$/.test(l)?(S=`& '${process.execPath}' ${k} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):l==="nu"?(S=`^'${process.execPath}' ${k} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,R=["-i","-l","-c"]):l==="xonsh"?(S=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,R=["-i","-l","-c"]):(S=`'${process.execPath}' ${k} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?R=["-ic"]:R=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),S);const P=(0,I.spawn)(s,[...R,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(P.kill(),n(new C.CancellationError))),P.on("error",U=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(U)),n(U)});const D=[];P.stdout.on("data",U=>D.push(U));const _=[];P.stderr.on("data",U=>_.push(U)),P.on("close",(U,F)=>{const H=Buffer.concat(D).toString("utf8");u.trace("getUnixShellEnvironment#raw",H);const j=Buffer.concat(_).toString("utf8");if(j.trim()&&u.trace("getUnixShellEnvironment#stderr",j),U||F)return n(new Error((0,r.localize)(2,null,U,F)));const le=t.exec(H),se=le?le[1]:"{}";try{const ue=JSON.parse(se);f?ue.ELECTRON_RUN_AS_NODE=f:delete ue.ELECTRON_RUN_AS_NODE,m?ue.ELECTRON_NO_ATTACH_CONSOLE=m:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){u.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(ue)),n(ue)}})})}}),define(ae[248],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class I{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(r){try{const O=await this.getValidator();if(O){const M=String(I._nextId++);return this.validators.set(M,O),{id:M,data:O.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,O){if(!r.id)return!0;const M=this.validators.get(r.id);if(!M)return!1;this.validators.delete(r.id);try{return M.validate(O)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=I}),define(ae[96],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ae[249],ce([0,1,248]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends I.AbstractSignService{getValidator(){return this.vsda().then(O=>new O.validator)}signValue(O){return this.vsda().then(M=>new M.signer().sign(O))}vsda(){return new Promise((O,M)=>K(["vsda"],O,M))}}e.SignService=L}),define(ae[34],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(ae[123],ce([0,1,8,17,2,12,38,16,5]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var c;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class v extends r.Disposable{constructor(p,y,E,u){super(),this.storagePath=p,this.saveStrategy=y,this.logService=E,this.fileService=u,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new I.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,y){const E=this.storage[p];return(0,O.isUndefinedOrNull)(E)?y:E}setItem(p,y){this.setItems([{key:p,data:y}])}setItems(p){let y=!1;for(const{key:E,data:u}of p)this.storage[E]!==u&&((0,O.isUndefinedOrNull)(u)?(0,O.isUndefined)(this.storage[E])||(this.storage[E]=void 0,y=!0):(this.storage[E]=u,y=!0));y&&this.save()}removeItem(p){(0,O.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(p),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=p}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=v;let b=class extends r.Disposable{constructor(p,y,E,u){super(),this.fileStorage=this._register(new v(y.stateResource,p,E,u))}async init(){await this.fileStorage.init()}getItem(p,y){return this.fileStorage.getItem(p,y)}};e.StateReadonlyService=b,e.StateReadonlyService=b=be([re(1,M.IEnvironmentService),re(2,g.ILogService),re(3,C.IFileService)],b);class w extends b{setItem(p,y){this.fileStorage.setItem(p,y)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}}e.StateService=w}),define(ae[124],ce([0,1,4,36,32]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(g){if(I.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,c,v,b,w,h,p,y,E){const u=Object.create(null);u["common.machineId"]=h,u["common.sqmId"]=p,u.sessionID=(0,r.generateUuid)()+Date.now(),u.commitHash=b,u.version=w,u["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,I.PlatformToString)(I.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=v,u["common.product"]=E||"desktop",y&&(u["common.msftInternal"]=y);let d=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),I.isLinuxSnap&&(u["common.snap"]="true");const m=O(c);return m&&(u["common.platformDetail"]=m),u}e.resolveCommonProperties=M;function C(g){const c=L.env.USERDNSDOMAIN;if(!c)return!1;const v=c.toLowerCase();return g.some(b=>v===b)}e.verifyMicrosoftInternalDomain=C}),define(ae[28],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(ae[250],ce([0,1,26,8,42,13,9,4,7,89,21,109,92,16,27,28]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const E=new Map;async function u(t,o){const s=`${t}::${o.join(":")}`,i=E.get(s);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,S=new Map,R=2e4;function k(D,_,U,F){const H=_.substring(D.length+1);return L.Promises.withAsyncBody(async j=>{let le;try{le=await v.Promises.readdir(_,{withFileTypes:!0})}catch{j();return}if(F.count>=R){F.count+=le.length,F.maxReached=!0,j();return}let se=le.length;if(se===0){j();return}let ue=le;F.count+le.length>R&&(F.maxReached=!0,se=R-F.count,ue=le.slice(0,se)),F.count+=le.length;for(const Y of ue)if(Y.isDirectory()){if(U.includes(Y.name)||await k(D,(0,M.join)(_,Y.name),U,F),--se===0){j();return}}else{const Q=Y.name.lastIndexOf(".");if(Q>=0){const q=Y.name.substring(Q+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(H)!==!1&&q.filePattern.test(Y.name)&&S.set(q.tag,(S.get(q.tag)??0)+1);if(--se===0){j();return}}})}const P=L.Promises.withAsyncBody(async D=>{const _={count:0,maxReached:!1};await k(t,t,o,_);const U=await m(t);D({configFiles:d(S),fileTypes:d(l),fileCount:_.count,maxFilesReached:_.maxReached,launchConfigFiles:U})});return E.set(s,P),P}e.collectWorkspaceStats=u;function d(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function f(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.virtualMachineHint.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.getMachineInfo=f;async function m(t){try{const o=new Map,s=(0,M.join)(t,".vscode","launch.json"),i=await v.Promises.readFile(s),n=[],l=(0,r.parse)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.getNodeType)(l)==="object"&&l.configurations)for(const S of l.configurations){const R=S.type;R&&(o.has(R)?o.set(R,o.get(R)+1):o.set(R,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=m;let a=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||s.push(`Load (avg):       ${I.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(c.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async i=>{let[n,l]=i,S=this.formatProcessList(o,n);return s.forEach(R=>{if((0,w.isRemoteDiagnosticError)(R))S+=`
${R.errorMessage}`,l+=`
${R.errorMessage}`;else if(S+=`

Remote: ${R.hostName}`,R.processes&&(S+=`
${this.formatProcessList(o,R.processes)}`),R.workspaceMetadata){l+=`
|  Remote: ${R.hostName}`;for(const k of Object.keys(R.workspaceMetadata)){const P=R.workspaceMetadata[k];let D=`${P.fileCount} files`;P.maxFilesReached&&(D=`more than ${D}`),l+=`|    Folder (${k}): ${D}`,l+=this.formatWorkspaceStats(P)}}}),{processInfo:S,workspaceInfo:l}})}async getSystemInfo(o,s){const{memory:i,vmHint:n,os:l,cpus:S}=f(),R={os:l,memory:i,cpus:S,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return C.isWindows||(R.load=`${I.loadavg().map(k=>Math.round(k)).join(", ")}`),C.isLinux&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(o,s){const i=[];return(0,b.listProcesses)(o.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(o)),i.push(""),i.push(this.formatProcessList(o,n)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(o))),s.forEach(l=>{if((0,w.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.formatMachineInfo(l.machineInfo)),l.processes&&i.push(this.formatProcessList(o,l.processes)),l.workspaceMetadata)for(const S of Object.keys(l.workspaceMetadata)){const R=l.workspaceMetadata[S];let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),i.push(`Folder (${S}): ${k}`),i.push(this.formatWorkspaceStats(R))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(o){const s=[];let n=0;const l=(P,D)=>{const _=` ${P}(${D})`;n+_.length>60?(s.push(S),S="|                 ",n=S.length):n+=_.length,S+=_};let S="|      File types:";const R=10,k=o.fileTypes.length>R?R:o.fileTypes.length;for(let P=0;P<k;P++){const D=o.fileTypes[P];l(D.name,D.count)}if(s.push(S),o.configFiles.length>=0&&(S="|      Conf files:",n=0,o.configFiles.forEach(P=>{l(P.name,P.count)}),s.push(S)),o.launchConfigFiles.length>0){let P="|      Launch Configs:";o.launchConfigFiles.forEach(D=>{const _=D.count>1?` ${D.name}(${D.count})`:` ${D.name}`;P+=_}),s.push(P)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${o[i]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const S=g.URI.revive(l);if(S.scheme===O.Schemas.file){const R=S.fsPath;i.push(u(R,["node_modules",".git"]).then(k=>{let P=`${k.fileCount} files`;k.maxFilesReached&&(P=`more than ${P}`),s.push(`|    Folder (${(0,M.basename)(R)}): ${P}`),s.push(this.formatWorkspaceStats(k))}).catch(k=>{s.push(`|      Error: Unable to collect workspace stats for folder ${R} (${k.toString()})`)}))}else s.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(o,s){const i=new Map;o.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:S})=>i.set(l,S));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,i,n,s,0),n.join(`
`)}formatProcessItem(o,s,i,n,l){const S=l===0;let R;S?R=n.pid===o?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?R=s.get(n.pid):R=`${"  ".repeat(l)} ${n.name}`;const k=process.platform==="win32"?n.mem:I.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(k/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(P=>this.formatProcessItem(o,s,i,P,l+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:i}of o.folders){const n=g.URI.revive(i);if(n.scheme!==O.Schemas.file)continue;const l=n.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(R=>s.add(R.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const i=g.URI.revive(s);if(i.scheme!==O.Schemas.file)continue;const n=i.fsPath;try{const l=await u(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),l.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),l.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})})}catch{}}}};e.DiagnosticsService=a,e.DiagnosticsService=a=be([re(0,y.ITelemetryService),re(1,p.IProductService)],a)}),define(ae[251],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(O){this.appenders=O}listen(O,M){throw new Error(`Event not found: ${M}`)}call(O,M,{eventName:C,data:g}){return this.appenders.forEach(c=>c.log(C,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class L{constructor(O){this.channel=O}log(O,M){return this.channel.call("log",{eventName:O,data:M}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ae[54],ce([0,1,35,12,60,124,28]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class C{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=C;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=g,e.NullTelemetryService=new g;class c{async publicLog(o,s,i){}async publicLogError(o,s,i){}}e.NullEndpointTelemetryService=c,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=v;function b(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=b;function w(t){const o=t.getValue(M.TELEMETRY_SETTING_ID),s=t.getValue(M.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function h(t){const o={},s={},i={};E(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const l=i[n];typeof l=="number"?s[n]=l:typeof l=="boolean"?s[n]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${l.length}`),o[n]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(o[n]=l)}return{properties:o,measurements:s}}e.validateTelemetryData=h;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const o=(0,r.getRemoteName)(t);return p.has(o)?o:"other"}e.cleanRemoteAuthority=y;function E(t,o,s=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const l=t[n],S=i?i+n:n;Array.isArray(l)?o[S]=(0,I.safeStringify)(l):l instanceof Date?o[S]=l.toISOString():(0,L.isObject)(l)?s<2?E(l,o,s+1,S+"."):o[S]=(0,I.safeStringify)(l):o[S]=l}}function u(t,o){const s=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(s)||i}e.isInternalTelemetry=u;function d(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=d;function f(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const R of o)for(;;){const k=R.exec(t);if(!k)break;i.push([k.index,R.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(s="";;){const R=l.exec(t);if(!R)break;const k=i.some(([P,D])=>R.index<D&&P<l.lastIndex);!n.test(R[0])&&!k&&(s+=t.substring(S,R.index)+"<REDACTED: user-file-path>",S=l.lastIndex)}return S<t.length&&(s+=t.substr(S)),s}function m(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,o){return(0,I.cloneAndChange)(t,s=>{if(s instanceof C||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=f(i,o);for(const n of o)i=i.replace(n,"");return i=m(i),i}})}e.cleanData=a}),define(ae[125],ce([0,1,25,119,122,4,7,15,36,54]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function v(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,I.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=v;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const n=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,n,l)}static parse(i){const n=b.exec(i);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?v(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const i=h.exec(s);return i&&i[1]?[E(i[1]),i[2]]:[E(s),void 0]}e.getIdAndVersion=p;function y(s,i){return`${s}.${i}`}e.getExtensionId=y;function E(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=E;function u(s,i){return E(y(s??r.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=u;function d(s,i){const n=[],l=S=>{for(const R of n)if(R.some(k=>v(i(k),i(S))))return R;return null};for(const S of s){const R=l(S);R?R.push(S):n.push([S])}return n}e.groupByExtension=d;function f(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function m(s){return{id:new c.TelemetryTrustedValue(s.identifier.id),name:new c.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function a(s,i){const n=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&n.every(R=>!v(R.identifier,{id:S}))){const R=s.filter(k=>v(k.identifier,{id:S}));R.length===1&&(n.push(R[0]),l.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=a;async function t(s,i){if(!O.isLinux)return!1;let n;try{n=(await s.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){i.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(S))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,i){const n=await t(s,i),l=(0,L.getTargetPlatform)(n?"alpine":O.platform,g.arch);return i.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=o}),define(ae[252],ce([0,1,206,54]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(O,M,C,g,c,v,b){const w={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${M.nameShort})`};if((0,L.supportsTelemetry)(M,C)&&(0,L.getTelemetryLevel)(g)===3){const h=await(0,I.getServiceMachineId)(C,c,v);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=b.machineId||h}return w}e.resolveMarketplaceHeaders=r}),define(ae[253],ce([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,f){this._configurationService=d,this._productService=f,this._experimentProperties={},this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(m),"gi")),m.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(m.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(m=>{(m.affectsConfiguration(w.TELEMETRY_SETTING_ID)||m.affectsConfiguration(w.TELEMETRY_OLD_SETTING_ID)||m.affectsConfiguration(w.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,d){this._experimentProperties[u]=d}_updateTelemetryLevel(){let u=(0,h.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const f=d.usage?3:d.error?2:0;u=Math.min(u,f)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(u,d,f){this._telemetryLevel<d||(f=(0,L.mixin)(f,this._experimentProperties),f=(0,h.cleanData)(f,this._cleanupPatterns),f=(0,L.mixin)(f,this._commonProperties),this._appenders.forEach(m=>m.log(u,f)))}publicLog(u,d){this._log(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this._sendErrorTelemetry&&this._log(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.TelemetryService=p,e.TelemetryService=p=be([re(1,C.IConfigurationService),re(2,v.IProductService)],p);function y(){const E=(0,M.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=r.isWeb?"":(0,M.localize)(3,null),f=(0,M.localize)(4,null),m=(0,M.localize)(5,null),a=(0,M.localize)(6,null),t=(0,M.localize)(7,null),o=`
|       | ${f} | ${m} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,M.localize)(8,null);return`
${E} ${u} ${d}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}b.Registry.as(g.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,M.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(g.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,M.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,M.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[254],ce([0,1,4,89,28]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function O(C,g){let c=C.getItem(r.machineIdKey);return(typeof c!="string"||I.isMacintosh&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,L.getMachineId)(g.error.bind(g))),c}e.resolveMachineId=O;async function M(C,g){let c=C.getItem(r.sqmIdKey);return typeof c!="string"&&(c=await(0,L.getSqmMachineId)(g.error.bind(g))),c}e.resolveSqmId=M}),define(ae[255],ce([0,1,28,254]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function r(M,C){const g=await(0,L.resolveMachineId)(M,C);return M.setItem(I.machineIdKey,g),g}e.resolveMachineId=r;async function O(M,C){const g=await(0,L.resolveSqmId)(M,C);return M.setItem(I.sqmIdKey,g),g}e.resolveSqmId=O}),define(ae[126],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var I;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(I||(e.EnvironmentVariableMutatorType=I={}))}),define(ae[256],ce([0,1,4,126]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(v){this.collections=v,this.map=new Map,this.descriptionMap=new Map,v.forEach((b,w)=>{this.populateDescriptionMap(b,w);const h=b.map.entries();let p=h.next();for(;!p.done;){const y=p.value[1],E=p.value[0];let u=this.map.get(E);if(u||(u=[],this.map.set(E,u)),u.length>0&&u[0].type===L.EnvironmentVariableMutatorType.Replace){p=h.next();continue}const d={extensionIdentifier:w,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};d.scope||delete d.scope,u.unshift(d),p=h.next()}})}async applyToProcessEnvironment(v,b,w){let h;I.isWindows&&(h={},Object.keys(v).forEach(p=>h[p.toLowerCase()]=p));for(const[p,y]of this.getVariableMap(b)){const E=I.isWindows&&h[p.toLowerCase()]||p;for(const u of y){const d=w?await w(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case L.EnvironmentVariableMutatorType.Append:v[E]=(v[E]||"")+d;break;case L.EnvironmentVariableMutatorType.Prepend:v[E]=d+(v[E]||"");break;case L.EnvironmentVariableMutatorType.Replace:v[E]=d;break}if(u.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${r.get(u.type)}`;v[f]=(v[f]?v[f]+":":"")+p+"="+this._encodeColons(d)}}}}_encodeColons(v){return v.replaceAll(":","\\x3a")}diff(v,b){const w=new Map,h=new Map,p=new Map;if(v.getVariableMap(b).forEach((y,E)=>{const u=this.getVariableMap(b).get(E),d=C(y,u);d&&w.set(E,d)}),this.getVariableMap(b).forEach((y,E)=>{const u=v.getVariableMap(b).get(E),d=C(y,u);d&&p.set(E,d)}),this.getVariableMap(b).forEach((y,E)=>{const u=v.getVariableMap(b).get(E),d=g(y,u);d&&h.set(E,d)}),!(w.size===0&&h.size===0&&p.size===0))return{added:w,changed:h,removed:p}}getVariableMap(v){const b=new Map;for(const w of this.map.values()){const h=w.filter(p=>M(p,v));h.length>0&&b.set(h[0].variable,h)}return b}getDescriptionMap(v){const b=new Map;for(const w of this.descriptionMap.values()){const h=w.filter(p=>M(p,v,!0));for(const p of h)b.set(p.extensionIdentifier,p.description)}return b}populateDescriptionMap(v,b){if(!v.descriptionMap)return;const w=v.descriptionMap.entries();let h=w.next();for(;!h.done;){const p=h.value[1],y=h.value[0];let E=this.descriptionMap.get(y);E||(E=[],this.descriptionMap.set(y,E));const u={extensionIdentifier:b,scope:p.scope,description:p.description};u.scope||delete u.scope,E.push(u),h=w.next()}}}e.MergedEnvironmentVariableCollection=O;function M(c,v,b=!1){return c.scope?!!(c.scope.workspaceFolder&&v?.workspaceFolder&&c.scope.workspaceFolder.index===v.workspaceFolder.index):b?v===c.scope:!0}function C(c,v){if(!v)return c;const b=new Set;v.forEach(h=>b.add(h.extensionIdentifier));const w=[];return c.forEach(h=>{b.has(h.extensionIdentifier)||w.push(h)}),w.length===0?void 0:w}function g(c,v){if(!v)return;const b=new Map;v.forEach(h=>b.set(h.extensionIdentifier,h));const w=[];return c.forEach(h=>{const p=b.get(h.extensionIdentifier);p&&(h.type!==p.type||h.value!==p.value||h.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index)&&w.push(p)}),w.length===0?void 0:w}}),define(ae[257],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(g){return[...g.entries()]}e.serializeEnvironmentVariableCollection=I;function L(g){return g?[...g.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(g){return new Map(g)}e.deserializeEnvironmentVariableCollection=r;function O(g){return new Map(g??[])}e.deserializeEnvironmentDescriptionMap=O;function M(g){return Array.from(g.entries()).map(c=>[c[0],I(c[1].map),L(c[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function C(g){return new Map(g.map(c=>[c[0],{map:r(c[1]),descriptionMap:O(c[2])}]))}e.deserializeEnvironmentVariableCollections=C}),define(ae[258],ce([0,1,8,23,3,2,5]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends O.Disposable{constructor(c,v){super(),this._logService=v,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=c===void 0?15e3:c,this._register((0,O.toDisposable)(()=>{for(const b of this._pendingRequestDisposables.values())(0,O.dispose)(b)}))}createRequest(c){return new Promise((v,b)=>{const w=++this._lastRequestId;this._pendingRequests.set(w,v),this._onCreateRequest.fire({requestId:w,...c});const h=new L.CancellationTokenSource;(0,I.timeout)(this._timeout,h.token).then(()=>b(`Request ${w} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(w,[(0,O.toDisposable)(()=>h.cancel())])})}acceptReply(c,v){const b=this._pendingRequests.get(c);b?(this._pendingRequests.delete(c),(0,O.dispose)(this._pendingRequestDisposables.get(c)||[]),this._pendingRequestDisposables.delete(c),b(v)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.RequestStore=C,e.RequestStore=C=be([re(1,M.ILogService)],C)}),define(ae[127],ce([0,1,6,116,44]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var M;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var C;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(C||(e.PosixShellType=C={}));var g;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(g||(e.WindowsShellType=g={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var v;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(v||(e.TerminalIpcChannels=v={}));var b;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.IPtyService=(0,I.createDecorator)("ptyService");var w;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var h;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var p;(function(a){a.TerminalView="view",a.Editor="editor"})(p||(e.TerminalLocationString=p={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var E;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(E||(e.FlowControlConstants=E={}));var u;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var d;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var f;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class m{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const o=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this._backends.set(o,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}r.Registry.add(e.TerminalExtensions.Backend,new m),e.ILocalPtyService=(0,I.createDecorator)("localPtyService"),e.ITerminalLogService=(0,I.createDecorator)("terminalLogService")}),define(ae[259],ce([0,1,74,7,187,104]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function M(w,h){const p=[{name:null,description:(0,r.localize)(0,null)}];return p.push(...w.map(y=>({name:y.profileName,description:C(y)}))),h&&p.push(...h.map(y=>({name:y.title,description:g(y)}))),{values:p.map(y=>y.name),markdownDescriptions:p.map(y=>y.description)}}e.createProfileSchemaEnums=M;function C(w){let h=`$(${O.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:I.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?h+=`
- args: "${w.args}"`:h+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(h+=`
- overrideName: ${w.overrideName}`),w.color&&(h+=`
- color: ${w.color}`),w.env&&(h+=`
- env: ${JSON.stringify(w.env)}`),h}function g(w){return`$(${O.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:I.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function c(w,h){if(!w&&!h)return!0;if(typeof w=="string"&&typeof h=="string")return w===h;if(Array.isArray(w)&&Array.isArray(h)){if(w.length!==h.length)return!1;for(let p=0;p<w.length;p++)if(w[p]!==h[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=c;function v(w,h){if(!w&&!h)return!0;if(!w||!h)return!1;if(O.ThemeIcon.isThemeIcon(w)&&O.ThemeIcon.isThemeIcon(h))return w.id===h.id&&w.color===h.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof h=="object"&&"light"in h&&"dark"in h){const p=w,y=h;if((L.URI.isUri(p.light)||b(p.light))&&(L.URI.isUri(p.dark)||b(p.dark))&&(L.URI.isUri(y.light)||b(y.light))&&(L.URI.isUri(y.dark)||b(y.dark)))return p.light.path===y.light.path&&p.dark.path===y.dark.path}if(L.URI.isUri(w)&&L.URI.isUri(h)||b(w)||b(h)){const p=w,y=h;return p.path===y.path&&p.scheme===y.scheme}return!1}e.terminalIconsEqual=v;function b(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=b}),define(ae[260],ce([0,1,74,4,186,52,44,259]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,I.getAllCodicons)(),E=>E.id),markdownEnumDescriptions:Array.from((0,I.getAllCodicons)(),E=>`$(${E.id})`)};const g={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...g}},v={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...g}};function b(E){const u=E===2?"linux":E===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(E),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...g}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...g}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...g}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...g}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,r.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){M.Registry.as(O.Extensions.Configuration).registerConfiguration(w),y()}e.registerTerminalPlatformConfiguration=h;let p;function y(E,u){const d=M.Registry.as(O.Extensions.Configuration);let f;E&&(f=(0,C.createProfileSchemaEnums)(E?.profiles,u));const m=p;p={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:E?.os===3?f?.values:void 0,markdownEnumDescriptions:E?.os===3?f?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:E?.os===2?f?.values:void 0,markdownEnumDescriptions:E?.os===2?f?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:E?.os===1?f?.values:void 0,markdownEnumDescriptions:E?.os===1?f?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[p],remove:m?[m]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(ae[261],ce([0,1,26,13,35,9,4,36,25,12,21,126,257,256]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.getWindowsBuildNumber=p;async function y(i,n,l,S=C.env,R=v.Promises.exists){if(O.isAbsolute(i))return await R(i)?i:void 0;if(n===void 0&&(n=C.cwd()),O.dirname(i)!=="."){const _=O.join(n,i);return await R(_)?_:void 0}const P=(0,r.getCaseInsensitive)(S,"PATH");if(l===void 0&&(0,c.isString)(P)&&(l=P.split(O.delimiter)),l===void 0||l.length===0){const _=O.join(n,i);return await R(_)?_:void 0}for(const _ of l){let U;if(O.isAbsolute(_)?U=O.join(_,i):U=O.join(n,_,i),await R(U))return U;if(M.isWindows){let F=U+".com";if(await R(F)||(F=U+".exe",await R(F)))return F}}const D=O.join(n,i);return await R(D)?D:void 0}e.findExecutable=y;function E(i,n,l,S,R){const k=M.isWindows&&(!n.windowsEnableConpty||p()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||k)return;const P=i.args,D=C.platform==="win32"?O.basename(i.executable).toLowerCase():O.basename(i.executable),_=O.dirname(L.FileAccess.asFileUri("").fsPath);let U;const F={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(F.VSCODE_NONCE=n.shellIntegration.nonce),M.isWindows){if(D==="pwsh.exe"||D==="powershell.exe")return!P||o(P)?U=f.get(d.WindowsPwsh):t(P)&&(U=f.get(d.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,g.format)(U[U.length-1],_,""),n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:U,envMixin:F}):void 0;S.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(D){case"bash":return!P||P.length===0?U=f.get(d.Bash):s(P)&&(F.VSCODE_SHELL_LOGIN="1",u(n,F),U=f.get(d.Bash)),U?(U=[...U],U[U.length-1]=(0,g.format)(U[U.length-1],_),{newArgs:U,envMixin:F}):void 0;case"fish":{const H=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",j=O.join(_,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${H}:${j}`,u(n,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!P||o(P)?U=f.get(d.Pwsh):t(P)&&(U=f.get(d.PwshLogin)),U?(n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),U=[...U],U[U.length-1]=(0,g.format)(U[U.length-1],_,""),{newArgs:U,envMixin:F}):void 0;case"zsh":{if(!P||P.length===0?U=f.get(d.Zsh):s(P)?(U=f.get(d.ZshLogin),u(n,F)):(P===f.get(d.Zsh)||P===f.get(d.ZshLogin))&&(U=P),!U)return;U=[...U],U[U.length-1]=(0,g.format)(U[U.length-1],_);let H;try{H=I.userInfo().username}catch{H="unknown"}const j=O.join(I.tmpdir(),`${H}-${R.applicationName}-zsh`);F.ZDOTDIR=j;const le=l?.ZDOTDIR??I.homedir()??"~";F.USER_ZDOTDIR=le;const se=[];return se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(j,".zshrc")}),se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(j,".zprofile")}),se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(j,".zshenv")}),se.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(j,".zlogin")}),{newArgs:U,envMixin:F,filesToCopy:se}}}S.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=E;function u(i,n){if(M.isMacintosh&&i.environmentVariableCollections){const l=(0,w.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),R=new h.MergedEnvironmentVariableCollection(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),k=[];if(R)for(const P of R)P.type===b.EnvironmentVariableMutatorType.Prepend&&k.push(P.value);k.length>0&&(n.VSCODE_PATH_PREFIX=k.join(""))}}var d;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(d||(d={}));const f=new Map;f.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(d.Zsh,["-i"]),f.set(d.ZshLogin,["-il"]),f.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const m=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?m.includes(i.toLowerCase()):i.length===1&&m.includes(i[0].toLowerCase())||i.length===2&&(m.includes(i[0].toLowerCase())||m.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function s(i){return i==="string"&&m.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&m.includes(i[0].toLowerCase())}}),define(ae[262],ce([0,1,48,74,9,4,12,21,108,261,115]),function(K,e,I,L,r,O,M,C,g,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;var b;(function(l){l.UnixShellsPath="/etc/shells"})(b||(b={}));let w,h=!0;function p(l,S,R,k,P=process.env,D,_,U,F){return D=D||{existsFile:C.SymlinkSupport.existsFile,readFile:C.Promises.readFile},O.isWindows?y(R,D,P,_,k.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:k.getValue("terminal.integrated.profiles.windows"),typeof S=="string"?S:k.getValue("terminal.integrated.defaultProfile.windows"),F,U):s(D,_,R,l&&typeof l=="object"?{...l}:k.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof S=="string"?S:k.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,U,P)}e.detectAvailableProfiles=p;async function y(l,S,R,k,P,D,_,U,F){const H=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),j=`${process.env.windir}\\${H?"Sysnative":"System32"}`;let le=!1;(0,c.getWindowsBuildNumber)()>=16299&&(le=!0),await f(U);const se=new Map;if(l){se.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${j}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),se.set("Command Prompt",{path:`${j}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),se.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),se.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:L.Codicon.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;se.set("Cmder",{path:`${j}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}i(D,se);const ue=await E(se.entries(),_,S,R,k,F);if(l&&P)try{const Y=await t(`${j}\\${le?"wsl":"bash"}.exe`,_);for(const Q of Y)(!D||!(Q.profileName in D))&&ue.push(Q)}catch{h&&(k?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return ue}async function E(l,S,R,k=process.env,P,D){const _=[];for(const[U,F]of l)_.push(u(U,F,S,R,k,P,D));return(await Promise.all(_)).filter(U=>!!U)}async function u(l,S,R,k,P=process.env,D,_){if(S===null)return;let U,F,H;if("source"in S&&!("path"in S)){const ue=w?.get(S.source);if(!ue)return;U=ue.paths,F=S.args||ue.args,S.icon?H=d(S.icon):ue.icon&&(H=ue.icon)}else U=Array.isArray(S.path)?S.path:[S.path],F=O.isWindows||Array.isArray(S.args)?S.args:void 0,H=d(S.icon);let j;if(_){const ue=U.map(Q=>typeof Q=="string"?Q:Q.path),Y=await _(ue);j=new Array(U.length);for(let Q=0;Q<U.length;Q++)typeof U[Q]=="string"?j[Q]=Y[Q]:j[Q]={path:Y[Q],isUnsafe:!0}}else j=U.slice();let le;if(S.requiresPath){let ue;if((0,M.isString)(S.requiresPath)?ue=S.requiresPath:(ue=S.requiresPath.path,S.requiresPath.isUnsafe&&(le=ue)),!await k.existsFile(ue))return}const se=await n(l,R,j,k,P,F,S.env,S.overrideName,S.isAutoDetected,le);if(!se){D?.debug("Terminal profile not validated",l,U);return}return se.isAutoDetected=S.isAutoDetected,se.icon=H,se.color=S.color,se}function d(l){return typeof l=="string"?{id:l}:l}async function f(l){if(w&&!l)return;const[S,R]=await Promise.all([m(),l||a()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:S,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:R,icon:L.Codicon.terminalPowershell})}async function m(){const l=new Set,S=await(0,c.findExecutable)("git.exe");if(S){const P=(0,v.dirname)(S);l.add((0,v.resolve)(P,"../.."))}function R(P,D){D&&P.add(D)}R(l,process.env.ProgramW6432),R(l,process.env.ProgramFiles),R(l,process.env["ProgramFiles(X86)"]),R(l,`${process.env.LocalAppData}\\Program`);const k=[];for(const P of l)k.push(`${P}\\Git\\bin\\bash.exe`,`${P}\\Git\\usr\\bin\\bash.exe`,`${P}\\usr\\bin\\bash.exe`);return k.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),k.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),k}async function a(){const l=[];for await(const S of(0,g.enumeratePowerShellInstallations)())l.push(S.exePath);return l}async function t(l,S){const R=[],k=await new Promise((_,U)=>{I.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,H)=>{if(F)return U("Problem occurred when getting wsl distros");_(H)})});if(!k)return[];const P=new RegExp(/[\r?\n]/),D=k.split(P).filter(_=>_.trim().length>0&&_!=="");for(const _ of D){if(_===""||_.startsWith("docker-desktop"))continue;const U=`${_} (WSL)`,F={profileName:U,path:l,args:["-d",`${_}`],isDefault:U===S,icon:o(_),isAutoDetected:!1};R.push(F)}return R}function o(l){return l.includes("Ubuntu")?L.Codicon.terminalUbuntu:l.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function s(l,S,R,k,P,D,_,U){const F=new Map;if(R&&await l.existsFile("/etc/shells")){const H=(await l.readFile("/etc/shells")).toString(),j=(D||H.split(`
`)).map(se=>{const ue=se.indexOf("#");return ue===-1?se:se.substring(0,ue)}).filter(se=>se.trim().length>0),le=new Map;for(const se of j){let ue=(0,r.basename)(se),Y=le.get(ue)||0;Y++,Y>1&&(ue=`${ue} (${Y})`),le.set(ue,Y),F.set(ue,{path:se,isAutoDetected:!0})}}return i(k,F),await E(F.entries(),P,l,U,S,_)}function i(l,S){if(l)for(const[R,k]of Object.entries(l))k===null||typeof k!="object"||!("path"in k)&&!("source"in k)?S.delete(R):(k.icon=k.icon||S.get(R)?.icon,S.set(R,k))}async function n(l,S,R,k,P,D,_,U,F,H){if(R.length===0)return Promise.resolve(void 0);const j=R.shift();if(j==="")return n(l,S,R,k,P,D,_,U,F);const le=typeof j!="string"&&j.isUnsafe,se=typeof j=="string"?j:j.path,ue={profileName:l,path:se,args:D,env:_,overrideName:U,isAutoDetected:F,isDefault:l===S,isUnsafePath:le,requiresUnsafePath:H};if((0,r.basename)(se)===se){const Q=P.PATH?P.PATH.split(r.delimiter):void 0,q=await(0,c.findExecutable)(se,void 0,Q,void 0,k.existsFile);return q?(ue.path=q,ue.isFromPath=!0,ue):n(l,S,R,k,P,D)}return await k.existsFile((0,r.normalize)(se))?ue:n(l,S,R,k,P,D,_,U,F)}}),define(ae[263],ce([0,1,3,2,4,43,18,5,226,95,258,127,260,262,110,72]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let u=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(f,m,a,t){super(),this._ptyHostStarter=f,this._configurationService=m,this._logService=a,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new I.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new I.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new I.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new I.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new I.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new I.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new I.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new I.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new I.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new I.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new I.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new I.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&I.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,c.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(f){return this._logService.error("ptyHost was unable to resolve shell environment",f),{}}}_startPtyHost(){const f=this._ptyHostStarter.start(),m=f.client;this._logService.getLevel()===C.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(m.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(f.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=O.ProxyChannel.toService(m.getChannel(b.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(o=>this._onProcessData.fire(o))),this._register(t.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(t.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(t.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(t.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(t.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(t.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),this._register(new g.RemoteLoggerChannelClient(this._loggerService,m.getChannel(b.TerminalIpcChannels.Logger))),this.__connection=f,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[f,t]}async createProcess(f,m,a,t,o,s,i,n,l,S,R){const k=setTimeout(()=>this._handleUnresponsiveCreateProcess(),b.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(f,m,a,t,o,s,i,n,l,S,R);return clearTimeout(k),P}updateTitle(f,m,a){return this._proxy.updateTitle(f,m,a)}updateIcon(f,m,a,t){return this._proxy.updateIcon(f,m,a,t)}attachToProcess(f){return this._proxy.attachToProcess(f)}detachFromProcess(f,m){return this._proxy.detachFromProcess(f,m)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(f){return this._proxy.start(f)}shutdown(f,m){return this._proxy.shutdown(f,m)}input(f,m){return this._proxy.input(f,m)}processBinary(f,m){return this._proxy.processBinary(f,m)}resize(f,m,a){return this._proxy.resize(f,m,a)}clearBuffer(f){return this._proxy.clearBuffer(f)}acknowledgeDataEvent(f,m){return this._proxy.acknowledgeDataEvent(f,m)}setUnicodeVersion(f,m){return this._proxy.setUnicodeVersion(f,m)}getInitialCwd(f){return this._proxy.getInitialCwd(f)}getCwd(f){return this._proxy.getCwd(f)}async getLatency(){const f=new y.StopWatch,m=await this._proxy.getLatency();return f.stop(),[{label:"ptyhostservice<->ptyhost",latency:f.elapsed()},...m]}orphanQuestionReply(f){return this._proxy.orphanQuestionReply(f)}installAutoReply(f,m){return this._proxy.installAutoReply(f,m)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(f){return this._proxy.uninstallAutoReply(f)}getDefaultSystemShell(f){return this._optionalProxy?.getDefaultSystemShell(f)??(0,p.getSystemShell)(f??r.OS,process.env)}async getProfiles(f,m,a,t=!1){const o=await this._resolveShellEnv();return(0,h.detectAvailableProfiles)(m,a,t,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,f))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(f,m){return this._proxy.getWslPath(f,m)}getRevivedPtyNewId(f,m){return this._proxy.getRevivedPtyNewId(f,m)}setTerminalLayoutInfo(f){return this._proxy.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return this._optionalProxy?.getTerminalLayoutInfo(f)}async requestDetachInstance(f,m){return this._proxy.requestDetachInstance(f,m)}async acceptDetachInstanceReply(f,m){return this._proxy.acceptDetachInstanceReply(f,m)}async freePortKillProcess(f){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(f)}async serializeTerminalState(f){return this._proxy.serializeTerminalState(f)}async reviveTerminalProcesses(f,m,a){return this._proxy.reviveTerminalProcesses(f,m,a)}async refreshProperty(f,m){return this._proxy.refreshProperty(f,m)}async updateProperty(f,m,a){return this._proxy.updateProperty(f,m,a)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(f){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(f,m){return this._resolveVariablesRequestStore.createRequest({workspaceId:f,originalText:m})}async acceptPtyHostResolvedVariables(f,m){this._resolveVariablesRequestStore.acceptReply(f,m)}};e.PtyHostService=u,e.PtyHostService=u=be([re(1,M.IConfigurationService),re(2,C.ILogService),re(3,C.ILoggerService)],u)}),define(ae[69],ce([0,1,14,3,2,4,18,6,34]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const c="#FFFFFF",v="#1E1E1E",b="#000000",w="#FFFFFF",h="theme",p="themeBackground",y="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let E=class extends r.Disposable{constructor(d,f){super(),this.stateService=d,this.configurationService=f,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._register(this.configurationService.onDidChangeConfiguration(m=>{m.affectsConfiguration("window.systemColorTheme")&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(L.Event.fromNodeEventEmitter(I.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){switch(this.configurationService.getValue("window.systemColorTheme")){case"dark":I.nativeTheme.themeSource="dark";break;case"light":I.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":I.nativeTheme.themeSource="light";break;case"vs-dark":I.nativeTheme.themeSource="dark";break;default:I.nativeTheme.themeSource="system"}break;default:I.nativeTheme.themeSource="system";break}}getColorScheme(){if(O.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return d.dark?b:w;let f=this.stateService.getItem(p,null);if(!f)switch(this.getBaseTheme()){case"vs":f=c;break;case"hc-black":f=b;break;case"hc-light":f=w;break;default:f=v}return O.isMacintosh&&f.toUpperCase()===v&&(f="#171717"),f}getBaseTheme(){switch(this.stateService.getItem(h,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(d,f){this.stateService.setItems([{key:h,data:f.baseTheme},{key:p,data:f.colorInfo.background},{key:y,data:f}]),typeof d=="number"&&this.updateBackgroundColor(d,f),this.updateSystemColorTheme()}updateBackgroundColor(d,f){for(const m of I.BrowserWindow.getAllWindows())if(m.id===d){m.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(y)}};e.ThemeMainService=E,e.ThemeMainService=E=be([re(0,g.IStateService),re(1,M.IConfigurationService)],E)}),define(ae[128],ce([0,1,3,18,6,5]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var M;(function(E){E.Http="http",E.Https="https"})(M||(e.TunnelProtocol=M={}));var C;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(C||(e.TunnelPrivacyId=C={}));function g(E){return!!E.forwardPort}e.isTunnelProvider=g;var c;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function v(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=w;function h(E,u,d,f){if(d===1)return!1;if(d===2&&w(u)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(m?.length===4&&parseInt(m[1])>=18)return!1}return E<1024}e.isPortPrivileged=h;class p{constructor(u,d,f){this.remoteAddress=u,this.localAddress=d,this._dispose=f,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let y=class{constructor(u,d){this.logService=u,this.configurationService=d,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions,this._canChangeProtocol=u.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(const f of d){const m=Array.from(f.values());for(const a of m){const t=await a.value;t&&typeof t!="string"&&u.push(t)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(f=>typeof f!="string"?f?.dispose():void 0);u.clear()}this._tunnels.clear()}setEnvironmentTunnel(u,d,f,m,a){this.addTunnelToMap(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:f,privacy:m,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(w(u)||b(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const f=this.getTunnelFromMap(u,d);if(f)return++f.refcount,f.value}openTunnel(u,d,f,m,a,t=!1,o,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${a}.`);const i=this._tunnelProvider??u;if(!i)return;if(d||(d="localhost"),m||(m=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(i,d,f,m,a,t,o,s);return n?n.then(l=>{if(l){if(typeof l=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,f),l}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.makeTunnel(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(S),S}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const f=d.get(u.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,f))}}}}async tryDisposeTunnel(u,d,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const m=f.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),m}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const f=this._tunnels.get(u);if(f&&f.has(d)){const m=f.get(d);m.refcount=0,await this.tryDisposeTunnel(u,d,m)}}addTunnelToMap(u,d,f){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:f})}async removeEmptyOrErrorTunnelFromMap(u,d){const f=this._tunnels.get(u);if(f){const m=f.get(d),a=m?await m.value:void 0;(!a||typeof a=="string")&&f.delete(d),f.size===0&&this._tunnels.delete(u)}}getTunnelFromMap(u,d){const f=[u];b(u)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):w(u)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const m=f.map(a=>this._tunnels.get(a));for(const a of m){const t=a?.get(d);if(t)return t}}canTunnel(u){return!!v(u)}createWithProvider(u,d,f,m,a,t,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${m}.`);const s=f;this._factoryInProgress.add(s);const i=m===void 0?f:m,n={elevationRequired:a?this.isPortPrivileged(i):!1},l={remoteAddress:{host:d,port:f},localAddressPort:m,privacy:t,public:t?t!==C.Private:void 0,protocol:o},S=u.forwardPort(l,n);return S?(this.addTunnelToMap(d,f,S),S.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),S}};e.AbstractTunnelService=y,e.AbstractTunnelService=y=be([re(0,O.ILogService),re(1,L.IConfigurationService)],y)}),define(ae[49],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.Disabled="disabled",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L||(e.StateType=L={}));var r;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap",M[M.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={}));var O;(function(M){M[M.NotBuilt=0]="NotBuilt",M[M.DisabledByEnvironment=1]="DisabledByEnvironment",M[M.ManuallyDisabled=2]="ManuallyDisabled",M[M.MissingConfiguration=3]="MissingConfiguration",M[M.InvalidConfiguration=4]="InvalidConfiguration",M[M.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:M=>({type:"disabled",reason:M}),Idle:(M,C)=>({type:"idle",updateType:M,error:C}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ae[264],ce([0,1,4,188,52,44]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[265],ce([0,1,3,49]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(C){this.service=C}listen(C,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(C,g,c){switch(g){case"checkForUpdates":return this.service.checkForUpdates(c);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(c)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=r;class O{get state(){return this._state}set state(C){this._state=C,this._onStateChange.fire(C)}constructor(C){this.channel=C,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(C){return this.channel.call("checkForUpdates",C)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(C){return this.channel.call("_applySpecificUpdate",C)}}e.UpdateChannelClient=O}),define(ae[40],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ae[266],ce([0,1,40,207,16,19,141,3,2]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{static{this._clock=0}constructor(w){this.uri=w,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let v=class{constructor(w){this._fileService=w,this._dispooables=new g.DisposableStore,this._limit=2**16;const h=new Map,p=y=>{let E=h.get(y.scheme);return E===void 0&&(E=w.hasProvider(y)&&!this._fileService.hasCapability(y,1024),h.set(y.scheme,E)),E};this._dispooables.add(C.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new O.ExtUri(p),this._canonicalUris=new M.SkipList((y,E)=>this.extUri.compare(y,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,O.normalizePath)(w));const h=this._canonicalUris.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new c(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((p,y)=>p[1].time<y[1].time?1:p[1].time>y[1].time?-1:0);c._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let p=0;p<h;p++)this._canonicalUris.set(w[p][0],w[p][1].touch())}};e.UriIdentityService=v,e.UriIdentityService=v=be([re(0,r.IFileService)],v),(0,L.registerSingleton)(I.IUriIdentityService,v,1)}),define(ae[129],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ae[267],ce([0,1,7]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(C){this.handler=C}listen(C,g){throw new Error(`Event not found: ${g}`)}call(C,g,c){switch(g){case"handleURL":return this.handler.handleURL(I.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=L;class r{constructor(C){this.channel=C}handleURL(C,g){return this.channel.call("handleURL",[C.toJSON(),g])}}e.URLHandlerChannelClient=r;class O{constructor(C,g){this.next=C,this.logService=g}async routeCall(C,g,c,v){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(c)&&c.length>0){const b=I.URI.revive(c[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const w=/\bwindowId=(\d+)/.exec(b.query);if(w){const h=w[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,b.toString(!0));const p=new RegExp(`window:${h}`),y=C.connections.find(E=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",E.ctx),p.test(E.ctx)));if(y)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),y;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(C,g,c,v)}routeEvent(C,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=O}),define(ae[268],ce([0,1,8,2,7,27]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(c,v){const b=[...this.handlers.values()];return(0,I.first)(b.map(w=>()=>w.handleURL(c,v)),void 0,!1).then(w=>w||!1)}registerHandler(c){return this.handlers.add(c),(0,L.toDisposable)(()=>this.handlers.delete(c))}}e.AbstractURLService=M;let C=class extends M{constructor(c){super(),this.productService=c}create(c){let{authority:v,path:b,query:w,fragment:h}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return v&&b&&b.indexOf("/")!==0&&(b=`/${b}`),r.URI.from({scheme:this.productService.urlProtocol,authority:v,path:b,query:w,fragment:h})}};e.NativeURLService=C,e.NativeURLService=C=be([re(0,O.IProductService)],C)}),define(ae[269],ce([0,1,14,8,3,2,4,7]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class g extends O.Disposable{constructor(v,b,w,h,p,y){if(super(),this.urlService=b,this.logService=y,this.uris=[],this.retryCount=0,v&&(y.trace("ElectronURLListener initialUrisToHandle:",v.map(d=>d.originalUrl)),this.uris=v),M.isWindows){const d=h.isBuilt?[]:[`"${h.appRoot}"`];d.push("--open-url","--"),I.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,d)}const E=r.Event.map(r.Event.fromNodeEventEmitter(I.app,"open-url",(d,f)=>({event:d,url:f})),({event:d,url:f})=>(d.preventDefault(),f));this._register(E(d=>{const f=this.uriFromRawUrl(d);f&&this.urlService.open(f,{originalUrl:d})})),w.getWindows().filter(d=>d.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(r.Event.once(w.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(v){try{return C.URI.parse(v)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const v=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),v.push(b));v.length!==0&&(this.uris=v,(0,L.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=g}),define(ae[270],ce([0,1,3,2,16,59,31]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends L.Disposable{constructor(c,v,b,w,h,p){super(),this.fileSystemScheme=c,this.fileSystemProvider=v,this.userDataScheme=b,this.userDataProfilesService=w,this.uriIdentityService=h,this.logService=p,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new M.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(w.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const c of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(c.settingsResource),this.atomicReadWriteResources.add(c.keybindingsResource),this.atomicReadWriteResources.add(c.tasksResource),this.atomicReadWriteResources.add(c.extensionsResource)}open(c,v){return this.fileSystemProvider.open(this.toFileSystemResource(c),v)}close(c){return this.fileSystemProvider.close(c)}read(c,v,b,w,h){return this.fileSystemProvider.read(c,v,b,w,h)}write(c,v,b,w,h){return this.fileSystemProvider.write(c,v,b,w,h)}watch(c,v){this.watchResources.set(c,c);const b=this.fileSystemProvider.watch(this.toFileSystemResource(c),v);return(0,L.toDisposable)(()=>{this.watchResources.delete(c),b.dispose()})}stat(c){return this.fileSystemProvider.stat(this.toFileSystemResource(c))}mkdir(c){return this.fileSystemProvider.mkdir(this.toFileSystemResource(c))}rename(c,v,b){return this.fileSystemProvider.rename(this.toFileSystemResource(c),this.toFileSystemResource(v),b)}readFile(c,v){return this.fileSystemProvider.readFile(this.toFileSystemResource(c),v)}readFileStream(c,v,b){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(c),v,b)}readdir(c){return this.fileSystemProvider.readdir(this.toFileSystemResource(c))}enforceAtomicReadFile(c){return this.atomicReadWriteResources.has(c)}writeFile(c,v,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(c),v,b)}enforceAtomicWriteFile(c){return this.atomicReadWriteResources.has(c)?{postfix:".vsctmp"}:!1}delete(c,v){return this.fileSystemProvider.delete(this.toFileSystemResource(c),v)}copy(c,v,b){if((0,r.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(c),this.toFileSystemResource(v),b);throw new Error("copy not supported")}cloneFile(c,v){if((0,r.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(c),this.toFileSystemResource(v));throw new Error("clone not supported")}handleFileChanges(c){const v=[];for(const b of c){if(b.resource.scheme!==this.fileSystemScheme)continue;const w=this.toUserDataResource(b.resource);this.watchResources.findSubstr(w)&&v.push({resource:w,type:b.type,cId:b.cId})}v.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(v))}toFileSystemResource(c){return c.with({scheme:this.fileSystemScheme})}toUserDataResource(c){return c.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(ae[271],ce([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ae[272],ce([0,1,6]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ae[273],ce([0,1,14,2,13,7]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const g=this.handleWebviewRequest.bind(this);I.protocol.registerFileProtocol(r.Schemas.vscodeWebview,g)}handleWebviewRequest(g,c){try{const v=O.URI.parse(g.url),b=M.validWebviewFilePaths.get(v.path);if(typeof b=="string"){const w=`vs/workbench/contrib/webview/browser/pre/${b}`,h=r.FileAccess.asFileUri(w);return c({path:h.fsPath,headers:{...r.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.WebviewProtocolProvider=M}),define(ae[55],ce([0,1,4]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useNativeFullScreen=e.useWindowControlsOverlay=e.getTitleBarStyle=e.hasNativeTitlebar=e.hasCustomTitlebar=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.isOpenedAuxiliaryWindow=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(u){return typeof u.parentId=="number"}e.isOpenedAuxiliaryWindow=L;function r(u){return!!u.workspaceUri}e.isWorkspaceToOpen=r;function O(u){return!!u.folderUri}e.isFolderToOpen=O;function M(u){return!!u.fileUri}e.isFileToOpen=M;function C(u){const d=w(u),f=u.getValue("window.menuBarVisibility");return f==="default"||d&&f==="compact"||I.isMacintosh&&I.isNative?"classic":f}e.getMenuBarVisibility=C;var g;(function(u){u.TITLE_BAR_STYLE="window.titleBarStyle",u.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(g||(e.TitleBarSetting=g={}));var c;(function(u){u.NATIVE="native",u.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var v;(function(u){u.AUTO="auto",u.WINDOWED="windowed",u.NEVER="never"})(v||(e.CustomTitleBarVisibility=v={}));function b(u,d){return!0}e.hasCustomTitlebar=b;function w(u,d){return d||(d=h(u)),d==="native"}e.hasNativeTitlebar=w;function h(u){if(I.isWeb)return"custom";const d=u.getValue("window");if(d){if(I.isMacintosh&&d.nativeTabs===!0||I.isMacintosh&&d.nativeFullScreen===!1)return"native";const a=d.titleBarStyle;if(a==="native"||a==="custom")return a}return I.isLinux?"native":"custom"}e.getTitleBarStyle=h;function p(u){return!(!I.isWindows||I.isWeb||w(u))}e.useWindowControlsOverlay=p;function y(u){const d=u.getValue("window");return!d||typeof d.nativeFullScreen!="boolean"||d.nativeTabs?!0:d.nativeFullScreen!==!1}e.useNativeFullScreen=y;function E(u=0){return Math.pow(1.2,u)}e.zoomLevelToZoomFactor=E}),define(ae[81],ce([0,1,14]),function(K,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var L;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(L||(e.LoadReason=L={}));var r;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(r||(e.UnloadReason=r={}));const O=function(c=1){return{width:1024,height:768,mode:c}};e.defaultWindowState=O;const M=function(){const b=I.screen.getPrimaryDisplay().workArea,w=Math.max(b.x+b.width/2-800/2,0),h=Math.max(b.y+b.height/2-600/2,0);return{x:w,y:h,width:800,height:600,mode:1}};e.defaultAuxWindowState=M;var C;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(C||(e.WindowMode=C={}));var g;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(g||(e.WindowError=g={}))}),define(ae[274],ce([0,1,8,3,2]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends r.Disposable{constructor({onDidOpenMainWindow:C,onDidFocusMainWindow:g,getActiveWindowId:c}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(C,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,I.createCancelablePromise)(()=>c()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=O}),define(ae[30],ce([0,1,192,9,59,19,7,6,13]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function v(i){return typeof i?.id=="string"&&!c(i)&&!w(i)}e.isEmptyWorkspaceIdentifier=v,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=b;function w(i){const n=i;return typeof n?.id=="string"&&M.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=w;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:M.URI.revive(n.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:M.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=h;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=y;function E(i){const n=i;return!!(n&&typeof n=="object"&&M.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=E;class u{constructor(n,l,S,R,k){this._id=n,this._transient=S,this._configuration=R,this._ignorePathCasing=k,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=l}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function f(i){return new d({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(i,n){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function a(i){let n;return M.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=a,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function o(i,n){return!m(i,n)&&!a(i)}e.isSavedWorkspace=o;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ae[56],ce([0,1,14,8,45,47,2,86,4,21,167,117,6,5,27,30]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let E=class{constructor(d,f){this.logService=d,this.productService=f,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(d,f){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},f)}pickFolder(d,f){return this.doPick({...d,pickFolders:!0,title:(0,v.localize)(1,null)},f)}pickFile(d,f){return this.doPick({...d,pickFiles:!0,title:(0,v.localize)(2,null)},f)}pickWorkspace(d,f){const m=(0,v.localize)(3,null),a=(0,O.mnemonicButtonLabel)((0,v.localize)(4,null)),t=y.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:m,filters:t,buttonLabel:a},f)}async doPick(d,f){const m={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(m.properties=void 0,d.pickFiles&&d.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&m.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(m,(f||I.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}getWindowDialogQueue(d){if(d){let f=this.windowDialogQueues.get(d.id);return f||(f=new L.Queue,this.windowDialogQueues.set(d.id,f)),f}else return this.noWindowDialogueQueue}showMessageBox(d,f){return this.getWindowDialogQueue(f).queue(async()=>{const{options:m,buttonIndeces:a}=(0,b.massageMessageBoxOptions)(d,this.productService);let t;return f?t=await I.dialog.showMessageBox(f,m):t=await I.dialog.showMessageBox(m),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(d,f){const m=this.acquireFileDialogLock(d,f);if(!m)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(f).queue(async()=>{let a;return f?a=await I.dialog.showSaveDialog(f,d):a=await I.dialog.showSaveDialog(d),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,M.dispose)(m)}}normalizePath(d){return d&&g.isMacintosh&&(d=(0,C.normalizeNFC)(d)),d}normalizePaths(d){return d.map(f=>this.normalizePath(f))}async showOpenDialog(d,f){d.defaultPath&&(await c.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const m=this.acquireFileDialogLock(d,f);if(!m)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(f).queue(async()=>{let a;return f?a=await I.dialog.showOpenDialog(f,d):a=await I.dialog.showOpenDialog(d),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,M.dispose)(m)}}acquireFileDialogLock(d,f){if(!f)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let m=this.windowFileDialogLocks.get(f.id);m||(m=new Set,this.windowFileDialogLocks.set(f.id,m));const a=(0,r.hash)(d);if(!m.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),m.add(a),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),m?.delete(a),m?.size===0&&this.windowFileDialogLocks.delete(f.id)})}};e.DialogMainService=E,e.DialogMainService=E=be([re(0,h.ILogService),re(1,p.IProductService)],E)}),define(ae[275],ce([0,1,3,2,76,30]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(g,c){super(),this.logService=g,this.storageMainService=c,this.onDidChangeApplicationStorageEmitter=this._register(new I.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(c.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(g,c){this._register(I.Event.debounce(g.onDidChangeStorage,(v,b)=>(v?v.push(b):v=[b],v),M.STORAGE_CHANGE_DEBOUNCE_TIME)(v=>{v.length&&c.fire(this.serializeStorageChangeEvents(v,g))}))}serializeStorageChangeEvents(g,c){const v=new Map,b=new Set;return g.forEach(w=>{const h=c.get(w.key);typeof h=="string"?v.set(w.key,h):b.add(w.key)}),{changed:Array.from(v.entries()),deleted:Array.from(b.values())}}listen(g,c,v){switch(c){case"onDidChangeStorage":{const b=v.profile?(0,r.revive)(v.profile):void 0;if(!b)return this.onDidChangeApplicationStorageEmitter.event;let w=this.mapProfileToOnDidChangeProfileStorageEmitter.get(b.id);return w||(w=this._register(new I.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(b),w),this.mapProfileToOnDidChangeProfileStorageEmitter.set(b.id,w)),w.event}}throw new Error(`Event not found: ${c}`)}async call(g,c,v){const b=v.profile?(0,r.revive)(v.profile):void 0,w=(0,O.reviveIdentifier)(v.workspace),h=await this.withStorageInitialized(b,w);switch(c){case"getItems":return Array.from(h.items.entries());case"updateItems":{const p=v;if(p.insert)for(const[y,E]of p.insert)h.set(y,E);p.delete?.forEach(y=>h.delete(y));break}case"optimize":return h.optimize();case"isUsed":{const p=v.payload;if(typeof p=="string")return this.storageMainService.isUsed(p)}default:throw new Error(`Call not found: ${c}`)}}async withStorageInitialized(g,c){let v;c?v=this.storageMainService.workspaceStorage(c):g?v=this.storageMainService.profileStorage(g):v=this.storageMainService.applicationStorage;try{await v.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${c?"workspace":g?"profile":"application"} storage due to ${b}`)}return v}}e.StorageDatabaseChannel=M}),define(ae[41],ce([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var f;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(f||(e.ProfileResourceType=f={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&M.URI.isUri(n.location)&&M.URI.isUri(n.globalStorageHome)&&M.URI.isUri(n.settingsResource)&&M.URI.isUri(n.keybindingsResource)&&M.URI.isUri(n.tasksResource)&&M.URI.isUri(n.snippetsHome)&&M.URI.isUri(n.extensionsResource))}e.isUserDataProfile=m,e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function a(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:M.URI.revive(i.location).with({scheme:n}),globalStorageHome:M.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:M.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:M.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:M.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:M.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:M.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:M.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=a;function t(i,n,l,S,R,k){return{id:i,name:n,location:l,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:k&&R?.useDefaultFlags?.globalState?k.globalStorageHome:(0,O.joinPath)(l,"globalStorage"),settingsResource:k&&R?.useDefaultFlags?.settings?k.settingsResource:(0,O.joinPath)(l,"settings.json"),keybindingsResource:k&&R?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,O.joinPath)(l,"keybindings.json"),tasksResource:k&&R?.useDefaultFlags?.tasks?k.tasksResource:(0,O.joinPath)(l,"tasks.json"),snippetsHome:k&&R?.useDefaultFlags?.snippets?k.snippetsHome:(0,O.joinPath)(l,"snippets"),extensionsResource:k&&R?.useDefaultFlags?.extensions?k.extensionsResource:(0,O.joinPath)(l,"extensions.json"),cacheHome:(0,O.joinPath)(S,i),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.toUserDataProfile=t;let o=class extends r.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,l,S,R){super(),this.environmentService=n,this.fileService=l,this.uriIdentityService=S,this.logService=R,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),l=[n];if(this.enabled)try{for(const k of this.getStoredProfiles()){if(!k.name||!(0,d.isString)(k.name)||!k.location){this.logService.warn("Skipping the invalid stored profile",k.location||k.name);continue}l.push(t((0,O.basename)(k.location),k.name,k.location,this.profilesCacheHome,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},n))}}catch(k){this.logService.error(k)}const S=new h.ResourceMap,R=new Map;if(l.length)try{const k=this.getStoredProfileAssociations();if(k.workspaces)for(const[P,D]of Object.entries(k.workspaces)){const _=M.URI.parse(P),U=l.find(F=>F.id===D);U&&S.set(_,U)}if(k.emptyWindows)for(const[P,D]of Object.entries(k.emptyWindows)){const _=l.find(U=>U.id===D);_&&R.set(P,_)}}catch(k){this.logService.error(k)}this._profilesObject={profiles:l,workspaces:S,emptyWindows:R}}return this._profilesObject}createDefaultProfile(){const n=t("__default__profile__",(0,C.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",S=new RegExp(`${(0,u.escapeRegExpCharacters)(l)}\\s(\\d+)`);let R=0;for(const P of this.profiles){const D=S.exec(P.name),_=D?parseInt(D[1]):0;R=_>R?_:R}const k=`${l} ${R+1}`;return this.createProfile((0,I.hash)((0,E.generateUuid)()).toString(16),k,{transient:!0},n)}async createNamedProfile(n,l,S){return this.createProfile((0,I.hash)((0,E.generateUuid)()).toString(16),n,l,S)}async createProfile(n,l,S,R){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const k=await this.doCreateProfile(n,l,S);return R&&await this.setProfileForWorkspace(R,k),k}async doCreateProfile(n,l,S){if(!(0,d.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.profileCreationPromises.get(l);return R||(R=(async()=>{try{const k=this.profiles.find(_=>_.name===l||_.id===n);if(k)return k;const P=t(n,l,(0,O.joinPath)(this.profilesHome,n),this.profilesCacheHome,S,this.defaultProfile);await this.fileService.createFolder(P.location);const D=[];return this._onWillCreateProfile.fire({profile:P,join(_){D.push(_)}}),await y.Promises.settled(D),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(l)}})(),this.profileCreationPromises.set(l,R)),R}async updateProfile(n,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(R=>R.id===n.id);if(!S)throw new Error(`Profile '${n.name}' does not exist`);return S=t(S.id,l.name??S.name,S.location,this.profilesCacheHome,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[S]),S}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(R=>R.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:l,join(R){S.push(R)}});try{await Promise.allSettled(S)}catch(R){this.logService.error(R)}for(const R of[...this.profilesObject.emptyWindows.keys()])l.id===this.profilesObject.emptyWindows.get(R)?.id&&this.profilesObject.emptyWindows.delete(R);for(const R of[...this.profilesObject.workspaces.keys()])l.id===this.profilesObject.workspaces.get(R)?.id&&this.profilesObject.workspaces.delete(R);this.updateStoredProfileAssociations(),this.updateProfiles([],[l],[]);try{await this.fileService.del(l.cacheHome,{recursive:!0})}catch(R){(0,c.toFileOperationResult)(R)!==1&&this.logService.error(R)}}async setProfileForWorkspace(n,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(R=>R.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.updateWorkspaceAssociation(n,S)}unsetWorkspace(n,l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,l)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,l.resource))).map(l=>this.fileService.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(l=>!this.isProfileAssociatedToWorkspace(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.getWorkspace(n);return M.URI.isUri(l)?this.transientProfilesObject.workspaces.get(l)??this.profilesObject.workspaces.get(l):this.transientProfilesObject.emptyWindows.get(l)??this.profilesObject.emptyWindows.get(l)}getWorkspace(n){return(0,w.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,w.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location))||[...this.profilesObject.workspaces.values()].some(l=>this.uriIdentityService.extUri.isEqual(l.location,n.location)))}updateProfiles(n,l,S){const R=[...this.profiles,...n],k=[];this.transientProfilesObject.profiles=[];for(let P of R)P.isDefault||l.some(D=>P.id===D.id)||(P=S.find(D=>P.id===D.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):k.push({location:P.location,name:P.name,shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(k),this._profilesObject=void 0,this.triggerProfilesChanges(n,l,S)}triggerProfilesChanges(n,l,S){this._onDidChangeProfiles.fire({added:n,removed:l,updated:S,all:this.profiles})}updateWorkspaceAssociation(n,l,S){S=l?.isTransient?!0:S,S||this.updateWorkspaceAssociation(n,void 0,!0);const R=this.getWorkspace(n),k=S?this.transientProfilesObject:this.profilesObject;M.URI.isUri(R)?(k.workspaces.delete(R),l&&k.workspaces.set(R,l)):(k.emptyWindows.delete(R),l&&k.emptyWindows.set(R,l)),S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[S,R]of this.profilesObject.workspaces.entries())n[S.toString()]=R.id;const l={};for(const[S,R]of this.profilesObject.emptyWindows.entries())l[S.toString()]=R.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:l}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const l={},S=this.createDefaultProfile();if(n.workspaces)for(const[k,P]of Object.entries(n.workspaces)){const D=M.URI.parse(P);l[k]=this.uriIdentityService.extUri.isEqual(D,S.location)?S.id:this.uriIdentityService.extUri.basename(D)}const R={};if(n.emptyWindows)for(const[k,P]of Object.entries(n.emptyWindows)){const D=M.URI.parse(P);R[k]=this.uriIdentityService.extUri.isEqual(D,S.location)?S.id:this.uriIdentityService.extUri.basename(D)}return{workspaces:l,emptyWindows:R}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=be([re(0,g.IEnvironmentService),re(1,c.IFileService),re(2,p.IUriIdentityService),re(3,b.ILogService)],o);class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(ae[82],ce([0,1,8,17,2,3,31,7,119,125,16,6,5,41,40,12,15,28]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class f extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let m=class extends r.Disposable{constructor(s,i,n,l,S,R){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=l,this.telemetryService=S,this.logService=R,this._onAddExtensions=this._register(new O.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new O.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new O.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new O.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new M.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i){const n=[],l=[];try{return await this.withProfileExtensions(i,S=>{const R=[];for(const k of S)s.some(([P])=>(0,c.areSameExtensions)(P.identifier,k.identifier)&&P.manifest.version!==k.version)?n.push(k):R.push(k);for(const[k,P]of s){const D=R.findIndex(U=>(0,c.areSameExtensions)(U.identifier,k.identifier)&&U.version===k.manifest.version),_={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:P};D===-1?(l.push(_),R.push(_)):R.splice(D,1,_)}return l.length&&this._onAddExtensions.fire({extensions:l,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),R}),l.length&&this._onDidAddExtensions.fire({extensions:l,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),l}catch(S){throw l.length&&this._onDidAddExtensions.fire({extensions:l,error:S,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:S,profileLocation:i}),S}}async updateMetadata(s,i){const n=[];return await this.withProfileExtensions(i,l=>{const S=[];for(const R of l){const k=s.find(([P])=>(0,c.areSameExtensions)(P.identifier,R.identifier)&&P.manifest.version===R.version);k&&(R.metadata={...R.metadata,...k[1]},n.push(R)),S.push(R)}return S}),n}async removeExtensionFromProfile(s,i){const n=[];try{await this.withProfileExtensions(i,l=>{const S=[];for(const R of l)(0,c.areSameExtensions)(R.identifier,s.identifier)?n.push(R):S.push(R);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),S}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(l){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:l,profileLocation:i}),l}}async withProfileExtensions(s,i,n){return this.getResourceAccessQueue(s).queue(async()=>{let l=[],S;try{const R=await this.fileService.readFile(s);S=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,v.toFileOperationResult)(R)!==1)throw R;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(S=await this.migrateFromOldDefaultProfileExtensionsLocation()),!S&&n?.bailOutWhenFileNotFound)throw new f((0,E.getErrorMessage)(R),"ERROR_PROFILE_NOT_FOUND")}if(S){Array.isArray(S)||this.reportAndThrowInvalidConentError(s);let R=!1;for(const k of S){a(k)||this.reportAndThrowInvalidConentError(s);let P;if((0,y.isString)(k.relativeLocation)&&k.relativeLocation)P=this.resolveExtensionLocation(k.relativeLocation);else if((0,y.isString)(k.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{P=C.URI.revive(k.location);const D=this.toRelativePath(P);D&&(R=!0,k.relativeLocation=D)}(0,y.isUndefined)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(R=!0,k.metadata.hasPreReleaseVersion=!0),l.push({identifier:k.identifier,location:P,version:k.version,metadata:k.metadata})}R&&await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(S)))}if(i){l=i(l);const R=l.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.toRelativePath(k.location),metadata:k.metadata}));await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(R)))}return l})}reportAndThrowInvalidConentError(s){const i=new f(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(S){if((0,v.toFileOperationResult)(S)===1)return;throw S}this.logService.info("Migrating extensions from old default profile location",s.toString());let l;try{const S=JSON.parse(n);Array.isArray(S)&&S.every(R=>a(R))?l=S:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.logService.error(S)}if(l)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(S){if((0,v.toFileOperationResult)(S)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw S}try{await this.fileService.del(s)}catch(S){(0,v.toFileOperationResult)(S)!==1&&this.logService.error(S)}try{await this.fileService.del(i)}catch(S){(0,v.toFileOperationResult)(S)!==1&&this.logService.error(S)}return l})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new I.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=m,e.AbstractExtensionsProfileScannerService=m=be([re(1,v.IFileService),re(2,h.IUserDataProfilesService),re(3,p.IUriIdentityService),re(4,u.ITelemetryService),re(5,w.ILogService)],m);function a(o){return(0,y.isObject)(o)&&(0,g.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,y.isString)(o.location)&&o.location)&&((0,y.isUndefined)(o.relativeLocation)||(0,y.isString)(o.relativeLocation))&&o.version&&(0,y.isString)(o.version)}function t(o){return o?(0,y.isString)(o.path)&&(0,y.isString)(o.scheme):!1}}),define(ae[130],ce([0,1,22,8,35,17,15,42,152,2,13,9,4,19,205,73,12,7,172,38,125,122,204,16,6,5,27,3,76,82,41,40,203]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n,l,S,R,k,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(ue){function Y(Q,q){if(Q===q)return!0;const W=Object.keys(Q),N=new Set;for(const V of Object.keys(q))N.add(V);if(W.length!==N.size)return!1;for(const V of W){if(Q[V]!==q[V])return!1;N.delete(V)}return N.size===0}ue.equals=Y})(_||(e.Translations=_={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let U=class extends c.Disposable{constructor(Y,Q,q,W,N,V,$,oe,de,G,A,T){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Q,this.extensionsControlLocation=q,this.currentProfile=W,this.userDataProfilesService=N,this.extensionsProfileScannerService=V,this.fileService=$,this.logService=oe,this.environmentService=de,this.productService=G,this.uriIdentityService=A,this.instantiationService=T,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(H,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,m.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(Y,Q,q){const[W,N]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Q)]),V=q?await this.scanExtensionsUnderDevelopment(Y,[...W,...N]):[];return this.dedupExtensions(W,N,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Q=[];Q.push(this.scanDefaultSystemExtensions(!!Y.useCache,Y.language)),Q.push(this.scanDevSystemExtensions(Y.language,!!Y.checkControlFile));const[q,W]=await Promise.all(Q);return this.applyScanOptions([...q,...W],0,Y,!1)}async scanUserExtensions(Y){const Q=Y.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Q);const q=this.uriIdentityService.extUri.isEqual(Y.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(Q,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,q),N=Y.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let V;try{V=await N.scanExtensions(W)}catch($){if($ instanceof R.ExtensionsProfileScanningError&&$.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),V=await N.scanExtensions(W);else throw $}return V=await this.applyScanOptions(V,1,Y,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(Y,Q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const q=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===v.Schemas.file).map(async W=>{const N=await this.createExtensionScannerInput(W,!1,1,!0,Y.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(N)).map($=>($.type=Q.find(oe=>(0,m.areSameExtensions)(oe.identifier,$.identifier))?.type??$.type,this.extensionsScanner.validate($,N)))}))).flat();return this.applyScanOptions(q,"development",Y,!0)}return[]}async scanExistingExtension(Y,Q,q){const W=await this.createExtensionScannerInput(Y,!1,Q,!0,q.language,!0,void 0),N=await this.extensionsScanner.scanExtension(W);return!N||!q.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Y,Q,q){const W=await this.createExtensionScannerInput(Y,!1,Q,!0,q.language,!0,void 0),N=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(N,Q,q,!0)}async scanMetadata(Y){const Q=(0,h.joinPath)(Y,"package.json"),q=(await this.fileService.readFile(Q)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(Y,Q){const q=(0,h.joinPath)(Y,"package.json"),W=(await this.fileService.readFile(q)).value.toString(),N=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,N.__metadata={...N.__metadata,...Q},await this.fileService.writeFile((0,h.joinPath)(Y,"package.json"),O.VSBuffer.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof R.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw Y}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.extensionsProfileScannerService.addExtensionsToProfile(Y.map(Q=>[Q,Q.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(Q){(0,o.toFileOperationResult)(Q)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(Q))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.logService.error(Y)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(Y,Q,q,W){return q.includeAllVersions||(Y=this.dedupExtensions(Q===0?Y:void 0,Q===1?Y:void 0,Q==="development"?Y:void 0,await this.getTargetPlatform(),W)),q.includeInvalid||(Y=Y.filter(N=>N.isValid)),Y.sort((N,V)=>{const $=b.basename(N.location.fsPath),oe=b.basename(V.location.fsPath);return $<oe?-1:$>oe?1:0})}dedupExtensions(Y,Q,q,W,N){const V=(oe,de,G)=>{if(oe.isValid&&!de.isValid)return!1;if(oe.isValid===de.isValid){if(N&&p.gt(oe.manifest.version,de.manifest.version))return this.logService.debug(`Skipping extension ${de.location.path} with lower version ${de.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(p.eq(oe.manifest.version,de.manifest.version)){if(oe.type===0)return this.logService.debug(`Skipping extension ${de.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===W)return this.logService.debug(`Skipping extension ${de.location.path} from different target platform ${de.targetPlatform}`),!1}}return G?this.logService.warn(`Overwriting user extension ${oe.location.path} with ${de.location.path}.`):this.logService.debug(`Overwriting user extension ${oe.location.path} with ${de.location.path}.`),!0},$=new a.ExtensionIdentifierMap;return Y?.forEach(oe=>{const de=$.get(oe.identifier.id);(!de||V(de,oe,!1))&&$.set(oe.identifier.id,oe)}),Q?.forEach(oe=>{const de=$.get(oe.identifier.id);if(!de&&Y&&oe.type===0){this.logService.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!de||V(de,oe,!1))&&$.set(oe.identifier.id,oe)}),q?.forEach(oe=>{const de=$.get(oe.identifier.id);(!de||V(de,oe,!0))&&$.set(oe.identifier.id,oe),$.set(oe.identifier.id,oe)}),[...$.values()]}async scanDefaultSystemExtensions(Y,Q){this.logService.trace("Started scanning system extensions");const q=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),N=await(Y&&!q.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return this.logService.trace("Scanned system extensions:",N.length),N}async scanDevSystemExtensions(Y,Q){const q=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!q?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=Q?await this.getBuiltInExtensionControl():{},N=[],V=u.URI.file(b.normalize(b.join(v.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of q){const de=W[oe.name]||"marketplace";switch(de){case"disabled":break;case"marketplace":N.push((0,h.joinPath)(V,oe.name));break;default:N.push(u.URI.file(de));break}}const $=await Promise.all(N.map(async oe=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(oe,!1,0,!0,Y,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",$.length),(0,I.coalesce)($)}async getBuiltInExtensionControl(){try{const Y=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(Y.value.toString())}catch{return{}}}async createExtensionScannerInput(Y,Q,q,W,N,V,$){const oe=await this.getTranslations(N??w.language),de=await this.getMtime(Y),G=Q&&!this.uriIdentityService.extUri.isEqual(Y,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,A=G?await this.getMtime(G):void 0;return new F(Y,de,G,A,Q,$,q,W,V,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,N,oe)}async getMtime(Y){try{const Q=await this.fileService.stat(Y);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.AbstractExtensionsScannerService=U,e.AbstractExtensionsScannerService=U=be([re(4,k.IUserDataProfilesService),re(5,R.IExtensionsProfileScannerService),re(6,o.IFileService),re(7,i.ILogService),re(8,f.IEnvironmentService),re(9,n.IProductService),re(10,P.IUriIdentityService),re(11,s.IInstantiationService)],U);class F{constructor(Y,Q,q,W,N,V,$,oe,de,G,A,T,J,B,X){this.location=Y,this.mtime=Q,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=W,this.profile=N,this.profileScanOptions=V,this.type=$,this.excludeObsolete=oe,this.validate=de,this.productVersion=G,this.productDate=A,this.productCommit=T,this.devMode=J,this.language=B,this.translations=X}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Q){return(0,h.isEqual)(Y.location,Q.location)&&Y.mtime===Q.mtime&&(0,h.isEqual)(Y.applicationExtensionslocation,Q.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&Y.profile===Q.profile&&r.equals(Y.profileScanOptions,Q.profileScanOptions)&&Y.type===Q.type&&Y.excludeObsolete===Q.excludeObsolete&&Y.validate===Q.validate&&Y.productVersion===Q.productVersion&&Y.productDate===Q.productDate&&Y.productCommit===Q.productCommit&&Y.devMode===Q.devMode&&Y.language===Q.language&&_.equals(Y.translations,Q.translations)}}e.ExtensionScannerInput=F;let H=class extends c.Disposable{constructor(Y,Q,q,W,N){super(),this.obsoleteFile=Y,this.extensionsProfileScannerService=Q,this.uriIdentityService=q,this.fileService=W,this.logService=N}async scanExtensions(Y){const Q=Y.profile?await this.scanExtensionsFromProfile(Y):await this.scanExtensionsFromLocation(Y);let q={};if(Y.excludeObsolete&&Y.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();q=JSON.parse(W)}catch{}return(0,E.isEmptyObject)(q)?Q:Q.filter(W=>!q[m.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(Y){const Q=await this.fileService.resolve(Y.location);if(!Q.children?.length)return[];const q=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||Y.type===1&&(0,h.basename)(W.resource).indexOf(".")===0)return null;const N=new F(W.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(N)}));return(0,I.coalesce)(q).sort((W,N)=>W.location.path<N.location.path?-1:1)}async scanExtensionsFromProfile(Y){let Q=await this.scanExtensionsFromProfileResource(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const q=await this.scanExtensionsFromProfileResource(Y.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,Y);Q.push(...q)}return Q}async scanExtensionsFromProfileResource(Y,Q,q){const W=await this.extensionsProfileScannerService.scanProfileExtensions(Y,q.profileScanOptions);if(!W.length)return[];const N=await Promise.all(W.map(async V=>{if(Q(V)){const $=new F(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension($,V.metadata)}return null}));return(0,I.coalesce)(N)}async scanOneOrMultipleExtensions(Y){try{if(await this.fileService.exists((0,h.joinPath)(Y.location,"package.json"))){const Q=await this.scanExtension(Y);return Q?[Q]:[]}else return await this.scanExtensions(Y)}catch(Q){return this.logService.error(`Error scanning extensions at ${Y.location.path}:`,(0,M.getErrorMessage)(Q)),[]}}async scanExtension(Y,Q){try{let q=await this.scanExtensionManifest(Y.location);if(q){q.publisher||(q.publisher=a.UNDEFINED_PUBLISHER),Q=Q??q.__metadata,delete q.__metadata;const W=(0,m.getGalleryExtensionId)(q.publisher,q.name),N=Q?.id?{id:W,uuid:Q.id}:{id:W},V=Q?.isSystem?0:Y.type,$=V===0||!!Q?.isBuiltin;q=await this.translateManifest(Y.location,q,F.createNlsConfiguration(Y));const oe={type:V,identifier:N,manifest:q,location:Y.location,isBuiltin:$,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return Y.validate?this.validate(oe,Y):oe}}catch(q){Y.type!==0&&this.logService.error(q)}return null}validate(Y,Q){let q=!0;const W=(0,t.validateExtensionManifest)(Q.productVersion,Q.productDate,Q.location,Y.manifest,Y.isBuiltin);for(const[N,V]of W)N===y.default.Error&&(q=!1,this.logService.error(this.formatMessage(Q.location,V)));return Y.isValid=q,Y.validations=W,Y}async scanExtensionManifest(Y){const Q=(0,h.joinPath)(Y,"package.json");let q;try{q=(await this.fileService.readFile(Q)).value.toString()}catch(N){return(0,o.toFileOperationResult)(N)!==1&&this.logService.error(this.formatMessage(Y,(0,d.localize)(0,null,Q.path,N.message))),null}let W;try{W=JSON.parse(q)}catch{const V=[];(0,C.parse)(q,V);for(const $ of V)this.logService.error(this.formatMessage(Y,(0,d.localize)(1,null,Q.path,$.offset,$.length,(0,g.getParseErrorMessage)($.error))));return null}return(0,C.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(Y,(0,d.localize)(2,null,Q.path))),null):W}async translateManifest(Y,Q,q){const W=await this.getLocalizedMessages(Y,Q,q);if(W)try{const N=[],V=await this.resolveOriginalMessageBundle(W.default,N);if(N.length>0)return N.forEach(oe=>{this.logService.error(this.formatMessage(Y,(0,d.localize)(3,null,W.default?.path,(0,g.getParseErrorMessage)(oe.error))))}),Q;if((0,C.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(Y,(0,d.localize)(4,null,W.default?.path))),Q;const $=W.values||Object.create(null);return(0,D.localizeManifest)(this.logService,Q,$,V)}catch{}return Q}async getLocalizedMessages(Y,Q,q){const W=(0,h.joinPath)(Y,"package.nls.json"),N=(de,G)=>{G.forEach(A=>{this.logService.error(this.formatMessage(Y,(0,d.localize)(5,null,de?.path,(0,g.getParseErrorMessage)(A.error))))})},V=de=>{this.logService.error(this.formatMessage(Y,(0,d.localize)(6,null,de?.path)))},$=`${Q.publisher}.${Q.name}`,oe=q.translations[$];if(oe)try{const de=u.URI.file(oe),G=(await this.fileService.readFile(de)).value.toString(),A=[],T=(0,C.parse)(G,A);return A.length>0?(N(de,A),{values:void 0,default:W}):(0,C.getNodeType)(T)!=="object"?(V(de),{values:void 0,default:W}):{values:T.contents?T.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let G;try{G=await this.findMessageBundles(Y,q)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const A=(await this.fileService.readFile(G.localized)).value.toString(),T=[],J=(0,C.parse)(A,T);return T.length>0?(N(G.localized,T),{values:void 0,default:G.original}):(0,C.getNodeType)(J)!=="object"?(V(G.localized),{values:void 0,default:G.original}):{values:J,default:G.original}}catch{return{values:void 0,default:G.original}}}}async resolveOriginalMessageBundle(Y,Q){if(Y)try{const q=(await this.fileService.readFile(Y)).value.toString();return(0,C.parse)(q,Q)}catch{}}findMessageBundles(Y,Q){return new Promise((q,W)=>{const N=V=>{const $=(0,h.joinPath)(Y,`package.nls.${V}.json`);this.fileService.exists($).then(oe=>{oe&&q({localized:$,original:(0,h.joinPath)(Y,"package.nls.json")});const de=V.lastIndexOf("-");de===-1?q({localized:(0,h.joinPath)(Y,"package.nls.json"),original:null}):(V=V.substring(0,de),N(V))})};if(Q.devMode||Q.pseudo||!Q.language)return q({localized:(0,h.joinPath)(Y,"package.nls.json"),original:null});N(Q.language)})}formatMessage(Y,Q){return`[${Y.path}]: ${Q}`}};H=be([re(1,R.IExtensionsProfileScannerService),re(2,P.IUriIdentityService),re(3,o.IFileService),re(4,i.ILogService)],H);let j=class extends H{constructor(Y,Q,q,W,N,V,$){super(Q,W,N,V,$),this.currentProfile=Y,this.userDataProfilesService=q,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(Y){const Q=this.getCacheFile(Y),q=await this.readExtensionCache(Q);if(this.input=Y,q&&q.input&&F.equals(q.input,this.input))return this.logService.debug("Using cached extensions scan result",Y.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(N=>(N.location=u.URI.revive(N.location),N));const W=await super.scanExtensions(Y);return await this.writeExtensionCache(Q,{input:Y,result:W}),W}async readExtensionCache(Y){try{const Q=await this.fileService.readFile(Y),q=JSON.parse(Q.value.toString());return{result:q.result,input:(0,S.revive)(q.input)}}catch(Q){this.logService.debug("Error while reading the extension cache file:",Y.path,(0,M.getErrorMessage)(Q))}return null}async writeExtensionCache(Y,Q){try{await this.fileService.writeFile(Y,O.VSBuffer.fromString(JSON.stringify(Q)))}catch(q){this.logService.debug("Error while writing the extension cache file:",Y.path,(0,M.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const Y=this.getCacheFile(this.input),Q=await this.readExtensionCache(Y);if(!Q)return;const q=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(W,q))try{this.logService.info("Invalidating Cache",q,W),await this.fileService.del(Y),this._onDidChangeCache.fire()}catch(N){this.logService.error(N)}}getCacheFile(Y){const Q=this.getProfile(Y);return this.uriIdentityService.extUri.joinPath(Q.cacheHome,Y.type===0?a.BUILTIN_MANIFEST_CACHE_FILE:a.USER_MANIFEST_CACHE_FILE)}getProfile(Y){return Y.type===0?this.userDataProfilesService.defaultProfile:Y.profile?this.uriIdentityService.extUri.isEqual(Y.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Q=>this.uriIdentityService.extUri.isEqual(Y.location,Q.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};j=be([re(2,k.IUserDataProfilesService),re(3,R.IExtensionsProfileScannerService),re(4,P.IUriIdentityService),re(5,o.IFileService),re(6,i.ILogService)],j);function le(ue,Y){const Q=(0,m.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:Q,identifier:new a.ExtensionIdentifier(Q),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Y,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=le;class se extends U{constructor(Y,Q,q,W,N,V,$,oe,de,G,A,T){super(Y,Q,(0,h.joinPath)(q,".vscode-oss-dev","extensions","control.json"),W,N,V,$,oe,de,G,A,T),this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const J=await this.fileService.readFile(u.URI.file(w.translationsConfigFile));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}getTranslations(Y){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(ae[276],ce([0,1,5,41,40,28,82,16,38,7]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let v=class extends M.AbstractExtensionsProfileScannerService{constructor(w,h,p,y,E,u){super(c.URI.file(w.extensionsPath),h,p,y,E,u)}};e.ExtensionsProfileScannerService=v,e.ExtensionsProfileScannerService=v=be([re(0,g.INativeEnvironmentService),re(1,C.IFileService),re(2,L.IUserDataProfilesService),re(3,r.IUriIdentityService),re(4,O.ITelemetryService),re(5,I.ILogService)],v)}),define(ae[277],ce([0,1,7,38,82,130,16,6,5,27,40,41]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends O.NativeExtensionsScannerService{constructor(p,y,E,u,d,f,m,a){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,p.defaultProfile,p,y,E,u,d,f,m,a)}};e.ExtensionsScannerService=w,e.ExtensionsScannerService=w=be([re(0,b.IUserDataProfilesService),re(1,r.IExtensionsProfileScannerService),re(2,M.IFileService),re(3,g.ILogService),re(4,L.INativeEnvironmentService),re(5,c.IProductService),re(6,v.IUriIdentityService),re(7,C.IInstantiationService)],w)}),define(ae[278],ce([0,1,14,2,13,9,4,59,7,32,37,38,5,41]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends L.Disposable{constructor(E,u,d){super(),this.environmentService=E,this.logService=d,this.validRoots=C.TernarySearchTree.forPaths(!M.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(E.appRoot),this.addValidFileRoot(E.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.with({scheme:r.Schemas.file}).fsPath),this.addValidFileRoot(E.workspaceStorageHome.with({scheme:r.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:E}=I.session;E.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(u,d)=>this.handleResourceRequest(u,d)),E.protocol.interceptFileProtocol(r.Schemas.file,(u,d)=>this.handleFileRequest(u,d)),this._register((0,L.toDisposable)(()=>{E.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),E.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(E){const u=(0,O.normalize)(E);return this.validRoots.get(u)?L.Disposable.None:(this.validRoots.set(u,!0),(0,L.toDisposable)(()=>this.validRoots.delete(u)))}handleFileRequest(E,u){const d=g.URI.parse(E.url);return this.logService.error(`Refused to load resource ${d.fsPath} from ${r.Schemas.file}: protocol (original URL: ${E.url})`),u({error:-3})}handleResourceRequest(E,u){const d=this.requestToNormalizedFilePath(E);let f;return this.environmentService.crossOriginIsolated&&((0,O.basename)(d)==="workbench.html"||(0,O.basename)(d)==="workbench-dev.html"?f=r.COI.CoopAndCoep:f=r.COI.getHeadersFromQuery(E.url)),this.validRoots.findSubstr(d)?u({path:d,headers:f}):this.validExtensions.has((0,O.extname)(d).toLowerCase())?u({path:d}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${E.url})`),u({error:-3}))}requestToNormalizedFilePath(E){const u=g.URI.parse(E.url),d=r.FileAccess.uriToFileUri(u);return(0,O.normalize)(d.fsPath)}createIPCObjectUrl(){let E;const u=g.URI.from({scheme:"vscode",path:(0,c.generateUuid)()}),d=u.toString(),f=async()=>E;return v.validatedIpcMain.handle(d,f),this.logService.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:u,update:m=>E=m,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${d}.`),v.validatedIpcMain.removeHandler(d)}}}};e.ProtocolMainService=p,e.ProtocolMainService=p=be([re(0,b.INativeEnvironmentService),re(1,h.IUserDataProfilesService),re(2,w.ILogService)],p)}),define(ae[97],ce([0,1,8,3,2,67,12,113,6,41]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var v;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(v||(e.WillSaveStateReason=v={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(d){const f=d.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=h;class p extends r.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(f={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(f,m,a){return L.Event.filter(this._onDidChangeValue.event,t=>t.scope===f&&(m===void 0||t.key===m),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,m){const{key:a,external:t}=m;if(a===e.TARGET_KEY){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:a,target:this.getKeyTargets(f)[a],external:t})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,m,a){return this.getStorage(m)?.get(f,a)}getBoolean(f,m,a){return this.getStorage(m)?.getBoolean(f,a)}getNumber(f,m,a){return this.getStorage(m)?.getNumber(f,a)}getObject(f,m,a){return this.getStorage(m)?.getObject(f,a)}storeAll(f,m){this.withPausedEmitters(()=>{for(const a of f)this.store(a.key,a.value,a.scope,a.target,m)})}store(f,m,a,t,o=!1){if((0,M.isUndefinedOrNull)(m)){this.remove(f,a,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,a,t),this.getStorage(a)?.set(f,m,o)})}remove(f,m,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(f,m,void 0),this.getStorage(m)?.delete(f,a)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,m){const a=[],t=this.getKeyTargets(f);for(const o of Object.keys(t))t[o]===m&&a.push(o);return a}updateKeyTarget(f,m,a,t=!1){const o=this.getKeyTargets(m);typeof a=="number"?o[f]!==a&&(o[f]=a,this.getStorage(m)?.set(e.TARGET_KEY,JSON.stringify(o),t)):typeof o[f]=="number"&&(delete o[f],this.getStorage(m)?.set(e.TARGET_KEY,JSON.stringify(o),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const m=this.getStorage(f);return m?h(m):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=v.NONE){this._onWillSaveState.fire({reason:f});const m=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(f){case v.NONE:await I.Promises.settled([m?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await I.Promises.settled([m?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,m=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return u(f,m,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(f){return await this.flush(),this.getStorage(f)?.optimize()}async switch(f,m){return this.emitWillSaveState(v.NONE),(0,c.isUserDataProfile)(f)?this.switchToProfile(f,m):this.switchToWorkspace(f,m)}canSwitchProfile(f,m){return!(f.id===m.id||y(m)&&y(f))}switchData(f,m,a){this.withPausedEmitters(()=>{const t=new Set;for(const[o,s]of f)t.add(o),m.get(o)!==s&&this.emitDidChangeValue(a,{key:o,external:!0});for(const[o]of m.items)t.has(o)||this.emitDidChangeValue(a,{key:o,external:!0})})}}e.AbstractStorageService=p;function y(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=y;class E extends p{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(f){return!1}}e.InMemoryStorageService=E;async function u(d,f,m,a,t,o){const s=_=>{try{return JSON.parse(_)}catch{return _}},i=new Map,n=new Map;d.forEach((_,U)=>{i.set(U,_),n.set(U,s(_))});const l=new Map,S=new Map;f.forEach((_,U)=>{l.set(U,_),S.set(U,s(_))});const R=new Map,k=new Map;m.forEach((_,U)=>{R.set(U,_),k.set(U,s(_))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const P=[];if(i.forEach((_,U)=>{P.push({key:U,value:_})}),console.table(P),console.groupEnd(),console.log(n),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const _=[];l.forEach((U,F)=>{_.push({key:F,value:U})}),console.table(_),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${o})`);const D=[];R.forEach((_,U)=>{D.push({key:U,value:_})}),console.table(D),console.groupEnd(),console.log(k)}e.logStorage=u}),define(ae[279],ce([0,1,22,8,3,2,9,72,7,21,113,161,5,97,28,30,13]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class u extends O.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,i){super(),this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=v.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===v.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(s);const i=s.getBoolean(h.IS_NEW_KEY);i===void 0?s.set(h.IS_NEW_KEY,!0):i&&s.set(h.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=v.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new C.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>u.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const i=(0,I.top)(Array.from(this._storage.items.entries()).map(([l,S])=>({key:l,length:S.length})),(l,S)=>S.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),n=(await this.fileService.stat(g.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=v.StorageState.Closed,await this._storage.close()}}class d extends u{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath,d.STORAGE_NAME)}constructor(s,i,n,l){super(n,l),this.profile=s,this.options=i}async doCreate(){return new v.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:v.StorageHint.STORAGE_IN_MEMORY})}}class f extends d{constructor(s,i,n,l){super(s,i,n,l)}}e.ProfileStorageMain=f;class m extends d{constructor(s,i,n,l){super(i.defaultProfile,s,n,l)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(p.firstSessionDateStorageKey,void 0)===void 0&&s.set(p.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(p.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();s.set(p.lastSessionDateStorageKey,typeof n>"u"?null:n),s.set(p.currentSessionDateStorageKey,l)}}e.ApplicationStorageMain=m;class a extends u{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,this.workspace.id,a.WORKSPACE_STORAGE_NAME)}constructor(s,i,n,l,S){super(n,S),this.workspace=s,this.options=i,this.environmentService=l}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new v.Storage(new b.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?v.StorageHint.STORAGE_IN_MEMORY:i?v.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,M.join)(this.environmentService.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,this.workspace.id),i=(0,M.join)(s,a.WORKSPACE_STORAGE_NAME);return await c.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,M.join)(s,a.WORKSPACE_META_NAME);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=a;class t extends u{get path(){}async doCreate(){return new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(ae[280],ce([0,1,3,2,97]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class O extends L.Disposable{constructor(C,g,c){super(),this.storageMainService=C,this.userDataProfilesService=g,this.logService=c;const v=this._register(new L.MutableDisposable);this._onDidChange=this._register(new I.Emitter({onWillAddFirstListener:()=>v.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>v.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const C=new L.DisposableStore;return C.add(I.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(g,c)=>(g?g.push(c.key):g=[c.key],g),100)(g=>this.onDidChangeApplicationStorage(g))),C.add(I.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(g,c)=>{g||(g=new Map);let v=g.get(c.profile.id);return v||g.set(c.profile.id,v={profile:c.profile,keys:[],storage:c.storage}),v.keys.push(c.key),g},100)(g=>this.onDidChangeProfileStorage(g))),C}onDidChangeApplicationStorage(C){const g=C.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],c=[];if(C=C.filter(v=>v!==r.TARGET_KEY),C.length){const v=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);c.push({profile:this.userDataProfilesService.defaultProfile,changes:C.map(b=>({key:b,scope:0,target:v[b]}))})}this.triggerEvents(g,c)}onDidChangeProfileStorage(C){const g=[],c=new Map;for(const[v,b]of C.entries()){b.keys.includes(r.TARGET_KEY)&&g.push(b.profile);const w=b.keys.filter(h=>h!==r.TARGET_KEY);if(w.length){const h=(0,r.loadKeyTargets)(b.storage.storage);c.set(v,{profile:b.profile,changes:w.map(p=>({key:p,scope:0,target:h[p]}))})}}this.triggerEvents(g,[...c.values()])}triggerEvents(C,g){(C.length||g.length)&&this._onDidChange.fire({valueChanges:g,targetChanges:C})}listen(C,g,c){switch(g){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${g}`)}async call(C,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=O}),define(ae[281],ce([0,1,7,38,16,5,34,40,41,12,123]),function(K,e,I,L,r,O,M,C,g,c,v){"use strict";var b,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let h=class extends g.UserDataProfilesService{static{b=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(u,d,f,m,a){super(f,m,d,a),this.stateReadonlyService=u,this.nativeEnvironmentService=f}getStoredProfiles(){return this.stateReadonlyService.getItem(b.PROFILES_KEY,[]).map(d=>({...d,location:(0,c.isString)(d.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,d.location):I.URI.revive(d.location)}))}getStoredProfileAssociations(){const u=this.stateReadonlyService.getItem(b.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(b.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?u:this.migrateStoredProfileAssociations(u)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(I.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=h,e.UserDataProfilesReadonlyService=h=b=be([re(0,M.IStateReadService),re(1,C.IUriIdentityService),re(2,L.INativeEnvironmentService),re(3,r.IFileService),re(4,O.ILogService)],h);let p=w=class extends h{constructor(u,d,f,m,a){super(u,d,f,m,a),this.stateService=u}saveStoredProfiles(u){u.length?this.stateService.setItem(w.PROFILES_KEY,u.map(d=>({...d,location:this.uriIdentityService.extUri.basename(d.location)}))):this.stateService.removeItem(w.PROFILES_KEY)}getStoredProfiles(){const u=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(u),this.stateService.setItem("userDataProfilesMigration",!0)),u}saveStoredProfileAssociations(u){u.emptyWindows||u.workspaces?this.stateService.setItem(w.PROFILE_ASSOCIATIONS_KEY,u):this.stateService.removeItem(w.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const u="workspaceAndProfileInfo",d=this.stateService.getItem(u,void 0);if(d){this.stateService.removeItem(u);const m=d.reduce((a,{workspace:t,profile:o})=>(a[I.URI.revive(t).toString()]=I.URI.revive(o).toString(),a),{});this.stateService.setItem(w.PROFILE_ASSOCIATIONS_KEY,{workspaces:m})}const f=super.getStoredProfileAssociations();return this.stateService.getItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(f),this.stateService.setItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),f}};e.UserDataProfilesService=p,e.UserDataProfilesService=p=w=be([re(0,M.IStateService),re(1,C.IUriIdentityService),re(2,L.INativeEnvironmentService),re(3,r.IFileService),re(4,O.ILogService)],p);let y=class extends p{constructor(u,d,f,m){super(new v.StateService(0,d,m,f),u,d,f,m)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=y,e.ServerUserDataProfilesService=y=be([re(0,C.IUriIdentityService),re(1,L.INativeEnvironmentService),re(2,r.IFileService),re(3,O.ILogService)],y)}),define(ae[57],ce([0,1,38,16,6,5,40,41,281,34]),function(K,e,I,L,r,O,M,C,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(C.IUserDataProfilesService);let v=class extends g.UserDataProfilesService{constructor(w,h,p,y,E){super(w,h,p,y,E)}getAssociatedEmptyWindows(){const w=[];for(const h of this.profilesObject.emptyWindows.keys())w.push({id:h});return w}};e.UserDataProfilesMainService=v,e.UserDataProfilesMainService=v=be([re(0,c.IStateService),re(1,M.IUriIdentityService),re(2,I.INativeEnvironmentService),re(3,L.IFileService),re(4,O.ILogService)],v)}),define(ae[131],ce([0,1,19,7,30]),function(K,e,I,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function O(g,c,v){for(const w of g){const h=w.openedWorkspace;if((0,r.isWorkspaceIdentifier)(h)){const p=await v(h);if(p){if(p.folders.some(y=>I.extUriBiasedIgnorePathCase.isEqualOrParent(c,y.uri)))return w}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(c,h.configPath))return w}}const b=g.filter(w=>(0,r.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(c,w.openedWorkspace.uri));if(b.length)return b.sort((w,h)=>-(w.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=O;function M(g,c){for(const v of g)if((0,r.isWorkspaceIdentifier)(v.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.configPath,c)||(0,r.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.uri,c))return v}e.findWindowOnWorkspaceOrFolder=M;function C(g,c){const v=b=>c.some(w=>I.extUriBiasedIgnorePathCase.isEqual(L.URI.file(w),L.URI.file(b)));for(const b of g)if(b.config?.extensionDevelopmentPath?.some(w=>v(w)))return b}e.findWindowOnExtensionDevelopmentPath=C}),define(ae[98],ce([0,1,33,42,102,47,13,9,4,19,7,6,60,30]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function p(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function y(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=y;function E(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=E;function u(k){return d(k)||f(k)}e.isStoredWorkspaceFolder=u;function d(k){const P=k;return typeof P?.path=="string"&&(!P.name||typeof P.name=="string")}function f(k){const P=k;return typeof P?.uri=="string"&&(!P.name||typeof P.name=="string")}function m(k,P,D,_,U){if(k.scheme!==_.scheme)return{name:D,uri:k.toString(!0)};let F=P?void 0:U.relativePath(_,k);if(F!==void 0)F.length===0?F=".":g.isWindows&&(F=a(F));else if(k.scheme===M.Schemas.file)F=k.fsPath,g.isWindows&&(F=a(F));else if(U.isEqualAuthority(k.authority,_.authority))F=k.path;else return{name:D,uri:k.toString(!0)};return{name:D,path:F}}e.getStoredWorkspaceFolder=m;function a(k){return k=(0,O.normalizeDriveLetter)(k),(0,I.isUNC)(k)||(k=(0,I.toSlashes)(k)),k}function t(k,P,D){const _=[],U=new Set,F=D.dirname(P);for(const H of k){let j;if(d(H))H.path&&(j=D.resolvePath(F,H.path));else if(f(H))try{j=v.URI.parse(H.uri),j.path[0]!==C.posix.sep&&(j=j.with({path:C.posix.sep+j.path}))}catch(le){console.warn(le)}if(j){const le=D.getComparisonKey(j);if(!U.has(le)){U.add(le);const se=H.name||D.basenameOrAuthority(j);_.push(new h.WorkspaceFolder({uri:j,name:se,index:_.length},H))}}}return _}e.toWorkspaceFolders=t;function o(k,P,D,_,U){const F=s(P,k),H=U.dirname(P),j=U.dirname(_),le=[];for(const Q of F.folders){const q=d(Q)?U.resolvePath(H,Q.path):v.URI.parse(Q.uri);let W;D?W=!1:W=!d(Q)||(0,C.isAbsolute)(Q.path),le.push(m(q,W,Q.name,j,U))}const se={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},ue=r.setProperty(k,["folders"],le,se);let Y=r.applyEdits(k,ue);return(0,c.isEqualAuthority)(F.remoteAuthority,(0,w.getRemoteAuthority)(_))&&(Y=r.applyEdits(Y,r.removeProperty(Y,["remoteAuthority"],se))),Y}e.rewriteWorkspaceFileForNewLocation=o;function s(k,P){const D=L.parse(P);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(_=>u(_));else throw new Error(`${k} looks like an invalid workspace file.`);return D}function i(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function n(k){return typeof k.folderUri=="string"}function l(k){return typeof k.fileUri=="string"}function S(k,P){const D={workspaces:[],files:[]};if(k){const _=function(F,H){for(let j=0;j<F.length;j++)try{H(F[j],j)}catch(le){P.warn(`Error restoring recent entry ${JSON.stringify(F[j])}: ${le.toString()}. Skip entry.`)}},U=k;Array.isArray(U.entries)&&_(U.entries,F=>{const H=F.label,j=F.remoteAuthority;i(F)?D.workspaces.push({label:H,remoteAuthority:j,workspace:{id:F.workspace.id,configPath:v.URI.parse(F.workspace.configPath)}}):n(F)?D.workspaces.push({label:H,remoteAuthority:j,folderUri:v.URI.parse(F.folderUri)}):l(F)&&D.files.push({label:H,remoteAuthority:j,fileUri:v.URI.parse(F.fileUri)})})}return D}e.restoreRecentlyOpened=S;function R(k){const P={entries:[]};for(const D of k.workspaces)y(D)?P.entries.push({folderUri:D.folderUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority}):P.entries.push({workspace:{id:D.workspace.id,configPath:D.workspace.configPath.toString()},label:D.label,remoteAuthority:D.remoteAuthority});for(const D of k.files)P.entries.push({fileUri:D.fileUri.toString(),label:D.label,remoteAuthority:D.remoteAuthority});return P}e.toStoreData=R}),define(ae[99],ce([0,1,87,13,4,19]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(c){function v(){let b=c.scheme===L.Schemas.file?(0,O.originalFSPath)(c):c.toString();return r.isLinux||(b=b.toLowerCase()),(0,I.createHash)("md5").update(b).digest("hex")}return{id:v(),configPath:c}}e.getWorkspaceIdentifier=M;function C(c,v){function b(){if(c.scheme!==L.Schemas.file)return(0,I.createHash)("md5").update(c.toString()).digest("hex");if(!v)return;let h;return r.isLinux?h=v.ino:r.isMacintosh?h=v.birthtime.getTime():r.isWindows&&(typeof v.birthtimeMs=="number"?h=Math.floor(v.birthtimeMs):h=v.birthtime.getTime()),(0,I.createHash)("md5").update(c.fsPath).update(h?String(h):"").digest("hex")}const w=b();if(typeof w=="string")return{id:w,uri:c}}e.getSingleFolderWorkspaceIdentifier=C;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(ae[100],ce([0,1,87,88,26,282,17,15,3,2,9,4,32,43,111]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{traceSocketEvent(P,D){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,D)}constructor(P,D=""){this._canWrite=!0,this.debugLabel=D,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,C.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener),this._closeListener=_=>{this.traceSocketEvent("close",{hadError:_}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(P){const D=_=>{this.traceSocketEvent("read",_),P(M.VSBuffer.wrap(_))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(P){const D=_=>{P({type:0,hadError:_,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(P){const D=()=>{P()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(P){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,C.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,C.onUnexpectedError)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=y;var E;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(E||(E={}));var u;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(u||(u={}));class d extends c.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,D){this.socket.traceSocketEvent(P,D)}constructor(P,D,_,U){super(),this._onData=this._register(new g.Emitter),this._onClose=this._register(new g.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:_?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new f(this,D,_,U,this._onData,(F,H)=>this._write(F,H))),this._register(this._flowManager.onError(F=>{console.error(F),(0,C.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await g.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){let D=0;for(;D<P.byteLength;)this._flowManager.writeMessage(P.slice(D,Math.min(D+262144,P.byteLength)),{compressed:!0,opcode:2}),D+=262144}_write(P,{compressed:D,opcode:_}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let U=2;P.byteLength<126?U+=0:P.byteLength<2**16?U+=2:U+=8;const F=M.VSBuffer.alloc(U),H=D?64:0,j=_&15;if(F.writeUInt8(128|H|j,0),P.byteLength<126)F.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(P.byteLength>>>8&255,++le),F.writeUInt8(P.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(P.byteLength>>>24&255,++le),F.writeUInt8(P.byteLength>>>16&255,++le),F.writeUInt8(P.byteLength>>>8&255,++le),F.writeUInt8(P.byteLength>>>0&255,++le)}this.socket.write(M.VSBuffer.concat([F,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),_=D.readUInt8(0),U=(_&128)>>>7,F=(_&64)>>>6,H=_&15,j=D.readUInt8(1),le=(j&128)>>>7,se=j&127;this._state.state=2,this._state.readLen=2+(le?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this._state.opcode=H,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),_=D.readUInt8(1),U=(_&128)>>>7;let F=_&127,H=1;F===126?F=D.readUInt8(++H)*2**8+D.readUInt8(++H):F===127&&(F=D.readUInt8(++H)*0+D.readUInt8(++H)*0+D.readUInt8(++H)*0+D.readUInt8(++H)*0+D.readUInt8(++H)*2**24+D.readUInt8(++H)*2**16+D.readUInt8(++H)*2**8+D.readUInt8(++H));let j=0;U&&(j=D.readUInt8(++H)*2**24+D.readUInt8(++H)*2**16+D.readUInt8(++H)*2**8+D.readUInt8(++H)),this._state.state=3,this._state.readLen=F,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(D,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await g.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class f extends c.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}constructor(P,D,_,U,F,H){super(),this._tracer=P,this._onData=F,this._writeFn=H,this._onError=this._register(new g.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new g.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new g.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,D?(this._zlibInflateStream=this._register(new m(this._tracer,U,_,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(P,D){this._writeQueue.push({data:P,options:D}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:P,options:D}=this._writeQueue.shift();if(this._zlibDeflateStream&&D.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(_,D)}else this._writeFn(P,{...D,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,D){return new Promise((_,U)=>{P.write(D),P.flush(F=>_(F))})}acceptFrame(P,D,_){this._readQueue.push({data:P,isCompressed:D,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const D=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(D)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(P,D,_){return new Promise((U,F)=>{P.write(D),_&&P.write(M.VSBuffer.fromByteArray([0,0,255,255])),P.flush(H=>U(H))})}}class m extends c.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}constructor(P,D,_,U){super(),this._tracer=P,this._recordInflateBytes=D,this._onError=this._register(new g.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,O.createInflateRaw)(U),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(M.VSBuffer.wrap(F))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const D=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(D)})}}class a extends c.Disposable{constructor(P,D){super(),this._tracer=P,this._onError=this._register(new g.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,O.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(M.VSBuffer.wrap(_))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let D=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.byteLength-4),P(D)})}}function t(k,P){if(P===0)return;const D=k.byteLength>>>2;for(let le=0;le<D;le++){const se=k.readUInt32BE(le*4);k.writeUInt32BE(se^P,le*4)}const _=D*4,U=k.byteLength-_,F=P>>>24&255,H=P>>>16&255,j=P>>>8&255;U>=1&&k.writeUInt8(k.readUInt8(_)^F,_),U>=2&&k.writeUInt8(k.readUInt8(_+1)^H,_+1),U>=3&&k.writeUInt8(k.readUInt8(_+2)^j,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function s(){const k=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const P=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),D=(0,v.join)(P,`vscode-ipc-${k}.sock`);return n(D),D}e.createRandomIPCHandle=s;function i(k,P,D){const U=(0,I.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${D}-${P}-sock`;const F=D.substr(0,4),H=P.substr(0,6);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,v.join)(e.XDG_RUNTIME_DIR,`vscode-${U}-${F}-${H}.sock`):j=(0,v.join)(k,`${F}-${H}.sock`),n(j),j}e.createStaticIPCHandle=i;function n(k){const P=o[b.platform];typeof P=="number"&&k.length>=P&&console.warn(`WARNING: IPC handle "${k}" is longer than ${P} chars, try a shorter --user-data-dir`)}class l extends h.IPCServer{static toClientConnectionEvent(P){const D=g.Event.fromNodeEventEmitter(P,"connection");return g.Event.map(D,_=>({protocol:new p.Protocol(new y(_,"ipc-server-connection")),onDidClientDisconnect:g.Event.once(g.Event.fromNodeEventEmitter(_,"close"))}))}constructor(P){super(l.toClientConnectionEvent(P)),this.server=P}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=l;function S(k){return new Promise((P,D)=>{const _=(0,L.createServer)();_.on("error",D),_.listen(k,()=>{_.removeListener("error",D),P(new l(_))})})}e.serve=S;function R(k,P){return new Promise((D,_)=>{const U=(0,L.createConnection)(k,()=>{U.removeListener("error",_),D(p.Client.fromSocket(new y(U,`ipc-client${P}`),P))});U.once("error",_)})}e.connect=R}),define(ae[24],ce([0,1,50,9,4,100,38,91,6]),function(K,e,I,L,r,O,M,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,g.refineServiceDecorator)(M.IEnvironmentService);class c extends C.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.isLinux){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const w=b.slice(0,-17);if(this._snapEnv[w])continue;process.env[w]&&(this._snapEnv[w]=process.env[w]),process.env[b]?process.env[w]=process.env[b]:delete process.env[w]}}}restoreSnapExportedVariables(){if(r.isLinux)for(const b in this._snapEnv)process.env[b]=this._snapEnv[b],delete this._snapEnv[b]}}e.EnvironmentMainService=c,be([I.memoize],c.prototype,"cachedLanguagesPath",null),be([I.memoize],c.prototype,"backupHome",null),be([I.memoize],c.prototype,"mainIPCHandle",null),be([I.memoize],c.prototype,"mainLockfile",null),be([I.memoize],c.prototype,"disableUpdates",null),be([I.memoize],c.prototype,"crossOriginIsolated",null),be([I.memoize],c.prototype,"codeCachePath",null),be([I.memoize],c.prototype,"useCodeCache",null)}),define(ae[283],ce([0,1,87,33,13,9,4,19,21,196,18,24,34,16,5,195,30,99]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let f=class{static{d=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(a,t,o,s){this.environmentMainService=a,this.configurationService=t,this.logService=o,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=C.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,n)=>(0,L.isEqual)(i,n,!M.isLinux)}}async initialize(){const a=this.stateService.getItem(d.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(a.emptyWindows),this.workspaces=await this.validateWorkspaces((0,c.deserializeWorkspaceInfos)(a)),this.folders=await this.validateFolders((0,c.deserializeFolderInfos)(a)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(a,t){this.workspaces.some(s=>a.workspace.id===s.workspace.id)||(this.workspaces.push(a),this.storeWorkspacesMetadata());const o=(0,O.join)(this.backupHome,a.workspace.id);return t?this.moveBackupFolder(o,t).then(()=>o):o}async moveBackupFolder(a,t){if(await g.Promises.exists(a)&&await this.convertToEmptyWindowBackup(a),await g.Promises.exists(t))try{await g.Promises.rename(t,a,!1)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.folders.some(t=>this.backupUriComparer.isEqual(a.folderUri,t.folderUri))||(this.folders.push(a),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,this.getFolderHash(a))}registerEmptyWindowBackup(a){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.backupFolder))||(this.emptyWindows.push(a),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,a.backupFolder)}async validateWorkspaces(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const s of a){const i=s.workspace;if(!(0,E.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,O.join)(this.backupHome,i.id);await this.doHasBackups(n)?i.configPath.scheme!==r.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?o.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return o}async validateFolders(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const i=s.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!o.has(n)){o.add(n);const l=(0,O.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(l)?i.scheme!==r.Schemas.file||await g.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(l):await this.deleteStaleBackup(l)}}return t}async validateEmptyWorkspaces(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,O.join)(this.backupHome,i);await this.doHasBackups(n)?t.push(s):await this.deleteStaleBackup(n)}}return t}async deleteStaleBackup(a){try{await g.Promises.rm(a,g.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let a=(0,u.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.id));)a=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:a.id}}async convertToEmptyWindowBackup(a){const t=this.prepareNewEmptyWindowBackup(),o=(0,O.join)(this.backupHome,t.backupFolder);try{await g.Promises.rename(a,o,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.workspaces)await this.hasBackups(t)&&a.push(t);for(const t of this.folders)await this.hasBackups(t)&&a.push(t);return a}hasBackups(a){let t;return(0,c.isEmptyWindowBackupInfo)(a)?t=(0,O.join)(this.backupHome,a.backupFolder):(0,y.isFolderBackupInfo)(a)?t=(0,O.join)(this.backupHome,this.getFolderHash(a)):t=(0,O.join)(this.backupHome,a.workspace.id),this.doHasBackups(t)}async doHasBackups(a){try{const t=await g.Promises.readdir(a);for(const o of t)try{if((await g.Promises.readdir((0,O.join)(a,o))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const a={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:o})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.folders.map(({folderUri:t,remoteAuthority:o})=>{const s={folderUri:t.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:o})=>{const s={backupFolder:t};return o&&(s.remoteAuthority=o),s})};this.stateService.setItem(d.backupWorkspacesMetadataStorageKey,a)}getFolderHash(a){const t=a.folderUri;let o;return t.scheme===r.Schemas.file?o=M.isLinux?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,I.createHash)("md5").update(o).digest("hex")}};e.BackupMainService=f,e.BackupMainService=f=d=be([re(0,b.IEnvironmentMainService),re(1,v.IConfigurationService),re(2,p.ILogService),re(3,w.IStateService)],f)}),define(ae[20],ce([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,v.createDecorator)("lifecycleMainService");var y;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var E;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(E||(e.LifecycleMainPhase=E={}));let u=class extends M.Disposable{static{p=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(f,m,a){super(),this.logService=f,this.stateService=m,this.environmentMainService=a,this._onBeforeShutdown=this._register(new O.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new O.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new O.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new O.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(p.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(p.QUIT_AND_RESTART_KEY)}registerListeners(){const f=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),C.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};I.app.addListener("before-quit",f);const m=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!C.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",m),I.app.once("will-quit",a=>{this.trace("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),I.app.removeListener("before-quit",f),I.app.removeListener("window-all-closed",m),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}fireOnWillShutdown(f){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const m=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const a=[];return this._onWillShutdown.fire({reason:f,join(t,o){m.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{m.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(a)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(f){if(f<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===f)return;this.trace(`lifecycle (main): phase changed (value: ${f})`),this._phase=f;const m=this.phaseWhen.get(this._phase);m&&(m.open(),this.phaseWhen.delete(this._phase))}async when(f){if(f<=this._phase)return;let m=this.phaseWhen.get(f);m||(m=new r.Barrier,this.phaseWhen.set(f,m)),await m.wait()}registerWindow(f){const m=new M.DisposableStore;this.windowCounter++,m.add(f.onWillLoad(t=>this._onWillLoadWindow.fire({window:f,workspace:t.workspace,reason:t.reason})));const a=(0,c.assertIsDefined)(f.win);a.on("close",t=>{const o=f.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${f.id}`),t.preventDefault(),this.unload(f,1).then(s=>{if(s){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(f),f.close()})}),a.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${f.id}`),this.windowCounter--,m.dispose(),this.windowCounter===0&&(!C.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}registerAuxWindow(f){const m=(0,c.assertIsDefined)(f.win);m.on("close",a=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${f.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),m.on("closed",()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${f.id}`)})}async reload(f,m){await this.unload(f,3)||f.reload(m)}unload(f,m){const a=this.mapWindowIdToPendingUnload.get(f.id);if(a)return a;const t=this.doUnload(f,m).finally(()=>{this.mapWindowIdToPendingUnload.delete(f.id)});return this.mapWindowIdToPendingUnload.set(f.id,t),t}async doUnload(f,m){if(!f.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${f.id}`);const a=this._quitRequested?2:m,t=await this.onBeforeUnloadWindowInRenderer(f,a);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${f.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(f,a),!1)}handleWindowUnloadVeto(f){return f?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(f){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(f),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(f,m){return new Promise(a=>{const t=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;L.validatedIpcMain.once(o,()=>{a(!1)}),L.validatedIpcMain.once(s,()=>{a(!0)}),f.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:m})})}onWillUnloadWindowInRenderer(f,m){return new Promise(a=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(o,()=>a()),f.send("vscode:onWillUnload",{replyChannel:o,reason:m})})}quit(f){return this.doQuit(f).then(m=>{if(!m&&f)try{if(C.isWindows){const a=(0,g.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}return m})}doQuit(f){return this.trace(`Lifecycle#quit() - begin (willRestart: ${f})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(f&&this.stateService.setItem(p.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(m=>{this.pendingQuitPromiseResolve=m,this.trace("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.pendingQuitPromise)}trace(f){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(f):this.logService.trace(f)}setRelaunchHandler(f){this.relaunchHandler=f}async relaunch(f){this.trace("Lifecycle#relaunch()");const m=process.argv.slice(1);if(f?.addArgs&&m.push(...f.addArgs),f?.removeArgs)for(const o of f.removeArgs){const s=m.indexOf(o);s>=0&&m.splice(s,1)}const a=()=>{this.relaunchHandler?.handleRelaunch(f)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:m}))};I.app.once("quit",a),await this.quit(!0)&&I.app.removeListener("quit",a)}async kill(f){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const m of I.BrowserWindow.getAllWindows())if(m&&!m.isDestroyed()){let a;m.webContents&&!m.webContents.isDestroyed()?a=new Promise(t=>m.once("closed",t)):a=Promise.resolve(),m.destroy(),await a}})()]),I.app.exit(f)}};e.LifecycleMainService=u,e.LifecycleMainService=u=p=be([re(0,b.ILogService),re(1,w.IStateService),re(2,h.IEnvironmentMainService)],u)}),define(ae[284],ce([0,1,4,3,2,6,20]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,O.createDecorator)("keyboardLayoutMainService");let C=class extends r.Disposable{constructor(v){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((b,w)=>{K(["native-keymap"],b,w)});this._keyboardLayoutData=g(v),I.isCI||v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=g(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=C,e.KeyboardLayoutMainService=C=be([re(0,M.ILifecycleMainService)],C);function g(c){const v=c.getKeyMap(),b=c.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:b}}}),define(ae[285],ce([0,1,246,8,17,15,12,18,38,95,5,53,245,282]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let p=class extends b.AbstractRequestService{constructor(d,f,m,a){super(a),this.configurationService=d,this.environmentService=f,this.logService=m,this.configure(),this._register(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const d=this.configurationService.getValue("http");this.proxyUrl=d?.proxy,this.strictSSL=!!d?.proxyStrictSSL,this.authorization=d?.proxyAuthorization}async request(d,f){const{proxyUrl:m,strictSSL:a}=this;let t;try{t=await(0,c.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,O.getErrorMessage)(i)))}const o={...process.env,...t},s=d.agent?d.agent:await(0,w.getProxyAgent)(d.url||"",o,{proxyUrl:m,strictSSL:a});return d.agent=s,d.strictSSL=a,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(d.isChromiumNetwork?"electron":"node",d,()=>E(d,f))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((f,m)=>{K(["@vscode/proxy-agent"],f,m)})).loadSystemCertificates({log:this.logService})}};e.RequestService=p,e.RequestService=p=be([re(0,C.IConfigurationService),re(1,g.INativeEnvironmentService),re(2,v.ILogService),re(3,v.ILoggerService)],p);async function y(u){return((0,I.parse)(u.url).protocol==="https:"?await new Promise((m,a)=>{K(["https"],m,a)}):await new Promise((m,a)=>{K(["http"],m,a)})).request}async function E(u,d){return L.Promises.withAsyncBody(async(f,m)=>{const a=(0,I.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await y(u),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,M.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const s=t(o,i=>{const n=(0,M.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)E({...u,url:i.headers.location,followRedirects:n-1},d).then(f,m);else{let l=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,h.createGunzip)())),f({res:i,stream:(0,r.streamToBufferReadableStream)(l)})}});s.on("error",m),u.timeout&&s.setTimeout(u.timeout),u.isChromiumNetwork&&s.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&s.write(u.data),s.end(),d.onCancellationRequested(()=>{s.abort(),m(new O.CancellationError)})})}e.nodeRequest=E}),define(ae[286],ce([0,1,14,285]),function(K,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(M){return I.net.request}class O extends L.RequestService{request(C,g){return super.request({...C||{},getRawRequest:r,isChromiumNetwork:!0},g)}}e.RequestMainService=O}),define(ae[83],ce([0,1,7,3,2,38,16,6,20,5,97,279,41,57,40,13]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let E=class extends r.Disposable{constructor(f,m,a,t,o,s){super(),this.logService=f,this.environmentService=m,this.userDataProfilesService=a,this.lifecycleMainService=t,this.fileService=o,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new L.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(f=>{f.window.profile&&this.profileStorage(f.window.profile).init(),f.workspace&&this.workspaceStorage(f.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(f=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=f.reason,f.join("applicationStorage",this.applicationStorage.close());for(const[,m]of this.mapProfileToStorage)f.join("profileStorage",m.close());for(const[,m]of this.mapWorkspaceToStorage)f.join("workspaceStorage",m.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(f=>{f.join((async()=>{await this.fileService.exists(f.profile.globalStorageHome)||await this.fileService.createFolder(f.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(f=>{const m=this.mapProfileToStorage.get(f.profile.id);m&&f.join(m.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const f=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(L.Event.once(f.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),f}profileStorage(f){if((0,v.isProfileUsingDefaultStorage)(f))return this.applicationStorage;let m=this.mapProfileToStorage.get(f.id);if(!m){this.logService.trace(`StorageMainService: creating profile storage (${f.name})`),m=this._register(this.createProfileStorage(f)),this.mapProfileToStorage.set(f.id,m);const a=this._register(m.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:m,profile:f})));this._register(L.Event.once(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${f.name})`),this.mapProfileToStorage.delete(f.id),a.dispose()}))}return m}createProfileStorage(f){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(f,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(f){let m=this.mapWorkspaceToStorage.get(f.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${f.id})`),m=this._register(this.createWorkspaceStorage(f)),this.mapWorkspaceToStorage.set(f.id,m),this._register(L.Event.once(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${f.id})`),this.mapWorkspaceToStorage.delete(f.id)}))),m}createWorkspaceStorage(f){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(f,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(f){const m=I.URI.file(f);for(const a of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(a.path&&this.uriIdentityService.extUri.isEqualOrParent(I.URI.file(a.path),m))return!0;return!1}};e.StorageMainService=E,e.StorageMainService=E=be([re(0,c.ILogService),re(1,O.IEnvironmentService),re(2,h.IUserDataProfilesMainService),re(3,g.ILifecycleMainService),re(4,M.IFileService),re(5,p.IUriIdentityService)],E),e.IApplicationStorageMainService=(0,C.createDecorator)("applicationStorageMainService");let u=class extends v.AbstractStorageService{constructor(f,m){super(),this.userDataProfilesService=f,this.storageMainService=m,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(f){if(f===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(f){if(f===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=u,e.ApplicationStorageMainService=u=be([re(0,w.IUserDataProfilesService),re(1,e.IStorageMainService)],u)}),define(ae[287],ce([0,1,88,26,105,100,8,2,4,18,5,27,241,242,96,128,17]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function u(t,o,s,i,n){let l;for(let S=3;S&&(l?.dispose(),l=await new d(t,o,s,i,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));S--);return l}class d extends C.Disposable{constructor(o,s,i,n,l){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=l,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=I.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=S=>this._onConnection(S),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,r.findFreePortFaster)(o,2,1e3,s),n=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(o){o.pause();const s=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,w.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n instanceof O.NodeSocket?n.socket.destroy():n.end()}),n instanceof O.NodeSocket?this._mirrorNodeSocket(o,n):this._mirrorGenericSocket(o,n),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),n.end()})}_mirrorGenericSocket(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(i=>o.write(i.buffer)),o.on("data",i=>s.write(E.VSBuffer.wrap(i))),o.resume()}_mirrorNodeSocket(o,s){const i=s.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.NodeRemoteTunnel=d;let f=class extends y.AbstractTunnelService{constructor(o,s,i,n,l){super(s,l),this.remoteSocketFactoryService=o,this.signService=i,this.productService=n}isPortPrivileged(o){return(0,y.isPortPrivileged)(o,this.defaultTunnelHost,g.OS,L.release())}retainOrCreateTunnel(o,s,i,n,l,S,R,k){const P=this.getTunnelFromMap(s,i);if(P)return++P.refcount,P.value;if((0,y.isTunnelProvider)(o))return this.createWithProvider(o,s,i,l,S,R,k);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${l}.`);const D={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},_=u(D,n,s,i,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,_),_}}};e.BaseTunnelService=f,e.BaseTunnelService=f=be([re(0,h.IRemoteSocketFactoryService),re(1,v.ILogService),re(2,p.ISignService),re(3,b.IProductService),re(4,c.IConfigurationService)],f);let m=class extends f{constructor(o,s,i,n,l){super(o,s,i,n,l)}};e.TunnelService=m,e.TunnelService=m=be([re(0,h.IRemoteSocketFactoryService),re(1,v.ILogService),re(2,p.ISignService),re(3,b.IProductService),re(4,c.IConfigurationService)],m);let a=class extends C.Disposable{constructor(o,s,i,n,l){super(),this.remoteSocketFactoryService=o,this.logService=s,this.productService=i,this.signService=n,this.configurationService=l,this._tunnelServices=new Map}async openTunnel(o,s,i,n,l,S,R,k,P){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${S}.`),!this._tunnelServices.has(o)){const D=new m(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(D),this._tunnelServices.set(o,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(s,i,n,l,S,R,k,P)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=be([re(0,h.IRemoteSocketFactoryService),re(1,v.ILogService),re(2,b.IProductService),re(3,p.ISignService),re(4,c.IConfigurationService)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function w(p,y,E){return`${E.updateUrl}/api/update/${p}/${y}/${E.commit}`}e.createUpdateURL=w;let h=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,E,u,d,f,m){this.lifecycleMainService=y,this.configurationService=E,this.environmentMainService=u,this.requestService=d,this.logService=f,this.productService=m,this._state=b.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,y.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(b.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(b.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(b.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.configurationService.getValue("update.mode"),E=this.getProductQuality(y);if(!E){this.setState(b.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.setState(b.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const u=new URL(this.url);u.searchParams.set("prss","true"),this.url=u.toString()}if(this.setState(b.State.Idle(this.getUpdateType())),y==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}getProductQuality(y){return y==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(y=60*60*1e3){return(0,I.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(y){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(E){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(E);return}}async _applySpecificUpdate(y){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=h,e.AbstractUpdateService=h=be([re(0,C.ILifecycleMainService),re(1,O.IConfigurationService),re(2,M.IEnvironmentMainService),re(3,v.IRequestService),re(4,g.ILogService),re(5,c.IProductService)],h)}),define(ae[288],ce([0,1,14,50,3,45,2,18,24,20,5,27,53,28,49,101]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let E=class extends y.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"error",(d,f)=>f)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(d,f,m)=>({url:f,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(d,f,m,a)=>({releaseNotes:f,version:m,productVersion:m,date:a}))}constructor(d,f,m,a,t,o,s){super(d,f,a,t,o,s),this.telemetryService=m,this.disposables=new M.DisposableStore,d.setRelaunchHandler(this)}handleRelaunch(d){return d?.addArgs||d?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(d){this.telemetryService.publicLog2("update:error",{messageHash:String((0,O.hash)(String(d)))}),this.logService.error("UpdateService error:",d);const f=this.state.type==="checking for updates"&&this.state.explicit?d:void 0;this.setState(p.State.Idle(1,f))}buildUpdateFeedUrl(d){let f;this.productService.darwinUniversalAssetId?f=this.productService.darwinUniversalAssetId:f=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,y.createUpdateURL)(f,d,this.productService);try{I.autoUpdater.setFeedURL({url:m})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return m}doCheckForUpdates(d){this.setState(p.State.CheckingForUpdates(d)),I.autoUpdater.checkForUpdates()}onUpdateAvailable(d){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(d))}onUpdateDownloaded(d){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:d.version}),this.setState(p.State.Ready(d)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=E,be([L.memoize],E.prototype,"onRawError",null),be([L.memoize],E.prototype,"onRawUpdateNotAvailable",null),be([L.memoize],E.prototype,"onRawUpdateAvailable",null),be([L.memoize],E.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=E=be([re(0,c.ILifecycleMainService),re(1,C.IConfigurationService),re(2,h.ITelemetryService),re(3,g.IEnvironmentMainService),re(4,w.IRequestService),re(5,v.ILogService),re(6,b.IProductService)],E)}),define(ae[289],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let w=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,E,u){if(this.lifecycleMainService=y,this.logService=u,this._state=b.State.Uninitialized,this._onStateChange=new O.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}scheduleCheckForUpdates(y=60*60*1e3){return(0,r.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(y){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(y){}};w=be([re(0,g.ILifecycleMainService),re(1,C.IEnvironmentMainService),re(2,c.ILogService)],w);let h=class extends w{constructor(y,E,u,d,f,m){super(u,d,f),this.snap=y,this.snapRevision=E,this.telemetryService=m;const a=(0,L.watch)(M.dirname(this.snap)),t=O.Event.fromNodeEventEmitter(a,"change",(n,l)=>l),o=O.Event.filter(t,n=>n==="current"),i=O.Event.debounce(o,(n,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{i.dispose(),a.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(y=>{y?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,y.message||y))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const y=await new Promise((u,d)=>(0,L.realpath)(`${M.dirname(this.snap)}/current`,(f,m)=>f?d(f):u(m))),E=M.basename(y);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,y=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=h,e.SnapUpdateService=h=be([re(2,g.ILifecycleMainService),re(3,C.IEnvironmentMainService),re(4,c.ILogService),re(5,v.ITelemetryService)],h)}),define(ae[29],ce([0,1,14,4,6,81,55,69,27,18,24,9,137]),function(K,e,I,L,r,O,M,C,g,c,v,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.getLastFocused=e.defaultBrowserWindowOptions=e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,r.createDecorator)("windowsMainService");var h;(function(u){u[u.CLI=0]="CLI",u[u.DOCK=1]="DOCK",u[u.MENU=2]="MENU",u[u.DIALOG=3]="DIALOG",u[u.DESKTOP=4]="DESKTOP",u[u.API=5]="API"})(h||(e.OpenContext=h={}));function p(u,d,f){const m=u.get(C.IThemeMainService),a=u.get(g.IProductService),t=u.get(c.IConfigurationService),o=u.get(v.IEnvironmentMainService),s=t.getValue("window"),i={backgroundColor:m.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,title:a.nameLong,...f,x:d.x,y:d.y,width:d.width,height:d.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(d.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...f?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(L.isLinux?i.icon=(0,b.join)(o.appRoot,"resources/linux/code.png"):L.isWindows&&!o.isBuilt&&(i.icon=(0,b.join)(o.appRoot,"resources/win32/code_150x150.png")),L.isMacintosh&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),L.isMacintosh&&!(0,M.useNativeFullScreen)(t)&&(i.fullscreenable=!1),L.isMacintosh&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,M.hasNativeTitlebar)(t)&&(i.titleBarStyle="hidden",L.isMacintosh||(i.frame=!1),(0,M.useWindowControlsOverlay)(t))){const S=m.getWindowSplash()?.colorInfo.titleBarBackground??m.getBackgroundColor(),R=w.Color.fromHex(S).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:S,symbolColor:R}}return i}e.defaultBrowserWindowOptions=p;function y(u){let d,f=Number.MIN_VALUE;for(const m of u)m.lastFocusTime>f&&(f=m.lastFocusTime,d=m);return d}e.getLastFocused=y;var E;(function(u){function d(m,a,t=I.screen.getAllDisplays()){if(m.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){m.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){m.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=f(t[0]);if(m.trace("window#validateWindowState: single monitor working area",i),i){let n=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};n(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),n()}return a}if(a.display&&a.mode===3){const i=t.find(n=>n.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){m.trace("window#validateWindowState: restoring fullscreen to previous display");const n=(0,O.defaultWindowState)(3);return n.x=i.bounds.x,n.y=i.bounds.y,n}}let o,s;try{o=I.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=f(o),m.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){m.error("window#validateWindowState: error finding display for window state",i)}if(o&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;m.trace("window#validateWindowState: state is outside of the multi-monitor working area")}u.validateWindowState=d;function f(m){if(m.workArea.width>0&&m.workArea.height>0)return m.workArea;if(m.bounds.width>0&&m.bounds.height>0)return m.bounds}})(E||(e.WindowStateValidator=E={}))}),define(ae[290],ce([0,1,14,23,3,45,2,32,118,5,83,29]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let h=class extends M.Disposable{constructor(y,E,u,d){super(),this.logService=y,this.windowsMainService=E,this.encryptionMainService=u,this.applicationStorageMainService=d,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=r.Event.fromNodeEventEmitter(I.app,"login",(E,u,d,f,m)=>({event:E,webContents:u,req:d,authInfo:f,callback:m}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:E,req:u,callback:d}){if(!E.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(E);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(f?.username,f?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const E=await this.doResolveProxyCredentials(y);if(E)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),E;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const E=String((0,O.hash)({scheme:y.scheme,host:y.host,port:y.port}));let u,d;try{const t=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+E,-1);if(t){const o=JSON.parse(await this.encryptionMainService.decrypt(t));u=o.username,d=o.password}}catch(t){this.logService.error(t)}if(this.state!==w.StoredCredentialsUsed&&typeof u=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:u,password:d};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const m={authInfo:y,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,C.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,m),this.state=w.LoginDialogShown;const a=await new Promise(t=>{const o=async(s,i,n)=>{if(i===m.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",o),n){const l={username:n.username,password:n.password};try{if(n.remember){const S=await this.encryptionMainService.encrypt(JSON.stringify(l));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+E,S,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+E,-1)}catch(S){this.logService.error(S)}t({username:l.username,password:l.password})}else t(void 0)};f.win?.webContents.on("ipc-message",o)});return this.sessionCredentials=a,a}};e.ProxyAuthHandler=h,e.ProxyAuthHandler=h=be([re(0,c.ILogService),re(1,b.IWindowsMainService),re(2,g.IEncryptionMainService),re(3,v.IApplicationStorageMainService)],h)}),define(ae[291],ce([0,1,14,22,4,7,21,18,64,6,5,129,29]),function(K,e,I,L,r,O,M,C,g,c,v,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,c.createDecorator)(e.ID);let h=class{constructor(y,E,u,d){this.logService=y,this.windowsMainService=E,this.urlService=u,this.configurationService=d}async start(y,E){this.logService.trace("Received data from other instance: ",y,E),r.isMacintosh&&I.app.focus({steal:!0});const u=this.parseOpenUrl(y);if(u.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const f=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));f&&(d=f.ready())}d.then(()=>{for(const{uri:f,originalUrl:m}of u)this.urlService.open(f,{originalUrl:m})})}else return this.startOpenWindow(y,E)}parseOpenUrl(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,L.coalesce)(y._urls.map(E=>{try{return{uri:O.URI.parse(E),originalUrl:E}}catch{return null}})):[]}async startOpenWindow(y,E){const u=(0,g.isLaunchedFromCli)(E)?0:4;let d=[];const f=y.wait&&y.waitMarkerFilePath?O.URI.file(y.waitMarkerFilePath):void 0,m=y.remote||void 0,a={context:u,cli:y,userEnv:y["preserve-env"]||u===0?E:void 0,waitMarkerFileURI:f,remoteAuthority:m,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||y["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.isMacintosh}if(t)d=await this.windowsMainService.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,a),d=[o]):d=await this.windowsMainService.open({...a,forceEmpty:!0})}}else d=await this.windowsMainService.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(f&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,M.whenDeleted)(f.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=h,e.LaunchMainService=h=be([re(0,v.ILogService),re(1,w.IWindowsMainService),re(2,b.IURLService),re(3,C.IConfigurationService)],h)}),define(ae[292],ce([0,1,2,20,57,30,8,29]),function(K,e,I,L,r,O,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends I.Disposable{constructor(v,b,w){super(),this.userDataProfilesService=b,this.windowsMainService=w,this._register(v.onWillLoadWindow(h=>{h.reason===2&&this.unsetProfileForWorkspace(h.window)})),this._register(v.onBeforeCloseWindow(h=>this.unsetProfileForWorkspace(h))),this._register(new M.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(v){const b=this.getWorkspace(v),w=this.userDataProfilesService.getProfileForWorkspace(b);w?.isTransient&&(this.userDataProfilesService.unsetWorkspace(b,w.isTransient),w.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(v){return v.openedWorkspace??(0,O.toWorkspaceIdentifier)(v.backupPath,v.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const v=this.userDataProfilesService.getAssociatedEmptyWindows();if(v.length===0)return;const b=this.windowsMainService.getWindows().map(w=>this.getWorkspace(w));for(const w of v)b.some(h=>h.id===w.id)||this.userDataProfilesService.unsetWorkspace(w,!1)}};e.UserDataProfilesHandler=g,e.UserDataProfilesHandler=g=be([re(0,L.ILifecycleMainService),re(1,r.IUserDataProfilesMainService),re(2,C.IWindowsMainService)],g)}),define(ae[61],ce([0,1,14,2,3,5,312,8,13,29,73,28,20,75,35,4,132]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function d(a){return typeof a.responseWindowId=="number"}let f=class extends L.Disposable{static{u=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(u.all.values())}constructor(t,o,s){super(),this.logService=t,this.telemetryService=o,this.lifecycleMainService=s,this.id=String(++u.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new r.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(t,o){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,o){case v.default.Error:this.logService.error(s);break;case v.default.Warning:this.logService.warn(s);break;case v.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",v.default.Error),!1):!0}start(t){const o=this.doStart(t);return o&&t.payload&&this.postMessage(t.payload),o}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const o=`${this.configuration.type}-${this.id}`,s=g.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],n=this.configuration.execArgv??[],l=this.configuration.allowLoadingUnsignedLibraries,S=this.configuration.forceAllocationsToV8Sandbox,R="pipe",k=this.createEnv(t);return this.log("creating new...",v.default.Info),this.process=I.utilityProcess.fork(s,i,{serviceName:o,env:k,execArgv:n,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:S,stdio:R}),this.registerListeners(this.process,this.configuration,o),!0}createEnv(t){const o=t.env?{...t.env}:{...(0,p.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.isWindows&&((0,E.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,E.getUNCHostAllowlist)().join("\\")),(0,h.removeDangerousEnvVariables)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}registerListeners(t,o,s){if(t.stdout){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new M.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:i.write(n))))}this._register(r.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(r.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&u.all.set(t.pid,{pid:t.pid,name:d(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",v.default.Info),this._onSpawn.fire(t.pid)})),this._register(r.Event.fromNodeEventEmitter(t,"exit")(i=>{this.log(`received exit event with code ${i}`,v.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(I.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,v.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,o){const s=this._register(this._onMessage.event(i=>{i===t&&(s.dispose(),o())}))}postMessage(t,o){this.process&&this.process.postMessage(t,o)}connect(t){const{port1:o,port2:s}=new I.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",v.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",v.default.Info),this.process.kill()?(this.log("successfully killed the process",v.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",v.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&u.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",v.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,C.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,v.default.Info),this.kill()))}};e.UtilityProcess=f,e.UtilityProcess=f=u=be([re(0,O.ILogService),re(1,b.ITelemetryService),re(2,w.ILifecycleMainService)],f);let m=class extends f{constructor(t,o,s,i){super(t,s,i),this.windowsMainService=o}start(t){const o=this.windowsMainService.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,o){o.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=m,e.WindowUtilityProcess=m=be([re(0,O.ILogService),re(1,c.IWindowsMainService),re(2,b.ITelemetryService),re(3,w.ILifecycleMainService)],m)}),define(ae[293],ce([0,1,15,3,5,20,8,61,29,28]),function(K,e,I,L,r,O,M,C,g,c){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let b=class{static{v=this}static{this._lastId=0}constructor(h,p,y,E){this._logService=h,this._lifecycleMainService=p,this._windowsMainService=y,this._telemetryService=E,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(u=>{this._shutdown=!0,u.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(h){const p=this._extHosts.get(h);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(h){return this._getExtHost(h).onStdout}onDynamicStderr(h){return this._getExtHost(h).onStderr}onDynamicMessage(h){return this._getExtHost(h).onMessage}onDynamicExit(h){return this._getExtHost(h).onExit}async createExtensionHost(){if(this._shutdown)throw(0,I.canceled)();const h=String(++v._lastId),p=new C.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(h,p),p.onExit(({pid:y,code:E,signal:u})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${E}, signal: ${u}.`),setTimeout(()=>{p.dispose(),this._extHosts.delete(h)}),setTimeout(()=>{try{process.kill(y,0),this._logService.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:h}}async start(h,p){if(this._shutdown)throw(0,I.canceled)();const y=this._getExtHost(h);return y.start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:h}),{pid:await L.Event.toPromise(y.onSpawn)}}async enableInspectPort(h){if(this._shutdown)throw(0,I.canceled)();const p=this._extHosts.get(h);return p?p.enableInspectPort():!1}async kill(h){if(this._shutdown)throw(0,I.canceled)();const p=this._extHosts.get(h);p&&p.kill()}async _killAllNow(){for(const[,h]of this._extHosts)h.kill()}async _waitForAllExit(h){const p=[];for(const[,y]of this._extHosts)p.push(y.waitForExit(h));return M.Promises.settled(p).then(()=>{})}};e.ExtensionHostStarter=b,e.ExtensionHostStarter=b=v=be([re(0,r.ILogService),re(1,O.ILifecycleMainService),re(2,g.IWindowsMainService),re(3,c.ITelemetryService)],b)}),define(ae[294],ce([0,1,37,8,2,24,20,5,41,39,68,61,54,91,12,247]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends r.Disposable{constructor(d,f,m,a,t,o,s,i){super(),this.machineId=d,this.sqmId=f,this.environmentMainService=m,this.userDataProfilesService=a,this.lifecycleMainService=t,this.logService=o,this.loggerMainService=s,this.policyService=i,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){I.validatedIpcMain.on(y.SharedProcessChannelConnection.request,(d,f)=>this.onWindowConnection(d,f,y.SharedProcessChannelConnection.response)),I.validatedIpcMain.on(y.SharedProcessRawConnection.request,(d,f)=>this.onWindowConnection(d,f,y.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(d,f,m){this.logService.trace(`[SharedProcess] onWindowConnection for: ${m}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect(m);if(d.sender.isDestroyed())return a.close();d.sender.postMessage(m,f,[a])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(y.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const d=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(y.SharedProcessLifecycle.initDone,()=>d.complete()):I.validatedIpcMain.once(y.SharedProcessLifecycle.initDone,()=>d.complete()),await d.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const d=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(y.SharedProcessLifecycle.ipcReady,()=>d.complete()):I.validatedIpcMain.once(y.SharedProcessLifecycle.ipcReady,()=>d.complete()),await d.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new b.UtilityProcess(this.logService,w.NullTelemetryService,this.lifecycleMainService));const d=(0,h.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let f;d.port&&(f=["--nolazy"],d.break?f.push(`--inspect-brk=${d.port}`):f.push(`--inspect=${d.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:f})}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(d){return await this.whenIpcReady,(0,p.assertIsDefined)(this.utilityProcess).connect(d)}};e.SharedProcess=E,e.SharedProcess=E=be([re(2,O.IEnvironmentMainService),re(3,g.IUserDataProfilesService),re(4,M.ILifecycleMainService),re(5,C.ILogService),re(6,v.ILoggerMainService),re(7,c.IPolicyService)],E)}),define(ae[295],ce([0,1,24,91,20,5,54,61,112,37,2,3,35,18,13]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let y=class extends v.Disposable{constructor(u,d,f,m,a){super(),this._reconnectConstants=u,this._configurationService=d,this._environmentMainService=f,this._lifecycleMainService=m,this._logService=a,this.utilityProcess=void 0,this._onRequestConnection=new b.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new b.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),c.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,o)=>this._onWindowConnection(t,o)),this._register((0,v.toDisposable)(()=>{c.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new C.UtilityProcess(this._logService,M.NullTelemetryService,this._lifecycleMainService);const u=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),d=u.port?["--nolazy",`--inspect${u.break?"-brk":""}=${u.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:p.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const f=this.utilityProcess.connect(),m=new g.Client(f,"ptyHost"),a=new v.DisposableStore;return a.add(m),a.add((0,v.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:m,store:a,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const u={...(0,w.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},d=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&(u.VSCODE_LATENCY=String(d));const f=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return f&&typeof f=="number"&&(u.VSCODE_STARTUP_DELAY=String(f)),this._environmentMainService.restoreSnapExportedVariables(),u}_onWindowConnection(u,d){this._onRequestConnection.fire();const f=this.utilityProcess.connect();if(u.sender.isDestroyed()){f.close();return}u.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[f])}};e.ElectronPtyHostStarter=y,e.ElectronPtyHostStarter=y=be([re(1,h.IConfigurationService),re(2,I.IEnvironmentMainService),re(3,r.ILifecycleMainService),re(4,O.ILogService)],y)}),define(ae[296],ce([0,1,2,6,5,29,61,28,45,3,8,20]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let w=class extends I.Disposable{constructor(y,E,u,d){super(),this.logService=y,this.windowsMainService=E,this.telemetryService=u,this.lifecycleMainService=d,this.workers=new Map}async createWorker(y){const E=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${E})`);const u=this.hash(y);this.workers.has(u)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${E})`),this.disposeWorker(y));const d=new h(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,y);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(u,d);const f=new v.DeferredPromise;return c.Event.once(d.onDidTerminate)(m=>{m.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${m.code}, signal: ${m.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${m.code}, signal: ${m.signal}`),this.workers.delete(u),f.complete({reason:m})}),f.p}hash(y){return(0,g.hash)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const E=this.hash(y),u=this.workers.get(E);u&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),u.kill(),this.workers.delete(E))}};e.UtilityProcessWorkerMainService=w,e.UtilityProcessWorkerMainService=w=be([re(0,r.ILogService),re(1,O.IWindowsMainService),re(2,C.ITelemetryService),re(3,b.ILifecycleMainService)],w);let h=class extends I.Disposable{constructor(y,E,u,d,f){super(),this.logService=y,this.windowsMainService=E,this.telemetryService=u,this.lifecycleMainService=d,this.configuration=f,this._onDidTerminate=this._register(new c.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new M.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(y=>this._onDidTerminate.fire({code:y.code,signal:y.signal}))),this._register(this.utilityProcess.onCrash(y=>this._onDidTerminate.fire({code:y.code,signal:"ECRASH"})))}spawn(){const E=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:E,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};h=be([re(0,r.ILogService),re(1,O.IWindowsMainService),re(2,C.ITelemetryService),re(3,b.ILifecycleMainService)],h)}),define(ae[297],ce([0,1,14,3,2,273,29]),function(K,e,I,L,r,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let C=class extends r.Disposable{constructor(c){super(),this.windowsMainService=c,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new O.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(c,v){let b;if(typeof c.windowId=="number"){const{windowId:w}=c,h=this.windowsMainService.getWindowById(w);if(!h?.win)throw new Error(`Invalid windowId: ${w}`);b=h.win.webContents}else{const{webContentsId:w}=c;if(b=I.webContents.fromId(w),!b)throw new Error(`Invalid webContentsId: ${w}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(v)}async findInFrame(c,v,b,w){const p=this.getFrameByName(c,v);if(typeof p.findInFrame=="function"){p.findInFrame(b,{findNext:w.findNext,forward:w.forward});const y=(E,u)=>{u.finalUpdate&&(this._onFoundInFrame.fire(u),p.removeListener("found-in-frame",y))};p.on("found-in-frame",y)}}async stopFindInFrame(c,v,b){const h=this.getFrameByName(c,v);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(c,v){const b=this.windowsMainService.getWindowById(c.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${c}`);const w=b.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===v);if(!w)throw new Error(`Unknown frame: ${v}`);return w}};e.WebviewMainService=C,e.WebviewMainService=C=be([re(0,M.IWindowsMainService)],C)}),define(ae[298],ce([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class extends L.Disposable{static{p=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(a,t,o,s,i){super(),this.windowsMainService=a,this.stateService=t,this.lifecycleMainService=o,this.logService=s,this.configurationService=i,this._state=E(this.stateService.getItem(p.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){I.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(a=>this.onBeforeCloseWindow(a)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(a=>this.onBeforeCloseWindow(a))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(a.has(n.uiState.display)?r.isMacintosh&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):a.add(n.uiState.display)),n}));const s=d(t);this.stateService.setItem(p.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(a){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this._state.openedWindows.forEach(o=>{const s=(0,h.isWorkspaceIdentifier)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)&&o.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(o.folderUri,a.openedWorkspace.uri);(s||i)&&(o.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(a){return{windowId:a.id,workspace:(0,h.isWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.doGetNewWindowState(a),o=this.configurationService.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),s||(t.mode=1)}return t}doGetNewWindowState(a){const t=this.windowsMainService.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=a.workspace;if((0,h.isWorkspaceIdentifier)(S)){const k=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===S.id).map(P=>P.uiState);if(k.length)return k[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(S)){const k=this.state.openedWindows.filter(P=>P.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(P.folderUri,S.uri)).map(P=>P.uiState);if(k.length)return k[0]}else if(a.backupPath){const k=this.state.openedWindows.filter(P=>P.backupPath===a.backupPath).map(P=>P.uiState);if(k.length)return k[0]}const R=this.lastClosedState||this.state.lastActiveWindow;if(!t&&R)return R.uiState}let o;const s=I.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(r.isMacintosh){const S=I.screen.getCursorScreenPoint();o=I.screen.getDisplayNearestPoint(S)}!o&&t&&(o=I.screen.getDisplayMatching(t.getBounds())),o||(o=I.screen.getPrimaryDisplay()||s[0])}let i=(0,w.defaultWindowState)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let l=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const S=t.serializeWindowState();S.mode===3?i.mode=3:i={...S,zoomLevel:void 0},l=i.mode!==3&&n.newWindowDimensions==="offset"}}return l&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(a){if(this.windowsMainService.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.WindowsStateHandler=y,e.WindowsStateHandler=y=p=be([re(0,b.IWindowsMainService),re(1,v.IStateService),re(2,g.ILifecycleMainService),re(3,c.ILogService),re(4,C.IConfigurationService)],y);function E(m){const a={openedWindows:[]},t=m||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=u(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=u(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>u(o))),a}e.restoreWindowsState=E;function u(m){const a={uiState:m.uiState};return m.backupPath&&(a.backupPath=m.backupPath),m.remoteAuthority&&(a.remoteAuthority=m.remoteAuthority),m.folder&&(a.folderUri=M.URI.parse(m.folder)),m.workspaceIdentifier&&(a.workspace={id:m.workspaceIdentifier.id,configPath:M.URI.parse(m.workspaceIdentifier.configURIPath)}),a}function d(m){return{lastActiveWindow:m.lastActiveWindow&&f(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&f(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(a=>f(a))}}e.getWindowsStateStoreData=d;function f(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(ae[58],ce([0,1,14,3,42,2,13,9,19,21,194,65,56,24,6,5,57,131,30,98,99]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let a=class extends O.Disposable{constructor(o,s,i,n,l){super(),this.environmentMainService=o,this.logService=s,this.userDataProfilesMainService=i,this.backupMainService=n,this.dialogMainService=l,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await c.Promises.readdir(this.untitledWorkspacesHome.with({scheme:M.Schemas.file}).fsPath)).map(s=>(0,g.joinPath)(this.untitledWorkspacesHome,s,d.UNTITLED_WORKSPACE_NAME));for(const s of o){const i=(0,m.getWorkspaceIdentifier)(s),n=await this.resolveLocalWorkspace(s);n?this.untitledWorkspaces.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,s=>c.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(o,s){if(this.isWorkspacePath(o)&&o.scheme===M.Schemas.file)try{const i=s(o.fsPath);return i instanceof Promise?i.then(n=>this.doResolveWorkspace(o,n),n=>{}):this.doResolveWorkspace(o,i)}catch{return}}isWorkspacePath(o){return(0,d.isUntitledWorkspace)(o,this.environmentMainService)||(0,d.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,s){try{const i=this.doParseStoredWorkspace(o,s),n=(0,m.getWorkspaceIdentifier)(o);return{id:n.id,configPath:n.configPath,folders:(0,f.toWorkspaceFolders)(i.folders,n.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(o,s){const i=(0,r.parse)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,f.isStoredWorkspaceFolder)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,s){const{workspace:i,storedWorkspace:n}=this.newUntitledWorkspace(o,s),l=i.configPath.fsPath;return await c.Promises.mkdir((0,C.dirname)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(n,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:s}),i}newUntitledWorkspace(o=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,g.joinPath)(this.untitledWorkspacesHome,i),l=(0,g.joinPath)(n,d.UNTITLED_WORKSPACE_NAME),S=[];for(const R of o)S.push((0,f.getStoredWorkspaceFolder)(R.uri,!0,R.name,n,g.extUriBiasedIgnorePathCase));return{workspace:(0,m.getWorkspaceIdentifier)(l),storedWorkspace:{folders:S,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,m.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,d.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const s=(0,g.originalFSPath)(o.configPath);try{await c.Promises.rm((0,C.dirname)(s));const i=(0,C.join)(this.environmentMainService.workspaceStorageHome.with({scheme:M.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,C.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(n=>n.workspace.id!==o.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,s,i){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,s,i))return;const l=await this.doEnterWorkspace(o,(0,m.getWorkspaceIdentifier)(i));if(l)return this._onDidEnterWorkspace.fire({window:o,workspace:l.workspace}),l}async isValidTargetWorkspacePath(o,s,i){return i?(0,d.isWorkspaceIdentifier)(o.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,i)?!1:(0,u.findWindowOnWorkspaceOrFolder)(s,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,g.basename)(i)),detail:(0,v.localize)(2,null)},I.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,s){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,d.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=i,{workspace:s,backupPath:i}}};e.WorkspacesManagementMainService=a,e.WorkspacesManagementMainService=a=be([re(0,h.IEnvironmentMainService),re(1,y.ILogService),re(2,E.IUserDataProfilesMainService),re(3,b.IBackupMainService),re(4,w.IDialogMainService)],a)}),define(ae[133],ce([0,1,14,37,23,6,29,30,58,12,5,61]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,O.createDecorator)(e.ID);let w=class{constructor(p,y,E){this.windowsMainService=p,this.workspacesManagementMainService=y,this.logService=E}async getRemoteDiagnostics(p){const y=this.windowsMainService.getWindows();return(await Promise.all(y.map(async u=>{const d=u.remoteAuthority;if(!d)return;const f=`vscode:getDiagnosticInfoResponse${u.id}`,m={includeProcesses:p.includeProcesses,folders:p.includeWorkspaceMetadata?await this.getFolderURIs(u):void 0};return new Promise(a=>{u.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:f,args:m}),L.validatedIpcMain.once(f,(t,o)=>{o||a({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),a(o)}),setTimeout(()=>{a({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(u=>!!u)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const p=[];for(const E of I.BrowserWindow.getAllWindows()){const u=this.windowsMainService.getWindowById(E.id);u?p.push(await this.codeWindowToInfo(u)):p.push(this.browserWindowToInfo(E))}const y=[];for(const{pid:E,name:u}of b.UtilityProcess.getAll())y.push({pid:E,name:u});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:p,pidToNames:y,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async codeWindowToInfo(p){const y=await this.getFolderURIs(p),E=(0,c.assertIsDefined)(p.win);return this.browserWindowToInfo(E,y,p.remoteAuthority)}browserWindowToInfo(p,y=[],E){return{id:p.id,pid:p.webContents.getOSProcessId(),title:p.getTitle(),folderURIs:y,remoteAuthority:E}}async getFolderURIs(p){const y=[],E=p.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(E))y.push(E.uri);else if((0,C.isWorkspaceIdentifier)(E)){const u=await this.workspacesManagementMainService.resolveLocalWorkspace(E.configPath);u&&u.folders.forEach(f=>{y.push(f.uri)})}return y}};e.DiagnosticsMainService=w,e.DiagnosticsMainService=w=be([re(0,M.IWindowsMainService),re(1,g.IWorkspacesManagementMainService),re(2,v.ILogService)],w)}),define(ae[70],ce([0,1,48,14,26,156,50,3,2,13,9,4,7,107,89,21,105,182,56,24,6,20,5,27,69,29,30,58,17,243,235,78,15]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n,l,S,R,k,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,m.createDecorator)("nativeHostMainService");let _=class extends g.Disposable{constructor(F,H,j,le,se,ue,Y,Q,q){super(),this.windowsMainService=F,this.auxiliaryWindowsMainService=H,this.dialogMainService=j,this.lifecycleMainService=le,this.environmentMainService=se,this.logService=ue,this.productService=Y,this.themeMainService=Q,this.workspacesManagementMainService=q,this.onDidOpenMainWindow=C.Event.map(this.windowsMainService.onDidOpenWindow,W=>W.id),this.onDidTriggerWindowSystemContextMenu=C.Event.any(C.Event.filter(C.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:W,x:N,y:V})=>({windowId:W.id,x:N,y:V})),({windowId:W})=>!!this.windowsMainService.getWindowById(W)),C.Event.filter(C.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:W,x:N,y:V})=>({windowId:W.id,x:N,y:V})),({windowId:W})=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidMaximizeWindow=C.Event.any(C.Event.filter(C.Event.map(this.windowsMainService.onDidMaximizeWindow,W=>W.id),W=>!!this.windowsMainService.getWindowById(W)),C.Event.filter(C.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,W=>W.id),W=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidUnmaximizeWindow=C.Event.any(C.Event.filter(C.Event.map(this.windowsMainService.onDidUnmaximizeWindow,W=>W.id),W=>!!this.windowsMainService.getWindowById(W)),C.Event.filter(C.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,W=>W.id),W=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidChangeWindowFullScreen=C.Event.any(C.Event.map(this.windowsMainService.onDidChangeFullScreen,W=>({windowId:W.window.id,fullscreen:W.fullscreen})),C.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,W=>({windowId:W.window.id,fullscreen:W.fullscreen}))),this.onDidBlurMainWindow=C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(W,N)=>N.id),W=>!!this.windowsMainService.getWindowById(W)),this.onDidFocusMainWindow=C.Event.any(C.Event.map(C.Event.filter(C.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),W=>!!W),W=>W.id),C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(W,N)=>N.id),W=>!!this.windowsMainService.getWindowById(W))),this.onDidBlurMainOrAuxiliaryWindow=C.Event.any(this.onDidBlurMainWindow,C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(W,N)=>N.id),W=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidFocusMainOrAuxiliaryWindow=C.Event.any(this.onDidFocusMainWindow,C.Event.filter(C.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(W,N)=>N.id),W=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidResumeOS=C.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new C.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=C.Event.debounce(C.Event.any(C.Event.filter(C.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(W,N,V)=>V),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),C.Event.fromNodeEventEmitter(L.screen,"display-added"),C.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,H){const j=this.windowsMainService.getWindows().map(se=>({id:se.id,workspace:se.openedWorkspace??(0,n.toWorkspaceIdentifier)(se.backupPath,se.isExtensionDevelopmentHost),title:se.win?.getTitle()??"",filename:se.getRepresentedFilename(),dirty:se.isDocumentEdited()})),le=[];return H.includeAuxiliaryWindows&&le.push(...this.auxiliaryWindowsMainService.getWindows().map(se=>({id:se.id,parentId:se.parentId,title:se.win?.getTitle()??"",filename:se.getRepresentedFilename()}))),[...j,...le]}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const H=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(H)return H.id}openWindow(F,H,j){return Array.isArray(H)?this.doOpenWindow(F,H,j):this.doOpenEmptyWindow(F,H)}async doOpenWindow(F,H,j=Object.create(null)){H.length>0&&await this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:H,cli:this.environmentMainService.args,forceNewWindow:j.forceNewWindow,forceReuseWindow:j.forceReuseWindow,preferNewWindow:j.preferNewWindow,diffMode:j.diffMode,mergeMode:j.mergeMode,addMode:j.addMode,gotoLineMode:j.gotoLineMode,noRecentEntry:j.noRecentEntry,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:j.remoteAuthority||void 0,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile})}async doOpenEmptyWindow(F,H){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},H)}async toggleFullScreen(F,H){this.windowById(H?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,H){this.windowById(H?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const H=L.screen.getCursorScreenPoint(),j=L.screen.getDisplayNearestPoint(H);return{point:H,display:j.bounds}}async isMaximized(F,H){return this.windowById(H?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,H){this.windowById(H?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,H){this.windowById(H?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,H){this.windowById(H?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,H){this.windowById(H?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,H,j){const le=this.windowById(j?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const se=C.Event.toPromise(C.Event.once(C.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await se}le.win.setBounds(H)}}async updateWindowControls(F,H){this.windowById(H?.targetWindowId,F)?.updateWindowControls(H)}async focusWindow(F,H){this.windowById(H?.targetWindowId,F)?.focus({force:H?.force??!1})}async setMinimumSize(F,H,j){const le=this.codeWindowById(F);if(le?.win){const[se,ue]=le.win.getSize(),[Y,Q]=le.win.getMinimumSize(),[q,W]=[H??Y,j??Q],[N,V]=[Math.max(se,q),Math.max(ue,W)];(Y!==q||Q!==W)&&le.win.setMinimumSize(q,W),(se!==N||ue!==V)&&le.win.setSize(N,V)}}async saveWindowSplash(F,H){this.themeMainService.saveWindowSplash(F,H)}async installShellCommand(F){const{source:H,target:j}=await this.getShellCommandLink();try{const{symbolicLink:le}=await y.SymlinkSupport.stat(H);if(le&&!le.dangling){const se=await(0,h.realpath)(H);if(j===se)return}await y.Promises.unlink(H)}catch(le){if(le.code!=="ENOENT")throw le}try{await y.Promises.symlink(j,H)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:se}=await this.showMessageBox(F,{type:"info",message:(0,u.localize)(0,null,this.productService.nameShort),buttons:[(0,u.localize)(1,null),(0,u.localize)(2,null)]});if(se===1)throw new D.CancellationError;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${j}' '${H}'\\" with administrator privileges"`;await(0,O.promisify)(I.exec)(ue)}catch{throw new Error((0,u.localize)(3,null,H))}}}async uninstallShellCommand(F){const{source:H}=await this.getShellCommandLink();try{await y.Promises.unlink(H)}catch(j){switch(j.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,u.localize)(4,null,this.productService.nameShort),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]});if(le===1)throw new D.CancellationError;try{const se=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,O.promisify)(I.exec)(se)}catch{throw new Error((0,u.localize)(7,null,H))}break}case"ENOENT":break;default:throw j}}}async getShellCommandLink(){const F=(0,v.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),H=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(F))throw new Error((0,u.localize)(8,null,F));return{source:H,target:F}}async showMessageBox(F,H){const j=this.windowById(H?.targetWindowId,F);return this.dialogMainService.showMessageBox(H,j?.win??void 0)}async showSaveDialog(F,H){const j=this.windowById(H?.targetWindowId,F);return this.dialogMainService.showSaveDialog(H,j?.win??void 0)}async showOpenDialog(F,H){const j=this.windowById(H?.targetWindowId,F);return this.dialogMainService.showOpenDialog(H,j?.win??void 0)}async pickFileFolderAndOpen(F,H){const j=await this.dialogMainService.pickFileFolder(H);j&&await this.doOpenPicked(await Promise.all(j.map(async le=>await y.SymlinkSupport.existsDirectory(le)?{folderUri:w.URI.file(le)}:{fileUri:w.URI.file(le)})),H,F)}async pickFolderAndOpen(F,H){const j=await this.dialogMainService.pickFolder(H);j&&await this.doOpenPicked(j.map(le=>({folderUri:w.URI.file(le)})),H,F)}async pickFileAndOpen(F,H){const j=await this.dialogMainService.pickFile(H);j&&await this.doOpenPicked(j.map(le=>({fileUri:w.URI.file(le)})),H,F)}async pickWorkspaceAndOpen(F,H){const j=await this.dialogMainService.pickWorkspace(H);j&&await this.doOpenPicked(j.map(le=>({workspaceUri:w.URI.file(le)})),H,F)}async doOpenPicked(F,H,j){await this.windowsMainService.open({context:3,contextWindowId:j,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:H.forceNewWindow})}async showItemInFolder(F,H){L.shell.showItemInFolder(H)}async setRepresentedFilename(F,H,j){this.windowById(j?.targetWindowId,F)?.setRepresentedFilename(H)}async setDocumentEdited(F,H,j){this.windowById(j?.targetWindowId,F)?.setDocumentEdited(H)}async openExternal(F,H){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(H),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(F,H){return L.shell.trashItem(H)}async isAdmin(){let F;return b.isWindows?F=(await new Promise((H,j)=>{K(["native-is-elevated"],H,j)}))():F=process.getuid?.()===0,F}async writeElevated(F,H,j,le){const se=await new Promise((ue,Y)=>{K(["@vscode/sudo-prompt"],ue,Y)});return new Promise((ue,Y)=>{const Q=[`"${this.cliPath}"`];le?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${H.fsPath}"`,`"${j.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(Q.join(" "),q,(W,N,V)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),V&&this.logService.trace(`[sudo-prompt] received stderr: ${V}`),W?Y(W):ue(void 0)})})}async isRunningUnderARM64Translation(){return b.isLinux||b.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,v.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return p.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,R.hasWSLFeatureInstalled)()}async killProcess(F,H,j){process.kill(H,j)}async readClipboardText(F,H){return L.clipboard.readText(H)}async writeClipboardText(F,H,j){return L.clipboard.writeText(H,j)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,H){return L.clipboard.writeFindText(H)}async writeClipboardBuffer(F,H,j,le){return L.clipboard.writeBuffer(H,Buffer.from(j.buffer),le)}async readClipboardBuffer(F,H){return S.VSBuffer.wrap(L.clipboard.readBuffer(H))}async hasClipboard(F,H,j){return L.clipboard.has(H,j)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,H){this.codeWindowById(F)?.updateTouchBar(H)}async notifyReady(F){this.codeWindowById(F)?.setReady()}async relaunch(F,H){return this.lifecycleMainService.relaunch(H)}async reload(F,H){const j=this.codeWindowById(F);if(j){if((0,n.isWorkspaceIdentifier)(j.openedWorkspace)){const le=j.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(le))?.transient)return this.openWindow(j.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(j,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(F,H){return this.windowById(H?.targetWindowId,F)?.win?.close()}async quit(F){const H=this.windowsMainService.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&H.win?H.win.close():this.lifecycleMainService.quit()}async exit(F,H){await this.lifecycleMainService.kill(H)}async resolveProxy(F,H){return this.codeWindowById(F)?.win?.webContents?.session?.resolveProxy(H)}async loadCertificates(F){return(await new Promise((j,le)=>{K(["@vscode/proxy-agent"],j,le)})).loadSystemCertificates({log:this.logService})}findFreePort(F,H,j,le,se=1){return(0,E.findFreePort)(H,j,le,se)}async openDevTools(F,H){this.windowById(H?.targetWindowId,F)?.win?.webContents.openDevTools(H?.mode?{mode:H.mode,activate:H.activate}:void 0)}async toggleDevTools(F,H){this.windowById(H?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,H,j){const le=this.codeWindowById(F);if(!le||!le.win)throw new Error;return await new k.WindowProfiler(le.win,H,this.logService).inspect(j)}async windowsGetStringRegKey(F,H,j,le){if(!b.isWindows)return;const se=await new Promise((ue,Y)=>{K(["@vscode/windows-registry"],ue,Y)});try{return se.GetStringRegKey(H,j,le)}catch{return}}windowById(F,H){return this.codeWindowById(F)??this.auxiliaryWindowById(F)??this.codeWindowById(H)}codeWindowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}auxiliaryWindowById(F){if(typeof F=="number")return this.auxiliaryWindowsMainService.getWindowById(F)}};e.NativeHostMainService=_,be([M.memoize],_.prototype,"cliPath",null),e.NativeHostMainService=_=be([re(0,i.IWindowsMainService),re(1,P.IAuxiliaryWindowsMainService),re(2,d.IDialogMainService),re(3,a.ILifecycleMainService),re(4,f.IEnvironmentMainService),re(5,t.ILogService),re(6,o.IProductService),re(7,s.IThemeMainService),re(8,l.IWorkspacesManagementMainService)],_)}),define(ae[299],ce([0,1,14,26,8,23,33,2,13,4,7,109,37,180,92,133,56,24,5,70,79,27,80,34,61,55,29]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const S="issue.processExplorerWindowState";let R=class{static{l=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(D,_,U,F,H,j,le,se,ue,Y,Q){this.userEnv=D,this.environmentMainService=_,this.logService=U,this.diagnosticsService=F,this.diagnosticsMainService=H,this.dialogMainService=j,this.nativeHostMainService=le,this.protocolMainService=se,this.productService=ue,this.stateService=Y,this.windowsMainService=Q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.validatedIpcMain.on("vscode:listProcesses",async D=>{const _=[];try{_.push({name:(0,h.localize)(0,null),rootProcess:await(0,b.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,p.isRemoteDiagnosticError)(F)?_.push({name:F.hostName,rootProcess:F}):F.processes&&_.push({name:F.hostName,rootProcess:F.processes})})}catch(U){this.logService.error(`Listing processes failed: ${U}`)}this.safeSend(D,"vscode:listProcessesResponse",_)}),w.validatedIpcMain.on("vscode:workbenchCommand",(D,_)=>{const{id:U,from:F,args:H}=_;let j;switch(F){case"processExplorer":j=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${F}`)}j?.webContents.send("vscode:runAction",{id:U,from:F,args:H})}),w.validatedIpcMain.on("vscode:closeProcessExplorer",D=>{this.processExplorerWindow?.close()}),w.validatedIpcMain.on("vscode:pidToNameRequest",async D=>{const _=await this.diagnosticsMainService.getMainDiagnostics(),U=[];for(const F of _.windows)U.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:H}of s.UtilityProcess.getAll())U.push([F,H]);this.safeSend(D,"vscode:pidToNameResponse",U)})}async openReporter(D){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=I.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const _=new C.DisposableStore,U=_.add(this.protocolMainService.createIPCObjectUrl()),F=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(F,U,{backgroundColor:D.styles.backgroundColor,title:(0,h.localize)(1,null),zoomLevel:D.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:D,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:m.default}),this.issueReporterWindow.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,_.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,_.dispose())})}}async openProcessExplorer(D){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=I.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const _=new C.DisposableStore,U=_.add(this.protocolMainService.createIPCObjectUrl()),F=this.stateService.getItem(S,void 0),H=k(F)?F:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(H,U,{backgroundColor:D.styles.backgroundColor,title:(0,h.localize)(2,null),zoomLevel:D.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:D,product:m.default}),this.processExplorerWindow.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,_.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,_.dispose())});const j=()=>{if(!this.processExplorerWindow)return;const le=this.processExplorerWindow.getSize(),se=this.processExplorerWindow.getPosition();if(!le||!se)return;const ue={width:le[0],height:le[1],x:se[0],y:se[1]};this.stateService.setItem(S,ue)};this.processExplorerWindow.on("moved",j),this.processExplorerWindow.on("resized",j)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const D=await I.contentTracing.stopRecording(`${(0,M.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null,D),buttons:[(0,h.localize)(5,null)]},I.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,D)}async getSystemStatus(){const[D,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(D,_)}async $getSystemInfo(){const[D,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(D,_)}async $getPerformanceInfo(){try{const[D,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(D,_)}catch(D){throw this.logService.warn("issueService#getPerformanceInfo ",D.message),D}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(D){this.logService.error(D)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(6,null),buttons:[(0,h.localize)(7,null),(0,h.localize)(8,null)]},this.issueReporterWindow);D===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:D}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,h.localize)(9,null),buttons:[(0,h.localize)(10,null),(0,h.localize)(11,null)]},this.issueReporterWindow);return D===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const D=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!D)throw new Error("Window not found");return D}async $getIssueReporterUri(D){const _=this.issueReporterWindowCheck(),U=`vscode:triggerIssueUriRequestHandlerResponse${_.id}`;return r.Promises.withAsyncBody(async(F,H)=>{const j=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueUriRequestHandler",j.token,{replyChannel:U,extensionId:D}),w.validatedIpcMain.once(U,(le,se)=>{F(v.URI.parse(se))});try{await(0,r.timeout)(5e3),j.cancel(),H(new Error("Timed out waiting for issue reporter URI"))}finally{w.validatedIpcMain.removeHandler(U)}})}async $getIssueReporterData(D){const _=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataProviderResponse${_.id}`;return r.Promises.withAsyncBody(async F=>{const H=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueDataProvider",H.token,{replyChannel:U,extensionId:D}),w.validatedIpcMain.once(U,(j,le)=>{F(le)});try{await(0,r.timeout)(5e3),H.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{w.validatedIpcMain.removeHandler(U)}})}async $getIssueReporterTemplate(D){const _=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataTemplateResponse${_.id}`;return r.Promises.withAsyncBody(async F=>{const H=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueDataTemplate",H.token,{replyChannel:U,extensionId:D}),w.validatedIpcMain.once(U,(j,le)=>{F(le)});try{await(0,r.timeout)(5e3),H.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{w.validatedIpcMain.removeHandler(U)}})}async $getReporterStatus(D,_){const U=[!1,!1],F=this.issueReporterWindowCheck(),H="vscode:triggerReporterStatus",j=new O.CancellationTokenSource;return F.sendWhenReady(H,j.token,{replyChannel:H,extensionId:D,extensionName:_}),await(0,r.raceTimeout)(new Promise(se=>w.validatedIpcMain.once("vscode:triggerReporterStatusResponse",(ue,Y)=>se(Y))),2e3,()=>{this.logService.error("Error: Extension timed out waiting for reporter status"),j.cancel()})??U}async $sendReporterMenu(D,_){const U=this.issueReporterWindowCheck(),F="vscode:triggerReporterMenu",H=new O.CancellationTokenSource;return U.sendWhenReady(F,H.token,{replyChannel:F,extensionId:D,extensionName:_}),await(0,r.raceTimeout)(new Promise(le=>w.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${D}`,(se,ue)=>le(ue))),5e3,()=>{this.logService.error(`Error: Extension ${D} timed out waiting for menu response`),H.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(D){D.isMinimized()&&D.restore(),D.focus()}safeSend(D,_,...U){D.sender.isDestroyed()||D.sender.send(_,...U)}createBrowserWindow(D,_,U,F){const H=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:D.width,height:D.height,minWidth:300,minHeight:200,x:D.x,y:D.y,title:U.title,backgroundColor:U.backgroundColor||l.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${_.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.zoomLevelToZoomFactor)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return H.setMenuBarVisibility(!1),H}getWindowPosition(D,_,U){let F;const H=I.screen.getAllDisplays();if(H.length===1)F=H[0];else{if(c.isMacintosh){const se=I.screen.getCursorScreenPoint();F=I.screen.getDisplayNearestPoint(se)}!F&&D&&(F=I.screen.getDisplayMatching(D.getBounds())),F||(F=I.screen.getPrimaryDisplay()||H[0])}const j=F.bounds,le={width:_,height:U,x:j.x+j.width/2-_/2,y:j.y+j.height/2-U/2};return j.width>0&&j.height>0&&(le.x<j.x&&(le.x=j.x),le.y<j.y&&(le.y=j.y),le.x>j.x+j.width&&(le.x=j.x),le.y>j.y+j.height&&(le.y=j.y),le.width>j.width&&(le.width=j.width),le.height>j.height&&(le.height=j.height)),le}};e.IssueMainService=R,e.IssueMainService=R=l=be([re(1,u.IEnvironmentMainService),re(2,d.ILogService),re(3,p.IDiagnosticsService),re(4,y.IDiagnosticsMainService),re(5,E.IDialogMainService),re(6,f.INativeHostMainService),re(7,t.IProtocolMainService),re(8,a.IProductService),re(9,o.IStateService),re(10,n.IWindowsMainService)],R);function k(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(ae[300],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(K,e,I,L,r,O,M,C,g,c,v,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends w.AbstractUpdateService{constructor(y,E,u,d,f,m,a,t){super(y,E,d,f,m,t),this.telemetryService=u,this.nativeHostMainService=a}buildUpdateFeedUrl(y){return(0,w.createUpdateURL)(`linux-${process.arch}`,y,this.productService)}doCheckForUpdates(y){this.url&&(this.setState(b.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},I.CancellationToken.None).then(c.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E);const u=y?E.message||E:void 0;this.setState(b.State.Idle(1,u))}))}async doDownloadUpdate(y){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(b.State.Idle(1))}};e.LinuxUpdateService=h,e.LinuxUpdateService=h=be([re(0,O.ILifecycleMainService),re(1,L.IConfigurationService),re(2,v.ITelemetryService),re(3,r.IEnvironmentMainService),re(4,c.IRequestService),re(5,M.ILogService),re(6,C.INativeHostMainService),re(7,g.IProductService)],h)}),define(ae[301],ce([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,70,27,53,28,49,101]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(S,R=1e3){for(;!S();)await(0,O.timeout)(R)}let i;function n(){return typeof i>"u"&&(L.existsSync(c.join(c.dirname(process.execPath),"unins000.exe"))?i=0:c.basename(c.normalize(c.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let l=class extends o.AbstractUpdateService{get cachePath(){const R=c.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return w.Promises.mkdir(R,{recursive:!0}).then(()=>R)}constructor(R,k,P,D,_,U,F,H,j){super(R,k,D,_,U,j),this.telemetryService=P,this.fileService=F,this.nativeHostMainService=H,R.setRelaunchHandler(this)}handleRelaunch(R){return R?.addArgs||R?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(t.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(R){let k=`win32-${process.arch}`;switch(n()){case 1:k+="-archive";break;case 3:k+="-msi";break;default:this.productService.target==="user"?k+="-user":k+="-system"}return(0,o.createUpdateURL)(k,R,this.productService)}doCheckForUpdates(R){this.url&&(this.setState(t.State.CheckingForUpdates(R)),this.requestService.request({url:this.url},M.CancellationToken.None).then(m.asJson).then(k=>{const P=n();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!R}),this.setState(t.State.Idle(P)),Promise.resolve(null)):P===1?(this.setState(t.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(t.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(D=>w.Promises.exists(D).then(_=>{if(_)return Promise.resolve(D);const U=`${D}.tmp`;return this.requestService.request({url:k.url},M.CancellationToken.None).then(F=>this.fileService.writeFile(v.URI.file(U),F.stream)).then(k.sha256hash?()=>(0,b.checksum)(U,k.sha256hash):()=>{}).then(()=>w.Promises.rename(U,D,!1)).then(()=>D)})).then(D=>{const _=n()==0&&this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:D},_?this.productService.target==="user"?this.doApplyUpdate():this.setState(t.State.Downloaded(k)):this.setState(t.State.Ready(k))})))}).then(void 0,k=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,g.hash)(String(k)))}),this.logService.error(k);const P=R?k.message||k:void 0;this.setState(t.State.Idle(n(),P))}))}async doDownloadUpdate(R){R.update.url&&this.nativeHostMainService.openExternal(void 0,R.update.url),this.setState(t.State.Idle(n()))}async getUpdatePackagePath(R){const k=await this.cachePath;return c.join(k,`CodeSetup-${this.productService.quality}-${R}.exe`)}async cleanup(R=null){const k=R?U=>!new RegExp(`${this.productService.quality}-${R}\\.exe$`).test(U):()=>!0,P=await this.cachePath,_=(await w.Promises.readdir(P)).filter(k).map(async U=>{try{await w.Promises.unlink(c.join(P,U))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const R=this.state.update;this.setState(t.State.Updating(R));const k=await this.cachePath;this.availableUpdate.updateFilePath=c.join(k,`CodeSetup-${this.productService.quality}-${R.version}.flag`),await w.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(t.State.Idle(n()))});const D=`${this.productService.win32MutexName}-ready`,_=await new Promise((U,F)=>{K(["@vscode/windows-mutex"],U,F)});s(()=>_.isActive(D)).then(()=>this.setState(t.State.Ready(R)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,I.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(R){if(this.state.type!=="idle")return;const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),P={version:"unknown",productVersion:"unknown"};this.setState(t.State.Downloading(P)),this.availableUpdate={packagePath:R},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(t.State.Downloaded(P)):this.setState(t.State.Ready(P))}};e.Win32UpdateService=l,be([C.memoize],l.prototype,"cachePath",null),e.Win32UpdateService=l=be([re(0,E.ILifecycleMainService),re(1,h.IConfigurationService),re(2,a.ITelemetryService),re(3,p.IEnvironmentMainService),re(4,m.IRequestService),re(5,u.ILogService),re(6,y.IFileService),re(7,d.INativeHostMainService),re(8,f.IProductService)],l)}),define(ae[134],ce([0,1,14,8,23,51,3,2,13,67,4,7,190,26,65,18,56,24,64,16,20,5,27,80,252,83,28,104,69,55,29,30,58,81,39,34,57,68,22,6]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n,l,S,R,k,P,D,_,U,F,H,j,le,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var ue;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ue||(ue={}));class Y extends C.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(W){this._win=W,this._register(M.Event.fromNodeEventEmitter(W,"maximize")(()=>this._onDidMaximize.fire())),this._register(M.Event.fromNodeEventEmitter(W,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(M.Event.fromNodeEventEmitter(W,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(M.Event.fromNodeEventEmitter(W,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(M.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(M.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const N=!(0,R.hasNativeTitlebar)(this.configurationService);if(v.isMacintosh&&N&&W.setSheetOffset((0,v.isBigSurOrNewer)((0,h.release)())?28:22),N&&(v.isWindows&&(0,R.useWindowControlsOverlay)(this.configurationService)||v.isMacintosh)){const V=this.stateService.getItem(Y.windowControlHeightStateStorageKey);V&&this.updateWindowControls({height:V})}v.isWindows&&N&&W.hookWindowMessage(278,()=>{const[$,oe]=W.getPosition(),de=I.screen.getCursorScreenPoint(),G=de.x-$,A=de.y-oe;return!(G>30&&A>=0&&A<=Math.max(W.getBounds().height*.15,35))||(W.setEnabled(!1),W.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:G,y:A})),0}),this.environmentMainService.args["open-devtools"]===!0&&W.webContents.openDevTools(),v.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(W,N,V,$){super(),this.configurationService=W,this.stateService=N,this.environmentMainService=V,this.logService=$,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new M.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new M.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new M.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new M.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,R.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}setRepresentedFilename(W){v.isMacintosh?this.win?.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return v.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){v.isMacintosh&&this.win?.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return v.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(W){v.isMacintosh&&W?.force&&I.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const W=this.win;if(W)if(v.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":W.minimize();break;case"None":break;case"Maximize":default:W.isMaximized()?W.unmaximize():W.maximize()}else W.isMaximized()?W.unmaximize():W.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(W){const N=this.win;if(N){if(W.height&&this.stateService.setItem(Q.windowControlHeightStateStorageKey,W.height),v.isWindows&&this.hasWindowControlOverlay)N.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(v.isMacintosh&&W.height!==void 0){const V=(W.height-15)/2;V?N.setWindowButtonPosition({x:V,y:V}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(W,N){(0,R.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(W,N):this.setSimpleFullScreen(W)}get isFullScreen(){if(v.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const W=this.win,N=W?.isFullScreen(),V=W?.isSimpleFullScreen();return!!(N||V)}setNativeFullScreen(W,N){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W,N)}doSetNativeFullScreen(W,N){if(v.isMacintosh){this.transientIsNativeFullScreen=W;const $=this.joinNativeFullScreenTransition=new L.DeferredPromise;(async()=>{const oe=await Promise.race([$.p,(0,L.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===$&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!oe&&W&&N&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(W)}setSimpleFullScreen(W){const N=this.win;N?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),N?.setSimpleFullScreen(W),N?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=Y;let Q=class extends Y{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,P.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,N,V,$,oe,de,G,A,T,J,B,X,x,Z,z,ee,ie,fe,pe,Pe,Ce){super(J,Pe,$,N),this.loggerMainService=V,this.policyService=oe,this.userDataProfilesService=de,this.fileService=G,this.applicationStorageMainService=A,this.storageMainService=T,this.themeMainService=B,this.workspacesManagementMainService=X,this.backupMainService=x,this.telemetryService=Z,this.dialogMainService=z,this.lifecycleMainService=ee,this.productService=ie,this.protocolMainService=fe,this.windowsMainService=pe,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[We,Ee]=this.restoreWindowState(W.state);this.windowState=We,this.logService.trace("window#ctor: using window state",We);const ye=this.windowState.mode===0||this.windowState.mode===3,te=Ce.invokeFunction(k.defaultBrowserWindowOptions,this.windowState,{show:!ye,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this._win=new I.BrowserWindow(te),(0,c.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win);const he=this.configurationService.getValue("window"),me=v.isMacintosh&&he?.nativeTabs===!0;(v.isMacintosh||v.isWindows)&&Ee&&(!me||I.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(De=>typeof De=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0,!0),this._win.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function N(){V.dispose(),$.dispose(),W()}const V=this.onDidClose(()=>N()),$=this.onWillLoad(()=>N())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,V)=>this.onWindowError(2,{...V})),this._win.webContents.on("did-fail-load",(N,V,$)=>this.onWindowError(3,{reason:$,exitCode:V})),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(N=>this.onConfigurationUpdated(N))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(N,V)=>{const $=await this.getMarketplaceHeaders();V({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,$)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,N){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:N?.reason,code:N?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:$}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null),(0,w.localize)(2,null)],message:(0,w.localize)(3,null),detail:(0,w.localize)(4,null),checkboxLabel:this._config?.workspace?(0,w.localize)(5,null):void 0},this._win);if(V!==2){const oe=V===0;await this.destroyWindow(oe,$)}}else if(W===2){let V;N?V=(0,w.localize)(7,null,N.reason,N.exitCode??"<unknown>"):V=(0,w.localize)(6,null);const{response:$,checkboxChecked:oe}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,w.localize)(8,null):(0,w.localize)(9,null),(0,w.localize)(10,null)],message:V,detail:this._config?.workspace?(0,w.localize)(11,null):(0,w.localize)(12,null),checkboxLabel:this._config?.workspace?(0,w.localize)(13,null):void 0},this._win),de=$===0;await this.destroyWindow(de,oe)}break}}async destroyWindow(W,N){const V=this._config?.workspace;if(N&&V)try{const $=this.storageMainService.workspaceStorage(V);await $.init(),$.delete("memento/workbench.parts.editor"),await $.close()}catch($){this.logService.error($)}this._onDidDestroy.fire();try{if(W&&this._config){let $,oe;(0,P.isSingleFolderWorkspaceIdentifier)(V)?$={folderUri:V.uri}:(0,P.isWorkspaceIdentifier)(V)?$={workspaceUri:V.configPath}:oe=!0,(0,le.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:$?[$]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N))}if(!W||W.affectsConfiguration("http.proxy")){let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||V!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=V;const $=N||"",oe=V?`${V},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${oe}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(W){v.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,N=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!N.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,N),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:N.isReload?3:V?2:1})}updateConfiguration(W,N){const V=(this._config??this.pendingLoadConfig)?.userEnv;if(V){const $=(0,d.isLaunchedFromCli)(V)&&!(0,d.isLaunchedFromCli)(W.userEnv),oe=this.isExtensionDevelopmentHost;($||oe)&&(W.userEnv={...V,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(W["disable-extensions"]=N.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),W.zoomLevel=this.getZoomLevel(),W.isCustomZoomLevel=typeof this.customZoomLevel=="number",W.isCustomZoomLevel&&W.partsSplash&&(W.partsSplash.zoomLevel=W.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),W.perfMarks=(0,c.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const N=Object.assign({},this._config);N.workspace=await this.validateWorkspaceBeforeReload(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&W&&(N.verbose=W.verbose,N.debugId=W.debugId,N.extensionEnvironment=W.extensionEnvironment,N["inspect-extensions"]=W["inspect-extensions"],N["inspect-brk-extensions"]=W["inspect-brk-extensions"],N["extensions-dir"]=W["extensions-dir"]),N.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.policyService.serialize(),N.continueOn=this.environmentMainService.continueOn,N.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},N.logLevel=this.loggerMainService.getLogLevel(),N.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,P.isWorkspaceIdentifier)(W.workspace)){const N=W.workspace.configPath;if(N.scheme===g.Schemas.file&&!await this.fileService.exists(N))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(W.workspace)){const N=W.workspace.uri;if(N.scheme===g.Schemas.file&&!await this.fileService.exists(N))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,_.defaultWindowState)();if(this.isFullScreen){let V;try{V=I.screen.getDisplayMatching(this.getBounds())}catch{}const $=(0,_.defaultWindowState)();return{mode:3,display:V?V.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const W=Object.create(null);let N;if(!v.isMacintosh&&this._win.isMaximized()?N=0:N=1,N===0?W.mode=0:W.mode=1,N===1||N===0){let V;N===1?V=this.getBounds():V=this._win.getNormalBounds(),W.x=V.x,W.y=V.y,W.width=V.width,W.height=V.height}return W.zoomLevel=this.customZoomLevel,W}restoreWindowState(W){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(W){this.customZoomLevel=W.zoomLevel;try{const V=I.screen.getAllDisplays();N=V.length>1,W=k.WindowStateValidator.validateWindowState(this.logService,W,V)}catch(V){this.logService.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[W||(0,_.defaultWindowState)(),N]}getBounds(){const[W,N]=this._win.getPosition(),[V,$]=this._win.getSize();return{x:W,y:N,width:V,height:$}}setFullScreen(W,N){super.setFullScreen(W,N),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let W=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,N=!0){v.isMacintosh||(W==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,w.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const N=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!N),this._win.autoHideMenuBar=N;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(W){this.customZoomLevel=W}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(W,N,...V){this.isReady?this.send(W,...V):this.ready().then(()=>{N.isCancellationRequested||this.send(W,...V)})}send(W,...N){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...N)}catch(V){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,O.toErrorMessage)(V)}`)}}}updateTouchBar(W){v.isMacintosh&&this.touchBarGroups.forEach((N,V)=>{const $=W[V];N.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(v.isMacintosh){for(let W=0;W<10;W++){const N=this.createTouchBarGroup();this.touchBarGroups.push(N)}this._win.setTouchBar(new I.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const N=this.createTouchBarGroupSegments(W),V=new I.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:V.segments[$].id,from:"touchbar"})}});return V}createTouchBarGroupSegments(W=[]){return W.map(V=>{let $;V.icon&&!l.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===g.Schemas.file&&($=I.nativeImage.createFromPath(b.URI.revive(V.icon.dark).fsPath),$.isEmpty()&&($=void 0));let oe;return typeof V.title=="string"?oe=V.title:oe=V.title.value,{id:V.id,label:$?void 0:oe,icon:$}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=Q,e.CodeWindow=Q=be([re(1,a.ILogService),re(2,j.ILoggerMainService),re(3,u.IEnvironmentMainService),re(4,U.IPolicyService),re(5,H.IUserDataProfilesMainService),re(6,f.IFileService),re(7,i.IApplicationStorageMainService),re(8,i.IStorageMainService),re(9,y.IConfigurationService),re(10,S.IThemeMainService),re(11,D.IWorkspacesManagementMainService),re(12,p.IBackupMainService),re(13,n.ITelemetryService),re(14,E.IDialogMainService),re(15,m.ILifecycleMainService),re(16,t.IProductService),re(17,o.IProtocolMainService),re(18,k.IWindowsMainService),re(19,F.IStateService),re(20,se.IInstantiationService)],Q)}),define(ae[302],ce([0,1,14,4,18,24,20,5,34,55,134]),function(K,e,I,L,r,O,M,C,g,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let b=class extends v.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,p,y,E,u,d){super(E,u,p,y),this.contents=h,this.lifecycleMainService=d,this.id=this.contents.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this._win||this._store.isDisposed||this.contents.isDestroyed())return;const h=I.BrowserWindow.fromWebContents(this.contents);h&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(h),h.setMenu(null),(L.isWindows||L.isLinux)&&(0,c.hasNativeTitlebar)(this.configurationService)&&h.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}};e.AuxiliaryWindow=b,e.AuxiliaryWindow=b=be([re(1,O.IEnvironmentMainService),re(2,C.ILogService),re(3,r.IConfigurationService),re(4,g.IStateService),re(5,M.ILifecycleMainService)],b)}),define(ae[303],ce([0,1,14,3,2,13,37,302,6,5,81,29]),function(K,e,I,L,r,O,M,C,g,c,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let w=class extends r.Disposable{constructor(p,y){super(),this.instantiationService=p,this.logService=y,this._onDidMaximizeWindow=this._register(new L.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new L.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new L.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new L.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){I.app.on("browser-window-created",(p,y)=>{const E=this.getWindowById(y.id);E&&(this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),E.tryClaimWindow())}),M.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(p,y)=>{const E=this.getWindowById(p.sender.id);return E&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),E.parentId=y),p.sender.id})}createWindow(p){return this.instantiationService.invokeFunction(b.defaultBrowserWindowOptions,this.validateWindowState(p),{webPreferences:{preload:O.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}validateWindowState(p){const y={},E=p.features.split(",");for(const d of E){const[f,m]=d.split("=");switch(f){case"width":y.width=parseInt(m,10);break;case"height":y.height=parseInt(m,10);break;case"left":y.x=parseInt(m,10);break;case"top":y.y=parseInt(m,10);break}}const u=b.WindowStateValidator.validateWindowState(this.logService,y)??(0,v.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",u),u}registerWindow(p){const y=new r.DisposableStore,E=this.instantiationService.createInstance(C.AuxiliaryWindow,p);this.windows.set(E.id,E),y.add((0,r.toDisposable)(()=>this.windows.delete(E.id))),y.add(E.onDidMaximize(()=>this._onDidMaximizeWindow.fire(E))),y.add(E.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(E))),y.add(E.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!0}))),y.add(E.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:E,fullscreen:!1}))),y.add(E.onDidTriggerSystemContextMenu(({x:u,y:d})=>this._onDidTriggerSystemContextMenu.fire({window:E,x:u,y:d}))),L.Event.once(E.onDidClose)(()=>y.dispose())}getWindowById(p){return this.windows.get(p)}getFocusedWindow(){const p=I.BrowserWindow.getFocusedWindow();if(p)return this.getWindowById(p.id)}getLastActiveWindow(){return(0,b.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=w,e.AuxiliaryWindowsMainService=w=be([re(0,g.IInstantiationService),re(1,c.ILogService)],w)}),define(ae[84],ce([0,1,14,22,8,3,47,2,13,4,19,7,21,193,6,20,5,83,98,30,58,31,56]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,p.createDecorator)("workspacesHistoryMainService");let s=class extends C.Disposable{static{o=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(n,l,S,R,k){super(),this.logService=n,this.workspacesManagementMainService=l,this.lifecycleMainService=S,this.applicationStorageMainService=R,this.dialogMainService=k,this._onDidChangeRecentlyOpened=this._register(new O.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let l=[],S=[];for(const k of n)if((0,d.isRecentWorkspace)(k))!this.workspacesManagementMainService.isUntitledWorkspace(k.workspace)&&!this.containsWorkspace(l,k.workspace)&&l.push(k);else if((0,d.isRecentFolder)(k))this.containsFolder(l,k.folderUri)||l.push(k);else{const P=this.containsFile(S,k.fileUri),D=k.fileUri.scheme===g.Schemas.file&&o.COMMON_FILES_FILTER.indexOf((0,v.basename)(k.fileUri))>=0;!P&&!D&&(S.push(k),c.isWindows&&k.fileUri.scheme===g.Schemas.file&&I.app.addRecentDocument(k.fileUri.fsPath))}const R=await this.mergeEntriesFromStorage({workspaces:l,files:S});l=R.workspaces,S=R.files,l.length>o.MAX_TOTAL_RECENT_ENTRIES&&(l.length=o.MAX_TOTAL_RECENT_ENTRIES),S.length>o.MAX_TOTAL_RECENT_ENTRIES&&(S.length=o.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:l,files:S}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const l=P=>{const D=this.location(P);for(const _ of n)if(v.extUriBiasedIgnorePathCase.isEqual(_,D))return!1;return!0},S=await this.getRecentlyOpened(),R=S.workspaces.filter(l),k=S.files.filter(l);(R.length!==S.workspaces.length||k.length!==S.files.length)&&(await this.saveRecentlyOpened({files:k,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),c.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:l}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null)],message:(0,h.localize)(2,null),detail:(0,h.localize)(3,null),cancelId:1});if(l!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const l=new a.ResourceMap(k=>v.extUriBiasedIgnorePathCase.getComparisonKey(k));if(n?.workspaces)for(const k of n.workspaces)l.set(this.location(k),k);const S=new a.ResourceMap(k=>v.extUriBiasedIgnorePathCase.getComparisonKey(k));if(n?.files)for(const k of n.files)S.set(this.location(k),k);const R=await this.getRecentlyOpenedFromStorage();for(const k of R.workspaces){const P=l.get(this.location(k));P?P.label=P.label??k.label:l.set(this.location(k),k)}for(const k of R.files){const P=S.get(this.location(k));P?P.label=P.label??k.label:S.set(this.location(k),k)}return{workspaces:[...l.values()],files:[...S.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const l=this.applicationStorageMainService.get(o.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof l=="string")try{n=JSON.parse(l)}catch(S){this.logService.error("Unexpected error parsing opened paths list",S)}return(0,d.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(o.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(n)),-1,1)}location(n){return(0,d.isRecentFolder)(n)?n.folderUri:(0,d.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,l){return!!n.find(S=>(0,d.isRecentWorkspace)(S)&&S.workspace.id===l.id)}containsFolder(n,l){return!!n.find(S=>(0,d.isRecentFolder)(S)&&v.extUriBiasedIgnorePathCase.isEqual(S.folderUri,l))}containsFile(n,l){return!!n.find(S=>v.extUriBiasedIgnorePathCase.isEqual(S.fileUri,l))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){c.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!c.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(4,null),description:(0,h.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const k of I.app.getJumpListSettings().removedItems){const P=k.args;if(P){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(P);D&&l.push(b.URI.parse(D[2]))}}await this.removeRecentlyOpened(l);let S=!1;const R=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,o.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(k=>{const P=(0,d.isRecentWorkspace)(k)?k.workspace:k.folderUri,{title:D,description:_}=this.getWindowsJumpListLabel(P,k.label);let U;return b.URI.isUri(P)?U=`--folder-uri "${P.toString()}"`:(S=!0,U=`--file-uri "${P.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:_.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&n.push({type:"custom",name:S?(0,h.localize)(6,null):(0,h.localize)(7,null),items:R})}n.push({type:"recent"});try{const l=I.app.setJumpList(n);l&&l!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.logService.warn("updateWindowsJumpList#setJumpList",l)}}getWindowsJumpListLabel(n,l){if(l)return{title:(0,M.splitRecentLabel)(l).name,description:l};if(b.URI.isUri(n))return{title:(0,v.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,h.localize)(8,null),description:""};let S=(0,v.basename)(n.configPath);return S.endsWith(f.WORKSPACE_EXTENSION)&&(S=S.substr(0,S.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(9,null,S),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,M.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!c.isMacintosh)return;I.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),l=[];let S=0;for(let k=0;k<n.workspaces.length&&S<o.MAX_MACOS_DOCK_RECENT_WORKSPACES;k++){const P=this.location(n.workspaces[k]);if(P.scheme===g.Schemas.file){const D=(0,v.originalFSPath)(P);await w.Promises.exists(D)&&(l.push(D),S++)}}const R=[];for(let k=0;k<n.files.length&&S<o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;k++){const P=this.location(n.files[k]);if(P.scheme===g.Schemas.file){const D=(0,v.originalFSPath)(P);if(o.COMMON_FILES_FILTER.includes((0,v.basename)(P))||l.includes(D))continue;await w.Promises.exists(D)&&(R.push(D),S++)}}R.reverse().forEach(k=>I.app.addRecentDocument(k)),l.reverse().forEach(k=>I.app.addRecentDocument(k))}};e.WorkspacesHistoryMainService=s,e.WorkspacesHistoryMainService=s=o=be([re(0,E.ILogService),re(1,m.IWorkspacesManagementMainService),re(2,y.ILifecycleMainService),re(3,u.IApplicationStorageMainService),re(4,t.IDialogMainService)],s)}),define(ae[304],ce([0,1,14,8,23,47,4,7,181,78,18,24,20,5,231,70,27,34,28,49,55,29,84]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let i=class{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(S,R,k,P,D,_,U,F,H,j,le,se){this.updateService=S,this.configurationService=R,this.windowsMainService=k,this.environmentMainService=P,this.telemetryService=D,this.workspacesHistoryMainService=_,this.stateService=U,this.lifecycleMainService=F,this.logService=H,this.nativeHostMainService=j,this.productService=le,this.auxiliaryWindowsMainService=se,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,m.hasNativeTitlebar)(R))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const S=this.stateService.getItem(o.lastKnownMenubarStorageKey);S&&(S.menus&&(this.menubarMenus=S.menus),S.keybindings&&(this.keybindings=S.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,U,F)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,U,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,U,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(_,U,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,U,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const S=this.productService.youTubeUrl;S&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(S,"openYouTubeUrl"));const R=this.productService.requestFeatureUrl;R&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(R,"openUserVoiceUrl"));const k=this.productService.reportIssueUrl;k&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(k,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const _=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${_}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(S=>this.onDidChangeWindowsCount(S)),this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const S=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof S!="boolean"?!0:S}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const S=this.configurationService.getValue("window.nativeTabs");return typeof S!="boolean"?!1:S}updateMenu(S,R){this.menubarMenus=S.menus,this.keybindings=S.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,S),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(S){M.isMacintosh&&(S.oldCount===0&&S.newCount>0||S.oldCount>0&&S.newCount===0)&&(this.closedLastWindow=S.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!M.isMacintosh)return;const S=I.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!S||!!this.auxiliaryWindowsMainService.getWindowById(S.id),this.scheduleUpdateMenu()}install(){const S=I.Menu.getApplicationMenu();if(S&&this.oldMenus.push(S),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(M.isMacintosh?new I.Menu:null);return}const R=new I.Menu;let k;if(M.isMacintosh){const D=new I.Menu;k=new I.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),R.append(k)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new I.Menu;D.append(new I.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),I.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:D});this.setMenuById(D,"File"),R.append(_)}if(this.shouldDrawMenu("Edit")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),R.append(_)}if(this.shouldDrawMenu("Selection")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),R.append(_)}if(this.shouldDrawMenu("View")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:D});this.setMenuById(D,"View"),R.append(_)}if(this.shouldDrawMenu("Go")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),R.append(_)}if(this.shouldDrawMenu("Run")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),R.append(_)}if(this.shouldDrawMenu("Terminal")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),R.append(_)}let P;if(this.shouldDrawMenu("Window")){const D=new I.Menu;P=new I.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(P&&R.append(P),this.shouldDrawMenu("Help")){const D=new I.Menu,_=new I.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),R.append(_)}R.items&&R.items.length>0?this.doSetApplicationMenu(R):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(S){if(I.Menu.setApplicationMenu(S),S)for(const R of this.auxiliaryWindowsMainService.getWindows())R.win?.setMenu(null)}setMacApplicationMenu(S){const R=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),k=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const se=new I.Menu;this.setMenuById(se,"Preferences"),P=new I.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:se})}const D=new I.Menu,_=new I.MenuItem({label:g.localize(12,null),role:"services",submenu:D}),U=new I.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new I.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),H=new I.MenuItem({label:g.localize(15,null),role:"unhide"}),j=new I.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:async(se,ue,Y)=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||I.BrowserWindow.getFocusedWindow()||Q?.win?.isMinimized())&&await this.confirmBeforeQuit(Y)&&this.nativeHostMainService.quit(void 0)}})),le=[R];le.push(...k),P&&le.push(n(),P),le.push(n(),_,n(),U,F,H,n(),j),le.forEach(se=>S.append(se))}async confirmBeforeQuit(S){if(this.windowsMainService.getWindowCount()===0)return!0;const R=this.configurationService.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.isKeyboardEvent(S)){const{response:k}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return k===0}return!0}shouldDrawMenu(S){if(!M.isMacintosh&&!(0,m.hasNativeTitlebar)(this.configurationService))return!1;switch(S){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[S];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[S]}}setMenu(S,R){R.forEach(k=>{if((0,p.isMenubarMenuItemSeparator)(k))S.append(n());else if((0,p.isMenubarMenuItemSubmenu)(k)){const P=new I.Menu,D=new I.MenuItem({label:this.mnemonicLabel(k.label),submenu:P});this.setMenu(P,k.submenu.items),S.append(D)}else(0,p.isMenubarMenuItemRecentAction)(k)?S.append(this.createOpenRecentMenuItem(k)):(0,p.isMenubarMenuItemAction)(k)&&(k.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(S),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[k.id]?S.append(new I.MenuItem(this.likeAction(k.id,{label:this.mnemonicLabel(k.label),click:this.fallbackMenuHandlers[k.id]}))):S.append(this.createMenuItem(k.label,k.id,!1,k.checked)):S.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)):S.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)))})}setMenuById(S,R){this.menubarMenus&&this.menubarMenus[R]&&this.setMenu(S,this.menubarMenus[R].items)}insertCheckForUpdatesItems(S){const R=this.getUpdateMenuItems();R.length&&(R.forEach(k=>S.append(k)),S.append(n()))}createOpenRecentMenuItem(S){const R=C.URI.revive(S.uri),k=S.id,P=k==="openRecentFile"?{fileUri:R}:k==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new I.MenuItem(this.likeAction(k,{label:S.label,click:async(D,_,U)=>{const F=this.isOptionClick(U);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:S.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([R])}},!1))}isOptionClick(S){return!!(S&&(!M.isMacintosh&&(S.ctrlKey||S.shiftKey)||M.isMacintosh&&(S.metaKey||S.altKey)))}isKeyboardEvent(S){return!!(S.triggeredByAccelerator||S.altKey||S.ctrlKey||S.metaKey||S.shiftKey)}createRoleMenuItem(S,R,k){const P={label:this.mnemonicLabel(S),role:k,enabled:!0};return new I.MenuItem(this.withKeybinding(R,P))}setMacWindowMenu(S){const R=new I.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),k=new I.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new I.MenuItem({label:g.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(g.localize(23,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(n()),_.push(this.createMenuItem(g.localize(24,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,k,n(),D,..._,n(),P].forEach(U=>S.append(U))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new I.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.mnemonicLabel(g.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(S,R,k,P){const D=this.mnemonicLabel(S),_=typeof R=="function"?R:(le,se,ue)=>{const Y=le?le.userSettingsLabel:null;let Q=R;Array.isArray(R)&&(Q=this.isOptionClick(ue)?R[1]:R[0]),Y&&ue.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:Y}):this.runActionInRenderer({type:"commandId",commandId:Q})},U=typeof k=="boolean"?k:this.windowsMainService.getWindowCount()>0,F=typeof P=="boolean"?P:!1,H={label:D,click:_,enabled:U};F&&(H.type="checkbox",H.checked=F);let j;return typeof R=="string"?j=R:Array.isArray(R)&&(j=R[0]),M.isMacintosh&&(j==="editor.action.clipboardCutAction"?H.role="cut":j==="editor.action.clipboardCopyAction"?H.role="copy":j==="editor.action.clipboardPasteAction"&&(H.role="paste"),j==="undo"?H.click=this.makeContextAwareClickHandler(_,{inDevTools:le=>le.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):j==="redo"?H.click=this.makeContextAwareClickHandler(_,{inDevTools:le=>le.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):j==="editor.action.selectAll"&&(H.click=this.makeContextAwareClickHandler(_,{inDevTools:le=>le.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.withKeybinding(j,H))}makeContextAwareClickHandler(S,R){return(k,P,D)=>{const _=I.BrowserWindow.getFocusedWindow();if(!_)return R.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return R.inDevTools(_.webContents.devToolsWebContents);S(k,P||_,D)}}runActionInRenderer(S){let R=I.BrowserWindow.getFocusedWindow();if(R){const P=this.auxiliaryWindowsMainService.getWindowById(R.id);P&&(R=this.windowsMainService.getWindowById(P.parentId)?.win??null)}if(!R){const P=this.windowsMainService.getLastActiveWindow();P?.win?.isMinimized()&&(R=P.win)}const k=R?this.windowsMainService.getWindowById(R.id):void 0;if(k){if(this.logService.trace("menubar#runActionInRenderer",S),M.isMacintosh&&!this.environmentMainService.isBuilt&&!k.isReady&&(S.type==="commandId"&&S.commandId==="workbench.action.toggleDevTools"||S.type!=="commandId"&&S.userSettingsLabel==="alt+cmd+i"))return!1;if(S.type==="commandId"){const P={id:S.commandId,from:"menu"};k.sendWhenReady("vscode:runAction",r.CancellationToken.None,P)}else{const P={userSettingsLabel:S.userSettingsLabel};k.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,P)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",S),!1}withKeybinding(S,R){const k=typeof S=="string"?this.keybindings[S]:void 0;if(k?.label){if(k.isNative!==!1)R.accelerator=k.label,R.userSettingsLabel=k.userSettingsLabel;else if(typeof R.label=="string"){const P=R.label.indexOf("[");P>=0?R.label=`${R.label.substr(0,P)} [${k.label}]`:R.label=`${R.label} [${k.label}]`}}else R.accelerator=void 0;return R}likeAction(S,R,k=!R.accelerator){k&&(R=this.withKeybinding(S,R));const P=R.click;return R.click=(D,_,U)=>{this.reportMenuActionTelemetry(S),P?.(D,_,U)},R}openUrl(S,R){this.nativeHostMainService.openExternal(void 0,S),this.reportMenuActionTelemetry(R)}reportMenuActionTelemetry(S){this.telemetryService.publicLog2("workbenchActionExecuted",{id:S,from:s})}mnemonicLabel(S){return(0,O.mnemonicMenuLabel)(S,!this.currentEnableMenuBarMnemonics)}};e.Menubar=i,e.Menubar=i=o=be([re(0,f.IUpdateService),re(1,v.IConfigurationService),re(2,a.IWindowsMainService),re(3,b.IEnvironmentMainService),re(4,d.ITelemetryService),re(5,t.IWorkspacesHistoryMainService),re(6,u.IStateService),re(7,w.ILifecycleMainService),re(8,h.ILogService),re(9,y.INativeHostMainService),re(10,E.IProductService),re(11,c.IAuxiliaryWindowsMainService)],i);function n(){return new I.MenuItem({type:"separator"})}}),define(ae[305],ce([0,1,6,20,5,304]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let M=class{constructor(g,c,v){this.instantiationService=g,this.lifecycleMainService=c,this.logService=v,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(O.Menubar)}async updateMenubar(g,c){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(c,g)}};e.MenubarMainService=M,e.MenubarMainService=M=be([re(0,I.IInstantiationService),re(1,L.ILifecycleMainService),re(2,r.ILogService)],M)}),define(ae[306],ce([0,1,14,21,132,26,22,23,3,33,47,2,13,9,67,4,36,19,12,7,191,65,18,56,24,16,6,20,5,79,80,60,34,55,134,29,131,298,30,99,84,58,69,39,57,68,78]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n,l,S,R,k,P,D,_,U,F,H,j,le,se,ue,Y,Q,q,W,N,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(G){return(0,le.isWorkspaceIdentifier)(G?.workspace)}function oe(G){return(0,le.isSingleFolderWorkspaceIdentifier)(G?.workspace)}let de=class extends b.Disposable{constructor(A,T,J,B,X,x,Z,z,ee,ie,fe,pe,Pe,Ce,We,Ee,ye,te,he,me){super(),this.machineId=A,this.sqmId=T,this.initialUserEnv=J,this.logService=B,this.loggerService=X,this.stateService=x,this.policyService=Z,this.environmentMainService=z,this.userDataProfilesMainService=ee,this.lifecycleMainService=ie,this.backupMainService=fe,this.configurationService=pe,this.workspacesHistoryMainService=Pe,this.workspacesManagementMainService=Ce,this.instantiationService=We,this.dialogMainService=Ee,this.fileService=ye,this.protocolMainService=te,this.themeMainService=he,this.auxiliaryWindowsMainService=me,this._onDidOpenWindow=this._register(new g.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new g.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new g.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new g.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new g.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new g.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new g.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new g.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new j.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const T=new b.DisposableStore;if(T.add(g.Event.any(A.onDidClose,A.onDidDestroy)(()=>T.dispose())),A.config.extensionDevelopmentPath)for(const J of A.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(J));A.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,T){const J=this.environmentMainService.args,B=T?.remoteAuthority||void 0,X=!0,x=T?.forceReuseWindow,Z=!x;return this.open({...A,cli:J,forceEmpty:X,forceNewWindow:Z,forceReuseWindow:x,remoteAuthority:B})}openExistingWindow(A,T){A.focus(),this.handleWaitMarkerFile(T,[A])}async open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const T=[],J=[],B=[],X=[],x=[];let Z,z=0;const ee=await this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ee);for(const Ce of ee)oe(Ce)?A.addMode?T.push(Ce):J.push(Ce):$(Ce)?B.push(Ce):Ce.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),Z.filesToOpenOrCreate.push(Ce)):Ce.backupPath?x.push({backupFolder:(0,h.basename)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):z++;A.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),A.mergeMode&&Z&&Z.filesToOpenOrCreate.length===4&&(Z.filesToMerge=Z.filesToOpenOrCreate.slice(0,4),Z.filesToOpenOrCreate=[],Z.filesToDiff=[]),Z&&A.waitMarkerFileURI&&(Z.filesToWait={paths:(0,M.coalesce)([...Z.filesToDiff,Z.filesToMerge[3],...Z.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(X.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),B.push(...X),x.push(...this.backupMainService.getEmptyWindowBackups())):x.length=0;const{windows:ie,filesOpenedInWindow:fe}=await this.doOpen(A,B,J,x,z,Z,T);if(this.logService.trace(`windowsManager#open used window count ${ie.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${J.length}, emptyToRestore: ${x.length}, emptyToOpen: ${z})`),ie.length>1)if(fe)fe.focus();else{const Ce=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let We=!0,Ee=!0;if(Ce){const ye=ie.filter(te=>this.windowsStateHandler.state.lastActiveWindow&&te.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),We=!1,Ee=!1)}if(We)for(let ye=ie.length-1;ye>=0;ye--){const te=ie[ye];if(!(te.openedWorkspace&&X.some(he=>te.openedWorkspace&&he.workspace.id===te.openedWorkspace.id)||te.backupPath&&x.some(he=>te.backupPath&&he.backupFolder===(0,h.basename)(te.backupPath)))){te.focus(),Ee=!1;break}}Ee&&ie[ie.length-1].focus()}const pe=Z&&Z.filesToDiff.length>0,Pe=Z&&Z.filesToMerge.length>0;if(!ie.some(Ce=>Ce.isExtensionDevelopmentHost)&&!pe&&!Pe&&!A.noRecentEntry){const Ce=[];for(const We of ee)$(We)&&!We.transient?Ce.push({label:We.label,workspace:We.workspace,remoteAuthority:We.remoteAuthority}):oe(We)?Ce.push({label:We.label,folderUri:We.workspace.uri,remoteAuthority:We.remoteAuthority}):We.fileUri&&Ce.push({label:We.label,fileUri:We.fileUri,remoteAuthority:We.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ce)}return this.handleWaitMarkerFile(A,ie),ie}handleWaitMarkerFile(A,T){const J=A.waitMarkerFileURI;A.context===0&&J&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.fileService.del(J)}catch{}})()}async doOpen(A,T,J,B,X,x,Z){const z=[];let ee;function ie(ye,te){z.push(ye),te&&(ee=ye,x=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:pe}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Z.length>0){const ye=Z[0].remoteAuthority,te=this.getLastActiveWindowForAuthority(ye);te&&ie(this.doAddFoldersToExistingWindow(te,Z.map(he=>he.workspace.uri)))}const Pe=J.length+T.length+B.length;if(x&&Pe===0){const ye=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],te=this.getWindows().filter(me=>x&&(0,u.isEqualAuthority)(me.remoteAuthority,x.remoteAuthority));let he;ye?.fileUri&&!pe&&((A.context===4||A.context===0||A.context===1)&&(he=await(0,H.findWindowOnFile)(te,ye.fileUri,async me=>me.configPath.scheme===w.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(me.configPath):void 0)),he||(he=this.doGetLastActiveWindow(te))),he?(0,le.isWorkspaceIdentifier)(he.openedWorkspace)?T.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):(0,le.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)?J.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):ie(this.doOpenFilesInExistingWindow(A,he,x),!0):ie(await this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Ce=(0,M.distinct)(T,ye=>ye.workspace.id);if(Ce.length>0){const ye=(0,M.coalesce)(Ce.map(te=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),te.workspace.configPath)));if(ye.length>0){const te=ye[0],he=(0,u.isEqualAuthority)(x?.remoteAuthority,te.remoteAuthority)?x:void 0;ie(this.doOpenFilesInExistingWindow(A,te,he),!!he),fe=!0}for(const te of Ce){if(ye.some(De=>De.openedWorkspace&&De.openedWorkspace.id===te.workspace.id))continue;const he=te.remoteAuthority,me=(0,u.isEqualAuthority)(x?.remoteAuthority,he)?x:void 0;ie(await this.doOpenFolderOrWorkspace(A,te,fe,me),!!me),fe=!0}}const We=(0,M.distinct)(J,ye=>u.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(We.length>0){const ye=(0,M.coalesce)(We.map(te=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),te.workspace.uri)));if(ye.length>0){const te=ye[0],he=(0,u.isEqualAuthority)(x?.remoteAuthority,te.remoteAuthority)?x:void 0;ie(this.doOpenFilesInExistingWindow(A,te,he),!!he),fe=!0}for(const te of We){if(ye.some(De=>(0,le.isSingleFolderWorkspaceIdentifier)(De.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(De.openedWorkspace.uri,te.workspace.uri)))continue;const he=te.remoteAuthority,me=(0,u.isEqualAuthority)(x?.remoteAuthority,he)?x:void 0;ie(await this.doOpenFolderOrWorkspace(A,te,fe,me),!!me),fe=!0}}const Ee=(0,M.distinct)(B,ye=>ye.backupFolder);if(Ee.length>0)for(const ye of Ee){const te=ye.remoteAuthority,he=(0,u.isEqualAuthority)(x?.remoteAuthority,te)?x:void 0;ie(await this.doOpenEmpty(A,!0,te,he,ye),!!he),fe=!0}if(z.length===0||x){x&&!X&&X++;const ye=x?x.remoteAuthority:A.remoteAuthority;for(let te=0;te<X;te++)ie(await this.doOpenEmpty(A,fe,ye,x),!!x),fe=!0}return{windows:(0,M.distinct)(z),filesOpenedInWindow:ee}}doOpenFilesInExistingWindow(A,T,J){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:J}),this.focusMainOrChildWindow(T);const B={filesToOpenOrCreate:J?.filesToOpenOrCreate,filesToDiff:J?.filesToDiff,filesToMerge:J?.filesToMerge,filesToWait:J?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",C.CancellationToken.None,B),T}focusMainOrChildWindow(A){let T=A;const J=I.BrowserWindow.getFocusedWindow();if(J&&J.id!==A.id){const B=this.auxiliaryWindowsMainService.getWindowById(J.id);B&&B.parentId===A.id&&(T=B)}T.focus()}doAddFoldersToExistingWindow(A,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),A.focus();const J={foldersToAdd:T};return A.sendWhenReady("vscode:addFolders",C.CancellationToken.None,J),A}doOpenEmpty(A,T,J,B,X){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:J,filesToOpen:B,forceNewWindow:T});let x;return!T&&typeof A.contextWindowId=="number"&&(x=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:J,forceNewWindow:T,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:B,windowToUse:x,emptyWindowBackupInfo:X,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}doOpenFolderOrWorkspace(A,T,J,B,X){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:B}),!J&&!X&&typeof A.contextWindowId=="number"&&(X=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:J,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:B,windowToUse:X,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async getPathsToOpen(A){let T,J=!1,B=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(T=await this.doExtractPathsFromAPI(A),J=!0):A.forceEmpty?T=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(T=await this.doExtractPathsFromCLI(A.cli),T.length===0&&T.push(Object.create(null)),J=!0):(T=await this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),B=!0),!A.addMode&&J){const X=T.filter(x=>oe(x));if(X.length>1){const x=X[0].remoteAuthority;if(X.every(Z=>(0,u.isEqualAuthority)(Z.remoteAuthority,x))){const Z=await this.workspacesManagementMainService.createUntitledWorkspace(X.map(z=>({uri:z.workspace.uri})));T.push({workspace:Z,remoteAuthority:x}),T=T.filter(z=>!oe(z))}}}if(A.initialStartup&&!B&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const X=await this.doGetPathsFromLastSession();T.unshift(...X.filter(x=>$(x)||oe(x)||x.backupPath))}return T}async doExtractPathsFromAPI(A){const T={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},J=await Promise.all((0,M.coalesce)(A.urisToOpen||[]).map(async B=>{const X=await this.resolveOpenable(B,T);if(X)return X.label=B.label,X;const x=this.resourceFromOpenable(B);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:x.scheme===w.Schemas.file?(0,m.localize)(1,null):(0,m.localize)(2,null),detail:x.scheme===w.Schemas.file?(0,m.localize)(3,null,(0,v.getPathLabel)(x,{os:y.OS,tildify:this.environmentMainService})):(0,m.localize)(4,null,x.toString(!0))},I.BrowserWindow.getFocusedWindow()??void 0)}));return(0,M.coalesce)(J)}async doExtractPathsFromCLI(A){const T=[],J={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},B=A["folder-uri"];if(B){const Z=await Promise.all(B.map(z=>{const ee=this.cliArgToUri(z);if(ee)return this.resolveOpenable({folderUri:ee},J)}));T.push(...(0,M.coalesce)(Z))}const X=A["file-uri"];if(X){const Z=await Promise.all(X.map(z=>{const ee=this.cliArgToUri(z);if(ee)return this.resolveOpenable((0,le.hasWorkspaceFileExtension)(z)?{workspaceUri:ee}:{fileUri:ee},J)}));T.push(...(0,M.coalesce)(Z))}const x=await Promise.all(A._.map(Z=>J.remoteAuthority?this.doResolveRemotePath(Z,J):this.doResolveFilePath(Z,J)));return T.push(...(0,M.coalesce)(x)),T}cliArgToUri(A){try{const T=f.URI.parse(A);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return T.path?T:T.with({path:"/"})}catch(T){this.logService.error(`Invalid URI input string: ${A}, ${T.message}`)}}async doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const T=[];A!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const J=await Promise.all(T.map(async B=>{if(B.workspace){const X=await this.resolveOpenable({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if($(X))return X}else if(B.folderUri){const X=await this.resolveOpenable({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(oe(X))return X}else if(A!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,M.coalesce)(J)}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async resolveOpenable(A,T=Object.create(null)){const J=this.resourceFromOpenable(A);return J.scheme===w.Schemas.file?((0,_.isFileToOpen)(A)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(J.fsPath,T)):this.doResolveRemoteOpenable(A,T)}doResolveRemoteOpenable(A,T){let J=this.resourceFromOpenable(A);const B=(0,P.getRemoteAuthority)(J)||T.remoteAuthority;if(J=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(J)),(0,_.isFileToOpen)(A)){if(T.gotoLineMode){const{path:X,line:x,column:Z}=(0,c.parseLineAndColumnAware)(J.path);return{fileUri:J.with({path:X}),options:{selection:x?{startLineNumber:x,startColumn:Z||1}:void 0},remoteAuthority:B}}return{fileUri:J,remoteAuthority:B}}else if((0,_.isWorkspaceToOpen)(A))return{workspace:(0,se.getWorkspaceIdentifier)(J),remoteAuthority:B};return{workspace:(0,se.getSingleFolderWorkspaceIdentifier)(J),remoteAuthority:B}}resourceFromOpenable(A){return(0,_.isWorkspaceToOpen)(A)?A.workspaceUri:(0,_.isFolderToOpen)(A)?A.folderUri:A.fileUri}async doResolveFilePath(A,T,J){let B,X;T.gotoLineMode&&({path:A,line:B,column:X}=(0,c.parseLineAndColumnAware)(A)),A=(0,c.sanitizeFilePath)((0,h.normalize)(A),(0,E.cwd)());try{const x=await L.Promises.stat(A);if(x.isFile()){if(!T.forceOpenWorkspaceAsFile){const Z=await this.workspacesManagementMainService.resolveLocalWorkspace(f.URI.file(A));if(Z)return Z.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:Z.id,configPath:Z.configPath},type:i.FileType.File,exists:!0,remoteAuthority:Z.remoteAuthority,transient:Z.transient}}return{fileUri:f.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:X||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,se.getSingleFolderWorkspaceIdentifier)(f.URI.file(A),x),type:i.FileType.Directory,exists:!0};if(!y.isWindows&&A==="/dev/null")return{fileUri:f.URI.file(A),type:i.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!J)return this.onUNCHostNotAllowed(A,T);const Z=f.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([Z]),T.ignoreFileNotFound)return{fileUri:Z,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(A,T){const J=f.URI.file(A),{response:B,checkboxChecked:X}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],message:(0,m.localize)(8,null,J.authority),detail:(0,m.localize)(9,null,(0,v.getPathLabel)(J,{os:y.OS,tildify:this.environmentMainService})),checkboxLabel:(0,m.localize)(10,null,J.authority),cancelId:1});if(B===0){if((0,r.addUNCHostToAllowlist)(J.authority),X){const x={channel:"vscode:configureAllowedUNCHost",args:J.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.doResolveFilePath(A,T,!0)}if(B===2)return I.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(A,T)}doResolveRemotePath(A,T){const J=A.charCodeAt(0),B=T.remoteAuthority;let X,x;T.gotoLineMode&&({path:A,line:X,column:x}=(0,c.parseLineAndColumnAware)(A)),J!==47&&((0,c.isWindowsDriveLetter)(J)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,c.toSlashes)(A)),A=`/${A}`);const Z=f.URI.from({scheme:w.Schemas.vscodeRemote,authority:B,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,le.hasWorkspaceFileExtension)(A))return T.forceOpenWorkspaceAsFile?{fileUri:Z,options:{selection:X?{startLineNumber:X,startColumn:x||1}:void 0},remoteAuthority:T.remoteAuthority}:{workspace:(0,se.getWorkspaceIdentifier)(Z),remoteAuthority:B};if(T.gotoLineMode||h.posix.basename(A).indexOf(".")!==-1)return{fileUri:Z,options:{selection:X?{startLineNumber:X,startColumn:x||1}:void 0},remoteAuthority:B}}return{workspace:(0,se.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:B}}shouldOpenNewWindow(A){const T=this.configurationService.getValue("window"),J=T?.openFoldersInNewWindow||"default",B=T?.openFilesInNewWindow||"off";let X=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(J==="on"||J==="off")&&(X=J==="on");let x=!1;return A.forceNewWindow||A.forceReuseWindow?x=!!A.forceNewWindow&&!A.forceReuseWindow:(y.isMacintosh?A.context===1&&(x=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!A.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(x=B==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(A,T){const J=(0,H.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(J)return this.lifecycleMainService.reload(J,T.cli),J.focus(),[J];let B=T.cli["folder-uri"]||[],X=T.cli["file-uri"]||[],x=T.cli._;if(!x.length&&!B.length&&!X.length&&!T.cli.extensionTestsPath){const ee=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=ee?.workspace??ee?.folderUri;ie&&(f.URI.isUri(ie)?ie.scheme===w.Schemas.file?x=[ie.fsPath]:B=[ie.toString()]:ie.configPath.scheme===w.Schemas.file?x=[(0,u.originalFSPath)(ie.configPath)]:X=[ie.configPath.toString()])}let Z=T.remoteAuthority;for(const ee of A)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=f.URI.parse(ee),fe=(0,P.getRemoteAuthority)(ie);fe&&(Z?(0,u.isEqualAuthority)(fe,Z)||this.logService.error("more than one extension development path authority"):Z=fe)}x=x.filter(ee=>{const ie=f.URI.file(ee);return(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,u.isEqualAuthority)((0,P.getRemoteAuthority)(ie),Z)}),B=B.filter(ee=>{const ie=this.cliArgToUri(ee);return ie&&(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,u.isEqualAuthority)((0,P.getRemoteAuthority)(ie),Z):!1}),X=X.filter(ee=>{const ie=this.cliArgToUri(ee);return ie&&(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,u.isEqualAuthority)((0,P.getRemoteAuthority)(ie),Z):!1}),T.cli._=x,T.cli["folder-uri"]=B,T.cli["file-uri"]=X;const z={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:!x.length&&!B.length&&!X.length,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:Z,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile};return this.open(z)}async openInBrowserWindow(A){const T=this.configurationService.getValue("window"),J=this.getLastActiveWindow(),B=J?.profile??this.userDataProfilesMainService.defaultProfile;let X;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||J,X&&X.focus());const x={...this.environmentMainService.args,...A.cli,machineId:this.machineId,sqmId:this.sqmId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:B},homeDir:this.environmentMainService.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:w.Schemas.file}).fsPath,product:R.default,isInitialStartup:A.initialStartup,perfMarks:(0,p.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},autoDetectHighContrast:T?.autoDetectHighContrast??!0,autoDetectColorScheme:T?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(X){const Z=X.config;!x.extensionDevelopmentPath&&Z?.extensionDevelopmentPath&&(x.extensionDevelopmentPath=Z.extensionDevelopmentPath,x.extensionDevelopmentKind=Z.extensionDevelopmentKind,x["enable-proposed-api"]=Z["enable-proposed-api"],x.verbose=Z.verbose,x["inspect-extensions"]=Z["inspect-extensions"],x["inspect-brk-extensions"]=Z["inspect-brk-extensions"],x.debugId=Z.debugId,x.extensionEnvironment=Z.extensionEnvironment,x["extensions-dir"]=Z["extensions-dir"],x["disable-extensions"]=Z["disable-extensions"]),x.loggers={global:x.loggers.global,window:Z?.loggers.window??x.loggers.window}}else{const Z=this.windowsStateHandler.getNewWindowState(x);(0,p.mark)("code/willCreateCodeWindow");const z=X=this.instantiationService.createInstance(U.CodeWindow,{state:Z,extensionDevelopmentPath:x.extensionDevelopmentPath,isExtensionTestHost:!!x.extensionTestsPath});(0,p.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(z),this.windows.set(z.id,z),this._onDidOpenWindow.fire(z),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ee=new b.DisposableStore;ee.add(z.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(z))),ee.add(g.Event.once(z.onDidClose)(()=>this.onWindowClosed(z,ee))),ee.add(g.Event.once(z.onDidDestroy)(()=>this.onWindowDestroyed(z))),ee.add(z.onDidMaximize(()=>this._onDidMaximizeWindow.fire(z))),ee.add(z.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(z))),ee.add(z.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:z,fullscreen:!0}))),ee.add(z.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:z,fullscreen:!1}))),ee.add(z.onDidTriggerSystemContextMenu(({x:fe,y:pe})=>this._onDidTriggerSystemContextMenu.fire({window:z,x:fe,y:pe})));const ie=(0,d.assertIsDefined)(z.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.lifecycleMainService.reload(z)),this.lifecycleMainService.registerWindow(z)}return x.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then(async Z=>{Z||await this.doOpenInBrowserWindow(X,x,A,B)}):await this.doOpenInBrowserWindow(X,x,A,B),X}async doOpenInBrowserWindow(A,T,J,B){if(T.extensionDevelopmentPath||((0,le.isWorkspaceIdentifier)(T.workspace)?T.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:T.workspace,remoteAuthority:T.remoteAuthority}):(0,le.isSingleFolderWorkspaceIdentifier)(T.workspace)?T.backupPath=this.backupMainService.registerFolderBackup({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority}):T.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:J.emptyWindowBackupInfo?.backupFolder??(0,se.createEmptyWorkspaceIdentifier)().id,remoteAuthority:T.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const X=T.workspace??(0,le.toWorkspaceIdentifier)(T.backupPath,!1),x=this.resolveProfileForBrowserWindow(J,X,B),Z=x instanceof Promise?await x:x;T.profiles.profile=Z,T.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(X,Z)}A.load(T)}resolveProfileForBrowserWindow(A,T,J){return A.forceProfile?this.userDataProfilesMainService.profiles.find(B=>B.name===A.forceProfile)??this.userDataProfilesMainService.createNamedProfile(A.forceProfile):A.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(T)??J}onWindowClosed(A,T){this.windows.delete(A.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),T.dispose()}onWindowDestroyed(A){this.windows.delete(A.id),this._onDidDestroyWindow.fire(A)}getFocusedWindow(){const A=I.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(T=>(0,u.isEqualAuthority)(T.remoteAuthority,A)))}doGetLastActiveWindow(A){return(0,F.getLastFocused)(A)}sendToFocused(A,...T){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,C.CancellationToken.None,...T)}sendToOpeningWindow(A,...T){this._register(g.Event.once(this.onDidSignalReadyWindow)(J=>{J.sendWhenReady(A,C.CancellationToken.None,...T)}))}sendToAll(A,T,J){for(const B of this.getWindows())J&&J.indexOf(B.id)>=0||B.sendWhenReady(A,C.CancellationToken.None,T)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(A){return this.windows.get(A)}getWindowByWebContents(A){const T=I.BrowserWindow.fromWebContents(A);if(T)return this.getWindowById(T.id)}};e.WindowsMainService=de,e.WindowsMainService=de=be([re(3,S.ILogService),re(4,N.ILoggerMainService),re(5,D.IStateService),re(6,q.IPolicyService),re(7,s.IEnvironmentMainService),re(8,W.IUserDataProfilesMainService),re(9,l.ILifecycleMainService),re(10,a.IBackupMainService),re(11,t.IConfigurationService),re(12,ue.IWorkspacesHistoryMainService),re(13,Y.IWorkspacesManagementMainService),re(14,n.IInstantiationService),re(15,o.IDialogMainService),re(16,i.IFileService),re(17,k.IProtocolMainService),re(18,Q.IThemeMainService),re(19,V.IAuxiliaryWindowsMainService)],de)}),define(ae[307],ce([0,1,65,29,84,58]),function(K,e,I,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(g,c,v,b){this.workspacesManagementMainService=g,this.windowsMainService=c,this.workspacesHistoryMainService=v,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,c){const v=this.windowsMainService.getWindowById(g);if(v)return this.workspacesManagementMainService.enterWorkspace(v,this.windowsMainService.getWindows(),c)}createUntitledWorkspace(g,c,v){return this.workspacesManagementMainService.createUntitledWorkspace(c,v)}deleteUntitledWorkspace(g,c){return this.workspacesManagementMainService.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(g,c){return this.workspacesManagementMainService.getWorkspaceIdentifier(c)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(g,c){return this.workspacesHistoryMainService.addRecentlyOpened(c)}removeRecentlyOpened(g,c){return this.workspacesHistoryMainService.removeRecentlyOpened(c)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=M,e.WorkspacesMainService=M=be([re(0,O.IWorkspacesManagementMainService),re(1,L.IWindowsMainService),re(2,r.IWorkspacesHistoryMainService),re(3,I.IBackupMainService)],M)}),define(ae[308],ce([0,1,14,132,37,26,17,51,15,33,3,42,47,2,13,9,4,12,7,32,158,43,159,112,290,162,65,283,18,200,92,133,56,118,220,24,64,95,209,293,211,212,213,16,224,94,77,6,93,219,299,284,291,20,5,305,70,27,60,294,96,34,275,83,124,28,251,253,54,49,265,288,300,289,301,129,267,268,269,272,297,55,29,306,274,30,98,84,307,58,39,233,57,244,53,82,130,277,292,280,8,255,276,228,68,296,271,22,127,295,263,239,62,78,303]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n,l,S,R,k,P,D,_,U,F,H,j,le,se,ue,Y,Q,q,W,N,V,$,oe,de,G,A,T,J,B,X,x,Z,z,ee,ie,fe,pe,Pe,Ce,We,Ee,ye,te,he,me,De,Ae,Ue,_e,je,qe,Ge,xe,$e,ne,ge,Se,we,Ie,Oe,Ne,Ke,Je,Xe,Ye,rt,tt,ot,at,yt,bt,Et,Pt,It,ct,gt,Ct,kt,Dt,lt,Mt,mt,ut,Rt,Lt,dt,At,pt,Ot){"use strict";var ht;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ft=class extends h.Disposable{static{ht=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[p.Schemas.file]:"security.promptForLocalFileProtocolHandling",[p.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(ke,Me,Le,ve,Re,Be,ze,Ve,Te,Fe,He,Qe){super(),this.mainProcessNodeIpcServer=ke,this.userEnv=Me,this.mainInstantiationService=Le,this.logService=ve,this.loggerService=Re,this.environmentMainService=Be,this.lifecycleMainService=ze,this.configurationService=Ve,this.stateService=Te,this.fileService=Fe,this.productService=He,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const ke=Te=>Te?.startsWith(`${p.Schemas.vscodeWebview}://`),Me=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((Te,Fe,He,Qe)=>ke(Qe.requestingUrl)?He(Me.has(Fe)):He(!1)),I.session.defaultSession.setPermissionCheckHandler((Te,Fe,He,Qe)=>ke(Qe.requestingUrl)?Me.has(Fe):!1);const Le=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,p.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Te=>{for(let Fe=Te;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Re=Te=>Te.resourceType==="xhr"||ve(Te.frame),Be=Te=>{const Fe=Te.frame;if(!Fe||!this.windowsMainService)return!1;const He=I.BrowserWindow.getAllWindows();for(const Qe of He)if(Fe.processId===Qe.webContents.mainFrame.processId)return!0;return!1},ze=(Te,Fe)=>{if(Te.path!=="/index.html")return!0;const He=Fe.frame;if(!He||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&He.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((Te,Fe)=>{const He=d.URI.parse(Te.url);return He.scheme===p.Schemas.vscodeWebview&&!ze(He,Te)?(this.logService.error("Blocked vscode-webview request",Te.url),Fe({cancel:!0})):He.scheme===p.Schemas.vscodeFileResource&&!Be(Te)?(this.logService.error("Blocked vscode-file request",Te.url),Fe({cancel:!0})):He.path.endsWith(".svg")&&!Le.has(He.scheme)?Fe({cancel:!Re(Te)}):Fe({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((Te,Fe)=>{const He=Te.responseHeaders,Qe=He["content-type"]||He["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=d.URI.parse(Te.url);if(Ze.path.endsWith(".svg")&&Le.has(Ze.scheme))return He["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:He});if(!Ze.path.endsWith(p.Schemas.vscodeRemoteResource)&&Qe.some(it=>it.toLowerCase().includes("image/svg")))return Fe({cancel:!Re(Te)})}return Fe({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((Te,Fe)=>{if(Te.url.startsWith("https://vscode.download.prss.microsoft.com/")){const He=Te.responseHeaders??Object.create(null);if(He["Access-Control-Allow-Origin"]===void 0)return He["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:He})}return Fe({cancel:!1})});const Ve=I.session.defaultSession;typeof Ve.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ve.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome")),E.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,g.setUnexpectedErrorHandler)(Le=>this.onUnexpectedError(Le)),process.on("uncaughtException",Le=>{(0,g.isSigPipeError)(Le)||(0,g.onUnexpectedError)(Le)}),process.on("unhandledRejection",Le=>(0,g.onUnexpectedError)(Le)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,m.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Le,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),I.app.on("activate",async(Le,ve)=>{this.logService.trace("app#activate"),ve||await this.windowsMainService?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Le,ve)=>{ve?.opener?.url.startsWith(`${p.Schemas.vscodeFileResource}://${p.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(ve)),ve.on("will-navigate",Re=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),ve.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(Re)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.nativeHostMainService?.openExternal(void 0,Re.url),{action:"deny"}))});let ke=[],Me;I.app.on("open-file",(Le,ve)=>{this.logService.trace("app#open-file: ",ve),Le.preventDefault(),ke.push((0,Oe.hasWorkspaceFileExtension)(ve)?{workspaceUri:d.URI.file(ve)}:{fileUri:d.URI.file(ve)}),Me!==void 0&&(clearTimeout(Me),Me=void 0),Me=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Me=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",Le=>{const ve=this.windowsMainService?.getWindowByWebContents(Le.sender);let Re,Be;return ve?.config?(Re=ve.config,Be={...process.env,...ve.config.userEnv}):(Re=this.environmentMainService.args,Be=process.env),this.resolveShellEnvironment(Re,Be,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(Le,ve,Re)=>{const Be=this.validateNlsPath([ve]);if(!Be||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Be,M.VSBuffer.fromString(Re))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(Le,...ve)=>{const Re=this.validateNlsPath(ve);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Re)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",Le=>Le.sender.reload()),r.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Le,ve)=>{const Re=this.windowsMainService?.getWindowById(Le.sender.id);Re&&Re.notifyZoomLevel(ve)})}validateNlsPath(ke){let Me;for(const Le of ke)typeof Le=="string"&&(typeof Me!="string"?Me=Le:Me=(0,y.join)(Me,Le));if(!(typeof Me!="string"||!(0,y.isAbsolute)(Me)||!(0,c.isEqualOrParent)(Me,this.environmentMainService.cachedLanguagesPath,!E.isLinux)))return d.URI.file(Me)}onUnexpectedError(ke){if(ke){const Me={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.logService.error(ke.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ke=this.productService.win32AppUserModelId;E.isWindows&&ke&&I.app.setAppUserModelId(ke);try{E.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const Me=new t.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&Me.dispose()}),this.logService.trace("Resolving machine identifier...");const[Le,ve]=await Promise.all([(0,gt.resolveMachineId)(this.stateService,this.logService),(0,gt.resolveSqmId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:Re,sharedProcessClient:Be}=this.setupSharedProcess(Le,ve),ze=await this.initServices(Le,ve,Re);this._register(ze.createInstance(s.ProxyAuthHandler)),this._register(ze.createInstance(Pt.UserDataProfilesHandler)),ze.invokeFunction(Fe=>this.initChannels(Fe,Me,Be));const Ve=await ze.invokeFunction(Fe=>this.setupProtocolUrlHandlers(Fe,Me));this.setupManagedRemoteResourceUrlHandler(Me),this.lifecycleMainService.phase=2,await ze.invokeFunction(Fe=>this.openFirstWindow(Fe,Ve)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new ct.RunOnceScheduler(()=>{this._register((0,ct.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(ke,Me){const Le=this.windowsMainService=ke.get(Se.IWindowsMainService),ve=ke.get(je.IURLService),Re=this.nativeHostMainService=ke.get(x.INativeHostMainService),Be=ke.get(D.IDialogMainService),ze=this;ve.registerHandler({async handleURL(Ze,it){return ze.handleProtocolUrl(Le,Be,ve,Ze,it)}});const Ve=this._register(new Ie.ActiveWindowManager({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Te=new a.StaticRouter(Ze=>Ve.getActiveClientId().then(it=>Ze===it)),Fe=new qe.URLHandlerRouter(Te,this.logService),He=Me.getChannel("urlHandler",Fe);ve.registerHandler(new qe.URLHandlerChannelClient(He));const Qe=await this.resolveInitialProtocolUrls(Le,Be);return this._register(new xe.ElectronURLListener(Qe?.urls,ve,Le,this.environmentMainService,this.productService,this.logService)),Qe}setupManagedRemoteResourceUrlHandler(ke){const Me=()=>({statusCode:404,data:"Not found"}),Le=new At.Lazy(()=>ke.getChannel(dt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new dt.NodeRemoteResourceRouter));I.protocol.registerBufferProtocol(p.Schemas.vscodeManagedRemoteResource,(ve,Re)=>{const Be=d.URI.parse(ve.url);if(!Be.authority.startsWith("window:"))return Re(Me());Le.value.call(dt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Be]).then(ze=>Re({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.logService.warn("error dispatching remote resource call",ze),Re({statusCode:500,data:String(ze)})})})}async resolveInitialProtocolUrls(ke,Me){const Le=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Le.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),Le.length+ve.length===0)return;const Re=[...Le,...ve].map(Ve=>{try{return{uri:d.URI.parse(Ve),originalUrl:Ve}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ve);return}}),Be=[],ze=[];for(const Ve of Re){if(!Ve)continue;const Te=this.getWindowOpenableFromProtocolUrl(Ve.uri);if(Te)if(await this.shouldBlockOpenable(Te,ke,Me)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ve.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ve.uri.toString(!0),Te),Be.push(Te);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ve.uri.toString(!0)),ze.push(Ve)}return{urls:ze,openables:Be}}async shouldBlockOpenable(ke,Me,Le){let ve,Re;if((0,ge.isWorkspaceToOpen)(ke)?(ve=ke.workspaceUri,Re=(0,i.localize)(0,null,ve.scheme===p.Schemas.file?(0,w.getPathLabel)(ve,{os:E.OS,tildify:this.environmentMainService}):ve.toString(!0),this.productService.nameShort)):(0,ge.isFolderToOpen)(ke)?(ve=ke.folderUri,Re=(0,i.localize)(1,null,ve.scheme===p.Schemas.file?(0,w.getPathLabel)(ve,{os:E.OS,tildify:this.environmentMainService}):ve.toString(!0),this.productService.nameShort)):(ve=ke.fileUri,Re=(0,i.localize)(2,null,ve.scheme===p.Schemas.file?(0,w.getPathLabel)(ve,{os:E.OS,tildify:this.environmentMainService}):ve.toString(!0),this.productService.nameShort)),ve.scheme!==p.Schemas.file&&ve.scheme!==p.Schemas.vscodeRemote||this.configurationService.getValue(ht.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[ve.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ve}=await Le.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Re,detail:(0,i.localize)(5,null),checkboxLabel:ve.scheme===p.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ve){const Te={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===p.Schemas.file?"local":"remote"};Me.sendToFocused(Te.channel,Te.args),Me.sendToOpeningWindow(Te.channel,Te.args)}return!1}getWindowOpenableFromProtocolUrl(ke){if(ke.path){if(ke.authority===p.Schemas.file){const Me=d.URI.file(ke.fsPath);return(0,Oe.hasWorkspaceFileExtension)(Me)?{workspaceUri:Me}:{fileUri:Me}}else if(ke.authority===p.Schemas.vscodeRemote){const Me=ke.path.indexOf(y.posix.sep,1);if(Me!==-1){const Le=ke.path.substring(1,Me),ve=ke.path.substring(Me);let Re=ke.query;const Be=new URLSearchParams(ke.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Re=Be.toString());const ze=d.URI.from({scheme:p.Schemas.vscodeRemote,authority:Le,path:ve,query:Re,fragment:ke.fragment});return(0,Oe.hasWorkspaceFileExtension)(ve)?{workspaceUri:ze}:/:[\d]+$/.test(ve)?{fileUri:ze}:{folderUri:ze}}}}}async handleProtocolUrl(ke,Me,Le,ve,Re){this.logService.trace("app#handleProtocolUrl():",ve.toString(!0),Re),ve.scheme===this.productService.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:d.URI.parse(ve.query).path,query:""}));let Be=!1;const ze=new URLSearchParams(ve.query);ze.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),ze.delete("windowId"),ve=ve.with({query:ze.toString()}),Be=!0):E.isMacintosh&&ke.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Be=!0);const Ve=ze.get("continueOn");Ve!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),ze.delete("continueOn"),ve=ve.with({query:ze.toString()}),this.environmentMainService.continueOn=Ve??void 0);const Te=this.getWindowOpenableFromProtocolUrl(ve);return Te?await this.shouldBlockOpenable(Te,ke,Me)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Te,ve.toString(!0)),(0,mt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Te],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,mt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,z.getRemoteAuthority)(ve)}))?.ready(),Le.open(ve,Re)):(this.logService.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Re),!1)}setupSharedProcess(ke,Me){const Le=this._register(this.mainInstantiationService.createInstance(ee.SharedProcess,ke,Me)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Be=await Le.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Be,"main")})();return{sharedProcessReady:(async()=>(await Le.whenReady(),ve))(),sharedProcessClient:ve}}async initServices(ke,Me,Le){const ve=new oe.ServiceCollection;switch(process.platform){case"win32":ve.set(he.IUpdateService,new V.SyncDescriptor(_e.Win32UpdateService));break;case"linux":E.isLinuxSnap?ve.set(he.IUpdateService,new V.SyncDescriptor(Ue.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(he.IUpdateService,new V.SyncDescriptor(Ae.LinuxUpdateService));break;case"darwin":ve.set(he.IUpdateService,new V.SyncDescriptor(De.DarwinUpdateService));break}ve.set(Se.IWindowsMainService,new V.SyncDescriptor(we.WindowsMainService,[ke,Me,this.userEnv],!1)),ve.set(pt.IAuxiliaryWindowsMainService,new V.SyncDescriptor(Ot.AuxiliaryWindowsMainService,void 0,!1));const Re=new D.DialogMainService(this.logService,this.productService);ve.set(D.IDialogMainService,Re),ve.set(T.ILaunchMainService,new V.SyncDescriptor(T.LaunchMainService,void 0,!1)),ve.set(P.IDiagnosticsMainService,new V.SyncDescriptor(P.DiagnosticsMainService,void 0,!1)),ve.set(k.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Le.then(Fe=>Fe.getChannel("diagnostics"))))),ve.set(de.IIssueMainService,new V.SyncDescriptor(G.IssueMainService,[this.userEnv])),ve.set(_.IEncryptionMainService,new V.SyncDescriptor(U.EncryptionMainService)),ve.set(A.IKeyboardLayoutMainService,new V.SyncDescriptor(A.KeyboardLayoutMainService)),ve.set(x.INativeHostMainService,new V.SyncDescriptor(x.NativeHostMainService,void 0,!1)),ve.set($e.IWebviewManagerService,new V.SyncDescriptor(ne.WebviewMainService)),ve.set(X.IMenubarMainService,new V.SyncDescriptor(X.MenubarMainService)),ve.set(le.IExtensionHostStarter,new V.SyncDescriptor(se.ExtensionHostStarter)),ve.set(Pe.IStorageMainService,new V.SyncDescriptor(Pe.StorageMainService)),ve.set(Pe.IApplicationStorageMainService,new V.SyncDescriptor(Pe.ApplicationStorageMainService));const Be=new Rt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),ze=new Lt.PtyHostService(Be,this.configurationService,this.logService,this.loggerService);ve.set(ut.ILocalPtyService,ze),E.isWindows?ve.set(ue.IExternalTerminalMainService,new V.SyncDescriptor(Y.WindowsExternalTerminalService)):E.isMacintosh?ve.set(ue.IExternalTerminalMainService,new V.SyncDescriptor(Y.MacExternalTerminalService)):E.isLinux&&ve.set(ue.IExternalTerminalMainService,new V.SyncDescriptor(Y.LinuxExternalTerminalService));const Ve=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);ve.set(n.IBackupMainService,Ve);const Te=new Xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ve,Re);if(ve.set(Xe.IWorkspacesManagementMainService,Te),ve.set(Ne.IWorkspacesService,new V.SyncDescriptor(Je.WorkspacesMainService,void 0,!1)),ve.set(Ke.IWorkspacesHistoryMainService,new V.SyncDescriptor(Ke.WorkspacesHistoryMainService,void 0,!1)),ve.set(je.IURLService,new V.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,te.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,te.isInternalTelemetry)(this.productService,this.configurationService),He=(0,a.getDelayedChannel)(Le.then(st=>st.getChannel("telemetryAppender"))),Qe=new Ee.TelemetryAppenderClient(He),Ze=(0,Ce.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,this.productService.commit,this.productService.version,ke,Me,Fe),it=(0,te.getPiiPathsFromEnvironment)(this.environmentMainService),nt={appenders:[Qe],commonProperties:Ze,piiPaths:it,sendErrorTelemetry:!0};ve.set(We.ITelemetryService,new V.SyncDescriptor(ye.TelemetryService,[nt],!1))}else ve.set(We.ITelemetryService,te.NullTelemetryService);return ve.set(yt.IExtensionsProfileScannerService,new V.SyncDescriptor(Ct.ExtensionsProfileScannerService,void 0,!0)),ve.set(bt.IExtensionsScannerService,new V.SyncDescriptor(Et.ExtensionsScannerService,void 0,!0)),ve.set(lt.IUtilityProcessWorkerMainService,new V.SyncDescriptor(lt.UtilityProcessWorkerMainService,void 0,!0)),await ct.Promises.settled([Ve.initialize(),Te.initialize()]),this.mainInstantiationService.createChild(ve)}initChannels(ke,Me,Le){const ve=this._register(new h.DisposableStore),Re=a.ProxyChannel.fromService(ke.get(T.ILaunchMainService),ve,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Re);const Be=a.ProxyChannel.fromService(ke.get(P.IDiagnosticsMainService),ve,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Be);const ze=new rt.PolicyChannel(ke.get(Ye.IPolicyService));Me.registerChannel("policy",ze),Le.then(et=>et.registerChannel("policy",ze));const Ve=this.fileService.getProvider(p.Schemas.file);(0,u.assertType)(Ve instanceof N.DiskFileSystemProvider);const Te=new W.DiskFileSystemProviderChannel(Ve,this.logService,this.environmentMainService);Me.registerChannel(Q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Te),Le.then(et=>et.registerChannel(Q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Te));const Fe=a.ProxyChannel.fromService(ke.get(tt.IUserDataProfilesMainService),ve);Me.registerChannel("userDataProfiles",Fe),Le.then(et=>et.registerChannel("userDataProfiles",Fe));const He=new ot.RequestChannel(ke.get(at.IRequestService));Le.then(et=>et.registerChannel("request",He));const Qe=new me.UpdateChannel(ke.get(he.IUpdateService));Me.registerChannel("update",Qe);const Ze=a.ProxyChannel.fromService(ke.get(de.IIssueMainService),ve);Me.registerChannel("issue",Ze);const it=a.ProxyChannel.fromService(ke.get(_.IEncryptionMainService),ve);Me.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(ke.get(ie.ISignService),ve);Me.registerChannel("sign",nt);const st=a.ProxyChannel.fromService(ke.get(A.IKeyboardLayoutMainService),ve);Me.registerChannel("keyboardLayout",st),this.nativeHostMainService=ke.get(x.INativeHostMainService);const vt=a.ProxyChannel.fromService(this.nativeHostMainService,ve);Me.registerChannel("nativeHost",vt),Le.then(et=>et.registerChannel("nativeHost",vt));const _t=a.ProxyChannel.fromService(ke.get(Ne.IWorkspacesService),ve);Me.registerChannel("workspaces",_t);const Wt=a.ProxyChannel.fromService(ke.get(X.IMenubarMainService),ve);Me.registerChannel("menubar",Wt);const Tt=a.ProxyChannel.fromService(ke.get(je.IURLService),ve);Me.registerChannel("url",Tt);const Ft=a.ProxyChannel.fromService(ke.get($e.IWebviewManagerService),ve);Me.registerChannel("webview",Ft);const wt=this._register(new pe.StorageDatabaseChannel(this.logService,ke.get(Pe.IStorageMainService)));Me.registerChannel("storage",wt),Le.then(et=>et.registerChannel("storage",wt));const Ut=this._register(new It.ProfileStorageChangesListenerChannel(ke.get(Pe.IStorageMainService),ke.get(tt.IUserDataProfilesMainService),this.logService));Le.then(et=>et.registerChannel("profileStorageListener",Ut));const Nt=a.ProxyChannel.fromService(ke.get(ut.ILocalPtyService),ve);Me.registerChannel(ut.TerminalIpcChannels.LocalPty,Nt);const Bt=a.ProxyChannel.fromService(ke.get(ue.IExternalTerminalMainService),ve);Me.registerChannel("externalTerminal",Bt);const St=new kt.LoggerChannel(ke.get(Dt.ILoggerMainService));Me.registerChannel("logger",St),Le.then(et=>et.registerChannel("logger",St));const zt=new R.ElectronExtensionHostDebugBroadcastChannel(ke.get(Se.IWindowsMainService));Me.registerChannel("extensionhostdebugservice",zt);const $t=a.ProxyChannel.fromService(ke.get(le.IExtensionHostStarter),ve);Me.registerChannel(le.ipcExtensionHostStarterChannelName,$t);const qt=a.ProxyChannel.fromService(ke.get(lt.IUtilityProcessWorkerMainService),ve);Me.registerChannel(Mt.ipcUtilityProcessWorkerChannelName,qt)}async openFirstWindow(ke,Me){const Le=this.windowsMainService=ke.get(Se.IWindowsMainService);this.auxiliaryWindowsMainService=ke.get(pt.IAuxiliaryWindowsMainService);const ve=(0,H.isLaunchedFromCli)(process.env)?0:4,Re=this.environmentMainService.args;if(Me){if(Me.openables.length>0)return Le.open({context:ve,cli:Re,urisToOpen:Me.openables,gotoLineMode:!0,initialStartup:!0});if(Me.urls.length>0)for(const nt of Me.urls){const st=new URLSearchParams(nt.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:st.toString()}),Le.open({context:ve,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,ze=Re._.length,Ve=!!Re["folder-uri"],Te=!!Re["file-uri"],Fe=Re["skip-add-to-recently-opened"]===!0,He=Re.wait&&Re.waitMarkerFilePath?d.URI.file(Re.waitMarkerFilePath):void 0,Qe=Re.remote||void 0,Ze=Re.profile,it=Re["profile-temp"];if(!ze&&!Ve&&!Te){if(Re["new-window"]||Ze||it)return Le.open({context:ve,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:He,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:it});if(Be.length)return Le.open({context:1,cli:Re,urisToOpen:Be.map(nt=>(0,Oe.hasWorkspaceFileExtension)(nt)?{workspaceUri:d.URI.file(nt)}:{fileUri:d.URI.file(nt)}),noRecentEntry:Fe,waitMarkerFileURI:He,initialStartup:!0})}return Le.open({context:ve,cli:Re,forceNewWindow:Re["new-window"]||!ze&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Fe,waitMarkerFileURI:He,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:it})}afterWindowOpen(){this.installMutex(),I.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(ke,Me)=>{Me({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),E.isMacintosh&&I.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const ke=this.productService.win32MutexName;if(E.isWindows&&ke)try{const Me=await new Promise((ve,Re)=>{K(["@vscode/windows-mutex"],ve,Re)}),Le=new Me.Mutex(ke);v.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(ke,Me,Le){try{return await(0,j.getResolvedShellEnv)(this.configurationService,this.logService,ke,Me)}catch(ve){const Re=(0,C.toErrorMessage)(ve);Le?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Re):this.logService.error(Re)}return{}}async updateCrashReporterEnablement(){try{const Me=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Le=JSON.parse((0,b.stripComments)(Me)),Re=(0,te.getTelemetryLevel)(this.configurationService)>=1;if(Le["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],ze=Me.substring(0,Me.length-2).concat(`,
`,Be.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(ze))}else{const Be=Me.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Be!==Me&&await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(Be))}}catch(ke){this.logService.error(ke)}}};e.CodeApplication=ft,e.CodeApplication=ft=ht=be([re(2,$.IInstantiationService),re(3,B.ILogService),re(4,B.ILoggerService),re(5,F.IEnvironmentMainService),re(6,J.ILifecycleMainService),re(7,S.IConfigurationService),re(8,fe.IStateService),re(9,q.IFileService),re(10,Z.IProductService),re(11,tt.IUserDataProfilesMainService)],ft)}),define(ae[313],ce([0,1,14,46,7,22,8,51,15,33,3,47,13,9,67,4,36,25,21,43,100,308,10,18,238,250,24,64,202,16,222,94,77,218,93,20,225,5,79,27,80,278,128,287,53,286,96,249,34,54,69,57,39,234,232,2,40,266,68,227,117,123,270,264]),function(K,e,I,L,r,O,M,C,g,c,v,b,w,h,p,y,E,u,d,f,m,a,t,o,s,i,n,l,S,R,k,P,D,_,U,F,H,j,le,se,ue,Y,Q,q,W,N,V,$,oe,de,G,A,T,J,B,X,x,Z,z,ee,ie,fe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.startup()}catch(Ee){console.error(Ee.message),I.app.exit(1)}}async startup(){(0,g.setUnexpectedErrorHandler)(_e=>console.error(_e));const[Ee,ye,te,he,me,De,Ae,Ue]=this.createServices();try{try{await this.initServices(te,Ue,he,me,Ae)}catch(_e){throw this.handleStartupDataDirError(te,Ae,_e),_e}await Ee.invokeFunction(async _e=>{const je=_e.get(j.ILogService),qe=_e.get(F.ILifecycleMainService),Ge=_e.get(R.IFileService),xe=_e.get(j.ILoggerService),$e=await this.claimInstance(je,te,qe,Ee,Ae,!0);return d.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(ne=>{je.warn(`app#startup(): Error writing main lockfile: ${ne.stack}`)}),De.logger=xe.createLogger("main",{name:(0,t.localize)(0,null)}),v.Event.once(qe.onWillShutdown)(ne=>{Ge.dispose(),he.dispose(),ne.join("instanceLockfile",d.Promises.unlink(te.mainLockfile).catch(()=>{}))}),Ee.createInstance(a.CodeApplication,$e,ye).startup()})}catch(_e){Ee.invokeFunction(this.quit,_e)}}createServices(){const Ee=new U.ServiceCollection,ye=new X.DisposableStore;process.once("exit",()=>ye.dispose());const te={_serviceBrand:void 0,...le.default};Ee.set(se.IProductService,te);const he=new n.EnvironmentMainService(this.resolveArgs(),te),me=this.patchEnvironment(he);Ee.set(n.IEnvironmentMainService,he);const De=new z.LoggerMainService((0,j.getLogLevel)(he),he.logsHome);Ee.set(z.ILoggerMainService,De);const Ae=new H.BufferLogger(De.getLogLevel()),Ue=ye.add(new ee.LogService(Ae,[new j.ConsoleMainLogger(De.getLogLevel())]));Ee.set(j.ILogService,Ue);const _e=new k.FileService(Ue);Ee.set(R.IFileService,_e);const je=new P.DiskFileSystemProvider(Ue);_e.registerProvider(w.Schemas.file,je);const qe=new Z.UriIdentityService(_e);Ee.set(x.IUriIdentityService,qe);const Ge=new fe.StateService(1,he,Ue,_e);Ee.set(oe.IStateReadService,Ge),Ee.set(oe.IStateService,Ge);const xe=new A.UserDataProfilesMainService(Ge,qe,he,_e,Ue);Ee.set(A.IUserDataProfilesMainService,xe),_e.registerProvider(w.Schemas.vscodeUserData,new pe.FileUserDataProvider(w.Schemas.file,je,w.Schemas.vscodeUserData,xe,qe,Ue));const $e=y.isWindows&&te.win32RegValueName?ye.add(new J.NativePolicyService(Ue,te.win32RegValueName)):he.policyFile?ye.add(new B.FilePolicyService(he.policyFile,_e,Ue)):new T.NullPolicyService;Ee.set(T.IPolicyService,$e);const ne=new s.ConfigurationService(xe.defaultProfile.settingsResource,_e,$e,Ue);return Ee.set(o.IConfigurationService,ne),Ee.set(F.ILifecycleMainService,new D.SyncDescriptor(F.LifecycleMainService,void 0,!1)),Ee.set(W.IRequestService,new D.SyncDescriptor(N.RequestMainService,void 0,!0)),Ee.set(G.IThemeMainService,new D.SyncDescriptor(G.ThemeMainService)),Ee.set(V.ISignService,new D.SyncDescriptor($.SignService,void 0,!1)),Ee.set(Q.ITunnelService,new D.SyncDescriptor(q.TunnelService)),Ee.set(ue.IProtocolMainService,new Y.ProtocolMainService(he,xe,Ue)),[new _.InstantiationService(Ee,!0),me,he,ne,Ge,Ae,te,xe]}patchEnvironment(Ee){const ye={VSCODE_IPC_HOOK:Ee.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const he=process.env[te];typeof he=="string"&&(ye[te]=he)}),Object.assign(process.env,ye),ye}async initServices(Ee,ye,te,he,me){await M.Promises.settled([Promise.all([Ee.extensionsPath,Ee.codeCachePath,Ee.logsHome.with({scheme:w.Schemas.file}).fsPath,ye.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,Ee.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,Ee.localHistoryHome.with({scheme:w.Schemas.file}).fsPath,Ee.backupHome].map(De=>De?d.Promises.mkdir(De,{recursive:!0}):void 0)),he.init(),te.initialize()]),ye.init()}async claimInstance(Ee,ye,te,he,me,De){let Ae;try{(0,p.mark)("code/willStartMainServer"),Ae=await(0,m.serve)(ye.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),v.Event.once(te.onWillShutdown)(()=>Ae.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ye,me,Ue),Ue;let _e;try{_e=await(0,m.connect)(ye.mainIPCHandle,"main")}catch(xe){if(!De||y.isWindows||xe.code!=="ECONNREFUSED")throw xe.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,me.nameShort),(0,t.localize)(2,null),me),xe;try{(0,L.unlinkSync)(ye.mainIPCHandle)}catch($e){throw Ee.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(Ee,ye,te,he,me,!1)}if(ye.extensionTestsLocationURI&&!ye.debugExtensionHost.break){const xe=`Running extension tests from the command line is currently only supported if no other instance of ${me.nameShort} is running.`;throw Ee.error(xe),_e.dispose(),new Error(xe)}let je;!ye.args.wait&&!ye.args.status&&(je=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,me.nameShort),(0,t.localize)(4,null),me)},1e4));const qe=f.ProxyChannel.toService(_e.getChannel("launch"),{disableMarshalling:!0}),Ge=f.ProxyChannel.toService(_e.getChannel("diagnostics"),{disableMarshalling:!0});if(ye.args.status)return he.invokeFunction(async()=>{const xe=new i.DiagnosticsService(de.NullTelemetryService,me),$e=await Ge.getMainDiagnostics(),ne=await Ge.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ge=await xe.getDiagnostics($e,ne);throw console.log(ge),new g.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(qe,Ee),Ee.trace("Sending env to running instance..."),await qe.start(ye.args,process.env),_e.dispose(),je&&clearTimeout(je),new g.ExpectedError("Sent env to running instance. Terminating...")}if(ye.args.status)throw console.log((0,t.localize)(5,null,me.nameShort)),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(Ee,ye,te){if(te.code==="EACCES"||te.code==="EPERM"){const he=(0,O.coalesce)([Ee.userDataPath,Ee.extensionsPath,m.XDG_RUNTIME_DIR]).map(me=>(0,b.getPathLabel)(r.URI.file(me),{os:y.OS,tildify:Ee}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,C.toErrorMessage)(te),he.join(`
`)),ye)}}showStartupWarningDialog(Ee,ye,te){I.dialog.showMessageBoxSync((0,ie.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:Ee,detail:ye},te).options)}async windowsAllowSetForegroundWindow(Ee,ye){if(y.isWindows){const te=await Ee.getMainProcessId();ye.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((he,me)=>{K(["windows-foreground-love"],he,me)})).allowSetForegroundWindow(te)}catch(he){ye.error(he)}}}quit(Ee,ye){const te=Ee.get(j.ILogService),he=Ee.get(F.ILifecycleMainService);let me=0;ye&&(ye.isExpected?ye.message&&te.trace(ye.message):(me=1,ye.stack?te.error(ye.stack):te.error(`Startup error: ${ye.toString()}`))),he.kill(me)}resolveArgs(){const Ee=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(Ee.wait&&!Ee.waitMarkerFilePath){const ye=(0,S.createWaitMarkerFileSync)(Ee.verbose);ye&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ye),Ee.waitMarkerFilePath=ye)}return Ee}validatePaths(Ee){if(Ee["open-url"]&&(Ee._urls=Ee._,Ee._=[]),!Ee.remote){const ye=this.doValidatePaths(Ee._,Ee.goto);Ee._=ye}return Ee}doValidatePaths(Ee,ye){const te=(0,E.cwd)(),he=Ee.map(Ae=>{let Ue=String(Ae),_e;ye&&(_e=(0,c.parseLineAndColumnAware)(Ue),Ue=_e.path),Ue&&(Ue=this.preparePath(te,Ue));const je=(0,c.sanitizeFilePath)(Ue,te),qe=(0,h.basename)(je);return qe&&!(0,c.isValidBasename)(qe)?null:ye&&_e?(_e.path=je,this.toPath(_e)):je}),me=y.isWindows||y.isMacintosh,De=(0,O.distinct)(he,Ae=>Ae&&me?Ae.toLowerCase():Ae||"");return(0,O.coalesce)(De)}preparePath(Ee,ye){return y.isWindows&&(ye=(0,u.rtrim)(ye,'"')),ye=(0,u.trim)((0,u.trim)(ye," "),"	"),y.isWindows&&(ye=(0,h.resolve)(Ee,ye),ye=(0,u.rtrim)(ye,".")),ye}toPath(Ee){const ye=[Ee.path];return typeof Ee.line=="number"&&ye.push(String(Ee.line)),typeof Ee.column=="number"&&ye.push(String(Ee.column)),ye.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/code/electron-main/main.js.map
