/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/browser/ui/hover/hoverDelegate","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/browser/ui/iconLabel/iconLabelHover","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(se){for(var e=[],S=0,F=se.length;S<F;S++)e[S]=me[se[S]];return e};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Wt,setPrototypeOf:Ht,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:dt,create:ri}=Object,{apply:Lt,construct:Ft}=typeof Reflect<"u"&&Reflect;Lt||(Lt=function(e,S,F){return e.apply(S,F)}),ot||(ot=function(e){return e}),dt||(dt=function(e){return e}),Ft||(Ft=function(e,S){return new e(...S)});const oi=ct(Array.prototype.forEach),xt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),St=ct(String.prototype.toLowerCase),Nt=ct(String.prototype.toString),li=ct(String.prototype.match),ft=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),ui=ct(String.prototype.trim),ut=ct(RegExp.prototype.test),yt=ci(TypeError);function ct(se){return function(e){for(var S=arguments.length,F=new Array(S>1?S-1:0),n=1;n<S;n++)F[n-1]=arguments[n];return Lt(se,e,F)}}function ci(se){return function(){for(var e=arguments.length,S=new Array(e),F=0;F<e;F++)S[F]=arguments[F];return Ft(se,S)}}function ze(se,e,S){var F;S=(F=S)!==null&&F!==void 0?F:St,Ht&&Ht(se,null);let n=e.length;for(;n--;){let U=e[n];if(typeof U=="string"){const y=S(U);y!==U&&(ii(e)||(e[n]=y),U=y)}se[U]=!0}return se}function bt(se){const e=ri(null);for(const[S,F]of Wt(se))e[S]=F;return e}function Ct(se,e){for(;se!==null;){const F=si(se,e);if(F){if(F.get)return ct(F.get);if(typeof F.value=="function")return ct(F.value)}se=ni(se)}function S(F){return console.warn("fallback value for",F),null}return S}const zt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),kt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Mt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),hi=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Pt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),di=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=ot(["#text"]),$t=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Rt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),fi=dt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=dt(/<%[\w\W]*|[\w\W]*%>/gm),mi=dt(/\${[\w\W]*}/gm),pi=dt(/^data-[\-\w.\u00B7-\uFFFF]/),bi=dt(/^aria-[\-\w]+$/),Kt=dt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),vi=dt(/^(?:\w+script|data):/i),Di=dt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),qt=dt(/^html$/i);var jt=Object.freeze({__proto__:null,MUSTACHE_EXPR:fi,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:pi,ARIA_ATTR:bi,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:vi,ATTR_WHITESPACE:Di,DOCTYPE_NAME:qt});const wi=()=>typeof window>"u"?null:window,yi=function(e,S){if(typeof e!="object"||typeof e.createPolicy!="function")return null;let F=null;const n="data-tt-policy-suffix";S&&S.hasAttribute(n)&&(F=S.getAttribute(n));const U="dompurify"+(F?"#"+F:"");try{return e.createPolicy(U,{createHTML(y){return y},createScriptURL(y){return y}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Gt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:wi();const e=We=>Gt(We);if(e.version="3.0.5",e.removed=[],!se||!se.document||se.document.nodeType!==9)return e.isSupported=!1,e;const S=se.document,F=S.currentScript;let{document:n}=se;const{DocumentFragment:U,HTMLTemplateElement:y,Node:A,Element:p,NodeFilter:b,NamedNodeMap:v=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:O,DOMParser:l,trustedTypes:d}=se,t=p.prototype,s=Ct(t,"cloneNode"),h=Ct(t,"nextSibling"),g=Ct(t,"childNodes"),c=Ct(t,"parentNode");if(typeof y=="function"){const We=n.createElement("template");We.content&&We.content.ownerDocument&&(n=We.content.ownerDocument)}let D,u="";const{implementation:m,createNodeIterator:a,createDocumentFragment:E,getElementsByTagName:k}=n,{importNode:N}=S;let H={};e.isSupported=typeof Wt=="function"&&typeof c=="function"&&m&&m.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:W,ERB_EXPR:_,TMPLIT_EXPR:B,DATA_ATTR:z,ARIA_ATTR:T,IS_SCRIPT_OR_DATA:P,ATTR_WHITESPACE:M}=jt;let{IS_ALLOWED_URI:Y}=jt,Z=null;const fe=ze({},[...zt,...kt,...Mt,...Pt,...Ut]);let ce=null;const te=ze({},[...$t,...Rt,...Vt,...At]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),ke=null,Le=null,Be=!0,le=!0,J=!1,ae=!0,re=!1,X=!1,j=!1,ie=!1,de=!1,Ee=!1,Ie=!1,Ce=!0,K=!1;const f="user-content-";let C=!0,I=!1,r={},i=null;const o=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let w=null;const R=ze({},["audio","video","img","source","image","track"]);let L=null;const x=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),V="http://www.w3.org/1998/Math/MathML",Q="http://www.w3.org/2000/svg",oe="http://www.w3.org/1999/xhtml";let pe=oe,ye=!1,we=null;const Ae=ze({},[V,Q,oe],Nt);let De;const Fe=["application/xhtml+xml","text/html"],Pe="text/html";let Re,Ze=null;const nt=n.createElement("form"),je=function(ue){return ue instanceof RegExp||ue instanceof Function},Qe=function(ue){if(!(Ze&&Ze===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),De=Fe.indexOf(ue.PARSER_MEDIA_TYPE)===-1?De=Pe:De=ue.PARSER_MEDIA_TYPE,Re=De==="application/xhtml+xml"?Nt:St,Z="ALLOWED_TAGS"in ue?ze({},ue.ALLOWED_TAGS,Re):fe,ce="ALLOWED_ATTR"in ue?ze({},ue.ALLOWED_ATTR,Re):te,we="ALLOWED_NAMESPACES"in ue?ze({},ue.ALLOWED_NAMESPACES,Nt):Ae,L="ADD_URI_SAFE_ATTR"in ue?ze(bt(x),ue.ADD_URI_SAFE_ATTR,Re):x,w="ADD_DATA_URI_TAGS"in ue?ze(bt(R),ue.ADD_DATA_URI_TAGS,Re):R,i="FORBID_CONTENTS"in ue?ze({},ue.FORBID_CONTENTS,Re):o,ke="FORBID_TAGS"in ue?ze({},ue.FORBID_TAGS,Re):{},Le="FORBID_ATTR"in ue?ze({},ue.FORBID_ATTR,Re):{},r="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Be=ue.ALLOW_ARIA_ATTR!==!1,le=ue.ALLOW_DATA_ATTR!==!1,J=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=ue.SAFE_FOR_TEMPLATES||!1,X=ue.WHOLE_DOCUMENT||!1,de=ue.RETURN_DOM||!1,Ee=ue.RETURN_DOM_FRAGMENT||!1,Ie=ue.RETURN_TRUSTED_TYPE||!1,ie=ue.FORCE_BODY||!1,Ce=ue.SANITIZE_DOM!==!1,K=ue.SANITIZE_NAMED_PROPS||!1,C=ue.KEEP_CONTENT!==!1,I=ue.IN_PLACE||!1,Y=ue.ALLOWED_URI_REGEXP||Kt,pe=ue.NAMESPACE||oe,ge=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&je(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&je(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),Ee&&(de=!0),r&&(Z=ze({},[...Ut]),ce=[],r.html===!0&&(ze(Z,zt),ze(ce,$t)),r.svg===!0&&(ze(Z,kt),ze(ce,Rt),ze(ce,At)),r.svgFilters===!0&&(ze(Z,Mt),ze(ce,Rt),ze(ce,At)),r.mathMl===!0&&(ze(Z,Pt),ze(ce,Vt),ze(ce,At))),ue.ADD_TAGS&&(Z===fe&&(Z=bt(Z)),ze(Z,ue.ADD_TAGS,Re)),ue.ADD_ATTR&&(ce===te&&(ce=bt(ce)),ze(ce,ue.ADD_ATTR,Re)),ue.ADD_URI_SAFE_ATTR&&ze(L,ue.ADD_URI_SAFE_ATTR,Re),ue.FORBID_CONTENTS&&(i===o&&(i=bt(i)),ze(i,ue.FORBID_CONTENTS,Re)),C&&(Z["#text"]=!0),X&&ze(Z,["html","head","body"]),Z.table&&(ze(Z,["tbody"]),delete ke.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');D=ue.TRUSTED_TYPES_POLICY,u=D.createHTML("")}else D===void 0&&(D=yi(d,F)),D!==null&&typeof u=="string"&&(u=D.createHTML(""));ot&&ot(ue),Ze=ue}},G=ze({},["mi","mo","mn","ms","mtext"]),ne=ze({},["foreignobject","desc","title","annotation-xml"]),ve=ze({},["title","style","font","a","script"]),_e=ze({},kt);ze(_e,Mt),ze(_e,hi);const Ne=ze({},Pt);ze(Ne,di);const xe=function(ue){let Te=c(ue);(!Te||!Te.tagName)&&(Te={namespaceURI:pe,tagName:"template"});const Me=St(ue.tagName),Ve=St(Te.tagName);return we[ue.namespaceURI]?ue.namespaceURI===Q?Te.namespaceURI===oe?Me==="svg":Te.namespaceURI===V?Me==="svg"&&(Ve==="annotation-xml"||G[Ve]):!!_e[Me]:ue.namespaceURI===V?Te.namespaceURI===oe?Me==="math":Te.namespaceURI===Q?Me==="math"&&ne[Ve]:!!Ne[Me]:ue.namespaceURI===oe?Te.namespaceURI===Q&&!ne[Ve]||Te.namespaceURI===V&&!G[Ve]?!1:!Ne[Me]&&(ve[Me]||!_e[Me]):!!(De==="application/xhtml+xml"&&we[ue.namespaceURI]):!1},$e=function(ue){wt(e.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},Je=function(ue,Te){try{wt(e.removed,{attribute:Te.getAttributeNode(ue),from:Te})}catch{wt(e.removed,{attribute:null,from:Te})}if(Te.removeAttribute(ue),ue==="is"&&!ce[ue])if(de||Ee)try{$e(Te)}catch{}else try{Te.setAttribute(ue,"")}catch{}},tt=function(ue){let Te,Me;if(ie)ue="<remove></remove>"+ue;else{const lt=li(ue,/^[\r\n\t ]+/);Me=lt&&lt[0]}De==="application/xhtml+xml"&&pe===oe&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Ve=D?D.createHTML(ue):ue;if(pe===oe)try{Te=new l().parseFromString(Ve,De)}catch{}if(!Te||!Te.documentElement){Te=m.createDocument(pe,"template",null);try{Te.documentElement.innerHTML=ye?u:Ve}catch{}}const it=Te.body||Te.documentElement;return ue&&Me&&it.insertBefore(n.createTextNode(Me),it.childNodes[0]||null),pe===oe?k.call(Te,X?"html":"body")[0]:X?Te.documentElement:it},st=function(ue){return a.call(ue.ownerDocument||ue,ue,b.SHOW_ELEMENT|b.SHOW_COMMENT|b.SHOW_TEXT,null,!1)},Xe=function(ue){return ue instanceof O&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof v)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof A=="object"?ue instanceof A:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},et=function(ue,Te,Me){H[ue]&&oi(H[ue],Ve=>{Ve.call(e,Te,Me,Ze)})},gt=function(ue){let Te;if(et("beforeSanitizeElements",ue,null),Xe(ue))return $e(ue),!0;const Me=Re(ue.nodeName);if(et("uponSanitizeElement",ue,{tagName:Me,allowedTags:Z}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ut(/<[/\w]/g,ue.innerHTML)&&ut(/<[/\w]/g,ue.textContent))return $e(ue),!0;if(!Z[Me]||ke[Me]){if(!ke[Me]&&pt(Me)&&(ge.tagNameCheck instanceof RegExp&&ut(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me)))return!1;if(C&&!i[Me]){const Ve=c(ue)||ue.parentNode,it=g(ue)||ue.childNodes;if(it&&Ve){const lt=it.length;for(let Ge=lt-1;Ge>=0;--Ge)Ve.insertBefore(s(it[Ge],!0),h(ue))}}return $e(ue),!0}return ue instanceof p&&!xe(ue)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&ut(/<\/no(script|embed|frames)/i,ue.innerHTML)?($e(ue),!0):(re&&ue.nodeType===3&&(Te=ue.textContent,Te=ft(Te,W," "),Te=ft(Te,_," "),Te=ft(Te,B," "),ue.textContent!==Te&&(wt(e.removed,{element:ue.cloneNode()}),ue.textContent=Te)),et("afterSanitizeElements",ue,null),!1)},mt=function(ue,Te,Me){if(Ce&&(Te==="id"||Te==="name")&&(Me in n||Me in nt))return!1;if(!(le&&!Le[Te]&&ut(z,Te))){if(!(Be&&ut(T,Te))){if(!ce[Te]||Le[Te]){if(!(pt(ue)&&(ge.tagNameCheck instanceof RegExp&&ut(ge.tagNameCheck,ue)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ue))&&(ge.attributeNameCheck instanceof RegExp&&ut(ge.attributeNameCheck,Te)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Te))||Te==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ut(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me))))return!1}else if(!L[Te]){if(!ut(Y,ft(Me,M,""))){if(!((Te==="src"||Te==="xlink:href"||Te==="href")&&ue!=="script"&&ai(Me,"data:")===0&&w[ue])){if(!(J&&!ut(P,ft(Me,M,"")))){if(Me)return!1}}}}}}return!0},pt=function(ue){return ue.indexOf("-")>0},Tt=function(ue){let Te,Me,Ve,it;et("beforeSanitizeAttributes",ue,null);const{attributes:lt}=ue;if(!lt)return;const Ge={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ce};for(it=lt.length;it--;){Te=lt[it];const{name:ht,namespaceURI:vt}=Te;if(Me=ht==="value"?Te.value:ui(Te.value),Ve=Re(ht),Ge.attrName=Ve,Ge.attrValue=Me,Ge.keepAttr=!0,Ge.forceKeepAttr=void 0,et("uponSanitizeAttribute",ue,Ge),Me=Ge.attrValue,Ge.forceKeepAttr||(Je(ht,ue),!Ge.keepAttr))continue;if(!ae&&ut(/\/>/i,Me)){Je(ht,ue);continue}re&&(Me=ft(Me,W," "),Me=ft(Me,_," "),Me=ft(Me,B," "));const Et=Re(ue.nodeName);if(mt(Et,Ve,Me)){if(K&&(Ve==="id"||Ve==="name")&&(Je(ht,ue),Me=f+Me),D&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!vt)switch(d.getAttributeType(Et,Ve)){case"TrustedHTML":{Me=D.createHTML(Me);break}case"TrustedScriptURL":{Me=D.createScriptURL(Me);break}}try{vt?ue.setAttributeNS(vt,ht,Me):ue.setAttribute(ht,Me),xt(e.removed)}catch{}}}et("afterSanitizeAttributes",ue,null)},Ot=function We(ue){let Te;const Me=st(ue);for(et("beforeSanitizeShadowDOM",ue,null);Te=Me.nextNode();)et("uponSanitizeShadowNode",Te,null),!gt(Te)&&(Te.content instanceof U&&We(Te.content),Tt(Te));et("afterSanitizeShadowDOM",ue,null)};return e.sanitize=function(We){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Te,Me,Ve,it;if(ye=!We,ye&&(We="<!-->"),typeof We!="string"&&!rt(We))if(typeof We.toString=="function"){if(We=We.toString(),typeof We!="string")throw yt("dirty is not a string, aborting")}else throw yt("toString is not a function");if(!e.isSupported)return We;if(j||Qe(ue),e.removed=[],typeof We=="string"&&(I=!1),I){if(We.nodeName){const ht=Re(We.nodeName);if(!Z[ht]||ke[ht])throw yt("root node is forbidden and cannot be sanitized in-place")}}else if(We instanceof A)Te=tt("<!---->"),Me=Te.ownerDocument.importNode(We,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Te=Me:Te.appendChild(Me);else{if(!de&&!re&&!X&&We.indexOf("<")===-1)return D&&Ie?D.createHTML(We):We;if(Te=tt(We),!Te)return de?null:Ie?u:""}Te&&ie&&$e(Te.firstChild);const lt=st(I?We:Te);for(;Ve=lt.nextNode();)gt(Ve)||(Ve.content instanceof U&&Ot(Ve.content),Tt(Ve));if(I)return We;if(de){if(Ee)for(it=E.call(Te.ownerDocument);Te.firstChild;)it.appendChild(Te.firstChild);else it=Te;return(ce.shadowroot||ce.shadowrootmode)&&(it=N.call(S,it,!0)),it}let Ge=X?Te.outerHTML:Te.innerHTML;return X&&Z["!doctype"]&&Te.ownerDocument&&Te.ownerDocument.doctype&&Te.ownerDocument.doctype.name&&ut(qt,Te.ownerDocument.doctype.name)&&(Ge="<!DOCTYPE "+Te.ownerDocument.doctype.name+`>
`+Ge),re&&(Ge=ft(Ge,W," "),Ge=ft(Ge,_," "),Ge=ft(Ge,B," ")),D&&Ie?D.createHTML(Ge):Ge},e.setConfig=function(We){Qe(We),j=!0},e.clearConfig=function(){Ze=null,j=!1},e.isValidAttribute=function(We,ue,Te){Ze||Qe({});const Me=Re(We),Ve=Re(ue);return mt(Me,Ve,Te)},e.addHook=function(We,ue){typeof ue=="function"&&(H[We]=H[We]||[],wt(H[We],ue))},e.removeHook=function(We){if(H[We])return xt(H[We])},e.removeHooks=function(We){H[We]&&(H[We]=[])},e.removeAllHooks=function(){H={}},e}var Ei=Gt();define("vs/base/browser/dompurify/dompurify",function(){return Ei}),define(me[44],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createFastDomNode=e.FastDomNode=void 0;class S{constructor(y){this.domNode=y,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(y){const A=F(y);this._maxWidth!==A&&(this._maxWidth=A,this.domNode.style.maxWidth=this._maxWidth)}setWidth(y){const A=F(y);this._width!==A&&(this._width=A,this.domNode.style.width=this._width)}setHeight(y){const A=F(y);this._height!==A&&(this._height=A,this.domNode.style.height=this._height)}setTop(y){const A=F(y);this._top!==A&&(this._top=A,this.domNode.style.top=this._top)}setLeft(y){const A=F(y);this._left!==A&&(this._left=A,this.domNode.style.left=this._left)}setBottom(y){const A=F(y);this._bottom!==A&&(this._bottom=A,this.domNode.style.bottom=this._bottom)}setRight(y){const A=F(y);this._right!==A&&(this._right=A,this.domNode.style.right=this._right)}setPaddingTop(y){const A=F(y);this._paddingTop!==A&&(this._paddingTop=A,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(y){const A=F(y);this._paddingLeft!==A&&(this._paddingLeft=A,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(y){const A=F(y);this._paddingBottom!==A&&(this._paddingBottom=A,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(y){const A=F(y);this._paddingRight!==A&&(this._paddingRight=A,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(y){this._fontFamily!==y&&(this._fontFamily=y,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(y){this._fontWeight!==y&&(this._fontWeight=y,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(y){const A=F(y);this._fontSize!==A&&(this._fontSize=A,this.domNode.style.fontSize=this._fontSize)}setFontStyle(y){this._fontStyle!==y&&(this._fontStyle=y,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(y){this._fontFeatureSettings!==y&&(this._fontFeatureSettings=y,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(y){this._fontVariationSettings!==y&&(this._fontVariationSettings=y,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(y){this._textDecoration!==y&&(this._textDecoration=y,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(y){const A=F(y);this._lineHeight!==A&&(this._lineHeight=A,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(y){const A=F(y);this._letterSpacing!==A&&(this._letterSpacing=A,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(y){this._className!==y&&(this._className=y,this.domNode.className=this._className)}toggleClassName(y,A){this.domNode.classList.toggle(y,A),this._className=this.domNode.className}setDisplay(y){this._display!==y&&(this._display=y,this.domNode.style.display=this._display)}setPosition(y){this._position!==y&&(this._position=y,this.domNode.style.position=this._position)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this.domNode.style.visibility=this._visibility)}setColor(y){this._color!==y&&(this._color=y,this.domNode.style.color=this._color)}setBackgroundColor(y){this._backgroundColor!==y&&(this._backgroundColor=y,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(y){this._layerHint!==y&&(this._layerHint=y,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this._boxShadow!==y&&(this._boxShadow=y,this.domNode.style.boxShadow=y)}setContain(y){this._contain!==y&&(this._contain=y,this.domNode.style.contain=this._contain)}setAttribute(y,A){this.domNode.setAttribute(y,A)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}e.FastDomNode=S;function F(U){return typeof U=="number"?`${U}px`:U}function n(U){return new S(U)}e.createFastDomNode=n}),define(me[71],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parentOriginHash=e.IframeUtils=void 0;const S=new WeakMap;function F(A){if(!A.parent||A.parent===A)return null;try{const p=A.location,b=A.parent.location;if(p.origin!=="null"&&b.origin!=="null"&&p.origin!==b.origin)return null}catch{return null}return A.parent}class n{static getSameOriginWindowChain(p){let b=S.get(p);if(!b){b=[],S.set(p,b);let v=p,O;do O=F(v),O?b.push({window:new WeakRef(v),iframeElement:v.frameElement||null}):b.push({window:new WeakRef(v),iframeElement:null}),v=O;while(v)}return b.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(p,b){if(!b||p===b)return{top:0,left:0};let v=0,O=0;const l=this.getSameOriginWindowChain(p);for(const d of l){const t=d.window.deref();if(v+=t?.scrollY??0,O+=t?.scrollX??0,t===b||!d.iframeElement)break;const s=d.iframeElement.getBoundingClientRect();v+=s.top,O+=s.left}return{top:v,left:O}}}e.IframeUtils=n;async function U(A,p){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const b=JSON.stringify({parentOrigin:A,salt:p}),O=new TextEncoder().encode(b),l=await crypto.subtle.digest("sha-256",O);return y(l)}e.parentOriginHash=U;function y(A){const b=Array.from(new Uint8Array(A)).map(v=>v.toString(16).padStart(2,"0")).join("");return BigInt(`0x${b}`).toString(32).padStart(52,"0")}}),define(me[72],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedListVirtualDelegate=e.ListError=e.ListDragOverReactions=e.ListDragOverEffectPosition=e.ListDragOverEffectType=void 0;var S;(function(y){y[y.Copy=0]="Copy",y[y.Move=1]="Move"})(S||(e.ListDragOverEffectType=S={}));var F;(function(y){y.Over="drop-target",y.Before="drop-target-before",y.After="drop-target-after"})(F||(e.ListDragOverEffectPosition=F={})),e.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(A,p){super(`ListError [${A}] ${p}`)}}e.ListError=n;class U{constructor(){this.cache=new WeakMap}getHeight(A){return this.cache.get(A)??this.estimateHeight(A)}setDynamicHeight(A,p){p>0&&this.cache.set(A,p)}}e.CachedListVirtualDelegate=U}),define(me[73],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CombinedSpliceable=void 0;class S{constructor(n){this.spliceables=n}splice(n,U,y){this.spliceables.forEach(A=>A.splice(n,U,y))}}e.CombinedSpliceable=S}),define(me[45],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScrollbarState=void 0;const S=20;class F{constructor(U,y,A,p,b,v){this._scrollbarSize=Math.round(y),this._oppositeScrollbarSize=Math.round(A),this._arrowSize=Math.round(U),this._visibleSize=p,this._scrollSize=b,this._scrollPosition=v,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new F(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(U){const y=Math.round(U);return this._visibleSize!==y?(this._visibleSize=y,this._refreshComputedValues(),!0):!1}setScrollSize(U){const y=Math.round(U);return this._scrollSize!==y?(this._scrollSize=y,this._refreshComputedValues(),!0):!1}setScrollPosition(U){const y=Math.round(U);return this._scrollPosition!==y?(this._scrollPosition=y,this._refreshComputedValues(),!0):!1}setScrollbarSize(U){this._scrollbarSize=Math.round(U)}setOppositeScrollbarSize(U){this._oppositeScrollbarSize=Math.round(U)}static _computeValues(U,y,A,p,b){const v=Math.max(0,A-U),O=Math.max(0,v-2*y),l=p>0&&p>A;if(!l)return{computedAvailableSize:Math.round(v),computedIsNeeded:l,computedSliderSize:Math.round(O),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(S,Math.floor(A*O/p))),t=(O-d)/(p-A),s=b*t;return{computedAvailableSize:Math.round(v),computedIsNeeded:l,computedSliderSize:Math.round(d),computedSliderRatio:t,computedSliderPosition:Math.round(s)}}_refreshComputedValues(){const U=F._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=U.computedAvailableSize,this._computedIsNeeded=U.computedIsNeeded,this._computedSliderSize=U.computedSliderSize,this._computedSliderRatio=U.computedSliderRatio,this._computedSliderPosition=U.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(U){if(!this._computedIsNeeded)return 0;const y=U-this._arrowSize-this._computedSliderSize/2;return Math.round(y/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(U){if(!this._computedIsNeeded)return 0;const y=U-this._arrowSize;let A=this._scrollPosition;return y<this._computedSliderPosition?A-=this._visibleSize:A+=this._visibleSize,A}getDesiredScrollPositionFromDelta(U){if(!this._computedIsNeeded)return 0;const y=this._computedSliderPosition+U;return Math.round(y/this._computedSliderRatio)}}e.ScrollbarState=F}),define(me[26],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WeakMapper=e.TreeError=e.TreeDragOverReactions=e.TreeDragOverBubble=e.TreeMouseEventTarget=e.ObjectTreeElementCollapseState=e.TreeVisibility=void 0;var S;(function(p){p[p.Hidden=0]="Hidden",p[p.Visible=1]="Visible",p[p.Recurse=2]="Recurse"})(S||(e.TreeVisibility=S={}));var F;(function(p){p[p.Expanded=0]="Expanded",p[p.Collapsed=1]="Collapsed",p[p.PreserveOrExpanded=2]="PreserveOrExpanded",p[p.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(F||(e.ObjectTreeElementCollapseState=F={}));var n;(function(p){p[p.Unknown=0]="Unknown",p[p.Twistie=1]="Twistie",p[p.Element=2]="Element",p[p.Filter=3]="Filter"})(n||(e.TreeMouseEventTarget=n={}));var U;(function(p){p[p.Down=0]="Down",p[p.Up=1]="Up"})(U||(e.TreeDragOverBubble=U={})),e.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(p=!1){return{accept:!0,bubble:0,autoExpand:p}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(p=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:p}}};class y extends Error{constructor(b,v){super(`TreeError [${b}] ${v}`)}}e.TreeError=y;class A{constructor(b){this.fn=b,this._map=new WeakMap}map(b){let v=this._map.get(b);return v||(v=this.fn(b),this._map.set(b,v)),v}}e.WeakMapper=A}),define(me[21],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAuxiliaryWindow=e.$window=e.mainWindow=e.ensureCodeWindow=void 0;function S(n,U){const y=n;typeof y.vscodeWindowId!="number"&&Object.defineProperty(y,"vscodeWindowId",{get:()=>U})}e.ensureCodeWindow=S,e.mainWindow=window,e.$window=e.mainWindow;function F(n){return n===e.mainWindow?!1:typeof n?.vscodeWindowId=="number"}e.isAuxiliaryWindow=F}),define(me[74],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function S(s,h,g){const c=F(s,h);if(c!==-1)return s[c]}e.findLast=S;function F(s,h,g=s.length-1){for(let c=g;c>=0;c--){const D=s[c];if(h(D))return c}return-1}e.findLastIdx=F;function n(s,h){const g=U(s,h);return g===-1?void 0:s[g]}e.findLastMonotonous=n;function U(s,h,g=0,c=s.length){let D=g,u=c;for(;D<u;){const m=Math.floor((D+u)/2);h(s[m])?D=m+1:u=m}return D-1}e.findLastIdxMonotonous=U;function y(s,h){const g=A(s,h);return g===s.length?void 0:s[g]}e.findFirstMonotonous=y;function A(s,h,g=0,c=s.length){let D=g,u=c;for(;D<u;){const m=Math.floor((D+u)/2);h(s[m])?u=m:D=m+1}return D}e.findFirstIdxMonotonousOrArrLen=A;function p(s,h,g=0,c=s.length){const D=A(s,h,g,c);return D===s.length?-1:D}e.findFirstIdxMonotonous=p;class b{static{this.assertInvariants=!1}constructor(h){this._array=h,this._findLastMonotonousLastIdx=0}findLastMonotonous(h){if(b.assertInvariants){if(this._prevFindLastPredicate){for(const c of this._array)if(this._prevFindLastPredicate(c)&&!h(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=h}const g=U(this._array,h,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=g+1,g===-1?void 0:this._array[g]}}e.MonotonousArray=b;function v(s,h){if(s.length===0)return;let g=s[0];for(let c=1;c<s.length;c++){const D=s[c];h(D,g)>0&&(g=D)}return g}e.findFirstMaxBy=v;function O(s,h){if(s.length===0)return;let g=s[0];for(let c=1;c<s.length;c++){const D=s[c];h(D,g)>=0&&(g=D)}return g}e.findLastMaxBy=O;function l(s,h){return v(s,(g,c)=>-h(g,c))}e.findFirstMinBy=l;function d(s,h){if(s.length===0)return-1;let g=0;for(let c=1;c<s.length;c++){const D=s[c];h(D,s[g])>0&&(g=c)}return g}e.findMaxIdxBy=d;function t(s,h){for(const g of s){const c=h(g);if(c!==void 0)return c}}e.mapFindFirst=t}),define(me[75],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function S(y,A){const p=Object.create(null);for(const b of y){const v=A(b);let O=p[v];O||(O=p[v]=[]),O.push(b)}return p}e.groupBy=S;function F(y,A){const p=[],b=[];for(const v of y)A.has(v)||p.push(v);for(const v of A)y.has(v)||b.push(v);return{removed:p,added:b}}e.diffSets=F;function n(y,A){const p=[],b=[];for(const[v,O]of y)A.has(v)||p.push(O);for(const[v,O]of A)y.has(v)||b.push(O);return{removed:p,added:b}}e.diffMaps=n;function U(y,A){const p=new Set;for(const b of A)y.has(b)&&p.add(b);return p}e.intersection=U}),define(me[76],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(A,p){const b=Math.pow(10,p);return Math.round(A*b)/b}class F{constructor(p,b,v,O=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,p))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=S(Math.max(Math.min(1,O),0),3)}static equals(p,b){return p.r===b.r&&p.g===b.g&&p.b===b.b&&p.a===b.a}}e.RGBA=F;class n{constructor(p,b,v,O){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=S(Math.max(Math.min(1,b),0),3),this.l=S(Math.max(Math.min(1,v),0),3),this.a=S(Math.max(Math.min(1,O),0),3)}static equals(p,b){return p.h===b.h&&p.s===b.s&&p.l===b.l&&p.a===b.a}static fromRGBA(p){const b=p.r/255,v=p.g/255,O=p.b/255,l=p.a,d=Math.max(b,v,O),t=Math.min(b,v,O);let s=0,h=0;const g=(t+d)/2,c=d-t;if(c>0){switch(h=Math.min(g<=.5?c/(2*g):c/(2-2*g),1),d){case b:s=(v-O)/c+(v<O?6:0);break;case v:s=(O-b)/c+2;break;case O:s=(b-v)/c+4;break}s*=60,s=Math.round(s)}return new n(s,h,g,l)}static _hue2rgb(p,b,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?p+(b-p)*6*v:v<1/2?b:v<2/3?p+(b-p)*(2/3-v)*6:p}static toRGBA(p){const b=p.h/360,{s:v,l:O,a:l}=p;let d,t,s;if(v===0)d=t=s=O;else{const h=O<.5?O*(1+v):O+v-O*v,g=2*O-h;d=n._hue2rgb(g,h,b+1/3),t=n._hue2rgb(g,h,b),s=n._hue2rgb(g,h,b-1/3)}return new F(Math.round(d*255),Math.round(t*255),Math.round(s*255),l)}}e.HSLA=n;class U{constructor(p,b,v,O){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=S(Math.max(Math.min(1,b),0),3),this.v=S(Math.max(Math.min(1,v),0),3),this.a=S(Math.max(Math.min(1,O),0),3)}static equals(p,b){return p.h===b.h&&p.s===b.s&&p.v===b.v&&p.a===b.a}static fromRGBA(p){const b=p.r/255,v=p.g/255,O=p.b/255,l=Math.max(b,v,O),d=Math.min(b,v,O),t=l-d,s=l===0?0:t/l;let h;return t===0?h=0:l===b?h=((v-O)/t%6+6)%6:l===v?h=(O-b)/t+2:h=(b-v)/t+4,new U(Math.round(h*60),s,l,p.a)}static toRGBA(p){const{h:b,s:v,v:O,a:l}=p,d=O*v,t=d*(1-Math.abs(b/60%2-1)),s=O-d;let[h,g,c]=[0,0,0];return b<60?(h=d,g=t):b<120?(h=t,g=d):b<180?(g=d,c=t):b<240?(g=t,c=d):b<300?(h=t,c=d):b<=360&&(h=d,c=t),h=Math.round((h+s)*255),g=Math.round((g+s)*255),c=Math.round((c+s)*255),new F(h,g,c,l)}}e.HSVA=U;class y{static fromHex(p){return y.Format.CSS.parseHex(p)||y.red}static equals(p,b){return!p&&!b?!0:!p||!b?!1:p.equals(b)}get hsla(){return this._hsla?this._hsla:n.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:U.fromRGBA(this.rgba)}constructor(p){if(p)if(p instanceof F)this.rgba=p;else if(p instanceof n)this._hsla=p,this.rgba=n.toRGBA(p);else if(p instanceof U)this._hsva=p,this.rgba=U.toRGBA(p);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(p){return!!p&&F.equals(this.rgba,p.rgba)&&n.equals(this.hsla,p.hsla)&&U.equals(this.hsva,p.hsva)}getRelativeLuminance(){const p=y._relativeLuminanceForComponent(this.rgba.r),b=y._relativeLuminanceForComponent(this.rgba.g),v=y._relativeLuminanceForComponent(this.rgba.b),O=.2126*p+.7152*b+.0722*v;return S(O,4)}static _relativeLuminanceForComponent(p){const b=p/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio(p){const b=this.getRelativeLuminance(),v=p.getRelativeLuminance();return b>v?(b+.05)/(v+.05):(v+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(p){const b=this.getRelativeLuminance(),v=p.getRelativeLuminance();return b>v}isDarkerThan(p){const b=this.getRelativeLuminance(),v=p.getRelativeLuminance();return b<v}lighten(p){return new y(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*p,this.hsla.a))}darken(p){return new y(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*p,this.hsla.a))}transparent(p){const{r:b,g:v,b:O,a:l}=this.rgba;return new y(new F(b,v,O,l*p))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(p){const b=p.rgba,v=this.rgba.a,O=b.a,l=v+O*(1-v);if(l<1e-6)return y.transparent;const d=this.rgba.r*v/l+b.r*O*(1-v)/l,t=this.rgba.g*v/l+b.g*O*(1-v)/l,s=this.rgba.b*v/l+b.b*O*(1-v)/l;return new y(new F(d,t,s,l))}makeOpaque(p){if(this.isOpaque()||p.rgba.a!==1)return this;const{r:b,g:v,b:O,a:l}=this.rgba;return new y(new F(p.rgba.r-l*(p.rgba.r-b),p.rgba.g-l*(p.rgba.g-v),p.rgba.b-l*(p.rgba.b-O),1))}flatten(...p){const b=p.reduceRight((v,O)=>y._flatten(O,v));return y._flatten(this,b)}static _flatten(p,b){const v=1-p.rgba.a;return new y(new F(v*b.rgba.r+p.rgba.a*p.rgba.r,v*b.rgba.g+p.rgba.a*p.rgba.g,v*b.rgba.b+p.rgba.a*p.rgba.b))}toString(){return this._toString||(this._toString=y.Format.CSS.format(this)),this._toString}static getLighterColor(p,b,v){if(p.isLighterThan(b))return p;v=v||.5;const O=p.getRelativeLuminance(),l=b.getRelativeLuminance();return v=v*(l-O)/l,p.lighten(v)}static getDarkerColor(p,b,v){if(p.isDarkerThan(b))return p;v=v||.5;const O=p.getRelativeLuminance(),l=b.getRelativeLuminance();return v=v*(O-l)/O,p.darken(v)}static{this.white=new y(new F(255,255,255,1))}static{this.black=new y(new F(0,0,0,1))}static{this.red=new y(new F(255,0,0,1))}static{this.blue=new y(new F(0,0,255,1))}static{this.green=new y(new F(0,255,0,1))}static{this.cyan=new y(new F(0,255,255,1))}static{this.lightgrey=new y(new F(211,211,211,1))}static{this.transparent=new y(new F(0,0,0,0))}}e.Color=y,function(A){let p;(function(b){let v;(function(O){function l(a){return a.rgba.a===1?`rgb(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b})`:A.Format.CSS.formatRGBA(a)}O.formatRGB=l;function d(a){return`rgba(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b}, ${+a.rgba.a.toFixed(2)})`}O.formatRGBA=d;function t(a){return a.hsla.a===1?`hsl(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(a)}O.formatHSL=t;function s(a){return`hsla(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%, ${a.hsla.a.toFixed(2)})`}O.formatHSLA=s;function h(a){const E=a.toString(16);return E.length!==2?"0"+E:E}function g(a){return`#${h(a.rgba.r)}${h(a.rgba.g)}${h(a.rgba.b)}`}O.formatHex=g;function c(a,E=!1){return E&&a.rgba.a===1?A.Format.CSS.formatHex(a):`#${h(a.rgba.r)}${h(a.rgba.g)}${h(a.rgba.b)}${h(Math.round(a.rgba.a*255))}`}O.formatHexA=c;function D(a){return a.isOpaque()?A.Format.CSS.formatHex(a):A.Format.CSS.formatRGBA(a)}O.format=D;function u(a){const E=a.length;if(E===0||a.charCodeAt(0)!==35)return null;if(E===7){const k=16*m(a.charCodeAt(1))+m(a.charCodeAt(2)),N=16*m(a.charCodeAt(3))+m(a.charCodeAt(4)),H=16*m(a.charCodeAt(5))+m(a.charCodeAt(6));return new A(new F(k,N,H,1))}if(E===9){const k=16*m(a.charCodeAt(1))+m(a.charCodeAt(2)),N=16*m(a.charCodeAt(3))+m(a.charCodeAt(4)),H=16*m(a.charCodeAt(5))+m(a.charCodeAt(6)),W=16*m(a.charCodeAt(7))+m(a.charCodeAt(8));return new A(new F(k,N,H,W/255))}if(E===4){const k=m(a.charCodeAt(1)),N=m(a.charCodeAt(2)),H=m(a.charCodeAt(3));return new A(new F(16*k+k,16*N+N,16*H+H))}if(E===5){const k=m(a.charCodeAt(1)),N=m(a.charCodeAt(2)),H=m(a.charCodeAt(3)),W=m(a.charCodeAt(4));return new A(new F(16*k+k,16*N+N,16*H+H,(16*W+W)/255))}return null}O.parseHex=u;function m(a){switch(a){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=b.CSS||(b.CSS={}))})(p=A.Format||(A.Format={}))}(y||(e.Color=y={}))}),define(me[27],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(y){return(A,p,b)=>{let v=null,O=null;if(typeof b.value=="function"?(v="value",O=b.value):typeof b.get=="function"&&(v="get",O=b.get),!O)throw new Error("not supported");b[v]=y(O,p)}}function F(y,A,p){let b=null,v=null;if(typeof p.value=="function"?(b="value",v=p.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(b="get",v=p.get),!v)throw new Error("not supported");const O=`$memoize$${A}`;p[b]=function(...l){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,l)}),this[O]}}e.memoize=F;function n(y,A,p){return S((b,v)=>{const O=`$debounce$${v}`,l=`$debounce$result$${v}`;return function(...d){this[l]||(this[l]=p?p():void 0),clearTimeout(this[O]),A&&(this[l]=A(this[l],...d),d=[this[l]]),this[O]=setTimeout(()=>{b.apply(this,d),this[l]=p?p():void 0},y)}})}e.debounce=n;function U(y,A,p){return S((b,v)=>{const O=`$throttle$timer$${v}`,l=`$throttle$result$${v}`,d=`$throttle$lastRun$${v}`,t=`$throttle$pending$${v}`;return function(...s){if(this[l]||(this[l]=p?p():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),A&&(this[l]=A(this[l],...s)),this[t])return;const h=this[d]+y;h<=Date.now()?(this[d]=Date.now(),b.apply(this,[this[l]]),this[l]=p?p():void 0):(this[t]=!0,this[O]=setTimeout(()=>{this[t]=!1,this[d]=Date.now(),b.apply(this,[this[l]]),this[l]=p?p():void 0},h-Date.now()))}})}e.throttle=U}),define(me[77],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiffChange=void 0;class S{constructor(n,U,y,A){this.originalStart=n,this.originalLength=U,this.modifiedStart=y,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}e.DiffChange=S}),define(me[6],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?D.isErrorNoTelemetry(a)?new D(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(E=>{E(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=S,e.errorHandler=new S;function F(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=F;function n(m){if(!m||typeof m!="object")return!1;const a=m;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function U(m){b(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=U;function y(m){b(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=y;function A(m){if(m instanceof Error){const{name:a,message:E}=m,k=m.stacktrace||m.stack;return{$isError:!0,name:a,message:E,stack:k,noTelemetry:D.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=A;const p="Canceled";function b(m){return m instanceof v?!0:m instanceof Error&&m.name===p&&m.message===p}e.isCancellationError=b;class v extends Error{constructor(){super(p),this.name=this.message}}e.CancellationError=v;function O(){const m=new Error(p);return m.name=m.message,m}e.canceled=O;function l(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=l;function d(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=d;class t extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=t;function s(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=s;class h extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=h;class g extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=g;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=c;class D extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof D)return a;const E=new D;return E.message=a.message,E.stack=a.stack,E}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class u extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.BugIndicatingError=u}),define(me[12],be([1,0,6,74]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(K,f=0){return K[K.length-(1+f)]}e.tail=n;function U(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=U;function y(K,f,C=(I,r)=>I===r){if(K===f)return!0;if(!K||!f||K.length!==f.length)return!1;for(let I=0,r=K.length;I<r;I++)if(!C(K[I],f[I]))return!1;return!0}e.equals=y;function A(K,f){const C=K.length-1;f<C&&(K[f]=K[C]),K.pop()}e.removeFastWithoutKeepingOrder=A;function p(K,f,C){return b(K.length,I=>C(K[I],f))}e.binarySearch=p;function b(K,f){let C=0,I=K-1;for(;C<=I;){const r=(C+I)/2|0,i=f(r);if(i<0)C=r+1;else if(i>0)I=r-1;else return r}return-(C+1)}e.binarySearch2=b;function v(K,f,C){if(K=K|0,K>=f.length)throw new TypeError("invalid index");const I=f[Math.floor(f.length*Math.random())],r=[],i=[],o=[];for(const w of f){const R=C(w,I);R<0?r.push(w):R>0?i.push(w):o.push(w)}return K<r.length?v(K,r,C):K<r.length+o.length?o[0]:v(K-(r.length+o.length),i,C)}e.quickSelect=v;function O(K,f){const C=[];let I;for(const r of K.slice(0).sort(f))!I||f(I[0],r)!==0?(I=[r],C.push(I)):I.push(r);return C}e.groupBy=O;function*l(K,f){let C,I;for(const r of K)I!==void 0&&f(I,r)?C.push(r):(C&&(yield C),C=[r]),I=r;C&&(yield C)}e.groupAdjacentBy=l;function d(K,f){for(let C=0;C<=K.length;C++)f(C===0?void 0:K[C-1],C===K.length?void 0:K[C])}e.forEachAdjacent=d;function t(K,f){for(let C=0;C<K.length;C++)f(C===0?void 0:K[C-1],K[C],C+1===K.length?void 0:K[C+1])}e.forEachWithNeighbors=t;function s(K,f,C){const I=[];function r(w,R,L){if(R===0&&L.length===0)return;const x=I[I.length-1];x&&x.start+x.deleteCount===w?(x.deleteCount+=R,x.toInsert.push(...L)):I.push({start:w,deleteCount:R,toInsert:L})}let i=0,o=0;for(;;){if(i===K.length){r(i,0,f.slice(o));break}if(o===f.length){r(i,K.length-i,[]);break}const w=K[i],R=f[o],L=C(w,R);L===0?(i+=1,o+=1):L<0?(r(i,1,[]),i+=1):L>0&&(r(i,0,[R]),o+=1)}return I}e.sortedDiff=s;function h(K,f,C){const I=s(K,f,C),r=[],i=[];for(const o of I)r.push(...K.slice(o.start,o.start+o.deleteCount)),i.push(...o.toInsert);return{removed:r,added:i}}e.delta=h;function g(K,f,C){if(C===0)return[];const I=K.slice(0,C).sort(f);return D(K,f,I,C,K.length),I}e.top=g;function c(K,f,C,I,r){return C===0?Promise.resolve([]):new Promise((i,o)=>{(async()=>{const w=K.length,R=K.slice(0,C).sort(f);for(let L=C,x=Math.min(C+I,w);L<w;L=x,x=Math.min(x+I,w)){if(L>C&&await new Promise(V=>setTimeout(V)),r&&r.isCancellationRequested)throw new S.CancellationError;D(K,f,R,L,x)}return R})().then(i,o)})}e.topAsync=c;function D(K,f,C,I,r){for(const i=C.length;I<r;I++){const o=K[I];if(f(o,C[i-1])<0){C.pop();const w=(0,F.findFirstIdxMonotonousOrArrLen)(C,R=>f(o,R)<0);C.splice(w,0,o)}}}function u(K){return K.filter(f=>!!f)}e.coalesce=u;function m(K){let f=0;for(let C=0;C<K.length;C++)K[C]&&(K[f]=K[C],f+=1);K.length=f}e.coalesceInPlace=m;function a(K,f,C){K.splice(C,0,K.splice(f,1)[0])}e.move=a;function E(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=E;function k(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=k;function N(K,f=C=>C){const C=new Set;return K.filter(I=>{const r=f(I);return C.has(r)?!1:(C.add(r),!0)})}e.distinct=N;function H(K){const f=new Set;return C=>{const I=K(C);return f.has(I)?!1:(f.add(I),!0)}}e.uniqueFilter=H;function W(K,f){return K.length>0?K[0]:f}e.firstOrDefault=W;function _(K,f){return K.length>0?K[K.length-1]:f}e.lastOrDefault=_;function B(K,f,C=(I,r)=>I===r){let I=0;for(let r=0,i=Math.min(K.length,f.length);r<i&&C(K[r],f[r]);r++)I++;return I}e.commonPrefixLength=B;function z(K){return[].concat(...K)}e.flatten=z;function T(K,f){let C=typeof f=="number"?K:0;typeof f=="number"?C=K:(C=0,f=K);const I=[];if(C<=f)for(let r=C;r<f;r++)I.push(r);else for(let r=C;r>f;r--)I.push(r);return I}e.range=T;function P(K,f,C){return K.reduce((I,r)=>(I[f(r)]=C?C(r):r,I),Object.create(null))}e.index=P;function M(K,f){return K.push(f),()=>Y(K,f)}e.insert=M;function Y(K,f){const C=K.indexOf(f);if(C>-1)return K.splice(C,1),f}e.remove=Y;function Z(K,f,C){const I=K.slice(0,f),r=K.slice(f);return I.concat(C,r)}e.arrayInsert=Z;function fe(K,f){let C;if(typeof f=="number"){let I=f;C=()=>{const r=Math.sin(I++)*179426549;return r-Math.floor(r)}}else C=Math.random;for(let I=K.length-1;I>0;I-=1){const r=Math.floor(C()*(I+1)),i=K[I];K[I]=K[r],K[r]=i}}e.shuffle=fe;function ce(K,f){const C=K.indexOf(f);C>-1&&(K.splice(C,1),K.unshift(f))}e.pushToStart=ce;function te(K,f){const C=K.indexOf(f);C>-1&&(K.splice(C,1),K.push(f))}e.pushToEnd=te;function ge(K,f){for(const C of f)K.push(C)}e.pushMany=ge;function ke(K,f){return Array.isArray(K)?K.map(f):f(K)}e.mapArrayOrNot=ke;function Le(K){return Array.isArray(K)?K:[K]}e.asArray=Le;function Be(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=Be;function le(K,f,C){const I=ae(K,f),r=K.length,i=C.length;K.length=r+i;for(let o=r-1;o>=I;o--)K[o+i]=K[o];for(let o=0;o<i;o++)K[o+I]=C[o]}e.insertInto=le;function J(K,f,C,I){const r=ae(K,f);let i=K.splice(r,C);return i===void 0&&(i=[]),le(K,r,I),i}e.splice=J;function ae(K,f){return f<0?Math.max(f+K.length,0):Math.min(f,K.length)}var re;(function(K){function f(i){return i<0}K.isLessThan=f;function C(i){return i<=0}K.isLessThanOrEqual=C;function I(i){return i>0}K.isGreaterThan=I;function r(i){return i===0}K.isNeitherLessOrGreaterThan=r,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function X(K,f){return(C,I)=>f(K(C),K(I))}e.compareBy=X;function j(...K){return(f,C)=>{for(const I of K){const r=I(f,C);if(!re.isNeitherLessOrGreaterThan(r))return r}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const ie=(K,f)=>K-f;e.numberComparator=ie;const de=(K,f)=>(0,e.numberComparator)(K?1:0,f?1:0);e.booleanComparator=de;function Ee(K){return(f,C)=>-K(f,C)}e.reverseOrder=Ee;class Ie{constructor(f){this.items=f,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(f){let C=this.firstIdx;for(;C<this.items.length&&f(this.items[C]);)C++;const I=C===this.firstIdx?null:this.items.slice(this.firstIdx,C);return this.firstIdx=C,I}takeFromEndWhile(f){let C=this.lastIdx;for(;C>=0&&f(this.items[C]);)C--;const I=C===this.lastIdx?null:this.items.slice(C+1,this.lastIdx+1);return this.lastIdx=C,I}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const f=this.items[this.firstIdx];return this.firstIdx++,f}removeLast(){const f=this.items[this.lastIdx];return this.lastIdx--,f}takeCount(f){const C=this.items.slice(this.firstIdx,this.firstIdx+f);return this.firstIdx+=f,C}}e.ArrayQueue=Ie;class Ce{static{this.empty=new Ce(f=>{})}constructor(f){this.iterate=f}forEach(f){this.iterate(C=>(f(C),!0))}toArray(){const f=[];return this.iterate(C=>(f.push(C),!0)),f}filter(f){return new Ce(C=>this.iterate(I=>f(I)?C(I):!0))}map(f){return new Ce(C=>this.iterate(I=>C(f(I))))}some(f){let C=!1;return this.iterate(I=>(C=f(I),!C)),C}findFirst(f){let C;return this.iterate(I=>f(I)?(C=I,!1):!0),C}findLast(f){let C;return this.iterate(I=>(f(I)&&(C=I),!0)),C}findLastMaxBy(f){let C,I=!0;return this.iterate(r=>((I||re.isGreaterThan(f(r,C)))&&(I=!1,C=r),!0)),C}}e.CallbackIterable=Ce}),define(me[78],be([1,0,6]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function F(b,v){if(!b)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=F;function n(b,v="Unreachable"){throw new Error(v)}e.assertNever=n;function U(b){if(!b)throw new S.BugIndicatingError("Assertion Failed")}e.assert=U;function y(b){b||(0,S.onUnexpectedError)(new S.BugIndicatingError("Soft Assertion Failed"))}e.softAssert=y;function A(b){if(!b()){debugger;b(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function p(b,v){let O=0;for(;O<b.length-1;){const l=b[O],d=b[O+1];if(!v(l,d))return!1;O++}return!0}e.checkAdjacentItems=p}),define(me[46],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function S(F,n){const U=this;let y=!1,A;return function(){if(y)return A;if(y=!0,n)try{A=F.apply(U,arguments)}finally{n()}else A=F.apply(U,arguments);return A}}e.createSingleCallFunction=S}),define(me[79],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class S{constructor(n){this._prefix=n,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=S,e.defaultGenerator=new S("id#")}),define(me[28],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(F){function n(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=n;const U=Object.freeze([]);function y(){return U}F.empty=y;function*A(a){yield a}F.single=A;function p(a){return n(a)?a:A(a)}F.wrap=p;function b(a){return a||U}F.from=b;function*v(a){for(let E=a.length-1;E>=0;E--)yield a[E]}F.reverse=v;function O(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=O;function l(a){return a[Symbol.iterator]().next().value}F.first=l;function d(a,E){for(const k of a)if(E(k))return!0;return!1}F.some=d;function t(a,E){for(const k of a)if(E(k))return k}F.find=t;function*s(a,E){for(const k of a)E(k)&&(yield k)}F.filter=s;function*h(a,E){let k=0;for(const N of a)yield E(N,k++)}F.map=h;function*g(...a){for(const E of a)yield*E}F.concat=g;function c(a,E,k){let N=k;for(const H of a)N=E(N,H);return N}F.reduce=c;function*D(a,E,k=a.length){for(E<0&&(E+=a.length),k<0?k+=a.length:k>a.length&&(k=a.length);E<k;E++)yield a[E]}F.slice=D;function u(a,E=Number.POSITIVE_INFINITY){const k=[];if(E===0)return[k,a];const N=a[Symbol.iterator]();for(let H=0;H<E;H++){const W=N.next();if(W.done)return[k,F.empty()];k.push(W.value)}return[k,{[Symbol.iterator](){return N}}]}F.consume=u;async function m(a){const E=[];for await(const k of a)E.push(k);return Promise.resolve(E)}F.asyncToArray=m})(S||(e.Iterable=S={}))}),define(me[47],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var S;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(S||(e.KeyCode=S={}));var F;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(F||(e.ScanCode=F={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,h){this._keyCodeToStr[s]=h,this._strToKeyCode[h.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const U=new n,y=new n,A=new n;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const p=[],b=Object.create(null),v=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>v[t]||0,toEnum:t=>b[t]||0,toString:t=>p[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=132;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[1,1,"Hyper",0,t,0,t,t,t],[1,2,"Super",0,t,0,t,t,t],[1,3,"Fn",0,t,0,t,t,t],[1,4,"FnLock",0,t,0,t,t,t],[1,5,"Suspend",0,t,0,t,t,t],[1,6,"Resume",0,t,0,t,t,t],[1,7,"Turbo",0,t,0,t,t,t],[1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[1,9,"WakeUp",0,t,0,t,t,t],[0,10,"KeyA",31,"A",65,"VK_A",t,t],[0,11,"KeyB",32,"B",66,"VK_B",t,t],[0,12,"KeyC",33,"C",67,"VK_C",t,t],[0,13,"KeyD",34,"D",68,"VK_D",t,t],[0,14,"KeyE",35,"E",69,"VK_E",t,t],[0,15,"KeyF",36,"F",70,"VK_F",t,t],[0,16,"KeyG",37,"G",71,"VK_G",t,t],[0,17,"KeyH",38,"H",72,"VK_H",t,t],[0,18,"KeyI",39,"I",73,"VK_I",t,t],[0,19,"KeyJ",40,"J",74,"VK_J",t,t],[0,20,"KeyK",41,"K",75,"VK_K",t,t],[0,21,"KeyL",42,"L",76,"VK_L",t,t],[0,22,"KeyM",43,"M",77,"VK_M",t,t],[0,23,"KeyN",44,"N",78,"VK_N",t,t],[0,24,"KeyO",45,"O",79,"VK_O",t,t],[0,25,"KeyP",46,"P",80,"VK_P",t,t],[0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[0,27,"KeyR",48,"R",82,"VK_R",t,t],[0,28,"KeyS",49,"S",83,"VK_S",t,t],[0,29,"KeyT",50,"T",84,"VK_T",t,t],[0,30,"KeyU",51,"U",85,"VK_U",t,t],[0,31,"KeyV",52,"V",86,"VK_V",t,t],[0,32,"KeyW",53,"W",87,"VK_W",t,t],[0,33,"KeyX",54,"X",88,"VK_X",t,t],[0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[0,36,"Digit1",22,"1",49,"VK_1",t,t],[0,37,"Digit2",23,"2",50,"VK_2",t,t],[0,38,"Digit3",24,"3",51,"VK_3",t,t],[0,39,"Digit4",25,"4",52,"VK_4",t,t],[0,40,"Digit5",26,"5",53,"VK_5",t,t],[0,41,"Digit6",27,"6",54,"VK_6",t,t],[0,42,"Digit7",28,"7",55,"VK_7",t,t],[0,43,"Digit8",29,"8",56,"VK_8",t,t],[0,44,"Digit9",30,"9",57,"VK_9",t,t],[0,45,"Digit0",21,"0",48,"VK_0",t,t],[1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,t,0,t,t,t],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[1,64,"F1",59,"F1",112,"VK_F1",t,t],[1,65,"F2",60,"F2",113,"VK_F2",t,t],[1,66,"F3",61,"F3",114,"VK_F3",t,t],[1,67,"F4",62,"F4",115,"VK_F4",t,t],[1,68,"F5",63,"F5",116,"VK_F5",t,t],[1,69,"F6",64,"F6",117,"VK_F6",t,t],[1,70,"F7",65,"F7",118,"VK_F7",t,t],[1,71,"F8",66,"F8",119,"VK_F8",t,t],[1,72,"F9",67,"F9",120,"VK_F9",t,t],[1,73,"F10",68,"F10",121,"VK_F10",t,t],[1,74,"F11",69,"F11",122,"VK_F11",t,t],[1,75,"F12",70,"F12",123,"VK_F12",t,t],[1,76,"PrintScreen",0,t,0,t,t,t],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",t,t],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[1,80,"Home",14,"Home",36,"VK_HOME",t,t],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[1,83,"End",13,"End",35,"VK_END",t,t],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",t,t],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",t,t],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",t,t],[1,94,"NumpadEnter",3,t,0,t,t,t],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",t,t],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",t,t],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",t,t],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",t,t],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",t,t],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",t,t],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",t,t],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",t,t],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",t,t],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",t,t],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",t,t],[1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[1,108,"Power",0,t,0,t,t,t],[1,109,"NumpadEqual",0,t,0,t,t,t],[1,110,"F13",71,"F13",124,"VK_F13",t,t],[1,111,"F14",72,"F14",125,"VK_F14",t,t],[1,112,"F15",73,"F15",126,"VK_F15",t,t],[1,113,"F16",74,"F16",127,"VK_F16",t,t],[1,114,"F17",75,"F17",128,"VK_F17",t,t],[1,115,"F18",76,"F18",129,"VK_F18",t,t],[1,116,"F19",77,"F19",130,"VK_F19",t,t],[1,117,"F20",78,"F20",131,"VK_F20",t,t],[1,118,"F21",79,"F21",132,"VK_F21",t,t],[1,119,"F22",80,"F22",133,"VK_F22",t,t],[1,120,"F23",81,"F23",134,"VK_F23",t,t],[1,121,"F24",82,"F24",135,"VK_F24",t,t],[1,122,"Open",0,t,0,t,t,t],[1,123,"Help",0,t,0,t,t,t],[1,124,"Select",0,t,0,t,t,t],[1,125,"Again",0,t,0,t,t,t],[1,126,"Undo",0,t,0,t,t,t],[1,127,"Cut",0,t,0,t,t,t],[1,128,"Copy",0,t,0,t,t,t],[1,129,"Paste",0,t,0,t,t,t],[1,130,"Find",0,t,0,t,t,t],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",t,t],[1,136,"KanaMode",0,t,0,t,t,t],[0,137,"IntlYen",0,t,0,t,t,t],[1,138,"Convert",0,t,0,t,t,t],[1,139,"NonConvert",0,t,0,t,t,t],[1,140,"Lang1",0,t,0,t,t,t],[1,141,"Lang2",0,t,0,t,t,t],[1,142,"Lang3",0,t,0,t,t,t],[1,143,"Lang4",0,t,0,t,t,t],[1,144,"Lang5",0,t,0,t,t,t],[1,145,"Abort",0,t,0,t,t,t],[1,146,"Props",0,t,0,t,t,t],[1,147,"NumpadParenLeft",0,t,0,t,t,t],[1,148,"NumpadParenRight",0,t,0,t,t,t],[1,149,"NumpadBackspace",0,t,0,t,t,t],[1,150,"NumpadMemoryStore",0,t,0,t,t,t],[1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[1,152,"NumpadMemoryClear",0,t,0,t,t,t],[1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",t,t],[1,156,"NumpadClearEntry",0,t,0,t,t,t],[1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[1,0,t,6,"Alt",18,"VK_MENU",t,t],[1,0,t,57,"Meta",91,"VK_COMMAND",t,t],[1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[1,165,"BrightnessUp",0,t,0,t,t,t],[1,166,"BrightnessDown",0,t,0,t,t,t],[1,167,"MediaPlay",0,t,0,t,t,t],[1,168,"MediaRecord",0,t,0,t,t,t],[1,169,"MediaFastForward",0,t,0,t,t,t],[1,170,"MediaRewind",0,t,0,t,t,t],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",t,t],[1,174,"Eject",0,t,0,t,t,t],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[1,180,"SelectTask",0,t,0,t,t,t],[1,181,"LaunchScreenSaver",0,t,0,t,t,t],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[1,189,"ZoomToggle",0,t,0,t,t,t],[1,190,"MailReply",0,t,0,t,t,t],[1,191,"MailForward",0,t,0,t,t,t],[1,192,"MailSend",0,t,0,t,t,t],[1,0,t,114,"KeyInComposition",229,t,t,t],[1,0,t,116,"ABNT_C2",194,"VK_ABNT_C2",t,t],[1,0,t,96,"OEM_8",223,"VK_OEM_8",t,t],[1,0,t,0,t,0,"VK_KANA",t,t],[1,0,t,0,t,0,"VK_HANGUL",t,t],[1,0,t,0,t,0,"VK_JUNJA",t,t],[1,0,t,0,t,0,"VK_FINAL",t,t],[1,0,t,0,t,0,"VK_HANJA",t,t],[1,0,t,0,t,0,"VK_KANJI",t,t],[1,0,t,0,t,0,"VK_CONVERT",t,t],[1,0,t,0,t,0,"VK_NONCONVERT",t,t],[1,0,t,0,t,0,"VK_ACCEPT",t,t],[1,0,t,0,t,0,"VK_MODECHANGE",t,t],[1,0,t,0,t,0,"VK_SELECT",t,t],[1,0,t,0,t,0,"VK_PRINT",t,t],[1,0,t,0,t,0,"VK_EXECUTE",t,t],[1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[1,0,t,0,t,0,"VK_HELP",t,t],[1,0,t,0,t,0,"VK_APPS",t,t],[1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[1,0,t,0,t,0,"VK_PACKET",t,t],[1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[1,0,t,0,t,0,"VK_ATTN",t,t],[1,0,t,0,t,0,"VK_CRSEL",t,t],[1,0,t,0,t,0,"VK_EXSEL",t,t],[1,0,t,0,t,0,"VK_EREOF",t,t],[1,0,t,0,t,0,"VK_PLAY",t,t],[1,0,t,0,t,0,"VK_ZOOM",t,t],[1,0,t,0,t,0,"VK_NONAME",t,t],[1,0,t,0,t,0,"VK_PA1",t,t],[1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],h=[],g=[];for(const c of s){const[D,u,m,a,E,k,N,H,W]=c;if(g[u]||(g[u]=!0,p[u]=m,b[m]=u,v[m.toLowerCase()]=u,D&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[a]=u))),!h[a]){if(h[a]=!0,!E)throw new Error(`String representation missing for key code ${a} around scan code ${m}`);U.define(a,E),y.define(a,H||E),A.define(a,W||H||E)}k&&(e.EVENT_KEY_CODE_MAP[k]=a),N&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[N]=a)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var O;(function(t){function s(m){return U.keyCodeToStr(m)}t.toString=s;function h(m){return U.strToKeyCode(m)}t.fromString=h;function g(m){return y.keyCodeToStr(m)}t.toUserSettingsUS=g;function c(m){return A.keyCodeToStr(m)}t.toUserSettingsGeneral=c;function D(m){return y.strToKeyCode(m)||A.strToKeyCode(m)}t.fromUserSettings=D;function u(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(m)}t.toElectronAccelerator=u})(O||(e.KeyCodeUtils=O={}));var l;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(l||(e.KeyMod=l={}));function d(t,s){const h=(s&65535)<<16>>>0;return(t|h)>>>0}e.KeyChord=d}),define(me[80],be([1,0,6]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedChord=e.Keybinding=e.ScanCodeChord=e.KeyCodeChord=e.createSimpleKeybinding=e.decodeKeybinding=void 0;var F;(function(O){O[O.CtrlCmd=2048]="CtrlCmd",O[O.Shift=1024]="Shift",O[O.Alt=512]="Alt",O[O.WinCtrl=256]="WinCtrl",O[O.KeyCode=255]="KeyCode"})(F||(F={}));function n(O,l){if(typeof O=="number"){if(O===0)return null;const d=(O&65535)>>>0,t=(O&4294901760)>>>16;return t!==0?new p([U(d,l),U(t,l)]):new p([U(d,l)])}else{const d=[];for(let t=0;t<O.length;t++)d.push(U(O[t],l));return new p(d)}}e.decodeKeybinding=n;function U(O,l){const d=!!(O&2048),t=!!(O&256),s=l===2?t:d,h=!!(O&1024),g=!!(O&512),c=l===2?d:t,D=O&255;return new y(s,h,g,c,D)}e.createSimpleKeybinding=U;class y{constructor(l,d,t,s,h){this.ctrlKey=l,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.keyCode=h}equals(l){return l instanceof y&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${l}${d}${t}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new p([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.KeyCodeChord=y;class A{constructor(l,d,t,s,h){this.ctrlKey=l,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.scanCode=h}equals(l){return l instanceof A&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}getHashCode(){const l=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${l}${d}${t}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeChord=A;class p{constructor(l){if(l.length===0)throw(0,S.illegalArgument)("chords");this.chords=l}getHashCode(){let l="";for(let d=0,t=this.chords.length;d<t;d++)d!==0&&(l+=";"),l+=this.chords[d].getHashCode();return l}equals(l){if(l===null||this.chords.length!==l.chords.length)return!1;for(let d=0;d<this.chords.length;d++)if(!this.chords[d].equals(l.chords[d]))return!1;return!0}}e.Keybinding=p;class b{constructor(l,d,t,s,h,g){this.ctrlKey=l,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.keyLabel=h,this.keyAriaLabel=g}}e.ResolvedChord=b;class v{}e.ResolvedKeybinding=v}),define(me[22],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(n){this.executor=n,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(n){this._error=n}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=S}),define(me[29],be([1,0,22]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDefaultHoverDelegate=e.setHoverDelegateFactory=void 0;let n=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const U=new S.Lazy(()=>n("mouse",!1)),y=new S.Lazy(()=>n("element",!1));function A(b){n=b}e.setHoverDelegateFactory=A;function p(b,v){return v?n(b,!0):b==="element"?y.value:U.value}e.getDefaultHoverDelegate=p}),define(me[48],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{static{this.Undefined=new S(void 0)}constructor(U){this.element=U,this.next=S.Undefined,this.prev=S.Undefined}}class F{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let U=this._first;for(;U!==S.Undefined;){const y=U.next;U.prev=S.Undefined,U.next=S.Undefined,U=y}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(U){return this._insert(U,!1)}push(U){return this._insert(U,!0)}_insert(U,y){const A=new S(U);if(this._first===S.Undefined)this._first=A,this._last=A;else if(y){const b=this._last;this._last=A,A.prev=b,b.next=A}else{const b=this._first;this._first=A,A.next=b,b.prev=A}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(A))}}shift(){if(this._first!==S.Undefined){const U=this._first.element;return this._remove(this._first),U}}pop(){if(this._last!==S.Undefined){const U=this._last.element;return this._remove(this._last),U}}_remove(U){if(U.prev!==S.Undefined&&U.next!==S.Undefined){const y=U.prev;y.next=U.next,U.next.prev=y}else U.prev===S.Undefined&&U.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):U.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):U.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let U=this._first;for(;U!==S.Undefined;)yield U.element,U=U.next}}e.LinkedList=F}),define(me[33],be([1,0]),function(se,e){"use strict";var S,F,n;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function U(D,u,m){let a=D.get(u);return a===void 0&&(a=m,D.set(u,a)),a}e.getOrSet=U;function y(D){const u=[];return D.forEach((m,a)=>{u.push(`${a} => ${m}`)}),`Map(${D.size}) {${u.join(", ")}}`}e.mapToString=y;function A(D){const u=[];return D.forEach(m=>{u.push(m)}),`Set(${D.size}) {${u.join(", ")}}`}e.setToString=A;class p{constructor(u,m){this.uri=u,this.value=m}}function b(D){return Array.isArray(D)}class v{static{this.defaultToKey=u=>u.toString()}constructor(u,m){if(this[S]="ResourceMap",u instanceof v)this.map=new Map(u.map),this.toKey=m??v.defaultToKey;else if(b(u)){this.map=new Map,this.toKey=m??v.defaultToKey;for(const[a,E]of u)this.set(a,E)}else this.map=new Map,this.toKey=u??v.defaultToKey}set(u,m){return this.map.set(this.toKey(u),new p(u,m)),this}get(u){return this.map.get(this.toKey(u))?.value}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,m){typeof m<"u"&&(u=u.bind(m));for(const[a,E]of this.map)u(E.value,E.uri,this)}*values(){for(const u of this.map.values())yield u.value}*keys(){for(const u of this.map.values())yield u.uri}*entries(){for(const u of this.map.values())yield[u.uri,u.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.map)yield[u.uri,u.value]}}e.ResourceMap=v;class O{constructor(u,m){this[F]="ResourceSet",!u||typeof u=="function"?this._map=new v(u):(this._map=new v(m),u.forEach(this.add,this))}get size(){return this._map.size}add(u){return this._map.set(u,u),this}clear(){this._map.clear()}delete(u){return this._map.delete(u)}forEach(u,m){this._map.forEach((a,E)=>u.call(m,E,E,this))}has(u){return this._map.has(u)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var l;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(l||(e.Touch=l={}));class d{constructor(){this[n]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(u){return this._map.has(u)}get(u,m=0){const a=this._map.get(u);if(a)return m!==0&&this.touch(a,m),a.value}set(u,m,a=0){let E=this._map.get(u);if(E)E.value=m,a!==0&&this.touch(E,a);else{switch(E={key:u,value:m,next:void 0,previous:void 0},a){case 0:this.addItemLast(E);break;case 1:this.addItemFirst(E);break;case 2:this.addItemLast(E);break;default:this.addItemLast(E);break}this._map.set(u,E),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const m=this._map.get(u);if(m)return this._map.delete(u),this.removeItem(m),this._size--,m.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}forEach(u,m){const a=this._state;let E=this._head;for(;E;){if(m?u.bind(m)(E.value,E.key,this):u(E.value,E.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const u=this,m=this._state;let a=this._head;const E={[Symbol.iterator](){return E},next(){if(u._state!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const k={value:a.key,done:!1};return a=a.next,k}else return{value:void 0,done:!0}}};return E}values(){const u=this,m=this._state;let a=this._head;const E={[Symbol.iterator](){return E},next(){if(u._state!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const k={value:a.value,done:!1};return a=a.next,k}else return{value:void 0,done:!0}}};return E}entries(){const u=this,m=this._state;let a=this._head;const E={[Symbol.iterator](){return E},next(){if(u._state!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const k={value:[a.key,a.value],done:!1};return a=a.next,k}else return{value:void 0,done:!0}}};return E}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(u>=this.size)return;if(u===0){this.clear();return}let m=this._head,a=this.size;for(;m&&a>u;)this._map.delete(m.key),m=m.next,a--;this._head=m,this._size=a,m&&(m.previous=void 0),this._state++}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const m=u.next,a=u.previous;if(!m||!a)throw new Error("Invalid list");m.previous=a,a.next=m}u.next=void 0,u.previous=void 0,this._state++}touch(u,m){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(u===this._head)return;const a=u.next,E=u.previous;u===this._tail?(E.next=void 0,this._tail=E):(a.previous=E,E.next=a),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(m===2){if(u===this._tail)return;const a=u.next,E=u.previous;u===this._head?(a.previous=void 0,this._head=a):(a.previous=E,E.next=a),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((m,a)=>{u.push([a,m])}),u}fromJSON(u){this.clear();for(const[m,a]of u)this.set(m,a)}}e.LinkedMap=d;class t extends d{constructor(u,m=1){super(),this._limit=u,this._ratio=Math.min(Math.max(0,m),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,m=2){return super.get(u,m)}peek(u){return super.get(u,0)}set(u,m){return super.set(u,m,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(){this.map=new Map}add(u){return this.map.set(u,(this.map.get(u)||0)+1),this}delete(u){let m=this.map.get(u)||0;return m===0?!1:(m--,m===0?this.map.delete(u):this.map.set(u,m),!0)}has(u){return this.map.has(u)}}e.CounterSet=s;class h{constructor(u){if(this._m1=new Map,this._m2=new Map,u)for(const[m,a]of u)this.set(m,a)}clear(){this._m1.clear(),this._m2.clear()}set(u,m){this._m1.set(u,m),this._m2.set(m,u)}get(u){return this._m1.get(u)}getKey(u){return this._m2.get(u)}delete(u){const m=this._m1.get(u);return m===void 0?!1:(this._m1.delete(u),this._m2.delete(m),!0)}forEach(u,m){this._m1.forEach((a,E)=>{u.call(m,a,E,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=h;class g{constructor(){this.map=new Map}add(u,m){let a=this.map.get(u);a||(a=new Set,this.map.set(u,a)),a.add(m)}delete(u,m){const a=this.map.get(u);a&&(a.delete(m),a.size===0&&this.map.delete(u))}forEach(u,m){const a=this.map.get(u);a&&a.forEach(m)}get(u){const m=this.map.get(u);return m||new Set}}e.SetMap=g;function c(D,u){if(D===u)return!0;if(D.size!==u.size)return!1;for(const[m,a]of D)if(!u.has(m)||u.get(m)!==a)return!1;for(const[m]of u)if(!D.has(m))return!1;return!0}e.mapsStrictEqualIgnoreOrder=c}),define(me[3],be([1,0,12,75,33,46,28]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const A=!1;let p=null;class b{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(M){let Y=this.livingDisposables.get(M);return Y||(Y={parent:null,source:null,isSingleton:!1,value:M,idx:b.idx++},this.livingDisposables.set(M,Y)),Y}trackDisposable(M){const Y=this.getDisposableData(M);Y.source||(Y.source=new Error().stack)}setParent(M,Y){const Z=this.getDisposableData(M);Z.parent=Y}markAsDisposed(M){this.livingDisposables.delete(M)}markAsSingleton(M){this.getDisposableData(M).isSingleton=!0}getRootParent(M,Y){const Z=Y.get(M);if(Z)return Z;const fe=M.parent?this.getRootParent(this.getDisposableData(M.parent),Y):M;return Y.set(M,fe),fe}getTrackedDisposables(){const M=new Map;return[...this.livingDisposables.entries()].filter(([,Z])=>Z.source!==null&&!this.getRootParent(Z,M).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(M=10,Y){let Z;if(Y)Z=Y;else{const ke=new Map,Le=[...this.livingDisposables.values()].filter(le=>le.source!==null&&!this.getRootParent(le,ke).isSingleton);if(Le.length===0)return;const Be=new Set(Le.map(le=>le.value));if(Z=Le.filter(le=>!(le.parent&&Be.has(le.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function fe(ke){function Le(le,J){for(;le.length>0&&J.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Be=ke.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Le(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const ce=new n.SetMap;for(const ke of Z){const Le=fe(ke);for(let Be=0;Be<=Le.length;Be++)ce.add(Le.slice(0,Be).join(`
`),ke)}Z.sort((0,S.compareBy)(ke=>ke.idx,S.numberComparator));let te="",ge=0;for(const ke of Z.slice(0,M)){ge++;const Le=fe(ke),Be=[];for(let le=0;le<Le.length;le++){let J=Le[le];J=`(shared with ${ce.get(Le.slice(0,le+1).join(`
`)).size}/${Z.length} leaks) at ${J}`;const re=ce.get(Le.slice(0,le).join(`
`)),X=(0,F.groupBy)([...re].map(j=>fe(j)[le]),j=>j);delete X[Le[le]];for(const[j,ie]of Object.entries(X))Be.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${j}`);Be.unshift(J)}te+=`


==================== Leaking disposable ${ge}/${Z.length}: ${ke.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return Z.length>M&&(te+=`


... and ${Z.length-M} more leaking disposables

`),{leaks:Z,details:te}}}e.DisposableTracker=b;function v(P){p=P}if(e.setDisposableTracker=v,A){const P="__is_disposable_tracked__";v(new class{trackDisposable(M){const Y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[P]||console.log(Y)},3e3)}setParent(M,Y){if(M&&M!==a.None)try{M[P]=!0}catch{}}markAsDisposed(M){if(M&&M!==a.None)try{M[P]=!0}catch{}}markAsSingleton(M){}})}function O(P){return p?.trackDisposable(P),P}e.trackDisposable=O;function l(P){p?.markAsDisposed(P)}e.markAsDisposed=l;function d(P,M){p?.setParent(P,M)}function t(P,M){if(p)for(const Y of P)p.setParent(Y,M)}function s(P){return p?.markAsSingleton(P),P}e.markAsSingleton=s;function h(P){return typeof P.dispose=="function"&&P.dispose.length===0}e.isDisposable=h;function g(P){if(y.Iterable.is(P)){const M=[];for(const Y of P)if(Y)try{Y.dispose()}catch(Z){M.push(Z)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}e.dispose=g;function c(P){for(const M of P)h(M)&&M.dispose();return[]}e.disposeIfDisposable=c;function D(...P){const M=u(()=>g(P));return t(P,M),M}e.combinedDisposable=D;function u(P){const M=O({dispose:(0,U.createSingleCallFunction)(()=>{l(M),P()})});return M}e.toDisposable=u;class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,O(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{g(this._toDispose)}finally{this._toDispose.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return d(M,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(M),M.dispose()}}deleteAndLeak(M){M&&this._toDispose.has(M)&&(this._toDispose.delete(M),d(M,null))}}e.DisposableStore=m;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new m,O(this),d(this._store,this)}dispose(){l(this),this._store.dispose()}_register(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(M)}}e.Disposable=a;class E{constructor(){this._isDisposed=!1,O(this)}get value(){return this._isDisposed?void 0:this._value}set value(M){this._isDisposed||M===this._value||(this._value?.dispose(),M&&d(M,this),this._value=M)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const M=this._value;return this._value=void 0,M&&d(M,null),M}}e.MutableDisposable=E;class k{constructor(M){this._disposable=new E,this._isDisposed=!1,this._disposable.value=M}get value(){return this._disposable.value}set value(M){this._isDisposed||M===this._disposable.value||(this._disposable.value=M)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=k;class N{constructor(M){this._disposable=M,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=N;class H{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,O(this)}set(M){let Y=M;return this.unset=()=>Y=void 0,this.isset=()=>Y!==void 0,this.dispose=()=>{Y&&(Y(),Y=void 0,l(this))},this}}e.SafeDisposable=H;class W{constructor(){this.references=new Map}acquire(M,...Y){let Z=this.references.get(M);Z||(Z={counter:0,object:this.createReferencedObject(M,...Y)},this.references.set(M,Z));const{object:fe}=Z,ce=(0,U.createSingleCallFunction)(()=>{--Z.counter===0&&(this.destroyReferencedObject(M,Z.object),this.references.delete(M))});return Z.counter++,{object:fe,dispose:ce}}}e.ReferenceCollection=W;class _{constructor(M){this.referenceCollection=M}async acquire(M,...Y){const Z=this.referenceCollection.acquire(M,...Y);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(fe){throw Z.dispose(),fe}}}e.AsyncReferenceCollection=_;class B{constructor(M){this.object=M}dispose(){}}e.ImmortalReference=B;function z(P){const M=new m;try{P(M)}finally{M.dispose()}}e.disposeOnReturn=z;class T{constructor(){this._store=new Map,this._isDisposed=!1,O(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{g(this._store.values())}finally{this._store.clear()}}has(M){return this._store.has(M)}get size(){return this._store.size}get(M){return this._store.get(M)}set(M,Y,Z=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this._store.get(M)?.dispose(),this._store.set(M,Y)}deleteAndDispose(M){this._store.get(M)?.dispose(),this._store.delete(M)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=T}),function(se,e){typeof define=="function"&&define.amd?define(me[81],be([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(f,C){for(var I=0;I<C.length;I++){var r=C[I];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(f,r.key,r)}}function S(f,C,I){return C&&e(f.prototype,C),I&&e(f,I),Object.defineProperty(f,"prototype",{writable:!1}),f}function F(f,C){if(f){if(typeof f=="string")return n(f,C);var I=Object.prototype.toString.call(f).slice(8,-1);if(I==="Object"&&f.constructor&&(I=f.constructor.name),I==="Map"||I==="Set")return Array.from(f);if(I==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(I))return n(f,C)}}function n(f,C){(C==null||C>f.length)&&(C=f.length);for(var I=0,r=new Array(C);I<C;I++)r[I]=f[I];return r}function U(f,C){var I=typeof Symbol<"u"&&f[Symbol.iterator]||f["@@iterator"];if(I)return(I=I.call(f)).next.bind(I);if(Array.isArray(f)||(I=F(f))||C&&f&&typeof f.length=="number"){I&&(f=I);var r=0;return function(){return r>=f.length?{done:!0}:{done:!1,value:f[r++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=y();function A(f){se.defaults=f}var p=/[&<>"']/,b=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,O=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(C){return l[C]};function t(f,C){if(C){if(p.test(f))return f.replace(b,d)}else if(v.test(f))return f.replace(O,d);return f}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(f){return f.replace(s,function(C,I){return I=I.toLowerCase(),I==="colon"?":":I.charAt(0)==="#"?I.charAt(1)==="x"?String.fromCharCode(parseInt(I.substring(2),16)):String.fromCharCode(+I.substring(1)):""})}var g=/(^|[^\[])\^/g;function c(f,C){f=typeof f=="string"?f:f.source,C=C||"";var I={replace:function(i,o){return o=o.source||o,o=o.replace(g,"$1"),f=f.replace(i,o),I},getRegex:function(){return new RegExp(f,C)}};return I}var D=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(f,C,I){if(f){var r;try{r=decodeURIComponent(h(I)).replace(D,"").toLowerCase()}catch{return null}if(r.indexOf("javascript:")===0||r.indexOf("vbscript:")===0||r.indexOf("data:")===0)return null}C&&!u.test(I)&&(I=H(C,I));try{I=encodeURI(I).replace(/%25/g,"%")}catch{return null}return I}var a={},E=/^[^:]+:\/*[^/]*$/,k=/^([^:]+:)[\s\S]*$/,N=/^([^:]+:\/*[^/]*)[\s\S]*$/;function H(f,C){a[" "+f]||(E.test(f)?a[" "+f]=f+"/":a[" "+f]=z(f,"/",!0)),f=a[" "+f];var I=f.indexOf(":")===-1;return C.substring(0,2)==="//"?I?C:f.replace(k,"$1")+C:C.charAt(0)==="/"?I?C:f.replace(N,"$1")+C:f+C}var W={exec:function(){}};function _(f){for(var C=1,I,r;C<arguments.length;C++){I=arguments[C];for(r in I)Object.prototype.hasOwnProperty.call(I,r)&&(f[r]=I[r])}return f}function B(f,C){var I=f.replace(/\|/g,function(o,w,R){for(var L=!1,x=w;--x>=0&&R[x]==="\\";)L=!L;return L?"|":" |"}),r=I.split(/ \|/),i=0;if(r[0].trim()||r.shift(),r.length>0&&!r[r.length-1].trim()&&r.pop(),r.length>C)r.splice(C);else for(;r.length<C;)r.push("");for(;i<r.length;i++)r[i]=r[i].trim().replace(/\\\|/g,"|");return r}function z(f,C,I){var r=f.length;if(r===0)return"";for(var i=0;i<r;){var o=f.charAt(r-i-1);if(o===C&&!I)i++;else if(o!==C&&I)i++;else break}return f.slice(0,r-i)}function T(f,C){if(f.indexOf(C[1])===-1)return-1;for(var I=f.length,r=0,i=0;i<I;i++)if(f[i]==="\\")i++;else if(f[i]===C[0])r++;else if(f[i]===C[1]&&(r--,r<0))return i;return-1}function P(f){f&&f.sanitize&&!f.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(f,C){if(C<1)return"";for(var I="";C>1;)C&1&&(I+=f),C>>=1,f+=f;return I+f}function Y(f,C,I,r){var i=C.href,o=C.title?t(C.title):null,w=f[1].replace(/\\([\[\]])/g,"$1");if(f[0].charAt(0)!=="!"){r.state.inLink=!0;var R={type:"link",raw:I,href:i,title:o,text:w,tokens:r.inlineTokens(w)};return r.state.inLink=!1,R}return{type:"image",raw:I,href:i,title:o,text:t(w)}}function Z(f,C){var I=f.match(/^(\s+)(?:```)/);if(I===null)return C;var r=I[1];return C.split(`
`).map(function(i){var o=i.match(/^\s+/);if(o===null)return i;var w=o[0];return w.length>=r.length?i.slice(r.length):i}).join(`
`)}var fe=function(){function f(I){this.options=I||se.defaults}var C=f.prototype;return C.space=function(r){var i=this.rules.block.newline.exec(r);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},C.code=function(r){var i=this.rules.block.code.exec(r);if(i){var o=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?o:z(o,`
`)}}},C.fences=function(r){var i=this.rules.block.fences.exec(r);if(i){var o=i[0],w=Z(o,i[3]||"");return{type:"code",raw:o,lang:i[2]?i[2].trim():i[2],text:w}}},C.heading=function(r){var i=this.rules.block.heading.exec(r);if(i){var o=i[2].trim();if(/#$/.test(o)){var w=z(o,"#");(this.options.pedantic||!w||/ $/.test(w))&&(o=w.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:o,tokens:this.lexer.inline(o)}}},C.hr=function(r){var i=this.rules.block.hr.exec(r);if(i)return{type:"hr",raw:i[0]}},C.blockquote=function(r){var i=this.rules.block.blockquote.exec(r);if(i){var o=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(o,[]),text:o}}},C.list=function(r){var i=this.rules.block.list.exec(r);if(i){var o,w,R,L,x,V,Q,oe,pe,ye,we,Ae,De=i[1].trim(),Fe=De.length>1,Pe={type:"list",raw:"",ordered:Fe,start:Fe?+De.slice(0,-1):"",loose:!1,items:[]};De=Fe?"\\d{1,9}\\"+De.slice(-1):"\\"+De,this.options.pedantic&&(De=Fe?De:"[*+-]");for(var Re=new RegExp("^( {0,3}"+De+")((?:[	 ][^\\n]*)?(?:\\n|$))");r&&(Ae=!1,!(!(i=Re.exec(r))||this.rules.block.hr.test(r)));){if(o=i[0],r=r.substring(o.length),oe=i[2].split(`
`,1)[0],pe=r.split(`
`,1)[0],this.options.pedantic?(L=2,we=oe.trimLeft()):(L=i[2].search(/[^ ]/),L=L>4?1:L,we=oe.slice(L),L+=i[1].length),V=!1,!oe&&/^ *$/.test(pe)&&(o+=pe+`
`,r=r.substring(pe.length+1),Ae=!0),!Ae)for(var Ze=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,L-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),je=new RegExp("^ {0,"+Math.min(3,L-1)+"}(?:```|~~~)"),Qe=new RegExp("^ {0,"+Math.min(3,L-1)+"}#");r&&(ye=r.split(`
`,1)[0],oe=ye,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(je.test(oe)||Qe.test(oe)||Ze.test(oe)||nt.test(r)));){if(oe.search(/[^ ]/)>=L||!oe.trim())we+=`
`+oe.slice(L);else if(!V)we+=`
`+oe;else break;!V&&!oe.trim()&&(V=!0),o+=ye+`
`,r=r.substring(ye.length+1)}Pe.loose||(Q?Pe.loose=!0:/\n *\n *$/.test(o)&&(Q=!0)),this.options.gfm&&(w=/^\[[ xX]\] /.exec(we),w&&(R=w[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:o,task:!!w,checked:R,loose:!1,text:we}),Pe.raw+=o}Pe.items[Pe.items.length-1].raw=o.trimRight(),Pe.items[Pe.items.length-1].text=we.trimRight(),Pe.raw=Pe.raw.trimRight();var G=Pe.items.length;for(x=0;x<G;x++){this.lexer.state.top=!1,Pe.items[x].tokens=this.lexer.blockTokens(Pe.items[x].text,[]);var ne=Pe.items[x].tokens.filter(function(_e){return _e.type==="space"}),ve=ne.every(function(_e){for(var Ne=_e.raw.split(""),xe=0,$e=U(Ne),Je;!(Je=$e()).done;){var tt=Je.value;if(tt===`
`&&(xe+=1),xe>1)return!0}return!1});!Pe.loose&&ne.length&&ve&&(Pe.loose=!0,Pe.items[x].loose=!0)}return Pe}},C.html=function(r){var i=this.rules.block.html.exec(r);if(i){var o={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var w=this.options.sanitizer?this.options.sanitizer(i[0]):t(i[0]);o.type="paragraph",o.text=w,o.tokens=this.lexer.inline(w)}return o}},C.def=function(r){var i=this.rules.block.def.exec(r);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var o=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:o,raw:i[0],href:i[2],title:i[3]}}},C.table=function(r){var i=this.rules.block.table.exec(r);if(i){var o={type:"table",header:B(i[1]).map(function(Q){return{text:Q}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(o.header.length===o.align.length){o.raw=i[0];var w=o.align.length,R,L,x,V;for(R=0;R<w;R++)/^ *-+: *$/.test(o.align[R])?o.align[R]="right":/^ *:-+: *$/.test(o.align[R])?o.align[R]="center":/^ *:-+ *$/.test(o.align[R])?o.align[R]="left":o.align[R]=null;for(w=o.rows.length,R=0;R<w;R++)o.rows[R]=B(o.rows[R],o.header.length).map(function(Q){return{text:Q}});for(w=o.header.length,L=0;L<w;L++)o.header[L].tokens=this.lexer.inline(o.header[L].text);for(w=o.rows.length,L=0;L<w;L++)for(V=o.rows[L],x=0;x<V.length;x++)V[x].tokens=this.lexer.inline(V[x].text);return o}}},C.lheading=function(r){var i=this.rules.block.lheading.exec(r);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},C.paragraph=function(r){var i=this.rules.block.paragraph.exec(r);if(i){var o=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:o,tokens:this.lexer.inline(o)}}},C.text=function(r){var i=this.rules.block.text.exec(r);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},C.escape=function(r){var i=this.rules.inline.escape.exec(r);if(i)return{type:"escape",raw:i[0],text:t(i[1])}},C.tag=function(r){var i=this.rules.inline.tag.exec(r);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):t(i[0]):i[0]}},C.link=function(r){var i=this.rules.inline.link.exec(r);if(i){var o=i[2].trim();if(!this.options.pedantic&&/^</.test(o)){if(!/>$/.test(o))return;var w=z(o.slice(0,-1),"\\");if((o.length-w.length)%2===0)return}else{var R=T(i[2],"()");if(R>-1){var L=i[0].indexOf("!")===0?5:4,x=L+i[1].length+R;i[2]=i[2].substring(0,R),i[0]=i[0].substring(0,x).trim(),i[3]=""}}var V=i[2],Q="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);oe&&(V=oe[1],Q=oe[3])}else Q=i[3]?i[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(o)?V=V.slice(1):V=V.slice(1,-1)),Y(i,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},C.reflink=function(r,i){var o;if((o=this.rules.inline.reflink.exec(r))||(o=this.rules.inline.nolink.exec(r))){var w=(o[2]||o[1]).replace(/\s+/g," ");if(w=i[w.toLowerCase()],!w||!w.href){var R=o[0].charAt(0);return{type:"text",raw:R,text:R}}return Y(o,w,o[0],this.lexer)}},C.emStrong=function(r,i,o){o===void 0&&(o="");var w=this.rules.inline.emStrong.lDelim.exec(r);if(w&&!(w[3]&&o.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var R=w[1]||w[2]||"";if(!R||R&&(o===""||this.rules.inline.punctuation.exec(o))){var L=w[0].length-1,x,V,Q=L,oe=0,pe=w[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,i=i.slice(-1*r.length+L);(w=pe.exec(i))!=null;)if(x=w[1]||w[2]||w[3]||w[4]||w[5]||w[6],!!x){if(V=x.length,w[3]||w[4]){Q+=V;continue}else if((w[5]||w[6])&&L%3&&!((L+V)%3)){oe+=V;continue}if(Q-=V,!(Q>0)){if(V=Math.min(V,V+Q+oe),Math.min(L,V)%2){var ye=r.slice(1,L+w.index+V);return{type:"em",raw:r.slice(0,L+w.index+V+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var we=r.slice(2,L+w.index+V-1);return{type:"strong",raw:r.slice(0,L+w.index+V+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},C.codespan=function(r){var i=this.rules.inline.code.exec(r);if(i){var o=i[2].replace(/\n/g," "),w=/[^ ]/.test(o),R=/^ /.test(o)&&/ $/.test(o);return w&&R&&(o=o.substring(1,o.length-1)),o=t(o,!0),{type:"codespan",raw:i[0],text:o}}},C.br=function(r){var i=this.rules.inline.br.exec(r);if(i)return{type:"br",raw:i[0]}},C.del=function(r){var i=this.rules.inline.del.exec(r);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},C.autolink=function(r,i){var o=this.rules.inline.autolink.exec(r);if(o){var w,R;return o[2]==="@"?(w=t(this.options.mangle?i(o[1]):o[1]),R="mailto:"+w):(w=t(o[1]),R=w),{type:"link",raw:o[0],text:w,href:R,tokens:[{type:"text",raw:w,text:w}]}}},C.url=function(r,i){var o;if(o=this.rules.inline.url.exec(r)){var w,R;if(o[2]==="@")w=t(this.options.mangle?i(o[0]):o[0]),R="mailto:"+w;else{var L;do L=o[0],o[0]=this.rules.inline._backpedal.exec(o[0])[0];while(L!==o[0]);w=t(o[0]),o[1]==="www."?R="http://"+w:R=w}return{type:"link",raw:o[0],text:w,href:R,tokens:[{type:"text",raw:w,text:w}]}}},C.inlineText=function(r,i){var o=this.rules.inline.text.exec(r);if(o){var w;return this.lexer.state.inRawBlock?w=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(o[0]):t(o[0]):o[0]:w=t(this.options.smartypants?i(o[0]):o[0]),{type:"text",raw:o[0],text:w}}},f}(),ce={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:W,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ce._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ce._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ce.def=c(ce.def).replace("label",ce._label).replace("title",ce._title).getRegex(),ce.bullet=/(?:[*+-]|\d{1,9}[.)])/,ce.listItemStart=c(/^( *)(bull) */).replace("bull",ce.bullet).getRegex(),ce.list=c(ce.list).replace(/bull/g,ce.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ce.def.source+")").getRegex(),ce._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ce._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ce.html=c(ce.html,"i").replace("comment",ce._comment).replace("tag",ce._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ce.paragraph=c(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.blockquote=c(ce.blockquote).replace("paragraph",ce.paragraph).getRegex(),ce.normal=_({},ce),ce.gfm=_({},ce.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ce.gfm.table=c(ce.gfm.table).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.gfm.paragraph=c(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ce.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.pedantic=_({},ce.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ce._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:W,paragraph:c(ce.normal._paragraph).replace("hr",ce.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ce.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:W,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:W,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=c(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=c(ce._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=c(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=c(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=c(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=c(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=c(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=c(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=c(te.reflink).replace("label",te._label).replace("ref",ce._label).getRegex(),te.nolink=c(te.nolink).replace("ref",ce._label).getRegex(),te.reflinkSearch=c(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=_({},te),te.pedantic=_({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=_({},te.normal,{escape:c(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=c(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=_({},te.gfm,{br:c(te.br).replace("{2,}","*").getRegex(),text:c(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(f){return f.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ke(f){var C="",I,r,i=f.length;for(I=0;I<i;I++)r=f.charCodeAt(I),Math.random()>.5&&(r="x"+r.toString(16)),C+="&#"+r+";";return C}var Le=function(){function f(I){this.tokens=[],this.tokens.links=Object.create(null),this.options=I||se.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var r={block:ce.normal,inline:te.normal};this.options.pedantic?(r.block=ce.pedantic,r.inline=te.pedantic):this.options.gfm&&(r.block=ce.gfm,this.options.breaks?r.inline=te.breaks:r.inline=te.gfm),this.tokenizer.rules=r}f.lex=function(r,i){var o=new f(i);return o.lex(r)},f.lexInline=function(r,i){var o=new f(i);return o.inlineTokens(r)};var C=f.prototype;return C.lex=function(r){r=r.replace(/\r\n|\r/g,`
`),this.blockTokens(r,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},C.blockTokens=function(r,i){var o=this;i===void 0&&(i=[]),this.options.pedantic?r=r.replace(/\t/g,"    ").replace(/^ +$/gm,""):r=r.replace(/^( *)(\t+)/gm,function(Q,oe,pe){return oe+"    ".repeat(pe.length)});for(var w,R,L,x;r;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(w=Q.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.space(r)){r=r.substring(w.raw.length),w.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(w);continue}if(w=this.tokenizer.code(r)){r=r.substring(w.raw.length),R=i[i.length-1],R&&(R.type==="paragraph"||R.type==="text")?(R.raw+=`
`+w.raw,R.text+=`
`+w.text,this.inlineQueue[this.inlineQueue.length-1].src=R.text):i.push(w);continue}if(w=this.tokenizer.fences(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.heading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.hr(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.blockquote(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.list(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.html(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.def(r)){r=r.substring(w.raw.length),R=i[i.length-1],R&&(R.type==="paragraph"||R.type==="text")?(R.raw+=`
`+w.raw,R.text+=`
`+w.raw,this.inlineQueue[this.inlineQueue.length-1].src=R.text):this.tokens.links[w.tag]||(this.tokens.links[w.tag]={href:w.href,title:w.title});continue}if(w=this.tokenizer.table(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.lheading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(L=r,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,oe=r.slice(1),pe=void 0;o.options.extensions.startBlock.forEach(function(ye){pe=ye.call({lexer:this},oe),typeof pe=="number"&&pe>=0&&(Q=Math.min(Q,pe))}),Q<1/0&&Q>=0&&(L=r.substring(0,Q+1))}(),this.state.top&&(w=this.tokenizer.paragraph(L))){R=i[i.length-1],x&&R.type==="paragraph"?(R.raw+=`
`+w.raw,R.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=R.text):i.push(w),x=L.length!==r.length,r=r.substring(w.raw.length);continue}if(w=this.tokenizer.text(r)){r=r.substring(w.raw.length),R=i[i.length-1],R&&R.type==="text"?(R.raw+=`
`+w.raw,R.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=R.text):i.push(w);continue}if(r){var V="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,i},C.inline=function(r,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:r,tokens:i}),i},C.inlineTokens=function(r,i){var o=this;i===void 0&&(i=[]);var w,R,L,x=r,V,Q,oe;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(x))!=null;)pe.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(x=x.slice(0,V.index)+"["+M("a",V[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(x))!=null;)x=x.slice(0,V.index)+"["+M("a",V[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(x))!=null;)x=x.slice(0,V.index)+"++"+x.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;r;)if(Q||(oe=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(w=we.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.escape(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.tag(r)){r=r.substring(w.raw.length),R=i[i.length-1],R&&w.type==="text"&&R.type==="text"?(R.raw+=w.raw,R.text+=w.text):i.push(w);continue}if(w=this.tokenizer.link(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.reflink(r,this.tokens.links)){r=r.substring(w.raw.length),R=i[i.length-1],R&&w.type==="text"&&R.type==="text"?(R.raw+=w.raw,R.text+=w.text):i.push(w);continue}if(w=this.tokenizer.emStrong(r,x,oe)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.codespan(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.br(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.del(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.autolink(r,ke)){r=r.substring(w.raw.length),i.push(w);continue}if(!this.state.inLink&&(w=this.tokenizer.url(r,ke))){r=r.substring(w.raw.length),i.push(w);continue}if(L=r,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ae=r.slice(1),De=void 0;o.options.extensions.startInline.forEach(function(Fe){De=Fe.call({lexer:this},Ae),typeof De=="number"&&De>=0&&(we=Math.min(we,De))}),we<1/0&&we>=0&&(L=r.substring(0,we+1))}(),w=this.tokenizer.inlineText(L,ge)){r=r.substring(w.raw.length),w.raw.slice(-1)!=="_"&&(oe=w.raw.slice(-1)),Q=!0,R=i[i.length-1],R&&R.type==="text"?(R.raw+=w.raw,R.text+=w.text):i.push(w);continue}if(r){var ye="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return i},S(f,null,[{key:"rules",get:function(){return{block:ce,inline:te}}}]),f}(),Be=function(){function f(I){this.options=I||se.defaults}var C=f.prototype;return C.code=function(r,i,o){var w=(i||"").match(/\S*/)[0];if(this.options.highlight){var R=this.options.highlight(r,w);R!=null&&R!==r&&(o=!0,r=R)}return r=r.replace(/\n$/,"")+`
`,w?'<pre><code class="'+this.options.langPrefix+t(w,!0)+'">'+(o?r:t(r,!0))+`</code></pre>
`:"<pre><code>"+(o?r:t(r,!0))+`</code></pre>
`},C.blockquote=function(r){return`<blockquote>
`+r+`</blockquote>
`},C.html=function(r){return r},C.heading=function(r,i,o,w){if(this.options.headerIds){var R=this.options.headerPrefix+w.slug(o);return"<h"+i+' id="'+R+'">'+r+"</h"+i+`>
`}return"<h"+i+">"+r+"</h"+i+`>
`},C.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},C.list=function(r,i,o){var w=i?"ol":"ul",R=i&&o!==1?' start="'+o+'"':"";return"<"+w+R+`>
`+r+"</"+w+`>
`},C.listitem=function(r){return"<li>"+r+`</li>
`},C.checkbox=function(r){return"<input "+(r?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},C.paragraph=function(r){return"<p>"+r+`</p>
`},C.table=function(r,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+r+`</thead>
`+i+`</table>
`},C.tablerow=function(r){return`<tr>
`+r+`</tr>
`},C.tablecell=function(r,i){var o=i.header?"th":"td",w=i.align?"<"+o+' align="'+i.align+'">':"<"+o+">";return w+r+("</"+o+`>
`)},C.strong=function(r){return"<strong>"+r+"</strong>"},C.em=function(r){return"<em>"+r+"</em>"},C.codespan=function(r){return"<code>"+r+"</code>"},C.br=function(){return this.options.xhtml?"<br/>":"<br>"},C.del=function(r){return"<del>"+r+"</del>"},C.link=function(r,i,o){if(r=m(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<a href="'+t(r)+'"';return i&&(w+=' title="'+i+'"'),w+=">"+o+"</a>",w},C.image=function(r,i,o){if(r=m(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<img src="'+r+'" alt="'+o+'"';return i&&(w+=' title="'+i+'"'),w+=this.options.xhtml?"/>":">",w},C.text=function(r){return r},f}(),le=function(){function f(){}var C=f.prototype;return C.strong=function(r){return r},C.em=function(r){return r},C.codespan=function(r){return r},C.del=function(r){return r},C.html=function(r){return r},C.text=function(r){return r},C.link=function(r,i,o){return""+o},C.image=function(r,i,o){return""+o},C.br=function(){return""},f}(),J=function(){function f(){this.seen={}}var C=f.prototype;return C.serialize=function(r){return r.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},C.getNextSafeSlug=function(r,i){var o=r,w=0;if(this.seen.hasOwnProperty(o)){w=this.seen[r];do w++,o=r+"-"+w;while(this.seen.hasOwnProperty(o))}return i||(this.seen[r]=w,this.seen[o]=0),o},C.slug=function(r,i){i===void 0&&(i={});var o=this.serialize(r);return this.getNextSafeSlug(o,i.dryrun)},f}(),ae=function(){function f(I){this.options=I||se.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new J}f.parse=function(r,i){var o=new f(i);return o.parse(r)},f.parseInline=function(r,i){var o=new f(i);return o.parseInline(r)};var C=f.prototype;return C.parse=function(r,i){i===void 0&&(i=!0);var o="",w,R,L,x,V,Q,oe,pe,ye,we,Ae,De,Fe,Pe,Re,Ze,nt,je,Qe,G=r.length;for(w=0;w<G;w++){if(we=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Qe=this.options.extensions.renderers[we.type].call({parser:this},we),Qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){o+=Qe||"";continue}switch(we.type){case"space":continue;case"hr":{o+=this.renderer.hr();continue}case"heading":{o+=this.renderer.heading(this.parseInline(we.tokens),we.depth,h(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{o+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(pe="",oe="",x=we.header.length,R=0;R<x;R++)oe+=this.renderer.tablecell(this.parseInline(we.header[R].tokens),{header:!0,align:we.align[R]});for(pe+=this.renderer.tablerow(oe),ye="",x=we.rows.length,R=0;R<x;R++){for(Q=we.rows[R],oe="",V=Q.length,L=0;L<V;L++)oe+=this.renderer.tablecell(this.parseInline(Q[L].tokens),{header:!1,align:we.align[L]});ye+=this.renderer.tablerow(oe)}o+=this.renderer.table(pe,ye);continue}case"blockquote":{ye=this.parse(we.tokens),o+=this.renderer.blockquote(ye);continue}case"list":{for(Ae=we.ordered,De=we.start,Fe=we.loose,x=we.items.length,ye="",R=0;R<x;R++)Re=we.items[R],Ze=Re.checked,nt=Re.task,Pe="",Re.task&&(je=this.renderer.checkbox(Ze),Fe?Re.tokens.length>0&&Re.tokens[0].type==="paragraph"?(Re.tokens[0].text=je+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=je+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:je}):Pe+=je),Pe+=this.parse(Re.tokens,Fe),ye+=this.renderer.listitem(Pe,nt,Ze);o+=this.renderer.list(ye,Ae,De);continue}case"html":{o+=this.renderer.html(we.text);continue}case"paragraph":{o+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(ye=we.tokens?this.parseInline(we.tokens):we.text;w+1<G&&r[w+1].type==="text";)we=r[++w],ye+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);o+=i?this.renderer.paragraph(ye):ye;continue}default:{var ne='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return o},C.parseInline=function(r,i){i=i||this.renderer;var o="",w,R,L,x=r.length;for(w=0;w<x;w++){if(R=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[R.type]&&(L=this.options.extensions.renderers[R.type].call({parser:this},R),L!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(R.type))){o+=L||"";continue}switch(R.type){case"escape":{o+=i.text(R.text);break}case"html":{o+=i.html(R.text);break}case"link":{o+=i.link(R.href,R.title,this.parseInline(R.tokens,i));break}case"image":{o+=i.image(R.href,R.title,R.text);break}case"strong":{o+=i.strong(this.parseInline(R.tokens,i));break}case"em":{o+=i.em(this.parseInline(R.tokens,i));break}case"codespan":{o+=i.codespan(R.text);break}case"br":{o+=i.br();break}case"del":{o+=i.del(this.parseInline(R.tokens,i));break}case"text":{o+=i.text(R.text);break}default:{var V='Token with "'+R.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return o},f}();function re(f,C,I){if(typeof f>"u"||f===null)throw new Error("marked(): input parameter is undefined or null");if(typeof f!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(f)+", string expected");if(typeof C=="function"&&(I=C,C=null),C=_({},re.defaults,C||{}),P(C),I){var r=C.highlight,i;try{i=Le.lex(f,C)}catch(x){return I(x)}var o=function(V){var Q;if(!V)try{C.walkTokens&&re.walkTokens(i,C.walkTokens),Q=ae.parse(i,C)}catch(oe){V=oe}return C.highlight=r,V?I(V):I(null,Q)};if(!r||r.length<3||(delete C.highlight,!i.length))return o();var w=0;re.walkTokens(i,function(x){x.type==="code"&&(w++,setTimeout(function(){r(x.text,x.lang,function(V,Q){if(V)return o(V);Q!=null&&Q!==x.text&&(x.text=Q,x.escaped=!0),w--,w===0&&o()})},0))}),w===0&&o();return}function R(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,C.silent)return"<p>An error occurred:</p><pre>"+t(x.message+"",!0)+"</pre>";throw x}try{var L=Le.lex(f,C);if(C.walkTokens){if(C.async)return Promise.all(re.walkTokens(L,C.walkTokens)).then(function(){return ae.parse(L,C)}).catch(R);re.walkTokens(L,C.walkTokens)}return ae.parse(L,C)}catch(x){R(x)}}re.options=re.setOptions=function(f){return _(re.defaults,f),A(re.defaults),re},re.getDefaults=y,re.defaults=se.defaults,re.use=function(){for(var f=arguments.length,C=new Array(f),I=0;I<f;I++)C[I]=arguments[I];var r=_.apply(void 0,[{}].concat(C)),i=re.defaults.extensions||{renderers:{},childTokens:{}},o;C.forEach(function(w){if(w.extensions&&(o=!0,w.extensions.forEach(function(L){if(!L.name)throw new Error("extension name required");if(L.renderer){var x=i.renderers?i.renderers[L.name]:null;x?i.renderers[L.name]=function(){for(var V=arguments.length,Q=new Array(V),oe=0;oe<V;oe++)Q[oe]=arguments[oe];var pe=L.renderer.apply(this,Q);return pe===!1&&(pe=x.apply(this,Q)),pe}:i.renderers[L.name]=L.renderer}if(L.tokenizer){if(!L.level||L.level!=="block"&&L.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[L.level]?i[L.level].unshift(L.tokenizer):i[L.level]=[L.tokenizer],L.start&&(L.level==="block"?i.startBlock?i.startBlock.push(L.start):i.startBlock=[L.start]:L.level==="inline"&&(i.startInline?i.startInline.push(L.start):i.startInline=[L.start]))}L.childTokens&&(i.childTokens[L.name]=L.childTokens)})),w.renderer&&function(){var L=re.defaults.renderer||new Be,x=function(oe){var pe=L[oe];L[oe]=function(){for(var ye=arguments.length,we=new Array(ye),Ae=0;Ae<ye;Ae++)we[Ae]=arguments[Ae];var De=w.renderer[oe].apply(L,we);return De===!1&&(De=pe.apply(L,we)),De}};for(var V in w.renderer)x(V);r.renderer=L}(),w.tokenizer&&function(){var L=re.defaults.tokenizer||new fe,x=function(oe){var pe=L[oe];L[oe]=function(){for(var ye=arguments.length,we=new Array(ye),Ae=0;Ae<ye;Ae++)we[Ae]=arguments[Ae];var De=w.tokenizer[oe].apply(L,we);return De===!1&&(De=pe.apply(L,we)),De}};for(var V in w.tokenizer)x(V);r.tokenizer=L}(),w.walkTokens){var R=re.defaults.walkTokens;r.walkTokens=function(L){var x=[];return x.push(w.walkTokens.call(this,L)),R&&(x=x.concat(R.call(this,L))),x}}o&&(r.extensions=i),re.setOptions(r)})},re.walkTokens=function(f,C){for(var I=[],r=function(){var R=o.value;switch(I=I.concat(C.call(re,R)),R.type){case"table":{for(var L=U(R.header),x;!(x=L()).done;){var V=x.value;I=I.concat(re.walkTokens(V.tokens,C))}for(var Q=U(R.rows),oe;!(oe=Q()).done;)for(var pe=oe.value,ye=U(pe),we;!(we=ye()).done;){var Ae=we.value;I=I.concat(re.walkTokens(Ae.tokens,C))}break}case"list":{I=I.concat(re.walkTokens(R.items,C));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[R.type]?re.defaults.extensions.childTokens[R.type].forEach(function(De){I=I.concat(re.walkTokens(R[De],C))}):R.tokens&&(I=I.concat(re.walkTokens(R.tokens,C)))}},i=U(f),o;!(o=i()).done;)r();return I},re.parseInline=function(f,C){if(typeof f>"u"||f===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof f!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(f)+", string expected");C=_({},re.defaults,C||{}),P(C);try{var I=Le.lexInline(f,C);return C.walkTokens&&re.walkTokens(I,C.walkTokens),ae.parseInline(I,C)}catch(r){if(r.message+=`
Please report this to https://github.com/markedjs/marked.`,C.silent)return"<p>An error occurred:</p><pre>"+t(r.message+"",!0)+"</pre>";throw r}},re.Parser=ae,re.parser=ae.parse,re.Renderer=Be,re.TextRenderer=le,re.Lexer=Le,re.lexer=Le.lex,re.Tokenizer=fe,re.Slugger=J,re.parse=re;var X=re.options,j=re.setOptions,ie=re.use,de=re.walkTokens,Ee=re.parseInline,Ie=re,Ce=ae.parse,K=Le.lex;se.Lexer=Le,se.Parser=ae,se.Renderer=Be,se.Slugger=J,se.TextRenderer=le,se.Tokenizer=fe,se.getDefaults=y,se.lexer=K,se.marked=re,se.options=X,se.parse=Ie,se.parseInline=Ee,se.parser=Ce,se.setOptions=j,se.use=ie,se.walkTokens=de,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[82],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function S(s){const h=U(s);if(h&&h.length>0)return new Uint32Array(h)}e.getKoreanAltChars=S;let F=0;const n=new Uint32Array(10);function U(s){if(F=0,y(s,O,4352),F>0||(y(s,l,4449),F>0)||(y(s,d,4520),F>0)||(y(s,t,12593),F))return n.subarray(0,F);if(s>=44032&&s<=55203){const h=s-44032,g=h%588,c=Math.floor(h/588),D=Math.floor(g/28),u=g%28-1;if(c<O.length?y(c,O,0):4352+c-12593<t.length&&y(4352+c,t,12593),D<l.length?y(D,l,0):4449+D-12593<t.length&&y(4449+D-12593,t,12593),u>=0&&(u<d.length?y(u,d,0):4520+u-12593<t.length&&y(4520+u-12593,t,12593)),F>0)return n.subarray(0,F)}}function y(s,h,g){s>=g&&s<g+h.length&&A(h[s-g])}function A(s){s!==0&&(n[F++]=s&255,s>>8&&(n[F++]=s>>8&255),s>>16&&(n[F++]=s>>16&255))}var p;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var b;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(b||(b={}));var v;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(v||(v={}));const O=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),d=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),t=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[83],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayNavigator=void 0;class S{constructor(n,U=0,y=n.length,A=U-1){this.items=n,this.start=U,this.end=y,this.index=A}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}e.ArrayNavigator=S}),define(me[84],be([1,0,83]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HistoryNavigator2=e.HistoryNavigator=void 0;class F{constructor(y=[],A=10){this._initialize(y),this._limit=A,this._onChange()}getHistory(){return this._elements}add(y){this._history.delete(y),this._history.add(y),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(y){return this._history.has(y)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const y=this._elements;this._navigator=new S.ArrayNavigator(y,0,y.length,y.length)}_reduceToLimit(){const y=this._elements;y.length>this._limit&&this._initialize(y.slice(y.length-this._limit))}_currentPosition(){const y=this._navigator.current();return y?this._elements.indexOf(y):-1}_initialize(y){this._history=new Set;for(const A of y)this._history.add(A)}get _elements(){const y=[];return this._history.forEach(A=>y.push(A)),y}}e.HistoryNavigator=F;class n{get size(){return this._size}constructor(y,A=10){if(this.capacity=A,y.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:y[0],previous:void 0,next:void 0},this.valueSet=new Set([y[0]]);for(let p=1;p<y.length;p++)this.add(y[p])}add(y){const A={value:y,previous:this.tail,next:void 0};for(this.tail.next=A,this.tail=A,this.cursor=this.tail,this._size++,this.valueSet.has(y)?this._deleteFromList(y):this.valueSet.add(y);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(y){if(this.tail.value===y)return y;const A=this.tail.value;return this.valueSet.delete(A),this.tail.value=y,this.valueSet.has(y)?this._deleteFromList(y):this.valueSet.add(y),A}prepend(y){if(this._size===this.capacity||this.valueSet.has(y))return;const A={value:y,previous:void 0,next:this.head};this.head.previous=A,this.head=A,this._size++,this.valueSet.add(y)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(y){return this.valueSet.has(y)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let y=this.head;for(;y;)yield y.value,y=y.next}_deleteFromList(y){let A=this.head;for(;A!==this.tail;)A.value===y&&(A===this.head?(this.head=this.head.next,this.head.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this._size--),A=A.next}}e.HistoryNavigator2=n}),define(me[34],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(A,p,b){return Math.min(Math.max(A,p),b)}e.clamp=S;function F(A,p){return(p+A%p)%p}e.rot=F;class n{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=n;class U{constructor(){this._n=1,this._val=0}update(p){return this._val=this._val+(p-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=U;class y{constructor(p){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(p),this._values.fill(0,0,p)}update(p){const b=this._values[this._index];return this._values[this._index]=p,this._index=(this._index+1)%this._values.length,this._sum-=b,this._sum+=p,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),define(me[49],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;var S;(function(F){function n(p,b){if(p.start>=b.end||b.start>=p.end)return{start:0,end:0};const v=Math.max(p.start,b.start),O=Math.min(p.end,b.end);return O-v<=0?{start:0,end:0}:{start:v,end:O}}F.intersect=n;function U(p){return p.end-p.start<=0}F.isEmpty=U;function y(p,b){return!U(n(p,b))}F.intersects=y;function A(p,b){const v=[],O={start:p.start,end:Math.min(b.start,p.end)},l={start:Math.max(b.end,p.start),end:p.end};return U(O)||v.push(O),U(l)||v.push(l),v}F.relativeComplement=A})(S||(e.Range=S={}))}),define(me[85],be([1,0,49]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RangeMap=e.consolidate=e.shift=e.groupIntersect=void 0;function F(p,b){const v=[];for(const O of b){if(p.start>=O.range.end)continue;if(p.end<O.range.start)break;const l=S.Range.intersect(p,O.range);S.Range.isEmpty(l)||v.push({range:l,size:O.size})}return v}e.groupIntersect=F;function n({start:p,end:b},v){return{start:p+v,end:b+v}}e.shift=n;function U(p){const b=[];let v=null;for(const O of p){const l=O.range.start,d=O.range.end,t=O.size;if(v&&t===v.size){v.range.end=d;continue}v={range:{start:l,end:d},size:t},b.push(v)}return b}e.consolidate=U;function y(...p){return U(p.reduce((b,v)=>b.concat(v),[]))}class A{get paddingTop(){return this._paddingTop}set paddingTop(b){this._size=this._size+b-this._paddingTop,this._paddingTop=b}constructor(b){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=b??0,this._size=this._paddingTop}splice(b,v,O=[]){const l=O.length-v,d=F({start:0,end:b},this.groups),t=F({start:b+v,end:Number.POSITIVE_INFINITY},this.groups).map(h=>({range:n(h.range,l),size:h.size})),s=O.map((h,g)=>({range:{start:b+g,end:b+g+1},size:h.size}));this.groups=y(d,s,t),this._size=this._paddingTop+this.groups.reduce((h,g)=>h+g.size*(g.range.end-g.range.start),0)}get count(){const b=this.groups.length;return b?this.groups[b-1].range.end:0}get size(){return this._size}indexAt(b){if(b<0)return-1;if(b<this._paddingTop)return 0;let v=0,O=this._paddingTop;for(const l of this.groups){const d=l.range.end-l.range.start,t=O+d*l.size;if(b<t)return v+Math.floor((b-O)/l.size);v+=d,O=t}return v}indexAfter(b){return Math.min(this.indexAt(b)+1,this.count)}positionAt(b){if(b<0)return-1;let v=0,O=0;for(const l of this.groups){const d=l.range.end-l.range.start,t=O+d;if(b<t)return this._paddingTop+v+(b-O)*l.size;v+=d*l.size,O=t}return-1}}e.RangeMap=A}),define(me[86],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(U){return new F(U)}constructor(U){this._now=S&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=F}),define(me[4],be([1,0,6,46,3,48,86]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,p=!1;var b;(function(z){z.None=()=>n.Disposable.None;function T(r){if(p){const{onDidAddListener:i}=r,o=t.create();let w=0;r.onDidAddListener=()=>{++w===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),o.print()),i?.()}}}function P(r,i){return Be(r,()=>{},0,void 0,!0,void 0,i)}z.defer=P;function M(r){return(i,o=null,w)=>{let R=!1,L;return L=r(x=>{if(!R)return L?L.dispose():R=!0,i.call(o,x)},null,w),R&&L.dispose(),L}}z.once=M;function Y(r,i,o){return ke((w,R=null,L)=>r(x=>w.call(R,i(x)),null,L),o)}z.map=Y;function Z(r,i,o){return ke((w,R=null,L)=>r(x=>{i(x),w.call(R,x)},null,L),o)}z.forEach=Z;function fe(r,i,o){return ke((w,R=null,L)=>r(x=>i(x)&&w.call(R,x),null,L),o)}z.filter=fe;function ce(r){return r}z.signal=ce;function te(...r){return(i,o=null,w)=>{const R=(0,n.combinedDisposable)(...r.map(L=>L(x=>i.call(o,x))));return Le(R,w)}}z.any=te;function ge(r,i,o,w){let R=o;return Y(r,L=>(R=i(R,L),R),w)}z.reduce=ge;function ke(r,i){let o;const w={onWillAddFirstListener(){o=r(R.fire,R)},onDidRemoveLastListener(){o?.dispose()}};i||T(w);const R=new D(w);return i?.add(R),R.event}function Le(r,i){return i instanceof Array?i.push(r):i&&i.add(r),r}function Be(r,i,o=100,w=!1,R=!1,L,x){let V,Q,oe,pe=0,ye;const we={leakWarningThreshold:L,onWillAddFirstListener(){V=r(De=>{pe++,Q=i(Q,De),w&&!oe&&(Ae.fire(Q),Q=void 0),ye=()=>{const Fe=Q;Q=void 0,oe=void 0,(!w||pe>1)&&Ae.fire(Fe),pe=0},typeof o=="number"?(clearTimeout(oe),oe=setTimeout(ye,o)):oe===void 0&&(oe=0,queueMicrotask(ye))})},onWillRemoveListener(){R&&pe>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,V.dispose()}};x||T(we);const Ae=new D(we);return x?.add(Ae),Ae.event}z.debounce=Be;function le(r,i=0,o){return z.debounce(r,(w,R)=>w?(w.push(R),w):[R],i,void 0,!0,void 0,o)}z.accumulate=le;function J(r,i=(w,R)=>w===R,o){let w=!0,R;return fe(r,L=>{const x=w||!i(L,R);return w=!1,R=L,x},o)}z.latch=J;function ae(r,i,o){return[z.filter(r,i,o),z.filter(r,w=>!i(w),o)]}z.split=ae;function re(r,i=!1,o=[],w){let R=o.slice(),L=r(Q=>{R?R.push(Q):V.fire(Q)});w&&w.add(L);const x=()=>{R?.forEach(Q=>V.fire(Q)),R=null},V=new D({onWillAddFirstListener(){L||(L=r(Q=>V.fire(Q)),w&&w.add(L))},onDidAddFirstListener(){R&&(i?setTimeout(x):x())},onDidRemoveLastListener(){L&&L.dispose(),L=null}});return w&&w.add(V),V.event}z.buffer=re;function X(r,i){return(w,R,L)=>{const x=i(new ie);return r(function(V){const Q=x.evaluate(V);Q!==j&&w.call(R,Q)},void 0,L)}}z.chain=X;const j=Symbol("HaltChainable");class ie{constructor(){this.steps=[]}map(i){return this.steps.push(i),this}forEach(i){return this.steps.push(o=>(i(o),o)),this}filter(i){return this.steps.push(o=>i(o)?o:j),this}reduce(i,o){let w=o;return this.steps.push(R=>(w=i(w,R),w)),this}latch(i=(o,w)=>o===w){let o=!0,w;return this.steps.push(R=>{const L=o||!i(R,w);return o=!1,w=R,L?R:j}),this}evaluate(i){for(const o of this.steps)if(i=o(i),i===j)break;return i}}function de(r,i,o=w=>w){const w=(...V)=>x.fire(o(...V)),R=()=>r.on(i,w),L=()=>r.removeListener(i,w),x=new D({onWillAddFirstListener:R,onDidRemoveLastListener:L});return x.event}z.fromNodeEventEmitter=de;function Ee(r,i,o=w=>w){const w=(...V)=>x.fire(o(...V)),R=()=>r.addEventListener(i,w),L=()=>r.removeEventListener(i,w),x=new D({onWillAddFirstListener:R,onDidRemoveLastListener:L});return x.event}z.fromDOMEventEmitter=Ee;function Ie(r){return new Promise(i=>M(r)(i))}z.toPromise=Ie;function Ce(r){const i=new D;return r.then(o=>{i.fire(o)},()=>{i.fire(void 0)}).finally(()=>{i.dispose()}),i.event}z.fromPromise=Ce;function K(r,i,o){return i(o),r(w=>i(w))}z.runAndSubscribe=K;class f{constructor(i,o){this._observable=i,this._counter=0,this._hasChanged=!1;const w={onWillAddFirstListener:()=>{i.addObserver(this)},onDidRemoveLastListener:()=>{i.removeObserver(this)}};o||T(w),this.emitter=new D(w),o&&o.add(this.emitter)}beginUpdate(i){this._counter++}handlePossibleChange(i){}handleChange(i,o){this._hasChanged=!0}endUpdate(i){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function C(r,i){return new f(r,i).emitter.event}z.fromObservable=C;function I(r){return(i,o,w)=>{let R=0,L=!1;const x={beginUpdate(){R++},endUpdate(){R--,R===0&&(r.reportChanges(),L&&(L=!1,i.call(o)))},handlePossibleChange(){},handleChange(){L=!0}};r.addObserver(x),r.reportChanges();const V={dispose(){r.removeObserver(x)}};return w instanceof n.DisposableStore?w.add(V):Array.isArray(w)&&w.push(V),V}}z.fromObservableLight=I})(b||(e.Event=b={}));class v{static{this.all=new Set}static{this._idPool=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${v._idPool++}`,v.all.add(this)}start(T){this._stopWatch=new y.StopWatch,this.listenerCount=T}stop(){if(this._stopWatch){const T=this._stopWatch.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=v;let O=-1;function l(z){const T=O;return O=z,{dispose(){O=T}}}e.setGlobalLeakWarningThreshold=l;class d{constructor(T,P=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=P,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(T,P){const M=this.threshold;if(M<=0||P<M)return;this._stacks||(this._stacks=new Map);const Y=this._stacks.get(T.value)||0;if(this._stacks.set(T.value,Y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let Z,fe=0;for(const[ce,te]of this._stacks)(!Z||fe<te)&&(Z=ce,fe=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${fe}):`),console.warn(Z)}return()=>{const Z=this._stacks.get(T.value)||0;this._stacks.set(T.value,Z-1)}}}class t{static create(){return new t(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class h{constructor(T){this.value=T,this.id=s++}}const g=2,c=(z,T)=>{if(z instanceof h)T(z);else for(let P=0;P<z.length;P++){const M=z[P];M&&T(M)}};class D{constructor(T){this._size=0,this._options=T,this._leakageMon=O>0||this._options?.leakWarningThreshold?new d(this._options?.leakWarningThreshold??O):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(A){const T=this._listeners;queueMicrotask(()=>{c(T,P=>P.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(T,P,M)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;if(this._disposed)return n.Disposable.None;P&&(T=T.bind(P));const Y=new h(T);let Z,fe;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Y.stack=t.create(),Z=this._leakageMon.check(Y.stack,this._size+1)),A&&(Y.stack=fe??t.create()),this._listeners?this._listeners instanceof h?(this._deliveryQueue??=new m,this._listeners=[this._listeners,Y]):this._listeners.push(Y):(this._options?.onWillAddFirstListener?.(this),this._listeners=Y,this._options?.onDidAddFirstListener?.(this)),this._size++;const ce=(0,n.toDisposable)(()=>{Z?.(),this._removeListener(Y)});return M instanceof n.DisposableStore?M.add(ce):Array.isArray(M)&&M.push(ce),ce},this._event}_removeListener(T){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const P=this._listeners,M=P.indexOf(T);if(M===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,P[M]=void 0;const Y=this._deliveryQueue.current===this;if(this._size*g<=P.length){let Z=0;for(let fe=0;fe<P.length;fe++)P[fe]?P[Z++]=P[fe]:Y&&(this._deliveryQueue.end--,Z<this._deliveryQueue.i&&this._deliveryQueue.i--);P.length=Z}}_deliver(T,P){if(!T)return;const M=this._options?.onListenerError||S.onUnexpectedError;if(!M){T.value(P);return}try{T.value(P)}catch(Y){M(Y)}}_deliverQueue(T){const P=T.current._listeners;for(;T.i<T.end;)this._deliver(P[T.i++],T.value);T.reset()}fire(T){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof h)this._deliver(this._listeners,T);else{const P=this._deliveryQueue;P.enqueue(this,T,this._listeners.length),this._deliverQueue(P)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=D;const u=()=>new m;e.createEventDeliveryQueue=u;class m{constructor(){this.i=-1,this.end=0}enqueue(T,P,M){this.i=0,this.end=M,this.current=T,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends D{async fireAsync(T,P,M){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList),c(this._listeners,Y=>this._asyncDeliveryQueue.push([Y.value,T]));this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[Y,Z]=this._asyncDeliveryQueue.shift(),fe=[],ce={...Z,token:P,waitUntil:te=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");M&&(te=M(te,Y)),fe.push(te)}};try{Y(ce)}catch(te){(0,S.onUnexpectedError)(te);continue}Object.freeze(fe),await Promise.allSettled(fe).then(te=>{for(const ge of te)ge.status==="rejected"&&(0,S.onUnexpectedError)(ge.reason)})}}}e.AsyncEmitter=a;class E extends D{get isPaused(){return this._isPaused!==0}constructor(T){super(T),this._isPaused=0,this._eventQueue=new U.LinkedList,this._mergeFn=T?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const T=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(T))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(T){this._size&&(this._isPaused!==0?this._eventQueue.push(T):super.fire(T))}}e.PauseableEmitter=E;class k extends E{constructor(T){super(T),this._delay=T.delay??100}fire(T){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(T)}}e.DebounceEmitter=k;class N extends D{constructor(T){super(T),this._queuedEvents=[],this._mergeFn=T?.merge}fire(T){this.hasListeners()&&(this._queuedEvents.push(T),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=N;class H{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new D({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(T){const P={event:T,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const Y=this.events.indexOf(P);this.events.splice(Y,1)};return(0,n.toDisposable)((0,F.createSingleCallFunction)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(T=>this.hook(T))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(T=>this.unhook(T))}hook(T){T.listener=T.event(P=>this.emitter.fire(P))}unhook(T){T.listener?.dispose(),T.listener=null}dispose(){this.emitter.dispose();for(const T of this.events)T.listener?.dispose();this.events=[]}}e.EventMultiplexer=H;class W{constructor(T,P,M,Y){this._store=new n.DisposableStore;const Z=this._store.add(new H),fe=this._store.add(new n.DisposableMap);function ce(te){fe.set(te,Z.add(Y(te)))}for(const te of T)ce(te);this._store.add(P(te=>{ce(te)})),this._store.add(M(te=>{fe.deleteAndDispose(te)})),this.event=Z.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=W;class _{constructor(){this.buffers=[]}wrapEvent(T){return(P,M,Y)=>T(Z=>{const fe=this.buffers[this.buffers.length-1];fe?fe.push(()=>P.call(M,Z)):P.call(M,Z)},void 0,Y)}bufferEvents(T){const P=[];this.buffers.push(P);const M=T();return this.buffers.pop(),P.forEach(Y=>Y()),M}}e.EventBufferer=_;class B{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=n.Disposable.None,this.emitter=new D({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(T){this.inputEvent=T,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=T(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=B}),define(me[16],be([1,0,21,4]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWCOEnabled=e.isStandalone=e.isAndroid=e.isElectron=e.isWebkitWebView=e.isSafari=e.isChrome=e.isWebKit=e.isFirefox=e.onDidChangeFullscreen=e.isFullscreen=e.setFullscreen=e.setZoomFactor=e.getZoomFactor=e.onDidChangeZoomLevel=e.getZoomLevel=e.setZoomLevel=e.addMatchMediaChangeListener=void 0;class n{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new F.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new F.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new n}getZoomLevel(g){return this.mapWindowIdToZoomLevel.get(this.getWindowId(g))??0}setZoomLevel(g,c){if(this.getZoomLevel(c)===g)return;const D=this.getWindowId(c);this.mapWindowIdToZoomLevel.set(D,g),this._onDidChangeZoomLevel.fire(D)}getZoomFactor(g){return this.mapWindowIdToZoomFactor.get(this.getWindowId(g))??1}setZoomFactor(g,c){this.mapWindowIdToZoomFactor.set(this.getWindowId(c),g)}setFullscreen(g,c){if(this.isFullscreen(c)===g)return;const D=this.getWindowId(c);this.mapWindowIdToFullScreen.set(D,g),this._onDidChangeFullscreen.fire(D)}isFullscreen(g){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(g))}getWindowId(g){return g.vscodeWindowId}}function U(h,g,c){typeof g=="string"&&(g=h.matchMedia(g)),g.addEventListener("change",c)}e.addMatchMediaChangeListener=U;function y(h,g){n.INSTANCE.setZoomLevel(h,g)}e.setZoomLevel=y;function A(h){return n.INSTANCE.getZoomLevel(h)}e.getZoomLevel=A,e.onDidChangeZoomLevel=n.INSTANCE.onDidChangeZoomLevel;function p(h){return n.INSTANCE.getZoomFactor(h)}e.getZoomFactor=p;function b(h,g){n.INSTANCE.setZoomFactor(h,g)}e.setZoomFactor=b;function v(h,g){n.INSTANCE.setFullscreen(h,g)}e.setFullscreen=v;function O(h){return n.INSTANCE.isFullscreen(h)}e.isFullscreen=O,e.onDidChangeFullscreen=n.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;e.isFirefox=l.indexOf("Firefox")>=0,e.isWebKit=l.indexOf("AppleWebKit")>=0,e.isChrome=l.indexOf("Chrome")>=0,e.isSafari=!e.isChrome&&l.indexOf("Safari")>=0,e.isWebkitWebView=!e.isChrome&&!e.isSafari&&e.isWebKit,e.isElectron=l.indexOf("Electron/")>=0,e.isAndroid=l.indexOf("Android")>=0;let d=!1;if(typeof S.mainWindow.matchMedia=="function"){const h=S.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),g=S.mainWindow.matchMedia("(display-mode: fullscreen)");d=h.matches,U(S.mainWindow,h,({matches:c})=>{d&&g.matches||(d=c)})}function t(){return d}e.isStandalone=t;function s(){return navigator?.windowControlsOverlay?.visible}e.isWCOEnabled=s}),define(me[23],be([1,0,4]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DomEmitter=void 0;class F{get event(){return this.emitter.event}constructor(U,y,A){const p=b=>this.emitter.fire(b);this.emitter=new S.Emitter({onWillAddFirstListener:()=>U.addEventListener(y,p,A),onDidRemoveLastListener:()=>U.removeEventListener(y,p,A)})}dispose(){this.emitter.dispose()}}e.DomEmitter=F}),define(me[30],be([1,0,4]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(A,p){const b=setTimeout(A.bind(p),0);return{dispose(){clearTimeout(b)}}});var n;(function(A){function p(b){return b===A.None||b===A.Cancelled||b instanceof U?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}A.isCancellationToken=p,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(n||(e.CancellationToken=n={}));class U{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new U),this._token}cancel(){this._token?this._token instanceof U&&this._token.cancel():this._token=n.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof U&&this._token.dispose():this._token=n.None}}e.CancellationTokenSource=y}),define(me[87],be([1,0,30]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class F{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new S.CancellationTokenSource,p=this.task(A.token);return this.result={promise:p,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=F;class n{constructor(A){this.fn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const p=JSON.stringify(A);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(A)),this.lastCache}}e.LRUCachedFunction=n;class U{get cachedValues(){return this._map}constructor(A){this.fn=A,this._map=new Map}get(A){if(this._map.has(A))return this._map.get(A);const p=this.fn(A);return this._map.set(A,p),p}}e.CachedFunction=U}),define(me[50],be([1,0,4,3]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var n;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(n||(e.ScrollbarVisibility=n={}));class U{constructor(t,s,h,g,c,D,u){this._forceIntegerValues=t,this._scrollStateBrand=void 0,this._forceIntegerValues&&(s=s|0,h=h|0,g=g|0,c=c|0,D=D|0,u=u|0),this.rawScrollLeft=g,this.rawScrollTop=u,s<0&&(s=0),g+s>h&&(g=h-s),g<0&&(g=0),c<0&&(c=0),u+c>D&&(u=D-c),u<0&&(u=0),this.width=s,this.scrollWidth=h,this.scrollLeft=g,this.height=c,this.scrollHeight=D,this.scrollTop=u}equals(t){return this.rawScrollLeft===t.rawScrollLeft&&this.rawScrollTop===t.rawScrollTop&&this.width===t.width&&this.scrollWidth===t.scrollWidth&&this.scrollLeft===t.scrollLeft&&this.height===t.height&&this.scrollHeight===t.scrollHeight&&this.scrollTop===t.scrollTop}withScrollDimensions(t,s){return new U(this._forceIntegerValues,typeof t.width<"u"?t.width:this.width,typeof t.scrollWidth<"u"?t.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof t.height<"u"?t.height:this.height,typeof t.scrollHeight<"u"?t.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(t){return new U(this._forceIntegerValues,this.width,this.scrollWidth,typeof t.scrollLeft<"u"?t.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof t.scrollTop<"u"?t.scrollTop:this.rawScrollTop)}createScrollEvent(t,s){const h=this.width!==t.width,g=this.scrollWidth!==t.scrollWidth,c=this.scrollLeft!==t.scrollLeft,D=this.height!==t.height,u=this.scrollHeight!==t.scrollHeight,m=this.scrollTop!==t.scrollTop;return{inSmoothScrolling:s,oldWidth:t.width,oldScrollWidth:t.scrollWidth,oldScrollLeft:t.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:t.height,oldScrollHeight:t.scrollHeight,oldScrollTop:t.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:h,scrollWidthChanged:g,scrollLeftChanged:c,heightChanged:D,scrollHeightChanged:u,scrollTopChanged:m}}}e.ScrollState=U;class y extends F.Disposable{constructor(t){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new S.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=t.smoothScrollDuration,this._scheduleAtNextAnimationFrame=t.scheduleAtNextAnimationFrame,this._state=new U(t.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(t){this._smoothScrollDuration=t}validateScrollPosition(t){return this._state.withScrollPosition(t)}getScrollDimensions(){return this._state}setScrollDimensions(t,s){const h=this._state.withScrollDimensions(t,s);this._setState(h,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(t){const s=this._state.withScrollPosition(t);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(s,!1)}setScrollPositionSmooth(t,s){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(t);if(this._smoothScrolling){t={scrollLeft:typeof t.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:t.scrollLeft,scrollTop:typeof t.scrollTop>"u"?this._smoothScrolling.to.scrollTop:t.scrollTop};const h=this._state.withScrollPosition(t);if(this._smoothScrolling.to.scrollLeft===h.scrollLeft&&this._smoothScrolling.to.scrollTop===h.scrollTop)return;let g;s?g=new v(this._smoothScrolling.from,h,this._smoothScrolling.startTime,this._smoothScrolling.duration):g=this._smoothScrolling.combine(this._state,h,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=g}else{const h=this._state.withScrollPosition(t);this._smoothScrolling=v.start(this._state,h,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const t=this._smoothScrolling.tick(),s=this._state.withScrollPosition(t);if(this._setState(s,!0),!!this._smoothScrolling){if(t.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(t,s){const h=this._state;h.equals(t)||(this._state=t,this._onScroll.fire(this._state.createScrollEvent(h,s)))}}e.Scrollable=y;class A{constructor(t,s,h){this.scrollLeft=t,this.scrollTop=s,this.isDone=h}}e.SmoothScrollingUpdate=A;function p(d,t){const s=t-d;return function(h){return d+s*l(h)}}function b(d,t,s){return function(h){return h<s?d(h/s):t((h-s)/(1-s))}}class v{constructor(t,s,h,g){this.from=t,this.to=s,this.duration=g,this.startTime=h,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(t,s,h){if(Math.abs(t-s)>2.5*h){let c,D;return t<s?(c=t+.75*h,D=s-.75*h):(c=t-.75*h,D=s+.75*h),b(p(t,c),p(D,s),.33)}return p(t,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(t){this.to=t.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(t){const s=(t-this.startTime)/this.duration;if(s<1){const h=this.scrollLeft(s),g=this.scrollTop(s);return new A(h,g,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(t,s,h){return v.start(t,s,h)}static start(t,s,h){h=h+10;const g=Date.now()-10;return new v(t,s,g,h)}}e.SmoothScrollingOperation=v;function O(d){return Math.pow(d,3)}function l(d){return 1-O(1-d)}}),define(me[88],be([1,0,6,3]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(u){const m=u;return m?typeof m.read=="function":!1}e.isReadable=n;function U(u){const m=u;return m?[m.on,m.pause,m.resume,m.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=U;function y(u){const m=u;return m?U(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(u,m){return new p(u,m)}e.newWriteableStream=A;class p{constructor(m,a){this.reducer=m,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m<"u"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(a=>a(m))}emitError(m){this.listeners.error.length===0?(0,S.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(a=>a(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,a){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(m,a){if(this.state.destroyed)return;let E;switch(m){case"data":E=this.listeners.data;break;case"end":E=this.listeners.end;break;case"error":E=this.listeners.error;break}if(E){const k=E.indexOf(a);k>=0&&E.splice(k,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(E=>E())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(u,m){const a=[];let E;for(;(E=u.read())!==null;)a.push(E);return m(a)}e.consumeReadable=b;function v(u,m,a){const E=[];let k;for(;(k=u.read())!==null&&E.length<a;)E.push(k);return k===null&&E.length>0?m(E):{read:()=>{if(E.length>0)return E.shift();if(typeof k<"u"){const N=k;return k=void 0,N}return u.read()}}}e.peekReadable=v;function O(u,m){return new Promise((a,E)=>{const k=[];l(u,{onData:N=>{m&&k.push(N)},onError:N=>{m?E(N):a(void 0)},onEnd:()=>{a(m?m(k):void 0)}})})}e.consumeStream=O;function l(u,m,a){u.on("error",E=>{a?.isCancellationRequested||m.onError(E)}),u.on("end",()=>{a?.isCancellationRequested||m.onEnd()}),u.on("data",E=>{a?.isCancellationRequested||m.onData(E)})}e.listenStream=l;function d(u,m){return new Promise((a,E)=>{const k=new F.DisposableStore,N=[],H=B=>{if(N.push(B),N.length>m)return k.dispose(),u.pause(),a({stream:u,buffer:N,ended:!1})},W=B=>(k.dispose(),E(B)),_=()=>(k.dispose(),a({stream:u,buffer:N,ended:!0}));k.add((0,F.toDisposable)(()=>u.removeListener("error",W))),u.on("error",W),k.add((0,F.toDisposable)(()=>u.removeListener("end",_))),u.on("end",_),k.add((0,F.toDisposable)(()=>u.removeListener("data",H))),u.on("data",H)})}e.peekStream=d;function t(u,m){const a=A(m);return a.end(u),a}e.toStream=t;function s(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=s;function h(u){let m=!1;return{read:()=>m?null:(m=!0,u)}}e.toReadable=h;function g(u,m,a){const E=A(a);return l(u,{onData:k=>E.write(m.data(k)),onError:k=>E.error(m.error?m.error(k):k),onEnd:()=>E.end()}),E}e.transform=g;function c(u,m,a){let E=!1;return{read:()=>{const k=m.read();return E?k:(E=!0,k!==null?a([u,k]):u)}}}e.prefixedReadable=c;function D(u,m,a){let E=!1;const k=A(a);return l(m,{onData:N=>E?k.write(N):(E=!0,k.write(a([u,N]))),onError:N=>k.error(N),onEnd:()=>{E||(E=!0,k.write(u)),k.end()}}),k}e.prefixedStream=D}),define(me[35],be([1,0,22,88]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const n=typeof Buffer<"u",U=new S.Lazy(()=>new Uint8Array(256));let y,A;class p{static alloc(P){return n?new p(Buffer.allocUnsafe(P)):new p(new Uint8Array(P))}static wrap(P){return n&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new p(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&n?new p(Buffer.from(P)):(y||(y=new TextEncoder),new p(y.encode(P)))}static fromByteArray(P){const M=p.alloc(P.length);for(let Y=0,Z=P.length;Y<Z;Y++)M.buffer[Y]=P[Y];return M}static concat(P,M){if(typeof M>"u"){M=0;for(let fe=0,ce=P.length;fe<ce;fe++)M+=P[fe].byteLength}const Y=p.alloc(M);let Z=0;for(let fe=0,ce=P.length;fe<ce;fe++){const te=P[fe];Y.set(te,Z),Z+=te.byteLength}return Y}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=p.alloc(this.byteLength);return P.set(this),P}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(P,M){return new p(this.buffer.subarray(P,M))}set(P,M){if(P instanceof p)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return l(this.buffer,P)}writeUInt32BE(P,M){d(this.buffer,P,M)}readUInt32LE(P){return t(this.buffer,P)}writeUInt32LE(P,M){s(this.buffer,P,M)}readUInt8(P){return h(this.buffer,P)}writeUInt8(P,M){g(this.buffer,P,M)}indexOf(P,M=0){return b(this.buffer,P instanceof p?P.buffer:P,M)}}e.VSBuffer=p;function b(T,P,M=0){const Y=P.byteLength,Z=T.byteLength;if(Y===0)return 0;if(Y===1)return T.indexOf(P[0]);if(Y>Z-M)return-1;const fe=U.value;fe.fill(P.length);for(let ke=0;ke<P.length;ke++)fe[P[ke]]=P.length-ke-1;let ce=M+P.length-1,te=ce,ge=-1;for(;ce<Z;)if(T[ce]===P[te]){if(te===0){ge=ce;break}ce--,te--}else ce+=Math.max(P.length-te,fe[T[ce]]),te=P.length-1;return ge}e.binaryIndexOf=b;function v(T,P){return T[P+0]<<0>>>0|T[P+1]<<8>>>0}e.readUInt16LE=v;function O(T,P,M){T[M+0]=P&255,P=P>>>8,T[M+1]=P&255}e.writeUInt16LE=O;function l(T,P){return T[P]*2**24+T[P+1]*2**16+T[P+2]*2**8+T[P+3]}e.readUInt32BE=l;function d(T,P,M){T[M+3]=P,P=P>>>8,T[M+2]=P,P=P>>>8,T[M+1]=P,P=P>>>8,T[M]=P}e.writeUInt32BE=d;function t(T,P){return T[P+0]<<0>>>0|T[P+1]<<8>>>0|T[P+2]<<16>>>0|T[P+3]<<24>>>0}e.readUInt32LE=t;function s(T,P,M){T[M+0]=P&255,P=P>>>8,T[M+1]=P&255,P=P>>>8,T[M+2]=P&255,P=P>>>8,T[M+3]=P&255}e.writeUInt32LE=s;function h(T,P){return T[P]}e.readUInt8=h;function g(T,P,M){T[M]=P}e.writeUInt8=g;function c(T){return F.consumeReadable(T,P=>p.concat(P))}e.readableToBuffer=c;function D(T){return F.toReadable(T)}e.bufferToReadable=D;function u(T){return F.consumeStream(T,P=>p.concat(P))}e.streamToBuffer=u;async function m(T){return T.ended?p.concat(T.buffer):p.concat([...T.buffer,await u(T.stream)])}e.bufferedStreamToBuffer=m;function a(T){return F.toStream(T,P=>p.concat(P))}e.bufferToStream=a;function E(T){return F.transform(T,{data:P=>typeof P=="string"?p.fromString(P):p.wrap(P)},P=>p.concat(P))}e.streamToBufferReadableStream=E;function k(T){return F.newWriteableStream(P=>p.concat(P),T)}e.newWriteableBufferStream=k;function N(T,P){return F.prefixedReadable(T,P,M=>p.concat(M))}e.prefixedBufferReadable=N;function H(T,P){return F.prefixedStream(T,P,M=>p.concat(M))}e.prefixedBufferStream=H;function W(T){let P=0,M=0,Y=0;const Z=new Uint8Array(Math.floor(T.length/4*3)),fe=te=>{switch(M){case 3:Z[Y++]=P|te,M=0;break;case 2:Z[Y++]=P|te>>>2,P=te<<6,M=3;break;case 1:Z[Y++]=P|te>>>4,P=te<<4,M=2;break;default:P=te<<2,M=1}};for(let te=0;te<T.length;te++){const ge=T.charCodeAt(te);if(ge>=65&&ge<=90)fe(ge-65);else if(ge>=97&&ge<=122)fe(ge-97+26);else if(ge>=48&&ge<=57)fe(ge-48+52);else if(ge===43||ge===45)fe(62);else if(ge===47||ge===95)fe(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${T[te]}`)}}const ce=Y;for(;M>0;)fe(0);return p.wrap(Z).slice(0,ce)}e.decodeBase64=W;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:T},P=!0,M=!1){const Y=M?B:_;let Z="";const fe=T.byteLength%3;let ce=0;for(;ce<T.byteLength-fe;ce+=3){const te=T[ce+0],ge=T[ce+1],ke=T[ce+2];Z+=Y[te>>>2],Z+=Y[(te<<4|ge>>>4)&63],Z+=Y[(ge<<2|ke>>>6)&63],Z+=Y[ke&63]}if(fe===1){const te=T[ce+0];Z+=Y[te>>>2],Z+=Y[te<<4&63],P&&(Z+="==")}else if(fe===2){const te=T[ce+0],ge=T[ce+1];Z+=Y[te>>>2],Z+=Y[(te<<4|ge>>>4)&63],Z+=Y[ge<<2&63],P&&(Z+="=")}return Z}e.encodeBase64=z}),define(me[10],be([1,0,87,22]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLinesIncludeSeparators=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function n(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=n;const U=/{(\d+)}/g;function y(G,...ne){return ne.length===0?G:G.replace(U,function(ve,_e){const Ne=parseInt(_e,10);return isNaN(Ne)||Ne<0||Ne>=ne.length?ve:ne[Ne]})}e.format=y;const A=/{([^}]+)}/g;function p(G,ne){return Object.keys(ne).length===0?G:G.replace(A,(ve,_e)=>ne[_e]??ve)}e.format2=p;function b(G){return G.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}e.htmlAttributeEncodeValue=b;function v(G){return G.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=v;function O(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=O;function l(G,ne){let ve=0;const _e=ne.charCodeAt(0);for(let Ne=G.length-1;Ne>=0;Ne--)G.charCodeAt(Ne)===_e&&ve++;return ve}e.count=l;function d(G,ne,ve="\u2026"){return G.length<=ne?G:`${G.substr(0,ne)}${ve}`}e.truncate=d;function t(G,ne,ve="\u2026"){if(G.length<=ne)return G;const _e=Math.ceil(ne/2)-ve.length/2,Ne=Math.floor(ne/2)-ve.length/2;return`${G.substr(0,_e)}${ve}${G.substr(G.length-Ne)}`}e.truncateMiddle=t;function s(G,ne=" "){const ve=h(G,ne);return g(ve,ne)}e.trim=s;function h(G,ne){if(!G||!ne)return G;const ve=ne.length;if(ve===0||G.length===0)return G;let _e=0;for(;G.indexOf(ne,_e)===_e;)_e=_e+ve;return G.substring(_e)}e.ltrim=h;function g(G,ne){if(!G||!ne)return G;const ve=ne.length,_e=G.length;if(ve===0||_e===0)return G;let Ne=_e,xe=-1;for(;xe=G.lastIndexOf(ne,Ne-1),!(xe===-1||xe+ve!==Ne);){if(xe===0)return"";Ne=xe}return G.substring(0,Ne)}e.rtrim=g;function c(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function D(G){return G.replace(/\*/g,"")}e.stripWildcards=D;function u(G,ne,ve={}){if(!G)throw new Error("Cannot create regex from empty string");ne||(G=O(G)),ve.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let _e="";return ve.global&&(_e+="g"),ve.matchCase||(_e+="i"),ve.multiline&&(_e+="m"),ve.unicode&&(_e+="u"),new RegExp(G,_e)}e.createRegExp=u;function m(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function a(G){return G.split(/\r\n|\r|\n/)}e.splitLines=a;function E(G){const ne=[],ve=G.split(/(\r\n|\r|\n)/);for(let _e=0;_e<Math.ceil(ve.length/2);_e++)ne.push(ve[2*_e]+(ve[2*_e+1]??""));return ne}e.splitLinesIncludeSeparators=E;function k(G){for(let ne=0,ve=G.length;ne<ve;ne++){const _e=G.charCodeAt(ne);if(_e!==32&&_e!==9)return ne}return-1}e.firstNonWhitespaceIndex=k;function N(G,ne=0,ve=G.length){for(let _e=ne;_e<ve;_e++){const Ne=G.charCodeAt(_e);if(Ne!==32&&Ne!==9)return G.substring(ne,_e)}return G.substring(ne,ve)}e.getLeadingWhitespace=N;function H(G,ne=G.length-1){for(let ve=ne;ve>=0;ve--){const _e=G.charCodeAt(ve);if(_e!==32&&_e!==9)return ve}return-1}e.lastNonWhitespaceIndex=H;function W(G,ne,ve){const _e=[];let Ne=0;for(const xe of G.matchAll(ne)){if(_e.push(G.slice(Ne,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Ne=xe.index+xe[0].length,_e.push(ve(xe[0],...xe.slice(1),xe.index,G,xe.groups))}return _e.push(G.slice(Ne)),Promise.all(_e).then(xe=>xe.join(""))}e.replaceAsync=W;function _(G,ne){return G<ne?-1:G>ne?1:0}e.compare=_;function B(G,ne,ve=0,_e=G.length,Ne=0,xe=ne.length){for(;ve<_e&&Ne<xe;ve++,Ne++){const tt=G.charCodeAt(ve),st=ne.charCodeAt(Ne);if(tt<st)return-1;if(tt>st)return 1}const $e=_e-ve,Je=xe-Ne;return $e<Je?-1:$e>Je?1:0}e.compareSubstring=B;function z(G,ne){return T(G,ne,0,G.length,0,ne.length)}e.compareIgnoreCase=z;function T(G,ne,ve=0,_e=G.length,Ne=0,xe=ne.length){for(;ve<_e&&Ne<xe;ve++,Ne++){let tt=G.charCodeAt(ve),st=ne.charCodeAt(Ne);if(tt===st)continue;if(tt>=128||st>=128)return B(G.toLowerCase(),ne.toLowerCase(),ve,_e,Ne,xe);M(tt)&&(tt-=32),M(st)&&(st-=32);const Xe=tt-st;if(Xe!==0)return Xe}const $e=_e-ve,Je=xe-Ne;return $e<Je?-1:$e>Je?1:0}e.compareSubstringIgnoreCase=T;function P(G){return G>=48&&G<=57}e.isAsciiDigit=P;function M(G){return G>=97&&G<=122}e.isLowerAsciiLetter=M;function Y(G){return G>=65&&G<=90}e.isUpperAsciiLetter=Y;function Z(G,ne){return G.length===ne.length&&T(G,ne)===0}e.equalsIgnoreCase=Z;function fe(G,ne){const ve=ne.length;return ne.length>G.length?!1:T(G,ne,0,ve)===0}e.startsWithIgnoreCase=fe;function ce(G,ne){const ve=Math.min(G.length,ne.length);let _e;for(_e=0;_e<ve;_e++)if(G.charCodeAt(_e)!==ne.charCodeAt(_e))return _e;return ve}e.commonPrefixLength=ce;function te(G,ne){const ve=Math.min(G.length,ne.length);let _e;const Ne=G.length-1,xe=ne.length-1;for(_e=0;_e<ve;_e++)if(G.charCodeAt(Ne-_e)!==ne.charCodeAt(xe-_e))return _e;return ve}e.commonSuffixLength=te;function ge(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ge;function ke(G){return 56320<=G&&G<=57343}e.isLowSurrogate=ke;function Le(G,ne){return(G-55296<<10)+(ne-56320)+65536}e.computeCodePoint=Le;function Be(G,ne,ve){const _e=G.charCodeAt(ve);if(ge(_e)&&ve+1<ne){const Ne=G.charCodeAt(ve+1);if(ke(Ne))return Le(_e,Ne)}return _e}e.getNextCodePoint=Be;function le(G,ne){const ve=G.charCodeAt(ne-1);if(ke(ve)&&ne>1){const _e=G.charCodeAt(ne-2);if(ge(_e))return Le(_e,ve)}return ve}class J{get offset(){return this._offset}constructor(ne,ve=0){this._str=ne,this._len=ne.length,this._offset=ve}setOffset(ne){this._offset=ne}prevCodePoint(){const ne=le(this._str,this._offset);return this._offset-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Be(this._str,this._len,this._offset);return this._offset+=ne>=65536?2:1,ne}eol(){return this._offset>=this._len}}e.CodePointIterator=J;class ae{get offset(){return this._iterator.offset}constructor(ne,ve=0){this._iterator=new J(ne,ve)}nextGraphemeLength(){const ne=De.getInstance(),ve=this._iterator,_e=ve.offset;let Ne=ne.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const xe=ve.offset,$e=ne.getGraphemeBreakType(ve.nextCodePoint());if(we(Ne,$e)){ve.setOffset(xe);break}Ne=$e}return ve.offset-_e}prevGraphemeLength(){const ne=De.getInstance(),ve=this._iterator,_e=ve.offset;let Ne=ne.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const xe=ve.offset,$e=ne.getGraphemeBreakType(ve.prevCodePoint());if(we($e,Ne)){ve.setOffset(xe);break}Ne=$e}return _e-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ae;function re(G,ne){return new ae(G,ne).nextGraphemeLength()}e.nextCharLength=re;function X(G,ne){return new ae(G,ne).prevGraphemeLength()}e.prevCharLength=X;function j(G,ne){ne>0&&ke(G.charCodeAt(ne))&&ne--;const ve=ne+re(G,ne);return[ve-X(G,ve),ve]}e.getCharContainingOffset=j;function ie(G){const ne=new ae(G);let ve=0;for(;!ne.eol();)ve++,ne.nextGraphemeLength();return ve}e.charCount=ie;let de;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(G){return de||(de=Ee()),de.test(G)}e.containsRTL=Ie;const Ce=/^[\t\n\r\x20-\x7E]*$/;function K(G){return Ce.test(G)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function f(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=f;function C(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=C;function I(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=I;function r(G,ne,ve=""){const _e=G.trimStart();if(_e.length<ne)return _e;const Ne=/\b/g;let xe=0;for(;Ne.test(_e)&&!(_e.length-Ne.lastIndex<ne);)xe=Ne.lastIndex,Ne.lastIndex+=1;return xe===0?_e:ve+_e.substring(xe).trimStart()}e.lcut=r;const i=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,o=/\x1b\].*?\x07/g;function w(G){return G&&(G=G.replace(i,"").replace(o,"")),G}e.removeAnsiEscapeCodes=w,e.UTF8_BOM_CHARACTER="\uFEFF";function R(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=R;function L(G){return R(G)?G.substr(1):G}e.stripUTF8BOM=L;function x(G,ne){if(!G||!ne||G.length<ne.length)return!1;const ve=ne.length,_e=G.toLowerCase();let Ne=0,xe=-1;for(;Ne<ve;){const $e=_e.indexOf(ne[Ne],xe+1);if($e<0)return!1;xe=$e,Ne++}return!0}e.fuzzyContains=x;function V(G,ne=!1){return G?(ne&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=V;function Q(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Q;function oe(G,ne=1){if(ne===0)return"";let ve=-1;do ve=G.indexOf(`
`,ve+1),ne--;while(ne>0&&ve>=0);return ve===-1?G:(G[ve-1]==="\r"&&ve--,G.substr(0,ve))}e.getNLines=oe;function pe(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=pe;function ye(G){return De.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ye;function we(G,ne){return G===0?ne!==5&&ne!==7:G===2&&ne===3?!1:G===4||G===2||G===3||ne===4||ne===2||ne===3?!0:!(G===8&&(ne===8||ne===9||ne===11||ne===12)||(G===11||G===9)&&(ne===9||ne===10)||(G===12||G===10)&&ne===10||ne===5||ne===13||ne===7||G===1||G===13&&ne===14||G===6&&ne===6)}var Ae;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class De{static{this._INSTANCE=null}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}constructor(){this._data=Fe()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ve=this._data,_e=ve.length/3;let Ne=1;for(;Ne<=_e;)if(ne<ve[3*Ne])Ne=2*Ne;else if(ne>ve[3*Ne+1])Ne=2*Ne+1;else return ve[3*Ne+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(G,ne){if(G===0)return 0;const ve=Re(G,ne);if(ve!==void 0)return ve;const _e=new J(ne,G);return _e.prevCodePoint(),_e.offset}e.getLeftDeleteOffset=Pe;function Re(G,ne){const ve=new J(ne,G);let _e=ve.prevCodePoint();for(;Ze(_e)||_e===65039||_e===8419;){if(ve.offset===0)return;_e=ve.prevCodePoint()}if(!I(_e))return;let Ne=ve.offset;return Ne>0&&ve.prevCodePoint()===8205&&(Ne=ve.offset),Ne}function Ze(G){return 127995<=G&&G<=127999}var nt;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.noBreakWhitespace="\xA0";class je{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new S.LRUCachedFunction(ne=>{function ve(Xe){const rt=new Map;for(let et=0;et<Xe.length;et+=2)rt.set(Xe[et],Xe[et+1]);return rt}function _e(Xe,rt){const et=new Map(Xe);for(const[gt,mt]of rt)et.set(gt,mt);return et}function Ne(Xe,rt){if(!Xe)return rt;const et=new Map;for(const[gt,mt]of Xe)rt.has(gt)&&et.set(gt,mt);return et}const xe=this.ambiguousCharacterData.value;let $e=ne.filter(Xe=>!Xe.startsWith("_")&&Xe in xe);$e.length===0&&($e=["_default"]);let Je;for(const Xe of $e){const rt=ve(xe[Xe]);Je=Ne(Je,rt)}const tt=ve(xe._common),st=_e(tt,Je);return new je(st)})}static getInstance(ne){return je.cache.get(Array.from(ne))}static{this._locales=new F.Lazy(()=>Object.keys(je.ambiguousCharacterData.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return je._locales.value}constructor(ne){this.confusableDictionary=ne}isAmbiguous(ne){return this.confusableDictionary.has(ne)}getPrimaryConfusable(ne){return this.confusableDictionary.get(ne)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je;class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(ne){return Qe.getData().has(ne)}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe}),define(me[36],be([1,0,33,82,10]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function U(...L){return function(x,V){for(let Q=0,oe=L.length;Q<oe;Q++){const pe=L[Q](x,V);if(pe)return pe}return null}}e.or=U,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(L,x,V){if(!V||V.length<x.length)return null;let Q;return L?Q=n.startsWithIgnoreCase(V,x):Q=V.indexOf(x)===0,Q?x.length>0?[{start:0,end:x.length}]:[]:null}function A(L,x){const V=x.toLowerCase().indexOf(L.toLowerCase());return V===-1?null:[{start:V,end:V+L.length}]}e.matchesContiguousSubString=A;function p(L,x){return b(L.toLowerCase(),x.toLowerCase(),0,0)}e.matchesSubString=p;function b(L,x,V,Q){if(V===L.length)return[];if(Q===x.length)return null;if(L[V]===x[Q]){let oe=null;return(oe=b(L,x,V+1,Q+1))?u({start:Q,end:Q+1},oe):null}return b(L,x,V,Q+1)}function v(L){return 97<=L&&L<=122}function O(L){return 65<=L&&L<=90}e.isUpper=O;function l(L){return 48<=L&&L<=57}function d(L){return L===32||L===9||L===10||L===13}const t=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(L=>t.add(L.charCodeAt(0)));function s(L){return d(L)||t.has(L)}function h(L,x){return L===x||s(L)&&s(x)}const g=new Map;function c(L){if(g.has(L))return g.get(L);let x;const V=(0,F.getKoreanAltChars)(L);return V&&(x=V),g.set(L,x),x}function D(L){return v(L)||O(L)||l(L)}function u(L,x){return x.length===0?x=[L]:L.end===x[0].start?x[0].start=L.start:x.unshift(L),x}function m(L,x){for(let V=x;V<L.length;V++){const Q=L.charCodeAt(V);if(O(Q)||l(Q)||V>0&&!D(L.charCodeAt(V-1)))return V}return L.length}function a(L,x,V,Q){if(V===L.length)return[];if(Q===x.length)return null;if(L[V]!==x[Q].toLowerCase())return null;{let oe=null,pe=Q+1;for(oe=a(L,x,V+1,Q+1);!oe&&(pe=m(x,pe))<x.length;)oe=a(L,x,V+1,pe),pe++;return oe===null?null:u({start:Q,end:Q+1},oe)}}function E(L){let x=0,V=0,Q=0,oe=0,pe=0;for(let Fe=0;Fe<L.length;Fe++)pe=L.charCodeAt(Fe),O(pe)&&x++,v(pe)&&V++,D(pe)&&Q++,l(pe)&&oe++;const ye=x/L.length,we=V/L.length,Ae=Q/L.length,De=oe/L.length;return{upperPercent:ye,lowerPercent:we,alphaPercent:Ae,numericPercent:De}}function k(L){const{upperPercent:x,lowerPercent:V}=L;return V===0&&x>.6}function N(L){const{upperPercent:x,lowerPercent:V,alphaPercent:Q,numericPercent:oe}=L;return V>.2&&x<.8&&Q>.6&&oe<.2}function H(L){let x=0,V=0,Q=0,oe=0;for(let pe=0;pe<L.length;pe++)Q=L.charCodeAt(pe),O(Q)&&x++,v(Q)&&V++,d(Q)&&oe++;return(x===0||V===0)&&oe===0?L.length<=30:x<=5}function W(L,x){if(!x||(x=x.trim(),x.length===0)||!H(L))return null;x.length>60&&(x=x.substring(0,60));const V=E(x);if(!N(V)){if(!k(V))return null;x=x.toLowerCase()}let Q=null,oe=0;for(L=L.toLowerCase();oe<x.length&&(Q=a(L,x,0,oe))===null;)oe=m(x,oe+1);return Q}e.matchesCamelCase=W;function _(L,x,V=!1){if(!x||x.length===0)return null;let Q=null,oe=0;for(L=L.toLowerCase(),x=x.toLowerCase();oe<x.length&&(Q=B(L,x,0,oe,V),Q===null);)oe=z(x,oe+1);return Q}e.matchesWords=_;function B(L,x,V,Q,oe){let pe=0;if(V===L.length)return[];if(Q===x.length)return null;if(!h(L.charCodeAt(V),x.charCodeAt(Q))){const Ae=c(L.charCodeAt(V));if(!Ae)return null;for(let De=0;De<Ae.length;De++)if(!h(Ae[De],x.charCodeAt(Q+De)))return null;pe+=Ae.length-1}let ye=null,we=Q+pe+1;if(ye=B(L,x,V+1,we,oe),!oe)for(;!ye&&(we=z(x,we))<x.length;)ye=B(L,x,V+1,we,oe),we++;if(!ye)return null;if(L.charCodeAt(V)!==x.charCodeAt(Q)){const Ae=c(L.charCodeAt(V));if(!Ae)return ye;for(let De=0;De<Ae.length;De++)if(Ae[De]!==x.charCodeAt(Q+De))return ye}return u({start:Q,end:Q+pe+1},ye)}function z(L,x){for(let V=x;V<L.length;V++)if(s(L.charCodeAt(V))||V>0&&s(L.charCodeAt(V-1)))return V;return L.length}const T=U(e.matchesPrefix,W,A),P=U(e.matchesPrefix,W,p),M=new S.LRUCache(1e4);function Y(L,x,V=!1){if(typeof L!="string"||typeof x!="string")return null;let Q=M.get(L);Q||(Q=new RegExp(n.convertSimple2RegExpPattern(L),"i"),M.set(L,Q));const oe=Q.exec(x);return oe?[{start:oe.index,end:oe.index+oe[0].length}]:V?P(L,x):T(L,x)}e.matchesFuzzy=Y;function Z(L,x){const V=C(L,L.toLowerCase(),0,x,x.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?ce(V):null}e.matchesFuzzy2=Z;function fe(L,x,V,Q,oe,pe){const ye=Math.min(13,L.length);for(;V<ye;V++){const we=C(L,x,V,Q,oe,pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,pe]}e.anyScore=fe;function ce(L){if(typeof L>"u")return[];const x=[],V=L[1];for(let Q=L.length-1;Q>1;Q--){const oe=L[Q]+V,pe=x[x.length-1];pe&&pe.end===oe?pe.end=oe+1:x.push({start:oe,end:oe+1})}return x}e.createMatches=ce;const te=128;function ge(){const L=[],x=[];for(let V=0;V<=te;V++)x[V]=0;for(let V=0;V<=te;V++)L.push(x.slice(0));return L}function ke(L){const x=[];for(let V=0;V<=L;V++)x[V]=0;return x}const Le=ke(2*te),Be=ke(2*te),le=ge(),J=ge(),ae=ge(),re=!1;function X(L,x,V,Q,oe){function pe(we,Ae,De=" "){for(;we.length<Ae;)we=De+we;return we}let ye=` |   |${Q.split("").map(we=>pe(we,3)).join("|")}
`;for(let we=0;we<=V;we++)we===0?ye+=" |":ye+=`${x[we-1]}|`,ye+=L[we].slice(0,oe+1).map(Ae=>pe(Ae.toString(),3)).join("|")+`
`;return ye}function j(L,x,V,Q){L=L.substr(x),V=V.substr(Q),console.log(X(J,L,L.length,V,V.length)),console.log(X(ae,L,L.length,V,V.length)),console.log(X(le,L,L.length,V,V.length))}function ie(L,x){if(x<0||x>=L.length)return!1;const V=L.codePointAt(x);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(V)}}function de(L,x){if(x<0||x>=L.length)return!1;switch(L.charCodeAt(x)){case 32:case 9:return!0;default:return!1}}function Ee(L,x,V){return x[L]!==V[L]}function Ie(L,x,V,Q,oe,pe,ye=!1){for(;x<V&&oe<pe;)L[x]===Q[oe]&&(ye&&(Le[x]=oe),x+=1),oe+=1;return x===V}e.isPatternInWord=Ie;var Ce;(function(L){L[L.Diag=1]="Diag",L[L.Left=2]="Left",L[L.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var K;(function(L){L.Default=[-100,0];function x(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}L.isDefault=x})(K||(e.FuzzyScore=K={}));class f{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(x,V){this.firstMatchCanBeWeak=x,this.boostFullMatch=V}}e.FuzzyScoreOptions=f;function C(L,x,V,Q,oe,pe,ye=f.default){const we=L.length>te?te:L.length,Ae=Q.length>te?te:Q.length;if(V>=we||pe>=Ae||we-V>Ae-pe||!Ie(x,V,we,oe,pe,Ae,!0))return;I(we,Ae,V,pe,x,oe);let De=1,Fe=1,Pe=V,Re=pe;const Ze=[!1];for(De=1,Pe=V;Pe<we;De++,Pe++){const ne=Le[Pe],ve=Be[Pe],_e=Pe+1<we?Be[Pe+1]:Ae;for(Fe=ne-pe+1,Re=ne;Re<_e;Fe++,Re++){let Ne=Number.MIN_SAFE_INTEGER,xe=!1;Re<=ve&&(Ne=r(L,x,Pe,V,Q,oe,Re,Ae,pe,le[De-1][Fe-1]===0,Ze));let $e=0;Ne!==Number.MAX_SAFE_INTEGER&&(xe=!0,$e=Ne+J[De-1][Fe-1]);const Je=Re>ne,tt=Je?J[De][Fe-1]+(le[De][Fe-1]>0?-5:0):0,st=Re>ne+1&&le[De][Fe-1]>0,Xe=st?J[De][Fe-2]+(le[De][Fe-2]>0?-5:0):0;if(st&&(!Je||Xe>=tt)&&(!xe||Xe>=$e))J[De][Fe]=Xe,ae[De][Fe]=3,le[De][Fe]=0;else if(Je&&(!xe||tt>=$e))J[De][Fe]=tt,ae[De][Fe]=2,le[De][Fe]=0;else if(xe)J[De][Fe]=$e,ae[De][Fe]=1,le[De][Fe]=le[De-1][Fe-1]+1;else throw new Error("not possible")}}if(re&&j(L,V,Q,pe),!Ze[0]&&!ye.firstMatchCanBeWeak)return;De--,Fe--;const nt=[J[De][Fe],pe];let je=0,Qe=0;for(;De>=1;){let ne=Fe;do{const ve=ae[De][ne];if(ve===3)ne=ne-2;else if(ve===2)ne=ne-1;else break}while(ne>=1);je>1&&x[V+De-1]===oe[pe+Fe-1]&&!Ee(ne+pe-1,Q,oe)&&je+1>le[De][ne]&&(ne=Fe),ne===Fe?je++:je=1,Qe||(Qe=ne),De--,Fe=ne-1,nt.push(Fe)}Ae===we&&ye.boostFullMatch&&(nt[0]+=2);const G=Qe-we;return nt[0]-=G,nt}e.fuzzyScore=C;function I(L,x,V,Q,oe,pe){let ye=L-1,we=x-1;for(;ye>=V&&we>=Q;)oe[ye]===pe[we]&&(Be[ye]=we,ye--),we--}function r(L,x,V,Q,oe,pe,ye,we,Ae,De,Fe){if(x[V]!==pe[ye])return Number.MIN_SAFE_INTEGER;let Pe=1,Re=!1;return ye===V-Q?Pe=L[V]===oe[ye]?7:5:Ee(ye,oe,pe)&&(ye===0||!Ee(ye-1,oe,pe))?(Pe=L[V]===oe[ye]?7:5,Re=!0):ie(pe,ye)&&(ye===0||!ie(pe,ye-1))?Pe=5:(ie(pe,ye-1)||de(pe,ye-1))&&(Pe=5,Re=!0),Pe>1&&V===Q&&(Fe[0]=!0),Re||(Re=Ee(ye,oe,pe)||ie(pe,ye-1)||de(pe,ye-1)),V===Q?ye>Ae&&(Pe-=Re?3:5):De?Pe+=Re?2:0:Pe+=Re?0:1,ye+1===we&&(Pe-=Re?3:5),Pe}function i(L,x,V,Q,oe,pe,ye){return w(L,x,V,Q,oe,pe,!0,ye)}e.fuzzyScoreGracefulAggressive=i;function o(L,x,V,Q,oe,pe,ye){return w(L,x,V,Q,oe,pe,!1,ye)}e.fuzzyScoreGraceful=o;function w(L,x,V,Q,oe,pe,ye,we){let Ae=C(L,x,V,Q,oe,pe,we);if(Ae&&!ye)return Ae;if(L.length>=3){const De=Math.min(7,L.length-1);for(let Fe=V+1;Fe<De;Fe++){const Pe=R(L,Fe);if(Pe){const Re=C(Pe,Pe.toLowerCase(),V,Q,oe,pe,we);Re&&(Re[0]-=3,(!Ae||Re[0]>Ae[0])&&(Ae=Re))}}}return Ae}function R(L,x){if(x+1>=L.length)return;const V=L[x],Q=L[x+1];if(V!==Q)return L.slice(0,x)+Q+V+L.slice(x+2)}}),define(me[51],be([1,0,10]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(g){return n(g,0)}e.hash=F;function n(g,c){switch(typeof g){case"object":return g===null?U(349,c):Array.isArray(g)?p(g,c):b(g,c);case"string":return A(g,c);case"boolean":return y(g,c);case"number":return U(g,c);case"undefined":return U(937,c);default:return U(617,c)}}e.doHash=n;function U(g,c){return(c<<5)-c+g|0}e.numberHash=U;function y(g,c){return U(g?433:863,c)}function A(g,c){c=U(149417,c);for(let D=0,u=g.length;D<u;D++)c=U(g.charCodeAt(D),c);return c}e.stringHash=A;function p(g,c){return c=U(104579,c),g.reduce((D,u)=>n(u,D),c)}function b(g,c){return c=U(181387,c),Object.keys(g).sort().reduce((D,u)=>(D=A(u,D),n(g[u],D)),c)}class v{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=n(c,this._value),this._value}}e.Hasher=v;var O;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function l(g,c,D=32){const u=D-c,m=~((1<<u)-1);return(g<<c|(m&g)>>>u)>>>0}function d(g,c=0,D=g.byteLength,u=0){for(let m=0;m<D;m++)g[c+m]=u}function t(g,c,D="0"){for(;g.length<c;)g=D+g;return g}function s(g,c=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(D=>D.toString(16).padStart(2,"0")).join(""):t((g>>>0).toString(16),c/4)}e.toHexString=s;class h{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const D=c.length;if(D===0)return;const u=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,E,k;for(a!==0?(E=a,k=-1,a=0):(E=c.charCodeAt(0),k=0);;){let N=E;if(S.isHighSurrogate(E))if(k+1<D){const H=c.charCodeAt(k+1);S.isLowSurrogate(H)?(k++,N=S.computeCodePoint(E,H)):N=65533}else{a=E;break}else S.isLowSurrogate(E)&&(N=65533);if(m=this._push(u,m,N),k++,k<D)E=c.charCodeAt(k);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(c,D,u){return u<128?c[D++]=u:u<2048?(c[D++]=192|(u&1984)>>>6,c[D++]=128|(u&63)>>>0):u<65536?(c[D++]=224|(u&61440)>>>12,c[D++]=128|(u&4032)>>>6,c[D++]=128|(u&63)>>>0):(c[D++]=240|(u&1835008)>>>18,c[D++]=128|(u&258048)>>>12,c[D++]=128|(u&4032)>>>6,c[D++]=128|(u&63)>>>0),D>=64&&(this._step(),D-=64,this._totalLen+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),D}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=h._bigBlock32,D=this._buffDV;for(let _=0;_<64;_+=4)c.setUint32(_,D.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)c.setUint32(_,l(c.getUint32(_-12,!1)^c.getUint32(_-32,!1)^c.getUint32(_-56,!1)^c.getUint32(_-64,!1),1),!1);let u=this._h0,m=this._h1,a=this._h2,E=this._h3,k=this._h4,N,H,W;for(let _=0;_<80;_++)_<20?(N=m&a|~m&E,H=1518500249):_<40?(N=m^a^E,H=1859775393):_<60?(N=m&a|m&E|a&E,H=2400959708):(N=m^a^E,H=3395469782),W=l(u,5)+N+k+H+c.getUint32(_*4,!1)&4294967295,k=E,E=a,a=l(m,30),m=u,u=W;this._h0=this._h0+u&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+k&4294967295}}e.StringSHA1=h}),define(me[89],be([1,0,77,51]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LcsDiff=e.stringDiff=e.StringDiffSequence=void 0;class n{constructor(l){this.source=l}getElements(){const l=this.source,d=new Int32Array(l.length);for(let t=0,s=l.length;t<s;t++)d[t]=l.charCodeAt(t);return d}}e.StringDiffSequence=n;function U(O,l,d){return new v(new n(O),new n(l)).ComputeDiff(d).changes}e.stringDiff=U;class y{static Assert(l,d){if(!l)throw new Error(d)}}class A{static Copy(l,d,t,s,h){for(let g=0;g<h;g++)t[s+g]=l[d+g]}static Copy2(l,d,t,s,h){for(let g=0;g<h;g++)t[s+g]=l[d+g]}}var p;(function(O){O[O.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(p||(p={}));class b{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new S.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(l,d){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(l,d){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class v{constructor(l,d,t=null){this.ContinueProcessingPredicate=t,this._originalSequence=l,this._modifiedSequence=d;const[s,h,g]=v._getElements(l),[c,D,u]=v._getElements(d);this._hasStrings=g&&u,this._originalStringElements=s,this._originalElementsOrHash=h,this._modifiedStringElements=c,this._modifiedElementsOrHash=D,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(l){return l.length>0&&typeof l[0]=="string"}static _getElements(l){const d=l.getElements();if(v._isStringArray(d)){const t=new Int32Array(d.length);for(let s=0,h=d.length;s<h;s++)t[s]=(0,F.stringHash)(d[s],0);return[d,t,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(l,d){return this._originalElementsOrHash[l]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[l]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(l,d){if(!this.ElementsAreEqual(l,d))return!1;const t=v._getStrictElement(this._originalSequence,l),s=v._getStrictElement(this._modifiedSequence,d);return t===s}static _getStrictElement(l,d){return typeof l.getStrictElement=="function"?l.getStrictElement(d):null}OriginalElementsAreEqual(l,d){return this._originalElementsOrHash[l]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[l]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(l,d){return this._modifiedElementsOrHash[l]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[l]===this._modifiedStringElements[d]:!0}ComputeDiff(l){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,l)}_ComputeDiff(l,d,t,s,h){const g=[!1];let c=this.ComputeDiffRecursive(l,d,t,s,g);return h&&(c=this.PrettifyChanges(c)),{quitEarly:g[0],changes:c}}ComputeDiffRecursive(l,d,t,s,h){for(h[0]=!1;l<=d&&t<=s&&this.ElementsAreEqual(l,t);)l++,t++;for(;d>=l&&s>=t&&this.ElementsAreEqual(d,s);)d--,s--;if(l>d||t>s){let a;return t<=s?(y.Assert(l===d+1,"originalStart should only be one more than originalEnd"),a=[new S.DiffChange(l,0,t,s-t+1)]):l<=d?(y.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),a=[new S.DiffChange(l,d-l+1,t,0)]):(y.Assert(l===d+1,"originalStart should only be one more than originalEnd"),y.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const g=[0],c=[0],D=this.ComputeRecursionPoint(l,d,t,s,g,c,h),u=g[0],m=c[0];if(D!==null)return D;if(!h[0]){const a=this.ComputeDiffRecursive(l,u,t,m,h);let E=[];return h[0]?E=[new S.DiffChange(u+1,d-(u+1)+1,m+1,s-(m+1)+1)]:E=this.ComputeDiffRecursive(u+1,d,m+1,s,h),this.ConcatenateChanges(a,E)}return[new S.DiffChange(l,d-l+1,t,s-t+1)]}WALKTRACE(l,d,t,s,h,g,c,D,u,m,a,E,k,N,H,W,_,B){let z=null,T=null,P=new b,M=d,Y=t,Z=k[0]-W[0]-s,fe=-1073741824,ce=this.m_forwardHistory.length-1;do{const te=Z+l;te===M||te<Y&&u[te-1]<u[te+1]?(a=u[te+1],N=a-Z-s,a<fe&&P.MarkNextChange(),fe=a,P.AddModifiedElement(a+1,N),Z=te+1-l):(a=u[te-1]+1,N=a-Z-s,a<fe&&P.MarkNextChange(),fe=a-1,P.AddOriginalElement(a,N+1),Z=te-1-l),ce>=0&&(u=this.m_forwardHistory[ce],l=u[0],M=1,Y=u.length-1)}while(--ce>=-1);if(z=P.getReverseChanges(),B[0]){let te=k[0]+1,ge=W[0]+1;if(z!==null&&z.length>0){const ke=z[z.length-1];te=Math.max(te,ke.getOriginalEnd()),ge=Math.max(ge,ke.getModifiedEnd())}T=[new S.DiffChange(te,E-te+1,ge,H-ge+1)]}else{P=new b,M=g,Y=c,Z=k[0]-W[0]-D,fe=1073741824,ce=_?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const te=Z+h;te===M||te<Y&&m[te-1]>=m[te+1]?(a=m[te+1]-1,N=a-Z-D,a>fe&&P.MarkNextChange(),fe=a+1,P.AddOriginalElement(a+1,N+1),Z=te+1-h):(a=m[te-1],N=a-Z-D,a>fe&&P.MarkNextChange(),fe=a,P.AddModifiedElement(a+1,N+1),Z=te-1-h),ce>=0&&(m=this.m_reverseHistory[ce],h=m[0],M=1,Y=m.length-1)}while(--ce>=-1);T=P.getChanges()}return this.ConcatenateChanges(z,T)}ComputeRecursionPoint(l,d,t,s,h,g,c){let D=0,u=0,m=0,a=0,E=0,k=0;l--,t--,h[0]=0,g[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const N=d-l+(s-t),H=N+1,W=new Int32Array(H),_=new Int32Array(H),B=s-t,z=d-l,T=l-t,P=d-s,Y=(z-B)%2===0;W[B]=l,_[z]=d,c[0]=!1;for(let Z=1;Z<=N/2+1;Z++){let fe=0,ce=0;m=this.ClipDiagonalBound(B-Z,Z,B,H),a=this.ClipDiagonalBound(B+Z,Z,B,H);for(let ge=m;ge<=a;ge+=2){ge===m||ge<a&&W[ge-1]<W[ge+1]?D=W[ge+1]:D=W[ge-1]+1,u=D-(ge-B)-T;const ke=D;for(;D<d&&u<s&&this.ElementsAreEqual(D+1,u+1);)D++,u++;if(W[ge]=D,D+u>fe+ce&&(fe=D,ce=u),!Y&&Math.abs(ge-z)<=Z-1&&D>=_[ge])return h[0]=D,g[0]=u,ke<=_[ge]&&1447>0&&Z<=1448?this.WALKTRACE(B,m,a,T,z,E,k,P,W,_,D,d,h,u,s,g,Y,c):null}const te=(fe-l+(ce-t)-Z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(fe,te))return c[0]=!0,h[0]=fe,g[0]=ce,te>0&&1447>0&&Z<=1448?this.WALKTRACE(B,m,a,T,z,E,k,P,W,_,D,d,h,u,s,g,Y,c):(l++,t++,[new S.DiffChange(l,d-l+1,t,s-t+1)]);E=this.ClipDiagonalBound(z-Z,Z,z,H),k=this.ClipDiagonalBound(z+Z,Z,z,H);for(let ge=E;ge<=k;ge+=2){ge===E||ge<k&&_[ge-1]>=_[ge+1]?D=_[ge+1]-1:D=_[ge-1],u=D-(ge-z)-P;const ke=D;for(;D>l&&u>t&&this.ElementsAreEqual(D,u);)D--,u--;if(_[ge]=D,Y&&Math.abs(ge-B)<=Z&&D<=W[ge])return h[0]=D,g[0]=u,ke>=W[ge]&&1447>0&&Z<=1448?this.WALKTRACE(B,m,a,T,z,E,k,P,W,_,D,d,h,u,s,g,Y,c):null}if(Z<=1447){let ge=new Int32Array(a-m+2);ge[0]=B-m+1,A.Copy2(W,m,ge,1,a-m+1),this.m_forwardHistory.push(ge),ge=new Int32Array(k-E+2),ge[0]=z-E+1,A.Copy2(_,E,ge,1,k-E+1),this.m_reverseHistory.push(ge)}}return this.WALKTRACE(B,m,a,T,z,E,k,P,W,_,D,d,h,u,s,g,Y,c)}PrettifyChanges(l){for(let d=0;d<l.length;d++){const t=l[d],s=d<l.length-1?l[d+1].originalStart:this._originalElementsOrHash.length,h=d<l.length-1?l[d+1].modifiedStart:this._modifiedElementsOrHash.length,g=t.originalLength>0,c=t.modifiedLength>0;for(;t.originalStart+t.originalLength<s&&t.modifiedStart+t.modifiedLength<h&&(!g||this.OriginalElementsAreEqual(t.originalStart,t.originalStart+t.originalLength))&&(!c||this.ModifiedElementsAreEqual(t.modifiedStart,t.modifiedStart+t.modifiedLength));){const u=this.ElementsAreStrictEqual(t.originalStart,t.modifiedStart);if(this.ElementsAreStrictEqual(t.originalStart+t.originalLength,t.modifiedStart+t.modifiedLength)&&!u)break;t.originalStart++,t.modifiedStart++}const D=[null];if(d<l.length-1&&this.ChangesOverlap(l[d],l[d+1],D)){l[d]=D[0],l.splice(d+1,1),d--;continue}}for(let d=l.length-1;d>=0;d--){const t=l[d];let s=0,h=0;if(d>0){const a=l[d-1];s=a.originalStart+a.originalLength,h=a.modifiedStart+a.modifiedLength}const g=t.originalLength>0,c=t.modifiedLength>0;let D=0,u=this._boundaryScore(t.originalStart,t.originalLength,t.modifiedStart,t.modifiedLength);for(let a=1;;a++){const E=t.originalStart-a,k=t.modifiedStart-a;if(E<s||k<h||g&&!this.OriginalElementsAreEqual(E,E+t.originalLength)||c&&!this.ModifiedElementsAreEqual(k,k+t.modifiedLength))break;const H=(E===s&&k===h?5:0)+this._boundaryScore(E,t.originalLength,k,t.modifiedLength);H>u&&(u=H,D=a)}t.originalStart-=D,t.modifiedStart-=D;const m=[null];if(d>0&&this.ChangesOverlap(l[d-1],l[d],m)){l[d-1]=m[0],l.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,t=l.length;d<t;d++){const s=l[d-1],h=l[d],g=h.originalStart-s.originalStart-s.originalLength,c=s.originalStart,D=h.originalStart+h.originalLength,u=D-c,m=s.modifiedStart,a=h.modifiedStart+h.modifiedLength,E=a-m;if(g<5&&u<20&&E<20){const k=this._findBetterContiguousSequence(c,u,m,E,g);if(k){const[N,H]=k;(N!==s.originalStart+s.originalLength||H!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=N-s.originalStart,s.modifiedLength=H-s.modifiedStart,h.originalStart=N+g,h.modifiedStart=H+g,h.originalLength=D-h.originalStart,h.modifiedLength=a-h.modifiedStart)}}}return l}_findBetterContiguousSequence(l,d,t,s,h){if(d<h||s<h)return null;const g=l+d-h+1,c=t+s-h+1;let D=0,u=0,m=0;for(let a=l;a<g;a++)for(let E=t;E<c;E++){const k=this._contiguousSequenceScore(a,E,h);k>0&&k>D&&(D=k,u=a,m=E)}return D>0?[u,m]:null}_contiguousSequenceScore(l,d,t){let s=0;for(let h=0;h<t;h++){if(!this.ElementsAreEqual(l+h,d+h))return 0;s+=this._originalStringElements[l+h].length}return s}_OriginalIsBoundary(l){return l<=0||l>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[l])}_OriginalRegionIsBoundary(l,d){if(this._OriginalIsBoundary(l)||this._OriginalIsBoundary(l-1))return!0;if(d>0){const t=l+d;if(this._OriginalIsBoundary(t-1)||this._OriginalIsBoundary(t))return!0}return!1}_ModifiedIsBoundary(l){return l<=0||l>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[l])}_ModifiedRegionIsBoundary(l,d){if(this._ModifiedIsBoundary(l)||this._ModifiedIsBoundary(l-1))return!0;if(d>0){const t=l+d;if(this._ModifiedIsBoundary(t-1)||this._ModifiedIsBoundary(t))return!0}return!1}_boundaryScore(l,d,t,s){const h=this._OriginalRegionIsBoundary(l,d)?1:0,g=this._ModifiedRegionIsBoundary(t,s)?1:0;return h+g}ConcatenateChanges(l,d){const t=[];if(l.length===0||d.length===0)return d.length>0?d:l;if(this.ChangesOverlap(l[l.length-1],d[0],t)){const s=new Array(l.length+d.length-1);return A.Copy(l,0,s,0,l.length-1),s[l.length-1]=t[0],A.Copy(d,1,s,l.length,d.length-1),s}else{const s=new Array(l.length+d.length);return A.Copy(l,0,s,0,l.length),A.Copy(d,0,s,l.length,d.length),s}}ChangesOverlap(l,d,t){if(y.Assert(l.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),y.Assert(l.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=d.originalStart||l.modifiedStart+l.modifiedLength>=d.modifiedStart){const s=l.originalStart;let h=l.originalLength;const g=l.modifiedStart;let c=l.modifiedLength;return l.originalStart+l.originalLength>=d.originalStart&&(h=d.originalStart+d.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=d.modifiedStart&&(c=d.modifiedStart+d.modifiedLength-l.modifiedStart),t[0]=new S.DiffChange(s,h,g,c),!0}else return t[0]=null,!1}ClipDiagonalBound(l,d,t,s){if(l>=0&&l<s)return l;const h=t,g=s-t-1,c=d%2===0;if(l<0){const D=h%2===0;return c===D?0:1}else{const D=g%2===0;return c===D?s-1:s-2}}}e.LcsDiff=v}),define(me[52],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(me[90],be([1,0,12,10]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const t=d.charCodeAt(0),s=this._value.charCodeAt(this._pos);return t-s}value(){return this._value[this._pos]}}e.StringIterator=n;class U{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,F.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=U;class y{constructor(d=!0,t=!0){this._splitOnBackslash=d,this._caseSensitive=t}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let t=d.length-1;t>=0;t--,this._valueLen--){const s=this._value.charCodeAt(t);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,F.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var A;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(A||(A={}));class p{constructor(d,t){this._ignorePathCasing=d,this._ignoreQueryAndFragment=t,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,F.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(v||(v={}));class O{static forUris(d=()=>!1,t=()=>!1){return new O(new p(d,t))}static forPaths(d=!1){return new O(new y(void 0,!d))}static forStrings(){return new O(new n)}static forConfigKeys(){return new O(new U)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,t){if(t){const s=t.slice(0);(0,S.shuffle)(s);for(const h of s)this.set(h,d)}else{const s=d.slice(0);(0,S.shuffle)(s);for(const h of s)this.set(h[0],h[1])}}set(d,t){const s=this._iter.reset(d);let h;this._root||(this._root=new b,this._root.segment=s.value());const g=[];for(h=this._root;;){const D=s.cmp(h.segment);if(D>0)h.left||(h.left=new b,h.left.segment=s.value()),g.push([-1,h]),h=h.left;else if(D<0)h.right||(h.right=new b,h.right.segment=s.value()),g.push([1,h]),h=h.right;else if(s.hasNext())s.next(),h.mid||(h.mid=new b,h.mid.segment=s.value()),g.push([0,h]),h=h.mid;else break}const c=h.value;h.value=t,h.key=d;for(let D=g.length-1;D>=0;D--){const u=g[D][1];u.updateHeight();const m=u.balanceFactor();if(m<-1||m>1){const a=g[D][0],E=g[D+1][0];if(a===1&&E===1)g[D][1]=u.rotateLeft();else if(a===-1&&E===-1)g[D][1]=u.rotateRight();else if(a===1&&E===-1)u.right=g[D+1][1]=g[D+1][1].rotateRight(),g[D][1]=u.rotateLeft();else if(a===-1&&E===1)u.left=g[D+1][1]=g[D+1][1].rotateLeft(),g[D][1]=u.rotateRight();else throw new Error;if(D>0)switch(g[D-1][0]){case-1:g[D-1][1].left=g[D][1];break;case 1:g[D-1][1].right=g[D][1];break;case 0:g[D-1][1].mid=g[D][1];break}else this._root=g[0][1]}}return c}get(d){return this._getNode(d)?.value}_getNode(d){const t=this._iter.reset(d);let s=this._root;for(;s;){const h=t.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(t.hasNext())t.next(),s=s.mid;else break}return s}has(d){const t=this._getNode(d);return!(t?.value===void 0&&t?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,t){const s=this._iter.reset(d),h=[];let g=this._root;for(;g;){const c=s.cmp(g.segment);if(c>0)h.push([-1,g]),g=g.left;else if(c<0)h.push([1,g]),g=g.right;else if(s.hasNext())s.next(),h.push([0,g]),g=g.mid;else break}if(g){if(t?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const c=this._min(g.right);if(c.key){const{key:D,value:u,segment:m}=c;this._delete(c.key,!1),g.key=D,g.value=u,g.segment=m}}else{const c=g.left??g.right;if(h.length>0){const[D,u]=h[h.length-1];switch(D){case-1:u.left=c;break;case 0:u.mid=c;break;case 1:u.right=c;break}}else this._root=c}for(let c=h.length-1;c>=0;c--){const D=h[c][1];D.updateHeight();const u=D.balanceFactor();if(u>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),h[c][1]=D.rotateLeft()):u<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),h[c][1]=D.rotateRight()),c>0)switch(h[c-1][0]){case-1:h[c-1][1].left=h[c][1];break;case 1:h[c-1][1].right=h[c][1];break;case 0:h[c-1][1].mid=h[c][1];break}else this._root=h[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const t=this._iter.reset(d);let s=this._root,h;for(;s;){const g=t.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(t.hasNext())t.next(),h=s.value||h,s=s.mid;else break}return s&&s.value||h}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,t){const s=this._iter.reset(d);let h=this._root;for(;h;){const g=s.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(s.hasNext())s.next(),h=h.mid;else return h.mid?this._entries(h.mid):t?h.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[t,s]of this)d(s,t)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const t=[];return this._dfsEntries(d,t),t[Symbol.iterator]()}_dfsEntries(d,t){d&&(d.left&&this._dfsEntries(d.left,t),d.value&&t.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,t),d.right&&this._dfsEntries(d.right,t))}_isBalanced(){const d=t=>{if(!t)return!0;const s=t.balanceFactor();return s<-1||s>1?!1:d(t.left)&&d(t.right)};return d(this._root)}}e.TernarySearchTree=O}),define(me[7],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(m){return typeof m=="string"}e.isString=S;function F(m){return Array.isArray(m)&&m.every(a=>S(a))}e.isStringArray=F;function n(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=n;function U(m){const a=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof a}e.isTypedArray=U;function y(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=y;function A(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=A;function p(m){return m===!0||m===!1}e.isBoolean=p;function b(m){return typeof m>"u"}e.isUndefined=b;function v(m){return!O(m)}e.isDefined=v;function O(m){return b(m)||m===null}e.isUndefinedOrNull=O;function l(m,a){if(!m)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=l;function d(m){if(O(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=d;function t(...m){const a=[];for(let E=0;E<m.length;E++){const k=m[E];if(O(k))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);a.push(k)}return a}e.assertAllDefined=t;const s=Object.prototype.hasOwnProperty;function h(m){if(!n(m))return!1;for(const a in m)if(s.call(m,a))return!1;return!0}e.isEmptyObject=h;function g(m){return typeof m=="function"}e.isFunction=g;function c(...m){return m.length>0&&m.every(g)}e.areFunctions=c;function D(m,a){const E=Math.min(m.length,a.length);for(let k=0;k<E;k++)u(m[k],a[k])}e.validateConstraints=D;function u(m,a){if(S(a)){if(typeof m!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(g(a)){try{if(m instanceof a)return}catch{}if(!O(m)&&m.constructor===a||a.length===1&&a.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u}),define(me[17],be([1,0,7]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const F=Object.create(null);function n(A,p){if((0,S.isString)(p)){const b=F[p];if(b===void 0)throw new Error(`${A} references an unknown codicon: ${p}`);p=b}return F[A]=p,{id:A}}function U(){return F}e.getCodiconFontCharacters=U;function y(){return Object.values(e.Codicon)}e.getAllCodicons=y,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),runAllCoverage:n("run-all-coverage",60461),runCoverage:n("run-all-coverage",60460),coverage:n("coverage",60462),githubProject:n("github-project",60463),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(me[53],be([1,0,7]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const c=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([D,u])=>{c[D]=u&&typeof u=="object"?F(u):u}),c}e.deepClone=F;function n(g){if(!g||typeof g!="object")return g;const c=[g];for(;c.length>0;){const D=c.shift();Object.freeze(D);for(const u in D)if(U.call(D,u)){const m=D[u];typeof m=="object"&&!Object.isFrozen(m)&&!(0,S.isTypedArray)(m)&&c.push(m)}}return g}e.deepFreeze=n;const U=Object.prototype.hasOwnProperty;function y(g,c){return A(g,c,new Set)}e.cloneAndChange=y;function A(g,c,D){if((0,S.isUndefinedOrNull)(g))return g;const u=c(g);if(typeof u<"u")return u;if(Array.isArray(g)){const m=[];for(const a of g)m.push(A(a,c,D));return m}if((0,S.isObject)(g)){if(D.has(g))throw new Error("Cannot clone recursive data-structure");D.add(g);const m={};for(const a in g)U.call(g,a)&&(m[a]=A(g[a],c,D));return D.delete(g),m}return g}function p(g,c,D=!0){return(0,S.isObject)(g)?((0,S.isObject)(c)&&Object.keys(c).forEach(u=>{u in g?D&&((0,S.isObject)(g[u])&&(0,S.isObject)(c[u])?p(g[u],c[u],D):g[u]=c[u]):g[u]=c[u]}),g):c}e.mixin=p;function b(g,c){if(g===c)return!0;if(g==null||c===null||c===void 0||typeof g!=typeof c||typeof g!="object"||Array.isArray(g)!==Array.isArray(c))return!1;let D,u;if(Array.isArray(g)){if(g.length!==c.length)return!1;for(D=0;D<g.length;D++)if(!b(g[D],c[D]))return!1}else{const m=[];for(u in g)m.push(u);m.sort();const a=[];for(u in c)a.push(u);if(a.sort(),!b(m,a))return!1;for(D=0;D<m.length;D++)if(!b(g[m[D]],c[m[D]]))return!1}return!0}e.equals=b;function v(g){const c=new Set;return JSON.stringify(g,(D,u)=>{if((0,S.isObject)(u)||Array.isArray(u)){if(c.has(u))return"[Circular]";c.add(u)}return u})}e.safeStringify=v;function O(g,c){const D=Object.create(null);return!g||!c||Object.keys(c).forEach(m=>{const a=g[m],E=c[m];b(a,E)||(D[m]=E)}),D}e.distinct=O;function l(g,c){const D=c.toLowerCase(),u=Object.keys(g).find(m=>m.toLowerCase()===D);return u?g[u]:g[c]}e.getCaseInsensitive=l;function d(g,c){const D=Object.create(null);for(const[u,m]of Object.entries(g))c(u,m)&&(D[u]=m);return D}e.filter=d;function t(g){let c=[];for(;Object.prototype!==g;)c=c.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return c}e.getAllPropertyNames=t;function s(g){const c=[];for(const D of t(g))typeof g[D]=="function"&&c.push(D);return c}e.getAllMethodNames=s;function h(g,c){const D=m=>function(){const a=Array.prototype.slice.call(arguments,0);return c(m,a)},u={};for(const m of g)u[m]=D(m);return u}e.createProxyObject=h}),define(me[18],be([1,0,17]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var F;(function(y){function A(p){return p&&typeof p=="object"&&typeof p.id=="string"}y.isThemeColor=A})(F||(e.ThemeColor=F={}));function n(y){return{id:y}}e.themeColorFromId=n;var U;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function p(c){const D=A.exec(c.id);if(!D)return p(S.Codicon.error);const[,u,m]=D,a=["codicon","codicon-"+u];return m&&a.push("codicon-modifier-"+m.substring(1)),a}y.asClassNameArray=p;function b(c){return p(c).join(" ")}y.asClassName=b;function v(c){return"."+p(c).join(".")}y.asCSSSelector=v;function O(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||F.isThemeColor(c.color))}y.isThemeIcon=O;const l=new RegExp(`^\\$\\((${y.iconNameExpression}(?:${y.iconModifierExpression})?)\\)$`);function d(c){const D=l.exec(c);if(!D)return;const[,u]=D;return{id:u}}y.fromString=d;function t(c){return{id:c}}y.fromId=t;function s(c,D){let u=c.id;const m=u.lastIndexOf("~");return m!==-1&&(u=u.substring(0,m)),D&&(u=`${u}~${D}`),{id:u}}y.modify=s;function h(c){const D=c.id.lastIndexOf("~");if(D!==-1)return c.id.substring(D+1)}y.getModifier=h;function g(c,D){return c.id===D.id&&c.color?.id===D.color?.id}y.isEqual=g})(U||(e.ThemeIcon=U={}))}),define(me[37],be([1,0,36,10,18]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const U="$(",y=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function p(g){return g.replace(A,(c,D)=>D?c:`\\${c}`)}e.escapeIcons=p;const b=new RegExp(`\\\\${y.source}`,"g");function v(g){return g.replace(b,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=v;const O=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function l(g){return g.indexOf(U)===-1?g:g.replace(O,(c,D,u,m)=>u?c:D||m||"")}e.stripIcons=l;function d(g){return g?g.replace(/\$\((.*?)\)/g,(c,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=d;const t=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(g){t.lastIndex=0;let c="";const D=[];let u=0;for(;;){const m=t.lastIndex,a=t.exec(g),E=g.substring(m,a?.index);if(E.length>0){c+=E;for(let k=0;k<E.length;k++)D.push(u)}if(!a)break;u+=a[0].length}return{text:c,iconOffsets:D}}e.parseLabelWithIcons=s;function h(g,c,D=!1){const{text:u,iconOffsets:m}=c;if(!m||m.length===0)return(0,S.matchesFuzzy)(g,u,D);const a=(0,F.ltrim)(u," "),E=u.length-a.length,k=(0,S.matchesFuzzy)(g,a,D);if(k)for(const N of k){const H=m[N.start+E]+E;N.start+=H,N.end+=H}return k}e.matchesFuzzyIconAware=h}),define(me[91],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[92],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(n,U){this.sender=n,this.onMessage=U}send(n){try{this.sender.send("vscode:message",n.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(me[31],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.context=e.process=e.webFrame=e.ipcMessagePort=e.ipcRenderer=void 0;const S=globalThis.vscode;e.ipcRenderer=S.ipcRenderer,e.ipcMessagePort=S.ipcMessagePort,e.webFrame=S.webFrame,e.process=S.process,e.context=S.context}),define(me[93],be([1,0,91,31]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.popup=void 0;let n=0;function U(A,p,b){const v=[],O=n++,l=`vscode:onContextMenu${O}`,d=(t,s,h)=>{v[s].click?.(h)};F.ipcRenderer.once(l,d),F.ipcRenderer.once(S.CONTEXT_MENU_CLOSE_CHANNEL,(t,s)=>{s===O&&(F.ipcRenderer.removeListener(l,d),b?.())}),F.ipcRenderer.send(S.CONTEXT_MENU_CHANNEL,O,A.map(t=>y(t,v)),l,p)}e.popup=U;function y(A,p){const b={id:p.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return p.push(A),Array.isArray(A.submenu)&&(b.submenu=A.submenu.map(v=>y(v,p))),b}}),define(me[54],be([8]),{}),define(me[94],be([8]),{}),define(me[95],be([8]),{}),define(me[96],be([8]),{}),define(me[97],be([1,0,95,96]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0})}),define(me[98],be([8]),{}),define(me[99],be([8]),{}),define(me[100],be([8]),{}),define(me[101],be([8]),{}),define(me[102],be([8]),{}),define(me[103],be([8]),{}),define(me[104],be([8]),{}),define(me[105],be([8]),{}),define(me[106],be([8]),{}),define(me[107],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/actionbar/actionViewItems",e)}),define(me[108],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/findinput/findInput",e)}),define(me[109],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/findinput/findInputToggles",e)}),define(me[110],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/iconLabel/iconLabelHover",e)}),define(me[111],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/inputbox/inputBox",e)}),define(me[112],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",e)}),define(me[113],be([13,11]),function(se,e){return se.create("vs/base/browser/ui/tree/abstractTree",e)}),define(me[114],be([13,11]),function(se,e){return se.create("vs/base/common/actions",e)}),define(me[38],be([1,0,4,3,114]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class U extends F.Disposable{constructor(l,d="",t="",s=!0,h){super(),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=d,this._cssClass=t,this._enabled=s,this._actionCallback=h}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,d){this._actionCallback&&await this._actionCallback(l)}}e.Action=U;class y extends F.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new S.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new S.Emitter),this.onDidRun=this._onDidRun.event}async run(l,d){if(!l.enabled)return;this._onWillRun.fire({action:l});let t;try{await this.runAction(l,d)}catch(s){t=s}this._onDidRun.fire({action:l,error:t})}async runAction(l,d){await l.run(d)}}e.ActionRunner=y;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let d=[];for(const t of l)t.length&&(d.length?d=[...d,new A,...t]:d=t);return d}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=A;class p{get actions(){return this._actions}constructor(l,d,t,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=d,this.class=s,this._actions=t}async run(){}}e.SubmenuAction=p;class b extends U{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,n.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=b;function v(O){return{id:O.id,label:O.label,class:O.class,enabled:O.enabled??!0,checked:O.checked,run:async(...l)=>O.run(...l),tooltip:O.label}}e.toAction=v}),define(me[115],be([13,11]),function(se,e){return se.create("vs/base/common/platform",e)}),define(me[5],be([1,0,115]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let F=!1,n=!1,U=!1,y=!1,A=!1,p=!1,b=!1,v=!1,O=!1,l=!1,d,t=e.LANGUAGE_DEFAULT,s=e.LANGUAGE_DEFAULT,h,g;const c=globalThis;let D;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?D=c.vscode.process:typeof process<"u"&&(D=process);const u=typeof D?.versions?.electron=="string",m=u&&D?.type==="renderer";if(typeof D=="object"){F=D.platform==="win32",n=D.platform==="darwin",U=D.platform==="linux",y=U&&!!D.env.SNAP&&!!D.env.SNAP_REVISION,b=u,O=!!D.env.CI||!!D.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,t=e.LANGUAGE_DEFAULT;const T=D.env.VSCODE_NLS_CONFIG;if(T)try{const P=JSON.parse(T),M=P.availableLanguages["*"];d=P.locale,s=P.osLocale,t=M||e.LANGUAGE_DEFAULT,h=P._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!m?(g=navigator.userAgent,F=g.indexOf("Windows")>=0,n=g.indexOf("Macintosh")>=0,v=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=g.indexOf("Linux")>=0,l=g?.indexOf("Mobi")>=0,p=!0,d=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,t=d,s=navigator.language):console.error("Unable to resolve platform.");var a;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(a||(e.Platform=a={}));function E(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let k=0;n?k=1:F?k=3:U&&(k=2),e.isWindows=F,e.isMacintosh=n,e.isLinux=U,e.isLinuxSnap=y,e.isNative=A,e.isElectron=b,e.isWeb=p,e.isWebWorker=p&&typeof c.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?c.origin:void 0,e.isIOS=v,e.isMobile=l,e.isCI=O,e.platform=k,e.userAgent=g,e.language=t;var N;(function(T){function P(){return e.language}T.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}T.isDefaultVariant=M;function Y(){return e.language==="en"}T.isDefault=Y})(N||(e.Language=N={})),e.locale=d,e.platformLocale=s,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof c.postMessage=="function"&&!c.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const T=[];c.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let Y=0,Z=T.length;Y<Z;Y++){const fe=T[Y];if(fe.id===M.data.vscodeScheduleAsyncWork){T.splice(Y,1),fe.callback();return}}});let P=0;return M=>{const Y=++P;T.push({id:Y,callback:M}),c.postMessage({vscodeScheduleAsyncWork:Y},"*")}}return T=>setTimeout(T)})();var H;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(H||(e.OperatingSystem=H={})),e.OS=n||v?2:F?1:3;let W=!0,_=!1;function B(){if(!_){_=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,W=new Uint16Array(T.buffer)[0]===513}return W}e.isLittleEndian=B,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function z(T){return parseFloat(T)>=20}e.isBigSurOrNewer=z}),define(me[116],be([1,0,16,21,5]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BrowserFeatures=e.KeyboardSupport=void 0;var U;(function(y){y[y.Always=0]="Always",y[y.FullScreen=1]="FullScreen",y[y.None=2]="None"})(U||(e.KeyboardSupport=U={})),e.BrowserFeatures={clipboard:{writeText:n.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:n.isNative||S.isStandalone()?0:navigator.keyboard||S.isSafari?1:2,touch:"ontouchstart"in F.mainWindow||navigator.maxTouchPoints>0,pointerEvents:F.mainWindow.PointerEvent&&("ontouchstart"in F.mainWindow||navigator.maxTouchPoints>0)}}),define(me[14],be([1,0,16,47,80,5]),function(se,e,S,F,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StandardKeyboardEvent=e.printStandardKeyboardEvent=e.printKeyboardEvent=void 0;function y(t){if(t.charCode){const h=String.fromCharCode(t.charCode).toUpperCase();return F.KeyCodeUtils.fromString(h)}const s=t.keyCode;if(s===3)return 7;if(S.isFirefox)switch(s){case 59:return 85;case 60:if(U.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.isMacintosh)return 57;break}else if(S.isWebKit){if(U.isMacintosh&&s===93)return 57;if(!U.isMacintosh&&s===92)return 57}return F.EVENT_KEY_CODE_MAP[s]||0}const A=U.isMacintosh?256:2048,p=512,b=1024,v=U.isMacintosh?2048:256;function O(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode}, key: ${t.key}`}e.printKeyboardEvent=O;function l(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode} ('${F.KeyCodeUtils.toString(t.keyCode)}')`}e.printStandardKeyboardEvent=l;class d{constructor(s){this._standardKeyboardEventBrand=!0;const h=s;this.browserEvent=h,this.target=h.target,this.ctrlKey=h.ctrlKey,this.shiftKey=h.shiftKey,this.altKey=h.altKey,this.metaKey=h.metaKey,this.altGraphKey=h.getModifierState("AltGraph"),this.keyCode=y(h),this.code=h.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(s){return this._asKeybinding===s}_computeKeybinding(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let h=0;return this.ctrlKey&&(h|=A),this.altKey&&(h|=p),this.shiftKey&&(h|=b),this.metaKey&&(h|=v),h|=s,h}_computeKeyCodeChord(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}e.StandardKeyboardEvent=d}),define(me[19],be([1,0,16,71,5]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StandardWheelEvent=e.DragMouseEvent=e.StandardMouseEvent=void 0;class U{constructor(b,v){this.timestamp=Date.now(),this.browserEvent=v,this.leftButton=v.button===0,this.middleButton=v.button===1,this.rightButton=v.button===2,this.buttons=v.buttons,this.target=v.target,this.detail=v.detail||1,v.type==="dblclick"&&(this.detail=2),this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,typeof v.pageX=="number"?(this.posx=v.pageX,this.posy=v.pageY):(this.posx=v.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=v.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const O=F.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(b,v.view);this.posx-=O.left,this.posy-=O.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}e.StandardMouseEvent=U;class y extends U{constructor(b,v){super(b,v),this.dataTransfer=v.dataTransfer}}e.DragMouseEvent=y;class A{constructor(b,v=0,O=0){this.browserEvent=b||null,this.target=b?b.target||b.targetNode||b.srcElement:null,this.deltaY=O,this.deltaX=v;let l=!1;if(S.isChrome){const d=navigator.userAgent.match(/Chrome\/(\d+)/);l=(d?parseInt(d[1]):123)<=122}if(b){const d=b,t=b,s=b.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")l?this.deltaY=d.wheelDeltaY/(120*s):this.deltaY=d.wheelDeltaY/120;else if(typeof t.VERTICAL_AXIS<"u"&&t.axis===t.VERTICAL_AXIS)this.deltaY=-t.detail/3;else if(b.type==="wheel"){const h=b;h.deltaMode===h.DOM_DELTA_LINE?S.isFirefox&&!n.isMacintosh?this.deltaY=-b.deltaY/3:this.deltaY=-b.deltaY:this.deltaY=-b.deltaY/40}if(typeof d.wheelDeltaX<"u")S.isSafari&&n.isWindows?this.deltaX=-(d.wheelDeltaX/120):l?this.deltaX=d.wheelDeltaX/(120*s):this.deltaX=d.wheelDeltaX/120;else if(typeof t.HORIZONTAL_AXIS<"u"&&t.axis===t.HORIZONTAL_AXIS)this.deltaX=-b.detail/3;else if(b.type==="wheel"){const h=b;h.deltaMode===h.DOM_DELTA_LINE?S.isFirefox&&!n.isMacintosh?this.deltaX=-b.deltaX/3:this.deltaX=-b.deltaX:this.deltaX=-b.deltaX/40}this.deltaY===0&&this.deltaX===0&&b.wheelDelta&&(l?this.deltaY=b.wheelDelta/(120*s):this.deltaY=b.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}e.StandardWheelEvent=A}),define(me[117],be([1,0,5]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let F;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const U=n.process;F={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.arch=F.arch}),define(me[24],be([1,0,117]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,n=97,U=90,y=122,A=46,p=47,b=92,v=58,O=63;class l extends Error{constructor(E,k,N){let H;typeof k=="string"&&k.indexOf("not ")===0?(H="must not be",k=k.replace(/^not /,"")):H="must be";const W=E.indexOf(".")!==-1?"property":"argument";let _=`The "${E}" ${W} ${H} of type ${k}`;_+=`. Received type ${typeof N}`,super(_),this.code="ERR_INVALID_ARG_TYPE"}}function d(a,E){if(a===null||typeof a!="object")throw new l(E,"Object",a)}function t(a,E){if(typeof a!="string")throw new l(E,"string",a)}const s=S.platform==="win32";function h(a){return a===p||a===b}function g(a){return a===p}function c(a){return a>=F&&a<=U||a>=n&&a<=y}function D(a,E,k,N){let H="",W=0,_=-1,B=0,z=0;for(let T=0;T<=a.length;++T){if(T<a.length)z=a.charCodeAt(T);else{if(N(z))break;z=p}if(N(z)){if(!(_===T-1||B===1))if(B===2){if(H.length<2||W!==2||H.charCodeAt(H.length-1)!==A||H.charCodeAt(H.length-2)!==A){if(H.length>2){const P=H.lastIndexOf(k);P===-1?(H="",W=0):(H=H.slice(0,P),W=H.length-1-H.lastIndexOf(k)),_=T,B=0;continue}else if(H.length!==0){H="",W=0,_=T,B=0;continue}}E&&(H+=H.length>0?`${k}..`:"..",W=2)}else H.length>0?H+=`${k}${a.slice(_+1,T)}`:H=a.slice(_+1,T),W=T-_-1;_=T,B=0}else z===A&&B!==-1?++B:B=-1}return H}function u(a,E){d(E,"pathObject");const k=E.dir||E.root,N=E.base||`${E.name||""}${E.ext||""}`;return k?k===E.root?`${k}${N}`:`${k}${a}${N}`:N}e.win32={resolve(...a){let E="",k="",N=!1;for(let H=a.length-1;H>=-1;H--){let W;if(H>=0){if(W=a[H],t(W,"path"),W.length===0)continue}else E.length===0?W=S.cwd():(W=S.env[`=${E}`]||S.cwd(),(W===void 0||W.slice(0,2).toLowerCase()!==E.toLowerCase()&&W.charCodeAt(2)===b)&&(W=`${E}\\`));const _=W.length;let B=0,z="",T=!1;const P=W.charCodeAt(0);if(_===1)h(P)&&(B=1,T=!0);else if(h(P))if(T=!0,h(W.charCodeAt(1))){let M=2,Y=M;for(;M<_&&!h(W.charCodeAt(M));)M++;if(M<_&&M!==Y){const Z=W.slice(Y,M);for(Y=M;M<_&&h(W.charCodeAt(M));)M++;if(M<_&&M!==Y){for(Y=M;M<_&&!h(W.charCodeAt(M));)M++;(M===_||M!==Y)&&(z=`\\\\${Z}\\${W.slice(Y,M)}`,B=M)}}}else B=1;else c(P)&&W.charCodeAt(1)===v&&(z=W.slice(0,2),B=2,_>2&&h(W.charCodeAt(2))&&(T=!0,B=3));if(z.length>0)if(E.length>0){if(z.toLowerCase()!==E.toLowerCase())continue}else E=z;if(N){if(E.length>0)break}else if(k=`${W.slice(B)}\\${k}`,N=T,T&&E.length>0)break}return k=D(k,!N,"\\",h),N?`${E}\\${k}`:`${E}${k}`||"."},normalize(a){t(a,"path");const E=a.length;if(E===0)return".";let k=0,N,H=!1;const W=a.charCodeAt(0);if(E===1)return g(W)?"\\":a;if(h(W))if(H=!0,h(a.charCodeAt(1))){let B=2,z=B;for(;B<E&&!h(a.charCodeAt(B));)B++;if(B<E&&B!==z){const T=a.slice(z,B);for(z=B;B<E&&h(a.charCodeAt(B));)B++;if(B<E&&B!==z){for(z=B;B<E&&!h(a.charCodeAt(B));)B++;if(B===E)return`\\\\${T}\\${a.slice(z)}\\`;B!==z&&(N=`\\\\${T}\\${a.slice(z,B)}`,k=B)}}}else k=1;else c(W)&&a.charCodeAt(1)===v&&(N=a.slice(0,2),k=2,E>2&&h(a.charCodeAt(2))&&(H=!0,k=3));let _=k<E?D(a.slice(k),!H,"\\",h):"";return _.length===0&&!H&&(_="."),_.length>0&&h(a.charCodeAt(E-1))&&(_+="\\"),N===void 0?H?`\\${_}`:_:H?`${N}\\${_}`:`${N}${_}`},isAbsolute(a){t(a,"path");const E=a.length;if(E===0)return!1;const k=a.charCodeAt(0);return h(k)||E>2&&c(k)&&a.charCodeAt(1)===v&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let E,k;for(let W=0;W<a.length;++W){const _=a[W];t(_,"path"),_.length>0&&(E===void 0?E=k=_:E+=`\\${_}`)}if(E===void 0)return".";let N=!0,H=0;if(typeof k=="string"&&h(k.charCodeAt(0))){++H;const W=k.length;W>1&&h(k.charCodeAt(1))&&(++H,W>2&&(h(k.charCodeAt(2))?++H:N=!1))}if(N){for(;H<E.length&&h(E.charCodeAt(H));)H++;H>=2&&(E=`\\${E.slice(H)}`)}return e.win32.normalize(E)},relative(a,E){if(t(a,"from"),t(E,"to"),a===E)return"";const k=e.win32.resolve(a),N=e.win32.resolve(E);if(k===N||(a=k.toLowerCase(),E=N.toLowerCase(),a===E))return"";let H=0;for(;H<a.length&&a.charCodeAt(H)===b;)H++;let W=a.length;for(;W-1>H&&a.charCodeAt(W-1)===b;)W--;const _=W-H;let B=0;for(;B<E.length&&E.charCodeAt(B)===b;)B++;let z=E.length;for(;z-1>B&&E.charCodeAt(z-1)===b;)z--;const T=z-B,P=_<T?_:T;let M=-1,Y=0;for(;Y<P;Y++){const fe=a.charCodeAt(H+Y);if(fe!==E.charCodeAt(B+Y))break;fe===b&&(M=Y)}if(Y!==P){if(M===-1)return N}else{if(T>P){if(E.charCodeAt(B+Y)===b)return N.slice(B+Y+1);if(Y===2)return N.slice(B+Y)}_>P&&(a.charCodeAt(H+Y)===b?M=Y:Y===2&&(M=3)),M===-1&&(M=0)}let Z="";for(Y=H+M+1;Y<=W;++Y)(Y===W||a.charCodeAt(Y)===b)&&(Z+=Z.length===0?"..":"\\..");return B+=M,Z.length>0?`${Z}${N.slice(B,z)}`:(N.charCodeAt(B)===b&&++B,N.slice(B,z))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const E=e.win32.resolve(a);if(E.length<=2)return a;if(E.charCodeAt(0)===b){if(E.charCodeAt(1)===b){const k=E.charCodeAt(2);if(k!==O&&k!==A)return`\\\\?\\UNC\\${E.slice(2)}`}}else if(c(E.charCodeAt(0))&&E.charCodeAt(1)===v&&E.charCodeAt(2)===b)return`\\\\?\\${E}`;return a},dirname(a){t(a,"path");const E=a.length;if(E===0)return".";let k=-1,N=0;const H=a.charCodeAt(0);if(E===1)return h(H)?a:".";if(h(H)){if(k=N=1,h(a.charCodeAt(1))){let B=2,z=B;for(;B<E&&!h(a.charCodeAt(B));)B++;if(B<E&&B!==z){for(z=B;B<E&&h(a.charCodeAt(B));)B++;if(B<E&&B!==z){for(z=B;B<E&&!h(a.charCodeAt(B));)B++;if(B===E)return a;B!==z&&(k=N=B+1)}}}}else c(H)&&a.charCodeAt(1)===v&&(k=E>2&&h(a.charCodeAt(2))?3:2,N=k);let W=-1,_=!0;for(let B=E-1;B>=N;--B)if(h(a.charCodeAt(B))){if(!_){W=B;break}}else _=!1;if(W===-1){if(k===-1)return".";W=k}return a.slice(0,W)},basename(a,E){E!==void 0&&t(E,"ext"),t(a,"path");let k=0,N=-1,H=!0,W;if(a.length>=2&&c(a.charCodeAt(0))&&a.charCodeAt(1)===v&&(k=2),E!==void 0&&E.length>0&&E.length<=a.length){if(E===a)return"";let _=E.length-1,B=-1;for(W=a.length-1;W>=k;--W){const z=a.charCodeAt(W);if(h(z)){if(!H){k=W+1;break}}else B===-1&&(H=!1,B=W+1),_>=0&&(z===E.charCodeAt(_)?--_===-1&&(N=W):(_=-1,N=B))}return k===N?N=B:N===-1&&(N=a.length),a.slice(k,N)}for(W=a.length-1;W>=k;--W)if(h(a.charCodeAt(W))){if(!H){k=W+1;break}}else N===-1&&(H=!1,N=W+1);return N===-1?"":a.slice(k,N)},extname(a){t(a,"path");let E=0,k=-1,N=0,H=-1,W=!0,_=0;a.length>=2&&a.charCodeAt(1)===v&&c(a.charCodeAt(0))&&(E=N=2);for(let B=a.length-1;B>=E;--B){const z=a.charCodeAt(B);if(h(z)){if(!W){N=B+1;break}continue}H===-1&&(W=!1,H=B+1),z===A?k===-1?k=B:_!==1&&(_=1):k!==-1&&(_=-1)}return k===-1||H===-1||_===0||_===1&&k===H-1&&k===N+1?"":a.slice(k,H)},format:u.bind(null,"\\"),parse(a){t(a,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return E;const k=a.length;let N=0,H=a.charCodeAt(0);if(k===1)return h(H)?(E.root=E.dir=a,E):(E.base=E.name=a,E);if(h(H)){if(N=1,h(a.charCodeAt(1))){let M=2,Y=M;for(;M<k&&!h(a.charCodeAt(M));)M++;if(M<k&&M!==Y){for(Y=M;M<k&&h(a.charCodeAt(M));)M++;if(M<k&&M!==Y){for(Y=M;M<k&&!h(a.charCodeAt(M));)M++;M===k?N=M:M!==Y&&(N=M+1)}}}}else if(c(H)&&a.charCodeAt(1)===v){if(k<=2)return E.root=E.dir=a,E;if(N=2,h(a.charCodeAt(2))){if(k===3)return E.root=E.dir=a,E;N=3}}N>0&&(E.root=a.slice(0,N));let W=-1,_=N,B=-1,z=!0,T=a.length-1,P=0;for(;T>=N;--T){if(H=a.charCodeAt(T),h(H)){if(!z){_=T+1;break}continue}B===-1&&(z=!1,B=T+1),H===A?W===-1?W=T:P!==1&&(P=1):W!==-1&&(P=-1)}return B!==-1&&(W===-1||P===0||P===1&&W===B-1&&W===_+1?E.base=E.name=a.slice(_,B):(E.name=a.slice(_,W),E.base=a.slice(_,B),E.ext=a.slice(W,B))),_>0&&_!==N?E.dir=a.slice(0,_-1):E.dir=E.root,E},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(s){const a=/\\/g;return()=>{const E=S.cwd().replace(a,"/");return E.slice(E.indexOf("/"))}}return()=>S.cwd()})();e.posix={resolve(...a){let E="",k=!1;for(let N=a.length-1;N>=-1&&!k;N--){const H=N>=0?a[N]:m();t(H,"path"),H.length!==0&&(E=`${H}/${E}`,k=H.charCodeAt(0)===p)}return E=D(E,!k,"/",g),k?`/${E}`:E.length>0?E:"."},normalize(a){if(t(a,"path"),a.length===0)return".";const E=a.charCodeAt(0)===p,k=a.charCodeAt(a.length-1)===p;return a=D(a,!E,"/",g),a.length===0?E?"/":k?"./":".":(k&&(a+="/"),E?`/${a}`:a)},isAbsolute(a){return t(a,"path"),a.length>0&&a.charCodeAt(0)===p},join(...a){if(a.length===0)return".";let E;for(let k=0;k<a.length;++k){const N=a[k];t(N,"path"),N.length>0&&(E===void 0?E=N:E+=`/${N}`)}return E===void 0?".":e.posix.normalize(E)},relative(a,E){if(t(a,"from"),t(E,"to"),a===E||(a=e.posix.resolve(a),E=e.posix.resolve(E),a===E))return"";const k=1,N=a.length,H=N-k,W=1,_=E.length-W,B=H<_?H:_;let z=-1,T=0;for(;T<B;T++){const M=a.charCodeAt(k+T);if(M!==E.charCodeAt(W+T))break;M===p&&(z=T)}if(T===B)if(_>B){if(E.charCodeAt(W+T)===p)return E.slice(W+T+1);if(T===0)return E.slice(W+T)}else H>B&&(a.charCodeAt(k+T)===p?z=T:T===0&&(z=0));let P="";for(T=k+z+1;T<=N;++T)(T===N||a.charCodeAt(T)===p)&&(P+=P.length===0?"..":"/..");return`${P}${E.slice(W+z)}`},toNamespacedPath(a){return a},dirname(a){if(t(a,"path"),a.length===0)return".";const E=a.charCodeAt(0)===p;let k=-1,N=!0;for(let H=a.length-1;H>=1;--H)if(a.charCodeAt(H)===p){if(!N){k=H;break}}else N=!1;return k===-1?E?"/":".":E&&k===1?"//":a.slice(0,k)},basename(a,E){E!==void 0&&t(E,"ext"),t(a,"path");let k=0,N=-1,H=!0,W;if(E!==void 0&&E.length>0&&E.length<=a.length){if(E===a)return"";let _=E.length-1,B=-1;for(W=a.length-1;W>=0;--W){const z=a.charCodeAt(W);if(z===p){if(!H){k=W+1;break}}else B===-1&&(H=!1,B=W+1),_>=0&&(z===E.charCodeAt(_)?--_===-1&&(N=W):(_=-1,N=B))}return k===N?N=B:N===-1&&(N=a.length),a.slice(k,N)}for(W=a.length-1;W>=0;--W)if(a.charCodeAt(W)===p){if(!H){k=W+1;break}}else N===-1&&(H=!1,N=W+1);return N===-1?"":a.slice(k,N)},extname(a){t(a,"path");let E=-1,k=0,N=-1,H=!0,W=0;for(let _=a.length-1;_>=0;--_){const B=a.charCodeAt(_);if(B===p){if(!H){k=_+1;break}continue}N===-1&&(H=!1,N=_+1),B===A?E===-1?E=_:W!==1&&(W=1):E!==-1&&(W=-1)}return E===-1||N===-1||W===0||W===1&&E===N-1&&E===k+1?"":a.slice(E,N)},format:u.bind(null,"/"),parse(a){t(a,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return E;const k=a.charCodeAt(0)===p;let N;k?(E.root="/",N=1):N=0;let H=-1,W=0,_=-1,B=!0,z=a.length-1,T=0;for(;z>=N;--z){const P=a.charCodeAt(z);if(P===p){if(!B){W=z+1;break}continue}_===-1&&(B=!1,_=z+1),P===A?H===-1?H=z:T!==1&&(T=1):H!==-1&&(T=-1)}if(_!==-1){const P=W===0&&k?1:W;H===-1||T===0||T===1&&H===_-1&&H===W+1?E.base=E.name=a.slice(P,_):(E.name=a.slice(P,H),E.base=a.slice(P,_),E.ext=a.slice(H,_))}return W>0?E.dir=a.slice(0,W-1):k&&(E.dir="/"),E},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=s?e.win32.normalize:e.posix.normalize,e.isAbsolute=s?e.win32.isAbsolute:e.posix.isAbsolute,e.join=s?e.win32.join:e.posix.join,e.resolve=s?e.win32.resolve:e.posix.resolve,e.relative=s?e.win32.relative:e.posix.relative,e.dirname=s?e.win32.dirname:e.posix.dirname,e.basename=s?e.win32.basename:e.posix.basename,e.extname=s?e.win32.extname:e.posix.extname,e.format=s?e.win32.format:e.posix.format,e.parse=s?e.win32.parse:e.posix.parse,e.toNamespacedPath=s?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=s?e.win32.sep:e.posix.sep,e.delimiter=s?e.win32.delimiter:e.posix.delimiter}),define(me[118],be([1,0,24,5,10,7]),function(se,e,S,F,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(W){return W===47||W===92}e.isPathSeparator=y;function A(W){return W.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=A;function p(W){return W.indexOf("/")===-1&&(W=A(W)),/^[a-zA-Z]:(\/|$)/.test(W)&&(W="/"+W),W}e.toPosixPath=p;function b(W,_=S.posix.sep){if(!W)return"";const B=W.length,z=W.charCodeAt(0);if(y(z)){if(y(W.charCodeAt(1))&&!y(W.charCodeAt(2))){let P=3;const M=P;for(;P<B&&!y(W.charCodeAt(P));P++);if(M!==P&&!y(W.charCodeAt(P+1))){for(P+=1;P<B;P++)if(y(W.charCodeAt(P)))return W.slice(0,P+1).replace(/[\\/]/g,_)}}return _}else if(g(z)&&W.charCodeAt(1)===58)return y(W.charCodeAt(2))?W.slice(0,2)+_:W.slice(0,2);let T=W.indexOf("://");if(T!==-1){for(T+=3;T<B;T++)if(y(W.charCodeAt(T)))return W.slice(0,T+1)}return""}e.getRoot=b;function v(W){if(!F.isWindows||!W||W.length<5)return!1;let _=W.charCodeAt(0);if(_!==92||(_=W.charCodeAt(1),_!==92))return!1;let B=2;const z=B;for(;B<W.length&&(_=W.charCodeAt(B),_!==92);B++);return!(z===B||(_=W.charCodeAt(B+1),isNaN(_)||_===92))}e.isUNC=v;const O=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(W,_=F.isWindows){const B=_?O:l;return!(!W||W.length===0||/^\s+$/.test(W)||(B.lastIndex=0,B.test(W))||_&&d.test(W)||W==="."||W===".."||_&&W[W.length-1]==="."||_&&W.length!==W.trim().length||W.length>255)}e.isValidBasename=t;function s(W,_,B){const z=W===_;return!B||z?z:!W||!_?!1:(0,n.equalsIgnoreCase)(W,_)}e.isEqual=s;function h(W,_,B,z=S.sep){if(W===_)return!0;if(!W||!_||_.length>W.length)return!1;if(B){if(!(0,n.startsWithIgnoreCase)(W,_))return!1;if(_.length===W.length)return!0;let P=_.length;return _.charAt(_.length-1)===z&&P--,W.charAt(P)===z}return _.charAt(_.length-1)!==z&&(_+=z),W.indexOf(_)===0}e.isEqualOrParent=h;function g(W){return W>=65&&W<=90||W>=97&&W<=122}e.isWindowsDriveLetter=g;function c(W,_){return F.isWindows&&W.endsWith(":")&&(W+=S.sep),(0,S.isAbsolute)(W)||(W=(0,S.join)(_,W)),W=(0,S.normalize)(W),F.isWindows?(W=(0,n.rtrim)(W,S.sep),W.endsWith(":")&&(W+=S.sep)):(W=(0,n.rtrim)(W,S.sep),W||(W=S.sep)),W}e.sanitizeFilePath=c;function D(W){const _=(0,S.normalize)(W);return F.isWindows?W.length>3?!1:u(_)&&(W.length===2||_.charCodeAt(2)===92):_===S.posix.sep}e.isRootOrDriveLetter=D;function u(W,_=F.isWindows){return _?g(W.charCodeAt(0))&&W.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function m(W,_=F.isWindows){return u(W,_)?W[0]:void 0}e.getDriveLetter=m;function a(W,_,B){return _.length>W.length?-1:W===_?0:(B&&(W=W.toLowerCase(),_=_.toLowerCase()),W.indexOf(_))}e.indexOfPath=a;function E(W){const _=W.split(":");let B,z,T;for(const P of _){const M=Number(P);(0,U.isNumber)(M)?z===void 0?z=M:T===void 0&&(T=M):B=B?[B,P].join(":"):P}if(!B)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:B,line:z!==void 0?z:void 0,column:T!==void 0?T:z!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function H(W,_,B=8){let z="";for(let P=0;P<B;P++){let M;P===0&&F.isWindows&&!_&&(B===3||B===4)?M=N:M=k,z+=M.charAt(Math.floor(Math.random()*M.length))}let T;return _?T=`${_}-${z}`:T=z,W?(0,S.join)(W,T):T}e.randomPath=H}),define(me[119],be([1,0,24]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(v){const O=(0,S.extname)(v),l=F[O.toLowerCase()];return l!==void 0?l:y(v)}e.getMediaOrTextMime=U;function y(v){const O=(0,S.extname)(v);return n[O.toLowerCase()]}e.getMediaMime=y;function A(v){for(const O in n)if(n[O]===v)return O}e.getExtensionForMimeType=A;const p=/^(.+)\/(.+?)(;.+)?$/;function b(v,O){const l=p.exec(v);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:O?void 0:v}e.normalizeMimeType=b}),define(me[15],be([1,0,24,5]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,U=/^\//,y=/^\/\//;function A(N,H){if(!N.scheme&&H)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!n.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!U.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(N,H){return!N&&!H?"file":N}function b(N,H){switch(N){case"https":case"http":case"file":H?H[0]!==O&&(H=O+H):H=O;break}return H}const v="",O="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(H){return H instanceof d?!0:H?typeof H.authority=="string"&&typeof H.fragment=="string"&&typeof H.path=="string"&&typeof H.query=="string"&&typeof H.scheme=="string"&&typeof H.fsPath=="string"&&typeof H.with=="function"&&typeof H.toString=="function":!1}constructor(H,W,_,B,z,T=!1){typeof H=="object"?(this.scheme=H.scheme||v,this.authority=H.authority||v,this.path=H.path||v,this.query=H.query||v,this.fragment=H.fragment||v):(this.scheme=p(H,T),this.authority=W||v,this.path=b(this.scheme,_||v),this.query=B||v,this.fragment=z||v,A(this,T))}get fsPath(){return u(this,!1)}with(H){if(!H)return this;let{scheme:W,authority:_,path:B,query:z,fragment:T}=H;return W===void 0?W=this.scheme:W===null&&(W=v),_===void 0?_=this.authority:_===null&&(_=v),B===void 0?B=this.path:B===null&&(B=v),z===void 0?z=this.query:z===null&&(z=v),T===void 0?T=this.fragment:T===null&&(T=v),W===this.scheme&&_===this.authority&&B===this.path&&z===this.query&&T===this.fragment?this:new h(W,_,B,z,T)}static parse(H,W=!1){const _=l.exec(H);return _?new h(_[2]||v,k(_[4]||v),k(_[5]||v),k(_[7]||v),k(_[9]||v),W):new h(v,v,v,v,v)}static file(H){let W=v;if(F.isWindows&&(H=H.replace(/\\/g,O)),H[0]===O&&H[1]===O){const _=H.indexOf(O,2);_===-1?(W=H.substring(2),H=O):(W=H.substring(2,_),H=H.substring(_)||O)}return new h("file",W,H,v,v)}static from(H,W){return new h(H.scheme,H.authority,H.path,H.query,H.fragment,W)}static joinPath(H,...W){if(!H.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return F.isWindows&&H.scheme==="file"?_=d.file(S.win32.join(u(H,!0),...W)).path:_=S.posix.join(H.path,...W),H.with({path:_})}toString(H=!1){return m(this,H)}toJSON(){return this}static revive(H){if(H){if(H instanceof d)return H;{const W=new h(H);return W._formatted=H.external??null,W._fsPath=H._sep===s?H.fsPath??null:null,W}}else return H}}e.URI=d;function t(N){return!N||typeof N!="object"?!1:typeof N.scheme=="string"&&(typeof N.authority=="string"||typeof N.authority>"u")&&(typeof N.path=="string"||typeof N.path>"u")&&(typeof N.query=="string"||typeof N.query>"u")&&(typeof N.fragment=="string"||typeof N.fragment>"u")}e.isUriComponents=t;const s=F.isWindows?1:void 0;class h extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(H=!1){return H?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const H={$mid:1};return this._fsPath&&(H.fsPath=this._fsPath,H._sep=s),this._formatted&&(H.external=this._formatted),this.path&&(H.path=this.path),this.scheme&&(H.scheme=this.scheme),this.authority&&(H.authority=this.authority),this.query&&(H.query=this.query),this.fragment&&(H.fragment=this.fragment),H}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function c(N,H,W){let _,B=-1;for(let z=0;z<N.length;z++){const T=N.charCodeAt(z);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||H&&T===47||W&&T===91||W&&T===93||W&&T===58)B!==-1&&(_+=encodeURIComponent(N.substring(B,z)),B=-1),_!==void 0&&(_+=N.charAt(z));else{_===void 0&&(_=N.substr(0,z));const P=g[T];P!==void 0?(B!==-1&&(_+=encodeURIComponent(N.substring(B,z)),B=-1),_+=P):B===-1&&(B=z)}}return B!==-1&&(_+=encodeURIComponent(N.substring(B))),_!==void 0?_:N}function D(N){let H;for(let W=0;W<N.length;W++){const _=N.charCodeAt(W);_===35||_===63?(H===void 0&&(H=N.substr(0,W)),H+=g[_]):H!==void 0&&(H+=N[W])}return H!==void 0?H:N}function u(N,H){let W;return N.authority&&N.path.length>1&&N.scheme==="file"?W=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===47&&(N.path.charCodeAt(1)>=65&&N.path.charCodeAt(1)<=90||N.path.charCodeAt(1)>=97&&N.path.charCodeAt(1)<=122)&&N.path.charCodeAt(2)===58?H?W=N.path.substr(1):W=N.path[1].toLowerCase()+N.path.substr(2):W=N.path,F.isWindows&&(W=W.replace(/\//g,"\\")),W}e.uriToFsPath=u;function m(N,H){const W=H?D:c;let _="",{scheme:B,authority:z,path:T,query:P,fragment:M}=N;if(B&&(_+=B,_+=":"),(z||B==="file")&&(_+=O,_+=O),z){let Y=z.indexOf("@");if(Y!==-1){const Z=z.substr(0,Y);z=z.substr(Y+1),Y=Z.lastIndexOf(":"),Y===-1?_+=W(Z,!1,!1):(_+=W(Z.substr(0,Y),!1,!1),_+=":",_+=W(Z.substr(Y+1),!1,!0)),_+="@"}z=z.toLowerCase(),Y=z.lastIndexOf(":"),Y===-1?_+=W(z,!1,!0):(_+=W(z.substr(0,Y),!1,!0),_+=z.substr(Y))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const Y=T.charCodeAt(1);Y>=65&&Y<=90&&(T=`/${String.fromCharCode(Y+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const Y=T.charCodeAt(0);Y>=65&&Y<=90&&(T=`${String.fromCharCode(Y+32)}:${T.substr(2)}`)}_+=W(T,!0,!1)}return P&&(_+="?",_+=W(P,!1,!1)),M&&(_+="#",_+=H?M:c(M,!1,!1)),_}function a(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+a(N.substr(3)):N}}const E=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function k(N){return N.match(E)?N.replace(E,H=>a(H)):N}}),define(me[55],be([1,0,35,15]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function n(p){return JSON.stringify(p,y)}e.stringify=n;function U(p){let b=JSON.parse(p);return b=A(b),b}e.parse=U;function y(p,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function A(p,b=0){if(!p||b>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return F.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof S.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let v=0;v<p.length;++v)p[v]=A(p[v],b+1);else for(const v in p)Object.hasOwnProperty.call(p,v)&&(p[v]=A(p[v],b+1))}return p}e.revive=A}),define(me[32],be([1,0,6,5,10,15]),function(se,e,S,F,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var y;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting",l.codeFeature="code-feature"})(y||(e.Schemas=y={}));function A(l,d){return U.URI.isUri(l)?(0,n.equalsIgnoreCase)(l.scheme,d):(0,n.startsWithIgnoreCase)(l,d+":")}e.matchesScheme=A;function p(l,...d){return d.some(t=>A(l,t))}e.matchesSomeScheme=p,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}setServerRootPath(d){this._remoteResourcesPath=`${d}/${y.vscodeRemoteResource}`}set(d,t,s){this._hosts[d]=t,this._ports[d]=s}setConnectionToken(d,t){this._connectionTokens[d]=t}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)try{return this._delegate(d)}catch(D){return S.onUnexpectedError(D),d}const t=d.authority;let s=this._hosts[t];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const h=this._ports[t],g=this._connectionTokens[t];let c=`path=${encodeURIComponent(d.path)}`;return typeof g=="string"&&(c+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),U.URI.from({scheme:F.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${s}:${h}`,path:this._remoteResourcesPath,query:c})}}e.RemoteAuthorities=new b,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class v{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(d){const t=this.toUri(d,se);return this.uriToBrowserUri(t)}uriToBrowserUri(d){return d.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(d):d.scheme===y.file&&(F.isNative||F.webWorkerOrigin===`${y.vscodeFileResource}://${v.FALLBACK_AUTHORITY}`)?d.with({scheme:y.vscodeFileResource,authority:d.authority||v.FALLBACK_AUTHORITY,query:null,fragment:null}):d}asFileUri(d){const t=this.toUri(d,se);return this.uriToFileUri(t)}uriToFileUri(d){return d.scheme===y.vscodeFileResource?d.with({scheme:y.file,authority:d.authority!==v.FALLBACK_AUTHORITY?d.authority:null,query:null,fragment:null}):d}toUri(d,t){return U.URI.isUri(d)?d:U.URI.parse(t.toUrl(d))}}e.FileAccess=new v;var O;(function(l){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(d.get("3"));const t="vscode-coi";function s(g){let c;typeof g=="string"?c=new URL(g).searchParams:g instanceof URL?c=g.searchParams:U.URI.isUri(g)&&(c=new URL(g.toString(!0)).searchParams);const D=c?.get(t);if(D)return d.get(D)}l.getHeadersFromQuery=s;function h(g,c,D){if(!globalThis.crossOriginIsolated)return;const u=c&&D?"3":D?"2":"1";g instanceof URLSearchParams?g.set(t,u):g[t]=u}l.addSearchParam=h})(O||(e.COI=O={}))}),define(me[39],be([1,0,118,32,24,5,10,15]),function(se,e,S,F,n,U,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(d){return(0,A.uriToFsPath)(d,!0)}e.originalFSPath=p;class b{constructor(t){this._ignorePathCasing=t}compare(t,s,h=!1){return t===s?0:(0,y.compare)(this.getComparisonKey(t,h),this.getComparisonKey(s,h))}isEqual(t,s,h=!1){return t===s?!0:!t||!s?!1:this.getComparisonKey(t,h)===this.getComparisonKey(s,h)}getComparisonKey(t,s=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,s,h=!1){if(t.scheme===s.scheme){if(t.scheme===F.Schemas.file)return S.isEqualOrParent(p(t),p(s),this._ignorePathCasing(t))&&t.query===s.query&&(h||t.fragment===s.fragment);if((0,e.isEqualAuthority)(t.authority,s.authority))return S.isEqualOrParent(t.path,s.path,this._ignorePathCasing(t),"/")&&t.query===s.query&&(h||t.fragment===s.fragment)}return!1}joinPath(t,...s){return A.URI.joinPath(t,...s)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return n.posix.basename(t.path)}extname(t){return n.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let s;return t.scheme===F.Schemas.file?s=A.URI.file(n.dirname(p(t))).path:(s=n.posix.dirname(t.path),t.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),s="/")),t.with({path:s})}normalizePath(t){if(!t.path.length)return t;let s;return t.scheme===F.Schemas.file?s=A.URI.file(n.normalize(p(t))).path:s=n.posix.normalize(t.path),t.with({path:s})}relativePath(t,s){if(t.scheme!==s.scheme||!(0,e.isEqualAuthority)(t.authority,s.authority))return;if(t.scheme===F.Schemas.file){const c=n.relative(p(t),p(s));return U.isWindows?S.toSlashes(c):c}let h=t.path||"/";const g=s.path||"/";if(this._ignorePathCasing(t)){let c=0;for(const D=Math.min(h.length,g.length);c<D&&!(h.charCodeAt(c)!==g.charCodeAt(c)&&h.charAt(c).toLowerCase()!==g.charAt(c).toLowerCase());c++);h=g.substr(0,c)+h.substr(c)}return n.posix.relative(h,g)}resolvePath(t,s){if(t.scheme===F.Schemas.file){const h=A.URI.file(n.resolve(p(t),s));return t.with({authority:h.authority,path:h.path})}return s=S.toPosixPath(s),t.with({path:n.posix.resolve(t.path,s)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,s){return t===s||t!==void 0&&s!==void 0&&(0,y.equalsIgnoreCase)(t,s)}hasTrailingPathSeparator(t,s=n.sep){if(t.scheme===F.Schemas.file){const h=p(t);return h.length>S.getRoot(h).length&&h[h.length-1]===s}else{const h=t.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,s=n.sep){return(0,e.hasTrailingPathSeparator)(t,s)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,s=n.sep){let h=!1;if(t.scheme===F.Schemas.file){const g=p(t);h=g!==void 0&&g.length===S.getRoot(g).length&&g[g.length-1]===s}else{s="/";const g=t.path;h=g.length===1&&g.charCodeAt(g.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(t,s)?t.with({path:t.path+"/"}):t}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(d=>d.scheme===F.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new b(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(d,t){const s=[];for(let h=0;h<d.length;h++){const g=t(d[h]);d.some((c,D)=>D===h?!1:(0,e.isEqualOrParent)(g,t(c)))||s.push(d[h])}return s}e.distinctParents=v;var O;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function t(s){const h=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(D=>{const[u,m]=D.split(":");u&&m&&h.set(u,m)});const c=s.path.substring(0,s.path.indexOf(";"));return c&&h.set(d.META_DATA_MIME,c),h}d.parseMetaData=t})(O||(e.DataUri=O={}));function l(d,t,s){if(t){let h=d.path;return h&&h[0]!==n.posix.sep&&(h=n.posix.sep+h),d.with({scheme:s,authority:t,path:h})}return d.with({scheme:s})}e.toLocalResource=l}),define(me[9],be([1,0,30,6,4,3,39,5,52,22]),function(se,e,S,F,n,U,y,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(I){return!!I&&typeof I.then=="function"}e.isThenable=v;function O(I){const r=new S.CancellationTokenSource,i=I(r.token),o=new Promise((w,R)=>{const L=r.token.onCancellationRequested(()=>{L.dispose(),R(new F.CancellationError)});Promise.resolve(i).then(x=>{L.dispose(),r.dispose(),w(x)},x=>{L.dispose(),r.dispose(),R(x)})});return new class{cancel(){r.cancel(),r.dispose()}then(w,R){return o.then(w,R)}catch(w){return this.then(void 0,w)}finally(w){return o.finally(w)}}}e.createCancelablePromise=O;function l(I,r,i){return new Promise((o,w)=>{const R=r.onCancellationRequested(()=>{R.dispose(),o(i)});I.then(o,w).finally(()=>R.dispose())})}e.raceCancellation=l;function d(I,r){return new Promise((i,o)=>{const w=r.onCancellationRequested(()=>{w.dispose(),o(new F.CancellationError)});I.then(i,o).finally(()=>w.dispose())})}e.raceCancellationError=d;async function t(I){let r=-1;const i=I.map((o,w)=>o.then(R=>(r=w,R)));try{return await Promise.race(i)}finally{I.forEach((o,w)=>{w!==r&&o.cancel()})}}e.raceCancellablePromises=t;function s(I,r,i){let o;const w=setTimeout(()=>{o?.(void 0),i?.()},r);return Promise.race([I.finally(()=>clearTimeout(w)),new Promise(R=>o=R)])}e.raceTimeout=s;function h(I){return new Promise((r,i)=>{const o=I();v(o)?o.then(r,i):r(o)})}e.asPromise=h;function g(){let I,r;return{promise:new Promise((o,w)=>{I=o,r=w}),resolve:I,reject:r}}e.promiseWithResolvers=g;class c{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(r){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=r,!this.queuedPromise){const i=()=>{if(this.queuedPromise=null,this.isDisposed)return;const o=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,o};this.queuedPromise=new Promise(o=>{this.activePromise.then(i,i).then(o)})}return new Promise((i,o)=>{this.queuedPromise.then(i,o)})}return this.activePromise=r(),new Promise((i,o)=>{this.activePromise.then(w=>{this.activePromise=null,i(w)},w=>{this.activePromise=null,o(w)})})}dispose(){this.isDisposed=!0}}e.Throttler=c;class D{constructor(){this.current=Promise.resolve(null)}queue(r){return this.current=this.current.then(()=>r(),()=>r())}}e.Sequencer=D;class u{constructor(){this.promiseMap=new Map}queue(r,i){const w=(this.promiseMap.get(r)??Promise.resolve()).catch(()=>{}).then(i).finally(()=>{this.promiseMap.get(r)===w&&this.promiseMap.delete(r)});return this.promiseMap.set(r,w),w}}e.SequencerByKey=u;const m=(I,r)=>{let i=!0;const o=setTimeout(()=>{i=!1,r()},I);return{isTriggered:()=>i,dispose:()=>{clearTimeout(o),i=!1}}},a=I=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,I())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class E{constructor(r){this.defaultDelay=r,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(r,i=this.defaultDelay){this.task=r,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((w,R)=>{this.doResolve=w,this.doReject=R}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const w=this.task;return this.task=null,w()}}));const o=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=i===p.MicrotaskDelay?a(o):m(i,o),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new F.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class k{constructor(r){this.delayer=new E(r),this.throttler=new c}trigger(r,i){return this.delayer.trigger(()=>this.throttler.queue(r),i)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=k;class N{constructor(){this._isOpen=!1,this._promise=new Promise((r,i)=>{this._completePromise=r})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=N;class H extends N{constructor(r){super(),this._timeout=setTimeout(()=>this.open(),r)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=H;function W(I,r){return r?new Promise((i,o)=>{const w=setTimeout(()=>{R.dispose(),i()},I),R=r.onCancellationRequested(()=>{clearTimeout(w),R.dispose(),o(new F.CancellationError)})}):O(i=>W(I,i))}e.timeout=W;function _(I,r=0,i){const o=setTimeout(()=>{I(),i&&w.dispose()},r),w=(0,U.toDisposable)(()=>{clearTimeout(o),i?.deleteAndLeak(w)});return i?.add(w),w}e.disposableTimeout=_;function B(I){const r=[];let i=0;const o=I.length;function w(){return i<o?I[i++]():null}function R(L){L!=null&&r.push(L);const x=w();return x?x.then(R):Promise.resolve(r)}return Promise.resolve(null).then(R)}e.sequence=B;function z(I,r=o=>!!o,i=null){let o=0;const w=I.length,R=()=>{if(o>=w)return Promise.resolve(i);const L=I[o++];return Promise.resolve(L()).then(V=>r(V)?Promise.resolve(V):R())};return R()}e.first=z;function T(I,r=o=>!!o,i=null){if(I.length===0)return Promise.resolve(i);let o=I.length;const w=()=>{o=-1;for(const R of I)R.cancel?.()};return new Promise((R,L)=>{for(const x of I)x.then(V=>{--o>=0&&r(V)?(w(),R(V)):o===0&&R(i)}).catch(V=>{--o>=0&&(w(),L(V))})})}e.firstParallel=T;class P{constructor(r){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=r,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new n.Emitter}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(r){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((i,o)=>{this.outstandingPromises.push({factory:r,c:i,e:o}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const r=this.outstandingPromises.shift();this.runningPromises++;const i=r.factory();i.then(r.c,r.e),i.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class Y{constructor(){this.sequentializer=new ae,this.tasks=0}queue(r){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,r())):this.sequentializer.run(this.tasks++,r())}}e.LimitedQueue=Y;class Z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const r=new j;return this.drainers.add(r),r.p}isDrained(){for(const[,r]of this.queues)if(r.size>0)return!1;return!0}queueSize(r,i=y.extUri){const o=i.getComparisonKey(r);return this.queues.get(o)?.size??0}queueFor(r,i,o=y.extUri){const w=o.getComparisonKey(r);let R=this.queues.get(w);if(!R){R=new M;const L=this.drainListenerCount++,x=n.Event.once(R.onDrained)(()=>{R?.dispose(),this.queues.delete(w),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(L),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new U.DisposableMap),this.drainListeners.set(L,x),this.queues.set(w,R)}return R.queue(i)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const r of this.drainers)r.complete();this.drainers.clear()}dispose(){for(const[,r]of this.queues)r.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=Z;class fe{constructor(r,i){this._token=-1,typeof r=="function"&&typeof i=="number"&&this.setIfNotSet(r,i)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(r,i){this.cancel(),this._token=setTimeout(()=>{this._token=-1,r()},i)}setIfNotSet(r,i){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,r()},i))}}e.TimeoutTimer=fe;class ce{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(r,i,o=globalThis){this.cancel();const w=o.setInterval(()=>{r()},i);this.disposable=(0,U.toDisposable)(()=>{o.clearInterval(w),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=ce;class te{constructor(r,i){this.timeoutToken=-1,this.runner=r,this.timeout=i,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(r=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,r)}get delay(){return this.timeout}set delay(r){this.timeout=r}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=te;class ge{constructor(r,i){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.runner=r,this.timeout=i,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(r=this.timeout){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(r/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ge;class ke extends te{constructor(r,i){super(r,i),this.units=[]}work(r){this.units.push(r),this.isScheduled()||this.schedule()}doRun(){const r=this.units;this.units=[],this.runner?.(r)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ke;class Le extends U.Disposable{constructor(r,i){super(),this.options=r,this.handler=i,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(r){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+r.length>this.options.maxBufferedWork)return!1}else if(this.pending+r.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const i of r)this.pendingWork.push(i);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new te(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Le,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(I,r)=>{(0,A.setTimeout0)(()=>{if(i)return;const o=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,o-Date.now())}}))});let i=!1;return{dispose(){i||(i=!0)}}}:e._runWhenIdle=(I,r,i)=>{const o=I.requestIdleCallback(r,typeof i=="number"?{timeout:i}:void 0);let w=!1;return{dispose(){w||(w=!0,I.cancelIdleCallback(o))}}},e.runWhenGlobalIdle=I=>(0,e._runWhenIdle)(globalThis,I)}();class Be{constructor(r,i){this._didRun=!1,this._executor=()=>{try{this._value=i()}catch(o){this._error=o}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(r,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=Be;class le extends Be{constructor(r){super(globalThis,r)}}e.GlobalIdleValue=le;async function J(I,r,i){let o;for(let w=0;w<i;w++)try{return await I()}catch(R){o=R,await W(r)}throw o}e.retry=J;class ae{isRunning(r){return typeof r=="number"?this._running?.taskId===r:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(r,i,o){return this._running={taskId:r,cancel:()=>o?.(),promise:i},i.then(()=>this.doneRunning(r),()=>this.doneRunning(r)),i}doneRunning(r){this._running&&r===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const r=this._queued;this._queued=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this._queued)this._queued.run=r;else{const{promise:i,resolve:o,reject:w}=g();this._queued={run:r,promise:i,promiseResolve:o,promiseReject:w}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ae;class re{constructor(r,i=()=>Date.now()){this.interval=r,this.nowFn=i,this.lastIncrementTime=0,this.value=0}increment(){const r=this.nowFn();return r-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=r,this.value=0),this.value++,this.value}}e.IntervalCounter=re;var X;(function(I){I[I.Resolved=0]="Resolved",I[I.Rejected=1]="Rejected"})(X||(X={}));class j{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((r,i)=>{this.completeCallback=r,this.errorCallback=i})}complete(r){return new Promise(i=>{this.completeCallback(r),this.outcome={outcome:0,value:r},i()})}error(r){return new Promise(i=>{this.errorCallback(r),this.outcome={outcome:1,value:r},i()})}cancel(){return this.error(new F.CancellationError)}}e.DeferredPromise=j;var ie;(function(I){async function r(o){let w;const R=await Promise.all(o.map(L=>L.then(x=>x,x=>{w||(w=x)})));if(typeof w<"u")throw w;return R}I.settled=r;function i(o){return new Promise(async(w,R)=>{try{await o(w,R)}catch(L){R(L)}})}I.withAsyncBody=i})(ie||(e.Promises=ie={}));class de{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(r){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=r.then(i=>(this._value=i,this._isResolved=!0,i),i=>{throw this._error=i,this._isResolved=!0,i})}requireValue(){if(!this._isResolved)throw new F.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=de;class Ee{constructor(r){this._compute=r,this._promise=new b.Lazy(()=>new de(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=Ee;var Ie;(function(I){I[I.Initial=0]="Initial",I[I.DoneOK=1]="DoneOK",I[I.DoneError=2]="DoneError"})(Ie||(Ie={}));class Ce{static fromArray(r){return new Ce(i=>{i.emitMany(r)})}static fromPromise(r){return new Ce(async i=>{i.emitMany(await r)})}static fromPromises(r){return new Ce(async i=>{await Promise.all(r.map(async o=>i.emitOne(await o)))})}static merge(r){return new Ce(async i=>{await Promise.all(r.map(async o=>{for await(const w of o)i.emitOne(w)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(r){this._state=0,this._results=[],this._error=null,this._onStateChanged=new n.Emitter,queueMicrotask(async()=>{const i={emitOne:o=>this.emitOne(o),emitMany:o=>this.emitMany(o),reject:o=>this.reject(o)};try{await Promise.resolve(r(i)),this.resolve()}catch(o){this.reject(o)}finally{i.emitOne=void 0,i.emitMany=void 0,i.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(r<this._results.length)return{done:!1,value:this._results[r++]};if(this._state===1)return{done:!0,value:void 0};await n.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(r,i){return new Ce(async o=>{for await(const w of r)o.emitOne(i(w))})}map(r){return Ce.map(this,r)}static filter(r,i){return new Ce(async o=>{for await(const w of r)i(w)&&o.emitOne(w)})}filter(r){return Ce.filter(this,r)}static coalesce(r){return Ce.filter(r,i=>!!i)}coalesce(){return Ce.coalesce(this)}static async toPromise(r){const i=[];for await(const o of r)i.push(o);return i}toPromise(){return Ce.toPromise(this)}emitOne(r){this._state===0&&(this._results.push(r),this._onStateChanged.fire())}emitMany(r){this._state===0&&(this._results=this._results.concat(r),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(r){this._state===0&&(this._state=2,this._error=r,this._onStateChanged.fire())}}e.AsyncIterableObject=Ce;class K extends Ce{constructor(r,i){super(i),this._source=r}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function f(I){const r=new S.CancellationTokenSource,i=I(r.token);return new K(r,async o=>{const w=r.token.onCancellationRequested(()=>{w.dispose(),r.dispose(),o.reject(new F.CancellationError)});try{for await(const R of i){if(r.token.isCancellationRequested)return;o.emitOne(R)}w.dispose(),r.dispose()}catch(R){w.dispose(),r.dispose(),o.reject(R)}})}e.createCancelableAsyncIterable=f;class C{constructor(){this._deferred=new j,this._asyncIterable=new Ce(o=>{if(r){o.reject(r);return}return i&&o.emitMany(i),this._errorFn=w=>o.reject(w),this._emitFn=w=>o.emitOne(w),this._deferred.p});let r,i;this._emitFn=o=>{i||(i=[]),i.push(o)},this._errorFn=o=>{r||(r=o)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(r){this._errorFn(r),this._deferred.complete()}emitOne(r){this._emitFn(r)}}e.AsyncIterableSource=C}),define(me[2],be([1,0,16,116,14,19,9,6,4,120,3,32,5,15,51,21]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t,s){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.trackAttributes=e.copyAttributes=e.h=e.DragAndDropObserver=e.getCookieValue=e.ModifierKeyEmitter=e.multibyteAwareBtoa=e.safeInnerHtml=e.basicMarkupHtmlTags=e.hookDomPurifyHrefAndSrcSanitizer=e.detectFullscreen=e.DetectedFullscreenMode=e.triggerUpload=e.triggerDownload=e.asCssValueWithDefault=e.asCSSPropertyValue=e.asCSSUrl=e.animate=e.windowOpenWithSuccess=e.windowOpenPopup=e.windowOpenNoOpener=e.computeScreenAwareSize=e.domContentLoaded=e.finalHandler=e.removeTabIndexAndUpdateFocus=e.hide=e.show=e.setVisibility=e.join=e.$=e.Namespace=e.reset=e.prepend=e.append=e.after=e.trackFocus=e.restoreParentsScrollTop=e.saveParentsScrollTop=e.EventHelper=e.isEventLike=e.EventType=e.isDragEvent=e.isPointerEvent=e.isKeyboardEvent=e.isMouseEvent=e.removeCSSRulesContainingSelector=e.createCSSRule=e.createLinkElement=e.createMetaElement=e.sharedMutationObserver=e.cloneGlobalStylesheets=e.createStyleSheet=e.createStyleSheet2=e.isGlobalStylesheet=e.focusWindow=e.getActiveWindow=e.getActiveDocument=e.isActiveDocument=e.isAncestorOfActiveElement=e.isActiveElement=e.getActiveElement=e.getShadowRoot=e.isInShadowDOM=e.isShadowRoot=e.hasParentWithClass=e.findParentWithClass=e.isAncestorUsingFlowTo=e.setParentFlowTo=e.isAncestor=e.getLargestChildWidth=e.getTotalHeight=e.getContentHeight=e.getTotalScrollWidth=e.getContentWidth=e.getTotalWidth=e.getDomNodeZoomLevel=e.getDomNodePagePosition=e.position=e.size=e.getTopLeftOffset=e.Dimension=e.getClientArea=e.getComputedStyle=e.addDisposableThrottledListener=e.modify=e.measure=e.WindowIntervalTimer=e.disposableWindowInterval=e.scheduleAtNextAnimationFrame=e.runAtThisOrScheduleAtNextAnimationFrame=e.WindowIdleValue=e.runWhenWindowIdle=e.addDisposableGenericMouseUpListener=e.addDisposableGenericMouseMoveListener=e.addDisposableGenericMouseDownListener=e.addStandardDisposableGenericMouseUpListener=e.addStandardDisposableGenericMouseDownListener=e.addStandardDisposableListener=e.addDisposableListener=e.clearNode=e.onDidUnregisterWindow=e.onWillUnregisterWindow=e.onDidRegisterWindow=e.hasWindow=e.getWindowById=e.getWindowId=e.getWindowsCount=e.getWindows=e.getDocument=e.getWindow=e.registerWindow=void 0,h=function(){const $=new Map;(0,s.ensureCodeWindow)(s.mainWindow,1);const q={window:s.mainWindow,disposables:new v.DisposableStore};$.set(s.mainWindow.vscodeWindowId,q);const ee=new p.Emitter,he=new p.Emitter,Se=new p.Emitter;function He(Oe,Ue){return(typeof Oe=="number"?$.get(Oe):void 0)??(Ue?q:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:he.event,registerWindow(Oe){if($.has(Oe.vscodeWindowId))return v.Disposable.None;const Ue=new v.DisposableStore,Ke={window:Oe,disposables:Ue.add(new v.DisposableStore)};return $.set(Oe.vscodeWindowId,Ke),Ue.add((0,v.toDisposable)(()=>{$.delete(Oe.vscodeWindowId),he.fire(Oe)})),Ue.add(D(Oe,e.EventType.BEFORE_UNLOAD,()=>{Se.fire(Oe)})),ee.fire(Ke),Ue},getWindows(){return $.values()},getWindowsCount(){return $.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return $.has(Oe)},getWindowById:He,getWindow(Oe){const Ue=Oe;if(Ue?.ownerDocument?.defaultView)return Ue.ownerDocument.defaultView.window;const Ke=Oe;return Ke?.view?Ke.view.window:s.mainWindow},getDocument(Oe){const Ue=Oe;return(0,e.getWindow)(Ue).document}}}(),e.registerWindow=h.registerWindow,e.getWindow=h.getWindow,e.getDocument=h.getDocument,e.getWindows=h.getWindows,e.getWindowsCount=h.getWindowsCount,e.getWindowId=h.getWindowId,e.getWindowById=h.getWindowById,e.hasWindow=h.hasWindow,e.onDidRegisterWindow=h.onDidRegisterWindow,e.onWillUnregisterWindow=h.onWillUnregisterWindow,e.onDidUnregisterWindow=h.onDidUnregisterWindow;function g($){for(;$.firstChild;)$.firstChild.remove()}e.clearNode=g;class c{constructor(q,ee,he,Se){this._node=q,this._type=ee,this._handler=he,this._options=Se||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function D($,q,ee,he){return new c($,q,ee,he)}e.addDisposableListener=D;function u($,q){return function(ee){return q(new U.StandardMouseEvent($,ee))}}function m($){return function(q){return $(new n.StandardKeyboardEvent(q))}}const a=function(q,ee,he,Se){let He=he;return ee==="click"||ee==="mousedown"?He=u((0,e.getWindow)(q),he):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(He=m(he)),D(q,ee,He,Se)};e.addStandardDisposableListener=a;const E=function(q,ee,he){const Se=u((0,e.getWindow)(q),ee);return N(q,Se,he)};e.addStandardDisposableGenericMouseDownListener=E;const k=function(q,ee,he){const Se=u((0,e.getWindow)(q),ee);return W(q,Se,he)};e.addStandardDisposableGenericMouseUpListener=k;function N($,q,ee){return D($,l.isIOS&&F.BrowserFeatures.pointerEvents?e.EventType.POINTER_DOWN:e.EventType.MOUSE_DOWN,q,ee)}e.addDisposableGenericMouseDownListener=N;function H($,q,ee){return D($,l.isIOS&&F.BrowserFeatures.pointerEvents?e.EventType.POINTER_MOVE:e.EventType.MOUSE_MOVE,q,ee)}e.addDisposableGenericMouseMoveListener=H;function W($,q,ee){return D($,l.isIOS&&F.BrowserFeatures.pointerEvents?e.EventType.POINTER_UP:e.EventType.MOUSE_UP,q,ee)}e.addDisposableGenericMouseUpListener=W;function _($,q,ee){return(0,y._runWhenIdle)($,q,ee)}e.runWhenWindowIdle=_;class B extends y.AbstractIdleValue{constructor(q,ee){super(q,ee)}}e.WindowIdleValue=B;function z($,q,ee,he){let Se=0;const He=$.setInterval(()=>{Se++,(typeof he=="number"&&Se>=he||q()===!0)&&Oe.dispose()},ee),Oe=(0,v.toDisposable)(()=>{$.clearInterval(He)});return Oe}e.disposableWindowInterval=z;class T extends y.IntervalTimer{constructor(q){super(),this.defaultTarget=q&&(0,e.getWindow)(q)}cancelAndSet(q,ee,he){return super.cancelAndSet(q,ee,he??this.defaultTarget)}}e.WindowIntervalTimer=T;class P{constructor(q,ee=0){this._runner=q,this.priority=ee,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(q){(0,A.onUnexpectedError)(q)}}static sort(q,ee){return ee.priority-q.priority}}(function(){const $=new Map,q=new Map,ee=new Map,he=new Map,Se=He=>{ee.set(He,!1);const Oe=$.get(He)??[];for(q.set(He,Oe),$.set(He,[]),he.set(He,!0);Oe.length>0;)Oe.sort(P.sort),Oe.shift().execute();he.set(He,!1)};e.scheduleAtNextAnimationFrame=(He,Oe,Ue=0)=>{const Ke=(0,e.getWindowId)(He),qe=new P(Oe,Ue);let at=$.get(Ke);return at||(at=[],$.set(Ke,at)),at.push(qe),ee.get(Ke)||(ee.set(Ke,!0),He.requestAnimationFrame(()=>Se(Ke))),qe},e.runAtThisOrScheduleAtNextAnimationFrame=(He,Oe,Ue)=>{const Ke=(0,e.getWindowId)(He);if(he.get(Ke)){const qe=new P(Oe,Ue);let at=q.get(Ke);return at||(at=[],q.set(Ke,at)),at.push(qe),qe}else return(0,e.scheduleAtNextAnimationFrame)(He,Oe,Ue)}})();function M($,q){return(0,e.scheduleAtNextAnimationFrame)($,q,1e4)}e.measure=M;function Y($,q){return(0,e.scheduleAtNextAnimationFrame)($,q,-1e4)}e.modify=Y;const Z=8,fe=function($,q){return q};class ce extends v.Disposable{constructor(q,ee,he,Se=fe,He=Z){super();let Oe=null,Ue=0;const Ke=this._register(new y.TimeoutTimer),qe=()=>{Ue=new Date().getTime(),he(Oe),Oe=null};this._register(D(q,ee,at=>{Oe=Se(Oe,at);const It=new Date().getTime()-Ue;It>=He?(Ke.cancel(),qe()):Ke.setIfNotSet(qe,He-It)}))}}function te($,q,ee,he,Se){return new ce($,q,ee,he,Se)}e.addDisposableThrottledListener=te;function ge($){return(0,e.getWindow)($).getComputedStyle($,null)}e.getComputedStyle=ge;function ke($,q){const ee=(0,e.getWindow)($),he=ee.document;if($!==he.body)return new Be($.clientWidth,$.clientHeight);if(l.isIOS&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(he.body&&he.body.clientWidth&&he.body.clientHeight)return new Be(he.body.clientWidth,he.body.clientHeight);if(he.documentElement&&he.documentElement.clientWidth&&he.documentElement.clientHeight)return new Be(he.documentElement.clientWidth,he.documentElement.clientHeight);if(q)return ke(q);throw new Error("Unable to figure out browser width and height")}e.getClientArea=ke;class Le{static convertToPixels(q,ee){return parseFloat(ee)||0}static getDimension(q,ee,he){const Se=ge(q),He=Se?Se.getPropertyValue(ee):"0";return Le.convertToPixels(q,He)}static getBorderLeftWidth(q){return Le.getDimension(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return Le.getDimension(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return Le.getDimension(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return Le.getDimension(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return Le.getDimension(q,"padding-left","paddingLeft")}static getPaddingRight(q){return Le.getDimension(q,"padding-right","paddingRight")}static getPaddingTop(q){return Le.getDimension(q,"padding-top","paddingTop")}static getPaddingBottom(q){return Le.getDimension(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return Le.getDimension(q,"margin-left","marginLeft")}static getMarginTop(q){return Le.getDimension(q,"margin-top","marginTop")}static getMarginRight(q){return Le.getDimension(q,"margin-right","marginRight")}static getMarginBottom(q){return Le.getDimension(q,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(q,ee){this.width=q,this.height=ee}with(q=this.width,ee=this.height){return q!==this.width||ee!==this.height?new Be(q,ee):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof Be?q:new Be(q.width,q.height)}static equals(q,ee){return q===ee?!0:!q||!ee?!1:q.width===ee.width&&q.height===ee.height}}e.Dimension=Be;function le($){let q=$.offsetParent,ee=$.offsetTop,he=$.offsetLeft;for(;($=$.parentNode)!==null&&$!==$.ownerDocument.body&&$!==$.ownerDocument.documentElement;){ee-=$.scrollTop;const Se=R($)?null:ge($);Se&&(he-=Se.direction!=="rtl"?$.scrollLeft:-$.scrollLeft),$===q&&(he+=Le.getBorderLeftWidth($),ee+=Le.getBorderTopWidth($),ee+=$.offsetTop,he+=$.offsetLeft,q=$.offsetParent)}return{left:he,top:ee}}e.getTopLeftOffset=le;function J($,q,ee){typeof q=="number"&&($.style.width=`${q}px`),typeof ee=="number"&&($.style.height=`${ee}px`)}e.size=J;function ae($,q,ee,he,Se,He="absolute"){typeof q=="number"&&($.style.top=`${q}px`),typeof ee=="number"&&($.style.right=`${ee}px`),typeof he=="number"&&($.style.bottom=`${he}px`),typeof Se=="number"&&($.style.left=`${Se}px`),$.style.position=He}e.position=ae;function re($){const q=$.getBoundingClientRect(),ee=(0,e.getWindow)($);return{left:q.left+ee.scrollX,top:q.top+ee.scrollY,width:q.width,height:q.height}}e.getDomNodePagePosition=re;function X($){let q=$,ee=1;do{const he=ge(q).zoom;he!=null&&he!=="1"&&(ee*=he),q=q.parentElement}while(q!==null&&q!==q.ownerDocument.documentElement);return ee}e.getDomNodeZoomLevel=X;function j($){const q=Le.getMarginLeft($)+Le.getMarginRight($);return $.offsetWidth+q}e.getTotalWidth=j;function ie($){const q=Le.getBorderLeftWidth($)+Le.getBorderRightWidth($),ee=Le.getPaddingLeft($)+Le.getPaddingRight($);return $.offsetWidth-q-ee}e.getContentWidth=ie;function de($){const q=Le.getMarginLeft($)+Le.getMarginRight($);return $.scrollWidth+q}e.getTotalScrollWidth=de;function Ee($){const q=Le.getBorderTopWidth($)+Le.getBorderBottomWidth($),ee=Le.getPaddingTop($)+Le.getPaddingBottom($);return $.offsetHeight-q-ee}e.getContentHeight=Ee;function Ie($){const q=Le.getMarginTop($)+Le.getMarginBottom($);return $.offsetHeight+q}e.getTotalHeight=Ie;function Ce($,q){if($===null)return 0;const ee=le($),he=le(q);return ee.left-he.left}function K($,q){const ee=q.map(Se=>Math.max(de(Se),j(Se))+Ce(Se,$)||0);return Math.max(...ee)}e.getLargestChildWidth=K;function f($,q){return!!q?.contains($)}e.isAncestor=f;const C="parentFlowToElementId";function I($,q){$.dataset[C]=q.id}e.setParentFlowTo=I;function r($){const q=$.dataset[C];return typeof q=="string"?$.ownerDocument.getElementById(q):null}function i($,q){let ee=$;for(;ee;){if(ee===q)return!0;if(ee instanceof HTMLElement){const he=r(ee);if(he){ee=he;continue}}ee=ee.parentNode}return!1}e.isAncestorUsingFlowTo=i;function o($,q,ee){for(;$&&$.nodeType===$.ELEMENT_NODE;){if($.classList.contains(q))return $;if(ee){if(typeof ee=="string"){if($.classList.contains(ee))return null}else if($===ee)return null}$=$.parentNode}return null}e.findParentWithClass=o;function w($,q,ee){return!!o($,q,ee)}e.hasParentWithClass=w;function R($){return $&&!!$.host&&!!$.mode}e.isShadowRoot=R;function L($){return!!x($)}e.isInShadowDOM=L;function x($){for(;$.parentNode;){if($===$.ownerDocument?.body)return null;$=$.parentNode}return R($)?$:null}e.getShadowRoot=x;function V(){let $=ye().activeElement;for(;$?.shadowRoot;)$=$.shadowRoot.activeElement;return $}e.getActiveElement=V;function Q($){return V()===$}e.isActiveElement=Q;function oe($){return f(V(),$)}e.isAncestorOfActiveElement=oe;function pe($){return $.ownerDocument===ye()}e.isActiveDocument=pe;function ye(){return(0,e.getWindowsCount)()<=1?s.mainWindow.document:Array.from((0,e.getWindows)()).map(({window:q})=>q.document).find(q=>q.hasFocus())??s.mainWindow.document}e.getActiveDocument=ye;function we(){return ye().defaultView?.window??s.mainWindow}e.getActiveWindow=we;function Ae($){const q=(0,e.getWindow)($);q.document.hasFocus()||q.focus()}e.focusWindow=Ae;const De=new Map;function Fe($){return De.has($)}e.isGlobalStylesheet=Fe;function Pe(){return new Re}e.createStyleSheet2=Pe;class Re{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(q){q!==this._currentCssStyle&&(this._currentCssStyle=q,this._styleSheet?this._styleSheet.innerText=q:this._styleSheet=Ze(s.mainWindow.document.head,ee=>ee.innerText=q))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function Ze($=s.mainWindow.document.head,q,ee){const he=document.createElement("style");if(he.type="text/css",he.media="screen",q?.(he),$.appendChild(he),ee&&ee.add((0,v.toDisposable)(()=>$.removeChild(he))),$===s.mainWindow.document.head){const Se=new Set;De.set(he,Se);for(const{window:He,disposables:Oe}of(0,e.getWindows)()){if(He===s.mainWindow)continue;const Ue=Oe.add(je(he,Se,He));ee?.add(Ue)}}return he}e.createStyleSheet=Ze;function nt($){const q=new v.DisposableStore;for(const[ee,he]of De)q.add(je(ee,he,$));return q}e.cloneGlobalStylesheets=nt;function je($,q,ee){const he=new v.DisposableStore,Se=$.cloneNode(!0);ee.document.head.appendChild(Se),he.add((0,v.toDisposable)(()=>ee.document.head.removeChild(Se)));for(const He of Ne($))Se.sheet?.insertRule(He.cssText,Se.sheet?.cssRules.length);return he.add(e.sharedMutationObserver.observe($,he,{childList:!0})(()=>{Se.textContent=$.textContent})),q.add(Se),he.add((0,v.toDisposable)(()=>q.delete(Se))),he}e.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe($,q,ee){let he=this.mutationObservers.get($);he||(he=new Map,this.mutationObservers.set($,he));const Se=(0,t.hash)(ee);let He=he.get(Se);if(He)He.users+=1;else{const Oe=new p.Emitter,Ue=new MutationObserver(qe=>Oe.fire(qe));Ue.observe($,ee);const Ke=He={users:1,observer:Ue,onDidMutate:Oe.event};q.add((0,v.toDisposable)(()=>{Ke.users-=1,Ke.users===0&&(Oe.dispose(),Ue.disconnect(),he?.delete(Se),he?.size===0&&this.mutationObservers.delete($))})),he.set(Se,He)}return He.onDidMutate}};function Qe($=s.mainWindow.document.head){return ne("meta",$)}e.createMetaElement=Qe;function G($=s.mainWindow.document.head){return ne("link",$)}e.createLinkElement=G;function ne($,q=s.mainWindow.document.head){const ee=document.createElement($);return q.appendChild(ee),ee}let ve=null;function _e(){return ve||(ve=Ze()),ve}function Ne($){return $?.sheet?.rules?$.sheet.rules:$?.sheet?.cssRules?$.sheet.cssRules:[]}function xe($,q,ee=_e()){if(!(!ee||!q)){ee.sheet?.insertRule(`${$} {${q}}`,0);for(const he of De.get(ee)??[])xe($,q,he)}}e.createCSSRule=xe;function $e($,q=_e()){if(!q)return;const ee=Ne(q),he=[];for(let Se=0;Se<ee.length;Se++){const He=ee[Se];Je(He)&&He.selectorText.indexOf($)!==-1&&he.push(Se)}for(let Se=he.length-1;Se>=0;Se--)q.sheet?.deleteRule(he[Se]);for(const Se of De.get(q)??[])$e($,Se)}e.removeCSSRulesContainingSelector=$e;function Je($){return typeof $.selectorText=="string"}function tt($){return $ instanceof MouseEvent||$ instanceof(0,e.getWindow)($).MouseEvent}e.isMouseEvent=tt;function st($){return $ instanceof KeyboardEvent||$ instanceof(0,e.getWindow)($).KeyboardEvent}e.isKeyboardEvent=st;function Xe($){return $ instanceof PointerEvent||$ instanceof(0,e.getWindow)($).PointerEvent}e.isPointerEvent=Xe;function rt($){return $ instanceof DragEvent||$ instanceof(0,e.getWindow)($).DragEvent}e.isDragEvent=rt,e.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:S.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:S.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:S.isWebKit?"webkitAnimationIteration":"animationiteration"};function et($){const q=$;return!!(q&&typeof q.preventDefault=="function"&&typeof q.stopPropagation=="function")}e.isEventLike=et,e.EventHelper={stop:($,q)=>($.preventDefault(),q&&$.stopPropagation(),$)};function gt($){const q=[];for(let ee=0;$&&$.nodeType===$.ELEMENT_NODE;ee++)q[ee]=$.scrollTop,$=$.parentNode;return q}e.saveParentsScrollTop=gt;function mt($,q){for(let ee=0;$&&$.nodeType===$.ELEMENT_NODE;ee++)$.scrollTop!==q[ee]&&($.scrollTop=q[ee]),$=$.parentNode}e.restoreParentsScrollTop=mt;class pt extends v.Disposable{static hasFocusWithin(q){if(q instanceof HTMLElement){const ee=x(q),he=ee?ee.activeElement:q.ownerDocument.activeElement;return f(he,q)}else{const ee=q;return f(ee.document.activeElement,ee.document)}}constructor(q){super(),this._onDidFocus=this._register(new p.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new p.Emitter),this.onDidBlur=this._onDidBlur.event;let ee=pt.hasFocusWithin(q),he=!1;const Se=()=>{he=!1,ee||(ee=!0,this._onDidFocus.fire())},He=()=>{ee&&(he=!0,(q instanceof HTMLElement?(0,e.getWindow)(q):q).setTimeout(()=>{he&&(he=!1,ee=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{pt.hasFocusWithin(q)!==ee&&(ee?He():Se())},this._register(D(q,e.EventType.FOCUS,Se,!0)),this._register(D(q,e.EventType.BLUR,He,!0)),q instanceof HTMLElement&&(this._register(D(q,e.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(D(q,e.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function Tt($){return new pt($)}e.trackFocus=Tt;function Ot($,q){return $.after(q),q}e.after=Ot;function We($,...q){if($.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}e.append=We;function ue($,q){return $.insertBefore(q,$.firstChild),q}e.prepend=ue;function Te($,...q){$.innerText="",We($,...q)}e.reset=Te;const Me=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ve;(function($){$.HTML="http://www.w3.org/1999/xhtml",$.SVG="http://www.w3.org/2000/svg"})(Ve||(e.Namespace=Ve={}));function it($,q,ee,...he){const Se=Me.exec(q);if(!Se)throw new Error("Bad use of emmet");const He=Se[1]||"div";let Oe;return $!==Ve.HTML?Oe=document.createElementNS($,He):Oe=document.createElement(He),Se[3]&&(Oe.id=Se[3]),Se[4]&&(Oe.className=Se[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([Ue,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(Ue)?Oe[Ue]=Ke:Ue==="selected"?Ke&&Oe.setAttribute(Ue,"true"):Oe.setAttribute(Ue,Ke))}),Oe.append(...he),Oe}function lt($,q,...ee){return it(Ve.HTML,$,q,...ee)}e.$=lt,lt.SVG=function($,q,...ee){return it(Ve.SVG,$,q,...ee)};function Ge($,q){const ee=[];return $.forEach((he,Se)=>{Se>0&&(q instanceof Node?ee.push(q.cloneNode()):ee.push(document.createTextNode(q))),ee.push(he)}),ee}e.join=Ge;function ht($,...q){$?vt(...q):Et(...q)}e.setVisibility=ht;function vt(...$){for(const q of $)q.style.display="",q.removeAttribute("aria-hidden")}e.show=vt;function Et(...$){for(const q of $)q.style.display="none",q.setAttribute("aria-hidden","true")}e.hide=Et;function Yt($,q){for(;$&&$.nodeType===$.ELEMENT_NODE;){if($ instanceof HTMLElement&&$.hasAttribute(q))return $;$=$.parentNode}return null}function Si($){!$||!$.hasAttribute("tabIndex")||($.ownerDocument.activeElement===$&&Yt($.parentElement,"tabIndex")?.focus(),$.removeAttribute("tabindex"))}e.removeTabIndexAndUpdateFocus=Si;function Ci($){return q=>{q.preventDefault(),q.stopPropagation(),$(q)}}e.finalHandler=Ci;function Ai($){return new Promise(q=>{if($.document.readyState==="complete"||$.document&&$.document.body!==null)q(void 0);else{const he=()=>{$.window.removeEventListener("DOMContentLoaded",he,!1),q()};$.window.addEventListener("DOMContentLoaded",he,!1)}})}e.domContentLoaded=Ai;function Ti($,q){const ee=$.devicePixelRatio*q;return Math.max(1,Math.floor(ee))/$.devicePixelRatio}e.computeScreenAwareSize=Ti;function Ii($){s.mainWindow.open($,"_blank","noopener")}e.windowOpenNoOpener=Ii;const Xt=780,Zt=640;function Li($){const q=Math.floor(s.mainWindow.screenLeft+s.mainWindow.innerWidth/2-Xt/2),ee=Math.floor(s.mainWindow.screenTop+s.mainWindow.innerHeight/2-Zt/2);s.mainWindow.open($,"_blank",`width=${Xt},height=${Zt},top=${ee},left=${q}`)}e.windowOpenPopup=Li;function Fi($,q=!0){const ee=s.mainWindow.open();return ee?(q&&(ee.opener=null),ee.location.href=$,!0):!1}e.windowOpenWithSuccess=Fi;function Ni($,q){const ee=()=>{q(),he=(0,e.scheduleAtNextAnimationFrame)($,ee)};let he=(0,e.scheduleAtNextAnimationFrame)($,ee);return(0,v.toDisposable)(()=>he.dispose())}e.animate=Ni,O.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(s.mainWindow.location.href)?"https":"http");function ki($){return $?`url('${O.FileAccess.uriToBrowserUri($).toString(!0).replace(/'/g,"%27")}')`:"url('')"}e.asCSSUrl=ki;function Mi($){return`'${$.replace(/'/g,"%27")}'`}e.asCSSPropertyValue=Mi;function Qt($,q){if($!==void 0){const ee=$.match(/^\s*var\((.+)\)$/);if(ee){const he=ee[1].split(",",2);return he.length===2&&(q=Qt(he[1].trim(),q)),`var(${he[0]}, ${q})`}return $}return q}e.asCssValueWithDefault=Qt;function Pi($,q){let ee;if(d.URI.isUri($))ee=$.toString(!0);else{const He=new Blob([$]);ee=URL.createObjectURL(He),setTimeout(()=>URL.revokeObjectURL(ee))}const he=we(),Se=document.createElement("a");he.document.body.appendChild(Se),Se.download=q,Se.href=ee,Se.click(),setTimeout(()=>he.document.body.removeChild(Se))}e.triggerDownload=Pi;function Ri(){return new Promise($=>{const q=we(),ee=document.createElement("input");q.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,p.Event.once(p.Event.fromDOMEventEmitter(ee,"input"))(()=>{$(ee.files??void 0)}),ee.click(),setTimeout(()=>q.document.body.removeChild(ee))})}e.triggerUpload=Ri;var _t;(function($){$[$.DOCUMENT=1]="DOCUMENT",$[$.BROWSER=2]="BROWSER"})(_t||(e.DetectedFullscreenMode=_t={}));function Oi($){return $.document.fullscreenElement||$.document.webkitFullscreenElement||$.document.webkitIsFullScreen?{mode:_t.DOCUMENT,guess:!1}:$.innerHeight===$.screen.height?{mode:_t.BROWSER,guess:!1}:(l.isMacintosh||l.isLinux)&&$.outerHeight===$.screen.height&&$.outerWidth===$.screen.width?{mode:_t.BROWSER,guess:!0}:null}e.detectFullscreen=Oi;function Jt($,q=!1){const ee=document.createElement("a");return b.addHook("afterSanitizeAttributes",he=>{for(const Se of["href","src"])if(he.hasAttribute(Se)){const He=he.getAttribute(Se);if(Se==="href"&&He.startsWith("#"))continue;if(ee.href=He,!$.includes(ee.protocol.replace(/:$/,""))){if(q&&Se==="src"&&ee.href.startsWith("data:"))continue;he.removeAttribute(Se)}}}),(0,v.toDisposable)(()=>{b.removeHook("afterSanitizeAttributes")})}e.hookDomPurifyHrefAndSrcSanitizer=Jt;const Bi=[O.Schemas.http,O.Schemas.https,O.Schemas.command];e.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Wi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Hi($,q){const ee=Jt(Bi);try{const he=b.sanitize(q,Wi);$.innerHTML=he}finally{ee.dispose()}}e.safeInnerHtml=Hi;function xi($){const q=new Uint16Array($.length);for(let Se=0;Se<q.length;Se++)q[Se]=$.charCodeAt(Se);let ee="";const he=new Uint8Array(q.buffer);for(let Se=0;Se<he.length;Se++)ee+=String.fromCharCode(he[Se]);return ee}function zi($){return btoa(xi($))}e.multibyteAwareBtoa=zi;class Dt extends p.Emitter{constructor(){super(),this._subscriptions=new v.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(p.Event.runAndSubscribe(e.onDidRegisterWindow,({window:q,disposables:ee})=>this.registerListeners(q,ee),{window:s.mainWindow,disposables:this._subscriptions}))}registerListeners(q,ee){ee.add(D(q,"keydown",he=>{if(he.defaultPrevented)return;const Se=new n.StandardKeyboardEvent(he);if(!(Se.keyCode===6&&he.repeat)){if(he.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(he.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(he.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(he.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(Se.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=he.altKey,this._keyStatus.ctrlKey=he.ctrlKey,this._keyStatus.metaKey=he.metaKey,this._keyStatus.shiftKey=he.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=he,this.fire(this._keyStatus))}},!0)),ee.add(D(q,"keyup",he=>{he.defaultPrevented||(!he.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!he.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!he.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!he.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=he.altKey,this._keyStatus.ctrlKey=he.ctrlKey,this._keyStatus.metaKey=he.metaKey,this._keyStatus.shiftKey=he.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=he,this.fire(this._keyStatus)))},!0)),ee.add(D(q.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),ee.add(D(q.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),ee.add(D(q.document.body,"mousemove",he=>{he.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),ee.add(D(q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return Dt.instance||(Dt.instance=new Dt),Dt.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}e.ModifierKeyEmitter=Dt;function Ui($){const q=document.cookie.match("(^|[^;]+)\\s*"+$+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}e.getCookieValue=Ui;class $i extends v.Disposable{constructor(q,ee){super(),this.element=q,this.callbacks=ee,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(D(this.element,e.EventType.DRAG_START,q=>{this.callbacks.onDragStart?.(q)})),this.callbacks.onDrag&&this._register(D(this.element,e.EventType.DRAG,q=>{this.callbacks.onDrag?.(q)})),this._register(D(this.element,e.EventType.DRAG_ENTER,q=>{this.counter++,this.dragStartTime=q.timeStamp,this.callbacks.onDragEnter?.(q)})),this._register(D(this.element,e.EventType.DRAG_OVER,q=>{q.preventDefault(),this.callbacks.onDragOver?.(q,q.timeStamp-this.dragStartTime)})),this._register(D(this.element,e.EventType.DRAG_LEAVE,q=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(q))})),this._register(D(this.element,e.EventType.DRAG_END,q=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(q)})),this._register(D(this.element,e.EventType.DROP,q=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(q)}))}}e.DragAndDropObserver=$i;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ki($,...q){let ee,he;Array.isArray(q[0])?(ee={},he=q[0]):(ee=q[0]||{},he=q[1]);const Se=Vi.exec($);if(!Se||!Se.groups)throw new Error("Bad use of h");const He=Se.groups.tag||"div",Oe=document.createElement(He);Se.groups.id&&(Oe.id=Se.groups.id);const Ue=[];if(Se.groups.class)for(const qe of Se.groups.class.split("."))qe!==""&&Ue.push(qe);if(ee.className!==void 0)for(const qe of ee.className.split("."))qe!==""&&Ue.push(qe);Ue.length>0&&(Oe.className=Ue.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=Oe),he)for(const qe of he)qe instanceof HTMLElement?Oe.appendChild(qe):typeof qe=="string"?Oe.append(qe):"root"in qe&&(Object.assign(Ke,qe),Oe.appendChild(qe.root));for(const[qe,at]of Object.entries(ee))if(qe!=="className")if(qe==="style")for(const[It,Bt]of Object.entries(at))Oe.style.setProperty(ei(It),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(qe),at.toString());return Ke.root=Oe,Ke}e.h=Ki;function ei($){return $.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti($,q,ee){for(const{name:he,value:Se}of $.attributes)(!ee||ee.includes(he))&&q.setAttribute(he,Se)}e.copyAttributes=ti;function qi($,q,ee){const he=$.getAttribute(ee);he?q.setAttribute(ee,he):q.removeAttribute(ee)}function ji($,q,ee){ti($,q,ee);const he=new v.DisposableStore;return he.add(e.sharedMutationObserver.observe($,he,{attributes:!0,attributeFilter:ee})(Se=>{for(const He of Se)He.type==="attributes"&&He.attributeName&&qi($,q,He.attributeName)})),he}e.trackAttributes=ji}),define(me[56],be([1,0,2,3,119]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyDragImage=e.DataTransfers=e.DelayedDragHandler=void 0;class U extends F.Disposable{constructor(p,b){super(),this._register((0,S.addDisposableListener)(p,"dragover",v=>{v.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{b(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(v=>{this._register((0,S.addDisposableListener)(p,v,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}e.DelayedDragHandler=U,e.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function y(A,p,b,v,O){const l=document.createElement("div");if(l.className=b,l.textContent=p,O&&(l.style.color=O),v&&(l.style.background=v),A.dataTransfer){const d=(0,S.getWindow)(A).document;d.body.appendChild(l),A.dataTransfer.setDragImage(l,-10,-10),setTimeout(()=>d.body.removeChild(l),0)}}e.applyDragImage=y}),define(me[57],be([1,0,2]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createElement=e.renderFormattedText=e.renderText=void 0;function F(l,d={}){const t=U(d);return t.textContent=l,t}e.renderText=F;function n(l,d={}){const t=U(d);return p(t,b(l,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),t}e.renderFormattedText=n;function U(l){const d=l.inline?"span":"div",t=document.createElement(d);return l.className&&(t.className=l.className),t}e.createElement=U;class y{constructor(d){this.source=d,this.index=0}eos(){return this.index>=this.source.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.source[this.index]}advance(){this.index++}}var A;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(A||(A={}));function p(l,d,t,s){let h;if(d.type===2)h=document.createTextNode(d.content||"");else if(d.type===3)h=document.createElement("b");else if(d.type===4)h=document.createElement("i");else if(d.type===7&&s)h=document.createElement("code");else if(d.type===5&&t){const g=document.createElement("a");t.disposables.add(S.addStandardDisposableListener(g,"click",c=>{t.callback(String(d.index),c)})),h=g}else d.type===8?h=document.createElement("br"):d.type===1&&(h=l);h&&l!==h&&l.appendChild(h),h&&Array.isArray(d.children)&&d.children.forEach(g=>{p(h,g,t,s)})}function b(l,d){const t={type:1,children:[]};let s=0,h=t;const g=[],c=new y(l);for(;!c.eos();){let D=c.next();const u=D==="\\"&&O(c.peek(),d)!==0;if(u&&(D=c.next()),!u&&v(D,d)&&D===c.peek()){c.advance(),h.type===2&&(h=g.pop());const m=O(D,d);if(h.type===m||h.type===5&&m===6)h=g.pop();else{const a={type:m,children:[]};m===5&&(a.index=s,s++),h.children.push(a),g.push(h),h=a}}else if(D===`
`)h.type===2&&(h=g.pop()),h.children.push({type:8});else if(h.type!==2){const m={type:2,content:D};h.children.push(m),g.push(h),h=m}else h.content+=D}return h.type===2&&(h=g.pop()),g.length,t}function v(l,d){return O(l,d)!==0}function O(l,d){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return d?7:0;default:return 0}}}),define(me[58],be([1,0,2,3]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalPointerMoveMonitor=void 0;class n{constructor(){this._hooks=new F.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(y,A){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const p=this._onStopCallback;this._onStopCallback=null,y&&p&&p(A)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(y,A,p,b,v){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=b,this._onStopCallback=v;let O=y;try{y.setPointerCapture(A),this._hooks.add((0,F.toDisposable)(()=>{try{y.releasePointerCapture(A)}catch{}}))}catch{O=S.getWindow(y)}this._hooks.add(S.addDisposableListener(O,S.EventType.POINTER_MOVE,l=>{if(l.buttons!==p){this.stopMonitoring(!0);return}l.preventDefault(),this._pointerMoveCallback(l)})),this._hooks.add(S.addDisposableListener(O,S.EventType.POINTER_UP,l=>this.stopMonitoring(!0)))}}e.GlobalPointerMoveMonitor=n});var Ye=this&&this.__decorate||function(se,e,S,F){var n=arguments.length,U=n<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(se,e,S,F);else for(var A=se.length-1;A>=0;A--)(y=se[A])&&(U=(n<3?y(U):n>3?y(e,S,U):y(e,S))||U);return n>3&&U&&Object.defineProperty(e,S,U),U};define(me[25],be([1,0,2,21,12,27,4,3,48]),function(se,e,S,F,n,U,y,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Gesture=e.EventType=void 0;var b;(function(O){O.Tap="-monaco-gesturetap",O.Change="-monaco-gesturechange",O.Start="-monaco-gesturestart",O.End="-monaco-gesturesend",O.Contextmenu="-monaco-gesturecontextmenu"})(b||(e.EventType=b={}));class v extends A.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new p.LinkedList,this.ignoreTargets=new p.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(y.Event.runAndSubscribe(S.onDidRegisterWindow,({window:l,disposables:d})=>{d.add(S.addDisposableListener(l.document,"touchstart",t=>this.onTouchStart(t),{passive:!1})),d.add(S.addDisposableListener(l.document,"touchend",t=>this.onTouchEnd(l,t))),d.add(S.addDisposableListener(l.document,"touchmove",t=>this.onTouchMove(t),{passive:!1}))},{window:F.mainWindow,disposables:this._store}))}static addTarget(l){if(!v.isTouchDevice())return A.Disposable.None;v.INSTANCE||(v.INSTANCE=(0,A.markAsSingleton)(new v));const d=v.INSTANCE.targets.push(l);return(0,A.toDisposable)(d)}static ignoreTarget(l){if(!v.isTouchDevice())return A.Disposable.None;v.INSTANCE||(v.INSTANCE=(0,A.markAsSingleton)(new v));const d=v.INSTANCE.ignoreTargets.push(l);return(0,A.toDisposable)(d)}static isTouchDevice(){return"ontouchstart"in F.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(l){const d=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let t=0,s=l.targetTouches.length;t<s;t++){const h=l.targetTouches.item(t);this.activeTouches[h.identifier]={id:h.identifier,initialTarget:h.target,initialTimeStamp:d,initialPageX:h.pageX,initialPageY:h.pageY,rollingTimestamps:[d],rollingPageX:[h.pageX],rollingPageY:[h.pageY]};const g=this.newGestureEvent(b.Start,h.target);g.pageX=h.pageX,g.pageY=h.pageY,this.dispatchEvent(g)}this.dispatched&&(l.preventDefault(),l.stopPropagation(),this.dispatched=!1)}onTouchEnd(l,d){const t=Date.now(),s=Object.keys(this.activeTouches).length;for(let h=0,g=d.changedTouches.length;h<g;h++){const c=d.changedTouches.item(h);if(!this.activeTouches.hasOwnProperty(String(c.identifier))){console.warn("move of an UNKNOWN touch",c);continue}const D=this.activeTouches[c.identifier],u=Date.now()-D.initialTimeStamp;if(u<v.HOLD_DELAY&&Math.abs(D.initialPageX-n.tail(D.rollingPageX))<30&&Math.abs(D.initialPageY-n.tail(D.rollingPageY))<30){const m=this.newGestureEvent(b.Tap,D.initialTarget);m.pageX=n.tail(D.rollingPageX),m.pageY=n.tail(D.rollingPageY),this.dispatchEvent(m)}else if(u>=v.HOLD_DELAY&&Math.abs(D.initialPageX-n.tail(D.rollingPageX))<30&&Math.abs(D.initialPageY-n.tail(D.rollingPageY))<30){const m=this.newGestureEvent(b.Contextmenu,D.initialTarget);m.pageX=n.tail(D.rollingPageX),m.pageY=n.tail(D.rollingPageY),this.dispatchEvent(m)}else if(s===1){const m=n.tail(D.rollingPageX),a=n.tail(D.rollingPageY),E=n.tail(D.rollingTimestamps)-D.rollingTimestamps[0],k=m-D.rollingPageX[0],N=a-D.rollingPageY[0],H=[...this.targets].filter(W=>D.initialTarget instanceof Node&&W.contains(D.initialTarget));this.inertia(l,H,t,Math.abs(k)/E,k>0?1:-1,m,Math.abs(N)/E,N>0?1:-1,a)}this.dispatchEvent(this.newGestureEvent(b.End,D.initialTarget)),delete this.activeTouches[c.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(l,d){const t=document.createEvent("CustomEvent");return t.initEvent(l,!1,!0),t.initialTarget=d,t.tapCount=0,t}dispatchEvent(l){if(l.type===b.Tap){const d=new Date().getTime();let t=0;d-this._lastSetTapCountTime>v.CLEAR_TAP_COUNT_TIME?t=1:t=2,this._lastSetTapCountTime=d,l.tapCount=t}else(l.type===b.Change||l.type===b.Contextmenu)&&(this._lastSetTapCountTime=0);if(l.initialTarget instanceof Node){for(const d of this.ignoreTargets)if(d.contains(l.initialTarget))return;for(const d of this.targets)d.contains(l.initialTarget)&&(d.dispatchEvent(l),this.dispatched=!0)}}inertia(l,d,t,s,h,g,c,D,u){this.handle=S.scheduleAtNextAnimationFrame(l,()=>{const m=Date.now(),a=m-t;let E=0,k=0,N=!0;s+=v.SCROLL_FRICTION*a,c+=v.SCROLL_FRICTION*a,s>0&&(N=!1,E=h*s*a),c>0&&(N=!1,k=D*c*a);const H=this.newGestureEvent(b.Change);H.translationX=E,H.translationY=k,d.forEach(W=>W.dispatchEvent(H)),N||this.inertia(l,d,m,s,h,g+E,c,D,u+k)})}onTouchMove(l){const d=Date.now();for(let t=0,s=l.changedTouches.length;t<s;t++){const h=l.changedTouches.item(t);if(!this.activeTouches.hasOwnProperty(String(h.identifier))){console.warn("end of an UNKNOWN touch",h);continue}const g=this.activeTouches[h.identifier],c=this.newGestureEvent(b.Change,g.initialTarget);c.translationX=h.pageX-n.tail(g.rollingPageX),c.translationY=h.pageY-n.tail(g.rollingPageY),c.pageX=h.pageX,c.pageY=h.pageY,this.dispatchEvent(c),g.rollingPageX.length>3&&(g.rollingPageX.shift(),g.rollingPageY.shift(),g.rollingTimestamps.shift()),g.rollingPageX.push(h.pageX),g.rollingPageY.push(h.pageY),g.rollingTimestamps.push(d)}this.dispatched&&(l.preventDefault(),l.stopPropagation(),this.dispatched=!1)}}e.Gesture=v,Ye([U.memoize],v,"isTouchDevice",null)}),define(me[59],be([1,0,2,94]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.status=e.alert=e.setARIAContainer=void 0;const F=2e4;let n,U,y,A,p;function b(d){n=document.createElement("div"),n.className="monaco-aria-container";const t=()=>{const h=document.createElement("div");return h.className="monaco-alert",h.setAttribute("role","alert"),h.setAttribute("aria-atomic","true"),n.appendChild(h),h};U=t(),y=t();const s=()=>{const h=document.createElement("div");return h.className="monaco-status",h.setAttribute("aria-live","polite"),h.setAttribute("aria-atomic","true"),n.appendChild(h),h};A=s(),p=s(),d.appendChild(n)}e.setARIAContainer=b;function v(d){n&&(U.textContent!==d?(S.clearNode(y),l(U,d)):(S.clearNode(U),l(y,d)))}e.alert=v;function O(d){n&&(A.textContent!==d?(S.clearNode(p),l(A,d)):(S.clearNode(A),l(p,d)))}e.status=O;function l(d,t){S.clearNode(d),t.length>F&&(t=t.substr(0,F)),d.textContent=t,d.style.visibility="hidden",d.style.visibility="visible"}}),define(me[121],be([1,0,2,18]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.renderIcon=e.renderLabelWithIcons=void 0;const n=new RegExp(`(\\\\)?\\$\\((${F.ThemeIcon.iconNameExpression}(?:${F.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(A){const p=new Array;let b,v=0,O=0;for(;(b=n.exec(A))!==null;){O=b.index||0,v<O&&p.push(A.substring(v,O)),v=(b.index||0)+b[0].length;const[,l,d]=b;p.push(l?`$(${d})`:y({id:d}))}return v<A.length&&p.push(A.substring(v)),p}e.renderLabelWithIcons=U;function y(A){const p=S.$("span");return p.classList.add(...F.ThemeIcon.asClassNameArray(A)),p}e.renderIcon=y}),define(me[122],be([1,0,2]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RowCache=void 0;function F(U){try{U.parentElement?.removeChild(U)}catch{}}class n{constructor(y){this.renderers=y,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(y){let A=this.getTemplateCache(y).pop(),p=!1;if(A)p=this.transactionNodesPendingRemoval.has(A.domNode),p&&this.transactionNodesPendingRemoval.delete(A.domNode);else{const b=(0,S.$)(".monaco-list-row"),O=this.getRenderer(y).renderTemplate(b);A={domNode:b,templateId:y,templateData:O}}return{row:A,isReusingConnectedDomNode:p}}release(y){y&&this.releaseRow(y)}transact(y){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{y()}finally{for(const A of this.transactionNodesPendingRemoval)this.doRemoveNode(A);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(y){const{domNode:A,templateId:p}=y;A&&(this.inTransaction?this.transactionNodesPendingRemoval.add(A):this.doRemoveNode(A)),this.getTemplateCache(p).push(y)}doRemoveNode(y){y.classList.remove("scrolling"),F(y)}getTemplateCache(y){let A=this.cache.get(y);return A||(A=[],this.cache.set(y,A)),A}dispose(){this.cache.forEach((y,A)=>{for(const p of y)this.getRenderer(A).disposeTemplate(p.templateData),p.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(y){const A=this.renderers.get(y);if(!A)throw new Error(`No renderer found for ${y}`);return A}}e.RowCache=n}),define(me[123],be([1,0,9,3]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScrollbarVisibilityController=void 0;class n extends F.Disposable{constructor(y,A,p){super(),this._visibility=y,this._visibleClassName=A,this._invisibleClassName=p,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new S.TimeoutTimer)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this._updateShouldBeVisible())}setShouldBeVisible(y){this._rawShouldBeVisible=y,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const y=this._applyVisibilitySetting();this._shouldBeVisible!==y&&(this._shouldBeVisible=y,this.ensureVisibility())}setIsNeeded(y){this._isNeeded!==y&&(this._isNeeded=y,this.ensureVisibility())}setDomNode(y){this._domNode=y,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(y){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(y?" fade":"")))}}e.ScrollbarVisibilityController=n}),define(me[124],be([1,0,2,25,12,4,3,5]),function(se,e,S,F,n,U,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SelectBoxNative=void 0;class p extends y.Disposable{constructor(v,O,l,d){super(),this.selected=0,this.selectBoxOptions=d||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new U.Emitter),this.styles=l,this.registerListeners(),this.setOptions(v,O)}registerListeners(){this._register(F.Gesture.addTarget(this.selectElement)),[F.EventType.Tap].forEach(v=>{this._register(S.addDisposableListener(this.selectElement,v,O=>{this.selectElement.focus()}))}),this._register(S.addStandardDisposableListener(this.selectElement,"click",v=>{S.EventHelper.stop(v,!0)})),this._register(S.addStandardDisposableListener(this.selectElement,"change",v=>{this.selectElement.title=v.target.value,this._onDidSelect.fire({index:v.target.selectedIndex,selected:v.target.value})})),this._register(S.addStandardDisposableListener(this.selectElement,"keydown",v=>{let O=!1;A.isMacintosh?(v.keyCode===18||v.keyCode===16||v.keyCode===10)&&(O=!0):(v.keyCode===18&&v.altKey||v.keyCode===10||v.keyCode===3)&&(O=!0),O&&v.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(v,O){(!this.options||!n.equals(this.options,v))&&(this.options=v,this.selectElement.options.length=0,this.options.forEach((l,d)=>{this.selectElement.add(this.createOption(l.text,d,l.isDisabled))})),O!==void 0&&this.select(O)}select(v){this.options.length===0?this.selected=0:v>=0&&v<this.options.length?this.selected=v:v>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(v){this.selectBoxOptions.ariaLabel=v,this.selectElement.setAttribute("aria-label",v)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(v){this.selectElement.tabIndex=v?0:-1}render(v){v.classList.add("select-container"),v.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(v){this.styles=v,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(v,O,l){const d=document.createElement("option");return d.value=v,d.text=v,d.disabled=!!l,d}}e.SelectBoxNative=p}),define(me[60],be([1,0,26,12,9,52,89,4,28]),function(se,e,S,F,n,U,y,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IndexTreeModel=e.getVisibleState=e.isFilterResult=void 0;function b(d){return typeof d=="object"&&"visibility"in d&&"data"in d}e.isFilterResult=b;function v(d){switch(d){case!0:return 1;case!1:return 0;default:return d}}e.getVisibleState=v;function O(d){return typeof d.collapsible=="boolean"}class l{constructor(t,s,h,g={}){this.user=t,this.list=s,this.rootRef=[],this.eventBufferer=new A.EventBufferer,this._onDidChangeCollapseState=new A.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new A.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new A.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new n.Delayer(U.MicrotaskDelay),this.collapseByDefault=typeof g.collapseByDefault>"u"?!1:g.collapseByDefault,this.filter=g.filter,this.autoExpandSingleChildren=typeof g.autoExpandSingleChildren>"u"?!1:g.autoExpandSingleChildren,this.root={parent:void 0,element:h,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(t,s,h=p.Iterable.empty(),g={}){if(t.length===0)throw new S.TreeError(this.user,"Invalid tree location");g.diffIdentityProvider?this.spliceSmart(g.diffIdentityProvider,t,s,h,g):this.spliceSimple(t,s,h,g)}spliceSmart(t,s,h,g=p.Iterable.empty(),c,D=c.diffDepth??0){const{parentNode:u}=this.getParentNodeWithListIndex(s);if(!u.lastDiffIds)return this.spliceSimple(s,h,g,c);const m=[...g],a=s[s.length-1],E=new y.LcsDiff({getElements:()=>u.lastDiffIds},{getElements:()=>[...u.children.slice(0,a),...m,...u.children.slice(a+h)].map(_=>t.getId(_.element).toString())}).ComputeDiff(!1);if(E.quitEarly)return u.lastDiffIds=void 0,this.spliceSimple(s,h,m,c);const k=s.slice(0,-1),N=(_,B,z)=>{if(D>0)for(let T=0;T<z;T++)_--,B--,this.spliceSmart(t,[...k,_,0],Number.MAX_SAFE_INTEGER,m[B].children,c,D-1)};let H=Math.min(u.children.length,a+h),W=m.length;for(const _ of E.changes.sort((B,z)=>z.originalStart-B.originalStart))N(H,W,H-(_.originalStart+_.originalLength)),H=_.originalStart,W=_.modifiedStart-a,this.spliceSimple([...k,H],_.originalLength,p.Iterable.slice(m,W,W+_.modifiedLength),c);N(H,W,H)}spliceSimple(t,s,h=p.Iterable.empty(),{onDidCreateNode:g,onDidDeleteNode:c,diffIdentityProvider:D}){const{parentNode:u,listIndex:m,revealed:a,visible:E}=this.getParentNodeWithListIndex(t),k=[],N=p.Iterable.map(h,Y=>this.createTreeNode(Y,u,u.visible?1:0,a,k,g)),H=t[t.length-1];let W=0;for(let Y=H;Y>=0&&Y<u.children.length;Y--){const Z=u.children[Y];if(Z.visible){W=Z.visibleChildIndex;break}}const _=[];let B=0,z=0;for(const Y of N)_.push(Y),z+=Y.renderNodeCount,Y.visible&&(Y.visibleChildIndex=W+B++);const T=(0,F.splice)(u.children,H,s,_);D?u.lastDiffIds?(0,F.splice)(u.lastDiffIds,H,s,_.map(Y=>D.getId(Y.element).toString())):u.lastDiffIds=u.children.map(Y=>D.getId(Y.element).toString()):u.lastDiffIds=void 0;let P=0;for(const Y of T)Y.visible&&P++;if(P!==0)for(let Y=H+_.length;Y<u.children.length;Y++){const Z=u.children[Y];Z.visible&&(Z.visibleChildIndex-=P)}if(u.visibleChildrenCount+=B-P,a&&E){const Y=T.reduce((Z,fe)=>Z+(fe.visible?fe.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(u,z-Y),this.list.splice(m,Y,k)}if(T.length>0&&c){const Y=Z=>{c(Z),Z.children.forEach(Y)};T.forEach(Y)}this._onDidSplice.fire({insertedNodes:_,deletedNodes:T});let M=u;for(;M;){if(M.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}M=M.parent}}rerender(t){if(t.length===0)throw new S.TreeError(this.user,"Invalid tree location");const{node:s,listIndex:h,revealed:g}=this.getTreeNodeWithListIndex(t);s.visible&&g&&this.list.splice(h,1,[s])}updateElementHeight(t,s){if(t.length===0)throw new S.TreeError(this.user,"Invalid tree location");const{listIndex:h}=this.getTreeNodeWithListIndex(t);this.list.updateElementHeight(h,s)}has(t){return this.hasTreeNode(t)}getListIndex(t){const{listIndex:s,visible:h,revealed:g}=this.getTreeNodeWithListIndex(t);return h&&g?s:-1}getListRenderCount(t){return this.getTreeNode(t).renderNodeCount}isCollapsible(t){return this.getTreeNode(t).collapsible}setCollapsible(t,s){const h=this.getTreeNode(t);typeof s>"u"&&(s=!h.collapsible);const g={collapsible:s};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(t,g))}isCollapsed(t){return this.getTreeNode(t).collapsed}setCollapsed(t,s,h){const g=this.getTreeNode(t);typeof s>"u"&&(s=!g.collapsed);const c={collapsed:s,recursive:h||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(t,c))}_setCollapseState(t,s){const{node:h,listIndex:g,revealed:c}=this.getTreeNodeWithListIndex(t),D=this._setListNodeCollapseState(h,g,c,s);if(h!==this.root&&this.autoExpandSingleChildren&&D&&!O(s)&&h.collapsible&&!h.collapsed&&!s.recursive){let u=-1;for(let m=0;m<h.children.length;m++)if(h.children[m].visible)if(u>-1){u=-1;break}else u=m;u>-1&&this._setCollapseState([...t,u],s)}return D}_setListNodeCollapseState(t,s,h,g){const c=this._setNodeCollapseState(t,g,!1);if(!h||!t.visible||!c)return c;const D=t.renderNodeCount,u=this.updateNodeAfterCollapseChange(t),m=D-(s===-1?0:1);return this.list.splice(s+1,m,u.slice(1)),c}_setNodeCollapseState(t,s,h){let g;if(t===this.root?g=!1:(O(s)?(g=t.collapsible!==s.collapsible,t.collapsible=s.collapsible):t.collapsible?(g=t.collapsed!==s.collapsed,t.collapsed=s.collapsed):g=!1,g&&this._onDidChangeCollapseState.fire({node:t,deep:h})),!O(s)&&s.recursive)for(const c of t.children)g=this._setNodeCollapseState(c,s,!0)||g;return g}expandTo(t){this.eventBufferer.bufferEvents(()=>{let s=this.getTreeNode(t);for(;s.parent;)s=s.parent,t=t.slice(0,t.length-1),s.collapsed&&this._setCollapseState(t,{collapsed:!1,recursive:!1})})}refilter(){const t=this.root.renderNodeCount,s=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,t,s),this.refilterDelayer.cancel()}createTreeNode(t,s,h,g,c,D){const u={parent:s,element:t.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof t.collapsible=="boolean"?t.collapsible:typeof t.collapsed<"u",collapsed:typeof t.collapsed>"u"?this.collapseByDefault:t.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},m=this._filterNode(u,h);u.visibility=m,g&&c.push(u);const a=t.children||p.Iterable.empty(),E=g&&m!==0&&!u.collapsed;let k=0,N=1;for(const H of a){const W=this.createTreeNode(H,u,m,E,c,D);u.children.push(W),N+=W.renderNodeCount,W.visible&&(W.visibleChildIndex=k++)}return u.collapsible=u.collapsible||u.children.length>0,u.visibleChildrenCount=k,u.visible=m===2?k>0:m===1,u.visible?u.collapsed||(u.renderNodeCount=N):(u.renderNodeCount=0,g&&c.pop()),D?.(u),u}updateNodeAfterCollapseChange(t){const s=t.renderNodeCount,h=[];return this._updateNodeAfterCollapseChange(t,h),this._updateAncestorsRenderNodeCount(t.parent,h.length-s),h}_updateNodeAfterCollapseChange(t,s){if(t.visible===!1)return 0;if(s.push(t),t.renderNodeCount=1,!t.collapsed)for(const h of t.children)t.renderNodeCount+=this._updateNodeAfterCollapseChange(h,s);return this._onDidChangeRenderNodeCount.fire(t),t.renderNodeCount}updateNodeAfterFilterChange(t){const s=t.renderNodeCount,h=[];return this._updateNodeAfterFilterChange(t,t.visible?1:0,h),this._updateAncestorsRenderNodeCount(t.parent,h.length-s),h}_updateNodeAfterFilterChange(t,s,h,g=!0){let c;if(t!==this.root){if(c=this._filterNode(t,s),c===0)return t.visible=!1,t.renderNodeCount=0,!1;g&&h.push(t)}const D=h.length;t.renderNodeCount=t===this.root?0:1;let u=!1;if(!t.collapsed||c!==0){let m=0;for(const a of t.children)u=this._updateNodeAfterFilterChange(a,c,h,g&&!t.collapsed)||u,a.visible&&(a.visibleChildIndex=m++);t.visibleChildrenCount=m}else t.visibleChildrenCount=0;return t!==this.root&&(t.visible=c===2?u:c===1,t.visibility=c),t.visible?t.collapsed||(t.renderNodeCount+=h.length-D):(t.renderNodeCount=0,g&&h.pop()),this._onDidChangeRenderNodeCount.fire(t),t.visible}_updateAncestorsRenderNodeCount(t,s){if(s!==0)for(;t;)t.renderNodeCount+=s,this._onDidChangeRenderNodeCount.fire(t),t=t.parent}_filterNode(t,s){const h=this.filter?this.filter.filter(t.element,s):1;return typeof h=="boolean"?(t.filterData=void 0,h?1:0):b(h)?(t.filterData=h.data,v(h.visibility)):(t.filterData=void 0,v(h))}hasTreeNode(t,s=this.root){if(!t||t.length===0)return!0;const[h,...g]=t;return h<0||h>s.children.length?!1:this.hasTreeNode(g,s.children[h])}getTreeNode(t,s=this.root){if(!t||t.length===0)return s;const[h,...g]=t;if(h<0||h>s.children.length)throw new S.TreeError(this.user,"Invalid tree location");return this.getTreeNode(g,s.children[h])}getTreeNodeWithListIndex(t){if(t.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:h,revealed:g,visible:c}=this.getParentNodeWithListIndex(t),D=t[t.length-1];if(D<0||D>s.children.length)throw new S.TreeError(this.user,"Invalid tree location");const u=s.children[D];return{node:u,listIndex:h,revealed:g,visible:c&&u.visible}}getParentNodeWithListIndex(t,s=this.root,h=0,g=!0,c=!0){const[D,...u]=t;if(D<0||D>s.children.length)throw new S.TreeError(this.user,"Invalid tree location");for(let m=0;m<D;m++)h+=s.children[m].renderNodeCount;return g=g&&!s.collapsed,c=c&&s.visible,u.length===0?{parentNode:s,listIndex:h,revealed:g,visible:c}:this.getParentNodeWithListIndex(u,s.children[D],h+1,g,c)}getNode(t=[]){return this.getTreeNode(t)}getNodeLocation(t){const s=[];let h=t;for(;h.parent;)s.push(h.parent.children.indexOf(h)),h=h.parent;return s.reverse()}getParentNodeLocation(t){if(t.length!==0)return t.length===1?[]:(0,F.tail2)(t)[0]}getFirstElementChild(t){const s=this.getTreeNode(t);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(t=[]){const s=this.getTreeNode(t);if(s.children.length!==0)return this._getLastElementAncestor(s)}_getLastElementAncestor(t){return t.children.length===0?t.element:this._getLastElementAncestor(t.children[t.children.length-1])}}e.IndexTreeModel=l}),define(me[125],be([1,0,60,26,28]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ObjectTreeModel=void 0;class U{get size(){return this.nodes.size}constructor(A,p,b={}){this.user=A,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new S.IndexTreeModel(A,p,null,b),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,b.sorter&&(this.sorter={compare(v,O){return b.sorter.compare(v.element,O.element)}}),this.identityProvider=b.identityProvider}setChildren(A,p=n.Iterable.empty(),b={}){const v=this.getElementLocation(A);this._setChildren(v,this.preserveCollapseState(p),b)}_setChildren(A,p=n.Iterable.empty(),b){const v=new Set,O=new Set,l=t=>{if(t.element===null)return;const s=t;if(v.add(s.element),this.nodes.set(s.element,s),this.identityProvider){const h=this.identityProvider.getId(s.element).toString();O.add(h),this.nodesByIdentity.set(h,s)}b.onDidCreateNode?.(s)},d=t=>{if(t.element===null)return;const s=t;if(v.has(s.element)||this.nodes.delete(s.element),this.identityProvider){const h=this.identityProvider.getId(s.element).toString();O.has(h)||this.nodesByIdentity.delete(h)}b.onDidDeleteNode?.(s)};this.model.splice([...A,0],Number.MAX_VALUE,p,{...b,onDidCreateNode:l,onDidDeleteNode:d})}preserveCollapseState(A=n.Iterable.empty()){return this.sorter&&(A=[...A].sort(this.sorter.compare.bind(this.sorter))),n.Iterable.map(A,p=>{let b=this.nodes.get(p.element);if(!b&&this.identityProvider){const l=this.identityProvider.getId(p.element).toString();b=this.nodesByIdentity.get(l)}if(!b){let l;return typeof p.collapsed>"u"?l=void 0:p.collapsed===F.ObjectTreeElementCollapseState.Collapsed||p.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed?l=!0:p.collapsed===F.ObjectTreeElementCollapseState.Expanded||p.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?l=!1:l=!!p.collapsed,{...p,children:this.preserveCollapseState(p.children),collapsed:l}}const v=typeof p.collapsible=="boolean"?p.collapsible:b.collapsible;let O;return typeof p.collapsed>"u"||p.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed||p.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?O=b.collapsed:p.collapsed===F.ObjectTreeElementCollapseState.Collapsed?O=!0:p.collapsed===F.ObjectTreeElementCollapseState.Expanded?O=!1:O=!!p.collapsed,{...p,collapsible:v,collapsed:O,children:this.preserveCollapseState(p.children)}})}rerender(A){const p=this.getElementLocation(A);this.model.rerender(p)}updateElementHeight(A,p){const b=this.getElementLocation(A);this.model.updateElementHeight(b,p)}resort(A=null,p=!0){if(!this.sorter)return;const b=this.getElementLocation(A),v=this.model.getNode(b);this._setChildren(b,this.resortChildren(v,p),{})}resortChildren(A,p,b=!0){let v=[...A.children];return(p||b)&&(v=v.sort(this.sorter.compare.bind(this.sorter))),n.Iterable.map(v,O=>({element:O.element,collapsible:O.collapsible,collapsed:O.collapsed,children:this.resortChildren(O,p,!1)}))}getFirstElementChild(A=null){const p=this.getElementLocation(A);return this.model.getFirstElementChild(p)}getLastElementAncestor(A=null){const p=this.getElementLocation(A);return this.model.getLastElementAncestor(p)}has(A){return this.nodes.has(A)}getListIndex(A){const p=this.getElementLocation(A);return this.model.getListIndex(p)}getListRenderCount(A){const p=this.getElementLocation(A);return this.model.getListRenderCount(p)}isCollapsible(A){const p=this.getElementLocation(A);return this.model.isCollapsible(p)}setCollapsible(A,p){const b=this.getElementLocation(A);return this.model.setCollapsible(b,p)}isCollapsed(A){const p=this.getElementLocation(A);return this.model.isCollapsed(p)}setCollapsed(A,p,b){const v=this.getElementLocation(A);return this.model.setCollapsed(v,p,b)}expandTo(A){const p=this.getElementLocation(A);this.model.expandTo(p)}refilter(){this.model.refilter()}getNode(A=null){if(A===null)return this.model.getNode(this.model.rootRef);const p=this.nodes.get(A);if(!p)throw new F.TreeError(this.user,`Tree element not found: ${A}`);return p}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new F.TreeError(this.user,"Invalid getParentNodeLocation call");const p=this.nodes.get(A);if(!p)throw new F.TreeError(this.user,`Tree element not found: ${A}`);const b=this.model.getNodeLocation(p),v=this.model.getParentNodeLocation(b);return this.model.getNode(v).element}getElementLocation(A){if(A===null)return[];const p=this.nodes.get(A);if(!p)throw new F.TreeError(this.user,`Tree element not found: ${A}`);return this.model.getNodeLocation(p)}}e.ObjectTreeModel=U}),define(me[20],be([1,0,2,14,19,25,3]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Widget=void 0;class A extends y.Disposable{onclick(b,v){this._register(S.addDisposableListener(b,S.EventType.CLICK,O=>v(new n.StandardMouseEvent(S.getWindow(b),O))))}onmousedown(b,v){this._register(S.addDisposableListener(b,S.EventType.MOUSE_DOWN,O=>v(new n.StandardMouseEvent(S.getWindow(b),O))))}onmouseover(b,v){this._register(S.addDisposableListener(b,S.EventType.MOUSE_OVER,O=>v(new n.StandardMouseEvent(S.getWindow(b),O))))}onmouseleave(b,v){this._register(S.addDisposableListener(b,S.EventType.MOUSE_LEAVE,O=>v(new n.StandardMouseEvent(S.getWindow(b),O))))}onkeydown(b,v){this._register(S.addDisposableListener(b,S.EventType.KEY_DOWN,O=>v(new F.StandardKeyboardEvent(O))))}onkeyup(b,v){this._register(S.addDisposableListener(b,S.EventType.KEY_UP,O=>v(new F.StandardKeyboardEvent(O))))}oninput(b,v){this._register(S.addDisposableListener(b,S.EventType.INPUT,v))}onblur(b,v){this._register(S.addDisposableListener(b,S.EventType.BLUR,v))}onfocus(b,v){this._register(S.addDisposableListener(b,S.EventType.FOCUS,v))}onchange(b,v){this._register(S.addDisposableListener(b,S.EventType.CHANGE,v))}ignoreGesture(b){return U.Gesture.ignoreTarget(b)}}e.Widget=A}),define(me[40],be([1,0,58,20,9,18,2]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScrollbarArrow=e.ARROW_IMG_SIZE=void 0,e.ARROW_IMG_SIZE=11;class A extends F.Widget{constructor(b){super(),this._onActivate=b.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=b.bgWidth+"px",this.bgDomNode.style.height=b.bgHeight+"px",typeof b.top<"u"&&(this.bgDomNode.style.top="0px"),typeof b.left<"u"&&(this.bgDomNode.style.left="0px"),typeof b.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof b.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=b.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(b.icon)),this.domNode.style.position="absolute",this.domNode.style.width=e.ARROW_IMG_SIZE+"px",this.domNode.style.height=e.ARROW_IMG_SIZE+"px",typeof b.top<"u"&&(this.domNode.style.top=b.top+"px"),typeof b.left<"u"&&(this.domNode.style.left=b.left+"px"),typeof b.bottom<"u"&&(this.domNode.style.bottom=b.bottom+"px"),typeof b.right<"u"&&(this.domNode.style.right=b.right+"px"),this._pointerMoveMonitor=this._register(new S.GlobalPointerMoveMonitor),this._register(y.addStandardDisposableListener(this.bgDomNode,y.EventType.POINTER_DOWN,v=>this._arrowPointerDown(v))),this._register(y.addStandardDisposableListener(this.domNode,y.EventType.POINTER_DOWN,v=>this._arrowPointerDown(v))),this._pointerdownRepeatTimer=this._register(new y.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new n.TimeoutTimer)}_arrowPointerDown(b){if(!b.target||!(b.target instanceof Element))return;const v=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,y.getWindow(b))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(v,200),this._pointerMoveMonitor.startMonitoring(b.target,b.pointerId,b.buttons,O=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),b.preventDefault()}}e.ScrollbarArrow=A}),define(me[61],be([1,0,2,44,58,40,123,20,5]),function(se,e,S,F,n,U,y,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractScrollbar=void 0;const b=140;class v extends A.Widget{constructor(l){super(),this._lazyRender=l.lazyRender,this._host=l.host,this._scrollable=l.scrollable,this._scrollByPage=l.scrollByPage,this._scrollbarState=l.scrollbarState,this._visibilityController=this._register(new y.ScrollbarVisibilityController(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new n.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,F.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(S.addDisposableListener(this.domNode.domNode,S.EventType.POINTER_DOWN,d=>this._domNodePointerDown(d)))}_createArrow(l){const d=this._register(new U.ScrollbarArrow(l));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}_createSlider(l,d,t,s){this.slider=(0,F.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(d),typeof t=="number"&&this.slider.setWidth(t),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(S.addDisposableListener(this.slider.domNode,S.EventType.POINTER_DOWN,h=>{h.button===0&&(h.preventDefault(),this._sliderPointerDown(h))})),this.onclick(this.slider.domNode,h=>{h.leftButton&&h.stopPropagation()})}_onElementSize(l){return this._scrollbarState.setVisibleSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(l){return this._scrollbarState.setScrollSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(l){return this._scrollbarState.setScrollPosition(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(l){l.target===this.domNode.domNode&&this._onPointerDown(l)}delegatePointerDown(l){const d=this.domNode.domNode.getClientRects()[0].top,t=d+this._scrollbarState.getSliderPosition(),s=d+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),h=this._sliderPointerPosition(l);t<=h&&h<=s?l.button===0&&(l.preventDefault(),this._sliderPointerDown(l)):this._onPointerDown(l)}_onPointerDown(l){let d,t;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")d=l.offsetX,t=l.offsetY;else{const h=S.getDomNodePagePosition(this.domNode.domNode);d=l.pageX-h.left,t=l.pageY-h.top}const s=this._pointerDownRelativePosition(d,t);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(s):this._scrollbarState.getDesiredScrollPositionFromOffset(s)),l.button===0&&(l.preventDefault(),this._sliderPointerDown(l))}_sliderPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const d=this._sliderPointerPosition(l),t=this._sliderOrthogonalPointerPosition(l),s=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,h=>{const g=this._sliderOrthogonalPointerPosition(h),c=Math.abs(g-t);if(p.isWindows&&c>b){this._setDesiredScrollPositionNow(s.getScrollPosition());return}const u=this._sliderPointerPosition(h)-d;this._setDesiredScrollPositionNow(s.getDesiredScrollPositionFromDelta(u))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(l){const d={};this.writeScrollPosition(d,l),this._scrollable.setScrollPositionNow(d)}updateScrollbarSize(l){this._updateScrollbarSize(l),this._scrollbarState.setScrollbarSize(l),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}e.AbstractScrollbar=v}),define(me[126],be([1,0,19,61,40,45,17]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HorizontalScrollbar=void 0;class A extends F.AbstractScrollbar{constructor(b,v,O){const l=b.getScrollDimensions(),d=b.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:O,scrollbarState:new U.ScrollbarState(v.horizontalHasArrows?v.arrowSize:0,v.horizontal===2?0:v.horizontalScrollbarSize,v.vertical===2?0:v.verticalScrollbarSize,l.width,l.scrollWidth,d.scrollLeft),visibility:v.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:v.scrollByPage}),v.horizontalHasArrows){const t=(v.arrowSize-n.ARROW_IMG_SIZE)/2,s=(v.horizontalScrollbarSize-n.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:s,left:t,bottom:void 0,right:void 0,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new S.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:t,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new S.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((v.horizontalScrollbarSize-v.horizontalSliderSize)/2),0,void 0,v.horizontalSliderSize)}_updateSlider(b,v){this.slider.setWidth(b),this.slider.setLeft(v)}_renderDomNode(b,v){this.domNode.setWidth(b),this.domNode.setHeight(v),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this._shouldRender=this._onElementScrollSize(b.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(b.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(b.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(b,v){return b}_sliderPointerPosition(b){return b.pageX}_sliderOrthogonalPointerPosition(b){return b.pageY}_updateScrollbarSize(b){this.slider.setHeight(b)}writeScrollPosition(b,v){b.scrollLeft=v}updateOptions(b){this.updateScrollbarSize(b.horizontal===2?0:b.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this._visibilityController.setVisibility(b.horizontal),this._scrollByPage=b.scrollByPage}}e.HorizontalScrollbar=A}),define(me[127],be([1,0,19,61,40,45,17]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VerticalScrollbar=void 0;class A extends F.AbstractScrollbar{constructor(b,v,O){const l=b.getScrollDimensions(),d=b.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:O,scrollbarState:new U.ScrollbarState(v.verticalHasArrows?v.arrowSize:0,v.vertical===2?0:v.verticalScrollbarSize,0,l.height,l.scrollHeight,d.scrollTop),visibility:v.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:v.scrollByPage}),v.verticalHasArrows){const t=(v.arrowSize-n.ARROW_IMG_SIZE)/2,s=(v.verticalScrollbarSize-n.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:t,left:s,bottom:void 0,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this._host.onMouseWheel(new S.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:t,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this._host.onMouseWheel(new S.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((v.verticalScrollbarSize-v.verticalSliderSize)/2),v.verticalSliderSize,void 0)}_updateSlider(b,v){this.slider.setHeight(b),this.slider.setTop(v)}_renderDomNode(b,v){this.domNode.setWidth(v),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this._shouldRender=this._onElementScrollSize(b.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(b.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(b.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(b,v){return v}_sliderPointerPosition(b){return b.pageY}_sliderOrthogonalPointerPosition(b){return b.pageX}_updateScrollbarSize(b){this.slider.setWidth(b)}writeScrollPosition(b,v){b.scrollTop=v}updateOptions(b){this.updateScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(b.vertical),this._scrollByPage=b.scrollByPage}}e.VerticalScrollbar=A}),define(me[62],be([1,0,16,2,44,19,126,127,20,9,4,3,5,50,101]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DomScrollableElement=e.SmoothScrollableElement=e.ScrollableElement=e.AbstractScrollableElement=e.MouseWheelClassifier=void 0;const t=500,s=50,h=!0;class g{constructor(N,H,W){this.timestamp=N,this.deltaX=H,this.deltaY=W,this.score=0}}class c{static{this.INSTANCE=new c}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let N=1,H=0,W=1,_=this._rear;do{const B=_===this._front?N:Math.pow(2,-W);if(N-=B,H+=this._memory[_].score*B,_===this._front)break;_=(this._capacity+_-1)%this._capacity,W++}while(!0);return H<=.5}acceptStandardWheelEvent(N){if(S.isChrome){const H=F.getWindow(N.browserEvent),W=(0,S.getZoomFactor)(H);this.accept(Date.now(),N.deltaX*W,N.deltaY*W)}else this.accept(Date.now(),N.deltaX,N.deltaY)}accept(N,H,W){const _=new g(N,H,W);_.score=this._computeScore(_),this._front===-1&&this._rear===-1?(this._memory[0]=_,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=_)}_computeScore(N){if(Math.abs(N.deltaX)>0&&Math.abs(N.deltaY)>0)return 1;let H=.5;const W=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(N.deltaX)||!this._isAlmostInt(N.deltaY))&&(H+=.25),Math.min(Math.max(H,0),1)}_isAlmostInt(N){return Math.abs(Math.round(N)-N)<.01}}e.MouseWheelClassifier=c;class D extends p.Widget{get options(){return this._options}constructor(N,H,W){super(),this._onScroll=this._register(new v.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new v.Emitter),this.onWillScroll=this._onWillScroll.event,N.style.overflow="hidden",this._options=E(H),this._scrollable=W,this._register(this._scrollable.onScroll(B=>{this._onWillScroll.fire(B),this._onDidScroll(B),this._onScroll.fire(B)}));const _={onMouseWheel:B=>this._onMouseWheel(B),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new A.VerticalScrollbar(this._scrollable,this._options,_)),this._horizontalScrollbar=this._register(new y.HorizontalScrollbar(this._scrollable,this._options,_)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(N),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,n.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,n.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,n.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,B=>this._onMouseOver(B)),this.onmouseleave(this._listenOnDomNode,B=>this._onMouseLeave(B)),this._hideTimeout=this._register(new b.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,O.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(N){this._verticalScrollbar.delegatePointerDown(N)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(N){this._scrollable.setScrollDimensions(N,!1)}updateClassName(N){this._options.className=N,l.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(N){typeof N.handleMouseWheel<"u"&&(this._options.handleMouseWheel=N.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof N.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=N.mouseWheelScrollSensitivity),typeof N.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=N.fastScrollSensitivity),typeof N.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=N.scrollPredominantAxis),typeof N.horizontal<"u"&&(this._options.horizontal=N.horizontal),typeof N.vertical<"u"&&(this._options.vertical=N.vertical),typeof N.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=N.horizontalScrollbarSize),typeof N.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=N.verticalScrollbarSize),typeof N.scrollByPage<"u"&&(this._options.scrollByPage=N.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(N){this._revealOnScroll=N}delegateScrollFromMouseWheelEvent(N){this._onMouseWheel(new U.StandardWheelEvent(N))}_setListeningToMouseWheel(N){if(this._mouseWheelToDispose.length>0!==N&&(this._mouseWheelToDispose=(0,O.dispose)(this._mouseWheelToDispose),N)){const W=_=>{this._onMouseWheel(new U.StandardWheelEvent(_))};this._mouseWheelToDispose.push(F.addDisposableListener(this._listenOnDomNode,F.EventType.MOUSE_WHEEL,W,{passive:!1}))}}_onMouseWheel(N){if(N.browserEvent?.defaultPrevented)return;const H=c.INSTANCE;h&&H.acceptStandardWheelEvent(N);let W=!1;if(N.deltaY||N.deltaX){let B=N.deltaY*this._options.mouseWheelScrollSensitivity,z=N.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&z+B===0?z=B=0:Math.abs(B)>=Math.abs(z)?z=0:B=0),this._options.flipAxes&&([B,z]=[z,B]);const T=!l.isMacintosh&&N.browserEvent&&N.browserEvent.shiftKey;(this._options.scrollYToX||T)&&!z&&(z=B,B=0),N.browserEvent&&N.browserEvent.altKey&&(z=z*this._options.fastScrollSensitivity,B=B*this._options.fastScrollSensitivity);const P=this._scrollable.getFutureScrollPosition();let M={};if(B){const Y=s*B,Z=P.scrollTop-(Y<0?Math.floor(Y):Math.ceil(Y));this._verticalScrollbar.writeScrollPosition(M,Z)}if(z){const Y=s*z,Z=P.scrollLeft-(Y<0?Math.floor(Y):Math.ceil(Y));this._horizontalScrollbar.writeScrollPosition(M,Z)}M=this._scrollable.validateScrollPosition(M),(P.scrollLeft!==M.scrollLeft||P.scrollTop!==M.scrollTop)&&(h&&this._options.mouseWheelSmoothScroll&&H.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(M):this._scrollable.setScrollPositionNow(M),W=!0)}let _=W;!_&&this._options.alwaysConsumeMouseWheel&&(_=!0),!_&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(_=!0),_&&(N.preventDefault(),N.stopPropagation())}_onDidScroll(N){this._shouldRender=this._horizontalScrollbar.onDidScroll(N)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(N)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const N=this._scrollable.getCurrentScrollPosition(),H=N.scrollTop>0,W=N.scrollLeft>0,_=W?" left":"",B=H?" top":"",z=W||H?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${_}`),this._topShadowDomNode.setClassName(`shadow${B}`),this._topLeftShadowDomNode.setClassName(`shadow${z}${B}${_}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(N){this._mouseIsOver=!1,this._hide()}_onMouseOver(N){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),t)}}e.AbstractScrollableElement=D;class u extends D{constructor(N,H){H=H||{},H.mouseWheelSmoothScroll=!1;const W=new d.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:_=>F.scheduleAtNextAnimationFrame(F.getWindow(N),_)});super(N,H,W),this._register(W)}setScrollPosition(N){this._scrollable.setScrollPositionNow(N)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}e.ScrollableElement=u;class m extends D{constructor(N,H,W){super(N,H,W)}setScrollPosition(N){N.reuseAnimation?this._scrollable.setScrollPositionSmooth(N,N.reuseAnimation):this._scrollable.setScrollPositionNow(N)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}e.SmoothScrollableElement=m;class a extends D{constructor(N,H){H=H||{},H.mouseWheelSmoothScroll=!1;const W=new d.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:_=>F.scheduleAtNextAnimationFrame(F.getWindow(N),_)});super(N,H,W),this._register(W),this._element=N,this._register(this.onScroll(_=>{_.scrollTopChanged&&(this._element.scrollTop=_.scrollTop),_.scrollLeftChanged&&(this._element.scrollLeft=_.scrollLeft)})),this.scanDomNode()}setScrollPosition(N){this._scrollable.setScrollPositionNow(N)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}e.DomScrollableElement=a;function E(k){const N={lazyRender:typeof k.lazyRender<"u"?k.lazyRender:!1,className:typeof k.className<"u"?k.className:"",useShadows:typeof k.useShadows<"u"?k.useShadows:!0,handleMouseWheel:typeof k.handleMouseWheel<"u"?k.handleMouseWheel:!0,flipAxes:typeof k.flipAxes<"u"?k.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof k.consumeMouseWheelIfScrollbarIsNeeded<"u"?k.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof k.alwaysConsumeMouseWheel<"u"?k.alwaysConsumeMouseWheel:!1,scrollYToX:typeof k.scrollYToX<"u"?k.scrollYToX:!1,mouseWheelScrollSensitivity:typeof k.mouseWheelScrollSensitivity<"u"?k.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof k.fastScrollSensitivity<"u"?k.fastScrollSensitivity:5,scrollPredominantAxis:typeof k.scrollPredominantAxis<"u"?k.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof k.mouseWheelSmoothScroll<"u"?k.mouseWheelSmoothScroll:!0,arrowSize:typeof k.arrowSize<"u"?k.arrowSize:11,listenOnDomNode:typeof k.listenOnDomNode<"u"?k.listenOnDomNode:null,horizontal:typeof k.horizontal<"u"?k.horizontal:1,horizontalScrollbarSize:typeof k.horizontalScrollbarSize<"u"?k.horizontalScrollbarSize:10,horizontalSliderSize:typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:0,horizontalHasArrows:typeof k.horizontalHasArrows<"u"?k.horizontalHasArrows:!1,vertical:typeof k.vertical<"u"?k.vertical:1,verticalScrollbarSize:typeof k.verticalScrollbarSize<"u"?k.verticalScrollbarSize:10,verticalHasArrows:typeof k.verticalHasArrows<"u"?k.verticalHasArrows:!1,verticalSliderSize:typeof k.verticalSliderSize<"u"?k.verticalSliderSize:0,scrollByPage:typeof k.scrollByPage<"u"?k.scrollByPage:!1};return N.horizontalSliderSize=typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:N.horizontalScrollbarSize,N.verticalSliderSize=typeof k.verticalSliderSize<"u"?k.verticalSliderSize:N.verticalScrollbarSize,l.isMacintosh&&(N.className+=" mac"),N}}),define(me[63],be([1,0,56,2,23,25,62,12,9,27,4,3,49,50,85,122,6,34]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t,s,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ListView=e.NativeDragAndDropData=e.ExternalElementsDragAndDropData=e.ElementsDragAndDropData=e.ListViewTargetSector=void 0;const c={CurrentDragAndDropData:void 0};var D;(function(W){W[W.TOP=0]="TOP",W[W.CENTER_TOP=1]="CENTER_TOP",W[W.CENTER_BOTTOM=2]="CENTER_BOTTOM",W[W.BOTTOM=3]="BOTTOM"})(D||(e.ListViewTargetSector=D={}));const u={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(W){return[W]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class m{get context(){return this._context}set context(_){this._context=_}constructor(_){this.elements=_}update(){}getData(){return this.elements}}e.ElementsDragAndDropData=m;class a{constructor(_){this.elements=_}update(){}getData(){return this.elements}}e.ExternalElementsDragAndDropData=a;class E{constructor(){this.types=[],this.files=[]}update(_){if(_.types&&this.types.splice(0,this.types.length,..._.types),_.files){this.files.splice(0,this.files.length);for(let B=0;B<_.files.length;B++){const z=_.files.item(B);z&&(z.size||z.type)&&this.files.push(z)}}}getData(){return{types:this.types,files:this.files}}}e.NativeDragAndDropData=E;function k(W,_){return Array.isArray(W)&&Array.isArray(_)?(0,A.equals)(W,_):W===_}class N{constructor(_){_?.getSetSize?this.getSetSize=_.getSetSize.bind(_):this.getSetSize=(B,z,T)=>T,_?.getPosInSet?this.getPosInSet=_.getPosInSet.bind(_):this.getPosInSet=(B,z)=>z+1,_?.getRole?this.getRole=_.getRole.bind(_):this.getRole=B=>"listitem",_?.isChecked?this.isChecked=_.isChecked.bind(_):this.isChecked=B=>{}}}class H{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(_){if(_!==this._horizontalScrolling){if(_&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=_,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const B of this.items)this.measureItemWidth(B);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,F.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(_,B,z,T=u){if(this.virtualDelegate=B,this.domId=`list_id_${++H.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new p.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=O.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=O.Disposable.None,this.onDragLeaveTimeout=O.Disposable.None,this.disposables=new O.DisposableStore,this._onDidChangeContentHeight=new v.Emitter,this._onDidChangeContentWidth=new v.Emitter,this.onDidChangeContentHeight=v.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=v.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,T.horizontalScrolling&&T.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(T.paddingTop??0);for(const M of z)this.renderers.set(M.templateId,M);this.cache=this.disposables.add(new s.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof T.mouseSupport=="boolean"?T.mouseSupport:!0),this._horizontalScrolling=T.horizontalScrolling??u.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof T.paddingBottom>"u"?0:T.paddingBottom,this.accessibilityProvider=new N(T.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(T.transformOptimization??u.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(U.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new d.Scrollable({forceIntegerValues:!0,smoothScrollDuration:T.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,F.scheduleAtNextAnimationFrame)((0,F.getWindow)(this.domNode),M)})),this.scrollableElement=this.disposables.add(new y.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:T.alwaysConsumeMouseWheel??u.alwaysConsumeMouseWheel,horizontal:1,vertical:T.verticalScrollMode??u.verticalScrollMode,useShadows:T.useShadows??u.useShadows,mouseWheelScrollSensitivity:T.mouseWheelScrollSensitivity,fastScrollSensitivity:T.fastScrollSensitivity,scrollByPage:T.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),_.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,F.addDisposableListener)(this.rowsContainer,U.EventType.Change,M=>this.onTouchChange(M))),this.disposables.add((0,F.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.disposables.add((0,F.addDisposableListener)(this.domNode,"dragover",M=>this.onDragOver(this.toDragEvent(M)))),this.disposables.add((0,F.addDisposableListener)(this.domNode,"drop",M=>this.onDrop(this.toDragEvent(M)))),this.disposables.add((0,F.addDisposableListener)(this.domNode,"dragleave",M=>this.onDragLeave(this.toDragEvent(M)))),this.disposables.add((0,F.addDisposableListener)(this.domNode,"dragend",M=>this.onDragEnd(M))),this.setRowLineHeight=T.setRowLineHeight??u.setRowLineHeight,this.setRowHeight=T.setRowHeight??u.setRowHeight,this.supportDynamicHeights=T.supportDynamicHeights??u.supportDynamicHeights,this.dnd=T.dnd??this.disposables.add(u.dnd),this.layout(T.initialSize?.height,T.initialSize?.width)}updateOptions(_){_.paddingBottom!==void 0&&(this.paddingBottom=_.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),_.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(_.smoothScrolling?125:0),_.horizontalScrolling!==void 0&&(this.horizontalScrolling=_.horizontalScrolling);let B;if(_.scrollByPage!==void 0&&(B={...B??{},scrollByPage:_.scrollByPage}),_.mouseWheelScrollSensitivity!==void 0&&(B={...B??{},mouseWheelScrollSensitivity:_.mouseWheelScrollSensitivity}),_.fastScrollSensitivity!==void 0&&(B={...B??{},fastScrollSensitivity:_.fastScrollSensitivity}),B&&this.scrollableElement.updateOptions(B),_.paddingTop!==void 0&&_.paddingTop!==this.rangeMap.paddingTop){const z=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),T=_.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=_.paddingTop,this.render(z,Math.max(0,this.lastRenderTop+T),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(_){this.scrollableElement.delegateScrollFromMouseWheelEvent(_)}delegateVerticalScrollbarPointerDown(_){this.scrollableElement.delegateVerticalScrollbarPointerDown(_)}updateElementHeight(_,B,z){if(_<0||_>=this.items.length)return;const T=this.items[_].size;if(typeof B>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[_].lastDynamicHeightWidth=void 0,B=T+this.probeDynamicHeight(_)}if(T===B)return;const P=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let M=0;_<P.start||z!==null&&z>_&&z<P.end?M=B-T:M=0,this.rangeMap.splice(_,1,[{size:B}]),this.items[_].size=B,this.render(P,Math.max(0,this.lastRenderTop+M),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(_){return new t.RangeMap(_)}splice(_,B,z=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(_,B,z)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(_,B,z=[]){const T=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),P={start:_,end:_+B},M=l.Range.intersect(T,P),Y=new Map;for(let j=M.end-1;j>=M.start;j--){const ie=this.items[j];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let de=Y.get(ie.templateId);de||(de=[],Y.set(ie.templateId,de));const Ee=this.renderers.get(ie.templateId);Ee&&Ee.disposeElement&&Ee.disposeElement(ie.element,j,ie.row.templateData,ie.size),de.push(ie.row)}ie.row=null,ie.stale=!0}const Z={start:_+B,end:this.items.length},fe=l.Range.intersect(Z,T),ce=l.Range.relativeComplement(Z,T),te=z.map(j=>({id:String(this.itemId++),element:j,templateId:this.virtualDelegate.getTemplateId(j),size:this.virtualDelegate.getHeight(j),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(j),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:O.Disposable.None,checkedDisposable:O.Disposable.None,stale:!1}));let ge;_===0&&B>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,te),ge=this.items,this.items=te):(this.rangeMap.splice(_,B,te),ge=this.items.splice(_,B,...te));const ke=z.length-B,Le=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),Be=(0,t.shift)(fe,ke),le=l.Range.intersect(Le,Be);for(let j=le.start;j<le.end;j++)this.updateItemInDOM(this.items[j],j);const J=l.Range.relativeComplement(Be,Le);for(const j of J)for(let ie=j.start;ie<j.end;ie++)this.removeItemFromDOM(ie);const ae=ce.map(j=>(0,t.shift)(j,ke)),X=[{start:_,end:_+z.length},...ae].map(j=>l.Range.intersect(Le,j)).reverse();for(const j of X)for(let ie=j.end-1;ie>=j.start;ie--){const de=this.items[ie],Ie=Y.get(de.templateId)?.pop();this.insertItemInDOM(ie,Ie)}for(const j of Y.values())for(const ie of j)this.cache.release(ie);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ge.map(j=>j.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,F.scheduleAtNextAnimationFrame)((0,F.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let _=0;for(const B of this.items)typeof B.width<"u"&&(_=Math.max(_,B.width));this.scrollWidth=_,this.scrollableElement.setScrollDimensions({scrollWidth:_===0?0:_+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(_){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const B=this.items[_];this.measureItemWidth(B),typeof B.width<"u"&&B.width>this.scrollWidth&&(this.scrollWidth=B.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const _ of this.items)_.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const _=this.firstVisibleIndex,B=this.rangeMap.positionAt(_),z=this.rangeMap.positionAt(_+1);return z!==-1&&(z-B)/2+B<this.scrollTop?_+1:_}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(_){return this.items[_].element}indexOf(_){return this.items.findIndex(B=>B.element===_)}domElement(_){const B=this.items[_].row;return B&&B.domNode}elementHeight(_){return this.items[_].size}elementTop(_){return this.rangeMap.positionAt(_)}indexAt(_){return this.rangeMap.indexAt(_)}indexAfter(_){return this.rangeMap.indexAfter(_)}layout(_,B){const z={height:typeof _=="number"?_:(0,F.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,z.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(z),typeof B<"u"&&(this.renderWidth=B,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof B=="number"?B:(0,F.getContentWidth)(this.domNode)})}render(_,B,z,T,P,M=!1){const Y=this.getRenderRange(B,z),Z=l.Range.relativeComplement(Y,_).reverse(),fe=l.Range.relativeComplement(_,Y);if(M){const ce=l.Range.intersect(_,Y);for(let te=ce.start;te<ce.end;te++)this.updateItemInDOM(this.items[te],te)}this.cache.transact(()=>{for(const ce of fe)for(let te=ce.start;te<ce.end;te++)this.removeItemFromDOM(te);for(const ce of Z)for(let te=ce.end-1;te>=ce.start;te--)this.insertItemInDOM(te)}),T!==void 0&&(this.rowsContainer.style.left=`-${T}px`),this.rowsContainer.style.top=`-${B}px`,this.horizontalScrolling&&P!==void 0&&(this.rowsContainer.style.width=`${Math.max(P,this.renderWidth)}px`),this.lastRenderTop=B,this.lastRenderHeight=z}insertItemInDOM(_,B){const z=this.items[_];if(!z.row)if(B)z.row=B,z.stale=!0;else{const Z=this.cache.alloc(z.templateId);z.row=Z.row,z.stale||=Z.isReusingConnectedDomNode}const T=this.accessibilityProvider.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",T);const P=this.accessibilityProvider.isChecked(z.element);if(typeof P=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const Z=fe=>z.row.domNode.setAttribute("aria-checked",String(!!fe));Z(P.value),z.checkedDisposable=P.onDidChange(Z)}if(z.stale||!z.row.domNode.parentElement){const Z=this.items.at(_+1)?.row?.domNode??null;this.rowsContainer.insertBefore(z.row.domNode,Z),z.stale=!1}this.updateItemInDOM(z,_);const M=this.renderers.get(z.templateId);if(!M)throw new Error(`No renderer found for template id ${z.templateId}`);M?.renderElement(z.element,_,z.row.templateData,z.size);const Y=this.dnd.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!Y,Y&&(z.dragStartDisposable=(0,F.addDisposableListener)(z.row.domNode,"dragstart",Z=>this.onDragStart(z.element,Y,Z))),this.horizontalScrolling&&(this.measureItemWidth(z),this.eventuallyUpdateScrollWidth())}measureItemWidth(_){if(!_.row||!_.row.domNode)return;_.row.domNode.style.width="fit-content",_.width=(0,F.getContentWidth)(_.row.domNode);const B=(0,F.getWindow)(_.row.domNode).getComputedStyle(_.row.domNode);B.paddingLeft&&(_.width+=parseFloat(B.paddingLeft)),B.paddingRight&&(_.width+=parseFloat(B.paddingRight)),_.row.domNode.style.width=""}updateItemInDOM(_,B){_.row.domNode.style.top=`${this.elementTop(B)}px`,this.setRowHeight&&(_.row.domNode.style.height=`${_.size}px`),this.setRowLineHeight&&(_.row.domNode.style.lineHeight=`${_.size}px`),_.row.domNode.setAttribute("data-index",`${B}`),_.row.domNode.setAttribute("data-last-element",B===this.length-1?"true":"false"),_.row.domNode.setAttribute("data-parity",B%2===0?"even":"odd"),_.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(_.element,B,this.length))),_.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(_.element,B))),_.row.domNode.setAttribute("id",this.getElementDomId(B)),_.row.domNode.classList.toggle("drop-target",_.dropTarget)}removeItemFromDOM(_){const B=this.items[_];if(B.dragStartDisposable.dispose(),B.checkedDisposable.dispose(),B.row){const z=this.renderers.get(B.templateId);z&&z.disposeElement&&z.disposeElement(B.element,_,B.row.templateData,B.size),this.cache.release(B.row),B.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(_,B){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:_,reuseAnimation:B})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(_){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:_})}get scrollTop(){return this.getScrollTop()}set scrollTop(_){this.setScrollTop(_)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"click")).event,_=>this.toMouseEvent(_),this.disposables)}get onMouseDblClick(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"dblclick")).event,_=>this.toMouseEvent(_),this.disposables)}get onMouseMiddleClick(){return v.Event.filter(v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"auxclick")).event,_=>this.toMouseEvent(_),this.disposables),_=>_.browserEvent.button===1,this.disposables)}get onMouseUp(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"mouseup")).event,_=>this.toMouseEvent(_),this.disposables)}get onMouseDown(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"mousedown")).event,_=>this.toMouseEvent(_),this.disposables)}get onMouseOver(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"mouseover")).event,_=>this.toMouseEvent(_),this.disposables)}get onMouseMove(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"mousemove")).event,_=>this.toMouseEvent(_),this.disposables)}get onMouseOut(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"mouseout")).event,_=>this.toMouseEvent(_),this.disposables)}get onContextMenu(){return v.Event.any(v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"contextmenu")).event,_=>this.toMouseEvent(_),this.disposables),v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,U.EventType.Contextmenu)).event,_=>this.toGestureEvent(_),this.disposables))}get onTouchStart(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.domNode,"touchstart")).event,_=>this.toTouchEvent(_),this.disposables)}get onTap(){return v.Event.map(this.disposables.add(new n.DomEmitter(this.rowsContainer,U.EventType.Tap)).event,_=>this.toGestureEvent(_),this.disposables)}toMouseEvent(_){const B=this.getItemIndexFromEventTarget(_.target||null),z=typeof B>"u"?void 0:this.items[B],T=z&&z.element;return{browserEvent:_,index:B,element:T}}toTouchEvent(_){const B=this.getItemIndexFromEventTarget(_.target||null),z=typeof B>"u"?void 0:this.items[B],T=z&&z.element;return{browserEvent:_,index:B,element:T}}toGestureEvent(_){const B=this.getItemIndexFromEventTarget(_.initialTarget||null),z=typeof B>"u"?void 0:this.items[B],T=z&&z.element;return{browserEvent:_,index:B,element:T}}toDragEvent(_){const B=this.getItemIndexFromEventTarget(_.target||null),z=typeof B>"u"?void 0:this.items[B],T=z&&z.element,P=this.getTargetSector(_,B);return{browserEvent:_,index:B,element:T,sector:P}}onScroll(_){try{const B=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(B,_.scrollTop,_.height,_.scrollLeft,_.scrollWidth),this.supportDynamicHeights&&this._rerender(_.scrollTop,_.height,_.inSmoothScrolling)}catch(B){throw console.error("Got bad scroll event:",_),B}}onTouchChange(_){_.preventDefault(),_.stopPropagation(),this.scrollTop-=_.translationY}onDragStart(_,B,z){if(!z.dataTransfer)return;const T=this.dnd.getDragElements(_);if(z.dataTransfer.effectAllowed="copyMove",z.dataTransfer.setData(S.DataTransfers.TEXT,B),z.dataTransfer.setDragImage){let P;this.dnd.getDragLabel&&(P=this.dnd.getDragLabel(T,z)),typeof P>"u"&&(P=String(T.length));const M=(0,F.$)(".monaco-drag-image");M.textContent=P;const Z=(fe=>{for(;fe&&!fe.classList.contains("monaco-workbench");)fe=fe.parentElement;return fe||this.domNode.ownerDocument})(this.domNode);Z.appendChild(M),z.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>Z.removeChild(M),0)}this.domNode.classList.add("dragging"),this.currentDragData=new m(T),c.CurrentDragAndDropData=new a(T),this.dnd.onDragStart?.(this.currentDragData,z)}onDragOver(_){if(_.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),c.CurrentDragAndDropData&&c.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(_.browserEvent),!_.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(c.CurrentDragAndDropData)this.currentDragData=c.CurrentDragAndDropData;else{if(!_.browserEvent.dataTransfer.types)return!1;this.currentDragData=new E}const B=this.dnd.onDragOver(this.currentDragData,_.element,_.index,_.sector,_.browserEvent);if(this.canDrop=typeof B=="boolean"?B:B.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;_.browserEvent.dataTransfer.dropEffect=typeof B!="boolean"&&B.effect?.type===0?"copy":"move";let z;typeof B!="boolean"&&B.feedback?z=B.feedback:typeof _.index>"u"?z=[-1]:z=[_.index],z=(0,A.distinct)(z).filter(P=>P>=-1&&P<this.length).sort((P,M)=>P-M),z=z[0]===-1?[-1]:z;let T=typeof B!="boolean"&&B.effect&&B.effect.position?B.effect.position:"drop-target";if(k(this.currentDragFeedback,z)&&this.currentDragFeedbackPosition===T)return!0;if(this.currentDragFeedback=z,this.currentDragFeedbackPosition=T,this.currentDragFeedbackDisposable.dispose(),z[0]===-1)this.domNode.classList.add(T),this.rowsContainer.classList.add(T),this.currentDragFeedbackDisposable=(0,O.toDisposable)(()=>{this.domNode.classList.remove(T),this.rowsContainer.classList.remove(T)});else{if(z.length>1&&T!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");T==="drop-target-after"&&z[0]<this.length-1&&(z[0]+=1,T="drop-target-before");for(const P of z){const M=this.items[P];M.dropTarget=!0,M.row?.domNode.classList.add(T)}this.currentDragFeedbackDisposable=(0,O.toDisposable)(()=>{for(const P of z){const M=this.items[P];M.dropTarget=!1,M.row?.domNode.classList.remove(T)}})}return!0}onDragLeave(_){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,p.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,_.element,_.index,_.browserEvent)}onDrop(_){if(!this.canDrop)return;const B=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,c.CurrentDragAndDropData=void 0,!(!B||!_.browserEvent.dataTransfer)&&(_.browserEvent.preventDefault(),B.update(_.browserEvent.dataTransfer),this.dnd.drop(B,_.element,_.index,_.sector,_.browserEvent))}onDragEnd(_){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,c.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(_)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=O.Disposable.None}setupDragAndDropScrollTopAnimation(_){if(!this.dragOverAnimationDisposable){const B=(0,F.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,F.animate)((0,F.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,B))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,p.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=_.pageY}animateDragAndDropScrollTop(_){if(this.dragOverMouseY===void 0)return;const B=this.dragOverMouseY-_,z=this.renderHeight-35;B<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(B-35))):B>z&&(this.scrollTop+=Math.min(14,Math.floor(.3*(B-z))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(_,B){if(B===void 0)return;const z=_.offsetY/this.items[B].size,T=Math.floor(z/.25);return(0,g.clamp)(T,0,3)}getItemIndexFromEventTarget(_){const B=this.scrollableElement.getDomNode();let z=_;for(;z instanceof HTMLElement&&z!==this.rowsContainer&&B.contains(z);){const T=z.getAttribute("data-index");if(T){const P=Number(T);if(!isNaN(P))return P}z=z.parentElement}}getRenderRange(_,B){return{start:this.rangeMap.indexAt(_),end:this.rangeMap.indexAfter(_+B-1)}}_rerender(_,B,z){const T=this.getRenderRange(_,B);let P,M;_===this.elementTop(T.start)?(P=T.start,M=0):T.end-T.start>1&&(P=T.start+1,M=this.elementTop(P)-_);let Y=0;for(;;){const Z=this.getRenderRange(_,B);let fe=!1;for(let ce=Z.start;ce<Z.end;ce++){const te=this.probeDynamicHeight(ce);te!==0&&this.rangeMap.splice(ce,1,[this.items[ce]]),Y+=te,fe=fe||te!==0}if(!fe){Y!==0&&this.eventuallyUpdateScrollDimensions();const ce=l.Range.relativeComplement(T,Z);for(const ge of ce)for(let ke=ge.start;ke<ge.end;ke++)this.items[ke].row&&this.removeItemFromDOM(ke);const te=l.Range.relativeComplement(Z,T).reverse();for(const ge of te)for(let ke=ge.end-1;ke>=ge.start;ke--)this.insertItemInDOM(ke);for(let ge=Z.start;ge<Z.end;ge++)this.items[ge].row&&this.updateItemInDOM(this.items[ge],ge);if(typeof P=="number"){const ge=this.scrollable.getFutureScrollPosition().scrollTop-_,ke=this.elementTop(P)-M+ge;this.setScrollTop(ke,z)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(_){const B=this.items[_];if(this.virtualDelegate.getDynamicHeight){const M=this.virtualDelegate.getDynamicHeight(B.element);if(M!==null){const Y=B.size;return B.size=M,B.lastDynamicHeightWidth=this.renderWidth,M-Y}}if(!B.hasDynamicHeight||B.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(B.element))return 0;const z=B.size;if(B.row)return B.row.domNode.style.height="",B.size=B.row.domNode.offsetHeight,B.lastDynamicHeightWidth=this.renderWidth,B.size-z;const{row:T}=this.cache.alloc(B.templateId);T.domNode.style.height="",this.rowsContainer.appendChild(T.domNode);const P=this.renderers.get(B.templateId);if(!P)throw new h.BugIndicatingError("Missing renderer for templateId: "+B.templateId);return P.renderElement(B.element,_,T.templateData,void 0),B.size=T.domNode.offsetHeight,P.disposeElement?.(B.element,_,T.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(B.element,B.size),B.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(T.domNode),this.cache.release(T),B.size-z}getElementDomId(_){return`${this.domId}_${_}`}dispose(){for(const _ of this.items)if(_.dragStartDisposable.dispose(),_.checkedDisposable.dispose(),_.row){const B=this.renderers.get(_.row.templateId);B&&(B.disposeElement?.(_.element,-1,_.row.templateData,void 0),B.disposeTemplate(_.row.templateData))}this.items=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}e.ListView=H,Ye([b.memoize],H.prototype,"onMouseClick",null),Ye([b.memoize],H.prototype,"onMouseDblClick",null),Ye([b.memoize],H.prototype,"onMouseMiddleClick",null),Ye([b.memoize],H.prototype,"onMouseUp",null),Ye([b.memoize],H.prototype,"onMouseDown",null),Ye([b.memoize],H.prototype,"onMouseOver",null),Ye([b.memoize],H.prototype,"onMouseMove",null),Ye([b.memoize],H.prototype,"onMouseOut",null),Ye([b.memoize],H.prototype,"onContextMenu",null),Ye([b.memoize],H.prototype,"onTouchStart",null),Ye([b.memoize],H.prototype,"onTap",null)}),define(me[41],be([1,0,2,23,14,25,59,73,12,9,76,27,4,36,3,34,5,7,72,63,19,100]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t,s,h,g,c,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.List=e.unthemedListStyles=e.DefaultStyleController=e.MouseController=e.isSelectionRangeChangeEvent=e.isSelectionSingleChangeEvent=e.DefaultKeyboardNavigationDelegate=e.TypeNavigationMode=e.isButton=e.isStickyScrollContainer=e.isStickyScrollElement=e.isMonacoTwistie=e.isActionItem=e.isMonacoCustomToggle=e.isMonacoEditor=e.isInputElement=void 0;class m{constructor(f){this.trait=f,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(f){return f}renderElement(f,C,I){const r=this.renderedElements.findIndex(i=>i.templateData===I);if(r>=0){const i=this.renderedElements[r];this.trait.unrender(I),i.index=C}else{const i={index:C,templateData:I};this.renderedElements.push(i)}this.trait.renderIndex(C,I)}splice(f,C,I){const r=[];for(const i of this.renderedElements)i.index<f?r.push(i):i.index>=f+C&&r.push({index:i.index+I-C,templateData:i.templateData});this.renderedElements=r}renderIndexes(f){for(const{index:C,templateData:I}of this.renderedElements)f.indexOf(C)>-1&&this.trait.renderIndex(C,I)}disposeTemplate(f){const C=this.renderedElements.findIndex(I=>I.templateData===f);C<0||this.renderedElements.splice(C,1)}}class a{get name(){return this._trait}get renderer(){return new m(this)}constructor(f){this._trait=f,this.indexes=[],this.sortedIndexes=[],this._onChange=new l.Emitter,this.onChange=this._onChange.event}splice(f,C,I){const r=I.length-C,i=f+C,o=[];let w=0;for(;w<this.sortedIndexes.length&&this.sortedIndexes[w]<f;)o.push(this.sortedIndexes[w++]);for(let R=0;R<I.length;R++)I[R]&&o.push(R+f);for(;w<this.sortedIndexes.length&&this.sortedIndexes[w]>=i;)o.push(this.sortedIndexes[w++]+r);this.renderer.splice(f,C,I.length),this._set(o,o)}renderIndex(f,C){C.classList.toggle(this._trait,this.contains(f))}unrender(f){f.classList.remove(this._trait)}set(f,C){return this._set(f,[...f].sort(ie),C)}_set(f,C,I){const r=this.indexes,i=this.sortedIndexes;this.indexes=f,this.sortedIndexes=C;const o=X(i,f);return this.renderer.renderIndexes(o),this._onChange.fire({indexes:f,browserEvent:I}),r}get(){return this.indexes}contains(f){return(0,p.binarySearch)(this.sortedIndexes,f,ie)>=0}dispose(){(0,t.dispose)(this._onChange)}}Ye([O.memoize],a.prototype,"renderer",null);class E extends a{constructor(f){super("selected"),this.setAriaSelected=f}renderIndex(f,C){super.renderIndex(f,C),this.setAriaSelected&&(this.contains(f)?C.setAttribute("aria-selected","true"):C.setAttribute("aria-selected","false"))}}class k{constructor(f,C,I){this.trait=f,this.view=C,this.identityProvider=I}splice(f,C,I){if(!this.identityProvider)return this.trait.splice(f,C,new Array(I.length).fill(!1));const r=this.trait.get().map(w=>this.identityProvider.getId(this.view.element(w)).toString());if(r.length===0)return this.trait.splice(f,C,new Array(I.length).fill(!1));const i=new Set(r),o=I.map(w=>i.has(this.identityProvider.getId(w).toString()));this.trait.splice(f,C,o)}}function N(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}e.isInputElement=N;function H(K,f){return K.classList.contains(f)?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:H(K.parentElement,f)}function W(K){return H(K,"monaco-editor")}e.isMonacoEditor=W;function _(K){return H(K,"monaco-custom-toggle")}e.isMonacoCustomToggle=_;function B(K){return H(K,"action-item")}e.isActionItem=B;function z(K){return H(K,"monaco-tl-twistie")}e.isMonacoTwistie=z;function T(K){return H(K,"monaco-tree-sticky-row")}e.isStickyScrollElement=T;function P(K){return K.classList.contains("monaco-tree-sticky-container")}e.isStickyScrollContainer=P;function M(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:M(K.parentElement)}e.isButton=M;class Y{get onKeyDown(){return l.Event.chain(this.disposables.add(new F.DomEmitter(this.view.domNode,"keydown")).event,f=>f.filter(C=>!N(C.target)).map(C=>new n.StandardKeyboardEvent(C)))}constructor(f,C,I){this.list=f,this.view=C,this.disposables=new t.DisposableStore,this.multipleSelectionDisposables=new t.DisposableStore,this.multipleSelectionSupport=I.multipleSelectionSupport,this.disposables.add(this.onKeyDown(r=>{switch(r.keyCode){case 3:return this.onEnter(r);case 16:return this.onUpArrow(r);case 18:return this.onDownArrow(r);case 11:return this.onPageUpArrow(r);case 12:return this.onPageDownArrow(r);case 9:return this.onEscape(r);case 31:this.multipleSelectionSupport&&(h.isMacintosh?r.metaKey:r.ctrlKey)&&this.onCtrlA(r)}}))}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=f.multipleSelectionSupport)}onEnter(f){f.preventDefault(),f.stopPropagation(),this.list.setSelection(this.list.getFocus(),f.browserEvent)}onUpArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusPrevious(1,!1,f.browserEvent);const C=this.list.getFocus()[0];this.list.setAnchor(C),this.list.reveal(C),this.view.domNode.focus()}onDownArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusNext(1,!1,f.browserEvent);const C=this.list.getFocus()[0];this.list.setAnchor(C),this.list.reveal(C),this.view.domNode.focus()}onPageUpArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusPreviousPage(f.browserEvent);const C=this.list.getFocus()[0];this.list.setAnchor(C),this.list.reveal(C),this.view.domNode.focus()}onPageDownArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusNextPage(f.browserEvent);const C=this.list.getFocus()[0];this.list.setAnchor(C),this.list.reveal(C),this.view.domNode.focus()}onCtrlA(f){f.preventDefault(),f.stopPropagation(),this.list.setSelection((0,p.range)(this.list.length),f.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(f){this.list.getSelection().length&&(f.preventDefault(),f.stopPropagation(),this.list.setSelection([],f.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ye([O.memoize],Y.prototype,"onKeyDown",null);var Z;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(Z||(e.TypeNavigationMode=Z={}));var fe;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(fe||(fe={})),e.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class ce{constructor(f,C,I,r,i){this.list=f,this.view=C,this.keyboardNavigationLabelProvider=I,this.keyboardNavigationEventFilter=r,this.delegate=i,this.enabled=!1,this.state=fe.Idle,this.mode=Z.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new t.DisposableStore,this.disposables=new t.DisposableStore,this.updateOptions(f.options)}updateOptions(f){f.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=f.typeNavigationMode??Z.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let f=!1;const C=l.Event.chain(this.enabledDisposables.add(new F.DomEmitter(this.view.domNode,"keydown")).event,i=>i.filter(o=>!N(o.target)).filter(()=>this.mode===Z.Automatic||this.triggered).map(o=>new n.StandardKeyboardEvent(o)).filter(o=>f||this.keyboardNavigationEventFilter(o)).filter(o=>this.delegate.mightProducePrintableCharacter(o)).forEach(o=>S.EventHelper.stop(o,!0)).map(o=>o.browserEvent.key)),I=l.Event.debounce(C,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);l.Event.reduce(l.Event.any(C,I),(i,o)=>o===null?null:(i||"")+o,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),I(this.onClear,this,this.enabledDisposables),C(()=>f=!0,void 0,this.enabledDisposables),I(()=>f=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const f=this.list.getFocus();if(f.length>0&&f[0]===this.previouslyFocused){const C=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(f[0]));C&&(0,y.alert)(C)}this.previouslyFocused=-1}onInput(f){if(!f){this.state=fe.Idle,this.triggered=!1;return}const C=this.list.getFocus(),I=C.length>0?C[0]:0,r=this.state===fe.Idle?1:0;this.state=fe.Typing;for(let i=0;i<this.list.length;i++){const o=(I+i+r)%this.list.length,w=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(o)),R=w&&w.toString();if(this.list.options.typeNavigationEnabled){if(typeof R<"u"){if((0,d.matchesPrefix)(f,R)){this.previouslyFocused=I,this.list.setFocus([o]),this.list.reveal(o);return}const L=(0,d.matchesFuzzy2)(f,R);if(L&&L[0].end-L[0].start>1&&L.length===1){this.previouslyFocused=I,this.list.setFocus([o]),this.list.reveal(o);return}}}else if(typeof R>"u"||(0,d.matchesPrefix)(f,R)){this.previouslyFocused=I,this.list.setFocus([o]),this.list.reveal(o);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class te{constructor(f,C){this.list=f,this.view=C,this.disposables=new t.DisposableStore;const I=l.Event.chain(this.disposables.add(new F.DomEmitter(C.domNode,"keydown")).event,i=>i.filter(o=>!N(o.target)).map(o=>new n.StandardKeyboardEvent(o)));l.Event.chain(I,i=>i.filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey))(this.onTab,this,this.disposables)}onTab(f){if(f.target!==this.view.domNode)return;const C=this.list.getFocus();if(C.length===0)return;const I=this.view.domElement(C[0]);if(!I)return;const r=I.querySelector("[tabIndex]");if(!r||!(r instanceof HTMLElement)||r.tabIndex===-1)return;const i=(0,S.getWindow)(r).getComputedStyle(r);i.visibility==="hidden"||i.display==="none"||(f.preventDefault(),f.stopPropagation(),r.focus())}dispose(){this.disposables.dispose()}}function ge(K){return h.isMacintosh?K.browserEvent.metaKey:K.browserEvent.ctrlKey}e.isSelectionSingleChangeEvent=ge;function ke(K){return K.browserEvent.shiftKey}e.isSelectionRangeChangeEvent=ke;function Le(K){return(0,S.isMouseEvent)(K)&&K.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:ke};class le{constructor(f){this.list=f,this.disposables=new t.DisposableStore,this._onPointer=new l.Emitter,this.onPointer=this._onPointer.event,f.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||Be),this.mouseSupport=typeof f.options.mouseSupport>"u"||!!f.options.mouseSupport,this.mouseSupport&&(f.onMouseDown(this.onMouseDown,this,this.disposables),f.onContextMenu(this.onContextMenu,this,this.disposables),f.onMouseDblClick(this.onDoubleClick,this,this.disposables),f.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(U.Gesture.addTarget(f.getHTMLElement()))),l.Event.any(f.onMouseClick,f.onMouseMiddleClick,f.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,f.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||Be))}isSelectionSingleChangeEvent(f){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(f):!1}isSelectionRangeChangeEvent(f){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(f):!1}isSelectionChangeEvent(f){return this.isSelectionSingleChangeEvent(f)||this.isSelectionRangeChangeEvent(f)}onMouseDown(f){W(f.browserEvent.target)||(0,S.getActiveElement)()!==f.browserEvent.target&&this.list.domFocus()}onContextMenu(f){if(N(f.browserEvent.target)||W(f.browserEvent.target))return;const C=typeof f.index>"u"?[]:[f.index];this.list.setFocus(C,f.browserEvent)}onViewPointer(f){if(!this.mouseSupport||N(f.browserEvent.target)||W(f.browserEvent.target)||f.browserEvent.isHandledByList)return;f.browserEvent.isHandledByList=!0;const C=f.index;if(typeof C>"u"){this.list.setFocus([],f.browserEvent),this.list.setSelection([],f.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(f))return this.changeSelection(f);this.list.setFocus([C],f.browserEvent),this.list.setAnchor(C),Le(f.browserEvent)||this.list.setSelection([C],f.browserEvent),this._onPointer.fire(f)}onDoubleClick(f){if(N(f.browserEvent.target)||W(f.browserEvent.target)||this.isSelectionChangeEvent(f)||f.browserEvent.isHandledByList)return;f.browserEvent.isHandledByList=!0;const C=this.list.getFocus();this.list.setSelection(C,f.browserEvent)}changeSelection(f){const C=f.index;let I=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(f)){typeof I>"u"&&(I=this.list.getFocus()[0]??C,this.list.setAnchor(I));const r=Math.min(I,C),i=Math.max(I,C),o=(0,p.range)(r,i+1),w=this.list.getSelection(),R=re(X(w,[I]),I);if(R.length===0)return;const L=X(o,j(w,R));this.list.setSelection(L,f.browserEvent),this.list.setFocus([C],f.browserEvent)}else if(this.isSelectionSingleChangeEvent(f)){const r=this.list.getSelection(),i=r.filter(o=>o!==C);this.list.setFocus([C]),this.list.setAnchor(C),r.length===i.length?this.list.setSelection([...i,C],f.browserEvent):this.list.setSelection(i,f.browserEvent)}}dispose(){this.disposables.dispose()}}e.MouseController=le;class J{constructor(f,C){this.styleElement=f,this.selectorSuffix=C}style(f){const C=this.selectorSuffix&&`.${this.selectorSuffix}`,I=[];f.listBackground&&I.push(`.monaco-list${C} .monaco-list-rows { background: ${f.listBackground}; }`),f.listFocusBackground&&(I.push(`.monaco-list${C}:focus .monaco-list-row.focused { background-color: ${f.listFocusBackground}; }`),I.push(`.monaco-list${C}:focus .monaco-list-row.focused:hover { background-color: ${f.listFocusBackground}; }`)),f.listFocusForeground&&I.push(`.monaco-list${C}:focus .monaco-list-row.focused { color: ${f.listFocusForeground}; }`),f.listActiveSelectionBackground&&(I.push(`.monaco-list${C}:focus .monaco-list-row.selected { background-color: ${f.listActiveSelectionBackground}; }`),I.push(`.monaco-list${C}:focus .monaco-list-row.selected:hover { background-color: ${f.listActiveSelectionBackground}; }`)),f.listActiveSelectionForeground&&I.push(`.monaco-list${C}:focus .monaco-list-row.selected { color: ${f.listActiveSelectionForeground}; }`),f.listActiveSelectionIconForeground&&I.push(`.monaco-list${C}:focus .monaco-list-row.selected .codicon { color: ${f.listActiveSelectionIconForeground}; }`),f.listFocusAndSelectionBackground&&I.push(`
				.monaco-drag-image,
				.monaco-list${C}:focus .monaco-list-row.selected.focused { background-color: ${f.listFocusAndSelectionBackground}; }
			`),f.listFocusAndSelectionForeground&&I.push(`
				.monaco-drag-image,
				.monaco-list${C}:focus .monaco-list-row.selected.focused { color: ${f.listFocusAndSelectionForeground}; }
			`),f.listInactiveFocusForeground&&(I.push(`.monaco-list${C} .monaco-list-row.focused { color:  ${f.listInactiveFocusForeground}; }`),I.push(`.monaco-list${C} .monaco-list-row.focused:hover { color:  ${f.listInactiveFocusForeground}; }`)),f.listInactiveSelectionIconForeground&&I.push(`.monaco-list${C} .monaco-list-row.focused .codicon { color:  ${f.listInactiveSelectionIconForeground}; }`),f.listInactiveFocusBackground&&(I.push(`.monaco-list${C} .monaco-list-row.focused { background-color:  ${f.listInactiveFocusBackground}; }`),I.push(`.monaco-list${C} .monaco-list-row.focused:hover { background-color:  ${f.listInactiveFocusBackground}; }`)),f.listInactiveSelectionBackground&&(I.push(`.monaco-list${C} .monaco-list-row.selected { background-color:  ${f.listInactiveSelectionBackground}; }`),I.push(`.monaco-list${C} .monaco-list-row.selected:hover { background-color:  ${f.listInactiveSelectionBackground}; }`)),f.listInactiveSelectionForeground&&I.push(`.monaco-list${C} .monaco-list-row.selected { color: ${f.listInactiveSelectionForeground}; }`),f.listHoverBackground&&I.push(`.monaco-list${C}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${f.listHoverBackground}; }`),f.listHoverForeground&&I.push(`.monaco-list${C}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${f.listHoverForeground}; }`);const r=(0,S.asCssValueWithDefault)(f.listFocusAndSelectionOutline,(0,S.asCssValueWithDefault)(f.listSelectionOutline,f.listFocusOutline??""));r&&I.push(`.monaco-list${C}:focus .monaco-list-row.focused.selected { outline: 1px solid ${r}; outline-offset: -1px;}`),f.listFocusOutline&&I.push(`
				.monaco-drag-image,
				.monaco-list${C}:focus .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${C}.last-focused .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,S.asCssValueWithDefault)(f.listSelectionOutline,f.listInactiveFocusOutline??"");i&&I.push(`.monaco-list${C} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),f.listSelectionOutline&&I.push(`.monaco-list${C} .monaco-list-row.selected { outline: 1px dotted ${f.listSelectionOutline}; outline-offset: -1px; }`),f.listInactiveFocusOutline&&I.push(`.monaco-list${C} .monaco-list-row.focused { outline: 1px dotted ${f.listInactiveFocusOutline}; outline-offset: -1px; }`),f.listHoverOutline&&I.push(`.monaco-list${C} .monaco-list-row:hover { outline: 1px dashed ${f.listHoverOutline}; outline-offset: -1px; }`),f.listDropOverBackground&&I.push(`
				.monaco-list${C}.drop-target,
				.monaco-list${C} .monaco-list-rows.drop-target,
				.monaco-list${C} .monaco-list-row.drop-target { background-color: ${f.listDropOverBackground} !important; color: inherit !important; }
			`),f.listDropBetweenBackground&&(I.push(`
			.monaco-list${C} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${C} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${f.listDropBetweenBackground};
			}`),I.push(`
			.monaco-list${C} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${C} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${f.listDropBetweenBackground};
			}`)),f.tableColumnsBorder&&I.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${f.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),f.tableOddRowsBackgroundColor&&I.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${f.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=I.join(`
`)}}e.DefaultStyleController=J,e.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:v.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:v.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:v.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function re(K,f){const C=K.indexOf(f);if(C===-1)return[];const I=[];let r=C-1;for(;r>=0&&K[r]===f-(C-r);)I.push(K[r--]);for(I.reverse(),r=C;r<K.length&&K[r]===f+(r-C);)I.push(K[r++]);return I}function X(K,f){const C=[];let I=0,r=0;for(;I<K.length||r<f.length;)if(I>=K.length)C.push(f[r++]);else if(r>=f.length)C.push(K[I++]);else if(K[I]===f[r]){C.push(K[I]),I++,r++;continue}else K[I]<f[r]?C.push(K[I++]):C.push(f[r++]);return C}function j(K,f){const C=[];let I=0,r=0;for(;I<K.length||r<f.length;)if(I>=K.length)C.push(f[r++]);else if(r>=f.length)C.push(K[I++]);else if(K[I]===f[r]){I++,r++;continue}else K[I]<f[r]?C.push(K[I++]):r++;return C}const ie=(K,f)=>K-f;class de{constructor(f,C){this._templateId=f,this.renderers=C}get templateId(){return this._templateId}renderTemplate(f){return this.renderers.map(C=>C.renderTemplate(f))}renderElement(f,C,I,r){let i=0;for(const o of this.renderers)o.renderElement(f,C,I[i++],r)}disposeElement(f,C,I,r){let i=0;for(const o of this.renderers)o.disposeElement?.(f,C,I[i],r),i+=1}disposeTemplate(f){let C=0;for(const I of this.renderers)I.disposeTemplate(f[C++])}}class Ee{constructor(f){this.accessibilityProvider=f,this.templateId="a18n"}renderTemplate(f){return f}renderElement(f,C,I){const r=this.accessibilityProvider.getAriaLabel(f);r?I.setAttribute("aria-label",r):I.removeAttribute("aria-label");const i=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(f);typeof i=="number"?I.setAttribute("aria-level",`${i}`):I.removeAttribute("aria-level")}disposeTemplate(f){}}class Ie{constructor(f,C){this.list=f,this.dnd=C}getDragElements(f){const C=this.list.getSelectedElements();return C.indexOf(f)>-1?C:[f]}getDragURI(f){return this.dnd.getDragURI(f)}getDragLabel(f,C){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(f,C)}onDragStart(f,C){this.dnd.onDragStart?.(f,C)}onDragOver(f,C,I,r,i){return this.dnd.onDragOver(f,C,I,r,i)}onDragLeave(f,C,I,r){this.dnd.onDragLeave?.(f,C,I,r)}onDragEnd(f){this.dnd.onDragEnd?.(f)}drop(f,C,I,r,i){this.dnd.drop(f,C,I,r,i)}dispose(){this.dnd.dispose()}}class Ce{get onDidChangeFocus(){return l.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),f=>this.toListEvent(f),this.disposables)}get onDidChangeSelection(){return l.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),f=>this.toListEvent(f),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let f=!1;const C=l.Event.chain(this.disposables.add(new F.DomEmitter(this.view.domNode,"keydown")).event,i=>i.map(o=>new n.StandardKeyboardEvent(o)).filter(o=>f=o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>S.EventHelper.stop(o,!0)).filter(()=>!1)),I=l.Event.chain(this.disposables.add(new F.DomEmitter(this.view.domNode,"keyup")).event,i=>i.forEach(()=>f=!1).map(o=>new n.StandardKeyboardEvent(o)).filter(o=>o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>S.EventHelper.stop(o,!0)).map(({browserEvent:o})=>{const w=this.getFocus(),R=w.length?w[0]:void 0,L=typeof R<"u"?this.view.element(R):void 0,x=typeof R<"u"?this.view.domElement(R):this.view.domNode;return{index:R,element:L,anchor:x,browserEvent:o}})),r=l.Event.chain(this.view.onContextMenu,i=>i.filter(o=>!f).map(({element:o,index:w,browserEvent:R})=>({element:o,index:w,anchor:new u.StandardMouseEvent((0,S.getWindow)(this.view.domNode),R),browserEvent:R})));return l.Event.any(C,I,r)}get onKeyDown(){return this.disposables.add(new F.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new F.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new F.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.disposables.add(new F.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.disposables.add(new F.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(f,C,I,r,i=ae){this.user=f,this._options=i,this.focus=new a("focused"),this.anchor=new a("anchor"),this.eventBufferer=new l.EventBufferer,this._ariaLabel="",this.disposables=new t.DisposableStore,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event;const o=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new E(o!=="listbox");const w=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=i.accessibilityProvider,this.accessibilityProvider&&(w.push(new Ee(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),r=r.map(L=>new de(L.templateId,[...w,L]));const R={...i,dnd:i.dnd&&new Ie(this,i.dnd)};if(this.view=this.createListView(C,I,r,R),this.view.domNode.setAttribute("role",o),i.styleController)this.styleController=i.styleController(this.view.domId);else{const L=(0,S.createStyleSheet)(this.view.domNode);this.styleController=new J(L,this.view.domId)}if(this.spliceable=new A.CombinedSpliceable([new k(this.focus,this.view,i.identityProvider),new k(this.selection,this.view,i.identityProvider),new k(this.anchor,this.view,i.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new te(this,this.view)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.keyboardController=new Y(this,this.view,i),this.disposables.add(this.keyboardController)),i.keyboardNavigationLabelProvider){const L=i.keyboardNavigationDelegate||e.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new ce(this,this.view,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),L),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(i),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(f,C,I,r){return new D.ListView(f,C,I,r)}createMouseController(f){return new le(this)}updateOptions(f={}){this._options={...this._options,...f},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(f),this.keyboardController?.updateOptions(f),this.view.updateOptions(f)}get options(){return this._options}splice(f,C,I=[]){if(f<0||f>this.view.length)throw new c.ListError(this.user,`Invalid start index: ${f}`);if(C<0)throw new c.ListError(this.user,`Invalid delete count: ${C}`);C===0&&I.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(f,C,I))}updateWidth(f){this.view.updateWidth(f)}updateElementHeight(f,C){this.view.updateElementHeight(f,C,null)}rerender(){this.view.rerender()}element(f){return this.view.element(f)}indexOf(f){return this.view.indexOf(f)}indexAt(f){return this.view.indexAt(f)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(f){this.view.setScrollTop(f)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(f){this.view.setScrollLeft(f)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(f){this._ariaLabel=f,this.view.domNode.setAttribute("aria-label",f)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(f,C){this.view.layout(f,C)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(f,C){for(const I of f)if(I<0||I>=this.length)throw new c.ListError(this.user,`Invalid index ${I}`);this.selection.set(f,C)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(f=>this.view.element(f))}setAnchor(f){if(typeof f>"u"){this.anchor.set([]);return}if(f<0||f>=this.length)throw new c.ListError(this.user,`Invalid index ${f}`);this.anchor.set([f])}getAnchor(){return(0,p.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const f=this.getAnchor();return typeof f>"u"?void 0:this.element(f)}setFocus(f,C){for(const I of f)if(I<0||I>=this.length)throw new c.ListError(this.user,`Invalid index ${I}`);this.focus.set(f,C)}focusNext(f=1,C=!1,I,r){if(this.length===0)return;const i=this.focus.get(),o=this.findNextIndex(i.length>0?i[0]+f:0,C,r);o>-1&&this.setFocus([o],I)}focusPrevious(f=1,C=!1,I,r){if(this.length===0)return;const i=this.focus.get(),o=this.findPreviousIndex(i.length>0?i[0]-f:0,C,r);o>-1&&this.setFocus([o],I)}async focusNextPage(f,C){let I=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);I=I===0?0:I-1;const r=this.getFocus()[0];if(r!==I&&(r===void 0||I>r)){const i=this.findPreviousIndex(I,!1,C);i>-1&&r!==i?this.setFocus([i],f):this.setFocus([I],f)}else{const i=this.view.getScrollTop();let o=i+this.view.renderHeight;I>r&&(o-=this.view.elementHeight(I)),this.view.setScrollTop(o),this.view.getScrollTop()!==i&&(this.setFocus([]),await(0,b.timeout)(0),await this.focusNextPage(f,C))}}async focusPreviousPage(f,C,I=()=>0){let r;const i=I(),o=this.view.getScrollTop()+i;o===0?r=this.view.indexAt(o):r=this.view.indexAfter(o-1);const w=this.getFocus()[0];if(w!==r&&(w===void 0||w>=r)){const R=this.findNextIndex(r,!1,C);R>-1&&w!==R?this.setFocus([R],f):this.setFocus([r],f)}else{const R=o;this.view.setScrollTop(o-this.view.renderHeight-i),this.view.getScrollTop()+I()!==R&&(this.setFocus([]),await(0,b.timeout)(0),await this.focusPreviousPage(f,C,I))}}focusLast(f,C){if(this.length===0)return;const I=this.findPreviousIndex(this.length-1,!1,C);I>-1&&this.setFocus([I],f)}focusFirst(f,C){this.focusNth(0,f,C)}focusNth(f,C,I){if(this.length===0)return;const r=this.findNextIndex(f,!1,I);r>-1&&this.setFocus([r],C)}findNextIndex(f,C=!1,I){for(let r=0;r<this.length;r++){if(f>=this.length&&!C)return-1;if(f=f%this.length,!I||I(this.element(f)))return f;f++}return-1}findPreviousIndex(f,C=!1,I){for(let r=0;r<this.length;r++){if(f<0&&!C)return-1;if(f=(this.length+f%this.length)%this.length,!I||I(this.element(f)))return f;f--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(f=>this.view.element(f))}reveal(f,C,I=0){if(f<0||f>=this.length)throw new c.ListError(this.user,`Invalid index ${f}`);const r=this.view.getScrollTop(),i=this.view.elementTop(f),o=this.view.elementHeight(f);if((0,g.isNumber)(C)){const w=o-this.view.renderHeight+I;this.view.setScrollTop(w*(0,s.clamp)(C,0,1)+i-I)}else{const w=i+o,R=r+this.view.renderHeight;i<r+I&&w>=R||(i<r+I||w>=R&&o>=this.view.renderHeight?this.view.setScrollTop(i-I):w>=R&&this.view.setScrollTop(w-this.view.renderHeight))}}getRelativeTop(f,C=0){if(f<0||f>=this.length)throw new c.ListError(this.user,`Invalid index ${f}`);const I=this.view.getScrollTop(),r=this.view.elementTop(f),i=this.view.elementHeight(f);if(r<I+C||r+i>I+this.view.renderHeight)return null;const o=i-this.view.renderHeight+C;return Math.abs((I+C-r)/o)}isDOMFocused(){return(0,S.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(f){return this.view.getElementDomId(f)}getElementTop(f){return this.view.elementTop(f)}style(f){this.styleController.style(f)}toListEvent({indexes:f,browserEvent:C}){return{indexes:f,elements:f.map(I=>this.view.element(I)),browserEvent:C}}_onFocusChange(){const f=this.focus.get();this.view.domNode.classList.toggle("element-focused",f.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const f=this.focus.get();if(f.length>0){let C;this.accessibilityProvider?.getActiveDescendantId&&(C=this.accessibilityProvider.getActiveDescendantId(this.view.element(f[0]))),this.view.domNode.setAttribute("aria-activedescendant",C||this.view.getElementDomId(f[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const f=this.selection.get();this.view.domNode.classList.toggle("selection-none",f.length===0),this.view.domNode.classList.toggle("selection-single",f.length===1),this.view.domNode.classList.toggle("selection-multiple",f.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}e.List=Ce,Ye([O.memoize],Ce.prototype,"onDidChangeFocus",null),Ye([O.memoize],Ce.prototype,"onDidChangeSelection",null),Ye([O.memoize],Ce.prototype,"onContextMenu",null),Ye([O.memoize],Ce.prototype,"onKeyDown",null),Ye([O.memoize],Ce.prototype,"onKeyUp",null),Ye([O.memoize],Ce.prototype,"onKeyPress",null),Ye([O.memoize],Ce.prototype,"onDidFocus",null),Ye([O.memoize],Ce.prototype,"onDidBlur",null)}),define(me[64],be([1,0,6,37,39,10,15]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.appendEscapedMarkdownCodeBlockFence=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class p{constructor(c="",D=!1){if(this.value=c,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof D=="boolean"?(this.isTrusted=D,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=D.isTrusted??void 0,this.supportThemeIcons=D.supportThemeIcons??!1,this.supportHtml=D.supportHtml??!1)}appendText(c,D=0){return this.value+=l(this.supportThemeIcons?(0,F.escapeIcons)(c):c).replace(/([ \t]+)/g,(u,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,D===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,D){return this.value+=`
${d(D,c)}
`,this}appendLink(c,D,u){return this.value+="[",this.value+=this._escape(D,"]"),this.value+="](",this.value+=this._escape(String(c),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(c,D){const u=new RegExp((0,U.escapeRegExpCharacters)(D),"g");return c.replace(u,(m,a)=>c.charAt(a-1)!=="\\"?`\\${m}`:m)}}e.MarkdownString=p;function b(g){return v(g)?!g.value:Array.isArray(g)?g.every(b):!0}e.isEmptyMarkdownString=b;function v(g){return g instanceof p?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=v;function O(g,c){return g===c?!0:!g||!c?!1:g.value===c.value&&g.isTrusted===c.isTrusted&&g.supportThemeIcons===c.supportThemeIcons&&g.supportHtml===c.supportHtml&&(g.baseUri===c.baseUri||!!g.baseUri&&!!c.baseUri&&(0,n.isEqual)(y.URI.from(g.baseUri),y.URI.from(c.baseUri)))}e.markdownStringEqual=O;function l(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=l;function d(g,c){const D=g.match(/^`+/gm)?.reduce((m,a)=>m.length>a.length?m:a).length??0,u=D>=3?D+1:3;return[`${"`".repeat(u)}${c}`,g,`${"`".repeat(u)}`].join(`
`)}e.appendEscapedMarkdownCodeBlockFence=d;function t(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=t;function s(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=s;function h(g){const c=[],D=g.split("|").map(m=>m.trim());g=D[0];const u=D[1];if(u){const m=/height=(\d+)/.exec(u),a=/width=(\d+)/.exec(u),E=m?m[1]:"",k=a?a[1]:"",N=isFinite(parseInt(k)),H=isFinite(parseInt(E));N&&c.push(`width="${k}"`),H&&c.push(`height="${E}"`)}return{href:g,dimensions:c}}e.parseHrefAndDimensions=h}),define(me[128],be([1,0,2,120,23,57,14,19,121,6,4,64,37,79,22,3,81,55,32,53,39,10,15]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t,s,h,g,c,D,u,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fillInIncompleteTokens=e.renderMarkdownAsPlaintext=e.renderStringAsPlaintext=e.allowedMarkdownAttr=e.renderMarkdown=void 0;const E=Object.freeze({image:(j,ie,de)=>{let Ee=[],Ie=[];return j&&({href:j,dimensions:Ee}=(0,O.parseHrefAndDimensions)(j),Ie.push(`src="${(0,O.escapeDoubleQuotes)(j)}"`)),de&&Ie.push(`alt="${(0,O.escapeDoubleQuotes)(de)}"`),ie&&Ie.push(`title="${(0,O.escapeDoubleQuotes)(ie)}"`),Ee.length&&(Ie=Ie.concat(Ee)),"<img "+Ie.join(" ")+">"},paragraph:j=>`<p>${j}</p>`,link:(j,ie,de)=>typeof j!="string"?"":(j===de&&(de=(0,O.removeMarkdownEscapes)(de)),ie=typeof ie=="string"?(0,O.escapeDoubleQuotes)((0,O.removeMarkdownEscapes)(ie)):"",j=(0,O.removeMarkdownEscapes)(j),j=j.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${j}" title="${ie||j}" draggable="false">${de}</a>`)});function k(j,ie={},de={}){const Ee=new s.DisposableStore;let Ie=!1;const Ce=(0,U.createElement)(ie),K=function(L){let x;try{x=(0,g.parse)(decodeURIComponent(L))}catch{}return x?(x=(0,D.cloneAndChange)(x,V=>{if(j.uris&&j.uris[V])return a.URI.revive(j.uris[V])}),encodeURIComponent(JSON.stringify(x))):L},f=function(L,x){const V=j.uris&&j.uris[L];let Q=a.URI.revive(V);return x?L.startsWith(c.Schemas.data+":")?L:(Q||(Q=a.URI.parse(L)),c.FileAccess.uriToBrowserUri(Q).toString(!0)):!Q||a.URI.parse(L).toString()===Q.toString()?L:(Q.query&&(Q=Q.with({query:K(Q.query)})),Q.toString())},C=new h.marked.Renderer;C.image=E.image,C.link=E.link,C.paragraph=E.paragraph;const I=[],r=[];if(ie.codeBlockRendererSync?C.code=(L,x)=>{const V=d.defaultGenerator.nextId(),Q=ie.codeBlockRendererSync(N(x),L);return r.push([V,Q]),`<div class="code" data-code="${V}">${(0,m.escape)(L)}</div>`}:ie.codeBlockRenderer&&(C.code=(L,x)=>{const V=d.defaultGenerator.nextId(),Q=ie.codeBlockRenderer(N(x),L);return I.push(Q.then(oe=>[V,oe])),`<div class="code" data-code="${V}">${(0,m.escape)(L)}</div>`}),ie.actionHandler){const L=function(Q){let oe=Q.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let pe=oe.dataset.href;pe&&(j.baseUri&&(pe=H(a.URI.from(j.baseUri),pe)),ie.actionHandler.callback(pe,Q))}catch(pe){(0,b.onUnexpectedError)(pe)}finally{Q.preventDefault()}},x=ie.actionHandler.disposables.add(new n.DomEmitter(Ce,"click")),V=ie.actionHandler.disposables.add(new n.DomEmitter(Ce,"auxclick"));ie.actionHandler.disposables.add(v.Event.any(x.event,V.event)(Q=>{const oe=new A.StandardMouseEvent(S.getWindow(Ce),Q);!oe.leftButton&&!oe.middleButton||L(oe)})),ie.actionHandler.disposables.add(S.addDisposableListener(Ce,"keydown",Q=>{const oe=new y.StandardKeyboardEvent(Q);!oe.equals(10)&&!oe.equals(3)||L(oe)}))}j.supportHtml||(de.sanitizer=L=>(j.isTrusted?L.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?L:"",de.sanitize=!0,de.silent=!0),de.renderer=C;let i=j.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),j.supportThemeIcons&&(i=(0,l.markdownEscapeEscapedIcons)(i));let o;if(ie.fillInIncompleteTokens){const L={...h.marked.defaults,...de},x=h.marked.lexer(i,L),V=fe(x);o=h.marked.parser(V,L)}else o=h.marked.parse(i,de);j.supportThemeIcons&&(o=(0,p.renderLabelWithIcons)(o).map(x=>typeof x=="string"?x:x.outerHTML).join(""));const R=new DOMParser().parseFromString(W(j,o),"text/html");if(R.body.querySelectorAll("img").forEach(L=>{const x=L.getAttribute("src");if(x){let V=x;try{j.baseUri&&(V=H(a.URI.from(j.baseUri),V))}catch{}L.src=f(V,!0)}}),R.body.querySelectorAll("a").forEach(L=>{const x=L.getAttribute("href");if(L.setAttribute("href",""),!x||/^data:|javascript:/i.test(x)||/^command:/i.test(x)&&!j.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(x))L.replaceWith(...L.childNodes);else{let V=f(x,!1);j.baseUri&&(V=H(a.URI.from(j.baseUri),x)),L.dataset.href=V}}),Ce.innerHTML=W(j,R.body.innerHTML),I.length>0)Promise.all(I).then(L=>{if(Ie)return;const x=new Map(L),V=Ce.querySelectorAll("div[data-code]");for(const Q of V){const oe=x.get(Q.dataset.code??"");oe&&S.reset(Q,oe)}ie.asyncRenderCallback?.()});else if(r.length>0){const L=new Map(r),x=Ce.querySelectorAll("div[data-code]");for(const V of x){const Q=L.get(V.dataset.code??"");Q&&S.reset(V,Q)}}if(ie.asyncRenderCallback)for(const L of Ce.getElementsByTagName("img")){const x=Ee.add(S.addDisposableListener(L,"load",()=>{x.dispose(),ie.asyncRenderCallback()}))}return{element:Ce,dispose:()=>{Ie=!0,Ee.dispose()}}}e.renderMarkdown=k;function N(j){if(!j)return"";const ie=j.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:j}function H(j,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:j.path.endsWith("/")?(0,u.resolvePath)(j,ie).toString():(0,u.resolvePath)((0,u.dirname)(j),ie).toString()}function W(j,ie){const{config:de,allowedSchemes:Ee}=_(j);F.addHook("uponSanitizeAttribute",(Ce,K)=>{if(K.attrName==="style"||K.attrName==="class"){if(Ce.tagName==="SPAN"){if(K.attrName==="style"){K.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(K.attrValue);return}else if(K.attrName==="class"){K.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(K.attrValue);return}}K.keepAttr=!1;return}else if(Ce.tagName==="INPUT"&&Ce.attributes.getNamedItem("type")?.value==="checkbox"){if(K.attrName==="type"&&K.attrValue==="checkbox"||K.attrName==="disabled"||K.attrName==="checked"){K.keepAttr=!0;return}K.keepAttr=!1}}),F.addHook("uponSanitizeElement",(Ce,K)=>{K.tagName==="input"&&(Ce.attributes.getNamedItem("type")?.value==="checkbox"?Ce.setAttribute("disabled",""):Ce.parentElement?.removeChild(Ce))});const Ie=S.hookDomPurifyHrefAndSrcSanitizer(Ee);try{return F.sanitize(ie,{...de,RETURN_TRUSTED_TYPE:!0})}finally{F.removeHook("uponSanitizeAttribute"),Ie.dispose()}}e.allowedMarkdownAttr=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function _(j){const ie=[c.Schemas.http,c.Schemas.https,c.Schemas.mailto,c.Schemas.data,c.Schemas.file,c.Schemas.vscodeFileResource,c.Schemas.vscodeRemote,c.Schemas.vscodeRemoteResource];return j.isTrusted&&ie.push(c.Schemas.command),{config:{ALLOWED_TAGS:[...S.basicMarkupHtmlTags],ALLOWED_ATTR:e.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function B(j){return typeof j=="string"?j:z(j)}e.renderStringAsPlaintext=B;function z(j){let ie=j.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const de=h.marked.parse(ie,{renderer:P.value}).replace(/&(#\d+|[a-zA-Z]+);/g,Ee=>T.get(Ee)??Ee);return W({isTrusted:!1},de).toString()}e.renderMarkdownAsPlaintext=z;const T=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),P=new t.Lazy(()=>{const j=new h.marked.Renderer;return j.code=ie=>ie,j.blockquote=ie=>ie,j.html=ie=>"",j.heading=(ie,de,Ee)=>ie+`
`,j.hr=()=>"",j.list=(ie,de)=>ie,j.listitem=ie=>ie+`
`,j.paragraph=ie=>ie+`
`,j.table=(ie,de)=>ie+de+`
`,j.tablerow=ie=>ie,j.tablecell=(ie,de)=>ie+" ",j.strong=ie=>ie,j.em=ie=>ie,j.codespan=ie=>ie,j.br=()=>`
`,j.del=ie=>ie,j.image=(ie,de,Ee)=>"",j.text=ie=>ie,j.link=(ie,de,Ee)=>Ee,j});function M(j){let ie="";return j.forEach(de=>{ie+=de.raw}),ie}function Y(j){for(let ie=0;ie<j.tokens.length;ie++){const de=j.tokens[ie];if(de.type==="text"){const Ee=de.raw.split(`
`),Ie=Ee[Ee.length-1];if(Ie.includes("`"))return te(j);if(Ie.includes("**"))return J(j);if(Ie.match(/\*\w/))return ge(j);if(Ie.match(/(^|\s)__\w/))return ae(j);if(Ie.match(/(^|\s)_\w/))return ke(j);if(Ie.match(/(^|\s)\[.*\]\(\w*/)){const Ce=j.tokens.slice(ie+1);return Ce[0]?.type==="link"&&Ce[1]?.type==="text"&&Ce[1].raw.match(/^ *"[^"]*$/)?Be(j):Le(j)}else{if(Z(Ie))return Le(j);if(Ie.match(/(^|\s)\[\w/)&&!j.tokens.slice(ie+1).some(Ce=>Z(Ce.raw)))return le(j)}}}}function Z(j){return!!j.match(/^[^\[]*\]\([^\)]*$/)}function fe(j){let ie,de;for(ie=0;ie<j.length;ie++){const Ee=j[ie];let Ie;if(Ee.type==="paragraph"&&(Ie=Ee.raw.match(/(\n|^)(````*)/))){const Ce=Ie[2];de=ce(j.slice(ie),Ce);break}if(Ee.type==="paragraph"&&Ee.raw.match(/(\n|^)\|/)){de=X(j.slice(ie));break}if(ie===j.length-1&&Ee.type==="paragraph"){const Ce=Y(Ee);if(Ce){de=[Ce];break}}}if(de){const Ee=[...j.slice(0,ie),...de];return Ee.links=j.links,Ee}return j}e.fillInIncompleteTokens=fe;function ce(j,ie){const de=M(j);return h.marked.lexer(de+`
${ie}`)}function te(j){return re(j,"`")}function ge(j){return re(j,"*")}function ke(j){return re(j,"_")}function Le(j){return re(j,")")}function Be(j){return re(j,'")')}function le(j){return re(j,"](about:blank)")}function J(j){return re(j,"**")}function ae(j){return re(j,"__")}function re(j,ie){const de=M(Array.isArray(j)?j:[j]);return h.marked.lexer(de+ie)[0]}function X(j){const ie=M(j),de=ie.split(`
`);let Ee,Ie=!1;for(let Ce=0;Ce<de.length;Ce++){const K=de[Ce].trim();if(typeof Ee>"u"&&K.match(/^\s*\|/)){const f=K.match(/(\|[^\|]+)(?=\||$)/g);f&&(Ee=f.length)}else if(typeof Ee=="number")if(K.match(/^\s*\|/)){if(Ce!==de.length-1)return;Ie=!0}else return}if(typeof Ee=="number"&&Ee>0){const Ce=Ie?de.slice(0,-1).join(`
`):ie,K=!!Ce.match(/\|\s*$/),f=Ce+(K?"":"|")+`
|${" --- |".repeat(Ee)}`;return h.marked.lexer(f)}}}),define(me[42],be([1,0,2,9,30,64,37,3,7,110]),function(se,e,S,F,n,U,y,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setupCustomHover=e.setupNativeHover=void 0;function v(d,t){(0,p.isString)(t)?d.title=(0,y.stripIcons)(t):t?.markdownNotSupportedFallback?d.title=t.markdownNotSupportedFallback:d.removeAttribute("title")}e.setupNativeHover=v;class O{constructor(t,s,h){this.hoverDelegate=t,this.target=s,this.fadeInAnimation=h}async update(t,s,h){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let g;if(t===void 0||(0,p.isString)(t)||t instanceof HTMLElement)g=t;else if(!(0,p.isFunction)(t.markdown))g=t.markdown??t.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,b.localize)(0,null),s),this._cancellationTokenSource=new n.CancellationTokenSource;const c=this._cancellationTokenSource.token;if(g=await t.markdown(c),g===void 0&&(g=t.markdownNotSupportedFallback),this.isDisposed||c.isCancellationRequested)return}this.show(g,s,h)}show(t,s,h){const g=this._hoverWidget;if(this.hasContent(t)){const c={content:t,target:this.target,appearance:{showPointer:this.hoverDelegate.placement==="element",skipFadeInAnimation:!this.fadeInAnimation||!!g},position:{hoverPosition:2},...h};this._hoverWidget=this.hoverDelegate.showHover(c,s)}g?.dispose()}hasContent(t){return t?(0,U.isMarkdownString)(t)?!!t.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function l(d,t,s,h){let g,c;const D=(z,T)=>{const P=c!==void 0;z&&(c?.dispose(),c=void 0),T&&(g?.dispose(),g=void 0),P&&(d.onDidHideHover?.(),c=void 0)},u=(z,T,P)=>new F.TimeoutTimer(async()=>{(!c||c.isDisposed)&&(c=new O(d,P||t,z>0),await c.update(typeof s=="function"?s():s,T,h))},z);let m=!1;const a=S.addDisposableListener(t,S.EventType.MOUSE_DOWN,()=>{m=!0,D(!0,!0)},!0),E=S.addDisposableListener(t,S.EventType.MOUSE_UP,()=>{m=!1},!0),k=S.addDisposableListener(t,S.EventType.MOUSE_LEAVE,z=>{m=!1,D(!1,z.fromElement===t)},!0),N=()=>{if(g)return;const z=new A.DisposableStore,T={targetElements:[t],dispose:()=>{}};if(d.placement===void 0||d.placement==="mouse"){const P=M=>{T.x=M.x+10,M.target instanceof HTMLElement&&M.target.classList.contains("action-label")&&D(!0,!0)};z.add(S.addDisposableListener(t,S.EventType.MOUSE_MOVE,P,!0))}z.add(u(d.delay,!1,T)),g=z},H=S.addDisposableListener(t,S.EventType.MOUSE_OVER,N,!0),W=()=>{if(m||g)return;const z={targetElements:[t],dispose:()=>{}},T=new A.DisposableStore,P=()=>D(!0,!0);T.add(S.addDisposableListener(t,S.EventType.BLUR,P,!0)),T.add(u(d.delay,!1,z)),g=T},_=S.addDisposableListener(t,S.EventType.FOCUS,W,!0);return{show:z=>{D(!1,!0),u(0,z)},hide:()=>{D(!0,!0)},update:async(z,T)=>{s=z,await c?.update(s,void 0,T)},dispose:()=>{H.dispose(),k.dispose(),a.dispose(),E.dispose(),_.dispose(),D(!0,!0)}}}e.setupCustomHover=l}),define(me[129],be([1,0,2,23,14,128,29,42,41,12,4,47,3,5,112,103]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SelectBoxList=void 0;const s=S.$,h="selectOption.entry.template";class g{get templateId(){return h}renderTemplate(u){const m=Object.create(null);return m.root=u,m.text=S.append(u,s(".option-text")),m.detail=S.append(u,s(".option-detail")),m.decoratorRight=S.append(u,s(".option-decorator-right")),m}renderElement(u,m,a){const E=a,k=u.text,N=u.detail,H=u.decoratorRight,W=u.isDisabled;E.text.textContent=k,E.detail.textContent=N||"",E.decoratorRight.innerText=H||"",W?E.root.classList.add("option-disabled"):E.root.classList.remove("option-disabled")}disposeTemplate(u){}}class c extends l.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(u,m,a,E,k){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=E,this.selectBoxOptions=k||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=c.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._hover=this._register((0,A.setupCustomHover)((0,y.getDefaultHoverDelegate)("mouse"),this.selectElement,"")),this._onDidSelect=new v.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(a),this.selected=m||0,u&&this.setOptions(u,m),this.initStyleSheet()}getHeight(){return 22}getTemplateId(){return h}constructSelectDropDown(u){this.contextViewProvider=u,this.selectDropDownContainer=S.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=S.append(this.selectDropDownContainer,s(".select-box-details-pane"));const m=S.append(this.selectDropDownContainer,s(".select-box-dropdown-container-width-control")),a=S.append(m,s(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",S.append(a,this.widthControlElement),this._dropDownPosition=0,this.styleElement=S.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(S.addDisposableListener(this.selectDropDownContainer,S.EventType.DRAG_START,E=>{S.EventHelper.stop(E,!0)}))}registerListeners(){this._register(S.addStandardDisposableListener(this.selectElement,"change",m=>{this.selected=m.target.selectedIndex,this._onDidSelect.fire({index:m.target.selectedIndex,selected:m.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this._hover.update(this.options[this.selected].text)})),this._register(S.addDisposableListener(this.selectElement,S.EventType.CLICK,m=>{S.EventHelper.stop(m),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(S.addDisposableListener(this.selectElement,S.EventType.MOUSE_DOWN,m=>{S.EventHelper.stop(m)}));let u;this._register(S.addDisposableListener(this.selectElement,"touchstart",m=>{u=this._isVisible})),this._register(S.addDisposableListener(this.selectElement,"touchend",m=>{S.EventHelper.stop(m),u?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(S.addDisposableListener(this.selectElement,S.EventType.KEY_DOWN,m=>{const a=new n.StandardKeyboardEvent(m);let E=!1;d.isMacintosh?(a.keyCode===18||a.keyCode===16||a.keyCode===10||a.keyCode===3)&&(E=!0):(a.keyCode===18&&a.altKey||a.keyCode===16&&a.altKey||a.keyCode===10||a.keyCode===3)&&(E=!0),E&&(this.showSelectDropDown(),S.EventHelper.stop(m,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(u,m){b.equals(this.options,u)||(this.options=u,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((a,E)=>{this.selectElement.add(this.createOption(a.text,E,a.isDisabled)),typeof a.description=="string"&&(this._hasDetails=!0)})),m!==void 0&&(this.select(m),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(u){u>=0&&u<this.options.length?this.selected=u:u>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this._hover.update(this.options[this.selected].text)}setAriaLabel(u){this.selectBoxOptions.ariaLabel=u,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(u){this.selectElement.tabIndex=u?0:-1}render(u){this.container=u,u.classList.add("select-container"),u.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const u=[];this.styles.listFocusBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(u.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=u.join(`
`)}styleSelectElement(){const u=this.styles.selectBackground??"",m=this.styles.selectForeground??"",a=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=u,this.selectElement.style.color=m,this.selectElement.style.borderColor=a}styleList(){const u=this.styles.selectBackground??"",m=S.asCssValueWithDefault(this.styles.selectListBackground,u);this.selectDropDownListContainer.style.backgroundColor=m,this.selectionDetailsPane.style.backgroundColor=m;const a=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=a,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(u,m,a){const E=document.createElement("option");return E.value=u,E.text=u,E.disabled=!!a,E}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:u=>this.renderSelectDropDown(u,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:u=>this.renderSelectDropDown(u),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(u){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),u&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(u,m){return u.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(m),{dispose:()=>{try{u.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let u=0;return this.options.forEach((m,a)=>{this.updateDetail(a),this.selectionDetailsPane.offsetHeight>u&&(u=this.selectionDetailsPane.offsetHeight)}),u}layoutSelectDropDown(u){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const m=S.getWindow(this.selectElement),a=S.getDomNodePagePosition(this.selectElement),E=S.getWindow(this.selectElement).getComputedStyle(this.selectElement),k=parseFloat(E.getPropertyValue("--dropdown-padding-top"))+parseFloat(E.getPropertyValue("--dropdown-padding-bottom")),N=m.innerHeight-a.top-a.height-(this.selectBoxOptions.minBottomMargin||0),H=a.top-c.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,W=this.selectElement.offsetWidth,_=this.setWidthControlElement(this.widthControlElement),B=Math.max(_,Math.round(W)).toString()+"px";this.selectDropDownContainer.style.width=B,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let z=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const T=this._hasDetails?this._cachedMaxDetailsHeight:0,P=z+k+T,M=Math.floor((N-k-T)/this.getHeight()),Y=Math.floor((H-k-T)/this.getHeight());if(u)return a.top+a.height>m.innerHeight-22||a.top<c.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||M<1&&Y<1?!1:(M<c.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&Y>M&&this.options.length>M?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(a.top+a.height>m.innerHeight-22||a.top<c.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&M<1||this._dropDownPosition===1&&Y<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&M+Y<1)return this.hideSelectDropDown(!0),!1;P>N&&(z=M*this.getHeight())}else P>H&&(z=Y*this.getHeight());return this.selectList.layout(z),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=z+k+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=z+k+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=B,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(u){let m=0;if(u){let a=0,E=0;this.options.forEach((k,N)=>{const H=k.detail?k.detail.length:0,W=k.decoratorRight?k.decoratorRight.length:0,_=k.text.length+H+W;_>E&&(a=N,E=_)}),u.textContent=this.options[a].text+(this.options[a].decoratorRight?this.options[a].decoratorRight+" ":""),m=S.getTotalWidth(u)}return m}createSelectList(u){if(this.selectList)return;this.selectDropDownListContainer=S.append(u,s(".select-box-dropdown-list-container")),this.listRenderer=new g,this.selectList=new p.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:E=>{let k=E.text;return E.detail&&(k+=`. ${E.detail}`),E.decoratorRight&&(k+=`. ${E.decoratorRight}`),E.description&&(k+=`. ${E.description}`),k},getWidgetAriaLabel:()=>(0,t.localize)(0,null),getRole:()=>d.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const m=this._register(new F.DomEmitter(this.selectDropDownListContainer,"keydown")),a=v.Event.chain(m.event,E=>E.filter(()=>this.selectList.length>0).map(k=>new n.StandardKeyboardEvent(k)));this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===3))(this.onEnter,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===2))(this.onEnter,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===9))(this.onEscape,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===16))(this.onUpArrow,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===18))(this.onDownArrow,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===12))(this.onPageDown,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===11))(this.onPageUp,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===14))(this.onHome,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode===13))(this.onEnd,this)),this._register(v.Event.chain(a,E=>E.filter(k=>k.keyCode>=21&&k.keyCode<=56||k.keyCode>=85&&k.keyCode<=113))(this.onCharacter,this)),this._register(S.addDisposableListener(this.selectList.getHTMLElement(),S.EventType.POINTER_UP,E=>this.onPointerUp(E))),this._register(this.selectList.onMouseOver(E=>typeof E.index<"u"&&this.selectList.setFocus([E.index]))),this._register(this.selectList.onDidChangeFocus(E=>this.onListFocus(E))),this._register(S.addDisposableListener(this.selectDropDownContainer,S.EventType.FOCUS_OUT,E=>{!this._isVisible||S.isAncestor(E.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(u){if(!this.selectList.length)return;S.EventHelper.stop(u);const m=u.target;if(!m||m.classList.contains("slider"))return;const a=m.closest(".monaco-list-row");if(!a)return;const E=Number(a.getAttribute("data-index")),k=a.classList.contains("option-disabled");E>=0&&E<this.options.length&&!k&&(this.selected=E,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this._hover.update(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(u,m){const a=k=>{for(let N=0;N<k.childNodes.length;N++){const H=k.childNodes.item(N);(H.tagName&&H.tagName.toLowerCase())==="img"?k.removeChild(H):a(H)}},E=(0,U.renderMarkdown)({value:u,supportThemeIcons:!0},{actionHandler:m});return E.element.classList.add("select-box-description-markdown"),a(E.element),E.element}onListFocus(u){!this._isVisible||!this._hasDetails||this.updateDetail(u.indexes[0])}updateDetail(u){this.selectionDetailsPane.innerText="";const m=this.options[u],a=m?.description??"",E=m?.descriptionIsMarkdown??!1;if(a){if(E){const k=m.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(a,k))}else this.selectionDetailsPane.innerText=a;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(u){S.EventHelper.stop(u),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(u){S.EventHelper.stop(u),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this._hover.update(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(u){if(this.selected<this.options.length-1){S.EventHelper.stop(u,!0);const m=this.options[this.selected+1].isDisabled;if(m&&this.options.length>this.selected+2)this.selected+=2;else{if(m)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(u){this.selected>0&&(S.EventHelper.stop(u,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(u){S.EventHelper.stop(u),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(u){S.EventHelper.stop(u),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(u){S.EventHelper.stop(u),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(u){S.EventHelper.stop(u),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(u){const m=O.KeyCodeUtils.toString(u.keyCode);let a=-1;for(let E=0;E<this.options.length-1;E++)if(a=(E+this.selected+1)%this.options.length,this.options[a].text.charAt(0).toUpperCase()===m&&!this.options[a].isDisabled){this.select(a),this.selectList.setFocus([a]),this.selectList.reveal(this.selectList.getFocus()[0]),S.EventHelper.stop(u);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}e.SelectBoxList=c}),define(me[130],be([1,0,41,129,124,20,5,102]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SelectBox=e.unthemedSelectBoxStyles=void 0,e.unthemedSelectBoxStyles={...S.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends U.Widget{constructor(b,v,O,l,d){super(),y.isMacintosh&&!d?.useCustomDrawn?this.selectBoxDelegate=new n.SelectBoxNative(b,v,l,d):this.selectBoxDelegate=new F.SelectBoxList(b,v,O,l,d),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(b,v){this.selectBoxDelegate.setOptions(b,v)}select(b){this.selectBoxDelegate.select(b)}setAriaLabel(b){this.selectBoxDelegate.setAriaLabel(b)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(b){this.selectBoxDelegate.setFocusable(b)}render(b){this.selectBoxDelegate.render(b)}}e.SelectBox=A}),define(me[65],be([1,0,16,56,2,25,29,42,130,38,3,5,7,107,54]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SelectActionViewItem=e.ActionViewItem=e.BaseActionViewItem=void 0;class t extends v.Disposable{get action(){return this._action}constructor(c,D,u={}){super(),this.options=u,this._context=c||this,this._action=D,D instanceof b.Action&&this._register(D.onDidChange(m=>{this.element&&this.handleActionChangeEvent(m)}))}handleActionChangeEvent(c){c.enabled!==void 0&&this.updateEnabled(),c.checked!==void 0&&this.updateChecked(),c.class!==void 0&&this.updateClass(),c.label!==void 0&&(this.updateLabel(),this.updateTooltip()),c.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new b.ActionRunner)),this._actionRunner}set actionRunner(c){this._actionRunner=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const D=this.element=c;this._register(U.Gesture.addTarget(c));const u=this.options&&this.options.draggable;u&&(c.draggable=!0,S.isFirefox&&this._register((0,n.addDisposableListener)(c,n.EventType.DRAG_START,m=>m.dataTransfer?.setData(F.DataTransfers.TEXT,this._action.label)))),this._register((0,n.addDisposableListener)(D,U.EventType.Tap,m=>this.onClick(m,!0))),this._register((0,n.addDisposableListener)(D,n.EventType.MOUSE_DOWN,m=>{u||n.EventHelper.stop(m,!0),this._action.enabled&&m.button===0&&D.classList.add("active")})),O.isMacintosh&&this._register((0,n.addDisposableListener)(D,n.EventType.CONTEXT_MENU,m=>{m.button===0&&m.ctrlKey===!0&&this.onClick(m)})),this._register((0,n.addDisposableListener)(D,n.EventType.CLICK,m=>{n.EventHelper.stop(m,!0),this.options&&this.options.isMenu||this.onClick(m)})),this._register((0,n.addDisposableListener)(D,n.EventType.DBLCLICK,m=>{n.EventHelper.stop(m,!0)})),[n.EventType.MOUSE_UP,n.EventType.MOUSE_OUT].forEach(m=>{this._register((0,n.addDisposableListener)(D,m,a=>{n.EventHelper.stop(a),D.classList.remove("active")}))})}onClick(c,D=!1){n.EventHelper.stop(c,!0);const u=l.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?c:{preserveFocus:D}:this._context;this.actionRunner.run(this._action,u)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const c=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=c;else if(this.customHover)this.customHover.update(c);else{const D=this.options.hoverDelegate??(0,y.getDefaultHoverDelegate)("element");this.customHover=(0,A.setupCustomHover)(D,this.element,c),this._store.add(this.customHover)}}updateAriaLabel(){if(this.element){const c=this.getTooltip()??"";this.element.setAttribute("aria-label",c)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}e.BaseActionViewItem=t;class s extends t{constructor(c,D,u){super(c,D,u),this.options=u,this.options.icon=u.icon!==void 0?u.icon:!1,this.options.label=u.label!==void 0?u.label:!0,this.cssClass=""}render(c){super.render(c),l.assertType(this.element);const D=document.createElement("a");if(D.classList.add("action-label"),D.setAttribute("role",this.getDefaultAriaRole()),this.label=D,this.element.appendChild(D),this.options.label&&this.options.keybinding){const u=document.createElement("span");u.classList.add("keybinding"),u.textContent=this.options.keybinding,this.element.appendChild(u)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===b.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(c){this.label&&(this.label.tabIndex=c?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(c=this.action.label,this.options.keybinding&&(c=d.localize(0,null,c,this.options.keybinding))),c??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const c=this.getTooltip()??"";this.label.setAttribute("aria-label",c)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.removeAttribute("aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}e.ActionViewItem=s;class h extends t{constructor(c,D,u,m,a,E,k){super(c,D),this.selectBox=new p.SelectBox(u,m,a,E,k),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(c,D){this.selectBox.setOptions(c,D)}select(c){this.selectBox.select(c)}registerListeners(){this._register(this.selectBox.onDidSelect(c=>this.runAction(c.selected,c.index)))}runAction(c,D){this.actionRunner.run(this._action,this.getActionContext(c,D))}getActionContext(c,D){return c}setFocusable(c){this.selectBox.setFocusable(c)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(c){this.selectBox.render(c)}}e.SelectActionViewItem=h}),define(me[66],be([1,0,2,14,65,29,38,4,3,7,54]),function(se,e,S,F,n,U,y,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareActions=e.ActionBar=e.ActionsOrientation=void 0;var v;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(v||(e.ActionsOrientation=v={}));class O extends p.Disposable{constructor(t,s={}){super(),this._actionRunnerDisposables=this._register(new p.DisposableStore),this.viewItemDisposables=this._register(new p.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new A.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new A.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new A.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new A.Emitter),this.onWillRun=this._onWillRun.event,this.options=s,this._context=s.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this._hoverDelegate=s.hoverDelegate??this._register((0,U.getDefaultHoverDelegate)("element",!0)),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new y.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(c=>this._onDidRun.fire(c))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(c=>this._onWillRun.fire(c))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,g;switch(this._orientation){case 0:h=[15],g=[17];break;case 1:h=[16],g=[18],this.domNode.className+=" vertical";break}this._register(S.addDisposableListener(this.domNode,S.EventType.KEY_DOWN,c=>{const D=new F.StandardKeyboardEvent(c);let u=!0;const m=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;h&&(D.equals(h[0])||D.equals(h[1]))?u=this.focusPrevious():g&&(D.equals(g[0])||D.equals(g[1]))?u=this.focusNext():D.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():D.equals(14)?u=this.focusFirst():D.equals(13)?u=this.focusLast():D.equals(2)&&m instanceof n.BaseActionViewItem&&m.trapsArrowNavigation?u=this.focusNext():this.isTriggerKeyEvent(D)?this._triggerKeys.keyDown?this.doTrigger(D):this.triggerKeyDown=!0:u=!1,u&&(D.preventDefault(),D.stopPropagation())})),this._register(S.addDisposableListener(this.domNode,S.EventType.KEY_UP,c=>{const D=new F.StandardKeyboardEvent(c);this.isTriggerKeyEvent(D)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(D)),D.preventDefault(),D.stopPropagation()):(D.equals(2)||D.equals(1026)||D.equals(16)||D.equals(18)||D.equals(15)||D.equals(17))&&this.updateFocusedItem()})),this.focusTracker=this._register(S.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(S.getActiveElement()===this.domNode||!S.isAncestor(S.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),t.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(t){t?this.actionsList.setAttribute("aria-label",t):this.actionsList.removeAttribute("aria-label")}setFocusable(t){if(this.focusable=t,this.focusable){const s=this.viewItems.find(h=>h instanceof n.BaseActionViewItem&&h.isEnabled());s instanceof n.BaseActionViewItem&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof n.BaseActionViewItem&&s.setFocusable(!1)})}isTriggerKeyEvent(t){let s=!1;return this._triggerKeys.keys.forEach(h=>{s=s||t.equals(h)}),s}updateFocusedItem(){for(let t=0;t<this.actionsList.children.length;t++){const s=this.actionsList.children[t];if(S.isAncestor(S.getActiveElement(),s)){this.focusedItem=t,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(t){this._context=t,this.viewItems.forEach(s=>s.setActionContext(t))}get actionRunner(){return this._actionRunner}set actionRunner(t){this._actionRunner=t,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(s=>this._onDidRun.fire(s))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(s=>this._onWillRun.fire(s))),this.viewItems.forEach(s=>s.actionRunner=t)}getContainer(){return this.domNode}hasAction(t){return this.viewItems.findIndex(s=>s.action.id===t.id)!==-1}getAction(t){if(typeof t=="number")return this.viewItems[t]?.action;if(t instanceof HTMLElement){for(;t.parentElement!==this.actionsList;){if(!t.parentElement)return;t=t.parentElement}for(let s=0;s<this.actionsList.childNodes.length;s++)if(this.actionsList.childNodes[s]===t)return this.viewItems[s].action}}push(t,s={}){const h=Array.isArray(t)?t:[t];let g=b.isNumber(s.index)?s.index:null;h.forEach(c=>{const D=document.createElement("li");D.className="action-item",D.setAttribute("role","presentation");let u;const m={hoverDelegate:this._hoverDelegate,...s};this.options.actionViewItemProvider&&(u=this.options.actionViewItemProvider(c,m)),u||(u=new n.ActionViewItem(this.context,c,m)),this.options.allowContextMenu||this.viewItemDisposables.set(u,S.addDisposableListener(D,S.EventType.CONTEXT_MENU,a=>{S.EventHelper.stop(a,!0)})),u.actionRunner=this._actionRunner,u.setActionContext(this.context),u.render(D),this.focusable&&u instanceof n.BaseActionViewItem&&this.viewItems.length===0&&u.setFocusable(!0),g===null||g<0||g>=this.actionsList.children.length?(this.actionsList.appendChild(D),this.viewItems.push(u)):(this.actionsList.insertBefore(D,this.actionsList.children[g]),this.viewItems.splice(g,0,u),g++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(t){if(t>=0&&t<this.actionsList.children.length){const s=this.actionsList.children.item(t);if(s)return s.clientWidth}return 0}getHeight(t){if(t>=0&&t<this.actionsList.children.length){const s=this.actionsList.children.item(t);if(s)return s.clientHeight}return 0}pull(t){t>=0&&t<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[t]),this.viewItemDisposables.deleteAndDispose(this.viewItems[t]),(0,p.dispose)(this.viewItems.splice(t,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,p.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),S.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(t){let s=!1,h;if(t===void 0?s=!0:typeof t=="number"?h=t:typeof t=="boolean"&&(s=t),s&&typeof this.focusedItem>"u"){const g=this.viewItems.findIndex(c=>c.isEnabled());this.focusedItem=g===-1?void 0:g,this.updateFocus(void 0,void 0,!0)}else h!==void 0&&(this.focusedItem=h),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(t){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.focusedItem;let h;do{if(!t&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=s,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,h=this.viewItems[this.focusedItem]}while(this.focusedItem!==s&&(this.options.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===y.Separator.ID));return this.updateFocus(),!0}focusPrevious(t){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const s=this.focusedItem;let h;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!t&&this.options.preventLoopNavigation)return this.focusedItem=s,!1;this.focusedItem=this.viewItems.length-1}h=this.viewItems[this.focusedItem]}while(this.focusedItem!==s&&(this.options.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===y.Separator.ID));return this.updateFocus(!0),!0}updateFocus(t,s,h=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:s}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const g=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(g){let c=!0;b.isFunction(g.focus)||(c=!1),this.options.focusOnlyEnabledItems&&b.isFunction(g.isEnabled)&&!g.isEnabled()&&(c=!1),g.action.id===y.Separator.ID&&(c=!1),c?(h||this.previouslyFocusedItem!==this.focusedItem)&&(g.focus(t),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:s}),this.previouslyFocusedItem=void 0),c&&g.showHover?.()}}doTrigger(t){if(typeof this.focusedItem>"u")return;const s=this.viewItems[this.focusedItem];if(s instanceof n.BaseActionViewItem){const h=s._context===null||s._context===void 0?t:s._context;this.run(s._action,h)}}async run(t,s){await this._actionRunner.run(t,s)}dispose(){this._context=void 0,this.viewItems=(0,p.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}e.ActionBar=O;function l(d){if(!d.length)return d;let t=-1;for(let h=0;h<d.length;h++)if(d[h].id!==y.Separator.ID){t=h;break}if(t===-1)return[];d=d.slice(t);for(let h=d.length-1;h>=0&&d[h].id===y.Separator.ID;h--)d.splice(h,1);let s=!1;for(let h=d.length-1;h>=0;h--){const g=d[h].id===y.Separator.ID;g&&!s?d.splice(h,1):g?g&&(s=!1):s=!0}return d}e.prepareActions=l}),define(me[67],be([1,0,2,23,57,66,59,62,20,4,84,53,111,99]),function(se,e,S,F,n,U,y,A,p,b,v,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HistoryInputBox=e.InputBox=e.unthemedInboxStyles=e.MessageType=void 0;const d=S.$;var t;(function(g){g[g.INFO=1]="INFO",g[g.WARNING=2]="WARNING",g[g.ERROR=3]="ERROR"})(t||(e.MessageType=t={})),e.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends p.Widget{constructor(c,D,u){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new b.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=D,this.options=u,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=S.append(c,d(".monaco-inputbox.idle"));const m=this.options.flexibleHeight?"textarea":"input",a=S.append(this.element,d(".ibwrapper"));if(this.input=S.append(a,d(m+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=S.append(a,d("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new A.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),S.append(c,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(N=>this.input.scrollTop=N.scrollTop));const E=this._register(new F.DomEmitter(c.ownerDocument,"selectionchange")),k=b.Event.filter(E.event,()=>c.ownerDocument.getSelection()?.anchorNode===a);this._register(k(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new U.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(c){this.placeholder=c,this.input.setAttribute("placeholder",c)}setTooltip(c){this.tooltip=c,this.input.title=c}setAriaLabel(c){this.ariaLabel=c,c?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(c){this.input.value!==c&&(this.input.value=c,this.onValueChange())}get step(){return this.input.step}set step(c){this.input.step=c}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:S.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return S.isActiveElement(this.input)}select(c=null){this.input.select(),c&&(this.input.setSelectionRange(c.start,c.end),c.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(c){c?this.enable():this.disable()}get width(){return S.getTotalWidth(this.input)}set width(c){if(this.options.flexibleHeight&&this.options.flexibleWidth){let D=0;if(this.mirror){const u=parseFloat(this.mirror.style.paddingLeft||"")||0,m=parseFloat(this.mirror.style.paddingRight||"")||0;D=u+m}this.input.style.width=c-D+"px"}else this.input.style.width=c+"px";this.mirror&&(this.mirror.style.width=c+"px")}set paddingRight(c){this.input.style.width=`calc(100% - ${c}px)`,this.mirror&&(this.mirror.style.paddingRight=c+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const c=this.cachedContentHeight,D=this.cachedHeight,u=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:c,height:D}),this.scrollableElement.setScrollPosition({scrollTop:u})}showMessage(c,D){if(this.state==="open"&&(0,O.equals)(this.message,c))return;this.message=c,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(c.type));const u=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${S.asCssValueWithDefault(u.border,"transparent")}`,this.message.content&&(this.hasFocus()||D)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let c=null;return this.validation&&(c=this.validation(this.value),c?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(c)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),c?.type}stylesForType(c){const D=this.options.inputBoxStyles;switch(c){case 1:return{border:D.inputValidationInfoBorder,background:D.inputValidationInfoBackground,foreground:D.inputValidationInfoForeground};case 2:return{border:D.inputValidationWarningBorder,background:D.inputValidationWarningBackground,foreground:D.inputValidationWarningForeground};default:return{border:D.inputValidationErrorBorder,background:D.inputValidationErrorBackground,foreground:D.inputValidationErrorForeground}}}classForType(c){switch(c){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let c;const D=()=>c.style.width=S.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:m=>{if(!this.message)return null;c=S.append(m,d(".monaco-inputbox-container")),D();const a={inline:!0,className:"monaco-inputbox-message"},E=this.message.formatContent?(0,n.renderFormattedText)(this.message.content,a):(0,n.renderText)(this.message.content,a);E.classList.add(this.classForType(this.message.type));const k=this.stylesForType(this.message.type);return E.style.backgroundColor=k.background??"",E.style.color=k.foreground??"",E.style.border=k.border?`1px solid ${k.border}`:"",S.append(c,E),null},onHide:()=>{this.state="closed"},layout:D});let u;this.message.type===3?u=l.localize(0,null,this.message.content):this.message.type===2?u=l.localize(1,null,this.message.content):u=l.localize(2,null,this.message.content),y.alert(u),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const c=this.value,u=c.charCodeAt(c.length-1)===10?" ":"";(c+u).replace(/\u000c/g,"")?this.mirror.textContent=c+u:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const c=this.options.inputBoxStyles,D=c.inputBackground??"",u=c.inputForeground??"",m=c.inputBorder??"";this.element.style.backgroundColor=D,this.element.style.color=u,this.input.style.backgroundColor="inherit",this.input.style.color=u,this.element.style.border=`1px solid ${S.asCssValueWithDefault(m,"transparent")}`}layout(){if(!this.mirror)return;const c=this.cachedContentHeight;this.cachedContentHeight=S.getTotalHeight(this.mirror),c!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(c){const D=this.inputElement,u=D.selectionStart,m=D.selectionEnd,a=D.value;u!==null&&m!==null&&(this.value=a.substr(0,u)+c+a.substr(m),D.setSelectionRange(u+1,u+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}e.InputBox=s;class h extends s{constructor(c,D,u){const m=l.localize(3,null,"\u21C5"),a=l.localize(4,null,"\u21C5");super(c,D,u),this._onDidFocus=this._register(new b.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new v.HistoryNavigator(u.history,100);const E=()=>{if(u.showHistoryHint&&u.showHistoryHint()&&!this.placeholder.endsWith(m)&&!this.placeholder.endsWith(a)&&this.history.getHistory().length){const k=this.placeholder.endsWith(")")?m:a,N=this.placeholder+k;u.showPlaceholderOnFocus&&!S.isActiveElement(this.input)?this.placeholder=N:this.setPlaceHolder(N)}};this.observer=new MutationObserver((k,N)=>{k.forEach(H=>{H.target.textContent||E()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>E()),this.onblur(this.input,()=>{const k=N=>{if(this.placeholder.endsWith(N)){const H=this.placeholder.slice(0,this.placeholder.length-N.length);return u.showPlaceholderOnFocus?this.placeholder=H:this.setPlaceHolder(H),!0}else return!1};k(a)||k(m)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(c){this.value&&(c||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(c){const D=this.getHistory();this.clearHistory(),c.forEach(u=>{this.history.add(u)}),D.forEach(u=>{this.history.add(u)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let c=this.getNextValue();c&&(c=c===this.value?this.getNextValue():c),this.value=c??"",y.status(this.value?this.value:l.localize(5,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let c=this.getPreviousValue();c&&(c=c===this.value?this.getPreviousValue():c),c&&(this.value=c,y.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(c){super.setPlaceHolder(c),this.setTooltip(c)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let c=this.history.current();return c||(c=this.history.last(),this.history.next()),c}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}e.HistoryInputBox=h}),define(me[68],be([1,0,65,20,17,18,4,2,42,29,104]),function(se,e,S,F,n,U,y,A,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CheckboxActionViewItem=e.Checkbox=e.Toggle=e.ToggleActionViewItem=e.unthemedToggleStyles=void 0,e.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class v extends S.BaseActionViewItem{constructor(s,h,g){super(s,h,g),this.toggle=this._register(new O({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:g.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:g.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:g.toggleStyles?.inputActiveOptionForeground})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(s){this.element=s,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(s){this.toggle.domNode.tabIndex=s?0:-1}}e.ToggleActionViewItem=v;class O extends F.Widget{constructor(s){super(),this._onChange=this._register(new y.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=s,this._checked=this._opts.isChecked;const h=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,h.push(...U.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&h.push(...this._opts.actionClassName.split(" ")),this._checked&&h.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,p.setupCustomHover)((0,b.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...h),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,g=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),g.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,g=>{if(g.keyCode===10||g.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),g.preventDefault(),g.stopPropagation();return}this._onKeyDown.fire(g)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(s){this._checked=s,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(s){this._icon&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this._icon)),this._icon=s,this._icon&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this._hover.update(s),this.domNode.setAttribute("aria-label",s)}}e.Toggle=O;class l extends F.Widget{constructor(s,h,g){super(),this.title=s,this.isChecked=h,this._onChange=this._register(new y.Emitter),this.onChange=this._onChange.event,this.checkbox=new O({title:this.title,isChecked:this.isChecked,icon:n.Codicon.check,actionClassName:"monaco-checkbox",...e.unthemedToggleStyles}),this.domNode=this.checkbox.domNode,this.styles=g,this.applyStyles(),this._register(this.checkbox.onChange(c=>{this.applyStyles(),this._onChange.fire(c)}))}get checked(){return this.checkbox.checked}set checked(s){this.checkbox.checked=s,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,A.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}e.Checkbox=l;class d extends S.BaseActionViewItem{constructor(s,h,g){super(s,h,g),this.toggle=this._register(new l(this._action.label,!!this._action.checked,g.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const h=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this._register((0,A.addDisposableListener)(h,A.EventType.CLICK,g=>{this.toggle.checked=!this.toggle.checked,g.stopPropagation(),g.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(s){this.toggle.domNode.tabIndex=s?0:-1}}e.CheckboxActionViewItem=d}),define(me[131],be([1,0,68,17,109]),function(se,e,S,F,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RegexToggle=e.WholeWordsToggle=e.CaseSensitiveToggle=void 0;const U=n.localize(0,null),y=n.localize(1,null),A=n.localize(2,null);class p extends S.Toggle{constructor(l){super({icon:F.Codicon.caseSensitive,title:U+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}e.CaseSensitiveToggle=p;class b extends S.Toggle{constructor(l){super({icon:F.Codicon.wholeWord,title:y+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}e.WholeWordsToggle=b;class v extends S.Toggle{constructor(l){super({icon:F.Codicon.regex,title:A+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}e.RegexToggle=v}),define(me[132],be([1,0,2,131,67,20,4,108,3,98]),function(se,e,S,F,n,U,y,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FindInput=void 0;const b=A.localize(0,null);class v extends U.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(l,d,t){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new p.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new y.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new y.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new y.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new y.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new y.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new y.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=t.placeholder||"",this.validation=t.validation,this.label=t.label||b,this.showCommonFindToggles=!!t.showCommonFindToggles;const s=t.appendCaseSensitiveLabel||"",h=t.appendWholeWordsLabel||"",g=t.appendRegexLabel||"",c=t.history||[],D=!!t.flexibleHeight,u=!!t.flexibleWidth,m=t.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new n.HistoryInputBox(this.domNode,d,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:c,showHistoryHint:t.showHistoryHint,flexibleHeight:D,flexibleWidth:u,flexibleMaxHeight:m,inputBoxStyles:t.inputBoxStyles})),this.showCommonFindToggles){this.regex=this._register(new F.RegexToggle({appendTitle:g,isChecked:!1,...t.toggleStyles})),this._register(this.regex.onChange(E=>{this._onDidOptionChange.fire(E),!E&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(E=>{this._onRegexKeyDown.fire(E)})),this.wholeWords=this._register(new F.WholeWordsToggle({appendTitle:h,isChecked:!1,...t.toggleStyles})),this._register(this.wholeWords.onChange(E=>{this._onDidOptionChange.fire(E),!E&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new F.CaseSensitiveToggle({appendTitle:s,isChecked:!1,...t.toggleStyles})),this._register(this.caseSensitive.onChange(E=>{this._onDidOptionChange.fire(E),!E&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(E=>{this._onCaseSensitiveKeyDown.fire(E)}));const a=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,E=>{if(E.equals(15)||E.equals(17)||E.equals(9)){const k=a.indexOf(this.domNode.ownerDocument.activeElement);if(k>=0){let N=-1;E.equals(17)?N=(k+1)%a.length:E.equals(15)&&(k===0?N=a.length-1:N=k-1),E.equals(9)?(a[k].blur(),this.inputBox.focus()):N>=0&&a[N].focus(),S.EventHelper.stop(E,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(t?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),l?.appendChild(this.domNode),this._register(S.addDisposableListener(this.inputBox.inputElement,"compositionstart",a=>{this.imeSessionInProgress=!0})),this._register(S.addDisposableListener(this.inputBox.inputElement,"compositionend",a=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,a=>this._onKeyDown.fire(a)),this.onkeyup(this.inputBox.inputElement,a=>this._onKeyUp.fire(a)),this.oninput(this.inputBox.inputElement,a=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,a=>this._onMouseDown.fire(a))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(l){this.inputBox.layout(),this.updateInputBoxPadding(l.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const l of this.additionalToggles)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const l of this.additionalToggles)l.disable()}setFocusInputOnOptionClick(l){this.fixFocusOnOptionClickEnabled=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const d of this.additionalToggles)d.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new p.DisposableStore;for(const d of l??[])this.additionalTogglesDisposables.value.add(d),this.controls.appendChild(d.domNode),this.additionalTogglesDisposables.value.add(d.onChange(t=>{this._onDidOptionChange.fire(t),!t&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(d);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(l=!1){l?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((d,t)=>d+t.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(l){this.caseSensitive&&(this.caseSensitive.checked=l)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(l){this.wholeWords&&(this.wholeWords.checked=l)}getRegex(){return this.regex?.checked??!1}setRegex(l){this.regex&&(this.regex.checked=l,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}e.FindInput=v}),define(me[133],be([1,0,2,23,14,66,132,67,63,41,68,60,26,38,12,9,17,18,33,4,36,3,34,7,113,105]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t,s,h,g,c,D,u,m,a,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTree=e.AbstractTreePart=e.TreeFindMatchType=e.TreeFindMode=e.FuzzyToggle=e.ModeToggle=e.TreeRenderer=e.RenderIndentGuides=e.AbstractTreeViewState=e.ComposedTreeDelegate=void 0;class N extends p.ElementsDragAndDropData{set context(i){this.data.context=i}get context(){return this.data.context}constructor(i){super(i.elements.map(o=>o.element)),this.data=i}}function H(r){return r instanceof p.ElementsDragAndDropData?new N(r):r}class W{constructor(i,o){this.modelProvider=i,this.dnd=o,this.autoExpandDisposable=m.Disposable.None,this.disposables=new m.DisposableStore}getDragURI(i){return this.dnd.getDragURI(i.element)}getDragLabel(i,o){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(i.map(w=>w.element),o)}onDragStart(i,o){this.dnd.onDragStart?.(H(i),o)}onDragOver(i,o,w,R,L,x=!0){const V=this.dnd.onDragOver(H(i),o&&o.element,w,R,L),Q=this.autoExpandNode!==o;if(Q&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=o),typeof o>"u")return V;if(Q&&typeof V!="boolean"&&V.autoExpand&&(this.autoExpandDisposable=(0,s.disposableTimeout)(()=>{const Ae=this.modelProvider(),De=Ae.getNodeLocation(o);Ae.isCollapsed(De)&&Ae.setCollapsed(De,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof V=="boolean"||!V.accept||typeof V.bubble>"u"||V.feedback){if(!x){const Ae=typeof V=="boolean"?V:V.accept,De=typeof V=="boolean"?void 0:V.effect;return{accept:Ae,effect:De,feedback:[w]}}return V}if(V.bubble===1){const Ae=this.modelProvider(),De=Ae.getNodeLocation(o),Fe=Ae.getParentNodeLocation(De),Pe=Ae.getNode(Fe),Re=Fe&&Ae.getListIndex(Fe);return this.onDragOver(i,Pe,Re,R,L,!1)}const oe=this.modelProvider(),pe=oe.getNodeLocation(o),ye=oe.getListIndex(pe),we=oe.getListRenderCount(pe);return{...V,feedback:(0,t.range)(ye,ye+we)}}drop(i,o,w,R,L){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(H(i),o&&o.element,w,R,L)}onDragEnd(i){this.dnd.onDragEnd?.(i)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function _(r,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(o){return i.identityProvider.getId(o.element)}},dnd:i.dnd&&new W(r,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(o){return i.multipleSelectionController.isSelectionSingleChangeEvent({...o,element:o.element})},isSelectionRangeChangeEvent(o){return i.multipleSelectionController.isSelectionRangeChangeEvent({...o,element:o.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(o){const w=r(),R=w.getNodeLocation(o),L=w.getParentNodeLocation(R);return w.getNode(L).visibleChildrenCount},getPosInSet(o){return o.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?o=>i.accessibilityProvider.isChecked(o.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?o=>i.accessibilityProvider.getRole(o.element):()=>"treeitem",getAriaLabel(o){return i.accessibilityProvider.getAriaLabel(o.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?o=>i.accessibilityProvider.getAriaLevel(o.element):o=>o.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(o=>i.accessibilityProvider.getActiveDescendantId(o.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(o){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o.element)}}}}class B{constructor(i){this.delegate=i}getHeight(i){return this.delegate.getHeight(i.element)}getTemplateId(i){return this.delegate.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(i.element)}setDynamicHeight(i,o){this.delegate.setDynamicHeight?.(i.element,o)}}e.ComposedTreeDelegate=B;class z{static lift(i){return i instanceof z?i:new z(i)}static empty(i=0){return new z({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const o of i.expanded)this.expanded[o]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}e.AbstractTreeViewState=z;var T;(function(r){r.None="none",r.OnHover="onHover",r.Always="always"})(T||(e.RenderIndentGuides=T={}));class P{get elements(){return this._elements}constructor(i,o=[]){this._elements=o,this.disposables=new m.DisposableStore,this.onDidChange=D.Event.forEach(i,w=>this._elements=w,this.disposables)}dispose(){this.disposables.dispose()}}class M{static{this.DefaultIndent=8}constructor(i,o,w,R,L,x={}){this.renderer=i,this.modelProvider=o,this.activeNodes=R,this.renderedIndentGuides=L,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=M.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=m.Disposable.None,this.disposables=new m.DisposableStore,this.templateId=i.templateId,this.updateOptions(x),D.Event.map(w,V=>V.node)(this.onDidChangeNodeTwistieState,this,this.disposables),i.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(i={}){if(typeof i.indent<"u"){const o=(0,a.clamp)(i.indent,0,40);if(o!==this.indent){this.indent=o;for(const[w,R]of this.renderedNodes)this.renderTreeElement(w,R)}}if(typeof i.renderIndentGuides<"u"){const o=i.renderIndentGuides!==T.None;if(o!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=o;for(const[w,R]of this.renderedNodes)this._renderIndentGuides(w,R);if(this.indentGuidesDisposable.dispose(),o){const w=new m.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,w),this.indentGuidesDisposable=w,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const o=(0,S.append)(i,(0,S.$)(".monaco-tl-row")),w=(0,S.append)(o,(0,S.$)(".monaco-tl-indent")),R=(0,S.append)(o,(0,S.$)(".monaco-tl-twistie")),L=(0,S.append)(o,(0,S.$)(".monaco-tl-contents")),x=this.renderer.renderTemplate(L);return{container:i,indent:w,twistie:R,indentGuidesDisposable:m.Disposable.None,templateData:x}}renderElement(i,o,w,R){this.renderedNodes.set(i,w),this.renderedElements.set(i.element,i),this.renderTreeElement(i,w),this.renderer.renderElement(i,o,w.templateData,R)}disposeElement(i,o,w,R){w.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(i,o,w.templateData,R),typeof R=="number"&&(this.renderedNodes.delete(i),this.renderedElements.delete(i.element))}disposeTemplate(i){this.renderer.disposeTemplate(i.templateData)}onDidChangeTwistieState(i){const o=this.renderedElements.get(i);o&&this.onDidChangeNodeTwistieState(o)}onDidChangeNodeTwistieState(i){const o=this.renderedNodes.get(i);o&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(i,o))}renderTreeElement(i,o){const w=M.DefaultIndent+(i.depth-1)*this.indent;o.twistie.style.paddingLeft=`${w}px`,o.indent.style.width=`${w+this.indent-16}px`,i.collapsible?o.container.setAttribute("aria-expanded",String(!i.collapsed)):o.container.removeAttribute("aria-expanded"),o.twistie.classList.remove(...g.ThemeIcon.asClassNameArray(h.Codicon.treeItemExpanded));let R=!1;this.renderer.renderTwistie&&(R=this.renderer.renderTwistie(i.element,o.twistie)),i.collapsible&&(!this.hideTwistiesOfChildlessElements||i.visibleChildrenCount>0)?(R||o.twistie.classList.add(...g.ThemeIcon.asClassNameArray(h.Codicon.treeItemExpanded)),o.twistie.classList.add("collapsible"),o.twistie.classList.toggle("collapsed",i.collapsed)):o.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(i,o)}_renderIndentGuides(i,o){if((0,S.clearNode)(o.indent),o.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const w=new m.DisposableStore,R=this.modelProvider();for(;;){const L=R.getNodeLocation(i),x=R.getParentNodeLocation(L);if(!x)break;const V=R.getNode(x),Q=(0,S.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(V)&&Q.classList.add("active"),o.indent.childElementCount===0?o.indent.appendChild(Q):o.indent.insertBefore(Q,o.indent.firstElementChild),this.renderedIndentGuides.add(V,Q),w.add((0,m.toDisposable)(()=>this.renderedIndentGuides.delete(V,Q))),i=V}o.indentGuidesDisposable=w}_onDidChangeActiveNodes(i){if(!this.shouldRenderIndentGuides)return;const o=new Set,w=this.modelProvider();i.forEach(R=>{const L=w.getNodeLocation(R);try{const x=w.getParentNodeLocation(L);R.collapsible&&R.children.length>0&&!R.collapsed?o.add(R):x&&o.add(w.getNode(x))}catch{}}),this.activeIndentNodes.forEach(R=>{o.has(R)||this.renderedIndentGuides.forEach(R,L=>L.classList.remove("active"))}),o.forEach(R=>{this.activeIndentNodes.has(R)||this.renderedIndentGuides.forEach(R,L=>L.classList.add("active"))}),this.activeIndentNodes=o}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,m.dispose)(this.disposables)}}e.TreeRenderer=M;class Y{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(i){this._pattern=i,this._lowercasePattern=i.toLowerCase()}constructor(i,o,w){this.tree=i,this.keyboardNavigationLabelProvider=o,this._filter=w,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new m.DisposableStore,i.onWillRefilter(this.reset,this,this.disposables)}filter(i,o){let w=1;if(this._filter){const x=this._filter.filter(i,o);if(typeof x=="boolean"?w=x?1:0:(0,O.isFilterResult)(x)?w=(0,O.getVisibleState)(x.visibility):w=x,w===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:u.FuzzyScore.Default,visibility:w};const R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(i),L=Array.isArray(R)?R:[R];for(const x of L){const V=x&&x.toString();if(typeof V>"u")return{data:u.FuzzyScore.Default,visibility:w};let Q;if(this.tree.findMatchType===ge.Contiguous){const oe=V.toLowerCase().indexOf(this._lowercasePattern);if(oe>-1){Q=[Number.MAX_SAFE_INTEGER,0];for(let pe=this._lowercasePattern.length;pe>0;pe--)Q.push(oe+pe-1)}}else Q=(0,u.fuzzyScore)(this._pattern,this._lowercasePattern,0,V,V.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return this._matchCount++,L.length===1?{data:Q,visibility:w}:{data:{label:V,score:Q},visibility:w}}return this.tree.findMode===te.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(i):2:{data:u.FuzzyScore.Default,visibility:w}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,m.dispose)(this.disposables)}}class Z extends v.Toggle{constructor(i){super({icon:h.Codicon.listFilter,title:(0,k.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}e.ModeToggle=Z;class fe extends v.Toggle{constructor(i){super({icon:h.Codicon.searchFuzzy,title:(0,k.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}e.FuzzyToggle=fe;const ce={inputBoxStyles:A.unthemedInboxStyles,toggleStyles:v.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(r){r[r.Highlight=0]="Highlight",r[r.Filter=1]="Filter"})(te||(e.TreeFindMode=te={}));var ge;(function(r){r[r.Fuzzy=0]="Fuzzy",r[r.Contiguous=1]="Contiguous"})(ge||(e.TreeFindMatchType=ge={}));class ke extends m.Disposable{set mode(i){this.modeToggle.checked=i===te.Filter,this.findInput.inputBox.setPlaceHolder(i===te.Filter?(0,k.localize)(2,null):(0,k.localize)(3,null))}set matchType(i){this.matchTypeToggle.checked=i===ge.Fuzzy}get value(){return this.findInput.inputBox.value}set value(i){this.findInput.inputBox.value=i}constructor(i,o,w,R,L,x){super(),this.tree=o,this.elements=(0,S.h)(".monaco-tree-type-filter",[(0,S.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,S.h)(".monaco-tree-type-filter-input@findInput"),(0,S.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new D.Emitter,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.elements.root),this._register((0,m.toDisposable)(()=>i.removeChild(this.elements.root)));const V=x?.styles??ce;V.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=V.listFilterWidgetBackground),V.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${V.listFilterWidgetShadow}`),this.modeToggle=this._register(new Z({...V.toggleStyles,isChecked:R===te.Filter})),this.matchTypeToggle=this._register(new fe({...V.toggleStyles,isChecked:L===ge.Fuzzy})),this.onDidChangeMode=D.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?te.Filter:te.Highlight,this._store),this.onDidChangeMatchType=D.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?ge.Fuzzy:ge.Contiguous,this._store),this.findInput=this._register(new y.FindInput(this.elements.findInput,w,{label:(0,k.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:V.inputBoxStyles,toggleStyles:V.toggleStyles,history:x?.history})),this.actionbar=this._register(new U.ActionBar(this.elements.actionbar)),this.mode=R;const Q=this._register(new F.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),oe=D.Event.chain(Q.event,Ae=>Ae.map(De=>new n.StandardKeyboardEvent(De)));this._register(oe(Ae=>{if(Ae.equals(3)){Ae.preventDefault(),Ae.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(Ae.equals(18)){Ae.preventDefault(),Ae.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(Ae.equals(16)){Ae.preventDefault(),Ae.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const pe=this._register(new d.Action("close",(0,k.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(pe,{icon:!0,label:!1});const ye=this._register(new F.DomEmitter(this.elements.grab,"mousedown"));this._register(ye.event(Ae=>{const De=new m.DisposableStore,Fe=De.add(new F.DomEmitter((0,S.getWindow)(Ae),"mousemove")),Pe=De.add(new F.DomEmitter((0,S.getWindow)(Ae),"mouseup")),Re=this.right,Ze=Ae.pageX,nt=this.top,je=Ae.pageY;this.elements.grab.classList.add("grabbing");const Qe=this.elements.root.style.transition;this.elements.root.style.transition="unset";const G=ne=>{const ve=ne.pageX-Ze;this.right=Re-ve;const _e=ne.pageY-je;this.top=nt+_e,this.layout()};De.add(Fe.event(G)),De.add(Pe.event(ne=>{G(ne),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=Qe,De.dispose()}))}));const we=D.Event.chain(this._register(new F.DomEmitter(this.elements.grab,"keydown")).event,Ae=>Ae.map(De=>new n.StandardKeyboardEvent(De)));this._register(we(Ae=>{let De,Fe;if(Ae.keyCode===15?De=Number.POSITIVE_INFINITY:Ae.keyCode===17?De=0:Ae.keyCode===10&&(De=this.right===0?Number.POSITIVE_INFINITY:0),Ae.keyCode===16?Fe=0:Ae.keyCode===18&&(Fe=Number.POSITIVE_INFINITY),De!==void 0&&(Ae.preventDefault(),Ae.stopPropagation(),this.right=De,this.layout()),Fe!==void 0){Ae.preventDefault(),Ae.stopPropagation(),this.top=Fe;const Pe=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=Pe},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(i=this.width){this.width=i,this.right=(0,a.clamp)(this.right,0,Math.max(0,i-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,a.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(i){this.findInput.showMessage(i)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class Le{get pattern(){return this._pattern}get mode(){return this._mode}set mode(i){i!==this._mode&&(this._mode=i,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(i))}get matchType(){return this._matchType}set matchType(i){i!==this._matchType&&(this._matchType=i,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(i))}constructor(i,o,w,R,L,x={}){this.tree=i,this.view=w,this.filter=R,this.contextViewProvider=L,this.options=x,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new D.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new D.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new D.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new D.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new m.DisposableStore,this.disposables=new m.DisposableStore,this._mode=i.options.defaultFindMode??te.Highlight,this._matchType=i.options.defaultFindMatchType??ge.Fuzzy,o.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new ke(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(i=>this.mode=i,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(i=>this.matchType=i,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(i){this._pattern=i,this._onDidChangePattern.fire(i),this.filter.pattern=i,this.tree.refilter(),i&&this.tree.focusNext(0,!0,void 0,w=>!u.FuzzyScore.isDefault(w.filterData));const o=this.tree.getFocus();if(o.length>0){const w=o[0];this.tree.getRelativeTop(w)===null&&this.tree.reveal(w,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const i=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&i?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,k.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(i){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!u.FuzzyScore.isDefault(i.filterData)}layout(i){this.width=i,this.widget?.layout(i)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function Be(r,i){return r.position===i.position&&le(r,i)}function le(r,i){return r.node.element===i.node.element&&r.startIndex===i.startIndex&&r.height===i.height&&r.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,t.equals)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const o=this.stickyNodes[this.count-2];return o.position+o.height!==i.position}animationStateChanged(i){if(!(0,t.equals)(this.stickyNodes,i.stickyNodes,le)||this.count===0)return!1;const o=this.stickyNodes[this.count-1],w=i.stickyNodes[i.count-1];return o.position!==w.position}}class ae{constrainStickyScrollNodes(i,o,w){for(let R=0;R<i.length;R++){const L=i[R];if(L.position+L.height>w||R>=o)return i.slice(0,R)}return i}}class re extends m.Disposable{constructor(i,o,w,R,L,x={}){super(),this.tree=i,this.model=o,this.view=w,this.treeDelegate=L,this.maxWidgetViewRatio=.4;const V=this.validateStickySettings(x);this.stickyScrollMaxItemCount=V.stickyScrollMaxItemCount,this.stickyScrollDelegate=x.stickyScrollDelegate??new ae,this._widget=this._register(new X(w.getScrollableElement(),w,i,R,L,x.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(w.onDidScroll(()=>this.update())),this._register(w.onDidChangeContentHeight(()=>this.update())),this._register(i.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(i){return this._widget.getNode(i)}getNodeAtHeight(i){let o;if(i===0?o=this.view.firstVisibleIndex:o=this.view.indexAt(i+this.view.scrollTop),!(o<0||o>=this.view.length))return this.view.element(o)}update(){const i=this.getNodeAtHeight(0);if(!i||this.tree.scrollTop===0){this._widget.setState(void 0);return}const o=this.findStickyState(i);this._widget.setState(o)}findStickyState(i){const o=[];let w=i,R=0,L=this.getNextStickyNode(w,void 0,R);for(;L&&(o.push(L),R+=L.height,!(o.length<=this.stickyScrollMaxItemCount&&(w=this.getNextVisibleNode(L),!w)));)L=this.getNextStickyNode(w,L.node,R);const x=this.constrainStickyNodes(o);return x.length?new J(x):void 0}getNextVisibleNode(i){return this.getNodeAtHeight(i.position+i.height)}getNextStickyNode(i,o,w){const R=this.getAncestorUnderPrevious(i,o);if(R&&!(R===i&&(!this.nodeIsUncollapsedParent(i)||this.nodeTopAlignsWithStickyNodesBottom(i,w))))return this.createStickyScrollNode(R,w)}nodeTopAlignsWithStickyNodesBottom(i,o){const w=this.getNodeIndex(i),R=this.view.getElementTop(w),L=o;return this.view.scrollTop===R-L}createStickyScrollNode(i,o){const w=this.treeDelegate.getHeight(i),{startIndex:R,endIndex:L}=this.getNodeRange(i),x=this.calculateStickyNodePosition(L,o,w);return{node:i,position:x,height:w,startIndex:R,endIndex:L}}getAncestorUnderPrevious(i,o=void 0){let w=i,R=this.getParentNode(w);for(;R;){if(R===o)return w;w=R,R=this.getParentNode(w)}if(o===void 0)return w}calculateStickyNodePosition(i,o,w){let R=this.view.getRelativeTop(i);if(R===null&&this.view.firstVisibleIndex===i&&i+1<this.view.length){const oe=this.treeDelegate.getHeight(this.view.element(i)),pe=this.view.getRelativeTop(i+1);R=pe?pe-oe/this.view.renderHeight:null}if(R===null)return o;const L=this.view.element(i),x=this.treeDelegate.getHeight(L),Q=R*this.view.renderHeight+x;return o+w>Q&&o<=Q?Q-w:o}constrainStickyNodes(i){if(i.length===0)return[];const o=this.view.renderHeight*this.maxWidgetViewRatio,w=i[i.length-1];if(i.length<=this.stickyScrollMaxItemCount&&w.position+w.height<=o)return i;const R=this.stickyScrollDelegate.constrainStickyScrollNodes(i,this.stickyScrollMaxItemCount,o);if(!R.length)return[];const L=R[R.length-1];if(R.length>this.stickyScrollMaxItemCount||L.position+L.height>o)throw new Error("stickyScrollDelegate violates constraints");return R}getParentNode(i){const o=this.model.getNodeLocation(i),w=this.model.getParentNodeLocation(o);return w?this.model.getNode(w):void 0}nodeIsUncollapsedParent(i){const o=this.model.getNodeLocation(i);return this.model.getListRenderCount(o)>1}getNodeIndex(i){const o=this.model.getNodeLocation(i);return this.model.getListIndex(o)}getNodeRange(i){const o=this.model.getNodeLocation(i),w=this.model.getListIndex(o);if(w<0)throw new Error("Node not found in tree");const R=this.model.getListRenderCount(o),L=w+R-1;return{startIndex:w,endIndex:L}}nodePositionTopBelowWidget(i){const o=[];let w=this.getParentNode(i);for(;w;)o.push(w),w=this.getParentNode(w);let R=0;for(let L=0;L<o.length&&L<this.stickyScrollMaxItemCount;L++)R+=this.treeDelegate.getHeight(o[L]);return R}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const o=this.validateStickySettings(i);this.stickyScrollMaxItemCount!==o.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=o.stickyScrollMaxItemCount,this.update())}validateStickySettings(i){let o=7;return typeof i.stickyScrollMaxItemCount=="number"&&(o=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:o}}}class X{constructor(i,o,w,R,L,x){this.view=o,this.tree=w,this.treeRenderers=R,this.treeDelegate=L,this.accessibilityProvider=x,this._previousElements=[],this._previousStateDisposables=new m.DisposableStore,this._rootDomNode=(0,S.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this._rootDomNode);const V=(0,S.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(V),this.stickyScrollFocus=new j(this._rootDomNode,o),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const i=this._previousState.stickyNodes[this._previousState.count-1];return i.position+i.height}get count(){return this._previousState?.count??0}getNode(i){return this._previousState?.stickyNodes.find(o=>o.node===i)}setState(i){const o=!!this._previousState&&this._previousState.count>0,w=!!i&&i.count>0;if(!o&&!w||o&&w&&this._previousState.equal(i))return;if(o!==w&&this.setVisible(w),!w){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const R=i.stickyNodes[i.count-1];if(this._previousState&&i.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${R.position}px`;else{this._previousStateDisposables.clear();const L=Array(i.count);for(let x=i.count-1;x>=0;x--){const V=i.stickyNodes[x],{element:Q,disposable:oe}=this.createElement(V,x,i.count);L[x]=Q,this._rootDomNode.appendChild(Q),this._previousStateDisposables.add(oe)}this.stickyScrollFocus.updateElements(L,i),this._previousElements=L}this._previousState=i,this._rootDomNode.style.height=`${R.position+R.height}px`}createElement(i,o,w){const R=i.startIndex,L=document.createElement("div");L.style.top=`${i.position}px`,L.style.height=`${i.height}px`,L.style.lineHeight=`${i.height}px`,L.classList.add("monaco-tree-sticky-row"),L.classList.add("monaco-list-row"),L.setAttribute("data-index",`${R}`),L.setAttribute("data-parity",R%2===0?"even":"odd"),L.setAttribute("id",this.view.getElementID(R)),this.setAccessibilityAttributes(L,i.node.element,o,w);const x=this.treeDelegate.getTemplateId(i.node),V=this.treeRenderers.find(ye=>ye.templateId===x);if(!V)throw new Error(`No renderer found for template id ${x}`);let Q=i.node;Q===this.tree.getNode(this.tree.getNodeLocation(i.node))&&(Q=new Proxy(i.node,{}));const oe=V.renderTemplate(L);V.renderElement(Q,i.startIndex,oe,i.height);const pe=(0,m.toDisposable)(()=>{V.disposeElement(Q,i.startIndex,oe,i.height),V.disposeTemplate(oe),L.remove()});return{element:L,disposable:pe}}setAccessibilityAttributes(i,o,w,R){if(!this.accessibilityProvider)return;this.accessibilityProvider.getSetSize&&i.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(o,w,R))),this.accessibilityProvider.getPosInSet&&i.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(o,w))),this.accessibilityProvider.getRole&&i.setAttribute("role",this.accessibilityProvider.getRole(o)??"treeitem");const L=this.accessibilityProvider.getAriaLabel(o);L&&i.setAttribute("aria-label",L);const x=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(o);typeof x=="number"&&i.setAttribute("aria-level",`${x}`),i.setAttribute("aria-selected",String(!1))}setVisible(i){this._rootDomNode.classList.toggle("empty",!i),i||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class j extends m.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(i){i!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(i),this._domHasFocus=i)}constructor(i,o){super(),this.container=i,this.view=o,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new D.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new D.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this.container.addEventListener("focus",()=>this.onFocus()),this.container.addEventListener("blur",()=>this.onBlur()),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(w=>this.onKeyDown(w))),this._register(this.view.onMouseDown(w=>this.onMouseDown(w))),this._register(this.view.onContextMenu(w=>this.handleContextMenu(w)))}handleContextMenu(i){const o=i.browserEvent.target;if(!(0,b.isStickyScrollContainer)(o)&&!(0,b.isStickyScrollElement)(o)){this.focusedLast()&&this.view.domFocus();return}if(!(0,S.isKeyboardEvent)(i.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const x=this.state.stickyNodes.findIndex(V=>V.node.element===i.element?.element);if(x===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(x);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const R=this.state.stickyNodes[this.focusedIndex].node.element,L=this.elements[this.focusedIndex];this._onContextMenu.fire({element:R,anchor:L,browserEvent:i.browserEvent,isStickyScroll:!0})}onKeyDown(i){if(this.domHasFocus&&this.state){if(i.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const o=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([o]),this.scrollNodeUnderWidget(o,this.state)}else this.setFocusedElement(this.focusedIndex+1);i.preventDefault(),i.stopPropagation()}}}onMouseDown(i){const o=i.browserEvent.target;!(0,b.isStickyScrollContainer)(o)&&!(0,b.isStickyScrollElement)(o)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,o){if(o&&o.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(o&&o.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const w=this.focusedIndex;if(this.removeFocus(),this.elements=i,this.state=o,o){const R=(0,a.clamp)(w,0,o.count-1);this.setFocus(R)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=o?0:-1}setFocusedElement(i){const o=this.state;if(!o)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(i),!(i<o.count-1)&&o.lastNodePartiallyVisible()){const w=o.stickyNodes[i];this.scrollNodeUnderWidget(w.endIndex+1,o)}}scrollNodeUnderWidget(i,o){const w=o.stickyNodes[o.count-1],R=o.count>1?o.stickyNodes[o.count-2]:void 0,L=this.view.getElementTop(i),x=R?R.position+R.height+w.height:w.height;this.view.scrollTop=L-x}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.state&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&i>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const o=this.focusedIndex;o>=0&&this.toggleElementFocus(this.elements[o],!1),i>=0&&this.toggleElementFocus(this.elements[i],!0),this.focusedIndex=i}toggleElementFocus(i,o){i.classList.toggle("focused",o)}toggleStickyScrollFocused(i){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function ie(r){let i=l.TreeMouseEventTarget.Unknown;return(0,S.hasParentWithClass)(r.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=l.TreeMouseEventTarget.Twistie:(0,S.hasParentWithClass)(r.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=l.TreeMouseEventTarget.Element:(0,S.hasParentWithClass)(r.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=l.TreeMouseEventTarget.Filter),{browserEvent:r.browserEvent,element:r.element?r.element.element:null,target:i}}function de(r){const i=(0,b.isStickyScrollContainer)(r.browserEvent.target);return{element:r.element?r.element.element:null,browserEvent:r.browserEvent,anchor:r.anchor,isStickyScroll:i}}function Ee(r,i){i(r),r.children.forEach(o=>Ee(o,i))}class Ie{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(i,o){this.getFirstViewElementWithTrait=i,this.identityProvider=o,this.nodes=[],this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event}set(i,o){!o?.__forceEvent&&(0,t.equals)(this.nodes,i)||this._set(i,!1,o)}_set(i,o,w){if(this.nodes=[...i],this.elements=void 0,this._nodeSet=void 0,!o){const R=this;this._onDidChange.fire({get elements(){return R.get()},browserEvent:w})}}get(){return this.elements||(this.elements=this.nodes.map(i=>i.element)),[...this.elements]}getNodes(){return this.nodes}has(i){return this.nodeSet.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:o}){if(!this.identityProvider){const Q=this.createNodeSet(),oe=pe=>Q.delete(pe);o.forEach(pe=>Ee(pe,oe)),this.set([...Q.values()]);return}const w=new Set,R=Q=>w.add(this.identityProvider.getId(Q.element).toString());o.forEach(Q=>Ee(Q,R));const L=new Map,x=Q=>L.set(this.identityProvider.getId(Q.element).toString(),Q);i.forEach(Q=>Ee(Q,x));const V=[];for(const Q of this.nodes){const oe=this.identityProvider.getId(Q.element).toString();if(!w.has(oe))V.push(Q);else{const ye=L.get(oe);ye&&ye.visible&&V.push(ye)}}if(this.nodes.length>0&&V.length===0){const Q=this.getFirstViewElementWithTrait();Q&&V.push(Q)}this._set(V,!0)}createNodeSet(){const i=new Set;for(const o of this.nodes)i.add(o);return i}}class Ce extends b.MouseController{constructor(i,o,w){super(i),this.tree=o,this.stickyScrollProvider=w}onViewPointer(i){if((0,b.isButton)(i.browserEvent.target)||(0,b.isInputElement)(i.browserEvent.target)||(0,b.isMonacoEditor)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const o=i.element;if(!o)return super.onViewPointer(i);if(this.isSelectionRangeChangeEvent(i)||this.isSelectionSingleChangeEvent(i))return super.onViewPointer(i);const w=i.browserEvent.target,R=w.classList.contains("monaco-tl-twistie")||w.classList.contains("monaco-icon-label")&&w.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,L=(0,b.isStickyScrollElement)(i.browserEvent.target);let x=!1;if(L?x=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?x=this.tree.expandOnlyOnTwistieClick(o.element):x=!!this.tree.expandOnlyOnTwistieClick,L)this.handleStickyScrollMouseEvent(i,o);else{if(x&&!R&&i.browserEvent.detail!==2)return super.onViewPointer(i);if(!this.tree.expandOnDoubleClick&&i.browserEvent.detail===2)return super.onViewPointer(i)}if(o.collapsible&&(!L||R)){const V=this.tree.getNodeLocation(o),Q=i.browserEvent.altKey;if(this.tree.setFocus([V]),this.tree.toggleCollapsed(V,Q),x&&R){i.browserEvent.isHandledByList=!0;return}}L||super.onViewPointer(i)}handleStickyScrollMouseEvent(i,o){if((0,b.isMonacoCustomToggle)(i.browserEvent.target)||(0,b.isActionItem)(i.browserEvent.target))return;const w=this.stickyScrollProvider();if(!w)throw new Error("Sticky scroll controller not found");const R=this.list.indexOf(o),L=this.list.getElementTop(R),x=w.nodePositionTopBelowWidget(o);this.tree.scrollTop=L-x,this.list.domFocus(),this.list.setFocus([R]),this.list.setSelection([R])}onDoubleClick(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||i.browserEvent.isHandledByList||super.onDoubleClick(i)}onMouseDown(i){const o=i.browserEvent.target;if(!(0,b.isStickyScrollContainer)(o)&&!(0,b.isStickyScrollElement)(o)){super.onMouseDown(i);return}}onContextMenu(i){const o=i.browserEvent.target;if(!(0,b.isStickyScrollContainer)(o)&&!(0,b.isStickyScrollElement)(o)){super.onContextMenu(i);return}}}class K extends b.List{constructor(i,o,w,R,L,x,V,Q){super(i,o,w,R,Q),this.focusTrait=L,this.selectionTrait=x,this.anchorTrait=V}createMouseController(i){return new Ce(this,i.tree,i.stickyScrollProvider)}splice(i,o,w=[]){if(super.splice(i,o,w),w.length===0)return;const R=[],L=[];let x;w.forEach((V,Q)=>{this.focusTrait.has(V)&&R.push(i+Q),this.selectionTrait.has(V)&&L.push(i+Q),this.anchorTrait.has(V)&&(x=i+Q)}),R.length>0&&super.setFocus((0,t.distinct)([...super.getFocus(),...R])),L.length>0&&super.setSelection((0,t.distinct)([...super.getSelection(),...L])),typeof x=="number"&&super.setAnchor(x)}setFocus(i,o,w=!1){super.setFocus(i,o),w||this.focusTrait.set(i.map(R=>this.element(R)),o)}setSelection(i,o,w=!1){super.setSelection(i,o),w||this.selectionTrait.set(i.map(R=>this.element(R)),o)}setAnchor(i,o=!1){super.setAnchor(i),o||(typeof i>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(i)]))}}var f;(function(r){r[r.Tree=0]="Tree",r[r.StickyScroll=1]="StickyScroll"})(f||(e.AbstractTreePart=f={}));class C{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return D.Event.map(this.view.onMouseClick,ie)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.view.onMouseDblClick,ie),i=>i.target!==l.TreeMouseEventTarget.Filter)}get onContextMenu(){return D.Event.any(D.Event.filter(D.Event.map(this.view.onContextMenu,de),i=>!i.isStickyScroll),this.stickyScrollController?.onContextMenu??D.Event.None)}get onTap(){return D.Event.map(this.view.onTap,ie)}get onPointer(){return D.Event.map(this.view.onPointer,ie)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??te.Highlight}set findMode(i){this.findController&&(this.findController.mode=i)}get findMatchType(){return this.findController?.matchType??ge.Fuzzy}set findMatchType(i){this.findController&&(this.findController.matchType=i)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(i,o,w,R,L={}){this._user=i,this._options=L,this.eventBufferer=new D.EventBufferer,this.onDidChangeFindOpenState=D.Event.None,this.onDidChangeStickyScrollFocused=D.Event.None,this.disposables=new m.DisposableStore,this._onWillRefilter=new D.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new D.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new B(w);const x=new D.Relay,V=new D.Relay,Q=this.disposables.add(new P(V.event)),oe=new c.SetMap;this.renderers=R.map(De=>new M(De,()=>this.model,x.event,Q,oe,L));for(const De of this.renderers)this.disposables.add(De);let pe;L.keyboardNavigationLabelProvider&&(pe=new Y(this,L.keyboardNavigationLabelProvider,L.filter),L={...L,filter:pe},this.disposables.add(pe)),this.focus=new Ie(()=>this.view.getFocusedElements()[0],L.identityProvider),this.selection=new Ie(()=>this.view.getSelectedElements()[0],L.identityProvider),this.anchor=new Ie(()=>this.view.getAnchorElement(),L.identityProvider),this.view=new K(i,o,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{..._(()=>this.model,L),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(i,this.view,L),x.input=this.model.onDidChangeCollapseState;const ye=D.Event.forEach(this.model.onDidSplice,De=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(De),this.selection.onDidModelSplice(De)})},this.disposables);ye(()=>null,null,this.disposables);const we=this.disposables.add(new D.Emitter),Ae=this.disposables.add(new s.Delayer(0));if(this.disposables.add(D.Event.any(ye,this.focus.onDidChange,this.selection.onDidChange)(()=>{Ae.trigger(()=>{const De=new Set;for(const Fe of this.focus.getNodes())De.add(Fe);for(const Fe of this.selection.getNodes())De.add(Fe);we.fire([...De.values()])})})),V.input=we.event,L.keyboardSupport!==!1){const De=D.Event.chain(this.view.onKeyDown,Fe=>Fe.filter(Pe=>!(0,b.isInputElement)(Pe.target)).map(Pe=>new n.StandardKeyboardEvent(Pe)));D.Event.chain(De,Fe=>Fe.filter(Pe=>Pe.keyCode===15))(this.onLeftArrow,this,this.disposables),D.Event.chain(De,Fe=>Fe.filter(Pe=>Pe.keyCode===17))(this.onRightArrow,this,this.disposables),D.Event.chain(De,Fe=>Fe.filter(Pe=>Pe.keyCode===10))(this.onSpace,this,this.disposables)}if((L.findWidgetEnabled??!0)&&L.keyboardNavigationLabelProvider&&L.contextViewProvider){const De=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new Le(this,this.model,this.view,pe,L.contextViewProvider,De),this.focusNavigationFilter=Fe=>this.findController.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;L.enableStickyScroll&&(this.stickyScrollController=new re(this,this.model,this.view,this.renderers,this.treeDelegate,L),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,S.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===T.Always)}updateOptions(i={}){this._options={...this._options,...i};for(const o of this.renderers)o.updateOptions(i);this.view.updateOptions(this._options),this.findController?.updateOptions(i),this.updateStickyScroll(i),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===T.Always)}get options(){return this._options}updateStickyScroll(i){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new re(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=D.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(i)}updateWidth(i){const o=this.model.getListIndex(i);o!==-1&&this.view.updateWidth(o)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(i){this.view.scrollTop=i}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(i){this.view.scrollLeft=i}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let i=this.view.firstVisibleIndex;return this.stickyScrollController&&(i+=this.stickyScrollController.count),i<0||i>=this.view.length?void 0:this.view.element(i).element}get lastVisibleElement(){const i=this.view.lastVisibleIndex;return this.view.element(i).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(i){this.view.ariaLabel=i}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,S.isActiveElement)(this.getHTMLElement())}layout(i,o){this.view.layout(i,o),(0,E.isNumber)(o)&&this.findController?.layout(o)}style(i){const o=`.${this.view.domId}`,w=[];i.treeIndentGuidesStroke&&(w.push(`.monaco-list${o}:hover .monaco-tl-indent > .indent-guide, .monaco-list${o}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),w.push(`.monaco-list${o} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const R=(0,S.asCssValueWithDefault)(i.listFocusAndSelectionOutline,(0,S.asCssValueWithDefault)(i.listSelectionOutline,i.listFocusOutline??""));R&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${R}; outline-offset: -1px;}`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=w.join(`
`),this.view.style(i)}getParentElement(i){const o=this.model.getParentNodeLocation(i);return this.model.getNode(o).element}getFirstElementChild(i){return this.model.getFirstElementChild(i)}getNode(i){return this.model.getNode(i)}getNodeLocation(i){return this.model.getNodeLocation(i)}collapse(i,o=!1){return this.model.setCollapsed(i,!0,o)}expand(i,o=!1){return this.model.setCollapsed(i,!1,o)}toggleCollapsed(i,o=!1){return this.model.setCollapsed(i,void 0,o)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(i){return this.model.isCollapsible(i)}setCollapsible(i,o){return this.model.setCollapsible(i,o)}isCollapsed(i){return this.model.isCollapsed(i)}expandTo(i){this.model.expandTo(i)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(i){if(typeof i>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const o=this.model.getNode(i);this.anchor.set([o]);const w=this.model.getListIndex(i);w>-1&&this.view.setAnchor(w,!0)})}getAnchor(){return(0,t.firstOrDefault)(this.anchor.get(),void 0)}setSelection(i,o){this.eventBufferer.bufferEvents(()=>{const w=i.map(L=>this.model.getNode(L));this.selection.set(w,o);const R=i.map(L=>this.model.getListIndex(L)).filter(L=>L>-1);this.view.setSelection(R,o,!0)})}getSelection(){return this.selection.get()}setFocus(i,o){this.eventBufferer.bufferEvents(()=>{const w=i.map(L=>this.model.getNode(L));this.focus.set(w,o);const R=i.map(L=>this.model.getListIndex(L)).filter(L=>L>-1);this.view.setFocus(R,o,!0)})}focusNext(i=1,o=!1,w,R=(0,S.isKeyboardEvent)(w)&&w.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(i,o,w,R)}focusPrevious(i=1,o=!1,w,R=(0,S.isKeyboardEvent)(w)&&w.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(i,o,w,R)}focusNextPage(i,o=(0,S.isKeyboardEvent)(i)&&i.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(i,o)}focusPreviousPage(i,o=(0,S.isKeyboardEvent)(i)&&i.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(i,o,()=>this.stickyScrollController?.height??0)}focusLast(i,o=(0,S.isKeyboardEvent)(i)&&i.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(i,o)}focusFirst(i,o=(0,S.isKeyboardEvent)(i)&&i.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(i,o)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const i=this.stickyScrollController?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?1:0}reveal(i,o){this.model.expandTo(i);const w=this.model.getListIndex(i);if(w!==-1)if(!this.stickyScrollController)this.view.reveal(w,o);else{const R=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(i));this.view.reveal(w,o,R)}}getRelativeTop(i){const o=this.model.getListIndex(i);if(o===-1)return null;const w=this.stickyScrollController?.getNode(this.getNode(i));return this.view.getRelativeTop(o,w?.position??this.stickyScrollController?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new l.TreeError(this._user,"Can't get tree view state without an identity provider");const o=x=>i.getId(x).toString(),w=z.empty(this.scrollTop);for(const x of this.getFocus())w.focus.add(o(x));for(const x of this.getSelection())w.selection.add(o(x));const R=this.model.getNode(),L=[R];for(;L.length>0;){const x=L.shift();x!==R&&x.collapsible&&(w.expanded[o(x.element)]=x.collapsed?0:1),L.push(...x.children)}return w}onLeftArrow(i){i.preventDefault(),i.stopPropagation();const o=this.view.getFocusedElements();if(o.length===0)return;const w=o[0],R=this.model.getNodeLocation(w);if(!this.model.setCollapsed(R,!0)){const x=this.model.getParentNodeLocation(R);if(!x)return;const V=this.model.getListIndex(x);this.view.reveal(V),this.view.setFocus([V])}}onRightArrow(i){i.preventDefault(),i.stopPropagation();const o=this.view.getFocusedElements();if(o.length===0)return;const w=o[0],R=this.model.getNodeLocation(w);if(!this.model.setCollapsed(R,!1)){if(!w.children.some(Q=>Q.visible))return;const[x]=this.view.getFocus(),V=x+1;this.view.reveal(V),this.view.setFocus([V])}}onSpace(i){i.preventDefault(),i.stopPropagation();const o=this.view.getFocusedElements();if(o.length===0)return;const w=o[0],R=this.model.getNodeLocation(w),L=i.browserEvent.altKey;this.model.setCollapsed(R,void 0,L)}navigate(i){return new I(this.view,this.model,i)}dispose(){(0,m.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}e.AbstractTree=C;class I{constructor(i,o,w){this.view=i,this.model=o,w?this.index=this.model.getListIndex(w):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[134],be([1,0,133,125,26,28]),function(se,e,S,F,n,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTree=void 0;class y extends S.AbstractTree{constructor(p,b,v,O,l,d={}){super(p,b,v,O,d),this.user=p,this.dataSource=l,this.nodesByIdentity=new Map,this.identityProvider=d.identityProvider}getInput(){return this.input}setInput(p,b){if(b&&!this.identityProvider)throw new n.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=p,!p){this.nodesByIdentity.clear(),this.model.setChildren(null,U.Iterable.empty());return}if(!b){this._refresh(p);return}const v=[],O=[],l=t=>{const s=this.identityProvider.getId(t).toString();return!b.expanded[s]},d=t=>{const s=this.identityProvider.getId(t.element).toString();b.focus.has(s)&&v.push(t.element),b.selection.has(s)&&O.push(t.element)};this._refresh(p,l,d),this.setFocus(v),this.setSelection(O),b&&typeof b.scrollTop=="number"&&(this.scrollTop=b.scrollTop)}updateChildren(p=this.input){if(typeof this.input>"u")throw new n.TreeError(this.user,"Tree input not set");let b;this.identityProvider&&(b=v=>{const O=this.identityProvider.getId(v).toString(),l=this.nodesByIdentity.get(O);if(l)return l.collapsed}),this._refresh(p,b)}resort(p=this.input,b=!0){this.model.resort(p===this.input?null:p,b)}refresh(p){if(p===void 0){this.view.rerender();return}this.model.rerender(p)}_refresh(p,b,v){let O;if(this.identityProvider){const l=new Set,d=v;v=t=>{const s=this.identityProvider.getId(t.element).toString();l.add(s),this.nodesByIdentity.set(s,t),d?.(t)},O=t=>{const s=this.identityProvider.getId(t.element).toString();l.has(s)||this.nodesByIdentity.delete(s)}}this.model.setChildren(p===this.input?null:p,this.iterate(p,b).elements,{onDidCreateNode:v,onDidDeleteNode:O})}iterate(p,b){const v=[...this.dataSource.getChildren(p)];return{elements:U.Iterable.map(v,l=>{const{elements:d,size:t}=this.iterate(l,b),s=this.dataSource.hasChildren?this.dataSource.hasChildren(l):void 0,h=t===0?void 0:b&&b(l);return{element:l,children:d,collapsible:s,collapsed:h}}),size:v.length}}createModel(p,b,v){return new F.ObjectTreeModel(p,b,v)}}e.DataTree=y}),define(me[69],be([1,0,12,9,35,30,27,6,4,3,55,10,7]),function(se,e,S,F,n,U,y,A,p,b,v,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(d||(d={}));function t(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function h(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(g||(g={}));function c(le){let J=0;for(let ae=0;;ae+=7){const re=le.read(1);if(J|=(re.buffer[0]&127)<<ae,!(re.buffer[0]&128))return J}}const D=k(0);function u(le,J){if(J===0){le.write(D);return}let ae=0;for(let X=J;X!==0;X=X>>>7)ae++;const re=n.VSBuffer.alloc(ae);for(let X=0;J!==0;X++)re.buffer[X]=J&127,J=J>>>7,J>0&&(re.buffer[X]|=128);le.write(re)}class m{constructor(J){this.buffer=J,this.pos=0}read(J){const ae=this.buffer.slice(this.pos,this.pos+J);return this.pos+=ae.byteLength,ae}}e.BufferReader=m;class a{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(J){this.buffers.push(J)}}e.BufferWriter=a;var E;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(E||(E={}));function k(le){const J=n.VSBuffer.alloc(1);return J.writeUInt8(le,0),J}const N={Undefined:k(E.Undefined),String:k(E.String),Buffer:k(E.Buffer),VSBuffer:k(E.VSBuffer),Array:k(E.Array),Object:k(E.Object),Uint:k(E.Int)},H=typeof Buffer<"u";function W(le,J){if(typeof J>"u")le.write(N.Undefined);else if(typeof J=="string"){const ae=n.VSBuffer.fromString(J);le.write(N.String),u(le,ae.byteLength),le.write(ae)}else if(H&&Buffer.isBuffer(J)){const ae=n.VSBuffer.wrap(J);le.write(N.Buffer),u(le,ae.byteLength),le.write(ae)}else if(J instanceof n.VSBuffer)le.write(N.VSBuffer),u(le,J.byteLength),le.write(J);else if(Array.isArray(J)){le.write(N.Array),u(le,J.length);for(const ae of J)W(le,ae)}else if(typeof J=="number"&&(J|0)===J)le.write(N.Uint),u(le,J);else{const ae=n.VSBuffer.fromString(JSON.stringify(J));le.write(N.Object),u(le,ae.byteLength),le.write(ae)}}e.serialize=W;function _(le){switch(le.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return le.read(c(le)).toString();case E.Buffer:return le.read(c(le)).buffer;case E.VSBuffer:return le.read(c(le));case E.Array:{const ae=c(le),re=[];for(let X=0;X<ae;X++)re.push(_(le));return re}case E.Object:return JSON.parse(le.read(c(le)).toString());case E.Int:return c(le)}}e.deserialize=_;class B{constructor(J,ae,re=null,X=1e3){this.protocol=J,this.ctx=ae,this.logger=re,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:200})}registerChannel(J,ae){this.channels.set(J,ae),setTimeout(()=>this.flushPendingRequests(J),0)}sendResponse(J){switch(J.type){case 200:{const ae=this.send([J.type]);this.logger?.logOutgoing(ae,0,1,h(J.type));return}case 201:case 202:case 204:case 203:{const ae=this.send([J.type,J.id],J.data);this.logger?.logOutgoing(ae,J.id,1,h(J.type),J.data);return}}}send(J,ae=void 0){const re=new a;return W(re,J),W(re,ae),this.sendBuffer(re.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onRawMessage(J){const ae=new m(J),re=_(ae),X=_(ae),j=re[0];switch(j){case 100:return this.logger?.logIncoming(J.byteLength,re[1],1,`${t(j)}: ${re[2]}.${re[3]}`,X),this.onPromise({type:j,id:re[1],channelName:re[2],name:re[3],arg:X});case 102:return this.logger?.logIncoming(J.byteLength,re[1],1,`${t(j)}: ${re[2]}.${re[3]}`,X),this.onEventListen({type:j,id:re[1],channelName:re[2],name:re[3],arg:X});case 101:return this.logger?.logIncoming(J.byteLength,re[1],1,`${t(j)}`),this.disposeActiveRequest({type:j,id:re[1]});case 103:return this.logger?.logIncoming(J.byteLength,re[1],1,`${t(j)}`),this.disposeActiveRequest({type:j,id:re[1]})}}onPromise(J){const ae=this.channels.get(J.channelName);if(!ae){this.collectPendingRequest(J);return}const re=new U.CancellationTokenSource;let X;try{X=ae.call(this.ctx,J.name,J.arg,re.token)}catch(de){X=Promise.reject(de)}const j=J.id;X.then(de=>{this.sendResponse({id:j,data:de,type:201})},de=>{de instanceof Error?this.sendResponse({id:j,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.sendResponse({id:j,data:de,type:203})}).finally(()=>{ie.dispose(),this.activeRequests.delete(J.id)});const ie=(0,b.toDisposable)(()=>re.cancel());this.activeRequests.set(J.id,ie)}onEventListen(J){const ae=this.channels.get(J.channelName);if(!ae){this.collectPendingRequest(J);return}const re=J.id,j=ae.listen(this.ctx,J.name,J.arg)(ie=>this.sendResponse({id:re,data:ie,type:204}));this.activeRequests.set(J.id,j)}disposeActiveRequest(J){const ae=this.activeRequests.get(J.id);ae&&(ae.dispose(),this.activeRequests.delete(J.id))}collectPendingRequest(J){let ae=this.pendingRequests.get(J.channelName);ae||(ae=[],this.pendingRequests.set(J.channelName,ae));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.sendResponse({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ae.push({request:J,timeoutTimer:re})}flushPendingRequests(J){const ae=this.pendingRequests.get(J);if(ae){for(const re of ae)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(J)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=B;var z;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(z||(e.RequestInitiator=z={}));class T{constructor(J,ae=null){this.protocol=J,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=ae}getChannel(J){const ae=this;return{call(re,X,j){return ae.isDisposed?Promise.reject(new A.CancellationError):ae.requestPromise(J,re,X,j)},listen(re,X){return ae.isDisposed?p.Event.None:ae.requestEvent(J,re,X)}}}requestPromise(J,ae,re,X=U.CancellationToken.None){const j=this.lastRequestId++,de={id:j,type:100,channelName:J,name:ae,arg:re};if(X.isCancellationRequested)return Promise.reject(new A.CancellationError);let Ee;return new Promise((Ce,K)=>{if(X.isCancellationRequested)return K(new A.CancellationError);const f=()=>{const i=o=>{switch(o.type){case 201:this.handlers.delete(j),Ce(o.data);break;case 202:{this.handlers.delete(j);const w=new Error(o.data.message);w.stack=Array.isArray(o.data.stack)?o.data.stack.join(`
`):o.data.stack,w.name=o.data.name,K(w);break}case 203:this.handlers.delete(j),K(o.data);break}};this.handlers.set(j,i),this.sendRequest(de)};let C=null;this.state===g.Idle?f():(C=(0,F.createCancelablePromise)(i=>this.whenInitialized()),C.then(()=>{C=null,f()}));const I=()=>{C?(C.cancel(),C=null):this.sendRequest({id:j,type:101}),K(new A.CancellationError)},r=X.onCancellationRequested(I);Ee=(0,b.combinedDisposable)((0,b.toDisposable)(I),r),this.activeRequests.add(Ee)}).finally(()=>{Ee.dispose(),this.activeRequests.delete(Ee)})}requestEvent(J,ae,re){const X=this.lastRequestId++,ie={id:X,type:102,channelName:J,name:ae,arg:re};let de=null;const Ee=new p.Emitter({onWillAddFirstListener:()=>{de=(0,F.createCancelablePromise)(Ce=>this.whenInitialized()),de.then(()=>{de=null,this.activeRequests.add(Ee),this.sendRequest(ie)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.activeRequests.delete(Ee),this.sendRequest({id:X,type:103}))}}),Ie=Ce=>Ee.fire(Ce.data);return this.handlers.set(X,Ie),Ee.event}sendRequest(J){switch(J.type){case 100:case 102:{const ae=this.send([J.type,J.id,J.channelName,J.name],J.arg);this.logger?.logOutgoing(ae,J.id,0,`${t(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const ae=this.send([J.type,J.id]);this.logger?.logOutgoing(ae,J.id,0,t(J.type));return}}}send(J,ae=void 0){const re=new a;return W(re,J),W(re,ae),this.sendBuffer(re.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onBuffer(J){const ae=new m(J),re=_(ae),X=_(ae),j=re[0];switch(j){case 200:return this.logger?.logIncoming(J.byteLength,0,0,h(j)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(J.byteLength,re[1],0,h(j),X),this.onResponse({type:re[0],id:re[1],data:X})}}onResponse(J){if(J.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(J.id)?.(J)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=T,Ye([y.memoize],T.prototype,"onDidInitializePromise",null);class P{get connections(){const J=[];return this._connections.forEach(ae=>J.push(ae)),J}constructor(J){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new b.DisposableStore,this.disposables.add(J(({protocol:ae,onDidClientDisconnect:re})=>{const X=p.Event.once(ae.onMessage);this.disposables.add(X(j=>{const ie=new m(j),de=_(ie),Ee=new B(ae,de),Ie=new T(ae);this.channels.forEach((K,f)=>Ee.registerChannel(f,K));const Ce={channelServer:Ee,channelClient:Ie,ctx:de};this._connections.add(Ce),this._onDidAddConnection.fire(Ce),this.disposables.add(re(()=>{Ee.dispose(),Ie.dispose(),this._connections.delete(Ce),this._onDidRemoveConnection.fire(Ce)}))}))}))}getChannel(J,ae){const re=this;return{call(X,j,ie){let de;if((0,l.isFunction)(ae)){const Ie=(0,S.getRandomElement)(re.connections.filter(ae));de=Ie?Promise.resolve(Ie):p.Event.toPromise(p.Event.filter(re.onDidAddConnection,ae))}else de=ae.routeCall(re,X,j);const Ee=de.then(Ie=>Ie.channelClient.getChannel(J));return Y(Ee).call(X,j,ie)},listen(X,j){if((0,l.isFunction)(ae))return re.getMulticastEvent(J,ae,X,j);const ie=ae.routeEvent(re,X,j).then(de=>de.channelClient.getChannel(J));return Y(ie).listen(X,j)}}}getMulticastEvent(J,ae,re,X){const j=this;let ie;const de=new p.Emitter({onWillAddFirstListener:()=>{ie=new b.DisposableStore;const Ee=new p.EventMultiplexer,Ie=new Map,Ce=f=>{const I=f.channelClient.getChannel(J).listen(re,X),r=Ee.add(I);Ie.set(f,r)},K=f=>{const C=Ie.get(f);C&&(C.dispose(),Ie.delete(f))};j.connections.filter(ae).forEach(Ce),p.Event.filter(j.onDidAddConnection,ae)(Ce,void 0,ie),j.onDidRemoveConnection(K,void 0,ie),Ee.event(de.fire,de,ie),ie.add(Ee)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return de.event}registerChannel(J,ae){this.channels.set(J,ae);for(const re of this._connections)re.channelServer.registerChannel(J,ae)}dispose(){this.disposables.dispose();for(const J of this._connections)J.channelClient.dispose(),J.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class M{constructor(J,ae,re=null){const X=new a;W(X,ae),J.send(X.buffer),this.channelClient=new T(J,re),this.channelServer=new B(J,ae,re)}getChannel(J){return this.channelClient.getChannel(J)}registerChannel(J,ae){this.channelServer.registerChannel(J,ae)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function Y(le){return{call(J,ae,re){return le.then(X=>X.call(J,ae,re))},listen(J,ae){const re=new p.Relay;return le.then(X=>re.input=X.listen(J,ae)),re.event}}}e.getDelayedChannel=Y;function Z(le){let J=!1;return{call(ae,re,X){return J?le.call(ae,re,X):(0,F.timeout)(0).then(()=>J=!0).then(()=>le.call(ae,re,X))},listen(ae,re){if(J)return le.listen(ae,re);const X=new p.Relay;return(0,F.timeout)(0).then(()=>J=!0).then(()=>X.input=le.listen(ae,re)),X.event}}}e.getNextTickChannel=Z;class fe{constructor(J){this.fn=J}routeCall(J){return this.route(J)}routeEvent(J){return this.route(J)}async route(J){for(const ae of J.connections)if(await Promise.resolve(this.fn(ae.ctx)))return Promise.resolve(ae);return await p.Event.toPromise(J.onDidAddConnection),await this.route(J)}}e.StaticRouter=fe;var ce;(function(le){function J(j,ie,de){const Ee=j,Ie=de&&de.disableMarshalling,Ce=new Map;for(const K in Ee)re(K)&&Ce.set(K,p.Event.buffer(Ee[K],!0,void 0,ie));return new class{listen(K,f,C){const I=Ce.get(f);if(I)return I;if(X(f)){const r=Ee[f];if(typeof r=="function")return r.call(Ee,C)}throw new A.ErrorNoTelemetry(`Event not found: ${f}`)}call(K,f,C){const I=Ee[f];if(typeof I=="function"){if(!Ie&&Array.isArray(C))for(let i=0;i<C.length;i++)C[i]=(0,v.revive)(C[i]);let r=I.apply(Ee,C);return r instanceof Promise||(r=Promise.resolve(r)),r}throw new A.ErrorNoTelemetry(`Method not found: ${f}`)}}}le.fromService=J;function ae(j,ie){const de=ie&&ie.disableMarshalling;return new Proxy({},{get(Ee,Ie){if(typeof Ie=="string")return ie?.properties?.has(Ie)?ie.properties.get(Ie):X(Ie)?function(Ce){return j.listen(Ie,Ce)}:re(Ie)?j.listen(Ie):async function(...Ce){let K;ie&&!(0,l.isUndefinedOrNull)(ie.context)?K=[ie.context,...Ce]:K=Ce;const f=await j.call(Ie,K);return de?f:(0,v.revive)(f)};throw new A.ErrorNoTelemetry(`Property not found: ${String(Ie)}`)}})}le.toService=ae;function re(j){return j[0]==="o"&&j[1]==="n"&&O.isUpperAsciiLetter(j.charCodeAt(2))}function X(j){return/^onDynamic/.test(j)&&O.isUpperAsciiLetter(j.charCodeAt(9))}})(ce||(e.ProxyChannel=ce={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const J=le.toString();if(J!=="[object Object]")return J}return le}function ke(le){return Array.isArray(le)?le.map(ge):ge(le)}function Le(le,J,ae,re,X,j,ie){ie=ke(ie);const de=te[X],Ee=de[re%de.length];let Ie=[`%c[${le}]%c[${String(J).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${Ee}`];/\($/.test(j)?(Ie=Ie.concat(ie),Ie.push(")")):Ie.push(ie),console.log.apply(console,Ie)}class Be{constructor(J,ae){this._outgoingPrefix=J,this._incomingPrefix=ae,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(J,ae,re,X,j){this._totalOutgoing+=J,Le(this._outgoingPrefix,this._totalOutgoing,J,ae,re,X,j)}logIncoming(J,ae,re,X,j){this._totalIncoming+=J,Le(this._incomingPrefix,this._totalIncoming,J,ae,re,X,j)}}e.IPCLogger=Be}),define(me[135],be([1,0,35,4,69,92,31]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0;class A extends n.IPCClient{static createProtocol(){const b=F.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(v,O)=>S.VSBuffer.wrap(O));return y.ipcRenderer.send("vscode:hello"),new U.Protocol(y.ipcRenderer,b)}constructor(b){const v=A.createProtocol();super(v,b),this.protocol=v}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=A}),define(me[136],be([13,11]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(me[137],be([13,11]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(me[43],be([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function A(p){return p[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=A})(S||(e._util=S={})),e.IInstantiationService=n("instantiationService");function F(y,A,p){A[S.DI_TARGET]===A?A[S.DI_DEPENDENCIES].push({id:y,index:p}):(A[S.DI_DEPENDENCIES]=[{id:y,index:p}],A[S.DI_TARGET]=A)}function n(y){if(S.serviceIds.has(y))return S.serviceIds.get(y);const A=function(p,b,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(A,p,v)};return A.toString=()=>y,S.serviceIds.set(y,A),A}e.createDecorator=n;function U(y){return y}e.refineServiceDecorator=U}),define(me[138],be([1,0,43]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function F(U){return!!U.hostName&&!!U.errorMessage}e.isRemoteDiagnosticError=F;class n{async getPerformanceInfo(y,A){return{}}async getSystemInfo(y,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,A){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}e.NullDiagnosticsService=n}),define(me[139],be([1,0,90,24,10,7,15,136,43,5,32,22]),function(se,e,S,F,n,U,y,A,p,b,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function l(X){return X.create===!0}e.isFileOpenForWriteOptions=l;var d;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var t;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(t||(e.FilePermission=t={}));function s(X){const j=X;return!!j&&typeof j.onDidChange=="function"}e.isFileSystemWatcher=s;var h;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function g(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=g;function c(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=c;function D(X){return!!(X.capabilities&131072)}e.hasFileCloneCapability=D;function u(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function m(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=m;function a(X){return g(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=a;function E(X){return g(X)?!!(X.capabilities&32768):!1}e.hasFileAtomicWriteCapability=E;function k(X){return!!(X.capabilities&65536)}e.hasFileAtomicDeleteCapability=k;function N(X){return!!(X.capabilities&2048)}e.hasReadonlyCapability=N;var H;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(H||(e.FileSystemProviderErrorCode=H={}));class W extends Error{static create(j,ie){const de=new W(j.toString(),ie);return z(de,ie),de}constructor(j,ie){super(j),this.code=ie}}e.FileSystemProviderError=W;function _(X,j){return W.create(X,j)}e.createFileSystemProviderError=_;function B(X){return X||_((0,A.localize)(0,null),H.Unknown)}e.ensureFileSystemProviderError=B;function z(X,j){return X.name=j?`${j} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=z;function T(X){if(!X)return H.Unknown;if(X instanceof W)return X.code;const j=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!j)return H.Unknown;switch(j[1]){case H.FileExists:return H.FileExists;case H.FileIsADirectory:return H.FileIsADirectory;case H.FileNotADirectory:return H.FileNotADirectory;case H.FileNotFound:return H.FileNotFound;case H.FileTooLarge:return H.FileTooLarge;case H.FileWriteLocked:return H.FileWriteLocked;case H.NoPermissions:return H.NoPermissions;case H.Unavailable:return H.Unavailable}return H.Unknown}e.toFileSystemProviderErrorCode=T;function P(X){if(X instanceof te)return X.fileOperationResult;switch(T(X)){case H.FileNotFound:return 1;case H.FileIsADirectory:return 0;case H.FileNotADirectory:return 9;case H.FileWriteLocked:return 5;case H.NoPermissions:return 6;case H.FileExists:return 4;case H.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=P;var M;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class Y{constructor(j,ie,de){this.resource=j,this.operation=ie,this.target=de}isOperation(j){return this.operation===j}}e.FileOperationEvent=Y;var Z;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(Z||(e.FileChangeType=Z={}));class fe{static{this.MIXED_CORRELATION=null}constructor(j,ie){this.ignorePathCasing=ie,this.correlationId=void 0,this.added=new O.Lazy(()=>{const de=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return de.fill(this.rawAdded.map(Ee=>[Ee,!0])),de}),this.updated=new O.Lazy(()=>{const de=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return de.fill(this.rawUpdated.map(Ee=>[Ee,!0])),de}),this.deleted=new O.Lazy(()=>{const de=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return de.fill(this.rawDeleted.map(Ee=>[Ee,!0])),de}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const de of j){switch(de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}this.correlationId!==fe.MIXED_CORRELATION&&(typeof de.cId=="number"?this.correlationId===void 0?this.correlationId=de.cId:this.correlationId!==de.cId&&(this.correlationId=fe.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=fe.MIXED_CORRELATION))}}contains(j,...ie){return this.doContains(j,{includeChildren:!1},...ie)}affects(j,...ie){return this.doContains(j,{includeChildren:!0},...ie)}doContains(j,ie,...de){if(!j)return!1;const Ee=de.length>0;return!!((!Ee||de.includes(1))&&(this.added.value.get(j)||ie.includeChildren&&this.added.value.findSuperstr(j))||(!Ee||de.includes(0))&&(this.updated.value.get(j)||ie.includeChildren&&this.updated.value.findSuperstr(j))||(!Ee||de.includes(2))&&(this.deleted.value.findSubstr(j)||ie.includeChildren&&this.deleted.value.findSuperstr(j)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(j){return this.correlationId===j}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=fe;function ce(X,j,ie){return!X||!j||X===j||j.length>X.length?!1:(j.charAt(j.length-1)!==F.sep&&(j+=F.sep),ie?(0,n.startsWithIgnoreCase)(X,j):X.indexOf(j)===0)}e.isParent=ce;class te extends Error{constructor(j,ie,de){super(j),this.fileOperationResult=ie,this.options=de}}e.FileOperationError=te;class ge extends te{constructor(j,ie,de,Ee){super(j,ie,Ee),this.fileOperationResult=ie,this.size=de}}e.TooLargeFileOperationError=ge;class ke extends te{constructor(j,ie,de){super(j,2,de),this.stat=ie}}e.NotModifiedSinceFileOperationError=ke;var Le;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Le||(e.FileOperationResult=Le={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Be;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(e.FileKind=Be={})),e.ETAG_DISABLED="";function le(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=le;async function J(X,j){if(!j.hasProvider(y.URI.from({scheme:X.scheme})))return new Promise(ie=>{const de=j.onDidChangeFileSystemProviderRegistrations(Ee=>{Ee.scheme===X.scheme&&Ee.added&&(de.dispose(),ie())})})}e.whenProviderRegistered=J;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(j){return(0,U.isNumber)(j)||(j=0),j<ae.KB?(0,A.localize)(1,null,j.toFixed(0)):j<ae.MB?(0,A.localize)(2,null,(j/ae.KB).toFixed(2)):j<ae.GB?(0,A.localize)(3,null,(j/ae.MB).toFixed(2)):j<ae.TB?(0,A.localize)(4,null,(j/ae.GB).toFixed(2)):(0,A.localize)(5,null,(j/ae.TB).toFixed(2))}}e.ByteSize=ae;function re(X){const j=typeof X=="string"||X?.scheme===v.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===v.Schemas.file?1024*ae.MB:j?10*ae.MB:b.isWeb?50*ae.MB:1024*ae.MB}e.getLargeFileConfirmationLimit=re}),define(me[140],be([1,0,43]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,S.createDecorator)("mainProcessService");class F{constructor(U,y){this.server=U,this.router=y}getChannel(U){return this.server.getChannel(U,this.router)}registerChannel(U,y){this.server.registerChannel(U,y)}}e.MainProcessService=F}),define(me[141],be([1,0,3,135]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronIPCMainProcessService=void 0;class n extends S.Disposable{constructor(y){super(),this.mainProcessConnection=this._register(new F.Client(`window:${y}`))}getChannel(y){return this.mainProcessConnection.getChannel(y)}registerChannel(y,A){this.mainProcessConnection.registerChannel(y,A)}}e.ElectronIPCMainProcessService=n});var _i=this&&this.__param||function(se,e){return function(S,F){e(S,F,se)}};define(me[142],be([1,0,69,140]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let n=class{constructor(y,A){return this.windowId=y,S.ProxyChannel.toService(A.getChannel("nativeHost"),{context:y,properties:(()=>{const p=new Map;return p.set("windowId",y),p})()})}};e.NativeHostService=n,e.NativeHostService=n=Ye([_i(1,F.IMainProcessService)],n)}),define(me[70],be([1,0,78,7]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.data=new Map}add(y,A){S.ok(F.isString(y)),S.ok(F.isObject(A)),S.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,A)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new n}),define(me[143],be([1,0,4,70]),function(se,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class U{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,b){this.schemasById[n(p)]=b,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new U;F.Registry.add(e.Extensions.JSONContribution,y)}),define(me[144],be([1,0,9,17,18,4,7,15,137,143,70]),function(se,e,S,F,n,U,y,A,p,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var O;(function(u){function m(a,E){let k=a.defaults;for(;n.ThemeIcon.isThemeIcon(k);){const N=t.getIcon(k.id);if(!N)return;k=N.defaults}return k}u.getDefinition=m})(O||(e.IconContribution=O={}));var l;(function(u){function m(E){return{weight:E.weight,style:E.style,src:E.src.map(k=>({format:k.format,location:k.location.toString()}))}}u.toJSONObject=m;function a(E){const k=N=>(0,y.isString)(N)?N:void 0;if(E&&Array.isArray(E.src)&&E.src.every(N=>(0,y.isString)(N.format)&&(0,y.isString)(N.location)))return{weight:k(E.weight),style:k(E.style),src:E.src.map(N=>({format:N.format,location:A.URI.parse(N.location)}))}}u.fromJSONObject=a})(l||(e.IconFontDefinition=l={}));class d{constructor(){this._onDidChange=new U.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,a,E,k){const N=this.iconsById[m];if(N){if(E&&!N.description){N.description=E,this.iconSchema.properties[m].markdownDescription=`${E} $(${m})`;const _=this.iconReferenceSchema.enum.indexOf(m);_!==-1&&(this.iconReferenceSchema.enumDescriptions[_]=E),this._onDidChange.fire()}return N}const H={id:m,description:E,defaults:a,deprecationMessage:k};this.iconsById[m]=H;const W={$ref:"#/definitions/icons"};return k&&(W.deprecationMessage=k),E&&(W.markdownDescription=`${E}: $(${m})`),this.iconSchema.properties[m]=W,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(E||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const a=this.iconReferenceSchema.enum.indexOf(m);a!==-1&&(this.iconReferenceSchema.enum.splice(a,1),this.iconReferenceSchema.enumDescriptions.splice(a,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,a){const E=this.iconFontsById[m];return E||(this.iconFontsById[m]=a,this._onDidChange.fire(),a)}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(N,H)=>N.id.localeCompare(H.id),a=N=>{for(;n.ThemeIcon.isThemeIcon(N.defaults);)N=this.iconsById[N.defaults.id];return`codicon codicon-${N?N.id:""}`},E=[];E.push("| preview     | identifier                        | default codicon ID                | description"),E.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const k=Object.keys(this.iconsById).map(N=>this.iconsById[N]);for(const N of k.filter(H=>!!H.description).sort(m))E.push(`|<i class="${a(N)}"></i>|${N.id}|${n.ThemeIcon.isThemeIcon(N.defaults)?N.defaults.id:N.id}|${N.description||""}|`);E.push("| preview     | identifier                        "),E.push("| ----------- | --------------------------------- |");for(const N of k.filter(H=>!n.ThemeIcon.isThemeIcon(H.defaults)).sort(m))E.push(`|<i class="${a(N)}"></i>|${N.id}|`);return E.join(`
`)}}const t=new d;v.Registry.add(e.Extensions.IconContribution,t);function s(u,m,a,E){return t.registerIcon(u,m,a,E)}e.registerIcon=s;function h(){return t}e.getIconRegistry=h;function g(){const u=(0,F.getCodiconFontCharacters)();for(const m in u){const a="\\"+u[m].toString(16);t.registerIcon(m,{fontCharacter:a})}}g(),e.iconsSchemaId="vscode://schemas/icons";const c=v.Registry.as(b.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,t.getIconSchema());const D=new S.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{D.isScheduled()||D.schedule()}),e.widgetClose=s("widget-close",F.Codicon.close,(0,p.localize)(2,null)),e.gotoPreviousLocation=s("goto-previous-location",F.Codicon.arrowUp,(0,p.localize)(3,null)),e.gotoNextLocation=s("goto-next-location",F.Codicon.arrowDown,(0,p.localize)(4,null)),e.syncing=n.ThemeIcon.modify(F.Codicon.sync,"spin"),e.spinningLoading=n.ThemeIcon.modify(F.Codicon.loading,"spin")}),define(me[145],be([1,0,2,4,3,18,144]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnthemedProductIconTheme=e.getIconsStyleSheet=void 0;function A(b){const v=new n.DisposableStore,O=v.add(new F.Emitter),l=(0,y.getIconRegistry)();return v.add(l.onDidChange(()=>O.fire())),b&&v.add(b.onDidProductIconThemeChange(()=>O.fire())),{dispose:()=>v.dispose(),onDidChange:O.event,getCSS(){const d=b?b.getProductIconTheme():new p,t={},s=g=>{const c=d.getIcon(g);if(!c)return;const D=c.font;return D?(t[D.id]=D.definition,`.codicon-${g.id}:before { content: '${c.fontCharacter}'; font-family: ${(0,S.asCSSPropertyValue)(D.id)}; }`):`.codicon-${g.id}:before { content: '${c.fontCharacter}'; }`},h=[];for(const g of l.getIcons()){const c=s(g);c&&h.push(c)}for(const g in t){const c=t[g],D=c.weight?`font-weight: ${c.weight};`:"",u=c.style?`font-style: ${c.style};`:"",m=c.src.map(a=>`${(0,S.asCSSUrl)(a.location)} format('${a.format}')`).join(", ");h.push(`@font-face { src: ${m}; font-family: ${(0,S.asCSSPropertyValue)(g)};${D}${u} font-display: block; }`)}return h.join(`
`)}}}e.getIconsStyleSheet=A;class p{getIcon(v){const O=(0,y.getIconRegistry)();let l=v.defaults;for(;U.ThemeIcon.isThemeIcon(l);){const d=O.getIcon(l.id);if(!d)return;l=d.defaults}return l}}e.UnthemedProductIconTheme=p}),define(me[146],be([1,0,5]),function(se,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useNativeFullScreen=e.useWindowControlsOverlay=e.getTitleBarStyle=e.hasNativeTitlebar=e.hasCustomTitlebar=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.isOpenedAuxiliaryWindow=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function F(g){return typeof g.parentId=="number"}e.isOpenedAuxiliaryWindow=F;function n(g){return!!g.workspaceUri}e.isWorkspaceToOpen=n;function U(g){return!!g.folderUri}e.isFolderToOpen=U;function y(g){return!!g.fileUri}e.isFileToOpen=y;function A(g){const c=l(g),D=g.getValue("window.menuBarVisibility");return D==="default"||c&&D==="compact"||S.isMacintosh&&S.isNative?"classic":D}e.getMenuBarVisibility=A;var p;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(p||(e.TitleBarSetting=p={}));var b;(function(g){g.NATIVE="native",g.CUSTOM="custom"})(b||(e.TitlebarStyle=b={}));var v;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(v||(e.CustomTitleBarVisibility=v={}));function O(g,c){return!0}e.hasCustomTitlebar=O;function l(g,c){return c||(c=d(g)),c==="native"}e.hasNativeTitlebar=l;function d(g){if(S.isWeb)return"custom";const c=g.getValue("window");if(c){if(S.isMacintosh&&c.nativeTabs===!0||S.isMacintosh&&c.nativeFullScreen===!1)return"native";const m=c.titleBarStyle;if(m==="native"||m==="custom")return m}return S.isLinux?"native":"custom"}e.getTitleBarStyle=d;function t(g){return!(!S.isWindows||S.isWeb||l(g))}e.useWindowControlsOverlay=t;function s(g){const c=g.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}e.useNativeFullScreen=s;function h(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=h}),define(me[147],be([1,0,16,2,21,31,146]),function(se,e,S,F,n,U,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomOut=e.zoomIn=e.applyZoom=e.MIN_ZOOM_LEVEL=e.MAX_ZOOM_LEVEL=e.ApplyZoomTarget=void 0;var A;(function(l){l[l.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",l[l.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(e.ApplyZoomTarget=A={})),e.MAX_ZOOM_LEVEL=8,e.MIN_ZOOM_LEVEL=-8;function p(l,d){l=Math.min(Math.max(l,e.MIN_ZOOM_LEVEL),e.MAX_ZOOM_LEVEL);const t=[];d===A.ACTIVE_WINDOW?t.push((0,F.getActiveWindow)()):d===A.ALL_WINDOWS?t.push(...Array.from((0,F.getWindows)()).map(({window:s})=>s)):t.push(d);for(const s of t)b(s)?.webFrame?.setZoomLevel(l),(0,S.setZoomFactor)((0,y.zoomLevelToZoomFactor)(l),s),(0,S.setZoomLevel)(l,s)}e.applyZoom=p;function b(l){if(l===n.mainWindow)return{ipcRenderer:U.ipcRenderer,webFrame:U.webFrame};{const d=l;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function v(l){p((0,S.getZoomLevel)(typeof l=="number"?(0,F.getActiveWindow)():l)+1,l)}e.zoomIn=v;function O(l){p((0,S.getZoomLevel)(typeof l=="number"?(0,F.getActiveWindow)():l)-1,l)}e.zoomOut=O}),define(me[148],be([1,0,11,2,134,9,93,31,138,139,141,142,145,147,14,21,106,97]),function(se,e,S,F,n,U,y,A,p,b,v,O,l,d,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startup=void 0;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,g=/\s--inspect-port=(?<port>\d+)/;class c{getHeight(T){return 22}getTemplateId(T){return H(T)?"process":k(T)?"machine":(0,p.isRemoteDiagnosticError)(T)?"error":N(T)?"header":""}}class D{hasChildren(T){return(0,p.isRemoteDiagnosticError)(T)?!1:H(T)?!!T.children?.length:!0}getChildren(T){return H(T)?T.children?T.children:[]:(0,p.isRemoteDiagnosticError)(T)?[]:N(T)?T.processRoots.length>1?T.processRoots:[T.processRoots[0].rootProcess]:k(T)?[T.rootProcess]:[T.processes]}}class u{constructor(){this.templateId="header"}renderTemplate(T){const P=(0,F.append)(T,(0,F.$)(".row")),M=(0,F.append)(P,(0,F.$)(".nameLabel")),Y=(0,F.append)(P,(0,F.$)(".cpu")),Z=(0,F.append)(P,(0,F.$)(".memory")),fe=(0,F.append)(P,(0,F.$)(".pid"));return{name:M,CPU:Y,memory:Z,PID:fe}}renderElement(T,P,M,Y){M.name.textContent=(0,S.localize)(0,null),M.CPU.textContent=(0,S.localize)(1,null),M.PID.textContent=(0,S.localize)(2,null),M.memory.textContent=(0,S.localize)(3,null)}disposeTemplate(T){}}class m{constructor(){this.templateId="machine"}renderTemplate(T){const P=Object.create(null),M=(0,F.append)(T,(0,F.$)(".row"));return P.name=(0,F.append)(M,(0,F.$)(".nameLabel")),P}renderElement(T,P,M,Y){M.name.textContent=T.element.name}disposeTemplate(T){}}class a{constructor(){this.templateId="error"}renderTemplate(T){const P=Object.create(null),M=(0,F.append)(T,(0,F.$)(".row"));return P.name=(0,F.append)(M,(0,F.$)(".nameLabel")),P}renderElement(T,P,M,Y){M.name.textContent=T.element.errorMessage}disposeTemplate(T){}}class E{constructor(T,P,M){this.platform=T,this.totalMem=P,this.mapPidToName=M,this.templateId="process"}renderTemplate(T){const P=(0,F.append)(T,(0,F.$)(".row")),M=(0,F.append)(P,(0,F.$)(".nameLabel")),Y=(0,F.append)(P,(0,F.$)(".cpu")),Z=(0,F.append)(P,(0,F.$)(".memory")),fe=(0,F.append)(P,(0,F.$)(".pid"));return{name:M,CPU:Y,PID:fe,memory:Z}}renderElement(T,P,M,Y){const{element:Z}=T,fe=Z.pid.toFixed(0);let ce=Z.name;this.mapPidToName.has(Z.pid)&&(ce=this.mapPidToName.get(Z.pid)),M.name.textContent=ce,M.name.title=Z.cmd,M.CPU.textContent=Z.load.toFixed(0),M.PID.textContent=fe,M.PID.parentElement.id=`pid-${fe}`;const te=this.platform==="win32"?Z.mem:this.totalMem*(Z.mem/100);M.memory.textContent=(te/b.ByteSize.MB).toFixed(0)}disposeTemplate(T){}}function k(z){return!!z.name&&!!z.rootProcess}function N(z){return!!z.processRoots}function H(z){return!!z.pid}class W{constructor(T,P){this.data=P,this.mapPidToName=new Map;const M=new v.ElectronIPCMainProcessService(T);this.nativeHostService=new O.NativeHostService(T,M),this.applyStyles(P.styles),this.setEventHandlers(P),A.ipcRenderer.on("vscode:pidToNameResponse",(Y,Z)=>{this.mapPidToName.clear();for(const[fe,ce]of Z)this.mapPidToName.set(fe,ce)}),A.ipcRenderer.on("vscode:listProcessesResponse",async(Y,Z)=>{Z.forEach((fe,ce)=>{H(fe.rootProcess)&&(fe.rootProcess.name=ce===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:Z}}),this.tree.layout(s.mainWindow.innerHeight,s.mainWindow.innerWidth)):await this.createProcessTree(Z),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(T){s.mainWindow.document.onkeydown=P=>{const M=T.platform==="darwin"?P.metaKey:P.ctrlKey;M&&P.keyCode===87&&(P.stopPropagation(),P.preventDefault(),A.ipcRenderer.send("vscode:closeProcessExplorer")),M&&P.keyCode===187&&(0,d.zoomIn)(s.mainWindow),M&&P.keyCode===189&&(0,d.zoomOut)(s.mainWindow)}}async createProcessTree(T){const P=s.mainWindow.document.getElementById("process-list");if(!P)return;const{totalmem:M}=await this.nativeHostService.getOSStatistics(),Y=[new E(this.data.platform,M,this.mapPidToName),new u,new m,new a];this.tree=new n.DataTree("processExplorer",P,new c,Y,new D,{identityProvider:{getId:Z=>H(Z)?Z.pid.toString():(0,p.isRemoteDiagnosticError)(Z)?Z.hostName:N(Z)?"processes":k(Z)?Z.name:"header"}}),this.tree.setInput({processes:{processRoots:T}}),this.tree.layout(s.mainWindow.innerHeight,s.mainWindow.innerWidth),this.tree.onKeyDown(Z=>{const fe=new t.StandardKeyboardEvent(Z);if(fe.keyCode===35&&fe.altKey){const ce=this.getSelectedPids();Promise.all(ce.map(te=>this.nativeHostService.killProcess(te,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(Z=>{H(Z.element)&&this.showContextMenu(Z.element,!0)}),P.style.height=`${s.mainWindow.innerHeight}px`,s.mainWindow.addEventListener("resize",()=>{P.style.height=`${s.mainWindow.innerHeight}px`,this.tree?.layout(s.mainWindow.innerHeight,s.mainWindow.innerWidth)})}isDebuggable(T){const P=h.exec(T);return P&&P.groups.port!=="0"||T.indexOf("node ")>=0||T.indexOf("node.exe")>=0}attachTo(T){const P={type:"node",request:"attach",name:`process ${T.pid}`};let M=h.exec(T.cmd);M?P.port=Number(M.groups.port):P.processId=String(T.pid),M=g.exec(T.cmd),M&&(P.port=Number(M.groups.port)),A.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[P]})}applyStyles(T){const P=(0,F.createStyleSheet)(),M=[];T.listFocusBackground&&(M.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&M.push(`.monaco-list:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(M.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&M.push(`.monaco-list:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listHoverBackground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${T.listHoverForeground}; }`),T.listFocusOutline&&M.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&M.push(`.monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.scrollbarShadowColor&&M.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${T.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),T.scrollbarSliderBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${T.scrollbarSliderBackgroundColor};
				}
			`),T.scrollbarSliderHoverBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${T.scrollbarSliderHoverBackgroundColor};
				}
			`),T.scrollbarSliderActiveBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${T.scrollbarSliderActiveBackgroundColor};
				}
			`),P.textContent=M.join(`
`),T.color&&(s.mainWindow.document.body.style.color=T.color)}showContextMenu(T,P){const M=[],Y=Number(T.pid);P&&(M.push({accelerator:"Alt+E",label:(0,S.localize)(4,null),click:()=>{this.nativeHostService.killProcess(Y,"SIGTERM")}}),M.push({label:(0,S.localize)(5,null),click:()=>{this.nativeHostService.killProcess(Y,"SIGKILL")}}),M.push({type:"separator"})),M.push({label:(0,S.localize)(6,null),click:()=>{const Z=this.getSelectedPids();Z?.includes(Y)||(Z.length=0,Z.push(Y));const fe=Z?.map(ce=>s.mainWindow.document.getElementById(`pid-${ce}`)).filter(ce=>!!ce);if(fe){const ce=fe.map(te=>te.innerText).filter(te=>!!te);this.nativeHostService.writeClipboardText(ce.join(`
`))}}}),M.push({label:(0,S.localize)(7,null),click:()=>{const Z=s.mainWindow.document.getElementById("process-list");Z&&this.nativeHostService.writeClipboardText(Z.innerText)}}),T&&P&&this.isDebuggable(T.cmd)&&(M.push({type:"separator"}),M.push({label:(0,S.localize)(8,null),click:()=>{this.attachTo(T)}})),(0,y.popup)(M)}requestProcessList(T){setTimeout(()=>{const P=Date.now(),M=T+P-this.lastRequestTime;this.lastRequestTime=P,M>1e3?(A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(M)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(T=>{if(!(!T||!("pid"in T)))return T.pid}).filter(T=>!!T)}}function _(){const z=(0,F.createStyleSheet)();z.id="codiconStyles";const T=(0,l.getIconsStyleSheet)(void 0);function P(){z.textContent=T.getCSS()}const M=new U.RunOnceScheduler(P,0);T.onDidChange(()=>M.schedule()),M.schedule()}function B(z){const T=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";s.mainWindow.document.body.classList.add(T),_(),(0,d.applyZoom)(z.data.zoomLevel,s.mainWindow),new W(z.windowId,z.data)}e.startup=B})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
