/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],A=0,O=G.length;A<O;A++)e[A]=ie[G[A]];return e};define(ie[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class A{static get(){const k=new Map,N=new Map,T=new Map,b=new Map;function f(m,S){m.has(S.detail)||m.set(S.detail,-S.timestamp)}function a(m,S){const C=m.get(S.detail);C&&(C>=0||m.set(S.detail,C+S.timestamp))}let y=[];typeof G=="function"&&typeof G.getStats=="function"&&(y=G.getStats().slice(0).sort((m,S)=>m.timestamp-S.timestamp));for(const m of y)switch(m.type){case 10:f(k,m);break;case 11:case 12:a(k,m);break;case 21:f(N,m);break;case 22:a(N,m);break;case 33:f(T,m);break;case 34:a(T,m);break;case 31:f(b,m);break;case 32:a(b,m);break}let P=0;T.forEach(m=>P+=m);function d(m){const S=[];return m.forEach((C,E)=>S.push([E,C])),S}return{amdLoad:d(k),amdInvoke:d(N),nodeRequire:d(T),nodeEval:d(b),nodeRequireTotal:P}}static toMarkdownTable(k,N){let T="";const b=[];return k.forEach((f,a)=>{b[a]=f.length}),N.forEach(f=>{f.forEach((a,y)=>{typeof a>"u"&&(a=f[y]="-");const P=a.toString().length;b[y]=Math.max(P,b[y])})}),k.forEach((f,a)=>{T+=`| ${f+" ".repeat(b[a]-f.toString().length)} `}),T+=`|
`,k.forEach((f,a)=>{T+=`| ${"-".repeat(b[a])} `}),T+=`|
`,N.forEach(f=>{f.forEach((a,y)=>{typeof a<"u"&&(T+=`| ${a+" ".repeat(b[y]-a.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=A}),define(ie[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function A(T){return(b,f,a)=>{let y=null,P=null;if(typeof a.value=="function"?(y="value",P=a.value):typeof a.get=="function"&&(y="get",P=a.get),!P)throw new Error("not supported");a[y]=T(P,f)}}function O(T,b,f){let a=null,y=null;if(typeof f.value=="function"?(a="value",y=f.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",y=f.get),!y)throw new Error("not supported");const P=`$memoize$${b}`;f[a]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[P]}}e.memoize=O;function k(T,b,f){return A((a,y)=>{const P=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...m){this[d]||(this[d]=f?f():void 0),clearTimeout(this[P]),b&&(this[d]=b(this[d],...m),m=[this[d]]),this[P]=setTimeout(()=>{a.apply(this,m),this[d]=f?f():void 0},T)}})}e.debounce=k;function N(T,b,f){return A((a,y)=>{const P=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,S=`$throttle$pending$${y}`;return function(...C){if(this[d]||(this[d]=f?f():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),b&&(this[d]=b(this[d],...C)),this[S])return;const E=this[m]+T;E<=Date.now()?(this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=f?f():void 0):(this[S]=!0,this[P]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=f?f():void 0},E-Date.now()))}})}e.throttle=N}),define(ie[71],ne([0,1,7]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function O(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=O;function k(a,y="Unreachable"){throw new Error(y)}e.assertNever=k;function N(a){if(!a)throw new A.BugIndicatingError("Assertion Failed")}e.assert=N;function T(a){a||(0,A.onUnexpectedError)(new A.BugIndicatingError("Soft Assertion Failed"))}e.softAssert=T;function b(a){if(!a()){debugger;a(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}e.assertFn=b;function f(a,y){let P=0;for(;P<a.length-1;){const d=a[P],m=a[P+1];if(!y(d,m))return!1;P++}return!0}e.checkAdjacentItems=f}),define(ie[38],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var A;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var N;(function(i){i.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function T(i,s=!1){let t=0;const n=i.length;let r="",o=0,c=16,R=0;function D(se){let fe=0,de=0;for(;fe<se;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)de=de*16+ae-48;else if(ae>=65&&ae<=70)de=de*16+ae-65+10;else if(ae>=97&&ae<=102)de=de*16+ae-97+10;else break;t++,fe++}return fe<se&&(de=-1),de}function w(se){t=se,r="",o=0,c=16,R=0}function L(){const se=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return R=3,i.substring(se,t);let fe=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;fe=t}else R=3;return i.substring(se,fe)}function W(){let se="",fe=t;for(;;){if(t>=n){se+=i.substring(fe,t),R=2;break}const de=i.charCodeAt(t);if(de===34){se+=i.substring(fe,t),t++;break}if(de===92){if(se+=i.substring(fe,t),t++,t>=n){R=2;break}switch(i.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const z=D(4);z>=0?se+=String.fromCharCode(z):R=4;break}default:R=5}fe=t;continue}if(de>=0&&de<=31)if(f(de)){se+=i.substring(fe,t),R=2;break}else R=6;t++}return se}function J(){if(r="",R=0,o=t,t>=n)return o=n,c=17;let se=i.charCodeAt(t);if(b(se)){do t++,r+=String.fromCharCode(se),se=i.charCodeAt(t);while(b(se));return c=15}if(f(se))return t++,r+=String.fromCharCode(se),se===13&&i.charCodeAt(t)===10&&(t++,r+=`
`),c=14;switch(se){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,r=W(),c=10;case 47:{const fe=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!f(i.charCodeAt(t));)t++;return r=i.substring(fe,t),c=12}if(i.charCodeAt(t+1)===42){t+=2;const de=n-1;let ae=!1;for(;t<de;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,R=1),r=i.substring(fe,t),c=13}return r+=String.fromCharCode(se),t++,c=16}case 45:if(r+=String.fromCharCode(se),t++,t===n||!a(i.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),c=11;default:for(;t<n&&X(se);)t++,se=i.charCodeAt(t);if(o!==t){switch(r=i.substring(o,t),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(se),t++,c=16}}function X(se){if(b(se)||f(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=J();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:s?oe:J,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>R}}e.createScanner=T;function b(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function P(i,s){const t=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function R(D,w,L,W){o.value=D,o.offset=w,o.length=L,o.type=W,o.colonOffset=void 0,r=o}try{p(i,{onObjectBegin:(D,w)=>{if(s<=D)throw n;r=void 0,c=s>D,t.push("")},onObjectProperty:(D,w,L)=>{if(s<w||(R(D,w,L,"property"),t[t.length-1]=D,s<=w+L))throw n},onObjectEnd:(D,w)=>{if(s<=D)throw n;r=void 0,t.pop()},onArrayBegin:(D,w)=>{if(s<=D)throw n;r=void 0,t.push(0)},onArrayEnd:(D,w)=>{if(s<=D)throw n;r=void 0,t.pop()},onLiteralValue:(D,w,L)=>{if(s<w||(R(D,w,L,g(D)),s<=w+L))throw n},onSeparator:(D,w,L)=>{if(s<=w)throw n;if(D===":"&&r&&r.type==="property")r.colonOffset=w,c=!1,r=void 0;else if(D===","){const W=t[t.length-1];typeof W=="number"?t[t.length-1]=W+1:(c=!0,t[t.length-1]=""),r=void 0}}})}catch(D){if(D!==n)throw D}return{path:t,previousNode:r,isAtPropertyKey:c,matches:D=>{let w=0;for(let L=0;w<D.length&&L<t.length;L++)if(D[w]===t[L]||D[w]==="*")w++;else if(D[w]!=="**")return!1;return w===D.length}}}e.getLocation=P;function d(i,s=[],t=N.DEFAULT){let n=null,r=[];const o=[];function c(D){Array.isArray(r)?r.push(D):n!==null&&(r[n]=D)}return p(i,{onObjectBegin:()=>{const D={};c(D),o.push(r),r=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const D=[];c(D),o.push(r),r=D,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:c,onError:(D,w,L)=>{s.push({error:D,offset:w,length:L})}},t),r[0]}e.parse=d;function m(i,s=[],t=N.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function o(D){return n.children.push(D),D}p(i,{onObjectBegin:D=>{n=o({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,w,L)=>{n=o({type:"property",offset:w,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:w,length:L,parent:n})},onObjectEnd:(D,w)=>{n.length=D+w-n.offset,n=n.parent,r(D+w)},onArrayBegin:(D,w)=>{n=o({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,w)=>{n.length=D+w-n.offset,n=n.parent,r(D+w)},onLiteralValue:(D,w,L)=>{o({type:g(D),offset:w,length:L,parent:n,value:D}),r(w+L)},onSeparator:(D,w,L)=>{n.type==="property"&&(D===":"?n.colonOffset=w:D===","&&r(w))},onError:(D,w,L)=>{s.push({error:D,offset:w,length:L})}},t);const R=n.children[0];return R&&delete R.parent,R}e.parseTree=m;function S(i,s){if(!i)return;let t=i;for(const n of s)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=S;function C(i){if(!i.parent||!i.parent.children)return[];const s=C(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=C;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const s=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(s[t.children[0].value]=E(n))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function l(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=l;function v(i,s,t=!1){if(l(i,s,t)){const n=i.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=v(n[r],s,t);if(o)return o}return i}}e.findNodeAtOffset=v;function p(i,s,t=N.DEFAULT){const n=T(i,!1);function r(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?Z=>Y(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=r(s.onObjectBegin),R=o(s.onObjectProperty),D=r(s.onObjectEnd),w=r(s.onArrayBegin),L=r(s.onArrayEnd),W=o(s.onLiteralValue),J=o(s.onSeparator),X=r(s.onComment),oe=o(s.onError),se=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function de(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:se||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Y){case 12:case 13:se?ae(10):X();break;case 16:ae(1);break;case 15:case 14:break;default:return Y}}}function ae(Y,Z=[],M=[]){if(oe(Y),Z.length+M.length>0){let F=n.getToken();for(;F!==17;){if(Z.indexOf(F)!==-1){de();break}else if(M.indexOf(F)!==-1)break;F=de()}}}function z(Y){const Z=n.getTokenValue();return Y?W(Z):R(Z),de(),!0}function K(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ae(2),Y=0)}catch{ae(2)}W(Y);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return de(),!0}function V(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(z(!1),n.getToken()===6?(J(":"),de(),H()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function _(){c(),de();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),J(","),de(),n.getToken()===2&&fe)break}else Y&&ae(6,[],[]);V()||ae(4,[],[2,5]),Y=!0}return D(),n.getToken()!==2?ae(7,[2],[]):de(),!0}function $(){w(),de();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),J(","),de(),n.getToken()===4&&fe)break}else Y&&ae(6,[],[]);H()||ae(4,[],[4,5]),Y=!0}return L(),n.getToken()!==4?ae(8,[4],[]):de(),!0}function H(){switch(n.getToken()){case 3:return $();case 1:return _();case 10:return z(!0);default:return K()}}return de(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):H()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=p;function u(i,s){const t=T(i),n=[];let r,o=0,c;do switch(c=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:o!==c&&n.push(i.substring(o,c)),s!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,s)),o=t.getPosition();break}while(r!==17);return n.join("")}e.stripComments=u;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ie[72],ne([0,1,38]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(a,y,P){let d,m,S,C,E;if(y){for(C=y.offset,E=C+y.length,S=C;S>0&&!f(a,S-1);)S--;let c=E;for(;c<a.length&&!f(a,c);)c++;m=a.substring(S,c),d=T(m,P)}else m=a,d=0,S=0,C=0,E=a.length;const l=b(P,a);let v=!1,p=0,u;P.insertSpaces?u=N(" ",P.tabSize||4):u="	";const g=(0,A.createScanner)(m,!1);let i=!1;function s(){return l+N(u,d+p)}function t(){let c=g.scan();for(v=!1;c===15||c===14;)v=v||c===14,c=g.scan();return i=c===16||g.getTokenError()!==0,c}const n=[];function r(c,R,D){!i&&R<E&&D>C&&a.substring(R,D)!==c&&n.push({offset:R,length:D-R,content:c})}let o=t();if(o!==17){const c=g.getTokenOffset()+S,R=N(u,d);r(R,S,c)}for(;o!==17;){let c=g.getTokenOffset()+g.getTokenLength()+S,R=t(),D="";for(;!v&&(R===12||R===13);){const L=g.getTokenOffset()+S;r(" ",c,L),c=g.getTokenOffset()+g.getTokenLength()+S,D=R===12?s():"",R=t()}if(R===2)o!==1&&(p--,D=s());else if(R===4)o!==3&&(p--,D=s());else{switch(o){case 3:case 1:p++,D=s();break;case 5:case 12:D=s();break;case 13:v?D=s():D=" ";break;case 6:D=" ";break;case 10:if(R===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?D=" ":R!==5&&R!==17&&(i=!0);break;case 16:i=!0;break}v&&(R===12||R===13)&&(D=s())}const w=g.getTokenOffset()+S;r(D,c,w),o=R}return n}e.format=O;function k(a,y){const P=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?P.replace(/\r\n|\r|\n/g,y.eol):P}e.toFormattedString=k;function N(a,y){let P="";for(let d=0;d<y;d++)P+=a;return P}function T(a,y){let P=0,d=0;const m=y.tabSize||4;for(;P<a.length;){const S=a.charAt(P);if(S===" ")d++;else if(S==="	")d+=m;else break;P++}return Math.floor(d/m)}function b(a,y){for(let P=0;P<y.length;P++){const d=y.charAt(P);if(d==="\r")return P+1<y.length&&y.charAt(P+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}e.getEOL=b;function f(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}e.isEOL=f}),define(ie[73],ne([0,1,38,72]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(a,y,P){return N(a,y,void 0,P)}e.removeProperty=k;function N(a,y,P,d,m){const S=y.slice(),C=[],E=(0,A.parseTree)(a,C);let l,v;for(;S.length>0&&(v=S.pop(),l=(0,A.findNodeAtLocation)(E,S),l===void 0&&P!==void 0);)typeof v=="string"?P={[v]:P}:P=[P];if(l)if(l.type==="object"&&typeof v=="string"&&Array.isArray(l.children)){const p=(0,A.findNodeAtLocation)(l,[v]);if(p!==void 0)if(P===void 0){if(!p.parent)throw new Error("Malformed AST");const u=l.children.indexOf(p.parent);let g,i=p.parent.offset+p.parent.length;if(u>0){const s=l.children[u-1];g=s.offset+s.length}else g=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return T(a,{offset:g,length:i-g,content:""},d)}else return T(a,{offset:p.offset,length:p.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const u=`${JSON.stringify(v)}: ${JSON.stringify(P)}`,g=m?m(l.children.map(s=>s.children[0].value)):l.children.length;let i;if(g>0){const s=l.children[g-1];i={offset:s.offset+s.length,length:0,content:","+u}}else l.children.length===0?i={offset:l.offset+1,length:0,content:u}:i={offset:l.offset+1,length:0,content:u+","};return T(a,i,d)}}else if(l.type==="array"&&typeof v=="number"&&Array.isArray(l.children))if(P!==void 0){const p=`${JSON.stringify(P)}`;let u;if(l.children.length===0||v===0)u={offset:l.offset+1,length:0,content:l.children.length===0?p:p+","};else{const g=v===-1||v>l.children.length?l.children.length:v,i=l.children[g-1];u={offset:i.offset+i.length,length:0,content:","+p}}return T(a,u,d)}else{const p=v,u=l.children[p];let g;if(l.children.length===1)g={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===p){const i=l.children[p-1],s=i.offset+i.length,t=l.offset+l.length;g={offset:s,length:t-2-s,content:""}}else g={offset:u.offset,length:l.children[p+1].offset-u.offset,content:""};return T(a,g,d)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${l.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return T(a,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(P)},d)}}e.setProperty=N;function T(a,y,P){let d=b(a,y),m=y.offset,S=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,O.isEOL)(d,m-1);)m--;for(;S<d.length&&!(0,O.isEOL)(d,S);)S++}const C=(0,O.format)(d,{offset:m,length:S-m},P);for(let l=C.length-1;l>=0;l--){const v=C[l];d=b(d,v),m=Math.min(m,v.offset),S=Math.max(S,v.offset+v.length),S+=v.content.length-v.length}const E=a.length-(d.length-S)-m;return[{offset:m,length:E,content:d.substring(m,S)}]}e.withFormatting=T;function b(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}e.applyEdit=b;function f(a,y){const P=y.slice(0).sort((m,S)=>{const C=m.offset-S.offset;return C===0?m.length-S.length:C});let d=a.length;for(let m=P.length-1;m>=0;m--){const S=P[m];if(S.offset+S.length<=d)a=b(a,S);else throw new Error("Overlapping edit");d=S.offset}return a}e.applyEdits=f}),define(ie[74],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function A(b,f,a){return Math.min(Math.max(b,f),a)}e.clamp=A;function O(b,f){return(f+b%f)%f}e.rot=O;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class N{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class T{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const a=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function G(k){const N=[];typeof k=="number"&&N.push("code/timeOrigin",k);function T(f){N.push(f,Date.now())}function b(){const f=[];for(let a=0;a<N.length;a+=2)f.push({name:N[a],startTime:N[a+1]});return f}return{mark:T,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))N.push({name:T.name,startTime:Math.round(k+T.startTime)});return N}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function A(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=A(O))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var O in A)(typeof exports=="object"?exports:G)[O]=A[O]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function A(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return G[O].call(k.exports,k,k.exports,A),k.l=!0,k.exports}return A.m=G,A.c=e,A.d=function(O,k,N){A.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:N})},A.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},A.t=function(O,k){if(1&k&&(O=A(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(A.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var T in O)A.d(N,T,function(b){return O[b]}.bind(null,T));return N},A.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return A.d(k,"a",k),k},A.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},A.p="",A(A.s=0)}([function(G,e,A){(function(O){var k;e=G.exports=M,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],f=e.src=[],a=0,y=a++;f[y]="0|[1-9]\\d*";var P=a++;f[P]="[0-9]+";var d=a++;f[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=a++;f[m]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var S=a++;f[S]="("+f[P]+")\\.("+f[P]+")\\.("+f[P]+")";var C=a++;f[C]="(?:"+f[y]+"|"+f[d]+")";var E=a++;f[E]="(?:"+f[P]+"|"+f[d]+")";var l=a++;f[l]="(?:-("+f[C]+"(?:\\."+f[C]+")*))";var v=a++;f[v]="(?:-?("+f[E]+"(?:\\."+f[E]+")*))";var p=a++;f[p]="[0-9A-Za-z-]+";var u=a++;f[u]="(?:\\+("+f[p]+"(?:\\."+f[p]+")*))";var g=a++,i="v?"+f[m]+f[l]+"?"+f[u]+"?";f[g]="^"+i+"$";var s="[v=\\s]*"+f[S]+f[v]+"?"+f[u]+"?",t=a++;f[t]="^"+s+"$";var n=a++;f[n]="((?:<|>)?=?)";var r=a++;f[r]=f[P]+"|x|X|\\*";var o=a++;f[o]=f[y]+"|x|X|\\*";var c=a++;f[c]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[l]+")?"+f[u]+"?)?)?";var R=a++;f[R]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[v]+")?"+f[u]+"?)?)?";var D=a++;f[D]="^"+f[n]+"\\s*"+f[c]+"$";var w=a++;f[w]="^"+f[n]+"\\s*"+f[R]+"$";var L=a++;f[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=a++;f[W]="(?:~>?)";var J=a++;f[J]="(\\s*)"+f[W]+"\\s+",b[J]=new RegExp(f[J],"g");var X=a++;f[X]="^"+f[W]+f[c]+"$";var oe=a++;f[oe]="^"+f[W]+f[R]+"$";var se=a++;f[se]="(?:\\^)";var fe=a++;f[fe]="(\\s*)"+f[se]+"\\s+",b[fe]=new RegExp(f[fe],"g");var de=a++;f[de]="^"+f[se]+f[c]+"$";var ae=a++;f[ae]="^"+f[se]+f[R]+"$";var z=a++;f[z]="^"+f[n]+"\\s*("+s+")$|^$";var K=a++;f[K]="^"+f[n]+"\\s*("+i+")$|^$";var V=a++;f[V]="(\\s*)"+f[n]+"\\s*("+s+"|"+f[c]+")",b[V]=new RegExp(f[V],"g");var _=a++;f[_]="^\\s*("+f[c]+")\\s+-\\s+("+f[c]+")\\s*$";var $=a++;f[$]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var H=a++;f[H]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,f[Y]),b[Y]||(b[Y]=new RegExp(f[Y]));function Z(j,Q){if(j instanceof M)return j;if(typeof j!="string"||j.length>N||!(Q?b[t]:b[g]).test(j))return null;try{return new M(j,Q)}catch{return null}}function M(j,Q){if(j instanceof M){if(j.loose===Q)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof M))return new M(j,Q);k("SemVer",j,Q),this.loose=Q;var ee=j.trim().match(Q?b[t]:b[g]);if(!ee)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<T)return ye}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Z,e.valid=function(j,Q){var ee=Z(j,Q);return ee?ee.version:null},e.clean=function(j,Q){var ee=Z(j.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(j){return k("SemVer.compare",this.version,this.loose,j),j instanceof M||(j=new M(j,this.loose)),this.compareMain(j)||this.comparePre(j)},M.prototype.compareMain=function(j){return j instanceof M||(j=new M(j,this.loose)),h(this.major,j.major)||h(this.minor,j.minor)||h(this.patch,j.patch)},M.prototype.comparePre=function(j){if(j instanceof M||(j=new M(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],ge=j.prerelease[Q];if(k("prerelease compare",Q,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return h(ee,ge)}while(++Q)},M.prototype.inc=function(j,Q){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,Q,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new M(j,ee).inc(Q,ge).version}catch{return null}},e.diff=function(j,Q){if(q(j,Q))return null;var ee=Z(j),ge=Z(Q);if(ee.prerelease.length||ge.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return ye},e.compareIdentifiers=h;var F=/^[0-9]+$/;function h(j,Q){var ee=F.test(j),ge=F.test(Q);return ee&&ge&&(j=+j,Q=+Q),ee&&!ge?-1:ge&&!ee?1:j<Q?-1:j>Q?1:0}function I(j,Q,ee){return new M(j,ee).compare(new M(Q,ee))}function x(j,Q,ee){return I(j,Q,ee)>0}function U(j,Q,ee){return I(j,Q,ee)<0}function q(j,Q,ee){return I(j,Q,ee)===0}function B(j,Q,ee){return I(j,Q,ee)!==0}function te(j,Q,ee){return I(j,Q,ee)>=0}function ce(j,Q,ee){return I(j,Q,ee)<=0}function ue(j,Q,ee,ge){var ye;switch(Q){case"===":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),ye=j===ee;break;case"!==":typeof j=="object"&&(j=j.version),typeof ee=="object"&&(ee=ee.version),ye=j!==ee;break;case"":case"=":case"==":ye=q(j,ee,ge);break;case"!=":ye=B(j,ee,ge);break;case">":ye=x(j,ee,ge);break;case">=":ye=te(j,ee,ge);break;case"<":ye=U(j,ee,ge);break;case"<=":ye=ce(j,ee,ge);break;default:throw new TypeError("Invalid operator: "+Q)}return ye}function pe(j,Q){if(j instanceof pe){if(j.loose===Q)return j;j=j.value}if(!(this instanceof pe))return new pe(j,Q);k("comparator",j,Q),this.loose=Q,this.parse(j),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(j,Q){return h(Q,j)},e.major=function(j,Q){return new M(j,Q).major},e.minor=function(j,Q){return new M(j,Q).minor},e.patch=function(j,Q){return new M(j,Q).patch},e.compare=I,e.compareLoose=function(j,Q){return I(j,Q,!0)},e.rcompare=function(j,Q,ee){return I(Q,j,ee)},e.sort=function(j,Q){return j.sort(function(ee,ge){return e.compare(ee,ge,Q)})},e.rsort=function(j,Q){return j.sort(function(ee,ge){return e.rcompare(ee,ge,Q)})},e.gt=x,e.lt=U,e.eq=q,e.neq=B,e.gte=te,e.lte=ce,e.cmp=ue,e.Comparator=pe;var Se={};function he(j,Q){if(j instanceof he)return j.loose===Q?j:new he(j.raw,Q);if(j instanceof pe)return new he(j.value,Q);if(!(this instanceof he))return new he(j,Q);if(this.loose=Q,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function le(j){return!j||j.toLowerCase()==="x"||j==="*"}function ve(j,Q,ee,ge,ye,Oe,Ie,xe,De,Ae,Ue,Re,Te){return((Q=le(ee)?"":le(ge)?">="+ee+".0.0":le(ye)?">="+ee+"."+ge+".0":">="+Q)+" "+(xe=le(De)?"":le(Ae)?"<"+(+De+1)+".0.0":le(Ue)?"<"+De+"."+(+Ae+1)+".0":Re?"<="+De+"."+Ae+"."+Ue+"-"+Re:"<="+xe)).trim()}function Ee(j,Q){for(var ee=0;ee<j.length;ee++)if(!j[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<j.length;ee++)if(k(j[ee].semver),j[ee].semver!==Se&&j[ee].semver.prerelease.length>0){var ge=j[ee].semver;if(ge.major===Q.major&&ge.minor===Q.minor&&ge.patch===Q.patch)return!0}return!1}return!0}function be(j,Q,ee){try{Q=new he(Q,ee)}catch{return!1}return Q.test(j)}function Le(j,Q,ee,ge){var ye,Oe,Ie,xe,De;switch(j=new M(j,ge),Q=new he(Q,ge),ee){case">":ye=x,Oe=ce,Ie=U,xe=">",De=">=";break;case"<":ye=U,Oe=te,Ie=x,xe="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(j,Q,ge))return!1;for(var Ae=0;Ae<Q.set.length;++Ae){var Ue=Q.set[Ae],Re=null,Te=null;if(Ue.forEach(function(Fe){Fe.semver===Se&&(Fe=new pe(">=0.0.0")),Re=Re||Fe,Te=Te||Fe,ye(Fe.semver,Re.semver,ge)?Re=Fe:Ie(Fe.semver,Te.semver,ge)&&(Te=Fe)}),Re.operator===xe||Re.operator===De||(!Te.operator||Te.operator===xe)&&Oe(j,Te.semver)||Te.operator===De&&Ie(j,Te.semver))return!1}return!0}pe.prototype.parse=function(j){var Q=this.loose?b[z]:b[K],ee=j.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+j);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new M(ee[2],this.loose):this.semver=Se},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(j){return k("Comparator.test",j,this.loose),this.semver===Se||(typeof j=="string"&&(j=new M(j,this.loose)),ue(j,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(j,Q){if(!(j instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he(j.value,Q),be(this.value,ee,Q);if(j.operator==="")return ee=new he(this.value,Q),be(j.semver,ee,Q);var ge=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Oe=this.semver.version===j.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),xe=ue(this.semver,"<",j.semver,Q)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),De=ue(this.semver,">",j.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ge||ye||Oe&&Ie||xe||De},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(j){var Q=this.loose;j=j.trim(),k("range",j,Q);var ee=Q?b[$]:b[_];j=j.replace(ee,ve),k("hyphen replace",j),j=j.replace(b[V],"$1$2$3"),k("comparator trim",j,b[V]),j=(j=(j=j.replace(b[J],"$1~")).replace(b[fe],"$1^")).split(/\s+/).join(" ");var ge=Q?b[z]:b[K],ye=j.split(" ").map(function(Oe){return function(Ie,xe){return k("comp",Ie),Ie=function(De,Ae){return De.trim().split(/\s+/).map(function(Ue){return function(Re,Te){k("caret",Re,Te);var Fe=Te?b[ae]:b[de];return Re.replace(Fe,function(Ne,we,Pe,Ce,ke){var Me;return k("caret",Re,Ne,we,Pe,Ce,ke),le(we)?Me="":le(Pe)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":le(Ce)?Me=we==="0"?">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+Ce+ke+" <"+we+"."+Pe+"."+(+Ce+1):">="+we+"."+Pe+"."+Ce+ke+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+Ce+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Me=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+Ce+" <"+we+"."+Pe+"."+(+Ce+1):">="+we+"."+Pe+"."+Ce+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+Ce+" <"+(+we+1)+".0.0"),k("caret return",Me),Me})}(Ue,Ae)}).join(" ")}(Ie,xe),k("caret",Ie),Ie=function(De,Ae){return De.trim().split(/\s+/).map(function(Ue){return function(Re,Te){var Fe=Te?b[oe]:b[X];return Re.replace(Fe,function(Ne,we,Pe,Ce,ke){var Me;return k("tilde",Re,Ne,we,Pe,Ce,ke),le(we)?Me="":le(Pe)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":le(Ce)?Me=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=">="+we+"."+Pe+"."+Ce+ke+" <"+we+"."+(+Pe+1)+".0"):Me=">="+we+"."+Pe+"."+Ce+" <"+we+"."+(+Pe+1)+".0",k("tilde return",Me),Me})}(Ue,Ae)}).join(" ")}(Ie,xe),k("tildes",Ie),Ie=function(De,Ae){return k("replaceXRanges",De,Ae),De.split(/\s+/).map(function(Ue){return function(Re,Te){Re=Re.trim();var Fe=Te?b[w]:b[D];return Re.replace(Fe,function(Ne,we,Pe,Ce,ke,Me){k("xRange",Re,Ne,we,Pe,Ce,ke,Me);var We=le(Pe),_e=We||le(Ce),Ve=_e||le(ke);return we==="="&&Ve&&(we=""),We?Ne=we===">"||we==="<"?"<0.0.0":"*":we&&Ve?(_e&&(Ce=0),Ve&&(ke=0),we===">"?(we=">=",_e?(Pe=+Pe+1,Ce=0,ke=0):Ve&&(Ce=+Ce+1,ke=0)):we==="<="&&(we="<",_e?Pe=+Pe+1:Ce=+Ce+1),Ne=we+Pe+"."+Ce+"."+ke):_e?Ne=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Ne=">="+Pe+"."+Ce+".0 <"+Pe+"."+(+Ce+1)+".0"),k("xRange return",Ne),Ne})}(Ue,Ae)}).join(" ")}(Ie,xe),k("xrange",Ie),Ie=function(De,Ae){return k("replaceStars",De,Ae),De.trim().replace(b[H],"")}(Ie,xe),k("stars",Ie),Ie}(Oe,Q)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Oe){return!!Oe.match(ge)})),ye=ye.map(function(Oe){return new pe(Oe,Q)})},he.prototype.intersects=function(j,Q){if(!(j instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return j.set.some(function(ye){return ye.every(function(Oe){return ge.intersects(Oe,Q)})})})})},e.toComparators=function(j,Q){return new he(j,Q).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},he.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new M(j,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ee(this.set[Q],j))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(j,Q,ee){var ge=null,ye=null;try{var Oe=new he(Q,ee)}catch{return null}return j.forEach(function(Ie){Oe.test(Ie)&&(ge&&ye.compare(Ie)!==-1||(ye=new M(ge=Ie,ee)))}),ge},e.minSatisfying=function(j,Q,ee){var ge=null,ye=null;try{var Oe=new he(Q,ee)}catch{return null}return j.forEach(function(Ie){Oe.test(Ie)&&(ge&&ye.compare(Ie)!==1||(ye=new M(ge=Ie,ee)))}),ge},e.validRange=function(j,Q){try{return new he(j,Q).range||"*"}catch{return null}},e.ltr=function(j,Q,ee){return Le(j,Q,"<",ee)},e.gtr=function(j,Q,ee){return Le(j,Q,">",ee)},e.outside=Le,e.prerelease=function(j,Q){var ee=Z(j,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(j,Q,ee){return j=new he(j,ee),Q=new he(Q,ee),j.intersects(Q)},e.coerce=function(j){if(j instanceof M)return j;if(typeof j!="string")return null;var Q=j.match(b[L]);return Q==null?null:Z((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,A(1))},function(G,e){var A,O,k=G.exports={};function N(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function b(E){if(A===setTimeout)return setTimeout(E,0);if((A===N||!A)&&setTimeout)return A=setTimeout,setTimeout(E,0);try{return A(E,0)}catch{try{return A.call(null,E,0)}catch{return A.call(this,E,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:N}catch{A=N}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var f,a=[],y=!1,P=-1;function d(){y&&f&&(y=!1,f.length?a=f.concat(a):P=-1,a.length&&m())}function m(){if(!y){var E=b(d);y=!0;for(var l=a.length;l;){for(f=a,a=[];++P<l;)f&&f[P].run();P=-1,l=a.length}f=null,y=!1,function(v){if(O===clearTimeout)return clearTimeout(v);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(v);try{O(v)}catch{try{return O.call(null,v)}catch{return O.call(this,v)}}}(E)}}function S(E,l){this.fun=E,this.array=l}function C(){}k.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];a.push(new S(E,l)),a.length!==1||y||b(m)},S.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=C,k.addListener=C,k.once=C,k.off=C,k.removeListener=C,k.removeAllListeners=C,k.emit=C,k.prependListener=C,k.prependOnceListener=C,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(G,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(b,f,a){this.level=b,this.key=f,this.value=a,this.forward=[]}}const k=void 0;class N{constructor(b,f=2**16){this.comparator=b,this[A]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new O(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,k,k),this._size=0}has(b){return!!N._search(this,b,this.comparator)}get(b){return N._search(this,b,this.comparator)?.value}set(b,f){return N._insert(this,b,f,this.comparator)&&(this._size+=1),this}delete(b){const f=N._delete(this,b,this.comparator);return f&&(this._size-=1),f}forEach(b,f){let a=this._header.forward[0];for(;a;)b.call(f,a.value,a.key,this),a=a.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",f=this._header.forward[0];for(;f;)b+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return b}static _search(b,f,a){let y=b._header;for(let P=b._level-1;P>=0;P--)for(;y.forward[P]&&a(y.forward[P].key,f)<0;)y=y.forward[P];if(y=y.forward[0],y&&a(y.key,f)===0)return y}static _insert(b,f,a,y){const P=[];let d=b._header;for(let m=b._level-1;m>=0;m--){for(;d.forward[m]&&y(d.forward[m].key,f)<0;)d=d.forward[m];P[m]=d}if(d=d.forward[0],d&&y(d.key,f)===0)return d.value=a,!1;{const m=N._randomLevel(b);if(m>b._level){for(let S=b._level;S<m;S++)P[S]=b._header;b._level=m}d=new O(m,f,a);for(let S=0;S<m;S++)d.forward[S]=P[S].forward[S],P[S].forward[S]=d;return!0}}static _randomLevel(b,f=.5){let a=1;for(;Math.random()<f&&a<b._maxLevel;)a+=1;return a}static _delete(b,f,a){const y=[];let P=b._header;for(let d=b._level-1;d>=0;d--){for(;P.forward[d]&&a(P.forward[d].key,f)<0;)P=P.forward[d];y[d]=P}if(P=P.forward[0],!P||a(P.key,f)!==0)return!1;for(let d=0;d<b._level&&y[d].forward[d]===P;d++)y[d].forward[d]=P.forward[d];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=N}),define(ie[46],ne([0,1,7,2]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(u){const g=u;return g?typeof g.read=="function":!1}e.isReadable=k;function N(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=N;function T(u){const g=u;return g?N(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=T;function b(u,g){return new f(u,g)}e.newWriteableStream=b;class f{constructor(g,i){this.reducer=g,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(i=>i(g))}emitError(g){this.listeners.error.length===0?(0,A.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(i=>i(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,i){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(g,i){if(this.state.destroyed)return;let s;switch(g){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(u,g){const i=[];let s;for(;(s=u.read())!==null;)i.push(s);return g(i)}e.consumeReadable=a;function y(u,g,i){const s=[];let t;for(;(t=u.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return u.read()}}}e.peekReadable=y;function P(u,g){return new Promise((i,s)=>{const t=[];d(u,{onData:n=>{g&&t.push(n)},onError:n=>{g?s(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.consumeStream=P;function d(u,g,i){u.on("error",s=>{i?.isCancellationRequested||g.onError(s)}),u.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),u.on("data",s=>{i?.isCancellationRequested||g.onData(s)})}e.listenStream=d;function m(u,g){return new Promise((i,s)=>{const t=new O.DisposableStore,n=[],r=R=>{if(n.push(R),n.length>g)return t.dispose(),u.pause(),i({stream:u,buffer:n,ended:!1})},o=R=>(t.dispose(),s(R)),c=()=>(t.dispose(),i({stream:u,buffer:n,ended:!0}));t.add((0,O.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),t.add((0,O.toDisposable)(()=>u.removeListener("end",c))),u.on("end",c),t.add((0,O.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=m;function S(u,g){const i=b(g);return i.end(u),i}e.toStream=S;function C(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=C;function E(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.toReadable=E;function l(u,g,i){const s=b(i);return d(u,{onData:t=>s.write(g.data(t)),onError:t=>s.error(g.error?g.error(t):t),onEnd:()=>s.end()}),s}e.transform=l;function v(u,g,i){let s=!1;return{read:()=>{const t=g.read();return s?t:(s=!0,t!==null?i([u,t]):u)}}}e.prefixedReadable=v;function p(u,g,i){let s=!1;const t=b(i);return d(g,{onData:n=>s?t.write(n):(s=!0,t.write(i([u,n]))),onError:n=>t.error(n),onEnd:()=>{s||(s=!0,t.write(u)),t.end()}}),t}e.prefixedStream=p}),define(ie[14],ne([0,1,166,46]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",N=new A.Lazy(()=>new Uint8Array(256));let T,b;class f{static alloc(L){return k?new f(Buffer.allocUnsafe(L)):new f(new Uint8Array(L))}static wrap(L){return k&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new f(L)}static fromString(L,W){return!(W?.dontUseNodeBuffer||!1)&&k?new f(Buffer.from(L)):(T||(T=new TextEncoder),new f(T.encode(L)))}static fromByteArray(L){const W=f.alloc(L.length);for(let J=0,X=L.length;J<X;J++)W.buffer[J]=L[J];return W}static concat(L,W){if(typeof W>"u"){W=0;for(let oe=0,se=L.length;oe<se;oe++)W+=L[oe].byteLength}const J=f.alloc(W);let X=0;for(let oe=0,se=L.length;oe<se;oe++){const fe=L[oe];J.set(fe,X),X+=fe.byteLength}return J}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=f.alloc(this.byteLength);return L.set(this),L}toString(){return k?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(L,W){return new f(this.buffer.subarray(L,W))}set(L,W){if(L instanceof f)this.buffer.set(L.buffer,W);else if(L instanceof Uint8Array)this.buffer.set(L,W);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),W);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return d(this.buffer,L)}writeUInt32BE(L,W){m(this.buffer,L,W)}readUInt32LE(L){return S(this.buffer,L)}writeUInt32LE(L,W){C(this.buffer,L,W)}readUInt8(L){return E(this.buffer,L)}writeUInt8(L,W){l(this.buffer,L,W)}indexOf(L,W=0){return a(this.buffer,L instanceof f?L.buffer:L,W)}}e.VSBuffer=f;function a(w,L,W=0){const J=L.byteLength,X=w.byteLength;if(J===0)return 0;if(J===1)return w.indexOf(L[0]);if(J>X-W)return-1;const oe=N.value;oe.fill(L.length);for(let ae=0;ae<L.length;ae++)oe[L[ae]]=L.length-ae-1;let se=W+L.length-1,fe=se,de=-1;for(;se<X;)if(w[se]===L[fe]){if(fe===0){de=se;break}se--,fe--}else se+=Math.max(L.length-fe,oe[w[se]]),fe=L.length-1;return de}e.binaryIndexOf=a;function y(w,L){return w[L+0]<<0>>>0|w[L+1]<<8>>>0}e.readUInt16LE=y;function P(w,L,W){w[W+0]=L&255,L=L>>>8,w[W+1]=L&255}e.writeUInt16LE=P;function d(w,L){return w[L]*2**24+w[L+1]*2**16+w[L+2]*2**8+w[L+3]}e.readUInt32BE=d;function m(w,L,W){w[W+3]=L,L=L>>>8,w[W+2]=L,L=L>>>8,w[W+1]=L,L=L>>>8,w[W]=L}e.writeUInt32BE=m;function S(w,L){return w[L+0]<<0>>>0|w[L+1]<<8>>>0|w[L+2]<<16>>>0|w[L+3]<<24>>>0}e.readUInt32LE=S;function C(w,L,W){w[W+0]=L&255,L=L>>>8,w[W+1]=L&255,L=L>>>8,w[W+2]=L&255,L=L>>>8,w[W+3]=L&255}e.writeUInt32LE=C;function E(w,L){return w[L]}e.readUInt8=E;function l(w,L,W){w[W]=L}e.writeUInt8=l;function v(w){return O.consumeReadable(w,L=>f.concat(L))}e.readableToBuffer=v;function p(w){return O.toReadable(w)}e.bufferToReadable=p;function u(w){return O.consumeStream(w,L=>f.concat(L))}e.streamToBuffer=u;async function g(w){return w.ended?f.concat(w.buffer):f.concat([...w.buffer,await u(w.stream)])}e.bufferedStreamToBuffer=g;function i(w){return O.toStream(w,L=>f.concat(L))}e.bufferToStream=i;function s(w){return O.transform(w,{data:L=>typeof L=="string"?f.fromString(L):f.wrap(L)},L=>f.concat(L))}e.streamToBufferReadableStream=s;function t(w){return O.newWriteableStream(L=>f.concat(L),w)}e.newWriteableBufferStream=t;function n(w,L){return O.prefixedReadable(w,L,W=>f.concat(W))}e.prefixedBufferReadable=n;function r(w,L){return O.prefixedStream(w,L,W=>f.concat(W))}e.prefixedBufferStream=r;function o(w){let L=0,W=0,J=0;const X=new Uint8Array(Math.floor(w.length/4*3)),oe=fe=>{switch(W){case 3:X[J++]=L|fe,W=0;break;case 2:X[J++]=L|fe>>>2,L=fe<<6,W=3;break;case 1:X[J++]=L|fe>>>4,L=fe<<4,W=2;break;default:L=fe<<2,W=1}};for(let fe=0;fe<w.length;fe++){const de=w.charCodeAt(fe);if(de>=65&&de<=90)oe(de-65);else if(de>=97&&de<=122)oe(de-97+26);else if(de>=48&&de<=57)oe(de-48+52);else if(de===43||de===45)oe(62);else if(de===47||de===95)oe(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${w[fe]}`)}}const se=J;for(;W>0;)oe(0);return f.wrap(X).slice(0,se)}e.decodeBase64=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:w},L=!0,W=!1){const J=W?R:c;let X="";const oe=w.byteLength%3;let se=0;for(;se<w.byteLength-oe;se+=3){const fe=w[se+0],de=w[se+1],ae=w[se+2];X+=J[fe>>>2],X+=J[(fe<<4|de>>>4)&63],X+=J[(de<<2|ae>>>6)&63],X+=J[ae&63]}if(oe===1){const fe=w[se+0];X+=J[fe>>>2],X+=J[fe<<4&63],L&&(X+="==")}else if(oe===2){const fe=w[se+0],de=w[se+1];X+=J[fe>>>2],X+=J[(fe<<4|de>>>4)&63],X+=J[de<<2&63],L&&(X+="=")}return X}e.encodeBase64=D}),define(ie[43],ne([0,1,30]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(l){return k(l,0)}e.hash=O;function k(l,v){switch(typeof l){case"object":return l===null?N(349,v):Array.isArray(l)?f(l,v):a(l,v);case"string":return b(l,v);case"boolean":return T(l,v);case"number":return N(l,v);case"undefined":return N(937,v);default:return N(617,v)}}e.doHash=k;function N(l,v){return(v<<5)-v+l|0}e.numberHash=N;function T(l,v){return N(l?433:863,v)}function b(l,v){v=N(149417,v);for(let p=0,u=l.length;p<u;p++)v=N(l.charCodeAt(p),v);return v}e.stringHash=b;function f(l,v){return v=N(104579,v),l.reduce((p,u)=>k(u,p),v)}function a(l,v){return v=N(181387,v),Object.keys(l).sort().reduce((p,u)=>(p=b(u,p),k(l[u],p)),v)}class y{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=y;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(l,v,p=32){const u=p-v,g=~((1<<u)-1);return(l<<v|(g&l)>>>u)>>>0}function m(l,v=0,p=l.byteLength,u=0){for(let g=0;g<p;g++)l[v+g]=u}function S(l,v,p="0"){for(;l.length<v;)l=p+l;return l}function C(l,v=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):S((l>>>0).toString(16),v/4)}e.toHexString=C;class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const p=v.length;if(p===0)return;const u=this._buff;let g=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=v.charCodeAt(0),t=0);;){let n=s;if(A.isHighSurrogate(s))if(t+1<p){const r=v.charCodeAt(t+1);A.isLowSurrogate(r)?(t++,n=A.computeCodePoint(s,r)):n=65533}else{i=s;break}else A.isLowSurrogate(s)&&(n=65533);if(g=this._push(u,g,n),t++,t<p)s=v.charCodeAt(t);else break}this._buffLen=g,this._leftoverHighSurrogate=i}_push(v,p,u){return u<128?v[p++]=u:u<2048?(v[p++]=192|(u&1984)>>>6,v[p++]=128|(u&63)>>>0):u<65536?(v[p++]=224|(u&61440)>>>12,v[p++]=128|(u&4032)>>>6,v[p++]=128|(u&63)>>>0):(v[p++]=240|(u&1835008)>>>18,v[p++]=128|(u&258048)>>>12,v[p++]=128|(u&4032)>>>6,v[p++]=128|(u&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,v[0]=v[64],v[1]=v[65],v[2]=v[66]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=E._bigBlock32,p=this._buffDV;for(let c=0;c<64;c+=4)v.setUint32(c,p.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)v.setUint32(c,d(v.getUint32(c-12,!1)^v.getUint32(c-32,!1)^v.getUint32(c-56,!1)^v.getUint32(c-64,!1),1),!1);let u=this._h0,g=this._h1,i=this._h2,s=this._h3,t=this._h4,n,r,o;for(let c=0;c<80;c++)c<20?(n=g&i|~g&s,r=1518500249):c<40?(n=g^i^s,r=1859775393):c<60?(n=g&i|g&s|i&s,r=2400959708):(n=g^i^s,r=3395469782),o=d(u,5)+n+t+r+v.getUint32(c*4,!1)&4294967295,t=s,s=i,i=d(g,30),g=u,u=o;this._h0=this._h0+u&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=E}),define(ie[54],ne([0,1,30]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const N="error",T="warning",b="warn",f="info",a="ignore";function y(d){return d?A.equalsIgnoreCase(N,d)?k.Error:A.equalsIgnoreCase(T,d)||A.equalsIgnoreCase(b,d)?k.Warning:A.equalsIgnoreCase(f,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=y;function P(d){switch(d){case k.Error:return N;case k.Warning:return T;case k.Info:return f;default:return a}}k.toString=P}(O||(O={})),e.default=O}),define(ie[27],ne([0,1,3]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([p,u])=>{v[p]=u&&typeof u=="object"?O(u):u}),v}e.deepClone=O;function k(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const u in p)if(N.call(p,u)){const g=p[u];typeof g=="object"&&!Object.isFrozen(g)&&!(0,A.isTypedArray)(g)&&v.push(g)}}return l}e.deepFreeze=k;const N=Object.prototype.hasOwnProperty;function T(l,v){return b(l,v,new Set)}e.cloneAndChange=T;function b(l,v,p){if((0,A.isUndefinedOrNull)(l))return l;const u=v(l);if(typeof u<"u")return u;if(Array.isArray(l)){const g=[];for(const i of l)g.push(b(i,v,p));return g}if((0,A.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const g={};for(const i in l)N.call(l,i)&&(g[i]=b(l[i],v,p));return p.delete(l),g}return l}function f(l,v,p=!0){return(0,A.isObject)(l)?((0,A.isObject)(v)&&Object.keys(v).forEach(u=>{u in l?p&&((0,A.isObject)(l[u])&&(0,A.isObject)(v[u])?f(l[u],v[u],p):l[u]=v[u]):l[u]=v[u]}),l):v}e.mixin=f;function a(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let p,u;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(p=0;p<l.length;p++)if(!a(l[p],v[p]))return!1}else{const g=[];for(u in l)g.push(u);g.sort();const i=[];for(u in v)i.push(u);if(i.sort(),!a(g,i))return!1;for(p=0;p<g.length;p++)if(!a(l[g[p]],v[g[p]]))return!1}return!0}e.equals=a;function y(l){const v=new Set;return JSON.stringify(l,(p,u)=>{if((0,A.isObject)(u)||Array.isArray(u)){if(v.has(u))return"[Circular]";v.add(u)}return u})}e.safeStringify=y;function P(l,v){const p=Object.create(null);return!l||!v||Object.keys(v).forEach(g=>{const i=l[g],s=v[g];a(i,s)||(p[g]=s)}),p}e.distinct=P;function d(l,v){const p=v.toLowerCase(),u=Object.keys(l).find(g=>g.toLowerCase()===p);return u?l[u]:l[v]}e.getCaseInsensitive=d;function m(l,v){const p=Object.create(null);for(const[u,g]of Object.entries(l))v(u,g)&&(p[u]=g);return p}e.filter=m;function S(l){let v=[];for(;Object.prototype!==l;)v=v.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return v}e.getAllPropertyNames=S;function C(l){const v=[];for(const p of S(l))typeof l[p]=="function"&&v.push(p);return v}e.getAllMethodNames=C;function E(l,v){const p=g=>function(){const i=Array.prototype.slice.call(arguments,0);return v(g,i)},u={};for(const g of l)u[g]=p(g);return u}e.createProxyObject=E}),define(ie[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return A.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let f=0;f<b.length;f++)b[f]=Math.floor(Math.random()*256);return b};const N=new Uint8Array(16),T=[];for(let b=0;b<256;b++)T.push(b.toString(16).padStart(2,"0"));return function(){k(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let f=0,a="";return a+=T[N[f++]],a+=T[N[f++]],a+=T[N[f++]],a+=T[N[f++]],a+="-",a+=T[N[f++]],a+=T[N[f++]],a+="-",a+=T[N[f++]],a+=T[N[f++]],a+="-",a+=T[N[f++]],a+=T[N[f++]],a+="-",a+=T[N[f++]],a+=T[N[f++]],a+=T[N[f++]],a+=T[N[f++]],a+=T[N[f++]],a+=T[N[f++]],a}}()}),define(ie[76],ne([0,1,33]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const b=T.replace(/\-/g,":").toLowerCase();return!O.has(b)}function N(){const T=(0,A.networkInterfaces)();for(const b in T){const f=T[b];if(f){for(const{mac:a}of f)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=N}),define(ie[77],ne([8,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.getDurationString=e.fromNow=void 0;const O=60,k=O*60,N=k*24,T=N*7,b=N*30,f=N*365;function a(d,m,S,C){typeof d!="number"&&(d=d.getTime());const E=Math.round((new Date().getTime()-d)/1e3);if(E<-30)return(0,A.localize)(0,null,a(new Date().getTime()+E*1e3,!1));if(!C&&E<30)return(0,A.localize)(1,null);let l;return E<O?(l=E,m?l===1?S?(0,A.localize)(2,null,l):(0,A.localize)(3,null,l):S?(0,A.localize)(4,null,l):(0,A.localize)(5,null,l):l===1?S?(0,A.localize)(6,null,l):(0,A.localize)(7,null,l):S?(0,A.localize)(8,null,l):(0,A.localize)(9,null,l)):E<k?(l=Math.floor(E/O),m?l===1?S?(0,A.localize)(10,null,l):(0,A.localize)(11,null,l):S?(0,A.localize)(12,null,l):(0,A.localize)(13,null,l):l===1?S?(0,A.localize)(14,null,l):(0,A.localize)(15,null,l):S?(0,A.localize)(16,null,l):(0,A.localize)(17,null,l)):E<N?(l=Math.floor(E/k),m?l===1?S?(0,A.localize)(18,null,l):(0,A.localize)(19,null,l):S?(0,A.localize)(20,null,l):(0,A.localize)(21,null,l):l===1?S?(0,A.localize)(22,null,l):(0,A.localize)(23,null,l):S?(0,A.localize)(24,null,l):(0,A.localize)(25,null,l)):E<T?(l=Math.floor(E/N),m?l===1?(0,A.localize)(26,null,l):(0,A.localize)(27,null,l):l===1?(0,A.localize)(28,null,l):(0,A.localize)(29,null,l)):E<b?(l=Math.floor(E/T),m?l===1?S?(0,A.localize)(30,null,l):(0,A.localize)(31,null,l):S?(0,A.localize)(32,null,l):(0,A.localize)(33,null,l):l===1?S?(0,A.localize)(34,null,l):(0,A.localize)(35,null,l):S?(0,A.localize)(36,null,l):(0,A.localize)(37,null,l)):E<f?(l=Math.floor(E/b),m?l===1?S?(0,A.localize)(38,null,l):(0,A.localize)(39,null,l):S?(0,A.localize)(40,null,l):(0,A.localize)(41,null,l):l===1?S?(0,A.localize)(42,null,l):(0,A.localize)(43,null,l):S?(0,A.localize)(44,null,l):(0,A.localize)(45,null,l)):(l=Math.floor(E/f),m?l===1?S?(0,A.localize)(46,null,l):(0,A.localize)(47,null,l):S?(0,A.localize)(48,null,l):(0,A.localize)(49,null,l):l===1?S?(0,A.localize)(50,null,l):(0,A.localize)(51,null,l):S?(0,A.localize)(52,null,l):(0,A.localize)(53,null,l))}e.fromNow=a;function y(d,m){const S=Math.abs(d/1e3);return S<1?m?(0,A.localize)(54,null,d):(0,A.localize)(55,null,d):S<O?m?(0,A.localize)(56,null,Math.round(d)/1e3):(0,A.localize)(57,null,Math.round(d)/1e3):S<k?m?(0,A.localize)(58,null,Math.round(d/(1e3*O))):(0,A.localize)(59,null,Math.round(d/(1e3*O))):S<N?m?(0,A.localize)(60,null,Math.round(d/(1e3*k))):(0,A.localize)(61,null,Math.round(d/(1e3*k))):(0,A.localize)(62,null,Math.round(d/(1e3*N)))}e.getDurationString=y;function P(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ie[79],ne([8,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(P,d){return d&&(P.stack||P.stacktrace)?k.localize(0,null,b(P),T(P.stack)||T(P.stacktrace)):b(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function f(P=null,d=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const m=A.coalesce(P),S=f(m[0],d);return m.length>1?k.localize(4,null,S,m.length):S}if(O.isString(P))return P;if(P.detail){const m=P.detail;if(m.error)return N(m.error,d);if(m.exception)return N(m.exception,d)}return P.stack?N(P,d):P.message?P.message:k.localize(5,null)}e.toErrorMessage=f;function a(P){const d=P;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=a;function y(P,d){let m;return typeof P=="string"?m=new Error(P):m=P,m.actions=d,m}e.createErrorWithActions=y}),define(ie[80],ne([8,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(ie[55],ne([0,1,12]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function N(b,...f){const a=f.reduce((d,m)=>(d[m]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(d=>!a[d]).forEach(d=>{for(let m=0;m<y.length;m++)if(d.search(y[m])!==-1){delete b[d];break}})}e.sanitizeProcessEnvironment=N;function T(b){b&&(delete b.DEBUG,A.isMacintosh&&delete b.DYLD_LIBRARY_PATH,A.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ie[82],ne([0,1,11]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=O;function k(a){const y=[];let P;try{const d=JSON.parse(a.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),P=m.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:P}}e.parse=k;function N(a){if(typeof a!="string")return N(k(a).stack);const y=a;if(y){const P=T(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(d&&d.length===4)return{uri:A.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=N;function T(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function b(a,y){const{args:P,stack:d}=k(a),m=typeof P[0]=="string"&&P.length===1;let S=T(d);S&&(S=`(${S.trim()})`);let C=[];if(typeof P[0]=="string"?S&&m?C=[`%c[${y}] %c${P[0]} %c${S}`,f("blue"),f(""),f("grey")]:C=[`%c[${y}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:C=[`%c[${y}]%`,f("blue"),...P],S&&!m&&C.push(S),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,C)}e.log=b;function f(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(f){return JSON.stringify(f,T)}e.stringify=k;function N(f){let a=JSON.parse(f);return a=b(a),a}e.parse=N;function T(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function b(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return O.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof A.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let y=0;y<f.length;++y)f[y]=b(f[y],a+1);else for(const y in f)Object.hasOwnProperty.call(f,y)&&(f[y]=b(f[y],a+1))}return f}e.revive=b}),define(ie[83],ne([0,1,70,15,12,11]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(d,m,S){this.id=d,this.dependencies=m,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,m,S)=>{typeof d!="string"&&(S=m,m=d,d=null),(typeof m!="object"||!Array.isArray(m))&&(S=m,m=null),this._defineCalls.push(new T(d,m,S))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const m=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!m)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}_rendererLoadScript(d){return new Promise((m,S)=>{const C=document.createElement("script");C.setAttribute("async","async"),C.setAttribute("type","text/javascript");const E=()=>{C.removeEventListener("load",l),C.removeEventListener("error",v)},l=p=>{E(),m(this._defineCalls.pop())},v=p=>{E(),S(p)};C.addEventListener("load",l),C.addEventListener("error",v),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),C.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(C)})}_workerLoadScript(d){return new Promise((m,S)=>{try{this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),importScripts(d),m(this._defineCalls.pop())}catch(C){S(C)}})}async _nodeJSLoadScript(d){try{const m=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,C=globalThis._VSCODE_NODE_MODULES.module,E=N.URI.parse(d).fsPath,l=m.readFileSync(E).toString(),v=C.wrap(l.replace(/^#!.*/,""));return new S.Script(v).runInThisContext().apply(),this._defineCalls.pop()}catch(m){throw m}}}const f=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(P,d,m){if(A.isESM){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[P]&&(P=a[P]);const S=`${P}/${d}`;if(f.has(S))return f.get(S);let C;if(/^\w[\w\d+.-]*:\/\//.test(S))C=S;else{const p=`${m&&!k.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${S}`;C=O.FileAccess.asBrowserUri(p).toString(!0)}const E=b.INSTANCE.load(C);return f.set(S,E),E}else return await new Promise((S,C)=>{G([P],S,C)})}e.importAMDNodeModule=y}),define(ie[84],ne([0,1,33,48,28,76,12]),function(G,e,A,O,k,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(d){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(d)}value(){if(this._value===void 0){let d=0,m=0;const S=(0,A.networkInterfaces)();for(const C in S){const E=S[C];if(E)for(const{mac:l,internal:v}of E)v||(m+=1,this._isVirtualMachineMacAddress(l.toUpperCase())&&(d+=1))}this._value=m>0?d/m:0}return this._value}};let b;async function f(d){return b||(b=(async()=>await a(d)||k.generateUuid())()),b}e.getMachineId=f;async function a(d){try{const m=await new Promise((C,E)=>{G(["crypto"],C,E)}),S=(0,N.getMac)();return m.createHash("sha256").update(S,"utf8").digest("hex")}catch(m){d(m);return}}const y="Software\\Microsoft\\SQMClient";async function P(d){if(T.isWindows){const m=await new Promise((S,C)=>{G(["@vscode/windows-registry"],S,C)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(S){return d(S),""}}return""}e.getSqmMachineId=P}),define(ie[85],ne([0,1,33,16,24]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const N=/^\d+$/,T=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var f;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class P{constructor(g,i,s){this.exePath=g,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:u=!1}={}){return u?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:u});if(!i)return null;const s=O.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let t=-1,n=null;for(const c of await k.Promises.readdir(s)){let R=-1;if(g){const w=c.indexOf("-");if(w<0)continue;const L=c.substring(0,w);if(!N.test(L)||c.substring(w+1)!=="preview")continue;R=parseInt(L,10)}else{if(!N.test(c))continue;R=parseInt(c,10)}if(R<=t)continue;const D=O.join(s,c,"pwsh.exe");await k.SymlinkSupport.existsFile(D)&&(n=D,t=R)}if(!n)return null;const r=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new P(n,`PowerShell${o}${r}`,!0)}async function S({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const g=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=u?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(g))if(i.test(t)){const n=O.join(g,t,"pwsh.exe");return new P(n,s)}return null}function C(){const u=O.join(A.homedir(),".dotnet","tools","pwsh.exe");return new P(u,".NET Core PowerShell Global Tool")}function E(){const u=O.join(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(u,"Windows PowerShell",!0)}async function*l(){let u=await m();u&&(yield u),u=await m({useAlternateBitness:!0}),u&&(yield u),u=await S(),u&&(yield u),u=C(),u&&(yield u),u=await m({findPreview:!0}),u&&(yield u),u=await S({findPreview:!0}),u&&(yield u),u=await m({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=E(),u&&(yield u)}async function*v(){for await(const u of l())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=v;async function p(){for await(const u of v())return u;return null}e.getFirstAvailablePowerShellInstallation=p}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(G,e,A,O,k,N,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function f(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=f;function a(P){let d=[],m=!1;const S=function(C){if(m){d.push(C);return}(!P.send(C,l=>{if(l&&console.error(l),m=!1,d.length>0){const v=d.slice(0);d=[],v.forEach(p=>S(p))}})||O.isWindows)&&(m=!0)};return{send:S}}e.createQueuedSender=a;var y;(function(P){async function d(m,S,C){if(A.isAbsolute(m))return m;if(S===void 0&&(S=k.cwd()),A.dirname(m)!=="."||(C===void 0&&T.isString(k.env.PATH)&&(C=k.env.PATH.split(A.delimiter)),C===void 0||C.length===0))return A.join(S,m);async function l(v){if(await b.Promises.exists(v)){let p;try{p=await b.Promises.stat(v)}catch(u){u.message.startsWith("EACCES")&&(p=await b.Promises.lstat(v))}return p?!p.isDirectory():!1}return!1}for(const v of C){let p;if(A.isAbsolute(v)?p=A.join(v,m):p=A.join(S,v,m),await l(p))return p;let u=p+".com";if(await l(u)||(u=p+".exe",await l(u)))return u}return A.join(S,m)}P.findExecutable=d})(y||(e.win32=y={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(P,d){return P===1?O.isWindows?y():N.getWindowsShell(d):f(P,d)}e.getSystemShell=T;let b=null;function f(P,d){if(O.isLinux&&P===2||O.isMacintosh&&P===3)return"/bin/bash";if(!b){let m;if(O.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,A.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}b=m}return b}let a=null;async function y(){return a||(a=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),a}});var me=this&&this.__decorate||function(G,e,A,O){var k=arguments.length,N=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,A):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(G,e,A,O);else for(var b=G.length-1;b>=0;b--)(T=G[b])&&(N=(k<3?T(N):k>3?T(e,A,N):T(e,A))||N);return k>3&&N&&Object.defineProperty(e,A,N),N};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(G,e,A,O,k,N,T,b,f,a,y,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(m||(m={}));function S(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(C||(C={}));function E(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function v(V){let _=0;for(let $=0;;$+=7){const H=V.read(1);if(_|=(H.buffer[0]&127)<<$,!(H.buffer[0]&128))return _}}const p=t(0);function u(V,_){if(_===0){V.write(p);return}let $=0;for(let Y=_;Y!==0;Y=Y>>>7)$++;const H=k.VSBuffer.alloc($);for(let Y=0;_!==0;Y++)H.buffer[Y]=_&127,_=_>>>7,_>0&&(H.buffer[Y]|=128);V.write(H)}class g{constructor(_){this.buffer=_,this.pos=0}read(_){const $=this.buffer.slice(this.pos,this.pos+_);return this.pos+=$.byteLength,$}}e.BufferReader=g;class i{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}e.BufferWriter=i;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function t(V){const _=k.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const n={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},r=typeof Buffer<"u";function o(V,_){if(typeof _>"u")V.write(n.Undefined);else if(typeof _=="string"){const $=k.VSBuffer.fromString(_);V.write(n.String),u(V,$.byteLength),V.write($)}else if(r&&Buffer.isBuffer(_)){const $=k.VSBuffer.wrap(_);V.write(n.Buffer),u(V,$.byteLength),V.write($)}else if(_ instanceof k.VSBuffer)V.write(n.VSBuffer),u(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(n.Array),u(V,_.length);for(const $ of _)o(V,$)}else if(typeof _=="number"&&(_|0)===_)V.write(n.Uint),u(V,_);else{const $=k.VSBuffer.fromString(JSON.stringify(_));V.write(n.Object),u(V,$.byteLength),V.write($)}}e.serialize=o;function c(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(v(V)).toString();case s.Buffer:return V.read(v(V)).buffer;case s.VSBuffer:return V.read(v(V));case s.Array:{const $=v(V),H=[];for(let Y=0;Y<$;Y++)H.push(c(V));return H}case s.Object:return JSON.parse(V.read(v(V)).toString());case s.Int:return v(V)}}e.deserialize=c;class R{constructor(_,$,H=null,Y=1e3){this.protocol=_,this.ctx=$,this.logger=H,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(_,$){this.channels.set(_,$),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const $=this.send([_.type]);this.logger?.logOutgoing($,0,1,E(_.type));return}case 201:case 202:case 204:case 203:{const $=this.send([_.type,_.id],_.data);this.logger?.logOutgoing($,_.id,1,E(_.type),_.data);return}}}send(_,$=void 0){const H=new i;return o(H,_),o(H,$),this.sendBuffer(H.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const $=new g(_),H=c($),Y=c($),Z=H[0];switch(Z){case 100:return this.logger?.logIncoming(_.byteLength,H[1],1,`${S(Z)}: ${H[2]}.${H[3]}`,Y),this.onPromise({type:Z,id:H[1],channelName:H[2],name:H[3],arg:Y});case 102:return this.logger?.logIncoming(_.byteLength,H[1],1,`${S(Z)}: ${H[2]}.${H[3]}`,Y),this.onEventListen({type:Z,id:H[1],channelName:H[2],name:H[3],arg:Y});case 101:return this.logger?.logIncoming(_.byteLength,H[1],1,`${S(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]});case 103:return this.logger?.logIncoming(_.byteLength,H[1],1,`${S(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]})}}onPromise(_){const $=this.channels.get(_.channelName);if(!$){this.collectPendingRequest(_);return}const H=new N.CancellationTokenSource;let Y;try{Y=$.call(this.ctx,_.name,_.arg,H.token)}catch(F){Y=Promise.reject(F)}const Z=_.id;Y.then(F=>{this.sendResponse({id:Z,data:F,type:201})},F=>{F instanceof Error?this.sendResponse({id:Z,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:Z,data:F,type:203})}).finally(()=>{M.dispose(),this.activeRequests.delete(_.id)});const M=(0,a.toDisposable)(()=>H.cancel());this.activeRequests.set(_.id,M)}onEventListen(_){const $=this.channels.get(_.channelName);if(!$){this.collectPendingRequest(_);return}const H=_.id,Z=$.listen(this.ctx,_.name,_.arg)(M=>this.sendResponse({id:H,data:M,type:204}));this.activeRequests.set(_.id,Z)}disposeActiveRequest(_){const $=this.activeRequests.get(_.id);$&&($.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let $=this.pendingRequests.get(_.channelName);$||($=[],this.pendingRequests.set(_.channelName,$));const H=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:_,timeoutTimer:H})}flushPendingRequests(_){const $=this.pendingRequests.get(_);if($){for(const H of $)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=R;var D;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class w{constructor(_,$=null){this.protocol=_,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=$}getChannel(_){const $=this;return{call(H,Y,Z){return $.isDisposed?Promise.reject(new b.CancellationError):$.requestPromise(_,H,Y,Z)},listen(H,Y){return $.isDisposed?f.Event.None:$.requestEvent(_,H,Y)}}}requestPromise(_,$,H,Y=N.CancellationToken.None){const Z=this.lastRequestId++,F={id:Z,type:100,channelName:_,name:$,arg:H};if(Y.isCancellationRequested)return Promise.reject(new b.CancellationError);let h;return new Promise((x,U)=>{if(Y.isCancellationRequested)return U(new b.CancellationError);const q=()=>{const ue=pe=>{switch(pe.type){case 201:this.handlers.delete(Z),x(pe.data);break;case 202:{this.handlers.delete(Z);const Se=new Error(pe.data.message);Se.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,Se.name=pe.data.name,U(Se);break}case 203:this.handlers.delete(Z),U(pe.data);break}};this.handlers.set(Z,ue),this.sendRequest(F)};let B=null;this.state===l.Idle?q():(B=(0,O.createCancelablePromise)(ue=>this.whenInitialized()),B.then(()=>{B=null,q()}));const te=()=>{B?(B.cancel(),B=null):this.sendRequest({id:Z,type:101}),U(new b.CancellationError)},ce=Y.onCancellationRequested(te);h=(0,a.combinedDisposable)((0,a.toDisposable)(te),ce),this.activeRequests.add(h)}).finally(()=>{h.dispose(),this.activeRequests.delete(h)})}requestEvent(_,$,H){const Y=this.lastRequestId++,M={id:Y,type:102,channelName:_,name:$,arg:H};let F=null;const h=new f.Emitter({onWillAddFirstListener:()=>{F=(0,O.createCancelablePromise)(x=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(h),this.sendRequest(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(h),this.sendRequest({id:Y,type:103}))}}),I=x=>h.fire(x.data);return this.handlers.set(Y,I),h.event}sendRequest(_){switch(_.type){case 100:case 102:{const $=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing($,_.id,0,`${S(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const $=this.send([_.type,_.id]);this.logger?.logOutgoing($,_.id,0,S(_.type));return}}}send(_,$=void 0){const H=new i;return o(H,_),o(H,$),this.sendBuffer(H.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const $=new g(_),H=c($),Y=c($),Z=H[0];switch(Z){case 200:return this.logger?.logIncoming(_.byteLength,0,0,E(Z)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,H[1],0,E(Z),Y),this.onResponse({type:H[0],id:H[1],data:Y})}}onResponse(_){if(_.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=w,me([T.memoize],w.prototype,"onDidInitializePromise",null);class L{get connections(){const _=[];return this._connections.forEach($=>_.push($)),_}constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(_(({protocol:$,onDidClientDisconnect:H})=>{const Y=f.Event.once($.onMessage);this.disposables.add(Y(Z=>{const M=new g(Z),F=c(M),h=new R($,F),I=new w($);this.channels.forEach((U,q)=>h.registerChannel(q,U));const x={channelServer:h,channelClient:I,ctx:F};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(H(()=>{h.dispose(),I.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(_,$){const H=this;return{call(Y,Z,M){let F;if((0,d.isFunction)($)){const I=(0,A.getRandomElement)(H.connections.filter($));F=I?Promise.resolve(I):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,$))}else F=$.routeCall(H,Y,Z);const h=F.then(I=>I.channelClient.getChannel(_));return J(h).call(Y,Z,M)},listen(Y,Z){if((0,d.isFunction)($))return H.getMulticastEvent(_,$,Y,Z);const M=$.routeEvent(H,Y,Z).then(F=>F.channelClient.getChannel(_));return J(M).listen(Y,Z)}}}getMulticastEvent(_,$,H,Y){const Z=this;let M;const F=new f.Emitter({onWillAddFirstListener:()=>{M=new a.DisposableStore;const h=new f.EventMultiplexer,I=new Map,x=q=>{const te=q.channelClient.getChannel(_).listen(H,Y),ce=h.add(te);I.set(q,ce)},U=q=>{const B=I.get(q);B&&(B.dispose(),I.delete(q))};Z.connections.filter($).forEach(x),f.Event.filter(Z.onDidAddConnection,$)(x,void 0,M),Z.onDidRemoveConnection(U,void 0,M),h.event(F.fire,F,M),M.add(h)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(_,$){this.channels.set(_,$);for(const H of this._connections)H.channelServer.registerChannel(_,$)}dispose(){this.disposables.dispose();for(const _ of this._connections)_.channelClient.dispose(),_.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class W{constructor(_,$,H=null){const Y=new i;o(Y,$),_.send(Y.buffer),this.channelClient=new w(_,H),this.channelServer=new R(_,$,H)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,$){this.channelServer.registerChannel(_,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function J(V){return{call(_,$,H){return V.then(Y=>Y.call(_,$,H))},listen(_,$){const H=new f.Relay;return V.then(Y=>H.input=Y.listen(_,$)),H.event}}}e.getDelayedChannel=J;function X(V){let _=!1;return{call($,H,Y){return _?V.call($,H,Y):(0,O.timeout)(0).then(()=>_=!0).then(()=>V.call($,H,Y))},listen($,H){if(_)return V.listen($,H);const Y=new f.Relay;return(0,O.timeout)(0).then(()=>_=!0).then(()=>Y.input=V.listen($,H)),Y.event}}}e.getNextTickChannel=X;class oe{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const $ of _.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=oe;var se;(function(V){function _(Z,M,F){const h=Z,I=F&&F.disableMarshalling,x=new Map;for(const U in h)H(U)&&x.set(U,f.Event.buffer(h[U],!0,void 0,M));return new class{listen(U,q,B){const te=x.get(q);if(te)return te;if(Y(q)){const ce=h[q];if(typeof ce=="function")return ce.call(h,B)}throw new b.ErrorNoTelemetry(`Event not found: ${q}`)}call(U,q,B){const te=h[q];if(typeof te=="function"){if(!I&&Array.isArray(B))for(let ue=0;ue<B.length;ue++)B[ue]=(0,y.revive)(B[ue]);let ce=te.apply(h,B);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new b.ErrorNoTelemetry(`Method not found: ${q}`)}}}V.fromService=_;function $(Z,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(h,I){if(typeof I=="string")return M?.properties?.has(I)?M.properties.get(I):Y(I)?function(x){return Z.listen(I,x)}:H(I)?Z.listen(I):async function(...x){let U;M&&!(0,d.isUndefinedOrNull)(M.context)?U=[M.context,...x]:U=x;const q=await Z.call(I,U);return F?q:(0,y.revive)(q)};throw new b.ErrorNoTelemetry(`Property not found: ${String(I)}`)}})}V.toService=$;function H(Z){return Z[0]==="o"&&Z[1]==="n"&&P.isUpperAsciiLetter(Z.charCodeAt(2))}function Y(Z){return/^onDynamic/.test(Z)&&P.isUpperAsciiLetter(Z.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function ae(V){return Array.isArray(V)?V.map(de):de(V)}function z(V,_,$,H,Y,Z,M){M=ae(M);const F=fe[Y],h=F[H%F.length];let I=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(Z)?(I=I.concat(M),I.push(")")):I.push(M),console.log.apply(console,I)}class K{constructor(_,$){this._outgoingPrefix=_,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,$,H,Y,Z){this._totalOutgoing+=_,z(this._outgoingPrefix,this._totalOutgoing,_,$,H,Y,Z)}logIncoming(_,$,H,Y,Z){this._totalIncoming+=_,z(this._incomingPrefix,this._totalIncoming,_,$,H,Y,Z)}}e.IPCLogger=K}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends m.ChannelServer{constructor(l){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=S;class C{constructor(l,v){this.modulePath=l,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new O.Delayer(p),this.child=null,this._client=null}getChannel(l){const v=this;return{call(p,u,g){return v.requestPromise(l,p,u,g)},listen(p,u){return v.requestEvent(l,p,u)}}}requestPromise(l,v,p,u=N.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const g=this.getCachedChannel(l),i=(0,O.createCancelablePromise)(n=>g.call(v,p,n)),s=u.onCancellationRequested(()=>i.cancel()),t=(0,a.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(l,v,p){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let u;const g=new f.Emitter({onWillAddFirstListener:()=>{u=this.getCachedChannel(l).listen(v,p)(g.fire,g),this.activeRequests.add(u)},onDidRemoveLastListener:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return g.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,d.removeDangerousEnvVariables)(v.env),this.child=(0,A.fork)(this.modulePath,l,v);const p=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}p.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const g=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&g.send(r.buffer.toString("base64")),s=p.event,t={send:i,onMessage:s};this._client=new m.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,o)=>{process.removeListener("exit",n),this.activeRequests.forEach(c=>(0,a.dispose)(c)),this.activeRequests.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+o),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:o})})}return this._client}getCachedChannel(l){let v=this.channels.get(l);return v||(v=this.client.getChannel(l),this.channels.set(l,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(ie[88],ne([0,1,9,6,2,47,3]),function(G,e,A,O,k,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var b;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function f(d){const m=d;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends k.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(m,S=Object.create(null)){super(),this.database=m,this.options=S,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new A.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){this._onDidChangeStorage.pause();try{m.changed?.forEach((S,C)=>this.acceptExternal(C,S)),m.deleted?.forEach(S=>this.acceptExternal(S,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(m,S){if(this.state===a.Closed)return;let C=!1;(0,T.isUndefinedOrNull)(S)?C=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),C=!0),C&&this._onDidChangeStorage.fire({key:m,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const C=this.cache.get(m);return(0,T.isUndefinedOrNull)(C)?S:C}getBoolean(m,S){const C=this.get(m);return(0,T.isUndefinedOrNull)(C)?S:C==="true"}getNumber(m,S){const C=this.get(m);return(0,T.isUndefinedOrNull)(C)?S:parseInt(C,10)}getObject(m,S){const C=this.get(m);return(0,T.isUndefinedOrNull)(C)?S:(0,N.parse)(C)}async set(m,S,C=!1){if(this.state===a.Closed)return;if((0,T.isUndefinedOrNull)(S))return this.delete(m,C);const E=(0,T.isObject)(S)||Array.isArray(S)?(0,N.stringify)(S):String(S);if(this.cache.get(m)!==E)return this.cache.set(m,E),this.pendingInserts.set(m,E),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire({key:m,external:C}),this.doFlush()}async delete(m,S=!1){if(!(this.state===a.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire({key:m,external:S}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(this.hasPending)return this.doFlush(m)}async doFlush(m){return this.options.hint===b.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===b.STORAGE_IN_MEMORY}}e.Storage=y;class P{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((S,C)=>this.items.set(C,S)),m.delete?.forEach(S=>this.items.delete(S))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=P}),define(ie[89],ne([8,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(G,e,A,O,k,N,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const f=new RegExp(e.CorruptZipMessage);class a extends Error{constructor(g,i){let s=i.message;switch(g){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=g,this.cause=i}}e.ExtractError=a;function y(u){const g=u.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,s)=>i+s,g&61440)}function P(u){if(u instanceof a)return u;let g;return f.test(u.message)&&(g="CorruptZip"),new a(g,u)}function d(u,g,i,s,t,n){const r=k.dirname(g),o=k.join(s,r);if(!o.startsWith(s))return Promise.reject(new Error(b.localize(0,null,g)));const c=k.join(s,g);let R;return n.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((D,w)=>{if(!n.isCancellationRequested)try{R=(0,A.createWriteStream)(c,{mode:i}),R.once("close",()=>D()),R.once("error",w),u.once("error",w),u.pipe(R)}catch(L){w(L)}}))}function m(u,g,i,s){let t=(0,O.createCancelablePromise)(()=>Promise.resolve()),n=0;const r=s.onCancellationRequested(()=>{t.cancel(),u.close()});return new Promise((o,c)=>{const R=new O.Sequencer,D=w=>{w.isCancellationRequested||(n++,u.readEntry())};u.once("error",c),u.once("close",()=>t.then(()=>{s.isCancellationRequested||u.entryCount===n?o():c(new a("Incomplete",new Error(b.localize(1,null,n,u.entryCount))))},c)),u.readEntry(),u.on("entry",w=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(w.fileName)){D(s);return}const L=w.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(L)){const X=k.join(g,L);t=(0,O.createCancelablePromise)(oe=>T.Promises.mkdir(X,{recursive:!0}).then(()=>D(oe)).then(void 0,c));return}const W=C(u,w),J=y(w);t=(0,O.createCancelablePromise)(X=>R.queue(()=>W.then(oe=>d(oe,L,J,g,i,X).then(()=>D(X)))).then(null,c))})}).finally(()=>r.dispose())}async function S(u,g=!1){const{open:i}=await new Promise((s,t)=>{G(["yauzl"],s,t)});return new Promise((s,t)=>{i(u,g?{lazyEntries:!0}:void 0,(n,r)=>{n?t(P(n)):s((0,N.assertIsDefined)(r))})})}function C(u,g){return new Promise((i,s)=>{u.openReadStream(g,(t,n)=>{t?s(P(t)):i((0,N.assertIsDefined)(n))})})}async function E(u,g){const{ZipFile:i}=await new Promise((s,t)=>{G(["yazl"],s,t)});return new Promise((s,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,A.createWriteStream)(u);n.outputStream.pipe(r),n.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>s(u))})}e.zip=E;function l(u,g,i={},s){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=S(u,!0);return i.overwrite&&(n=n.then(r=>T.Promises.rm(g).then(()=>r))),n.then(r=>m(r,g,{sourcePathRegex:t},s))}e.extract=l;function v(u,g){return S(u).then(i=>new Promise((s,t)=>{i.on("entry",n=>{n.fileName===g&&C(i,n).then(r=>s(r),r=>t(r))}),i.once("close",()=>t(new Error(b.localize(2,null,g))))}))}function p(u,g){return v(u,g).then(i=>new Promise((s,t)=>{const n=[];i.once("error",t),i.on("data",r=>n.push(r)),i.on("end",()=>s(Buffer.concat(n)))}))}e.buffer=p}),define(ie[91],ne([8,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function N(...a){switch(a.length){case 1:return(0,O.localize)(0,null,a[0]);case 2:return(0,O.localize)(1,null,a[0],a[1]);case 3:return(0,O.localize)(2,null,a[0],a[1],a[2]);default:return}}const T=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,A.illegalState)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(y){return this._input=y,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const P=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:P})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const P=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:P})}else this._match(126)?this._addToken(9):this._error(N("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(N("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(y){return this._isAtEnd()||this._input.charCodeAt(this._current)!==y?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(y){this._tokens.push({type:y,offset:this._start})}_error(y){const P=this._start,d=this._input.substring(this._start,this._current),m={type:19,offset:this._start,lexeme:d};this._errors.push({offset:P,lexeme:d,additionalInfo:y}),this._tokens.push(m)}_string(){this.stringRe.lastIndex=this._start;const y=this.stringRe.exec(this._input);if(y){this._current=this._start+y[0].length;const P=this._input.substring(this._start,this._current),d=f._keywords.get(P);d?this._addToken(d):this._tokens.push({type:17,lexeme:P,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let y=this._current,P=!1,d=!1;for(;;){if(y>=this._input.length){this._current=y,this._error(b);return}const S=this._input.charCodeAt(y);if(P)P=!1;else if(S===47&&!d){y++;break}else S===91?d=!0:S===92?P=!0:S===93&&(d=!1);y++}for(;y<this._input.length&&f._regexFlags.has(this._input.charCodeAt(y));)y++;this._current=y;const m=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:m,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(G,e,A,O,k,N,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,N.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.join)(this.userDataPath,"logs",m)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(f.URI.file((0,N.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=T.env.VSCODE_PORTABLE;return m?f.URI.file((0,N.join)(m,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,N.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,N.resolve)(m):(0,N.normalize)((0,N.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?f.URI.file((0,N.resolve)(m)):f.URI.file((0,N.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,N.resolve)(m);const S=T.env.VSCODE_EXTENSIONS;if(S)return S;const C=T.env.VSCODE_PORTABLE;return C?(0,N.join)(C,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(S=>/^[^:/?#]+?:\/\//.test(S)?f.URI.parse(S):f.URI.file((0,N.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,N.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const S of this.args.log||[]){const C=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);C&&C[1]&&C[2]&&m.push([C[1],C[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=T.env.VSCODE_PORTABLE;return m?f.URI.file((0,N.join)(m,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,S,C){this._args=m,this.paths=S,this.productService=C,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,me([O.memoize],a.prototype,"appRoot",null),me([O.memoize],a.prototype,"userHome",null),me([O.memoize],a.prototype,"userDataPath",null),me([O.memoize],a.prototype,"appSettingsHome",null),me([O.memoize],a.prototype,"tmpDir",null),me([O.memoize],a.prototype,"cacheHome",null),me([O.memoize],a.prototype,"stateResource",null),me([O.memoize],a.prototype,"userRoamingDataHome",null),me([O.memoize],a.prototype,"userDataSyncHome",null),me([O.memoize],a.prototype,"sync",null),me([O.memoize],a.prototype,"machineSettingsResource",null),me([O.memoize],a.prototype,"workspaceStorageHome",null),me([O.memoize],a.prototype,"localHistoryHome",null),me([O.memoize],a.prototype,"keyboardLayoutResource",null),me([O.memoize],a.prototype,"argvResource",null),me([O.memoize],a.prototype,"isExtensionDevelopment",null),me([O.memoize],a.prototype,"untitledWorkspacesHome",null),me([O.memoize],a.prototype,"builtinExtensionsPath",null),me([O.memoize],a.prototype,"extensionsPath",null),me([O.memoize],a.prototype,"extensionDevelopmentLocationURI",null),me([O.memoize],a.prototype,"extensionDevelopmentKind",null),me([O.memoize],a.prototype,"extensionTestsLocationURI",null),me([O.memoize],a.prototype,"debugExtensionHost",null),me([O.memoize],a.prototype,"logLevel",null),me([O.memoize],a.prototype,"extensionLogLevel",null),me([O.memoize],a.prototype,"serviceMachineIdResource",null),me([O.memoize],a.prototype,"disableTelemetry",null),me([O.memoize],a.prototype,"disableWorkspaceTrust",null),me([O.memoize],a.prototype,"useInMemorySecretStorage",null),me([O.memoize],a.prototype,"policyFile",null);function y(d,m){return P(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.parseExtensionHostDebugPort=y;function P(d,m,S,C,E,l){const p=Number(m||d)||(C?null:S),u=p?!!m:!1;let g;if(l)try{g=JSON.parse(l)}catch{}return{port:p,break:u,debugId:E,env:g}}e.parseDebugParams=P}),function(){"use strict";function G(e,A,O){function k(T,b){const f=N(T,b),a=[f];return e.isAbsolute(f)||a.unshift(O),e.resolve(...a)}function N(T,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,b);const y=T["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(P,"AppData","Roaming")}break;case"darwin":a=e.join(A.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,b)}return{getUserDataPath:k}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,A,O){return G(e,A,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=G(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class N extends O.AbstractNativeEnvironmentService{constructor(a,y){super(a,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,y.nameShort)},y)}}e.NativeEnvironmentService=N;function T(f,a){return(0,O.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.parsePtyHostDebugPort=T;function b(f,a){return(0,O.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.parseSharedProcessDebugPort=b}),define(ie[115],ne([0,1,3,97]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(T,b,f,a){try{N(T,b,f,a)}catch(y){T.error(y?.message??y)}return b}e.localizeManifest=k;function N(T,b,f,a){const y=(P,d,m)=>{const S=P[d];if((0,A.isString)(S)){const C=S,E=C.length;if(E>1&&C[0]==="%"&&C[E-1]==="%"){const l=C.substr(1,E-2);let v=f[l];v===void 0&&a&&(v=a[l]);const p=typeof v=="string"?v:v?.message,u=a?.[l],g=typeof u=="string"?u:u?.message;if(!p){g||T.warn(`[${b.name}]: ${(0,O.localize)(0,null,l)}`);return}if(m&&(d==="title"||d==="category")&&g&&g!==p){const i={value:p,original:g};P[d]=i}else P[d]=p}}else if((0,A.isObject)(S))for(const C in S)S.hasOwnProperty(C)&&(C==="commands"?y(S,C,!0):y(S,C,m));else if(Array.isArray(S))for(let C=0;C<S.length;C++)y(S,C,m)};for(const P in b)b.hasOwnProperty(P)&&y(b,P)}}),define(ie[116],ne([0,1,49,100]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(N){return(0,A.buffer)(N,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(ie[50],ne([0,1,17,54,101,44]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function f(l){return l=l.trim(),l==="*"||T.test(l)}e.isValidVersionStr=f;function a(l){if(!f(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(T);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=a;function y(l){if(!l)return null;const v=l.majorBase,p=l.majorMustEqual,u=l.minorBase;let g=l.minorMustEqual;const i=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(v===0||(g=!1),s=!1);let t=0;if(l.preRelease){const n=b.exec(l.preRelease);if(n){const[,r,o,c]=n;t=Date.UTC(Number(r),Number(o)-1,Number(c))}}return{majorBase:v,majorMustEqual:p,minorBase:u,minorMustEqual:g,patchBase:i,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=y;function P(l,v,p){let u;typeof l=="string"?u=y(a(l)):u=l;let g;v instanceof Date?g=v.getTime():typeof v=="string"&&(g=new Date(v).getTime());let i;if(typeof p=="string"?i=y(a(p)):i=p,!u||!i)return!1;const s=u.majorBase,t=u.minorBase,n=u.patchBase;let r=i.majorBase,o=i.minorBase,c=i.patchBase;const R=i.notBefore;let D=i.majorMustEqual,w=i.minorMustEqual,L=i.patchMustEqual;return i.isMinimum?s>r?!0:s<r?!1:t>o?!0:t<o||g&&g<R?!1:n>=c:(s===1&&r===0&&(!D||!w||!L)&&(r=1,o=0,c=0,D=!0,w=!1,L=!1),s<r?!1:s>r?!D:t<o?!1:t>o?!w:n<c?!1:n>c?!L:!(g&&g<R))}e.isValidVersion=P;function d(l,v,p,u,g){const i=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return i.push([O.default.Error,k.localize(0,null)]),i;if(typeof u.name!="string")return i.push([O.default.Error,k.localize(1,null,"name")]),i;if(typeof u.version!="string")return i.push([O.default.Error,k.localize(2,null,"version")]),i;if(!u.engines)return i.push([O.default.Error,k.localize(3,null,"engines")]),i;if(typeof u.engines.vscode!="string")return i.push([O.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof u.extensionDependencies<"u"&&!E(u.extensionDependencies))return i.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof u.activationEvents<"u"){if(!E(u.activationEvents))return i.push([O.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof u.main>"u"&&typeof u.browser>"u")return i.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&i.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return i.push([O.default.Error,k.localize(9,null,"main")]),i;{const n=(0,A.joinPath)(p,u.main);(0,A.isEqualOrParent)(n,p)||i.push([O.default.Warning,k.localize(10,null,n.path,p.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return i.push([O.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,A.joinPath)(p,u.browser);(0,A.isEqualOrParent)(n,p)||i.push([O.default.Warning,k.localize(12,null,n.path,p.path)])}}if(!N.valid(u.version))return i.push([O.default.Error,k.localize(13,null)]),i;const s=[];if(!m(l,v,u,g,s))for(const n of s)i.push([O.default.Error,n]);return i}e.validateExtensionManifest=d;function m(l,v,p,u,g){return u||typeof p.main>"u"&&typeof p.browser>"u"?!0:C(l,v,p.engines.vscode,g)}e.isValidExtensionVersion=m;function S(l,v,p){return l==="*"||C(v,p,l)}e.isEngineValid=S;function C(l,v,p,u=[]){const g=y(a(p));if(!g)return u.push(k.localize(14,null,p)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(k.localize(15,null,p)),!1}else if(!g.majorMustEqual)return u.push(k.localize(16,null,p)),!1;return P(l,v,g)?!0:(u.push(k.localize(17,null,l,p)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let v=0,p=l.length;v<p;v++)if(typeof l[v]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(N,T,b){let f=b&&b.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const y=(await T.readFile(N.serviceMachineIdResource)).value.toString();f=(0,O.isUUID)(y)?y:null}catch{f=null}if(!f){f=(0,O.generateUuid)();try{await T.writeFile(N.serviceMachineIdResource,A.VSBuffer.fromString(f))}catch{}}return b?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=k}),define(ie[51],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class A{constructor(k,N=[],T=!1){this.ctor=k,this.staticArguments=N,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=A}),define(ie[118],ne([0,1,51]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function N(b,f,a){f instanceof A.SyncDescriptor||(f=new A.SyncDescriptor(f,[],!!a)),O.push([b,f])}e.registerSingleton=N;function T(){return O}e.getSingletonServiceDescriptors=T}),define(ie[119],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class A{constructor(N,T){this.key=N,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=A;class O{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const T of this._nodes.values())T.outgoing.size===0&&N.push(T);return N}insertEdge(N,T){const b=this.lookupOrInsertNode(N),f=this.lookupOrInsertNode(T);b.outgoing.set(f.key,f),f.incoming.set(b.key,b)}removeNode(N){const T=this._hashFn(N);this._nodes.delete(T);for(const b of this._nodes.values())b.outgoing.delete(T),b.incoming.delete(T)}lookupOrInsertNode(N){const T=this._hashFn(N);let b=this._nodes.get(T);return b||(b=new A(T,N),this._nodes.set(T,b)),b}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[T,b]of this._nodes)N.push(`${T}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,T]of this._nodes){const b=new Set([N]),f=this._findCycle(T,b);if(f)return f}}_findCycle(N,T){for(const[b,f]of N.outgoing){if(T.has(b))return[...T,b].join(" -> ");T.add(b);const a=this._findCycle(f,T);if(a)return a;T.delete(b)}}}e.Graph=O}),define(ie[29],ne([0,1,3,11,10]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationOverrides=N;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function f(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.isConfigured=a;function y(l,v){const p=Object.create(null);for(const u in l)P(p,u,l[u],v);return p}e.toValuesTree=y;function P(l,v,p,u){const g=v.split("."),i=g.pop();let s=l;for(let t=0;t<g.length;t++){const n=g[t];let r=s[n];switch(typeof r){case"undefined":r=s[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${v} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[i]=p}catch{u(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(s)}`)}else u(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=P;function d(l,v){const p=v.split(".");m(l,p)}e.removeFromValueTree=d;function m(l,v){const p=v.shift();if(v.length===0){delete l[p];return}if(Object.keys(l).indexOf(p)!==-1){const u=l[p];typeof u=="object"&&!Array.isArray(u)&&(m(u,v),Object.keys(u).length===0&&delete l[p])}}function S(l,v,p){function u(s,t){let n=s;for(const r of t){if(typeof n!="object"||n===null)return;n=n[r]}return n}const g=v.split("."),i=u(l,g);return typeof i>"u"?p:i}e.getConfigurationValue=S;function C(l,v,p){Object.keys(v).forEach(u=>{u!=="__proto__"&&(u in l?A.isObject(l[u])&&A.isObject(v[u])?C(l[u],v[u],p):p&&(l[u]=v[u]):l[u]=v[u])})}e.merge=C;function E(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(G,e,A,O,k,N,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",A.isMacintosh),f.set("isLinux",A.isLinux),f.set("isWindows",A.isWindows),f.set("isWeb",A.isWeb),f.set("isMacNative",A.isMacintosh&&!A.isWeb),f.set("isEdge",A.isEdge),f.set("isFirefox",A.isFirefox),f.set("isChrome",A.isChrome),f.set("isSafari",A.isSafari);function a(F,h){if(f.get(F)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(F,h)}e.setConstant=a;const y=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const d={regexParsingWithErrorRecovery:!0},m=(0,T.localize)(0,null),S=(0,T.localize)(1,null),C=(0,T.localize)(2,null),E=(0,T.localize)(3,null),l=(0,T.localize)(4,null),v=(0,T.localize)(5,null),p=(0,T.localize)(6,null),u=(0,T.localize)(7,null);class g{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(h=d){this._config=h,this._scanner=new k.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(h){if(h===""){this._parsingErrors.push({message:m,offset:0,lexeme:"",additionalInfo:S});return}this._tokens=this._scanner.reset(h).scan(),this._current=0,this._parsingErrors=[];try{const I=this._expr();if(!this._isAtEnd()){const x=this._peek(),U=x.type===17?v:void 0;throw this._parsingErrors.push({message:l,offset:x.offset,lexeme:k.Scanner.getLexeme(x),additionalInfo:U}),g._parseError}return I}catch(I){if(I!==g._parseError)throw I;return}}_expr(){return this._or()}_or(){const h=[this._and()];for(;this._matchOne(16);){const I=this._and();h.push(I)}return h.length===1?h[0]:i.or(...h)}_and(){const h=[this._term()];for(;this._matchOne(15);){const I=this._term();h.push(I)}return h.length===1?h[0]:i.and(...h)}_term(){if(this._matchOne(2)){const h=this._peek();switch(h.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const I=this._expr();return this._consume(1,E),I?.negate()}case 17:return this._advance(),W.create(h.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",h)}}return this._primary()}_primary(){const h=this._peek();switch(h.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const I=this._expr();return this._consume(1,E),I}case 17:{const I=h.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const q=U.lexeme,B=q.lastIndexOf("/"),te=B===q.length-1?void 0:this._removeFlagsGY(q.substring(B+1));let ce;try{ce=new RegExp(q.substring(1,B),te)}catch{throw this._errExpectedButGot("REGEX",U)}return de.create(I,ce)}switch(U.type){case 10:case 19:{const q=[U.lexeme];this._advance();let B=this._peek(),te=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?te++:U.lexeme.charCodeAt(he)===41&&te--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let he=0;he<B.lexeme.length;he++)B.lexeme.charCodeAt(he)===40?te++:U.lexeme.charCodeAt(he)===41&&te--}if(te<0)break;q.push(k.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const ce=q.join(""),ue=ce.lastIndexOf("/"),pe=ue===ce.length-1?void 0:this._removeFlagsGY(ce.substring(ue+1));let Se;try{Se=new RegExp(ce.substring(1,ue),pe)}catch{throw this._errExpectedButGot("REGEX",U)}return i.regex(I,Se)}case 18:{const q=U.lexeme;this._advance();let B=null;if(!(0,O.isFalsyOrWhitespace)(q)){const te=q.indexOf("/"),ce=q.lastIndexOf("/");if(te!==ce&&te>=0){const ue=q.slice(te+1,ce),pe=q[ce+1]==="i"?"i":"";try{B=new RegExp(ue,pe)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(B===null)throw this._errExpectedButGot("REGEX",U);return de.create(I,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,C);const U=this._value();return i.notIn(I,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return i.equals(I,U);switch(U){case"true":return i.has(I);case"false":return i.not(I);default:return i.equals(I,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return i.notEquals(I,U);switch(U){case"true":return i.not(I);case"false":return i.has(I);default:return i.notEquals(I,U)}}case 5:return this._advance(),se.create(I,this._value());case 6:return this._advance(),fe.create(I,this._value());case 7:return this._advance(),X.create(I,this._value());case 8:return this._advance(),oe.create(I,this._value());case 13:return this._advance(),i.in(I,this._value());default:return i.has(I)}}case 20:throw this._parsingErrors.push({message:p,offset:h.offset,lexeme:"",additionalInfo:u}),g._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const h=this._peek();switch(h.type){case 17:case 18:return this._advance(),h.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(h){return h.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(h){return this._check(h)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(h,I){if(this._check(h))return this._advance();throw this._errExpectedButGot(I,this._peek())}_errExpectedButGot(h,I,x){const U=(0,T.localize)(8,null,h,k.Scanner.getLexeme(I)),q=I.offset,B=k.Scanner.getLexeme(I);return this._parsingErrors.push({message:U,offset:q,lexeme:B,additionalInfo:x}),g._parseError}_check(h){return this._peek().type===h}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=g;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(h){return c.create(h)}static equals(h,I){return R.create(h,I)}static notEquals(h,I){return L.create(h,I)}static regex(h,I){return de.create(h,I)}static in(h,I){return D.create(h,I)}static notIn(h,I){return w.create(h,I)}static not(h){return W.create(h)}static and(...h){return K.create(h,null,!0)}static or(...h){return V.create(h,null,!0)}static greater(h,I){return X.create(h,I)}static greaterEquals(h,I){return oe.create(h,I)}static smaller(h,I){return se.create(h,I)}static smallerEquals(h,I){return fe.create(h,I)}static{this._parser=new g({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this._parser.parse(h)}}e.ContextKeyExpr=i;function s(F){const h=new g({regexParsingWithErrorRecovery:!1});return F.map(I=>(h.parse(I),h.lexingErrors.length>0?h.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,T.localize)(9,null,x.additionalInfo):(0,T.localize)(10,null),offset:x.offset,length:x.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.validateWhenClauses=s;function t(F,h){const I=F?F.substituteConstants():void 0,x=h?h.substituteConstants():void 0;return!I&&!x?!0:!I||!x?!1:I.equals(x)}e.expressionsAreEqualWithConstantSubstitution=t;function n(F,h){return F.cmp(h)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class c{static create(h,I=null){const x=f.get(h);return typeof x=="boolean"?x?o.INSTANCE:r.INSTANCE:new c(h,I)}constructor(h,I){this.key=h,this.negated=I,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:$(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=f.get(this.key);return typeof h=="boolean"?h?o.INSTANCE:r.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.negated||(this.negated=W.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class R{static create(h,I,x=null){if(typeof I=="boolean")return I?c.create(h,x):W.create(h,x);const U=f.get(h);return typeof U=="boolean"?I===(U?"true":"false")?o.INSTANCE:r.INSTANCE:new R(h,I,x)}constructor(h,I,x){this.key=h,this.value=I,this.negated=x,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=f.get(this.key);if(typeof h=="boolean"){const I=h?"true":"false";return this.value===I?o.INSTANCE:r.INSTANCE}return this}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=R;class D{static create(h,I){return new D(h,I)}constructor(h,I){this.key=h,this.valueKey=I,this.type=10,this.negated=null}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}substituteConstants(){return this}evaluate(h){const I=h.getValue(this.valueKey),x=h.getValue(this.key);return Array.isArray(I)?I.includes(x):typeof x=="string"&&typeof I=="object"&&I!==null?y.call(I,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=D;class w{static create(h,I){return new w(h,I)}constructor(h,I){this.key=h,this.valueKey=I,this.type=11,this._negated=D.create(h,I)}cmp(h){return h.type!==this.type?this.type-h.type:this._negated.cmp(h._negated)}equals(h){return h.type===this.type?this._negated.equals(h._negated):!1}substituteConstants(){return this}evaluate(h){return!this._negated.evaluate(h)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(h){return h.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class L{static create(h,I,x=null){if(typeof I=="boolean")return I?W.create(h,x):c.create(h,x);const U=f.get(h);return typeof U=="boolean"?I===(U?"true":"false")?r.INSTANCE:o.INSTANCE:new L(h,I,x)}constructor(h,I,x){this.key=h,this.value=I,this.negated=x,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=f.get(this.key);if(typeof h=="boolean"){const I=h?"true":"false";return this.value===I?r.INSTANCE:o.INSTANCE}return this}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=L;class W{static create(h,I=null){const x=f.get(h);return typeof x=="boolean"?x?r.INSTANCE:o.INSTANCE:new W(h,I)}constructor(h,I){this.key=h,this.negated=I,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:$(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=f.get(this.key);return typeof h=="boolean"?h?r.INSTANCE:o.INSTANCE:this}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=W;function J(F,h){if(typeof F=="string"){const I=parseFloat(F);isNaN(I)||(F=I)}return typeof F=="string"||typeof F=="number"?h(F):r.INSTANCE}class X{static create(h,I,x=null){return J(I,U=>new X(h,U,x))}constructor(h,I,x){this.key=h,this.value=I,this.negated=x,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=fe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=X;class oe{static create(h,I,x=null){return J(I,U=>new oe(h,U,x))}constructor(h,I,x){this.key=h,this.value=I,this.negated=x,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=oe;class se{static create(h,I,x=null){return J(I,U=>new se(h,U,x))}constructor(h,I,x){this.key=h,this.value=I,this.negated=x,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=oe.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=se;class fe{static create(h,I,x=null){return J(I,U=>new fe(h,U,x))}constructor(h,I,x){this.key=h,this.value=I,this.negated=x,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=X.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=fe;class de{static create(h,I){return new de(h,I)}constructor(h,I){this.key=h,this.regexp=I,this.type=7,this.negated=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const I=this.regexp?this.regexp.source:"",x=h.regexp?h.regexp.source:"";return I<x?-1:I>x?1:0}equals(h){if(h.type===this.type){const I=this.regexp?this.regexp.source:"",x=h.regexp?h.regexp.source:"";return this.key===h.key&&I===x}return!1}substituteConstants(){return this}evaluate(h){const I=h.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ae.create(this)),this.negated}}e.ContextKeyRegexExpr=de;class ae{static create(h){return new ae(h)}constructor(h){this._actual=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}substituteConstants(){return this}evaluate(h){return!this._actual.evaluate(h)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(h){return new ae(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ae;function z(F){let h=null;for(let I=0,x=F.length;I<x;I++){const U=F[I].substituteConstants();if(F[I]!==U&&h===null){h=[];for(let q=0;q<I;q++)h[q]=F[q]}h!==null&&(h[I]=U)}return h===null?F:h}class K{static create(h,I,x){return K._normalizeArr(h,I,x)}constructor(h,I){this.expr=h,this.negated=I,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let I=0,x=this.expr.length;I<x;I++){const U=n(this.expr[I],h.expr[I]);if(U!==0)return U}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let I=0,x=this.expr.length;I<x;I++)if(!this.expr[I].equals(h.expr[I]))return!1;return!0}return!1}substituteConstants(){const h=z(this.expr);return h===this.expr?this:K.create(h,this.negated,!1)}evaluate(h){for(let I=0,x=this.expr.length;I<x;I++)if(!this.expr[I].evaluate(h))return!1;return!0}static _normalizeArr(h,I,x){const U=[];let q=!1;for(const B of h)if(B){if(B.type===1){q=!0;continue}if(B.type===0)return r.INSTANCE;if(B.type===6){U.push(...B.expr);continue}U.push(B)}if(U.length===0&&q)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];for(;U.length>1;){const B=U[U.length-1];if(B.type!==9)break;U.pop();const te=U.pop(),ce=U.length===0,ue=V.create(B.expr.map(pe=>K.create([pe,te],null,x)),null,ce);ue&&(U.push(ue),U.sort(n))}if(U.length===1)return U[0];if(x){for(let B=0;B<U.length;B++)for(let te=B+1;te<U.length;te++)if(U[B].negate().equals(U[te]))return r.INSTANCE;if(U.length===1)return U[0]}return new K(U,I)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const I of this.expr)h.push(...I.keys());return h}map(h){return new K(this.expr.map(I=>I.map(h)),null)}negate(){if(!this.negated){const h=[];for(const I of this.expr)h.push(I.negate());this.negated=V.create(h,this,!0)}return this.negated}}e.ContextKeyAndExpr=K;class V{static create(h,I,x){return V._normalizeArr(h,I,x)}constructor(h,I){this.expr=h,this.negated=I,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let I=0,x=this.expr.length;I<x;I++){const U=n(this.expr[I],h.expr[I]);if(U!==0)return U}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let I=0,x=this.expr.length;I<x;I++)if(!this.expr[I].equals(h.expr[I]))return!1;return!0}return!1}substituteConstants(){const h=z(this.expr);return h===this.expr?this:V.create(h,this.negated,!1)}evaluate(h){for(let I=0,x=this.expr.length;I<x;I++)if(this.expr[I].evaluate(h))return!0;return!1}static _normalizeArr(h,I,x){let U=[],q=!1;if(h){for(let B=0,te=h.length;B<te;B++){const ce=h[B];if(ce){if(ce.type===0){q=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){U=U.concat(ce.expr);continue}U.push(ce)}}if(U.length===0&&q)return r.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];if(x){for(let B=0;B<U.length;B++)for(let te=B+1;te<U.length;te++)if(U[B].negate().equals(U[te]))return o.INSTANCE;if(U.length===1)return U[0]}return new V(U,I)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const I of this.expr)h.push(...I.keys());return h}map(h){return new V(this.expr.map(I=>I.map(h)),null)}negate(){if(!this.negated){const h=[];for(const I of this.expr)h.push(I.negate());for(;h.length>1;){const I=h.shift(),x=h.shift(),U=[];for(const q of M(I))for(const B of M(x))U.push(K.create([q,B],null,!1));h.unshift(V.create(U,null,!1))}this.negated=V.create(h,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class _ extends c{static{this._info=[]}static all(){return _._info.values()}constructor(h,I,x){super(h,null),this._defaultValue=I,typeof x=="object"?_._info.push({...x,key:h}):x!==!0&&_._info.push({key:h,description:x,type:I!=null?typeof I:void 0})}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return R.create(this.key,h)}notEqualsTo(h){return L.create(this.key,h)}}e.RawContextKey=_,e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function $(F,h){return F<h?-1:F>h?1:0}function H(F,h,I,x){return F<I?-1:F>I?1:h<x?-1:h>x?1:0}function Y(F,h){if(F.type===0||h.type===1)return!0;if(F.type===9)return h.type===9?Z(F.expr,h.expr):!1;if(h.type===9){for(const I of h.expr)if(Y(F,I))return!0;return!1}if(F.type===6){if(h.type===6)return Z(h.expr,F.expr);for(const I of F.expr)if(Y(I,h))return!0;return!1}return F.equals(h)}e.implies=Y;function Z(F,h){let I=0,x=0;for(;I<F.length&&x<h.length;){const U=F[I].cmp(h[x]);if(U<0)return!1;U===0&&I++,x++}return I===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(ie[59],ne([0,1,10]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,A.createDecorator)("downloadService")}),define(ie[18],ne([0,1,10]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,A.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,A.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[21],ne([0,1,95,10]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function N(p){switch(p){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function T(p,u){switch(p){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":u==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function b(p,u){return u==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function f(p,u,g){return b(u,g)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===g}e.isTargetPlatformCompatible=f;function a(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=a;var y;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var P;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var d;(function(p){p.Install="install",p.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var m;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var S;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.DownloadSignature="DownloadSignature",p.UpdateMetadata="UpdateMetadata",p.Extract="Extract",p.Scanning="Scanning",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Signature="Signature",p.NotAllowed="NotAllowed",p.Gallery="Gallery",p.Unknown="Unknown",p.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var C;(function(p){p.UnknownError="UnknownError",p.PackageIsInvalidZip="PackageIsInvalidZip",p.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(C||(e.ExtensionSignaturetErrorCode=C={}));class E extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.ExtensionManagementError=E;var l;(function(p){p.Timeout="Timeout",p.Cancelled="Cancelled",p.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class v extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.ExtensionGalleryError=v,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,A.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,A.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(y,P,d,m,S,C){let E;try{await b(y,P,d,m,S,C)}catch(l){E=l}finally{E&&S.errorTransformer&&(E=S.errorTransformer(E)),typeof E<"u"&&d.error(E),d.end()}}e.readFileIntoStream=T;async function b(y,P,d,m,S,C){f(C);const E=await y.open(P,{create:!1});try{f(C);let l=0,v=0,p=S&&typeof S.length=="number"?S.length:void 0,u=A.VSBuffer.alloc(Math.min(S.bufferSize,typeof p=="number"?p:S.bufferSize)),g=S&&typeof S.position=="number"?S.position:0,i=0;do v=await y.read(E,g,u.buffer,i,u.byteLength-i),g+=v,i+=v,l+=v,typeof p=="number"&&(p-=v),i===u.byteLength&&(await d.write(m(u)),u=A.VSBuffer.alloc(Math.min(S.bufferSize,typeof p=="number"?p:S.bufferSize)),i=0);while(v>0&&(typeof p!="number"||p>0)&&f(C)&&a(l,S));if(i>0){let s=i;typeof p=="number"&&(s=Math.min(i,p)),d.write(m(u.slice(0,s)))}}catch(l){throw(0,N.ensureFileSystemProviderError)(l)}finally{await y.close(E)}}function f(y){if(y.isCancellationRequested)throw(0,O.canceled)();return!0}function a(y,P){if(typeof P?.limits?.size=="number"&&y>P.limits.size)throw(0,N.createFileSystemProviderError)((0,k.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(G,e,A,O,k,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=A.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(a){const y=this.normalizeRequests(a),P=y.filter(m=>{const S=this.watchers.get(m.path);return S?!(0,O.patternsEquals)(S.request.excludes,m.excludes)||!(0,O.patternsEquals)(S.request.includes,m.includes):!0}),d=Array.from(this.watchers.values()).filter(({request:m})=>!y.find(S=>S.path===m.path&&(0,O.patternsEquals)(S.excludes,m.excludes)&&(0,O.patternsEquals)(S.includes,m.includes))).map(({request:m})=>m.path);P.length&&this.trace(`Request to start watching: ${P.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const m of d)this.stopWatching(m);for(const m of P)this.startWatching(m)}startWatching(a){const y=new T.NodeJSFileWatcherLibrary(a,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),P={request:a,instance:y};this.watchers.set(a.path,P)}async stop(){for(const[a]of this.watchers)this.stopWatching(a);this.watchers.clear()}stopWatching(a){const y=this.watchers.get(a);y&&(this.watchers.delete(a),y.instance.dispose())}normalizeRequests(a){const y=new Map;for(const P of a){const d=N.isLinux?P.path:P.path.toLowerCase();let m=y.get(P.correlationId);m||(m=new Map,y.set(P.correlationId,m)),m.set(d,P)}return Array.from(y.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(a){this.verboseLogging=a;for(const[,y]of this.watchers)y.instance.setVerboseLogging(a)}trace(a){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(a)})}toMessage(a,y){return y?`[File Watcher (node.js)] ${a} (path: ${y.request.path})`:`[File Watcher (node.js)] ${a}`}}e.NodeJSWatcher=b}),define(ie[122],ne([0,1,61,121]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends A.AbstractNonRecursiveWatcherClient{constructor(T,b,f){super(T,b,f),this.init()}createWatcher(T){return T.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=k}),define(ie[123],ne([0,1,15,57,87,61]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends N.AbstractUniversalWatcherClient{constructor(f,a,y){super(f,a,y),this.init()}createWatcher(f){const a=f.add(new k.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:y,signal:P})=>this.onError(`terminated by itself with code ${y}, signal: ${P}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ie[62],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class A{constructor(...k){this._entries=new Map;for(const[N,T]of k)this.set(N,T)}set(k,N){const T=this._entries.get(k);return this._entries.set(k,N),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=A}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(G,e,A,O,k,N,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class d{constructor(E=new f.ServiceCollection,l=!1,v,p=y){this._services=E,this._strict=l,this._parent=v,this._enableTracing=p,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=p?v?._globalGraph??new T.Graph(u=>u):void 0}createChild(E){return new d(E,this._strict,this,this._enableTracing)}invokeFunction(E,...l){const v=S.traceInvocation(this._enableTracing,E);let p=!1;try{return E({get:g=>{if(p)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(g,v);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...l)}finally{p=!0,v.stop()}}createInstance(E,...l){let v,p;return E instanceof N.SyncDescriptor?(v=S.traceCreation(this._enableTracing,E.ctor),p=this._createInstance(E.ctor,E.staticArguments.concat(l),v)):(v=S.traceCreation(this._enableTracing,E),p=this._createInstance(E,l,v)),v.stop(),p}_createInstance(E,l=[],v){const p=b._util.getServiceDependencies(E).sort((i,s)=>i.index-s.index),u=[];for(const i of p){const s=this._getOrCreateServiceInstance(i.id,v);s||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),u.push(s)}const g=p.length>0?p[0].index:l.length;if(l.length!==g){console.trace(`[createInstance] First service dependency of ${E.name} at position ${g+1} conflicts with ${l.length} static arguments`);const i=g-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,g)}return Reflect.construct(E,l.concat(u))}_setServiceInstance(E,l){if(this._services.get(E)instanceof N.SyncDescriptor)this._services.set(E,l);else if(this._parent)this._parent._setServiceInstance(E,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const l=this._services.get(E);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):l}_getOrCreateServiceInstance(E,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const v=this._getServiceInstanceOrDescriptor(E);return v instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,v,l.branch(E,!0)):(l.branch(E,!1),v)}_safeCreateAndCacheServiceInstance(E,l,v){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,l,v)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,l,v){const p=new T.Graph(i=>i.id.toString());let u=0;const g=[{id:E,desc:l,_trace:v}];for(;g.length;){const i=g.pop();if(p.lookupOrInsertNode(i),u++>1e3)throw new P(p);for(const s of b._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${E} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),t instanceof N.SyncDescriptor){const n={id:s.id,desc:t,_trace:i._trace.branch(s.id,!0)};p.insertEdge(i,n),g.push(n)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new P(p);break}for(const{data:s}of i){if(this._getServiceInstanceOrDescriptor(s.id)instanceof N.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}p.removeNode(s)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,l,v=[],p,u){if(this._services.get(E)instanceof N.SyncDescriptor)return this._createServiceInstance(E,l,v,p,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,l,v,p,u);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(E,l,v=[],p,u){if(p){const g=new d(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(E);const i=new Map,s=new A.GlobalIdleValue(()=>{const t=g._createInstance(l,v,u);for(const[n,r]of i){const o=t[n];if(typeof o=="function")for(const c of r)c.disposable=o.apply(t,c.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let c=i.get(n);return c||(c=new a.LinkedList,i.set(n,c)),(D,w,L)=>{if(s.isInitialized)return s.value[n](D,w,L);{const W={listener:[D,w,L],disposable:void 0},J=c.push(W);return(0,k.toDisposable)(()=>{J(),W.disposable?.dispose()})}}}if(n in t)return t[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),t[n]=o),o},set(t,n,r){return s.value[n]=r,!0},getPrototypeOf(t){return l.prototype}})}else return this._createInstance(l,v,u)}_throwIfStrict(E,l){if(l&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=d;var m;(function(C){C[C.None=0]="None",C[C.Creation=1]="Creation",C[C.Invocation=2]="Invocation",C[C.Branch=3]="Branch"})(m||(m={}));class S{static{this.all=new Set}static{this._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(E,l){return E?new S(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(E,l){return E?new S(1,l.name):S._None}static{this._totals=0}constructor(E,l){this.type=E,this.name=l,this._start=Date.now(),this._dep=[]}branch(E,l){const v=new S(3,E.toString());return this._dep.push([E,l,v]),v}stop(){const E=Date.now()-this._start;S._totals+=E;let l=!1;function v(u,g){const i=[],s=new Array(u+1).join("	");for(const[t,n,r]of g._dep)if(n&&r){l=!0,i.push(`${s}CREATES -> ${t}`);const o=v(u+1,r);o&&i.push(o)}else i.push(`${s}uses -> ${t}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(E>2||l)&&S.all.add(p.join(`
`))}}e.Trace=S});var re=this&&this.__param||function(G,e){return function(A,O){e(A,O,G)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(G,e,A,O,k,N,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(y){return y.tags.find(P=>P.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let a=class extends O.Disposable{constructor(P){super(),this.extensionGalleryService=P}async getAvailableLanguages(){const P=new A.CancellationTokenSource;setTimeout(()=>P.cancel(),1e3);let d;try{d=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},P.token)}catch{return[]}const S=d.firstPage.filter(C=>C.properties.localizedLanguages?.length&&C.tags.some(E=>E.startsWith("lp-"))).map(C=>{const E=C.properties.localizedLanguages?.[0],l=f(C);return{...this.createQuickPickItem(l,E,C),extensionId:C.identifier.id,galleryExtension:C}});return S.push(this.createQuickPickItem("en","English")),S}createQuickPickItem(P,d,m){const S=d??P;let C;if(S!==P&&(C=`(${P})`),P.toLowerCase()===k.language.toLowerCase()&&(C??="",C+=(0,N.localize)(0,null)),m?.installCount){C??="";const E=m.installCount;let l;E>1e6?l=`${Math.floor(E/1e5)/10}M`:E>1e3?l=`${Math.floor(E/1e3)}K`:l=String(E),C+=` $(cloud-download) ${l}`}return{id:P,label:S,description:C}}};e.LanguagePackBaseService=a,e.LanguagePackBaseService=a=me([re(0,T.IExtensionGalleryService)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(G,e,A,O,k,N,T,b,f,a,y,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function m(){return new Date().toISOString()}function S(D){return(0,a.isNumber)(D)}e.isLogLevel=S;var C;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(C||(e.LogLevel=C={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(D,w,L){switch(w){case C.Trace:D.trace(L);break;case C.Debug:D.debug(L);break;case C.Info:D.info(L);break;case C.Warning:D.warn(L);break;case C.Error:D.error(L);break;case C.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=E;function l(D,w=!1){let L="";for(let W=0;W<D.length;W++){let J=D[W];if(J instanceof Error&&(J=(0,A.toErrorMessage)(J,w)),typeof J=="object")try{J=JSON.stringify(J)}catch{}L+=(W>0?" ":"")+J}return L}class v extends N.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(w){this.level!==w&&(this.level=w,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(w){return this.level!==C.Off&&this.level<=w}}e.AbstractLogger=v;class p extends v{constructor(w){super(),this.logAlways=w}checkLogLevel(w){return this.logAlways||super.checkLogLevel(w)}trace(w,...L){this.checkLogLevel(C.Trace)&&this.log(C.Trace,l([w,...L],!0))}debug(w,...L){this.checkLogLevel(C.Debug)&&this.log(C.Debug,l([w,...L]))}info(w,...L){this.checkLogLevel(C.Info)&&this.log(C.Info,l([w,...L]))}warn(w,...L){this.checkLogLevel(C.Warning)&&this.log(C.Warning,l([w,...L]))}error(w,...L){if(this.checkLogLevel(C.Error))if(w instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=w.stack,this.log(C.Error,l(W))}else this.log(C.Error,l([w,...L]))}flush(){}}e.AbstractMessageLogger=p;class u extends v{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w),this.useColors=!b.isWindows}trace(w,...L){this.checkLogLevel(C.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,w,...L):console.log(`[main ${m()}]`,w,...L))}debug(w,...L){this.checkLogLevel(C.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,w,...L):console.log(`[main ${m()}]`,w,...L))}info(w,...L){this.checkLogLevel(C.Info)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,w,...L):console.log(`[main ${m()}]`,w,...L))}warn(w,...L){this.checkLogLevel(C.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,w,...L):console.warn(`[main ${m()}]`,w,...L))}error(w,...L){this.checkLogLevel(C.Error)&&(this.useColors?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,w,...L):console.error(`[main ${m()}]`,w,...L))}flush(){}}e.ConsoleMainLogger=u;class g extends v{constructor(w=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(w)}trace(w,...L){this.checkLogLevel(C.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",w,...L):console.log(w,...L))}debug(w,...L){this.checkLogLevel(C.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",w,...L):console.log(w,...L))}info(w,...L){this.checkLogLevel(C.Info)&&(this.useColors?console.log("%c INFO","color: #33f",w,...L):console.log(w,...L))}warn(w,...L){this.checkLogLevel(C.Warning)&&(this.useColors?console.log("%c WARN","color: #993",w,...L):console.log(w,...L))}error(w,...L){this.checkLogLevel(C.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",w,...L):console.error(w,...L))}flush(){}}e.ConsoleLogger=g;class i extends v{constructor(w,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=w,this.setLevel(L)}trace(w,...L){this.checkLogLevel(C.Trace)&&this.adapter.log(C.Trace,[this.extractMessage(w),...L])}debug(w,...L){this.checkLogLevel(C.Debug)&&this.adapter.log(C.Debug,[this.extractMessage(w),...L])}info(w,...L){this.checkLogLevel(C.Info)&&this.adapter.log(C.Info,[this.extractMessage(w),...L])}warn(w,...L){this.checkLogLevel(C.Warning)&&this.adapter.log(C.Warning,[this.extractMessage(w),...L])}error(w,...L){this.checkLogLevel(C.Error)&&this.adapter.log(C.Error,[this.extractMessage(w),...L])}extractMessage(w){return typeof w=="string"?w:(0,A.toErrorMessage)(w,this.checkLogLevel(C.Trace))}flush(){}}e.AdapterLogger=i;class s extends v{constructor(w){super(),this.loggers=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const L of this.loggers)L.setLevel(w);super.setLevel(w)}trace(w,...L){for(const W of this.loggers)W.trace(w,...L)}debug(w,...L){for(const W of this.loggers)W.debug(w,...L)}info(w,...L){for(const W of this.loggers)W.info(w,...L)}warn(w,...L){for(const W of this.loggers)W.warn(w,...L)}error(w,...L){for(const W of this.loggers)W.error(w,...L)}flush(){for(const w of this.loggers)w.flush()}dispose(){for(const w of this.loggers)w.dispose();super.dispose()}}e.MultiplexLogger=s;class t extends N.Disposable{constructor(w,L,W){if(super(),this.logLevel=w,this.logsHome=L,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,W)for(const J of W)this._loggers.set(J.resource,{logger:void 0,info:J})}getLoggerEntry(w){return(0,a.isString)(w)?[...this._loggers.values()].find(L=>L.info.id===w):this._loggers.get(w)}getLogger(w){return this.getLoggerEntry(w)?.logger}createLogger(w,L){const W=this.toResource(w),J=(0,a.isString)(w)?w:L?.id??(0,k.hash)(W.toString()).toString(16);let X=this._loggers.get(W)?.logger;const oe=L?.logLevel==="always"?C.Trace:L?.logLevel;X||(X=this.doCreateLogger(W,oe??this.getLogLevel(W)??this.logLevel,{...L,id:J}));const se={logger:X,info:{resource:W,id:J,logLevel:oe,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(se.info),this._loggers.set(W,se),X}toResource(w){return(0,a.isString)(w)?(0,f.joinPath)(this.logsHome,`${w}.log`):w}setLogLevel(w,L){if(y.URI.isUri(w)){const W=w,J=L,X=this._loggers.get(W);X&&J!==X.info.logLevel&&(X.info.logLevel=J===this.logLevel?void 0:J,X.logger?.setLevel(J),this._loggers.set(X.info.resource,X),this._onDidChangeLogLevel.fire([W,J]))}else{this.logLevel=w;for(const[W,J]of this._loggers.entries())this._loggers.get(W)?.info.logLevel===void 0&&J.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(w,L){const W=this.getLoggerEntry(w);W&&L!==!W.info.hidden&&(W.info.hidden=!L,this._loggers.set(W.info.resource,W),this._onDidChangeVisibility.fire([W.info.resource,L]))}getLogLevel(w){let L;return w&&(L=this._loggers.get(w)?.info.logLevel),L??this.logLevel}registerLogger(w){const L=this._loggers.get(w.resource);L?L.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this._loggers.set(w.resource,{info:w,logger:void 0}),this._onDidChangeLoggers.fire({added:[w],removed:[]}))}deregisterLogger(w){const L=this._loggers.get(w);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(w),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const w of this._loggers.values())yield w.info}getRegisteredLogger(w){return this._loggers.get(w)?.info}dispose(){this._loggers.forEach(w=>w.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class n{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(w){}getLevel(){return C.Info}trace(w,...L){}debug(w,...L){}info(w,...L){}warn(w,...L){}error(w,...L){}critical(w,...L){}dispose(){}flush(){}}e.NullLogger=n;class r extends n{}e.NullLogService=r;function o(D){if(D.verbose)return C.Trace;if(typeof D.logLevel=="string"){const w=R(D.logLevel.toLowerCase());if(w!==void 0)return w}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(D){switch(D){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=c;function R(D){switch(D){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=R,e.CONTEXT_LOG_LEVEL=new P.RawContextKey("logLevel",c(C.Info))}),define(ie[64],ne([0,1,7,10,4]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");let N=class{constructor(b){this.logService=b}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((b,f)=>G(["@vscode/vsce-sign"],async a=>b(a),f))),this.moduleLoadingPromise}async verify(b,f,a){let y;try{y=await this.vsceSign()}catch(P){return this.logService.error("Could not load vsce-sign module",(0,A.getErrorMessage)(P)),!1}return y.verify(b,f,a)}};e.ExtensionSignatureVerificationService=N,e.ExtensionSignatureVerificationService=N=me([re(0,k.ILogService)],N)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(G,e,A,O,k,N,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends T.Disposable{constructor(d,m){super(),this.logService=d,this.options=m,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new N.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(d,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,m):this.watchNonRecursive(d,m)}watchUniversal(d,m){const S={path:this.toFilePath(d),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},C=(0,A.insert)(this.universalPathsToWatch,S);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{C(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,k.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const m of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const m of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(m)&&d.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,m){const S={path:this.toFilePath(d),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},C=(0,A.insert)(this.nonRecursivePathsToWatch,S);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{C(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,k.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,b.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends a.Disposable{static{u=this}constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new T.Emitter),this._onDidUncorrelatedFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${s}`);const n=new a.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(r=>{const o=new E.FileChangesEvent(r,!this.isPathCaseSensitive(t));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,a.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await O.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return f.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,m.isAbsolutePath)(s))throw new E.FileOperationError((0,C.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new p.ErrorNoTelemetry;throw n.message=(0,C.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)||(0,E.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,C.localize)(2,null,this.resourceForError(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),r=this.isPathCaseSensitive(n),o=t?.resolveTo,c=t?.resolveSingleChildDescendants,R=t?.resolveMetadata,D=await n.stat(s);let w;return this.toFileStat(n,s,D,void 0,!!R,(L,W)=>(w||(w=y.TernarySearchTree.forUris(()=>!r),w.set(s,!0),o&&w.fill(!0,o)),w.get(L.resource)||w.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&c?W===1:!1))}async toFileStat(s,t,n,r,o,c){const{providerExtUri:R}=this.getExtUri(s),D={resource:t,name:R.basename(t),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&E.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((n.permissions??0)&E.FilePermission.Locked),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(D.isDirectory&&c(D,r)){try{const w=await s.readdir(t),L=await O.Promises.settled(w.map(async([W,J])=>{try{const X=R.joinPath(t,W),oe=o?await s.stat(X):{type:J};return await this.toFileStat(s,X,oe,w.length,o,c)}catch(X){return this.logService.trace(X),null}}));D.children=(0,A.coalesce)(L)}catch(w){this.logService.trace(w),D.children=[]}return D}return D}async resolveAll(s){return O.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,C.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=k.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const r=await this.writeFile(s,t);return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,r)),r}async writeFile(s,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:o}=this.getExtUri(r);let c=n;if((0,E.hasFileAtomicWriteCapability)(r)&&!c?.atomic){const R=r.enforceAtomicWriteFile?.(s);R&&(c={...n,atomic:R})}try{await this.validateWriteFile(r,s,c)||await this.mkdirp(r,o.dirname(s));let D;if((0,E.hasReadWriteCapability)(r)&&!(t instanceof k.VSBuffer))if((0,S.isReadableStream)(t)){const w=await(0,S.peekStream)(t,3);w.ended?D=k.VSBuffer.concat(w.buffer):D=w}else D=(0,S.peekReadable)(t,w=>k.VSBuffer.concat(w),3);else D=t;!(0,E.hasOpenReadWriteCloseCapability)(r)||(0,E.hasReadWriteCapability)(r)&&D instanceof k.VSBuffer||(0,E.hasReadWriteCapability)(r)&&(0,E.hasFileAtomicWriteCapability)(r)&&c?.atomic?await this.doWriteUnbuffered(r,s,c,D):await this.doWriteBuffered(r,s,c,D instanceof k.VSBuffer?(0,k.bufferToReadable)(D):D),this._onDidRunOperation.fire(new E.FileOperationEvent(s,4))}catch(R){throw new E.FileOperationError((0,C.localize)(4,null,this.resourceForError(s),(0,E.ensureFileSystemProviderError)(R).toString()),(0,E.toFileOperationResult)(R),c)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){const r=!!n?.unlock;if(r&&!(s.capabilities&8192))throw new Error((0,C.localize)(5,null,this.resourceForError(t)));if(!!n?.atomic){if(!(s.capabilities&32768))throw new Error((0,C.localize)(6,null,this.resourceForError(t)));if(!(s.capabilities&2))throw new Error((0,C.localize)(7,null,this.resourceForError(t)));if(r)throw new Error((0,C.localize)(8,null,this.resourceForError(t)))}let c;try{c=await s.stat(t)}catch{return}if(c.type&E.FileType.Directory)throw new E.FileOperationError((0,C.localize)(9,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,c),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&n.mtime<c.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:c.size}))throw new E.FileOperationError((0,C.localize)(10,null),3,n);return c}async readFile(s,t,n){const r=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(r,s,t,n):this.doReadFile(r,s,t,n)}async doReadFileAtomic(s,t,n,r){return new Promise((o,c)=>{this.writeQueue.queueFor(t,async()=>{try{const R=await this.doReadFile(s,t,n,r);o(R)}catch(R){c(R)}},this.getExtUri(s).providerExtUri)})}async doReadFile(s,t,n,r){const o=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},r);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(s,t,n){const r=await this.withReadProvider(s);return this.doReadFileStream(r,s,t,n)}async doReadFileStream(s,t,n,r){const o=new N.CancellationTokenSource(r);let c=n;(0,E.hasFileAtomicReadCapability)(s)&&s.enforceAtomicReadFile?.(t)&&(c={...n,atomic:!0});const R=this.validateReadFile(t,c).then(w=>w,w=>{throw o.dispose(!0),w});let D;try{return typeof c?.etag=="string"&&c.etag!==E.ETAG_DISABLED&&await R,c?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&c?.preferUnbuffered?D=this.readFileUnbuffered(s,t,c):(0,E.hasFileReadStreamCapability)(s)?D=this.readFileStreamed(s,t,o.token,c):D=this.readFileBuffered(s,t,o.token,c),D.on("end",()=>o.dispose()),D.on("error",()=>o.dispose()),{...await R,value:D}}catch(w){throw D&&await(0,S.consumeStream)(D),this.restoreReadError(w,t,c)}}restoreReadError(s,t,n){const r=(0,C.localize)(11,null,this.resourceForError(t),(0,E.ensureFileSystemProviderError)(s).toString());return s instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(r,s.stat,n):s instanceof E.TooLargeFileOperationError?new E.TooLargeFileOperationError(r,s.fileOperationResult,s.size,s.options):new E.FileOperationError(r,(0,E.toFileOperationResult)(s),n)}readFileStreamed(s,t,n,r=Object.create(null)){const o=s.readFileStream(t,r,n);return(0,S.transform)(o,{data:c=>c instanceof k.VSBuffer?c:k.VSBuffer.wrap(c),error:c=>this.restoreReadError(c,t,r)},c=>k.VSBuffer.concat(c))}readFileBuffered(s,t,n,r=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,o,c=>c,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>this.restoreReadError(c,t,r)},n),o}readFileUnbuffered(s,t,n){const r=(0,S.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?o=await s.readFile(t,{atomic:!0}):o=await s.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.validateReadFileLimits(t,o.byteLength,n),r.end(k.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,C.localize)(12,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==E.ETAG_DISABLED&&t.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,C.localize)(13,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new E.TooLargeFileOperationError((0,C.localize)(14,null,this.resourceForError(s)),7,t,n)}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,r){if(s.toString()!==t.toString())try{const o=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(o,s,c,t,n,r)}catch(o){return o}return!0}async move(s,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(r,s,o,t,"move",!!n),R=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,c==="move"?2:3,R)),R}async copy(s,t,n){const r=await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(r,s,o,t,"copy",!!n),R=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,c==="copy"?3:2,R)),R}async doMoveCopy(s,t,n,r,o,c){if(t.toString()===r.toString())return o;const{exists:R,isSameResourceWithDifferentPathCase:D}=await this.doValidateMoveCopy(s,t,n,r,o,c);if(R&&!D&&c&&await this.del(r,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),o==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(t,r,{overwrite:c});else{const w=await this.resolve(t);w.isDirectory?await this.doCopyFolder(s,w,n,r):await this.doCopyFile(s,t,n,r)}return o}else return s===n?(await s.rename(t,r,{overwrite:c}),o):(await this.doMoveCopy(s,t,n,r,"copy",c),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,r){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,r);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,r);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,r);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,r)}async doCopyFolder(s,t,n,r){await n.mkdir(r),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async o=>{const c=this.getExtUri(n).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(s,await this.resolve(o.resource),n,c):this.doCopyFile(s,o.resource,n,c)}))}async doValidateMoveCopy(s,t,n,r,o,c){let R=!1;if(s===n){const{providerExtUri:w,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(R=w.isEqual(t,r)),R&&o==="copy")throw new Error((0,C.localize)(15,null,this.resourceForError(t),this.resourceForError(r)));if(!R&&w.isEqualOrParent(r,t))throw new Error((0,C.localize)(16,null,this.resourceForError(t),this.resourceForError(r)))}const D=await this.exists(r);if(D&&!R){if(!c)throw new E.FileOperationError((0,C.localize)(17,null,this.resourceForError(t),this.resourceForError(r)),4);if(s===n){const{providerExtUri:w}=this.getExtUri(s);if(w.isEqualOrParent(t,r))throw new Error((0,C.localize)(18,null,this.resourceForError(t),this.resourceForError(r)))}}return{exists:D,isSameResourceWithDifferentPathCase:R}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(t,r.dirname(t));)try{if(!((await s.stat(t)).type&E.FileType.Directory))throw new Error((0,C.localize)(19,null,this.resourceForError(t)));break}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(t)),t=r.dirname(t)}for(let o=n.length-1;o>=0;o--){t=r.joinPath(t,n[o]);try{await s.mkdir(t)}catch(c){if((0,E.toFileSystemProviderErrorCode)(c)!==E.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s),r=!!t?.useTrash;if(r&&!(n.capabilities&4096))throw new Error((0,C.localize)(20,null,this.resourceForError(s)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,C.localize)(21,null,this.resourceForError(s)));if(r&&o)throw new Error((0,C.localize)(22,null,this.resourceForError(s)));let c;try{c=await n.stat(s)}catch{}if(c)this.throwIfFileIsReadonly(s,c);else throw new E.FileOperationError((0,C.localize)(23,null,this.resourceForError(s)),1);if(!!!t?.recursive){const D=await this.resolve(s);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,C.localize)(24,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t);let r=t;if((0,E.hasFileAtomicDeleteCapability)(n)&&!r?.atomic){const D=n.enforceAtomicDelete?.(s);D&&(r={...t,atomic:D})}const o=!!r?.useTrash,c=!!r?.recursive,R=r?.atomic??!1;await n.delete(s,{recursive:c,useTrash:o,atomic:R}),this._onDidRunOperation.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(!(n===r&&this.getExtUri(n).providerExtUri.isEqual(s,t)))return n===r&&(0,E.hasFileCloneCapability)(n)?n.cloneFile(s,t):(await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n===r&&(0,E.hasFileFolderCopyCapability)(n)?this.writeQueue.queueFor(s,()=>n.copy(s,t,{overwrite:!0}),this.getExtUri(n).providerExtUri):this.writeQueue.queueFor(s,()=>this.doCopyFile(n,s,r,t),this.getExtUri(n).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(s,t){return this.watch(s,{...t,correlationId:u.WATCHER_CORRELATION_IDS++})}watch(s,t={recursive:!1,excludes:[]}){const n=new a.DisposableStore;let r=!1,o=()=>{r=!0};n.add((0,a.toDisposable)(()=>o())),(async()=>{try{const R=await this.doWatch(s,t);r?(0,a.dispose)(R):o=()=>(0,a.dispose)(R)}catch(R){this.logService.error(R)}})();const c=t.correlationId;if(typeof c=="number"){const R=n.add(new T.Emitter);return n.add(this.internalOnDidFilesChange.event(w=>{w.correlates(c)&&R.fire(w)})),{onDidChange:R.event,dispose:()=>n.dispose()}}return n}async doWatch(s,t){const n=await this.withProvider(s),r=(0,b.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let o=this.activeWatchers.get(r);return o||(o={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(r,o)),o.count+=1,(0,a.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,a.dispose)(o.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,a.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,r){return this.writeQueue.queueFor(t,async()=>{const o=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,S.isReadableStream)(r)||(0,S.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,o,r):await this.doWriteReadableBufferedQueued(s,o,r)}catch(c){throw(0,E.ensureFileSystemProviderError)(c)}finally{await s.close(o)}},this.getExtUri(s).providerExtUri)}async doWriteStreamBufferedQueued(s,t,n){let r=0,o;if((0,S.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=k.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,c,c.byteLength,r,0),r+=c.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((c,R)=>{(0,S.listenStream)(o,{onData:async D=>{o.pause();try{await this.doWriteBuffer(s,t,D,D.byteLength,r,0)}catch(w){return R(w)}r+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>R(D),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(s,t,n){let r=0,o;for(;(o=n.read())!==null;)await this.doWriteBuffer(s,t,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(s,t,n,r,o,c){let R=0;for(;R<r;){const D=await s.write(t,o+R,n.buffer,c+R,r-R);R+=D}}async doWriteUnbuffered(s,t,n,r){return this.writeQueue.queueFor(t,()=>this.doWriteUnbufferedQueued(s,t,n,r),this.getExtUri(s).providerExtUri)}async doWriteUnbufferedQueued(s,t,n,r){let o;r instanceof k.VSBuffer?o=r:(0,S.isReadableStream)(r)?o=await(0,k.streamToBuffer)(r):(0,S.isReadableBufferedStream)(r)?o=await(0,k.bufferedStreamToBuffer)(r):o=(0,k.readableToBuffer)(r),await s.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeBufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeBufferedQueued(s,t,n,r){let o,c;try{o=await s.open(t,{create:!1}),c=await n.open(r,{create:!0,unlock:!1});const R=k.VSBuffer.alloc(this.BUFFER_SIZE);let D=0,w=0,L=0;do L=await s.read(o,D,R.buffer,w,R.byteLength-w),await this.doWriteBuffer(n,c,R,L,D,w),D+=L,w+=L,w===R.byteLength&&(w=0);while(L>0)}catch(R){throw(0,E.ensureFileSystemProviderError)(R)}finally{await O.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedQueued(s,t,n,r){return n.writeFile(r,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedToBufferedQueued(s,t,n,r){const o=await n.open(r,{create:!0,unlock:!1});try{const c=await s.readFile(t);await this.doWriteBuffer(n,o,k.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,E.ensureFileSystemProviderError)(c)}finally{await n.close(o)}}async doPipeBufferedToUnbuffered(s,t,n,r){const o=await(0,k.streamToBuffer)(this.readFileBuffered(s,t,N.CancellationToken.None));await this.doWriteUnbuffered(n,r,void 0,o)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new E.FileOperationError((0,C.localize)(25,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,C.localize)(26,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===P.Schemas.file?s.fsPath:s.toString(!0)}};e.FileService=g,e.FileService=g=u=me([re(0,v.ILogService)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(A)}catch(s){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(s)}`)}})();class i extends v.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new N.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:r}=await S.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:E.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await S.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,d.joinPath)(t,o.name))).type:c=this.toType(o),r.push([o.name,c])}catch(c){this.logService.trace(c)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let r;return n?.dangling?r=E.FileType.Unknown:t.isFile()?r=E.FileType.File:t.isDirectory()?r=E.FileType.Directory:r=E.FileType.Unknown,n&&(r|=E.FileType.SymbolicLink),r}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new k.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const o=this.toFilePath(t);return await S.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,r){const o=(0,m.newWriteableStream)(c=>T.VSBuffer.concat(c.map(R=>T.VSBuffer.wrap(R))).buffer);return(0,l.readFileIntoStream)(this,t,o,c=>c.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(t,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${r.atomic.postfix}`),n,r):this.doWriteFile(t,n,r)}async canWriteFileAtomic(t){try{const n=this.toFilePath(t),{symbolicLink:r}=await S.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async doWriteFileAtomic(t,n,r,o){const c=new a.DisposableStore;try{c.add(await this.createResourceLock(t)),c.add(await this.createResourceLock(n)),await this.doWriteFile(n,r,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(R){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{c.dispose()}}async doWriteFile(t,n,r,o){let c;try{const R=this.toFilePath(t);if(!r.create||!r.overwrite){if(await S.Promises.exists(R)){if(!r.overwrite)throw(0,E.createFileSystemProviderError)((0,C.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,E.createFileSystemProviderError)((0,C.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:r.unlock},o),await this.write(c,0,n,0,n.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(t,R)}finally{typeof c=="number"&&await this.close(c)}}static{this.canFlush=!0}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n,r){const o=this.toFilePath(t);let c;(0,E.isFileOpenForWriteOptions)(n)&&!r&&(c=await this.createResourceLock(t));let R;try{if((0,E.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(o);w.mode&128||await S.Promises.chmod(o,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}let D;if((0,E.isFileOpenForWriteOptions)(n)){if(P.isWindows)try{await S.Promises.truncate(o,0),D="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}D||(D="w")}else D="r";R=await S.Promises.open(o,D)}catch(D){throw c?.dispose(),(0,E.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(R,0),(0,E.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(R,t),c){const D=this.mapHandleToLock.get(R);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${o})`),this.mapHandleToLock.set(R,c),D&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${o})`),D.dispose())}return R}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await S.Promises.fdatasync(t)}catch(r){i.configureFlushOnWrite(!1),this.logService.error(r)}return await S.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,r,o,c){const R=this.normalizePos(t,n);let D=null;try{D=(await S.Promises.read(t,r,o,c,R)).bytesRead}catch(w){throw this.toFileSystemProviderError(w)}finally{this.updatePos(t,R,D)}return D}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,r){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,o+r):this.mapHandleToPos.delete(t)))}async write(t,n,r,o,c){return(0,k.retry)(()=>this.doWrite(t,n,r,o,c),100,3)}async doWrite(t,n,r,o,c){const R=this.normalizePos(t,n);let D=null;try{D=(await S.Promises.write(t,r,o,c,R)).bytesWritten}catch(w){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),w)}finally{this.updatePos(t,R,D)}return D}async mkdir(t){try{await S.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const r=this.toFilePath(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.join)((0,y.dirname)(r),`${(0,y.basename)(r)}${n.atomic.postfix}`)),await S.Promises.rm(r,S.RimRafMode.MOVE,o)}else try{await S.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:R,symbolicLink:D}=await S.SymlinkSupport.stat(r);c=R.isDirectory()&&!D}catch{}if(c)await S.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,n,r){const o=this.toFilePath(t),c=this.toFilePath(n);if(o!==c)try{await this.validateMoveCopy(t,n,"move",r.overwrite),await S.Promises.rename(o,c)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,C.localize)(2,null,(0,y.basename)(o),(0,y.basename)((0,y.dirname)(c)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(t,n,r){const o=this.toFilePath(t),c=this.toFilePath(n);if(o!==c)try{await this.validateMoveCopy(t,n,"copy",r.overwrite),await S.Promises.copy(o,c,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,C.localize)(3,null,(0,y.basename)(o),(0,y.basename)((0,y.dirname)(c)),R.toString()))),this.toFileSystemProviderError(R)}}async validateMoveCopy(t,n,r,o){const c=this.toFilePath(t),R=this.toFilePath(n);let D=!1;if(!!(this.capabilities&1024)||(D=(0,f.isEqual)(c,R,!0)),D){if(r==="copy")throw(0,E.createFileSystemProviderError)((0,C.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const L=await this.statIgnoreError(t);if(!L)throw(0,E.createFileSystemProviderError)((0,C.localize)(5,null),E.FileSystemProviderErrorCode.FileNotFound);const W=await this.statIgnoreError(n);if(W){if(!o)throw(0,E.createFileSystemProviderError)((0,C.localize)(6,null),E.FileSystemProviderErrorCode.FileExists);L.type&E.FileType.File&&W.type&E.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,r){const o=this.toFilePath(t),c=this.toFilePath(n),R=!!(this.capabilities&1024);if((0,f.isEqual)(o,c,!R))return;const D=new a.DisposableStore;try{D.add(await this.createResourceLock(t)),D.add(await this.createResourceLock(n)),r&&await S.Promises.mkdir((0,y.dirname)(c),{recursive:!0}),await S.Promises.copyFile(o,c)}catch(w){if(w.code==="ENOENT"&&!r)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(w)}finally{D.dispose()}}createUniversalWatcher(t,n,r){return new u.UniversalWatcherClient(o=>t(o),o=>n(o),r)}createNonRecursiveWatcher(t,n,r){return new g.NodeJSWatcherClient(o=>t(o),o=>n(o),r)}toFileSystemProviderError(t){if(t instanceof E.FileSystemProviderError)return t;let n=t,r;switch(t.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=E.FileSystemProviderErrorCode.Unknown;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(t,n){let r=this.toFileSystemProviderError(n);if(t&&r.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await S.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(r=(0,E.createFileSystemProviderError)(n,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=i}),define(ie[129],ne([0,1,2,4]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class k extends A.Disposable{constructor(T,b=[]){super(),this.logger=new O.MultiplexLogger([T,...b]),this._register(T.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...b){this.logger.trace(T,...b)}debug(T,...b){this.logger.debug(T,...b)}info(T,...b){this.logger.info(T,...b)}warn(T,...b){this.logger.warn(T,...b)}error(T,...b){this.logger.error(T,...b)}flush(){this.logger.flush()}}e.LogService=k}),define(ie[130],ne([0,1,13,4]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function N(a,y,P,d,m){try{const S=await new Promise((E,l)=>{G(["@vscode/spdlog"],E,l)});S.setFlushOn(k.Trace);const C=await S.createAsyncRotatingLogger(a,y,P,d);return m?C.clearFormatters():C.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),C}catch(S){console.error(S)}return null}function T(a,y,P){switch(y){case O.LogLevel.Trace:a.trace(P);break;case O.LogLevel.Debug:a.debug(P);break;case O.LogLevel.Info:a.info(P);break;case O.LogLevel.Warning:a.warn(P);break;case O.LogLevel.Error:a.error(P);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function b(a,y){switch(y){case O.LogLevel.Trace:a.setLevel(k.Trace);break;case O.LogLevel.Debug:a.setLevel(k.Debug);break;case O.LogLevel.Info:a.setLevel(k.Info);break;case O.LogLevel.Warning:a.setLevel(k.Warning);break;case O.LogLevel.Error:a.setLevel(k.Error);break;case O.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class f extends O.AbstractMessageLogger{constructor(y,P,d,m,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(y,P,d,m),this._register(this.onDidChangeLogLevel(C=>{this._logger&&b(this._logger,C)}))}async _createSpdLogLogger(y,P,d,m){const S=d?6:1,C=30/S*A.ByteSize.MB,E=await N(y,P,C,S,m);if(E){this._logger=E,b(this._logger,this.getLevel());for(const{level:l,message:v}of this.buffer)T(this._logger,l,v);this.buffer=[]}}log(y,P){this._logger?T(this._logger,y,P):this.getLevel()<=y&&this.buffer.push({level:y,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(ie[131],ne([0,1,28,4,130]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class N extends O.AbstractLoggerService{doCreateLogger(b,f,a){return new k.SpdLogLogger((0,A.generateUuid)(),b.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.LoggerService=N}),define(ie[39],ne([0,1,6,65,2,10]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,N.createDecorator)("policy");class T extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const y=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},y!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),O.Iterable.reduce(this.policies.entries(),(P,[d,m])=>({...P,[d]:m}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[y,P])=>({...a,[y]:{definition:P,value:this.policies.get(y)}}),{})}}e.AbstractPolicyService=T;class b{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(G,e,A,O,k,N,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(P,d){const m=[];for(const S of new Set(k.Iterable.concat(P.keys(),d.keys())))P.get(S)!==d.get(S)&&m.push(S);return m}let y=class extends f.AbstractPolicyService{constructor(d,m,S){super(),this.file=d,this.fileService=m,this.logService=S,this.throttledDelayer=this._register(new A.ThrottledDelayer(500));const C=O.Event.filter(m.onDidFilesChange,E=>E.affects(d));this._register(m.watch(d)),this._register(C(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const d=new Map;try{const m=await this.fileService.readFile(this.file),S=JSON.parse(m.value.toString());if(!(0,N.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const C of Object.keys(S))this.policyDefinitions[C]&&d.set(C,S[C])}catch(m){m.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",m)}return d}async refresh(){const d=await this.read(),m=a(this.policies,d);this.policies=d,m.length>0&&this._onDidChange.fire(m)}};e.FilePolicyService=y,e.FilePolicyService=y=me([re(1,T.IFileService),re(2,b.ILogService)],y)}),define(ie[133],ne([0,1,39,9,2,4]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let T=class extends A.AbstractPolicyService{constructor(f,a){super(),this.logService=f,this.productName=a,this.throttler=new O.Throttler,this.watcher=this._register(new k.MutableDisposable)}async _updatePolicyDefinitions(f){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:a}=await new Promise((y,P)=>{G(["@vscode/policy-watcher"],y,P)});await this.throttler.queue(()=>new Promise((y,P)=>{try{this.watcher.value=a(this.productName,f,d=>{this._onDidPolicyChange(d),y()})}catch(d){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),P(d)}}))}_onDidPolicyChange(f){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const a in f){const y=f[a];y===void 0?this.policies.delete(a):this.policies.set(a,y)}this._onDidChange.fire(Object.keys(f))}};e.NativePolicyService=T,e.NativePolicyService=T=me([re(0,N.ILogService)],T)}),define(ie[32],ne([0,1,10]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,A.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,b){A.ok(O.isString(T)),A.ok(O.isObject(b)),A.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,b)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ie[134],ne([0,1,6,36]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class N{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,a){this.schemasById[k(f)]=a,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new N;O.Registry.add(e.Extensions.JSONContribution,T)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(G,e,A,O,k,N,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=f.Registry.as(b.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=new Set;this.doRegisterConfigurations(i,s,t),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=new Set;this.doDeregisterConfigurations(i,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(i,!1,t),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(i){const s=new Set;this.doRegisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,s){const t=[];for(const{overrides:n,source:r}of i)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.configurationDefaultsOverrides.get(o),R=c?.valuesSources??new Map;if(r)for(const W of Object.keys(n[o]))R.set(W,r);const D={...c?.value||{},...n[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:D,valuesSources:R});const w=(0,T.getLanguageTagSettingPlainKey)(o),L={type:"object",default:D,description:N.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(r)?void 0:r,defaultValueSource:r};t.push(...C(o)),this.configurationProperties[o]=L,this.defaultLanguageConfigurationOverridesNode.properties[o]=L}else{this.configurationDefaultsOverrides.set(o,{value:n[o],source:r});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(i){const s=new Set;this.doDeregisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,s){for(const{overrides:t,source:n}of i)for(const r in t){const o=this.configurationDefaultsOverrides.get(r),c=k.isString(n)?n:n?.id,R=k.isString(o?.source)?o?.source:o?.source?.id;if(c===R)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const D=this.configurationProperties[r];D&&(this.updatePropertyDefaultValue(r,D),this.updateSchema(r,D))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let s=!1;const t=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,t),s=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,t),s=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,t),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s,t){i.forEach(n=>{this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties,void 0,t),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(i,s){const t=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>t(r))};for(const n of i){t(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(i,s=!0,t,n,r=3,o){r=k.isUndefinedOrNull(i.scope)?r:i.scope;const c=i.properties;if(c)for(const D in c){const w=c[D];if(s&&p(D,w)){delete c[D];continue}if(w.source=t,w.defaultDefaultValue=c[D].default,this.updatePropertyDefaultValue(D,w),e.OVERRIDE_PROPERTY_REGEX.test(D)?w.scope=void 0:(w.scope=k.isUndefinedOrNull(w.scope)?r:w.scope,w.restricted=k.isUndefinedOrNull(w.restricted)?!!n?.includes(D):w.restricted),c[D].hasOwnProperty("included")&&!c[D].included){this.excludedConfigurationProperties[D]=c[D],delete c[D];continue}else this.configurationProperties[D]=c[D],c[D].policy?.name&&this.policyConfigurations.set(c[D].policy.name,D);!c[D].deprecationMessage&&c[D].markdownDeprecationMessage&&(c[D].deprecationMessage=c[D].markdownDeprecationMessage),o.add(D)}const R=i.allOf;if(R)for(const D of R)this.validateAndRegisterProperties(D,s,t,n,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const n=t.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const i={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,r=t?.source;k.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),k.isUndefined(n)&&(n=l(s.type)),s.default=n,s.defaultValueSource=r}}const m="\\[([^\\]]+)\\]",S=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=S.exec(g);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=S.exec(g)}}return(0,A.distinct)(i)}e.overrideIdentifiersFromKey=C;function E(g){return g.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=E;function l(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new d;f.Registry.add(e.Extensions.Configuration,v);function p(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?N.localize(7,null,g):v.getConfigurationProperties()[g]!==void 0?N.localize(8,null,g):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?N.localize(9,null,g,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:N.localize(6,null)}e.validateProperty=p;function u(){const g=[],i=v.getConfigurationProperties();for(const s of Object.keys(i))g.push([s,i[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=u}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(G,e,A,O,k,N,T,b,f,a,y,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(s){return Object.isFrozen(s)?s:b.deepFreeze(s)}class S{constructor(t={},n=[],r=[],o){this._contents=t,this._keys=n,this._overrides=r,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof S)return n;const r=new C("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const r=this;return{get value(){return m(r.rawConfiguration.getValue(t))},get override(){return n?m(r.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return m(n?r.rawConfiguration.override(n).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:c,identifiers:R,keys:D}of r.rawConfiguration.overrides){const w=new S(c,D).getValue(t);w!==void 0&&o.push({identifiers:R,value:w})}return o.length?m(o):void 0}}}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,y.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return A.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return A.distinct(t)}override(t){let n=this.overrideConfigurations.get(t);return n||(n=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,n)),n}merge(...t){const n=b.deepClone(this.contents),r=b.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const R of t)if(c.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.mergeContents(n,R.contents);for(const D of R.overrides){const[w]=r.filter(L=>A.equals(L.identifiers,D.identifiers));w?(this.mergeContents(w.contents,D.contents),w.keys.push(...D.keys),w.keys=A.distinct(w.keys)):r.push(b.deepClone(D))}for(const D of R.keys)o.indexOf(D)===-1&&o.push(D)}return new S(n,o,r,c.every(R=>R instanceof S)?void 0:c)}createOverrideConfigurationModel(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[o];const R=n[o];R&&(typeof c=="object"&&typeof R=="object"?(c=b.deepClone(c),this.mergeContents(c,R)):c=R),r[o]=c}return new S(r,this.keys,this.overrides)}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&f.isObject(t[r])&&f.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=b.deepClone(n[r])}}getContentsForOverrideIdentifer(t){let n=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=b.deepClone(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===t?n=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.updateValue(t,n,!0)}setValue(t,n){this.updateValue(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.removeFromValueTree)(this.contents,t),P.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>A.equals(r.identifiers,(0,P.overrideIdentifiersFromKey)(t))),1))}updateValue(t,n,r){(0,y.addToValueTree)(this.contents,t,n,o=>console.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),P.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,P.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,y.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=S;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!f.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:o,overrides:c,restricted:R,hasExcludedProperties:D}=this.doParseRaw(t,n);this._configurationModel=new S(r,o,c,D?[t]:void 0),this._restrictedConfigurations=R||[]}doParseContent(t){let n={},r=null,o=[];const c=[],R=[];function D(L){Array.isArray(o)?o.push(L):r!==null&&(o[r]=L)}const w={onObjectBegin:()=>{const L={};D(L),c.push(o),o=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const L=[];D(L),c.push(o),o=L,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:D,onError:(L,W,J)=>{R.push({error:L,offset:W,length:J})}};if(t)try{k.visit(t,w),n=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return n}doParseRaw(t,n){const r=d.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,n);t=o.raw;const c=(0,y.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),R=Object.keys(t),D=this.toOverrides(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:c,keys:R,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,n,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:c};const R={},D=[];for(const w in t)if(P.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const L=this.filter(t[w],n,!1,o);R[w]=L.raw,c=c||L.hasExcludedProperties,D.push(...L.restricted)}else{const L=n[w],W=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&D.push(w),!o.exclude?.includes(w)&&(o.include?.includes(w)||(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&!(o.skipRestricted&&L?.restricted))?R[w]=t[w]:c=!0}return{raw:R,restricted:D,hasExcludedProperties:c}}toOverrides(t,n){const r=[];for(const o of Object.keys(t))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const R in t[o])c[R]=t[o][R];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,y.toValuesTree)(c,n)})}return r}}e.ConfigurationModelParser=C;class E extends N.Disposable{constructor(t,n,r,o){super(),this.userSettingsResource=t,this.parseOptions=n,this.fileService=o,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class l{constructor(t,n,r,o,c,R,D,w,L,W,J,X,oe){this.key=t,this.overrides=n,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=R,this.applicationConfiguration=D,this.userConfiguration=w,this.localUserConfiguration=L,this.remoteUserConfiguration=W,this.workspaceConfiguration=J,this.folderConfigurationModel=X,this.memoryConfigurationModel=oe}get value(){return m(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class v{constructor(t,n,r,o,c=new S,R=new S,D=new T.ResourceMap,w=new S,L=new T.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=R,this._folderConfigurations=D,this._memoryConfiguration=w,this._memoryConfigurationByResource=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidatedConfigurationModel(t,n,r).getValue(t)}updateValue(t,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new S,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(t):o.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const o=this.getConsolidatedConfigurationModel(t,n,r),c=this.getFolderConfigurationModelForResource(n.resource,r),R=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,D=new Set;for(const w of o.overrides)for(const L of w.identifiers)o.getOverrideValue(t,L)!==void 0&&D.add(L);return new l(t,n,o.getValue(t),D.size?[...D]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,c||void 0,R)}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:o,updated:c,removed:R}=g(this._defaultConfiguration,t);n=[...o,...c,...R]}for(const o of n)for(const c of(0,P.overrideIdentifiersFromKey)(o)){const R=this._defaultConfiguration.getKeysForOverrideIdentifier(c),D=t.getKeysForOverrideIdentifier(c),w=[...D.filter(L=>R.indexOf(L)===-1),...R.filter(L=>D.indexOf(L)===-1),...R.filter(L=>!b.equals(this._defaultConfiguration.override(c).getValue(L),t.override(c).getValue(L)))];r.push([c,w])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:o}=g(this._policyConfiguration,t),c=[...n,...r,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.applicationConfiguration,t),R=[...n,...r,...o];return R.length&&this.updateApplicationConfiguration(t),{keys:R,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.localUserConfiguration,t),R=[...n,...r,...o];return R.length&&this.updateLocalUserConfiguration(t),{keys:R,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.remoteUserConfiguration,t),R=[...n,...r,...o];return R.length&&this.updateRemoteUserConfiguration(t),{keys:R,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.workspaceConfiguration,t),R=[...n,...r,...o];return R.length&&this.updateWorkspaceConfiguration(t),{keys:R,overrides:c}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:o,updated:c,removed:R,overrides:D}=g(r,n),w=[...o,...c,...R];return(w.length||!r)&&this.updateFolderConfiguration(t,n),{keys:w,overrides:D}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:c,overrides:R}=g(n,void 0);return{keys:[...r,...o,...c],overrides:R}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,n,r){let o=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const o=n.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(t);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(n=r.merge(o),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this._workspaceConfiguration.keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),o=this.parseConfigurationModel(t.application),c=this.parseConfigurationModel(t.user),R=this.parseConfigurationModel(t.workspace),D=t.folders.reduce((w,L)=>(w.set(a.URI.revive(L[0]),this.parseConfigurationModel(L[1])),w),new T.ResourceMap);return new v(n,r,o,c,new S,R,D,new S,new T.ResourceMap)}static parseConfigurationModel(t){return new S(t.contents,t.keys,t.overrides)}}e.Configuration=v;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const o of s)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,R])=>{const D=(0,T.getOrSet)(n,c,new Set);R.forEach(w=>D.add(w))});const r=[];return n.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=p;class u{constructor(t,n,r,o){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const R of c)this.affectedKeys.add(R);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const c=o+r.length;if(c>=this._affectsConfigStr.length)return!1;const R=this._affectsConfigStr.charCodeAt(c);if(R!==this._markerCode1&&R!==this._markerCode2)return!1;if(n){const D=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.previous?.workspace):void 0,w=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!b.equals(D,w)}return!0}}e.ConfigurationChangeEvent=u;function g(s,t){const{added:n,removed:r,updated:o}=i(t?.rawConfiguration,s?.rawConfiguration),c=[],R=s?.getAllOverrideIdentifiers()||[],D=t?.getAllOverrideIdentifiers()||[];if(t){const w=D.filter(L=>!R.includes(L));for(const L of w)c.push([L,t.getKeysForOverrideIdentifier(L)])}if(s){const w=R.filter(L=>!D.includes(L));for(const L of w)c.push([L,s.getKeysForOverrideIdentifier(L)])}if(t&&s){for(const w of R)if(D.includes(w)){const L=i({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});c.push([w,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:r,updated:o,overrides:c}}function i(s,t){const n=s?t?s.keys.filter(c=>t.keys.indexOf(c)===-1):[...s.keys]:[],r=t?s?t.keys.filter(c=>s.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(s&&t){for(const c of t.keys)if(s.keys.indexOf(c)!==-1){const R=(0,y.getConfigurationValue)(t.contents,c),D=(0,y.getConfigurationValue)(s.contents,c);b.equals(R,D)||o.push(c)}}return{added:n,removed:r,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(G,e,A,O,k,N,T,b,f,a,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(P.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:l})=>this.onDidUpdateConfiguration(Array.from(E),l))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(E,l){this.updateConfigurationModel(E,P.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:E})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new b.ConfigurationModel;const E=P.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(E),E)}updateConfigurationModel(E,l){const v=this.getConfigurationDefaultOverrides();for(const p of E){const u=v[p],g=l[p];u!==void 0?this._configurationModel.addValue(p,u):g?this._configurationModel.addValue(p,g.default):this._configurationModel.removeValue(p)}}}e.DefaultConfiguration=d;class m{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new b.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let S=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(E,l,v){super(),this.defaultConfiguration=E,this.policyService=l,this.logService=v,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new b.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(E=>this.onDidChangePolicies(E))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:E})=>this.update(await this.updatePolicyDefinitions(E),!0))),this._configurationModel}async updatePolicyDefinitions(E){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",E);const l={},v=[],p=P.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const u of E){const g=p[u];if(!g){v.push(u);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.logService.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}v.push(u),l[g.policy.name]={type:g.type}}}return(0,T.isEmptyObject)(l)||await this.policyService.updatePolicyDefinitions(l),v}onDidChangePolicies(E){this.logService.trace("PolicyConfiguration#onDidChangePolicies",E);const l=P.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),v=(0,A.coalesce)(E.map(p=>l.get(p)));this.update(v,!0)}update(E,l){this.logService.trace("PolicyConfiguration#update",E);const v=P.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),p=[],u=this._configurationModel.isEmpty();for(const g of E){const i=v[g]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(u?s!==void 0:!(0,N.equals)(this._configurationModel.getValue(g),s))&&p.push([g,s])}else this._configurationModel.getValue(g)!==void 0&&p.push([g,void 0])}if(p.length){this.logService.trace("PolicyConfiguration#changed",p);const g=this._configurationModel;this._configurationModel=new b.ConfigurationModel;for(const i of g.keys)this._configurationModel.setValue(i,g.getValue(i));for(const[i,s]of p)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=S,e.PolicyConfiguration=S=me([re(1,y.IPolicyService),re(2,a.ILogService)],S)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class l extends f.Disposable{constructor(u,g,i,s){super(),this.settingsResource=u,this._onDidChangeConfiguration=this._register(new N.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new C.DefaultConfiguration),this.policyConfiguration=i instanceof E.NullPolicyService?new C.NullPolicyConfiguration:this._register(new C.PolicyConfiguration(this.defaultConfiguration,i,s)),this.userConfiguration=this._register(new m.UserSettings(this.settingsResource,{},P.extUriBiasedIgnorePathCase,g)),this.configuration=new m.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new m.ConfigurationModel,new m.ConfigurationModel),this.configurationEditing=new v(u,g,this),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:t,properties:n})=>this.onDidDefaultConfigurationChange(t,n))),this._register(this.policyConfiguration.onDidChangeConfiguration(t=>this.onDidPolicyConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[u,g,i]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new m.Configuration(u,g,new m.ConfigurationModel,i)}getConfigurationData(){return this.configuration.toData()}getValue(u,g){const i=typeof u=="string"?u:void 0,s=(0,d.isConfigurationOverrides)(u)?u:(0,d.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(i,s,void 0)}async updateValue(u,g,i,s,t){const n=(0,d.isConfigurationUpdateOverrides)(i)?i:(0,d.isConfigurationOverrides)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,r=n?s:i;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${u} to target ${r}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,A.distinct)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(u,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,a.equals)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const R=n.overrideIdentifiers.sort(),D=this.configuration.localUserConfiguration.overrides.find(w=>(0,A.equals)([...w.identifiers].sort(),R));D&&(n.overrideIdentifiers=D.identifiers)}const c=n?.overrideIdentifiers?.length?[(0,S.keyFromOverrideIdentifiers)(n.overrideIdentifiers),u]:[u];await this.configurationEditing.write(c,g),await this.reloadConfiguration()}inspect(u,g={}){return this.configuration.inspect(u,g,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const u=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(u)}onDidChangeUserConfiguration(u){const g=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(u);this.trigger(i,g,2)}onDidDefaultConfigurationChange(u,g){const i=this.configuration.toData(),s=this.configuration.compareAndUpdateDefaultConfiguration(u,g);this.trigger(s,i,7)}onDidPolicyConfigurationChange(u){const g=this.configuration.toData(),i=this.configuration.compareAndUpdatePolicyConfiguration(u);this.trigger(i,g,7)}trigger(u,g,i){const s=new m.ConfigurationChangeEvent(u,{data:g},this.configuration);s.source=i,this._onDidChangeConfiguration.fire(s)}}e.ConfigurationService=l;class v{constructor(u,g,i){this.settingsResource=u,this.fileService=g,this.configurationService=i,this.queue=new O.Queue}write(u,g){return this.queue.queue(()=>this.doWriteConfiguration(u,g))}async doWriteConfiguration(u,g){let i;try{i=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const s=[];if((0,T.parse)(i,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.getEdits(i,u,g);i=(0,b.applyEdits)(i,t),await this.fileService.writeFile(this.settingsResource,k.VSBuffer.fromString(i))}getEdits(u,g,i){const{tabSize:s,insertSpaces:t,eol:n}=this.formattingOptions;if(!g.length){const r=JSON.stringify(i,null,t?" ".repeat(s):"	");return[{content:r,length:r.length,offset:0}]}return(0,b.setProperty)(u,g,i,{tabSize:s,insertSpaces:t,eol:n})}get formattingOptions(){if(!this._formattingOptions){let u=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(u=g),this._formattingOptions={eol:u,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ie[67],ne([0,1,15]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(a){return a.scheme===A.Schemas.vscodeRemote?a.authority:void 0}e.getRemoteAuthority=O;function k(a){if(!a)return;const y=a.indexOf("+");return y<0?a:a.substr(0,y)}e.getRemoteName=k;function N(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.getRemoteServerRootPath=N;function T(a){const{host:y,port:P}=f(a);if(typeof P>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:P}}e.parseAuthorityWithPort=T;function b(a,y){let{host:P,port:d}=f(a);return typeof d>"u"&&(d=y),{host:P,port:d}}e.parseAuthorityWithOptionalPort=b;function f(a){const y=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const P=a.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const d=a.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}e.getWorkspaceSupportTypeMessage=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(T||(e.ExtensionType=T={}));var b;(function(C){C.WIN32_X64="win32-x64",C.WIN32_ARM64="win32-arm64",C.LINUX_X64="linux-x64",C.LINUX_ARM64="linux-arm64",C.LINUX_ARMHF="linux-armhf",C.LINUX_PPC64LE="linux-ppc64le",C.ALPINE_X64="alpine-x64",C.ALPINE_ARM64="alpine-arm64",C.DARWIN_X64="darwin-x64",C.DARWIN_ARM64="darwin-arm64",C.WEB="web",C.UNIVERSAL="universal",C.UNKNOWN="unknown",C.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class f{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,l){if(typeof E>"u"||E===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof E=="string"||typeof l=="string"){const v=typeof E=="string"?E:E.value,p=typeof l=="string"?l:l.value;return A.equalsIgnoreCase(v,p)}return E._lower===l._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=f;class a{get size(){return this._set.size}constructor(E){if(this._set=new Set,E)for(const l of E)this.add(l)}add(E){this._set.add(f.toKey(E))}delete(E){return this._set.delete(f.toKey(E))}has(E){return this._set.has(f.toKey(E))}}e.ExtensionIdentifierSet=a;class y{constructor(){this._map=new Map}clear(){this._map.clear()}delete(E){this._map.delete(f.toKey(E))}get(E){return this._map.get(f.toKey(E))}has(E){return this._map.has(f.toKey(E))}set(E,l){this._map.set(f.toKey(E),l)}values(){return this._map.values()}forEach(E){this._map.forEach(E)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=y;function P(C){return d(C)}e.isApplicationScopedExtension=P;function d(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function m(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function S(C,E){if(E){const l=`onResolveRemoteAuthority:${(0,k.getRemoteName)(E)}`;return!!C.activationEvents?.includes(l)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends A.Disposable{constructor(b,f,a,y,P){super(),this.userDataProfilesService=b,this.fileService=f,this.uriIdentityService=a,this.logService=P,this._register(y.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(y.onDidUninstallExtension(d=>this.onDidUnInstallExtension(d)))}onDidInstallExtensions(b){for(const f of b)f.local&&this.invalidate(f.profileLocation)}onDidUnInstallExtension(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const f of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(f.extensionsResource,b)&&await this.deleteUserCacheFile(f);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(b){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(b.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(f){(0,k.toFileOperationResult)(f)!==1&&this.logService.error(f)}}}e.ExtensionsManifestCache=N}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(G,e,A,O,k,N,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,b.createDecorator)("requestService");class y{constructor(g){this.original=g}toJSON(){if(!this.headers){const g=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.original[i];this.headers=g}return this.headers}}class P extends k.Disposable{constructor(g){super(),this.counter=0,this.logger=g.createLogger("network",{name:(0,N.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(g,i,s){const t=`${g} #${++this.counter}: ${i.url}`;this.logger.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await s();return this.logger.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${t} - error`,i.type,(0,O.getErrorMessage)(n)),n}}}e.AbstractRequestService=P;function d(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=d;function m(u){return u.res.statusCode===204}e.hasNoContent=m;async function S(u){return m(u)?null:(await(0,A.streamToBuffer)(u.stream)).toString()}e.asText=S;async function C(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);return S(u)}e.asTextOrError=C;async function E(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);if(m(u))return null;const i=(await(0,A.streamToBuffer)(u.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}e.asJson=E;function l(u){p(u)}e.updateProxyConfigurationsScope=l;let v;function p(u){const g=a.Registry.as(T.Extensions.Configuration),i=v;v={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[v],remove:i?[i]:[]})}p(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(f,a){this.requestService=f,this.fileService=a}async download(f,a,y=A.CancellationToken.None){if(f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(f,a);return}const P={type:"GET",url:f.toString(!0)},d=await this.requestService.request(P,y);if(d.res.statusCode===200)await this.fileService.writeFile(a,d.stream);else{const m=await(0,N.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};e.DownloadService=T,e.DownloadService=T=me([re(0,N.IRequestService),re(1,k.IFileService)],T)}),define(ie[139],ne([0,1,140,3]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(T,b){return T.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:T.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function N(T,b,f={}){const a=(0,A.parse)(T),y=f.proxyUrl||k(a,b);if(!y)return null;const P=(0,A.parse)(y);if(!/^https?:$/.test(P.protocol||""))return null;const d={host:P.hostname||"",port:(P.port?+P.port:0)||(P.protocol==="https"?443:80),auth:P.auth,rejectUnauthorized:(0,O.isBoolean)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((m,S)=>{G(["http-proxy-agent"],m,S)})).HttpProxyAgent(y,d):new(await new Promise((m,S)=>{G(["https-proxy-agent"],m,S)})).HttpsProxyAgent(y,d)}e.getProxyAgent=N}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let S;async function C(l,v,p,u){return p["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(u)&&!p["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=d.Promises.withAsyncBody(async(g,i)=>{const s=new N.CancellationTokenSource;let t=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,m.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{g(await E(v,s.token))}catch(o){!(0,b.isCancellationError)(o)&&!s.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(o)))):g({})}finally{clearTimeout(r),s.dispose()}})),S)}e.getResolvedShellEnv=C;async function E(l,v){const p=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",p);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",u);const g=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",s);const t=await(0,y.getSystemShell)(f.OS,s);return l.trace("getUnixShellEnvironment#shell",t),new Promise((n,r)=>{if(v.isCancellationRequested)return r(new b.CancellationError);const o=(0,O.basename)(t);let c,R;const D="";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${D} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,R=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${D} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,R=["-i","-l","-c"]):o==="xonsh"?(c=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,R=["-i","-l","-c"]):(c=`'${process.execPath}' ${D} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?R=["-ic"]:R=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),c);const w=(0,A.spawn)(t,[...R,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(w.kill(),r(new b.CancellationError))),w.on("error",J=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(J)),r(J)});const L=[];w.stdout.on("data",J=>L.push(J));const W=[];w.stderr.on("data",J=>W.push(J)),w.on("close",(J,X)=>{const oe=Buffer.concat(L).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const se=Buffer.concat(W).toString("utf8");if(se.trim()&&l.trace("getUnixShellEnvironment#stderr",se),J||X)return r(new Error((0,k.localize)(2,null,J,X)));const fe=i.exec(oe),de=fe?fe[1]:"{}";try{const ae=JSON.parse(de);p?ae.ELECTRON_RUN_AS_NODE=p:delete ae.ELECTRON_RUN_AS_NODE,u?ae.ELECTRON_NO_ATTACH_CONSOLE=u:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(ae)),r(ae)}})})}}),define(ie[142],ne([0,1,10]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,A.createDecorator)("stateReadService"),e.IStateService=(0,A.createDecorator)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(G,e,A,O,k,N,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends k.Disposable{constructor(S,C,E,l){super(),this.storagePath=S,this.saveStrategy=C,this.logService=E,this.fileService=l,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new A.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,C){const E=this.storage[S];return(0,N.isUndefinedOrNull)(E)?C:E}setItem(S,C){this.setItems([{key:S,data:C}])}setItems(S){let C=!1;for(const{key:E,data:l}of S)this.storage[E]!==l&&((0,N.isUndefinedOrNull)(l)?(0,N.isUndefined)(this.storage[E])||(this.storage[E]=void 0,C=!0):(this.storage[E]=l,C=!0));C&&this.save()}removeItem(S){(0,N.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(S),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=S}catch(C){this.logService.error(C)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let P=class extends k.Disposable{constructor(S,C,E,l){super(),this.fileStorage=this._register(new y(C.stateResource,S,E,l))}async init(){await this.fileStorage.init()}getItem(S,C){return this.fileStorage.getItem(S,C)}};e.StateReadonlyService=P,e.StateReadonlyService=P=me([re(1,T.IEnvironmentService),re(2,f.ILogService),re(3,b.IFileService)],P);class d extends P{setItem(S,C){this.fileStorage.setItem(S,C)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}}e.StateService=d}),define(ie[69],ne([0,1,12,35,28]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(f){if(A.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function T(f,a,y,P,d,m,S,C,E){const l=Object.create(null);l["common.machineId"]=m,l["common.sqmId"]=S,l.sessionID=(0,k.generateUuid)()+Date.now(),l.commitHash=P,l.version=d,l["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,A.PlatformToString)(A.platform),l["common.nodePlatform"]=O.platform,l["common.nodeArch"]=y,l["common.product"]=E||"desktop",C&&(l["common.msftInternal"]=C);let v=0;const p=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),A.isLinuxSnap&&(l["common.snap"]="true");const u=N(a);return u&&(l["common.platformDetail"]=u),l}e.resolveCommonProperties=T;function b(f){const a=O.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return f.some(P=>y===P)}e.verifyMicrosoftInternalDomain=b}),define(ie[25],ne([0,1,10]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,A.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,A.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(G,e,A,O,k,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class b{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=b;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=f,e.NullTelemetryService=new f;class a{async publicLog(s,t,n){}async publicLogError(s,t,n){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=y;function P(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=P;function d(i){const s=i.getValue(T.TELEMETRY_SETTING_ID),t=i.getValue(T.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function m(i){const s={},t={},n={};E(i,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const o=n[r];typeof o=="number"?t[r]=o:typeof o=="boolean"?t[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),s[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[r]=o)}return{properties:s,measurements:t}}e.validateTelemetryData=m;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function C(i){if(!i)return"none";const s=(0,k.getRemoteName)(i);return S.has(s)?s:"other"}e.cleanRemoteAuthority=C;function E(i,s,t=0,n){if(i)for(const r of Object.getOwnPropertyNames(i)){const o=i[r],c=n?n+r:r;Array.isArray(o)?s[c]=(0,A.safeStringify)(o):o instanceof Date?s[c]=o.toISOString():(0,O.isObject)(o)?t<2?E(o,s,t+1,c+"."):s[c]=(0,A.safeStringify)(o):s[c]=o}}function l(i,s){const t=i.msftInternalDomains||[],n=s.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(t)||n}e.isInternalTelemetry=l;function v(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=v;function p(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const R of s)for(;;){const D=R.exec(i);if(!D)break;n.push([D.index,R.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(t="";;){const R=o.exec(i);if(!R)break;const D=n.some(([w,L])=>R.index<L&&w<o.lastIndex);!r.test(R[0])&&!D&&(t+=i.substring(c,R.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<i.length&&(t+=i.substr(c)),t}function u(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of s)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,s){return(0,A.cloneAndChange)(i,t=>{if(t instanceof b||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=p(n,s);for(const r of s)n=n.replace(r,"");return n=u(n),n}})}e.cleanData=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(G,e,A,O,k,N,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,A.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=y;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,o)}static parse(n){const r=P.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(t){const n=m.exec(t);return n&&n[1]?[E(n[1]),n[2]]:[E(t),void 0]}e.getIdAndVersion=S;function C(t,n){return`${t}.${n}`}e.getExtensionId=C;function E(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=E;function l(t,n){return E(C(t??k.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=l;function v(t,n){const r=[],o=c=>{for(const R of r)if(R.some(D=>y(n(D),n(c))))return R;return null};for(const c of t){const R=o(c);R?R.push(c):r.push([c])}return r}e.groupByExtension=v;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function u(t){return{id:new a.TelemetryTrustedValue(t.identifier.id),name:new a.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(t,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(R=>!y(R.identifier,{id:c}))){const R=t.filter(D=>y(D.identifier,{id:c}));R.length===1&&(r.push(R[0]),o.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=g;async function i(t,n){if(!N.isLinux)return!1;let r;try{r=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(t,n){const r=await i(t,n),o=(0,O.getTargetPlatform)(r?"alpine":N.platform,f.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(G,e,A,O,k,N,T,b,f,a,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=C=>(0,f.localize)(0,null,C),m=(0,f.localize)(1,null,"ms-dotnettools.csharp");let S=class{constructor(E,l,v){this.logger=E,this.extensionManagementService=l,this.extensionGalleryService=v}get location(){}async listExtensions(E,l,v){let p=await this.extensionManagementService.getInstalled(1,v);const u=P.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(l&&l!==""){if(u.indexOf(l.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.logger.info("Possible Categories: "),u.forEach(i=>{this.logger.info(i)});return}this.location&&this.logger.info((0,f.localize)(2,null,this.location)),p=p.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let g;for(const i of p)g!==i.identifier.id&&(g=i.identifier.id,this.logger.info(E?`${g}@${i.manifest.version}`:g))}async installExtensions(E,l,v,p){const u=[];try{E.length&&this.logger.info(this.location?(0,f.localize)(3,null,this.location):(0,f.localize)(4,null));const g=[],i=[],s=(n,r,o)=>{i.push({id:n,version:r!=="prerelease"?r:void 0,installOptions:{...v,isBuiltin:o,installPreReleaseVersion:r==="prerelease"||v.installPreReleaseVersion}})};for(const n of E)if(n instanceof b.URI)g.push({vsix:n,installOptions:v});else{const[r,o]=(0,y.getIdAndVersion)(n);s(r,o,!1)}for(const n of l)if(n instanceof b.URI)g.push({vsix:n,installOptions:{...v,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,o]=(0,y.getIdAndVersion)(n);s(r,o,!0)}const t=await this.extensionManagementService.getInstalled(1,v.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:r})=>{try{await this.installVSIX(n,r,p,t)}catch(o){this.logger.error(o),u.push(n.toString())}})),i.length){const n=await this.installGalleryExtensions(i,t,p);u.push(...n)}}catch(g){throw this.logger.error((0,f.localize)(5,null,(0,O.getErrorMessage)(g))),g}if(u.length)throw new Error((0,f.localize)(6,null,u.join(", ")))}async updateExtensions(E){const l=await this.extensionManagementService.getInstalled(1,E),v=[];for(const i of l)i.identifier.uuid&&v.push({...i.identifier,preRelease:i.preRelease});this.logger.trace((0,f.localize)(7,null,v.length));const p=await this.extensionGalleryService.getExtensions(v,{compatible:!0},A.CancellationToken.None),u=[];for(const i of p)for(const s of l)(0,y.areSameExtensions)(s.identifier,i.identifier)&&(0,T.gt)(i.version,s.manifest.version)&&u.push({extension:i,options:{operation:3,installPreReleaseVersion:s.isPreReleaseVersion}});if(!u.length){this.logger.info((0,f.localize)(8,null));return}this.logger.info((0,f.localize)(9,null,u.map(i=>i.extension.identifier.id).join(", ")));const g=await this.extensionManagementService.installGalleryExtensions(u);for(const i of g)i.error?this.logger.error((0,f.localize)(10,null,i.identifier.id,(0,O.getErrorMessage)(i.error))):this.logger.info((0,f.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async installGalleryExtensions(E,l,v){if(E=E.filter(({id:i,version:s})=>{const t=l.find(n=>(0,y.areSameExtensions)(n.identifier,{id:i}));if(t){if(!v&&(!s||s==="prerelease"&&t.preRelease))return this.logger.info((0,f.localize)(12,null,i,t.manifest.version,i)),!1;if(s&&t.manifest.version===s)return this.logger.info((0,f.localize)(13,null,`${i}@${s}`)),!1}return!0}),!E.length)return[];const p=[],u=[],g=await this.getGalleryExtensions(E);if(await Promise.all(E.map(async({id:i,version:s,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.logger.error(`${d(s?`${i}@${s}`:i)}
${m}`),p.push(i);return}try{const o=await this.extensionGalleryService.getManifest(n,A.CancellationToken.None);if(o&&!this.validateExtensionKind(o))return}catch(o){this.logger.error(o.message||o.stack||o),p.push(i);return}const r=l.find(o=>(0,y.areSameExtensions)(o.identifier,n.identifier));if(r){if(n.version===r.manifest.version){this.logger.info((0,f.localize)(14,null,s?`${i}@${s}`:i));return}this.logger.info((0,f.localize)(15,null,i,n.version))}t.isBuiltin?this.logger.info(s?(0,f.localize)(16,null,i,s):(0,f.localize)(17,null,i)):this.logger.info(s?(0,f.localize)(18,null,i,s):(0,f.localize)(19,null,i)),u.push({extension:n,options:{...t,installGivenVersion:!!s}})})),u.length){const i=await this.extensionManagementService.installGalleryExtensions(u);for(const s of i)s.error?(this.logger.error((0,f.localize)(20,null,s.identifier.id,(0,O.getErrorMessage)(s.error))),p.push(s.identifier.id)):this.logger.info((0,f.localize)(21,null,s.identifier.id,s.local?.manifest.version))}return p}async installVSIX(E,l,v,p){const u=await this.extensionManagementService.getManifest(E);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,v,l.profileLocation,p))try{await this.extensionManagementService.install(E,l),this.logger.info((0,f.localize)(22,null,(0,N.basename)(E)))}catch(i){if((0,O.isCancellationError)(i))this.logger.info((0,f.localize)(23,null,(0,N.basename)(E)));else throw i}}async getGalleryExtensions(E){const l=new Map,v=E.some(g=>g.installOptions.installPreReleaseVersion),p=await this.extensionManagementService.getTargetPlatform(),u=[];for(const g of E)a.EXTENSION_IDENTIFIER_REGEX.test(g.id)&&u.push({...g,preRelease:v});if(u.length){const g=await this.extensionGalleryService.getExtensions(u,{targetPlatform:p},A.CancellationToken.None);for(const i of g)l.set(i.identifier.id.toLowerCase(),i)}return l}validateExtensionKind(E){return!0}async validateVSIX(E,l,v,p){if(!l){const u={id:(0,y.getGalleryExtensionId)(E.publisher,E.name)},g=p.find(i=>(0,y.areSameExtensions)(u,i.identifier)&&(0,T.gt)(i.manifest.version,E.version));if(g)return this.logger.info((0,f.localize)(24,null,g.identifier.id,g.manifest.version,E.version)),!1}return this.validateExtensionKind(E)}async uninstallExtensions(E,l,v){const p=async g=>{if(g instanceof b.URI){const i=await this.extensionManagementService.getManifest(g);return(0,y.getExtensionId)(i.publisher,i.name)}return g},u=[];for(const g of E){const i=await p(g),t=(await this.extensionManagementService.getInstalled(void 0,v)).filter(n=>(0,y.areSameExtensions)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.notInstalled(i)}
${m}`);if(t.some(n=>n.type===0)){this.logger.info((0,f.localize)(25,null,i));return}if(!l&&t.some(n=>n.isBuiltin)){this.logger.info((0,f.localize)(26,null,i));return}this.logger.info((0,f.localize)(27,null,i));for(const n of t)await this.extensionManagementService.uninstall(n,{profileLocation:v}),u.push(n);this.location?this.logger.info((0,f.localize)(28,null,i,this.location)):this.logger.info((0,f.localize)(29,null,i))}}async locateExtension(E){const l=await this.extensionManagementService.getInstalled();E.forEach(v=>{l.forEach(p=>{if(p.identifier.id===v&&p.location.scheme===k.Schemas.file){this.logger.info(p.location.fsPath);return}})})}notInstalled(E){return this.location?(0,f.localize)(30,null,E,this.location):(0,f.localize)(31,null,E)}};e.ExtensionManagementCLI=S,e.ExtensionManagementCLI=S=me([re(1,a.IExtensionManagementService),re(2,a.IExtensionGalleryService)],S)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let u=class extends k.Disposable{static{p=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(i,s,t,n,r,o){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=n,this.extensionSignatureVerificationService=r,this.logService=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,s,t){await this.cleanUpPromise;const n=(0,T.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,n,o=>this.extensionGalleryService.download(i,o,s))}catch(o){throw new S.ExtensionManagementError(o.message,S.ExtensionManagementErrorCode.Download)}let r=!1;if(t&&this.shouldVerifySignature(i)){const o=await this.downloadSignatureArchive(i);try{r=await this.extensionSignatureVerificationService.verify(n.fsPath,o.fsPath,this.logService.getLevel()===v.LogLevel.Trace)}catch(c){const R=c;if(r=R.code,R.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${R.output}`),r===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(D){this.logService.error(D)}throw new S.ExtensionManagementError(P.CorruptZipMessage,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(c){this.logService.error(c)}}}return r===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${i.identifier.id}`),{location:n,verificationStatus:r}}shouldVerifySignature(i){if(!i.isSigned)return this.logService.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,f.isBoolean)(s)?s:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const s=(0,T.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${p.SignatureArchiveExtension}`);try{await this.downloadFile(i,s,t=>this.extensionGalleryService.downloadSignatureArchive(i,t))}catch(t){throw new S.ExtensionManagementError(t.message,S.ExtensionManagementErrorCode.DownloadSignature)}return s}async downloadFile(i,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==N.Schemas.file){await t(s);return}const n=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,a.generateUuid)()}`);await this.fileService.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,s.fsPath,2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],t=[],n=[];for(const c of i.children)if(c.name.endsWith(p.SignatureArchiveExtension))n.push(c.resource);else{const R=C.ExtensionKey.parse(c.name);R&&t.push([R,c])}const r=(0,C.groupByExtension)(t,([c])=>c),o=[];for(const c of r)c.sort((R,D)=>b.rcompare(R[0].version,D[0].version)),s.push(...c.slice(1).map(R=>R[1].resource)),o.push(c[0][1]);o.sort((c,R)=>c.mtime-R.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(c=>c.resource)),s.push(...n),await A.Promises.settled(s.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?C.ExtensionKey.create(i).toString().toLowerCase():(0,a.generateUuid)()}};e.ExtensionsDownloader=u,e.ExtensionsDownloader=u=p=me([re(0,m.INativeEnvironmentService),re(1,l.IFileService),re(2,S.IExtensionGalleryService),re(3,d.IConfigurationService),re(4,E.IExtensionSignatureVerificationService),re(5,v.ILogService)],u)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(G,e,A,O,k,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends O.Disposable{constructor(a,y,P,d,m,S,C){super(),this.extensionManagementService=a,this.extensionsScannerService=y,this.userDataProfilesService=P,this.extensionsProfileScannerService=d,this.uriIdentityService=m,this.fileService=S,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,E=>C.error(E))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(a=>this.onDidChangeProfiles(a.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(a=>this.onAddExtensions(a))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(a=>this.onDidAddExtensions(a))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(a=>this.onRemoveExtensions(a))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(a=>this.onDidRemoveExtensions(a))),this._register(this.fileService.onDidFilesChange(a=>this.onDidFilesChange(a)))}async onDidChangeProfiles(a){try{a.length&&await Promise.all(a.map(y=>(this.extensionsProfileWatchDisposables.set(y.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(y.extensionsResource)),this.fileService.watch(y.extensionsResource))),this.populateExtensionsFromProfile(y.extensionsResource))))}catch(y){throw this.logService.error(y),y}}async onAddExtensions(a){for(const y of a.extensions)this.addExtensionWithKey(this.getKey(y.identifier,y.version),a.profileLocation)}async onDidAddExtensions(a){for(const y of a.extensions){const P=this.getKey(y.identifier,y.version);a.error?this.removeExtensionWithKey(P,a.profileLocation):this.addExtensionWithKey(P,a.profileLocation)}}async onRemoveExtensions(a){for(const y of a.extensions)this.removeExtensionWithKey(this.getKey(y.identifier,y.version),a.profileLocation)}async onDidRemoveExtensions(a){const y=[],P=[];for(const d of a.extensions){const m=this.getKey(d.identifier,d.version);a.error?this.addExtensionWithKey(m,a.profileLocation):(this.removeExtensionWithKey(m,a.profileLocation),this.allExtensions.has(m)||(this.logService.debug("Extension is removed from all profiles",d.identifier.id,d.version),P.push(this.extensionManagementService.scanInstalledExtensionAtLocation(d.location).then(S=>{S?y.push(S):this.logService.info("Extension not found at the location",d.location.toString())},S=>this.logService.error(S)))))}try{await Promise.all(P),y.length&&await this.uninstallExtensionsNotInProfiles(y)}catch(d){this.logService.error(d)}}onDidFilesChange(a){for(const y of this.userDataProfilesService.profiles)a.contains(y.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(y.extensionsResource)}async onDidExtensionsProfileChange(a){const y=[],P=[],d=await this.extensionsProfileScannerService.scanProfileExtensions(a),m=new Set,S=new Set;for(const[C,E]of this.allExtensions)E.has(a)&&S.add(C);for(const C of d){const E=this.getKey(C.identifier,C.version);m.add(E),S.has(E)||(y.push(C.identifier),this.addExtensionWithKey(E,a))}for(const C of S)if(!m.has(C)){const E=this.fromKey(C);E&&(P.push(E.identifier),this.removeExtensionWithKey(C,a))}(y.length||P.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:P.length?{extensions:P,profileLocation:a}:void 0})}async populateExtensionsFromProfile(a){const y=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const P of y)this.addExtensionWithKey(this.getKey(P.identifier,P.version),a)}async uninstallExtensionsNotInProfiles(a){a||(a=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(P=>!this.allExtensions.has(this.getKey(P.identifier,P.manifest.version)))),a.length&&await this.extensionManagementService.markAsUninstalled(...a)}addExtensionWithKey(a,y){let P=this.allExtensions.get(a);P||this.allExtensions.set(a,P=new k.ResourceSet(d=>this.uriIdentityService.extUri.getComparisonKey(d))),P.add(y)}removeExtensionWithKey(a,y){const P=this.allExtensions.get(a);P&&P.delete(y),P?.size||this.allExtensions.delete(a)}getKey(a,y){return`${T.ExtensionIdentifier.toKey(a.id)}@${y}`}fromKey(a){const[y,P]=(0,N.getIdAndVersion)(a);return P?{identifier:{id:y},version:P}:void 0}}e.ExtensionsWatcher=b}),define(ie[146],ne([0,1,117,41]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(N,T,b,f,a,y,P){const d={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,b)&&(0,O.getTelemetryLevel)(f)===3){const m=await(0,A.getServiceMachineId)(b,a,y);d["X-Market-User-Id"]=m,d["VSCode-SessionId"]=P.machineId||m}return d}e.resolveMarketplaceHeaders=k}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let C=class extends m.LanguagePackBaseService{constructor(p,u,g,i){super(g),this.extensionManagementService=p,this.logService=i,this.cache=this._register(new E(u,i)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(p,u){const i=(await this.cache.getLanguagePacks())[u];if(!i){this.logService.warn(`No language pack found for ${u}`);return}const s=i.translations[p];return s?S.URI.file(s):void 0}async getInstalledLanguages(){const p=await this.cache.getLanguagePacks(),u=Object.keys(p).map(g=>{const i=p[g];return{...this.createQuickPickItem(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return u.push(this.createQuickPickItem("en","English")),u.sort((g,i)=>g.label.localeCompare(i.label)),u}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const u=await this.cache.getLanguagePacks();Object.keys(u).some(g=>u[g]&&u[g].extensions.some(i=>(0,P.areSameExtensions)(i.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(u);return!(0,O.equals)(Object.keys(p),Object.keys(g))}};e.NativeLanguagePackService=C,e.NativeLanguagePackService=C=me([re(0,y.IExtensionManagementService),re(1,a.INativeEnvironmentService),re(2,y.IExtensionGalleryService),re(3,d.ILogService)],C);let E=class extends N.Disposable{constructor(p,u){super(),this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(u=>{Object.keys(u).forEach(g=>delete u[g]),this.createLanguagePacksFromExtensions(u,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...u){for(const g of u)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,g);Object.keys(p).forEach(g=>this.updateHash(p[g]))}createLanguagePacksFromExtension(p,u){const g=u.identifier,i=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of i)if(u.location.scheme===T.Schemas.file&&l(s)){let t=p[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},p[s.languageId]=t);const n=t.extensions.filter(r=>(0,P.areSameExtensions)(r.extensionIdentifier,g))[0];n?n.version=u.manifest.version:t.extensions.push({extensionIdentifier:g,version:u.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,b.join)(u.location.fsPath,r.path)}}updateHash(p){if(p){const u=(0,A.createHash)("md5");for(const g of p.extensions)u.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);p.hash=u.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return f.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(u=p(g),g)).then(g=>{for(const s of Object.keys(g))g[s]||delete g[s];this.languagePacks=g,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),f.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>u,g=>this.logService.error(g))})}};E=me([re(0,a.INativeEnvironmentService),re(1,d.ILogService)],E);function l(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const p of v.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",b="https://0.0.0.0/ping";async function f(y,P,d){const m=await(0,A.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,A.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),C=new m.AppInsightsCore,E=new S.PostChannel,l={instrumentationKey:y,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(d){l.extensionConfig={};const v={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};l.extensionConfig[E.identifier]=v}return C.initialize(l,[]),C.addTelemetryInitializer(v=>{v.ext=v.ext??{},v.ext.web=v.ext.web??{},v.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',P&&(v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),C}class a{constructor(P,d,m,S,C){this._isInternalTelemetry=P,this._eventPrefix=d,this._defaultData=m,this._xhrOverride=C,this.endPointUrl=T,this.endPointHealthUrl=b,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(P){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=f(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{P(d)},d=>{(0,O.onUnexpectedError)(d),console.error(d)})}}log(P,d){if(!this._aiCoreOrKey)return;d=(0,k.mixin)(d,this._defaultData),d=(0,N.validateTelemetryData)(d);const m=this._eventPrefix+"/"+P;try{this._withAIClient(S=>{S.pluginVersionString=d?.properties.version??"Unknown",S.track({name:m,baseData:{name:m,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,v,p){this._configurationService=v,this._productService=p,this._experimentProperties={},this._disposables=new A.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,N.escapeRegExpCharacters)(u),"gi")),u.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,N.escapeRegExpCharacters)(u.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(u=>{(u.affectsConfiguration(d.TELEMETRY_SETTING_ID)||u.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||u.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(l,v){this._experimentProperties[l]=v}_updateTelemetryLevel(){let l=(0,m.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const p=v.usage?3:v.error?2:0;l=Math.min(l,p)}this._telemetryLevel=l}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(l,v,p){this._telemetryLevel<v||(p=(0,O.mixin)(p,this._experimentProperties),p=(0,m.cleanData)(p,this._cleanupPatterns),p=(0,O.mixin)(p,this._commonProperties),this._appenders.forEach(u=>u.log(l,p)))}publicLog(l,v){this._log(l,3,v)}publicLog2(l,v){this.publicLog(l,v)}publicLogError(l,v){this._sendErrorTelemetry&&this._log(l,2,v)}publicLogError2(l,v){this.publicLogError(l,v)}};e.TelemetryService=S,e.TelemetryService=S=me([re(1,b.IConfigurationService),re(2,y.IProductService)],S);function C(){const E=(0,T.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=k.isWeb?"":(0,T.localize)(3,null),p=(0,T.localize)(4,null),u=(0,T.localize)(5,null),g=(0,T.localize)(6,null),i=(0,T.localize)(7,null),s=`
|       | ${p} | ${u} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${E} ${l} ${v}

&nbsp;

${i}
${s}

&nbsp;

${t}
`}P.Registry.as(f.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:C(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(f.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,T.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,T.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(G,e,A,O,k,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function T(y,P){const d=await P.request(y,O.CancellationToken.None),m=(await(0,A.streamToBuffer)(d.stream)).toString(),S=d.res.statusCode??200;return{headers:d.res.headers,statusCode:S,responseData:m}}async function b(y){const P={method:y.type,headers:y.headers};return new Promise((m,S)=>{const C=k.request(y.url??"",P,E=>{E.on("data",function(l){m({headers:E.headers,statusCode:E.statusCode??200,responseData:l.toString()})}),E.on("error",function(l){S(l)})});C.write(y.data,E=>{E&&S(E)}),C.end()})}async function f(y,P,d){const m=typeof P.data=="string"?P.data:new TextDecoder().decode(P.data),S={type:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data).toString()},url:P.urlString,data:m};try{const C=y?await T(S,y):await b(S);d(C.statusCode,C.headers,C.responseData)}catch{d(0,{})}}class a extends N.AbstractOneDataSystemAppender{constructor(P,d,m,S,C){const E={sendPOST:(l,v)=>{f(P,l,v)}};super(d,m,S,C,E)}}e.OneDataSystemAppender=a}),define(ie[152],ne([0,1,16,24]),function(G,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(N,T){const b=Object.create(null),f=(y,P)=>{const d=JSON.parse(y);b[P]=d};if(T){const y=[],P=await O.Promises.readdir(T);for(const m of P)try{(await O.Promises.stat((0,A.join)(T,m))).isDirectory()&&y.push(m)}catch{}const d=[];for(const m of y)(await O.Promises.readdir((0,A.join)(T,m))).filter(C=>C==="telemetry.json").length===1&&d.push(m);for(const m of d){const S=(await O.Promises.readFile((0,A.join)(T,m,"telemetry.json"))).toString();f(S,m)}}let a=(await O.Promises.readFile((0,A.join)(N,"telemetry-core.json"))).toString();return f(a,"vscode-core"),a=(await O.Promises.readFile((0,A.join)(N,"telemetry-extensions.json"))).toString(),f(a,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=k}),define(ie[153],ne([0,1,12,84,25]),function(G,e,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function N(b,f){let a=b.getItem(k.machineIdKey);return(typeof a!="string"||A.isMacintosh&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,O.getMachineId)(f.error.bind(f))),a}e.resolveMachineId=N;async function T(b,f){let a=b.getItem(k.sqmIdKey);return typeof a!="string"&&(a=await(0,O.getSqmMachineId)(f.error.bind(f))),a}e.resolveSqmId=T}),define(ie[22],ne([0,1,10]),function(G,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,A.createDecorator)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(G,e,A,O,k,N,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this._fileService=d,this._dispooables=new f.DisposableStore,this._limit=2**16;const m=new Map,S=C=>{let E=m.get(C.scheme);return E===void 0&&(E=d.hasProvider(C)&&!this._fileService.hasCapability(C,1024),m.set(C.scheme,E)),E};this._dispooables.add(b.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(C=>{m.delete(C.scheme)})),this.extUri=new N.ExtUri(S),this._canonicalUris=new T.SkipList((C,E)=>this.extUri.compare(C,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,N.normalizePath)(d));const m=this._canonicalUris.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new a(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((S,C)=>S[1].time<C[1].time?1:S[1].time>C[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let S=0;S<m;S++)this._canonicalUris.set(d[S][0],d[S][1].touch())}};e.UriIdentityService=y,e.UriIdentityService=y=me([re(0,k.IFileService)],y),(0,O.registerSingleton)(A.IUriIdentityService,y,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(G,e,A,O,k,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class b extends O.Disposable{constructor(a,y,P,d,m,S){super(),this.fileSystemScheme=a,this.fileSystemProvider=y,this.userDataScheme=P,this.userDataProfilesService=d,this.uriIdentityService=m,this.logService=S,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=N.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new T.ResourceSet(C=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(C))),this.updateAtomicReadWritesResources(),this._register(d.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(C=>this.handleFileChanges(C)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,y){return this.fileSystemProvider.open(this.toFileSystemResource(a),y)}close(a){return this.fileSystemProvider.close(a)}read(a,y,P,d,m){return this.fileSystemProvider.read(a,y,P,d,m)}write(a,y,P,d,m){return this.fileSystemProvider.write(a,y,P,d,m)}watch(a,y){this.watchResources.set(a,a);const P=this.fileSystemProvider.watch(this.toFileSystemResource(a),y);return(0,O.toDisposable)(()=>{this.watchResources.delete(a),P.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,y,P){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(y),P)}readFile(a,y){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),y)}readFileStream(a,y,P){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),y,P)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,y,P){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),y,P)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.fileSystemProvider.delete(this.toFileSystemResource(a),y)}copy(a,y,P){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(y),P);throw new Error("copy not supported")}cloneFile(a,y){if((0,k.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(y));throw new Error("clone not supported")}handleFileChanges(a){const y=[];for(const P of a){if(P.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(P.resource);this.watchResources.findSubstr(d)&&y.push({resource:d,type:P.type,cId:P.cId})}y.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(y))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=b}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(G,e,A,O,k,N,T,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function a(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=a;function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.isEmptyWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=P;function d(n){const r=n;return typeof r?.id=="string"&&T.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=d;function m(n){const r=n;if(r?.uri)return{id:r.id,uri:T.URI.revive(r.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function C(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=C;function E(n){const r=n;return!!(r&&typeof r=="object"&&T.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=E;class l{constructor(r,o,c,R,D){this._id=r,this._transient=c,this._configuration=R,this._ignorePathCasing=D,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,N.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function p(n){return new v({uri:n,index:0,name:(0,N.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(n,r){return N.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function g(n){let r;return T.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=g,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function s(n,r){return!u(n,r)&&!g(n)}e.isSavedWorkspace=s;function t(n){return(typeof n=="string"?(0,O.extname)(n):(0,N.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var p;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(p||(e.ProfileResourceType=p={}));function u(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&T.URI.isUri(r.location)&&T.URI.isUri(r.globalStorageHome)&&T.URI.isUri(r.settingsResource)&&T.URI.isUri(r.keybindingsResource)&&T.URI.isUri(r.tasksResource)&&T.URI.isUri(r.snippetsHome)&&T.URI.isUri(r.extensionsResource))}e.isUserDataProfile=u,e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function g(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:T.URI.revive(n.location).with({scheme:r}),globalStorageHome:T.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:T.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:T.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:T.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:T.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:T.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:T.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=g;function i(n,r,o,c,R,D){return{id:n,name:r,location:o,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:D&&R?.useDefaultFlags?.globalState?D.globalStorageHome:(0,N.joinPath)(o,"globalStorage"),settingsResource:D&&R?.useDefaultFlags?.settings?D.settingsResource:(0,N.joinPath)(o,"settings.json"),keybindingsResource:D&&R?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,N.joinPath)(o,"keybindings.json"),tasksResource:D&&R?.useDefaultFlags?.tasks?D.tasksResource:(0,N.joinPath)(o,"tasks.json"),snippetsHome:D&&R?.useDefaultFlags?.snippets?D.snippetsHome:(0,N.joinPath)(o,"snippets"),extensionsResource:D&&R?.useDefaultFlags?.extensions?D.extensionsResource:(0,N.joinPath)(o,"extensions.json"),cacheHome:(0,N.joinPath)(c,n),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.toUserDataProfile=i;let s=class extends k.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,c,R){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=c,this.logService=R,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,N.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,N.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),o=[r];if(this.enabled)try{for(const D of this.getStoredProfiles()){if(!D.name||!(0,v.isString)(D.name)||!D.location){this.logService.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(i((0,N.basename)(D.location),D.name,D.location,this.profilesCacheHome,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},r))}}catch(D){this.logService.error(D)}const c=new m.ResourceMap,R=new Map;if(o.length)try{const D=this.getStoredProfileAssociations();if(D.workspaces)for(const[w,L]of Object.entries(D.workspaces)){const W=T.URI.parse(w),J=o.find(X=>X.id===L);J&&c.set(W,J)}if(D.emptyWindows)for(const[w,L]of Object.entries(D.emptyWindows)){const W=o.find(J=>J.id===L);W&&R.set(w,W)}}catch(D){this.logService.error(D)}this._profilesObject={profiles:o,workspaces:c,emptyWindows:R}}return this._profilesObject}createDefaultProfile(){const r=i("__default__profile__",(0,b.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let R=0;for(const w of this.profiles){const L=c.exec(w.name),W=L?parseInt(L[1]):0;R=W>R?W:R}const D=`${o} ${R+1}`;return this.createProfile((0,A.hash)((0,E.generateUuid)()).toString(16),D,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,A.hash)((0,E.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,R){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const D=await this.doCreateProfile(r,o,c);return R&&await this.setProfileForWorkspace(R,D),D}async doCreateProfile(r,o,c){if(!(0,v.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.profileCreationPromises.get(o);return R||(R=(async()=>{try{const D=this.profiles.find(W=>W.name===o||W.id===r);if(D)return D;const w=i(r,o,(0,N.joinPath)(this.profilesHome,r),this.profilesCacheHome,c,this.defaultProfile);await this.fileService.createFolder(w.location);const L=[];return this._onWillCreateProfile.fire({profile:w,join(W){L.push(W)}}),await C.Promises.settled(L),this.updateProfiles([w],[],[]),w}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,R)),R}async updateProfile(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(R=>R.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=i(c.id,o.name??c.name,c.location,this.profilesCacheHome,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(R=>R.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(R){c.push(R)}});try{await Promise.allSettled(c)}catch(R){this.logService.error(R)}for(const R of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(R)?.id&&this.profilesObject.emptyWindows.delete(R);for(const R of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(R)?.id&&this.profilesObject.workspaces.delete(R);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(R){(0,a.toFileOperationResult)(R)!==1&&this.logService.error(R)}}async setProfileForWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(R=>R.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return T.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(r){return(0,d.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,d.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,c){const R=[...this.profiles,...r],D=[];this.transientProfilesObject.profiles=[];for(let w of R)w.isDefault||o.some(L=>w.id===L.id)||(w=c.find(L=>w.id===L.id)??w,w.isTransient?this.transientProfilesObject.profiles.push(w):D.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.saveStoredProfiles(D),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,c)}triggerProfilesChanges(r,o,c){this._onDidChangeProfiles.fire({added:r,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const R=this.getWorkspace(r),D=c?this.transientProfilesObject:this.profilesObject;T.URI.isUri(R)?(D.workspaces.delete(R),o&&D.workspaces.set(R,o)):(D.emptyWindows.delete(R),o&&D.emptyWindows.set(R,o)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,R]of this.profilesObject.workspaces.entries())r[c.toString()]=R.id;const o={};for(const[c,R]of this.profilesObject.emptyWindows.entries())o[c.toString()]=R.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const o={},c=this.createDefaultProfile();if(r.workspaces)for(const[D,w]of Object.entries(r.workspaces)){const L=T.URI.parse(w);o[D]=this.uriIdentityService.extUri.isEqual(L,c.location)?c.id:this.uriIdentityService.extUri.basename(L)}const R={};if(r.emptyWindows)for(const[D,w]of Object.entries(r.emptyWindows)){const L=T.URI.parse(w);R[D]=this.uriIdentityService.extUri.isEqual(L,c.location)?c.id:this.uriIdentityService.extUri.basename(L)}return{workspaces:o,emptyWindows:R}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=s,e.UserDataProfilesService=s=me([re(0,f.IEnvironmentService),re(1,a.IFileService),re(2,S.IUriIdentityService),re(3,P.ILogService)],s);class t extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let u=class extends b.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(r,o,c,R,D,w){super(),this.galleryService=r,this.telemetryService=o,this.uriIdentityService=c,this.logService=R,this.productService=D,this.userDataProfilesService=w,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(c=>(0,d.isTargetPlatformCompatible)(c,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const R=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:D})=>(0,m.areSameExtensions)(D,r.identifier));if(R?.local)return R?.local;throw R?.error?R.error:new d.ExtensionManagementError(`Unknown error while installing extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(c){throw i(c)}}async installGalleryExtensions(r){if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(P.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],c=[];await Promise.allSettled(r.map(async({extension:R,options:D})=>{try{const w=await this.checkAndGetCompatibleVersion(R,!!D?.installGivenVersion,!!D?.installPreReleaseVersion);c.push({...w,options:D})}catch(w){o.push({identifier:R.identifier,operation:2,source:R,error:w})}})),c.length&&o.push(...await this.installExtensions(c));for(const R of o)R.error&&(this.logService.error("Failed to install extension.",R.identifier.id),this.logService.error(R.error),R.source&&!y.URI.isUri(R.source)&&s(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(R.source),error:R.error}));return o}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtension(r,o)}async toggleAppliationScope(r,o){if((0,S.isApplicationScopedExtension)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let c=await this.updateMetadata(r,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(c=await this.copyExtension(r,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const R of this.userDataProfilesService.profiles){const D=(await this.getInstalled(1,R.extensionsResource)).find(w=>(0,m.areSameExtensions)(w.identifier,r.identifier));D?this._onDidUpdateExtensionMetadata.fire(D):this._onDidUninstallExtension.fire({identifier:r.identifier,profileLocation:R.extensionsResource})}return c}else{const c=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(r,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtensions(r){const o=[],c=new Map,R=[],D=[],w=(W,J)=>`${m.ExtensionKey.create(W).toString()}-${J.toString()}`,L=(W,J,X)=>{const oe=this.createInstallExtensionTask(W,J,X),se=y.URI.isUri(J)?J.path:`${J.identifier.id.toLowerCase()}-${X.profileLocation.toString()}`;c.set(se,{task:oe,manifest:W}),this._onInstallExtension.fire({identifier:oe.identifier,source:J,profileLocation:X.profileLocation}),this.logService.info("Installing extension:",oe.identifier.id),y.URI.isUri(J)||this.installingExtensions.set(w(J,X.profileLocation),{task:oe,waitingTasks:[]})};try{for(const{manifest:W,extension:J,options:X}of r){const oe=X.isApplicationScoped||X.isBuiltin||(0,S.isApplicationScopedExtension)(W),se={...X,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(J)?X.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:oe,profileLocation:oe?this.userDataProfilesService.defaultProfile.extensionsResource:X.profileLocation??this.getCurrentExtensionsManifestLocation()},fe=y.URI.isUri(J)?void 0:this.installingExtensions.get(w(J,se.profileLocation));fe?(this.logService.info("Extension is already requested to install",fe.task.identifier.id),R.push(fe.task.waitUntilTaskIsFinished())):L(W,J,se)}await Promise.all([...c.values()].map(async({task:W,manifest:J})=>{if(W.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const X=await this.getAllDepsAndPackExtensions(W.identifier,J,!!W.options.installOnlyNewlyAddedFromExtensionPack,!!W.options.installPreReleaseVersion,W.options.profileLocation),oe=await this.getInstalled(void 0,W.options.profileLocation),se={...W.options,donotIncludePackAndDependencies:!0,context:{...W.options.context,[d.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:fe,manifest:de}of(0,A.distinct)(X,({gallery:ae})=>ae.identifier.id)){if(c.has(`${fe.identifier.id.toLowerCase()}-${se.profileLocation.toString()}`))continue;const ae=this.installingExtensions.get(w(fe,se.profileLocation));if(ae){if(this.canWaitForTask(W,ae.task)){const z=ae.task.identifier;this.logService.info("Waiting for already requested installing extension",z.id,W.identifier.id),ae.waitingTasks.push(W),R.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,K=>K.some(V=>(0,m.areSameExtensions)(V.identifier,z)))).then(K=>{if(this.logService.info("Finished waiting for already requested installing extension",z.id,W.identifier.id),!K.find(_=>(0,m.areSameExtensions)(_.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else oe.some(({identifier:z})=>(0,m.areSameExtensions)(z,fe.identifier))||L(de,fe,se)}}catch(X){if(y.URI.isUri(W.source))(0,A.isNonEmptyArray)(J.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",W.identifier.id,X.message),(0,A.isNonEmptyArray)(J.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",W.identifier.id,X.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),X}})),await this.joinAllSettled([...c.values()].map(async({task:W})=>{const J=new Date().getTime();try{const X=await W.run();if(await this.joinAllSettled(this.participants.map(oe=>oe.postInstall(X,W.source,W.options,k.CancellationToken.None))),!y.URI.isUri(W.source)){const oe=W.operation===3,se=oe?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(s(this.telemetryService,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-J,durationSinceUpdate:se}),f.isWeb&&W.operation!==3)try{await this.galleryService.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}D.push({local:X,identifier:W.identifier,operation:W.operation,source:W.source,context:W.options.context,profileLocation:W.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw this.logService.error("Error while installing the extension",W.identifier.id,(0,N.getErrorMessage)(X)),X}})),R.length&&await this.joinAllSettled(R);for(const W of D)this.logService.info("Extension installed successfully:",W.identifier.id),o.push(W);return o}catch(W){D.length&&await Promise.allSettled(D.map(async({local:J,profileLocation:X})=>{try{await this.createUninstallExtensionTask(J,{versionOnly:!0,profileLocation:X}).run(),this.logService.info("Rollback: Uninstalled extension",J.identifier.id)}catch(oe){this.logService.warn("Rollback: Error while uninstalling extension",J.identifier.id,(0,N.getErrorMessage)(oe))}}));for(const{task:J}of c.values())J.cancel(),o.push({identifier:J.identifier,operation:2,source:J.source,context:J.options.context,profileLocation:J.profileLocation,error:W});throw W}finally{for(const{task:W}of c.values())W.source&&!y.URI.isUri(W.source)&&this.installingExtensions.delete(w(W.source,W.profileLocation));o.length&&this._onDidInstallExtensions.fire(o)}}canWaitForTask(r,o){for(const[,{task:c,waitingTasks:R}]of this.installingExtensions.entries())if(c===r&&(R.includes(o)||R.some(D=>this.canWaitForTask(D,o)))||c===o&&R[0]&&!this.canWaitForTask(r,R[0]))return!1;return!0}async joinAllSettled(r){const o=[],c=[],R=await Promise.allSettled(r);for(const D of R)D.status==="fulfilled"?o.push(D.value):c.push(D.reason);if(c.length)throw g(c);return o}async getAllDepsAndPackExtensions(r,o,c,R,D){if(!this.galleryService.isEnabled())return[];const w=await this.getInstalled(void 0,D),L=[],W=[],J=async(X,oe)=>{L.push(X);const se=oe.extensionDependencies||[],fe=[...se];if(oe.extensionPack){const de=c?w.find(ae=>(0,m.areSameExtensions)(ae.identifier,X)):void 0;for(const ae of oe.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(z=>(0,m.areSameExtensions)({id:z},{id:ae}))||fe.every(z=>!(0,m.areSameExtensions)({id:z},{id:ae}))&&fe.push(ae)}if(fe.length){const de=fe.filter(ae=>L.every(z=>!(0,m.areSameExtensions)(z,{id:ae})));if(de.length){const ae=await this.galleryService.getExtensions(de.map(z=>({id:z,preRelease:R})),k.CancellationToken.None);for(const z of ae){if(L.find(_=>(0,m.areSameExtensions)(_,z.identifier)))continue;const K=se.some(_=>(0,m.areSameExtensions)({id:_},z.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(z,!1,R)}catch(_){if(K)throw _;this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,N.getErrorMessage)(_));continue}W.push({gallery:V.extension,manifest:V.manifest}),await J(V.extension.identifier,V.manifest)}}}};return await J(r,o),W}async checkAndGetCompatibleVersion(r,o,c){let R;const D=await this.getExtensionsControlManifest();if(D.malicious.some(W=>(0,m.areSameExtensions)(r.identifier,W)))throw new d.ExtensionManagementError(P.localize(1,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=D.deprecated[r.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.logService.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),R=(await this.galleryService.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0],!R)throw new d.ExtensionManagementError(P.localize(2,null,r.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const W=await this.getTargetPlatform();throw new d.ExtensionManagementError(P.localize(3,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(W)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.getCompatibleVersion(r,o,c),!R)throw!c&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],k.CancellationToken.None))[0]?new d.ExtensionManagementError(P.localize(4,null,r.displayName??r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(P.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",R.identifier.id);const L=await this.galleryService.getManifest(R,k.CancellationToken.None);if(L===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${R.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(L.version!==R.version)throw new d.ExtensionManagementError(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:L}}async getCompatibleVersion(r,o,c){const R=await this.getTargetPlatform();let D=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==c&&(D=(await this.galleryService.getExtensions([{...r.identifier,preRelease:c}],{targetPlatform:R,compatible:!0},k.CancellationToken.None))[0]||null),!D&&await this.galleryService.isExtensionCompatible(r,c,R)&&(D=r),D||(o?D=(await this.galleryService.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:R,compatible:!0},k.CancellationToken.None))[0]||null:D=await this.galleryService.getCompatibleExtension(r,c,R)),D}async uninstallExtension(r,o){const c={...o,profileLocation:r.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},R=X=>`${X.id.toLowerCase()}${c.versionOnly?`-${r.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,D=this.uninstallingExtensions.get(R(r.identifier));if(D)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),D.waitUntilTaskIsFinished();const w=X=>{const oe=this.createUninstallExtensionTask(X,c);return this.uninstallingExtensions.set(R(oe.extension.identifier),oe),c.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,c.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this._onUninstallExtension.fire({identifier:X.identifier,profileLocation:c.profileLocation,applicationScoped:X.isApplicationScoped}),oe},L=(X,oe)=>{oe?c.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,c.profileLocation.toString(),oe.message):this.logService.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,oe.message):c.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,c.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(X),error:oe}),this._onDidUninstallExtension.fire({identifier:X.identifier,error:oe?.code,profileLocation:c.profileLocation,applicationScoped:X.isApplicationScoped})},W=[],J=[];try{W.push(w(r));const X=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${r.identifier.id}@${r.manifest.version}`);else{const oe=this.getAllPackExtensionsToUninstall(r,X);for(const se of oe)this.uninstallingExtensions.has(R(se.identifier))?this.logService.info("Extensions is already requested to uninstall",se.identifier.id):W.push(w(se))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${r.identifier.id}@${r.manifest.version}`):this.checkForDependents(W.map(oe=>oe.extension),X,r),await this.joinAllSettled(W.map(async oe=>{try{if(await oe.run(),await this.joinAllSettled(this.participants.map(se=>se.postUninstall(oe.extension,c,k.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.galleryService.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}L(oe.extension)}catch(se){const fe=se instanceof d.ExtensionManagementError?se:new d.ExtensionManagementError((0,N.getErrorMessage)(se),d.ExtensionManagementErrorCode.Internal);throw L(oe.extension,fe),fe}finally{J.push(oe)}}))}catch(X){const oe=X instanceof d.ExtensionManagementError?X:new d.ExtensionManagementError((0,N.getErrorMessage)(X),d.ExtensionManagementErrorCode.Internal);for(const se of W){try{se.cancel()}catch{}J.includes(se)||L(se.extension,oe)}throw oe}finally{for(const X of W)this.uninstallingExtensions.delete(R(X.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}checkForDependents(r,o,c){for(const R of r){const D=this.getDependents(R,o);if(D.length){const w=D.filter(L=>!r.some(W=>(0,m.areSameExtensions)(W.identifier,L.identifier)));if(w.length)throw new Error(this.getDependentsErrorMessage(R,w,c))}}}getDependentsErrorMessage(r,o,c){return c===r?o.length===1?P.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?P.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):P.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?P.localize(9,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?P.localize(10,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):P.localize(11,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,c=[]){if(c.indexOf(r)!==-1)return[];c.push(r);const R=r.manifest.extensionPack?r.manifest.extensionPack:[];if(R.length){const D=o.filter(L=>!L.isBuiltin&&R.some(W=>(0,m.areSameExtensions)({id:W},L.identifier))),w=[];for(const L of D)w.push(...this.getAllPackExtensionsToUninstall(L,o,c));return[...D,...w]}return[]}getDependents(r,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(R=>(0,m.areSameExtensions)({id:R},r.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(r){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.getErrorMessage)(r)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=u,e.AbstractExtensionManagementService=u=me([re(0,d.IExtensionGalleryService),re(1,l.ITelemetryService),re(2,v.IUriIdentityService),re(3,C.ILogService),re(4,E.IProductService),re(5,p.IUserDataProfilesService)],u);function g(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=g;function i(n){if(n instanceof d.ExtensionManagementError)return n;if(n instanceof d.ExtensionGalleryError){const o=new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const r=new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}e.toExtensionManagementError=i;function s(n,r,{extensionData:o,verificationStatus:c,duration:R,error:D,durationSinceUpdate:w}){let L,W;(0,a.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(L=d.ExtensionManagementErrorCode.Signature,W=c),c="Unverified")),D&&(D instanceof d.ExtensionManagementError||D instanceof d.ExtensionGalleryError?(L=D.code,D.code===d.ExtensionManagementErrorCode.Signature&&(W=D.message)):L=d.ExtensionManagementErrorCode.Internal),n.publicLog(r,{...o,verificationStatus:c,success:!D,duration:R,errorcode:L,errorcodeDetail:W,durationSinceUpdate:w})}class t{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>new Promise((o,c)=>{const R=r.onCancellationRequested(()=>{R.dispose(),c(new N.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v||(e.ExtensionsProfileScanningErrorCode=v={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let u=class extends k.Disposable{constructor(t,n,r,o,c,R){super(),this.extensionsLocation=t,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=c,this.logService=R,this._onAddExtensions=this._register(new N.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new N.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new N.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new N.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(t,n){return this.withProfileExtensions(t,void 0,n)}async addExtensionsToProfile(t,n){const r=[],o=[];try{return await this.withProfileExtensions(n,c=>{const R=[];for(const D of c)t.some(([w])=>(0,a.areSameExtensions)(w.identifier,D.identifier)&&w.manifest.version!==D.version)?r.push(D):R.push(D);for(const[D,w]of t){const L=R.findIndex(J=>(0,a.areSameExtensions)(J.identifier,D.identifier)&&J.version===D.manifest.version),W={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:w};L===-1?(o.push(W),R.push(W)):R.splice(L,1,W)}return o.length&&this._onAddExtensions.fire({extensions:o,profileLocation:n}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),R}),o.length&&this._onDidAddExtensions.fire({extensions:o,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n}),o}catch(c){throw o.length&&this._onDidAddExtensions.fire({extensions:o,error:c,profileLocation:n}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:c,profileLocation:n}),c}}async updateMetadata(t,n){const r=[];return await this.withProfileExtensions(n,o=>{const c=[];for(const R of o){const D=t.find(([w])=>(0,a.areSameExtensions)(w.identifier,R.identifier)&&w.manifest.version===R.version);D&&(R.metadata={...R.metadata,...D[1]},r.push(R)),c.push(R)}return c}),r}async removeExtensionFromProfile(t,n){const r=[];try{await this.withProfileExtensions(n,o=>{const c=[];for(const R of o)(0,a.areSameExtensions)(R.identifier,t.identifier)?r.push(R):c.push(R);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),c}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:n}),o}}async withProfileExtensions(t,n,r){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],c;try{const R=await this.fileService.readFile(t);c=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,y.toFileOperationResult)(R)!==1)throw R;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&r?.bailOutWhenFileNotFound)throw new p((0,E.getErrorMessage)(R),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(t);let R=!1;for(const D of c){g(D)||this.reportAndThrowInvalidConentError(t);let w;if((0,C.isString)(D.relativeLocation)&&D.relativeLocation)w=this.resolveExtensionLocation(D.relativeLocation);else if((0,C.isString)(D.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{w=b.URI.revive(D.location);const L=this.toRelativePath(w);L&&(R=!0,D.relativeLocation=L)}(0,C.isUndefined)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(R=!0,D.metadata.hasPreReleaseVersion=!0),o.push({identifier:D.identifier,location:w,version:D.version,metadata:D.metadata})}R&&await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(c)))}if(n){o=n(o);const R=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.toRelativePath(D.location),metadata:D.metadata}));await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(R)))}return o})}reportAndThrowInvalidConentError(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(t)).value.toString()}catch(c){if((0,y.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(r);Array.isArray(c)&&c.every(R=>g(R))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,y.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(t)}catch(c){(0,y.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(n)}catch(c){(0,y.toFileOperationResult)(c)!==1&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let n=this.resourcesAccessQueueMap.get(t);return n||(n=new A.Queue,this.resourcesAccessQueueMap.set(t,n)),n}};e.AbstractExtensionsProfileScannerService=u,e.AbstractExtensionsProfileScannerService=u=me([re(1,y.IFileService),re(2,m.IUserDataProfilesService),re(3,S.IUriIdentityService),re(4,l.ITelemetryService),re(5,d.ILogService)],u);function g(s){return(0,C.isObject)(s)&&(0,f.isIExtensionIdentifier)(s.identifier)&&(i(s.location)||(0,C.isString)(s.location)&&s.location)&&((0,C.isUndefined)(s.relativeLocation)||(0,C.isString)(s.relativeLocation))&&s.version&&(0,C.isString)(s.version)}function i(s){return s?(0,C.isString)(s.path)&&(0,C.isString)(s.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p,u,g,i,s,t,n,r,o,c,R,D,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var W;(function(ae){function z(K,V){if(K===V)return!0;const _=Object.keys(K),$=new Set;for(const H of Object.keys(V))$.add(H);if(_.length!==$.size)return!1;for(const H of _){if(K[H]!==V[H])return!1;$.delete(H)}return $.size===0}ae.equals=z})(W||(e.Translations=W={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let J=class extends a.Disposable{constructor(z,K,V,_,$,H,Y,Z,M,F,h,I){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=K,this.extensionsControlLocation=V,this.currentProfile=_,this.userDataProfilesService=$,this.extensionsProfileScannerService=H,this.fileService=Y,this.logService=Z,this.environmentService=M,this.productService=F,this.uriIdentityService=h,this.instantiationService=I,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(z,K,V){const[_,$]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(K)]),H=V?await this.scanExtensionsUnderDevelopment(z,[..._,...$]):[];return this.dedupExtensions(_,$,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const K=[];K.push(this.scanDefaultSystemExtensions(!!z.useCache,z.language)),K.push(this.scanDevSystemExtensions(z.language,!!z.checkControlFile));const[V,_]=await Promise.all(K);return this.applyScanOptions([...V,..._],0,z,!1)}async scanUserExtensions(z){const K=z.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",K);const V=this.uriIdentityService.extUri.isEqual(z.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,_=await this.createExtensionScannerInput(K,!!z.profileLocation,1,!z.includeUninstalled,z.language,!0,V),$=z.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let H;try{H=await $.scanExtensions(_)}catch(Y){if(Y instanceof R.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),H=await $.scanExtensions(_);else throw Y}return H=await this.applyScanOptions(H,1,z,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(z,K){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===y.Schemas.file).map(async _=>{const $=await this.createExtensionScannerInput(_,!1,1,!0,z.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(Y=>(Y.type=K.find(Z=>(0,u.areSameExtensions)(Z.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,$)))}))).flat();return this.applyScanOptions(V,"development",z,!0)}return[]}async scanExistingExtension(z,K,V){const _=await this.createExtensionScannerInput(z,!1,K,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanExtension(_);return!$||!V.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(z,K,V){const _=await this.createExtensionScannerInput(z,!1,K,!0,V.language,!0,void 0),$=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions($,K,V,!0)}async scanMetadata(z){const K=(0,m.joinPath)(z,"package.json"),V=(await this.fileService.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(z,K){const V=(0,m.joinPath)(z,"package.json"),_=(await this.fileService.readFile(V)).value.toString(),$=JSON.parse(_);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,$.__metadata={...$.__metadata,...K},await this.fileService.writeFile((0,m.joinPath)(z,"package.json"),N.VSBuffer.fromString(JSON.stringify($,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(z){if(z instanceof R.ExtensionsProfileScanningError&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw z}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});if(z.length)await this.extensionsProfileScannerService.addExtensionsToProfile(z.map(K=>[K,K.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify([])))}catch(K){(0,s.toFileOperationResult)(K)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(K))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(z){this.logService.error(z)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(z,K,V,_){return V.includeAllVersions||(z=this.dedupExtensions(K===0?z:void 0,K===1?z:void 0,K==="development"?z:void 0,await this.getTargetPlatform(),_)),V.includeInvalid||(z=z.filter($=>$.isValid)),z.sort(($,H)=>{const Y=P.basename($.location.fsPath),Z=P.basename(H.location.fsPath);return Y<Z?-1:Y>Z?1:0})}dedupExtensions(z,K,V,_,$){const H=(Z,M,F)=>{if(Z.isValid&&!M.isValid)return!1;if(Z.isValid===M.isValid){if($&&S.gt(Z.manifest.version,M.manifest.version))return this.logService.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(S.eq(Z.manifest.version,M.manifest.version)){if(Z.type===0)return this.logService.debug(`Skipping extension ${M.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===_)return this.logService.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.logService.warn(`Overwriting user extension ${Z.location.path} with ${M.location.path}.`):this.logService.debug(`Overwriting user extension ${Z.location.path} with ${M.location.path}.`),!0},Y=new g.ExtensionIdentifierMap;return z?.forEach(Z=>{const M=Y.get(Z.identifier.id);(!M||H(M,Z,!1))&&Y.set(Z.identifier.id,Z)}),K?.forEach(Z=>{const M=Y.get(Z.identifier.id);if(!M&&z&&Z.type===0){this.logService.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!M||H(M,Z,!1))&&Y.set(Z.identifier.id,Z)}),V?.forEach(Z=>{const M=Y.get(Z.identifier.id);(!M||H(M,Z,!0))&&Y.set(Z.identifier.id,Z),Y.set(Z.identifier.id,Z)}),[...Y.values()]}async scanDefaultSystemExtensions(z,K){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),$=await(z&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(z,K){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=K?await this.getBuiltInExtensionControl():{},$=[],H=l.URI.file(P.normalize(P.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of V){const M=_[Z.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":$.push((0,m.joinPath)(H,Z.name));break;default:$.push(l.URI.file(M));break}}const Y=await Promise.all($.map(async Z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(Z,!1,0,!0,z,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,A.coalesce)(Y)}async getBuiltInExtensionControl(){try{const z=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(z.value.toString())}catch{return{}}}async createExtensionScannerInput(z,K,V,_,$,H,Y){const Z=await this.getTranslations($??d.language),M=await this.getMtime(z),F=K&&!this.uriIdentityService.extUri.isEqual(z,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,h=F?await this.getMtime(F):void 0;return new X(z,M,F,h,K,Y,V,_,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,Z)}async getMtime(z){try{const K=await this.fileService.stat(z);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.AbstractExtensionsScannerService=J,e.AbstractExtensionsScannerService=J=me([re(4,D.IUserDataProfilesService),re(5,R.IExtensionsProfileScannerService),re(6,s.IFileService),re(7,n.ILogService),re(8,p.IEnvironmentService),re(9,r.IProductService),re(10,w.IUriIdentityService),re(11,t.IInstantiationService)],J);class X{constructor(z,K,V,_,$,H,Y,Z,M,F,h,I,x,U,q){this.location=z,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=_,this.profile=$,this.profileScanOptions=H,this.type=Y,this.excludeObsolete=Z,this.validate=M,this.productVersion=F,this.productDate=h,this.productCommit=I,this.devMode=x,this.language=U,this.translations=q}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,K){return(0,m.isEqual)(z.location,K.location)&&z.mtime===K.mtime&&(0,m.isEqual)(z.applicationExtensionslocation,K.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&z.profile===K.profile&&k.equals(z.profileScanOptions,K.profileScanOptions)&&z.type===K.type&&z.excludeObsolete===K.excludeObsolete&&z.validate===K.validate&&z.productVersion===K.productVersion&&z.productDate===K.productDate&&z.productCommit===K.productCommit&&z.devMode===K.devMode&&z.language===K.language&&W.equals(z.translations,K.translations)}}e.ExtensionScannerInput=X;let oe=class extends a.Disposable{constructor(z,K,V,_,$){super(),this.obsoleteFile=z,this.extensionsProfileScannerService=K,this.uriIdentityService=V,this.fileService=_,this.logService=$}async scanExtensions(z){const K=z.profile?await this.scanExtensionsFromProfile(z):await this.scanExtensionsFromLocation(z);let V={};if(z.excludeObsolete&&z.type===1)try{const _=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(_)}catch{}return(0,E.isEmptyObject)(V)?K:K.filter(_=>!V[u.ExtensionKey.create(_).toString()])}async scanExtensionsFromLocation(z){const K=await this.fileService.resolve(z.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async _=>{if(!_.isDirectory||z.type===1&&(0,m.basename)(_.resource).indexOf(".")===0)return null;const $=new X(_.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension($)}));return(0,A.coalesce)(V).sort((_,$)=>_.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(z){let K=await this.scanExtensionsFromProfileResource(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(z.location,z.applicationExtensionslocation)){K=K.filter(_=>!_.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(z.applicationExtensionslocation,_=>!!_.metadata?.isBuiltin||!!_.metadata?.isApplicationScoped,z);K.push(...V)}return K}async scanExtensionsFromProfileResource(z,K,V){const _=await this.extensionsProfileScannerService.scanProfileExtensions(z,V.profileScanOptions);if(!_.length)return[];const $=await Promise.all(_.map(async H=>{if(K(H)){const Y=new X(H.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(Y,H.metadata)}return null}));return(0,A.coalesce)($)}async scanOneOrMultipleExtensions(z){try{if(await this.fileService.exists((0,m.joinPath)(z.location,"package.json"))){const K=await this.scanExtension(z);return K?[K]:[]}else return await this.scanExtensions(z)}catch(K){return this.logService.error(`Error scanning extensions at ${z.location.path}:`,(0,T.getErrorMessage)(K)),[]}}async scanExtension(z,K){try{let V=await this.scanExtensionManifest(z.location);if(V){V.publisher||(V.publisher=g.UNDEFINED_PUBLISHER),K=K??V.__metadata,delete V.__metadata;const _=(0,u.getGalleryExtensionId)(V.publisher,V.name),$=K?.id?{id:_,uuid:K.id}:{id:_},H=K?.isSystem?0:z.type,Y=H===0||!!K?.isBuiltin;V=await this.translateManifest(z.location,V,X.createNlsConfiguration(z));const Z={type:H,identifier:$,manifest:V,location:z.location,isBuiltin:Y,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return z.validate?this.validate(Z,z):Z}}catch(V){z.type!==0&&this.logService.error(V)}return null}validate(z,K){let V=!0;const _=(0,i.validateExtensionManifest)(K.productVersion,K.productDate,K.location,z.manifest,z.isBuiltin);for(const[$,H]of _)$===C.default.Error&&(V=!1,this.logService.error(this.formatMessage(K.location,H)));return z.isValid=V,z.validations=_,z}async scanExtensionManifest(z){const K=(0,m.joinPath)(z,"package.json");let V;try{V=(await this.fileService.readFile(K)).value.toString()}catch($){return(0,s.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(z,(0,v.localize)(0,null,K.path,$.message))),null}let _;try{_=JSON.parse(V)}catch{const H=[];(0,b.parse)(V,H);for(const Y of H)this.logService.error(this.formatMessage(z,(0,v.localize)(1,null,K.path,Y.offset,Y.length,(0,f.getParseErrorMessage)(Y.error))));return null}return(0,b.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(z,(0,v.localize)(2,null,K.path))),null):_}async translateManifest(z,K,V){const _=await this.getLocalizedMessages(z,K,V);if(_)try{const $=[],H=await this.resolveOriginalMessageBundle(_.default,$);if($.length>0)return $.forEach(Z=>{this.logService.error(this.formatMessage(z,(0,v.localize)(3,null,_.default?.path,(0,f.getParseErrorMessage)(Z.error))))}),K;if((0,b.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(z,(0,v.localize)(4,null,_.default?.path))),K;const Y=_.values||Object.create(null);return(0,L.localizeManifest)(this.logService,K,Y,H)}catch{}return K}async getLocalizedMessages(z,K,V){const _=(0,m.joinPath)(z,"package.nls.json"),$=(M,F)=>{F.forEach(h=>{this.logService.error(this.formatMessage(z,(0,v.localize)(5,null,M?.path,(0,f.getParseErrorMessage)(h.error))))})},H=M=>{this.logService.error(this.formatMessage(z,(0,v.localize)(6,null,M?.path)))},Y=`${K.publisher}.${K.name}`,Z=V.translations[Y];if(Z)try{const M=l.URI.file(Z),F=(await this.fileService.readFile(M)).value.toString(),h=[],I=(0,b.parse)(F,h);return h.length>0?($(M,h),{values:void 0,default:_}):(0,b.getNodeType)(I)!=="object"?(H(M),{values:void 0,default:_}):{values:I.contents?I.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let F;try{F=await this.findMessageBundles(z,V)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const h=(await this.fileService.readFile(F.localized)).value.toString(),I=[],x=(0,b.parse)(h,I);return I.length>0?($(F.localized,I),{values:void 0,default:F.original}):(0,b.getNodeType)(x)!=="object"?(H(F.localized),{values:void 0,default:F.original}):{values:x,default:F.original}}catch{return{values:void 0,default:F.original}}}}async resolveOriginalMessageBundle(z,K){if(z)try{const V=(await this.fileService.readFile(z)).value.toString();return(0,b.parse)(V,K)}catch{}}findMessageBundles(z,K){return new Promise((V,_)=>{const $=H=>{const Y=(0,m.joinPath)(z,`package.nls.${H}.json`);this.fileService.exists(Y).then(Z=>{Z&&V({localized:Y,original:(0,m.joinPath)(z,"package.nls.json")});const M=H.lastIndexOf("-");M===-1?V({localized:(0,m.joinPath)(z,"package.nls.json"),original:null}):(H=H.substring(0,M),$(H))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,m.joinPath)(z,"package.nls.json"),original:null});$(K.language)})}formatMessage(z,K){return`[${z.path}]: ${K}`}};oe=me([re(1,R.IExtensionsProfileScannerService),re(2,w.IUriIdentityService),re(3,s.IFileService),re(4,n.ILogService)],oe);let se=class extends oe{constructor(z,K,V,_,$,H,Y){super(K,_,$,H,Y),this.currentProfile=z,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(z){const K=this.getCacheFile(z),V=await this.readExtensionCache(K);if(this.input=z,V&&V.input&&X.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",z.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map($=>($.location=l.URI.revive($.location),$));const _=await super.scanExtensions(z);return await this.writeExtensionCache(K,{input:z,result:_}),_}async readExtensionCache(z){try{const K=await this.fileService.readFile(z),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,c.revive)(V.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",z.path,(0,T.getErrorMessage)(K))}return null}async writeExtensionCache(z,K){try{await this.fileService.writeFile(z,N.VSBuffer.fromString(JSON.stringify(K)))}catch(V){this.logService.debug("Error while writing the extension cache file:",z.path,(0,T.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const z=this.getCacheFile(this.input),K=await this.readExtensionCache(z);if(!K)return;const V=K.result,_=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(_,V))try{this.logService.info("Invalidating Cache",V,_),await this.fileService.del(z),this._onDidChangeCache.fire()}catch($){this.logService.error($)}}getCacheFile(z){const K=this.getProfile(z);return this.uriIdentityService.extUri.joinPath(K.cacheHome,z.type===0?g.BUILTIN_MANIFEST_CACHE_FILE:g.USER_MANIFEST_CACHE_FILE)}getProfile(z){return z.type===0?this.userDataProfilesService.defaultProfile:z.profile?this.uriIdentityService.extUri.isEqual(z.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(K=>this.uriIdentityService.extUri.isEqual(z.location,K.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};se=me([re(2,D.IUserDataProfilesService),re(3,R.IExtensionsProfileScannerService),re(4,w.IUriIdentityService),re(5,s.IFileService),re(6,n.ILogService)],se);function fe(ae,z){const K=(0,u.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:K,identifier:new g.ExtensionIdentifier(K),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:z,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.toExtensionDescription=fe;class de extends J{constructor(z,K,V,_,$,H,Y,Z,M,F,h,I){super(z,K,(0,m.joinPath)(V,".vscode-oss-dev","extensions","control.json"),_,$,H,Y,Z,M,F,h,I),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const x=await this.fileService.readFile(l.URI.file(d.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(z){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(G,e,A,O,k,N,T,b,f,a,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends T.Disposable{constructor(S,C){super(),this.userDataProfilesService=S,this.logService=C,this.processesLimiter=new O.Limiter(5)}async postUninstall(S){const C=this.parseScript(S,"uninstall");C&&(this.logService.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(C.script,"uninstall",C.args,!0,S),this.logService.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch(E){this.logService.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.logService.error(E)}}));try{await a.Promises.rm(this.getExtensionStoragePath(S))}catch(E){this.logService.error("Error while removing extension storage path",S.identifier.id),this.logService.error(E)}}parseScript(S,C){const E=`vscode:${C}`;if(S.location.scheme===b.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[E]=="string"){const l=S.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(S.identifier.id,S.manifest.version,`${E} should be a node script`),null):{script:(0,f.join)(S.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(S,C,E,l,v){return new Promise((p,u)=>{const g=this.start(S,C,E,v);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?u(t):p(void 0)};g.on("error",t=>{s((0,k.toErrorMessage)(t)||"Unknown")}),g.on("exit",(t,n)=>{s(t?`post-${C} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,g.kill(),u("timed out")},5e3))})}start(S,C,E,l){const v={silent:!0,execArgv:void 0},p=(0,A.fork)(S,[`--type=extension-post-${C}`,...E],v);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const u=N.Event.fromNodeEventEmitter(p.stdout,"data"),g=N.Event.fromNodeEventEmitter(p.stderr,"data");u(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${C}`,t)),g(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${C}`,t));const i=N.Event.any(N.Event.map(u,t=>({data:`%c${t}`,format:[""]})),N.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}getExtensionStoragePath(S){return(0,f.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=d,e.ExtensionsLifecycle=d=me([re(0,P.IUserDataProfilesService),re(1,y.ILogService)],d)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p,u,g,i,s,t,n,r,o,c,R,D,w,L,W,J,X,oe,se,fe,de,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,X.refineServiceDecorator)(t.IExtensionManagementService);const z=".vsctmp";let K=class extends s.AbstractExtensionManagementService{constructor(M,F,h,I,x,U,q,B,te,ce,ue,pe){super(M,F,ue,h,ce,pe),this.extensionsScannerService=x,this.extensionsProfileScannerService=U,this.downloadService=q,this.fileService=te,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new y.ResourceSet;const Se=this._register(B.createInstance(R.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(V,le=>Se.postUninstall(le))),this.manifestCache=this._register(new w.ExtensionsManifestCache(pe,te,ue,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(c.ExtensionsDownloader));const he=this._register(new L.ExtensionsWatcher(this,this.extensionsScannerService,pe,U,ue,te,h));this._register(he.onDidChangeExtensionsByAnotherSource(le=>this.onDidChangeExtensionsFromAnotherSource(le))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),h=await(0,p.zip)((0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)()).fsPath,F);return E.URI.file(h)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:h}=await this.downloadVsix(M),I=d.resolve(F.fsPath);try{return await(0,D.getManifest)(I)}finally{await h()}}getInstalled(M,F=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(M??null,F)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.extensionsScanner.scanUserExtensionAtLocation(M)}async install(M,F={}){this.logService.trace("ExtensionManagementService#install",M.toString());const{location:h,cleanup:I}=await this.downloadVsix(M);try{const x=await(0,D.getManifest)(d.resolve(h.fsPath)),U=(0,n.getGalleryExtensionId)(x.publisher,x.name);if(x.engines&&x.engines.vscode&&!(0,W.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,U,this.productService.version));const B=(await this.installExtensions([{manifest:x,extension:h,options:F}])).find(({identifier:te})=>(0,n.areSameExtensions)(te,{id:U}));if(B?.local)return B.local;throw B?.error?B.error:(0,s.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await I()}}async installFromLocation(M,F){this.logService.trace("ExtensionManagementService#installFromLocation",M.toString());const h=await this.extensionsScanner.scanUserExtensionAtLocation(M);if(!h||!h.manifest.name||!h.manifest.version)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.addExtensionsToProfile([[h,void 0]],F),this.logService.info("Successfully installed extension",h.identifier.id,F.toString()),h}async installExtensionsFromProfile(M,F,h){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),h.toString());const I=(await this.extensionsScanner.scanExtensions(1,F)).filter(x=>M.some(U=>(0,n.areSameExtensions)(U,x.identifier)));if(I.length){const x=await Promise.all(I.map(U=>this.extensionsScanner.scanMetadata(U,F)));await this.addExtensionsToProfile(I.map((U,q)=>[U,x[q]]),h),this.logService.info("Successfully installed extensions",I.map(U=>U.identifier.id),h.toString())}return I}async updateMetadata(M,F,h=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.extensionsScanner.updateMetadata(M,F,h),this.manifestCache.invalidate(h),this._onDidUpdateExtensionMetadata.fire(M),M}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(u.localize(1,null));const F=await this.getTargetPlatform(),[h]=await this.galleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!h)throw new Error(u.localize(2,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(I){throw new Error(u.localize(3,null,(0,N.toErrorMessage)(I)))}return this.installFromGallery(h)}copyExtension(M,F,h,I){return this.extensionsScanner.copyExtension(M,F,h,I)}copyExtensions(M,F){return this.extensionsScanner.copyExtensions(M,F)}markAsUninstalled(...M){return this.extensionsScanner.setUninstalled(...M)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(M){this.logService.error(M)}}async download(M,F,h){const{location:I}=await this.extensionsDownloader.download(M,F,!h);return I}async downloadVsix(M){if(M.scheme===P.Schemas.file)return{location:M,async cleanup(){}};this.logService.trace("Downloading extension from",M.toString());const F=(0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)());return await this.downloadService.download(M,F),this.logService.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.fileService.del(F)}catch(I){this.logService.error(I)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(M,F,h){if(E.URI.isUri(F))return new H(M,F,h,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const I=n.ExtensionKey.create(F).toString();let x=this.installGalleryExtensionsTasks.get(I);return x||(this.installGalleryExtensionsTasks.set(I,x=new $(M,F,h,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),x.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(I))),x}createUninstallExtensionTask(M,F){return new Y(M,F.profileLocation,this.extensionsProfileScannerService)}async collectFiles(M){const F=async I=>{let x=await v.Promises.readdir(I);x=x.map(B=>d.join(I,B));const U=await Promise.all(x.map(B=>v.Promises.stat(B)));let q=Promise.resolve([]);return U.forEach((B,te)=>{const ce=x[te];B.isFile()&&(q=q.then(ue=>[...ue,ce])),B.isDirectory()&&(q=q.then(ue=>F(ce).then(pe=>[...ue,...pe])))}),q};return(await F(M.location.fsPath)).map(I=>({path:`extension/${d.relative(M.location.fsPath,I)}`,localPath:I}))}async onDidChangeExtensionsFromAnotherSource({added:M,removed:F}){if(F){const h=M&&this.uriIdentityService.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(I=>M.extensions.every(x=>!(0,n.areSameExtensions)(x,I))):F.extensions;for(const I of h)this.logService.info("Extensions removed from another source",I.id,F.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:I,profileLocation:F.profileLocation})}if(M){const I=(await this.extensionsScanner.scanExtensions(1,M.profileLocation)).filter(x=>M.extensions.some(U=>(0,n.areSameExtensions)(U,x.identifier)));this._onDidInstallExtensions.fire(I.map(x=>(this.logService.info("Extensions added from another source",x.identifier.id,M.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:M.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(F=>this.knownDirectories.add(F)));const M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.knownDirectories.add(F.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(F=>this.onDidFilesChange(F)))}async onDidFilesChange(M){if(!M.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const F=[];for(const h of M.rawAdded){if(this.knownDirectories.has(h)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(h,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(h).startsWith(".")||!(await this.fileService.stat(h)).isDirectory)continue;const I=await this.extensionsScanner.scanUserExtensionAtLocation(h);I&&I.installedTimestamp===void 0&&(this.knownDirectories.add(h),F.push(I))}F.length&&(await this.addExtensionsToProfile(F.map(h=>[h,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",F.map(h=>h.identifier.id)))}async addExtensionsToProfile(M,F){const h=M.map(I=>I[0]);await this.setInstalled(h),await this.extensionsProfileScannerService.addExtensionsToProfile(M,F),this._onDidInstallExtensions.fire(h.map(I=>({local:I,identifier:I.identifier,operation:1,profileLocation:F})))}async setInstalled(M){const F=await this.extensionsScanner.getUninstalledExtensions();for(const h of M){const I=n.ExtensionKey.create(h);F[I.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",I.id),await this.extensionsScanner.setInstalled(I),this.logService.info("Removed the extension from uninstalled list:",I.id))}}};e.ExtensionManagementService=K,e.ExtensionManagementService=K=me([re(0,t.IExtensionGalleryService),re(1,fe.ITelemetryService),re(2,oe.ILogService),re(3,i.INativeEnvironmentService),re(4,o.IExtensionsScannerService),re(5,r.IExtensionsProfileScannerService),re(6,g.IDownloadService),re(7,X.IInstantiationService),re(8,J.IFileService),re(9,se.IProductService),re(10,de.IUriIdentityService),re(11,ae.IUserDataProfilesService)],K);let V=class extends a.Disposable{constructor(M,F,h,I,x,U){super(),this.beforeRemovingExtension=M,this.fileService=F,this.extensionsScannerService=h,this.extensionsProfileScannerService=I,this.uriIdentityService=x,this.logService=U,this._onExtract=this._register(new b.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new A.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(M,F){const h={includeInvalid:!0,profileLocation:F};let I=[];return M===null||M===0?I.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},h,!1)):M===1&&I.push(...await this.extensionsScannerService.scanUserExtensions(h)),I=M!==null?I.filter(x=>x.type===M):I,Promise.all(I.map(x=>this.toLocalExtension(x)))}async scanAllUserExtensions(M){const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(h=>this.toLocalExtension(h)))}async scanUserExtensionAtLocation(M){try{const F=await this.extensionsScannerService.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.toLocalExtension(F)}catch(F){this.logService.error(F)}return null}async extractUserExtension(M,F,h,I,x){const U=M.toString(),q=E.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,l.generateUuid)()}`)),B=E.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let te=await this.fileService.exists(B);if(te&&I){try{await this.deleteExtensionFromLocation(M.id,B,"removeExisting")}catch{throw new t.ExtensionManagementError(u.localize(4,null,B.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.extensionsScannerService.updateMetadata(B,h);else try{try{this.logService.trace(`Started extracting the extension from ${F} to ${B.fsPath}`),await(0,p.extract)(F,q.fsPath,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${B}:`,M.id)}catch(ce){let ue=t.ExtensionManagementErrorCode.Extract;throw ce instanceof p.ExtractError&&(ce.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ce.message,ue)}await this.extensionsScannerService.updateMetadata(q,h);try{this.logService.trace(`Started renaming the extension from ${q.fsPath} to ${B.fsPath}`),await this.rename(q.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(ce)}. Deleted from extracted location`,q),ce}this._onExtract.fire(B)}catch(ce){try{await this.fileService.del(q,{recursive:!0})}catch{}throw ce}return this.scanLocalExtension(B,1)}async scanMetadata(M,F){return F?(await this.getScannedExtension(M,F))?.metadata:this.extensionsScannerService.scanMetadata(M.location)}async getScannedExtension(M,F){return(await this.extensionsProfileScannerService.scanProfileExtensions(F)).find(I=>(0,n.areSameExtensions)(I.identifier,M.identifier))}async updateMetadata(M,F,h){return h?await this.extensionsProfileScannerService.updateMetadata([[M,F]],h):await this.extensionsScannerService.updateMetadata(M.location,F),this.scanLocalExtension(M.location,M.type,h)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...M){const F=M.map(h=>n.ExtensionKey.create(h));await this.withUninstalledExtensions(h=>F.forEach(I=>{h[I.toString()]=!0,this.logService.info("Marked extension as uninstalled",I.toString())}))}async setInstalled(M){await this.withUninstalledExtensions(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.uriIdentityService.extUri.isEqualOrParent(M.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[n.ExtensionKey.create(M).toString()])}async copyExtension(M,F,h,I){const x=await this.getScannedExtension(M,F),U=await this.getScannedExtension(M,h);if(I={...x?.metadata,...I},U)if(this.uriIdentityService.extUri.isEqual(U.location,M.location))await this.extensionsProfileScannerService.updateMetadata([[M,{...U.metadata,...I}]],h);else{const q=await this.scanLocalExtension(U.location,M.type,h);await this.extensionsProfileScannerService.removeExtensionFromProfile(q,h),await this.extensionsProfileScannerService.addExtensionsToProfile([[M,{...U.metadata,...I}]],h)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[M,I]],h);return this.scanLocalExtension(M.location,M.type,h)}async copyExtensions(M,F){const h=await this.scanExtensions(1,M),I=await Promise.all(h.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,M)]));await this.extensionsProfileScannerService.addExtensionsToProfile(I,F)}async deleteExtensionFromLocation(M,F,h){this.logService.trace(`Deleting ${h} extension from disk`,M,F.fsPath);const I=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(F),`${this.uriIdentityService.extUri.basename(F)}.${(0,f.hash)((0,l.generateUuid)()).toString(16)}${z}`);await this.rename(F.fsPath,I.fsPath),await this.fileService.del(I,{recursive:!0}),this.logService.info(`Deleted ${h} extension from disk`,M,F.fsPath)}async withUninstalledExtensions(M){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(I){if((0,J.toFileOperationResult)(I)!==1)throw I}let h={};if(F)try{h=JSON.parse(F)}catch{}return M&&(M(h),Object.keys(h).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(h))):await this.fileService.del(this.uninstalledResource)),h})}async rename(M,F){try{await v.Promises.rename(M,F,2*60*1e3)}catch(h){throw new t.ExtensionManagementError(h.message||u.localize(5,null,M,F),h.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(M,F,h){if(h){const x=(await this.extensionsScannerService.scanUserExtensions({profileLocation:h})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,M));if(x)return this.toLocalExtension(x)}else{const I=await this.extensionsScannerService.scanExistingExtension(M,F,{includeInvalid:!0});if(I)return this.toLocalExtension(I)}throw new Error(u.localize(6,null,M.path))}async toLocalExtension(M){const F=await this.fileService.resolve(M.location);let h,I;return F.children&&(h=F.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,I=F.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:h,changelogUrl:I,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!M.metadata?.hasPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async removeUninstalledExtensions(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),h=new Set;for(const x of F)M[n.ExtensionKey.create(x).toString()]||h.add(x.identifier.id.toLowerCase());try{const x=(0,n.groupByExtension)(F,U=>U.identifier);await A.Promises.settled(x.map(async U=>{const q=U.sort((B,te)=>S.rcompare(B.manifest.version,te.manifest.version))[0];h.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}))}catch(x){this.logService.error(x)}const I=F.filter(x=>x.metadata&&M[n.ExtensionKey.create(x).toString()]);await Promise.allSettled(I.map(x=>this.removeUninstalledExtension(x)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(F){(0,J.toFileOperationResult)(F)!==1&&this.logService.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(z))){this.logService.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.fileService.del(F.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(h){(0,J.toFileOperationResult)(h)!==1&&this.logService.error(h)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=me([re(1,J.IFileService),re(2,o.IExtensionsScannerService),re(3,r.IExtensionsProfileScannerService),re(4,de.IUriIdentityService),re(5,oe.ILogService)],V);class _ extends s.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,C.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(M,F,h,I,x,U,q,B,te){super(),this.identifier=M,this.source=F,this.options=h,this.extensionsScanner=I,this.uriIdentityService=x,this.userDataProfilesService=U,this.extensionsScannerService=q,this.extensionsProfileScannerService=B,this.logService=te,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(M){const[F,h]=await this.install(M);return this._profileLocation=F.isBuiltin||F.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,h]],this._profileLocation),F}async extractExtension({zipPath:M,key:F,metadata:h},I,x){let U=await this.unsetIfUninstalled(F);return U?U=await this.extensionsScanner.updateMetadata(U,h):(this.logService.trace("Extracting extension...",F.id),U=await this.extensionsScanner.extractUserExtension(F,M,h,I,x),this.logService.info("Extracting extension completed.",F.id)),U}async unsetIfUninstalled(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(I=>n.ExtensionKey.create(I).equals(M))):void 0}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.toString()]}}class $ extends _{constructor(M,F,h,I,x,U,q,B,te,ce){super(F.identifier,F,h,x,U,q,B,te,ce),this.gallery=F,this.extensionsDownloader=I}async install(M){let F;try{F=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)}catch(q){throw new t.ExtensionManagementError(q,t.ExtensionManagementErrorCode.Scanning)}const h=F.find(q=>(0,n.areSameExtensions)(q.identifier,this.gallery.identifier));h&&(this._operation=3);const I={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||h?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||h?.isMachineScoped,isBuiltin:this.options.isBuiltin||h?.isBuiltin,isSystem:h?.type===0?!0:void 0,updated:!!h,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:h?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??h?.pinned,preRelease:(0,C.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||h?.preRelease};if(h?.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(h,I),I]}catch(q){throw new t.ExtensionManagementError((0,T.getErrorMessage)(q),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:x,verificationStatus:U}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=U,this.validateManifest(x.fsPath),[await this.extractExtension({zipPath:x.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:I},!1,M),I]}catch(q){try{await this.extensionsDownloader.delete(x)}catch(B){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,T.getErrorMessage)(B))}throw q}}async validateManifest(M){try{await(0,D.getManifest)(M)}catch(F){throw new t.ExtensionManagementError((0,s.joinErrors)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=$;class H extends _{constructor(M,F,h,I,x,U,q,B,te,ce){super({id:(0,n.getGalleryExtensionId)(M.publisher,M.name)},F,h,x,U,q,B,te,ce),this.manifest=M,this.location=F,this.galleryService=I}async doRun(M){const F=await super.doRun(M);return this.updateMetadata(F,M),F}async install(M){const F=new n.ExtensionKey(this.identifier,this.manifest.version),I=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(q=>(0,n.areSameExtensions)(this.identifier,q.identifier)),x={isApplicationScoped:this.options.isApplicationScoped||I?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||I?.isMachineScoped,isBuiltin:this.options.isBuiltin||I?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??I?.pinned};if(I)if(this._operation=3,F.equals(new n.ExtensionKey(I.identifier,I.manifest.version)))try{await this.extensionsScanner.removeExtension(I,"existing")}catch{throw new Error(u.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&S.gt(I.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(I);else{const q=await this.unsetIfUninstalled(F);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(u.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:d.resolve(this.location.fsPath),key:F,metadata:x},!0,M),x]}async updateMetadata(M,F){try{let[h]=await this.galleryService.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(h||([h]=await this.galleryService.getExtensions([{id:M.identifier.id}],F)),h){const I={id:h.identifier.uuid,publisherDisplayName:h.publisherDisplayName,publisherId:h.publisherId,isPreReleaseVersion:h.properties.isPreReleaseVersion,hasPreReleaseVersion:M.hasPreReleaseVersion||h.properties.isPreReleaseVersion,preRelease:h.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(M,I,this.options.profileLocation)}}catch{}}}class Y extends s.AbstractExtensionTask{constructor(M,F,h){super(),this.extension=M,this.profileLocation=F,this.extensionsProfileScannerService=h}async doRun(M){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(G,e,A,O,k,N,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let y=class extends T.AbstractExtensionsProfileScannerService{constructor(d,m,S,C,E,l){super(a.URI.file(d.extensionsPath),m,S,C,E,l)}};e.ExtensionsProfileScannerService=y,e.ExtensionsProfileScannerService=y=me([re(0,f.INativeEnvironmentService),re(1,b.IFileService),re(2,O.IUserDataProfilesService),re(3,k.IUriIdentityService),re(4,N.ITelemetryService),re(5,A.ILogService)],y)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(G,e,A,O,k,N,T,b,f,a,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends N.NativeExtensionsScannerService{constructor(S,C,E,l,v,p,u,g){super(A.URI.file(v.builtinExtensionsPath),A.URI.file(v.extensionsPath),v.userHome,S.defaultProfile,S,C,E,l,v,p,u,g)}};e.ExtensionsScannerService=d,e.ExtensionsScannerService=d=me([re(0,P.IUserDataProfilesService),re(1,k.IExtensionsProfileScannerService),re(2,T.IFileService),re(3,f.ILogService),re(4,O.INativeEnvironmentService),re(5,a.IProductService),re(6,y.IUriIdentityService),re(7,b.IInstantiationService)],d)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(G,e,A,O,k,N,T,b,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var y;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var P;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function m(v){const p=v.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=m;class S extends k.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(p={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=p,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new A.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(p,u,g){return O.Event.filter(this._onDidChangeValue.event,i=>i.scope===p&&(u===void 0||i.key===u),g)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,A.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,N.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,u){const{key:g,external:i}=u;if(g===e.TARGET_KEY){switch(p){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:p})}else this._onDidChangeValue.fire({scope:p,key:g,target:this.getKeyTargets(p)[g],external:i})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,u,g){return this.getStorage(u)?.get(p,g)}getBoolean(p,u,g){return this.getStorage(u)?.getBoolean(p,g)}getNumber(p,u,g){return this.getStorage(u)?.getNumber(p,g)}getObject(p,u,g){return this.getStorage(u)?.getObject(p,g)}storeAll(p,u){this.withPausedEmitters(()=>{for(const g of p)this.store(g.key,g.value,g.scope,g.target,u)})}store(p,u,g,i,s=!1){if((0,T.isUndefinedOrNull)(u)){this.remove(p,g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,g,i),this.getStorage(g)?.set(p,u,s)})}remove(p,u,g=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(p,u,void 0),this.getStorage(u)?.delete(p,g)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,u){const g=[],i=this.getKeyTargets(p);for(const s of Object.keys(i))i[s]===u&&g.push(s);return g}updateKeyTarget(p,u,g,i=!1){const s=this.getKeyTargets(u);typeof g=="number"?s[p]!==g&&(s[p]=g,this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(s),i)):typeof s[p]=="number"&&(delete s[p],this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(s),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(p){switch(p){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(p){const u=this.getStorage(p);return u?m(u):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=y.NONE){this._onWillSaveState.fire({reason:p});const u=this.getStorage(-1),g=this.getStorage(0),i=this.getStorage(1);switch(p){case y.NONE:await A.Promises.settled([u?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await A.Promises.settled([u?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return l(p,u,g,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(p){return await this.flush(),this.getStorage(p)?.optimize()}async switch(p,u){return this.emitWillSaveState(y.NONE),(0,a.isUserDataProfile)(p)?this.switchToProfile(p,u):this.switchToWorkspace(p,u)}canSwitchProfile(p,u){return!(p.id===u.id||C(u)&&C(p))}switchData(p,u,g){this.withPausedEmitters(()=>{const i=new Set;for(const[s,t]of p)i.add(s),u.get(s)!==t&&this.emitDidChangeValue(g,{key:s,external:!0});for(const[s]of u.items)i.has(s)||this.emitDidChangeValue(g,{key:s,external:!0})})}}e.AbstractStorageService=S;function C(v){return v.isDefault||!!v.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=C;class E extends S{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.profileStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),this._register(this.applicationStorage.onDidChangeStorage(p=>this.emitDidChangeValue(-1,p)))}getStorage(p){switch(p){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(p){return!1}}e.InMemoryStorageService=E;async function l(v,p,u,g,i,s){const t=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,r=new Map;v.forEach((W,J)=>{n.set(J,W),r.set(J,t(W))});const o=new Map,c=new Map;p.forEach((W,J)=>{o.set(J,W),c.set(J,t(W))});const R=new Map,D=new Map;u.forEach((W,J)=>{R.set(J,W),D.set(J,t(W))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const w=[];if(n.forEach((W,J)=>{w.push({key:J,value:W})}),console.table(w),console.groupEnd(),console.log(r),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const W=[];o.forEach((J,X)=>{W.push({key:X,value:J})}),console.table(W),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${s})`);const L=[];R.forEach((W,J)=>{L.push({key:J,value:W})}),console.table(L),console.groupEnd(),console.log(D)}e.logStorage=l}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=N.isWeb?"web":(0,P.getTargetPlatform)(N.platform,T.arch),s="X-Market-Search-Activity-Id";var t;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished",I[I.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...I){return String(I.reduce((x,U)=>x|U,0))}var r;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(x=D){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(x,U=this.state.pageSize){return new w({...this.state,pageNumber:x,pageSize:U})}withFilter(x,...U){const q=[...this.state.criteria,...U.length?U.map(B=>({filterType:x,value:B})):[{filterType:x}]];return new w({...this.state,criteria:q})}withSortBy(x){return new w({...this.state,sortBy:x})}withSortOrder(x){return new w({...this.state,sortOrder:x})}withFlags(...x){return new w({...this.state,flags:x.reduce((U,q)=>U|q,0)})}withAssetTypes(...x){return new w({...this.state,assetTypes:x})}withSource(x){return new w({...this.state,source:x})}get raw(){const{criteria:x,pageNumber:U,pageSize:q,sortBy:B,sortOrder:te,flags:ce,assetTypes:ue}=this.state;return{filters:[{criteria:x,pageNumber:U,pageSize:q,sortBy:B,sortOrder:te}],assetTypes:ue,flags:ce}}get searchText(){const x=this.state.criteria.filter(U=>U.filterType===r.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function L(I,x){const U=(I||[]).filter(q=>q.statisticName===x)[0];return U?U.value:0}function W(I){const x="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(q=>q.assetType.indexOf(x)===0).reduce((q,B)=>{const te=oe(I,B.assetType);return te&&q.push([B.assetType.substring(x.length),te]),q},[])}function J(I){if(I.properties){const x=I.properties.filter(B=>B.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=x.filter(B=>U.test(B.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return oe(I,o.Repository)}function X(I){return{uri:`${I.fallbackAssetUri}/${o.VSIX}?redirect=true${I.targetPlatform?`&targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${o.VSIX}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}}function oe(I,x){return I.files.filter(q=>q.assetType===x)[0]?{uri:`${I.assetUri}/${x}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${x}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}:null}function se(I,x){const U=I.properties?I.properties.filter(B=>B.key===x):[],q=U.length>0&&U[0].value;return q?q.split(",").map(B=>(0,d.adoptToGalleryExtensionId)(B)):[]}function fe(I){const x=I.properties?I.properties.filter(U=>U.key===c.Engine):[];return x.length>0&&x[0].value||""}function de(I){const x=I.properties?I.properties.filter(U=>U.key===c.PreRelease):[];return x.length>0&&x[0].value==="true"}function ae(I){const x=I.properties?I.properties.filter(q=>q.key===c.LocalizedLanguages):[],U=x.length>0&&x[0].value||"";return U?U.split(","):[]}function z(I){return I.properties?.find(x=>x.key===c.SponsorLink)?.value}function K(I){return I.properties?.find(x=>x.key===c.SupportLink)?.value}function V(I){return I.indexOf("preview")!==-1}function _(I){return I.targetPlatform?(0,P.toTargetPlatform)(I.targetPlatform):"undefined"}function $(I){const x=(0,A.distinct)(I.versions.map(_)),U=!!I.tags?.includes(P.WEB_EXTENSION_TAG),q=x.indexOf("web");return U?q===-1&&x.push("web"):q!==-1&&x.splice(q,1),x}function H(I,x){for(let U=0;U<I.length;U++){const q=I[U];if(q.version===I[U-1]?.version){let B=U;if(_(q)===x)for(;B>0&&I[B-1].version===q.version;)B--;B!==U&&(I.splice(U,1),I.splice(B,0,q))}}return I}e.sortExtensionVersions=H;function Y(I,x,U){I.telemetryData={index:x,querySource:U,queryActivityId:I.queryContext?.[s]}}function Z(I,x,U,q){const B=I.versions[0],te={manifest:oe(x,o.Manifest),readme:oe(x,o.Details),changelog:oe(x,o.Changelog),license:oe(x,o.License),repository:J(x),download:X(x),icon:oe(x,o.Icon),signature:oe(x,o.Signature),coreTranslations:W(x)};return{identifier:{id:(0,d.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:x.version,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,publisherDomain:I.publisher.domain?{link:I.publisher.domain,verified:!!I.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(B),description:I.shortDescription??"",installCount:L(I.statistics,"install"),rating:L(I.statistics,"averagerating"),ratingCount:L(I.statistics,"ratingcount"),categories:I.categories||[],tags:I.tags||[],releaseDate:Date.parse(I.releaseDate),lastUpdated:Date.parse(I.lastUpdated),allTargetPlatforms:U,assets:te,properties:{dependencies:se(x,c.Dependency),extensionPack:se(x,c.ExtensionPack),engine:fe(x),localizedLanguages:ae(x),targetPlatform:_(x),isPreReleaseVersion:de(x)},hasPreReleaseVersion:de(B),hasReleaseVersion:!0,preview:V(I.flags),isSigned:!!te.signature,queryContext:q,supportLink:K(B)}}let M=class{constructor(x,U,q,B,te,ce,ue,pe){this.requestService=U,this.logService=q,this.environmentService=B,this.telemetryService=te,this.fileService=ce,this.productService=ue,this.configurationService=pe;const Se=ue.extensionsGallery,he=Se?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=he?Se.servicePPEUrl:Se?.serviceUrl,this.extensionsGallerySearchUrl=he?void 0:Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,v.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,x,this.telemetryService)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,U,q){const B=O.CancellationToken.isCancellationToken(U)?{}:U,te=O.CancellationToken.isCancellationToken(U)?U:q,ce=[],ue=[],pe=[],Se=[];let he=!0;for(const Ee of x){Ee.uuid?ue.push(Ee.uuid):ce.push(Ee.id);const be=!!(Ee.version||Ee.preRelease);pe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:be}),Ee.version&&Se.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!be}if(!ue.length&&!ce.length)return[];let le=new w().withPage(1,x.length);ue.length&&(le=le.withFilter(r.ExtensionId,...ue)),ce.length&&(le=le.withFilter(r.ExtensionName,...ce)),(B.queryAllVersions||he)&&(le=le.withFlags(le.flags,t.IncludeVersions)),B.source&&(le=le.withSource(B.source));const{extensions:ve}=await this.queryGalleryExtensions(le,{targetPlatform:B.targetPlatform??i,includePreRelease:pe,versions:Se,compatible:!!B.compatible},te);return B.source&&ve.forEach((Ee,be)=>Y(Ee,be,B.source)),ve}async getCompatibleExtension(x,U,q){if((0,P.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(x,U,q))return x;const B=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,x.identifier.uuid),{extensions:te}=await this.queryGalleryExtensions(B,{targetPlatform:q,compatible:!0,includePreRelease:U},O.CancellationToken.None);return te[0]||null}async isExtensionCompatible(x,U,q){if(!(0,P.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,q)||!U&&x.properties.isPreReleaseVersion)return!1;let B=x.properties.engine;if(!B){const te=await this.getManifest(x,O.CancellationToken.None);if(!te)throw new Error("Manifest was not found");B=te.engines.vscode}return(0,m.isEngineValid)(B,this.productService.version,this.productService.date)}async isValidVersion(x,U,q,B,te){if(!(0,P.isTargetPlatformCompatible)(_(x),B,te)||U!=="any"&&de(x)!==(U==="prerelease"))return!1;if(q)try{const ce=await this.getEngine(x);if(!(0,m.isEngineValid)(ce,this.productService.version,this.productService.date))return!1}catch(ce){return this.logService.error(`Error while getting the engine for the version ${x.version}.`,(0,k.getErrorMessage)(ce)),!1}return!0}async query(x,U){let q=x.text||"";const B=x.pageSize??50;let te=new w().withPage(1,B);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,le,ve)=>(te=te.withFilter(r.Category,ve||le),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,le,ve)=>(te=te.withFilter(r.Tag,ve||le),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(r.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),te=te.withFilter(r.SearchText,q)),te=te.withSortBy(0)):x.ids?te=te.withFilter(r.ExtensionId,...x.ids):x.names?te=te.withFilter(r.ExtensionName,...x.names):te=te.withSortBy(4),typeof x.sortBy=="number"&&(te=te.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(te=te.withSortOrder(x.sortOrder)),x.source&&(te=te.withSource(x.source));const ce=async(he,le)=>{const{extensions:ve,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:i,compatible:!1,includePreRelease:!!x.includePreRelease},le);return ve.forEach((be,Le)=>Y(be,(he.pageNumber-1)*he.pageSize+Le,x.source)),{extensions:ve,total:Ee}},{extensions:ue,total:pe}=await ce(te,U),Se=async(he,le)=>{if(le.isCancellationRequested)throw new k.CancellationError;const{extensions:ve}=await ce(te.withPage(he+1),le);return ve};return{firstPage:ue,total:pe,pageSize:te.pageSize,getPage:Se}}async queryGalleryExtensions(x,U,q){const B=x.flags;x.flags&t.IncludeLatestVersionOnly&&x.flags&t.IncludeVersions&&(x=x.withFlags(x.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(x.flags&t.IncludeLatestVersionOnly)&&!(x.flags&t.IncludeVersions)&&(x=x.withFlags(x.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(x=x.withFlags(x.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),x=x.withFlags(x.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ce,context:ue}=await this.queryRawGalleryExtensions(x,q);if(!(x.flags&t.IncludeLatestVersionOnly)){const le=[];for(const ve of te){const Ee=await this.toGalleryExtensionWithCriteria(ve,U,ue);Ee&&le.push(Ee)}return{extensions:le,total:ce}}const Se=[],he=new Map;for(let le=0;le<te.length;le++){const ve=te[le],Ee={id:(0,d.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},be=(0,b.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(j=>(0,d.areSameExtensions)(j,Ee))?.includePreRelease;if(U.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)($(ve),U.targetPlatform))continue;const Le=await this.toGalleryExtensionWithCriteria(ve,U,ue);!Le||Le.properties.isPreReleaseVersion&&(!be||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==U.targetPlatform&&Le.hasPreReleaseVersion?he.set(ve.extensionId,le):Se.push([le,Le])}if(he.size){const le=new g.StopWatch,ve=new w().withFlags(B&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(r.ExtensionId,...he.keys()),{extensions:Ee}=await this.queryGalleryExtensions(ve,U,q);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:le.elapsed(),count:he.size});for(const be of Ee){const Le=he.get(be.identifier.uuid);Se.push([Le,be])}}return{extensions:Se.sort((le,ve)=>le[0]-ve[0]).map(([,le])=>le),total:ce}}async toGalleryExtensionWithCriteria(x,U,q){const B={id:(0,d.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},te=U.versions?.find(Se=>(0,d.areSameExtensions)(Se,B))?.version,ce=(0,b.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Se=>(0,d.areSameExtensions)(Se,B))?.includePreRelease,ue=$(x),pe=H(x.versions,U.targetPlatform);if(U.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(ue,U.targetPlatform))return null;for(let Se=0;Se<pe.length;Se++){const he=pe[Se];if(!(te&&he.version!==te)){if(await this.isValidVersion(he,ce?"any":"release",U.compatible,ue,U.targetPlatform))return Z(x,he,ue,q);if(te&&he.version===te)return null}}return te||U.compatible?null:Z(x,x.versions[0],ue)}async queryRawGalleryExtensions(x,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(t.Unpublished));const q=await this.commonHeadersPromise,B=JSON.stringify(x.raw),te={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},ce=new g.StopWatch;let ue,pe,Se=0;try{if(ue=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&x.criteria.some(le=>le.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:B,headers:te},U),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Se};const he=await(0,l.asJson)(ue);if(he){const le=he.results[0],ve=le.extensions,Ee=le.resultMetadata&&le.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return Se=Ee&&Ee.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:Se,context:{[s]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:Se}}catch(he){const le=(0,k.isCancellationError)(he)?P.ExtensionGalleryErrorCode.Cancelled:(0,k.getErrorMessage)(he).startsWith("XHR timeout")?P.ExtensionGalleryErrorCode.Timeout:P.ExtensionGalleryErrorCode.Failed;throw pe=new P.ExtensionGalleryError((0,k.getErrorMessage)(he),le),pe}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(B.length),duration:ce.elapsed(),success:!!ue&&(0,l.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?.code,count:String(Se)})}}async reportStatistic(x,U,q,B){if(!this.isEnabled())return;const te=N.isWeb?this.api(`/itemName/${x}.${U}/version/${q}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${U}/${q}/stats?statType=${B}`),ce=N.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:te,headers:pe},O.CancellationToken.None)}catch{}}async download(x,U,q){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const B=(0,d.getGalleryExtensionTelemetryData)(x),te=new Date().getTime(),ce=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:le}),ue=q===2?"install":q===3?"update":"",pe=ue?{uri:`${x.assets.download.uri}${f.URI.parse(x.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${x.assets.download.fallbackUri}${f.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:x.assets.download,Se=x.queryContext?.[s]?{[s]:x.queryContext[s]}:void 0,he=await this.getAsset(pe,Se?{headers:Se}:void 0);await this.fileService.writeFile(U,he.stream),ce(new Date().getTime()-te)}async downloadSignatureArchive(x,U){if(!x.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",x.identifier.id);const q=await this.getAsset(x.assets.signature);await this.fileService.writeFile(U,q.stream)}async getReadme(x,U){if(x.assets.readme){const q=await this.getAsset(x.assets.readme,{},U);return await(0,l.asTextOrError)(q)||""}return""}async getManifest(x,U){if(x.assets.manifest){const q=await this.getAsset(x.assets.manifest,{},U),B=await(0,l.asTextOrError)(q);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(x,U){const q=oe(x,o.Manifest);if(!q)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},te=await this.getAsset(q,{headers:B});return await(0,l.asJson)(te)}async getCoreTranslation(x,U){const q=x.assets.coreTranslations.filter(B=>B[0]===U.toUpperCase())[0];if(q){const B=await this.getAsset(q[1]),te=await(0,l.asTextOrError)(B);return te?JSON.parse(te):null}return null}async getChangelog(x,U){if(x.assets.changelog){const q=await this.getAsset(x.assets.changelog,{},U);return await(0,l.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(x,U,q){let B=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?B=B.withFilter(r.ExtensionId,x.identifier.uuid):B=B.withFilter(r.ExtensionName,x.identifier.id);const{galleryExtensions:te}=await this.queryRawGalleryExtensions(B,O.CancellationToken.None);if(!te.length)return[];const ce=$(te[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(ce,q))return[];const ue=[];await Promise.all(te[0].versions.map(async he=>{try{await this.isValidVersion(he,U?"any":"release",!0,ce,q)&&ue.push(he)}catch{}}));const pe=[],Se=new Set;for(const he of H(ue,q))Se.has(he.version)||(Se.add(he.version),pe.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:de(he)}));return pe}async getAsset(x,U={},q=O.CancellationToken.None){const B=await this.commonHeadersPromise,te={type:"GET"},ce={...B,...U.headers||{}};U={...U,...te,headers:ce};const ue=x.uri,pe=x.fallbackUri,Se={...U,url:ue};try{const he=await this.requestService.request(Se,q);if(he.res.statusCode===200)return he;const le=await(0,l.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${le}`)}catch(he){if((0,k.isCancellationError)(he))throw he;const le=(0,k.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:le});const ve={...U,url:pe};return this.requestService.request(ve,q)}}async getEngine(x){let U=fe(x);if(!U){const q=await this.getManifestFromRawExtensionVersion(x,O.CancellationToken.None);if(!q)throw new Error("Manifest was not found");U=q.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(x),q=[],B={},te=[];if(U){for(const ce of U.malicious)q.push({id:ce});if(U.migrateToPreRelease)for(const[ce,ue]of Object.entries(U.migrateToPreRelease))(!ue.engine||(0,m.isEngineValid)(ue.engine,this.productService.version,this.productService.date))&&(B[ce.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ce,ue]of Object.entries(U.deprecated))ue&&(B[ce.toLowerCase()]=(0,b.isBoolean)(ue)?{}:ue);if(U.search)for(const ce of U.search)te.push(ce)}return{malicious:q,deprecated:B,search:te}}};M=me([re(1,l.IRequestService),re(2,C.ILogService),re(3,y.IEnvironmentService),re(4,u.ITelemetryService),re(5,S.IFileService),re(6,E.IProductService),re(7,a.IConfigurationService)],M);let F=class extends M{constructor(x,U,q,B,te,ce,ue,pe){super(x,U,q,B,te,ce,ue,pe)}};e.ExtensionGalleryService=F,e.ExtensionGalleryService=F=me([re(0,p.IStorageService),re(1,l.IRequestService),re(2,C.ILogService),re(3,y.IEnvironmentService),re(4,u.ITelemetryService),re(5,S.IFileService),re(6,E.IProductService),re(7,a.IConfigurationService)],F);let h=class extends M{constructor(x,U,q,B,te,ce,ue){super(void 0,x,U,q,B,te,ce,ue)}};e.ExtensionGalleryServiceWithNoStorageService=h,e.ExtensionGalleryServiceWithNoStorageService=h=me([re(0,l.IRequestService),re(1,C.ILogService),re(2,y.IEnvironmentService),re(3,u.ITelemetryService),re(4,S.IFileService),re(5,E.IProductService),re(6,a.IConfigurationService)],h)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(G,e,A,O,k,N,T,b,f,a,y){"use strict";var P,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=class extends f.UserDataProfilesService{static{P=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(l,v,p,u,g){super(p,u,v,g),this.stateReadonlyService=l,this.nativeEnvironmentService=p}getStoredProfiles(){return this.stateReadonlyService.getItem(P.PROFILES_KEY,[]).map(v=>({...v,location:(0,a.isString)(v.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,v.location):A.URI.revive(v.location)}))}getStoredProfileAssociations(){const l=this.stateReadonlyService.getItem(P.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(P.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?l:this.migrateStoredProfileAssociations(l)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(A.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=m,e.UserDataProfilesReadonlyService=m=P=me([re(0,T.IStateReadService),re(1,b.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,N.ILogService)],m);let S=d=class extends m{constructor(l,v,p,u,g){super(l,v,p,u,g),this.stateService=l}saveStoredProfiles(l){l.length?this.stateService.setItem(d.PROFILES_KEY,l.map(v=>({...v,location:this.uriIdentityService.extUri.basename(v.location)}))):this.stateService.removeItem(d.PROFILES_KEY)}getStoredProfiles(){const l=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(l),this.stateService.setItem("userDataProfilesMigration",!0)),l}saveStoredProfileAssociations(l){l.emptyWindows||l.workspaces?this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,l):this.stateService.removeItem(d.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const l="workspaceAndProfileInfo",v=this.stateService.getItem(l,void 0);if(v){this.stateService.removeItem(l);const u=v.reduce((g,{workspace:i,profile:s})=>(g[A.URI.revive(i).toString()]=A.URI.revive(s).toString(),g),{});this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,{workspaces:u})}const p=super.getStoredProfileAssociations();return this.stateService.getItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(p),this.stateService.setItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),p}};e.UserDataProfilesService=S,e.UserDataProfilesService=S=d=me([re(0,T.IStateService),re(1,b.IUriIdentityService),re(2,O.INativeEnvironmentService),re(3,k.IFileService),re(4,N.ILogService)],S);let C=class extends S{constructor(l,v,p,u){super(new y.StateService(0,v,u,p),l,v,p,u)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=C,e.ServerUserDataProfilesService=C=me([re(0,b.IUriIdentityService),re(1,O.INativeEnvironmentService),re(2,k.IFileService),re(3,N.ILogService)],C)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let S=class extends P.AbstractRequestService{constructor(v,p,u,g){super(g),this.configurationService=v,this.environmentService=p,this.logService=u,this.configure(),this._register(v.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.configure()}))}configure(){const v=this.configurationService.getValue("http");this.proxyUrl=v?.proxy,this.strictSSL=!!v?.proxyStrictSSL,this.authorization=v?.proxyAuthorization}async request(v,p){const{proxyUrl:u,strictSSL:g}=this;let i;try{i=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,N.getErrorMessage)(n)))}const s={...process.env,...i},t=v.agent?v.agent:await(0,d.getProxyAgent)(v.url||"",s,{proxyUrl:u,strictSSL:g});return v.agent=t,v.strictSSL=g,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(v.isChromiumNetwork?"electron":"node",v,()=>E(v,p))}async resolveProxy(v){}async loadCertificates(){return(await new Promise((p,u)=>{G(["@vscode/proxy-agent"],p,u)})).loadSystemCertificates({log:this.logService})}};e.RequestService=S,e.RequestService=S=me([re(0,b.IConfigurationService),re(1,f.INativeEnvironmentService),re(2,y.ILogService),re(3,y.ILoggerService)],S);async function C(l){return((0,A.parse)(l.url).protocol==="https:"?await new Promise((u,g)=>{G(["https"],u,g)}):await new Promise((u,g)=>{G(["http"],u,g)})).request}async function E(l,v){return O.Promises.withAsyncBody(async(p,u)=>{const g=(0,A.parse)(l.url),i=l.getRawRequest?l.getRawRequest(l):await C(l),s={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,T.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(s.auth=l.user+":"+l.password);const t=i(s,n=>{const r=(0,T.isNumber)(l.followRedirects)?l.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)E({...l,url:n.headers.location,followRedirects:r-1},v).then(p,u);else{let o=n;!l.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,m.createGunzip)())),p({res:n,stream:(0,k.streamToBufferReadableStream)(o)})}});t.on("error",u),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),v.onCancellationRequested(()=>{t.abort(),u(new N.CancellationError)})})}e.nodeRequest=E}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(G,e,A,O,k,N,T,b,f,a,y,P,d,m,S,C,E,l,v,p,u,g,i,s,t,n,r,o,c,R,D,w,L,W,J,X,oe,se,fe,de,ae,z,K,V,_,$,H,Y,Z,M,F,h,I,x,U,q,B,te,ce,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends T.Disposable{constructor(le){super(),this.argv=le,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[le,ve]=await this.initServices();return le.invokeFunction(async Ee=>{const be=Ee.get(X.ILogService),Le=Ee.get(o.IFileService),j=Ee.get(l.INativeEnvironmentService),Q=Ee.get(I.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(j,Le,Q,le),await Promise.all(ve.map(ee=>{(0,O.raceTimeout)(ee.flush(),1e3)}))})}async initServices(){const le=new L.ServiceCollection,ve={_serviceBrand:void 0,...de.default};le.set(ae.IProductService,ve);const Ee=new v.NativeEnvironmentService(this.argv,ve);le.set(l.INativeEnvironmentService,Ee),await Promise.all([Ee.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,Ee.extensionsPath].map(Ne=>Ne?d.Promises.mkdir(Ne,{recursive:!0}):void 0));const be=new te.LoggerService((0,X.getLogLevel)(Ee),Ee.logsHome);le.set(X.ILoggerService,be);const Le=this._register(be.createLogger("cli",{name:(0,ce.localize)(0,null)})),j=[];be.getLogLevel()===X.LogLevel.Trace&&j.push(new X.ConsoleLogger(be.getLogLevel()));const Q=this._register(new B.LogService(Le,j));le.set(X.ILogService,Q);const ee=this._register(new c.FileService(Q));le.set(o.IFileService,ee);const ge=this._register(new R.DiskFileSystemProvider(Q));ee.registerProvider(b.Schemas.file,ge);const ye=new h.UriIdentityService(ee);le.set(F.IUriIdentityService,ye);const Oe=new V.StateReadonlyService(1,Ee,Q,ee),Ie=new x.UserDataProfilesReadonlyService(Oe,ye,Ee,ee,Q);le.set(I.IUserDataProfilesService,Ie),ee.registerProvider(b.Schemas.vscodeUserData,new ue.FileUserDataProvider(b.Schemas.file,ge,b.Schemas.vscodeUserData,Ie,ye,Q));const xe=a.isWindows&&ve.win32RegValueName?this._register(new fe.NativePolicyService(Q,ve.win32RegValueName)):Ee.policyFile?this._register(new oe.FilePolicyService(Ee.policyFile,ee,Q)):new se.NullPolicyService;le.set(se.IPolicyService,xe);const De=this._register(new S.ConfigurationService(Ie.defaultProfile.settingsResource,ee,xe,Q));le.set(m.IConfigurationService,De),await Promise.all([Oe.init(),De.initialize()]);let Ae;try{Ae=await(0,U.resolveMachineId)(Oe,Q)}catch(Ne){Ne.code!=="ENOENT"&&Q.error(Ne)}const Ue=await(0,U.resolveSqmId)(Oe,Q);Ie.init(),le.set(F.IUriIdentityService,new h.UriIdentityService(ee));const Re=new K.RequestService(De,Ee,Q,be);le.set(z.IRequestService,Re),le.set(C.IDownloadService,new D.SyncDescriptor(E.DownloadService,void 0,!0)),le.set(s.IExtensionsProfileScannerService,new D.SyncDescriptor(q.ExtensionsProfileScannerService,void 0,!0)),le.set(t.IExtensionsScannerService,new D.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),le.set(g.IExtensionSignatureVerificationService,new D.SyncDescriptor(g.ExtensionSignatureVerificationService,void 0,!0)),le.set(n.INativeServerExtensionManagementService,new D.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),le.set(u.IExtensionGalleryService,new D.SyncDescriptor(p.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),le.set(W.ILanguagePackService,new D.SyncDescriptor(J.NativeLanguagePackService,void 0,!1));const Te=[],Fe=(0,Y.isInternalTelemetry)(ve,De);if((0,Y.supportsTelemetry)(ve,Ee)){ve.aiConfig&&ve.aiConfig.ariaKey&&Te.push(new Z.OneDataSystemAppender(Re,Fe,"monacoworkbench",null,ve.aiConfig.ariaKey));const Ne={appenders:Te,sendErrorTelemetry:!1,commonProperties:(0,_.resolveCommonProperties)((0,A.release)(),(0,A.hostname)(),process.arch,ve.commit,ve.version,Ae,Ue,Fe),piiPaths:(0,Y.getPiiPathsFromEnvironment)(Ee)};le.set($.ITelemetryService,new D.SyncDescriptor(H.TelemetryService,[Ne],!1))}else le.set($.ITelemetryService,Y.NullTelemetryService);return[new w.InstantiationService(le),Te]}registerErrorHandler(le){(0,N.setUnexpectedErrorHandler)(ve=>{const Ee=(0,k.toErrorMessage)(ve,!0);Ee&&le.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",ve=>{(0,N.isSigPipeError)(ve)||(0,N.onUnexpectedError)(ve)}),process.on("unhandledRejection",ve=>(0,N.onUnexpectedError)(ve))}async doRun(le,ve,Ee,be){let Le;if(le.args.profile&&(Le=Ee.profiles.find(Q=>Q.name===le.args.profile),!Le))throw new Error(`Profile '${le.args.profile}' not found.`);const j=(Le??Ee.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return be.createInstance(i.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,j);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Q={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:j};return be.createInstance(i.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),Q,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(i.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,j);if(this.argv["update-extensions"])return be.createInstance(i.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).updateExtensions(j);if(this.argv["locate-extension"])return be.createInstance(i.ExtensionManagementCLI,new X.ConsoleLogger(X.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(le.appRoot,le.extensionsPath))}}asExtensionIdOrVSIX(le){return le.map(ve=>/\.vsix$/i.test(ve)?P.URI.file((0,f.isAbsolute)(ve)?ve:(0,f.join)((0,y.cwd)(),ve)):ve)}}async function Se(he){const le=new pe(he);try{await le.run()}finally{le.dispose()}}e.main=Se})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/code/node/cliProcessMain.js.map
