/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","fs","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","fs/promises","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(se){for(var e=[],L=0,O=se.length;L<O;L++)e[L]=le[se[L]];return e};define(le[124],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class L{static get(){const A=new Map,T=new Map,_=new Map,R=new Map;function b(u,f){u.has(f.detail)||u.set(f.detail,-f.timestamp)}function m(u,f){const v=u.get(f.detail);v&&(v>=0||u.set(f.detail,v+f.timestamp))}let P=[];typeof se=="function"&&typeof se.getStats=="function"&&(P=se.getStats().slice(0).sort((u,f)=>u.timestamp-f.timestamp));for(const u of P)switch(u.type){case 10:b(A,u);break;case 11:case 12:m(A,u);break;case 21:b(T,u);break;case 22:m(T,u);break;case 33:b(_,u);break;case 34:m(_,u);break;case 31:b(R,u);break;case 32:m(R,u);break}let I=0;_.forEach(u=>I+=u);function S(u){const f=[];return u.forEach((v,E)=>f.push([E,v])),f}return{amdLoad:S(A),amdInvoke:S(T),nodeRequire:S(_),nodeEval:S(R),nodeRequireTotal:I}}static toMarkdownTable(A,T){let _="";const R=[];return A.forEach((b,m)=>{R[m]=b.length}),T.forEach(b=>{b.forEach((m,P)=>{typeof m>"u"&&(m=b[P]="-");const I=m.toString().length;R[P]=Math.max(I,R[P])})}),A.forEach((b,m)=>{_+=`| ${b+" ".repeat(R[m]-b.toString().length)} `}),_+=`|
`,A.forEach((b,m)=>{_+=`| ${"-".repeat(R[m])} `}),_+=`|
`,T.forEach(b=>{b.forEach((m,P)=>{typeof m<"u"&&(_+=`| ${m+" ".repeat(R[P]-m.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=L}),define(le[125],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function L(v,E,c){const d=O(v,E);if(d!==-1)return v[d]}e.findLast=L;function O(v,E,c=v.length-1){for(let d=c;d>=0;d--){const g=v[d];if(E(g))return d}return-1}e.findLastIdx=O;function A(v,E){const c=T(v,E);return c===-1?void 0:v[c]}e.findLastMonotonous=A;function T(v,E,c=0,d=v.length){let g=c,l=d;for(;g<l;){const w=Math.floor((g+l)/2);E(v[w])?g=w+1:l=w}return g-1}e.findLastIdxMonotonous=T;function _(v,E){const c=R(v,E);return c===v.length?void 0:v[c]}e.findFirstMonotonous=_;function R(v,E,c=0,d=v.length){let g=c,l=d;for(;g<l;){const w=Math.floor((g+l)/2);E(v[w])?l=w:g=w+1}return g}e.findFirstIdxMonotonousOrArrLen=R;function b(v,E,c=0,d=v.length){const g=R(v,E,c,d);return g===v.length?-1:g}e.findFirstIdxMonotonous=b;class m{static{this.assertInvariants=!1}constructor(E){this._array=E,this._findLastMonotonousLastIdx=0}findLastMonotonous(E){if(m.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!E(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=E}const c=T(this._array,E,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}e.MonotonousArray=m;function P(v,E){if(v.length===0)return;let c=v[0];for(let d=1;d<v.length;d++){const g=v[d];E(g,c)>0&&(c=g)}return c}e.findFirstMaxBy=P;function I(v,E){if(v.length===0)return;let c=v[0];for(let d=1;d<v.length;d++){const g=v[d];E(g,c)>=0&&(c=g)}return c}e.findLastMaxBy=I;function S(v,E){return P(v,(c,d)=>-E(c,d))}e.findFirstMinBy=S;function u(v,E){if(v.length===0)return-1;let c=0;for(let d=1;d<v.length;d++){const g=v[d];E(g,v[c])>0&&(c=d)}return c}e.findMaxIdxBy=u;function f(v,E){for(const c of v){const d=E(c);if(d!==void 0)return d}}e.mapFindFirst=f}),define(le[126],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function L(_,R){const b=Object.create(null);for(const m of _){const P=R(m);let I=b[P];I||(I=b[P]=[]),I.push(m)}return b}e.groupBy=L;function O(_,R){const b=[],m=[];for(const P of _)R.has(P)||b.push(P);for(const P of R)_.has(P)||m.push(P);return{removed:b,added:m}}e.diffSets=O;function A(_,R){const b=[],m=[];for(const[P,I]of _)R.has(P)||b.push(I);for(const[P,I]of R)_.has(P)||m.push(I);return{removed:b,added:m}}e.diffMaps=A;function T(_,R){const b=new Set;for(const m of R)_.has(m)&&b.add(m);return b}e.intersection=T}),define(le[85],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(_){return(R,b,m)=>{let P=null,I=null;if(typeof m.value=="function"?(P="value",I=m.value):typeof m.get=="function"&&(P="get",I=m.get),!I)throw new Error("not supported");m[P]=_(I,b)}}function O(_,R,b){let m=null,P=null;if(typeof b.value=="function"?(m="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(m="get",P=b.get),!P)throw new Error("not supported");const I=`$memoize$${R}`;b[m]=function(...S){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,S)}),this[I]}}e.memoize=O;function A(_,R,b){return L((m,P)=>{const I=`$debounce$${P}`,S=`$debounce$result$${P}`;return function(...u){this[S]||(this[S]=b?b():void 0),clearTimeout(this[I]),R&&(this[S]=R(this[S],...u),u=[this[S]]),this[I]=setTimeout(()=>{m.apply(this,u),this[S]=b?b():void 0},_)}})}e.debounce=A;function T(_,R,b){return L((m,P)=>{const I=`$throttle$timer$${P}`,S=`$throttle$result$${P}`,u=`$throttle$lastRun$${P}`,f=`$throttle$pending$${P}`;return function(...v){if(this[S]||(this[S]=b?b():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),R&&(this[S]=R(this[S],...v)),this[f])return;const E=this[u]+_;E<=Date.now()?(this[u]=Date.now(),m.apply(this,[this[S]]),this[S]=b?b():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[u]=Date.now(),m.apply(this,[this[S]]),this[S]=b?b():void 0},E-Date.now()))}})}e.throttle=T}),define(le[7],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=L,e.errorHandler=new L;function O(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=O;function A(w){if(!w||typeof w!="object")return!1;const i=w;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=A;function T(w){m(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=T;function _(w){m(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=_;function R(w){if(w instanceof Error){const{name:i,message:o}=w,n=w.stacktrace||w.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:g.isErrorNoTelemetry(w)}}return w}e.transformErrorForSerialization=R;const b="Canceled";function m(w){return w instanceof P?!0:w instanceof Error&&w.name===b&&w.message===b}e.isCancellationError=m;class P extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=P;function I(){const w=new Error(b);return w.name=w.message,w}e.canceled=I;function S(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=S;function u(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=u;class f extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=f;function v(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=v;class E extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=E;class c extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=c;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const o=new g;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.BugIndicatingError=l}),define(le[17],ue([0,1,7,125]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A($,J=0){return $[$.length-(1+J)]}e.tail=A;function T($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=T;function _($,J,Z=(ie,H)=>ie===H){if($===J)return!0;if(!$||!J||$.length!==J.length)return!1;for(let ie=0,H=$.length;ie<H;ie++)if(!Z($[ie],J[ie]))return!1;return!0}e.equals=_;function R($,J){const Z=$.length-1;J<Z&&($[J]=$[Z]),$.pop()}e.removeFastWithoutKeepingOrder=R;function b($,J,Z){return m($.length,ie=>Z($[ie],J))}e.binarySearch=b;function m($,J){let Z=0,ie=$-1;for(;Z<=ie;){const H=(Z+ie)/2|0,ne=J(H);if(ne<0)Z=H+1;else if(ne>0)ie=H-1;else return H}return-(Z+1)}e.binarySearch2=m;function P($,J,Z){if($=$|0,$>=J.length)throw new TypeError("invalid index");const ie=J[Math.floor(J.length*Math.random())],H=[],ne=[],ce=[];for(const de of J){const fe=Z(de,ie);fe<0?H.push(de):fe>0?ne.push(de):ce.push(de)}return $<H.length?P($,H,Z):$<H.length+ce.length?ce[0]:P($-(H.length+ce.length),ne,Z)}e.quickSelect=P;function I($,J){const Z=[];let ie;for(const H of $.slice(0).sort(J))!ie||J(ie[0],H)!==0?(ie=[H],Z.push(ie)):ie.push(H);return Z}e.groupBy=I;function*S($,J){let Z,ie;for(const H of $)ie!==void 0&&J(ie,H)?Z.push(H):(Z&&(yield Z),Z=[H]),ie=H;Z&&(yield Z)}e.groupAdjacentBy=S;function u($,J){for(let Z=0;Z<=$.length;Z++)J(Z===0?void 0:$[Z-1],Z===$.length?void 0:$[Z])}e.forEachAdjacent=u;function f($,J){for(let Z=0;Z<$.length;Z++)J(Z===0?void 0:$[Z-1],$[Z],Z+1===$.length?void 0:$[Z+1])}e.forEachWithNeighbors=f;function v($,J,Z){const ie=[];function H(de,fe,Se){if(fe===0&&Se.length===0)return;const Ce=ie[ie.length-1];Ce&&Ce.start+Ce.deleteCount===de?(Ce.deleteCount+=fe,Ce.toInsert.push(...Se)):ie.push({start:de,deleteCount:fe,toInsert:Se})}let ne=0,ce=0;for(;;){if(ne===$.length){H(ne,0,J.slice(ce));break}if(ce===J.length){H(ne,$.length-ne,[]);break}const de=$[ne],fe=J[ce],Se=Z(de,fe);Se===0?(ne+=1,ce+=1):Se<0?(H(ne,1,[]),ne+=1):Se>0&&(H(ne,0,[fe]),ce+=1)}return ie}e.sortedDiff=v;function E($,J,Z){const ie=v($,J,Z),H=[],ne=[];for(const ce of ie)H.push(...$.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:H,added:ne}}e.delta=E;function c($,J,Z){if(Z===0)return[];const ie=$.slice(0,Z).sort(J);return g($,J,ie,Z,$.length),ie}e.top=c;function d($,J,Z,ie,H){return Z===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const de=$.length,fe=$.slice(0,Z).sort(J);for(let Se=Z,Ce=Math.min(Z+ie,de);Se<de;Se=Ce,Ce=Math.min(Ce+ie,de)){if(Se>Z&&await new Promise(Re=>setTimeout(Re)),H&&H.isCancellationRequested)throw new L.CancellationError;g($,J,fe,Se,Ce)}return fe})().then(ne,ce)})}e.topAsync=d;function g($,J,Z,ie,H){for(const ne=Z.length;ie<H;ie++){const ce=$[ie];if(J(ce,Z[ne-1])<0){Z.pop();const de=(0,O.findFirstIdxMonotonousOrArrLen)(Z,fe=>J(ce,fe)<0);Z.splice(de,0,ce)}}}function l($){return $.filter(J=>!!J)}e.coalesce=l;function w($){let J=0;for(let Z=0;Z<$.length;Z++)$[Z]&&($[J]=$[Z],J+=1);$.length=J}e.coalesceInPlace=w;function i($,J,Z){$.splice(Z,0,$.splice(J,1)[0])}e.move=i;function o($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=o;function n($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=n;function s($,J=Z=>Z){const Z=new Set;return $.filter(ie=>{const H=J(ie);return Z.has(H)?!1:(Z.add(H),!0)})}e.distinct=s;function t($){const J=new Set;return Z=>{const ie=$(Z);return J.has(ie)?!1:(J.add(ie),!0)}}e.uniqueFilter=t;function r($,J){return $.length>0?$[0]:J}e.firstOrDefault=r;function a($,J){return $.length>0?$[$.length-1]:J}e.lastOrDefault=a;function C($,J,Z=(ie,H)=>ie===H){let ie=0;for(let H=0,ne=Math.min($.length,J.length);H<ne&&Z($[H],J[H]);H++)ie++;return ie}e.commonPrefixLength=C;function p($){return[].concat(...$)}e.flatten=p;function h($,J){let Z=typeof J=="number"?$:0;typeof J=="number"?Z=$:(Z=0,J=$);const ie=[];if(Z<=J)for(let H=Z;H<J;H++)ie.push(H);else for(let H=Z;H>J;H--)ie.push(H);return ie}e.range=h;function y($,J,Z){return $.reduce((ie,H)=>(ie[J(H)]=Z?Z(H):H,ie),Object.create(null))}e.index=y;function D($,J){return $.push(J),()=>U($,J)}e.insert=D;function U($,J){const Z=$.indexOf(J);if(Z>-1)return $.splice(Z,1),J}e.remove=U;function M($,J,Z){const ie=$.slice(0,J),H=$.slice(J);return ie.concat(Z,H)}e.arrayInsert=M;function F($,J){let Z;if(typeof J=="number"){let ie=J;Z=()=>{const H=Math.sin(ie++)*179426549;return H-Math.floor(H)}}else Z=Math.random;for(let ie=$.length-1;ie>0;ie-=1){const H=Math.floor(Z()*(ie+1)),ne=$[ie];$[ie]=$[H],$[H]=ne}}e.shuffle=F;function z($,J){const Z=$.indexOf(J);Z>-1&&($.splice(Z,1),$.unshift(J))}e.pushToStart=z;function X($,J){const Z=$.indexOf(J);Z>-1&&($.splice(Z,1),$.push(J))}e.pushToEnd=X;function K($,J){for(const Z of J)$.push(Z)}e.pushMany=K;function Q($,J){return Array.isArray($)?$.map(J):J($)}e.mapArrayOrNot=Q;function V($){return Array.isArray($)?$:[$]}e.asArray=V;function Y($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=Y;function x($,J,Z){const ie=te($,J),H=$.length,ne=Z.length;$.length=H+ne;for(let ce=H-1;ce>=ie;ce--)$[ce+ne]=$[ce];for(let ce=0;ce<ne;ce++)$[ce+ie]=Z[ce]}e.insertInto=x;function q($,J,Z,ie){const H=te($,J);let ne=$.splice(H,Z);return ne===void 0&&(ne=[]),x($,H,ie),ne}e.splice=q;function te($,J){return J<0?Math.max(J+$.length,0):Math.min(J,$.length)}var oe;(function($){function J(ne){return ne<0}$.isLessThan=J;function Z(ne){return ne<=0}$.isLessThanOrEqual=Z;function ie(ne){return ne>0}$.isGreaterThan=ie;function H(ne){return ne===0}$.isNeitherLessOrGreaterThan=H,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function ee($,J){return(Z,ie)=>J($(Z),$(ie))}e.compareBy=ee;function ae(...$){return(J,Z)=>{for(const ie of $){const H=ie(J,Z);if(!oe.isNeitherLessOrGreaterThan(H))return H}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const B=($,J)=>$-J;e.numberComparator=B;const W=($,J)=>(0,e.numberComparator)($?1:0,J?1:0);e.booleanComparator=W;function k($){return(J,Z)=>-$(J,Z)}e.reverseOrder=k;class N{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let Z=this.firstIdx;for(;Z<this.items.length&&J(this.items[Z]);)Z++;const ie=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ie}takeFromEndWhile(J){let Z=this.lastIdx;for(;Z>=0&&J(this.items[Z]);)Z--;const ie=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ie}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const J=this.items[this.firstIdx];return this.firstIdx++,J}removeLast(){const J=this.items[this.lastIdx];return this.lastIdx--,J}takeCount(J){const Z=this.items.slice(this.firstIdx,this.firstIdx+J);return this.firstIdx+=J,Z}}e.ArrayQueue=N;class j{static{this.empty=new j(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(Z=>(J(Z),!0))}toArray(){const J=[];return this.iterate(Z=>(J.push(Z),!0)),J}filter(J){return new j(Z=>this.iterate(ie=>J(ie)?Z(ie):!0))}map(J){return new j(Z=>this.iterate(ie=>Z(J(ie))))}some(J){let Z=!1;return this.iterate(ie=>(Z=J(ie),!Z)),Z}findFirst(J){let Z;return this.iterate(ie=>J(ie)?(Z=ie,!1):!0),Z}findLast(J){let Z;return this.iterate(ie=>(J(ie)&&(Z=ie),!0)),Z}findLastMaxBy(J){let Z,ie=!0;return this.iterate(H=>((ie||oe.isGreaterThan(J(H,Z)))&&(ie=!1,Z=H),!0)),Z}}e.CallbackIterable=j}),define(le[127],ue([0,1,7]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function O(m,P){if(!m)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=O;function A(m,P="Unreachable"){throw new Error(P)}e.assertNever=A;function T(m){if(!m)throw new L.BugIndicatingError("Assertion Failed")}e.assert=T;function _(m){m||(0,L.onUnexpectedError)(new L.BugIndicatingError("Soft Assertion Failed"))}e.softAssert=_;function R(m){if(!m()){debugger;m(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function b(m,P){let I=0;for(;I<m.length-1;){const S=m[I],u=m[I+1];if(!P(S,u))return!1;I++}return!0}e.checkAdjacentItems=b}),define(le[86],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function L(O,A){const T=this;let _=!1,R;return function(){if(_)return R;if(_=!0,A)try{R=O.apply(T,arguments)}finally{A()}else R=O.apply(T,arguments);return R}}e.createSingleCallFunction=L}),define(le[61],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(O){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}O.is=A;const T=Object.freeze([]);function _(){return T}O.empty=_;function*R(i){yield i}O.single=R;function b(i){return A(i)?i:R(i)}O.wrap=b;function m(i){return i||T}O.from=m;function*P(i){for(let o=i.length-1;o>=0;o--)yield i[o]}O.reverse=P;function I(i){return!i||i[Symbol.iterator]().next().done===!0}O.isEmpty=I;function S(i){return i[Symbol.iterator]().next().value}O.first=S;function u(i,o){for(const n of i)if(o(n))return!0;return!1}O.some=u;function f(i,o){for(const n of i)if(o(n))return n}O.find=f;function*v(i,o){for(const n of i)o(n)&&(yield n)}O.filter=v;function*E(i,o){let n=0;for(const s of i)yield o(s,n++)}O.map=E;function*c(...i){for(const o of i)yield*o}O.concat=c;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}O.reduce=d;function*g(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}O.slice=g;function l(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,O.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}O.consume=l;async function w(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}O.asyncToArray=w})(L||(e.Iterable=L={}))}),define(le[34],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function _(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,C=0;function p(z){let X=0,K=0;for(;X<z;){const Q=i.charCodeAt(n);if(Q>=48&&Q<=57)K=K*16+Q-48;else if(Q>=65&&Q<=70)K=K*16+Q-65+10;else if(Q>=97&&Q<=102)K=K*16+Q-97+10;else break;n++,X++}return X<z&&(K=-1),K}function h(z){n=z,t="",r=0,a=16,C=0}function y(){const z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return C=3,i.substring(z,n);let X=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;X=n}else C=3;return i.substring(z,X)}function D(){let z="",X=n;for(;;){if(n>=s){z+=i.substring(X,n),C=2;break}const K=i.charCodeAt(n);if(K===34){z+=i.substring(X,n),n++;break}if(K===92){if(z+=i.substring(X,n),n++,n>=s){C=2;break}switch(i.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const V=p(4);V>=0?z+=String.fromCharCode(V):C=4;break}default:C=5}X=n;continue}if(K>=0&&K<=31)if(b(K)){z+=i.substring(X,n),C=2;break}else C=6;n++}return z}function U(){if(t="",C=0,r=n,n>=s)return r=s,a=17;let z=i.charCodeAt(n);if(R(z)){do n++,t+=String.fromCharCode(z),z=i.charCodeAt(n);while(R(z));return a=15}if(b(z))return n++,t+=String.fromCharCode(z),z===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(z){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=D(),a=10;case 47:{const X=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!b(i.charCodeAt(n));)n++;return t=i.substring(X,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const K=s-1;let Q=!1;for(;n<K;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,C=1),t=i.substring(X,n),a=13}return t+=String.fromCharCode(z),n++,a=16}case 45:if(t+=String.fromCharCode(z),n++,n===s||!m(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=y(),a=11;default:for(;n<s&&M(z);)n++,z=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(z),n++,a=16}}function M(z){if(R(z)||b(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=U();while(z>=12&&z<=15);return z}return{setPosition:h,getPosition:()=>n,scan:o?F:U,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>C}}e.createScanner=_;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function b(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function I(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function C(p,h,y,D){r.value=p,r.offset=h,r.length=y,r.type=D,r.colonOffset=void 0,t=r}try{g(i,{onObjectBegin:(p,h)=>{if(o<=p)throw s;t=void 0,a=o>p,n.push("")},onObjectProperty:(p,h,y)=>{if(o<h||(C(p,h,y,"property"),n[n.length-1]=p,o<=h+y))throw s},onObjectEnd:(p,h)=>{if(o<=p)throw s;t=void 0,n.pop()},onArrayBegin:(p,h)=>{if(o<=p)throw s;t=void 0,n.push(0)},onArrayEnd:(p,h)=>{if(o<=p)throw s;t=void 0,n.pop()},onLiteralValue:(p,h,y)=>{if(o<h||(C(p,h,y,w(p)),o<=h+y))throw s},onSeparator:(p,h,y)=>{if(o<=h)throw s;if(p===":"&&t&&t.type==="property")t.colonOffset=h,a=!1,t=void 0;else if(p===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(p){if(p!==s)throw p}return{path:n,previousNode:t,isAtPropertyKey:a,matches:p=>{let h=0;for(let y=0;h<p.length&&y<n.length;y++)if(p[h]===n[y]||p[h]==="*")h++;else if(p[h]!=="**")return!1;return h===p.length}}}e.getLocation=I;function S(i,o=[],n=T.DEFAULT){let s=null,t=[];const r=[];function a(p){Array.isArray(t)?t.push(p):s!==null&&(t[s]=p)}return g(i,{onObjectBegin:()=>{const p={};a(p),r.push(t),t=p,s=null},onObjectProperty:p=>{s=p},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const p=[];a(p),r.push(t),t=p,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(p,h,y)=>{o.push({error:p,offset:h,length:y})}},n),t[0]}e.parse=S;function u(i,o=[],n=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(p){s.type==="property"&&(s.length=p-s.offset,s=s.parent)}function r(p){return s.children.push(p),p}g(i,{onObjectBegin:p=>{s=r({type:"object",offset:p,length:-1,parent:s,children:[]})},onObjectProperty:(p,h,y)=>{s=r({type:"property",offset:h,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:p,offset:h,length:y,parent:s})},onObjectEnd:(p,h)=>{s.length=p+h-s.offset,s=s.parent,t(p+h)},onArrayBegin:(p,h)=>{s=r({type:"array",offset:p,length:-1,parent:s,children:[]})},onArrayEnd:(p,h)=>{s.length=p+h-s.offset,s=s.parent,t(p+h)},onLiteralValue:(p,h,y)=>{r({type:w(p),offset:h,length:y,parent:s,value:p}),t(h+y)},onSeparator:(p,h,y)=>{s.type==="property"&&(p===":"?s.colonOffset=h:p===","&&t(h))},onError:(p,h,y)=>{o.push({error:p,offset:h,length:y})}},n);const C=s.children[0];return C&&delete C.parent,C}e.parseTree=u;function f(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.findNodeAtLocation=f;function v(i){if(!i.parent||!i.parent.children)return[];const o=v(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=v;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=E(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function c(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=c;function d(i,o,n=!1){if(c(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}e.findNodeAtOffset=d;function g(i,o,n=T.DEFAULT){const s=_(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),C=r(o.onObjectProperty),p=t(o.onObjectEnd),h=t(o.onArrayBegin),y=t(o.onArrayEnd),D=r(o.onLiteralValue),U=r(o.onSeparator),M=t(o.onComment),F=r(o.onError),z=n&&n.disallowComments,X=n&&n.allowTrailingComma;function K(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:z||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(ee){case 12:case 13:z?Q(10):M();break;case 16:Q(1);break;case 15:case 14:break;default:return ee}}}function Q(ee,ae=[],B=[]){if(F(ee),ae.length+B.length>0){let W=s.getToken();for(;W!==17;){if(ae.indexOf(W)!==-1){K();break}else if(B.indexOf(W)!==-1)break;W=K()}}}function V(ee){const ae=s.getTokenValue();return ee?D(ae):C(ae),K(),!0}function Y(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(Q(2),ee=0)}catch{Q(2)}D(ee);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return K(),!0}function x(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(U(":"),K(),oe()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function q(){a(),K();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||Q(4,[],[]),U(","),K(),s.getToken()===2&&X)break}else ee&&Q(6,[],[]);x()||Q(4,[],[2,5]),ee=!0}return p(),s.getToken()!==2?Q(7,[2],[]):K(),!0}function te(){h(),K();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||Q(4,[],[]),U(","),K(),s.getToken()===4&&X)break}else ee&&Q(6,[],[]);oe()||Q(4,[],[4,5]),ee=!0}return y(),s.getToken()!==4?Q(8,[4],[]):K(),!0}function oe(){switch(s.getToken()){case 3:return te();case 1:return q();case 10:return V(!0);default:return Y()}}return K(),s.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):oe()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=g;function l(i,o){const n=_(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.stripComments=l;function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(le[42],ue([0,1,34]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(m,P,I){let S,u,f,v,E;if(P){for(v=P.offset,E=v+P.length,f=v;f>0&&!b(m,f-1);)f--;let a=E;for(;a<m.length&&!b(m,a);)a++;u=m.substring(f,a),S=_(u,I)}else u=m,S=0,f=0,v=0,E=m.length;const c=R(I,m);let d=!1,g=0,l;I.insertSpaces?l=T(" ",I.tabSize||4):l="	";const w=(0,L.createScanner)(u,!1);let i=!1;function o(){return c+T(l,S+g)}function n(){let a=w.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=w.scan();return i=a===16||w.getTokenError()!==0,a}const s=[];function t(a,C,p){!i&&C<E&&p>v&&m.substring(C,p)!==a&&s.push({offset:C,length:p-C,content:a})}let r=n();if(r!==17){const a=w.getTokenOffset()+f,C=T(l,S);t(C,f,a)}for(;r!==17;){let a=w.getTokenOffset()+w.getTokenLength()+f,C=n(),p="";for(;!d&&(C===12||C===13);){const y=w.getTokenOffset()+f;t(" ",a,y),a=w.getTokenOffset()+w.getTokenLength()+f,p=C===12?o():"",C=n()}if(C===2)r!==1&&(g--,p=o());else if(C===4)r!==3&&(g--,p=o());else{switch(r){case 3:case 1:g++,p=o();break;case 5:case 12:p=o();break;case 13:d?p=o():p=" ";break;case 6:p=" ";break;case 10:if(C===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?p=" ":C!==5&&C!==17&&(i=!0);break;case 16:i=!0;break}d&&(C===12||C===13)&&(p=o())}const h=w.getTokenOffset()+f;t(p,a,h),r=C}return s}e.format=O;function A(m,P){const I=JSON.stringify(m,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?I.replace(/\r\n|\r|\n/g,P.eol):I}e.toFormattedString=A;function T(m,P){let I="";for(let S=0;S<P;S++)I+=m;return I}function _(m,P){let I=0,S=0;const u=P.tabSize||4;for(;I<m.length;){const f=m.charAt(I);if(f===" ")S++;else if(f==="	")S+=u;else break;I++}return Math.floor(S/u)}function R(m,P){for(let I=0;I<P.length;I++){const S=P.charAt(I);if(S==="\r")return I+1<P.length&&P.charAt(I+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=R;function b(m,P){return`\r
`.indexOf(m.charAt(P))!==-1}e.isEOL=b}),define(le[62],ue([0,1,34,42]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(m,P,I){return T(m,P,void 0,I)}e.removeProperty=A;function T(m,P,I,S,u){const f=P.slice(),v=[],E=(0,L.parseTree)(m,v);let c,d;for(;f.length>0&&(d=f.pop(),c=(0,L.findNodeAtLocation)(E,f),c===void 0&&I!==void 0);)typeof d=="string"?I={[d]:I}:I=[I];if(c)if(c.type==="object"&&typeof d=="string"&&Array.isArray(c.children)){const g=(0,L.findNodeAtLocation)(c,[d]);if(g!==void 0)if(I===void 0){if(!g.parent)throw new Error("Malformed AST");const l=c.children.indexOf(g.parent);let w,i=g.parent.offset+g.parent.length;if(l>0){const o=c.children[l-1];w=o.offset+o.length}else w=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return _(m,{offset:w,length:i-w,content:""},S)}else return _(m,{offset:g.offset,length:g.length,content:JSON.stringify(I)},S);else{if(I===void 0)return[];const l=`${JSON.stringify(d)}: ${JSON.stringify(I)}`,w=u?u(c.children.map(o=>o.children[0].value)):c.children.length;let i;if(w>0){const o=c.children[w-1];i={offset:o.offset+o.length,length:0,content:","+l}}else c.children.length===0?i={offset:c.offset+1,length:0,content:l}:i={offset:c.offset+1,length:0,content:l+","};return _(m,i,S)}}else if(c.type==="array"&&typeof d=="number"&&Array.isArray(c.children))if(I!==void 0){const g=`${JSON.stringify(I)}`;let l;if(c.children.length===0||d===0)l={offset:c.offset+1,length:0,content:c.children.length===0?g:g+","};else{const w=d===-1||d>c.children.length?c.children.length:d,i=c.children[w-1];l={offset:i.offset+i.length,length:0,content:","+g}}return _(m,l,S)}else{const g=d,l=c.children[g];let w;if(c.children.length===1)w={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===g){const i=c.children[g-1],o=i.offset+i.length,n=c.offset+c.length;w={offset:o,length:n-2-o,content:""}}else w={offset:l.offset,length:c.children[g+1].offset-l.offset,content:""};return _(m,w,S)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${c.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return _(m,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(I)},S)}}e.setProperty=T;function _(m,P,I){let S=R(m,P),u=P.offset,f=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;u>0&&!(0,O.isEOL)(S,u-1);)u--;for(;f<S.length&&!(0,O.isEOL)(S,f);)f++}const v=(0,O.format)(S,{offset:u,length:f-u},I);for(let c=v.length-1;c>=0;c--){const d=v[c];S=R(S,d),u=Math.min(u,d.offset),f=Math.max(f,d.offset+d.length),f+=d.content.length-d.length}const E=m.length-(S.length-f)-u;return[{offset:u,length:E,content:S.substring(u,f)}]}e.withFormatting=_;function R(m,P){return m.substring(0,P.offset)+P.content+m.substring(P.offset+P.length)}e.applyEdit=R;function b(m,P){const I=P.slice(0).sort((u,f)=>{const v=u.offset-f.offset;return v===0?u.length-f.length:v});let S=m.length;for(let u=I.length-1;u>=0;u--){const f=I[u];if(f.offset+f.length<=S)m=R(m,f);else throw new Error("Overlapping edit");S=f.offset}return m}e.applyEdits=b}),define(le[53],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(A){this.executor=A,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=L}),define(le[87],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{static{this.Undefined=new L(void 0)}constructor(T){this.element=T,this.next=L.Undefined,this.prev=L.Undefined}}class O{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let T=this._first;for(;T!==L.Undefined;){const _=T.next;T.prev=L.Undefined,T.next=L.Undefined,T=_}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,_){const R=new L(T);if(this._first===L.Undefined)this._first=R,this._last=R;else if(_){const m=this._last;this._last=R,R.prev=m,m.next=R}else{const m=this._first;this._first=R,R.next=m,m.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==L.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==L.Undefined&&T.next!==L.Undefined){const _=T.prev;_.next=T.next,T.next.prev=_}else T.prev===L.Undefined&&T.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):T.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):T.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==L.Undefined;)yield T.element,T=T.next}}e.LinkedList=O}),define(le[35],ue([0,1]),function(se,e){"use strict";var L,O,A;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(g,l,w){let i=g.get(l);return i===void 0&&(i=w,g.set(l,i)),i}e.getOrSet=T;function _(g){const l=[];return g.forEach((w,i)=>{l.push(`${i} => ${w}`)}),`Map(${g.size}) {${l.join(", ")}}`}e.mapToString=_;function R(g){const l=[];return g.forEach(w=>{l.push(w)}),`Set(${g.size}) {${l.join(", ")}}`}e.setToString=R;class b{constructor(l,w){this.uri=l,this.value=w}}function m(g){return Array.isArray(g)}class P{static{this.defaultToKey=l=>l.toString()}constructor(l,w){if(this[L]="ResourceMap",l instanceof P)this.map=new Map(l.map),this.toKey=w??P.defaultToKey;else if(m(l)){this.map=new Map,this.toKey=w??P.defaultToKey;for(const[i,o]of l)this.set(i,o)}else this.map=new Map,this.toKey=l??P.defaultToKey}set(l,w){return this.map.set(this.toKey(l),new b(l,w)),this}get(l){return this.map.get(this.toKey(l))?.value}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,w){typeof w<"u"&&(l=l.bind(w));for(const[i,o]of this.map)l(o.value,o.uri,this)}*values(){for(const l of this.map.values())yield l.value}*keys(){for(const l of this.map.values())yield l.uri}*entries(){for(const l of this.map.values())yield[l.uri,l.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.map)yield[l.uri,l.value]}}e.ResourceMap=P;class I{constructor(l,w){this[O]="ResourceSet",!l||typeof l=="function"?this._map=new P(l):(this._map=new P(w),l.forEach(this.add,this))}get size(){return this._map.size}add(l){return this._map.set(l,l),this}clear(){this._map.clear()}delete(l){return this._map.delete(l)}forEach(l,w){this._map.forEach((i,o)=>l.call(w,o,o,this))}has(l){return this._map.has(l)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var S;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(S||(e.Touch=S={}));class u{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(l){return this._map.has(l)}get(l,w=0){const i=this._map.get(l);if(i)return w!==0&&this.touch(i,w),i.value}set(l,w,i=0){let o=this._map.get(l);if(o)o.value=w,i!==0&&this.touch(o,i);else{switch(o={key:l,value:w,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(l,o),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const w=this._map.get(l);if(w)return this._map.delete(l),this.removeItem(w),this._size--,w.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}forEach(l,w){const i=this._state;let o=this._head;for(;o;){if(w?l.bind(w)(o.value,o.key,this):l(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const l=this,w=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(l._state!==w)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const l=this,w=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(l._state!==w)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const l=this,w=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(l._state!==w)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(l>=this.size)return;if(l===0){this.clear();return}let w=this._head,i=this.size;for(;w&&i>l;)this._map.delete(w.key),w=w.next,i--;this._head=w,this._size=i,w&&(w.previous=void 0),this._state++}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const w=l.next,i=l.previous;if(!w||!i)throw new Error("Invalid list");w.previous=i,i.next=w}l.next=void 0,l.previous=void 0,this._state++}touch(l,w){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(w!==1&&w!==2)){if(w===1){if(l===this._head)return;const i=l.next,o=l.previous;l===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(w===2){if(l===this._tail)return;const i=l.next,o=l.previous;l===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((w,i)=>{l.push([i,w])}),l}fromJSON(l){this.clear();for(const[w,i]of l)this.set(w,i)}}e.LinkedMap=u;class f extends u{constructor(l,w=1){super(),this._limit=l,this._ratio=Math.min(Math.max(0,w),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,w=2){return super.get(l,w)}peek(l){return super.get(l,0)}set(l,w){return super.set(l,w,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class v{constructor(){this.map=new Map}add(l){return this.map.set(l,(this.map.get(l)||0)+1),this}delete(l){let w=this.map.get(l)||0;return w===0?!1:(w--,w===0?this.map.delete(l):this.map.set(l,w),!0)}has(l){return this.map.has(l)}}e.CounterSet=v;class E{constructor(l){if(this._m1=new Map,this._m2=new Map,l)for(const[w,i]of l)this.set(w,i)}clear(){this._m1.clear(),this._m2.clear()}set(l,w){this._m1.set(l,w),this._m2.set(w,l)}get(l){return this._m1.get(l)}getKey(l){return this._m2.get(l)}delete(l){const w=this._m1.get(l);return w===void 0?!1:(this._m1.delete(l),this._m2.delete(w),!0)}forEach(l,w){this._m1.forEach((i,o)=>{l.call(w,i,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=E;class c{constructor(){this.map=new Map}add(l,w){let i=this.map.get(l);i||(i=new Set,this.map.set(l,i)),i.add(w)}delete(l,w){const i=this.map.get(l);i&&(i.delete(w),i.size===0&&this.map.delete(l))}forEach(l,w){const i=this.map.get(l);i&&i.forEach(w)}get(l){const w=this.map.get(l);return w||new Set}}e.SetMap=c;function d(g,l){if(g===l)return!0;if(g.size!==l.size)return!1;for(const[w,i]of g)if(!l.has(w)||l.get(w)!==i)return!1;for(const[w]of l)if(!g.has(w))return!1;return!0}e.mapsStrictEqualIgnoreOrder=d}),define(le[2],ue([0,1,17,126,35,86,61]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const R=!1;let b=null;class m{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(D){let U=this.livingDisposables.get(D);return U||(U={parent:null,source:null,isSingleton:!1,value:D,idx:m.idx++},this.livingDisposables.set(D,U)),U}trackDisposable(D){const U=this.getDisposableData(D);U.source||(U.source=new Error().stack)}setParent(D,U){const M=this.getDisposableData(D);M.parent=U}markAsDisposed(D){this.livingDisposables.delete(D)}markAsSingleton(D){this.getDisposableData(D).isSingleton=!0}getRootParent(D,U){const M=U.get(D);if(M)return M;const F=D.parent?this.getRootParent(this.getDisposableData(D.parent),U):D;return U.set(D,F),F}getTrackedDisposables(){const D=new Map;return[...this.livingDisposables.entries()].filter(([,M])=>M.source!==null&&!this.getRootParent(M,D).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(D=10,U){let M;if(U)M=U;else{const Q=new Map,V=[...this.livingDisposables.values()].filter(x=>x.source!==null&&!this.getRootParent(x,Q).isSingleton);if(V.length===0)return;const Y=new Set(V.map(x=>x.value));if(M=V.filter(x=>!(x.parent&&Y.has(x.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function F(Q){function V(x,q){for(;x.length>0&&q.some(te=>typeof te=="string"?te===x[0]:x[0].match(te));)x.shift()}const Y=Q.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return V(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const z=new A.SetMap;for(const Q of M){const V=F(Q);for(let Y=0;Y<=V.length;Y++)z.add(V.slice(0,Y).join(`
`),Q)}M.sort((0,L.compareBy)(Q=>Q.idx,L.numberComparator));let X="",K=0;for(const Q of M.slice(0,D)){K++;const V=F(Q),Y=[];for(let x=0;x<V.length;x++){let q=V[x];q=`(shared with ${z.get(V.slice(0,x+1).join(`
`)).size}/${M.length} leaks) at ${q}`;const oe=z.get(V.slice(0,x).join(`
`)),ee=(0,O.groupBy)([...oe].map(ae=>F(ae)[x]),ae=>ae);delete ee[V[x]];for(const[ae,B]of Object.entries(ee))Y.unshift(`    - stacktraces of ${B.length} other leaks continue with ${ae}`);Y.unshift(q)}X+=`


==================== Leaking disposable ${K}/${M.length}: ${Q.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return M.length>D&&(X+=`


... and ${M.length-D} more leaking disposables

`),{leaks:M,details:X}}}e.DisposableTracker=m;function P(y){b=y}if(e.setDisposableTracker=P,R){const y="__is_disposable_tracked__";P(new class{trackDisposable(D){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[y]||console.log(U)},3e3)}setParent(D,U){if(D&&D!==i.None)try{D[y]=!0}catch{}}markAsDisposed(D){if(D&&D!==i.None)try{D[y]=!0}catch{}}markAsSingleton(D){}})}function I(y){return b?.trackDisposable(y),y}e.trackDisposable=I;function S(y){b?.markAsDisposed(y)}e.markAsDisposed=S;function u(y,D){b?.setParent(y,D)}function f(y,D){if(b)for(const U of y)b.setParent(U,D)}function v(y){return b?.markAsSingleton(y),y}e.markAsSingleton=v;function E(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.isDisposable=E;function c(y){if(_.Iterable.is(y)){const D=[];for(const U of y)if(U)try{U.dispose()}catch(M){D.push(M)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.dispose=c;function d(y){for(const D of y)E(D)&&D.dispose();return[]}e.disposeIfDisposable=d;function g(...y){const D=l(()=>c(y));return f(y,D),D}e.combinedDisposable=g;function l(y){const D=I({dispose:(0,T.createSingleCallFunction)(()=>{S(D),y()})});return D}e.toDisposable=l;class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{c(this._toDispose)}finally{this._toDispose.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return u(D,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(D),D.dispose()}}deleteAndLeak(D){D&&this._toDispose.has(D)&&(this._toDispose.delete(D),u(D,null))}}e.DisposableStore=w;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new w,I(this),u(this._store,this)}dispose(){S(this),this._store.dispose()}_register(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(D)}}e.Disposable=i;class o{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(D){this._isDisposed||D===this._value||(this._value?.dispose(),D&&u(D,this),this._value=D)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const D=this._value;return this._value=void 0,D&&u(D,null),D}}e.MutableDisposable=o;class n{constructor(D){this._disposable=new o,this._isDisposed=!1,this._disposable.value=D}get value(){return this._disposable.value}set value(D){this._isDisposed||D===this._disposable.value||(this._disposable.value=D)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class s{constructor(D){this._disposable=D,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(D){let U=D;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,S(this))},this}}e.SafeDisposable=t;class r{constructor(){this.references=new Map}acquire(D,...U){let M=this.references.get(D);M||(M={counter:0,object:this.createReferencedObject(D,...U)},this.references.set(D,M));const{object:F}=M,z=(0,T.createSingleCallFunction)(()=>{--M.counter===0&&(this.destroyReferencedObject(D,M.object),this.references.delete(D))});return M.counter++,{object:F,dispose:z}}}e.ReferenceCollection=r;class a{constructor(D){this.referenceCollection=D}async acquire(D,...U){const M=this.referenceCollection.acquire(D,...U);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(F){throw M.dispose(),F}}}e.AsyncReferenceCollection=a;class C{constructor(D){this.object=D}dispose(){}}e.ImmortalReference=C;function p(y){const D=new w;try{y(D)}finally{D.dispose()}}e.disposeOnReturn=p;class h{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{c(this._store.values())}finally{this._store.clear()}}has(D){return this._store.has(D)}get size(){return this._store.size}get(D){return this._store.get(D)}set(D,U,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(D)?.dispose(),this._store.set(D,U)}deleteAndDispose(D){this._store.get(D)?.dispose(),this._store.delete(D)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=h}),define(le[88],ue([0,1,35]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new L.LRUCache(1e4);function A(m){return b(m,"NFC",O)}e.normalizeNFC=A;const T=new L.LRUCache(1e4);function _(m){return b(m,"NFD",T)}e.normalizeNFD=_;const R=/[^\u0000-\u0080]/;function b(m,P,I){if(!m)return m;const S=I.get(m);if(S)return S;let u;return R.test(m)?u=m.normalize(P):u=m,I.set(m,u),u}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(P){return _(P).replace(m,"")}}()}),function(){function se(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function _(b){T.push(b,Date.now())}function R(){const b=[];for(let m=0;m<T.length;m+=2)b.push({name:T[m],startTime:T[m+1]});return b}return{mark:_,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const _ of performance.getEntriesByType("mark"))T.push({name:_.name,startTime:Math.round(A+_.startTime)});return T}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function L(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=L(O))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var O in L)(typeof exports=="object"?exports:se)[O]=L[O]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function L(O){if(e[O])return e[O].exports;var A=e[O]={i:O,l:!1,exports:{}};return se[O].call(A.exports,A,A.exports,L),A.l=!0,A.exports}return L.m=se,L.c=e,L.d=function(O,A,T){L.o(O,A)||Object.defineProperty(O,A,{enumerable:!0,get:T})},L.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},L.t=function(O,A){if(1&A&&(O=L(O)),8&A||4&A&&typeof O=="object"&&O&&O.__esModule)return O;var T=Object.create(null);if(L.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:O}),2&A&&typeof O!="string")for(var _ in O)L.d(T,_,function(R){return O[R]}.bind(null,_));return T},L.n=function(O){var A=O&&O.__esModule?function(){return O.default}:function(){return O};return L.d(A,"a",A),A},L.o=function(O,A){return Object.prototype.hasOwnProperty.call(O,A)},L.p="",L(L.s=0)}([function(se,e,L){(function(O){var A;e=se.exports=B,A=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],m=0,P=m++;b[P]="0|[1-9]\\d*";var I=m++;b[I]="[0-9]+";var S=m++;b[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=m++;b[u]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var f=m++;b[f]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var v=m++;b[v]="(?:"+b[P]+"|"+b[S]+")";var E=m++;b[E]="(?:"+b[I]+"|"+b[S]+")";var c=m++;b[c]="(?:-("+b[v]+"(?:\\."+b[v]+")*))";var d=m++;b[d]="(?:-?("+b[E]+"(?:\\."+b[E]+")*))";var g=m++;b[g]="[0-9A-Za-z-]+";var l=m++;b[l]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var w=m++,i="v?"+b[u]+b[c]+"?"+b[l]+"?";b[w]="^"+i+"$";var o="[v=\\s]*"+b[f]+b[d]+"?"+b[l]+"?",n=m++;b[n]="^"+o+"$";var s=m++;b[s]="((?:<|>)?=?)";var t=m++;b[t]=b[I]+"|x|X|\\*";var r=m++;b[r]=b[P]+"|x|X|\\*";var a=m++;b[a]="[v=\\s]*("+b[r]+")(?:\\.("+b[r]+")(?:\\.("+b[r]+")(?:"+b[c]+")?"+b[l]+"?)?)?";var C=m++;b[C]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[d]+")?"+b[l]+"?)?)?";var p=m++;b[p]="^"+b[s]+"\\s*"+b[a]+"$";var h=m++;b[h]="^"+b[s]+"\\s*"+b[C]+"$";var y=m++;b[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=m++;b[D]="(?:~>?)";var U=m++;b[U]="(\\s*)"+b[D]+"\\s+",R[U]=new RegExp(b[U],"g");var M=m++;b[M]="^"+b[D]+b[a]+"$";var F=m++;b[F]="^"+b[D]+b[C]+"$";var z=m++;b[z]="(?:\\^)";var X=m++;b[X]="(\\s*)"+b[z]+"\\s+",R[X]=new RegExp(b[X],"g");var K=m++;b[K]="^"+b[z]+b[a]+"$";var Q=m++;b[Q]="^"+b[z]+b[C]+"$";var V=m++;b[V]="^"+b[s]+"\\s*("+o+")$|^$";var Y=m++;b[Y]="^"+b[s]+"\\s*("+i+")$|^$";var x=m++;b[x]="(\\s*)"+b[s]+"\\s*("+o+"|"+b[a]+")",R[x]=new RegExp(b[x],"g");var q=m++;b[q]="^\\s*("+b[a]+")\\s+-\\s+("+b[a]+")\\s*$";var te=m++;b[te]="^\\s*("+b[C]+")\\s+-\\s+("+b[C]+")\\s*$";var oe=m++;b[oe]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)A(ee,b[ee]),R[ee]||(R[ee]=new RegExp(b[ee]));function ae(he,me){if(he instanceof B)return he;if(typeof he!="string"||he.length>T||!(me?R[n]:R[w]).test(he))return null;try{return new B(he,me)}catch{return null}}function B(he,me){if(he instanceof B){if(he.loose===me)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof B))return new B(he,me);A("SemVer",he,me),this.loose=me;var pe=he.trim().match(me?R[n]:R[w]);if(!pe)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var De=+Pe;if(De>=0&&De<_)return De}return Pe}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=ae,e.valid=function(he,me){var pe=ae(he,me);return pe?pe.version:null},e.clean=function(he,me){var pe=ae(he.trim().replace(/^[=v]+/,""),me);return pe?pe.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(he){return A("SemVer.compare",this.version,this.loose,he),he instanceof B||(he=new B(he,this.loose)),this.compareMain(he)||this.comparePre(he)},B.prototype.compareMain=function(he){return he instanceof B||(he=new B(he,this.loose)),k(this.major,he.major)||k(this.minor,he.minor)||k(this.patch,he.patch)},B.prototype.comparePre=function(he){if(he instanceof B||(he=new B(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var me=0;do{var pe=this.prerelease[me],Pe=he.prerelease[me];if(A("prerelease compare",me,pe,Pe),pe===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(pe===void 0)return-1;if(pe!==Pe)return k(pe,Pe)}while(++me)},B.prototype.inc=function(he,me){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,me,pe,Pe){typeof pe=="string"&&(Pe=pe,pe=void 0);try{return new B(he,pe).inc(me,Pe).version}catch{return null}},e.diff=function(he,me){if(J(he,me))return null;var pe=ae(he),Pe=ae(me);if(pe.prerelease.length||Pe.prerelease.length){for(var De in pe)if((De==="major"||De==="minor"||De==="patch")&&pe[De]!==Pe[De])return"pre"+De;return"prerelease"}for(var De in pe)if((De==="major"||De==="minor"||De==="patch")&&pe[De]!==Pe[De])return De},e.compareIdentifiers=k;var W=/^[0-9]+$/;function k(he,me){var pe=W.test(he),Pe=W.test(me);return pe&&Pe&&(he=+he,me=+me),pe&&!Pe?-1:Pe&&!pe?1:he<me?-1:he>me?1:0}function N(he,me,pe){return new B(he,pe).compare(new B(me,pe))}function j(he,me,pe){return N(he,me,pe)>0}function $(he,me,pe){return N(he,me,pe)<0}function J(he,me,pe){return N(he,me,pe)===0}function Z(he,me,pe){return N(he,me,pe)!==0}function ie(he,me,pe){return N(he,me,pe)>=0}function H(he,me,pe){return N(he,me,pe)<=0}function ne(he,me,pe,Pe){var De;switch(me){case"===":typeof he=="object"&&(he=he.version),typeof pe=="object"&&(pe=pe.version),De=he===pe;break;case"!==":typeof he=="object"&&(he=he.version),typeof pe=="object"&&(pe=pe.version),De=he!==pe;break;case"":case"=":case"==":De=J(he,pe,Pe);break;case"!=":De=Z(he,pe,Pe);break;case">":De=j(he,pe,Pe);break;case">=":De=ie(he,pe,Pe);break;case"<":De=$(he,pe,Pe);break;case"<=":De=H(he,pe,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return De}function ce(he,me){if(he instanceof ce){if(he.loose===me)return he;he=he.value}if(!(this instanceof ce))return new ce(he,me);A("comparator",he,me),this.loose=me,this.parse(he),this.semver===de?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(he,me){return k(me,he)},e.major=function(he,me){return new B(he,me).major},e.minor=function(he,me){return new B(he,me).minor},e.patch=function(he,me){return new B(he,me).patch},e.compare=N,e.compareLoose=function(he,me){return N(he,me,!0)},e.rcompare=function(he,me,pe){return N(me,he,pe)},e.sort=function(he,me){return he.sort(function(pe,Pe){return e.compare(pe,Pe,me)})},e.rsort=function(he,me){return he.sort(function(pe,Pe){return e.rcompare(pe,Pe,me)})},e.gt=j,e.lt=$,e.eq=J,e.neq=Z,e.gte=ie,e.lte=H,e.cmp=ne,e.Comparator=ce;var de={};function fe(he,me){if(he instanceof fe)return he.loose===me?he:new fe(he.raw,me);if(he instanceof ce)return new fe(he.value,me);if(!(this instanceof fe))return new fe(he,me);if(this.loose=me,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function Se(he){return!he||he.toLowerCase()==="x"||he==="*"}function Ce(he,me,pe,Pe,De,Me,ke,ze,Ne,$e,We,Ae,re){return((me=Se(pe)?"":Se(Pe)?">="+pe+".0.0":Se(De)?">="+pe+"."+Pe+".0":">="+me)+" "+(ze=Se(Ne)?"":Se($e)?"<"+(+Ne+1)+".0.0":Se(We)?"<"+Ne+"."+(+$e+1)+".0":Ae?"<="+Ne+"."+$e+"."+We+"-"+Ae:"<="+ze)).trim()}function Re(he,me){for(var pe=0;pe<he.length;pe++)if(!he[pe].test(me))return!1;if(me.prerelease.length){for(pe=0;pe<he.length;pe++)if(A(he[pe].semver),he[pe].semver!==de&&he[pe].semver.prerelease.length>0){var Pe=he[pe].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function _e(he,me,pe){try{me=new fe(me,pe)}catch{return!1}return me.test(he)}function Ue(he,me,pe,Pe){var De,Me,ke,ze,Ne;switch(he=new B(he,Pe),me=new fe(me,Pe),pe){case">":De=j,Me=H,ke=$,ze=">",Ne=">=";break;case"<":De=$,Me=ie,ke=j,ze="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_e(he,me,Pe))return!1;for(var $e=0;$e<me.set.length;++$e){var We=me.set[$e],Ae=null,re=null;if(We.forEach(function(ge){ge.semver===de&&(ge=new ce(">=0.0.0")),Ae=Ae||ge,re=re||ge,De(ge.semver,Ae.semver,Pe)?Ae=ge:ke(ge.semver,re.semver,Pe)&&(re=ge)}),Ae.operator===ze||Ae.operator===Ne||(!re.operator||re.operator===ze)&&Me(he,re.semver)||re.operator===Ne&&ke(he,re.semver))return!1}return!0}ce.prototype.parse=function(he){var me=this.loose?R[V]:R[Y],pe=he.match(me);if(!pe)throw new TypeError("Invalid comparator: "+he);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new B(pe[2],this.loose):this.semver=de},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(he){return A("Comparator.test",he,this.loose),this.semver===de||(typeof he=="string"&&(he=new B(he,this.loose)),ne(he,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(he,me){if(!(he instanceof ce))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new fe(he.value,me),_e(this.value,pe,me);if(he.operator==="")return pe=new fe(this.value,me),_e(he.semver,pe,me);var Pe=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),Me=this.semver.version===he.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),ze=ne(this.semver,"<",he.semver,me)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Ne=ne(this.semver,">",he.semver,me)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Pe||De||Me&&ke||ze||Ne},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(he){var me=this.loose;he=he.trim(),A("range",he,me);var pe=me?R[te]:R[q];he=he.replace(pe,Ce),A("hyphen replace",he),he=he.replace(R[x],"$1$2$3"),A("comparator trim",he,R[x]),he=(he=(he=he.replace(R[U],"$1~")).replace(R[X],"$1^")).split(/\s+/).join(" ");var Pe=me?R[V]:R[Y],De=he.split(" ").map(function(Me){return function(ke,ze){return A("comp",ke),ke=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(We){return function(Ae,re){A("caret",Ae,re);var ge=re?R[Q]:R[K];return Ae.replace(ge,function(ye,ve,we,be,Le){var Oe;return A("caret",Ae,ye,ve,we,be,Le),Se(ve)?Oe="":Se(we)?Oe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Se(be)?Oe=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":Le?(A("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Oe=ve==="0"?we==="0"?">="+ve+"."+we+"."+be+Le+" <"+ve+"."+we+"."+(+be+1):">="+ve+"."+we+"."+be+Le+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+be+Le+" <"+(+ve+1)+".0.0"):(A("no pr"),Oe=ve==="0"?we==="0"?">="+ve+"."+we+"."+be+" <"+ve+"."+we+"."+(+be+1):">="+ve+"."+we+"."+be+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+be+" <"+(+ve+1)+".0.0"),A("caret return",Oe),Oe})}(We,$e)}).join(" ")}(ke,ze),A("caret",ke),ke=function(Ne,$e){return Ne.trim().split(/\s+/).map(function(We){return function(Ae,re){var ge=re?R[F]:R[M];return Ae.replace(ge,function(ye,ve,we,be,Le){var Oe;return A("tilde",Ae,ye,ve,we,be,Le),Se(ve)?Oe="":Se(we)?Oe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Se(be)?Oe=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":Le?(A("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Oe=">="+ve+"."+we+"."+be+Le+" <"+ve+"."+(+we+1)+".0"):Oe=">="+ve+"."+we+"."+be+" <"+ve+"."+(+we+1)+".0",A("tilde return",Oe),Oe})}(We,$e)}).join(" ")}(ke,ze),A("tildes",ke),ke=function(Ne,$e){return A("replaceXRanges",Ne,$e),Ne.split(/\s+/).map(function(We){return function(Ae,re){Ae=Ae.trim();var ge=re?R[h]:R[p];return Ae.replace(ge,function(ye,ve,we,be,Le,Oe){A("xRange",Ae,ye,ve,we,be,Le,Oe);var qe=Se(we),je=qe||Se(be),Fe=je||Se(Le);return ve==="="&&Fe&&(ve=""),qe?ye=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Fe?(je&&(be=0),Fe&&(Le=0),ve===">"?(ve=">=",je?(we=+we+1,be=0,Le=0):Fe&&(be=+be+1,Le=0)):ve==="<="&&(ve="<",je?we=+we+1:be=+be+1),ye=ve+we+"."+be+"."+Le):je?ye=">="+we+".0.0 <"+(+we+1)+".0.0":Fe&&(ye=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),A("xRange return",ye),ye})}(We,$e)}).join(" ")}(ke,ze),A("xrange",ke),ke=function(Ne,$e){return A("replaceStars",Ne,$e),Ne.trim().replace(R[oe],"")}(ke,ze),A("stars",ke),ke}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Me){return!!Me.match(Pe)})),De=De.map(function(Me){return new ce(Me,me)})},fe.prototype.intersects=function(he,me){if(!(he instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Pe){return he.set.some(function(De){return De.every(function(Me){return Pe.intersects(Me,me)})})})})},e.toComparators=function(he,me){return new fe(he,me).set.map(function(pe){return pe.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new B(he,this.loose));for(var me=0;me<this.set.length;me++)if(Re(this.set[me],he))return!0;return!1},e.satisfies=_e,e.maxSatisfying=function(he,me,pe){var Pe=null,De=null;try{var Me=new fe(me,pe)}catch{return null}return he.forEach(function(ke){Me.test(ke)&&(Pe&&De.compare(ke)!==-1||(De=new B(Pe=ke,pe)))}),Pe},e.minSatisfying=function(he,me,pe){var Pe=null,De=null;try{var Me=new fe(me,pe)}catch{return null}return he.forEach(function(ke){Me.test(ke)&&(Pe&&De.compare(ke)!==1||(De=new B(Pe=ke,pe)))}),Pe},e.validRange=function(he,me){try{return new fe(he,me).range||"*"}catch{return null}},e.ltr=function(he,me,pe){return Ue(he,me,"<",pe)},e.gtr=function(he,me,pe){return Ue(he,me,">",pe)},e.outside=Ue,e.prerelease=function(he,me){var pe=ae(he,me);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(he,me,pe){return he=new fe(he,pe),me=new fe(me,pe),he.intersects(me)},e.coerce=function(he){if(he instanceof B)return he;if(typeof he!="string")return null;var me=he.match(R[y]);return me==null?null:ae((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,L(1))},function(se,e){var L,O,A=se.exports={};function T(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function R(E){if(L===setTimeout)return setTimeout(E,0);if((L===T||!L)&&setTimeout)return L=setTimeout,setTimeout(E,0);try{return L(E,0)}catch{try{return L.call(null,E,0)}catch{return L.call(this,E,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:T}catch{L=T}try{O=typeof clearTimeout=="function"?clearTimeout:_}catch{O=_}})();var b,m=[],P=!1,I=-1;function S(){P&&b&&(P=!1,b.length?m=b.concat(m):I=-1,m.length&&u())}function u(){if(!P){var E=R(S);P=!0;for(var c=m.length;c;){for(b=m,m=[];++I<c;)b&&b[I].run();I=-1,c=m.length}b=null,P=!1,function(d){if(O===clearTimeout)return clearTimeout(d);if((O===_||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(d);try{O(d)}catch{try{return O.call(null,d)}catch{return O.call(this,d)}}}(E)}}function f(E,c){this.fun=E,this.array=c}function v(){}A.nextTick=function(E){var c=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)c[d-1]=arguments[d];m.push(new f(E,c)),m.length!==1||P||R(u)},f.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=v,A.addListener=v,A.once=v,A.off=v,A.removeListener=v,A.removeAllListeners=v,A.emit=v,A.prependListener=v,A.prependOnceListener=v,A.listeners=function(E){return[]},A.binding=function(E){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(E){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[128],ue([0,1]),function(se,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(R,b,m){this.level=R,this.key=b,this.value=m,this.forward=[]}}const A=void 0;class T{constructor(R,b=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new O(this._maxLevel,A,A)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,A,A),this._size=0}has(R){return!!T._search(this,R,this.comparator)}get(R){return T._search(this,R,this.comparator)?.value}set(R,b){return T._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=T._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let m=this._header.forward[0];for(;m;)R.call(b,m.value,m.key,this),m=m.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,m){let P=R._header;for(let I=R._level-1;I>=0;I--)for(;P.forward[I]&&m(P.forward[I].key,b)<0;)P=P.forward[I];if(P=P.forward[0],P&&m(P.key,b)===0)return P}static _insert(R,b,m,P){const I=[];let S=R._header;for(let u=R._level-1;u>=0;u--){for(;S.forward[u]&&P(S.forward[u].key,b)<0;)S=S.forward[u];I[u]=S}if(S=S.forward[0],S&&P(S.key,b)===0)return S.value=m,!1;{const u=T._randomLevel(R);if(u>R._level){for(let f=R._level;f<u;f++)I[f]=R._header;R._level=u}S=new O(u,b,m);for(let f=0;f<u;f++)S.forward[f]=I[f].forward[f],I[f].forward[f]=S;return!0}}static _randomLevel(R,b=.5){let m=1;for(;Math.random()<b&&m<R._maxLevel;)m+=1;return m}static _delete(R,b,m){const P=[];let I=R._header;for(let S=R._level-1;S>=0;S--){for(;I.forward[S]&&m(I.forward[S].key,b)<0;)I=I.forward[S];P[S]=I}if(I=I.forward[0],!I||m(I.key,b)!==0)return!1;for(let S=0;S<R._level&&P[S].forward[S]===I;S++)P[S].forward[S]=I.forward[S];for(;R._level>0&&R._header.forward[R._level-1]===A;)R._level-=1;return!0}}e.SkipList=T}),define(le[63],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(T){return new O(T)}constructor(T){this._now=L&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(le[3],ue([0,1,7,86,2,87,63]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,b=!1;var m;(function(p){p.None=()=>A.Disposable.None;function h(H){if(b){const{onDidAddListener:ne}=H,ce=f.create();let de=0;H.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function y(H,ne){return Y(H,()=>{},0,void 0,!0,void 0,ne)}p.defer=y;function D(H){return(ne,ce=null,de)=>{let fe=!1,Se;return Se=H(Ce=>{if(!fe)return Se?Se.dispose():fe=!0,ne.call(ce,Ce)},null,de),fe&&Se.dispose(),Se}}p.once=D;function U(H,ne,ce){return Q((de,fe=null,Se)=>H(Ce=>de.call(fe,ne(Ce)),null,Se),ce)}p.map=U;function M(H,ne,ce){return Q((de,fe=null,Se)=>H(Ce=>{ne(Ce),de.call(fe,Ce)},null,Se),ce)}p.forEach=M;function F(H,ne,ce){return Q((de,fe=null,Se)=>H(Ce=>ne(Ce)&&de.call(fe,Ce),null,Se),ce)}p.filter=F;function z(H){return H}p.signal=z;function X(...H){return(ne,ce=null,de)=>{const fe=(0,A.combinedDisposable)(...H.map(Se=>Se(Ce=>ne.call(ce,Ce))));return V(fe,de)}}p.any=X;function K(H,ne,ce,de){let fe=ce;return U(H,Se=>(fe=ne(fe,Se),fe),de)}p.reduce=K;function Q(H,ne){let ce;const de={onWillAddFirstListener(){ce=H(fe.fire,fe)},onDidRemoveLastListener(){ce?.dispose()}};ne||h(de);const fe=new g(de);return ne?.add(fe),fe.event}function V(H,ne){return ne instanceof Array?ne.push(H):ne&&ne.add(H),H}function Y(H,ne,ce=100,de=!1,fe=!1,Se,Ce){let Re,_e,Ue,he=0,me;const pe={leakWarningThreshold:Se,onWillAddFirstListener(){Re=H(De=>{he++,_e=ne(_e,De),de&&!Ue&&(Pe.fire(_e),_e=void 0),me=()=>{const Me=_e;_e=void 0,Ue=void 0,(!de||he>1)&&Pe.fire(Me),he=0},typeof ce=="number"?(clearTimeout(Ue),Ue=setTimeout(me,ce)):Ue===void 0&&(Ue=0,queueMicrotask(me))})},onWillRemoveListener(){fe&&he>0&&me?.()},onDidRemoveLastListener(){me=void 0,Re.dispose()}};Ce||h(pe);const Pe=new g(pe);return Ce?.add(Pe),Pe.event}p.debounce=Y;function x(H,ne=0,ce){return p.debounce(H,(de,fe)=>de?(de.push(fe),de):[fe],ne,void 0,!0,void 0,ce)}p.accumulate=x;function q(H,ne=(de,fe)=>de===fe,ce){let de=!0,fe;return F(H,Se=>{const Ce=de||!ne(Se,fe);return de=!1,fe=Se,Ce},ce)}p.latch=q;function te(H,ne,ce){return[p.filter(H,ne,ce),p.filter(H,de=>!ne(de),ce)]}p.split=te;function oe(H,ne=!1,ce=[],de){let fe=ce.slice(),Se=H(_e=>{fe?fe.push(_e):Re.fire(_e)});de&&de.add(Se);const Ce=()=>{fe?.forEach(_e=>Re.fire(_e)),fe=null},Re=new g({onWillAddFirstListener(){Se||(Se=H(_e=>Re.fire(_e)),de&&de.add(Se))},onDidAddFirstListener(){fe&&(ne?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return de&&de.add(Re),Re.event}p.buffer=oe;function ee(H,ne){return(de,fe,Se)=>{const Ce=ne(new B);return H(function(Re){const _e=Ce.evaluate(Re);_e!==ae&&de.call(fe,_e)},void 0,Se)}}p.chain=ee;const ae=Symbol("HaltChainable");class B{constructor(){this.steps=[]}map(ne){return this.steps.push(ne),this}forEach(ne){return this.steps.push(ce=>(ne(ce),ce)),this}filter(ne){return this.steps.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let de=ce;return this.steps.push(fe=>(de=ne(de,fe),de)),this}latch(ne=(ce,de)=>ce===de){let ce=!0,de;return this.steps.push(fe=>{const Se=ce||!ne(fe,de);return ce=!1,de=fe,Se?fe:ae}),this}evaluate(ne){for(const ce of this.steps)if(ne=ce(ne),ne===ae)break;return ne}}function W(H,ne,ce=de=>de){const de=(...Re)=>Ce.fire(ce(...Re)),fe=()=>H.on(ne,de),Se=()=>H.removeListener(ne,de),Ce=new g({onWillAddFirstListener:fe,onDidRemoveLastListener:Se});return Ce.event}p.fromNodeEventEmitter=W;function k(H,ne,ce=de=>de){const de=(...Re)=>Ce.fire(ce(...Re)),fe=()=>H.addEventListener(ne,de),Se=()=>H.removeEventListener(ne,de),Ce=new g({onWillAddFirstListener:fe,onDidRemoveLastListener:Se});return Ce.event}p.fromDOMEventEmitter=k;function N(H){return new Promise(ne=>D(H)(ne))}p.toPromise=N;function j(H){const ne=new g;return H.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}p.fromPromise=j;function $(H,ne,ce){return ne(ce),H(de=>ne(de))}p.runAndSubscribe=$;class J{constructor(ne,ce){this._observable=ne,this._counter=0,this._hasChanged=!1;const de={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||h(de),this.emitter=new g(de),ce&&ce.add(this.emitter)}beginUpdate(ne){this._counter++}handlePossibleChange(ne){}handleChange(ne,ce){this._hasChanged=!0}endUpdate(ne){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Z(H,ne){return new J(H,ne).emitter.event}p.fromObservable=Z;function ie(H){return(ne,ce,de)=>{let fe=0,Se=!1;const Ce={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(H.reportChanges(),Se&&(Se=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){Se=!0}};H.addObserver(Ce),H.reportChanges();const Re={dispose(){H.removeObserver(Ce)}};return de instanceof A.DisposableStore?de.add(Re):Array.isArray(de)&&de.push(Re),Re}}p.fromObservableLight=ie})(m||(e.Event=m={}));class P{static{this.all=new Set}static{this._idPool=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${P._idPool++}`,P.all.add(this)}start(h){this._stopWatch=new _.StopWatch,this.listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P;let I=-1;function S(p){const h=I;return I=p,{dispose(){I=h}}}e.setGlobalLeakWarningThreshold=S;class u{constructor(h,y=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=y,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(h,y){const D=this.threshold;if(D<=0||y<D)return;this._stacks||(this._stacks=new Map);const U=this._stacks.get(h.value)||0;if(this._stacks.set(h.value,U+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let M,F=0;for(const[z,X]of this._stacks)(!M||F<X)&&(M=z,F=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this._stacks.get(h.value)||0;this._stacks.set(h.value,M-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class E{constructor(h){this.value=h,this.id=v++}}const c=2,d=(p,h)=>{if(p instanceof E)h(p);else for(let y=0;y<p.length;y++){const D=p[y];D&&h(D)}};class g{constructor(h){this._size=0,this._options=h,this._leakageMon=I>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(R){const h=this._listeners;queueMicrotask(()=>{d(h,y=>y.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(h,y,D)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;y&&(h=h.bind(y));const U=new E(h);let M,F;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(U.stack=f.create(),M=this._leakageMon.check(U.stack,this._size+1)),R&&(U.stack=F??f.create()),this._listeners?this._listeners instanceof E?(this._deliveryQueue??=new w,this._listeners=[this._listeners,U]):this._listeners.push(U):(this._options?.onWillAddFirstListener?.(this),this._listeners=U,this._options?.onDidAddFirstListener?.(this)),this._size++;const z=(0,A.toDisposable)(()=>{M?.(),this._removeListener(U)});return D instanceof A.DisposableStore?D.add(z):Array.isArray(D)&&D.push(z),z},this._event}_removeListener(h){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const y=this._listeners,D=y.indexOf(h);if(D===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,y[D]=void 0;const U=this._deliveryQueue.current===this;if(this._size*c<=y.length){let M=0;for(let F=0;F<y.length;F++)y[F]?y[M++]=y[F]:U&&(this._deliveryQueue.end--,M<this._deliveryQueue.i&&this._deliveryQueue.i--);y.length=M}}_deliver(h,y){if(!h)return;const D=this._options?.onListenerError||L.onUnexpectedError;if(!D){h.value(y);return}try{h.value(y)}catch(U){D(U)}}_deliverQueue(h){const y=h.current._listeners;for(;h.i<h.end;)this._deliver(y[h.i++],h.value);h.reset()}fire(h){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof E)this._deliver(this._listeners,h);else{const y=this._deliveryQueue;y.enqueue(this,h,this._listeners.length),this._deliverQueue(y)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=g;const l=()=>new w;e.createEventDeliveryQueue=l;class w{constructor(){this.i=-1,this.end=0}enqueue(h,y,D){this.i=0,this.end=D,this.current=h,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends g{async fireAsync(h,y,D){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList),d(this._listeners,U=>this._asyncDeliveryQueue.push([U.value,h]));this._asyncDeliveryQueue.size>0&&!y.isCancellationRequested;){const[U,M]=this._asyncDeliveryQueue.shift(),F=[],z={...M,token:y,waitUntil:X=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(X=D(X,U)),F.push(X)}};try{U(z)}catch(X){(0,L.onUnexpectedError)(X);continue}Object.freeze(F),await Promise.allSettled(F).then(X=>{for(const K of X)K.status==="rejected"&&(0,L.onUnexpectedError)(K.reason)})}}}e.AsyncEmitter=i;class o extends g{get isPaused(){return this._isPaused!==0}constructor(h){super(h),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._size&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=o;class n extends o{constructor(h){super(h),this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=n;class s extends g{constructor(h){super(h),this._queuedEvents=[],this._mergeFn=h?.merge}fire(h){this.hasListeners()&&(this._queuedEvents.push(h),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(y=>super.fire(y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const y={event:h,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const D=()=>{this.hasListeners&&this.unhook(y);const U=this.events.indexOf(y);this.events.splice(U,1)};return(0,A.toDisposable)((0,O.createSingleCallFunction)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(y=>this.emitter.fire(y))}unhook(h){h.listener?.dispose(),h.listener=null}dispose(){this.emitter.dispose();for(const h of this.events)h.listener?.dispose();this.events=[]}}e.EventMultiplexer=t;class r{constructor(h,y,D,U){this._store=new A.DisposableStore;const M=this._store.add(new t),F=this._store.add(new A.DisposableMap);function z(X){F.set(X,M.add(U(X)))}for(const X of h)z(X);this._store.add(y(X=>{z(X)})),this._store.add(D(X=>{F.deleteAndDispose(X)})),this.event=M.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(h){return(y,D,U)=>h(M=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>y.call(D,M)):y.call(D,M)},void 0,U)}bufferEvents(h){const y=[];this.buffers.push(y);const D=h();return this.buffers.pop(),y.forEach(U=>U()),D}}e.EventBufferer=a;class C{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=A.Disposable.None,this.emitter=new g({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(le[26],ue([0,1,3]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(R,b){const m=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(m)}}});var A;(function(R){function b(m){return m===R.None||m===R.Cancelled||m instanceof T?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(A||(e.CancellationToken=A={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=_}),define(le[129],ue([0,1,26]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new L.CancellationTokenSource,b=this.task(R.token);return this.result={promise:b,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=O;class A{constructor(R){this.fn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const b=JSON.stringify(R);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=A;class T{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const b=this.fn(R);return this._map.set(R,b),b}}e.CachedFunction=T}),define(le[47],ue([0,1,7,2]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function A(l){const w=l;return w?typeof w.read=="function":!1}e.isReadable=A;function T(l){const w=l;return w?[w.on,w.pause,w.resume,w.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=T;function _(l){const w=l;return w?T(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=_;function R(l,w){return new b(l,w)}e.newWriteableStream=R;class b{constructor(w,i){this.reducer=w,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(i=>i(w))}emitError(w){this.listeners.error.length===0?(0,L.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(i=>i(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,i){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(w,i){if(this.state.destroyed)return;let o;switch(w){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(l,w){const i=[];let o;for(;(o=l.read())!==null;)i.push(o);return w(i)}e.consumeReadable=m;function P(l,w,i){const o=[];let n;for(;(n=l.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return l.read()}}}e.peekReadable=P;function I(l,w){return new Promise((i,o)=>{const n=[];S(l,{onData:s=>{w&&n.push(s)},onError:s=>{w?o(s):i(void 0)},onEnd:()=>{i(w?w(n):void 0)}})})}e.consumeStream=I;function S(l,w,i){l.on("error",o=>{i?.isCancellationRequested||w.onError(o)}),l.on("end",()=>{i?.isCancellationRequested||w.onEnd()}),l.on("data",o=>{i?.isCancellationRequested||w.onData(o)})}e.listenStream=S;function u(l,w){return new Promise((i,o)=>{const n=new O.DisposableStore,s=[],t=C=>{if(s.push(C),s.length>w)return n.dispose(),l.pause(),i({stream:l,buffer:s,ended:!1})},r=C=>(n.dispose(),o(C)),a=()=>(n.dispose(),i({stream:l,buffer:s,ended:!0}));n.add((0,O.toDisposable)(()=>l.removeListener("error",r))),l.on("error",r),n.add((0,O.toDisposable)(()=>l.removeListener("end",a))),l.on("end",a),n.add((0,O.toDisposable)(()=>l.removeListener("data",t))),l.on("data",t)})}e.peekStream=u;function f(l,w){const i=R(w);return i.end(l),i}e.toStream=f;function v(){const l=R(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=v;function E(l){let w=!1;return{read:()=>w?null:(w=!0,l)}}e.toReadable=E;function c(l,w,i){const o=R(i);return S(l,{onData:n=>o.write(w.data(n)),onError:n=>o.error(w.error?w.error(n):n),onEnd:()=>o.end()}),o}e.transform=c;function d(l,w,i){let o=!1;return{read:()=>{const n=w.read();return o?n:(o=!0,n!==null?i([l,n]):l)}}}e.prefixedReadable=d;function g(l,w,i){let o=!1;const n=R(i);return S(w,{onData:s=>o?n.write(s):(o=!0,n.write(i([l,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(l)),n.end()}}),n}e.prefixedStream=g}),define(le[14],ue([0,1,53,47]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const A=typeof Buffer<"u",T=new L.Lazy(()=>new Uint8Array(256));let _,R;class b{static alloc(y){return A?new b(Buffer.allocUnsafe(y)):new b(new Uint8Array(y))}static wrap(y){return A&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new b(y)}static fromString(y,D){return!(D?.dontUseNodeBuffer||!1)&&A?new b(Buffer.from(y)):(_||(_=new TextEncoder),new b(_.encode(y)))}static fromByteArray(y){const D=b.alloc(y.length);for(let U=0,M=y.length;U<M;U++)D.buffer[U]=y[U];return D}static concat(y,D){if(typeof D>"u"){D=0;for(let F=0,z=y.length;F<z;F++)D+=y[F].byteLength}const U=b.alloc(D);let M=0;for(let F=0,z=y.length;F<z;F++){const X=y[F];U.set(X,M),M+=X.byteLength}return U}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=b.alloc(this.byteLength);return y.set(this),y}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(y,D){return new b(this.buffer.subarray(y,D))}set(y,D){if(y instanceof b)this.buffer.set(y.buffer,D);else if(y instanceof Uint8Array)this.buffer.set(y,D);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),D);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,D){u(this.buffer,y,D)}readUInt32LE(y){return f(this.buffer,y)}writeUInt32LE(y,D){v(this.buffer,y,D)}readUInt8(y){return E(this.buffer,y)}writeUInt8(y,D){c(this.buffer,y,D)}indexOf(y,D=0){return m(this.buffer,y instanceof b?y.buffer:y,D)}}e.VSBuffer=b;function m(h,y,D=0){const U=y.byteLength,M=h.byteLength;if(U===0)return 0;if(U===1)return h.indexOf(y[0]);if(U>M-D)return-1;const F=T.value;F.fill(y.length);for(let Q=0;Q<y.length;Q++)F[y[Q]]=y.length-Q-1;let z=D+y.length-1,X=z,K=-1;for(;z<M;)if(h[z]===y[X]){if(X===0){K=z;break}z--,X--}else z+=Math.max(y.length-X,F[h[z]]),X=y.length-1;return K}e.binaryIndexOf=m;function P(h,y){return h[y+0]<<0>>>0|h[y+1]<<8>>>0}e.readUInt16LE=P;function I(h,y,D){h[D+0]=y&255,y=y>>>8,h[D+1]=y&255}e.writeUInt16LE=I;function S(h,y){return h[y]*2**24+h[y+1]*2**16+h[y+2]*2**8+h[y+3]}e.readUInt32BE=S;function u(h,y,D){h[D+3]=y,y=y>>>8,h[D+2]=y,y=y>>>8,h[D+1]=y,y=y>>>8,h[D]=y}e.writeUInt32BE=u;function f(h,y){return h[y+0]<<0>>>0|h[y+1]<<8>>>0|h[y+2]<<16>>>0|h[y+3]<<24>>>0}e.readUInt32LE=f;function v(h,y,D){h[D+0]=y&255,y=y>>>8,h[D+1]=y&255,y=y>>>8,h[D+2]=y&255,y=y>>>8,h[D+3]=y&255}e.writeUInt32LE=v;function E(h,y){return h[y]}e.readUInt8=E;function c(h,y,D){h[D]=y}e.writeUInt8=c;function d(h){return O.consumeReadable(h,y=>b.concat(y))}e.readableToBuffer=d;function g(h){return O.toReadable(h)}e.bufferToReadable=g;function l(h){return O.consumeStream(h,y=>b.concat(y))}e.streamToBuffer=l;async function w(h){return h.ended?b.concat(h.buffer):b.concat([...h.buffer,await l(h.stream)])}e.bufferedStreamToBuffer=w;function i(h){return O.toStream(h,y=>b.concat(y))}e.bufferToStream=i;function o(h){return O.transform(h,{data:y=>typeof y=="string"?b.fromString(y):b.wrap(y)},y=>b.concat(y))}e.streamToBufferReadableStream=o;function n(h){return O.newWriteableStream(y=>b.concat(y),h)}e.newWriteableBufferStream=n;function s(h,y){return O.prefixedReadable(h,y,D=>b.concat(D))}e.prefixedBufferReadable=s;function t(h,y){return O.prefixedStream(h,y,D=>b.concat(D))}e.prefixedBufferStream=t;function r(h){let y=0,D=0,U=0;const M=new Uint8Array(Math.floor(h.length/4*3)),F=X=>{switch(D){case 3:M[U++]=y|X,D=0;break;case 2:M[U++]=y|X>>>2,y=X<<6,D=3;break;case 1:M[U++]=y|X>>>4,y=X<<4,D=2;break;default:y=X<<2,D=1}};for(let X=0;X<h.length;X++){const K=h.charCodeAt(X);if(K>=65&&K<=90)F(K-65);else if(K>=97&&K<=122)F(K-97+26);else if(K>=48&&K<=57)F(K-48+52);else if(K===43||K===45)F(62);else if(K===47||K===95)F(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${h[X]}`)}}const z=U;for(;D>0;)F(0);return b.wrap(M).slice(0,z)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:h},y=!0,D=!1){const U=D?C:a;let M="";const F=h.byteLength%3;let z=0;for(;z<h.byteLength-F;z+=3){const X=h[z+0],K=h[z+1],Q=h[z+2];M+=U[X>>>2],M+=U[(X<<4|K>>>4)&63],M+=U[(K<<2|Q>>>6)&63],M+=U[Q&63]}if(F===1){const X=h[z+0];M+=U[X>>>2],M+=U[X<<4&63],y&&(M+="==")}else if(F===2){const X=h[z+0],K=h[z+1];M+=U[X>>>2],M+=U[(X<<4|K>>>4)&63],M+=U[K<<2&63],y&&(M+="=")}return M}e.encodeBase64=p}),define(le[27],ue([0,1,129,53]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLinesIncludeSeparators=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function _(re,...ge){return ge.length===0?re:re.replace(T,function(ye,ve){const we=parseInt(ve,10);return isNaN(we)||we<0||we>=ge.length?ye:ge[we]})}e.format=_;const R=/{([^}]+)}/g;function b(re,ge){return Object.keys(ge).length===0?re:re.replace(R,(ye,ve)=>ge[ve]??ye)}e.format2=b;function m(re){return re.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}e.htmlAttributeEncodeValue=m;function P(re){return re.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=P;function I(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function S(re,ge){let ye=0;const ve=ge.charCodeAt(0);for(let we=re.length-1;we>=0;we--)re.charCodeAt(we)===ve&&ye++;return ye}e.count=S;function u(re,ge,ye="\u2026"){return re.length<=ge?re:`${re.substr(0,ge)}${ye}`}e.truncate=u;function f(re,ge,ye="\u2026"){if(re.length<=ge)return re;const ve=Math.ceil(ge/2)-ye.length/2,we=Math.floor(ge/2)-ye.length/2;return`${re.substr(0,ve)}${ye}${re.substr(re.length-we)}`}e.truncateMiddle=f;function v(re,ge=" "){const ye=E(re,ge);return c(ye,ge)}e.trim=v;function E(re,ge){if(!re||!ge)return re;const ye=ge.length;if(ye===0||re.length===0)return re;let ve=0;for(;re.indexOf(ge,ve)===ve;)ve=ve+ye;return re.substring(ve)}e.ltrim=E;function c(re,ge){if(!re||!ge)return re;const ye=ge.length,ve=re.length;if(ye===0||ve===0)return re;let we=ve,be=-1;for(;be=re.lastIndexOf(ge,we-1),!(be===-1||be+ye!==we);){if(be===0)return"";we=be}return re.substring(0,we)}e.rtrim=c;function d(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(re){return re.replace(/\*/g,"")}e.stripWildcards=g;function l(re,ge,ye={}){if(!re)throw new Error("Cannot create regex from empty string");ge||(re=I(re)),ye.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ve="";return ye.global&&(ve+="g"),ye.matchCase||(ve+="i"),ye.multiline&&(ve+="m"),ye.unicode&&(ve+="u"),new RegExp(re,ve)}e.createRegExp=l;function w(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function i(re){return re.split(/\r\n|\r|\n/)}e.splitLines=i;function o(re){const ge=[],ye=re.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(ye.length/2);ve++)ge.push(ye[2*ve]+(ye[2*ve+1]??""));return ge}e.splitLinesIncludeSeparators=o;function n(re){for(let ge=0,ye=re.length;ge<ye;ge++){const ve=re.charCodeAt(ge);if(ve!==32&&ve!==9)return ge}return-1}e.firstNonWhitespaceIndex=n;function s(re,ge=0,ye=re.length){for(let ve=ge;ve<ye;ve++){const we=re.charCodeAt(ve);if(we!==32&&we!==9)return re.substring(ge,ve)}return re.substring(ge,ye)}e.getLeadingWhitespace=s;function t(re,ge=re.length-1){for(let ye=ge;ye>=0;ye--){const ve=re.charCodeAt(ye);if(ve!==32&&ve!==9)return ye}return-1}e.lastNonWhitespaceIndex=t;function r(re,ge,ye){const ve=[];let we=0;for(const be of re.matchAll(ge)){if(ve.push(re.slice(we,be.index)),be.index===void 0)throw new Error("match.index should be defined");we=be.index+be[0].length,ve.push(ye(be[0],...be.slice(1),be.index,re,be.groups))}return ve.push(re.slice(we)),Promise.all(ve).then(be=>be.join(""))}e.replaceAsync=r;function a(re,ge){return re<ge?-1:re>ge?1:0}e.compare=a;function C(re,ge,ye=0,ve=re.length,we=0,be=ge.length){for(;ye<ve&&we<be;ye++,we++){const qe=re.charCodeAt(ye),je=ge.charCodeAt(we);if(qe<je)return-1;if(qe>je)return 1}const Le=ve-ye,Oe=be-we;return Le<Oe?-1:Le>Oe?1:0}e.compareSubstring=C;function p(re,ge){return h(re,ge,0,re.length,0,ge.length)}e.compareIgnoreCase=p;function h(re,ge,ye=0,ve=re.length,we=0,be=ge.length){for(;ye<ve&&we<be;ye++,we++){let qe=re.charCodeAt(ye),je=ge.charCodeAt(we);if(qe===je)continue;if(qe>=128||je>=128)return C(re.toLowerCase(),ge.toLowerCase(),ye,ve,we,be);D(qe)&&(qe-=32),D(je)&&(je-=32);const Fe=qe-je;if(Fe!==0)return Fe}const Le=ve-ye,Oe=be-we;return Le<Oe?-1:Le>Oe?1:0}e.compareSubstringIgnoreCase=h;function y(re){return re>=48&&re<=57}e.isAsciiDigit=y;function D(re){return re>=97&&re<=122}e.isLowerAsciiLetter=D;function U(re){return re>=65&&re<=90}e.isUpperAsciiLetter=U;function M(re,ge){return re.length===ge.length&&h(re,ge)===0}e.equalsIgnoreCase=M;function F(re,ge){const ye=ge.length;return ge.length>re.length?!1:h(re,ge,0,ye)===0}e.startsWithIgnoreCase=F;function z(re,ge){const ye=Math.min(re.length,ge.length);let ve;for(ve=0;ve<ye;ve++)if(re.charCodeAt(ve)!==ge.charCodeAt(ve))return ve;return ye}e.commonPrefixLength=z;function X(re,ge){const ye=Math.min(re.length,ge.length);let ve;const we=re.length-1,be=ge.length-1;for(ve=0;ve<ye;ve++)if(re.charCodeAt(we-ve)!==ge.charCodeAt(be-ve))return ve;return ye}e.commonSuffixLength=X;function K(re){return 55296<=re&&re<=56319}e.isHighSurrogate=K;function Q(re){return 56320<=re&&re<=57343}e.isLowSurrogate=Q;function V(re,ge){return(re-55296<<10)+(ge-56320)+65536}e.computeCodePoint=V;function Y(re,ge,ye){const ve=re.charCodeAt(ye);if(K(ve)&&ye+1<ge){const we=re.charCodeAt(ye+1);if(Q(we))return V(ve,we)}return ve}e.getNextCodePoint=Y;function x(re,ge){const ye=re.charCodeAt(ge-1);if(Q(ye)&&ge>1){const ve=re.charCodeAt(ge-2);if(K(ve))return V(ve,ye)}return ye}class q{get offset(){return this._offset}constructor(ge,ye=0){this._str=ge,this._len=ge.length,this._offset=ye}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=x(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Y(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class te{get offset(){return this._iterator.offset}constructor(ge,ye=0){this._iterator=new q(ge,ye)}nextGraphemeLength(){const ge=De.getInstance(),ye=this._iterator,ve=ye.offset;let we=ge.getGraphemeBreakType(ye.nextCodePoint());for(;!ye.eol();){const be=ye.offset,Le=ge.getGraphemeBreakType(ye.nextCodePoint());if(pe(we,Le)){ye.setOffset(be);break}we=Le}return ye.offset-ve}prevGraphemeLength(){const ge=De.getInstance(),ye=this._iterator,ve=ye.offset;let we=ge.getGraphemeBreakType(ye.prevCodePoint());for(;ye.offset>0;){const be=ye.offset,Le=ge.getGraphemeBreakType(ye.prevCodePoint());if(pe(Le,we)){ye.setOffset(be);break}we=Le}return ve-ye.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function oe(re,ge){return new te(re,ge).nextGraphemeLength()}e.nextCharLength=oe;function ee(re,ge){return new te(re,ge).prevGraphemeLength()}e.prevCharLength=ee;function ae(re,ge){ge>0&&Q(re.charCodeAt(ge))&&ge--;const ye=ge+oe(re,ge);return[ye-ee(re,ye),ye]}e.getCharContainingOffset=ae;function B(re){const ge=new te(re);let ye=0;for(;!ge.eol();)ye++,ge.nextGraphemeLength();return ye}e.charCount=B;let W;function k(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(re){return W||(W=k()),W.test(re)}e.containsRTL=N;const j=/^[\t\n\r\x20-\x7E]*$/;function $(re){return j.test(re)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=J;function Z(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=Z;function ie(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=ie;function H(re,ge,ye=""){const ve=re.trimStart();if(ve.length<ge)return ve;const we=/\b/g;let be=0;for(;we.test(ve)&&!(ve.length-we.lastIndex<ge);)be=we.lastIndex,we.lastIndex+=1;return be===0?ve:ye+ve.substring(be).trimStart()}e.lcut=H;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function de(re){return re&&(re=re.replace(ne,"").replace(ce,"")),re}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER="\uFEFF";function fe(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=fe;function Se(re){return fe(re)?re.substr(1):re}e.stripUTF8BOM=Se;function Ce(re,ge){if(!re||!ge||re.length<ge.length)return!1;const ye=ge.length,ve=re.toLowerCase();let we=0,be=-1;for(;we<ye;){const Le=ve.indexOf(ge[we],be+1);if(Le<0)return!1;be=Le,we++}return!0}e.fuzzyContains=Ce;function Re(re,ge=!1){return re?(ge&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=Re;function _e(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=_e;function Ue(re,ge=1){if(ge===0)return"";let ye=-1;do ye=re.indexOf(`
`,ye+1),ge--;while(ge>0&&ye>=0);return ye===-1?re:(re[ye-1]==="\r"&&ye--,re.substr(0,ye))}e.getNLines=Ue;function he(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.singleLetterHash=he;function me(re){return De.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=me;function pe(re,ge){return re===0?ge!==5&&ge!==7:re===2&&ge===3?!1:re===4||re===2||re===3||ge===4||ge===2||ge===3?!0:!(re===8&&(ge===8||ge===9||ge===11||ge===12)||(re===11||re===9)&&(ge===9||ge===10)||(re===12||re===10)&&ge===10||ge===5||ge===13||ge===7||re===1||re===13&&ge===14||re===6&&ge===6)}var Pe;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class De{static{this._INSTANCE=null}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const ye=this._data,ve=ye.length/3;let we=1;for(;we<=ve;)if(ge<ye[3*we])we=2*we;else if(ge>ye[3*we+1])we=2*we+1;else return ye[3*we+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(re,ge){if(re===0)return 0;const ye=ze(re,ge);if(ye!==void 0)return ye;const ve=new q(ge,re);return ve.prevCodePoint(),ve.offset}e.getLeftDeleteOffset=ke;function ze(re,ge){const ye=new q(ge,re);let ve=ye.prevCodePoint();for(;Ne(ve)||ve===65039||ve===8419;){if(ye.offset===0)return;ve=ye.prevCodePoint()}if(!ie(ve))return;let we=ye.offset;return we>0&&ye.prevCodePoint()===8205&&(we=ye.offset),we}function Ne(re){return 127995<=re&&re<=127999}var $e;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class We{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new L.LRUCachedFunction(ge=>{function ye(Fe){const Ge=new Map;for(let Be=0;Be<Fe.length;Be+=2)Ge.set(Fe[Be],Fe[Be+1]);return Ge}function ve(Fe,Ge){const Be=new Map(Fe);for(const[Ze,tt]of Ge)Be.set(Ze,tt);return Be}function we(Fe,Ge){if(!Fe)return Ge;const Be=new Map;for(const[Ze,tt]of Fe)Ge.has(Ze)&&Be.set(Ze,tt);return Be}const be=this.ambiguousCharacterData.value;let Le=ge.filter(Fe=>!Fe.startsWith("_")&&Fe in be);Le.length===0&&(Le=["_default"]);let Oe;for(const Fe of Le){const Ge=ye(be[Fe]);Oe=we(Oe,Ge)}const qe=ye(be._common),je=ve(qe,Oe);return new We(je)})}static getInstance(ge){return We.cache.get(Array.from(ge))}static{this._locales=new O.Lazy(()=>Object.keys(We.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return We._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=We;class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(ge){return Ae.getData().has(ge)}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae}),define(le[54],ue([0,1,27]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(c){return A(c,0)}e.hash=O;function A(c,d){switch(typeof c){case"object":return c===null?T(349,d):Array.isArray(c)?b(c,d):m(c,d);case"string":return R(c,d);case"boolean":return _(c,d);case"number":return T(c,d);case"undefined":return T(937,d);default:return T(617,d)}}e.doHash=A;function T(c,d){return(d<<5)-d+c|0}e.numberHash=T;function _(c,d){return T(c?433:863,d)}function R(c,d){d=T(149417,d);for(let g=0,l=c.length;g<l;g++)d=T(c.charCodeAt(g),d);return d}e.stringHash=R;function b(c,d){return d=T(104579,d),c.reduce((g,l)=>A(l,g),d)}function m(c,d){return d=T(181387,d),Object.keys(c).sort().reduce((g,l)=>(g=R(l,g),A(c[l],g)),d)}class P{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=A(d,this._value),this._value}}e.Hasher=P;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function S(c,d,g=32){const l=g-d,w=~((1<<l)-1);return(c<<d|(w&c)>>>l)>>>0}function u(c,d=0,g=c.byteLength,l=0){for(let w=0;w<g;w++)c[d+w]=l}function f(c,d,g="0"){for(;c.length<d;)c=g+c;return c}function v(c,d=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((c>>>0).toString(16),d/4)}e.toHexString=v;class E{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const g=d.length;if(g===0)return;const l=this._buff;let w=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(L.isHighSurrogate(o))if(n+1<g){const t=d.charCodeAt(n+1);L.isLowSurrogate(t)?(n++,s=L.computeCodePoint(o,t)):s=65533}else{i=o;break}else L.isLowSurrogate(o)&&(s=65533);if(w=this._push(l,w,s),n++,n<g)o=d.charCodeAt(n);else break}this._buffLen=w,this._leftoverHighSurrogate=i}_push(d,g,l){return l<128?d[g++]=l:l<2048?(d[g++]=192|(l&1984)>>>6,d[g++]=128|(l&63)>>>0):l<65536?(d[g++]=224|(l&61440)>>>12,d[g++]=128|(l&4032)>>>6,d[g++]=128|(l&63)>>>0):(d[g++]=240|(l&1835008)>>>18,d[g++]=128|(l&258048)>>>12,d[g++]=128|(l&4032)>>>6,d[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=E._bigBlock32,g=this._buffDV;for(let a=0;a<64;a+=4)d.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,S(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let l=this._h0,w=this._h1,i=this._h2,o=this._h3,n=this._h4,s,t,r;for(let a=0;a<80;a++)a<20?(s=w&i|~w&o,t=1518500249):a<40?(s=w^i^o,t=1859775393):a<60?(s=w&i|w&o|i&o,t=2400959708):(s=w^i^o,t=3395469782),r=S(l,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=S(w,30),w=l,l=r;this._h0=this._h0+l&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=E}),define(le[89],ue([0,1,27]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(O||(O={})),function(A){const T="error",_="warning",R="warn",b="info",m="ignore";function P(S){return S?L.equalsIgnoreCase(T,S)?A.Error:L.equalsIgnoreCase(_,S)||L.equalsIgnoreCase(R,S)?A.Warning:L.equalsIgnoreCase(b,S)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function I(S){switch(S){case A.Error:return T;case A.Warning:return _;case A.Info:return b;default:return m}}A.toString=I}(O||(O={})),e.default=O}),define(le[130],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[48],ue([0,1,17,27]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const f=u.charCodeAt(0),v=this._value.charCodeAt(this._pos);return f-v}value(){return this._value[this._pos]}}e.StringIterator=A;class T{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,O.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class _{constructor(u=!0,f=!0){this._splitOnBackslash=u,this._caseSensitive=f}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let f=u.length-1;f>=0;f--,this._valueLen--){const v=this._value.charCodeAt(f);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,O.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var R;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(R||(R={}));class b{constructor(u,f){this._ignorePathCasing=u,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,O.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(P||(P={}));class I{static forUris(u=()=>!1,f=()=>!1){return new I(new b(u,f))}static forPaths(u=!1){return new I(new _(void 0,!u))}static forStrings(){return new I(new A)}static forConfigKeys(){return new I(new T)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,f){if(f){const v=f.slice(0);(0,L.shuffle)(v);for(const E of v)this.set(E,u)}else{const v=u.slice(0);(0,L.shuffle)(v);for(const E of v)this.set(E[0],E[1])}}set(u,f){const v=this._iter.reset(u);let E;this._root||(this._root=new m,this._root.segment=v.value());const c=[];for(E=this._root;;){const g=v.cmp(E.segment);if(g>0)E.left||(E.left=new m,E.left.segment=v.value()),c.push([-1,E]),E=E.left;else if(g<0)E.right||(E.right=new m,E.right.segment=v.value()),c.push([1,E]),E=E.right;else if(v.hasNext())v.next(),E.mid||(E.mid=new m,E.mid.segment=v.value()),c.push([0,E]),E=E.mid;else break}const d=E.value;E.value=f,E.key=u;for(let g=c.length-1;g>=0;g--){const l=c[g][1];l.updateHeight();const w=l.balanceFactor();if(w<-1||w>1){const i=c[g][0],o=c[g+1][0];if(i===1&&o===1)c[g][1]=l.rotateLeft();else if(i===-1&&o===-1)c[g][1]=l.rotateRight();else if(i===1&&o===-1)l.right=c[g+1][1]=c[g+1][1].rotateRight(),c[g][1]=l.rotateLeft();else if(i===-1&&o===1)l.left=c[g+1][1]=c[g+1][1].rotateLeft(),c[g][1]=l.rotateRight();else throw new Error;if(g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this._root=c[0][1]}}return d}get(u){return this._getNode(u)?.value}_getNode(u){const f=this._iter.reset(u);let v=this._root;for(;v;){const E=f.cmp(v.segment);if(E>0)v=v.left;else if(E<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else break}return v}has(u){const f=this._getNode(u);return!(f?.value===void 0&&f?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,f){const v=this._iter.reset(u),E=[];let c=this._root;for(;c;){const d=v.cmp(c.segment);if(d>0)E.push([-1,c]),c=c.left;else if(d<0)E.push([1,c]),c=c.right;else if(v.hasNext())v.next(),E.push([0,c]),c=c.mid;else break}if(c){if(f?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const d=this._min(c.right);if(d.key){const{key:g,value:l,segment:w}=d;this._delete(d.key,!1),c.key=g,c.value=l,c.segment=w}}else{const d=c.left??c.right;if(E.length>0){const[g,l]=E[E.length-1];switch(g){case-1:l.left=d;break;case 0:l.mid=d;break;case 1:l.right=d;break}}else this._root=d}for(let d=E.length-1;d>=0;d--){const g=E[d][1];g.updateHeight();const l=g.balanceFactor();if(l>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),E[d][1]=g.rotateLeft()):l<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),E[d][1]=g.rotateRight()),d>0)switch(E[d-1][0]){case-1:E[d-1][1].left=E[d][1];break;case 1:E[d-1][1].right=E[d][1];break;case 0:E[d-1][1].mid=E[d][1];break}else this._root=E[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const f=this._iter.reset(u);let v=this._root,E;for(;v;){const c=f.cmp(v.segment);if(c>0)v=v.left;else if(c<0)v=v.right;else if(f.hasNext())f.next(),E=v.value||E,v=v.mid;else break}return v&&v.value||E}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,f){const v=this._iter.reset(u);let E=this._root;for(;E;){const c=v.cmp(E.segment);if(c>0)E=E.left;else if(c<0)E=E.right;else if(v.hasNext())v.next(),E=E.mid;else return E.mid?this._entries(E.mid):f?E.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[f,v]of this)u(v,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const f=[];return this._dfsEntries(u,f),f[Symbol.iterator]()}_dfsEntries(u,f){u&&(u.left&&this._dfsEntries(u.left,f),u.value&&f.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,f),u.right&&this._dfsEntries(u.right,f))}_isBalanced(){const u=f=>{if(!f)return!0;const v=f.balanceFactor();return v<-1||v>1?!1:u(f.left)&&u(f.right)};return u(this._root)}}e.TernarySearchTree=I}),define(le[12],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(w){return typeof w=="string"}e.isString=L;function O(w){return Array.isArray(w)&&w.every(i=>L(i))}e.isStringArray=O;function A(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=A;function T(w){const i=Object.getPrototypeOf(Uint8Array);return typeof w=="object"&&w instanceof i}e.isTypedArray=T;function _(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=_;function R(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=R;function b(w){return w===!0||w===!1}e.isBoolean=b;function m(w){return typeof w>"u"}e.isUndefined=m;function P(w){return!I(w)}e.isDefined=P;function I(w){return m(w)||w===null}e.isUndefinedOrNull=I;function S(w,i){if(!w)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function u(w){if(I(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=u;function f(...w){const i=[];for(let o=0;o<w.length;o++){const n=w[o];if(I(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function E(w){if(!A(w))return!1;for(const i in w)if(v.call(w,i))return!1;return!0}e.isEmptyObject=E;function c(w){return typeof w=="function"}e.isFunction=c;function d(...w){return w.length>0&&w.every(c)}e.areFunctions=d;function g(w,i){const o=Math.min(w.length,i.length);for(let n=0;n<o;n++)l(w[n],i[n])}e.validateConstraints=g;function l(w,i){if(L(i)){if(typeof w!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(c(i)){try{if(w instanceof i)return}catch{}if(!I(w)&&w.constructor===i||i.length===1&&i.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l}),define(le[30],ue([0,1,12]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const d=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([g,l])=>{d[g]=l&&typeof l=="object"?O(l):l}),d}e.deepClone=O;function A(c){if(!c||typeof c!="object")return c;const d=[c];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const l in g)if(T.call(g,l)){const w=g[l];typeof w=="object"&&!Object.isFrozen(w)&&!(0,L.isTypedArray)(w)&&d.push(w)}}return c}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function _(c,d){return R(c,d,new Set)}e.cloneAndChange=_;function R(c,d,g){if((0,L.isUndefinedOrNull)(c))return c;const l=d(c);if(typeof l<"u")return l;if(Array.isArray(c)){const w=[];for(const i of c)w.push(R(i,d,g));return w}if((0,L.isObject)(c)){if(g.has(c))throw new Error("Cannot clone recursive data-structure");g.add(c);const w={};for(const i in c)T.call(c,i)&&(w[i]=R(c[i],d,g));return g.delete(c),w}return c}function b(c,d,g=!0){return(0,L.isObject)(c)?((0,L.isObject)(d)&&Object.keys(d).forEach(l=>{l in c?g&&((0,L.isObject)(c[l])&&(0,L.isObject)(d[l])?b(c[l],d[l],g):c[l]=d[l]):c[l]=d[l]}),c):d}e.mixin=b;function m(c,d){if(c===d)return!0;if(c==null||d===null||d===void 0||typeof c!=typeof d||typeof c!="object"||Array.isArray(c)!==Array.isArray(d))return!1;let g,l;if(Array.isArray(c)){if(c.length!==d.length)return!1;for(g=0;g<c.length;g++)if(!m(c[g],d[g]))return!1}else{const w=[];for(l in c)w.push(l);w.sort();const i=[];for(l in d)i.push(l);if(i.sort(),!m(w,i))return!1;for(g=0;g<w.length;g++)if(!m(c[w[g]],d[w[g]]))return!1}return!0}e.equals=m;function P(c){const d=new Set;return JSON.stringify(c,(g,l)=>{if((0,L.isObject)(l)||Array.isArray(l)){if(d.has(l))return"[Circular]";d.add(l)}return l})}e.safeStringify=P;function I(c,d){const g=Object.create(null);return!c||!d||Object.keys(d).forEach(w=>{const i=c[w],o=d[w];m(i,o)||(g[w]=o)}),g}e.distinct=I;function S(c,d){const g=d.toLowerCase(),l=Object.keys(c).find(w=>w.toLowerCase()===g);return l?c[l]:c[d]}e.getCaseInsensitive=S;function u(c,d){const g=Object.create(null);for(const[l,w]of Object.entries(c))d(l,w)&&(g[l]=w);return g}e.filter=u;function f(c){let d=[];for(;Object.prototype!==c;)d=d.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return d}e.getAllPropertyNames=f;function v(c){const d=[];for(const g of f(c))typeof c[g]=="function"&&d.push(g);return d}e.getAllMethodNames=v;function E(c,d){const g=w=>function(){const i=Array.prototype.slice.call(arguments,0);return d(w,i)},l={};for(const w of c)l[w]=g(w);return l}e.createProxyObject=E}),define(le[32],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(A){return L.test(A)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let b=0;b<R.length;b++)R[b]=Math.floor(Math.random()*256);return R};const T=new Uint8Array(16),_=[];for(let R=0;R<256;R++)_.push(R.toString(16).padStart(2,"0"));return function(){A(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let b=0,m="";return m+=_[T[b++]],m+=_[T[b++]],m+=_[T[b++]],m+=_[T[b++]],m+="-",m+=_[T[b++]],m+=_[T[b++]],m+="-",m+=_[T[b++]],m+=_[T[b++]],m+="-",m+=_[T[b++]],m+=_[T[b++]],m+="-",m+=_[T[b++]],m+=_[T[b++]],m+=_[T[b++]],m+=_[T[b++]],m+=_[T[b++]],m+=_[T[b++]],m}}()}),define(le[131],ue([0,1,37]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(_){const R=_.replace(/\-/g,":").toLowerCase();return!O.has(R)}function T(){const _=(0,L.networkInterfaces)();for(const R in _){const b=_[R];if(b){for(const{mac:m}of b)if(A(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(le[132],ue([0,1,269,14]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class A extends L.Transform{constructor(_){if(super(),typeof _=="number")this.splitter=_,this.spitterLen=1;else{const R=Buffer.isBuffer(_)?_:Buffer.from(_);this.splitter=R.length===1?R[0]:R,this.spitterLen=R.length}}_transform(_,R,b){this.buffer?this.buffer=Buffer.concat([this.buffer,_]):this.buffer=_;let m=0;for(;m<this.buffer.length;){const P=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,m):(0,O.binaryIndexOf)(this.buffer,this.splitter,m);if(P===-1)break;this.push(this.buffer.slice(m,P+this.spitterLen)),m=P+this.spitterLen}this.buffer=m===this.buffer.length?void 0:this.buffer.slice(m),b()}_flush(_){this.buffer&&this.push(this.buffer),_()}}e.StreamSplitter=A}),define(le[133],ue([0,1,64]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(R,b,m,P=1){let I=!1;return new Promise(S=>{const u=setTimeout(()=>{if(!I)return I=!0,S(0)},m);A(R,b,P,f=>{if(!I)return I=!0,clearTimeout(u),S(f)})})}e.findFreePort=O;function A(R,b,m,P){if(b===0)return P(0);const I=new L.Socket;I.once("connect",()=>(_(I),A(R+m,b-1,m,P))),I.once("data",()=>{}),I.once("error",S=>(_(I),S.code!=="ECONNREFUSED"?A(R+m,b-1,m,P):P(R))),I.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,b,m,P="127.0.0.1"){let I=!1,S,u=1;const f=L.createServer({pauseOnConnect:!0});function v(E,c){I||(I=!0,f.removeAllListeners(),f.close(),S&&clearTimeout(S),c(E))}return new Promise(E=>{S=setTimeout(()=>{v(0,E)},m),f.on("listening",()=>{v(R,E)}),f.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&u<b?(R++,u++,f.listen(R,P)):v(0,E)}),f.on("close",()=>{v(0,E)}),f.listen(R,P)})}e.findFreePortFaster=T;function _(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(le[134],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(O){return!!O.parentPort}e.isUtilityProcess=L}),define(le[135],ue([13,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],ue([0,1,135]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.getDurationString=e.fromNow=void 0;const O=60,A=O*60,T=A*24,_=T*7,R=T*30,b=T*365;function m(S,u,f,v){typeof S!="number"&&(S=S.getTime());const E=Math.round((new Date().getTime()-S)/1e3);if(E<-30)return(0,L.localize)(0,null,m(new Date().getTime()+E*1e3,!1));if(!v&&E<30)return(0,L.localize)(1,null);let c;return E<O?(c=E,u?c===1?f?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):f?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?f?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):f?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):E<A?(c=Math.floor(E/O),u?c===1?f?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):f?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?f?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):f?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):E<T?(c=Math.floor(E/A),u?c===1?f?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):f?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?f?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):f?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):E<_?(c=Math.floor(E/T),u?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):E<R?(c=Math.floor(E/_),u?c===1?f?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):f?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?f?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):f?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):E<b?(c=Math.floor(E/R),u?c===1?f?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):f?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?f?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):f?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(E/b),u?c===1?f?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):f?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?f?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):f?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=m;function P(S,u){const f=Math.abs(S/1e3);return f<1?u?(0,L.localize)(54,null,S):(0,L.localize)(55,null,S):f<O?u?(0,L.localize)(56,null,Math.round(S)/1e3):(0,L.localize)(57,null,Math.round(S)/1e3):f<A?u?(0,L.localize)(58,null,Math.round(S/(1e3*O))):(0,L.localize)(59,null,Math.round(S/(1e3*O))):f<T?u?(0,L.localize)(60,null,Math.round(S/(1e3*A))):(0,L.localize)(61,null,Math.round(S/(1e3*A))):(0,L.localize)(62,null,Math.round(S/(1e3*T)))}e.getDurationString=P;function I(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(le[136],ue([13,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],ue([0,1,17,12,136]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(I,S){return S&&(I.stack||I.stacktrace)?A.localize(0,null,R(I),_(I.stack)||_(I.stacktrace)):R(I)}function _(I){return Array.isArray(I)?I.join(`
`):I}function R(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?A.localize(1,null,I.message):I.message||A.localize(2,null)}function b(I=null,S=!1){if(!I)return A.localize(3,null);if(Array.isArray(I)){const u=L.coalesce(I),f=b(u[0],S);return u.length>1?A.localize(4,null,f,u.length):f}if(O.isString(I))return I;if(I.detail){const u=I.detail;if(u.error)return T(u.error,S);if(u.exception)return T(u.exception,S)}return I.stack?T(I,S):I.message?I.message:A.localize(5,null)}e.toErrorMessage=b;function m(I){const S=I;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=m;function P(I,S){let u;return typeof I=="string"?u=new Error(I):u=I,u.actions=S,u}e.createErrorWithActions=P}),define(le[137],ue([13,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],ue([0,1,137]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(A){switch(A){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(le[139],ue([13,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],ue([0,1,139]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,A=!1,T=!1,_=!1,R=!1,b=!1,m=!1,P=!1,I=!1,S=!1,u,f=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,E,c;const d=globalThis;let g;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?g=d.vscode.process:typeof process<"u"&&(g=process);const l=typeof g?.versions?.electron=="string",w=l&&g?.type==="renderer";if(typeof g=="object"){O=g.platform==="win32",A=g.platform==="darwin",T=g.platform==="linux",_=T&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,m=l,I=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const h=g.env.VSCODE_NLS_CONFIG;if(h)try{const y=JSON.parse(h),D=y.availableLanguages["*"];u=y.locale,v=y.osLocale,f=D||e.LANGUAGE_DEFAULT,E=y._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!w?(c=navigator.userAgent,O=c.indexOf("Windows")>=0,A=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=c.indexOf("Linux")>=0,S=c?.indexOf("Mobi")>=0,b=!0,u=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,f=u,v=navigator.language):console.error("Unable to resolve platform.");var i;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let n=0;A?n=1:O?n=3:T&&(n=2),e.isWindows=O,e.isMacintosh=A,e.isLinux=T,e.isLinuxSnap=_,e.isNative=R,e.isElectron=m,e.isWeb=b,e.isWebWorker=b&&typeof d.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?d.origin:void 0,e.isIOS=P,e.isMobile=S,e.isCI=I,e.platform=n,e.userAgent=c,e.language=f;var s;(function(h){function y(){return e.language}h.value=y;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=D;function U(){return e.language==="en"}h.isDefault=U})(s||(e.Language=s={})),e.locale=u,e.platformLocale=v,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];d.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let U=0,M=h.length;U<M;U++){const F=h[U];if(F.id===D.data.vscodeScheduleAsyncWork){h.splice(U,1),F.callback();return}}});let y=0;return D=>{const U=++y;h.push({id:U,callback:D}),d.postMessage({vscodeScheduleAsyncWork:U},"*")}}return h=>setTimeout(h)})();var t;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=A||P?2:O?1:3;let r=!0,a=!1;function C(){if(!a){a=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,r=new Uint16Array(h.buffer)[0]===513}return r}e.isLittleEndian=C,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function p(h){return parseFloat(h)>=20}e.isBigSurOrNewer=p}),define(le[36],ue([0,1,5]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const T=A.process;O={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(le[140],ue([0,1,36]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=void 0;var O;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(O||(O={}));const A="XDG_CURRENT_DESKTOP",T="KDE_SESSION_VERSION";function _(){const R=L.env[A];if(R){const m=R.split(":").map(P=>P.trim()).filter(P=>P.length>0);for(const P of m)switch(P){case"Unity":{const I=L.env.DESKTOP_SESSION;return I&&I.includes("gnome-fallback")?O.GNOME:O.UNITY}case"Deepin":return O.DEEPIN;case"GNOME":return O.GNOME;case"X-Cinnamon":return O.CINNAMON;case"KDE":{const I=L.env[T];return I==="5"?O.KDE5:I==="6"?O.KDE6:O.KDE4}case"Pantheon":return O.PANTHEON;case"XFCE":return O.XFCE;case"UKUI":return O.UKUI;case"LXQt":return O.LXQT}}const b=L.env.DESKTOP_SESSION;if(b)switch(b){case"deepin":return O.DEEPIN;case"gnome":case"mate":return O.GNOME;case"kde4":case"kde-plasma":return O.KDE4;case"kde":return T in L.env?O.KDE4:O.KDE3;case"xfce":case"xubuntu":return O.XFCE;case"ukui":return O.UKUI}return"GNOME_DESKTOP_SESSION_ID"in L.env?O.GNOME:"KDE_FULL_SESSION"in L.env?T in L.env?O.KDE4:O.KDE3:O.UNKNOWN}e.getDesktopEnvironment=_}),define(le[16],ue([0,1,36]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,A=97,T=90,_=122,R=46,b=47,m=92,P=58,I=63;class S extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,o){if(i===null||typeof i!="object")throw new S(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new S(o,"string",i)}const v=L.platform==="win32";function E(i){return i===b||i===m}function c(i){return i===b}function d(i){return i>=O&&i<=T||i>=A&&i<=_}function g(i,o,n,s){let t="",r=0,a=-1,C=0,p=0;for(let h=0;h<=i.length;++h){if(h<i.length)p=i.charCodeAt(h);else{if(s(p))break;p=b}if(s(p)){if(!(a===h-1||C===1))if(C===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const y=t.lastIndexOf(n);y===-1?(t="",r=0):(t=t.slice(0,y),r=t.length-1-t.lastIndexOf(n)),a=h,C=0;continue}else if(t.length!==0){t="",r=0,a=h,C=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,h)}`:t=i.slice(a+1,h),r=h-a-1;a=h,C=0}else p===R&&C!==-1?++C:C=-1}return t}function l(i,o){u(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.win32={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],f(r,"path"),r.length===0)continue}else o.length===0?r=L.cwd():(r=L.env[`=${o}`]||L.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let C=0,p="",h=!1;const y=r.charCodeAt(0);if(a===1)E(y)&&(C=1,h=!0);else if(E(y))if(h=!0,E(r.charCodeAt(1))){let D=2,U=D;for(;D<a&&!E(r.charCodeAt(D));)D++;if(D<a&&D!==U){const M=r.slice(U,D);for(U=D;D<a&&E(r.charCodeAt(D));)D++;if(D<a&&D!==U){for(U=D;D<a&&!E(r.charCodeAt(D));)D++;(D===a||D!==U)&&(p=`\\\\${M}\\${r.slice(U,D)}`,C=D)}}}else C=1;else d(y)&&r.charCodeAt(1)===P&&(p=r.slice(0,2),C=2,a>2&&E(r.charCodeAt(2))&&(h=!0,C=3));if(p.length>0)if(o.length>0){if(p.toLowerCase()!==o.toLowerCase())continue}else o=p;if(s){if(o.length>0)break}else if(n=`${r.slice(C)}\\${n}`,s=h,h&&o.length>0)break}return n=g(n,!s,"\\",E),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return c(r)?"\\":i;if(E(r))if(t=!0,E(i.charCodeAt(1))){let C=2,p=C;for(;C<o&&!E(i.charCodeAt(C));)C++;if(C<o&&C!==p){const h=i.slice(p,C);for(p=C;C<o&&E(i.charCodeAt(C));)C++;if(C<o&&C!==p){for(p=C;C<o&&!E(i.charCodeAt(C));)C++;if(C===o)return`\\\\${h}\\${i.slice(p)}\\`;C!==p&&(s=`\\\\${h}\\${i.slice(p,C)}`,n=C)}}}else n=1;else d(r)&&i.charCodeAt(1)===P&&(s=i.slice(0,2),n=2,o>2&&E(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?g(i.slice(n),!t,"\\",E):"";return a.length===0&&!t&&(a="."),a.length>0&&E(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return E(n)||o>2&&d(n)&&i.charCodeAt(1)===P&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];f(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&E(n.charCodeAt(0))){++t;const r=n.length;r>1&&E(n.charCodeAt(1))&&(++t,r>2&&(E(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&E(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.win32.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const n=e.win32.resolve(i),s=e.win32.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===m;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===m;)r--;const a=r-t;let C=0;for(;C<o.length&&o.charCodeAt(C)===m;)C++;let p=o.length;for(;p-1>C&&o.charCodeAt(p-1)===m;)p--;const h=p-C,y=a<h?a:h;let D=-1,U=0;for(;U<y;U++){const F=i.charCodeAt(t+U);if(F!==o.charCodeAt(C+U))break;F===m&&(D=U)}if(U!==y){if(D===-1)return s}else{if(h>y){if(o.charCodeAt(C+U)===m)return s.slice(C+U+1);if(U===2)return s.slice(C+U)}a>y&&(i.charCodeAt(t+U)===m?D=U:U===2&&(D=3)),D===-1&&(D=0)}let M="";for(U=t+D+1;U<=r;++U)(U===r||i.charCodeAt(U)===m)&&(M+=M.length===0?"..":"\\..");return C+=D,M.length>0?`${M}${s.slice(C,p)}`:(s.charCodeAt(C)===m&&++C,s.slice(C,p))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const n=o.charCodeAt(2);if(n!==I&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return E(t)?i:".";if(E(t)){if(n=s=1,E(i.charCodeAt(1))){let C=2,p=C;for(;C<o&&!E(i.charCodeAt(C));)C++;if(C<o&&C!==p){for(p=C;C<o&&E(i.charCodeAt(C));)C++;if(C<o&&C!==p){for(p=C;C<o&&!E(i.charCodeAt(C));)C++;if(C===o)return i;C!==p&&(n=s=C+1)}}}}else d(t)&&i.charCodeAt(1)===P&&(n=o>2&&E(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let C=o-1;C>=s;--C)if(E(i.charCodeAt(C))){if(!a){r=C;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,C=-1;for(r=i.length-1;r>=n;--r){const p=i.charCodeAt(r);if(E(p)){if(!t){n=r+1;break}}else C===-1&&(t=!1,C=r+1),a>=0&&(p===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=C))}return n===s?s=C:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(E(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===P&&d(i.charCodeAt(0))&&(o=s=2);for(let C=i.length-1;C>=o;--C){const p=i.charCodeAt(C);if(E(p)){if(!r){s=C+1;break}continue}t===-1&&(r=!1,t=C+1),p===R?n===-1?n=C:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:l.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return E(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(E(t)){if(s=1,E(i.charCodeAt(1))){let D=2,U=D;for(;D<n&&!E(i.charCodeAt(D));)D++;if(D<n&&D!==U){for(U=D;D<n&&E(i.charCodeAt(D));)D++;if(D<n&&D!==U){for(U=D;D<n&&!E(i.charCodeAt(D));)D++;D===n?s=D:D!==U&&(s=D+1)}}}}else if(d(t)&&i.charCodeAt(1)===P){if(n<=2)return o.root=o.dir=i,o;if(s=2,E(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,C=-1,p=!0,h=i.length-1,y=0;for(;h>=s;--h){if(t=i.charCodeAt(h),E(t)){if(!p){a=h+1;break}continue}C===-1&&(p=!1,C=h+1),t===R?r===-1?r=h:y!==1&&(y=1):r!==-1&&(y=-1)}return C!==-1&&(r===-1||y===0||y===1&&r===C-1&&r===a+1?o.base=o.name=i.slice(a,C):(o.name=i.slice(a,r),o.base=i.slice(a,C),o.ext=i.slice(r,C))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(v){const i=/\\/g;return()=>{const o=L.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:w();f(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===b)}return o=g(o,!n,"/",c),n?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===b,n=i.charCodeAt(i.length-1)===b;return i=g(i,!o,"/",c),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===b},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];f(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,C=t<a?t:a;let p=-1,h=0;for(;h<C;h++){const D=i.charCodeAt(n+h);if(D!==o.charCodeAt(r+h))break;D===b&&(p=h)}if(h===C)if(a>C){if(o.charCodeAt(r+h)===b)return o.slice(r+h+1);if(h===0)return o.slice(r+h)}else t>C&&(i.charCodeAt(n+h)===b?p=h:h===0&&(p=0));let y="";for(h=n+p+1;h<=s;++h)(h===s||i.charCodeAt(h)===b)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(r+p)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===b;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===b){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,C=-1;for(r=i.length-1;r>=0;--r){const p=i.charCodeAt(r);if(p===b){if(!t){n=r+1;break}}else C===-1&&(t=!1,C=r+1),a>=0&&(p===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=C))}return n===s?s=C:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===b){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){f(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const C=i.charCodeAt(a);if(C===b){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),C===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:l.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===b;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,C=!0,p=i.length-1,h=0;for(;p>=s;--p){const y=i.charCodeAt(p);if(y===b){if(!C){r=p+1;break}continue}a===-1&&(C=!1,a=p+1),y===R?t===-1?t=p:h!==1&&(h=1):t!==-1&&(h=-1)}if(a!==-1){const y=r===0&&n?1:r;t===-1||h===0||h===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(y,a):(o.name=i.slice(y,t),o.base=i.slice(y,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(le[49],ue([0,1,16,5,27,12]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function R(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function b(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=b;function m(r,a=L.posix.sep){if(!r)return"";const C=r.length,p=r.charCodeAt(0);if(_(p)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let y=3;const D=y;for(;y<C&&!_(r.charCodeAt(y));y++);if(D!==y&&!_(r.charCodeAt(y+1))){for(y+=1;y<C;y++)if(_(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(c(p)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<C;h++)if(_(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=m;function P(r){if(!O.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let C=2;const p=C;for(;C<r.length&&(a=r.charCodeAt(C),a!==92);C++);return!(p===C||(a=r.charCodeAt(C+1),isNaN(a)||a===92))}e.isUNC=P;const I=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=O.isWindows){const C=a?I:S;return!(!r||r.length===0||/^\s+$/.test(r)||(C.lastIndex=0,C.test(r))||a&&u.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function v(r,a,C){const p=r===a;return!C||p?p:!r||!a?!1:(0,A.equalsIgnoreCase)(r,a)}e.isEqual=v;function E(r,a,C,p=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(C){if(!(0,A.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let y=a.length;return a.charAt(a.length-1)===p&&y--,r.charAt(y)===p}return a.charAt(a.length-1)!==p&&(a+=p),r.indexOf(a)===0}e.isEqualOrParent=E;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=c;function d(r,a){return O.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(a,r)),r=(0,L.normalize)(r),O.isWindows?(r=(0,A.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,A.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=d;function g(r){const a=(0,L.normalize)(r);return O.isWindows?r.length>3?!1:l(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=g;function l(r,a=O.isWindows){return a?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function w(r,a=O.isWindows){return l(r,a)?r[0]:void 0}e.getDriveLetter=w;function i(r,a,C){return a.length>r.length?-1:r===a?0:(C&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function o(r){const a=r.split(":");let C,p,h;for(const y of a){const D=Number(y);(0,T.isNumber)(D)?p===void 0?p=D:h===void 0&&(h=D):C=C?[C,y].join(":"):y}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:p!==void 0?p:void 0,column:h!==void 0?h:p!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,C=8){let p="";for(let y=0;y<C;y++){let D;y===0&&O.isWindows&&!a&&(C===3||C===4)?D=s:D=n,p+=D.charAt(Math.floor(Math.random()*D.length))}let h;return a?h=`${a}-${p}`:h=p,r?(0,L.join)(r,h):h}e.randomPath=t}),define(le[141],ue([0,1,16]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const I=(0,L.extname)(P),S=O[I.toLowerCase()];return S!==void 0?S:_(P)}e.getMediaOrTextMime=T;function _(P){const I=(0,L.extname)(P);return A[I.toLowerCase()]}e.getMediaMime=_;function R(P){for(const I in A)if(A[I]===P)return I}e.getExtensionForMimeType=R;const b=/^(.+)\/(.+?)(;.+)?$/;function m(P,I){const S=b.exec(P);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:I?void 0:P}e.normalizeMimeType=m}),define(le[90],ue([0,1,5]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O||(e.Source=O={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function T(R,...b){const m=b.reduce((S,u)=>(S[u]=!0,S),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(S=>!m[S]).forEach(S=>{for(let u=0;u<P.length;u++)if(S.search(P[u])!==-1){delete R[S];break}})}e.sanitizeProcessEnvironment=T;function _(R){R&&(delete R.DEBUG,L.isMacintosh&&delete R.DYLD_LIBRARY_PATH,L.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(le[10],ue([0,1,16,5]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,_=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(s,t){return!s&&!t?"file":s}function m(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const P="",I="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(t){return t instanceof u?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,C,p,h=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=b(t,h),this.authority=r||P,this.path=m(this.scheme,a||P),this.query=C||P,this.fragment=p||P,R(this,h))}get fsPath(){return l(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:C,query:p,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),C===void 0?C=this.path:C===null&&(C=P),p===void 0?p=this.query:p===null&&(p=P),h===void 0?h=this.fragment:h===null&&(h=P),r===this.scheme&&a===this.authority&&C===this.path&&p===this.query&&h===this.fragment?this:new E(r,a,C,p,h)}static parse(t,r=!1){const a=S.exec(t);return a?new E(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new E(P,P,P,P,P)}static file(t){let r=P;if(O.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const a=t.indexOf(I,2);a===-1?(r=t.substring(2),t=I):(r=t.substring(2,a),t=t.substring(a)||I)}return new E("file",r,t,P,P)}static from(t,r){return new E(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return O.isWindows&&t.scheme==="file"?a=u.file(L.win32.join(l(t,!0),...r)).path:a=L.posix.join(t.path,...r),t.with({path:a})}toString(t=!1){return w(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof u)return t;{const r=new E(t);return r._formatted=t.external??null,r._fsPath=t._sep===v?t.fsPath??null:null,r}}else return t}}e.URI=u;function f(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.isUriComponents=f;const v=O.isWindows?1:void 0;class E extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(t=!1){return t?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=v),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(s,t,r){let a,C=-1;for(let p=0;p<s.length;p++){const h=s.charCodeAt(p);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47||r&&h===91||r&&h===93||r&&h===58)C!==-1&&(a+=encodeURIComponent(s.substring(C,p)),C=-1),a!==void 0&&(a+=s.charAt(p));else{a===void 0&&(a=s.substr(0,p));const y=c[h];y!==void 0?(C!==-1&&(a+=encodeURIComponent(s.substring(C,p)),C=-1),a+=y):C===-1&&(C=p)}}return C!==-1&&(a+=encodeURIComponent(s.substring(C))),a!==void 0?a:s}function g(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=c[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function l(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=l;function w(s,t){const r=t?g:d;let a="",{scheme:C,authority:p,path:h,query:y,fragment:D}=s;if(C&&(a+=C,a+=":"),(p||C==="file")&&(a+=I,a+=I),p){let U=p.indexOf("@");if(U!==-1){const M=p.substr(0,U);p=p.substr(U+1),U=M.lastIndexOf(":"),U===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,U),!1,!1),a+=":",a+=r(M.substr(U+1),!1,!0)),a+="@"}p=p.toLowerCase(),U=p.lastIndexOf(":"),U===-1?a+=r(p,!1,!0):(a+=r(p.substr(0,U),!1,!0),a+=p.substr(U))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const U=h.charCodeAt(1);U>=65&&U<=90&&(h=`/${String.fromCharCode(U+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const U=h.charCodeAt(0);U>=65&&U<=90&&(h=`${String.fromCharCode(U+32)}:${h.substr(2)}`)}a+=r(h,!0,!1)}return y&&(a+="?",a+=r(y,!1,!1)),D&&(a+="#",a+=t?D:d(D,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],ue([0,1,10]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(m){const P=m;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=O;function A(m){const P=[];let I;try{const S=JSON.parse(m.arguments),u=S[S.length-1];u&&u.__$stack&&(S.pop(),I=u.__$stack),P.push(...S)}catch{P.push("Unable to log remote console arguments",m.arguments)}return{args:P,stack:I}}e.parse=A;function T(m){if(typeof m!="string")return T(A(m).stack);const P=m;if(P){const I=_(P),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(S&&S.length===4)return{uri:L.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=T;function _(m){if(!m)return m;const P=m.indexOf(`
`);return P===-1?m:m.substring(0,P)}function R(m,P){const{args:I,stack:S}=A(m),u=typeof I[0]=="string"&&I.length===1;let f=_(S);f&&(f=`(${f.trim()})`);let v=[];if(typeof I[0]=="string"?f&&u?v=[`%c[${P}] %c${I[0]} %c${f}`,b("blue"),b(""),b("grey")]:v=[`%c[${P}] %c${I[0]}`,b("blue"),b(""),...I.slice(1)]:v=[`%c[${P}]%`,b("blue"),...I],f&&!u&&v.push(f),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,v)}e.log=R;function b(m){return`color: ${m}`}}),define(le[66],ue([0,1,14,10]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(b){return JSON.stringify(b,_)}e.stringify=A;function T(b){let m=JSON.parse(b);return m=R(m),m}e.parse=T;function _(b,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:m.flags}:m}function R(b,m=0){if(!b||m>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return O.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof L.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let P=0;P<b.length;++P)b[P]=R(b[P],m+1);else for(const P in b)Object.hasOwnProperty.call(b,P)&&(b[P]=R(b[P],m+1))}return b}e.revive=R}),define(le[23],ue([0,1,7,5,27,10]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var _;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeManagedRemoteResource="vscode-managed-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeChatCodeBlock="vscode-chat-code-block",S.vscodeChatSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm",S.codeSetting="code-setting",S.codeFeature="code-feature"})(_||(e.Schemas=_={}));function R(S,u){return T.URI.isUri(S)?(0,A.equalsIgnoreCase)(S.scheme,u):(0,A.startsWithIgnoreCase)(S,u+":")}e.matchesScheme=R;function b(S,...u){return u.some(f=>R(S,f))}e.matchesSomeScheme=b,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class m{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(u){this._preferredWebSchema=u}setDelegate(u){this._delegate=u}setServerRootPath(u){this._remoteResourcesPath=`${u}/${_.vscodeRemoteResource}`}set(u,f,v){this._hosts[u]=f,this._ports[u]=v}setConnectionToken(u,f){this._connectionTokens[u]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(u){if(this._delegate)try{return this._delegate(u)}catch(g){return L.onUnexpectedError(g),u}const f=u.authority;let v=this._hosts[f];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const E=this._ports[f],c=this._connectionTokens[f];let d=`path=${encodeURIComponent(u.path)}`;return typeof c=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(c)}`),T.URI.from({scheme:O.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${v}:${E}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new m,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class P{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(u){const f=this.toUri(u,se);return this.uriToBrowserUri(f)}uriToBrowserUri(u){return u.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(u):u.scheme===_.file&&(O.isNative||O.webWorkerOrigin===`${_.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?u.with({scheme:_.vscodeFileResource,authority:u.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):u}asFileUri(u){const f=this.toUri(u,se);return this.uriToFileUri(f)}uriToFileUri(u){return u.scheme===_.vscodeFileResource?u.with({scheme:_.file,authority:u.authority!==P.FALLBACK_AUTHORITY?u.authority:null,query:null,fragment:null}):u}toUri(u,f){return T.URI.isUri(u)?u:T.URI.parse(f.toUrl(u))}}e.FileAccess=new P;var I;(function(S){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(u.get("3"));const f="vscode-coi";function v(c){let d;typeof c=="string"?d=new URL(c).searchParams:c instanceof URL?d=c.searchParams:T.URI.isUri(c)&&(d=new URL(c.toString(!0)).searchParams);const g=d?.get(f);if(g)return u.get(g)}S.getHeadersFromQuery=v;function E(c,d,g){if(!globalThis.crossOriginIsolated)return;const l=d&&g?"3":g?"2":"1";c instanceof URLSearchParams?c.set(f,l):c[f]=l}S.addSearchParam=E})(I||(e.COI=I={}))}),define(le[143],ue([0,1,124,23,5,10]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class _{constructor(S,u,f){this.id=S,this.dependencies=u,this.callback=f}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(S,u,f)=>{typeof S!="string"&&(f=u,u=S,S=null),(typeof u!="object"||!Array.isArray(u))&&(f=u,u=null),this._defineCalls.push(new _(S,u,f))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){if(S.startsWith(window.location.origin)||S.startsWith("vscode-file://vscode-app"))return S;throw new Error(`[trusted_script_src] Invalid script url: ${S}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(S){return S}})))}async load(S){this._initialize();const u=await(this._isWebWorker?this._workerLoadScript(S):this._isRenderer?this._rendererLoadScript(S):this._nodeJSLoadScript(S));if(!u)throw new Error(`Did not receive a define call from script ${S}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${S}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}_rendererLoadScript(S){return new Promise((u,f)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const E=()=>{v.removeEventListener("load",c),v.removeEventListener("error",d)},c=g=>{E(),u(this._defineCalls.pop())},d=g=>{E(),f(g)};v.addEventListener("load",c),v.addEventListener("error",d),this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),v.setAttribute("src",S),window.document.getElementsByTagName("head")[0].appendChild(v)})}_workerLoadScript(S){return new Promise((u,f)=>{try{this._amdPolicy&&(S=this._amdPolicy.createScriptURL(S)),importScripts(S),u(this._defineCalls.pop())}catch(v){f(v)}})}async _nodeJSLoadScript(S){try{const u=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,E=T.URI.parse(S).fsPath,c=u.readFileSync(E).toString(),d=v.wrap(c.replace(/^#!.*/,""));return new f.Script(d).runInThisContext().apply(),this._defineCalls.pop()}catch(u){throw u}}}const b=new Map;let m={};typeof globalThis.require=="object"&&(m=globalThis.require.paths??{});async function P(I,S,u){if(L.isESM){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),m[I]&&(I=m[I]);const f=`${I}/${S}`;if(b.has(f))return b.get(f);let v;if(/^\w[\w\d+.-]*:\/\//.test(f))v=f;else{const g=`${u&&!A.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${f}`;v=O.FileAccess.asBrowserUri(g).toString(!0)}const E=R.INSTANCE.load(v);return b.set(f,E),E}else return await new Promise((f,v)=>{se([I],f,v)})}e.importAMDNodeModule=P}),define(le[20],ue([0,1,49,23,16,5,27,10]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(u){return(0,R.uriToFsPath)(u,!0)}e.originalFSPath=b;class m{constructor(f){this._ignorePathCasing=f}compare(f,v,E=!1){return f===v?0:(0,_.compare)(this.getComparisonKey(f,E),this.getComparisonKey(v,E))}isEqual(f,v,E=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,E)===this.getComparisonKey(v,E)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,E=!1){if(f.scheme===v.scheme){if(f.scheme===O.Schemas.file)return L.isEqualOrParent(b(f),b(v),this._ignorePathCasing(f))&&f.query===v.query&&(E||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return L.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(E||f.fragment===v.fragment)}return!1}joinPath(f,...v){return R.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return A.posix.basename(f.path)}extname(f){return A.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===O.Schemas.file?v=R.URI.file(A.dirname(b(f))).path:(v=A.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===O.Schemas.file?v=R.URI.file(A.normalize(b(f))).path:v=A.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===O.Schemas.file){const d=A.relative(b(f),b(v));return T.isWindows?L.toSlashes(d):d}let E=f.path||"/";const c=v.path||"/";if(this._ignorePathCasing(f)){let d=0;for(const g=Math.min(E.length,c.length);d<g&&!(E.charCodeAt(d)!==c.charCodeAt(d)&&E.charAt(d).toLowerCase()!==c.charAt(d).toLowerCase());d++);E=c.substr(0,d)+E.substr(d)}return A.posix.relative(E,c)}resolvePath(f,v){if(f.scheme===O.Schemas.file){const E=R.URI.file(A.resolve(b(f),v));return f.with({authority:E.authority,path:E.path})}return v=L.toPosixPath(v),f.with({path:A.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,_.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=A.sep){if(f.scheme===O.Schemas.file){const E=b(f);return E.length>L.getRoot(E).length&&E[E.length-1]===v}else{const E=f.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=A.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=A.sep){let E=!1;if(f.scheme===O.Schemas.file){const c=b(f);E=c!==void 0&&c.length===L.getRoot(c).length&&c[c.length-1]===v}else{v="/";const c=f.path;E=c.length===1&&c.charCodeAt(c.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(u=>u.scheme===O.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new m(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(u,f){const v=[];for(let E=0;E<u.length;E++){const c=f(u[E]);u.some((d,g)=>g===E?!1:(0,e.isEqualOrParent)(c,f(d)))||v.push(u[E])}return v}e.distinctParents=P;var I;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function f(v){const E=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(g=>{const[l,w]=g.split(":");l&&w&&E.set(l,w)});const d=v.path.substring(0,v.path.indexOf(";"));return d&&E.set(u.META_DATA_MIME,d),E}u.parseMetaData=f})(I||(e.DataUri=I={}));function S(u,f,v){if(f){let E=u.path;return E&&E[0]!==A.posix.sep&&(E=A.posix.sep+E),u.with({scheme:v,authority:f,path:E})}return u.with({scheme:v})}e.toLocalResource=S}),define(le[6],ue([0,1,26,7,3,2,20,5,130,53]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(ie){return!!ie&&typeof ie.then=="function"}e.isThenable=P;function I(ie){const H=new L.CancellationTokenSource,ne=ie(H.token),ce=new Promise((de,fe)=>{const Se=H.token.onCancellationRequested(()=>{Se.dispose(),fe(new O.CancellationError)});Promise.resolve(ne).then(Ce=>{Se.dispose(),H.dispose(),de(Ce)},Ce=>{Se.dispose(),H.dispose(),fe(Ce)})});return new class{cancel(){H.cancel(),H.dispose()}then(de,fe){return ce.then(de,fe)}catch(de){return this.then(void 0,de)}finally(de){return ce.finally(de)}}}e.createCancelablePromise=I;function S(ie,H,ne){return new Promise((ce,de)=>{const fe=H.onCancellationRequested(()=>{fe.dispose(),ce(ne)});ie.then(ce,de).finally(()=>fe.dispose())})}e.raceCancellation=S;function u(ie,H){return new Promise((ne,ce)=>{const de=H.onCancellationRequested(()=>{de.dispose(),ce(new O.CancellationError)});ie.then(ne,ce).finally(()=>de.dispose())})}e.raceCancellationError=u;async function f(ie){let H=-1;const ne=ie.map((ce,de)=>ce.then(fe=>(H=de,fe)));try{return await Promise.race(ne)}finally{ie.forEach((ce,de)=>{de!==H&&ce.cancel()})}}e.raceCancellablePromises=f;function v(ie,H,ne){let ce;const de=setTimeout(()=>{ce?.(void 0),ne?.()},H);return Promise.race([ie.finally(()=>clearTimeout(de)),new Promise(fe=>ce=fe)])}e.raceTimeout=v;function E(ie){return new Promise((H,ne)=>{const ce=ie();P(ce)?ce.then(H,ne):H(ce)})}e.asPromise=E;function c(){let ie,H;return{promise:new Promise((ce,de)=>{ie=ce,H=de}),resolve:ie,reject:H}}e.promiseWithResolvers=c;class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const ne=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ce=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ce};this.queuedPromise=new Promise(ce=>{this.activePromise.then(ne,ne).then(ce)})}return new Promise((ne,ce)=>{this.queuedPromise.then(ne,ce)})}return this.activePromise=H(),new Promise((ne,ce)=>{this.activePromise.then(de=>{this.activePromise=null,ne(de)},de=>{this.activePromise=null,ce(de)})})}dispose(){this.isDisposed=!0}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=g;class l{constructor(){this.promiseMap=new Map}queue(H,ne){const de=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(H)===de&&this.promiseMap.delete(H)});return this.promiseMap.set(H,de),de}}e.SequencerByKey=l;const w=(ie,H)=>{let ne=!0;const ce=setTimeout(()=>{ne=!1,H()},ie);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(ce),ne=!1}}},i=ie=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,ie())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class o{constructor(H){this.defaultDelay=H,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,ne=this.defaultDelay){this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((de,fe)=>{this.doResolve=de,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const de=this.task;return this.task=null,de()}}));const ce=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ne===b.MicrotaskDelay?i(ce):w(ne,ce),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class n{constructor(H){this.delayer=new o(H),this.throttler=new d}trigger(H,ne){return this.delayer.trigger(()=>this.throttler.queue(H),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this._isOpen=!1,this._promise=new Promise((H,ne)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class t extends s{constructor(H){super(),this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function r(ie,H){return H?new Promise((ne,ce)=>{const de=setTimeout(()=>{fe.dispose(),ne()},ie),fe=H.onCancellationRequested(()=>{clearTimeout(de),fe.dispose(),ce(new O.CancellationError)})}):I(ne=>r(ie,ne))}e.timeout=r;function a(ie,H=0,ne){const ce=setTimeout(()=>{ie(),ne&&de.dispose()},H),de=(0,T.toDisposable)(()=>{clearTimeout(ce),ne?.deleteAndLeak(de)});return ne?.add(de),de}e.disposableTimeout=a;function C(ie){const H=[];let ne=0;const ce=ie.length;function de(){return ne<ce?ie[ne++]():null}function fe(Se){Se!=null&&H.push(Se);const Ce=de();return Ce?Ce.then(fe):Promise.resolve(H)}return Promise.resolve(null).then(fe)}e.sequence=C;function p(ie,H=ce=>!!ce,ne=null){let ce=0;const de=ie.length,fe=()=>{if(ce>=de)return Promise.resolve(ne);const Se=ie[ce++];return Promise.resolve(Se()).then(Re=>H(Re)?Promise.resolve(Re):fe())};return fe()}e.first=p;function h(ie,H=ce=>!!ce,ne=null){if(ie.length===0)return Promise.resolve(ne);let ce=ie.length;const de=()=>{ce=-1;for(const fe of ie)fe.cancel?.()};return new Promise((fe,Se)=>{for(const Ce of ie)Ce.then(Re=>{--ce>=0&&H(Re)?(de(),fe(Re)):ce===0&&fe(ne)}).catch(Re=>{--ce>=0&&(de(),Se(Re))})})}e.firstParallel=h;class y{constructor(H){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new A.Emitter}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(H){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ne,ce)=>{this.outstandingPromises.push({factory:H,c:ne,e:ce}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const ne=H.factory();ne.then(H.c,H.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=y;class D extends y{constructor(){super(1)}}e.Queue=D;class U{constructor(){this.sequentializer=new te,this.tasks=0}queue(H){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,H())):this.sequentializer.run(this.tasks++,H())}}e.LimitedQueue=U;class M{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const H=new ae;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueSize(H,ne=_.extUri){const ce=ne.getComparisonKey(H);return this.queues.get(ce)?.size??0}queueFor(H,ne,ce=_.extUri){const de=ce.getComparisonKey(H);let fe=this.queues.get(de);if(!fe){fe=new D;const Se=this.drainListenerCount++,Ce=A.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.queues.delete(de),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Se),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new T.DisposableMap),this.drainListeners.set(Se,Ce),this.queues.set(de,fe)}return fe.queue(ne)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=M;class F{constructor(H,ne){this._token=-1,typeof H=="function"&&typeof ne=="number"&&this.setIfNotSet(H,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},ne)}setIfNotSet(H,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},ne))}}e.TimeoutTimer=F;class z{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(H,ne,ce=globalThis){this.cancel();const de=ce.setInterval(()=>{H()},ne);this.disposable=(0,T.toDisposable)(()=>{ce.clearInterval(de),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=z;class X{constructor(H,ne){this.timeoutToken=-1,this.runner=H,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=X;class K{constructor(H,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class Q extends X{constructor(H,ne){super(H,ne),this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner?.(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class V extends T.Disposable{constructor(H,ne){super(),this.options=H,this.handler=ne,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.options.maxBufferedWork)return!1}else if(this.pending+H.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ne of H)this.pendingWork.push(ne);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new X(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ie,H)=>{(0,R.setTimeout0)(()=>{if(ne)return;const ce=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e._runWhenIdle=(ie,H,ne)=>{const ce=ie.requestIdleCallback(H,typeof ne=="number"?{timeout:ne}:void 0);let de=!1;return{dispose(){de||(de=!0,ie.cancelIdleCallback(ce))}}},e.runWhenGlobalIdle=ie=>(0,e._runWhenIdle)(globalThis,ie)}();class Y{constructor(H,ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(ce){this._error=ce}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(H,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=Y;class x extends Y{constructor(H){super(globalThis,H)}}e.GlobalIdleValue=x;async function q(ie,H,ne){let ce;for(let de=0;de<ne;de++)try{return await ie()}catch(fe){ce=fe,await r(H)}throw ce}e.retry=q;class te{isRunning(H){return typeof H=="number"?this._running?.taskId===H:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(H,ne,ce){return this._running={taskId:H,cancel:()=>ce?.(),promise:ne},ne.then(()=>this.doneRunning(H),()=>this.doneRunning(H)),ne}doneRunning(H){this._running&&H===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const H=this._queued;this._queued=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this._queued)this._queued.run=H;else{const{promise:ne,resolve:ce,reject:de}=c();this._queued={run:H,promise:ne,promiseResolve:ce,promiseReject:de}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=te;class oe{constructor(H,ne=()=>Date.now()){this.interval=H,this.nowFn=ne,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;var ee;(function(ie){ie[ie.Resolved=0]="Resolved",ie[ie.Rejected=1]="Rejected"})(ee||(ee={}));class ae{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((H,ne)=>{this.completeCallback=H,this.errorCallback=ne})}complete(H){return new Promise(ne=>{this.completeCallback(H),this.outcome={outcome:0,value:H},ne()})}error(H){return new Promise(ne=>{this.errorCallback(H),this.outcome={outcome:1,value:H},ne()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=ae;var B;(function(ie){async function H(ce){let de;const fe=await Promise.all(ce.map(Se=>Se.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de<"u")throw de;return fe}ie.settled=H;function ne(ce){return new Promise(async(de,fe)=>{try{await ce(de,fe)}catch(Se){fe(Se)}})}ie.withAsyncBody=ne})(B||(e.Promises=B={}));class W{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(H){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=H.then(ne=>(this._value=ne,this._isResolved=!0,ne),ne=>{throw this._error=ne,this._isResolved=!0,ne})}requireValue(){if(!this._isResolved)throw new O.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=W;class k{constructor(H){this._compute=H,this._promise=new m.Lazy(()=>new W(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=k;var N;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(N||(N={}));class j{static fromArray(H){return new j(ne=>{ne.emitMany(H)})}static fromPromise(H){return new j(async ne=>{ne.emitMany(await H)})}static fromPromises(H){return new j(async ne=>{await Promise.all(H.map(async ce=>ne.emitOne(await ce)))})}static merge(H){return new j(async ne=>{await Promise.all(H.map(async ce=>{for await(const de of ce)ne.emitOne(de)}))})}static{this.EMPTY=j.fromArray([])}constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new A.Emitter,queueMicrotask(async()=>{const ne={emitOne:ce=>this.emitOne(ce),emitMany:ce=>this.emitMany(ce),reject:ce=>this.reject(ce)};try{await Promise.resolve(H(ne)),this.resolve()}catch(ce){this.reject(ce)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await A.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,ne){return new j(async ce=>{for await(const de of H)ce.emitOne(ne(de))})}map(H){return j.map(this,H)}static filter(H,ne){return new j(async ce=>{for await(const de of H)ne(de)&&ce.emitOne(de)})}filter(H){return j.filter(this,H)}static coalesce(H){return j.filter(H,ne=>!!ne)}coalesce(){return j.coalesce(this)}static async toPromise(H){const ne=[];for await(const ce of H)ne.push(ce);return ne}toPromise(){return j.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}e.AsyncIterableObject=j;class $ extends j{constructor(H,ne){super(ne),this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=$;function J(ie){const H=new L.CancellationTokenSource,ne=ie(H.token);return new $(H,async ce=>{const de=H.token.onCancellationRequested(()=>{de.dispose(),H.dispose(),ce.reject(new O.CancellationError)});try{for await(const fe of ne){if(H.token.isCancellationRequested)return;ce.emitOne(fe)}de.dispose(),H.dispose()}catch(fe){de.dispose(),H.dispose(),ce.reject(fe)}})}e.createCancelableAsyncIterable=J;class Z{constructor(){this._deferred=new ae,this._asyncIterable=new j(ce=>{if(H){ce.reject(H);return}return ne&&ce.emitMany(ne),this._errorFn=de=>ce.reject(de),this._emitFn=de=>ce.emitOne(de),this._deferred.p});let H,ne;this._emitFn=ce=>{ne||(ne=[]),ne.push(ce)},this._errorFn=ce=>{H||(H=ce)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(H){this._errorFn(H),this._deferred.complete()}emitOne(H){this._emitFn(H)}}e.AsyncIterableSource=Z}),define(le[91],ue([0,1,17,6,49,35,16,5,27]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",I="[^/\\\\]",S=/\//g;function u(Y,x){switch(Y){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}${x?`|${P}${I}+`:""})*?`}}function f(Y,x){if(!Y)return[];const q=[];let te=!1,oe=!1,ee="";for(const ae of Y){switch(ae){case x:if(!te&&!oe){q.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ee+=ae}return ee&&q.push(ee),q}e.splitGlobAware=f;function v(Y){if(!Y)return"";let x="";const q=f(Y,e.GLOB_SPLIT);if(q.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;q.forEach((oe,ee)=>{if(oe===e.GLOBSTAR){if(te)return;x+=u(2,ee===q.length-1)}else{let ae=!1,B="",W=!1,k="";for(const N of oe){if(N!=="}"&&ae){B+=N;continue}if(W&&(N!=="]"||!k)){let j;N==="-"?j=N:(N==="^"||N==="!")&&!k?j="^":N===e.GLOB_SPLIT?j="":j=(0,b.escapeRegExpCharacters)(N),k+=j;continue}switch(N){case"{":ae=!0;continue;case"[":W=!0;continue;case"}":{const $=`(?:${f(B,",").map(J=>v(J)).join("|")})`;x+=$,ae=!1,B="";break}case"]":{x+="["+k+"]",W=!1,k="";break}case"?":x+=I;continue;case"*":x+=u(1);continue;default:x+=(0,b.escapeRegExpCharacters)(N)}}ee<q.length-1&&(q[ee+1]!==e.GLOBSTAR||ee+2<q.length)&&(x+=P)}te=oe===e.GLOBSTAR})}return x}const E=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.LRUCache(1e4),o=function(){return!1},n=function(){return null};function s(Y,x){if(!Y)return n;let q;typeof Y!="string"?q=Y.pattern:q=Y,q=q.trim();const te=`${q}_${!!x.trimForExclusions}`;let oe=i.get(te);if(oe)return t(oe,Y);let ee;return E.test(q)?oe=a(q.substr(4),q):(ee=c.exec(r(q,x)))?oe=C(ee[1],q):(x.trimForExclusions?g:d).test(q)?oe=p(q,x):(ee=l.exec(r(q,x)))?oe=h(ee[1].substr(1),q,!0):(ee=w.exec(r(q,x)))?oe=h(ee[1],q,!1):oe=y(q),i.set(te,oe),t(oe,Y)}function t(Y,x){if(typeof x=="string")return Y;const q=function(te,oe){return(0,A.isEqualOrParent)(te,x.base,!R.isLinux)?Y((0,b.ltrim)(te.substr(x.base.length),_.sep),oe):null};return q.allBasenames=Y.allBasenames,q.allPaths=Y.allPaths,q.basenames=Y.basenames,q.patterns=Y.patterns,q}function r(Y,x){return x.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,x){return function(q,te){return typeof q=="string"&&q.endsWith(Y)?x:null}}function C(Y,x){const q=`/${Y}`,te=`\\${Y}`,oe=function(ae,B){return typeof ae!="string"?null:B?B===Y?x:null:ae===Y||ae.endsWith(q)||ae.endsWith(te)?x:null},ee=[Y];return oe.basenames=ee,oe.patterns=[x],oe.allBasenames=ee,oe}function p(Y,x){const q=Q(Y.slice(1,-1).split(",").map(B=>s(B,x)).filter(B=>B!==n),Y),te=q.length;if(!te)return n;if(te===1)return q[0];const oe=function(B,W){for(let k=0,N=q.length;k<N;k++)if(q[k](B,W))return Y;return null},ee=q.find(B=>!!B.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=q.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return ae.length&&(oe.allPaths=ae),oe}function h(Y,x,q){const te=_.sep===_.posix.sep,oe=te?Y:Y.replace(S,_.sep),ee=_.sep+oe,ae=_.posix.sep+Y;let B;return q?B=function(W,k){return typeof W=="string"&&(W===oe||W.endsWith(ee)||!te&&(W===Y||W.endsWith(ae)))?x:null}:B=function(W,k){return typeof W=="string"&&(W===oe||!te&&W===Y)?x:null},B.allPaths=[(q?"*/":"./")+Y],B}function y(Y){try{const x=new RegExp(`^${v(Y)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?Y:null}}catch{return n}}function D(Y,x,q){return!Y||typeof x!="string"?!1:U(Y)(x,void 0,q)}e.match=D;function U(Y,x={}){if(!Y)return o;if(typeof Y=="string"||M(Y)){const q=s(Y,x);if(q===n)return o;const te=function(oe,ee){return!!q(oe,ee)};return q.allBasenames&&(te.allBasenames=q.allBasenames),q.allPaths&&(te.allPaths=q.allPaths),te}return X(Y,x)}e.parse=U;function M(Y){const x=Y;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=M;function F(Y){return Y.allBasenames||[]}e.getBasenameTerms=F;function z(Y){return Y.allPaths||[]}e.getPathTerms=z;function X(Y,x){const q=Q(Object.getOwnPropertyNames(Y).map(B=>K(B,Y[B],x)).filter(B=>B!==n)),te=q.length;if(!te)return n;if(!q.some(B=>!!B.requiresSiblings)){if(te===1)return q[0];const B=function(N,j){let $;for(let J=0,Z=q.length;J<Z;J++){const ie=q[J](N,j);if(typeof ie=="string")return ie;(0,O.isThenable)(ie)&&($||($=[]),$.push(ie))}return $?(async()=>{for(const J of $){const Z=await J;if(typeof Z=="string")return Z}return null})():null},W=q.find(N=>!!N.allBasenames);W&&(B.allBasenames=W.allBasenames);const k=q.reduce((N,j)=>j.allPaths?N.concat(j.allPaths):N,[]);return k.length&&(B.allPaths=k),B}const oe=function(B,W,k){let N,j;for(let $=0,J=q.length;$<J;$++){const Z=q[$];Z.requiresSiblings&&k&&(W||(W=(0,_.basename)(B)),N||(N=W.substr(0,W.length-(0,_.extname)(B).length)));const ie=Z(B,W,N,k);if(typeof ie=="string")return ie;(0,O.isThenable)(ie)&&(j||(j=[]),j.push(ie))}return j?(async()=>{for(const $ of j){const J=await $;if(typeof J=="string")return J}return null})():null},ee=q.find(B=>!!B.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=q.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return ae.length&&(oe.allPaths=ae),oe}function K(Y,x,q){if(x===!1)return n;const te=s(Y,q);if(te===n)return n;if(typeof x=="boolean")return te;if(x){const oe=x.when;if(typeof oe=="string"){const ee=(ae,B,W,k)=>{if(!k||!te(ae,B))return null;const N=oe.replace("$(basename)",()=>W),j=k(N);return(0,O.isThenable)(j)?j.then($=>$?Y:null):j?Y:null};return ee.requiresSiblings=!0,ee}}return te}function Q(Y,x){const q=Y.filter(B=>!!B.basenames);if(q.length<2)return Y;const te=q.reduce((B,W)=>{const k=W.basenames;return k?B.concat(k):B},[]);let oe;if(x){oe=[];for(let B=0,W=te.length;B<W;B++)oe.push(x)}else oe=q.reduce((B,W)=>{const k=W.patterns;return k?B.concat(k):B},[]);const ee=function(B,W){if(typeof B!="string")return null;if(!W){let N;for(N=B.length;N>0;N--){const j=B.charCodeAt(N-1);if(j===47||j===92)break}W=B.substr(N)}const k=te.indexOf(W);return k!==-1?oe[k]:null};ee.basenames=te,ee.patterns=oe,ee.allBasenames=te;const ae=Y.filter(B=>!B.basenames);return ae.push(ee),ae}function V(Y,x){return(0,L.equals)(Y,x,(q,te)=>typeof q=="string"&&typeof te=="string"?q===te:typeof q!="string"&&typeof te!="string"?q.base===te.base&&q.pattern===te.pattern:!1)}e.patternsEquals=V}),define(le[92],ue([0,1,14,10]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(I){return I.toJSON()}class T{constructor(S){this._uriTransformer=S}transformIncoming(S){const u=this._uriTransformer.transformIncoming(S);return u===S?S:A(O.URI.from(u))}transformOutgoing(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:A(O.URI.from(u))}transformOutgoingURI(S){const u=this._uriTransformer.transformOutgoing(S);return u===S?S:O.URI.from(u)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function _(I,S,u){if(!I||u>200)return null;if(typeof I=="object"){if(I instanceof O.URI)return S.transformOutgoing(I);for(const f in I)if(Object.hasOwnProperty.call(I,f)){const v=_(I[f],S,u+1);v!==null&&(I[f]=v)}}return null}function R(I,S){const u=_(I,S,0);return u===null?I:u}e.transformOutgoingURIs=R;function b(I,S,u,f){if(!I||f>200)return null;if(typeof I=="object"){if(I.$mid===1)return u?O.URI.revive(S.transformIncoming(I)):S.transformIncoming(I);if(I instanceof L.VSBuffer)return null;for(const v in I)if(Object.hasOwnProperty.call(I,v)){const E=b(I[v],S,u,f+1);E!==null&&(I[v]=E)}}return null}function m(I,S){const u=b(I,S,!1,0);return u===null?I:u}e.transformIncomingURIs=m;function P(I,S){const u=b(I,S,!0,0);return u===null?I:u}e.transformAndReviveIncomingURIs=P}),define(le[144],ue([0,1,37,48,32,131,5]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,u=0;const f=(0,L.networkInterfaces)();for(const v in f){const E=f[v];if(E)for(const{mac:c,internal:d}of E)d||(u+=1,this._isVirtualMachineMacAddress(c.toUpperCase())&&(S+=1))}this._value=u>0?S/u:0}return this._value}};let R;async function b(S){return R||(R=(async()=>await m(S)||A.generateUuid())()),R}e.getMachineId=b;async function m(S){try{const u=await new Promise((v,E)=>{se(["crypto"],v,E)}),f=(0,T.getMac)();return u.createHash("sha256").update(f,"utf8").digest("hex")}catch(u){S(u);return}}const P="Software\\Microsoft\\SQMClient";async function I(S){if(_.isWindows){const u=await new Promise((f,v)=>{se(["@vscode/windows-registry"],f,v)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(f){return S(f),""}}return""}e.getSqmMachineId=I}),define(le[145],ue([0,1,50,270,271,5]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=void 0;async function _(R){if(T.isMacintosh||T.isWindows)return;let b;for(const m of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,O.open)(m,L.constants.R_OK);break}catch{}if(!b){R("Unable to retrieve release information from known identifier paths.");return}try{const m=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),P={id:"unknown"};for await(const I of(0,A.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!I.includes("="))continue;const S=I.split("=")[0].toUpperCase().trim();if(m.has(S)){const u=I.split("=")[1].replace(/"/g,"").toLowerCase().trim();S==="ID"||S==="DISTRIB_ID"?P.id=u:S==="ID_LIKE"?P.id_like=u:(S==="VERSION_ID"||S==="DISTRIB_RELEASE")&&(P.version_id=u)}}return P}catch(m){R(m)}}e.getOSReleaseInfo=_}),define(le[31],ue([0,1,50,37,272,6,49,88,16,5,20,10]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(S||(e.RimRafMode=S={}));async function u(K,Q=S.UNLINK,V){if((0,_.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");return Q===S.UNLINK?v(K):f(K,V)}async function f(K,Q=(0,_.randomPath)((0,O.tmpdir)())){try{try{await L.promises.rename(K,Q)}catch(V){return V.code==="ENOENT"?void 0:v(K)}v(Q).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function v(K){return(0,A.promisify)(L.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function E(K){if((0,_.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function c(K,Q){return l(await(Q?d(K):(0,A.promisify)(L.readdir)(K)))}async function d(K){try{return await(0,A.promisify)(L.readdir)(K,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const Q=[],V=await c(K);for(const Y of V){let x=!1,q=!1,te=!1;try{const oe=await e.Promises.lstat((0,b.join)(K,Y));x=oe.isFile(),q=oe.isDirectory(),te=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}Q.push({name:Y,isFile:()=>x,isDirectory:()=>q,isSymbolicLink:()=>te})}return Q}function g(K){return l(L.readdirSync(K))}e.readdirSync=g;function l(K){return K.map(Q=>typeof Q=="string"?m.isMacintosh?(0,R.normalizeNFC)(Q):Q:(Q.name=m.isMacintosh?(0,R.normalizeNFC)(Q.name):Q.name,Q))}async function w(K){const Q=await c(K),V=[];for(const Y of Q)await o.existsDirectory((0,b.join)(K,Y))&&V.push(Y);return V}function i(K,Q=1e3){return new Promise(V=>{let Y=!1;const x=setInterval(()=>{Y||(Y=!0,L.access(K,q=>{Y=!1,q&&(clearInterval(x),V(void 0))}))},Q)})}e.whenDeleted=i;var o;(function(K){async function Q(x){let q;try{if(q=await e.Promises.lstat(x),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(m.isWindows&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw oe}throw te}}K.stat=Q;async function V(x){try{const{stat:q,symbolicLink:te}=await K.stat(x);return q.isFile()&&te?.dangling!==!0}catch{}return!1}K.existsFile=V;async function Y(x){try{const{stat:q,symbolicLink:te}=await K.stat(x);return q.isDirectory()&&te?.dangling!==!0}catch{}return!1}K.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const n=new T.ResourceQueue;function s(K,Q,V){return n.queueFor(I.URI.file(K),()=>{const Y=p(V);return new Promise((x,q)=>a(K,Q,Y,te=>te?q(te):x()))},P.extUriBiasedIgnorePathCase)}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function a(K,Q,V,Y){if(!t)return L.writeFile(K,Q,{mode:V.mode,flag:V.flag},Y);L.open(K,V.flag,V.mode,(x,q)=>{if(x)return Y(x);L.writeFile(q,Q,te=>{if(te)return L.close(q,()=>Y(te));L.fdatasync(q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),L.close(q,ee=>Y(ee))))})})}function C(K,Q,V){const Y=p(V);if(!t)return L.writeFileSync(K,Q,{mode:Y.mode,flag:Y.flag});const x=L.openSync(K,Y.flag,Y.mode);try{L.writeFileSync(x,Q);try{L.fdatasyncSync(x)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{L.closeSync(x)}}e.writeFileSync=C;function p(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function h(K,Q,V=6e4){if(K!==Q)try{m.isWindows&&typeof V=="number"?await y(K,Q,Date.now(),V):await(0,A.promisify)(L.rename)(K,Q)}catch(Y){if(K.toLowerCase()!==Q.toLowerCase()&&Y.code==="EXDEV"||K.endsWith("."))await D(K,Q,{preserveSymlinks:!1}),await u(K,S.MOVE);else throw Y}}async function y(K,Q,V,Y,x=0){try{return await(0,A.promisify)(L.rename)(K,Q)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-V>=Y)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${q}`),q;if(x===0){let te=!1;try{const{stat:oe}=await o.stat(Q);oe.isFile()||(te=!0)}catch{}if(te)throw q}return await(0,T.timeout)(Math.min(100,x*10)),y(K,Q,V,Y,x+1)}}async function D(K,Q,V){return M(K,Q,{root:{source:K,target:Q},options:V,handledSourcePaths:new Set})}const U=511;async function M(K,Q,V){if(V.handledSourcePaths.has(K))return;V.handledSourcePaths.add(K);const{stat:Y,symbolicLink:x}=await o.stat(K);if(x){if(V.options.preserveSymlinks)try{return await X(K,Q,V)}catch{}if(x.dangling)return}return Y.isDirectory()?F(K,Q,Y.mode&U,V):z(K,Q,Y.mode&U)}async function F(K,Q,V,Y){await e.Promises.mkdir(Q,{recursive:!0,mode:V});const x=await c(K);for(const q of x)await M((0,b.join)(K,q),(0,b.join)(Q,q),Y)}async function z(K,Q,V){await e.Promises.copyFile(K,Q),await e.Promises.chmod(Q,V)}async function X(K,Q,V){let Y=await e.Promises.readlink(K);(0,_.isEqualOrParent)(Y,V.root.source,!m.isLinux)&&(Y=(0,b.join)(V.root.target,Y.substr(V.root.source.length+1))),await e.Promises.symlink(Y,Q)}e.Promises=new class{get access(){return(0,A.promisify)(L.access)}get stat(){return(0,A.promisify)(L.stat)}get lstat(){return(0,A.promisify)(L.lstat)}get utimes(){return(0,A.promisify)(L.utimes)}get read(){return(K,Q,V,Y,x)=>new Promise((q,te)=>{L.read(K,Q,V,Y,x,(oe,ee,ae)=>oe?te(oe):q({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,A.promisify)(L.readFile)}get write(){return(K,Q,V,Y,x)=>new Promise((q,te)=>{L.write(K,Q,V,Y,x,(oe,ee,ae)=>oe?te(oe):q({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,A.promisify)(L.appendFile)}get fdatasync(){return(0,A.promisify)(L.fdatasync)}get truncate(){return(0,A.promisify)(L.truncate)}get copyFile(){return(0,A.promisify)(L.copyFile)}get open(){return(0,A.promisify)(L.open)}get close(){return(0,A.promisify)(L.close)}get symlink(){return(0,A.promisify)(L.symlink)}get readlink(){return(0,A.promisify)(L.readlink)}get chmod(){return(0,A.promisify)(L.chmod)}get mkdir(){return(0,A.promisify)(L.mkdir)}get unlink(){return(0,A.promisify)(L.unlink)}get rmdir(){return(0,A.promisify)(L.rmdir)}get realpath(){return(0,A.promisify)(L.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return w}get writeFile(){return s}get rm(){return u}get rename(){return h}get copy(){return D}}}),define(le[146],ue([0,1,50,16,5,27,31]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(S){if(A.isLinux)return S;const u=(0,O.dirname)(S);if(S===u)return S;const f=((0,O.basename)(S)||S).toLowerCase();try{const E=(0,_.readdirSync)(u).filter(c=>c.toLowerCase()===f);if(E.length===1){const c=R(u);if(c)return(0,O.join)(c,E[0])}else if(E.length>1){const c=E.indexOf(f);if(c>=0){const d=R(u);if(d)return(0,O.join)(d,E[c])}}}catch{}return null}e.realcaseSync=R;async function b(S){if(A.isLinux)return S;const u=(0,O.dirname)(S);if(S===u)return S;const f=((0,O.basename)(S)||S).toLowerCase();try{const E=(await _.Promises.readdir(u)).filter(c=>c.toLowerCase()===f);if(E.length===1){const c=await b(u);if(c)return(0,O.join)(c,E[0])}else if(E.length>1){const c=E.indexOf(f);if(c>=0){const d=await b(u);if(d)return(0,O.join)(d,E[c])}}}catch{}return null}e.realcase=b;async function m(S){try{return await _.Promises.realpath(S)}catch{const f=I(S);return await _.Promises.access(f,L.constants.R_OK),f}}e.realpath=m;function P(S){try{return L.realpathSync(S)}catch{const f=I(S);return L.accessSync(f,L.constants.R_OK),f}}e.realpathSync=P;function I(S){return(0,T.rtrim)((0,O.normalize)(S),O.sep)}}),define(le[147],ue([0,1,16,5,36,90,12,31]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function b(I=A.env){return I.comspec||"cmd.exe"}e.getWindowsShell=b;function m(I){let S=[],u=!1;const f=function(v){if(u){S.push(v);return}(!I.send(v,c=>{if(c&&console.error(c),u=!1,S.length>0){const d=S.slice(0);S=[],d.forEach(g=>f(g))}})||O.isWindows)&&(u=!0)};return{send:f}}e.createQueuedSender=m;var P;(function(I){async function S(u,f,v){if(L.isAbsolute(u))return u;if(f===void 0&&(f=A.cwd()),L.dirname(u)!=="."||(v===void 0&&_.isString(A.env.PATH)&&(v=A.env.PATH.split(L.delimiter)),v===void 0||v.length===0))return L.join(f,u);async function c(d){if(await R.Promises.exists(d)){let g;try{g=await R.Promises.stat(d)}catch(l){l.message.startsWith("EACCES")&&(g=await R.Promises.lstat(d))}return g?!g.isDirectory():!1}return!1}for(const d of v){let g;if(L.isAbsolute(d)?g=L.join(d,u):g=L.join(f,d,u),await c(g))return g;let l=g+".com";if(await c(l)||(l=g+".exe",await c(l)))return l}return L.join(f,u)}I.findExecutable=S})(P||(e.win32=P={}))}),define(le[148],ue([0,1,67,23]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(_){return new Promise((R,b)=>{let m;const P=new Map;function I(u,f,v,E,c){const d=P.get(f);if(u===_||d){const g={name:S(v),cmd:v,pid:u,ppid:f,load:E,mem:c};P.set(u,g),u===_&&(m=g),d&&(d.children||(d.children=[]),d.children.push(g),d.children.length>1&&(d.children=d.children.sort((l,w)=>l.pid-w.pid)))}}function S(u){const f=/--utility-sub-type=network/i,v=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(v.exec(u))return"electron-crash-reporter";if(E.exec(u))return"winpty-agent";if(c.exec(u))return"conpty-agent";let g=d.exec(u);if(g&&g.length===2)return g[1]==="renderer"?"window":g[1]==="utility"?f.exec(u)?"utility-network-service":"utility-process":g[1]==="extensionHost"?"extension-host":g[1];const l=/[a-zA-Z-]+\.js/g;let w="";do g=l.exec(u),g&&(w+=g+" ");while(g);return w&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${w})`:u}if(process.platform==="win32"){const u=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,v)=>{se(["@vscode/windows-process-tree"],f,v)}).then(f=>{f.getProcessList(_,v=>{if(!v){b(new Error(`Root process ${_} not found`));return}f.getProcessCpuUsage(v,E=>{const c=new Map;E.forEach(d=>{const g=u(d.commandLine||"");c.set(d.pid,{name:S(g),cmd:g,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),m=c.get(_),m?(c.forEach(d=>{const g=c.get(d.ppid);g&&(g.children||(g.children=[]),g.children.push(d))}),c.forEach(d=>{d.children&&(d.children=d.children.sort((g,l)=>g.pid-l.pid))}),R(m)):b(new Error(`Root process ${_} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let u=function(){let f=[m];const v=[];for(;f.length;){const c=f.shift();c&&(v.push(c.pid),c.children&&(f=f.concat(c.children)))}let E=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+v.join(" "),(0,L.exec)(E,{},(c,d,g)=>{if(c||g)b(c||new Error(g.toString()));else{const l=d.toString().split(`
`);for(let w=0;w<v.length;w++){const i=P.get(v[w]);i.load=parseFloat(l[w])}if(!m){b(new Error(`Root process ${_} not found`));return}R(m)}})};(0,L.exec)("which ps",{},(f,v,E)=>{if(f||E)if(process.platform!=="linux")b(f||new Error(E.toString()));else{const c=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(c,{},(d,g,l)=>{d||l?b(d||new Error(l.toString())):(T(g,I),u())})}else{const c=v.toString().trim();(0,L.exec)(`${c} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,l,w)=>{g||w&&!w.includes("screen size is bogus")?b(g||new Error(w.toString())):(T(l,I),process.platform==="linux"?u():m?R(m):b(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=A;function T(_,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=_.toString().split(`
`);for(const P of m){const I=b.exec(P.trim());I&&I.length===6&&R(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}});var Ee=this&&this.__decorate||function(se,e,L,O){var A=arguments.length,T=A<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,L):O,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(se,e,L,O);else for(var R=se.length-1;R>=0;R--)(_=se[R])&&(T=(A<3?_(T):A>3?_(e,L,T):_(e,L))||T);return A>3&&T&&Object.defineProperty(e,L,T),T};define(le[40],ue([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(se,e,L,O,A,T,_,R,b,m,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(u||(u={}));function f(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v||(v={}));function E(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(c||(c={}));function d(x){let q=0;for(let te=0;;te+=7){const oe=x.read(1);if(q|=(oe.buffer[0]&127)<<te,!(oe.buffer[0]&128))return q}}const g=n(0);function l(x,q){if(q===0){x.write(g);return}let te=0;for(let ee=q;ee!==0;ee=ee>>>7)te++;const oe=A.VSBuffer.alloc(te);for(let ee=0;q!==0;ee++)oe.buffer[ee]=q&127,q=q>>>7,q>0&&(oe.buffer[ee]|=128);x.write(oe)}class w{constructor(q){this.buffer=q,this.pos=0}read(q){const te=this.buffer.slice(this.pos,this.pos+q);return this.pos+=te.byteLength,te}}e.BufferReader=w;class i{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=i;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function n(x){const q=A.VSBuffer.alloc(1);return q.writeUInt8(x,0),q}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(x,q){if(typeof q>"u")x.write(s.Undefined);else if(typeof q=="string"){const te=A.VSBuffer.fromString(q);x.write(s.String),l(x,te.byteLength),x.write(te)}else if(t&&Buffer.isBuffer(q)){const te=A.VSBuffer.wrap(q);x.write(s.Buffer),l(x,te.byteLength),x.write(te)}else if(q instanceof A.VSBuffer)x.write(s.VSBuffer),l(x,q.byteLength),x.write(q);else if(Array.isArray(q)){x.write(s.Array),l(x,q.length);for(const te of q)r(x,te)}else if(typeof q=="number"&&(q|0)===q)x.write(s.Uint),l(x,q);else{const te=A.VSBuffer.fromString(JSON.stringify(q));x.write(s.Object),l(x,te.byteLength),x.write(te)}}e.serialize=r;function a(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(d(x)).toString();case o.Buffer:return x.read(d(x)).buffer;case o.VSBuffer:return x.read(d(x));case o.Array:{const te=d(x),oe=[];for(let ee=0;ee<te;ee++)oe.push(a(x));return oe}case o.Object:return JSON.parse(x.read(d(x)).toString());case o.Int:return d(x)}}e.deserialize=a;class C{constructor(q,te,oe=null,ee=1e3){this.protocol=q,this.ctx=te,this.logger=oe,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(q,te){this.channels.set(q,te),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const te=this.send([q.type]);this.logger?.logOutgoing(te,0,1,E(q.type));return}case 201:case 202:case 204:case 203:{const te=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(te,q.id,1,E(q.type),q.data);return}}}send(q,te=void 0){const oe=new i;return r(oe,q),r(oe,te),this.sendBuffer(oe.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const te=new w(q),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 100:return this.logger?.logIncoming(q.byteLength,oe[1],1,`${f(ae)}: ${oe[2]}.${oe[3]}`,ee),this.onPromise({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 102:return this.logger?.logIncoming(q.byteLength,oe[1],1,`${f(ae)}: ${oe[2]}.${oe[3]}`,ee),this.onEventListen({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 101:return this.logger?.logIncoming(q.byteLength,oe[1],1,`${f(ae)}`),this.disposeActiveRequest({type:ae,id:oe[1]});case 103:return this.logger?.logIncoming(q.byteLength,oe[1],1,`${f(ae)}`),this.disposeActiveRequest({type:ae,id:oe[1]})}}onPromise(q){const te=this.channels.get(q.channelName);if(!te){this.collectPendingRequest(q);return}const oe=new T.CancellationTokenSource;let ee;try{ee=te.call(this.ctx,q.name,q.arg,oe.token)}catch(W){ee=Promise.reject(W)}const ae=q.id;ee.then(W=>{this.sendResponse({id:ae,data:W,type:201})},W=>{W instanceof Error?this.sendResponse({id:ae,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:ae,data:W,type:203})}).finally(()=>{B.dispose(),this.activeRequests.delete(q.id)});const B=(0,m.toDisposable)(()=>oe.cancel());this.activeRequests.set(q.id,B)}onEventListen(q){const te=this.channels.get(q.channelName);if(!te){this.collectPendingRequest(q);return}const oe=q.id,ae=te.listen(this.ctx,q.name,q.arg)(B=>this.sendResponse({id:oe,data:B,type:204}));this.activeRequests.set(q.id,ae)}disposeActiveRequest(q){const te=this.activeRequests.get(q.id);te&&(te.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let te=this.pendingRequests.get(q.channelName);te||(te=[],this.pendingRequests.set(q.channelName,te));const oe=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);te.push({request:q,timeoutTimer:oe})}flushPendingRequests(q){const te=this.pendingRequests.get(q);if(te){for(const oe of te)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.onPromise(oe.request);break;case 102:this.onEventListen(oe.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=C;var p;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class h{constructor(q,te=null){this.protocol=q,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(oe=>this.onBuffer(oe)),this.logger=te}getChannel(q){const te=this;return{call(oe,ee,ae){return te.isDisposed?Promise.reject(new R.CancellationError):te.requestPromise(q,oe,ee,ae)},listen(oe,ee){return te.isDisposed?b.Event.None:te.requestEvent(q,oe,ee)}}}requestPromise(q,te,oe,ee=T.CancellationToken.None){const ae=this.lastRequestId++,W={id:ae,type:100,channelName:q,name:te,arg:oe};if(ee.isCancellationRequested)return Promise.reject(new R.CancellationError);let k;return new Promise((j,$)=>{if(ee.isCancellationRequested)return $(new R.CancellationError);const J=()=>{const ne=ce=>{switch(ce.type){case 201:this.handlers.delete(ae),j(ce.data);break;case 202:{this.handlers.delete(ae);const de=new Error(ce.data.message);de.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,de.name=ce.data.name,$(de);break}case 203:this.handlers.delete(ae),$(ce.data);break}};this.handlers.set(ae,ne),this.sendRequest(W)};let Z=null;this.state===c.Idle?J():(Z=(0,O.createCancelablePromise)(ne=>this.whenInitialized()),Z.then(()=>{Z=null,J()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:ae,type:101}),$(new R.CancellationError)},H=ee.onCancellationRequested(ie);k=(0,m.combinedDisposable)((0,m.toDisposable)(ie),H),this.activeRequests.add(k)}).finally(()=>{k.dispose(),this.activeRequests.delete(k)})}requestEvent(q,te,oe){const ee=this.lastRequestId++,B={id:ee,type:102,channelName:q,name:te,arg:oe};let W=null;const k=new b.Emitter({onWillAddFirstListener:()=>{W=(0,O.createCancelablePromise)(j=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(k),this.sendRequest(B)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(k),this.sendRequest({id:ee,type:103}))}}),N=j=>k.fire(j.data);return this.handlers.set(ee,N),k.event}sendRequest(q){switch(q.type){case 100:case 102:{const te=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(te,q.id,0,`${f(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const te=this.send([q.type,q.id]);this.logger?.logOutgoing(te,q.id,0,f(q.type));return}}}send(q,te=void 0){const oe=new i;return r(oe,q),r(oe,te),this.sendBuffer(oe.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const te=new w(q),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 200:return this.logger?.logIncoming(q.byteLength,0,0,E(ae)),this.onResponse({type:oe[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,oe[1],0,E(ae),ee),this.onResponse({type:oe[0],id:oe[1],data:ee})}}onResponse(q){if(q.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=h,Ee([_.memoize],h.prototype,"onDidInitializePromise",null);class y{get connections(){const q=[];return this._connections.forEach(te=>q.push(te)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new m.DisposableStore,this.disposables.add(q(({protocol:te,onDidClientDisconnect:oe})=>{const ee=b.Event.once(te.onMessage);this.disposables.add(ee(ae=>{const B=new w(ae),W=a(B),k=new C(te,W),N=new h(te);this.channels.forEach(($,J)=>k.registerChannel(J,$));const j={channelServer:k,channelClient:N,ctx:W};this._connections.add(j),this._onDidAddConnection.fire(j),this.disposables.add(oe(()=>{k.dispose(),N.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)}))}))}))}getChannel(q,te){const oe=this;return{call(ee,ae,B){let W;if((0,S.isFunction)(te)){const N=(0,L.getRandomElement)(oe.connections.filter(te));W=N?Promise.resolve(N):b.Event.toPromise(b.Event.filter(oe.onDidAddConnection,te))}else W=te.routeCall(oe,ee,ae);const k=W.then(N=>N.channelClient.getChannel(q));return U(k).call(ee,ae,B)},listen(ee,ae){if((0,S.isFunction)(te))return oe.getMulticastEvent(q,te,ee,ae);const B=te.routeEvent(oe,ee,ae).then(W=>W.channelClient.getChannel(q));return U(B).listen(ee,ae)}}}getMulticastEvent(q,te,oe,ee){const ae=this;let B;const W=new b.Emitter({onWillAddFirstListener:()=>{B=new m.DisposableStore;const k=new b.EventMultiplexer,N=new Map,j=J=>{const ie=J.channelClient.getChannel(q).listen(oe,ee),H=k.add(ie);N.set(J,H)},$=J=>{const Z=N.get(J);Z&&(Z.dispose(),N.delete(J))};ae.connections.filter(te).forEach(j),b.Event.filter(ae.onDidAddConnection,te)(j,void 0,B),ae.onDidRemoveConnection($,void 0,B),k.event(W.fire,W,B),B.add(k)},onDidRemoveLastListener:()=>{B?.dispose(),B=void 0}});return W.event}registerChannel(q,te){this.channels.set(q,te);for(const oe of this._connections)oe.channelServer.registerChannel(q,te)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class D{constructor(q,te,oe=null){const ee=new i;r(ee,te),q.send(ee.buffer),this.channelClient=new h(q,oe),this.channelServer=new C(q,te,oe)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,te){this.channelServer.registerChannel(q,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function U(x){return{call(q,te,oe){return x.then(ee=>ee.call(q,te,oe))},listen(q,te){const oe=new b.Relay;return x.then(ee=>oe.input=ee.listen(q,te)),oe.event}}}e.getDelayedChannel=U;function M(x){let q=!1;return{call(te,oe,ee){return q?x.call(te,oe,ee):(0,O.timeout)(0).then(()=>q=!0).then(()=>x.call(te,oe,ee))},listen(te,oe){if(q)return x.listen(te,oe);const ee=new b.Relay;return(0,O.timeout)(0).then(()=>q=!0).then(()=>ee.input=x.listen(te,oe)),ee.event}}}e.getNextTickChannel=M;class F{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const te of q.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=F;var z;(function(x){function q(ae,B,W){const k=ae,N=W&&W.disableMarshalling,j=new Map;for(const $ in k)oe($)&&j.set($,b.Event.buffer(k[$],!0,void 0,B));return new class{listen($,J,Z){const ie=j.get(J);if(ie)return ie;if(ee(J)){const H=k[J];if(typeof H=="function")return H.call(k,Z)}throw new R.ErrorNoTelemetry(`Event not found: ${J}`)}call($,J,Z){const ie=k[J];if(typeof ie=="function"){if(!N&&Array.isArray(Z))for(let ne=0;ne<Z.length;ne++)Z[ne]=(0,P.revive)(Z[ne]);let H=ie.apply(k,Z);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new R.ErrorNoTelemetry(`Method not found: ${J}`)}}}x.fromService=q;function te(ae,B){const W=B&&B.disableMarshalling;return new Proxy({},{get(k,N){if(typeof N=="string")return B?.properties?.has(N)?B.properties.get(N):ee(N)?function(j){return ae.listen(N,j)}:oe(N)?ae.listen(N):async function(...j){let $;B&&!(0,S.isUndefinedOrNull)(B.context)?$=[B.context,...j]:$=j;const J=await ae.call(N,$);return W?J:(0,P.revive)(J)};throw new R.ErrorNoTelemetry(`Property not found: ${String(N)}`)}})}x.toService=te;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&I.isUpperAsciiLetter(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&I.isUpperAsciiLetter(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const q=x.toString();if(q!=="[object Object]")return q}return x}function Q(x){return Array.isArray(x)?x.map(K):K(x)}function V(x,q,te,oe,ee,ae,B){B=Q(B);const W=X[ee],k=W[oe%W.length];let N=[`%c[${x}]%c[${String(q).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(ae)?(N=N.concat(B),N.push(")")):N.push(B),console.log.apply(console,N)}class Y{constructor(q,te){this._outgoingPrefix=q,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,te,oe,ee,ae){this._totalOutgoing+=q,V(this._outgoingPrefix,this._totalOutgoing,q,te,oe,ee,ae)}logIncoming(q,te,oe,ee,ae){this._totalIncoming+=q,V(this._incomingPrefix,this._totalIncoming,q,te,oe,ee,ae)}}e.IPCLogger=Y}),define(le[68],ue([0,1,14,3,2,40]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(_||(e.SocketDiagnosticsEventType=_={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(p,h){if(!t.has(p)){const y=String(++r);t.set(p,y)}return t.get(p)}function C(p,h,y,D){if(!s.enableDiagnostics)return;const U=a(p,h);if(D instanceof L.VSBuffer||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const M=L.VSBuffer.alloc(D.byteLength);M.set(D),s.records.push({timestamp:Date.now(),id:U,label:h,type:y,buff:M})}else s.records.push({timestamp:Date.now(),id:U,label:h,type:y,data:D})}s.traceSocketEvent=C})(R||(e.SocketDiagnostics=R={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let m=null;function P(){return m||(m=L.VSBuffer.alloc(0)),m}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,r){if(t===0)return P();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const h=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=t),h}if(this._chunks[0].byteLength>t){const h=this._chunks[0].slice(0,t);return r&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),h}const a=L.VSBuffer.alloc(t);let C=0,p=0;for(;t>0;){const h=this._chunks[p];if(h.byteLength>t){const y=h.slice(0,t);a.set(y,C),C+=t,r&&(this._chunks[p]=h.slice(t),this._totalLength-=t),t-=t}else a.set(h,C),C+=h.byteLength,r?(this._chunks.shift(),this._totalLength-=h.byteLength):p++,t-=h.byteLength}return a}}e.ChunkStream=I;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function u(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class v{constructor(t,r,a,C){this.type=t,this.id=r,this.ack=a,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends A.Disposable{constructor(t){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:u(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,C=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new v(a,C,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class c{constructor(t){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=L.VSBuffer.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:u(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",t.data),this._writeSoon(r,t.data)}_bufferAdd(t,r){const a=this._totalLength===0;return this._data.push(t,r),this._totalLength+=t.byteLength+r.byteLength,a}_bufferTake(){const t=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,r){this._bufferAdd(t,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const t=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this._socket.write(t)}}class d extends A.Disposable{constructor(t){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new c(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new v(1,0,0,t))}}e.Protocol=d;class g extends T.IPCClient{static fromSocket(t,r){return new g(new d(t),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.protocol=t}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=g;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class w{constructor(t){this.data=t,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let t=0,r=this._first;for(;r;)r=r.next,t++;return t}peek(){return this._first?this._first.data:null}toArray(){const t=[];let r=0,a=this._first;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const r=new w(t);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const t=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=t-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const t=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let C=0;C<o._HISTORY_LENGTH;C++)t-this.lastRuns[C]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(t){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=t.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=t.socket,this._socketWriter=this._socketDisposables.add(new c(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),t.initialChunk&&this._socketReader.acceptChunk(t.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new v(5,0,0,P());this._socketWriter.write(t),this._socketWriter.flush()}sendPause(){const t=new v(7,0,0,P());this._socketWriter.write(t)}sendResume(){const t=new v(8,0,0,P());this._socketWriter.write(t)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=t,this._socketWriter=this._socketDisposables.add(new c(this._socket)),this._socketReader=this._socketDisposables.add(new E(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const t=new v(3,0,this._incomingAckId,P());this._socketWriter.write(t);const r=this._outgoingUnackMsg.toArray();for(let a=0,C=r.length;a<C;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new v(6,0,0,P())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data);break}case 2:{this._onControlMessage.fire(t.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,C=r.length;a<C;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new v(1,r,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const r=new v(2,0,0,t);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this._socketReader.lastReadTime,C=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&C>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const p=Math.max(2e4-r,2e4-a,2e4-C,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new v(3,0,this._incomingAckId,P());this._socketWriter.write(t)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const t=new v(9,0,this._incomingAckId,P());this._socketWriter.write(t)}}e.PersistentProtocol=n}),define(le[93],ue([0,1,67,6,14,26,142,7,3,2,30,147,90,40]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends u.ChannelServer{constructor(c){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",d=>A.VSBuffer.wrap(Buffer.from(d,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=f;class v{constructor(c,d){this.modulePath=c,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new O.Delayer(g),this.child=null,this._client=null}getChannel(c){const d=this;return{call(g,l,w){return d.requestPromise(c,g,l,w)},listen(g,l){return d.requestEvent(c,g,l)}}}requestPromise(c,d,g,l=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const w=this.getCachedChannel(c),i=(0,O.createCancelablePromise)(s=>w.call(d,g,s)),o=l.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(c,d,g){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let l;const w=new b.Emitter({onWillAddFirstListener:()=>{l=this.getCachedChannel(c).listen(d,g)(w.fire,w),this.activeRequests.add(l)},onDidRemoveLastListener:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return w.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,S.removeDangerousEnvVariables)(d.env),this.child=(0,L.fork)(this.modulePath,c,d);const g=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,_.isRemoteConsoleLog)(t)){(0,_.log)(t,`IPC Library: ${this.options.serverName}`);return}g.fire(A.VSBuffer.wrap(Buffer.from(t,"base64")))});const w=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=t=>this.child&&this.child.connected&&w.send(t.buffer.toString("base64")),o=g.event,n={send:i,onMessage:o};this._client=new u.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,m.dispose)(a)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(c){let d=this.channels.get(c);return d||(d=this.client.getChannel(c),this.channels.set(c,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(le[149],ue([0,1,134,14,40,3,12,17]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class b{constructor(S){this.port=S,this.onMessage=T.Event.fromNodeEventEmitter(this.port,"message",u=>u.data?O.VSBuffer.wrap(u.data):O.VSBuffer.alloc(0)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}class m extends A.IPCServer{static getOnDidClientConnect(S){(0,_.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const u=new T.Emitter;return process.parentPort.on("message",f=>{if(S?.handledClientConnection(f))return;const v=(0,R.firstOrDefault)(f.ports);v&&u.fire(v)}),T.Event.map(u.event,f=>({protocol:new b(f),onDidClientDisconnect:T.Event.fromNodeEventEmitter(f,"close")}))}constructor(S){super(m.getOnDidClientConnect(S))}}e.Server=m;function P(I,S,u){const f=v=>{v.data===S&&(I.removeListener("message",f),u())};I.on("message",f)}e.once=P}),define(le[69],ue([0,1,6,3,2,66,12]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function b(S){const u=S;return u?.changed instanceof Map||u?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var m;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(m||(e.StorageState=m={}));class P extends A.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(u,f=Object.create(null)){super(),this.database=u,this.options=f,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=this._register(new L.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){this._onDidChangeStorage.pause();try{u.changed?.forEach((f,v)=>this.acceptExternal(v,f)),u.deleted?.forEach(f=>this.acceptExternal(f,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(u,f){if(this.state===m.Closed)return;let v=!1;(0,_.isUndefinedOrNull)(f)?v=this.cache.delete(u):this.cache.get(u)!==f&&(this.cache.set(u,f),v=!0),v&&this._onDidChangeStorage.fire({key:u,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,f){const v=this.cache.get(u);return(0,_.isUndefinedOrNull)(v)?f:v}getBoolean(u,f){const v=this.get(u);return(0,_.isUndefinedOrNull)(v)?f:v==="true"}getNumber(u,f){const v=this.get(u);return(0,_.isUndefinedOrNull)(v)?f:parseInt(v,10)}getObject(u,f){const v=this.get(u);return(0,_.isUndefinedOrNull)(v)?f:(0,T.parse)(v)}async set(u,f,v=!1){if(this.state===m.Closed)return;if((0,_.isUndefinedOrNull)(f))return this.delete(u,v);const E=(0,_.isObject)(f)||Array.isArray(f)?(0,T.stringify)(f):String(f);if(this.cache.get(u)!==E)return this.cache.set(u,E),this.pendingInserts.set(u,E),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire({key:u,external:v}),this.doFlush()}async delete(u,f=!1){if(!(this.state===m.Closed||!this.cache.delete(u)))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire({key:u,external:f}),this.doFlush()}async optimize(){if(this.state!==m.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(u){if(this.hasPending)return this.doFlush(u)}async doFlush(u){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),u)}async whenFlushed(){if(this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=P;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert?.forEach((f,v)=>this.items.set(v,f)),u.delete?.forEach(f=>this.items.delete(f))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=I}),define(le[150],ue([13,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],ue([0,1,50,6,16,12,31,150]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const b=new RegExp(e.CorruptZipMessage);class m extends Error{constructor(w,i){let o=i.message;switch(w){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=w,this.cause=i}}e.ExtractError=m;function P(l){const w=l.externalFileAttributes>>16||33188;return[448,56,7].map(i=>w&i).reduce((i,o)=>i+o,w&61440)}function I(l){if(l instanceof m)return l;let w;return b.test(l.message)&&(w="CorruptZip"),new m(w,l)}function S(l,w,i,o,n,s){const t=A.dirname(w),r=A.join(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,w)));const a=A.join(o,w);let C;return s.onCancellationRequested(()=>{C?.destroy()}),Promise.resolve(_.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((p,h)=>{if(!s.isCancellationRequested)try{C=(0,L.createWriteStream)(a,{mode:i}),C.once("close",()=>p()),C.once("error",h),l.once("error",h),l.pipe(C)}catch(y){h(y)}}))}function u(l,w,i,o){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),l.close()});return new Promise((r,a)=>{const C=new O.Sequencer,p=h=>{h.isCancellationRequested||(s++,l.readEntry())};l.once("error",a),l.once("close",()=>n.then(()=>{o.isCancellationRequested||l.entryCount===s?r():a(new m("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},a)),l.readEntry(),l.on("entry",h=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(h.fileName)){p(o);return}const y=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(y)){const M=A.join(w,y);n=(0,O.createCancelablePromise)(F=>_.Promises.mkdir(M,{recursive:!0}).then(()=>p(F)).then(void 0,a));return}const D=v(l,h),U=P(h);n=(0,O.createCancelablePromise)(M=>C.queue(()=>D.then(F=>S(F,y,U,w,i,M).then(()=>p(M)))).then(null,a))})}).finally(()=>t.dispose())}async function f(l,w=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(l,w?{lazyEntries:!0}:void 0,(s,t)=>{s?n(I(s)):o((0,T.assertIsDefined)(t))})})}function v(l,w){return new Promise((i,o)=>{l.openReadStream(w,(n,s)=>{n?o(I(n)):i((0,T.assertIsDefined)(s))})})}async function E(l,w){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;w.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,L.createWriteStream)(l);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(l))})}e.zip=E;function c(l,w,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=f(l,!0);return i.overwrite&&(s=s.then(t=>_.Promises.rm(w).then(()=>t))),s.then(t=>u(t,w,{sourcePathRegex:n},o))}e.extract=c;function d(l,w){return f(l).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===w&&v(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,w))))}))}function g(l,w){return d(l,w).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.buffer=g}),define(le[151],ue([13,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[152],ue([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[153],ue([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[154],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[155],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[156],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[157],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[158],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[159],ue([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[160],ue([13,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[161],ue([13,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[162],ue([13,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[163],ue([13,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[164],ue([13,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[165],ue([13,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[166],ue([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[167],ue([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[168],ue([13,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[169],ue([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[170],ue([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[171],ue([13,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[172],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[173],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[174],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[175],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[176],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[177],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[178],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[179],ue([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[180],ue([13,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[181],ue([0,1,7,153]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(A||(e.TokenType=A={}));function T(...m){switch(m.length){case 1:return(0,O.localize)(0,null,m[0]);case 2:return(0,O.localize)(1,null,m[0],m[1]);case 3:return(0,O.localize)(2,null,m[0],m[1],m[2]);default:return}}const _=(0,O.localize)(3,null),R=(0,O.localize)(4,null);class b{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(T("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(T("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const I=this._start,S=this._input.substring(this._start,this._current),u={type:19,offset:this._start,lexeme:S};this._errors.push({offset:I,lexeme:S,additionalInfo:P}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const I=this._input.substring(this._start,this._current),S=b._keywords.get(I);S?this._addToken(S):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,I=!1,S=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(R);return}const f=this._input.charCodeAt(P);if(I)I=!1;else if(f===47&&!S){P++;break}else f===91?S=!0:f===92?I=!0:f===93&&(S=!1);P++}for(;P<this._input.length&&b._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const u=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=b}),define(le[182],ue([0,1,65,85,23,16,36,20,10]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class m{get appRoot(){return(0,T.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",u)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=_.env.VSCODE_PORTABLE;return u?b.URI.file((0,T.join)(u,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,T.resolve)(u):(0,T.normalize)((0,T.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?b.URI.file((0,T.resolve)(u)):b.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,T.resolve)(u);const f=_.env.VSCODE_EXTENSIONS;if(f)return f;const v=_.env.VSCODE_PORTABLE;return v?(0,T.join)(v,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(f=>/^[^:/?#]+?:\/\//.test(f)?b.URI.parse(f):b.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?b.URI.parse(u):b.URI.file((0,T.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const f of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);v&&v[1]&&v[2]&&u.push([v[1],v[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=_.env.VSCODE_PORTABLE;return u?b.URI.file((0,T.join)(u,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this._args}constructor(u,f,v){this._args=u,this.paths=f,this.productService=v,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,Ee([O.memoize],m.prototype,"appRoot",null),Ee([O.memoize],m.prototype,"userHome",null),Ee([O.memoize],m.prototype,"userDataPath",null),Ee([O.memoize],m.prototype,"appSettingsHome",null),Ee([O.memoize],m.prototype,"tmpDir",null),Ee([O.memoize],m.prototype,"cacheHome",null),Ee([O.memoize],m.prototype,"stateResource",null),Ee([O.memoize],m.prototype,"userRoamingDataHome",null),Ee([O.memoize],m.prototype,"userDataSyncHome",null),Ee([O.memoize],m.prototype,"sync",null),Ee([O.memoize],m.prototype,"machineSettingsResource",null),Ee([O.memoize],m.prototype,"workspaceStorageHome",null),Ee([O.memoize],m.prototype,"localHistoryHome",null),Ee([O.memoize],m.prototype,"keyboardLayoutResource",null),Ee([O.memoize],m.prototype,"argvResource",null),Ee([O.memoize],m.prototype,"isExtensionDevelopment",null),Ee([O.memoize],m.prototype,"untitledWorkspacesHome",null),Ee([O.memoize],m.prototype,"builtinExtensionsPath",null),Ee([O.memoize],m.prototype,"extensionsPath",null),Ee([O.memoize],m.prototype,"extensionDevelopmentLocationURI",null),Ee([O.memoize],m.prototype,"extensionDevelopmentKind",null),Ee([O.memoize],m.prototype,"extensionTestsLocationURI",null),Ee([O.memoize],m.prototype,"debugExtensionHost",null),Ee([O.memoize],m.prototype,"logLevel",null),Ee([O.memoize],m.prototype,"extensionLogLevel",null),Ee([O.memoize],m.prototype,"serviceMachineIdResource",null),Ee([O.memoize],m.prototype,"disableTelemetry",null),Ee([O.memoize],m.prototype,"disableWorkspaceTrust",null),Ee([O.memoize],m.prototype,"useInMemorySecretStorage",null),Ee([O.memoize],m.prototype,"policyFile",null);function P(S,u){return I(S["inspect-extensions"],S["inspect-brk-extensions"],5870,u,S.debugId,S.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function I(S,u,f,v,E,c){const g=Number(u||S)||(v?null:f),l=g?!!u:!1;let w;if(c)try{w=JSON.parse(c)}catch{}return{port:g,break:l,debugId:E,env:w}}e.parseDebugParams=I}),function(){"use strict";function se(e,L,O){function A(_,R){const b=T(_,R),m=[b];return e.isAbsolute(b)||m.unshift(O),e.resolve(...m)}function T(_,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,R);const P=_["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(I,"AppData","Roaming")}break;case"darwin":m=e.join(L.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,R)}return{getUserDataPath:A}}if(typeof define=="function")define(le[183],ue([273,37,36]),function(e,L,O){return se(e,L,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=se(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[184],ue([0,1,37,182,183]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class T extends O.AbstractNativeEnvironmentService{constructor(m,P){super(m,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,A.getUserDataPath)(m,P.nameShort)},P)}}e.NativeEnvironmentService=T;function _(b,m){return(0,O.parseDebugParams)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,m,b.extensionEnvironment)}e.parsePtyHostDebugPort=_;function R(b,m){return(0,O.parseDebugParams)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,m,b.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(le[185],ue([0,1,12,156]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function A(_,R,b,m){try{T(_,R,b,m)}catch(P){_.error(P?.message??P)}return R}e.localizeManifest=A;function T(_,R,b,m){const P=(I,S,u)=>{const f=I[S];if((0,L.isString)(f)){const v=f,E=v.length;if(E>1&&v[0]==="%"&&v[E-1]==="%"){const c=v.substr(1,E-2);let d=b[c];d===void 0&&m&&(d=m[c]);const g=typeof d=="string"?d:d?.message,l=m?.[c],w=typeof l=="string"?l:l?.message;if(!g){w||_.warn(`[${R.name}]: ${(0,O.localize)(0,null,c)}`);return}if(u&&(S==="title"||S==="category")&&w&&w!==g){const i={value:g,original:w};I[S]=i}else I[S]=g}}else if((0,L.isObject)(f))for(const v in f)f.hasOwnProperty(v)&&(v==="commands"?P(f,v,!0):P(f,v,u));else if(Array.isArray(f))for(let v=0;v<f.length;v++)P(f,v,u)};for(const I in R)R.hasOwnProperty(I)&&P(R,I)}}),define(le[186],ue([0,1,70,159]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(T){return(0,L.buffer)(T,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=A}),define(le[187],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T){return this.channel.call("promptImportantExtensionsInstallNotification",[T])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class O{constructor(T){this.service=T}listen(T,_){throw new Error(`Event not found: ${_}`)}call(T,_,R){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(le[71],ue([0,1,20,89,160,55]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function b(c){return c=c.trim(),c==="*"||_.test(c)}e.isValidVersionStr=b;function m(c){if(!b(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=c.match(_);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=m;function P(c){if(!c)return null;const d=c.majorBase,g=c.majorMustEqual,l=c.minorBase;let w=c.minorMustEqual;const i=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(d===0||(w=!1),o=!1);let n=0;if(c.preRelease){const s=R.exec(c.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:g,minorBase:l,minorMustEqual:w,patchBase:i,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:n}}e.normalizeVersion=P;function I(c,d,g){let l;typeof c=="string"?l=P(m(c)):l=c;let w;d instanceof Date?w=d.getTime():typeof d=="string"&&(w=new Date(d).getTime());let i;if(typeof g=="string"?i=P(m(g)):i=g,!l||!i)return!1;const o=l.majorBase,n=l.minorBase,s=l.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const C=i.notBefore;let p=i.majorMustEqual,h=i.minorMustEqual,y=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||w&&w<C?!1:s>=a:(o===1&&t===0&&(!p||!h||!y)&&(t=1,r=0,a=0,p=!0,h=!1,y=!1),o<t?!1:o>t?!p:n<r?!1:n>r?!h:s<a?!1:s>a?!y:!(w&&w<C))}e.isValidVersion=I;function S(c,d,g,l,w){const i=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return i.push([O.default.Error,A.localize(0,null)]),i;if(typeof l.name!="string")return i.push([O.default.Error,A.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([O.default.Error,A.localize(2,null,"version")]),i;if(!l.engines)return i.push([O.default.Error,A.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([O.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies<"u"&&!E(l.extensionDependencies))return i.push([O.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents<"u"){if(!E(l.activationEvents))return i.push([O.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof l.main>"u"&&typeof l.browser>"u")return i.push([O.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&i.push([O.default.Warning,A.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return i.push([O.default.Error,A.localize(9,null,"main")]),i;{const s=(0,L.joinPath)(g,l.main);(0,L.isEqualOrParent)(s,g)||i.push([O.default.Warning,A.localize(10,null,s.path,g.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return i.push([O.default.Error,A.localize(11,null,"browser")]),i;{const s=(0,L.joinPath)(g,l.browser);(0,L.isEqualOrParent)(s,g)||i.push([O.default.Warning,A.localize(12,null,s.path,g.path)])}}if(!T.valid(l.version))return i.push([O.default.Error,A.localize(13,null)]),i;const o=[];if(!u(c,d,l,w,o))for(const s of o)i.push([O.default.Error,s]);return i}e.validateExtensionManifest=S;function u(c,d,g,l,w){return l||typeof g.main>"u"&&typeof g.browser>"u"?!0:v(c,d,g.engines.vscode,w)}e.isValidExtensionVersion=u;function f(c,d,g){return c==="*"||v(d,g,c)}e.isEngineValid=f;function v(c,d,g,l=[]){const w=P(m(g));if(!w)return l.push(A.localize(14,null,g)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(A.localize(15,null,g)),!1}else if(!w.majorMustEqual)return l.push(A.localize(16,null,g)),!1;return I(c,d,w)?!0:(l.push(A.localize(17,null,c,g)),!1)}function E(c){if(!Array.isArray(c))return!1;for(let d=0,g=c.length;d<g;d++)if(typeof c[d]!="string")return!1;return!0}}),define(le[43],ue([0,1,14,32]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(T,_,R){let b=R&&R.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const P=(await _.readFile(T.serviceMachineIdResource)).value.toString();b=(0,O.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,O.generateUuid)();try{await _.writeFile(T.serviceMachineIdResource,L.VSBuffer.fromString(b))}catch{}}return R?.store("storage.serviceMachineId",b,-1,1),b}e.getServiceMachineId=A}),define(le[72],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(A,T=[],_=!1){this.ctor=A,this.staticArguments=T,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=L}),define(le[188],ue([0,1,72]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function T(R,b,m){b instanceof L.SyncDescriptor||(b=new L.SyncDescriptor(b,[],!!m)),O.push([R,b])}e.registerSingleton=T;function _(){return O}e.getSingletonServiceDescriptors=_}),define(le[189],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(T,_){this.key=T,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class O{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const _ of this._nodes.values())_.outgoing.size===0&&T.push(_);return T}insertEdge(T,_){const R=this.lookupOrInsertNode(T),b=this.lookupOrInsertNode(_);R.outgoing.set(b.key,b),b.incoming.set(R.key,R)}removeNode(T){const _=this._hashFn(T);this._nodes.delete(_);for(const R of this._nodes.values())R.outgoing.delete(_),R.incoming.delete(_)}lookupOrInsertNode(T){const _=this._hashFn(T);let R=this._nodes.get(_);return R||(R=new L(_,T),this._nodes.set(_,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[_,R]of this._nodes)T.push(`${_}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,_]of this._nodes){const R=new Set([T]),b=this._findCycle(_,R);if(b)return b}}_findCycle(T,_){for(const[R,b]of T.outgoing){if(_.has(R))return[..._,R].join(" -> ");_.add(R);const m=this._findCycle(b,_);if(m)return m;_.delete(R)}}}e.Graph=O}),define(le[4],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=R})(L||(e._util=L={})),e.IInstantiationService=A("instantiationService");function O(_,R,b){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:_,index:b}):(R[L.DI_DEPENDENCIES]=[{id:_,index:b}],R[L.DI_TARGET]=R)}function A(_){if(L.serviceIds.has(_))return L.serviceIds.get(_);const R=function(b,m,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,b,P)};return R.toString=()=>_,L.serviceIds.set(_,R),R}e.createDecorator=A;function T(_){return _}e.refineServiceDecorator=T}),define(le[190],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(le[21],ue([0,1,12,10,4]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=T;function _(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=_;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function b(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function m(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.isConfigured=m;function P(c,d){const g=Object.create(null);for(const l in c)I(g,l,c[l],d);return g}e.toValuesTree=P;function I(c,d,g,l){const w=d.split("."),i=w.pop();let o=c;for(let n=0;n<w.length;n++){const s=w[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${d} as ${w.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=g}catch{l(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function S(c,d){const g=d.split(".");u(c,g)}e.removeFromValueTree=S;function u(c,d){const g=d.shift();if(d.length===0){delete c[g];return}if(Object.keys(c).indexOf(g)!==-1){const l=c[g];typeof l=="object"&&!Array.isArray(l)&&(u(l,d),Object.keys(l).length===0&&delete c[g])}}function f(c,d,g){function l(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const w=d.split("."),i=l(c,w);return typeof i>"u"?g:i}e.getConfigurationValue=f;function v(c,d,g){Object.keys(d).forEach(l=>{l!=="__proto__"&&(l in c?L.isObject(c[l])&&L.isObject(d[l])?v(c[l],d[l],g):g&&(c[l]=d[l]):c[l]=d[l])})}e.merge=v;function E(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(le[94],ue([0,1,5,27,181,4,152,7]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",L.isMacintosh),b.set("isLinux",L.isLinux),b.set("isWindows",L.isWindows),b.set("isWeb",L.isWeb),b.set("isMacNative",L.isMacintosh&&!L.isWeb),b.set("isEdge",L.isEdge),b.set("isFirefox",L.isFirefox),b.set("isChrome",L.isChrome),b.set("isSafari",L.isSafari);function m(W,k){if(b.get(W)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(W,k)}e.setConstant=m;const P=Object.prototype.hasOwnProperty;var I;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const S={regexParsingWithErrorRecovery:!0},u=(0,_.localize)(0,null),f=(0,_.localize)(1,null),v=(0,_.localize)(2,null),E=(0,_.localize)(3,null),c=(0,_.localize)(4,null),d=(0,_.localize)(5,null),g=(0,_.localize)(6,null),l=(0,_.localize)(7,null);class w{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(k=S){this._config=k,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(k){if(k===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:f});return}this._tokens=this._scanner.reset(k).scan(),this._current=0,this._parsingErrors=[];try{const N=this._expr();if(!this._isAtEnd()){const j=this._peek(),$=j.type===17?d:void 0;throw this._parsingErrors.push({message:c,offset:j.offset,lexeme:A.Scanner.getLexeme(j),additionalInfo:$}),w._parseError}return N}catch(N){if(N!==w._parseError)throw N;return}}_expr(){return this._or()}_or(){const k=[this._and()];for(;this._matchOne(16);){const N=this._and();k.push(N)}return k.length===1?k[0]:i.or(...k)}_and(){const k=[this._term()];for(;this._matchOne(15);){const N=this._term();k.push(N)}return k.length===1?k[0]:i.and(...k)}_term(){if(this._matchOne(2)){const k=this._peek();switch(k.type){case 11:return this._advance(),t.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const N=this._expr();return this._consume(1,E),N?.negate()}case 17:return this._advance(),D.create(k.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",k)}}return this._primary()}_primary(){const k=this._peek();switch(k.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const N=this._expr();return this._consume(1,E),N}case 17:{const N=k.lexeme;if(this._advance(),this._matchOne(9)){const $=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),$.type!==10)throw this._errExpectedButGot("REGEX",$);const J=$.lexeme,Z=J.lastIndexOf("/"),ie=Z===J.length-1?void 0:this._removeFlagsGY(J.substring(Z+1));let H;try{H=new RegExp(J.substring(1,Z),ie)}catch{throw this._errExpectedButGot("REGEX",$)}return K.create(N,H)}switch($.type){case 10:case 19:{const J=[$.lexeme];this._advance();let Z=this._peek(),ie=0;for(let fe=0;fe<$.lexeme.length;fe++)$.lexeme.charCodeAt(fe)===40?ie++:$.lexeme.charCodeAt(fe)===41&&ie--;for(;!this._isAtEnd()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let fe=0;fe<Z.lexeme.length;fe++)Z.lexeme.charCodeAt(fe)===40?ie++:$.lexeme.charCodeAt(fe)===41&&ie--}if(ie<0)break;J.push(A.Scanner.getLexeme(Z)),this._advance(),Z=this._peek()}const H=J.join(""),ne=H.lastIndexOf("/"),ce=ne===H.length-1?void 0:this._removeFlagsGY(H.substring(ne+1));let de;try{de=new RegExp(H.substring(1,ne),ce)}catch{throw this._errExpectedButGot("REGEX",$)}return i.regex(N,de)}case 18:{const J=$.lexeme;this._advance();let Z=null;if(!(0,O.isFalsyOrWhitespace)(J)){const ie=J.indexOf("/"),H=J.lastIndexOf("/");if(ie!==H&&ie>=0){const ne=J.slice(ie+1,H),ce=J[H+1]==="i"?"i":"";try{Z=new RegExp(ne,ce)}catch{throw this._errExpectedButGot("REGEX",$)}}}if(Z===null)throw this._errExpectedButGot("REGEX",$);return K.create(N,Z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,v);const $=this._value();return i.notIn(N,$)}switch(this._peek().type){case 3:{this._advance();const $=this._value();if(this._previous().type===18)return i.equals(N,$);switch($){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,$)}}case 4:{this._advance();const $=this._value();if(this._previous().type===18)return i.notEquals(N,$);switch($){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,$)}}case 5:return this._advance(),z.create(N,this._value());case 6:return this._advance(),X.create(N,this._value());case 7:return this._advance(),M.create(N,this._value());case 8:return this._advance(),F.create(N,this._value());case 13:return this._advance(),i.in(N,this._value());default:return i.has(N)}}case 20:throw this._parsingErrors.push({message:g,offset:k.offset,lexeme:"",additionalInfo:l}),w._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const k=this._peek();switch(k.type){case 17:case 18:return this._advance(),k.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(k){return k.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(k){return this._check(k)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(k,N){if(this._check(k))return this._advance();throw this._errExpectedButGot(N,this._peek())}_errExpectedButGot(k,N,j){const $=(0,_.localize)(8,null,k,A.Scanner.getLexeme(N)),J=N.offset,Z=A.Scanner.getLexeme(N);return this._parsingErrors.push({message:$,offset:J,lexeme:Z,additionalInfo:j}),w._parseError}_check(k){return this._peek().type===k}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=w;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(k){return a.create(k)}static equals(k,N){return C.create(k,N)}static notEquals(k,N){return y.create(k,N)}static regex(k,N){return K.create(k,N)}static in(k,N){return p.create(k,N)}static notIn(k,N){return h.create(k,N)}static not(k){return D.create(k)}static and(...k){return Y.create(k,null,!0)}static or(...k){return x.create(k,null,!0)}static greater(k,N){return M.create(k,N)}static greaterEquals(k,N){return F.create(k,N)}static smaller(k,N){return z.create(k,N)}static smallerEquals(k,N){return X.create(k,N)}static{this._parser=new w({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this._parser.parse(k)}}e.ContextKeyExpr=i;function o(W){const k=new w({regexParsingWithErrorRecovery:!1});return W.map(N=>(k.parse(N),k.lexingErrors.length>0?k.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,_.localize)(9,null,j.additionalInfo):(0,_.localize)(10,null),offset:j.offset,length:j.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}e.validateWhenClauses=o;function n(W,k){const N=W?W.substituteConstants():void 0,j=k?k.substituteConstants():void 0;return!N&&!j?!0:!N||!j?!1:N.equals(j)}e.expressionsAreEqualWithConstantSubstitution=n;function s(W,k){return W.cmp(k)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return t.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(k,N=null){const j=b.get(k);return typeof j=="boolean"?j?r.INSTANCE:t.INSTANCE:new a(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:te(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=b.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:t.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class C{static create(k,N,j=null){if(typeof N=="boolean")return N?a.create(k,j):D.create(k,j);const $=b.get(k);return typeof $=="boolean"?N===($?"true":"false")?r.INSTANCE:t.INSTANCE:new C(k,N,j)}constructor(k,N,j){this.key=k,this.value=N,this.negated=j,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=b.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?r.INSTANCE:t.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class p{static create(k,N){return new p(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.valueKey),j=k.getValue(this.key);return Array.isArray(N)?N.includes(j):typeof j=="string"&&typeof N=="object"&&N!==null?P.call(N,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class h{static create(k,N){return new h(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=11,this._negated=p.create(k,N)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class y{static create(k,N,j=null){if(typeof N=="boolean")return N?D.create(k,j):a.create(k,j);const $=b.get(k);return typeof $=="boolean"?N===($?"true":"false")?t.INSTANCE:r.INSTANCE:new y(k,N,j)}constructor(k,N,j){this.key=k,this.value=N,this.negated=j,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=b.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?t.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class D{static create(k,N=null){const j=b.get(k);return typeof j=="boolean"?j?t.INSTANCE:r.INSTANCE:new D(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:te(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=b.get(this.key);return typeof k=="boolean"?k?t.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function U(W,k){if(typeof W=="string"){const N=parseFloat(W);isNaN(N)||(W=N)}return typeof W=="string"||typeof W=="number"?k(W):t.INSTANCE}class M{static create(k,N,j=null){return U(N,$=>new M(k,$,j))}constructor(k,N,j){this.key=k,this.value=N,this.negated=j,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=X.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class F{static create(k,N,j=null){return U(N,$=>new F(k,$,j))}constructor(k,N,j){this.key=k,this.value=N,this.negated=j,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class z{static create(k,N,j=null){return U(N,$=>new z(k,$,j))}constructor(k,N,j){this.key=k,this.value=N,this.negated=j,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=z;class X{static create(k,N,j=null){return U(N,$=>new X(k,$,j))}constructor(k,N,j){this.key=k,this.value=N,this.negated=j,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:oe(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=X;class K{static create(k,N){return new K(k,N)}constructor(k,N){this.key=k,this.regexp=N,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const N=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return N<j?-1:N>j?1:0}equals(k){if(k.type===this.type){const N=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return this.key===k.key&&N===j}return!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Q.create(this)),this.negated}}e.ContextKeyRegexExpr=K;class Q{static create(k){return new Q(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(k){return new Q(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Q;function V(W){let k=null;for(let N=0,j=W.length;N<j;N++){const $=W[N].substituteConstants();if(W[N]!==$&&k===null){k=[];for(let J=0;J<N;J++)k[J]=W[J]}k!==null&&(k[N]=$)}return k===null?W:k}class Y{static create(k,N,j){return Y._normalizeArr(k,N,j)}constructor(k,N){this.expr=k,this.negated=N,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,j=this.expr.length;N<j;N++){const $=s(this.expr[N],k.expr[N]);if($!==0)return $}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,j=this.expr.length;N<j;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=V(this.expr);return k===this.expr?this:Y.create(k,this.negated,!1)}evaluate(k){for(let N=0,j=this.expr.length;N<j;N++)if(!this.expr[N].evaluate(k))return!1;return!0}static _normalizeArr(k,N,j){const $=[];let J=!1;for(const Z of k)if(Z){if(Z.type===1){J=!0;continue}if(Z.type===0)return t.INSTANCE;if(Z.type===6){$.push(...Z.expr);continue}$.push(Z)}if($.length===0&&J)return r.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(s);for(let Z=1;Z<$.length;Z++)$[Z-1].equals($[Z])&&($.splice(Z,1),Z--);if($.length===1)return $[0];for(;$.length>1;){const Z=$[$.length-1];if(Z.type!==9)break;$.pop();const ie=$.pop(),H=$.length===0,ne=x.create(Z.expr.map(ce=>Y.create([ce,ie],null,j)),null,H);ne&&($.push(ne),$.sort(s))}if($.length===1)return $[0];if(j){for(let Z=0;Z<$.length;Z++)for(let ie=Z+1;ie<$.length;ie++)if($[Z].negate().equals($[ie]))return t.INSTANCE;if($.length===1)return $[0]}return new Y($,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new Y(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());this.negated=x.create(k,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class x{static create(k,N,j){return x._normalizeArr(k,N,j)}constructor(k,N){this.expr=k,this.negated=N,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,j=this.expr.length;N<j;N++){const $=s(this.expr[N],k.expr[N]);if($!==0)return $}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,j=this.expr.length;N<j;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=V(this.expr);return k===this.expr?this:x.create(k,this.negated,!1)}evaluate(k){for(let N=0,j=this.expr.length;N<j;N++)if(this.expr[N].evaluate(k))return!0;return!1}static _normalizeArr(k,N,j){let $=[],J=!1;if(k){for(let Z=0,ie=k.length;Z<ie;Z++){const H=k[Z];if(H){if(H.type===0){J=!0;continue}if(H.type===1)return r.INSTANCE;if(H.type===9){$=$.concat(H.expr);continue}$.push(H)}}if($.length===0&&J)return t.INSTANCE;$.sort(s)}if($.length!==0){if($.length===1)return $[0];for(let Z=1;Z<$.length;Z++)$[Z-1].equals($[Z])&&($.splice(Z,1),Z--);if($.length===1)return $[0];if(j){for(let Z=0;Z<$.length;Z++)for(let ie=Z+1;ie<$.length;ie++)if($[Z].negate().equals($[ie]))return r.INSTANCE;if($.length===1)return $[0]}return new x($,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new x(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());for(;k.length>1;){const N=k.shift(),j=k.shift(),$=[];for(const J of B(N))for(const Z of B(j))$.push(Y.create([J,Z],null,!1));k.unshift(x.create($,null,!1))}this.negated=x.create(k,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class q extends a{static{this._info=[]}static all(){return q._info.values()}constructor(k,N,j){super(k,null),this._defaultValue=N,typeof j=="object"?q._info.push({...j,key:k}):j!==!0&&q._info.push({key:k,description:j,type:N!=null?typeof N:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return C.create(this.key,k)}notEqualsTo(k){return y.create(this.key,k)}}e.RawContextKey=q,e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function te(W,k){return W<k?-1:W>k?1:0}function oe(W,k,N,j){return W<N?-1:W>N?1:k<j?-1:k>j?1:0}function ee(W,k){if(W.type===0||k.type===1)return!0;if(W.type===9)return k.type===9?ae(W.expr,k.expr):!1;if(k.type===9){for(const N of k.expr)if(ee(W,N))return!0;return!1}if(W.type===6){if(k.type===6)return ae(k.expr,W.expr);for(const N of W.expr)if(ee(N,k))return!0;return!1}return W.equals(k)}e.implies=ee;function ae(W,k){let N=0,j=0;for(;N<W.length&&j<k.length;){const $=W[N].cmp(k[j]);if($<0)return!1;$===0&&N++,j++}return N===W.length}function B(W){return W.type===9?W.expr:[W]}}),define(le[95],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function O(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=O;class A{async getPerformanceInfo(_,R){return{}}async getSystemInfo(_,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,R){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=A}),define(le[96],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(le[15],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(le[29],ue([0,1,155,4]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function A(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function T(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function _(g,l){switch(g){case 3:return l==="x64"?"win32-x64":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":l==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function R(g,l){return l==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function b(g,l,w){return R(l,w)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===w}e.isTargetPlatformCompatible=b;function m(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=m;var P;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var I;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var S;(function(g){g.Install="install",g.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var u;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var f;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.DownloadSignature="DownloadSignature",g.UpdateMetadata="UpdateMetadata",g.Extract="Extract",g.Scanning="Scanning",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.NotAllowed="NotAllowed",g.Gallery="Gallery",g.Unknown="Unknown",g.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var v;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class E extends Error{constructor(l,w){super(l),this.code=w,this.name=w}}e.ExtensionManagementError=E;var c;(function(g){g.Timeout="Timeout",g.Cancelled="Cancelled",g.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class d extends Error{constructor(l,w){super(l),this.code=w,this.name=w}}e.ExtensionGalleryError=d,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,L.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,L.localize2)(1,"Preferences")}),define(le[191],ue([0,1,3,2,30,10,92,29]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(E,c){return E?T.URI.revive(c?c.transformIncoming(E):E):void 0}function m(E,c){return c?c.transformOutgoingURI(E):E}function P(E,c){c=c||_.DefaultURITransformer;const d=E.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...E,manifest:void 0},c),manifest:d}}function I(E,c){return E?.profileLocation?(0,_.transformAndReviveIncomingURIs)(E,c??_.DefaultURITransformer):E}function S(E,c){return c?(0,A.cloneAndChange)(E,d=>d instanceof T.URI?c.transformOutgoingURI(d):void 0):E}class u{constructor(c,d){this.service=c,this.getUriTransformer=d,this.onInstallExtension=L.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,d){const g=this.getUriTransformer(c);switch(d){case"onInstallExtension":return L.Event.map(this.onInstallExtension,l=>({...l,profileLocation:l.profileLocation?m(l.profileLocation,g):l.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,l=>l.map(w=>({...w,local:w.local?S(w.local,g):w.local,profileLocation:w.profileLocation?m(w.profileLocation,g):w.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,l=>({...l,profileLocation:l.profileLocation?m(l.profileLocation,g):l.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,l=>({...l,profileLocation:l.profileLocation?m(l.profileLocation,g):l.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,l=>S(l,g))}throw new Error("Invalid listen")}async call(c,d,g){const l=this.getUriTransformer(c);switch(d){case"zip":{const w=P(g[0],l),i=await this.service.zip(w);return m(i,l)}case"unzip":return this.service.unzip(b(g[0],l));case"install":return this.service.install(b(g[0],l),I(g[1],l));case"installFromLocation":return this.service.installFromLocation(b(g[0],l),b(g[1],l));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(g[0],b(g[1],l),b(g[2],l));case"getManifest":return this.service.getManifest(b(g[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],I(g[1],l));case"installGalleryExtensions":{const w=g[0];return this.service.installGalleryExtensions(w.map(({extension:i,options:o})=>({extension:i,options:I(o,l)??{}})))}case"uninstall":return this.service.uninstall(P(g[0],l),I(g[1],l));case"reinstallFromGallery":return this.service.reinstallFromGallery(P(g[0],l));case"getInstalled":return(await this.service.getInstalled(g[0],b(g[1],l))).map(i=>S(i,l));case"toggleAppliationScope":{const w=await this.service.toggleAppliationScope(P(g[0],l),b(g[1],l));return S(w,l)}case"copyExtensions":return this.service.copyExtensions(b(g[0],l),b(g[1],l));case"updateMetadata":{const w=await this.service.updateMetadata(P(g[0],l),g[1],b(g[2],l));return S(w,l)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(g[0],g[1],g[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=u;class f extends O.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(c){super(),this.channel=c,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this._register(this.channel.listen("onInstallExtension")(d=>this.fireEvent(this._onInstallExtension,{...d,source:this.isUriComponents(d.source)?T.URI.revive(d.source):d.source,profileLocation:T.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this.fireEvent(this._onDidInstallExtensions,d.map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source,profileLocation:T.URI.revive(g.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this.fireEvent(this._onUninstallExtension,{...d,profileLocation:T.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this.fireEvent(this._onDidUninstallExtension,{...d,profileLocation:T.URI.revive(d.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(d=>this._onDidUpdateExtensionMetadata.fire(P(d,null))))}fireEvent(c,d){c.fire(d)}isUriComponents(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(c){const d=await this.getTargetPlatform();return c.allTargetPlatforms.some(g=>(0,R.isTargetPlatformCompatible)(g,c.allTargetPlatforms,d))}zip(c){return Promise.resolve(this.channel.call("zip",[c]).then(d=>T.URI.revive(d)))}unzip(c){return Promise.resolve(this.channel.call("unzip",[c]))}install(c,d){return Promise.resolve(this.channel.call("install",[c,d])).then(g=>P(g,null))}installFromLocation(c,d){return Promise.resolve(this.channel.call("installFromLocation",[c,d])).then(g=>P(g,null))}async installExtensionsFromProfile(c,d,g){return(await this.channel.call("installExtensionsFromProfile",[c,d,g])).map(w=>P(w,null))}getManifest(c){return Promise.resolve(this.channel.call("getManifest",[c]))}installFromGallery(c,d){return Promise.resolve(this.channel.call("installFromGallery",[c,d])).then(g=>P(g,null))}async installGalleryExtensions(c){return(await this.channel.call("installGalleryExtensions",[c])).map(g=>({...g,local:g.local?P(g.local,null):g.local,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source,profileLocation:T.URI.revive(g.profileLocation)}))}uninstall(c,d){return Promise.resolve(this.channel.call("uninstall",[c,d]))}reinstallFromGallery(c){return Promise.resolve(this.channel.call("reinstallFromGallery",[c])).then(d=>P(d,null))}getInstalled(c=null,d){return Promise.resolve(this.channel.call("getInstalled",[c,d])).then(g=>g.map(l=>P(l,null)))}updateMetadata(c,d,g){return Promise.resolve(this.channel.call("updateMetadata",[c,d,g])).then(l=>P(l,null))}toggleAppliationScope(c,d){return this.channel.call("toggleAppliationScope",[c,d]).then(g=>P(g,null))}copyExtensions(c,d){return this.channel.call("copyExtensions",[c,d])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(c,d,g){const l=await this.channel.call("download",[c,d,g]);return T.URI.revive(l)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class v{constructor(c){this.service=c}listen(c,d){throw new Error("Invalid listen")}call(c,d,g){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(le[97],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(O||(e.RecommendationSource=O={}));function A(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var T;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(T||(e.RecommendationsNotificationResult=T={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(le[11],ue([0,1,48,16,27,12,10,162,4,5,23,53]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function S(ee){return ee.create===!0}e.isFileOpenForWriteOptions=S;var u;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var f;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function v(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.isFileSystemWatcher=v;var E;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function c(ee){return!!(ee.capabilities&2)}e.hasReadWriteCapability=c;function d(ee){return!!(ee.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(ee){return!!(ee.capabilities&131072)}e.hasFileCloneCapability=g;function l(ee){return!!(ee.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function w(ee){return!!(ee.capabilities&16)}e.hasFileReadStreamCapability=w;function i(ee){return c(ee)?!!(ee.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function o(ee){return c(ee)?!!(ee.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function n(ee){return!!(ee.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function s(ee){return!!(ee.capabilities&2048)}e.hasReadonlyCapability=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,B){const W=new r(ae.toString(),B);return p(W,B),W}constructor(ae,B){super(ae),this.code=B}}e.FileSystemProviderError=r;function a(ee,ae){return r.create(ee,ae)}e.createFileSystemProviderError=a;function C(ee){return ee||a((0,R.localize)(0,null),t.Unknown)}e.ensureFileSystemProviderError=C;function p(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.markAsFileSystemProviderError=p;function h(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.toFileSystemProviderErrorCode=h;function y(ee){if(ee instanceof X)return ee.fileOperationResult;switch(h(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=y;var D;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class U{constructor(ae,B,W){this.resource=ae,this.operation=B,this.target=W}isOperation(ae){return this.operation===ae}}e.FileOperationEvent=U;var M;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class F{static{this.MIXED_CORRELATION=null}constructor(ae,B){this.ignorePathCasing=B,this.correlationId=void 0,this.added=new I.Lazy(()=>{const W=L.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawAdded.map(k=>[k,!0])),W}),this.updated=new I.Lazy(()=>{const W=L.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawUpdated.map(k=>[k,!0])),W}),this.deleted=new I.Lazy(()=>{const W=L.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawDeleted.map(k=>[k,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of ae){switch(W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}this.correlationId!==F.MIXED_CORRELATION&&(typeof W.cId=="number"?this.correlationId===void 0?this.correlationId=W.cId:this.correlationId!==W.cId&&(this.correlationId=F.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=F.MIXED_CORRELATION))}}contains(ae,...B){return this.doContains(ae,{includeChildren:!1},...B)}affects(ae,...B){return this.doContains(ae,{includeChildren:!0},...B)}doContains(ae,B,...W){if(!ae)return!1;const k=W.length>0;return!!((!k||W.includes(1))&&(this.added.value.get(ae)||B.includeChildren&&this.added.value.findSuperstr(ae))||(!k||W.includes(0))&&(this.updated.value.get(ae)||B.includeChildren&&this.updated.value.findSuperstr(ae))||(!k||W.includes(2))&&(this.deleted.value.findSubstr(ae)||B.includeChildren&&this.deleted.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.correlationId===ae}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=F;function z(ee,ae,B){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==O.sep&&(ae+=O.sep),B?(0,A.startsWithIgnoreCase)(ee,ae):ee.indexOf(ae)===0)}e.isParent=z;class X extends Error{constructor(ae,B,W){super(ae),this.fileOperationResult=B,this.options=W}}e.FileOperationError=X;class K extends X{constructor(ae,B,W,k){super(ae,B,k),this.fileOperationResult=B,this.size=W}}e.TooLargeFileOperationError=K;class Q extends X{constructor(ae,B,W){super(ae,2,W),this.stat=B}}e.NotModifiedSinceFileOperationError=Q;var V;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Y;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.ETAG_DISABLED="";function x(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.etag=x;async function q(ee,ae){if(!ae.hasProvider(_.URI.from({scheme:ee.scheme})))return new Promise(B=>{const W=ae.onDidChangeFileSystemProviderRegistrations(k=>{k.scheme===ee.scheme&&k.added&&(W.dispose(),B())})})}e.whenProviderRegistered=q;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,T.isNumber)(ae)||(ae=0),ae<te.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,R.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,R.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,R.localize)(4,null,(ae/te.GB).toFixed(2)):(0,R.localize)(5,null,(ae/te.TB).toFixed(2))}}e.ByteSize=te;function oe(ee){const ae=typeof ee=="string"||ee?.scheme===P.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===P.Schemas.file?1024*te.MB:ae?10*te.MB:m.isWeb?50*te.MB:1024*te.MB}e.getLargeFileConfirmationLimit=oe});var G=this&&this.__param||function(se,e){return function(L,O){e(L,O,se)}};define(le[192],ue([0,1,73,47,11]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((m,P)=>{const I=(0,L.createHash)("sha256");(0,O.listenStream)(b,{onData:S=>I.update(S.buffer),onError:S=>P(S),onEnd:()=>m(I.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=T,e.ChecksumService=T=Ee([G(0,A.IFileService)],T)}),define(le[98],ue([0,1,14,7,163,11]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(P,I,S,u,f,v){let E;try{await R(P,I,S,u,f,v)}catch(c){E=c}finally{E&&f.errorTransformer&&(E=f.errorTransformer(E)),typeof E<"u"&&S.error(E),S.end()}}e.readFileIntoStream=_;async function R(P,I,S,u,f,v){b(v);const E=await P.open(I,{create:!1});try{b(v);let c=0,d=0,g=f&&typeof f.length=="number"?f.length:void 0,l=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),w=f&&typeof f.position=="number"?f.position:0,i=0;do d=await P.read(E,w,l.buffer,i,l.byteLength-i),w+=d,i+=d,c+=d,typeof g=="number"&&(g-=d),i===l.byteLength&&(await S.write(u(l)),l=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),i=0);while(d>0&&(typeof g!="number"||g>0)&&b(v)&&m(c,f));if(i>0){let o=i;typeof g=="number"&&(o=Math.min(i,g)),S.write(u(l.slice(0,o)))}}catch(c){throw(0,T.ensureFileSystemProviderError)(c)}finally{await P.close(E)}}function b(P){if(P.isCancellationRequested)throw(0,O.canceled)();return!0}function m(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,T.createFileSystemProviderError)((0,A.localize)(0,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[51],ue([0,1,91,2,16,5,10,11]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function b(c){return c.recursive===!0}e.isRecursiveWatchRequest=b;class m extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(d,g,l,w){super(),this.onFileChanges=d,this.onLogMessage=g,this.verboseLogging=l,this.options=w,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new O.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),d.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),d.add(this.watcher.onDidError(g=>this.onError(g)))}onError(d){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m;class P extends m{constructor(d,g,l){super(d,g,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class I extends m{constructor(d,g,l){super(d,g,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function S(c){return c.map(d=>({type:d.type,resource:_.URI.revive(d.resource),cId:d.cId}))}e.reviveFileChanges=S;function u(c){const d=new E;for(const g of c)d.processEvent(g);return d.coalesce()}e.coalesceEvents=u;function f(c,d){return typeof d=="string"&&!d.startsWith(L.GLOBSTAR)&&!(0,A.isAbsolute)(d)?{base:c,pattern:d}:d}e.normalizeWatcherPattern=f;function v(c,d){const g=[];for(const l of d)g.push((0,L.parse)(f(c,l)));return g}e.parseWatcherPatterns=v;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return T.isLinux?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const g=this.mapPathToChange.get(this.toKey(d));let l=!1;if(g){const w=g.type,i=d.type;g.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?l=!0:w===1&&i===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(g)):w===2&&i===1?g.type=0:w===1&&i===0||(g.type=i)}else l=!0;l&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],g=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(d.push(l),!1):!0).sort((l,w)=>l.resource.fsPath.length-w.resource.fsPath.length).filter(l=>g.some(w=>(0,R.isParent)(l.resource.fsPath,w,!T.isLinux))?!1:(g.push(l.resource.fsPath),!0)).concat(d)}}}),define(le[193],ue([0,1,14,38,7,3,2,47,32,11,51]),function(se,e,L,O,A,T,_,R,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends _.Disposable{constructor(u,f){super(),this.channel=u,this.extraCapabilities=f,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,f){const{buffer:v}=await this.channel.call("readFile",[u,f]);return v}readFileStream(u,f,v){const E=(0,R.newWriteableStream)(d=>L.VSBuffer.concat(d.map(g=>L.VSBuffer.wrap(g))).buffer),c=new _.DisposableStore;return c.add(this.channel.listen("readFileStream",[u,f])(d=>{if(d instanceof L.VSBuffer)E.write(d.buffer);else{if(d==="end")E.end();else{let g;if(d instanceof Error)g=d;else{const l=d;g=(0,m.createFileSystemProviderError)(l.message??(0,O.toErrorMessage)(l),l.code??m.FileSystemProviderErrorCode.Unknown)}E.error(g),E.end()}c.dispose()}})),c.add(v.onCancellationRequested(()=>{E.error((0,A.canceled)()),E.end(),c.dispose()})),E}writeFile(u,f,v){return this.channel.call("writeFile",[u,L.VSBuffer.wrap(f),v])}open(u,f){return this.channel.call("open",[u,f])}close(u){return this.channel.call("close",[u])}async read(u,f,v,E,c){const[d,g]=await this.channel.call("read",[u,f,c]);return v.set(d.buffer.slice(0,g),E),g}write(u,f,v,E,c){return this.channel.call("write",[u,f,L.VSBuffer.wrap(v),E,c])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,f){return this.channel.call("delete",[u,f])}rename(u,f,v){return this.channel.call("rename",[u,f,v])}copy(u,f,v){return this.channel.call("copy",[u,f,v])}cloneFile(u,f){return this.channel.call("cloneFile",[u,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const f=u;this._onDidChange.fire((0,P.reviveFileChanges)(f))}else{const f=u;this._onDidWatchError.fire(f)}}))}watch(u,f){const v=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,v,u,f]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=I}),define(le[194],ue([0,1,50,6,26,49,2,88,16,5,20,10,146,31,51]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends _.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(d,g,l,w){super(),this.request=d,this.onDidFilesChange=g,this.onLogMessage=l,this.verboseLogging=w,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.onDidFilesChange(i))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(i=>this.handleFileChanges(i),v.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,f.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,f.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new A.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await u.Promises.stat(d);this._register(await this.doWatch(d,g.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let g=d.path;try{g=await u.Promises.realpath(d.path),d.path===g&&(g=await(0,S.realcase)(d.path)??d.path),d.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${g})`)}catch{}return g}async doWatch(d,g){if(m.isMacintosh&&(0,T.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const l=new A.CancellationTokenSource(this.cts.token),w=new _.DisposableStore;try{const i=I.URI.file(this.request.path),o=(0,b.basename)(d),n=(0,L.watch)(d);w.add((0,_.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${d}'`);const s=new Set;if(g)try{for(const r of await u.Promises.readdir(d))s.add(r)}catch(r){this.error(r)}const t=new Map;w.add((0,_.toDisposable)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(l.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${a}`);let C="";if(a&&(C=a.toString(),m.isMacintosh&&(C=(0,R.normalizeNFC)(C))),!(!C||r!=="change"&&r!=="rename"))if(g)if(r==="rename"){t.get(C)?.dispose();const p=setTimeout(async()=>{if(t.delete(C),C===o&&!await u.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,b.join)(d,C));if(l.token.isCancellationRequested)return;let y;h?s.has(C)?y=0:(y=1,s.add(C)):(s.delete(C),y=2),this.onFileChange({resource:(0,P.joinPath)(i,C),type:y,cId:this.request.correlationId})},v.FILE_DELETE_HANDLER_DELAY);t.set(C,(0,_.toDisposable)(()=>clearTimeout(p)))}else{let p;s.has(C)?p=0:(p=1,s.add(C)),this.onFileChange({resource:(0,P.joinPath)(i,C),type:p,cId:this.request.correlationId})}else if(r==="rename"||C!==o){const p=setTimeout(async()=>{const h=await u.Promises.exists(d);l.token.isCancellationRequested||(h?(this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0),w.add(await this.doWatch(d,!1))):(this.onFileChange({resource:i,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,_.toDisposable)(()=>clearTimeout(p)))}else this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0)})}catch(i){await u.Promises.exists(d)&&!l.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,_.toDisposable)(()=>{l.dispose(!0),w.dispose()})}onFileChange(d,g=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!g&&this.excludes.some(l=>l(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.resource.fsPath}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(l=>l(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.resource.fsPath}`):this.fileChangesAggregator.work(d))}handleFileChanges(d){const g=(0,f.coalesceEvents)(d);if(g.length>0){if(this.verboseLogging)for(const w of g)this.trace(` >> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`);this.throttledFileChangesEmitter.work(g)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(d){if(m.isLinux)return u.Promises.exists(d);try{const g=(0,b.basename)(d);return(await u.Promises.readdir((0,b.dirname)(d))).some(w=>w===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v;async function E(c,d,g,l,w=512){const i=await u.Promises.open(c,"r"),o=Buffer.allocUnsafe(w),n=new A.CancellationTokenSource(l);let s,t=!1;const r={path:c,excludes:[],recursive:!1},a=new v(r,C=>{(async()=>{for(const{type:p}of C)if(p===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await u.Promises.read(i,o,0,w,null);if(!h||n.token.isCancellationRequested)break;d(o.slice(0,h))}}catch(h){s=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,g(),new Promise((C,p)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await u.Promises.close(i)}catch(h){s=new Error(h)}s?p(s):C()})})}e.watchFileContents=E}),define(le[195],ue([0,1,3,91,2,5,194]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends A.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new L.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=L.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const P=this.normalizeRequests(m),I=P.filter(u=>{const f=this.watchers.get(u.path);return f?!(0,O.patternsEquals)(f.request.excludes,u.excludes)||!(0,O.patternsEquals)(f.request.includes,u.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:u})=>!P.find(f=>f.path===u.path&&(0,O.patternsEquals)(f.excludes,u.excludes)&&(0,O.patternsEquals)(f.includes,u.includes))).map(({request:u})=>u.path);I.length&&this.trace(`Request to start watching: ${I.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const u of S)this.stopWatching(u);for(const u of I)this.startWatching(u)}startWatching(m){const P=new _.NodeJSFileWatcherLibrary(m,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),I={request:m,instance:P};this.watchers.set(m.path,I)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const P=this.watchers.get(m);P&&(this.watchers.delete(m),P.instance.dispose())}normalizeRequests(m){const P=new Map;for(const I of m){const S=T.isLinux?I.path:I.path.toLowerCase();let u=P.get(I.correlationId);u||(u=new Map,P.set(I.correlationId,u)),u.set(S,I)}return Array.from(P.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(m){this.verboseLogging=m;for(const[,P]of this.watchers)P.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,P){return P?`[File Watcher (node.js)] ${m} (path: ${P.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=R}),define(le[196],ue([0,1,51,195]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends L.AbstractNonRecursiveWatcherClient{constructor(_,R,b){super(_,R,b),this.init()}createWatcher(_){return _.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=A}),define(le[197],ue([0,1,23,40,93,51]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends T.AbstractUniversalWatcherClient{constructor(b,m,P){super(b,m,P),this.init()}createWatcher(b){const m=b.add(new A.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(m.onDidProcessExit(({code:P,signal:I})=>this.onError(`terminated by itself with code ${P}, signal: ${I}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(le[74],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...A){this._entries=new Map;for(const[T,_]of A)this.set(T,_)}set(A,T){const _=this._entries.get(A);return this._entries.set(A,T),_}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=L}),define(le[198],ue([0,1,6,7,2,72,189,4,74,87]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class I extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class S{constructor(E=new b.ServiceCollection,c=!1,d,g=P){this._services=E,this._strict=c,this._parent=d,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=g?d?._globalGraph??new _.Graph(l=>l):void 0}createChild(E){return new S(E,this._strict,this,this._enableTracing)}invokeFunction(E,...c){const d=f.traceInvocation(this._enableTracing,E);let g=!1;try{return E({get:w=>{if(g)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(w,d);if(!i)throw new Error(`[invokeFunction] unknown service '${w}'`);return i}},...c)}finally{g=!0,d.stop()}}createInstance(E,...c){let d,g;return E instanceof T.SyncDescriptor?(d=f.traceCreation(this._enableTracing,E.ctor),g=this._createInstance(E.ctor,E.staticArguments.concat(c),d)):(d=f.traceCreation(this._enableTracing,E),g=this._createInstance(E,c,d)),d.stop(),g}_createInstance(E,c=[],d){const g=R._util.getServiceDependencies(E).sort((i,o)=>i.index-o.index),l=[];for(const i of g){const o=this._getOrCreateServiceInstance(i.id,d);o||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),l.push(o)}const w=g.length>0?g[0].index:c.length;if(c.length!==w){console.trace(`[createInstance] First service dependency of ${E.name} at position ${w+1} conflicts with ${c.length} static arguments`);const i=w-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,w)}return Reflect.construct(E,c.concat(l))}_setServiceInstance(E,c){if(this._services.get(E)instanceof T.SyncDescriptor)this._services.set(E,c);else if(this._parent)this._parent._setServiceInstance(E,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const c=this._services.get(E);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):c}_getOrCreateServiceInstance(E,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const d=this._getServiceInstanceOrDescriptor(E);return d instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,d,c.branch(E,!0)):(c.branch(E,!1),d)}_safeCreateAndCacheServiceInstance(E,c,d){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,c,d)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,c,d){const g=new _.Graph(i=>i.id.toString());let l=0;const w=[{id:E,desc:c,_trace:d}];for(;w.length;){const i=w.pop();if(g.lookupOrInsertNode(i),l++>1e3)throw new I(g);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof T.SyncDescriptor){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};g.insertEdge(i,s),w.push(s)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new I(g);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}g.removeNode(o)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,c,d=[],g,l){if(this._services.get(E)instanceof T.SyncDescriptor)return this._createServiceInstance(E,c,d,g,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,c,d,g,l);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(E,c,d=[],g,l){if(g){const w=new S(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(E);const i=new Map,o=new L.GlobalIdleValue(()=>{const n=w._createInstance(c,d,l);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new m.LinkedList,i.set(s,a)),(p,h,y)=>{if(o.isInitialized)return o.value[s](p,h,y);{const D={listener:[p,h,y],disposable:void 0},U=a.push(D);return(0,A.toDisposable)(()=>{U(),D.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return c.prototype}})}else return this._createInstance(c,d,l)}_throwIfStrict(E,c){if(c&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=S;var u;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(u||(u={}));class f{static{this.all=new Set}static{this._None=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(E,c){return E?new f(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(E,c){return E?new f(1,c.name):f._None}static{this._totals=0}constructor(E,c){this.type=E,this.name=c,this._start=Date.now(),this._dep=[]}branch(E,c){const d=new f(3,E.toString());return this._dep.push([E,c,d]),d}stop(){const E=Date.now()-this._start;f._totals+=E;let c=!1;function d(l,w){const i=[],o=new Array(l+1).join("	");for(const[n,s,t]of w._dep)if(s&&t){c=!0,i.push(`${o}CREATES -> ${n}`);const r=d(l+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(E>2||c)&&f.all.add(g.join(`
`))}}e.Trace=f}),define(le[56],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class O{constructor(T,_){this.server=T,this.router=_}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,_){this.server.registerChannel(T,_)}}e.MainProcessService=O}),define(le[75],ue([0,1,26,2,5,165,29,4]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function b(P){return P.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=b,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let m=class extends O.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new L.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let S;try{S=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const f=S.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(E=>E.startsWith("lp-"))).map(v=>{const E=v.properties.localizedLanguages?.[0],c=b(v);return{...this.createQuickPickItem(c,E,v),extensionId:v.identifier.id,galleryExtension:v}});return f.push(this.createQuickPickItem("en","English")),f}createQuickPickItem(I,S,u){const f=S??I;let v;if(f!==I&&(v=`(${I})`),I.toLowerCase()===A.language.toLowerCase()&&(v??="",v+=(0,T.localize)(0,null)),u?.installCount){v??="";const E=u.installCount;let c;E>1e6?c=`${Math.floor(E/1e5)/10}M`:E>1e3?c=`${Math.floor(E/1e3)}K`:c=String(E),v+=` $(cloud-download) ${c}`}return{id:I,label:f,description:v}}};e.LanguagePackBaseService=m,e.LanguagePackBaseService=m=Ee([G(0,_.IExtensionGalleryService)],m)}),define(le[199],ue([0,1,2,75]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends L.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=A,e.LocalizationsUpdater=A=Ee([G(0,O.ILanguagePackService)],A)}),define(le[8],ue([0,1,38,3,54,2,35,5,20,12,10,94,4]),function(se,e,L,O,A,T,_,R,b,m,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function u(){return new Date().toISOString()}function f(p){return(0,m.isNumber)(p)}e.isLogLevel=f;var v;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function E(p,h,y){switch(h){case v.Trace:p.trace(y);break;case v.Debug:p.debug(y);break;case v.Info:p.info(y);break;case v.Warning:p.warn(y);break;case v.Error:p.error(y);break;case v.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=E;function c(p,h=!1){let y="";for(let D=0;D<p.length;D++){let U=p[D];if(U instanceof Error&&(U=(0,L.toErrorMessage)(U,h)),typeof U=="object")try{U=JSON.stringify(U)}catch{}y+=(D>0?" ":"")+U}return y}class d extends T.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(h){this.level!==h&&(this.level=h,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(h){return this.level!==v.Off&&this.level<=h}}e.AbstractLogger=d;class g extends d{constructor(h){super(),this.logAlways=h}checkLogLevel(h){return this.logAlways||super.checkLogLevel(h)}trace(h,...y){this.checkLogLevel(v.Trace)&&this.log(v.Trace,c([h,...y],!0))}debug(h,...y){this.checkLogLevel(v.Debug)&&this.log(v.Debug,c([h,...y]))}info(h,...y){this.checkLogLevel(v.Info)&&this.log(v.Info,c([h,...y]))}warn(h,...y){this.checkLogLevel(v.Warning)&&this.log(v.Warning,c([h,...y]))}error(h,...y){if(this.checkLogLevel(v.Error))if(h instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=h.stack,this.log(v.Error,c(D))}else this.log(v.Error,c([h,...y]))}flush(){}}e.AbstractMessageLogger=g;class l extends d{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.useColors=!R.isWindows}trace(h,...y){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,h,...y):console.log(`[main ${u()}]`,h,...y))}debug(h,...y){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,h,...y):console.log(`[main ${u()}]`,h,...y))}info(h,...y){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,h,...y):console.log(`[main ${u()}]`,h,...y))}warn(h,...y){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,h,...y):console.warn(`[main ${u()}]`,h,...y))}error(h,...y){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,h,...y):console.error(`[main ${u()}]`,h,...y))}flush(){}}e.ConsoleMainLogger=l;class w extends d{constructor(h=e.DEFAULT_LOG_LEVEL,y=!0){super(),this.useColors=y,this.setLevel(h)}trace(h,...y){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",h,...y):console.log(h,...y))}debug(h,...y){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",h,...y):console.log(h,...y))}info(h,...y){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",h,...y):console.log(h,...y))}warn(h,...y){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",h,...y):console.log(h,...y))}error(h,...y){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",h,...y):console.error(h,...y))}flush(){}}e.ConsoleLogger=w;class i extends d{constructor(h,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=h,this.setLevel(y)}trace(h,...y){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(h),...y])}debug(h,...y){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(h),...y])}info(h,...y){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(h),...y])}warn(h,...y){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(h),...y])}error(h,...y){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(h),...y])}extractMessage(h){return typeof h=="string"?h:(0,L.toErrorMessage)(h,this.checkLogLevel(v.Trace))}flush(){}}e.AdapterLogger=i;class o extends d{constructor(h){super(),this.loggers=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const y of this.loggers)y.setLevel(h);super.setLevel(h)}trace(h,...y){for(const D of this.loggers)D.trace(h,...y)}debug(h,...y){for(const D of this.loggers)D.debug(h,...y)}info(h,...y){for(const D of this.loggers)D.info(h,...y)}warn(h,...y){for(const D of this.loggers)D.warn(h,...y)}error(h,...y){for(const D of this.loggers)D.error(h,...y)}flush(){for(const h of this.loggers)h.flush()}dispose(){for(const h of this.loggers)h.dispose();super.dispose()}}e.MultiplexLogger=o;class n extends T.Disposable{constructor(h,y,D){if(super(),this.logLevel=h,this.logsHome=y,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,D)for(const U of D)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(h){return(0,m.isString)(h)?[...this._loggers.values()].find(y=>y.info.id===h):this._loggers.get(h)}getLogger(h){return this.getLoggerEntry(h)?.logger}createLogger(h,y){const D=this.toResource(h),U=(0,m.isString)(h)?h:y?.id??(0,A.hash)(D.toString()).toString(16);let M=this._loggers.get(D)?.logger;const F=y?.logLevel==="always"?v.Trace:y?.logLevel;M||(M=this.doCreateLogger(D,F??this.getLogLevel(D)??this.logLevel,{...y,id:U}));const z={logger:M,info:{resource:D,id:U,logLevel:F,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(z.info),this._loggers.set(D,z),M}toResource(h){return(0,m.isString)(h)?(0,b.joinPath)(this.logsHome,`${h}.log`):h}setLogLevel(h,y){if(P.URI.isUri(h)){const D=h,U=y,M=this._loggers.get(D);M&&U!==M.info.logLevel&&(M.info.logLevel=U===this.logLevel?void 0:U,M.logger?.setLevel(U),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([D,U]))}else{this.logLevel=h;for(const[D,U]of this._loggers.entries())this._loggers.get(D)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(h,y){const D=this.getLoggerEntry(h);D&&y!==!D.info.hidden&&(D.info.hidden=!y,this._loggers.set(D.info.resource,D),this._onDidChangeVisibility.fire([D.info.resource,y]))}getLogLevel(h){let y;return h&&(y=this._loggers.get(h)?.info.logLevel),y??this.logLevel}registerLogger(h){const y=this._loggers.get(h.resource);y?y.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this._loggers.set(h.resource,{info:h,logger:void 0}),this._onDidChangeLoggers.fire({added:[h],removed:[]}))}deregisterLogger(h){const y=this._loggers.get(h);y&&(y.logger&&y.logger.dispose(),this._loggers.delete(h),this._onDidChangeLoggers.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const h of this._loggers.values())yield h.info}getRegisteredLogger(h){return this._loggers.get(h)?.info}dispose(){this._loggers.forEach(h=>h.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class s{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(h){}getLevel(){return v.Info}trace(h,...y){}debug(h,...y){}info(h,...y){}warn(h,...y){}error(h,...y){}critical(h,...y){}dispose(){}flush(){}}e.NullLogger=s;class t extends s{}e.NullLogService=t;function r(p){if(p.verbose)return v.Trace;if(typeof p.logLevel=="string"){const h=C(p.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(p){switch(p){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=a;function C(p){switch(p){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",a(v.Info))}),define(le[200],ue([0,1,6,7,2,23,16,20,31,15,8]),function(se,e,L,O,A,T,_,R,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends A.Disposable{constructor(u,f){super(),this.environmentService=u,this.logService=f,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const u=(0,R.basename)(this.environmentService.logsHome),f=(0,R.dirname)(this.environmentService.logsHome.with({scheme:T.Schemas.file})).fsPath,c=(await b.Promises.readdir(f)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==u),d=c.slice(0,Math.max(0,c.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(g=>b.Promises.rm((0,_.join)(f,g)))))}catch(u){(0,O.onUnexpectedError)(u)}}};e.LogsDataCleaner=I,e.LogsDataCleaner=I=Ee([G(0,m.IEnvironmentService),G(1,P.ILogService)],I)}),define(le[99],ue([0,1,7,4,8]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");let T=class{constructor(R){this.logService=R}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((R,b)=>se(["@vscode/vsce-sign"],async m=>R(m),b))),this.moduleLoadingPromise}async verify(R,b,m){let P;try{P=await this.vsceSign()}catch(I){return this.logService.error("Could not load vsce-sign module",(0,L.getErrorMessage)(I)),!1}return P.verify(R,b,m)}};e.ExtensionSignatureVerificationService=T,e.ExtensionSignatureVerificationService=T=Ee([G(0,A.ILogService)],T)}),define(le[201],ue([0,1,17,6,7,3,2,16,51,8]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends _.Disposable{constructor(S,u){super(),this.logService=S,this.options=u,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(S,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,u):this.watchNonRecursive(S,u)}watchUniversal(S,u){const f={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},v=(0,L.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,A.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,b.reviveFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const u of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const u of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(u)&&S.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,u){const f={path:this.toFilePath(S),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},v=(0,L.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,A.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,b.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,R.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(le[202],ue([0,1,17,6,14,26,3,54,61,2,48,23,100,20,47,161,11,98,8,7]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends m.Disposable{static{l=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new _.Emitter),this._onDidUncorrelatedFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${o}`);const s=new m.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new E.FileChangesEvent(t,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,m.dispose)(s)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(s){n.push(s)}}),!this.provider.has(o)&&await O.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const s=this.provider.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return b.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,u.isAbsolutePath)(o))throw new E.FileOperationError((0,v.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const s=new g.ErrorNoTelemetry;throw s.message=(0,v.localize)(1,null,o.toString()),s}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)||(0,E.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(s){throw(0,E.toFileSystemProviderErrorCode)(s)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,v.localize)(2,null,this.resourceForError(o)),1):(0,E.ensureFileSystemProviderError)(s)}}async doResolveFile(o,n){const s=await this.withProvider(o),t=this.isPathCaseSensitive(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,C=n?.resolveMetadata,p=await s.stat(o);let h;return this.toFileStat(s,o,p,void 0,!!C,(y,D)=>(h||(h=P.TernarySearchTree.forUris(()=>!t),h.set(o,!0),r&&h.fill(!0,r)),h.get(y.resource)||h.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?D===1:!1))}async toFileStat(o,n,s,t,r,a){const{providerExtUri:C}=this.getExtUri(o),p={resource:n,name:C.basename(n),isFile:(s.type&E.FileType.File)!==0,isDirectory:(s.type&E.FileType.Directory)!==0,isSymbolicLink:(s.type&E.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&E.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&E.FilePermission.Locked),etag:(0,E.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(p.isDirectory&&a(p,t)){try{const h=await o.readdir(n),y=await O.Promises.settled(h.map(async([D,U])=>{try{const M=C.joinPath(n,D),F=r?await o.stat(M):{type:U};return await this.toFileStat(o,M,F,h.length,r,a)}catch(M){return this.logService.trace(M),null}}));p.children=(0,L.coalesce)(y)}catch(h){this.logService.trace(h),p.children=[]}return p}return p}async resolveAll(o){return O.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.withProvider(o),s=await n.stat(o);return this.toFileStat(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(s){return s}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new E.FileOperationError((0,v.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=A.VSBuffer.fromString(""),s){await this.doValidateCreateFile(o,s);const t=await this.writeFile(o,n);return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,t)),t}async writeFile(o,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(t);let a=s;if((0,E.hasFileAtomicWriteCapability)(t)&&!a?.atomic){const C=t.enforceAtomicWriteFile?.(o);C&&(a={...s,atomic:C})}try{await this.validateWriteFile(t,o,a)||await this.mkdirp(t,r.dirname(o));let p;if((0,E.hasReadWriteCapability)(t)&&!(n instanceof A.VSBuffer))if((0,f.isReadableStream)(n)){const h=await(0,f.peekStream)(n,3);h.ended?p=A.VSBuffer.concat(h.buffer):p=h}else p=(0,f.peekReadable)(n,h=>A.VSBuffer.concat(h),3);else p=n;!(0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)&&p instanceof A.VSBuffer||(0,E.hasReadWriteCapability)(t)&&(0,E.hasFileAtomicWriteCapability)(t)&&a?.atomic?await this.doWriteUnbuffered(t,o,a,p):await this.doWriteBuffered(t,o,a,p instanceof A.VSBuffer?(0,A.bufferToReadable)(p):p),this._onDidRunOperation.fire(new E.FileOperationEvent(o,4))}catch(C){throw new E.FileOperationError((0,v.localize)(4,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(C).toString()),(0,E.toFileOperationResult)(C),a)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.resourceForError(n)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.resourceForError(n)));if(t)throw new Error((0,v.localize)(8,null,this.resourceForError(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&E.FileType.Directory)throw new E.FileOperationError((0,v.localize)(9,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==E.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,E.etag)({mtime:s.mtime,size:a.size}))throw new E.FileOperationError((0,v.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(t,o,n,s):this.doReadFile(t,o,n,s)}async doReadFileAtomic(o,n,s,t){return new Promise((r,a)=>{this.writeQueue.queueFor(n,async()=>{try{const C=await this.doReadFile(o,n,s,t);r(C)}catch(C){a(C)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,n,s,t){const r=await this.doReadFileStream(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,A.streamToBuffer)(r.value)}}async readFileStream(o,n,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,n,s)}async doReadFileStream(o,n,s,t){const r=new T.CancellationTokenSource(t);let a=s;(0,E.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const C=this.validateReadFile(n,a).then(h=>h,h=>{throw r.dispose(!0),h});let p;try{return typeof a?.etag=="string"&&a.etag!==E.ETAG_DISABLED&&await C,a?.atomic&&(0,E.hasFileAtomicReadCapability)(o)||!((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasFileReadStreamCapability)(o))||(0,E.hasReadWriteCapability)(o)&&a?.preferUnbuffered?p=this.readFileUnbuffered(o,n,a):(0,E.hasFileReadStreamCapability)(o)?p=this.readFileStreamed(o,n,r.token,a):p=this.readFileBuffered(o,n,r.token,a),p.on("end",()=>r.dispose()),p.on("error",()=>r.dispose()),{...await C,value:p}}catch(h){throw p&&await(0,f.consumeStream)(p),this.restoreReadError(h,n,a)}}restoreReadError(o,n,s){const t=(0,v.localize)(11,null,this.resourceForError(n),(0,E.ensureFileSystemProviderError)(o).toString());return o instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(t,o.stat,s):o instanceof E.TooLargeFileOperationError?new E.TooLargeFileOperationError(t,o.fileOperationResult,o.size,o.options):new E.FileOperationError(t,(0,E.toFileOperationResult)(o),s)}readFileStreamed(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,f.transform)(r,{data:a=>a instanceof A.VSBuffer?a:A.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,n,t)},a=>A.VSBuffer.concat(a))}readFileBuffered(o,n,s,t=Object.create(null)){const r=(0,A.newWriteableBufferStream)();return(0,c.readFileIntoStream)(o,n,r,a=>a,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,n,t)},s),r}readFileUnbuffered(o,n,s){const t=(0,f.newWriteableStream)(r=>A.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,E.hasFileAtomicReadCapability)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(n,r.byteLength,s),t.end(A.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new E.FileOperationError((0,v.localize)(12,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&n.etag===s.etag)throw new E.NotModifiedSinceFileOperationError((0,v.localize)(13,null),s,n);return this.validateReadFileLimits(o,s.size,n),s}validateReadFileLimits(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new E.TooLargeFileOperationError((0,v.localize)(14,null,this.resourceForError(o)),7,n,s)}async canMove(o,n,s){return this.doCanMoveCopy(o,n,"move",s)}async canCopy(o,n,s){return this.doCanMoveCopy(o,n,"copy",s)}async doCanMoveCopy(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"move",!!s),C=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,a==="move"?2:3,C)),C}async copy(o,n,s){const t=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"copy",!!s),C=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,a==="copy"?3:2,C)),C}async doMoveCopy(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:C,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(o,n,s,t,r,a);if(C&&!p&&a&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,E.hasFileFolderCopyCapability)(o))await o.copy(n,t,{overwrite:a});else{const h=await this.resolve(n);h.isDirectory?await this.doCopyFolder(o,h,s,t):await this.doCopyFile(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.doMoveCopy(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,s,t){if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(o,n,s,t);if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(o,n,s,t);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(o,n,s,t);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasReadWriteCapability)(s))return this.doPipeUnbuffered(o,n,s,t)}async doCopyFolder(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await O.Promises.settled(n.children.map(async r=>{const a=this.getExtUri(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),s,a):this.doCopyFile(o,r.resource,s,a)}))}async doValidateMoveCopy(o,n,s,t,r,a){let C=!1;if(o===s){const{providerExtUri:h,isPathCaseSensitive:y}=this.getExtUri(o);if(y||(C=h.isEqual(n,t)),C&&r==="copy")throw new Error((0,v.localize)(15,null,this.resourceForError(n),this.resourceForError(t)));if(!C&&h.isEqualOrParent(t,n))throw new Error((0,v.localize)(16,null,this.resourceForError(n),this.resourceForError(t)))}const p=await this.exists(t);if(p&&!C){if(!a)throw new E.FileOperationError((0,v.localize)(17,null,this.resourceForError(n),this.resourceForError(t)),4);if(o===s){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(n,t))throw new Error((0,v.localize)(18,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:p,isSameResourceWithDifferentPathCase:C}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,s)),s}async mkdirp(o,n){const s=[],{providerExtUri:t}=this.getExtUri(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&E.FileType.Directory))throw new Error((0,v.localize)(19,null,this.resourceForError(n)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,E.toFileSystemProviderErrorCode)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(s){return s}return!0}async doValidateDelete(o,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,v.localize)(20,null,this.resourceForError(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,v.localize)(21,null,this.resourceForError(o)));if(t&&r)throw new Error((0,v.localize)(22,null,this.resourceForError(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.throwIfFileIsReadonly(o,a);else throw new E.FileOperationError((0,v.localize)(23,null,this.resourceForError(o)),1);if(!!!n?.recursive){const p=await this.resolve(o);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,v.localize)(24,null,this.resourceForError(o)))}return s}async del(o,n){const s=await this.doValidateDelete(o,n);let t=n;if((0,E.hasFileAtomicDeleteCapability)(s)&&!t?.atomic){const p=s.enforceAtomicDelete?.(o);p&&(t={...n,atomic:p})}const r=!!t?.useTrash,a=!!t?.recursive,C=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:C}),this._onDidRunOperation.fire(new E.FileOperationEvent(o,1))}async cloneFile(o,n){const s=await this.withProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(s===t&&this.getExtUri(s).providerExtUri.isEqual(o,n)))return s===t&&(0,E.hasFileCloneCapability)(s)?s.cloneFile(o,n):(await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),s===t&&(0,E.hasFileFolderCopyCapability)(s)?this.writeQueue.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.getExtUri(s).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(s,o,t,n),this.getExtUri(s).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:l.WATCHER_CORRELATION_IDS++})}watch(o,n={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let t=!1,r=()=>{t=!0};s.add((0,m.toDisposable)(()=>r())),(async()=>{try{const C=await this.doWatch(o,n);t?(0,m.dispose)(C):r=()=>(0,m.dispose)(C)}catch(C){this.logService.error(C)}})();const a=n.correlationId;if(typeof a=="number"){const C=s.add(new _.Emitter);return s.add(this.internalOnDidFilesChange.event(h=>{h.correlates(a)&&C.fire(h)})),{onDidChange:C.event,dispose:()=>s.dispose()}}return s}async doWatch(o,n){const s=await this.withProvider(o),t=(0,R.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(o),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,s,t){return this.writeQueue.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await o.close(r)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,n,s){let t=0,r;if((0,f.isReadableBufferedStream)(s)){if(s.buffer.length>0){const a=A.VSBuffer.concat(s.buffer);await this.doWriteBuffer(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,C)=>{(0,f.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(o,n,p,p.byteLength,t,0)}catch(h){return C(h)}t+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>C(p),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(o,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(o,n,s,t,r,a){let C=0;for(;C<t;){const p=await o.write(n,r+C,s.buffer,a+C,t-C);C+=p}}async doWriteUnbuffered(o,n,s,t){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(o,n,s,t),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,n,s,t){let r;t instanceof A.VSBuffer?r=t:(0,f.isReadableStream)(t)?r=await(0,A.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?r=await(0,A.bufferedStreamToBuffer)(t):r=(0,A.readableToBuffer)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeBufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeBufferedQueued(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const C=A.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,h=0,y=0;do y=await o.read(r,p,C.buffer,h,C.byteLength-h),await this.doWriteBuffer(s,a,C,y,p,h),p+=y,h+=y,h===C.byteLength&&(h=0);while(y>0)}catch(C){throw(0,E.ensureFileSystemProviderError)(C)}finally{await O.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeUnbufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedQueued(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeUnbufferedToBufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.doWriteBuffer(s,r,A.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(o,n,s,t){const r=await(0,A.streamToBuffer)(this.readFileBuffered(o,n,T.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,r)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new E.FileOperationError((0,v.localize)(25,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,v.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=w,e.FileService=w=l=Ee([G(0,d.ILogService)],w)}),define(le[203],ue([0,1,50,274,6,35,14,3,49,2,16,5,20,47,31,164,11,98,201,38,197,196]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(o)}`)}})();class i extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(t=>S.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:t}=await f.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:E.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await f.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(n,r.name))).type:a=this.toType(r),t.push([r.name,a])}catch(a){this.logService.trace(a)}})),t}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let t;return s?.dangling?t=E.FileType.Unknown:n.isFile()?t=E.FileType.File:n.isDirectory()?t=E.FileType.Directory:t=E.FileType.Unknown,s&&(t|=E.FileType.SymbolicLink),t}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new A.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),t=await this.createResourceLock(n));const r=this.toFilePath(n);return await f.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{t?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,t){const r=(0,u.newWriteableStream)(a=>_.VSBuffer.concat(a.map(C=>_.VSBuffer.wrap(C))).buffer);return(0,c.readFileIntoStream)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,S.joinPath)((0,S.dirname)(n),`${(0,S.basename)(n)}${t.atomic.postfix}`),s,t):this.doWriteFile(n,s,t)}async canWriteFileAtomic(n){try{const s=this.toFilePath(n),{symbolicLink:t}=await f.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async doWriteFileAtomic(n,s,t,r){const a=new m.DisposableStore;try{a.add(await this.createResourceLock(n)),a.add(await this.createResourceLock(s)),await this.doWriteFile(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(C){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{a.dispose()}}async doWriteFile(n,s,t,r){let a;try{const C=this.toFilePath(n);if(!t.create||!t.overwrite){if(await f.Promises.exists(C)){if(!t.overwrite)throw(0,E.createFileSystemProviderError)((0,v.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,E.createFileSystemProviderError)((0,v.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(C){throw await this.toFileSystemProviderWriteError(n,C)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(n){i.canFlush=n}async open(n,s,t){const r=this.toFilePath(n);let a;(0,E.isFileOpenForWriteOptions)(s)&&!t&&(a=await this.createResourceLock(n));let C;try{if((0,E.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:h}=await f.SymlinkSupport.stat(r);h.mode&128||await f.Promises.chmod(r,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}let p;if((0,E.isFileOpenForWriteOptions)(s)){if(I.isWindows)try{await f.Promises.truncate(r,0),p="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}p||(p="w")}else p="r";C=await f.Promises.open(r,p)}catch(p){throw a?.dispose(),(0,E.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(C,0),(0,E.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(C,n),a){const p=this.mapHandleToLock.get(C);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${r})`),this.mapHandleToLock.set(C,a),p&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${r})`),p.dispose())}return C}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await f.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.logService.error(t)}return await f.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const C=this.normalizePos(n,s);let p=null;try{p=(await f.Promises.read(n,t,r,a,C)).bytesRead}catch(h){throw this.toFileSystemProviderError(h)}finally{this.updatePos(n,C,p)}return p}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,t){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.mapHandleToPos.set(n,r+t):this.mapHandleToPos.delete(n)))}async write(n,s,t,r,a){return(0,A.retry)(()=>this.doWrite(n,s,t,r,a),100,3)}async doWrite(n,s,t,r,a){const C=this.normalizePos(n,s);let p=null;try{p=(await f.Promises.write(n,t,r,a,C)).bytesWritten}catch(h){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),h)}finally{this.updatePos(n,C,p)}return p}async mkdir(n){try{await f.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const t=this.toFilePath(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,P.join)((0,P.dirname)(t),`${(0,P.basename)(t)}${s.atomic.postfix}`)),await f.Promises.rm(t,f.RimRafMode.MOVE,r)}else try{await f.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:C,symbolicLink:p}=await f.SymlinkSupport.stat(t);a=C.isDirectory()&&!p}catch{}if(a)await f.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.toFileSystemProviderError(t)}}async rename(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"move",t.overwrite),await f.Promises.rename(r,a)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(2,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"copy",t.overwrite),await f.Promises.copy(r,a,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(3,null,(0,P.basename)(r),(0,P.basename)((0,P.dirname)(a)),C.toString()))),this.toFileSystemProviderError(C)}}async validateMoveCopy(n,s,t,r){const a=this.toFilePath(n),C=this.toFilePath(s);let p=!1;if(!!(this.capabilities&1024)||(p=(0,b.isEqual)(a,C,!0)),p){if(t==="copy")throw(0,E.createFileSystemProviderError)((0,v.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const y=await this.statIgnoreError(n);if(!y)throw(0,E.createFileSystemProviderError)((0,v.localize)(5,null),E.FileSystemProviderErrorCode.FileNotFound);const D=await this.statIgnoreError(s);if(D){if(!r)throw(0,E.createFileSystemProviderError)((0,v.localize)(6,null),E.FileSystemProviderErrorCode.FileExists);y.type&E.FileType.File&&D.type&E.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s),C=!!(this.capabilities&1024);if((0,b.isEqual)(r,a,!C))return;const p=new m.DisposableStore;try{p.add(await this.createResourceLock(n)),p.add(await this.createResourceLock(s)),t&&await f.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await f.Promises.copyFile(r,a)}catch(h){if(h.code==="ENOENT"&&!t)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(h)}finally{p.dispose()}}createUniversalWatcher(n,s,t){return new l.UniversalWatcherClient(r=>n(r),r=>s(r),t)}createNonRecursiveWatcher(n,s,t){return new w.NodeJSWatcherClient(r=>n(r),r=>s(r),t)}toFileSystemProviderError(n){if(n instanceof E.FileSystemProviderError)return n;let s=n,t;switch(n.code){case"ENOENT":t=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=E.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=E.FileSystemProviderErrorCode.Unknown;break;default:t=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(s,t)}async toFileSystemProviderWriteError(n,s){let t=this.toFileSystemProviderError(s);if(n&&t.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await f.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(t=(0,E.createFileSystemProviderError)(s,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return t}}e.DiskFileSystemProvider=i}),define(le[101],ue([0,1,3,2,4,8]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let _=class extends O.Disposable{constructor(b){super(),this.logService=b,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_,e.SharedProcessLifecycleService=_=Ee([G(0,T.ILogService)],_)}),define(le[204],ue([0,1,10,3,8,2]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends A.AbstractLoggerService{constructor(I,S,u,f,v){super(S,u,f),this.windowId=I,this.channel=v,this._register(v.listen("onDidChangeLogLevel",I)(E=>{(0,A.isLogLevel)(E)?super.setLogLevel(E):super.setLogLevel(L.URI.revive(E[0]),E[1])})),this._register(v.listen("onDidChangeVisibility",I)(([E,c])=>super.setVisibility(L.URI.revive(E),c))),this._register(v.listen("onDidChangeLoggers",I)(({added:E,removed:c})=>{for(const d of E)super.registerLogger({...d,resource:L.URI.revive(d.resource)});for(const d of c)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(I,S)=>{this.channel.call("consoleLog",[I,S])}})}registerLogger(I){super.registerLogger(I),this.channel.call("registerLogger",[I,this.windowId])}deregisterLogger(I){super.deregisterLogger(I),this.channel.call("deregisterLogger",[I,this.windowId])}setLogLevel(I,S){super.setLogLevel(I,S),this.channel.call("setLogLevel",[I,S])}setVisibility(I,S){super.setVisibility(I,S),this.channel.call("setVisibility",[this.toResource(I),S])}doCreateLogger(I,S,u){return new R(this.channel,I,S,u,this.windowId)}static setLogLevel(I,S,u){return I.call("setLogLevel",[S,u])}}e.LoggerChannelClient=_;class R extends A.AbstractMessageLogger{constructor(I,S,u,f,v){super(f?.logLevel==="always"),this.channel=I,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,f,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,S){const u=[[I,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(I){this.channel.call("log",[this.file,I])}}class b{constructor(I,S){this.loggerService=I,this.getUriTransformer=S}listen(I,S){const u=this.getUriTransformer(I);switch(S){case"onDidChangeLoggers":return O.Event.map(this.loggerService.onDidChangeLoggers,f=>({added:[...f.added].map(v=>this.transformLogger(v,u)),removed:[...f.removed].map(v=>this.transformLogger(v,u))}));case"onDidChangeVisibility":return O.Event.map(this.loggerService.onDidChangeVisibility,f=>[u.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return O.Event.map(this.loggerService.onDidChangeLogLevel,f=>(0,A.isLogLevel)(f)?f:[u.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${S}`)}async call(I,S,u){const f=this.getUriTransformer(I);switch(S){case"setLogLevel":return(0,A.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(L.URI.revive(f.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(v=>this.transformLogger(v,f)))}throw new Error(`Call not found: ${S}`)}transformLogger(I,S){return{...I,resource:S.transformOutgoingURI(I.resource)}}}e.LoggerChannel=b;class m extends T.Disposable{constructor(I,S){super(),S.call("setLogLevel",[I.getLogLevel()]),this._register(I.onDidChangeLogLevel(u=>S.call("setLogLevel",[u]))),S.call("getRegisteredLoggers").then(u=>{for(const f of u)I.registerLogger({...f,resource:L.URI.revive(f.resource)})}),this._register(S.listen("onDidChangeVisibility")(([u,f])=>I.setVisibility(L.URI.revive(u),f))),this._register(S.listen("onDidChangeLoggers")(({added:u,removed:f})=>{for(const v of u)I.registerLogger({...v,resource:L.URI.revive(v.resource)});for(const v of f)I.deregisterLogger(v.resource)}))}}e.RemoteLoggerChannelClient=m}),define(le[205],ue([0,1,2,8]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends L.Disposable{constructor(_,R=[]){super(),this.logger=new O.MultiplexLogger([_,...R]),this._register(_.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...R){this.logger.trace(_,...R)}debug(_,...R){this.logger.debug(_,...R)}info(_,...R){this.logger.info(_,...R)}warn(_,...R){this.logger.warn(_,...R)}error(_,...R){this.logger.error(_,...R)}flush(){this.logger.flush()}}e.LogService=A}),define(le[57],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(le[206],ue([0,1,40,56]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let A=class{constructor(_,R){return this.windowId=_,L.ProxyChannel.toService(R.getChannel("nativeHost"),{context:_,properties:(()=>{const b=new Map;return b.set("windowId",_),b})()})}};e.NativeHostService=A,e.NativeHostService=A=Ee([G(1,O.IMainProcessService)],A)}),define(le[58],ue([0,1,3,61,2,4]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class _ extends A.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(m){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(m),O.Iterable.reduce(this.policies.entries(),(I,[S,u])=>({...I,[S]:u}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[P,I])=>({...m,[P]:{definition:I,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=_;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(le[207],ue([0,1,3,2,58]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(b){this.service=b,this.disposables=new O.DisposableStore}listen(b,m){switch(m){case"onDidChange":return L.Event.map(this.service.onDidChange,P=>P.reduce((I,S)=>({...I,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(b,m,P){switch(m){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class _ extends A.AbstractPolicyService{constructor(b,m){super(),this.channel=m;for(const P in b){const{definition:I,value:S}=b[P];this.policyDefinitions[P]=I,S!==void 0&&this.policies.set(P,S)}this.channel.listen("onDidChange")(P=>{for(const I in P){const S=P[I];S===null?this.policies.delete(I):this.policies.set(I,S)}this._onDidChange.fire(Object.keys(P))})}async _updatePolicyDefinitions(b){const m=await this.channel.call("updatePolicyDefinitions",b);for(const P in m)this.policies.set(P,m[P])}}e.PolicyChannelClient=_}),define(le[102],ue([0,1,36]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const T=A.context.configuration();if(T)O=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){O=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:T,searchUrl:_,itemUrl:R,controlUrl:b}=O.extensionsGallery||{};Object.assign(O,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||T,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||_,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||b}});try{const m=(...I)=>I.reduce((S,u)=>(Object.keys(u).forEach(f=>{Array.isArray(S[f])&&Array.isArray(u[f])?S[f]=u[f]:typeof S[f]=="object"&&typeof u[f]=="object"?S[f]=m(S[f],u[f]):S[f]=u[f]}),S),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};O=m(O,P)}catch{}if(L.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const m=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:m.version,release:m.release})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(le[24],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[208],ue([0,1,6,7,2,16,31,8,24]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let m=class extends A.Disposable{constructor(I,S,u){super(),this.productService=S,this.logService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},3e4)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),u=(0,T.dirname)(I),f=(0,T.basename)(I),v=await _.Promises.readdir(u);await Promise.all(v.map(async E=>{if(E===f)return;const c=(0,T.join)(u,E),d=await _.Promises.stat(c);if(d.isDirectory()&&S-d.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${E}.`),_.Promises.rm(c)}))}catch(S){(0,O.onUnexpectedError)(S)}}};e.CodeCacheCleaner=m,e.CodeCacheCleaner=m=Ee([G(1,b.IProductService),G(2,R.ILogService)],m)}),define(le[209],ue([0,1,6,7,2,16,31,15,8,24]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends A.Disposable{constructor(S,u,f){super(),this.environmentService=S,this.logService=u,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),u=JSON.parse(await _.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(u)){const g=u[d];S[`${g.hash}.${d}`]=!0}const f=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(f))return;const E=await _.Promises.readdir(f);for(const d of E){if(S[d]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await _.Promises.rm((0,T.join)(f,d))}const c=Date.now();for(const d of Object.keys(S)){const g=(0,T.join)(f,d),l=await _.Promises.readdir(g);for(const w of l){if(w==="tcf.json")continue;const i=(0,T.join)(g,w),o=await _.Promises.stat(i);o.isDirectory()&&c-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(d,w)}`),await _.Promises.rm(i))}}}catch(S){(0,O.onUnexpectedError)(S)}}};e.LanguagePackCachedDataCleaner=P,e.LanguagePackCachedDataCleaner=P=Ee([G(0,R.INativeEnvironmentService),G(1,b.ILogService),G(2,m.IProductService)],P)}),define(le[210],ue([0,1,16,4]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var A;(function(T){function _(b){return!!(b.samples&&b.timeDeltas)}T.isValidProfile=_;function R(b,m="noAbsolutePaths"){for(const P of b.nodes)P.callFrame&&P.callFrame.url&&((0,L.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,L.join)(m,(0,L.basename)(P.callFrame.url)));return b}T.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(le[211],ue([0,1,32]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((m,P)=>{se(["v8-inspect-profiler"],m,P)})).startProfiling({port:T.port,checkForPaused:!0}),b=(0,L.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(T){const _=this._sessions.get(T);if(!_)throw new Error(`UNKNOWN session '${T}'`);const R=await _.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=O}),define(le[41],ue([0,1,127,12]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(_,R){L.ok(O.isString(_)),L.ok(O.isObject(R)),L.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,R)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new A}),define(le[103],ue([0,1,3,41]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,m){this.schemasById[A(b)]=m,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new T;O.Registry.add(e.Extensions.JSONContribution,_)}),define(le[44],ue([0,1,17,3,12,151,21,103,41]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=b.Registry.as(R.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.doRegisterConfigurations(i,o,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(i,!1,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),C=a?.valuesSources??new Map;if(t)for(const D of Object.keys(s[r]))C.set(D,t);const p={...a?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:p,valuesSources:C});const h=(0,_.getLanguageTagSettingPlainKey)(r),y={type:"object",default:p,description:T.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:A.isString(t)?void 0:t,defaultValueSource:t};n.push(...v(r)),this.configurationProperties[r]=y,this.defaultLanguageConfigurationOverridesNode.properties[r]=y}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:t});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.configurationDefaultsOverrides.get(t),a=A.isString(s)?s:s?.id,C=A.isString(r?.source)?r?.source:r?.source?.id;if(a===C)if(o.add(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const p=this.configurationProperties[t];p&&(this.updatePropertyDefaultValue(t,p),this.updateSchema(t,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,n),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,n){i.forEach(s=>{this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.configurationProperties[t];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[t],this.removeFromSchema(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.configurationContributors.indexOf(s);t!==-1&&this.configurationContributors.splice(t,1)}}validateAndRegisterProperties(i,o=!0,n,s,t=3,r){t=A.isUndefinedOrNull(i.scope)?t:i.scope;const a=i.properties;if(a)for(const p in a){const h=a[p];if(o&&g(p,h)){delete a[p];continue}if(h.source=n,h.defaultDefaultValue=a[p].default,this.updatePropertyDefaultValue(p,h),e.OVERRIDE_PROPERTY_REGEX.test(p)?h.scope=void 0:(h.scope=A.isUndefinedOrNull(h.scope)?t:h.scope,h.restricted=A.isUndefinedOrNull(h.restricted)?!!s?.includes(p):h.restricted),a[p].hasOwnProperty("included")&&!a[p].included){this.excludedConfigurationProperties[p]=a[p],delete a[p];continue}else this.configurationProperties[p]=a[p],a[p].policy?.name&&this.policyConfigurations.set(a[p].policy.name,p);!a[p].deprecationMessage&&a[p].markdownDeprecationMessage&&(a[p].deprecationMessage=a[p].markdownDeprecationMessage),r.add(p)}const C=i.allOf;if(C)for(const p of C)this.validateAndRegisterProperties(p,o,n,s,t,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let s=n?.value,t=n?.source;A.isUndefined(s)&&(s=o.defaultDefaultValue,t=void 0),A.isUndefined(s)&&(s=c(o.type)),o.default=s,o.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",f=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(w){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let o=f.exec(w);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=f.exec(w)}}return(0,L.distinct)(i)}e.overrideIdentifiersFromKey=v;function E(w){return w.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=E;function c(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const d=new S;b.Registry.add(e.Extensions.Configuration,d);function g(w,i){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?T.localize(7,null,w):d.getConfigurationProperties()[w]!==void 0?T.localize(8,null,w):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,w,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}e.validateProperty=g;function l(){const w=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))w.push([o,i[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=l}),define(le[76],ue([0,1,17,3,34,2,35,30,12,10,21,44,41]),function(se,e,L,O,A,T,_,R,b,m,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class f{constructor(n={},s=[],t=[],r){this._contents=n,this._keys=s,this._overrides=t,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof f)return s;const t=new v("");return t.parseRaw(s),t.configurationModel});this._rawConfiguration=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return u(t.rawConfiguration.getValue(n))},get override(){return s?u(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return u(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:C,keys:p}of t.rawConfiguration.overrides){const h=new f(a,p).getValue(n);h!==void 0&&r.push({identifiers:C,value:h})}return r.length?u(r):void 0}}}getOverrideValue(n,s){const t=this.getContentsForOverrideIdentifer(s);return t?n?(0,P.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return L.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return L.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=R.deepClone(this.contents),t=R.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const C of n)if(a.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(s,C.contents);for(const p of C.overrides){const[h]=t.filter(y=>L.equals(y.identifiers,p.identifiers));h?(this.mergeContents(h.contents,p.contents),h.keys.push(...p.keys),h.keys=L.distinct(h.keys)):t.push(R.deepClone(p))}for(const p of C.keys)r.indexOf(p)===-1&&r.push(p)}return new f(s,r,t,a.every(C=>C instanceof f)?void 0:a)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of L.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const C=s[r];C&&(typeof a=="object"&&typeof C=="object"?(a=R.deepClone(a),this.mergeContents(a,C)):a=C),t[r]=a}return new f(t,this.keys,this.overrides)}mergeContents(n,s){for(const t of Object.keys(s)){if(t in n&&b.isObject(n[t])&&b.isObject(s[t])){this.mergeContents(n[t],s[t]);continue}n[t]=R.deepClone(s[t])}}getContentsForOverrideIdentifer(n){let s=null,t=null;const r=a=>{a&&(t?this.mergeContents(t,a):t=R.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,P.removeFromValueTree)(this.contents,n),I.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>L.equals(t.identifiers,(0,I.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,t){(0,P.addToValueTree)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),I.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,P.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=f;class v{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!b.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:t,keys:r,overrides:a,restricted:C,hasExcludedProperties:p}=this.doParseRaw(n,s);this._configurationModel=new f(t,r,a,p?[n]:void 0),this._restrictedConfigurations=C||[]}doParseContent(n){let s={},t=null,r=[];const a=[],C=[];function p(y){Array.isArray(r)?r.push(y):t!==null&&(r[t]=y)}const h={onObjectBegin:()=>{const y={};p(y),a.push(r),r=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const y=[];p(y),a.push(r),r=y,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:p,onError:(y,D,U)=>{C.push({error:y,offset:D,length:U})}};if(n)try{A.visit(n,h),s=r[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return s}doParseRaw(n,s){const t=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,t,!0,s);n=r.raw;const a=(0,P.toValuesTree)(n,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),C=Object.keys(n),p=this.toOverrides(n,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:a,keys:C,overrides:p,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const C={},p=[];for(const h in n)if(I.OVERRIDE_PROPERTY_REGEX.test(h)&&t){const y=this.filter(n[h],s,!1,r);C[h]=y.raw,a=a||y.hasExcludedProperties,p.push(...y.restricted)}else{const y=s[h],D=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&p.push(h),!r.exclude?.includes(h)&&(r.include?.includes(h)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&y?.restricted))?C[h]=n[h]:a=!0}return{raw:C,restricted:p,hasExcludedProperties:a}}toOverrides(n,s){const t=[];for(const r of Object.keys(n))if(I.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const C in n[r])a[C]=n[r][C];t.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,s)})}return t}}e.ConfigurationModelParser=v;class E extends T.Disposable{constructor(n,s,t,r){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=r,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class c{constructor(n,s,t,r,a,C,p,h,y,D,U,M,F){this.key=n,this.overrides=s,this._value=t,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=C,this.applicationConfiguration=p,this.userConfiguration=h,this.localUserConfiguration=y,this.remoteUserConfiguration=D,this.workspaceConfiguration=U,this.folderConfigurationModel=M,this.memoryConfigurationModel=F}get value(){return u(this._value)}toInspectValue(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class d{constructor(n,s,t,r,a=new f,C=new f,p=new _.ResourceMap,h=new f,y=new _.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=C,this._folderConfigurations=p,this._memoryConfiguration=h,this._memoryConfigurationByResource=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,s,t){return this.getConsolidatedConfigurationModel(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new f,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,t){const r=this.getConsolidatedConfigurationModel(n,s,t),a=this.getFolderConfigurationModelForResource(s.resource,t),C=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,p=new Set;for(const h of r.overrides)for(const y of h.identifiers)r.getOverrideValue(n,y)!==void 0&&p.add(y);return new c(n,s,r.getValue(n),p.size?[...p]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this._workspaceConfiguration:void 0,a||void 0,C)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:C}=w(this._defaultConfiguration,n);s=[...r,...a,...C]}for(const r of s)for(const a of(0,I.overrideIdentifiersFromKey)(r)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=n.getKeysForOverrideIdentifier(a),h=[...p.filter(y=>C.indexOf(y)===-1),...C.filter(y=>p.indexOf(y)===-1),...C.filter(y=>!R.equals(this._defaultConfiguration.override(a).getValue(y),n.override(a).getValue(y)))];t.push([a,h])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=w(this._policyConfiguration,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.applicationConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateApplicationConfiguration(n),{keys:C,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.localUserConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateLocalUserConfiguration(n),{keys:C,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.remoteUserConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateRemoteUserConfiguration(n),{keys:C,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=w(this.workspaceConfiguration,n),C=[...s,...t,...r];return C.length&&this.updateWorkspaceConfiguration(n),{keys:C,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:C,overrides:p}=w(t,s),h=[...r,...a,...C];return(h.length||!t)&&this.updateFolderConfiguration(n,s),{keys:h,overrides:p}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:C}=w(s,void 0);return{keys:[...t,...r,...a],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const r=s.getFolder(n);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const a=this._memoryConfigurationByResource.get(n);a&&(t=t.merge(a))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(s=t.merge(r),this._foldersConsolidatedConfigurations.set(n,s)):s=t}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),C=this.parseConfigurationModel(n.workspace),p=n.folders.reduce((h,y)=>(h.set(m.URI.revive(y[0]),this.parseConfigurationModel(y[1])),h),new _.ResourceMap);return new d(s,t,r,a,new f,C,p,new f,new _.ResourceMap)}static parseConfigurationModel(n){return new f(n.contents,n.keys,n.overrides)}}e.Configuration=d;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,C])=>{const p=(0,_.getOrSet)(s,a,new Set);C.forEach(h=>p.add(h))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=g;class l{constructor(n,s,t,r){this.change=n,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const C of a)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const t=this._marker+n,r=this._affectsConfigStr.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(a);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(s){const p=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!R.equals(p,h)}return!0}}e.ConfigurationChangeEvent=l;function w(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],C=o?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const h=p.filter(y=>!C.includes(y));for(const y of h)a.push([y,n.getKeysForOverrideIdentifier(y)])}if(o){const h=C.filter(y=>!p.includes(y));for(const y of h)a.push([y,o.getKeysForOverrideIdentifier(y)])}if(n&&o){for(const h of C)if(p.includes(h)){const y=i({contents:o.getOverrideValue(void 0,h)||{},keys:o.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});a.push([h,[...y.added,...y.removed,...y.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const C=(0,P.getConfigurationValue)(n.contents,a),p=(0,P.getConfigurationValue)(o.contents,a);R.equals(C,p)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[212],ue([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class S extends A.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(I.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:c})=>this.onDidUpdateConfiguration(Array.from(E),c))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(E,c){this.updateConfigurationModel(E,I.Registry.as(b.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:E})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const E=I.Registry.as(b.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(E),E)}updateConfigurationModel(E,c){const d=this.getConfigurationDefaultOverrides();for(const g of E){const l=d[g],w=c[g];l!==void 0?this._configurationModel.addValue(g,l):w?this._configurationModel.addValue(g,w.default):this._configurationModel.removeValue(g)}}}e.DefaultConfiguration=S;class u{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let f=class extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(E,c,d){super(),this.defaultConfiguration=E,this.policyService=c,this.logService=d,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(E=>this.onDidChangePolicies(E))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:E})=>this.update(await this.updatePolicyDefinitions(E),!0))),this._configurationModel}async updatePolicyDefinitions(E){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",E);const c={},d=[],g=I.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const l of E){const w=g[l];if(!w){d.push(l);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.logService.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}d.push(l),c[w.policy.name]={type:w.type}}}return(0,_.isEmptyObject)(c)||await this.policyService.updatePolicyDefinitions(c),d}onDidChangePolicies(E){this.logService.trace("PolicyConfiguration#onDidChangePolicies",E);const c=I.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),d=(0,L.coalesce)(E.map(g=>c.get(g)));this.update(d,!0)}update(E,c){this.logService.trace("PolicyConfiguration#update",E);const d=I.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),g=[],l=this._configurationModel.isEmpty();for(const w of E){const i=d[w]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(l?o!==void 0:!(0,T.equals)(this._configurationModel.getValue(w),o))&&g.push([w,o])}else this._configurationModel.getValue(w)!==void 0&&g.push([w,void 0])}if(g.length){this.logService.trace("PolicyConfiguration#changed",g);const w=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const i of w.keys)this._configurationModel.setValue(i,w.getValue(i));for(const[i,o]of g)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=f,e.PolicyConfiguration=f=Ee([G(1,P.IPolicyService),G(2,m.ILogService)],f)}),define(le[213],ue([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,212,58]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class c extends b.Disposable{constructor(l,w,i,o){super(),this.settingsResource=l,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new v.DefaultConfiguration),this.policyConfiguration=i instanceof E.NullPolicyService?new v.NullPolicyConfiguration:this._register(new v.PolicyConfiguration(this.defaultConfiguration,i,o)),this.userConfiguration=this._register(new u.UserSettings(this.settingsResource,{},I.extUriBiasedIgnorePathCase,w)),this.configuration=new u.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new u.ConfigurationModel,new u.ConfigurationModel),this.configurationEditing=new d(l,w,this),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:s})=>this.onDidDefaultConfigurationChange(n,s))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[l,w,i]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new u.Configuration(l,w,new u.ConfigurationModel,i)}getConfigurationData(){return this.configuration.toData()}getValue(l,w){const i=typeof l=="string"?l:void 0,o=(0,S.isConfigurationOverrides)(l)?l:(0,S.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(i,o,void 0)}async updateValue(l,w,i,o,n){const s=(0,S.isConfigurationUpdateOverrides)(i)?i:(0,S.isConfigurationOverrides)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${l} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,L.distinct)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(l,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,m.equals)(w,r.defaultValue)&&(w=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const C=s.overrideIdentifiers.sort(),p=this.configuration.localUserConfiguration.overrides.find(h=>(0,L.equals)([...h.identifiers].sort(),C));p&&(s.overrideIdentifiers=p.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,f.keyFromOverrideIdentifiers)(s.overrideIdentifiers),l]:[l];await this.configurationEditing.write(a,w),await this.reloadConfiguration()}inspect(l,w={}){return this.configuration.inspect(l,w,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const l=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(l)}onDidChangeUserConfiguration(l){const w=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(l);this.trigger(i,w,2)}onDidDefaultConfigurationChange(l,w){const i=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(l,w);this.trigger(o,i,7)}onDidPolicyConfigurationChange(l){const w=this.configuration.toData(),i=this.configuration.compareAndUpdatePolicyConfiguration(l);this.trigger(i,w,7)}trigger(l,w,i){const o=new u.ConfigurationChangeEvent(l,{data:w},this.configuration);o.source=i,this._onDidChangeConfiguration.fire(o)}}e.ConfigurationService=c;class d{constructor(l,w,i){this.settingsResource=l,this.fileService=w,this.configurationService=i,this.queue=new O.Queue}write(l,w){return this.queue.queue(()=>this.doWriteConfiguration(l,w))}async doWriteConfiguration(l,w){let i;try{i=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,_.parse)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(i,l,w);i=(0,R.applyEdits)(i,n),await this.fileService.writeFile(this.settingsResource,A.VSBuffer.fromString(i))}getEdits(l,w,i){const{tabSize:o,insertSpaces:n,eol:s}=this.formattingOptions;if(!w.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.setProperty)(l,w,i,{tabSize:o,insertSpaces:n,eol:s})}get formattingOptions(){if(!this._formattingOptions){let l=P.OS===3||P.OS===2?`
`:`\r
`;const w=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});w&&typeof w=="string"&&w!=="auto"&&(l=w),this._formattingOptions={eol:l,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[214],ue([0,1,14,3,2,68]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const _=(m,P,I)=>{const S=new Uint8Array(16);for(let v=0;v<16;v++)S[v]=Math.round(Math.random()*256);const u=(0,L.encodeBase64)(L.VSBuffer.wrap(S));return[`GET ws://localhost${m}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=_,e.socketRawEndHeaderSequence=L.VSBuffer.fromString(`\r
\r
`);async function R(m,P,I,S,u){m.write(L.VSBuffer.fromString((0,e.makeRawSocketHeaders)(P,I,S)));const f=new A.DisposableStore;try{return await new Promise((v,E)=>{let c;f.add(m.onData(d=>{c?c=L.VSBuffer.concat([c,d],c.byteLength+d.byteLength):c=d;const g=c.indexOf(e.socketRawEndHeaderSequence);if(g===-1)return;v(m),m.pauseData();const l=c.slice(g+e.socketRawEndHeaderSequence.byteLength);l.byteLength&&u.onData.fire(l)})),f.add(m.onClose(d=>E(d??new Error("socket closed")))),f.add(m.onEnd(()=>E(new Error("socket ended"))))})}catch(v){throw m.dispose(),v}finally{f.dispose()}}e.connectManagedSocket=R;class b extends A.Disposable{constructor(P,I){super(),this.debugLabel=P,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...S)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...S)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(I.onData),this._register(I.onData.event(S=>this.pausableDataEmitter.fire(S))),this.onClose=this._register(I.onClose).event,this.onEnd=this._register(I.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(P,I){T.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,P,I)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=b}),define(le[215],ue([0,1,7,4]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class T{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=T;class _{constructor(I,S){this.host=I,this.port=S,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=_;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class b extends L.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof b&&I._code===R.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof b&&I._code===R.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof b&&I._code===R.NoResolverFound}static isInvalidAuthority(I){return I instanceof b&&I._code===R.InvalidAuthority}static isHandled(I){return I instanceof b&&I.isHandled}constructor(I,S=R.Unknown,u){super(I),this._message=I,this._code=S,this._detail=u,this.isHandled=S===R.NotAvailable&&u===!0,Object.setPrototypeOf(this,b.prototype)}}e.RemoteAuthorityResolverError=b;function m(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.getRemoteAuthorityPrefix=m}),define(le[77],ue([0,1,23]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(m){return m.scheme===L.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=O;function A(m){if(!m)return;const P=m.indexOf("+");return P<0?m:m.substr(0,P)}e.getRemoteName=A;function T(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=T;function _(m){const{host:P,port:I}=b(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:I}}e.parseAuthorityWithPort=_;function R(m,P){let{host:I,port:S}=b(m);return typeof S>"u"&&(S=P),{host:I,port:S}}e.parseAuthorityWithOptionalPort=R;function b(m){const P=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(le[45],ue([0,1,27,4,77]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(_||(e.ExtensionType=_={}));var R;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.LINUX_PPC64LE="linux-ppc64le",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class b{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,c){if(typeof E>"u"||E===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof E=="string"||typeof c=="string"){const d=typeof E=="string"?E:E.value,g=typeof c=="string"?c:c.value;return L.equalsIgnoreCase(d,g)}return E._lower===c._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=b;class m{get size(){return this._set.size}constructor(E){if(this._set=new Set,E)for(const c of E)this.add(c)}add(E){this._set.add(b.toKey(E))}delete(E){return this._set.delete(b.toKey(E))}has(E){return this._set.has(b.toKey(E))}}e.ExtensionIdentifierSet=m;class P{constructor(){this._map=new Map}clear(){this._map.clear()}delete(E){this._map.delete(b.toKey(E))}get(E){return this._map.get(b.toKey(E))}has(E){return this._map.has(b.toKey(E))}set(E,c){this._map.set(b.toKey(E),c)}values(){return this._map.values()}forEach(E){this._map.forEach(E)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=P;function I(v){return S(v)}e.isApplicationScopedExtension=I;function S(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function u(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function f(v,E){if(E){const c=`onResolveRemoteAuthority:${(0,A.getRemoteName)(E)}`;return!!v.activationEvents?.includes(c)}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[216],ue([0,1,2,45,11]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(R,b,m,P,I){super(),this.userDataProfilesService=R,this.fileService=b,this.uriIdentityService=m,this.logService=I,this._register(P.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(P.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtensions(R){for(const b of R)b.local&&this.invalidate(b.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const b of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(b.extensionsResource,R)&&await this.deleteUserCacheFile(b);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(b){(0,A.toFileOperationResult)(b)!==1&&this.logService.error(b)}}}e.ExtensionsManifestCache=T}),define(le[217],ue([0,1,6,14,26,7,3,2,100,63,32,68,215,77]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function E(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(W){const k=new A.CancellationTokenSource;return setTimeout(()=>k.cancel(),W),k.token}function d(W,k){if(W.isCancellationRequested||k.isCancellationRequested)return A.CancellationToken.Cancelled;const N=new A.CancellationTokenSource;return W.onCancellationRequested(()=>N.cancel()),k.onCancellationRequested(()=>N.cancel()),N.token}class g{get didTimeout(){return this._state==="timedout"}constructor(k){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,L.promiseWithResolvers)(),k.isCancellationRequested?this._timeout():this._disposables.add(k.onCancellationRequested(()=>this._timeout()))}registerDisposable(k){this._state==="pending"?this._disposables.add(k):k.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(k))}reject(k){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(k))}}function l(W,k){const N=new g(k);return N.registerDisposable(W.onControlMessage(j=>{const $=JSON.parse(j.toString()),J=q($);J?N.reject(J):N.resolve($)})),N.promise}function w(W,k,N,j,$,J,Z,ie){const H=new g(ie),ne=m.StopWatch.create(!1);return W.info(`Creating a socket (${Z})...`),b.mark(`code/willCreateSocket/${J}`),k.connect(N,j,$,Z).then(ce=>{H.didTimeout?(b.mark(`code/didCreateSocketError/${J}`),W.info(`Creating a socket (${Z}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(b.mark(`code/didCreateSocketOK/${J}`),W.info(`Creating a socket (${Z}) was successful after ${ne.elapsed()} ms.`),H.resolve(ce))},ce=>{b.mark(`code/didCreateSocketError/${J}`),W.info(`Creating a socket (${Z}) returned an error after ${ne.elapsed()} ms.`),W.error(ce),H.reject(ce)}),H.promise}function i(W,k){const N=new g(k);return W.then(j=>{N.didTimeout||N.resolve(j)},j=>{N.didTimeout||N.reject(j)}),N.promise}async function o(W,k,N,j){const $=ae(W,k);W.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let J;try{J=await w(W.logService,W.remoteSocketFactoryService,W.connectTo,(0,u.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,E(k),`renderer-${E(k)}-${W.reconnectionToken}`,j)}catch(ce){throw W.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ce),ce}W.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let Z,ie;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(J,null),Z=W.reconnectionProtocol,ie=!1):(Z=new I.PersistentProtocol({socket:J}),ie=!0),W.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const H=await i(W.signService.createNewMessage((0,P.generateUuid)()),j),ne={type:"auth",auth:W.connectionToken||"00000000000000000000",data:H.data};Z.sendControl(O.VSBuffer.fromString(JSON.stringify(ne)));try{const ce=await l(Z,d(j,c(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(W.logService.trace(`${$} 4/6. received SignRequest control message.`),!await i(W.signService.validate(H,ce.signedData),j)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await i(W.signService.sign(ce.data),j),Se={type:"connectionType",commit:W.commit,signedData:fe,desiredConnectionType:k};return N&&(Se.args=N),W.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(O.VSBuffer.fromString(JSON.stringify(Se))),{protocol:Z,ownsProtocol:ie}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(W.logService.error(`${$} the handshake timed out. Error:`),W.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${$} received error control message when negotiating connection. Error:`),W.logService.error(ce)),ie&&x(Z),ce}}async function n(W,k,N,j){const $=Date.now(),J=ae(W,k),{protocol:Z,ownsProtocol:ie}=await o(W,k,N,j),H=new g(j);return H.registerDisposable(Z.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),de=q(ce);de?(W.logService.error(`${J} received error control message when negotiating connection. Error:`),W.logService.error(de),ie&&x(Z),H.reject(de)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${B($)}!`),H.resolve({protocol:Z,firstMessage:ce}))})),H.promise}async function s(W,k){const{protocol:N}=await n(W,1,void 0,k);return{protocol:N}}async function t(W,k,N){const{protocol:j,firstMessage:$}=await n(W,2,k,N),J=$&&$.debugPort;return{protocol:j,debugPort:J}}async function r(W,k,N){const j=Date.now(),$=ae(W,3),{protocol:J}=await o(W,3,k,N);return W.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${B(j)}!`),J}async function a(W,k,N){const{connectTo:j,connectionToken:$}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,connectTo:j,connectionToken:$,reconnectionToken:k,reconnectionProtocol:N,remoteSocketFactoryService:W.remoteSocketFactoryService,signService:W.signService,logService:W.logService}}async function C(W,k,N){return h(W,async j=>{const{protocol:$}=await s(j,A.CancellationToken.None);return new V(W,k,N,j.reconnectionToken,$)})}e.connectRemoteAgentManagement=C;async function p(W,k){return h(W,async N=>{const{protocol:j,debugPort:$}=await t(N,k,A.CancellationToken.None);return new Y(W,k,N.reconnectionToken,j,$)})}e.connectRemoteAgentExtensionHost=p;async function h(W,k){for(let j=1;;j++)try{const $=(0,P.generateUuid)(),J=await a(W,$,null);return await k(J)}catch($){if(j<5)W.logService.error(`[remote-connection][attempt ${j}] An error occurred in initial connection! Will retry... Error:`),W.logService.error($);else throw W.logService.error(`[remote-connection][attempt ${j}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error($),Q.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled($)),$}}async function y(W,k,N){const j=await a(W,(0,P.generateUuid)(),null);return await r(j,{host:k,port:N},A.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function D(W){return(0,L.createCancelablePromise)(k=>new Promise((N,j)=>{const $=setTimeout(N,W*1e3);k.onCancellationRequested(()=>{clearTimeout($),N()})}))}var U;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class M{constructor(k,N){this.reconnectionToken=k,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=M;class F{constructor(k,N,j,$){this.reconnectionToken=k,this.millisSinceLastIncomingData=N,this.durationSeconds=j,this.cancellableTimer=$,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class z{constructor(k,N,j){this.reconnectionToken=k,this.millisSinceLastIncomingData=N,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=z;class X{constructor(k,N,j){this.reconnectionToken=k,this.millisSinceLastIncomingData=N,this.attempt=j,this.type=4}}e.ConnectionGainEvent=X;class K{constructor(k,N,j,$){this.reconnectionToken=k,this.millisSinceLastIncomingData=N,this.attempt=j,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=K;class Q extends R.Disposable{static triggerPermanentFailure(k,N,j){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=k,this._permanentFailureAttempt=N,this._permanentFailureHandled=j,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(k=>k._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(k=>k._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||Q._permanentFailure}constructor(k,N,j,$,J){super(),this._connectionType=k,this._options=N,this.reconnectionToken=j,this.protocol=$,this._reconnectionFailureIsFatal=J,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new X(this.reconnectionToken,0,0)),this._register($.onSocketClose(Z=>{const ie=ee(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${ie} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${ie} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${ie} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(Z=>{const ie=ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),Q._instances.push(this),this._register((0,R.toDisposable)(()=>{const Z=Q._instances.indexOf(this);Z>=0&&Q._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Q._permanentFailureMillisSinceLastIncomingData,Q._permanentFailureAttempt,Q._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const k=ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const $=j<N.length?N[j]:N[N.length-1];try{if($>0){const Z=D($);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,Z)),this._options.logService.info(`${k} waiting for ${$} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this._options.logService.info(`${k} resolving connection...`);const J=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${k} connecting to ${J.connectTo}...`),await this._reconnect(J,c(f)),this._options.logService.info(`${k} reconnected!`),this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this._options.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(J)){this._options.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this._options.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if((0,T.isCancellationError)(J)){this._options.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(J);continue}if(J instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,S.RemoteAuthorityResolverError.isHandled(J));break}this._options.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(J),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(k,N,j){this._reconnectionFailureIsFatal?Q.triggerPermanentFailure(k,N,j):this._gotoPermanentFailure(k,N,j)}_gotoPermanentFailure(k,N,j){this._onDidStateChange.fire(new K(this.reconnectionToken,k,N,j)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Q;class V extends Q{constructor(k,N,j,$,J){super(1,k,$,J,!0),this.client=this._register(new I.Client(J,{remoteAuthority:N,clientId:j},k.ipcLogger))}async _reconnect(k,N){await s(k,N)}}e.ManagementPersistentConnection=V;class Y extends Q{constructor(k,N,j,$,J){super(2,k,j,$,!1),this._startArguments=N,this.debugPort=J}async _reconnect(k,N){await t(k,this._startArguments,N)}}e.ExtensionHostPersistentConnection=Y;function x(W){try{W.acceptDisconnect();const k=W.getSocket();W.dispose(),k.dispose()}catch(k){(0,T.onUnexpectedError)(k)}}function q(W){if(W&&W.type==="error"){const k=new Error(`Connection error: ${W.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function te(W,k){for(;W.length<k;)W+=" ";return W}function oe(W,k){return`[remote-connection][${te(E(W),13)}][${k.substr(0,5)}\u2026]`}function ee(W,k,N){return`${oe(W,k)}[${N?"reconnect":"initial"}]`}function ae(W,k){return`${ee(k,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.connectTo}]`}function B(W){return`${Date.now()-W} ms`}}),define(le[104],ue([0,1,2,4]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.factories={}}register(_,R){return this.factories[_]??=[],this.factories[_].push(R),(0,L.toDisposable)(()=>{const b=this.factories[_]?.indexOf(R);typeof b=="number"&&b>=0&&this.factories[_]?.splice(b,1)})}getSocketFactory(_){return(this.factories[_.type]||[]).find(b=>b.supports(_))}connect(_,R,b,m){const P=this.getSocketFactory(_);if(!P)throw new Error(`No socket factory found for ${_}`);return P.connect(_,R,b,m)}}e.RemoteSocketFactoryService=A}),define(le[218],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(le[105],ue([0,1,4,166]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var A;(function(T){T.disconnected=_=>({type:"disconnected",onTokenFailed:_}),T.connected=(_,R)=>({type:"connected",info:_,serviceInstallFailed:R}),T.connecting=_=>({type:"connecting",progress:_}),T.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(le[59],ue([0,1,14,7,2,168,44,4,8,41]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class P{constructor(w){this.original=w}toJSON(){if(!this.headers){const w=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?w[i]="*****":w[i]=this.original[i];this.headers=w}return this.headers}}class I extends A.Disposable{constructor(w){super(),this.counter=0,this.logger=w.createLogger("network",{name:(0,T.localize)(0,null),when:b.CONTEXT_LOG_LEVEL.isEqualTo((0,b.LogLevelToString)(b.LogLevel.Trace)).serialize()})}async logAndRequest(w,i,o){const n=`${w} #${++this.counter}: ${i.url}`;this.logger.trace(`${n} - begin`,i.type,new P(i.headers??{}));try{const s=await o();return this.logger.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${n} - error`,i.type,(0,O.getErrorMessage)(s)),s}}}e.AbstractRequestService=I;function S(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}e.isSuccess=S;function u(l){return l.res.statusCode===204}e.hasNoContent=u;async function f(l){return u(l)?null:(await(0,L.streamToBuffer)(l.stream)).toString()}e.asText=f;async function v(l){if(!S(l))throw new Error("Server returned "+l.res.statusCode);return f(l)}e.asTextOrError=v;async function E(l){if(!S(l))throw new Error("Server returned "+l.res.statusCode);if(u(l))return null;const i=(await(0,L.streamToBuffer)(l.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.asJson=E;function c(l){g(l)}e.updateProxyConfigurationsScope=c;let d;function g(l){const w=m.Registry.as(_.Extensions.Configuration),i=d;d={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},w.updateConfigurations({add:[d],remove:i?[i]:[]})}g(1)}),define(le[219],ue([0,1,26,23,11,59]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(b,m){this.requestService=b,this.fileService=m}async download(b,m,P=L.CancellationToken.None){if(b.scheme===O.Schemas.file||b.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(b,m);return}const I={type:"GET",url:b.toString(!0)},S=await this.requestService.request(I,P);if(S.res.statusCode===200)await this.fileService.writeFile(m,S.stream);else{const u=await(0,T.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${u}`)}}};e.DownloadService=_,e.DownloadService=_=Ee([G(0,T.IRequestService),G(1,A.IFileService)],_)}),define(le[220],ue([0,1,14,26]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(R){this.service=R}listen(R,b){throw new Error("Invalid listen")}call(R,b,m,P=O.CancellationToken.None){switch(b){case"request":return this.service.request(m[0],P).then(async({res:I,stream:S})=>{const u=await(0,L.streamToBuffer)(S);return[{statusCode:I.statusCode,headers:I.headers},u]});case"resolveProxy":return this.service.resolveProxy(m[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=A;class T{constructor(R){this.channel=R}async request(R,b){const[m,P]=await this.channel.call("request",[R],b);return{res:m,stream:(0,L.bufferToStream)(P)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=T}),define(le[221],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[222],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class L{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(A){try{const T=await this.getValidator();if(T){const _=String(L._nextId++);return this.validators.set(_,T),{id:_,data:T.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,T){if(!A.id)return!0;const _=this.validators.get(A.id);if(!_)return!1;this.validators.delete(A.id);try{return _.validate(T)==="ok"}catch{return!1}finally{_.dispose?.()}}async sign(A){try{return await this.signValue(A)}catch{}return A}}e.AbstractSignService=L}),define(le[106],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[223],ue([0,1,222]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends L.AbstractSignService{getValidator(){return this.vsda().then(T=>new T.validator)}signValue(T){return this.vsda().then(_=>new _.signer().sign(T))}vsda(){return new Promise((T,_)=>se(["vsda"],T,_))}}e.SignService=O}),define(le[78],ue([0,1,3,2]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends O.Disposable{constructor(I,S,u){super(),this.channel=I,this.profile=S,this.workspace=u}async getItems(){const I={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",I);return new Map(S)}updateItems(I){const S={profile:this.profile,workspace:this.workspace};return I.insert&&(S.insert=Array.from(I.insert.entries())),I.delete&&(S.delete=Array.from(I.delete.values())),this.channel.call("updateItems",S)}optimize(){const I={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",I)}}class T extends A{constructor(I,S){super(I,S,void 0),this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(I=>this.onDidChangeStorage(I)))}onDidChangeStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}}class _ extends T{constructor(I){super(I,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class R extends T{constructor(I,S){super(I,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class b extends A{constructor(I,S){super(I,void 0,S),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=b;class m{constructor(I){this.channel=I}isUsed(I){const S={payload:I,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=m}),define(le[107],ue([0,1,5,36,32]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(L.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function _(b,m,P,I,S,u,f,v,E){const c=Object.create(null);c["common.machineId"]=u,c["common.sqmId"]=f,c.sessionID=(0,A.generateUuid)()+Date.now(),c.commitHash=I,c.version=S,c["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,L.PlatformToString)(L.platform),c["common.nodePlatform"]=O.platform,c["common.nodeArch"]=P,c["common.product"]=E||"desktop",v&&(c["common.msftInternal"]=v);let d=0;const g=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),L.isLinuxSnap&&(c["common.snap"]="true");const l=T(m);return l&&(c["common.platformDetail"]=l),c}e.resolveCommonProperties=_;function R(b){const m=O.env.USERDNSDOMAIN;if(!m)return!1;const P=m.toLowerCase();return b.some(I=>P===I)}e.verifyMicrosoftInternalDomain=R}),define(le[22],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var A;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[224],ue([0,1,37,6,34,23,16,5,10,144,31,148,95,11,24,22]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const E=new Map;async function c(i,o){const n=`${i}::${o.join(":")}`,s=E.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,C=2e4;function p(y,D,U,M){const F=D.substring(y.length+1);return O.Promises.withAsyncBody(async z=>{let X;try{X=await P.Promises.readdir(D,{withFileTypes:!0})}catch{z();return}if(M.count>=C){M.count+=X.length,M.maxReached=!0,z();return}let K=X.length;if(K===0){z();return}let Q=X;M.count+X.length>C&&(M.maxReached=!0,K=C-M.count,Q=X.slice(0,K)),M.count+=X.length;for(const V of Q)if(V.isDirectory()){if(U.includes(V.name)||await p(y,(0,_.join)(D,V.name),U,M),--K===0){z();return}}else{const Y=V.name.lastIndexOf(".");if(Y>=0){const x=V.name.substring(Y+1);x&&r.set(x,(r.get(x)??0)+1)}for(const x of t)x.relativePathPattern?.test(F)!==!1&&x.filePattern.test(V.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--K===0){z();return}}})}const h=O.Promises.withAsyncBody(async y=>{const D={count:0,maxReached:!1};await p(i,i,o,D);const U=await l(i);y({configFiles:d(a),fileTypes:d(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:U})});return E.set(n,h),h}e.collectWorkspaceStats=c;function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function g(){const i={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=g;async function l(i){try{const o=new Map,n=(0,_.join)(i,".vscode","launch.json"),s=await P.Promises.readFile(n),t=[],r=(0,A.parse)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const C=a.type;C&&(o.has(C)?o.set(C,o.get(C)+1):o.set(C,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=l;let w=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const s=L.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${L.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,I.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async s=>{let[t,r]=s,a=this.formatProcessList(o,t);return n.forEach(C=>{if((0,S.isRemoteDiagnosticError)(C))a+=`
${C.errorMessage}`,r+=`
${C.errorMessage}`;else if(a+=`

Remote: ${C.hostName}`,C.processes&&(a+=`
${this.formatProcessList(o,C.processes)}`),C.workspaceMetadata){r+=`
|  Remote: ${C.hostName}`;for(const p of Object.keys(C.workspaceMetadata)){const h=C.workspaceMetadata[p];let y=`${h.fileCount} files`;h.maxFilesReached&&(y=`more than ${y}`),r+=`|    Folder (${p}): ${y}`,r+=this.formatWorkspaceStats(h)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=g(),C={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(C.load=`${L.loadavg().map(p=>Math.round(p)).join(", ")}`),R.isLinux&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(o,n){const s=[];return(0,I.listProcesses)(o.mainPID).then(async t=>(s.push(""),s.push(this.formatEnvironment(o)),s.push(""),s.push(this.formatProcessList(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(o))),n.forEach(r=>{if((0,S.isRemoteDiagnosticError)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.formatMachineInfo(r.machineInfo)),r.processes&&s.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const C=r.workspaceMetadata[a];let p=`${C.fileCount} files`;C.maxFilesReached&&(p=`more than ${p}`),s.push(`Folder (${a}): ${p}`),s.push(this.formatWorkspaceStats(C))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(o){const n=[];let t=0;const r=(h,y)=>{const D=` ${h}(${y})`;t+D.length>60?(n.push(a),a="|                 ",t=a.length):t+=D.length,a+=D};let a="|      File types:";const C=10,p=o.fileTypes.length>C?C:o.fileTypes.length;for(let h=0;h<p;h++){const y=o.fileTypes[h];r(y.name,y.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(h=>{r(h.name,h.count)}),n.push(a)),o.launchConfigFiles.length>0){let h="|      Launch Configs:";o.launchConfigFiles.forEach(y=>{const D=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;h+=D}),n.push(h)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=b.URI.revive(r);if(a.scheme===T.Schemas.file){const C=a.fsPath;s.push(c(C,["node_modules",".git"]).then(p=>{let h=`${p.fileCount} files`;p.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,_.basename)(C)}): ${h}`),n.push(this.formatWorkspaceStats(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${C} (${p.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}formatProcessList(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,s,t,n,0),t.join(`
`)}formatProcessItem(o,n,s,t,r){const a=r===0;let C;a?C=t.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(t.pid)?C=n.get(t.pid):C=`${"  ".repeat(r)} ${t.name}`;const p=process.platform==="win32"?t.mem:L.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(p/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(t.children)&&t.children.forEach(h=>this.formatProcessItem(o,n,s,h,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=b.URI.revive(s);if(t.scheme!==T.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(C=>n.add(C.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=b.URI.revive(n);if(s.scheme!==T.Schemas.file)continue;const t=s.fsPath;try{const r=await c(t,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=w,e.DiagnosticsService=w=Ee([G(0,v.ITelemetryService),G(1,f.IProductService)],w)}),define(le[108],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(T){this.appenders=T}listen(T,_){throw new Error(`Event not found: ${_}`)}call(T,_,{eventName:R,data:b}){return this.appenders.forEach(m=>m.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class O{constructor(T){this.channel=T}log(T,_){return this.channel.call("log",{eventName:T,data:_}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(le[46],ue([0,1,30,12,77,107,22]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class m{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=P;function I(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=I;function S(i){const o=i.getValue(_.TELEMETRY_SETTING_ID),n=i.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function u(i){const o={},n={},s={};E(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(i){if(!i)return"none";const o=(0,A.getRemoteName)(i);return f.has(o)?o:"other"}e.cleanRemoteAuthority=v;function E(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,L.safeStringify)(r):r instanceof Date?o[a]=r.toISOString():(0,O.isObject)(r)?n<2?E(r,o,n+1,a+"."):o[a]=(0,L.safeStringify)(r):o[a]=r}}function c(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(n)||s}e.isInternalTelemetry=c;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=d;function g(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const C of o)for(;;){const p=C.exec(i);if(!p)break;s.push([p.index,C.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const C=r.exec(i);if(!C)break;const p=s.some(([h,y])=>C.index<y&&h<r.lastIndex);!t.test(C[0])&&!p&&(n+=i.substring(a,C.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function l(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function w(i,o){return(0,L.cloneAndChange)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=g(s,o);for(const t of o)s=s.replace(t,"");return s=l(s),s}})}e.cleanData=w}),define(le[33],ue([0,1,27,29,45,5,10,7,36,46]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,L.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new S(s.identifier,t,r)}static parse(s){const t=I.exec(s);return t&&t[1]&&t[2]?new S({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof S?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=S;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const s=u.exec(n);return s&&s[1]?[E(s[1]),s[2]]:[E(n),void 0]}e.getIdAndVersion=f;function v(n,s){return`${n}.${s}`}e.getExtensionId=v;function E(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=E;function c(n,s){return E(v(n??A.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=c;function d(n,s){const t=[],r=a=>{for(const C of t)if(C.some(p=>P(s(p),s(a))))return C;return null};for(const a of n){const C=r(a);C?C.push(a):t.push([a])}return t}e.groupByExtension=d;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function l(n){return{id:new m.TelemetryTrustedValue(n.identifier.id),name:new m.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=l,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function w(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(C=>!P(C.identifier,{id:a}))){const C=n.filter(p=>P(p.identifier,{id:a}));C.length===1&&(t.push(C[0]),r.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=w;async function i(n,s){if(!T.isLinux)return!1;let t;try{t=(await n.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,O.getTargetPlatform)(t?"alpine":T.platform,b.arch);return s.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(le[225],ue([0,1,17,2,20,10,11,24,6,3,16,5,36,33]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let f=class extends O.Disposable{constructor(g,l){super(),this.fileService=g,this.productService=l,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,w])=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(g){return this.getValidConfigBasedTips(g)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(g){const l=[];for(const[w,i]of this.allConfigBasedTips)if(!(i.configScheme&&i.configScheme!==g.scheme))try{const o=(await this.fileService.readFile((0,A.joinPath)(g,w))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&l.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return l}};e.ExtensionTipsService=f,e.ExtensionTipsService=f=Ee([G(0,_.IFileService),G(1,R.IProductService)],f);const v="extensionTips/promptedExecutableTips",E="extensionTips/lastPromptedMediumImpExeTime";class c extends f{constructor(g,l,w,i,o,n,s,t){super(s,t),this.userHome=g,this.windowEvents=l,this.telemetryService=w,this.extensionManagementService=i,this.storageService=o,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const C=[],p=[],h=[];Object.entries(a.recommendations).forEach(([y,D])=>{D.important?a.important?C.push({extensionId:y,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):p.push({extensionId:y,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):h.push({extensionId:y,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),C.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:C}),p.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p}),h.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:h})}),(0,b.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const g=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...g,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const g=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),w=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(g,w),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,w)}groupImportantTipsByExe(g,l){const w=new Map;g.forEach(t=>w.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.groupByInstalled([...w.keys()],l);for(const t of i){const r=w.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=w.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),s=new Map;for(const t of o){const r=w.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[g,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(w=>{switch(w){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(g);break;case"incompatibleWindow":{const i=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(i(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const i=this._register(new O.MutableDisposable);i.value=(0,b.disposableTimeout)(()=>{i.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const g=this.getLastPromptedMediumExeTime(),l=Date.now()-g,w=7*24*60*60*1e3;if(l<w){const n=this._register(new O.MutableDisposable);n.value=(0,b.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},w-l);return}const[i,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(i),this.addToRecommendedExecutables(o[0].exeName,o);const s=this._register(new O.MutableDisposable);s.value=(0,b.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},w);break}case"ignored":this.mediumImportanceTipsByExe.delete(i),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const s=m.Event.once(m.Event.latch(m.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(s(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new O.MutableDisposable);s.value=(0,b.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(g){const l=await this.extensionManagementService.getInstalled(1),w=g.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>l.every(n=>!(0,u.areSameExtensions)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:w,source:3,name:g[0].exeFriendlyName,searchValue:`@exe:"${g[0].exeName}"`})}getLastPromptedMediumExeTime(){let g=this.storageService.getNumber(E,-1);return g||(g=Date.now(),this.updateLastPromptedMediumExeTime(g)),g}updateLastPromptedMediumExeTime(g){this.storageService.store(E,g,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(v,-1,"{}"))}addToRecommendedExecutables(g,l){const w=this.getPromptedExecutableTips();w[g]=l.map(({extensionId:i})=>i.toLowerCase()),this.storageService.store(v,JSON.stringify(w),-1,0)}groupByInstalled(g,l){const w=[],i=[],o=l.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return g.forEach(n=>{o.has(n.toLowerCase())?w.push(n):i.push(n)}),{installed:w,uninstalled:i}}async getValidExecutableBasedExtensionTips(g){const l=[],w=new Map;for(const i of g.keys()){const o=g.get(i);if(!o||!(0,L.isNonEmptyArray)(o.recommendations))continue;const n=[];I.isWindows?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>S.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>S.env.ProgramFiles).replace("%APPDATA%",()=>S.env.APPDATA).replace("%WINDIR%",()=>S.env.WINDIR)):(n.push((0,P.join)("/usr/local/bin",i)),n.push((0,P.join)("/usr/bin",i)),n.push((0,P.join)(this.userHome.fsPath,i)));for(const s of n){let t=w.get(s);if(t===void 0&&(t=await this.fileService.exists(T.URI.file(s)),w.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:C,whenNotInstalled:p}of o.recommendations)l.push({extensionId:r,extensionName:a,isExtensionPack:C,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:p})}}return l}}e.AbstractNativeExtensionTipsService=c}),define(le[226],ue([0,1,26,33]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function A(T,_,R,b,m){try{const P=await T.getExtensionsControlManifest();if(!P.deprecated)return;const I=await T.getInstalled(1);for(const[S,u]of Object.entries(P.deprecated)){if(!u?.extension)continue;const{id:f,autoMigrate:v,preRelease:E}=u.extension;if(!v)continue;const c=I.find(g=>(0,O.areSameExtensions)(g.identifier,{id:S}));if(!c)continue;const d=(await _.getExtensions([{id:f,preRelease:E}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!d){m.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{m.info(`Migrating '${c.identifier.id}' extension to '${f}' extension...`);const g=!b.getDisabledExtensions().some(w=>(0,O.areSameExtensions)(w,c.identifier));await T.uninstall(c),m.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let l=I.find(w=>(0,O.areSameExtensions)(w.identifier,{id:f}));(!l||!l.isPreReleaseVersion&&g)&&(l=await T.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),m.info(`Installed the pre-release extension '${l.identifier.id}'`),g||(await b.disableExtension(l.identifier),m.info(`Disabled the pre-release extension '${l.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),v.storage&&(R.addToMigrationList((0,O.getExtensionId)(c.manifest.publisher,c.manifest.name),(0,O.getExtensionId)(l.manifest.publisher,l.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${c.identifier.id}' extension to '${f}' extension.`)}catch(g){m.error(g)}}}catch(P){m.error(P)}}e.migrateUnsupportedExtensions=A}),define(le[227],ue([0,1,6,7,2,23,20,55,12,32,31,70,21,15,29,33,99,11,8]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let l=class extends A.Disposable{static{g=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(i,o,n,s,t,r){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,o,n){await this.cleanUpPromise;const s=(0,_.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,s,r=>this.extensionGalleryService.download(i,r,o))}catch(r){throw new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.shouldVerifySignature(i)){const r=await this.downloadSignatureArchive(i);try{t=await this.extensionSignatureVerificationService.verify(s.fsPath,r.fsPath,this.logService.getLevel()===d.LogLevel.Trace)}catch(a){const C=a;if(t=C.code,C.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${C.output}`),t===f.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===f.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(p){this.logService.error(p)}throw new f.ExtensionManagementError(I.CorruptZipMessage,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return t===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}shouldVerifySignature(i){if(!i.isSigned)return this.logService.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,b.isBoolean)(o)?o:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const o=(0,_.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${g.SignatureArchiveExtension}`);try{await this.downloadFile(i,o,n=>this.extensionGalleryService.downloadSignatureArchive(i,n))}catch(n){throw new f.ExtensionManagementError(n.message,f.ExtensionManagementErrorCode.DownloadSignature)}return o}async downloadFile(i,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==T.Schemas.file){await n(o);return}const s=(0,_.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(s)||await n(s);try{await P.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.fileService.del(s)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(g.SignatureArchiveExtension))s.push(a.resource);else{const C=v.ExtensionKey.parse(a.name);C&&n.push([C,a])}const t=(0,v.groupByExtension)(n,([a])=>a),r=[];for(const a of t)a.sort((C,p)=>R.rcompare(C[0].version,p[0].version)),o.push(...a.slice(1).map(C=>C[1].resource)),r.push(a[0][1]);r.sort((a,C)=>a.mtime-C.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...s),await L.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?v.ExtensionKey.create(i).toString().toLowerCase():(0,m.generateUuid)()}};e.ExtensionsDownloader=l,e.ExtensionsDownloader=l=g=Ee([G(0,u.INativeEnvironmentService),G(1,c.IFileService),G(2,f.IExtensionGalleryService),G(3,S.IConfigurationService),G(4,E.IExtensionSignatureVerificationService),G(5,d.ILogService)],l)}),define(le[228],ue([0,1,3,2,35,33,45]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends O.Disposable{constructor(m,P,I,S,u,f,v){super(),this.extensionManagementService=m,this.extensionsScannerService=P,this.userDataProfilesService=I,this.extensionsProfileScannerService=S,this.uriIdentityService=u,this.fileService=f,this.logService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,E=>v.error(E))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(m=>this.onDidChangeProfiles(m.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(m=>this.onAddExtensions(m))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(m=>this.onDidAddExtensions(m))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(m=>this.onRemoveExtensions(m))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(m=>this.onDidRemoveExtensions(m))),this._register(this.fileService.onDidFilesChange(m=>this.onDidFilesChange(m)))}async onDidChangeProfiles(m){try{m.length&&await Promise.all(m.map(P=>(this.extensionsProfileWatchDisposables.set(P.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(P.extensionsResource)),this.fileService.watch(P.extensionsResource))),this.populateExtensionsFromProfile(P.extensionsResource))))}catch(P){throw this.logService.error(P),P}}async onAddExtensions(m){for(const P of m.extensions)this.addExtensionWithKey(this.getKey(P.identifier,P.version),m.profileLocation)}async onDidAddExtensions(m){for(const P of m.extensions){const I=this.getKey(P.identifier,P.version);m.error?this.removeExtensionWithKey(I,m.profileLocation):this.addExtensionWithKey(I,m.profileLocation)}}async onRemoveExtensions(m){for(const P of m.extensions)this.removeExtensionWithKey(this.getKey(P.identifier,P.version),m.profileLocation)}async onDidRemoveExtensions(m){const P=[],I=[];for(const S of m.extensions){const u=this.getKey(S.identifier,S.version);m.error?this.addExtensionWithKey(u,m.profileLocation):(this.removeExtensionWithKey(u,m.profileLocation),this.allExtensions.has(u)||(this.logService.debug("Extension is removed from all profiles",S.identifier.id,S.version),I.push(this.extensionManagementService.scanInstalledExtensionAtLocation(S.location).then(f=>{f?P.push(f):this.logService.info("Extension not found at the location",S.location.toString())},f=>this.logService.error(f)))))}try{await Promise.all(I),P.length&&await this.uninstallExtensionsNotInProfiles(P)}catch(S){this.logService.error(S)}}onDidFilesChange(m){for(const P of this.userDataProfilesService.profiles)m.contains(P.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(P.extensionsResource)}async onDidExtensionsProfileChange(m){const P=[],I=[],S=await this.extensionsProfileScannerService.scanProfileExtensions(m),u=new Set,f=new Set;for(const[v,E]of this.allExtensions)E.has(m)&&f.add(v);for(const v of S){const E=this.getKey(v.identifier,v.version);u.add(E),f.has(E)||(P.push(v.identifier),this.addExtensionWithKey(E,m))}for(const v of f)if(!u.has(v)){const E=this.fromKey(v);E&&(I.push(E.identifier),this.removeExtensionWithKey(v,m))}(P.length||I.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P.length?{extensions:P,profileLocation:m}:void 0,removed:I.length?{extensions:I,profileLocation:m}:void 0})}async populateExtensionsFromProfile(m){const P=await this.extensionsProfileScannerService.scanProfileExtensions(m);for(const I of P)this.addExtensionWithKey(this.getKey(I.identifier,I.version),m)}async uninstallExtensionsNotInProfiles(m){m||(m=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(I=>!this.allExtensions.has(this.getKey(I.identifier,I.manifest.version)))),m.length&&await this.extensionManagementService.markAsUninstalled(...m)}addExtensionWithKey(m,P){let I=this.allExtensions.get(m);I||this.allExtensions.set(m,I=new A.ResourceSet(S=>this.uriIdentityService.extUri.getComparisonKey(S))),I.add(P)}removeExtensionWithKey(m,P){const I=this.allExtensions.get(m);I&&I.delete(P),I?.size||this.allExtensions.delete(m)}getKey(m,P){return`${_.ExtensionIdentifier.toKey(m.id)}@${P}`}fromKey(m){const[P,I]=(0,T.getIdAndVersion)(m);return I?{identifier:{id:P},version:I}:void 0}}e.ExtensionsWatcher=R}),define(le[229],ue([0,1,43,46]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function A(T,_,R,b,m,P,I){const S={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${_.nameShort})`};if((0,O.supportsTelemetry)(_,R)&&(0,O.getTelemetryLevel)(b)===3){const u=await(0,L.getServiceMachineId)(R,m,P);S["X-Market-User-Id"]=u,S["VSCode-SessionId"]=I.machineId||u}return S}e.resolveMarketplaceHeaders=A}),define(le[230],ue([0,1,73,17,6,2,23,16,31,15,29,33,8,75,10]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends u.LanguagePackBaseService{constructor(g,l,w,i){super(w),this.extensionManagementService=g,this.logService=i,this.cache=this._register(new E(l,i)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(g,l){const i=(await this.cache.getLanguagePacks())[l];if(!i){this.logService.warn(`No language pack found for ${l}`);return}const o=i.translations[g];return o?f.URI.file(o):void 0}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),l=Object.keys(g).map(w=>{const i=g[w];return{...this.createQuickPickItem(w,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return l.push(this.createQuickPickItem("en","English")),l.sort((w,i)=>w.label.localeCompare(i.label)),l}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const l=await this.cache.getLanguagePacks();Object.keys(l).some(w=>l[w]&&l[w].extensions.some(i=>(0,I.areSameExtensions)(i.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(l);return!(0,O.equals)(Object.keys(g),Object.keys(w))}};e.NativeLanguagePackService=v,e.NativeLanguagePackService=v=Ee([G(0,P.IExtensionManagementService),G(1,m.INativeEnvironmentService),G(2,P.IExtensionGalleryService),G(3,S.ILogService)],v);let E=class extends T.Disposable{constructor(g,l){super(),this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new A.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(l=>{Object.keys(l).forEach(w=>delete l[w]),this.createLanguagePacksFromExtensions(l,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...l){for(const w of l)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,w);Object.keys(g).forEach(w=>this.updateHash(g[w]))}createLanguagePacksFromExtension(g,l){const w=l.identifier,i=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const o of i)if(l.location.scheme===_.Schemas.file&&c(o)){let n=g[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},g[o.languageId]=n);const s=n.extensions.filter(t=>(0,I.areSameExtensions)(t.extensionIdentifier,w))[0];s?s.version=l.manifest.version:n.extensions.push({extensionIdentifier:w,version:l.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.join)(l.location.fsPath,t.path)}}updateHash(g){if(g){const l=(0,L.createHash)("md5");for(const w of g.extensions)l.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);g.hash=l.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(l=g(w),w)).then(w=>{for(const o of Object.keys(w))w[o]||delete w[o];this.languagePacks=w,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),b.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>l,w=>this.logService.error(w))})}};E=Ee([G(0,m.INativeEnvironmentService),G(1,S.ILogService)],E);function c(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const g of d.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(le[231],ue([0,1,143,7,30,46]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const _="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function b(P,I,S){const u=await(0,L.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,L.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new u.AppInsightsCore,E=new f.PostChannel,c={instrumentationKey:P,endpointUrl:_,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(S){c.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:S};c.extensionConfig[E.identifier]=d}return v.initialize(c,[]),v.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',I&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),v}class m{constructor(I,S,u,f,v){this._isInternalTelemetry=I,this._eventPrefix=S,this._defaultData=u,this._xhrOverride=v,this.endPointUrl=_,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(I){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=b(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(S=>{I(S)},S=>{(0,O.onUnexpectedError)(S),console.error(S)})}}log(I,S){if(!this._aiCoreOrKey)return;S=(0,A.mixin)(S,this._defaultData),S=(0,T.validateTelemetryData)(S);const u=this._eventPrefix+"/"+I;try{this._withAIClient(f=>{f.pluginVersionString=S?.properties.version??"Unknown",f.track({name:u,baseData:{name:u,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(S=>{S.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=m}),define(le[109],ue([0,1,2,169,15,8,24,46]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let b=class extends L.Disposable{constructor(P,I,S,u,f=""){super(),this.prefix=f;const v=I.getLogger(R.telemetryLogId);if(v)this.logger=this._register(v);else{const c=(0,R.isLoggingOnly)(u,S)?" (Not Sent)":"",d=()=>(0,R.supportsTelemetry)(u,S)&&P.getLevel()===T.LogLevel.Trace;this.logger=this._register(I.createLogger(R.telemetryLogId,{name:(0,O.localize)(0,null,c),hidden:!d()})),this._register(P.onDidChangeLogLevel(()=>I.setVisibility(R.telemetryLogId,d()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,I){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,R.validateTelemetryData)(I))}};e.TelemetryLogAppender=b,e.TelemetryLogAppender=b=Ee([G(0,T.ILogService),G(1,T.ILoggerService),G(2,A.IEnvironmentService),G(3,_.IProductService)],b)}),define(le[110],ue([0,1,2,30,5,27,170,21,44,102,24,41,22,46]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,d,g){this._configurationService=d,this._productService=g,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=c.appenders,this._commonProperties=c.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=c.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(l),"gi")),l.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(l.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(l=>{(l.affectsConfiguration(S.TELEMETRY_SETTING_ID)||l.affectsConfiguration(S.TELEMETRY_OLD_SETTING_ID)||l.affectsConfiguration(S.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(c,d){this._experimentProperties[c]=d}_updateTelemetryLevel(){let c=(0,u.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const g=d.usage?3:d.error?2:0;c=Math.min(c,g)}this._telemetryLevel=c}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(c,d,g){this._telemetryLevel<d||(g=(0,O.mixin)(g,this._experimentProperties),g=(0,u.cleanData)(g,this._cleanupPatterns),g=(0,O.mixin)(g,this._commonProperties),this._appenders.forEach(l=>l.log(c,g)))}publicLog(c,d){this._log(c,3,d)}publicLog2(c,d){this.publicLog(c,d)}publicLogError(c,d){this._sendErrorTelemetry&&this._log(c,2,d)}publicLogError2(c,d){this.publicLogError(c,d)}};e.TelemetryService=f,e.TelemetryService=f=Ee([G(1,R.IConfigurationService),G(2,P.IProductService)],f);function v(){const E=(0,_.localize)(0,null,m.default.nameLong),c=m.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=A.isWeb?"":(0,_.localize)(3,null),g=(0,_.localize)(4,null),l=(0,_.localize)(5,null),w=(0,_.localize)(6,null),i=(0,_.localize)(7,null),o=`
|       | ${g} | ${l} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,_.localize)(8,null);return`
${E} ${c} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,_.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,_.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[232],ue([0,1,14,26,275,231]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function _(P,I){const S=await I.request(P,O.CancellationToken.None),u=(await(0,L.streamToBuffer)(S.stream)).toString(),f=S.res.statusCode??200;return{headers:S.res.headers,statusCode:f,responseData:u}}async function R(P){const I={method:P.type,headers:P.headers};return new Promise((u,f)=>{const v=A.request(P.url??"",I,E=>{E.on("data",function(c){u({headers:E.headers,statusCode:E.statusCode??200,responseData:c.toString()})}),E.on("error",function(c){f(c)})});v.write(P.data,E=>{E&&f(E)}),v.end()})}async function b(P,I,S){const u=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),f={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:u};try{const v=P?await _(f,P):await R(f);S(v.statusCode,v.headers,v.responseData)}catch{S(0,{})}}class m extends T.AbstractOneDataSystemAppender{constructor(I,S,u,f,v){const E={sendPOST:(c,d)=>{b(I,c,d)}};super(S,u,f,v,E)}}e.OneDataSystemAppender=m}),define(le[233],ue([0,1,23,93,21,15,8,24,22,108,109,110]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(f,v,E,c,d,g){this.configurationService=f,this.telemetryService=v,this.logService=E,this.loggerService=c,this.environmentService=d,this.productService=g,this.customTelemetryServices=new Map}getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const v=Object.create(null);v["common.vscodemachineid"]=this.telemetryService.machineId,v["common.vscodesessionid"]=this.telemetryService.sessionId;const E=[f.id,JSON.stringify(v),f.aiKey],d=new O.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),g=[new m.TelemetryAppenderClient(d),new P.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new I.TelemetryService({appenders:g,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}publicLog(f,v,E){this.getCustomTelemetryService(f).publicLog(v,E)}publicLogError(f,v,E){this.getCustomTelemetryService(f).publicLogError(v,E)}};e.CustomEndpointTelemetryService=S,e.CustomEndpointTelemetryService=S=Ee([G(0,A.IConfigurationService),G(1,b.ITelemetryService),G(2,_.ILogService),G(3,_.ILoggerService),G(4,T.IEnvironmentService),G(5,R.IProductService)],S)}),define(le[79],ue([0,1,3,21,4,8]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var _;(function(E){E.Http="http",E.Https="https"})(_||(e.TunnelProtocol=_={}));var R;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(R||(e.TunnelPrivacyId=R={}));function b(E){return!!E.forwardPort}e.isTunnelProvider=b;var m;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function P(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=S;function u(E,c,d,g){if(d===1)return!1;if(d===2&&S(c)){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(l?.length===4&&parseInt(l[1])>=18)return!1}return E<1024}e.isPortPrivileged=u;class f{constructor(c,d,g){this.remoteAddress=c,this.localAddress=d,this._dispose=g,this._onDispose=new L.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let v=class{constructor(c,d){this.logService=c,this.configurationService=d,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions,this._canChangeProtocol=c.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],d=Array.from(this._tunnels.values());for(const g of d){const l=Array.from(g.values());for(const w of l){const i=await w.value;i&&typeof i!="string"&&c.push(i)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:d}of c.values())await d.then(g=>typeof g!="string"?g?.dispose():void 0);c.clear()}this._tunnels.clear()}setEnvironmentTunnel(c,d,g,l,w){this.addTunnelToMap(c,d,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:d,localAddress:g,privacy:l,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,d){(S(c)||I(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const g=this.getTunnelFromMap(c,d);if(g)return++g.refcount,g.value}openTunnel(c,d,g,l,w,i=!1,o,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${w}.`);const s=this._tunnelProvider??c;if(!s)return;if(d||(d="localhost"),l||(l=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(s,d,g,l,w,i,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,g),r}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(r);return(r.tunnelRemoteHost!==d||r.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const d=this._tunnels.get(c.tunnelRemoteHost);if(d){const g=d.get(c.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,g))}}}}async tryDisposeTunnel(c,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${d}.`);const l=g.value.then(async w=>{w&&typeof w!="string"&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(d),l}}async closeTunnel(c,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${d} `);const g=this._tunnels.get(c);if(g&&g.has(d)){const l=g.get(d);l.refcount=0,await this.tryDisposeTunnel(c,d,l)}}addTunnelToMap(c,d,g){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(d,{refcount:1,value:g})}async removeEmptyOrErrorTunnelFromMap(c,d){const g=this._tunnels.get(c);if(g){const l=g.get(d),w=l?await l.value:void 0;(!w||typeof w=="string")&&g.delete(d),g.size===0&&this._tunnels.delete(c)}}getTunnelFromMap(c,d){const g=[c];I(c)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):S(c)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const l=g.map(w=>this._tunnels.get(w));for(const w of l){const i=w?.get(d);if(i)return i}}canTunnel(c){return!!P(c)}createWithProvider(c,d,g,l,w,i,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${l}.`);const n=g;this._factoryInProgress.add(n);const s=l===void 0?g:l,t={elevationRequired:w?this.isPortPrivileged(s):!1},r={remoteAddress:{host:d,port:g},localAddressPort:l,privacy:i,public:i?i!==R.Private:void 0,protocol:o},a=c.forwardPort(r,t);return a?(this.addTunnelToMap(d,g,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};e.AbstractTunnelService=v,e.AbstractTunnelService=v=Ee([G(0,T.ILogService),G(1,O.IConfigurationService)],v)}),define(le[234],ue([0,1,8,79,2,7,6]),function(se,e,L,O,A,T,_){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class b extends A.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let m=class extends A.Disposable{static{R=this}static{this._lastId=0}constructor(I,S){super(),this._tunnelService=I,this._logService=S,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++R._lastId)}}async startTunnel(I,S,u,f,v,E,c){const d=new b,g=await Promise.resolve(this._tunnelService.openTunnel(I,d,u,f,v,E,c));if(!g||typeof g=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${u}:${f} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(S))throw this._disposedTunnels.delete(S),d.dispose(),await g.dispose(),(0,T.canceled)();return d.setTunnel(g),this._tunnels.set(S,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${g.localAddress} (local) to ${u}:${f} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,S){const u=this._tunnels.get(I);u&&u.setAddress(S)}async destroyTunnel(I){const S=this._tunnels.get(I);if(S){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await S.dispose();return}this._disposedTunnels.add(I)}};e.SharedProcessTunnelService=m,e.SharedProcessTunnelService=m=R=Ee([G(0,O.ISharedTunnelsService),G(1,L.ILogService)],m)}),define(le[28],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(le[235],ue([0,1,28,188,11,20,128,3,2]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{static{this._clock=0}constructor(S){this.uri=S,this.time=m._clock++}touch(){return this.time=m._clock++,this}}let P=class{constructor(S){this._fileService=S,this._dispooables=new b.DisposableStore,this._limit=2**16;const u=new Map,f=v=>{let E=u.get(v.scheme);return E===void 0&&(E=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),u.set(v.scheme,E)),E};this._dispooables.add(R.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{u.delete(v.scheme)})),this.extUri=new T.ExtUri(f),this._canonicalUris=new _.SkipList((v,E)=>this.extUri.compare(v,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,T.normalizePath)(S));const u=this._canonicalUris.get(S);return u?u.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new m(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((f,v)=>f[1].time<v[1].time?1:f[1].time>v[1].time?-1:0);m._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let f=0;f<u;f++)this._canonicalUris.set(S[f][0],S[f][1].touch())}};e.UriIdentityService=P,e.UriIdentityService=P=Ee([G(0,A.IFileService)],P),(0,O.registerSingleton)(L.IUriIdentityService,P,1)}),define(le[236],ue([0,1,3,2,11,48,35]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends O.Disposable{constructor(m,P,I,S,u,f){super(),this.fileSystemScheme=m,this.fileSystemProvider=P,this.userDataScheme=I,this.userDataProfilesService=S,this.uriIdentityService=u,this.logService=f,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new _.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(v))),this.updateAtomicReadWritesResources(),this._register(S.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(v=>this.handleFileChanges(v)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const m of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(m.settingsResource),this.atomicReadWriteResources.add(m.keybindingsResource),this.atomicReadWriteResources.add(m.tasksResource),this.atomicReadWriteResources.add(m.extensionsResource)}open(m,P){return this.fileSystemProvider.open(this.toFileSystemResource(m),P)}close(m){return this.fileSystemProvider.close(m)}read(m,P,I,S,u){return this.fileSystemProvider.read(m,P,I,S,u)}write(m,P,I,S,u){return this.fileSystemProvider.write(m,P,I,S,u)}watch(m,P){this.watchResources.set(m,m);const I=this.fileSystemProvider.watch(this.toFileSystemResource(m),P);return(0,O.toDisposable)(()=>{this.watchResources.delete(m),I.dispose()})}stat(m){return this.fileSystemProvider.stat(this.toFileSystemResource(m))}mkdir(m){return this.fileSystemProvider.mkdir(this.toFileSystemResource(m))}rename(m,P,I){return this.fileSystemProvider.rename(this.toFileSystemResource(m),this.toFileSystemResource(P),I)}readFile(m,P){return this.fileSystemProvider.readFile(this.toFileSystemResource(m),P)}readFileStream(m,P,I){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(m),P,I)}readdir(m){return this.fileSystemProvider.readdir(this.toFileSystemResource(m))}enforceAtomicReadFile(m){return this.atomicReadWriteResources.has(m)}writeFile(m,P,I){return this.fileSystemProvider.writeFile(this.toFileSystemResource(m),P,I)}enforceAtomicWriteFile(m){return this.atomicReadWriteResources.has(m)?{postfix:".vsctmp"}:!1}delete(m,P){return this.fileSystemProvider.delete(this.toFileSystemResource(m),P)}copy(m,P,I){if((0,A.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(m),this.toFileSystemResource(P),I);throw new Error("copy not supported")}cloneFile(m,P){if((0,A.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(m),this.toFileSystemResource(P));throw new Error("clone not supported")}handleFileChanges(m){const P=[];for(const I of m){if(I.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(I.resource);this.watchResources.findSubstr(S)&&P.push({resource:S,type:I.type,cId:I.cId})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(m){return m.with({scheme:this.fileSystemScheme})}toUserDataResource(m){return m.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(le[80],ue([0,1,62]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(_,R,b,m){const P=(0,L.setProperty)(_,R,b,m)[0];return P&&(_=_.substring(0,P.offset)+P.content+_.substring(P.offset+P.length)),_}e.edit=O;function A(_,R,b){let m=b;for(;m>=0;){if(_.charAt(m)===R.charAt(R.length-1)&&R.length===1)return m+1;if(m--,R.length===2&&m>=0&&_.charAt(m)===R.charAt(0))return m+2}return 0}e.getLineStartOffset=A;function T(_,R,b){let m=b;for(;m>=0;)if(_.charAt(m)===R.charAt(R.length-1)&&R.length===1||(m++,R.length===2&&m>=0&&_.charAt(m)===R.charAt(1)))return m;return _.length-1}e.getLineEndOffset=T}),define(le[237],ue([0,1,30,55,12]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(u,f,v,E,c,d){const g=[],l=[],w=[];if(!f){const z=u.filter(({identifier:X})=>c.every(K=>K.toLowerCase()!==X.id.toLowerCase()));return{local:{added:g,removed:l,updated:w},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}u=u.map(I),f=f.map(I),v=v?v.map(I):null;const i=new Map,o=z=>{z.uuid&&i.set(z.id.toLowerCase(),z.uuid)};u.forEach(({identifier:z})=>o(z)),f.forEach(({identifier:z})=>o(z)),v?.forEach(({identifier:z})=>o(z)),E?.forEach(({identifier:z})=>o(z)),d?.forEach(z=>o(z));const n=z=>{const X=z.identifier.uuid||i.get(z.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${z.identifier.id.toLowerCase()}`},s=(z,X)=>(z.set(n(X),X),z),t=u.reduce(s,new Map),r=f.reduce(s,new Map),a=f.reduce((z,X)=>s(z,(0,L.deepClone)(X)),new Map),C=v?v.reduce(s,new Map):null,p=E.reduce(s,new Map),h=c.reduce((z,X)=>{const K=i.get(X.toLowerCase());return z.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)},new Set),y=d?d.reduce((z,{id:X,uuid:K})=>(K=K??i.get(X.toLowerCase()),z.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)),new Set):null,D=_(t,r,h,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const z=_(C,t,h,!1),X=_(C,r,h,!0),K=(Q,V,Y,x)=>{let q,te,oe;return V.installed?(q=x.pinned,oe=x.preRelease,q&&(te=x.version)):(q=Y.pinned,oe=Y.preRelease,q&&(te=Y.version)),q===void 0&&(q=V.pinned,q&&(te=V.version)),oe===void 0&&(oe=V.preRelease),{...x,installed:V.installed||Y.installed,pinned:q,preRelease:oe,version:te??(Y.version&&(!V.installed||O.gt(Y.version,V.version))?Y.version:V.version),state:b(V,Y,C?.get(Q))}};for(const Q of X.removed.values()){const V=t.get(Q);if(!V)continue;const Y=(0,A.assertIsDefined)(C?.get(Q)),x=y&&!y.has(Q)&&Y.installed;V.installed&&x?l.push(V.identifier):a.set(Q,V)}for(const Q of X.added.values()){const V=(0,A.assertIsDefined)(r.get(Q)),Y=t.get(Q);if(Y){if(D.updated.has(Q)){const x=K(Q,Y,V,V);R(Y,V,!1,!1)||w.push(S(x,Q)),a.set(Q,x)}}else V.installed&&g.push(S(V,Q))}for(const Q of X.updated.values()){const V=(0,A.assertIsDefined)(r.get(Q)),Y=(0,A.assertIsDefined)(C?.get(Q)),x=t.get(Q);if(x)if(y&&!y.has(Q)&&Y.installed&&x.installed&&!V.installed)l.push(x.identifier);else{const te=K(Q,x,V,V);w.push(S(te,Q)),a.set(Q,te)}else V.installed&&g.push(S(V,Q))}for(const Q of z.added.values())X.added.has(Q)||a.set(Q,(0,A.assertIsDefined)(t.get(Q)));for(const Q of z.updated.values()){if(X.removed.has(Q)||X.updated.has(Q))continue;const V=(0,A.assertIsDefined)(t.get(Q)),Y=(0,A.assertIsDefined)(r.get(Q));a.set(Q,K(Q,V,Y,V))}for(const Q of z.removed.values())X.updated.has(Q)||X.removed.has(Q)||p.has(Q)||(0,A.assertIsDefined)(r.get(Q)).installed&&y&&(y.has(Q)||!(0,A.assertIsDefined)(C?.get(Q)).installed||a.delete(Q))}const U=[],M=_(r,a,new Set,!0),F=M.added.size>0||M.updated.size>0||M.removed.size>0;return F&&a.forEach((z,X)=>U.push(S(z,X))),{local:{added:g,removed:l,updated:w},remote:F?{added:[...M.added].map(z=>a.get(z)),updated:[...M.updated].map(z=>a.get(z)),removed:[...M.removed].map(z=>r.get(z)),all:U}:null}}e.merge=T;function _(u,f,v,E){const c=u?[...u.keys()].filter(i=>!v.has(i)):[],d=[...f.keys()].filter(i=>!v.has(i)),g=d.filter(i=>!c.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),l=c.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),w=new Set;for(const i of c){if(l.has(i))continue;const o=u.get(i),n=f.get(i);(!n||!R(o,n,E,!0))&&w.add(i)}return{added:g,removed:l,updated:w}}function R(u,f,v,E){return!(u.disabled!==f.disabled||!!u.isApplicationScoped!=!!f.isApplicationScoped||E&&u.installed!==f.installed||u.installed&&f.installed&&(u.preRelease!==f.preRelease||u.pinned!==f.pinned||f.pinned&&u.version!==f.version)||!P(u.state,f.state)||v&&u.version!==f.version)}function b(u,f,v){const E=u.state,c=f.state,d=v?.state;if(!f.version||E&&O.gt(u.version,f.version))return E;if(c&&O.gt(f.version,u.version)||!E)return c;if(!c)return E;const g=(0,L.deepClone)(E),l=d?m(d,c):{added:Object.keys(c).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},w=d?m(d,E):{added:Object.keys(E).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...l.added.values(),...l.updated.values()])g[i]=c[i];for(const i of l.removed.values())w.updated.has(i)||delete g[i];return g}function m(u,f){const v=Object.keys(u),E=Object.keys(f),c=E.filter(l=>!v.includes(l)).reduce((l,w)=>(l.add(w),l),new Set),d=v.filter(l=>!E.includes(l)).reduce((l,w)=>(l.add(w),l),new Set),g=new Set;for(const l of v){if(d.has(l))continue;const w=u[l],i=f[l];(0,L.equals)(w,i)||g.add(l)}return{added:c,removed:d,updated:g}}function P(u={},f={}){const{added:v,removed:E,updated:c}=m(u,f);return v.size===0&&E.size===0&&c.size===0}function I(u){return{...u,disabled:!!u.disabled,installed:!!u.installed}}function S(u,f){const v={...u,identifier:{id:u.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!u.preRelease,pinned:!!u.pinned};return u.disabled||delete v.disabled,u.installed||delete v.installed,u.state||delete v.state,u.isApplicationScoped||delete v.isApplicationScoped,v}}),define(le[111],ue([0,1,17,21,4]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==R&&P!==`-${R}`),b&&m.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}updateSynchronizedExtensions(R,b){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return m=m.filter(P=>P!==R&&P!==`-${R}`),b&&m.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,2)}getIgnoredExtensions(R){const b=R.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),m=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),P=[],I=[];if(Array.isArray(m))for(const S of m)S.startsWith("-")?I.push(S.substring(1)):P.push(S);return(0,L.distinct)([...b,...P].filter(S=>!I.includes(S)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};e.IgnoredExtensionsManagementService=T,e.IgnoredExtensionsManagementService=T=Ee([G(0,O.IConfigurationService)],T)}),define(le[238],ue([0,1,17,34,30,94,80]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(l){return(0,O.parse)(l)||[]}async function b(l,w,i,o,n){const s=R(l),t=R(w),r=i?R(i):null,a=[...s,...t,...r||[]].map(K=>K.key),C=await n.resolveUserBindings(a),p=P(s,t,r,C);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const h=S(s),y=S(t),D=r?S(r):null,U=f(h,y,C),M=D?f(D,h,C):{added:[...h.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},F=D?f(D,y,C):{added:[...y.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},z=m(U,M,F);let X=l;for(const K of z.removed.values())z.conflicts.has(K)||(X=d(X,K,o));for(const K of z.added.values()){if(z.conflicts.has(K))continue;const Q=y.get(K);if(Q.some(V=>V.command!==`-${K}`&&p.conflicts.has(C[V.key]))){z.conflicts.add(K);continue}X=c(X,Q,o)}for(const K of z.updated.values()){if(z.conflicts.has(K))continue;const Q=y.get(K);if(Q.some(V=>V.command!==`-${K}`&&p.conflicts.has(C[V.key]))){z.conflicts.add(K);continue}X=g(X,K,Q,o)}return{mergeContent:X,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=b;function m(l,w,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of w.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(w.updated.has(r)?t.add(r):n.add(r));for(const r of w.added.values())t.has(r)||i.added.has(r)&&l.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(w.added.has(r)?l.updated.has(r)&&t.add(r):o.add(r));for(const r of w.updated.values())t.has(r)||i.updated.has(r)&&l.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(w.updated.has(r)?l.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function P(l,w,i,o){const n=new Set,s=I(l,o),t=I(w,o),r=i?I(i,o):null,a=u(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const C=r?u(r,s):{added:[...s.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=r?u(r,t):{added:[...t.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:y,updated:D,conflicts:U}=m(a,C,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:y,updated:D,conflicts:U}}function I(l,w){const i=new Map;for(const o of l){const n=w[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function S(l){const w=new Map;for(const i of l){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=w.get(o);n||(n=[],w.set(o,n)),n.push(i)}return w}function u(l,w){const i=[...l.keys()],o=[...w.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=l.get(r).map(p=>({...p,key:r})),C=w.get(r).map(p=>({...p,key:r}));(0,L.equals)(a,C,(p,h)=>E(p,h))||t.add(r)}return{added:n,removed:s,updated:t}}function f(l,w,i){const o=[...l.keys()],n=[...w.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,C)=>(a.add(C),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,C)=>(a.add(C),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const C=l.get(a).map(h=>({...h,key:i[h.key]})),p=w.get(a).map(h=>({...h,key:i[h.key]}));v(C,p)||r.add(a)}return{added:s,removed:t,updated:r}}function v(l,w){return!(!(0,L.equals)(l.filter(({command:i})=>i[0]!=="-"),w.filter(({command:i})=>i[0]!=="-"),(i,o)=>E(i,o))||!(0,L.equals)(l.filter(({command:i})=>i[0]==="-"),w.filter(({command:i})=>i[0]==="-"),(i,o)=>E(i,o)))}function E(l,w){if(l.command!==w.command||l.key!==w.key)return!1;const i=T.ContextKeyExpr.deserialize(l.when),o=T.ContextKeyExpr.deserialize(w.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!A.equals(l.args,w.args))}function c(l,w,i){for(const o of w)l=_.edit(l,[-1],o,i);return l}function d(l,w,i){const o=R(l);for(let n=o.length-1;n>=0;n--)(o[n].command===w||o[n].command===`-${w}`)&&(l=_.edit(l,[n],void 0,i));return l}function g(l,w,i,o){const n=R(l),s=n.findIndex(t=>t.command===w||t.command===`-${w}`);for(let t=n.length-1;t>=0;t--)(n[t].command===w||n[t].command===`-${w}`)&&(l=_.edit(l,[t],void 0,o));for(let t=i.length-1;t>=0;t--)l=_.edit(l,[s],i[t],o);return l}}),define(le[239],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(T,_,R){const b={},m={},P=new Set;if(!_)return{local:{added:b,updated:m,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const I=O(T,_);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:b,updated:m,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=O(R,T),u=O(R,_),f={},v={},E=new Set,c=new Set;for(const d of S.removed.values())u.updated.has(d)?b[d]=_[d]:E.add(d);for(const d of u.removed.values())c.has(d)||(S.updated.has(d)?c.add(d):P.add(d));for(const d of S.updated.values())c.has(d)||(u.updated.has(d)?I.updated.has(d)&&c.add(d):v[d]=T[d]);for(const d of u.updated.values())c.has(d)||(S.updated.has(d)?I.updated.has(d)&&c.add(d):T[d]!==void 0&&(m[d]=_[d]));for(const d of S.added.values())c.has(d)||(u.added.has(d)?I.updated.has(d)&&c.add(d):f[d]=T[d]);for(const d of u.added.values())c.has(d)||(S.added.has(d)?I.updated.has(d)&&c.add(d):b[d]=_[d]);return{local:{added:b,removed:[...P.values()],updated:m},remote:{added:f,removed:[...E.values()],updated:v},conflicts:[...c.values()]}}e.merge=L;function O(T,_){const R=T?Object.keys(T):[],b=_?Object.keys(_):[],m=b.filter(S=>!R.includes(S)).reduce((S,u)=>(S.add(u),S),new Set),P=R.filter(S=>!b.includes(S)).reduce((S,u)=>(S.add(u),S),new Set),I=new Set;for(const S of R){if(P.has(S))continue;const u=T[S],f=_[S];u!==f&&I.add(S)}return{added:m,removed:P,updated:I}}function A(T,_){const{added:R,removed:b,updated:m}=O(T,_);return R.size===0&&b.size===0&&m.size===0}e.areSame=A}),define(le[240],ue([0,1,30]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(T,_,R,b){const m={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!_){const S=T.filter(({id:u})=>!b.includes(u));return S.length?P.added=S:P=null,{local:m,remote:P}}const I=A(T,_,b);if(I.added.length>0||I.removed.length>0||I.updated.length>0){const S=A(R,T,b),u=A(R,_,b);for(const f of u.removed){const v=T.find(E=>E.id===f);v&&m.removed.push(v)}for(const f of u.added){const v=_.find(E=>E.id===f);S.added.includes(f)?I.updated.includes(f)&&m.updated.push(v):m.added.push(v)}for(const f of u.updated)m.updated.push(_.find(v=>v.id===f));for(const f of S.added)u.added.includes(f)||P.added.push(T.find(v=>v.id===f));for(const f of S.updated)u.removed.includes(f)||u.updated.includes(f)||P.updated.push(T.find(v=>v.id===f));for(const f of S.removed){const v=_.find(E=>E.id===f);v&&P.removed.push(v)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:m,remote:P}}e.merge=O;function A(T,_,R){T=T?T.filter(({id:u})=>!R.includes(u)):[],_=_.filter(({id:u})=>!R.includes(u));const b=T.map(({id:u})=>u),m=_.map(({id:u})=>u),P=m.filter(u=>!b.includes(u)),I=b.filter(u=>!m.includes(u)),S=[];for(const{id:u,name:f,shortName:v,icon:E,useDefaultFlags:c}of T){if(I.includes(u))continue;const d=_.find(g=>g.id===u);(!d||d.name!==f||d.shortName!==v||d.icon!==E||!(0,L.equals)(d.useDefaultFlags,c))&&S.push(u)}return{added:P,removed:I,updated:S}}}),define(le[25],ue([0,1,17,12,176,44,29,4,103,41]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function P(){const t=m.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function I(){const t=m.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(p=>!!t[p].ignoreSync),a=Object.keys(t).filter(p=>t[p].scope===2||t[p].scope===6),C=P();return(0,L.distinct)([...r,...a,...C])}e.getDefaultIgnoredSettings=I,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const t="vscode://schemas/ignoredSettings",r=m.Registry.as(T.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=m.Registry.as(b.Extensions.JSONContribution),C=()=>{const p=P(),h=I(),y=Object.keys(T.allSettings.properties).filter(M=>!h.includes(M)),D=h.filter(M=>!p.includes(M)),U={items:{type:"string",enum:[...y,...D.map(M=>`-${M}`)]}};a.registerSchema(t,U)};return r.onDidUpdateConfiguration(()=>C())}e.registerConfiguration=S;function u(t){return t&&(0,O.isObject)(t)&&(0,O.isString)(t.id)&&Array.isArray(t.scopes)}e.isAuthenticationProvider=u;var f;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(t,...r){return t?[t,...r]:r}e.getPathSegments=v;function E(t,r,a,C){return C.joinPath(a.userDataSyncHome,...v(t,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=E,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,R.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function c(t){const r={};return r[e.HEADER_EXECUTION_ID]=t,r}e.createSyncHeaders=c;var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class g extends Error{constructor(r,a,C,p){super(r),this.code=a,this.resource=C,this.operationId=p,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class l extends g{constructor(r,a,C,p,h){super(r,C,void 0,h),this.url=a,this.serverCode=p}}e.UserDataSyncStoreError=l;class w extends g{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=w,function(t){function r(a){if(a instanceof t)return a;const C=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(C&&C[1]){const p=C[2]==="unknown"?void 0:C[2],h=C[3]==="unknown"?void 0:C[3];return new t(a.message,C[1],p,h)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(g||(e.UserDataSyncError=g={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(le[241],ue([0,1,30,25]),function(se,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(_,R,b,m,P){if(!R)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const I=T(_,R);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=b?T(b,R):{added:Object.keys(R).reduce((d,g)=>(d.add(g),d),new Set),removed:new Set,updated:new Set},u=b?T(b,_):{added:Object.keys(_).reduce((d,g)=>(d.add(g),d),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},v=L.deepClone(R),E=!b;for(const d of u.added.values())d!==O.SYNC_SERVICE_URL_TYPE&&E&&S.added.has(d)||(v[d]=_[d]);for(const d of u.updated.values())v[d]=_[d];for(const d of u.removed.values())m.unregistered.includes(d)||delete v[d];for(const d of S.added.values()){const g=R[d];if(m.machine.includes(d)){P.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(b&&u.added.has(d))continue;const l=_[d];l&&l.value===g.value||d===O.SYNC_SERVICE_URL_TYPE&&E&&u.added.has(d)||(l?f.updated[d]=g:f.added[d]=g)}for(const d of S.updated.values()){const g=R[d];if(m.machine.includes(d)){P.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(d)||u.removed.has(d))continue;const l=_[d];l&&l.value===g.value||(f.updated[d]=g)}for(const d of S.removed.values()){if(m.machine.includes(d)){P.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}u.updated.has(d)||u.removed.has(d)||f.removed.push(d)}const c=T(R,v);return{local:f,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:v}}}e.merge=A;function T(_,R){const b=Object.keys(_),m=Object.keys(R),P=m.filter(u=>!b.includes(u)).reduce((u,f)=>(u.add(f),u),new Set),I=b.filter(u=>!m.includes(u)).reduce((u,f)=>(u.add(f),u),new Set),S=new Set;for(const u of b){if(I.has(u))continue;const f=_[u],v=R[u];L.equals(f,v)||S.add(u)}return{added:P,removed:I,updated:S}}}),define(le[242],ue([0,1,17,34,62,42,30,80,25]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function m(a,C,p){let h=[];p?h=I(p):h=P(C);const y=[],D=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(h))for(const U of h)U.startsWith("-")?D.push(U.substring(1)):y.push(U);return(0,L.distinct)([...a,...y].filter(U=>!D.includes(U)))}e.getIgnoredSettings=m;function P(a){let C=a.inspect("settingsSync.ignoredSettings").userValue;return C!==void 0||(C=a.inspect("sync.ignoredSettings").userValue,C!==void 0)?C:a.getValue("settingsSync.ignoredSettings")||[]}function I(a){const C=(0,O.parse)(a);return C?C["settingsSync.ignoredSettings"]||C["sync.ignoredSettings"]||[]:[]}function S(a,C){const p=(0,O.parse)(a)||{};let h="{}";for(const y of Object.keys(p)){const D=(0,A.setProperty)(h,[y],p[y],C);h=(0,A.applyEdits)(h,D)}return h}e.removeComments=S;function u(a,C,p,h){if(p.length){const y=r(C),D=(0,O.parse)(C)||{},U=(0,O.parse)(a);if(!U)return a;const M=[];for(const F of p){const z=D[F],X=U[F];z===void 0?a=R.edit(a,[F],void 0,h):X!==void 0?a=R.edit(a,[F],z,h):M.push(i(F,y))}M.sort((F,z)=>F.startOffset-z.startOffset),M.forEach(F=>a=d(F.setting.key,C,a,h))}return a}e.updateIgnoredSettings=u;function f(a,C,p,h,y,D){const U=u(a,C,h,D),M=p!==U,F=p!==C;if(!M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:u(C,a,h,D),remoteContent:null,hasConflicts:!1};if(p===null&&E(a)){const N=v(a,C,h)?null:u(C,a,h,D);return{conflictsSettings:[],localContent:N,remoteContent:null,hasConflicts:!1}}let z=a,X=C;const K=(0,O.parse)(a),Q=(0,O.parse)(C),V=p?(0,O.parse)(p):null,Y=h.reduce((N,j)=>(N.add(j),N),new Set),x=c(K,Q,Y),q=c(V,K,Y),te=c(V,Q,Y),oe=new Map,ee=new Set,ae=N=>{ee.add(N);const j=y.filter(({key:$})=>$===N)[0];j?(z=R.edit(z,[N],j.value,D),X=R.edit(X,[N],j.value,D)):oe.set(N,{key:N,localValue:K[N],remoteValue:Q[N]})};for(const N of q.removed.values())te.updated.has(N)?ae(N):X=R.edit(X,[N],void 0,D);for(const N of te.removed.values())ee.has(N)||(q.updated.has(N)?ae(N):z=R.edit(z,[N],void 0,D));for(const N of q.updated.values())ee.has(N)||(te.updated.has(N)?x.updated.has(N)&&ae(N):X=R.edit(X,[N],K[N],D));for(const N of te.updated.values())ee.has(N)||(q.updated.has(N)?x.updated.has(N)&&ae(N):z=R.edit(z,[N],Q[N],D));for(const N of q.added.values())ee.has(N)||(te.added.has(N)?x.updated.has(N)&&ae(N):X=d(N,z,X,D));for(const N of te.added.values())ee.has(N)||(q.added.has(N)?x.updated.has(N)&&ae(N):z=d(N,X,z,D));const B=oe.size>0||!v(z,X,h),W=B||!v(z,a,[]),k=B||!v(X,C,[]);return{localContent:W?z:null,remoteContent:k?X:null,conflictsSettings:[...oe.values()],hasConflicts:B}}e.merge=f;function v(a,C,p){if(a===C)return!0;const h=(0,O.parse)(a),y=(0,O.parse)(C),D=p.reduce((F,z)=>(F.add(z),F),new Set),U=r(a).filter(F=>!(F.setting&&D.has(F.setting.key))),M=r(C).filter(F=>!(F.setting&&D.has(F.setting.key)));if(U.length!==M.length)return!1;for(let F=0;F<U.length;F++){const z=U[F],X=M[F];if(z.setting&&X.setting){if(z.setting.key!==X.setting.key||!_.equals(h[z.setting.key],y[z.setting.key]))return!1}else if(!z.setting&&!X.setting){if(z.value!==X.value)return!1}else return!1}return!0}function E(a){return a?r(a).length===0:!0}e.isEmpty=E;function c(a,C,p){const h=a?Object.keys(a).filter(F=>!p.has(F)):[],y=Object.keys(C).filter(F=>!p.has(F)),D=y.filter(F=>!h.includes(F)).reduce((F,z)=>(F.add(z),F),new Set),U=h.filter(F=>!y.includes(F)).reduce((F,z)=>(F.add(z),F),new Set),M=new Set;if(a)for(const F of h){if(U.has(F))continue;const z=a[F],X=C[F];_.equals(z,X)||M.add(F)}return{added:D,removed:U,updated:M}}function d(a,C,p,h){const y=(0,O.parse)(C),D=r(C),U=r(p),M=g(a,D,U);return l(p,a,y[a],M,U,h)}e.addSetting=d;function g(a,C,p){const h=C.findIndex(D=>D.setting?.key===a),y=C[h-1];if(y){if(y.setting){const U=i(y.setting.key,p);if(U)return{index:p.indexOf(U),insertAfter:!0}}else{const U=o(h,C);if(U){const M=i(U.setting.key,p);if(M){const F=n(p.indexOf(M),p),z=s(C,U,C[h]);if(F){const X=s(p,M,F),K=t(z,X);return K?{index:p.indexOf(K),insertAfter:!0}:{index:p.indexOf(F),insertAfter:!1}}else{const X=s(p,M,p[p.length-1]),K=t(z,X);return K?{index:p.indexOf(K),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const D=C[h+1];if(D)if(D.setting){const U=i(D.setting.key,p);if(U)return{index:p.indexOf(U),insertAfter:!1}}else{const U=n(h,C);if(U){const M=i(U.setting.key,p);if(M){const F=o(p.indexOf(M),p),z=s(C,C[h],U);if(F){const X=s(p,F,M),K=t(z.reverse(),X.reverse());return K?{index:p.indexOf(K),insertAfter:!1}:{index:p.indexOf(F),insertAfter:!0}}else{const X=s(p,p[0],M),K=t(z.reverse(),X.reverse());return K?{index:p.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function l(a,C,p,h,y,D){let U;return h.index===-1?U=(0,A.setProperty)(a,[C],p,D):U=w(a,C,p,h,y,D).map(M=>(0,A.withFormatting)(a,M,D)[0]),(0,A.applyEdits)(a,U)}function w(a,C,p,h,y,D){const U=`${JSON.stringify(C)}: ${JSON.stringify(p)}`,M=(0,T.getEOL)(D,a),F=y[h.index];if(h.insertAfter){const z=[];if(F.setting)z.push({offset:F.endOffset,length:0,content:","+U});else{const X=n(h.index,y),K=o(h.index,y),Q=K?.setting?.commaOffset;K&&Q===void 0&&z.push({offset:K.endOffset,length:0,content:","});const V=Q!==void 0&&Q>F.endOffset;z.push({offset:V?Q+1:F.endOffset,length:0,content:X?M+U+",":M+U})}return z}else{if(F.setting)return[{offset:F.startOffset,length:0,content:U+","}];const z=(y[h.index-1]&&!y[h.index-1].setting?M:"")+U+(n(h.index,y)?",":"")+M;return[{offset:F.startOffset,length:0,content:z}]}}function i(a,C){return C.filter(p=>p.setting?.key===a)[0]}function o(a,C){for(let p=a-1;p>=0;p--)if(C[p].setting)return C[p]}function n(a,C){for(let p=a+1;p<C.length;p++)if(C[p].setting)return C[p]}function s(a,C,p){const h=a.indexOf(C),y=a.indexOf(p);return a.filter((D,U)=>h<U&&U<y)}function t(a,C){if(a.length&&C.length){let p=0;for(;p<C.length&&p<a.length;p++)if(a[p].value!==C[p].value)return C[p-1];return C[p-1]}}function r(a){const C=[];let p=-1,h,y;const D={onObjectBegin:U=>{p++},onObjectProperty:(U,M,F)=>{p===0&&(h=M,y=U)},onObjectEnd:(U,M)=>{p--,p===0&&C.push({startOffset:h,endOffset:U+M,value:a.substring(h,U+M),setting:{key:y,commaOffset:void 0}})},onArrayBegin:(U,M)=>{p++},onArrayEnd:(U,M)=>{p--,p===0&&C.push({startOffset:h,endOffset:U+M,value:a.substring(h,U+M),setting:{key:y,commaOffset:void 0}})},onLiteralValue:(U,M,F)=>{p===0&&C.push({startOffset:h,endOffset:M+F,value:a.substring(h,M+F),setting:{key:y,commaOffset:void 0}})},onSeparator:(U,M,F)=>{if(p===0&&U===","){let z=C.length-1;for(;z>=0&&!C[z].setting;z--);const X=C[z];X&&C.splice(z,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:M}})}},onComment:(U,M)=>{p===0&&C.push({startOffset:U,endOffset:U+M,value:a.substring(U,U+M)})}};return(0,O.visit)(a,D),C}}),define(le[81],ue([0,1,3,2,4,25]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let _=class extends O.Disposable{get account(){return this._account}constructor(b,m){super(),this.userDataSyncStoreService=b,this.logService=m,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(P=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,P),this.updateAccount(void 0),P==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};e.UserDataSyncAccountService=_,e.UserDataSyncAccountService=_=Ee([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],_)}),define(le[243],ue([0,1,20,177,15,8,25]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends T.AbstractLogger{constructor(m,P){super(),this.logger=this._register(m.createLogger((0,L.joinPath)(P.logsHome,`${_.USER_DATA_SYNC_LOG_ID}.log`),{id:_.USER_DATA_SYNC_LOG_ID,name:(0,O.localize)(0,null)}))}trace(m,...P){this.logger.trace(m,...P)}debug(m,...P){this.logger.debug(m,...P)}info(m,...P){this.logger.info(m,...P)}warn(m,...P){this.logger.warn(m,...P)}error(m,...P){this.logger.error(m,...P)}flush(){this.logger.flush()}};e.UserDataSyncLogService=R,e.UserDataSyncLogService=R=Ee([G(0,T.ILoggerService),G(1,A.IEnvironmentService)],R)}),define(le[244],ue([0,1,6,3,2]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends A.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:b,getActiveWindowId:m}){super(),this.disposables=this._register(new A.DisposableStore),O.Event.latch(O.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>m()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(le[112],ue([0,1,180,16,48,20,10,4,23]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function m(s){const t=s;return typeof t?.id=="string"&&_.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=m;function P(s){return typeof s?.id=="string"&&!m(s)&&!S(s)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,O.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=I;function S(s){const t=s;return typeof t?.id=="string"&&_.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=S;function u(s){const t=s;if(t?.uri)return{id:t.id,uri:_.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=u;var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function v(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=v;function E(s){const t=s;return!!(t&&typeof t=="object"&&_.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=E;class c{constructor(t,r,a,C,p){this._id=t,this._transient=a,this._configuration=C,this._ignorePathCasing=p,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function g(s){return new d({uri:s,index:0,name:(0,T.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(s,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function w(s){let t;return _.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=w,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(s,t){return!l(s,t)&&!w(s)}e.isSavedWorkspace=o;function n(s){return(typeof s=="string"?(0,O.extname)(s):(0,T.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(le[18],ue([0,1,54,3,2,20,10,171,15,11,4,8,112,35,28,6,32,27,12]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var g;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function l(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&_.URI.isUri(t.location)&&_.URI.isUri(t.globalStorageHome)&&_.URI.isUri(t.settingsResource)&&_.URI.isUri(t.keybindingsResource)&&_.URI.isUri(t.tasksResource)&&_.URI.isUri(t.snippetsHome)&&_.URI.isUri(t.extensionsResource))}e.isUserDataProfile=l,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function w(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:_.URI.revive(s.location).with({scheme:t}),globalStorageHome:_.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:_.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:_.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:_.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:_.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:_.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:_.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=w;function i(s,t,r,a,C,p){return{id:s,name:t,location:r,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:p&&C?.useDefaultFlags?.globalState?p.globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:p&&C?.useDefaultFlags?.settings?p.settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:p&&C?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:p&&C?.useDefaultFlags?.tasks?p.tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:p&&C?.useDefaultFlags?.snippets?p.snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:p&&C?.useDefaultFlags?.extensions?p.extensionsResource:(0,T.joinPath)(r,"extensions.json"),cacheHome:(0,T.joinPath)(a,s),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.toUserDataProfile=i;let o=class extends A.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,a,C){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=a,this.logService=C,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,T.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.createDefaultProfile(),r=[t];if(this.enabled)try{for(const p of this.getStoredProfiles()){if(!p.name||!(0,d.isString)(p.name)||!p.location){this.logService.warn("Skipping the invalid stored profile",p.location||p.name);continue}r.push(i((0,T.basename)(p.location),p.name,p.location,this.profilesCacheHome,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},t))}}catch(p){this.logService.error(p)}const a=new u.ResourceMap,C=new Map;if(r.length)try{const p=this.getStoredProfileAssociations();if(p.workspaces)for(const[h,y]of Object.entries(p.workspaces)){const D=_.URI.parse(h),U=r.find(M=>M.id===y);U&&a.set(D,U)}if(p.emptyWindows)for(const[h,y]of Object.entries(p.emptyWindows)){const D=r.find(U=>U.id===y);D&&C.set(h,D)}}catch(p){this.logService.error(p)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:C}}return this._profilesObject}createDefaultProfile(){const t=i("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...t,extensionsResource:this.getDefaultProfileExtensionsLocation()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,c.escapeRegExpCharacters)(r)}\\s(\\d+)`);let C=0;for(const h of this.profiles){const y=a.exec(h.name),D=y?parseInt(y[1]):0;C=D>C?D:C}const p=`${r} ${C+1}`;return this.createProfile((0,L.hash)((0,E.generateUuid)()).toString(16),p,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,L.hash)((0,E.generateUuid)()).toString(16),t,r,a)}async createProfile(t,r,a,C){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=await this.doCreateProfile(t,r,a);return C&&await this.setProfileForWorkspace(C,p),p}async doCreateProfile(t,r,a){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.profileCreationPromises.get(r);return C||(C=(async()=>{try{const p=this.profiles.find(D=>D.name===r||D.id===t);if(p)return p;const h=i(t,r,(0,T.joinPath)(this.profilesHome,t),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(h.location);const y=[];return this._onWillCreateProfile.fire({profile:h,join(D){y.push(D)}}),await v.Promises.settled(y),this.updateProfiles([h],[],[]),h}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,C)),C}async updateProfile(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(C=>C.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(C=>C.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(C){a.push(C)}});try{await Promise.allSettled(a)}catch(C){this.logService.error(C)}for(const C of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(C)?.id&&this.profilesObject.emptyWindows.delete(C);for(const C of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(C)?.id&&this.profilesObject.workspaces.delete(C);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(C){(0,m.toFileOperationResult)(C)!==1&&this.logService.error(C)}}async setProfileForWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(C=>C.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,a)}unsetWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(t){return(0,S.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,S.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,a){const C=[...this.profiles,...t],p=[];this.transientProfilesObject.profiles=[];for(let h of C)h.isDefault||r.some(y=>h.id===y.id)||(h=a.find(y=>h.id===y.id)??h,h.isTransient?this.transientProfilesObject.profiles.push(h):p.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.saveStoredProfiles(p),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,a)}triggerProfilesChanges(t,r,a){this._onDidChangeProfiles.fire({added:t,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(t,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(t,void 0,!0);const C=this.getWorkspace(t),p=a?this.transientProfilesObject:this.profilesObject;_.URI.isUri(C)?(p.workspaces.delete(C),r&&p.workspaces.set(C,r)):(p.emptyWindows.delete(C),r&&p.emptyWindows.set(C,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[a,C]of this.profilesObject.workspaces.entries())t[a.toString()]=C.id;const r={};for(const[a,C]of this.profilesObject.emptyWindows.entries())r[a.toString()]=C.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const r={},a=this.createDefaultProfile();if(t.workspaces)for(const[p,h]of Object.entries(t.workspaces)){const y=_.URI.parse(h);r[p]=this.uriIdentityService.extUri.isEqual(y,a.location)?a.id:this.uriIdentityService.extUri.basename(y)}const C={};if(t.emptyWindows)for(const[p,h]of Object.entries(t.emptyWindows)){const y=_.URI.parse(h);C[p]=this.uriIdentityService.extUri.isEqual(y,a.location)?a.id:this.uriIdentityService.extUri.basename(y)}return{workspaces:r,emptyWindows:C}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=Ee([G(0,b.IEnvironmentService),G(1,m.IFileService),G(2,f.IUriIdentityService),G(3,I.ILogService)],o);class n extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(le[245],ue([0,1,6,2,18]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends O.Disposable{constructor(R){super(),this._register(new L.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=T,e.UserDataProfilesCleaner=T=Ee([G(0,A.IUserDataProfilesService)],T)}),define(le[246],ue([0,1,17,6,26,7,3,2,5,12,10,154,29,33,45,8,24,22,28,18]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let l=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(t,r,a,C,p,h){super(),this.galleryService=t,this.telemetryService=r,this.uriIdentityService=a,this.logService=C,this.productService=p,this.userDataProfilesService=h,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this._onDidUpdateExtensionMetadata=this._register(new _.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:y})=>y.cancel()),this.uninstallingExtensions.forEach(y=>y.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,S.isTargetPlatformCompatible)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const C=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:p})=>(0,u.areSameExtensions)(p,t.identifier));if(C?.local)return C?.local;throw C?.error?C.error:new S.ExtensionManagementError(`Unknown error while installing extension ${t.identifier.id}`,S.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.galleryService.isEnabled())throw new S.ExtensionManagementError(I.localize(0,null),S.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:C,options:p})=>{try{const h=await this.checkAndGetCompatibleVersion(C,!!p?.installGivenVersion,!!p?.installPreReleaseVersion);a.push({...h,options:p})}catch(h){r.push({identifier:C.identifier,operation:2,source:C,error:h})}})),a.length&&r.push(...await this.installExtensions(a));for(const C of r)C.error&&(this.logService.error("Failed to install extension.",C.identifier.id),this.logService.error(C.error),C.source&&!P.URI.isUri(C.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,u.getGalleryExtensionTelemetryData)(C.source),error:C.error}));return r}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async toggleAppliationScope(t,r){if((0,f.isApplicationScopedExtension)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(t,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const C of this.userDataProfilesService.profiles){const p=(await this.getInstalled(1,C.extensionsResource)).find(h=>(0,u.areSameExtensions)(h.identifier,t.identifier));p?this._onDidUpdateExtensionMetadata.fire(p):this._onDidUninstallExtension.fire({identifier:t.identifier,profileLocation:C.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(t,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtensions(t){const r=[],a=new Map,C=[],p=[],h=(D,U)=>`${u.ExtensionKey.create(D).toString()}-${U.toString()}`,y=(D,U,M)=>{const F=this.createInstallExtensionTask(D,U,M),z=P.URI.isUri(U)?U.path:`${U.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`;a.set(z,{task:F,manifest:D}),this._onInstallExtension.fire({identifier:F.identifier,source:U,profileLocation:M.profileLocation}),this.logService.info("Installing extension:",F.identifier.id),P.URI.isUri(U)||this.installingExtensions.set(h(U,M.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:D,extension:U,options:M}of t){const F=M.isApplicationScoped||M.isBuiltin||(0,f.isApplicationScopedExtension)(D),z={...M,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(U)?M.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:F,profileLocation:F?this.userDataProfilesService.defaultProfile.extensionsResource:M.profileLocation??this.getCurrentExtensionsManifestLocation()},X=P.URI.isUri(U)?void 0:this.installingExtensions.get(h(U,z.profileLocation));X?(this.logService.info("Extension is already requested to install",X.task.identifier.id),C.push(X.task.waitUntilTaskIsFinished())):y(D,U,z)}await Promise.all([...a.values()].map(async({task:D,manifest:U})=>{if(D.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const M=await this.getAllDepsAndPackExtensions(D.identifier,U,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation),F=await this.getInstalled(void 0,D.options.profileLocation),z={...D.options,donotIncludePackAndDependencies:!0,context:{...D.options.context,[S.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:X,manifest:K}of(0,L.distinct)(M,({gallery:Q})=>Q.identifier.id)){if(a.has(`${X.identifier.id.toLowerCase()}-${z.profileLocation.toString()}`))continue;const Q=this.installingExtensions.get(h(X,z.profileLocation));if(Q){if(this.canWaitForTask(D,Q.task)){const V=Q.task.identifier;this.logService.info("Waiting for already requested installing extension",V.id,D.identifier.id),Q.waitingTasks.push(D),C.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,Y=>Y.some(x=>(0,u.areSameExtensions)(x.identifier,V)))).then(Y=>{if(this.logService.info("Finished waiting for already requested installing extension",V.id,D.identifier.id),!Y.find(q=>(0,u.areSameExtensions)(q.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else F.some(({identifier:V})=>(0,u.areSameExtensions)(V,X.identifier))||y(K,X,z)}}catch(M){if(P.URI.isUri(D.source))(0,L.isNonEmptyArray)(U.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",D.identifier.id,M.message),(0,L.isNonEmptyArray)(U.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",D.identifier.id,M.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),M}})),await this.joinAllSettled([...a.values()].map(async({task:D})=>{const U=new Date().getTime();try{const M=await D.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(M,D.source,D.options,A.CancellationToken.None))),!P.URI.isUri(D.source)){const F=D.operation===3,z=F?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(o(this.telemetryService,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.getGalleryExtensionTelemetryData)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-U,durationSinceUpdate:z}),b.isWeb&&D.operation!==3)try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}p.push({local:M,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw this.logService.error("Error while installing the extension",D.identifier.id,(0,T.getErrorMessage)(M)),M}})),C.length&&await this.joinAllSettled(C);for(const D of p)this.logService.info("Extension installed successfully:",D.identifier.id),r.push(D);return r}catch(D){p.length&&await Promise.allSettled(p.map(async({local:U,profileLocation:M})=>{try{await this.createUninstallExtensionTask(U,{versionOnly:!0,profileLocation:M}).run(),this.logService.info("Rollback: Uninstalled extension",U.identifier.id)}catch(F){this.logService.warn("Rollback: Error while uninstalling extension",U.identifier.id,(0,T.getErrorMessage)(F))}}));for(const{task:U}of a.values())U.cancel(),r.push({identifier:U.identifier,operation:2,source:U.source,context:U.options.context,profileLocation:U.profileLocation,error:D});throw D}finally{for(const{task:D}of a.values())D.source&&!P.URI.isUri(D.source)&&this.installingExtensions.delete(h(D.source,D.profileLocation));r.length&&this._onDidInstallExtensions.fire(r)}}canWaitForTask(t,r){for(const[,{task:a,waitingTasks:C}]of this.installingExtensions.entries())if(a===t&&(C.includes(r)||C.some(p=>this.canWaitForTask(p,r)))||a===r&&C[0]&&!this.canWaitForTask(t,C[0]))return!1;return!0}async joinAllSettled(t){const r=[],a=[],C=await Promise.allSettled(t);for(const p of C)p.status==="fulfilled"?r.push(p.value):a.push(p.reason);if(a.length)throw w(a);return r}async getAllDepsAndPackExtensions(t,r,a,C,p){if(!this.galleryService.isEnabled())return[];const h=await this.getInstalled(void 0,p),y=[],D=[],U=async(M,F)=>{y.push(M);const z=F.extensionDependencies||[],X=[...z];if(F.extensionPack){const K=a?h.find(Q=>(0,u.areSameExtensions)(Q.identifier,M)):void 0;for(const Q of F.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(V=>(0,u.areSameExtensions)({id:V},{id:Q}))||X.every(V=>!(0,u.areSameExtensions)({id:V},{id:Q}))&&X.push(Q)}if(X.length){const K=X.filter(Q=>y.every(V=>!(0,u.areSameExtensions)(V,{id:Q})));if(K.length){const Q=await this.galleryService.getExtensions(K.map(V=>({id:V,preRelease:C})),A.CancellationToken.None);for(const V of Q){if(y.find(q=>(0,u.areSameExtensions)(q,V.identifier)))continue;const Y=z.some(q=>(0,u.areSameExtensions)({id:q},V.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(V,!1,C)}catch(q){if(Y)throw q;this.logService.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,T.getErrorMessage)(q));continue}D.push({gallery:x.extension,manifest:x.manifest}),await U(x.extension.identifier,x.manifest)}}}};return await U(t,r),D}async checkAndGetCompatibleVersion(t,r,a){let C;const p=await this.getExtensionsControlManifest();if(p.malicious.some(D=>(0,u.areSameExtensions)(t.identifier,D)))throw new S.ExtensionManagementError(I.localize(1,null,t.identifier.id),S.ExtensionManagementErrorCode.Malicious);const h=p.deprecated[t.identifier.id.toLowerCase()];if(h?.extension?.autoMigrate){if(this.logService.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${h.extension.id}' extension instead.`),C=(await this.galleryService.getExtensions([{id:h.extension.id,preRelease:h.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!C)throw new S.ExtensionManagementError(I.localize(2,null,t.identifier.id,h.extension.id),S.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new S.ExtensionManagementError(I.localize(3,null,t.identifier.id,this.productService.nameLong,(0,S.TargetPlatformToString)(D)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.getCompatibleVersion(t,r,a),!C)throw!a&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],A.CancellationToken.None))[0]?new S.ExtensionManagementError(I.localize(4,null,t.displayName??t.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),S.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",C.identifier.id);const y=await this.galleryService.getManifest(C,A.CancellationToken.None);if(y===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${C.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(y.version!==C.version)throw new S.ExtensionManagementError(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:y}}async getCompatibleVersion(t,r,a){const C=await this.getTargetPlatform();let p=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(p=(await this.galleryService.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:C,compatible:!0},A.CancellationToken.None))[0]||null),!p&&await this.galleryService.isExtensionCompatible(t,a,C)&&(p=t),p||(r?p=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:C,compatible:!0},A.CancellationToken.None))[0]||null:p=await this.galleryService.getCompatibleExtension(t,a,C)),p}async uninstallExtension(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},C=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,p=this.uninstallingExtensions.get(C(t.identifier));if(p)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),p.waitUntilTaskIsFinished();const h=M=>{const F=this.createUninstallExtensionTask(M,a);return this.uninstallingExtensions.set(C(F.extension.identifier),F),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),F},y=(M,F)=>{F?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,u.getLocalExtensionTelemetryData)(M),error:F}),this._onDidUninstallExtension.fire({identifier:M.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],U=[];try{D.push(h(t));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(t,M);for(const z of F)this.uninstallingExtensions.has(C(z.identifier))?this.logService.info("Extensions is already requested to uninstall",z.identifier.id):D.push(h(z))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(D.map(F=>F.extension),M,t),await this.joinAllSettled(D.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(z=>z.postUninstall(F.extension,a,A.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}y(F.extension)}catch(z){const X=z instanceof S.ExtensionManagementError?z:new S.ExtensionManagementError((0,T.getErrorMessage)(z),S.ExtensionManagementErrorCode.Internal);throw y(F.extension,X),X}finally{U.push(F)}}))}catch(M){const F=M instanceof S.ExtensionManagementError?M:new S.ExtensionManagementError((0,T.getErrorMessage)(M),S.ExtensionManagementErrorCode.Internal);for(const z of D){try{z.cancel()}catch{}U.includes(z)||y(z.extension,F)}throw F}finally{for(const M of D)this.uninstallingExtensions.delete(C(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(t,r,a){for(const C of t){const p=this.getDependents(C,r);if(p.length){const h=p.filter(y=>!t.some(D=>(0,u.areSameExtensions)(D.identifier,y.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(C,h,a))}}}getDependentsErrorMessage(t,r,a){return a===t?r.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const C=t.manifest.extensionPack?t.manifest.extensionPack:[];if(C.length){const p=r.filter(y=>!y.isBuiltin&&C.some(D=>(0,u.areSameExtensions)({id:D},y.identifier))),h=[];for(const y of p)h.push(...this.getAllPackExtensionsToUninstall(y,r,a));return[...p,...h]}return[]}getDependents(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(C=>(0,u.areSameExtensions)({id:C},t.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(t){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,T.getErrorMessage)(t)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=l,e.AbstractExtensionManagementService=l=Ee([G(0,S.IExtensionGalleryService),G(1,c.ITelemetryService),G(2,d.IUriIdentityService),G(3,v.ILogService),G(4,E.IProductService),G(5,g.IUserDataProfilesService)],l);function w(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=w;function i(s){if(s instanceof S.ExtensionManagementError)return s;if(s instanceof S.ExtensionGalleryError){const r=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new S.ExtensionManagementError(s.message,S.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.toExtensionManagementError=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:C,error:p,durationSinceUpdate:h}){let y,D;(0,m.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(y=S.ExtensionManagementErrorCode.Signature,D=a),a="Unverified")),p&&(p instanceof S.ExtensionManagementError||p instanceof S.ExtensionGalleryError?(y=p.code,p.code===S.ExtensionManagementErrorCode.Signature&&(D=p.message)):y=S.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!p,duration:C,errorcode:y,errorcodeDetail:D,durationSinceUpdate:h})}class n{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(t=>new Promise((r,a)=>{const C=t.onCancellationRequested(()=>{C.dispose(),a(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(le[52],ue([0,1,6,14,2,3,35,10,29,33,11,4,8,18,28,12,7,22]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class g extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let l=class extends A.Disposable{constructor(n,s,t,r,a,C){super(),this.extensionsLocation=n,this.fileService=s,this.userDataProfilesService=t,this.uriIdentityService=r,this.telemetryService=a,this.logService=C,this._onAddExtensions=this._register(new T.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new T.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new T.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new T.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(n,s){return this.withProfileExtensions(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.withProfileExtensions(s,a=>{const C=[];for(const p of a)n.some(([h])=>(0,m.areSameExtensions)(h.identifier,p.identifier)&&h.manifest.version!==p.version)?t.push(p):C.push(p);for(const[p,h]of n){const y=C.findIndex(U=>(0,m.areSameExtensions)(U.identifier,p.identifier)&&U.version===p.manifest.version),D={identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:h};y===-1?(r.push(D),C.push(D)):C.splice(y,1,D)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:s}),t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:s}),C}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:s}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:a,profileLocation:s}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.withProfileExtensions(s,r=>{const a=[];for(const C of r){const p=n.find(([h])=>(0,m.areSameExtensions)(h.identifier,C.identifier)&&h.manifest.version===C.version);p&&(C.metadata={...C.metadata,...p[1]},t.push(C)),a.push(C)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.withProfileExtensions(s,r=>{const a=[];for(const C of r)(0,m.areSameExtensions)(C.identifier,n.identifier)?t.push(C):a.push(C);return t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:s}),a}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:r,profileLocation:s}),r}}async withProfileExtensions(n,s,t){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],a;try{const C=await this.fileService.readFile(n);a=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,P.toFileOperationResult)(C)!==1)throw C;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&t?.bailOutWhenFileNotFound)throw new g((0,E.getErrorMessage)(C),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let C=!1;for(const p of a){w(p)||this.reportAndThrowInvalidConentError(n);let h;if((0,v.isString)(p.relativeLocation)&&p.relativeLocation)h=this.resolveExtensionLocation(p.relativeLocation);else if((0,v.isString)(p.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${p.location}`);continue}else{h=R.URI.revive(p.location);const y=this.toRelativePath(h);y&&(C=!0,p.relativeLocation=y)}(0,v.isUndefined)(p.metadata?.hasPreReleaseVersion)&&p.metadata?.preRelease&&(C=!0,p.metadata.hasPreReleaseVersion=!0),r.push({identifier:p.identifier,location:h,version:p.version,metadata:p.metadata})}C&&await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(a)))}if(s){r=s(r);const C=r.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),relativeLocation:this.toRelativePath(p.location),metadata:p.metadata}));await this.fileService.writeFile(n,O.VSBuffer.fromString(JSON.stringify(C)))}return r})}reportAndThrowInvalidConentError(n){const s=new g(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let t;try{t=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,P.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(C=>w(C))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(s)}catch(a){(0,P.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let s=this.resourcesAccessQueueMap.get(n);return s||(s=new L.Queue,this.resourcesAccessQueueMap.set(n,s)),s}};e.AbstractExtensionsProfileScannerService=l,e.AbstractExtensionsProfileScannerService=l=Ee([G(1,P.IFileService),G(2,u.IUserDataProfilesService),G(3,f.IUriIdentityService),G(4,c.ITelemetryService),G(5,S.ILogService)],l);function w(o){return(0,v.isObject)(o)&&(0,b.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,v.isString)(o.location)&&o.location)&&((0,v.isUndefined)(o.relativeLocation)||(0,v.isString)(o.relativeLocation))&&o.version&&(0,v.isString)(o.version)}function i(o){return o?(0,v.isString)(o.path)&&(0,v.isString)(o.scheme):!1}}),define(le[82],ue([0,1,17,6,30,14,7,34,138,2,23,16,5,20,55,89,12,10,157,15,33,45,71,11,4,8,24,3,66,52,18,28,185]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i,o,n,s,t,r,a,C,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var D;(function(Q){function V(Y,x){if(Y===x)return!0;const q=Object.keys(Y),te=new Set;for(const oe of Object.keys(x))te.add(oe);if(q.length!==te.size)return!1;for(const oe of q){if(Y[oe]!==x[oe])return!1;te.delete(oe)}return te.size===0}Q.equals=V})(D||(e.Translations=D={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let U=class extends m.Disposable{constructor(V,Y,x,q,te,oe,ee,ae,B,W,k,N){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Y,this.extensionsControlLocation=x,this.currentProfile=q,this.userDataProfilesService=te,this.extensionsProfileScannerService=oe,this.fileService=ee,this.logService=ae,this.environmentService=B,this.productService=W,this.uriIdentityService=k,this.instantiationService=N,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(z,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,Y,x){const[q,te]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Y)]),oe=x?await this.scanExtensionsUnderDevelopment(V,[...q,...te]):[];return this.dedupExtensions(q,te,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),Y.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[x,q]=await Promise.all(Y);return this.applyScanOptions([...x,...q],0,V,!1)}async scanUserExtensions(V){const Y=V.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const x=this.uriIdentityService.extUri.isEqual(V.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(Y,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,x),te=V.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let oe;try{oe=await te.scanExtensions(q)}catch(ee){if(ee instanceof C.ExtensionsProfileScanningError&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),oe=await te.scanExtensions(q);else throw ee}return oe=await this.applyScanOptions(oe,1,V,!0),this.logService.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(V,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===P.Schemas.file).map(async q=>{const te=await this.createExtensionScannerInput(q,!1,1,!0,V.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=Y.find(ae=>(0,l.areSameExtensions)(ae.identifier,ee.identifier))?.type??ee.type,this.extensionsScanner.validate(ee,te)))}))).flat();return this.applyScanOptions(x,"development",V,!0)}return[]}async scanExistingExtension(V,Y,x){const q=await this.createExtensionScannerInput(V,!1,Y,!0,x.language,!0,void 0),te=await this.extensionsScanner.scanExtension(q);return!te||!x.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(V,Y,x){const q=await this.createExtensionScannerInput(V,!1,Y,!0,x.language,!0,void 0),te=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(te,Y,x,!0)}async scanMetadata(V){const Y=(0,u.joinPath)(V,"package.json"),x=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(V,Y){const x=(0,u.joinPath)(V,"package.json"),q=(await this.fileService.readFile(x)).value.toString(),te=JSON.parse(q);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,te.__metadata={...te.__metadata,...Y},await this.fileService.writeFile((0,u.joinPath)(V,"package.json"),T.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof C.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw V}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.extensionsProfileScannerService.addExtensionsToProfile(V.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.logService.error(V)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(V,Y,x,q){return x.includeAllVersions||(V=this.dedupExtensions(Y===0?V:void 0,Y===1?V:void 0,Y==="development"?V:void 0,await this.getTargetPlatform(),q)),x.includeInvalid||(V=V.filter(te=>te.isValid)),V.sort((te,oe)=>{const ee=I.basename(te.location.fsPath),ae=I.basename(oe.location.fsPath);return ee<ae?-1:ee>ae?1:0})}dedupExtensions(V,Y,x,q,te){const oe=(ae,B,W)=>{if(ae.isValid&&!B.isValid)return!1;if(ae.isValid===B.isValid){if(te&&f.gt(ae.manifest.version,B.manifest.version))return this.logService.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(f.eq(ae.manifest.version,B.manifest.version)){if(ae.type===0)return this.logService.debug(`Skipping extension ${B.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===q)return this.logService.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${ae.location.path} with ${B.location.path}.`):this.logService.debug(`Overwriting user extension ${ae.location.path} with ${B.location.path}.`),!0},ee=new w.ExtensionIdentifierMap;return V?.forEach(ae=>{const B=ee.get(ae.identifier.id);(!B||oe(B,ae,!1))&&ee.set(ae.identifier.id,ae)}),Y?.forEach(ae=>{const B=ee.get(ae.identifier.id);if(!B&&V&&ae.type===0){this.logService.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!B||oe(B,ae,!1))&&ee.set(ae.identifier.id,ae)}),x?.forEach(ae=>{const B=ee.get(ae.identifier.id);(!B||oe(B,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async scanDefaultSystemExtensions(V,Y){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),te=await(V&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(V,Y){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=Y?await this.getBuiltInExtensionControl():{},te=[],oe=c.URI.file(I.normalize(I.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of x){const B=q[ae.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":te.push((0,u.joinPath)(oe,ae.name));break;default:te.push(c.URI.file(B));break}}const ee=await Promise.all(te.map(async ae=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ae,!1,0,!0,V,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",ee.length),(0,L.coalesce)(ee)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,Y,x,q,te,oe,ee){const ae=await this.getTranslations(te??S.language),B=await this.getMtime(V),W=Y&&!this.uriIdentityService.extUri.isEqual(V,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,k=W?await this.getMtime(W):void 0;return new M(V,B,W,k,Y,ee,x,q,oe,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,ae)}async getMtime(V){try{const Y=await this.fileService.stat(V);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.AbstractExtensionsScannerService=U,e.AbstractExtensionsScannerService=U=Ee([G(4,p.IUserDataProfilesService),G(5,C.IExtensionsProfileScannerService),G(6,o.IFileService),G(7,s.ILogService),G(8,g.IEnvironmentService),G(9,t.IProductService),G(10,h.IUriIdentityService),G(11,n.IInstantiationService)],U);class M{constructor(V,Y,x,q,te,oe,ee,ae,B,W,k,N,j,$,J){this.location=V,this.mtime=Y,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=q,this.profile=te,this.profileScanOptions=oe,this.type=ee,this.excludeObsolete=ae,this.validate=B,this.productVersion=W,this.productDate=k,this.productCommit=N,this.devMode=j,this.language=$,this.translations=J}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Y){return(0,u.isEqual)(V.location,Y.location)&&V.mtime===Y.mtime&&(0,u.isEqual)(V.applicationExtensionslocation,Y.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&V.profile===Y.profile&&A.equals(V.profileScanOptions,Y.profileScanOptions)&&V.type===Y.type&&V.excludeObsolete===Y.excludeObsolete&&V.validate===Y.validate&&V.productVersion===Y.productVersion&&V.productDate===Y.productDate&&V.productCommit===Y.productCommit&&V.devMode===Y.devMode&&V.language===Y.language&&D.equals(V.translations,Y.translations)}}e.ExtensionScannerInput=M;let F=class extends m.Disposable{constructor(V,Y,x,q,te){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=Y,this.uriIdentityService=x,this.fileService=q,this.logService=te}async scanExtensions(V){const Y=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let x={};if(V.excludeObsolete&&V.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(q)}catch{}return(0,E.isEmptyObject)(x)?Y:Y.filter(q=>!x[l.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(V){const Y=await this.fileService.resolve(V.location);if(!Y.children?.length)return[];const x=await Promise.all(Y.children.map(async q=>{if(!q.isDirectory||V.type===1&&(0,u.basename)(q.resource).indexOf(".")===0)return null;const te=new M(q.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te)}));return(0,L.coalesce)(x).sort((q,te)=>q.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(V){let Y=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){Y=Y.filter(q=>!q.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,V);Y.push(...x)}return Y}async scanExtensionsFromProfileResource(V,Y,x){const q=await this.extensionsProfileScannerService.scanProfileExtensions(V,x.profileScanOptions);if(!q.length)return[];const te=await Promise.all(q.map(async oe=>{if(Y(oe)){const ee=new M(oe.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ee,oe.metadata)}return null}));return(0,L.coalesce)(te)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,u.joinPath)(V.location,"package.json"))){const Y=await this.scanExtension(V);return Y?[Y]:[]}else return await this.scanExtensions(V)}catch(Y){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,_.getErrorMessage)(Y)),[]}}async scanExtension(V,Y){try{let x=await this.scanExtensionManifest(V.location);if(x){x.publisher||(x.publisher=w.UNDEFINED_PUBLISHER),Y=Y??x.__metadata,delete x.__metadata;const q=(0,l.getGalleryExtensionId)(x.publisher,x.name),te=Y?.id?{id:q,uuid:Y.id}:{id:q},oe=Y?.isSystem?0:V.type,ee=oe===0||!!Y?.isBuiltin;x=await this.translateManifest(V.location,x,M.createNlsConfiguration(V));const ae={type:oe,identifier:te,manifest:x,location:V.location,isBuiltin:ee,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return V.validate?this.validate(ae,V):ae}}catch(x){V.type!==0&&this.logService.error(x)}return null}validate(V,Y){let x=!0;const q=(0,i.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,V.manifest,V.isBuiltin);for(const[te,oe]of q)te===v.default.Error&&(x=!1,this.logService.error(this.formatMessage(Y.location,oe)));return V.isValid=x,V.validations=q,V}async scanExtensionManifest(V){const Y=(0,u.joinPath)(V,"package.json");let x;try{x=(await this.fileService.readFile(Y)).value.toString()}catch(te){return(0,o.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(V,(0,d.localize)(0,null,Y.path,te.message))),null}let q;try{q=JSON.parse(x)}catch{const oe=[];(0,R.parse)(x,oe);for(const ee of oe)this.logService.error(this.formatMessage(V,(0,d.localize)(1,null,Y.path,ee.offset,ee.length,(0,b.getParseErrorMessage)(ee.error))));return null}return(0,R.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(V,(0,d.localize)(2,null,Y.path))),null):q}async translateManifest(V,Y,x){const q=await this.getLocalizedMessages(V,Y,x);if(q)try{const te=[],oe=await this.resolveOriginalMessageBundle(q.default,te);if(te.length>0)return te.forEach(ae=>{this.logService.error(this.formatMessage(V,(0,d.localize)(3,null,q.default?.path,(0,b.getParseErrorMessage)(ae.error))))}),Y;if((0,R.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(V,(0,d.localize)(4,null,q.default?.path))),Y;const ee=q.values||Object.create(null);return(0,y.localizeManifest)(this.logService,Y,ee,oe)}catch{}return Y}async getLocalizedMessages(V,Y,x){const q=(0,u.joinPath)(V,"package.nls.json"),te=(B,W)=>{W.forEach(k=>{this.logService.error(this.formatMessage(V,(0,d.localize)(5,null,B?.path,(0,b.getParseErrorMessage)(k.error))))})},oe=B=>{this.logService.error(this.formatMessage(V,(0,d.localize)(6,null,B?.path)))},ee=`${Y.publisher}.${Y.name}`,ae=x.translations[ee];if(ae)try{const B=c.URI.file(ae),W=(await this.fileService.readFile(B)).value.toString(),k=[],N=(0,R.parse)(W,k);return k.length>0?(te(B,k),{values:void 0,default:q}):(0,R.getNodeType)(N)!=="object"?(oe(B),{values:void 0,default:q}):{values:N.contents?N.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let W;try{W=await this.findMessageBundles(V,x)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const k=(await this.fileService.readFile(W.localized)).value.toString(),N=[],j=(0,R.parse)(k,N);return N.length>0?(te(W.localized,N),{values:void 0,default:W.original}):(0,R.getNodeType)(j)!=="object"?(oe(W.localized),{values:void 0,default:W.original}):{values:j,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(V,Y){if(V)try{const x=(await this.fileService.readFile(V)).value.toString();return(0,R.parse)(x,Y)}catch{}}findMessageBundles(V,Y){return new Promise((x,q)=>{const te=oe=>{const ee=(0,u.joinPath)(V,`package.nls.${oe}.json`);this.fileService.exists(ee).then(ae=>{ae&&x({localized:ee,original:(0,u.joinPath)(V,"package.nls.json")});const B=oe.lastIndexOf("-");B===-1?x({localized:(0,u.joinPath)(V,"package.nls.json"),original:null}):(oe=oe.substring(0,B),te(oe))})};if(Y.devMode||Y.pseudo||!Y.language)return x({localized:(0,u.joinPath)(V,"package.nls.json"),original:null});te(Y.language)})}formatMessage(V,Y){return`[${V.path}]: ${Y}`}};F=Ee([G(1,C.IExtensionsProfileScannerService),G(2,h.IUriIdentityService),G(3,o.IFileService),G(4,s.ILogService)],F);let z=class extends F{constructor(V,Y,x,q,te,oe,ee){super(Y,q,te,oe,ee),this.currentProfile=V,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const Y=this.getCacheFile(V),x=await this.readExtensionCache(Y);if(this.input=V,x&&x.input&&M.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",V.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(te=>(te.location=c.URI.revive(te.location),te));const q=await super.scanExtensions(V);return await this.writeExtensionCache(Y,{input:V,result:q}),q}async readExtensionCache(V){try{const Y=await this.fileService.readFile(V),x=JSON.parse(Y.value.toString());return{result:x.result,input:(0,a.revive)(x.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",V.path,(0,_.getErrorMessage)(Y))}return null}async writeExtensionCache(V,Y){try{await this.fileService.writeFile(V,T.VSBuffer.fromString(JSON.stringify(Y)))}catch(x){this.logService.debug("Error while writing the extension cache file:",V.path,(0,_.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const V=this.getCacheFile(this.input),Y=await this.readExtensionCache(V);if(!Y)return;const x=Y.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!A.equals(q,x))try{this.logService.info("Invalidating Cache",x,q),await this.fileService.del(V),this._onDidChangeCache.fire()}catch(te){this.logService.error(te)}}getCacheFile(V){const Y=this.getProfile(V);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,V.type===0?w.BUILTIN_MANIFEST_CACHE_FILE:w.USER_MANIFEST_CACHE_FILE)}getProfile(V){return V.type===0?this.userDataProfilesService.defaultProfile:V.profile?this.uriIdentityService.extUri.isEqual(V.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(V.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};z=Ee([G(2,p.IUserDataProfilesService),G(3,C.IExtensionsProfileScannerService),G(4,h.IUriIdentityService),G(5,o.IFileService),G(6,s.ILogService)],z);function X(Q,V){const Y=(0,l.getExtensionId)(Q.manifest.publisher,Q.manifest.name);return{id:Y,identifier:new w.ExtensionIdentifier(Y),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:V,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.toExtensionDescription=X;class K extends U{constructor(V,Y,x,q,te,oe,ee,ae,B,W,k,N){super(V,Y,(0,u.joinPath)(x,".vscode-oss-dev","extensions","control.json"),q,te,oe,ee,ae,B,W,k,N),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const j=await this.fileService.readFile(c.URI.file(S.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=K}),define(le[247],ue([0,1,67,6,38,3,2,23,16,31,8,18]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends _.Disposable{constructor(f,v){super(),this.userDataProfilesService=f,this.logService=v,this.processesLimiter=new O.Limiter(5)}async postUninstall(f){const v=this.parseScript(f,"uninstall");v&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(v.script,"uninstall",v.args,!0,f),this.logService.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(E){this.logService.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.logService.error(E)}}));try{await m.Promises.rm(this.getExtensionStoragePath(f))}catch(E){this.logService.error("Error while removing extension storage path",f.identifier.id),this.logService.error(E)}}parseScript(f,v){const E=`vscode:${v}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[E]=="string"){const c=f.manifest.scripts[E].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${E} should be a node script`),null):{script:(0,b.join)(f.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}runLifecycleHook(f,v,E,c,d){return new Promise((g,l)=>{const w=this.start(f,v,E,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?l(n):g(void 0)};w.on("error",n=>{o((0,A.toErrorMessage)(n)||"Unknown")}),w.on("exit",(n,s)=>{o(n?`post-${v} process exited with code ${n}`:void 0)}),c&&(i=setTimeout(()=>{i=null,w.kill(),l("timed out")},5e3))})}start(f,v,E,c){const d={silent:!0,execArgv:void 0},g=(0,L.fork)(f,[`--type=extension-post-${v}`,...E],d);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const l=T.Event.fromNodeEventEmitter(g.stdout,"data"),w=T.Event.fromNodeEventEmitter(g.stderr,"data");l(n=>this.logService.info(c.identifier.id,c.manifest.version,`post-${v}`,n)),w(n=>this.logService.error(c.identifier.id,c.manifest.version,`post-${v}`,n));const i=T.Event.any(T.Event.map(l,n=>({data:`%c${n}`,format:[""]})),T.Event.map(w,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(c.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,b.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=S,e.ExtensionsLifecycle=S=Ee([G(0,I.IUserDataProfilesService),G(1,P.ILogService)],S)}),define(le[113],ue([0,1,6,14,26,38,7,3,54,2,35,23,16,20,55,12,10,32,31,70,158,96,15,246,29,33,52,82,227,247,186,216,228,71,11,4,8,24,22,28,18]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i,o,n,s,t,r,a,C,p,h,y,D,U,M,F,z,X,K,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(n.IExtensionManagementService);const V=".vsctmp";let Y=class extends o.AbstractExtensionManagementService{constructor(B,W,k,N,j,$,J,Z,ie,H,ne,ce){super(B,W,ne,k,H,ce),this.extensionsScannerService=j,this.extensionsProfileScannerService=$,this.downloadService=J,this.fileService=ie,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new P.ResourceSet;const de=this._register(Z.createInstance(C.ExtensionsLifecycle));this.extensionsScanner=this._register(Z.createInstance(x,Se=>de.postUninstall(Se))),this.manifestCache=this._register(new h.ExtensionsManifestCache(ce,ie,ne,this,this.logService)),this.extensionsDownloader=this._register(Z.createInstance(a.ExtensionsDownloader));const fe=this._register(new y.ExtensionsWatcher(this,this.extensionsScannerService,ce,$,ne,ie,k));this._register(fe.onDidChangeExtensionsByAnotherSource(Se=>this.onDidChangeExtensionsFromAnotherSource(Se))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const W=await this.collectFiles(B),k=await(0,g.zip)((0,u.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)()).fsPath,W);return E.URI.file(k)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:W,cleanup:k}=await this.downloadVsix(B),N=S.resolve(W.fsPath);try{return await(0,p.getManifest)(N)}finally{await k()}}getInstalled(B,W=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(B??null,W)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.extensionsScanner.scanUserExtensionAtLocation(B)}async install(B,W={}){this.logService.trace("ExtensionManagementService#install",B.toString());const{location:k,cleanup:N}=await this.downloadVsix(B);try{const j=await(0,p.getManifest)(S.resolve(k.fsPath)),$=(0,s.getGalleryExtensionId)(j.publisher,j.name);if(j.engines&&j.engines.vscode&&!(0,D.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(l.localize(0,null,$,this.productService.version));const Z=(await this.installExtensions([{manifest:j,extension:k,options:W}])).find(({identifier:ie})=>(0,s.areSameExtensions)(ie,{id:$}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${$}`))}finally{await N()}}async installFromLocation(B,W){this.logService.trace("ExtensionManagementService#installFromLocation",B.toString());const k=await this.extensionsScanner.scanUserExtensionAtLocation(B);if(!k||!k.manifest.name||!k.manifest.version)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.addExtensionsToProfile([[k,void 0]],W),this.logService.info("Successfully installed extension",k.identifier.id,W.toString()),k}async installExtensionsFromProfile(B,W,k){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",B,W.toString(),k.toString());const N=(await this.extensionsScanner.scanExtensions(1,W)).filter(j=>B.some($=>(0,s.areSameExtensions)($,j.identifier)));if(N.length){const j=await Promise.all(N.map($=>this.extensionsScanner.scanMetadata($,W)));await this.addExtensionsToProfile(N.map(($,J)=>[$,j[J]]),k),this.logService.info("Successfully installed extensions",N.map($=>$.identifier.id),k.toString())}return N}async updateMetadata(B,W,k=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),B=await this.extensionsScanner.updateMetadata(B,W,k),this.manifestCache.invalidate(k),this._onDidUpdateExtensionMetadata.fire(B),B}async reinstallFromGallery(B){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.galleryService.isEnabled())throw new Error(l.localize(1,null));const W=await this.getTargetPlatform(),[k]=await this.galleryService.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:W,compatible:!0},A.CancellationToken.None);if(!k)throw new Error(l.localize(2,null));await this.extensionsScanner.setUninstalled(B);try{await this.extensionsScanner.removeUninstalledExtension(B)}catch(N){throw new Error(l.localize(3,null,(0,T.toErrorMessage)(N)))}return this.installFromGallery(k)}copyExtension(B,W,k,N){return this.extensionsScanner.copyExtension(B,W,k,N)}copyExtensions(B,W){return this.extensionsScanner.copyExtensions(B,W)}markAsUninstalled(...B){return this.extensionsScanner.setUninstalled(...B)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(B){this.logService.error(B)}}async download(B,W,k){const{location:N}=await this.extensionsDownloader.download(B,W,!k);return N}async downloadVsix(B){if(B.scheme===I.Schemas.file)return{location:B,async cleanup(){}};this.logService.trace("Downloading extension from",B.toString());const W=(0,u.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)());return await this.downloadService.download(B,W),this.logService.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.fileService.del(W)}catch(N){this.logService.error(N)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(B,W,k){if(E.URI.isUri(W))return new oe(B,W,k,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const N=s.ExtensionKey.create(W).toString();let j=this.installGalleryExtensionsTasks.get(N);return j||(this.installGalleryExtensionsTasks.set(N,j=new te(B,W,k,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),j.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(N))),j}createUninstallExtensionTask(B,W){return new ee(B,W.profileLocation,this.extensionsProfileScannerService)}async collectFiles(B){const W=async N=>{let j=await d.Promises.readdir(N);j=j.map(Z=>S.join(N,Z));const $=await Promise.all(j.map(Z=>d.Promises.stat(Z)));let J=Promise.resolve([]);return $.forEach((Z,ie)=>{const H=j[ie];Z.isFile()&&(J=J.then(ne=>[...ne,H])),Z.isDirectory()&&(J=J.then(ne=>W(H).then(ce=>[...ne,...ce])))}),J};return(await W(B.location.fsPath)).map(N=>({path:`extension/${S.relative(B.location.fsPath,N)}`,localPath:N}))}async onDidChangeExtensionsFromAnotherSource({added:B,removed:W}){if(W){const k=B&&this.uriIdentityService.extUri.isEqual(W.profileLocation,B.profileLocation)?W.extensions.filter(N=>B.extensions.every(j=>!(0,s.areSameExtensions)(j,N))):W.extensions;for(const N of k)this.logService.info("Extensions removed from another source",N.id,W.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:N,profileLocation:W.profileLocation})}if(B){const N=(await this.extensionsScanner.scanExtensions(1,B.profileLocation)).filter(j=>B.extensions.some($=>(0,s.areSameExtensions)($,j.identifier)));this._onDidInstallExtensions.fire(N.map(j=>(this.logService.info("Extensions added from another source",j.identifier.id,B.profileLocation.toString()),{identifier:j.identifier,local:j,profileLocation:B.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(W=>this.knownDirectories.add(W)));const B=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const W of B.children??[])W.isDirectory&&this.knownDirectories.add(W.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(W=>this.onDidFilesChange(W)))}async onDidFilesChange(B){if(!B.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const W=[];for(const k of B.rawAdded){if(this.knownDirectories.has(k)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(k),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(k,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(k).startsWith(".")||!(await this.fileService.stat(k)).isDirectory)continue;const N=await this.extensionsScanner.scanUserExtensionAtLocation(k);N&&N.installedTimestamp===void 0&&(this.knownDirectories.add(k),W.push(N))}W.length&&(await this.addExtensionsToProfile(W.map(k=>[k,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",W.map(k=>k.identifier.id)))}async addExtensionsToProfile(B,W){const k=B.map(N=>N[0]);await this.setInstalled(k),await this.extensionsProfileScannerService.addExtensionsToProfile(B,W),this._onDidInstallExtensions.fire(k.map(N=>({local:N,identifier:N.identifier,operation:1,profileLocation:W})))}async setInstalled(B){const W=await this.extensionsScanner.getUninstalledExtensions();for(const k of B){const N=s.ExtensionKey.create(k);W[N.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",N.id),await this.extensionsScanner.setInstalled(N),this.logService.info("Removed the extension from uninstalled list:",N.id))}}};e.ExtensionManagementService=Y,e.ExtensionManagementService=Y=Ee([G(0,n.IExtensionGalleryService),G(1,X.ITelemetryService),G(2,F.ILogService),G(3,i.INativeEnvironmentService),G(4,r.IExtensionsScannerService),G(5,t.IExtensionsProfileScannerService),G(6,w.IDownloadService),G(7,M.IInstantiationService),G(8,U.IFileService),G(9,z.IProductService),G(10,K.IUriIdentityService),G(11,Q.IUserDataProfilesService)],Y);let x=class extends m.Disposable{constructor(B,W,k,N,j,$){super(),this.beforeRemovingExtension=B,this.fileService=W,this.extensionsScannerService=k,this.extensionsProfileScannerService=N,this.uriIdentityService=j,this.logService=$,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,u.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(B,W){const k={includeInvalid:!0,profileLocation:W};let N=[];return B===null||B===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},k,!1)):B===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(k)),N=B!==null?N.filter(j=>j.type===B):N,Promise.all(N.map(j=>this.toLocalExtension(j)))}async scanAllUserExtensions(B){const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(W.map(k=>this.toLocalExtension(k)))}async scanUserExtensionAtLocation(B){try{const W=await this.extensionsScannerService.scanExistingExtension(B,1,{includeInvalid:!0});if(W)return await this.toLocalExtension(W)}catch(W){this.logService.error(W)}return null}async extractUserExtension(B,W,k,N,j){const $=B.toString(),J=E.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,c.generateUuid)()}`)),Z=E.URI.file(S.join(this.extensionsScannerService.userExtensionsLocation.fsPath,$));let ie=await this.fileService.exists(Z);if(ie&&N){try{await this.deleteExtensionFromLocation(B.id,Z,"removeExisting")}catch{throw new n.ExtensionManagementError(l.localize(4,null,Z.fsPath,B.id),n.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.extensionsScannerService.updateMetadata(Z,k);else try{try{this.logService.trace(`Started extracting the extension from ${W} to ${Z.fsPath}`),await(0,g.extract)(W,J.fsPath,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${Z}:`,B.id)}catch(H){let ne=n.ExtensionManagementErrorCode.Extract;throw H instanceof g.ExtractError&&(H.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(H.message,ne)}await this.extensionsScannerService.updateMetadata(J,k);try{this.logService.trace(`Started renaming the extension from ${J.fsPath} to ${Z.fsPath}`),await this.rename(J.fsPath,Z.fsPath),this.logService.info("Renamed to",Z.fsPath)}catch(H){if(H.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(H)}. Deleted from extracted location`,J),H}this._onExtract.fire(Z)}catch(H){try{await this.fileService.del(J,{recursive:!0})}catch{}throw H}return this.scanLocalExtension(Z,1)}async scanMetadata(B,W){return W?(await this.getScannedExtension(B,W))?.metadata:this.extensionsScannerService.scanMetadata(B.location)}async getScannedExtension(B,W){return(await this.extensionsProfileScannerService.scanProfileExtensions(W)).find(N=>(0,s.areSameExtensions)(N.identifier,B.identifier))}async updateMetadata(B,W,k){return k?await this.extensionsProfileScannerService.updateMetadata([[B,W]],k):await this.extensionsScannerService.updateMetadata(B.location,W),this.scanLocalExtension(B.location,B.type,k)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...B){const W=B.map(k=>s.ExtensionKey.create(k));await this.withUninstalledExtensions(k=>W.forEach(N=>{k[N.toString()]=!0,this.logService.info("Marked extension as uninstalled",N.toString())}))}async setInstalled(B){await this.withUninstalledExtensions(W=>delete W[B.toString()])}async removeExtension(B,W){if(this.uriIdentityService.extUri.isEqualOrParent(B.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(B.identifier.id,B.location,W)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.withUninstalledExtensions(W=>delete W[s.ExtensionKey.create(B).toString()])}async copyExtension(B,W,k,N){const j=await this.getScannedExtension(B,W),$=await this.getScannedExtension(B,k);if(N={...j?.metadata,...N},$)if(this.uriIdentityService.extUri.isEqual($.location,B.location))await this.extensionsProfileScannerService.updateMetadata([[B,{...$.metadata,...N}]],k);else{const J=await this.scanLocalExtension($.location,B.type,k);await this.extensionsProfileScannerService.removeExtensionFromProfile(J,k),await this.extensionsProfileScannerService.addExtensionsToProfile([[B,{...$.metadata,...N}]],k)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[B,N]],k);return this.scanLocalExtension(B.location,B.type,k)}async copyExtensions(B,W){const k=await this.scanExtensions(1,B),N=await Promise.all(k.filter(j=>!j.isApplicationScoped).map(async j=>[j,await this.scanMetadata(j,B)]));await this.extensionsProfileScannerService.addExtensionsToProfile(N,W)}async deleteExtensionFromLocation(B,W,k){this.logService.trace(`Deleting ${k} extension from disk`,B,W.fsPath);const N=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(W),`${this.uriIdentityService.extUri.basename(W)}.${(0,b.hash)((0,c.generateUuid)()).toString(16)}${V}`);await this.rename(W.fsPath,N.fsPath),await this.fileService.del(N,{recursive:!0}),this.logService.info(`Deleted ${k} extension from disk`,B,W.fsPath)}async withUninstalledExtensions(B){return this.uninstalledFileLimiter.queue(async()=>{let W;try{W=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(N){if((0,U.toFileOperationResult)(N)!==1)throw N}let k={};if(W)try{k=JSON.parse(W)}catch{}return B&&(B(k),Object.keys(k).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(k))):await this.fileService.del(this.uninstalledResource)),k})}async rename(B,W){try{await d.Promises.rename(B,W,2*60*1e3)}catch(k){throw new n.ExtensionManagementError(k.message||l.localize(5,null,B,W),k.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(B,W,k){if(k){const j=(await this.extensionsScannerService.scanUserExtensions({profileLocation:k})).find($=>this.uriIdentityService.extUri.isEqual($.location,B));if(j)return this.toLocalExtension(j)}else{const N=await this.extensionsScannerService.scanExistingExtension(B,W,{includeInvalid:!0});if(N)return this.toLocalExtension(N)}throw new Error(l.localize(6,null,B.path))}async toLocalExtension(B){const W=await this.fileService.resolve(B.location);let k,N;return W.children&&(k=W.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,N=W.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:k,changelogUrl:N,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!B.metadata?.hasPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async removeUninstalledExtensions(){const B=await this.getUninstalledExtensions();if(Object.keys(B).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(B));const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const j of W)B[s.ExtensionKey.create(j).toString()]||k.add(j.identifier.id.toLowerCase());try{const j=(0,s.groupByExtension)(W,$=>$.identifier);await L.Promises.settled(j.map(async $=>{const J=$.sort((Z,ie)=>f.rcompare(Z.manifest.version,ie.manifest.version))[0];k.has(J.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(J))}))}catch(j){this.logService.error(j)}const N=W.filter(j=>j.metadata&&B[s.ExtensionKey.create(j).toString()]);await Promise.allSettled(N.map(j=>this.removeUninstalledExtension(j)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let B;try{B=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(W){(0,U.toFileOperationResult)(W)!==1&&this.logService.error(W);return}if(B?.children)try{await Promise.allSettled(B.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(V))){this.logService.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.fileService.del(W.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(k){(0,U.toFileOperationResult)(k)!==1&&this.logService.error(k)}}}))}catch{}}};e.ExtensionsScanner=x,e.ExtensionsScanner=x=Ee([G(1,U.IFileService),G(2,r.IExtensionsScannerService),G(3,t.IExtensionsProfileScannerService),G(4,K.IUriIdentityService),G(5,F.ILogService)],x);class q extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,v.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(B,W,k,N,j,$,J,Z,ie){super(),this.identifier=B,this.source=W,this.options=k,this.extensionsScanner=N,this.uriIdentityService=j,this.userDataProfilesService=$,this.extensionsScannerService=J,this.extensionsProfileScannerService=Z,this.logService=ie,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(B){const[W,k]=await this.install(B);return this._profileLocation=W.isBuiltin||W.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[W,k]],this._profileLocation),W}async extractExtension({zipPath:B,key:W,metadata:k},N,j){let $=await this.unsetIfUninstalled(W);return $?$=await this.extensionsScanner.updateMetadata($,k):(this.logService.trace("Extracting extension...",W.id),$=await this.extensionsScanner.extractUserExtension(W,B,k,N,j),this.logService.info("Extracting extension completed.",W.id)),$}async unsetIfUninstalled(B){return await this.isUninstalled(B)?(this.logService.trace("Removing the extension from uninstalled list:",B.id),await this.extensionsScanner.setInstalled(B),this.logService.info("Removed the extension from uninstalled list:",B.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(N=>s.ExtensionKey.create(N).equals(B))):void 0}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}}class te extends q{constructor(B,W,k,N,j,$,J,Z,ie,H){super(W.identifier,W,k,j,$,J,Z,ie,H),this.gallery=W,this.extensionsDownloader=N}async install(B){let W;try{W=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)}catch(J){throw new n.ExtensionManagementError(J,n.ExtensionManagementErrorCode.Scanning)}const k=W.find(J=>(0,s.areSameExtensions)(J.identifier,this.gallery.identifier));k&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:k?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??k?.pinned,preRelease:(0,v.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||k?.preRelease};if(k?.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(k,N),N]}catch(J){throw new n.ExtensionManagementError((0,_.getErrorMessage)(J),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:j,verificationStatus:$}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=$,this.validateManifest(j.fsPath),[await this.extractExtension({zipPath:j.fsPath,key:s.ExtensionKey.create(this.gallery),metadata:N},!1,B),N]}catch(J){try{await this.extensionsDownloader.delete(j)}catch(Z){this.logService.warn("Error while deleting the downloaded file",j.toString(),(0,_.getErrorMessage)(Z))}throw J}}async validateManifest(B){try{await(0,p.getManifest)(B)}catch(W){throw new n.ExtensionManagementError((0,o.joinErrors)(W).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=te;class oe extends q{constructor(B,W,k,N,j,$,J,Z,ie,H){super({id:(0,s.getGalleryExtensionId)(B.publisher,B.name)},W,k,j,$,J,Z,ie,H),this.manifest=B,this.location=W,this.galleryService=N}async doRun(B){const W=await super.doRun(B);return this.updateMetadata(W,B),W}async install(B){const W=new s.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(J=>(0,s.areSameExtensions)(this.identifier,J.identifier)),j={isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??N?.pinned};if(N)if(this._operation=3,W.equals(new s.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(l.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&f.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const J=await this.unsetIfUninstalled(W);if(J)try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(l.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:S.resolve(this.location.fsPath),key:W,metadata:j},!0,B),j]}async updateMetadata(B,W){try{let[k]=await this.galleryService.getExtensions([{id:B.identifier.id,version:B.manifest.version}],W);if(k||([k]=await this.galleryService.getExtensions([{id:B.identifier.id}],W)),k){const N={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,hasPreReleaseVersion:B.hasPreReleaseVersion||k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(B,N,this.options.profileLocation)}}catch{}}}class ee extends o.AbstractExtensionTask{constructor(B,W,k){super(),this.extension=B,this.profileLocation=W,this.extensionsProfileScannerService=k}async doRun(B){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(le[248],ue([0,1,8,18,28,22,52,11,15,10]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends _.AbstractExtensionsProfileScannerService{constructor(S,u,f,v,E,c){super(m.URI.file(S.extensionsPath),u,f,v,E,c)}};e.ExtensionsProfileScannerService=P,e.ExtensionsProfileScannerService=P=Ee([G(0,b.INativeEnvironmentService),G(1,R.IFileService),G(2,O.IUserDataProfilesService),G(3,A.IUriIdentityService),G(4,T.ITelemetryService),G(5,L.ILogService)],P)}),define(le[249],ue([0,1,10,15,52,82,11,4,8,24,28,18]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let S=class extends T.NativeExtensionsScannerService{constructor(f,v,E,c,d,g,l,w){super(L.URI.file(d.builtinExtensionsPath),L.URI.file(d.extensionsPath),d.userHome,f.defaultProfile,f,v,E,c,d,g,l,w)}};e.ExtensionsScannerService=S,e.ExtensionsScannerService=S=Ee([G(0,I.IUserDataProfilesService),G(1,A.IExtensionsProfileScannerService),G(2,_.IFileService),G(3,b.ILogService),G(4,O.INativeEnvironmentService),G(5,m.IProductService),G(6,P.IUriIdentityService),G(7,R.IInstantiationService)],S)}),define(le[19],ue([0,1,6,3,2,100,12,69,4,18]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var S;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(S||(e.StorageTarget=S={}));function u(d){const g=d.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=u;class f extends A.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(g,l,w){return O.Event.filter(this._onDidChangeValue.event,i=>i.scope===g&&(l===void 0||i.key===l),w)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,l){const{key:w,external:i}=l;if(w===e.TARGET_KEY){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:w,target:this.getKeyTargets(g)[w],external:i})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,l,w){return this.getStorage(l)?.get(g,w)}getBoolean(g,l,w){return this.getStorage(l)?.getBoolean(g,w)}getNumber(g,l,w){return this.getStorage(l)?.getNumber(g,w)}getObject(g,l,w){return this.getStorage(l)?.getObject(g,w)}storeAll(g,l){this.withPausedEmitters(()=>{for(const w of g)this.store(w.key,w.value,w.scope,w.target,l)})}store(g,l,w,i,o=!1){if((0,_.isUndefinedOrNull)(l)){this.remove(g,w,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,i),this.getStorage(w)?.set(g,l,o)})}remove(g,l,w=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(g,l,void 0),this.getStorage(l)?.delete(g,w)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,l){const w=[],i=this.getKeyTargets(g);for(const o of Object.keys(i))i[o]===l&&w.push(o);return w}updateKeyTarget(g,l,w,i=!1){const o=this.getKeyTargets(l);typeof w=="number"?o[g]!==w&&(o[g]=w,this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(o),i)):typeof o[g]=="number"&&(delete o[g],this.getStorage(l)?.set(e.TARGET_KEY,JSON.stringify(o),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const l=this.getStorage(g);return l?u(l):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this._onWillSaveState.fire({reason:g});const l=this.getStorage(-1),w=this.getStorage(0),i=this.getStorage(1);switch(g){case P.NONE:await L.Promises.settled([l?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([l?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return c(g,l,w,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(g){return await this.flush(),this.getStorage(g)?.optimize()}async switch(g,l){return this.emitWillSaveState(P.NONE),(0,m.isUserDataProfile)(g)?this.switchToProfile(g,l):this.switchToWorkspace(g,l)}canSwitchProfile(g,l){return!(g.id===l.id||v(l)&&v(g))}switchData(g,l,w){this.withPausedEmitters(()=>{const i=new Set;for(const[o,n]of g)i.add(o),l.get(o)!==n&&this.emitDidChangeValue(w,{key:o,external:!0});for(const[o]of l.items)i.has(o)||this.emitDidChangeValue(w,{key:o,external:!0})})}}e.AbstractStorageService=f;function v(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=v;class E extends f{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(g){return!1}}e.InMemoryStorageService=E;async function c(d,g,l,w,i,o){const n=D=>{try{return JSON.parse(D)}catch{return D}},s=new Map,t=new Map;d.forEach((D,U)=>{s.set(U,D),t.set(U,n(D))});const r=new Map,a=new Map;g.forEach((D,U)=>{r.set(U,D),a.set(U,n(D))});const C=new Map,p=new Map;l.forEach((D,U)=>{C.set(U,D),p.set(U,n(D))}),console.group(w!==i?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const h=[];if(s.forEach((D,U)=>{h.push({key:U,value:D})}),console.table(h),console.groupEnd(),console.log(t),w!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const D=[];r.forEach((U,M)=>{D.push({key:M,value:U})}),console.table(D),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const y=[];C.forEach((D,U)=>{y.push({key:U,value:D})}),console.table(y),console.groupEnd(),console.log(p)}e.logStorage=c}),define(le[114],ue([0,1,3,2,12,29,33,19]),function(se,e,L,O,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends O.Disposable{constructor(I,S){super(),this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new m(I)),this._register(this.storageManger.onDidChange(u=>this._onDidChangeEnablement.fire({extensions:u,source:"storage"}))),this._register(S.onDidInstallExtensions(u=>u.forEach(({local:f,operation:v})=>{f&&v===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(I,S){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:S}),!0):!1}async disableExtension(I,S){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){const S=this.getDisabledExtensions();return S.every(u=>!(0,_.areSameExtensions)(u,I))?(S.push(I),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(I){const S=this.getDisabledExtensions();for(let u=0;u<S.length;u++){const f=S[u];if((0,_.areSameExtensions)(f,I))return S.splice(u,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(I){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,S){this.storageManger.set(I,S,0)}};e.GlobalExtensionEnablementService=b,e.GlobalExtensionEnablementService=b=Ee([G(0,R.IStorageService),G(1,T.IExtensionManagementService)],b);class m extends O.Disposable{constructor(I){super(),this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(0,void 0,this._register(new O.DisposableStore))(S=>this.onDidStorageChange(S)))}get(I,S){let u;return S===0?((0,A.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,S)),u=this.storage[I]):u=this._get(I,S),JSON.parse(u)}set(I,S,u){const f=JSON.stringify(S.map(({id:E,uuid:c})=>({id:E,uuid:c})));this._get(I,u)!==f&&(u===0&&(S.length?this.storage[I]=f:delete this.storage[I]),this._set(I,S.length?f:void 0,u))}onDidStorageChange(I){if(!(0,A.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const u=this.get(I.key,I.scope);delete this.storage[I.key];const f=this.get(I.key,I.scope),v=u.filter(c=>!f.some(d=>(0,_.areSameExtensions)(c,d))),E=f.filter(c=>!u.some(d=>(0,_.areSameExtensions)(d,c)));(v.length||E.length)&&this._onDidChange.fire([...v,...E])}}_get(I,S){return this.storageService.get(I,S,"[]")}_set(I,S,u){S?this.storageService.store(I,S,u,1):this.storageService.remove(I,u)}}e.StorageManager=m}),define(le[250],ue([0,1,17,26,7,5,36,12,10,21,15,29,33,71,11,8,24,59,229,19,22,63]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=T.isWeb?"web":(0,I.getTargetPlatform)(T.platform,_.arch),o="X-Market-Search-Activity-Id";var n;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...N){return String(N.reduce((j,$)=>j|$,0))}var t;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class h{constructor(j=p){this.state=j}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(j,$=this.state.pageSize){return new h({...this.state,pageNumber:j,pageSize:$})}withFilter(j,...$){const J=[...this.state.criteria,...$.length?$.map(Z=>({filterType:j,value:Z})):[{filterType:j}]];return new h({...this.state,criteria:J})}withSortBy(j){return new h({...this.state,sortBy:j})}withSortOrder(j){return new h({...this.state,sortOrder:j})}withFlags(...j){return new h({...this.state,flags:j.reduce(($,J)=>$|J,0)})}withAssetTypes(...j){return new h({...this.state,assetTypes:j})}withSource(j){return new h({...this.state,source:j})}get raw(){const{criteria:j,pageNumber:$,pageSize:J,sortBy:Z,sortOrder:ie,flags:H,assetTypes:ne}=this.state;return{filters:[{criteria:j,pageNumber:$,pageSize:J,sortBy:Z,sortOrder:ie}],assetTypes:ne,flags:H}}get searchText(){const j=this.state.criteria.filter($=>$.filterType===t.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(j=>String(j.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function y(N,j){const $=(N||[]).filter(J=>J.statisticName===j)[0];return $?$.value:0}function D(N){const j="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(J=>J.assetType.indexOf(j)===0).reduce((J,Z)=>{const ie=F(N,Z.assetType);return ie&&J.push([Z.assetType.substring(j.length),ie]),J},[])}function U(N){if(N.properties){const j=N.properties.filter(Z=>Z.key===r.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=j.filter(Z=>$.test(Z.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return F(N,r.Repository)}function M(N){return{uri:`${N.fallbackAssetUri}/${r.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${r.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function F(N,j){return N.files.filter(J=>J.assetType===j)[0]?{uri:`${N.assetUri}/${j}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${j}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function z(N,j){const $=N.properties?N.properties.filter(Z=>Z.key===j):[],J=$.length>0&&$[0].value;return J?J.split(",").map(Z=>(0,S.adoptToGalleryExtensionId)(Z)):[]}function X(N){const j=N.properties?N.properties.filter($=>$.key===a.Engine):[];return j.length>0&&j[0].value||""}function K(N){const j=N.properties?N.properties.filter($=>$.key===a.PreRelease):[];return j.length>0&&j[0].value==="true"}function Q(N){const j=N.properties?N.properties.filter(J=>J.key===a.LocalizedLanguages):[],$=j.length>0&&j[0].value||"";return $?$.split(","):[]}function V(N){return N.properties?.find(j=>j.key===a.SponsorLink)?.value}function Y(N){return N.properties?.find(j=>j.key===a.SupportLink)?.value}function x(N){return N.indexOf("preview")!==-1}function q(N){return N.targetPlatform?(0,I.toTargetPlatform)(N.targetPlatform):"undefined"}function te(N){const j=(0,L.distinct)(N.versions.map(q)),$=!!N.tags?.includes(I.WEB_EXTENSION_TAG),J=j.indexOf("web");return $?J===-1&&j.push("web"):J!==-1&&j.splice(J,1),j}function oe(N,j){for(let $=0;$<N.length;$++){const J=N[$];if(J.version===N[$-1]?.version){let Z=$;if(q(J)===j)for(;Z>0&&N[Z-1].version===J.version;)Z--;Z!==$&&(N.splice($,1),N.splice(Z,0,J))}}return N}e.sortExtensionVersions=oe;function ee(N,j,$){N.telemetryData={index:j,querySource:$,queryActivityId:N.queryContext?.[o]}}function ae(N,j,$,J){const Z=N.versions[0],ie={manifest:F(j,r.Manifest),readme:F(j,r.Details),changelog:F(j,r.Changelog),license:F(j,r.License),repository:U(j),download:M(j),icon:F(j,r.Icon),signature:F(j,r.Signature),coreTranslations:D(j)};return{identifier:{id:(0,S.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:j.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(Z),description:N.shortDescription??"",installCount:y(N.statistics,"install"),rating:y(N.statistics,"averagerating"),ratingCount:y(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:$,assets:ie,properties:{dependencies:z(j,a.Dependency),extensionPack:z(j,a.ExtensionPack),engine:X(j),localizedLanguages:Q(j),targetPlatform:q(j),isPreReleaseVersion:K(j)},hasPreReleaseVersion:K(Z),hasReleaseVersion:!0,preview:x(N.flags),isSigned:!!ie.signature,queryContext:J,supportLink:Y(Z)}}let B=class{constructor(j,$,J,Z,ie,H,ne,ce){this.requestService=$,this.logService=J,this.environmentService=Z,this.telemetryService=ie,this.fileService=H,this.productService=ne,this.configurationService=ce;const de=ne.extensionsGallery,fe=de?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=fe?de.servicePPEUrl:de?.serviceUrl,this.extensionsGallerySearchUrl=fe?void 0:de?.searchUrl,this.extensionsControlUrl=de?.controlUrl,this.commonHeadersPromise=(0,d.resolveMarketplaceHeaders)(ne.version,ne,this.environmentService,this.configurationService,this.fileService,j,this.telemetryService)}api(j=""){return`${this.extensionsGalleryUrl}${j}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(j,$,J){const Z=O.CancellationToken.isCancellationToken($)?{}:$,ie=O.CancellationToken.isCancellationToken($)?$:J,H=[],ne=[],ce=[],de=[];let fe=!0;for(const Re of j){Re.uuid?ne.push(Re.uuid):H.push(Re.id);const _e=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:_e}),Re.version&&de.push({id:Re.id,uuid:Re.uuid,version:Re.version}),fe=fe&&!!Re.hasPreRelease&&!_e}if(!ne.length&&!H.length)return[];let Se=new h().withPage(1,j.length);ne.length&&(Se=Se.withFilter(t.ExtensionId,...ne)),H.length&&(Se=Se.withFilter(t.ExtensionName,...H)),(Z.queryAllVersions||fe)&&(Se=Se.withFlags(Se.flags,n.IncludeVersions)),Z.source&&(Se=Se.withSource(Z.source));const{extensions:Ce}=await this.queryGalleryExtensions(Se,{targetPlatform:Z.targetPlatform??i,includePreRelease:ce,versions:de,compatible:!!Z.compatible},ie);return Z.source&&Ce.forEach((Re,_e)=>ee(Re,_e,Z.source)),Ce}async getCompatibleExtension(j,$,J){if((0,I.isNotWebExtensionInWebTargetPlatform)(j.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(j,$,J))return j;const Z=new h().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,j.identifier.uuid),{extensions:ie}=await this.queryGalleryExtensions(Z,{targetPlatform:J,compatible:!0,includePreRelease:$},O.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(j,$,J){if(!(0,I.isTargetPlatformCompatible)(j.properties.targetPlatform,j.allTargetPlatforms,J)||!$&&j.properties.isPreReleaseVersion)return!1;let Z=j.properties.engine;if(!Z){const ie=await this.getManifest(j,O.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Z=ie.engines.vscode}return(0,u.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(j,$,J,Z,ie){if(!(0,I.isTargetPlatformCompatible)(q(j),Z,ie)||$!=="any"&&K(j)!==($==="prerelease"))return!1;if(J)try{const H=await this.getEngine(j);if(!(0,u.isEngineValid)(H,this.productService.version,this.productService.date))return!1}catch(H){return this.logService.error(`Error while getting the engine for the version ${j.version}.`,(0,A.getErrorMessage)(H)),!1}return!0}async query(j,$){let J=j.text||"";const Z=j.pageSize??50;let ie=new h().withPage(1,Z);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,Se,Ce)=>(ie=ie.withFilter(t.Category,Ce||Se),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,Se,Ce)=>(ie=ie.withFilter(t.Tag,Ce||Se),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(t.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ie=ie.withFilter(t.SearchText,J)),ie=ie.withSortBy(0)):j.ids?ie=ie.withFilter(t.ExtensionId,...j.ids):j.names?ie=ie.withFilter(t.ExtensionName,...j.names):ie=ie.withSortBy(4),typeof j.sortBy=="number"&&(ie=ie.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(ie=ie.withSortOrder(j.sortOrder)),j.source&&(ie=ie.withSource(j.source));const H=async(fe,Se)=>{const{extensions:Ce,total:Re}=await this.queryGalleryExtensions(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!j.includePreRelease},Se);return Ce.forEach((_e,Ue)=>ee(_e,(fe.pageNumber-1)*fe.pageSize+Ue,j.source)),{extensions:Ce,total:Re}},{extensions:ne,total:ce}=await H(ie,$),de=async(fe,Se)=>{if(Se.isCancellationRequested)throw new A.CancellationError;const{extensions:Ce}=await H(ie.withPage(fe+1),Se);return Ce};return{firstPage:ne,total:ce,pageSize:ie.pageSize,getPage:de}}async queryGalleryExtensions(j,$,J){const Z=j.flags;j.flags&n.IncludeLatestVersionOnly&&j.flags&n.IncludeVersions&&(j=j.withFlags(j.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(j.flags&n.IncludeLatestVersionOnly)&&!(j.flags&n.IncludeVersions)&&(j=j.withFlags(j.flags,n.IncludeLatestVersionOnly)),$.versions?.length&&(j=j.withFlags(j.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),j=j.withFlags(j.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ie,total:H,context:ne}=await this.queryRawGalleryExtensions(j,J);if(!(j.flags&n.IncludeLatestVersionOnly)){const Se=[];for(const Ce of ie){const Re=await this.toGalleryExtensionWithCriteria(Ce,$,ne);Re&&Se.push(Re)}return{extensions:Se,total:H}}const de=[],fe=new Map;for(let Se=0;Se<ie.length;Se++){const Ce=ie[Se],Re={id:(0,S.getGalleryExtensionId)(Ce.publisher.publisherName,Ce.extensionName),uuid:Ce.extensionId},_e=(0,R.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(he=>(0,S.areSameExtensions)(he,Re))?.includePreRelease;if($.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(te(Ce),$.targetPlatform))continue;const Ue=await this.toGalleryExtensionWithCriteria(Ce,$,ne);!Ue||Ue.properties.isPreReleaseVersion&&(!_e||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==$.targetPlatform&&Ue.hasPreReleaseVersion?fe.set(Ce.extensionId,Se):de.push([Se,Ue])}if(fe.size){const Se=new w.StopWatch,Ce=new h().withFlags(Z&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:Re}=await this.queryGalleryExtensions(Ce,$,J);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:Se.elapsed(),count:fe.size});for(const _e of Re){const Ue=fe.get(_e.identifier.uuid);de.push([Ue,_e])}}return{extensions:de.sort((Se,Ce)=>Se[0]-Ce[0]).map(([,Se])=>Se),total:H}}async toGalleryExtensionWithCriteria(j,$,J){const Z={id:(0,S.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},ie=$.versions?.find(de=>(0,S.areSameExtensions)(de,Z))?.version,H=(0,R.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(de=>(0,S.areSameExtensions)(de,Z))?.includePreRelease,ne=te(j),ce=oe(j.versions,$.targetPlatform);if($.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(ne,$.targetPlatform))return null;for(let de=0;de<ce.length;de++){const fe=ce[de];if(!(ie&&fe.version!==ie)){if(await this.isValidVersion(fe,H?"any":"release",$.compatible,ne,$.targetPlatform))return ae(j,fe,ne,J);if(ie&&fe.version===ie)return null}}return ie||$.compatible?null:ae(j,j.versions[0],ne)}async queryRawGalleryExtensions(j,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const J=await this.commonHeadersPromise,Z=JSON.stringify(j.raw),ie={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},H=new w.StopWatch;let ne,ce,de=0;try{if(ne=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&j.criteria.some(Se=>Se.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:Z,headers:ie},$),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:de};const fe=await(0,c.asJson)(ne);if(fe){const Se=fe.results[0],Ce=Se.extensions,Re=Se.resultMetadata&&Se.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return de=Re&&Re.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:de,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(fe){const Se=(0,A.isCancellationError)(fe)?I.ExtensionGalleryErrorCode.Cancelled:(0,A.getErrorMessage)(fe).startsWith("XHR timeout")?I.ExtensionGalleryErrorCode.Timeout:I.ExtensionGalleryErrorCode.Failed;throw ce=new I.ExtensionGalleryError((0,A.getErrorMessage)(fe),Se),ce}finally{this.telemetryService.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(Z.length),duration:H.elapsed(),success:!!ne&&(0,c.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(de)})}}async reportStatistic(j,$,J,Z){if(!this.isEnabled())return;const ie=T.isWeb?this.api(`/itemName/${j}.${$}/version/${J}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${j}/extensions/${$}/${J}/stats?statType=${Z}`),H=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:H};try{await this.requestService.request({type:"POST",url:ie,headers:ce},O.CancellationToken.None)}catch{}}async download(j,$,J){this.logService.trace("ExtensionGalleryService#download",j.identifier.id);const Z=(0,S.getGalleryExtensionTelemetryData)(j),ie=new Date().getTime(),H=Se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:Se}),ne=J===2?"install":J===3?"update":"",ce=ne?{uri:`${j.assets.download.uri}${b.URI.parse(j.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${j.assets.download.fallbackUri}${b.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:j.assets.download,de=j.queryContext?.[o]?{[o]:j.queryContext[o]}:void 0,fe=await this.getAsset(ce,de?{headers:de}:void 0);await this.fileService.writeFile($,fe.stream),H(new Date().getTime()-ie)}async downloadSignatureArchive(j,$){if(!j.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const J=await this.getAsset(j.assets.signature);await this.fileService.writeFile($,J.stream)}async getReadme(j,$){if(j.assets.readme){const J=await this.getAsset(j.assets.readme,{},$);return await(0,c.asTextOrError)(J)||""}return""}async getManifest(j,$){if(j.assets.manifest){const J=await this.getAsset(j.assets.manifest,{},$),Z=await(0,c.asTextOrError)(J);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(j,$){const J=F(j,r.Manifest);if(!J)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},ie=await this.getAsset(J,{headers:Z});return await(0,c.asJson)(ie)}async getCoreTranslation(j,$){const J=j.assets.coreTranslations.filter(Z=>Z[0]===$.toUpperCase())[0];if(J){const Z=await this.getAsset(J[1]),ie=await(0,c.asTextOrError)(Z);return ie?JSON.parse(ie):null}return null}async getChangelog(j,$){if(j.assets.changelog){const J=await this.getAsset(j.assets.changelog,{},$);return await(0,c.asTextOrError)(J)||""}return""}async getAllCompatibleVersions(j,$,J){let Z=new h().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?Z=Z.withFilter(t.ExtensionId,j.identifier.uuid):Z=Z.withFilter(t.ExtensionName,j.identifier.id);const{galleryExtensions:ie}=await this.queryRawGalleryExtensions(Z,O.CancellationToken.None);if(!ie.length)return[];const H=te(ie[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(H,J))return[];const ne=[];await Promise.all(ie[0].versions.map(async fe=>{try{await this.isValidVersion(fe,$?"any":"release",!0,H,J)&&ne.push(fe)}catch{}}));const ce=[],de=new Set;for(const fe of oe(ne,J))de.has(fe.version)||(de.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:K(fe)}));return ce}async getAsset(j,$={},J=O.CancellationToken.None){const Z=await this.commonHeadersPromise,ie={type:"GET"},H={...Z,...$.headers||{}};$={...$,...ie,headers:H};const ne=j.uri,ce=j.fallbackUri,de={...$,url:ne};try{const fe=await this.requestService.request(de,J);if(fe.res.statusCode===200)return fe;const Se=await(0,c.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Se}`)}catch(fe){if((0,A.isCancellationError)(fe))throw fe;const Se=(0,A.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ne,message:Se});const Ce={...$,url:ce};return this.requestService.request(Ce,J)}}async getEngine(j){let $=X(j);if(!$){const J=await this.getManifestFromRawExtensionVersion(j,O.CancellationToken.None);if(!J)throw new Error("Manifest was not found");$=J.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const j=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,c.asJson)(j),J=[],Z={},ie=[];if($){for(const H of $.malicious)J.push({id:H});if($.migrateToPreRelease)for(const[H,ne]of Object.entries($.migrateToPreRelease))(!ne.engine||(0,u.isEngineValid)(ne.engine,this.productService.version,this.productService.date))&&(Z[H.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if($.deprecated)for(const[H,ne]of Object.entries($.deprecated))ne&&(Z[H.toLowerCase()]=(0,R.isBoolean)(ne)?{}:ne);if($.search)for(const H of $.search)ie.push(H)}return{malicious:J,deprecated:Z,search:ie}}};B=Ee([G(1,c.IRequestService),G(2,v.ILogService),G(3,P.IEnvironmentService),G(4,l.ITelemetryService),G(5,f.IFileService),G(6,E.IProductService),G(7,m.IConfigurationService)],B);let W=class extends B{constructor(j,$,J,Z,ie,H,ne,ce){super(j,$,J,Z,ie,H,ne,ce)}};e.ExtensionGalleryService=W,e.ExtensionGalleryService=W=Ee([G(0,g.IStorageService),G(1,c.IRequestService),G(2,v.ILogService),G(3,P.IEnvironmentService),G(4,l.ITelemetryService),G(5,f.IFileService),G(6,E.IProductService),G(7,m.IConfigurationService)],W);let k=class extends B{constructor(j,$,J,Z,ie,H,ne){super(void 0,j,$,J,Z,ie,H,ne)}};e.ExtensionGalleryServiceWithNoStorageService=k,e.ExtensionGalleryServiceWithNoStorageService=k=Ee([G(0,c.IRequestService),G(1,v.ILogService),G(2,P.IEnvironmentService),G(3,l.ITelemetryService),G(4,f.IFileService),G(5,E.IProductService),G(6,m.IConfigurationService)],k)}),define(le[83],ue([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,L,O,A,T,_,R,b,m,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let u=class extends A.Disposable{static{I=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(v){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(v.id)}@${v.version}`}static fromKey(v){const E=S.exec(v);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(v,E){const c=await v.getInstalled(),d=[];for(const[g,l]of I.readAllExtensionsWithKeysForSync(E)){const w=c.find(i=>(0,_.areSameExtensions)(i.identifier,{id:g}))?.manifest.version;for(const i of l)w!==i&&d.push(I.toKey({id:g,version:i}))}for(const g of d)E.remove(g,0)}static readAllExtensionsWithKeysForSync(v){const E=new Map,c=v.keys(0,1);for(const d of c){const g=I.fromKey(d);if(g){let l=E.get(g.id.toLowerCase());l||E.set(g.id.toLowerCase(),l=[]),l.push(g.version)}}return E}constructor(v,E,c){super(),this.storageService=v,this.productService=E,this.logService=c,this._onDidChangeExtensionStorageToSync=this._register(new O.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=I.readAllExtensionsWithKeysForSync(v),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new A.DisposableStore))(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(v){if(this.extensionsWithKeysForSync.has(v.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const E=I.fromKey(v.key);if(E){if(this.storageService.get(v.key,0)===void 0)this.extensionsWithKeysForSync.delete(E.id.toLowerCase());else{let c=this.extensionsWithKeysForSync.get(E.id.toLowerCase());c||this.extensionsWithKeysForSync.set(E.id.toLowerCase(),c=[]),c.push(E.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(v){if((0,P.isString)(v))return v;const E=v.manifest?v.manifest.publisher:v.publisher,c=v.manifest?v.manifest.name:v.name;return(0,_.getExtensionId)(E,c)}getExtensionState(v,E){const c=this.getExtensionId(v),d=this.getExtensionStateRaw(v,E);if(d)try{return JSON.parse(d)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${E}): ${g}`)}}getExtensionStateRaw(v,E){const c=this.getExtensionId(v),d=this.storageService.get(c,E?0:1);return d&&d?.length>I.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${E}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(v,E,c){const d=this.getExtensionId(v);E===void 0?this.storageService.remove(d,c?0:1):this.storageService.store(d,JSON.stringify(E),c?0:1,1)}setKeysForSync(v,E){this.storageService.store(I.toKey(v),JSON.stringify(E),0,1)}getKeysForSync(v){const E=this.productService.extensionSyncedKeys?.[v.id.toLowerCase()],c=this.storageService.get(I.toKey(v),0),d=c?JSON.parse(c):void 0;return d&&E?(0,b.distinct)([...d,...E]):d||E}addToMigrationList(v,E){if(v!==E){const c=this.migrationList.filter(d=>!d.includes(v)&&!d.includes(E));c.push([v,E]),this.migrationList=c}}getSourceExtensionToMigrate(v){const E=this.migrationList.find(([,c])=>v===c);return E?E[0]:void 0}get migrationList(){const v=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(v);if(Array.isArray(E))return E}catch{}return[]}set migrationList(v){v.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(v),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=u,e.ExtensionStorageService=u=I=Ee([G(0,T.IStorageService),G(1,R.IProductService),G(2,m.ILogService)],u)}),define(le[251],ue([0,1,2,29,83,226,113,8,19]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let m=class extends L.Disposable{constructor(I,S,u,f,v,E){super(),I.cleanUp(),(0,T.migrateUnsupportedExtensions)(I,S,u,f,E),A.ExtensionStorageService.removeOutdatedExtensionVersions(I,v)}};e.ExtensionsContributions=m,e.ExtensionsContributions=m=Ee([G(0,_.INativeServerExtensionManagementService),G(1,O.IExtensionGalleryService),G(2,A.IExtensionStorageService),G(3,O.IGlobalExtensionEnablementService),G(4,b.IStorageService),G(5,R.ILogService)],m)}),define(le[252],ue([0,1,29,11,24,15,97,57,19,22,225]),function(se,e,L,O,A,T,_,R,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends P.AbstractNativeExtensionTipsService{constructor(u,f,v,E,c,d,g,l){super(u.userHome,c,f,v,E,d,g,l)}};e.ExtensionTipsService=I,e.ExtensionTipsService=I=Ee([G(0,T.INativeEnvironmentService),G(1,m.ITelemetryService),G(2,L.IExtensionManagementService),G(3,b.IStorageService),G(4,R.INativeHostService),G(5,_.IExtensionRecommendationNotificationService),G(6,O.IFileService),G(7,A.IProductService)],I)}),define(le[253],ue([0,1,105,3,22,15,2,8,16,67,24,5,6,101,21,167,37,19,12,132,20]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const w=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends _.Disposable{constructor(a,C,p,h,y,D,U){super(),this.telemetryService=a,this.productService=C,this.environmentService=p,this.configurationService=D,this.storageService=U,this._onDidTokenFailedEmitter=new O.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new O.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new O.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=L.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(M,F)=>{F?this._logger.error(M):this._logger.info(M)},this._logger=this._register(h.createLogger((0,l.joinPath)(p.logsHome,`${L.LOG_ID}.log`),{id:L.LOG_ID,name:L.LOGGER_NAME})),this._startTunnelProcessDelayer=new S.Delayer(100),this._register(this._logger.onDidChangeLogLevel(M=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(M)))),this._register(y.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(D.onDidChangeConfiguration(M=>{w.some(F=>M.affectsConfiguration(F))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=L.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(a){this._tunnelStatus=a,this._onDidChangeTunnelStatusEmitter.fire(a)}setMode(a){t(this._mode,a)||(this._mode=a,this._storeMode(a),this._onDidChangeModeEmitter.fire(this._mode),a.active?(this._logger.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this._logger.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(a){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(C){this._logger.error(C)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let a;I.isMacintosh?a=this.environmentService.appRoot:a=(0,b.dirname)((0,b.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,b.join)(a,"bin",`${this.productService.tunnelApplicationName}${I.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(a){if(t(this._mode,a)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(C){this._logger.error(C)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const a=this._mode.asService;this.setMode(L.INACTIVE_TUNNEL_MODE);try{a&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(C){this._logger.error(C)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(a){this._logger.error(a)}this.setTunnelStatus(L.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let a="",C=!1;const p=(F,z)=>{z?this._logger.error(F):a+=F,!this.environmentService.isBuilt&&F.startsWith("   Compiling")&&this.setTunnelStatus(L.TunnelStates.connecting((0,v.localize)(0,null)))},h=this.runCodeTunnelCommand("status",["status"],p);this._tunnelProcess=h;try{if(await h,this._tunnelProcess!==h)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(z=>z.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.setTunnelStatus(L.TunnelStates.disconnected());return}if(C=F.service_installed,this._logger.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this._mode.active){this.setTunnelStatus(L.TunnelStates.disconnected());return}}catch(F){this._logger.error(F),this.setTunnelStatus(L.TunnelStates.disconnected());return}finally{this._tunnelProcess===h&&(this._tunnelProcess=void 0)}const y=this._mode.active?this._mode.session:void 0;if(y&&y.token){const F=y.token;this.setTunnelStatus(L.TunnelStates.connecting((0,v.localize)(1,null,y.accountLabel,y.providerId)));const z=(K,Q)=>{K=K.replaceAll(F,"*".repeat(4)),p(K,Q)},X=this.runCodeTunnelCommand("login",["user","login","--provider",y.providerId,"--access-token",F,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],z);this._tunnelProcess=X;try{if(await X,this._tunnelProcess!==X)return}catch(K){this._logger.error(K),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(y),this.setTunnelStatus(L.TunnelStates.disconnected(y));return}}const D=this._getTunnelName();D?this.setTunnelStatus(L.TunnelStates.connecting((0,v.localize)(2,null,D))):this.setTunnelStatus(L.TunnelStates.connecting((0,v.localize)(3,null)));const U=["--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];D?U.push("--name",D):U.push("--random-name");let M=!1;return this._mode.active&&this._mode.asService&&!C&&(M=await this.installTunnelService(U)===!1),this.serverOrAttachTunnel(y,U,M)}async installTunnelService(a){let C;try{C=await this.runCodeTunnelCommand("serviceInstall",["service","install",...a])}catch(p){this._logger.error(p),C=1}if(C!==0){const p=(0,v.localize)(4,null);return this._logger.warn(p),this.setTunnelStatus(L.TunnelStates.connecting(p)),!1}return!0}async serverOrAttachTunnel(a,C,p){C.push("--parent-process-id",String(process.pid)),this._preventSleep()&&C.push("--no-sleep");let h=!1;const y=this.runCodeTunnelCommand("tunnel",C,(D,U)=>{U?this._logger.error(D):this._logger.info(D),D.includes("Connected to an existing tunnel process")&&(h=!0);const M=D.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const F={link:M[1],domain:M[2],tunnelName:M[4],isAttached:h};this.setTunnelStatus(L.TunnelStates.connected(F,p))}else D.match(/error refreshing token/)&&(y.cancel(),this._onDidTokenFailedEmitter.fire(a),this.setTunnelStatus(L.TunnelStates.disconnected(a)))});this._tunnelProcess=y,y.finally(()=>{y===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=L.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(L.TunnelStates.disconnected()))})}runCodeTunnelCommand(a,C,p=this.defaultOnOutput){return(0,S.createCancelablePromise)(h=>new Promise((y,D)=>{h.isCancellationRequested&&y(-1);let U;const M=["ignore","pipe","pipe"];if(h.onCancellationRequested(()=>{U&&(this._logger.info(`${a} terminating(${U.pid})`),U.kill())}),!this.environmentService.isBuilt)p(`Building tunnel CLI from sources and run
`,!1),p(`${a} Spawning: cargo run -- tunnel ${C.join(" ")}
`,!1),U=(0,m.spawn)("cargo",["run","--","tunnel",...C],{cwd:(0,b.join)(this.environmentService.appRoot,"cli"),stdio:M});else{p(`Running tunnel CLI
`,!1);const F=this.getTunnelCommandLocation();p(`${a} Spawning: ${F} tunnel ${C.join(" ")}
`,!1),U=(0,m.spawn)(F,["tunnel",...C],{cwd:(0,E.homedir)(),stdio:M})}U.stdout.pipe(new g.StreamSplitter(`
`)).on("data",F=>{if(U){const z=F.toString();p(z,!1)}}),U.stderr.pipe(new g.StreamSplitter(`
`)).on("data",F=>{if(U){const z=F.toString();p(z,!0)}}),U.on("exit",F=>{U&&(p(`${a} exit(${U.pid}): + ${F} `,!1),U=void 0,y(F||0))}),U.on("error",F=>{U&&(p(`${a} error(${U.pid}): + ${F} `,!0),U=void 0,D())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let a=this.configurationService.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,E.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}_restoreMode(){try{const a=this.storageService.get(i,-1),C=this.storageService.getBoolean(o,-1,!1);if(a){const p=JSON.parse(a);if(p&&(0,d.isString)(p.accountLabel)&&(0,d.isString)(p.sessionId)&&(0,d.isString)(p.providerId))return{active:!0,session:p,asService:C};this._logger.error("Problems restoring session from storage, invalid format",p)}}catch(a){this._logger.error("Problems restoring session from storage",a)}return L.INACTIVE_TUNNEL_MODE}_storeMode(a){if(a.active){const C={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.storageService.store(i,JSON.stringify(C),-1,1),this.storageService.store(o,a.asService,-1,1)}else this.storageService.remove(i,-1),this.storageService.remove(o,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=Ee([G(0,A.ITelemetryService),G(1,P.IProductService),G(2,T.INativeEnvironmentService),G(3,R.ILoggerService),G(4,u.ISharedProcessLifecycleService),G(5,f.IConfigurationService),G(6,c.IStorageService)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[254],ue([0,1,6,2,23,20,69,19,78,18]),function(se,e,L,O,A,T,_,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class P extends R.AbstractStorageService{constructor(S,u,f,v){super(),this.initialWorkspace=S,this.initialProfiles=u,this.remoteService=f,this.environmentService=v,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new O.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new O.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const S=this._register(new b.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),u=this._register(new _.Storage(S));return this._register(u.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f))),u}createProfileStorage(S){this.profileStorageDisposables.clear(),this.profileStorageProfile=S;let u;if((0,R.isProfileUsingDefaultStorage)(S))u=this.applicationStorage;else{const f=this.profileStorageDisposables.add(new b.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),S));u=this.profileStorageDisposables.add(new _.Storage(f))}return this.profileStorageDisposables.add(u.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),u}createWorkspaceStorage(S){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=S?.id;let u;if(S){const f=this.workspaceStorageDisposables.add(new b.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),S));u=this.workspaceStorageDisposables.add(new _.Storage(f)),this.workspaceStorageDisposables.add(u.onDidChangeStorage(v=>this.emitDidChangeValue(1,v)))}return u}async doInitialize(){await L.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(S){switch(S){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(S){switch(S){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(S){if(!this.canSwitchProfile(this.profileStorageProfile,S))return;const u=this.profileStorage,f=u.items;u!==this.applicationStorage&&await u.close(),this.profileStorage=this.createProfileStorage(S),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0)}async switchToWorkspace(S,u){const f=this.workspaceStorage,v=f?.items??new Map;await f?.close(),this.workspaceStorage=this.createWorkspaceStorage(S),await this.workspaceStorage.init(),this.switchData(v,this.workspaceStorage,1)}hasScope(S){return(0,m.isUserDataProfile)(S)?this.profileStorageProfile.id===S.id:this.workspaceStorageId===S.id}}e.RemoteStorageService=P}),define(le[255],ue([0,1,3,2,18,92]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(m,P){this.service=m,this.getUriTransformer=P}listen(m,P){const I=this.getUriTransformer(m);switch(P){case"onDidChangeProfiles":return L.Event.map(this.service.onDidChangeProfiles,S=>({all:S.all.map(u=>(0,T.transformOutgoingURIs)({...u},I)),added:S.added.map(u=>(0,T.transformOutgoingURIs)({...u},I)),removed:S.removed.map(u=>(0,T.transformOutgoingURIs)({...u},I)),updated:S.updated.map(u=>(0,T.transformOutgoingURIs)({...u},I))}))}throw new Error(`Invalid listen ${P}`)}async call(m,P,I){const S=this.getUriTransformer(m);switch(P){case"createProfile":{const u=await this.service.createProfile(I[0],I[1],I[2]);return(0,T.transformOutgoingURIs)({...u},S)}case"updateProfile":{let u=(0,A.reviveProfile)((0,T.transformIncomingURIs)(I[0],S),this.service.profilesHome.scheme);return u=await this.service.updateProfile(u,I[1]),(0,T.transformOutgoingURIs)({...u},S)}case"removeProfile":{const u=(0,A.reviveProfile)((0,T.transformIncomingURIs)(I[0],S),this.service.profilesHome.scheme);return this.service.removeProfile(u)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=_;class R extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(m,P,I){super(),this.profilesHome=P,this.channel=I,this._profiles=[],this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=m.map(S=>(0,A.reviveProfile)(S,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(S=>{const u=S.added.map(E=>(0,A.reviveProfile)(E,this.profilesHome.scheme)),f=S.removed.map(E=>(0,A.reviveProfile)(E,this.profilesHome.scheme)),v=S.updated.map(E=>(0,A.reviveProfile)(E,this.profilesHome.scheme));this._profiles=S.all.map(E=>(0,A.reviveProfile)(E,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:u,removed:f,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(m){this.enabled=m}isEnabled(){return this.enabled}async createNamedProfile(m,P,I){const S=await this.channel.call("createNamedProfile",[m,P,I]);return(0,A.reviveProfile)(S,this.profilesHome.scheme)}async createProfile(m,P,I,S){const u=await this.channel.call("createProfile",[m,P,I,S]);return(0,A.reviveProfile)(u,this.profilesHome.scheme)}async createTransientProfile(m){const P=await this.channel.call("createTransientProfile",[m]);return(0,A.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(m,P){await this.channel.call("setProfileForWorkspace",[m,P])}removeProfile(m){return this.channel.call("removeProfile",[m])}async updateProfile(m,P){const I=await this.channel.call("updateProfile",[m,P]);return(0,A.reviveProfile)(I,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(le[60],ue([0,1,2,69,4,19,3,78,18]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let m=class extends L.Disposable{constructor(u){super(),this.storageService=u}async readStorageData(u){return this.withProfileScopedStorageService(u,async f=>this.getItems(f))}async updateStorageData(u,f,v){return this.withProfileScopedStorageService(u,async E=>this.writeItems(E,f,v))}async withProfileScopedStorageService(u,f){if(this.storageService.hasScope(u))return f(this.storageService);const v=await this.createStorageDatabase(u),E=new I(v);try{await E.initialize();const c=await f(E);return await E.flush(),c}finally{E.dispose(),await this.closeAndDispose(v)}}getItems(u){const f=new Map,v=E=>{for(const c of u.keys(0,E))f.set(c,{value:u.get(c,0),target:E})};return v(0),v(1),f}writeItems(u,f,v){u.storeAll(Array.from(f.entries()).map(([E,c])=>({key:E,value:c,scope:0,target:v})),!0)}async closeAndDispose(u){try{await u.close()}finally{(0,L.isDisposable)(u)&&u.dispose()}}};e.AbstractUserDataProfileStorageService=m,e.AbstractUserDataProfileStorageService=m=Ee([G(0,T.IStorageService)],m);class P extends m{constructor(u,f,v,E){super(v),this.remoteService=u;const c=u.getChannel("profileStorageListener"),d=this._register(new L.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{d.value=c.listen("onDidChange")(g=>{E.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(l=>(0,b.reviveProfile)(l,f.profilesHome.scheme)),valueChanges:g.valueChanges.map(l=>({...l,profile:(0,b.reviveProfile)(l.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(u){const f=this.remoteService.getChannel("storage");return(0,T.isProfileUsingDefaultStorage)(u)?new R.ApplicationStorageDatabaseClient(f):new R.ProfileStorageDatabaseClient(f,u)}}e.RemoteUserDataProfileStorageService=P;class I extends T.AbstractStorageService{constructor(u){super({flushInterval:100}),this.profileStorage=this._register(new O.Storage(u))}doInitialize(){return this.profileStorage.init()}getStorage(u){return u===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(le[256],ue([0,1,19,8,18,56,60]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends _.RemoteUserDataProfileStorageService{constructor(m,P,I,S){super(m,P,I,S)}};e.NativeUserDataProfileStorageService=R,e.NativeUserDataProfileStorageService=R=Ee([G(0,T.IMainProcessService),G(1,A.IUserDataProfilesService),G(2,L.IStorageService),G(3,O.ILogService)],R)}),define(le[39],ue([0,1,17,6,14,26,3,34,2,27,12,172,21,15,11,8,43,19,22,28,25,18]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(C){return!!(C&&C.ref!==void 0&&typeof C.ref=="string"&&C.ref!==""&&C.syncData!==void 0&&(C.syncData===null||o(C.syncData)))}e.isRemoteUserData=i;function o(C){return!!(C&&C.version!==void 0&&typeof C.version=="number"&&C.content!==void 0&&typeof C.content=="string"&&(Object.keys(C).length===2||Object.keys(C).length===3&&C.machineId!==void 0&&typeof C.machineId=="string"))}e.isSyncData=o;function n(C,p){return`${(0,m.uppercaseFirstLetter)(C)}${p.isDefault?"":` (${p.name})`}`}e.getSyncResourceLogLabel=n;let s=class extends b.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(p,h,y,D,U,M,F,z,X,K,Q,V){super(),this.syncResource=p,this.collection=h,this.fileService=y,this.environmentService=D,this.storageService=U,this.userDataSyncStoreService=M,this.userDataSyncLocalStoreService=F,this.userDataSyncEnablementService=z,this.telemetryService=X,this.logService=K,this.configurationService=Q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new O.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(p.syncResource,p.profile),this.extUri=V.extUri,this.syncFolder=this.extUri.joinPath(D.userDataSyncHome,...(0,l.getPathSegments)(p.profile.isDefault?void 0:p.profile.id,p.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(p.profile.isDefault?void 0:p.profile.id,p.syncResource,D,this.extUri),this.currentMachineIdPromise=(0,E.getServiceMachineId)(D,y,U)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const p=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(p.remoteUserData,p.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const p=await this.getLastSyncUserData();(p?await this.hasRemoteChanged(p):!0)&&this._onDidChangeLocal.fire()}}setStatus(p){this._status!==p&&(this._status=p,this._onDidChangStatus.fire(p))}async sync(p,h={}){await this._sync(p,!0,this.getUserDataSyncConfiguration(),h)}async preview(p,h,y={}){return this._sync(p,!1,h,y)}async apply(p,h={}){try{this.syncHeaders={...h};const y=await this.doApply(p);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(p,h,y,D){try{if(this.syncHeaders={...D},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let U="idle";try{const M=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(p,M);return U=await this.performSync(F,M,h,y),U==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):U==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(U)}}finally{this.syncHeaders={}}}async replace(p){const h=this.parseSyncData(p);if(!h)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const y=await this.getLastSyncUserData(),D=await this.getLatestRemoteUserData(null,y),U=await this.isRemoteDataFromCurrentMachine(D),M=await this.generateSyncPreview({ref:D.ref,syncData:h},y,U,this.getUserDataSyncConfiguration(),T.CancellationToken.None),F=[];for(const z of M){const X=await this.getAcceptResult(z,z.remoteResource,void 0,T.CancellationToken.None),{remoteChange:K}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,T.CancellationToken.None);F.push([z,{...X,remoteChange:K!==0?K:2}])}await this.applyResult(D,y,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(p){const h=await this.currentMachineIdPromise;return!!p.syncData?.machineId&&p.syncData.machineId===h}async getLatestRemoteUserData(p,h){if(h){const y=p?p[this.resource]:void 0;if(h.ref===y||y===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(p,h,y,D){if(p.syncData&&p.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,I.localize)(0,null,this.resource,this.version,p.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(p,h,y,D)}catch(U){if(U instanceof l.UserDataSyncError)switch(U.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(p,h,y,D);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),p=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(p,h,y,D)}throw U}}async doSync(p,h,y,D){try{const U=await this.isRemoteDataFromCurrentMachine(p),M=!U&&h===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,F=y&&!M;this.syncPreviewPromise||(this.syncPreviewPromise=(0,O.createCancelablePromise)(X=>this.doGenerateSyncResourcePreview(p,h,U,F,D,X)));let z=await this.syncPreviewPromise;if(y&&M){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of z.resourcePreviews)z=await this.accept(X.remoteResource)||z}return this.updateConflicts(z.resourcePreviews),z.resourcePreviews.some(({mergeState:X})=>X==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(U){throw this.syncPreviewPromise=null,U}}async merge(p){return await this.updateSyncResourcePreview(p,async h=>{const y=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,A.VSBuffer.fromString(y?.content||""));const D=y&&!y.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=D,h.mergeState=y.hasConflicts?"conflict":D?"accepted":"preview",h.localChange=D?D.localChange:y.localChange,h.remoteChange=D?D.remoteChange:y.remoteChange,h}),this.syncPreviewPromise}async accept(p,h){return await this.updateSyncResourcePreview(p,async y=>{const D=await this.getAcceptResult(y,p,h,T.CancellationToken.None);return y.acceptResult=D,y.mergeState="accepted",y.localChange=D.localChange,y.remoteChange=D.remoteChange,y}),this.syncPreviewPromise}async discard(p){return await this.updateSyncResourcePreview(p,async h=>{const y=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,A.VSBuffer.fromString(y.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=y.localChange,h.remoteChange=y.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(p,h){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const D=y.resourcePreviews.findIndex(({localResource:U,remoteResource:M,previewResource:F})=>this.extUri.isEqual(U,p)||this.extUri.isEqual(M,p)||this.extUri.isEqual(F,p));D!==-1&&(this.syncPreviewPromise=(0,O.createCancelablePromise)(async U=>{const M=[...y.resourcePreviews];return M[D]=await h(M[D]),{...y,resourcePreviews:M}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:U})=>U==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(p){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(y=>[y,y.acceptResult]),p),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(p){const h=p.filter(({mergeState:y})=>y==="conflict");(0,L.equals)(this._conflicts,h,(y,D)=>this.extUri.isEqual(y.previewResource,D.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const p=await this.getLastSyncUserData();return!!p&&p.syncData!==null}async resolvePreviewContent(p){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const y of h.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,p))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,p))return y.remoteContent;if(this.extUri.isEqual(y.localResource,p))return y.localContent;if(this.extUri.isEqual(y.baseResource,p))return y.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(p){(0,f.toFileOperationResult)(p)!==1&&this.logService.error(p)}}async doGenerateSyncResourcePreview(p,h,y,D,U,M){const F=await this.generateSyncPreview(p,h,y,U,M),z=[];for(const X of F){const K=X.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(X.localChange===0&&X.remoteChange===0)z.push({...X,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=D?await this.getMergeResult(X,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(X.previewResource,A.VSBuffer.fromString(Q?.content||""));const V=Q&&!Q.hasConflicts?await this.getAcceptResult(X,X.previewResource,void 0,M):void 0;z.push({...X,acceptResult:V,mergeState:Q?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:Q?Q.localChange:X.localChange,remoteChange:V?V.remoteChange:Q?Q.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:p,lastSyncUserData:h,resourcePreviews:z,isLastSyncFromCurrentMachine:y}}async getLastSyncUserData(){let p=this.getStoredLastSyncUserDataStateContent();if(p||(p=await this.migrateLastSyncUserData()),!p)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const h=JSON.parse(p),y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!h.version&&!!y&&h.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;let D,U=1;for(;D===void 0&&U++<6;)try{const M=await this.readLastSyncStoredRemoteUserData();M&&(M.ref===h.ref?D=M.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof f.FileOperationError&&M.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(M instanceof l.UserDataSyncError)throw M;this.logService.error(M,U)}}if(D===void 0)try{const M=await this.userDataSyncStoreService.resolveResourceContent(this.resource,h.ref,this.collection,this.syncHeaders);D=M===null?null:this.parseSyncData(M),await this.writeLastSyncStoredRemoteUserData({ref:h.ref,syncData:D})}catch(M){if(M instanceof l.UserDataSyncError&&M.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw M}return D===void 0?null:{...h,syncData:D}}async updateLastSyncUserData(p,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),D={ref:p.ref,version:y,...h};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(D),-1,1),await this.writeLastSyncStoredRemoteUserData(p)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const p=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const h=p?JSON.parse(p):void 0;if(i(h))return h}catch(h){this.logService.error(h)}}async writeLastSyncStoredRemoteUserData(p){await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}async migrateLastSyncUserData(){try{const p=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(p.value.toString());await this.fileService.del(this.lastSyncResource),h.ref&&h.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...h,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:h.ref,syncData:h.content===null?null:JSON.parse(h.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,h)}catch(p){p instanceof f.FileOperationError&&p.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(p)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(p){const{ref:h,content:y}=await this.getUserData(p);let D=null;return y!==null&&(D=this.parseSyncData(y)),{ref:h,syncData:D}}parseSyncData(p){try{const h=JSON.parse(p);if(o(h))return h}catch(h){this.logService.error(h)}throw new l.UserDataSyncError((0,I.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(p){const h=p?{ref:p.ref,content:p.syncData?JSON.stringify(p.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,h,this.collection,this.syncHeaders)}async updateRemoteUserData(p,h){const y=await this.currentMachineIdPromise,D={version:this.version,machineId:y,content:p};try{return h=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(D),h,this.collection,this.syncHeaders),{ref:h,syncData:D}}catch(U){throw U instanceof l.UserDataSyncError&&U.code==="TooLarge"&&(U=new l.UserDataSyncError(U.message,U.code,this.resource)),U}}async backupLocal(p){const h={version:this.version,content:p};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(h),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=s,e.AbstractSynchroniser=s=Ee([G(2,f.IFileService),G(3,u.IEnvironmentService),G(4,c.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncLocalStoreService),G(7,l.IUserDataSyncEnablementService),G(8,d.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,S.IConfigurationService),G(11,g.IUriIdentityService)],s);let t=class extends s{constructor(p,h,y,D,U,M,F,z,X,K,Q,V,Y){super(h,y,D,U,M,F,z,X,K,Q,V,Y),this.file=p,this._register(this.fileService.watch(this.extUri.dirname(p))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(p,h,y){try{h?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(p),y?void 0:h):await this.fileService.createFile(this.file,A.VSBuffer.fromString(p),{overwrite:y})}catch(D){throw D instanceof f.FileOperationError&&D.fileOperationResult===1||D instanceof f.FileOperationError&&D.fileOperationResult===3?new l.UserDataSyncError(D.message,"LocalPreconditionFailed"):D}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(p){if(!(p instanceof f.FileOperationError&&p.fileOperationResult===1))throw p}}onFileChanges(p){p.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=t,e.AbstractFileSynchroniser=t=Ee([G(3,f.IFileService),G(4,u.IEnvironmentService),G(5,c.IStorageService),G(6,l.IUserDataSyncStoreService),G(7,l.IUserDataSyncLocalStoreService),G(8,l.IUserDataSyncEnablementService),G(9,d.ITelemetryService),G(10,l.IUserDataSyncLogService),G(11,S.IConfigurationService),G(12,g.IUriIdentityService)],t);let r=class extends t{constructor(p,h,y,D,U,M,F,z,X,K,Q,V,Y,x){super(p,h,y,D,U,M,F,z,X,K,Q,Y,x),this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(p,h){const y=[],D=(0,R.parse)(p,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,P.isUndefined)(D)&&h!==Array.isArray(D)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=Ee([G(3,f.IFileService),G(4,u.IEnvironmentService),G(5,c.IStorageService),G(6,l.IUserDataSyncStoreService),G(7,l.IUserDataSyncLocalStoreService),G(8,l.IUserDataSyncEnablementService),G(9,d.ITelemetryService),G(10,l.IUserDataSyncLogService),G(11,l.IUserDataSyncUtilService),G(12,S.IConfigurationService),G(13,g.IUriIdentityService)],r);let a=class{constructor(p,h,y,D,U,M,F){this.resource=p,this.userDataProfilesService=h,this.environmentService=y,this.logService=D,this.fileService=U,this.storageService=M,this.extUri=F.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(void 0,this.resource,y,this.extUri)}async initialize({ref:p,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(h);if(y)try{await this.doInitialize({ref:p,syncData:y})}catch(D){this.logService.error(D)}}parseSyncData(p){try{const h=JSON.parse(p);if(o(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(p,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const y={ref:p.ref,version:void 0,...h};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(y),-1,1),await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=Ee([G(1,w.IUserDataProfilesService),G(2,u.IEnvironmentService),G(3,v.ILogService),G(4,f.IFileService),G(5,c.IStorageService),G(6,g.IUriIdentityService)],a)}),define(le[115],ue([0,1,6,26,7,3,42,2,27,21,15,114,29,33,83,45,11,4,74,8,19,22,28,18,39,237,111,25,60]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function C(M,F){const z=JSON.parse(M.content);if(M.version===1||M.version===2){const X=(await F.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of z)M.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),M.version===2&&X.every(Q=>!(0,u.areSameExtensions)(Q.identifier,K.identifier))&&(K.installed=!0)}return z}function p(M){return JSON.parse(M.content)}e.parseExtensions=p;function h(M,F){return M.sort((z,X)=>!z.identifier.uuid&&X.identifier.uuid?-1:z.identifier.uuid&&!X.identifier.uuid?1:(0,b.compare)(z.identifier.id,X.identifier.id)),F?(0,_.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=h;let y=class extends n.AbstractSynchroniser{constructor(F,z,X,K,Q,V,Y,x,q,te,oe,ee,ae,B,W,k,N){super({syncResource:"extensions",profile:F},z,K,X,Q,V,Y,ee,ae,te,oe,W),this.extensionManagementService=x,this.ignoredExtensionsManagementService=q,this.instantiationService=N,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(D),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:$})=>!!$)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),T.Event.filter(k.onDidChange,j=>j.valueChanges.some(({profile:$,changes:J})=>this.syncResource.profile.id===$.id&&J.some(Z=>Z.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),B.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,z){const X=F.syncData?await C(F.syncData,this.extensionManagementService):null,K=z?.skippedExtensions??[],Q=z?.builtinExtensions??null,V=z?.syncData?await C(z.syncData,this.extensionManagementService):null,{localExtensions:Y,ignoredExtensions:x}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);X?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:te}=(0,s.merge)(Y,X,V,K,x,Q),oe={local:q,remote:te,content:this.getPreviewContent(Y,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.stringify(Y,!1);return[{skippedExtensions:K,builtinExtensions:Q,baseResource:this.baseResource,baseContent:V?this.stringify(V,!1):ee,localResource:this.localResource,localContent:ee,localExtensions:Y,remoteResource:this.remoteResource,remoteExtensions:X,remoteContent:X?this.stringify(X,!1):null,previewResource:this.previewResource,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const z=F.syncData?await C(F.syncData,this.extensionManagementService):null,{localExtensions:X,ignoredExtensions:K}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,s.merge)(X,z,z,F.skippedExtensions||[],K,F.builtinExtensions||[]);return Q!==null}getPreviewContent(F,z,X,K){const Q=[...z,...X],V=new Set,Y=x=>{V.add(x.id.toLowerCase()),x.uuid&&V.add(x.uuid)};Q.forEach(({identifier:x})=>Y(x)),K.forEach(Y);for(const x of F)V.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&V.has(x.identifier.uuid)||Q.push(x);return this.stringify(Q,!1)}async getMergeResult(F,z){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,z,X,K){if(this.extUri.isEqual(z,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(z,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(z,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async acceptLocal(F){const z=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.ignoredExtensionsManagementService.getIgnoredExtensions(z),K=(0,s.merge)(F.localExtensions,null,null,F.skippedExtensions,X,F.builtinExtensions),{local:Q,remote:V}=K;return{content:F.localContent,local:Q,remote:V,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:V!==null?2:0}}async acceptRemote(F){const z=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.ignoredExtensionsManagementService.getIgnoredExtensions(z),K=F.remoteContent?JSON.parse(F.remoteContent):null;if(K!==null){const Q=(0,s.merge)(F.localExtensions,K,F.localExtensions,[],X,F.builtinExtensions),{local:V,remote:Y}=Q;return{content:F.remoteContent,local:V,remote:Y,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(F,z,X,K){let{skippedExtensions:Q,builtinExtensions:V,localExtensions:Y}=X[0][0];const{local:x,remote:q,localChange:te,remoteChange:oe}=X[0][1];if(te===0&&oe===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),te!==0&&(await this.backupLocal(JSON.stringify(Y)),Q=await this.localExtensionsProvider.updateLocalExtensions(x.added,x.removed,x.updated,Q,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ee=JSON.stringify(q.all);F=await this.updateRemoteUserData(ee,K?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(ae=>ae.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(ae=>ae.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(ae=>ae.identifier.id))}.`:""}`)}z?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),V=this.computeBuiltinExtensions(Y,V),await this.updateLastSyncUserData(F,{skippedExtensions:Q,builtinExtensions:V}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ee=>ee.identifier.id))}.`:""}`))}computeBuiltinExtensions(F,z){const X=new Set,K=[];for(const Q of F)X.add(Q.identifier.id.toLowerCase()),Q.installed||K.push(Q.identifier);if(z)for(const Q of z)X.has(Q.id.toLowerCase())||K.push(Q);return K}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const z=await this.resolvePreviewContent(F);return z&&this.stringify(JSON.parse(z),!0)}return null}stringify(F,z){return h(F,z)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(F.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=y,e.ExtensionsSynchroniser=y=Ee([G(2,P.IEnvironmentService),G(3,E.IFileService),G(4,l.IStorageService),G(5,r.IUserDataSyncStoreService),G(6,r.IUserDataSyncLocalStoreService),G(7,S.IExtensionManagementService),G(8,t.IIgnoredExtensionsManagementService),G(9,r.IUserDataSyncLogService),G(10,m.IConfigurationService),G(11,r.IUserDataSyncEnablementService),G(12,w.ITelemetryService),G(13,f.IExtensionStorageService),G(14,i.IUriIdentityService),G(15,a.IUserDataProfileStorageService),G(16,c.IInstantiationService)],y);let D=class{constructor(F,z,X,K,Q,V){this.extensionManagementService=F,this.userDataProfileStorageService=z,this.extensionGalleryService=X,this.ignoredExtensionsManagementService=K,this.instantiationService=Q,this.logService=V}async getLocalExtensions(F){const z=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),X=this.ignoredExtensionsManagementService.getIgnoredExtensions(z);return{localExtensions:await this.withProfileScopedServices(F,async(Q,V)=>{const Y=Q.getDisabledExtensions();return z.map(x=>{const{identifier:q,isBuiltin:te,manifest:oe,preRelease:ee,pinned:ae,isApplicationScoped:B}=x,W={identifier:q,preRelease:ee,version:oe.version,pinned:!!ae};B&&!(0,v.isApplicationScopedExtension)(oe)&&(W.isApplicationScoped=B),Y.some(k=>(0,u.areSameExtensions)(k,q))&&(W.disabled=!0),te||(W.installed=!0);try{const k=V.getKeysForSync({id:q.id,version:oe.version});if(k){const N=V.getExtensionState(x,!0)||{};W.state=Object.keys(N).reduce((j,$)=>(k.includes($)&&(j[$]=N[$]),j),{})}}catch(k){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,A.getErrorMessage)(k))}return W})}),ignoredExtensions:X}}async updateLocalExtensions(F,z,X,K,Q){const V=(0,n.getSyncResourceLogLabel)("extensions",Q),Y=[],x=new Map,q=[],te=[],oe=await this.extensionManagementService.getInstalled(void 0,Q.extensionsResource);if((F.length||X.length)&&await this.withProfileScopedServices(Q,async(B,W)=>{await L.Promises.settled([...F,...X].map(async k=>{const N=oe.find(J=>(0,u.areSameExtensions)(J.identifier,k.identifier));if(N&&N.isBuiltin){k.state&&N.manifest.version===k.version&&this.updateExtensionState(k.state,N,N.manifest.version,W),B.getDisabledExtensions().some(Z=>(0,u.areSameExtensions)(Z,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${V}: Disabling extension...`,k.identifier.id),await B.disableExtension(k.identifier),this.logService.info(`${V}: Disabled extension`,k.identifier.id)):(this.logService.trace(`${V}: Enabling extension...`,k.identifier.id),await B.enableExtension(k.identifier),this.logService.info(`${V}: Enabled extension`,k.identifier.id))),q.push(k.identifier);return}const j=k.pinned?k.version:void 0,$=(await this.extensionGalleryService.getExtensions([{...k.identifier,version:j,preRelease:j?void 0:k.preRelease}],O.CancellationToken.None))[0];if(k.state&&(N?N.manifest.version===k.version:$)&&this.updateExtensionState(k.state,N||$,N?.manifest.version,W),$)try{B.getDisabledExtensions().some(Z=>(0,u.areSameExtensions)(Z,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${V}: Disabling extension...`,k.identifier.id,$.version),await B.disableExtension($.identifier),this.logService.info(`${V}: Disabled extension`,k.identifier.id,$.version)):(this.logService.trace(`${V}: Enabling extension...`,k.identifier.id,$.version),await B.enableExtension($.identifier),this.logService.info(`${V}: Enabled extension`,k.identifier.id,$.version))),(!N||N.preRelease!==k.preRelease||N.pinned!==k.pinned||j&&N.manifest.version!==j)&&(await this.extensionManagementService.canInstall($)?(Y.push({extension:$,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[S.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[S.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),x.set($.identifier.id.toLowerCase(),k)):(this.logService.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),te.push(k)))}catch(J){te.push(k),this.logService.error(J),this.logService.info(`${V}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else te.push(k),this.logService.info(`${V}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),z.length){const B=oe.filter(({identifier:W,isBuiltin:k})=>!k&&z.some(N=>(0,u.areSameExtensions)(W,N)));await L.Promises.settled(B.map(async W=>{this.logService.trace(`${V}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.logService.info(`${V}: Uninstalled local extension.`,W.identifier.id),q.push(W.identifier)}))}const ee=await this.extensionManagementService.installGalleryExtensions(Y);for(const{identifier:B,local:W,error:k,source:N}of ee){const j=N;if(W)this.logService.info(`${V}: Installed extension.`,B.id,j.version),q.push(B);else{const $=x.get(B.id.toLowerCase());$&&(te.push($),this.logService.info(`${V}: Skipped synchronizing extension`,j.displayName||j.identifier.id)),k instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.logService.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,j.displayName||j.identifier.id):k&&this.logService.error(k)}}const ae=[];for(const B of K)q.some(W=>(0,u.areSameExtensions)(W,B.identifier))||ae.push(B);for(const B of te)ae.some(W=>(0,u.areSameExtensions)(W.identifier,B.identifier))||ae.push(B);return ae}updateExtensionState(F,z,X,K){const Q=K.getExtensionState(z,!0)||{},V=X?K.getKeysForSync({id:z.identifier.id,version:X}):void 0;V?V.forEach(Y=>{Q[Y]=F[Y]}):Object.keys(F).forEach(Y=>Q[Y]=F[Y]),K.setExtensionState(z,Q,!0)}async withProfileScopedServices(F,z){return this.userDataProfileStorageService.withProfileScopedStorageService(F,async X=>{const K=new R.DisposableStore,Q=this.instantiationService.createChild(new d.ServiceCollection([l.IStorageService,X])),V=K.add(Q.createInstance(I.GlobalExtensionEnablementService)),Y=K.add(Q.createInstance(f.ExtensionStorageService));try{return await z(V,Y)}finally{K.dispose()}})}};e.LocalExtensionsProvider=D,e.LocalExtensionsProvider=D=Ee([G(0,S.IExtensionManagementService),G(1,a.IUserDataProfileStorageService),G(2,S.IExtensionGalleryService),G(3,t.IIgnoredExtensionsManagementService),G(4,c.IInstantiationService),G(5,r.IUserDataSyncLogService)],D);let U=class extends n.AbstractInitializer{constructor(F,z,X,K,Q,V,Y,x){super("extensions",K,Q,V,X,Y,x),this.extensionManagementService=F,this.ignoredExtensionsManagementService=z}async parseExtensions(F){return F.syncData?await C(F.syncData,this.extensionManagementService):null}generatePreview(F,z){const X=[],K=[],Q=[];for(const V of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(V.identifier.id))continue;const Y=z.find(x=>(0,u.areSameExtensions)(x.identifier,V.identifier));Y?(X.push(Y),V.disabled&&Q.push(V.identifier)):V.installed&&(K.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&Q.push(V.identifier))}return{installedExtensions:X,newExtensions:K,disabledExtensions:Q,remoteExtensions:F}}};e.AbstractExtensionsInitializer=U,e.AbstractExtensionsInitializer=U=Ee([G(0,S.IExtensionManagementService),G(1,t.IIgnoredExtensionsManagementService),G(2,E.IFileService),G(3,o.IUserDataProfilesService),G(4,P.IEnvironmentService),G(5,g.ILogService),G(6,l.IStorageService),G(7,i.IUriIdentityService)],U)}),define(le[116],ue([0,1,14,7,3,34,42,5,32,21,15,11,8,43,19,22,28,39,80,241,25,18,60,4]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",s=["locale"];function t(y,D){const U=y.storage?Object.keys(y.storage).sort():[],M={};return U.forEach(F=>M[F]=y.storage[F]),y.storage=M,D?(0,_.toFormattedString)(y,{}):JSON.stringify(y)}e.stringify=t;const r=1;let a=class extends c.AbstractSynchroniser{constructor(D,U,M,F,z,X,K,Q,V,Y,x,q,te,oe){super({syncResource:"globalState",profile:D},U,F,Q,q,z,X,V,Y,K,x,te),this.userDataProfileStorageService=M,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=oe.createInstance(C),this._register(F.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(F.onDidFilesChange,ee=>ee.contains(this.environmentService.argvResource)),A.Event.filter(M.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:B})=>this.syncResource.profile.id===ae.id&&B.some(W=>W.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,U,M){const F=D.syncData?JSON.parse(D.syncData.content):null;U=U===null&&M?D:U;const z=U&&U.syncData?JSON.parse(U.syncData.content):null,X=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.getStorageKeys(z),{local:Q,remote:V}=(0,g.merge)(X.storage,F?F.storage:null,z?z.storage:null,K,this.logService),Y={content:null,local:Q,remote:V,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:V.all!==null?2:0},x=t(X,!1);return[{baseResource:this.baseResource,baseContent:z?t(z,!1):x,localResource:this.localResource,localContent:x,localUserData:X,remoteResource:this.remoteResource,remoteContent:F?t(F,!1):null,previewResource:this.previewResource,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.acceptedResource,storageKeys:K}]}async hasRemoteChanged(D){const U=D.syncData?JSON.parse(D.syncData.content):null;if(U===null)return!0;const M=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),F=await this.getStorageKeys(U),{remote:z}=(0,g.merge)(M.storage,U.storage,U.storage,F,this.logService);return z.all!==null}async getMergeResult(D,U){return{...D.previewResult,hasConflicts:!1}}async getAcceptResult(D,U,M,F){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(D);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(D);if(this.extUri.isEqual(U,this.previewResource))return D.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(D){if(D.remoteContent!==null){const U=JSON.parse(D.remoteContent),{local:M,remote:F}=(0,g.merge)(D.localUserData.storage,U.storage,null,D.storageKeys,this.logService);return{content:D.remoteContent,local:M,remote:F,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(D,U,M,F){const{localUserData:z}=M[0][0],{local:X,remote:K,localChange:Q,remoteChange:V}=M[0][1];if(Q===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Q!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(z)),await this.localGlobalStateProvider.writeLocalGlobalState(X,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Y=JSON.stringify({storage:K.all});D=await this.updateRemoteUserData(Y,F?null:D.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}U?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(D){if(this.extUri.isEqual(this.remoteResource,D)||this.extUri.isEqual(this.baseResource,D)||this.extUri.isEqual(this.localResource,D)||this.extUri.isEqual(this.acceptedResource,D)){const U=await this.resolvePreviewContent(D);return U&&t(JSON.parse(U),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(D){const U=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),M=[],F=[];for(const[K,Q]of U)Q.target===0?M.push(K):Q.target===1&&F.push(K);const z=[...M,...F],X=D?.storage?Object.keys(D.storage).filter(K=>!K.startsWith(n)&&!z.includes(K)&&U.get(K)!==void 0):[];if(!R.isWeb){const K=[...l.ALL_SYNC_RESOURCES.map(Q=>(0,l.getEnablementKey)(Q)),l.SYNC_SERVICE_URL_TYPE];X.push(...K),F.push(...K)}return{user:M,machine:F,unregistered:X}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=Ee([G(2,i.IUserDataProfileStorageService),G(3,I.IFileService),G(4,l.IUserDataSyncStoreService),G(5,l.IUserDataSyncLocalStoreService),G(6,l.IUserDataSyncLogService),G(7,P.IEnvironmentService),G(8,l.IUserDataSyncEnablementService),G(9,v.ITelemetryService),G(10,m.IConfigurationService),G(11,f.IStorageService),G(12,E.IUriIdentityService),G(13,o.IInstantiationService)],a);let C=class{constructor(D,U,M,F){this.fileService=D,this.environmentService=U,this.userDataProfileStorageService=M,this.logService=F}async getLocalGlobalState(D){const U={};if(D.isDefault){const F=await this.getLocalArgvContent(),z=(0,T.parse)(F);for(const X of s)z[X]!==void 0&&(U[`${n}${X}`]={version:1,value:z[X]})}const M=await this.userDataProfileStorageService.readStorageData(D);for(const[F,z]of M)z.value&&z.target===0&&(U[F]={version:1,value:z.value});return{storage:U}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const D=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),D.value.toString()}catch(D){this.logService.debug((0,O.getErrorMessage)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:U,updated:M},F){const z=(0,c.getSyncResourceLogLabel)("globalState",F),X={},K=new Map,Q=await this.userDataProfileStorageService.readStorageData(F),V=(Y,x)=>{for(const q of Y){if(q.startsWith(n)){X[q.substring(n.length)]=x?x[q].value:void 0;continue}if(x){const te=x[q];te.value!==Q.get(q)?.value&&K.set(q,te.value)}else Q.get(q)!==void 0&&K.set(q,void 0)}};if(V(Object.keys(D),D),V(Object.keys(M),M),V(U),Object.keys(X).length){this.logService.trace(`${z}: Updating locale...`);const Y=await this.getLocalArgvContent();let x=Y;for(const q of Object.keys(X))x=(0,d.edit)(x,[q],X[q],{});Y!==x&&(this.logService.trace(`${z}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(x)),this.logService.info(`${z}: Updated locale.`)),this.logService.info(`${z}: Updated locale`)}K.size&&(this.logService.trace(`${z}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(F,K,0),this.logService.info(`${z}: Updated global state`,[...K.keys()]))}};e.LocalGlobalStateProvider=C,e.LocalGlobalStateProvider=C=Ee([G(0,I.IFileService),G(1,P.IEnvironmentService),G(2,i.IUserDataProfileStorageService),G(3,l.IUserDataSyncLogService)],C);let p=class extends c.AbstractInitializer{constructor(D,U,M,F,z,X){super("globalState",M,F,z,U,D,X)}async doInitialize(D){const U=D.syncData?JSON.parse(D.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},F={};for(const z of Object.keys(U.storage))z.startsWith(n)?M[z.substring(n.length)]=U.storage[z].value:this.storageService.get(z,0)===void 0&&(F[z]=U.storage[z].value);if(Object.keys(M).length){let z="{}";try{z=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const X of Object.keys(M))z=(0,d.edit)(z,[X],M[X],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(z))}if(Object.keys(F).length){const z=[];for(const X of Object.keys(F))z.push({key:X,value:F[X],scope:0,target:0});this.storageService.storeAll(z,!0)}}};e.GlobalStateInitializer=p,e.GlobalStateInitializer=p=Ee([G(0,f.IStorageService),G(1,I.IFileService),G(2,w.IUserDataProfilesService),G(3,P.IEnvironmentService),G(4,l.IUserDataSyncLogService),G(5,E.IUriIdentityService)],p);let h=class{constructor(D,U,M,F,z){this.userDataSyncStoreClient=D,this.storageService=U,this.environmentService=M,this.fileService=F,this.logService=z}getSyncStoreType(D){return this.parseGlobalState(D)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(D){const U=(0,l.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(D,U)}catch(M){if(M instanceof l.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(D,U)}throw M}}async doSync(D,U){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,U),F=this.parseGlobalState(M)||{storage:{}};F.storage[l.SYNC_SERVICE_URL_TYPE]={value:D,version:r};const z=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),X={version:r,machineId:z,content:t(F,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(X),M.ref,void 0,U)}parseGlobalState({content:D}){if(!D)return null;const U=JSON.parse(D);if((0,c.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=h,e.UserDataSyncStoreTypeSynchronizer=h=Ee([G(1,f.IStorageService),G(2,P.IEnvironmentService),G(3,I.IFileService),G(4,S.ILogService)],h)}),define(le[117],ue([0,1,17,14,3,34,5,12,173,21,15,11,19,22,28,18,39,238,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.isUndefined)(s.all)?null:s.all;switch(_.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.getKeybindingsContentFromSyncContent=g;let l=class extends E.AbstractJsonFileSynchroniser{constructor(o,n,s,t,r,a,C,p,h,y,D,U,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,p,h,y,s,t,C,U,r,D,a,M),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,s,t){const r=o.syncData?g(o.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,C=await this.getLocalFileContent(),p=await this.getFormattingOptions();let h=null,y=!1,D=!1,U=!1;if(r){let z=C?C.value.toString():"[]";if(z=z||"[]",this.hasErrors(z,!0))throw new d.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==z||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const X=await(0,c.merge)(z,r,a,p,this.userDataSyncUtilService);X.hasChanges&&(h=X.mergeContent,U=X.hasConflicts,y=U||X.mergeContent!==z,D=U||X.mergeContent!==r)}}else C&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=C.value.toString(),D=!0);const M={content:U?a:h,localChange:y?C?2:1:0,remoteChange:D?2:0,hasConflicts:U},F=C?C.value.toString():null;return[{fileContent:C,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:F,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const s=await this.getLocalFileContent(),t=s?s.value.toString():"",r=await this.getFormattingOptions(),a=await(0,c.merge)(t||"[]",n,n,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,s,t){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:C,remoteChange:p}=s[0][1];if(C===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new d.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(C!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const h=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(h,t?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,T.parse)(o.value.toString());if((0,L.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:g(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,_.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=l,e.KeybindingsSynchroniser=l=Ee([G(2,d.IUserDataSyncStoreService),G(3,d.IUserDataSyncLocalStoreService),G(4,d.IUserDataSyncLogService),G(5,m.IConfigurationService),G(6,d.IUserDataSyncEnablementService),G(7,I.IFileService),G(8,P.IEnvironmentService),G(9,S.IStorageService),G(10,d.IUserDataSyncUtilService),G(11,u.ITelemetryService),G(12,f.IUriIdentityService)],l);let w=class extends E.AbstractInitializer{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,O.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,T.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return g(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=w,e.KeybindingsInitializer=w=Ee([G(0,I.IFileService),G(1,v.IUserDataProfilesService),G(2,P.IEnvironmentService),G(3,d.IUserDataSyncLogService),G(4,S.IStorageService),G(5,f.IUriIdentityService)],w)}),define(le[118],ue([0,1,14,3,174,21,76,15,29,11,19,22,28,18,39,242,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function c(w){return w&&w.settings&&typeof w.settings=="string"&&Object.keys(w).length===1}function d(w){const i=JSON.parse(w);return c(i)?i:{settings:w}}e.parseSettingsSyncContent=d;let g=class extends f.AbstractJsonFileSynchroniser{constructor(i,o,n,s,t,r,a,C,p,h,y,D,U,M){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,y,D,C,p,h,M),this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(i,o),s=this.getSettingsSyncContent(n),t=new _.ConfigurationModelParser(E.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(E.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,o,n){const s=await this.getLocalFileContent(),t=await this.getFormattingOptions(),r=this.getSettingsSyncContent(i);o=o===null&&n?i:o;const a=o?this.getSettingsSyncContent(o):null,C=await this.getIgnoredSettings();let p=null,h=!1,y=!1,D=!1;if(r){let z=s?s.value.toString().trim():"{}";z=z||"{}",this.validateContent(z),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const X=(0,v.merge)(z,r.settings,a?a.settings:null,C,[],t);p=X.localContent||X.remoteContent,h=X.localContent!==null,y=X.remoteContent!==null,D=X.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),p=s.value.toString().trim()||"{}",this.validateContent(p),y=!0);const U=s?s.value.toString():null,M=a?.settings??null,F={content:D?M:p,localChange:h?2:0,remoteChange:y?2:0,hasConflicts:D};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:U,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const o=this.getSettingsSyncContent(i);if(o===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",t=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,v.merge)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async getMergeResult(i,o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,v.updateIgnoredSettings)(i.previewResult.content,"{}",s,n):null}}async getAcceptResult(i,o,n,s){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:i.fileContent?(0,v.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,v.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,v.updateIgnoredSettings)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:C}=n[0][1];if(a===0&&C===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),t&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(t.value.toString()))),await this.updateLocalFileContent(r,t,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),C!==0){const p=await this.getFormattingOptions(),h=this.getSettingsSyncContent(i),y=await this.getIgnoredSettings(r);r=(0,v.updateIgnoredSettings)(r,h?h.settings:"{}",y,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),s?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i)return!(0,v.isEmpty)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i)||this.extUri.isEqual(this.baseResource,i)?this.resolvePreviewContent(i):null}async resolvePreviewContent(i){let o=await super.resolvePreviewContent(i);if(o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();o=(0,v.updateIgnoredSettings)(o,"{}",s,n)}return o}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return d(i)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const o=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(o,this.configurationService,i)}validateContent(i){if(this.hasErrors(i,!1))throw new E.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=g,e.SettingsSynchroniser=g=Ee([G(2,m.IFileService),G(3,R.IEnvironmentService),G(4,P.IStorageService),G(5,E.IUserDataSyncStoreService),G(6,E.IUserDataSyncLocalStoreService),G(7,E.IUserDataSyncLogService),G(8,E.IUserDataSyncUtilService),G(9,T.IConfigurationService),G(10,E.IUserDataSyncEnablementService),G(11,I.ITelemetryService),G(12,b.IExtensionManagementService),G(13,S.IUriIdentityService)],g);let l=class extends f.AbstractInitializer{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async doInitialize(i){const o=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,L.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,v.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return d(i)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=l,e.SettingsInitializer=l=Ee([G(0,m.IFileService),G(1,u.IUserDataProfilesService),G(2,R.IEnvironmentService),G(3,E.IUserDataSyncLogService),G(4,P.IStorageService),G(5,S.IUriIdentityService)],l)}),define(le[119],ue([0,1,14,3,30,21,15,11,19,22,28,18,39,239,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function v(d){return JSON.parse(d.content)}e.parseSnippets=v;let E=class extends S.AbstractSynchroniser{constructor(g,l,w,i,o,n,s,t,r,a,C,p){super({syncResource:"snippets",profile:g},l,i,w,o,n,s,a,C,t,r,p),this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(w.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(O.Event.filter(this.fileService.onDidFilesChange,h=>h.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,l,w){const i=await this.getSnippetsFileContents(),o=this.toSnippetsContents(i),n=g.syncData?this.parseSnippets(g.syncData):null;l=l===null&&w?g:l;const s=l&&l.syncData?this.parseSnippets(l.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,u.merge)(o,n,s);return this.getResourcePreviews(t,i,n||{},s||{})}async hasRemoteChanged(g){const l=g.syncData?this.parseSnippets(g.syncData):null;if(l===null)return!0;const w=await this.getSnippetsFileContents(),i=this.toSnippetsContents(w),o=(0,u.merge)(i,l,l);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(g,l){return g.previewResult}async getAcceptResult(g,l,w,i){if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder))return w===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:w,localChange:w===null?g.fileContent!==null?3:0:2,remoteChange:w===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(g,l,w,i){const o=w.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,i)),o.some(({remoteChange:n})=>n!==0)&&(g=await this.updateRemoteSnippets(o,g,i)),l?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(g,l,w,i){const o=new Map;for(const n of Object.keys(g.local.added)){const s={content:g.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.local.updated)){const s={content:g.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.remote.added)){const s={content:g.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(g.remote.updated)){const s={content:g.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of g.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:l[n]?2:1,remoteChange:w[n]?2:1},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(l))if(!o.has(n)){const s={content:l[n]?l[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(g){return this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(g):null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const l={};for(const w of g)w.fileContent&&(l[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(l)))}async updateLocalSnippets(g,l){for(const{fileContent:w,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of g)if(s!==0){const t=n?this.extUri.basename(n):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,t);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,L.VSBuffer.fromString(i.content),{overwrite:l}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,L.VSBuffer.fromString(i.content),l?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(g,l,w){const i=l.syncData?this.parseSnippets(l.syncData):{},o=(0,A.deepClone)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of g)if(r!==0){const a=s?this.extUri.basename(s):this.extUri.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,u.areSame)(i,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),l=await this.updateRemoteUserData(JSON.stringify(o),w?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),l}parseSnippets(g){return v(g)}toSnippetsContents(g){const l={};for(const w of Object.keys(g))l[w]=g[w].value.toString();return l}async getSnippetsFileContents(){const g={};let l;try{l=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof R.FileOperationError&&w.fileOperationResult===1)return g;throw w}for(const w of l.children||[]){const i=w.resource,o=this.extUri.extname(i);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,i),s=await this.fileService.readFile(i);g[n]=s}}return g}};e.SnippetsSynchroniser=E,e.SnippetsSynchroniser=E=Ee([G(2,_.IEnvironmentService),G(3,R.IFileService),G(4,b.IStorageService),G(5,f.IUserDataSyncStoreService),G(6,f.IUserDataSyncLocalStoreService),G(7,f.IUserDataSyncLogService),G(8,T.IConfigurationService),G(9,f.IUserDataSyncEnablementService),G(10,m.ITelemetryService),G(11,P.IUriIdentityService)],E);let c=class extends S.AbstractInitializer{constructor(g,l,w,i,o,n){super("snippets",l,w,i,g,o,n)}async doInitialize(g){const l=g.syncData?JSON.parse(g.syncData.content):null;if(!l){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(l)){const o=l[i];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,i);await this.fileService.createFile(n,L.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};e.SnippetsInitializer=c,e.SnippetsInitializer=c=Ee([G(0,R.IFileService),G(1,I.IUserDataProfilesService),G(2,_.IEnvironmentService),G(3,f.IUserDataSyncLogService),G(4,b.IStorageService),G(5,P.IUriIdentityService)],c)}),define(le[120],ue([0,1,14,21,15,11,19,22,28,18,39,25]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(E,c){try{return JSON.parse(E).tasks??null}catch(d){return c.error(d),null}}e.getTasksContentFromSyncContent=S;let u=class extends P.AbstractFileSynchroniser{constructor(c,d,g,l,w,i,o,n,s,t,r,a){super(c.tasksResource,{syncResource:"tasks",profile:c},d,n,s,t,g,l,o,r,w,i,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(c,d,g,l){const w=c.syncData?S(c.syncData.content,this.logService):null;d=d===null&&g?c:d;const i=d?.syncData?S(d.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,s=!1,t=!1,r=!1;if(c.syncData){const p=o?o.value.toString():null;if(!i||i!==p||i!==w){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const h=v(p,w,i);n=h.content,r=h.hasConflicts,s=h.hasLocalChanged,t=h.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},C=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:C,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:w,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(c){const d=c?.syncData?S(c.syncData.content,this.logService):null;if(d===null)return!0;const g=await this.getLocalFileContent(),l=g?g.value.toString():null,w=v(l,d,d);return w.hasLocalChanged||w.hasRemoteChanged}async getMergeResult(c,d){return c.previewResult}async getAcceptResult(c,d,g,l){if(this.extUri.isEqual(d,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(d,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(d,this.previewResource))return g===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(c,d,g,l){const{fileContent:w}=g[0][0],{content:i,localChange:o,remoteChange:n}=g[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),w&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(w.value.toString()))),i?await this.updateLocalFileContent(i,w,l):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(i));c=await this.updateRemoteUserData(s,l?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}d?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(c),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(c){return this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.baseResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c)?this.resolvePreviewContent(c):null}toTasksSyncContent(c){return c?{tasks:c}:{}}};e.TasksSynchroniser=u,e.TasksSynchroniser=u=Ee([G(2,I.IUserDataSyncStoreService),G(3,I.IUserDataSyncLocalStoreService),G(4,I.IUserDataSyncLogService),G(5,O.IConfigurationService),G(6,I.IUserDataSyncEnablementService),G(7,T.IFileService),G(8,A.IEnvironmentService),G(9,_.IStorageService),G(10,R.ITelemetryService),G(11,b.IUriIdentityService)],u);let f=class extends P.AbstractInitializer{constructor(c,d,g,l,w,i){super("tasks",d,g,l,c,w,i),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(c){const d=c.syncData?S(c.syncData.content,this.logService):null;if(!d){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,L.VSBuffer.fromString(d)),await this.updateLastSyncUserData(c)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=f,e.TasksInitializer=f=Ee([G(0,T.IFileService),G(1,m.IUserDataProfilesService),G(2,A.IEnvironmentService),G(3,I.IUserDataSyncLogService),G(4,_.IStorageService),G(5,b.IUriIdentityService)],f);function v(E,c,d){if(E===null&&c===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=d!==E,l=d!==c;return!g&&!l?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!l?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:l&&!g?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],ue([0,1,42,21,15,11,19,22,28,18,39,240,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let u=class extends P.AbstractSynchroniser{constructor(c,d,g,l,w,i,o,n,s,t,r,a,C){super({syncResource:"profiles",profile:c},d,l,w,i,o,n,r,a,s,t,C),this.userDataProfilesService=g,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?v(c.syncData):null}async getRemoteSyncedProfiles(c){const d=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(c,d);return g?.syncData?v(g.syncData):null}async generateSyncPreview(c,d,g){if(!this.userDataProfilesService.isEnabled())throw new S.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const l=c.syncData?v(c.syncData):null,w=d?.syncData?v(d.syncData):null,i=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,I.merge)(i,l,w,[]),s={local:o,remote:n,content:w?this.stringifyRemoteProfiles(w):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=f(i,!1);return[{baseResource:this.baseResource,baseContent:w?this.stringifyRemoteProfiles(w):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:l?this.stringifyRemoteProfiles(l):null,remoteProfiles:l,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(c){const d=c?.syncData?v(c.syncData):null,g=this.getLocalUserDataProfiles(),{remote:l}=(0,I.merge)(g,d,d,[]);return!!l?.added.length||!!l?.removed.length||!!l?.updated.length}async getMergeResult(c,d){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,d,g,l){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(d,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(c){const d=this.getLocalUserDataProfiles(),g=(0,I.merge)(d,null,null,[]),{local:l,remote:w}=g;return{content:c.localContent,local:l,remote:w,localChange:l.added.length>0||l.removed.length>0||l.updated.length>0?2:0,remoteChange:w!==null?2:0}}async acceptRemote(c){const d=c.remoteContent?JSON.parse(c.remoteContent):null,g=[],l=[];for(const w of this.getLocalUserDataProfiles()){const i=d?.find(o=>o.id===w.id);i&&(g.push({id:w.id,name:w.name,collection:i.collection}),l.push(w))}if(d!==null){const w=(0,I.merge)(l,d,g,[]),{local:i,remote:o}=w;return{content:c.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,d,g,l){const{local:w,remote:i,localChange:o,remoteChange:n}=g[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const s=g[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new S.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const t=[];for(const r of w.added)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of w.removed)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of w.updated){const a=this.userDataProfilesService.profiles.find(C=>C.id===r.id);a?t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const C=await this.userDataSyncStoreService.createCollection(this.syncHeaders);t.push(C),s.push({id:a.id,name:a.name,collection:C,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:C})=>a.id===C),1);for(const a of i?.updated||[]){const C=s.find(({id:p})=>a.id===p);C&&s.splice(s.indexOf(C),1,{...C,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{c=await this.updateRemoteProfiles(s,l?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const C of t)await this.userDataSyncStoreService.deleteCollection(C,this.syncHeaders)}throw a}for(const a of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}d?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(c),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,d){return this.updateRemoteUserData(this.stringifyRemoteProfiles(c),d)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.baseResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c)){const d=await this.resolvePreviewContent(c);return d&&(0,L.toFormattedString)(JSON.parse(d),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(c=>!c.isDefault&&!c.isTransient)}stringifyRemoteProfiles(c){return JSON.stringify([...c].sort((d,g)=>d.name.localeCompare(g.name)))}};e.UserDataProfilesManifestSynchroniser=u,e.UserDataProfilesManifestSynchroniser=u=Ee([G(2,m.IUserDataProfilesService),G(3,T.IFileService),G(4,A.IEnvironmentService),G(5,_.IStorageService),G(6,S.IUserDataSyncStoreService),G(7,S.IUserDataSyncLocalStoreService),G(8,S.IUserDataSyncLogService),G(9,O.IConfigurationService),G(10,S.IUserDataSyncEnablementService),G(11,R.ITelemetryService),G(12,b.IUriIdentityService)],u);function f(E,c){const d=[...E].sort((g,l)=>g.name.localeCompare(l.name)).map(g=>({id:g.id,name:g.name}));return c?(0,L.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=f;function v(E){return JSON.parse(E.content)}e.parseUserDataProfilesManifest=v}),define(le[257],ue([0,1,3,2,5,15,19,22,25]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const m="sync.enable";let P=class extends O.Disposable{constructor(S,u,f,v){super(),this.storageService=S,this.telemetryService=u,this.environmentService=f,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(-1,void 0,this._register(new O.DisposableStore))(E=>this.onDidStorageChange(E)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(m,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(m,{enabled:S}),this.storageService.store(m,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,b.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,u){if(this.isResourceEnabled(S)!==u){const f=(0,b.getEnablementKey)(S);this.storeResourceEnablement(f,u)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,u){this.storageService.store(S,u,-1,A.isWeb?0:1)}onDidStorageChange(S){if(m===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const u=b.ALL_SYNC_RESOURCES.filter(f=>(0,b.getEnablementKey)(f)===S.key)[0];if(u){this._onDidChangeResourceEnablement.fire([u,this.isResourceEnabled(u)]);return}}};e.UserDataSyncEnablementService=P,e.UserDataSyncEnablementService=P=Ee([G(0,_.IStorageService),G(1,R.ITelemetryService),G(2,T.IEnvironmentService),G(3,b.IUserDataSyncStoreManagementService)],P)}),define(le[258],ue([0,1,6,14,65,2,20,21,15,11,18,25]),function(se,e,L,O,A,T,_,R,b,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let S=class extends T.Disposable{constructor(f,v,E,c,d){super(),this.environmentService=f,this.fileService=v,this.configurationService=E,this.logService=c,this.userDataProfilesService=d,this.cleanUp()}async cleanUp(){for(const v of this.userDataProfilesService.profiles)for(const E of I.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(E,v.isDefault?void 0:v.id))}catch(c){this.logService.error(c)}let f;try{f=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(v){(0,m.toFileOperationResult)(v)!==1&&this.logService.error(v);return}if(f.children){for(const v of f.children)if(v.isDirectory&&!this.userDataProfilesService.profiles.some(E=>E.id===v.name))try{this.logService.info("Deleting non existing profile from backup",v.resource.path),await this.fileService.del(v.resource,{recursive:!0})}catch(E){this.logService.error(E)}}}async getAllResourceRefs(f,v,E){const c=this.getResourceBackupHome(f,v,E);try{const d=await this.fileService.resolve(c);if(d.children)return d.children.filter(l=>l.isFile&&!l.name.startsWith("lastSync")).sort().reverse().map(l=>({ref:l.name,created:this.getCreationTime(l)}))}catch(d){if((0,m.toFileOperationResult)(d)!==1)throw d}return[]}async resolveResourceContent(f,v,E,c){const d=this.getResourceBackupHome(f,E,c),g=(0,_.joinPath)(d,v);try{return(await this.fileService.readFile(g)).value.toString()}catch(l){return this.logService.error(l),null}}async writeResource(f,v,E,c,d){const g=this.getResourceBackupHome(f,c,d),l=(0,_.joinPath)(g,`${(0,A.toLocalISOString)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(l,O.VSBuffer.fromString(v))}catch(w){this.logService.error(w)}}getResourceBackupHome(f,v,E=this.environmentService.userDataSyncHome){return(0,_.joinPath)(E,...v?[v,f]:[f])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const v=await this.fileService.resolve(f);if(v.children){const E=v.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),c=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let d=E.filter(l=>Date.now()-this.getCreationTime(l)>c);const g=E.length-d.length;g<10&&(d=d.slice(10-g)),await L.Promises.settled(d.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(f){return new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=S,e.UserDataSyncLocalStoreService=S=Ee([G(0,b.IEnvironmentService),G(1,m.IFileService),G(2,R.IConfigurationService),G(3,I.IUserDataSyncLogService),G(4,P.IUserDataProfilesService)],S)}),define(le[84],ue([0,1,3,2,5,27,178,15,11,4,24,43,19,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,m.createDecorator)("IUserDataSyncMachinesService");const v="sync.currentMachineName",E="Safari",c="Chrome",d="Edge",g="Firefox",l="Android";function w(n){switch(n){case E:case c:case d:case g:case l:case(0,A.PlatformToString)(0):return!0}return!1}e.isWebPlatform=w;function i(){return A.isSafari?E:A.isChrome?c:A.isEdge?d:A.isFirefox?g:A.isAndroid?l:(0,A.PlatformToString)(A.isWeb?0:A.platform)}let o=class extends O.Disposable{static{f=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(s,t,r,a,C,p){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=C,this.productService=p,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(s,t,r)}async getMachines(s){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.computeCurrentMachineName(r.machines),platform:i()}),await this.writeMachinesData(r))}async removeCurrentMachine(s){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(s),a=r.machines.filter(({id:C})=>C!==t);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(s,t,r){const a=await this.readMachinesData(r),C=a.machines.find(({id:p})=>p===s);if(C){C.name=t,await this.writeMachinesData(a);const p=await this.currentMachineIdPromise;s===p&&this.storageService.store(v,t,-1,1)}}async setEnablements(s){const t=await this.readMachinesData();for(const[r,a]of s){const C=t.machines.find(p=>p.id===r);C&&(C.disabled=a?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(s){const t=this.storageService.get(v,-1);if(t)return t;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${i()} (${this.productService.nameShort})`,a=new RegExp(`${(0,T.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let C=0;for(const p of s){const h=a.exec(p.name),y=h?parseInt(h[1]):0;C=y>C?y:C}return`${r} #${C+1}`}async readMachinesData(s){this.userData=await this.readUserData(s);const t=this.parse(this.userData);if(t.version!==f.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(s){const t=JSON.stringify(s),r=await this.userDataSyncStoreService.writeResource(f.RESOURCE,t,this.userData?.ref||null);this.userData={ref:r,content:t},this._onDidChange.fire()}async readUserData(s){if(this.userData){const t=s&&s.latest?s.latest[f.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(f.RESOURCE,this.userData)}parse(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.logService.error(t)}return{version:f.VERSION,machines:[]}}};e.UserDataSyncMachinesService=o,e.UserDataSyncMachinesService=o=f=Ee([G(0,R.IEnvironmentService),G(1,b.IFileService),G(2,S.IStorageService),G(3,u.IUserDataSyncStoreService),G(4,u.IUserDataSyncLogService),G(5,P.IProductService)],o)}),define(le[259],ue([0,1,6,65,38,7,3,2,5,20,10,175,24,19,22,25,81,84]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",g="sync.sessionId",l="sync.storeUrl",w="sync.productQuality";let i=class extends R.Disposable{get syncUrl(){const s=this.storageService.get(l,-1);return s?P.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(l,s.toString(),-1,1):this.storageService.remove(l,-1)}get productQuality(){return this.storageService.get(w,-1)}set productQuality(s){s?this.storageService.store(w,s,-1,1):this.storageService.remove(w,-1)}constructor(s,t,r,a,C,p,h,y,D,U){super(),this.userDataSyncStoreManagementService=t,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=C,this.logService=p,this.userDataSyncAccountService=h,this.telemetryService=y,this.userDataSyncMachinesService=D,this.storageService=U,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(t.onDidChangeUserDataSyncStore(()=>{(0,m.isEqual)(this.syncUrl,t.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(h.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(C.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:t}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(t&&this.logService.info(t),this.autoSync.clear()):t&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(t))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,t,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),t)this.updateEnablement(!1);else throw a}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const t=v.UserDataSyncError.toUserDataSyncError(s);t instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:t.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?b.isWeb&&t.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(t),this.successiveFailures++),this._onError.fire(t)}async disableMachineEventually(){this.storageService.store(d,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(d,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(d,-1)}async triggerSync(s,t,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(t&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=i,e.UserDataAutoSyncService=i=Ee([G(0,S.IProductService),G(1,v.IUserDataSyncStoreManagementService),G(2,v.IUserDataSyncStoreService),G(3,v.IUserDataSyncEnablementService),G(4,v.IUserDataSyncService),G(5,v.IUserDataSyncLogService),G(6,E.IUserDataSyncAccountService),G(7,f.ITelemetryService),G(8,c.IUserDataSyncMachinesService),G(9,u.IStorageService)],i);class o extends R.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(s,t,r,a,C,p,h,y,D){super(),this.lastSyncUrl=s,this.interval=t,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=C,this.userDataSyncMachinesService=p,this.logService=h,this.telemetryService=y,this.storageService=D,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>{this.sync(o.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(s,t){const r=(0,L.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(C){if((0,T.isCancellationError)(C))return}return this.doSync(s,t,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,m.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),t=this.userDataSyncStoreManagementService.userDataSyncStore;return!!t&&!!s&&(!(0,m.isEqual)(t.defaultUrl,s.defaultUrl)||!(0,m.isEqual)(t.insidersUrl,s.insidersUrl)||!(0,m.isEqual)(t.stableUrl,s.stableUrl))}async doSync(s,t,r){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(t,r)}catch(C){if(this.logService.error(C),a=C,v.UserDataSyncError.toUserDataSyncError(C).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(t,r),a=void 0}catch(p){this.logService.error(p),a=p}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(s,t){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),t.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const r=this.storageService.get(g,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(t.isCancellationRequested)return;const C=a.find(h=>h.isCurrent);if(C?.disabled)throw new v.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");const p=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-p}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(h){throw new v.UserDataAutoSyncError((0,A.toErrorMessage)(h),h instanceof v.UserDataSyncError?h.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(g,this.manifest.session,-1,1),!t.isCancellationRequested&&(C||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(s){return super._register(s)}}}),define(le[260],ue([0,1,10,179,15,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{o=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(t,r,a,C,p,h,y,D,U,M){this.userDataSyncStoreService=t,this.userDataSyncLocalStoreService=r,this.logService=a,this.environmentService=p,this.storageService=h,this.fileService=y,this.userDataProfilesService=D,this.configurationService=U,this.instantiationService=M,this.extUri=C.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,l.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const C=this.parseSyncData(a,"profiles");return(0,l.parseUserDataProfilesManifest)(C)}}return[]}async getLocalSyncedMachines(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(p=>({...p,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:C,ref:p})=>({created:C,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:p,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(t,r?.collection,a)).map(({created:p,ref:h})=>({created:p,uri:this.toUri({remote:!1,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:h,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),a=r?this.userDataProfilesService.profiles.find(C=>C.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const a=this.userDataProfilesService.profiles.find(C=>C.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,a);case"keybindings":return this.getKeybindingsAssociatedResources(t,a);case"tasks":return this.getTasksAssociatedResources(t,a);case"snippets":return this.getSnippetsAssociatedResources(t,a);case"globalState":return this.getGlobalStateAssociatedResources(t,a);case"extensions":return this.getExtensionsAssociatedResources(t,a);case"profiles":return this.getProfilesAssociatedResources(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.getUserData(r.syncResource,r.ref,r.collection);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===o.NOT_EXISTING_RESOURCE)return null;if(r.ref){const a=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.resolveNodeContent(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,a,C,p){if(t){const{content:h}=await this.getUserData(r,C,a);return h}return this.userDataSyncLocalStoreService.resolveResourceContent(r,C,a,p)}resolveNodeContent(t,r,a){const C=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(C,a);case"keybindings":return this.resolveKeybindingsNodeContent(C,a);case"tasks":return this.resolveTasksNodeContent(C,a);case"snippets":return this.resolveSnippetsNodeContent(C,a);case"globalState":return this.resolveGlobalStateNodeContent(C,a);case"extensions":return this.resolveExtensionsNodeContent(C,a);case"profiles":return this.resolveProfileNodeContent(C,a);case"workspaceState":return null}}async resolveLatestContent(t,r){const a=this.userDataProfilesService.profiles.find(C=>C.id===r);if(!a)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(a);case"extensions":return this.resolveLatestExtensionsContent(a);case"profiles":return this.resolveLatestProfilesContent(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"settings.json"),C=r?r.settingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,u.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"keybindings.json"),C=r?r.keybindingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const a=this.extUri.joinPath(t,"tasks.json"),C=r?r.tasksResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,E.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const a=await this.resolveContent(t);if(a){const C=this.parseSyncData(a,"snippets");if(C){const p=(0,S.parseSnippets)(C),h=[];for(const y of Object.keys(p)){const D=this.extUri.joinPath(t,y),U=r?this.extUri.joinPath(r.snippetsHome,y):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);h.push({resource:D,comparableResource:U})}return h}}return[]}resolveSnippetsNodeContent(t,r){return(0,S.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"extensions.json"),C=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,c.stringify)((0,c.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(c.LocalExtensionsProvider).getLocalExtensions(t);return(0,c.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const a=this.extUri.joinPath(t,"globalState.json"),C=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:C}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const a=this.extUri.joinPath(t,"profiles.json"),C=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:C}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,w.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,l.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?o.REMOTE_BACKUP_AUTHORITY:o.LOCAL_BACKUP_AUTHORITY,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.trim)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.extUri.joinPath(L.URI.from({scheme:m.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}resolveUri(t){if(t.scheme!==m.USER_DATA_SYNC_SCHEME)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const a=t.authority===o.REMOTE_BACKUP_AUTHORITY;let C,p;const h=[];let y,D,U,M,F;for(;r.length;){const z=r.shift();z.startsWith("scheme:")?C=z.substring(7):z.startsWith("authority:")?p=z.substring(10):z.startsWith("syncResource:")?y=z.substring(13):z.startsWith("profile:")?D=z.substring(8):z.startsWith("collection:")?U=z.substring(11):z.startsWith("ref:")?M=z.substring(4):y?F=z:h.push(z)}return{remote:a,syncResource:y,profile:D,collection:U,ref:M,node:F,location:C&&p!==void 0?this.extUri.joinPath(L.URI.from({scheme:C,authority:p,query:t.query,fragment:t.fragment,path:"/"}),...h):void 0}}parseSyncData(t,r){try{const a=JSON.parse(t);if((0,I.isSyncData)(a))return a}catch(a){this.logService.error(a)}throw new m.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,a){const C=await this.userDataSyncStoreService.resolveResourceContent(t,r,a);return{ref:r,content:C}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=o=Ee([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncLocalStoreService),G(2,m.IUserDataSyncLogService),G(3,b.IUriIdentityService),G(4,A.IEnvironmentService),G(5,R.IStorageService),G(6,T.IFileService),G(7,P.IUserDataProfilesService),G(8,v.IConfigurationService),G(9,g.IInstantiationService)],n)}),define(le[261],ue([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(y,D,U,M,F,z,X,K,Q,V,Y){super(),this.fileService=y,this.userDataSyncStoreService=D,this.userDataSyncStoreManagementService=U,this.instantiationService=M,this.logService=F,this.telemetryService=z,this.storageService=X,this.userDataSyncEnablementService=K,this.userDataProfilesService=Q,this.userDataSyncResourceProviderService=V,this.userDataSyncLocalStoreService=Y,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=U.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(y,D){this.checkEnablement(),this.logService.info("Sync started.");const U=new Date().getTime(),M=(0,P.generateUuid)();try{const K=(0,s.createSyncHeaders)(M);D&&(K["Cache-Control"]="no-cache"),y=await this.userDataSyncStoreService.manifest(y,K)}catch(K){const Q=s.UserDataSyncError.toUserDataSyncError(K);throw p(Q,M,this.userDataSyncStoreManagementService,this.telemetryService),Q}const F=!1,z=this;let X;return{manifest:y,async run(){if(F)throw new Error("Can run a task only once");X=(0,O.createCancelablePromise)(K=>z.sync(y,!1,M,K)),await X.finally(()=>X=void 0),z.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),z.updateLastSyncTime()},stop(){return X?.cancel(),z.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const y=new Date().getTime(),D=(0,P.generateUuid)(),U=(0,s.createSyncHeaders)(D);let M;try{M=await this.userDataSyncStoreService.manifest(null,U)}catch(X){const K=s.UserDataSyncError.toUserDataSyncError(X);throw p(K,D,this.userDataSyncStoreManagementService,this.telemetryService),K}await this.resetLocal();const F=this,z=new A.CancellationTokenSource;return{id:D,async merge(){return F.sync(M,!0,D,z.token)},async apply(){try{try{await F.applyManualSync(M,D,z.token)}catch(X){if(s.UserDataSyncError.toUserDataSyncError(X).code==="MethodNotFound")F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(M,D,z.token);else throw X}}catch(X){throw F.logService.error(X),X}F.logService.info(`Sync done. Took ${new Date().getTime()-y}ms`),F.updateLastSyncTime()},async stop(){z.cancel(),await F.stop(),await F.resetLocal()}}}async sync(y,D,U,M){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,y,D,U,M));const z=F.enabled.find(X=>X.resource==="profiles");if(z){const X=await z.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.syncRemoteProfiles(X,y,D,U,M)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(y,D,U,M,F){for(const z of y){if(F.isCancellationRequested)return;const X=this.userDataProfilesService.profiles.find(Q=>Q.id===z.id);if(!X){this.logService.error(`Profile with id:${z.id} and name: ${z.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",z.name);const K=this.getOrCreateActiveProfileSynchronizer(X,z);this._syncErrors.push(...await this.syncProfile(K,D,U,M,F))}for(const[z,X]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(K=>K.id===X[0].profile.id)||(X[1].dispose(),this.activeProfileSynchronizers.delete(z))}async applyManualSync(y,D,U){const M=this.getActiveProfileSynchronizers();for(const Q of M){if(U.isCancellationRequested)return;await Q.apply(D,U)}const F=M.find(Q=>Q.profile.isDefault);if(!F)return;const z=F.enabled.find(Q=>Q.resource==="profiles");if(!z)return;const K=(await z.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(Q=>M.every(V=>V.profile.id!==Q.id));K.length&&await this.syncRemoteProfiles(K,y,!1,D,U)}async syncProfile(y,D,U,M,F){return(await y.sync(D,U,M,F)).map(([X,K])=>({profile:y.profile,syncResource:X,error:K}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(y=>y.stop()))}async resolveContent(y){const D=await this.userDataSyncResourceProviderService.resolveContent(y);if(D)return D;for(const U of this.getActiveProfileSynchronizers())for(const M of U.enabled){const F=await M.resolveContent(y);if(F)return F}return null}async replace(y){this.checkEnablement();const D=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(y);if(!D)return;const U=await this.resolveContent(y.uri);U&&await this.performAction(D.profile,async M=>{if(D.syncResource===M.resource)return await M.replace(U),!0})}async accept(y,D,U,M){this.checkEnablement(),await this.performAction(y.profile,async F=>{if(y.syncResource===F.resource)return await F.accept(D,U),M&&await F.apply((0,m.isBoolean)(M)?!1:M.force,(0,s.createSyncHeaders)((0,P.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(y){this.logService.error(y)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[y]of this.activeProfileSynchronizers.values())try{await y.resetLocal()}catch(D){this.logService.error(D)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),D=y.map(z=>z.collection),U=await this.userDataSyncStoreService.getAllCollections(),M=U.filter(z=>!D.includes(z));M.length&&(this.logService.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(z=>this.userDataSyncStoreService.deleteCollection(z))),this.logService.info("Deleted redundant collections on server"));const F=y.filter(z=>U.includes(z.collection));if(F.length!==y.length){const z=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await z.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await z.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{z.dispose()}}}async saveRemoteActivityData(y){this.checkEnablement();const D=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(y,D)}async extractActivityData(y,D){const U=(await this.fileService.readFile(y)).value.toString(),M=JSON.parse(U);if(M.resources)for(const F in M.resources)for(const z of M.resources[F])await this.userDataSyncLocalStoreService.writeResource(F,z.content,new Date(z.created*1e3),void 0,D);if(M.collections)for(const F in M.collections)for(const z in M.collections[F].resources)for(const X of M.collections[F].resources?.[z]??[])await this.userDataSyncLocalStoreService.writeResource(z,X.content,new Date(X.created*1e3),F,D)}async performAction(y,D){const U=new R.DisposableStore;try{const M=this.activeProfileSynchronizers.get(y.id);if(M){const Q=await this.performActionWithProfileSynchronizer(M[0],D,U);return(0,m.isUndefined)(Q)?null:Q}if(y.isDefault){const Q=U.add(this.instantiationService.createInstance(a,y,void 0)),V=await this.performActionWithProfileSynchronizer(Q,D,U);return(0,m.isUndefined)(V)?null:V}if(this.userDataProfilesService.isEnabled())return null;const F=U.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,y,void 0)),z=await this.userDataSyncStoreService.manifest(null),K=(await F.getRemoteSyncedProfiles(z?.latest??null)||[]).find(Q=>Q.id===y.id);if(K){const Q=U.add(this.instantiationService.createInstance(a,y,K.collection)),V=await this.performActionWithProfileSynchronizer(Q,D,U);return(0,m.isUndefined)(V)?null:V}return null}finally{U.dispose()}}async performActionWithProfileSynchronizer(y,D,U){const M=[...y.enabled,...y.disabled.reduce((F,z)=>(z!=="workspaceState"&&F.push(U.add(y.createSynchronizer(z))),F),[])];for(const F of M){const z=await D(F);if(!(0,m.isUndefined)(z))return z}}setStatus(y){const D=this._status;this._status!==y&&(this._status=y,this._onDidChangeStatus.fire(y),D==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const y=this.getActiveProfileSynchronizers().map(D=>D.conflicts).flat();(0,L.equals)(this._conflicts,y,(D,U)=>D.profile.id===U.profile.id&&D.syncResource===U.syncResource&&(0,L.equals)(D.conflicts,U.conflicts,(M,F)=>(0,b.isEqual)(M.previewResource,F.previewResource)))||(this._conflicts=y,this._onDidChangeConflicts.fire(y))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(y,D){let U=this.activeProfileSynchronizers.get(y.id);if(U&&U[0].collection!==D?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),U[1].dispose(),U=void 0,this.activeProfileSynchronizers.delete(y.id)),!U){const M=new R.DisposableStore,F=M.add(this.instantiationService.createInstance(a,y,D?.collection));M.add(F.onDidChangeStatus(z=>this.setStatus(z))),M.add(F.onDidChangeConflicts(z=>this.updateConflicts())),M.add(F.onDidChangeLocal(z=>this._onDidChangeLocal.fire(z))),this.activeProfileSynchronizers.set(y.id,U=[F,M])}return U[0]}getActiveProfileSynchronizers(){const y=[];for(const[D]of this.activeProfileSynchronizers.values())y.push(D);return y}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,y])=>y.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=Ee([G(0,u.IFileService),G(1,s.IUserDataSyncStoreService),G(2,s.IUserDataSyncStoreManagementService),G(3,f.IInstantiationService),G(4,s.IUserDataSyncLogService),G(5,E.ITelemetryService),G(6,v.IStorageService),G(7,s.IUserDataSyncEnablementService),G(8,c.IUserDataProfilesService),G(9,s.IUserDataSyncResourceProviderService),G(10,s.IUserDataSyncLocalStoreService)],r);let a=class extends R.Disposable{get enabled(){return this._enabled.sort((y,D)=>y[1]-D[1]).map(([y])=>y)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(y=>!this.userDataSyncEnablementService.isResourceEnabled(y))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(y,D,U,M,F,z,X,K,Q,V){super(),this.profile=y,this.collection=D,this.userDataSyncEnablementService=U,this.instantiationService=M,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=z,this.telemetryService=X,this.logService=K,this.userDataProfilesService=Q,this.configurationService=V,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(U.onDidChangeResourceEnablement(([Y,x])=>this.onDidChangeResourceEnablement(Y,x))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,Y])=>Y.dispose())));for(const Y of s.ALL_SYNC_RESOURCES)U.isResourceEnabled(Y)&&this.registerSynchronizer(Y)}onDidChangeResourceEnablement(y,D){D?this.registerSynchronizer(y):this.deRegisterSynchronizer(y)}registerSynchronizer(y){if(this._enabled.some(([F])=>F.resource===y))return;if(y==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||y==="workspaceState")return;if(y!=="profiles"&&this.profile.useDefaultFlags?.[y]){this.logService.debug(`Skipping syncing ${y} in ${this.profile.name} because it is already synced by default profile`);return}const D=new R.DisposableStore,U=D.add(this.createSynchronizer(y));D.add(U.onDidChangeStatus(()=>this.updateStatus())),D.add(U.onDidChangeConflicts(()=>this.updateConflicts())),D.add(U.onDidChangeLocal(()=>this._onDidChangeLocal.fire(y)));const M=this.getOrder(y);this._enabled.push([U,M,D])}deRegisterSynchronizer(y){const D=this._enabled.findIndex(([U])=>U.resource===y);if(D!==-1){const[[U,,M]]=this._enabled.splice(D,1);M.dispose(),this.updateStatus(),Promise.allSettled([U.stop(),U.resetLocal()]).then(null,F=>this.logService.error(F))}}createSynchronizer(y){switch(y){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(l.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(i.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(o.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(g.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(d.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(y,D,U,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const z=[],X=(0,s.createSyncHeaders)(U),K=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,Q=D?await this.getUserDataSyncConfiguration(K):{};for(const V of F){if(M.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(V.resource))return[];try{if(D){const Y=await V.preview(K,Q,X);if(Y)for(const x of Y.resourcePreviews)(x.localChange!==0||x.remoteChange!==0)&&x.mergeState==="preview"&&await V.merge(x.previewResource)}else await V.sync(K,X)}catch(Y){const x=s.UserDataSyncError.toUserDataSyncError(Y);if(p(x,U,this.userDataSyncStoreManagementService,this.telemetryService),C(Y))throw x;this.logService.error(Y),this.logService.error(`${V.resource}: ${(0,T.toErrorMessage)(Y)}`),z.push([V.resource,x])}}return z}finally{this.updateStatus()}}async apply(y,D){const U=(0,s.createSyncHeaders)(y);for(const M of this.enabled){if(D.isCancellationRequested)return;try{await M.apply(!1,U)}catch(F){const z=s.UserDataSyncError.toUserDataSyncError(F);if(p(z,y,this.userDataSyncStoreManagementService,this.telemetryService),C(F))throw z;this.logService.error(F),this.logService.error(`${M.resource}: ${(0,T.toErrorMessage)(F)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(D){this.logService.error(D)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(D){this.logService.error(`${y.resource}: ${(0,T.toErrorMessage)(D)}`),this.logService.error(D)}}async getUserDataSyncConfiguration(y){if(!this.profile.isDefault)return{};const D=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),U=this.enabled.find(M=>M instanceof w.SettingsSynchroniser);if(U){const M=await U.getRemoteUserDataSyncConfiguration(y);return{...D,...M}}return D}setStatus(y){this._status!==y&&(this._status=y,this._onDidChangeStatus.fire(y))}updateStatus(){return this.updateConflicts(),this.enabled.some(y=>y.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const y=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,L.equals)(this._conflicts,y,(D,U)=>D.syncResource===U.syncResource&&(0,L.equals)(D.conflicts,U.conflicts,(M,F)=>(0,b.isEqual)(M.previewResource,F.previewResource)))||(this._conflicts=y,this._onDidChangeConflicts.fire(y))}getOrder(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ee([G(2,s.IUserDataSyncEnablementService),G(3,f.IInstantiationService),G(4,S.IExtensionGalleryService),G(5,s.IUserDataSyncStoreManagementService),G(6,E.ITelemetryService),G(7,s.IUserDataSyncLogService),G(8,c.IUserDataProfilesService),G(9,I.IConfigurationService)],a);function C(h){if(h instanceof s.UserDataSyncError)switch(h.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function p(h,y,D,U){U.publicLog2("sync/error",{code:h.code,serverCode:h instanceof s.UserDataSyncStoreError?String(h.serverCode):void 0,url:h instanceof s.UserDataSyncStoreError?h.url:void 0,resource:h.resource,executionId:y,service:D.userDataSyncStore.url.toString()})}}),define(le[262],ue([0,1,3,2,10,18,25]),function(se,e,L,O,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function R(S,u){return{...S,profile:(0,T.reviveProfile)(S.profile,u.profilesHome.scheme)}}function b(S){return{created:S.created,uri:A.URI.revive(S.uri)}}class m{constructor(u,f,v){this.service=u,this.userDataProfilesService=f,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(u,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${f}`)}async call(u,f,v){try{return await this._call(u,f,v)}catch(E){throw this.logService.error(E),E}}async _call(u,f,v){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(A.URI.revive(v[0]));case"accept":return this.service.accept(R(v[0],this.userDataProfilesService),A.URI.revive(v[1]),v[2],v[3]);case"replace":return this.service.replace(b(v[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(A.URI.revive(v[0]));case"extractActivityData":return this.service.extractActivityData(A.URI.revive(v[0]),A.URI.revive(v[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const E=f.substring(11),c=v[0],d=this.getManualSyncTask(c);switch(v=v.slice(1),E){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.manualSyncTasks.delete(this.createKey(d.id)));case"stop":return d.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(d.id)))}}throw new Error("Invalid call")}getManualSyncTask(u){const f=this.manualSyncTasks.get(this.createKey(u));if(!f)throw new Error(`Manual sync taks not found: ${u}`);return f}async createManualSyncTask(){const u=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(u.id),u),u.id}createKey(u){return`manualSyncTask-${u}`}}e.UserDataSyncServiceChannel=m;let P=class extends O.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(u,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,E,c){return u.call(v,E,c).then(null,d=>{throw _.UserDataSyncError.toUserDataSyncError(d)})},listen(v,E){return u.listen(v,E)}},this.channel.call("_getInitialData").then(([v,E,c])=>{this.updateStatus(v),this.updateConflicts(E),c&&this.updateLastSyncTime(c),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(E=>({...E,error:_.UserDataSyncError.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const u=await this.channel.call("createManualSyncTask"),f=this;return new I(u,{async call(E,c,d){return f.channel.call(`manualSync/${E}`,[u,...Array.isArray(c)?c:[c]],d)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(u,f,v,E){return this.channel.call("accept",[u,f,v,E])}resolveContent(u){return this.channel.call("resolveContent",[u])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(u){return this.channel.call("replace",[u])}saveRemoteActivityData(u){return this.channel.call("getRemoteActivityData",[u])}extractActivityData(u,f){return this.channel.call("extractActivityData",[u,f])}async updateStatus(u){this._status=u,this._onDidChangeStatus.fire(u)}async updateConflicts(u){this._conflicts=u.map(f=>({syncResource:f.syncResource,profile:(0,T.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(v=>({...v,baseResource:A.URI.revive(v.baseResource),localResource:A.URI.revive(v.localResource),remoteResource:A.URI.revive(v.remoteResource),previewResource:A.URI.revive(v.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(u){this._lastSyncTime!==u&&(this._lastSyncTime=u,this._onDidChangeLastSyncTime.fire(u))}};e.UserDataSyncServiceChannelClient=P,e.UserDataSyncServiceChannelClient=P=Ee([G(1,T.IUserDataProfilesService)],P);class I extends O.Disposable{constructor(u,f){super(),this.id=u,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(le[122],ue([0,1,6,26,7,3,2,141,5,20,12,10,32,21,15,11,24,59,43,19,25]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const w="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(U){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,U,-1,b.isWeb?0:1)}constructor(U,M,F){super(),this.productService=U,this.configurationService=M,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const z=this._register(new _.DisposableStore);this._register(T.Event.filter(F.onDidChangeValue(-1,l.SYNC_SERVICE_URL_TYPE,z),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,z)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[w]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U){if(U&&(U=b.isWeb&&U.web?{...U,...U.web}:U,(0,P.isString)(U.url)&&(0,P.isObject)(U.authenticationProviders)&&Object.keys(U.authenticationProviders).every(M=>Array.isArray(U.authenticationProviders[M].scopes)))){const M=U,F=!!M.canSwitch,z=M.url===M.insidersUrl?"insiders":"stable",X=(F?this.userDataSyncStoreType:void 0)||z,K=X==="insiders"?M.insidersUrl:X==="stable"?M.stableUrl:M.url;return{url:I.URI.parse(K),type:X,defaultType:z,defaultUrl:I.URI.parse(M.url),stableUrl:I.URI.parse(M.stableUrl),insidersUrl:I.URI.parse(M.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Q,V)=>(Q.push({id:V,scopes:M.authenticationProviders[V].scopes}),Q),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=Ee([G(0,E.IProductService),G(1,u.IConfigurationService),G(2,g.IStorageService)],a);let C=class extends a{constructor(U,M,F){super(U,M,F);const z=this.storageService.get(i,-1);z&&(this.previousConfigurationSyncStore=JSON.parse(z));const X=this.productService[w];X?this.storageService.store(i,JSON.stringify(X),-1,1):this.storageService.remove(i,-1)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=C,e.UserDataSyncStoreManagementService=C=Ee([G(0,E.IProductService),G(1,u.IConfigurationService),G(2,g.IStorageService)],C);let p=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(U,M,F,z,X,K,Q){super(),this.requestService=F,this.logService=z,this.storageService=Q,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,d.getServiceMachineId)(X,K,Q).then(V=>{const Y={"X-Client-Name":`${M.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Y["X-Client-Commit"]=M.commit),Y}),this.session=new y(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(U,M){this.authToken={token:U,type:M}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,m.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(o,-1);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(M=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]="application/json";const F=await this.request(M,{type:"GET",headers:U},[],O.CancellationToken.None);return(await(0,c.asJson)(F))?.map(({id:z})=>z)||[]}async createCollection(U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},U["Content-Type"]=R.Mimes.text;const F=await this.request(M,{type:"POST",headers:U},[],O.CancellationToken.None),z=await(0,c.asTextOrError)(F);if(!z)throw new l.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);return z}async deleteCollection(U,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=U?(0,m.joinPath)(this.userDataSyncStoreUrl,"collection",U).toString():(0,m.joinPath)(this.userDataSyncStoreUrl,"collection").toString();M={...M},await this.request(F,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async getAllResourceRefs(U,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,M,U),z={},X=await this.request(F.toString(),{type:"GET",headers:z},[],O.CancellationToken.None);return(await(0,c.asJson)(X)||[]).map(({url:Q,created:V})=>({ref:(0,m.relativePath)(F,F.with({path:Q})),created:V*1e3}))}async resolveResourceContent(U,M,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const X=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,U),M).toString();z={...z},z["Cache-Control"]="no-cache";const K=await this.request(X,{type:"GET",headers:z},[],O.CancellationToken.None);return await(0,c.asTextOrError)(K)}async deleteResource(U,M,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=M!==null?(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,U),M).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,U).toString(),X={};await this.request(z,{type:"DELETE",headers:X},[],O.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,m.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.request(U,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async readResource(U,M,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const X=(0,m.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,U),"latest").toString();z={...z},z["Cache-Control"]="no-cache",M&&(z["If-None-Match"]=M.ref);const K=await this.request(X,{type:"GET",headers:z},[304],O.CancellationToken.None);let Q=null;if(K.res.statusCode===304&&(Q=M),Q===null){const V=K.res.headers.etag;if(!V)throw new l.UserDataSyncStoreError("Server did not return the ref",X,"NoRef",K.res.statusCode,K.res.headers[l.HEADER_OPERATION_ID]);const Y=await(0,c.asTextOrError)(K);if(!Y&&K.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",X,"EmptyResponse",K.res.statusCode,K.res.headers[l.HEADER_OPERATION_ID]);Q={ref:V,content:Y}}return Q}async writeResource(U,M,F,z,X={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=this.getResourceUrl(this.userDataSyncStoreUrl,z,U).toString();X={...X},X["Content-Type"]=R.Mimes.text,F&&(X["If-Match"]=F);const Q=await this.request(K,{type:"POST",data:M,headers:X},[],O.CancellationToken.None),V=Q.res.headers.etag;if(!V)throw new l.UserDataSyncStoreError("Server did not return the ref",K,"NoRef",Q.res.statusCode,Q.res.headers[l.HEADER_OPERATION_ID]);return V}async manifest(U,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,m.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",U&&(M["If-None-Match"]=U.ref);const z=await this.request(F,{type:"GET",headers:M},[304],O.CancellationToken.None);let X=null;if(z.res.statusCode===304&&(X=U),!X){const Q=z.res.headers.etag;if(!Q)throw new l.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[l.HEADER_OPERATION_ID]);const V=await(0,c.asTextOrError)(z);if(!V&&z.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[l.HEADER_OPERATION_ID]);V&&(X={...JSON.parse(V),ref:Q})}const K=this.storageService.get(n,-1);return K&&X&&K!==X.session&&this.clearSession(),X===null&&K&&this.clearSession(),X&&this.storageService.store(n,X.session,-1,1),X}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,m.joinPath)(this.userDataSyncStoreUrl,"download").toString(),M={},F=await this.request(U,{type:"GET",headers:M},[],O.CancellationToken.None);if(!(0,c.isSuccess)(F))throw new l.UserDataSyncStoreError("Server returned "+F.res.statusCode,U,"EmptyResponse",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);if((0,c.hasNoContent)(F))throw new l.UserDataSyncStoreError("Empty response",U,"EmptyResponse",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);return F.stream}getResourceUrl(U,M,F){return M?(0,m.joinPath)(U,"collection",M,"resource",F):(0,m.joinPath)(U,"resource",F)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(s,-1)}async request(U,M,F,z){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const X=await this.commonHeadersPromise;M.headers={...M.headers||{},...X,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:U,type:M.type,headers:{...M.headers,authorization:void 0}});let K;try{K=await this.session.request(U,M,z)}catch(q){if(!(q instanceof l.UserDataSyncStoreError)){let te="RequestFailed";const oe=(0,A.getErrorMessage)(q).toLowerCase();oe.includes("xhr timeout")?te="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?te="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":oe.includes("headers must be an object")?te="RequestHeadersNotObject":(0,A.isCancellationError)(q)&&(te="RequestCanceled"),q=new l.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,te,void 0,void 0)}throw this.logService.info("Request failed",U),q}const Q=K.res.headers[l.HEADER_OPERATION_ID],V={url:U,status:K.res.statusCode,"execution-id":M.headers[l.HEADER_EXECUTION_ID],"operation-id":Q},Y=(0,c.isSuccess)(K)||K.res.statusCode&&F.includes(K.res.statusCode);let x="";if(Y?this.logService.trace("Request succeeded",V):(x=await(0,c.asText)(K)||"",this.logService.info("Request failed",V,x)),K.res.statusCode===401||K.res.statusCode===403){if(this.authToken=void 0,K.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",K.res.statusCode,Q);if(K.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because the access is forbidden (403).`,U,"Forbidden",K.res.statusCode,Q)}if(this._onTokenSucceed.fire(),K.res.statusCode===404)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because the requested resource is not found (404).`,U,"NotFound",K.res.statusCode,Q);if(K.res.statusCode===405)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because the requested endpoint is not found (405). ${x}`,U,"MethodNotFound",K.res.statusCode,Q);if(K.res.statusCode===409)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",K.res.statusCode,Q);if(K.res.statusCode===410)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",K.res.statusCode,Q);if(K.res.statusCode===412)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",K.res.statusCode,Q);if(K.res.statusCode===413)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",K.res.statusCode,Q);if(K.res.statusCode===426)throw new l.UserDataSyncStoreError(`${M.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",K.res.statusCode,Q);if(K.res.statusCode===429){const q=K.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",K.res.statusCode,Q)):new l.UserDataSyncStoreError(`${M.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",K.res.statusCode,Q)}if(!Y)throw new l.UserDataSyncStoreError("Server returned "+K.res.statusCode,U,"Unknown",K.res.statusCode,Q);return K}addSessionHeaders(U){let M=this.storageService.get(s,-1);M===void 0&&(M=(0,S.generateUuid)(),this.storageService.store(s,M,-1,1)),U["X-Machine-Session-Id"]=M;const F=this.storageService.get(n,-1);F!==void 0&&(U["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=p,e.UserDataSyncStoreClient=p=Ee([G(1,E.IProductService),G(2,c.IRequestService),G(3,l.IUserDataSyncLogService),G(4,f.IEnvironmentService),G(5,v.IFileService),G(6,g.IStorageService)],p);let h=class extends p{constructor(U,M,F,z,X,K,Q){super(U.userDataSyncStore?.url,M,F,z,X,K,Q),this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=h,e.UserDataSyncStoreService=h=Ee([G(0,l.IUserDataSyncStoreManagementService),G(1,E.IProductService),G(2,c.IRequestService),G(3,l.IUserDataSyncLogService),G(4,f.IEnvironmentService),G(5,v.IFileService),G(6,g.IStorageService)],h);class y{constructor(U,M,F,z){this.limit=U,this.interval=M,this.requestService=F,this.logService=z,this.requests=[],this.startTime=void 0}request(U,M,F){if(this.isExpired()&&this.reset(),M.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(M,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=y}),define(le[263],ue([0,1,3,2,10,21,24,19,122]),function(se,e,L,O,A,T,_,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class m{constructor(f){this.service=f}listen(f,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${v}`)}call(f,v,E){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(E)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class P extends O.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(f){super(),this.channel=f,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(v=>{this._account=v,this._register(this.channel.listen("onDidChangeAccount")(E=>{this._account=E,this._onDidChangeAccount.fire(E)}))})}updateAccount(f){return this.channel.call("updateAccount",f)}}e.UserDataSyncAccountServiceChannelClient=P;class I{constructor(f){this.service=f}listen(f,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${v}`)}call(f,v,E){switch(v){case"switch":return this.service.switch(E[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;let S=class extends b.AbstractUserDataSyncStoreManagementService{constructor(f,v,E,c){super(v,E,c),this.channel=f,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:A.URI.revive(f.url),type:f.type,defaultUrl:A.URI.revive(f.defaultUrl),insidersUrl:A.URI.revive(f.insidersUrl),stableUrl:A.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=S,e.UserDataSyncStoreManagementServiceChannelClient=S=Ee([G(1,_.IProductService),G(2,T.IConfigurationService),G(3,R.IStorageService)],S)}),define(le[264],ue([0,1,3,57,24,19,22,259,25,81,84]),function(se,e,L,O,A,T,_,R,b,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends R.UserDataAutoSyncService{constructor(u,f,v,E,c,d,g,l,w,i,o){super(u,f,v,E,c,g,l,w,i,o),this._register(L.Event.debounce(L.Event.any(L.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),L.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=I,e.UserDataAutoSyncService=I=Ee([G(0,A.IProductService),G(1,b.IUserDataSyncStoreManagementService),G(2,b.IUserDataSyncStoreService),G(3,b.IUserDataSyncEnablementService),G(4,b.IUserDataSyncService),G(5,O.INativeHostService),G(6,b.IUserDataSyncLogService),G(7,m.IUserDataSyncAccountService),G(8,_.ITelemetryService),G(9,P.IUserDataSyncMachinesService),G(10,T.IStorageService)],I)}),define(le[265],ue([0,1,73,23,5,20]),function(se,e,L,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(m){function P(){let I=m.scheme===O.Schemas.file?(0,T.originalFSPath)(m):m.toString();return A.isLinux||(I=I.toLowerCase()),(0,L.createHash)("md5").update(I).digest("hex")}return{id:P(),configPath:m}}e.getWorkspaceIdentifier=_;function R(m,P){function I(){if(m.scheme!==O.Schemas.file)return(0,L.createHash)("md5").update(m.toString()).digest("hex");if(!P)return;let u;return A.isLinux?u=P.ino:A.isMacintosh?u=P.birthtime.getTime():A.isWindows&&(typeof P.birthtimeMs=="number"?u=Math.floor(P.birthtimeMs):u=P.birthtime.getTime()),(0,L.createHash)("md5").update(m.fsPath).update(u?String(u):"").digest("hex")}const S=I();if(typeof S=="string")return{id:S,uri:m}}e.getSingleFolderWorkspaceIdentifier=R;function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=b}),define(le[266],ue([0,1,6,7,2,16,31,15,8,78,112,265,57,56,23]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let v=class extends A.Disposable{constructor(c,d,g,l){super(),this.environmentService=c,this.logService=d,this.nativeHostService=g,this.mainProcessService=l,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.environmentService.workspaceStorageHome.with({scheme:f.Schemas.file}).fsPath,d=await _.Promises.readdir(c),g=new m.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(d.map(async l=>{const w=(0,T.join)(c,l);l.length===I.NON_EMPTY_WORKSPACE_ID_LENGTH||l===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===l)||await g.isUsed(w)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${l} as it seems to be an unused empty workspace.`),await _.Promises.rm(w))}))}catch(c){(0,O.onUnexpectedError)(c)}}};e.UnusedWorkspaceStorageDataCleaner=v,e.UnusedWorkspaceStorageDataCleaner=v=Ee([G(0,R.INativeEnvironmentService),G(1,b.ILogService),G(2,S.INativeHostService),G(3,u.IMainProcessService)],v)}),define(le[123],ue([0,1,73,64,37,276,14,7,3,2,16,5,32,40,68]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(h,y){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,y)}constructor(h,y=""){this._canWrite=!0,this.debugLabel=y,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener),this._closeListener=D=>{this.traceSocketEvent("close",{hadError:D}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(h){const y=D=>{this.traceSocketEvent("read",D),h(_.VSBuffer.wrap(D))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(h){const y=D=>{h({type:0,hadError:D,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(h){const y=()=>{h()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(h){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,R.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,R.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=v;var E;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(E||(E={}));var c;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(c||(c={}));class d extends m.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(h,y){this.socket.traceSocketEvent(h,y)}constructor(h,y,D,U){super(),this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:D?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new g(this,y,D,U,this._onData,(M,F)=>this._write(M,F))),this._register(this._flowManager.onError(M=>{console.error(M),(0,R.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new f.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(async M=>{this._flowManager.isProcessingReadQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(M)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let y=0;for(;y<h.byteLength;)this._flowManager.writeMessage(h.slice(y,Math.min(y+262144,h.byteLength)),{compressed:!0,opcode:2}),y+=262144}_write(h,{compressed:y,opcode:D}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let U=2;h.byteLength<126?U+=0:h.byteLength<2**16?U+=2:U+=8;const M=_.VSBuffer.alloc(U),F=y?64:0,z=D&15;if(M.writeUInt8(128|F|z,0),h.byteLength<126)M.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){M.writeUInt8(126,1);let X=1;M.writeUInt8(h.byteLength>>>8&255,++X),M.writeUInt8(h.byteLength>>>0&255,++X)}else{M.writeUInt8(127,1);let X=1;M.writeUInt8(0,++X),M.writeUInt8(0,++X),M.writeUInt8(0,++X),M.writeUInt8(0,++X),M.writeUInt8(h.byteLength>>>24&255,++X),M.writeUInt8(h.byteLength>>>16&255,++X),M.writeUInt8(h.byteLength>>>8&255,++X),M.writeUInt8(h.byteLength>>>0&255,++X)}this.socket.write(_.VSBuffer.concat([M,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),D=y.readUInt8(0),U=(D&128)>>>7,M=(D&64)>>>6,F=D&15,z=y.readUInt8(1),X=(z&128)>>>7,K=z&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(K===126?2:0)+(K===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!M),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this._state.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),D=y.readUInt8(1),U=(D&128)>>>7;let M=D&127,F=1;M===126?M=y.readUInt8(++F)*2**8+y.readUInt8(++F):M===127&&(M=y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*0+y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F));let z=0;U&&(z=y.readUInt8(++F)*2**24+y.readUInt8(++F)*2**16+y.readUInt8(++F)*2**8+y.readUInt8(++F)),this._state.state=3,this._state.readLen=M,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),i(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class g extends m.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(h,y,D,U,M,F){super(),this._tracer=h,this._onData=M,this._writeFn=F,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new b.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new l(this._tracer,U,D,{windowBits:15})),this._zlibDeflateStream=this._register(new w(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(h,y){this._writeQueue.push({data:h,options:y}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:h,options:y}=this._writeQueue.shift();if(this._zlibDeflateStream&&y.compressed){const D=await this._deflateMessage(this._zlibDeflateStream,h);this._writeFn(D,y)}else this._writeFn(h,{...y,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(h,y){return new Promise((D,U)=>{h.write(y),h.flush(M=>D(M))})}acceptFrame(h,y,D){this._readQueue.push({data:h,isCompressed:y,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const h=this._readQueue.shift();if(this._zlibInflateStream&&h.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,h.data,h.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(h.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(h,y,D){return new Promise((U,M)=>{h.write(y),D&&h.write(_.VSBuffer.fromByteArray([0,0,255,255])),h.flush(F=>U(F))})}}class l extends m.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(h,y,D,U){super(),this._tracer=h,this._recordInflateBytes=y,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,T.createInflateRaw)(U),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(_.VSBuffer.wrap(M))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(h){this._recordInflateBytes&&this._recordedInflateBytes.push(h.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",h),this._zlibInflate.write(h.buffer)}flush(h){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,h(y)})}}class w extends m.Disposable{constructor(h,y){super(),this._tracer=h,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,T.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(_.VSBuffer.wrap(D))})}write(h){this._tracer.traceSocketEvent("zlibDeflateWrite",h.buffer),this._zlibDeflate.write(h.buffer)}flush(h){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),h(y)})}}function i(p,h){if(h===0)return;const y=p.byteLength>>>2;for(let X=0;X<y;X++){const K=p.readUInt32BE(X*4);p.writeUInt32BE(K^h,X*4)}const D=y*4,U=p.byteLength-D,M=h>>>24&255,F=h>>>16&255,z=h>>>8&255;U>=1&&p.writeUInt8(p.readUInt8(D)^M,D),U>=2&&p.writeUInt8(p.readUInt8(D+1)^F,D+1),U>=3&&p.writeUInt8(p.readUInt8(D+2)^z,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const p=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const h=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),y=(0,P.join)(h,`vscode-ipc-${p}.sock`);return t(y),y}e.createRandomIPCHandle=n;function s(p,h,y){const U=(0,L.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${y}-${h}-sock`;const M=y.substr(0,4),F=h.substr(0,6);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${U}-${M}-${F}.sock`):z=(0,P.join)(p,`${M}-${F}.sock`),t(z),z}e.createStaticIPCHandle=s;function t(p){const h=o[I.platform];typeof h=="number"&&p.length>=h&&console.warn(`WARNING: IPC handle "${p}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends u.IPCServer{static toClientConnectionEvent(h){const y=b.Event.fromNodeEventEmitter(h,"connection");return b.Event.map(y,D=>({protocol:new f.Protocol(new v(D,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(D,"close"))}))}constructor(h){super(r.toClientConnectionEvent(h)),this.server=h}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(p){return new Promise((h,y)=>{const D=(0,O.createServer)();D.on("error",y),D.listen(p,()=>{D.removeListener("error",y),h(new r(D))})})}e.serve=a;function C(p,h){return new Promise((y,D)=>{const U=(0,O.createConnection)(p,()=>{U.removeListener("error",D),y(f.Client.fromSocket(new v(U,`ipc-client${h}`),h))});U.once("error",D)})}e.connect=C}),define(le[267],ue([0,1,64,123,214]),function(se,e,L,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(T){return!0}connect({host:T,port:_},R,b,m){return new Promise((P,I)=>{const S=L.createConnection({host:T,port:_},()=>{S.removeListener("error",I),S.write((0,A.makeRawSocketHeaders)(R,b,m));const u=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",u),P(new O.NodeSocket(S,m)))};S.on("data",u)});S.setNoDelay(!0),S.once("error",I)})}}}),define(le[268],ue([0,1,64,37,133,123,6,2,5,21,8,24,217,104,106,79,14]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function c(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&A.BROWSER_RESTRICTED_PORTS[t]||!A.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));a--);return r}class d extends R.Disposable{constructor(o,n,s,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=v.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,v.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,A.findFreePortFaster)(o,2,1e3,n),t=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(o){o.pause();const n=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,S.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t instanceof T.NodeSocket?t.socket.destroy():t.end()}),t instanceof T.NodeSocket?this._mirrorNodeSocket(o,t):this._mirrorGenericSocket(o,t),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),t.end()})}_mirrorGenericSocket(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(E.VSBuffer.wrap(s))),o.resume()}_mirrorNodeSocket(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.NodeRemoteTunnel=d;let g=class extends v.AbstractTunnelService{constructor(o,n,s,t,r){super(n,r),this.remoteSocketFactoryService=o,this.signService=s,this.productService=t}isPortPrivileged(o){return(0,v.isPortPrivileged)(o,this.defaultTunnelHost,b.OS,O.release())}retainOrCreateTunnel(o,n,s,t,r,a,C,p){const h=this.getTunnelFromMap(n,s);if(h)return++h.refcount,h.value;if((0,v.isTunnelProvider)(o))return this.createWithProvider(o,n,s,r,a,C,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const y={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},D=c(y,t,n,s,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,D),D}}};e.BaseTunnelService=g,e.BaseTunnelService=g=Ee([G(0,u.IRemoteSocketFactoryService),G(1,P.ILogService),G(2,f.ISignService),G(3,I.IProductService),G(4,m.IConfigurationService)],g);let l=class extends g{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.TunnelService=l,e.TunnelService=l=Ee([G(0,u.IRemoteSocketFactoryService),G(1,P.ILogService),G(2,f.ISignService),G(3,I.IProductService),G(4,m.IConfigurationService)],l);let w=class extends R.Disposable{constructor(o,n,s,t,r){super(),this.remoteSocketFactoryService=o,this.logService=n,this.productService=s,this.signService=t,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(o,n,s,t,r,a,C,p,h){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this._tunnelServices.has(o)){const y=new l(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(y),this._tunnelServices.set(o,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(n,s,t,r,a,C,p,h)}};e.SharedTunnelsService=w,e.SharedTunnelsService=w=Ee([G(0,u.IRemoteSocketFactoryService),G(1,P.ILogService),G(2,I.IProductService),G(3,f.ISignService),G(4,m.IConfigurationService)],w)}),define(le[277],ue([0,1,37,38,7,2,23,10,17,3,40,149,208,209,199,200,266,190,192,21,213,95,224,96,219,15,114,250,29,99,191,113,97,11,202,203,72,4,198,74,75,230,8,204,102,24,59,19,107,22,108,109,110,46,233,83,111,25,81,258,263,243,84,257,261,262,122,60,256,244,106,223,79,268,218,234,28,235,5,236,193,211,210,82,249,18,52,207,58,255,232,245,105,260,251,9,205,101,253,248,220,187,57,206,264,252,56,254,104,267,184,221,145,140]),function(se,e,L,O,A,T,_,R,b,m,P,I,S,u,f,v,E,c,d,g,l,w,i,o,n,s,t,r,a,C,p,h,y,D,U,M,F,z,X,K,Q,V,Y,x,q,te,oe,ee,ae,B,W,k,N,j,$,J,Z,ie,H,ne,ce,de,fe,Se,Ce,Re,_e,Ue,he,me,pe,Pe,De,Me,ke,ze,Ne,$e,We,Ae,re,ge,ye,ve,we,be,Le,Oe,qe,je,Fe,Ge,Be,Ze,tt,Ct,It,gt,bt,Pt,Dt,Rt,Lt,_t,kt,Tt,mt,At,St,Ot,Ut,st,Nt,Mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends T.Disposable{constructor(Ie){super(),this.configuration=Ie,this.server=this._register(new I.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new m.Emitter),this.registerListeners()}registerListeners(){let Ie=!1;const Te=()=>{Ie||(Ie=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Te),(0,I.once)(process.parentPort,st.SharedProcessLifecycle.exit,Te)}async init(){const Ie=await this.initServices();(0,ie.registerConfiguration)(),Ie.invokeFunction(Te=>{const Ve=Te.get(Y.ILogService),xe=Te.get(B.ITelemetryService),Je=Te.get(be.IUserDataProfilesService);Ve.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Te),this.registerErrorHandler(Ve),this.reportProfilesInfo(xe,Je),this._register(Je.onDidChangeProfiles(()=>this.reportProfilesInfo(xe,Je))),this.reportClientOSInfo(xe,Ve)}),this._register((0,T.combinedDisposable)(Ie.createInstance(S.CodeCacheCleaner,this.configuration.codeCachePath),Ie.createInstance(u.LanguagePackCachedDataCleaner),Ie.createInstance(E.UnusedWorkspaceStorageDataCleaner),Ie.createInstance(v.LogsDataCleaner),Ie.createInstance(f.LocalizationsUpdater),Ie.createInstance(tt.ExtensionsContributions),Ie.createInstance(Ge.UserDataProfilesCleaner)))}async initServices(){const Ie=new K.ServiceCollection,Te={_serviceBrand:void 0,...q.default};Ie.set(te.IProductService,Te);const Ve=new P.StaticRouter(He=>He==="main"),xe=new mt.MainProcessService(this.server,Ve);Ie.set(mt.IMainProcessService,xe);const Je=this.configuration.policiesData?new Oe.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new qe.NullPolicyService;Ie.set(qe.IPolicyService,Je);const Ke=new Ut.NativeEnvironmentService(this.configuration.args,Te);Ie.set(s.INativeEnvironmentService,Ke);const et=new x.LoggerChannelClient(void 0,this.configuration.logLevel,Ke.logsHome,this.configuration.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),xe.getChannel("logger"));Ie.set(Y.ILoggerService,et);const ot=this._register(et.createLogger("sharedprocess",{name:(0,Ct.localize)(0,null)})),ut=this._register(new Y.ConsoleLogger(ot.getLevel())),Ye=this._register(new It.LogService(ot,[ut]));Ie.set(Y.ILogService,Ye),this.lifecycleService=this._register(new gt.SharedProcessLifecycleService(Ye)),Ie.set(gt.ISharedProcessLifecycleService,this.lifecycleService);const Xe=this._register(new U.FileService(Ye));Ie.set(D.IFileService,Xe);const ht=this._register(new M.DiskFileSystemProvider(Ye));Xe.registerProvider(_.Schemas.file,ht);const at=new $e.UriIdentityService(Xe);Ie.set(Ne.IUriIdentityService,at);const Qe=this._register(new je.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),xe.getChannel("userDataProfiles")));Ie.set(be.IUserDataProfilesService,Qe);const dt=this._register(new Ae.FileUserDataProvider(_.Schemas.file,this._register(new re.DiskFileSystemProviderClient(xe.getChannel(re.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:We.isLinux})),_.Schemas.vscodeUserData,Qe,at,Ye));Xe.registerProvider(_.Schemas.vscodeUserData,dt);const it=this._register(new l.ConfigurationService(Qe.defaultProfile.settingsResource,Xe,Je,Ye));Ie.set(g.IConfigurationService,it);const ft=new At.RemoteStorageService(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},xe,Ke);Ie.set(ee.IStorageService,ft),this._register((0,T.toDisposable)(()=>ft.flush())),await Promise.all([it.initialize(),ft.initialize()]);const pt=new Dt.RequestChannelClient(xe.getChannel("request"));Ie.set(oe.IRequestService,pt),Ie.set(c.IChecksumService,new F.SyncDescriptor(d.ChecksumService,void 0,!1)),Ie.set(ye.IV8InspectProfilingService,new F.SyncDescriptor(ge.InspectProfilingService,void 0,!1));const yt=new _t.NativeHostService(-1,xe);Ie.set(Lt.INativeHostService,yt),Ie.set(o.IDownloadService,new F.SyncDescriptor(n.DownloadService,void 0,!0));const $t=this._register(new me.ActiveWindowManager(yt)),Wt=new P.StaticRouter(He=>$t.getActiveClientId().then(lt=>He===lt));Ie.set(y.IExtensionRecommendationNotificationService,new Rt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Wt)));let ct;const nt=[],Et=(0,j.isInternalTelemetry)(Te,it);if((0,j.supportsTelemetry)(Te,Ke)){const He=new k.TelemetryLogAppender(Ye,et,Ke,Te);if(nt.push(He),!(0,j.isLoggingOnly)(Te,Ke)&&Te.aiConfig?.ariaKey){const lt=new Fe.OneDataSystemAppender(pt,Et,"monacoworkbench",null,Te.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>lt.flush())),nt.push(lt)}ct=new N.TelemetryService({appenders:nt,commonProperties:(0,ae.resolveCommonProperties)((0,L.release)(),(0,L.hostname)(),process.arch,Te.commit,Te.version,this.configuration.machineId,this.configuration.sqmId,Et),sendErrorTelemetry:!0,piiPaths:(0,j.getPiiPathsFromEnvironment)(Ke)},it,Te)}else{ct=j.NullTelemetryService;const He=j.NullAppender;nt.push(He)}this.server.registerChannel("telemetryAppender",new W.TelemetryAppenderChannel(nt)),Ie.set(B.ITelemetryService,ct);const zt=new $.CustomEndpointTelemetryService(it,ct,Ye,et,Ke,Te);Ie.set(B.ICustomEndpointTelemetryService,zt),Ie.set(Le.IExtensionsProfileScannerService,new F.SyncDescriptor(Pt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(ve.IExtensionsScannerService,new F.SyncDescriptor(we.ExtensionsScannerService,void 0,!0)),Ie.set(C.IExtensionSignatureVerificationService,new F.SyncDescriptor(C.ExtensionSignatureVerificationService,void 0,!0)),Ie.set(h.INativeServerExtensionManagementService,new F.SyncDescriptor(h.ExtensionManagementService,void 0,!0)),Ie.set(a.IExtensionGalleryService,new F.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),Ie.set(a.IExtensionTipsService,new F.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),Ie.set(Q.ILanguagePackService,new F.SyncDescriptor(V.NativeLanguagePackService,void 0,!1)),Ie.set(w.IDiagnosticsService,new F.SyncDescriptor(i.DiagnosticsService,void 0,!1)),Ie.set(H.IUserDataSyncAccountService,new F.SyncDescriptor(H.UserDataSyncAccountService,void 0,!0)),Ie.set(ie.IUserDataSyncLogService,new F.SyncDescriptor(de.UserDataSyncLogService,void 0,!0)),Ie.set(ie.IUserDataSyncUtilService,P.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ie.set(a.IGlobalExtensionEnablementService,new F.SyncDescriptor(t.GlobalExtensionEnablementService,void 0,!1)),Ie.set(Z.IIgnoredExtensionsManagementService,new F.SyncDescriptor(Z.IgnoredExtensionsManagementService,void 0,!0)),Ie.set(J.IExtensionStorageService,new F.SyncDescriptor(J.ExtensionStorageService)),Ie.set(ie.IUserDataSyncStoreManagementService,new F.SyncDescriptor(_e.UserDataSyncStoreManagementService,void 0,!0)),Ie.set(ie.IUserDataSyncStoreService,new F.SyncDescriptor(_e.UserDataSyncStoreService,void 0,!0)),Ie.set(fe.IUserDataSyncMachinesService,new F.SyncDescriptor(fe.UserDataSyncMachinesService,void 0,!0)),Ie.set(ie.IUserDataSyncLocalStoreService,new F.SyncDescriptor(ne.UserDataSyncLocalStoreService,void 0,!1)),Ie.set(ie.IUserDataSyncEnablementService,new F.SyncDescriptor(Se.UserDataSyncEnablementService,void 0,!0)),Ie.set(ie.IUserDataSyncService,new F.SyncDescriptor(Ce.UserDataSyncService,void 0,!1)),Ie.set(Ue.IUserDataProfileStorageService,new F.SyncDescriptor(he.NativeUserDataProfileStorageService,void 0,!0)),Ie.set(ie.IUserDataSyncResourceProviderService,new F.SyncDescriptor(Ze.UserDataSyncResourceProviderService,void 0,!0)),Ie.set(pe.ISignService,new F.SyncDescriptor(Pe.SignService,void 0,!1));const wt=new St.RemoteSocketFactoryService;return Ie.set(St.IRemoteSocketFactoryService,wt),wt.register(0,Ot.nodeSocketFactory),Ie.set(De.ISharedTunnelsService,new F.SyncDescriptor(Me.SharedTunnelsService)),Ie.set(ke.ISharedProcessTunnelService,new F.SyncDescriptor(ze.SharedProcessTunnelService)),Ie.set(Be.IRemoteTunnelService,new F.SyncDescriptor(bt.RemoteTunnelService)),new X.InstantiationService(Ie)}initChannels(Ie){const Te=new p.ExtensionManagementChannel(Ie.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Te);const Ve=P.ProxyChannel.fromService(Ie.get(Q.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",Ve);const xe=P.ProxyChannel.fromService(Ie.get(w.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",xe);const Je=new p.ExtensionTipsChannel(Ie.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Je);const Ke=P.ProxyChannel.fromService(Ie.get(c.IChecksumService),this._store);this.server.registerChannel("checksum",Ke);const et=P.ProxyChannel.fromService(Ie.get(ye.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",et);const ot=P.ProxyChannel.fromService(Ie.get(fe.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",ot);const ut=P.ProxyChannel.fromService(Ie.get(B.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",ut);const Ye=new ce.UserDataSyncAccountServiceChannel(Ie.get(H.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ye);const Xe=new ce.UserDataSyncStoreManagementServiceChannel(Ie.get(ie.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ht=new Re.UserDataSyncServiceChannel(Ie.get(ie.IUserDataSyncService),Ie.get(be.IUserDataProfilesService),Ie.get(Y.ILogService));this.server.registerChannel("userDataSync",ht);const at=this._register(Ie.get(z.IInstantiationService).createInstance(kt.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",P.ProxyChannel.fromService(at,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",P.ProxyChannel.fromService(Ie.get(ie.IUserDataSyncResourceProviderService),this._store));const Qe=P.ProxyChannel.fromService(Ie.get(ke.ISharedProcessTunnelService),this._store);this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,Qe);const dt=P.ProxyChannel.fromService(Ie.get(Be.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",dt)}registerErrorHandler(Ie){process.on("uncaughtException",Te=>(0,A.onUnexpectedError)(Te)),process.on("unhandledRejection",Te=>(0,A.onUnexpectedError)(Te)),(0,A.setUnexpectedErrorHandler)(Te=>{const Ve=(0,O.toErrorMessage)(Te,!0);Ve&&Ie.error(`[uncaught exception in sharedProcess]: ${Ve}`)})}reportProfilesInfo(Ie,Te){Ie.publicLog2("profilesInfo",{count:Te.profiles.length})}async reportClientOSInfo(Ie,Te){if(We.isLinux){const Ve=await(0,Nt.getOSReleaseInfo)(Te.error.bind(Te)),xe=(0,Mt.getDesktopEnvironment)();Ve&&Ie.publicLog2("clientPlatformInfo",{platformId:Ve.id,platformVersionId:Ve.version_id,platformIdLike:Ve.id_like,desktopEnvironment:xe})}}handledClientConnection(Ie){if(Ie.data!==st.SharedProcessRawConnection.response)return!1;const Te=(0,b.firstOrDefault)(Ie.ports);return Te?(this.onDidWindowConnectRaw.fire(Te),!0):!1}}async function vt(rt){const Ie=new Ft(rt);process.parentPort.postMessage(st.SharedProcessLifecycle.ipcReady),await Ie.init(),process.parentPort.postMessage(st.SharedProcessLifecycle.initDone)}e.main=vt,process.parentPort.once("message",rt=>{vt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
