/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],he=function(oe){for(var e=[],w=0,D=oe.length;w<D;w++)e[w]=ue[oe[w]];return e};define(ue[40],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function w(d,u,i){const o=D(d,u);if(o!==-1)return d[o]}e.findLast=w;function D(d,u,i=d.length-1){for(let o=i;o>=0;o--){const m=d[o];if(u(m))return o}return-1}e.findLastIdx=D;function S(d,u){const i=I(d,u);return i===-1?void 0:d[i]}e.findLastMonotonous=S;function I(d,u,i=0,o=d.length){let m=i,r=o;for(;m<r;){const t=Math.floor((m+r)/2);u(d[t])?m=t+1:r=t}return m-1}e.findLastIdxMonotonous=I;function M(d,u){const i=E(d,u);return i===d.length?void 0:d[i]}e.findFirstMonotonous=M;function E(d,u,i=0,o=d.length){let m=i,r=o;for(;m<r;){const t=Math.floor((m+r)/2);u(d[t])?r=t:m=t+1}return m}e.findFirstIdxMonotonousOrArrLen=E;function f(d,u,i=0,o=d.length){const m=E(d,u,i,o);return m===d.length?-1:m}e.findFirstIdxMonotonous=f;class l{static{this.assertInvariants=!1}constructor(u){this._array=u,this._findLastMonotonousLastIdx=0}findLastMonotonous(u){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const o of this._array)if(this._prevFindLastPredicate(o)&&!u(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=u}const i=I(this._array,u,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=i+1,i===-1?void 0:this._array[i]}}e.MonotonousArray=l;function P(d,u){if(d.length===0)return;let i=d[0];for(let o=1;o<d.length;o++){const m=d[o];u(m,i)>0&&(i=m)}return i}e.findFirstMaxBy=P;function p(d,u){if(d.length===0)return;let i=d[0];for(let o=1;o<d.length;o++){const m=d[o];u(m,i)>=0&&(i=m)}return i}e.findLastMaxBy=p;function v(d,u){return P(d,(i,o)=>-u(i,o))}e.findFirstMinBy=v;function s(d,u){if(d.length===0)return-1;let i=0;for(let o=1;o<d.length;o++){const m=d[o];u(m,d[i])>0&&(i=o)}return i}e.findMaxIdxBy=s;function c(d,u){for(const i of d){const o=u(i);if(o!==void 0)return o}}e.mapFindFirst=c}),define(ue[41],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function w(M,E){const f=Object.create(null);for(const l of M){const P=E(l);let p=f[P];p||(p=f[P]=[]),p.push(l)}return f}e.groupBy=w;function D(M,E){const f=[],l=[];for(const P of M)E.has(P)||f.push(P);for(const P of E)M.has(P)||l.push(P);return{removed:f,added:l}}e.diffSets=D;function S(M,E){const f=[],l=[];for(const[P,p]of M)E.has(P)||f.push(p);for(const[P,p]of E)M.has(P)||l.push(p);return{removed:f,added:l}}e.diffMaps=S;function I(M,E){const f=new Set;for(const l of E)M.has(l)&&f.add(l);return f}e.intersection=I}),define(ue[14],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(M){return(E,f,l)=>{let P=null,p=null;if(typeof l.value=="function"?(P="value",p=l.value):typeof l.get=="function"&&(P="get",p=l.get),!p)throw new Error("not supported");l[P]=M(p,f)}}function D(M,E,f){let l=null,P=null;if(typeof f.value=="function"?(l="value",P=f.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",P=f.get),!P)throw new Error("not supported");const p=`$memoize$${E}`;f[l]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,v)}),this[p]}}e.memoize=D;function S(M,E,f){return w((l,P)=>{const p=`$debounce$${P}`,v=`$debounce$result$${P}`;return function(...s){this[v]||(this[v]=f?f():void 0),clearTimeout(this[p]),E&&(this[v]=E(this[v],...s),s=[this[v]]),this[p]=setTimeout(()=>{l.apply(this,s),this[v]=f?f():void 0},M)}})}e.debounce=S;function I(M,E,f){return w((l,P)=>{const p=`$throttle$timer$${P}`,v=`$throttle$result$${P}`,s=`$throttle$lastRun$${P}`,c=`$throttle$pending$${P}`;return function(...d){if(this[v]||(this[v]=f?f():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),E&&(this[v]=E(this[v],...d)),this[c])return;const u=this[s]+M;u<=Date.now()?(this[s]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0):(this[c]=!0,this[p]=setTimeout(()=>{this[c]=!1,this[s]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0},u-Date.now()))}})}e.throttle=I}),define(ue[6],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(y=>{y(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=w,e.errorHandler=new w;function D(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=D;function S(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=S;function I(t){l(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=I;function M(t){l(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=M;function E(t){if(t instanceof Error){const{name:n,message:y}=t,O=t.stacktrace||t.stack;return{$isError:!0,name:n,message:y,stack:O,noTelemetry:m.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=E;const f="Canceled";function l(t){return t instanceof P?!0:t instanceof Error&&t.name===f&&t.message===f}e.isCancellationError=l;class P extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=P;function p(){const t=new Error(f);return t.name=t.message,t}e.canceled=p;function v(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=v;function s(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=s;class c extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=c;function d(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=d;class u extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=u;class i extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=i;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=o;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const y=new m;return y.message=n.message,y.stack=n.stack,y}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class r extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.BugIndicatingError=r}),define(ue[16],he([0,1,6,40]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function S(T,Q=0){return T[T.length-(1+Q)]}e.tail=S;function I(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=I;function M(T,Q,H=(V,L)=>V===L){if(T===Q)return!0;if(!T||!Q||T.length!==Q.length)return!1;for(let V=0,L=T.length;V<L;V++)if(!H(T[V],Q[V]))return!1;return!0}e.equals=M;function E(T,Q){const H=T.length-1;Q<H&&(T[Q]=T[H]),T.pop()}e.removeFastWithoutKeepingOrder=E;function f(T,Q,H){return l(T.length,V=>H(T[V],Q))}e.binarySearch=f;function l(T,Q){let H=0,V=T-1;for(;H<=V;){const L=(H+V)/2|0,F=Q(L);if(F<0)H=L+1;else if(F>0)V=L-1;else return L}return-(H+1)}e.binarySearch2=l;function P(T,Q,H){if(T=T|0,T>=Q.length)throw new TypeError("invalid index");const V=Q[Math.floor(Q.length*Math.random())],L=[],F=[],G=[];for(const Z of Q){const le=H(Z,V);le<0?L.push(Z):le>0?F.push(Z):G.push(Z)}return T<L.length?P(T,L,H):T<L.length+G.length?G[0]:P(T-(L.length+G.length),F,H)}e.quickSelect=P;function p(T,Q){const H=[];let V;for(const L of T.slice(0).sort(Q))!V||Q(V[0],L)!==0?(V=[L],H.push(V)):V.push(L);return H}e.groupBy=p;function*v(T,Q){let H,V;for(const L of T)V!==void 0&&Q(V,L)?H.push(L):(H&&(yield H),H=[L]),V=L;H&&(yield H)}e.groupAdjacentBy=v;function s(T,Q){for(let H=0;H<=T.length;H++)Q(H===0?void 0:T[H-1],H===T.length?void 0:T[H])}e.forEachAdjacent=s;function c(T,Q){for(let H=0;H<T.length;H++)Q(H===0?void 0:T[H-1],T[H],H+1===T.length?void 0:T[H+1])}e.forEachWithNeighbors=c;function d(T,Q,H){const V=[];function L(Z,le,pe){if(le===0&&pe.length===0)return;const ye=V[V.length-1];ye&&ye.start+ye.deleteCount===Z?(ye.deleteCount+=le,ye.toInsert.push(...pe)):V.push({start:Z,deleteCount:le,toInsert:pe})}let F=0,G=0;for(;;){if(F===T.length){L(F,0,Q.slice(G));break}if(G===Q.length){L(F,T.length-F,[]);break}const Z=T[F],le=Q[G],pe=H(Z,le);pe===0?(F+=1,G+=1):pe<0?(L(F,1,[]),F+=1):pe>0&&(L(F,0,[le]),G+=1)}return V}e.sortedDiff=d;function u(T,Q,H){const V=d(T,Q,H),L=[],F=[];for(const G of V)L.push(...T.slice(G.start,G.start+G.deleteCount)),F.push(...G.toInsert);return{removed:L,added:F}}e.delta=u;function i(T,Q,H){if(H===0)return[];const V=T.slice(0,H).sort(Q);return m(T,Q,V,H,T.length),V}e.top=i;function o(T,Q,H,V,L){return H===0?Promise.resolve([]):new Promise((F,G)=>{(async()=>{const Z=T.length,le=T.slice(0,H).sort(Q);for(let pe=H,ye=Math.min(H+V,Z);pe<Z;pe=ye,ye=Math.min(ye+V,Z)){if(pe>H&&await new Promise(we=>setTimeout(we)),L&&L.isCancellationRequested)throw new w.CancellationError;m(T,Q,le,pe,ye)}return le})().then(F,G)})}e.topAsync=o;function m(T,Q,H,V,L){for(const F=H.length;V<L;V++){const G=T[V];if(Q(G,H[F-1])<0){H.pop();const Z=(0,D.findFirstIdxMonotonousOrArrLen)(H,le=>Q(G,le)<0);H.splice(Z,0,G)}}}function r(T){return T.filter(Q=>!!Q)}e.coalesce=r;function t(T){let Q=0;for(let H=0;H<T.length;H++)T[H]&&(T[Q]=T[H],Q+=1);T.length=Q}e.coalesceInPlace=t;function n(T,Q,H){T.splice(H,0,T.splice(Q,1)[0])}e.move=n;function y(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=y;function O(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=O;function g(T,Q=H=>H){const H=new Set;return T.filter(V=>{const L=Q(V);return H.has(L)?!1:(H.add(L),!0)})}e.distinct=g;function b(T){const Q=new Set;return H=>{const V=T(H);return Q.has(V)?!1:(Q.add(V),!0)}}e.uniqueFilter=b;function C(T,Q){return T.length>0?T[0]:Q}e.firstOrDefault=C;function A(T,Q){return T.length>0?T[T.length-1]:Q}e.lastOrDefault=A;function $(T,Q,H=(V,L)=>V===L){let V=0;for(let L=0,F=Math.min(T.length,Q.length);L<F&&H(T[L],Q[L]);L++)V++;return V}e.commonPrefixLength=$;function B(T){return[].concat(...T)}e.flatten=B;function a(T,Q){let H=typeof Q=="number"?T:0;typeof Q=="number"?H=T:(H=0,Q=T);const V=[];if(H<=Q)for(let L=H;L<Q;L++)V.push(L);else for(let L=H;L>Q;L--)V.push(L);return V}e.range=a;function _(T,Q,H){return T.reduce((V,L)=>(V[Q(L)]=H?H(L):L,V),Object.create(null))}e.index=_;function k(T,Q){return T.push(Q),()=>q(T,Q)}e.insert=k;function q(T,Q){const H=T.indexOf(Q);if(H>-1)return T.splice(H,1),Q}e.remove=q;function R(T,Q,H){const V=T.slice(0,Q),L=T.slice(Q);return V.concat(H,L)}e.arrayInsert=R;function z(T,Q){let H;if(typeof Q=="number"){let V=Q;H=()=>{const L=Math.sin(V++)*179426549;return L-Math.floor(L)}}else H=Math.random;for(let V=T.length-1;V>0;V-=1){const L=Math.floor(H()*(V+1)),F=T[V];T[V]=T[L],T[L]=F}}e.shuffle=z;function ne(T,Q){const H=T.indexOf(Q);H>-1&&(T.splice(H,1),T.unshift(Q))}e.pushToStart=ne;function re(T,Q){const H=T.indexOf(Q);H>-1&&(T.splice(H,1),T.push(Q))}e.pushToEnd=re;function X(T,Q){for(const H of Q)T.push(H)}e.pushMany=X;function se(T,Q){return Array.isArray(T)?T.map(Q):Q(T)}e.mapArrayOrNot=se;function ce(T){return Array.isArray(T)?T:[T]}e.asArray=ce;function fe(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=fe;function K(T,Q,H){const V=Y(T,Q),L=T.length,F=H.length;T.length=L+F;for(let G=L-1;G>=V;G--)T[G+F]=T[G];for(let G=0;G<F;G++)T[G+V]=H[G]}e.insertInto=K;function W(T,Q,H,V){const L=Y(T,Q);let F=T.splice(L,H);return F===void 0&&(F=[]),K(T,L,V),F}e.splice=W;function Y(T,Q){return Q<0?Math.max(Q+T.length,0):Math.min(Q,T.length)}var te;(function(T){function Q(F){return F<0}T.isLessThan=Q;function H(F){return F<=0}T.isLessThanOrEqual=H;function V(F){return F>0}T.isGreaterThan=V;function L(F){return F===0}T.isNeitherLessOrGreaterThan=L,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function j(T,Q){return(H,V)=>Q(T(H),T(V))}e.compareBy=j;function ee(...T){return(Q,H)=>{for(const V of T){const L=V(Q,H);if(!te.isNeitherLessOrGreaterThan(L))return L}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=ee;const me=(T,Q)=>T-Q;e.numberComparator=me;const x=(T,Q)=>(0,e.numberComparator)(T?1:0,Q?1:0);e.booleanComparator=x;function h(T){return(Q,H)=>-T(Q,H)}e.reverseOrder=h;class U{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let H=this.firstIdx;for(;H<this.items.length&&Q(this.items[H]);)H++;const V=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,V}takeFromEndWhile(Q){let H=this.lastIdx;for(;H>=0&&Q(this.items[H]);)H--;const V=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}removeLast(){const Q=this.items[this.lastIdx];return this.lastIdx--,Q}takeCount(Q){const H=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,H}}e.ArrayQueue=U;class ie{static{this.empty=new ie(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(H=>(Q(H),!0))}toArray(){const Q=[];return this.iterate(H=>(Q.push(H),!0)),Q}filter(Q){return new ie(H=>this.iterate(V=>Q(V)?H(V):!0))}map(Q){return new ie(H=>this.iterate(V=>H(Q(V))))}some(Q){let H=!1;return this.iterate(V=>(H=Q(V),!H)),H}findFirst(Q){let H;return this.iterate(V=>Q(V)?(H=V,!1):!0),H}findLast(Q){let H;return this.iterate(V=>(Q(V)&&(H=V),!0)),H}findLastMaxBy(Q){let H,V=!0;return this.iterate(L=>((V||te.isGreaterThan(Q(L,H)))&&(V=!1,H=L),!0)),H}}e.CallbackIterable=ie}),define(ue[42],he([0,1,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function D(l,P){if(!l)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=D;function S(l,P="Unreachable"){throw new Error(P)}e.assertNever=S;function I(l){if(!l)throw new w.BugIndicatingError("Assertion Failed")}e.assert=I;function M(l){l||(0,w.onUnexpectedError)(new w.BugIndicatingError("Soft Assertion Failed"))}e.softAssert=M;function E(l){if(!l()){debugger;l(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}e.assertFn=E;function f(l,P){let p=0;for(;p<l.length-1;){const v=l[p],s=l[p+1];if(!P(v,s))return!1;p++}return!0}e.checkAdjacentItems=f}),define(ue[29],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function w(D,S){const I=this;let M=!1,E;return function(){if(M)return E;if(M=!0,S)try{E=D.apply(I,arguments)}finally{S()}else E=D.apply(I,arguments);return E}}e.createSingleCallFunction=w}),define(ue[43],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(D){function S(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}D.is=S;const I=Object.freeze([]);function M(){return I}D.empty=M;function*E(n){yield n}D.single=E;function f(n){return S(n)?n:E(n)}D.wrap=f;function l(n){return n||I}D.from=l;function*P(n){for(let y=n.length-1;y>=0;y--)yield n[y]}D.reverse=P;function p(n){return!n||n[Symbol.iterator]().next().done===!0}D.isEmpty=p;function v(n){return n[Symbol.iterator]().next().value}D.first=v;function s(n,y){for(const O of n)if(y(O))return!0;return!1}D.some=s;function c(n,y){for(const O of n)if(y(O))return O}D.find=c;function*d(n,y){for(const O of n)y(O)&&(yield O)}D.filter=d;function*u(n,y){let O=0;for(const g of n)yield y(g,O++)}D.map=u;function*i(...n){for(const y of n)yield*y}D.concat=i;function o(n,y,O){let g=O;for(const b of n)g=y(g,b);return g}D.reduce=o;function*m(n,y,O=n.length){for(y<0&&(y+=n.length),O<0?O+=n.length:O>n.length&&(O=n.length);y<O;y++)yield n[y]}D.slice=m;function r(n,y=Number.POSITIVE_INFINITY){const O=[];if(y===0)return[O,n];const g=n[Symbol.iterator]();for(let b=0;b<y;b++){const C=g.next();if(C.done)return[O,D.empty()];O.push(C.value)}return[O,{[Symbol.iterator](){return g}}]}D.consume=r;async function t(n){const y=[];for await(const O of n)y.push(O);return Promise.resolve(y)}D.asyncToArray=t})(w||(e.Iterable=w={}))}),define(ue[22],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(S){this.executor=S,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=w}),define(ue[44],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{static{this.Undefined=new w(void 0)}constructor(I){this.element=I,this.next=w.Undefined,this.prev=w.Undefined}}class D{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let I=this._first;for(;I!==w.Undefined;){const M=I.next;I.prev=w.Undefined,I.next=w.Undefined,I=M}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,M){const E=new w(I);if(this._first===w.Undefined)this._first=E,this._last=E;else if(M){const l=this._last;this._last=E,E.prev=l,l.next=E}else{const l=this._first;this._first=E,E.next=l,l.prev=E}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(E))}}shift(){if(this._first!==w.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==w.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==w.Undefined&&I.next!==w.Undefined){const M=I.prev;M.next=I.next,I.next.prev=M}else I.prev===w.Undefined&&I.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):I.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):I.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==w.Undefined;)yield I.element,I=I.next}}e.LinkedList=D}),define(ue[25],he([0,1]),function(oe,e){"use strict";var w,D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function I(m,r,t){let n=m.get(r);return n===void 0&&(n=t,m.set(r,n)),n}e.getOrSet=I;function M(m){const r=[];return m.forEach((t,n)=>{r.push(`${n} => ${t}`)}),`Map(${m.size}) {${r.join(", ")}}`}e.mapToString=M;function E(m){const r=[];return m.forEach(t=>{r.push(t)}),`Set(${m.size}) {${r.join(", ")}}`}e.setToString=E;class f{constructor(r,t){this.uri=r,this.value=t}}function l(m){return Array.isArray(m)}class P{static{this.defaultToKey=r=>r.toString()}constructor(r,t){if(this[w]="ResourceMap",r instanceof P)this.map=new Map(r.map),this.toKey=t??P.defaultToKey;else if(l(r)){this.map=new Map,this.toKey=t??P.defaultToKey;for(const[n,y]of r)this.set(n,y)}else this.map=new Map,this.toKey=r??P.defaultToKey}set(r,t){return this.map.set(this.toKey(r),new f(r,t)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,t){typeof t<"u"&&(r=r.bind(t));for(const[n,y]of this.map)r(y.value,y.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=P;class p{constructor(r,t){this[D]="ResourceSet",!r||typeof r=="function"?this._map=new P(r):(this._map=new P(t),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,t){this._map.forEach((n,y)=>r.call(t,y,y,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var v;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class s{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,t=0){const n=this._map.get(r);if(n)return t!==0&&this.touch(n,t),n.value}set(r,t,n=0){let y=this._map.get(r);if(y)y.value=t,n!==0&&this.touch(y,n);else{switch(y={key:r,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(r,y),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const t=this._map.get(r);if(t)return this._map.delete(r),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,t){const n=this._state;let y=this._head;for(;y;){if(t?r.bind(t)(y.value,y.key,this):r(y.value,y.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const r=this,t=this._state;let n=this._head;const y={[Symbol.iterator](){return y},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const O={value:n.key,done:!1};return n=n.next,O}else return{value:void 0,done:!0}}};return y}values(){const r=this,t=this._state;let n=this._head;const y={[Symbol.iterator](){return y},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const O={value:n.value,done:!1};return n=n.next,O}else return{value:void 0,done:!0}}};return y}entries(){const r=this,t=this._state;let n=this._head;const y={[Symbol.iterator](){return y},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const O={value:[n.key,n.value],done:!1};return n=n.next,O}else return{value:void 0,done:!0}}};return y}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>r;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const t=r.next,n=r.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}r.next=void 0,r.previous=void 0,this._state++}touch(r,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(r===this._head)return;const n=r.next,y=r.previous;r===this._tail?(y.next=void 0,this._tail=y):(n.previous=y,y.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(t===2){if(r===this._tail)return;const n=r.next,y=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=y,y.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((t,n)=>{r.push([n,t])}),r}fromJSON(r){this.clear();for(const[t,n]of r)this.set(t,n)}}e.LinkedMap=s;class c extends s{constructor(r,t=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,t=2){return super.get(r,t)}peek(r){return super.get(r,0)}set(r,t){return super.set(r,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class d{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let t=this.map.get(r)||0;return t===0?!1:(t--,t===0?this.map.delete(r):this.map.set(r,t),!0)}has(r){return this.map.has(r)}}e.CounterSet=d;class u{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[t,n]of r)this.set(t,n)}clear(){this._m1.clear(),this._m2.clear()}set(r,t){this._m1.set(r,t),this._m2.set(t,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const t=this._m1.get(r);return t===void 0?!1:(this._m1.delete(r),this._m2.delete(t),!0)}forEach(r,t){this._m1.forEach((n,y)=>{r.call(t,n,y,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=u;class i{constructor(){this.map=new Map}add(r,t){let n=this.map.get(r);n||(n=new Set,this.map.set(r,n)),n.add(t)}delete(r,t){const n=this.map.get(r);n&&(n.delete(t),n.size===0&&this.map.delete(r))}forEach(r,t){const n=this.map.get(r);n&&n.forEach(t)}get(r){const t=this.map.get(r);return t||new Set}}e.SetMap=i;function o(m,r){if(m===r)return!0;if(m.size!==r.size)return!1;for(const[t,n]of m)if(!r.has(t)||r.get(t)!==n)return!1;for(const[t]of r)if(!m.has(t))return!1;return!0}e.mapsStrictEqualIgnoreOrder=o}),define(ue[2],he([0,1,16,41,25,29,43]),function(oe,e,w,D,S,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const E=!1;let f=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(k){let q=this.livingDisposables.get(k);return q||(q={parent:null,source:null,isSingleton:!1,value:k,idx:l.idx++},this.livingDisposables.set(k,q)),q}trackDisposable(k){const q=this.getDisposableData(k);q.source||(q.source=new Error().stack)}setParent(k,q){const R=this.getDisposableData(k);R.parent=q}markAsDisposed(k){this.livingDisposables.delete(k)}markAsSingleton(k){this.getDisposableData(k).isSingleton=!0}getRootParent(k,q){const R=q.get(k);if(R)return R;const z=k.parent?this.getRootParent(this.getDisposableData(k.parent),q):k;return q.set(k,z),z}getTrackedDisposables(){const k=new Map;return[...this.livingDisposables.entries()].filter(([,R])=>R.source!==null&&!this.getRootParent(R,k).isSingleton).flatMap(([R])=>R)}computeLeakingDisposables(k=10,q){let R;if(q)R=q;else{const se=new Map,ce=[...this.livingDisposables.values()].filter(K=>K.source!==null&&!this.getRootParent(K,se).isSingleton);if(ce.length===0)return;const fe=new Set(ce.map(K=>K.value));if(R=ce.filter(K=>!(K.parent&&fe.has(K.parent))),R.length===0)throw new Error("There are cyclic diposable chains!")}if(!R)return;function z(se){function ce(K,W){for(;K.length>0&&W.some(Y=>typeof Y=="string"?Y===K[0]:K[0].match(Y));)K.shift()}const fe=se.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return ce(fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),fe.reverse()}const ne=new S.SetMap;for(const se of R){const ce=z(se);for(let fe=0;fe<=ce.length;fe++)ne.add(ce.slice(0,fe).join(`
`),se)}R.sort((0,w.compareBy)(se=>se.idx,w.numberComparator));let re="",X=0;for(const se of R.slice(0,k)){X++;const ce=z(se),fe=[];for(let K=0;K<ce.length;K++){let W=ce[K];W=`(shared with ${ne.get(ce.slice(0,K+1).join(`
`)).size}/${R.length} leaks) at ${W}`;const te=ne.get(ce.slice(0,K).join(`
`)),j=(0,D.groupBy)([...te].map(ee=>z(ee)[K]),ee=>ee);delete j[ce[K]];for(const[ee,me]of Object.entries(j))fe.unshift(`    - stacktraces of ${me.length} other leaks continue with ${ee}`);fe.unshift(W)}re+=`


==================== Leaking disposable ${X}/${R.length}: ${se.value.constructor.name} ====================
${fe.join(`
`)}
============================================================

`}return R.length>k&&(re+=`


... and ${R.length-k} more leaking disposables

`),{leaks:R,details:re}}}e.DisposableTracker=l;function P(_){f=_}if(e.setDisposableTracker=P,E){const _="__is_disposable_tracked__";P(new class{trackDisposable(k){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[_]||console.log(q)},3e3)}setParent(k,q){if(k&&k!==n.None)try{k[_]=!0}catch{}}markAsDisposed(k){if(k&&k!==n.None)try{k[_]=!0}catch{}}markAsSingleton(k){}})}function p(_){return f?.trackDisposable(_),_}e.trackDisposable=p;function v(_){f?.markAsDisposed(_)}e.markAsDisposed=v;function s(_,k){f?.setParent(_,k)}function c(_,k){if(f)for(const q of _)f.setParent(q,k)}function d(_){return f?.markAsSingleton(_),_}e.markAsSingleton=d;function u(_){return typeof _.dispose=="function"&&_.dispose.length===0}e.isDisposable=u;function i(_){if(M.Iterable.is(_)){const k=[];for(const q of _)if(q)try{q.dispose()}catch(R){k.push(R)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}e.dispose=i;function o(_){for(const k of _)u(k)&&k.dispose();return[]}e.disposeIfDisposable=o;function m(..._){const k=r(()=>i(_));return c(_,k),k}e.combinedDisposable=m;function r(_){const k=p({dispose:(0,I.createSingleCallFunction)(()=>{v(k),_()})});return k}e.toDisposable=r;class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{i(this._toDispose)}finally{this._toDispose.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return s(k,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(k),k.dispose()}}deleteAndLeak(k){k&&this._toDispose.has(k)&&(this._toDispose.delete(k),s(k,null))}}e.DisposableStore=t;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,p(this),s(this._store,this)}dispose(){v(this),this._store.dispose()}_register(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(k)}}e.Disposable=n;class y{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(k){this._isDisposed||k===this._value||(this._value?.dispose(),k&&s(k,this),this._value=k)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const k=this._value;return this._value=void 0,k&&s(k,null),k}}e.MutableDisposable=y;class O{constructor(k){this._disposable=new y,this._isDisposed=!1,this._disposable.value=k}get value(){return this._disposable.value}set value(k){this._isDisposed||k===this._disposable.value||(this._disposable.value=k)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=O;class g{constructor(k){this._disposable=k,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(k){let q=k;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,v(this))},this}}e.SafeDisposable=b;class C{constructor(){this.references=new Map}acquire(k,...q){let R=this.references.get(k);R||(R={counter:0,object:this.createReferencedObject(k,...q)},this.references.set(k,R));const{object:z}=R,ne=(0,I.createSingleCallFunction)(()=>{--R.counter===0&&(this.destroyReferencedObject(k,R.object),this.references.delete(k))});return R.counter++,{object:z,dispose:ne}}}e.ReferenceCollection=C;class A{constructor(k){this.referenceCollection=k}async acquire(k,...q){const R=this.referenceCollection.acquire(k,...q);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(z){throw R.dispose(),z}}}e.AsyncReferenceCollection=A;class ${constructor(k){this.object=k}dispose(){}}e.ImmortalReference=$;function B(_){const k=new t;try{_(k)}finally{k.dispose()}}e.disposeOnReturn=B;class a{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{i(this._store.values())}finally{this._store.clear()}}has(k){return this._store.has(k)}get size(){return this._store.size}get(k){return this._store.get(k)}set(k,q,R=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this._store.get(k)?.dispose(),this._store.set(k,q)}deleteAndDispose(k){this._store.get(k)?.dispose(),this._store.delete(k)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=a}),define(ue[45],he([0,1,25]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const D=new w.LRUCache(1e4);function S(l){return f(l,"NFC",D)}e.normalizeNFC=S;const I=new w.LRUCache(1e4);function M(l){return f(l,"NFD",I)}e.normalizeNFD=M;const E=/[^\u0000-\u0080]/;function f(l,P,p){if(!l)return l;const v=p.get(l);if(v)return v;let s;return E.test(l)?s=l.normalize(P):s=l,p.set(l,s),s}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(P){return M(P).replace(l,"")}}()}),function(){function oe(S){const I=[];typeof S=="number"&&I.push("code/timeOrigin",S);function M(f){I.push(f,Date.now())}function E(){const f=[];for(let l=0;l<I.length;l+=2)f.push({name:I[l],startTime:I[l+1]});return f}return{mark:M,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const M of performance.getEntriesByType("mark"))I.push({name:M.name,startTime:Math.round(S+M.startTime)});return I}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=w(D))}(),define(ue[46],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const w=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(I){return new D(I)}constructor(I){this._now=w&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=D}),define(ue[4],he([0,1,6,29,2,44,46]),function(oe,e,w,D,S,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const E=!1,f=!1;var l;(function(B){B.None=()=>S.Disposable.None;function a(L){if(f){const{onDidAddListener:F}=L,G=c.create();let Z=0;L.onDidAddListener=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),F?.()}}}function _(L,F){return fe(L,()=>{},0,void 0,!0,void 0,F)}B.defer=_;function k(L){return(F,G=null,Z)=>{let le=!1,pe;return pe=L(ye=>{if(!le)return pe?pe.dispose():le=!0,F.call(G,ye)},null,Z),le&&pe.dispose(),pe}}B.once=k;function q(L,F,G){return se((Z,le=null,pe)=>L(ye=>Z.call(le,F(ye)),null,pe),G)}B.map=q;function R(L,F,G){return se((Z,le=null,pe)=>L(ye=>{F(ye),Z.call(le,ye)},null,pe),G)}B.forEach=R;function z(L,F,G){return se((Z,le=null,pe)=>L(ye=>F(ye)&&Z.call(le,ye),null,pe),G)}B.filter=z;function ne(L){return L}B.signal=ne;function re(...L){return(F,G=null,Z)=>{const le=(0,S.combinedDisposable)(...L.map(pe=>pe(ye=>F.call(G,ye))));return ce(le,Z)}}B.any=re;function X(L,F,G,Z){let le=G;return q(L,pe=>(le=F(le,pe),le),Z)}B.reduce=X;function se(L,F){let G;const Z={onWillAddFirstListener(){G=L(le.fire,le)},onDidRemoveLastListener(){G?.dispose()}};F||a(Z);const le=new m(Z);return F?.add(le),le.event}function ce(L,F){return F instanceof Array?F.push(L):F&&F.add(L),L}function fe(L,F,G=100,Z=!1,le=!1,pe,ye){let we,Ce,Ie,Oe=0,Re;const Ne={leakWarningThreshold:pe,onWillAddFirstListener(){we=L(Se=>{Oe++,Ce=F(Ce,Se),Z&&!Ie&&(Me.fire(Ce),Ce=void 0),Re=()=>{const qe=Ce;Ce=void 0,Ie=void 0,(!Z||Oe>1)&&Me.fire(qe),Oe=0},typeof G=="number"?(clearTimeout(Ie),Ie=setTimeout(Re,G)):Ie===void 0&&(Ie=0,queueMicrotask(Re))})},onWillRemoveListener(){le&&Oe>0&&Re?.()},onDidRemoveLastListener(){Re=void 0,we.dispose()}};ye||a(Ne);const Me=new m(Ne);return ye?.add(Me),Me.event}B.debounce=fe;function K(L,F=0,G){return B.debounce(L,(Z,le)=>Z?(Z.push(le),Z):[le],F,void 0,!0,void 0,G)}B.accumulate=K;function W(L,F=(Z,le)=>Z===le,G){let Z=!0,le;return z(L,pe=>{const ye=Z||!F(pe,le);return Z=!1,le=pe,ye},G)}B.latch=W;function Y(L,F,G){return[B.filter(L,F,G),B.filter(L,Z=>!F(Z),G)]}B.split=Y;function te(L,F=!1,G=[],Z){let le=G.slice(),pe=L(Ce=>{le?le.push(Ce):we.fire(Ce)});Z&&Z.add(pe);const ye=()=>{le?.forEach(Ce=>we.fire(Ce)),le=null},we=new m({onWillAddFirstListener(){pe||(pe=L(Ce=>we.fire(Ce)),Z&&Z.add(pe))},onDidAddFirstListener(){le&&(F?setTimeout(ye):ye())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return Z&&Z.add(we),we.event}B.buffer=te;function j(L,F){return(Z,le,pe)=>{const ye=F(new me);return L(function(we){const Ce=ye.evaluate(we);Ce!==ee&&Z.call(le,Ce)},void 0,pe)}}B.chain=j;const ee=Symbol("HaltChainable");class me{constructor(){this.steps=[]}map(F){return this.steps.push(F),this}forEach(F){return this.steps.push(G=>(F(G),G)),this}filter(F){return this.steps.push(G=>F(G)?G:ee),this}reduce(F,G){let Z=G;return this.steps.push(le=>(Z=F(Z,le),Z)),this}latch(F=(G,Z)=>G===Z){let G=!0,Z;return this.steps.push(le=>{const pe=G||!F(le,Z);return G=!1,Z=le,pe?le:ee}),this}evaluate(F){for(const G of this.steps)if(F=G(F),F===ee)break;return F}}function x(L,F,G=Z=>Z){const Z=(...we)=>ye.fire(G(...we)),le=()=>L.on(F,Z),pe=()=>L.removeListener(F,Z),ye=new m({onWillAddFirstListener:le,onDidRemoveLastListener:pe});return ye.event}B.fromNodeEventEmitter=x;function h(L,F,G=Z=>Z){const Z=(...we)=>ye.fire(G(...we)),le=()=>L.addEventListener(F,Z),pe=()=>L.removeEventListener(F,Z),ye=new m({onWillAddFirstListener:le,onDidRemoveLastListener:pe});return ye.event}B.fromDOMEventEmitter=h;function U(L){return new Promise(F=>k(L)(F))}B.toPromise=U;function ie(L){const F=new m;return L.then(G=>{F.fire(G)},()=>{F.fire(void 0)}).finally(()=>{F.dispose()}),F.event}B.fromPromise=ie;function T(L,F,G){return F(G),L(Z=>F(Z))}B.runAndSubscribe=T;class Q{constructor(F,G){this._observable=F,this._counter=0,this._hasChanged=!1;const Z={onWillAddFirstListener:()=>{F.addObserver(this)},onDidRemoveLastListener:()=>{F.removeObserver(this)}};G||a(Z),this.emitter=new m(Z),G&&G.add(this.emitter)}beginUpdate(F){this._counter++}handlePossibleChange(F){}handleChange(F,G){this._hasChanged=!0}endUpdate(F){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function H(L,F){return new Q(L,F).emitter.event}B.fromObservable=H;function V(L){return(F,G,Z)=>{let le=0,pe=!1;const ye={beginUpdate(){le++},endUpdate(){le--,le===0&&(L.reportChanges(),pe&&(pe=!1,F.call(G)))},handlePossibleChange(){},handleChange(){pe=!0}};L.addObserver(ye),L.reportChanges();const we={dispose(){L.removeObserver(ye)}};return Z instanceof S.DisposableStore?Z.add(we):Array.isArray(Z)&&Z.push(we),we}}B.fromObservableLight=V})(l||(e.Event=l={}));class P{static{this.all=new Set}static{this._idPool=0}constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${P._idPool++}`,P.all.add(this)}start(a){this._stopWatch=new M.StopWatch,this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=P;let p=-1;function v(B){const a=p;return p=B,{dispose(){p=a}}}e.setGlobalLeakWarningThreshold=v;class s{constructor(a,_=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=_,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,_){const k=this.threshold;if(k<=0||_<k)return;this._stacks||(this._stacks=new Map);const q=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,q+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=k*.5;let R,z=0;for(const[ne,re]of this._stacks)(!R||z<re)&&(R=ne,z=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${z}):`),console.warn(R)}return()=>{const R=this._stacks.get(a.value)||0;this._stacks.set(a.value,R-1)}}}class c{static create(){return new c(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let d=0;class u{constructor(a){this.value=a,this.id=d++}}const i=2,o=(B,a)=>{if(B instanceof u)a(B);else for(let _=0;_<B.length;_++){const k=B[_];k&&a(k)}};class m{constructor(a){this._size=0,this._options=a,this._leakageMon=p>0||this._options?.leakWarningThreshold?new s(this._options?.leakWarningThreshold??p):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(E){const a=this._listeners;queueMicrotask(()=>{o(a,_=>_.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(a,_,k)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.Disposable.None;if(this._disposed)return S.Disposable.None;_&&(a=a.bind(_));const q=new u(a);let R,z;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(q.stack=c.create(),R=this._leakageMon.check(q.stack,this._size+1)),E&&(q.stack=z??c.create()),this._listeners?this._listeners instanceof u?(this._deliveryQueue??=new t,this._listeners=[this._listeners,q]):this._listeners.push(q):(this._options?.onWillAddFirstListener?.(this),this._listeners=q,this._options?.onDidAddFirstListener?.(this)),this._size++;const ne=(0,S.toDisposable)(()=>{R?.(),this._removeListener(q)});return k instanceof S.DisposableStore?k.add(ne):Array.isArray(k)&&k.push(ne),ne},this._event}_removeListener(a){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const _=this._listeners,k=_.indexOf(a);if(k===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,_[k]=void 0;const q=this._deliveryQueue.current===this;if(this._size*i<=_.length){let R=0;for(let z=0;z<_.length;z++)_[z]?_[R++]=_[z]:q&&(this._deliveryQueue.end--,R<this._deliveryQueue.i&&this._deliveryQueue.i--);_.length=R}}_deliver(a,_){if(!a)return;const k=this._options?.onListenerError||w.onUnexpectedError;if(!k){a.value(_);return}try{a.value(_)}catch(q){k(q)}}_deliverQueue(a){const _=a.current._listeners;for(;a.i<a.end;)this._deliver(_[a.i++],a.value);a.reset()}fire(a){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,a);else{const _=this._deliveryQueue;_.enqueue(this,a,this._listeners.length),this._deliverQueue(_)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=m;const r=()=>new t;e.createEventDeliveryQueue=r;class t{constructor(){this.i=-1,this.end=0}enqueue(a,_,k){this.i=0,this.end=k,this.current=a,this.value=_}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends m{async fireAsync(a,_,k){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList),o(this._listeners,q=>this._asyncDeliveryQueue.push([q.value,a]));this._asyncDeliveryQueue.size>0&&!_.isCancellationRequested;){const[q,R]=this._asyncDeliveryQueue.shift(),z=[],ne={...R,token:_,waitUntil:re=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");k&&(re=k(re,q)),z.push(re)}};try{q(ne)}catch(re){(0,w.onUnexpectedError)(re);continue}Object.freeze(z),await Promise.allSettled(z).then(re=>{for(const X of re)X.status==="rejected"&&(0,w.onUnexpectedError)(X.reason)})}}}e.AsyncEmitter=n;class y extends m{get isPaused(){return this._isPaused!==0}constructor(a){super(a),this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._size&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=y;class O extends y{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=O;class g extends m{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this.hasListeners()&&(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(_=>super.fire(_)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=g;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const _={event:a,listener:null};this.events.push(_),this.hasListeners&&this.hook(_);const k=()=>{this.hasListeners&&this.unhook(_);const q=this.events.indexOf(_);this.events.splice(q,1)};return(0,S.toDisposable)((0,D.createSingleCallFunction)(k))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(_=>this.emitter.fire(_))}unhook(a){a.listener?.dispose(),a.listener=null}dispose(){this.emitter.dispose();for(const a of this.events)a.listener?.dispose();this.events=[]}}e.EventMultiplexer=b;class C{constructor(a,_,k,q){this._store=new S.DisposableStore;const R=this._store.add(new b),z=this._store.add(new S.DisposableMap);function ne(re){z.set(re,R.add(q(re)))}for(const re of a)ne(re);this._store.add(_(re=>{ne(re)})),this._store.add(k(re=>{z.deleteAndDispose(re)})),this.event=R.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=C;class A{constructor(){this.buffers=[]}wrapEvent(a){return(_,k,q)=>a(R=>{const z=this.buffers[this.buffers.length-1];z?z.push(()=>_.call(k,R)):_.call(k,R)},void 0,q)}bufferEvents(a){const _=[];this.buffers.push(_);const k=a();return this.buffers.pop(),_.forEach(q=>q()),k}}e.EventBufferer=A;class ${constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=S.Disposable.None,this.emitter=new m({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=$}),define(ue[17],he([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(E,f){const l=setTimeout(E.bind(f),0);return{dispose(){clearTimeout(l)}}});var S;(function(E){function f(l){return l===E.None||l===E.Cancelled||l instanceof I?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}E.isCancellationToken=f,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(S||(e.CancellationToken=S={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=S.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=M}),define(ue[47],he([0,1,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class D{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new w.CancellationTokenSource,f=this.task(E.token);return this.result={promise:f,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=D;class S{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const f=JSON.stringify(E);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=S;class I{get cachedValues(){return this._map}constructor(E){this.fn=E,this._map=new Map}get(E){if(this._map.has(E))return this._map.get(E);const f=this.fn(E);return this._map.set(E,f),f}}e.CachedFunction=I}),define(ue[48],he([0,1,6,2]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(r){const t=r;return t?typeof t.read=="function":!1}e.isReadable=S;function I(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=I;function M(r){const t=r;return t?I(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(r,t){return new f(r,t)}e.newWriteableStream=E;class f{constructor(t,n){this.reducer=t,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(n=>n(t))}emitError(t){this.listeners.error.length===0?(0,w.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(n=>n(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,n){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(t,n){if(this.state.destroyed)return;let y;switch(t){case"data":y=this.listeners.data;break;case"end":y=this.listeners.end;break;case"error":y=this.listeners.error;break}if(y){const O=y.indexOf(n);O>=0&&y.splice(O,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(y=>y())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(r,t){const n=[];let y;for(;(y=r.read())!==null;)n.push(y);return t(n)}e.consumeReadable=l;function P(r,t,n){const y=[];let O;for(;(O=r.read())!==null&&y.length<n;)y.push(O);return O===null&&y.length>0?t(y):{read:()=>{if(y.length>0)return y.shift();if(typeof O<"u"){const g=O;return O=void 0,g}return r.read()}}}e.peekReadable=P;function p(r,t){return new Promise((n,y)=>{const O=[];v(r,{onData:g=>{t&&O.push(g)},onError:g=>{t?y(g):n(void 0)},onEnd:()=>{n(t?t(O):void 0)}})})}e.consumeStream=p;function v(r,t,n){r.on("error",y=>{n?.isCancellationRequested||t.onError(y)}),r.on("end",()=>{n?.isCancellationRequested||t.onEnd()}),r.on("data",y=>{n?.isCancellationRequested||t.onData(y)})}e.listenStream=v;function s(r,t){return new Promise((n,y)=>{const O=new D.DisposableStore,g=[],b=$=>{if(g.push($),g.length>t)return O.dispose(),r.pause(),n({stream:r,buffer:g,ended:!1})},C=$=>(O.dispose(),y($)),A=()=>(O.dispose(),n({stream:r,buffer:g,ended:!0}));O.add((0,D.toDisposable)(()=>r.removeListener("error",C))),r.on("error",C),O.add((0,D.toDisposable)(()=>r.removeListener("end",A))),r.on("end",A),O.add((0,D.toDisposable)(()=>r.removeListener("data",b))),r.on("data",b)})}e.peekStream=s;function c(r,t){const n=E(t);return n.end(r),n}e.toStream=c;function d(){const r=E(()=>{throw new Error("not supported")});return r.end(),r}e.emptyStream=d;function u(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}e.toReadable=u;function i(r,t,n){const y=E(n);return v(r,{onData:O=>y.write(t.data(O)),onError:O=>y.error(t.error?t.error(O):O),onEnd:()=>y.end()}),y}e.transform=i;function o(r,t,n){let y=!1;return{read:()=>{const O=t.read();return y?O:(y=!0,O!==null?n([r,O]):r)}}}e.prefixedReadable=o;function m(r,t,n){let y=!1;const O=E(n);return v(t,{onData:g=>y?O.write(g):(y=!0,O.write(n([r,g]))),onError:g=>O.error(g),onEnd:()=>{y||(y=!0,O.write(r)),O.end()}}),O}e.prefixedStream=m}),define(ue[18],he([0,1,22,48]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const S=typeof Buffer<"u",I=new w.Lazy(()=>new Uint8Array(256));let M,E;class f{static alloc(_){return S?new f(Buffer.allocUnsafe(_)):new f(new Uint8Array(_))}static wrap(_){return S&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new f(_)}static fromString(_,k){return!(k?.dontUseNodeBuffer||!1)&&S?new f(Buffer.from(_)):(M||(M=new TextEncoder),new f(M.encode(_)))}static fromByteArray(_){const k=f.alloc(_.length);for(let q=0,R=_.length;q<R;q++)k.buffer[q]=_[q];return k}static concat(_,k){if(typeof k>"u"){k=0;for(let z=0,ne=_.length;z<ne;z++)k+=_[z].byteLength}const q=f.alloc(k);let R=0;for(let z=0,ne=_.length;z<ne;z++){const re=_[z];q.set(re,R),R+=re.byteLength}return q}constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}clone(){const _=f.alloc(this.byteLength);return _.set(this),_}toString(){return S?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(_,k){return new f(this.buffer.subarray(_,k))}set(_,k){if(_ instanceof f)this.buffer.set(_.buffer,k);else if(_ instanceof Uint8Array)this.buffer.set(_,k);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),k);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return v(this.buffer,_)}writeUInt32BE(_,k){s(this.buffer,_,k)}readUInt32LE(_){return c(this.buffer,_)}writeUInt32LE(_,k){d(this.buffer,_,k)}readUInt8(_){return u(this.buffer,_)}writeUInt8(_,k){i(this.buffer,_,k)}indexOf(_,k=0){return l(this.buffer,_ instanceof f?_.buffer:_,k)}}e.VSBuffer=f;function l(a,_,k=0){const q=_.byteLength,R=a.byteLength;if(q===0)return 0;if(q===1)return a.indexOf(_[0]);if(q>R-k)return-1;const z=I.value;z.fill(_.length);for(let se=0;se<_.length;se++)z[_[se]]=_.length-se-1;let ne=k+_.length-1,re=ne,X=-1;for(;ne<R;)if(a[ne]===_[re]){if(re===0){X=ne;break}ne--,re--}else ne+=Math.max(_.length-re,z[a[ne]]),re=_.length-1;return X}e.binaryIndexOf=l;function P(a,_){return a[_+0]<<0>>>0|a[_+1]<<8>>>0}e.readUInt16LE=P;function p(a,_,k){a[k+0]=_&255,_=_>>>8,a[k+1]=_&255}e.writeUInt16LE=p;function v(a,_){return a[_]*2**24+a[_+1]*2**16+a[_+2]*2**8+a[_+3]}e.readUInt32BE=v;function s(a,_,k){a[k+3]=_,_=_>>>8,a[k+2]=_,_=_>>>8,a[k+1]=_,_=_>>>8,a[k]=_}e.writeUInt32BE=s;function c(a,_){return a[_+0]<<0>>>0|a[_+1]<<8>>>0|a[_+2]<<16>>>0|a[_+3]<<24>>>0}e.readUInt32LE=c;function d(a,_,k){a[k+0]=_&255,_=_>>>8,a[k+1]=_&255,_=_>>>8,a[k+2]=_&255,_=_>>>8,a[k+3]=_&255}e.writeUInt32LE=d;function u(a,_){return a[_]}e.readUInt8=u;function i(a,_,k){a[k]=_}e.writeUInt8=i;function o(a){return D.consumeReadable(a,_=>f.concat(_))}e.readableToBuffer=o;function m(a){return D.toReadable(a)}e.bufferToReadable=m;function r(a){return D.consumeStream(a,_=>f.concat(_))}e.streamToBuffer=r;async function t(a){return a.ended?f.concat(a.buffer):f.concat([...a.buffer,await r(a.stream)])}e.bufferedStreamToBuffer=t;function n(a){return D.toStream(a,_=>f.concat(_))}e.bufferToStream=n;function y(a){return D.transform(a,{data:_=>typeof _=="string"?f.fromString(_):f.wrap(_)},_=>f.concat(_))}e.streamToBufferReadableStream=y;function O(a){return D.newWriteableStream(_=>f.concat(_),a)}e.newWriteableBufferStream=O;function g(a,_){return D.prefixedReadable(a,_,k=>f.concat(k))}e.prefixedBufferReadable=g;function b(a,_){return D.prefixedStream(a,_,k=>f.concat(k))}e.prefixedBufferStream=b;function C(a){let _=0,k=0,q=0;const R=new Uint8Array(Math.floor(a.length/4*3)),z=re=>{switch(k){case 3:R[q++]=_|re,k=0;break;case 2:R[q++]=_|re>>>2,_=re<<6,k=3;break;case 1:R[q++]=_|re>>>4,_=re<<4,k=2;break;default:_=re<<2,k=1}};for(let re=0;re<a.length;re++){const X=a.charCodeAt(re);if(X>=65&&X<=90)z(X-65);else if(X>=97&&X<=122)z(X-97+26);else if(X>=48&&X<=57)z(X-48+52);else if(X===43||X===45)z(62);else if(X===47||X===95)z(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${a[re]}`)}}const ne=q;for(;k>0;)z(0);return f.wrap(R).slice(0,ne)}e.decodeBase64=C;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:a},_=!0,k=!1){const q=k?$:A;let R="";const z=a.byteLength%3;let ne=0;for(;ne<a.byteLength-z;ne+=3){const re=a[ne+0],X=a[ne+1],se=a[ne+2];R+=q[re>>>2],R+=q[(re<<4|X>>>4)&63],R+=q[(X<<2|se>>>6)&63],R+=q[se&63]}if(z===1){const re=a[ne+0];R+=q[re>>>2],R+=q[re<<4&63],_&&(R+="==")}else if(z===2){const re=a[ne+0],X=a[ne+1];R+=q[re>>>2],R+=q[(re<<4|X>>>4)&63],R+=q[X<<2&63],_&&(R+="=")}return R}e.encodeBase64=B}),define(ue[11],he([0,1,47,22]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLinesIncludeSeparators=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=S;const I=/{(\d+)}/g;function M(N,...J){return J.length===0?N:N.replace(I,function(ae,de){const _e=parseInt(de,10);return isNaN(_e)||_e<0||_e>=J.length?ae:J[_e]})}e.format=M;const E=/{([^}]+)}/g;function f(N,J){return Object.keys(J).length===0?N:N.replace(E,(ae,de)=>J[de]??ae)}e.format2=f;function l(N){return N.replace(/[<>"'&]/g,J=>{switch(J){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return J})}e.htmlAttributeEncodeValue=l;function P(N){return N.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=P;function p(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function v(N,J){let ae=0;const de=J.charCodeAt(0);for(let _e=N.length-1;_e>=0;_e--)N.charCodeAt(_e)===de&&ae++;return ae}e.count=v;function s(N,J,ae="\u2026"){return N.length<=J?N:`${N.substr(0,J)}${ae}`}e.truncate=s;function c(N,J,ae="\u2026"){if(N.length<=J)return N;const de=Math.ceil(J/2)-ae.length/2,_e=Math.floor(J/2)-ae.length/2;return`${N.substr(0,de)}${ae}${N.substr(N.length-_e)}`}e.truncateMiddle=c;function d(N,J=" "){const ae=u(N,J);return i(ae,J)}e.trim=d;function u(N,J){if(!N||!J)return N;const ae=J.length;if(ae===0||N.length===0)return N;let de=0;for(;N.indexOf(J,de)===de;)de=de+ae;return N.substring(de)}e.ltrim=u;function i(N,J){if(!N||!J)return N;const ae=J.length,de=N.length;if(ae===0||de===0)return N;let _e=de,ve=-1;for(;ve=N.lastIndexOf(J,_e-1),!(ve===-1||ve+ae!==_e);){if(ve===0)return"";_e=ve}return N.substring(0,_e)}e.rtrim=i;function o(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function m(N){return N.replace(/\*/g,"")}e.stripWildcards=m;function r(N,J,ae={}){if(!N)throw new Error("Cannot create regex from empty string");J||(N=p(N)),ae.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let de="";return ae.global&&(de+="g"),ae.matchCase||(de+="i"),ae.multiline&&(de+="m"),ae.unicode&&(de+="u"),new RegExp(N,de)}e.createRegExp=r;function t(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=t;function n(N){return N.split(/\r\n|\r|\n/)}e.splitLines=n;function y(N){const J=[],ae=N.split(/(\r\n|\r|\n)/);for(let de=0;de<Math.ceil(ae.length/2);de++)J.push(ae[2*de]+(ae[2*de+1]??""));return J}e.splitLinesIncludeSeparators=y;function O(N){for(let J=0,ae=N.length;J<ae;J++){const de=N.charCodeAt(J);if(de!==32&&de!==9)return J}return-1}e.firstNonWhitespaceIndex=O;function g(N,J=0,ae=N.length){for(let de=J;de<ae;de++){const _e=N.charCodeAt(de);if(_e!==32&&_e!==9)return N.substring(J,de)}return N.substring(J,ae)}e.getLeadingWhitespace=g;function b(N,J=N.length-1){for(let ae=J;ae>=0;ae--){const de=N.charCodeAt(ae);if(de!==32&&de!==9)return ae}return-1}e.lastNonWhitespaceIndex=b;function C(N,J,ae){const de=[];let _e=0;for(const ve of N.matchAll(J)){if(de.push(N.slice(_e,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");_e=ve.index+ve[0].length,de.push(ae(ve[0],...ve.slice(1),ve.index,N,ve.groups))}return de.push(N.slice(_e)),Promise.all(de).then(ve=>ve.join(""))}e.replaceAsync=C;function A(N,J){return N<J?-1:N>J?1:0}e.compare=A;function $(N,J,ae=0,de=N.length,_e=0,ve=J.length){for(;ae<de&&_e<ve;ae++,_e++){const Pe=N.charCodeAt(ae),Le=J.charCodeAt(_e);if(Pe<Le)return-1;if(Pe>Le)return 1}const be=de-ae,ke=ve-_e;return be<ke?-1:be>ke?1:0}e.compareSubstring=$;function B(N,J){return a(N,J,0,N.length,0,J.length)}e.compareIgnoreCase=B;function a(N,J,ae=0,de=N.length,_e=0,ve=J.length){for(;ae<de&&_e<ve;ae++,_e++){let Pe=N.charCodeAt(ae),Le=J.charCodeAt(_e);if(Pe===Le)continue;if(Pe>=128||Le>=128)return $(N.toLowerCase(),J.toLowerCase(),ae,de,_e,ve);k(Pe)&&(Pe-=32),k(Le)&&(Le-=32);const Ee=Pe-Le;if(Ee!==0)return Ee}const be=de-ae,ke=ve-_e;return be<ke?-1:be>ke?1:0}e.compareSubstringIgnoreCase=a;function _(N){return N>=48&&N<=57}e.isAsciiDigit=_;function k(N){return N>=97&&N<=122}e.isLowerAsciiLetter=k;function q(N){return N>=65&&N<=90}e.isUpperAsciiLetter=q;function R(N,J){return N.length===J.length&&a(N,J)===0}e.equalsIgnoreCase=R;function z(N,J){const ae=J.length;return J.length>N.length?!1:a(N,J,0,ae)===0}e.startsWithIgnoreCase=z;function ne(N,J){const ae=Math.min(N.length,J.length);let de;for(de=0;de<ae;de++)if(N.charCodeAt(de)!==J.charCodeAt(de))return de;return ae}e.commonPrefixLength=ne;function re(N,J){const ae=Math.min(N.length,J.length);let de;const _e=N.length-1,ve=J.length-1;for(de=0;de<ae;de++)if(N.charCodeAt(_e-de)!==J.charCodeAt(ve-de))return de;return ae}e.commonSuffixLength=re;function X(N){return 55296<=N&&N<=56319}e.isHighSurrogate=X;function se(N){return 56320<=N&&N<=57343}e.isLowSurrogate=se;function ce(N,J){return(N-55296<<10)+(J-56320)+65536}e.computeCodePoint=ce;function fe(N,J,ae){const de=N.charCodeAt(ae);if(X(de)&&ae+1<J){const _e=N.charCodeAt(ae+1);if(se(_e))return ce(de,_e)}return de}e.getNextCodePoint=fe;function K(N,J){const ae=N.charCodeAt(J-1);if(se(ae)&&J>1){const de=N.charCodeAt(J-2);if(X(de))return ce(de,ae)}return ae}class W{get offset(){return this._offset}constructor(J,ae=0){this._str=J,this._len=J.length,this._offset=ae}setOffset(J){this._offset=J}prevCodePoint(){const J=K(this._str,this._offset);return this._offset-=J>=65536?2:1,J}nextCodePoint(){const J=fe(this._str,this._len,this._offset);return this._offset+=J>=65536?2:1,J}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class Y{get offset(){return this._iterator.offset}constructor(J,ae=0){this._iterator=new W(J,ae)}nextGraphemeLength(){const J=Se.getInstance(),ae=this._iterator,de=ae.offset;let _e=J.getGraphemeBreakType(ae.nextCodePoint());for(;!ae.eol();){const ve=ae.offset,be=J.getGraphemeBreakType(ae.nextCodePoint());if(Ne(_e,be)){ae.setOffset(ve);break}_e=be}return ae.offset-de}prevGraphemeLength(){const J=Se.getInstance(),ae=this._iterator,de=ae.offset;let _e=J.getGraphemeBreakType(ae.prevCodePoint());for(;ae.offset>0;){const ve=ae.offset,be=J.getGraphemeBreakType(ae.prevCodePoint());if(Ne(be,_e)){ae.setOffset(ve);break}_e=be}return de-ae.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function te(N,J){return new Y(N,J).nextGraphemeLength()}e.nextCharLength=te;function j(N,J){return new Y(N,J).prevGraphemeLength()}e.prevCharLength=j;function ee(N,J){J>0&&se(N.charCodeAt(J))&&J--;const ae=J+te(N,J);return[ae-j(N,ae),ae]}e.getCharContainingOffset=ee;function me(N){const J=new Y(N);let ae=0;for(;!J.eol();)ae++,J.nextGraphemeLength();return ae}e.charCount=me;let x;function h(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(N){return x||(x=h()),x.test(N)}e.containsRTL=U;const ie=/^[\t\n\r\x20-\x7E]*$/;function T(N){return ie.test(N)}e.isBasicASCII=T,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Q(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=Q;function H(N){return N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=H;function V(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129008||N>=129280&&N<=129535||N>=129648&&N<=129782}e.isEmojiImprecise=V;function L(N,J,ae=""){const de=N.trimStart();if(de.length<J)return de;const _e=/\b/g;let ve=0;for(;_e.test(de)&&!(de.length-_e.lastIndex<J);)ve=_e.lastIndex,_e.lastIndex+=1;return ve===0?de:ae+de.substring(ve).trimStart()}e.lcut=L;const F=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Z(N){return N&&(N=N.replace(F,"").replace(G,"")),N}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER="\uFEFF";function le(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function pe(N){return le(N)?N.substr(1):N}e.stripUTF8BOM=pe;function ye(N,J){if(!N||!J||N.length<J.length)return!1;const ae=J.length,de=N.toLowerCase();let _e=0,ve=-1;for(;_e<ae;){const be=de.indexOf(J[_e],ve+1);if(be<0)return!1;ve=be,_e++}return!0}e.fuzzyContains=ye;function we(N,J=!1){return N?(J&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=we;function Ce(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=Ce;function Ie(N,J=1){if(J===0)return"";let ae=-1;do ae=N.indexOf(`
`,ae+1),J--;while(J>0&&ae>=0);return ae===-1?N:(N[ae-1]==="\r"&&ae--,N.substr(0,ae))}e.getNLines=Ie;function Oe(N){return N=N%(2*26),N<26?String.fromCharCode(97+N):String.fromCharCode(65+N-26)}e.singleLetterHash=Oe;function Re(N){return Se.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=Re;function Ne(N,J){return N===0?J!==5&&J!==7:N===2&&J===3?!1:N===4||N===2||N===3||J===4||J===2||J===3?!0:!(N===8&&(J===8||J===9||J===11||J===12)||(N===11||N===9)&&(J===9||J===10)||(N===12||N===10)&&J===10||J===5||J===13||J===7||N===1||N===13&&J===14||N===6&&J===6)}var Me;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(e.GraphemeBreakType=Me={}));class Se{static{this._INSTANCE=null}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const ae=this._data,de=ae.length/3;let _e=1;for(;_e<=de;)if(J<ae[3*_e])_e=2*_e;else if(J>ae[3*_e+1])_e=2*_e+1;else return ae[3*_e+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(N,J){if(N===0)return 0;const ae=je(N,J);if(ae!==void 0)return ae;const de=new W(J,N);return de.prevCodePoint(),de.offset}e.getLeftDeleteOffset=$e;function je(N,J){const ae=new W(J,N);let de=ae.prevCodePoint();for(;He(de)||de===65039||de===8419;){if(ae.offset===0)return;de=ae.prevCodePoint()}if(!V(de))return;let _e=ae.offset;return _e>0&&ae.prevCodePoint()===8205&&(_e=ae.offset),_e}function He(N){return 127995<=N&&N<=127999}var Be;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class Te{static{this.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new w.LRUCachedFunction(J=>{function ae(Ee){const Ae=new Map;for(let De=0;De<Ee.length;De+=2)Ae.set(Ee[De],Ee[De+1]);return Ae}function de(Ee,Ae){const De=new Map(Ee);for(const[ze,We]of Ae)De.set(ze,We);return De}function _e(Ee,Ae){if(!Ee)return Ae;const De=new Map;for(const[ze,We]of Ee)Ae.has(ze)&&De.set(ze,We);return De}const ve=this.ambiguousCharacterData.value;let be=J.filter(Ee=>!Ee.startsWith("_")&&Ee in ve);be.length===0&&(be=["_default"]);let ke;for(const Ee of be){const Ae=ae(ve[Ee]);ke=_e(ke,Ae)}const Pe=ae(ve._common),Le=de(Pe,ke);return new Te(Le)})}static getInstance(J){return Te.cache.get(Array.from(J))}static{this._locales=new D.Lazy(()=>Object.keys(Te.ambiguousCharacterData.value).filter(J=>!J.startsWith("_")))}static getLocales(){return Te._locales.value}constructor(J){this.confusableDictionary=J}isAmbiguous(J){return this.confusableDictionary.has(J)}getPrimaryConfusable(J){return this.confusableDictionary.get(J)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(J){return Ue.getData().has(J)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue}),define(ue[49],he([0,1,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(i){return S(i,0)}e.hash=D;function S(i,o){switch(typeof i){case"object":return i===null?I(349,o):Array.isArray(i)?f(i,o):l(i,o);case"string":return E(i,o);case"boolean":return M(i,o);case"number":return I(i,o);case"undefined":return I(937,o);default:return I(617,o)}}e.doHash=S;function I(i,o){return(o<<5)-o+i|0}e.numberHash=I;function M(i,o){return I(i?433:863,o)}function E(i,o){o=I(149417,o);for(let m=0,r=i.length;m<r;m++)o=I(i.charCodeAt(m),o);return o}e.stringHash=E;function f(i,o){return o=I(104579,o),i.reduce((m,r)=>S(r,m),o)}function l(i,o){return o=I(181387,o),Object.keys(i).sort().reduce((m,r)=>(m=E(r,m),S(i[r],m)),o)}class P{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=S(o,this._value),this._value}}e.Hasher=P;var p;(function(i){i[i.BLOCK_SIZE=64]="BLOCK_SIZE",i[i.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(i,o,m=32){const r=m-o,t=~((1<<r)-1);return(i<<o|(t&i)>>>r)>>>0}function s(i,o=0,m=i.byteLength,r=0){for(let t=0;t<m;t++)i[o+t]=r}function c(i,o,m="0"){for(;i.length<o;)i=m+i;return i}function d(i,o=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((i>>>0).toString(16),o/4)}e.toHexString=d;class u{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const m=o.length;if(m===0)return;const r=this._buff;let t=this._buffLen,n=this._leftoverHighSurrogate,y,O;for(n!==0?(y=n,O=-1,n=0):(y=o.charCodeAt(0),O=0);;){let g=y;if(w.isHighSurrogate(y))if(O+1<m){const b=o.charCodeAt(O+1);w.isLowSurrogate(b)?(O++,g=w.computeCodePoint(y,b)):g=65533}else{n=y;break}else w.isLowSurrogate(y)&&(g=65533);if(t=this._push(r,t,g),O++,O<m)y=o.charCodeAt(O);else break}this._buffLen=t,this._leftoverHighSurrogate=n}_push(o,m,r){return r<128?o[m++]=r:r<2048?(o[m++]=192|(r&1984)>>>6,o[m++]=128|(r&63)>>>0):r<65536?(o[m++]=224|(r&61440)>>>12,o[m++]=128|(r&4032)>>>6,o[m++]=128|(r&63)>>>0):(o[m++]=240|(r&1835008)>>>18,o[m++]=128|(r&258048)>>>12,o[m++]=128|(r&4032)>>>6,o[m++]=128|(r&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,o[0]=o[64],o[1]=o[65],o[2]=o[66]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,s(this._buff,this._buffLen),this._buffLen>56&&(this._step(),s(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=u._bigBlock32,m=this._buffDV;for(let A=0;A<64;A+=4)o.setUint32(A,m.getUint32(A,!1),!1);for(let A=64;A<320;A+=4)o.setUint32(A,v(o.getUint32(A-12,!1)^o.getUint32(A-32,!1)^o.getUint32(A-56,!1)^o.getUint32(A-64,!1),1),!1);let r=this._h0,t=this._h1,n=this._h2,y=this._h3,O=this._h4,g,b,C;for(let A=0;A<80;A++)A<20?(g=t&n|~t&y,b=1518500249):A<40?(g=t^n^y,b=1859775393):A<60?(g=t&n|t&y|n&y,b=2400959708):(g=t^n^y,b=3395469782),C=v(r,5)+g+O+b+o.getUint32(A*4,!1)&4294967295,O=y,y=n,n=v(t,30),t=r,r=C;this._h0=this._h0+r&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+y&4294967295,this._h4=this._h4+O&4294967295}}e.StringSHA1=u}),define(ue[50],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ue[51],he([0,1,16,11]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const c=s.charCodeAt(0),d=this._value.charCodeAt(this._pos);return c-d}value(){return this._value[this._pos]}}e.StringIterator=S;class I{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,D.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class M{constructor(s=!0,c=!0){this._splitOnBackslash=s,this._caseSensitive=c}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let c=s.length-1;c>=0;c--,this._valueLen--){const d=this._value.charCodeAt(c);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,D.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var E;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(s,c){this._ignorePathCasing=s,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,D.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(P||(P={}));class p{static forUris(s=()=>!1,c=()=>!1){return new p(new f(s,c))}static forPaths(s=!1){return new p(new M(void 0,!s))}static forStrings(){return new p(new S)}static forConfigKeys(){return new p(new I)}constructor(s){this._iter=s}clear(){this._root=void 0}fill(s,c){if(c){const d=c.slice(0);(0,w.shuffle)(d);for(const u of d)this.set(u,s)}else{const d=s.slice(0);(0,w.shuffle)(d);for(const u of d)this.set(u[0],u[1])}}set(s,c){const d=this._iter.reset(s);let u;this._root||(this._root=new l,this._root.segment=d.value());const i=[];for(u=this._root;;){const m=d.cmp(u.segment);if(m>0)u.left||(u.left=new l,u.left.segment=d.value()),i.push([-1,u]),u=u.left;else if(m<0)u.right||(u.right=new l,u.right.segment=d.value()),i.push([1,u]),u=u.right;else if(d.hasNext())d.next(),u.mid||(u.mid=new l,u.mid.segment=d.value()),i.push([0,u]),u=u.mid;else break}const o=u.value;u.value=c,u.key=s;for(let m=i.length-1;m>=0;m--){const r=i[m][1];r.updateHeight();const t=r.balanceFactor();if(t<-1||t>1){const n=i[m][0],y=i[m+1][0];if(n===1&&y===1)i[m][1]=r.rotateLeft();else if(n===-1&&y===-1)i[m][1]=r.rotateRight();else if(n===1&&y===-1)r.right=i[m+1][1]=i[m+1][1].rotateRight(),i[m][1]=r.rotateLeft();else if(n===-1&&y===1)r.left=i[m+1][1]=i[m+1][1].rotateLeft(),i[m][1]=r.rotateRight();else throw new Error;if(m>0)switch(i[m-1][0]){case-1:i[m-1][1].left=i[m][1];break;case 1:i[m-1][1].right=i[m][1];break;case 0:i[m-1][1].mid=i[m][1];break}else this._root=i[0][1]}}return o}get(s){return this._getNode(s)?.value}_getNode(s){const c=this._iter.reset(s);let d=this._root;for(;d;){const u=c.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else break}return d}has(s){const c=this._getNode(s);return!(c?.value===void 0&&c?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,c){const d=this._iter.reset(s),u=[];let i=this._root;for(;i;){const o=d.cmp(i.segment);if(o>0)u.push([-1,i]),i=i.left;else if(o<0)u.push([1,i]),i=i.right;else if(d.hasNext())d.next(),u.push([0,i]),i=i.mid;else break}if(i){if(c?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const o=this._min(i.right);if(o.key){const{key:m,value:r,segment:t}=o;this._delete(o.key,!1),i.key=m,i.value=r,i.segment=t}}else{const o=i.left??i.right;if(u.length>0){const[m,r]=u[u.length-1];switch(m){case-1:r.left=o;break;case 0:r.mid=o;break;case 1:r.right=o;break}}else this._root=o}for(let o=u.length-1;o>=0;o--){const m=u[o][1];m.updateHeight();const r=m.balanceFactor();if(r>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),u[o][1]=m.rotateLeft()):r<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),u[o][1]=m.rotateRight()),o>0)switch(u[o-1][0]){case-1:u[o-1][1].left=u[o][1];break;case 1:u[o-1][1].right=u[o][1];break;case 0:u[o-1][1].mid=u[o][1];break}else this._root=u[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const c=this._iter.reset(s);let d=this._root,u;for(;d;){const i=c.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if(c.hasNext())c.next(),u=d.value||u,d=d.mid;else break}return d&&d.value||u}findSuperstr(s){return this._findSuperstrOrElement(s,!1)}_findSuperstrOrElement(s,c){const d=this._iter.reset(s);let u=this._root;for(;u;){const i=d.cmp(u.segment);if(i>0)u=u.left;else if(i<0)u=u.right;else if(d.hasNext())d.next(),u=u.mid;else return u.mid?this._entries(u.mid):c?u.value:void 0}}hasElementOrSubtree(s){return this._findSuperstrOrElement(s,!0)!==void 0}forEach(s){for(const[c,d]of this)s(d,c)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(s){const c=[];return this._dfsEntries(s,c),c[Symbol.iterator]()}_dfsEntries(s,c){s&&(s.left&&this._dfsEntries(s.left,c),s.value&&c.push([s.key,s.value]),s.mid&&this._dfsEntries(s.mid,c),s.right&&this._dfsEntries(s.right,c))}_isBalanced(){const s=c=>{if(!c)return!0;const d=c.balanceFactor();return d<-1||d>1?!1:s(c.left)&&s(c.right)};return s(this._root)}}e.TernarySearchTree=p}),define(ue[8],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(t){return typeof t=="string"}e.isString=w;function D(t){return Array.isArray(t)&&t.every(n=>w(n))}e.isStringArray=D;function S(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}e.isObject=S;function I(t){const n=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof n}e.isTypedArray=I;function M(t){return typeof t=="number"&&!isNaN(t)}e.isNumber=M;function E(t){return!!t&&typeof t[Symbol.iterator]=="function"}e.isIterable=E;function f(t){return t===!0||t===!1}e.isBoolean=f;function l(t){return typeof t>"u"}e.isUndefined=l;function P(t){return!p(t)}e.isDefined=P;function p(t){return l(t)||t===null}e.isUndefinedOrNull=p;function v(t,n){if(!t)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=v;function s(t){if(p(t))throw new Error("Assertion Failed: argument is undefined or null");return t}e.assertIsDefined=s;function c(...t){const n=[];for(let y=0;y<t.length;y++){const O=t[y];if(p(O))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);n.push(O)}return n}e.assertAllDefined=c;const d=Object.prototype.hasOwnProperty;function u(t){if(!S(t))return!1;for(const n in t)if(d.call(t,n))return!1;return!0}e.isEmptyObject=u;function i(t){return typeof t=="function"}e.isFunction=i;function o(...t){return t.length>0&&t.every(i)}e.areFunctions=o;function m(t,n){const y=Math.min(t.length,n.length);for(let O=0;O<y;O++)r(t[O],n[O])}e.validateConstraints=m;function r(t,n){if(w(n)){if(typeof t!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(i(n)){try{if(t instanceof n)return}catch{}if(!p(t)&&t.constructor===n||n.length===1&&n.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r}),define(ue[30],he([0,1,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const o=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([m,r])=>{o[m]=r&&typeof r=="object"?D(r):r}),o}e.deepClone=D;function S(i){if(!i||typeof i!="object")return i;const o=[i];for(;o.length>0;){const m=o.shift();Object.freeze(m);for(const r in m)if(I.call(m,r)){const t=m[r];typeof t=="object"&&!Object.isFrozen(t)&&!(0,w.isTypedArray)(t)&&o.push(t)}}return i}e.deepFreeze=S;const I=Object.prototype.hasOwnProperty;function M(i,o){return E(i,o,new Set)}e.cloneAndChange=M;function E(i,o,m){if((0,w.isUndefinedOrNull)(i))return i;const r=o(i);if(typeof r<"u")return r;if(Array.isArray(i)){const t=[];for(const n of i)t.push(E(n,o,m));return t}if((0,w.isObject)(i)){if(m.has(i))throw new Error("Cannot clone recursive data-structure");m.add(i);const t={};for(const n in i)I.call(i,n)&&(t[n]=E(i[n],o,m));return m.delete(i),t}return i}function f(i,o,m=!0){return(0,w.isObject)(i)?((0,w.isObject)(o)&&Object.keys(o).forEach(r=>{r in i?m&&((0,w.isObject)(i[r])&&(0,w.isObject)(o[r])?f(i[r],o[r],m):i[r]=o[r]):i[r]=o[r]}),i):o}e.mixin=f;function l(i,o){if(i===o)return!0;if(i==null||o===null||o===void 0||typeof i!=typeof o||typeof i!="object"||Array.isArray(i)!==Array.isArray(o))return!1;let m,r;if(Array.isArray(i)){if(i.length!==o.length)return!1;for(m=0;m<i.length;m++)if(!l(i[m],o[m]))return!1}else{const t=[];for(r in i)t.push(r);t.sort();const n=[];for(r in o)n.push(r);if(n.sort(),!l(t,n))return!1;for(m=0;m<t.length;m++)if(!l(i[t[m]],o[t[m]]))return!1}return!0}e.equals=l;function P(i){const o=new Set;return JSON.stringify(i,(m,r)=>{if((0,w.isObject)(r)||Array.isArray(r)){if(o.has(r))return"[Circular]";o.add(r)}return r})}e.safeStringify=P;function p(i,o){const m=Object.create(null);return!i||!o||Object.keys(o).forEach(t=>{const n=i[t],y=o[t];l(n,y)||(m[t]=y)}),m}e.distinct=p;function v(i,o){const m=o.toLowerCase(),r=Object.keys(i).find(t=>t.toLowerCase()===m);return r?i[r]:i[o]}e.getCaseInsensitive=v;function s(i,o){const m=Object.create(null);for(const[r,t]of Object.entries(i))o(r,t)&&(m[r]=t);return m}e.filter=s;function c(i){let o=[];for(;Object.prototype!==i;)o=o.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return o}e.getAllPropertyNames=c;function d(i){const o=[];for(const m of c(i))typeof i[m]=="function"&&o.push(m);return o}e.getAllMethodNames=d;function u(i,o){const m=t=>function(){const n=Array.prototype.slice.call(arguments,0);return o(t,n)},r={};for(const t of i)r[t]=m(t);return r}e.createProxyObject=u}),define(ue[52],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(S){return w.test(S)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(E){for(let f=0;f<E.length;f++)E[f]=Math.floor(Math.random()*256);return E};const I=new Uint8Array(16),M=[];for(let E=0;E<256;E++)M.push(E.toString(16).padStart(2,"0"));return function(){S(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let f=0,l="";return l+=M[I[f++]],l+=M[I[f++]],l+=M[I[f++]],l+=M[I[f++]],l+="-",l+=M[I[f++]],l+=M[I[f++]],l+="-",l+=M[I[f++]],l+=M[I[f++]],l+="-",l+=M[I[f++]],l+=M[I[f++]],l+="-",l+=M[I[f++]],l+=M[I[f++]],l+=M[I[f++]],l+=M[I[f++]],l+=M[I[f++]],l+=M[I[f++]],l}}()}),define(ue[31],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function w(D){return!!D.parentPort}e.isUtilityProcess=w}),define(ue[53],he([13,12]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ue[54],he([0,1,53]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.getDurationString=e.fromNow=void 0;const D=60,S=D*60,I=S*24,M=I*7,E=I*30,f=I*365;function l(v,s,c,d){typeof v!="number"&&(v=v.getTime());const u=Math.round((new Date().getTime()-v)/1e3);if(u<-30)return(0,w.localize)(0,null,l(new Date().getTime()+u*1e3,!1));if(!d&&u<30)return(0,w.localize)(1,null);let i;return u<D?(i=u,s?i===1?c?(0,w.localize)(2,null,i):(0,w.localize)(3,null,i):c?(0,w.localize)(4,null,i):(0,w.localize)(5,null,i):i===1?c?(0,w.localize)(6,null,i):(0,w.localize)(7,null,i):c?(0,w.localize)(8,null,i):(0,w.localize)(9,null,i)):u<S?(i=Math.floor(u/D),s?i===1?c?(0,w.localize)(10,null,i):(0,w.localize)(11,null,i):c?(0,w.localize)(12,null,i):(0,w.localize)(13,null,i):i===1?c?(0,w.localize)(14,null,i):(0,w.localize)(15,null,i):c?(0,w.localize)(16,null,i):(0,w.localize)(17,null,i)):u<I?(i=Math.floor(u/S),s?i===1?c?(0,w.localize)(18,null,i):(0,w.localize)(19,null,i):c?(0,w.localize)(20,null,i):(0,w.localize)(21,null,i):i===1?c?(0,w.localize)(22,null,i):(0,w.localize)(23,null,i):c?(0,w.localize)(24,null,i):(0,w.localize)(25,null,i)):u<M?(i=Math.floor(u/I),s?i===1?(0,w.localize)(26,null,i):(0,w.localize)(27,null,i):i===1?(0,w.localize)(28,null,i):(0,w.localize)(29,null,i)):u<E?(i=Math.floor(u/M),s?i===1?c?(0,w.localize)(30,null,i):(0,w.localize)(31,null,i):c?(0,w.localize)(32,null,i):(0,w.localize)(33,null,i):i===1?c?(0,w.localize)(34,null,i):(0,w.localize)(35,null,i):c?(0,w.localize)(36,null,i):(0,w.localize)(37,null,i)):u<f?(i=Math.floor(u/E),s?i===1?c?(0,w.localize)(38,null,i):(0,w.localize)(39,null,i):c?(0,w.localize)(40,null,i):(0,w.localize)(41,null,i):i===1?c?(0,w.localize)(42,null,i):(0,w.localize)(43,null,i):c?(0,w.localize)(44,null,i):(0,w.localize)(45,null,i)):(i=Math.floor(u/f),s?i===1?c?(0,w.localize)(46,null,i):(0,w.localize)(47,null,i):c?(0,w.localize)(48,null,i):(0,w.localize)(49,null,i):i===1?c?(0,w.localize)(50,null,i):(0,w.localize)(51,null,i):c?(0,w.localize)(52,null,i):(0,w.localize)(53,null,i))}e.fromNow=l;function P(v,s){const c=Math.abs(v/1e3);return c<1?s?(0,w.localize)(54,null,v):(0,w.localize)(55,null,v):c<D?s?(0,w.localize)(56,null,Math.round(v)/1e3):(0,w.localize)(57,null,Math.round(v)/1e3):c<S?s?(0,w.localize)(58,null,Math.round(v/(1e3*D))):(0,w.localize)(59,null,Math.round(v/(1e3*D))):c<I?s?(0,w.localize)(60,null,Math.round(v/(1e3*S))):(0,w.localize)(61,null,Math.round(v/(1e3*S))):(0,w.localize)(62,null,Math.round(v/(1e3*I)))}e.getDurationString=P;function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(ue[55],he([13,12]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ue[56],he([0,1,16,8,55]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function I(p,v){return v&&(p.stack||p.stacktrace)?S.localize(0,null,E(p),M(p.stack)||M(p.stacktrace)):E(p)}function M(p){return Array.isArray(p)?p.join(`
`):p}function E(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?S.localize(1,null,p.message):p.message||S.localize(2,null)}function f(p=null,v=!1){if(!p)return S.localize(3,null);if(Array.isArray(p)){const s=w.coalesce(p),c=f(s[0],v);return s.length>1?S.localize(4,null,c,s.length):c}if(D.isString(p))return p;if(p.detail){const s=p.detail;if(s.error)return I(s.error,v);if(s.exception)return I(s.exception,v)}return p.stack?I(p,v):p.message?p.message:S.localize(5,null)}e.toErrorMessage=f;function l(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=l;function P(p,v){let s;return typeof p=="string"?s=new Error(p):s=p,s.actions=v,s}e.createErrorWithActions=P}),define(ue[57],he([13,12]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(ue[3],he([0,1,57]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let D=!1,S=!1,I=!1,M=!1,E=!1,f=!1,l=!1,P=!1,p=!1,v=!1,s,c=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT,u,i;const o=globalThis;let m;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?m=o.vscode.process:typeof process<"u"&&(m=process);const r=typeof m?.versions?.electron=="string",t=r&&m?.type==="renderer";if(typeof m=="object"){D=m.platform==="win32",S=m.platform==="darwin",I=m.platform==="linux",M=I&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,l=r,p=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const _=JSON.parse(a),k=_.availableLanguages["*"];s=_.locale,d=_.osLocale,c=k||e.LANGUAGE_DEFAULT,u=_._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!t?(i=navigator.userAgent,D=i.indexOf("Windows")>=0,S=i.indexOf("Macintosh")>=0,P=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=i.indexOf("Linux")>=0,v=i?.indexOf("Mobi")>=0,f=!0,s=w.getConfiguredDefaultLocale(w.localize(0,null))||e.LANGUAGE_DEFAULT,c=s,d=navigator.language):console.error("Unable to resolve platform.");var n;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(n||(e.Platform=n={}));function y(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let O=0;S?O=1:D?O=3:I&&(O=2),e.isWindows=D,e.isMacintosh=S,e.isLinux=I,e.isLinuxSnap=M,e.isNative=E,e.isElectron=l,e.isWeb=f,e.isWebWorker=f&&typeof o.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?o.origin:void 0,e.isIOS=P,e.isMobile=v,e.isCI=p,e.platform=O,e.userAgent=i,e.language=c;var g;(function(a){function _(){return e.language}a.value=_;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=k;function q(){return e.language==="en"}a.isDefault=q})(g||(e.Language=g={})),e.locale=s,e.platformLocale=d,e.translationsConfigFile=u,e.setTimeout0IsFaster=typeof o.postMessage=="function"&&!o.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];o.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let q=0,R=a.length;q<R;q++){const z=a[q];if(z.id===k.data.vscodeScheduleAsyncWork){a.splice(q,1),z.callback();return}}});let _=0;return k=>{const q=++_;a.push({id:q,callback:k}),o.postMessage({vscodeScheduleAsyncWork:q},"*")}}return a=>setTimeout(a)})();var b;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(b||(e.OperatingSystem=b={})),e.OS=S||P?2:D?1:3;let C=!0,A=!1;function $(){if(!A){A=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,C=new Uint16Array(a.buffer)[0]===513}return C}e.isLittleEndian=$,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function B(a){return parseFloat(a)>=20}e.isBigSurOrNewer=B}),define(ue[15],he([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const I=S.process;D={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.arch=D.arch}),define(ue[7],he([0,1,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,S=97,I=90,M=122,E=46,f=47,l=92,P=58,p=63;class v extends Error{constructor(y,O,g){let b;typeof O=="string"&&O.indexOf("not ")===0?(b="must not be",O=O.replace(/^not /,"")):b="must be";const C=y.indexOf(".")!==-1?"property":"argument";let A=`The "${y}" ${C} ${b} of type ${O}`;A+=`. Received type ${typeof g}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function s(n,y){if(n===null||typeof n!="object")throw new v(y,"Object",n)}function c(n,y){if(typeof n!="string")throw new v(y,"string",n)}const d=w.platform==="win32";function u(n){return n===f||n===l}function i(n){return n===f}function o(n){return n>=D&&n<=I||n>=S&&n<=M}function m(n,y,O,g){let b="",C=0,A=-1,$=0,B=0;for(let a=0;a<=n.length;++a){if(a<n.length)B=n.charCodeAt(a);else{if(g(B))break;B=f}if(g(B)){if(!(A===a-1||$===1))if($===2){if(b.length<2||C!==2||b.charCodeAt(b.length-1)!==E||b.charCodeAt(b.length-2)!==E){if(b.length>2){const _=b.lastIndexOf(O);_===-1?(b="",C=0):(b=b.slice(0,_),C=b.length-1-b.lastIndexOf(O)),A=a,$=0;continue}else if(b.length!==0){b="",C=0,A=a,$=0;continue}}y&&(b+=b.length>0?`${O}..`:"..",C=2)}else b.length>0?b+=`${O}${n.slice(A+1,a)}`:b=n.slice(A+1,a),C=a-A-1;A=a,$=0}else B===E&&$!==-1?++$:$=-1}return b}function r(n,y){s(y,"pathObject");const O=y.dir||y.root,g=y.base||`${y.name||""}${y.ext||""}`;return O?O===y.root?`${O}${g}`:`${O}${n}${g}`:g}e.win32={resolve(...n){let y="",O="",g=!1;for(let b=n.length-1;b>=-1;b--){let C;if(b>=0){if(C=n[b],c(C,"path"),C.length===0)continue}else y.length===0?C=w.cwd():(C=w.env[`=${y}`]||w.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==y.toLowerCase()&&C.charCodeAt(2)===l)&&(C=`${y}\\`));const A=C.length;let $=0,B="",a=!1;const _=C.charCodeAt(0);if(A===1)u(_)&&($=1,a=!0);else if(u(_))if(a=!0,u(C.charCodeAt(1))){let k=2,q=k;for(;k<A&&!u(C.charCodeAt(k));)k++;if(k<A&&k!==q){const R=C.slice(q,k);for(q=k;k<A&&u(C.charCodeAt(k));)k++;if(k<A&&k!==q){for(q=k;k<A&&!u(C.charCodeAt(k));)k++;(k===A||k!==q)&&(B=`\\\\${R}\\${C.slice(q,k)}`,$=k)}}}else $=1;else o(_)&&C.charCodeAt(1)===P&&(B=C.slice(0,2),$=2,A>2&&u(C.charCodeAt(2))&&(a=!0,$=3));if(B.length>0)if(y.length>0){if(B.toLowerCase()!==y.toLowerCase())continue}else y=B;if(g){if(y.length>0)break}else if(O=`${C.slice($)}\\${O}`,g=a,a&&y.length>0)break}return O=m(O,!g,"\\",u),g?`${y}\\${O}`:`${y}${O}`||"."},normalize(n){c(n,"path");const y=n.length;if(y===0)return".";let O=0,g,b=!1;const C=n.charCodeAt(0);if(y===1)return i(C)?"\\":n;if(u(C))if(b=!0,u(n.charCodeAt(1))){let $=2,B=$;for(;$<y&&!u(n.charCodeAt($));)$++;if($<y&&$!==B){const a=n.slice(B,$);for(B=$;$<y&&u(n.charCodeAt($));)$++;if($<y&&$!==B){for(B=$;$<y&&!u(n.charCodeAt($));)$++;if($===y)return`\\\\${a}\\${n.slice(B)}\\`;$!==B&&(g=`\\\\${a}\\${n.slice(B,$)}`,O=$)}}}else O=1;else o(C)&&n.charCodeAt(1)===P&&(g=n.slice(0,2),O=2,y>2&&u(n.charCodeAt(2))&&(b=!0,O=3));let A=O<y?m(n.slice(O),!b,"\\",u):"";return A.length===0&&!b&&(A="."),A.length>0&&u(n.charCodeAt(y-1))&&(A+="\\"),g===void 0?b?`\\${A}`:A:b?`${g}\\${A}`:`${g}${A}`},isAbsolute(n){c(n,"path");const y=n.length;if(y===0)return!1;const O=n.charCodeAt(0);return u(O)||y>2&&o(O)&&n.charCodeAt(1)===P&&u(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let y,O;for(let C=0;C<n.length;++C){const A=n[C];c(A,"path"),A.length>0&&(y===void 0?y=O=A:y+=`\\${A}`)}if(y===void 0)return".";let g=!0,b=0;if(typeof O=="string"&&u(O.charCodeAt(0))){++b;const C=O.length;C>1&&u(O.charCodeAt(1))&&(++b,C>2&&(u(O.charCodeAt(2))?++b:g=!1))}if(g){for(;b<y.length&&u(y.charCodeAt(b));)b++;b>=2&&(y=`\\${y.slice(b)}`)}return e.win32.normalize(y)},relative(n,y){if(c(n,"from"),c(y,"to"),n===y)return"";const O=e.win32.resolve(n),g=e.win32.resolve(y);if(O===g||(n=O.toLowerCase(),y=g.toLowerCase(),n===y))return"";let b=0;for(;b<n.length&&n.charCodeAt(b)===l;)b++;let C=n.length;for(;C-1>b&&n.charCodeAt(C-1)===l;)C--;const A=C-b;let $=0;for(;$<y.length&&y.charCodeAt($)===l;)$++;let B=y.length;for(;B-1>$&&y.charCodeAt(B-1)===l;)B--;const a=B-$,_=A<a?A:a;let k=-1,q=0;for(;q<_;q++){const z=n.charCodeAt(b+q);if(z!==y.charCodeAt($+q))break;z===l&&(k=q)}if(q!==_){if(k===-1)return g}else{if(a>_){if(y.charCodeAt($+q)===l)return g.slice($+q+1);if(q===2)return g.slice($+q)}A>_&&(n.charCodeAt(b+q)===l?k=q:q===2&&(k=3)),k===-1&&(k=0)}let R="";for(q=b+k+1;q<=C;++q)(q===C||n.charCodeAt(q)===l)&&(R+=R.length===0?"..":"\\..");return $+=k,R.length>0?`${R}${g.slice($,B)}`:(g.charCodeAt($)===l&&++$,g.slice($,B))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const y=e.win32.resolve(n);if(y.length<=2)return n;if(y.charCodeAt(0)===l){if(y.charCodeAt(1)===l){const O=y.charCodeAt(2);if(O!==p&&O!==E)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(o(y.charCodeAt(0))&&y.charCodeAt(1)===P&&y.charCodeAt(2)===l)return`\\\\?\\${y}`;return n},dirname(n){c(n,"path");const y=n.length;if(y===0)return".";let O=-1,g=0;const b=n.charCodeAt(0);if(y===1)return u(b)?n:".";if(u(b)){if(O=g=1,u(n.charCodeAt(1))){let $=2,B=$;for(;$<y&&!u(n.charCodeAt($));)$++;if($<y&&$!==B){for(B=$;$<y&&u(n.charCodeAt($));)$++;if($<y&&$!==B){for(B=$;$<y&&!u(n.charCodeAt($));)$++;if($===y)return n;$!==B&&(O=g=$+1)}}}}else o(b)&&n.charCodeAt(1)===P&&(O=y>2&&u(n.charCodeAt(2))?3:2,g=O);let C=-1,A=!0;for(let $=y-1;$>=g;--$)if(u(n.charCodeAt($))){if(!A){C=$;break}}else A=!1;if(C===-1){if(O===-1)return".";C=O}return n.slice(0,C)},basename(n,y){y!==void 0&&c(y,"ext"),c(n,"path");let O=0,g=-1,b=!0,C;if(n.length>=2&&o(n.charCodeAt(0))&&n.charCodeAt(1)===P&&(O=2),y!==void 0&&y.length>0&&y.length<=n.length){if(y===n)return"";let A=y.length-1,$=-1;for(C=n.length-1;C>=O;--C){const B=n.charCodeAt(C);if(u(B)){if(!b){O=C+1;break}}else $===-1&&(b=!1,$=C+1),A>=0&&(B===y.charCodeAt(A)?--A===-1&&(g=C):(A=-1,g=$))}return O===g?g=$:g===-1&&(g=n.length),n.slice(O,g)}for(C=n.length-1;C>=O;--C)if(u(n.charCodeAt(C))){if(!b){O=C+1;break}}else g===-1&&(b=!1,g=C+1);return g===-1?"":n.slice(O,g)},extname(n){c(n,"path");let y=0,O=-1,g=0,b=-1,C=!0,A=0;n.length>=2&&n.charCodeAt(1)===P&&o(n.charCodeAt(0))&&(y=g=2);for(let $=n.length-1;$>=y;--$){const B=n.charCodeAt($);if(u(B)){if(!C){g=$+1;break}continue}b===-1&&(C=!1,b=$+1),B===E?O===-1?O=$:A!==1&&(A=1):O!==-1&&(A=-1)}return O===-1||b===-1||A===0||A===1&&O===b-1&&O===g+1?"":n.slice(O,b)},format:r.bind(null,"\\"),parse(n){c(n,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return y;const O=n.length;let g=0,b=n.charCodeAt(0);if(O===1)return u(b)?(y.root=y.dir=n,y):(y.base=y.name=n,y);if(u(b)){if(g=1,u(n.charCodeAt(1))){let k=2,q=k;for(;k<O&&!u(n.charCodeAt(k));)k++;if(k<O&&k!==q){for(q=k;k<O&&u(n.charCodeAt(k));)k++;if(k<O&&k!==q){for(q=k;k<O&&!u(n.charCodeAt(k));)k++;k===O?g=k:k!==q&&(g=k+1)}}}}else if(o(b)&&n.charCodeAt(1)===P){if(O<=2)return y.root=y.dir=n,y;if(g=2,u(n.charCodeAt(2))){if(O===3)return y.root=y.dir=n,y;g=3}}g>0&&(y.root=n.slice(0,g));let C=-1,A=g,$=-1,B=!0,a=n.length-1,_=0;for(;a>=g;--a){if(b=n.charCodeAt(a),u(b)){if(!B){A=a+1;break}continue}$===-1&&(B=!1,$=a+1),b===E?C===-1?C=a:_!==1&&(_=1):C!==-1&&(_=-1)}return $!==-1&&(C===-1||_===0||_===1&&C===$-1&&C===A+1?y.base=y.name=n.slice(A,$):(y.name=n.slice(A,C),y.base=n.slice(A,$),y.ext=n.slice(C,$))),A>0&&A!==g?y.dir=n.slice(0,A-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(d){const n=/\\/g;return()=>{const y=w.cwd().replace(n,"/");return y.slice(y.indexOf("/"))}}return()=>w.cwd()})();e.posix={resolve(...n){let y="",O=!1;for(let g=n.length-1;g>=-1&&!O;g--){const b=g>=0?n[g]:t();c(b,"path"),b.length!==0&&(y=`${b}/${y}`,O=b.charCodeAt(0)===f)}return y=m(y,!O,"/",i),O?`/${y}`:y.length>0?y:"."},normalize(n){if(c(n,"path"),n.length===0)return".";const y=n.charCodeAt(0)===f,O=n.charCodeAt(n.length-1)===f;return n=m(n,!y,"/",i),n.length===0?y?"/":O?"./":".":(O&&(n+="/"),y?`/${n}`:n)},isAbsolute(n){return c(n,"path"),n.length>0&&n.charCodeAt(0)===f},join(...n){if(n.length===0)return".";let y;for(let O=0;O<n.length;++O){const g=n[O];c(g,"path"),g.length>0&&(y===void 0?y=g:y+=`/${g}`)}return y===void 0?".":e.posix.normalize(y)},relative(n,y){if(c(n,"from"),c(y,"to"),n===y||(n=e.posix.resolve(n),y=e.posix.resolve(y),n===y))return"";const O=1,g=n.length,b=g-O,C=1,A=y.length-C,$=b<A?b:A;let B=-1,a=0;for(;a<$;a++){const k=n.charCodeAt(O+a);if(k!==y.charCodeAt(C+a))break;k===f&&(B=a)}if(a===$)if(A>$){if(y.charCodeAt(C+a)===f)return y.slice(C+a+1);if(a===0)return y.slice(C+a)}else b>$&&(n.charCodeAt(O+a)===f?B=a:a===0&&(B=0));let _="";for(a=O+B+1;a<=g;++a)(a===g||n.charCodeAt(a)===f)&&(_+=_.length===0?"..":"/..");return`${_}${y.slice(C+B)}`},toNamespacedPath(n){return n},dirname(n){if(c(n,"path"),n.length===0)return".";const y=n.charCodeAt(0)===f;let O=-1,g=!0;for(let b=n.length-1;b>=1;--b)if(n.charCodeAt(b)===f){if(!g){O=b;break}}else g=!1;return O===-1?y?"/":".":y&&O===1?"//":n.slice(0,O)},basename(n,y){y!==void 0&&c(y,"ext"),c(n,"path");let O=0,g=-1,b=!0,C;if(y!==void 0&&y.length>0&&y.length<=n.length){if(y===n)return"";let A=y.length-1,$=-1;for(C=n.length-1;C>=0;--C){const B=n.charCodeAt(C);if(B===f){if(!b){O=C+1;break}}else $===-1&&(b=!1,$=C+1),A>=0&&(B===y.charCodeAt(A)?--A===-1&&(g=C):(A=-1,g=$))}return O===g?g=$:g===-1&&(g=n.length),n.slice(O,g)}for(C=n.length-1;C>=0;--C)if(n.charCodeAt(C)===f){if(!b){O=C+1;break}}else g===-1&&(b=!1,g=C+1);return g===-1?"":n.slice(O,g)},extname(n){c(n,"path");let y=-1,O=0,g=-1,b=!0,C=0;for(let A=n.length-1;A>=0;--A){const $=n.charCodeAt(A);if($===f){if(!b){O=A+1;break}continue}g===-1&&(b=!1,g=A+1),$===E?y===-1?y=A:C!==1&&(C=1):y!==-1&&(C=-1)}return y===-1||g===-1||C===0||C===1&&y===g-1&&y===O+1?"":n.slice(y,g)},format:r.bind(null,"/"),parse(n){c(n,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return y;const O=n.charCodeAt(0)===f;let g;O?(y.root="/",g=1):g=0;let b=-1,C=0,A=-1,$=!0,B=n.length-1,a=0;for(;B>=g;--B){const _=n.charCodeAt(B);if(_===f){if(!$){C=B+1;break}continue}A===-1&&($=!1,A=B+1),_===E?b===-1?b=B:a!==1&&(a=1):b!==-1&&(a=-1)}if(A!==-1){const _=C===0&&O?1:C;b===-1||a===0||a===1&&b===A-1&&b===C+1?y.base=y.name=n.slice(_,A):(y.name=n.slice(_,b),y.base=n.slice(_,A),y.ext=n.slice(b,A))}return C>0?y.dir=n.slice(0,C-1):O&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d?e.win32.normalize:e.posix.normalize,e.isAbsolute=d?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d?e.win32.join:e.posix.join,e.resolve=d?e.win32.resolve:e.posix.resolve,e.relative=d?e.win32.relative:e.posix.relative,e.dirname=d?e.win32.dirname:e.posix.dirname,e.basename=d?e.win32.basename:e.posix.basename,e.extname=d?e.win32.extname:e.posix.extname,e.format=d?e.win32.format:e.posix.format,e.parse=d?e.win32.parse:e.posix.parse,e.toNamespacedPath=d?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d?e.win32.sep:e.posix.sep,e.delimiter=d?e.win32.delimiter:e.posix.delimiter}),define(ue[32],he([0,1,7,3,11,8]),function(oe,e,w,D,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(C){return C===47||C===92}e.isPathSeparator=M;function E(C){return C.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=E;function f(C){return C.indexOf("/")===-1&&(C=E(C)),/^[a-zA-Z]:(\/|$)/.test(C)&&(C="/"+C),C}e.toPosixPath=f;function l(C,A=w.posix.sep){if(!C)return"";const $=C.length,B=C.charCodeAt(0);if(M(B)){if(M(C.charCodeAt(1))&&!M(C.charCodeAt(2))){let _=3;const k=_;for(;_<$&&!M(C.charCodeAt(_));_++);if(k!==_&&!M(C.charCodeAt(_+1))){for(_+=1;_<$;_++)if(M(C.charCodeAt(_)))return C.slice(0,_+1).replace(/[\\/]/g,A)}}return A}else if(i(B)&&C.charCodeAt(1)===58)return M(C.charCodeAt(2))?C.slice(0,2)+A:C.slice(0,2);let a=C.indexOf("://");if(a!==-1){for(a+=3;a<$;a++)if(M(C.charCodeAt(a)))return C.slice(0,a+1)}return""}e.getRoot=l;function P(C){if(!D.isWindows||!C||C.length<5)return!1;let A=C.charCodeAt(0);if(A!==92||(A=C.charCodeAt(1),A!==92))return!1;let $=2;const B=$;for(;$<C.length&&(A=C.charCodeAt($),A!==92);$++);return!(B===$||(A=C.charCodeAt($+1),isNaN(A)||A===92))}e.isUNC=P;const p=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(C,A=D.isWindows){const $=A?p:v;return!(!C||C.length===0||/^\s+$/.test(C)||($.lastIndex=0,$.test(C))||A&&s.test(C)||C==="."||C===".."||A&&C[C.length-1]==="."||A&&C.length!==C.trim().length||C.length>255)}e.isValidBasename=c;function d(C,A,$){const B=C===A;return!$||B?B:!C||!A?!1:(0,S.equalsIgnoreCase)(C,A)}e.isEqual=d;function u(C,A,$,B=w.sep){if(C===A)return!0;if(!C||!A||A.length>C.length)return!1;if($){if(!(0,S.startsWithIgnoreCase)(C,A))return!1;if(A.length===C.length)return!0;let _=A.length;return A.charAt(A.length-1)===B&&_--,C.charAt(_)===B}return A.charAt(A.length-1)!==B&&(A+=B),C.indexOf(A)===0}e.isEqualOrParent=u;function i(C){return C>=65&&C<=90||C>=97&&C<=122}e.isWindowsDriveLetter=i;function o(C,A){return D.isWindows&&C.endsWith(":")&&(C+=w.sep),(0,w.isAbsolute)(C)||(C=(0,w.join)(A,C)),C=(0,w.normalize)(C),D.isWindows?(C=(0,S.rtrim)(C,w.sep),C.endsWith(":")&&(C+=w.sep)):(C=(0,S.rtrim)(C,w.sep),C||(C=w.sep)),C}e.sanitizeFilePath=o;function m(C){const A=(0,w.normalize)(C);return D.isWindows?C.length>3?!1:r(A)&&(C.length===2||A.charCodeAt(2)===92):A===w.posix.sep}e.isRootOrDriveLetter=m;function r(C,A=D.isWindows){return A?i(C.charCodeAt(0))&&C.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function t(C,A=D.isWindows){return r(C,A)?C[0]:void 0}e.getDriveLetter=t;function n(C,A,$){return A.length>C.length?-1:C===A?0:($&&(C=C.toLowerCase(),A=A.toLowerCase()),C.indexOf(A))}e.indexOfPath=n;function y(C){const A=C.split(":");let $,B,a;for(const _ of A){const k=Number(_);(0,I.isNumber)(k)?B===void 0?B=k:a===void 0&&(a=k):$=$?[$,_].join(":"):_}if(!$)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:$,line:B!==void 0?B:void 0,column:a!==void 0?a:B!==void 0?1:void 0}}e.parseLineAndColumnAware=y;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(C,A,$=8){let B="";for(let _=0;_<$;_++){let k;_===0&&D.isWindows&&!A&&($===3||$===4)?k=g:k=O,B+=k.charAt(Math.floor(Math.random()*k.length))}let a;return A?a=`${A}-${B}`:a=B,C?(0,w.join)(C,a):a}e.randomPath=b}),define(ue[33],he([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(D||(e.Source=D={}));var S;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function I(E,...f){const l=f.reduce((v,s)=>(v[s]=!0,v),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(v=>!l[v]).forEach(v=>{for(let s=0;s<P.length;s++)if(v.search(P[s])!==-1){delete E[v];break}})}e.sanitizeProcessEnvironment=I;function M(E){E&&(delete E.DEBUG,w.isMacintosh&&delete E.DYLD_LIBRARY_PATH,w.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ue[5],he([0,1,7,3]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,I=/^\//,M=/^\/\//;function E(g,b){if(!g.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!S.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!I.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(g,b){return!g&&!b?"file":g}function l(g,b){switch(g){case"https":case"http":case"file":b?b[0]!==p&&(b=p+b):b=p;break}return b}const P="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(b){return b instanceof s?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,C,A,$,B,a=!1){typeof b=="object"?(this.scheme=b.scheme||P,this.authority=b.authority||P,this.path=b.path||P,this.query=b.query||P,this.fragment=b.fragment||P):(this.scheme=f(b,a),this.authority=C||P,this.path=l(this.scheme,A||P),this.query=$||P,this.fragment=B||P,E(this,a))}get fsPath(){return r(this,!1)}with(b){if(!b)return this;let{scheme:C,authority:A,path:$,query:B,fragment:a}=b;return C===void 0?C=this.scheme:C===null&&(C=P),A===void 0?A=this.authority:A===null&&(A=P),$===void 0?$=this.path:$===null&&($=P),B===void 0?B=this.query:B===null&&(B=P),a===void 0?a=this.fragment:a===null&&(a=P),C===this.scheme&&A===this.authority&&$===this.path&&B===this.query&&a===this.fragment?this:new u(C,A,$,B,a)}static parse(b,C=!1){const A=v.exec(b);return A?new u(A[2]||P,O(A[4]||P),O(A[5]||P),O(A[7]||P),O(A[9]||P),C):new u(P,P,P,P,P)}static file(b){let C=P;if(D.isWindows&&(b=b.replace(/\\/g,p)),b[0]===p&&b[1]===p){const A=b.indexOf(p,2);A===-1?(C=b.substring(2),b=p):(C=b.substring(2,A),b=b.substring(A)||p)}return new u("file",C,b,P,P)}static from(b,C){return new u(b.scheme,b.authority,b.path,b.query,b.fragment,C)}static joinPath(b,...C){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return D.isWindows&&b.scheme==="file"?A=s.file(w.win32.join(r(b,!0),...C)).path:A=w.posix.join(b.path,...C),b.with({path:A})}toString(b=!1){return t(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof s)return b;{const C=new u(b);return C._formatted=b.external??null,C._fsPath=b._sep===d?b.fsPath??null:null,C}}else return b}}e.URI=s;function c(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}e.isUriComponents=c;const d=D.isWindows?1:void 0;class u extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(b=!1){return b?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=d),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const i={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function o(g,b,C){let A,$=-1;for(let B=0;B<g.length;B++){const a=g.charCodeAt(B);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||b&&a===47||C&&a===91||C&&a===93||C&&a===58)$!==-1&&(A+=encodeURIComponent(g.substring($,B)),$=-1),A!==void 0&&(A+=g.charAt(B));else{A===void 0&&(A=g.substr(0,B));const _=i[a];_!==void 0?($!==-1&&(A+=encodeURIComponent(g.substring($,B)),$=-1),A+=_):$===-1&&($=B)}}return $!==-1&&(A+=encodeURIComponent(g.substring($))),A!==void 0?A:g}function m(g){let b;for(let C=0;C<g.length;C++){const A=g.charCodeAt(C);A===35||A===63?(b===void 0&&(b=g.substr(0,C)),b+=i[A]):b!==void 0&&(b+=g[C])}return b!==void 0?b:g}function r(g,b){let C;return g.authority&&g.path.length>1&&g.scheme==="file"?C=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?b?C=g.path.substr(1):C=g.path[1].toLowerCase()+g.path.substr(2):C=g.path,D.isWindows&&(C=C.replace(/\//g,"\\")),C}e.uriToFsPath=r;function t(g,b){const C=b?m:o;let A="",{scheme:$,authority:B,path:a,query:_,fragment:k}=g;if($&&(A+=$,A+=":"),(B||$==="file")&&(A+=p,A+=p),B){let q=B.indexOf("@");if(q!==-1){const R=B.substr(0,q);B=B.substr(q+1),q=R.lastIndexOf(":"),q===-1?A+=C(R,!1,!1):(A+=C(R.substr(0,q),!1,!1),A+=":",A+=C(R.substr(q+1),!1,!0)),A+="@"}B=B.toLowerCase(),q=B.lastIndexOf(":"),q===-1?A+=C(B,!1,!0):(A+=C(B.substr(0,q),!1,!0),A+=B.substr(q))}if(a){if(a.length>=3&&a.charCodeAt(0)===47&&a.charCodeAt(2)===58){const q=a.charCodeAt(1);q>=65&&q<=90&&(a=`/${String.fromCharCode(q+32)}:${a.substr(3)}`)}else if(a.length>=2&&a.charCodeAt(1)===58){const q=a.charCodeAt(0);q>=65&&q<=90&&(a=`${String.fromCharCode(q+32)}:${a.substr(2)}`)}A+=C(a,!0,!1)}return _&&(A+="?",A+=C(_,!1,!1)),k&&(A+="#",A+=b?k:o(k,!1,!1)),A}function n(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+n(g.substr(3)):g}}const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(g){return g.match(y)?g.replace(y,b=>n(b)):g}}),define(ue[58],he([0,1,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(l){const P=l;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=D;function S(l){const P=[];let p;try{const v=JSON.parse(l.arguments),s=v[v.length-1];s&&s.__$stack&&(v.pop(),p=s.__$stack),P.push(...v)}catch{P.push("Unable to log remote console arguments",l.arguments)}return{args:P,stack:p}}e.parse=S;function I(l){if(typeof l!="string")return I(S(l).stack);const P=l;if(P){const p=M(P),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:w.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=I;function M(l){if(!l)return l;const P=l.indexOf(`
`);return P===-1?l:l.substring(0,P)}function E(l,P){const{args:p,stack:v}=S(l),s=typeof p[0]=="string"&&p.length===1;let c=M(v);c&&(c=`(${c.trim()})`);let d=[];if(typeof p[0]=="string"?c&&s?d=[`%c[${P}] %c${p[0]} %c${c}`,f("blue"),f(""),f("grey")]:d=[`%c[${P}] %c${p[0]}`,f("blue"),f(""),...p.slice(1)]:d=[`%c[${P}]%`,f("blue"),...p],c&&!s&&d.push(c),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,d)}e.log=E;function f(l){return`color: ${l}`}}),define(ue[59],he([0,1,18,5]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(f){return JSON.stringify(f,M)}e.stringify=S;function I(f){let l=JSON.parse(f);return l=E(l),l}e.parse=I;function M(f,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function E(f,l=0){if(!f||l>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return D.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof w.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let P=0;P<f.length;++P)f[P]=E(f[P],l+1);else for(const P in f)Object.hasOwnProperty.call(f,P)&&(f[P]=E(f[P],l+1))}return f}e.revive=E}),define(ue[19],he([0,1,6,3,11,5]),function(oe,e,w,D,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var M;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.codeSetting="code-setting",v.codeFeature="code-feature"})(M||(e.Schemas=M={}));function E(v,s){return I.URI.isUri(v)?(0,S.equalsIgnoreCase)(v.scheme,s):(0,S.startsWithIgnoreCase)(v,s+":")}e.matchesScheme=E;function f(v,...s){return s.some(c=>E(v,c))}e.matchesSomeScheme=f,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class l{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(s){this._preferredWebSchema=s}setDelegate(s){this._delegate=s}setServerRootPath(s){this._remoteResourcesPath=`${s}/${M.vscodeRemoteResource}`}set(s,c,d){this._hosts[s]=c,this._ports[s]=d}setConnectionToken(s,c){this._connectionTokens[s]=c}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(s){if(this._delegate)try{return this._delegate(s)}catch(m){return w.onUnexpectedError(m),s}const c=s.authority;let d=this._hosts[c];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const u=this._ports[c],i=this._connectionTokens[c];let o=`path=${encodeURIComponent(s.path)}`;return typeof i=="string"&&(o+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),I.URI.from({scheme:D.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${d}:${u}`,path:this._remoteResourcesPath,query:o})}}e.RemoteAuthorities=new l,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class P{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(s){const c=this.toUri(s,oe);return this.uriToBrowserUri(c)}uriToBrowserUri(s){return s.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(s):s.scheme===M.file&&(D.isNative||D.webWorkerOrigin===`${M.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?s.with({scheme:M.vscodeFileResource,authority:s.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):s}asFileUri(s){const c=this.toUri(s,oe);return this.uriToFileUri(c)}uriToFileUri(s){return s.scheme===M.vscodeFileResource?s.with({scheme:M.file,authority:s.authority!==P.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(s,c){return I.URI.isUri(s)?s:I.URI.parse(c.toUrl(s))}}e.FileAccess=new P;var p;(function(v){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(s.get("3"));const c="vscode-coi";function d(i){let o;typeof i=="string"?o=new URL(i).searchParams:i instanceof URL?o=i.searchParams:I.URI.isUri(i)&&(o=new URL(i.toString(!0)).searchParams);const m=o?.get(c);if(m)return s.get(m)}v.getHeadersFromQuery=d;function u(i,o,m){if(!globalThis.crossOriginIsolated)return;const r=o&&m?"3":m?"2":"1";i instanceof URLSearchParams?i.set(c,r):i[c]=r}v.addSearchParam=u})(p||(e.COI=p={}))}),define(ue[23],he([0,1,32,19,7,3,11,5]),function(oe,e,w,D,S,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(s){return(0,E.uriToFsPath)(s,!0)}e.originalFSPath=f;class l{constructor(c){this._ignorePathCasing=c}compare(c,d,u=!1){return c===d?0:(0,M.compare)(this.getComparisonKey(c,u),this.getComparisonKey(d,u))}isEqual(c,d,u=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,u)===this.getComparisonKey(d,u)}getComparisonKey(c,d=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,d,u=!1){if(c.scheme===d.scheme){if(c.scheme===D.Schemas.file)return w.isEqualOrParent(f(c),f(d),this._ignorePathCasing(c))&&c.query===d.query&&(u||c.fragment===d.fragment);if((0,e.isEqualAuthority)(c.authority,d.authority))return w.isEqualOrParent(c.path,d.path,this._ignorePathCasing(c),"/")&&c.query===d.query&&(u||c.fragment===d.fragment)}return!1}joinPath(c,...d){return E.URI.joinPath(c,...d)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return S.posix.basename(c.path)}extname(c){return S.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===D.Schemas.file?d=E.URI.file(S.dirname(f(c))).path:(d=S.posix.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===D.Schemas.file?d=E.URI.file(S.normalize(f(c))).path:d=S.posix.normalize(c.path),c.with({path:d})}relativePath(c,d){if(c.scheme!==d.scheme||!(0,e.isEqualAuthority)(c.authority,d.authority))return;if(c.scheme===D.Schemas.file){const o=S.relative(f(c),f(d));return I.isWindows?w.toSlashes(o):o}let u=c.path||"/";const i=d.path||"/";if(this._ignorePathCasing(c)){let o=0;for(const m=Math.min(u.length,i.length);o<m&&!(u.charCodeAt(o)!==i.charCodeAt(o)&&u.charAt(o).toLowerCase()!==i.charAt(o).toLowerCase());o++);u=i.substr(0,o)+u.substr(o)}return S.posix.relative(u,i)}resolvePath(c,d){if(c.scheme===D.Schemas.file){const u=E.URI.file(S.resolve(f(c),d));return c.with({authority:u.authority,path:u.path})}return d=w.toPosixPath(d),c.with({path:S.posix.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||c!==void 0&&d!==void 0&&(0,M.equalsIgnoreCase)(c,d)}hasTrailingPathSeparator(c,d=S.sep){if(c.scheme===D.Schemas.file){const u=f(c);return u.length>w.getRoot(u).length&&u[u.length-1]===d}else{const u=c.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=S.sep){return(0,e.hasTrailingPathSeparator)(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=S.sep){let u=!1;if(c.scheme===D.Schemas.file){const i=f(c);u=i!==void 0&&i.length===w.getRoot(i).length&&i[i.length-1]===d}else{d="/";const i=c.path;u=i.length===1&&i.charCodeAt(i.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(c,d)?c.with({path:c.path+"/"}):c}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(s=>s.scheme===D.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new l(s=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(s,c){const d=[];for(let u=0;u<s.length;u++){const i=c(s[u]);s.some((o,m)=>m===u?!1:(0,e.isEqualOrParent)(i,c(o)))||d.push(s[u])}return d}e.distinctParents=P;var p;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function c(d){const u=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[r,t]=m.split(":");r&&t&&u.set(r,t)});const o=d.path.substring(0,d.path.indexOf(";"));return o&&u.set(s.META_DATA_MIME,o),u}s.parseMetaData=c})(p||(e.DataUri=p={}));function v(s,c,d){if(c){let u=s.path;return u&&u[0]!==S.posix.sep&&(u=S.posix.sep+u),s.with({scheme:d,authority:c,path:u})}return s.with({scheme:d})}e.toLocalResource=v}),define(ue[9],he([0,1,17,6,4,2,23,3,50,22]),function(oe,e,w,D,S,I,M,E,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(V){return!!V&&typeof V.then=="function"}e.isThenable=P;function p(V){const L=new w.CancellationTokenSource,F=V(L.token),G=new Promise((Z,le)=>{const pe=L.token.onCancellationRequested(()=>{pe.dispose(),le(new D.CancellationError)});Promise.resolve(F).then(ye=>{pe.dispose(),L.dispose(),Z(ye)},ye=>{pe.dispose(),L.dispose(),le(ye)})});return new class{cancel(){L.cancel(),L.dispose()}then(Z,le){return G.then(Z,le)}catch(Z){return this.then(void 0,Z)}finally(Z){return G.finally(Z)}}}e.createCancelablePromise=p;function v(V,L,F){return new Promise((G,Z)=>{const le=L.onCancellationRequested(()=>{le.dispose(),G(F)});V.then(G,Z).finally(()=>le.dispose())})}e.raceCancellation=v;function s(V,L){return new Promise((F,G)=>{const Z=L.onCancellationRequested(()=>{Z.dispose(),G(new D.CancellationError)});V.then(F,G).finally(()=>Z.dispose())})}e.raceCancellationError=s;async function c(V){let L=-1;const F=V.map((G,Z)=>G.then(le=>(L=Z,le)));try{return await Promise.race(F)}finally{V.forEach((G,Z)=>{Z!==L&&G.cancel()})}}e.raceCancellablePromises=c;function d(V,L,F){let G;const Z=setTimeout(()=>{G?.(void 0),F?.()},L);return Promise.race([V.finally(()=>clearTimeout(Z)),new Promise(le=>G=le)])}e.raceTimeout=d;function u(V){return new Promise((L,F)=>{const G=V();P(G)?G.then(L,F):L(G)})}e.asPromise=u;function i(){let V,L;return{promise:new Promise((G,Z)=>{V=G,L=Z}),resolve:V,reject:L}}e.promiseWithResolvers=i;class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const F=()=>{if(this.queuedPromise=null,this.isDisposed)return;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(F,F).then(G)})}return new Promise((F,G)=>{this.queuedPromise.then(F,G)})}return this.activePromise=L(),new Promise((F,G)=>{this.activePromise.then(Z=>{this.activePromise=null,F(Z)},Z=>{this.activePromise=null,G(Z)})})}dispose(){this.isDisposed=!0}}e.Throttler=o;class m{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=m;class r{constructor(){this.promiseMap=new Map}queue(L,F){const Z=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(L)===Z&&this.promiseMap.delete(L)});return this.promiseMap.set(L,Z),Z}}e.SequencerByKey=r;const t=(V,L)=>{let F=!0;const G=setTimeout(()=>{F=!1,L()},V);return{isTriggered:()=>F,dispose:()=>{clearTimeout(G),F=!1}}},n=V=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,V())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class y{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,F=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,le)=>{this.doResolve=Z,this.doReject=le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}}));const G=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===f.MicrotaskDelay?n(G):t(F,G),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=y;class O{constructor(L){this.delayer=new y(L),this.throttler=new o}trigger(L,F){return this.delayer.trigger(()=>this.throttler.queue(L),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=O;class g{constructor(){this._isOpen=!1,this._promise=new Promise((L,F)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class b extends g{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=b;function C(V,L){return L?new Promise((F,G)=>{const Z=setTimeout(()=>{le.dispose(),F()},V),le=L.onCancellationRequested(()=>{clearTimeout(Z),le.dispose(),G(new D.CancellationError)})}):p(F=>C(V,F))}e.timeout=C;function A(V,L=0,F){const G=setTimeout(()=>{V(),F&&Z.dispose()},L),Z=(0,I.toDisposable)(()=>{clearTimeout(G),F?.deleteAndLeak(Z)});return F?.add(Z),Z}e.disposableTimeout=A;function $(V){const L=[];let F=0;const G=V.length;function Z(){return F<G?V[F++]():null}function le(pe){pe!=null&&L.push(pe);const ye=Z();return ye?ye.then(le):Promise.resolve(L)}return Promise.resolve(null).then(le)}e.sequence=$;function B(V,L=G=>!!G,F=null){let G=0;const Z=V.length,le=()=>{if(G>=Z)return Promise.resolve(F);const pe=V[G++];return Promise.resolve(pe()).then(we=>L(we)?Promise.resolve(we):le())};return le()}e.first=B;function a(V,L=G=>!!G,F=null){if(V.length===0)return Promise.resolve(F);let G=V.length;const Z=()=>{G=-1;for(const le of V)le.cancel?.()};return new Promise((le,pe)=>{for(const ye of V)ye.then(we=>{--G>=0&&L(we)?(Z(),le(we)):G===0&&le(F)}).catch(we=>{--G>=0&&(Z(),pe(we))})})}e.firstParallel=a;class _{constructor(L){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((F,G)=>{this.outstandingPromises.push({factory:L,c:F,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const F=L.factory();F.then(L.c,L.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=_;class k extends _{constructor(){super(1)}}e.Queue=k;class q{constructor(){this.sequentializer=new Y,this.tasks=0}queue(L){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,L())):this.sequentializer.run(this.tasks++,L())}}e.LimitedQueue=q;class R{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const L=new ee;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueSize(L,F=M.extUri){const G=F.getComparisonKey(L);return this.queues.get(G)?.size??0}queueFor(L,F,G=M.extUri){const Z=G.getComparisonKey(L);let le=this.queues.get(Z);if(!le){le=new k;const pe=this.drainListenerCount++,ye=S.Event.once(le.onDrained)(()=>{le?.dispose(),this.queues.delete(Z),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(pe),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new I.DisposableMap),this.drainListeners.set(pe,ye),this.queues.set(Z,le)}return le.queue(F)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=R;class z{constructor(L,F){this._token=-1,typeof L=="function"&&typeof F=="number"&&this.setIfNotSet(L,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},F)}setIfNotSet(L,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},F))}}e.TimeoutTimer=z;class ne{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(L,F,G=globalThis){this.cancel();const Z=G.setInterval(()=>{L()},F);this.disposable=(0,I.toDisposable)(()=>{G.clearInterval(Z),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=ne;class re{constructor(L,F){this.timeoutToken=-1,this.runner=L,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=re;class X{constructor(L,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=X;class se extends re{constructor(L,F){super(L,F),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class ce extends I.Disposable{constructor(L,F){super(),this.options=L,this.handler=F,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const F of L)this.pendingWork.push(F);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new re(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(V,L)=>{(0,E.setTimeout0)(()=>{if(F)return;const G=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e._runWhenIdle=(V,L,F)=>{const G=V.requestIdleCallback(L,typeof F=="number"?{timeout:F}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,V.cancelIdleCallback(G))}}},e.runWhenGlobalIdle=V=>(0,e._runWhenIdle)(globalThis,V)}();class fe{constructor(L,F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(G){this._error=G}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(L,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=fe;class K extends fe{constructor(L){super(globalThis,L)}}e.GlobalIdleValue=K;async function W(V,L,F){let G;for(let Z=0;Z<F;Z++)try{return await V()}catch(le){G=le,await C(L)}throw G}e.retry=W;class Y{isRunning(L){return typeof L=="number"?this._running?.taskId===L:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(L,F,G){return this._running={taskId:L,cancel:()=>G?.(),promise:F},F.then(()=>this.doneRunning(L),()=>this.doneRunning(L)),F}doneRunning(L){this._running&&L===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const L=this._queued;this._queued=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this._queued)this._queued.run=L;else{const{promise:F,resolve:G,reject:Z}=i();this._queued={run:L,promise:F,promiseResolve:G,promiseReject:Z}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Y;class te{constructor(L,F=()=>Date.now()){this.interval=L,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=te;var j;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(j||(j={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((L,F)=>{this.completeCallback=L,this.errorCallback=F})}complete(L){return new Promise(F=>{this.completeCallback(L),this.outcome={outcome:0,value:L},F()})}error(L){return new Promise(F=>{this.errorCallback(L),this.outcome={outcome:1,value:L},F()})}cancel(){return this.error(new D.CancellationError)}}e.DeferredPromise=ee;var me;(function(V){async function L(G){let Z;const le=await Promise.all(G.map(pe=>pe.then(ye=>ye,ye=>{Z||(Z=ye)})));if(typeof Z<"u")throw Z;return le}V.settled=L;function F(G){return new Promise(async(Z,le)=>{try{await G(Z,le)}catch(pe){le(pe)}})}V.withAsyncBody=F})(me||(e.Promises=me={}));class x{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(L){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=L.then(F=>(this._value=F,this._isResolved=!0,F),F=>{throw this._error=F,this._isResolved=!0,F})}requireValue(){if(!this._isResolved)throw new D.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=x;class h{constructor(L){this._compute=L,this._promise=new l.Lazy(()=>new x(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=h;var U;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(U||(U={}));class ie{static fromArray(L){return new ie(F=>{F.emitMany(L)})}static fromPromise(L){return new ie(async F=>{F.emitMany(await L)})}static fromPromises(L){return new ie(async F=>{await Promise.all(L.map(async G=>F.emitOne(await G)))})}static merge(L){return new ie(async F=>{await Promise.all(L.map(async G=>{for await(const Z of G)F.emitOne(Z)}))})}static{this.EMPTY=ie.fromArray([])}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const F={emitOne:G=>this.emitOne(G),emitMany:G=>this.emitMany(G),reject:G=>this.reject(G)};try{await Promise.resolve(L(F)),this.resolve()}catch(G){this.reject(G)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,F){return new ie(async G=>{for await(const Z of L)G.emitOne(F(Z))})}map(L){return ie.map(this,L)}static filter(L,F){return new ie(async G=>{for await(const Z of L)F(Z)&&G.emitOne(Z)})}filter(L){return ie.filter(this,L)}static coalesce(L){return ie.filter(L,F=>!!F)}coalesce(){return ie.coalesce(this)}static async toPromise(L){const F=[];for await(const G of L)F.push(G);return F}toPromise(){return ie.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=ie;class T extends ie{constructor(L,F){super(F),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=T;function Q(V){const L=new w.CancellationTokenSource,F=V(L.token);return new T(L,async G=>{const Z=L.token.onCancellationRequested(()=>{Z.dispose(),L.dispose(),G.reject(new D.CancellationError)});try{for await(const le of F){if(L.token.isCancellationRequested)return;G.emitOne(le)}Z.dispose(),L.dispose()}catch(le){Z.dispose(),L.dispose(),G.reject(le)}})}e.createCancelableAsyncIterable=Q;class H{constructor(){this._deferred=new ee,this._asyncIterable=new ie(G=>{if(L){G.reject(L);return}return F&&G.emitMany(F),this._errorFn=Z=>G.reject(Z),this._emitFn=Z=>G.emitOne(Z),this._deferred.p});let L,F;this._emitFn=G=>{F||(F=[]),F.push(G)},this._errorFn=G=>{L||(L=G)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(L){this._errorFn(L),this._deferred.complete()}emitOne(L){this._emitFn(L)}}e.AsyncIterableSource=H}),define(ue[60],he([0,1,18,5]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function S(p){return p.toJSON()}class I{constructor(v){this._uriTransformer=v}transformIncoming(v){const s=this._uriTransformer.transformIncoming(v);return s===v?v:S(D.URI.from(s))}transformOutgoing(v){const s=this._uriTransformer.transformOutgoing(v);return s===v?v:S(D.URI.from(s))}transformOutgoingURI(v){const s=this._uriTransformer.transformOutgoing(v);return s===v?v:D.URI.from(s)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function M(p,v,s){if(!p||s>200)return null;if(typeof p=="object"){if(p instanceof D.URI)return v.transformOutgoing(p);for(const c in p)if(Object.hasOwnProperty.call(p,c)){const d=M(p[c],v,s+1);d!==null&&(p[c]=d)}}return null}function E(p,v){const s=M(p,v,0);return s===null?p:s}e.transformOutgoingURIs=E;function f(p,v,s,c){if(!p||c>200)return null;if(typeof p=="object"){if(p.$mid===1)return s?D.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof w.VSBuffer)return null;for(const d in p)if(Object.hasOwnProperty.call(p,d)){const u=f(p[d],v,s,c+1);u!==null&&(p[d]=u)}}return null}function l(p,v){const s=f(p,v,!1,0);return s===null?p:s}e.transformIncomingURIs=l;function P(p,v){const s=f(p,v,!0,0);return s===null?p:s}e.transformAndReviveIncomingURIs=P}),define(ue[24],he([0,1,104,20,105,9,32,45,7,3,23,5]),function(oe,e,w,D,S,I,M,E,f,l,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function s(X,se=v.UNLINK,ce){if((0,M.isRootOrDriveLetter)(X))throw new Error("rimraf - will refuse to recursively delete root");return se===v.UNLINK?d(X):c(X,ce)}async function c(X,se=(0,M.randomPath)((0,D.tmpdir)())){try{try{await w.promises.rename(X,se)}catch(ce){return ce.code==="ENOENT"?void 0:d(X)}d(se).catch(ce=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function d(X){return(0,S.promisify)(w.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function u(X){if((0,M.isRootOrDriveLetter)(X))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function i(X,se){return r(await(se?o(X):(0,S.promisify)(w.readdir)(X)))}async function o(X){try{return await(0,S.promisify)(w.readdir)(X,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const se=[],ce=await i(X);for(const fe of ce){let K=!1,W=!1,Y=!1;try{const te=await e.Promises.lstat((0,f.join)(X,fe));K=te.isFile(),W=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}se.push({name:fe,isFile:()=>K,isDirectory:()=>W,isSymbolicLink:()=>Y})}return se}function m(X){return r(w.readdirSync(X))}e.readdirSync=m;function r(X){return X.map(se=>typeof se=="string"?l.isMacintosh?(0,E.normalizeNFC)(se):se:(se.name=l.isMacintosh?(0,E.normalizeNFC)(se.name):se.name,se))}async function t(X){const se=await i(X),ce=[];for(const fe of se)await y.existsDirectory((0,f.join)(X,fe))&&ce.push(fe);return ce}function n(X,se=1e3){return new Promise(ce=>{let fe=!1;const K=setInterval(()=>{fe||(fe=!0,w.access(X,W=>{fe=!1,W&&(clearInterval(K),ce(void 0))}))},se)})}e.whenDeleted=n;var y;(function(X){async function se(K){let W;try{if(W=await e.Promises.lstat(K),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(l.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw te}throw Y}}X.stat=se;async function ce(K){try{const{stat:W,symbolicLink:Y}=await X.stat(K);return W.isFile()&&Y?.dangling!==!0}catch{}return!1}X.existsFile=ce;async function fe(K){try{const{stat:W,symbolicLink:Y}=await X.stat(K);return W.isDirectory()&&Y?.dangling!==!0}catch{}return!1}X.existsDirectory=fe})(y||(e.SymlinkSupport=y={}));const O=new I.ResourceQueue;function g(X,se,ce){return O.queueFor(p.URI.file(X),()=>{const fe=B(ce);return new Promise((K,W)=>A(X,se,fe,Y=>Y?W(Y):K()))},P.extUriBiasedIgnorePathCase)}let b=!0;function C(X){b=X}e.configureFlushOnWrite=C;function A(X,se,ce,fe){if(!b)return w.writeFile(X,se,{mode:ce.mode,flag:ce.flag},fe);w.open(X,ce.flag,ce.mode,(K,W)=>{if(K)return fe(K);w.writeFile(W,se,Y=>{if(Y)return w.close(W,()=>fe(Y));w.fdatasync(W,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),C(!1)),w.close(W,j=>fe(j))))})})}function $(X,se,ce){const fe=B(ce);if(!b)return w.writeFileSync(X,se,{mode:fe.mode,flag:fe.flag});const K=w.openSync(X,fe.flag,fe.mode);try{w.writeFileSync(K,se);try{w.fdatasyncSync(K)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),C(!1)}}finally{w.closeSync(K)}}e.writeFileSync=$;function B(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function a(X,se,ce=6e4){if(X!==se)try{l.isWindows&&typeof ce=="number"?await _(X,se,Date.now(),ce):await(0,S.promisify)(w.rename)(X,se)}catch(fe){if(X.toLowerCase()!==se.toLowerCase()&&fe.code==="EXDEV"||X.endsWith("."))await k(X,se,{preserveSymlinks:!1}),await s(X,v.MOVE);else throw fe}}async function _(X,se,ce,fe,K=0){try{return await(0,S.promisify)(w.rename)(X,se)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-ce>=fe)throw console.error(`[node.js fs] rename failed after ${K} retries with error: ${W}`),W;if(K===0){let Y=!1;try{const{stat:te}=await y.stat(se);te.isFile()||(Y=!0)}catch{}if(Y)throw W}return await(0,I.timeout)(Math.min(100,K*10)),_(X,se,ce,fe,K+1)}}async function k(X,se,ce){return R(X,se,{root:{source:X,target:se},options:ce,handledSourcePaths:new Set})}const q=511;async function R(X,se,ce){if(ce.handledSourcePaths.has(X))return;ce.handledSourcePaths.add(X);const{stat:fe,symbolicLink:K}=await y.stat(X);if(K){if(ce.options.preserveSymlinks)try{return await re(X,se,ce)}catch{}if(K.dangling)return}return fe.isDirectory()?z(X,se,fe.mode&q,ce):ne(X,se,fe.mode&q)}async function z(X,se,ce,fe){await e.Promises.mkdir(se,{recursive:!0,mode:ce});const K=await i(X);for(const W of K)await R((0,f.join)(X,W),(0,f.join)(se,W),fe)}async function ne(X,se,ce){await e.Promises.copyFile(X,se),await e.Promises.chmod(se,ce)}async function re(X,se,ce){let fe=await e.Promises.readlink(X);(0,M.isEqualOrParent)(fe,ce.root.source,!l.isLinux)&&(fe=(0,f.join)(ce.root.target,fe.substr(ce.root.source.length+1))),await e.Promises.symlink(fe,se)}e.Promises=new class{get access(){return(0,S.promisify)(w.access)}get stat(){return(0,S.promisify)(w.stat)}get lstat(){return(0,S.promisify)(w.lstat)}get utimes(){return(0,S.promisify)(w.utimes)}get read(){return(X,se,ce,fe,K)=>new Promise((W,Y)=>{w.read(X,se,ce,fe,K,(te,j,ee)=>te?Y(te):W({bytesRead:j,buffer:ee}))})}get readFile(){return(0,S.promisify)(w.readFile)}get write(){return(X,se,ce,fe,K)=>new Promise((W,Y)=>{w.write(X,se,ce,fe,K,(te,j,ee)=>te?Y(te):W({bytesWritten:j,buffer:ee}))})}get appendFile(){return(0,S.promisify)(w.appendFile)}get fdatasync(){return(0,S.promisify)(w.fdatasync)}get truncate(){return(0,S.promisify)(w.truncate)}get copyFile(){return(0,S.promisify)(w.copyFile)}get open(){return(0,S.promisify)(w.open)}get close(){return(0,S.promisify)(w.close)}get symlink(){return(0,S.promisify)(w.symlink)}get readlink(){return(0,S.promisify)(w.readlink)}get chmod(){return(0,S.promisify)(w.chmod)}get mkdir(){return(0,S.promisify)(w.mkdir)}get unlink(){return(0,S.promisify)(w.unlink)}get rmdir(){return(0,S.promisify)(w.rmdir)}get realpath(){return(0,S.promisify)(w.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return i}get readDirsInDir(){return t}get writeFile(){return g}get rm(){return s}get rename(){return a}get copy(){return k}}}),define(ue[61],he([0,1,20,7,24]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,M=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var f;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class p{constructor(t,n,y){this.exePath=t,this.displayName=n,this.knownToExist=y}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:r=!1}={}){return r?l===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function s({useAlternateBitness:r=!1,findPreview:t=!1}={}){const n=v({useAlternateBitness:r});if(!n)return null;const y=D.join(n,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(y))return null;let O=-1,g=null;for(const A of await S.Promises.readdir(y)){let $=-1;if(t){const a=A.indexOf("-");if(a<0)continue;const _=A.substring(0,a);if(!I.test(_)||A.substring(a+1)!=="preview")continue;$=parseInt(_,10)}else{if(!I.test(A))continue;$=parseInt(A,10)}if($<=O)continue;const B=D.join(y,A,"pwsh.exe");await S.SymlinkSupport.existsFile(B)&&(g=B,O=$)}if(!g)return null;const b=n.includes("x86")?" (x86)":"",C=t?" Preview":"";return new p(g,`PowerShell${C}${b}`,!0)}async function c({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const t=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:n,pwshMsixName:y}=r?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const O of await S.Promises.readdir(t))if(n.test(O)){const g=D.join(t,O,"pwsh.exe");return new p(g,y)}return null}function d(){const r=D.join(w.homedir(),".dotnet","tools","pwsh.exe");return new p(r,".NET Core PowerShell Global Tool")}function u(){const r=D.join(process.env.windir,l===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(r,"Windows PowerShell",!0)}async function*i(){let r=await s();r&&(yield r),r=await s({useAlternateBitness:!0}),r&&(yield r),r=await c(),r&&(yield r),r=d(),r&&(yield r),r=await s({findPreview:!0}),r&&(yield r),r=await c({findPreview:!0}),r&&(yield r),r=await s({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=u(),r&&(yield r)}async function*o(){for await(const r of i())await r.exists()&&(yield r)}e.enumeratePowerShellInstallations=o;async function m(){for await(const r of o())return r;return null}e.getFirstAvailablePowerShellInstallation=m}),define(ue[34],he([0,1,7,3,15,33,8,24]),function(oe,e,w,D,S,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function f(p=S.env){return p.comspec||"cmd.exe"}e.getWindowsShell=f;function l(p){let v=[],s=!1;const c=function(d){if(s){v.push(d);return}(!p.send(d,i=>{if(i&&console.error(i),s=!1,v.length>0){const o=v.slice(0);v=[],o.forEach(m=>c(m))}})||D.isWindows)&&(s=!0)};return{send:c}}e.createQueuedSender=l;var P;(function(p){async function v(s,c,d){if(w.isAbsolute(s))return s;if(c===void 0&&(c=S.cwd()),w.dirname(s)!=="."||(d===void 0&&M.isString(S.env.PATH)&&(d=S.env.PATH.split(w.delimiter)),d===void 0||d.length===0))return w.join(c,s);async function i(o){if(await E.Promises.exists(o)){let m;try{m=await E.Promises.stat(o)}catch(r){r.message.startsWith("EACCES")&&(m=await E.Promises.lstat(o))}return m?!m.isDirectory():!1}return!1}for(const o of d){let m;if(w.isAbsolute(o)?m=w.join(o,s):m=w.join(c,o,s),await i(m))return m;let r=m+".com";if(await i(r)||(r=m+".exe",await i(r)))return r}return w.join(c,s)}p.findExecutable=v})(P||(e.win32=P={}))}),define(ue[62],he([0,1,26,19]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function S(M){return new Promise((E,f)=>{let l;const P=new Map;function p(s,c,d,u,i){const o=P.get(c);if(s===M||o){const m={name:v(d),cmd:d,pid:s,ppid:c,load:u,mem:i};P.set(s,m),s===M&&(l=m),o&&(o.children||(o.children=[]),o.children.push(m),o.children.length>1&&(o.children=o.children.sort((r,t)=>r.pid-t.pid)))}}function v(s){const c=/--utility-sub-type=network/i,d=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,i=/conhost\.exe.+--headless/i,o=/--type=([a-zA-Z-]+)/;if(d.exec(s))return"electron-crash-reporter";if(u.exec(s))return"winpty-agent";if(i.exec(s))return"conpty-agent";let m=o.exec(s);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(s)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const r=/[a-zA-Z-]+\.js/g;let t="";do m=r.exec(s),m&&(t+=m+" ");while(m);return t&&s.indexOf("node ")<0&&s.indexOf("node.exe")<0?`electron-nodejs (${t})`:s}if(process.platform==="win32"){const s=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,d)=>{oe(["@vscode/windows-process-tree"],c,d)}).then(c=>{c.getProcessList(M,d=>{if(!d){f(new Error(`Root process ${M} not found`));return}c.getProcessCpuUsage(d,u=>{const i=new Map;u.forEach(o=>{const m=s(o.commandLine||"");i.set(o.pid,{name:v(m),cmd:m,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),l=i.get(M),l?(i.forEach(o=>{const m=i.get(o.ppid);m&&(m.children||(m.children=[]),m.children.push(o))}),i.forEach(o=>{o.children&&(o.children=o.children.sort((m,r)=>m.pid-r.pid))}),E(l)):f(new Error(`Root process ${M} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let s=function(){let c=[l];const d=[];for(;c.length;){const i=c.shift();i&&(d.push(i.pid),i.children&&(c=c.concat(i.children)))}let u=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);u+=" "+d.join(" "),(0,w.exec)(u,{},(i,o,m)=>{if(i||m)f(i||new Error(m.toString()));else{const r=o.toString().split(`
`);for(let t=0;t<d.length;t++){const n=P.get(d[t]);n.load=parseFloat(r[t])}if(!l){f(new Error(`Root process ${M} not found`));return}E(l)}})};(0,w.exec)("which ps",{},(c,d,u)=>{if(c||u)if(process.platform!=="linux")f(c||new Error(u.toString()));else{const i=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(i,{},(o,m,r)=>{o||r?f(o||new Error(r.toString())):(I(m,p),s())})}else{const i=d.toString().trim();(0,w.exec)(`${i} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,r,t)=>{m||t&&!t.includes("screen size is bogus")?f(m||new Error(t.toString())):(I(r,p),process.platform==="linux"?s():l?E(l):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=S;function I(M,E){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=M.toString().split(`
`);for(const P of l){const p=f.exec(P.trim());p&&p.length===6&&E(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(ue[63],he([0,1,20,3,61,34]),function(oe,e,w,D,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(p,v){return p===1?D.isWindows?P():I.getWindowsShell(v):f(p,v)}e.getSystemShell=M;let E=null;function f(p,v){if(D.isLinux&&p===2||D.isMacintosh&&p===3)return"/bin/bash";if(!E){let s;if(D.isWindows)s="/bin/bash";else{if(s=v.SHELL,!s)try{s=(0,w.userInfo)().shell}catch{}s||(s="sh"),s==="/bin/false"&&(s="/bin/bash")}E=s}return E}let l=null;async function P(){return l||(l=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ge=this&&this.__decorate||function(oe,e,w,D){var S=arguments.length,I=S<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,w):D,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(oe,e,w,D);else for(var E=oe.length-1;E>=0;E--)(M=oe[E])&&(I=(S<3?M(I):S>3?M(e,w,I):M(e,w))||I);return S>3&&I&&Object.defineProperty(e,w,I),I};define(ue[27],he([0,1,16,9,18,17,14,6,4,2,59,11,8]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var s;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(s||(s={}));function c(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(d||(d={}));function u(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var i;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(i||(i={}));function o(K){let W=0;for(let Y=0;;Y+=7){const te=K.read(1);if(W|=(te.buffer[0]&127)<<Y,!(te.buffer[0]&128))return W}}const m=O(0);function r(K,W){if(W===0){K.write(m);return}let Y=0;for(let j=W;j!==0;j=j>>>7)Y++;const te=S.VSBuffer.alloc(Y);for(let j=0;W!==0;j++)te.buffer[j]=W&127,W=W>>>7,W>0&&(te.buffer[j]|=128);K.write(te)}class t{constructor(W){this.buffer=W,this.pos=0}read(W){const Y=this.buffer.slice(this.pos,this.pos+W);return this.pos+=Y.byteLength,Y}}e.BufferReader=t;class n{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=n;var y;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object",K[K.Int=6]="Int"})(y||(y={}));function O(K){const W=S.VSBuffer.alloc(1);return W.writeUInt8(K,0),W}const g={Undefined:O(y.Undefined),String:O(y.String),Buffer:O(y.Buffer),VSBuffer:O(y.VSBuffer),Array:O(y.Array),Object:O(y.Object),Uint:O(y.Int)},b=typeof Buffer<"u";function C(K,W){if(typeof W>"u")K.write(g.Undefined);else if(typeof W=="string"){const Y=S.VSBuffer.fromString(W);K.write(g.String),r(K,Y.byteLength),K.write(Y)}else if(b&&Buffer.isBuffer(W)){const Y=S.VSBuffer.wrap(W);K.write(g.Buffer),r(K,Y.byteLength),K.write(Y)}else if(W instanceof S.VSBuffer)K.write(g.VSBuffer),r(K,W.byteLength),K.write(W);else if(Array.isArray(W)){K.write(g.Array),r(K,W.length);for(const Y of W)C(K,Y)}else if(typeof W=="number"&&(W|0)===W)K.write(g.Uint),r(K,W);else{const Y=S.VSBuffer.fromString(JSON.stringify(W));K.write(g.Object),r(K,Y.byteLength),K.write(Y)}}e.serialize=C;function A(K){switch(K.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return K.read(o(K)).toString();case y.Buffer:return K.read(o(K)).buffer;case y.VSBuffer:return K.read(o(K));case y.Array:{const Y=o(K),te=[];for(let j=0;j<Y;j++)te.push(A(K));return te}case y.Object:return JSON.parse(K.read(o(K)).toString());case y.Int:return o(K)}}e.deserialize=A;class ${constructor(W,Y,te=null,j=1e3){this.protocol=W,this.ctx=Y,this.logger=te,this.timeoutDelay=j,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(W,Y){this.channels.set(W,Y),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const Y=this.send([W.type]);this.logger?.logOutgoing(Y,0,1,u(W.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(Y,W.id,1,u(W.type),W.data);return}}}send(W,Y=void 0){const te=new n;return C(te,W),C(te,Y),this.sendBuffer(te.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const Y=new t(W),te=A(Y),j=A(Y),ee=te[0];switch(ee){case 100:return this.logger?.logIncoming(W.byteLength,te[1],1,`${c(ee)}: ${te[2]}.${te[3]}`,j),this.onPromise({type:ee,id:te[1],channelName:te[2],name:te[3],arg:j});case 102:return this.logger?.logIncoming(W.byteLength,te[1],1,`${c(ee)}: ${te[2]}.${te[3]}`,j),this.onEventListen({type:ee,id:te[1],channelName:te[2],name:te[3],arg:j});case 101:return this.logger?.logIncoming(W.byteLength,te[1],1,`${c(ee)}`),this.disposeActiveRequest({type:ee,id:te[1]});case 103:return this.logger?.logIncoming(W.byteLength,te[1],1,`${c(ee)}`),this.disposeActiveRequest({type:ee,id:te[1]})}}onPromise(W){const Y=this.channels.get(W.channelName);if(!Y){this.collectPendingRequest(W);return}const te=new I.CancellationTokenSource;let j;try{j=Y.call(this.ctx,W.name,W.arg,te.token)}catch(x){j=Promise.reject(x)}const ee=W.id;j.then(x=>{this.sendResponse({id:ee,data:x,type:201})},x=>{x instanceof Error?this.sendResponse({id:ee,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.sendResponse({id:ee,data:x,type:203})}).finally(()=>{me.dispose(),this.activeRequests.delete(W.id)});const me=(0,l.toDisposable)(()=>te.cancel());this.activeRequests.set(W.id,me)}onEventListen(W){const Y=this.channels.get(W.channelName);if(!Y){this.collectPendingRequest(W);return}const te=W.id,ee=Y.listen(this.ctx,W.name,W.arg)(me=>this.sendResponse({id:te,data:me,type:204}));this.activeRequests.set(W.id,ee)}disposeActiveRequest(W){const Y=this.activeRequests.get(W.id);Y&&(Y.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let Y=this.pendingRequests.get(W.channelName);Y||(Y=[],this.pendingRequests.set(W.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:W,timeoutTimer:te})}flushPendingRequests(W){const Y=this.pendingRequests.get(W);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=$;var B;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(B||(e.RequestInitiator=B={}));class a{constructor(W,Y=null){this.protocol=W,this.isDisposed=!1,this.state=i.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(W){const Y=this;return{call(te,j,ee){return Y.isDisposed?Promise.reject(new E.CancellationError):Y.requestPromise(W,te,j,ee)},listen(te,j){return Y.isDisposed?f.Event.None:Y.requestEvent(W,te,j)}}}requestPromise(W,Y,te,j=I.CancellationToken.None){const ee=this.lastRequestId++,x={id:ee,type:100,channelName:W,name:Y,arg:te};if(j.isCancellationRequested)return Promise.reject(new E.CancellationError);let h;return new Promise((ie,T)=>{if(j.isCancellationRequested)return T(new E.CancellationError);const Q=()=>{const F=G=>{switch(G.type){case 201:this.handlers.delete(ee),ie(G.data);break;case 202:{this.handlers.delete(ee);const Z=new Error(G.data.message);Z.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,Z.name=G.data.name,T(Z);break}case 203:this.handlers.delete(ee),T(G.data);break}};this.handlers.set(ee,F),this.sendRequest(x)};let H=null;this.state===i.Idle?Q():(H=(0,D.createCancelablePromise)(F=>this.whenInitialized()),H.then(()=>{H=null,Q()}));const V=()=>{H?(H.cancel(),H=null):this.sendRequest({id:ee,type:101}),T(new E.CancellationError)},L=j.onCancellationRequested(V);h=(0,l.combinedDisposable)((0,l.toDisposable)(V),L),this.activeRequests.add(h)}).finally(()=>{h.dispose(),this.activeRequests.delete(h)})}requestEvent(W,Y,te){const j=this.lastRequestId++,me={id:j,type:102,channelName:W,name:Y,arg:te};let x=null;const h=new f.Emitter({onWillAddFirstListener:()=>{x=(0,D.createCancelablePromise)(ie=>this.whenInitialized()),x.then(()=>{x=null,this.activeRequests.add(h),this.sendRequest(me)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.activeRequests.delete(h),this.sendRequest({id:j,type:103}))}}),U=ie=>h.fire(ie.data);return this.handlers.set(j,U),h.event}sendRequest(W){switch(W.type){case 100:case 102:{const Y=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(Y,W.id,0,`${c(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const Y=this.send([W.type,W.id]);this.logger?.logOutgoing(Y,W.id,0,c(W.type));return}}}send(W,Y=void 0){const te=new n;return C(te,W),C(te,Y),this.sendBuffer(te.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const Y=new t(W),te=A(Y),j=A(Y),ee=te[0];switch(ee){case 200:return this.logger?.logIncoming(W.byteLength,0,0,u(ee)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,te[1],0,u(ee),j),this.onResponse({type:te[0],id:te[1],data:j})}}onResponse(W){if(W.type===200){this.state=i.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===i.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=a,ge([M.memoize],a.prototype,"onDidInitializePromise",null);class _{get connections(){const W=[];return this._connections.forEach(Y=>W.push(Y)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(W(({protocol:Y,onDidClientDisconnect:te})=>{const j=f.Event.once(Y.onMessage);this.disposables.add(j(ee=>{const me=new t(ee),x=A(me),h=new $(Y,x),U=new a(Y);this.channels.forEach((T,Q)=>h.registerChannel(Q,T));const ie={channelServer:h,channelClient:U,ctx:x};this._connections.add(ie),this._onDidAddConnection.fire(ie),this.disposables.add(te(()=>{h.dispose(),U.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)}))}))}))}getChannel(W,Y){const te=this;return{call(j,ee,me){let x;if((0,v.isFunction)(Y)){const U=(0,w.getRandomElement)(te.connections.filter(Y));x=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(te.onDidAddConnection,Y))}else x=Y.routeCall(te,j,ee);const h=x.then(U=>U.channelClient.getChannel(W));return q(h).call(j,ee,me)},listen(j,ee){if((0,v.isFunction)(Y))return te.getMulticastEvent(W,Y,j,ee);const me=Y.routeEvent(te,j,ee).then(x=>x.channelClient.getChannel(W));return q(me).listen(j,ee)}}}getMulticastEvent(W,Y,te,j){const ee=this;let me;const x=new f.Emitter({onWillAddFirstListener:()=>{me=new l.DisposableStore;const h=new f.EventMultiplexer,U=new Map,ie=Q=>{const V=Q.channelClient.getChannel(W).listen(te,j),L=h.add(V);U.set(Q,L)},T=Q=>{const H=U.get(Q);H&&(H.dispose(),U.delete(Q))};ee.connections.filter(Y).forEach(ie),f.Event.filter(ee.onDidAddConnection,Y)(ie,void 0,me),ee.onDidRemoveConnection(T,void 0,me),h.event(x.fire,x,me),me.add(h)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return x.event}registerChannel(W,Y){this.channels.set(W,Y);for(const te of this._connections)te.channelServer.registerChannel(W,Y)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class k{constructor(W,Y,te=null){const j=new n;C(j,Y),W.send(j.buffer),this.channelClient=new a(W,te),this.channelServer=new $(W,Y,te)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,Y){this.channelServer.registerChannel(W,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function q(K){return{call(W,Y,te){return K.then(j=>j.call(W,Y,te))},listen(W,Y){const te=new f.Relay;return K.then(j=>te.input=j.listen(W,Y)),te.event}}}e.getDelayedChannel=q;function R(K){let W=!1;return{call(Y,te,j){return W?K.call(Y,te,j):(0,D.timeout)(0).then(()=>W=!0).then(()=>K.call(Y,te,j))},listen(Y,te){if(W)return K.listen(Y,te);const j=new f.Relay;return(0,D.timeout)(0).then(()=>W=!0).then(()=>j.input=K.listen(Y,te)),j.event}}}e.getNextTickChannel=R;class z{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const Y of W.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await f.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=z;var ne;(function(K){function W(ee,me,x){const h=ee,U=x&&x.disableMarshalling,ie=new Map;for(const T in h)te(T)&&ie.set(T,f.Event.buffer(h[T],!0,void 0,me));return new class{listen(T,Q,H){const V=ie.get(Q);if(V)return V;if(j(Q)){const L=h[Q];if(typeof L=="function")return L.call(h,H)}throw new E.ErrorNoTelemetry(`Event not found: ${Q}`)}call(T,Q,H){const V=h[Q];if(typeof V=="function"){if(!U&&Array.isArray(H))for(let F=0;F<H.length;F++)H[F]=(0,P.revive)(H[F]);let L=V.apply(h,H);return L instanceof Promise||(L=Promise.resolve(L)),L}throw new E.ErrorNoTelemetry(`Method not found: ${Q}`)}}}K.fromService=W;function Y(ee,me){const x=me&&me.disableMarshalling;return new Proxy({},{get(h,U){if(typeof U=="string")return me?.properties?.has(U)?me.properties.get(U):j(U)?function(ie){return ee.listen(U,ie)}:te(U)?ee.listen(U):async function(...ie){let T;me&&!(0,v.isUndefinedOrNull)(me.context)?T=[me.context,...ie]:T=ie;const Q=await ee.call(U,T);return x?Q:(0,P.revive)(Q)};throw new E.ErrorNoTelemetry(`Property not found: ${String(U)}`)}})}K.toService=Y;function te(ee){return ee[0]==="o"&&ee[1]==="n"&&p.isUpperAsciiLetter(ee.charCodeAt(2))}function j(ee){return/^onDynamic/.test(ee)&&p.isUpperAsciiLetter(ee.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const W=K.toString();if(W!=="[object Object]")return W}return K}function se(K){return Array.isArray(K)?K.map(X):X(K)}function ce(K,W,Y,te,j,ee,me){me=se(me);const x=re[j],h=x[te%x.length];let U=[`%c[${K}]%c[${String(W).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(ee)?(U=U.concat(me),U.push(")")):U.push(me),console.log.apply(console,U)}class fe{constructor(W,Y){this._outgoingPrefix=W,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,Y,te,j,ee){this._totalOutgoing+=W,ce(this._outgoingPrefix,this._totalOutgoing,W,Y,te,j,ee)}logIncoming(W,Y,te,j,ee){this._totalIncoming+=W,ce(this._incomingPrefix,this._totalIncoming,W,Y,te,j,ee)}}e.IPCLogger=fe}),define(ue[64],he([0,1,26,9,18,17,58,6,4,2,30,34,33,27]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends s.ChannelServer{constructor(i){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",o=>S.VSBuffer.wrap(Buffer.from(o,"base64")))},i),process.once("disconnect",()=>this.dispose())}}e.Server=c;class d{constructor(i,o){this.modulePath=i,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new D.Delayer(m),this.child=null,this._client=null}getChannel(i){const o=this;return{call(m,r,t){return o.requestPromise(i,m,r,t)},listen(m,r){return o.requestEvent(i,m,r)}}}requestPromise(i,o,m,r=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(i),n=(0,D.createCancelablePromise)(g=>t.call(o,m,g)),y=r.onCancellationRequested(()=>n.cancel()),O=(0,l.toDisposable)(()=>n.cancel());return this.activeRequests.add(O),n.finally(()=>{y.dispose(),this.activeRequests.delete(O),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(i,o,m){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let r;const t=new f.Emitter({onWillAddFirstListener:()=>{r=this.getCachedChannel(i).listen(o,m)(t.fire,t),this.activeRequests.add(r)},onDidRemoveLastListener:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const i=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(o.env={...o.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(b=>!/^--inspect(-brk)?=/.test(b)).filter(b=>!b.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(o.env),this.child=(0,w.fork)(this.modulePath,i,o);const m=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",b=>b)(b=>{if((0,M.isRemoteConsoleLog)(b)){(0,M.log)(b,`IPC Library: ${this.options.serverName}`);return}m.fire(S.VSBuffer.wrap(Buffer.from(b,"base64")))});const t=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,n=b=>this.child&&this.child.connected&&t.send(b.buffer.toString("base64")),y=m.event,O={send:n,onMessage:y};this._client=new s.ChannelClient(O);const g=()=>this.disposeClient();process.once("exit",g),this.child.on("error",b=>console.warn('IPC "'+this.options.serverName+'" errored with '+b)),this.child.on("exit",(b,C)=>{process.removeListener("exit",g),this.activeRequests.forEach(A=>(0,l.dispose)(A)),this.activeRequests.clear(),b!==0&&C!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+b+" and signal "+C),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:b,signal:C})})}return this._client}getCachedChannel(i){let o=this.channels.get(i);return o||(o=this.client.getChannel(i),this.channels.set(i,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(ue[65],he([0,1,31,18,27,4,8,16]),function(oe,e,w,D,S,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class f{constructor(v){this.port=v,this.onMessage=I.Event.fromNodeEventEmitter(this.port,"message",s=>s.data?D.VSBuffer.wrap(s.data):D.VSBuffer.alloc(0)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}class l extends S.IPCServer{static getOnDidClientConnect(v){(0,M.assertType)((0,w.isUtilityProcess)(process),"Electron Utility Process");const s=new I.Emitter;return process.parentPort.on("message",c=>{if(v?.handledClientConnection(c))return;const d=(0,E.firstOrDefault)(c.ports);d&&s.fire(d)}),I.Event.map(s.event,c=>({protocol:new f(c),onDidClientDisconnect:I.Event.fromNodeEventEmitter(c,"close")}))}constructor(v){super(l.getOnDidClientConnect(v))}}e.Server=l;function P(p,v,s){const c=d=>{d.data===v&&(p.removeListener("message",c),s())};p.on("message",c)}e.once=P}),define(ue[66],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(ue[67],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(ue[68],he([13,12]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(ue[69],he([13,12]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ue[70],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(ue[71],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(ue[72],he([0,1,6,67]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var S;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(S||(e.TokenType=S={}));function I(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const M=(0,D.localize)(3,null),E=(0,D.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(P){return this._input=P,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const p=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:p})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const p=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:p})}else this._match(126)?this._addToken(9):this._error(I("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(I("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(P){return this._isAtEnd()||this._input.charCodeAt(this._current)!==P?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(P){this._tokens.push({type:P,offset:this._start})}_error(P){const p=this._start,v=this._input.substring(this._start,this._current),s={type:19,offset:this._start,lexeme:v};this._errors.push({offset:p,lexeme:v,additionalInfo:P}),this._tokens.push(s)}_string(){this.stringRe.lastIndex=this._start;const P=this.stringRe.exec(this._input);if(P){this._current=this._start+P[0].length;const p=this._input.substring(this._start,this._current),v=f._keywords.get(p);v?this._addToken(v):this._tokens.push({type:17,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let P=this._current,p=!1,v=!1;for(;;){if(P>=this._input.length){this._current=P,this._error(E);return}const c=this._input.charCodeAt(P);if(p)p=!1;else if(c===47&&!v){P++;break}else c===91?v=!0:c===92?p=!0:c===93&&(v=!1);P++}for(;P<this._input.length&&f._regexFlags.has(this._input.charCodeAt(P));)P++;this._current=P;const s=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:s,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(ue[73],he([0,1,54,14,19,7,15,23,5]),function(oe,e,w,D,S,I,M,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,I.dirname)(S.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const s=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",s)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(f.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const s=M.env.VSCODE_PORTABLE;return s?f.URI.file((0,I.join)(s,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const s=this.args["builtin-extensions-dir"];return s?(0,I.resolve)(s):(0,I.normalize)((0,I.join)(S.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const s=this.args["extensions-download-dir"];return s?f.URI.file((0,I.resolve)(s)):f.URI.file((0,I.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const s=this.args["extensions-dir"];if(s)return(0,I.resolve)(s);const c=M.env.VSCODE_EXTENSIONS;if(c)return c;const d=M.env.VSCODE_PORTABLE;return d?(0,I.join)(d,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const s=this.args.extensionDevelopmentPath;if(Array.isArray(s))return s.map(c=>/^[^:/?#]+?:\/\//.test(c)?f.URI.parse(c):f.URI.file((0,I.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(s=>s==="ui"||s==="workspace"||s==="web"?s:"workspace")}get extensionTestsLocationURI(){const s=this.args.extensionTestsPath;if(s)return/^[^:/?#]+?:\/\//.test(s)?f.URI.parse(s):f.URI.file((0,I.normalize)(s))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const s=this.args["disable-extension"];if(s){if(typeof s=="string")return[s];if(Array.isArray(s)&&s.length>0)return s}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(s=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(s))}get extensionLogLevel(){const s=[];for(const c of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(c);d&&d[1]&&d[2]&&s.push([d[1],d[2]])}return s.length?s:void 0}get serviceMachineIdResource(){return(0,E.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const s=M.env.VSCODE_PORTABLE;return s?f.URI.file((0,I.join)(s,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(s){this.args.continueOn=s}get args(){return this._args}constructor(s,c,d){this._args=s,this.paths=c,this.productService=d,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ge([D.memoize],l.prototype,"appRoot",null),ge([D.memoize],l.prototype,"userHome",null),ge([D.memoize],l.prototype,"userDataPath",null),ge([D.memoize],l.prototype,"appSettingsHome",null),ge([D.memoize],l.prototype,"tmpDir",null),ge([D.memoize],l.prototype,"cacheHome",null),ge([D.memoize],l.prototype,"stateResource",null),ge([D.memoize],l.prototype,"userRoamingDataHome",null),ge([D.memoize],l.prototype,"userDataSyncHome",null),ge([D.memoize],l.prototype,"sync",null),ge([D.memoize],l.prototype,"machineSettingsResource",null),ge([D.memoize],l.prototype,"workspaceStorageHome",null),ge([D.memoize],l.prototype,"localHistoryHome",null),ge([D.memoize],l.prototype,"keyboardLayoutResource",null),ge([D.memoize],l.prototype,"argvResource",null),ge([D.memoize],l.prototype,"isExtensionDevelopment",null),ge([D.memoize],l.prototype,"untitledWorkspacesHome",null),ge([D.memoize],l.prototype,"builtinExtensionsPath",null),ge([D.memoize],l.prototype,"extensionsPath",null),ge([D.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ge([D.memoize],l.prototype,"extensionDevelopmentKind",null),ge([D.memoize],l.prototype,"extensionTestsLocationURI",null),ge([D.memoize],l.prototype,"debugExtensionHost",null),ge([D.memoize],l.prototype,"logLevel",null),ge([D.memoize],l.prototype,"extensionLogLevel",null),ge([D.memoize],l.prototype,"serviceMachineIdResource",null),ge([D.memoize],l.prototype,"disableTelemetry",null),ge([D.memoize],l.prototype,"disableWorkspaceTrust",null),ge([D.memoize],l.prototype,"useInMemorySecretStorage",null),ge([D.memoize],l.prototype,"policyFile",null);function P(v,s){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,s,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function p(v,s,c,d,u,i){const m=Number(s||v)||(d?null:c),r=m?!!s:!1;let t;if(i)try{t=JSON.parse(i)}catch{}return{port:m,break:r,debugId:u,env:t}}e.parseDebugParams=p}),define(ue[74],he([0,1,106,3,68]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const I={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(d,u,i=M){const o=d.find(C=>C.length>0&&C[0]!=="-"),m={},r=["_"],t=[],n={};let y;for(const C in u){const A=u[C];A.type==="subcommand"?C===o&&(y=A):(A.alias&&(m[C]=A.alias),A.type==="string"||A.type==="string[]"?(r.push(C),A.deprecates&&r.push(...A.deprecates)):A.type==="boolean"&&(t.push(C),A.deprecates&&t.push(...A.deprecates)),A.global&&(n[C]=A))}if(y&&o){const C=n;for(const a in y.options)C[a]=y.options[a];const A=d.filter(a=>a!==o),$=i.getSubcommandReporter?i.getSubcommandReporter(o):void 0,B=E(A,C,$);return{[o]:B,_:[]}}const O=w(d,{string:r,boolean:t,alias:m}),g={},b=O;g._=O._.map(C=>String(C)).filter(C=>C.length>0),delete b._;for(const C in u){const A=u[C];if(A.type==="subcommand")continue;A.alias&&delete b[A.alias];let $=b[C];if(A.deprecates)for(const B of A.deprecates)b.hasOwnProperty(B)&&($||($=b[B],$&&i.onDeprecatedOption(B,A.deprecationMessage||(0,S.localize)(38,null,C))),delete b[B]);if(typeof $<"u"){if(A.type==="string[]"){if(Array.isArray($)||($=[$]),!A.allowEmptyValue){const B=$.filter(a=>a.length>0);B.length!==$.length&&(i.onEmptyValue(C),$=B.length>0?B:void 0)}}else A.type==="string"&&(Array.isArray($)?($=$.pop(),i.onMultipleValues(C,$)):!$&&!A.allowEmptyValue&&(i.onEmptyValue(C),$=void 0));g[C]=$,A.deprecationMessage&&i.onDeprecatedOption(C,A.deprecationMessage)}delete b[C]}for(const C in b)i.onUnknownOption(C);return g}e.parseArgs=E;function f(d,u){let i="";return u.args&&(Array.isArray(u.args)?i=` <${u.args.join("> <")}>`:i=` <${u.args}>`),u.alias?`-${u.alias} --${d}${i}`:`--${d}${i}`}function l(d,u){const i=[];for(const o in d){const m=d[o],r=f(o,m);i.push([r,m.description])}return P(i,u)}e.formatOptions=l;function P(d,u){const o=d.reduce((t,n)=>Math.max(t,n[0].length),12)+2+1;if(u-o<25)return d.reduce((t,n)=>t.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const m=u-o-1,r=[];for(const t of d){const n=t[0],y=v(t[1],m),O=p(o-n.length-2);r.push("  "+n+O+y[0]);for(let g=1;g<y.length;g++)r.push(p(o)+y[g])}return r}function p(d){return" ".repeat(d)}function v(d,u){const i=[];for(;d.length;){const o=d.length<u?d.length:d.lastIndexOf(" ",u),m=d.slice(0,o).trim();d=d.slice(o),i.push(m)}return i}function s(d,u,i,o,m){const r=process.stdout.isTTY&&process.stdout.columns||80,t=m?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",n=[`${d} ${i}`];n.push(""),n.push(`${(0,S.localize)(40,null)}: ${u} [${(0,S.localize)(41,null)}]${t}`),n.push(""),m?.noPipe!==!0&&(D.isWindows?n.push((0,S.localize)(42,null,u)):n.push((0,S.localize)(43,null,u)),n.push(""));const y={},O=[];for(const g in o){const b=o[g];if(b.type==="subcommand")b.description&&O.push({command:g,description:b.description});else if(b.description&&b.cat){let C=y[b.cat];C||(y[b.cat]=C={}),C[g]=b}}for(const g in y){const b=g,C=y[b];C&&(n.push(I[b]),n.push(...l(C,r)),n.push(""))}return O.length&&(n.push((0,S.localize)(44,null)),n.push(...P(O.map(g=>[g.command,g.description]),r)),n.push("")),n.join(`
`)}e.buildHelpMessage=s;function c(d,u){return`${d||(0,S.localize)(45,null)}
${u||(0,S.localize)(46,null)}
${process.arch}`}e.buildVersionMessage=c}),function(){"use strict";function oe(e,w,D){function S(M,E){const f=I(M,E),l=[f];return e.isAbsolute(f)||l.unshift(D),e.resolve(...l)}function I(M,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,E);const P=M["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(p,"AppData","Roaming")}break;case"darwin":l=e.join(w.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,E)}return{getUserDataPath:S}}if(typeof define=="function")define(ue[75],he([76,20,15]),function(e,w,D){return oe(e,w,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=oe(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[77],he([0,1,20,73,75]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class I extends D.AbstractNativeEnvironmentService{constructor(l,P){super(l,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,S.getUserDataPath)(l,P.nameShort)},P)}}e.NativeEnvironmentService=I;function M(f,l){return(0,D.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.parsePtyHostDebugPort=M;function E(f,l){return(0,D.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.parseSharedProcessDebugPort=E}),define(ue[21],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function E(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=E})(w||(e._util=w={})),e.IInstantiationService=S("instantiationService");function D(M,E,f){E[w.DI_TARGET]===E?E[w.DI_DEPENDENCIES].push({id:M,index:f}):(E[w.DI_DEPENDENCIES]=[{id:M,index:f}],E[w.DI_TARGET]=E)}function S(M){if(w.serviceIds.has(M))return w.serviceIds.get(M);const E=function(f,l,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(E,f,P)};return E.toString=()=>M,w.serviceIds.set(M,E),E}e.createDecorator=S;function I(M){return M}e.refineServiceDecorator=I}),define(ue[35],he([0,1,3,11,72,21,66,6]),function(oe,e,w,D,S,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",w.isMacintosh),f.set("isLinux",w.isLinux),f.set("isWindows",w.isWindows),f.set("isWeb",w.isWeb),f.set("isMacNative",w.isMacintosh&&!w.isWeb),f.set("isEdge",w.isEdge),f.set("isFirefox",w.isFirefox),f.set("isChrome",w.isChrome),f.set("isSafari",w.isSafari);function l(x,h){if(f.get(x)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(x,h)}e.setConstant=l;const P=Object.prototype.hasOwnProperty;var p;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},s=(0,M.localize)(0,null),c=(0,M.localize)(1,null),d=(0,M.localize)(2,null),u=(0,M.localize)(3,null),i=(0,M.localize)(4,null),o=(0,M.localize)(5,null),m=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class t{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(h=v){this._config=h,this._scanner=new S.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(h){if(h===""){this._parsingErrors.push({message:s,offset:0,lexeme:"",additionalInfo:c});return}this._tokens=this._scanner.reset(h).scan(),this._current=0,this._parsingErrors=[];try{const U=this._expr();if(!this._isAtEnd()){const ie=this._peek(),T=ie.type===17?o:void 0;throw this._parsingErrors.push({message:i,offset:ie.offset,lexeme:S.Scanner.getLexeme(ie),additionalInfo:T}),t._parseError}return U}catch(U){if(U!==t._parseError)throw U;return}}_expr(){return this._or()}_or(){const h=[this._and()];for(;this._matchOne(16);){const U=this._and();h.push(U)}return h.length===1?h[0]:n.or(...h)}_and(){const h=[this._term()];for(;this._matchOne(15);){const U=this._term();h.push(U)}return h.length===1?h[0]:n.and(...h)}_term(){if(this._matchOne(2)){const h=this._peek();switch(h.type){case 11:return this._advance(),b.INSTANCE;case 12:return this._advance(),C.INSTANCE;case 0:{this._advance();const U=this._expr();return this._consume(1,u),U?.negate()}case 17:return this._advance(),k.create(h.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",h)}}return this._primary()}_primary(){const h=this._peek();switch(h.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const U=this._expr();return this._consume(1,u),U}case 17:{const U=h.lexeme;if(this._advance(),this._matchOne(9)){const T=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),T.type!==10)throw this._errExpectedButGot("REGEX",T);const Q=T.lexeme,H=Q.lastIndexOf("/"),V=H===Q.length-1?void 0:this._removeFlagsGY(Q.substring(H+1));let L;try{L=new RegExp(Q.substring(1,H),V)}catch{throw this._errExpectedButGot("REGEX",T)}return X.create(U,L)}switch(T.type){case 10:case 19:{const Q=[T.lexeme];this._advance();let H=this._peek(),V=0;for(let le=0;le<T.lexeme.length;le++)T.lexeme.charCodeAt(le)===40?V++:T.lexeme.charCodeAt(le)===41&&V--;for(;!this._isAtEnd()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let le=0;le<H.lexeme.length;le++)H.lexeme.charCodeAt(le)===40?V++:T.lexeme.charCodeAt(le)===41&&V--}if(V<0)break;Q.push(S.Scanner.getLexeme(H)),this._advance(),H=this._peek()}const L=Q.join(""),F=L.lastIndexOf("/"),G=F===L.length-1?void 0:this._removeFlagsGY(L.substring(F+1));let Z;try{Z=new RegExp(L.substring(1,F),G)}catch{throw this._errExpectedButGot("REGEX",T)}return n.regex(U,Z)}case 18:{const Q=T.lexeme;this._advance();let H=null;if(!(0,D.isFalsyOrWhitespace)(Q)){const V=Q.indexOf("/"),L=Q.lastIndexOf("/");if(V!==L&&V>=0){const F=Q.slice(V+1,L),G=Q[L+1]==="i"?"i":"";try{H=new RegExp(F,G)}catch{throw this._errExpectedButGot("REGEX",T)}}}if(H===null)throw this._errExpectedButGot("REGEX",T);return X.create(U,H)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,d);const T=this._value();return n.notIn(U,T)}switch(this._peek().type){case 3:{this._advance();const T=this._value();if(this._previous().type===18)return n.equals(U,T);switch(T){case"true":return n.has(U);case"false":return n.not(U);default:return n.equals(U,T)}}case 4:{this._advance();const T=this._value();if(this._previous().type===18)return n.notEquals(U,T);switch(T){case"true":return n.not(U);case"false":return n.has(U);default:return n.notEquals(U,T)}}case 5:return this._advance(),ne.create(U,this._value());case 6:return this._advance(),re.create(U,this._value());case 7:return this._advance(),R.create(U,this._value());case 8:return this._advance(),z.create(U,this._value());case 13:return this._advance(),n.in(U,this._value());default:return n.has(U)}}case 20:throw this._parsingErrors.push({message:m,offset:h.offset,lexeme:"",additionalInfo:r}),t._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const h=this._peek();switch(h.type){case 17:case 18:return this._advance(),h.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(h){return h.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(h){return this._check(h)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(h,U){if(this._check(h))return this._advance();throw this._errExpectedButGot(U,this._peek())}_errExpectedButGot(h,U,ie){const T=(0,M.localize)(8,null,h,S.Scanner.getLexeme(U)),Q=U.offset,H=S.Scanner.getLexeme(U);return this._parsingErrors.push({message:T,offset:Q,lexeme:H,additionalInfo:ie}),t._parseError}_check(h){return this._peek().type===h}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=t;class n{static false(){return b.INSTANCE}static true(){return C.INSTANCE}static has(h){return A.create(h)}static equals(h,U){return $.create(h,U)}static notEquals(h,U){return _.create(h,U)}static regex(h,U){return X.create(h,U)}static in(h,U){return B.create(h,U)}static notIn(h,U){return a.create(h,U)}static not(h){return k.create(h)}static and(...h){return fe.create(h,null,!0)}static or(...h){return K.create(h,null,!0)}static greater(h,U){return R.create(h,U)}static greaterEquals(h,U){return z.create(h,U)}static smaller(h,U){return ne.create(h,U)}static smallerEquals(h,U){return re.create(h,U)}static{this._parser=new t({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this._parser.parse(h)}}e.ContextKeyExpr=n;function y(x){const h=new t({regexParsingWithErrorRecovery:!1});return x.map(U=>(h.parse(U),h.lexingErrors.length>0?h.lexingErrors.map(ie=>({errorMessage:ie.additionalInfo?(0,M.localize)(9,null,ie.additionalInfo):(0,M.localize)(10,null),offset:ie.offset,length:ie.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(ie=>({errorMessage:ie.additionalInfo?`${ie.message}. ${ie.additionalInfo}`:ie.message,offset:ie.offset,length:ie.lexeme.length})):[]))}e.validateWhenClauses=y;function O(x,h){const U=x?x.substituteConstants():void 0,ie=h?h.substituteConstants():void 0;return!U&&!ie?!0:!U||!ie?!1:U.equals(ie)}e.expressionsAreEqualWithConstantSubstitution=O;function g(x,h){return x.cmp(h)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=b;class C{static{this.INSTANCE=new C}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=C;class A{static create(h,U=null){const ie=f.get(h);return typeof ie=="boolean"?ie?C.INSTANCE:b.INSTANCE:new A(h,U)}constructor(h,U){this.key=h,this.negated=U,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=f.get(this.key);return typeof h=="boolean"?h?C.INSTANCE:b.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=A;class ${static create(h,U,ie=null){if(typeof U=="boolean")return U?A.create(h,ie):k.create(h,ie);const T=f.get(h);return typeof T=="boolean"?U===(T?"true":"false")?C.INSTANCE:b.INSTANCE:new $(h,U,ie)}constructor(h,U,ie){this.key=h,this.value=U,this.negated=ie,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=f.get(this.key);if(typeof h=="boolean"){const U=h?"true":"false";return this.value===U?C.INSTANCE:b.INSTANCE}return this}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=$;class B{static create(h,U){return new B(h,U)}constructor(h,U){this.key=h,this.valueKey=U,this.type=10,this.negated=null}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}substituteConstants(){return this}evaluate(h){const U=h.getValue(this.valueKey),ie=h.getValue(this.key);return Array.isArray(U)?U.includes(ie):typeof ie=="string"&&typeof U=="object"&&U!==null?P.call(U,ie):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=a.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=B;class a{static create(h,U){return new a(h,U)}constructor(h,U){this.key=h,this.valueKey=U,this.type=11,this._negated=B.create(h,U)}cmp(h){return h.type!==this.type?this.type-h.type:this._negated.cmp(h._negated)}equals(h){return h.type===this.type?this._negated.equals(h._negated):!1}substituteConstants(){return this}evaluate(h){return!this._negated.evaluate(h)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(h){return h.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=a;class _{static create(h,U,ie=null){if(typeof U=="boolean")return U?k.create(h,ie):A.create(h,ie);const T=f.get(h);return typeof T=="boolean"?U===(T?"true":"false")?b.INSTANCE:C.INSTANCE:new _(h,U,ie)}constructor(h,U,ie){this.key=h,this.value=U,this.negated=ie,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=f.get(this.key);if(typeof h=="boolean"){const U=h?"true":"false";return this.value===U?b.INSTANCE:C.INSTANCE}return this}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class k{static create(h,U=null){const ie=f.get(h);return typeof ie=="boolean"?ie?b.INSTANCE:C.INSTANCE:new k(h,U)}constructor(h,U){this.key=h,this.negated=U,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=f.get(this.key);return typeof h=="boolean"?h?b.INSTANCE:C.INSTANCE:this}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return this.negated||(this.negated=A.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function q(x,h){if(typeof x=="string"){const U=parseFloat(x);isNaN(U)||(x=U)}return typeof x=="string"||typeof x=="number"?h(x):b.INSTANCE}class R{static create(h,U,ie=null){return q(U,T=>new R(h,T,ie))}constructor(h,U,ie){this.key=h,this.value=U,this.negated=ie,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=R;class z{static create(h,U,ie=null){return q(U,T=>new z(h,T,ie))}constructor(h,U,ie){this.key=h,this.value=U,this.negated=ie,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ne.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=z;class ne{static create(h,U,ie=null){return q(U,T=>new ne(h,T,ie))}constructor(h,U,ie){this.key=h,this.value=U,this.negated=ie,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ne;class re{static create(h,U,ie=null){return q(U,T=>new re(h,T,ie))}constructor(h,U,ie){this.key=h,this.value=U,this.negated=ie,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:te(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=re;class X{static create(h,U){return new X(h,U)}constructor(h,U){this.key=h,this.regexp=U,this.type=7,this.negated=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const U=this.regexp?this.regexp.source:"",ie=h.regexp?h.regexp.source:"";return U<ie?-1:U>ie?1:0}equals(h){if(h.type===this.type){const U=this.regexp?this.regexp.source:"",ie=h.regexp?h.regexp.source:"";return this.key===h.key&&U===ie}return!1}substituteConstants(){return this}evaluate(h){const U=h.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=se.create(this)),this.negated}}e.ContextKeyRegexExpr=X;class se{static create(h){return new se(h)}constructor(h){this._actual=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}substituteConstants(){return this}evaluate(h){return!this._actual.evaluate(h)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(h){return new se(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=se;function ce(x){let h=null;for(let U=0,ie=x.length;U<ie;U++){const T=x[U].substituteConstants();if(x[U]!==T&&h===null){h=[];for(let Q=0;Q<U;Q++)h[Q]=x[Q]}h!==null&&(h[U]=T)}return h===null?x:h}class fe{static create(h,U,ie){return fe._normalizeArr(h,U,ie)}constructor(h,U){this.expr=h,this.negated=U,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let U=0,ie=this.expr.length;U<ie;U++){const T=g(this.expr[U],h.expr[U]);if(T!==0)return T}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let U=0,ie=this.expr.length;U<ie;U++)if(!this.expr[U].equals(h.expr[U]))return!1;return!0}return!1}substituteConstants(){const h=ce(this.expr);return h===this.expr?this:fe.create(h,this.negated,!1)}evaluate(h){for(let U=0,ie=this.expr.length;U<ie;U++)if(!this.expr[U].evaluate(h))return!1;return!0}static _normalizeArr(h,U,ie){const T=[];let Q=!1;for(const H of h)if(H){if(H.type===1){Q=!0;continue}if(H.type===0)return b.INSTANCE;if(H.type===6){T.push(...H.expr);continue}T.push(H)}if(T.length===0&&Q)return C.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(g);for(let H=1;H<T.length;H++)T[H-1].equals(T[H])&&(T.splice(H,1),H--);if(T.length===1)return T[0];for(;T.length>1;){const H=T[T.length-1];if(H.type!==9)break;T.pop();const V=T.pop(),L=T.length===0,F=K.create(H.expr.map(G=>fe.create([G,V],null,ie)),null,L);F&&(T.push(F),T.sort(g))}if(T.length===1)return T[0];if(ie){for(let H=0;H<T.length;H++)for(let V=H+1;V<T.length;V++)if(T[H].negate().equals(T[V]))return b.INSTANCE;if(T.length===1)return T[0]}return new fe(T,U)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const U of this.expr)h.push(...U.keys());return h}map(h){return new fe(this.expr.map(U=>U.map(h)),null)}negate(){if(!this.negated){const h=[];for(const U of this.expr)h.push(U.negate());this.negated=K.create(h,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class K{static create(h,U,ie){return K._normalizeArr(h,U,ie)}constructor(h,U){this.expr=h,this.negated=U,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let U=0,ie=this.expr.length;U<ie;U++){const T=g(this.expr[U],h.expr[U]);if(T!==0)return T}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let U=0,ie=this.expr.length;U<ie;U++)if(!this.expr[U].equals(h.expr[U]))return!1;return!0}return!1}substituteConstants(){const h=ce(this.expr);return h===this.expr?this:K.create(h,this.negated,!1)}evaluate(h){for(let U=0,ie=this.expr.length;U<ie;U++)if(this.expr[U].evaluate(h))return!0;return!1}static _normalizeArr(h,U,ie){let T=[],Q=!1;if(h){for(let H=0,V=h.length;H<V;H++){const L=h[H];if(L){if(L.type===0){Q=!0;continue}if(L.type===1)return C.INSTANCE;if(L.type===9){T=T.concat(L.expr);continue}T.push(L)}}if(T.length===0&&Q)return b.INSTANCE;T.sort(g)}if(T.length!==0){if(T.length===1)return T[0];for(let H=1;H<T.length;H++)T[H-1].equals(T[H])&&(T.splice(H,1),H--);if(T.length===1)return T[0];if(ie){for(let H=0;H<T.length;H++)for(let V=H+1;V<T.length;V++)if(T[H].negate().equals(T[V]))return C.INSTANCE;if(T.length===1)return T[0]}return new K(T,U)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const U of this.expr)h.push(...U.keys());return h}map(h){return new K(this.expr.map(U=>U.map(h)),null)}negate(){if(!this.negated){const h=[];for(const U of this.expr)h.push(U.negate());for(;h.length>1;){const U=h.shift(),ie=h.shift(),T=[];for(const Q of me(U))for(const H of me(ie))T.push(fe.create([Q,H],null,!1));h.unshift(K.create(T,null,!1))}this.negated=K.create(h,this,!0)}return this.negated}}e.ContextKeyOrExpr=K;class W extends A{static{this._info=[]}static all(){return W._info.values()}constructor(h,U,ie){super(h,null),this._defaultValue=U,typeof ie=="object"?W._info.push({...ie,key:h}):ie!==!0&&W._info.push({key:h,description:ie,type:U!=null?typeof U:void 0})}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return $.create(this.key,h)}notEqualsTo(h){return _.create(this.key,h)}}e.RawContextKey=W,e.IContextKeyService=(0,I.createDecorator)("contextKeyService");function Y(x,h){return x<h?-1:x>h?1:0}function te(x,h,U,ie){return x<U?-1:x>U?1:h<ie?-1:h>ie?1:0}function j(x,h){if(x.type===0||h.type===1)return!0;if(x.type===9)return h.type===9?ee(x.expr,h.expr):!1;if(h.type===9){for(const U of h.expr)if(j(x,U))return!0;return!1}if(x.type===6){if(h.type===6)return ee(h.expr,x.expr);for(const U of x.expr)if(j(U,h))return!0;return!1}return x.equals(h)}e.implies=j;function ee(x,h){let U=0,ie=0;for(;U<x.length&&ie<h.length;){const T=x[U].cmp(h[ie]);if(T<0)return!1;T===0&&U++,ie++}return U===x.length}function me(x){return x.type===9?x.expr:[x]}}),define(ue[78],he([0,1,51,7,11,8,5,69,21,3,19,22]),function(oe,e,w,D,S,I,M,E,f,l,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function v(j){return j.create===!0}e.isFileOpenForWriteOptions=v;var s;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(s||(e.FileType=s={}));var c;(function(j){j[j.Readonly=1]="Readonly",j[j.Locked=2]="Locked"})(c||(e.FilePermission=c={}));function d(j){const ee=j;return!!ee&&typeof ee.onDidChange=="function"}e.isFileSystemWatcher=d;var u;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileAtomicWrite=32768]="FileAtomicWrite",j[j.FileAtomicDelete=65536]="FileAtomicDelete",j[j.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function i(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=i;function o(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=o;function m(j){return!!(j.capabilities&131072)}e.hasFileCloneCapability=m;function r(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function t(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=t;function n(j){return i(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=n;function y(j){return i(j)?!!(j.capabilities&32768):!1}e.hasFileAtomicWriteCapability=y;function O(j){return!!(j.capabilities&65536)}e.hasFileAtomicDeleteCapability=O;function g(j){return!!(j.capabilities&2048)}e.hasReadonlyCapability=g;var b;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsStorageQuota="EntryExceedsStorageQuota",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class C extends Error{static create(ee,me){const x=new C(ee.toString(),me);return B(x,me),x}constructor(ee,me){super(ee),this.code=me}}e.FileSystemProviderError=C;function A(j,ee){return C.create(j,ee)}e.createFileSystemProviderError=A;function $(j){return j||A((0,E.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=$;function B(j,ee){return j.name=ee?`${ee} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=B;function a(j){if(!j)return b.Unknown;if(j instanceof C)return j.code;const ee=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!ee)return b.Unknown;switch(ee[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=a;function _(j){if(j instanceof re)return j.fileOperationResult;switch(a(j)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=_;var k;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class q{constructor(ee,me,x){this.resource=ee,this.operation=me,this.target=x}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=q;var R;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class z{static{this.MIXED_CORRELATION=null}constructor(ee,me){this.ignorePathCasing=me,this.correlationId=void 0,this.added=new p.Lazy(()=>{const x=w.TernarySearchTree.forUris(()=>this.ignorePathCasing);return x.fill(this.rawAdded.map(h=>[h,!0])),x}),this.updated=new p.Lazy(()=>{const x=w.TernarySearchTree.forUris(()=>this.ignorePathCasing);return x.fill(this.rawUpdated.map(h=>[h,!0])),x}),this.deleted=new p.Lazy(()=>{const x=w.TernarySearchTree.forUris(()=>this.ignorePathCasing);return x.fill(this.rawDeleted.map(h=>[h,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of ee){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.correlationId!==z.MIXED_CORRELATION&&(typeof x.cId=="number"?this.correlationId===void 0?this.correlationId=x.cId:this.correlationId!==x.cId&&(this.correlationId=z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=z.MIXED_CORRELATION))}}contains(ee,...me){return this.doContains(ee,{includeChildren:!1},...me)}affects(ee,...me){return this.doContains(ee,{includeChildren:!0},...me)}doContains(ee,me,...x){if(!ee)return!1;const h=x.length>0;return!!((!h||x.includes(1))&&(this.added.value.get(ee)||me.includeChildren&&this.added.value.findSuperstr(ee))||(!h||x.includes(0))&&(this.updated.value.get(ee)||me.includeChildren&&this.updated.value.findSuperstr(ee))||(!h||x.includes(2))&&(this.deleted.value.findSubstr(ee)||me.includeChildren&&this.deleted.value.findSuperstr(ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ee){return this.correlationId===ee}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=z;function ne(j,ee,me){return!j||!ee||j===ee||ee.length>j.length?!1:(ee.charAt(ee.length-1)!==D.sep&&(ee+=D.sep),me?(0,S.startsWithIgnoreCase)(j,ee):j.indexOf(ee)===0)}e.isParent=ne;class re extends Error{constructor(ee,me,x){super(ee),this.fileOperationResult=me,this.options=x}}e.FileOperationError=re;class X extends re{constructor(ee,me,x,h){super(ee,me,h),this.fileOperationResult=me,this.size=x}}e.TooLargeFileOperationError=X;class se extends re{constructor(ee,me,x){super(ee,2,x),this.stat=me}}e.NotModifiedSinceFileOperationError=se;var ce;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var fe;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.ETAG_DISABLED="";function K(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=K;async function W(j,ee){if(!ee.hasProvider(M.URI.from({scheme:j.scheme})))return new Promise(me=>{const x=ee.onDidChangeFileSystemProviderRegistrations(h=>{h.scheme===j.scheme&&h.added&&(x.dispose(),me())})})}e.whenProviderRegistered=W;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(ee){return(0,I.isNumber)(ee)||(ee=0),ee<Y.KB?(0,E.localize)(1,null,ee.toFixed(0)):ee<Y.MB?(0,E.localize)(2,null,(ee/Y.KB).toFixed(2)):ee<Y.GB?(0,E.localize)(3,null,(ee/Y.MB).toFixed(2)):ee<Y.TB?(0,E.localize)(4,null,(ee/Y.GB).toFixed(2)):(0,E.localize)(5,null,(ee/Y.TB).toFixed(2))}}e.ByteSize=Y;function te(j){const ee=typeof j=="string"||j?.scheme===P.Schemas.vscodeRemote;return typeof j!="string"&&j?.scheme===P.Schemas.file?1024*Y.MB:ee?10*Y.MB:l.isWeb?50*Y.MB:1024*Y.MB}e.getLargeFileConfirmationLimit=te}),define(ue[10],he([0,1,56,4,49,2,25,3,23,8,5,35,21]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function s(){return new Date().toISOString()}function c(B){return(0,l.isNumber)(B)}e.isLogLevel=c;var d;(function(B){B[B.Off=0]="Off",B[B.Trace=1]="Trace",B[B.Debug=2]="Debug",B[B.Info=3]="Info",B[B.Warning=4]="Warning",B[B.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function u(B,a,_){switch(a){case d.Trace:B.trace(_);break;case d.Debug:B.debug(_);break;case d.Info:B.info(_);break;case d.Warning:B.warn(_);break;case d.Error:B.error(_);break;case d.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=u;function i(B,a=!1){let _="";for(let k=0;k<B.length;k++){let q=B[k];if(q instanceof Error&&(q=(0,w.toErrorMessage)(q,a)),typeof q=="object")try{q=JSON.stringify(q)}catch{}_+=(k>0?" ":"")+q}return _}class o extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(a){return this.level!==d.Off&&this.level<=a}}e.AbstractLogger=o;class m extends o{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||super.checkLogLevel(a)}trace(a,..._){this.checkLogLevel(d.Trace)&&this.log(d.Trace,i([a,..._],!0))}debug(a,..._){this.checkLogLevel(d.Debug)&&this.log(d.Debug,i([a,..._]))}info(a,..._){this.checkLogLevel(d.Info)&&this.log(d.Info,i([a,..._]))}warn(a,..._){this.checkLogLevel(d.Warning)&&this.log(d.Warning,i([a,..._]))}error(a,..._){if(this.checkLogLevel(d.Error))if(a instanceof Error){const k=Array.prototype.slice.call(arguments);k[0]=a.stack,this.log(d.Error,i(k))}else this.log(d.Error,i([a,..._]))}flush(){}}e.AbstractMessageLogger=m;class r extends o{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!E.isWindows}trace(a,..._){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,a,..._):console.log(`[main ${s()}]`,a,..._))}debug(a,..._){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,a,..._):console.log(`[main ${s()}]`,a,..._))}info(a,..._){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,a,..._):console.log(`[main ${s()}]`,a,..._))}warn(a,..._){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${s()}]\x1B[0m`,a,..._):console.warn(`[main ${s()}]`,a,..._))}error(a,..._){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${s()}]\x1B[0m`,a,..._):console.error(`[main ${s()}]`,a,..._))}flush(){}}e.ConsoleMainLogger=r;class t extends o{constructor(a=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(a)}trace(a,..._){this.checkLogLevel(d.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",a,..._):console.log(a,..._))}debug(a,..._){this.checkLogLevel(d.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",a,..._):console.log(a,..._))}info(a,..._){this.checkLogLevel(d.Info)&&(this.useColors?console.log("%c INFO","color: #33f",a,..._):console.log(a,..._))}warn(a,..._){this.checkLogLevel(d.Warning)&&(this.useColors?console.log("%c WARN","color: #993",a,..._):console.log(a,..._))}error(a,..._){this.checkLogLevel(d.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",a,..._):console.error(a,..._))}flush(){}}e.ConsoleLogger=t;class n extends o{constructor(a,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(_)}trace(a,..._){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(a),..._])}debug(a,..._){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(a),..._])}info(a,..._){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(a),..._])}warn(a,..._){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(a),..._])}error(a,..._){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(a),..._])}extractMessage(a){return typeof a=="string"?a:(0,w.toErrorMessage)(a,this.checkLogLevel(d.Trace))}flush(){}}e.AdapterLogger=n;class y extends o{constructor(a){super(),this.loggers=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const _ of this.loggers)_.setLevel(a);super.setLevel(a)}trace(a,..._){for(const k of this.loggers)k.trace(a,..._)}debug(a,..._){for(const k of this.loggers)k.debug(a,..._)}info(a,..._){for(const k of this.loggers)k.info(a,..._)}warn(a,..._){for(const k of this.loggers)k.warn(a,..._)}error(a,..._){for(const k of this.loggers)k.error(a,..._)}flush(){for(const a of this.loggers)a.flush()}dispose(){for(const a of this.loggers)a.dispose();super.dispose()}}e.MultiplexLogger=y;class O extends I.Disposable{constructor(a,_,k){if(super(),this.logLevel=a,this.logsHome=_,this._loggers=new M.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,k)for(const q of k)this._loggers.set(q.resource,{logger:void 0,info:q})}getLoggerEntry(a){return(0,l.isString)(a)?[...this._loggers.values()].find(_=>_.info.id===a):this._loggers.get(a)}getLogger(a){return this.getLoggerEntry(a)?.logger}createLogger(a,_){const k=this.toResource(a),q=(0,l.isString)(a)?a:_?.id??(0,S.hash)(k.toString()).toString(16);let R=this._loggers.get(k)?.logger;const z=_?.logLevel==="always"?d.Trace:_?.logLevel;R||(R=this.doCreateLogger(k,z??this.getLogLevel(k)??this.logLevel,{..._,id:q}));const ne={logger:R,info:{resource:k,id:q,logLevel:z,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(ne.info),this._loggers.set(k,ne),R}toResource(a){return(0,l.isString)(a)?(0,f.joinPath)(this.logsHome,`${a}.log`):a}setLogLevel(a,_){if(P.URI.isUri(a)){const k=a,q=_,R=this._loggers.get(k);R&&q!==R.info.logLevel&&(R.info.logLevel=q===this.logLevel?void 0:q,R.logger?.setLevel(q),this._loggers.set(R.info.resource,R),this._onDidChangeLogLevel.fire([k,q]))}else{this.logLevel=a;for(const[k,q]of this._loggers.entries())this._loggers.get(k)?.info.logLevel===void 0&&q.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(a,_){const k=this.getLoggerEntry(a);k&&_!==!k.info.hidden&&(k.info.hidden=!_,this._loggers.set(k.info.resource,k),this._onDidChangeVisibility.fire([k.info.resource,_]))}getLogLevel(a){let _;return a&&(_=this._loggers.get(a)?.info.logLevel),_??this.logLevel}registerLogger(a){const _=this._loggers.get(a.resource);_?_.info.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this._loggers.set(a.resource,{info:a,logger:void 0}),this._onDidChangeLoggers.fire({added:[a],removed:[]}))}deregisterLogger(a){const _=this._loggers.get(a);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(a),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const a of this._loggers.values())yield a.info}getRegisteredLogger(a){return this._loggers.get(a)?.info}dispose(){this._loggers.forEach(a=>a.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=O;class g{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(a){}getLevel(){return d.Info}trace(a,..._){}debug(a,..._){}info(a,..._){}warn(a,..._){}error(a,..._){}critical(a,..._){}dispose(){}flush(){}}e.NullLogger=g;class b extends g{}e.NullLogService=b;function C(B){if(B.verbose)return d.Trace;if(typeof B.logLevel=="string"){const a=$(B.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function A(B){switch(B){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=A;function $(B){switch(B){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=$,e.CONTEXT_LOG_LEVEL=new p.RawContextKey("logLevel",A(d.Info))}),define(ue[79],he([0,1,5,4,10,2]),function(oe,e,w,D,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends S.AbstractLoggerService{constructor(p,v,s,c,d){super(v,s,c),this.windowId=p,this.channel=d,this._register(d.listen("onDidChangeLogLevel",p)(u=>{(0,S.isLogLevel)(u)?super.setLogLevel(u):super.setLogLevel(w.URI.revive(u[0]),u[1])})),this._register(d.listen("onDidChangeVisibility",p)(([u,i])=>super.setVisibility(w.URI.revive(u),i))),this._register(d.listen("onDidChangeLoggers",p)(({added:u,removed:i})=>{for(const o of u)super.registerLogger({...o,resource:w.URI.revive(o.resource)});for(const o of i)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new S.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.channel.call("registerLogger",[p,this.windowId])}deregisterLogger(p){super.deregisterLogger(p),this.channel.call("deregisterLogger",[p,this.windowId])}setLogLevel(p,v){super.setLogLevel(p,v),this.channel.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.channel.call("setVisibility",[this.toResource(p),v])}doCreateLogger(p,v,s){return new E(this.channel,p,v,s,this.windowId)}static setLogLevel(p,v,s){return p.call("setLogLevel",[v,s])}}e.LoggerChannelClient=M;class E extends S.AbstractMessageLogger{constructor(p,v,s,c,d){super(c?.logLevel==="always"),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(s),this.channel.call("createLogger",[v,c,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const s=[[p,v]];this.isLoggerCreated?this.doLog(s):this.buffer.push(...s)}doLog(p){this.channel.call("log",[this.file,p])}}class f{constructor(p,v){this.loggerService=p,this.getUriTransformer=v}listen(p,v){const s=this.getUriTransformer(p);switch(v){case"onDidChangeLoggers":return D.Event.map(this.loggerService.onDidChangeLoggers,c=>({added:[...c.added].map(d=>this.transformLogger(d,s)),removed:[...c.removed].map(d=>this.transformLogger(d,s))}));case"onDidChangeVisibility":return D.Event.map(this.loggerService.onDidChangeVisibility,c=>[s.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return D.Event.map(this.loggerService.onDidChangeLogLevel,c=>(0,S.isLogLevel)(c)?c:[s.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,s){const c=this.getUriTransformer(p);switch(v){case"setLogLevel":return(0,S.isLogLevel)(s[0])?this.loggerService.setLogLevel(s[0]):this.loggerService.setLogLevel(w.URI.revive(c.transformIncoming(s[0][0])),s[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(d=>this.transformLogger(d,c)))}throw new Error(`Call not found: ${v}`)}transformLogger(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.LoggerChannel=f;class l extends I.Disposable{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this._register(p.onDidChangeLogLevel(s=>v.call("setLogLevel",[s]))),v.call("getRegisteredLoggers").then(s=>{for(const c of s)p.registerLogger({...c,resource:w.URI.revive(c.resource)})}),this._register(v.listen("onDidChangeVisibility")(([s,c])=>p.setVisibility(w.URI.revive(s),c))),this._register(v.listen("onDidChangeLoggers")(({added:s,removed:c})=>{for(const d of s)p.registerLogger({...d,resource:w.URI.revive(d.resource)});for(const d of c)p.deregisterLogger(d.resource)}))}}e.RemoteLoggerChannelClient=l}),define(ue[80],he([0,1,2,10]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class S extends w.Disposable{constructor(M,E=[]){super(),this.logger=new D.MultiplexLogger([M,...E]),this._register(M.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...E){this.logger.trace(M,...E)}debug(M,...E){this.logger.debug(M,...E)}info(M,...E){this.logger.info(M,...E)}warn(M,...E){this.logger.warn(M,...E)}error(M,...E){this.logger.error(M,...E)}flush(){this.logger.flush()}}e.LogService=S}),define(ue[81],he([0,1,78,10]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var S;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(S||(S={}));async function I(l,P,p,v,s){try{const c=await new Promise((u,i)=>{oe(["@vscode/spdlog"],u,i)});c.setFlushOn(S.Trace);const d=await c.createAsyncRotatingLogger(l,P,p,v);return s?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(c){console.error(c)}return null}function M(l,P,p){switch(P){case D.LogLevel.Trace:l.trace(p);break;case D.LogLevel.Debug:l.debug(p);break;case D.LogLevel.Info:l.info(p);break;case D.LogLevel.Warning:l.warn(p);break;case D.LogLevel.Error:l.error(p);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function E(l,P){switch(P){case D.LogLevel.Trace:l.setLevel(S.Trace);break;case D.LogLevel.Debug:l.setLevel(S.Debug);break;case D.LogLevel.Info:l.setLevel(S.Info);break;case D.LogLevel.Warning:l.setLevel(S.Warning);break;case D.LogLevel.Error:l.setLevel(S.Error);break;case D.LogLevel.Off:l.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class f extends D.AbstractMessageLogger{constructor(P,p,v,s,c){super(),this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(P,p,v,s),this._register(this.onDidChangeLogLevel(d=>{this._logger&&E(this._logger,d)}))}async _createSpdLogLogger(P,p,v,s){const c=v?6:1,d=30/c*w.ByteSize.MB,u=await I(P,p,d,c,s);if(u){this._logger=u,E(this._logger,this.getLevel());for(const{level:i,message:o}of this.buffer)M(this._logger,i,o);this.buffer=[]}}log(P,p){this._logger?M(this._logger,P,p):this.getLevel()<=P&&this.buffer.push({level:P,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(ue[82],he([0,1,52,10,81]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class I extends D.AbstractLoggerService{doCreateLogger(E,f,l){return new S.SpdLogLogger((0,w.generateUuid)(),E.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.LoggerService=I}),define(ue[83],he([0,1,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const I=S.context.configuration();if(I)D=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){D=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:I,searchUrl:M,itemUrl:E,controlUrl:f}=D.extensionsGallery||{};Object.assign(D,{extensionsGallery:{serviceUrl:w.env.VSCODE_GALLERY_SERVICE_URL||I,searchUrl:w.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:w.env.VSCODE_GALLERY_ITEM_URL||E,controlUrl:w.env.VSCODE_GALLERY_CONTROL_URL||f}});try{const l=(...p)=>p.reduce((v,s)=>(Object.keys(s).forEach(c=>{Array.isArray(v[c])&&Array.isArray(s[c])?v[c]=s[c]:typeof v[c]=="object"&&typeof s[c]=="object"?v[c]=l(v[c],s[c]):v[c]=s[c]}),v),{}),P=globalThis._VSCODE_USER_PRODUCT_JSON||{};D=l(D,P)}catch{}if(w.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:l.version,release:l.release})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(ue[84],he([0,1,21]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ue[85],he([0,1,42,8]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(M,E){w.ok(D.isString(M)),w.ok(D.isObject(E)),w.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,E)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new S}),define(ue[86],he([0,1,4,2]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class S extends D.Disposable{constructor(M){super(),this._terminal=M,this.type=4,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new w.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const M of this._idToMarkerMap.values())yield M;for(const M of this._anonymousMarkers.values())yield M}addMark(M){const E=M?.marker||this._terminal.registerMarker(),f=M?.id;E&&(f?(this._idToMarkerMap.set(f,E),E.onDispose(()=>this._idToMarkerMap.delete(f))):(this._anonymousMarkers.set(E.id,E),E.onDispose(()=>this._anonymousMarkers.delete(E.id))),this._onMarkAdded.fire({marker:E,id:f,hidden:M?.hidden,hoverMessage:M?.hoverMessage}))}getMark(M){return this._idToMarkerMap.get(M)}}e.BufferMarkCapability=S}),define(ue[87],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class w{get command(){return this._properties.command}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get duration(){return this._properties.duration}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(l){this._properties.endMarker=l}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(l,P){this._xterm=l,this._properties=P}static deserialize(l,P,p){const v=l.buffer.normal,s=P.startLine!==void 0?l.registerMarker(P.startLine-(v.baseY+v.cursorY)):void 0;if(!s)return;const c=P.promptStartLine!==void 0?l.registerMarker(P.promptStartLine-(v.baseY+v.cursorY)):void 0,d=P.endLine!==void 0?l.registerMarker(P.endLine-(v.baseY+v.cursorY)):void 0,u=P.executedLine!==void 0?l.registerMarker(P.executedLine-(v.baseY+v.cursorY)):void 0;return new w(l,{command:p?"":P.command,isTrusted:P.isTrusted,promptStartMarker:c,marker:s,startX:P.startX,endMarker:d,executedMarker:u,executedX:P.executedX,timestamp:P.timestamp,duration:P.duration,cwd:P.cwd,commandStartLineContent:P.commandStartLineContent,exitCode:P.exitCode,markProperties:P.markProperties,aliases:void 0,wasReplayed:!0})}serialize(l){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:l?"":this.command,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}getOutput(){if(!this.executedMarker||!this.endMarker)return;const l=this.executedMarker.line,P=this.endMarker.line;if(l===P)return;let p="",v;for(let s=l;s<P;s++)v=this._xterm.buffer.active.getLine(s),v&&(p+=v.translateToString(!v.isWrapped)+(v.isWrapped?"":`
`));return p===""?void 0:p}getOutputMatch(l){if(!this.executedMarker||!this.endMarker)return;const P=this.endMarker.line;if(P===-1)return;const p=this._xterm.buffer.active,v=Math.max(this.executedMarker.line,0),s=l.lineMatcher,c=typeof s=="string"?1:l.length||I(s),d=[];let u;if(l.anchor==="bottom")for(let i=P-(l.offset||0);i>=v;i--){let o=i;const m=i;for(;o>=v&&p.getLine(o)?.isWrapped;)o--;if(i=o,d.unshift(S(p,o,m,this._xterm.cols)),u||(u=d[0].match(s)),d.length>=c)break}else for(let i=v+(l.offset||0);i<P;i++){const o=i;let m=i;for(;m+1<P&&p.getLine(m+1)?.isWrapped;)m++;if(i=m,d.push(S(p,o,m,this._xterm.cols)),u||(u=d[d.length-1].match(s)),d.length>=c)break}return u?{regexMatch:u,outputLines:d}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return M(this,this._xterm.buffer.active)}getCommandRowCount(){return E(this)}}e.TerminalCommand=w;class D{constructor(l){this._xterm=l}serialize(l){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",isTrusted:!0,cwd:l,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(l,P,p,v){if(P===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||p)return new w(this._xterm,{command:p?"":this.command||"",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.commandDuration||0,cwd:l,exitCode:P,commandStartLineContent:this.commandStartLineContent,markProperties:v})}markExecutedTime(){this.commandExecutedTimestamp===void 0&&(this.commandExecutedTimestamp=Date.now())}markFinishedTime(){this.commandDuration===void 0&&this.commandExecutedTimestamp!==void 0&&(this.commandDuration=Date.now()-this.commandExecutedTimestamp)}getPromptRowCount(){return M(this,this._xterm.buffer.active)}getCommandRowCount(){return E(this)}}e.PartialTerminalCommand=D;function S(f,l,P,p){const v=Math.max(2048/p*2);P=Math.min(P,l+v);let s="";for(let c=l;c<=P;c++){const d=f.getLine(c);d&&(s+=d.translateToString(!0,0,p))}return s}function I(f){if(!f.multiline)return 1;const l=f.source;let P=1,p=l.indexOf("\\n");for(;p!==-1;)P++,p=l.indexOf("\\n",p+1);return P}function M(f,l){const P="hasOutput"in f?f.marker:f.commandStartMarker;if(!P||!f.promptStartMarker)return 1;let p=1,v=f.promptStartMarker.line;for(;v<P.line&&(l.getLine(v)?.translateToString(!0)??"").length===0;)v++;return p=P.line-v+1,p}function E(f){const l="hasOutput"in f?f.marker:f.commandStartMarker,P="hasOutput"in f?f.executedMarker:f.commandExecutedMarker;if(!l||!P)return 1;let v=Math.max(P.line,l.line)-l.line+1;return("hasOutput"in f?f.executedX:f.commandExecutedX)===0&&v--,v}});var Fe=this&&this.__param||function(oe,e){return function(w,D){e(w,D,oe)}};define(ue[88],he([0,1,9,14,4,2,10,87]),function(oe,e,w,D,S,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLinesForCommand=e.CommandDetectionCapability=void 0;class f extends I.Disposable{get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get _isInputting(){return!!(this._currentCommand.commandStartMarker&&!this._currentCommand.commandExecutedMarker)}get hasInput(){if(!(!this._isInputting||!this._currentCommand?.commandStartMarker)){if(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY===this._currentCommand.commandStartMarker?.line){const u=this._terminal.buffer.active.getLine(this._terminal.buffer.active.cursorY)?.translateToString(!0,this._currentCommand.commandStartX);return u===void 0?void 0:u.length>0}return!0}}constructor(u,i){super(),this._terminal=u,this._logService=i,this.type=2,this._commands=[],this._currentCommand=new E.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new S.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new S.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new S.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new S.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new S.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new S.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event;const o=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return o._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return o._onCommandStarted}get onCommandExecutedEmitter(){return o._onCommandExecuted}get dimensions(){return o._dimensions}get isCommandStorageDisabled(){return o.__isCommandStorageDisabled}get commandMarkers(){return o._commandMarkers}set commandMarkers(m){o._commandMarkers=m}get clearCommandsInViewport(){return o._clearCommandsInViewport.bind(o)}commitCommandFinished(){o._commitCommandFinished?.flush(),o._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new I.MandatoryMutableDisposable(new l(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(m=>this._handleResize(m))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(u){this._ptyHeuristics.value.preHandleResize?.(u),this._dimensions.cols=u.cols,this._dimensions.rows=u.rows}_handleCursorMove(){this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:"windows"}))}_clearCommandsInViewport(){let u=0;for(let i=this._commands.length-1;i>=0;i--){const o=this._commands[i].marker?.line;if(o&&o<this._terminal.buffer.active.baseY)break;u++}u>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-u,u))}setCwd(u){this._cwd=u}setIsWindowsPty(u){if(u&&!(this._ptyHeuristics.value instanceof p)){const i=this;this._ptyHeuristics.value=new p(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return i._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return i._onCommandStarted}get onCommandExecutedEmitter(){return i._onCommandExecuted}get dimensions(){return i._dimensions}get isCommandStorageDisabled(){return i.__isCommandStorageDisabled}get commandMarkers(){return i._commandMarkers}set commandMarkers(o){i._commandMarkers=o}get clearCommandsInViewport(){return i._clearCommandsInViewport.bind(i)}commitCommandFinished(){i._commitCommandFinished?.flush(),i._commitCommandFinished=void 0}},this._logService)}else!u&&!(this._ptyHeuristics.value instanceof l)&&(this._ptyHeuristics.value=new l(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(u){if(this._currentCommand.promptStartMarker&&u>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>u)){for(let i=this.commands.length-1;i>=0;i--)if((this.commands[i].promptStartMarker??this.commands[i].marker).line<=u)return this.commands[i]}}getCwdForLine(u){if(this._currentCommand.promptStartMarker&&u>=this._currentCommand.promptStartMarker?.line)return this._cwd;const i=this.getCommandForLine(u);if(i&&"cwd"in i)return i.cwd}handlePromptStart(u){const i=this.commands.at(-1);i?.endMarker&&i?.executedMarker&&i.endMarker.line===i.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${i.endMarker.line} -> ${i.executedMarker.line+1}`),i.endMarker=c(this._terminal,i.executedMarker,1)),this._currentCommand.promptStartMarker=u?.marker||(i?.endMarker?c(this._terminal,i.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(u){if(this._handleCommandStartOptions=u,this._currentCommand.commandStartMarker=u?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(u)}handleGenericCommand(u){u?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(u),this.handleCommandStart(u),this.handleCommandExecuted(u),this.handleCommandFinished(void 0,u)}handleCommandExecuted(u){this._ptyHeuristics.value.handleCommandExecuted(u),this._currentCommand.markExecutedTime()}handleCommandFinished(u,i){if(this._currentCommand.markFinishedTime(),this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,i?.marker?.line,this._currentCommand.command,this._currentCommand),u===void 0){const m=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&m?.command===this._currentCommand.command&&(u=m.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=i?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const o=this._currentCommand.promoteToFullCommand(this._cwd,u,this._handleCommandStartOptions?.ignoreCommandLine??!1,i?.markProperties);o&&(this._commands.push(o),this._commitCommandFinished=new w.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(o),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",o),this._onCommandFinished.fire(o))},50),this._commitCommandFinished.schedule()),this._currentCommand=new E.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(u,i){this._logService.debug("CommandDetectionCapability#setCommandLine",u,i),this._currentCommand.command=u,this._currentCommand.isTrusted=i}serialize(){const u=this.commands.map(o=>o.serialize(this.__isCommandStorageDisabled)),i=this._currentCommand.serialize(this._cwd);return i&&u.push(i),{isWindowsPty:this._ptyHeuristics.value instanceof p,commands:u}}deserialize(u){u.isWindowsPty&&this.setIsWindowsPty(u.isWindowsPty);const i=this._terminal.buffer.normal;for(const o of u.commands){if(!o.endLine){const r=o.startLine!==void 0?this._terminal.registerMarker(o.startLine-(i.baseY+i.cursorY)):void 0;if(!r)continue;this._currentCommand.commandStartMarker=o.startLine!==void 0?this._terminal.registerMarker(o.startLine-(i.baseY+i.cursorY)):void 0,this._currentCommand.commandStartX=o.startX,this._currentCommand.promptStartMarker=o.promptStartLine!==void 0?this._terminal.registerMarker(o.promptStartLine-(i.baseY+i.cursorY)):void 0,this._cwd=o.cwd,this._onCommandStarted.fire({marker:r});continue}const m=E.TerminalCommand.deserialize(this._terminal,o,this.__isCommandStorageDisabled);m&&(this._commands.push(m),this._logService.debug("CommandDetectionCapability#onCommandFinished",m),this._onCommandFinished.fire(m))}}}e.CommandDetectionCapability=f,ge([(0,D.debounce)(500)],f.prototype,"_handleCursorMove",null);class l extends I.Disposable{constructor(u,i,o,m){super(),this._terminal=u,this._capability=i,this._hooks=o,this._logService=m,this._register(u.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&o.clearCommandsInViewport(),!1)))}async handleCommandStart(u){this._hooks.commitCommandFinished();const i=this._capability.currentCommand;i.commandStartX=this._terminal.buffer.active.cursorX,i.commandStartMarker=u?.marker||this._terminal.registerMarker(0),i.commandExecutedMarker?.dispose(),i.commandExecutedMarker=void 0,i.commandExecutedX=void 0;for(const o of this._hooks.commandMarkers)o.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:u?.marker||i.commandStartMarker,markProperties:u?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",i.commandStartX,i.commandStartMarker?.line)}handleCommandExecuted(u){const i=this._capability.currentCommand;if(i.commandExecutedMarker=u?.marker||this._terminal.registerMarker(0),i.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",i.commandExecutedX,i.commandExecutedMarker?.line),!i.commandStartMarker||!i.commandExecutedMarker||i.commandStartX===void 0)return;i.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(i.commandStartMarker.line)?.translateToString(!0,i.commandStartX,i.commandRightPromptStartX).trim();let o=i.commandStartMarker.line+1;const m=i.commandExecutedMarker.line;for(;o<m;o++){const r=this._terminal.buffer.active.getLine(o);if(r){const t=i.continuations?.find(y=>y.marker.line===o);t&&(i.command+=`
`);const n=t?.end??0;i.command+=r.translateToString(!0,n)}}o===m&&(i.command+=this._terminal.buffer.active.getLine(m)?.translateToString(!0,void 0,i.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire()}}var P;(function(d){d[d.MaxCheckLineCount=5]="MaxCheckLineCount",d[d.Interval=20]="Interval",d[d.MaximumPollCount=50]="MaximumPollCount"})(P||(P={}));let p=class extends I.Disposable{constructor(u,i,o,m){super(),this._terminal=u,this._capability=i,this._hooks=o,this._logService=m,this._onCursorMoveListener=this._register(new I.MutableDisposable),this._recentlyPerformedCsiJ=!1,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(u.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&(this._recentlyPerformedCsiJ=!0,this._hooks.clearCommandsInViewport()),!1))),this._register(this._capability.onBeforeCommandFinished(r=>{if(this._recentlyPerformedCsiJ){this._recentlyPerformedCsiJ=!1;return}(r.command.trim().toLowerCase()==="clear"||r.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(u){const i=this._terminal.buffer.active.baseY,o=u.rows-this._hooks.dimensions.rows;o>0&&this._waitForCursorMove().then(()=>{const m=Math.min(o,i);for(let r=this._capability.commands.length-1;r>=0;r--){const t=this._capability.commands[r];if(!t.marker||t.marker.line<i||t.commandStartLineContent===void 0)break;const n=this._terminal.buffer.active.getLine(t.marker.line);if(!n||n.translateToString(!0)===t.commandStartLineContent)continue;const y=t.marker.line-m;this._terminal.buffer.active.getLine(y)?.translateToString(!0)===t.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:m})}})}async handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const u=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?c(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new w.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(u),20),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(u){if(this._store.isDisposed)return;const i=this._terminal.buffer.active;let o=this._tryAdjustCommandStartMarkerScannedLineCount;for(;o<5&&u.line+o<i.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const m=this._getWindowsPrompt(u.line+o);if(m){const r=typeof m=="string"?m:m.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof m=="object"&&m.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=c(this._terminal,this._capability.currentCommand.commandStartMarker);const t=this._capability.commands.at(-1);t&&this._capability.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=c(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=r.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${u.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}o++}o<5?(this._tryAdjustCommandStartMarkerScannedLineCount=o,this._tryAdjustCommandStartMarkerPollCount<50?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=50,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const u=this._terminal.registerMarker(0);u&&this._hooks.commandMarkers.push(u)}})),this._capability.currentCommand.commandStartMarker){const u=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);u&&(this._capability.currentCommand.commandStartLineContent=u.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(u){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const u=this._capability.currentCommand,i=u.command,o=u.commandStartMarker?.line,m=u.commandExecutedMarker?.line;if(!i||i.length===0||o===void 0||o===-1||m===void 0||m===-1)return;let r=0,t=!1;for(let n=o;n<=m;n++){const y=this._terminal.buffer.active.getLine(n);if(!y)break;const O=y.translateToString(!0);for(let g=0;g<O.length;g++){for(;i.length<r&&i[r]===" ";)r++;if(O[g]===i[r]&&r++,r===i.length){const b=g>=this._terminal.cols-1;u.commandExecutedMarker=this._terminal.registerMarker(n-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(b?1:0)),u.commandExecutedX=b?0:g+1,t=!0;break}}if(t)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((u,i)=>u.line-i.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const u=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);u&&(this._capability.currentCommand.commandStartLineContent=u.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire()}}_cursorOnNextLine(){const u=this._capability.commands.at(-1);if(!u)return!0;const i=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,o=(u.endMarker?u.endMarker.line:u.marker?.line)??-1;return i>o}_waitForCursorMove(){const u=this._terminal.buffer.active.cursorX,i=this._terminal.buffer.active.cursorY;let o=0;return new Promise((m,r)=>{const t=setInterval(()=>{if(u!==this._terminal.buffer.active.cursorX||i!==this._terminal.buffer.active.cursorY){m(),clearInterval(t);return}o+=10,o>1e3&&(clearInterval(t),m())},10)})}_getWindowsPrompt(u=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const i=this._terminal.buffer.active.getLine(u);if(!i)return;const o=i.translateToString(!0);if(!o)return;const m=o.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(m){const y=this._adjustPrompt(m,o,">");if(y)return{prompt:y,likelySingleLine:!0}}const r=o.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(r){const y=this._adjustPrompt(r,o,"\u276F");if(y)return y}const t=o.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(t)return{prompt:t,likelySingleLine:!0};const n=o.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return n?.groups?.prompt?{prompt:n.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(u,i,o){if(u)return i===u&&u.endsWith(o)&&(u+=" "),u}};p=ge([Fe(3,M.ILogService)],p);function v(d,u,i,o){if(!o)return;const m=u.executedMarker,r=u.endMarker;if(!m||!r)return;const t=m.line,n=r.line,y=o.length,O=[];if(o.anchor==="bottom")for(let g=n-(o.offset||0);g>=t;g--){let b=g;const C=g;for(;b>=t&&d.getLine(b)?.isWrapped;)b--;g=b,O.unshift(s(d,b,C,i)),O.length>y&&O.pop()}else for(let g=t+(o.offset||0);g<n;g++){const b=g;let C=g;for(;C+1<n&&d.getLine(C+1)?.isWrapped;)C++;g=C,O.push(s(d,b,C,i)),O.length===y&&O.shift()}return O}e.getLinesForCommand=v;function s(d,u,i,o){const m=Math.max(2048/o*2);i=Math.min(i,u+m);let r="";for(let t=u;t<=i;t++){const n=d.getLine(t);n&&(r+=n.translateToString(!0,0,o))}return r}function c(d,u,i=0){return d.registerMarker(u.line-(d.buffer.active.baseY+d.buffer.active.cursorY)+i)}}),define(ue[89],he([0,1,4,2]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class S extends D.Disposable{constructor(){super(...arguments),this.type=0,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new w.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(M){const E=this._cwd!==M;this._cwd=M;const f=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,f+1),E&&this._onDidChangeCwd.fire(M)}}e.CwdDetectionCapability=S}),define(ue[90],he([0,1,4,2]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var S;(function(M){M[M.MinimumPromptLength=2]="MinimumPromptLength"})(S||(S={}));class I extends D.DisposableStore{get commands(){return this._commands}constructor(E){super(),this._terminal=E,this.type=3,this._commands=[],this._onCommandFinished=this.add(new w.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(f=>this._onData(f))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},f=>(f.length>=1&&(f[0]===2||f[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(E){E==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=2){const E=this._terminal.registerMarker(0);E&&(this._commands.push(E),this._onCommandFinished.fire(E))}}_clearCommandsInViewport(){let E=0;for(let f=this._commands.length-1;f>=0&&!(this._commands[f].line<this._terminal.buffer.active.baseY);f--)E++;this._commands.splice(this._commands.length-E,E)}}e.PartialCommandDetectionCapability=I}),define(ue[91],he([0,1,4,2]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class S extends D.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new w.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new w.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new w.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new w.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(E,f){this._map.set(E,f),this._onDidAddCapabilityType.fire(E),this._onDidAddCapability.fire({id:E,capability:f})}get(E){return this._map.get(E)}remove(E){const f=this._map.get(E);f&&(this._map.delete(E),this._onDidRemoveCapabilityType.fire(E),this._onDidAddCapability.fire({id:E,capability:f}))}has(E){return this._map.has(E)}}e.TerminalCapabilityStore=S;class I extends D.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new w.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new w.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new w.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new w.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const E of this._stores)for(const f of E.items)yield f}has(E){for(const f of this._stores)for(const l of f.items)if(l===E)return!0;return!1}get(E){for(const f of this._stores){const l=f.get(E);if(l)return l}}add(E){this._stores.push(E);for(const f of E.items)this._onDidAddCapabilityType.fire(f),this._onDidAddCapability.fire({id:f,capability:E.get(f)});this._register(E.onDidAddCapabilityType(f=>this._onDidAddCapabilityType.fire(f))),this._register(E.onDidAddCapability(f=>this._onDidAddCapability.fire(f))),this._register(E.onDidRemoveCapabilityType(f=>this._onDidRemoveCapabilityType.fire(f))),this._register(E.onDidRemoveCapability(f=>this._onDidRemoveCapability.fire(f)))}}e.TerminalCapabilityStoreMultiplexer=I}),define(ue[36],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(w||(e.EnvironmentVariableMutatorType=w={}))}),define(ue[92],he([0,1,3,36]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const S=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(P){this.collections=P,this.map=new Map,this.descriptionMap=new Map,P.forEach((p,v)=>{this.populateDescriptionMap(p,v);const s=p.map.entries();let c=s.next();for(;!c.done;){const d=c.value[1],u=c.value[0];let i=this.map.get(u);if(i||(i=[],this.map.set(u,i)),i.length>0&&i[0].type===D.EnvironmentVariableMutatorType.Replace){c=s.next();continue}const o={extensionIdentifier:v,value:d.value,type:d.type,scope:d.scope,variable:d.variable,options:d.options};o.scope||delete o.scope,i.unshift(o),c=s.next()}})}async applyToProcessEnvironment(P,p,v){let s;w.isWindows&&(s={},Object.keys(P).forEach(c=>s[c.toLowerCase()]=c));for(const[c,d]of this.getVariableMap(p)){const u=w.isWindows&&s[c.toLowerCase()]||c;for(const i of d){const o=v?await v(i.value):i.value;if(i.options?.applyAtProcessCreation??!0)switch(i.type){case D.EnvironmentVariableMutatorType.Append:P[u]=(P[u]||"")+o;break;case D.EnvironmentVariableMutatorType.Prepend:P[u]=o+(P[u]||"");break;case D.EnvironmentVariableMutatorType.Replace:P[u]=o;break}if(i.options?.applyAtShellIntegration??!1){const m=`VSCODE_ENV_${S.get(i.type)}`;P[m]=(P[m]?P[m]+":":"")+c+"="+this._encodeColons(o)}}}}_encodeColons(P){return P.replaceAll(":","\\x3a")}diff(P,p){const v=new Map,s=new Map,c=new Map;if(P.getVariableMap(p).forEach((d,u)=>{const i=this.getVariableMap(p).get(u),o=E(d,i);o&&v.set(u,o)}),this.getVariableMap(p).forEach((d,u)=>{const i=P.getVariableMap(p).get(u),o=E(d,i);o&&c.set(u,o)}),this.getVariableMap(p).forEach((d,u)=>{const i=P.getVariableMap(p).get(u),o=f(d,i);o&&s.set(u,o)}),!(v.size===0&&s.size===0&&c.size===0))return{added:v,changed:s,removed:c}}getVariableMap(P){const p=new Map;for(const v of this.map.values()){const s=v.filter(c=>M(c,P));s.length>0&&p.set(s[0].variable,s)}return p}getDescriptionMap(P){const p=new Map;for(const v of this.descriptionMap.values()){const s=v.filter(c=>M(c,P,!0));for(const c of s)p.set(c.extensionIdentifier,c.description)}return p}populateDescriptionMap(P,p){if(!P.descriptionMap)return;const v=P.descriptionMap.entries();let s=v.next();for(;!s.done;){const c=s.value[1],d=s.value[0];let u=this.descriptionMap.get(d);u||(u=[],this.descriptionMap.set(d,u));const i={extensionIdentifier:p,scope:c.scope,description:c.description};i.scope||delete i.scope,u.push(i),s=v.next()}}}e.MergedEnvironmentVariableCollection=I;function M(l,P,p=!1){return l.scope?!!(l.scope.workspaceFolder&&P?.workspaceFolder&&l.scope.workspaceFolder.index===P.workspaceFolder.index):p?P===l.scope:!0}function E(l,P){if(!P)return l;const p=new Set;P.forEach(s=>p.add(s.extensionIdentifier));const v=[];return l.forEach(s=>{p.has(s.extensionIdentifier)||v.push(s)}),v.length===0?void 0:v}function f(l,P){if(!P)return;const p=new Map;P.forEach(s=>p.set(s.extensionIdentifier,s));const v=[];return l.forEach(s=>{const c=p.get(s.extensionIdentifier);c&&(s.type!==c.type||s.value!==c.value||s.scope?.workspaceFolder?.index!==c.scope?.workspaceFolder?.index)&&v.push(c)}),v.length===0?void 0:v}}),define(ue[93],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(f){return[...f.entries()]}e.serializeEnvironmentVariableCollection=w;function D(f){return f?[...f.entries()]:[]}e.serializeEnvironmentDescriptionMap=D;function S(f){return new Map(f)}e.deserializeEnvironmentVariableCollection=S;function I(f){return new Map(f??[])}e.deserializeEnvironmentDescriptionMap=I;function M(f){return Array.from(f.entries()).map(l=>[l[0],w(l[1].map),D(l[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=M;function E(f){return new Map(f.map(l=>[l[0],{map:S(l[1]),descriptionMap:I(l[2])}]))}e.deserializeEnvironmentVariableCollections=E}),define(ue[94],he([0,1,9,17,4,2,10]),function(oe,e,w,D,S,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let E=class extends I.Disposable{constructor(l,P){super(),this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new S.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l,this._register((0,I.toDisposable)(()=>{for(const p of this._pendingRequestDisposables.values())(0,I.dispose)(p)}))}createRequest(l){return new Promise((P,p)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,P),this._onCreateRequest.fire({requestId:v,...l});const s=new D.CancellationTokenSource;(0,w.timeout)(this._timeout,s.token).then(()=>p(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,I.toDisposable)(()=>s.cancel())])})}acceptReply(l,P){const p=this._pendingRequests.get(l);p?(this._pendingRequests.delete(l),(0,I.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),p(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=E,e.RequestStore=E=ge([Fe(1,M.ILogService)],E)}),define(ue[28],he([0,1,21,35,85]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new D.RawContextKey("terminalTabFocusMode",!1,!0);var I;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var M;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",t.LocalEchoEnabled="terminal.integrated.localEchoEnabled",t.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",t.LocalEchoStyle="terminal.integrated.localEchoStyle",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",t.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",t.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",t.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",t.MouseWheelZoom="terminal.integrated.mouseWheelZoom",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var E;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(E||(e.PosixShellType=E={}));var f;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(f||(e.WindowsShellType=f={}));var l;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var P;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={}));var p;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.IPtyService=(0,w.createDecorator)("ptyService");var v;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var s;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(s||(e.TerminalLocation=s={}));var c;(function(t){t.TerminalView="view",t.Editor="editor"})(c||(e.TerminalLocationString=c={}));var d;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var u;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(u||(e.FlowControlConstants=u={}));var i;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(i||(e.ProfileSource=i={}));var o;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(o||(e.ShellIntegrationStatus=o={}));var m;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(m||(e.TerminalExitReason=m={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(n){const y=this._sanitizeRemoteAuthority(n.remoteAuthority);if(this._backends.has(y))throw new Error(`A terminal backend with remote authority '${y}' was already registered.`);this._backends.set(y,n)}getTerminalBackend(n){return this._backends.get(this._sanitizeRemoteAuthority(n))}_sanitizeRemoteAuthority(n){return n?.toLowerCase()??""}}S.Registry.add(e.TerminalExtensions.Backend,new r),e.ILocalPtyService=(0,w.createDecorator)("localPtyService"),e.ITerminalLogService=(0,w.createDecorator)("terminalLogService")}),define(ue[95],he([0,1,9,2,3]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class I extends D.Disposable{constructor(E,f,l,P){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(E.onProcessData(p=>{if(this._paused||this._throttled)return;const v=typeof p=="string"?p:p.data;for(let s=0;s<v.length;s++)v[s]===f[this._pointer]?this._pointer++:this._reset(),this._pointer===f.length&&(P.debug(`Auto reply match: "${f}", response: "${l}"`),E.input(l),this._throttled=!0,(0,w.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){S.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=I}),define(ue[96],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,I,M=5){const E=I(f=>{const l=typeof f=="string"?f:f.data;let P=this._terminalBufferMap.get(S);if(P){P.data.push(l);return}const p=setTimeout(()=>this.flushBuffer(S),M);P={data:[l],timeoutId:p,dispose:()=>{clearTimeout(p),this.flushBuffer(S),E.dispose()}},this._terminalBufferMap.set(S,P)});return E}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const I=this._terminalBufferMap.get(S);I&&(this._terminalBufferMap.delete(S),this._callback(S,I.data.join("")))}}e.TerminalDataBufferer=w}),define(ue[37],he([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function D(M){let E=M;E.includes("\\")&&(E=E.replace(/\\/g,"\\\\"));const f=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return E=E.replace(f,""),`'${E}'`}e.escapeNonWindowsPath=D;function S(M,E,f){if(!M)return"";if(!E)return M;E.match(/[\/\\]$/)&&(E=E.slice(0,E.length-1));const l=M.replace(/\\/g,"/").toLowerCase(),P=E.replace(/\\/g,"/").toLowerCase();return l.includes(P)?`~${f}${M.slice(E.length+1)}`:M}e.collapseTildePath=S;function I(M){return M.match(/^['"].*['"]$/)&&(M=M.substring(1,M.length-1)),w.OS===1&&M&&M[1]===":"?M[0].toUpperCase()+M.substring(1):M}e.sanitizeCwd=I}),define(ue[97],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=void 0;var w;(function(S){S[S.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(w||(w={}));function D(S){const I=[];let M=0;for(let E=0;E<S.length-1;E++)(E-M+1>=50||S[E+1]==="\x1B")&&(I.push(S.substring(M,E+1)),M=E+1,E++);return M!==S.length&&I.push(S.substring(M)),I}e.chunkInput=D}),define(ue[98],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=void 0;function w(D,S={}){let I="";return S.excludeLeadingNewLine||(I+=`\r
`),I+="\x1B[0m\x1B[7m * ",S.loudFormatting?I+="\x1B[0;104m":I+="\x1B[0m",I+=` ${D} \x1B[0m
\r`,I}e.formatMessageForTerminal=w}),define(ue[99],he([0,1,2,91,88,89,90,4,86,5,37]),function(oe,e,w,D,S,I,M,E,f,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMarkSequence=e.parseKeyValueAssignment=e.deserializeMessage=e.ShellIntegrationAddon=void 0;var p;(function(o){o[o.FinalTerm=133]="FinalTerm",o[o.VSCode=633]="VSCode",o[o.ITerm=1337]="ITerm",o[o.SetCwd=7]="SetCwd",o[o.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(p||(p={}));var v;(function(o){o.PromptStart="A",o.CommandStart="B",o.CommandExecuted="C",o.CommandFinished="D",o.CommandLine="E",o.ContinuationStart="F",o.ContinuationEnd="G",o.RightPromptStart="H",o.RightPromptEnd="I",o.Property="P",o.SetMark="SetMark"})(v||(v={}));var s;(function(o){o.SetMark="SetMark",o.CurrentDir="CurrentDir"})(s||(s={}));class c extends w.Disposable{get status(){return this._status}constructor(m,r,t,n){super(),this._nonce=m,this._disableTelemetry=r,this._telemetryService=t,this._logService=n,this.capabilities=this._register(new D.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=0,this._onDidChangeStatus=new E.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,w.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,w.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(m){this._terminal=m,this.capabilities.add(3,this._register(new M.PartialCommandDetectionCapability(this._terminal))),this._register(m.parser.registerOscHandler(633,r=>this._handleVSCodeSequence(r))),this._register(m.parser.registerOscHandler(1337,r=>this._doHandleITermSequence(r))),this._commonProtocolDisposables.push(m.parser.registerOscHandler(133,r=>this._handleFinalTermSequence(r))),this._register(m.parser.registerOscHandler(7,r=>this._doHandleSetCwd(r))),this._register(m.parser.registerOscHandler(9,r=>this._doHandleSetWindowsFriendlyCwd(r))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(m,r){this._createOrGetBufferMarkDetection(m).getMark(r)}_handleFinalTermSequence(m){const r=this._doHandleFinalTermSequence(m);return this._status===0&&(this._status=1,this._onDidChangeStatus.fire(this._status)),r}_doHandleFinalTermSequence(m){if(!this._terminal)return!1;const[r,...t]=m.split(";");switch(r){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const n=t.length===1?parseInt(t[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(n),!0}}return!1}_handleVSCodeSequence(m){const r=this._doHandleVSCodeSequence(m);return!this._hasUpdatedTelemetry&&r&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==2&&(this._status=2,this._onDidChangeStatus.fire(this._status)),r}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(m){if(!this._terminal)return!1;const r=m.indexOf(";"),t=r===-1?m:m.substring(0,r),n=r===-1?[]:m.substring(r+1).split(";");switch(t){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const y=n[0],O=y!==void 0?parseInt(y):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(O),!0}case"E":{const y=n[0],O=n[1];let g;return y!==void 0?g=d(y):g="",this._createOrGetCommandDetection(this._terminal).setCommandLine(g,O===this._nonce),!0}case"F":return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case"G":return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case"H":return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case"I":return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case"P":{const y=n[0],O=y!==void 0?d(y):"",{key:g,value:b}=u(O);if(b===void 0)return!0;switch(g){case"Cwd":return this._updateCwd(b),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(b==="True"),!0;case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this._createOrGetBufferMarkDetection(this._terminal).addMark(i(n)),!0}return!1}_updateCwd(m){m=(0,P.sanitizeCwd)(m),this._createOrGetCwdDetection().updateCwd(m),this.capabilities.get(2)?.setCwd(m)}_doHandleITermSequence(m){if(!this._terminal)return!1;const[r]=m.split(";");switch(r){case"SetMark":this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:t,value:n}=u(r);if(n===void 0)return!0;switch(t){case"CurrentDir":return this._updateCwd(n),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(m){if(!this._terminal)return!1;const[r,...t]=m.split(";");switch(r){case"9":return t.length&&this._updateCwd(t[0]),!0}return!1}_doHandleSetCwd(m){if(!this._terminal)return!1;const[r]=m.split(";");if(r.match(/^file:\/\/.*\//)){const t=l.URI.parse(r);if(t.path&&t.path.length>0)return this._updateCwd(t.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(m){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(m)}_createOrGetCwdDetection(){let m=this.capabilities.get(0);return m||(m=this._register(new I.CwdDetectionCapability),this.capabilities.add(0,m)),m}_createOrGetCommandDetection(m){let r=this.capabilities.get(2);return r||(r=this._register(new S.CommandDetectionCapability(m,this._logService)),this.capabilities.add(2,r)),r}_createOrGetBufferMarkDetection(m){let r=this.capabilities.get(4);return r||(r=this._register(new f.BufferMarkCapability(m)),this.capabilities.add(4,r)),r}}e.ShellIntegrationAddon=c;function d(o){return o.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(m,r,t)=>t?String.fromCharCode(parseInt(t,16)):r)}e.deserializeMessage=d;function u(o){const m=o.indexOf("=");return m===-1?{key:o,value:void 0}:{key:o.substring(0,m),value:o.substring(1+m)}}e.parseKeyValueAssignment=u;function i(o){let m,r=!1;for(const t of o)t!==void 0&&(t==="Hidden"&&(r=!0),t.startsWith("Id=")&&(m=t.substring(3)));return{id:m,hidden:r}}e.parseMarkSequence=i}),define(ue[38],he([0,1,7,14,4,2,62,10]),function(oe,e,w,D,S,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var f;(function(P){P[P.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",P[P.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(f||(f={})),e.ignoreProcessNames=[];let l=class extends I.Disposable{set hasChildProcesses(p){this._hasChildProcesses!==p&&(this._hasChildProcesses=p,this._logService.debug("ChildProcessMonitor: Has child processes changed",p),this._onDidChangeHasChildProcesses.fire(p))}get hasChildProcesses(){return this._hasChildProcesses}constructor(p,v){super(),this._pid=p,this._logService=v,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new S.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const p=await(0,M.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(p)}catch(p){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",p)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(p){if(!p.children)return!1;if(p.children.length===1){const v=p.children[0];let s;if(v.cmd.startsWith('"'))s=v.cmd.substring(1,v.cmd.indexOf('"',1));else{const c=v.cmd.indexOf(" ");c===-1?s=v.cmd:s=v.cmd.substring(0,c)}return e.ignoreProcessNames.indexOf((0,w.parse)(s).name)===-1}return p.children.length>0}};e.ChildProcessMonitor=l,ge([(0,D.debounce)(1e3)],l.prototype,"_refreshActive",null),ge([(0,D.throttle)(5e3)],l.prototype,"_refreshInactive",null),e.ChildProcessMonitor=l=ge([Fe(1,E.ILogService)],l)}),define(ue[100],he([0,1,4,2,28]),function(oe,e,w,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class I extends D.Disposable{constructor(){super(),this._onBeat=this._register(new w.Emitter),this.onBeat=this._onBeat.event;const E=setInterval(()=>{this._onBeat.fire()},S.HeartbeatConstants.BeatInterval);this._register((0,D.toDisposable)(()=>clearInterval(E)))}}e.HeartbeatService=I}),define(ue[39],he([0,1,20,19,30,7,3,15,11,8,24,36,93,92]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function c(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let b=0;return g&&g.length===4&&(b=parseInt(g[3])),b}e.getWindowsBuildNumber=c;async function d(g,b,C,A=E.env,$=P.Promises.exists){if(I.isAbsolute(g))return await $(g)?g:void 0;if(b===void 0&&(b=E.cwd()),I.dirname(g)!=="."){const k=I.join(b,g);return await $(k)?k:void 0}const a=(0,S.getCaseInsensitive)(A,"PATH");if(C===void 0&&(0,l.isString)(a)&&(C=a.split(I.delimiter)),C===void 0||C.length===0){const k=I.join(b,g);return await $(k)?k:void 0}for(const k of C){let q;if(I.isAbsolute(k)?q=I.join(k,g):q=I.join(b,k,g),await $(q))return q;if(M.isWindows){let R=q+".com";if(await $(R)||(R=q+".exe",await $(R)))return R}}const _=I.join(b,g);return await $(_)?_:void 0}e.findExecutable=d;function u(g,b,C,A,$){const B=M.isWindows&&(!b.windowsEnableConpty||c()<18309);if(!b.shellIntegration.enabled||!g.executable||g.isFeatureTerminal||g.hideFromUser||g.ignoreShellIntegration||B)return;const a=g.args,_=E.platform==="win32"?I.basename(g.executable).toLowerCase():I.basename(g.executable),k=I.dirname(D.FileAccess.asFileUri("").fsPath);let q;const R={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(R.VSCODE_NONCE=b.shellIntegration.nonce),M.isWindows){if(_==="pwsh.exe"||_==="powershell.exe")return!a||y(a)?q=m.get(o.WindowsPwsh):n(a)&&(q=m.get(o.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,f.format)(q[q.length-1],k,""),b.shellIntegration.suggestEnabled&&(R.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:R}):void 0;A.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args);return}switch(_){case"bash":return!a||a.length===0?q=m.get(o.Bash):O(a)&&(R.VSCODE_SHELL_LOGIN="1",i(b,R),q=m.get(o.Bash)),q?(q=[...q],q[q.length-1]=(0,f.format)(q[q.length-1],k),{newArgs:q,envMixin:R}):void 0;case"fish":{const z=C?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=I.join(k,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return R.XDG_DATA_DIRS=`${z}:${ne}`,i(b,R),{newArgs:void 0,envMixin:R}}case"pwsh":return!a||y(a)?q=m.get(o.Pwsh):n(a)&&(q=m.get(o.PwshLogin)),q?(b.shellIntegration.suggestEnabled&&(R.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,f.format)(q[q.length-1],k,""),{newArgs:q,envMixin:R}):void 0;case"zsh":{if(!a||a.length===0?q=m.get(o.Zsh):O(a)?(q=m.get(o.ZshLogin),i(b,R)):(a===m.get(o.Zsh)||a===m.get(o.ZshLogin))&&(q=a),!q)return;q=[...q],q[q.length-1]=(0,f.format)(q[q.length-1],k);let z;try{z=w.userInfo().username}catch{z="unknown"}const ne=I.join(w.tmpdir(),`${z}-${$.applicationName}-zsh`);R.ZDOTDIR=ne;const re=C?.ZDOTDIR??w.homedir()??"~";R.USER_ZDOTDIR=re;const X=[];return X.push({source:I.join(k,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.join(ne,".zshrc")}),X.push({source:I.join(k,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.join(ne,".zprofile")}),X.push({source:I.join(k,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.join(ne,".zshenv")}),X.push({source:I.join(k,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.join(ne,".zlogin")}),{newArgs:q,envMixin:R,filesToCopy:X}}}A.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args)}e.getShellIntegrationInjection=u;function i(g,b){if(M.isMacintosh&&g.environmentVariableCollections){const C=(0,v.deserializeEnvironmentVariableCollections)(g.environmentVariableCollections),$=new s.MergedEnvironmentVariableCollection(C).getVariableMap({workspaceFolder:g.workspaceFolder}).get("PATH"),B=[];if($)for(const a of $)a.type===p.EnvironmentVariableMutatorType.Prepend&&B.push(a.value);B.length>0&&(b.VSCODE_PATH_PREFIX=B.join(""))}}var o;(function(g){g.WindowsPwsh="windows-pwsh",g.WindowsPwshLogin="windows-pwsh-login",g.Pwsh="pwsh",g.PwshLogin="pwsh-login",g.Zsh="zsh",g.ZshLogin="zsh-login",g.Bash="bash"})(o||(o={}));const m=new Map;m.set(o.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(o.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(o.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(o.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(o.Zsh,["-i"]),m.set(o.ZshLogin,["-il"]),m.set(o.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const r=["-login","-l"],t=["-nol","-nologo"];function n(g){return typeof g=="string"?r.includes(g.toLowerCase()):g.length===1&&r.includes(g[0].toLowerCase())||g.length===2&&(r.includes(g[0].toLowerCase())||r.includes(g[1].toLowerCase()))&&(t.includes(g[0].toLowerCase())||t.includes(g[1].toLowerCase()))}function y(g){return typeof g=="string"?t.includes(g.toLowerCase()):g.length===0||g?.length===1&&t.includes(g[0].toLowerCase())}function O(g){return g==="string"&&r.includes(g.toLowerCase())||typeof g!="string"&&g.length===1&&r.includes(g[0].toLowerCase())}}),define(ue[101],he([0,1,9,14,4,2,3]),function(oe,e,w,D,S,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const E=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let f;class l extends I.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(p){if(super(),this._rootProcessId=p,this._shellTitle="",this._onShellNameChanged=new S.Emitter,this._onShellTypeChanged=new S.Emitter,!M.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${M.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){M.isWindows&&(await(0,w.timeout)(300),this.getShellName().then(p=>{const v=this.getShellType(p);v!==this._shellType&&(this._onShellTypeChanged.fire(v),this._onShellNameChanged.fire(p),this._shellType=v,this._shellTitle=p)}))}traverseTree(p){if(!p)return"";if(E.indexOf(p.name)===-1||!p.children||p.children.length===0)return p.name;let v=0;for(;v<p.children.length;v++){const s=p.children[v];if(!s.children||s.children.length===0||s.children[0].name!=="conhost.exe")break}return v>=p.children.length?p.name:this.traverseTree(p.children[v])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(f||(f=await new Promise((p,v)=>{oe(["@vscode/windows-process-tree"],p,v)})),this._currentRequest=new Promise(p=>{f.getProcessTree(this._rootProcessId,v=>{const s=this.traverseTree(v);this._currentRequest=void 0,p(s)})}),this._currentRequest)}getShellType(p){switch(p.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return p.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.WindowsShellHelper=l,ge([(0,D.debounce)(500)],l.prototype,"checkShell",null)}),define(ue[102],he([0,1,26,9,4,2,7,3,5,24,71,10,84,38,39,101,107,97]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v,s,c,d,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;var m;(function(O){O[O.DataFlushTimeout=250]="DataFlushTimeout",O[O.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(m||(m={}));var r;(function(O){O[O.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",O[O.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",O[O.WriteInterval=5]="WriteInterval"})(r||(r={}));const t=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let n=class extends I.Disposable{static{o=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return E.isWindows?this._windowsShellHelper?.shellType:t.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(g,b,C,A,$,B,a,_,k){super(),this.shellLaunchConfig=g,this._executableEnv=B,this._options=a,this._logService=_,this._productService=k,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event;let q;E.isWindows?q=M.basename(this.shellLaunchConfig.executable||""):q="xterm-256color",this._initialCwd=b,this._properties.initialCwd=this._initialCwd,this._properties.cwd=this._initialCwd;const R=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,c.getWindowsBuildNumber)()>=18309;this._ptyOptions={name:q,cwd:b,env:$,cols:C,rows:A,useConpty:R,conptyInheritCursor:R&&!!g.initialText},E.isWindows&&(R&&C===0&&A===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new y,this._register(this._delayedResizer.onTrigger(z=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,z.cols&&z.rows&&this.resize(z.cols,z.rows)}))),this.onProcessReady(z=>{this._windowsShellHelper=this._register(new d.WindowsShellHelper(z.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(ne=>this._onDidChangeProperty.fire({type:"shellType",value:ne}))),this._register(this._windowsShellHelper.onShellNameChanged(ne=>this._onDidChangeProperty.fire({type:"title",value:ne})))})),this._register((0,I.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const b=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(A=>A!==void 0);if(b)return b;let C;if(this._options.shellIntegration.enabled)if(C=(0,c.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),C){if(this._onDidChangeProperty.fire({type:"usedShellIntegrationInjection",value:!0}),C.envMixin)for(const[A,$]of Object.entries(C.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[A]=$;if(C.filesToCopy)for(const A of C.filesToCopy){await l.Promises.mkdir(M.dirname(A.dest),{recursive:!0});try{await l.Promises.copyFile(A.source,A.dest)}catch{}}}else this._onDidChangeProperty.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,C),C?.newArgs?{injectedArgs:C.newArgs}:void 0}catch(A){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",A),{message:`A native exception occurred during launch (${A.message})`}}}async _validateCwd(){try{if(!(await l.Promises.stat(this._initialCwd)).isDirectory())return{message:(0,P.localize)(0,null,this._initialCwd.toString())}}catch(g){if(g?.code==="ENOENT")return{message:(0,P.localize)(1,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:"initialCwd",value:this._initialCwd})}async _validateExecutable(){const g=this.shellLaunchConfig;if(!g.executable)throw new Error("IShellLaunchConfig.executable not set");const b=g.cwd instanceof f.URI?g.cwd.path:g.cwd,C=g.env&&g.env.PATH?g.env.PATH.split(M.delimiter):void 0,A=await(0,c.findExecutable)(g.executable,b,C,this._executableEnv);if(!A)return{message:(0,P.localize)(2,null,g.executable)};try{const $=await l.Promises.stat(A);if(!$.isFile()&&!$.isSymbolicLink())return{message:(0,P.localize)(3,null,g.executable)};g.executable=A}catch($){if($?.code!=="EACCES")throw $}}async setupPtyProcess(g,b,C){const A=C?.newArgs||g.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",g.executable,A,b);const $=(0,u.spawn)(g.executable,A,b);this._ptyProcess=$,this._childProcessMonitor=this._register(new s.ChildProcessMonitor($.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(B=>this._onDidChangeProperty.fire({type:"hasChildProcesses",value:B})),this._processStartupComplete=new Promise(B=>{this.onProcessReady(()=>B())}),$.onData(B=>{this._unacknowledgedCharCount+=B.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > 100000)`),this._isPtyPaused=!0,$.pause()),this._logService.trace("node-pty.IPty#onData",B),this._onProcessData.fire(B),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),$.onExit(B=>{this._exitCode=B.exitCode,this._queueProcessExit()}),this._sendProcessId($.pid),this._setupTitlePolling($)}_setupTitlePolling(g){setTimeout(()=>this._sendProcessTitle(g)),E.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==g.process&&this._sendProcessTitle(g)},200))}_queueProcessExit(){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},250)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!E.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-o._lastKillOrStart<250;)this._logService.trace("Throttling kill/spawn call"),await(0,D.timeout)(250-(Date.now()-o._lastKillOrStart)+50);o._lastKillOrStart=Date.now()}}_sendProcessId(g){this._onProcessReady.fire({pid:g,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(g){if(this._store.isDisposed)return;this._currentTitle=g.process,this._onDidChangeProperty.fire({type:"title",value:this._currentTitle});const b=this.currentTitle.replace(/ \(figterm\)$/g,"");b.toLowerCase().startsWith("python")?this._onDidChangeProperty.fire({type:"shellType",value:"python"}):this._onDidChangeProperty.fire({type:"shellType",value:t.get(b)})}shutdown(g){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),g&&!E.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},5e3))}input(g,b=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,i.chunkInput)(g).map(C=>({isBinary:b,data:C}))),this._startWrite())}async processBinary(g){this.input(g,!0)}async refreshProperty(g){switch(g){case"cwd":{const b=await this.getCwd();return b!==this._properties.cwd&&(this._properties.cwd=b,this._onDidChangeProperty.fire({type:"cwd",value:this._properties.cwd})),b}case"initialCwd":{const b=await this.getInitialCwd();return b!==this._properties.initialCwd&&(this._properties.initialCwd=b,this._onDidChangeProperty.fire({type:"initialCwd",value:this._properties.initialCwd})),b}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(g,b){g==="fixedDimensions"&&(this._properties.fixedDimensions=b)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},5)}}_doWrite(){const g=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",g.data),g.isBinary?this._ptyProcess.write(Buffer.from(g.data,"binary")):this._ptyProcess.write(g.data),this._childProcessMonitor?.handleInput()}resize(g,b){if(!this._store.isDisposed&&!(typeof g!="number"||typeof b!="number"||isNaN(g)||isNaN(b))&&this._ptyProcess){if(g=Math.max(g,1),b=Math.max(b,1),this._delayedResizer){this._delayedResizer.cols=g,this._delayedResizer.rows=b;return}this._logService.trace("node-pty.IPty#resize",g,b);try{this._ptyProcess.resize(g,b)}catch(C){if(this._logService.trace("node-pty.IPty#resize exception "+C.message),this._exitCode!==void 0&&C.message!=="ioctl(2) failed, EBADF"&&C.message!=="Cannot resize a pty that has already exited")throw C}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(g){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-g,0),this._logService.trace(`Flow control: Ack ${g} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < 5000)`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(E.isMacintosh)return new Promise(g=>{if(!this._ptyProcess){g(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,w.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(b,C,A)=>{!b&&C!==""?g(C.substring(C.indexOf("/"),C.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",b,C,A),g(this._initialCwd))})});if(E.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await l.Promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return E.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,c.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=n,e.TerminalProcess=n=o=ge([Fe(7,p.ILogService),Fe(8,v.IProductService)],n);class y extends I.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new S.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,I.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(ue[103],he([0,1,26,9,4,2,3,63,10,94,28,96,37,108,39,102,70,38,95,6,99,98,76,14,109]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v,s,c,d,u,i,o,m,r,t,n,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=e.traceRpc=void 0;function g(q,R,z){if(typeof z.value!="function")throw new Error("not supported");const ne="value",re=z.value;z[ne]=async function(...X){this.traceRpcArgs.logService.getLevel()===f.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${re.name}(${X.map(ce=>JSON.stringify(ce)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,D.timeout)(this.traceRpcArgs.simulatedLatency);let se;try{se=await re.apply(this,X)}catch(ce){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${re.name}`,ce),ce}return this.traceRpcArgs.logService.getLevel()===f.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${re.name}`,se),se}}e.traceRpc=g;let b,C;class A extends I.Disposable{_traceEvent(R,z){return z(ne=>{this._logService.getLevel()===f.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${R}.fire(${JSON.stringify(ne)})`)}),z}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(R,z,ne,re){super(),this._logService=R,this._productService=z,this._reconnectConstants=ne,this._simulatedLatency=re,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new S.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new S.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,I.toDisposable)(()=>{for(const X of this._ptys.values())X.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new l.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(R){i.ignoreProcessNames.length=0,i.ignoreProcessNames.push(...R)}async requestDetachInstance(R,z){return this._detachInstanceRequestStore.createRequest({workspaceId:R,instanceId:z})}async acceptDetachInstanceReply(R,z){let ne;const re=this._ptys.get(z);re&&(ne=await this._buildProcessDetails(z,re)),this._detachInstanceRequestStore.acceptReply(R,ne)}async freePortKillProcess(R){const ne=(await new Promise((re,X)=>{(0,w.exec)(M.isWindows?`netstat -ano | findstr "${R}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${R}`,{},(se,ce)=>{if(se)return X("Problem occurred when listing active processes");re(ce)})})).split(/\r?\n/).filter(re=>!!re.trim());if(ne.length>=1){const re=/\s+(\d+)(?:\s+|$)/,X=ne[0].match(re)?.[1];if(X)try{process.kill(Number.parseInt(X))}catch{}else throw new Error(`Processes for port ${R} were not found`);return{port:R,processId:X}}throw new Error(`Could not kill process with port ${R}`)}async serializeTerminalState(R){const z=[];for(const[re,X]of this._ptys.entries())X.hasWrittenData&&R.indexOf(re)!==-1&&z.push(D.Promises.withAsyncBody(async se=>{se({id:re,shellLaunchConfig:X.shellLaunchConfig,processDetails:await this._buildProcessDetails(re,X),processLaunchConfig:X.processLaunchOptions,unicodeVersion:X.unicodeVersion,replayEvent:await X.serializeNormalBuffer(),timestamp:Date.now()})}));const ne={version:1,state:await Promise.all(z)};return JSON.stringify(ne)}async reviveTerminalProcesses(R,z,ne){const re=[];for(const X of z)re.push(this._reviveTerminalProcess(R,X));await Promise.all(re)}async _reviveTerminalProcess(R,z){const ne=(0,u.localize)(0,null),re=await this.createProcess({...z.shellLaunchConfig,cwd:z.processDetails.cwd,color:z.processDetails.color,icon:z.processDetails.icon,name:z.processDetails.titleSource===P.TitleEventSource.Api?z.processDetails.title:void 0,initialText:z.replayEvent.events[0].data+(0,t.formatMessageForTerminal)(ne,{loudFormatting:!0})},z.processDetails.cwd,z.replayEvent.events[0].cols,z.replayEvent.events[0].rows,z.unicodeVersion,z.processLaunchConfig.env,z.processLaunchConfig.executableEnv,z.processLaunchConfig.options,!0,z.processDetails.workspaceId,z.processDetails.workspaceName,!0,z.replayEvent.events[0].data),X=this._getRevivingProcessId(R,z.id);this._revivedPtyIdMap.set(X,{newId:re,state:z}),this._logService.info(`Revived process, old id ${X} -> new id ${re}`)}async shutdownAll(){this.dispose()}async createProcess(R,z,ne,re,X,se,ce,fe,K,W,Y,te,j){if(R.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const ee=++this._lastPtyId,me=new d.TerminalProcess(R,z,ne,re,se,ce,fe,this._logService,this._productService),x={env:se,executableEnv:ce,options:fe},h=new B(ee,me,W,Y,K,ne,re,x,X,this._reconnectConstants,this._logService,te&&typeof R.initialText=="string"?R.initialText:void 0,j,R.icon,R.color,R.name,R.fixedDimensions);return me.onProcessExit(U=>{h.dispose(),this._ptys.delete(ee),this._onProcessExit.fire({id:ee,event:U})}),h.onProcessData(U=>this._onProcessData.fire({id:ee,event:U})),h.onProcessReplay(U=>this._onProcessReplay.fire({id:ee,event:U})),h.onProcessReady(U=>this._onProcessReady.fire({id:ee,event:U})),h.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:ee})),h.onDidChangeProperty(U=>this._onDidChangeProperty.fire({id:ee,property:U})),h.onPersistentProcessReady(()=>{for(const U of this._autoReplies.entries())h.installAutoReply(U[0],U[1])}),this._ptys.set(ee,h),ee}async attachToProcess(R){try{await this._throwIfNoPty(R).attach(),this._logService.info(`Persistent process reconnection "${R}"`)}catch(z){throw this._logService.warn(`Persistent process reconnection "${R}" failed`,z.message),z}}async updateTitle(R,z,ne){this._throwIfNoPty(R).setTitle(z,ne)}async updateIcon(R,z,ne,re){this._throwIfNoPty(R).setIcon(z,ne,re)}async clearBuffer(R){this._throwIfNoPty(R).clearBuffer()}async refreshProperty(R,z){return this._throwIfNoPty(R).refreshProperty(z)}async updateProperty(R,z,ne){return this._throwIfNoPty(R).updateProperty(z,ne)}async detachFromProcess(R,z){return this._throwIfNoPty(R).detach(z)}async reduceConnectionGraceTime(){for(const R of this._ptys.values())R.reduceGraceTime()}async listProcesses(){const R=Array.from(this._ptys.entries()).filter(([re,X])=>X.shouldPersistTerminal);this._logService.info(`Listing ${R.length} persistent terminals, ${this._ptys.size} total terminals`);const z=R.map(async([re,X])=>this._buildProcessDetails(re,X));return(await Promise.all(z)).filter(re=>re.isOrphan)}async getPerformanceMarks(){return O.getMarks()}async start(R){const z=this._ptys.get(R);return z?z.start():{message:`Could not find pty with id "${R}"`}}async shutdown(R,z){return this._ptys.get(R)?.shutdown(z)}async input(R,z){return this._throwIfNoPty(R).input(z)}async processBinary(R,z){return this._throwIfNoPty(R).writeBinary(z)}async resize(R,z,ne){return this._throwIfNoPty(R).resize(z,ne)}async getInitialCwd(R){return this._throwIfNoPty(R).getInitialCwd()}async getCwd(R){return this._throwIfNoPty(R).getCwd()}async acknowledgeDataEvent(R,z){return this._throwIfNoPty(R).acknowledgeDataEvent(z)}async setUnicodeVersion(R,z){return this._throwIfNoPty(R).setUnicodeVersion(z)}async getLatency(){return[]}async orphanQuestionReply(R){return this._throwIfNoPty(R).orphanQuestionReply()}async installAutoReply(R,z){this._autoReplies.set(R,z);for(const ne of this._ptys.values())ne.installAutoReply(R,z)}async uninstallAllAutoReplies(){for(const R of this._autoReplies.keys())for(const z of this._ptys.values())z.uninstallAutoReply(R)}async uninstallAutoReply(R){for(const z of this._ptys.values())z.uninstallAutoReply(R)}async getDefaultSystemShell(R=M.OS){return(0,E.getSystemShell)(R,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(R,z){if(z==="win-to-unix"){if(!M.isWindows)return R;if((0,c.getWindowsBuildNumber)()<17063)return R.replace(/\\/g,"/");const ne=this._getWSLExecutablePath();return ne?new Promise(re=>{(0,w.execFile)(ne,["-e","wslpath",R],{},(se,ce,fe)=>{re(se?R:(0,v.escapeNonWindowsPath)(ce.trim()))}).stdin.end()}):R}if(z==="unix-to-win"&&M.isWindows){if((0,c.getWindowsBuildNumber)()<17063)return R;const ne=this._getWSLExecutablePath();return ne?new Promise(re=>{(0,w.execFile)(ne,["-e","wslpath","-w",R],{},(se,ce,fe)=>{re(se?R:ce.trim())}).stdin.end()}):R}return R}_getWSLExecutablePath(){const R=(0,c.getWindowsBuildNumber)()>=16299,z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=process.env.SystemRoot;if(ne)return(0,n.join)(ne,z?"Sysnative":"System32",R?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(R,z){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(R,z))?.newId}catch(ne){this._logService.warn(`Couldn't find terminal ID ${R}-${z}`,ne.message)}}async setTerminalLayoutInfo(R){this._workspaceLayoutInfos.set(R.workspaceId,R)}async getTerminalLayoutInfo(R){O.mark("code/willGetTerminalLayoutInfo");const z=this._workspaceLayoutInfos.get(R.workspaceId);if(z){const ne=new Set,X=(await Promise.all(z.tabs.map(async se=>this._expandTerminalTab(R.workspaceId,se,ne)))).filter(se=>se.terminals.length>0);return O.mark("code/didGetTerminalLayoutInfo"),{tabs:X}}O.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(R,z,ne){const X=(await Promise.all(z.terminals.map(se=>this._expandTerminalInstance(R,se,ne)))).filter(se=>se.terminal!==null);return{isActive:z.isActive,activePersistentProcessId:z.activePersistentProcessId,terminals:X}}async _expandTerminalInstance(R,z,ne){try{const re=this._getRevivingProcessId(R,z.terminal),X=this._revivedPtyIdMap.get(re)?.newId;this._logService.info(`Expanding terminal instance, old id ${re} -> new id ${X}`),this._revivedPtyIdMap.delete(re);const se=X??z.terminal;if(ne.has(se))throw new Error(`Terminal ${se} has already been expanded`);ne.add(se);const ce=this._throwIfNoPty(se);return{terminal:{...ce&&await this._buildProcessDetails(z.terminal,ce,X!==void 0),id:se},relativeSize:z.relativeSize}}catch(re){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",re.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",z),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:z.relativeSize}}}_getRevivingProcessId(R,z){return`${R}-${z}`}async _buildProcessDetails(R,z,ne=!1){O.mark(`code/willBuildProcessDetails/${R}`);const[re,X]=await Promise.all([z.getCwd(),ne?!0:z.isOrphaned()]),se={id:R,title:z.title,titleSource:z.titleSource,pid:z.pid,workspaceId:z.workspaceId,workspaceName:z.workspaceName,cwd:re,isOrphan:X,icon:z.icon,color:z.color,fixedDimensions:z.fixedDimensions,environmentVariableCollections:z.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:z.shellLaunchConfig.reconnectionProperties,waitOnExit:z.shellLaunchConfig.waitOnExit,hideFromUser:z.shellLaunchConfig.hideFromUser,isFeatureTerminal:z.shellLaunchConfig.isFeatureTerminal,type:z.shellLaunchConfig.type,hasChildProcesses:z.hasChildProcesses,shellIntegrationNonce:z.processLaunchOptions.options.shellIntegration.nonce};return O.mark(`code/didBuildProcessDetails/${R}`),se}_throwIfNoPty(R){const z=this._ptys.get(R);if(!z)throw new m.ErrorNoTelemetry("Could not find pty on pty host");return z}}e.PtyService=A,ge([y.memoize],A.prototype,"traceRpcArgs",null),ge([g],A.prototype,"refreshIgnoreProcessNames",null),ge([g],A.prototype,"requestDetachInstance",null),ge([g],A.prototype,"acceptDetachInstanceReply",null),ge([g],A.prototype,"freePortKillProcess",null),ge([g],A.prototype,"serializeTerminalState",null),ge([g],A.prototype,"reviveTerminalProcesses",null),ge([g],A.prototype,"shutdownAll",null),ge([g],A.prototype,"createProcess",null),ge([g],A.prototype,"attachToProcess",null),ge([g],A.prototype,"updateTitle",null),ge([g],A.prototype,"updateIcon",null),ge([g],A.prototype,"clearBuffer",null),ge([g],A.prototype,"refreshProperty",null),ge([g],A.prototype,"updateProperty",null),ge([g],A.prototype,"detachFromProcess",null),ge([g],A.prototype,"reduceConnectionGraceTime",null),ge([g],A.prototype,"listProcesses",null),ge([g],A.prototype,"getPerformanceMarks",null),ge([g],A.prototype,"start",null),ge([g],A.prototype,"shutdown",null),ge([g],A.prototype,"input",null),ge([g],A.prototype,"processBinary",null),ge([g],A.prototype,"resize",null),ge([g],A.prototype,"getInitialCwd",null),ge([g],A.prototype,"getCwd",null),ge([g],A.prototype,"acknowledgeDataEvent",null),ge([g],A.prototype,"setUnicodeVersion",null),ge([g],A.prototype,"getLatency",null),ge([g],A.prototype,"orphanQuestionReply",null),ge([g],A.prototype,"installAutoReply",null),ge([g],A.prototype,"uninstallAllAutoReplies",null),ge([g],A.prototype,"uninstallAutoReply",null),ge([g],A.prototype,"getDefaultSystemShell",null),ge([g],A.prototype,"getEnvironment",null),ge([g],A.prototype,"getWslPath",null),ge([g],A.prototype,"getRevivedPtyNewId",null),ge([g],A.prototype,"setTerminalLayoutInfo",null),ge([g],A.prototype,"getTerminalLayoutInfo",null);var $;(function(q){q.None="None",q.ReplayOnly="ReplayOnly",q.Session="Session"})($||($={}));class B extends I.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!=="None"}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(R,z){z===P.TitleEventSource.Api&&(this._interactionState.setValue("Session","setTitle"),this._serializer.freeRawReviveBuffer()),this._title=R,this._titleSource=z}setIcon(R,z,ne){(!this._icon||"id"in z&&"id"in this._icon&&z.id!==this._icon.id||!this.color||ne!==this._color)&&(this._serializer.freeRawReviveBuffer(),R&&this._interactionState.setValue("Session","setIcon")),this._icon=z,this._color=ne}_setFixedDimensions(R){this._fixedDimensions=R}constructor(R,z,ne,re,X,se,ce,fe,K,W,Y,te,j,ee,me,x,h){super(),this._persistentProcessId=R,this._terminalProcess=z,this.workspaceId=ne,this.workspaceName=re,this.shouldPersistTerminal=X,this.processLaunchOptions=fe,this.unicodeVersion=K,this._logService=Y,this._icon=ee,this._color=me,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new D.Queue,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new S.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=P.TitleEventSource.Process,this._interactionState=new a(`Persistent process "${this._persistentProcessId}" interaction state`,"None",this._logService),this._wasRevived=te!==void 0,this._serializer=new _(se,ce,W.scrollback,K,te,fe.options.shellIntegration.nonce,X?j:void 0,this._logService),x&&this.setTitle(x,P.TitleEventSource.Api),this._fixedDimensions=h,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new D.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${k(W.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},W.graceTime)),this._disconnectRunner2=this._register(new D.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${k(W.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},W.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(U=>{this._pid=U.pid,this._cwd=U.cwd,this._onProcessReady.fire(U)})),this._register(this._terminalProcess.onDidChangeProperty(U=>{this._onDidChangeProperty.fire(U)})),this._bufferer=new p.TerminalDataBufferer((U,ie)=>this._onProcessData.fire(ie)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(U=>this._serializer.handleData(U))),this._register((0,I.toDisposable)(()=>{for(const U of this._autoReplies.values())U.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(R){this.shouldPersistTerminal&&(this._interactionState.value!=="None"||R)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!=="Session")}async refreshProperty(R){return this._terminalProcess.refreshProperty(R)}async updateProperty(R,z){if(R==="fixedDimensions")return this._setFixedDimensions(z)}async start(){if(!this._isStarted){const R=await this._terminalProcess.start();return R&&"message"in R||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),R}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:"title",value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:"shellType",value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(R){return this._terminalProcess.shutdown(R)}input(R){if(this._interactionState.setValue("Session","input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const z of this._autoReplies.values())z.handleInput();return this._terminalProcess.input(R)}}writeBinary(R){return this._terminalProcess.processBinary(R)}resize(R,z){if(!this._inReplay){this._serializer.handleResize(R,z),this._bufferer.flushBuffer(this._persistentProcessId);for(const ne of this._autoReplies.values())ne.handleResize();return this._terminalProcess.resize(R,z)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(R){this.unicodeVersion=R,this._serializer.setUnicodeVersion?.(R)}acknowledgeDataEvent(R){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(R)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value==="None"&&this._interactionState.setValue("ReplayOnly","triggerReplay");const R=await this._serializer.generateReplayEvent();let z=0;for(const ne of R.events)z+=ne.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${z} chars and ${R.events.length} size events`),this._onProcessReplay.fire(R),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(R,z){this._autoReplies.get(R)?.dispose(),this._autoReplies.set(R,new o.TerminalAutoResponder(this._terminalProcess,R,z,this._logService))}uninstallAutoReply(R){this._autoReplies.get(R)?.dispose(),this._autoReplies.delete(R)}sendCommandResult(R,z,ne){this._pendingCommands.get(R)&&this._pendingCommands.delete(R)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const R=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,R.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new D.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class a{get value(){return this._value}setValue(R,z){this._value!==R&&(this._value=R,this._log(z))}constructor(R,z,ne){this._name=R,this._value=z,this._logService=ne,this._log("initialized")}_log(R){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${R}`)}}class _{constructor(R,z,ne,re,X,se,ce,fe){this._rawReviveBuffer=ce,this._xterm=new s.Terminal({cols:R,rows:z,scrollback:ne,allowProposedApi:!0}),X&&this._xterm.writeln(X),this.setUnicodeVersion(re),this._shellIntegrationAddon=new r.ShellIntegrationAddon(se,!0,void 0,fe),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(R){this._xterm.write(R)}handleResize(R,z){this._xterm.resize(R,z)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(R,z){const ne=new(await this._getSerializeConstructor());this._xterm.loadAddon(ne);const re={scrollback:this._xterm.options.scrollback};R&&(re.excludeAltBuffer=!0,re.excludeModes=!0);let X;return z&&this._rawReviveBuffer?X=this._rawReviveBuffer:X=ne.serialize(re),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:X}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(R){this._xterm.unicode.activeVersion!==R&&(R==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=R)}async _getUnicode11Constructor(){return C||(C=(await new Promise((R,z)=>{oe(["@xterm/addon-unicode11"],R,z)})).Unicode11Addon),C}async _getSerializeConstructor(){return b||(b=(await new Promise((R,z)=>{oe(["@xterm/addon-serialize"],R,z)})).SerializeAddon),b}}function k(q){let R=0,z=0,ne=0;q>=1e3&&(ne=Math.floor(q/1e3),q-=ne*1e3),ne>=60&&(z=Math.floor(ne/60),ne-=z*60),z>=60&&(R=Math.floor(z/60),z-=R*60);const re=R?`${R}h`:"",X=z?`${z}m`:"",se=ne?`${ne}s`:"",ce=q?`${q}ms`:"";return`${re}${X}${se}${ce}`}}),define(ue[110],he([0,1,60,27,64,65,12,74,77,10,79,80,82,83,28,100,103,31,9,2]),function(oe,e,w,D,S,I,M,E,f,l,P,p,v,s,c,d,u,i,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r();async function r(){const t=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),n=parseInt(process.env.VSCODE_LATENCY??"0"),y={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,t&&await(0,o.timeout)(t);const O=(0,i.isUtilityProcess)(process);let g;O?g=new I.Server:g=new S.Server(c.TerminalIpcChannels.PtyHost);const b={_serviceBrand:void 0,...s.default},C=new f.NativeEnvironmentService((0,E.parseArgs)(process.argv,E.OPTIONS),b),A=new v.LoggerService((0,l.getLogLevel)(C),C.logsHome);g.registerChannel(c.TerminalIpcChannels.Logger,new P.LoggerChannel(A,()=>w.DefaultURITransformer));const $=A.createLogger("ptyhost",{name:(0,M.localize)(0,null)}),B=new p.LogService($);t&&B.warn(`Pty Host startup is delayed ${t}ms`),n&&B.warn(`Pty host is simulating ${n}ms latency`);const a=new m.DisposableStore,_=new d.HeartbeatService;g.registerChannel(c.TerminalIpcChannels.Heartbeat,D.ProxyChannel.fromService(_,a));const k=new u.PtyService(B,b,y,n),q=D.ProxyChannel.fromService(k,a);g.registerChannel(c.TerminalIpcChannels.PtyHost,q),O&&g.registerChannel(c.TerminalIpcChannels.PtyHostWindow,q),process.once("exit",()=>{B.trace("Pty host exiting"),B.dispose(),_.dispose(),k.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/platform/terminal/node/ptyHostMain.js.map
