/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(me){for(var e=[],P=0,F=me.length;P<F;P++)e[P]=Ce[me[P]];return e};define(Ce[158],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class P{static get(){const p=new Map,R=new Map,A=new Map,w=new Map;function E(y,_){y.has(_.detail)||y.set(_.detail,-_.timestamp)}function C(y,_){const l=y.get(_.detail);l&&(l>=0||y.set(_.detail,l+_.timestamp))}let L=[];typeof me=="function"&&typeof me.getStats=="function"&&(L=me.getStats().slice(0).sort((y,_)=>y.timestamp-_.timestamp));for(const y of L)switch(y.type){case 10:E(p,y);break;case 11:case 12:C(p,y);break;case 21:E(R,y);break;case 22:C(R,y);break;case 33:E(A,y);break;case 34:C(A,y);break;case 31:E(w,y);break;case 32:C(w,y);break}let I=0;A.forEach(y=>I+=y);function v(y){const _=[];return y.forEach((l,b)=>_.push([b,l])),_}return{amdLoad:v(p),amdInvoke:v(R),nodeRequire:v(A),nodeEval:v(w),nodeRequireTotal:I}}static toMarkdownTable(p,R){let A="";const w=[];return p.forEach((E,C)=>{w[C]=E.length}),R.forEach(E=>{E.forEach((C,L)=>{typeof C>"u"&&(C=E[L]="-");const I=C.toString().length;w[L]=Math.max(I,w[L])})}),p.forEach((E,C)=>{A+=`| ${E+" ".repeat(w[C]-E.toString().length)} `}),A+=`|
`,p.forEach((E,C)=>{A+=`| ${"-".repeat(w[C])} `}),A+=`|
`,R.forEach(E=>{E.forEach((C,L)=>{typeof C<"u"&&(A+=`| ${C+" ".repeat(w[L]-C.toString().length)} `)}),A+=`|
`}),A}}e.LoaderStats=P}),define(Ce[159],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function P(l,b,o){const i=F(l,b);if(i!==-1)return l[i]}e.findLast=P;function F(l,b,o=l.length-1){for(let i=o;i>=0;i--){const n=l[i];if(b(n))return i}return-1}e.findLastIdx=F;function p(l,b){const o=R(l,b);return o===-1?void 0:l[o]}e.findLastMonotonous=p;function R(l,b,o=0,i=l.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);b(l[a])?n=a+1:r=a}return n-1}e.findLastIdxMonotonous=R;function A(l,b){const o=w(l,b);return o===l.length?void 0:l[o]}e.findFirstMonotonous=A;function w(l,b,o=0,i=l.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);b(l[a])?r=a:n=a+1}return n}e.findFirstIdxMonotonousOrArrLen=w;function E(l,b,o=0,i=l.length){const n=w(l,b,o,i);return n===l.length?-1:n}e.findFirstIdxMonotonous=E;class C{static{this.assertInvariants=!1}constructor(b){this._array=b,this._findLastMonotonousLastIdx=0}findLastMonotonous(b){if(C.assertInvariants){if(this._prevFindLastPredicate){for(const i of this._array)if(this._prevFindLastPredicate(i)&&!b(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=b}const o=R(this._array,b,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=o+1,o===-1?void 0:this._array[o]}}e.MonotonousArray=C;function L(l,b){if(l.length===0)return;let o=l[0];for(let i=1;i<l.length;i++){const n=l[i];b(n,o)>0&&(o=n)}return o}e.findFirstMaxBy=L;function I(l,b){if(l.length===0)return;let o=l[0];for(let i=1;i<l.length;i++){const n=l[i];b(n,o)>=0&&(o=n)}return o}e.findLastMaxBy=I;function v(l,b){return L(l,(o,i)=>-b(o,i))}e.findFirstMinBy=v;function y(l,b){if(l.length===0)return-1;let o=0;for(let i=1;i<l.length;i++){const n=l[i];b(n,l[o])>0&&(o=i)}return o}e.findMaxIdxBy=y;function _(l,b){for(const o of l){const i=b(o);if(i!==void 0)return i}}e.mapFindFirst=_}),define(Ce[73],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function P(A,w){const E=Object.create(null);for(const C of A){const L=w(C);let I=E[L];I||(I=E[L]=[]),I.push(C)}return E}e.groupBy=P;function F(A,w){const E=[],C=[];for(const L of A)w.has(L)||E.push(L);for(const L of w)A.has(L)||C.push(L);return{removed:E,added:C}}e.diffSets=F;function p(A,w){const E=[],C=[];for(const[L,I]of A)w.has(L)||E.push(I);for(const[L,I]of w)A.has(L)||C.push(I);return{removed:E,added:C}}e.diffMaps=p;function R(A,w){const E=new Set;for(const C of w)A.has(C)&&E.add(C);return E}e.intersection=R}),define(Ce[53],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function P(A){return(w,E,C)=>{let L=null,I=null;if(typeof C.value=="function"?(L="value",I=C.value):typeof C.get=="function"&&(L="get",I=C.get),!I)throw new Error("not supported");C[L]=A(I,E)}}function F(A,w,E){let C=null,L=null;if(typeof E.value=="function"?(C="value",L=E.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",L=E.get),!L)throw new Error("not supported");const I=`$memoize$${w}`;E[C]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[I]}}e.memoize=F;function p(A,w,E){return P((C,L)=>{const I=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...y){this[v]||(this[v]=E?E():void 0),clearTimeout(this[I]),w&&(this[v]=w(this[v],...y),y=[this[v]]),this[I]=setTimeout(()=>{C.apply(this,y),this[v]=E?E():void 0},A)}})}e.debounce=p;function R(A,w,E){return P((C,L)=>{const I=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,y=`$throttle$lastRun$${L}`,_=`$throttle$pending$${L}`;return function(...l){if(this[v]||(this[v]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),w&&(this[v]=w(this[v],...l)),this[_])return;const b=this[y]+A;b<=Date.now()?(this[y]=Date.now(),C.apply(this,[this[v]]),this[v]=E?E():void 0):(this[_]=!0,this[I]=setTimeout(()=>{this[_]=!1,this[y]=Date.now(),C.apply(this,[this[v]]),this[v]=E?E():void 0},b-Date.now()))}})}e.throttle=R}),define(Ce[14],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(h=>{h(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=P,e.errorHandler=new P;function F(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function p(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=p;function R(a){C(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function A(a){C(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=A;function w(a){if(a instanceof Error){const{name:t,message:h}=a,u=a.stacktrace||a.stack;return{$isError:!0,name:t,message:h,stack:u,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=w;const E="Canceled";function C(a){return a instanceof L?!0:a instanceof Error&&a.name===E&&a.message===E}e.isCancellationError=C;class L extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=L;function I(){const a=new Error(E);return a.name=a.message,a}e.canceled=I;function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=v;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=y;class _ extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=_;function l(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=l;class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=b;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const h=new n;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.BugIndicatingError=r}),define(Ce[19],De([1,0,14,159]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function p(le,de=0){return le[le.length-(1+de)]}e.tail=p;function R(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.tail2=R;function A(le,de,ce=(he,V)=>he===V){if(le===de)return!0;if(!le||!de||le.length!==de.length)return!1;for(let he=0,V=le.length;he<V;he++)if(!ce(le[he],de[he]))return!1;return!0}e.equals=A;function w(le,de){const ce=le.length-1;de<ce&&(le[de]=le[ce]),le.pop()}e.removeFastWithoutKeepingOrder=w;function E(le,de,ce){return C(le.length,he=>ce(le[he],de))}e.binarySearch=E;function C(le,de){let ce=0,he=le-1;for(;ce<=he;){const V=(ce+he)/2|0,J=de(V);if(J<0)ce=V+1;else if(J>0)he=V-1;else return V}return-(ce+1)}e.binarySearch2=C;function L(le,de,ce){if(le=le|0,le>=de.length)throw new TypeError("invalid index");const he=de[Math.floor(de.length*Math.random())],V=[],J=[],ue=[];for(const ve of de){const ke=ce(ve,he);ke<0?V.push(ve):ke>0?J.push(ve):ue.push(ve)}return le<V.length?L(le,V,ce):le<V.length+ue.length?ue[0]:L(le-(V.length+ue.length),J,ce)}e.quickSelect=L;function I(le,de){const ce=[];let he;for(const V of le.slice(0).sort(de))!he||de(he[0],V)!==0?(he=[V],ce.push(he)):he.push(V);return ce}e.groupBy=I;function*v(le,de){let ce,he;for(const V of le)he!==void 0&&de(he,V)?ce.push(V):(ce&&(yield ce),ce=[V]),he=V;ce&&(yield ce)}e.groupAdjacentBy=v;function y(le,de){for(let ce=0;ce<=le.length;ce++)de(ce===0?void 0:le[ce-1],ce===le.length?void 0:le[ce])}e.forEachAdjacent=y;function _(le,de){for(let ce=0;ce<le.length;ce++)de(ce===0?void 0:le[ce-1],le[ce],ce+1===le.length?void 0:le[ce+1])}e.forEachWithNeighbors=_;function l(le,de,ce){const he=[];function V(ve,ke,we){if(ke===0&&we.length===0)return;const Te=he[he.length-1];Te&&Te.start+Te.deleteCount===ve?(Te.deleteCount+=ke,Te.toInsert.push(...we)):he.push({start:ve,deleteCount:ke,toInsert:we})}let J=0,ue=0;for(;;){if(J===le.length){V(J,0,de.slice(ue));break}if(ue===de.length){V(J,le.length-J,[]);break}const ve=le[J],ke=de[ue],we=ce(ve,ke);we===0?(J+=1,ue+=1):we<0?(V(J,1,[]),J+=1):we>0&&(V(J,0,[ke]),ue+=1)}return he}e.sortedDiff=l;function b(le,de,ce){const he=l(le,de,ce),V=[],J=[];for(const ue of he)V.push(...le.slice(ue.start,ue.start+ue.deleteCount)),J.push(...ue.toInsert);return{removed:V,added:J}}e.delta=b;function o(le,de,ce){if(ce===0)return[];const he=le.slice(0,ce).sort(de);return n(le,de,he,ce,le.length),he}e.top=o;function i(le,de,ce,he,V){return ce===0?Promise.resolve([]):new Promise((J,ue)=>{(async()=>{const ve=le.length,ke=le.slice(0,ce).sort(de);for(let we=ce,Te=Math.min(ce+he,ve);we<ve;we=Te,Te=Math.min(Te+he,ve)){if(we>ce&&await new Promise(Oe=>setTimeout(Oe)),V&&V.isCancellationRequested)throw new P.CancellationError;n(le,de,ke,we,Te)}return ke})().then(J,ue)})}e.topAsync=i;function n(le,de,ce,he,V){for(const J=ce.length;he<V;he++){const ue=le[he];if(de(ue,ce[J-1])<0){ce.pop();const ve=(0,F.findFirstIdxMonotonousOrArrLen)(ce,ke=>de(ue,ke)<0);ce.splice(ve,0,ue)}}}function r(le){return le.filter(de=>!!de)}e.coalesce=r;function a(le){let de=0;for(let ce=0;ce<le.length;ce++)le[ce]&&(le[de]=le[ce],de+=1);le.length=de}e.coalesceInPlace=a;function t(le,de,ce){le.splice(ce,0,le.splice(de,1)[0])}e.move=t;function h(le){return!Array.isArray(le)||le.length===0}e.isFalsyOrEmpty=h;function u(le){return Array.isArray(le)&&le.length>0}e.isNonEmptyArray=u;function s(le,de=ce=>ce){const ce=new Set;return le.filter(he=>{const V=de(he);return ce.has(V)?!1:(ce.add(V),!0)})}e.distinct=s;function c(le){const de=new Set;return ce=>{const he=le(ce);return de.has(he)?!1:(de.add(he),!0)}}e.uniqueFilter=c;function d(le,de){return le.length>0?le[0]:de}e.firstOrDefault=d;function m(le,de){return le.length>0?le[le.length-1]:de}e.lastOrDefault=m;function D(le,de,ce=(he,V)=>he===V){let he=0;for(let V=0,J=Math.min(le.length,de.length);V<J&&ce(le[V],de[V]);V++)he++;return he}e.commonPrefixLength=D;function g(le){return[].concat(...le)}e.flatten=g;function f(le,de){let ce=typeof de=="number"?le:0;typeof de=="number"?ce=le:(ce=0,de=le);const he=[];if(ce<=de)for(let V=ce;V<de;V++)he.push(V);else for(let V=ce;V>de;V--)he.push(V);return he}e.range=f;function S(le,de,ce){return le.reduce((he,V)=>(he[de(V)]=ce?ce(V):V,he),Object.create(null))}e.index=S;function T(le,de){return le.push(de),()=>N(le,de)}e.insert=T;function N(le,de){const ce=le.indexOf(de);if(ce>-1)return le.splice(ce,1),de}e.remove=N;function z(le,de,ce){const he=le.slice(0,de),V=le.slice(de);return he.concat(ce,V)}e.arrayInsert=z;function x(le,de){let ce;if(typeof de=="number"){let he=de;ce=()=>{const V=Math.sin(he++)*179426549;return V-Math.floor(V)}}else ce=Math.random;for(let he=le.length-1;he>0;he-=1){const V=Math.floor(ce()*(he+1)),J=le[he];le[he]=le[V],le[V]=J}}e.shuffle=x;function M(le,de){const ce=le.indexOf(de);ce>-1&&(le.splice(ce,1),le.unshift(de))}e.pushToStart=M;function k(le,de){const ce=le.indexOf(de);ce>-1&&(le.splice(ce,1),le.push(de))}e.pushToEnd=k;function O(le,de){for(const ce of de)le.push(ce)}e.pushMany=O;function U(le,de){return Array.isArray(le)?le.map(de):de(le)}e.mapArrayOrNot=U;function q(le){return Array.isArray(le)?le:[le]}e.asArray=q;function ie(le){return le[Math.floor(Math.random()*le.length)]}e.getRandomElement=ie;function Z(le,de,ce){const he=Y(le,de),V=le.length,J=ce.length;le.length=V+J;for(let ue=V-1;ue>=he;ue--)le[ue+J]=le[ue];for(let ue=0;ue<J;ue++)le[ue+he]=ce[ue]}e.insertInto=Z;function Q(le,de,ce,he){const V=Y(le,de);let J=le.splice(V,ce);return J===void 0&&(J=[]),Z(le,V,he),J}e.splice=Q;function Y(le,de){return de<0?Math.max(de+le.length,0):Math.min(de,le.length)}var ae;(function(le){function de(J){return J<0}le.isLessThan=de;function ce(J){return J<=0}le.isLessThanOrEqual=ce;function he(J){return J>0}le.isGreaterThan=he;function V(J){return J===0}le.isNeitherLessOrGreaterThan=V,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function ee(le,de){return(ce,he)=>de(le(ce),le(he))}e.compareBy=ee;function fe(...le){return(de,ce)=>{for(const he of le){const V=he(de,ce);if(!ae.isNeitherLessOrGreaterThan(V))return V}return ae.neitherLessOrGreaterThan}}e.tieBreakComparators=fe;const re=(le,de)=>le-de;e.numberComparator=re;const G=(le,de)=>(0,e.numberComparator)(le?1:0,de?1:0);e.booleanComparator=G;function B(le){return(de,ce)=>-le(de,ce)}e.reverseOrder=B;class se{constructor(de){this.items=de,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(de){let ce=this.firstIdx;for(;ce<this.items.length&&de(this.items[ce]);)ce++;const he=ce===this.firstIdx?null:this.items.slice(this.firstIdx,ce);return this.firstIdx=ce,he}takeFromEndWhile(de){let ce=this.lastIdx;for(;ce>=0&&de(this.items[ce]);)ce--;const he=ce===this.lastIdx?null:this.items.slice(ce+1,this.lastIdx+1);return this.lastIdx=ce,he}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const de=this.items[this.firstIdx];return this.firstIdx++,de}removeLast(){const de=this.items[this.lastIdx];return this.lastIdx--,de}takeCount(de){const ce=this.items.slice(this.firstIdx,this.firstIdx+de);return this.firstIdx+=de,ce}}e.ArrayQueue=se;class ye{static{this.empty=new ye(de=>{})}constructor(de){this.iterate=de}forEach(de){this.iterate(ce=>(de(ce),!0))}toArray(){const de=[];return this.iterate(ce=>(de.push(ce),!0)),de}filter(de){return new ye(ce=>this.iterate(he=>de(he)?ce(he):!0))}map(de){return new ye(ce=>this.iterate(he=>ce(de(he))))}some(de){let ce=!1;return this.iterate(he=>(ce=de(he),!ce)),ce}findFirst(de){let ce;return this.iterate(he=>de(he)?(ce=he,!1):!0),ce}findLast(de){let ce;return this.iterate(he=>(de(he)&&(ce=he),!0)),ce}findLastMaxBy(de){let ce,he=!0;return this.iterate(V=>((he||ae.isGreaterThan(de(V,ce)))&&(he=!1,ce=V),!0)),ce}}e.CallbackIterable=ye}),define(Ce[61],De([1,0,14]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.softAssert=e.assert=e.assertNever=e.ok=void 0;function F(C,L){if(!C)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=F;function p(C,L="Unreachable"){throw new Error(L)}e.assertNever=p;function R(C){if(!C)throw new P.BugIndicatingError("Assertion Failed")}e.assert=R;function A(C){C||(0,P.onUnexpectedError)(new P.BugIndicatingError("Soft Assertion Failed"))}e.softAssert=A;function w(C){if(!C()){debugger;C(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}e.assertFn=w;function E(C,L){let I=0;for(;I<C.length-1;){const v=C[I],y=C[I+1];if(!L(v,y))return!1;I++}return!0}e.checkAdjacentItems=E}),define(Ce[74],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function P(F,p){const R=this;let A=!1,w;return function(){if(A)return w;if(A=!0,p)try{w=F.apply(R,arguments)}finally{p()}else w=F.apply(R,arguments);return w}}e.createSingleCallFunction=P}),define(Ce[121],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class P{constructor(p){this._prefix=p,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=P,e.defaultGenerator=new P("id#")}),define(Ce[48],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(F){function p(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}F.is=p;const R=Object.freeze([]);function A(){return R}F.empty=A;function*w(t){yield t}F.single=w;function E(t){return p(t)?t:w(t)}F.wrap=E;function C(t){return t||R}F.from=C;function*L(t){for(let h=t.length-1;h>=0;h--)yield t[h]}F.reverse=L;function I(t){return!t||t[Symbol.iterator]().next().done===!0}F.isEmpty=I;function v(t){return t[Symbol.iterator]().next().value}F.first=v;function y(t,h){for(const u of t)if(h(u))return!0;return!1}F.some=y;function _(t,h){for(const u of t)if(h(u))return u}F.find=_;function*l(t,h){for(const u of t)h(u)&&(yield u)}F.filter=l;function*b(t,h){let u=0;for(const s of t)yield h(s,u++)}F.map=b;function*o(...t){for(const h of t)yield*h}F.concat=o;function i(t,h,u){let s=u;for(const c of t)s=h(s,c);return s}F.reduce=i;function*n(t,h,u=t.length){for(h<0&&(h+=t.length),u<0?u+=t.length:u>t.length&&(u=t.length);h<u;h++)yield t[h]}F.slice=n;function r(t,h=Number.POSITIVE_INFINITY){const u=[];if(h===0)return[u,t];const s=t[Symbol.iterator]();for(let c=0;c<h;c++){const d=s.next();if(d.done)return[u,F.empty()];u.push(d.value)}return[u,{[Symbol.iterator](){return s}}]}F.consume=r;async function a(t){const h=[];for await(const u of t)h.push(u);return Promise.resolve(h)}F.asyncToArray=a})(P||(e.Iterable=P={}))}),define(Ce[160],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var p;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(p||(e.ParseErrorCode=p={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,h=!1){let u=0;const s=t.length;let c="",d=0,m=16,D=0;function g(M){let k=0,O=0;for(;k<M;){const U=t.charCodeAt(u);if(U>=48&&U<=57)O=O*16+U-48;else if(U>=65&&U<=70)O=O*16+U-65+10;else if(U>=97&&U<=102)O=O*16+U-97+10;else break;u++,k++}return k<M&&(O=-1),O}function f(M){u=M,c="",d=0,m=16,D=0}function S(){const M=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&C(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&C(t.charCodeAt(u)))for(u++;u<t.length&&C(t.charCodeAt(u));)u++;else return D=3,t.substring(M,u);let k=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&C(t.charCodeAt(u))){for(u++;u<t.length&&C(t.charCodeAt(u));)u++;k=u}else D=3;return t.substring(M,k)}function T(){let M="",k=u;for(;;){if(u>=s){M+=t.substring(k,u),D=2;break}const O=t.charCodeAt(u);if(O===34){M+=t.substring(k,u),u++;break}if(O===92){if(M+=t.substring(k,u),u++,u>=s){D=2;break}switch(t.charCodeAt(u++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const q=g(4);q>=0?M+=String.fromCharCode(q):D=4;break}default:D=5}k=u;continue}if(O>=0&&O<=31)if(E(O)){M+=t.substring(k,u),D=2;break}else D=6;u++}return M}function N(){if(c="",D=0,d=u,u>=s)return d=s,m=17;let M=t.charCodeAt(u);if(w(M)){do u++,c+=String.fromCharCode(M),M=t.charCodeAt(u);while(w(M));return m=15}if(E(M))return u++,c+=String.fromCharCode(M),M===13&&t.charCodeAt(u)===10&&(u++,c+=`
`),m=14;switch(M){case 123:return u++,m=1;case 125:return u++,m=2;case 91:return u++,m=3;case 93:return u++,m=4;case 58:return u++,m=6;case 44:return u++,m=5;case 34:return u++,c=T(),m=10;case 47:{const k=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<s&&!E(t.charCodeAt(u));)u++;return c=t.substring(k,u),m=12}if(t.charCodeAt(u+1)===42){u+=2;const O=s-1;let U=!1;for(;u<O;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,U=!0;break}u++}return U||(u++,D=1),c=t.substring(k,u),m=13}return c+=String.fromCharCode(M),u++,m=16}case 45:if(c+=String.fromCharCode(M),u++,u===s||!C(t.charCodeAt(u)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=S(),m=11;default:for(;u<s&&z(M);)u++,M=t.charCodeAt(u);if(d!==u){switch(c=t.substring(d,u),c){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return c+=String.fromCharCode(M),u++,m=16}}function z(M){if(w(M)||E(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:f,getPosition:()=>u,scan:h?x:N,getToken:()=>m,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>u-d,getTokenError:()=>D}}e.createScanner=A;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function I(t,h){const u=[],s=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(g,f,S,T){d.value=g,d.offset=f,d.length=S,d.type=T,d.colonOffset=void 0,c=d}try{n(t,{onObjectBegin:(g,f)=>{if(h<=g)throw s;c=void 0,m=h>g,u.push("")},onObjectProperty:(g,f,S)=>{if(h<f||(D(g,f,S,"property"),u[u.length-1]=g,h<=f+S))throw s},onObjectEnd:(g,f)=>{if(h<=g)throw s;c=void 0,u.pop()},onArrayBegin:(g,f)=>{if(h<=g)throw s;c=void 0,u.push(0)},onArrayEnd:(g,f)=>{if(h<=g)throw s;c=void 0,u.pop()},onLiteralValue:(g,f,S)=>{if(h<f||(D(g,f,S,a(g)),h<=f+S))throw s},onSeparator:(g,f,S)=>{if(h<=f)throw s;if(g===":"&&c&&c.type==="property")c.colonOffset=f,m=!1,c=void 0;else if(g===","){const T=u[u.length-1];typeof T=="number"?u[u.length-1]=T+1:(m=!0,u[u.length-1]=""),c=void 0}}})}catch(g){if(g!==s)throw g}return{path:u,previousNode:c,isAtPropertyKey:m,matches:g=>{let f=0;for(let S=0;f<g.length&&S<u.length;S++)if(g[f]===u[S]||g[f]==="*")f++;else if(g[f]!=="**")return!1;return f===g.length}}}e.getLocation=I;function v(t,h=[],u=R.DEFAULT){let s=null,c=[];const d=[];function m(g){Array.isArray(c)?c.push(g):s!==null&&(c[s]=g)}return n(t,{onObjectBegin:()=>{const g={};m(g),d.push(c),c=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const g=[];m(g),d.push(c),c=g,s=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:m,onError:(g,f,S)=>{h.push({error:g,offset:f,length:S})}},u),c[0]}e.parse=v;function y(t,h=[],u=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(g){s.type==="property"&&(s.length=g-s.offset,s=s.parent)}function d(g){return s.children.push(g),g}n(t,{onObjectBegin:g=>{s=d({type:"object",offset:g,length:-1,parent:s,children:[]})},onObjectProperty:(g,f,S)=>{s=d({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:g,offset:f,length:S,parent:s})},onObjectEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,c(g+f)},onArrayBegin:(g,f)=>{s=d({type:"array",offset:g,length:-1,parent:s,children:[]})},onArrayEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,c(g+f)},onLiteralValue:(g,f,S)=>{d({type:a(g),offset:f,length:S,parent:s,value:g}),c(f+S)},onSeparator:(g,f,S)=>{s.type==="property"&&(g===":"?s.colonOffset=f:g===","&&c(f))},onError:(g,f,S)=>{h.push({error:g,offset:f,length:S})}},u);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=y;function _(t,h){if(!t)return;let u=t;for(const s of h)if(typeof s=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let c=!1;for(const d of u.children)if(Array.isArray(d.children)&&d.children[0].value===s){u=d.children[1],c=!0;break}if(!c)return}else{const c=s;if(u.type!=="array"||c<0||!Array.isArray(u.children)||c>=u.children.length)return;u=u.children[c]}return u}e.findNodeAtLocation=_;function l(t){if(!t.parent||!t.parent.children)return[];const h=l(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;h.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&h.push(u)}return h}e.getNodePath=l;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const h=Object.create(null);for(const u of t.children){const s=u.children[1];s&&(h[u.children[0].value]=b(s))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function o(t,h,u=!1){return h>=t.offset&&h<t.offset+t.length||u&&h===t.offset+t.length}e.contains=o;function i(t,h,u=!1){if(o(t,h,u)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=h;c++){const d=i(s[c],h,u);if(d)return d}return t}}e.findNodeAtOffset=i;function n(t,h,u=R.DEFAULT){const s=A(t,!1);function c(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function d(ee){return ee?fe=>ee(fe,s.getTokenOffset(),s.getTokenLength()):()=>!0}const m=c(h.onObjectBegin),D=d(h.onObjectProperty),g=c(h.onObjectEnd),f=c(h.onArrayBegin),S=c(h.onArrayEnd),T=d(h.onLiteralValue),N=d(h.onSeparator),z=c(h.onComment),x=d(h.onError),M=u&&u.disallowComments,k=u&&u.allowTrailingComma;function O(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ee){case 12:case 13:M?U(10):z();break;case 16:U(1);break;case 15:case 14:break;default:return ee}}}function U(ee,fe=[],re=[]){if(x(ee),fe.length+re.length>0){let G=s.getToken();for(;G!==17;){if(fe.indexOf(G)!==-1){O();break}else if(re.indexOf(G)!==-1)break;G=O()}}}function q(ee){const fe=s.getTokenValue();return ee?T(fe):D(fe),O(),!0}function ie(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(U(2),ee=0)}catch{U(2)}T(ee);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return O(),!0}function Z(){return s.getToken()!==10?(U(3,[],[2,5]),!1):(q(!1),s.getToken()===6?(N(":"),O(),ae()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){m(),O();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||U(4,[],[]),N(","),O(),s.getToken()===2&&k)break}else ee&&U(6,[],[]);Z()||U(4,[],[2,5]),ee=!0}return g(),s.getToken()!==2?U(7,[2],[]):O(),!0}function Y(){f(),O();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||U(4,[],[]),N(","),O(),s.getToken()===4&&k)break}else ee&&U(6,[],[]);ae()||U(4,[],[4,5]),ee=!0}return S(),s.getToken()!==4?U(8,[4],[]):O(),!0}function ae(){switch(s.getToken()){case 3:return Y();case 1:return Q();case 10:return q(!0);default:return ie()}}return O(),s.getToken()===17?u.allowEmptyContent?!0:(U(4,[],[]),!1):ae()?(s.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=n;function r(t,h){const u=A(t),s=[];let c,d=0,m;do switch(m=u.getPosition(),c=u.scan(),c){case 12:case 13:case 17:d!==m&&s.push(t.substring(d,m)),h!==void 0&&s.push(u.getTokenValue().replace(/[^\r\n]/g,h)),d=u.getPosition();break}while(c!==17);return s.join("")}e.stripComments=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Ce[44],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(p){this.executor=p,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(p){this._error=p}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=P}),define(Ce[75],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{static{this.Undefined=new P(void 0)}constructor(R){this.element=R,this.next=P.Undefined,this.prev=P.Undefined}}class F{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let R=this._first;for(;R!==P.Undefined;){const A=R.next;R.prev=P.Undefined,R.next=P.Undefined,R=A}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,A){const w=new P(R);if(this._first===P.Undefined)this._first=w,this._last=w;else if(A){const C=this._last;this._last=w,w.prev=C,C.next=w}else{const C=this._first;this._first=w,w.next=C,C.prev=w}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(w))}}shift(){if(this._first!==P.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==P.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==P.Undefined&&R.next!==P.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===P.Undefined&&R.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):R.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):R.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==P.Undefined;)yield R.element,R=R.next}}e.LinkedList=F}),define(Ce[28],De([1,0]),function(me,e){"use strict";var P,F,p;Object.defineProperty(e,"__esModule",{value:!0}),e.mapsStrictEqualIgnoreOrder=e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,r,a){let t=n.get(r);return t===void 0&&(t=a,n.set(r,t)),t}e.getOrSet=R;function A(n){const r=[];return n.forEach((a,t)=>{r.push(`${t} => ${a}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=A;function w(n){const r=[];return n.forEach(a=>{r.push(a)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=w;class E{constructor(r,a){this.uri=r,this.value=a}}function C(n){return Array.isArray(n)}class L{static{this.defaultToKey=r=>r.toString()}constructor(r,a){if(this[P]="ResourceMap",r instanceof L)this.map=new Map(r.map),this.toKey=a??L.defaultToKey;else if(C(r)){this.map=new Map,this.toKey=a??L.defaultToKey;for(const[t,h]of r)this.set(t,h)}else this.map=new Map,this.toKey=r??L.defaultToKey}set(r,a){return this.map.set(this.toKey(r),new E(r,a)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a<"u"&&(r=r.bind(a));for(const[t,h]of this.map)r(h.value,h.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=L;class I{constructor(r,a){this[F]="ResourceSet",!r||typeof r=="function"?this._map=new L(r):(this._map=new L(a),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,a){this._map.forEach((t,h)=>r.call(a,h,h,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var v;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class y{constructor(){this[p]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const t=this._map.get(r);if(t)return a!==0&&this.touch(t,a),t.value}set(r,a,t=0){let h=this._map.get(r);if(h)h.value=a,t!==0&&this.touch(h,t);else{switch(h={key:r,value:a,next:void 0,previous:void 0},t){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const t=this._state;let h=this._head;for(;h;){if(a?r.bind(a)(h.value,h.key,this):r(h.value,h.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,a=this._state;let t=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const u={value:t.key,done:!1};return t=t.next,u}else return{value:void 0,done:!0}}};return h}values(){const r=this,a=this._state;let t=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const u={value:t.value,done:!1};return t=t.next,u}else return{value:void 0,done:!0}}};return h}entries(){const r=this,a=this._state;let t=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const u={value:[t.key,t.value],done:!1};return t=t.next,u}else return{value:void 0,done:!0}}};return h}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,t=this.size;for(;a&&t>r;)this._map.delete(a.key),a=a.next,t--;this._head=a,this._size=t,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,t=r.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const t=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(t.previous=h,h.next=t),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const t=r.next,h=r.previous;r===this._head?(t.previous=void 0,this._head=t):(t.previous=h,h.next=t),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,t)=>{r.push([t,a])}),r}fromJSON(r){this.clear();for(const[a,t]of r)this.set(a,t)}}e.LinkedMap=y;class _ extends y{constructor(r,a=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=_;class l{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let a=this.map.get(r)||0;return a===0?!1:(a--,a===0?this.map.delete(r):this.map.set(r,a),!0)}has(r){return this.map.has(r)}}e.CounterSet=l;class b{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[a,t]of r)this.set(a,t)}clear(){this._m1.clear(),this._m2.clear()}set(r,a){this._m1.set(r,a),this._m2.set(a,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const a=this._m1.get(r);return a===void 0?!1:(this._m1.delete(r),this._m2.delete(a),!0)}forEach(r,a){this._m1.forEach((t,h)=>{r.call(a,t,h,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=b;class o{constructor(){this.map=new Map}add(r,a){let t=this.map.get(r);t||(t=new Set,this.map.set(r,t)),t.add(a)}delete(r,a){const t=this.map.get(r);t&&(t.delete(a),t.size===0&&this.map.delete(r))}forEach(r,a){const t=this.map.get(r);t&&t.forEach(a)}get(r){const a=this.map.get(r);return a||new Set}}e.SetMap=o;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[a,t]of n)if(!r.has(a)||r.get(a)!==t)return!1;for(const[a]of r)if(!n.has(a))return!1;return!0}e.mapsStrictEqualIgnoreOrder=i}),define(Ce[3],De([1,0,19,73,28,74,48]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const w=!1;let E=null;class C{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(T){let N=this.livingDisposables.get(T);return N||(N={parent:null,source:null,isSingleton:!1,value:T,idx:C.idx++},this.livingDisposables.set(T,N)),N}trackDisposable(T){const N=this.getDisposableData(T);N.source||(N.source=new Error().stack)}setParent(T,N){const z=this.getDisposableData(T);z.parent=N}markAsDisposed(T){this.livingDisposables.delete(T)}markAsSingleton(T){this.getDisposableData(T).isSingleton=!0}getRootParent(T,N){const z=N.get(T);if(z)return z;const x=T.parent?this.getRootParent(this.getDisposableData(T.parent),N):T;return N.set(T,x),x}getTrackedDisposables(){const T=new Map;return[...this.livingDisposables.entries()].filter(([,z])=>z.source!==null&&!this.getRootParent(z,T).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(T=10,N){let z;if(N)z=N;else{const U=new Map,q=[...this.livingDisposables.values()].filter(Z=>Z.source!==null&&!this.getRootParent(Z,U).isSingleton);if(q.length===0)return;const ie=new Set(q.map(Z=>Z.value));if(z=q.filter(Z=>!(Z.parent&&ie.has(Z.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function x(U){function q(Z,Q){for(;Z.length>0&&Q.some(Y=>typeof Y=="string"?Y===Z[0]:Z[0].match(Y));)Z.shift()}const ie=U.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return q(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new p.SetMap;for(const U of z){const q=x(U);for(let ie=0;ie<=q.length;ie++)M.add(q.slice(0,ie).join(`
`),U)}z.sort((0,P.compareBy)(U=>U.idx,P.numberComparator));let k="",O=0;for(const U of z.slice(0,T)){O++;const q=x(U),ie=[];for(let Z=0;Z<q.length;Z++){let Q=q[Z];Q=`(shared with ${M.get(q.slice(0,Z+1).join(`
`)).size}/${z.length} leaks) at ${Q}`;const ae=M.get(q.slice(0,Z).join(`
`)),ee=(0,F.groupBy)([...ae].map(fe=>x(fe)[Z]),fe=>fe);delete ee[q[Z]];for(const[fe,re]of Object.entries(ee))ie.unshift(`    - stacktraces of ${re.length} other leaks continue with ${fe}`);ie.unshift(Q)}k+=`


==================== Leaking disposable ${O}/${z.length}: ${U.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return z.length>T&&(k+=`


... and ${z.length-T} more leaking disposables

`),{leaks:z,details:k}}}e.DisposableTracker=C;function L(S){E=S}if(e.setDisposableTracker=L,w){const S="__is_disposable_tracked__";L(new class{trackDisposable(T){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[S]||console.log(N)},3e3)}setParent(T,N){if(T&&T!==t.None)try{T[S]=!0}catch{}}markAsDisposed(T){if(T&&T!==t.None)try{T[S]=!0}catch{}}markAsSingleton(T){}})}function I(S){return E?.trackDisposable(S),S}e.trackDisposable=I;function v(S){E?.markAsDisposed(S)}e.markAsDisposed=v;function y(S,T){E?.setParent(S,T)}function _(S,T){if(E)for(const N of S)E.setParent(N,T)}function l(S){return E?.markAsSingleton(S),S}e.markAsSingleton=l;function b(S){return typeof S.dispose=="function"&&S.dispose.length===0}e.isDisposable=b;function o(S){if(A.Iterable.is(S)){const T=[];for(const N of S)if(N)try{N.dispose()}catch(z){T.push(z)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}e.dispose=o;function i(S){for(const T of S)b(T)&&T.dispose();return[]}e.disposeIfDisposable=i;function n(...S){const T=r(()=>o(S));return _(S,T),T}e.combinedDisposable=n;function r(S){const T=I({dispose:(0,R.createSingleCallFunction)(()=>{v(T),S()})});return T}e.toDisposable=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return y(T,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(T),T.dispose()}}deleteAndLeak(T){T&&this._toDispose.has(T)&&(this._toDispose.delete(T),y(T,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,I(this),y(this._store,this)}dispose(){v(this),this._store.dispose()}_register(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(T)}}e.Disposable=t;class h{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(T){this._isDisposed||T===this._value||(this._value?.dispose(),T&&y(T,this),this._value=T)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const T=this._value;return this._value=void 0,T&&y(T,null),T}}e.MutableDisposable=h;class u{constructor(T){this._disposable=new h,this._isDisposed=!1,this._disposable.value=T}get value(){return this._disposable.value}set value(T){this._isDisposed||T===this._disposable.value||(this._disposable.value=T)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=u;class s{constructor(T){this._disposable=T,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(T){let N=T;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,v(this))},this}}e.SafeDisposable=c;class d{constructor(){this.references=new Map}acquire(T,...N){let z=this.references.get(T);z||(z={counter:0,object:this.createReferencedObject(T,...N)},this.references.set(T,z));const{object:x}=z,M=(0,R.createSingleCallFunction)(()=>{--z.counter===0&&(this.destroyReferencedObject(T,z.object),this.references.delete(T))});return z.counter++,{object:x,dispose:M}}}e.ReferenceCollection=d;class m{constructor(T){this.referenceCollection=T}async acquire(T,...N){const z=this.referenceCollection.acquire(T,...N);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(x){throw z.dispose(),x}}}e.AsyncReferenceCollection=m;class D{constructor(T){this.object=T}dispose(){}}e.ImmortalReference=D;function g(S){const T=new a;try{S(T)}finally{T.dispose()}}e.disposeOnReturn=g;class f{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}has(T){return this._store.has(T)}get size(){return this._store.size}get(T){return this._store.get(T)}set(T,N,z=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this._store.get(T)?.dispose(),this._store.set(T,N)}deleteAndDispose(T){this._store.get(T)?.dispose(),this._store.delete(T)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=f}),function(me,e){typeof define=="function"&&define.amd?define(Ce[161],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(de,ce){for(var he=0;he<ce.length;he++){var V=ce[he];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(de,V.key,V)}}function P(de,ce,he){return ce&&e(de.prototype,ce),he&&e(de,he),Object.defineProperty(de,"prototype",{writable:!1}),de}function F(de,ce){if(de){if(typeof de=="string")return p(de,ce);var he=Object.prototype.toString.call(de).slice(8,-1);if(he==="Object"&&de.constructor&&(he=de.constructor.name),he==="Map"||he==="Set")return Array.from(de);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return p(de,ce)}}function p(de,ce){(ce==null||ce>de.length)&&(ce=de.length);for(var he=0,V=new Array(ce);he<ce;he++)V[he]=de[he];return V}function R(de,ce){var he=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(he)return(he=he.call(de)).next.bind(he);if(Array.isArray(de)||(he=F(de))||ce&&de&&typeof de.length=="number"){he&&(de=he);var V=0;return function(){return V>=de.length?{done:!0}:{done:!1,value:de[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function w(de){me.defaults=de}var E=/[&<>"']/,C=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(ce){return v[ce]};function _(de,ce){if(ce){if(E.test(de))return de.replace(C,y)}else if(L.test(de))return de.replace(I,y);return de}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(de){return de.replace(l,function(ce,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(de,ce){de=typeof de=="string"?de:de.source,ce=ce||"";var he={replace:function(J,ue){return ue=ue.source||ue,ue=ue.replace(o,"$1"),de=de.replace(J,ue),he},getRegex:function(){return new RegExp(de,ce)}};return he}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(de,ce,he){if(de){var V;try{V=decodeURIComponent(b(he)).replace(n,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ce&&!r.test(he)&&(he=c(ce,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},h=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(de,ce){t[" "+de]||(h.test(de)?t[" "+de]=de+"/":t[" "+de]=g(de,"/",!0)),de=t[" "+de];var he=de.indexOf(":")===-1;return ce.substring(0,2)==="//"?he?ce:de.replace(u,"$1")+ce:ce.charAt(0)==="/"?he?ce:de.replace(s,"$1")+ce:de+ce}var d={exec:function(){}};function m(de){for(var ce=1,he,V;ce<arguments.length;ce++){he=arguments[ce];for(V in he)Object.prototype.hasOwnProperty.call(he,V)&&(de[V]=he[V])}return de}function D(de,ce){var he=de.replace(/\|/g,function(ue,ve,ke){for(var we=!1,Te=ve;--Te>=0&&ke[Te]==="\\";)we=!we;return we?"|":" |"}),V=he.split(/ \|/),J=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>ce)V.splice(ce);else for(;V.length<ce;)V.push("");for(;J<V.length;J++)V[J]=V[J].trim().replace(/\\\|/g,"|");return V}function g(de,ce,he){var V=de.length;if(V===0)return"";for(var J=0;J<V;){var ue=de.charAt(V-J-1);if(ue===ce&&!he)J++;else if(ue!==ce&&he)J++;else break}return de.slice(0,V-J)}function f(de,ce){if(de.indexOf(ce[1])===-1)return-1;for(var he=de.length,V=0,J=0;J<he;J++)if(de[J]==="\\")J++;else if(de[J]===ce[0])V++;else if(de[J]===ce[1]&&(V--,V<0))return J;return-1}function S(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(de,ce){if(ce<1)return"";for(var he="";ce>1;)ce&1&&(he+=de),ce>>=1,de+=de;return he+de}function N(de,ce,he,V){var J=ce.href,ue=ce.title?_(ce.title):null,ve=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){V.state.inLink=!0;var ke={type:"link",raw:he,href:J,title:ue,text:ve,tokens:V.inlineTokens(ve)};return V.state.inLink=!1,ke}return{type:"image",raw:he,href:J,title:ue,text:_(ve)}}function z(de,ce){var he=de.match(/^(\s+)(?:```)/);if(he===null)return ce;var V=he[1];return ce.split(`
`).map(function(J){var ue=J.match(/^\s+/);if(ue===null)return J;var ve=ue[0];return ve.length>=V.length?J.slice(V.length):J}).join(`
`)}var x=function(){function de(he){this.options=he||me.defaults}var ce=de.prototype;return ce.space=function(V){var J=this.rules.block.newline.exec(V);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},ce.code=function(V){var J=this.rules.block.code.exec(V);if(J){var ue=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:g(ue,`
`)}}},ce.fences=function(V){var J=this.rules.block.fences.exec(V);if(J){var ue=J[0],ve=z(ue,J[3]||"");return{type:"code",raw:ue,lang:J[2]?J[2].trim():J[2],text:ve}}},ce.heading=function(V){var J=this.rules.block.heading.exec(V);if(J){var ue=J[2].trim();if(/#$/.test(ue)){var ve=g(ue,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(ue=ve.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:ue,tokens:this.lexer.inline(ue)}}},ce.hr=function(V){var J=this.rules.block.hr.exec(V);if(J)return{type:"hr",raw:J[0]}},ce.blockquote=function(V){var J=this.rules.block.blockquote.exec(V);if(J){var ue=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},ce.list=function(V){var J=this.rules.block.list.exec(V);if(J){var ue,ve,ke,we,Te,Oe,xe,W,H,X,K,pe,Ee=J[1].trim(),Me=Ee.length>1,Ve={type:"list",raw:"",ordered:Me,start:Me?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Me?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Me?Ee:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(pe=!1,!(!(J=Ke.exec(V))||this.rules.block.hr.test(V)));){if(ue=J[0],V=V.substring(ue.length),W=J[2].split(`
`,1)[0],H=V.split(`
`,1)[0],this.options.pedantic?(we=2,K=W.trimLeft()):(we=J[2].search(/[^ ]/),we=we>4?1:we,K=W.slice(we),we+=J[1].length),Oe=!1,!W&&/^ *$/.test(H)&&(ue+=H+`
`,V=V.substring(H.length+1),pe=!0),!pe)for(var tt=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,we-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,we-1)+"}#");V&&(X=V.split(`
`,1)[0],W=X,this.options.pedantic&&(W=W.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(W)||rt.test(W)||tt.test(W)||st.test(V)));){if(W.search(/[^ ]/)>=we||!W.trim())K+=`
`+W.slice(we);else if(!Oe)K+=`
`+W;else break;!Oe&&!W.trim()&&(Oe=!0),ue+=X+`
`,V=V.substring(X.length+1)}Ve.loose||(xe?Ve.loose=!0:/\n *\n *$/.test(ue)&&(xe=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(K),ve&&(ke=ve[0]!=="[ ] ",K=K.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ue,task:!!ve,checked:ke,loose:!1,text:K}),Ve.raw+=ue}Ve.items[Ve.items.length-1].raw=ue.trimRight(),Ve.items[Ve.items.length-1].text=K.trimRight(),Ve.raw=Ve.raw.trimRight();var Pe=Ve.items.length;for(Te=0;Te<Pe;Te++){this.lexer.state.top=!1,Ve.items[Te].tokens=this.lexer.blockTokens(Ve.items[Te].text,[]);var ze=Ve.items[Te].tokens.filter(function(je){return je.type==="space"}),Ae=ze.every(function(je){for(var ne=je.raw.split(""),oe=0,Ie=R(ne),qe;!(qe=Ie()).done;){var Je=qe.value;if(Je===`
`&&(oe+=1),oe>1)return!0}return!1});!Ve.loose&&ze.length&&Ae&&(Ve.loose=!0,Ve.items[Te].loose=!0)}return Ve}},ce.html=function(V){var J=this.rules.block.html.exec(V);if(J){var ue={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(J[0]):_(J[0]);ue.type="paragraph",ue.text=ve,ue.tokens=this.lexer.inline(ve)}return ue}},ce.def=function(V){var J=this.rules.block.def.exec(V);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var ue=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:J[0],href:J[2],title:J[3]}}},ce.table=function(V){var J=this.rules.block.table.exec(V);if(J){var ue={type:"table",header:D(J[1]).map(function(xe){return{text:xe}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=J[0];var ve=ue.align.length,ke,we,Te,Oe;for(ke=0;ke<ve;ke++)/^ *-+: *$/.test(ue.align[ke])?ue.align[ke]="right":/^ *:-+: *$/.test(ue.align[ke])?ue.align[ke]="center":/^ *:-+ *$/.test(ue.align[ke])?ue.align[ke]="left":ue.align[ke]=null;for(ve=ue.rows.length,ke=0;ke<ve;ke++)ue.rows[ke]=D(ue.rows[ke],ue.header.length).map(function(xe){return{text:xe}});for(ve=ue.header.length,we=0;we<ve;we++)ue.header[we].tokens=this.lexer.inline(ue.header[we].text);for(ve=ue.rows.length,we=0;we<ve;we++)for(Oe=ue.rows[we],Te=0;Te<Oe.length;Te++)Oe[Te].tokens=this.lexer.inline(Oe[Te].text);return ue}}},ce.lheading=function(V){var J=this.rules.block.lheading.exec(V);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:this.lexer.inline(J[1])}},ce.paragraph=function(V){var J=this.rules.block.paragraph.exec(V);if(J){var ue=J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1];return{type:"paragraph",raw:J[0],text:ue,tokens:this.lexer.inline(ue)}}},ce.text=function(V){var J=this.rules.block.text.exec(V);if(J)return{type:"text",raw:J[0],text:J[0],tokens:this.lexer.inline(J[0])}},ce.escape=function(V){var J=this.rules.inline.escape.exec(V);if(J)return{type:"escape",raw:J[0],text:_(J[1])}},ce.tag=function(V){var J=this.rules.inline.tag.exec(V);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):_(J[0]):J[0]}},ce.link=function(V){var J=this.rules.inline.link.exec(V);if(J){var ue=J[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var ve=g(ue.slice(0,-1),"\\");if((ue.length-ve.length)%2===0)return}else{var ke=f(J[2],"()");if(ke>-1){var we=J[0].indexOf("!")===0?5:4,Te=we+J[1].length+ke;J[2]=J[2].substring(0,ke),J[0]=J[0].substring(0,Te).trim(),J[3]=""}}var Oe=J[2],xe="";if(this.options.pedantic){var W=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);W&&(Oe=W[1],xe=W[3])}else xe=J[3]?J[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(ue)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),N(J,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},ce.reflink=function(V,J){var ue;if((ue=this.rules.inline.reflink.exec(V))||(ue=this.rules.inline.nolink.exec(V))){var ve=(ue[2]||ue[1]).replace(/\s+/g," ");if(ve=J[ve.toLowerCase()],!ve||!ve.href){var ke=ue[0].charAt(0);return{type:"text",raw:ke,text:ke}}return N(ue,ve,ue[0],this.lexer)}},ce.emStrong=function(V,J,ue){ue===void 0&&(ue="");var ve=this.rules.inline.emStrong.lDelim.exec(V);if(ve&&!(ve[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=ve[1]||ve[2]||"";if(!ke||ke&&(ue===""||this.rules.inline.punctuation.exec(ue))){var we=ve[0].length-1,Te,Oe,xe=we,W=0,H=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,J=J.slice(-1*V.length+we);(ve=H.exec(J))!=null;)if(Te=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Te){if(Oe=Te.length,ve[3]||ve[4]){xe+=Oe;continue}else if((ve[5]||ve[6])&&we%3&&!((we+Oe)%3)){W+=Oe;continue}if(xe-=Oe,!(xe>0)){if(Oe=Math.min(Oe,Oe+xe+W),Math.min(we,Oe)%2){var X=V.slice(1,we+ve.index+Oe);return{type:"em",raw:V.slice(0,we+ve.index+Oe+1),text:X,tokens:this.lexer.inlineTokens(X)}}var K=V.slice(2,we+ve.index+Oe-1);return{type:"strong",raw:V.slice(0,we+ve.index+Oe+1),text:K,tokens:this.lexer.inlineTokens(K)}}}}}},ce.codespan=function(V){var J=this.rules.inline.code.exec(V);if(J){var ue=J[2].replace(/\n/g," "),ve=/[^ ]/.test(ue),ke=/^ /.test(ue)&&/ $/.test(ue);return ve&&ke&&(ue=ue.substring(1,ue.length-1)),ue=_(ue,!0),{type:"codespan",raw:J[0],text:ue}}},ce.br=function(V){var J=this.rules.inline.br.exec(V);if(J)return{type:"br",raw:J[0]}},ce.del=function(V){var J=this.rules.inline.del.exec(V);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2])}},ce.autolink=function(V,J){var ue=this.rules.inline.autolink.exec(V);if(ue){var ve,ke;return ue[2]==="@"?(ve=_(this.options.mangle?J(ue[1]):ue[1]),ke="mailto:"+ve):(ve=_(ue[1]),ke=ve),{type:"link",raw:ue[0],text:ve,href:ke,tokens:[{type:"text",raw:ve,text:ve}]}}},ce.url=function(V,J){var ue;if(ue=this.rules.inline.url.exec(V)){var ve,ke;if(ue[2]==="@")ve=_(this.options.mangle?J(ue[0]):ue[0]),ke="mailto:"+ve;else{var we;do we=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(we!==ue[0]);ve=_(ue[0]),ue[1]==="www."?ke="http://"+ve:ke=ve}return{type:"link",raw:ue[0],text:ve,href:ke,tokens:[{type:"text",raw:ve,text:ve}]}}},ce.inlineText=function(V,J){var ue=this.rules.inline.text.exec(V);if(ue){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):_(ue[0]):ue[0]:ve=_(this.options.smartypants?J(ue[0]):ue[0]),{type:"text",raw:ue[0],text:ve}}},de}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=i(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=i(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=i(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=i(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=i(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=i(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=m({},M),M.gfm=m({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=i(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=i(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=m({},M.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var k={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};k._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",k.punctuation=i(k.punctuation).replace(/punctuation/g,k._punctuation).getRegex(),k.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,k.escapedEmSt=/\\\*|\\_/g,k._comment=i(M._comment).replace("(?:-->|$)","-->").getRegex(),k.emStrong.lDelim=i(k.emStrong.lDelim).replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimAst=i(k.emStrong.rDelimAst,"g").replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimUnd=i(k.emStrong.rDelimUnd,"g").replace(/punct/g,k._punctuation).getRegex(),k._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,k._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,k._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,k.autolink=i(k.autolink).replace("scheme",k._scheme).replace("email",k._email).getRegex(),k._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,k.tag=i(k.tag).replace("comment",k._comment).replace("attribute",k._attribute).getRegex(),k._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,k._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,k._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,k.link=i(k.link).replace("label",k._label).replace("href",k._href).replace("title",k._title).getRegex(),k.reflink=i(k.reflink).replace("label",k._label).replace("ref",M._label).getRegex(),k.nolink=i(k.nolink).replace("ref",M._label).getRegex(),k.reflinkSearch=i(k.reflinkSearch,"g").replace("reflink",k.reflink).replace("nolink",k.nolink).getRegex(),k.normal=m({},k),k.pedantic=m({},k.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",k._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",k._label).getRegex()}),k.gfm=m({},k.normal,{escape:i(k.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),k.gfm.url=i(k.gfm.url,"i").replace("email",k.gfm._extended_email).getRegex(),k.breaks=m({},k.gfm,{br:i(k.br).replace("{2,}","*").getRegex(),text:i(k.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(de){var ce="",he,V,J=de.length;for(he=0;he<J;he++)V=de.charCodeAt(he),Math.random()>.5&&(V="x"+V.toString(16)),ce+="&#"+V+";";return ce}var q=function(){function de(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||me.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:M.normal,inline:k.normal};this.options.pedantic?(V.block=M.pedantic,V.inline=k.pedantic):this.options.gfm&&(V.block=M.gfm,this.options.breaks?V.inline=k.breaks:V.inline=k.gfm),this.tokenizer.rules=V}de.lex=function(V,J){var ue=new de(J);return ue.lex(V)},de.lexInline=function(V,J){var ue=new de(J);return ue.inlineTokens(V)};var ce=de.prototype;return ce.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},ce.blockTokens=function(V,J){var ue=this;J===void 0&&(J=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(xe,W,H){return W+"    ".repeat(H.length)});for(var ve,ke,we,Te;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(xe){return(ve=xe.call({lexer:ue},V,J))?(V=V.substring(ve.raw.length),J.push(ve),!0):!1}))){if(ve=this.tokenizer.space(V)){V=V.substring(ve.raw.length),ve.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(ve);continue}if(ve=this.tokenizer.code(V)){V=V.substring(ve.raw.length),ke=J[J.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ve.raw,ke.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):J.push(ve);continue}if(ve=this.tokenizer.fences(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.heading(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.hr(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.blockquote(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.list(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.html(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.def(V)){V=V.substring(ve.raw.length),ke=J[J.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ve.raw,ke.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.lheading(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(we=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var xe=1/0,W=V.slice(1),H=void 0;ue.options.extensions.startBlock.forEach(function(X){H=X.call({lexer:this},W),typeof H=="number"&&H>=0&&(xe=Math.min(xe,H))}),xe<1/0&&xe>=0&&(we=V.substring(0,xe+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(we))){ke=J[J.length-1],Te&&ke.type==="paragraph"?(ke.raw+=`
`+ve.raw,ke.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):J.push(ve),Te=we.length!==V.length,V=V.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(V)){V=V.substring(ve.raw.length),ke=J[J.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+ve.raw,ke.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):J.push(ve);continue}if(V){var Oe="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return this.state.top=!0,J},ce.inline=function(V,J){return J===void 0&&(J=[]),this.inlineQueue.push({src:V,tokens:J}),J},ce.inlineTokens=function(V,J){var ue=this;J===void 0&&(J=[]);var ve,ke,we,Te=V,Oe,xe,W;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Te))!=null;)H.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Te=Te.slice(0,Oe.index)+"["+T("a",Oe[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Te))!=null;)Te=Te.slice(0,Oe.index)+"["+T("a",Oe[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Te))!=null;)Te=Te.slice(0,Oe.index)+"++"+Te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(xe||(W=""),xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(K){return(ve=K.call({lexer:ue},V,J))?(V=V.substring(ve.raw.length),J.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.tag(V)){V=V.substring(ve.raw.length),ke=J[J.length-1],ke&&ve.type==="text"&&ke.type==="text"?(ke.raw+=ve.raw,ke.text+=ve.text):J.push(ve);continue}if(ve=this.tokenizer.link(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(ve.raw.length),ke=J[J.length-1],ke&&ve.type==="text"&&ke.type==="text"?(ke.raw+=ve.raw,ke.text+=ve.text):J.push(ve);continue}if(ve=this.tokenizer.emStrong(V,Te,W)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.codespan(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.br(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.del(V)){V=V.substring(ve.raw.length),J.push(ve);continue}if(ve=this.tokenizer.autolink(V,U)){V=V.substring(ve.raw.length),J.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(V,U))){V=V.substring(ve.raw.length),J.push(ve);continue}if(we=V,this.options.extensions&&this.options.extensions.startInline&&function(){var K=1/0,pe=V.slice(1),Ee=void 0;ue.options.extensions.startInline.forEach(function(Me){Ee=Me.call({lexer:this},pe),typeof Ee=="number"&&Ee>=0&&(K=Math.min(K,Ee))}),K<1/0&&K>=0&&(we=V.substring(0,K+1))}(),ve=this.tokenizer.inlineText(we,O)){V=V.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(W=ve.raw.slice(-1)),xe=!0,ke=J[J.length-1],ke&&ke.type==="text"?(ke.raw+=ve.raw,ke.text+=ve.text):J.push(ve);continue}if(V){var X="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return J},P(de,null,[{key:"rules",get:function(){return{block:M,inline:k}}}]),de}(),ie=function(){function de(he){this.options=he||me.defaults}var ce=de.prototype;return ce.code=function(V,J,ue){var ve=(J||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(V,ve);ke!=null&&ke!==V&&(ue=!0,V=ke)}return V=V.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+_(ve,!0)+'">'+(ue?V:_(V,!0))+`</code></pre>
`:"<pre><code>"+(ue?V:_(V,!0))+`</code></pre>
`},ce.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ce.html=function(V){return V},ce.heading=function(V,J,ue,ve){if(this.options.headerIds){var ke=this.options.headerPrefix+ve.slug(ue);return"<h"+J+' id="'+ke+'">'+V+"</h"+J+`>
`}return"<h"+J+">"+V+"</h"+J+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(V,J,ue){var ve=J?"ol":"ul",ke=J&&ue!==1?' start="'+ue+'"':"";return"<"+ve+ke+`>
`+V+"</"+ve+`>
`},ce.listitem=function(V){return"<li>"+V+`</li>
`},ce.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(V){return"<p>"+V+`</p>
`},ce.table=function(V,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+J+`</table>
`},ce.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ce.tablecell=function(V,J){var ue=J.header?"th":"td",ve=J.align?"<"+ue+' align="'+J.align+'">':"<"+ue+">";return ve+V+("</"+ue+`>
`)},ce.strong=function(V){return"<strong>"+V+"</strong>"},ce.em=function(V){return"<em>"+V+"</em>"},ce.codespan=function(V){return"<code>"+V+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(V){return"<del>"+V+"</del>"},ce.link=function(V,J,ue){if(V=a(this.options.sanitize,this.options.baseUrl,V),V===null)return ue;var ve='<a href="'+_(V)+'"';return J&&(ve+=' title="'+J+'"'),ve+=">"+ue+"</a>",ve},ce.image=function(V,J,ue){if(V=a(this.options.sanitize,this.options.baseUrl,V),V===null)return ue;var ve='<img src="'+V+'" alt="'+ue+'"';return J&&(ve+=' title="'+J+'"'),ve+=this.options.xhtml?"/>":">",ve},ce.text=function(V){return V},de}(),Z=function(){function de(){}var ce=de.prototype;return ce.strong=function(V){return V},ce.em=function(V){return V},ce.codespan=function(V){return V},ce.del=function(V){return V},ce.html=function(V){return V},ce.text=function(V){return V},ce.link=function(V,J,ue){return""+ue},ce.image=function(V,J,ue){return""+ue},ce.br=function(){return""},de}(),Q=function(){function de(){this.seen={}}var ce=de.prototype;return ce.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(V,J){var ue=V,ve=0;if(this.seen.hasOwnProperty(ue)){ve=this.seen[V];do ve++,ue=V+"-"+ve;while(this.seen.hasOwnProperty(ue))}return J||(this.seen[V]=ve,this.seen[ue]=0),ue},ce.slug=function(V,J){J===void 0&&(J={});var ue=this.serialize(V);return this.getNextSafeSlug(ue,J.dryrun)},de}(),Y=function(){function de(he){this.options=he||me.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new Q}de.parse=function(V,J){var ue=new de(J);return ue.parse(V)},de.parseInline=function(V,J){var ue=new de(J);return ue.parseInline(V)};var ce=de.prototype;return ce.parse=function(V,J){J===void 0&&(J=!0);var ue="",ve,ke,we,Te,Oe,xe,W,H,X,K,pe,Ee,Me,Ve,Ke,tt,st,lt,rt,Pe=V.length;for(ve=0;ve<Pe;ve++){if(K=V[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[K.type]&&(rt=this.options.extensions.renderers[K.type].call({parser:this},K),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(K.type))){ue+=rt||"";continue}switch(K.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(K.tokens),K.depth,b(this.parseInline(K.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(K.text,K.lang,K.escaped);continue}case"table":{for(H="",W="",Te=K.header.length,ke=0;ke<Te;ke++)W+=this.renderer.tablecell(this.parseInline(K.header[ke].tokens),{header:!0,align:K.align[ke]});for(H+=this.renderer.tablerow(W),X="",Te=K.rows.length,ke=0;ke<Te;ke++){for(xe=K.rows[ke],W="",Oe=xe.length,we=0;we<Oe;we++)W+=this.renderer.tablecell(this.parseInline(xe[we].tokens),{header:!1,align:K.align[we]});X+=this.renderer.tablerow(W)}ue+=this.renderer.table(H,X);continue}case"blockquote":{X=this.parse(K.tokens),ue+=this.renderer.blockquote(X);continue}case"list":{for(pe=K.ordered,Ee=K.start,Me=K.loose,Te=K.items.length,X="",ke=0;ke<Te;ke++)Ke=K.items[ke],tt=Ke.checked,st=Ke.task,Ve="",Ke.task&&(lt=this.renderer.checkbox(tt),Me?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=lt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=lt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:lt}):Ve+=lt),Ve+=this.parse(Ke.tokens,Me),X+=this.renderer.listitem(Ve,st,tt);ue+=this.renderer.list(X,pe,Ee);continue}case"html":{ue+=this.renderer.html(K.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(K.tokens));continue}case"text":{for(X=K.tokens?this.parseInline(K.tokens):K.text;ve+1<Pe&&V[ve+1].type==="text";)K=V[++ve],X+=`
`+(K.tokens?this.parseInline(K.tokens):K.text);ue+=J?this.renderer.paragraph(X):X;continue}default:{var ze='Token with "'+K.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return ue},ce.parseInline=function(V,J){J=J||this.renderer;var ue="",ve,ke,we,Te=V.length;for(ve=0;ve<Te;ve++){if(ke=V[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(we=this.options.extensions.renderers[ke.type].call({parser:this},ke),we!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){ue+=we||"";continue}switch(ke.type){case"escape":{ue+=J.text(ke.text);break}case"html":{ue+=J.html(ke.text);break}case"link":{ue+=J.link(ke.href,ke.title,this.parseInline(ke.tokens,J));break}case"image":{ue+=J.image(ke.href,ke.title,ke.text);break}case"strong":{ue+=J.strong(this.parseInline(ke.tokens,J));break}case"em":{ue+=J.em(this.parseInline(ke.tokens,J));break}case"codespan":{ue+=J.codespan(ke.text);break}case"br":{ue+=J.br();break}case"del":{ue+=J.del(this.parseInline(ke.tokens,J));break}case"text":{ue+=J.text(ke.text);break}default:{var Oe='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return ue},de}();function ae(de,ce,he){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof ce=="function"&&(he=ce,ce=null),ce=m({},ae.defaults,ce||{}),S(ce),he){var V=ce.highlight,J;try{J=q.lex(de,ce)}catch(Te){return he(Te)}var ue=function(Oe){var xe;if(!Oe)try{ce.walkTokens&&ae.walkTokens(J,ce.walkTokens),xe=Y.parse(J,ce)}catch(W){Oe=W}return ce.highlight=V,Oe?he(Oe):he(null,xe)};if(!V||V.length<3||(delete ce.highlight,!J.length))return ue();var ve=0;ae.walkTokens(J,function(Te){Te.type==="code"&&(ve++,setTimeout(function(){V(Te.text,Te.lang,function(Oe,xe){if(Oe)return ue(Oe);xe!=null&&xe!==Te.text&&(Te.text=xe,Te.escaped=!0),ve--,ve===0&&ue()})},0))}),ve===0&&ue();return}function ke(Te){if(Te.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+_(Te.message+"",!0)+"</pre>";throw Te}try{var we=q.lex(de,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ae.walkTokens(we,ce.walkTokens)).then(function(){return Y.parse(we,ce)}).catch(ke);ae.walkTokens(we,ce.walkTokens)}return Y.parse(we,ce)}catch(Te){ke(Te)}}ae.options=ae.setOptions=function(de){return m(ae.defaults,de),w(ae.defaults),ae},ae.getDefaults=A,ae.defaults=me.defaults,ae.use=function(){for(var de=arguments.length,ce=new Array(de),he=0;he<de;he++)ce[he]=arguments[he];var V=m.apply(void 0,[{}].concat(ce)),J=ae.defaults.extensions||{renderers:{},childTokens:{}},ue;ce.forEach(function(ve){if(ve.extensions&&(ue=!0,ve.extensions.forEach(function(we){if(!we.name)throw new Error("extension name required");if(we.renderer){var Te=J.renderers?J.renderers[we.name]:null;Te?J.renderers[we.name]=function(){for(var Oe=arguments.length,xe=new Array(Oe),W=0;W<Oe;W++)xe[W]=arguments[W];var H=we.renderer.apply(this,xe);return H===!1&&(H=Te.apply(this,xe)),H}:J.renderers[we.name]=we.renderer}if(we.tokenizer){if(!we.level||we.level!=="block"&&we.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[we.level]?J[we.level].unshift(we.tokenizer):J[we.level]=[we.tokenizer],we.start&&(we.level==="block"?J.startBlock?J.startBlock.push(we.start):J.startBlock=[we.start]:we.level==="inline"&&(J.startInline?J.startInline.push(we.start):J.startInline=[we.start]))}we.childTokens&&(J.childTokens[we.name]=we.childTokens)})),ve.renderer&&function(){var we=ae.defaults.renderer||new ie,Te=function(W){var H=we[W];we[W]=function(){for(var X=arguments.length,K=new Array(X),pe=0;pe<X;pe++)K[pe]=arguments[pe];var Ee=ve.renderer[W].apply(we,K);return Ee===!1&&(Ee=H.apply(we,K)),Ee}};for(var Oe in ve.renderer)Te(Oe);V.renderer=we}(),ve.tokenizer&&function(){var we=ae.defaults.tokenizer||new x,Te=function(W){var H=we[W];we[W]=function(){for(var X=arguments.length,K=new Array(X),pe=0;pe<X;pe++)K[pe]=arguments[pe];var Ee=ve.tokenizer[W].apply(we,K);return Ee===!1&&(Ee=H.apply(we,K)),Ee}};for(var Oe in ve.tokenizer)Te(Oe);V.tokenizer=we}(),ve.walkTokens){var ke=ae.defaults.walkTokens;V.walkTokens=function(we){var Te=[];return Te.push(ve.walkTokens.call(this,we)),ke&&(Te=Te.concat(ke.call(this,we))),Te}}ue&&(V.extensions=J),ae.setOptions(V)})},ae.walkTokens=function(de,ce){for(var he=[],V=function(){var ke=ue.value;switch(he=he.concat(ce.call(ae,ke)),ke.type){case"table":{for(var we=R(ke.header),Te;!(Te=we()).done;){var Oe=Te.value;he=he.concat(ae.walkTokens(Oe.tokens,ce))}for(var xe=R(ke.rows),W;!(W=xe()).done;)for(var H=W.value,X=R(H),K;!(K=X()).done;){var pe=K.value;he=he.concat(ae.walkTokens(pe.tokens,ce))}break}case"list":{he=he.concat(ae.walkTokens(ke.items,ce));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[ke.type]?ae.defaults.extensions.childTokens[ke.type].forEach(function(Ee){he=he.concat(ae.walkTokens(ke[Ee],ce))}):ke.tokens&&(he=he.concat(ae.walkTokens(ke.tokens,ce)))}},J=R(de),ue;!(ue=J()).done;)V();return he},ae.parseInline=function(de,ce){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");ce=m({},ae.defaults,ce||{}),S(ce);try{var he=q.lexInline(de,ce);return ce.walkTokens&&ae.walkTokens(he,ce.walkTokens),Y.parseInline(he,ce)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+_(V.message+"",!0)+"</pre>";throw V}},ae.Parser=Y,ae.parser=Y.parse,ae.Renderer=ie,ae.TextRenderer=Z,ae.Lexer=q,ae.lexer=q.lex,ae.Tokenizer=x,ae.Slugger=Q,ae.parse=ae;var ee=ae.options,fe=ae.setOptions,re=ae.use,G=ae.walkTokens,B=ae.parseInline,se=ae,ye=Y.parse,le=q.lex;me.Lexer=q,me.Parser=Y,me.Renderer=ie,me.Slugger=Q,me.TextRenderer=Z,me.Tokenizer=x,me.getDefaults=A,me.lexer=le,me.marked=ae,me.options=ee,me.parse=se,me.parseInline=B,me.parser=ye,me.setOptions=fe,me.use=re,me.walkTokens=G,Object.defineProperty(me,"__esModule",{value:!0})}),define(Ce[162],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function P(l){const b=R(l);if(b&&b.length>0)return new Uint32Array(b)}e.getKoreanAltChars=P;let F=0;const p=new Uint32Array(10);function R(l){if(F=0,A(l,I,4352),F>0||(A(l,v,4449),F>0)||(A(l,y,4520),F>0)||(A(l,_,12593),F))return p.subarray(0,F);if(l>=44032&&l<=55203){const b=l-44032,o=b%588,i=Math.floor(b/588),n=Math.floor(o/28),r=o%28-1;if(i<I.length?A(i,I,0):4352+i-12593<_.length&&A(4352+i,_,12593),n<v.length?A(n,v,0):4449+n-12593<_.length&&A(4449+n-12593,_,12593),r>=0&&(r<y.length?A(r,y,0):4520+r-12593<_.length&&A(4520+r-12593,_,12593)),F>0)return p.subarray(0,F)}}function A(l,b,o){l>=o&&l<o+b.length&&w(b[l-o])}function w(l){l!==0&&(p[F++]=l&255,l>>8&&(p[F++]=l>>8&255),l>>16&&(p[F++]=l>>16&255))}var E;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})(E||(E={}));var C;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(C||(C={}));var L;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(L||(L={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),v=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),_=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[76],De([1,0,28]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new P.LRUCache(1e4);function p(C){return E(C,"NFC",F)}e.normalizeNFC=p;const R=new P.LRUCache(1e4);function A(C){return E(C,"NFD",R)}e.normalizeNFD=A;const w=/[^\u0000-\u0080]/;function E(C,L,I){if(!C)return C;const v=I.get(C);if(v)return v;let y;return w.test(C)?y=C.normalize(L):y=C,I.set(C,y),y}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(L){return A(L).replace(C,"")}}()}),define(Ce[122],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function P(w,E,C){return Math.min(Math.max(w,E),C)}e.clamp=P;function F(w,E){return(E+w%E)%E}e.rot=F;class p{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=p;class R{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class A{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const C=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=C,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),function(){function me(p){const R=[];typeof p=="number"&&R.push("code/timeOrigin",p);function A(E){R.push(E,Date.now())}function w(){const E=[];for(let C=0;C<R.length;C+=2)E.push({name:R[C],startTime:R[C+1]});return E}return{mark:A,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(p+A.startTime)});return R}};if(typeof process=="object"){const p=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function P(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=P(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var F in P)(typeof exports=="object"?exports:me)[F]=P[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function P(F){if(e[F])return e[F].exports;var p=e[F]={i:F,l:!1,exports:{}};return me[F].call(p.exports,p,p.exports,P),p.l=!0,p.exports}return P.m=me,P.c=e,P.d=function(F,p,R){P.o(F,p)||Object.defineProperty(F,p,{enumerable:!0,get:R})},P.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},P.t=function(F,p){if(1&p&&(F=P(F)),8&p||4&p&&typeof F=="object"&&F&&F.__esModule)return F;var R=Object.create(null);if(P.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:F}),2&p&&typeof F!="string")for(var A in F)P.d(R,A,function(w){return F[w]}.bind(null,A));return R},P.n=function(F){var p=F&&F.__esModule?function(){return F.default}:function(){return F};return P.d(p,"a",p),p},P.o=function(F,p){return Object.prototype.hasOwnProperty.call(F,p)},P.p="",P(P.s=0)}([function(me,e,P){(function(F){var p;e=me.exports=re,p=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],E=e.src=[],C=0,L=C++;E[L]="0|[1-9]\\d*";var I=C++;E[I]="[0-9]+";var v=C++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=C++;E[y]="("+E[L]+")\\.("+E[L]+")\\.("+E[L]+")";var _=C++;E[_]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var l=C++;E[l]="(?:"+E[L]+"|"+E[v]+")";var b=C++;E[b]="(?:"+E[I]+"|"+E[v]+")";var o=C++;E[o]="(?:-("+E[l]+"(?:\\."+E[l]+")*))";var i=C++;E[i]="(?:-?("+E[b]+"(?:\\."+E[b]+")*))";var n=C++;E[n]="[0-9A-Za-z-]+";var r=C++;E[r]="(?:\\+("+E[n]+"(?:\\."+E[n]+")*))";var a=C++,t="v?"+E[y]+E[o]+"?"+E[r]+"?";E[a]="^"+t+"$";var h="[v=\\s]*"+E[_]+E[i]+"?"+E[r]+"?",u=C++;E[u]="^"+h+"$";var s=C++;E[s]="((?:<|>)?=?)";var c=C++;E[c]=E[I]+"|x|X|\\*";var d=C++;E[d]=E[L]+"|x|X|\\*";var m=C++;E[m]="[v=\\s]*("+E[d]+")(?:\\.("+E[d]+")(?:\\.("+E[d]+")(?:"+E[o]+")?"+E[r]+"?)?)?";var D=C++;E[D]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[i]+")?"+E[r]+"?)?)?";var g=C++;E[g]="^"+E[s]+"\\s*"+E[m]+"$";var f=C++;E[f]="^"+E[s]+"\\s*"+E[D]+"$";var S=C++;E[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=C++;E[T]="(?:~>?)";var N=C++;E[N]="(\\s*)"+E[T]+"\\s+",w[N]=new RegExp(E[N],"g");var z=C++;E[z]="^"+E[T]+E[m]+"$";var x=C++;E[x]="^"+E[T]+E[D]+"$";var M=C++;E[M]="(?:\\^)";var k=C++;E[k]="(\\s*)"+E[M]+"\\s+",w[k]=new RegExp(E[k],"g");var O=C++;E[O]="^"+E[M]+E[m]+"$";var U=C++;E[U]="^"+E[M]+E[D]+"$";var q=C++;E[q]="^"+E[s]+"\\s*("+h+")$|^$";var ie=C++;E[ie]="^"+E[s]+"\\s*("+t+")$|^$";var Z=C++;E[Z]="(\\s*)"+E[s]+"\\s*("+h+"|"+E[m]+")",w[Z]=new RegExp(E[Z],"g");var Q=C++;E[Q]="^\\s*("+E[m]+")\\s+-\\s+("+E[m]+")\\s*$";var Y=C++;E[Y]="^\\s*("+E[D]+")\\s+-\\s+("+E[D]+")\\s*$";var ae=C++;E[ae]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)p(ee,E[ee]),w[ee]||(w[ee]=new RegExp(E[ee]));function fe(H,X){if(H instanceof re)return H;if(typeof H!="string"||H.length>R||!(X?w[u]:w[a]).test(H))return null;try{return new re(H,X)}catch{return null}}function re(H,X){if(H instanceof re){if(H.loose===X)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof re))return new re(H,X);p("SemVer",H,X),this.loose=X;var K=H.trim().match(X?w[u]:w[a]);if(!K)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Ee=+pe;if(Ee>=0&&Ee<A)return Ee}return pe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=fe,e.valid=function(H,X){var K=fe(H,X);return K?K.version:null},e.clean=function(H,X){var K=fe(H.trim().replace(/^[=v]+/,""),X);return K?K.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(H){return p("SemVer.compare",this.version,this.loose,H),H instanceof re||(H=new re(H,this.loose)),this.compareMain(H)||this.comparePre(H)},re.prototype.compareMain=function(H){return H instanceof re||(H=new re(H,this.loose)),B(this.major,H.major)||B(this.minor,H.minor)||B(this.patch,H.patch)},re.prototype.comparePre=function(H){if(H instanceof re||(H=new re(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var X=0;do{var K=this.prerelease[X],pe=H.prerelease[X];if(p("prerelease compare",X,K,pe),K===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(K===void 0)return-1;if(K!==pe)return B(K,pe)}while(++X)},re.prototype.inc=function(H,X){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,X,K,pe){typeof K=="string"&&(pe=K,K=void 0);try{return new re(H,K).inc(X,pe).version}catch{return null}},e.diff=function(H,X){if(de(H,X))return null;var K=fe(H),pe=fe(X);if(K.prerelease.length||pe.prerelease.length){for(var Ee in K)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&K[Ee]!==pe[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in K)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&K[Ee]!==pe[Ee])return Ee},e.compareIdentifiers=B;var G=/^[0-9]+$/;function B(H,X){var K=G.test(H),pe=G.test(X);return K&&pe&&(H=+H,X=+X),K&&!pe?-1:pe&&!K?1:H<X?-1:H>X?1:0}function se(H,X,K){return new re(H,K).compare(new re(X,K))}function ye(H,X,K){return se(H,X,K)>0}function le(H,X,K){return se(H,X,K)<0}function de(H,X,K){return se(H,X,K)===0}function ce(H,X,K){return se(H,X,K)!==0}function he(H,X,K){return se(H,X,K)>=0}function V(H,X,K){return se(H,X,K)<=0}function J(H,X,K,pe){var Ee;switch(X){case"===":typeof H=="object"&&(H=H.version),typeof K=="object"&&(K=K.version),Ee=H===K;break;case"!==":typeof H=="object"&&(H=H.version),typeof K=="object"&&(K=K.version),Ee=H!==K;break;case"":case"=":case"==":Ee=de(H,K,pe);break;case"!=":Ee=ce(H,K,pe);break;case">":Ee=ye(H,K,pe);break;case">=":Ee=he(H,K,pe);break;case"<":Ee=le(H,K,pe);break;case"<=":Ee=V(H,K,pe);break;default:throw new TypeError("Invalid operator: "+X)}return Ee}function ue(H,X){if(H instanceof ue){if(H.loose===X)return H;H=H.value}if(!(this instanceof ue))return new ue(H,X);p("comparator",H,X),this.loose=X,this.parse(H),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(H,X){return B(X,H)},e.major=function(H,X){return new re(H,X).major},e.minor=function(H,X){return new re(H,X).minor},e.patch=function(H,X){return new re(H,X).patch},e.compare=se,e.compareLoose=function(H,X){return se(H,X,!0)},e.rcompare=function(H,X,K){return se(X,H,K)},e.sort=function(H,X){return H.sort(function(K,pe){return e.compare(K,pe,X)})},e.rsort=function(H,X){return H.sort(function(K,pe){return e.rcompare(K,pe,X)})},e.gt=ye,e.lt=le,e.eq=de,e.neq=ce,e.gte=he,e.lte=V,e.cmp=J,e.Comparator=ue;var ve={};function ke(H,X){if(H instanceof ke)return H.loose===X?H:new ke(H.raw,X);if(H instanceof ue)return new ke(H.value,X);if(!(this instanceof ke))return new ke(H,X);if(this.loose=X,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function we(H){return!H||H.toLowerCase()==="x"||H==="*"}function Te(H,X,K,pe,Ee,Me,Ve,Ke,tt,st,lt,rt,Pe){return((X=we(K)?"":we(pe)?">="+K+".0.0":we(Ee)?">="+K+"."+pe+".0":">="+X)+" "+(Ke=we(tt)?"":we(st)?"<"+(+tt+1)+".0.0":we(lt)?"<"+tt+"."+(+st+1)+".0":rt?"<="+tt+"."+st+"."+lt+"-"+rt:"<="+Ke)).trim()}function Oe(H,X){for(var K=0;K<H.length;K++)if(!H[K].test(X))return!1;if(X.prerelease.length){for(K=0;K<H.length;K++)if(p(H[K].semver),H[K].semver!==ve&&H[K].semver.prerelease.length>0){var pe=H[K].semver;if(pe.major===X.major&&pe.minor===X.minor&&pe.patch===X.patch)return!0}return!1}return!0}function xe(H,X,K){try{X=new ke(X,K)}catch{return!1}return X.test(H)}function W(H,X,K,pe){var Ee,Me,Ve,Ke,tt;switch(H=new re(H,pe),X=new ke(X,pe),K){case">":Ee=ye,Me=V,Ve=le,Ke=">",tt=">=";break;case"<":Ee=le,Me=he,Ve=ye,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(H,X,pe))return!1;for(var st=0;st<X.set.length;++st){var lt=X.set[st],rt=null,Pe=null;if(lt.forEach(function(ze){ze.semver===ve&&(ze=new ue(">=0.0.0")),rt=rt||ze,Pe=Pe||ze,Ee(ze.semver,rt.semver,pe)?rt=ze:Ve(ze.semver,Pe.semver,pe)&&(Pe=ze)}),rt.operator===Ke||rt.operator===tt||(!Pe.operator||Pe.operator===Ke)&&Me(H,Pe.semver)||Pe.operator===tt&&Ve(H,Pe.semver))return!1}return!0}ue.prototype.parse=function(H){var X=this.loose?w[q]:w[ie],K=H.match(X);if(!K)throw new TypeError("Invalid comparator: "+H);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new re(K[2],this.loose):this.semver=ve},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(H){return p("Comparator.test",H,this.loose),this.semver===ve||(typeof H=="string"&&(H=new re(H,this.loose)),J(H,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(H,X){if(!(H instanceof ue))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ke(H.value,X),xe(this.value,K,X);if(H.operator==="")return K=new ke(this.value,X),xe(H.semver,K,X);var pe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Me=this.semver.version===H.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ke=J(this.semver,"<",H.semver,X)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),tt=J(this.semver,">",H.semver,X)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return pe||Ee||Me&&Ve||Ke||tt},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(H){var X=this.loose;H=H.trim(),p("range",H,X);var K=X?w[Y]:w[Q];H=H.replace(K,Te),p("hyphen replace",H),H=H.replace(w[Z],"$1$2$3"),p("comparator trim",H,w[Z]),H=(H=(H=H.replace(w[N],"$1~")).replace(w[k],"$1^")).split(/\s+/).join(" ");var pe=X?w[q]:w[ie],Ee=H.split(" ").map(function(Me){return function(Ve,Ke){return p("comp",Ve),Ve=function(tt,st){return tt.trim().split(/\s+/).map(function(lt){return function(rt,Pe){p("caret",rt,Pe);var ze=Pe?w[U]:w[O];return rt.replace(ze,function(Ae,je,ne,oe,Ie){var qe;return p("caret",rt,Ae,je,ne,oe,Ie),we(je)?qe="":we(ne)?qe=">="+je+".0.0 <"+(+je+1)+".0.0":we(oe)?qe=je==="0"?">="+je+"."+ne+".0 <"+je+"."+(+ne+1)+".0":">="+je+"."+ne+".0 <"+(+je+1)+".0.0":Ie?(p("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),qe=je==="0"?ne==="0"?">="+je+"."+ne+"."+oe+Ie+" <"+je+"."+ne+"."+(+oe+1):">="+je+"."+ne+"."+oe+Ie+" <"+je+"."+(+ne+1)+".0":">="+je+"."+ne+"."+oe+Ie+" <"+(+je+1)+".0.0"):(p("no pr"),qe=je==="0"?ne==="0"?">="+je+"."+ne+"."+oe+" <"+je+"."+ne+"."+(+oe+1):">="+je+"."+ne+"."+oe+" <"+je+"."+(+ne+1)+".0":">="+je+"."+ne+"."+oe+" <"+(+je+1)+".0.0"),p("caret return",qe),qe})}(lt,st)}).join(" ")}(Ve,Ke),p("caret",Ve),Ve=function(tt,st){return tt.trim().split(/\s+/).map(function(lt){return function(rt,Pe){var ze=Pe?w[x]:w[z];return rt.replace(ze,function(Ae,je,ne,oe,Ie){var qe;return p("tilde",rt,Ae,je,ne,oe,Ie),we(je)?qe="":we(ne)?qe=">="+je+".0.0 <"+(+je+1)+".0.0":we(oe)?qe=">="+je+"."+ne+".0 <"+je+"."+(+ne+1)+".0":Ie?(p("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),qe=">="+je+"."+ne+"."+oe+Ie+" <"+je+"."+(+ne+1)+".0"):qe=">="+je+"."+ne+"."+oe+" <"+je+"."+(+ne+1)+".0",p("tilde return",qe),qe})}(lt,st)}).join(" ")}(Ve,Ke),p("tildes",Ve),Ve=function(tt,st){return p("replaceXRanges",tt,st),tt.split(/\s+/).map(function(lt){return function(rt,Pe){rt=rt.trim();var ze=Pe?w[f]:w[g];return rt.replace(ze,function(Ae,je,ne,oe,Ie,qe){p("xRange",rt,Ae,je,ne,oe,Ie,qe);var Je=we(ne),nt=Je||we(oe),Ne=nt||we(Ie);return je==="="&&Ne&&(je=""),Je?Ae=je===">"||je==="<"?"<0.0.0":"*":je&&Ne?(nt&&(oe=0),Ne&&(Ie=0),je===">"?(je=">=",nt?(ne=+ne+1,oe=0,Ie=0):Ne&&(oe=+oe+1,Ie=0)):je==="<="&&(je="<",nt?ne=+ne+1:oe=+oe+1),Ae=je+ne+"."+oe+"."+Ie):nt?Ae=">="+ne+".0.0 <"+(+ne+1)+".0.0":Ne&&(Ae=">="+ne+"."+oe+".0 <"+ne+"."+(+oe+1)+".0"),p("xRange return",Ae),Ae})}(lt,st)}).join(" ")}(Ve,Ke),p("xrange",Ve),Ve=function(tt,st){return p("replaceStars",tt,st),tt.trim().replace(w[ae],"")}(Ve,Ke),p("stars",Ve),Ve}(Me,X)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Me){return!!Me.match(pe)})),Ee=Ee.map(function(Me){return new ue(Me,X)})},ke.prototype.intersects=function(H,X){if(!(H instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(pe){return H.set.some(function(Ee){return Ee.every(function(Me){return pe.intersects(Me,X)})})})})},e.toComparators=function(H,X){return new ke(H,X).set.map(function(K){return K.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new re(H,this.loose));for(var X=0;X<this.set.length;X++)if(Oe(this.set[X],H))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(H,X,K){var pe=null,Ee=null;try{var Me=new ke(X,K)}catch{return null}return H.forEach(function(Ve){Me.test(Ve)&&(pe&&Ee.compare(Ve)!==-1||(Ee=new re(pe=Ve,K)))}),pe},e.minSatisfying=function(H,X,K){var pe=null,Ee=null;try{var Me=new ke(X,K)}catch{return null}return H.forEach(function(Ve){Me.test(Ve)&&(pe&&Ee.compare(Ve)!==1||(Ee=new re(pe=Ve,K)))}),pe},e.validRange=function(H,X){try{return new ke(H,X).range||"*"}catch{return null}},e.ltr=function(H,X,K){return W(H,X,"<",K)},e.gtr=function(H,X,K){return W(H,X,">",K)},e.outside=W,e.prerelease=function(H,X){var K=fe(H,X);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(H,X,K){return H=new ke(H,K),X=new ke(X,K),H.intersects(X)},e.coerce=function(H){if(H instanceof re)return H;if(typeof H!="string")return null;var X=H.match(w[S]);return X==null?null:fe((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,P(1))},function(me,e){var P,F,p=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function w(b){if(P===setTimeout)return setTimeout(b,0);if((P===R||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:R}catch{P=R}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var E,C=[],L=!1,I=-1;function v(){L&&E&&(L=!1,E.length?C=E.concat(C):I=-1,C.length&&y())}function y(){if(!L){var b=w(v);L=!0;for(var o=C.length;o;){for(E=C,C=[];++I<o;)E&&E[I].run();I=-1,o=C.length}E=null,L=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(b)}}function _(b,o){this.fun=b,this.array=o}function l(){}p.nextTick=function(b){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];C.push(new _(b,o)),C.length!==1||L||w(y)},_.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=l,p.addListener=l,p.once=l,p.off=l,p.removeListener=l,p.removeAllListeners=l,p.emit=l,p.prependListener=l,p.prependOnceListener=l,p.listeners=function(b){return[]},p.binding=function(b){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(b){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(Ce[38],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(R){return new F(R)}constructor(R){this._now=P&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=F}),define(Ce[4],De([1,0,14,74,3,75,38]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const w=!1,E=!1;var C;(function(g){g.None=()=>p.Disposable.None;function f(V){if(E){const{onDidAddListener:J}=V,ue=_.create();let ve=0;V.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),J?.()}}}function S(V,J){return ie(V,()=>{},0,void 0,!0,void 0,J)}g.defer=S;function T(V){return(J,ue=null,ve)=>{let ke=!1,we;return we=V(Te=>{if(!ke)return we?we.dispose():ke=!0,J.call(ue,Te)},null,ve),ke&&we.dispose(),we}}g.once=T;function N(V,J,ue){return U((ve,ke=null,we)=>V(Te=>ve.call(ke,J(Te)),null,we),ue)}g.map=N;function z(V,J,ue){return U((ve,ke=null,we)=>V(Te=>{J(Te),ve.call(ke,Te)},null,we),ue)}g.forEach=z;function x(V,J,ue){return U((ve,ke=null,we)=>V(Te=>J(Te)&&ve.call(ke,Te),null,we),ue)}g.filter=x;function M(V){return V}g.signal=M;function k(...V){return(J,ue=null,ve)=>{const ke=(0,p.combinedDisposable)(...V.map(we=>we(Te=>J.call(ue,Te))));return q(ke,ve)}}g.any=k;function O(V,J,ue,ve){let ke=ue;return N(V,we=>(ke=J(ke,we),ke),ve)}g.reduce=O;function U(V,J){let ue;const ve={onWillAddFirstListener(){ue=V(ke.fire,ke)},onDidRemoveLastListener(){ue?.dispose()}};J||f(ve);const ke=new n(ve);return J?.add(ke),ke.event}function q(V,J){return J instanceof Array?J.push(V):J&&J.add(V),V}function ie(V,J,ue=100,ve=!1,ke=!1,we,Te){let Oe,xe,W,H=0,X;const K={leakWarningThreshold:we,onWillAddFirstListener(){Oe=V(Ee=>{H++,xe=J(xe,Ee),ve&&!W&&(pe.fire(xe),xe=void 0),X=()=>{const Me=xe;xe=void 0,W=void 0,(!ve||H>1)&&pe.fire(Me),H=0},typeof ue=="number"?(clearTimeout(W),W=setTimeout(X,ue)):W===void 0&&(W=0,queueMicrotask(X))})},onWillRemoveListener(){ke&&H>0&&X?.()},onDidRemoveLastListener(){X=void 0,Oe.dispose()}};Te||f(K);const pe=new n(K);return Te?.add(pe),pe.event}g.debounce=ie;function Z(V,J=0,ue){return g.debounce(V,(ve,ke)=>ve?(ve.push(ke),ve):[ke],J,void 0,!0,void 0,ue)}g.accumulate=Z;function Q(V,J=(ve,ke)=>ve===ke,ue){let ve=!0,ke;return x(V,we=>{const Te=ve||!J(we,ke);return ve=!1,ke=we,Te},ue)}g.latch=Q;function Y(V,J,ue){return[g.filter(V,J,ue),g.filter(V,ve=>!J(ve),ue)]}g.split=Y;function ae(V,J=!1,ue=[],ve){let ke=ue.slice(),we=V(xe=>{ke?ke.push(xe):Oe.fire(xe)});ve&&ve.add(we);const Te=()=>{ke?.forEach(xe=>Oe.fire(xe)),ke=null},Oe=new n({onWillAddFirstListener(){we||(we=V(xe=>Oe.fire(xe)),ve&&ve.add(we))},onDidAddFirstListener(){ke&&(J?setTimeout(Te):Te())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ve&&ve.add(Oe),Oe.event}g.buffer=ae;function ee(V,J){return(ve,ke,we)=>{const Te=J(new re);return V(function(Oe){const xe=Te.evaluate(Oe);xe!==fe&&ve.call(ke,xe)},void 0,we)}}g.chain=ee;const fe=Symbol("HaltChainable");class re{constructor(){this.steps=[]}map(J){return this.steps.push(J),this}forEach(J){return this.steps.push(ue=>(J(ue),ue)),this}filter(J){return this.steps.push(ue=>J(ue)?ue:fe),this}reduce(J,ue){let ve=ue;return this.steps.push(ke=>(ve=J(ve,ke),ve)),this}latch(J=(ue,ve)=>ue===ve){let ue=!0,ve;return this.steps.push(ke=>{const we=ue||!J(ke,ve);return ue=!1,ve=ke,we?ke:fe}),this}evaluate(J){for(const ue of this.steps)if(J=ue(J),J===fe)break;return J}}function G(V,J,ue=ve=>ve){const ve=(...Oe)=>Te.fire(ue(...Oe)),ke=()=>V.on(J,ve),we=()=>V.removeListener(J,ve),Te=new n({onWillAddFirstListener:ke,onDidRemoveLastListener:we});return Te.event}g.fromNodeEventEmitter=G;function B(V,J,ue=ve=>ve){const ve=(...Oe)=>Te.fire(ue(...Oe)),ke=()=>V.addEventListener(J,ve),we=()=>V.removeEventListener(J,ve),Te=new n({onWillAddFirstListener:ke,onDidRemoveLastListener:we});return Te.event}g.fromDOMEventEmitter=B;function se(V){return new Promise(J=>T(V)(J))}g.toPromise=se;function ye(V){const J=new n;return V.then(ue=>{J.fire(ue)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}g.fromPromise=ye;function le(V,J,ue){return J(ue),V(ve=>J(ve))}g.runAndSubscribe=le;class de{constructor(J,ue){this._observable=J,this._counter=0,this._hasChanged=!1;const ve={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ue||f(ve),this.emitter=new n(ve),ue&&ue.add(this.emitter)}beginUpdate(J){this._counter++}handlePossibleChange(J){}handleChange(J,ue){this._hasChanged=!0}endUpdate(J){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ce(V,J){return new de(V,J).emitter.event}g.fromObservable=ce;function he(V){return(J,ue,ve)=>{let ke=0,we=!1;const Te={beginUpdate(){ke++},endUpdate(){ke--,ke===0&&(V.reportChanges(),we&&(we=!1,J.call(ue)))},handlePossibleChange(){},handleChange(){we=!0}};V.addObserver(Te),V.reportChanges();const Oe={dispose(){V.removeObserver(Te)}};return ve instanceof p.DisposableStore?ve.add(Oe):Array.isArray(ve)&&ve.push(Oe),Oe}}g.fromObservableLight=he})(C||(e.Event=C={}));class L{static{this.all=new Set}static{this._idPool=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${L._idPool++}`,L.all.add(this)}start(f){this._stopWatch=new A.StopWatch,this.listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=L;let I=-1;function v(g){const f=I;return I=g,{dispose(){I=f}}}e.setGlobalLeakWarningThreshold=v;class y{constructor(f,S=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=S,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(f,S){const T=this.threshold;if(T<=0||S<T)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(f.value)||0;if(this._stacks.set(f.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let z,x=0;for(const[M,k]of this._stacks)(!z||x<k)&&(z=M,x=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${x}):`),console.warn(z)}return()=>{const z=this._stacks.get(f.value)||0;this._stacks.set(f.value,z-1)}}}class _{static create(){return new _(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class b{constructor(f){this.value=f,this.id=l++}}const o=2,i=(g,f)=>{if(g instanceof b)f(g);else for(let S=0;S<g.length;S++){const T=g[S];T&&f(T)}};class n{constructor(f){this._size=0,this._options=f,this._leakageMon=I>0||this._options?.leakWarningThreshold?new y(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(w){const f=this._listeners;queueMicrotask(()=>{i(f,S=>S.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(f,S,T)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),p.Disposable.None;if(this._disposed)return p.Disposable.None;S&&(f=f.bind(S));const N=new b(f);let z,x;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=_.create(),z=this._leakageMon.check(N.stack,this._size+1)),w&&(N.stack=x??_.create()),this._listeners?this._listeners instanceof b?(this._deliveryQueue??=new a,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const M=(0,p.toDisposable)(()=>{z?.(),this._removeListener(N)});return T instanceof p.DisposableStore?T.add(M):Array.isArray(T)&&T.push(M),M},this._event}_removeListener(f){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const S=this._listeners,T=S.indexOf(f);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,S[T]=void 0;const N=this._deliveryQueue.current===this;if(this._size*o<=S.length){let z=0;for(let x=0;x<S.length;x++)S[x]?S[z++]=S[x]:N&&(this._deliveryQueue.end--,z<this._deliveryQueue.i&&this._deliveryQueue.i--);S.length=z}}_deliver(f,S){if(!f)return;const T=this._options?.onListenerError||P.onUnexpectedError;if(!T){f.value(S);return}try{f.value(S)}catch(N){T(N)}}_deliverQueue(f){const S=f.current._listeners;for(;f.i<f.end;)this._deliver(S[f.i++],f.value);f.reset()}fire(f){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof b)this._deliver(this._listeners,f);else{const S=this._deliveryQueue;S.enqueue(this,f,this._listeners.length),this._deliverQueue(S)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=n;const r=()=>new a;e.createEventDeliveryQueue=r;class a{constructor(){this.i=-1,this.end=0}enqueue(f,S,T){this.i=0,this.end=T,this.current=f,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(f,S,T){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList),i(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,f]));this._asyncDeliveryQueue.size>0&&!S.isCancellationRequested;){const[N,z]=this._asyncDeliveryQueue.shift(),x=[],M={...z,token:S,waitUntil:k=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");T&&(k=T(k,N)),x.push(k)}};try{N(M)}catch(k){(0,P.onUnexpectedError)(k);continue}Object.freeze(x),await Promise.allSettled(x).then(k=>{for(const O of k)O.status==="rejected"&&(0,P.onUnexpectedError)(O.reason)})}}}e.AsyncEmitter=t;class h extends n{get isPaused(){return this._isPaused!==0}constructor(f){super(f),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._size&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=h;class u extends h{constructor(f){super(f),this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=u;class s extends n{constructor(f){super(f),this._queuedEvents=[],this._mergeFn=f?.merge}fire(f){this.hasListeners()&&(this._queuedEvents.push(f),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(S=>super.fire(S)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const S={event:f,listener:null};this.events.push(S),this.hasListeners&&this.hook(S);const T=()=>{this.hasListeners&&this.unhook(S);const N=this.events.indexOf(S);this.events.splice(N,1)};return(0,p.toDisposable)((0,F.createSingleCallFunction)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(S=>this.emitter.fire(S))}unhook(f){f.listener?.dispose(),f.listener=null}dispose(){this.emitter.dispose();for(const f of this.events)f.listener?.dispose();this.events=[]}}e.EventMultiplexer=c;class d{constructor(f,S,T,N){this._store=new p.DisposableStore;const z=this._store.add(new c),x=this._store.add(new p.DisposableMap);function M(k){x.set(k,z.add(N(k)))}for(const k of f)M(k);this._store.add(S(k=>{M(k)})),this._store.add(T(k=>{x.deleteAndDispose(k)})),this.event=z.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=d;class m{constructor(){this.buffers=[]}wrapEvent(f){return(S,T,N)=>f(z=>{const x=this.buffers[this.buffers.length-1];x?x.push(()=>S.call(T,z)):S.call(T,z)},void 0,N)}bufferEvents(f){const S=[];this.buffers.push(S);const T=f();return this.buffers.pop(),S.forEach(N=>N()),T}}e.EventBufferer=m;class D{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=p.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(Ce[22],De([1,0,4]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(w,E){const C=setTimeout(w.bind(E),0);return{dispose(){clearTimeout(C)}}});var p;(function(w){function E(C){return C===w.None||C===w.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}w.isCancellationToken=E,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(p||(e.CancellationToken=p={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=p.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=p.None}}e.CancellationTokenSource=A}),define(Ce[163],De([1,0,22]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class F{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new P.CancellationTokenSource,E=this.task(w.token);return this.result={promise:E,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}e.Cache=F;class p{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const E=JSON.stringify(w);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(w)),this.lastCache}}e.LRUCachedFunction=p;class R{get cachedValues(){return this._map}constructor(w){this.fn=w,this._map=new Map}get(w){if(this._map.has(w))return this._map.get(w);const E=this.fn(w);return this._map.set(w,E),E}}e.CachedFunction=R}),define(Ce[98],De([1,0,14,3]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function p(r){const a=r;return a?typeof a.read=="function":!1}e.isReadable=p;function R(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function A(r){const a=r;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=A;function w(r,a){return new E(r,a)}e.newWriteableStream=w;class E{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,P.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let h;switch(a){case"data":h=this.listeners.data;break;case"end":h=this.listeners.end;break;case"error":h=this.listeners.error;break}if(h){const u=h.indexOf(t);u>=0&&h.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(h=>h())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(r,a){const t=[];let h;for(;(h=r.read())!==null;)t.push(h);return a(t)}e.consumeReadable=C;function L(r,a,t){const h=[];let u;for(;(u=r.read())!==null&&h.length<t;)h.push(u);return u===null&&h.length>0?a(h):{read:()=>{if(h.length>0)return h.shift();if(typeof u<"u"){const s=u;return u=void 0,s}return r.read()}}}e.peekReadable=L;function I(r,a){return new Promise((t,h)=>{const u=[];v(r,{onData:s=>{a&&u.push(s)},onError:s=>{a?h(s):t(void 0)},onEnd:()=>{t(a?a(u):void 0)}})})}e.consumeStream=I;function v(r,a,t){r.on("error",h=>{t?.isCancellationRequested||a.onError(h)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",h=>{t?.isCancellationRequested||a.onData(h)})}e.listenStream=v;function y(r,a){return new Promise((t,h)=>{const u=new F.DisposableStore,s=[],c=D=>{if(s.push(D),s.length>a)return u.dispose(),r.pause(),t({stream:r,buffer:s,ended:!1})},d=D=>(u.dispose(),h(D)),m=()=>(u.dispose(),t({stream:r,buffer:s,ended:!0}));u.add((0,F.toDisposable)(()=>r.removeListener("error",d))),r.on("error",d),u.add((0,F.toDisposable)(()=>r.removeListener("end",m))),r.on("end",m),u.add((0,F.toDisposable)(()=>r.removeListener("data",c))),r.on("data",c)})}e.peekStream=y;function _(r,a){const t=w(a);return t.end(r),t}e.toStream=_;function l(){const r=w(()=>{throw new Error("not supported")});return r.end(),r}e.emptyStream=l;function b(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.toReadable=b;function o(r,a,t){const h=w(t);return v(r,{onData:u=>h.write(a.data(u)),onError:u=>h.error(a.error?a.error(u):u),onEnd:()=>h.end()}),h}e.transform=o;function i(r,a,t){let h=!1;return{read:()=>{const u=a.read();return h?u:(h=!0,u!==null?t([r,u]):r)}}}e.prefixedReadable=i;function n(r,a,t){let h=!1;const u=w(t);return v(a,{onData:s=>h?u.write(s):(h=!0,u.write(t([r,s]))),onError:s=>u.error(s),onEnd:()=>{h||(h=!0,u.write(r)),u.end()}}),u}e.prefixedStream=n}),define(Ce[21],De([1,0,44,98]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const p=typeof Buffer<"u",R=new P.Lazy(()=>new Uint8Array(256));let A,w;class E{static alloc(S){return p?new E(Buffer.allocUnsafe(S)):new E(new Uint8Array(S))}static wrap(S){return p&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new E(S)}static fromString(S,T){return!(T?.dontUseNodeBuffer||!1)&&p?new E(Buffer.from(S)):(A||(A=new TextEncoder),new E(A.encode(S)))}static fromByteArray(S){const T=E.alloc(S.length);for(let N=0,z=S.length;N<z;N++)T.buffer[N]=S[N];return T}static concat(S,T){if(typeof T>"u"){T=0;for(let x=0,M=S.length;x<M;x++)T+=S[x].byteLength}const N=E.alloc(T);let z=0;for(let x=0,M=S.length;x<M;x++){const k=S[x];N.set(k,z),z+=k.byteLength}return N}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=E.alloc(this.byteLength);return S.set(this),S}toString(){return p?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(S,T){return new E(this.buffer.subarray(S,T))}set(S,T){if(S instanceof E)this.buffer.set(S.buffer,T);else if(S instanceof Uint8Array)this.buffer.set(S,T);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),T);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return v(this.buffer,S)}writeUInt32BE(S,T){y(this.buffer,S,T)}readUInt32LE(S){return _(this.buffer,S)}writeUInt32LE(S,T){l(this.buffer,S,T)}readUInt8(S){return b(this.buffer,S)}writeUInt8(S,T){o(this.buffer,S,T)}indexOf(S,T=0){return C(this.buffer,S instanceof E?S.buffer:S,T)}}e.VSBuffer=E;function C(f,S,T=0){const N=S.byteLength,z=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(S[0]);if(N>z-T)return-1;const x=R.value;x.fill(S.length);for(let U=0;U<S.length;U++)x[S[U]]=S.length-U-1;let M=T+S.length-1,k=M,O=-1;for(;M<z;)if(f[M]===S[k]){if(k===0){O=M;break}M--,k--}else M+=Math.max(S.length-k,x[f[M]]),k=S.length-1;return O}e.binaryIndexOf=C;function L(f,S){return f[S+0]<<0>>>0|f[S+1]<<8>>>0}e.readUInt16LE=L;function I(f,S,T){f[T+0]=S&255,S=S>>>8,f[T+1]=S&255}e.writeUInt16LE=I;function v(f,S){return f[S]*2**24+f[S+1]*2**16+f[S+2]*2**8+f[S+3]}e.readUInt32BE=v;function y(f,S,T){f[T+3]=S,S=S>>>8,f[T+2]=S,S=S>>>8,f[T+1]=S,S=S>>>8,f[T]=S}e.writeUInt32BE=y;function _(f,S){return f[S+0]<<0>>>0|f[S+1]<<8>>>0|f[S+2]<<16>>>0|f[S+3]<<24>>>0}e.readUInt32LE=_;function l(f,S,T){f[T+0]=S&255,S=S>>>8,f[T+1]=S&255,S=S>>>8,f[T+2]=S&255,S=S>>>8,f[T+3]=S&255}e.writeUInt32LE=l;function b(f,S){return f[S]}e.readUInt8=b;function o(f,S,T){f[T]=S}e.writeUInt8=o;function i(f){return F.consumeReadable(f,S=>E.concat(S))}e.readableToBuffer=i;function n(f){return F.toReadable(f)}e.bufferToReadable=n;function r(f){return F.consumeStream(f,S=>E.concat(S))}e.streamToBuffer=r;async function a(f){return f.ended?E.concat(f.buffer):E.concat([...f.buffer,await r(f.stream)])}e.bufferedStreamToBuffer=a;function t(f){return F.toStream(f,S=>E.concat(S))}e.bufferToStream=t;function h(f){return F.transform(f,{data:S=>typeof S=="string"?E.fromString(S):E.wrap(S)},S=>E.concat(S))}e.streamToBufferReadableStream=h;function u(f){return F.newWriteableStream(S=>E.concat(S),f)}e.newWriteableBufferStream=u;function s(f,S){return F.prefixedReadable(f,S,T=>E.concat(T))}e.prefixedBufferReadable=s;function c(f,S){return F.prefixedStream(f,S,T=>E.concat(T))}e.prefixedBufferStream=c;function d(f){let S=0,T=0,N=0;const z=new Uint8Array(Math.floor(f.length/4*3)),x=k=>{switch(T){case 3:z[N++]=S|k,T=0;break;case 2:z[N++]=S|k>>>2,S=k<<6,T=3;break;case 1:z[N++]=S|k>>>4,S=k<<4,T=2;break;default:S=k<<2,T=1}};for(let k=0;k<f.length;k++){const O=f.charCodeAt(k);if(O>=65&&O<=90)x(O-65);else if(O>=97&&O<=122)x(O-97+26);else if(O>=48&&O<=57)x(O-48+52);else if(O===43||O===45)x(62);else if(O===47||O===95)x(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${f[k]}`)}}const M=N;for(;T>0;)x(0);return E.wrap(z).slice(0,M)}e.decodeBase64=d;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:f},S=!0,T=!1){const N=T?D:m;let z="";const x=f.byteLength%3;let M=0;for(;M<f.byteLength-x;M+=3){const k=f[M+0],O=f[M+1],U=f[M+2];z+=N[k>>>2],z+=N[(k<<4|O>>>4)&63],z+=N[(O<<2|U>>>6)&63],z+=N[U&63]}if(x===1){const k=f[M+0];z+=N[k>>>2],z+=N[k<<4&63],S&&(z+="==")}else if(x===2){const k=f[M+0],O=f[M+1];z+=N[k>>>2],z+=N[(k<<4|O>>>4)&63],z+=N[O<<2&63],S&&(z+="=")}return z}e.encodeBase64=g}),define(Ce[12],De([1,0,163,44]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLinesIncludeSeparators=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.htmlAttributeEncodeValue=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function A(Pe,...ze){return ze.length===0?Pe:Pe.replace(R,function(Ae,je){const ne=parseInt(je,10);return isNaN(ne)||ne<0||ne>=ze.length?Ae:ze[ne]})}e.format=A;const w=/{([^}]+)}/g;function E(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(w,(Ae,je)=>ze[je]??Ae)}e.format2=E;function C(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}e.htmlAttributeEncodeValue=C;function L(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.escape=L;function I(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function v(Pe,ze){let Ae=0;const je=ze.charCodeAt(0);for(let ne=Pe.length-1;ne>=0;ne--)Pe.charCodeAt(ne)===je&&Ae++;return Ae}e.count=v;function y(Pe,ze,Ae="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${Ae}`}e.truncate=y;function _(Pe,ze,Ae="\u2026"){if(Pe.length<=ze)return Pe;const je=Math.ceil(ze/2)-Ae.length/2,ne=Math.floor(ze/2)-Ae.length/2;return`${Pe.substr(0,je)}${Ae}${Pe.substr(Pe.length-ne)}`}e.truncateMiddle=_;function l(Pe,ze=" "){const Ae=b(Pe,ze);return o(Ae,ze)}e.trim=l;function b(Pe,ze){if(!Pe||!ze)return Pe;const Ae=ze.length;if(Ae===0||Pe.length===0)return Pe;let je=0;for(;Pe.indexOf(ze,je)===je;)je=je+Ae;return Pe.substring(je)}e.ltrim=b;function o(Pe,ze){if(!Pe||!ze)return Pe;const Ae=ze.length,je=Pe.length;if(Ae===0||je===0)return Pe;let ne=je,oe=-1;for(;oe=Pe.lastIndexOf(ze,ne-1),!(oe===-1||oe+Ae!==ne);){if(oe===0)return"";ne=oe}return Pe.substring(0,ne)}e.rtrim=o;function i(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=i;function n(Pe){return Pe.replace(/\*/g,"")}e.stripWildcards=n;function r(Pe,ze,Ae={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=I(Pe)),Ae.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let je="";return Ae.global&&(je+="g"),Ae.matchCase||(je+="i"),Ae.multiline&&(je+="m"),Ae.unicode&&(je+="u"),new RegExp(Pe,je)}e.createRegExp=r;function a(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function t(Pe){return Pe.split(/\r\n|\r|\n/)}e.splitLines=t;function h(Pe){const ze=[],Ae=Pe.split(/(\r\n|\r|\n)/);for(let je=0;je<Math.ceil(Ae.length/2);je++)ze.push(Ae[2*je]+(Ae[2*je+1]??""));return ze}e.splitLinesIncludeSeparators=h;function u(Pe){for(let ze=0,Ae=Pe.length;ze<Ae;ze++){const je=Pe.charCodeAt(ze);if(je!==32&&je!==9)return ze}return-1}e.firstNonWhitespaceIndex=u;function s(Pe,ze=0,Ae=Pe.length){for(let je=ze;je<Ae;je++){const ne=Pe.charCodeAt(je);if(ne!==32&&ne!==9)return Pe.substring(ze,je)}return Pe.substring(ze,Ae)}e.getLeadingWhitespace=s;function c(Pe,ze=Pe.length-1){for(let Ae=ze;Ae>=0;Ae--){const je=Pe.charCodeAt(Ae);if(je!==32&&je!==9)return Ae}return-1}e.lastNonWhitespaceIndex=c;function d(Pe,ze,Ae){const je=[];let ne=0;for(const oe of Pe.matchAll(ze)){if(je.push(Pe.slice(ne,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ne=oe.index+oe[0].length,je.push(Ae(oe[0],...oe.slice(1),oe.index,Pe,oe.groups))}return je.push(Pe.slice(ne)),Promise.all(je).then(oe=>oe.join(""))}e.replaceAsync=d;function m(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}e.compare=m;function D(Pe,ze,Ae=0,je=Pe.length,ne=0,oe=ze.length){for(;Ae<je&&ne<oe;Ae++,ne++){const Je=Pe.charCodeAt(Ae),nt=ze.charCodeAt(ne);if(Je<nt)return-1;if(Je>nt)return 1}const Ie=je-Ae,qe=oe-ne;return Ie<qe?-1:Ie>qe?1:0}e.compareSubstring=D;function g(Pe,ze){return f(Pe,ze,0,Pe.length,0,ze.length)}e.compareIgnoreCase=g;function f(Pe,ze,Ae=0,je=Pe.length,ne=0,oe=ze.length){for(;Ae<je&&ne<oe;Ae++,ne++){let Je=Pe.charCodeAt(Ae),nt=ze.charCodeAt(ne);if(Je===nt)continue;if(Je>=128||nt>=128)return D(Pe.toLowerCase(),ze.toLowerCase(),Ae,je,ne,oe);T(Je)&&(Je-=32),T(nt)&&(nt-=32);const Ne=Je-nt;if(Ne!==0)return Ne}const Ie=je-Ae,qe=oe-ne;return Ie<qe?-1:Ie>qe?1:0}e.compareSubstringIgnoreCase=f;function S(Pe){return Pe>=48&&Pe<=57}e.isAsciiDigit=S;function T(Pe){return Pe>=97&&Pe<=122}e.isLowerAsciiLetter=T;function N(Pe){return Pe>=65&&Pe<=90}e.isUpperAsciiLetter=N;function z(Pe,ze){return Pe.length===ze.length&&f(Pe,ze)===0}e.equalsIgnoreCase=z;function x(Pe,ze){const Ae=ze.length;return ze.length>Pe.length?!1:f(Pe,ze,0,Ae)===0}e.startsWithIgnoreCase=x;function M(Pe,ze){const Ae=Math.min(Pe.length,ze.length);let je;for(je=0;je<Ae;je++)if(Pe.charCodeAt(je)!==ze.charCodeAt(je))return je;return Ae}e.commonPrefixLength=M;function k(Pe,ze){const Ae=Math.min(Pe.length,ze.length);let je;const ne=Pe.length-1,oe=ze.length-1;for(je=0;je<Ae;je++)if(Pe.charCodeAt(ne-je)!==ze.charCodeAt(oe-je))return je;return Ae}e.commonSuffixLength=k;function O(Pe){return 55296<=Pe&&Pe<=56319}e.isHighSurrogate=O;function U(Pe){return 56320<=Pe&&Pe<=57343}e.isLowSurrogate=U;function q(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}e.computeCodePoint=q;function ie(Pe,ze,Ae){const je=Pe.charCodeAt(Ae);if(O(je)&&Ae+1<ze){const ne=Pe.charCodeAt(Ae+1);if(U(ne))return q(je,ne)}return je}e.getNextCodePoint=ie;function Z(Pe,ze){const Ae=Pe.charCodeAt(ze-1);if(U(Ae)&&ze>1){const je=Pe.charCodeAt(ze-2);if(O(je))return q(je,Ae)}return Ae}class Q{get offset(){return this._offset}constructor(ze,Ae=0){this._str=ze,this._len=ze.length,this._offset=Ae}setOffset(ze){this._offset=ze}prevCodePoint(){const ze=Z(this._str,this._offset);return this._offset-=ze>=65536?2:1,ze}nextCodePoint(){const ze=ie(this._str,this._len,this._offset);return this._offset+=ze>=65536?2:1,ze}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class Y{get offset(){return this._iterator.offset}constructor(ze,Ae=0){this._iterator=new Q(ze,Ae)}nextGraphemeLength(){const ze=Ee.getInstance(),Ae=this._iterator,je=Ae.offset;let ne=ze.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const oe=Ae.offset,Ie=ze.getGraphemeBreakType(Ae.nextCodePoint());if(K(ne,Ie)){Ae.setOffset(oe);break}ne=Ie}return Ae.offset-je}prevGraphemeLength(){const ze=Ee.getInstance(),Ae=this._iterator,je=Ae.offset;let ne=ze.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const oe=Ae.offset,Ie=ze.getGraphemeBreakType(Ae.prevCodePoint());if(K(Ie,ne)){Ae.setOffset(oe);break}ne=Ie}return je-Ae.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function ae(Pe,ze){return new Y(Pe,ze).nextGraphemeLength()}e.nextCharLength=ae;function ee(Pe,ze){return new Y(Pe,ze).prevGraphemeLength()}e.prevCharLength=ee;function fe(Pe,ze){ze>0&&U(Pe.charCodeAt(ze))&&ze--;const Ae=ze+ae(Pe,ze);return[Ae-ee(Pe,Ae),Ae]}e.getCharContainingOffset=fe;function re(Pe){const ze=new Y(Pe);let Ae=0;for(;!ze.eol();)Ae++,ze.nextGraphemeLength();return Ae}e.charCount=re;let G;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function se(Pe){return G||(G=B()),G.test(Pe)}e.containsRTL=se;const ye=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return ye.test(Pe)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(Pe){return e.UNUSUAL_LINE_TERMINATORS.test(Pe)}e.containsUnusualLineTerminators=de;function ce(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.isFullWidthCharacter=ce;function he(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.isEmojiImprecise=he;function V(Pe,ze,Ae=""){const je=Pe.trimStart();if(je.length<ze)return je;const ne=/\b/g;let oe=0;for(;ne.test(je)&&!(je.length-ne.lastIndex<ze);)oe=ne.lastIndex,ne.lastIndex+=1;return oe===0?je:Ae+je.substring(oe).trimStart()}e.lcut=V;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ue=/\x1b\].*?\x07/g;function ve(Pe){return Pe&&(Pe=Pe.replace(J,"").replace(ue,"")),Pe}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER="\uFEFF";function ke(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function we(Pe){return ke(Pe)?Pe.substr(1):Pe}e.stripUTF8BOM=we;function Te(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const Ae=ze.length,je=Pe.toLowerCase();let ne=0,oe=-1;for(;ne<Ae;){const Ie=je.indexOf(ze[ne],oe+1);if(Ie<0)return!1;oe=Ie,ne++}return!0}e.fuzzyContains=Te;function Oe(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.containsUppercaseCharacter=Oe;function xe(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.uppercaseFirstLetter=xe;function W(Pe,ze=1){if(ze===0)return"";let Ae=-1;do Ae=Pe.indexOf(`
`,Ae+1),ze--;while(ze>0&&Ae>=0);return Ae===-1?Pe:(Pe[Ae-1]==="\r"&&Ae--,Pe.substr(0,Ae))}e.getNLines=W;function H(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.singleLetterHash=H;function X(Pe){return Ee.getInstance().getGraphemeBreakType(Pe)}e.getGraphemeBreakType=X;function K(Pe,ze){return Pe===0?ze!==5&&ze!==7:Pe===2&&ze===3?!1:Pe===4||Pe===2||Pe===3||ze===4||ze===2||ze===3?!0:!(Pe===8&&(ze===8||ze===9||ze===11||ze===12)||(Pe===11||Pe===9)&&(ze===9||ze===10)||(Pe===12||Pe===10)&&ze===10||ze===5||ze===13||ze===7||Pe===1||Pe===13&&ze===14||Pe===6&&ze===6)}var pe;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(pe||(e.GraphemeBreakType=pe={}));class Ee{static{this._INSTANCE=null}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Ae=this._data,je=Ae.length/3;let ne=1;for(;ne<=je;)if(ze<Ae[3*ne])ne=2*ne;else if(ze>Ae[3*ne+1])ne=2*ne+1;else return Ae[3*ne+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(Pe,ze){if(Pe===0)return 0;const Ae=Ke(Pe,ze);if(Ae!==void 0)return Ae;const je=new Q(ze,Pe);return je.prevCodePoint(),je.offset}e.getLeftDeleteOffset=Ve;function Ke(Pe,ze){const Ae=new Q(ze,Pe);let je=Ae.prevCodePoint();for(;tt(je)||je===65039||je===8419;){if(Ae.offset===0)return;je=Ae.prevCodePoint()}if(!he(je))return;let ne=Ae.offset;return ne>0&&Ae.prevCodePoint()===8205&&(ne=Ae.offset),ne}function tt(Pe){return 127995<=Pe&&Pe<=127999}var st;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.noBreakWhitespace="\xA0";class lt{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new P.LRUCachedFunction(ze=>{function Ae(Ne){const vt=new Map;for(let yt=0;yt<Ne.length;yt+=2)vt.set(Ne[yt],Ne[yt+1]);return vt}function je(Ne,vt){const yt=new Map(Ne);for(const[kt,Mt]of vt)yt.set(kt,Mt);return yt}function ne(Ne,vt){if(!Ne)return vt;const yt=new Map;for(const[kt,Mt]of Ne)vt.has(kt)&&yt.set(kt,Mt);return yt}const oe=this.ambiguousCharacterData.value;let Ie=ze.filter(Ne=>!Ne.startsWith("_")&&Ne in oe);Ie.length===0&&(Ie=["_default"]);let qe;for(const Ne of Ie){const vt=Ae(oe[Ne]);qe=ne(qe,vt)}const Je=Ae(oe._common),nt=je(Je,qe);return new lt(nt)})}static getInstance(ze){return lt.cache.get(Array.from(ze))}static{this._locales=new F.Lazy(()=>Object.keys(lt.ambiguousCharacterData.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return lt._locales.value}constructor(ze){this.confusableDictionary=ze}isAmbiguous(ze){return this.confusableDictionary.has(ze)}getPrimaryConfusable(ze){return this.confusableDictionary.get(ze)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=lt;class rt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(rt.getRawData())),this._data}static isInvisibleCharacter(ze){return rt.getData().has(ze)}static get codePoints(){return rt.getData()}}e.InvisibleCharacters=rt}),define(Ce[123],De([1,0,28,162,12]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...we){return function(Te,Oe){for(let xe=0,W=we.length;xe<W;xe++){const H=we[xe](Te,Oe);if(H)return H}return null}}e.or=R,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(we,Te,Oe){if(!Oe||Oe.length<Te.length)return null;let xe;return we?xe=p.startsWithIgnoreCase(Oe,Te):xe=Oe.indexOf(Te)===0,xe?Te.length>0?[{start:0,end:Te.length}]:[]:null}function w(we,Te){const Oe=Te.toLowerCase().indexOf(we.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+we.length}]}e.matchesContiguousSubString=w;function E(we,Te){return C(we.toLowerCase(),Te.toLowerCase(),0,0)}e.matchesSubString=E;function C(we,Te,Oe,xe){if(Oe===we.length)return[];if(xe===Te.length)return null;if(we[Oe]===Te[xe]){let W=null;return(W=C(we,Te,Oe+1,xe+1))?r({start:xe,end:xe+1},W):null}return C(we,Te,Oe,xe+1)}function L(we){return 97<=we&&we<=122}function I(we){return 65<=we&&we<=90}e.isUpper=I;function v(we){return 48<=we&&we<=57}function y(we){return we===32||we===9||we===10||we===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(we=>_.add(we.charCodeAt(0)));function l(we){return y(we)||_.has(we)}function b(we,Te){return we===Te||l(we)&&l(Te)}const o=new Map;function i(we){if(o.has(we))return o.get(we);let Te;const Oe=(0,F.getKoreanAltChars)(we);return Oe&&(Te=Oe),o.set(we,Te),Te}function n(we){return L(we)||I(we)||v(we)}function r(we,Te){return Te.length===0?Te=[we]:we.end===Te[0].start?Te[0].start=we.start:Te.unshift(we),Te}function a(we,Te){for(let Oe=Te;Oe<we.length;Oe++){const xe=we.charCodeAt(Oe);if(I(xe)||v(xe)||Oe>0&&!n(we.charCodeAt(Oe-1)))return Oe}return we.length}function t(we,Te,Oe,xe){if(Oe===we.length)return[];if(xe===Te.length)return null;if(we[Oe]!==Te[xe].toLowerCase())return null;{let W=null,H=xe+1;for(W=t(we,Te,Oe+1,xe+1);!W&&(H=a(Te,H))<Te.length;)W=t(we,Te,Oe+1,H),H++;return W===null?null:r({start:xe,end:xe+1},W)}}function h(we){let Te=0,Oe=0,xe=0,W=0,H=0;for(let Me=0;Me<we.length;Me++)H=we.charCodeAt(Me),I(H)&&Te++,L(H)&&Oe++,n(H)&&xe++,v(H)&&W++;const X=Te/we.length,K=Oe/we.length,pe=xe/we.length,Ee=W/we.length;return{upperPercent:X,lowerPercent:K,alphaPercent:pe,numericPercent:Ee}}function u(we){const{upperPercent:Te,lowerPercent:Oe}=we;return Oe===0&&Te>.6}function s(we){const{upperPercent:Te,lowerPercent:Oe,alphaPercent:xe,numericPercent:W}=we;return Oe>.2&&Te<.8&&xe>.6&&W<.2}function c(we){let Te=0,Oe=0,xe=0,W=0;for(let H=0;H<we.length;H++)xe=we.charCodeAt(H),I(xe)&&Te++,L(xe)&&Oe++,y(xe)&&W++;return(Te===0||Oe===0)&&W===0?we.length<=30:Te<=5}function d(we,Te){if(!Te||(Te=Te.trim(),Te.length===0)||!c(we))return null;Te.length>60&&(Te=Te.substring(0,60));const Oe=h(Te);if(!s(Oe)){if(!u(Oe))return null;Te=Te.toLowerCase()}let xe=null,W=0;for(we=we.toLowerCase();W<Te.length&&(xe=t(we,Te,0,W))===null;)W=a(Te,W+1);return xe}e.matchesCamelCase=d;function m(we,Te,Oe=!1){if(!Te||Te.length===0)return null;let xe=null,W=0;for(we=we.toLowerCase(),Te=Te.toLowerCase();W<Te.length&&(xe=D(we,Te,0,W,Oe),xe===null);)W=g(Te,W+1);return xe}e.matchesWords=m;function D(we,Te,Oe,xe,W){let H=0;if(Oe===we.length)return[];if(xe===Te.length)return null;if(!b(we.charCodeAt(Oe),Te.charCodeAt(xe))){const pe=i(we.charCodeAt(Oe));if(!pe)return null;for(let Ee=0;Ee<pe.length;Ee++)if(!b(pe[Ee],Te.charCodeAt(xe+Ee)))return null;H+=pe.length-1}let X=null,K=xe+H+1;if(X=D(we,Te,Oe+1,K,W),!W)for(;!X&&(K=g(Te,K))<Te.length;)X=D(we,Te,Oe+1,K,W),K++;if(!X)return null;if(we.charCodeAt(Oe)!==Te.charCodeAt(xe)){const pe=i(we.charCodeAt(Oe));if(!pe)return X;for(let Ee=0;Ee<pe.length;Ee++)if(pe[Ee]!==Te.charCodeAt(xe+Ee))return X}return r({start:xe,end:xe+H+1},X)}function g(we,Te){for(let Oe=Te;Oe<we.length;Oe++)if(l(we.charCodeAt(Oe))||Oe>0&&l(we.charCodeAt(Oe-1)))return Oe;return we.length}const f=R(e.matchesPrefix,d,w),S=R(e.matchesPrefix,d,E),T=new P.LRUCache(1e4);function N(we,Te,Oe=!1){if(typeof we!="string"||typeof Te!="string")return null;let xe=T.get(we);xe||(xe=new RegExp(p.convertSimple2RegExpPattern(we),"i"),T.set(we,xe));const W=xe.exec(Te);return W?[{start:W.index,end:W.index+W[0].length}]:Oe?S(we,Te):f(we,Te)}e.matchesFuzzy=N;function z(we,Te){const Oe=ce(we,we.toLowerCase(),0,Te,Te.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?M(Oe):null}e.matchesFuzzy2=z;function x(we,Te,Oe,xe,W,H){const X=Math.min(13,we.length);for(;Oe<X;Oe++){const K=ce(we,Te,Oe,xe,W,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return K}return[0,H]}e.anyScore=x;function M(we){if(typeof we>"u")return[];const Te=[],Oe=we[1];for(let xe=we.length-1;xe>1;xe--){const W=we[xe]+Oe,H=Te[Te.length-1];H&&H.end===W?H.end=W+1:Te.push({start:W,end:W+1})}return Te}e.createMatches=M;const k=128;function O(){const we=[],Te=[];for(let Oe=0;Oe<=k;Oe++)Te[Oe]=0;for(let Oe=0;Oe<=k;Oe++)we.push(Te.slice(0));return we}function U(we){const Te=[];for(let Oe=0;Oe<=we;Oe++)Te[Oe]=0;return Te}const q=U(2*k),ie=U(2*k),Z=O(),Q=O(),Y=O(),ae=!1;function ee(we,Te,Oe,xe,W){function H(K,pe,Ee=" "){for(;K.length<pe;)K=Ee+K;return K}let X=` |   |${xe.split("").map(K=>H(K,3)).join("|")}
`;for(let K=0;K<=Oe;K++)K===0?X+=" |":X+=`${Te[K-1]}|`,X+=we[K].slice(0,W+1).map(pe=>H(pe.toString(),3)).join("|")+`
`;return X}function fe(we,Te,Oe,xe){we=we.substr(Te),Oe=Oe.substr(xe),console.log(ee(Q,we,we.length,Oe,Oe.length)),console.log(ee(Y,we,we.length,Oe,Oe.length)),console.log(ee(Z,we,we.length,Oe,Oe.length))}function re(we,Te){if(Te<0||Te>=we.length)return!1;const Oe=we.codePointAt(Te);switch(Oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!p.isEmojiImprecise(Oe)}}function G(we,Te){if(Te<0||Te>=we.length)return!1;switch(we.charCodeAt(Te)){case 32:case 9:return!0;default:return!1}}function B(we,Te,Oe){return Te[we]!==Oe[we]}function se(we,Te,Oe,xe,W,H,X=!1){for(;Te<Oe&&W<H;)we[Te]===xe[W]&&(X&&(q[Te]=W),Te+=1),W+=1;return Te===Oe}e.isPatternInWord=se;var ye;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var le;(function(we){we.Default=[-100,0];function Te(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}we.isDefault=Te})(le||(e.FuzzyScore=le={}));class de{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Te,Oe){this.firstMatchCanBeWeak=Te,this.boostFullMatch=Oe}}e.FuzzyScoreOptions=de;function ce(we,Te,Oe,xe,W,H,X=de.default){const K=we.length>k?k:we.length,pe=xe.length>k?k:xe.length;if(Oe>=K||H>=pe||K-Oe>pe-H||!se(Te,Oe,K,W,H,pe,!0))return;he(K,pe,Oe,H,Te,W);let Ee=1,Me=1,Ve=Oe,Ke=H;const tt=[!1];for(Ee=1,Ve=Oe;Ve<K;Ee++,Ve++){const ze=q[Ve],Ae=ie[Ve],je=Ve+1<K?ie[Ve+1]:pe;for(Me=ze-H+1,Ke=ze;Ke<je;Me++,Ke++){let ne=Number.MIN_SAFE_INTEGER,oe=!1;Ke<=Ae&&(ne=V(we,Te,Ve,Oe,xe,W,Ke,pe,H,Z[Ee-1][Me-1]===0,tt));let Ie=0;ne!==Number.MAX_SAFE_INTEGER&&(oe=!0,Ie=ne+Q[Ee-1][Me-1]);const qe=Ke>ze,Je=qe?Q[Ee][Me-1]+(Z[Ee][Me-1]>0?-5:0):0,nt=Ke>ze+1&&Z[Ee][Me-1]>0,Ne=nt?Q[Ee][Me-2]+(Z[Ee][Me-2]>0?-5:0):0;if(nt&&(!qe||Ne>=Je)&&(!oe||Ne>=Ie))Q[Ee][Me]=Ne,Y[Ee][Me]=3,Z[Ee][Me]=0;else if(qe&&(!oe||Je>=Ie))Q[Ee][Me]=Je,Y[Ee][Me]=2,Z[Ee][Me]=0;else if(oe)Q[Ee][Me]=Ie,Y[Ee][Me]=1,Z[Ee][Me]=Z[Ee-1][Me-1]+1;else throw new Error("not possible")}}if(ae&&fe(we,Oe,xe,H),!tt[0]&&!X.firstMatchCanBeWeak)return;Ee--,Me--;const st=[Q[Ee][Me],H];let lt=0,rt=0;for(;Ee>=1;){let ze=Me;do{const Ae=Y[Ee][ze];if(Ae===3)ze=ze-2;else if(Ae===2)ze=ze-1;else break}while(ze>=1);lt>1&&Te[Oe+Ee-1]===W[H+Me-1]&&!B(ze+H-1,xe,W)&&lt+1>Z[Ee][ze]&&(ze=Me),ze===Me?lt++:lt=1,rt||(rt=ze),Ee--,Me=ze-1,st.push(Me)}pe===K&&X.boostFullMatch&&(st[0]+=2);const Pe=rt-K;return st[0]-=Pe,st}e.fuzzyScore=ce;function he(we,Te,Oe,xe,W,H){let X=we-1,K=Te-1;for(;X>=Oe&&K>=xe;)W[X]===H[K]&&(ie[X]=K,X--),K--}function V(we,Te,Oe,xe,W,H,X,K,pe,Ee,Me){if(Te[Oe]!==H[X])return Number.MIN_SAFE_INTEGER;let Ve=1,Ke=!1;return X===Oe-xe?Ve=we[Oe]===W[X]?7:5:B(X,W,H)&&(X===0||!B(X-1,W,H))?(Ve=we[Oe]===W[X]?7:5,Ke=!0):re(H,X)&&(X===0||!re(H,X-1))?Ve=5:(re(H,X-1)||G(H,X-1))&&(Ve=5,Ke=!0),Ve>1&&Oe===xe&&(Me[0]=!0),Ke||(Ke=B(X,W,H)||re(H,X-1)||G(H,X-1)),Oe===xe?X>pe&&(Ve-=Ke?3:5):Ee?Ve+=Ke?2:0:Ve+=Ke?0:1,X+1===K&&(Ve-=Ke?3:5),Ve}function J(we,Te,Oe,xe,W,H,X){return ve(we,Te,Oe,xe,W,H,!0,X)}e.fuzzyScoreGracefulAggressive=J;function ue(we,Te,Oe,xe,W,H,X){return ve(we,Te,Oe,xe,W,H,!1,X)}e.fuzzyScoreGraceful=ue;function ve(we,Te,Oe,xe,W,H,X,K){let pe=ce(we,Te,Oe,xe,W,H,K);if(pe&&!X)return pe;if(we.length>=3){const Ee=Math.min(7,we.length-1);for(let Me=Oe+1;Me<Ee;Me++){const Ve=ke(we,Me);if(Ve){const Ke=ce(Ve,Ve.toLowerCase(),Oe,xe,W,H,K);Ke&&(Ke[0]-=3,(!pe||Ke[0]>pe[0])&&(pe=Ke))}}}return pe}function ke(we,Te){if(Te+1>=we.length)return;const Oe=we[Te],xe=we[Te+1];if(Oe!==xe)return we.slice(0,Te)+xe+Oe+we.slice(Te+2)}}),define(Ce[54],De([1,0,12]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(o){return p(o,0)}e.hash=F;function p(o,i){switch(typeof o){case"object":return o===null?R(349,i):Array.isArray(o)?E(o,i):C(o,i);case"string":return w(o,i);case"boolean":return A(o,i);case"number":return R(o,i);case"undefined":return R(937,i);default:return R(617,i)}}e.doHash=p;function R(o,i){return(i<<5)-i+o|0}e.numberHash=R;function A(o,i){return R(o?433:863,i)}function w(o,i){i=R(149417,i);for(let n=0,r=o.length;n<r;n++)i=R(o.charCodeAt(n),i);return i}e.stringHash=w;function E(o,i){return i=R(104579,i),o.reduce((n,r)=>p(r,n),i)}function C(o,i){return i=R(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=w(r,n),p(o[r],n)),i)}class L{constructor(){this._value=0}get value(){return this._value}hash(i){return this._value=p(i,this._value),this._value}}e.Hasher=L;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(o,i,n=32){const r=n-i,a=~((1<<r)-1);return(o<<i|(a&o)>>>r)>>>0}function y(o,i=0,n=o.byteLength,r=0){for(let a=0;a<n;a++)o[i+a]=r}function _(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function l(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):_((o>>>0).toString(16),i/4)}e.toHexString=l;class b{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(i){const n=i.length;if(n===0)return;const r=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,h,u;for(t!==0?(h=t,u=-1,t=0):(h=i.charCodeAt(0),u=0);;){let s=h;if(P.isHighSurrogate(h))if(u+1<n){const c=i.charCodeAt(u+1);P.isLowSurrogate(c)?(u++,s=P.computeCodePoint(h,c)):s=65533}else{t=h;break}else P.isLowSurrogate(h)&&(s=65533);if(a=this._push(r,a,s),u++,u<n)h=i.charCodeAt(u);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this._step(),n-=64,this._totalLen+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const i=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(i/4294967296),!1),this._buffDV.setUint32(60,i%4294967296,!1),this._step()}_step(){const i=b._bigBlock32,n=this._buffDV;for(let m=0;m<64;m+=4)i.setUint32(m,n.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)i.setUint32(m,v(i.getUint32(m-12,!1)^i.getUint32(m-32,!1)^i.getUint32(m-56,!1)^i.getUint32(m-64,!1),1),!1);let r=this._h0,a=this._h1,t=this._h2,h=this._h3,u=this._h4,s,c,d;for(let m=0;m<80;m++)m<20?(s=a&t|~a&h,c=1518500249):m<40?(s=a^t^h,c=1859775393):m<60?(s=a&t|a&h|t&h,c=2400959708):(s=a^t^h,c=3395469782),d=v(r,5)+s+u+c+i.getUint32(m*4,!1)&4294967295,u=h,h=t,t=v(a,30),a=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+u&4294967295}}e.StringSHA1=b}),define(Ce[39],De([1,0,12]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(F||(F={})),function(p){const R="error",A="warning",w="warn",E="info",C="ignore";function L(v){return v?P.equalsIgnoreCase(R,v)?p.Error:P.equalsIgnoreCase(A,v)||P.equalsIgnoreCase(w,v)?p.Warning:P.equalsIgnoreCase(E,v)?p.Info:p.Ignore:p.Ignore}p.fromValue=L;function I(v){switch(v){case p.Error:return R;case p.Warning:return A;case p.Info:return E;default:return C}}p.toString=I}(F||(F={})),e.default=F}),define(Ce[164],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[77],De([1,0,19,12]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class p{constructor(){this._value="",this._pos=0}reset(y){return this._value=y,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(y){const _=y.charCodeAt(0),l=this._value.charCodeAt(this._pos);return _-l}value(){return this._value[this._pos]}}e.StringIterator=p;class R{constructor(y=!0){this._caseSensitive=y}reset(y){return this._value=y,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let y=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(y)this._from++;else break;else y=!1;return this}cmp(y){return this._caseSensitive?(0,F.compareSubstring)(y,this._value,0,y.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(y,this._value,0,y.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class A{constructor(y=!0,_=!0){this._splitOnBackslash=y,this._caseSensitive=_}reset(y){this._from=0,this._to=0,this._value=y,this._valueLen=y.length;for(let _=y.length-1;_>=0;_--,this._valueLen--){const l=this._value.charCodeAt(_);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let y=!0;for(;this._to<this._valueLen;this._to++){const _=this._value.charCodeAt(this._to);if(_===47||this._splitOnBackslash&&_===92)if(y)this._from++;else break;else y=!1}return this}cmp(y){return this._caseSensitive?(0,F.compareSubstring)(y,this._value,0,y.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(y,this._value,0,y.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var w;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(w||(w={}));class E{constructor(y,_){this._ignorePathCasing=y,this._ignoreQueryAndFragment=_,this._states=[],this._stateIdx=0}reset(y){return this._value=y,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(y)),this._pathIterator.reset(y.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(y)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(y){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(y,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(y,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(y);if(this._states[this._stateIdx]===4)return(0,F.compare)(y,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(y,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class I{static forUris(y=()=>!1,_=()=>!1){return new I(new E(y,_))}static forPaths(y=!1){return new I(new A(void 0,!y))}static forStrings(){return new I(new p)}static forConfigKeys(){return new I(new R)}constructor(y){this._iter=y}clear(){this._root=void 0}fill(y,_){if(_){const l=_.slice(0);(0,P.shuffle)(l);for(const b of l)this.set(b,y)}else{const l=y.slice(0);(0,P.shuffle)(l);for(const b of l)this.set(b[0],b[1])}}set(y,_){const l=this._iter.reset(y);let b;this._root||(this._root=new C,this._root.segment=l.value());const o=[];for(b=this._root;;){const n=l.cmp(b.segment);if(n>0)b.left||(b.left=new C,b.left.segment=l.value()),o.push([-1,b]),b=b.left;else if(n<0)b.right||(b.right=new C,b.right.segment=l.value()),o.push([1,b]),b=b.right;else if(l.hasNext())l.next(),b.mid||(b.mid=new C,b.mid.segment=l.value()),o.push([0,b]),b=b.mid;else break}const i=b.value;b.value=_,b.key=y;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=o[n][0],h=o[n+1][0];if(t===1&&h===1)o[n][1]=r.rotateLeft();else if(t===-1&&h===-1)o[n][1]=r.rotateRight();else if(t===1&&h===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&h===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this._root=o[0][1]}}return i}get(y){return this._getNode(y)?.value}_getNode(y){const _=this._iter.reset(y);let l=this._root;for(;l;){const b=_.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(_.hasNext())_.next(),l=l.mid;else break}return l}has(y){const _=this._getNode(y);return!(_?.value===void 0&&_?.mid===void 0)}delete(y){return this._delete(y,!1)}deleteSuperstr(y){return this._delete(y,!0)}_delete(y,_){const l=this._iter.reset(y),b=[];let o=this._root;for(;o;){const i=l.cmp(o.segment);if(i>0)b.push([-1,o]),o=o.left;else if(i<0)b.push([1,o]),o=o.right;else if(l.hasNext())l.next(),b.push([0,o]),o=o.mid;else break}if(o){if(_?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this._min(o.right);if(i.key){const{key:n,value:r,segment:a}=i;this._delete(i.key,!1),o.key=n,o.value=r,o.segment=a}}else{const i=o.left??o.right;if(b.length>0){const[n,r]=b[b.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this._root=i}for(let i=b.length-1;i>=0;i--){const n=b[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),b[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),b[i][1]=n.rotateRight()),i>0)switch(b[i-1][0]){case-1:b[i-1][1].left=b[i][1];break;case 1:b[i-1][1].right=b[i][1];break;case 0:b[i-1][1].mid=b[i][1];break}else this._root=b[0][1]}}}_min(y){for(;y.left;)y=y.left;return y}findSubstr(y){const _=this._iter.reset(y);let l=this._root,b;for(;l;){const o=_.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(_.hasNext())_.next(),b=l.value||b,l=l.mid;else break}return l&&l.value||b}findSuperstr(y){return this._findSuperstrOrElement(y,!1)}_findSuperstrOrElement(y,_){const l=this._iter.reset(y);let b=this._root;for(;b;){const o=l.cmp(b.segment);if(o>0)b=b.left;else if(o<0)b=b.right;else if(l.hasNext())l.next(),b=b.mid;else return b.mid?this._entries(b.mid):_?b.value:void 0}}hasElementOrSubtree(y){return this._findSuperstrOrElement(y,!0)!==void 0}forEach(y){for(const[_,l]of this)y(l,_)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(y){const _=[];return this._dfsEntries(y,_),_[Symbol.iterator]()}_dfsEntries(y,_){y&&(y.left&&this._dfsEntries(y.left,_),y.value&&_.push([y.key,y.value]),y.mid&&this._dfsEntries(y.mid,_),y.right&&this._dfsEntries(y.right,_))}_isBalanced(){const y=_=>{if(!_)return!0;const l=_.balanceFactor();return l<-1||l>1?!1:y(_.left)&&y(_.right)};return y(this._root)}}e.TernarySearchTree=I}),define(Ce[18],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function P(a){return typeof a=="string"}e.isString=P;function F(a){return Array.isArray(a)&&a.every(t=>P(t))}e.isStringArray=F;function p(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=p;function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.isTypedArray=R;function A(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=A;function w(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=w;function E(a){return a===!0||a===!1}e.isBoolean=E;function C(a){return typeof a>"u"}e.isUndefined=C;function L(a){return!I(a)}e.isDefined=L;function I(a){return C(a)||a===null}e.isUndefinedOrNull=I;function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=v;function y(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=y;function _(...a){const t=[];for(let h=0;h<a.length;h++){const u=a[h];if(I(u))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(u)}return t}e.assertAllDefined=_;const l=Object.prototype.hasOwnProperty;function b(a){if(!p(a))return!1;for(const t in a)if(l.call(a,t))return!1;return!0}e.isEmptyObject=b;function o(a){return typeof a=="function"}e.isFunction=o;function i(...a){return a.length>0&&a.every(o)}e.areFunctions=i;function n(a,t){const h=Math.min(a.length,t.length);for(let u=0;u<h;u++)r(a[u],t[u])}e.validateConstraints=n;function r(a,t){if(P(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r}),define(Ce[78],De([1,0,18]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const F=Object.create(null);function p(w,E){if((0,P.isString)(E)){const C=F[E];if(C===void 0)throw new Error(`${w} references an unknown codicon: ${E}`);E=C}return F[w]=E,{id:w}}function R(){return F}e.getCodiconFontCharacters=R;function A(){return Object.values(e.Codicon)}e.getAllCodicons=A,e.Codicon={add:p("add",6e4),plus:p("plus",6e4),gistNew:p("gist-new",6e4),repoCreate:p("repo-create",6e4),lightbulb:p("lightbulb",60001),lightBulb:p("light-bulb",60001),repo:p("repo",60002),repoDelete:p("repo-delete",60002),gistFork:p("gist-fork",60003),repoForked:p("repo-forked",60003),gitPullRequest:p("git-pull-request",60004),gitPullRequestAbandoned:p("git-pull-request-abandoned",60004),recordKeys:p("record-keys",60005),keyboard:p("keyboard",60005),tag:p("tag",60006),tagAdd:p("tag-add",60006),tagRemove:p("tag-remove",60006),gitPullRequestLabel:p("git-pull-request-label",60006),person:p("person",60007),personFollow:p("person-follow",60007),personOutline:p("person-outline",60007),personFilled:p("person-filled",60007),gitBranch:p("git-branch",60008),gitBranchCreate:p("git-branch-create",60008),gitBranchDelete:p("git-branch-delete",60008),sourceControl:p("source-control",60008),mirror:p("mirror",60009),mirrorPublic:p("mirror-public",60009),star:p("star",60010),starAdd:p("star-add",60010),starDelete:p("star-delete",60010),starEmpty:p("star-empty",60010),comment:p("comment",60011),commentAdd:p("comment-add",60011),alert:p("alert",60012),warning:p("warning",60012),search:p("search",60013),searchSave:p("search-save",60013),logOut:p("log-out",60014),signOut:p("sign-out",60014),logIn:p("log-in",60015),signIn:p("sign-in",60015),eye:p("eye",60016),eyeUnwatch:p("eye-unwatch",60016),eyeWatch:p("eye-watch",60016),circleFilled:p("circle-filled",60017),primitiveDot:p("primitive-dot",60017),closeDirty:p("close-dirty",60017),debugBreakpoint:p("debug-breakpoint",60017),debugBreakpointDisabled:p("debug-breakpoint-disabled",60017),debugBreakpointPending:p("debug-breakpoint-pending",60377),debugHint:p("debug-hint",60017),primitiveSquare:p("primitive-square",60018),edit:p("edit",60019),pencil:p("pencil",60019),info:p("info",60020),issueOpened:p("issue-opened",60020),gistPrivate:p("gist-private",60021),gitForkPrivate:p("git-fork-private",60021),lock:p("lock",60021),mirrorPrivate:p("mirror-private",60021),close:p("close",60022),removeClose:p("remove-close",60022),x:p("x",60022),repoSync:p("repo-sync",60023),sync:p("sync",60023),clone:p("clone",60024),desktopDownload:p("desktop-download",60024),beaker:p("beaker",60025),microscope:p("microscope",60025),vm:p("vm",60026),deviceDesktop:p("device-desktop",60026),file:p("file",60027),fileText:p("file-text",60027),more:p("more",60028),ellipsis:p("ellipsis",60028),kebabHorizontal:p("kebab-horizontal",60028),mailReply:p("mail-reply",60029),reply:p("reply",60029),organization:p("organization",60030),organizationFilled:p("organization-filled",60030),organizationOutline:p("organization-outline",60030),newFile:p("new-file",60031),fileAdd:p("file-add",60031),newFolder:p("new-folder",60032),fileDirectoryCreate:p("file-directory-create",60032),trash:p("trash",60033),trashcan:p("trashcan",60033),history:p("history",60034),clock:p("clock",60034),folder:p("folder",60035),fileDirectory:p("file-directory",60035),symbolFolder:p("symbol-folder",60035),logoGithub:p("logo-github",60036),markGithub:p("mark-github",60036),github:p("github",60036),terminal:p("terminal",60037),console:p("console",60037),repl:p("repl",60037),zap:p("zap",60038),symbolEvent:p("symbol-event",60038),error:p("error",60039),stop:p("stop",60039),variable:p("variable",60040),symbolVariable:p("symbol-variable",60040),array:p("array",60042),symbolArray:p("symbol-array",60042),symbolModule:p("symbol-module",60043),symbolPackage:p("symbol-package",60043),symbolNamespace:p("symbol-namespace",60043),symbolObject:p("symbol-object",60043),symbolMethod:p("symbol-method",60044),symbolFunction:p("symbol-function",60044),symbolConstructor:p("symbol-constructor",60044),symbolBoolean:p("symbol-boolean",60047),symbolNull:p("symbol-null",60047),symbolNumeric:p("symbol-numeric",60048),symbolNumber:p("symbol-number",60048),symbolStructure:p("symbol-structure",60049),symbolStruct:p("symbol-struct",60049),symbolParameter:p("symbol-parameter",60050),symbolTypeParameter:p("symbol-type-parameter",60050),symbolKey:p("symbol-key",60051),symbolText:p("symbol-text",60051),symbolReference:p("symbol-reference",60052),goToFile:p("go-to-file",60052),symbolEnum:p("symbol-enum",60053),symbolValue:p("symbol-value",60053),symbolRuler:p("symbol-ruler",60054),symbolUnit:p("symbol-unit",60054),activateBreakpoints:p("activate-breakpoints",60055),archive:p("archive",60056),arrowBoth:p("arrow-both",60057),arrowDown:p("arrow-down",60058),arrowLeft:p("arrow-left",60059),arrowRight:p("arrow-right",60060),arrowSmallDown:p("arrow-small-down",60061),arrowSmallLeft:p("arrow-small-left",60062),arrowSmallRight:p("arrow-small-right",60063),arrowSmallUp:p("arrow-small-up",60064),arrowUp:p("arrow-up",60065),bell:p("bell",60066),bold:p("bold",60067),book:p("book",60068),bookmark:p("bookmark",60069),debugBreakpointConditionalUnverified:p("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:p("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:p("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:p("debug-breakpoint-data-unverified",60072),debugBreakpointData:p("debug-breakpoint-data",60073),debugBreakpointDataDisabled:p("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:p("debug-breakpoint-log-unverified",60074),debugBreakpointLog:p("debug-breakpoint-log",60075),debugBreakpointLogDisabled:p("debug-breakpoint-log-disabled",60075),briefcase:p("briefcase",60076),broadcast:p("broadcast",60077),browser:p("browser",60078),bug:p("bug",60079),calendar:p("calendar",60080),caseSensitive:p("case-sensitive",60081),check:p("check",60082),checklist:p("checklist",60083),chevronDown:p("chevron-down",60084),dropDownButton:p("drop-down-button",60084),chevronLeft:p("chevron-left",60085),chevronRight:p("chevron-right",60086),chevronUp:p("chevron-up",60087),chromeClose:p("chrome-close",60088),chromeMaximize:p("chrome-maximize",60089),chromeMinimize:p("chrome-minimize",60090),chromeRestore:p("chrome-restore",60091),circle:p("circle",60092),circleOutline:p("circle-outline",60092),debugBreakpointUnverified:p("debug-breakpoint-unverified",60092),circleSlash:p("circle-slash",60093),circuitBoard:p("circuit-board",60094),clearAll:p("clear-all",60095),clippy:p("clippy",60096),closeAll:p("close-all",60097),cloudDownload:p("cloud-download",60098),cloudUpload:p("cloud-upload",60099),code:p("code",60100),collapseAll:p("collapse-all",60101),colorMode:p("color-mode",60102),commentDiscussion:p("comment-discussion",60103),compareChanges:p("compare-changes",60157),creditCard:p("credit-card",60105),dash:p("dash",60108),dashboard:p("dashboard",60109),database:p("database",60110),debugContinue:p("debug-continue",60111),debugDisconnect:p("debug-disconnect",60112),debugPause:p("debug-pause",60113),debugRestart:p("debug-restart",60114),debugStart:p("debug-start",60115),debugStepInto:p("debug-step-into",60116),debugStepOut:p("debug-step-out",60117),debugStepOver:p("debug-step-over",60118),debugStop:p("debug-stop",60119),debug:p("debug",60120),deviceCameraVideo:p("device-camera-video",60121),deviceCamera:p("device-camera",60122),deviceMobile:p("device-mobile",60123),diffAdded:p("diff-added",60124),diffIgnored:p("diff-ignored",60125),diffModified:p("diff-modified",60126),diffRemoved:p("diff-removed",60127),diffRenamed:p("diff-renamed",60128),diff:p("diff",60129),discard:p("discard",60130),editorLayout:p("editor-layout",60131),emptyWindow:p("empty-window",60132),exclude:p("exclude",60133),extensions:p("extensions",60134),eyeClosed:p("eye-closed",60135),fileBinary:p("file-binary",60136),fileCode:p("file-code",60137),fileMedia:p("file-media",60138),filePdf:p("file-pdf",60139),fileSubmodule:p("file-submodule",60140),fileSymlinkDirectory:p("file-symlink-directory",60141),fileSymlinkFile:p("file-symlink-file",60142),fileZip:p("file-zip",60143),files:p("files",60144),filter:p("filter",60145),flame:p("flame",60146),foldDown:p("fold-down",60147),foldUp:p("fold-up",60148),fold:p("fold",60149),folderActive:p("folder-active",60150),folderOpened:p("folder-opened",60151),gear:p("gear",60152),gift:p("gift",60153),gistSecret:p("gist-secret",60154),gist:p("gist",60155),gitCommit:p("git-commit",60156),gitCompare:p("git-compare",60157),gitMerge:p("git-merge",60158),githubAction:p("github-action",60159),githubAlt:p("github-alt",60160),globe:p("globe",60161),grabber:p("grabber",60162),graph:p("graph",60163),gripper:p("gripper",60164),heart:p("heart",60165),home:p("home",60166),horizontalRule:p("horizontal-rule",60167),hubot:p("hubot",60168),inbox:p("inbox",60169),issueClosed:p("issue-closed",60324),issueReopened:p("issue-reopened",60171),issues:p("issues",60172),italic:p("italic",60173),jersey:p("jersey",60174),json:p("json",60175),bracket:p("bracket",60175),kebabVertical:p("kebab-vertical",60176),key:p("key",60177),law:p("law",60178),lightbulbAutofix:p("lightbulb-autofix",60179),linkExternal:p("link-external",60180),link:p("link",60181),listOrdered:p("list-ordered",60182),listUnordered:p("list-unordered",60183),liveShare:p("live-share",60184),loading:p("loading",60185),location:p("location",60186),mailRead:p("mail-read",60187),mail:p("mail",60188),markdown:p("markdown",60189),megaphone:p("megaphone",60190),mention:p("mention",60191),milestone:p("milestone",60192),gitPullRequestMilestone:p("git-pull-request-milestone",60192),mortarBoard:p("mortar-board",60193),move:p("move",60194),multipleWindows:p("multiple-windows",60195),mute:p("mute",60196),noNewline:p("no-newline",60197),note:p("note",60198),octoface:p("octoface",60199),openPreview:p("open-preview",60200),package:p("package",60201),paintcan:p("paintcan",60202),pin:p("pin",60203),play:p("play",60204),run:p("run",60204),plug:p("plug",60205),preserveCase:p("preserve-case",60206),preview:p("preview",60207),project:p("project",60208),pulse:p("pulse",60209),question:p("question",60210),quote:p("quote",60211),radioTower:p("radio-tower",60212),reactions:p("reactions",60213),references:p("references",60214),refresh:p("refresh",60215),regex:p("regex",60216),remoteExplorer:p("remote-explorer",60217),remote:p("remote",60218),remove:p("remove",60219),replaceAll:p("replace-all",60220),replace:p("replace",60221),repoClone:p("repo-clone",60222),repoForcePush:p("repo-force-push",60223),repoPull:p("repo-pull",60224),repoPush:p("repo-push",60225),report:p("report",60226),requestChanges:p("request-changes",60227),rocket:p("rocket",60228),rootFolderOpened:p("root-folder-opened",60229),rootFolder:p("root-folder",60230),rss:p("rss",60231),ruby:p("ruby",60232),saveAll:p("save-all",60233),saveAs:p("save-as",60234),save:p("save",60235),screenFull:p("screen-full",60236),screenNormal:p("screen-normal",60237),searchStop:p("search-stop",60238),server:p("server",60240),settingsGear:p("settings-gear",60241),settings:p("settings",60242),shield:p("shield",60243),smiley:p("smiley",60244),sortPrecedence:p("sort-precedence",60245),splitHorizontal:p("split-horizontal",60246),splitVertical:p("split-vertical",60247),squirrel:p("squirrel",60248),starFull:p("star-full",60249),starHalf:p("star-half",60250),symbolClass:p("symbol-class",60251),symbolColor:p("symbol-color",60252),symbolCustomColor:p("symbol-customcolor",60252),symbolConstant:p("symbol-constant",60253),symbolEnumMember:p("symbol-enum-member",60254),symbolField:p("symbol-field",60255),symbolFile:p("symbol-file",60256),symbolInterface:p("symbol-interface",60257),symbolKeyword:p("symbol-keyword",60258),symbolMisc:p("symbol-misc",60259),symbolOperator:p("symbol-operator",60260),symbolProperty:p("symbol-property",60261),wrench:p("wrench",60261),wrenchSubaction:p("wrench-subaction",60261),symbolSnippet:p("symbol-snippet",60262),tasklist:p("tasklist",60263),telescope:p("telescope",60264),textSize:p("text-size",60265),threeBars:p("three-bars",60266),thumbsdown:p("thumbsdown",60267),thumbsup:p("thumbsup",60268),tools:p("tools",60269),triangleDown:p("triangle-down",60270),triangleLeft:p("triangle-left",60271),triangleRight:p("triangle-right",60272),triangleUp:p("triangle-up",60273),twitter:p("twitter",60274),unfold:p("unfold",60275),unlock:p("unlock",60276),unmute:p("unmute",60277),unverified:p("unverified",60278),verified:p("verified",60279),versions:p("versions",60280),vmActive:p("vm-active",60281),vmOutline:p("vm-outline",60282),vmRunning:p("vm-running",60283),watch:p("watch",60284),whitespace:p("whitespace",60285),wholeWord:p("whole-word",60286),window:p("window",60287),wordWrap:p("word-wrap",60288),zoomIn:p("zoom-in",60289),zoomOut:p("zoom-out",60290),listFilter:p("list-filter",60291),listFlat:p("list-flat",60292),listSelection:p("list-selection",60293),selection:p("selection",60293),listTree:p("list-tree",60294),debugBreakpointFunctionUnverified:p("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:p("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:p("debug-breakpoint-function-disabled",60296),debugStackframeActive:p("debug-stackframe-active",60297),circleSmallFilled:p("circle-small-filled",60298),debugStackframeDot:p("debug-stackframe-dot",60298),debugStackframe:p("debug-stackframe",60299),debugStackframeFocused:p("debug-stackframe-focused",60299),debugBreakpointUnsupported:p("debug-breakpoint-unsupported",60300),symbolString:p("symbol-string",60301),debugReverseContinue:p("debug-reverse-continue",60302),debugStepBack:p("debug-step-back",60303),debugRestartFrame:p("debug-restart-frame",60304),callIncoming:p("call-incoming",60306),callOutgoing:p("call-outgoing",60307),menu:p("menu",60308),expandAll:p("expand-all",60309),feedback:p("feedback",60310),gitPullRequestReviewer:p("git-pull-request-reviewer",60310),groupByRefType:p("group-by-ref-type",60311),ungroupByRefType:p("ungroup-by-ref-type",60312),account:p("account",60313),gitPullRequestAssignee:p("git-pull-request-assignee",60313),bellDot:p("bell-dot",60314),debugConsole:p("debug-console",60315),library:p("library",60316),output:p("output",60317),runAll:p("run-all",60318),syncIgnored:p("sync-ignored",60319),pinned:p("pinned",60320),githubInverted:p("github-inverted",60321),debugAlt:p("debug-alt",60305),serverProcess:p("server-process",60322),serverEnvironment:p("server-environment",60323),pass:p("pass",60324),stopCircle:p("stop-circle",60325),playCircle:p("play-circle",60326),record:p("record",60327),debugAltSmall:p("debug-alt-small",60328),vmConnect:p("vm-connect",60329),cloud:p("cloud",60330),merge:p("merge",60331),exportIcon:p("export",60332),graphLeft:p("graph-left",60333),magnet:p("magnet",60334),notebook:p("notebook",60335),redo:p("redo",60336),checkAll:p("check-all",60337),pinnedDirty:p("pinned-dirty",60338),passFilled:p("pass-filled",60339),circleLargeFilled:p("circle-large-filled",60340),circleLarge:p("circle-large",60341),circleLargeOutline:p("circle-large-outline",60341),combine:p("combine",60342),gather:p("gather",60342),table:p("table",60343),variableGroup:p("variable-group",60344),typeHierarchy:p("type-hierarchy",60345),typeHierarchySub:p("type-hierarchy-sub",60346),typeHierarchySuper:p("type-hierarchy-super",60347),gitPullRequestCreate:p("git-pull-request-create",60348),runAbove:p("run-above",60349),runBelow:p("run-below",60350),notebookTemplate:p("notebook-template",60351),debugRerun:p("debug-rerun",60352),workspaceTrusted:p("workspace-trusted",60353),workspaceUntrusted:p("workspace-untrusted",60354),workspaceUnspecified:p("workspace-unspecified",60355),terminalCmd:p("terminal-cmd",60356),terminalDebian:p("terminal-debian",60357),terminalLinux:p("terminal-linux",60358),terminalPowershell:p("terminal-powershell",60359),terminalTmux:p("terminal-tmux",60360),terminalUbuntu:p("terminal-ubuntu",60361),terminalBash:p("terminal-bash",60362),arrowSwap:p("arrow-swap",60363),copy:p("copy",60364),personAdd:p("person-add",60365),filterFilled:p("filter-filled",60366),wand:p("wand",60367),debugLineByLine:p("debug-line-by-line",60368),inspect:p("inspect",60369),layers:p("layers",60370),layersDot:p("layers-dot",60371),layersActive:p("layers-active",60372),compass:p("compass",60373),compassDot:p("compass-dot",60374),compassActive:p("compass-active",60375),azure:p("azure",60376),issueDraft:p("issue-draft",60377),gitPullRequestClosed:p("git-pull-request-closed",60378),gitPullRequestDraft:p("git-pull-request-draft",60379),debugAll:p("debug-all",60380),debugCoverage:p("debug-coverage",60381),runErrors:p("run-errors",60382),folderLibrary:p("folder-library",60383),debugContinueSmall:p("debug-continue-small",60384),beakerStop:p("beaker-stop",60385),graphLine:p("graph-line",60386),graphScatter:p("graph-scatter",60387),pieChart:p("pie-chart",60388),bracketDot:p("bracket-dot",60389),bracketError:p("bracket-error",60390),lockSmall:p("lock-small",60391),azureDevops:p("azure-devops",60392),verifiedFilled:p("verified-filled",60393),newLine:p("newline",60394),layout:p("layout",60395),layoutActivitybarLeft:p("layout-activitybar-left",60396),layoutActivitybarRight:p("layout-activitybar-right",60397),layoutPanelLeft:p("layout-panel-left",60398),layoutPanelCenter:p("layout-panel-center",60399),layoutPanelJustify:p("layout-panel-justify",60400),layoutPanelRight:p("layout-panel-right",60401),layoutPanel:p("layout-panel",60402),layoutSidebarLeft:p("layout-sidebar-left",60403),layoutSidebarRight:p("layout-sidebar-right",60404),layoutStatusbar:p("layout-statusbar",60405),layoutMenubar:p("layout-menubar",60406),layoutCentered:p("layout-centered",60407),layoutSidebarRightOff:p("layout-sidebar-right-off",60416),layoutPanelOff:p("layout-panel-off",60417),layoutSidebarLeftOff:p("layout-sidebar-left-off",60418),target:p("target",60408),indent:p("indent",60409),recordSmall:p("record-small",60410),errorSmall:p("error-small",60411),arrowCircleDown:p("arrow-circle-down",60412),arrowCircleLeft:p("arrow-circle-left",60413),arrowCircleRight:p("arrow-circle-right",60414),arrowCircleUp:p("arrow-circle-up",60415),heartFilled:p("heart-filled",60420),map:p("map",60421),mapFilled:p("map-filled",60422),circleSmall:p("circle-small",60423),bellSlash:p("bell-slash",60424),bellSlashDot:p("bell-slash-dot",60425),commentUnresolved:p("comment-unresolved",60426),gitPullRequestGoToChanges:p("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:p("git-pull-request-new-changes",60428),searchFuzzy:p("search-fuzzy",60429),commentDraft:p("comment-draft",60430),send:p("send",60431),sparkle:p("sparkle",60432),insert:p("insert",60433),mic:p("mic",60434),thumbsDownFilled:p("thumbsdown-filled",60435),thumbsUpFilled:p("thumbsup-filled",60436),coffee:p("coffee",60437),snake:p("snake",60438),game:p("game",60439),vr:p("vr",60440),chip:p("chip",60441),piano:p("piano",60442),music:p("music",60443),micFilled:p("mic-filled",60444),gitFetch:p("git-fetch",60445),copilot:p("copilot",60446),lightbulbSparkle:p("lightbulb-sparkle",60447),lightbulbSparkleAutofix:p("lightbulb-sparkle-autofix",60447),robot:p("robot",60448),sparkleFilled:p("sparkle-filled",60449),diffSingle:p("diff-single",60450),diffMultiple:p("diff-multiple",60451),surroundWith:p("surround-with",60452),gitStash:p("git-stash",60454),gitStashApply:p("git-stash-apply",60455),gitStashPop:p("git-stash-pop",60456),runAllCoverage:p("run-all-coverage",60461),runCoverage:p("run-all-coverage",60460),coverage:p("coverage",60462),githubProject:p("github-project",60463),dialogError:p("dialog-error","error"),dialogWarning:p("dialog-warning","warning"),dialogInfo:p("dialog-info","info"),dialogClose:p("dialog-close","close"),treeItemExpanded:p("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:p("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:p("tree-filter-on-type-off","list-selection"),treeFilterClear:p("tree-filter-clear","close"),treeItemLoading:p("tree-item-loading","loading"),menuSelection:p("menu-selection","check"),menuSubmenu:p("menu-submenu","chevron-right"),menuBarMore:p("menubar-more","more"),scrollbarButtonLeft:p("scrollbar-button-left","triangle-left"),scrollbarButtonRight:p("scrollbar-button-right","triangle-right"),scrollbarButtonUp:p("scrollbar-button-up","triangle-up"),scrollbarButtonDown:p("scrollbar-button-down","triangle-down"),toolBarMore:p("toolbar-more","more"),quickInputBack:p("quick-input-back","arrow-left")}}),define(Ce[24],De([1,0,18]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?F(r):r}),i}e.deepClone=F;function p(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(R.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,P.isTypedArray)(a)&&i.push(a)}}return o}e.deepFreeze=p;const R=Object.prototype.hasOwnProperty;function A(o,i){return w(o,i,new Set)}e.cloneAndChange=A;function w(o,i,n){if((0,P.isUndefinedOrNull)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const a=[];for(const t of o)a.push(w(t,i,n));return a}if((0,P.isObject)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)R.call(o,t)&&(a[t]=w(o[t],i,n));return n.delete(o),a}return o}function E(o,i,n=!0){return(0,P.isObject)(o)?((0,P.isObject)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,P.isObject)(o[r])&&(0,P.isObject)(i[r])?E(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.mixin=E;function C(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!C(o[n],i[n]))return!1}else{const a=[];for(r in o)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!C(a,t))return!1;for(n=0;n<a.length;n++)if(!C(o[a[n]],i[a[n]]))return!1}return!0}e.equals=C;function L(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,P.isObject)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.safeStringify=L;function I(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],h=i[a];C(t,h)||(n[a]=h)}),n}e.distinct=I;function v(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(a=>a.toLowerCase()===n);return r?o[r]:o[i]}e.getCaseInsensitive=v;function y(o,i){const n=Object.create(null);for(const[r,a]of Object.entries(o))i(r,a)&&(n[r]=a);return n}e.filter=y;function _(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.getAllPropertyNames=_;function l(o){const i=[];for(const n of _(o))typeof o[n]=="function"&&i.push(n);return i}e.getAllMethodNames=l;function b(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of o)r[a]=n(a);return r}e.createProxyObject=b}),define(Ce[55],De([1,0,78]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var F;(function(A){function w(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=w})(F||(e.ThemeColor=F={}));function p(A){return{id:A}}e.themeColorFromId=p;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(i){const n=w.exec(i.id);if(!n)return E(P.Codicon.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=E;function C(i){return E(i).join(" ")}A.asClassName=C;function L(i){return"."+E(i).join(".")}A.asCSSSelector=L;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}A.isThemeIcon=I;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(i){const n=v.exec(i);if(!n)return;const[,r]=n;return{id:r}}A.fromString=y;function _(i){return{id:i}}A.fromId=_;function l(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}A.modify=l;function b(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}A.getModifier=b;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}A.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(Ce[165],De([1,0,123,12,55]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",A=new RegExp(`\\$\\(${p.ThemeIcon.iconNameExpression}(?:${p.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${A.source}`,"g");function E(o){return o.replace(w,(i,n)=>n?i:`\\${i}`)}e.escapeIcons=E;const C=new RegExp(`\\\\${A.source}`,"g");function L(o){return o.replace(C,i=>`\\${i}`)}e.markdownEscapeEscapedIcons=L;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(o){return o.indexOf(R)===-1?o:o.replace(I,(i,n,r,a)=>r?i:n||a||"")}e.stripIcons=v;function y(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=y;const _=new RegExp(`\\$\\(${p.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(o){_.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=_.lastIndex,t=_.exec(o),h=o.substring(a,t?.index);if(h.length>0){i+=h;for(let u=0;u<h.length;u++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.parseLabelWithIcons=l;function b(o,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,P.matchesFuzzy)(o,r,n);const t=(0,F.ltrim)(r," "),h=r.length-t.length,u=(0,P.matchesFuzzy)(o,t,n);if(u)for(const s of u){const c=a[s.start+h]+h;s.start+=c,s.end+=c}return u}e.matchesFuzzyIconAware=b}),define(Ce[124],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var P;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function F(R){return R<0?0:R>255?255:R|0}e.toUint8=F;function p(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=p}),define(Ce[30],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(p){return P.test(p)}e.isUUID=F,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let p;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?p=crypto.getRandomValues.bind(crypto):p=function(w){for(let E=0;E<w.length;E++)w[E]=Math.floor(Math.random()*256);return w};const R=new Uint8Array(16),A=[];for(let w=0;w<256;w++)A.push(w.toString(16).padStart(2,"0"));return function(){p(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let E=0,C="";return C+=A[R[E++]],C+=A[R[E++]],C+=A[R[E++]],C+=A[R[E++]],C+="-",C+=A[R[E++]],C+=A[R[E++]],C+="-",C+=A[R[E++]],C+=A[R[E++]],C+="-",C+=A[R[E++]],C+=A[R[E++]],C+="-",C+=A[R[E++]],C+=A[R[E++]],C+=A[R[E++]],C+=A[R[E++]],C+=A[R[E++]],C+=A[R[E++]],C}}()}),define(Ce[166],De([1,0,19,48,30]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.createStringDataTransferItem=R;function A(I,v,y){const _={id:(0,p.generateUuid)(),name:I,uri:v,data:y};return{asString:async()=>"",asFile:()=>_,value:void 0}}e.createFileDataTransferItem=A;class w{constructor(){this._entries=new Map}get size(){let v=0;for(const y of this._entries)v++;return v}has(v){return this._entries.has(this.toKey(v))}matches(v){const y=[...this._entries.keys()];return F.Iterable.some(this,([_,l])=>l.asFile())&&y.push("files"),L(E(v),y)}get(v){return this._entries.get(this.toKey(v))?.[0]}append(v,y){const _=this._entries.get(v);_?_.push(y):this._entries.set(this.toKey(v),[y])}replace(v,y){this._entries.set(this.toKey(v),[y])}delete(v){this._entries.delete(this.toKey(v))}*[Symbol.iterator](){for(const[v,y]of this._entries)for(const _ of y)yield[v,_]}toKey(v){return E(v)}}e.VSDataTransfer=w;function E(I){return I.toLowerCase()}function C(I,v){return L(E(I),v.map(E))}e.matchesMimeType=C;function L(I,v){if(I==="*/*")return v.length>0;if(v.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[_,l,b]=y;return b==="*"?v.some(o=>o.startsWith(l+"/")):!1}e.UriList=Object.freeze({create:I=>(0,P.distinct)(I.map(v=>v.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.UriList.split(I).filter(v=>!v.startsWith("#"))})}),define(Ce[167],De([1,0,62]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function F(w,E,C,L=1){let I=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!I)return I=!0,v(0)},C);p(w,E,L,_=>{if(!I)return I=!0,clearTimeout(y),v(_)})})}e.findFreePort=F;function p(w,E,C,L){if(E===0)return L(0);const I=new P.Socket;I.once("connect",()=>(A(I),p(w+C,E-1,C,L))),I.once("data",()=>{}),I.once("error",v=>(A(I),v.code!=="ECONNREFUSED"?p(w+C,E-1,C,L):L(w))),I.connect(w,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(w,E,C,L="127.0.0.1"){let I=!1,v,y=1;const _=P.createServer({pauseOnConnect:!0});function l(b,o){I||(I=!0,_.removeAllListeners(),_.close(),v&&clearTimeout(v),o(b))}return new Promise(b=>{v=setTimeout(()=>{l(0,b)},C),_.on("listening",()=>{l(w,b)}),_.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<E?(w++,y++,_.listen(w,L)):l(0,b)}),_.on("close",()=>{l(0,b)}),_.listen(w,L)})}e.findFreePortFaster=R;function A(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(E){console.error(E)}}}),define(Ce[125],De([1,0,124]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(w){const E=(0,P.toUint8)(w);this._defaultValue=E,this._asciiMap=F._createAsciiMap(E),this._map=new Map}static _createAsciiMap(w){const E=new Uint8Array(256);return E.fill(w),E}set(w,E){const C=(0,P.toUint8)(E);w>=0&&w<256?this._asciiMap[w]=C:this._map.set(w,C)}get(w){return w>=0&&w<256?this._asciiMap[w]:this._map.get(w)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=F;var p;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(p||(p={}));class R{constructor(){this._actual=new F(0)}add(w){this._actual.set(w,1)}has(w){return this._actual.get(w)===1}clear(){return this._actual.clear()}}e.CharacterSet=R}),define(Ce[168],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var P;(function(p){p[p.Unknown=0]="Unknown",p[p.Invalid=3]="Invalid",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function F(p){let R=0,A=0,w=0,E=0;for(let C=0,L=p.length;C<L;C++){const I=p.charCodeAt(C);I===13?(R===0&&(A=C),R++,C+1<L&&p.charCodeAt(C+1)===10?(E|=2,C++):E|=3,w=C+1):I===10&&(E|=1,R===0&&(A=C),R++,w=C+1)}return R===0&&(A=p.length),[R,A,p.length-w,E]}e.countEOL=F}),define(Ce[49],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class P{constructor(p,R){this.lineNumber=p,this.column=R}with(p=this.lineNumber,R=this.column){return p===this.lineNumber&&R===this.column?this:new P(p,R)}delta(p=0,R=0){return this.with(this.lineNumber+p,this.column+R)}equals(p){return P.equals(this,p)}static equals(p,R){return!p&&!R?!0:!!p&&!!R&&p.lineNumber===R.lineNumber&&p.column===R.column}isBefore(p){return P.isBefore(this,p)}static isBefore(p,R){return p.lineNumber<R.lineNumber?!0:R.lineNumber<p.lineNumber?!1:p.column<R.column}isBeforeOrEqual(p){return P.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,R){return p.lineNumber<R.lineNumber?!0:R.lineNumber<p.lineNumber?!1:p.column<=R.column}static compare(p,R){const A=p.lineNumber|0,w=R.lineNumber|0;if(A===w){const E=p.column|0,C=R.column|0;return E-C}return A-w}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new P(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=P}),define(Ce[29],De([1,0,49]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(R,A,w,E){R>w||R===w&&A>E?(this.startLineNumber=w,this.startColumn=E,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=w,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return F.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return F.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return F.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return F.plusRange(this,R)}static plusRange(R,A){let w,E,C,L;return A.startLineNumber<R.startLineNumber?(w=A.startLineNumber,E=A.startColumn):A.startLineNumber===R.startLineNumber?(w=A.startLineNumber,E=Math.min(A.startColumn,R.startColumn)):(w=R.startLineNumber,E=R.startColumn),A.endLineNumber>R.endLineNumber?(C=A.endLineNumber,L=A.endColumn):A.endLineNumber===R.endLineNumber?(C=A.endLineNumber,L=Math.max(A.endColumn,R.endColumn)):(C=R.endLineNumber,L=R.endColumn),new F(w,E,C,L)}intersectRanges(R){return F.intersectRanges(this,R)}static intersectRanges(R,A){let w=R.startLineNumber,E=R.startColumn,C=R.endLineNumber,L=R.endColumn;const I=A.startLineNumber,v=A.startColumn,y=A.endLineNumber,_=A.endColumn;return w<I?(w=I,E=v):w===I&&(E=Math.max(E,v)),C>y?(C=y,L=_):C===y&&(L=Math.min(L,_)),w>C||w===C&&E>L?null:new F(w,E,C,L)}equalsRange(R){return F.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(R){return new P.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(R){return new P.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new F(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new F(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(R){return new F(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(R){return new F(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new F(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new F(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new F(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const C=R.startLineNumber|0,L=A.startLineNumber|0;if(C===L){const I=R.startColumn|0,v=A.startColumn|0;if(I===v){const y=R.endLineNumber|0,_=A.endLineNumber|0;if(y===_){const l=R.endColumn|0,b=A.endColumn|0;return l-b}return y-_}return I-v}return C-L}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=F}),define(Ce[169],De([1,0,29]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class F{static insert(R,A){return{range:new P.Range(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.EditOperation=F}),define(Ce[170],De([1,0,49,29]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var p;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(p||(e.SelectionDirection=p={}));class R extends F.Range{constructor(w,E,C,L){super(w,E,C,L),this.selectionStartLineNumber=w,this.selectionStartColumn=E,this.positionLineNumber=C,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return R.selectionsEqual(this,w)}static selectionsEqual(w,E){return w.selectionStartLineNumber===E.selectionStartLineNumber&&w.selectionStartColumn===E.selectionStartColumn&&w.positionLineNumber===E.positionLineNumber&&w.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,E){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,w,E):new R(w,E,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new P.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,E){return this.getDirection()===0?new R(w,E,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,w,E)}static fromPositions(w,E=w){return new R(w.lineNumber,w.column,E.lineNumber,E.column)}static fromRange(w,E){return E===0?new R(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new R(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new R(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,E){if(w&&!E||!w&&E)return!1;if(!w&&!E)return!0;if(w.length!==E.length)return!1;for(let C=0,L=w.length;C<L;C++)if(!this.selectionsEqual(w[C],E[C]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,E,C,L,I){return I===0?new R(w,E,C,L):new R(C,L,w,E)}}e.Selection=R}),define(Ce[171],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[172],De([1,0,125]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class p extends P.CharacterClassifier{constructor(w){super(0);for(let E=0,C=w.length;E<C;E++)this.set(w.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=p;function R(A){const w={};return E=>(w.hasOwnProperty(E)||(w[E]=A(E)),w[E])}e.getMapForWordSeparators=R(A=>new p(A))}),define(Ce[126],De([1,0,48,3,75]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)I.indexOf(y)>=0||(v+="\\"+y);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function A(I){let v=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)v=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),v=new RegExp(I.source,y)}return v.lastIndex=0,v}e.ensureValidWordDefinition=A;const w=new p.LinkedList;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const v=w.unshift(I);return(0,F.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=E;function C(I,v,y,_,l){if(v=A(v),l||(l=P.Iterable.first(w)),y.length>l.maxLen){let r=I-l.maxLen/2;return r<0?r=0:_+=r,y=y.substring(r,I+l.maxLen/2),C(I,v,y,_,l)}const b=Date.now(),o=I-1-_;let i=-1,n=null;for(let r=1;!(Date.now()-b>=l.timeBudget);r++){const a=o-l.windowSize*r;v.lastIndex=Math.max(0,a);const t=L(v,y,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:_+1+n.index,endColumn:_+1+n.index+n[0].length};return v.lastIndex=0,r}return null}e.getWordAtText=C;function L(I,v,y,_){let l;for(;l=I.exec(v);){const b=l.index||0;if(b<=y&&I.lastIndex>=y)return l;if(_>0&&b>_)return null}return null}}),define(Ce[173],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var P;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class F{constructor(w){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=w.open,this.close=w.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(w.notIn))for(let E=0,C=w.notIn.length;E<C;E++)switch(w.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(w,E){if(w.getTokenCount()===0)return!0;const C=w.findTokenIndexAtOffset(E-2),L=w.getStandardTokenType(C);return this.isOK(L)}_findNeutralCharacterInRange(w,E){for(let C=w;C<=E;C++){const L=String.fromCharCode(C);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class p{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of w)R(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),R(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),R(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),R(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&R(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=p;function R(A,w,E){A.has(w)?A.get(w).push(E):A.set(w,[E])}}),define(Ce[174],De([1,0,125]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class p{constructor(_,l,b){const o=new Uint8Array(_*l);for(let i=0,n=_*l;i<n;i++)o[i]=b;this._data=o,this.rows=_,this.cols=l}get(_,l){return this._data[_*this.cols+l]}set(_,l,b){this._data[_*this.cols+l]=b}}class R{constructor(_){let l=0,b=0;for(let i=0,n=_.length;i<n;i++){const[r,a,t]=_[i];a>l&&(l=a),r>b&&(b=r),t>b&&(b=t)}l++,b++;const o=new p(b,l,0);for(let i=0,n=_.length;i<n;i++){const[r,a,t]=_[i];o.set(r,a,t)}this._states=o,this._maxCharCode=l}nextState(_,l){return l<0||l>=this._maxCharCode?0:this._states.get(_,l)}}e.StateMachine=R;let A=null;function w(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let C=null;function L(){if(C===null){C=new P.CharacterClassifier(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<y.length;l++)C.set(y.charCodeAt(l),1);const _=".,;:";for(let l=0;l<_.length;l++)C.set(_.charCodeAt(l),2)}return C}class I{static _createLink(_,l,b,o,i){let n=i-1;do{const r=l.charCodeAt(n);if(_.get(r)!==2)break;n--}while(n>o);if(o>0){const r=l.charCodeAt(o-1),a=l.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:b,startColumn:o+1,endLineNumber:b,endColumn:n+2},url:l.substring(o,n+1)}}static computeLinks(_,l=w()){const b=L(),o=[];for(let i=1,n=_.getLineCount();i<=n;i++){const r=_.getLineContent(i),a=r.length;let t=0,h=0,u=0,s=1,c=!1,d=!1,m=!1,D=!1;for(;t<a;){let g=!1;const f=r.charCodeAt(t);if(s===13){let S;switch(f){case 40:c=!0,S=0;break;case 41:S=c?0:1;break;case 91:m=!0,d=!0,S=0;break;case 93:m=!1,S=d?0:1;break;case 123:D=!0,S=0;break;case 125:S=D?0:1;break;case 39:case 34:case 96:u===f?S=1:u===39||u===34||u===96?S=0:S=1;break;case 42:S=u===42?1:0;break;case 124:S=u===124?1:0;break;case 32:S=m?0:1;break;default:S=b.get(f)}S===1&&(o.push(I._createLink(b,r,i,h,t)),g=!0)}else if(s===12){let S;f===91?(d=!0,S=0):S=b.get(f),S===1?g=!0:s=13}else s=l.nextState(s,f),s===0&&(g=!0);g&&(s=1,c=!1,d=!1,D=!1,h=t+1,u=f),t++}s===13&&o.push(I._createLink(b,r,i,h,a))}return o}}e.LinkComputer=I;function v(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.computeLinks=v}),define(Ce[79],De([1,0,24]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var p;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(p||(e.GlyphMarginLane=p={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var w;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var E;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var C;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(C||(e.EndOfLineSequence=C={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,a.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this._indentSizeIsTabSize===a._indentSizeIsTabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,P.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=L;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.FindMatch=I;var v;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function y(r){return r&&typeof r.read=="function"}e.isITextSnapshot=y;var _;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(_||(e.PositionAffinity=_={}));var l;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class b{constructor(a,t,h,u,s,c){this.identifier=a,this.range=t,this.text=h,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=s,this._isTracked=c}}e.ValidAnnotatedEditOperation=b;class o{constructor(a,t,h){this.regex=a,this.wordSeparators=t,this.simpleSearch=h}}e.SearchData=o;class i{constructor(a,t,h){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.shouldSynchronizeModel=n}),define(Ce[175],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.recomputeTreeMetadata=e.updateTreeMetadata=e.fixInsert=e.rbDelete=e.rightRotate=e.leftRotate=e.righttest=e.leftest=e.SENTINEL=e.NodeColor=e.TreeNode=void 0;class P{constructor(b,o){this.piece=b,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return p(this.right);let b=this;for(;b.parent!==e.SENTINEL&&b.parent.left!==b;)b=b.parent;return b.parent===e.SENTINEL?e.SENTINEL:b.parent}prev(){if(this.left!==e.SENTINEL)return R(this.left);let b=this;for(;b.parent!==e.SENTINEL&&b.parent.right!==b;)b=b.parent;return b.parent===e.SENTINEL?e.SENTINEL:b.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=P;var F;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(F||(e.NodeColor=F={})),e.SENTINEL=new P(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function p(l){for(;l.left!==e.SENTINEL;)l=l.left;return l}e.leftest=p;function R(l){for(;l.right!==e.SENTINEL;)l=l.right;return l}e.righttest=R;function A(l){return l===e.SENTINEL?0:l.size_left+l.piece.length+A(l.right)}function w(l){return l===e.SENTINEL?0:l.lf_left+l.piece.lineFeedCnt+w(l.right)}function E(){e.SENTINEL.parent=e.SENTINEL}function C(l,b){const o=b.right;o.size_left+=b.size_left+(b.piece?b.piece.length:0),o.lf_left+=b.lf_left+(b.piece?b.piece.lineFeedCnt:0),b.right=o.left,o.left!==e.SENTINEL&&(o.left.parent=b),o.parent=b.parent,b.parent===e.SENTINEL?l.root=o:b.parent.left===b?b.parent.left=o:b.parent.right=o,o.left=b,b.parent=o}e.leftRotate=C;function L(l,b){const o=b.left;b.left=o.right,o.right!==e.SENTINEL&&(o.right.parent=b),o.parent=b.parent,b.size_left-=o.size_left+(o.piece?o.piece.length:0),b.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),b.parent===e.SENTINEL?l.root=o:b===b.parent.right?b.parent.right=o:b.parent.left=o,o.right=b,b.parent=o}e.rightRotate=L;function I(l,b){let o,i;if(b.left===e.SENTINEL?(i=b,o=i.right):b.right===e.SENTINEL?(i=b,o=i.left):(i=p(b.right),o=i.right),i===l.root){l.root=o,o.color=0,b.detach(),E(),l.root.parent=e.SENTINEL;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===b?(o.parent=i.parent,_(l,o)):(i.parent===b?o.parent=i:o.parent=i.parent,_(l,o),i.left=b.left,i.right=b.right,i.parent=b.parent,i.color=b.color,b===l.root?l.root=i:b===b.parent.left?b.parent.left=i:b.parent.right=i,i.left!==e.SENTINEL&&(i.left.parent=i),i.right!==e.SENTINEL&&(i.right.parent=i),i.size_left=b.size_left,i.lf_left=b.lf_left,_(l,i)),b.detach(),o.parent.left===o){const a=A(o),t=w(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const h=a-o.parent.size_left,u=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,y(l,o.parent,h,u)}}if(_(l,o.parent),n){E();return}let r;for(;o!==l.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,C(l,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,L(l,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,C(l,o.parent),o=l.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,L(l,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,C(l,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,L(l,o.parent),o=l.root));o.color=0,E()}e.rbDelete=I;function v(l,b){for(_(l,b);b!==l.root&&b.parent.color===1;)if(b.parent===b.parent.parent.left){const o=b.parent.parent.right;o.color===1?(b.parent.color=0,o.color=0,b.parent.parent.color=1,b=b.parent.parent):(b===b.parent.right&&(b=b.parent,C(l,b)),b.parent.color=0,b.parent.parent.color=1,L(l,b.parent.parent))}else{const o=b.parent.parent.left;o.color===1?(b.parent.color=0,o.color=0,b.parent.parent.color=1,b=b.parent.parent):(b===b.parent.left&&(b=b.parent,L(l,b)),b.parent.color=0,b.parent.parent.color=1,C(l,b.parent.parent))}l.root.color=0}e.fixInsert=v;function y(l,b,o,i){for(;b!==l.root&&b!==e.SENTINEL;)b.parent.left===b&&(b.parent.size_left+=o,b.parent.lf_left+=i),b=b.parent}e.updateTreeMetadata=y;function _(l,b){let o=0,i=0;if(b!==l.root){for(;b!==l.root&&b===b.parent.right;)b=b.parent;if(b!==l.root)for(b=b.parent,o=A(b.left)-b.size_left,i=w(b.left)-b.lf_left,b.size_left+=o,b.lf_left+=i;b!==l.root&&(o!==0||i!==0);)b.parent.left===b&&(b.parent.size_left+=o,b.parent.lf_left+=i),b=b.parent}}e.recomputeTreeMetadata=_}),define(Ce[176],De([1,0,19,124]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class p{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,C){E=(0,F.toUint32)(E);const L=this.values,I=this.prefixSum,v=C.length;return v===0?!1:(this.values=new Uint32Array(L.length+v),this.values.set(L.subarray(0,E),0),this.values.set(L.subarray(E),E+v),this.values.set(C,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,C){return E=(0,F.toUint32)(E),C=(0,F.toUint32)(C),this.values[E]===C?!1:(this.values[E]=C,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,C){E=(0,F.toUint32)(E),C=(0,F.toUint32)(C);const L=this.values,I=this.prefixSum;if(E>=L.length)return!1;const v=L.length-E;return C>=v&&(C=v),C===0?!1:(this.values=new Uint32Array(L.length-C),this.values.set(L.subarray(0,E),0),this.values.set(L.subarray(E+C),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),E>=this.values.length&&(E=this.values.length-1);for(let L=C;L<=E;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let C=0,L=this.values.length-1,I=0,v=0,y=0;for(;C<=L;)if(I=C+(L-C)/2|0,v=this.prefixSum[I],y=v-this.values[I],E<y)L=I-1;else if(E>=v)C=I+1;else break;return new A(I,E-y)}}e.PrefixSumComputer=p;class R{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const C=this._indexBySum[E],L=C>0?this._prefixSum[C-1]:0;return new A(C,E-L)}removeValues(E,C){this._values.splice(E,C),this._invalidate(E)}insertValues(E,C){this._values=(0,P.arrayInsert)(this._values,E,C),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,C=this._values.length;E<C;E++){const L=this._values[E],I=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=I+L;for(let v=0;v<L;v++)this._indexBySum[I+v]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,C){this._values[E]!==C&&(this._values[E]=C,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=R;class A{constructor(E,C){this.index=E,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=C}}e.PrefixSumIndexOfResult=A}),define(Ce[177],De([1,0,12,49,176]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(w,E,C,L){this._uri=w,this._lines=E,this._eol=C,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(w){w.eol&&w.eol!==this._eol&&(this._eol=w.eol,this._lineStarts=null);const E=w.changes;for(const C of E)this._acceptDeleteRange(C.range),this._acceptInsertText(new F.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=w.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const w=this._eol.length,E=this._lines.length,C=new Uint32Array(E);for(let L=0;L<E;L++)C[L]=this._lines[L].length+w;this._lineStarts=new p.PrefixSumComputer(C)}}_setLineText(w,E){this._lines[w]=E,this._lineStarts&&this._lineStarts.setValue(w,this._lines[w].length+this._eol.length)}_acceptDeleteRange(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this._setLineText(w.startLineNumber-1,this._lines[w.startLineNumber-1].substring(0,w.startColumn-1)+this._lines[w.startLineNumber-1].substring(w.endColumn-1));return}this._setLineText(w.startLineNumber-1,this._lines[w.startLineNumber-1].substring(0,w.startColumn-1)+this._lines[w.endLineNumber-1].substring(w.endColumn-1)),this._lines.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}_acceptInsertText(w,E){if(E.length===0)return;const C=(0,P.splitLines)(E);if(C.length===1){this._setLineText(w.lineNumber-1,this._lines[w.lineNumber-1].substring(0,w.column-1)+C[0]+this._lines[w.lineNumber-1].substring(w.column-1));return}C[C.length-1]+=this._lines[w.lineNumber-1].substring(w.column-1),this._setLineText(w.lineNumber-1,this._lines[w.lineNumber-1].substring(0,w.column-1)+C[0]);const L=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(w.lineNumber+I-1,0,C[I]),L[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(w.lineNumber,L)}}e.MirrorTextModel=R}),define(Ce[99],De([1,0,12,172,49,29,79]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const w=999;class E{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=C(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=P.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new A.SearchData(n,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,r?this.searchString:null)}}e.SearchParams=E;function C(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.isMultilineRegexSource=C;function L(o,i,n){if(!n)return new A.FindMatch(o,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new A.FindMatch(o,r)}e.createFindMatch=L;class I{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this._lineFeedsOffsets=n}findLineFeedCountBeforeOffset(i){const n=this._lineFeedsOffsets;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class v{static findMatches(i,n,r,a,t){const h=n.parseSearchRequest();return h?h.regex.multiline?this._doFindMatchesMultiline(i,r,new b(h.wordSeparators,h.regex),a,t):this._doFindMatchesLineByLine(i,r,h,a,t):[]}static _getMultilineMatchRange(i,n,r,a,t,h){let u,s=0;a?(s=a.findLineFeedCountBeforeOffset(t),u=n+t+s):u=n+t;let c;if(a){const g=a.findLineFeedCountBeforeOffset(t+h.length)-s;c=u+h.length+g}else c=u+h.length;const d=i.getPositionAt(u),m=i.getPositionAt(c);return new R.Range(d.lineNumber,d.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(i,n,r,a,t){const h=i.getOffsetAt(n.getStartPosition()),u=i.getValueInRange(n,1),s=i.getEOL()===`\r
`?new I(u):null,c=[];let d=0,m;for(r.reset(0);m=r.next(u);)if(c[d++]=L(this._getMultilineMatchRange(i,h,u,s,m.index,m[0]),m,a),d>=t)return c;return c}static _doFindMatchesLineByLine(i,n,r,a,t){const h=[];let u=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return u=this._findMatchesInLine(r,c,n.startLineNumber,n.startColumn-1,u,h,a,t),h}const s=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);u=this._findMatchesInLine(r,s,n.startLineNumber,n.startColumn-1,u,h,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&u<t;c++)u=this._findMatchesInLine(r,i.getLineContent(c),c,0,u,h,a,t);if(u<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);u=this._findMatchesInLine(r,c,n.endLineNumber,0,u,h,a,t)}return h}static _findMatchesInLine(i,n,r,a,t,h,u,s){const c=i.wordSeparators;if(!u&&i.simpleSearch){const D=i.simpleSearch,g=D.length,f=n.length;let S=-g;for(;(S=n.indexOf(D,S+g))!==-1;)if((!c||l(c,n,f,S,g))&&(h[t++]=new A.FindMatch(new R.Range(r,S+1+a,r,S+1+g+a),null),t>=s))return t;return t}const d=new b(i.wordSeparators,i.regex);let m;d.reset(0);do if(m=d.next(n),m&&(h[t++]=L(new R.Range(r,m.index+1+a,r,m.index+1+m[0].length+a),m,u),t>=s))return t;while(m);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const h=new b(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(i,r,h,a):this._doFindNextMatchLineByLine(i,r,h,a)}static _doFindNextMatchMultiline(i,n,r,a){const t=new p.Position(n.lineNumber,1),h=i.getOffsetAt(t),u=i.getLineCount(),s=i.getValueInRange(new R.Range(t.lineNumber,t.column,u,i.getLineMaxColumn(u)),1),c=i.getEOL()===`\r
`?new I(s):null;r.reset(n.column-1);const d=r.next(s);return d?L(this._getMultilineMatchRange(i,h,s,c,d.index,d[0]),d,a):n.lineNumber!==1||n.column!==1?this._doFindNextMatchMultiline(i,new p.Position(1,1),r,a):null}static _doFindNextMatchLineByLine(i,n,r,a){const t=i.getLineCount(),h=n.lineNumber,u=i.getLineContent(h),s=this._findFirstMatchInLine(r,u,h,n.column,a);if(s)return s;for(let c=1;c<=t;c++){const d=(h+c-1)%t,m=i.getLineContent(d+1),D=this._findFirstMatchInLine(r,m,d+1,1,a);if(D)return D}return null}static _findFirstMatchInLine(i,n,r,a,t){i.reset(a-1);const h=i.next(n);return h?L(new R.Range(r,h.index+1,r,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const h=new b(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(i,r,h,a):this._doFindPreviousMatchLineByLine(i,r,h,a)}static _doFindPreviousMatchMultiline(i,n,r,a){const t=this._doFindMatchesMultiline(i,new R.Range(1,1,n.lineNumber,n.column),r,a,10*w);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return n.lineNumber!==h||n.column!==i.getLineMaxColumn(h)?this._doFindPreviousMatchMultiline(i,new p.Position(h,i.getLineMaxColumn(h)),r,a):null}static _doFindPreviousMatchLineByLine(i,n,r,a){const t=i.getLineCount(),h=n.lineNumber,u=i.getLineContent(h).substring(0,n.column-1),s=this._findLastMatchInLine(r,u,h,a);if(s)return s;for(let c=1;c<=t;c++){const d=(t+h-c-1)%t,m=i.getLineContent(d+1),D=this._findLastMatchInLine(r,m,d+1,a);if(D)return D}return null}static _findLastMatchInLine(i,n,r,a){let t=null,h;for(i.reset(0);h=i.next(n);)t=L(new R.Range(r,h.index+1,r,h.index+1+h[0].length),h,a);return t}}e.TextModelSearch=v;function y(o,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(r);if(o.get(h)!==0)return!0}return!1}function _(o,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(r+a-1);if(o.get(h)!==0)return!0}return!1}function l(o,i,n,r,a){return y(o,i,n,r,a)&&_(o,i,n,r,a)}e.isValidMatch=l;class b{constructor(i,n){this._wordSeparators=i,this._searchRegex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(i){this._searchRegex.lastIndex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(i){const n=i.length;let r;do{if(this._prevMatchStartIndex+this._prevMatchLength===n||(r=this._searchRegex.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){P.getNextCodePoint(i,n,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=t,!this._wordSeparators||l(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.Searcher=b}),define(Ce[127],De([1,0,49,29,79,175,99]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=e.createLineStarts=e.createLineStartsFast=void 0;const w=65535;function E(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class C{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function L(o,i=!0){const n=[0];let r=1;for(let a=0,t=o.length;a<t;a++){const h=o.charCodeAt(a);h===13?a+1<t&&o.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:h===10&&(n[r++]=a+1)}return i?E(n):n}e.createLineStartsFast=L;function I(o,i){o.length=0,o[0]=0;let n=1,r=0,a=0,t=0,h=!0;for(let s=0,c=i.length;s<c;s++){const d=i.charCodeAt(s);d===13?s+1<c&&i.charCodeAt(s+1)===10?(t++,o[n++]=s+2,s++):(r++,o[n++]=s+1):d===10?(a++,o[n++]=s+1):h&&d!==9&&(d<32||d>126)&&(h=!1)}const u=new C(E(o),r,a,t,h);return o.length=0,u}e.createLineStarts=I;class v{constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.Piece=v;class y{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.StringBuffer=y;class _{constructor(i,n){this._pieces=[],this._tree=i,this._BOM=n,this._index=0,i.root!==R.SENTINEL&&i.iterate(i.root,r=>(r!==R.SENTINEL&&this._pieces.push(r.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class l{constructor(i){this._limit=i,this._cache=[]}get(i){for(let n=this._cache.length-1;n>=0;n--){const r=this._cache[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this._cache.length-1;n>=0;n--){const r=this._cache[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let n=!1;const r=this._cache;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this._cache=a}}}class b{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this._buffers=[new y("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=R.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=n,this._EOLLength=n.length,this._EOLNormalized=r;let a=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const u=new v(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this._buffers.push(i[t]),a=this.rbInsertRight(a,u)}this._searchCache=new l(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const n=w,r=n-Math.floor(n/3),a=r*2;let t="",h=0;const u=[];if(this.iterate(this.root,s=>{const c=this.getNodeContent(s),d=c.length;if(h<=r||h+d<a)return t+=c,h+=d,!0;const m=t.replace(/\r\n|\r|\n/g,i);return u.push(new y(m,L(m))),t=c,h=d,!0}),h>0){const s=t.replace(/\r\n|\r|\n/g,i);u.push(new y(s,L(s)))}this.create(u,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new _(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===R.SENTINEL)return!0;const t=this.getNodeContent(a),h=t.length,u=i.nodeAt(n),s=i.nodeAt(n+h),c=i.getValueInRange2(u,s);return n+=h,t===c})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==R.SENTINEL;)if(a.left!==R.SENTINEL&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.getAccumulatedValue(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==R.SENTINEL;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.getIndexOf(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const h=this.getOffsetAt(r+1,1),u=a-h;return new P.Position(r+1,u+1)}return new P.Position(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===R.SENTINEL){const t=this.getOffsetAt(r+1,1),h=a-i-t;return new P.Position(r+1,h+1)}else n=n.right;return new P.Position(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.nodeAt2(i.startLineNumber,i.startColumn),a=this.nodeAt2(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const u=i.node,s=this._buffers[u.piece.bufferIndex].buffer,c=this.offsetInBuffer(u.piece.bufferIndex,u.piece.start);return s.substring(c+i.remainder,c+n.remainder)}let r=i.node;const a=this._buffers[r.piece.bufferIndex].buffer,t=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);let h=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==R.SENTINEL;){const u=this._buffers[r.piece.bufferIndex].buffer,s=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);if(r===n.node){h+=u.substring(s,s+n.remainder);break}else h+=u.substr(s,r.piece.length);r=r.next()}return h}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===R.SENTINEL)return!0;const h=t.piece;let u=h.length;if(u===0)return!0;const s=this._buffers[h.bufferIndex].buffer,c=this._buffers[h.bufferIndex].lineStarts,d=h.start.line,m=h.end.line;let D=c[d]+h.start.column;if(a&&(s.charCodeAt(D)===10&&(D++,u--),i[n++]=r,r="",a=!1,u===0))return!0;if(d===m)return!this._EOLNormalized&&s.charCodeAt(D+u-1)===13?(a=!0,r+=s.substr(D,u-1)):r+=s.substr(D,u),!0;r+=this._EOLNormalized?s.substring(D,Math.max(D,c[d+1]-this._EOLLength)):s.substring(D,c[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let g=d+1;g<m;g++)r=this._EOLNormalized?s.substring(c[g],c[g+1]-this._EOLLength):s.substring(c[g],c[g+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this._EOLNormalized&&s.charCodeAt(c[m]+h.end.column-1)===13?(a=!0,h.end.column===0?n--:r=s.substr(c[m],h.end.column-1)):r=s.substr(c[m],h.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this._buffers[n.piece.bufferIndex],a=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this._buffers[i.node.piece.bufferIndex],a=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.nodeAt2(i,n+1);return this._getCharCode(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const n=this.nodeAt(i);return this._getCharCode(n)}findMatchesInNode(i,n,r,a,t,h,u,s,c,d,m){const D=this._buffers[i.piece.bufferIndex],g=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),f=this.offsetInBuffer(i.piece.bufferIndex,t),S=this.offsetInBuffer(i.piece.bufferIndex,h);let T;const N={line:0,column:0};let z,x;n._wordSeparators?(z=D.buffer.substring(f,S),x=M=>M+f,n.reset(0)):(z=D.buffer,x=M=>M,n.reset(f));do if(T=n.next(z),T){if(x(T.index)>=S)return d;this.positionInBuffer(i,x(T.index)-g,N);const M=this.getLineFeedCnt(i.piece.bufferIndex,t,N),k=N.line===t.line?N.column-t.column+a:N.column+1,O=k+T[0].length;if(m[d++]=(0,A.createFindMatch)(new F.Range(r+M,k,r+M,O),T,s),x(T.index)+T[0].length>=S||d>=c)return d}while(T);return d}findMatchesLineByLine(i,n,r,a){const t=[];let h=0;const u=new A.Searcher(n.wordSeparators,n.regex);let s=this.nodeAt2(i.startLineNumber,i.startColumn);if(s===null)return[];const c=this.nodeAt2(i.endLineNumber,i.endColumn);if(c===null)return[];let d=this.positionInBuffer(s.node,s.remainder);const m=this.positionInBuffer(c.node,c.remainder);if(s.node===c.node)return this.findMatchesInNode(s.node,u,i.startLineNumber,i.startColumn,d,m,n,r,a,h,t),t;let D=i.startLineNumber,g=s.node;for(;g!==c.node;){const S=this.getLineFeedCnt(g.piece.bufferIndex,d,g.piece.end);if(S>=1){const N=this._buffers[g.piece.bufferIndex].lineStarts,z=this.offsetInBuffer(g.piece.bufferIndex,g.piece.start),x=N[d.line+S],M=D===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(g,u,D,M,d,this.positionInBuffer(g,x-z),n,r,a,h,t),h>=a)return t;D+=S}const T=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const N=this.getLineContent(D).substring(T,i.endColumn-1);return h=this._findMatchesInLine(n,u,N,i.endLineNumber,T,h,t,r,a),t}if(h=this._findMatchesInLine(n,u,this.getLineContent(D).substr(T),D,T,h,t,r,a),h>=a)return t;D++,s=this.nodeAt2(D,1),g=s.node,d=this.positionInBuffer(s.node,s.remainder)}if(D===i.endLineNumber){const S=D===i.startLineNumber?i.startColumn-1:0,T=this.getLineContent(D).substring(S,i.endColumn-1);return h=this._findMatchesInLine(n,u,T,i.endLineNumber,S,h,t,r,a),t}const f=D===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(c.node,u,D,f,d,m,n,r,a,h,t),t}_findMatchesInLine(i,n,r,a,t,h,u,s,c){const d=i.wordSeparators;if(!s&&i.simpleSearch){const D=i.simpleSearch,g=D.length,f=r.length;let S=-g;for(;(S=r.indexOf(D,S+g))!==-1;)if((!d||(0,A.isValidMatch)(d,r,f,S,g))&&(u[h++]=new p.FindMatch(new F.Range(a,S+1+t,a,S+1+g+t),null),h>=c))return h;return h}let m;n.reset(0);do if(m=n.next(r),m&&(u[h++]=(0,A.createFindMatch)(new F.Range(a,m.index+1+t,a,m.index+1+m[0].length+t),m,s),h>=c))return h;while(m);return h}insert(i,n,r=!1){if(this._EOLNormalized=this._EOLNormalized&&r,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==R.SENTINEL){const{node:a,remainder:t,nodeStartOffset:h}=this.nodeAt(i),u=a.piece,s=u.bufferIndex,c=this.positionInBuffer(a,t);if(a.piece.bufferIndex===0&&u.end.line===this._lastChangeBufferPos.line&&u.end.column===this._lastChangeBufferPos.column&&h+u.length===i&&n.length<w){this.appendToNode(a,n),this.computeBufferMetadata();return}if(h===i)this.insertContentToNodeLeft(n,a),this._searchCache.validate(i);else if(h+a.piece.length>i){const d=[];let m=new v(u.bufferIndex,c,u.end,this.getLineFeedCnt(u.bufferIndex,c,u.end),this.offsetInBuffer(s,u.end)-this.offsetInBuffer(s,c));if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.nodeCharCodeAt(a,t)===10){const S={line:m.start.line+1,column:0};m=new v(m.bufferIndex,S,m.end,this.getLineFeedCnt(m.bufferIndex,S,m.end),m.length-1),n+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(n))if(this.nodeCharCodeAt(a,t-1)===13){const S=this.positionInBuffer(a,t-1);this.deleteNodeTail(a,S),n="\r"+n,a.piece.length===0&&d.push(a)}else this.deleteNodeTail(a,c);else this.deleteNodeTail(a,c);const D=this.createNewPieces(n);m.length>0&&this.rbInsertRight(a,m);let g=a;for(let f=0;f<D.length;f++)g=this.rbInsertRight(g,D[f]);this.deleteNodes(d)}else this.insertContentToNodeRight(n,a)}else{const a=this.createNewPieces(n);let t=this.rbInsertLeft(null,a[0]);for(let h=1;h<a.length;h++)t=this.rbInsertRight(t,a[h])}this.computeBufferMetadata()}delete(i,n){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",n<=0||this.root===R.SENTINEL)return;const r=this.nodeAt(i),a=this.nodeAt(i+n),t=r.node,h=a.node;if(t===h){const D=this.positionInBuffer(t,r.remainder),g=this.positionInBuffer(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const f=t.next();(0,R.rbDelete)(this,t),this.validateCRLFWithPrevNode(f),this.computeBufferMetadata();return}this.deleteNodeHead(t,g),this._searchCache.validate(i),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(r.nodeStartOffset+t.piece.length===i+n){this.deleteNodeTail(t,D),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,D,g),this.computeBufferMetadata();return}const u=[],s=this.positionInBuffer(t,r.remainder);this.deleteNodeTail(t,s),this._searchCache.validate(i),t.piece.length===0&&u.push(t);const c=this.positionInBuffer(h,a.remainder);this.deleteNodeHead(h,c),h.piece.length===0&&u.push(h);const d=t.next();for(let D=d;D!==R.SENTINEL&&D!==h;D=D.next())u.push(D);const m=t.piece.length===0?t.prev():t;this.deleteNodes(u),this.validateCRLFWithNextNode(m),this.computeBufferMetadata()}insertContentToNodeLeft(i,n){const r=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(n)){const h=n.piece,u={line:h.start.line+1,column:0},s=new v(h.bufferIndex,u,h.end,this.getLineFeedCnt(h.bufferIndex,u,h.end),h.length-1);n.piece=s,i+=`
`,(0,R.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.createNewPieces(i);let t=this.rbInsertLeft(n,a[a.length-1]);for(let h=a.length-2;h>=0;h--)t=this.rbInsertLeft(t,a[h]);this.validateCRLFWithPrevNode(t),this.deleteNodes(r)}insertContentToNodeRight(i,n){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const r=this.createNewPieces(i),a=this.rbInsertRight(n,r[0]);let t=a;for(let h=1;h<r.length;h++)t=this.rbInsertRight(t,r[h]);this.validateCRLFWithPrevNode(a)}positionInBuffer(i,n,r){const a=i.piece,t=i.piece.bufferIndex,h=this._buffers[t].lineStarts,s=h[a.start.line]+a.start.column+n;let c=a.start.line,d=a.end.line,m=0,D=0,g=0;for(;c<=d&&(m=c+(d-c)/2|0,g=h[m],m!==d);)if(D=h[m+1],s<g)d=m-1;else if(s>=D)c=m+1;else break;return r?(r.line=m,r.column=s-g,null):{line:m,column:s-g}}getLineFeedCnt(i,n,r){if(r.column===0)return r.line-n.line;const a=this._buffers[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],h=a[r.line]+r.column;if(t>h+1)return r.line-n.line;const u=h-1;return this._buffers[i].buffer.charCodeAt(u)===13?r.line-n.line+1:r.line-n.line}offsetInBuffer(i,n){return this._buffers[i].lineStarts[n.line]+n.column}deleteNodes(i){for(let n=0;n<i.length;n++)(0,R.rbDelete)(this,i[n])}createNewPieces(i){if(i.length>w){const d=[];for(;i.length>w;){const D=i.charCodeAt(w-1);let g;D===13||D>=55296&&D<=56319?(g=i.substring(0,w-1),i=i.substring(w-1)):(g=i.substring(0,w),i=i.substring(w));const f=L(g);d.push(new v(this._buffers.length,{line:0,column:0},{line:f.length-1,column:g.length-f[f.length-1]},f.length-1,g.length)),this._buffers.push(new y(g,f))}const m=L(i);return d.push(new v(this._buffers.length,{line:0,column:0},{line:m.length-1,column:i.length-m[m.length-1]},m.length-1,i.length)),this._buffers.push(new y(i,m)),d}let n=this._buffers[0].buffer.length;const r=L(i,!1);let a=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===n&&n!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},a=this._lastChangeBufferPos;for(let d=0;d<r.length;d++)r[d]+=n+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(r.slice(1)),this._buffers[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let d=0;d<r.length;d++)r[d]+=n;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(r.slice(1)),this._buffers[0].buffer+=i}const t=this._buffers[0].buffer.length,h=this._buffers[0].lineStarts.length-1,u=t-this._buffers[0].lineStarts[h],s={line:h,column:u},c=new v(0,a,s,this.getLineFeedCnt(0,a,s),t-n);return this._lastChangeBufferPos=s,[c]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this._searchCache.get2(i);if(t){r=t.node;const h=this.getAccumulatedValue(r,i-t.nodeStartLineNumber-1),u=this._buffers[r.piece.bufferIndex].buffer,s=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=u.substring(s+h,s+r.piece.length);else{const c=this.getAccumulatedValue(r,i-t.nodeStartLineNumber);return u.substring(s+h,s+c-n)}}else{let h=0;const u=i;for(;r!==R.SENTINEL;)if(r.left!==R.SENTINEL&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const s=this.getAccumulatedValue(r,i-r.lf_left-2),c=this.getAccumulatedValue(r,i-r.lf_left-1),d=this._buffers[r.piece.bufferIndex].buffer,m=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return h+=r.size_left,this._searchCache.set({node:r,nodeStartOffset:h,nodeStartLineNumber:u-(i-1-r.lf_left)}),d.substring(m+s,m+c-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const s=this.getAccumulatedValue(r,i-r.lf_left-2),c=this._buffers[r.piece.bufferIndex].buffer,d=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);a=c.substring(d+s,d+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,h+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.SENTINEL;){const h=this._buffers[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const u=this.getAccumulatedValue(r,0),s=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return a+=h.substring(s,s+u-n),a}else{const u=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);a+=h.substr(u,r.piece.length)}r=r.next()}return a}computeBufferMetadata(){let i=this.root,n=1,r=0;for(;i!==R.SENTINEL;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this._lineCnt=n,this._length=r,this._searchCache.validate(this._length)}getIndexOf(i,n){const r=i.piece,a=this.positionInBuffer(i,n),t=a.line-r.start.line;if(this.offsetInBuffer(r.bufferIndex,r.end)-this.offsetInBuffer(r.bufferIndex,r.start)===n){const h=this.getLineFeedCnt(i.piece.bufferIndex,r.start,a);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:a.column}}getAccumulatedValue(i,n){if(n<0)return 0;const r=i.piece,a=this._buffers[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}deleteNodeTail(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.offsetInBuffer(r.bufferIndex,r.end),h=n,u=this.offsetInBuffer(r.bufferIndex,h),s=this.getLineFeedCnt(r.bufferIndex,r.start,h),c=s-a,d=u-t,m=r.length+d;i.piece=new v(r.bufferIndex,r.start,h,s,m),(0,R.updateTreeMetadata)(this,i,d,c)}deleteNodeHead(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.offsetInBuffer(r.bufferIndex,r.start),h=n,u=this.getLineFeedCnt(r.bufferIndex,h,r.end),s=this.offsetInBuffer(r.bufferIndex,h),c=u-a,d=t-s,m=r.length+d;i.piece=new v(r.bufferIndex,h,r.end,u,m),(0,R.updateTreeMetadata)(this,i,d,c)}shrinkNode(i,n,r){const a=i.piece,t=a.start,h=a.end,u=a.length,s=a.lineFeedCnt,c=n,d=this.getLineFeedCnt(a.bufferIndex,a.start,c),m=this.offsetInBuffer(a.bufferIndex,n)-this.offsetInBuffer(a.bufferIndex,t);i.piece=new v(a.bufferIndex,a.start,c,d,m),(0,R.updateTreeMetadata)(this,i,m-u,d-s);const D=new v(a.bufferIndex,r,h,this.getLineFeedCnt(a.bufferIndex,r,h),this.offsetInBuffer(a.bufferIndex,h)-this.offsetInBuffer(a.bufferIndex,r)),g=this.rbInsertRight(i,D);this.validateCRLFWithPrevNode(g)}appendToNode(i,n){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const r=this.shouldCheckCRLF()&&this.startWithLF(n)&&this.endWithCR(i),a=this._buffers[0].buffer.length;this._buffers[0].buffer+=n;const t=L(n,!1);for(let g=0;g<t.length;g++)t[g]+=a;if(r){const g=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:a-g}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const h=this._buffers[0].lineStarts.length-1,u=this._buffers[0].buffer.length-this._buffers[0].lineStarts[h],s={line:h,column:u},c=i.piece.length+n.length,d=i.piece.lineFeedCnt,m=this.getLineFeedCnt(0,i.piece.start,s),D=m-d;i.piece=new v(i.piece.bufferIndex,i.piece.start,s,m,c),this._lastChangeBufferPos=s,(0,R.updateTreeMetadata)(this,i,n.length,D)}nodeAt(i){let n=this.root;const r=this._searchCache.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==R.SENTINEL;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this._searchCache.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}nodeAt2(i,n){let r=this.root,a=0;for(;r!==R.SENTINEL;)if(r.left!==R.SENTINEL&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.getAccumulatedValue(r,i-r.lf_left-2),h=this.getAccumulatedValue(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,h),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.getAccumulatedValue(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.SENTINEL;){if(r.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(r,0),h=this.offsetOfNode(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:h}}else if(r.piece.length>=n-1){const t=this.offsetOfNode(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}nodeCharCodeAt(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this._buffers[i.piece.bufferIndex],a=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}offsetOfNode(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.SENTINEL||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this._buffers[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this._buffers[n.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const n=i.prev();this.endWithCR(n)&&this.fixCRLF(n,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=i.next();this.startWithLF(n)&&this.fixCRLF(i,n)}}fixCRLF(i,n){const r=[],a=this._buffers[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,u=i.piece.lineFeedCnt-1;i.piece=new v(i.piece.bufferIndex,i.piece.start,t,u,h),(0,R.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&r.push(i);const s={line:n.piece.start.line+1,column:0},c=n.piece.length-1,d=this.getLineFeedCnt(n.piece.bufferIndex,s,n.piece.end);n.piece=new v(n.piece.bufferIndex,s,n.piece.end,d,c),(0,R.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&r.push(n);const m=this.createNewPieces(`\r
`);this.rbInsertRight(i,m[0]);for(let D=0;D<r.length;D++)(0,R.rbDelete)(this,r[D])}adjustCarriageReturnFromNext(i,n){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const r=n.next();if(this.startWithLF(r)){if(i+=`
`,r.piece.length===1)(0,R.rbDelete)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},h=a.length-1,u=this.getLineFeedCnt(a.bufferIndex,t,a.end);r.piece=new v(a.bufferIndex,t,a.end,u,h),(0,R.updateTreeMetadata)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.SENTINEL)return n(R.SENTINEL);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}getNodeContent(i){if(i===R.SENTINEL)return"";const n=this._buffers[i.piece.bufferIndex],r=i.piece,a=this.offsetInBuffer(r.bufferIndex,r.start),t=this.offsetInBuffer(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this._buffers[i.bufferIndex],r=this.offsetInBuffer(i.bufferIndex,i.start),a=this.offsetInBuffer(i.bufferIndex,i.end);return n.buffer.substring(r,a)}rbInsertRight(i,n){const r=new R.TreeNode(n,1);if(r.left=R.SENTINEL,r.right=R.SENTINEL,r.parent=R.SENTINEL,r.size_left=0,r.lf_left=0,this.root===R.SENTINEL)this.root=r,r.color=0;else if(i.right===R.SENTINEL)i.right=r,r.parent=i;else{const t=(0,R.leftest)(i.right);t.left=r,r.parent=t}return(0,R.fixInsert)(this,r),r}rbInsertLeft(i,n){const r=new R.TreeNode(n,1);if(r.left=R.SENTINEL,r.right=R.SENTINEL,r.parent=R.SENTINEL,r.size_left=0,r.lf_left=0,this.root===R.SENTINEL)this.root=r,r.color=0;else if(i.left===R.SENTINEL)i.left=r,r.parent=i;else{const a=(0,R.righttest)(i.left);a.right=r,r.parent=a}return(0,R.fixInsert)(this,r),r}getContentOfSubTree(i){let n="";return this.iterate(i,r=>(n+=this.getNodeContent(r),!0)),n}}e.PieceTreeBase=b}),define(Ce[178],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class P{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const A=this._dragOperations.get(R);return this._dragOperations.delete(R),A}}addDragOperationTransfer(R,A){this._dragOperations.set(R,A)}}e.TreeViewsDnDService=P;class F{constructor(R){this.identifier=R}}e.DraggedTreeItemsIdentifier=F}),define(Ce[179],De([1,0,4,3]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class p{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(w){this._onDidChange.fire({changedLanguages:w,changedColorMap:!1})}register(w,E){return this._tokenizationSupports.set(w,E),this.handleChange([w]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(w)===E&&(this._tokenizationSupports.delete(w),this.handleChange([w]))})}get(w){return this._tokenizationSupports.get(w)||null}registerFactory(w,E){this._factories.get(w)?.dispose();const C=new R(this,w,E);return this._factories.set(w,C),(0,F.toDisposable)(()=>{const L=this._factories.get(w);!L||L!==C||(this._factories.delete(w),L.dispose())})}async getOrCreate(w){const E=this.get(w);if(E)return E;const C=this._factories.get(w);return!C||C.isResolved?null:(await C.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const C=this._factories.get(w);return!!(!C||C.isResolved)}setColorMap(w){this._colorMap=w,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=p;class R extends F.Disposable{get isResolved(){return this._isResolved}constructor(w,E,C){super(),this._registry=w,this._languageId=E,this._factory=C,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const w=await this._factory.tokenizationSupport;this._isResolved=!0,w&&!this._isDisposed&&this._register(this._registry.register(this._languageId,w))}}}),define(Ce[180],De([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Ce[181],De([1,0,4,3,180]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends F.Disposable{constructor(v,y="",_="",l=!0,b){super(),this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=v,this._label=y,this._cssClass=_,this._enabled=l,this._actionCallback=b}get id(){return this._id}get label(){return this._label}set label(v){this._setLabel(v)}_setLabel(v){this._label!==v&&(this._label=v,this._onDidChange.fire({label:v}))}get tooltip(){return this._tooltip||""}set tooltip(v){this._setTooltip(v)}_setTooltip(v){this._tooltip!==v&&(this._tooltip=v,this._onDidChange.fire({tooltip:v}))}get class(){return this._cssClass}set class(v){this._setClass(v)}_setClass(v){this._cssClass!==v&&(this._cssClass=v,this._onDidChange.fire({class:v}))}get enabled(){return this._enabled}set enabled(v){this._setEnabled(v)}_setEnabled(v){this._enabled!==v&&(this._enabled=v,this._onDidChange.fire({enabled:v}))}get checked(){return this._checked}set checked(v){this._setChecked(v)}_setChecked(v){this._checked!==v&&(this._checked=v,this._onDidChange.fire({checked:v}))}async run(v,y){this._actionCallback&&await this._actionCallback(v)}}e.Action=R;class A extends F.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new P.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new P.Emitter),this.onDidRun=this._onDidRun.event}async run(v,y){if(!v.enabled)return;this._onWillRun.fire({action:v});let _;try{await this.runAction(v,y)}catch(l){_=l}this._onDidRun.fire({action:v,error:_})}async runAction(v,y){await v.run(y)}}e.ActionRunner=A;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let y=[];for(const _ of v)_.length&&(y.length?y=[...y,new w,..._]:y=_);return y}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=w;class E{get actions(){return this._actions}constructor(v,y,_,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=y,this.class=l,this._actions=_}async run(){}}e.SubmenuAction=E;class C extends R{static{this.ID="vs.actions.empty"}constructor(){super(C.ID,p.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=C;function L(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...v)=>I.run(...v),tooltip:I.label}}e.toAction=L}),define(Ce[182],De([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Ce[183],De([1,0,182]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.getDurationString=e.fromNow=void 0;const F=60,p=F*60,R=p*24,A=R*7,w=R*30,E=R*365;function C(v,y,_,l){typeof v!="number"&&(v=v.getTime());const b=Math.round((new Date().getTime()-v)/1e3);if(b<-30)return(0,P.localize)(0,null,C(new Date().getTime()+b*1e3,!1));if(!l&&b<30)return(0,P.localize)(1,null);let o;return b<F?(o=b,y?o===1?_?(0,P.localize)(2,null,o):(0,P.localize)(3,null,o):_?(0,P.localize)(4,null,o):(0,P.localize)(5,null,o):o===1?_?(0,P.localize)(6,null,o):(0,P.localize)(7,null,o):_?(0,P.localize)(8,null,o):(0,P.localize)(9,null,o)):b<p?(o=Math.floor(b/F),y?o===1?_?(0,P.localize)(10,null,o):(0,P.localize)(11,null,o):_?(0,P.localize)(12,null,o):(0,P.localize)(13,null,o):o===1?_?(0,P.localize)(14,null,o):(0,P.localize)(15,null,o):_?(0,P.localize)(16,null,o):(0,P.localize)(17,null,o)):b<R?(o=Math.floor(b/p),y?o===1?_?(0,P.localize)(18,null,o):(0,P.localize)(19,null,o):_?(0,P.localize)(20,null,o):(0,P.localize)(21,null,o):o===1?_?(0,P.localize)(22,null,o):(0,P.localize)(23,null,o):_?(0,P.localize)(24,null,o):(0,P.localize)(25,null,o)):b<A?(o=Math.floor(b/R),y?o===1?(0,P.localize)(26,null,o):(0,P.localize)(27,null,o):o===1?(0,P.localize)(28,null,o):(0,P.localize)(29,null,o)):b<w?(o=Math.floor(b/A),y?o===1?_?(0,P.localize)(30,null,o):(0,P.localize)(31,null,o):_?(0,P.localize)(32,null,o):(0,P.localize)(33,null,o):o===1?_?(0,P.localize)(34,null,o):(0,P.localize)(35,null,o):_?(0,P.localize)(36,null,o):(0,P.localize)(37,null,o)):b<E?(o=Math.floor(b/w),y?o===1?_?(0,P.localize)(38,null,o):(0,P.localize)(39,null,o):_?(0,P.localize)(40,null,o):(0,P.localize)(41,null,o):o===1?_?(0,P.localize)(42,null,o):(0,P.localize)(43,null,o):_?(0,P.localize)(44,null,o):(0,P.localize)(45,null,o)):(o=Math.floor(b/E),y?o===1?_?(0,P.localize)(46,null,o):(0,P.localize)(47,null,o):_?(0,P.localize)(48,null,o):(0,P.localize)(49,null,o):o===1?_?(0,P.localize)(50,null,o):(0,P.localize)(51,null,o):_?(0,P.localize)(52,null,o):(0,P.localize)(53,null,o))}e.fromNow=C;function L(v,y){const _=Math.abs(v/1e3);return _<1?y?(0,P.localize)(54,null,v):(0,P.localize)(55,null,v):_<F?y?(0,P.localize)(56,null,Math.round(v)/1e3):(0,P.localize)(57,null,Math.round(v)/1e3):_<p?y?(0,P.localize)(58,null,Math.round(v/(1e3*F))):(0,P.localize)(59,null,Math.round(v/(1e3*F))):_<R?y?(0,P.localize)(60,null,Math.round(v/(1e3*p))):(0,P.localize)(61,null,Math.round(v/(1e3*p))):(0,P.localize)(62,null,Math.round(v/(1e3*R)))}e.getDurationString=L;function I(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Ce[184],De([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Ce[40],De([1,0,19,18,184]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,v){return v&&(I.stack||I.stacktrace)?p.localize(0,null,w(I),A(I.stack)||A(I.stacktrace)):w(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function w(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?p.localize(1,null,I.message):I.message||p.localize(2,null)}function E(I=null,v=!1){if(!I)return p.localize(3,null);if(Array.isArray(I)){const y=P.coalesce(I),_=E(y[0],v);return y.length>1?p.localize(4,null,_,y.length):_}if(F.isString(I))return I;if(I.detail){const y=I.detail;if(y.error)return R(y.error,v);if(y.exception)return R(y.exception,v)}return I.stack?R(I,v):I.message?I.message:p.localize(5,null)}e.toErrorMessage=E;function C(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=C;function L(I,v){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=v,y}e.createErrorWithActions=L}),define(Ce[185],De([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Ce[11],De([1,0,185]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let F=!1,p=!1,R=!1,A=!1,w=!1,E=!1,C=!1,L=!1,I=!1,v=!1,y,_=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT,b,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof n=="object"){F=n.platform==="win32",p=n.platform==="darwin",R=n.platform==="linux",A=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,C=r,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,_=e.LANGUAGE_DEFAULT;const f=n.env.VSCODE_NLS_CONFIG;if(f)try{const S=JSON.parse(f),T=S.availableLanguages["*"];y=S.locale,l=S.osLocale,_=T||e.LANGUAGE_DEFAULT,b=S._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!a?(o=navigator.userAgent,F=o.indexOf("Windows")>=0,p=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,v=o?.indexOf("Mobi")>=0,E=!0,y=P.getConfiguredDefaultLocale(P.localize(0,null))||e.LANGUAGE_DEFAULT,_=y,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let u=0;p?u=1:F?u=3:R&&(u=2),e.isWindows=F,e.isMacintosh=p,e.isLinux=R,e.isLinuxSnap=A,e.isNative=w,e.isElectron=C,e.isWeb=E,e.isWebWorker=E&&typeof i.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?i.origin:void 0,e.isIOS=L,e.isMobile=v,e.isCI=I,e.platform=u,e.userAgent=o,e.language=_;var s;(function(f){function S(){return e.language}f.value=S;function T(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}f.isDefaultVariant=T;function N(){return e.language==="en"}f.isDefault=N})(s||(e.Language=s={})),e.locale=y,e.platformLocale=l,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof i.postMessage=="function"&&!i.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const f=[];i.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let N=0,z=f.length;N<z;N++){const x=f[N];if(x.id===T.data.vscodeScheduleAsyncWork){f.splice(N,1),x.callback();return}}});let S=0;return T=>{const N=++S;f.push({id:N,callback:T}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return f=>setTimeout(f)})();var c;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=p||L?2:F?1:3;let d=!0,m=!1;function D(){if(!m){m=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,d=new Uint16Array(f.buffer)[0]===513}return d}e.isLittleEndian=D,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function g(f){return parseFloat(f)>=20}e.isBigSurOrNewer=g}),define(Ce[50],De([1,0,11]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let F;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const R=p.process;F={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.arch=F.arch}),define(Ce[17],De([1,0,50]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,p=97,R=90,A=122,w=46,E=47,C=92,L=58,I=63;class v extends Error{constructor(h,u,s){let c;typeof u=="string"&&u.indexOf("not ")===0?(c="must not be",u=u.replace(/^not /,"")):c="must be";const d=h.indexOf(".")!==-1?"property":"argument";let m=`The "${h}" ${d} ${c} of type ${u}`;m+=`. Received type ${typeof s}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,h){if(t===null||typeof t!="object")throw new v(h,"Object",t)}function _(t,h){if(typeof t!="string")throw new v(h,"string",t)}const l=P.platform==="win32";function b(t){return t===E||t===C}function o(t){return t===E}function i(t){return t>=F&&t<=R||t>=p&&t<=A}function n(t,h,u,s){let c="",d=0,m=-1,D=0,g=0;for(let f=0;f<=t.length;++f){if(f<t.length)g=t.charCodeAt(f);else{if(s(g))break;g=E}if(s(g)){if(!(m===f-1||D===1))if(D===2){if(c.length<2||d!==2||c.charCodeAt(c.length-1)!==w||c.charCodeAt(c.length-2)!==w){if(c.length>2){const S=c.lastIndexOf(u);S===-1?(c="",d=0):(c=c.slice(0,S),d=c.length-1-c.lastIndexOf(u)),m=f,D=0;continue}else if(c.length!==0){c="",d=0,m=f,D=0;continue}}h&&(c+=c.length>0?`${u}..`:"..",d=2)}else c.length>0?c+=`${u}${t.slice(m+1,f)}`:c=t.slice(m+1,f),d=f-m-1;m=f,D=0}else g===w&&D!==-1?++D:D=-1}return c}function r(t,h){y(h,"pathObject");const u=h.dir||h.root,s=h.base||`${h.name||""}${h.ext||""}`;return u?u===h.root?`${u}${s}`:`${u}${t}${s}`:s}e.win32={resolve(...t){let h="",u="",s=!1;for(let c=t.length-1;c>=-1;c--){let d;if(c>=0){if(d=t[c],_(d,"path"),d.length===0)continue}else h.length===0?d=P.cwd():(d=P.env[`=${h}`]||P.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==h.toLowerCase()&&d.charCodeAt(2)===C)&&(d=`${h}\\`));const m=d.length;let D=0,g="",f=!1;const S=d.charCodeAt(0);if(m===1)b(S)&&(D=1,f=!0);else if(b(S))if(f=!0,b(d.charCodeAt(1))){let T=2,N=T;for(;T<m&&!b(d.charCodeAt(T));)T++;if(T<m&&T!==N){const z=d.slice(N,T);for(N=T;T<m&&b(d.charCodeAt(T));)T++;if(T<m&&T!==N){for(N=T;T<m&&!b(d.charCodeAt(T));)T++;(T===m||T!==N)&&(g=`\\\\${z}\\${d.slice(N,T)}`,D=T)}}}else D=1;else i(S)&&d.charCodeAt(1)===L&&(g=d.slice(0,2),D=2,m>2&&b(d.charCodeAt(2))&&(f=!0,D=3));if(g.length>0)if(h.length>0){if(g.toLowerCase()!==h.toLowerCase())continue}else h=g;if(s){if(h.length>0)break}else if(u=`${d.slice(D)}\\${u}`,s=f,f&&h.length>0)break}return u=n(u,!s,"\\",b),s?`${h}\\${u}`:`${h}${u}`||"."},normalize(t){_(t,"path");const h=t.length;if(h===0)return".";let u=0,s,c=!1;const d=t.charCodeAt(0);if(h===1)return o(d)?"\\":t;if(b(d))if(c=!0,b(t.charCodeAt(1))){let D=2,g=D;for(;D<h&&!b(t.charCodeAt(D));)D++;if(D<h&&D!==g){const f=t.slice(g,D);for(g=D;D<h&&b(t.charCodeAt(D));)D++;if(D<h&&D!==g){for(g=D;D<h&&!b(t.charCodeAt(D));)D++;if(D===h)return`\\\\${f}\\${t.slice(g)}\\`;D!==g&&(s=`\\\\${f}\\${t.slice(g,D)}`,u=D)}}}else u=1;else i(d)&&t.charCodeAt(1)===L&&(s=t.slice(0,2),u=2,h>2&&b(t.charCodeAt(2))&&(c=!0,u=3));let m=u<h?n(t.slice(u),!c,"\\",b):"";return m.length===0&&!c&&(m="."),m.length>0&&b(t.charCodeAt(h-1))&&(m+="\\"),s===void 0?c?`\\${m}`:m:c?`${s}\\${m}`:`${s}${m}`},isAbsolute(t){_(t,"path");const h=t.length;if(h===0)return!1;const u=t.charCodeAt(0);return b(u)||h>2&&i(u)&&t.charCodeAt(1)===L&&b(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,u;for(let d=0;d<t.length;++d){const m=t[d];_(m,"path"),m.length>0&&(h===void 0?h=u=m:h+=`\\${m}`)}if(h===void 0)return".";let s=!0,c=0;if(typeof u=="string"&&b(u.charCodeAt(0))){++c;const d=u.length;d>1&&b(u.charCodeAt(1))&&(++c,d>2&&(b(u.charCodeAt(2))?++c:s=!1))}if(s){for(;c<h.length&&b(h.charCodeAt(c));)c++;c>=2&&(h=`\\${h.slice(c)}`)}return e.win32.normalize(h)},relative(t,h){if(_(t,"from"),_(h,"to"),t===h)return"";const u=e.win32.resolve(t),s=e.win32.resolve(h);if(u===s||(t=u.toLowerCase(),h=s.toLowerCase(),t===h))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===C;)c++;let d=t.length;for(;d-1>c&&t.charCodeAt(d-1)===C;)d--;const m=d-c;let D=0;for(;D<h.length&&h.charCodeAt(D)===C;)D++;let g=h.length;for(;g-1>D&&h.charCodeAt(g-1)===C;)g--;const f=g-D,S=m<f?m:f;let T=-1,N=0;for(;N<S;N++){const x=t.charCodeAt(c+N);if(x!==h.charCodeAt(D+N))break;x===C&&(T=N)}if(N!==S){if(T===-1)return s}else{if(f>S){if(h.charCodeAt(D+N)===C)return s.slice(D+N+1);if(N===2)return s.slice(D+N)}m>S&&(t.charCodeAt(c+N)===C?T=N:N===2&&(T=3)),T===-1&&(T=0)}let z="";for(N=c+T+1;N<=d;++N)(N===d||t.charCodeAt(N)===C)&&(z+=z.length===0?"..":"\\..");return D+=T,z.length>0?`${z}${s.slice(D,g)}`:(s.charCodeAt(D)===C&&++D,s.slice(D,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.win32.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const u=h.charCodeAt(2);if(u!==I&&u!==w)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===L&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return t},dirname(t){_(t,"path");const h=t.length;if(h===0)return".";let u=-1,s=0;const c=t.charCodeAt(0);if(h===1)return b(c)?t:".";if(b(c)){if(u=s=1,b(t.charCodeAt(1))){let D=2,g=D;for(;D<h&&!b(t.charCodeAt(D));)D++;if(D<h&&D!==g){for(g=D;D<h&&b(t.charCodeAt(D));)D++;if(D<h&&D!==g){for(g=D;D<h&&!b(t.charCodeAt(D));)D++;if(D===h)return t;D!==g&&(u=s=D+1)}}}}else i(c)&&t.charCodeAt(1)===L&&(u=h>2&&b(t.charCodeAt(2))?3:2,s=u);let d=-1,m=!0;for(let D=h-1;D>=s;--D)if(b(t.charCodeAt(D))){if(!m){d=D;break}}else m=!1;if(d===-1){if(u===-1)return".";d=u}return t.slice(0,d)},basename(t,h){h!==void 0&&_(h,"ext"),_(t,"path");let u=0,s=-1,c=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(u=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let m=h.length-1,D=-1;for(d=t.length-1;d>=u;--d){const g=t.charCodeAt(d);if(b(g)){if(!c){u=d+1;break}}else D===-1&&(c=!1,D=d+1),m>=0&&(g===h.charCodeAt(m)?--m===-1&&(s=d):(m=-1,s=D))}return u===s?s=D:s===-1&&(s=t.length),t.slice(u,s)}for(d=t.length-1;d>=u;--d)if(b(t.charCodeAt(d))){if(!c){u=d+1;break}}else s===-1&&(c=!1,s=d+1);return s===-1?"":t.slice(u,s)},extname(t){_(t,"path");let h=0,u=-1,s=0,c=-1,d=!0,m=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(h=s=2);for(let D=t.length-1;D>=h;--D){const g=t.charCodeAt(D);if(b(g)){if(!d){s=D+1;break}continue}c===-1&&(d=!1,c=D+1),g===w?u===-1?u=D:m!==1&&(m=1):u!==-1&&(m=-1)}return u===-1||c===-1||m===0||m===1&&u===c-1&&u===s+1?"":t.slice(u,c)},format:r.bind(null,"\\"),parse(t){_(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const u=t.length;let s=0,c=t.charCodeAt(0);if(u===1)return b(c)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(b(c)){if(s=1,b(t.charCodeAt(1))){let T=2,N=T;for(;T<u&&!b(t.charCodeAt(T));)T++;if(T<u&&T!==N){for(N=T;T<u&&b(t.charCodeAt(T));)T++;if(T<u&&T!==N){for(N=T;T<u&&!b(t.charCodeAt(T));)T++;T===u?s=T:T!==N&&(s=T+1)}}}}else if(i(c)&&t.charCodeAt(1)===L){if(u<=2)return h.root=h.dir=t,h;if(s=2,b(t.charCodeAt(2))){if(u===3)return h.root=h.dir=t,h;s=3}}s>0&&(h.root=t.slice(0,s));let d=-1,m=s,D=-1,g=!0,f=t.length-1,S=0;for(;f>=s;--f){if(c=t.charCodeAt(f),b(c)){if(!g){m=f+1;break}continue}D===-1&&(g=!1,D=f+1),c===w?d===-1?d=f:S!==1&&(S=1):d!==-1&&(S=-1)}return D!==-1&&(d===-1||S===0||S===1&&d===D-1&&d===m+1?h.base=h.name=t.slice(m,D):(h.name=t.slice(m,d),h.base=t.slice(m,D),h.ext=t.slice(d,D))),m>0&&m!==s?h.dir=t.slice(0,m-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(l){const t=/\\/g;return()=>{const h=P.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...t){let h="",u=!1;for(let s=t.length-1;s>=-1&&!u;s--){const c=s>=0?t[s]:a();_(c,"path"),c.length!==0&&(h=`${c}/${h}`,u=c.charCodeAt(0)===E)}return h=n(h,!u,"/",o),u?`/${h}`:h.length>0?h:"."},normalize(t){if(_(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===E,u=t.charCodeAt(t.length-1)===E;return t=n(t,!h,"/",o),t.length===0?h?"/":u?"./":".":(u&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return _(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let h;for(let u=0;u<t.length;++u){const s=t[u];_(s,"path"),s.length>0&&(h===void 0?h=s:h+=`/${s}`)}return h===void 0?".":e.posix.normalize(h)},relative(t,h){if(_(t,"from"),_(h,"to"),t===h||(t=e.posix.resolve(t),h=e.posix.resolve(h),t===h))return"";const u=1,s=t.length,c=s-u,d=1,m=h.length-d,D=c<m?c:m;let g=-1,f=0;for(;f<D;f++){const T=t.charCodeAt(u+f);if(T!==h.charCodeAt(d+f))break;T===E&&(g=f)}if(f===D)if(m>D){if(h.charCodeAt(d+f)===E)return h.slice(d+f+1);if(f===0)return h.slice(d+f)}else c>D&&(t.charCodeAt(u+f)===E?g=f:f===0&&(g=0));let S="";for(f=u+g+1;f<=s;++f)(f===s||t.charCodeAt(f)===E)&&(S+=S.length===0?"..":"/..");return`${S}${h.slice(d+g)}`},toNamespacedPath(t){return t},dirname(t){if(_(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===E;let u=-1,s=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===E){if(!s){u=c;break}}else s=!1;return u===-1?h?"/":".":h&&u===1?"//":t.slice(0,u)},basename(t,h){h!==void 0&&_(h,"ext"),_(t,"path");let u=0,s=-1,c=!0,d;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let m=h.length-1,D=-1;for(d=t.length-1;d>=0;--d){const g=t.charCodeAt(d);if(g===E){if(!c){u=d+1;break}}else D===-1&&(c=!1,D=d+1),m>=0&&(g===h.charCodeAt(m)?--m===-1&&(s=d):(m=-1,s=D))}return u===s?s=D:s===-1&&(s=t.length),t.slice(u,s)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===E){if(!c){u=d+1;break}}else s===-1&&(c=!1,s=d+1);return s===-1?"":t.slice(u,s)},extname(t){_(t,"path");let h=-1,u=0,s=-1,c=!0,d=0;for(let m=t.length-1;m>=0;--m){const D=t.charCodeAt(m);if(D===E){if(!c){u=m+1;break}continue}s===-1&&(c=!1,s=m+1),D===w?h===-1?h=m:d!==1&&(d=1):h!==-1&&(d=-1)}return h===-1||s===-1||d===0||d===1&&h===s-1&&h===u+1?"":t.slice(h,s)},format:r.bind(null,"/"),parse(t){_(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const u=t.charCodeAt(0)===E;let s;u?(h.root="/",s=1):s=0;let c=-1,d=0,m=-1,D=!0,g=t.length-1,f=0;for(;g>=s;--g){const S=t.charCodeAt(g);if(S===E){if(!D){d=g+1;break}continue}m===-1&&(D=!1,m=g+1),S===w?c===-1?c=g:f!==1&&(f=1):c!==-1&&(f=-1)}if(m!==-1){const S=d===0&&u?1:d;c===-1||f===0||f===1&&c===m-1&&c===d+1?h.base=h.name=t.slice(S,m):(h.name=t.slice(S,c),h.base=t.slice(S,m),h.ext=t.slice(c,m))}return d>0?h.dir=t.slice(0,d-1):u&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l?e.win32.normalize:e.posix.normalize,e.isAbsolute=l?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l?e.win32.join:e.posix.join,e.resolve=l?e.win32.resolve:e.posix.resolve,e.relative=l?e.win32.relative:e.posix.relative,e.dirname=l?e.win32.dirname:e.posix.dirname,e.basename=l?e.win32.basename:e.posix.basename,e.extname=l?e.win32.extname:e.posix.extname,e.format=l?e.win32.format:e.posix.format,e.parse=l?e.win32.parse:e.posix.parse,e.toNamespacedPath=l?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l?e.win32.sep:e.posix.sep,e.delimiter=l?e.win32.delimiter:e.posix.delimiter}),define(Ce[128],De([1,0,44,17]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const p=new P.Lazy(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new P.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new P.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(D,g,f=!1){const S=D||"",T=g||"",N=p.value.collator.compare(S,T);return p.value.collatorIsNumeric&&N===0&&S!==T?S<T?-1:1:N}e.compareFileNames=w;function E(D,g){const f=R.value.collator;return D=D||"",g=g||"",r(f,D,g)}e.compareFileNamesDefault=E;function C(D,g){const f=R.value.collator;return D=D||"",g=g||"",u(D,g)||r(f,D,g)}e.compareFileNamesUpper=C;function L(D,g){const f=R.value.collator;return D=D||"",g=g||"",h(D,g)||r(f,D,g)}e.compareFileNamesLower=L;function I(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}e.compareFileNamesUnicode=I;function v(D,g){const[f,S]=i(D),[T,N]=i(g);let z=p.value.collator.compare(S,N);if(z===0){if(p.value.collatorIsNumeric&&S!==N)return S<N?-1:1;if(z=p.value.collator.compare(f,T),p.value.collatorIsNumeric&&z===0&&f!==T)return f<T?-1:1}return z}e.compareFileExtensions=v;function y(D,g){D=D||"",g=g||"";const f=n(D),S=n(g),T=R.value.collator,N=A.value.collator;return r(N,f,S)||r(T,D,g)}e.compareFileExtensionsDefault=y;function _(D,g){D=D||"",g=g||"";const f=n(D),S=n(g),T=R.value.collator,N=A.value.collator;return r(N,f,S)||u(D,g)||r(T,D,g)}e.compareFileExtensionsUpper=_;function l(D,g){D=D||"",g=g||"";const f=n(D),S=n(g),T=R.value.collator,N=A.value.collator;return r(N,f,S)||h(D,g)||r(T,D,g)}e.compareFileExtensionsLower=l;function b(D,g){D=D||"",g=g||"";const f=n(D).toLowerCase(),S=n(g).toLowerCase();return f!==S?f<S?-1:1:D!==g?D<g?-1:1:0}e.compareFileExtensionsUnicode=b;const o=/^(.*?)(\.([^.]*))?$/;function i(D,g=!1){const f=D?o.exec(D):[];let S=[f&&f[1]||"",f&&f[3]||""];return g&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function n(D){const g=D?o.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function r(D,g,f){const S=D.compare(g,f);return S!==0?S:g.length!==f.length?g.length<f.length?-1:1:0}function a(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function h(D,g){return a(D)&&t(g)?-1:t(D)&&a(g)?1:0}function u(D,g){return t(D)&&a(g)?-1:a(D)&&t(g)?1:0}function s(D,g,f=!1){return f||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function c(D,g,f=!1){const S=D.split(F.sep),T=g.split(F.sep),N=S.length-1,z=T.length-1;let x,M;for(let k=0;;k++){if(x=N===k,M=z===k,x&&M)return w(S[k],T[k],f);if(x)return-1;if(M)return 1;const O=s(S[k],T[k],f);if(O!==0)return O}}e.comparePaths=c;function d(D,g,f){const S=D.toLowerCase(),T=g.toLowerCase(),N=m(D,g,f);if(N)return N;const z=S.endsWith(f),x=T.endsWith(f);if(z!==x)return z?-1:1;const M=w(S,T);return M!==0?M:S.localeCompare(T)}e.compareAnything=d;function m(D,g,f){const S=D.toLowerCase(),T=g.toLowerCase(),N=S.startsWith(f),z=T.startsWith(f);if(N!==z)return N?-1:1;if(N&&z){if(S.length<T.length)return-1;if(S.length>T.length)return 1}return 0}e.compareByPrefix=m}),define(Ce[34],De([1,0,17,11,12,18]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(d){return d===47||d===92}e.isPathSeparator=A;function w(d){return d.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=w;function E(d){return d.indexOf("/")===-1&&(d=w(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=E;function C(d,m=P.posix.sep){if(!d)return"";const D=d.length,g=d.charCodeAt(0);if(A(g)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let S=3;const T=S;for(;S<D&&!A(d.charCodeAt(S));S++);if(T!==S&&!A(d.charCodeAt(S+1))){for(S+=1;S<D;S++)if(A(d.charCodeAt(S)))return d.slice(0,S+1).replace(/[\\/]/g,m)}}return m}else if(o(g)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+m:d.slice(0,2);let f=d.indexOf("://");if(f!==-1){for(f+=3;f<D;f++)if(A(d.charCodeAt(f)))return d.slice(0,f+1)}return""}e.getRoot=C;function L(d){if(!F.isWindows||!d||d.length<5)return!1;let m=d.charCodeAt(0);if(m!==92||(m=d.charCodeAt(1),m!==92))return!1;let D=2;const g=D;for(;D<d.length&&(m=d.charCodeAt(D),m!==92);D++);return!(g===D||(m=d.charCodeAt(D+1),isNaN(m)||m===92))}e.isUNC=L;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function _(d,m=F.isWindows){const D=m?I:v;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||m&&y.test(d)||d==="."||d===".."||m&&d[d.length-1]==="."||m&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=_;function l(d,m,D){const g=d===m;return!D||g?g:!d||!m?!1:(0,p.equalsIgnoreCase)(d,m)}e.isEqual=l;function b(d,m,D,g=P.sep){if(d===m)return!0;if(!d||!m||m.length>d.length)return!1;if(D){if(!(0,p.startsWithIgnoreCase)(d,m))return!1;if(m.length===d.length)return!0;let S=m.length;return m.charAt(m.length-1)===g&&S--,d.charAt(S)===g}return m.charAt(m.length-1)!==g&&(m+=g),d.indexOf(m)===0}e.isEqualOrParent=b;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=o;function i(d,m){return F.isWindows&&d.endsWith(":")&&(d+=P.sep),(0,P.isAbsolute)(d)||(d=(0,P.join)(m,d)),d=(0,P.normalize)(d),F.isWindows?(d=(0,p.rtrim)(d,P.sep),d.endsWith(":")&&(d+=P.sep)):(d=(0,p.rtrim)(d,P.sep),d||(d=P.sep)),d}e.sanitizeFilePath=i;function n(d){const m=(0,P.normalize)(d);return F.isWindows?d.length>3?!1:r(m)&&(d.length===2||m.charCodeAt(2)===92):m===P.posix.sep}e.isRootOrDriveLetter=n;function r(d,m=F.isWindows){return m?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function a(d,m=F.isWindows){return r(d,m)?d[0]:void 0}e.getDriveLetter=a;function t(d,m,D){return m.length>d.length?-1:d===m?0:(D&&(d=d.toLowerCase(),m=m.toLowerCase()),d.indexOf(m))}e.indexOfPath=t;function h(d){const m=d.split(":");let D,g,f;for(const S of m){const T=Number(S);(0,R.isNumber)(T)?g===void 0?g=T:f===void 0&&(f=T):D=D?[D,S].join(":"):S}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(d,m,D=8){let g="";for(let S=0;S<D;S++){let T;S===0&&F.isWindows&&!m&&(D===3||D===4)?T=s:T=u,g+=T.charAt(Math.floor(Math.random()*T.length))}let f;return m?f=`${m}-${g}`:f=g,d?(0,P.join)(d,f):f}e.randomPath=c}),define(Ce[129],De([1,0,128,123,54,17,11,12]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,C=[E,[]];function L(U,q,ie,Z){if(!U||!q)return C;const Q=U.length,Y=q.length;if(Q<Y)return C;const ae=U.toLowerCase();return I(q,ie,Y,U,ae,Q,Z)}e.scoreFuzzy=L;function I(U,q,ie,Z,Q,Y,ae){const ee=[],fe=[];for(let se=0;se<ie;se++){const ye=se*Y,le=ye-Y,de=se>0,ce=U[se],he=q[se];for(let V=0;V<Y;V++){const J=V>0,ue=ye+V,ve=ue-1,ke=le+V-1,we=J?ee[ve]:0,Te=de&&J?ee[ke]:0,Oe=de&&J?fe[ke]:0;let xe;!Te&&de?xe=0:xe=v(ce,he,Z,Q,V,Oe),xe&&Te+xe>=we&&(ae||de||Q.startsWith(q,V))?(fe[ue]=Oe+1,ee[ue]=Te+xe):(fe[ue]=E,ee[ue]=we)}}const re=[];let G=ie-1,B=Y-1;for(;G>=0&&B>=0;){const se=G*Y+B;fe[se]===E||(re.push(B),G--),B--}return[ee[ie*Y-1],re.reverse()]}function v(U,q,ie,Z,Q,Y){let ae=0;if(!y(q,Z[Q]))return ae;if(ae+=1,Y>0&&(ae+=Y*5),U===ie[Q]&&(ae+=1),Q===0)ae+=8;else{const ee=_(ie.charCodeAt(Q-1));ee?ae+=ee:(0,F.isUpper)(ie.charCodeAt(Q))&&Y===0&&(ae+=2)}return ae}function y(U,q){return U===q?!0:U==="/"||U==="\\"?q==="/"||q==="\\":!1}function _(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function b(U,q,ie=0,Z=0){const Q=q;return Q.values&&Q.values.length>1?o(U,Q.values,ie,Z):i(U,q,ie,Z)}e.scoreFuzzy2=b;function o(U,q,ie,Z){let Q=0;const Y=[];for(const ae of q){const[ee,fe]=i(U,ae,ie,Z);if(typeof ee!="number")return l;Q+=ee,Y.push(...fe)}return[Q,D(Y)]}function i(U,q,ie,Z){const Q=(0,F.fuzzyScore)(q.original,q.originalLowercase,ie,U,U.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.createMatches)(Q)]:l}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=65536;function h(U,q,ie,Z){const Q=Z.values?Z.values:[Z];return(0,p.hash)({[Z.normalized]:{values:Q.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:U,description:q,allowNonContiguousMatches:ie}})}function u(U,q,ie,Z,Q){if(!U||!q.normalized)return n;const Y=Z.getItemLabel(U);if(!Y)return n;const ae=Z.getItemDescription(U),ee=h(Y,ae,ie,q),fe=Q[ee];if(fe)return fe;const re=s(Y,ae,Z.getItemPath(U),q,ie);return Q[ee]=re,re}e.scoreItemFuzzy=u;function s(U,q,ie,Z,Q){const Y=!ie||!Z.containsPathSeparator;return ie&&(A.isLinux?Z.pathNormalized===ie:(0,w.equalsIgnoreCase)(Z.pathNormalized,ie))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:Z.values&&Z.values.length>1?c(U,q,ie,Z.values,Y,Q):d(U,q,ie,Z,Y,Q)}function c(U,q,ie,Z,Q,Y){let ae=0;const ee=[],fe=[];for(const re of Z){const{score:G,labelMatch:B,descriptionMatch:se}=d(U,q,ie,re,Q,Y);if(G===E)return n;ae+=G,B&&ee.push(...B),se&&fe.push(...se)}return{score:ae,labelMatch:D(ee),descriptionMatch:D(fe)}}function d(U,q,ie,Z,Q,Y){if(Q||!q){const[ae,ee]=L(U,Z.normalized,Z.normalizedLowercase,Y&&!Z.expectContiguousMatch);if(ae){const fe=(0,F.matchesPrefix)(Z.normalized,U);let re;if(fe){re=a;const G=Math.round(Z.normalized.length/U.length*100);re+=G}else re=t;return{score:re+ae,labelMatch:fe||m(ee)}}}if(q){let ae=q;ie&&(ae=`${q}${R.sep}`);const ee=ae.length,fe=`${ae}${U}`,[re,G]=L(fe,Z.normalized,Z.normalizedLowercase,Y&&!Z.expectContiguousMatch);if(re){const B=m(G),se=[],ye=[];return B.forEach(le=>{le.start<ee&&le.end>ee?(se.push({start:0,end:le.end-ee}),ye.push({start:le.start,end:ee})):le.start>=ee?se.push({start:le.start-ee,end:le.end-ee}):ye.push(le)}),{score:re,labelMatch:se,descriptionMatch:ye}}}return n}function m(U){const q=[];if(!U)return q;let ie;for(const Z of U)ie&&ie.end===Z?ie.end+=1:(ie={start:Z,end:Z+1},q.push(ie));return q}function D(U){const q=U.sort((Q,Y)=>Q.start-Y.start),ie=[];let Z;for(const Q of q)!Z||!g(Z,Q)?(Z=Q,ie.push(Q)):(Z.start=Math.min(Z.start,Q.start),Z.end=Math.max(Z.end,Q.end));return ie}function g(U,q){return!(U.end<q.start||q.end<U.start)}function f(U,q,ie,Z,Q,Y){const ae=u(U,ie,Z,Q,Y),ee=u(q,ie,Z,Q,Y),fe=ae.score,re=ee.score;if((fe===r||re===r)&&fe!==re)return fe===r?-1:1;if(fe>t||re>t){if(fe!==re)return fe>re?-1:1;if(fe<a&&re<a){const ce=T(ae.labelMatch,ee.labelMatch);if(ce!==0)return ce}const le=Q.getItemLabel(U)||"",de=Q.getItemLabel(q)||"";if(le.length!==de.length)return le.length-de.length}if(fe!==re)return fe>re?-1:1;const G=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,B=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(G&&!B)return-1;if(B&&!G)return 1;const se=S(U,ae,Q),ye=S(q,ee,Q);return se&&ye&&se!==ye?ye>se?-1:1:N(U,q,ie,Q)}e.compareItemsByFuzzyScore=f;function S(U,q,ie){let Z=-1,Q=-1;if(q.descriptionMatch&&q.descriptionMatch.length?Z=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(Z=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(Q=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const Y=ie.getItemDescription(U);Y&&(Q+=Y.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(Q=q.descriptionMatch[q.descriptionMatch.length-1].end);return Q-Z}function T(U,q){if(!U&&!q||(!U||!U.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!U||!U.length)return 1;const ie=U[0].start,Q=U[U.length-1].end-ie,Y=q[0].start,ee=q[q.length-1].end-Y;return Q===ee?0:ee<Q?1:-1}function N(U,q,ie,Z){const Q=Z.getItemLabel(U)||"",Y=Z.getItemLabel(q)||"",ae=Z.getItemDescription(U),ee=Z.getItemDescription(q),fe=Q.length+(ae?ae.length:0),re=Y.length+(ee?ee.length:0);if(fe!==re)return fe-re;const G=Z.getItemPath(U),B=Z.getItemPath(q);return G&&B&&G.length!==B.length?G.length-B.length:Q!==Y?(0,P.compareAnything)(Q,Y,ie.normalized):ae&&ee&&ae!==ee?(0,P.compareAnything)(ae,ee,ie.normalized):G&&B&&G!==B?(0,P.compareAnything)(G,B,ie.normalized):0}function z(U){return U.startsWith('"')&&U.endsWith('"')}const x=" ";function M(U){typeof U!="string"&&(U="");const q=U.toLowerCase(),{pathNormalized:ie,normalized:Z,normalizedLowercase:Q}=k(U),Y=ie.indexOf(R.sep)>=0,ae=z(U);let ee;const fe=U.split(x);if(fe.length>1)for(const re of fe){const G=z(re),{pathNormalized:B,normalized:se,normalizedLowercase:ye}=k(re);se&&(ee||(ee=[]),ee.push({original:re,originalLowercase:re.toLowerCase(),pathNormalized:B,normalized:se,normalizedLowercase:ye,expectContiguousMatch:G}))}return{original:U,originalLowercase:q,pathNormalized:ie,normalized:Z,normalizedLowercase:Q,values:ee,containsPathSeparator:Y,expectContiguousMatch:ae}}e.prepareQuery=M;function k(U){let q;A.isWindows?q=U.replace(/\//g,R.sep):q=U.replace(/\\/g,R.sep);const ie=(0,w.stripWildcards)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:ie,normalizedLowercase:ie.toLowerCase()}}function O(U){return Array.isArray(U)?M(U.map(q=>q.original).join(x)):M(U.original)}e.pieceToQuery=O}),define(Ce[100],De([1,0,17]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const I=(0,P.extname)(L),v=F[I.toLowerCase()];return v!==void 0?v:A(L)}e.getMediaOrTextMime=R;function A(L){const I=(0,P.extname)(L);return p[I.toLowerCase()]}e.getMediaMime=A;function w(L){for(const I in p)if(p[I]===L)return I}e.getExtensionForMimeType=w;const E=/^(.+)\/(.+?)(;.+)?$/;function C(L,I){const v=E.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:I?void 0:L}e.normalizeMimeType=C}),define(Ce[101],De([1,0,11]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var F;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(F||(e.Source=F={}));var p;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(p||(e.TerminateResponseCode=p={}));function R(w,...E){const C=E.reduce((v,y)=>(v[y]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(v=>!C[v]).forEach(v=>{for(let y=0;y<L.length;y++)if(v.search(L[y])!==-1){delete w[v];break}})}e.sanitizeProcessEnvironment=R;function A(w){w&&(delete w.DEBUG,P.isMacintosh&&delete w.DYLD_LIBRARY_PATH,P.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(Ce[2],De([1,0,17,11]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const p=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function w(s,c){if(!s.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!p.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(s,c){return!s&&!c?"file":s}function C(s,c){switch(s){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const L="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(c){return c instanceof y?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,d,m,D,g,f=!1){typeof c=="object"?(this.scheme=c.scheme||L,this.authority=c.authority||L,this.path=c.path||L,this.query=c.query||L,this.fragment=c.fragment||L):(this.scheme=E(c,f),this.authority=d||L,this.path=C(this.scheme,m||L),this.query=D||L,this.fragment=g||L,w(this,f))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:d,authority:m,path:D,query:g,fragment:f}=c;return d===void 0?d=this.scheme:d===null&&(d=L),m===void 0?m=this.authority:m===null&&(m=L),D===void 0?D=this.path:D===null&&(D=L),g===void 0?g=this.query:g===null&&(g=L),f===void 0?f=this.fragment:f===null&&(f=L),d===this.scheme&&m===this.authority&&D===this.path&&g===this.query&&f===this.fragment?this:new b(d,m,D,g,f)}static parse(c,d=!1){const m=v.exec(c);return m?new b(m[2]||L,u(m[4]||L),u(m[5]||L),u(m[7]||L),u(m[9]||L),d):new b(L,L,L,L,L)}static file(c){let d=L;if(F.isWindows&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const m=c.indexOf(I,2);m===-1?(d=c.substring(2),c=I):(d=c.substring(2,m),c=c.substring(m)||I)}return new b("file",d,c,L,L)}static from(c,d){return new b(c.scheme,c.authority,c.path,c.query,c.fragment,d)}static joinPath(c,...d){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return F.isWindows&&c.scheme==="file"?m=y.file(P.win32.join(r(c,!0),...d)).path:m=P.posix.join(c.path,...d),c.with({path:m})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof y)return c;{const d=new b(c);return d._formatted=c.external??null,d._fsPath=c._sep===l?c.fsPath??null:null,d}}else return c}}e.URI=y;function _(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.isUriComponents=_;const l=F.isWindows?1:void 0;class b extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=l),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(s,c,d){let m,D=-1;for(let g=0;g<s.length;g++){const f=s.charCodeAt(g);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||c&&f===47||d&&f===91||d&&f===93||d&&f===58)D!==-1&&(m+=encodeURIComponent(s.substring(D,g)),D=-1),m!==void 0&&(m+=s.charAt(g));else{m===void 0&&(m=s.substr(0,g));const S=o[f];S!==void 0?(D!==-1&&(m+=encodeURIComponent(s.substring(D,g)),D=-1),m+=S):D===-1&&(D=g)}}return D!==-1&&(m+=encodeURIComponent(s.substring(D))),m!==void 0?m:s}function n(s){let c;for(let d=0;d<s.length;d++){const m=s.charCodeAt(d);m===35||m===63?(c===void 0&&(c=s.substr(0,d)),c+=o[m]):c!==void 0&&(c+=s[d])}return c!==void 0?c:s}function r(s,c){let d;return s.authority&&s.path.length>1&&s.scheme==="file"?d=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?c?d=s.path.substr(1):d=s.path[1].toLowerCase()+s.path.substr(2):d=s.path,F.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=r;function a(s,c){const d=c?n:i;let m="",{scheme:D,authority:g,path:f,query:S,fragment:T}=s;if(D&&(m+=D,m+=":"),(g||D==="file")&&(m+=I,m+=I),g){let N=g.indexOf("@");if(N!==-1){const z=g.substr(0,N);g=g.substr(N+1),N=z.lastIndexOf(":"),N===-1?m+=d(z,!1,!1):(m+=d(z.substr(0,N),!1,!1),m+=":",m+=d(z.substr(N+1),!1,!0)),m+="@"}g=g.toLowerCase(),N=g.lastIndexOf(":"),N===-1?m+=d(g,!1,!0):(m+=d(g.substr(0,N),!1,!0),m+=g.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}m+=d(f,!0,!1)}return S&&(m+="?",m+=d(S,!1,!1)),T&&(m+="#",m+=c?T:i(T,!1,!1)),m}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(s){return s.match(h)?s.replace(h,c=>t(c)):s}}),define(Ce[186],De([1,0,2]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function F(C){const L=C;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.isRemoteConsoleLog=F;function p(C){const L=[];let I;try{const v=JSON.parse(C.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),I=y.__$stack),L.push(...v)}catch{L.push("Unable to log remote console arguments",C.arguments)}return{args:L,stack:I}}e.parse=p;function R(C){if(typeof C!="string")return R(p(C).stack);const L=C;if(L){const I=A(L),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:P.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=R;function A(C){if(!C)return C;const L=C.indexOf(`
`);return L===-1?C:C.substring(0,L)}function w(C,L){const{args:I,stack:v}=p(C),y=typeof I[0]=="string"&&I.length===1;let _=A(v);_&&(_=`(${_.trim()})`);let l=[];if(typeof I[0]=="string"?_&&y?l=[`%c[${L}] %c${I[0]} %c${_}`,E("blue"),E(""),E("grey")]:l=[`%c[${L}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:l=[`%c[${L}]%`,E("blue"),...I],_&&!y&&l.push(_),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,l)}e.log=w;function E(C){return`color: ${C}`}}),define(Ce[56],De([1,0,21,2]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function p(E){return JSON.stringify(E,A)}e.stringify=p;function R(E){let C=JSON.parse(E);return C=w(C),C}e.parse=R;function A(E,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:C.flags}:C}function w(E,C=0){if(!E||C>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof P.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let L=0;L<E.length;++L)E[L]=w(E[L],C+1);else for(const L in E)Object.hasOwnProperty.call(E,L)&&(E[L]=w(E[L],C+1))}return E}e.revive=w}),define(Ce[16],De([1,0,14,11,12,2]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.codeSetting="code-setting",v.codeFeature="code-feature"})(A||(e.Schemas=A={}));function w(v,y){return R.URI.isUri(v)?(0,p.equalsIgnoreCase)(v.scheme,y):(0,p.startsWithIgnoreCase)(v,y+":")}e.matchesScheme=w;function E(v,...y){return y.some(_=>w(v,_))}e.matchesSomeScheme=E,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}setServerRootPath(y){this._remoteResourcesPath=`${y}/${A.vscodeRemoteResource}`}set(y,_,l){this._hosts[y]=_,this._ports[y]=l}setConnectionToken(y,_){this._connectionTokens[y]=_}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)try{return this._delegate(y)}catch(n){return P.onUnexpectedError(n),y}const _=y.authority;let l=this._hosts[_];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const b=this._ports[_],o=this._connectionTokens[_];let i=`path=${encodeURIComponent(y.path)}`;return typeof o=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(o)}`),R.URI.from({scheme:F.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${l}:${b}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class L{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(y){const _=this.toUri(y,me);return this.uriToBrowserUri(_)}uriToBrowserUri(y){return y.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===A.file&&(F.isNative||F.webWorkerOrigin===`${A.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?y.with({scheme:A.vscodeFileResource,authority:y.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(y){const _=this.toUri(y,me);return this.uriToFileUri(_)}uriToFileUri(y){return y.scheme===A.vscodeFileResource?y.with({scheme:A.file,authority:y.authority!==L.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(y,_){return R.URI.isUri(y)?y:R.URI.parse(_.toUrl(y))}}e.FileAccess=new L;var I;(function(v){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(y.get("3"));const _="vscode-coi";function l(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:R.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const n=i?.get(_);if(n)return y.get(n)}v.getHeadersFromQuery=l;function b(o,i,n){if(!globalThis.crossOriginIsolated)return;const r=i&&n?"3":n?"2":"1";o instanceof URLSearchParams?o.set(_,r):o[_]=r}v.addSearchParam=b})(I||(e.COI=I={}))}),define(Ce[187],De([1,0,158,16,11,2]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class A{constructor(v,y,_){this.id=v,this.dependencies=y,this.callback=_}}class w{static{this.INSTANCE=new w}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,y,_)=>{typeof v!="string"&&(_=y,y=v,v=null),(typeof y!="object"||!Array.isArray(y))&&(_=y,y=null),this._defineCalls.push(new A(v,y,_))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const y=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!y)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}_rendererLoadScript(v){return new Promise((y,_)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const b=()=>{l.removeEventListener("load",o),l.removeEventListener("error",i)},o=n=>{b(),y(this._defineCalls.pop())},i=n=>{b(),_(n)};l.addEventListener("load",o),l.addEventListener("error",i),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),l.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(l)})}_workerLoadScript(v){return new Promise((y,_)=>{try{this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),importScripts(v),y(this._defineCalls.pop())}catch(l){_(l)}})}async _nodeJSLoadScript(v){try{const y=globalThis._VSCODE_NODE_MODULES.fs,_=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,b=R.URI.parse(v).fsPath,o=y.readFileSync(b).toString(),i=l.wrap(o.replace(/^#!.*/,""));return new _.Script(i).runInThisContext().apply(),this._defineCalls.pop()}catch(y){throw y}}}const E=new Map;let C={};typeof globalThis.require=="object"&&(C=globalThis.require.paths??{});async function L(I,v,y){if(P.isESM){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),C[I]&&(I=C[I]);const _=`${I}/${v}`;if(E.has(_))return E.get(_);let l;if(/^\w[\w\d+.-]*:\/\//.test(_))l=_;else{const n=`${y&&!p.isWeb?F.nodeModulesAsarPath:F.nodeModulesPath}/${_}`;l=F.FileAccess.asBrowserUri(n).toString(!0)}const b=w.INSTANCE.load(l);return E.set(_,b),b}else return await new Promise((_,l)=>{me([I],_,l)})}e.importAMDNodeModule=L}),define(Ce[23],De([1,0,34,16,17,11,12,2]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(y){return(0,w.uriToFsPath)(y,!0)}e.originalFSPath=E;class C{constructor(_){this._ignorePathCasing=_}compare(_,l,b=!1){return _===l?0:(0,A.compare)(this.getComparisonKey(_,b),this.getComparisonKey(l,b))}isEqual(_,l,b=!1){return _===l?!0:!_||!l?!1:this.getComparisonKey(_,b)===this.getComparisonKey(l,b)}getComparisonKey(_,l=!1){return _.with({path:this._ignorePathCasing(_)?_.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(_){return this._ignorePathCasing(_)}isEqualOrParent(_,l,b=!1){if(_.scheme===l.scheme){if(_.scheme===F.Schemas.file)return P.isEqualOrParent(E(_),E(l),this._ignorePathCasing(_))&&_.query===l.query&&(b||_.fragment===l.fragment);if((0,e.isEqualAuthority)(_.authority,l.authority))return P.isEqualOrParent(_.path,l.path,this._ignorePathCasing(_),"/")&&_.query===l.query&&(b||_.fragment===l.fragment)}return!1}joinPath(_,...l){return w.URI.joinPath(_,...l)}basenameOrAuthority(_){return(0,e.basename)(_)||_.authority}basename(_){return p.posix.basename(_.path)}extname(_){return p.posix.extname(_.path)}dirname(_){if(_.path.length===0)return _;let l;return _.scheme===F.Schemas.file?l=w.URI.file(p.dirname(E(_))).path:(l=p.posix.dirname(_.path),_.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${_.toString})) resulted in a relative path`),l="/")),_.with({path:l})}normalizePath(_){if(!_.path.length)return _;let l;return _.scheme===F.Schemas.file?l=w.URI.file(p.normalize(E(_))).path:l=p.posix.normalize(_.path),_.with({path:l})}relativePath(_,l){if(_.scheme!==l.scheme||!(0,e.isEqualAuthority)(_.authority,l.authority))return;if(_.scheme===F.Schemas.file){const i=p.relative(E(_),E(l));return R.isWindows?P.toSlashes(i):i}let b=_.path||"/";const o=l.path||"/";if(this._ignorePathCasing(_)){let i=0;for(const n=Math.min(b.length,o.length);i<n&&!(b.charCodeAt(i)!==o.charCodeAt(i)&&b.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);b=o.substr(0,i)+b.substr(i)}return p.posix.relative(b,o)}resolvePath(_,l){if(_.scheme===F.Schemas.file){const b=w.URI.file(p.resolve(E(_),l));return _.with({authority:b.authority,path:b.path})}return l=P.toPosixPath(l),_.with({path:p.posix.resolve(_.path,l)})}isAbsolutePath(_){return!!_.path&&_.path[0]==="/"}isEqualAuthority(_,l){return _===l||_!==void 0&&l!==void 0&&(0,A.equalsIgnoreCase)(_,l)}hasTrailingPathSeparator(_,l=p.sep){if(_.scheme===F.Schemas.file){const b=E(_);return b.length>P.getRoot(b).length&&b[b.length-1]===l}else{const b=_.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(_.fsPath)}}removeTrailingPathSeparator(_,l=p.sep){return(0,e.hasTrailingPathSeparator)(_,l)?_.with({path:_.path.substr(0,_.path.length-1)}):_}addTrailingPathSeparator(_,l=p.sep){let b=!1;if(_.scheme===F.Schemas.file){const o=E(_);b=o!==void 0&&o.length===P.getRoot(o).length&&o[o.length-1]===l}else{l="/";const o=_.path;b=o.length===1&&o.charCodeAt(o.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(_,l)?_.with({path:_.path+"/"}):_}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(y=>y.scheme===F.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new C(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(y,_){const l=[];for(let b=0;b<y.length;b++){const o=_(y[b]);y.some((i,n)=>n===b?!1:(0,e.isEqualOrParent)(o,_(i)))||l.push(y[b])}return l}e.distinctParents=L;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function _(l){const b=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&b.set(r,a)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&b.set(y.META_DATA_MIME,i),b}y.parseMetaData=_})(I||(e.DataUri=I={}));function v(y,_,l){if(_){let b=y.path;return b&&b[0]!==p.posix.sep&&(b=p.posix.sep+b),y.with({scheme:l,authority:_,path:b})}return y.with({scheme:l})}e.toLocalResource=v}),define(Ce[8],De([1,0,22,14,4,3,23,11,164,44]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function L(he){return!!he&&typeof he.then=="function"}e.isThenable=L;function I(he){const V=new P.CancellationTokenSource,J=he(V.token),ue=new Promise((ve,ke)=>{const we=V.token.onCancellationRequested(()=>{we.dispose(),ke(new F.CancellationError)});Promise.resolve(J).then(Te=>{we.dispose(),V.dispose(),ve(Te)},Te=>{we.dispose(),V.dispose(),ke(Te)})});return new class{cancel(){V.cancel(),V.dispose()}then(ve,ke){return ue.then(ve,ke)}catch(ve){return this.then(void 0,ve)}finally(ve){return ue.finally(ve)}}}e.createCancelablePromise=I;function v(he,V,J){return new Promise((ue,ve)=>{const ke=V.onCancellationRequested(()=>{ke.dispose(),ue(J)});he.then(ue,ve).finally(()=>ke.dispose())})}e.raceCancellation=v;function y(he,V){return new Promise((J,ue)=>{const ve=V.onCancellationRequested(()=>{ve.dispose(),ue(new F.CancellationError)});he.then(J,ue).finally(()=>ve.dispose())})}e.raceCancellationError=y;async function _(he){let V=-1;const J=he.map((ue,ve)=>ue.then(ke=>(V=ve,ke)));try{return await Promise.race(J)}finally{he.forEach((ue,ve)=>{ve!==V&&ue.cancel()})}}e.raceCancellablePromises=_;function l(he,V,J){let ue;const ve=setTimeout(()=>{ue?.(void 0),J?.()},V);return Promise.race([he.finally(()=>clearTimeout(ve)),new Promise(ke=>ue=ke)])}e.raceTimeout=l;function b(he){return new Promise((V,J)=>{const ue=he();L(ue)?ue.then(V,J):V(ue)})}e.asPromise=b;function o(){let he,V;return{promise:new Promise((ue,ve)=>{he=ue,V=ve}),resolve:he,reject:V}}e.promiseWithResolvers=o;class i{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const J=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ue=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ue};this.queuedPromise=new Promise(ue=>{this.activePromise.then(J,J).then(ue)})}return new Promise((J,ue)=>{this.queuedPromise.then(J,ue)})}return this.activePromise=V(),new Promise((J,ue)=>{this.activePromise.then(ve=>{this.activePromise=null,J(ve)},ve=>{this.activePromise=null,ue(ve)})})}dispose(){this.isDisposed=!0}}e.Throttler=i;class n{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=n;class r{constructor(){this.promiseMap=new Map}queue(V,J){const ve=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get(V)===ve&&this.promiseMap.delete(V)});return this.promiseMap.set(V,ve),ve}}e.SequencerByKey=r;const a=(he,V)=>{let J=!0;const ue=setTimeout(()=>{J=!1,V()},he);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ue),J=!1}}},t=he=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,he())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class h{constructor(V){this.defaultDelay=V,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,J=this.defaultDelay){this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ve,ke)=>{this.doResolve=ve,this.doReject=ke}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ve=this.task;return this.task=null,ve()}}));const ue=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=J===E.MicrotaskDelay?t(ue):a(J,ue),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new F.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class u{constructor(V){this.delayer=new h(V),this.throttler=new i}trigger(V,J){return this.delayer.trigger(()=>this.throttler.queue(V),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=u;class s{constructor(){this._isOpen=!1,this._promise=new Promise((V,J)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class c extends s{constructor(V){super(),this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function d(he,V){return V?new Promise((J,ue)=>{const ve=setTimeout(()=>{ke.dispose(),J()},he),ke=V.onCancellationRequested(()=>{clearTimeout(ve),ke.dispose(),ue(new F.CancellationError)})}):I(J=>d(he,J))}e.timeout=d;function m(he,V=0,J){const ue=setTimeout(()=>{he(),J&&ve.dispose()},V),ve=(0,R.toDisposable)(()=>{clearTimeout(ue),J?.deleteAndLeak(ve)});return J?.add(ve),ve}e.disposableTimeout=m;function D(he){const V=[];let J=0;const ue=he.length;function ve(){return J<ue?he[J++]():null}function ke(we){we!=null&&V.push(we);const Te=ve();return Te?Te.then(ke):Promise.resolve(V)}return Promise.resolve(null).then(ke)}e.sequence=D;function g(he,V=ue=>!!ue,J=null){let ue=0;const ve=he.length,ke=()=>{if(ue>=ve)return Promise.resolve(J);const we=he[ue++];return Promise.resolve(we()).then(Oe=>V(Oe)?Promise.resolve(Oe):ke())};return ke()}e.first=g;function f(he,V=ue=>!!ue,J=null){if(he.length===0)return Promise.resolve(J);let ue=he.length;const ve=()=>{ue=-1;for(const ke of he)ke.cancel?.()};return new Promise((ke,we)=>{for(const Te of he)Te.then(Oe=>{--ue>=0&&V(Oe)?(ve(),ke(Oe)):ue===0&&ke(J)}).catch(Oe=>{--ue>=0&&(ve(),we(Oe))})})}e.firstParallel=f;class S{constructor(V){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new p.Emitter}whenIdle(){return this.size>0?p.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(V){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((J,ue)=>{this.outstandingPromises.push({factory:V,c:J,e:ue}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const J=V.factory();J.then(V.c,V.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=S;class T extends S{constructor(){super(1)}}e.Queue=T;class N{constructor(){this.sequentializer=new Y,this.tasks=0}queue(V){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,V())):this.sequentializer.run(this.tasks++,V())}}e.LimitedQueue=N;class z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const V=new fe;return this.drainers.add(V),V.p}isDrained(){for(const[,V]of this.queues)if(V.size>0)return!1;return!0}queueSize(V,J=A.extUri){const ue=J.getComparisonKey(V);return this.queues.get(ue)?.size??0}queueFor(V,J,ue=A.extUri){const ve=ue.getComparisonKey(V);let ke=this.queues.get(ve);if(!ke){ke=new T;const we=this.drainListenerCount++,Te=p.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(ve),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(we),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new R.DisposableMap),this.drainListeners.set(we,Te),this.queues.set(ve,ke)}return ke.queue(J)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const V of this.drainers)V.complete();this.drainers.clear()}dispose(){for(const[,V]of this.queues)V.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=z;class x{constructor(V,J){this._token=-1,typeof V=="function"&&typeof J=="number"&&this.setIfNotSet(V,J)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,J){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},J)}setIfNotSet(V,J){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},J))}}e.TimeoutTimer=x;class M{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(V,J,ue=globalThis){this.cancel();const ve=ue.setInterval(()=>{V()},J);this.disposable=(0,R.toDisposable)(()=>{ue.clearInterval(ve),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=M;class k{constructor(V,J){this.timeoutToken=-1,this.runner=V,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=k;class O{constructor(V,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=O;class U extends k{constructor(V,J){super(V,J),this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner?.(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class q extends R.Disposable{constructor(V,J){super(),this.options=V,this.handler=J,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.options.maxBufferedWork)return!1}else if(this.pending+V.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const J of V)this.pendingWork.push(J);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new k(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(he,V)=>{(0,w.setTimeout0)(()=>{if(J)return;const ue=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e._runWhenIdle=(he,V,J)=>{const ue=he.requestIdleCallback(V,typeof J=="number"?{timeout:J}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,he.cancelIdleCallback(ue))}}},e.runWhenGlobalIdle=he=>(0,e._runWhenIdle)(globalThis,he)}();class ie{constructor(V,J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(ue){this._error=ue}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(V,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ie;class Z extends ie{constructor(V){super(globalThis,V)}}e.GlobalIdleValue=Z;async function Q(he,V,J){let ue;for(let ve=0;ve<J;ve++)try{return await he()}catch(ke){ue=ke,await d(V)}throw ue}e.retry=Q;class Y{isRunning(V){return typeof V=="number"?this._running?.taskId===V:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(V,J,ue){return this._running={taskId:V,cancel:()=>ue?.(),promise:J},J.then(()=>this.doneRunning(V),()=>this.doneRunning(V)),J}doneRunning(V){this._running&&V===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const V=this._queued;this._queued=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this._queued)this._queued.run=V;else{const{promise:J,resolve:ue,reject:ve}=o();this._queued={run:V,promise:J,promiseResolve:ue,promiseReject:ve}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Y;class ae{constructor(V,J=()=>Date.now()){this.interval=V,this.nowFn=J,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var ee;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ee||(ee={}));class fe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((V,J)=>{this.completeCallback=V,this.errorCallback=J})}complete(V){return new Promise(J=>{this.completeCallback(V),this.outcome={outcome:0,value:V},J()})}error(V){return new Promise(J=>{this.errorCallback(V),this.outcome={outcome:1,value:V},J()})}cancel(){return this.error(new F.CancellationError)}}e.DeferredPromise=fe;var re;(function(he){async function V(ue){let ve;const ke=await Promise.all(ue.map(we=>we.then(Te=>Te,Te=>{ve||(ve=Te)})));if(typeof ve<"u")throw ve;return ke}he.settled=V;function J(ue){return new Promise(async(ve,ke)=>{try{await ue(ve,ke)}catch(we){ke(we)}})}he.withAsyncBody=J})(re||(e.Promises=re={}));class G{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(V){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=V.then(J=>(this._value=J,this._isResolved=!0,J),J=>{throw this._error=J,this._isResolved=!0,J})}requireValue(){if(!this._isResolved)throw new F.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=G;class B{constructor(V){this._compute=V,this._promise=new C.Lazy(()=>new G(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=B;var se;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(se||(se={}));class ye{static fromArray(V){return new ye(J=>{J.emitMany(V)})}static fromPromise(V){return new ye(async J=>{J.emitMany(await V)})}static fromPromises(V){return new ye(async J=>{await Promise.all(V.map(async ue=>J.emitOne(await ue)))})}static merge(V){return new ye(async J=>{await Promise.all(V.map(async ue=>{for await(const ve of ue)J.emitOne(ve)}))})}static{this.EMPTY=ye.fromArray([])}constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new p.Emitter,queueMicrotask(async()=>{const J={emitOne:ue=>this.emitOne(ue),emitMany:ue=>this.emitMany(ue),reject:ue=>this.reject(ue)};try{await Promise.resolve(V(J)),this.resolve()}catch(ue){this.reject(ue)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await p.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,J){return new ye(async ue=>{for await(const ve of V)ue.emitOne(J(ve))})}map(V){return ye.map(this,V)}static filter(V,J){return new ye(async ue=>{for await(const ve of V)J(ve)&&ue.emitOne(ve)})}filter(V){return ye.filter(this,V)}static coalesce(V){return ye.filter(V,J=>!!J)}coalesce(){return ye.coalesce(this)}static async toPromise(V){const J=[];for await(const ue of V)J.push(ue);return J}toPromise(){return ye.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=ye;class le extends ye{constructor(V,J){super(J),this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=le;function de(he){const V=new P.CancellationTokenSource,J=he(V.token);return new le(V,async ue=>{const ve=V.token.onCancellationRequested(()=>{ve.dispose(),V.dispose(),ue.reject(new F.CancellationError)});try{for await(const ke of J){if(V.token.isCancellationRequested)return;ue.emitOne(ke)}ve.dispose(),V.dispose()}catch(ke){ve.dispose(),V.dispose(),ue.reject(ke)}})}e.createCancelableAsyncIterable=de;class ce{constructor(){this._deferred=new fe,this._asyncIterable=new ye(ue=>{if(V){ue.reject(V);return}return J&&ue.emitMany(J),this._errorFn=ve=>ue.reject(ve),this._emitFn=ve=>ue.emitOne(ve),this._deferred.p});let V,J;this._emitFn=ue=>{J||(J=[]),J.push(ue)},this._errorFn=ue=>{V||(V=ue)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(V){this._errorFn(V),this._deferred.complete()}emitOne(V){this._emitFn(V)}}e.AsyncIterableSource=ce}),define(Ce[35],De([1,0,19,8,34,28,17,11,12]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",I="[^/\\\\]",v=/\//g;function y(ie,Z){switch(ie){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${Z?`|${L}${I}+`:""})*?`}}function _(ie,Z){if(!ie)return[];const Q=[];let Y=!1,ae=!1,ee="";for(const fe of ie){switch(fe){case Z:if(!Y&&!ae){Q.push(ee),ee="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}ee+=fe}return ee&&Q.push(ee),Q}e.splitGlobAware=_;function l(ie){if(!ie)return"";let Z="";const Q=_(ie,e.GLOB_SPLIT);if(Q.every(Y=>Y===e.GLOBSTAR))Z=".*";else{let Y=!1;Q.forEach((ae,ee)=>{if(ae===e.GLOBSTAR){if(Y)return;Z+=y(2,ee===Q.length-1)}else{let fe=!1,re="",G=!1,B="";for(const se of ae){if(se!=="}"&&fe){re+=se;continue}if(G&&(se!=="]"||!B)){let ye;se==="-"?ye=se:(se==="^"||se==="!")&&!B?ye="^":se===e.GLOB_SPLIT?ye="":ye=(0,E.escapeRegExpCharacters)(se),B+=ye;continue}switch(se){case"{":fe=!0;continue;case"[":G=!0;continue;case"}":{const le=`(?:${_(re,",").map(de=>l(de)).join("|")})`;Z+=le,fe=!1,re="";break}case"]":{Z+="["+B+"]",G=!1,B="";break}case"?":Z+=I;continue;case"*":Z+=y(1);continue;default:Z+=(0,E.escapeRegExpCharacters)(se)}}ee<Q.length-1&&(Q[ee+1]!==e.GLOBSTAR||ee+2<Q.length)&&(Z+=L)}Y=ae===e.GLOBSTAR})}return Z}const b=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),h=function(){return!1},u=function(){return null};function s(ie,Z){if(!ie)return u;let Q;typeof ie!="string"?Q=ie.pattern:Q=ie,Q=Q.trim();const Y=`${Q}_${!!Z.trimForExclusions}`;let ae=t.get(Y);if(ae)return c(ae,ie);let ee;return b.test(Q)?ae=m(Q.substr(4),Q):(ee=o.exec(d(Q,Z)))?ae=D(ee[1],Q):(Z.trimForExclusions?n:i).test(Q)?ae=g(Q,Z):(ee=r.exec(d(Q,Z)))?ae=f(ee[1].substr(1),Q,!0):(ee=a.exec(d(Q,Z)))?ae=f(ee[1],Q,!1):ae=S(Q),t.set(Y,ae),c(ae,ie)}function c(ie,Z){if(typeof Z=="string")return ie;const Q=function(Y,ae){return(0,p.isEqualOrParent)(Y,Z.base,!w.isLinux)?ie((0,E.ltrim)(Y.substr(Z.base.length),A.sep),ae):null};return Q.allBasenames=ie.allBasenames,Q.allPaths=ie.allPaths,Q.basenames=ie.basenames,Q.patterns=ie.patterns,Q}function d(ie,Z){return Z.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function m(ie,Z){return function(Q,Y){return typeof Q=="string"&&Q.endsWith(ie)?Z:null}}function D(ie,Z){const Q=`/${ie}`,Y=`\\${ie}`,ae=function(fe,re){return typeof fe!="string"?null:re?re===ie?Z:null:fe===ie||fe.endsWith(Q)||fe.endsWith(Y)?Z:null},ee=[ie];return ae.basenames=ee,ae.patterns=[Z],ae.allBasenames=ee,ae}function g(ie,Z){const Q=U(ie.slice(1,-1).split(",").map(re=>s(re,Z)).filter(re=>re!==u),ie),Y=Q.length;if(!Y)return u;if(Y===1)return Q[0];const ae=function(re,G){for(let B=0,se=Q.length;B<se;B++)if(Q[B](re,G))return ie;return null},ee=Q.find(re=>!!re.allBasenames);ee&&(ae.allBasenames=ee.allBasenames);const fe=Q.reduce((re,G)=>G.allPaths?re.concat(G.allPaths):re,[]);return fe.length&&(ae.allPaths=fe),ae}function f(ie,Z,Q){const Y=A.sep===A.posix.sep,ae=Y?ie:ie.replace(v,A.sep),ee=A.sep+ae,fe=A.posix.sep+ie;let re;return Q?re=function(G,B){return typeof G=="string"&&(G===ae||G.endsWith(ee)||!Y&&(G===ie||G.endsWith(fe)))?Z:null}:re=function(G,B){return typeof G=="string"&&(G===ae||!Y&&G===ie)?Z:null},re.allPaths=[(Q?"*/":"./")+ie],re}function S(ie){try{const Z=new RegExp(`^${l(ie)}$`);return function(Q){return Z.lastIndex=0,typeof Q=="string"&&Z.test(Q)?ie:null}}catch{return u}}function T(ie,Z,Q){return!ie||typeof Z!="string"?!1:N(ie)(Z,void 0,Q)}e.match=T;function N(ie,Z={}){if(!ie)return h;if(typeof ie=="string"||z(ie)){const Q=s(ie,Z);if(Q===u)return h;const Y=function(ae,ee){return!!Q(ae,ee)};return Q.allBasenames&&(Y.allBasenames=Q.allBasenames),Q.allPaths&&(Y.allPaths=Q.allPaths),Y}return k(ie,Z)}e.parse=N;function z(ie){const Z=ie;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.isRelativePattern=z;function x(ie){return ie.allBasenames||[]}e.getBasenameTerms=x;function M(ie){return ie.allPaths||[]}e.getPathTerms=M;function k(ie,Z){const Q=U(Object.getOwnPropertyNames(ie).map(re=>O(re,ie[re],Z)).filter(re=>re!==u)),Y=Q.length;if(!Y)return u;if(!Q.some(re=>!!re.requiresSiblings)){if(Y===1)return Q[0];const re=function(se,ye){let le;for(let de=0,ce=Q.length;de<ce;de++){const he=Q[de](se,ye);if(typeof he=="string")return he;(0,F.isThenable)(he)&&(le||(le=[]),le.push(he))}return le?(async()=>{for(const de of le){const ce=await de;if(typeof ce=="string")return ce}return null})():null},G=Q.find(se=>!!se.allBasenames);G&&(re.allBasenames=G.allBasenames);const B=Q.reduce((se,ye)=>ye.allPaths?se.concat(ye.allPaths):se,[]);return B.length&&(re.allPaths=B),re}const ae=function(re,G,B){let se,ye;for(let le=0,de=Q.length;le<de;le++){const ce=Q[le];ce.requiresSiblings&&B&&(G||(G=(0,A.basename)(re)),se||(se=G.substr(0,G.length-(0,A.extname)(re).length)));const he=ce(re,G,se,B);if(typeof he=="string")return he;(0,F.isThenable)(he)&&(ye||(ye=[]),ye.push(he))}return ye?(async()=>{for(const le of ye){const de=await le;if(typeof de=="string")return de}return null})():null},ee=Q.find(re=>!!re.allBasenames);ee&&(ae.allBasenames=ee.allBasenames);const fe=Q.reduce((re,G)=>G.allPaths?re.concat(G.allPaths):re,[]);return fe.length&&(ae.allPaths=fe),ae}function O(ie,Z,Q){if(Z===!1)return u;const Y=s(ie,Q);if(Y===u)return u;if(typeof Z=="boolean")return Y;if(Z){const ae=Z.when;if(typeof ae=="string"){const ee=(fe,re,G,B)=>{if(!B||!Y(fe,re))return null;const se=ae.replace("$(basename)",()=>G),ye=B(se);return(0,F.isThenable)(ye)?ye.then(le=>le?ie:null):ye?ie:null};return ee.requiresSiblings=!0,ee}}return Y}function U(ie,Z){const Q=ie.filter(re=>!!re.basenames);if(Q.length<2)return ie;const Y=Q.reduce((re,G)=>{const B=G.basenames;return B?re.concat(B):re},[]);let ae;if(Z){ae=[];for(let re=0,G=Y.length;re<G;re++)ae.push(Z)}else ae=Q.reduce((re,G)=>{const B=G.patterns;return B?re.concat(B):re},[]);const ee=function(re,G){if(typeof re!="string")return null;if(!G){let se;for(se=re.length;se>0;se--){const ye=re.charCodeAt(se-1);if(ye===47||ye===92)break}G=re.substr(se)}const B=Y.indexOf(G);return B!==-1?ae[B]:null};ee.basenames=Y,ee.patterns=ae,ee.allBasenames=Y;const fe=ie.filter(re=>!re.basenames);return fe.push(ee),fe}function q(ie,Z){return(0,P.equals)(ie,Z,(Q,Y)=>typeof Q=="string"&&typeof Y=="string"?Q===Y:typeof Q!="string"&&typeof Y!="string"?Q.base===Y.base&&Q.pattern===Y.pattern:!1)}e.patternsEquals=q}),define(Ce[80],De([1,0,14,165,23,12,2]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.appendEscapedMarkdownCodeBlockFence=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class E{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=v(this.supportThemeIcons?(0,F.escapeIcons)(i):i).replace(/([ \t]+)/g,(r,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${y(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this._escape(n,"]"),this.value+="](",this.value+=this._escape(String(i),")"),r&&(this.value+=` "${this._escape(this._escape(r,'"'),")")}"`),this.value+=")",this}_escape(i,n){const r=new RegExp((0,R.escapeRegExpCharacters)(n),"g");return i.replace(r,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=E;function C(o){return L(o)?!o.value:Array.isArray(o)?o.every(C):!0}e.isEmptyMarkdownString=C;function L(o){return o instanceof E?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function I(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,p.isEqual)(A.URI.from(o.baseUri),A.URI.from(i.baseUri)))}e.markdownStringEqual=I;function v(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function y(o,i){const n=o.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,o,`${"`".repeat(r)}`].join(`
`)}e.appendEscapedMarkdownCodeBlockFence=y;function _(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=_;function l(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=l;function b(o){const i=[],n=o.split("|").map(a=>a.trim());o=n[0];const r=n[1];if(r){const a=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),h=a?a[1]:"",u=t?t[1]:"",s=isFinite(parseInt(u)),c=isFinite(parseInt(h));s&&i.push(`width="${u}"`),c&&i.push(`height="${h}"`)}return{href:o,dimensions:i}}e.parseHrefAndDimensions=b}),define(Ce[102],De([1,0,19,34,17,11,23,12]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(s,c){const{os:d,tildify:m,relative:D}=c;if(D){const S=C(s,D,d);if(typeof S=="string")return S}let g=s.fsPath;if(d===1&&!R.isWindows?g=g.replace(/\//g,"\\"):d!==1&&R.isWindows&&(g=g.replace(/\\/g,"/")),d!==1&&m?.userHome){const S=m.userHome.fsPath;let T;s.scheme!==m.userHome.scheme&&s.path[0]===p.posix.sep&&s.path[1]!==p.posix.sep?T=m.userHome.with({path:s.path}).fsPath:T=g,g=v(T,S,d)}return(d===1?p.win32:p.posix).normalize(L(g,d===1))}e.getPathLabel=E;function C(s,c,d){const m=d===1?p.win32:p.posix,D=d===3?A.extUri:A.extUriIgnorePathCase,g=c.getWorkspace(),f=(0,P.firstOrDefault)(g.folders);if(!f)return;s.scheme!==f.uri.scheme&&s.path[0]===p.posix.sep&&s.path[1]!==p.posix.sep&&(s=f.uri.with({path:s.path}));const S=c.getWorkspaceFolder(s);if(!S)return;let T;if(D.isEqual(S.uri,s)?T="":T=D.relativePath(S.uri,s)??"",T&&(T=m.normalize(T)),g.folders.length>1&&!c.noPrefix){const N=S.name?S.name:D.basenameOrAuthority(S.uri);T=T?`${N} \u2022 ${T}`:N}return T}function L(s,c=R.isWindows){return(0,F.hasDriveLetter)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let I=Object.create(null);function v(s,c,d=R.OS){if(d===1||!s||!c)return s;let m=I.original===c?I.normalized:void 0;m||(m=c,R.isWindows&&(m=(0,F.toSlashes)(m)),m=`${(0,w.rtrim)(m,p.posix.sep)}${p.posix.sep}`,I={original:c,normalized:m});let D=s;return R.isWindows&&(D=(0,F.toSlashes)(D)),(d===3?D.startsWith(m):(0,w.startsWithIgnoreCase)(D,m))?`~/${D.substr(m.length)}`:s}e.tildify=v;function y(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=y;const _="\u2026",l="\\\\",b="~";function o(s,c=p.sep){const d=new Array(s.length);let m=!1;for(let D=0;D<s.length;D++){const g=s[D];if(g===""){d[D]=`.${c}`;continue}if(!g){d[D]=g;continue}m=!0;let f="",S=g;S.indexOf(l)===0?(f=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(c)===0?(f=S.substr(0,S.indexOf(c)+c.length),S=S.substr(S.indexOf(c)+c.length)):S.indexOf(b)===0&&(f=S.substr(0,S.indexOf(b)+b.length),S=S.substr(S.indexOf(b)+b.length));const T=S.split(c);for(let N=1;m&&N<=T.length;N++)for(let z=T.length-N;m&&z>=0;z--){m=!1;let x=T.slice(z,z+N).join(c);for(let M=0;!m&&M<s.length;M++)if(M!==D&&s[M]&&s[M].indexOf(x)>-1){const k=z+N===T.length,O=z>0&&s[M].indexOf(c)>-1?c+x:x,U=s[M].endsWith(O);m=!k||U}if(!m){let M="";(T[0].endsWith(":")||f!=="")&&(z===1&&(z=0,N++,x=T[0]+c+x),z>0&&(M=T[0]+c),M=f+M),z>0&&(M=M+_+c),M=M+x,z+N<T.length&&(M=M+c+_),d[D]=M}}m&&(d[D]=g)}return d}e.shorten=o;var i;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(s,c=Object.create(null)){const d=[];let m=!1,D="";for(const g of s)if(g==="$"||m&&g==="{")D&&d.push({value:D,type:i.TEXT}),D="",m=!0;else if(g==="}"&&m){const f=c[D];if(typeof f=="string")f.length&&d.push({value:f,type:i.VARIABLE});else if(f){const S=d[d.length-1];(!S||S.type!==i.SEPARATOR)&&d.push({value:f.label,type:i.SEPARATOR})}D="",m=!1}else D+=g;return D&&!m&&d.push({value:D,type:i.TEXT}),d.filter((g,f)=>{if(g.type===i.SEPARATOR){const S=d[f-1],T=d[f+1];return[S,T].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=n;function r(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=r;function a(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function t(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=t;function h(s){if(s.endsWith("]")){const c=s.lastIndexOf(" [",s.length-2);if(c!==-1){const d=u(s.substring(0,c)),m=s.substring(c);return{name:d.name+m,parentPath:d.parentPath}}}return u(s)}e.splitRecentLabel=h;function u(s){const c=s.indexOf("/")!==-1?p.posix:p.win32,d=c.basename(s),m=c.dirname(s);return d.length?{name:d,parentPath:m}:{name:m,parentPath:""}}}),define(Ce[130],De([1,0,21,2]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function p(I){return I.toJSON()}class R{constructor(v){this._uriTransformer=v}transformIncoming(v){const y=this._uriTransformer.transformIncoming(v);return y===v?v:p(F.URI.from(y))}transformOutgoing(v){const y=this._uriTransformer.transformOutgoing(v);return y===v?v:p(F.URI.from(y))}transformOutgoingURI(v){const y=this._uriTransformer.transformOutgoing(v);return y===v?v:F.URI.from(y)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,v,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return v.transformOutgoing(I);for(const _ in I)if(Object.hasOwnProperty.call(I,_)){const l=A(I[_],v,y+1);l!==null&&(I[_]=l)}}return null}function w(I,v){const y=A(I,v,0);return y===null?I:y}e.transformOutgoingURIs=w;function E(I,v,y,_){if(!I||_>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?F.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);if(I instanceof P.VSBuffer)return null;for(const l in I)if(Object.hasOwnProperty.call(I,l)){const b=E(I[l],v,y,_+1);b!==null&&(I[l]=b)}}return null}function C(I,v){const y=E(I,v,!1,0);return y===null?I:y}e.transformIncomingURIs=C;function L(I,v){const y=E(I,v,!0,0);return y===null?I:y}e.transformAndReviveIncomingURIs=L}),define(Ce[31],De([1,0,57,63,388,8,34,76,17,11,23,2]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function y(O,U=v.UNLINK,q){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?l(O):_(O,q)}async function _(O,U=(0,A.randomPath)((0,F.tmpdir)())){try{try{await P.promises.rename(O,U)}catch(q){return q.code==="ENOENT"?void 0:l(O)}l(U).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function l(O){return(0,p.promisify)(P.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function b(O){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function o(O,U){return r(await(U?i(O):(0,p.promisify)(P.readdir)(O)))}async function i(O){try{return await(0,p.promisify)(P.readdir)(O,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const U=[],q=await o(O);for(const ie of q){let Z=!1,Q=!1,Y=!1;try{const ae=await e.Promises.lstat((0,E.join)(O,ie));Z=ae.isFile(),Q=ae.isDirectory(),Y=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}U.push({name:ie,isFile:()=>Z,isDirectory:()=>Q,isSymbolicLink:()=>Y})}return U}function n(O){return r(P.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(U=>typeof U=="string"?C.isMacintosh?(0,w.normalizeNFC)(U):U:(U.name=C.isMacintosh?(0,w.normalizeNFC)(U.name):U.name,U))}async function a(O){const U=await o(O),q=[];for(const ie of U)await h.existsDirectory((0,E.join)(O,ie))&&q.push(ie);return q}function t(O,U=1e3){return new Promise(q=>{let ie=!1;const Z=setInterval(()=>{ie||(ie=!0,P.access(O,Q=>{ie=!1,Q&&(clearInterval(Z),q(void 0))}))},U)})}e.whenDeleted=t;var h;(function(O){async function U(Z){let Q;try{if(Q=await e.Promises.lstat(Z),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(C.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ae}throw Y}}O.stat=U;async function q(Z){try{const{stat:Q,symbolicLink:Y}=await O.stat(Z);return Q.isFile()&&Y?.dangling!==!0}catch{}return!1}O.existsFile=q;async function ie(Z){try{const{stat:Q,symbolicLink:Y}=await O.stat(Z);return Q.isDirectory()&&Y?.dangling!==!0}catch{}return!1}O.existsDirectory=ie})(h||(e.SymlinkSupport=h={}));const u=new R.ResourceQueue;function s(O,U,q){return u.queueFor(I.URI.file(O),()=>{const ie=g(q);return new Promise((Z,Q)=>m(O,U,ie,Y=>Y?Q(Y):Z()))},L.extUriBiasedIgnorePathCase)}let c=!0;function d(O){c=O}e.configureFlushOnWrite=d;function m(O,U,q,ie){if(!c)return P.writeFile(O,U,{mode:q.mode,flag:q.flag},ie);P.open(O,q.flag,q.mode,(Z,Q)=>{if(Z)return ie(Z);P.writeFile(Q,U,Y=>{if(Y)return P.close(Q,()=>ie(Y));P.fdatasync(Q,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),d(!1)),P.close(Q,ee=>ie(ee))))})})}function D(O,U,q){const ie=g(q);if(!c)return P.writeFileSync(O,U,{mode:ie.mode,flag:ie.flag});const Z=P.openSync(O,ie.flag,ie.mode);try{P.writeFileSync(Z,U);try{P.fdatasyncSync(Z)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),d(!1)}}finally{P.closeSync(Z)}}e.writeFileSync=D;function g(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function f(O,U,q=6e4){if(O!==U)try{C.isWindows&&typeof q=="number"?await S(O,U,Date.now(),q):await(0,p.promisify)(P.rename)(O,U)}catch(ie){if(O.toLowerCase()!==U.toLowerCase()&&ie.code==="EXDEV"||O.endsWith("."))await T(O,U,{preserveSymlinks:!1}),await y(O,v.MOVE);else throw ie}}async function S(O,U,q,ie,Z=0){try{return await(0,p.promisify)(P.rename)(O,U)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-q>=ie)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${Q}`),Q;if(Z===0){let Y=!1;try{const{stat:ae}=await h.stat(U);ae.isFile()||(Y=!0)}catch{}if(Y)throw Q}return await(0,R.timeout)(Math.min(100,Z*10)),S(O,U,q,ie,Z+1)}}async function T(O,U,q){return z(O,U,{root:{source:O,target:U},options:q,handledSourcePaths:new Set})}const N=511;async function z(O,U,q){if(q.handledSourcePaths.has(O))return;q.handledSourcePaths.add(O);const{stat:ie,symbolicLink:Z}=await h.stat(O);if(Z){if(q.options.preserveSymlinks)try{return await k(O,U,q)}catch{}if(Z.dangling)return}return ie.isDirectory()?x(O,U,ie.mode&N,q):M(O,U,ie.mode&N)}async function x(O,U,q,ie){await e.Promises.mkdir(U,{recursive:!0,mode:q});const Z=await o(O);for(const Q of Z)await z((0,E.join)(O,Q),(0,E.join)(U,Q),ie)}async function M(O,U,q){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,q)}async function k(O,U,q){let ie=await e.Promises.readlink(O);(0,A.isEqualOrParent)(ie,q.root.source,!C.isLinux)&&(ie=(0,E.join)(q.root.target,ie.substr(q.root.source.length+1))),await e.Promises.symlink(ie,U)}e.Promises=new class{get access(){return(0,p.promisify)(P.access)}get stat(){return(0,p.promisify)(P.stat)}get lstat(){return(0,p.promisify)(P.lstat)}get utimes(){return(0,p.promisify)(P.utimes)}get read(){return(O,U,q,ie,Z)=>new Promise((Q,Y)=>{P.read(O,U,q,ie,Z,(ae,ee,fe)=>ae?Y(ae):Q({bytesRead:ee,buffer:fe}))})}get readFile(){return(0,p.promisify)(P.readFile)}get write(){return(O,U,q,ie,Z)=>new Promise((Q,Y)=>{P.write(O,U,q,ie,Z,(ae,ee,fe)=>ae?Y(ae):Q({bytesWritten:ee,buffer:fe}))})}get appendFile(){return(0,p.promisify)(P.appendFile)}get fdatasync(){return(0,p.promisify)(P.fdatasync)}get truncate(){return(0,p.promisify)(P.truncate)}get copyFile(){return(0,p.promisify)(P.copyFile)}get open(){return(0,p.promisify)(P.open)}get close(){return(0,p.promisify)(P.close)}get symlink(){return(0,p.promisify)(P.symlink)}get readlink(){return(0,p.promisify)(P.readlink)}get chmod(){return(0,p.promisify)(P.chmod)}get mkdir(){return(0,p.promisify)(P.mkdir)}get unlink(){return(0,p.promisify)(P.unlink)}get rmdir(){return(0,p.promisify)(P.rmdir)}get realpath(){return(0,p.promisify)(P.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return s}get rm(){return y}get rename(){return f}get copy(){return T}}}),define(Ce[103],De([1,0,57,17,11,12,31]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function w(v){if(p.isLinux)return v;const y=(0,F.dirname)(v);if(v===y)return v;const _=((0,F.basename)(v)||v).toLowerCase();try{const b=(0,A.readdirSync)(y).filter(o=>o.toLowerCase()===_);if(b.length===1){const o=w(y);if(o)return(0,F.join)(o,b[0])}else if(b.length>1){const o=b.indexOf(_);if(o>=0){const i=w(y);if(i)return(0,F.join)(i,b[o])}}}catch{}return null}e.realcaseSync=w;async function E(v){if(p.isLinux)return v;const y=(0,F.dirname)(v);if(v===y)return v;const _=((0,F.basename)(v)||v).toLowerCase();try{const b=(await A.Promises.readdir(y)).filter(o=>o.toLowerCase()===_);if(b.length===1){const o=await E(y);if(o)return(0,F.join)(o,b[0])}else if(b.length>1){const o=b.indexOf(_);if(o>=0){const i=await E(y);if(i)return(0,F.join)(i,b[o])}}}catch{}return null}e.realcase=E;async function C(v){try{return await A.Promises.realpath(v)}catch{const _=I(v);return await A.Promises.access(_,P.constants.R_OK),_}}e.realpath=C;function L(v){try{return P.realpathSync(v)}catch{const _=I(v);return P.accessSync(_,P.constants.R_OK),_}}e.realpathSync=L;function I(v){return(0,R.rtrim)((0,F.normalize)(v),F.sep)}}),define(Ce[104],De([1,0,17,11,50,101,18,31]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function E(I=p.env){return I.comspec||"cmd.exe"}e.getWindowsShell=E;function C(I){let v=[],y=!1;const _=function(l){if(y){v.push(l);return}(!I.send(l,o=>{if(o&&console.error(o),y=!1,v.length>0){const i=v.slice(0);v=[],i.forEach(n=>_(n))}})||F.isWindows)&&(y=!0)};return{send:_}}e.createQueuedSender=C;var L;(function(I){async function v(y,_,l){if(P.isAbsolute(y))return y;if(_===void 0&&(_=p.cwd()),P.dirname(y)!=="."||(l===void 0&&A.isString(p.env.PATH)&&(l=p.env.PATH.split(P.delimiter)),l===void 0||l.length===0))return P.join(_,y);async function o(i){if(await w.Promises.exists(i)){let n;try{n=await w.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await w.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of l){let n;if(P.isAbsolute(i)?n=P.join(i,y):n=P.join(_,i,y),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return P.join(_,y)}I.findExecutable=v})(L||(e.win32=L={}))});var Ge=this&&this.__decorate||function(me,e,P,F){var p=arguments.length,R=p<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,P):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,P,F);else for(var w=me.length-1;w>=0;w--)(A=me[w])&&(R=(p<3?A(R):p>3?A(e,P,R):A(e,P))||R);return p>3&&R&&Object.defineProperty(e,P,R),R};define(Ce[81],De([1,0,19,8,21,22,53,14,4,3,56,12,18]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var y;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(y||(y={}));function _(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(l||(l={}));function b(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function i(Z){let Q=0;for(let Y=0;;Y+=7){const ae=Z.read(1);if(Q|=(ae.buffer[0]&127)<<Y,!(ae.buffer[0]&128))return Q}}const n=u(0);function r(Z,Q){if(Q===0){Z.write(n);return}let Y=0;for(let ee=Q;ee!==0;ee=ee>>>7)Y++;const ae=p.VSBuffer.alloc(Y);for(let ee=0;Q!==0;ee++)ae.buffer[ee]=Q&127,Q=Q>>>7,Q>0&&(ae.buffer[ee]|=128);Z.write(ae)}class a{constructor(Q){this.buffer=Q,this.pos=0}read(Q){const Y=this.buffer.slice(this.pos,this.pos+Q);return this.pos+=Y.byteLength,Y}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return p.VSBuffer.concat(this.buffers)}write(Q){this.buffers.push(Q)}}e.BufferWriter=t;var h;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(h||(h={}));function u(Z){const Q=p.VSBuffer.alloc(1);return Q.writeUInt8(Z,0),Q}const s={Undefined:u(h.Undefined),String:u(h.String),Buffer:u(h.Buffer),VSBuffer:u(h.VSBuffer),Array:u(h.Array),Object:u(h.Object),Uint:u(h.Int)},c=typeof Buffer<"u";function d(Z,Q){if(typeof Q>"u")Z.write(s.Undefined);else if(typeof Q=="string"){const Y=p.VSBuffer.fromString(Q);Z.write(s.String),r(Z,Y.byteLength),Z.write(Y)}else if(c&&Buffer.isBuffer(Q)){const Y=p.VSBuffer.wrap(Q);Z.write(s.Buffer),r(Z,Y.byteLength),Z.write(Y)}else if(Q instanceof p.VSBuffer)Z.write(s.VSBuffer),r(Z,Q.byteLength),Z.write(Q);else if(Array.isArray(Q)){Z.write(s.Array),r(Z,Q.length);for(const Y of Q)d(Z,Y)}else if(typeof Q=="number"&&(Q|0)===Q)Z.write(s.Uint),r(Z,Q);else{const Y=p.VSBuffer.fromString(JSON.stringify(Q));Z.write(s.Object),r(Z,Y.byteLength),Z.write(Y)}}e.serialize=d;function m(Z){switch(Z.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return Z.read(i(Z)).toString();case h.Buffer:return Z.read(i(Z)).buffer;case h.VSBuffer:return Z.read(i(Z));case h.Array:{const Y=i(Z),ae=[];for(let ee=0;ee<Y;ee++)ae.push(m(Z));return ae}case h.Object:return JSON.parse(Z.read(i(Z)).toString());case h.Int:return i(Z)}}e.deserialize=m;class D{constructor(Q,Y,ae=null,ee=1e3){this.protocol=Q,this.ctx=Y,this.logger=ae,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(fe=>this.onRawMessage(fe)),this.sendResponse({type:200})}registerChannel(Q,Y){this.channels.set(Q,Y),setTimeout(()=>this.flushPendingRequests(Q),0)}sendResponse(Q){switch(Q.type){case 200:{const Y=this.send([Q.type]);this.logger?.logOutgoing(Y,0,1,b(Q.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([Q.type,Q.id],Q.data);this.logger?.logOutgoing(Y,Q.id,1,b(Q.type),Q.data);return}}}send(Q,Y=void 0){const ae=new t;return d(ae,Q),d(ae,Y),this.sendBuffer(ae.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onRawMessage(Q){const Y=new a(Q),ae=m(Y),ee=m(Y),fe=ae[0];switch(fe){case 100:return this.logger?.logIncoming(Q.byteLength,ae[1],1,`${_(fe)}: ${ae[2]}.${ae[3]}`,ee),this.onPromise({type:fe,id:ae[1],channelName:ae[2],name:ae[3],arg:ee});case 102:return this.logger?.logIncoming(Q.byteLength,ae[1],1,`${_(fe)}: ${ae[2]}.${ae[3]}`,ee),this.onEventListen({type:fe,id:ae[1],channelName:ae[2],name:ae[3],arg:ee});case 101:return this.logger?.logIncoming(Q.byteLength,ae[1],1,`${_(fe)}`),this.disposeActiveRequest({type:fe,id:ae[1]});case 103:return this.logger?.logIncoming(Q.byteLength,ae[1],1,`${_(fe)}`),this.disposeActiveRequest({type:fe,id:ae[1]})}}onPromise(Q){const Y=this.channels.get(Q.channelName);if(!Y){this.collectPendingRequest(Q);return}const ae=new R.CancellationTokenSource;let ee;try{ee=Y.call(this.ctx,Q.name,Q.arg,ae.token)}catch(G){ee=Promise.reject(G)}const fe=Q.id;ee.then(G=>{this.sendResponse({id:fe,data:G,type:201})},G=>{G instanceof Error?this.sendResponse({id:fe,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:fe,data:G,type:203})}).finally(()=>{re.dispose(),this.activeRequests.delete(Q.id)});const re=(0,C.toDisposable)(()=>ae.cancel());this.activeRequests.set(Q.id,re)}onEventListen(Q){const Y=this.channels.get(Q.channelName);if(!Y){this.collectPendingRequest(Q);return}const ae=Q.id,fe=Y.listen(this.ctx,Q.name,Q.arg)(re=>this.sendResponse({id:ae,data:re,type:204}));this.activeRequests.set(Q.id,fe)}disposeActiveRequest(Q){const Y=this.activeRequests.get(Q.id);Y&&(Y.dispose(),this.activeRequests.delete(Q.id))}collectPendingRequest(Q){let Y=this.pendingRequests.get(Q.channelName);Y||(Y=[],this.pendingRequests.set(Q.channelName,Y));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.sendResponse({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:Q,timeoutTimer:ae})}flushPendingRequests(Q){const Y=this.pendingRequests.get(Q);if(Y){for(const ae of Y)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(Q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var g;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class f{constructor(Q,Y=null){this.protocol=Q,this.isDisposed=!1,this.state=o.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=Y}getChannel(Q){const Y=this;return{call(ae,ee,fe){return Y.isDisposed?Promise.reject(new w.CancellationError):Y.requestPromise(Q,ae,ee,fe)},listen(ae,ee){return Y.isDisposed?E.Event.None:Y.requestEvent(Q,ae,ee)}}}requestPromise(Q,Y,ae,ee=R.CancellationToken.None){const fe=this.lastRequestId++,G={id:fe,type:100,channelName:Q,name:Y,arg:ae};if(ee.isCancellationRequested)return Promise.reject(new w.CancellationError);let B;return new Promise((ye,le)=>{if(ee.isCancellationRequested)return le(new w.CancellationError);const de=()=>{const J=ue=>{switch(ue.type){case 201:this.handlers.delete(fe),ye(ue.data);break;case 202:{this.handlers.delete(fe);const ve=new Error(ue.data.message);ve.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ve.name=ue.data.name,le(ve);break}case 203:this.handlers.delete(fe),le(ue.data);break}};this.handlers.set(fe,J),this.sendRequest(G)};let ce=null;this.state===o.Idle?de():(ce=(0,F.createCancelablePromise)(J=>this.whenInitialized()),ce.then(()=>{ce=null,de()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:fe,type:101}),le(new w.CancellationError)},V=ee.onCancellationRequested(he);B=(0,C.combinedDisposable)((0,C.toDisposable)(he),V),this.activeRequests.add(B)}).finally(()=>{B.dispose(),this.activeRequests.delete(B)})}requestEvent(Q,Y,ae){const ee=this.lastRequestId++,re={id:ee,type:102,channelName:Q,name:Y,arg:ae};let G=null;const B=new E.Emitter({onWillAddFirstListener:()=>{G=(0,F.createCancelablePromise)(ye=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(B),this.sendRequest(re)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(B),this.sendRequest({id:ee,type:103}))}}),se=ye=>B.fire(ye.data);return this.handlers.set(ee,se),B.event}sendRequest(Q){switch(Q.type){case 100:case 102:{const Y=this.send([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.logger?.logOutgoing(Y,Q.id,0,`${_(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Y=this.send([Q.type,Q.id]);this.logger?.logOutgoing(Y,Q.id,0,_(Q.type));return}}}send(Q,Y=void 0){const ae=new t;return d(ae,Q),d(ae,Y),this.sendBuffer(ae.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onBuffer(Q){const Y=new a(Q),ae=m(Y),ee=m(Y),fe=ae[0];switch(fe){case 200:return this.logger?.logIncoming(Q.byteLength,0,0,b(fe)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(Q.byteLength,ae[1],0,b(fe),ee),this.onResponse({type:ae[0],id:ae[1],data:ee})}}onResponse(Q){if(Q.type===200){this.state=o.Idle,this._onDidInitialize.fire();return}this.handlers.get(Q.id)?.(Q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=f,Ge([A.memoize],f.prototype,"onDidInitializePromise",null);class S{get connections(){const Q=[];return this._connections.forEach(Y=>Q.push(Y)),Q}constructor(Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new C.DisposableStore,this.disposables.add(Q(({protocol:Y,onDidClientDisconnect:ae})=>{const ee=E.Event.once(Y.onMessage);this.disposables.add(ee(fe=>{const re=new a(fe),G=m(re),B=new D(Y,G),se=new f(Y);this.channels.forEach((le,de)=>B.registerChannel(de,le));const ye={channelServer:B,channelClient:se,ctx:G};this._connections.add(ye),this._onDidAddConnection.fire(ye),this.disposables.add(ae(()=>{B.dispose(),se.dispose(),this._connections.delete(ye),this._onDidRemoveConnection.fire(ye)}))}))}))}getChannel(Q,Y){const ae=this;return{call(ee,fe,re){let G;if((0,v.isFunction)(Y)){const se=(0,P.getRandomElement)(ae.connections.filter(Y));G=se?Promise.resolve(se):E.Event.toPromise(E.Event.filter(ae.onDidAddConnection,Y))}else G=Y.routeCall(ae,ee,fe);const B=G.then(se=>se.channelClient.getChannel(Q));return N(B).call(ee,fe,re)},listen(ee,fe){if((0,v.isFunction)(Y))return ae.getMulticastEvent(Q,Y,ee,fe);const re=Y.routeEvent(ae,ee,fe).then(G=>G.channelClient.getChannel(Q));return N(re).listen(ee,fe)}}}getMulticastEvent(Q,Y,ae,ee){const fe=this;let re;const G=new E.Emitter({onWillAddFirstListener:()=>{re=new C.DisposableStore;const B=new E.EventMultiplexer,se=new Map,ye=de=>{const he=de.channelClient.getChannel(Q).listen(ae,ee),V=B.add(he);se.set(de,V)},le=de=>{const ce=se.get(de);ce&&(ce.dispose(),se.delete(de))};fe.connections.filter(Y).forEach(ye),E.Event.filter(fe.onDidAddConnection,Y)(ye,void 0,re),fe.onDidRemoveConnection(le,void 0,re),B.event(G.fire,G,re),re.add(B)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return G.event}registerChannel(Q,Y){this.channels.set(Q,Y);for(const ae of this._connections)ae.channelServer.registerChannel(Q,Y)}dispose(){this.disposables.dispose();for(const Q of this._connections)Q.channelClient.dispose(),Q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class T{constructor(Q,Y,ae=null){const ee=new t;d(ee,Y),Q.send(ee.buffer),this.channelClient=new f(Q,ae),this.channelServer=new D(Q,Y,ae)}getChannel(Q){return this.channelClient.getChannel(Q)}registerChannel(Q,Y){this.channelServer.registerChannel(Q,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function N(Z){return{call(Q,Y,ae){return Z.then(ee=>ee.call(Q,Y,ae))},listen(Q,Y){const ae=new E.Relay;return Z.then(ee=>ae.input=ee.listen(Q,Y)),ae.event}}}e.getDelayedChannel=N;function z(Z){let Q=!1;return{call(Y,ae,ee){return Q?Z.call(Y,ae,ee):(0,F.timeout)(0).then(()=>Q=!0).then(()=>Z.call(Y,ae,ee))},listen(Y,ae){if(Q)return Z.listen(Y,ae);const ee=new E.Relay;return(0,F.timeout)(0).then(()=>Q=!0).then(()=>ee.input=Z.listen(Y,ae)),ee.event}}}e.getNextTickChannel=z;class x{constructor(Q){this.fn=Q}routeCall(Q){return this.route(Q)}routeEvent(Q){return this.route(Q)}async route(Q){for(const Y of Q.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await E.Event.toPromise(Q.onDidAddConnection),await this.route(Q)}}e.StaticRouter=x;var M;(function(Z){function Q(fe,re,G){const B=fe,se=G&&G.disableMarshalling,ye=new Map;for(const le in B)ae(le)&&ye.set(le,E.Event.buffer(B[le],!0,void 0,re));return new class{listen(le,de,ce){const he=ye.get(de);if(he)return he;if(ee(de)){const V=B[de];if(typeof V=="function")return V.call(B,ce)}throw new w.ErrorNoTelemetry(`Event not found: ${de}`)}call(le,de,ce){const he=B[de];if(typeof he=="function"){if(!se&&Array.isArray(ce))for(let J=0;J<ce.length;J++)ce[J]=(0,L.revive)(ce[J]);let V=he.apply(B,ce);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new w.ErrorNoTelemetry(`Method not found: ${de}`)}}}Z.fromService=Q;function Y(fe,re){const G=re&&re.disableMarshalling;return new Proxy({},{get(B,se){if(typeof se=="string")return re?.properties?.has(se)?re.properties.get(se):ee(se)?function(ye){return fe.listen(se,ye)}:ae(se)?fe.listen(se):async function(...ye){let le;re&&!(0,v.isUndefinedOrNull)(re.context)?le=[re.context,...ye]:le=ye;const de=await fe.call(se,le);return G?de:(0,L.revive)(de)};throw new w.ErrorNoTelemetry(`Property not found: ${String(se)}`)}})}Z.toService=Y;function ae(fe){return fe[0]==="o"&&fe[1]==="n"&&I.isUpperAsciiLetter(fe.charCodeAt(2))}function ee(fe){return/^onDynamic/.test(fe)&&I.isUpperAsciiLetter(fe.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const k=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const Q=Z.toString();if(Q!=="[object Object]")return Q}return Z}function U(Z){return Array.isArray(Z)?Z.map(O):O(Z)}function q(Z,Q,Y,ae,ee,fe,re){re=U(re);const G=k[ee],B=G[ae%G.length];let se=[`%c[${Z}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${fe}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(fe)?(se=se.concat(re),se.push(")")):se.push(re),console.log.apply(console,se)}class ie{constructor(Q,Y){this._outgoingPrefix=Q,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Q,Y,ae,ee,fe){this._totalOutgoing+=Q,q(this._outgoingPrefix,this._totalOutgoing,Q,Y,ae,ee,fe)}logIncoming(Q,Y,ae,ee,fe){this._totalIncoming+=Q,q(this._incomingPrefix,this._totalIncoming,Q,Y,ae,ee,fe)}}e.IPCLogger=ie}),define(Ce[82],De([1,0,21,4,3,81]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var w;(function(s){s.enableDiagnostics=!1,s.records=[];const c=new WeakMap;let d=0;function m(g,f){if(!c.has(g)){const S=String(++d);c.set(g,S)}return c.get(g)}function D(g,f,S,T){if(!s.enableDiagnostics)return;const N=m(g,f);if(T instanceof P.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const z=P.VSBuffer.alloc(T.byteLength);z.set(T),s.records.push({timestamp:Date.now(),id:N,label:f,type:S,buff:z})}else s.records.push({timestamp:Date.now(),id:N,label:f,type:S,data:T})}s.traceSocketEvent=D})(w||(e.SocketDiagnostics=w={}));var E;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let C=null;function L(){return C||(C=P.VSBuffer.alloc(0)),C}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,d){if(c===0)return L();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const f=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=c),f}if(this._chunks[0].byteLength>c){const f=this._chunks[0].slice(0,c);return d&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),f}const m=P.VSBuffer.alloc(c);let D=0,g=0;for(;c>0;){const f=this._chunks[g];if(f.byteLength>c){const S=f.slice(0,c);m.set(S,D),D+=c,d&&(this._chunks[g]=f.slice(c),this._totalLength-=c),c-=c}else m.set(f,D),D+=f.byteLength,d?(this._chunks.shift(),this._totalLength-=f.byteLength):g++,c-=f.byteLength}return m}}e.ChunkStream=I;var v;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(v||(v={}));function y(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var _;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(_||(e.ProtocolConstants=_={}));class l{constructor(c,d,m,D){this.type=c,this.id=d,this.ack=m,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends p.Disposable{constructor(c){super(),this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const m=this._state.messageType,D=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new l(m,D,g,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class o{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=P.VSBuffer.alloc(13);d.writeUInt8(c.type,0),d.writeUInt32BE(c.id,1),d.writeUInt32BE(c.ack,5),d.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(d,c.data)}_bufferAdd(c,d){const m=this._totalLength===0;return this._data.push(c,d),this._totalLength+=c.byteLength+d.byteLength,m}_bufferTake(){const c=P.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,d){this._bufferAdd(c,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class i extends p.Disposable{constructor(c){super(),this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new o(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new l(1,0,0,c))}}e.Protocol=i;class n extends R.IPCClient{static fromSocket(c,d){return new n(new i(c),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(c,d,m=null){super(c,d,m),this.protocol=c}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=n;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let c=0,d=this._first;for(;d;)d=d.next,c++;return c}peek(){return this._first?this._first.data:null}toArray(){const c=[];let d=0,m=this._first;for(;m;)c[d++]=m.data,m=m.next;return c}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const d=new a(c);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class h{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}constructor(){this.lastRuns=[];const c=Date.now();for(let d=0;d<h._HISTORY_LENGTH;d++)this.lastRuns[d]=c-1e3*d;setInterval(()=>{for(let d=h._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const c=Date.now(),d=(1+h._HISTORY_LENGTH)*1e3;let m=0;for(let D=0;D<h._HISTORY_LENGTH;D++)c-this.lastRuns[D]<=d&&m++;return 1-m/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class u{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(c){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c.loadEstimator??h.getInstance(),this._shouldSendKeepAlive=c.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new p.DisposableStore,this._socket=c.socket,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new b(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.add(this._socket.onClose(d=>this._onSocketClose.fire(d))),c.initialChunk&&this._socketReader.acceptChunk(c.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new l(5,0,0,L());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new l(7,0,0,L());this._socketWriter.write(c)}sendResume(){const c=new l(8,0,0,L());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,d){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new p.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new b(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.add(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new l(3,0,this._incomingAckId,L());this._socketWriter.write(c);const d=this._outgoingUnackMsg.toArray();for(let m=0,D=d.length;m<D;m++)this._socketWriter.write(d[m]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new l(6,0,0,L())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let m=0,D=d.length;m<D;m++)this._socketWriter.write(d[m]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new l(1,d,this._incomingAckId,c);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(c){const d=new l(2,0,0,c);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),d=Date.now()-c.writtenTime,m=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&m>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:m});return}const g=Math.max(2e4-d,2e4-m,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new l(3,0,this._incomingAckId,L());this._socketWriter.write(c)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const c=new l(9,0,this._incomingAckId,L());this._socketWriter.write(c)}}e.PersistentProtocol=u}),define(Ce[188],De([1,0,51,8,21,22,186,14,4,3,24,104,101,81]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class _ extends y.ChannelServer{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",i=>p.VSBuffer.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.Server=_;class l{constructor(o,i){this.modulePath=o,this.options=i,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=i&&i.timeout?i.timeout:6e4;this.disposeDelayer=new F.Delayer(n),this.child=null,this._client=null}getChannel(o){const i=this;return{call(n,r,a){return i.requestPromise(o,n,r,a)},listen(n,r){return i.requestEvent(o,n,r)}}}requestPromise(o,i,n,r=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(o),t=(0,F.createCancelablePromise)(s=>a.call(i,n,s)),h=r.onCancellationRequested(()=>t.cancel()),u=(0,C.toDisposable)(()=>t.cancel());return this.activeRequests.add(u),t.finally(()=>{h.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(o,i,n){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let r;const a=new E.Emitter({onWillAddFirstListener:()=>{r=this.getCachedChannel(o).listen(i,n)(a.fire,a),this.activeRequests.add(r)},onDidRemoveLastListener:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const o=this.options&&this.options.args?this.options.args:[],i=Object.create(null);i.env={...(0,L.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(i.env={...i.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(i.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(i.env),this.child=(0,P.fork)(this.modulePath,o,i);const n=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,A.isRemoteConsoleLog)(c)){(0,A.log)(c,`IPC Library: ${this.options.serverName}`);return}n.fire(p.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),h=n.event,u={send:t,onMessage:h};this._client=new y.ChannelClient(u);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,d)=>{process.removeListener("exit",s),this.activeRequests.forEach(m=>(0,C.dispose)(m)),this.activeRequests.clear(),c!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+d),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:d})})}return this._client}getCachedChannel(o){let i=this.channels.get(o);return i||(i=this.client.getChannel(o),this.channels.set(o,i)),i}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=l}),define(Ce[189],De([1,0,8,4,3,56,18]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var w;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function E(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var C;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(C||(e.StorageState=C={}));class L extends p.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(y,_=Object.create(null)){super(),this.database=y,this.options=_,this._onDidChangeStorage=this._register(new F.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=this._register(new P.ThrottledDelayer(L.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){this._onDidChangeStorage.pause();try{y.changed?.forEach((_,l)=>this.acceptExternal(l,_)),y.deleted?.forEach(_=>this.acceptExternal(_,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(y,_){if(this.state===C.Closed)return;let l=!1;(0,A.isUndefinedOrNull)(_)?l=this.cache.delete(y):this.cache.get(y)!==_&&(this.cache.set(y,_),l=!0),l&&this._onDidChangeStorage.fire({key:y,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,_){const l=this.cache.get(y);return(0,A.isUndefinedOrNull)(l)?_:l}getBoolean(y,_){const l=this.get(y);return(0,A.isUndefinedOrNull)(l)?_:l==="true"}getNumber(y,_){const l=this.get(y);return(0,A.isUndefinedOrNull)(l)?_:parseInt(l,10)}getObject(y,_){const l=this.get(y);return(0,A.isUndefinedOrNull)(l)?_:(0,R.parse)(l)}async set(y,_,l=!1){if(this.state===C.Closed)return;if((0,A.isUndefinedOrNull)(_))return this.delete(y,l);const b=(0,A.isObject)(_)||Array.isArray(_)?(0,R.stringify)(_):String(_);if(this.cache.get(y)!==b)return this.cache.set(y,b),this.pendingInserts.set(y,b),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire({key:y,external:l}),this.doFlush()}async delete(y,_=!1){if(!(this.state===C.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire({key:y,external:_}),this.doFlush()}async optimize(){if(this.state!==C.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(this.hasPending)return this.doFlush(y)}async doFlush(y){return this.options.hint===w.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}isInMemory(){return this.options.hint===w.STORAGE_IN_MEMORY}}e.Storage=L;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((_,l)=>this.items.set(l,_)),y.delete?.forEach(_=>this.items.delete(_))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=I}),define(Ce[190],De([1,0,12,11,21]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=e.decodeUTF16LE=e.getPlatformTextDecoder=void 0;let R;function A(){return R||(R=new TextDecoder("UTF-16LE")),R}let w;function E(){return w||(w=new TextDecoder("UTF-16BE")),w}let C;function L(){return C||(C=F.isLittleEndian()?A():E()),C}e.getPlatformTextDecoder=L;function I(_,l,b){const o=new Uint16Array(_.buffer,l,b);return b>0&&(o[0]===65279||o[0]===65534)?v(_,l,b):A().decode(o)}e.decodeUTF16LE=I;function v(_,l,b){const o=[];let i=0;for(let n=0;n<b;n++){const r=p.readUInt16LE(_,l);l+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class y{constructor(l){this._capacity=l|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const l=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return L().decode(l)}_flushBuffer(){const l=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[l]:this._completedStrings[this._completedStrings.length]=l}appendCharCode(l){const b=this._capacity-this._bufferLength;b<=1&&(b===0||P.isHighSurrogate(l))&&this._flushBuffer(),this._buffer[this._bufferLength++]=l}appendASCIICharCode(l){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=l}appendString(l){const b=l.length;if(this._bufferLength+b>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=l;return}for(let o=0;o<b;o++)this._buffer[this._bufferLength++]=l.charCodeAt(o)}}e.StringBuilder=y}),define(Ce[191],De([1,0,21,190]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressConsecutiveTextChanges=e.TextChange=void 0;function p(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(C,L,I,v){this.oldPosition=C,this.oldText=L,this.newPosition=I,this.newText=v}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${p(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${p(this.oldText)}")`:`(replace@${this.oldPosition} "${p(this.oldText)}" with "${p(this.newText)}")`}static _writeStringSize(C){return 4+2*C.length}static _writeString(C,L,I){const v=L.length;P.writeUInt32BE(C,v,I),I+=4;for(let y=0;y<v;y++)P.writeUInt16LE(C,L.charCodeAt(y),I),I+=2;return I}static _readString(C,L){const I=P.readUInt32BE(C,L);return L+=4,(0,F.decodeUTF16LE)(C,L,I)}writeSize(){return 8+R._writeStringSize(this.oldText)+R._writeStringSize(this.newText)}write(C,L){return P.writeUInt32BE(C,this.oldPosition,L),L+=4,P.writeUInt32BE(C,this.newPosition,L),L+=4,L=R._writeString(C,this.oldText,L),L=R._writeString(C,this.newText,L),L}static read(C,L,I){const v=P.readUInt32BE(C,L);L+=4;const y=P.readUInt32BE(C,L);L+=4;const _=R._readString(C,L);L+=R._writeStringSize(_);const l=R._readString(C,L);return L+=R._writeStringSize(l),I.push(new R(v,_,y,l)),L}}e.TextChange=R;function A(E,C){return E===null||E.length===0?C:new w(E,C).compress()}e.compressConsecutiveTextChanges=A;class w{constructor(C,L){this._prevEdits=C,this._currEdits=L,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let C=0,L=0,I=this._getPrev(C),v=this._getCurr(L);for(;C<this._prevLen||L<this._currLen;){if(I===null){this._acceptCurr(v),v=this._getCurr(++L);continue}if(v===null){this._acceptPrev(I),I=this._getPrev(++C);continue}if(v.oldEnd<=I.newPosition){this._acceptCurr(v),v=this._getCurr(++L);continue}if(I.newEnd<=v.oldPosition){this._acceptPrev(I),I=this._getPrev(++C);continue}if(v.oldPosition<I.newPosition){const[o,i]=w._splitCurr(v,I.newPosition-v.oldPosition);this._acceptCurr(o),v=i;continue}if(I.newPosition<v.oldPosition){const[o,i]=w._splitPrev(I,v.oldPosition-I.newPosition);this._acceptPrev(o),I=i;continue}let l,b;if(v.oldEnd===I.newEnd)l=I,b=v,I=this._getPrev(++C),v=this._getCurr(++L);else if(v.oldEnd<I.newEnd){const[o,i]=w._splitPrev(I,v.oldLength);l=o,b=v,I=i,v=this._getCurr(++L)}else{const[o,i]=w._splitCurr(v,I.newLength);l=I,b=o,I=this._getPrev(++C),v=i}this._result[this._resultLen++]=new R(l.oldPosition,l.oldText,b.newPosition,b.newText),this._prevDeltaOffset+=l.newLength-l.oldLength,this._currDeltaOffset+=b.newLength-b.oldLength}const y=w._merge(this._result);return w._removeNoOps(y)}_acceptCurr(C){this._result[this._resultLen++]=w._rebaseCurr(this._prevDeltaOffset,C),this._currDeltaOffset+=C.newLength-C.oldLength}_getCurr(C){return C<this._currLen?this._currEdits[C]:null}_acceptPrev(C){this._result[this._resultLen++]=w._rebasePrev(this._currDeltaOffset,C),this._prevDeltaOffset+=C.newLength-C.oldLength}_getPrev(C){return C<this._prevLen?this._prevEdits[C]:null}static _rebaseCurr(C,L){return new R(L.oldPosition-C,L.oldText,L.newPosition,L.newText)}static _rebasePrev(C,L){return new R(L.oldPosition,L.oldText,L.newPosition+C,L.newText)}static _splitPrev(C,L){const I=C.newText.substr(0,L),v=C.newText.substr(L);return[new R(C.oldPosition,C.oldText,C.newPosition,I),new R(C.oldEnd,"",C.newPosition+L,v)]}static _splitCurr(C,L){const I=C.oldText.substr(0,L),v=C.oldText.substr(L);return[new R(C.oldPosition,I,C.newPosition,C.newText),new R(C.oldPosition+L,v,C.newEnd,"")]}static _merge(C){if(C.length===0)return C;const L=[];let I=0,v=C[0];for(let y=1;y<C.length;y++){const _=C[y];v.oldEnd===_.oldPosition?v=new R(v.oldPosition,v.oldText+_.oldText,v.newPosition,v.newText+_.newText):(L[I++]=v,v=_)}return L[I++]=v,L}static _removeNoOps(C){if(C.length===0)return C;const L=[];let I=0;for(let v=0;v<C.length;v++){const y=C[v];y.oldText!==y.newText&&(L[I++]=y)}return L}}}),define(Ce[192],De([1,0,35,17]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.targetsNotebooks=e.score=void 0;function p(A,w,E,C,L,I){if(Array.isArray(A)){let v=0;for(const y of A){const _=p(y,w,E,C,L,I);if(_===10)return _;_>v&&(v=_)}return v}else{if(typeof A=="string")return C?A==="*"?5:A===E?10:0:0;if(A){const{language:v,pattern:y,scheme:_,hasAccessToAllModels:l,notebookType:b}=A;if(!C&&!l)return 0;b&&L&&(w=L);let o=0;if(_)if(_===w.scheme)o=10;else if(_==="*")o=5;else return 0;if(v)if(v===E)o=10;else if(v==="*")o=Math.max(o,5);else return 0;if(b)if(b===I)o=10;else if(b==="*"&&I!==void 0)o=Math.max(o,5);else return 0;if(y){let i;if(typeof y=="string"?i=y:i={...y,base:(0,F.normalize)(y.base)},i===w.fsPath||(0,P.match)(i,w.fsPath))o=10;else return 0}return o}else return 0}}e.score=p;function R(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(R):!!A.notebookType}e.targetsNotebooks=R}),define(Ce[193],De([1,0,4,12,29,79,127,168,191,3]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class L extends C.Disposable{constructor(v,y,_,l,b,o,i){super(),this._onDidChangeContent=this._register(new P.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=y,this._mightContainNonBasicASCII=!o,this._mightContainRTL=l,this._mightContainUnusualLineTerminators=b,this._pieceTree=new A.PieceTreeBase(v,_,i)}equals(v){return!(v instanceof L)||this._BOM!==v._BOM||this.getEOL()!==v.getEOL()?!1:this._pieceTree.equal(v._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(v){return this._pieceTree.createSnapshot(v?this._BOM:"")}getOffsetAt(v,y){return this._pieceTree.getOffsetAt(v,y)}getPositionAt(v){return this._pieceTree.getPositionAt(v)}getRangeAt(v,y){const _=v+y,l=this.getPositionAt(v),b=this.getPositionAt(_);return new p.Range(l.lineNumber,l.column,b.lineNumber,b.column)}getValueInRange(v,y=0){if(v.isEmpty())return"";const _=this._getEndOfLine(y);return this._pieceTree.getValueInRange(v,_)}getValueLengthInRange(v,y=0){if(v.isEmpty())return 0;if(v.startLineNumber===v.endLineNumber)return v.endColumn-v.startColumn;const _=this.getOffsetAt(v.startLineNumber,v.startColumn),l=this.getOffsetAt(v.endLineNumber,v.endColumn);let b=0;const o=this._getEndOfLine(y),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=v.endLineNumber-v.startLineNumber;b=n*r}return l-_+b}getCharacterCountInRange(v,y=0){if(this._mightContainNonBasicASCII){let _=0;const l=v.startLineNumber,b=v.endLineNumber;for(let o=l;o<=b;o++){const i=this.getLineContent(o),n=o===l?v.startColumn-1:0,r=o===b?v.endColumn-1:i.length;for(let a=n;a<r;a++)F.isHighSurrogate(i.charCodeAt(a))?(_=_+1,a=a+1):_=_+1}return _+=this._getEndOfLine(y).length*(b-l),_}return this.getValueLengthInRange(v,y)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(v){return this._pieceTree.getLineContent(v)}getLineCharCode(v,y){return this._pieceTree.getLineCharCode(v,y)}getCharCode(v){return this._pieceTree.getCharCode(v)}getLineLength(v){return this._pieceTree.getLineLength(v)}getLineMinColumn(v){return 1}getLineMaxColumn(v){return this.getLineLength(v)+1}getLineFirstNonWhitespaceColumn(v){const y=F.firstNonWhitespaceIndex(this.getLineContent(v));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(v){const y=F.lastNonWhitespaceIndex(this.getLineContent(v));return y===-1?0:y+2}_getEndOfLine(v){switch(v){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(v){this._pieceTree.setEOL(v)}applyEdits(v,y,_){let l=this._mightContainRTL,b=this._mightContainUnusualLineTerminators,o=this._mightContainNonBasicASCII,i=!0,n=[];for(let c=0;c<v.length;c++){const d=v[c];i&&d._isTracked&&(i=!1);const m=d.range;if(d.text){let T=!0;o||(T=!F.isBasicASCII(d.text),o=T),!l&&T&&(l=F.containsRTL(d.text)),!b&&T&&(b=F.containsUnusualLineTerminators(d.text))}let D="",g=0,f=0,S=0;if(d.text){let T;[g,f,S,T]=(0,w.countEOL)(d.text);const N=this.getEOL();T===0||T===(N===`\r
`?2:1)?D=d.text:D=d.text.replace(/\r\n|\r|\n/g,N)}n[c]={sortIndex:c,identifier:d.identifier||null,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m),text:D,eolCount:g,firstLineLength:f,lastLineLength:S,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}n.sort(L._sortOpsAscending);let r=!1;for(let c=0,d=n.length-1;c<d;c++){const m=n[c].range.getEndPosition(),D=n[c+1].range.getStartPosition();if(D.isBeforeOrEqual(m)){if(D.isBefore(m))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this._reduceOperations(n));const a=_||y?L._getInverseEditRanges(n):[],t=[];if(y)for(let c=0;c<n.length;c++){const d=n[c],m=a[c];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let D=m.startLineNumber;D<=m.endLineNumber;D++){let g="";D===m.startLineNumber&&(g=this.getLineContent(d.range.startLineNumber),F.firstNonWhitespaceIndex(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let h=null;if(_){let c=0;h=[];for(let d=0;d<n.length;d++){const m=n[d],D=a[d],g=this.getValueInRange(m.range),f=m.rangeOffset+c;c+=m.text.length-g.length,h[d]={sortIndex:m.sortIndex,identifier:m.identifier,range:D,text:g,textChange:new E.TextChange(m.rangeOffset,g,f,m.text)}}r||h.sort((d,m)=>d.sortIndex-m.sortIndex)}this._mightContainRTL=l,this._mightContainUnusualLineTerminators=b,this._mightContainNonBasicASCII=o;const u=this._doApplyEdits(n);let s=null;if(y&&t.length>0){t.sort((c,d)=>d.lineNumber-c.lineNumber),s=[];for(let c=0,d=t.length;c<d;c++){const m=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===m)continue;const D=t[c].oldContent,g=this.getLineContent(m);g.length===0||g===D||F.firstNonWhitespaceIndex(g)!==-1||s.push(m)}}return this._onDidChangeContent.fire(),new R.ApplyEditsResult(h,u,s)}_reduceOperations(v){return v.length<1e3?v:[this._toSingleEditOperation(v)]}_toSingleEditOperation(v){let y=!1;const _=v[0].range,l=v[v.length-1].range,b=new p.Range(_.startLineNumber,_.startColumn,l.endLineNumber,l.endColumn);let o=_.startLineNumber,i=_.startColumn;const n=[];for(let u=0,s=v.length;u<s;u++){const c=v[u],d=c.range;y=y||c.forceMoveMarkers,n.push(this.getValueInRange(new p.Range(o,i,d.startLineNumber,d.startColumn))),c.text.length>0&&n.push(c.text),o=d.endLineNumber,i=d.endColumn}const r=n.join(""),[a,t,h]=(0,w.countEOL)(r);return{sortIndex:0,identifier:v[0].identifier,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:h,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}_doApplyEdits(v){v.sort(L._sortOpsDescending);const y=[];for(let _=0;_<v.length;_++){const l=v[_],b=l.range.startLineNumber,o=l.range.startColumn,i=l.range.endLineNumber,n=l.range.endColumn;if(b===i&&o===n&&l.text.length===0)continue;l.text?(this._pieceTree.delete(l.rangeOffset,l.rangeLength),this._pieceTree.insert(l.rangeOffset,l.text,!0)):this._pieceTree.delete(l.rangeOffset,l.rangeLength);const r=new p.Range(b,o,i,n);y.push({range:r,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return y}findMatchesLineByLine(v,y,_,l){return this._pieceTree.findMatchesLineByLine(v,y,_,l)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(v,y){const _=v.startLineNumber,l=v.startColumn,[b,o,i]=(0,w.countEOL)(y);let n;if(y.length>0){const r=b+1;r===1?n=new p.Range(_,l,_,l+o):n=new p.Range(_,l,_+r-1,i+1)}else n=new p.Range(_,l,_,l);return n}static _getInverseEditRanges(v){const y=[];let _=0,l=0,b=null;for(let o=0,i=v.length;o<i;o++){const n=v[o];let r,a;b?b.range.endLineNumber===n.range.startLineNumber?(r=_,a=l+(n.range.startColumn-b.range.endColumn)):(r=_+(n.range.startLineNumber-b.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const h=n.eolCount+1;h===1?t=new p.Range(r,a,r,a+n.firstLineLength):t=new p.Range(r,a,r+h-1,n.lastLineLength+1)}else t=new p.Range(r,a,r,a);_=t.endLineNumber,l=t.endColumn,y.push(t),b=n}return y}static _sortOpsAscending(v,y){const _=p.Range.compareRangesUsingEnds(v.range,y.range);return _===0?v.sortIndex-y.sortIndex:_}static _sortOpsDescending(v,y){const _=p.Range.compareRangesUsingEnds(v.range,y.range);return _===0?y.sortIndex-v.sortIndex:-_}}e.PieceTreeTextBuffer=L}),define(Ce[194],De([1,0,12,127,193]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class R{constructor(E,C,L,I,v,y,_,l,b){this._chunks=E,this._bom=C,this._cr=L,this._lf=I,this._crlf=v,this._containsRTL=y,this._containsUnusualLineTerminators=_,this._isBasicASCII=l,this._normalizeEOL=b}_getEOL(E){const C=this._cr+this._lf+this._crlf,L=this._cr+this._crlf;return C===0?E===1?`
`:`\r
`:L>C/2?`\r
`:`
`}create(E){const C=this._getEOL(E),L=this._chunks;if(this._normalizeEOL&&(C===`\r
`&&(this._cr>0||this._lf>0)||C===`
`&&(this._cr>0||this._crlf>0)))for(let v=0,y=L.length;v<y;v++){const _=L[v].buffer.replace(/\r\n|\r|\n/g,C),l=(0,F.createLineStartsFast)(_);L[v]=new F.StringBuffer(_,l)}const I=new p.PieceTreeTextBuffer(L,this._bom,C,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:I,disposable:I}}getFirstLineText(E){return this._chunks[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(E){if(E.length===0)return;this.chunks.length===0&&P.startsWithUTF8BOM(E)&&(this.BOM=P.UTF8_BOM_CHARACTER,E=E.substr(1));const C=E.charCodeAt(E.length-1);C===13||C>=55296&&C<=56319?(this._acceptChunk1(E.substr(0,E.length-1),!1),this._hasPreviousChar=!0,this._previousChar=C):(this._acceptChunk1(E,!1),this._hasPreviousChar=!1,this._previousChar=C)}_acceptChunk1(E,C){!C&&E.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+E):this._acceptChunk2(E))}_acceptChunk2(E){const C=(0,F.createLineStarts)(this._tmpLineStarts,E);this.chunks.push(new F.StringBuffer(E,C.lineStarts)),this.cr+=C.cr,this.lf+=C.lf,this.crlf+=C.crlf,C.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=P.containsRTL(E)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=P.containsUnusualLineTerminators(E)))}finish(E=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,E)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const E=this.chunks[this.chunks.length-1];E.buffer+=String.fromCharCode(this._previousChar);const C=(0,F.createLineStartsFast)(E.buffer);E.lineStarts=C,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=A}),define(Ce[131],De([1,0,21,11]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var p;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(p||(p={}));function R(I){for(let v=0,y=I.length;v<y;v+=4){const _=I[v+0],l=I[v+1],b=I[v+2],o=I[v+3];I[v+0]=o,I[v+1]=b,I[v+2]=l,I[v+3]=_}}function A(I){const v=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.isLittleEndian()||R(v),P.VSBuffer.wrap(v)}function w(I){const v=I.buffer;if(F.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const y=new Uint8Array(v.byteLength);return y.set(v),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(I){const v=new Uint32Array(C(I));let y=0;if(v[y++]=I.id,I.type==="full")v[y++]=1,v[y++]=I.data.length,v.set(I.data,y),y+=I.data.length;else{v[y++]=2,v[y++]=I.deltas.length;for(const _ of I.deltas)v[y++]=_.start,v[y++]=_.deleteCount,_.data?(v[y++]=_.data.length,v.set(_.data,y),y+=_.data.length):v[y++]=0}return A(v)}e.encodeSemanticTokensDto=E;function C(I){let v=0;if(v+=2,I.type==="full")v+=1+I.data.length;else{v+=1,v+=3*I.deltas.length;for(const y of I.deltas)y.data&&(v+=y.data.length)}return v}function L(I){const v=w(I);let y=0;const _=v[y++];if(v[y++]===1){const i=v[y++],n=v.subarray(y,y+i);return y+=i,{id:_,type:"full",data:n}}const b=v[y++],o=[];for(let i=0;i<b;i++){const n=v[y++],r=v[y++],a=v[y++];let t;a>0&&(t=v.subarray(y,y+a),y+=a),o[i]={start:n,deleteCount:r,data:t}}return{id:_,type:"delta",deltas:o}}e.decodeSemanticTokensDto=L}),define(Ce[195],De([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Ce[132],De([1,0,19,24,11,171,126,195]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=C;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(oe,Ie,qe,Je){this.id=oe,this.name=Ie,this.defaultValue=qe,this.schema=Je}applyUpdate(oe,Ie){return y(oe,Ie)}compute(oe,Ie,qe){return qe}}class v{constructor(oe,Ie){this.newValue=oe,this.didChange=Ie}}e.ApplyUpdateResult=v;function y(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new v(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const qe=Array.isArray(ne)&&Array.isArray(oe)&&P.equals(ne,oe);return new v(oe,!qe)}let Ie=!1;for(const qe in oe)if(oe.hasOwnProperty(qe)){const Je=y(ne[qe],oe[qe]);Je.didChange&&(ne[qe]=Je.newValue,Ie=!0)}return new v(ne,Ie)}class _{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ie){return y(oe,Ie)}validate(oe){return this.defaultValue}}class l{constructor(oe,Ie,qe,Je){this.id=oe,this.name=Ie,this.defaultValue=qe,this.schema=Je}applyUpdate(oe,Ie){return y(oe,Ie)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ie,qe){return qe}}function b(ne,oe){return typeof ne>"u"?oe:ne==="false"?!1:!!ne}e.boolean=b;class o extends l{constructor(oe,Ie,qe,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=qe),super(oe,Ie,qe,Je)}validate(oe){return b(oe,this.defaultValue)}}function i(ne,oe,Ie,qe){if(typeof ne>"u")return oe;let Je=parseInt(ne,10);return isNaN(Je)?oe:(Je=Math.max(Ie,Je),Je=Math.min(qe,Je),Je|0)}e.clampedInt=i;class n extends l{static clampedInt(oe,Ie,qe,Je){return i(oe,Ie,qe,Je)}constructor(oe,Ie,qe,Je,nt,Ne=void 0){typeof Ne<"u"&&(Ne.type="integer",Ne.default=qe,Ne.minimum=Je,Ne.maximum=nt),super(oe,Ie,qe,Ne),this.minimum=Je,this.maximum=nt}validate(oe){return n.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function r(ne,oe,Ie,qe){if(typeof ne>"u")return oe;const Je=a.float(ne,oe);return a.clamp(Je,Ie,qe)}e.clampedFloat=r;class a extends l{static clamp(oe,Ie,qe){return oe<Ie?Ie:oe>qe?qe:oe}static float(oe,Ie){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ie;const qe=parseFloat(oe);return isNaN(qe)?Ie:qe}constructor(oe,Ie,qe,Je,nt){typeof nt<"u"&&(nt.type="number",nt.default=qe),super(oe,Ie,qe,nt),this.validationFn=Je}validate(oe){return this.validationFn(a.float(oe,this.defaultValue))}}class t extends l{static string(oe,Ie){return typeof oe!="string"?Ie:oe}constructor(oe,Ie,qe,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=qe),super(oe,Ie,qe,Je)}validate(oe){return t.string(oe,this.defaultValue)}}function h(ne,oe,Ie,qe){return typeof ne!="string"?oe:qe&&ne in qe?qe[ne]:Ie.indexOf(ne)===-1?oe:ne}e.stringSet=h;class u extends l{constructor(oe,Ie,qe,Je,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Je,nt.default=qe),super(oe,Ie,qe,nt),this._allowedValues=Je}validate(oe){return h(oe,this.defaultValue,this._allowedValues)}}class s extends I{constructor(oe,Ie,qe,Je,nt,Ne,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=nt,vt.default=Je),super(oe,Ie,qe,vt),this._allowedValues=nt,this._convert=Ne}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function c(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ie,qe){return qe===0?oe.accessibilitySupport:qe}}class m extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:w.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertSpace:b(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function S(ne){switch(ne){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function T(ne){switch(ne){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class N extends _{constructor(){super(141)}compute(oe,Ie,qe){const Je=["monaco-editor"];return Ie.get(39)&&Je.push(Ie.get(39)),oe.extraEditorClassName&&Je.push(oe.extraEditorClassName),Ie.get(74)==="default"?Je.push("mouse-default"):Ie.get(74)==="copy"&&Je.push("mouse-copy"),Ie.get(111)&&Je.push("showUnused"),Ie.get(139)&&Je.push("showDeprecated"),Je.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(oe,Ie,qe){return qe&&oe.emptySelectionClipboard}}class x extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:w.localize(16,null),included:p.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:w.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{cursorMoveOnType:b(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":h(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":h(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ie.loop,this.defaultValue.loop)}}}class M extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"||oe.length===0?M.OFF:oe==="true"?M.ON:oe:oe?M.ON:M.OFF}}e.EditorFontLigatures=M;class k extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",k.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?k.OFF:oe==="true"?k.TRANSLATE:oe:oe?k.TRANSLATE:k.OFF}compute(oe,Ie,qe){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=k;class O extends _{constructor(){super(50)}compute(oe,Ie,qe){return oe.fontInfo}}class U extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(oe){const Ie=a.float(oe,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(oe,Ie,qe){return oe.fontInfo.fontSize}}class q extends I{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(n.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}class ie extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:qe,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:qe,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:qe,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:qe,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:qe,description:w.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{multiple:h(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??h(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??h(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??h(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??h(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??h(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends I{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:w.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:b(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:b(Ie.above,this.defaultValue.above)}}}var Q;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Y extends _{constructor(){super(144)}compute(oe,Ie,qe){return Y.computeLayout(Ie,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ie=oe.height/oe.lineHeight,qe=Math.floor(oe.paddingTop/oe.lineHeight);let Je=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(Je=Math.max(Je,Ie-1));const nt=(qe+oe.viewLineCount+Je)/(oe.pixelRatio*oe.height),Ne=Math.floor(oe.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Je,desiredRatio:nt,minimapLineCount:Ne}}static _computeMinimapLayout(oe,Ie){const qe=oe.outerWidth,Je=oe.outerHeight,nt=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const Ne=Ie.stableMinimapLayoutInput,vt=Ne&&oe.outerHeight===Ne.outerHeight&&oe.lineHeight===Ne.lineHeight&&oe.typicalHalfwidthCharacterWidth===Ne.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Ne.pixelRatio&&oe.scrollBeyondLastLine===Ne.scrollBeyondLastLine&&oe.paddingTop===Ne.paddingTop&&oe.paddingBottom===Ne.paddingBottom&&oe.minimap.enabled===Ne.minimap.enabled&&oe.minimap.side===Ne.minimap.side&&oe.minimap.size===Ne.minimap.size&&oe.minimap.showSlider===Ne.minimap.showSlider&&oe.minimap.renderCharacters===Ne.minimap.renderCharacters&&oe.minimap.maxColumn===Ne.minimap.maxColumn&&oe.minimap.scale===Ne.minimap.scale&&oe.verticalScrollbarWidth===Ne.verticalScrollbarWidth&&oe.isViewportWrapping===Ne.isViewportWrapping,yt=oe.lineHeight,kt=oe.typicalHalfwidthCharacterWidth,Mt=oe.scrollBeyondLastLine,Qt=oe.minimap.renderCharacters;let Pt=nt>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const qt=oe.minimap.maxColumn,Gt=oe.minimap.size,Jt=oe.minimap.side,ii=oe.verticalScrollbarWidth,et=oe.viewLineCount,xt=oe.remainingWidth,Zt=oe.isViewportWrapping,ft=Qt?2:3;let Et=Math.floor(nt*Je);const ei=Et/nt;let $t=!1,zt=!1,ht=ft*Pt,Rt=Pt/nt,ti=1;if(Gt==="fill"||Gt==="fit"){const{typicalViewportLineCount:Nt,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Wt,desiredRatio:ri,minimapLineCount:Ut}=Y.computeContainedMinimapLineCount({viewLineCount:et,scrollBeyondLastLine:Mt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:Je,lineHeight:yt,pixelRatio:nt});if(et/Ut>1)$t=!0,zt=!0,Pt=1,ht=1,Rt=Pt/nt;else{let At=!1,Dt=Pt+1;if(Gt==="fit"){const pt=Math.ceil((Tt+et+Wt)*ht);Zt&&vt&&xt<=Ie.stableFitRemainingWidth?(At=!0,Dt=Ie.stableFitMaxMinimapScale):At=pt>Et}if(Gt==="fill"||At){$t=!0;const pt=Pt;ht=Math.min(yt*nt,Math.max(1,Math.floor(1/ri))),Zt&&vt&&xt<=Ie.stableFitRemainingWidth&&(Dt=Ie.stableFitMaxMinimapScale),Pt=Math.min(Dt,Math.max(1,Math.floor(ht/ft))),Pt>pt&&(ti=Math.min(2,Pt/pt)),Rt=Pt/nt/ti,Et=Math.ceil(Math.max(Nt,Tt+et+Wt)*ht),Zt?(Ie.stableMinimapLayoutInput=oe,Ie.stableFitRemainingWidth=xt,Ie.stableFitMaxMinimapScale=Pt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Yt=Math.floor(qt*Rt),Xe=Math.min(Yt,Math.max(0,Math.floor((xt-ii-2)*Rt/(kt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(nt*Xe);const Bt=Ft/nt;Ft=Math.floor(Ft*ti);const ni=Qt?1:2,mt=Jt==="left"?0:qe-Xe-ii;return{renderMinimap:ni,minimapLeft:mt,minimapWidth:Xe,minimapHeightIsEditorHeight:$t,minimapIsSampling:zt,minimapScale:Pt,minimapLineHeight:ht,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:Et,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ei}}static computeLayout(oe,Ie){const qe=Ie.outerWidth|0,Je=Ie.outerHeight|0,nt=Ie.lineHeight|0,Ne=Ie.lineNumbersDigitCount|0,vt=Ie.typicalHalfwidthCharacterWidth,yt=Ie.maxDigitWidth,kt=Ie.pixelRatio,Mt=Ie.viewLineCount,Qt=oe.get(136),Pt=Qt==="inherit"?oe.get(135):Qt,qt=Pt==="inherit"?oe.get(131):Pt,Gt=oe.get(134),Jt=Ie.isDominatedByLongLines,ii=oe.get(57),et=oe.get(68).renderType!==0,xt=oe.get(69),Zt=oe.get(105),ft=oe.get(84),Et=oe.get(73),ei=oe.get(103),$t=ei.verticalScrollbarSize,zt=ei.verticalHasArrows,ht=ei.arrowSize,Rt=ei.horizontalScrollbarSize,ti=oe.get(43),Yt=oe.get(110)!=="never";let Xe=oe.get(66);ti&&Yt&&(Xe+=16);let Ft=0;if(et){const St=Math.max(Ne,xt);Ft=Math.round(St*yt)}let Bt=0;ii&&(Bt=nt*Ie.glyphMarginDecorationLaneCount);let ni=0,mt=ni+Bt,Nt=mt+Ft,Tt=Nt+Xe;const Wt=qe-Bt-Ft-Xe;let ri=!1,Ut=!1,Ht=-1;Pt==="inherit"&&Jt?(ri=!0,Ut=!0):qt==="on"||qt==="bounded"?Ut=!0:qt==="wordWrapColumn"&&(Ht=Gt);const At=Y._computeMinimapLayout({outerWidth:qe,outerHeight:Je,lineHeight:nt,typicalHalfwidthCharacterWidth:vt,pixelRatio:kt,scrollBeyondLastLine:Zt,paddingTop:ft.top,paddingBottom:ft.bottom,minimap:Et,verticalScrollbarWidth:$t,viewLineCount:Mt,remainingWidth:Wt,isViewportWrapping:Ut},Ie.memory||new L);At.renderMinimap!==0&&At.minimapLeft===0&&(ni+=At.minimapWidth,mt+=At.minimapWidth,Nt+=At.minimapWidth,Tt+=At.minimapWidth);const Dt=Wt-At.minimapWidth,pt=Math.max(1,Math.floor((Dt-$t-2)/vt)),It=zt?ht:0;return Ut&&(Ht=Math.max(1,pt),qt==="bounded"&&(Ht=Math.min(Ht,Gt))),{width:qe,height:Je,glyphMarginLeft:ni,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Ft,decorationsLeft:Nt,decorationsWidth:Xe,contentLeft:Tt,contentWidth:Dt,minimap:At,viewportColumn:pt,isWordWrapMinified:ri,isViewportWrapping:Ut,wrappingColumn:Ht,verticalScrollbarWidth:$t,horizontalScrollbarHeight:Rt,overviewRuler:{top:It,width:$t,height:Je-2*It,right:0}}}}e.EditorLayoutInfoComputer=Y;class ae extends I{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(oe){return h(oe,"simple",["simple","advanced"])}compute(oe,Ie,qe){return Ie.get(2)===2?"advanced":qe}}var ee;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class fe extends I{constructor(){const oe={enabled:ee.OnCode};super(65,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ee.Off,ee.OnCode,ee.On],default:oe.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:h(oe.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class re extends I{constructor(){const oe={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:w.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:b(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class G extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,p.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,p.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:w.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:h(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:b(Ie.padding,this.defaultValue.padding)}}}class B extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):n.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ie,qe){return qe<0?n.clampedInt(-qe*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class se extends a{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>a.clamp(oe,0,150),{markdownDescription:w.localize(66,null)})}compute(oe,Ie,qe){return oe.fontInfo.lineHeight}}class ye extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:oe.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:w.localize(77,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),autohide:b(Ie.autohide,this.defaultValue.autohide),size:h(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Ie.side,this.defaultValue.side,["right","left"]),showSlider:h(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(ne){return ne==="ctrlCmd"?p.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(79,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class ce extends I{constructor(){const oe={enabled:!0,cycle:!0};super(86,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:w.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:w.localize(81,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),cycle:b(Ie.cycle,this.defaultValue.cycle)}}}class he extends _{constructor(){super(142)}compute(oe,Ie,qe){return oe.pixelRatio}}class V extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(82,null),w.localize(83,null),w.localize(84,null)]}];super(89,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:oe.strings,description:w.localize(85,null)},comments:{anyOf:Ie,default:oe.comments,description:w.localize(86,null)},other:{anyOf:Ie,default:oe.other,description:w.localize(87,null)}},default:oe,markdownDescription:w.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const kt=oe?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:Je}=oe,nt=["on","inline","off"];let Ne,vt,yt;return typeof Ie=="boolean"?Ne=Ie?"on":"off":Ne=h(Ie,this.defaultValue.other,nt),typeof qe=="boolean"?vt=qe?"on":"off":vt=h(qe,this.defaultValue.comments,nt),typeof Je=="boolean"?yt=Je?"on":"off":yt=h(Je,this.defaultValue.strings,nt),{other:Ne,comments:vt,strings:yt}}}var J;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(J||(e.RenderLineNumbersType=J={}));class ue extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(89,null),w.localize(90,null),w.localize(91,null),w.localize(92,null)],default:"on",description:w.localize(93,null)})}validate(oe){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ie=4,qe=oe):oe==="interval"?Ie=3:oe==="relative"?Ie=2:oe==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function ve(ne){const oe=ne.get(98);return oe==="editable"?ne.get(91):oe!=="on"}e.filterValidationDecorations=ve;class ke extends I{constructor(){const oe=[],Ie={type:"number",description:w.localize(94,null)};super(102,"rulers",oe,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:w.localize(95,null),format:"color-hex"}}}]},default:oe,description:w.localize(96,null)})}validate(oe){if(Array.isArray(oe)){const Ie=[];for(const qe of oe)if(typeof qe=="number")Ie.push({column:n.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Je=qe;Ie.push({column:n.clampedInt(Je.column,0,0,1e4),color:Je.color})}return Ie.sort((qe,Je)=>qe.column-Je.column),Ie}return this.defaultValue}}class we extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Te(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Oe extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(97,null),w.localize(98,null),w.localize(99,null)],default:"auto",description:w.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(101,null),w.localize(102,null),w.localize(103,null)],default:"auto",description:w.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:w.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:w.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:w.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:oe.ignoreHorizontalScrollbarInContentHeight,description:w.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe,qe=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Te(Ie.vertical,this.defaultValue.vertical),horizontal:Te(Ie.horizontal,this.defaultValue.horizontal),useShadows:b(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Je,0,1e3),scrollByPage:b(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:b(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class xe extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:w.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:w.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:w.localize(115,null)}})}applyUpdate(oe,Ie){let qe=!1;Ie.allowedCharacters&&oe&&(F.equals(oe.allowedCharacters,Ie.allowedCharacters)||(oe={...oe,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&oe&&(F.equals(oe.allowedLocales,Ie.allowedLocales)||(oe={...oe,allowedLocales:Ie.allowedLocales},qe=!0));const Je=super.applyUpdate(oe,Ie);return qe?new v(Je.newValue,!0):Je}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{nonBasicASCII:pe(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:pe(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:pe(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,Ie){if(typeof oe!="object"||!oe)return Ie;const qe={};for(const[Je,nt]of Object.entries(oe))nt===!0&&(qe[Je]=!0);return qe}}class W extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:w.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(117,null),w.localize(118,null),w.localize(119,null)],description:w.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:w.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:oe.fontFamily,description:w.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),mode:h(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:b(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:b(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class H extends I{constructor(){const oe={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",oe,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:oe.enabled,description:w.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(124,null),w.localize(125,null),w.localize(126,null)],description:w.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:oe.fontFamily,description:w.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:oe.backgroundColoring,description:w.localize(129,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),showToolbar:h(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:b(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:b(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends I{constructor(){const oe={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:w.localize(131,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null)],default:oe.bracketPairs,description:w.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(136,null),w.localize(137,null),w.localize(138,null)],default:oe.bracketPairsHorizontal,description:w.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:w.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:w.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(142,null),w.localize(143,null),w.localize(144,null)],default:oe.highlightActiveIndentation,description:w.localize(145,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{bracketPairs:pe(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:pe(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:pe(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function pe(ne,oe,Ie){const qe=Ie.indexOf(ne);return qe===-1?oe:Ie[qe]}class Ee extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(146,null),w.localize(147,null)],default:oe.insertMode,description:w.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:w.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:w.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:w.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(152,null),w.localize(153,null),w.localize(154,null),w.localize(155,null)],default:oe.selectionMode,markdownDescription:w.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:w.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:w.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:w.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:w.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:w.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertMode:h(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:b(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:b(Ie.preview,this.defaultValue.preview),previewMode:h(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ie.showMethods,this.defaultValue.showMethods),showFunctions:b(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(Ie.showFields,this.defaultValue.showFields),showVariables:b(Ie.showVariables,this.defaultValue.showVariables),showClasses:b(Ie.showClasses,this.defaultValue.showClasses),showStructs:b(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ie.showModules,this.defaultValue.showModules),showProperties:b(Ie.showProperties,this.defaultValue.showProperties),showEvents:b(Ie.showEvents,this.defaultValue.showEvents),showOperators:b(Ie.showOperators,this.defaultValue.showOperators),showUnits:b(Ie.showUnits,this.defaultValue.showUnits),showValues:b(Ie.showValues,this.defaultValue.showValues),showConstants:b(Ie.showConstants,this.defaultValue.showConstants),showEnums:b(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ie.showKeywords,this.defaultValue.showKeywords),showWords:b(Ie.showWords,this.defaultValue.showWords),showColors:b(Ie.showColors,this.defaultValue.showColors),showFiles:b(Ie.showFiles,this.defaultValue.showFiles),showReferences:b(Ie.showReferences,this.defaultValue.showReferences),showFolders:b(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ie.showUsers,this.defaultValue.showUsers),showIssues:b(Ie.showIssues,this.defaultValue.showIssues)}}}class Me extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(195,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:b(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Ke extends I{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(196,null),w.localize(197,null),w.localize(198,null),w.localize(199,null)],description:w.localize(200,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ie,qe){return Ie.get(2)===2?0:qe}}class tt extends _{constructor(){super(145)}compute(oe,Ie,qe){const Je=Ie.get(144);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class st extends I{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(203,null),w.localize(204,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),showDropSelector:h(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends I{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(207,null),w.localize(208,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:b(Ie.enabled,this.defaultValue.enabled),showPasteSelector:h(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:p.isMacintosh?Pe:p.isLinux?ze:rt,fontWeight:"normal",fontSize:p.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var je;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSeparators=130]="wordSeparators",ne[ne.wordWrap=131]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=134]="wordWrapColumn",ne[ne.wordWrapOverride1=135]="wordWrapOverride1",ne[ne.wordWrapOverride2=136]="wordWrapOverride2",ne[ne.wrappingIndent=137]="wrappingIndent",ne[ne.wrappingStrategy=138]="wrappingStrategy",ne[ne.showDeprecated=139]="showDeprecated",ne[ne.inlayHints=140]="inlayHints",ne[ne.editorClassName=141]="editorClassName",ne[ne.pixelRatio=142]="pixelRatio",ne[ne.tabFocusMode=143]="tabFocusMode",ne[ne.layoutInfo=144]="layoutInfo",ne[ne.wrappingInfo=145]="wrappingInfo",ne[ne.defaultColorDecorators=146]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(209,null)})),acceptSuggestionOnEnter:Ae(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(210,null),""],markdownDescription:w.localize(211,null)})),accessibilitySupport:Ae(new d),accessibilityPageSize:Ae(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(212,null),tags:["accessibility"]})),ariaLabel:Ae(new t(4,"ariaLabel",w.localize(213,null))),ariaRequired:Ae(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(215,null),w.localize(216,null),""],description:w.localize(217,null)})),autoClosingComments:Ae(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(218,null),w.localize(219,null),""],description:w.localize(220,null)})),autoClosingDelete:Ae(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(221,null),""],description:w.localize(222,null)})),autoClosingOvertype:Ae(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(223,null),""],description:w.localize(224,null)})),autoClosingQuotes:Ae(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(225,null),w.localize(226,null),""],description:w.localize(227,null)})),autoIndent:Ae(new s(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[w.localize(228,null),w.localize(229,null),w.localize(230,null),w.localize(231,null),w.localize(232,null)],description:w.localize(233,null)})),automaticLayout:Ae(new o(13,"automaticLayout",!1)),autoSurround:Ae(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(234,null),w.localize(235,null),w.localize(236,null),""],description:w.localize(237,null)})),bracketPairColorization:Ae(new X),bracketPairGuides:Ae(new K),stickyTabStops:Ae(new o(116,"stickyTabStops",!1,{description:w.localize(238,null)})),codeLens:Ae(new o(17,"codeLens",!0,{description:w.localize(239,null)})),codeLensFontFamily:Ae(new t(18,"codeLensFontFamily","",{description:w.localize(240,null)})),codeLensFontSize:Ae(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(241,null)})),colorDecorators:Ae(new o(20,"colorDecorators",!0,{description:w.localize(242,null)})),colorDecoratorActivatedOn:Ae(new u(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(243,null),w.localize(244,null),w.localize(245,null)],description:w.localize(246,null)})),colorDecoratorsLimit:Ae(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(247,null)})),columnSelection:Ae(new o(22,"columnSelection",!1,{description:w.localize(248,null)})),comments:Ae(new m),contextmenu:Ae(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new o(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(249,null)})),cursorBlinking:Ae(new s(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:w.localize(250,null)})),cursorSmoothCaretAnimation:Ae(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(251,null),w.localize(252,null),w.localize(253,null)],description:w.localize(254,null)})),cursorStyle:Ae(new s(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:w.localize(255,null)})),cursorSurroundingLines:Ae(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(256,null)})),cursorSurroundingLinesStyle:Ae(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(257,null),w.localize(258,null)],markdownDescription:w.localize(259,null)})),cursorWidth:Ae(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(260,null)})),disableLayerHinting:Ae(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new o(34,"domReadOnly",!1)),dragAndDrop:Ae(new o(35,"dragAndDrop",!0,{description:w.localize(261,null)})),emptySelectionClipboard:Ae(new z),dropIntoEditor:Ae(new st),stickyScroll:Ae(new re),experimentalWhitespaceRendering:Ae(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(262,null),w.localize(263,null),w.localize(264,null)],description:w.localize(265,null)})),extraEditorClassName:Ae(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ae(new a(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:w.localize(266,null)})),find:Ae(new x),fixedOverflowWidgets:Ae(new o(42,"fixedOverflowWidgets",!1)),folding:Ae(new o(43,"folding",!0,{description:w.localize(267,null)})),foldingStrategy:Ae(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),foldingHighlight:Ae(new o(45,"foldingHighlight",!0,{description:w.localize(271,null)})),foldingImportsByDefault:Ae(new o(46,"foldingImportsByDefault",!1,{description:w.localize(272,null)})),foldingMaximumRegions:Ae(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(273,null)})),unfoldOnClickAfterEndOfLine:Ae(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(274,null)})),fontFamily:Ae(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(275,null)})),fontInfo:Ae(new O),fontLigatures2:Ae(new M),fontSize:Ae(new U),fontWeight:Ae(new q),fontVariations:Ae(new k),formatOnPaste:Ae(new o(55,"formatOnPaste",!1,{description:w.localize(276,null)})),formatOnType:Ae(new o(56,"formatOnType",!1,{description:w.localize(277,null)})),glyphMargin:Ae(new o(57,"glyphMargin",!0,{description:w.localize(278,null)})),gotoLocation:Ae(new ie),hideCursorInOverviewRuler:Ae(new o(59,"hideCursorInOverviewRuler",!1,{description:w.localize(279,null)})),hover:Ae(new Z),inDiffEditor:Ae(new o(61,"inDiffEditor",!1)),letterSpacing:Ae(new a(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>a.clamp(ne,-5,20),{description:w.localize(280,null)})),lightbulb:Ae(new fe),lineDecorationsWidth:Ae(new B),lineHeight:Ae(new se),lineNumbers:Ae(new ue),lineNumbersMinChars:Ae(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new o(70,"linkedEditing",!1,{description:w.localize(281,null)})),links:Ae(new o(71,"links",!0,{description:w.localize(282,null)})),matchBrackets:Ae(new u(72,"matchBrackets","always",["always","near","never"],{description:w.localize(283,null)})),minimap:Ae(new ye),mouseStyle:Ae(new u(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new a(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:w.localize(284,null)})),mouseWheelZoom:Ae(new o(76,"mouseWheelZoom",!1,{markdownDescription:p.isMacintosh?w.localize(285,null):w.localize(286,null)})),multiCursorMergeOverlapping:Ae(new o(77,"multiCursorMergeOverlapping",!0,{description:w.localize(287,null)})),multiCursorModifier:Ae(new s(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[w.localize(288,null),w.localize(289,null)],markdownDescription:w.localize(290,null)})),multiCursorPaste:Ae(new u(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(291,null),w.localize(292,null)],markdownDescription:w.localize(293,null)})),multiCursorLimit:Ae(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(294,null)})),occurrencesHighlight:Ae(new u(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(295,null),w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),overviewRulerBorder:Ae(new o(82,"overviewRulerBorder",!0,{description:w.localize(299,null)})),overviewRulerLanes:Ae(new n(83,"overviewRulerLanes",3,0,3)),padding:Ae(new de),pasteAs:Ae(new lt),parameterHints:Ae(new ce),peekWidgetDefaultFocus:Ae(new u(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(300,null),w.localize(301,null)],description:w.localize(302,null)})),definitionLinkOpensInPeek:Ae(new o(88,"definitionLinkOpensInPeek",!1,{description:w.localize(303,null)})),quickSuggestions:Ae(new V),quickSuggestionsDelay:Ae(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(304,null)})),readOnly:Ae(new o(91,"readOnly",!1)),readOnlyMessage:Ae(new we),renameOnType:Ae(new o(93,"renameOnType",!1,{description:w.localize(305,null),markdownDeprecationMessage:w.localize(306,null)})),renderControlCharacters:Ae(new o(94,"renderControlCharacters",!0,{description:w.localize(307,null),restricted:!0})),renderFinalNewline:Ae(new u(95,"renderFinalNewline",p.isLinux?"dimmed":"on",["off","on","dimmed"],{description:w.localize(308,null)})),renderLineHighlight:Ae(new u(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(309,null)],description:w.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Ae(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(311,null)})),renderValidationDecorations:Ae(new u(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new u(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(312,null),w.localize(313,null),w.localize(314,null),""],description:w.localize(315,null)})),revealHorizontalRightPadding:Ae(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new o(101,"roundedSelection",!0,{description:w.localize(316,null)})),rulers:Ae(new ke),scrollbar:Ae(new Oe),scrollBeyondLastColumn:Ae(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(317,null)})),scrollBeyondLastLine:Ae(new o(105,"scrollBeyondLastLine",!0,{description:w.localize(318,null)})),scrollPredominantAxis:Ae(new o(106,"scrollPredominantAxis",!0,{description:w.localize(319,null)})),selectionClipboard:Ae(new o(107,"selectionClipboard",!0,{description:w.localize(320,null),included:p.isLinux})),selectionHighlight:Ae(new o(108,"selectionHighlight",!0,{description:w.localize(321,null)})),selectOnLineNumbers:Ae(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new u(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(322,null),w.localize(323,null),w.localize(324,null)],description:w.localize(325,null)})),showUnused:Ae(new o(111,"showUnused",!0,{description:w.localize(326,null)})),showDeprecated:Ae(new o(139,"showDeprecated",!0,{description:w.localize(327,null)})),inlayHints:Ae(new G),snippetSuggestions:Ae(new u(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(328,null),w.localize(329,null),w.localize(330,null),w.localize(331,null)],description:w.localize(332,null)})),smartSelect:Ae(new Me),smoothScrolling:Ae(new o(114,"smoothScrolling",!1,{description:w.localize(333,null)})),stopRenderingLineAfter:Ae(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new Ee),inlineSuggest:Ae(new W),inlineEdit:Ae(new H),inlineCompletionsAccessibilityVerbose:Ae(new o(148,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(334,null)})),suggestFontSize:Ae(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new o(121,"suggestOnTriggerCharacters",!0,{description:w.localize(337,null)})),suggestSelection:Ae(new u(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(338,null),w.localize(339,null),w.localize(340,null)],description:w.localize(341,null)})),tabCompletion:Ae(new u(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(342,null),w.localize(343,null),w.localize(344,null)],description:w.localize(345,null)})),tabIndex:Ae(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new xe),unusualLineTerminators:Ae(new u(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(346,null),w.localize(347,null),w.localize(348,null)],description:w.localize(349,null)})),useShadowDOM:Ae(new o(127,"useShadowDOM",!0)),useTabStops:Ae(new o(128,"useTabStops",!0,{description:w.localize(350,null)})),wordBreak:Ae(new u(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(351,null),w.localize(352,null)],description:w.localize(353,null)})),wordSeparators:Ae(new t(130,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:w.localize(354,null)})),wordWrap:Ae(new u(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(355,null),w.localize(356,null),w.localize(357,null),w.localize(358,null)],description:w.localize(359,null)})),wordWrapBreakAfterCharacters:Ae(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(360,null)})),wordWrapOverride1:Ae(new u(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new u(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new N),defaultColorDecorators:Ae(new o(146,"defaultColorDecorators",!1,{markdownDescription:w.localize(361,null)})),pixelRatio:Ae(new he),tabFocusMode:Ae(new o(143,"tabFocusMode",!1,{markdownDescription:w.localize(362,null)})),layoutInfo:Ae(new Y),wrappingInfo:Ae(new tt),wrappingIndent:Ae(new Ke),wrappingStrategy:Ae(new ae)}}),define(Ce[196],De([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Ce[83],De([1,0,78,2,169,29,179,196]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class E{constructor(O,U,q){this.offset=O,this.type=U,this.language=q,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=E;class C{constructor(O,U){this.tokens=O,this.endState=U,this._tokenizationResultBrand=void 0}}e.TokenizationResult=C;class L{constructor(O,U){this.tokens=O,this.endState=U,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=L;var I;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var v;(function(k){const O=new Map;O.set(0,P.Codicon.symbolMethod),O.set(1,P.Codicon.symbolFunction),O.set(2,P.Codicon.symbolConstructor),O.set(3,P.Codicon.symbolField),O.set(4,P.Codicon.symbolVariable),O.set(5,P.Codicon.symbolClass),O.set(6,P.Codicon.symbolStruct),O.set(7,P.Codicon.symbolInterface),O.set(8,P.Codicon.symbolModule),O.set(9,P.Codicon.symbolProperty),O.set(10,P.Codicon.symbolEvent),O.set(11,P.Codicon.symbolOperator),O.set(12,P.Codicon.symbolUnit),O.set(13,P.Codicon.symbolValue),O.set(15,P.Codicon.symbolEnum),O.set(14,P.Codicon.symbolConstant),O.set(15,P.Codicon.symbolEnum),O.set(16,P.Codicon.symbolEnumMember),O.set(17,P.Codicon.symbolKeyword),O.set(27,P.Codicon.symbolSnippet),O.set(18,P.Codicon.symbolText),O.set(19,P.Codicon.symbolColor),O.set(20,P.Codicon.symbolFile),O.set(21,P.Codicon.symbolReference),O.set(22,P.Codicon.symbolCustomColor),O.set(23,P.Codicon.symbolFolder),O.set(24,P.Codicon.symbolTypeParameter),O.set(25,P.Codicon.account),O.set(26,P.Codicon.issues);function U(Z){let Q=O.get(Z);return Q||(console.info("No codicon found for CompletionItemKind "+Z),Q=P.Codicon.symbolProperty),Q}k.toIcon=U;const q=new Map;q.set("method",0),q.set("function",1),q.set("constructor",2),q.set("field",3),q.set("variable",4),q.set("class",5),q.set("struct",6),q.set("interface",7),q.set("module",8),q.set("property",9),q.set("event",10),q.set("operator",11),q.set("unit",12),q.set("value",13),q.set("constant",14),q.set("enum",15),q.set("enum-member",16),q.set("enumMember",16),q.set("keyword",17),q.set("snippet",27),q.set("text",18),q.set("color",19),q.set("file",20),q.set("reference",21),q.set("customcolor",22),q.set("folder",23),q.set("type-parameter",24),q.set("typeParameter",24),q.set("account",25),q.set("issue",26);function ie(Z,Q){let Y=q.get(Z);return typeof Y>"u"&&!Q&&(Y=9),Y}k.fromString=ie})(v||(e.CompletionItemKinds=v={}));var y;(function(k){k[k.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var _;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(_||(e.CompletionItemInsertTextRule=_={}));var l;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var b;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(b||(e.InlineCompletionTriggerKind=b={}));class o{constructor(O,U,q,ie){this.range=O,this.text=U,this.completionKind=q,this.isSnippetText=ie}equals(O){return R.Range.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.SelectedSuggestionInfo=o;var i;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(k){return k&&F.URI.isUri(k.uri)&&R.Range.isIRange(k.range)&&(R.Range.isIRange(k.originSelectionRange)||R.Range.isIRange(k.targetSelectionRange))}e.isLocationLink=a;var t;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function h(k,O){return(0,w.localize)(26,null,k,e.symbolKindNames[O])}e.getAriaLabelForSymbol=h;var u;(function(k){k[k.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var s;(function(k){const O=new Map;O.set(0,P.Codicon.symbolFile),O.set(1,P.Codicon.symbolModule),O.set(2,P.Codicon.symbolNamespace),O.set(3,P.Codicon.symbolPackage),O.set(4,P.Codicon.symbolClass),O.set(5,P.Codicon.symbolMethod),O.set(6,P.Codicon.symbolProperty),O.set(7,P.Codicon.symbolField),O.set(8,P.Codicon.symbolConstructor),O.set(9,P.Codicon.symbolEnum),O.set(10,P.Codicon.symbolInterface),O.set(11,P.Codicon.symbolFunction),O.set(12,P.Codicon.symbolVariable),O.set(13,P.Codicon.symbolConstant),O.set(14,P.Codicon.symbolString),O.set(15,P.Codicon.symbolNumber),O.set(16,P.Codicon.symbolBoolean),O.set(17,P.Codicon.symbolArray),O.set(18,P.Codicon.symbolObject),O.set(19,P.Codicon.symbolKey),O.set(20,P.Codicon.symbolNull),O.set(21,P.Codicon.symbolEnumMember),O.set(22,P.Codicon.symbolStruct),O.set(23,P.Codicon.symbolEvent),O.set(24,P.Codicon.symbolOperator),O.set(25,P.Codicon.symbolTypeParameter);function U(q){let ie=O.get(q);return ie||(console.info("No codicon found for SymbolKind "+q),ie=P.Codicon.symbolProperty),ie}k.toIcon=U})(s||(e.SymbolKinds=s={}));class c{static asEditOperation(O){return p.EditOperation.replace(R.Range.lift(O.range),O.text)}}e.TextEdit=c;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(O){switch(O){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(O)}constructor(O){this.value=O}}e.FoldingRangeKind=d;var m;(function(k){k[k.AIGenerated=1]="AIGenerated"})(m||(e.NewSymbolNameTag=m={}));var D;(function(k){function O(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}k.is=O})(D||(e.Command=D={}));var g;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(g||(e.CommentThreadCollapsibleState=g={}));var f;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var S;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(S||(e.CommentMode=S={}));var T;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(T||(e.CommentState=T={}));var N;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(N||(e.InlayHintKind=N={}));class z{constructor(O){this.createSupport=O,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=z,e.TokenizationRegistry=new A.TokenizationRegistry;var x;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(x||(e.ExternalUriOpenerPriority=x={}));var M;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(M||(e.InlineEditTriggerKind=M={}))}),define(Ce[197],De([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[198],De([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[199],De([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[200],De([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Ce[201],De([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[202],De([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[203],De([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[204],De([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Ce[205],De([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Ce[206],De([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[207],De([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Ce[208],De([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[209],De([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[210],De([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Ce[211],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[212],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Ce[213],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[214],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[215],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[216],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[217],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[218],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[219],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[220],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[221],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[222],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[223],De([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[224],De([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[225],De([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Ce[226],De([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Ce[227],De([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Ce[228],De([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[229],De([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[230],De([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[231],De([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[232],De([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[233],De([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[234],De([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[235],De([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[236],De([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ce[237],De([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[238],De([1,0,14,199]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var p;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(p||(e.TokenType=p={}));function R(...C){switch(C.length){case 1:return(0,F.localize)(0,null,C[0]);case 2:return(0,F.localize)(1,null,C[0],C[1]);case 3:return(0,F.localize)(2,null,C[0],C[1],C[2]);default:return}}const A=(0,F.localize)(3,null),w=(0,F.localize)(4,null);class E{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,P.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(L){return this._input=L,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(R("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(R("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(L){return this._isAtEnd()||this._input.charCodeAt(this._current)!==L?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(L){this._tokens.push({type:L,offset:this._start})}_error(L){const I=this._start,v=this._input.substring(this._start,this._current),y={type:19,offset:this._start,lexeme:v};this._errors.push({offset:I,lexeme:v,additionalInfo:L}),this._tokens.push(y)}_string(){this.stringRe.lastIndex=this._start;const L=this.stringRe.exec(this._input);if(L){this._current=this._start+L[0].length;const I=this._input.substring(this._start,this._current),v=E._keywords.get(I);v?this._addToken(v):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let L=this._current,I=!1,v=!1;for(;;){if(L>=this._input.length){this._current=L,this._error(w);return}const _=this._input.charCodeAt(L);if(I)I=!1;else if(_===47&&!v){L++;break}else _===91?v=!0:_===92?I=!0:_===93&&(v=!1);L++}for(;L<this._input.length&&E._regexFlags.has(this._input.charCodeAt(L));)L++;this._current=L;const y=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:y,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=E}),define(Ce[239],De([1,0,23,39,202,389]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||A.test(o)}e.isValidVersionStr=E;function C(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.parseVersion=C;function L(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let h=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),h=!1);let u=0;if(o.preRelease){const s=w.exec(o.preRelease);if(s){const[,c,d,m]=s;u=Date.UTC(Number(c),Number(d)-1,Number(m))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:h,isMinimum:o.hasGreaterEquals,notBefore:u}}e.normalizeVersion=L;function I(o,i,n){let r;typeof o=="string"?r=L(C(o)):r=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=L(C(n)):t=n,!r||!t)return!1;const h=r.majorBase,u=r.minorBase,s=r.patchBase;let c=t.majorBase,d=t.minorBase,m=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,f=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?h>c?!0:h<c?!1:u>d?!0:u<d||a&&a<D?!1:s>=m:(h===1&&c===0&&(!g||!f||!S)&&(c=1,d=0,m=0,g=!0,f=!1,S=!1),h<c?!1:h>c?!g:u<d?!1:u>d?!f:s<m?!1:s>m?!S:!(a&&a<D))}e.isValidVersion=I;function v(o,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([F.default.Error,p.localize(0,null)]),t;if(typeof r.name!="string")return t.push([F.default.Error,p.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([F.default.Error,p.localize(2,null,"version")]),t;if(!r.engines)return t.push([F.default.Error,p.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([F.default.Error,p.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!b(r.extensionDependencies))return t.push([F.default.Error,p.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!b(r.activationEvents))return t.push([F.default.Error,p.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([F.default.Error,p.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([F.default.Warning,p.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([F.default.Error,p.localize(9,null,"main")]),t;{const s=(0,P.joinPath)(n,r.main);(0,P.isEqualOrParent)(s,n)||t.push([F.default.Warning,p.localize(10,null,s.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([F.default.Error,p.localize(11,null,"browser")]),t;{const s=(0,P.joinPath)(n,r.browser);(0,P.isEqualOrParent)(s,n)||t.push([F.default.Warning,p.localize(12,null,s.path,n.path)])}}if(!R.valid(r.version))return t.push([F.default.Error,p.localize(13,null)]),t;const h=[];if(!y(o,i,r,a,h))for(const s of h)t.push([F.default.Error,s]);return t}e.validateExtensionManifest=v;function y(o,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:l(o,i,n.engines.vscode,a)}e.isValidExtensionVersion=y;function _(o,i,n){return o==="*"||l(i,n,o)}e.isEngineValid=_;function l(o,i,n,r=[]){const a=L(C(n));if(!a)return r.push(p.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push(p.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push(p.localize(16,null,n)),!1;return I(o,i,a)?!0:(r.push(p.localize(17,null,o,n)),!1)}function b(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Ce[105],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(p,R=[],A=!1){this.ctor=p,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=P}),define(Ce[84],De([1,0,105]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const F=[];var p;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(p||(e.InstantiationType=p={}));function R(w,E,C){E instanceof P.SyncDescriptor||(E=new P.SyncDescriptor(E,[],!!C)),F.push([w,E])}e.registerSingleton=R;function A(){return F}e.getSingletonServiceDescriptors=A}),define(Ce[240],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class F{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const A of this._nodes.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const w=this.lookupOrInsertNode(R),E=this.lookupOrInsertNode(A);w.outgoing.set(E.key,E),E.incoming.set(w.key,w)}removeNode(R){const A=this._hashFn(R);this._nodes.delete(A);for(const w of this._nodes.values())w.outgoing.delete(A),w.incoming.delete(A)}lookupOrInsertNode(R){const A=this._hashFn(R);let w=this._nodes.get(A);return w||(w=new P(A,R),this._nodes.set(A,w)),w}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[A,w]of this._nodes)R.push(`${A}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this._nodes){const w=new Set([R]),E=this._findCycle(A,w);if(E)return E}}_findCycle(R,A){for(const[w,E]of R.outgoing){if(A.has(w))return[...A,w].join(" -> ");A.add(w);const C=this._findCycle(E,A);if(C)return C;A.delete(w)}}}e.Graph=F}),define(Ce[5],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var P;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function w(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=w})(P||(e._util=P={})),e.IInstantiationService=p("instantiationService");function F(A,w,E){w[P.DI_TARGET]===w?w[P.DI_DEPENDENCIES].push({id:A,index:E}):(w[P.DI_DEPENDENCIES]=[{id:A,index:E}],w[P.DI_TARGET]=w)}function p(A){if(P.serviceIds.has(A))return P.serviceIds.get(A);const w=function(E,C,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(w,E,L)};return w.toString=()=>A,P.serviceIds.set(A,w),w}e.createDecorator=p;function R(A){return A}e.refineServiceDecorator=R}),define(Ce[52],De([1,0,18,2,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,p.createDecorator)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.isConfigurationOverrides=R;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=A;var w;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function E(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function C(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.isConfigured=C;function L(o,i){const n=Object.create(null);for(const r in o)I(n,r,o[r],i);return n}e.toValuesTree=L;function I(o,i,n,r){const a=i.split("."),t=a.pop();let h=o;for(let u=0;u<a.length;u++){const s=a[u];let c=h[s];switch(typeof c){case"undefined":c=h[s]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,u+1).join(".")} is ${JSON.stringify(c)}`);return}h=c}if(typeof h=="object"&&h!==null)try{h[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=I;function v(o,i){const n=i.split(".");y(o,n)}e.removeFromValueTree=v;function y(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(y(r,i),Object.keys(r).length===0&&delete o[n])}}function _(o,i,n){function r(h,u){let s=h;for(const c of u){if(typeof s!="object"||s===null)return;s=s[c]}return s}const a=i.split("."),t=r(o,a);return typeof t>"u"?n:t}e.getConfigurationValue=_;function l(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?P.isObject(o[r])&&P.isObject(i[r])?l(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.merge=l;function b(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(Ce[45],De([1,0,11,12,238,5,198,14]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",P.isMacintosh),E.set("isLinux",P.isLinux),E.set("isWindows",P.isWindows),E.set("isWeb",P.isWeb),E.set("isMacNative",P.isMacintosh&&!P.isWeb),E.set("isEdge",P.isEdge),E.set("isFirefox",P.isFirefox),E.set("isChrome",P.isChrome),E.set("isSafari",P.isSafari);function C(G,B){if(E.get(G)!==void 0)throw(0,w.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(G,B)}e.setConstant=C;const L=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),_=(0,A.localize)(1,null),l=(0,A.localize)(2,null),b=(0,A.localize)(3,null),o=(0,A.localize)(4,null),i=(0,A.localize)(5,null),n=(0,A.localize)(6,null),r=(0,A.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(B=v){this._config=B,this._scanner=new p.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(B){if(B===""){this._parsingErrors.push({message:y,offset:0,lexeme:"",additionalInfo:_});return}this._tokens=this._scanner.reset(B).scan(),this._current=0,this._parsingErrors=[];try{const se=this._expr();if(!this._isAtEnd()){const ye=this._peek(),le=ye.type===17?i:void 0;throw this._parsingErrors.push({message:o,offset:ye.offset,lexeme:p.Scanner.getLexeme(ye),additionalInfo:le}),a._parseError}return se}catch(se){if(se!==a._parseError)throw se;return}}_expr(){return this._or()}_or(){const B=[this._and()];for(;this._matchOne(16);){const se=this._and();B.push(se)}return B.length===1?B[0]:t.or(...B)}_and(){const B=[this._term()];for(;this._matchOne(15);){const se=this._term();B.push(se)}return B.length===1?B[0]:t.and(...B)}_term(){if(this._matchOne(2)){const B=this._peek();switch(B.type){case 11:return this._advance(),c.INSTANCE;case 12:return this._advance(),d.INSTANCE;case 0:{this._advance();const se=this._expr();return this._consume(1,b),se?.negate()}case 17:return this._advance(),T.create(B.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",B)}}return this._primary()}_primary(){const B=this._peek();switch(B.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const se=this._expr();return this._consume(1,b),se}case 17:{const se=B.lexeme;if(this._advance(),this._matchOne(9)){const le=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),le.type!==10)throw this._errExpectedButGot("REGEX",le);const de=le.lexeme,ce=de.lastIndexOf("/"),he=ce===de.length-1?void 0:this._removeFlagsGY(de.substring(ce+1));let V;try{V=new RegExp(de.substring(1,ce),he)}catch{throw this._errExpectedButGot("REGEX",le)}return O.create(se,V)}switch(le.type){case 10:case 19:{const de=[le.lexeme];this._advance();let ce=this._peek(),he=0;for(let ke=0;ke<le.lexeme.length;ke++)le.lexeme.charCodeAt(ke)===40?he++:le.lexeme.charCodeAt(ke)===41&&he--;for(;!this._isAtEnd()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:he++;break;case 1:he--;break;case 10:case 18:for(let ke=0;ke<ce.lexeme.length;ke++)ce.lexeme.charCodeAt(ke)===40?he++:le.lexeme.charCodeAt(ke)===41&&he--}if(he<0)break;de.push(p.Scanner.getLexeme(ce)),this._advance(),ce=this._peek()}const V=de.join(""),J=V.lastIndexOf("/"),ue=J===V.length-1?void 0:this._removeFlagsGY(V.substring(J+1));let ve;try{ve=new RegExp(V.substring(1,J),ue)}catch{throw this._errExpectedButGot("REGEX",le)}return t.regex(se,ve)}case 18:{const de=le.lexeme;this._advance();let ce=null;if(!(0,F.isFalsyOrWhitespace)(de)){const he=de.indexOf("/"),V=de.lastIndexOf("/");if(he!==V&&he>=0){const J=de.slice(he+1,V),ue=de[V+1]==="i"?"i":"";try{ce=new RegExp(J,ue)}catch{throw this._errExpectedButGot("REGEX",le)}}}if(ce===null)throw this._errExpectedButGot("REGEX",le);return O.create(se,ce)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,l);const le=this._value();return t.notIn(se,le)}switch(this._peek().type){case 3:{this._advance();const le=this._value();if(this._previous().type===18)return t.equals(se,le);switch(le){case"true":return t.has(se);case"false":return t.not(se);default:return t.equals(se,le)}}case 4:{this._advance();const le=this._value();if(this._previous().type===18)return t.notEquals(se,le);switch(le){case"true":return t.not(se);case"false":return t.has(se);default:return t.notEquals(se,le)}}case 5:return this._advance(),M.create(se,this._value());case 6:return this._advance(),k.create(se,this._value());case 7:return this._advance(),z.create(se,this._value());case 8:return this._advance(),x.create(se,this._value());case 13:return this._advance(),t.in(se,this._value());default:return t.has(se)}}case 20:throw this._parsingErrors.push({message:n,offset:B.offset,lexeme:"",additionalInfo:r}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const B=this._peek();switch(B.type){case 17:case 18:return this._advance(),B.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(B){return B.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(B){return this._check(B)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(B,se){if(this._check(B))return this._advance();throw this._errExpectedButGot(se,this._peek())}_errExpectedButGot(B,se,ye){const le=(0,A.localize)(8,null,B,p.Scanner.getLexeme(se)),de=se.offset,ce=p.Scanner.getLexeme(se);return this._parsingErrors.push({message:le,offset:de,lexeme:ce,additionalInfo:ye}),a._parseError}_check(B){return this._peek().type===B}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return c.INSTANCE}static true(){return d.INSTANCE}static has(B){return m.create(B)}static equals(B,se){return D.create(B,se)}static notEquals(B,se){return S.create(B,se)}static regex(B,se){return O.create(B,se)}static in(B,se){return g.create(B,se)}static notIn(B,se){return f.create(B,se)}static not(B){return T.create(B)}static and(...B){return ie.create(B,null,!0)}static or(...B){return Z.create(B,null,!0)}static greater(B,se){return z.create(B,se)}static greaterEquals(B,se){return x.create(B,se)}static smaller(B,se){return M.create(B,se)}static smallerEquals(B,se){return k.create(B,se)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this._parser.parse(B)}}e.ContextKeyExpr=t;function h(G){const B=new a({regexParsingWithErrorRecovery:!1});return G.map(se=>(B.parse(se),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,A.localize)(9,null,ye.additionalInfo):(0,A.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.validateWhenClauses=h;function u(G,B){const se=G?G.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!se&&!ye?!0:!se||!ye?!1:se.equals(ye)}e.expressionsAreEqualWithConstantSubstitution=u;function s(G,B){return G.cmp(B)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=c;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=d;class m{static create(B,se=null){const ye=E.get(B);return typeof ye=="boolean"?ye?d.INSTANCE:c.INSTANCE:new m(B,se)}constructor(B,se){this.key=B,this.negated=se,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?d.INSTANCE:c.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class D{static create(B,se,ye=null){if(typeof se=="boolean")return se?m.create(B,ye):T.create(B,ye);const le=E.get(B);return typeof le=="boolean"?se===(le?"true":"false")?d.INSTANCE:c.INSTANCE:new D(B,se,ye)}constructor(B,se,ye){this.key=B,this.value=se,this.negated=ye,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=E.get(this.key);if(typeof B=="boolean"){const se=B?"true":"false";return this.value===se?d.INSTANCE:c.INSTANCE}return this}evaluate(B){return B.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(B){return B.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class g{static create(B,se){return new g(B,se)}constructor(B,se){this.key=B,this.valueKey=se,this.type=10,this.negated=null}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.valueKey,B.key,B.valueKey)}equals(B){return B.type===this.type?this.key===B.key&&this.valueKey===B.valueKey:!1}substituteConstants(){return this}evaluate(B){const se=B.getValue(this.valueKey),ye=B.getValue(this.key);return Array.isArray(se)?se.includes(ye):typeof ye=="string"&&typeof se=="object"&&se!==null?L.call(se,ye):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(B){return B.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class f{static create(B,se){return new f(B,se)}constructor(B,se){this.key=B,this.valueKey=se,this.type=11,this._negated=g.create(B,se)}cmp(B){return B.type!==this.type?this.type-B.type:this._negated.cmp(B._negated)}equals(B){return B.type===this.type?this._negated.equals(B._negated):!1}substituteConstants(){return this}evaluate(B){return!this._negated.evaluate(B)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(B){return B.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=f;class S{static create(B,se,ye=null){if(typeof se=="boolean")return se?T.create(B,ye):m.create(B,ye);const le=E.get(B);return typeof le=="boolean"?se===(le?"true":"false")?c.INSTANCE:d.INSTANCE:new S(B,se,ye)}constructor(B,se,ye){this.key=B,this.value=se,this.negated=ye,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){const B=E.get(this.key);if(typeof B=="boolean"){const se=B?"true":"false";return this.value===se?c.INSTANCE:d.INSTANCE}return this}evaluate(B){return B.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(B){return B.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class T{static create(B,se=null){const ye=E.get(B);return typeof ye=="boolean"?ye?c.INSTANCE:d.INSTANCE:new T(B,se)}constructor(B,se){this.key=B,this.negated=se,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?c.INSTANCE:d.INSTANCE:this}evaluate(B){return!B.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(B){return B.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function N(G,B){if(typeof G=="string"){const se=parseFloat(G);isNaN(se)||(G=se)}return typeof G=="string"||typeof G=="number"?B(G):c.INSTANCE}class z{static create(B,se,ye=null){return N(se,le=>new z(B,le,ye))}constructor(B,se,ye){this.key=B,this.value=se,this.negated=ye,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=z;class x{static create(B,se,ye=null){return N(se,le=>new x(B,le,ye))}constructor(B,se,ye){this.key=B,this.value=se,this.negated=ye,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(B){return B.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class M{static create(B,se,ye=null){return N(se,le=>new M(B,le,ye))}constructor(B,se,ye){this.key=B,this.value=se,this.negated=ye,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class k{static create(B,se,ye=null){return N(se,le=>new k(B,le,ye))}constructor(B,se,ye){this.key=B,this.value=se,this.negated=ye,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.key,this.value,B.key,B.value)}equals(B){return B.type===this.type?this.key===B.key&&this.value===B.value:!1}substituteConstants(){return this}evaluate(B){return typeof this.value=="string"?!1:parseFloat(B.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(B){return B.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=k;class O{static create(B,se){return new O(B,se)}constructor(B,se){this.key=B,this.regexp=se,this.type=7,this.negated=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.key<B.key)return-1;if(this.key>B.key)return 1;const se=this.regexp?this.regexp.source:"",ye=B.regexp?B.regexp.source:"";return se<ye?-1:se>ye?1:0}equals(B){if(B.type===this.type){const se=this.regexp?this.regexp.source:"",ye=B.regexp?B.regexp.source:"";return this.key===B.key&&se===ye}return!1}substituteConstants(){return this}evaluate(B){const se=B.getValue(this.key);return this.regexp?this.regexp.test(se):!1}serialize(){const B=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${B}`}keys(){return[this.key]}map(B){return B.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=U.create(this)),this.negated}}e.ContextKeyRegexExpr=O;class U{static create(B){return new U(B)}constructor(B){this._actual=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this._actual.cmp(B._actual)}equals(B){return B.type===this.type?this._actual.equals(B._actual):!1}substituteConstants(){return this}evaluate(B){return!this._actual.evaluate(B)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(B){return new U(this._actual.map(B))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=U;function q(G){let B=null;for(let se=0,ye=G.length;se<ye;se++){const le=G[se].substituteConstants();if(G[se]!==le&&B===null){B=[];for(let de=0;de<se;de++)B[de]=G[de]}B!==null&&(B[se]=le)}return B===null?G:B}class ie{static create(B,se,ye){return ie._normalizeArr(B,se,ye)}constructor(B,se){this.expr=B,this.negated=se,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let se=0,ye=this.expr.length;se<ye;se++){const le=s(this.expr[se],B.expr[se]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let se=0,ye=this.expr.length;se<ye;se++)if(!this.expr[se].equals(B.expr[se]))return!1;return!0}return!1}substituteConstants(){const B=q(this.expr);return B===this.expr?this:ie.create(B,this.negated,!1)}evaluate(B){for(let se=0,ye=this.expr.length;se<ye;se++)if(!this.expr[se].evaluate(B))return!1;return!0}static _normalizeArr(B,se,ye){const le=[];let de=!1;for(const ce of B)if(ce){if(ce.type===1){de=!0;continue}if(ce.type===0)return c.INSTANCE;if(ce.type===6){le.push(...ce.expr);continue}le.push(ce)}if(le.length===0&&de)return d.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(s);for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];for(;le.length>1;){const ce=le[le.length-1];if(ce.type!==9)break;le.pop();const he=le.pop(),V=le.length===0,J=Z.create(ce.expr.map(ue=>ie.create([ue,he],null,ye)),null,V);J&&(le.push(J),le.sort(s))}if(le.length===1)return le[0];if(ye){for(let ce=0;ce<le.length;ce++)for(let he=ce+1;he<le.length;he++)if(le[ce].negate().equals(le[he]))return c.INSTANCE;if(le.length===1)return le[0]}return new ie(le,se)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const se of this.expr)B.push(...se.keys());return B}map(B){return new ie(this.expr.map(se=>se.map(B)),null)}negate(){if(!this.negated){const B=[];for(const se of this.expr)B.push(se.negate());this.negated=Z.create(B,this,!0)}return this.negated}}e.ContextKeyAndExpr=ie;class Z{static create(B,se,ye){return Z._normalizeArr(B,se,ye)}constructor(B,se){this.expr=B,this.negated=se,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let se=0,ye=this.expr.length;se<ye;se++){const le=s(this.expr[se],B.expr[se]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let se=0,ye=this.expr.length;se<ye;se++)if(!this.expr[se].equals(B.expr[se]))return!1;return!0}return!1}substituteConstants(){const B=q(this.expr);return B===this.expr?this:Z.create(B,this.negated,!1)}evaluate(B){for(let se=0,ye=this.expr.length;se<ye;se++)if(this.expr[se].evaluate(B))return!0;return!1}static _normalizeArr(B,se,ye){let le=[],de=!1;if(B){for(let ce=0,he=B.length;ce<he;ce++){const V=B[ce];if(V){if(V.type===0){de=!0;continue}if(V.type===1)return d.INSTANCE;if(V.type===9){le=le.concat(V.expr);continue}le.push(V)}}if(le.length===0&&de)return c.INSTANCE;le.sort(s)}if(le.length!==0){if(le.length===1)return le[0];for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];if(ye){for(let ce=0;ce<le.length;ce++)for(let he=ce+1;he<le.length;he++)if(le[ce].negate().equals(le[he]))return d.INSTANCE;if(le.length===1)return le[0]}return new Z(le,se)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const se of this.expr)B.push(...se.keys());return B}map(B){return new Z(this.expr.map(se=>se.map(B)),null)}negate(){if(!this.negated){const B=[];for(const se of this.expr)B.push(se.negate());for(;B.length>1;){const se=B.shift(),ye=B.shift(),le=[];for(const de of re(se))for(const ce of re(ye))le.push(ie.create([de,ce],null,!1));B.unshift(Z.create(le,null,!1))}this.negated=Z.create(B,this,!0)}return this.negated}}e.ContextKeyOrExpr=Z;class Q extends m{static{this._info=[]}static all(){return Q._info.values()}constructor(B,se,ye){super(B,null),this._defaultValue=se,typeof ye=="object"?Q._info.push({...ye,key:B}):ye!==!0&&Q._info.push({key:B,description:ye,type:se!=null?typeof se:void 0})}bindTo(B){return B.createKey(this.key,this._defaultValue)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return S.create(this.key,B)}}e.RawContextKey=Q,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function Y(G,B){return G<B?-1:G>B?1:0}function ae(G,B,se,ye){return G<se?-1:G>se?1:B<ye?-1:B>ye?1:0}function ee(G,B){if(G.type===0||B.type===1)return!0;if(G.type===9)return B.type===9?fe(G.expr,B.expr):!1;if(B.type===9){for(const se of B.expr)if(ee(G,se))return!0;return!1}if(G.type===6){if(B.type===6)return fe(B.expr,G.expr);for(const se of G.expr)if(ee(se,B))return!0;return!1}return G.equals(B)}e.implies=ee;function fe(G,B){let se=0,ye=0;for(;se<G.length&&ye<B.length;){const le=G[se].cmp(B[ye]);if(le<0)return!1;le===0&&se++,ye++}return se===G.length}function re(G){return G.type===9?G.expr:[G]}}),define(Ce[241],De([1,0,23,39,200,5,102,11,24]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var C;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(C||(C={}));class L{getConfirmationButtons(b){return this.getButtons(b,C.Confirmation)}getPromptButtons(b){return this.getButtons(b,C.Prompt)}getInputButtons(b){return this.getButtons(b,C.Input)}getButtons(b,o){const i=[];switch(o){case C.Confirmation:{const n=b;n.primaryButton?i.push(n.primaryButton):i.push((0,p.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,p.localize)(1,null));break}case C.Prompt:{const n=b;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,p.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,p.localize)(3,null))),i.length===0&&i.push((0,p.localize)(4,null));break}case C.Input:{const n=b;n.primaryButton?i.push(n.primaryButton):i.push((0,p.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,p.localize)(6,null));break}}return i}getDialogType(b){if(typeof b=="string")return b;if(typeof b=="number")return b===F.default.Info?"info":b===F.default.Error?"error":b===F.default.Warning?"warning":"none"}getPromptResult(b,o,i){const n=[...b.buttons??[]];b.cancelButton&&typeof b.cancelButton!="string"&&typeof b.cancelButton!="boolean"&&n.push(b.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.AbstractDialogHandler=L,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var I;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const v=10;function y(l){const b=[];return b.push(...l.slice(0,v).map(o=>typeof o=="string"?o:(0,P.basename)(o))),l.length>v&&(l.length-v===1?b.push((0,p.localize)(7,null)):b.push((0,p.localize)(8,null,l.length-v))),b.push(""),b.join(`
`)}e.getFileNamesMessage=y;function _(l,b){const o=(0,E.deepClone)(l);let i=(o.buttons??[]).map(t=>(0,A.mnemonicButtonLabel)(t)),n=(l.buttons||[]).map((t,h)=>h),r=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(w.isLinux||w.isMacintosh){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const h=n[a];n.splice(a,1),n.splice(1,0,h),a=1}w.isLinux&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(w.isWindows&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const h=n[a];n.splice(a,1),n.push(h),a=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=a,o.noLink=!0,o.title=o.title||b.nameLong,{options:o,buttonIndeces:n}}e.massageMessageBoxOptions=_}),define(Ce[133],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[134],De([1,0,201,5]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function p(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=p;function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":r==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function w(n,r){return r==="web"&&!n.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function E(n,r,a){return w(r,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a}e.isTargetPlatformCompatible=E;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C;var L;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var I;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var v;(function(n){n.Install="install",n.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var y;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,F.createDecorator)("extensionGalleryService");var _;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(_||(e.ExtensionManagementErrorCode=_={}));var l;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class b extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.ExtensionManagementError=b;var o;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.ExtensionGalleryError=i,e.IExtensionManagementService=(0,F.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,F.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,F.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,P.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,P.localize2)(1,"Preferences")}),define(Ce[242],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,P.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(Ce[243],De([1,0,51,53,16,17,11,101,31,104,203,242]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=L.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends y{static{this.CMD="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(P,a,C.getWindowsShell(),t)}spawnTerminal(a,t,h,u){const s=t.windowsExec||_.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const c=R.basename(s,".exe").toLowerCase();if(c==="cmder")return a.spawn(s,u?[u]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),c==="wt"&&d.push("-d ."),new Promise((m,D)=>{const g=o(process),f=a.spawn(h,d,{cwd:u,env:g,detached:!0});f.on("error",D),f.on("exit",()=>m())})}async runInTerminal(a,t,h,u,s){const c="windowsExec"in s&&s.windowsExec?s.windowsExec:_.getDefaultTerminalWindows(),d=await _.getWtExePath();return new Promise((m,D)=>{const g=`"${t} - ${v}"`,f=`""${h.join('" "')}" & pause"`,S=Object.assign({},o(process),u);Object.keys(S).filter(M=>S[M]===null).forEach(M=>delete S[M]);const T={cwd:t,env:S,windowsVerbatimArguments:!0};let N,z;R.basename(c,".exe")==="wt"?(N=c,z=["-d",".",_.CMD,"/c",f]):d?(N=d,z=["-d",".",c,"/c",f]):(N=_.CMD,z=["/c","start",g,"/wait",c,"/c",f]),P.spawn(N,z,T).on("error",M=>{D(i(M))}),m(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const a=await C.win32.findExecutable("wt");return await E.Promises.exists(a)?a:void 0}catch{return}}}e.WindowsExternalTerminalService=_,Ge([F.memoize],_,"getWtExePath",null);class l extends y{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(P,a,t)}runInTerminal(a,t,h,u,s){const c=s.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((d,m)=>{if(c===I.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const D=c===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[p.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",a||v,"-w",t];for(const N of h)f.push("-a"),f.push(N);if(u){const N=Object.assign({},o(process),u);for(const z in N){const x=N[z];x===null?(f.push("-u"),f.push(z)):(f.push("-e"),f.push(`${z}=${x}`))}}let S="";const T=P.spawn(l.OSASCRIPT,f);T.on("error",N=>{m(i(N))}),T.stderr.on("data",N=>{S+=N.toString()}),T.on("exit",N=>{if(N===0)d(void 0);else if(S){const z=S.split(`
`,1);m(new Error(z[0]))}else m(new Error(L.localize(1,null,D,N)))})}else m(new Error(L.localize(2,null,c)))})}spawnTerminal(a,t,h){const u=t.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{const d=["-a",u];h&&d.push(h);const m=o(process),D=a.spawn("/usr/bin/open",d,{cwd:h,env:m});D.on("error",c),D.on("exit",()=>s())})}}e.MacExternalTerminalService=l;class b extends y{static{this.WAIT_MESSAGE=L.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(P,a,t)}runInTerminal(a,t,h,u,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((d,m)=>{const D=[];c.then(g=>{g.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const f=`${n(h)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;D.push(`''${f}''`);const S=Object.assign({},o(process),u);Object.keys(S).filter(x=>S[x]===null).forEach(x=>delete S[x]);const T={cwd:t,env:S};let N="";const z=P.spawn(g,D,T);z.on("error",x=>{m(i(x))}),z.stderr.on("data",x=>{N+=x.toString()}),z.on("exit",x=>{if(x===0)d(void 0);else if(N){const M=N.split(`
`,1);m(new Error(M[0]))}else m(new Error(L.localize(4,null,g,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await E.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,t,h){const u=t.linuxExec?Promise.resolve(t.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{u.then(d=>{const m=o(process),D=a.spawn(d,[],{cwd:h,env:m});D.on("error",c),D.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=b;function o(r){const a={...r.env};return(0,w.sanitizeProcessEnvironment)(a),a}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(L.localize(5,null,r.path)):r}function n(r){let a="";for(const t of r)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(Ce[32],De([1,0,77,17,12,18,2,204,5,11,16,44]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function v(ee){return ee.create===!0}e.isFileOpenForWriteOptions=v;var y;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var _;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(_||(e.FilePermission=_={}));function l(ee){const fe=ee;return!!fe&&typeof fe.onDidChange=="function"}e.isFileSystemWatcher=l;var b;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function o(ee){return!!(ee.capabilities&2)}e.hasReadWriteCapability=o;function i(ee){return!!(ee.capabilities&8)}e.hasFileFolderCopyCapability=i;function n(ee){return!!(ee.capabilities&131072)}e.hasFileCloneCapability=n;function r(ee){return!!(ee.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function a(ee){return!!(ee.capabilities&16)}e.hasFileReadStreamCapability=a;function t(ee){return o(ee)?!!(ee.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function h(ee){return o(ee)?!!(ee.capabilities&32768):!1}e.hasFileAtomicWriteCapability=h;function u(ee){return!!(ee.capabilities&65536)}e.hasFileAtomicDeleteCapability=u;function s(ee){return!!(ee.capabilities&2048)}e.hasReadonlyCapability=s;var c;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class d extends Error{static create(fe,re){const G=new d(fe.toString(),re);return g(G,re),G}constructor(fe,re){super(fe),this.code=re}}e.FileSystemProviderError=d;function m(ee,fe){return d.create(ee,fe)}e.createFileSystemProviderError=m;function D(ee){return ee||m((0,w.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=D;function g(ee,fe){return ee.name=fe?`${fe} (FileSystemError)`:"FileSystemError",ee}e.markAsFileSystemProviderError=g;function f(ee){if(!ee)return c.Unknown;if(ee instanceof d)return ee.code;const fe=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!fe)return c.Unknown;switch(fe[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=f;function S(ee){if(ee instanceof k)return ee.fileOperationResult;switch(f(ee)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=S;var T;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class N{constructor(fe,re,G){this.resource=fe,this.operation=re,this.target=G}isOperation(fe){return this.operation===fe}}e.FileOperationEvent=N;var z;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class x{static{this.MIXED_CORRELATION=null}constructor(fe,re){this.ignorePathCasing=re,this.correlationId=void 0,this.added=new I.Lazy(()=>{const G=P.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawAdded.map(B=>[B,!0])),G}),this.updated=new I.Lazy(()=>{const G=P.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawUpdated.map(B=>[B,!0])),G}),this.deleted=new I.Lazy(()=>{const G=P.TernarySearchTree.forUris(()=>this.ignorePathCasing);return G.fill(this.rawDeleted.map(B=>[B,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of fe){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.correlationId!==x.MIXED_CORRELATION&&(typeof G.cId=="number"?this.correlationId===void 0?this.correlationId=G.cId:this.correlationId!==G.cId&&(this.correlationId=x.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=x.MIXED_CORRELATION))}}contains(fe,...re){return this.doContains(fe,{includeChildren:!1},...re)}affects(fe,...re){return this.doContains(fe,{includeChildren:!0},...re)}doContains(fe,re,...G){if(!fe)return!1;const B=G.length>0;return!!((!B||G.includes(1))&&(this.added.value.get(fe)||re.includeChildren&&this.added.value.findSuperstr(fe))||(!B||G.includes(0))&&(this.updated.value.get(fe)||re.includeChildren&&this.updated.value.findSuperstr(fe))||(!B||G.includes(2))&&(this.deleted.value.findSubstr(fe)||re.includeChildren&&this.deleted.value.findSuperstr(fe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(fe){return this.correlationId===fe}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=x;function M(ee,fe,re){return!ee||!fe||ee===fe||fe.length>ee.length?!1:(fe.charAt(fe.length-1)!==F.sep&&(fe+=F.sep),re?(0,p.startsWithIgnoreCase)(ee,fe):ee.indexOf(fe)===0)}e.isParent=M;class k extends Error{constructor(fe,re,G){super(fe),this.fileOperationResult=re,this.options=G}}e.FileOperationError=k;class O extends k{constructor(fe,re,G,B){super(fe,re,B),this.fileOperationResult=re,this.size=G}}e.TooLargeFileOperationError=O;class U extends k{constructor(fe,re,G){super(fe,2,G),this.stat=re}}e.NotModifiedSinceFileOperationError=U;var q;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(q||(e.FileOperationResult=q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ie;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie||(e.FileKind=ie={})),e.ETAG_DISABLED="";function Z(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.etag=Z;async function Q(ee,fe){if(!fe.hasProvider(A.URI.from({scheme:ee.scheme})))return new Promise(re=>{const G=fe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ee.scheme&&B.added&&(G.dispose(),re())})})}e.whenProviderRegistered=Q;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(fe){return(0,R.isNumber)(fe)||(fe=0),fe<Y.KB?(0,w.localize)(1,null,fe.toFixed(0)):fe<Y.MB?(0,w.localize)(2,null,(fe/Y.KB).toFixed(2)):fe<Y.GB?(0,w.localize)(3,null,(fe/Y.MB).toFixed(2)):fe<Y.TB?(0,w.localize)(4,null,(fe/Y.GB).toFixed(2)):(0,w.localize)(5,null,(fe/Y.TB).toFixed(2))}}e.ByteSize=Y;function ae(ee){const fe=typeof ee=="string"||ee?.scheme===L.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===L.Schemas.file?1024*Y.MB:fe?10*Y.MB:C.isWeb?50*Y.MB:1024*Y.MB}e.getLargeFileConfirmationLimit=ae}),define(Ce[244],De([1,0,21,14,205,32]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(L,I,v,y,_,l){let b;try{await w(L,I,v,y,_,l)}catch(o){b=o}finally{b&&_.errorTransformer&&(b=_.errorTransformer(b)),typeof b<"u"&&v.error(b),v.end()}}e.readFileIntoStream=A;async function w(L,I,v,y,_,l){E(l);const b=await L.open(I,{create:!1});try{E(l);let o=0,i=0,n=_&&typeof _.length=="number"?_.length:void 0,r=P.VSBuffer.alloc(Math.min(_.bufferSize,typeof n=="number"?n:_.bufferSize)),a=_&&typeof _.position=="number"?_.position:0,t=0;do i=await L.read(b,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await v.write(y(r)),r=P.VSBuffer.alloc(Math.min(_.bufferSize,typeof n=="number"?n:_.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&E(l)&&C(o,_));if(t>0){let h=t;typeof n=="number"&&(h=Math.min(t,n)),v.write(y(r.slice(0,h)))}}catch(o){throw(0,R.ensureFileSystemProviderError)(o)}finally{await L.close(b)}}function E(L){if(L.isCancellationRequested)throw(0,F.canceled)();return!0}function C(L,I){if(typeof I?.limits?.size=="number"&&L>I.limits.size)throw(0,R.createFileSystemProviderError)((0,p.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[85],De([1,0,35,3,17,11,2,32]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(o){return o.recursive===!0}e.isRecursiveWatchRequest=E;class C extends F.Disposable{static{this.MAX_RESTARTS=5}constructor(i,n,r,a){super(),this.onFileChanges=i,this.onLogMessage=n,this.verboseLogging=r,this.options=a,this.watcherDisposables=this._register(new F.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const i=new F.DisposableStore;this.watcherDisposables.value=i,this.watcher=this.createWatcher(i),this.watcher.setVerboseLogging(this.verboseLogging),i.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),i.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),i.add(this.watcher.onDidError(n=>this.onError(n)))}onError(i){this.options.restartOnError?this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${i}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${i}`):this.error(i)}restart(i){this.restartCounter++,this.init(),this.watch(i)}async watch(i){this.requests=i,await this.watcher?.watch(i)}async setVerboseLogging(i){this.verboseLogging=i,await this.watcher?.setVerboseLogging(i)}error(i){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${i}`})}trace(i){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${i}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=C;class L extends C{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=L;class I extends C{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function v(o){return o.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.reviveFileChanges=v;function y(o){const i=new b;for(const n of o)i.processEvent(n);return i.coalesce()}e.coalesceEvents=y;function _(o,i){return typeof i=="string"&&!i.startsWith(P.GLOBSTAR)&&!(0,p.isAbsolute)(i)?{base:o,pattern:i}:i}e.normalizeWatcherPattern=_;function l(o,i){const n=[];for(const r of i)n.push((0,P.parse)(_(o,r)));return n}e.parseWatcherPatterns=l;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(i){return R.isLinux?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.mapPathToChange.get(this.toKey(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.mapPathToChange.delete(this.toKey(i)),this.coalesced.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.coalesced.add(i),this.mapPathToChange.set(this.toKey(i),i))}coalesce(){const i=[],n=[];return Array.from(this.coalesced).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,w.isParent)(r.resource.fsPath,a,!R.isLinux))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(Ce[245],De([1,0,57,8,22,34,3,76,17,11,23,2,103,31,85]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class l extends A.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(i,n,r,a){super(),this.request=i,this.onDidFilesChange=n,this.onLogMessage=r,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new F.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new F.RunOnceWorker(t=>this.handleFileChanges(t),l.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,_.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,_.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new p.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const n=await y.Promises.stat(i);this._register(await this.doWatch(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(i)}}async normalizePath(i){let n=i.path;try{n=await y.Promises.realpath(i.path),i.path===n&&(n=await(0,v.realcase)(i.path)??i.path),i.path!==n&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async doWatch(i,n){if(C.isMacintosh&&(0,R.isEqualOrParent)(i,"/Volumes/",!0))return this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const r=new p.CancellationTokenSource(this.cts.token),a=new A.DisposableStore;try{const t=I.URI.file(this.request.path),h=(0,E.basename)(i),u=(0,P.watch)(i);a.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${i}'`);const s=new Set;if(n)try{for(const d of await y.Promises.readdir(i))s.add(d)}catch(d){this.error(d)}const c=new Map;a.add((0,A.toDisposable)(()=>{for(const[,d]of c)d.dispose();c.clear()})),u.on("error",(d,m)=>{this.error(`Failed to watch ${i} for changes using fs.watch() (${d}, ${m})`),this.dispose()}),u.on("change",(d,m)=>{if(r.token.isCancellationRequested)return;this.trace(`[raw] ["${d}"] ${m}`);let D="";if(m&&(D=m.toString(),C.isMacintosh&&(D=(0,w.normalizeNFC)(D))),!(!D||d!=="change"&&d!=="rename"))if(n)if(d==="rename"){c.get(D)?.dispose();const g=setTimeout(async()=>{if(c.delete(D),D===h&&!await y.Promises.exists(i)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.existsChildStrictCase((0,E.join)(i,D));if(r.token.isCancellationRequested)return;let S;f?s.has(D)?S=0:(S=1,s.add(D)):(s.delete(D),S=2),this.onFileChange({resource:(0,L.joinPath)(t,D),type:S,cId:this.request.correlationId})},l.FILE_DELETE_HANDLER_DELAY);c.set(D,(0,A.toDisposable)(()=>clearTimeout(g)))}else{let g;s.has(D)?g=0:(g=1,s.add(D)),this.onFileChange({resource:(0,L.joinPath)(t,D),type:g,cId:this.request.correlationId})}else if(d==="rename"||D!==h){const g=setTimeout(async()=>{const f=await y.Promises.exists(i);r.token.isCancellationRequested||(f?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(i,!1))):(this.onFileChange({resource:t,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},l.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,A.toDisposable)(()=>clearTimeout(g)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){await y.Promises.exists(i)&&!r.token.isCancellationRequested&&this.error(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.toDisposable)(()=>{r.dispose(!0),a.dispose()})}onFileChange(i,n=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.excludes.some(r=>r(i.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.includes&&this.includes.length>0&&!this.includes.some(r=>r(i.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${i.resource.fsPath}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const n=(0,_.coalesceEvents)(i);if(n.length>0){if(this.verboseLogging)for(const a of n)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(n)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(i){if(C.isLinux)return y.Promises.exists(i);try{const n=(0,E.basename)(i);return(await y.Promises.readdir((0,E.dirname)(i))).some(a=>a===n)}catch(n){return this.trace(n),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=l;async function b(o,i,n,r,a=512){const t=await y.Promises.open(o,"r"),h=Buffer.allocUnsafe(a),u=new p.CancellationTokenSource(r);let s,c=!1;const d={path:o,excludes:[],recursive:!1},m=new l(d,D=>{(async()=>{for(const{type:g}of D)if(g===0){if(c)return;c=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:f}=await y.Promises.read(t,h,0,a,null);if(!f||u.token.isCancellationRequested)break;i(h.slice(0,f))}}catch(f){s=new Error(f),u.dispose(!0)}finally{c=!1}}})()});return await m.ready,n(),new Promise((D,g)=>{u.token.onCancellationRequested(async()=>{m.dispose();try{await y.Promises.close(t)}catch(f){s=new Error(f)}s?g(s):D()})})}e.watchFileContents=b}),define(Ce[246],De([1,0,4,35,3,11,245]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends p.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new P.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=P.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(C){const L=this.normalizeRequests(C),I=L.filter(y=>{const _=this.watchers.get(y.path);return _?!(0,F.patternsEquals)(_.request.excludes,y.excludes)||!(0,F.patternsEquals)(_.request.includes,y.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:y})=>!L.find(_=>_.path===y.path&&(0,F.patternsEquals)(_.excludes,y.excludes)&&(0,F.patternsEquals)(_.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.trace(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.stopWatching(y);for(const y of I)this.startWatching(y)}startWatching(C){const L=new A.NodeJSFileWatcherLibrary(C,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),I={request:C,instance:L};this.watchers.set(C.path,I)}async stop(){for(const[C]of this.watchers)this.stopWatching(C);this.watchers.clear()}stopWatching(C){const L=this.watchers.get(C);L&&(this.watchers.delete(C),L.instance.dispose())}normalizeRequests(C){const L=new Map;for(const I of C){const v=R.isLinux?I.path:I.path.toLowerCase();let y=L.get(I.correlationId);y||(y=new Map,L.set(I.correlationId,y)),y.set(v,I)}return Array.from(L.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(C){this.verboseLogging=C;for(const[,L]of this.watchers)L.instance.setVerboseLogging(C)}trace(C){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C)})}toMessage(C,L){return L?`[File Watcher (node.js)] ${C} (path: ${L.request.path})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=w}),define(Ce[247],De([1,0,85,246]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class p extends P.AbstractNonRecursiveWatcherClient{constructor(A,w,E){super(A,w,E),this.init()}createWatcher(A){return A.add(new F.NodeJSWatcher)}}e.NodeJSWatcherClient=p}),define(Ce[248],De([1,0,16,81,188,85]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(E,C,L){super(E,C,L),this.init()}createWatcher(E){const C=E.add(new p.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(C.onDidProcessExit(({code:L,signal:I})=>this.onError(`terminated by itself with code ${L}, signal: ${I}`))),F.ProxyChannel.toService((0,F.getNextTickChannel)(C.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(Ce[106],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(...p){this._entries=new Map;for(const[R,A]of p)this.set(R,A)}set(p,R){const A=this._entries.get(p);return this._entries.set(p,R),A}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=P}),define(Ce[249],De([1,0,8,14,3,105,240,5,106,75]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class I extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class v{constructor(b=new E.ServiceCollection,o=!1,i,n=L){this._services=b,this._strict=o,this._parent=i,this._enableTracing=n,this._activeInstantiations=new Set,this._services.set(w.IInstantiationService,this),this._globalGraph=n?i?._globalGraph??new A.Graph(r=>r):void 0}createChild(b){return new v(b,this._strict,this,this._enableTracing)}invokeFunction(b,...o){const i=_.traceInvocation(this._enableTracing,b);let n=!1;try{return b({get:a=>{if(n)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(b,...o){let i,n;return b instanceof R.SyncDescriptor?(i=_.traceCreation(this._enableTracing,b.ctor),n=this._createInstance(b.ctor,b.staticArguments.concat(o),i)):(i=_.traceCreation(this._enableTracing,b),n=this._createInstance(b,o,i)),i.stop(),n}_createInstance(b,o=[],i){const n=w._util.getServiceDependencies(b).sort((t,h)=>t.index-h.index),r=[];for(const t of n){const h=this._getOrCreateServiceInstance(t.id,i);h||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(h)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${b.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(b,o.concat(r))}_setServiceInstance(b,o){if(this._services.get(b)instanceof R.SyncDescriptor)this._services.set(b,o);else if(this._parent)this._parent._setServiceInstance(b,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){const o=this._services.get(b);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):o}_getOrCreateServiceInstance(b,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(b));const i=this._getServiceInstanceOrDescriptor(b);return i instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,i,o.branch(b,!0)):(o.branch(b,!1),i)}_safeCreateAndCacheServiceInstance(b,o,i){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,o,i)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,o,i){const n=new A.Graph(t=>t.id.toString());let r=0;const a=[{id:b,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new I(n);for(const h of w._util.getServiceDependencies(t.desc.ctor)){const u=this._getServiceInstanceOrDescriptor(h.id);if(u||this._throwIfStrict(`[createInstance] ${b} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),u instanceof R.SyncDescriptor){const s={id:h.id,desc:u,_trace:t._trace.branch(h.id,!0)};n.insertEdge(t,s),a.push(s)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new I(n);break}for(const{data:h}of t){if(this._getServiceInstanceOrDescriptor(h.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,s)}n.removeNode(h)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,o,i=[],n,r){if(this._services.get(b)instanceof R.SyncDescriptor)return this._createServiceInstance(b,o,i,n,r);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(b,o,i=[],n,r){if(n){const a=new v(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(b);const t=new Map,h=new P.GlobalIdleValue(()=>{const u=a._createInstance(o,i,r);for(const[s,c]of t){const d=u[s];if(typeof d=="function")for(const m of c)m.disposable=d.apply(u,m.listener)}return t.clear(),u});return new Proxy(Object.create(null),{get(u,s){if(!h.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let m=t.get(s);return m||(m=new C.LinkedList,t.set(s,m)),(g,f,S)=>{if(h.isInitialized)return h.value[s](g,f,S);{const T={listener:[g,f,S],disposable:void 0},N=m.push(T);return(0,p.toDisposable)(()=>{N(),T.disposable?.dispose()})}}}if(s in u)return u[s];const c=h.value;let d=c[s];return typeof d!="function"||(d=d.bind(c),u[s]=d),d},set(u,s,c){return h.value[s]=c,!0},getPrototypeOf(u){return o.prototype}})}else return this._createInstance(o,i,r)}_throwIfStrict(b,o){if(o&&console.warn(b),this._strict)throw new Error(b)}}e.InstantiationService=v;var y;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(y||(y={}));class _{static{this.all=new Set}static{this._None=new class extends _{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,o){return b?new _(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):_._None}static traceCreation(b,o){return b?new _(1,o.name):_._None}static{this._totals=0}constructor(b,o){this.type=b,this.name=o,this._start=Date.now(),this._dep=[]}branch(b,o){const i=new _(3,b.toString());return this._dep.push([b,o,i]),i}stop(){const b=Date.now()-this._start;_._totals+=b;let o=!1;function i(r,a){const t=[],h=new Array(r+1).join("	");for(const[u,s,c]of a._dep)if(s&&c){o=!0,t.push(`${h}CREATES -> ${u}`);const d=i(r+1,c);d&&t.push(d)}else t.push(`${h}uses -> ${u}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(b>2||o)&&_.all.add(n.join(`
`))}}e.Trace=_}),define(Ce[13],De([1,0,40,4,54,3,28,11,23,18,2,45,5]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function y(){return new Date().toISOString()}function _(g){return(0,C.isNumber)(g)}e.isLogLevel=_;var l;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(l||(e.LogLevel=l={})),e.DEFAULT_LOG_LEVEL=l.Info;function b(g,f,S){switch(f){case l.Trace:g.trace(S);break;case l.Debug:g.debug(S);break;case l.Info:g.info(S);break;case l.Warning:g.warn(S);break;case l.Error:g.error(S);break;case l.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=b;function o(g,f=!1){let S="";for(let T=0;T<g.length;T++){let N=g[T];if(N instanceof Error&&(N=(0,P.toErrorMessage)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}S+=(T>0?" ":"")+N}return S}class i extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(f){this.level!==f&&(this.level=f,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(f){return this.level!==l.Off&&this.level<=f}}e.AbstractLogger=i;class n extends i{constructor(f){super(),this.logAlways=f}checkLogLevel(f){return this.logAlways||super.checkLogLevel(f)}trace(f,...S){this.checkLogLevel(l.Trace)&&this.log(l.Trace,o([f,...S],!0))}debug(f,...S){this.checkLogLevel(l.Debug)&&this.log(l.Debug,o([f,...S]))}info(f,...S){this.checkLogLevel(l.Info)&&this.log(l.Info,o([f,...S]))}warn(f,...S){this.checkLogLevel(l.Warning)&&this.log(l.Warning,o([f,...S]))}error(f,...S){if(this.checkLogLevel(l.Error))if(f instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=f.stack,this.log(l.Error,o(T))}else this.log(l.Error,o([f,...S]))}flush(){}}e.AbstractMessageLogger=n;class r extends i{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f),this.useColors=!w.isWindows}trace(f,...S){this.checkLogLevel(l.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...S):console.log(`[main ${y()}]`,f,...S))}debug(f,...S){this.checkLogLevel(l.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...S):console.log(`[main ${y()}]`,f,...S))}info(f,...S){this.checkLogLevel(l.Info)&&(this.useColors?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...S):console.log(`[main ${y()}]`,f,...S))}warn(f,...S){this.checkLogLevel(l.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,f,...S):console.warn(`[main ${y()}]`,f,...S))}error(f,...S){this.checkLogLevel(l.Error)&&(this.useColors?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,f,...S):console.error(`[main ${y()}]`,f,...S))}flush(){}}e.ConsoleMainLogger=r;class a extends i{constructor(f=e.DEFAULT_LOG_LEVEL,S=!0){super(),this.useColors=S,this.setLevel(f)}trace(f,...S){this.checkLogLevel(l.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",f,...S):console.log(f,...S))}debug(f,...S){this.checkLogLevel(l.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",f,...S):console.log(f,...S))}info(f,...S){this.checkLogLevel(l.Info)&&(this.useColors?console.log("%c INFO","color: #33f",f,...S):console.log(f,...S))}warn(f,...S){this.checkLogLevel(l.Warning)&&(this.useColors?console.log("%c WARN","color: #993",f,...S):console.log(f,...S))}error(f,...S){this.checkLogLevel(l.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",f,...S):console.error(f,...S))}flush(){}}e.ConsoleLogger=a;class t extends i{constructor(f,S=e.DEFAULT_LOG_LEVEL){super(),this.adapter=f,this.setLevel(S)}trace(f,...S){this.checkLogLevel(l.Trace)&&this.adapter.log(l.Trace,[this.extractMessage(f),...S])}debug(f,...S){this.checkLogLevel(l.Debug)&&this.adapter.log(l.Debug,[this.extractMessage(f),...S])}info(f,...S){this.checkLogLevel(l.Info)&&this.adapter.log(l.Info,[this.extractMessage(f),...S])}warn(f,...S){this.checkLogLevel(l.Warning)&&this.adapter.log(l.Warning,[this.extractMessage(f),...S])}error(f,...S){this.checkLogLevel(l.Error)&&this.adapter.log(l.Error,[this.extractMessage(f),...S])}extractMessage(f){return typeof f=="string"?f:(0,P.toErrorMessage)(f,this.checkLogLevel(l.Trace))}flush(){}}e.AdapterLogger=t;class h extends i{constructor(f){super(),this.loggers=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const S of this.loggers)S.setLevel(f);super.setLevel(f)}trace(f,...S){for(const T of this.loggers)T.trace(f,...S)}debug(f,...S){for(const T of this.loggers)T.debug(f,...S)}info(f,...S){for(const T of this.loggers)T.info(f,...S)}warn(f,...S){for(const T of this.loggers)T.warn(f,...S)}error(f,...S){for(const T of this.loggers)T.error(f,...S)}flush(){for(const f of this.loggers)f.flush()}dispose(){for(const f of this.loggers)f.dispose();super.dispose()}}e.MultiplexLogger=h;class u extends R.Disposable{constructor(f,S,T){if(super(),this.logLevel=f,this.logsHome=S,this._loggers=new A.ResourceMap,this._onDidChangeLoggers=this._register(new F.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const N of T)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(f){return(0,C.isString)(f)?[...this._loggers.values()].find(S=>S.info.id===f):this._loggers.get(f)}getLogger(f){return this.getLoggerEntry(f)?.logger}createLogger(f,S){const T=this.toResource(f),N=(0,C.isString)(f)?f:S?.id??(0,p.hash)(T.toString()).toString(16);let z=this._loggers.get(T)?.logger;const x=S?.logLevel==="always"?l.Trace:S?.logLevel;z||(z=this.doCreateLogger(T,x??this.getLogLevel(T)??this.logLevel,{...S,id:N}));const M={logger:z,info:{resource:T,id:N,logLevel:x,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(M.info),this._loggers.set(T,M),z}toResource(f){return(0,C.isString)(f)?(0,E.joinPath)(this.logsHome,`${f}.log`):f}setLogLevel(f,S){if(L.URI.isUri(f)){const T=f,N=S,z=this._loggers.get(T);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.logLevel?void 0:N,z.logger?.setLevel(N),this._loggers.set(z.info.resource,z),this._onDidChangeLogLevel.fire([T,N]))}else{this.logLevel=f;for(const[T,N]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(f,S){const T=this.getLoggerEntry(f);T&&S!==!T.info.hidden&&(T.info.hidden=!S,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,S]))}getLogLevel(f){let S;return f&&(S=this._loggers.get(f)?.info.logLevel),S??this.logLevel}registerLogger(f){const S=this._loggers.get(f.resource);S?S.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this._loggers.set(f.resource,{info:f,logger:void 0}),this._onDidChangeLoggers.fire({added:[f],removed:[]}))}deregisterLogger(f){const S=this._loggers.get(f);S&&(S.logger&&S.logger.dispose(),this._loggers.delete(f),this._onDidChangeLoggers.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const f of this._loggers.values())yield f.info}getRegisteredLogger(f){return this._loggers.get(f)?.info}dispose(){this._loggers.forEach(f=>f.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=u;class s{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(f){}getLevel(){return l.Info}trace(f,...S){}debug(f,...S){}info(f,...S){}warn(f,...S){}error(f,...S){}critical(f,...S){}dispose(){}flush(){}}e.NullLogger=s;class c extends s{}e.NullLogService=c;function d(g){if(g.verbose)return l.Trace;if(typeof g.logLevel=="string"){const f=D(g.logLevel.toLowerCase());if(f!==void 0)return f}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function m(g){switch(g){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.LogLevelToString=m;function D(g){switch(g){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",m(l.Info))}),define(Ce[250],De([1,0,19,8,14,4,3,17,85,13]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class L extends A.Disposable{constructor(v,y){super(),this.logService=v,this.options=y,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new F.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new F.ThrottledDelayer(0))}watch(v,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,y):this.watchNonRecursive(v,y)}watchUniversal(v,y){const _={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},l=(0,P.insert)(this.universalPathsToWatch,_);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{l(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,p.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,E.reviveFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(y)&&v.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,y){const _={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},l=(0,P.insert)(this.nonRecursivePathsToWatch,_);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{l(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,p.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,E.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,w.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=L}),define(Ce[251],De([1,0,57,390,8,28,21,4,34,3,17,11,23,98,31,206,32,244,250,40,248,247]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,F.gracefulify)(P)}catch(h){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(h)}`)}})();class t extends i.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(u,s){super(u,s),this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new R.ResourceMap(c=>v.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(u){try{const{stat:s,symbolicLink:c}=await _.SymlinkSupport.stat(this.toFilePath(u));return{type:this.toType(s,c),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:b.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const s=await _.Promises.readdir(this.toFilePath(u),{withFileTypes:!0}),c=[];return await Promise.all(s.map(async d=>{try{let m;d.isSymbolicLink()?m=(await this.stat((0,v.joinPath)(u,d.name))).type:m=this.toType(d),c.push([d.name,m])}catch(m){this.logService.trace(m)}})),c}catch(s){throw this.toFileSystemProviderError(s)}}toType(u,s){let c;return s?.dangling?c=b.FileType.Unknown:u.isFile()?c=b.FileType.File:u.isDirectory()?c=b.FileType.Directory:c=b.FileType.Unknown,s&&(c|=b.FileType.SymbolicLink),c}async createResourceLock(u){const s=this.toFilePath(u);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let c;for(;c=this.resourceLocks.get(u);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await c.wait();const d=new p.Barrier;return this.resourceLocks.set(u,d),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,C.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(u)===d&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(u)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),d.open()})}async readFile(u,s){let c;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(u)})`),c=await this.createResourceLock(u));const d=this.toFilePath(u);return await _.Promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}finally{c?.dispose()}}traceLock(u){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(u)}readFileStream(u,s,c){const d=(0,y.newWriteableStream)(m=>A.VSBuffer.concat(m.map(D=>A.VSBuffer.wrap(D))).buffer);return(0,o.readFileIntoStream)(this,u,d,m=>m.buffer,{...s,bufferSize:256*1024},c),d}async writeFile(u,s,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.canWriteFileAtomic(u)?this.doWriteFileAtomic(u,(0,v.joinPath)((0,v.dirname)(u),`${(0,v.basename)(u)}${c.atomic.postfix}`),s,c):this.doWriteFile(u,s,c)}async canWriteFileAtomic(u){try{const s=this.toFilePath(u),{symbolicLink:c}=await _.SymlinkSupport.stat(s);if(c)return!1}catch{}return!0}async doWriteFileAtomic(u,s,c,d){const m=new C.DisposableStore;try{m.add(await this.createResourceLock(u)),m.add(await this.createResourceLock(s)),await this.doWriteFile(s,c,d,!0);try{await this.rename(s,u,{overwrite:!0})}catch(D){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{m.dispose()}}async doWriteFile(u,s,c,d){let m;try{const D=this.toFilePath(u);if(!c.create||!c.overwrite){if(await _.Promises.exists(D)){if(!c.overwrite)throw(0,b.createFileSystemProviderError)((0,l.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,b.createFileSystemProviderError)((0,l.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(u,{create:!0,unlock:c.unlock},d),await this.write(m,0,s,0,s.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(u,D)}finally{typeof m=="number"&&await this.close(m)}}static{this.canFlush=!0}static configureFlushOnWrite(u){t.canFlush=u}async open(u,s,c){const d=this.toFilePath(u);let m;(0,b.isFileOpenForWriteOptions)(s)&&!c&&(m=await this.createResourceLock(u));let D;try{if((0,b.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:f}=await _.SymlinkSupport.stat(d);f.mode&128||await _.Promises.chmod(d,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}let g;if((0,b.isFileOpenForWriteOptions)(s)){if(I.isWindows)try{await _.Promises.truncate(d,0),g="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}g||(g="w")}else g="r";D=await _.Promises.open(d,g)}catch(g){throw m?.dispose(),(0,b.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(u,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(D,0),(0,b.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(D,u),m){const g=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${d})`),this.mapHandleToLock.set(D,m),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${d})`),g.dispose())}return D}async close(u){const s=this.mapHandleToLock.get(u);try{if(this.mapHandleToPos.delete(u),this.writeHandles.delete(u)&&t.canFlush)try{await _.Promises.fdatasync(u)}catch(c){t.configureFlushOnWrite(!1),this.logService.error(c)}return await _.Promises.close(u)}catch(c){throw this.toFileSystemProviderError(c)}finally{s&&(this.mapHandleToLock.get(u)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.mapHandleToLock.delete(u)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),s.dispose())}}async read(u,s,c,d,m){const D=this.normalizePos(u,s);let g=null;try{g=(await _.Promises.read(u,c,d,m,D)).bytesRead}catch(f){throw this.toFileSystemProviderError(f)}finally{this.updatePos(u,D,g)}return g}normalizePos(u,s){return s===this.mapHandleToPos.get(u)?null:s}updatePos(u,s,c){const d=this.mapHandleToPos.get(u);typeof d=="number"&&(typeof s=="number"||(typeof c=="number"?this.mapHandleToPos.set(u,d+c):this.mapHandleToPos.delete(u)))}async write(u,s,c,d,m){return(0,p.retry)(()=>this.doWrite(u,s,c,d,m),100,3)}async doWrite(u,s,c,d,m){const D=this.normalizePos(u,s);let g=null;try{g=(await _.Promises.write(u,c,d,m,D)).bytesWritten}catch(f){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(u),f)}finally{this.updatePos(u,D,g)}return g}async mkdir(u){try{await _.Promises.mkdir(this.toFilePath(u))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(u,s){try{const c=this.toFilePath(u);if(s.recursive){let d;s?.atomic!==!1&&s.atomic.postfix&&(d=(0,L.join)((0,L.dirname)(c),`${(0,L.basename)(c)}${s.atomic.postfix}`)),await _.Promises.rm(c,_.RimRafMode.MOVE,d)}else try{await _.Promises.unlink(c)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let m=!1;try{const{stat:D,symbolicLink:g}=await _.SymlinkSupport.stat(c);m=D.isDirectory()&&!g}catch{}if(m)await _.Promises.rmdir(c);else throw d}else throw d}}catch(c){throw this.toFileSystemProviderError(c)}}async rename(u,s,c){const d=this.toFilePath(u),m=this.toFilePath(s);if(d!==m)try{await this.validateMoveCopy(u,s,"move",c.overwrite),await _.Promises.rename(d,m)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(2,null,(0,L.basename)(d),(0,L.basename)((0,L.dirname)(m)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(u,s,c){const d=this.toFilePath(u),m=this.toFilePath(s);if(d!==m)try{await this.validateMoveCopy(u,s,"copy",c.overwrite),await _.Promises.copy(d,m,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(3,null,(0,L.basename)(d),(0,L.basename)((0,L.dirname)(m)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(u,s,c,d){const m=this.toFilePath(u),D=this.toFilePath(s);let g=!1;if(!!(this.capabilities&1024)||(g=(0,E.isEqual)(m,D,!0)),g){if(c==="copy")throw(0,b.createFileSystemProviderError)((0,l.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const S=await this.statIgnoreError(u);if(!S)throw(0,b.createFileSystemProviderError)((0,l.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(s);if(T){if(!d)throw(0,b.createFileSystemProviderError)((0,l.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);S.type&b.FileType.File&&T.type&b.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,s){return this.doCloneFile(u,s,!1)}async doCloneFile(u,s,c){const d=this.toFilePath(u),m=this.toFilePath(s),D=!!(this.capabilities&1024);if((0,E.isEqual)(d,m,!D))return;const g=new C.DisposableStore;try{g.add(await this.createResourceLock(u)),g.add(await this.createResourceLock(s)),c&&await _.Promises.mkdir((0,L.dirname)(m),{recursive:!0}),await _.Promises.copyFile(d,m)}catch(f){if(f.code==="ENOENT"&&!c)return this.doCloneFile(u,s,!0);throw this.toFileSystemProviderError(f)}finally{g.dispose()}}createUniversalWatcher(u,s,c){return new r.UniversalWatcherClient(d=>u(d),d=>s(d),c)}createNonRecursiveWatcher(u,s,c){return new a.NodeJSWatcherClient(d=>u(d),d=>s(d),c)}toFileSystemProviderError(u){if(u instanceof b.FileSystemProviderError)return u;let s=u,c;switch(u.code){case"ENOENT":c=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=b.FileSystemProviderErrorCode.Unknown;break;default:c=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(s,c)}async toFileSystemProviderWriteError(u,s){let c=this.toFileSystemProviderError(s);if(u&&c.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await _.SymlinkSupport.stat(this.toFilePath(u));d.mode&128||(c=(0,b.createFileSystemProviderError)(s,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return c}}e.DiskFileSystemProvider=t}),define(Ce[252],De([1,0,3,13]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class p extends P.Disposable{constructor(A,w=[]){super(),this.logger=new F.MultiplexLogger([A,...w]),this._register(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...w){this.logger.trace(A,...w)}debug(A,...w){this.logger.debug(A,...w)}info(A,...w){this.logger.info(A,...w)}warn(A,...w){this.logger.warn(A,...w)}error(A,...w){this.logger.error(A,...w)}flush(){this.logger.flush()}}e.LogService=p}),define(Ce[253],De([1,0,32,13]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var p;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(p||(p={}));async function R(C,L,I,v,y){try{const _=await new Promise((b,o)=>{me(["@vscode/spdlog"],b,o)});_.setFlushOn(p.Trace);const l=await _.createAsyncRotatingLogger(C,L,I,v);return y?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(_){console.error(_)}return null}function A(C,L,I){switch(L){case F.LogLevel.Trace:C.trace(I);break;case F.LogLevel.Debug:C.debug(I);break;case F.LogLevel.Info:C.info(I);break;case F.LogLevel.Warning:C.warn(I);break;case F.LogLevel.Error:C.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function w(C,L){switch(L){case F.LogLevel.Trace:C.setLevel(p.Trace);break;case F.LogLevel.Debug:C.setLevel(p.Debug);break;case F.LogLevel.Info:C.setLevel(p.Info);break;case F.LogLevel.Warning:C.setLevel(p.Warning);break;case F.LogLevel.Error:C.setLevel(p.Error);break;case F.LogLevel.Off:C.setLevel(p.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class E extends F.AbstractMessageLogger{constructor(L,I,v,y,_){super(),this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(L,I,v,y),this._register(this.onDidChangeLogLevel(l=>{this._logger&&w(this._logger,l)}))}async _createSpdLogLogger(L,I,v,y){const _=v?6:1,l=30/_*P.ByteSize.MB,b=await R(L,I,l,_,y);if(b){this._logger=b,w(this._logger,this.getLevel());for(const{level:o,message:i}of this.buffer)A(this._logger,o,i);this.buffer=[]}}log(L,I){this._logger?A(this._logger,L,I):this.getLevel()<=L&&this.buffer.push({level:L,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=E}),define(Ce[135],De([1,0,39,207,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function C(_,l){return l-_}E.compare=C;const L=Object.create(null);L[E.Error]=(0,F.localize)(0,null),L[E.Warning]=(0,F.localize)(1,null),L[E.Info]=(0,F.localize)(2,null);function I(_){return L[_]||""}E.toString=I;function v(_){switch(_){case P.default.Error:return E.Error;case P.default.Warning:return E.Warning;case P.default.Info:return E.Info;case P.default.Ignore:return E.Hint}}E.fromSeverity=v;function y(_){switch(_){case E.Error:return P.default.Error;case E.Warning:return P.default.Warning;case E.Info:return P.default.Info;case E.Hint:return P.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var w;(function(E){const C="";function L(v){return I(v,!0)}E.makeKey=L;function I(v,y){const _=[C];return v.source?_.push(v.source.replace("\xA6","\\\xA6")):_.push(C),v.code?typeof v.code=="string"?_.push(v.code.replace("\xA6","\\\xA6")):_.push(v.code.value.replace("\xA6","\\\xA6")):_.push(C),v.severity!==void 0&&v.severity!==null?_.push(A.toString(v.severity)):_.push(C),v.message&&y?_.push(v.message.replace("\xA6","\\\xA6")):_.push(C),v.startLineNumber!==void 0&&v.startLineNumber!==null?_.push(v.startLineNumber.toString()):_.push(C),v.startColumn!==void 0&&v.startColumn!==null?_.push(v.startColumn.toString()):_.push(C),v.endLineNumber!==void 0&&v.endLineNumber!==null?_.push(v.endLineNumber.toString()):_.push(C),v.endColumn!==void 0&&v.endColumn!==null?_.push(v.endColumn.toString()):_.push(C),_.push(C),_.join("\xA6")}E.makeKeyOptionalMessage=I})(w||(e.IMarkerData=w={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(Ce[254],De([1,0,4,39,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.isNotificationSource=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,p.createDecorator)("notificationService");var R;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function w(I){if(I){const v=I;return typeof v.id=="string"&&typeof v.label=="string"}return!1}e.isNotificationSource=w;var E;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})(E||(e.NotificationsFilter=E={}));class C{constructor(){this.progress=new L,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(v){}updateMessage(v){}updateActions(v){}close(){}}e.NoOpNotification=C;class L{infinite(){}done(){}total(v){}worked(v){}}e.NoOpProgress=L}),define(Ce[255],De([1,0,50]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.context<"u"){const R=p.context.configuration();if(R)F=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){F=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:R,searchUrl:A,itemUrl:w,controlUrl:E}=F.extensionsGallery||{};Object.assign(F,{extensionsGallery:{serviceUrl:P.env.VSCODE_GALLERY_SERVICE_URL||R,searchUrl:P.env.VSCODE_GALLERY_SEARCH_URL||A,itemUrl:P.env.VSCODE_GALLERY_ITEM_URL||w,controlUrl:P.env.VSCODE_GALLERY_CONTROL_URL||E}});try{const C=(...I)=>I.reduce((v,y)=>(Object.keys(y).forEach(_=>{Array.isArray(v[_])&&Array.isArray(y[_])?v[_]=y[_]:typeof v[_]=="object"&&typeof y[_]=="object"?v[_]=C(v[_],y[_]):v[_]=y[_]}),v),{}),L=globalThis._VSCODE_USER_PRODUCT_JSON||{};F=C(F,L)}catch{}if(P.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:C.version,release:C.release})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(Ce[136],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(me,e){return function(P,F){e(P,F,me)}};define(Ce[107],De([1,0,8,22,3,5]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var A;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(v){this.callback=v}report(v){this._value=v,this.callback(this._value)}}e.Progress=w;class E{get value(){return this._value}constructor(v){this.callback=v}report(v){this._asyncQueue?this._asyncQueue.push(v):this._asyncQueue=[v],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const v=this._asyncQueue.shift();this._value=v,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const v=this._drainListener;this._drainListener=void 0,v?.()}}drain(){return this._processingAsyncQueue?new Promise(v=>{const y=this._drainListener;this._drainListener=()=>{y?.(),v()}}):Promise.resolve()}}e.AsyncProgress=E;let C=class extends p.Disposable{constructor(v,y){super(),this.deferred=new P.DeferredPromise,y.withProgress(v,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,p.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};e.UnmanagedProgress=C,e.UnmanagedProgress=C=Ge([He(1,e.IProgressService)],C);class L extends p.Disposable{constructor(v){super(),this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new p.DisposableStore)}start(v){this.stop();const y=++this.currentOperationId,_=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{y===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,p.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,p.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,p.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:y,token:_.token,stop:()=>this.doStop(y),isCurrent:()=>this.currentOperationId===y}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=L,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(Ce[37],De([1,0,61,18]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(A,w){P.ok(F.isString(A)),P.ok(F.isObject(w)),P.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,w)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new p}),define(Ce[108],De([1,0,4,37]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class R{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[p(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new R;F.Registry.add(e.Extensions.JSONContribution,A)}),define(Ce[86],De([1,0,19,4,18,197,52,108,37]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(C||(e.EditPresentationTypes=C={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=E.Registry.as(w.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const u=new Set;this.doRegisterConfigurations(t,h,u),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}deregisterConfigurations(t){const h=new Set;this.doDeregisterConfigurations(t,h),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}updateConfigurations({add:t,remove:h}){const u=new Set;this.doDeregisterConfigurations(h,u),this.doRegisterConfigurations(t,!1,u),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}registerDefaultConfigurations(t){const h=new Set;this.doRegisterDefaultConfigurations(t,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,h){const u=[];for(const{overrides:s,source:c}of t)for(const d in s)if(h.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const m=this.configurationDefaultsOverrides.get(d),D=m?.valuesSources??new Map;if(c)for(const T of Object.keys(s[d]))D.set(T,c);const g={...m?.value||{},...s[d]};this.configurationDefaultsOverrides.set(d,{source:c,value:g,valuesSources:D});const f=(0,A.getLanguageTagSettingPlainKey)(d),S={type:"object",default:g,description:R.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:p.isString(c)?void 0:c,defaultValueSource:c};u.push(...l(d)),this.configurationProperties[d]=S,this.defaultLanguageConfigurationOverridesNode.properties[d]=S}else{this.configurationDefaultsOverrides.set(d,{value:s[d],source:c});const m=this.configurationProperties[d];m&&(this.updatePropertyDefaultValue(d,m),this.updateSchema(d,m))}this.doRegisterOverrideIdentifiers(u)}deregisterDefaultConfigurations(t){const h=new Set;this.doDeregisterDefaultConfigurations(t,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,h){for(const{overrides:u,source:s}of t)for(const c in u){const d=this.configurationDefaultsOverrides.get(c),m=p.isString(s)?s:s?.id,D=p.isString(d?.source)?d?.source:d?.source?.id;if(m===D)if(h.add(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const g=this.configurationProperties[c];g&&(this.updatePropertyDefaultValue(c,g),this.updateSchema(c,g))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let h=!1;const u=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,u),h=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,u),h=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,u),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const h of t)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,h,u){t.forEach(s=>{this.validateAndRegisterProperties(s,h,s.extensionInfo,s.restrictedProperties,void 0,u),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(t,h){const u=s=>{if(s.properties)for(const c in s.properties){h.add(c);const d=this.configurationProperties[c];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,s.properties[c])}s.allOf?.forEach(c=>u(c))};for(const s of t){u(s);const c=this.configurationContributors.indexOf(s);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(t,h=!0,u,s,c=3,d){c=p.isUndefinedOrNull(t.scope)?c:t.scope;const m=t.properties;if(m)for(const g in m){const f=m[g];if(h&&n(g,f)){delete m[g];continue}if(f.source=u,f.defaultDefaultValue=m[g].default,this.updatePropertyDefaultValue(g,f),e.OVERRIDE_PROPERTY_REGEX.test(g)?f.scope=void 0:(f.scope=p.isUndefinedOrNull(f.scope)?c:f.scope,f.restricted=p.isUndefinedOrNull(f.restricted)?!!s?.includes(g):f.restricted),m[g].hasOwnProperty("included")&&!m[g].included){this.excludedConfigurationProperties[g]=m[g],delete m[g];continue}else this.configurationProperties[g]=m[g],m[g].policy?.name&&this.policyConfigurations.set(m[g].policy.name,g);!m[g].deprecationMessage&&m[g].markdownDeprecationMessage&&(m[g].deprecationMessage=m[g].markdownDeprecationMessage),d.add(g)}const D=t.allOf;if(D)for(const g of D)this.validateAndRegisterProperties(g,h,u,s,c,d)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const h=u=>{const s=u.properties;if(s)for(const d in s)this.updateSchema(d,s[d]);u.allOf?.forEach(h)};h(t)}updateSchema(t,h){switch(e.allSettings.properties[t]=h,h.scope){case 1:e.applicationSettings.properties[t]=h;break;case 2:e.machineSettings.properties[t]=h;break;case 6:e.machineOverridableSettings.properties[t]=h;break;case 3:e.windowSettings.properties[t]=h;break;case 4:e.resourceSettings.properties[t]=h;break;case 5:e.resourceSettings.properties[t]=h,this.resourceLanguageSettingsSchema.properties[t]=h;break}}removeFromSchema(t,h){switch(delete e.allSettings.properties[t],h.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const h=`[${t}]`,u={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,u),e.allSettings.properties[h]=u,e.applicationSettings.properties[h]=u,e.machineSettings.properties[h]=u,e.machineOverridableSettings.properties[h]=u,e.windowSettings.properties[h]=u,e.resourceSettings.properties[h]=u}}registerOverridePropertyPatternKey(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,h){const u=this.configurationDefaultsOverrides.get(t);let s=u?.value,c=u?.source;p.isUndefined(s)&&(s=h.defaultDefaultValue,c=void 0),p.isUndefined(s)&&(s=o(h.type)),h.default=s,h.defaultValueSource=c}}const y="\\[([^\\]]+)\\]",_=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let h=_.exec(a);for(;h?.length;){const u=h[1].trim();u&&t.push(u),h=_.exec(a)}}return(0,P.distinct)(t)}e.overrideIdentifiersFromKey=l;function b(a){return a.reduce((t,h)=>`${t}[${h}]`,"")}e.keyFromOverrideIdentifiers=b;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const i=new v;E.Registry.add(e.Extensions.Configuration,i);function n(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?R.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=n;function r(){const a=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))a.push([h,t[h].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=r}),define(Ce[256],De([1,0,19,4,160,3,28,24,18,2,52,86,37]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function y(h){return Object.isFrozen(h)?h:w.deepFreeze(h)}class _{constructor(u={},s=[],c=[],d){this._contents=u,this._keys=s,this._overrides=c,this.raw=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(s=>{if(s instanceof _)return s;const c=new l("");return c.parseRaw(s),c.configurationModel});this._rawConfiguration=u.reduce((s,c)=>c===s?c:s.merge(c),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(u){return u?(0,L.getConfigurationValue)(this.contents,u):this.contents}inspect(u,s){const c=this;return{get value(){return y(c.rawConfiguration.getValue(u))},get override(){return s?y(c.rawConfiguration.getOverrideValue(u,s)):void 0},get merged(){return y(s?c.rawConfiguration.override(s).getValue(u):c.rawConfiguration.getValue(u))},get overrides(){const d=[];for(const{contents:m,identifiers:D,keys:g}of c.rawConfiguration.overrides){const f=new _(m,g).getValue(u);f!==void 0&&d.push({identifiers:D,value:f})}return d.length?y(d):void 0}}}getOverrideValue(u,s){const c=this.getContentsForOverrideIdentifer(s);return c?u?(0,L.getConfigurationValue)(c,u):c:void 0}getKeysForOverrideIdentifier(u){const s=[];for(const c of this.overrides)c.identifiers.includes(u)&&s.push(...c.keys);return P.distinct(s)}getAllOverrideIdentifiers(){const u=[];for(const s of this.overrides)u.push(...s.identifiers);return P.distinct(u)}override(u){let s=this.overrideConfigurations.get(u);return s||(s=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,s)),s}merge(...u){const s=w.deepClone(this.contents),c=w.deepClone(this.overrides),d=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const D of u)if(m.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(s,D.contents);for(const g of D.overrides){const[f]=c.filter(S=>P.equals(S.identifiers,g.identifiers));f?(this.mergeContents(f.contents,g.contents),f.keys.push(...g.keys),f.keys=P.distinct(f.keys)):c.push(w.deepClone(g))}for(const g of D.keys)d.indexOf(g)===-1&&d.push(g)}return new _(s,d,c,m.every(D=>D instanceof _)?void 0:m)}createOverrideConfigurationModel(u){const s=this.getContentsForOverrideIdentifer(u);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const c={};for(const d of P.distinct([...Object.keys(this.contents),...Object.keys(s)])){let m=this.contents[d];const D=s[d];D&&(typeof m=="object"&&typeof D=="object"?(m=w.deepClone(m),this.mergeContents(m,D)):m=D),c[d]=m}return new _(c,this.keys,this.overrides)}mergeContents(u,s){for(const c of Object.keys(s)){if(c in u&&E.isObject(u[c])&&E.isObject(s[c])){this.mergeContents(u[c],s[c]);continue}u[c]=w.deepClone(s[c])}}getContentsForOverrideIdentifer(u){let s=null,c=null;const d=m=>{m&&(c?this.mergeContents(c,m):c=w.deepClone(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===u?s=m.contents:m.identifiers.includes(u)&&d(m.contents);return d(s),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,s){this.updateValue(u,s,!0)}setValue(u,s){this.updateValue(u,s,!1)}removeValue(u){const s=this.keys.indexOf(u);s!==-1&&(this.keys.splice(s,1),(0,L.removeFromValueTree)(this.contents,u),I.OVERRIDE_PROPERTY_REGEX.test(u)&&this.overrides.splice(this.overrides.findIndex(c=>P.equals(c.identifiers,(0,I.overrideIdentifiersFromKey)(u))),1))}updateValue(u,s,c){(0,L.addToValueTree)(this.contents,u,s,d=>console.error(d)),c=c||this.keys.indexOf(u)===-1,c&&this.keys.push(u),I.OVERRIDE_PROPERTY_REGEX.test(u)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(u),keys:Object.keys(this.contents[u]),contents:(0,L.toValuesTree)(this.contents[u],d=>console.error(d))})}}e.ConfigurationModel=_;class l{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,s){if(!E.isUndefinedOrNull(u)){const c=this.doParseContent(u);this.parseRaw(c,s)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,s){this._raw=u;const{contents:c,keys:d,overrides:m,restricted:D,hasExcludedProperties:g}=this.doParseRaw(u,s);this._configurationModel=new _(c,d,m,g?[u]:void 0),this._restrictedConfigurations=D||[]}doParseContent(u){let s={},c=null,d=[];const m=[],D=[];function g(S){Array.isArray(d)?d.push(S):c!==null&&(d[c]=S)}const f={onObjectBegin:()=>{const S={};g(S),m.push(d),d=S,c=null},onObjectProperty:S=>{c=S},onObjectEnd:()=>{d=m.pop()},onArrayBegin:()=>{const S=[];g(S),m.push(d),d=S,c=null},onArrayEnd:()=>{d=m.pop()},onLiteralValue:g,onError:(S,T,N)=>{D.push({error:S,offset:T,length:N})}};if(u)try{p.visit(u,f),s=d[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return s}doParseRaw(u,s){const c=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(u,c,!0,s);u=d.raw;const m=(0,L.toValuesTree)(u,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),D=Object.keys(u),g=this.toOverrides(u,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:m,keys:D,overrides:g,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}filter(u,s,c,d){let m=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:m};const D={},g=[];for(const f in u)if(I.OVERRIDE_PROPERTY_REGEX.test(f)&&c){const S=this.filter(u[f],s,!1,d);D[f]=S.raw,m=m||S.hasExcludedProperties,g.push(...S.restricted)}else{const S=s[f],T=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&g.push(f),!d.exclude?.includes(f)&&(d.include?.includes(f)||(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&!(d.skipRestricted&&S?.restricted))?D[f]=u[f]:m=!0}return{raw:D,restricted:g,hasExcludedProperties:m}}toOverrides(u,s){const c=[];for(const d of Object.keys(u))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const m={};for(const D in u[d])m[D]=u[d][D];c.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(m),contents:(0,L.toValuesTree)(m,s)})}return c}}e.ConfigurationModelParser=l;class b extends R.Disposable{constructor(u,s,c,d){super(),this.userSettingsResource=u,this.parseOptions=s,this.fileService=d,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.any(F.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource)),F.Event.filter(this.fileService.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&c.isEqual(m.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(u){return u&&(this.parseOptions=u),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class o{constructor(u,s,c,d,m,D,g,f,S,T,N,z,x){this.key=u,this.overrides=s,this._value=c,this.overrideIdentifiers=d,this.defaultConfiguration=m,this.policyConfiguration=D,this.applicationConfiguration=g,this.userConfiguration=f,this.localUserConfiguration=S,this.remoteUserConfiguration=T,this.workspaceConfiguration=N,this.folderConfigurationModel=z,this.memoryConfigurationModel=x}get value(){return y(this._value)}toInspectValue(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(u,s,c,d,m=new _,D=new _,g=new A.ResourceMap,f=new _,S=new A.ResourceMap){this._defaultConfiguration=u,this._policyConfiguration=s,this._applicationConfiguration=c,this._localUserConfiguration=d,this._remoteUserConfiguration=m,this._workspaceConfiguration=D,this._folderConfigurations=g,this._memoryConfiguration=f,this._memoryConfigurationByResource=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(u,s,c){return this.getConsolidatedConfigurationModel(u,s,c).getValue(u)}updateValue(u,s,c={}){let d;c.resource?(d=this._memoryConfigurationByResource.get(c.resource),d||(d=new _,this._memoryConfigurationByResource.set(c.resource,d))):d=this._memoryConfiguration,s===void 0?d.removeValue(u):d.setValue(u,s),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,s,c){const d=this.getConsolidatedConfigurationModel(u,s,c),m=this.getFolderConfigurationModelForResource(s.resource,c),D=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,g=new Set;for(const f of d.overrides)for(const S of f.identifiers)d.getOverrideValue(u,S)!==void 0&&g.add(S);return new o(u,s,d.getValue(u),g.size?[...g]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this._workspaceConfiguration:void 0,m||void 0,D)}keys(u){const s=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,s){this._folderConfigurations.set(u,s),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,s){const c=[];if(!s){const{added:d,updated:m,removed:D}=a(this._defaultConfiguration,u);s=[...d,...m,...D]}for(const d of s)for(const m of(0,I.overrideIdentifiersFromKey)(d)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(m),g=u.getKeysForOverrideIdentifier(m),f=[...g.filter(S=>D.indexOf(S)===-1),...D.filter(S=>g.indexOf(S)===-1),...D.filter(S=>!w.equals(this._defaultConfiguration.override(m).getValue(S),u.override(m).getValue(S)))];c.push([m,f])}return this.updateDefaultConfiguration(u),{keys:s,overrides:c}}compareAndUpdatePolicyConfiguration(u){const{added:s,updated:c,removed:d}=a(this._policyConfiguration,u),m=[...s,...c,...d];return m.length&&this.updatePolicyConfiguration(u),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:s,updated:c,removed:d,overrides:m}=a(this.applicationConfiguration,u),D=[...s,...c,...d];return D.length&&this.updateApplicationConfiguration(u),{keys:D,overrides:m}}compareAndUpdateLocalUserConfiguration(u){const{added:s,updated:c,removed:d,overrides:m}=a(this.localUserConfiguration,u),D=[...s,...c,...d];return D.length&&this.updateLocalUserConfiguration(u),{keys:D,overrides:m}}compareAndUpdateRemoteUserConfiguration(u){const{added:s,updated:c,removed:d,overrides:m}=a(this.remoteUserConfiguration,u),D=[...s,...c,...d];return D.length&&this.updateRemoteUserConfiguration(u),{keys:D,overrides:m}}compareAndUpdateWorkspaceConfiguration(u){const{added:s,updated:c,removed:d,overrides:m}=a(this.workspaceConfiguration,u),D=[...s,...c,...d];return D.length&&this.updateWorkspaceConfiguration(u),{keys:D,overrides:m}}compareAndUpdateFolderConfiguration(u,s){const c=this.folderConfigurations.get(u),{added:d,updated:m,removed:D,overrides:g}=a(c,s),f=[...d,...m,...D];return(f.length||!c)&&this.updateFolderConfiguration(u,s),{keys:f,overrides:g}}compareAndDeleteFolderConfiguration(u){const s=this.folderConfigurations.get(u);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:c,updated:d,removed:m,overrides:D}=a(s,void 0);return{keys:[...c,...d,...m],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,s,c){let d=this.getConsolidatedConfigurationModelForResource(s,c);return s.overrideIdentifier&&(d=d.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(d=d.merge(this._policyConfiguration)),d}getConsolidatedConfigurationModelForResource({resource:u},s){let c=this.getWorkspaceConsolidatedConfiguration();if(s&&u){const d=s.getFolder(u);d&&(c=this.getFolderConsolidatedConfiguration(d.uri)||c);const m=this._memoryConfigurationByResource.get(u);m&&(c=c.merge(m))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let s=this._foldersConsolidatedConfigurations.get(u);if(!s){const c=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(u);d?(s=c.merge(d),this._foldersConsolidatedConfigurations.set(u,s)):s=c}return s}getFolderConfigurationModelForResource(u,s){if(s&&u){const c=s.getFolder(u);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,s)=>{const{contents:c,overrides:d,keys:m}=this._folderConfigurations.get(s);return u.push([s,{contents:c,overrides:d,keys:m}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.keys.forEach(s=>u.add(s)),this.userConfiguration.keys.forEach(s=>u.add(s)),this._workspaceConfiguration.keys.forEach(s=>u.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(c=>u.add(c))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>u.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>u.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>u.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(c=>u.add(c))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(c=>s.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(c=>s.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(c=>s.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(u).forEach(d=>s.add(d))),[...s.values()]}static parse(u){const s=this.parseConfigurationModel(u.defaults),c=this.parseConfigurationModel(u.policy),d=this.parseConfigurationModel(u.application),m=this.parseConfigurationModel(u.user),D=this.parseConfigurationModel(u.workspace),g=u.folders.reduce((f,S)=>(f.set(C.URI.revive(S[0]),this.parseConfigurationModel(S[1])),f),new A.ResourceMap);return new i(s,c,d,m,new _,D,g,new _,new A.ResourceMap)}static parseConfigurationModel(u){return new _(u.contents,u.keys,u.overrides)}}e.Configuration=i;function n(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const u=new Set,s=new Map;for(const d of h)d.keys.forEach(m=>u.add(m)),d.overrides.forEach(([m,D])=>{const g=(0,A.getOrSet)(s,m,new Set);D.forEach(f=>g.add(f))});const c=[];return s.forEach((d,m)=>c.push([m,[...d.values()]])),{keys:[...u.values()],overrides:c}}e.mergeChanges=n;class r{constructor(u,s,c,d){this.change=u,this.previous=s,this.currentConfiguraiton=c,this.currentWorkspace=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const m of u.keys)this.affectedKeys.add(m);for(const[,m]of u.overrides)for(const D of m)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const m of this.affectedKeys)this._affectsConfigStr+=m+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,s){const c=this._marker+u,d=this._affectsConfigStr.indexOf(c);if(d<0)return!1;const m=d+c.length;if(m>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(m);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(s){const g=this.previousConfiguration?this.previousConfiguration.getValue(u,s,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(u,s,this.currentWorkspace);return!w.equals(g,f)}return!0}}e.ConfigurationChangeEvent=r;function a(h,u){const{added:s,removed:c,updated:d}=t(u?.rawConfiguration,h?.rawConfiguration),m=[],D=h?.getAllOverrideIdentifiers()||[],g=u?.getAllOverrideIdentifiers()||[];if(u){const f=g.filter(S=>!D.includes(S));for(const S of f)m.push([S,u.getKeysForOverrideIdentifier(S)])}if(h){const f=D.filter(S=>!g.includes(S));for(const S of f)m.push([S,h.getKeysForOverrideIdentifier(S)])}if(u&&h){for(const f of D)if(g.includes(f)){const S=t({contents:h.getOverrideValue(void 0,f)||{},keys:h.getKeysForOverrideIdentifier(f)},{contents:u.getOverrideValue(void 0,f)||{},keys:u.getKeysForOverrideIdentifier(f)});m.push([f,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:c,updated:d,overrides:m}}function t(h,u){const s=h?u?h.keys.filter(m=>u.keys.indexOf(m)===-1):[...h.keys]:[],c=u?h?u.keys.filter(m=>h.keys.indexOf(m)===-1):[...u.keys]:[],d=[];if(h&&u){for(const m of u.keys)if(h.keys.indexOf(m)!==-1){const D=(0,L.getConfigurationValue)(u.contents,m),g=(0,L.getConfigurationValue)(h.contents,m);w.equals(D,g)||d.push(m)}}return{added:s,removed:c,updated:d}}}),define(Ce[257],De([1,0,21,4,3,82]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const A=(C,L,I)=>{const v=new Uint8Array(16);for(let l=0;l<16;l++)v[l]=Math.round(Math.random()*256);const y=(0,P.encodeBase64)(P.VSBuffer.wrap(v));return[`GET ws://localhost${C}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=A,e.socketRawEndHeaderSequence=P.VSBuffer.fromString(`\r
\r
`);async function w(C,L,I,v,y){C.write(P.VSBuffer.fromString((0,e.makeRawSocketHeaders)(L,I,v)));const _=new p.DisposableStore;try{return await new Promise((l,b)=>{let o;_.add(C.onData(i=>{o?o=P.VSBuffer.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.socketRawEndHeaderSequence);if(n===-1)return;l(C),C.pauseData();const r=o.slice(n+e.socketRawEndHeaderSequence.byteLength);r.byteLength&&y.onData.fire(r)})),_.add(C.onClose(i=>b(i??new Error("socket closed")))),_.add(C.onEnd(()=>b(new Error("socket ended"))))})}catch(l){throw C.dispose(),l}finally{_.dispose()}}e.connectManagedSocket=w;class E extends p.Disposable{constructor(L,I){super(),this.debugLabel=L,this.pausableDataEmitter=this._register(new F.PauseableEmitter),this.onData=(...v)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...v)),this.didDisposeEmitter=this._register(new F.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(I.onData),this._register(I.onData.event(v=>this.pausableDataEmitter.fire(v))),this.onClose=this._register(I.onClose).event,this.onEnd=this._register(I.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(L,I){R.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,L,I)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=E}),define(Ce[64],De([1,0,14,5]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,F.createDecorator)("remoteAuthorityResolverService");var p;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(p||(e.RemoteConnectionType=p={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=R;class A{constructor(I,v){this.host=I,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var w;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class E extends P.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof E&&I._code===w.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===w.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===w.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===w.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,v=w.Unknown,y){super(I),this._message=I,this._code=v,this._detail=y,this.isHandled=v===w.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.RemoteAuthorityResolverError=E;function C(L){const I=L.indexOf("+");return I===-1?L:L.substring(0,I)}e.getRemoteAuthorityPrefix=C}),define(Ce[65],De([1,0,16]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function F(C){return C.scheme===P.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=F;function p(C){if(!C)return;const L=C.indexOf("+");return L<0?C:C.substr(0,L)}e.getRemoteName=p;function R(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(C){const{host:L,port:I}=E(C);if(typeof I>"u")throw new Error(`Invalid remote authority: ${C}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:L,port:I}}e.parseAuthorityWithPort=A;function w(C,L){let{host:I,port:v}=E(C);return typeof v>"u"&&(v=L),{host:I,port:v}}e.parseAuthorityWithOptionalPort=w;function E(C){const L=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=C.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=C.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:C,port:void 0}}}),define(Ce[25],De([1,0,12,5,65]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(A||(e.ExtensionType=A={}));var w;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.LINUX_PPC64LE="linux-ppc64le",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class E{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,o){if(typeof b>"u"||b===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof b=="string"||typeof o=="string"){const i=typeof b=="string"?b:b.value,n=typeof o=="string"?o:o.value;return P.equalsIgnoreCase(i,n)}return b._lower===o._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=E;class C{get size(){return this._set.size}constructor(b){if(this._set=new Set,b)for(const o of b)this.add(o)}add(b){this._set.add(E.toKey(b))}delete(b){return this._set.delete(E.toKey(b))}has(b){return this._set.has(E.toKey(b))}}e.ExtensionIdentifierSet=C;class L{constructor(){this._map=new Map}clear(){this._map.clear()}delete(b){this._map.delete(E.toKey(b))}get(b){return this._map.get(E.toKey(b))}has(b){return this._map.has(E.toKey(b))}set(b,o){this._map.set(E.toKey(b),o)}values(){return this._map.values()}forEach(b){this._map.forEach(b)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function I(l){return v(l)}e.isApplicationScopedExtension=I;function v(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function y(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function _(l,b){if(b){const o=`onResolveRemoteAuthority:${(0,p.getRemoteName)(b)}`;return!!l.activationEvents?.includes(o)}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[137],De([1,0,14,25]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class p{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,w){this._generators.set(A,w)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const w=Object.create(null);for(const E of A){const C=this.readActivationEvents(E);C.length>0&&(w[F.ExtensionIdentifier.toKey(E.identifier)]=C)}return w}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const w=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let E=0;E<w.length;E++)w[E]==="onUri"&&(w[E]=`onUri:${F.ExtensionIdentifier.toKey(A.identifier)}`);if(!A.contributes)return w;for(const E in A.contributes){const C=this._generators.get(E);if(!C)continue;const L=A.contributes[E],I=Array.isArray(L)?L:[L];try{C(I,w)}catch(v){(0,P.onUnexpectedError)(v)}}return w}}e.ImplicitActivationEventsImpl=p,e.ImplicitActivationEvents=new p}),define(Ce[258],De([1,0,8,21,22,14,4,3,58,38,30,82,64,65]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const _=30*1e3;var l;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function b(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(G){const B=new p.CancellationTokenSource;return setTimeout(()=>B.cancel(),G),B.token}function i(G,B){if(G.isCancellationRequested||B.isCancellationRequested)return p.CancellationToken.Cancelled;const se=new p.CancellationTokenSource;return G.onCancellationRequested(()=>se.cancel()),B.onCancellationRequested(()=>se.cancel()),se.token}class n{get didTimeout(){return this._state==="timedout"}constructor(B){this._state="pending",this._disposables=new w.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,P.promiseWithResolvers)(),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function r(G,B){const se=new n(B);return se.registerDisposable(G.onControlMessage(ye=>{const le=JSON.parse(ye.toString()),de=Q(le);de?se.reject(de):se.resolve(le)})),se.promise}function a(G,B,se,ye,le,de,ce,he){const V=new n(he),J=C.StopWatch.create(!1);return G.info(`Creating a socket (${ce})...`),E.mark(`code/willCreateSocket/${de}`),B.connect(se,ye,le,ce).then(ue=>{V.didTimeout?(E.mark(`code/didCreateSocketError/${de}`),G.info(`Creating a socket (${ce}) finished after ${J.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(E.mark(`code/didCreateSocketOK/${de}`),G.info(`Creating a socket (${ce}) was successful after ${J.elapsed()} ms.`),V.resolve(ue))},ue=>{E.mark(`code/didCreateSocketError/${de}`),G.info(`Creating a socket (${ce}) returned an error after ${J.elapsed()} ms.`),G.error(ue),V.reject(ue)}),V.promise}function t(G,B){const se=new n(B);return G.then(ye=>{se.didTimeout||se.resolve(ye)},ye=>{se.didTimeout||se.reject(ye)}),se.promise}async function h(G,B,se,ye){const le=fe(G,B);G.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let de;try{de=await a(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,y.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,b(B),`renderer-${b(B)}-${G.reconnectionToken}`,ye)}catch(ue){throw G.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ue),ue}G.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ce,he;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(de,null),ce=G.reconnectionProtocol,he=!1):(ce=new I.PersistentProtocol({socket:de}),he=!0),G.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const V=await t(G.signService.createNewMessage((0,L.generateUuid)()),ye),J={type:"auth",auth:G.connectionToken||"00000000000000000000",data:V.data};ce.sendControl(F.VSBuffer.fromString(JSON.stringify(J)));try{const ue=await r(ce,i(ye,o(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Te=new Error("Unexpected handshake message");throw Te.code="VSCODE_CONNECTION_ERROR",Te}if(G.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(G.signService.validate(V,ue.signedData),ye)){const Te=new Error("Refused to connect to unsupported server");throw Te.code="VSCODE_CONNECTION_ERROR",Te}const ke=await t(G.signService.sign(ue.data),ye),we={type:"connectionType",commit:G.commit,signedData:ke,desiredConnectionType:B};return se&&(we.args=se),G.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(F.VSBuffer.fromString(JSON.stringify(we))),{protocol:ce,ownsProtocol:he}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(G.logService.error(`${le} the handshake timed out. Error:`),G.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${le} received error control message when negotiating connection. Error:`),G.logService.error(ue)),he&&Z(ce),ue}}async function u(G,B,se,ye){const le=Date.now(),de=fe(G,B),{protocol:ce,ownsProtocol:he}=await h(G,B,se,ye),V=new n(ye);return V.registerDisposable(ce.onControlMessage(J=>{const ue=JSON.parse(J.toString()),ve=Q(ue);ve?(G.logService.error(`${de} received error control message when negotiating connection. Error:`),G.logService.error(ve),he&&Z(ce),V.reject(ve)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${re(le)}!`),V.resolve({protocol:ce,firstMessage:ue}))})),V.promise}async function s(G,B){const{protocol:se}=await u(G,1,void 0,B);return{protocol:se}}async function c(G,B,se){const{protocol:ye,firstMessage:le}=await u(G,2,B,se),de=le&&le.debugPort;return{protocol:ye,debugPort:de}}async function d(G,B,se){const ye=Date.now(),le=fe(G,3),{protocol:de}=await h(G,3,B,se);return G.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${re(ye)}!`),de}async function m(G,B,se){const{connectTo:ye,connectionToken:le}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:ye,connectionToken:le,reconnectionToken:B,reconnectionProtocol:se,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function D(G,B,se){return f(G,async ye=>{const{protocol:le}=await s(ye,p.CancellationToken.None);return new q(G,B,se,ye.reconnectionToken,le)})}e.connectRemoteAgentManagement=D;async function g(G,B){return f(G,async se=>{const{protocol:ye,debugPort:le}=await c(se,B,p.CancellationToken.None);return new ie(G,B,se.reconnectionToken,ye,le)})}e.connectRemoteAgentExtensionHost=g;async function f(G,B){for(let ye=1;;ye++)try{const le=(0,L.generateUuid)(),de=await m(G,le,null);return await B(de)}catch(le){if(ye<5)G.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(le);else throw G.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(le),U.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(le)),le}}async function S(G,B,se){const ye=await m(G,(0,L.generateUuid)(),null);return await d(ye,{host:B,port:se},p.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function T(G){return(0,P.createCancelablePromise)(B=>new Promise((se,ye)=>{const le=setTimeout(se,G*1e3);B.onCancellationRequested(()=>{clearTimeout(le),se()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(B,se){this.reconnectionToken=B,this.millisSinceLastIncomingData=se,this.type=0}}e.ConnectionLostEvent=z;class x{constructor(B,se,ye,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=se,this.durationSeconds=ye,this.cancellableTimer=le,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=x;class M{constructor(B,se,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=se,this.attempt=ye,this.type=2}}e.ReconnectionRunningEvent=M;class k{constructor(B,se,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=se,this.attempt=ye,this.type=4}}e.ConnectionGainEvent=k;class O{constructor(B,se,ye,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=se,this.attempt=ye,this.handled=le,this.type=3}}e.ReconnectionPermanentFailureEvent=O;class U extends w.Disposable{static triggerPermanentFailure(B,se,ye){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=se,this._permanentFailureHandled=ye,this._instances.forEach(le=>le._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||U._permanentFailure}constructor(B,se,ye,le,de){super(),this._connectionType=B,this._options=se,this.reconnectionToken=ye,this.protocol=le,this._reconnectionFailureIsFatal=de,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new k(this.reconnectionToken,0,0)),this._register(le.onSocketClose(ce=>{const he=ee(this._connectionType,this.reconnectionToken,!0);ce?ce.type===0?(this._options.logService.info(`${he} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this._options.logService.error(ce.error)):(this._options.logService.info(`${he} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this._options.logService.error(ce.event)):this._options.logService.info(`${he} received socket close event.`),this._beginReconnecting()})),this._register(le.onSocketTimeout(ce=>{const he=ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${he} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),U._instances.push(this),this._register((0,w.toDisposable)(()=>{const ce=U._instances.indexOf(this);ce>=0&&U._instances.splice(ce,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(U._permanentFailureMillisSinceLastIncomingData,U._permanentFailureAttempt,U._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const B=ee(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const se=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const le=ye<se.length?se[ye]:se[se.length-1];try{if(le>0){const ce=T(le);this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ce)),this._options.logService.info(`${B} waiting for ${le} seconds before reconnecting...`);try{await ce}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this._options.logService.info(`${B} resolving connection...`);const de=await m(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${de.connectTo}...`),await this._reconnect(de,o(_)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(de){if(de.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(de),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(de),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(de)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(de);continue}if((de.code==="ETIMEDOUT"||de.code==="ENETUNREACH"||de.code==="ECONNREFUSED"||de.code==="ECONNRESET")&&de.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(de);continue}if((0,R.isCancellationError)(de)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(de);continue}if(de instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(de),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ye+1,v.RemoteAuthorityResolverError.isHandled(de));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(de),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(B,se,ye){this._reconnectionFailureIsFatal?U.triggerPermanentFailure(B,se,ye):this._gotoPermanentFailure(B,se,ye)}_gotoPermanentFailure(B,se,ye){this._onDidStateChange.fire(new O(this.reconnectionToken,B,se,ye)),Z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=U;class q extends U{constructor(B,se,ye,le,de){super(1,B,le,de,!0),this.client=this._register(new I.Client(de,{remoteAuthority:se,clientId:ye},B.ipcLogger))}async _reconnect(B,se){await s(B,se)}}e.ManagementPersistentConnection=q;class ie extends U{constructor(B,se,ye,le,de){super(2,B,ye,le,!1),this._startArguments=se,this.debugPort=de}async _reconnect(B,se){await c(B,this._startArguments,se)}}e.ExtensionHostPersistentConnection=ie;function Z(G){try{G.acceptDisconnect();const B=G.getSocket();G.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function Q(G){if(G&&G.type==="error"){const B=new Error(`Connection error: ${G.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Y(G,B){for(;G.length<B;)G+=" ";return G}function ae(G,B){return`[remote-connection][${Y(b(G),13)}][${B.substr(0,5)}\u2026]`}function ee(G,B,se){return`${ae(G,B)}[${se?"reconnect":"initial"}]`}function fe(G,B){return`${ee(B,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function re(G){return`${Date.now()-G} ms`}}),define(Ce[259],De([1,0,3,5]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,F.createDecorator)("remoteSocketFactoryService");class p{constructor(){this.factories={}}register(A,w){return this.factories[A]??=[],this.factories[A].push(w),(0,P.toDisposable)(()=>{const E=this.factories[A]?.indexOf(w);typeof E=="number"&&E>=0&&this.factories[A]?.splice(E,1)})}getSocketFactory(A){return(this.factories[A.type]||[]).find(E=>E.supports(A))}connect(A,w,E,C){const L=this.getSocketFactory(A);if(!L)throw new Error(`No socket factory found for ${A}`);return L.connect(A,w,E,C)}}e.RemoteSocketFactoryService=p}),define(Ce[260],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class P{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(p){try{const R=await this.getValidator();if(R){const A=String(P._nextId++);return this.validators.set(A,R),{id:A,data:R.createNewMessage(p)}}}catch{}return{id:"",data:p}}async validate(p,R){if(!p.id)return!0;const A=this.validators.get(p.id);if(!A)return!1;this.validators.delete(p.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(p){try{return await this.signValue(p)}catch{}return p}}e.AbstractSignService=P}),define(Ce[109],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(Ce[138],De([1,0,260]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class F extends P.AbstractSignService{getValidator(){return this.vsda().then(R=>new R.validator)}signValue(R){return this.vsda().then(A=>new A.signer().sign(R))}vsda(){return new Promise((R,A)=>me(["vsda"],R,A))}}e.SignService=F}),define(Ce[261],De([1,0,11,50,30]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(E){if(P.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,C,L,I,v,y,_,l,b){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=_,o.sessionID=(0,p.generateUuid)()+Date.now(),o.commitHash=I,o.version=v,o["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,P.PlatformToString)(P.platform),o["common.nodePlatform"]=F.platform,o["common.nodeArch"]=L,o["common.product"]=b||"desktop",l&&(o["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),P.isLinuxSnap&&(o["common.snap"]="true");const r=R(C);return r&&(o["common.platformDetail"]=r),o}e.resolveCommonProperties=A;function w(E){const C=F.env.USERDNSDOMAIN;if(!C)return!1;const L=C.toLowerCase();return E.some(I=>L===I)}e.verifyMicrosoftInternalDomain=w}),define(Ce[262],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var F;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var p;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(p||(e.TelemetryConfiguration=p={}))}),define(Ce[87],De([1,0,24,18,65,261,262]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=w;class E{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class C{async publicLog(h,u,s){}async publicLogError(h,u,s){}}e.NullEndpointTelemetryService=C,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=L;function I(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=I;function v(t){const h=t.getValue(A.TELEMETRY_SETTING_ID),u=t.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function y(t){const h={},u={},s={};b(t,s);for(let c in s){c=c.length>150?c.substr(c.length-149):c;const d=s[c];typeof d=="number"?u[c]=d:typeof d=="boolean"?u[c]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${d.length}`),h[c]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(h[c]=d)}return{properties:h,measurements:u}}e.validateTelemetryData=y;const _=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const h=(0,p.getRemoteName)(t);return _.has(h)?h:"other"}e.cleanRemoteAuthority=l;function b(t,h,u=0,s){if(t)for(const c of Object.getOwnPropertyNames(t)){const d=t[c],m=s?s+c:c;Array.isArray(d)?h[m]=(0,P.safeStringify)(d):d instanceof Date?h[m]=d.toISOString():(0,F.isObject)(d)?u<2?b(d,h,u+1,m+"."):h[m]=(0,P.safeStringify)(d):h[m]=d}}function o(t,h){const u=t.msftInternalDomains||[],s=h.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||s}e.isInternalTelemetry=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let u=t;const s=[];for(const D of h)for(;;){const g=D.exec(t);if(!g)break;s.push([g.index,D.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(u="";;){const D=d.exec(t);if(!D)break;const g=s.some(([f,S])=>D.index<S&&f<d.lastIndex);!c.test(D[0])&&!g&&(u+=t.substring(m,D.index)+"<REDACTED: user-file-path>",m=d.lastIndex)}return m<t.length&&(u+=t.substr(m)),u}function r(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of h)if(u.regex.test(t))return`<REDACTED: ${u.label}>`;return t}function a(t,h){return(0,P.cloneAndChange)(t,u=>{if(u instanceof w||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let s=u.replaceAll("%20"," ");s=n(s,h);for(const c of h)s=s.replace(c,"");return s=r(s),s}})}e.cleanData=a}),define(Ce[263],De([1,0,12,134,25,11,2,14,50,87]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(u,s){return u.uuid&&s.uuid?u.uuid===s.uuid:u.id===s.id?!0:(0,P.compareIgnoreCase)(u.id,s.id)===0}e.areSameExtensions=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(s){const c=s.manifest?s.manifest.version:s.version,d=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new v(s.identifier,c,d)}static parse(s){const c=I.exec(s);return c&&c[1]&&c[2]?new v({id:c[1]},c[2],c[4]||void 0):null}constructor(s,c,d="undefined"){this.version=c,this.targetPlatform=d,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof v?L(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=v;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function _(u){const s=y.exec(u);return s&&s[1]?[b(s[1]),s[2]]:[b(u),void 0]}e.getIdAndVersion=_;function l(u,s){return`${u}.${s}`}e.getExtensionId=l;function b(u){return u.toLowerCase()}e.adoptToGalleryExtensionId=b;function o(u,s){return b(l(u??p.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=o;function i(u,s){const c=[],d=m=>{for(const D of c)if(D.some(g=>L(s(g),s(m))))return D;return null};for(const m of u){const D=d(m);D?D.push(m):c.push([m])}return c}e.groupByExtension=i;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function r(u){return{id:new C.TelemetryTrustedValue(u.identifier.id),name:new C.TelemetryTrustedValue(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.getGalleryExtensionTelemetryData=r,e.BetterMergeId=new p.ExtensionIdentifier("pprice.better-merge");function a(u,s){const c=[],d=s.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const m=d.shift();if(m&&c.every(D=>!L(D.identifier,{id:m}))){const D=u.filter(g=>L(g.identifier,{id:m}));D.length===1&&(c.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=a;async function t(u,s){if(!R.isLinux)return!1;let c;try{c=(await u.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await u.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){s.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(m))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(u,s){const c=await t(u,s),d=(0,F.getTargetPlatform)(c?"alpine":R.platform,E.arch);return s.debug("ComputeTargetPlatform:",d),d}e.computeTargetPlatform=h}),define(Ce[264],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function P(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=P;function F(E){return E?[...E.entries()]:[]}e.serializeEnvironmentDescriptionMap=F;function p(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=p;function R(E){return new Map(E??[])}e.deserializeEnvironmentDescriptionMap=R;function A(E){return Array.from(E.entries()).map(C=>[C[0],P(C[1].map),F(C[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function w(E){return new Map(E.map(C=>[C[0],{map:p(C[1]),descriptionMap:R(C[2])}]))}e.deserializeEnvironmentVariableCollections=w}),define(Ce[265],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class P{constructor(p){this._callback=p,this._terminalBufferMap=new Map}dispose(){for(const p of this._terminalBufferMap.values())p.dispose()}startBuffering(p,R,A=5){const w=R(E=>{const C=typeof E=="string"?E:E.data;let L=this._terminalBufferMap.get(p);if(L){L.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(p),A);L={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(p),w.dispose()}},this._terminalBufferMap.set(p,L)});return w}stopBuffering(p){this._terminalBufferMap.get(p)?.dispose()}flushBuffer(p){const R=this._terminalBufferMap.get(p);R&&(this._terminalBufferMap.delete(p),this._callback(p,R.data.join("")))}}e.TerminalDataBufferer=P}),define(Ce[266],De([1,0,8,78,55,4,18,2,208,108,37]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(r){function a(t,h){let u=t.defaults;for(;p.ThemeIcon.isThemeIcon(u);){const s=_.getIcon(u.id);if(!s)return;u=s.defaults}return u}r.getDefinition=a})(I||(e.IconContribution=I={}));var v;(function(r){function a(h){return{weight:h.weight,style:h.style,src:h.src.map(u=>({format:u.format,location:u.location.toString()}))}}r.toJSONObject=a;function t(h){const u=s=>(0,A.isString)(s)?s:void 0;if(h&&Array.isArray(h.src)&&h.src.every(s=>(0,A.isString)(s.format)&&(0,A.isString)(s.location)))return{weight:u(h.weight),style:u(h.style),src:h.src.map(s=>({format:s.format,location:w.URI.parse(s.location)}))}}r.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class y{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${p.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(a,t,h,u){const s=this.iconsById[a];if(s){if(h&&!s.description){s.description=h,this.iconSchema.properties[a].markdownDescription=`${h} $(${a})`;const m=this.iconReferenceSchema.enum.indexOf(a);m!==-1&&(this.iconReferenceSchema.enumDescriptions[m]=h),this._onDidChange.fire()}return s}const c={id:a,description:h,defaults:t,deprecationMessage:u};this.iconsById[a]=c;const d={$ref:"#/definitions/icons"};return u&&(d.deprecationMessage=u),h&&(d.markdownDescription=`${h}: $(${a})`),this.iconSchema.properties[a]=d,this.iconReferenceSchema.enum.push(a),this.iconReferenceSchema.enumDescriptions.push(h||""),this._onDidChange.fire(),{id:a}}deregisterIcon(a){delete this.iconsById[a],delete this.iconSchema.properties[a];const t=this.iconReferenceSchema.enum.indexOf(a);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(a=>this.iconsById[a])}getIcon(a){return this.iconsById[a]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(a,t){const h=this.iconFontsById[a];return h||(this.iconFontsById[a]=t,this._onDidChange.fire(),t)}deregisterIconFont(a){delete this.iconFontsById[a]}getIconFont(a){return this.iconFontsById[a]}toString(){const a=(s,c)=>s.id.localeCompare(c.id),t=s=>{for(;p.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of u.filter(c=>!!c.description).sort(a))h.push(`|<i class="${t(s)}"></i>|${s.id}|${p.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const s of u.filter(c=>!p.ThemeIcon.isThemeIcon(c.defaults)).sort(a))h.push(`|<i class="${t(s)}"></i>|${s.id}|`);return h.join(`
`)}}const _=new y;L.Registry.add(e.Extensions.IconContribution,_);function l(r,a,t,h){return _.registerIcon(r,a,t,h)}e.registerIcon=l;function b(){return _}e.getIconRegistry=b;function o(){const r=(0,F.getCodiconFontCharacters)();for(const a in r){const t="\\"+r[a].toString(16);_.registerIcon(a,{fontCharacter:t})}}o(),e.iconsSchemaId="vscode://schemas/icons";const i=L.Registry.as(C.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,_.getIconSchema());const n=new P.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);_.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.widgetClose=l("widget-close",F.Codicon.close,(0,E.localize)(2,null)),e.gotoPreviousLocation=l("goto-previous-location",F.Codicon.arrowUp,(0,E.localize)(3,null)),e.gotoNextLocation=l("goto-next-location",F.Codicon.arrowDown,(0,E.localize)(4,null)),e.syncing=p.ThemeIcon.modify(F.Codicon.sync,"spin"),e.spinningLoading=p.ThemeIcon.modify(F.Codicon.loading,"spin")}),define(Ce[88],De([1,0,4,52,5,13]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,p.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,p.createDecorator)("sharedTunnelsService");var A;(function(b){b.Http="http",b.Https="https"})(A||(e.TunnelProtocol=A={}));var w;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(w||(e.TunnelPrivacyId=w={}));function E(b){return!!b.forwardPort}e.isTunnelProvider=E;var C;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function L(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=L,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=v;function y(b,o,i,n){if(i===1)return!1;if(i===2&&v(o)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return b<1024}e.isPortPrivileged=y;class _{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this._dispose=n,this._onDispose=new P.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=_;let l=class{constructor(o,i){this.logService=o,this.configurationService=i,this._onTunnelOpened=new P.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new P.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new P.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const o=this.configurationService.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this._tunnelProvider=o,o?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this._canElevate=o.elevation,this._privacyOptions=o.privacyOptions,this._canChangeProtocol=o.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const o=[],i=Array.from(this._tunnels.values());for(const n of i){const r=Array.from(n.values());for(const a of r){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this._tunnels.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this._tunnels.clear()}setEnvironmentTunnel(o,i,n,r,a){this.addTunnelToMap(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(v(o)||I(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const n=this.getTunnelFromMap(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,r,a,t=!1,h,u){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const s=this._tunnelProvider??o;if(!s)return;if(i||(i="localhost"),r||(r=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(n)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(s,i,n,r,a,t,h,u);return c?c.then(d=>{if(d){if(typeof d=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(i,n),d}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(i,n);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.makeTunnel(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==n)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&d.privacy!==h&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(m),m}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this._tunnels.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.tryDisposeTunnel(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async tryDisposeTunnel(o,i,n){if(n.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const r=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(o)&&this._tunnels.get(o).delete(i),r}}async closeTunnel(o,i){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this._tunnels.get(o);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.tryDisposeTunnel(o,i,r)}}addTunnelToMap(o,i,n){this._tunnels.has(o)||this._tunnels.set(o,new Map),this._tunnels.get(o).set(i,{refcount:1,value:n})}async removeEmptyOrErrorTunnelFromMap(o,i){const n=this._tunnels.get(o);if(n){const r=n.get(i),a=r?await r.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this._tunnels.delete(o)}}getTunnelFromMap(o,i){const n=[o];I(o)?(n.push(...e.LOCALHOST_ADDRESSES),n.push(...e.ALL_INTERFACES_ADDRESSES)):v(o)&&n.push(...e.ALL_INTERFACES_ADDRESSES);const r=n.map(a=>this._tunnels.get(a));for(const a of r){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!L(o)}createWithProvider(o,i,n,r,a,t,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const u=n;this._factoryInProgress.add(u);const s=r===void 0?n:r,c={elevationRequired:a?this.isPortPrivileged(s):!1},d={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==w.Private:void 0,protocol:h},m=o.forwardPort(d,c);return m?(this.addTunnelToMap(i,n,m),m.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),m}};e.AbstractTunnelService=l,e.AbstractTunnelService=l=Ge([He(0,R.ILogService),He(1,F.IConfigurationService)],l)}),define(Ce[267],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(Ce[268],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,P.createDecorator)("editSessionIdentityService");var F;(function(p){p[p.Complete=100]="Complete",p[p.Partial=50]="Partial",p[p.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ce[269],De([1,0,16]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function F(E){return E.scheme!==P.Schemas.file&&E.scheme!==P.Schemas.vscodeRemote}e.isVirtualResource=F;function p(E){if(E.folders.length)return E.folders.every(C=>F(C.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=p;function R(E){return p(E)?.scheme}e.getVirtualWorkspaceScheme=R;function A(E){return p(E)?.authority}e.getVirtualWorkspaceAuthority=A;function w(E){return p(E)!==void 0}e.isVirtualWorkspace=w}),define(Ce[41],De([1,0,210,17,77,23,2,5,16]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function C(s){const c=s;return typeof c?.id=="string"&&A.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=C;function L(s){return typeof s?.id=="string"&&!C(s)&&!v(s)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(s,c){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,F.basename)(s)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=s;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.toWorkspaceIdentifier=I;function v(s){const c=s;return typeof c?.id=="string"&&A.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=v;function y(s){const c=s;if(c?.uri)return{id:c.id,uri:A.URI.revive(c.uri)};const d=s;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=y;var _;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(_||(e.WorkbenchState=_={}));function l(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=l;function b(s){const c=s;return!!(c&&typeof c=="object"&&A.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=b;class o{constructor(c,d,m,D,g){this._id=c,this._transient=m,this._configuration=D,this._ignorePathCasing=g,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(c){this._id=c.id,this._configuration=c.configuration,this._transient=c.transient,this._ignorePathCasing=c._ignorePathCasing,this.folders=c.folders}get folders(){return this._folders}set folders(c){this._folders=c,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(c){this._configuration=c}getFolder(c){return c&&this._foldersMap.findSubstr(c)||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const c of this.folders)this._foldersMap.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class i{constructor(c,d){this.raw=d,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function n(s){return new i({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=n,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function r(s,c){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,c.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(s){let c;return A.URI.isUri(s)?c=s:c=s.configuration,c?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=a,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function h(s,c){return!r(s,c)&&!a(s)}e.isSavedWorkspace=h;function u(s){return(typeof s=="string"?(0,F.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=u}),define(Ce[270],De([1,0,54,4,3,23,2,209,133,32,5,13,41,28,267,8,30,12,18]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var n;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&A.URI.isUri(c.location)&&A.URI.isUri(c.globalStorageHome)&&A.URI.isUri(c.settingsResource)&&A.URI.isUri(c.keybindingsResource)&&A.URI.isUri(c.tasksResource)&&A.URI.isUri(c.snippetsHome)&&A.URI.isUri(c.extensionsResource))}e.isUserDataProfile=r,e.IUserDataProfilesService=(0,L.createDecorator)("IUserDataProfilesService");function a(s,c){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:A.URI.revive(s.location).with({scheme:c}),globalStorageHome:A.URI.revive(s.globalStorageHome).with({scheme:c}),settingsResource:A.URI.revive(s.settingsResource).with({scheme:c}),keybindingsResource:A.URI.revive(s.keybindingsResource).with({scheme:c}),tasksResource:A.URI.revive(s.tasksResource).with({scheme:c}),snippetsHome:A.URI.revive(s.snippetsHome).with({scheme:c}),extensionsResource:A.URI.revive(s.extensionsResource).with({scheme:c}),cacheHome:A.URI.revive(s.cacheHome).with({scheme:c}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=a;function t(s,c,d,m,D,g){return{id:s,name:c,location:d,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:g&&D?.useDefaultFlags?.globalState?g.globalStorageHome:(0,R.joinPath)(d,"globalStorage"),settingsResource:g&&D?.useDefaultFlags?.settings?g.settingsResource:(0,R.joinPath)(d,"settings.json"),keybindingsResource:g&&D?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,R.joinPath)(d,"keybindings.json"),tasksResource:g&&D?.useDefaultFlags?.tasks?g.tasksResource:(0,R.joinPath)(d,"tasks.json"),snippetsHome:g&&D?.useDefaultFlags?.snippets?g.snippetsHome:(0,R.joinPath)(d,"snippets"),extensionsResource:g&&D?.useDefaultFlags?.extensions?g.extensionsResource:(0,R.joinPath)(d,"extensions.json"),cacheHome:(0,R.joinPath)(m,s),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.toUserDataProfile=t;let h=class extends p.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(c,d,m,D){super(),this.environmentService=c,this.fileService=d,this.uriIdentityService=m,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new F.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new F.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new F.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new F.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new y.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,R.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(c){this.enabled!==c&&(this._profilesObject=void 0,this.enabled=c)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const c=this.createDefaultProfile(),d=[c];if(this.enabled)try{for(const g of this.getStoredProfiles()){if(!g.name||!(0,i.isString)(g.name)||!g.location){this.logService.warn("Skipping the invalid stored profile",g.location||g.name);continue}d.push(t((0,R.basename)(g.location),g.name,g.location,this.profilesCacheHome,{shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags},c))}}catch(g){this.logService.error(g)}const m=new y.ResourceMap,D=new Map;if(d.length)try{const g=this.getStoredProfileAssociations();if(g.workspaces)for(const[f,S]of Object.entries(g.workspaces)){const T=A.URI.parse(f),N=d.find(z=>z.id===S);N&&m.set(T,N)}if(g.emptyWindows)for(const[f,S]of Object.entries(g.emptyWindows)){const T=d.find(N=>N.id===S);T&&D.set(f,T)}}catch(g){this.logService.error(g)}this._profilesObject={profiles:d,workspaces:m,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const c=t("__default__profile__",(0,w.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const d="Temp",m=new RegExp(`${(0,o.escapeRegExpCharacters)(d)}\\s(\\d+)`);let D=0;for(const f of this.profiles){const S=m.exec(f.name),T=S?parseInt(S[1]):0;D=T>D?T:D}const g=`${d} ${D+1}`;return this.createProfile((0,P.hash)((0,b.generateUuid)()).toString(16),g,{transient:!0},c)}async createNamedProfile(c,d,m){return this.createProfile((0,P.hash)((0,b.generateUuid)()).toString(16),c,d,m)}async createProfile(c,d,m,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const g=await this.doCreateProfile(c,d,m);return D&&await this.setProfileForWorkspace(D,g),g}async doCreateProfile(c,d,m){if(!(0,i.isString)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(d);return D||(D=(async()=>{try{const g=this.profiles.find(T=>T.name===d||T.id===c);if(g)return g;const f=t(c,d,(0,R.joinPath)(this.profilesHome,c),this.profilesCacheHome,m,this.defaultProfile);await this.fileService.createFolder(f.location);const S=[];return this._onWillCreateProfile.fire({profile:f,join(T){S.push(T)}}),await l.Promises.settled(S),this.updateProfiles([f],[],[]),f}finally{this.profileCreationPromises.delete(d)}})(),this.profileCreationPromises.set(d,D)),D}async updateProfile(c,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(D=>D.id===c.id);if(!m)throw new Error(`Profile '${c.name}' does not exist`);return m=t(m.id,d.name??m.name,m.location,this.profilesCacheHome,{shortName:d.shortName??m.shortName,icon:d.icon===null?void 0:d.icon??m.icon,transient:d.transient??m.isTransient,useDefaultFlags:d.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[m]),m}async removeProfile(c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(D=>D.id===c.id);if(!d)throw new Error(`Profile '${c.name}' does not exist`);const m=[];this._onWillRemoveProfile.fire({profile:d,join(D){m.push(D)}});try{await Promise.allSettled(m)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])d.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])d.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[d],[]);try{await this.fileService.del(d.cacheHome,{recursive:!0})}catch(D){(0,C.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(c,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(D=>D.id===d.id);if(!m)throw new Error(`Profile '${d.name}' does not exist`);this.updateWorkspaceAssociation(c,m)}unsetWorkspace(c,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(c,void 0,d)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const c=await this.fileService.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(d=>d.isDirectory&&this.profiles.every(m=>!this.uriIdentityService.extUri.isEqual(m.location,d.resource))).map(d=>this.fileService.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const c=this.transientProfilesObject.profiles.filter(d=>!this.isProfileAssociatedToWorkspace(d));await Promise.allSettled(c.map(d=>this.removeProfile(d)))}getProfileForWorkspace(c){const d=this.getWorkspace(c);return A.URI.isUri(d)?this.transientProfilesObject.workspaces.get(d)??this.profilesObject.workspaces.get(d):this.transientProfilesObject.emptyWindows.get(d)??this.profilesObject.emptyWindows.get(d)}getWorkspace(c){return(0,v.isSingleFolderWorkspaceIdentifier)(c)?c.uri:(0,v.isWorkspaceIdentifier)(c)?c.configPath:c.id}isProfileAssociatedToWorkspace(c){return!!([...this.transientProfilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location))||[...this.transientProfilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location))||[...this.profilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location))||[...this.profilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location)))}updateProfiles(c,d,m){const D=[...this.profiles,...c],g=[];this.transientProfilesObject.profiles=[];for(let f of D)f.isDefault||d.some(S=>f.id===S.id)||(f=m.find(S=>f.id===S.id)??f,f.isTransient?this.transientProfilesObject.profiles.push(f):g.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.saveStoredProfiles(g),this._profilesObject=void 0,this.triggerProfilesChanges(c,d,m)}triggerProfilesChanges(c,d,m){this._onDidChangeProfiles.fire({added:c,removed:d,updated:m,all:this.profiles})}updateWorkspaceAssociation(c,d,m){m=d?.isTransient?!0:m,m||this.updateWorkspaceAssociation(c,void 0,!0);const D=this.getWorkspace(c),g=m?this.transientProfilesObject:this.profilesObject;A.URI.isUri(D)?(g.workspaces.delete(D),d&&g.workspaces.set(D,d)):(g.emptyWindows.delete(D),d&&g.emptyWindows.set(D,d)),m||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const c={};for(const[m,D]of this.profilesObject.workspaces.entries())c[m.toString()]=D.id;const d={};for(const[m,D]of this.profilesObject.emptyWindows.entries())d[m.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:c,emptyWindows:d}),this._profilesObject=void 0}migrateStoredProfileAssociations(c){const d={},m=this.createDefaultProfile();if(c.workspaces)for(const[g,f]of Object.entries(c.workspaces)){const S=A.URI.parse(f);d[g]=this.uriIdentityService.extUri.isEqual(S,m.location)?m.id:this.uriIdentityService.extUri.basename(S)}const D={};if(c.emptyWindows)for(const[g,f]of Object.entries(c.emptyWindows)){const S=A.URI.parse(f);D[g]=this.uriIdentityService.extUri.isEqual(S,m.location)?m.id:this.uriIdentityService.extUri.basename(S)}return{workspaces:d,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(c){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(c){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=h,e.UserDataProfilesService=h=Ge([He(0,E.IEnvironmentService),He(1,C.IFileService),He(2,_.IUriIdentityService),He(3,I.ILogService)],h);class u extends h{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(c){this.storedProfiles=c}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(c){this.storedProfileAssociations=c}}e.InMemoryUserDataProfilesService=u}),define(Ce[271],De([1,0,8,4,3,58,18,189,5,270]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function y(i){const n=i.get(e.TARGET_KEY);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.loadKeyTargets=y;class _ extends p.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(n={flushInterval:_.DEFAULT_FLUSH_INTERVAL}){super(),this.options=n,this._onDidChangeValue=this._register(new F.PauseableEmitter),this._onDidChangeTarget=this._register(new F.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new F.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new p.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(n,r,a){return F.Event.filter(this._onDidChangeValue.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,p.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(n,r){const{key:a,external:t}=r;if(a===e.TARGET_KEY){switch(n){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:n})}else this._onDidChangeValue.fire({scope:n,key:a,target:this.getKeyTargets(n)[a],external:t})}emitWillSaveState(n){this._onWillSaveState.fire({reason:n})}get(n,r,a){return this.getStorage(r)?.get(n,a)}getBoolean(n,r,a){return this.getStorage(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.getStorage(r)?.getNumber(n,a)}getObject(n,r,a){return this.getStorage(r)?.getObject(n,a)}storeAll(n,r){this.withPausedEmitters(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,h=!1){if((0,A.isUndefinedOrNull)(r)){this.remove(n,a,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(n,a,t),this.getStorage(a)?.set(n,r,h)})}remove(n,r,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(n,r,void 0),this.getStorage(r)?.delete(n,a)})}withPausedEmitters(n){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{n()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(n,r){const a=[],t=this.getKeyTargets(n);for(const h of Object.keys(t))t[h]===r&&a.push(h);return a}updateKeyTarget(n,r,a,t=!1){const h=this.getKeyTargets(r);typeof a=="number"?h[n]!==a&&(h[n]=a,this.getStorage(r)?.set(e.TARGET_KEY,JSON.stringify(h),t)):typeof h[n]=="number"&&(delete h[n],this.getStorage(r)?.set(e.TARGET_KEY,JSON.stringify(h),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(n){switch(n){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(n){const r=this.getStorage(n);return r?y(r):Object.create(null)}isNew(n){return this.getBoolean(e.IS_NEW_KEY,n)===!0}async flush(n=L.NONE){this._onWillSaveState.fire({reason:n});const r=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(n){case L.NONE:await P.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await P.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.getStorage(-1)?.items??new Map,r=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return o(n,r,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(n){return await this.flush(),this.getStorage(n)?.optimize()}async switch(n,r){return this.emitWillSaveState(L.NONE),(0,C.isUserDataProfile)(n)?this.switchToProfile(n,r):this.switchToWorkspace(n,r)}canSwitchProfile(n,r){return!(n.id===r.id||l(r)&&l(n))}switchData(n,r,a){this.withPausedEmitters(()=>{const t=new Set;for(const[h,u]of n)t.add(h),r.get(h)!==u&&this.emitDidChangeValue(a,{key:h,external:!0});for(const[h]of r.items)t.has(h)||this.emitDidChangeValue(a,{key:h,external:!0})})}}e.AbstractStorageService=_;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=l;class b extends _{constructor(){super(),this.applicationStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(n=>this.emitDidChangeValue(1,n))),this._register(this.profileStorage.onDidChangeStorage(n=>this.emitDidChangeValue(0,n))),this._register(this.applicationStorage.onDidChangeStorage(n=>this.emitDidChangeValue(-1,n)))}getStorage(n){switch(n){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(n){return!1}}e.InMemoryStorageService=b;async function o(i,n,r,a,t,h){const u=T=>{try{return JSON.parse(T)}catch{return T}},s=new Map,c=new Map;i.forEach((T,N)=>{s.set(N,T),c.set(N,u(T))});const d=new Map,m=new Map;n.forEach((T,N)=>{d.set(N,T),m.set(N,u(T))});const D=new Map,g=new Map;r.forEach((T,N)=>{D.set(N,T),g.set(N,u(T))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const f=[];if(s.forEach((T,N)=>{f.push({key:N,value:T})}),console.table(f),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];d.forEach((N,z)=>{T.push({key:z,value:N})}),console.table(T),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${h})`);const S=[];D.forEach((T,N)=>{S.push({key:N,value:T})}),console.table(S),console.groupEnd(),console.log(g)}e.logStorage=o}),define(Ce[110],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class P{static{this.enableDebugLogging=!1}constructor(p){this.id=p,this._data=new Map,this._idPool=1}add(p){const R=this._idPool++;return this._data.set(R,p),this.logDebugInfo(),R}get(p,R){return this._data.has(p)?this._data.get(p)[R]:void 0}delete(p){this._data.delete(p),this.logDebugInfo()}logDebugInfo(){P.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=P}),define(Ce[59],De([1,0,16,23,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(P.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(w=>{const E=this._providerInfo.get(w.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(w,E){E===null?this._providerInfo.delete(w.scheme):this._providerInfo.set(w.scheme,E)}isFreeScheme(w){return!this._providerInfo.has(w)&&!this._systemSchemes.has(w)}getCapabilities(w){return this._providerInfo.get(w)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,p.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[27],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,P.createDecorator)("IExtHostInitDataService")}),define(Ce[272],De([1,0,216,13,252,27]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends p.LogService{constructor(E,C,L){const I=L.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",v=L.remote.isRemote?(0,P.localize)(0,null):E?(0,P.localize)(1,null):(0,P.localize)(2,null);super(C.createLogger(I,{name:v}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=Ge([He(1,F.ILoggerService),He(2,R.IExtHostInitDataService)],A)}),define(Ce[273],De([1,0,8]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,w,E){this._deferredPromises=new Map,this._id=A,this._shared=w,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new P.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of C.values())L.complete()}catch(L){for(const I of C.values())I.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,w){let E=this._value[A];return typeof E>"u"&&(E=w),E}update(A,w){this._value[A]=w;const E=this._deferredPromises.get(A);if(E!==void 0)return E.p;const C=new P.DeferredPromise;return this._deferredPromises.set(A,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class p extends F{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,w){super(A.identifier.value,!0,w),this._extension=A}}e.ExtensionGlobalMemento=p}),define(Ce[274],De([1,0,4,2]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class p{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new P.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new P.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,w,E,C){const I=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(w.value,E,C);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(A,w){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A)).acceptDirty(w)}$acceptModelSaved(A){const w=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(A));this._onDidSaveNotebookDocument.fire(w.apiNotebook)}}e.ExtHostNotebookDocuments=p}),define(Ce[20],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,P.createDecorator)("IExtHostRpcService");class F{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=F}),define(Ce[275],De([1,0,25,4]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class p{#e;constructor(A,w){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=P.ExtensionIdentifier.toKey(A.identifier),this.#e=w,this.#e.onDidChangePassword(E=>{E.extensionId===this._id&&this._onDidChange.fire({key:E.key})})}get(A){return this.#e.get(this._id,A)}store(A,w){return this.#e.store(this._id,A,w)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=p}),define(Ce[66],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,P.createDecorator)("IURITransformerService");class F{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(Ce[276],De([1,0,21]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(E){let C=this.buffers.indexOf(E);return C<0&&(C=this.buffers.length,this.buffers.push(E)),C}}function p(w,E){if(E.serializeBuffersForPostMessage){const C=new F,I=JSON.stringify(w,(y,_)=>{if(_ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(_)};if(ArrayBuffer.isView(_)){const l=R(_);if(l)return{$$vscode_array_buffer_reference$$:!0,index:C.add(_.buffer),view:{type:l,byteLength:_.byteLength,byteOffset:_.byteOffset}}}return _}),v=C.buffers.map(y=>{const _=new Uint8Array(y);return P.VSBuffer.wrap(_)});return{message:I,buffers:v}}else return{message:JSON.stringify(w),buffers:[]}}e.serializeWebviewMessage=p;function R(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(w,E){const C=E.map(v=>{const y=new ArrayBuffer(v.byteLength);return new Uint8Array(y).set(v.buffer),y}),L=E.length?(v,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const _=y,{index:l}=_,b=C[l];if(_.view)switch(_.view.type){case 1:return new Int8Array(b,_.view.byteOffset,_.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,_.view.byteOffset,_.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,_.view.byteOffset,_.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,_.view.byteOffset,_.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,_.view.byteOffset,_.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,_.view.byteOffset,_.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,_.view.byteOffset,_.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,_.view.byteOffset,_.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,_.view.byteOffset,_.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,_.view.byteOffset,_.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,_.view.byteOffset,_.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return y}:void 0;return{message:JSON.parse(w,L),arrayBuffers:C}}e.deserializeWebviewMessage=A}),define(Ce[277],De([1,0,278,391,392,62,2,13,393]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const C=!1;function L(n,r,a,t,h,u){const s=u.environment.useHostProxy,c=typeof s=="boolean"?s:!u.remote.isRemote,d={resolveProxy:g=>n.resolveProxy(g),lookupProxyAuthorization:b.bind(void 0,t,h,r,{},u.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>v(r),addCertificatesV2:()=>y(r),log:t,getLogLevel:()=>{const g=t.getLevel();switch(g){case w.LogLevel.Trace:return E.LogLevel.Trace;case w.LogLevel.Debug:return E.LogLevel.Debug;case w.LogLevel.Info:return E.LogLevel.Info;case w.LogLevel.Warning:return E.LogLevel.Warning;case w.LogLevel.Error:return E.LogLevel.Error;case w.LogLevel.Off:return E.LogLevel.Off;default:return f(g)}function f(S){return t.error("Unknown log level",S),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const g=[];if(u.remote.isRemote&&g.push((0,E.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const f=n.loadCertificates();f.then(S=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",S.length)),g.push(f)}return(await Promise.all(g)).flat()},env:process.env},m=(0,E.createProxyResolver)(d),D=I(d,m);return l(a,D)}e.connectProxyResolver=L;function I(n,r){return{http:Object.assign(P,(0,E.createHttpPatch)(n,P,r)),https:Object.assign(F,(0,E.createHttpPatch)(n,F,r)),net:Object.assign(R,(0,E.createNetPatch)(n,R)),tls:Object.assign(p,(0,E.createTlsPatch)(n,p))}}function v(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",C)&&!!r.get("systemCertificates")}function y(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",C)&&!!r.get("systemCertificates")}const _=new Map;function l(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(s,c,d){if(s==="net")return r.net;if(s==="tls")return r.tls;if(s!=="http"&&s!=="https")return h.apply(this,arguments);const m=a.findSubstr(A.URI.file(c.filename));let D=_.get(m);if(D||_.set(m,D={}),!D[s]){const g=r[s];D[s]={...g}}return D[s]}})}async function b(n,r,a,t,h,u,s,c){const d=t[u];s&&(t[u]=s),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${u}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${d}`);const m=s||d,D=Array.isArray(m)?m:typeof m=="string"?[m]:[];if(i(r,D,h),D.some(g=>/^(Negotiate|Kerberos)( |$)/i.test(g))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const g=await new Promise((z,x)=>{me(["kerberos"],z,x)}),f=new URL(u),S=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${u}`,`spn:${S}`),"Negotiate "+await(await g.initializeClient(S)).step("")}catch(g){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",g)}}let o=!1;function i(n,r,a){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Ce[279],De([1,0,130]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function F(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function p(R){return new P.URITransformer(F(R))}e.createURITransformer=p}),define(Ce[139],De([1,0,226,18,2,3,5,37,32,16,40,181,39]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffListEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,P.localize)(0,null),providerDisplayName:(0,P.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var _;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(_||(e.EditorPaneSelectionCompareResult=_={}));function l(re){const G=re;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=l;function b(re,G,B){for(const se of B.visibleEditorPanes)if(se.group.id===G&&re.matches(se.input))return se.getViewState()}e.findViewStateForEditor=b;function o(re){if(m(re))return!1;const G=re;return p.URI.isUri(G?.resource)}e.isResourceEditorInput=o;function i(re){if(m(re))return!1;const G=re;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=i;function n(re){if(m(re))return!1;const G=re;return!G||G.resources&&!Array.isArray(G.resources)?!1:!!G.resources||!!G.multiDiffSource}e.isResourceDiffListEditorInput=n;function r(re){if(m(re)||i(re))return!1;const G=re;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=r;function a(re){if(m(re))return!1;const G=re;return G?G.resource===void 0||G.resource.scheme===C.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;function t(re){if(m(re))return!1;const G=re;return p.URI.isUri(G?.base?.resource)&&p.URI.isUri(G?.input1?.resource)&&p.URI.isUri(G?.input2?.resource)&&p.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=t;var h;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var u;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(G,B){let se=this.mapIdToSaveSource.get(G);return se||(se={source:G,label:B},this.mapIdToSaveSource.set(G,se)),se.source}getSourceLabel(G){return this.mapIdToSaveSource.get(G)?.label??G}}e.SaveSourceRegistry=new s;var c;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class d extends R.Disposable{}e.AbstractEditorInput=d;function m(re){return re instanceof d}e.isEditorInput=m;function D(re){const G=re;return p.URI.isUri(G?.preferredResource)}function g(re){const G=re;return m(G?.primary)&&m(G?.secondary)}e.isSideBySideEditorInput=g;function f(re){const G=re;return m(G?.modified)&&m(G?.original)}e.isDiffEditorInput=f;function S(re,G,B,se,ye){return fe(se,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,P.localize)(2,null),run:()=>{const le={...B,limits:{size:Number.MAX_VALUE}};re.openEditor(G,le)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,P.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=S;function T(re){return m(re?.editor)}e.isEditorInputWithOptions=T;function N(re){const G=re;return T(re)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=N;function z(re){const G=re;return typeof G?.groupId=="number"&&m(G.editor)}e.isEditorIdentifier=z;var x;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(x||(e.EditorCloseContext=x={}));var M;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_STICKY=11]="EDITOR_STICKY",re[re.EDITOR_DIRTY=12]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var k;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(k||(e.SideBySideEditor=k={}));class O{getOriginalUri(G,B){if(!G)return;if(t(G))return e.EditorResourceAccessor.getOriginalUri(G.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:le}=this.getSideEditors(G);if(ye&&le){if(B?.supportSideBySide===k.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===k.ANY)return this.getOriginalUri(ye,{filterByScheme:B.filterByScheme})??this.getOriginalUri(le,{filterByScheme:B.filterByScheme});G=B.supportSideBySide===k.PRIMARY?ye:le}}if(i(G)||n(G)||r(G)||t(G))return;const se=D(G)?G.preferredResource:G.resource;return!se||!B||!B.filterByScheme?se:this.filterUri(se,B.filterByScheme)}getSideEditors(G){return g(G)||r(G)?{primary:G.primary,secondary:G.secondary}:f(G)||i(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,B){if(!G)return;if(t(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:le}=this.getSideEditors(G);if(ye&&le){if(B?.supportSideBySide===k.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===k.ANY)return this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:B.filterByScheme});G=B.supportSideBySide===k.PRIMARY?ye:le}}if(i(G)||n(G)||r(G)||t(G))return;const se=G.resource;return!se||!B||!B.filterByScheme?se:this.filterUri(se,B.filterByScheme)}filterUri(G,B){if(Array.isArray(B)){if(B.some(se=>G.scheme===se))return G}else if(B===G.scheme)return G}}var U;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(U||(e.EditorCloseMethod=U={}));function q(re,G,B,se){if(!re.isSticky(G))return!1;switch(se.preventPinnedEditorClose){case"keyboardAndMouse":return B===U.MOUSE||B===U.KEYBOARD;case"mouse":return B===U.MOUSE;case"keyboard":return B===U.KEYBOARD}return!1}e.preventEditorClose=q,e.EditorResourceAccessor=new O;var ie;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(ie||(e.CloseDirection=ie={}));class Z{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(G){const B=this.instantiationService=G.get(A.IInstantiationService);for(const[se,ye]of this.editorSerializerConstructors)this.createEditorSerializer(se,ye,B);this.editorSerializerConstructors.clear()}createEditorSerializer(G,B,se){const ye=se.createInstance(B);this.editorSerializerInstances.set(G,ye)}registerFileEditorFactory(G){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=G}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(G,B){if(this.editorSerializerConstructors.has(G)||this.editorSerializerInstances.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.instantiationService?this.createEditorSerializer(G,B,this.instantiationService):this.editorSerializerConstructors.set(G,B),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(G),this.editorSerializerInstances.delete(G)})}getEditorSerializer(G){return this.editorSerializerInstances.get(typeof G=="string"?G:G.typeId)}}w.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function Q(re,G,B){return!re||!re.length?[]:await Promise.all(re.map(async se=>{const ye=p.URI.revive(se.fileUri);if(!ye){B.info("Cannot resolve the path because it is not valid.",se);return}if(!await G.canHandleResource(ye)){B.info("Cannot resolve the path because it cannot be handled",se);return}let de=se.exists,ce=se.type;if(typeof de!="boolean"||typeof ce!="number")try{ce=(await G.stat(ye)).isDirectory?E.FileType.Directory:E.FileType.Unknown,de=!0}catch(V){B.error(V),de=!1}if(!de&&se.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",se);return}if(ce===E.FileType.Directory){B.info("Cannot resolve the path because it is a directory",se);return}const he={...se.options,pinned:!0};return de?{resource:ye,options:he}:{resource:ye,options:he,forceUntitled:!0}}))}e.pathsToEditors=Q;var Y;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function ae(re){const G=re;if(!G)return!1;const B=G;if(B.modified)return ae(B.modified);const se=G;return!!(se.contributionsState&&se.viewState&&Array.isArray(se.cursorState))}e.isTextEditorViewState=ae;function ee(re){return(0,L.isErrorWithActions)(re)}e.isEditorOpenError=ee;function fe(re,G,B){const se=(0,L.createErrorWithActions)(re,G);return se.forceMessage=B?.forceMessage,se.forceSeverity=B?.forceSeverity,se.allowDialog=B?.allowDialog,se}e.createEditorOpenError=fe}),define(Ce[280],De([1,0,4,227,5,3,28,37,19,24,78,266]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,F.localize)(0,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",L.Codicon.window,(0,F.localize)(1,null));var v;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var y;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.ViewContainerLocations=[0,1,2];function _(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=_;class l extends R.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new P.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new P.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,E.flatten)([...this.viewContainers.values()])}registerViewContainer(u,s,c){const d=this.get(u.id);if(d)return d;const m=u;return m.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,A.getOrSet)(this.viewContainers,s,[]).push(m),c?.isDefault&&this.defaultViewContainers.push(m),this._onDidRegister.fire({viewContainer:m,viewContainerLocation:s}),m}deregisterViewContainer(u){for(const s of this.viewContainers.keys()){const c=this.viewContainers.get(s),d=c?.indexOf(u);if(d!==-1){c?.splice(d,1),c.length===0&&this.viewContainers.delete(s),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:s});return}}}get(u){return this.all.filter(s=>s.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(s=>this.getViewContainers(s).filter(c=>c?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(s=>this.getViewContainerLocation(s)===u)}}w.Registry.add(v.ViewContainersRegistry,new l);var b;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(b||(e.ViewContentGroups=b={}));function o(h,u){const s=h.group??b.More,c=u.group??b.More;return s!==c?s.localeCompare(c):(h.order??5)-(u.order??5)}class i extends R.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new P.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new P.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new P.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new P.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(u,s){this.registerViews2([{views:u,viewContainer:s}])}registerViews2(u){u.forEach(({views:s,viewContainer:c})=>this.addViews(s,c)),this._onViewsRegistered.fire(u)}deregisterViews(u,s){const c=this.removeViews(u,s);c.length&&this._onViewsDeregistered.fire({views:c,viewContainer:s})}moveViews(u,s){for(const c of this._views.keys())if(c!==s){const d=this.removeViews(u,c);d.length&&(this.addViews(d,s),this._onDidChangeContainer.fire({views:d,from:c,to:s}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const s of this._viewContainers){const c=(this._views.get(s)||[]).filter(d=>d.id===u)[0];if(c)return c}return null}getViewContainer(u){for(const s of this._viewContainers)if((this._views.get(s)||[]).filter(d=>d.id===u)[0])return s;return null}registerViewWelcomeContent(u,s){return this._viewWelcomeContents.add(u,s),this._onDidChangeViewWelcomeContent.fire(u),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(u,s),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,s){const c=new Map;for(const[d,m]of s)this._viewWelcomeContents.add(u,m),c.set(d,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(u,m),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),c}getViewWelcomeContent(u){const s=[];return this._viewWelcomeContents.forEach(u,c=>s.push(c)),s.sort(o)}addViews(u,s){let c=this._views.get(s);c||(c=[],this._views.set(s,c),this._viewContainers.push(s));for(const d of u){if(this.getView(d.id)!==null)throw new Error((0,F.localize)(2,null,d.id));c.push(d)}}removeViews(u,s){const c=this._views.get(s);if(!c)return[];const d=[],m=[];for(const D of c)u.includes(D)?d.push(D):m.push(D);return d.length&&(m.length?this._views.set(s,m):(this._views.delete(s),this._viewContainers.splice(this._viewContainers.indexOf(s),1))),d}}w.Registry.add(v.ViewsRegistry,new i),e.IViewDescriptorService=(0,p.createDecorator)("viewDescriptorService");var n;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(u,s){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,u),this._hasResolve=!!s,this.resolve=async c=>{if(s&&!this.resolved){const d=await s(c);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}c.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a;class t extends Error{constructor(u){super((0,F.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Ce[281],De([1,0,2,29,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function R(C){return!!C&&typeof C=="object"&&"uri"in C&&C.uri instanceof P.URI&&"version"in C&&typeof C.version=="number"&&"ranges"in C&&Array.isArray(C.ranges)&&C.ranges.every(F.Range.isIRange)}e.isIDocumentContext=R;function A(C){return!!C&&typeof C=="object"&&"documents"in C&&Array.isArray(C.documents)&&C.documents.every(R)}e.isIUsedContext=A;var w;(function(C){C[C.Down=0]="Down",C[C.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var E;(function(C){C[C.Action=1]="Action",C[C.Toolbar=2]="Toolbar"})(E||(e.ChatCopyKind=E={})),e.IChatService=(0,p.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Ce[140],De([1,0,4,8,228]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new P.Emitter,this._onExit=new P.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(w){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=w}onEvent(w){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=w}onRequest(w){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=w}sendResponse(w){w.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.internalSend("response",w)}sendRequest(w,E,C,L){const I={command:w};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.internalSend("request",I),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const y=this.pendingRequests.get(I.seq);if(y){this.pendingRequests.delete(I.seq);const _={type:"response",seq:0,request_seq:I.seq,success:!1,command:w,message:(0,p.localize)(0,null,L,w)};y(_)}},L)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(w){this.messageCallback?this.messageCallback(w):(this.queue.push(w),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(w,E){return w.type!=="event"||E.type!=="event"}async processQueue(){let w;for(;this.queue.length;){if((!w||this.needsTaskBoundaryBetween(this.queue[0],w))&&await(0,F.timeout)(0),w=this.queue.shift(),!w)return;switch(w.type){case"event":this.eventCallback?.(w);break;case"request":this.requestCallback?.(w);break;case"response":{const E=w,C=this.pendingRequests.get(E.request_seq);C&&(this.pendingRequests.delete(E.request_seq),C(E));break}}}}internalSend(w,E){E.type=w,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const w=new Map;this.pendingRequests.forEach((E,C)=>w.set(C,E)),await(0,F.timeout)(500),w.forEach((E,C)=>{E({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(Ce[282],De([1,0,2,229,45,5]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new p.RawContextKey("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new p.RawContextKey("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new p.RawContextKey("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new p.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:F.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new p.RawContextKey("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new p.RawContextKey("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new p.RawContextKey("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new p.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new p.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new p.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new p.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new p.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new p.RawContextKey("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new p.RawContextKey("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new p.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new p.RawContextKey("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new p.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new p.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new p.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new p.RawContextKey("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new p.RawContextKey("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new p.RawContextKey("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new p.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:F.localize(22,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new p.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new p.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new p.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:F.localize(25,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new p.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new p.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(27,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new p.RawContextKey("stepBackSupported",!1,{type:"boolean",description:F.localize(28,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new p.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new p.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(30,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new p.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(31,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new p.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new p.RawContextKey("breakpointsExist",!1,{type:"boolean",description:F.localize(33,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new p.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:F.localize(34,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new p.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(35,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new p.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(36,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new p.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(37,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new p.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new p.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new p.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new p.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new p.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new p.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new p.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(44,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new p.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:F.localize(45,null)}),e.CONTEXT_VARIABLE_VALUE=new p.RawContextKey("variableValue",!1,{type:"string",description:F.localize(46,null)}),e.CONTEXT_VARIABLE_TYPE=new p.RawContextKey("variableType",!1,{type:"string",description:F.localize(47,null)}),e.CONTEXT_VARIABLE_NAME=new p.RawContextKey("variableName",!1,{type:"string",description:F.localize(48,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new p.RawContextKey("variableLanguage",!1,{type:"string",description:F.localize(49,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new p.RawContextKey("variableExtensionId",!1,{type:"string",description:F.localize(50,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new p.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(51,null)}),e.CONTEXT_MULTI_SESSION_REPL=new p.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:F.localize(52,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new p.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:F.localize(53,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new p.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(54,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new p.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(55,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new p.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(56,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new p.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(57,null)});const A=o=>F.localize(58,null,o);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(59,null)};var w;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(w||(e.State=w={}));function E(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=E;var C;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(C||(e.MemoryRangeType=C={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var L;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(L||(e.DebugConfigurationProviderTriggerKind=L={}));var I;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(I||(e.DebuggerString=I={})),e.IDebugService=(0,R.createDecorator)("debugService");var v;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE",o[o.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var y;(function(o){o[o.Command=0]="Command",o[o.Tree=1]="Tree"})(y||(e.DebugVisualizationType=y={}));var _;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(_||(e.DebugTreeItemCollapsibleState=_={}));var l;(function(o){o.deserialize=i=>i,o.serialize=i=>i})(l||(e.IDebugVisualizationTreeItem=l={}));var b;(function(o){o.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:P.URI.revive(i.iconPath.light),dark:P.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),o.serialize=i=>i})(b||(e.IDebugVisualization=b={}))}),define(Ce[283],De([1,0,12,2,17,24,16,29,22,19]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function I(D,g,f){return D.replace(L,function(S,T){return g&&T.length>0&&T[0]!=="_"?S:f&&f.hasOwnProperty(T)?f[T]:S})}e.formatPII=I;function v(D){const g={};for(const f of Object.keys(D))f.startsWith("!")||(g[f]=D[f]);return g}e.filterExceptionsFromTelemetry=v;function y(D){return D.configuration.request==="attach"&&!_(D)&&(!D.parentSession||y(D.parentSession))}e.isSessionAttach=y;function _(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,P.equalsIgnoreCase)(g,"extensionhost")||(0,P.equalsIgnoreCase)(g,"pwa-extensionhost")?D:D.parentSession?_(D.parentSession):void 0}e.getExtensionHostDebugSession=_;function l(D){return D.type&&(D.label||D.program||D.runtime)}e.isDebuggerMainContribution=l;function b(D,g,f){let S,T=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=N.exec(D);){const x=z.index+1,M=x+z[0].length;if(x<=g&&M>=f){S=z[0],T=x;break}}if(S){const x=/\w+/g;let M=null;for(;(M=x.exec(S))&&!(M.index+1+T+M[0].length>=f););M&&(S=S.substring(0,x.lastIndex))}return S?{start:T,end:T+S.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;async function o(D,g,f,S){if(D.evaluatableExpressionProvider.has(g)){const T=D.evaluatableExpressionProvider.ordered(g),N=(0,C.coalesce)(await Promise.all(T.map(async z=>{try{return await z.provideEvaluatableExpression(g,f,S??E.CancellationToken.None)}catch{return}})));if(N.length>0){let z=N[0].expression;const x=N[0].range;return z||(z=g.getLineContent(f.lineNumber).substring(x.startColumn-1,x.endColumn-1)),{range:x,matchingExpression:z}}}else{const T=g.getLineContent(f.lineNumber),{start:N,end:z}=b(T,f.column,f.column),x=T.substring(N-1,z);return{matchingExpression:x,range:new w.Range(f.lineNumber,N,f.lineNumber,N+x.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.isUri=n;function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return F.URI.parse(D.path);if((0,p.isAbsolute)(D.path))return F.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const g=F.URI.revive(D.path);if(g)return g.scheme===A.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const f=g?r:a,S=(0,R.deepClone)(D);return u(S,(T,N)=>{T&&N&&(N.path=f(N))}),S}e.convertToDAPaths=t;function h(D,g){const f=g?r:a,S=(0,R.deepClone)(D);return u(S,(T,N)=>{!T&&N&&(N.path=f(N))}),S}e.convertToVSCPaths=h;function u(D,g){switch(D.type){case"event":{const f=D;switch(f.event){case"output":g(!1,f.body.source);break;case"loadedSource":g(!1,f.body.source);break;case"breakpoint":g(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=D;switch(f.command){case"setBreakpoints":g(!0,f.arguments.source);break;case"breakpointLocations":g(!0,f.arguments.source);break;case"source":g(!0,f.arguments.source);break;case"gotoTargets":g(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(S=>g(!1,S));break;default:break}break}case"response":{const f=D;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(S=>g(!1,S.source));break;case"loadedSources":f.body.sources.forEach(S=>g(!1,S));break;case"scopes":f.body.scopes.forEach(S=>g(!1,S.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(S=>g(!1,S.source));break;case"setBreakpoints":f.body.breakpoints.forEach(S=>g(!1,S.source));break;case"disassemble":f.body?.instructions.forEach(T=>g(!1,T.location));break;default:break}break}}}function s(D){return D.filter(g=>!g.presentation?.hidden).sort((g,f)=>g.presentation?f.presentation?g.presentation.group?f.presentation.group?g.presentation.group!==f.presentation.group?g.presentation.group.localeCompare(f.presentation.group):c(g.presentation.order,f.presentation.order):-1:f.presentation.group?1:c(g.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=s;function c(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function d(D,g){const f=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(f!=="none"&&(await g.saveAll(),f==="allEditorsInActiveGroup")){const S=g.activeEditorPane;S&&S.input.resource?.scheme===A.Schemas.untitled&&await g.save({editor:S.input,groupId:S.group.id})}await D.reloadConfiguration()}e.saveAllBeforeDebugStart=d;const m=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.sourcesEqual=m}),define(Ce[284],De([1,0,51,62,24,17,11,12,31,230,140]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends L.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(o,i){this.outputStream=i,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,o.on("data",n=>this.handleData(n))}sendMessage(o){if(this.outputStream){const i=JSON.stringify(o);this.outputStream.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.TWO_CRLF}${i}`,"utf8")}}handleData(o){for(this.rawData=Buffer.concat([this.rawData,o]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const i=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this._onError.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.rawData.indexOf(I.TWO_CRLF);if(i!==-1){const r=this.rawData.toString("utf8",0,i).split(I.HEADER_LINESEPARATOR);for(const a of r){const t=a.split(I.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(i+I.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=I;class v extends I{startSession(){return new Promise((o,i)=>{let n=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),o(),n=!0}),this.socket.on("close",()=>{n?this._onError.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.socket.on("error",r=>{n?this._onError.fire(r):i(r)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=v;class y extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return F.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",o)}}e.SocketDebugAdapter=y;class _ extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return F.createConnection(this.adapterServer.path,o)}}e.NamedPipeDebugAdapter=_;class l extends I{constructor(o,i){super(),this.adapterExecutable=o,this.debugType=i}async startSession(){const o=this.adapterExecutable.command,i=this.adapterExecutable.args,n=this.adapterExecutable.options||{};try{if(o)if(R.isAbsolute(o)){if(!await E.Promises.exists(o))throw new Error(C.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=p.mixin(p.deepClone(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const h=P.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(C.localize(2,null,i[0]));this.serverProcess=h}else throw new Error(C.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.serverProcess=P.spawn(o,i,a)}this.serverProcess.on("error",a=>{this._onError.fire(a)}),this.serverProcess.on("exit",(a,t)=>{this._onExit.fire(a)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stdin.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(r){this._onError.fire(r)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((o,i)=>{const n=P.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=R.join(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(R.isAbsolute(o.program)?n.program=o.program:n.program=R.join(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=l.extract(r.win,i)),r.winx86&&(n.winx86=l.extract(r.winx86,i)),r.windows&&(n.windows=l.extract(r.windows,i)),r.osx&&(n.osx=l.extract(r.osx,i)),r.linux&&(n.linux=l.extract(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const s of o)if(s.contributes){const c=s.contributes.debuggers;c&&c.length>0&&c.filter(d=>typeof d.type=="string"&&w.equalsIgnoreCase(d.type,i)).forEach(d=>{const m=l.extract(d,s.extensionLocation.fsPath);n=p.mixin(n,m,s.isBuiltin)})}let r;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:A.isWindows?r=n.win||n.windows:A.isMacintosh?r=n.osx:A.isLinux&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,h=r.runtime||n.runtime,u=r.runtimeArgs||n.runtimeArgs;if(h)return{type:"executable",command:h,args:(u||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.ExecutableDebugAdapter=l}),define(Ce[285],De([1,0,51,34,11]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(C,L){return new Promise((I,v)=>{let y="";const _=P.spawn(C,L);_.pid&&_.stdout.on("data",l=>{y+=l.toString()}),_.on("error",l=>{v(l)}),_.on("close",l=>{I(y)})})}async function A(C){if(C)if(p.isWindows){const L=await new Promise((I,v)=>{me(["@vscode/windows-process-tree"],I,v)});return new Promise(I=>{L.getProcessTree(C,v=>{I(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(C)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=A;var w;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(w||(w={}));function E(C,L,I,v,y){C=C.trim().toLowerCase();let _;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?_=1:C.indexOf("cmd.exe")>=0?_=0:C.indexOf("bash")>=0?_=2:p.isWindows?_=0:_=2;let l,b=" ";switch(_){case 1:if(l=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),v){const o=(0,F.getDriveLetter)(v);o&&(b+=`${o}:; `),b+=`cd ${l(v)}; `}if(y)for(const o in y){const i=y[o];i===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${i}'; `}if(L.length>0){const o=L.shift(),i=I?o:l(o);b+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of L)b+=n==="<"||n===">"||I?n:l(n),b+=" "}break;case 0:if(l=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),v){const o=(0,F.getDriveLetter)(v);o&&(b+=`${o}: && `),b+=`cd ${l(v)} && `}if(y){b+='cmd /C "';for(const o in y){let i=y[o];i===null?b+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),b+=`set "${o}=${i}" && `)}}for(const o of L)b+=o==="<"||o===">"||I?o:l(o),b+=" ";y&&(b+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(v&&(b+=`cd ${l(v)} ; `),y){b+="/usr/bin/env";for(const i in y){const n=y[i];n===null?b+=` -u ${o(i)}`:b+=` ${o(`${i}=${n}`)}`}b+=" "}for(const i of L)b+=i==="<"||i===">"||I?i:l(i),b+=" ";break}}return b}e.prepareCommand=E}),define(Ce[286],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(p){p[p.Output=1]="Output",p[p.OutputItems=2]="OutputItems",p[p.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.INotebookExecutionService=(0,P.createDecorator)("INotebookExecutionService")}),define(Ce[287],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var F;(function(p){p[p.Disconnected=1]="Disconnected",p[p.Connected=2]="Connected",p[p.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.INotebookKernelService=(0,P.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,P.createDecorator)("INotebookKernelHistoryService")}),define(Ce[288],De([1,0,3,29,194,99]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class A extends P.Disposable{constructor(E,C,L){super(),this._source=E,this._inputTextBuffer=C,this._outputs=L,this._outputTextBuffers=void 0}_getFullModelRange(E){const C=E.getLineCount();return new F.Range(1,1,C,this._getLineMaxColumn(E,C))}_getLineMaxColumn(E,C){if(C<1||C>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(C)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const E=new p.PieceTreeTextBufferBuilder;E.acceptChunk(this._source);const C=E.finish(!0),{textBuffer:L,disposable:I}=C.create(1);this._inputTextBuffer=L,this._register(I)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(E=>{const C=new p.PieceTreeTextBufferBuilder;C.acceptChunk(E);const L=C.finish(!0),{textBuffer:I,disposable:v}=L.create(1);return this._register(v),I})),this._outputTextBuffers}findInInputs(E){const L=new R.SearchParams(E,!1,!1,null).parseSearchRequest();if(!L)return[];const I=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,L,!0,5e3)}findInOutputs(E){const L=new R.SearchParams(E,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(I=>{const v=I.findMatchesLineByLine(this._getFullModelRange(I),L,!0,5e3);if(v.length!==0)return{textBuffer:I,matches:v}}).filter(I=>!!I):[]}}e.CellSearchModel=A}),define(Ce[67],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var P;(function(R){R.Delimiter="\0"})(P||(e.TestIdPathParts=P={}));var F;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class p{static fromExtHostTestItem(A,w,E=A.parent){if(A._isRoot)return new p([w]);const C=[A.id];for(let L=E;L&&L.id!==w;L=L.parent)C.push(L.id);return C.push(w),new p(C.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const w=A.indexOf("\0");return w===-1?A:A.slice(0,w)}static fromString(A){return new p(A.split("\0"))}static join(A,w){return new p([...A.path,w])}static joinToString(A,w){return A.toString()+"\0"+w}static parentId(A){const w=A.lastIndexOf("\0");return w===-1?void 0:A.slice(0,w)}static localId(A){const w=A.lastIndexOf("\0");return w===-1?A:A.slice(w+1)}static isChild(A,w){return w.startsWith(A)&&w[A.length]==="\0"}static compare(A,w){return A===w?0:p.isChild(A,w)?2:p.isChild(w,A)?3:1}constructor(A,w=A.length){if(this.path=A,this.viewEnd=w,A.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new p(this.path,1)}get parentId(){return this.viewEnd>1?new p(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new p(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new p(this.path,A)}compare(A){if(typeof A=="string")return p.compare(this.toString(),A);for(let w=0;w<A.viewEnd&&w<this.viewEnd;w++)if(A.path[w]!==this.path[w])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=p}),define(Ce[89],De([1,0,2,49,29,67]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var w;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var E;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(E||(e.TestRunProfileBitset=E={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const C=k=>"runId"in k;e.isStartControllerTests=C;var L;(function(k){k.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),k.deserialize=(O,U)=>({range:p.Range.lift(U.range),uri:O.asCanonicalUri(P.URI.revive(U.uri))})})(L||(e.IRichLocation=L={}));var I;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(I||(e.TestMessageType=I={}));var v;(function(k){k.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&L.serialize(O.location)}),k.deserialize=(O,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&L.deserialize(O,U.location)})})(v||(e.ITestErrorMessage=v={}));const y=(k,O)=>`${O?"s":"e"}${k}`;e.getMarkId=y;var _;(function(k){k.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&L.serialize(O.location)}),k.deserialize=(O,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&L.deserialize(O,U.location)})})(_||(e.ITestOutputMessage=_={}));var l;(function(k){k.serialize=O=>O.type===0?v.serialize(O):_.serialize(O),k.deserialize=(O,U)=>U.type===0?v.deserialize(O,U):_.deserialize(O,U)})(l||(e.ITestMessage=l={}));var b;(function(k){k.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),k.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(l.serialize)}),k.deserialize=(O,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(q=>l.deserialize(O,q))})})(b||(e.ITestTaskState=b={}));const o="\0",i=(k,O)=>k+o+O;e.namespaceTestTag=i;const n=k=>{const O=k.indexOf(o);return{ctrlId:k.slice(0,O),tagId:k.slice(O+1)}};e.denamespaceTestTag=n;var r;(function(k){k.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),k.deserialize=(O,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?O.asCanonicalUri(P.URI.revive(U.uri)):void 0,range:U.range?p.Range.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(r||(e.ITestItem=r={}));var a;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(k){k.serialize=O=>({expand:O.expand,item:r.serialize(O.item)}),k.deserialize=(O,U)=>({controllerId:R.TestId.root(U.item.extId),expand:U.expand,item:r.deserialize(O,U.item)})})(t||(e.InternalTestItem=t={}));var h;(function(k){k.serialize=O=>{let U;return O.item&&(U={},O.item.label!==void 0&&(U.label=O.item.label),O.item.tags!==void 0&&(U.tags=O.item.tags),O.item.busy!==void 0&&(U.busy=O.item.busy),O.item.uri!==void 0&&(U.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(U.range=O.item.range?.toJSON()),O.item.description!==void 0&&(U.description=O.item.description),O.item.error!==void 0&&(U.error=O.item.error),O.item.sortText!==void 0&&(U.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:U}},k.deserialize=O=>{let U;return O.item&&(U={},O.item.label!==void 0&&(U.label=O.item.label),O.item.tags!==void 0&&(U.tags=O.item.tags),O.item.busy!==void 0&&(U.busy=O.item.busy),O.item.range!==void 0&&(U.range=O.item.range?p.Range.lift(O.item.range):null),O.item.description!==void 0&&(U.description=O.item.description),O.item.error!==void 0&&(U.error=O.item.error),O.item.sortText!==void 0&&(U.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:U}}})(h||(e.ITestItemUpdate=h={}));const u=(k,O)=>{O.expand!==void 0&&(k.expand=O.expand),O.item!==void 0&&(k.item=k.item?Object.assign(k.item,O.item):O.item)};e.applyTestItemUpdate=u;var s;(function(k){k.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(b.serializeWithoutMessages)}),k.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(b.serialize)}),k.deserialize=(O,U)=>({...t.deserialize(O,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(q=>b.deserialize(O,q)),retired:!0})})(s||(e.TestResultItem=s={}));var c;(function(k){k.empty=()=>({covered:0,total:0}),k.sum=(O,U)=>{O.covered+=U.covered,O.total+=U.total}})(c||(e.ICoveredCount=c={}));var d;(function(k){k.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(f.serialize),uri:O.uri.toJSON()}),k.deserialize=(O,U)=>({statement:U.statement,branch:U.branch,declaration:U.declaration,details:U.details?.map(f.deserialize),uri:O.asCanonicalUri(P.URI.revive(U.uri))})})(d||(e.IFileCoverage=d={}));function m(k){return{...k,location:k.location?.toJSON()}}function D(k){return k.location=k.location?F.Position.isIPosition(k.location)?F.Position.lift(k.location):p.Range.lift(k.location):void 0,k}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var g;(function(k){k[k.Declaration=0]="Declaration",k[k.Statement=1]="Statement",k[k.Branch=2]="Branch"})(g||(e.DetailType=g={}));var f;(function(k){k.serialize=O=>O.type===0?T.serialize(O):N.serialize(O),k.deserialize=O=>O.type===0?T.deserialize(O):N.deserialize(O)})(f||(e.CoverageDetails=f={}));var S;(function(k){k.serialize=m,k.deserialize=D})(S||(e.IBranchCoverage=S={}));var T;(function(k){k.serialize=m,k.deserialize=D})(T||(e.IDeclarationCoverage=T={}));var N;(function(k){k.serialize=O=>({...m(O),branches:O.branches?.map(S.serialize)}),k.deserialize=O=>({...D(O),branches:O.branches?.map(S.deserialize)})})(N||(e.IStatementCoverage=N={}));var z;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var x;(function(k){k.deserialize=(O,U)=>U.op===0?{op:U.op,item:t.deserialize(O,U.item)}:U.op===1?{op:U.op,item:h.deserialize(U.item)}:U.op===2?{op:U.op,uri:O.asCanonicalUri(P.URI.revive(U.uri)),docv:U.docv}:U,k.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:h.serialize(O.item)}:O})(x||(e.TestsDiffOp=x={}));class M{constructor(O){this.uriIdentity=O,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(O){const U=this.createChangeCollector();for(const q of O)switch(q.op){case 0:this.add(t.deserialize(this.uriIdentity,q.item),U);break;case 1:this.update(h.deserialize(q.item),U);break;case 3:this.remove(q.itemId,U);break;case 5:this.retireTest(q.itemId);break;case 4:this.updatePendingRoots(q.amount);break;case 6:this._tags.set(q.tag.id,q.tag);break;case 7:this._tags.delete(q.id);break}U.complete?.()}add(O,U){const q=R.TestId.parentId(O.item.extId)?.toString();let ie;if(!q)ie=this.createItem(O),this.roots.add(ie),this.items.set(O.item.extId,ie);else if(this.items.has(q)){const Z=this.items.get(q);Z.children.add(O.item.extId),ie=this.createItem(O,Z),this.items.set(O.item.extId,ie)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return U.add?.(ie),O.expand===2&&this.busyControllerCount++,ie}update(O,U){const q=this.items.get(O.extId);if(q)return O.expand!==void 0&&(q.expand===2&&this.busyControllerCount--,O.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(q,O),U.update?.(q),q}remove(O,U){const q=this.items.get(O);if(!q)return;const ie=R.TestId.parentId(q.item.extId)?.toString();ie?this.items.get(ie).children.delete(q.item.extId):this.roots.delete(q);const Z=[[O]];for(;Z.length;)for(const Q of Z.pop()){const Y=this.items.get(Q);Y&&(Z.push(Y.children),this.items.delete(Q),U.remove?.(Y,Y!==q),Y.expand===2&&this.busyControllerCount--)}}retireTest(O){}updatePendingRoots(O){this.pendingRootCount+=O}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=M}),define(Ce[111],De([1,0,8,4,3,61,89,67]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const C=(i,n)=>i===n,I=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:C,label:C,description:C,error:C,sortText:C,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),v=(i,n)=>{let r;for(const[a,t]of I)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class y extends p.Disposable{get root(){return this.options.root}constructor(n){super(),this.options=n,this.debounceSendDiff=this._register(new P.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const r of this.tree.values())this.updateExpandability(r)}get resolveHandler(){return this._resolveHandler}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.diff)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.diff[this.diff.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,A.applyTestItemUpdate)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,A.applyTestItemUpdate)(r.item,n.item);return}}break}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.resolveChildren(a);return t.isOpen()?this.expandChildren(a,r-1):t.wait().then(()=>this.expandChildren(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,r-1)):this.expandChildren(a,r-1)}}dispose(){for(const n of this.tree.values())this.options.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,r){switch(r.op){case 3:this.removeItem(w.TestId.joinToString(n.fullId,r.id));break;case 0:this.upsertItem(r.item,n);break;case 5:for(const a of r.ops)this.onTestItemEvent(n,a);break;case 1:this.diffTagRefs(r.new,r.old,n.fullId.toString());break;case 2:this.updateExpandability(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.documentSynced(n.actual.uri);break;default:(0,R.assertNever)(r)}}documentSynced(n){n&&this.pushDiff({op:2,uri:n,docv:this.options.getDocumentVersion(n)})}upsertItem(n,r){const a=w.TestId.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.options.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.options.getChildren(t.parent).delete(n.id);let h=this.tree.get(a.toString());if(!h){h={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(h.fullId.toString(),h),this.setItemParent(n,r),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:h.expand,item:this.options.toITestItem(n)}}),this.connectItemAndChildren(n,h,r);return}if(h.actual===n){this.connectItem(n,h,r);return}if(h.actual.uri?.toString()!==n.uri?.toString())return this.removeItem(a.toString()),this.upsertItem(n,r);const u=this.options.getChildren(h.actual),s=h.actual,c=v(this.options.toITestItem(s),this.options.toITestItem(n));this.options.getApiFor(s).listener=void 0,h.actual=n,h.expand=0,c&&(c.hasOwnProperty("tags")&&(this.diffTagRefs(n.tags,s.tags,a.toString()),delete c.tags),this.onTestItemEvent(h,{op:4,update:c})),this.connectItemAndChildren(n,h,r);for(const[d,m]of u)this.options.getChildren(n).get(m.id)||this.removeItem(w.TestId.joinToString(a,m.id));this.documentSynced(h.actual.uri)}diffTagRefs(n,r,a){const t=new Set(r.map(h=>h.id));for(const h of n)t.delete(h.id)||this.incrementTagRefs(h);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(h=>(0,A.namespaceTestTag)(this.options.controllerId,h.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const r=this.tags.get(n.id);r?r.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,n.id)}}))}decrementTagRefs(n){const r=this.tags.get(n);r&&!--r.refCount&&(this.tags.delete(n),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,n)}))}setItemParent(n,r){this.options.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}connectItem(n,r,a){this.setItemParent(n,a);const t=this.options.getApiFor(n);t.parent=a?.actual,t.listener=h=>this.onTestItemEvent(r,h),this.updateExpandability(r)}connectItemAndChildren(n,r,a){this.connectItem(n,r,a);for(const[t,h]of this.options.getChildren(n))this.upsertItem(h,r)}updateExpandability(n){let r;this._resolveHandler?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,r){if(r<0)return;const a=[];for(const[t,h]of this.options.getChildren(n.actual)){const u=this.expand(w.TestId.joinToString(n.fullId,h.id),r);(0,P.isThenable)(u)&&a.push(u)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const h=new P.Barrier;return h.open(),h}n.expand=2,this.pushExpandStateUpdate(n);const r=n.resolveBarrier=new P.Barrier,a=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,h)};let t;try{t=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(h){a(h)}return(0,P.isThenable)(t)?t.catch(a).then(()=>{r.open(),this.updateExpandability(n)}):(r.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}removeItem(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.decrementTagRefs(h.id);this.tree.delete(t.fullId.toString());for(const[h,u]of this.options.getChildren(t.actual))a.push(this.tree.get(w.TestId.joinToString(t.fullId,u.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.TestItemCollection=y;class _ extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.DuplicateTestItemError=_;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;class b extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=b;const o=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,h){for(const u of a.values())t.call(h,u,this)},[Symbol.iterator](){return a.entries()},replace(t){const h=new Map,u=new Set(a.keys()),s={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new l(c.id);const d=n(c).controllerId;if(d!==i.controllerId)throw new b(c.id,d,i.controllerId);if(h.has(c.id))throw new _(c.id);h.set(c.id,c),u.delete(c.id),s.ops.push({op:0,item:c})}for(const c of u.keys())s.ops.push({op:3,id:c});i.listener?.(s),a=h},add(t){if(!(t instanceof r))throw new l(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=o}),define(Ce[141],De([1,0,111]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const F=new WeakMap,p=(A,w)=>{const E={controllerId:w};return F.set(A,E),E};e.createPrivateApiFor=p;const R=A=>{const w=F.get(A);if(!w)throw new P.InvalidTestItemError(A?.id||"<unknown>");return w};e.getPrivateApiFor=R}),define(Ce[112],De([1,0,16,2]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function p(w,E){return w.scheme===P.Schemas.http||w.scheme===P.Schemas.https?w:(E&&E.authority&&E.isRemote&&w.scheme===P.Schemas.file&&(w=F.URI.from({scheme:P.Schemas.vscodeRemote,authority:E.authority,path:w.path})),F.URI.from({scheme:P.Schemas.https,authority:`${w.scheme}+${R(w.authority)}.${e.webviewRootResourceAuthority}`,path:w.path,fragment:w.fragment,query:w.query}))}e.asWebviewUri=p;function R(w){return w.replace(/./g,E=>{const C=E.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?E:"-"+C.toString(16).padStart(4,"0")})}function A(w){return w.replace(/-([0-9a-f]{4})/g,(E,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=A}),define(Ce[289],De([1,0,4,3,112]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(w,E,C){this._proxy=w,this._editors=E,this._remoteInfo=C,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const L=E.getVisibleTextEditors();for(const I of this._insets.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(w=>w.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(w,E,C,L,I){let v;for(const n of this._editors.getVisibleTextEditors(!0))if(n.value===w){v=n;break}if(!v)throw new Error("not a visible editor");const y=this,_=this._handlePool++,l=new P.Emitter,b=new P.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(n){return(0,p.asWebviewUri)(n,y._remoteInfo)}get cspSource(){return p.webviewGenericCspSource}set options(n){this._options=n,y._proxy.$setOptions(_,n)}get options(){return this._options}set html(n){this._html=n,y._proxy.$setHtml(_,n)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(n){return y._proxy.$postMessage(_,n)}},i=new class{constructor(){this.editor=w,this.line=E,this.height=C,this.webview=o,this.onDidDispose=b.event}dispose(){y._insets.has(_)&&(y._insets.delete(_),y._proxy.$disposeEditorInset(_),b.fire(),b.dispose(),l.dispose())}};return this._proxy.$createEditorInset(_,v.id,v.value.document.uri,E+1,C,L||{},I.identifier,I.extensionLocation),this._insets.set(_,{editor:w,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(w){const E=this._insets.get(w);E&&E.inset.dispose()}$onDidReceiveMessage(w,E){this._insets.get(w)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=R}),define(Ce[142],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,P.createDecorator)("IAuthenticationService")}),define(Ce[290],De([1,0,5]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,P.createDecorator)("configurationResolverService");var F;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class p extends Error{constructor(A,w){super(w),this.variable=A}}e.VariableError=p}),define(Ce[291],De([1,0,17,50,18,24,11,102,233,290,12]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,_,l,b){this._contributedVariables=new Map,this._context=y,this._labelService=_,this._userHomePromise=l,b&&(this._envVariablesPromise=b.then(o=>this.prepareEnv(o)))}prepareEnv(y){if(A.isWindows){const _=Object.create(null);return Object.keys(y).forEach(l=>{_[l.toLowerCase()]=y[l]}),_}return y}resolveWithEnvironment(y,_,l){return this.recursiveResolve({env:this.prepareEnv(y),userHome:void 0},_?_.uri:void 0,l)}async resolveAsync(y,_){const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,y?y.uri:void 0,_)}async resolveAnyBase(y,_,l,b){const o=R.deepClone(_);A.isWindows&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):A.isMacintosh&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):A.isLinux&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(i,y?y.uri:void 0,o,l,b)}async resolveAnyAsync(y,_,l){return this.resolveAnyBase(y,_,l)}async resolveAnyMap(y,_,l){const b=new Map;return{newConfig:await this.resolveAnyBase(y,_,l,b),resolvedVariables:b}}resolveWithInteractionReplace(y,_,l,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,_,l,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,_){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,_)}async recursiveResolve(y,_,l,b,o){if(p.isString(l))return this.resolveString(y,_,l,b,o);if(Array.isArray(l))return Promise.all(l.map(i=>this.recursiveResolve(y,_,i,b,o)));if(p.isObject(l)){const i=Object.create(null),n=await Promise.all(Object.keys(l).map(async r=>[await this.resolveString(y,_,r,b,o),await this.recursiveResolve(y,_,l[r],b,o)]));for(const[r,a]of n)i[r]=a;return i}return l}resolveString(y,_,l,b,o){return(0,L.replaceAsync)(l,I.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(I.VARIABLE_LHS))return i;let r=await this.evaluateSingleVariable(y,i,n,_,b);return o?.set(n,r),r!==i&&p.isString(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.resolveString(y,_,r,b,o)),r})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}async evaluateSingleVariable(y,_,l,b,o){let i;const n=l.split(":");n.length>1&&(l=n[0],i=n[1]);const r=h=>{const u=this._context.getFilePath();if(u)return(0,w.normalizeDriveLetter)(u);throw new C.VariableError(h,(0,E.localize)(0,null,_))},a=h=>{const u=r(h);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,w.normalizeDriveLetter)(s)}throw new C.VariableError(h,(0,E.localize)(1,null,_,P.basename(u)))},t=h=>{if(i){const u=this._context.getFolderUri(i);if(u)return u;throw new C.VariableError(h,(0,E.localize)(2,null,_,i))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new C.VariableError(h,(0,E.localize)(3,null,_)):new C.VariableError(h,(0,E.localize)(4,null,_))};switch(l){case"env":if(i){if(y.env){const h=y.env[A.isWindows?i.toLowerCase():i];if(p.isString(h))return h}return""}throw new C.VariableError(C.VariableKind.Env,(0,E.localize)(5,null,_));case"config":if(i){const h=this._context.getConfigurationValue(b,i);if(p.isUndefinedOrNull(h))throw new C.VariableError(C.VariableKind.Config,(0,E.localize)(6,null,_,i));if(p.isObject(h))throw new C.VariableError(C.VariableKind.Config,(0,E.localize)(7,null,_,i));return h}throw new C.VariableError(C.VariableKind.Config,(0,E.localize)(8,null,_));case"command":return this.resolveFromMap(C.VariableKind.Command,_,i,o,"command");case"input":return this.resolveFromMap(C.VariableKind.Input,_,i,o,"input");case"extensionInstallFolder":if(i){const h=await this._context.getExtension(i);if(!h)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,_,i));return this.fsPath(h.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,_));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,w.normalizeDriveLetter)(this.fsPath(t(C.VariableKind.WorkspaceFolder)));case"cwd":return b||i?(0,w.normalizeDriveLetter)(this.fsPath(t(C.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.normalizeDriveLetter)(P.basename(this.fsPath(t(C.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,E.localize)(11,null,_))}case"lineNumber":{const h=this._context.getLineNumber();if(h)return h;throw new C.VariableError(C.VariableKind.LineNumber,(0,E.localize)(12,null,_))}case"selectedText":{const h=this._context.getSelectedText();if(h)return h;throw new C.VariableError(C.VariableKind.SelectedText,(0,E.localize)(13,null,_))}case"file":return r(C.VariableKind.File);case"fileWorkspaceFolder":return a(C.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return P.basename(a(C.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return b||i?P.relative(this.fsPath(t(C.VariableKind.RelativeFile)),r(C.VariableKind.RelativeFile)):r(C.VariableKind.RelativeFile);case"relativeFileDirname":{const h=P.dirname(r(C.VariableKind.RelativeFileDirname));if(b||i){const u=P.relative(this.fsPath(t(C.VariableKind.RelativeFileDirname)),h);return u.length===0?".":u}return h}case"fileDirname":return P.dirname(r(C.VariableKind.FileDirname));case"fileExtname":return P.extname(r(C.VariableKind.FileExtname));case"fileBasename":return P.basename(r(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=P.basename(r(C.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-P.extname(h).length)}case"fileDirnameBasename":return P.basename(P.dirname(r(C.VariableKind.FileDirnameBasename)));case"execPath":{const h=this._context.getExecPath();return h||_}case"execInstallFolder":{const h=this._context.getAppRoot();return h||_}case"pathSeparator":case"/":return P.sep;default:try{const h=i?`${l}:${i}`:l;return this.resolveFromMap(C.VariableKind.Unknown,_,h,o,void 0)}catch{return _}}}}resolveFromMap(y,_,l,b,o){if(l&&b){const i=o===void 0?b[l]:b[o+":"+l];if(typeof i=="string")return i;throw new C.VariableError(y,(0,E.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=I}),define(Ce[143],De([1,0,5,139]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,P.createDecorator)("editorGroupsService");var p;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(p||(e.GroupDirection=p={}));var R;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var w;(function(_){_[_.MAXIMIZE=0]="MAXIMIZE",_[_.EXPAND=1]="EXPAND",_[_.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var E;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function C(_){const l=_;return(0,F.isEditorInput)(l?.editor)&&(0,F.isEditorInput)(l?.replacement)}e.isEditorReplacement=C;var L;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var I;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function v(_){const l=_;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=v;function y(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Ce[292],De([1,0,5,143]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,P.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function p(R){const A=R;return typeof R=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=p}),define(Ce[144],De([1,0,5,133]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,P.refineServiceDecorator)(F.IEnvironmentService)}),define(Ce[145],De([1,0,25,4,17,3,8]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class w{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.DeltaExtensionsResult=w;class E{static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const a=r.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this._activationEventsReader=i,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(l),this._extensionsMap=new P.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const n=this._activationEventsReader.readActivationEvents(i);for(const r of n)this._activationMap.has(r)||this._activationMap.set(r,[]),this._activationMap.get(r).push(i)}}set(i){return this._extensionDescriptions=i,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(i,n){this._extensionDescriptions=b(this._extensionDescriptions,n),this._extensionDescriptions=this._extensionDescriptions.concat(i);const r=E._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=b(this._extensionDescriptions,r.map(a=>a.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new w(this._versionId,r)}static _findLoopingExtensions(i){const n=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,s){this.addNode(u),this.addNode(s),this._arcs.has(u)?this._arcs.get(u).push(s):this._arcs.set(u,[s])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,s){const c=n.getArcs(u);for(let d=0;d<c.length;d++)if(!s.has(c[d]))return!1;return!0}getNodes(){return this._nodesArr}},r=new P.ExtensionIdentifierMap;for(const u of i)if(r.set(u.identifier,u),u.extensionDependencies)for(const s of u.extensionDependencies)n.addArc(P.ExtensionIdentifier.toKey(u.identifier),P.ExtensionIdentifier.toKey(s));const a=new Set;n.getNodes().filter(u=>n.getArcs(u).length===0).forEach(u=>a.add(u));const t=n.getNodes().filter(u=>!a.has(u));let h;do{h=!1;for(let u=0;u<t.length;u++){const s=t[u];n.hasOnlyGoodArcs(s,a)&&(t.splice(u,1),u--,a.add(s),h=!0)}}while(h);return t.map(u=>r.get(u))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this._activationMap.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new C(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this._extensionsMap.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this._extensionsArr)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.ExtensionDescriptionRegistry=E;class C{constructor(i,n){this.versionId=i,this.extensions=n}}e.ExtensionDescriptionRegistrySnapshot=C;class L{constructor(i){this._lock=new y,this._actual=new E(i,[])}async acquireLock(i){const n=await this._lock.acquire(i);return new I(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(n,r)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this._actual.getExtensionDescriptionByIdOrUUID(i,n)}}e.LockableExtensionDescriptionRegistry=L;class I extends R.Disposable{constructor(i,n){super(),this._registry=i,this._isDisposed=!1,this._register(n)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=I;class v{constructor(i){this.name=i;const n=(0,A.promiseWithResolvers)();this.promise=n.promise,this._resolve=n.resolve}resolve(i){this._resolve(i)}}class y{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const n=new v(i);return this._pendingCustomers.push(n),this._advance(),n.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(r),n=!1,this._isLocked=!1,this._advance())};i.resolve((0,R.toDisposable)(a))}}var _;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(_||(_={}));function l(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const a=p.posix.basename(o.extensionLocation.path),t=p.posix.basename(i.extensionLocation.path);return a<t?-1:a>t?1:0}function b(o,i){const n=new P.ExtensionIdentifierSet(i);return o.filter(r=>!n.has(r.identifier))}}),define(Ce[293],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var P;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(P||(e.ExtHostConnectionType=P={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=F;class p{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[p.ENV_KEY]="1"}}e.SocketExtHostConnection=p;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R;function A(L){delete L[F.ENV_KEY],delete L[p.ENV_KEY],delete L[R.ENV_KEY]}function w(L,I){A(I),L.serialize(I)}e.writeExtHostConnection=w;function E(L){if(L[F.ENV_KEY])return C(L,new F(L[F.ENV_KEY]));if(L[p.ENV_KEY])return C(L,new p);if(L[R.ENV_KEY])return C(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function C(L,I){return A(L),I}}),define(Ce[113],De([1,0,21]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(F||(e.UIKind=F={}));var p;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(p||(e.ExtensionHostExitCode=p={}));var R;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A(C){const L=P.VSBuffer.alloc(1);switch(C){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=A;function w(C,L){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=w;var E;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Ce[90],De([1,0,5,4,13,27,113,65,87,24,2,3,219]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let y=class extends I.Disposable{constructor(o,i){super(),this.initData=o,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new F.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new F.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=L.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:E.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(n=>{(0,p.isLogLevel)(n)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===p.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),a=new _(i,n,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this._level=o,this._telemetryIsSupported=i,this._productConfig=n??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=l(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.getRemoteName)((0,E.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this._telemetryLoggers.delete(r):this._telemetryLoggers.set(r,a)}),this._telemetryLoggers.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,i){const r=this._telemetryLoggers.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this._telemetryLoggers.delete(o.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.ExtHostTelemetry=y,e.ExtHostTelemetry=y=Ge([He(0,R.IExtHostInitDataService),He(1,p.ILoggerService)],y);class _{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,a,t,h){this._extension=n,this._logger=r,this._inLoggingOnlyMode=a,this._commonProperties=t,this._onDidChangeEnableStates=new F.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(o,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,E.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,C.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,C.mixin)(i,this._commonProperties)),"properties"in o?o.properties=i:o=i,o}logEvent(o,i){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,i),this._logger.trace(o,i))}logUsage(o,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,i)}logError(o,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof o=="string")this.logEvent(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,E.cleanData)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(a,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=_;function l(b){const o=Date.now()-new Date(b).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=l,e.IExtHostTelemetry=(0,P.createDecorator)("IExtHostTelemetry")}),define(Ce[26],De([1,0,4,2,263,137,25,5]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");class E{constructor(a){this.dependency=a}}e.MissingExtensionDependency=E;var C;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(C||(e.ExtensionHostStartup=C={}));class L{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(a,t,h){this._versionId=a,this._allExtensions=t.slice(0),this._myExtensions=h.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(a,t,h){if(this._versionId>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this._versionId})`);const u=[],s=[],c=[],d=[],m=I(this._allExtensions),D=I(t),g=(z,x)=>z.extensionLocation.toString()===x.extensionLocation.toString()||z.isBuiltin===x.isBuiltin||z.isUserBuiltin===x.isUserBuiltin||z.isUnderDevelopment===x.isUnderDevelopment;for(const z of this._allExtensions){const x=D.get(z.identifier);if(!x){u.push(z.identifier),m.delete(z.identifier);continue}if(!g(z,x)){u.push(z.identifier),m.delete(z.identifier);continue}}for(const z of t){const x=m.get(z.identifier);if(!x){s.push(z);continue}if(!g(x,z)){u.push(x.identifier),m.delete(x.identifier);continue}}const f=new A.ExtensionIdentifierSet(this._myExtensions),S=new A.ExtensionIdentifierSet(h);for(const z of this._myExtensions)S.has(z)||c.push(z);for(const z of h)f.has(z)||d.push(z);const T=R.ImplicitActivationEvents.createActivationEventsMap(s),N={versionId:a,toRemove:u,toAdd:s,addActivationEvents:T,myToRemove:c,myToAdd:d};return this.delta(N),N}delta(a){if(this._versionId>=a.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:u,myToAdd:s}=a,c=new A.ExtensionIdentifierSet(t),d=new A.ExtensionIdentifierSet(u);for(let m=0;m<this._allExtensions.length;m++)c.has(this._allExtensions[m].identifier)&&(this._allExtensions.splice(m,1),m--);for(let m=0;m<this._myExtensions.length;m++)d.has(this._myExtensions[m])&&(this._myExtensions.splice(m,1),m--);for(const m of h)this._allExtensions.push(m);for(const m of s)this._myExtensions.push(m);return this._myActivationEvents=null,a}containsExtension(a){for(const t of this._myExtensions)if(A.ExtensionIdentifier.equals(t,a))return!0;return!1}containsActivationEvent(a){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(a)}_readMyActivationEvents(){const a=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const h=R.ImplicitActivationEvents.readActivationEvents(t);for(const u of h)a.add(u)}return a}}e.ExtensionHostExtensions=L;function I(r){const a=new A.ExtensionIdentifierMap;for(const t of r)a.set(t.identifier,t);return a}function v(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=v;function y(r,a){if(!v(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=y;class _{constructor(a,t,h,u){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=u}}e.ActivationTimes=_;class l{constructor(a,t){this.description=a,this.value=t}}e.ExtensionPointContribution=l;var b;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(b||(e.ActivationKind=b={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,p.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function i(r,a){return{identifier:new A.ExtensionIdentifier((0,p.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=P.Event.None,this.onDidChangeExtensionsStatus=P.Event.None,this.onDidChangeExtensions=P.Event.None,this.onWillActivateByEvent=P.Event.None,this.onDidChangeResponsiveChange=P.Event.None,this.onWillStop=P.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n}),define(Ce[294],De([1,0,14,145,25,26,13,8]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.ExtensionActivationTimes=E;class C{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,i){return o===-1||i===-1?-1:i-o}build(){return new E(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class L{constructor(o,i,n,r,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.ActivatedExtension=L;class I extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class v extends L{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class y extends L{constructor(o){super(!0,o,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let _=class{constructor(o,i,n,r){this._logService=r,this._registry=o,this._globalRegistry=i,this._host=n,this._operations=new p.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this._operations)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this._operations.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this._operations.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this._alreadyActivatedEvents[o])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,i){const n=this._registry.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this._activateExtensions([{id:n.identifier,reason:i}])}async _activateExtensions(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(i.map(n=>n.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const i=this._registry.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this._createAndSaveOperation(o,null,[],new y(a));return this._host.onExtensionActivationError(o.id,a,new R.MissingExtensionDependency(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this._isResolvedExtension(a))continue;const t=this._operations.get(a);if(t){n.push(t);continue}if(this._isHostExtension(a)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(a).identifier,reason:o.reason}));continue}const h=this._registry.getExtensionDescription(a);if(h){if(!h.main&&!h.browser)continue;n.push(this._handleActivationRequest({id:h.identifier,reason:o.reason}));continue}const u=i.displayName||i.identifier.value,s=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${a}'`),c=this._createAndSaveOperation(o,i.displayName,[],new y(s));return this._host.onExtensionActivationError(i.identifier,s,new R.MissingExtensionDependency(a)),c}return this._createAndSaveOperation(o,i.displayName,n,null)}_createAndSaveOperation(o,i,n,r){const a=new l(o.id,i,o.reason,n,r,this._host,this._logService);return this._operations.set(o.id,a),a}_isHostExtension(o){return F.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const i=this._globalRegistry.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=_,e.ExtensionsActivator=_=Ge([He(3,A.ILogService)],_);let l=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,i,n,r,a,t,h){this._id=o,this._displayName=i,this._reason=n,this._deps=r,this._value=a,this._host=t,this._logService=h,this._barrier=new w.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const i=this._deps[o];if(i.value&&!i.value.activationFailed){this._deps.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this._value=new y(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this._value=new y(i),this._isDisposed&&P.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};l=Ge([He(6,A.ILogService)],l)}),define(Ce[295],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[296],De([1,0,235,14,39,134,108,37,25,295,136,137]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=w.Registry.as(A.Extensions.JSONContribution);class y{constructor(a,t,h){this._messageHandler=a,this._extension=t,this._extensionPointId=h}_msg(a,t){this._messageHandler({type:a,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(p.default.Error,a)}warn(a){this._msg(p.default.Warning,a)}info(a){this._msg(p.default.Info,a)}}e.ExtensionMessageCollector=y;class _{static _toSet(a){const t=new E.ExtensionIdentifierSet;for(let h=0,u=a.length;h<u;h++)t.add(a[h].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new _(t,[]);if(!t||!t.length)return new _([],a);const h=this._toSet(a),u=this._toSet(t),s=t.filter(d=>!h.has(d.description.identifier)),c=a.filter(d=>!u.has(d.description.identifier));return new _(s,c)}constructor(a,t){this.added=a,this.removed=t}}e.ExtensionPointUserDelta=_;class l{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=_.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,F.onUnexpectedError)(a)}}}e.ExtensionPoint=l;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[P.localize(0,null),P.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:P.localize(2,null),properties:{vscode:{type:"string",description:P.localize(3,null),default:"^1.22.0"}}},publisher:{description:P.localize(4,null),type:"string"},displayName:{description:P.localize(5,null),type:"string"},categories:{description:P.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:P.localize(7,null)}]}},galleryBanner:{type:"object",description:P.localize(8,null),properties:{color:{description:P.localize(9,null),type:"string"},theme:{description:P.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:P.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:P.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:P.localize(13,null)},enabledApiProposals:{markdownDescription:P.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},api:{markdownDescription:P.localize(15,null),type:"string",enum:["none"],enumDescriptions:[P.localize(16,null)]},activationEvents:{description:P.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:P.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:P.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:P.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:P.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:P.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:P.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:P.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:P.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:P.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:P.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:P.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:P.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:P.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:P.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:P.localize(32,null)},{label:"onUri",body:"onUri",description:P.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:P.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:P.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:P.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:P.localize(37,null)},{label:"onRenderer",description:P.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:P.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:P.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:P.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:P.localize(42,null)},{label:"*",description:P.localize(43,null),body:"*"}]}},badges:{type:"array",description:P.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:P.localize(45,null)},href:{type:"string",description:P.localize(46,null)},description:{type:"string",description:P.localize(47,null)}}}},markdown:{type:"string",description:P.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:P.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:P.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:P.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:P.localize(52,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:P.localize(53,null)},{body:["workspace"],description:P.localize(54,null)},{body:["ui","workspace"],description:P.localize(55,null)},{body:["workspace","ui"],description:P.localize(56,null)},{body:[],description:P.localize(57,null)}]},capabilities:{description:P.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:P.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:P.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[P.localize(61,null),P.localize(62,null),P.localize(63,null)]},description:{type:"string",markdownDescription:P.localize(64,null)}}},untrustedWorkspaces:{description:P.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:P.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[P.localize(67,null),P.localize(68,null),P.localize(69,null)]},restrictedConfigurations:{description:P.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:P.localize(71,null)}}}}},sponsor:{description:P.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:P.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:P.localize(74,null),type:"string"},"vscode:uninstall":{description:P.localize(75,null),type:"string"}}},icon:{type:"string",description:P.localize(76,null)},l10n:{type:"string",description:P.localize(77,null)},pricing:{type:"string",markdownDescription:P.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new l(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,t),a.activationEventsGenerator&&I.ImplicitActivationEvents.register(a.extensionPoint,a.activationEventsGenerator),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,v.registerSchema(o,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.Registry.add(n.ExtensionsRegistry,new i),e.ExtensionsRegistry=w.Registry.as(n.ExtensionsRegistry),v.registerSchema(o,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:P.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(Ce[297],De([1,0,231,18,24,296,45,4]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:P.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:P.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:P.localize(2,null),default:""}}};var C;(function(v){function y(_,l,b){if(!_)return;const o=F.isString(_.type)?_.type:void 0;if(!o||o.length===0){b.error(P.localize(3,null));return}const i=[];if(Array.isArray(_.required))for(const n of _.required)F.isString(n)&&i.push(n);return{extensionId:l.value,taskType:o,required:i,properties:_.properties?p.deepClone(_.properties):{},when:_.when?A.ContextKeyExpr.deserialize(_.when):void 0}}v.from=y})(C||(C={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,y)=>{for(const _ of v)_.type&&y.push(`onTaskType:${_.type}`)},jsonSchema:{description:P.localize(4,null),type:"array",items:E}});class I{constructor(){this._onDefinitionsChanged=new w.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((y,_)=>{L.setHandler((l,b)=>{this._schema=void 0;try{for(const o of b.removed){const i=o.value;for(const n of i)this.taskTypes&&n.type&&this.taskTypes[n.type]&&delete this.taskTypes[n.type]}for(const o of b.added){const i=o.value;for(const n of i){const r=C.from(n,o.description.identifier,o.collector);r&&(this.taskTypes[r.taskType]=r)}}(b.removed.length>0||b.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}y(void 0)})})}onReady(){return this.readyPromise}get(y){return this.taskTypes[y]}all(){return Object.keys(this.taskTypes).map(y=>this.taskTypes[y])}getJsonSchema(){if(this._schema===void 0){const y=[];for(const _ of this.all()){const l={type:"object",additionalProperties:!1};_.required.length>0&&(l.required=_.required.slice(0)),_.properties!==void 0?l.properties=p.deepClone(_.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[_.taskType]},y.push(l)}this._schema={oneOf:y}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(Ce[298],De([1,0,232,18,23,24,45,297]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,P.localize(0,null)),e.TASKS_CATEGORY=P.localize2(2,"Tasks");var E;(function(k){k[k.Escape=1]="Escape",k[k.Strong=2]="Strong",k[k.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(k){function O(U){if(!U)return k.Strong;switch(U.toLowerCase()){case"escape":return k.Escape;case"strong":return k.Strong;case"weak":return k.Weak;default:return k.Strong}}k.from=O}(E||(e.ShellQuoting=E={}));var C;(function(k){k.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var L;(function(k){k[k.Always=1]="Always",k[k.Silent=2]="Silent",k[k.Never=3]="Never"})(L||(e.RevealKind=L={})),function(k){function O(U){switch(U.toLowerCase()){case"always":return k.Always;case"silent":return k.Silent;case"never":return k.Never;default:return k.Always}}k.fromString=O}(L||(e.RevealKind=L={}));var I;(function(k){k[k.Never=1]="Never",k[k.OnProblem=2]="OnProblem",k[k.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(k){function O(U){switch(U.toLowerCase()){case"always":return k.Always;case"never":return k.Never;case"onproblem":return k.OnProblem;default:return k.OnProblem}}k.fromString=O}(I||(e.RevealProblemKind=I={}));var v;(function(k){k[k.Shared=1]="Shared",k[k.Dedicated=2]="Dedicated",k[k.New=3]="New"})(v||(e.PanelKind=v={})),function(k){function O(U){switch(U.toLowerCase()){case"shared":return k.Shared;case"dedicated":return k.Dedicated;case"new":return k.New;default:return k.Shared}}k.fromString=O}(v||(e.PanelKind=v={}));var y;(function(k){k.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var _;(function(k){k[k.Shell=1]="Shell",k[k.Process=2]="Process",k[k.CustomExecution=3]="CustomExecution"})(_||(e.RuntimeType=_={})),function(k){function O(q){switch(q.toLowerCase()){case"shell":return k.Shell;case"process":return k.Process;case"customExecution":return k.CustomExecution;default:return k.Process}}k.fromString=O;function U(q){switch(q){case k.Shell:return"shell";case k.Process:return"process";case k.CustomExecution:return"customExecution";default:return"process"}}k.toString=U}(_||(e.RuntimeType=_={}));var l;(function(k){function O(U){return F.isString(U)?U:U.value}k.value=O})(l||(e.CommandString=l={}));var b;(function(k){k.Clean={_id:"clean",isDefault:!1},k.Build={_id:"build",isDefault:!1},k.Rebuild={_id:"rebuild",isDefault:!1},k.Test={_id:"test",isDefault:!1};function O(q){return q===k.Clean._id||q===k.Build._id||q===k.Rebuild._id||q===k.Test._id}k.is=O;function U(q){if(q!==void 0)return F.isString(q)?O(q)?{_id:q,isDefault:!1}:void 0:q}k.from=U})(b||(e.TaskGroup=b={}));var o;(function(k){k[k.Global=1]="Global",k[k.Workspace=2]="Workspace",k[k.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(k){k.Workspace="workspace",k.Extension="extension",k.InMemory="inMemory",k.WorkspaceFile="workspaceFile",k.User="user";function O(U){switch(U){case k.User:return 2;case k.WorkspaceFile:return 5;default:return 6}}k.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(k){k.parallel="parallel",k.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(k){k[k.default=1]="default",k[k.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(k){k.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,U,q,ie,Z,Q){this._label="",this._id=O,U&&(this._label=U),q&&(this.type=q),this.runOptions=ie,this.configurationProperties=Z,this._source=Q}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.getFolderId(),id:this._id};return JSON.stringify(O)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,U=!1){if(O===void 0)return!1;if(F.isString(O))return O===this._label||O===this.configurationProperties.identifier||U&&O===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),O&&(this._taskLoadMessages=this._taskLoadMessages.concat(O))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class h extends t{constructor(O,U,q,ie,Z,Q,Y,ae){super(O,q,void 0,Y,ae,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,Z&&(this.command=Z)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case _.Shell:U="shell";break;case _.Process:U="process";break;case _.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(O){return O instanceof h}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.getFolderId();if(!O)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:U};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?p.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(O){return new h(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.CustomTask=h;class u extends t{constructor(O,U,q,ie,Z,Q,Y){super(O,q,ie,Q,Y,U),this._source=U,this.configures=Z}static is(O){return O instanceof u}fromObject(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?p.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.getFolderId();if(!O)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:U};return JSON.stringify(q)}}e.ConfiguringTask=u;class s extends t{constructor(O,U,q,ie,Z,Q,Y,ae,ee){super(O,q,ie,ae,ee,U),this.defines=Z,this.hasDefinedMatchers=Y,this.command=Q,this.icon=ee.icon,this.hide=ee.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof s}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.getFolderId(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(O){return new s(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.ContributedTask=s;class c extends t{constructor(O,U,q,ie,Z,Q){super(O,q,ie,Z,Q,U),this._source=U}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(O){return new c(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.InMemoryTask=c;var d;(function(k){k[k.Process=1]="Process",k[k.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(k){k._default=k.Terminal}(d||(e.ExecutionEngine=d={}));var m;(function(k){k[k.V0_1_0=1]="V0_1_0",k[k.V2_0_0=2]="V2_0_0"})(m||(e.JsonSchemaVersion=m={}));class D{constructor(O){this._order=new Map;for(let U=0;U<O.length;U++)this._order.set(O[U].uri.toString(),U)}compare(O,U){const q=O.getWorkspaceFolder(),ie=U.getWorkspaceFolder();if(q&&ie){let Z=this._order.get(q.uri.toString());Z=Z===void 0?0:Z+1;let Q=this._order.get(ie.uri.toString());return Q=Q===void 0?0:Q+1,Z===Q?O._label.localeCompare(U._label):Z-Q}else return!q&&ie?-1:q&&!ie?1:0}}e.TaskSorter=D;var g;(function(k){k.DependsOnStarted="dependsOnStarted",k.AcquiredInput="acquiredInput",k.Start="start",k.ProcessStarted="processStarted",k.Active="active",k.Inactive="inactive",k.Changed="changed",k.Terminated="terminated",k.ProcessEnded="processEnded",k.End="end"})(g||(e.TaskEventKind=g={}));var f;(function(k){k.SingleRun="singleRun",k.Background="background"})(f||(e.TaskRunType=f={}));var S;(function(k){k[k.System=0]="System",k[k.User=1]="User",k[k.FolderOpen=2]="FolderOpen",k[k.ConfigurationChange=3]="ConfigurationChange",k[k.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var T;(function(k){function O(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function U(ae,ee,fe){return{...O(ae),kind:"start",terminalId:ee,resolvedVariables:fe}}k.start=U;function q(ae,ee,fe){return{...O(ae),kind:"processStarted",terminalId:ee,processId:fe}}k.processStarted=q;function ie(ae,ee,fe){return{...O(ae),kind:"processEnded",terminalId:ee,exitCode:fe}}k.processEnded=ie;function Z(ae,ee,fe){return{...O(ae),kind:"terminated",exitReason:fe,terminalId:ee}}k.terminated=Z;function Q(ae,ee,fe){return{...O(ee),kind:ae,terminalId:fe}}k.general=Q;function Y(){return{kind:"changed"}}k.changed=Y})(T||(e.TaskEvent=T={}));var N;(function(k){function O(q){const ie=Object.keys(q).sort();let Z="";for(const Q of ie){let Y=q[Q];Y instanceof Object?Y=O(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),Z+=Q+","+Y+","}return Z}function U(q){const Z={_key:O(q),type:q.taskType};return Object.assign(Z,q),Z}k.create=U})(N||(e.KeyedTaskIdentifier=N={}));var z;(function(k){k.AutoDetect="task.autoDetect",k.SaveBeforeRun="task.saveBeforeRun",k.ShowDecorations="task.showDecorations",k.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",k.SlowProviderWarning="task.slowProviderWarning",k.QuickOpenHistory="task.quickOpen.history",k.QuickOpenDetail="task.quickOpen.detail",k.QuickOpenSkip="task.quickOpen.skip",k.QuickOpenShowAll="task.quickOpen.showAll",k.AllowAutomaticTasks="task.allowAutomaticTasks",k.Reconnection="task.reconnection",k.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var x;(function(k){k.Tasks="tasks",k.SuppressTaskName="tasks.suppressTaskName",k.Windows="tasks.windows",k.Osx="tasks.osx",k.Linux="tasks.linux",k.ShowOutput="tasks.showOutput",k.IsShellCommand="tasks.isShellCommand",k.ServiceTestSetting="tasks.service.testSetting"})(x||(e.TasksSchemaProperties=x={}));var M;(function(k){function O(U,q){const ie=w.TaskDefinitionRegistry.get(U.type);if(ie===void 0){const ae=R.deepClone(U);return delete ae._key,N.create(ae)}const Z=Object.create(null);Z.type=ie.taskType;const Q=new Set;ie.required.forEach(ae=>Q.add(ae));const Y=ie.properties;for(const ae of Object.keys(Y)){const ee=U[ae];if(ee!=null)Z[ae]=ee;else if(Q.has(ae)){const fe=Y[ae];if(fe.default!==void 0)Z[ae]=R.deepClone(fe.default);else switch(fe.type){case"boolean":Z[ae]=!1;break;case"number":case"integer":Z[ae]=0;break;case"string":Z[ae]="";break;default:q.error(P.localize(1,null,JSON.stringify(U,void 0,0),ae));return}}}return N.create(Z)}k.createTaskIdentifier=O})(M||(e.TaskDefinition=M={}))}),define(Ce[299],De([1,0,14]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,w)=>{this._actualOk=A,this._actualErr=w,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,P.onUnexpectedError)(A))}then(A,w){return this._ensureActual().then(A,w)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F;class p extends F{constructor(){super(),this._hasErr=!0,this._err=new P.CancellationError}}e.CanceledLazyPromise=p}),define(Ce[68],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class P{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++P.count}}e.ProxyIdentifier=P;const F=[];function p(w){const E=new P(w);return F[E.nid]=E,E}e.createProxyIdentifier=p;function R(w){return F[w].sid}e.getStringIdentifierForProxy=R;class A{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=A}),define(Ce[6],De([1,0,68]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var p;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})(p||(e.TabInputKind=p={}));var R;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var w;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var E;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C||(e.NotebookEditorRevealType=C={}));var L;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class I{static{this._n=0}static mixin(b){return b._id=I._n++,b}}e.IdObject=I;var v;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var y;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var _;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(_||(e.ExtHostTestingResource=_={})),e.MainContext={MainThreadAuthentication:(0,P.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,P.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents2:(0,P.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,P.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,P.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,P.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,P.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,P.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,P.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,P.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,P.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,P.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,P.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,P.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,P.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,P.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,P.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,P.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,P.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,P.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,P.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,P.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,P.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,P.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,P.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,P.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,P.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,P.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,P.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,P.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,P.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,P.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,P.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,P.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,P.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,P.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,P.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,P.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,P.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,P.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,P.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,P.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,P.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,P.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,P.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,P.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,P.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,P.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,P.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,P.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,P.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,P.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,P.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,P.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,P.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,P.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,P.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,P.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,P.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,P.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,P.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,P.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,P.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,P.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,P.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,P.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,P.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,P.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,P.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,P.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,P.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,P.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,P.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,P.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,P.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,P.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,P.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,P.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,P.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,P.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,P.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,P.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,P.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,P.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,P.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,P.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,P.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,P.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,P.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,P.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,P.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,P.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,P.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,P.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,P.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,P.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,P.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,P.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,P.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,P.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,P.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,P.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ce[91],De([1,0,5,13,6,20]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,P.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(E,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(p.MainContext.MainThreadTelemetry)}report(E,C,L){const I=this.getUsageKey(E,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:E}))}getUsageKey(E,C){return`${E}-${C.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=Ge([He(0,R.IExtHostRpcService),He(1,F.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(w,E,C){}})}),define(Ce[300],De([1,0,48,3,6]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class R{static{this._pool=0}constructor(E,C){this.extension=E,this.provider=C,this.handle=R._pool++}}class A{static{this._nextId=0}constructor(E){this._chatProvider=new Map,this._chatSessions=new Map,this._proxy=E.getProxy(p.MainContext.MainThreadChat)}registerChatProvider(E,C,L){const I=new R(E,L);return this._chatProvider.set(I.handle,I),this._proxy.$registerChatProvider(I.handle,C),(0,F.toDisposable)(()=>{this._proxy.$unregisterChatProvider(I.handle),this._chatProvider.delete(I.handle)})}transferChatSession(E,C){const L=P.Iterable.find(this._chatSessions.keys(),I=>this._chatSessions.get(I)===E)??0;typeof L=="number"&&this._proxy.$transferChatSession(L,C)}sendInteractiveRequestToProvider(E,C){this._proxy.$sendRequestToProvider(E,C)}async $prepareChat(E,C){const L=this._chatProvider.get(E);if(!L)return;const I=await L.provider.prepareSession(C);if(!I)return;const v=A._nextId++;return this._chatSessions.set(v,I),{id:v,requesterUsername:I.requester?.name,requesterAvatarIconUri:I.requester?.icon,responderUsername:I.responder?.name,responderAvatarIconUri:I.responder?.icon,inputPlaceholder:I.inputPlaceholder}}$releaseSession(E){this._chatSessions.delete(E)}}e.ExtHostChat=A}),define(Ce[301],De([1,0,6]),function(me,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(R){const A=R.getProxy(P.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(w){return A.$writeText(w)}})}}e.ExtHostClipboard=F}),define(Ce[302],De([1,0,24,6,27,20]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(L,I){this._mainThreadConsole=L.getProxy(F.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,I){const v=this,y=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v._handleConsoleCall(L,I,y,arguments)}})}_handleConsoleCall(L,I,v,y){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(y,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,v,y)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=Ge([He(0,R.IExtHostRpcService),He(1,p.IExtHostInitDataService)],A);const w=1e5;function E(C,L){const I=[];if(C.length)for(let v=0;v<C.length;v++){let y=C[v];if(typeof y>"u")y="undefined";else if(y instanceof Error){const _=y;_.stack?y=_.stack:y=_.toString()}I.push(y)}if(L){const v=new Error().stack;v&&I.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,P.safeStringify)(I);return v.length>w?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(Ce[303],De([1,0,2,6,26]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(w){this._proxy=w.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(w,E){return E?.allowUIResources&&(0,p.checkProposedApiEnabled)(w,"showLocal"),this._proxy.$showOpenDialog(E).then(C=>C?C.map(L=>P.URI.revive(L)):void 0)}showSaveDialog(w){return this._proxy.$showSaveDialog(w).then(E=>E?P.URI.revive(E):void 0)}}e.ExtHostDialogs=R}),define(Ce[304],De([1,0,3,6]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class p{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const w=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(w,A),(0,P.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(w)})}}e.ExtHostLabelService=p}),define(Ce[114],De([1,0,11,12,2,5,13,6,27,20]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,y,_){this.logService=_,this.bundleCache=new Map,this._proxy=y.getProxy(w.MainContext.MainThreadLocalization),this.currentLanguage=v.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===P.LANGUAGE_DEFAULT}getMessage(v,y){const{message:_,args:l,comment:b}=y;if(this.isDefaultLanguage)return(0,F.format2)(_,l??{});let o=_;b&&b.length>0&&(o+=`/${Array.isArray(b)?b.join(""):b}`);const i=this.bundleCache.get(v)?.contents[o];return i||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.format2)(i??_,l??{})}getBundle(v){return this.bundleCache.get(v)?.contents}getBundleUri(v){return this.bundleCache.get(v)?.uri}async initializeLocalizedMessages(v){if(this.isDefaultLanguage||!v.l10n&&!v.isBuiltin||this.bundleCache.has(v.identifier.value))return;let y;const _=await this.getBundleLocation(v);if(!_){this.logService.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const l=await this._proxy.$fetchBundleContents(_),b=JSON.parse(l);y=v.isBuiltin?b.contents?.bundle:b}catch(l){this.logService.error(`Failed to load translations for ${v.identifier.value} from ${_}: ${l.message}`);return}y&&this.bundleCache.set(v.identifier.value,{contents:y,uri:_})}async getBundleLocation(v){if(v.isBuiltin){const y=await this._proxy.$fetchBuiltInBundleUri(v.identifier.value,this.currentLanguage);return p.URI.revive(y)}return v.l10n?p.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=L,e.ExtHostLocalizationService=L=Ge([He(0,E.IExtHostInitDataService),He(1,C.IExtHostRpcService),He(2,A.ILogService)],L),e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(Ce[146],De([1,0,13,6,27,20,2,56]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let E=class extends P.AbstractLoggerService{constructor(I,v){super(v.logLevel,v.logsLocation,v.loggers.map(y=>(0,w.revive)(y))),this._proxy=I.getProxy(F.MainContext.MainThreadLogger)}$setLogLevel(I,v){v?this.setLogLevel(A.URI.revive(v),I):this.setLogLevel(I)}setVisibility(I,v){super.setVisibility(I,v),this._proxy.$setVisibility(I,v)}doCreateLogger(I,v,y){return new C(this._proxy,I,v,y)}};e.ExtHostLoggerService=E,e.ExtHostLoggerService=E=Ge([He(0,R.IExtHostRpcService),He(1,p.IExtHostInitDataService)],E);class C extends P.AbstractMessageLogger{constructor(I,v,y,_){super(_?.logLevel==="always"),this.proxy=I,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(y),this.proxy.$createLogger(v,_).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,v){const y=[[I,v]];this.isLoggerCreated?this.doLog(y):this.buffer.push(...y)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(Ce[115],De([1,0,6,5,3,20,21]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,F.createDecorator)("IExtHostManagedSockets");let w=class{constructor(I){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=I.getProxy(P.MainContext.MainThreadManagedSockets)}setFactory(I,v){for(const y of this._managedRemoteSockets.values())y.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new E(I,v),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(I){if(!this._factory||this._factory.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const v=++this._remoteSocketIdCounter,y=await this._factory.makeConnection(),_=new p.DisposableStore;return this._managedRemoteSockets.set(v,new C(v,y,_)),_.add((0,p.toDisposable)(()=>this._managedRemoteSockets.delete(v))),_.add(y.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(v),_.dispose()})),_.add(y.onDidClose(l=>{this._proxy.$onDidManagedSocketClose(v,l?.stack??l?.message),_.dispose()})),_.add(y.onDidReceiveMessage(l=>this._proxy.$onDidManagedSocketHaveData(v,A.VSBuffer.wrap(l)))),v}$remoteSocketWrite(I,v){this._managedRemoteSockets.get(I)?.actual.send(v.buffer)}$remoteSocketEnd(I){const v=this._managedRemoteSockets.get(I);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(I){await this._managedRemoteSockets.get(I)?.actual.drain?.()}};e.ExtHostManagedSockets=w,e.ExtHostManagedSockets=w=Ge([He(0,R.IExtHostRpcService)],w);class E{constructor(I,v){this.socketFactoryId=I,this.makeConnection=v}}class C extends p.Disposable{constructor(I,v,y){super(),this.socketId=I,this.actual=v,this._register(y)}}}),define(Ce[305],De([1,0,6,13,26]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(w){return w&&w.title}let A=class{constructor(E,C){this._logService=C,this._proxy=E.getProxy(P.MainContext.MainThreadMessageService)}showMessage(E,C,L,I,v){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let _;typeof I=="string"||R(I)?_=[I,...v]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,_=v),y.useCustom&&(0,p.checkProposedApiEnabled)(E,"resolvers");const l=[];let b=!1;for(let o=0;o<_.length;o++){const i=_[o];if(typeof i=="string")l.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;l.push({title:n,isCloseAffordance:!!r,handle:o}),r&&(b?this._logService.warn(`[${E.identifier}] Only one message item can have 'isCloseAffordance':`,i):b=!0)}else this._logService.warn(`[${E.identifier}] Invalid message item:`,i)}return this._proxy.$showMessage(C,L,y,l).then(o=>{if(typeof o=="number")return _[o]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=Ge([He(1,F.ILogService)],A)}),define(Ce[306],De([1,0,3,18,2,26,6]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class w{constructor(C){this.handlers=new Map,this.proxy=C.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(C,L,I){if((0,R.checkProposedApiEnabled)(C,"profileContentHandlers"),this.handlers.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.handlers.set(L,I),this.proxy.$registerProfileContentHandler(L,I.name,I.description,C.identifier.value),(0,P.toDisposable)(()=>{this.handlers.delete(L),this.proxy.$unregisterProfileContentHandler(L)})}async $saveProfile(C,L,I,v){const y=this.handlers.get(C);if(!y)throw new Error(`Unknown handler with id: ${C}`);return y.saveProfile(L,I,v)}async $readProfile(C,L,I){const v=this.handlers.get(C);if(!v)throw new Error(`Unknown handler with id: ${C}`);return v.readProfile((0,F.isString)(L)?L:p.URI.revive(L),I)}}e.ExtHostProfileContentHandlers=w}),define(Ce[116],De([1,0,6,4,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(w){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=w.getProxy(P.MainContext.MainThreadSecretState)}async $onDidChangePassword(w){this._onDidChangePassword.fire(w)}get(w,E){return this._proxy.$getPassword(w,E)}store(w,E,C){return this._proxy.$setPassword(w,E,C)}delete(w,E){return this._proxy.$deletePassword(w,E)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,p.createDecorator)("IExtHostSecretState")}),define(Ce[307],De([1,0,22,3,6]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class R{static{this.ID_POOL=1}constructor(w){this.providers=new Map,this.sessions=new Map,this.proxy=w.getProxy(p.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(w,E,C){const L=this.providers.get(w);if(!L)return;const I=new F.DisposableStore,v=new P.CancellationTokenSource;this.sessions.set(E,v);const y=I.add(L.provideSpeechToTextSession(v.token,C?{language:C}:void 0));I.add(y.onDidChange(_=>{v.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(E,_)})),I.add(v.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(w){this.sessions.get(w)?.dispose(!0),this.sessions.delete(w)}async $createKeywordRecognitionSession(w,E){const C=this.providers.get(w);if(!C)return;const L=new F.DisposableStore,I=new P.CancellationTokenSource;this.sessions.set(E,I);const v=L.add(C.provideKeywordRecognitionSession(I.token));L.add(v.onDidChange(y=>{I.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(E,y)})),L.add(I.token.onCancellationRequested(()=>L.dispose()))}async $cancelKeywordRecognitionSession(w){this.sessions.get(w)?.dispose(!0),this.sessions.delete(w)}registerProvider(w,E,C){const L=R.ID_POOL++;return this.providers.set(L,C),this.proxy.$registerProvider(L,E,{extension:w,displayName:w.value}),(0,F.toDisposable)(()=>{this.proxy.$unregisterProvider(L),this.providers.delete(L)})}}e.ExtHostSpeech=R}),define(Ce[117],De([1,0,6,4,5]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(w,E){this._logService=E,this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=w.getProxy(P.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(w,E){this._proxy.$registerExtensionStorageKeysToSync(w,E)}async initializeExtensionStorage(w,E,C){const L=await this._proxy.$initializeExtensionStorage(w,E);let I;return L&&(I=this.safeParseValue(w,E,L)),I||C}setValue(w,E,C){return this._proxy.$setValue(w,E,C)}$acceptValue(w,E,C){const L=this.safeParseValue(w,E,C);L&&this._onDidChangeStorage.fire({shared:w,key:E,value:L})}safeParseValue(w,E,C){try{return JSON.parse(C)}catch(L){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${w}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,p.createDecorator)("IExtHostStorage")}),define(Ce[308],De([1,0,3,16,2,6]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this._openers=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,C,L,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const v=I.schemes.find(y=>!A.supportedSchemes.has(y));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,L),this._proxy.$registerUriOpener(C,I.schemes,E,I.label),(0,P.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(E,C,L){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const v=p.URI.revive(C);return I.canOpenExternalUri(v,L)}async $openUri(E,C,L){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(p.URI.revive(C.resolvedUri),{sourceUri:p.URI.revive(C.sourceUri)},L)}}e.ExtHostUriOpeners=A}),define(Ce[309],De([1,0,6,2,3,14,25]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class w{static{this.HandlePool=0}constructor(C){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadUrls)}registerUriHandler(C,L){const I=C.identifier;if(this.handles.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const v=w.HandlePool++;return this.handles.add(I),this.handlers.set(v,L),this._proxy.$registerUriHandler(v,I,C.displayName||C.name),(0,p.toDisposable)(()=>{this.handles.delete(I),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(C,L){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(C){return F.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=w}),define(Ce[92],De([1,0,4,3,16,24,2,239,276,112,6]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(r,a,t,h,u,s,c){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new P.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new P.Emitter,this._onDidDispose=this.#d.event,this.#e=r,this.#t=a,this.#o=t,this.#n=h,this.#s=u,this.#r=s,this.#u=v(s),this.#h=y(s),this.#i=c}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#l=!0,(0,C.asWebviewUri)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===p.Schemas.https||r.scheme===p.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+C.webviewGenericCspSource}return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(r){this.assertNotDisposed(),this.#a!==r&&(this.#a=r,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(r)))}get options(){return this.assertNotDisposed(),this.#o}set options(r){this.assertNotDisposed(),R.equals(this.#o,r)||this.#t.$setOptions(this.#e,b(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const a=(0,E.serializeWebviewMessage)(r,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(r){if(!this.#h)return r;const a=this.#r.extensionLocation?.scheme===p.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===p.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,u,s,c,d,m)=>{const D=A.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),g=(0,C.asWebviewUri)(D,{isRemote:a,authority:t}).toString();return`${u}${g}${m}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,u,s,c,d,m)=>{const D=A.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),g=(0,C.asWebviewUri)(D,{isRemote:a,authority:t}).toString();return`${u}${g}${m}`})}}e.ExtHostWebview=I;function v(n){try{const r=(0,w.normalizeVersion)((0,w.parseVersion)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;function y(n){try{const r=(0,w.normalizeVersion)((0,w.parseVersion)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class _ extends F.Disposable{constructor(r,a,t,h,u){super(),this.remoteInfo=a,this.workspace=t,this._logService=h,this._deprecationService=u,this._webviews=new Map,this._webviewProxy=r.getProxy(L.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const r of this._webviews.values())r.dispose();this._webviews.clear()}$onMessage(r,a,t){const h=this.getWebview(r);if(h){const{message:u}=(0,E.deserializeWebviewMessage)(a,t.value);h._onMessageEmitter.fire(u)}}$onMissingCsp(r,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const h=new I(r,this._webviewProxy,o(a),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(r,h);const u=h._onDidDispose(()=>{u.dispose(),this.deleteWebview(r)});return h}deleteWebview(r){this._webviews.delete(r)}getWebview(r){return this._webviews.get(r)}}e.ExtHostWebviews=_;function l(n){return{id:n.identifier,location:n.extensionLocation}}e.toExtensionData=l;function b(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.serializeWebviewOptions=b;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>A.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(Ce[147],De([1,0,4,6,2,16,12,5,20,26]),function(me,e,P,F,p,R,A,w,E,C){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{L=this}static{this.InitialState={focused:!0,active:!0}}getState(y){const _=this._state;return{get focused(){return _.focused},get active(){return(0,C.checkProposedApiEnabled)(y,"windowActivity"),_.active}}}constructor(y){this._onDidChangeWindowState=new P.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=L.InitialState,this._proxy=y.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:_,isActive:l})=>{this.onDidChangeWindowProperty("focused",_),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,_){_!==this._state[y]&&(this._state={...this._state,[y]:_},this._onDidChangeWindowState.fire(this._state))}openUri(y,_){let l;if(typeof y=="string"){l=y;try{y=p.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,l,_)}async asExternalUri(y,_){if((0,A.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this._proxy.$asExternalUri(y,_);return p.URI.from(l)}};e.ExtHostWindow=I,e.ExtHostWindow=I=L=Ge([He(0,E.IExtHostRpcService)],I),e.IExtHostWindow=(0,w.createDecorator)("IExtHostWindow")}),define(Ce[310],De([1,0,302,27,20]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let A=class extends P.AbstractExtHostConsoleForwarder{constructor(E,C){super(E,C),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(E,C,L){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),C.apply(console,L),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(E,C){const L=process[E],I=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(y,_,l)=>{if(!this._isMakingConsoleCall){v+=y.toString(_);const b=v.length>R?v.length:v.lastIndexOf(`
`);b!==-1&&(console[C](v.slice(0,b)),v=v.slice(b+1))}I.call(L,y,_,l)}})}};e.ExtHostConsoleForwarder=A,e.ExtHostConsoleForwarder=A=Ge([He(0,p.IExtHostRpcService),He(1,F.IExtHostInitDataService)],A)}),define(Ce[311],De([1,0,146,16,253,30]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends P.ExtHostLoggerService{doCreateLogger(E,C,L){return E.scheme===F.Schemas.file?new p.SpdLogLogger(L?.name||(0,R.generateUuid)(),E.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,C):super.doCreateLogger(E,C,L)}registerLogger(E){super.registerLogger(E),this._proxy.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this._proxy.$deregisterLogger(E)}}e.ExtHostLoggerService=A}),define(Ce[312],De([1,0,8,21,22,14,4,3,130,299,68]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(S,T){try{return JSON.stringify(S,T)}catch{return"null"}}const y="$$ref$$",_={[y]:-1};class l{constructor(T,N){this.jsonString=T,this.referencedBuffers=N}}function b(S,T=null,N=!1){const z=[];return{jsonString:(N?v:JSON.stringify)(S,(M,k)=>{if(typeof k>"u")return _;if(typeof k=="object"){if(k instanceof F.VSBuffer){const O=z.push(k)-1;return{[y]:O}}if(T)return T(M,k)}return k}),referencedBuffers:z}}e.stringifyJsonWithBufferRefs=b;function o(S,T,N){return JSON.parse(S,(z,x)=>{if(x){const M=x[y];if(typeof M=="number")return T[M];if(N&&x.$mid===1)return N.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=o;function i(S,T){return JSON.stringify(S,T)}function n(S){return S?(T,N)=>N&&N.$mid===1?S.transformOutgoing(N):N:null}var r;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},h=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class s extends w.Disposable{static{I=h}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(T,N=null,z=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=N,this._uriTransformer=z,this._uriReplacer=n(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,M=L.ProxyIdentifier.count;x<M;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new P.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{const N=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],N.resolveErr(R.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,E.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:N,sid:z}=T;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,z)),this._proxies[N]}_createProxy(T,N){const z={get:(x,M)=>(typeof M=="string"&&!x[M]&&M.charCodeAt(0)===36&&(x[M]=(...k)=>this._remoteCall(T,M,k)),M===u?N:x[M])};return new Proxy(Object.create(null),z)}set(T,N){return this._locals[T.nid]=N,N}assertRegistered(T){for(let N=0,z=T.length;N<z;N++){const x=T[N];if(!this._locals[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const N=T.byteLength,z=d.read(T,0),x=z.readUInt8(),M=z.readUInt32();switch(x){case 1:case 2:{let{rpcId:k,method:O,args:U}=D.deserializeRequestJSONArgs(z);this._uriTransformer&&(U=(0,E.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(N,M,k,O,U,x===2);break}case 3:case 4:{let{rpcId:k,method:O,args:U}=D.deserializeRequestMixedArgs(z);this._uriTransformer&&(U=(0,E.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(N,M,k,O,U,x===4);break}case 5:{this._logger?.logIncoming(N,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(N,M);break}case 7:{this._receiveReply(N,M,void 0);break}case 9:{let k=D.deserializeReplyOKJSON(z);this._uriTransformer&&(k=(0,E.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReply(N,M,k);break}case 10:{const k=D.deserializeReplyOKJSONWithBuffers(z,this._uriTransformer);this._receiveReply(N,M,k);break}case 8:{const k=D.deserializeReplyOKVSBuffer(z);this._receiveReply(N,M,k);break}case 11:{let k=D.deserializeReplyErrError(z);this._uriTransformer&&(k=(0,E.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReplyErr(N,M,k);break}case 12:{this._receiveReplyErr(N,M,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,N,z,x,M,k){this._logger?.logIncoming(T,N,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(z)}.${x}(`,M);const O=String(N);let U,q;if(k){const Z=new p.CancellationTokenSource;M.push(Z.token),U=this._invokeHandler(z,x,M),q=()=>Z.cancel()}else U=this._invokeHandler(z,x,M),q=t;this._cancelInvokedHandlers[O]=q;const ie=D.serializeAcknowledged(N);this._logger?.logOutgoing(ie.byteLength,N,1,"ack"),this._protocol.send(ie),U.then(Z=>{delete this._cancelInvokedHandlers[O];const Q=D.serializeReplyOK(N,Z,this._uriReplacer);this._logger?.logOutgoing(Q.byteLength,N,1,"reply:",Z),this._protocol.send(Q)},Z=>{delete this._cancelInvokedHandlers[O];const Q=D.serializeReplyErr(N,Z);this._logger?.logOutgoing(Q.byteLength,N,1,"replyErr:",Z),this._protocol.send(Q)})}_receiveCancel(T,N){this._logger?.logIncoming(T,N,1,"receiveCancel");const z=String(N);this._cancelInvokedHandlers[z]?.()}_receiveReply(T,N,z){this._logger?.logIncoming(T,N,0,"receiveReply:",z);const x=String(N);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const M=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],M.resolveOk(z)}_receiveReplyErr(T,N,z){this._logger?.logIncoming(T,N,0,"receiveReplyErr:",z);const x=String(N);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const M=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let k;z&&(z.$isError?(k=new Error,k.name=z.name,k.message=z.message,k.stack=z.stack):k=z),M.resolveErr(k)}_invokeHandler(T,N,z){try{return Promise.resolve(this._doInvokeHandler(T,N,z))}catch(x){return Promise.reject(x)}}_doInvokeHandler(T,N,z){const x=this._locals[T];if(!x)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(T));const M=x[N];if(typeof M!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.getStringIdentifierForProxy)(T));return M.apply(x,z)}_remoteCall(T,N,z){if(this._isDisposed)return new C.CanceledLazyPromise;let x=null;if(z.length>0&&p.CancellationToken.isCancellationToken(z[z.length-1])&&(x=z.pop()),x&&x.isCancellationRequested)return Promise.reject(R.canceled());const M=D.serializeRequestArguments(z,this._uriReplacer),k=++this._lastMessageId,O=String(k),U=new C.LazyPromise,q=new w.DisposableStore;x&&q.add(x.onCancellationRequested(()=>{const Z=D.serializeCancel(k);this._logger?.logOutgoing(Z.byteLength,k,0,"cancel"),this._protocol.send(D.serializeCancel(k))})),this._pendingRPCReplies[O]=new c(U,q),this._onWillSendRequest(k);const ie=D.serializeRequest(k,T,N,M,!!x);return this._logger?.logOutgoing(ie.byteLength,k,0,`request: ${(0,L.getStringIdentifierForProxy)(T)}.${N}(`,z),this._protocol.send(ie),U}}e.RPCProtocol=s;class c{constructor(T,N){this._promise=T,this._disposable=N}resolveOk(T){this._promise.resolveOk(T),this._disposable.dispose()}resolveErr(T){this._promise.resolveErr(T),this._disposable.dispose()}}class d{static alloc(T,N,z){const x=new d(F.VSBuffer.alloc(z+1+4),0);return x.writeUInt8(T),x.writeUInt32(N),x}static read(T,N){return new d(T,N)}get buffer(){return this._buff}constructor(T,N){this._buff=T,this._offset=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const z=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,z}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,z}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,N}static sizeMixedArray(T){let N=0;N+=1;for(let z=0,x=T.length;z<x;z++){const M=T[z];switch(N+=1,M.type){case 1:N+=this.sizeLongString(M.value);break;case 2:N+=this.sizeVSBuffer(M.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(M.value);for(let k=0;k<M.buffers.length;++k)N+=this.sizeVSBuffer(M.buffers[k]);break;case 4:break}}return N}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let N=0,z=T.length;N<z;N++){const x=T[N];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let M=0;M<x.buffers.length;++M)this.writeBuffer(x.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(T);for(let z=0;z<T;z++)switch(this.readUInt8()){case 1:N[z]=this.readLongString();break;case 2:N[z]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),k=this.readLongString(),O=[];for(let U=0;U<M;++U)O.push(this.readVSBuffer());N[z]=new L.SerializableObjectWithBuffers(o(k,O,null));break}case 4:N[z]=void 0;break}return N}}var m;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(m||(m={}));class D{static _useMixedArgSerialization(T){for(let N=0,z=T.length;N<z;N++)if(T[N]instanceof F.VSBuffer||T[N]instanceof L.SerializableObjectWithBuffers||typeof T[N]>"u")return!0;return!1}static serializeRequestArguments(T,N){if(this._useMixedArgSerialization(T)){const z=[];for(let x=0,M=T.length;x<M;x++){const k=T[x];if(k instanceof F.VSBuffer)z[x]={type:2,value:k};else if(typeof k>"u")z[x]={type:4};else if(k instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=b(k.value,N);z[x]={type:3,value:F.VSBuffer.fromString(O),buffers:U}}else z[x]={type:1,value:F.VSBuffer.fromString(i(k,N))}}return{type:1,args:z}}return{type:0,args:i(T,N)}}static serializeRequest(T,N,z,x,M){switch(x.type){case 0:return this._requestJSONArgs(T,N,z,x.args,M);case 1:return this._requestMixedArgs(T,N,z,x.args,M)}}static _requestJSONArgs(T,N,z,x,M){const k=F.VSBuffer.fromString(z),O=F.VSBuffer.fromString(x);let U=0;U+=d.sizeUInt8(),U+=d.sizeShortString(k),U+=d.sizeLongString(O);const q=d.alloc(M?2:1,T,U);return q.writeUInt8(N),q.writeShortString(k),q.writeLongString(O),q.buffer}static deserializeRequestJSONArgs(T){const N=T.readUInt8(),z=T.readShortString(),x=T.readLongString();return{rpcId:N,method:z,args:JSON.parse(x)}}static _requestMixedArgs(T,N,z,x,M){const k=F.VSBuffer.fromString(z);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(k),O+=d.sizeMixedArray(x);const U=d.alloc(M?4:3,T,O);return U.writeUInt8(N),U.writeShortString(k),U.writeMixedArray(x),U.buffer}static deserializeRequestMixedArgs(T){const N=T.readUInt8(),z=T.readShortString(),x=T.readMixedArray(),M=new Array(x.length);for(let k=0,O=x.length;k<O;k++){const U=x[k];typeof U=="string"?M[k]=JSON.parse(U):M[k]=U}return{rpcId:N,method:z,args:M}}static serializeAcknowledged(T){return d.alloc(5,T,0).buffer}static serializeCancel(T){return d.alloc(6,T,0).buffer}static serializeReplyOK(T,N,z){if(typeof N>"u")return this._serializeReplyOKEmpty(T);if(N instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(T,N);if(N instanceof L.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:M}=b(N.value,z,!0);return this._serializeReplyOKJSONWithBuffers(T,x,M)}else return this._serializeReplyOKJSON(T,v(N,z))}static _serializeReplyOKEmpty(T){return d.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,N){let z=0;z+=d.sizeVSBuffer(N);const x=d.alloc(8,T,z);return x.writeVSBuffer(N),x.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,N){const z=F.VSBuffer.fromString(N);let x=0;x+=d.sizeLongString(z);const M=d.alloc(9,T,x);return M.writeLongString(z),M.buffer}static _serializeReplyOKJSONWithBuffers(T,N,z){const x=F.VSBuffer.fromString(N);let M=0;M+=d.sizeUInt32,M+=d.sizeLongString(x);for(const O of z)M+=d.sizeVSBuffer(O);const k=d.alloc(10,T,M);k.writeUInt32(z.length),k.writeLongString(x);for(const O of z)k.writeBuffer(O);return k.buffer}static deserializeReplyOKJSON(T){const N=T.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(T,N){const z=T.readUInt32(),x=T.readLongString(),M=[];for(let k=0;k<z;++k)M.push(T.readVSBuffer());return new L.SerializableObjectWithBuffers(o(x,M,N))}static serializeReplyErr(T,N){const z=N?v(R.transformErrorForSerialization(N),null):void 0;if(typeof z!="string")return this._serializeReplyErrEmpty(T);const x=F.VSBuffer.fromString(z);let M=0;M+=d.sizeLongString(x);const k=d.alloc(11,T,M);return k.writeLongString(x),k.buffer}static deserializeReplyErrError(T){const N=T.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(T){return d.alloc(12,T,0).buffer}}var g;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var f;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(f||(f={}))}),define(Ce[313],De([1,0,21,28,16,84,5]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.generate=e.parse=e.INotebookDocumentService=void 0,e.INotebookDocumentService=(0,A.createDecorator)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],E=new RegExp(`^[${w.join("")}]+`),C=7;function L(y){if(y.scheme!==p.Schemas.vscodeNotebookCell)return;const _=y.fragment.indexOf("s");if(_<0)return;const l=parseInt(y.fragment.substring(0,_).replace(E,""),C),b=(0,P.decodeBase64)(y.fragment.substring(_+1)).toString();if(!isNaN(l))return{handle:l,notebook:y.with({scheme:b,fragment:null})}}e.parse=L;function I(y,_){const l=_.toString(C),o=`${l.length<w.length?w[l.length-1]:"z"}${l}s${(0,P.encodeBase64)(P.VSBuffer.fromString(y.scheme),!0,!0)}`;return y.with({scheme:p.Schemas.vscodeNotebookCell,fragment:o})}e.generate=I;class v{constructor(){this._documents=new F.ResourceMap}getNotebook(_){if(_.scheme===p.Schemas.vscodeNotebookCell){const l=L(_);if(l){const b=this._documents.get(l.notebook);if(b)return b}}return this._documents.get(_)}addNotebookDocument(_){this._documents.set(_.uri,_)}removeNotebookDocument(_){this._documents.delete(_.uri)}}e.NotebookDocumentWorkbenchService=v,(0,R.registerSingleton)(e.INotebookDocumentService,v,1)}),define(Ce[118],De([1,0,21,35,48,100,16,17,11,45,313]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var I;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(I||(e.CellKind=I={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var v;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(v||(e.NotebookRunState=v={}));var y;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var _;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(_||(e.NotebookExecutionState=_={}));var l;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var b;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var o;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(U){U.scheme=A.Schemas.vscodeNotebookCell;function q(ee,fe){return(0,L.generate)(ee,fe)}U.generate=q;function ie(ee){return(0,L.parse)(ee)}U.parse=ie;function Z(ee,fe){return ee.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${ee.scheme!==A.Schemas.file?ee.scheme:""}`})}U.generateCellOutputUri=Z;function Q(ee){if(ee.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ee.fragment);if(!fe)return;const re=fe[1]&&fe[1]!==""?fe[1]:void 0,G=fe[2];return{outputId:re,notebook:ee.with({scheme:G||A.Schemas.file,fragment:null})}}U.parseCellOutputUri=Q;function Y(ee,fe,re){return U.generate(ee,fe).with({scheme:re})}U.generateCellPropertyUri=Y;function ae(ee,fe){if(ee.scheme===fe)return U.parse(ee.with({scheme:U.scheme}))}U.parseCellPropertyUri=ae})(r||(e.CellUri=r={}));const a=U=>E.isWindows?U.replace(/\//g,"\\"):U;class t{constructor(q=[],ie=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ie,this.order=[...new Set(q)].map(Z=>({pattern:Z,matches:F.parse(a(Z))}))}sort(q){const ie=new Map(p.Iterable.map(q,Q=>[Q,a(Q)]));let Z=[];for(const{matches:Q}of this.order)for(const[Y,ae]of ie)if(Q(ae)){Z.push(Y),ie.delete(Y);break}return ie.size&&(Z=Z.concat([...ie.keys()].sort((Q,Y)=>this.defaultOrder.indexOf(Q)-this.defaultOrder.indexOf(Y)))),Z}prioritize(q,ie){const Z=this.findIndex(q);if(Z===-1){this.order.unshift({pattern:q,matches:F.parse(a(q))});return}const Q=new Set(ie.map(ae=>this.findIndex(ae,Z)));Q.delete(-1);const Y=Array.from(Q).sort();this.order.splice(Z+1,0,...Y.map(ae=>this.order[ae]));for(let ae=Y.length-1;ae>=0;ae--)this.order.splice(Y[ae],1)}toArray(){return this.order.map(q=>q.pattern)}findIndex(q,ie=this.order.length){const Z=a(q);for(let Q=0;Q<ie;Q++)if(this.order[Q].matches(Z))return Q;return-1}}e.MimeTypeDisplayOrder=t;function h(U,q,ie,Z=(Q,Y)=>Q===Y){const Q=[];function Y(fe,re,G){if(re===0&&G.length===0)return;const B=Q[Q.length-1];B&&B.start+B.deleteCount===fe?(B.deleteCount+=re,B.toInsert.push(...G)):Q.push({start:fe,deleteCount:re,toInsert:G})}let ae=0,ee=0;for(;;){if(ae===U.length){Y(ae,0,q.slice(ee));break}if(ee===q.length){Y(ae,U.length-ae,[]);break}const fe=U[ae],re=q[ee];if(Z(fe,re)){ae+=1,ee+=1;continue}ie(re)?(Y(ae,1,[]),ae+=1):(Y(ae,0,[re]),ee+=1)}return Q}e.diff=h,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtLineBoundary","none");var u;(function(U){U.default="default",U.option="option"})(u||(e.NotebookEditorPriority=u={}));function s(U){const q=U;return!!((typeof q.include=="string"||F.isRelativePattern(q.include))&&(typeof q.exclude=="string"||F.isRelativePattern(q.exclude)))}e.isDocumentExcludePattern=s;function c(U,q,ie){if(Array.isArray(U.viewType)&&U.viewType.indexOf(q)>=0||U.viewType===q)return!0;if(U.filenamePattern){const Z=s(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,Q=s(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(F.match(Z,(0,w.basename)(ie.fsPath).toLowerCase()))return!(Q&&F.match(Q,(0,w.basename)(ie.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class m{static{this._prefix="notebook/"}static create(q){return`${m._prefix}${q}`}static parse(q){if(q.startsWith(m._prefix))return q.substring(m._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=m;function D(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=D;const g=new TextDecoder;function f(U){const q=[];let ie=!1;for(const ae of U)(q.length===0||ie)&&(q.push(ae),ie=!0);let Z=N(q);const Q=P.VSBuffer.concat(q.map(ae=>P.VSBuffer.wrap(ae))),Y=O(Q);return Z=Z||Y.byteLength!==Q.byteLength,{data:Y,didCompression:Z}}e.compressOutputItemStreams=f,e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const S=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(U=>U.charCodeAt(0)),T=10;function N(U){let q=!1;return U.forEach((ie,Z)=>{if(Z===0||ie.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const Q=U[Z-1],Y=ie.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Y[0]===S[0]&&Y[1]===S[1]&&Y[2]===S[2]){const ae=Q.lastIndexOf(T);if(ae===-1)return;q=!0,U[Z-1]=Q.subarray(0,ae),U[Z]=ie.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),q}function z(U){let q=U;do U=q,q=U.replace(/[^\n]\x08/gm,"");while(q.length<U.length);return U}function x(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const q=U.match(/^(.*)\r+/m)[1];let ie=U.match(/\r+(.*)$/m)[1];ie=ie+q.slice(ie.length,q.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return U}const M=8,k=13;function O(U){return!U.buffer.includes(M)&&!U.buffer.includes(k)?U:P.VSBuffer.fromString(x(z(g.decode(U.buffer))))}}),define(Ce[7],De([1,0,19,14,80,28,100,12,18,2,30,25,32,64,118]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_){"use strict";var l,b,o,i,n,r,a,t,h,u,s,c,d,m,D,g,f;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelAssistantMessage=e.LanguageModelUserMessage=e.LanguageModelSystemMessage=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function S(j){return Object.assign(j,{apply:function(...be){if(be.length===0)return Reflect.construct(j,[]);{const Fe=be.length===1?[]:be[1];return Reflect.construct(j,Fe,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(j,[]);{const[Fe,...Ye]=be;return Reflect.construct(j,Ye,Fe.constructor)}}})}var T;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var N;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let z=l=class{static from(...$){let be=$;return new l(function(){if(be){for(const Fe of be)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();be=void 0}})}#e;constructor($){this.#e=$}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=z,e.Disposable=z=l=Ge([S],z);let x=b=class{static Min(...$){if($.length===0)throw new TypeError;let be=$[0];for(let Fe=1;Fe<$.length;Fe++){const Ye=$[Fe];Ye.isBefore(be)&&(be=Ye)}return be}static Max(...$){if($.length===0)throw new TypeError;let be=$[0];for(let Fe=1;Fe<$.length;Fe++){const Ye=$[Fe];Ye.isAfter(be)&&(be=Ye)}return be}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;const{line:be,character:Fe}=$;return typeof be=="number"&&typeof Fe=="number"}static of($){if($ instanceof b)return $;if(this.isPosition($))return new b($.line,$.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor($,be){if($<0)throw(0,F.illegalArgument)("line must be non-negative");if(be<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=$,this._character=be}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,be=0){if($===null||be===null)throw(0,F.illegalArgument)();let Fe;return typeof $>"u"?Fe=0:typeof $=="number"?Fe=$:(Fe=typeof $.lineDelta=="number"?$.lineDelta:0,be=typeof $.characterDelta=="number"?$.characterDelta:0),Fe===0&&be===0?this:new b(this.line+Fe,this.character+be)}with($,be=this.character){if($===null||be===null)throw(0,F.illegalArgument)();let Fe;return typeof $>"u"?Fe=this.line:typeof $=="number"?Fe=$:(Fe=typeof $.line=="number"?$.line:this.line,be=typeof $.character=="number"?$.character:this.character),Fe===this.line&&be===this.character?this:new b(Fe,be)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=b=Ge([S],x);let M=o=class{static isRange($){return $ instanceof o?!0:$?x.isPosition($.start)&&x.isPosition($.end):!1}static of($){if($ instanceof o)return $;if(this.isRange($))return new o($.start,$.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor($,be,Fe,Ye){let it,ut;if(typeof $=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Ye=="number"?(it=new x($,be),ut=new x(Fe,Ye)):x.isPosition($)&&x.isPosition(be)&&(it=x.of($),ut=x.of(be)),!it||!ut)throw new Error("Invalid arguments");it.isBefore(ut)?(this._start=it,this._end=ut):(this._start=ut,this._end=it)}contains($){return o.isRange($)?this.contains($.start)&&this.contains($.end):x.isPosition($)?!(x.of($).isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const be=x.Max($.start,this._start),Fe=x.Min($.end,this._end);if(!be.isAfter(Fe))return new o(be,Fe)}union($){if(this.contains($))return this;if($.contains(this))return $;const be=x.Min($.start,this._start),Fe=x.Max($.end,this.end);return new o(be,Fe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,be=this.end){if($===null||be===null)throw(0,F.illegalArgument)();let Fe;return $?x.isPosition($)?Fe=$:(Fe=$.start||this.start,be=$.end||this.end):Fe=this.start,Fe.isEqual(this._start)&&be.isEqual(this.end)?this:new o(Fe,be)}toJSON(){return[this.start,this.end]}};e.Range=M,e.Range=M=o=Ge([S],M);let k=i=class extends M{static isSelection($){return $ instanceof i?!0:$?M.isRange($)&&x.isPosition($.anchor)&&x.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor($,be,Fe,Ye){let it,ut;if(typeof $=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Ye=="number"?(it=new x($,be),ut=new x(Fe,Ye)):x.isPosition($)&&x.isPosition(be)&&(it=x.of($),ut=x.of(be)),!it||!ut)throw new Error("Invalid arguments");super(it,ut),this._anchor=it,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=k,e.Selection=k=i=Ge([S],k);const O=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,F.illegalArgument)("connectionToken")};class U{static isResolvedAuthority($){return $&&typeof $=="object"&&typeof $.host=="string"&&typeof $.port=="number"&&($.connectionToken===void 0||typeof $.connectionToken=="string")}constructor($,be,Fe){if(typeof $!="string"||$.length===0)throw(0,F.illegalArgument)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,F.illegalArgument)("port");typeof Fe<"u"&&O(Fe),this.host=$,this.port=Math.round(be),this.connectionToken=Fe}}e.ResolvedAuthority=U;class q{static isManagedResolvedAuthority($){return $&&typeof $=="object"&&typeof $.makeConnection=="function"&&($.connectionToken===void 0||typeof $.connectionToken=="string")}constructor($,be){this.makeConnection=$,this.connectionToken=be,typeof be<"u"&&O(be)}}e.ManagedResolvedAuthority=q;class ie extends Error{static NotAvailable($,be){return new ie($,y.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable($){return new ie($,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor($,be=y.RemoteAuthorityResolverErrorCode.Unknown,Fe){super($),this._message=$,this._code=be,this._detail=Fe,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var Z;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var Q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let Y=n=class{static isTextEdit($){return $ instanceof n?!0:$?M.isRange($)&&typeof $.newText=="string":!1}static replace($,be){return new n($,be)}static insert($,be){return n.replace(new M($,$),be)}static delete($){return n.replace($,"")}static setEndOfLine($){const be=new n(new M(new x(0,0),new x(0,0)),"");return be.newEol=$,be}get range(){return this._range}set range($){if($&&!M.isRange($))throw(0,F.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,F.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,F.illegalArgument)("newEol");this._newEol=$}constructor($,be){this._range=$,this._newText=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Y,e.TextEdit=Y=n=Ge([S],Y);let ae=r=class{static isNotebookCellEdit($){return $ instanceof r?!0:$?di.isNotebookRange($)&&Array.isArray($.newCells):!1}static replaceCells($,be){return new r($,be)}static insertCells($,be){return new r(new di($,$),be)}static deleteCells($){return new r($,[])}static updateCellMetadata($,be){const Fe=new r(new di($,$),[]);return Fe.newCellMetadata=be,Fe}static updateNotebookMetadata($){const be=new r(new di(0,0),[]);return be.newNotebookMetadata=$,be}constructor($,be){this.range=$,this.newCells=be}};e.NotebookEdit=ae,e.NotebookEdit=ae=r=Ge([S],ae);class ee{static isSnippetTextEdit($){return $ instanceof ee?!0:$?M.isRange($.range)&&G.isSnippetString($.snippet):!1}static replace($,be){return new ee($,be)}static insert($,be){return ee.replace(new M($,$),be)}constructor($,be){this.range=$,this.snippet=be}}e.SnippetTextEdit=ee;var fe;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(fe||(e.FileEditType=fe={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,be,Fe,Ye){this._edits.push({_type:1,from:$,to:be,options:Fe,metadata:Ye})}createFile($,be,Fe){this._edits.push({_type:1,from:void 0,to:$,options:be,metadata:Fe})}deleteFile($,be,Fe){this._edits.push({_type:1,from:$,to:void 0,options:be,metadata:Fe})}replaceNotebookMetadata($,be,Fe){this._edits.push({_type:3,metadata:Fe,uri:$,edit:{editType:5,metadata:be},notebookMetadata:be})}replaceNotebookCells($,be,Fe,Ye){const it=be.start,ut=be.end;(it!==ut||Fe.length>0)&&this._edits.push({_type:5,uri:$,index:it,count:ut-it,cells:Fe,metadata:Ye})}replaceNotebookCellMetadata($,be,Fe,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:3,index:be,metadata:Fe}})}replace($,be,Fe,Ye){this._edits.push({_type:2,uri:$,edit:new Y(be,Fe),metadata:Ye})}insert($,be,Fe,Ye){this.replace($,new M(be,be),Fe,Ye)}delete($,be,Fe){this.replace($,be,"",Fe)}has($){return this._edits.some(be=>be._type===2&&be.uri.toString()===$.toString())}set($,be){if(be)for(const Fe of be){if(!Fe)continue;let Ye,it;Array.isArray(Fe)?(Ye=Fe[0],it=Fe[1]):Ye=Fe,ae.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.replaceNotebookCellMetadata($,Ye.range.start,Ye.newCellMetadata,it):Ye.newNotebookMetadata?this.replaceNotebookMetadata($,Ye.newNotebookMetadata,it):this.replaceNotebookCells($,Ye.range,Ye.newCells,it):ee.isSnippetTextEdit(Ye)?this._edits.push({_type:6,uri:$,range:Ye.range,edit:Ye.snippet,metadata:it}):this._edits.push({_type:2,uri:$,edit:Ye,metadata:it})}else{for(let Fe=0;Fe<this._edits.length;Fe++){const Ye=this._edits[Fe];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===$.toString()&&(this._edits[Fe]=void 0);break}}(0,P.coalesceInPlace)(this._edits)}}get($){const be=[];for(const Fe of this._edits)Fe._type===2&&Fe.uri.toString()===$.toString()&&be.push(Fe.edit);return be}entries(){const $=new R.ResourceMap;for(const be of this._edits)if(be._type===2){let Fe=$.get(be.uri);Fe||(Fe=[be.uri,[]],$.set(be.uri,Fe)),Fe[1].push(be.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=re,e.WorkspaceEdit=re=Ge([S],re);let G=a=class{static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}constructor($){this._tabstop=1,this.value=$||""}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,be=this._tabstop++){if(typeof $=="function"){const Fe=new a;Fe._tabstop=this._tabstop,$(Fe),this._tabstop=Fe._tabstop,$=Fe.value}else $=a._escape($);return this.value+="${",this.value+=be,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,be=this._tabstop++){const Fe=$.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable($,be){if(typeof be=="function"){const Fe=new a;Fe._tabstop=this._tabstop,be(Fe),this._tabstop=Fe._tabstop,be=Fe.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.SnippetString=G,e.SnippetString=G=a=Ge([S],G);var B;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var se;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(se||(e.DiagnosticSeverity=se={}));let ye=t=class{static isLocation($){return $ instanceof t?!0:$?M.isRange($.range)&&C.URI.isUri($.uri):!1}constructor($,be){if(this.uri=$,be)if(M.isRange(be))this.range=M.of(be);else if(x.isPosition(be))this.range=new M(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ye,e.Location=ye=t=Ge([S],ye);let le=class{static is($){return $?typeof $.message=="string"&&$.location&&M.isRange($.location.range)&&C.URI.isUri($.location.uri):!1}constructor($,be){this.location=$,this.message=be}static isEqual($,be){return $===be?!0:!$||!be?!1:$.message===be.message&&$.location.range.isEqual(be.location.range)&&$.location.uri.toString()===be.location.uri.toString()}};e.DiagnosticRelatedInformation=le,e.DiagnosticRelatedInformation=le=Ge([S],le);let de=class{constructor($,be,Fe=se.Error){if(!M.isRange($))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=$,this.message=be,this.severity=Fe}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,be){return $===be?!0:!$||!be?!1:$.message===be.message&&$.severity===be.severity&&$.code===be.code&&$.severity===be.severity&&$.source===be.source&&$.range.isEqual(be.range)&&(0,P.equals)($.tags,be.tags)&&(0,P.equals)($.relatedInformation,be.relatedInformation,le.isEqual)}};e.Diagnostic=de,e.Diagnostic=de=Ge([S],de);let ce=class{constructor($,be){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=be}};e.Hover=ce,e.Hover=ce=Ge([S],ce);var he;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(he||(e.DocumentHighlightKind=he={}));let V=class{constructor($,be=he.Text){this.range=$,this.kind=be}toJSON(){return{range:this.range,kind:he[this.kind]}}};e.DocumentHighlight=V,e.DocumentHighlight=V=Ge([S],V);let J=class{constructor($,be){this.uri=$,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map($=>$.toJSON())}}};e.MultiDocumentHighlight=J,e.MultiDocumentHighlight=J=Ge([S],J);var ue;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var ve;(function(j){j[j.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let ke=h=class{static validate($){if(!$.name)throw new Error("name must not be falsy")}constructor($,be,Fe,Ye,it){this.name=$,this.kind=be,this.containerName=it,typeof Fe=="string"&&(this.containerName=Fe),Ye instanceof ye?this.location=Ye:Fe instanceof M&&(this.location=new ye(Ye,Fe)),h.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ke,e.SymbolInformation=ke=h=Ge([S],ke);let we=u=class{static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children?.forEach(u.validate)}constructor($,be,Fe,Ye,it){this.name=$,this.detail=be,this.kind=Fe,this.range=Ye,this.selectionRange=it,this.children=[],u.validate(this)}};e.DocumentSymbol=we,e.DocumentSymbol=we=u=Ge([S],we);var Te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let Oe=class{constructor($,be){this.title=$,this.kind=be}};e.CodeAction=Oe,e.CodeAction=Oe=Ge([S],Oe);let xe=class{static{s=this}static{this.sep="."}constructor($){this.value=$}append($){return new s(this.value?this.value+s.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+s.sep)}};e.CodeActionKind=xe,e.CodeActionKind=xe=s=Ge([S],xe),xe.Empty=new xe(""),xe.QuickFix=xe.Empty.append("quickfix"),xe.Refactor=xe.Empty.append("refactor"),xe.RefactorExtract=xe.Refactor.append("extract"),xe.RefactorInline=xe.Refactor.append("inline"),xe.RefactorMove=xe.Refactor.append("move"),xe.RefactorRewrite=xe.Refactor.append("rewrite"),xe.Source=xe.Empty.append("source"),xe.SourceOrganizeImports=xe.Source.append("organizeImports"),xe.SourceFixAll=xe.Source.append("fixAll"),xe.Notebook=xe.Empty.append("notebook");let W=class{constructor($,be){if(this.range=$,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=W,e.SelectionRange=W=Ge([S],W);class H{constructor($,be,Fe,Ye,it,ut){this.kind=$,this.name=be,this.detail=Fe,this.uri=Ye,this.range=it,this.selectionRange=ut}}e.CallHierarchyItem=H;class X{constructor($,be){this.fromRanges=be,this.from=$}}e.CallHierarchyIncomingCall=X;class K{constructor($,be){this.fromRanges=be,this.to=$}}e.CallHierarchyOutgoingCall=K;var pe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(pe||(e.LanguageStatusSeverity=pe={}));let Ee=class{constructor($,be){this.range=$,this.command=be}get isResolved(){return!!this.command}};e.CodeLens=Ee,e.CodeLens=Ee=Ge([S],Ee);let Me=c=class{#e;static isMarkdownString($){return $ instanceof c?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}constructor($,be=!1){this.#e=new p.MarkdownString($,{supportThemeIcons:be})}get value(){return this.#e.value}set value($){this.#e.value=$}get isTrusted(){return this.#e.isTrusted}set isTrusted($){this.#e.isTrusted=$}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons($){this.#e.supportThemeIcons=$}get supportHtml(){return this.#e.supportHtml}set supportHtml($){this.#e.supportHtml=$}get baseUri(){return this.#e.baseUri}set baseUri($){this.#e.baseUri=$}appendText($){return this.#e.appendText($),this}appendMarkdown($){return this.#e.appendMarkdown($),this}appendCodeblock($,be){return this.#e.appendCodeblock(be??"",$),this}};e.MarkdownString=Me,e.MarkdownString=Me=c=Ge([S],Me);let Ve=class{constructor($,be){this.label=$,this.documentation=be}};e.ParameterInformation=Ve,e.ParameterInformation=Ve=Ge([S],Ve);let Ke=class{constructor($,be){this.label=$,this.documentation=be,this.parameters=[]}};e.SignatureInformation=Ke,e.SignatureInformation=Ke=Ge([S],Ke);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=tt,e.SignatureHelp=tt=Ge([S],tt);var st;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var lt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let rt=class{constructor($){this.value=$}};e.InlayHintLabelPart=rt,e.InlayHintLabelPart=rt=Ge([S],rt);let Pe=class{constructor($,be,Fe){this.position=$,this.label=be,this.kind=Fe}};e.InlayHint=Pe,e.InlayHint=Pe=Ge([S],Pe);var ze;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var Ae;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ae||(e.CompletionItemKind=Ae={}));var je;(function(j){j[j.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let ne=class{constructor($,be){this.label=$,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ne,e.CompletionItem=ne=Ge([S],ne);let oe=class{constructor($=[],be=!1){this.items=$,this.isIncomplete=be}};e.CompletionList=oe,e.CompletionList=oe=Ge([S],oe);let Ie=class{constructor($,be,Fe){this.insertText=$,this.range=be,this.command=Fe}};e.InlineSuggestion=Ie,e.InlineSuggestion=Ie=Ge([S],Ie);let qe=class{constructor($){this.commands=void 0,this.suppressSuggestions=void 0,this.items=$}};e.InlineSuggestionList=qe,e.InlineSuggestionList=qe=Ge([S],qe);var Je;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Je||(e.ViewColumn=Je={}));var nt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Ne(j,$){return`${I.ExtensionIdentifier.toKey(j)}.${$}`}e.asStatusBarItemIdentifier=Ne;var vt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(vt||(e.TextEditorLineNumbersStyle=vt={}));var yt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(yt||(e.TextDocumentSaveReason=yt={}));var kt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(kt||(e.TextEditorRevealType=kt={}));var Mt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var Qt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Qt||(e.TextDocumentChangeReason=Qt={}));var Pt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(j){function $(be){switch(be){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var qt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(j){function $(be){switch(be){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=$}(qt||(e.SyntaxTokenType=qt={}));let Gt=class{constructor($,be){if(be&&!C.URI.isUri(be))throw(0,F.illegalArgument)("target");if(!M.isRange($)||$.isEmpty)throw(0,F.illegalArgument)("range");this.range=$,this.target=be}};e.DocumentLink=Gt,e.DocumentLink=Gt=Ge([S],Gt);let Jt=class{constructor($,be,Fe,Ye){this.red=$,this.green=be,this.blue=Fe,this.alpha=Ye}};e.Color=Jt,e.Color=Jt=Ge([S],Jt);let ii=class{constructor($,be){if(be&&!(be instanceof Jt))throw(0,F.illegalArgument)("color");if(!M.isRange($)||$.isEmpty)throw(0,F.illegalArgument)("range");this.range=$,this.color=be}};e.ColorInformation=ii,e.ColorInformation=ii=Ge([S],ii);let et=class{constructor($){if(!$||typeof $!="string")throw(0,F.illegalArgument)("label");this.label=$}};e.ColorPresentation=et,e.ColorPresentation=et=Ge([S],et);var xt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Zt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Zt||(e.SourceControlInputBoxValidationType=Zt={}));var ft;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ft||(e.TerminalExitReason=ft={}));class Et{constructor($,be,Fe){if(this.startIndex=$,this.length=be,this.tooltip=Fe,typeof $!="number"||$<0)throw(0,F.illegalArgument)("startIndex");if(typeof be!="number"||be<1)throw(0,F.illegalArgument)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=Et;class ei{constructor($){this.uri=$}}e.TerminalQuickFixOpener=ei;class $t{constructor($){this.terminalCommand=$}}e.TerminalQuickFixCommand=$t;var zt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(zt||(e.TerminalLocation=zt={}));class ht{constructor($){if(this.options=$,typeof $!="object")throw(0,F.illegalArgument)("options")}}e.TerminalProfile=ht;var Rt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ti;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ti||(e.TaskPanelKind=ti={}));let Yt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from($){switch($){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor($,be){if(this.label=be,typeof $!="string"||typeof be!="string")throw(0,F.illegalArgument)("name");this._id=$}get id(){return this._id}};e.TaskGroup=Yt,e.TaskGroup=Yt=d=Ge([S],Yt);function Xe(j){let $="";for(let be=0;be<j.length;be++)$+=j[be].replace(/,/g,",,")+",";return $}let Ft=class{constructor($,be,Fe){if(typeof $!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=$,be!==void 0&&(Array.isArray(be)?(this._args=be,this._options=Fe):this._options=be)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,F.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(const be of this._args)$.push(be);return Xe($)}};e.ProcessExecution=Ft,e.ProcessExecution=Ft=Ge([S],Ft);let Bt=class{constructor($,be,Fe){if(this._args=[],Array.isArray(be)){if(!$)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,F.illegalArgument)("command");this._command=$,this._args=be,this._options=Fe}else{if(typeof $!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=$,this._options=be}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,F.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const be of this._args)$.push(typeof be=="string"?be:be.value);return Xe($)}};e.ShellExecution=Bt,e.ShellExecution=Bt=Ge([S],Bt);var ni;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var mt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(mt||(e.TaskScope=mt={}));class Nt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Nt;let Tt=class{static{m=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor($,be,Fe,Ye,it,ut){this.__deprecated=!1,this._definition=this.definition=$;let gt;typeof be=="string"?(this._name=this.name=be,this._source=this.source=Fe,this.execution=Ye,gt=it,this.__deprecated=!0):be===mt.Global||be===mt.Workspace?(this.target=be,this._name=this.name=Fe,this._source=this.source=Ye,this.execution=it,gt=ut):(this.target=be,this._name=this.name=Fe,this._source=this.source=Ye,this.execution=it,gt=ut),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ft?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Bt?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof Nt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const be=this._definition.type;(m.EmptyType===be||m.ProcessType===be||m.ShellType===be||m.ExtensionCallbackType===be)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};e.Task=Tt,e.Task=Tt=m=Ge([S],Tt);var Wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Wt||(e.ProgressLocation=Wt={}));var ri;(function(j){function $(be){const Fe=be;return(0,E.isNumber)(Fe.value)?Fe.tooltip&&!(0,E.isString)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}j.isViewBadge=$})(ri||(e.ViewBadge=ri={}));let Ut=D=class{static isTreeItem($,be){const Fe=$;if(Fe.checkboxState!==void 0){const Ye=(0,E.isNumber)(Fe.checkboxState)?Fe.checkboxState:(0,E.isObject)(Fe.checkboxState)&&(0,E.isNumber)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,it=!(0,E.isNumber)(Fe.checkboxState)&&(0,E.isObject)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==At.Checked&&Ye!==At.Unchecked||it!==void 0&&!(0,E.isString)(it))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if($ instanceof D)return!0;if(Fe.label!==void 0&&!(0,E.isString)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,E.isString)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,E.isString)(Fe.iconPath)&&!C.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,E.isString)(Fe.iconPath.id))){const Ye=Fe.iconPath;if(!Ye||!(0,E.isString)(Ye.light)&&!C.URI.isUri(Ye.light)&&!(0,E.isString)(Ye.dark)&&!C.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,E.isString)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!C.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,E.isString)(Fe.tooltip)&&!(Fe.tooltip instanceof Me)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<Ht.None&&Fe.collapsibleState>Ht.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,E.isString)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor($,be=Ht.None){this.collapsibleState=be,C.URI.isUri($)?this.resourceUri=$:this.label=$}};e.TreeItem=Ut,e.TreeItem=Ut=D=Ge([S],Ut);var Ht;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ht||(e.TreeItemCollapsibleState=Ht={}));var At;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(At||(e.TreeItemCheckboxState=At={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor($){this.value=$}};e.DataTransferItem=Dt,e.DataTransferItem=Dt=Ge([S],Dt);class pt extends Dt{}e.InternalDataTransferItem=pt;class It extends pt{#e;constructor($){super(""),this.#e=$}asFile(){return this.#e}}e.InternalFileDataTransferItem=It;class St{constructor($,be,Fe,Ye){this.name=$,this.uri=be,this._itemId=Fe,this._getData=Ye}data(){return this._getData()}}e.DataTransferFile=St;let ui=class{#e=new Map;constructor($){for(const[be,Fe]of $??[]){const Ye=this.#e.get(this.#t(be));Ye?Ye.push(Fe):this.#e.set(this.#t(be),[Fe])}}get($){return this.#e.get(this.#t($))?.[0]}set($,be){this.#e.set(this.#t($),[be])}forEach($,be){for(const[Fe,Ye]of this.#e)for(const it of Ye)$.call(be,it,Fe,this)}*[Symbol.iterator](){for(const[$,be]of this.#e)for(const Fe of be)yield[$,Fe]}#t($){return $.toLowerCase()}};e.DataTransfer=ui,e.DataTransfer=ui=Ge([S],ui);let Kt=class{constructor($){this.insertText=$}};e.DocumentDropEdit=Kt,e.DocumentDropEdit=Kt=Ge([S],Kt);let pi=class{constructor($,be){this.label=be,this.insertText=$}};e.DocumentPasteEdit=pi,e.DocumentPasteEdit=pi=Ge([S],pi);let Re=class{constructor($,be){this.id=$,this.color=be}static isThemeIcon($){return typeof $.id!="string"?(console.log("INVALID ThemeIcon, invalid id",$.id),!1):!0}};e.ThemeIcon=Re,e.ThemeIcon=Re=Ge([S],Re),Re.File=new Re("file"),Re.Folder=new Re("folder");let Ue=class{constructor($){this.id=$}};e.ThemeColor=Ue,e.ThemeColor=Ue=Ge([S],Ue);var Se;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Se||(e.ConfigurationTarget=Se={}));let te=class{get base(){return this._base}set base($){this._base=$,this._baseUri=C.URI.file($)}get baseUri(){return this._baseUri}set baseUri($){this._baseUri=$,this._base=$.fsPath}constructor($,be){if(typeof $!="string"&&(!$||!C.URI.isUri($)&&!C.URI.isUri($.uri)))throw(0,F.illegalArgument)("base");if(typeof be!="string")throw(0,F.illegalArgument)("pattern");typeof $=="string"?this.baseUri=C.URI.file($):C.URI.isUri($)?this.baseUri=$:this.baseUri=$.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=te,e.RelativePattern=te=Ge([S],te);const Le=new WeakMap;function Be(j,$){Le.set(j,$)}e.setBreakpointId=Be;let Ze=class{constructor($,be,Fe,Ye,it){this.enabled=typeof $=="boolean"?$:!0,typeof be=="string"&&(this.condition=be),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Ye=="string"&&(this.logMessage=Ye),typeof it=="string"&&(this.mode=it)}get id(){return this._id||(this._id=Le.get(this)??(0,L.generateUuid)()),this._id}};e.Breakpoint=Ze,e.Breakpoint=Ze=Ge([S],Ze);let Qe=class extends Ze{constructor($,be,Fe,Ye,it,ut){if(super(be,Fe,Ye,it,ut),$===null)throw(0,F.illegalArgument)("location");this.location=$}};e.SourceBreakpoint=Qe,e.SourceBreakpoint=Qe=Ge([S],Qe);let at=class extends Ze{constructor($,be,Fe,Ye,it,ut){super(be,Fe,Ye,it,ut),this.functionName=$}};e.FunctionBreakpoint=at,e.FunctionBreakpoint=at=Ge([S],at);let _t=class extends Ze{constructor($,be,Fe,Ye,it,ut,gt,jt){if(super(Ye,it,ut,gt,jt),!be)throw(0,F.illegalArgument)("dataId");this.label=$,this.dataId=be,this.canPersist=Fe}};e.DataBreakpoint=_t,e.DataBreakpoint=_t=Ge([S],_t);let Vt=class{constructor($,be,Fe){this.command=$,this.args=be||[],this.options=Fe}};e.DebugAdapterExecutable=Vt,e.DebugAdapterExecutable=Vt=Ge([S],Vt);let Ct=class{constructor($,be){this.port=$,this.host=be}};e.DebugAdapterServer=Ct,e.DebugAdapterServer=Ct=Ge([S],Ct);let Lt=class{constructor($){this.path=$}};e.DebugAdapterNamedPipeServer=Lt,e.DebugAdapterNamedPipeServer=Lt=Ge([S],Lt);let Xt=class{constructor($){this.implementation=$}};e.DebugAdapterInlineImplementation=Xt,e.DebugAdapterInlineImplementation=Xt=Ge([S],Xt);let vi=class{constructor($,be,Fe){this.session=$,this.threadId=be,this.frameId=Fe}};e.StackFrameFocus=vi,e.StackFrameFocus=vi=Ge([S],vi);let bi=class{constructor($,be){this.session=$,this.threadId=be}};e.ThreadFocus=bi,e.ThreadFocus=bi=Ge([S],bi);let dt=class{constructor($,be){this.range=$,this.expression=be}};e.EvaluatableExpression=dt,e.EvaluatableExpression=dt=Ge([S],dt);var Qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ai=class{constructor($,be){this.range=$,this.text=be}};e.InlineValueText=ai,e.InlineValueText=ai=Ge([S],ai);let fi=class{constructor($,be,Fe=!0){this.range=$,this.variableName=be,this.caseSensitiveLookup=Fe}};e.InlineValueVariableLookup=fi,e.InlineValueVariableLookup=fi=Ge([S],fi);let Si=class{constructor($,be){this.range=$,this.expression=be}};e.InlineValueEvaluatableExpression=Si,e.InlineValueEvaluatableExpression=Si=Ge([S],Si);let Ti=class{constructor($,be){this.frameId=$,this.stoppedLocation=be}};e.InlineValueContext=Ti,e.InlineValueContext=Ti=Ge([S],Ti);var Yi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));class dn{constructor($,be){this.newSymbolName=$,this.tags=be}}e.NewSymbolName=dn;var Ai;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Ri=g=class extends Error{static FileExists($){return new g($,v.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound($){return new g($,v.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory($){return new g($,v.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory($){return new g($,v.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions($){return new g($,v.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable($){return new g($,v.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor($,be=v.FileSystemProviderErrorCode.Unknown,Fe){super(C.URI.isUri($)?$.toString(!0):$),this.code=Fe?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,be),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.FileSystemError=Ri,e.FileSystemError=Ri=g=Ge([S],Ri);let _i=class{constructor($,be,Fe){this.start=$,this.end=be,this.kind=Fe}};e.FoldingRange=_i,e.FoldingRange=_i=Ge([S],_i);var mi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(mi||(e.FoldingRangeKind=mi={}));var Ji;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var yi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(yi||(e.CommentMode=yi={}));var Ci;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ci||(e.CommentState=Ci={}));var Zi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Zi||(e.CommentThreadState=Zi={}));class hn{constructor($,be=[]){this.tokenTypes=$,this.tokenModifiers=be}}e.SemanticTokensLegend=hn;function Ei(j){return typeof j>"u"||(0,E.isStringArray)(j)}class Li{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let be=0,Fe=$.tokenTypes.length;be<Fe;be++)this._tokenTypeStrToInt.set($.tokenTypes[be],be);for(let be=0,Fe=$.tokenModifiers.length;be<Fe;be++)this._tokenModifierStrToInt.set($.tokenModifiers[be],be)}}push($,be,Fe,Ye,it){if(typeof $=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this._pushEncoded($,be,Fe,Ye,it);if(M.isRange($)&&typeof be=="string"&&Ei(Fe))return this._push($,be,Fe);throw(0,F.illegalArgument)()}_push($,be,Fe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(be))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,it=$.start.character,ut=$.end.character-$.start.character,gt=this._tokenTypeStrToInt.get(be);let jt=0;if(Fe)for(const oi of Fe){if(!this._tokenModifierStrToInt.has(oi))throw new Error("`tokenModifier` is not in the provided legend");const li=this._tokenModifierStrToInt.get(oi);jt|=1<<li>>>0}this._pushEncoded(Ye,it,ut,gt,jt)}_pushEncoded($,be,Fe,Ye,it){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&be<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const jt=this._data.length/5|0;let oi=0,li=0;for(let hi=0;hi<jt;hi++){let gi=this._data[5*hi],Ki=this._data[5*hi+1];gi===0?(gi=oi,Ki+=li):gi+=oi,this._data[5*hi]=gi,this._data[5*hi+1]=Ki,oi=gi,li=Ki}}let ut=$,gt=be;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=Fe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=it,this._prevLine=$,this._prevChar=be}static _sortAndDeltaEncode($){const be=[],Fe=$.length/5|0;for(let gt=0;gt<Fe;gt++)be[gt]=gt;be.sort((gt,jt)=>{const oi=$[5*gt],li=$[5*jt];if(oi===li){const hi=$[5*gt+1],gi=$[5*jt+1];return hi-gi}return oi-li});const Ye=new Uint32Array($.length);let it=0,ut=0;for(let gt=0;gt<Fe;gt++){const jt=5*be[gt],oi=$[jt+0],li=$[jt+1],hi=$[jt+2],gi=$[jt+3],Ki=$[jt+4],kn=oi-it,Jn=kn===0?li-ut:li,Xi=5*gt;Ye[Xi+0]=kn,Ye[Xi+1]=Jn,Ye[Xi+2]=hi,Ye[Xi+3]=gi,Ye[Xi+4]=Ki,it=oi,ut=li}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Oi(new Uint32Array(this._data),$):new Oi(Li._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Li;class Oi{constructor($,be){this.resultId=be,this.data=$}}e.SemanticTokens=Oi;class fn{constructor($,be,Fe){this.start=$,this.deleteCount=be,this.data=Fe}}e.SemanticTokensEdit=fn;class Di{constructor($,be){this.resultId=be,this.edits=$}}e.SemanticTokensEdits=Di;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class mn{constructor($){this.name=$}}e.DebugVisualization=mn;let wi=class{static{this.Back={iconPath:new Re("arrow-left")}}constructor(){}};e.QuickInputButtons=wi,e.QuickInputButtons=wi=Ge([S],wi);var Fi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Fi||(e.QuickPickItemKind=Fi={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var Ni;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class nn{static validate($){if(typeof $.badge=="string"){let be=(0,w.nextCharLength)($.badge,0);if(be<$.badge.length&&(be+=(0,w.nextCharLength)($.badge,be)),$.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if($.badge&&!Re.isThemeIcon($.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}constructor($,be,Fe){this.badge=$,this.tooltip=be,this.color=Fe}}e.FileDecoration=nn;let Mi=class{constructor($){this.kind=$}};e.ColorTheme=Mi,e.ColorTheme=Mi=Ge([S],Mi);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class di{static isNotebookRange($){return $ instanceof di?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor($,be){if($<0)throw(0,F.illegalArgument)("start must be positive");if(be<0)throw(0,F.illegalArgument)("end must be positive");$<=be?(this._start=$,this._end=be):(this._start=be,this._end=$)}with($){let be=this._start,Fe=this._end;return $.start!==void 0&&(be=$.start),$.end!==void 0&&(Fe=$.end),be===this._start&&Fe===this._end?this:new di(be,Fe)}}e.NotebookRange=di;class Ii{static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(be=>Ii.isNotebookCellData(be))}static isNotebookCellData($){return!0}constructor($,be,Fe,Ye,it,ut,gt){this.kind=$,this.value=be,this.languageId=Fe,this.mime=Ye,this.outputs=it??[],this.metadata=ut,this.executionSummary=gt,Ii.validate(this)}}e.NotebookCellData=Ii;class Ui{constructor($){this.cells=$}}e.NotebookData=Ui;class si{static isNotebookCellOutputItem($){return $ instanceof si?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const be={name:$.name,message:$.message,stack:$.stack};return si.json(be,"application/vnd.code.notebook.error")}static stdout($){return si.text($,"application/vnd.code.notebook.stdout")}static stderr($){return si.text($,"application/vnd.code.notebook.stderr")}static bytes($,be="application/octet-stream"){return new si($,be)}static#e=new TextEncoder;static text($,be=A.Mimes.text){const Fe=si.#e.encode(String($));return new si(Fe,be)}static json($,be="text/x-json"){const Fe=JSON.stringify($,void 0,"	");return si.text(Fe,be)}constructor($,be){this.data=$,this.mime=be;const Fe=(0,A.normalizeMimeType)(be,!0);if(!Fe)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.NotebookCellOutputItem=si;class We{static isNotebookCellOutput($){return $ instanceof We?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&Array.isArray($.items)}static ensureUniqueMimeTypes($,be=!1){const Fe=new Set,Ye=new Set;for(let it=0;it<$.length;it++){const ut=$[it],gt=(0,A.normalizeMimeType)(ut.mime);if(!Fe.has(gt)||(0,_.isTextStreamMime)(gt)){Fe.add(gt);continue}Ye.add(it),be&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ye.size===0?$:$.filter((it,ut)=>!Ye.has(ut))}constructor($,be,Fe){this.items=We.ensureUniqueMimeTypes($,!0),typeof be=="string"?(this.id=be,this.metadata=Fe):(this.id=(0,L.generateUuid)(),this.metadata=be??Fe)}}e.NotebookCellOutput=We;var ci;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(ci||(e.NotebookCellKind=ci={}));var xi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var ot;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ot||(e.NotebookCellStatusBarAlignment=ot={}));var bt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(bt||(e.NotebookEditorRevealType=bt={}));class gn{constructor($,be){this.text=$,this.alignment=be}}e.NotebookCellStatusBarItem=gn;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var zi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(zi||(e.NotebookControllerAffinity2=zi={}));class pn{constructor($,be=[]){this.uri=$,this.provides=(0,P.asArray)(be)}}e.NotebookRendererScript=pn;class Pi{constructor($){this.label=$}}e.NotebookKernelSourceAction=Pi;var on;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let Bi=class{constructor($,be){this.label=$,this.timestamp=be}};e.TimelineItem=Bi,e.TimelineItem=Bi=Ge([S],Bi);var an;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Wi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Wi||(e.ExtensionRuntime=Wi={}));var cn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class vn{constructor($,be){this.ranges=$,this.wordPattern=be}}e.LinkedEditingRanges=vn;class bn{constructor($){this._autoForwardAction=$}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=bn;var ln;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ln||(e.TestResultState=ln={}));var un;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let $i=class{constructor($=void 0,be=void 0,Fe=void 0,Ye=!1){this.include=$,this.exclude=be,this.profile=Fe,this.continuous=Ye}};e.TestRunRequest=$i,e.TestRunRequest=$i=Ge([S],$i);let Hi=f=class{static diff($,be,Fe){const Ye=new f($);return Ye.expectedOutput=be,Ye.actualOutput=Fe,Ye}constructor($){this.message=$}};e.TestMessage=Hi,e.TestMessage=Hi=f=Ge([S],Hi);let Vi=class{constructor($){this.id=$}};e.TestTag=Vi,e.TestTag=Vi=Ge([S],Vi);class ki{constructor($,be){this.covered=$,this.total=be}}e.CoveredCount=ki;const ji=j=>{if(j&&j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`)};class qi{static fromDetails($,be){const Fe=new ki(0,0),Ye=new ki(0,0),it=new ki(0,0);for(const gt of be)if("branches"in gt){Fe.total+=1,Fe.covered+=gt.executed?1:0;for(const jt of gt.branches)Ye.total+=1,Ye.covered+=jt.executed?1:0}else it.total+=1,it.covered+=gt.executed?1:0;const ut=new qi($,Fe,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return ut.detailedCoverage=be,ut}constructor($,be,Fe,Ye){this.uri=$,this.statementCoverage=be,this.branchCoverage=Fe,this.declarationCoverage=Ye,ji(be),ji(Fe),ji(Ye)}}e.FileCoverage=qi;class ge{get executionCount(){return+this.executed}set executionCount($){this.executed=$}constructor($,be,Fe=[]){this.executed=$,this.location=be,this.branches=Fe}}e.StatementCoverage=ge;class _e{get executionCount(){return+this.executed}set executionCount($){this.executed=$}constructor($,be,Fe){this.executed=$,this.location=be,this.label=Fe}}e.BranchCoverage=_e;class $e{get executionCount(){return+this.executed}set executionCount($){this.executed=$}constructor($,be,Fe){this.name=$,this.executed=be,this.location=Fe}}e.DeclarationCoverage=$e;var ct;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ct||(e.ExternalUriOpenerPriority=ct={}));var wt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(wt||(e.WorkspaceTrustState=wt={}));var Ot;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ot||(e.PortAutoForwardAction=Ot={}));class Gi{constructor($,be,Fe,Ye,it,ut){this.kind=$,this.name=be,this.detail=Fe,this.uri=Ye,this.range=it,this.selectionRange=ut}}e.TypeHierarchyItem=Gi;class Tn{constructor($){this.uri=$}}e.TextTabInput=Tn;class An{constructor($,be){this.original=$,this.modified=be}}e.TextDiffTabInput=An;class Rn{constructor($,be,Fe,Ye){this.base=$,this.input1=be,this.input2=Fe,this.result=Ye}}e.TextMergeTabInput=Rn;class Ln{constructor($,be){this.uri=$,this.viewType=be}}e.CustomEditorTabInput=Ln;class On{constructor($){this.viewType=$}}e.WebviewEditorTabInput=On;class Fn{constructor($,be){this.uri=$,this.notebookType=be}}e.NotebookEditorTabInput=Fn;class Nn{constructor($,be,Fe){this.original=$,this.modified=be,this.notebookType=Fe}}e.NotebookDiffEditorTabInput=Nn;class Mn{constructor(){}}e.TerminalEditorTabInput=Mn;class Un{constructor($,be){this.uri=$,this.inputBoxUri=be}}e.InteractiveWindowInput=Un;class xn{constructor($){this.providerId=$}}e.ChatEditorTabInput=xn;var En;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var wn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(wn||(e.ChatCopyKind=wn={}));var Sn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class zn{constructor($,be){this.label=$,this.values=be}}e.ChatCompletionItem=zn;var _n;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(_n||(e.InteractiveEditorResponseFeedbackKind=_n={}));var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(yn||(e.ChatResultFeedbackKind=yn={}));class Bn{constructor($){this.value=typeof $=="string"?new Me($):$}}e.ChatResponseMarkdownPart=Bn;class Wn{constructor($,be){this.value=$,this.baseUri=be}}e.ChatResponseFileTreePart=Wn;class $n{constructor($,be){this.value=$,this.title=be}}e.ChatResponseAnchorPart=$n;class Hn{constructor($){this.value=$}}e.ChatResponseProgressPart=Hn;class Vn{constructor($){this.value=$}}e.ChatResponseCommandButtonPart=Vn;class jn{constructor($){this.value=$}}e.ChatResponseReferencePart=jn;class qn{constructor($,be,Fe,Ye){this.prompt=$,this.command=be,this.variables=Fe,this.participant=Ye}}e.ChatRequestTurn=qn;class Gn{constructor($,be,Fe,Ye){this.response=$,this.result=be,this.participant=Fe,this.command=Ye}}e.ChatResponseTurn=Gn;class Kn{constructor($){this.content=$}}e.LanguageModelSystemMessage=Kn;class Xn{constructor($,be){this.content=$,this.name=be}}e.LanguageModelUserMessage=Xn;class Qn{constructor($){this.content=$}}e.LanguageModelAssistantMessage=Qn;var Cn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Dn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var In;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}));class Yn{constructor($,be){this.text=$,this.range=be}}e.InlineEdit=Yn;var Pn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Pn||(e.InlineEditTriggerKind=Pn={}))}),define(Ce[314],De([1,0,6,7]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class p{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(P.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,w,E){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const C=this._relatedInformationProviders.get(A);if(!C)throw new Error("related information provider not found");return await C.provideRelatedInformation(w,E)??[]}getRelatedInformation(A,w,E){return this._proxy.$getAiRelatedInformation(w,E)}registerRelatedInformationProvider(A,w,E){const C=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(C,E),this._proxy.$registerAiRelatedInformationProvider(C,w),new F.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(C),this._relatedInformationProviders.delete(C)})}}e.ExtHostRelatedInformation=p}),define(Ce[315],De([1,0,4,6,7,25,142]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class w{constructor(L){this._authenticationProviders=new Map,this._onDidChangeSessions=new P.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new E,this._getSessionsTaskSingler=new E,this._proxy=L.getProxy(F.MainContext.MainThreadAuthentication)}async getSession(L,I,v,y={}){const _=R.ExtensionIdentifier.toKey(L.identifier),l=[...v].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${_} ${I} ${l}`,async()=>{await this._proxy.$ensureProvider(I);const b=L.displayName||L.name;return this._proxy.$getSession(I,v,_,b,y)})}async getSessions(L,I,v){const y=R.ExtensionIdentifier.toKey(L.identifier),_=[...v].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${y} ${_}`,async()=>{await this._proxy.$ensureProvider(I);const l=L.displayName||L.name;return this._proxy.$getSessions(I,v,y,l)})}async removeSession(L,I){const v=this._authenticationProviders.get(L);return v?v.provider.removeSession(I):this._proxy.$removeSession(L,I)}registerAuthenticationProvider(L,I,v,y){if(this._authenticationProviders.get(L))throw new Error(`An authentication provider with id '${L}' is already registered.`);this._authenticationProviders.set(L,{label:I,provider:v,options:y??{supportsMultipleAccounts:!1}});const _=v.onDidChangeSessions(l=>this._proxy.$sendDidChangeSessions(L,l));return this._proxy.$registerAuthenticationProvider(L,I,y?.supportsMultipleAccounts??!1),new p.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(L),this._proxy.$unregisterAuthenticationProvider(L)})}$createSession(L,I,v){const y=this._authenticationProviders.get(L);if(y)return Promise.resolve(y.provider.createSession(I,v));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$removeSession(L,I){const v=this._authenticationProviders.get(L);if(v)return Promise.resolve(v.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$getSessions(L,I){const v=this._authenticationProviders.get(L);if(v)return Promise.resolve(v.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$onDidChangeAuthenticationSessions(L,I){return L.startsWith(A.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:L,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=w;class E{constructor(){this._inFlightPromises=new Map}getOrCreate(L,I){const v=this._inFlightPromises.get(L);if(v)return v;const y=I().finally(()=>this._inFlightPromises.delete(L));return this._inFlightPromises.set(L,y),y}}}),define(Ce[148],De([1,0,2,6,7,5,20,13,19,12,17,26]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class{static{v=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(l,b){this._logService=b,this._provider=new Map,this._proxy=l.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(l,b){const o=v._handlePool++;this._provider.set(o,{provider:l,extensionDescription:b}),this._proxy.$registerDecorationProvider(o,b.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this._proxy.$onDidChange(o,null);return}const r=(0,E.asArray)(n);if(r.length<=v._maxEventSize){this._proxy.$onDidChange(o,r);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",b.identifier.value,r.length);const a=r.map(u=>({uri:u,rank:(0,C.count)(u.path,"/")})),t=(0,E.groupBy)(a,(u,s)=>u.rank-s.rank||(0,C.compare)(u.uri.path,s.uri.path)),h=[];e:for(const u of t){let s;for(const c of u){const d=(0,L.dirname)(c.uri.path);if(s!==d&&(s=d,h.push(c.uri)>=v._maxEventSize))break e}}this._proxy.$onDidChange(o,h)});return new p.Disposable(()=>{i?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(l,b,o){if(!this._provider.has(l))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this._provider.get(l);return await Promise.all(b.map(async a=>{try{const{uri:t,id:h}=a,u=await Promise.resolve(n.provideFileDecoration(P.URI.revive(t),o));if(!u)return;try{p.FileDecoration.validate(u),u.badge&&typeof u.badge!="string"&&(0,I.checkProposedApiEnabled)(r,"codiconDecoration"),i[h]=[u.propagate,u.tooltip,u.badge,u.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${r.identifier.value}': ${s}`)}}catch(t){this._logService.error(t)}})),i}};e.ExtHostDecorations=y,e.ExtHostDecorations=y=v=Ge([He(0,A.IExtHostRpcService),He(1,w.ILogService)],y),e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")}),define(Ce[316],De([1,0,14,2,7,6,16,22,12]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{static{this._handlePool=0}constructor(I,v,y){this._documentsAndEditors=v,this._logService=y,this._documentContentProviders=new Map,this._proxy=I.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,v){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=C._handlePool++;this._documentContentProviders.set(y,v),this._proxy.$registerTextContentProvider(y,I);let _;if(typeof v.onDidChange=="function"){let l;_=v.onDidChange(async b=>{if(b.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(b))return;l&&await l;const o=this.$provideTextDocumentContent(y,b).then(async i=>{if(!i&&typeof i!="string")return;const n=this._documentsAndEditors.getDocument(b);if(!n)return;const r=(0,E.splitLines)(i);if(!n.equalLines(r))return this._proxy.$onVirtualDocumentChange(b,i)}).catch(P.onUnexpectedError).finally(()=>{l===o&&(l=void 0)});l=o})}return new p.Disposable(()=>{this._documentContentProviders.delete(y)&&this._proxy.$unregisterTextContentProvider(y),_&&(_.dispose(),_=void 0)})}$provideTextDocumentContent(I,v){const y=this._documentContentProviders.get(I);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(v),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=C}),define(Ce[149],De([1,0,61,16,12,177,126,7,19]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function L(_,l){l?C.set(_,l):C.delete(_)}e.setWordDefinitionFor=L;function I(_){return C.get(_)}class v extends R.MirrorTextModel{constructor(l,b,o,i,n,r,a){super(b,o,i,n),this._proxy=l,this._languageId=r,this._isDirty=a,this._isDisposed=!1}dispose(){(0,P.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,E.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===F.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},save(){return l._save()},getText(b){return b?l._getTextInRange(b):l.getText()},get eol(){return l._eol===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(b){return l._lineAt(b)},offsetAt(b){return l._offsetAt(b)},positionAt(b){return l._positionAt(b)},validateRange(b){return l._validateRange(b)},validatePosition(b){return l._validatePosition(b)},getWordRangeAtPosition(b,o){return l._getWordRangeAtPosition(b,o)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,P.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,P.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const b=this._validateRange(l);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const o=this._eol,i=b.start.line,n=b.end.line,r=[];r.push(this._lines[i].substring(b.start.character));for(let a=i+1;a<n;a++)r.push(this._lines[a]);return r.push(this._lines[n].substring(0,b.end.character)),r.join(o)}_lineAt(l){let b;if(l instanceof w.Position?b=l.line:typeof l=="number"&&(b=l),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new y(b,this._lines[b],b===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(l),o=this._lines[b.index].length;return new w.Position(b.index,Math.min(b.remainder,o))}_validateRange(l){if(!(l instanceof w.Range))throw new Error("Invalid argument");const b=this._validatePosition(l.start),o=this._validatePosition(l.end);return b===l.start&&o===l.end?l:new w.Range(b.line,b.character,o.line,o.character)}_validatePosition(l){if(!(l instanceof w.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:b,character:o}=l,i=!1;if(b<0)b=0,o=0,i=!0;else if(b>=this._lines.length)b=this._lines.length-1,o=this._lines[b].length,i=!0;else{const n=this._lines[b].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new w.Position(b,o):l}_getWordRangeAtPosition(l,b){const o=this._validatePosition(l);if(!b)b=I(this._languageId);else if((0,p.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const i=(0,A.getWordAtText)(o.character+1,(0,A.ensureValidWordDefinition)(b),this._lines[o.line],0);if(i)return new w.Range(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.ExtHostDocumentData=v;class y{constructor(l,b,o){this._line=l,this._text=b,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new w.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new w.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=y}),define(Ce[317],De([1,0,6,7]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class p{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(P.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,w,E){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const C=this._AiEmbeddingVectorProviders.get(A);if(!C)throw new Error("Embedding vector provider not found");const L=await C.provideEmbeddingVector(w,E);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(A,w,E){const C=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(C,E),this._proxy.$registerAiEmbeddingVectorProvider(w,C),new F.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(C),this._AiEmbeddingVectorProviders.delete(C)})}}e.ExtHostAiEmbeddingVector=p}),define(Ce[69],De([1,0,6,32,7,21,5,20,59,3,8,23,16]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let _=y=class{constructor(b,o){this._fileSystemProvider=new Map,this._writeQueue=new L.ResourceQueue,this._proxy=b.getProxy(P.MainContext.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i._fileSystemProvider.get(n.scheme);return a?(await i._proxy.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i._proxy.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===F.FilePermission.Readonly?1:void 0}}catch(r){y._handleError(r)}},async readDirectory(n){try{const r=i._fileSystemProvider.get(n.scheme);return r?(await i._proxy.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i._proxy.$readdir(n)}catch(r){return y._handleError(r)}},async createDirectory(n){try{const r=i._fileSystemProvider.get(n.scheme);return r&&!r.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(r.impl,r.extUri,n)):await i._proxy.$mkdir(n)}catch(r){return y._handleError(r)}},async readFile(n){try{const r=i._fileSystemProvider.get(n.scheme);return r?(await i._proxy.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i._proxy.$readFile(n)).buffer}catch(r){return y._handleError(r)}},async writeFile(n,r){try{const a=i._fileSystemProvider.get(n.scheme);return a&&!a.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(a.impl,a.extUri,a.extUri.dirname(n)),await i._writeQueue.queueFor(n,()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i._proxy.$writeFile(n,R.VSBuffer.wrap(r))}catch(a){return y._handleError(a)}},async delete(n,r){try{const a=i._fileSystemProvider.get(n.scheme);return a&&!a.isReadonly&&!r?.useTrash?(await i._proxy.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i._proxy.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return y._handleError(a)}},async rename(n,r,a){try{return await i._proxy.$rename(n,r,{overwrite:!1,...a})}catch(t){return y._handleError(t)}},async copy(n,r,a){try{return await i._proxy.$copy(n,r,{overwrite:!1,...a})}catch(t){return y._handleError(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async mkdirp(b,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await b.stat(i)).type&F.FileType.Directory))throw p.FileSystemError.FileExists(`Unable to create folder '${i.scheme===v.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(F.toFileSystemProviderErrorCode(r)!==F.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await b.createDirectory(i)}catch(a){if(F.toFileSystemProviderErrorCode(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static _handleError(b){if(b instanceof p.FileSystemError)throw b;if(b instanceof F.FileSystemProviderError)switch(b.code){case F.FileSystemProviderErrorCode.FileExists:throw p.FileSystemError.FileExists(b.message);case F.FileSystemProviderErrorCode.FileNotFound:throw p.FileSystemError.FileNotFound(b.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw p.FileSystemError.FileNotADirectory(b.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw p.FileSystemError.FileIsADirectory(b.message);case F.FileSystemProviderErrorCode.NoPermissions:throw p.FileSystemError.NoPermissions(b.message);case F.FileSystemProviderErrorCode.Unavailable:throw p.FileSystemError.Unavailable(b.message);default:throw new p.FileSystemError(b.message,b.name)}if(!(b instanceof Error))throw new p.FileSystemError(String(b));if(b.name==="ENOPRO"||b.message.includes("ENOPRO"))throw p.FileSystemError.Unavailable(b.message);switch(b.name){case F.FileSystemProviderErrorCode.FileExists:throw p.FileSystemError.FileExists(b.message);case F.FileSystemProviderErrorCode.FileNotFound:throw p.FileSystemError.FileNotFound(b.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw p.FileSystemError.FileNotADirectory(b.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw p.FileSystemError.FileIsADirectory(b.message);case F.FileSystemProviderErrorCode.NoPermissions:throw p.FileSystemError.NoPermissions(b.message);case F.FileSystemProviderErrorCode.Unavailable:throw p.FileSystemError.Unavailable(b.message);default:throw new p.FileSystemError(b.message,b.name)}}addFileSystemProvider(b,o,i){return this._fileSystemProvider.set(b,{impl:o,extUri:i?.isCaseSensitive?I.extUri:I.extUriIgnorePathCase,isReadonly:!!i?.isReadonly}),(0,C.toDisposable)(()=>this._fileSystemProvider.delete(b))}getFileSystemProviderExtUri(b){return this._fileSystemProvider.get(b)?.extUri??I.extUri}};e.ExtHostConsumerFileSystem=_,e.ExtHostConsumerFileSystem=_=y=Ge([He(0,w.IExtHostRpcService),He(1,E.IExtHostFileSystemInfo)],_),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[318],De([1,0,6,7]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class p{constructor(A){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=A.getProxy(P.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,w){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const E=this._IssueUriRequestHandlers.get(A);if(!E)throw new Error("Issue request handler not found");const C=await E.handleIssueUrlRequest();if(!C)throw new Error("Issue request handler returned no result");return C}async $getIssueReporterData(A,w){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const E=this._IssueDataProviders.get(A);if(!E)throw new Error("Issue data provider not found");const C=await E.provideIssueData(w);if(!C)throw new Error("Issue data provider returned no result");return C}async $getIssueReporterTemplate(A,w){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const E=this._IssueDataProviders.get(A);if(!E)throw new Error("Issue data provider not found");const C=await E.provideIssueTemplate(w);if(!C)throw new Error("Issue template provider returned no result");return C}registerIssueUriRequestHandler(A,w){const E=A.identifier.value;return this._IssueUriRequestHandlers.set(E,w),this._proxy.$registerIssueUriRequestHandler(E),new F.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(E),this._IssueUriRequestHandlers.delete(E)})}registerIssueDataProvider(A,w){const E=A.identifier.value;return this._IssueDataProviders.set(E,w),this._proxy.$registerIssueDataProvider(E),new F.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(E),this._IssueDataProviders.delete(E)})}}e.ExtHostIssueReporter=p}),define(Ce[93],De([1,0,5,27,13,69,2]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,P.createDecorator)("IExtensionStoragePaths");let w=class{constructor(C,L,I){this._logService=L,this._extHostFileSystem=I,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(v=>this._value=v)}async _getWorkspaceStorageURI(C){return A.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,L=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(C){if(this._value)return A.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return A.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=w,e.ExtensionStoragePaths=w=Ge([He(0,F.IExtHostInitDataService),He(1,p.ILogService),He(2,R.IExtHostConsumerFileSystem)],w)}),define(Ce[319],De([1,0,7,20,4]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(w){this._actual=new P.ColorTheme(P.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new p.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(w){let E;switch(w){case"light":E=P.ColorThemeKind.Light;break;case"hcDark":E=P.ColorThemeKind.HighContrast;break;case"hcLight":E=P.ColorThemeKind.HighContrastLight;break;default:E=P.ColorThemeKind.Dark}this._actual=new P.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=R,e.ExtHostTheming=R=Ge([He(0,F.IExtHostRpcService)],R)}),define(Ce[70],De([1,0,22,4,3,222,5,13,88,6,27,20,7]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class y extends E.DisposableTunnel{}var _;(function(b){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:n.protocol}}b.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==E.TunnelPrivacyId.ConstantPrivate&&n.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}b.fromServiceTunnel=i})(_||(e.TunnelDtoConverter=_={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let l=class extends p.Disposable{constructor(o,i,n){super(),this.logService=n,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new F.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadTunnelService)}async openTunnel(o,i){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this._proxy.$openTunnel(i,o.displayName);if(n){const r=new y(n.remoteAddress,n.localAddress,()=>this._proxy.$closeTunnel(n.remoteAddress));return this._register(r),r}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,i){const n=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(n,{selector:o,provider:i}),this._proxy.$registerPortsAttributesProvider(o,n),new v.Disposable(()=>{this._portAttributesProviders.delete(n),this._proxy.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,a){const t=[];for(const u of o){const s=this._portAttributesProviders.get(u);if(!s)return[];t.push(...await Promise.all(i.map(async c=>{let d;try{d=await s.provider.providePortAttributes({port:c,pid:n,commandLine:r},a)}catch{d=await s.provider.providePortAttributes(c,n,r,a)}return{providedAttributes:d,port:c}})))}const h=t.filter(u=>!!u.providedAttributes);return h.length>0?h.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(r,a)=>await o.provideTunnel(r,a,new P.CancellationTokenSource().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(n),Promise.resolve((0,p.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const n=o.tunnelFactory??(i?this.makeManagedTunnelFactory(i):void 0);if(n){this._forwardPortProvider=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this._proxy.$setTunnelProvider(a)}}else this._forwardPortProvider=void 0;return(0,p.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,i){if(this._extensionTunnels.has(o.host)){const n=this._extensionTunnels.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,i){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this._forwardPortProvider(o,i);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const a=this._register(r.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(r.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:a}),_.fromApiTunnel(r)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this._showCandidatePort(r.host,r.port,r.detail??""))),n=o.filter((r,a)=>i[a]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.ExtHostTunnelService=l,e.ExtHostTunnelService=l=Ge([He(0,I.IExtHostRpcService),He(1,L.IExtHostInitDataService),He(2,w.ILogService)],l)}),define(Ce[15],De([1,0,19,21,166,74,80,28,161,56,100,24,23,18,2,29,83,135,141,139,118,67,89,292,26,7]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var c;(function(Re){function Ue(te){const{selectionStartLineNumber:Le,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:Qe}=te,at=new s.Position(Le-1,Be-1),_t=new s.Position(Ze-1,Qe-1);return new s.Selection(at,_t)}Re.to=Ue;function Se(te){const{anchor:Le,active:Be}=te;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Re.from=Se})(c||(e.Selection=c={}));var d;(function(Re){function Ue(te){if(!te)return;const{start:Le,end:Be}=te;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Re.from=Ue;function Se(te){if(!te)return;const{startLineNumber:Le,startColumn:Be,endLineNumber:Ze,endColumn:Qe}=te;return new s.Range(Le-1,Be-1,Ze-1,Qe-1)}Re.to=Se})(d||(e.Range=d={}));var m;(function(Re){function Ue(te){return{uri:te.uri,range:d.from(te.range)}}Re.from=Ue;function Se(te){return new s.Location(_.URI.revive(te.uri),d.to(te.range))}Re.to=Se})(m||(e.Location=m={}));var D;(function(Re){function Ue(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Ue})(D||(e.TokenType=D={}));var g;(function(Re){function Ue(te){return new s.Position(te.lineNumber-1,te.column-1)}Re.to=Ue;function Se(te){return{lineNumber:te.line+1,column:te.character+1}}Re.from=Se})(g||(e.Position=g={}));var f;(function(Re){function Ue(Le,Be,Ze){return(0,P.coalesce)((0,P.asArray)(Le).map(Qe=>Se(Qe,Be,Ze)))}Re.from=Ue;function Se(Le,Be,Ze){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ze?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:te(Le.scheme,Be),pattern:oe.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ze?.isBuiltin}}function te(Le,Be){return Be&&typeof Le=="string"?Be.transformOutgoingScheme(Le):Le}})(f||(e.DocumentSelector=f={}));var S;(function(Re){function Ue(te){switch(te){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Ue;function Se(te){switch(te){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(S||(e.DiagnosticTag=S={}));var T;(function(Re){function Ue(te){let Le;return te.code&&((0,y.isString)(te.code)||(0,y.isNumber)(te.code)?Le=String(te.code):Le={value:String(te.code.value),target:te.code.target}),{...d.from(te.range),message:te.message,source:te.source,code:Le,severity:z.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(N.from),tags:Array.isArray(te.tags)?(0,P.coalesce)(te.tags.map(S.from)):void 0}}Re.from=Ue;function Se(te){const Le=new s.Diagnostic(d.to(te),te.message,z.to(te.severity));return Le.source=te.source,Le.code=(0,y.isString)(te.code)?te.code:te.code?.value,Le.relatedInformation=te.relatedInformation&&te.relatedInformation.map(N.to),Le.tags=te.tags&&(0,P.coalesce)(te.tags.map(S.to)),Le}Re.to=Se})(T||(e.Diagnostic=T={}));var N;(function(Re){function Ue(te){return{...d.from(te.location.range),message:te.message,resource:te.location.uri}}Re.from=Ue;function Se(te){return new s.DiagnosticRelatedInformation(new s.Location(te.resource,d.to(te)),te.message)}Re.to=Se})(N||(e.DiagnosticRelatedInformation=N={}));var z;(function(Re){function Ue(te){switch(te){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Re.from=Ue;function Se(te){switch(te){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Se})(z||(e.DiagnosticSeverity=z={}));var x;(function(Re){function Ue(te){return typeof te=="number"&&te>=s.ViewColumn.One?te-1:te===s.ViewColumn.Beside?h.SIDE_GROUP:h.ACTIVE_GROUP}Re.from=Ue;function Se(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(x||(e.ViewColumn=x={}));function M(Re){return typeof Re.range<"u"}function k(Re){return Re.length===0?!0:!!M(Re[0])}e.isDecorationOptionsArr=k;var O;(function(Re){function Ue(Qe){return Qe.map(Re.from)}Re.fromMany=Ue;function Se(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function te(Qe){let at;if(Se(Qe)){const{language:Lt,value:Xt}=Qe;at={value:"```"+Lt+`
`+Xt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Qe)?at={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?at={value:Qe}:at={value:""};const _t=Object.create(null);at.uris=_t;const Vt=Lt=>{try{let Xt=_.URI.parse(Lt,!0);Xt=Xt.with({query:Le(Xt.query,_t)}),_t[Lt]=Xt}catch{}return""},Ct=new E.marked.Renderer;return Ct.link=Vt,Ct.image=Lt=>typeof Lt=="string"?Vt(A.parseHrefAndDimensions(Lt).href):"",(0,E.marked)(at.value,{renderer:Ct}),at}Re.from=te;function Le(Qe,at){if(!Qe)return Qe;let _t;try{_t=(0,C.parse)(Qe)}catch{}if(!_t)return Qe;let Vt=!1;return _t=(0,I.cloneAndChange)(_t,Ct=>{if(_.URI.isUri(Ct)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[Lt]=Ct,Vt=!0,Lt}else return}),Vt?JSON.stringify(_t):Qe}function Be(Qe){const at=new s.MarkdownString(Qe.value,Qe.supportThemeIcons);return at.isTrusted=Qe.isTrusted,at.supportHtml=Qe.supportHtml,at.baseUri=Qe.baseUri?_.URI.from(Qe.baseUri):void 0,at}Re.to=Be;function Ze(Qe){if(Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=Ze})(O||(e.MarkdownString=O={}));function U(Re){return k(Re)?Re.map(Ue=>({range:d.from(Ue.range),hoverMessage:Array.isArray(Ue.hoverMessage)?O.fromMany(Ue.hoverMessage):Ue.hoverMessage?O.from(Ue.hoverMessage):void 0,renderOptions:Ue.renderOptions})):Re.map(Ue=>({range:d.from(Ue)}))}e.fromRangeOrRangeWithMessage=U;function q(Re){return typeof Re>"u"?Re:typeof Re=="string"?_.URI.file(Re):Re}e.pathOrURIToURI=q;var ie;(function(Re){function Ue(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?q(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Ue})(ie||(e.ThemableDecorationAttachmentRenderOptions=ie={}));var Z;(function(Re){function Ue(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?q(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ie.from(Se.before):void 0,after:Se.after?ie.from(Se.after):void 0}}Re.from=Ue})(Z||(e.ThemableDecorationRenderOptions=Z={}));var Q;(function(Re){function Ue(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ue})(Q||(e.DecorationRangeBehavior=Q={}));var Y;(function(Re){function Ue(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?Q.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Z.from(Se.light):void 0,dark:Se.dark?Z.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?q(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?ie.from(Se.before):void 0,after:Se.after?ie.from(Se.after):void 0}}Re.from=Ue})(Y||(e.DecorationRenderOptions=Y={}));var ae;(function(Re){function Ue(te){return{text:te.newText,eol:te.newEol&&Pe.from(te.newEol),range:d.from(te.range)}}Re.from=Ue;function Se(te){const Le=new s.TextEdit(d.to(te.range),te.text);return Le.newEol=typeof te.eol>"u"?void 0:Pe.to(te.eol),Le}Re.to=Se})(ae||(e.TextEdit=ae={}));var ee;(function(Re){function Ue(te,Le){const Be={edits:[]};if(te instanceof s.WorkspaceEdit){const Ze=new w.ResourceSet;for(const Qe of te._allEntries())Qe._type===1&&_.URI.isUri(Qe.to)&&Qe.from===void 0&&Ze.add(Qe.to);for(const Qe of te._allEntries())if(Qe._type===1){let at;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?at={type:"base64",value:(0,F.encodeBase64)(F.VSBuffer.wrap(Qe.options.contents))}:at={type:"dataTransferItem",id:Qe.options.contents._itemId}),Be.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:at},metadata:Qe.metadata})}else Qe._type===2?Be.edits.push({resource:Qe.uri,textEdit:ae.from(Qe.edit),versionId:Ze.has(Qe.uri)?void 0:Le?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Be.edits.push({resource:Qe.uri,textEdit:{range:d.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(Qe.uri)?void 0:Le?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(kt.from)}})}return Be}Re.from=Ue;function Se(te){const Le=new s.WorkspaceEdit,Be=new w.ResourceMap;for(const Ze of te.edits)if(Ze.textEdit){const Qe=Ze,at=_.URI.revive(Qe.resource),_t=d.to(Qe.textEdit.range),Vt=Qe.textEdit.text,Ct=Qe.textEdit.insertAsSnippet;let Lt;Ct?Lt=s.SnippetTextEdit.replace(_t,new s.SnippetString(Vt)):Lt=s.TextEdit.replace(_t,Vt);const Xt=Be.get(at);Xt?Xt.push(Lt):Be.set(at,[Lt])}else Le.renameFile(_.URI.revive(Ze.oldResource),_.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Qe]of Be)Le.set(Ze,Qe);return Le}Re.to=Se})(ee||(e.WorkspaceEdit=ee={}));var fe;(function(Re){const Ue=Object.create(null);Ue[s.SymbolKind.File]=0,Ue[s.SymbolKind.Module]=1,Ue[s.SymbolKind.Namespace]=2,Ue[s.SymbolKind.Package]=3,Ue[s.SymbolKind.Class]=4,Ue[s.SymbolKind.Method]=5,Ue[s.SymbolKind.Property]=6,Ue[s.SymbolKind.Field]=7,Ue[s.SymbolKind.Constructor]=8,Ue[s.SymbolKind.Enum]=9,Ue[s.SymbolKind.Interface]=10,Ue[s.SymbolKind.Function]=11,Ue[s.SymbolKind.Variable]=12,Ue[s.SymbolKind.Constant]=13,Ue[s.SymbolKind.String]=14,Ue[s.SymbolKind.Number]=15,Ue[s.SymbolKind.Boolean]=16,Ue[s.SymbolKind.Array]=17,Ue[s.SymbolKind.Object]=18,Ue[s.SymbolKind.Key]=19,Ue[s.SymbolKind.Null]=20,Ue[s.SymbolKind.EnumMember]=21,Ue[s.SymbolKind.Struct]=22,Ue[s.SymbolKind.Event]=23,Ue[s.SymbolKind.Operator]=24,Ue[s.SymbolKind.TypeParameter]=25;function Se(Le){return typeof Ue[Le]=="number"?Ue[Le]:6}Re.from=Se;function te(Le){for(const Be in Ue)if(Ue[Be]===Le)return Number(Be);return s.SymbolKind.Property}Re.to=te})(fe||(e.SymbolKind=fe={}));var re;(function(Re){function Ue(te){switch(te){case s.SymbolTag.Deprecated:return 1}}Re.from=Ue;function Se(te){switch(te){case 1:return s.SymbolTag.Deprecated}}Re.to=Se})(re||(e.SymbolTag=re={}));var G;(function(Re){function Ue(te){return{name:te.name,kind:fe.from(te.kind),tags:te.tags&&te.tags.map(re.from),containerName:te.containerName,location:de.from(te.location)}}Re.from=Ue;function Se(te){const Le=new s.SymbolInformation(te.name,fe.to(te.kind),te.containerName,de.to(te.location));return Le.tags=te.tags&&te.tags.map(re.to),Le}Re.to=Se})(G||(e.WorkspaceSymbol=G={}));var B;(function(Re){function Ue(te){const Le={name:te.name||"!!MISSING: name!!",detail:te.detail,range:d.from(te.range),selectionRange:d.from(te.selectionRange),kind:fe.from(te.kind),tags:te.tags?.map(re.from)??[]};return te.children&&(Le.children=te.children.map(Ue)),Le}Re.from=Ue;function Se(te){const Le=new s.DocumentSymbol(te.name,te.detail,fe.to(te.kind),d.to(te.range),d.to(te.selectionRange));return(0,P.isNonEmptyArray)(te.tags)&&(Le.tags=te.tags.map(re.to)),te.children&&(Le.children=te.children.map(Se)),Le}Re.to=Se})(B||(e.DocumentSymbol=B={}));var se;(function(Re){function Ue(te){const Le=new s.CallHierarchyItem(fe.to(te.kind),te.name,te.detail||"",_.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Le._sessionId=te._sessionId,Le._itemId=te._itemId,Le}Re.to=Ue;function Se(te,Le,Be){if(Le=Le??te._sessionId,Be=Be??te._itemId,Le===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Be,name:te.name,detail:te.detail,kind:fe.from(te.kind),uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(re.from)}}Re.from=Se})(se||(e.CallHierarchyItem=se={}));var ye;(function(Re){function Ue(Se){return new s.CallHierarchyIncomingCall(se.to(Se.from),Se.fromRanges.map(te=>d.to(te)))}Re.to=Ue})(ye||(e.CallHierarchyIncomingCall=ye={}));var le;(function(Re){function Ue(Se){return new s.CallHierarchyOutgoingCall(se.to(Se.to),Se.fromRanges.map(te=>d.to(te)))}Re.to=Ue})(le||(e.CallHierarchyOutgoingCall=le={}));var de;(function(Re){function Ue(te){return{range:te.range&&d.from(te.range),uri:te.uri}}Re.from=Ue;function Se(te){return new s.Location(_.URI.revive(te.uri),d.to(te.range))}Re.to=Se})(de||(e.location=de={}));var ce;(function(Re){function Ue(te){const Le=te,Be=te;return{originSelectionRange:Le.originSelectionRange?d.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Be.uri,range:d.from(Le.targetRange?Le.targetRange:Be.range),targetSelectionRange:Le.targetSelectionRange?d.from(Le.targetSelectionRange):void 0}}Re.from=Ue;function Se(te){return{targetUri:_.URI.revive(te.uri),targetRange:d.to(te.range),targetSelectionRange:te.targetSelectionRange?d.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?d.to(te.originSelectionRange):void 0}}Re.to=Se})(ce||(e.DefinitionLink=ce={}));var he;(function(Re){function Ue(te){return{range:d.from(te.range),contents:O.fromMany(te.contents)}}Re.from=Ue;function Se(te){return new s.Hover(te.contents.map(O.to),d.to(te.range))}Re.to=Se})(he||(e.Hover=he={}));var V;(function(Re){function Ue(te){return{range:d.from(te.range),expression:te.expression}}Re.from=Ue;function Se(te){return new s.EvaluatableExpression(d.to(te.range),te.expression)}Re.to=Se})(V||(e.EvaluatableExpression=V={}));var J;(function(Re){function Ue(te){if(te instanceof s.InlineValueText)return{type:"text",range:d.from(te.range),text:te.text};if(te instanceof s.InlineValueVariableLookup)return{type:"variable",range:d.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ue;function Se(te){switch(te.type){case"text":return{range:d.to(te.range),text:te.text};case"variable":return{range:d.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:d.to(te.range),expression:te.expression}}}Re.to=Se})(J||(e.InlineValue=J={}));var ue;(function(Re){function Ue(te){return{frameId:te.frameId,stoppedLocation:d.from(te.stoppedLocation)}}Re.from=Ue;function Se(te){return new s.InlineValueContext(te.frameId,d.to(te.stoppedLocation))}Re.to=Se})(ue||(e.InlineValueContext=ue={}));var ve;(function(Re){function Ue(te){return{range:d.from(te.range),kind:te.kind}}Re.from=Ue;function Se(te){return new s.DocumentHighlight(d.to(te.range),te.kind)}Re.to=Se})(ve||(e.DocumentHighlight=ve={}));var ke;(function(Re){function Ue(te){return{uri:te.uri,highlights:te.highlights.map(ve.from)}}Re.from=Ue;function Se(te){return new s.MultiDocumentHighlight(_.URI.revive(te.uri),te.highlights.map(ve.to))}Re.to=Se})(ke||(e.MultiDocumentHighlight=ke={}));var we;(function(Re){function Ue(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Ue})(we||(e.CompletionTriggerKind=we={}));var Te;(function(Re){function Ue(Se){return{triggerKind:we.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Ue})(Te||(e.CompletionContext=Te={}));var Oe;(function(Re){function Ue(te){switch(te){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Ue;function Se(te){switch(te){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Se})(Oe||(e.CompletionItemTag=Oe={}));var xe;(function(Re){const Ue=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se(Be){return Ue.get(Be)??9}Re.from=Se;const te=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Be){return te.get(Be)??s.CompletionItemKind.Property}Re.to=Le})(xe||(e.CompletionItemKind=xe={}));var W;(function(Re){function Ue(Se,te){const Le=new s.CompletionItem(Se.label);return Le.insertText=Se.insertText,Le.kind=xe.to(Se.kind),Le.tags=Se.tags?.map(Oe.to),Le.detail=Se.detail,Le.documentation=A.isMarkdownString(Se.documentation)?O.to(Se.documentation):Se.documentation,Le.sortText=Se.sortText,Le.filterText=Se.filterText,Le.preselect=Se.preselect,Le.commitCharacters=Se.commitCharacters,l.Range.isIRange(Se.range)?Le.range=d.to(Se.range):typeof Se.range=="object"&&(Le.range={inserting:d.to(Se.range.insert),replacing:d.to(Se.range.replace)}),Le.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Le.insertText=new s.SnippetString(Se.insertText):(Le.insertText=Se.insertText,Le.textEdit=Le.range instanceof s.Range?new s.TextEdit(Le.range,Le.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Le.additionalTextEdits=Se.additionalTextEdits.map(Be=>ae.to(Be))),Le.command=te&&Se.command?te.fromInternal(Se.command):void 0,Le}Re.to=Ue})(W||(e.CompletionItem=W={}));var H;(function(Re){function Ue(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:O.fromStrict(te.documentation)}}Re.from=Ue;function Se(te){return{label:te.label,documentation:A.isMarkdownString(te.documentation)?O.to(te.documentation):te.documentation}}Re.to=Se})(H||(e.ParameterInformation=H={}));var X;(function(Re){function Ue(te){return{label:te.label,documentation:O.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(H.from):[],activeParameter:te.activeParameter}}Re.from=Ue;function Se(te){return{label:te.label,documentation:A.isMarkdownString(te.documentation)?O.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(H.to):[],activeParameter:te.activeParameter}}Re.to=Se})(X||(e.SignatureInformation=X={}));var K;(function(Re){function Ue(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(X.from):[]}}Re.from=Ue;function Se(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(X.to):[]}}Re.to=Se})(K||(e.SignatureHelp=K={}));var pe;(function(Re){function Ue(Se,te){const Le=new s.InlayHint(g.to(te.position),typeof te.label=="string"?te.label:te.label.map(Ee.to.bind(void 0,Se)),te.kind&&Me.to(te.kind));return Le.textEdits=te.textEdits&&te.textEdits.map(ae.to),Le.tooltip=A.isMarkdownString(te.tooltip)?O.to(te.tooltip):te.tooltip,Le.paddingLeft=te.paddingLeft,Le.paddingRight=te.paddingRight,Le}Re.to=Ue})(pe||(e.InlayHint=pe={}));var Ee;(function(Re){function Ue(Se,te){const Le=new s.InlayHintLabelPart(te.label);return Le.tooltip=A.isMarkdownString(te.tooltip)?O.to(te.tooltip):te.tooltip,b.Command.is(te.command)&&(Le.command=Se.fromInternal(te.command)),te.location&&(Le.location=de.to(te.location)),Le}Re.to=Ue})(Ee||(e.InlayHintLabelPart=Ee={}));var Me;(function(Re){function Ue(te){return te}Re.from=Ue;function Se(te){return te}Re.to=Se})(Me||(e.InlayHintKind=Me={}));var Ve;(function(Re){function Ue(te){return{range:d.from(te.range),url:te.target,tooltip:te.tooltip}}Re.from=Ue;function Se(te){let Le;if(te.url)try{Le=typeof te.url=="string"?_.URI.parse(te.url,!0):_.URI.revive(te.url)}catch{}return new s.DocumentLink(d.to(te.range),Le)}Re.to=Se})(Ve||(e.DocumentLink=Ve={}));var Ke;(function(Re){function Ue(te){const Le=new s.ColorPresentation(te.label);return te.textEdit&&(Le.textEdit=ae.to(te.textEdit)),te.additionalTextEdits&&(Le.additionalTextEdits=te.additionalTextEdits.map(Be=>ae.to(Be))),Le}Re.to=Ue;function Se(te){return{label:te.label,textEdit:te.textEdit?ae.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Le=>ae.from(Le)):void 0}}Re.from=Se})(Ke||(e.ColorPresentation=Ke={}));var tt;(function(Re){function Ue(te){return new s.Color(te[0],te[1],te[2],te[3])}Re.to=Ue;function Se(te){return[te.red,te.green,te.blue,te.alpha]}Re.from=Se})(tt||(e.Color=tt={}));var st;(function(Re){function Ue(te){return{range:d.from(te.range)}}Re.from=Ue;function Se(te){return new s.SelectionRange(d.to(te.range))}Re.to=Se})(st||(e.SelectionRange=st={}));var lt;(function(Re){function Ue(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Ue})(lt||(e.TextDocumentSaveReason=lt={}));var rt;(function(Re){function Ue(te){switch(te){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ue;function Se(te){switch(te){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Se})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Pe;(function(Re){function Ue(te){if(te===s.EndOfLine.CRLF)return 1;if(te===s.EndOfLine.LF)return 0}Re.from=Ue;function Se(te){if(te===1)return s.EndOfLine.CRLF;if(te===0)return s.EndOfLine.LF}Re.to=Se})(Pe||(e.EndOfLine=Pe={}));var ze;(function(Re){function Ue(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ue})(ze||(e.ProgressLocation=ze={}));var Ae;(function(Re){function Ue(te){const Le={start:te.start+1,end:te.end+1};return te.kind&&(Le.kind=je.from(te.kind)),Le}Re.from=Ue;function Se(te){const Le={start:te.start-1,end:te.end-1};return te.kind&&(Le.kind=je.to(te.kind)),Le}Re.to=Se})(Ae||(e.FoldingRange=Ae={}));var je;(function(Re){function Ue(te){if(te)switch(te){case s.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}Re.from=Ue;function Se(te){if(te)switch(te.value){case b.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Re.to=Se})(je||(e.FoldingRangeKind=je={}));var ne;(function(Re){function Ue(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?d.from(Se.selection):void 0,override:typeof Se.override=="boolean"?n.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Ue})(ne||(e.TextEditorOpenOptions=ne={}));var oe;(function(Re){function Ue(Be){return Be instanceof s.RelativePattern?Be.toJSON():typeof Be=="string"?Be:Se(Be)||te(Be)?new s.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Re.from=Ue;function Se(Be){const Ze=Be;return Ze?_.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function te(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Le(Be){return typeof Be=="string"?Be:new s.RelativePattern(_.URI.revive(Be.baseUri),Be.pattern)}Re.to=Le})(oe||(e.GlobPattern=oe={}));var Ie;(function(Re){function Ue(Se){if(Se){if(Array.isArray(Se))return Se.map(Ue);if(typeof Se=="string")return Se;{const te=Se;return{language:te.language,scheme:te.scheme,pattern:oe.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Re.from=Ue})(Ie||(e.LanguageSelector=Ie={}));var qe;(function(Re){function Ue(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Le=>Array.isArray(Le)&&Le.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&_.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof s.Range)))}Re.is=Ue;function Se(te){return{documents:te.documents.map(Le=>Le.map(Be=>({uri:_.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>d.from(Ze))})))}}Re.from=Se})(qe||(e.MappedEditsContext=qe={}));var Je;(function(Re){function Ue(te){return{start:te.start,end:te.end}}Re.from=Ue;function Se(te){return new s.NotebookRange(te.start,te.end)}Re.to=Se})(Je||(e.NotebookRange=Je={}));var nt;(function(Re){function Ue(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Re.to=Ue;function Se(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Re.from=Se})(nt||(e.NotebookCellExecutionSummary=nt={}));var Ne;(function(Re){function Ue(Se){if(Se===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===r.NotebookCellExecutionState.Pending)return;if(Se===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Ue})(Ne||(e.NotebookCellExecutionState=Ne={}));var vt;(function(Re){function Ue(te){switch(te){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Re.from=Ue;function Se(te){switch(te){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Se})(vt||(e.NotebookCellKind=vt={}));var yt;(function(Re){function Ue(te){const Le={metadata:te.metadata??Object.create(null),cells:[]};for(const Be of te.cells)s.NotebookCellData.validate(Be),Le.cells.push(kt.from(Be));return Le}Re.from=Ue;function Se(te){const Le=new s.NotebookData(te.cells.map(kt.to));return(0,y.isEmptyObject)(te.metadata)||(Le.metadata=te.metadata),Le}Re.to=Se})(yt||(e.NotebookData=yt={}));var kt;(function(Re){function Ue(te){return{cellKind:vt.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:nt.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Qt.from):[]}}Re.from=Ue;function Se(te){return new s.NotebookCellData(vt.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Qt.to):void 0,te.metadata,te.internalMetadata?nt.to(te.internalMetadata):void 0)}Re.to=Se})(kt||(e.NotebookCellData=kt={}));var Mt;(function(Re){function Ue(te){return{mime:te.mime,valueBytes:F.VSBuffer.wrap(te.data)}}Re.from=Ue;function Se(te){return new s.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Re.to=Se})(Mt||(e.NotebookCellOutputItem=Mt={}));var Qt;(function(Re){function Ue(te){return{outputId:te.id,items:te.items.map(Mt.from),metadata:te.metadata}}Re.from=Ue;function Se(te){const Le=te.items.map(Mt.to);return new s.NotebookCellOutput(Le,te.outputId,te.metadata)}Re.to=Se})(Qt||(e.NotebookCellOutput=Qt={}));var Pt;(function(Re){function Ue(Le){return te(Le)?{include:oe.from(Le.include)??void 0,exclude:oe.from(Le.exclude)??void 0}:oe.from(Le)??void 0}Re.from=Ue;function Se(Le){return te(Le)?{include:oe.to(Le.include),exclude:oe.to(Le.exclude)}:oe.to(Le)}Re.to=Se;function te(Le){const Be=Le;return Be?!(0,y.isUndefinedOrNull)(Be.include)&&!(0,y.isUndefinedOrNull)(Be.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var qt;(function(Re){function Ue(Se,te,Le){const Be=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Be,Le),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Ue})(qt||(e.NotebookStatusBarItem=qt={}));var Gt;(function(Re){function Ue(Se,te,Le){const Be=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:te.toInternal(Be,Le),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Ue})(Gt||(e.NotebookKernelSourceAction=Gt={}));var Jt;(function(Re){function Ue(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Ue})(Jt||(e.NotebookDocumentContentOptions=Jt={}));var ii;(function(Re){function Ue(te){return{uri:te.uri,provides:te.provides}}Re.from=Ue;function Se(te){return new s.NotebookRendererScript(_.URI.revive(te.uri),te.provides)}Re.to=Se})(ii||(e.NotebookRendererScript=ii={}));var et;(function(Re){function Ue(te){return{message:O.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:d.from(te.location.range),uri:te.location.uri}}}Re.from=Ue;function Se(te){const Le=new s.TestMessage(typeof te.message=="string"?te.message:O.to(te.message));return Le.actualOutput=te.actual,Le.expectedOutput=te.expected,Le.contextValue=te.contextValue,Le.location=te.location?de.to(te.location):void 0,Le}Re.to=Se})(et||(e.TestMessage=et={}));var xt;(function(Re){Re.namespace=t.namespaceTestTag,Re.denamespace=t.denamespaceTestTag})(xt||(e.TestTag=xt={}));var Zt;(function(Re){function Ue(te){const Le=(0,i.getPrivateApiFor)(te).controllerId;return{extId:a.TestId.fromExtHostTestItem(te,Le).toString(),label:te.label,uri:_.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Be=>xt.namespace(Le,Be.id)),range:l.Range.lift(d.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&O.fromStrict(te.error)||null}}Re.from=Ue;function Se(te){return{parent:void 0,error:void 0,id:a.TestId.fromString(te.extId).localId,label:te.label,uri:_.URI.revive(te.uri),tags:(te.tags||[]).map(Le=>{const{tagId:Be}=xt.denamespace(Le);return new s.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Re.toPlain=Se})(Zt||(e.TestItem=Zt={})),function(Re){function Ue(te){return{id:te.id}}Re.from=Ue;function Se(te){return new s.TestTag(te.id)}Re.to=Se}(xt||(e.TestTag=xt={}));var ft;(function(Re){const Ue=(te,Le)=>{const Be=[];for(const[Qe,at]of Le)a.TestId.compare(at.item.extId,Qe)===2&&(Le.delete(Qe),Be.push(at));const Ze={...Zt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(at=>at.type===0).map(et.to)})),children:Be.map(Qe=>Ue(Qe,Le))};for(const Qe of Ze.children)Qe.parent=Ze;return Ze};function Se(te){const Le=[],Be=new Map;for(const Ze of te.items){Be.set(Ze.item.extId,Ze);const Qe=a.TestId.root(Ze.item.extId);te.request.targets.some(at=>at.controllerId===Qe&&at.testIds.includes(Ze.item.extId))&&Le.push(Ze)}return{completedAt:te.completedAt,results:Le.map(Ze=>Ue(Ze,Be))}}Re.to=Se})(ft||(e.TestResults=ft={}));var Et;(function(Re){function Ue(Be){return{covered:Be.covered,total:Be.total}}function Se(Be){return"line"in Be?g.from(Be):d.from(Be)}function te(Be){return"branches"in Be?{count:Be.executed,location:Se(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&Se(Ze.location),label:Ze.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:Se(Be.location)}}Re.fromDetailed=te;function Le(Be){return{uri:Be.uri,statement:Ue(Be.statementCoverage),branch:Be.branchCoverage&&Ue(Be.branchCoverage),declaration:Be.declarationCoverage&&Ue(Be.declarationCoverage),details:Be.detailedCoverage?.map(te)}}Re.fromFile=Le})(Et||(e.TestCoverage=Et={}));var ei;(function(Re){function Ue(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Ue})(ei||(e.CodeActionTriggerKind=ei={}));var $t;(function(Re){function Ue(te){const Le=new s.TypeHierarchyItem(fe.to(te.kind),te.name,te.detail||"",_.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Le._sessionId=te._sessionId,Le._itemId=te._itemId,Le}Re.to=Ue;function Se(te,Le,Be){if(Le=Le??te._sessionId,Be=Be??te._itemId,Le===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Be,kind:fe.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(re.from)}}Re.from=Se})($t||(e.TypeHierarchyItem=$t={}));var zt;(function(Re){function Ue(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Ue})(zt||(e.ViewBadge=zt={}));var ht;(function(Re){function Ue(Be,Ze,Qe){const at=Ze.fileData;return at?new s.InternalFileDataTransferItem(new s.DataTransferFile(at.name,_.URI.revive(at.uri),at.id,(0,R.createSingleCallFunction)(()=>Qe(at.id)))):Be===L.Mimes.uriList&&Ze.uriListData?new s.InternalDataTransferItem(Le(Ze.uriListData)):new s.InternalDataTransferItem(Ze.asString)}Re.to=Ue;async function Se(Be,Ze){const Qe=await Ze.asString();if(Be===L.Mimes.uriList)return{asString:Qe,fileData:void 0,uriListData:te(Qe)};const at=Ze.asFile();return{asString:Qe,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}Re.from=Se;function te(Be){return p.UriList.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return _.URI.parse(Ze)}catch{}return Ze})}function Le(Be){return p.UriList.create(Be.map(Ze=>typeof Ze=="string"?Ze:_.URI.revive(Ze)))}})(ht||(e.DataTransferItem=ht={}));var Rt;(function(Re){function Ue(te,Le){const Be=te.items.map(([Ze,Qe])=>[Ze,ht.to(Ze,Qe,Le)]);return new s.DataTransfer(Be)}Re.toDataTransfer=Ue;async function Se(te){const Le={items:[]},Be=[];for(const[Ze,Qe]of te)Be.push((async()=>{Le.items.push([Ze,await ht.from(Ze,Qe)])})());return await Promise.all(Be),Le}Re.from=Se})(Rt||(e.DataTransfer=Rt={}));var ti;(function(Re){function Ue(te,Le){return{kind:"reply",agentId:te.participant??Le?.agentId??"",subCommand:te.command??Le?.command,message:te.prompt,title:te.label}}Re.from=Ue;function Se(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Re.to=Se})(ti||(e.ChatFollowup=ti={}));var Yt;(function(Re){function Ue(Se){return"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:{kind:"reply",message:Se.message,title:Se.title,tooltip:Se.tooltip}}Re.from=Ue})(Yt||(e.ChatInlineFollowup=Yt={}));var Xe;(function(Re){function Ue(te){switch(te.role){case 0:return new s.LanguageModelSystemMessage(te.content);case 1:return new s.LanguageModelUserMessage(te.content);case 2:return new s.LanguageModelAssistantMessage(te.content)}}Re.to=Ue;function Se(te){if(te instanceof s.LanguageModelSystemMessage)return{role:0,content:te.content};if(te instanceof s.LanguageModelUserMessage)return{role:1,content:te.content};if(te instanceof s.LanguageModelAssistantMessage)return{role:2,content:te.content};throw new Error("Invalid LanguageModelMessage")}Re.from=Se})(Xe||(e.LanguageModelMessage=Xe={}));var Ft;(function(Re){function Ue(Le){const Be={};for(const Ze of Object.keys(Le))Be[Ze]=Le[Ze].map(Re.to);return Be}Re.objectTo=Ue;function Se(Le){return{level:Bt.to(Le.level),kind:Le.kind,value:(0,_.isUriComponents)(Le.value)?_.URI.revive(Le.value):Le.value,description:Le.description}}Re.to=Se;function te(Le){return{level:Bt.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Re.from=te})(Ft||(e.ChatVariable=Ft={}));var Bt;(function(Re){function Ue(te){switch(te){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Re.to=Ue;function Se(te){switch(te){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Re.from=Se})(Bt||(e.ChatVariableLevel=Bt={}));var ni;(function(Re){function Ue(Se){switch(Se){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Ue})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var mt;(function(Re){function Ue(te){return{kind:"markdownContent",content:O.from(te.value)}}Re.to=Ue;function Se(te){return new s.ChatResponseMarkdownPart(O.to(te.content))}Re.from=Se})(mt||(e.ChatResponseMarkdownPart=mt={}));var Nt;(function(Re){function Ue(te){const{value:Le,baseUri:Be}=te;function Ze(Qe,at){return Qe.map(_t=>{const Vt=_.URI.joinPath(at,_t.name);return{label:_t.name,uri:Vt,children:_t.children&&Ze(_t.children,Vt)}})}return{kind:"treeData",treeData:{label:(0,v.basename)(Be),uri:Be,children:Ze(Le,Be)}}}Re.to=Ue;function Se(te){const Le=(0,C.revive)(te.treeData);function Be(at){return at.map(_t=>({name:_t.label,children:_t.children&&Be(_t.children)}))}const Ze=Le.uri,Qe=Le.children?Be(Le.children):[];return new s.ChatResponseFileTreePart(Qe,Ze)}Re.from=Se})(Nt||(e.ChatResponseFilesPart=Nt={}));var Tt;(function(Re){function Ue(te){return{kind:"inlineReference",name:te.title,inlineReference:_.URI.isUri(te.value)?te.value:m.from(te.value)}}Re.to=Ue;function Se(te){const Le=(0,C.revive)(te);return new s.ChatResponseAnchorPart(_.URI.isUri(Le.inlineReference)?Le.inlineReference:m.to(Le.inlineReference),te.name)}Re.from=Se})(Tt||(e.ChatResponseAnchorPart=Tt={}));var Wt;(function(Re){function Ue(te){return{kind:"progressMessage",content:O.from(te.value)}}Re.to=Ue;function Se(te){return new s.ChatResponseProgressPart(te.content.value)}Re.from=Se})(Wt||(e.ChatResponseProgressPart=Wt={}));var ri;(function(Re){function Ue(te,Le,Be){return{kind:"command",command:Le.toInternal(te.value,Be)??{command:te.value.command,title:te.value.title}}}Re.to=Ue;function Se(te,Le){return new s.ChatResponseCommandButtonPart(Le.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Re.from=Se})(ri||(e.ChatResponseCommandButtonPart=ri={}));var Ut;(function(Re){function Ue(te){return{kind:"reference",reference:_.URI.isUri(te.value)?te.value:m.from(te.value)}}Re.to=Ue;function Se(te){const Le=(0,C.revive)(te);return new s.ChatResponseReferencePart(_.URI.isUri(Le.reference)?Le.reference:m.to(Le.reference))}Re.from=Se})(Ut||(e.ChatResponseReferencePart=Ut={}));var Ht;(function(Re){function Ue(Le){return Le instanceof s.ChatResponseMarkdownPart?mt.to(Le):Le instanceof s.ChatResponseAnchorPart?Tt.to(Le):Le instanceof s.ChatResponseReferencePart?Ut.to(Le):Le instanceof s.ChatResponseProgressPart?Wt.to(Le):Le instanceof s.ChatResponseFileTreePart?Nt.to(Le):{kind:"content",content:""}}Re.to=Ue;function Se(Le,Be){switch(Le.kind){case"reference":return Ut.from(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Le,Be)}}Re.from=Se;function te(Le,Be){switch(Le.kind){case"markdownContent":return mt.from(Le);case"inlineReference":return Tt.from(Le);case"progressMessage":return;case"treeData":return Nt.from(Le);case"command":return ri.from(Le,Be)}}Re.fromContent=te})(Ht||(e.ChatResponsePart=Ht={}));var At;(function(Re){function Ue(Le,Be){return"markdownContent"in Be?((0,u.checkProposedApiEnabled)(Le,"chatParticipantAdditions"),{content:O.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,u.checkProposedApiEnabled)(Le,"chatParticipantAdditions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,u.checkProposedApiEnabled)(Le,"chatParticipantAdditions"),{content:O.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Qe=>d.from(Qe))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:d.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:d.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"participant"in Be?((0,u.checkProposedApiEnabled)(Le,"chatParticipantAdditions"),{agentName:Be.participant,command:Be.command,kind:"agentDetection"}):"message"in Be?{content:O.from(Be.message),kind:"progressMessage"}:void 0}Re.from=Ue;function Se(Le){switch(Le.kind){case"markdownContent":case"inlineReference":case"treeData":return Re.to(Le);case"content":return{content:Le.content};case"usedContext":return{documents:Le.documents.map(Be=>({uri:_.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>d.to(Ze))}))};case"reference":return{reference:(0,_.isUriComponents)(Le.reference)?_.URI.revive(Le.reference):m.to(Le.reference)};case"agentDetection":return;case"progressMessage":return{message:Le.content.value};case"vulnerability":return{content:Le.content,vulnerabilities:Le.vulnerabilities};default:return}}Re.to=Se;function te(Le,Be){switch(Le.kind){case"markdownContent":return{content:Le.content.value};case"inlineReference":return{inlineReference:(0,_.isUriComponents)(Le.inlineReference)?_.URI.revive(Le.inlineReference):m.to(Le.inlineReference),title:Le.name};case"command":return{command:Be.fromInternal(Le.command)??{command:Le.command.id,title:Le.command.title}};default:return}}Re.toProgressContent=te})(At||(e.ChatResponseProgress=At={}));var Dt;(function(Re){function Ue(Se){return{prompt:Se.message,command:Se.command,variables:Se.variables.variables.map(pt.to)}}Re.to=Ue})(Dt||(e.ChatAgentRequest=Dt={}));var pt;(function(Re){function Ue(Se){return{name:Se.name,range:[Se.range.start,Se.range.endExclusive],values:Se.values.map(Ft.to)}}Re.to=Ue})(pt||(e.ChatAgentResolvedVariable=pt={}));var It;(function(Re){function Ue(Se){return{label:Se.label,values:Se.values.map(Ft.from),insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation}}Re.from=Ue})(It||(e.ChatAgentCompletionItem=It={}));var St;(function(Re){function Ue(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}Re.to=Ue})(St||(e.ChatAgentResult=St={}));var ui;(function(Re){function Ue(Se,te,Le){if(te.action.kind==="vote")return;const Be=St.to(Se);return te.action.kind==="command"?{action:{kind:"command",commandButton:At.toProgressContent(te.action.commandButton,Le)},result:Be}:te.action.kind==="followUp"?{action:{kind:"followUp",followup:ti.to(te.action.followup)},result:Be}:{action:te.action,result:Be}}Re.to=Ue})(ui||(e.ChatAgentUserActionEvent=ui={}));var Kt;(function(Re){function Ue(Se,te,Le){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:te.toInternal(Se,Le)}Re.from=Ue})(Kt||(e.TerminalQuickFix=Kt={}));var pi;(function(Re){function Ue(Se,te){return{id:te,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||0,contextValue:Se.contextValue}}Re.from=Ue})(pi||(e.DebugTreeItem=pi={}))}),define(Ce[320],De([1,0,6,20,15]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(w,E){this._proxy=w.getProxy(P.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:C=>E.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,E,C){const L=p.WorkspaceEdit.from(w,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,C?.isRefactoring??!1)}};e.ExtHostBulkEdits=R,e.ExtHostBulkEdits=R=Ge([He(0,F.IExtHostRpcService)],R)}),define(Ce[321],De([1,0,19,8,40,4,48,3,38,18,2,211,25,6,15,7,281,26]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class i{constructor(t,h,u,s,c,d){this._extension=t,this._request=h,this._proxy=u,this._logService=s,this._commandsConverter=c,this._sessionDisposables=d,this._stopWatch=E.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let h=function(s){if(t._isClosed){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,s),c}};const t=this;this._stopWatch.reset();const u=s=>{typeof this._firstProgress>"u"&&"content"in s&&(this._firstProgress=this._stopWatch.elapsed()),this._proxy.$handleProgressChunk(this._request.requestId,s)};this._apiObject={markdown(s){h(this.markdown);const c=new l.ChatResponseMarkdownPart(s),d=_.ChatResponseMarkdownPart.to(c);return u(d),this},filetree(s,c){h(this.filetree);const d=new l.ChatResponseFileTreePart(s,c),m=_.ChatResponseFilesPart.to(d);return u(m),this},anchor(s,c){h(this.anchor);const d=new l.ChatResponseAnchorPart(s,c),m=_.ChatResponseAnchorPart.to(d);return u(m),this},button(s){h(this.anchor);const c=new l.ChatResponseCommandButtonPart(s),d=_.ChatResponseCommandButtonPart.to(c,t._commandsConverter,t._sessionDisposables);return u(d),this},progress(s){h(this.progress);const c=new l.ChatResponseProgressPart(s),d=_.ChatResponseProgressPart.to(c);return u(d),this},reference(s){h(this.reference);const c=new l.ChatResponseReferencePart(s),d=_.ChatResponseReferencePart.to(c);return u(d),this},push(s){h(this.push);const c=_.ChatResponsePart.to(s);return u(c),this},report(s){if(h(this.report),"placeholder"in s&&"resolvedContent"in s)return;const c=_.ChatResponseProgress.from(t._extension,s);if(!c){t._logService.error("Unknown progress type: "+JSON.stringify(s));return}return u(c),this}}}return this._apiObject}}class n{static{this._idPool=0}constructor(t,h,u){this._logService=h,this.commands=u,this._agents=new Map,this._sessionDisposables=new w.DisposableMap,this._proxy=t.getProxy(y.MainContext.MainThreadChatAgents2)}createChatAgent(t,h,u){const s=n._idPool++,c=new r(t,h,this._proxy,s,u);return this._agents.set(s,c),this._proxy.$registerAgent(s,t.identifier,h,{}),c.apiAgent}async $invokeAgent(t,h,u,s){const c=this._agents.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let d=this._sessionDisposables.get(h.sessionId);d||(d=new w.DisposableStore,this._sessionDisposables.set(h.sessionId,d));const m=new i(c.extension,h,this._proxy,this._logService,this.commands.converter,d);try{const D=await this.prepareHistoryTurns(h.agentId,u),g=c.invoke(_.ChatAgentRequest.to(h),{history:D},m.apiObject,s);return await(0,F.raceCancellation)(Promise.resolve(g).then(f=>{if(f?.metadata)try{JSON.stringify(f.metadata)}catch(S){const T=`result.metadata MUST be JSON.stringify-able. Got error: ${S.message}`;return this._logService.error(`[${c.extension.identifier.value}] [@${c.id}] ${T}`,c.extension),{errorDetails:{message:T},timings:m.timings}}return{errorDetails:f?.errorDetails,timings:m.timings,metadata:f?.metadata}}),s)}catch(D){return this._logService.error(D,c.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,p.toErrorMessage)(D)),responseIsIncomplete:!0}}}finally{m.close()}}async prepareHistoryTurns(t,h){const u=[];for(const s of h.history){const c=_.ChatAgentResult.to(s.result),d=t===s.request.agentId?c:{...c,metadata:void 0};u.push(new l.ChatRequestTurn(s.request.message,s.request.command,s.request.variables.variables.map(_.ChatAgentResolvedVariable.to),{extensionId:"",name:s.request.agentId}));const m=(0,P.coalesce)(s.response.map(D=>_.ChatResponsePart.fromContent(D,this.commands.converter)));u.push(new l.ChatResponseTurn(m,d,{extensionId:"",name:s.request.agentId},s.request.command))}return u}$releaseSession(t){this._sessionDisposables.deleteAndDispose(t)}async $provideSlashCommands(t,h,u){const s=this._agents.get(t);if(!s)return[];const c=await this.prepareHistoryTurns(s.id,h);try{return await s.provideSlashCommands({history:c},u)}catch(d){const m=(0,p.toErrorMessage)(d);return this._logService.error(`[${s.extension.identifier.value}] [@${s.id}] Error while providing slash commands: ${m}`),[]}}async $provideFollowups(t,h,u,s){const c=this._agents.get(h);if(!c)return Promise.resolve([]);const d=_.ChatAgentResult.to(u);return(await c.provideFollowups(d,s)).filter(m=>{const D=!m.participant||A.Iterable.some(this._agents.values(),g=>g.id===m.participant&&v.ExtensionIdentifier.equals(g.extension.identifier,c.extension.identifier));return D||this._logService.warn(`[@${c.id}] ChatFollowup refers to an invalid participant: ${m.participant}`),D}).map(m=>_.ChatFollowup.from(m,t))}$acceptFeedback(t,h,u,s){const c=this._agents.get(t);if(!c)return;const d=_.ChatAgentResult.to(h);let m;switch(u){case b.InteractiveSessionVoteDirection.Down:m=l.ChatResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:m=l.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(s?{result:d,kind:m,reportIssue:s}:{result:d,kind:m}))}$acceptAction(t,h,u){const s=this._agents.get(t);if(!s||u.action.kind==="vote")return;const c=_.ChatAgentUserActionEvent.to(h,u,this.commands.converter);c&&s.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,h,u){const s=this._agents.get(t);return s?(await s.invokeCompletionProvider(h,u)).map(_.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,h){const u=this._agents.get(t);if(u)return await u.provideWelcomeMessage(h)}async $provideSampleQuestions(t,h){const u=this._agents.get(t);if(u)return(await u.provideSampleQuestions(h)).map(s=>_.ChatFollowup.from(s,void 0))}}e.ExtHostChatAgents2=n;class r{constructor(t,h,u,s,c){this.extension=t,this.id=h,this._proxy=u,this._handle=s,this._requestHandler=c,this._onDidReceiveFeedback=new R.Emitter,this._onDidPerformAction=new R.Emitter}acceptFeedback(t){this._onDidReceiveFeedback.fire(t)}acceptAction(t){this._onDidPerformAction.fire(t)}async invokeCompletionProvider(t,h){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(t,h)??[]:[]}async provideSlashCommands(t,h){if(!this._commandProvider)return[];const u=await this._commandProvider.provideCommands(t,h);return u?u.map(s=>("isSticky2"in s&&(0,o.checkProposedApiEnabled)(this.extension,"chatParticipantAdditions"),{name:s.name,description:s.description??"",followupPlaceholder:s.isSticky2?.placeholder,isSticky:s.isSticky2?.isSticky??s.isSticky,sampleRequest:s.sampleRequest})):[]}async provideFollowups(t,h){if(!this._followupProvider)return[];const u=await this._followupProvider.provideFollowups(t,h);return u?u.filter(s=>!(s&&"commandId"in s)).filter(s=>!(s&&"message"in s)):[]}async provideWelcomeMessage(t){if(!this._welcomeMessageProvider)return[];const h=await this._welcomeMessageProvider.provideWelcomeMessage(t);return h?h.map(u=>typeof u=="string"?u:_.MarkdownString.from(u)):[]}async provideSampleQuestions(t){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const h=await this._welcomeMessageProvider.provideSampleQuestions(t);return h||[]}get apiAgent(){let t=!1,h=!1;const u=()=>{t||h||(h=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof L.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof l.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._commandProvider!==void 0,hasFollowups:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:_.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:_.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:_.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting,isSticky:this._isSticky}),h=!1}))},s=this;return{get name(){return s.id},get description(){return s._description??""},set description(c){s._description=c,u()},get fullName(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._fullName??s.extension.displayName??s.extension.name},set fullName(c){(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._fullName=c,u()},get iconPath(){return s._iconPath},set iconPath(c){s._iconPath=c,u()},get requestHandler(){return s._requestHandler},set requestHandler(c){(0,C.assertType)(typeof c=="function","Invalid request handler"),s._requestHandler=c},get commandProvider(){return s._commandProvider},set commandProvider(c){s._commandProvider=c,u()},get followupProvider(){return s._followupProvider},set followupProvider(c){s._followupProvider=c,u()},get isDefault(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._isDefault},set isDefault(c){(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._isDefault=c,u()},get helpTextPrefix(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._helpTextPrefix},set helpTextPrefix(c){if((0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),!s._isDefault)throw new Error("helpTextPrefix is only available on the default chat agent");s._helpTextPrefix=c,u()},get helpTextVariablesPrefix(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._helpTextVariablesPrefix},set helpTextVariablesPrefix(c){if((0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),!s._isDefault)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");s._helpTextVariablesPrefix=c,u()},get helpTextPostfix(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._helpTextPostfix},set helpTextPostfix(c){if((0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),!s._isDefault)throw new Error("helpTextPostfix is only available on the default chat agent");s._helpTextPostfix=c,u()},get isSecondary(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._isSecondary},set isSecondary(c){(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._isSecondary=c,u()},get sampleRequest(){return s._sampleRequest},set sampleRequest(c){s._sampleRequest=c,u()},get supportIssueReporting(){return(0,o.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions"),s._supportIssueReporting},set supportIssueReporting(c){(0,o.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions"),s._supportIssueReporting=c,u()},get onDidReceiveFeedback(){return s._onDidReceiveFeedback.event},set participantVariableProvider(c){if((0,o.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions"),s._agentVariableProvider=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");s._proxy.$registerAgentCompletionsProvider(s._handle,c.triggerCharacters)}else s._proxy.$unregisterAgentCompletionsProvider(s._handle)},get participantVariableProvider(){return(0,o.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions"),s._agentVariableProvider},set welcomeMessageProvider(c){(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._welcomeMessageProvider=c,u()},get welcomeMessageProvider(){return(0,o.checkProposedApiEnabled)(s.extension,"defaultChatParticipant"),s._welcomeMessageProvider},onDidPerformAction:(0,o.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,get isSticky(){return s._isSticky},set isSticky(c){s._isSticky=c,u()},dispose(){t=!0,s._commandProvider=void 0,s._followupProvider=void 0,s._onDidReceiveFeedback.dispose(),s._proxy.$unregisterAgent(s._handle)}}}invoke(t,h,u,s){return this._requestHandler(t,h,u,s)}}}),define(Ce[322],De([1,0,22,3,6,15,107,25,8,4,212,142,40]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class y{constructor(o,i){this.option=o,this.stream=new E.AsyncIterableSource,this.stream=i??new E.AsyncIterableSource}}class _{constructor(o,i){this.cts=i,this._responseStreams=new Map,this._defaultStream=new E.AsyncIterableSource,this._isDone=!1;const n=this;this.apiObject={result:o,stream:n._defaultStream.asyncIterable},o.then(()=>{for(const r of this._streams())r.resolve()}).catch(r=>{r instanceof Error||(r=new Error((0,v.toErrorMessage)(r),{cause:r}));for(const a of this._streams())a.reject(r)}).finally(()=>{this._isDone=!0})}*_streams(){if(this._responseStreams.size>0)for(const[,o]of this._responseStreams)yield o.stream;else yield this._defaultStream}handleFragment(o){if(this._isDone)return;let i=this._responseStreams.get(o.index);i||(this._responseStreams.size===0?i=new y(o.index,this._defaultStream):i=new y(o.index),this._responseStreams.set(o.index,i)),i.stream.emitOne(o.part)}}class l{static{this._idPool=1}constructor(o,i,n){this._logService=i,this._extHostAuthentication=n,this._onDidChangeModelAccess=new C.Emitter,this._onDidChangeProviders=new C.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._languageModelIds=new Set,this._modelAccessList=new w.ExtensionIdentifierMap,this._pendingRequest=new Map,this._proxy=o.getProxy(p.MainContext.MainThreadChatProvider)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(o,i,n,r){const a=l._idPool++;this._languageModels.set(a,{extension:o.identifier,provider:n});let t;return r.auth&&(t={providerLabel:o.displayName||o.name,accountLabel:typeof r.auth=="object"?r.auth.label:void 0}),this._proxy.$registerProvider(a,i,{extension:o.identifier,model:r.name??"",auth:t}),(0,F.toDisposable)(()=>{this._languageModels.delete(a),this._proxy.$unregisterProvider(a)})}async $provideLanguageModelResponse(o,i,n,r,a,t){const h=this._languageModels.get(o);if(!h)return;const u=new A.Progress(async s=>{if(t.isCancellationRequested){this._logService.warn(`[CHAT](${h.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(i,{index:s.index,part:s.part})});return h.provider.provideLanguageModelResponse2(r.map(R.LanguageModelMessage.to),a,w.ExtensionIdentifier.toKey(n),u,t)}$updateLanguageModels(o){const i=[],n=[];if(o.added)for(const r of o.added)this._languageModelIds.add(r),i.push(r);if(o.removed)for(const r of o.removed){this._languageModelIds.delete(r),n.push(r);for(const[a,t]of this._pendingRequest)t.languageModelId===r&&(t.res.cts.cancel(),this._pendingRequest.delete(a))}this._onDidChangeProviders.fire(Object.freeze({added:Object.freeze(i),removed:Object.freeze(n)}))}getLanguageModelIds(){return Array.from(this._languageModelIds)}$updateModelAccesslist(o){const i=new Array;for(const{from:n,to:r,enabled:a}of o){const t=this._modelAccessList.get(n)??new w.ExtensionIdentifierSet;if(t.has(r)!==a){a?t.add(r):t.delete(r),this._modelAccessList.set(n,t);const u={from:n,to:r};i.push(u),this._onDidChangeModelAccess.fire(u)}}}async requestLanguageModelAccess(o,i,n){const r=o.identifier,a=n?.justification,t=await this._proxy.$prepareChatAccess(r,i,a);if(!t)throw new Error(`Language model '${i}' NOT found`);this._isUsingAuth(r,t)&&await this._getAuthAccess(o,{identifier:t.extension,displayName:t.auth.providerLabel},a);const h=this;return{get model(){return t.model},get isRevoked(){return h._isUsingAuth(r,t)&&!h._modelAccessList.get(r)?.has(t.extension)||!h._languageModelIds.has(i)},get onDidChangeAccess(){const u=C.Event.filter(h._onDidChangeProviders.event,c=>c.removed.includes(i)),s=C.Event.filter(h._onDidChangeModelAccess.event,c=>w.ExtensionIdentifier.equals(c.from,r)&&w.ExtensionIdentifier.equals(c.to,t.extension));return C.Event.signal(C.Event.any(u,s))},makeChatRequest(u,s,c){if(h._isUsingAuth(r,t)&&!h._modelAccessList.get(r)?.has(t.extension))throw new Error("Access to chat has been revoked");if(!h._languageModelIds.has(i))throw new Error("Language Model has been removed");const d=new P.CancellationTokenSource(c),m=Math.random()*1e6|0,D=h._proxy.$fetchResponse(r,i,m,u.map(R.LanguageModelMessage.from),s??{},d.token),g=new _(D,d);return h._pendingRequest.set(m,{languageModelId:i,res:g}),D.finally(()=>{h._pendingRequest.delete(m),d.dispose()}),g.apiObject}}}async $handleResponseFragment(o,i){const n=this._pendingRequest.get(o);n&&n.res.handleFragment(i)}async _getAuthAccess(o,i,n){const r=I.INTERNAL_AUTH_PROVIDER_PREFIX+i.identifier.value;if(!await this._extHostAuthentication.getSession(o,r,[],{silent:!0}))try{const t=n?(0,L.localize)(0,null,i.displayName,n):(0,L.localize)(1,null,i.displayName);await this._extHostAuthentication.getSession(o,r,[],{forceNewSession:{detail:t}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:o.identifier,to:i.identifier,enabled:!0}])}_isUsingAuth(o,i){return!!i.auth&&!w.ExtensionIdentifier.equals(i.extension,o)}}e.ExtHostChatProvider=l}),define(Ce[323],De([1,0,14,3,6,15,7,26]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class E{static{this._idPool=0}constructor(I){this._resolver=new Map,this._proxy=I.getProxy(p.MainContext.MainThreadChatVariables)}async $resolveVariable(I,v,y,_){const l=this._resolver.get(I);if(l)try{if(l.resolver.resolve2){(0,w.checkProposedApiEnabled)(l.extension,"chatParticipantAdditions");const b=new C(v,this._proxy),o=await l.resolver.resolve2(l.data.name,{prompt:y},b.apiObject,_);if(o)return o.map(R.ChatVariable.from)}else{const b=await l.resolver.resolve(l.data.name,{prompt:y},_);if(b)return b.map(R.ChatVariable.from)}}catch(b){(0,P.onUnexpectedExternalError)(b)}}registerVariableResolver(I,v,y,_){const l=E._idPool++;return this._resolver.set(l,{extension:I,data:{name:v,description:y},resolver:_}),this._proxy.$registerVariable(l,{name:v,description:y}),(0,F.toDisposable)(()=>{this._resolver.delete(l),this._proxy.$unregisterVariable(l)})}}e.ExtHostChatVariables=E;class C{constructor(I,v){this._requestId=I,this._proxy=v,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let v=function(_){if(I._isClosed){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,_),l}};const I=this,y=_=>{this._proxy.$handleProgressChunk(this._requestId,_)};this._apiObject={progress(_){v(this.progress);const l=new A.ChatResponseProgressPart(_),b=R.ChatResponseProgressPart.to(l);return y(b),this},reference(_){v(this.reference);const l=new A.ChatResponseReferencePart(_),b=R.ChatResponseReferencePart.to(l);return y(b),this},push(_){v(this.push);const l=R.ChatResponsePart.to(_);return y(l),this}}}return this._apiObject}}}),define(Ce[324],De([1,0,8,53,4,3,2,83,25,15,7,6,26]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(_,l,b){const o=_.getProxy(I.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new E.ExtensionIdentifierMap,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const m=this._commentControllers.get(d.handle);return m?m.value:d}else if(d&&d.$mid===7){const m=this._commentControllers.get(d.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.commentThreadHandle);return D?D.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const m=this._commentControllers.get(d.thread.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.thread.commentThreadHandle);return D?d.$mid===8?D.value:{thread:D.value,text:d.text}:d}else if(d&&d.$mid===10){const m=this._commentControllers.get(d.thread.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const g=d.commentUniqueId,f=D.getCommentByUniqueId(g);return f||d}else if(d&&d.$mid===11){const m=this._commentControllers.get(d.thread.commentControlHandle);if(!m)return d;const D=m.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const g=d.text,f=d.commentUniqueId,S=D.getCommentByUniqueId(f);return S?(typeof S.body=="string"?S.body=g:S.body=new L.MarkdownString(g),S):d}return d}})}createCommentController(d,m,D){const g=i.handlePool++,f=new r(d,g,m,D);this._commentControllers.set(f.handle,f);const S=this._commentControllersByExtension.get(d.identifier)||[];return S.push(f),this._commentControllersByExtension.set(d.identifier,S),f.value}async $createCommentThreadTemplate(d,m,D){const g=this._commentControllers.get(d);g&&g.$createCommentThreadTemplate(m,D)}async $setActiveComment(d,m){const D=this._commentControllers.get(d);D&&D.$setActiveComment(m??void 0)}async $updateCommentThreadTemplate(d,m,D){const g=this._commentControllers.get(d);g&&g.$updateCommentThreadTemplate(m,D)}$deleteCommentThread(d,m){this._commentControllers.get(d)?.$deleteCommentThread(m)}$provideCommentingRanges(d,m,D){const g=this._commentControllers.get(d);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const f=b.getDocument(A.URI.revive(m));return(0,P.asPromise)(async()=>{const S=await g.commentingRangeProvider.provideCommentingRanges(f,D);let T;return Array.isArray(S)?T={ranges:S,fileComments:!1}:S?T={ranges:S.ranges||[],fileComments:S.fileComments||!1}:T=S??void 0,T}).then(S=>{let T;return S&&(T={ranges:S.ranges.map(N=>C.Range.from(N)),fileComments:S.fileComments}),T})}$toggleReaction(d,m,D,g,f){const S=this._commentControllers.get(d);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,P.asPromise)(()=>{const T=S.getCommentThread(m);if(T){const N=T.getCommentByUniqueId(g.uniqueIdInThread);if(S!==void 0&&N&&S.reactionHandler)return S.reactionHandler(N,h(f))}return Promise.resolve(void 0)})}}class n{static{this._handlePool=0}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){(d===void 0!=(this._range===void 0)||!d||!this._range||!d.isEqual(this._range))&&(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(d){this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,m,D,g,f,S,T,N){this._commentControllerHandle=m,this._id=D,this._uri=g,this._range=f,this._comments=S,this.extensionDescription=T,this._isTemplate=N,this.handle=n._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new p.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),o.$createCommentThread(m,this.handle,this._id,this._uri,C.Range.from(this._range),T.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(m,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(x){z.range=x},get comments(){return z.comments},set comments(x){z.comments=x},get collapsibleState(){return z.collapsibleState},set collapsibleState(x){z.collapsibleState=x},get canReply(){return z.canReply},set canReply(x){z.canReply=x},get contextValue(){return z.contextValue},set contextValue(x){z.contextValue=x},get label(){return z.label},set label(x){z.label=x},get state(){return z.state},set state(x){z.state=x},dispose:()=>{z.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const d=D=>Object.prototype.hasOwnProperty.call(this.modifications,D),m={};d("range")&&(m.range=C.Range.from(this._range)),d("label")&&(m.label=this.label),d("contextValue")&&(m.contextValue=this.contextValue??null),d("comments")&&(m.comments=this._comments.map(D=>a(this,D,this._commentsMap,this.extensionDescription))),d("collapsibleState")&&(m.collapseState=u(this._collapseState)),d("canReply")&&(m.canReply=this.canReply),d("state")&&(m.state=s(this._state)),d("isTemplate")&&(m.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(d){for(const m of this._commentsMap){const D=m[0],g=m[1];if(d===g)return D}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}Ge([(0,F.debounce)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,v.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,v.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(d,m,D,g){this._extension=d,this._handle=m,this._id=D,this._label=g,this._threads=new Map,o.$registerCommentController(this.handle,D,g,this._extension.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(S){f.options=S},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(S){f.commentingRangeProvider=S},get reactionHandler(){return f.reactionHandler},set reactionHandler(S){f.reactionHandler=S},get activeCommentThread(){return f.activeCommentThread},createCommentThread(S,T,N){return f.createCommentThread(S,T,N).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,m,D){m===void 0&&(0,v.checkProposedApiEnabled)(this._extension,"fileComments");const g=new n(this.id,this.handle,void 0,d,m,D,this._extension,!1);return this._threads.set(g.handle,g),g}$setActiveComment(d){if(!d){this._activeComment=void 0,this._activeThread=void 0;return}const m=this._threads.get(d.commentThreadHandle);m&&(this._activeComment=d.uniqueIdInThread?m.getCommentByUniqueId(d.uniqueIdInThread):void 0,this._activeThread=m)}$createCommentThreadTemplate(d,m){const D=new n(this.id,this.handle,void 0,A.URI.revive(d),C.Range.to(m),[],this._extension,!0);return D.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this._threads.set(D.handle,D),D}$updateCommentThreadTemplate(d,m){const D=this._threads.get(d);D&&(D.range=C.Range.to(m))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function a(c,d,m,D){let g=m.get(d);return g||(g=++c.commentHandle,m.set(d,g)),d.state!==void 0&&(0,v.checkProposedApiEnabled)(D,"commentsDraftState"),d.reactions?.some(f=>f.reactors!==void 0)&&(0,v.checkProposedApiEnabled)(D,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:g,body:typeof d.body=="string"?d.body:C.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(f=>t(f)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?C.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted,reactors:c.reactors&&c.reactors.length>0&&typeof c.reactors[0]!="string"?c.reactors.map(d=>d.name):c.reactors}}function h(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?A.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1,reactors:c.reactors?.map(d=>({name:d}))}}function u(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function s(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.createExtHostComments=y}),define(Ce[325],De([1,0,22,54,3,16,23,2,15,92,110,6,7]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(h,u){this.document=h,this._storagePath=u,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(h){return this._edits.add([h])}async undo(h,u){await this.getEdit(h).undo(),u||this.disposeBackup()}async redo(h,u){await this.getEdit(h).redo(),u||this.disposeBackup()}disposeEdits(h){for(const u of h)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const h=a(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,h)}updateBackup(h){this._backup?.delete(),this._backup=h}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(h){const u=this._edits.get(h,0);if(!u)throw new Error("No edit found");return u}}class _{constructor(){this._documents=new Map}get(h,u){return this._documents.get(this.key(h,u))}add(h,u,s){const c=this.key(h,u.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${h} resource:${u.uri}`);const d=new y(u,s);return this._documents.set(c,d),d}delete(h,u){const s=this.key(h,u.uri);this._documents.delete(s)}key(h,u){return`${h}@@@${u}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class b{constructor(){this._providers=new Map}addTextProvider(h,u,s){return this.add(0,h,u,s)}addCustomProvider(h,u,s){return this.add(1,h,u,s)}get(h){return this._providers.get(h)}add(h,u,s,c){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:h,extension:s,provider:c}),new v.Disposable(()=>this._providers.delete(u))}}class o{constructor(h,u,s,c,d){this._extHostDocuments=u,this._extensionStoragePaths=s,this._extHostWebview=c,this._extHostWebviewPanels=d,this._editorProviders=new b,this._documents=new _,this._proxy=h.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(h,u,s,c){const d=new p.DisposableStore;return n(s)?(d.add(this._editorProviders.addTextProvider(u,h,s)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(h),u,c.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(h))):(d.add(this._editorProviders.addCustomProvider(u,h,s)),i(s)&&d.add(s.onDidChangeCustomDocument(m=>{const D=this.getCustomDocumentEntry(u,m.document.uri);if(r(m)){const g=D.addEdit(m);this._proxy.$onDidEdit(m.document.uri,u,g,m.label)}else this._proxy.$onContentChange(m.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(h),u,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(h))),v.Disposable.from(d,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(h,u,s,c,d){const m=this._editorProviders.get(u);if(!m)throw new Error(`No provider found for '${u}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${u}'`);const D=w.URI.revive(h),g=await m.provider.openCustomDocument(D,{backupId:s,untitledDocumentData:c?.buffer},d);let f;return i(m.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(u,g,f),{editable:i(m.provider)}}async $disposeCustomDocument(h,u){const s=this._editorProviders.get(u);if(!s)throw new Error(`No provider found for '${u}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${u}'`);const c=w.URI.revive(h),{document:d}=this.getCustomDocumentEntry(u,c);this._documents.delete(u,d),d.dispose()}async $resolveCustomEditor(h,u,s,c,d,m){const D=this._editorProviders.get(s);if(!D)throw new Error(`No provider found for '${s}'`);const g=E.ViewColumn.to(d),f=this._extHostWebview.createNewWebview(u,c.contentOptions,D.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(u,s,c.title,g,c.options,f,c.active),T=w.URI.revive(h);switch(D.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,T);return D.provider.resolveCustomEditor(N,S,m)}case 0:{const N=this._extHostDocuments.getDocument(T);return D.provider.resolveCustomTextEditor(N,S,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,u,s){this.getCustomDocumentEntry(u,h).disposeEdits(s)}async $onMoveCustomEditor(h,u,s){const c=this._editorProviders.get(s);if(!c)throw new Error(`No provider found for '${s}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const d=this._extHostWebviewPanels.getWebviewPanel(h);if(!d)throw new Error("No webview found");const m=w.URI.revive(u),D=this._extHostDocuments.getDocument(m);await c.provider.moveCustomTextEditor(D,d,P.CancellationToken.None)}async $undo(h,u,s,c){return this.getCustomDocumentEntry(u,h).undo(s,c)}async $redo(h,u,s,c){return this.getCustomDocumentEntry(u,h).redo(s,c)}async $revert(h,u,s){const c=this.getCustomDocumentEntry(u,h);await this.getCustomEditorProvider(u).revertCustomDocument(c.document,s),c.disposeBackup()}async $onSave(h,u,s){const c=this.getCustomDocumentEntry(u,h);await this.getCustomEditorProvider(u).saveCustomDocument(c.document,s),c.disposeBackup()}async $onSaveAs(h,u,s,c){const d=this.getCustomDocumentEntry(u,h);return this.getCustomEditorProvider(u).saveCustomDocumentAs(d.document,w.URI.revive(s),c)}async $backup(h,u,s){const c=this.getCustomDocumentEntry(u,h),m=await this.getCustomEditorProvider(u).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},s);return c.updateBackup(m),m.id}getCustomDocumentEntry(h,u){const s=this._documents.get(h,w.URI.revive(u));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(h){const s=this._editorProviders.get(h)?.provider;if(!s||!i(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const h=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,F.hash)(h)+""}}),define(Ce[326],De([1,0,213,135,2,6,7,15,4,13,28,59]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class y{#e;#t;#i;constructor(b,o,i,n,r,a,t,h){this._name=b,this._owner=o,this._maxDiagnosticsTotal=i,this._maxDiagnosticsPerFile=n,this._modelVersionIdProvider=r,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(n,i),this.#i=new L.ResourceMap(u=>a.getComparisonKey(u)),this.#e=t,this.#t=h}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,o){if(!b){this.clear();return}this._checkDisposed();let i=[];if(p.URI.isUri(b)){if(!o){this.delete(b);return}this.#i.set(b,o.slice()),i=[b]}else if(Array.isArray(b)){i=[];let a;b=[...b].sort(y._compareIndexedTuplesByUri);for(const t of b){const[h,u]=t;if((!a||h.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=h,i.push(h),this.#i.set(h,[])),u)this.#i.get(h)?.push(...u);else{const s=this.#i.get(h);s&&(s.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const h=this.#i.get(a);if(h)if(h.length>this._maxDiagnosticsPerFile){t=[];const u=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const c of h)if(c.severity===u[s]&&t.push({...w.Diagnostic.from(c),modelVersionId:this._modelVersionIdProvider(a)})===this._maxDiagnosticsPerFile)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,P.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(u=>({...w.Diagnostic.from(u),modelVersionId:this._modelVersionIdProvider(a)}));if(n.push([a,t]),r+=t.length,r>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,n)}delete(b){this._checkDisposed(),this.#t.fire([b]),this.#i.delete(b),this.#e?.$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(b,o){this._checkDisposed();for(const[i,n]of this)b.call(o,i,n,this)}*[Symbol.iterator](){this._checkDisposed();for(const b of this.#i.keys())yield[b,this.get(b)]}get(b){this._checkDisposed();const o=this.#i.get(b);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(this.#i.get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,o){return b[0].toString()<o[0].toString()?-1:b[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=y;let _=class{static{v=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*v._maxDiagnosticsPerFile}static _mapper(b){const o=new L.ResourceMap;for(const i of b)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(b,o,i,n){this._logService=o,this._fileSystemInfoService=i,this._extHostDocumentsAndEditors=n,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,v._mapper),this._proxy=b.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,o){const{_collections:i,_proxy:n,_onDidChangeDiagnostics:r,_logService:a,_fileSystemInfoService:t,_extHostDocumentsAndEditors:h}=this,u=new class{$changeMany(d,m){n.$changeMany(d,m),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,d,m.length===0?"CLEARING":m)}$clear(d){n.$clear(d),a.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,d)}dispose(){n.dispose()}};let s;if(!o)o="_generated_diagnostic_collection_name_#"+v._idPool++,s=o;else if(!i.has(o))s=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do s=o+v._idPool++;while(i.has(s))}return new class extends y{constructor(){super(o,s,v._maxDiagnosticsTotal,v._maxDiagnosticsPerFile,d=>h.getDocument(d)?.version,t.extUri,u,r),i.set(s,this)}dispose(){super.dispose(),i.delete(s)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const o=new Map,i=[];for(const n of this._collections.values())n.forEach((r,a)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}_getDiagnostics(b){let o=[];for(const i of this._collections.values())i.has(b)&&(o=o.concat(i.get(b)));return o}$acceptMarkersChange(b){if(!this._mirrorCollection){const o="_generated_mirror",i=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,i),this._mirrorCollection=i}for(const[o,i]of b)this._mirrorCollection.set(p.URI.revive(o),i.map(w.Diagnostic.to))}};e.ExtHostDiagnostics=_,e.ExtHostDiagnostics=_=v=Ge([He(1,C.ILogService),He(2,I.IExtHostFileSystemInfo)],_)}),define(Ce[327],De([1,0,2,14,7,15,75]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class w{constructor(C,L,I,v={timeout:1500,errors:3}){this._logService=C,this._documents=L,this._mainThreadBulkEdits=I,this._thresholds=v,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(L,I,v)=>{const _={dispose:this._callbacks.push([L,I,C])};return Array.isArray(v)&&v.push(_),_}}async $participateInSave(C,L){const I=P.URI.revive(C);let v=!1;const y=setTimeout(()=>v=!0,this._thresholds.timeout),_=[];try{for(const l of[...this._callbacks]){if(v)break;const b=this._documents.getDocument(I),o=await this._deliverEventAsyncAndBlameBadListeners(l,{document:b,reason:R.TextDocumentSaveReason.to(L)});_.push(o)}}finally{clearTimeout(y)}return _}_deliverEventAsyncAndBlameBadListeners([C,L,I],v){const y=this._badListeners.get(C);return typeof y=="number"&&y>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,L,v).then(()=>!0,_=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(_),!(_ instanceof Error)||_.message!=="concurrent_edits"){const l=this._badListeners.get(C);this._badListeners.set(C,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,L,I,v){const y=[],_=Date.now(),{document:l,reason:b}=v,{version:o}=l,i=Object.freeze({document:l,reason:b,waitUntil(n){if(Object.isFrozen(y))throw(0,F.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(n))}});try{L.apply(I,[i])}catch(n){return Promise.reject(n)}return Object.freeze(y),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(y).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-_}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof p.TextEdit))for(const{newText:t,newEol:h,range:u}of a)r.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:u&&R.Range.from(u),text:t,eol:h&&R.EndOfLine.from(h)}});if(r.edits.length!==0)return o===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=w}),define(Ce[328],De([1,0,4,3,2,6,149,15,18,24,7]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(y,_){this._onDidAddDocument=new P.Emitter,this._onDidRemoveDocument=new P.Emitter,this._onDidChangeDocument=new P.Emitter,this._onDidSaveDocument=new P.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=_,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const b of l)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const b of l)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(y){if(!y)return;const _=this._documentsAndEditors.getDocument(y);if(_)return _}getDocument(y){const _=this.getDocumentData(y);if(!_?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return _.document}ensureDocumentData(y){const _=this._documentsAndEditors.getDocument(y);if(_)return Promise.resolve(_);let l=this._documentLoader.get(y.toString());return l||(l=this._proxy.$tryOpenDocument(y).then(b=>{this._documentLoader.delete(y.toString());const o=p.URI.revive(b);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(o))},b=>(this._documentLoader.delete(y.toString()),Promise.reject(b))),this._documentLoader.set(y.toString(),l)),l}createDocumentData(y){return this._proxy.$tryCreateDocument(y).then(_=>p.URI.revive(_))}$acceptModelLanguageChanged(y,_){const l=p.URI.revive(y),b=this._documentsAndEditors.getDocument(l);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(_),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(y){const _=p.URI.revive(y),l=this._documentsAndEditors.getDocument(_);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(y,_){const l=p.URI.revive(y),b=this._documentsAndEditors.getDocument(l);if(!b)throw new Error("unknown document");b._acceptIsDirty(_),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,_,l){const b=p.URI.revive(y),o=this._documentsAndEditors.getDocument(b);if(!o)throw new Error("unknown document");o._acceptIsDirty(l),o.onEvents(_);let i;_.isUndoing?i=L.TextDocumentChangeReason.Undo:_.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:o.document,contentChanges:_.changes.map(n=>({range:w.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(y,_){(0,A.setWordDefinitionFor)(y,_)}}e.ExtHostDocuments=I}),define(Ce[71],De([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class I{constructor(b,o,i){this._activeTabIdGetter=i,this._parentGroup=o,this.acceptDtoUpdate(b)}get apiObject(){if(!this._apiObject){const b=this,o={get isActive(){return b._dto.id===b._activeTabIdGetter()},get label(){return b._dto.label},get input(){return b._input},get isDirty(){return b._dto.isDirty},get isPinned(){return b._dto.isPinned},get isPreview(){return b._dto.isPreview},get group(){return b._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(b){this._dto=b,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new L.TextTabInput(R.URI.revive(this._dto.input.uri));case 2:return new L.TextDiffTabInput(R.URI.revive(this._dto.input.original),R.URI.revive(this._dto.input.modified));case 3:return new L.TextMergeTabInput(R.URI.revive(this._dto.input.base),R.URI.revive(this._dto.input.input1),R.URI.revive(this._dto.input.input2),R.URI.revive(this._dto.input.result));case 6:return new L.CustomEditorTabInput(R.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new L.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new L.NotebookEditorTabInput(R.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new L.NotebookDiffEditorTabInput(R.URI.revive(this._dto.input.original),R.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new L.TerminalEditorTabInput;case 9:return new L.InteractiveWindowInput(R.URI.revive(this._dto.input.uri),R.URI.revive(this._dto.input.inputBoxUri));case 10:return new L.ChatEditorTabInput(this._dto.input.providerId);default:return}}}class v{constructor(b,o){this._tabs=[],this._activeTabId="",this._dto=b,this._activeGroupIdGetter=o;for(const i of b.tabs)i.isActive&&(this._activeTabId=i.id),this._tabs.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const b=this,o={get isActive(){return b._dto.groupId===b._activeGroupIdGetter()},get viewColumn(){return C.ViewColumn.to(b._dto.viewColumn)},get activeTab(){return b._tabs.find(i=>i.tabId===b._activeTabId)?.apiObject},get tabs(){return Object.freeze(b._tabs.map(i=>i.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(b){this._dto=b}acceptTabOperation(b){if(b.kind===0){const i=new I(b.tabDto,this,()=>this.activeTabId());return this._tabs.splice(b.index,0,i),b.tabDto.isActive&&(this._activeTabId=i.tabId),i}else if(b.kind===1){const i=this._tabs.splice(b.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return i.tabId===this._activeTabId&&(this._activeTabId=""),i}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this._tabs.splice(b.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this._tabs.splice(b.index,0,i),i}const o=this._tabs.find(i=>i.tabId===b.tabDto.id);if(!o)throw new Error("INVALID tab");return b.tabDto.isActive?this._activeTabId=b.tabDto.id:this._activeTabId===b.tabDto.id&&!b.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(b.tabDto),o}activeTabId(){return this._activeTabId}}let y=class{constructor(b){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=b.getProxy(w.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const b=this,o={onDidChangeTabGroups:b._onDidChangeTabGroups.event,onDidChangeTabs:b._onDidChangeTabs.event,get all(){return Object.freeze(b._extHostTabGroups.map(i=>i.apiObject))},get activeTabGroup(){const i=b._activeGroupId;return(0,p.assertIsDefined)(b._extHostTabGroups.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?_(r[0])?this._closeGroups(r,n):this._closeTabs(r,n):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(b){const o=new Set(this._extHostTabGroups.map(u=>u.groupId)),i=new Set(b.map(u=>u.groupId)),n=(0,P.diffSets)(o,i),r=this._extHostTabGroups.filter(u=>n.removed.includes(u.groupId)).map(u=>u.apiObject),a=[],t=[];this._extHostTabGroups=b.map(u=>{const s=new v(u,()=>this._activeGroupId);return n.added.includes(s.groupId)?a.push(s.apiObject):t.push(s.apiObject),s});const h=(0,p.assertIsDefined)(b.find(u=>u.isActive===!0)?.groupId);h!==void 0&&this._activeGroupId!==h&&(this._activeGroupId=h),this._onDidChangeTabGroups.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(b){const o=this._extHostTabGroups.find(i=>i.groupId===b.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(b),b.isActive&&(this._activeGroupId=b.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const o=this._extHostTabGroups.find(n=>n.groupId===b.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(b);switch(b.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}_findExtHostTabFromApi(b){for(const o of this._extHostTabGroups)for(const i of o.tabs)if(i.apiObject===b)return i}_findExtHostTabGroupFromApi(b){return this._extHostTabGroups.find(o=>o.apiObject===b)}async _closeTabs(b,o){const i=[];for(const n of b){const r=this._findExtHostTabFromApi(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this._proxy.$closeTab(i,o)}async _closeGroups(b,o){const i=[];for(const n of b){const r=this._findExtHostTabGroupFromApi(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this._proxy.$closeGroup(i,o)}};e.ExtHostEditorTabs=y,e.ExtHostEditorTabs=y=Ge([He(0,E.IExtHostRpcService)],y);function _(l){return l.tabs!==void 0}}),define(Ce[329],De([1,0,2,6,3,7,15,174,12,21,26,80]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const b=this._schemes.indexOf(l);b>=0&&(this._schemes.splice(b,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),b=[];let o,i,n=14,r=14;for(const a of l){let t=o?(0,E.commonPrefixLength)(o,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,b.push([i,a.toUpperCase().charCodeAt(t),r]),b.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;o=a,r=n}b.push([9,58,10]),b.push([10,47,12]),this._stateMachine=new w.StateMachine(b)}}provideDocumentLinks(l){this._initStateMachine();const b=[],o=w.LinkComputer.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const i of o){const n=A.DocumentLink.to(i);n.target&&b.push(n)}return b}}class y{constructor(l,b){this._extHostLanguageFeatures=b,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,b,o,i={}){if(y._validateFileSystemProvider(o),this._registeredSchemes.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const n=this._handlePool++;this._linkProvider.add(b),this._registeredSchemes.add(b),this._fsProvider.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.checkProposedApiEnabled)(l,"fsChunks"),r+=4);let a;i.isReadonly&&(0,I.isMarkdownString)(i.isReadonly)&&i.isReadonly.value!==""&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this._proxy.$registerFileSystemProvider(n,b,r,a).catch(h=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${b}`),console.error(h)});const t=o.onDidChangeFile(h=>{const u=[];for(const s of h){const{uri:c,type:d}=s;if(c.scheme!==b)continue;let m;switch(d){case R.FileChangeType.Changed:m=0;break;case R.FileChangeType.Created:m=1;break;case R.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:c,type:m})}this._proxy.$onFileSystemChange(n,u)});return(0,p.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(b),this._registeredSchemes.delete(b),this._fsProvider.delete(n),this._proxy.$unregisterProvider(n)})}static _validateFileSystemProvider(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(l){const{type:b,ctime:o,mtime:i,size:n,permissions:r}=l;return{type:b,ctime:o,mtime:i,size:n,permissions:r}}$stat(l,b){return Promise.resolve(this._getFsProvider(l).stat(P.URI.revive(b))).then(o=>y._asIStat(o))}$readdir(l,b){return Promise.resolve(this._getFsProvider(l).readDirectory(P.URI.revive(b)))}$readFile(l,b){return Promise.resolve(this._getFsProvider(l).readFile(P.URI.revive(b))).then(o=>C.VSBuffer.wrap(o))}$writeFile(l,b,o,i){return Promise.resolve(this._getFsProvider(l).writeFile(P.URI.revive(b),o.buffer,i))}$delete(l,b,o){return Promise.resolve(this._getFsProvider(l).delete(P.URI.revive(b),o))}$rename(l,b,o,i){return Promise.resolve(this._getFsProvider(l).rename(P.URI.revive(b),P.URI.revive(o),i))}$copy(l,b,o,i){const n=this._getFsProvider(l);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(P.URI.revive(b),P.URI.revive(o),i))}$mkdir(l,b){return Promise.resolve(this._getFsProvider(l).createDirectory(P.URI.revive(b)))}$watch(l,b,o,i){const n=this._getFsProvider(l).watch(P.URI.revive(o),i);this._watches.set(b,n)}$unwatch(l,b){const o=this._watches.get(b);o&&(o.dispose(),this._watches.delete(b))}$open(l,b,o){const i=this._getFsProvider(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(P.URI.revive(b),o))}$close(l,b){const o=this._getFsProvider(l);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(b))}$read(l,b,o,i){const n=this._getFsProvider(l);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=C.VSBuffer.alloc(i);return Promise.resolve(n.read(b,o,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(l,b,o,i){const n=this._getFsProvider(l);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(b,o,i.buffer,0,i.byteLength))}_getFsProvider(l){const b=this._fsProvider.get(l);if(!b){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return b}}e.ExtHostFileSystem=y}),define(Ce[330],De([1,0,4,35,2,6,15,7,44]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(y,_,l,b,o,i){this.session=Math.random(),this._onDidCreate=new P.Emitter,this._onDidChange=new P.Emitter,this._onDidDelete=new P.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const n=(0,F.parse)(o),r=typeof o=="string",a=i?.correlate,t=b(h=>{if(!(typeof h.session=="number"&&h.session!==this.session)&&!(a&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const u of h.created){const s=p.URI.revive(u);n(s.fsPath)&&(!r||_.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!i?.ignoreChangeEvents)for(const u of h.changed){const s=p.URI.revive(u);n(s.fsPath)&&(!r||_.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!i?.ignoreDeleteEvents)for(const u of h.deleted){const s=p.URI.revive(u);n(s.fsPath)&&(!r||_.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}}});this._disposable=w.Disposable.from(this.ensureWatching(y,l,o,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(y,_,l,b,o){const i=w.Disposable.from();if(typeof l=="string")return i;const n=y.getProxy(R.MainContext.MainThreadFileSystemEventService);let r=!1;return(l.pattern.includes(F.GLOBSTAR)||l.pattern.includes(F.GLOB_SPLIT))&&(r=!0),n.$watch(_.identifier.value,this.session,l.baseUri,{recursive:r,excludes:b?.excludes??[]},!!o),w.Disposable.from({dispose:()=>n.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(y){this._events=y,this.session=this._events.session,this._created=new E.Lazy(()=>this._events.created.map(p.URI.revive)),this._changed=new E.Lazy(()=>this._events.changed.map(p.URI.revive)),this._deleted=new E.Lazy(()=>this._events.deleted.map(p.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class I{constructor(y,_,l){this._mainContext=y,this._logService=_,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new P.Emitter,this._onDidRenameFile=new P.Emitter,this._onDidCreateFile=new P.Emitter,this._onDidDeleteFile=new P.Emitter,this._onWillRenameFile=new P.AsyncEmitter,this._onWillCreateFile=new P.AsyncEmitter,this._onWillDeleteFile=new P.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,_,l,b){return new C(this._mainContext,y,_,this._onFileSystemEvent.event,A.GlobPattern.from(l),b)}$onFileEvent(y){this._onFileSystemEvent.fire(new L(y))}$onDidRunFileOperation(y,_){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(l=>({oldUri:p.URI.revive(l.source),newUri:p.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(l=>p.URI.revive(l.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:_.map(l=>p.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,_){return(l,b,o)=>{const i=function(r){l.call(b,r)};return i.extension=y,_.event(i,void 0,o)}}async $onWillRunFileOperation(y,_,l,b){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:p.URI.revive(o.source),newUri:p.URI.revive(o.target)}))},l,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>p.URI.revive(o.target))},l,b);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>p.URI.revive(o.target))},l,b)}}async _fireWillEvent(y,_,l,b){const o=new Set,i=[];if(await y.fireAsync(_,b,async(r,a)=>{const t=Date.now(),h=await Promise.resolve(r);h instanceof w.WorkspaceEdit&&(i.push([a.extension,h]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>l&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),b.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=A.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=I}),define(Ce[331],De([1,0,19,8,22,14,121,3,24,38,12,18,2,29,170,83,131,215,25,15,7,26,110,6]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class u{constructor(W,H){this._documents=W,this._provider=H}async provideDocumentSymbols(W,H){const X=this._documents.getDocument(W),K=await this._provider.provideDocumentSymbols(X,H);if(!(0,P.isFalsyOrEmpty)(K))return K[0]instanceof r.DocumentSymbol?K.map(n.DocumentSymbol.from):u._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((K,pe)=>{let Ee=K.location.range.start.compareTo(pe.location.range.start);return Ee===0&&(Ee=pe.location.range.end.compareTo(K.location.range.end)),Ee});const H=[],X=[];for(const K of W){const pe={name:K.name||"!!MISSING: name!!",kind:n.SymbolKind.from(K.kind),tags:K.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:n.Range.from(K.location.range),selectionRange:n.Range.from(K.location.range),children:[]};for(;;){if(X.length===0){X.push(pe),H.push(pe);break}const Ee=X[X.length-1];if(y.Range.containsRange(Ee.range,pe.range)&&!y.Range.equalsRange(Ee.range,pe.range)){Ee.children?.push(pe),X.push(pe);break}X.pop()}}return H}}class s{constructor(W,H,X,K,pe,Ee){this._documents=W,this._commands=H,this._provider=X,this._extension=K,this._extTelemetry=pe,this._logService=Ee,this._cache=new t.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,H){const X=this._documents.getDocument(W),K=await this._provider.provideCodeLenses(X,H);if(!K||H.isCancellationRequested)return;const pe=this._cache.add(K),Ee=new w.DisposableStore;this._disposables.set(pe,Ee);const Me={cacheId:pe,lenses:[]};for(let Ve=0;Ve<K.length;Ve++)Me.lenses.push({cacheId:[pe,Ve],range:n.Range.from(K[Ve].range),command:this._commands.toInternal(K[Ve].command,Ee)});return Me}async resolveCodeLens(W,H){const X=W.cacheId&&this._cache.get(...W.cacheId);if(!X)return;let K;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?K=X:K=await this._provider.resolveCodeLens(X,H),K||(K=X),H.isCancellationRequested)return;const pe=W.cacheId&&this._disposables.get(W.cacheId[0]);if(pe){if(!K.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,Ee),this._logService.error(Ee);return}return W.command=this._commands.toInternal(K.command,pe),W}}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}function c(xe){return Array.isArray(xe)?xe.map(n.DefinitionLink.from):xe?[n.DefinitionLink.from(xe)]:[]}class d{constructor(W,H){this._documents=W,this._provider=H}async provideDefinition(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideDefinition(K,pe,X);return c(Ee)}}class m{constructor(W,H){this._documents=W,this._provider=H}async provideDeclaration(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideDeclaration(K,pe,X);return c(Ee)}}class D{constructor(W,H){this._documents=W,this._provider=H}async provideImplementation(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideImplementation(K,pe,X);return c(Ee)}}class g{constructor(W,H){this._documents=W,this._provider=H}async provideTypeDefinition(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideTypeDefinition(K,pe,X);return c(Ee)}}class f{constructor(W,H){this._documents=W,this._provider=H}async provideHover(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideHover(K,pe,X);if(!(!Ee||(0,P.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=K.getWordRangeAtPosition(pe)),Ee.range||(Ee.range=new r.Range(pe,pe)),n.Hover.from(Ee)}}class S{constructor(W,H){this._documents=W,this._provider=H}async provideEvaluatableExpression(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideEvaluatableExpression(K,pe,X);if(Ee)return n.EvaluatableExpression.from(Ee)}}class T{constructor(W,H){this._documents=W,this._provider=H}async provideInlineValues(W,H,X,K){const pe=this._documents.getDocument(W),Ee=await this._provider.provideInlineValues(pe,n.Range.to(H),n.InlineValueContext.to(X),K);if(Array.isArray(Ee))return Ee.map(Me=>n.InlineValue.from(Me))}}class N{constructor(W,H){this._documents=W,this._provider=H}async provideDocumentHighlights(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideDocumentHighlights(K,pe,X);if(Array.isArray(Ee))return Ee.map(n.DocumentHighlight.from)}}class z{constructor(W,H){this._documents=W,this._provider=H}async provideMultiDocumentHighlights(W,H,X,K){const pe=this._documents.getDocument(W),Ee=X.map(Ke=>this._documents.getDocument(Ke)),Me=n.Position.to(H),Ve=await this._provider.provideMultiDocumentHighlights(pe,Me,Ee,K);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class x{constructor(W,H){this._documents=W,this._provider=H}async provideLinkedEditingRanges(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.provideLinkedEditingRanges(K,pe,X);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,P.coalesce)(Ee.ranges.map(n.Range.from)),wordPattern:Ee.wordPattern}}}class M{constructor(W,H){this._documents=W,this._provider=H}async provideReferences(W,H,X,K){const pe=this._documents.getDocument(W),Ee=n.Position.to(H),Me=await this._provider.provideReferences(pe,Ee,X,K);if(Array.isArray(Me))return Me.map(n.location.from)}}class k{static{this._maxCodeActionsPerFile=1e3}constructor(W,H,X,K,pe,Ee,Me){this._documents=W,this._commands=H,this._diagnostics=X,this._provider=K,this._logService=pe,this._extension=Ee,this._apiDeprecation=Me,this._cache=new t.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,H,X,K){const pe=this._documents.getDocument(W),Ee=_.Selection.isISelection(H)?n.Selection.to(H):n.Range.to(H),Me=[];for(const rt of this._diagnostics.getDiagnostics(W))if(Ee.intersection(rt.range)&&Me.push(rt)>k._maxCodeActionsPerFile)break;const Ve={diagnostics:Me,only:X.only?new r.CodeActionKind(X.only):void 0,triggerKind:n.CodeActionTriggerKind.to(X.trigger)},Ke=await this._provider.provideCodeActions(pe,Ee,Ve,K);if(!(0,P.isNonEmptyArray)(Ke)||K.isCancellationRequested)return;const tt=this._cache.add(Ke),st=new w.DisposableStore;this._disposables.set(tt,st);const lt=[];for(let rt=0;rt<Ke.length;rt++){const Pe=Ke[rt];if(Pe)if(k._isCommand(Pe))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:Pe.title,command:this._commands.toInternal(Pe,st)});else{Ve.only&&(Pe.kind?Ve.only.contains(Pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ze=Pe.ranges??[];lt.push({cacheId:[tt,rt],title:Pe.title,command:Pe.command&&this._commands.toInternal(Pe.command,st),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(n.Diagnostic.from),edit:Pe.edit&&n.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,isAI:(0,a.isProposedApiEnabled)(this._extension,"codeActionAI")?Pe.isAI:!1,ranges:(0,a.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,P.coalesce)(ze.map(n.Range.from)):void 0,disabled:Pe.disabled?.reason})}}return{cacheId:tt,actions:lt}}async resolveCodeAction(W,H){const[X,K]=W,pe=this._cache.get(X,K);if(!pe||k._isCommand(pe))return{};if(!this._provider.resolveCodeAction)return{};const Ee=await this._provider.resolveCodeAction(pe,H)??pe;let Me;Ee.edit&&(Me=n.WorkspaceEdit.from(Ee.edit,void 0));let Ve;if(Ee.command){const Ke=this._disposables.get(X);Ke&&(Ve=this._commands.toInternal(Ee.command,Ke))}return{edit:Me,command:Ve}}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}class O{static toInternalProviderId(W,H){return W+"."+H}constructor(W,H,X,K,pe){this._proxy=W,this._documents=H,this._provider=X,this._handle=K,this._extension=pe}async prepareDocumentPaste(W,H,X,K){if(!this._provider.prepareDocumentPaste)return;const pe=this._documents.getDocument(W),Ee=H.map(Ke=>n.Range.to(Ke)),Me=n.DataTransfer.toDataTransfer(X,()=>{throw new R.NotImplementedError});if(await this._provider.prepareDocumentPaste(pe,Ee,Me,K),K.isCancellationRequested)return;const Ve=Array.from(Me).filter(([,Ke])=>!(Ke instanceof r.InternalDataTransferItem));return n.DataTransfer.from(Ve)}async providePasteEdits(W,H,X,K,pe){if(!this._provider.provideDocumentPasteEdits)return;const Ee=this._documents.getDocument(H),Me=X.map(tt=>n.Range.to(tt)),Ve=n.DataTransfer.toDataTransfer(K,async tt=>(await this._proxy.$resolvePasteFileData(this._handle,W,tt)).buffer),Ke=await this._provider.provideDocumentPasteEdits(Ee,Me,Ve,pe);if(Ke)return{label:Ke.label??(0,o.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:Ke.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:O.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?n.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class U{constructor(W,H){this._documents=W,this._provider=H}async provideDocumentFormattingEdits(W,H,X){const K=this._documents.getDocument(W),pe=await this._provider.provideDocumentFormattingEdits(K,H,X);if(Array.isArray(pe))return pe.map(n.TextEdit.from)}}class q{constructor(W,H){this._documents=W,this._provider=H}async provideDocumentRangeFormattingEdits(W,H,X,K){const pe=this._documents.getDocument(W),Ee=n.Range.to(H),Me=await this._provider.provideDocumentRangeFormattingEdits(pe,Ee,X,K);if(Array.isArray(Me))return Me.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,H,X,K){(0,I.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const pe=this._documents.getDocument(W),Ee=H.map(n.Range.to),Me=await this._provider.provideDocumentRangesFormattingEdits(pe,Ee,X,K);if(Array.isArray(Me))return Me.map(n.TextEdit.from)}}class ie{constructor(W,H){this._documents=W,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,H,X,K,pe){const Ee=this._documents.getDocument(W),Me=n.Position.to(H),Ve=await this._provider.provideOnTypeFormattingEdits(Ee,Me,X,K,pe);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class Z{constructor(W,H){this._provider=W,this._logService=H,this._cache=new t.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(W,H){const X=await this._provider.provideWorkspaceSymbols(W,H);if(!(0,P.isNonEmptyArray)(X))return{symbols:[]};const K=this._cache.add(X),pe={cacheId:K,symbols:[]};for(let Ee=0;Ee<X.length;Ee++){const Me=X[Ee];if(!Me||!Me.name){this._logService.warn("INVALID SymbolInformation",Me);continue}pe.symbols.push({...n.WorkspaceSymbol.from(Me),cacheId:[K,Ee]})}return pe}async resolveWorkspaceSymbol(W,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const X=this._cache.get(...W.cacheId);if(X){const K=await this._provider.resolveWorkspaceSymbol(X,H);return K&&(0,E.mixin)(W,n.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(W){this._cache.delete(W)}}class Q{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,H,X){this._documents=W,this._provider=H,this._logService=X}async provideRenameEdits(W,H,X,K){const pe=this._documents.getDocument(W),Ee=n.Position.to(H);try{const Me=await this._provider.provideRenameEdits(pe,Ee,X,K);return Me?n.WorkspaceEdit.from(Me):void 0}catch(Me){const Ve=Q._asMessage(Me);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Me)}}async resolveRenameLocation(W,H,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(W),pe=n.Position.to(H);try{const Ee=await this._provider.prepareRename(K,pe,X);let Me,Ve;if(r.Range.isRange(Ee)?(Me=Ee,Ve=K.getText(Ee)):(0,I.isObject)(Ee)&&(Me=Ee.range,Ve=Ee.placeholder),!Me||!Ve)return;if(Me.start.line>pe.line||Me.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Me),text:Ve}}catch(Ee){const Me=Q._asMessage(Ee);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Y{constructor(W,H,X){this._documents=W,this._provider=H,this._logService=X}async provideNewSymbolNames(W,H,X){const K=this._documents.getDocument(W),pe=n.Range.to(H);try{const Ee=await this._provider.provideNewSymbolNames(K,pe,X);return Ee?Ee.map(Me=>typeof Me=="string"?{newSymbolName:Me}:{newSymbolName:Me.newSymbolName,tags:Me.tags}):void 0}catch(Ee){this._logService.error(Y._asMessage(Ee)??JSON.stringify(Ee,null,"	"));return}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ae{constructor(W,H){this.resultId=W,this.tokens=H}}class ee{constructor(W,H){this._documents=W,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,H,X){const K=this._documents.getDocument(W),pe=H!==0?this._previousResults.get(H):null;let Ee=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,pe.resultId,X):await this._provider.provideDocumentSemanticTokens(K,X);return pe&&this._previousResults.delete(H),Ee?(Ee=ee._fixProvidedSemanticTokens(Ee),this._send(ee._convertToEdits(pe,Ee),Ee)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return ee._isSemanticTokens(W)?ee._isCorrectSemanticTokens(W)?W:new r.SemanticTokens(new Uint32Array(W.data),W.resultId):ee._isSemanticTokensEdits(W)?ee._isCorrectSemanticTokensEdits(W)?W:new r.SemanticTokensEdits(W.edits.map(H=>new r.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const H of W.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,H){if(!ee._isSemanticTokens(H)||!W||!W.tokens)return H;const X=W.tokens,K=X.length,pe=H.data,Ee=pe.length;let Me=0;const Ve=Math.min(K,Ee);for(;Me<Ve&&X[Me]===pe[Me];)Me++;if(Me===K&&Me===Ee)return new r.SemanticTokensEdits([],H.resultId);let Ke=0;const tt=Ve-Me;for(;Ke<tt&&X[K-Ke-1]===pe[Ee-Ke-1];)Ke++;return new r.SemanticTokensEdits([{start:Me,deleteCount:K-Me-Ke,data:pe.subarray(Me,Ee-Ke)}],H.resultId)}_send(W,H){if(ee._isSemanticTokens(W)){const X=this._nextResultId++;return this._previousResults.set(X,new ae(W.resultId,W.data)),(0,b.encodeSemanticTokensDto)({id:X,type:"full",data:W.data})}if(ee._isSemanticTokensEdits(W)){const X=this._nextResultId++;return ee._isSemanticTokens(H)?this._previousResults.set(X,new ae(H.resultId,H.data)):this._previousResults.set(X,new ae(W.resultId)),(0,b.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(W.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class fe{constructor(W,H){this._documents=W,this._provider=H}async provideDocumentRangeSemanticTokens(W,H,X){const K=this._documents.getDocument(W),pe=await this._provider.provideDocumentRangeSemanticTokens(K,n.Range.to(H),X);return pe?this._send(pe):null}_send(W){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}class re{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,H,X,K,pe){this._documents=W,this._commands=H,this._provider=X,this._apiDeprecation=K,this._extension=pe,this._cache=new t.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(W,H,X,K){const pe=this._documents.getDocument(W),Ee=n.Position.to(H),Me=pe.getWordRangeAtPosition(Ee)||new r.Range(Ee,Ee),Ve=Me.with({end:Ee}),Ke=new C.StopWatch,tt=await this._provider.provideCompletionItems(pe,Ee,K,n.CompletionContext.to(X));if(!tt||K.isCancellationRequested)return;const st=Array.isArray(tt)?new r.CompletionList(tt):tt,lt=re.supportsResolving(this._provider)?this._cache.add(st.items):this._cache.add([]),rt=new w.DisposableStore;this._disposables.set(lt,rt);const Pe=[],ze={x:lt,b:Pe,a:{replace:n.Range.from(Me),insert:n.Range.from(Ve)},c:st.isIncomplete||void 0,d:Ke.elapsed()};for(let Ae=0;Ae<st.items.length;Ae++){const je=st.items[Ae],ne=this._convertCompletionItem(je,[lt,Ae],Ve,Me);Pe.push(ne)}return ze}async resolveCompletionItem(W,H){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...W);if(!X)return;const K=this._convertCompletionItem(X,W),pe=await this._provider.resolveCompletionItem(X,H);if(!pe)return;const Ee=this._convertCompletionItem(pe,W);return(K.h!==Ee.h||K.i!==Ee.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==Ee.n||K.o!==Ee.o||!(0,E.equals)(K.p,Ee.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:Ee.d,c:Ee.c,l:Ee.l,h:Ee.h,i:Ee.i,n:Ee.n,o:Ee.o,p:Ee.p}}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,H,X,K){const pe=this._disposables.get(H[0]);if(!pe)throw Error("DisposableStore is missing...");const Ee=this._commands.toInternal(W.command,pe),Me={x:H,a:W.label,b:W.kind!==void 0?n.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(n.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:n.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(n.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=W.textEdit.newText):typeof W.insertText=="string"?Me.h=W.insertText:W.insertText instanceof r.SnippetString&&(Me.h=W.insertText.value,Me.i|=4);let Ve;return W.textEdit?Ve=W.textEdit.range:W.range&&(Ve=W.range),r.Range.isRange(Ve)?Me.j=n.Range.from(Ve):Ve&&(!X?.isEqual(Ve.inserting)||!K?.isEqual(Ve.replacing))&&(Me.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Me}}class G{async provideInlineCompletions(W,H,X,K){}disposeCompletions(W){}handleDidShowCompletionItem(W,H,X){}handlePartialAccept(W,H,X){}}class B extends G{constructor(W,H,X,K){super(),this._extension=W,this._documents=H,this._provider=X,this._commands=K,this._references=new ye,this._isAdditionsProposedApiEnabled=(0,a.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[l.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,a.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,H,X,K){const pe=this._documents.getDocument(W),Ee=n.Position.to(H),Me=await this._provider.provideInlineCompletionItems(pe,Ee,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:n.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[X.triggerKind]},K);if(!Me||K.isCancellationRequested)return;const Ve=Array.isArray(Me)?Me:Me.items,Ke=this._isAdditionsProposedApiEnabled?Array.isArray(Me)?[]:Me.commands||[]:[],tt=this._isAdditionsProposedApiEnabled&&!Array.isArray(Me)?Me.enableForwardStability:void 0;let st;return{pid:this._references.createReferenceId({dispose(){st?.dispose()},items:Ve}),items:Ve.map((rt,Pe)=>{let ze;rt.command&&(st||(st=new w.DisposableStore),ze=this._commands.toInternal(rt.command,st));const Ae=rt.insertText;return{insertText:typeof Ae=="string"?Ae:{snippet:Ae.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:ze,idx:Pe,completeBracketPairs:this._isAdditionsProposedApiEnabled?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(st||(st=new w.DisposableStore),this._commands.toInternal(rt,st))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(W){this._references.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,H,X){const K=this._references.get(W)?.items[H];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K,X)}handlePartialAccept(W,H,X){const K=this._references.get(W)?.items[H];K&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(K,X)}}class se{async provideInlineEdits(W,H,X){const K=this._documents.getDocument(W),pe=await this._provider.provideInlineEdit(K,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},X);if(!pe||X.isCancellationRequested)return;let Ee;const Me=this._references.createReferenceId({dispose(){Ee?.dispose()},item:pe});let Ve;pe.accepted&&(Ee||(Ee=new w.DisposableStore),Ve=this._commands.toInternal(pe.accepted,Ee));let Ke;return pe.rejected&&(Ee||(Ee=new w.DisposableStore),Ke=this._commands.toInternal(pe.rejected,Ee)),{pid:Me,text:pe.text,range:n.Range.from(pe.range),accepted:Ve,rejected:Ke}}disposeEdit(W){this._references.disposeReferenceId(W)?.dispose()}constructor(W,H,X,K){this._documents=H,this._provider=X,this._commands=K,this._references=new ye,this.languageTriggerKindToVSCodeTriggerKind={[l.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[l.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ye{constructor(){this._references=new Map,this._idPool=1}createReferenceId(W){const H=this._idPool++;return this._references.set(H,W),H}disposeReferenceId(W){const H=this._references.get(W);return this._references.delete(W),H}get(W){return this._references.get(W)}}class le{constructor(W,H){this._documents=W,this._provider=H,this._cache=new t.Cache("SignatureHelp")}async provideSignatureHelp(W,H,X,K){const pe=this._documents.getDocument(W),Ee=n.Position.to(H),Me=this.reviveContext(X),Ve=await this._provider.provideSignatureHelp(pe,Ee,K,Me);if(Ve){const Ke=this._cache.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Ke}}}reviveContext(W){let H;if(W.activeSignatureHelp){const X=n.SignatureHelp.to(W.activeSignatureHelp),K=this._cache.get(W.activeSignatureHelp.id,0);K?(H=K,H.activeSignature=X.activeSignature,H.activeParameter=X.activeParameter):H=X}return{...W,activeSignatureHelp:H}}releaseSignatureHelp(W){this._cache.delete(W)}}class de{constructor(W,H,X,K,pe){this._documents=W,this._commands=H,this._provider=X,this._logService=K,this._extension=pe,this._cache=new t.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(W,H,X){const K=this._documents.getDocument(W),pe=n.Range.to(H),Ee=await this._provider.provideInlayHints(K,pe,X);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(H)}`);return}if(X.isCancellationRequested)return;const Me=this._cache.add(Ee);this._disposables.set(Me,new w.DisposableStore);const Ve={hints:[],cacheId:Me};for(let Ke=0;Ke<Ee.length;Ke++)this._isValidInlayHint(Ee[Ke],pe)&&Ve.hints.push(this._convertInlayHint(Ee[Ke],[Me,Ke]));return this._logService.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(H)}`),Ve}async resolveInlayHint(W,H){if(typeof this._provider.resolveInlayHint!="function")return;const X=this._cache.get(...W);if(!X)return;const K=await this._provider.resolveInlayHint(X,H);if(K&&this._isValidInlayHint(K))return this._convertInlayHint(K,W)}releaseHints(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_isValidInlayHint(W,H){return W.label.length===0||Array.isArray(W.label)&&W.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(H&&!H.contains(W.position))}_convertInlayHint(W,H){const X=this._disposables.get(H[0]);if(!X)throw Error("DisposableStore is missing...");const K={label:"",cacheId:H,tooltip:n.MarkdownString.fromStrict(W.tooltip),position:n.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(n.TextEdit.from),kind:W.kind&&n.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")K.label=W.label;else{const pe=[];K.label=pe;for(const Ee of W.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Me={label:Ee.value,tooltip:n.MarkdownString.fromStrict(Ee.tooltip)};r.Location.isLocation(Ee.location)&&(Me.location=n.location.from(Ee.location)),Ee.command&&(Me.command=this._commands.toInternal(Ee.command,X)),pe.push(Me)}}return K}}class ce{constructor(W,H){this._documents=W,this._provider=H,this._cache=new t.Cache("DocumentLink")}async provideLinks(W,H){const X=this._documents.getDocument(W),K=await this._provider.provideDocumentLinks(X,H);if(!(!Array.isArray(K)||K.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(ce._validateLink).map(n.DocumentLink.from)};{const pe=this._cache.add(K),Ee={links:[],cacheId:pe};for(let Me=0;Me<K.length;Me++){if(!ce._validateLink(K[Me]))continue;const Ve=n.DocumentLink.from(K[Me]);Ve.cacheId=[pe,Me],Ee.links.push(Ve)}return Ee}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,H){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...W);if(!X)return;const K=await this._provider.resolveDocumentLink(X,H);if(!(!K||!ce._validateLink(K)))return n.DocumentLink.from(K)}releaseLinks(W){this._cache.delete(W)}}class he{constructor(W,H){this._documents=W,this._provider=H}async provideColors(W,H){const X=this._documents.getDocument(W),K=await this._provider.provideDocumentColors(X,H);return Array.isArray(K)?K.map(Ee=>({color:n.Color.from(Ee.color),range:n.Range.from(Ee.range)})):[]}async provideColorPresentations(W,H,X){const K=this._documents.getDocument(W),pe=n.Range.to(H.range),Ee=n.Color.to(H.color),Me=await this._provider.provideColorPresentations(Ee,{document:K,range:pe},X);if(Array.isArray(Me))return Me.map(n.ColorPresentation.from)}}class V{constructor(W,H){this._documents=W,this._provider=H}async provideFoldingRanges(W,H,X){const K=this._documents.getDocument(W),pe=await this._provider.provideFoldingRanges(K,H,X);if(Array.isArray(pe))return pe.map(n.FoldingRange.from)}}class J{constructor(W,H,X){this._documents=W,this._provider=H,this._logService=X}async provideSelectionRanges(W,H,X){const K=this._documents.getDocument(W),pe=H.map(n.Position.to),Ee=await this._provider.provideSelectionRanges(K,pe,X);if(!(0,P.isNonEmptyArray)(Ee))return[];if(Ee.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let Ve=0;Ve<pe.length;Ve++){const Ke=[];Me.push(Ke);let tt=pe[Ve],st=Ee[Ve];for(;;){if(!st.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(st)),!st.parent)break;tt=st.range,st=st.parent}}return Me}}class ue{constructor(W,H){this._documents=W,this._provider=H,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.prepareCallHierarchy(K,pe,X);if(!Ee)return;const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(Ee)?Ee.map(Ve=>this._cacheAndConvertItem(Me,Ve)):[this._cacheAndConvertItem(Me,Ee)]}async provideCallsTo(W,H,X){const K=this._itemFromCache(W,H);if(!K)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(K,X);if(pe)return pe.map(Ee=>({from:this._cacheAndConvertItem(W,Ee.from),fromRanges:Ee.fromRanges.map(Me=>n.Range.from(Me))}))}async provideCallsFrom(W,H,X){const K=this._itemFromCache(W,H);if(!K)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(K,X);if(pe)return pe.map(Ee=>({to:this._cacheAndConvertItem(W,Ee.to),fromRanges:Ee.fromRanges.map(Me=>n.Range.from(Me))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,H){const X=this._cache.get(W),K=n.CallHierarchyItem.from(H,W,X.size.toString(36));return X.set(K._itemId,H),K}_itemFromCache(W,H){return this._cache.get(W)?.get(H)}}class ve{constructor(W,H){this._documents=W,this._provider=H,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(W,H,X){const K=this._documents.getDocument(W),pe=n.Position.to(H),Ee=await this._provider.prepareTypeHierarchy(K,pe,X);if(!Ee)return;const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(Ee)?Ee.map(Ve=>this._cacheAndConvertItem(Me,Ve)):[this._cacheAndConvertItem(Me,Ee)]}async provideSupertypes(W,H,X){const K=this._itemFromCache(W,H);if(!K)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySupertypes(K,X);if(pe)return pe.map(Ee=>this._cacheAndConvertItem(W,Ee))}async provideSubtypes(W,H,X){const K=this._itemFromCache(W,H);if(!K)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySubtypes(K,X);if(pe)return pe.map(Ee=>this._cacheAndConvertItem(W,Ee))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,H){const X=this._cache.get(W),K=n.TypeHierarchyItem.from(H,W,X.size.toString(36));return X.set(K._itemId,H),K}_itemFromCache(W,H){return this._cache.get(W)?.get(H)}}class ke{static toInternalProviderId(W,H){return W+"."+H}constructor(W,H,X,K,pe){this._proxy=W,this._documents=H,this._provider=X,this._handle=K,this._extension=pe}async provideDocumentOnDropEdits(W,H,X,K,pe){const Ee=this._documents.getDocument(H),Me=n.Position.to(X),Ve=n.DataTransfer.toDataTransfer(K,async tt=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,W,tt)).buffer),Ke=await this._provider.provideDocumentDropEdits(Ee,Me,Ve,pe);if(Ke)return{label:Ke.label??(0,o.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:Ke.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:ke.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?n.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class we{constructor(W,H){this._documents=W,this._provider=H}async provideMappedEdits(W,H,X,K){const pe=v.URI.revive(W),Ee=this._documents.getDocument(pe),Me=X.documents.map(tt=>tt.map(st=>({uri:v.URI.revive(st.uri),version:st.version,ranges:st.ranges.map(lt=>n.Range.to(lt))}))),Ve={documents:Me,selections:Me[0]?.[0]?.ranges??[]},Ke=await this._provider.provideMappedEdits(Ee,H,Ve,K);return Ke?n.WorkspaceEdit.from(Ke):null}}class Te{constructor(W,H){this.adapter=W,this.extension=H}}class Oe{static{this._handlePool=0}constructor(W,H,X,K,pe,Ee,Me,Ve){this._uriTransformer=H,this._documents=X,this._commands=K,this._diagnostics=pe,this._logService=Ee,this._apiDeprecation=Me,this._extensionTelemetry=Ve,this._adapter=new Map,this._proxy=W.getProxy(h.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(W,H){return n.DocumentSelector.from(W,this._uriTransformer,H)}_createDisposable(W){return new r.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Oe._handlePool++}async _withAdapter(W,H,X,K,pe,Ee=!1){const Me=this._adapter.get(W);if(!Me||!(Me.adapter instanceof H))return K;const Ve=Date.now();Ee||this._logService.trace(`[${Me.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ke=X(Me.adapter,Me.extension);return Promise.resolve(Ke).catch(tt=>{(0,R.isCancellationError)(tt)||(this._logService.error(`[${Me.extension.identifier.value}] provider FAILED`),this._logService.error(tt),this._extensionTelemetry.onExtensionError(Me.extension.identifier,tt))}).finally(()=>{Ee||this._logService.trace(`[${Me.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),p.CancellationToken.isCancellationToken(pe)?(0,F.raceCancellationError)(Ke,pe):Ke}_addNewAdapter(W,H){const X=this._nextHandle();return this._adapter.set(X,new Te(W,H)),X}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,H,X,K){const pe=this._addNewAdapter(new u(this._documents,X),W),Ee=K&&K.label||Oe._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(H,W),Ee),this._createDisposable(pe)}$provideDocumentSymbols(W,H,X){return this._withAdapter(W,u,K=>K.provideDocumentSymbols(v.URI.revive(H),X),void 0,X)}registerCodeLensProvider(W,H,X){const K=this._nextHandle(),pe=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new Te(new s(this._documents,this._commands.converter,X,W,this._extensionTelemetry,this._logService),W)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector(H,W),pe);let Ee=this._createDisposable(K);if(pe!==void 0){const Me=X.onDidChangeCodeLenses(Ve=>this._proxy.$emitCodeLensEvent(pe));Ee=r.Disposable.from(Ee,Me)}return Ee}$provideCodeLenses(W,H,X){return this._withAdapter(W,s,K=>K.provideCodeLenses(v.URI.revive(H),X),void 0,X)}$resolveCodeLens(W,H,X){return this._withAdapter(W,s,K=>K.resolveCodeLens(H,X),void 0,void 0)}$releaseCodeLenses(W,H){this._withAdapter(W,s,X=>Promise.resolve(X.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(W,H,X){const K=this._addNewAdapter(new d(this._documents,X),W);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideDefinition(W,H,X,K){return this._withAdapter(W,d,pe=>pe.provideDefinition(v.URI.revive(H),X,K),[],K)}registerDeclarationProvider(W,H,X){const K=this._addNewAdapter(new m(this._documents,X),W);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideDeclaration(W,H,X,K){return this._withAdapter(W,m,pe=>pe.provideDeclaration(v.URI.revive(H),X,K),[],K)}registerImplementationProvider(W,H,X){const K=this._addNewAdapter(new D(this._documents,X),W);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideImplementation(W,H,X,K){return this._withAdapter(W,D,pe=>pe.provideImplementation(v.URI.revive(H),X,K),[],K)}registerTypeDefinitionProvider(W,H,X){const K=this._addNewAdapter(new g(this._documents,X),W);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideTypeDefinition(W,H,X,K){return this._withAdapter(W,g,pe=>pe.provideTypeDefinition(v.URI.revive(H),X,K),[],K)}registerHoverProvider(W,H,X,K){const pe=this._addNewAdapter(new f(this._documents,X),W);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(H,W)),this._createDisposable(pe)}$provideHover(W,H,X,K){return this._withAdapter(W,f,pe=>pe.provideHover(v.URI.revive(H),X,K),void 0,K)}registerEvaluatableExpressionProvider(W,H,X,K){const pe=this._addNewAdapter(new S(this._documents,X),W);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(H,W)),this._createDisposable(pe)}$provideEvaluatableExpression(W,H,X,K){return this._withAdapter(W,S,pe=>pe.provideEvaluatableExpression(v.URI.revive(H),X,K),void 0,K)}registerInlineValuesProvider(W,H,X,K){const pe=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new T(this._documents,X),W);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(H,W),pe);let Me=this._createDisposable(Ee);if(pe!==void 0){const Ve=X.onDidChangeInlineValues(Ke=>this._proxy.$emitInlineValuesEvent(pe));Me=r.Disposable.from(Me,Ve)}return Me}$provideInlineValues(W,H,X,K,pe){return this._withAdapter(W,T,Ee=>Ee.provideInlineValues(v.URI.revive(H),X,K,pe),void 0,pe)}registerDocumentHighlightProvider(W,H,X){const K=this._addNewAdapter(new N(this._documents,X),W);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}registerMultiDocumentHighlightProvider(W,H,X){const K=this._addNewAdapter(new z(this._documents,X),W);return this._proxy.$registerMultiDocumentHighlightProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideDocumentHighlights(W,H,X,K){return this._withAdapter(W,N,pe=>pe.provideDocumentHighlights(v.URI.revive(H),X,K),void 0,K)}$provideMultiDocumentHighlights(W,H,X,K,pe){return this._withAdapter(W,z,Ee=>Ee.provideMultiDocumentHighlights(v.URI.revive(H),X,K.map(Me=>v.URI.revive(Me)),pe),void 0,pe)}registerLinkedEditingRangeProvider(W,H,X){const K=this._addNewAdapter(new x(this._documents,X),W);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideLinkedEditingRanges(W,H,X,K){return this._withAdapter(W,x,async pe=>{const Ee=await pe.provideLinkedEditingRanges(v.URI.revive(H),X,K);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Oe._serializeRegExp(Ee.wordPattern):void 0}},void 0,K)}registerReferenceProvider(W,H,X){const K=this._addNewAdapter(new M(this._documents,X),W);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideReferences(W,H,X,K,pe){return this._withAdapter(W,M,Ee=>Ee.provideReferences(v.URI.revive(H),X,K,pe),void 0,pe)}registerCodeActionProvider(W,H,X,K){const pe=new w.DisposableStore,Ee=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,X,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector(H,W),{providedKinds:K?.providedCodeActionKinds?.map(Me=>Me.value),documentation:K?.documentation?.map(Me=>({kind:Me.kind.value,command:this._commands.converter.toInternal(Me.command,pe)}))},Oe._extLabel(W),!!X.resolveCodeAction),pe.add(this._createDisposable(Ee)),pe}$provideCodeActions(W,H,X,K,pe){return this._withAdapter(W,k,Ee=>Ee.provideCodeActions(v.URI.revive(H),X,K,pe),void 0,pe)}$resolveCodeAction(W,H,X){return this._withAdapter(W,k,K=>K.resolveCodeAction(H,X),{},void 0)}$releaseCodeActions(W,H){this._withAdapter(W,k,X=>Promise.resolve(X.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(W,H,X){const K=this._addNewAdapter(new U(this._documents,X),W);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector(H,W),W.identifier,W.displayName||W.name),this._createDisposable(K)}$provideDocumentFormattingEdits(W,H,X,K){return this._withAdapter(W,U,pe=>pe.provideDocumentFormattingEdits(v.URI.revive(H),X,K),void 0,K)}registerDocumentRangeFormattingEditProvider(W,H,X){const K=typeof X.provideDocumentRangesFormattingEdits=="function",pe=this._addNewAdapter(new q(this._documents,X),W);return this._proxy.$registerRangeFormattingSupport(pe,this._transformDocumentSelector(H,W),W.identifier,W.displayName||W.name,K),this._createDisposable(pe)}$provideDocumentRangeFormattingEdits(W,H,X,K,pe){return this._withAdapter(W,q,Ee=>Ee.provideDocumentRangeFormattingEdits(v.URI.revive(H),X,K,pe),void 0,pe)}$provideDocumentRangesFormattingEdits(W,H,X,K,pe){return this._withAdapter(W,q,Ee=>Ee.provideDocumentRangesFormattingEdits(v.URI.revive(H),X,K,pe),void 0,pe)}registerOnTypeFormattingEditProvider(W,H,X,K){const pe=this._addNewAdapter(new ie(this._documents,X),W);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(H,W),K,W.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(W,H,X,K,pe,Ee){return this._withAdapter(W,ie,Me=>Me.provideOnTypeFormattingEdits(v.URI.revive(H),X,K,pe,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(W,H){const X=this._addNewAdapter(new Z(H,this._logService),W);return this._proxy.$registerNavigateTypeSupport(X,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(W,H,X){return this._withAdapter(W,Z,K=>K.provideWorkspaceSymbols(H,X),{symbols:[]},X)}$resolveWorkspaceSymbol(W,H,X){return this._withAdapter(W,Z,K=>K.resolveWorkspaceSymbol(H,X),void 0,void 0)}$releaseWorkspaceSymbols(W,H){this._withAdapter(W,Z,X=>X.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(W,H,X){const K=this._addNewAdapter(new Q(this._documents,X,this._logService),W);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector(H,W),Q.supportsResolving(X)),this._createDisposable(K)}$provideRenameEdits(W,H,X,K,pe){return this._withAdapter(W,Q,Ee=>Ee.provideRenameEdits(v.URI.revive(H),X,K,pe),void 0,pe)}$resolveRenameLocation(W,H,X,K){return this._withAdapter(W,Q,pe=>pe.resolveRenameLocation(v.URI.revive(H),X,K),void 0,K)}registerNewSymbolNamesProvider(W,H,X){const K=this._addNewAdapter(new Y(this._documents,X,this._logService),W);return this._proxy.$registerNewSymbolNamesProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideNewSymbolNames(W,H,X,K){return this._withAdapter(W,Y,pe=>pe.provideNewSymbolNames(v.URI.revive(H),X,K),void 0,K)}registerDocumentSemanticTokensProvider(W,H,X,K){const pe=this._addNewAdapter(new ee(this._documents,X),W),Ee=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(H,W),K,Ee);let Me=this._createDisposable(pe);if(Ee){const Ve=X.onDidChangeSemanticTokens(Ke=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Me=r.Disposable.from(Me,Ve)}return Me}$provideDocumentSemanticTokens(W,H,X,K){return this._withAdapter(W,ee,pe=>pe.provideDocumentSemanticTokens(v.URI.revive(H),X,K),null,K)}$releaseDocumentSemanticTokens(W,H){this._withAdapter(W,ee,X=>X.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,H,X,K){const pe=this._addNewAdapter(new fe(this._documents,X),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(H,W),K),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(W,H,X,K){return this._withAdapter(W,fe,pe=>pe.provideDocumentRangeSemanticTokens(v.URI.revive(H),X,K),null,K)}registerCompletionItemProvider(W,H,X,K){const pe=this._addNewAdapter(new re(this._documents,this._commands.converter,X,this._apiDeprecation,W),W);return this._proxy.$registerCompletionsProvider(pe,this._transformDocumentSelector(H,W),K,re.supportsResolving(X),W.identifier),this._createDisposable(pe)}$provideCompletionItems(W,H,X,K,pe){return this._withAdapter(W,re,Ee=>Ee.provideCompletionItems(v.URI.revive(H),X,K,pe),void 0,pe)}$resolveCompletionItem(W,H,X){return this._withAdapter(W,re,K=>K.resolveCompletionItem(H,X),void 0,X)}$releaseCompletionItems(W,H){this._withAdapter(W,re,X=>X.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(W,H,X,K){const pe=new B(W,this._documents,X,this._commands.converter),Ee=this._addNewAdapter(pe,W);return this._proxy.$registerInlineCompletionsSupport(Ee,this._transformDocumentSelector(H,W),pe.supportsHandleEvents,i.ExtensionIdentifier.toKey(W.identifier.value),K?.yieldTo?.map(Me=>i.ExtensionIdentifier.toKey(Me))||[]),this._createDisposable(Ee)}$provideInlineCompletions(W,H,X,K,pe){return this._withAdapter(W,G,Ee=>Ee.provideInlineCompletions(v.URI.revive(H),X,K,pe),void 0,pe)}$handleInlineCompletionDidShow(W,H,X,K){this._withAdapter(W,G,async pe=>{pe.handleDidShowCompletionItem(H,X,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,H,X,K){this._withAdapter(W,G,async pe=>{pe.handlePartialAccept(H,X,K)},void 0,void 0)}$freeInlineCompletionsList(W,H){this._withAdapter(W,G,async X=>{X.disposeCompletions(H)},void 0,void 0)}registerInlineEditProvider(W,H,X){const K=new se(W,this._documents,X,this._commands.converter),pe=this._addNewAdapter(K,W);return this._proxy.$registerInlineEditProvider(pe,this._transformDocumentSelector(H,W),W.identifier),this._createDisposable(pe)}$provideInlineEdit(W,H,X,K){return this._withAdapter(W,se,pe=>pe.provideInlineEdits(v.URI.revive(H),X,K),void 0,K)}$freeInlineEdit(W,H){this._withAdapter(W,se,async X=>{X.disposeEdit(H)},void 0,void 0)}registerSignatureHelpProvider(W,H,X,K){const pe=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,Ee=this._addNewAdapter(new le(this._documents,X),W);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(H,W),pe),this._createDisposable(Ee)}$provideSignatureHelp(W,H,X,K,pe){return this._withAdapter(W,le,Ee=>Ee.provideSignatureHelp(v.URI.revive(H),X,K,pe),void 0,pe)}$releaseSignatureHelp(W,H){this._withAdapter(W,le,X=>X.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(W,H,X){const K=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new de(this._documents,this._commands.converter,X,this._logService,W),W);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(H,W),typeof X.resolveInlayHint=="function",K,Oe._extLabel(W));let Ee=this._createDisposable(pe);if(K!==void 0){const Me=X.onDidChangeInlayHints(Ve=>this._proxy.$emitInlayHintsEvent(K));Ee=r.Disposable.from(Ee,Me)}return Ee}$provideInlayHints(W,H,X,K){return this._withAdapter(W,de,pe=>pe.provideInlayHints(v.URI.revive(H),X,K),void 0,K)}$resolveInlayHint(W,H,X){return this._withAdapter(W,de,K=>K.resolveInlayHint(H,X),void 0,X)}$releaseInlayHints(W,H){this._withAdapter(W,de,X=>X.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(W,H,X){const K=this._addNewAdapter(new ce(this._documents,X),W);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector(H,W),typeof X.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(W,H,X){return this._withAdapter(W,ce,K=>K.provideLinks(v.URI.revive(H),X),void 0,X,H.scheme==="output")}$resolveDocumentLink(W,H,X){return this._withAdapter(W,ce,K=>K.resolveLink(H,X),void 0,void 0,!0)}$releaseDocumentLinks(W,H){this._withAdapter(W,ce,X=>X.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(W,H,X){const K=this._addNewAdapter(new he(this._documents,X),W);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideDocumentColors(W,H,X){return this._withAdapter(W,he,K=>K.provideColors(v.URI.revive(H),X),[],X)}$provideColorPresentations(W,H,X,K){return this._withAdapter(W,he,pe=>pe.provideColorPresentations(v.URI.revive(H),X,K),void 0,K)}registerFoldingRangeProvider(W,H,X){const K=this._nextHandle(),pe=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new Te(new V(this._documents,X),W)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector(H,W),W.identifier,pe);let Ee=this._createDisposable(K);if(pe!==void 0){const Me=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));Ee=r.Disposable.from(Ee,Me)}return Ee}$provideFoldingRanges(W,H,X,K){return this._withAdapter(W,V,pe=>pe.provideFoldingRanges(v.URI.revive(H),X,K),void 0,K)}registerSelectionRangeProvider(W,H,X){const K=this._addNewAdapter(new J(this._documents,X,this._logService),W);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideSelectionRanges(W,H,X,K){return this._withAdapter(W,J,pe=>pe.provideSelectionRanges(v.URI.revive(H),X,K),[],K)}registerCallHierarchyProvider(W,H,X){const K=this._addNewAdapter(new ue(this._documents,X),W);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$prepareCallHierarchy(W,H,X,K){return this._withAdapter(W,ue,pe=>Promise.resolve(pe.prepareSession(v.URI.revive(H),X,K)),void 0,K)}$provideCallHierarchyIncomingCalls(W,H,X,K){return this._withAdapter(W,ue,pe=>pe.provideCallsTo(H,X,K),void 0,K)}$provideCallHierarchyOutgoingCalls(W,H,X,K){return this._withAdapter(W,ue,pe=>pe.provideCallsFrom(H,X,K),void 0,K)}$releaseCallHierarchy(W,H){this._withAdapter(W,ue,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(W,H,X){const K=this._addNewAdapter(new ve(this._documents,X),W);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$prepareTypeHierarchy(W,H,X,K){return this._withAdapter(W,ve,pe=>Promise.resolve(pe.prepareSession(v.URI.revive(H),X,K)),void 0,K)}$provideTypeHierarchySupertypes(W,H,X,K){return this._withAdapter(W,ve,pe=>pe.provideSupertypes(H,X,K),void 0,K)}$provideTypeHierarchySubtypes(W,H,X,K){return this._withAdapter(W,ve,pe=>pe.provideSubtypes(H,X,K),void 0,K)}$releaseTypeHierarchy(W,H){this._withAdapter(W,ve,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(W,H,X,K){const pe=this._nextHandle();this._adapter.set(pe,new Te(new ke(this._proxy,this._documents,X,pe,W),W));const Ee=(0,a.isProposedApiEnabled)(W,"dropMetadata")&&K?ke.toInternalProviderId(W.identifier.value,K.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(pe,this._transformDocumentSelector(H,W),Ee,(0,a.isProposedApiEnabled)(W,"dropMetadata")?K:void 0),this._createDisposable(pe)}$provideDocumentOnDropEdits(W,H,X,K,pe,Ee){return this._withAdapter(W,ke,Me=>Promise.resolve(Me.provideDocumentOnDropEdits(H,v.URI.revive(X),K,pe,Ee)),void 0,void 0)}registerMappedEditsProvider(W,H,X){const K=this._addNewAdapter(new we(this._documents,X),W);return this._proxy.$registerMappedEditsProvider(K,this._transformDocumentSelector(H,W)),this._createDisposable(K)}$provideMappedEdits(W,H,X,K,pe){return this._withAdapter(W,we,Ee=>Promise.resolve(Ee.provideMappedEdits(H,X,K,pe)),null,pe)}registerDocumentPasteEditProvider(W,H,X,K){const pe=this._nextHandle();this._adapter.set(pe,new Te(new O(this._proxy,this._documents,X,pe,W),W));const Ee=O.toInternalProviderId(W.identifier.value,K.id);return this._proxy.$registerPasteEditProvider(pe,this._transformDocumentSelector(H,W),Ee,{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this._createDisposable(pe)}$prepareDocumentPaste(W,H,X,K,pe){return this._withAdapter(W,O,Ee=>Ee.prepareDocumentPaste(v.URI.revive(H),X,K,pe),void 0,pe)}$providePasteEdits(W,H,X,K,pe,Ee){return this._withAdapter(W,O,Me=>Me.providePasteEdits(H,v.URI.revive(X),K,pe,Ee),void 0,Ee)}static _serializeRegExp(W){return{pattern:W.source,flags:W.flags}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Oe._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Oe._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Oe._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Oe._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Oe._serializeRegExp(W.beforeText),afterText:W.afterText?Oe._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Oe._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Oe._serializeOnEnterRule)}static _serializeAutoClosingPair(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(H=>r.SyntaxTokenType.toString(H)):void 0}}static _serializeAutoClosingPairs(W){return W.map(Oe._serializeAutoClosingPair)}setLanguageConfiguration(W,H,X){const{wordPattern:K}=X;if(K&&(0,L.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor(H,K):this._documents.setWordDefinitionFor(H,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const pe=this._nextHandle(),Ee={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Oe._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Oe._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Oe._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Oe._serializeAutoClosingPairs(X.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(pe,H,Ee),this._createDisposable(pe)}$setWordDefinitions(W){for(const H of W)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=Oe}),define(Ce[332],De([1,0,6,15,7,39,8,3,26]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(I,v,y,_){this._documents=v,this._commands=y,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=I.getProxy(P.MainContext.MainThreadLanguages)}$acceptLanguageIds(I){this._languageIds=I}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(I,v){await this._proxy.$changeLanguage(I,v);const y=this._documents.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,v){const y=I.version,_=F.Position.from(v),l=await this._proxy.$tokensAtPosition(I.uri,_),b={type:p.StandardTokenType.Other,range:I.getWordRangeAtPosition(v)??new p.Range(v.line,v.character,v.line,v.character)};if(!l)return b;const o={range:F.Range.to(l.range),type:F.TokenType.to(l.type)};return!o.range.contains(v)||y!==I.version?b:o}createLanguageStatusItem(I,v,y){const _=this._handlePool++,l=this._proxy,b=this._ids,o=`${I.identifier.value}/${v}`;if(b.has(o))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);b.add(o);const i={selector:y,id:v,name:I.displayName??I.name,severity:p.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new w.DisposableStore,a=()=>{if(n?.dispose(),!b.has(o)){console.warn(`LanguageStatusItem (${v}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.disposableTimeout)(()=>{r.clear(),this._proxy.$setLanguageStatus(_,{id:o,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:F.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===p.LanguageStatusSeverity.Error?R.default.Error:i.severity===p.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this._commands.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),l.$removeLanguageStatus(_),b.delete(o)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,a()},get selector(){return i.selector},set selector(h){i.selector=h,a()},get text(){return i.text},set text(h){i.text=h,a()},set text2(h){(0,E.checkProposedApiEnabled)(I,"languageStatusText"),i.text=h,a()},get text2(){return(0,E.checkProposedApiEnabled)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,a()},get severity(){return i.severity},set severity(h){i.severity=h,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,a()},get command(){return i.command},set command(h){i.command=h,a()},get busy(){return i.busy},set busy(h){i.busy=h,a()}};return a(),t}}e.ExtHostLanguages=C}),define(Ce[333],De([1,0,16,2,15,7,118]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class w{constructor(I,v,y,_){this.start=I,this.deletedCount=v,this.deletedItems=y,this.items=_}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,v,y){this.notebook=I,this._extHostDocument=v,this._cellData=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this._outputs=y.outputs.map(p.NotebookCellOutput.to),this._internalMetadata=y.internalMetadata??{},this._metadata=Object.freeze(y.metadata??{}),this._previousResult=Object.freeze(p.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:p.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return I._mime},set mime(_){I._mime=_},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(y)}return this._apiCell}setOutputs(I){this._outputs=I.map(p.NotebookCellOutput.to)}setOutputItems(I,v,y){const _=y.map(p.NotebookCellOutputItem.to),l=this._outputs.find(b=>b.id===I);if(l&&(v||(l.items.length=0),l.items.push(..._),l.items.length>1&&l.items.every(b=>A.isTextStreamMime(b.mime)))){const b=new Map,o=[];l.items.forEach(i=>{let n;b.has(i.mime)?n=b.get(i.mime):(n=[],b.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),l.items.length=0,o.forEach(i=>{const n=A.compressOutputItemStreams(b.get(i));l.items.push({mime:i,data:n.data.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(p.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=E;class C{static{this._handlePool=0}constructor(I,v,y,_,l){this._proxy=I,this._textDocumentsAndEditors=v,this._textDocuments=y,this.uri=_,this.handle=C._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0,void 0),this._versionId=l.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const I=this,v={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===P.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(y){return y=I._validateIndex(y),I._cells[y].apiCell},getCells(y){return(y?I._getCells(y):I._cells).map(l=>l.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(v)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,v,y){this._versionId=I.versionId,this._isDirty=v,this.acceptDocumentPropertiesChanged({metadata:y});const _={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},l=[];for(const o of I.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,_.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,_.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),l.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),l.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),l.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),l.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),l.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const b=new Map;for(let o=0;o<l.length;o++){const i=l[o],n=b.get(i.cell);if(n===void 0){const r=_.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});b.set(i.cell,r-1)}else _.cellChanges[n]={..._.cellChanges[n],...i}}return Object.freeze(_),Object.freeze(_.cellChanges),Object.freeze(_.contentChanges),_}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let v=I.start|0,y=I.end|0;return v<0&&(v=0),y>this._cells.length&&(y=this._cells.length),I.with({start:v,end:y})}_getCells(I){I=this._validateRange(I);const v=[];for(let y=I.start;y<I.end;y++)v.push(this._cells[y]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,v,y){if(this._disposed)return;const _=[],l=[],b=[];if(I.reverse().forEach(o=>{const n=o[2].map(t=>{const h=new E(this,this._textDocumentsAndEditors,t);return v||l.push(E.asModelAddData(t)),h}),r=new w(o[0],o[1],[],n),a=this._cells.splice(o[0],o[1],...n);for(const t of a)b.push(t.uri),r.deletedItems.push(t.apiCell);_.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:b}),y)for(const o of _)y.push(o.asApiEvent())}_moveCells(I,v,y,_){const l=this._cells.splice(I,v);this._cells.splice(y,0,...l);const b=[new w(I,v,l.map(o=>o.apiCell),[]),new w(y,0,[],l)];for(const o of b)_.push(o.asApiEvent())}_setCellOutputs(I,v){this._cells[I].setOutputs(v)}_setCellOutputItems(I,v,y,_){this._cells[I].setOutputItems(v,y,_)}_changeCellLanguage(I,v){const y=this._cells[I];y.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelLanguageChanged(y.uri,v)}_changeCellMime(I,v){const y=this._cells[I];y.apiCell.mime=v}_changeCellMetadata(I,v){this._cells[I].setMetadata(v)}_changeCellInternalMetadata(I,v){this._cells[I].setInternalMetadata(v)}getCellFromApiCell(I){return this._cells.find(v=>v.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(v=>v.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=C}),define(Ce[334],De([1,0,4,2,15,7]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(E,C,L,I={timeout:1500,errors:3}){this._logService=E,this._notebooksAndEditors=C,this._mainThreadBulkEdits=L,this._thresholds=I,this._onWillSaveNotebookDocumentEvent=new P.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(C,L,I)=>{const v=function(_){C.call(L,_)};return v.extension=E,this._onWillSaveNotebookDocumentEvent.event(v,void 0,I)}}async $participateInSave(E,C,L){const I=F.URI.revive(E),v=this._notebooksAndEditors.getNotebookDocument(I);if(!v)throw new Error("Unable to resolve notebook document");const y=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:v.apiNotebook,reason:p.TextDocumentSaveReason.to(C)},L,async(l,b)=>{const o=Date.now(),i=await await Promise.resolve(l);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",b.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof R.WorkspaceEdit?y.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",b.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(y.length===0)return!0;const _={edits:[]};for(const l of y){const{edits:b}=p.WorkspaceEdit.from(l);_.edits=_.edits.concat(b)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(_)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(Ce[150],De([1,0,14,15,7]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,E,C,L,I,v){this.id=w,this._proxy=E,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=L,this._viewColumn=v}get apiEditor(){if(!this._editor){const w=this;this._editor={get notebook(){return w.notebookData.apiNotebook},get selection(){return w._selections[0]},set selection(E){this.selections=[E]},get selections(){return w._selections},set selections(E){if(!Array.isArray(E)||!E.every(p.NotebookRange.isNotebookRange))throw(0,P.illegalArgument)("selections");w._selections=E,w._trySetSelections(E)},get visibleRanges(){return w._visibleRanges},revealRange(E,C){w._proxy.$tryRevealRange(w.id,F.NotebookRange.from(E),C??p.NotebookEditorRevealType.Default)},get viewColumn(){return w._viewColumn}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(w){this._visible=w}_acceptVisibleRanges(w){this._visibleRanges=w}_acceptSelections(w){this._selections=w}_trySetSelections(w){this._proxy.$trySetSelections(this.id,w.map(F.NotebookRange.from))}_acceptViewColumn(w){this._viewColumn=w}}e.ExtHostNotebookEditor=R}),define(Ce[335],De([1,0,4,13,15]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(w,E){this._logService=w,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new P.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new P.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(w,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,E);const C=this._notebooksAndEditors.getEditorById(w);E.visibleRanges&&C._acceptVisibleRanges(E.visibleRanges.ranges.map(p.NotebookRange.to)),E.selections&&C._acceptSelections(E.selections.selections.map(p.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const E in w)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(p.ViewColumn.to(w[E]))}};e.ExtHostNotebookEditors=R,e.ExtHostNotebookEditors=R=Ge([He(0,F.ILogService)],R)}),define(Ce[336],De([1,0,4,6,150]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(w,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=w.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(w,E,C){const L=this._extHostNotebook.getEditorById(w);this._rendererMessageEmitters.get(E)?.fire({editor:L.apiEditor,message:C})}createRendererMessaging(w,E){if(!w.contributes?.notebookRenderer?.some(L=>L.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(L,I,v)=>this.getOrCreateEmitterFor(E).event(L,I,v),postMessage:(L,I)=>{p.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const v=I&&p.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(v?.id,E,L)}}}getOrCreateEmitterFor(w){let E=this._rendererMessageEmitters.get(w);return E||(E=new P.Emitter({onDidRemoveLastListener:()=>{E?.dispose(),this._rendererMessageEmitters.delete(w)}}),this._rendererMessageEmitters.set(w,E),E)}}e.ExtHostNotebookRenderers=R}),define(Ce[337],De([1,0,15,107,22,53,14]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}async withProgress(I,v,y){const _=this._handles++,{title:l,location:b,cancellable:o}=v,i={label:I.displayName||I.name,id:I.identifier.value};return this._proxy.$startProgress(_,{location:P.ProgressLocation.from(b),title:l,source:i,cancellable:o},I.isUnderDevelopment?void 0:I.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(_,y,!!o)}_withProgress(I,v,y){let _;y&&(_=new p.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,_));const l=o=>{this._proxy.$progressEnd(o),this._mapHandleToCancellationSource.delete(o),_?.dispose()};let b;try{b=v(new C(this._proxy,I),y&&_?_.token:p.CancellationToken.None)}catch(o){throw l(I),o}return b.then(o=>l(I),o=>l(I)),b}$acceptProgressCanceled(I){const v=this._mapHandleToCancellationSource.get(I);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=w;function E(L,I){return L.message=I.message,typeof I.increment=="number"&&(typeof L.increment=="number"?L.increment+=I.increment:L.increment=I.increment),L}class C extends F.Progress{constructor(I,v){super(y=>this.throttledReport(y)),this._proxy=I,this._handle=v}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ge([(0,R.throttle)(100,(L,I)=>E(L,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Ce[338],De([1,0,2,6,8,15]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(E,C){this.uriTransformer=C,this.providers=new Map,this.proxy=E.getProxy(F.MainContext.MainThreadQuickDiff)}$provideOriginalResource(E,C,L){const I=P.URI.revive(C),v=this.providers.get(E);return v?(0,p.asPromise)(()=>v.provideOriginalResource(I,L)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,C,L,I){const v=A.handlePool++;return this.providers.set(v,C),this.proxy.$registerQuickDiffProvider(v,R.DocumentSelector.from(E,this.uriTransformer),L,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(v),this.providers.delete(v)}}}}e.ExtHostQuickDiff=A}),define(Ce[339],De([1,0,22,4,3,6,2,7,14,19,39,55,26,15]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(l,b,o){const i=l.getProxy(R.MainContext.MainThreadQuickOpen);class n{constructor(m,D){this._sessions=new Map,this._instances=0,this._workspace=m,this._commands=D}showQuickPick(m,D,g,f=P.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(D),T=++this._instances,N=i.$show(T,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},f),z={},x=N.then(()=>z);return Promise.race([x,S]).then(M=>{if(M===z)return;const k=(0,v.isProposedApiEnabled)(m,"quickPickItemTooltip");return S.then(O=>{const U=[];for(let q=0;q<O.length;q++){const ie=O[q];if(typeof ie=="string")U.push({label:ie,handle:q});else if(ie.kind===w.QuickPickItemKind.Separator)U.push({type:"separator",label:ie.label});else{ie.tooltip&&!k&&console.warn(`Extension '${m.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`);const Z=ie.iconPath?u(ie.iconPath):void 0;U.push({label:ie.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:k?y.MarkdownString.fromStrict(ie.tooltip):void 0,handle:q})}}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{g.onDidSelectItem(O[q])}),i.$setItems(T,U),N.then(q=>{if(typeof q=="number")return O[q];if(Array.isArray(q))return q.map(ie=>O[ie])})})}).then(void 0,M=>{if(!(0,E.isCancellationError)(M))return i.$setError(T,M),Promise.reject(M)})}$onItemSelected(m){this._onDidSelectItem?.(m)}showInput(m,D=P.CancellationToken.None){return this._validateInput=m?.validateInput,i.$input(m,typeof this._validateInput=="function",D).then(void 0,g=>{if(!(0,E.isCancellationError)(g))return Promise.reject(g)})}async $validateInput(m){if(!this._validateInput)return;const D=await this._validateInput(m);if(!D||typeof D=="string")return D;let g;switch(D.severity){case w.InputBoxValidationSeverity.Info:g=L.default.Info;break;case w.InputBoxValidationSeverity.Warning:g=L.default.Warning;break;case w.InputBoxValidationSeverity.Error:g=L.default.Error;break;default:g=D.message?L.default.Error:L.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(m,D=P.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!g)return;const f=await this._workspace.getWorkspaceFolders2();if(f)return f.find(S=>S.uri.toString()===g.uri.toString())}createQuickPick(m){const D=new s(m,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(m){const D=new c(m,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}$onDidChangeValue(m,D){this._sessions.get(m)?._fireDidChangeValue(D)}$onDidAccept(m){this._sessions.get(m)?._fireDidAccept()}$onDidChangeActive(m,D){const g=this._sessions.get(m);g instanceof s&&g._fireDidChangeActive(D)}$onDidChangeSelection(m,D){const g=this._sessions.get(m);g instanceof s&&g._fireDidChangeSelection(D)}$onDidTriggerButton(m,D){this._sessions.get(m)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(m,D,g){const f=this._sessions.get(m);f instanceof s&&f._fireDidTriggerItemButton(D,g)}$onDidHide(m){this._sessions.get(m)?._fireDidHide()}}class r{static{this._nextId=1}constructor(m,D){this._extensionId=m,this._onDidDispose=D,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new F.Emitter,this._onDidChangeValueEmitter=new F.Emitter,this._onDidTriggerButtonEmitter=new F.Emitter,this._onDidHideEmitter=new F.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(m){this._title=m,this.update({title:m})}get step(){return this._steps}set step(m){this._steps=m,this.update({step:m})}get totalSteps(){return this._totalSteps}set totalSteps(m){this._totalSteps=m,this.update({totalSteps:m})}get enabled(){return this._enabled}set enabled(m){this._enabled=m,this.update({enabled:m})}get busy(){return this._busy}set busy(m){this._busy=m,this.update({busy:m})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(m){this._ignoreFocusOut=m,this.update({ignoreFocusOut:m})}get value(){return this._value}set value(m){this._value=m,this.update({value:m})}get placeholder(){return this._placeholder}set placeholder(m){this._placeholder=m,this.update({placeholder:m})}get buttons(){return this._buttons}set buttons(m){this._buttons=m.slice(),this._handlesToButtons.clear(),m.forEach((D,g)=>{const f=D===w.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(f,D)}),this.update({buttons:m.map((D,g)=>({...u(D.iconPath),tooltip:D.tooltip,handle:D===w.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(m){this._value=m,this._onDidChangeValueEmitter.fire(m)}_fireDidTriggerButton(m){const D=this._handlesToButtons.get(m);D&&this._onDidTriggerButtonEmitter.fire(D)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,p.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),i.$dispose(this._id))}update(m){if(!this._disposed){for(const D of Object.keys(m)){const g=m[D];this._pendingUpdate[D]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){i.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function a(d){if(d instanceof w.ThemeIcon)return{id:d.id};const m=h(d),D=t(d);return{dark:typeof m=="string"?A.URI.file(m):m,light:typeof D=="string"?A.URI.file(D):D}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function h(d){return typeof d=="object"&&"dark"in d?d.dark:d}function u(d){const m=a(d);let D,g;return"id"in m?g=I.ThemeIcon.asClassName(m):D=m,{iconPath:D,iconClass:g}}class s extends r{constructor(m,D){super(m.identifier,D),this.extension=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new F.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new F.Emitter,this._onDidTriggerItemButtonEmitter=new F.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(m){this._items=m.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),m.forEach((f,S)=>{this._handlesToItems.set(S,f),this._itemsToHandles.set(f,S)});const D=(0,v.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),g=[];for(let f=0;f<m.length;f++){const S=m[f];if(S.kind===w.QuickPickItemKind.Separator)g.push({type:"separator",label:S.label});else{S.tooltip&&!D&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const T=S.iconPath?u(S.iconPath):void 0;g.push({handle:f,label:S.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((N,z)=>({...u(N.iconPath),tooltip:N.tooltip,handle:z}))})}}this.update({items:g})}get canSelectMany(){return this._canSelectMany}set canSelectMany(m){this._canSelectMany=m,this.update({canSelectMany:m})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(m){this._matchOnDescription=m,this.update({matchOnDescription:m})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(m){this._matchOnDetail=m,this.update({matchOnDetail:m})}get sortByLabel(){return this._sortByLabel}set sortByLabel(m){this._sortByLabel=m,this.update({sortByLabel:m})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(m){this._keepScrollPosition=m,this.update({keepScrollPosition:m})}get activeItems(){return this._activeItems}set activeItems(m){this._activeItems=m.filter(D=>this._itemsToHandles.has(D)),this.update({activeItems:this._activeItems.map(D=>this._itemsToHandles.get(D))})}get selectedItems(){return this._selectedItems}set selectedItems(m){this._selectedItems=m.filter(D=>this._itemsToHandles.has(D)),this.update({selectedItems:this._selectedItems.map(D=>this._itemsToHandles.get(D))})}_fireDidChangeActive(m){const D=(0,C.coalesce)(m.map(g=>this._handlesToItems.get(g)));this._activeItems=D,this._onDidChangeActiveEmitter.fire(D)}_fireDidChangeSelection(m){const D=(0,C.coalesce)(m.map(g=>this._handlesToItems.get(g)));this._selectedItems=D,this._onDidChangeSelectionEmitter.fire(D)}_fireDidTriggerItemButton(m,D){const g=this._handlesToItems.get(m);if(!g||!g.buttons||!g.buttons.length)return;const f=g.buttons[D];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:g})}}class c extends r{constructor(m,D){super(m.identifier,D),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(m){this._password=m,this.update({password:m})}get prompt(){return this._prompt}set prompt(m){this._prompt=m,this.update({prompt:m})}get valueSelection(){return this._valueSelection}set valueSelection(m){this._valueSelection=m,this.update({valueSelection:m})}get validationMessage(){return this._validationMessage}set validationMessage(m){this._validationMessage=m,m?typeof m=="string"?this.update({validationMessage:m,severity:L.default.Error}):this.update({validationMessage:m.message,severity:m.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new n(b,o)}e.createExtHostQuickOpen=_}),define(Ce[340],De([1,0,2,4,53,3,8,6,19,128,13,25,55,15,26,16,11]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(T){return T instanceof P.URI}function n(T,N){return T.scheme===l.Schemas.file&&N.scheme===l.Schemas.file&&b.isLinux?T.toString()===N.toString():T.toString().toLowerCase()===N.toString().toLowerCase()}function r(T){if(T)return typeof T.iconPath=="string"?P.URI.file(T.iconPath):P.URI.isUri(T.iconPath)||v.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function a(T){if(T.icon){if(P.URI.isUri(T.icon))return T.icon;if(v.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const N=T.icon;return{light:N.light,dark:N.dark}}}else return}function t(T,N){if(!T.iconPath&&!N.iconPath)return 0;if(T.iconPath){if(!N.iconPath)return 1}else return-1;const z=typeof T.iconPath=="string"?T.iconPath:P.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,x=typeof N.iconPath=="string"?N.iconPath:P.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,C.comparePaths)(z,x)}function h(T,N){let z=0;if(T.strikeThrough!==N.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==N.faded)return T.faded?1:-1;if(T.tooltip!==N.tooltip)return(T.tooltip||"").localeCompare(N.tooltip||"");if(z=t(T,N),z!==0)return z;if(T.light&&N.light)z=t(T.light,N.light);else{if(T.light)return 1;if(N.light)return-1}if(z!==0)return z;if(T.dark&&N.dark)z=t(T.dark,N.dark);else{if(T.dark)return 1;if(N.dark)return-1}return z}function u(T,N){if(T.command!==N.command)return T.command<N.command?-1:1;if(T.title!==N.title)return T.title<N.title?-1:1;if(T.tooltip!==N.tooltip){if(T.tooltip!==void 0&&N.tooltip!==void 0)return T.tooltip<N.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(T.arguments===N.arguments)return 0;if(T.arguments)if(N.arguments){if(T.arguments.length!==N.arguments.length)return T.arguments.length-N.arguments.length}else return 1;else return-1;for(let z=0;z<T.arguments.length;z++){const x=T.arguments[z],M=N.arguments[z];if(x!==M&&!(i(x)&&i(M)&&n(x,M)))return x<M?-1:1}return 0}function s(T,N){let z=(0,C.comparePaths)(T.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(z!==0)return z;if(T.command&&N.command)z=u(T.command,N.command);else{if(T.command)return 1;if(N.command)return-1}if(z!==0)return z;if(T.decorations&&N.decorations)z=h(T.decorations,N.decorations);else{if(T.decorations)return 1;if(N.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)z=(0,C.comparePaths)(T.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)z=(0,C.comparePaths)(T.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return z}function c(T,N){for(let z=0;z<T.length;z++)if(T[z]!==N[z])return!1;return!0}function d(T,N){return T.command===N.command&&T.title===N.title&&T.tooltip===N.tooltip&&(T.arguments&&N.arguments?c(T.arguments,N.arguments):T.arguments===N.arguments)}function m(T,N){return(0,E.equals)(T,N,d)}class D{#e;#t;get value(){return this._value}set value(N){N=N??"",this.#e.$setInputBoxValue(this._sourceControlHandle,N),this.updateValue(N)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(N){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,N),this._placeholder=N}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(N){if((0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=N,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!N)}get enabled(){return this._enabled}set enabled(N){N=!!N,this._enabled!==N&&(this._enabled=N,this.#e.$setInputBoxEnablement(this._sourceControlHandle,N))}get visible(){return this._visible}set visible(N){N=!!N,this._visible!==N&&(this._visible=N,this.#e.$setInputBoxVisibility(this._sourceControlHandle,N))}get document(){return(0,_.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(N,z,x,M,k){this._extension=N,this._sourceControlHandle=M,this._documentUri=k,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=z,this.#e=x}showValidationMessage(N,z){(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,N,z)}$onInputBoxValueChange(N){this.updateValue(N)}updateValue(N){this._value=N,this._onDidChange.fire(N)}}e.ExtHostSCMInputBox=D;class g{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(N){this._label=N,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,N)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(N){this._hideWhenEmpty=N,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(N){this._resourceStates=[...N],this._onDidUpdateResourceStates.fire()}constructor(N,z,x,M,k,O,U){this._proxy=N,this._commands=z,this._sourceControlHandle=x,this._id=M,this._label=k,this.multiDiffEditorEnableViewChanges=O,this._extension=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=g._handlePool++}getResourceState(N){return this._resourceStatesMap.get(N)}$executeResourceCommand(N,z){const x=this._resourceStatesCommandsMap.get(N);return x?(0,A.asPromise)(()=>this._commands.executeCommand(x.command,...x.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this._resourceStates].sort(s),x=(0,E.sortedDiff)(this._resourceSnapshot,N,s).map(O=>{const U=O.toInsert.map(q=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,q);const Z=q.resourceUri;let Q;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"||q.command.command==="vscode.changes"){const he=new R.DisposableStore;Q=this._commands.converter.toInternal(q.command,he),this._resourceStatesDisposablesMap.set(ie,he)}else this._resourceStatesCommandsMap.set(ie,q.command);const Y=(0,_.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),ae=Y?q.multiDiffEditorOriginalUri:void 0,ee=Y?q.multiFileDiffEditorModifiedUri:void 0,fe=r(q.decorations),re=q.decorations&&r(q.decorations.light)||fe,G=q.decorations&&r(q.decorations.dark)||fe,B=[re,G],se=q.decorations&&q.decorations.tooltip||"",ye=q.decorations&&!!q.decorations.strikeThrough,le=q.decorations&&!!q.decorations.faded,de=q.contextValue||"";return{rawResource:[ie,Z,B,se,ye,le,de,Q,ae,ee],handle:ie}});return{start:O.start,deleteCount:O.deleteCount,toInsert:U}}),M=x.map(({start:O,deleteCount:U,toInsert:q})=>[O,U,q.map(ie=>ie.rawResource)]),k=x.reverse();for(const{start:O,deleteCount:U,toInsert:q}of k){const ie=q.map(Q=>Q.handle),Z=this._handlesSnapshot.splice(O,U,...ie);for(const Q of Z)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=N,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class f{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(N){this._count!==N&&(this._count=N,this.#e.$updateSourceControl(this.handle,{count:N}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(N){this._quickDiffProvider=N;let z;(0,_.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(z=N?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!N,quickDiffLabel:z})}get historyProvider(){return(0,_.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(N){(0,_.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=N,this._historyProviderDisposable.value=new R.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!N}),N&&this._historyProviderDisposable.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(N){N!==this._commitTemplate&&(this._commitTemplate=N,this.#e.$updateSourceControl(this.handle,{commitTemplate:N}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(N){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=N;const z=this._commands.converter.toInternal(N,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:z})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(N){(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=N;const z=N!==void 0?{command:this._commands.converter.toInternal(N.command,this._actionButtonDisposables.value),secondaryCommands:N.secondaryCommands?.map(x=>x.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:z??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(N){if(this._statusBarCommands&&N&&m(this._statusBarCommands,N))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=N;const z=(N||[]).map(x=>this._commands.converter.toInternal(x,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:z})}get selected(){return this._selected}constructor(N,z,x,M,k,O,U){this._extension=N,this._commands=M,this._id=k,this._label=O,this._rootUri=U,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new R.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new R.MutableDisposable,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=x;const q=P.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${k}/scm${this.handle}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this._inputBox=new D(N,z,this.#e,this.handle,q),this.#e.$registerSourceControl(this.handle,k,O,U,q)}createResourceGroup(N,z,x){const M=(0,_.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,k=new g(this.#e,this._commands,this.handle,N,z,M,this._extension),O=F.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,O),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const N=[],z=[];for(const[x,M]of this.createdResourceGroups){M.dispose();const k=x.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(x),this.eventuallyUpdateResourceStates()});F.Event.once(x.onDidDispose)(()=>{this.updatedResourceGroups.delete(x),k.dispose(),this._groups.delete(x.handle),this.#e.$unregisterGroup(this.handle,x.handle)}),N.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const O=x._takeResourceStateSnapshot();O.length>0&&z.push([x.handle,O]),this._groups.set(x.handle,x)}this.#e.$registerGroups(this.handle,N,z),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const N=[];this.updatedResourceGroups.forEach(z=>{const x=z._takeResourceStateSnapshot();x.length!==0&&N.push([z.handle,x])}),N.length>0&&this.#e.$spliceResourceStates(this.handle,N),this.updatedResourceGroups.clear()}getResourceGroup(N){return this._groups.get(N)}setSelectionState(N){this._selected=N,this._onDidChangeSelection.fire(N)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ge([(0,p.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),Ge([(0,p.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{o=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(N,z,x,M){this._commands=z,this._extHostDocuments=x,this.logService=M,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=N.getProxy(w.MainContext.MainThreadSCM),this._telemetry=N.getProxy(w.MainContext.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const O=this._sourceControls.get(k.sourceControlHandle);if(!O)return k;const U=O.getResourceGroup(k.groupHandle);return U?U.getResourceState(k.handle):k}else if(k&&k.$mid===4){const O=this._sourceControls.get(k.sourceControlHandle);return O?O.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const O=this._sourceControls.get(k.handle);return O||k}return k}})}createSourceControl(N,z,x,M){this.logService.trace("ExtHostSCM#createSourceControl",N.identifier.value,z,x,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const k=o._handlePool++,O=new f(N,this._extHostDocuments,this._proxy,this._commands,z,x,M);this._sourceControls.set(k,O);const U=this._sourceControlsByExtension.get(N.identifier)||[];return U.push(O),this._sourceControlsByExtension.set(N.identifier,U),O}getLastInputBox(N){this.logService.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const z=this._sourceControlsByExtension.get(N.identifier),x=z&&z[z.length-1];return x&&x.inputBox}$provideOriginalResource(N,z,x){const M=P.URI.revive(z);this.logService.trace("ExtHostSCM#$provideOriginalResource",N,M.toString());const k=this._sourceControls.get(N);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(M,x)).then(O=>O||null)}$onInputBoxValueChange(N,z){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",N);const x=this._sourceControls.get(N);return x&&x.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(N,z,x,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",N,z,x);const k=this._sourceControls.get(N);if(!k)return Promise.resolve(void 0);const O=k.getResourceGroup(z);return O?O.$executeResourceCommand(x,M):Promise.resolve(void 0)}$validateInput(N,z,x){this.logService.trace("ExtHostSCM#$validateInput",N);const M=this._sourceControls.get(N);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>M.inputBox.validateInput(z,x)).then(k=>{if(!k)return Promise.resolve(void 0);const O=y.MarkdownString.fromStrict(k.message);return O?Promise.resolve([O,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this._sourceControls.get(N)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,z,x,M){return await this._sourceControls.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,x,M)??void 0}async $provideHistoryItems(N,z,x,M){return(await this._sourceControls.get(N)?.historyProvider?.provideHistoryItems(z,x,M))?.map(U=>({...U,icon:a(U)}))??void 0}async $provideHistoryItemSummary(N,z,x,M){const k=this._sourceControls.get(N)?.historyProvider;if(typeof k?.provideHistoryItemSummary!="function")return;const O=await k.provideHistoryItemSummary(z,x,M);return O?{...O,icon:a(O)}:void 0}async $provideHistoryItemChanges(N,z,x,M){return await this._sourceControls.get(N)?.historyProvider?.provideHistoryItemChanges(z,x,M)??void 0}};e.ExtHostSCM=S,e.ExtHostSCM=S=o=Ge([He(3,L.ILogService)],S)}),define(Ce[341],De([1,0,6,15,2]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class R{static{this.handlePool=0}constructor(w,E){this.uriTransformer=E,this.providers=new Map,this.proxy=w.getProxy(P.MainContext.MainThreadShare)}async $provideShare(w,E,C){return await this.providers.get(w)?.provideShare({selection:F.Range.to(E.selection),resourceUri:p.URI.revive(E.resourceUri)},C)??void 0}registerShareProvider(w,E){const C=R.handlePool++;return this.providers.set(C,E),this.proxy.$registerShareProvider(C,F.DocumentSelector.from(w,this.uriTransformer),E.id,E.label,E.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(C),this.providers.delete(C)}}}}e.ExtHostShare=R}),define(Ce[342],De([1,0,7,6,218,3,15,18]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class E{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new P.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new P.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(v,y,_,l,b,o=P.StatusBarAlignment.Left,i){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new R.DisposableStore,this.#e=v,this.#t=y,b&&l){this._entryId=(0,P.asStatusBarItemIdentifier)(l.identifier,b);const n=_.get(this._entryId);n&&(o=n.alignLeft?P.StatusBarAlignment.Left:P.StatusBarAlignment.Right,i=n.priority,this._visible=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this._entryId=String(E.ID_GEN++);this._extension=l,this._id=b,this._alignment=o,this._priority=this.validatePriority(i)}validatePriority(v){if((0,w.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!E.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new R.DisposableStore,typeof v=="string"?this._command={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this._latestCommandRegistration)}:v?this._command={fromApi:v,internal:this.#t.toInternal(v,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let y;this._name?y=this._name:y=(0,p.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=E.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const l=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,v,this._extension?.identifier.value,y,this._text,l,this._command?.internal,_,this._backgroundColor,this._alignment===P.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=E;class C{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",P.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,p.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const y={message:v};return this._messages.unshift(y),this._update(),new P.Disposable(()=>{const _=this._messages.indexOf(y);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class L{constructor(v,y){this._existingItems=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadStatusBar),this._commands=y,this._statusMessage=new C(this)}$acceptStaticEntries(v){for(const y of v)this._existingItems.set(y.entryId,y)}createStatusBarEntry(v,y,_,l){return new E(this._proxy,this._commands,this._existingItems,v,y,_,l)}setStatusBarMessage(v,y){const _=this._statusMessage.setMessage(v);let l;return typeof y=="number"?l=setTimeout(()=>_.dispose(),y):typeof y<"u"&&y.then(()=>_.dispose(),()=>_.dispose()),new P.Disposable(()=>{_.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=L}),define(Ce[151],De([1,0,29,141,67,111,89,15,2]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(n,r,a,t)=>{let h=r;return{enumerable:!0,configurable:!1,get(){return h},set(u){if(!a(h,u)){const s=h;h=u,n.listener?.(t(u,s))}}}},L=(n,r)=>n===r,I={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},v=n=>r=>({op:4,update:n(r)}),y=(n,r)=>({range:(()=>{let a;const t=v(h=>({range:P.Range.lift(w.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return a},set(h){n.listener?.({op:6}),I.range(a,h)||(a=h,n.listener?.(t(h)))}}})(),label:C(n,r,I.label,v(a=>({label:a}))),description:C(n,void 0,I.description,v(a=>({description:a}))),sortText:C(n,void 0,I.sortText,v(a=>({sortText:a}))),canResolveChildren:C(n,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:C(n,!1,I.busy,v(a=>({busy:a}))),error:C(n,void 0,I.error,v(a=>({error:w.MarkdownString.fromStrict(a)||null}))),tags:C(n,[],I.tags,(a,t)=>({op:1,new:a.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),_=n=>{const r=p.TestId.fromString(n.extId),a=new b(r.controllerId,r.localId,n.label,E.URI.revive(n.uri)||void 0);return a.range=w.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>w.TestTag.to({id:(0,A.denamespaceTestTag)(t).tagId})),a},l=n=>{let r;for(const a of n.tests){const t=_(a.item);(0,F.getPrivateApiFor)(t).parent=r,r=t}return r};e.toItemFromContext=l;class b{constructor(r,a,t,h){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const u=(0,F.createPrivateApiFor)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof o?void 0:u.parent}},children:{value:(0,R.createTestItemChildren)(u,F.getPrivateApiFor,b),enumerable:!0,writable:!1},...y(u,t)})}}e.TestItemImpl=b;class o extends b{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class i extends R.TestItemCollection{constructor(r,a,t){super({controllerId:r,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:F.getPrivateApiFor,getChildren:h=>h.children,root:new o(r,a),toITestItem:w.TestItem.from})}}e.ExtHostTestItemCollection=i}),define(Ce[33],De([1,0,18,7,15,24,6,19,13,56,29,49,2,3,5,20,151,21,68,40,38,87,90,30]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{#e;#t;#i;constructor(g,f,S){this._commands=new Map,this._apiCommands=new Map,this.#e=g.getProxy(A.MainContext.MainThreadCommands),this._logService=f,this.#i=S,this.#t=g.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new s(this,T=>{const N=this._apiCommands.get(T);return N?.result===d.Void?N:void 0},f),this._argumentProcessors=[{processArgument(T){return(0,C.revive)(T)}},{processArgument(T){return(0,R.cloneAndChange)(T,function(N){if(L.Range.isIRange(N))return p.Range.to(N);if(I.Position.isIPosition(N))return p.Position.to(N);if(L.Range.isIRange(N.range)&&v.URI.isUri(N.uri))return p.location.to(N);if(N instanceof o.VSBuffer)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const f=this.registerCommand(!1,g.id,async(...S)=>{const T=g.args.map((z,x)=>{if(!z.validate(S[x]))throw new Error(`Invalid argument '${z.name}' when running '${g.id}', received: ${typeof S[x]=="object"?JSON.stringify(S[x],null,"	"):S[x]} `);return z.convert(S[x])}),N=await this.executeCommand(g.internalId,...T);return g.result.convert(N,S,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new F.Disposable(()=>{f.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,f,S,T,N,z){if(this._logService.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this._commands.has(f))throw new Error(`command '${f}' already exists`);return this._commands.set(f,{callback:S,thisArg:T,metadata:N,extension:z}),g&&this.#e.$registerCommand(f),new F.Disposable(()=>{this._commands.delete(f)&&g&&this.#e.$unregisterCommand(f)})}executeCommand(g,...f){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,f,!0)}async _doExecuteCommand(g,f,S){if(this._commands.has(g))return this.#e.$fireCommandActivationEvent(g),this._executeContributedCommand(g,f,!1);{let T=!1;const N=(0,R.cloneAndChange)(f,function(z){if(z instanceof F.Position)return p.Position.from(z);if(z instanceof F.Range)return p.Range.from(z);if(z instanceof F.Location)return p.location.from(z);if(F.NotebookRange.isNotebookRange(z))return p.NotebookRange.from(z);if(z instanceof ArrayBuffer)return T=!0,o.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return T=!0,o.VSBuffer.wrap(z);if(z instanceof o.VSBuffer)return T=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(g,T?new i.SerializableObjectWithBuffers(N):N,S);return(0,C.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(g,f,!1);throw z}}}async _executeContributedCommand(g,f,S){const T=this._commands.get(g);if(!T)throw new Error("Unknown command");const{callback:N,thisArg:z,metadata:x}=T;if(x?.args)for(let k=0;k<x.args.length;k++)try{(0,P.validateConstraint)(f[k],x.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${x.args[k].name}' - ${x.args[k].description}`)}const M=r.StopWatch.create();try{return await N.apply(z,f)}catch(k){if(g===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...f);O&&(g=O.command)}if(this._logService.error(k,g,T.extension?.identifier),!S)throw k;if(T.extension?.identifier){const O=this.#i.onExtensionError(T.extension.identifier,k);this._logService.trace("forwarded error to extension?",O,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.toErrorMessage)(k)),this.id=g,this.source=T.extension?.displayName??T.extension?.name}}}finally{this._reportTelemetry(T,g,M.elapsed())}}_reportTelemetry(g,f,S){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new a.TelemetryTrustedValue(f),duration:S})}$executeContributedCommand(g,...f){this._logService.trace("ExtHostCommands#$executeContributedCommand",g);const S=this._commands.get(g);return S?(f=f.map(T=>this._argumentProcessors.reduce((N,z)=>z.processArgument(N,S.extension?.identifier),T)),this._executeContributedCommand(g,f,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(f=>(g&&(f=f.filter(S=>S[0]!=="_")),f))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[f,S]of this._commands){const{metadata:T}=S;T&&(g[f]=T)}return Promise.resolve(g)}};e.ExtHostCommands=u,e.ExtHostCommands=u=Ge([He(0,l.IExtHostRpcService),He(1,E.ILogService),He(2,t.IExtHostTelemetry)],u),e.IExtHostCommands=(0,_.createDecorator)("IExtHostCommands");class s{constructor(g,f,S){this._commands=g,this._lookupApiCommand=f,this._logService=S,this.delegatingCommandId=`__vsc${(0,h.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,f){if(!g)return;const S={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return S;const T=this._lookupApiCommand(g.command);if(T)S.id=T.internalId,S.arguments=T.args.map((N,z)=>N.convert(g.arguments&&g.arguments[z]));else if((0,w.isNonEmptyArray)(g.arguments)){const N=`${g.command} /${++this._cachIdPool}`;this._cache.set(N,g),f.add((0,y.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),S.$ident=N,S.id=this.delegatingCommandId,S.arguments=[N],this._logService.trace("CommandsConverter#CREATE",g.command,N)}return S}fromInternal(g){return typeof g.$ident=="string"?this._cache.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const f=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],f?f.command:"MISSING"),f?this._commands.executeCommand(f.command,...f.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=s;class c{static{this.Uri=new c("uri","Uri of a text document",g=>v.URI.isUri(g),g=>g)}static{this.Position=new c("position","A position in a text document",g=>F.Position.isPosition(g),p.Position.from)}static{this.Range=new c("range","A range in a text document",g=>F.Range.isRange(g),p.Range.from)}static{this.Selection=new c("selection","A selection in a text document",g=>F.Selection.isSelection(g),p.Selection.from)}static{this.Number=new c("number","",g=>typeof g=="number",g=>g)}static{this.String=new c("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=c.Arr(c.String)}static Arr(g){return new c(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,f=>Array.isArray(f)&&f.every(S=>g.validate(S)),f=>f.map(S=>g.convert(S)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",g=>g instanceof F.CallHierarchyItem,p.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",g=>g instanceof F.TypeHierarchyItem,p.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VSCodium TestItem",g=>g instanceof b.TestItemImpl,p.TestItem.from)}constructor(g,f,S,T){this.name=g,this.description=f,this.validate=S,this.convert=T}optional(){return new c(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,f){return new c(g??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c;class d{static{this.Void=new d("no result",g=>g)}constructor(g,f){this.description=g,this.convert=f}}e.ApiCommandResult=d;class m{constructor(g,f,S,T,N){this.id=g,this.internalId=f,this.description=S,this.args=T,this.result=N}}e.ApiCommand=m}),define(Ce[343],De([1,0,19,16,2,83,131,45,33,15,7]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(C.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,b)=>{if((0,P.isFalsyOrEmpty)(l))return;class o extends L.SymbolInformation{static to(n){const r=new o(n.name,C.SymbolKind.to(n.kind),n.containerName||"",new L.Location(b[0],C.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=C.Range.to(n.selectionRange),r.children=n.children?n.children.map(o.to):[],r}}return l.map(o.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(C.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(C.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(C.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(C.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(C.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(b=>L.Position.isPosition(b)),l=>l.map(C.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(b=>{let o;for(const i of b.reverse())o=new L.SelectionRange(C.Range.to(i),o);return o}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(C.WorkspaceSymbol.to))),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(C.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(C.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(C.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:C.Range.to(l.range),placeholder:l.text}})),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return C.WorkspaceEdit.to(l)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(C.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,A.decodeSemanticTokensDto)(l);if(b.type==="full")return new L.SemanticTokens(b.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range.optional()],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,A.decodeSemanticTokensDto)(l);if(b.type==="full")return new L.SemanticTokens(b.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,b,o)=>{if(!l)return new L.CompletionList([]);const i=l.suggestions.map(n=>C.CompletionItem.to(n,o));return new L.CompletionList(i,l.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return C.SignatureHelp.to(l)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,b,o)=>y(i=>new L.CodeLens(C.Range.to(i.range),i.command&&o.fromInternal(i.command)))(l))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.Range.isRange(l),l=>L.Selection.isSelection(l)?C.Selection.from(l):C.Range.from(l)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,b,o)=>y(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new L.CodeAction(i.title,i.kind?new L.CodeActionKind(i.kind):void 0);return i.edit&&(n.edit=C.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(l))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(b=>new L.ColorInformation(C.Range.to(b.range),C.Color.to(b.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",l=>l instanceof L.Color,C.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:C.Range.from(l.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(C.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,b,o)=>l.map(C.InlayHint.to.bind(void 0,o)))),new E.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(l,b)=>{if(l)return l.map(C.FoldingRange.to)})),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(b=>C.NotebookExclusiveDocumentPattern.to(b))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof L.Range,l=>C.InlineValueContext.from(l))],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(C.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new E.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",l=>p.URI.isUri(l)||typeof l=="string"&&(0,F.matchesSomeScheme)(l,F.Schemas.http,F.Schemas.https),l=>l),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[C.ViewColumn.from(l),void 0]:[C.ViewColumn.from(l.viewColumn),C.TextEditorOpenOptions.from(l)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[C.ViewColumn.from(l),void 0]:[C.ViewColumn.from(l.viewColumn),C.TextEditorOpenOptions.from(l)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[C.ViewColumn.from(l.viewColumn),C.TextEditorOpenOptions.from(l)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[E.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new E.ApiCommandArgument("resourceList","List of resources to compare",l=>{for(const b of l){if(b.length!==3)return!1;const[o,i,n]=b;if(!p.URI.isUri(o)||!p.URI.isUri(i)&&i!==void 0&&i!==null||!p.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(C.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(C.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(C.TypeHierarchyItem.to))),new E.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[E.ApiCommandArgument.TestItem],E.ApiCommandResult.Void),new E.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[E.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],E.ApiCommandResult.Void),new E.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[E.ApiCommandArgument.String.with("name","The context key name"),new E.ApiCommandArgument("value","The context key value",()=>!0,l=>l)],E.ApiCommandResult.Void),new E.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.StringArray,new E.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",l=>C.MappedEditsContext.is(l),l=>C.MappedEditsContext.from(l))],new E.ApiCommandResult("A promise that resolves to a workspace edit or null",l=>l?C.WorkspaceEdit.to(l):null))];class v{static register(b){I.forEach(b.registerApiCommand,b),this._registerValidateWhenClausesCommand(b)}static _registerValidateWhenClausesCommand(b){b.registerCommand(!1,"_validateWhenClauses",w.validateWhenClauses)}}e.ExtHostApiCommands=v;function y(l){return b=>{if(Array.isArray(b))return b.map(l)}}function _(l){if(!Array.isArray(l))return;const b=[];for(const o of l)R.isLocationLink(o)?b.push(C.DefinitionLink.to(o)):b.push(C.location.to(o));return b}}),define(Ce[344],De([1,0,8,3,2,6,33,15,7]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class C{static{this._pool=0}constructor(y,_){this.extension=y,this.provider=_,this.handle=C._pool++}}class L{constructor(y){this.session=y,this.responses=[]}}class I{static{this._nextId=0}constructor(y,_,l,b){this._documents=l,this._logService=b,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=y.getProxy(R.MainContext.MainThreadInlineChat),_.registerApiCommand(new A.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.ApiCommandArgument("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?w.Range.from(o.initialRange):void 0,initialSelection:E.Selection.isSelection(o.initialSelection)?w.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?w.Position.from(o.position):void 0}})],A.ApiCommandResult.Void))}registerProvider(y,_,l){const b=new C(y,_);return this._inputProvider.set(b.handle,b),this._proxy.$registerInteractiveEditorProvider(b.handle,l?.label??y.displayName??y.name,y.identifier.value,typeof _.handleInteractiveEditorResponseFeedback=="function",typeof _.provideFollowups=="function",l?.supportReportIssue??!1),(0,F.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(b.handle),this._inputProvider.delete(b.handle)})}async $prepareSession(y,_,l,b){const o=this._inputProvider.get(y);if(!o){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(p.URI.revive(_)),n=w.Selection.to(l),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},b);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I._nextId++;return this._inputSessions.set(a,new L(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:w.Range.from(r.wholeRange),message:r.message}}async $provideResponse(y,_,l,b){const o=this._inputProvider.get(y);if(!o)return;const i=this._inputSessions.get(_.id);if(!i)return;const n={prompt:l.prompt,selection:w.Selection.to(l.selection),wholeRange:w.Range.to(l.wholeRange),attempt:l.attempt,live:l.live,previewDocument:this._documents.getDocument(p.URI.revive(l.previewDocument)),withIntentDetection:l.withIntentDetection};let r=!1;const a={report:async D=>{if(!l.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||b.isCancellationRequested||await this._proxy.$handleProgressChunk(l.requestId,{message:D.message,edits:D.edits?.map(w.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:E.MarkdownString.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,b));let h;try{h=await(0,P.raceCancellation)(t,b)}finally{r=!0}if(!h)return;const u=i.responses.push(h)-1,s={wholeRange:w.Range.from(h.wholeRange),placeholder:h.placeholder};if(!I._isEditResponse(h))return{...s,id:u,type:"editorEdit",message:w.MarkdownString.from(h.contents),edits:[]};const{edits:c,contents:d}=h,m=d!==void 0?w.MarkdownString.from(d):void 0;return c instanceof E.WorkspaceEdit?{...s,id:u,type:"bulkEdit",edits:w.WorkspaceEdit.from(c),message:m}:{...s,id:u,type:"editorEdit",edits:c.map(w.TextEdit.from),message:m}}async $provideFollowups(y,_,l,b){const o=this._inputProvider.get(y),i=this._inputSessions.get(_),n=i?.responses[l];if(o&&n&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(i.session,n,b));return(await(0,P.raceCancellation)(r,b))?.map(w.ChatInlineFollowup.from)}}$handleFeedback(y,_,l,b){const o=this._inputProvider.get(y),i=this._inputSessions.get(_),n=i?.responses[l];if(o&&n){const r=w.InteractiveEditorResponseFeedbackKind.to(b);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(y,_){}static _isEditResponse(y){return typeof y=="object"&&typeof y.edits=="object"}}e.ExtHostInteractiveEditor=I}),define(Ce[345],De([1,0,2,33]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class p{constructor(A,w,E,C,L){this._extHostNotebooks=w,this._textDocumentsAndEditors=E,this._commands=C;const I=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new F.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new F.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new F.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new F.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const y=this._extHostNotebooks.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:P.URI.revive(v.notebookUri),inputUri:P.URI.revive(v.inputUri),notebookEditor:y.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:P.URI.revive(v.notebookUri),inputUri:P.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(A,w,E,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,w){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=p}),define(Ce[346],De([1,0,19,8,22,4,3,28,2,25,13,6,33,15,7,112,286,26,68,287]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let r=class{constructor(m,D,g,f,S){this._initData=D,this._extHostNotebook=g,this._commands=f,this._logService=S,this._activeExecutions=new w.ResourceMap,this._activeNotebookExecutions=new w.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=m.getProxy(I.MainContext.MainThreadNotebookKernels);const T=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const x=this._extHostNotebook.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:x}}else if(z&&"notebookEditor"in z){const x=this._extHostNotebook.getIdByEditor(z.notebookEditor);if(x===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:x}}return z})],v.ApiCommandResult.Void),N=new v.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of variables",(z,x)=>z.map(M=>({name:M.name,value:M.value,type:M.type,editable:!1}))));this._commands.registerApiCommand(T),this._commands.registerApiCommand(N)}createNotebookController(m,D,g,f,S,T){for(const fe of this._kernelData.values())if(fe.controller.id===D&&C.ExtensionIdentifier.equals(m.identifier,fe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const N=this._handlePool++,z=this;this._logService.trace(`NotebookController[${N}], CREATED by ${m.identifier.value}, ${D}`);const x=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${m.identifier}'`);let M=!1;const k=new R.Emitter,O=new R.Emitter,U={id:c(m.identifier,D),notebookType:g,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:f||m.identifier.value,preloads:T?T.map(y.NotebookRendererScript.from):[]};let q=S??x,ie,Z;this._proxy.$addKernel(N,U).catch(fe=>{console.log(fe),M=!0});let Q=0;const Y=()=>{if(M)return;const fe=++Q;Promise.resolve().then(()=>{fe===Q&&this._proxy.$updateKernel(N,U)})},ae=new w.ResourceMap,ee={get id(){return D},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:k.event,get label(){return U.label},set label(fe){U.label=fe??m.displayName??m.name,Y()},get detail(){return U.detail??""},set detail(fe){U.detail=fe,Y()},get description(){return U.description??""},set description(fe){U.description=fe,Y()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(fe){U.supportedLanguages=fe,Y()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){U.supportsExecutionOrder=fe,Y()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(fe){q=fe??x},get interruptHandler(){return ie},set interruptHandler(fe){ie=fe,U.supportsInterrupt=!!fe,Y()},set variableProvider(fe){(0,o.checkProposedApiEnabled)(m,"notebookVariableProvider"),Z=fe,U.hasVariableProvider=!!fe,fe?.onDidChangeVariables(re=>z._proxy.$variablesUpdated(re.uri)),Y()},get variableProvider(){return Z},createNotebookCellExecution(fe){if(M)throw new Error("notebook controller is DISPOSED");if(!ae.has(fe.notebook.uri))throw z._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return z._createNotebookCellExecution(fe,c(m.identifier,this.id))},createNotebookExecution(fe){if((0,o.checkProposedApiEnabled)(m,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!ae.has(fe.uri))throw z._logService.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.uri.toString()}`);return z._createNotebookExecution(fe,c(m.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${N}], DISPOSED`),M=!0,this._kernelData.delete(N),k.dispose(),O.dispose(),this._proxy.$removeKernel(N))},updateNotebookAffinity(fe,re){re===_.NotebookControllerAffinity2.Hidden&&(0,o.checkProposedApiEnabled)(m,"notebookControllerAffinityHidden"),z._proxy.$updateNotebookPriority(N,fe.uri,re)},onDidReceiveMessage:O.event,postMessage(fe,re){return(0,o.checkProposedApiEnabled)(m,"notebookMessaging"),z._proxy.$postMessage(N,re&&z._extHostNotebook.getIdByEditor(re),fe)},asWebviewUri(fe){return(0,o.checkProposedApiEnabled)(m,"notebookMessaging"),(0,l.asWebviewUri)(fe,z._initData.remote)}};return this._kernelData.set(N,{extensionId:m.identifier,controller:ee,onDidReceiveMessage:O,onDidChangeSelection:k,associatedNotebooks:ae}),ee}getIdByController(m){for(const[D,g]of this._kernelData)if(g.controller===m)return c(g.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,D){const g=this._kernelDetectionTaskHandlePool++,f=this;this._logService.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${m.identifier.value}`),this._proxy.$addKernelDetectionTask(g,D);const S={dispose:()=>{this._kernelDetectionTask.delete(g),f._proxy.$removeKernelDetectionTask(g)}};return this._kernelDetectionTask.set(g,S),S}registerKernelSourceActionProvider(m,D,g){const f=this._kernelSourceActionProviderHandlePool++,S=typeof g.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,T=this;this._kernelSourceActionProviders.set(f,g),this._logService.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${m.identifier.value}`),this._proxy.$addKernelSourceActionProvider(f,f,D);let N;return S!==void 0&&(N=g.onDidChangeNotebookKernelSourceActions(z=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this._kernelSourceActionProviders.delete(f),T._proxy.$removeKernelSourceActionProvider(f,f),N?.dispose()}}}async $provideKernelSourceActions(m,D){const g=this._kernelSourceActionProviders.get(m);if(g){const f=new A.DisposableStore;return(await g.provideNotebookKernelSourceActions(D)??[]).map(T=>y.NotebookKernelSourceAction.from(T,this._commands.converter,f))}return[]}$acceptNotebookAssociation(m,D,g){const f=this._kernelData.get(m);if(f){const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(D));g?f.associatedNotebooks.set(S.uri,!0):f.associatedNotebooks.delete(S.uri),this._logService.trace(`NotebookController[${m}] ASSOCIATE notebook`,S.uri.toString(),g),f.onDidChangeSelection.fire({selected:g,notebook:S.apiNotebook})}}async $executeCells(m,D,g){const f=this._kernelData.get(m);if(!f)return;const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(D)),T=[];for(const N of g){const z=S.getCell(N);z&&T.push(z.apiCell)}try{this._logService.trace(`NotebookController[${m}] EXECUTE cells`,S.uri.toString(),T.length),await f.controller.executeHandler.call(f.controller,T,S.apiNotebook,f.controller)}catch(N){this._logService.error(`NotebookController[${m}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(m,D,g){const f=this._kernelData.get(m);if(!f)return;const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(D));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,S.apiNotebook);else for(const T of g){const N=S.getCell(T);N&&this._activeExecutions.get(N.uri)?.cancel()}if(f.controller.interruptHandler){const T=this._activeNotebookExecutions.get(S.uri);g.length&&Array.isArray(T)&&T.length&&T.forEach(N=>N.dispose())}}async $provideVariables(m,D,g,f,S,T,N){const z=this._kernelData.get(m);if(!z)return;const x=this._extHostNotebook.getNotebookDocument(E.URI.revive(g)),M=z.controller.variableProvider;if(!M)return;let k;if(f!==void 0){if(k=this.variableStore[f],!k)return}else this.variableStore={};const O=S==="named"?_.NotebookVariablesRequestKind.Named:_.NotebookVariablesRequestKind.Indexed,U=M.provideVariables(x.apiNotebook,k,O,T,N);let q=0;for await(const ie of U){if(N.isCancellationRequested)return;const Z={id:this.id++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:z.extensionId.value};if(this.variableStore[Z.id]=ie.variable,this._proxy.$receiveVariable(D,Z),q++>=n.variablePageSize)return}}$acceptKernelMessageFromRenderer(m,D,g){const f=this._kernelData.get(m);if(!f)return;const S=this._extHostNotebook.getEditorById(D);f.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:g}))}$cellExecutionChanged(m,D,g){const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(m)).getCell(D);if(S){const T=g?y.NotebookCellExecutionState.to(g):_.NotebookCellExecutionState.Idle;T!==void 0&&this._onDidChangeCellExecutionState.fire({cell:S.apiCell,state:T})}}_createNotebookCellExecution(m,D){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this._extHostNotebook.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!f)throw new Error("invalid cell");if(this._activeExecutions.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const S=new t(D,f,this._proxy);this._activeExecutions.set(f.uri,S);const T=S.onDidChangeState(()=>{S.state===a.Resolved&&(S.dispose(),T.dispose(),this._activeExecutions.delete(f.uri))});return S.asApiObject()}_createNotebookExecution(m,D){const g=this._extHostNotebook.getNotebookDocument(m.uri),f=m.getCells().find(N=>{const z=g.getCellFromApiCell(N);return z&&this._activeExecutions.has(z.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this._activeNotebookExecutions.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const S=new u(D,g,this._proxy),T=S.onDidChangeState(()=>{S.state===h.Resolved&&(S.dispose(),T.dispose(),this._activeNotebookExecutions.delete(g.uri))});return this._activeNotebookExecutions.set(g.uri,[S,T]),S.asApiObject()}};e.ExtHostNotebookKernels=r,e.ExtHostNotebookKernels=r=Ge([He(4,L.ILogService)],r);var a;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(a||(a={}));class t extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(m,D,g){super(),this._cell=D,this._proxy=g,this._handle=t.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new p.CancellationTokenSource),this._collector=new s(10,f=>this.update(f)),this._executionOrder=D.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,m,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(m){await this._collector.addItem(m)}async update(m){const D=Array.isArray(m)?m:[m];return this._proxy.$updateExecution(this._handle,new i.SerializableObjectWithBuffers(D))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(m){let D=this._cell;if(m&&(D=this._cell.notebook.getCellFromApiCell(m)),!D)throw new Error("INVALID cell");return D.handle}validateAndConvertOutputs(m){return m.map(D=>{const g=_.NotebookCellOutput.ensureUniqueMimeTypes(D.items,!0);return g===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async updateOutputs(m,D,g){const f=this.cellIndexToHandle(D),S=this.validateAndConvertOutputs((0,P.asArray)(m));return this.updateSoon({editType:b.CellExecutionUpdateType.Output,cellHandle:f,append:g,outputs:S})}async updateOutputItems(m,D,g){return m=_.NotebookCellOutput.ensureUniqueMimeTypes((0,P.asArray)(m),!0),this.updateSoon({editType:b.CellExecutionUpdateType.OutputItems,items:m.map(y.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const m=this;return Object.freeze({get token(){return m._tokenSource.token},get cell(){return m._cell.apiCell},get executionOrder(){return m._executionOrder},set executionOrder(g){m._executionOrder=g,m.update([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:m._executionOrder}])},start(g){if(m._state===a.Resolved||m._state===a.Started)throw new Error("Cannot call start again");m._state=a.Started,m._onDidChangeState.fire(),m.update({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,f){if(m._state===a.Resolved)throw new Error("Cannot call resolve twice");m._state=a.Resolved,m._onDidChangeState.fire(),m._collector.flush(),m._proxy.$completeExecution(m._handle,new i.SerializableObjectWithBuffers({runEndTime:f,lastRunSuccess:g}))},clearOutput(g){return m.verifyStateForOutput(),m.updateOutputs([],g,!1)},appendOutput(g,f){return m.verifyStateForOutput(),m.updateOutputs(g,f,!0)},replaceOutput(g,f){return m.verifyStateForOutput(),m.updateOutputs(g,f,!1)},appendOutputItems(g,f){return m.verifyStateForOutput(),m.updateOutputItems(g,f,!0)},replaceOutputItems(g,f){return m.verifyStateForOutput(),m.updateOutputItems(g,f,!1)}})}}var h;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(h||(h={}));class u extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(m,D,g){super(),this._notebook=D,this._proxy=g,this._handle=u.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new p.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,m,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===h.Resolved||this._state===h.Started)throw new Error("Cannot call start again");this._state=h.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===h.Resolved)throw new Error("Cannot call resolve twice");this._state=h.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class s{constructor(m,D){this.delay=m,this.callback=D,this.batch=[],this.startedTimer=Date.now()}addItem(m){return this.batch.push(m),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const m=this.currentDeferred;this.currentDeferred=void 0;const D=this.batch;return this.batch=[],this.callback(D).finally(()=>m.complete())}}function c(d,m){return`${d.value}/${m}`}e.createKernelId=c}),define(Ce[46],De([1,0,4,6,5,2,20,3,7,220,14,264,22,30,265,55,8,15,33]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,p.createDecorator)("IExtHostTerminalService");class n{constructor(g,f,S,T){this._proxy=g,this._id=f,this._creationOptions=S,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(z=>this._pidPromiseComplete=z);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},get selection(){return N._selection},sendText(z,x=!0){N._checkDisposed(),N._proxy.$sendText(N._id,z,x)},show(z){N._checkDisposed(),N._proxy.$show(N._id,z)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}async create(g,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??f?.cwd??void 0,env:g.env??void 0,icon:c(g.iconPath)??void 0,color:l.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this._serializeParentTerminal(g.location,f?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,f,S,T,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:T,color:l.ThemeColor.isThemeColor(N)?N.id:void 0,location:f?.location||this._serializeParentTerminal(g,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,f){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in g?{viewColumn:o.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitStatus(g,f){this._exitStatus=Object.freeze({code:g,reason:f})}setDimensions(g,f){return g===this._cols&&f===this._rows||g===0||f===0?!1:(this._cols=g,this._rows=f,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(g){this._selection=g}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=n;class r{get onProcessReady(){return this._onProcessReady.event}constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._onProcessData=new P.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new P.Emitter,this._onDidChangeProperty=new P.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new P.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${f}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,f){this._pty.setDimensions?.({columns:g,rows:f})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose?.((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions?.(f=>{f&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this._pty.onDidChangeName?.(f=>{this._onDidChangeProperty.fire({type:"title",value:f})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends w.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}constructor(g,f,S){super(),this._extHostCommands=f,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new w.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new P.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new P.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new P.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new P.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new P.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new P.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new P.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new P.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=S.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new _.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(g),this._extHostCommands.registerArgumentProcessor({processArgument:T=>{const N=z=>{const x=z;return this._getTerminalById(x.instanceId)?.value};switch(T?.$mid){case 15:return N(T);default:{if(Array.isArray(T))for(let z=0;z<T.length&&T[z].$mid===15;z++)T[z]=N(T[z]);return T}}}}),this._register({dispose:()=>{for(const[T,N]of this._terminalProcesses)N.shutdown(!0)}})}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,f){const S=new n(this._proxy,(0,y.generateUuid)(),g,g.name),T=new r(g.pty);return S.createExtensionTerminal(g.location,f,this._serializeParentTerminal(g,f).resolvedExtHostIdentifier,c(g.iconPath),d(g.color)).then(N=>{const z=this._setupExtHostProcessListeners(N,T);this._terminalProcessDisposables[N]=z}),this._terminals.push(S),S.value}_serializeParentTerminal(g,f){if(f=f||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const S=g.location.parentTerminal;if(S){const T=this._terminals.find(N=>N.value===S);T&&(f.resolvedExtHostIdentifier=T._id)}}else g.location&&typeof g.location!="object"?f.location=g.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(g,f){if(!this._getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const T=new r(f),N=this._setupExtHostProcessListeners(g,T);this._terminalProcessDisposables[g]=N}async $acceptActiveTerminalChanged(g){const f=this._activeTerminal;if(g===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const S=this._getTerminalById(g);S&&(this._activeTerminal=S,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,f){const S=this._getTerminalById(g);S&&this._onDidWriteTerminalData.fire({terminal:S.value,data:f})}async $acceptTerminalDimensions(g,f,S){const T=this._getTerminalById(g);T&&T.setDimensions(f,S)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(g,f){const S=this._getTerminalById(g);S&&this._onDidExecuteCommand.fire({terminal:S.value,...f})}async $acceptTerminalMaximumDimensions(g,f,S){this._terminalProcesses.get(g)?.resize(f,S)}async $acceptTerminalTitleChange(g,f){const S=this._getTerminalById(g);S&&(S.name=f)}async $acceptTerminalClosed(g,f,S){const T=this._getTerminalObjectIndexById(this._terminals,g);if(T!==null){const N=this._terminals.splice(T,1)[0];N.setExitStatus(f,S),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(g,f,S,T){if(f){const x=this._getTerminalObjectIndexById(this._terminals,f);if(x!==null){this._terminals[x]._id=g,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const N={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:R.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},z=new n(this._proxy,g,N,S);this._terminals.push(z),this._onDidOpenTerminal.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(g,f){this._getTerminalById(g)?._setProcessId(f)}async $startExtensionTerminal(g,f){const S=this._getTerminalById(g);if(!S)return{message:(0,C.localize)(0,null,g)};S.isOpen||await new Promise(N=>{const z=this.onDidOpenTerminal(async x=>{x===S.value&&(z.dispose(),N())})});const T=this._terminalProcesses.get(g);T?T.startSendingEvents(f):this._extensionTerminalAwaitingStart[g]={initialDimensions:f}}_setupExtHostProcessListeners(g,f){const S=new w.DisposableStore;S.add(f.onProcessReady(N=>this._proxy.$sendProcessReady(g,N.pid,N.cwd,N.windowsPty))),S.add(f.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(g,N))),this._bufferer.startBuffering(g,f.onProcessData),S.add(f.onProcessExit(N=>this._onProcessExit(g,N))),this._terminalProcesses.set(g,f);const T=this._extensionTerminalAwaitingStart[g];return T&&f instanceof r&&(f.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),S}$acceptProcessAckDataEvent(g,f){this._terminalProcesses.get(g)?.acknowledgeDataEvent(f)}$acceptProcessInput(g,f){this._terminalProcesses.get(g)?.input(f)}$acceptTerminalInteraction(g){const f=this._getTerminalById(g);f?.setInteractedWith()&&this._onDidChangeTerminalState.fire(f.value)}$acceptTerminalSelection(g,f){this._getTerminalById(g)?.setSelection(f)}$acceptProcessResize(g,f,S){try{this._terminalProcesses.get(g)?.resize(f,S)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(g,f){this._terminalProcesses.get(g)?.shutdown(f)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(f=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(f=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:f}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,f,S){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,S),this._proxy.$registerProfileProvider(f,g.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(g,f,S){if(this._quickFixProviders.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this._quickFixProviders.set(g,S),this._proxy.$registerQuickFixProvider(g,f),new E.Disposable(()=>{this._quickFixProviders.delete(g),this._proxy.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,f){const S=new v.CancellationTokenSource().token;if(S.isCancellationRequested)return;const T=this._quickFixProviders.get(g);if(!T)return;const N=await T.provideTerminalQuickFixes(f,S);if(N===null||Array.isArray(N)&&N.length===0)return;const z=new w.DisposableStore;if(this._lastQuickFixCommands.value=z,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this._extHostCommands.converter,z):void 0;const x=[];for(const M of N){const k=o.TerminalQuickFix.from(M,this._extHostCommands.converter,z);k&&x.push(k)}return x}async $createContributedProfileTerminal(g,f){const S=new v.CancellationTokenSource().token;let T=await this._profileProviders.get(g)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,f);return}this.createTerminalFromOptions(T.options,f)}}async $provideLinks(g,f){const S=this._getTerminalById(g);if(!S)return[];this._terminalLinkCache.delete(g),this._terminalLinkCancellationSource.get(g)?.dispose(!0);const N=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,N);const z=[],x={terminal:S.value,line:f},M=[];for(const U of this._linkProviders)M.push(b.Promises.withAsyncBody(async q=>{N.token.onCancellationRequested(()=>q({provider:U,links:[]}));const ie=await U.provideTerminalLinks(x,N.token)||[];N.token.isCancellationRequested||q({provider:U,links:ie})}));const k=await Promise.all(M);if(N.token.isCancellationRequested)return[];const O=new Map;for(const U of k)U&&U.links.length>0&&z.push(...U.links.map(q=>{const ie={id:a++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return O.set(ie.id,{provider:U.provider,link:q}),ie}));return this._terminalLinkCache.set(g,O),z}$activateLink(g,f){const S=this._terminalLinkCache.get(g)?.get(f);S&&S.provider.handleTerminalLink(S.link)}_onProcessExit(g,f){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const S=this._terminalProcessDisposables[g];S&&(S.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,f)}_getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}_getTerminalObjectById(g,f){const S=this._getTerminalObjectIndexById(g,f);return S!==null?g[S]:null}_getTerminalObjectIndexById(g,f){const S=g.findIndex(T=>T._id===f);return S===-1?null:S}getEnvironmentVariableCollection(g){let f=this._environmentVariableCollections.get(g.identifier.value);return f||(f=new h,this._setEnvironmentVariableCollection(g.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(g,f){const S=(0,I.serializeEnvironmentVariableCollection)(f.map),T=(0,I.serializeEnvironmentDescriptionMap)(f.descriptionMap);this._proxy.$setEnvironmentVariableCollection(g,f.persistent,S.length===0?void 0:S,T)}$initEnvironmentVariableCollections(g){g.forEach(f=>{const S=f[0],T=new h(f[1]);this._setEnvironmentVariableCollection(S,T)})}$acceptDefaultProfile(g,f){const S=this._defaultProfile;this._defaultProfile=g,this._defaultAutomationProfile=f,S?.path!==g.path&&this._onDidChangeShell.fire(g.path)}_setEnvironmentVariableCollection(g,f){this._environmentVariableCollections.set(g,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,f)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ge([He(1,i.IExtHostCommands),He(2,A.IExtHostRpcService)],t);class h{get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(g){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new P.Emitter,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const f=this.getScopeKey(g);let S=this.scopedCollections.get(f);return S||(S=new u(this,g),this.scopedCollections.set(f,S),S.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),S}replace(g,f,S,T){this._setIfDiffers(g,{value:f,type:E.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:T})}append(g,f,S,T){this._setIfDiffers(g,{value:f,type:E.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:T})}prepend(g,f,S,T){this._setIfDiffers(g,{value:f,type:E.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:T})}_setIfDiffers(g,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.getKey(g,f.scope),T=this.map.get(S),N=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==f.value||T.type!==f.type||T.options?.applyAtProcessCreation!==N.applyAtProcessCreation||T.options?.applyAtShellIntegration!==N.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const z=this.getKey(g,f.scope),x={variable:g,...f,options:N};this.map.set(z,x),this._onDidChangeCollection.fire()}}get(g,f){const S=this.getKey(g,f),T=this.map.get(S);return T?m(T):void 0}getKey(g,f){const S=this.getScopeKey(f);return S.length?`${g}:::${S}`:g}getScopeKey(g){return this.getWorkspaceKey(g?.workspaceFolder)??""}getWorkspaceKey(g){return g?g.uri.toString():void 0}getVariableMap(g){const f=new Map;for(const[S,T]of this.map)this.getScopeKey(T.scope)===this.getScopeKey(g)&&f.set(T.variable,m(T));return f}delete(g,f){const S=this.getKey(g,f);this.map.delete(S),this._onDidChangeCollection.fire()}clear(g){if(g?.workspaceFolder){for(const[f,S]of this.map)S.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(f);this.clearDescription(g)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(g,f){const S=this.getScopeKey(f),T=this.descriptionMap.get(S);if(!T||T.description!==g){let N;typeof g=="string"?N=g:N=g?.value.split(`

`)[0];const z={description:N,scope:f};this.descriptionMap.set(S,z),this._onDidChangeCollection.fire()}}getDescription(g){const f=this.getScopeKey(g);return this.descriptionMap.get(f)?.description}clearDescription(g){const f=this.getScopeKey(g);this.descriptionMap.delete(f)}}class u{get persistent(){return this.collection.persistent}set persistent(g){this.collection.persistent=g}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(g,f){this.collection=g,this.scope=f,this._onDidChangeCollection=new P.Emitter}getScoped(g){return this.collection.getScopedEnvironmentVariableCollection(g)}replace(g,f,S){this.collection.replace(g,f,S,this.scope)}append(g,f,S){this.collection.append(g,f,S,this.scope)}prepend(g,f,S){this.collection.prepend(g,f,S,this.scope)}get(g){return this.collection.get(g,this.scope)}forEach(g,f){this.collection.getVariableMap(this.scope).forEach((S,T)=>g.call(f,T,S,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(g){this.collection.delete(g,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(g){this.collection.setDescription(g,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let s=class extends t{constructor(g,f){super(!1,g,f)}createTerminal(g,f,S){throw new L.NotSupportedError}createTerminalFromOptions(g,f){throw new L.NotSupportedError}};e.WorkerExtHostTerminalService=s,e.WorkerExtHostTerminalService=s=Ge([He(0,i.IExtHostCommands),He(1,A.IExtHostRpcService)],s);function c(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function d(D){return l.ThemeColor.isThemeColor(D)?D:void 0}function m(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[347],De([1,0,8,21,22,4,74,54,3,24,18,30,13,6,20,151,15,7,67,111,89,26]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class extends E.Disposable{constructor(M,k,O,U){super(),this.editors=U,this.resultsChangedEmitter=this._register(new R.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new R.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(y.MainContext.MainThreadTesting),this.observer=new S(this.proxy),this.runTracker=new c(this.proxy,k),O.registerArgumentProcessor({processArgument:q=>{switch(q?.$mid){case 16:{const ie=q,Z=ie.tests[ie.tests.length-1].item.extId;return this.controllers.get(i.TestId.root(Z))?.collection.tree.get(Z)?.actual??(0,l.toItemFromContext)(q)}case 18:{const{extId:ie,message:Z}=q;return{test:this.controllers.get(i.TestId.root(ie))?.collection.tree.get(ie)?.actual,message:b.TestMessage.to(Z)}}default:return q}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const q=await O.executeCommand("_testing.getExplorerSelection"),ie=Z=>{const Q=this.controllers.get(i.TestId.root(Z));if(Q)return i.TestId.isRoot(Z)?Q.controller:Q.collection.tree.get(Z)?.actual};return{include:q?.include.map(ie).filter(L.isDefined)||[],exclude:q?.exclude.map(ie).filter(L.isDefined)||[]}})}createTestController(M,k,O,U){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const q=new E.DisposableStore,ie=q.add(new l.ExtHostTestItemCollection(k,O,this.editors));ie.root.label=O;const Z=new Map,Q=new Set,Y=this.proxy,ae={items:ie.root.children,get label(){return O},set label(fe){O=fe,ie.root.label=fe,Y.$updateController(k,{label:O})},get refreshHandler(){return U},set refreshHandler(fe){U=fe,Y.$updateController(k,{canRefresh:!!fe})},get id(){return k},createRunProfile:(fe,re,G,B,se,ye)=>{let le=(0,w.hash)(fe);for(;Z.has(le);)le++;return new N(this.proxy,Z,Q,this.defaultProfilesChangedEmitter.event,k,le,fe,re,G,B,se,ye)},createTestItem(fe,re,G){return new l.TestItemImpl(k,fe,re,G)},createTestRun:(fe,re,G=!0)=>this.runTracker.createTestRun(M,k,ie,fe,re,G),invalidateTestResults:fe=>{if(fe===void 0)this.proxy.$markTestRetired(void 0);else{const re=fe instanceof Array?fe:[fe];this.proxy.$markTestRetired(re.map(G=>i.TestId.fromExtHostTestItem(G,k).toString()))}},set resolveHandler(fe){ie.resolveHandler=fe},get resolveHandler(){return ie.resolveHandler},dispose:()=>{q.dispose()}};Y.$registerTestController(k,O,!!U),q.add((0,E.toDisposable)(()=>Y.$unregisterTestController(k)));const ee={controller:ae,collection:ie,profiles:Z,extension:M,activeProfiles:Q};return this.controllers.set(k,ee),q.add((0,E.toDisposable)(()=>this.controllers.delete(k))),q.add(ie.onDidGenerateDiff(fe=>Y.$publishDiff(k,fe.map(r.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.observer.checkout()}async runTests(M,k=p.CancellationToken.None){const O=d(M);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(O.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(q=>i.TestId.fromExtHostTestItem(q,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:z[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:M.exclude?.map(q=>q.id)},k)}$syncTests(){for(const{collection:M}of this.controllers.values())M.flushDiff();return Promise.resolve()}async $provideFileCoverage(M,k,O){return await this.runTracker.getCoverageReport(M,k)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(M,k,O,U){return await this.runTracker.getCoverageReport(M,k)?.resolveFileCoverage(O,U)??[]}$configureRunProfile(M,k){this.controllers.get(M)?.profiles.get(k)?.configureHandler?.()}$setDefaultRunProfiles(M){const k=new Map;for(const[O,U]of Object.entries(M)){const q=this.controllers.get(O);if(!q)continue;const ie=new Map,Z=U.filter(Y=>!q.activeProfiles.has(Y)),Q=[...q.activeProfiles].filter(Y=>!U.includes(Y));for(const Y of Z)ie.set(Y,!0),q.activeProfiles.add(Y);for(const Y of Q)ie.set(Y,!1),q.activeProfiles.delete(Y);ie.size&&k.set(O,ie)}this.defaultProfilesChangedEmitter.fire(k)}async $refreshTests(M,k){await this.controllers.get(M)?.controller.refreshHandler?.(k)}$publishTestResults(M){this.results=Object.freeze(M.map(k=>(0,C.deepFreeze)(b.TestResults.to(k))).concat(this.results).sort((k,O)=>O.completedAt-k.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,k){const O=this.controllers.get(i.TestId.fromString(M).controllerId)?.collection;O&&(await O.expand(M,k<0?1/0:k),O.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(k=>r.TestsDiffOp.deserialize({asCanonicalUri:O=>O},k)))}async $runControllerTests(M,k){return Promise.all(M.map(O=>this.runControllerTestRequest(O,!1,k)))}async $startContinuousRun(M,k){const O=new p.CancellationTokenSource(k),U=await Promise.all(M.map(q=>this.runControllerTestRequest(q,!0,O.token)));return!k.isCancellationRequested&&!U.some(q=>q.error)&&await new Promise(q=>k.onCancellationRequested(q)),O.dispose(!0),U}async runControllerTestRequest(M,k,O){const U=this.controllers.get(M.controllerId);if(!U)return{};const{collection:q,profiles:ie,extension:Z}=U,Q=ie.get(M.profileId);if(!Q)return{};const Y=M.testIds.map(re=>q.tree.get(re)).filter(L.isDefined),ae=M.excludeExtIds.map(re=>U.collection.tree.get(re)).filter(L.isDefined).filter(re=>Y.some(G=>G.fullId.compare(re.fullId)===2));if(!Y.length)return{};const ee=new o.TestRunRequest(Y.some(re=>re.actual instanceof l.TestItemRootImpl)?void 0:Y.map(re=>re.actual),ae.map(re=>re.actual),Q,k),fe=(0,r.isStartControllerTests)(M)&&this.runTracker.prepareForMainThreadTestRun(ee,m.fromInternal(M,U.collection),Z,O);try{return await Q.runHandler(ee,O),{}}catch(re){return{error:String(re)}}finally{fe&&(fe.hasRunningTasks&&!O.isCancellationRequested&&await R.Event.toPromise(fe.onEnd),fe.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};e.ExtHostTesting=t,e.ExtHostTesting=t=Ge([He(0,_.IExtHostRpcService),He(1,v.ILogService)],t);const h=1e4;var u;(function(x){x[x.Running=0]="Running",x[x.Cancelling=1]="Cancelling",x[x.Ended=2]="Ended"})(u||(u={}));class s extends E.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(M,k,O,U,q){super(),this.dto=M,this.proxy=k,this.extension=O,this.logService=U,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.coverageEmitter=this._register(new R.Emitter),this.onDidCoverage=this.coverageEmitter.event,this.onEnd=this.endEmitter.event,this.cts=this._register(new p.CancellationTokenSource(q));const ie=this._register(new P.RunOnceScheduler(()=>this.forciblyEndTasks(),h));this._register(this.cts.token.onCancellationRequested(()=>ie.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}createRun(M){const k=this.dto.id,O=this.dto.controllerId,U=(0,I.generateUuid)(),q=this.extension,ie=this.coverageEmitter;let Z;const Q=fe=>(re,...G)=>{if(ae){this.logService.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(re)&&(this.ensureTestIsKnown(re),fe(re,...G))},Y=(fe,re)=>{const G=re instanceof Array?re.map(b.TestMessage.from):[b.TestMessage.from(re)];if(fe.uri&&fe.range){const B={range:b.Range.from(fe.range),uri:fe.uri};for(const se of G)se.location=se.location||B}this.proxy.$appendTestMessagesInRun(k,U,i.TestId.fromExtHostTestItem(fe,O).toString(),G)};let ae=!1;const ee={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return Z?.provider},set coverageProvider(fe){(0,a.checkProposedApiEnabled)(q,"testCoverage"),Z=fe&&new D(fe),ie.fire({taskId:U,runId:k,coverage:Z})},enqueued:Q(fe=>{this.proxy.$updateTestStateInRun(k,U,i.TestId.fromExtHostTestItem(fe,O).toString(),1)}),skipped:Q(fe=>{this.proxy.$updateTestStateInRun(k,U,i.TestId.fromExtHostTestItem(fe,O).toString(),5)}),started:Q(fe=>{this.proxy.$updateTestStateInRun(k,U,i.TestId.fromExtHostTestItem(fe,O).toString(),2)}),errored:Q((fe,re,G)=>{Y(fe,re),this.proxy.$updateTestStateInRun(k,U,i.TestId.fromExtHostTestItem(fe,O).toString(),6,G)}),failed:Q((fe,re,G)=>{Y(fe,re),this.proxy.$updateTestStateInRun(k,U,i.TestId.fromExtHostTestItem(fe,O).toString(),4,G)}),passed:Q((fe,re)=>{this.proxy.$updateTestStateInRun(k,U,i.TestId.fromExtHostTestItem(fe,this.dto.controllerId).toString(),3,re)}),appendOutput:(fe,re,G)=>{ae||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(k,U,F.VSBuffer.fromString(fe),re&&b.location.from(re),G&&i.TestId.fromExtHostTestItem(G,O).toString()))},end:()=>{ae||(ae=!0,this.proxy.$finishedTestRunTask(k,U),this.tasks.delete(U),this.tasks.size||this.markEnded())}};return this.tasks.set(U,{run:ee}),this.proxy.$startedTestRunTask(k,{id:U,name:M,running:!0}),ee}forciblyEndTasks(){for(const{run:M}of this.tasks.values())M.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(M){if(!(M instanceof l.TestItemImpl))throw new n.InvalidTestItemError(M.id);if(this.sharedTestIds.has(i.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const k=[],O=this.dto.colllection.root;for(;;){const U=b.TestItem.from(M);if(k.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),M===O))break;M=M.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,k)}dispose(){this.markEnded(),super.dispose()}}class c{get trackers(){return this.tracked.values()}constructor(M,k){this.proxy=M,this.logService=k,this.tracked=new Map,this.coverageReports=[]}getCoverageReport(M,k){return this.coverageReports.find(O=>O.runId===M)?.coverage.get(k)}prepareForMainThreadTestRun(M,k,O,U){return this.getTracker(M,k,O,U)}cancelRunById(M){for(const k of this.tracked.values())if(k.id===M){k.cancel();return}}cancelAllRuns(){for(const M of this.tracked.values())M.cancel()}createTestRun(M,k,O,U,q,ie){const Z=this.tracked.get(U);if(Z)return Z.createRun(q);const Q=m.fromPublic(k,O,U,ie),Y=d(U);this.proxy.$startedExtensionTestRun({controllerId:k,continuous:!!U.continuous,profile:Y&&{group:z[Y.kind],id:Y.profileId},exclude:U.exclude?.map(ee=>i.TestId.fromExtHostTestItem(ee,O.root.id).toString())??[],id:Q.id,include:U.include?.map(ee=>i.TestId.fromExtHostTestItem(ee,O.root.id).toString())??[O.root.id],persist:ie});const ae=this.getTracker(U,Q,M);return R.Event.once(ae.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(Q.id),ae.dispose()}),ae.createRun(q)}getTracker(M,k,O,U){const q=new s(k,this.proxy,O,this.logService,U);this.tracked.set(M,q);let ie;const Z=q.onDidCoverage(({runId:Q,taskId:Y,coverage:ae})=>{ie||(ie={runId:Q,coverage:new Map},this.coverageReports.unshift(ie),this.coverageReports.length>r.KEEP_N_LAST_COVERAGE_REPORTS&&this.coverageReports.pop()),ie.coverage.set(Y,ae),this.proxy.$signalCoverageAvailable(Q,Y,!!ae)});return R.Event.once(q.onEnd)(()=>{this.tracked.delete(M),Z.dispose()}),q}}e.TestRunCoordinator=c;const d=x=>{if(x.profile){if(!(x.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return x.profile}};class m{static fromPublic(M,k,O,U){return new m(M,(0,I.generateUuid)(),O.include?.map(q=>i.TestId.fromExtHostTestItem(q,M).toString())??[M],O.exclude?.map(q=>i.TestId.fromExtHostTestItem(q,M).toString())??[],U,k)}static fromInternal(M,k){return new m(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,k)}constructor(M,k,O,U,q,ie){this.controllerId=M,this.id=k,this.isPersisted=q,this.colllection=ie,this.includePrefix=O.map(Z=>Z+"\0"),this.excludePrefix=U.map(Z=>Z+"\0")}isIncluded(M){const k=i.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(k===O||k.startsWith(O))return!1;for(const O of this.includePrefix)if(k===O||k.startsWith(O))return!0;return!1}}e.TestRunDto=m;class D{constructor(M){this.provider=M}async provideFileCoverage(M){this.fileCoverage||(this.fileCoverage=(async()=>this.provider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(b.TestCoverage.fromFile)??[]}catch(k){throw this.fileCoverage=void 0,k}}async resolveFileCoverage(M,k){const O=await this.fileCoverage;let U=O?.[M];return!this.provider||!O||!U?[]:(U.detailedCoverage||(U=O[M]=await this.provider.resolveFileCoverage?.(U,k)??U),U.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(M){this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(M){this.added.add(M)}update(M){Object.assign(M.revived,b.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}this.updated.delete(M);const k=i.TestId.parentId(M.item.extId);if(k&&this.alreadyRemoved.has(k.toString())){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:k,removed:O}=this;return{get added(){return[...M].map(U=>U.revived)},get updated(){return[...k].map(U=>U.revived)},get removed(){return[...O].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends r.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,k){return{...M,revived:b.TestItem.toPlain(M.item),depth:k?k.depth+1:0,children:new Set}}createChangeCollector(){return new g(this.changeEmitter)}}class S{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(k=>k.revived)},dispose:(0,A.createSingleCallFunction)(()=>{--M.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new f({asCanonicalUri:k=>k});return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}const T=(x,M,k,O)=>{k?Object.assign(k,O):M.$updateTestRunConfig(x.controllerId,x.profileId,O)};class N{#e;#t;#i;#n;#s;get label(){return this._label}set label(M){M!==this._label&&(this._label=M,T(this,this.#e,this.#n,{label:M}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(M){M!==this._supportsContinuousRun&&(this._supportsContinuousRun=M,T(this,this.#e,this.#n,{supportsContinuousRun:M}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(M){M!==this.isDefault&&(M?this.#t.add(this.profileId):this.#t.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,T(this,this.#e,this.#n,{tag:M?b.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,T(this,this.#e,this.#n,{hasConfigurationHandler:!!M}))}get onDidChangeDefault(){return R.Event.chain(this.#i,M=>M.map(k=>k.get(this.controllerId)?.get(this.profileId)).filter(L.isDefined))}constructor(M,k,O,U,q,ie,Z,Q,Y,ae=!1,ee=void 0,fe=!1){this.controllerId=q,this.profileId=ie,this._label=Z,this.kind=Q,this.runHandler=Y,this._tag=ee,this._supportsContinuousRun=fe,this.#e=M,this.#s=k,this.#t=O,this.#i=U,k.set(ie,this);const re=z[Q];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);ae&&O.add(ie),this.#n={profileId:ie,controllerId:q,tag:ee?b.TestTag.namespace(this.controllerId,ee.id):null,label:Z,group:re,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=N;const z={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[152],De([1,0,61,14,121,15,7]),function(me,e,P,F,p,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class w{static{this._Keys=new p.IdGenerator("TextEditorDecorationType")}constructor(v,y,_){const l=w._Keys.nextId();v.$registerTextEditorDecorationType(y.identifier,l,R.DecorationRenderOptions.from(_)),this.value=Object.freeze({key:l,dispose(){v.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=w;class E{constructor(v,y){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=y.undoStopBefore,this._undoStopAfter=y.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,y){this._throwIfFinalized();let _=null;if(v instanceof A.Position)_=new A.Range(v,v);else if(v instanceof A.Range)_=v;else throw new Error("Unrecognized location");this._pushEdit(_,y,!1)}insert(v,y){this._throwIfFinalized(),this._pushEdit(new A.Range(v,v),y,!0)}delete(v){this._throwIfFinalized();let y=null;if(v instanceof A.Range)y=v;else throw new Error("Unrecognized location");this._pushEdit(y,null,!0)}_pushEdit(v,y,_){const l=this._document.validateRange(v);this._collectedEdits.push({range:l,text:y,forceMoveMarkers:_})}setEndOfLine(v){if(this._throwIfFinalized(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=v}}class C{constructor(v,y,_,l){this._proxy=v,this._id=y,this._accept(_),this._logService=l;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(o){b._setTabSize(o)},get indentSize(){return b._indentSize},set indentSize(o){b._setIndentSize(o)},get insertSpaces(){return b._insertSpaces},set insertSpaces(o){b._setInsertSpaces(o)},get cursorStyle(){return b._cursorStyle},set cursorStyle(o){b._setCursorStyle(o)},get lineNumbers(){return b._lineNumbers},set lineNumbers(o){b._setLineNumbers(o)}}}_accept(v){this._tabSize=v.tabSize,this._indentSize=v.indentSize,this._originalIndentSize=v.originalIndentSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}_setTabSize(v){const y=this._validateTabSize(v);if(y!==null){if(typeof y=="number"){if(this._tabSize===y)return;this._tabSize=y}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:y}))}}_validateIndentSize(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}_setIndentSize(v){const y=this._validateIndentSize(v);if(y!==null){if(typeof y=="number"){if(this._originalIndentSize===y)return;this._indentSize=y,this._originalIndentSize=y}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:y}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:!!v}_setInsertSpaces(v){const y=this._validateInsertSpaces(v);if(typeof y=="boolean"){if(this._insertSpaces===y)return;this._insertSpaces=y}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:y}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const y={};let _=!1;if(typeof v.tabSize<"u"){const l=this._validateTabSize(v.tabSize);l==="auto"?(_=!0,y.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,_=!0,y.tabSize=l)}if(typeof v.indentSize<"u"){const l=this._validateIndentSize(v.indentSize);l==="tabSize"?(_=!0,y.indentSize=l):typeof l=="number"&&this._originalIndentSize!==l&&(this._indentSize=l,this._originalIndentSize=l,_=!0,y.indentSize=l)}if(typeof v.insertSpaces<"u"){const l=this._validateInsertSpaces(v.insertSpaces);l==="auto"?(_=!0,y.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,_=!0,y.insertSpaces=l)}typeof v.cursorStyle<"u"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,_=!0,y.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,_=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),_&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,y))}_warnOnError(v,y){y.catch(_=>{this._logService.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this._logService.warn(_)})}}e.ExtHostTextEditorOptions=C;class L{constructor(v,y,_,l,b,o,i,n){this.id=v,this._proxy=y,this._logService=_,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new C(this._proxy,this.id,o,_),this._visibleRanges=i,this._viewColumn=n;const r=this;this.value=Object.freeze({get document(){return l.value},set document(a){throw new F.ReadonlyError("document")},get selection(){return r._selections&&r._selections[0]},set selection(a){if(!(a instanceof A.Selection))throw(0,F.illegalArgument)("selection");r._selections=[a],r._trySetSelection()},get selections(){return r._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");r._selections=a,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(a){throw new F.ReadonlyError("visibleRanges")},get options(){return r._options.value},set options(a){r._disposed||r._options.assign(a)},get viewColumn(){return r._viewColumn},set viewColumn(a){throw new F.ReadonlyError("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new E(l.value,t);return a(h),r._applyEdit(h)},insertSnippet(a,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=r._selections.map(s=>R.Range.from(s));else if(t instanceof A.Position){const{lineNumber:s,column:c}=R.Position.from(t);u=[{startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c}]}else if(t instanceof A.Range)u=[R.Range.from(t)];else{u=[];for(const s of t)if(s instanceof A.Range)u.push(R.Range.from(s));else{const{lineNumber:c,column:d}=R.Position.from(s);u.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return y.$tryInsertSnippet(v,l.value.version,a.value,u,h)},setDecorations(a,t){const h=t.length===0;h&&!r._hasDecorationsForKey.has(a.key)||(h?r._hasDecorationsForKey.delete(a.key):r._hasDecorationsForKey.add(a.key),r._runOnProxy(()=>{if(R.isDecorationOptionsArr(t))return y.$trySetDecorations(v,a.key,R.fromRangeOrRangeWithMessage(t));{const u=new Array(4*t.length);for(let s=0,c=t.length;s<c;s++){const d=t[s];u[4*s]=d.start.line+1,u[4*s+1]=d.start.character+1,u[4*s+2]=d.end.line+1,u[4*s+3]=d.end.character+1}return y.$trySetDecorationsFast(v,a.key,u)}}))},revealRange(a,t){r._runOnProxy(()=>y.$tryRevealRange(v,R.Range.from(a),t||A.TextEditorRevealType.Default))},show(a){y.$tryShowEditor(v,R.ViewColumn.from(a))},hide(){y.$tryHideEditor(v)}})}dispose(){(0,P.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,P.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,P.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,P.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,P.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const y=v.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const _=y.edits.map(b=>b.range);_.sort((b,o)=>b.end.line===o.end.line?b.end.character===o.end.character?b.start.line===o.start.line?b.start.character-o.start.character:b.start.line-o.start.line:b.end.character-o.end.character:b.end.line-o.end.line);for(let b=0,o=_.length-1;b<o;b++){const i=_[b].end;if(_[b+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=y.edits.map(b=>({range:R.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,l,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this._logService.warn(y),null))}}e.ExtHostTextEditor=L}),define(Ce[72],De([1,0,61,4,3,2,5,6,149,20,152,15,13,28,16,48,44]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let i=class{constructor(r,a){this._extHostRpc=r,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new y.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],h=[];if(r.removedDocuments)for(const u of r.removedDocuments){const s=R.URI.revive(u),c=this._documents.get(s);c?.unref()&&(this._documents.delete(s),a.push(c.value))}if(r.addedDocuments)for(const u of r.addedDocuments){const s=R.URI.revive(u.uri);let c=this._documents.get(s);if(c&&s.scheme!==_.Schemas.vscodeNotebookCell&&s.scheme!==_.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);c||(c=new o(new E.ExtHostDocumentData(this._extHostRpc.getProxy(w.MainContext.MainThreadDocuments),s,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this._documents.set(s,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const u of r.removedEditors){const s=this._editors.get(u);this._editors.delete(u),s&&h.push(s)}if(r.addedEditors)for(const u of r.addedEditors){const s=R.URI.revive(u.documentUri);P.ok(this._documents.has(s),`document '${s}' does not exist`),P.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const c=this._documents.get(s).value,d=new L.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(w.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>c.document),u.selections.map(I.Selection.to),u.options,u.visibleRanges.map(m=>I.Range.to(m)),typeof u.editorPosition=="number"?I.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,d)}r.newActiveEditor!==void 0&&(P.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,p.dispose)(a),(0,p.dispose)(h),r.removedDocuments&&this._onDidRemoveDocuments.fire(a),r.addedDocuments&&this._onDidAddDocuments.fire(t),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const a=this._editors.get(this._activeEditorId);return r?a:a?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=i,e.ExtHostDocumentsAndEditors=i=Ge([He(0,C.IExtHostRpcService),He(1,v.ILogService)],i),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[348],De([1,0,19,4,6,152,15,7]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(L,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new F.Emitter,this._onDidChangeTextEditorOptions=new F.Emitter,this._onDidChangeTextEditorVisibleRanges=new F.Emitter,this._onDidChangeTextEditorViewColumn=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(p.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const I=this._extHostDocumentsAndEditors.allEditors();return L?I:I.map(v=>v.value)}async showTextDocument(L,I,v){let y;typeof I=="number"?y={position:A.ViewColumn.from(I),preserveFocus:v}:typeof I=="object"?y={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:y={preserveFocus:!1};const _=await this._proxy.$tryShowTextDocument(L.uri,y),l=_&&this._extHostDocumentsAndEditors.getEditor(_);if(l)return l.value;throw _?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,I){return new R.TextEditorDecorationType(this._proxy,L,I).value}$acceptEditorPropertiesChanged(L,I){const v=this._extHostDocumentsAndEditors.getEditor(L);if(!v)throw new Error("unknown text editor");if(I.options&&v._acceptOptions(I.options),I.selections){const y=I.selections.selections.map(A.Selection.to);v._acceptSelections(y)}if(I.visibleRanges){const y=P.coalesce(I.visibleRanges.map(A.Range.to));v._acceptVisibleRanges(y)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const y=w.TextEditorSelectionChangeKind.fromValue(I.selections.source),_=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:_,kind:y})}if(I.visibleRanges){const y=P.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:y})}}$acceptEditorPositionData(L){for(const I in L){const v=this._extHostDocumentsAndEditors.getEditor(I);if(!v)throw new Error("Unknown text editor");const y=A.ViewColumn.to(L[I]);v.value.viewColumn!==y&&(v._acceptViewColumn(y),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:y}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=E}),define(Ce[349],De([1,0,2,5,6,3,7,15,25,18]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class L{constructor(y,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=y.getProxy(p.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:(l,b)=>{if(l&&l.$mid===12)if(this._providers.get(l.source)&&E.ExtensionIdentifier.equals(b,this._providers.get(l.source)?.extension)){const o=l.uri===void 0?void 0:P.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(I(o))?.get(l.handle)}else return;return l}})}async $getTimeline(y,_,l,b){return this._providers.get(y)?.provider.provideTimeline(P.URI.revive(_),l,b)}registerTimelineProvider(y,_,l,b){const o=new R.DisposableStore,i=this.convertTimelineItem(_.id,b,o).bind(this);let n;_.onDidChange&&(n=_.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:_.id}),this));const r=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:y,onDidChange:void 0,async provideTimeline(a,t,h){t?.resetCache&&(o.clear(),r.get(_.id)?.clear());const u=await _.provideTimeline(a,t,h);if(u==null)return;const s=i(a,t);return{...u,source:_.id,items:u.items.map(s)}},dispose(){for(const a of r.values())a.get(_.id)?.clear();n?.dispose(),o.dispose()}},l)}convertTimelineItem(y,_,l){return(b,o)=>{let i;if(o?.cacheResults){let n=this._itemsBySourceAndUriMap.get(y);n===void 0&&(n=new Map,this._itemsBySourceAndUriMap.set(y,n));const r=I(b);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${y}|${n.id??n.timestamp}`;i?.set(t,n);let h,u,s;n.iconPath&&(r instanceof A.ThemeIcon?s={id:r.id,color:r.color}:P.URI.isUri(r)?(h=r,u=r):{light:h,dark:u}=r);let c;return A.MarkdownString.isMarkdownString(a.tooltip)?c=w.MarkdownString.from(a.tooltip):(0,C.isString)(a.tooltip)?c=a.tooltip:A.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=w.MarkdownString.from(a.detail)):(0,C.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:n.command?_.toInternal(n.command,l):void 0,icon:h,iconDark:u,themeIcon:s,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}registerTimelineProviderCore(y,_){if(this._providers.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this._proxy.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this._providers.set(y.id,{provider:y,extension:_}),(0,R.toDisposable)(()=>{for(const b of this._itemsBySourceAndUriMap.values())b.get(y.id)?.clear();this._providers.delete(y.id),this._proxy.$unregisterTimelineProvider(y.id),y.dispose()})}}e.ExtHostTimeline=L;function I(v){return v?.toString()}}),define(Ce[350],De([1,0,221,23,2,4,3,280,8,7,18,19,15,80,22,178,26]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(r,a){if((0,L.isString)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends A.Disposable{constructor(a,t,h){super(),this._proxy=a,this.commands=t,this.logService=h,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDnDService;function u(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>u(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(c=>u(c)?this.convertArgument(c):c):s})}registerTreeDataProvider(a,t,h){const u=this.createTreeView(a,{treeDataProvider:t},h);return{dispose:()=>u.dispose()}}createTreeView(a,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,m=this.createExtHostTreeView(a,t,h),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:u,dragMimeTypes:s,hasHandleDrag:c,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this._proxy.$registerTreeViewDataProvider(a,D),f={get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get activeItem(){return(0,b.checkProposedApiEnabled)(h,"treeViewActiveItem"),m.focusedElement},get onDidChangeActiveItem(){return(0,b.checkProposedApiEnabled)(h,"treeViewActiveItem"),m.onDidChangeActiveItem},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get onDidChangeCheckboxState(){return m.onDidChangeCheckboxState},get message(){return m.message},set message(S){(0,y.isMarkdownString)(S)&&(0,b.checkProposedApiEnabled)(h,"treeViewMarkdownMessage"),m.message=S},get title(){return m.title},set title(S){m.title=S},get description(){return m.description},set description(S){m.description=S},get badge(){return m.badge},set badge(S){S!==void 0&&C.ViewBadge.isViewBadge(S)?m.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(m.badge=void 0)},reveal:(S,T)=>m.reveal(S,T),dispose:async()=>{await g,this.treeViews.delete(a),m.dispose()}};return this._register(f),f}$getChildren(a,t){const h=this.treeViews.get(a);return h?h.getChildren(t):Promise.reject(new w.NoTreeViewError(a))}async $handleDrop(a,t,h,u,s,c,d,m){const D=this.treeViews.get(a);if(!D)return Promise.reject(new w.NoTreeViewError(a));const g=v.DataTransfer.toDataTransfer(h,async f=>(await this._proxy.$resolveDropFileData(a,t,f)).buffer);return d===a&&m&&await this.addAdditionalTransferItems(g,D,m,s,c),D.onDrop(g,u,s)}async addAdditionalTransferItems(a,t,h,u,s){const c=this.treeDragAndDropService.removeDragOperationTransfer(s);if(c)(await c)?.forEach((d,m)=>{d&&a.set(m,d)});else if(s&&t.handleDrag){const d=t.handleDrag(h,a,u);this.treeDragAndDropService.addDragOperationTransfer(s,d),await d}return a}async $handleDrag(a,t,h,u){const s=this.treeViews.get(a);if(!s)return Promise.reject(new w.NoTreeViewError(a));const c=await this.addAdditionalTransferItems(new C.DataTransfer,s,t,u,h);if(!(!c||u.isCancellationRequested))return v.DataTransfer.from(c)}async $hasResolve(a){const t=this.treeViews.get(a);if(!t)throw new w.NoTreeViewError(a);return t.hasResolve}$resolve(a,t,h){const u=this.treeViews.get(a);if(!u)throw new w.NoTreeViewError(a);return u.resolveTreeItem(t,h)}$setExpanded(a,t,h){const u=this.treeViews.get(a);if(!u)throw new w.NoTreeViewError(a);u.setExpanded(t,h)}$setSelectionAndFocus(a,t,h){const u=this.treeViews.get(a);if(!u)throw new w.NoTreeViewError(a);u.setSelectionAndFocus(t,h)}$setVisible(a,t){const h=this.treeViews.get(a);if(!h){if(!t)return;throw new w.NoTreeViewError(a)}h.setVisible(t)}$changeCheckboxState(a,t){const h=this.treeViews.get(a);if(!h)throw new w.NoTreeViewError(a);h.setCheckboxState(t)}createExtHostTreeView(a,t,h){const u=this._register(new n(a,t,this._proxy,this.commands.converter,this.logService,h));return this.treeViews.set(a,u),u}convertArgument(a){const t=this.treeViews.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=i;class n extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(a,t,h,u,s,c){if(super(),this.viewId=a,this.proxy=h,this.commands=u,this.logService=s,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new R.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,c.contributes&&c.contributes.views)for(const g in c.contributes.views)for(const f of c.contributes.views[g])f.id===a&&(this._title=f.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>this._onDidChangeData.fire({message:!1,element:g})));let d,m;const D=R.Event.debounce(this._onDidChangeData.event,(g,f)=>(g||(g={message:!1,elements:[]}),f.element!==!1&&(d||(d=new Promise(S=>m=S),this.refreshPromise=this.refreshPromise.then(()=>d)),Array.isArray(f.element)?g.elements.push(...f.element):g.elements.push(f.element)),f.message&&(g.message=!0),g),200,!0);this._register(D(({message:g,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=m;return d=null,this.refresh(f).then(()=>S())})),g&&this.proxy.$setMessage(this.viewId,v.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let h=this.getChildrenNodes(a);return h||(h=await this.fetchChildrenNodes(t)),h?h.map(u=>u.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const h=(0,L.isUndefinedOrNull)(t.select)?!0:t.select,u=(0,L.isUndefinedOrNull)(t.focus)?!1:t.focus,s=(0,L.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(c=>this.resolveTreeNode(a,c[c.length-1]).then(d=>this.proxy.$reveal(this.viewId,{item:d.item,parentChain:c.map(m=>m.item)},{select:h,focus:u,expand:s})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:u,expand:s})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=v.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,t){const h=this.getExtensionElement(a);h&&(t?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelectionAndFocus(a,t){const h=!(0,I.equals)(this._selectedHandles,a);this._selectedHandles=a;const u=this._focusedHandle!==t;this._focusedHandle=t,h&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),u&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async h=>{const u=this.getExtensionElement(h.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:h.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(a,t,h){const u=[];for(const s of a){const c=this.getExtensionElement(s);c&&u.push(c)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,t,h),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,t,h){const u=t?this.getExtensionElement(t):void 0;if(!(!u&&t||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,a,h):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,t){if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(a);if(h){const u=this.nodes.get(h);if(u){const s=await this.dataProvider.resolveTreeItem(u.extensionItem,h,t)??u.extensionItem;return this.validateTreeItem(s),u.item.tooltip=this.getTooltip(s.tooltip),u.item.command=this.getCommand(u.disposableStore,s.command),u.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(t=>t?this.resolveUnknownParentChain(t).then(h=>this.resolveTreeNode(t,h[h.length-1]).then(u=>(h.push(u),h))):Promise.resolve([]))}resolveParent(a){const t=this.nodes.get(a);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,t){const h=this.nodes.get(a);return h?Promise.resolve(h):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(u=>this.createHandle(a,u,t,!0)).then(u=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(u);if(s){const c=this.nodes.get(s);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(a){if(a){let t;if(typeof a=="string"){const h=this.getExtensionElement(a);t=h?this.nodes.get(h):void 0}else t=a;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const t=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=a?this.nodes.get(a):void 0,u=await this.dataProvider.getChildren(a);if(t.token.isCancellationRequested)return;const s=(0,I.coalesce)(u||[]),c=await Promise.all((0,I.coalesce)(s).map(m=>this.dataProvider.getTreeItem(m)));if(t.token.isCancellationRequested)return;const d=c.map((m,D)=>m?this.createAndRegisterTreeNode(s[D],m,h):null);return(0,I.coalesce)(d)}finally{t.dispose()}}refresh(a){if(a.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(a);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const t=new Set,h=a.map(s=>this.nodes.get(s));for(const s of h)if(s&&!t.has(s.item.handle)){let c=s;for(;c&&c.parent&&h.findIndex(d=>c&&c.parent&&d&&d.item.handle===c.parent.item.handle)===-1;){const d=this.elements.get(c.parent.item.handle);c=d?this.nodes.get(d):void 0}c&&!c.parent&&t.add(s.item.handle)}const u=[];return t.forEach(s=>{const c=this.elements.get(s);if(c){const d=this.nodes.get(c);d&&(!d.parent||!t.has(d.parent.item.handle))&&u.push(s)}}),u}refreshHandles(a){const t={};return Promise.all(a.map(h=>this.refreshNode(h).then(u=>{u&&(t[h]=u.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(a){const t=this.getExtensionElement(a);if(t){const h=this.nodes.get(t);if(h)return this.clearChildren(t),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(u=>{if(u){const s=this.createTreeNode(t,u,h.parent);return this.updateNodeCache(t,s,h,h.parent),h.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,t,h){const u=this.createTreeNode(a,t,h);if(t.id&&this.elements.has(u.item.handle))throw new Error((0,P.localize)(0,null,t.id));return this.addNodeToCache(a,u),this.addNodeToParentCache(u,h),u}getTooltip(a){return C.MarkdownString.isMarkdownString(a)?v.MarkdownString.from(a):a}getCommand(a,t){return t?{...this.commands.toInternal(t,a),originalId:t.command}:void 0}getCheckbox(a){if(a.checkboxState===void 0)return;let t,h,u;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,h=a.checkboxState.tooltip,u=a.checkboxState.accessibilityInformation),{isChecked:t===C.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:u}}validateTreeItem(a){if(!C.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,t,h){this.validateTreeItem(t);const u=this._register(new A.DisposableStore),s=this.createHandle(a,t,h),c=this.getLightIconPath(t);return{item:{handle:s,parentHandle:h?h.item.handle:void 0,label:o(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(u,t.command),contextValue:t.contextValue,icon:c,iconDark:this.getDarkIconPath(t)||c,themeIcon:this.getThemeIcon(t),collapsibleState:(0,L.isUndefinedOrNull)(t.collapsibleState)?C.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:h,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(a){return a.iconPath instanceof C.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:t,label:h,resourceUri:u},s,c){if(t)return`${n.ID_HANDLE_PREFIX}/${t}`;const d=o(h,this.extension),m=s?s.item.handle:n.LABEL_HANDLE_PREFIX;let D=d?d.label:u?(0,F.basename)(u):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,f=this.getChildrenNodes(s)||[];let S,T=0;do{if(S=`${m}/${T}:${D}`,c||!this.elements.has(S)||g===S)break;T++}while(T<=f.length);return S}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon))return typeof a.iconPath=="string"||p.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return p.URI.isUri(a)?a:p.URI.file(a)}addNodeToCache(a,t){this.elements.set(t.item.handle,a),this.nodes.set(a,t)}updateNodeCache(a,t,h,u){this.elements.delete(t.item.handle),this.nodes.delete(a),t.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(a,t);const s=this.getChildrenNodes(u)||[],c=s.filter(d=>d.item.handle===h.item.handle)[0];c&&s.splice(s.indexOf(c),1,t)}addNodeToParentCache(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const t=this.nodes.get(a);if(t){if(t.children)for(const h of t.children){const u=this.elements.get(h.item.handle);u&&this.clear(u)}t.children=void 0}}else this.clearAll()}clear(a){const t=this.nodes.get(a);if(t){if(t.children)for(const h of t.children){const u=this.elements.get(h.item.handle);u&&this.clear(u)}this.nodes.delete(a),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Ce[351],De([1,0,4,3,2,30,15,92,6,7]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class L extends F.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(_,l,b,o){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new P.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new P.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=_,this.#t=l,this.#n=b,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#l=o.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(_){this.assertNotDisposed(),this.#r!==_&&(this.#r=_,this.#t.$setTitle(this.#e,_))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(_){this.assertNotDisposed(),this.#a!==_&&(this.#a=_,this.#t.$setIconPath(this.#e,p.URI.isUri(_)?{light:_,dark:_}:_))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(_){this.#u||(this.active!==_.active||this.visible!==_.visible||this.viewColumn!==_.viewColumn)&&(this.#l=_.active,this.#c=_.visible,this.#o=_.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(_,l){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof _>"u"?void 0:A.ViewColumn.from(_),preserveFocus:!!l})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class I extends F.Disposable{static newHandle(){return(0,R.generateUuid)()}constructor(_,l,b){super(),this.webviews=l,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(_=>_.dispose()),this._webviewPanels.clear()}createWebviewPanel(_,l,b,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,w.shouldSerializeBuffersForPostMessage)(_),t=I.newHandle();this._proxy.$createWebviewPanel((0,w.toExtensionData)(_),t,l,{title:b,panelOptions:v(i),webviewOptions:(0,w.serializeWebviewOptions)(_,this.workspace,i),serializeBuffersForPostMessage:a},r);const h=this.webviews.createNewWebview(t,i,_);return this.createNewWebviewPanel(t,l,b,n,i,h,!0)}$onDidChangeWebviewPanelViewStates(_){const l=Object.keys(_);l.sort((b,o)=>{const i=_[b],n=_[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const b of l){const o=this.getWebviewPanel(b);if(!o)continue;const i=_[b];o._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(_){this.getWebviewPanel(_)?.dispose(),this._webviewPanels.delete(_),this.webviews.deleteWebview(_)}registerWebviewPanelSerializer(_,l,b){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:b,extension:_}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,w.shouldSerializeBuffersForPostMessage)(_)}),new C.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(_,l,b,o){const i=this._serializers.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:r}=i,a=this.webviews.createNewWebview(_,b.webviewOptions,r),t=this.createNewWebviewPanel(_,l,b.title,o,b.panelOptions,a,b.active);await n.deserializeWebviewPanel(t,b.state)}createNewWebviewPanel(_,l,b,o,i,n,r){const a=new L(_,this._proxy,n,{viewType:l,title:b,viewColumn:o,panelOptions:i,active:r});return this._webviewPanels.set(_,a),a}getWebviewPanel(_){return this._webviewPanels.get(_)}}e.ExtHostWebviewPanels=I;function v(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Ce[352],De([1,0,4,3,92,15,6,7]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends F.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,v,y,_,l,b){super(),this.#s=!1,this.#l=this._register(new P.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new P.Emitter),this.onDidDispose=this.#u.event,this.#i=y,this.#a=_,this.#e=I,this.#t=v,this.#n=l,this.#r=b}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(I){this.assertNotDisposed(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.assertNotDisposed(),this.#o}set description(I){this.assertNotDisposed(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(I){this.assertNotDisposed(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.assertNotDisposed(),this.#t.$show(this.#e,!!I)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class C{constructor(I,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(I,v,y,_){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:y,extension:I}),this._proxy.$registerWebviewViewProvider((0,p.toExtensionData)(I),v,{retainContextWhenHidden:_?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,p.shouldSerializeBuffersForPostMessage)(I)}),new w.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(I,v,y,_,l){const b=this._viewProviders.get(v);if(!b)throw new Error(`No view provider found for '${v}'`);const{provider:o,extension:i}=b,n=this._extHostWebview.createNewWebview(I,{},i),r=new E(I,this._proxy,v,y,n,!0);this._webviewViews.set(I,r),await o.resolveWebviewView(r,{state:_},l)}async $onDidChangeWebviewViewVisibility(I,v){this.getWebviewView(I)._setVisible(v)}async $disposeWebviewView(I){const v=this.getWebviewView(I);this._webviewViews.delete(I),v.dispose(),this._extHostWebview.deleteWebview(I)}getWebviewView(I){const v=this._webviewViews.get(I);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=C}),define(Ce[353],De([1,0,69,16,13,251,32,11]),function(me,e,P,F,p,R,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let E=class{constructor(I,v){I.addFileSystemProvider(F.Schemas.file,new C(v),{isCaseSensitive:w.isLinux})}};e.ExtHostDiskFileSystemProvider=E,e.ExtHostDiskFileSystemProvider=E=Ge([He(0,P.IExtHostConsumerFileSystem),He(1,p.ILogService)],E);class C{constructor(I){this.logService=I,this.impl=new R.DiskFileSystemProvider(this.logService)}async stat(I){const v=await this.impl.stat(I);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.impl.readdir(I)}createDirectory(I){return this.impl.mkdir(I)}readFile(I){return this.impl.readFile(I)}writeFile(I,v,y){return this.impl.writeFile(I,v,{...y,unlock:!1,atomic:!1})}delete(I,v){return this.impl.delete(I,{...v,useTrash:!1,atomic:!1})}rename(I,v,y){return this.impl.rename(I,v,y)}copy(I,v,y){return this.impl.copy(I,v,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,v){throw new Error("Method not implemented.")}}}),define(Ce[354],De([1,0,17,63,30,33,3,6,2,20]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends A.Disposable{constructor(v,y){super();const _=v.getProxy(w.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async l=>{const b=E.URI.file((0,P.join)((0,F.tmpdir)(),(0,p.generateUuid)()));return await _.$download(l,b),b})}};e.ExtHostDownloadService=L,e.ExtHostDownloadService=L=Ge([He(0,C.IExtHostRpcService),He(1,R.IExtHostCommands)],L)}),define(Ce[355],De([1,0,57,17,2,93,3,16,8,31]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const h=await super._getWorkspaceStorageURI(t);if(h.scheme!==w.Schemas.file)return h;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const u=h.fsPath;let s=0;do{let c;s===0?c=u:c=/[/\\]$/.test(u)?`${u.substr(0,u.length-1)}-${s}`:`${u}-${s}`,await I(c);const d=F.join(c,"vscode.lock"),m=await l(this._logService,d,!1);if(m)return this._workspaceStorageLock=m,process.on("exit",()=>{m.dispose()}),p.URI.file(c);s++}while(s<10);return h}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function I(a){try{await C.Promises.stat(a);return}catch{}try{await C.Promises.mkdir(a,{recursive:!0})}catch{}}const v=1e3,y=10*60*1e3;class _ extends A.Disposable{constructor(t,h){super(),this.logService=t,this.filename=h,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const u=await b(t,h);(!u||u.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this._timer.cancel());try{await C.Promises.utimes(h,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${h}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{P.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await C.Promises.writeFile(this.filename,JSON.stringify(h),{flag:"w"})}catch(h){this.logService.error(h)}}}async function l(a,t,h){try{const s={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){a.error(s)}const u=await b(a,t);return!u||u.pid!==process.pid?h?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new _(a,t))}async function b(a,t){let h;try{h=await C.Promises.readFile(t)}catch(u){return a.error(u),null}try{return JSON.parse(String(h))}catch(u){return a.error(u),null}}async function o(a,t){let h;try{h=await C.Promises.stat(t)}catch(u){return a.error(u),0}return h.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const h=await b(a,t);if(!h)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(h.willReleaseAt){let m=h.willReleaseAt-Date.now();if(m<5e3){for(m>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${m} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);m>0;){if(await(0,E.timeout)(Math.min(100,m)),await o(a,t)===0)return r(a,t);m=h.willReleaseAt-Date.now()}return r(a,t)}}if(!i(h.pid))return a.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),r(a,t);const u=await o(a,t),s=Date.now()-u;if(s<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const c=await o(a,t),d=Date.now()-c;return d<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await C.Promises.unlink(t)}catch{}return l(a,t,!0)}}),define(Ce[356],De([1,0,30,20,46,33]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends p.BaseExtHostTerminalService{constructor(E,C){super(!0,E,C)}createTerminal(E,C,L){return this.createTerminalFromOptions({name:E,shellPath:C,shellArgs:L})}createTerminalFromOptions(E,C){const L=new p.ExtHostTerminal(this._proxy,(0,P.generateUuid)(),E,E.name);return this._terminals.push(L),L.create(E,this._serializeParentTerminal(E,C)),L.value}};e.ExtHostTerminalService=A,e.ExtHostTerminalService=A=Ge([He(0,R.IExtHostCommands),He(1,F.IExtHostRpcService)],A)}),define(Ce[357],De([1,0,4,37,45,5]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new p.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new p.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new p.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.channels=new Map,this._onDidRegisterChannel=new P.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new P.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(C){this.channels.has(C.id)||(this.channels.set(C.id,C),this._onDidRegisterChannel.fire(C.id))}getChannels(){const C=[];return this.channels.forEach(L=>C.push(L)),C}getChannel(C){return this.channels.get(C)}removeChannel(C){this.channels.delete(C),this._onDidRemoveChannel.fire(C)}}F.Registry.add(e.Extensions.OutputChannels,new w),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new p.RawContextKey("activeOutputChannel","")}),define(Ce[153],De([1,0,6,5,20,25,13,357,69,27,59,183,21,18,32,4,3]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(a,t,h,u,s){super(),this.id=a,this.name=t,this.logger=h,this.proxy=u,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(h.getLevel()),this._register(h.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.offset;this.logger.flush(),this.proxy.$update(this.id,w.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.offset;this.info(a),this.proxy.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(a,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.proxy.$close(this.id)}log(a,t){this.offset+=v.VSBuffer.fromString(t).byteLength,(0,A.log)(this.logger,a,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,h,u,s,c){this.initData=t,this.extHostFileSystem=h,this.extHostFileSystemInfo=u,this.loggerService=s,this.logService=c,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=a.getProxy(P.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.visibleChannelId=a;for(const[t,h]of this.channels)h.visible=t===this.visibleChannelId}createOutputChannel(a,t,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const u=typeof t=="object"&&t.log,s=(0,y.isString)(t)?t:void 0;if((0,y.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const d=this.initData.environment.extensionLogLevel?.find(([D])=>R.ExtensionIdentifier.equals(h.identifier,D))?.[1];d&&(c=(0,A.parseLogLevel)(d));const m=u?this.doCreateLogOutputChannel(a,c,h):this.doCreateOutputChannel(a,s,h);return m.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),u?this.createExtHostLogOutputChannel(a,c??this.logService.getLevel(),m):this.createExtHostOutputChannel(a,m)}async doCreateOutputChannel(a,t,h){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const u=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(u,`${this.namePool++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.proxy.$register(a,s,t,h.identifier.value);return new o(d,a,c,this.proxy,h)}async doCreateLogOutputChannel(a,t,h){const u=await this.createExtensionLogDirectory(h),s=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.extHostFileSystemInfo.extUri.joinPath(u,`${s}.log`),d=`${h.identifier.value}.${s}`,m=this.loggerService.createLogger(c,{id:d,name:a,logLevel:t,extensionId:h.identifier.value});return new i(d,a,m,this.proxy,h)}createExtensionLogDirectory(a){let t=this.extensionLogDirectoryPromise.get(a.identifier.value);if(!t){const h=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,a.identifier.value);this.extensionLogDirectoryPromise.set(a.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(h)}catch(u){if((0,_.toFileSystemProviderErrorCode)(u)!==_.FileSystemProviderErrorCode.FileExists)throw u}return h})())}return t}createExtHostOutputChannel(a,t){let h=!1;const u=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return a},append(s){u(),t.then(c=>c.append(s))},appendLine(s){u(),t.then(c=>c.appendLine(s))},clear(){u(),t.then(s=>s.clear())},replace(s){u(),t.then(c=>c.replace(s))},show(s,c){u(),t.then(d=>d.show(s,c))},hide(){u(),t.then(s=>s.hide())},dispose(){h=!0,t.then(s=>s.dispose())}}}createExtHostLogOutputChannel(a,t,h){const u=new b.DisposableStore,s=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},c=u.add(new l.Emitter);function d(m){t=m,c.fire(m)}return h.then(m=>{u.add(m),m.logLevel!==t&&d(m.logLevel),u.add(m.onDidChangeLogLevel(D=>d(D)))}),{...this.createExtHostOutputChannel(a,h),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(m,...D){s(),h.then(g=>g.trace(m,...D))},debug(m,...D){s(),h.then(g=>g.debug(m,...D))},info(m,...D){s(),h.then(g=>g.info(m,...D))},warn(m,...D){s(),h.then(g=>g.warn(m,...D))},error(m,...D){s(),h.then(g=>g.error(m,...D))},dispose(){u.dispose()}}}};e.ExtHostOutputService=n,e.ExtHostOutputService=n=Ge([He(0,p.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,E.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,A.ILoggerService),He(5,A.ILogService)],n),e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(Ce[154],De([1,0,5,8]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,P.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(p){let R=1/0;for(let w=0;w<this.maxSampleCount;w++){const E=await p.getRoundTripTime();if(E===void 0)return;R=Math.min(R,E/2),await(0,F.timeout)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((w,E)=>w+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((w,E)=>w+E,0)/this.average.length,high:typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[358],De([1,0,225,86,37,41,52,3,4,154,11,24,8]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,P.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,P.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,P.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,P.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new E.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const _=new y;p.Registry.add(e.Extensions.ConfigurationMigration,_);let l=class extends w.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.configurationService=i,this.workspaceService=n,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async r=>{for(const a of r.added)await this.migrateConfigurationsForFolder(a,_.migrations)})),this.migrateConfigurations(_.migrations),this._register(_.onDidRegisterConfigurationMigration(r=>this.migrateConfigurations(r)))}async migrateConfigurations(i){await this.migrateConfigurationsForFolder(void 0,i);for(const n of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(n,i)}async migrateConfigurationsForFolder(i,n){await Promise.all([n.map(r=>this.migrateConfigurationsForFolderAndOverride(r,i?.uri))])}async migrateConfigurationsForFolderAndOverride(i,n){const r=this.configurationService.inspect(i.key,{resource:n}),a=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,h]of a){const u=r[t];if(!u)continue;const s=[];if(u.value!==void 0){const c=await this.runMigration(i,t,u.value,n,void 0);for(const d of c??[])s.push([d,[]])}for(const{identifiers:c,value:d}of u.overrides??[])if(d!==void 0){const m=await this.runMigration(i,t,d,n,c);for(const D of m??[])s.push([D,c])}s.length&&await Promise.allSettled(s.map(async([[c,d],m])=>this.configurationService.updateValue(c,d.value,{resource:n,overrideIdentifiers:m},h)))}}async runMigration(i,n,r,a,t){const h=s=>{const d=this.configurationService.inspect(s,{resource:a})[n];if(d)return t?d.overrides?.find(({identifiers:m})=>(0,I.equals)(m,t))?.value:d.value},u=await i.migrateFn(r,h);return Array.isArray(u)?u:[[i.key,u]]}};e.ConfigurationMigrationWorkbenchContribution=l,e.ConfigurationMigrationWorkbenchContribution=l=Ge([He(0,A.IConfigurationService),He(1,R.IWorkspaceContextService)],l);let b=class extends w.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.remoteAgentService=i,this._ready=new v.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!L.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==1)return;p.Registry.as(F.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,P.localize)(4,null)},default:[],markdownDescription:(0,P.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,P.localize)(6,null),scope:2}}})}};e.DynamicWorkbenchSecurityConfiguration=b,e.DynamicWorkbenchSecurityConfiguration=b=Ge([He(0,C.IRemoteAgentService)],b)}),define(Ce[359],De([1,0,35,16,17,23,234,358,86,5,37]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.globMatchesResource=e.priorityToRank=e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.IEditorResolverService=(0,C.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const I=L.Registry.as(E.Extensions.Configuration),v={...w.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(v);var y;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(y||(e.RegisteredEditorPriority=y={}));var _;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(_||(e.ResolvedStatus=_={}));function l(o){switch(o){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}e.priorityToRank=l;function b(o,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(p.posix.sep)>=0?`${i.scheme}:${i.path}`:(0,R.basename)(i);return P.match(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.globMatchesResource=b}),define(Ce[360],De([1,0,34,16,17,11,23,2,5,269,41,144,154]),function(me,e,P,F,p,R,A,w,E,C,L,I,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let _=y=class{constructor(b,o,i,n){this.localUserHome=b,this.remoteAgentService=o,this.environmentService=i,this.contextService=n,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||R.OS)(),this.resolveUserHome=(async()=>{const r=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=r?.userHome??b})()}hasValidBasename(b,o,i){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(n=>this.doHasValidBasename(b,n,o)):this.doHasValidBasename(b,o,i)}doHasValidBasename(b,o,i){return b.scheme===F.Schemas.file||b.scheme===F.Schemas.vscodeRemote?(0,P.isValidBasename)(i??(0,A.basename)(b),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,o){if(b.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,C.getVirtualWorkspaceScheme)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:F.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?p.win32:p.posix)}async fileURI(b){let o="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const n=b.indexOf("/",2);n===-1?(o=b.substring(2),b="/"):(o=b.substring(2,n),b=b.substring(n)||"/")}return w.URI.from({scheme:F.Schemas.file,authority:o,path:b,query:"",fragment:""})}};e.AbstractPathService=_,e.AbstractPathService=_=y=Ge([He(1,v.IRemoteAgentService),He(2,I.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],_)}),define(Ce[361],De([1,0,236,19,53,4,54,3,2,52,241,13,64,271,88,41,144,26,22,18,24,45]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.isCandidatePort=e.OnPortForward=e.makeAddress=e.mapHasAddressLocalhostOrAllInterfaces=e.mapHasAddress=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.parseAddress=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0;const t=10*1e3,h="remote.tunnels.toRestore",u="remote.tunnels.toRestoreExpiration",s=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new a.RawContextKey("forwardedPortsViewEnabled",!1,P.localize(0,null));function c(x){const M=x.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}e.parseAddress=c;var d;(function(x){x.Other="Other",x.User="User",x.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var m;(function(x){x[x.User=0]="User",x[x.Auto=1]="Auto",x[x.Extension=2]="Extension"})(m||(e.TunnelSource=m={})),e.UserTunnelSource={source:m.User,description:P.localize(1,null)},e.AutoTunnelSource={source:m.Auto,description:P.localize(2,null)};function D(x,M,k){const O=x.get(f(M,k));if(O)return O;if((0,_.isLocalhost)(M))for(const U of _.LOCALHOST_ADDRESSES){const q=f(U,k);if(x.has(q))return x.get(q)}else if((0,_.isAllInterfaces)(M))for(const U of _.ALL_INTERFACES_ADDRESSES){const q=f(U,k);if(x.has(q))return x.get(q)}}e.mapHasAddress=D;function g(x,M,k){const O=D(x,M,k);if(O)return O;const U=(0,_.isAllInterfaces)(M)?"localhost":(0,_.isLocalhost)(M)?"0.0.0.0":void 0;if(U)return D(x,U,k)}e.mapHasAddressLocalhostOrAllInterfaces=g;function f(x,M){return x+":"+M}e.makeAddress=f;var S;(function(x){x.Notify="notify",x.OpenBrowser="openBrowser",x.OpenBrowserOnce="openBrowserOnce",x.OpenPreview="openPreview",x.Silent="silent",x.Ignore="ignore"})(S||(e.OnPortForward=S={}));function T(x){return x&&"host"in x&&typeof x.host=="string"&&"port"in x&&typeof x.port=="number"&&(!("detail"in x)||typeof x.detail=="string")&&(!("pid"in x)||typeof x.pid=="string")}e.isCandidatePort=T;class N extends w.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.configurationService=M,this.portsAttributes=[],this._onDidChangeAttributes=new R.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(M.onDidChangeConfiguration(k=>{(k.affectsConfiguration(N.SETTING)||k.affectsConfiguration(N.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(M,k,O){let U=this.findNextIndex(M,k,O,this.portsAttributes,0);const q={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const ie=this.portsAttributes[U];ie.key===M?(q.onAutoForward=ie.onAutoForward??q.onAutoForward,q.elevateIfNeeded=ie.elevateIfNeeded!==void 0?ie.elevateIfNeeded:q.elevateIfNeeded,q.label=ie.label??q.label,q.requireLocalPort=ie.requireLocalPort,q.protocol=ie.protocol):(q.onAutoForward=q.onAutoForward??ie.onAutoForward,q.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:ie.elevateIfNeeded,q.label=q.label??ie.label,q.requireLocalPort=q.requireLocalPort!==void 0?q.requireLocalPort:void 0,q.protocol=q.protocol??ie.protocol),U=this.findNextIndex(M,k,O,this.portsAttributes,U+1)}return q.onAutoForward!==void 0||q.elevateIfNeeded!==void 0||q.label!==void 0||q.requireLocalPort!==void 0||q.protocol!==void 0?q:this.getOtherAttributes()}hasStartEnd(M){return M.start!==void 0&&M.end!==void 0}hasHostAndPort(M){return M.host!==void 0&&M.port!==void 0&&(0,n.isString)(M.host)&&(0,n.isNumber)(M.port)}findNextIndex(M,k,O,U,q){if(q>=U.length)return-1;const ie=!(0,_.isLocalhost)(k)&&!(0,_.isAllInterfaces)(k),Q=U.slice(q).findIndex(Y=>(0,n.isNumber)(Y.key)?ie?!1:Y.key===M:this.hasStartEnd(Y.key)?ie?!1:M>=Y.key.start&&M<=Y.key.end:this.hasHostAndPort(Y.key)?M===Y.key.port&&k===Y.key.host:O?Y.key.test(O):!1);return Q>=0?Q+q:-1}readSetting(){const M=this.configurationService.getValue(N.SETTING);if(!M||!(0,n.isObject)(M))return[];const k=[];for(const U in M){if(U===void 0)continue;const q=M[U];let ie;if(Number(U))ie=Number(U);else if((0,n.isString)(U))if(N.RANGE.test(U)){const Z=U.match(N.RANGE);ie={start:Number(Z[1]),end:Number(Z[2])}}else if(N.HOST_AND_PORT.test(U)){const Z=U.match(N.HOST_AND_PORT);ie={host:Z[1],port:Number(Z[2])}}else{let Z;try{Z=RegExp(U)}catch{}Z&&(ie=Z)}ie&&k.push({key:ie,elevateIfNeeded:q.elevateIfNeeded,onAutoForward:q.onAutoForward,label:q.label,requireLocalPort:q.requireLocalPort,protocol:q.protocol})}const O=this.configurationService.getValue(N.DEFAULTS);return O&&(this.defaultPortAttributes={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.sortAttributes(k)}sortAttributes(M){function k(O,U){return(0,n.isNumber)(O.key)?O.key:U.hasStartEnd(O.key)?O.key.start:U.hasHostAndPort(O.key)?O.key.port:Number.MAX_VALUE}return M.sort((O,U)=>k(O,this)-k(U,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(M){switch(M){case _.ProvidedOnAutoForward.Notify:return S.Notify;case _.ProvidedOnAutoForward.OpenBrowser:return S.OpenBrowser;case _.ProvidedOnAutoForward.OpenBrowserOnce:return S.OpenBrowserOnce;case _.ProvidedOnAutoForward.OpenPreview:return S.OpenPreview;case _.ProvidedOnAutoForward.Silent:return S.Silent;case _.ProvidedOnAutoForward.Ignore:return S.Ignore;default:return}}async addAttributes(M,k,O){const q=this.configurationService.inspect(N.SETTING).userRemoteValue;let ie;!q||!(0,n.isObject)(q)?ie={}:ie=(0,r.deepClone)(q),ie[`${M}`]||(ie[`${M}`]={});for(const Z in k)ie[`${M}`][Z]=k[Z];return this.configurationService.updateValue(N.SETTING,ie,O)}}e.PortsAttributes=N;let z=class extends w.Disposable{constructor(M,k,O,U,q,ie,Z,Q,Y,ae){super(),this.tunnelService=M,this.storageService=k,this.configurationService=O,this.environmentService=U,this.remoteAuthorityResolverService=q,this.workspaceContextService=ie,this.logService=Z,this.dialogService=Q,this.extensionService=Y,this.contextKeyService=ae,this.inProgress=new Map,this._onForwardPort=new R.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new R.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new R.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new R.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new R.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new R.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new N(O),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async ee=>{const fe=await this.getAttributes(ee.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ee)if(re.localAddress){const G=f(re.tunnelRemoteHost,re.tunnelRemotePort),B=g(this._candidates??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(G,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:fe?.get(re.tunnelRemotePort)?.protocol??_.TunnelProtocol.Http,localUri:await this.makeLocalUri(re.localAddress,fe?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:re.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(G,re)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async ee=>{const fe=f(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!g(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!g(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!g(this.inProgress,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const re=g(this._candidates??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),G=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(fe,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:G?.protocol??_.TunnelProtocol.Http,localUri:await this.makeLocalUri(ee.localAddress,G),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ee.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(fe,ee),this._onForwardPort.fire(this.forwarded.get(fe))})),this._register(this.tunnelService.onTunnelClosed(ee=>this.onTunnelClosed(ee,d.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(M=>M.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const M=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&M.dispose()}))}async onTunnelClosed(M,k){const O=f(M.host,M.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.storeForwarded(),this._onClosePort.fire(M))}makeLocalUri(M,k){if(M.startsWith("http"))return E.URI.parse(M);const O=k?.protocol??"http";return E.URI.parse(`${O}://${M}`)}async addStorageKeyPostfix(M){const k=this.workspaceContextService.getWorkspace(),O=k.configuration?(0,A.hash)(k.configuration.path):k.folders.length>0?(0,A.hash)(k.folders[0].uri.path):void 0;if(O===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${M}.${this.environmentService.remoteAuthority}.${O}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(h)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(u)}async getTunnelRestoreValue(){const M=this.storageService.get(h,1);if(M)return this.storageService.remove(h,1),await this.storeForwarded(),M;const k=await this.getTunnelRestoreStorageKey();if(k)return this.storageService.get(k,0)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const M=await this.tunnelRestoreValue;if(M&&M!==this.knownPortsRestoreValue){const k=JSON.parse(M)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${k.map(O=>O.remotePort).join(", ")}`);for(const O of k){const U=g(this.detected,O.remoteHost,O.remotePort);O.source.source!==m.Extension&&!U||O.source.source===m.Extension&&U?await this.doForward({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,elevateIfNeeded:!0,source:O.source}):O.source.source===m.Extension&&!U&&this.unrestoredExtensionTunnels.set(f(O.remoteHost,O.remotePort),O)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const M=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new w.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async k=>{k.key===M&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(M,0)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const M=this.storageService.keys(0,0).filter(k=>k.startsWith(u));for(const k of M){const O=this.storageService.getNumber(k,0);if(O&&O<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const U=k.replace(u,h);this.storageService.remove(k,0),this.storageService.remove(U,0)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const M=Array.from(this.forwarded.values()),k=M.map(ie=>({remoteHost:ie.remoteHost,remotePort:ie.remotePort,localPort:ie.localPort,name:ie.name,localAddress:ie.localAddress,localUri:ie.localUri,protocol:ie.protocol,source:ie.source}));let O;M.length>0&&(O=JSON.stringify(k));const U=await this.getTunnelRestoreStorageKey(),q=await this.getRestoreExpirationStorageKey();!O&&U&&q?(this.storageService.remove(U,0),this.storageService.remove(q,0)):O!==this.knownPortsRestoreValue&&U&&q&&(this.storageService.store(U,O,0,0),this.storageService.store(q,Date.now()+s,0,0)),this.knownPortsRestoreValue=O}}async showPortMismatchModalIfNeeded(M,k,O){if(!M.tunnelLocalPort||!O?.requireLocalPort||M.tunnelLocalPort===k)return;const U=new Date;if(this.mismatchCooldown.getTime()+t>U.getTime())return;this.mismatchCooldown=U;const q=P.localize(3,null,k,M.tunnelRemotePort,M.tunnelLocalPort);return this.dialogService.info(q)}async forward(M,k){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await R.Event.toPromise(this.onRestoreComplete.event),this.doForward(M,k)}async doForward(M,k){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const O=g(this.forwarded,M.remote.host,M.remote.port);k=k??(k!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const U=M.local!==void 0?M.local:M.remote.port;let q;if(O)return this.mergeAttributesIntoExistingTunnel(O,M,k);{const ie=this.environmentService.remoteAuthority,Z=ie?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(ie)).authority}:void 0,Q=f(M.remote.host,M.remote.port);this.inProgress.set(Q,!0),M=this.mergeCachedAndUnrestoredProperties(Q,M);const Y=await this.tunnelService.openTunnel(Z,M.remote.host,M.remote.port,void 0,U,M.elevateIfNeeded?M.elevateIfNeeded:k?.elevateIfNeeded,M.privacy,k?.protocol);if(typeof Y=="string")q=Y;else if(Y&&Y.localAddress){const ae=g(this._candidates??new Map,M.remote.host,M.remote.port),ee=Y.protocol?Y.protocol===_.TunnelProtocol.Https?_.TunnelProtocol.Https:_.TunnelProtocol.Http:k?.protocol??_.TunnelProtocol.Http,fe={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:k?.label??M.name,closeable:!0,localAddress:Y.localAddress,protocol:ee,localUri:await this.makeLocalUri(Y.localAddress,k),runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,source:M.source??e.UserTunnelSource,privacy:Y.privacy};return this.forwarded.set(Q,fe),this.remoteTunnels.set(Q,Y),this.inProgress.delete(Q),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(Y,U,k),this._onForwardPort.fire(fe),Y}this.inProgress.delete(Q)}return q}mergeCachedAndUnrestoredProperties(M,k){const O=this.unrestoredExtensionTunnels.has(M)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(M)?this.sessionCachedProperties:void 0;if(O){const U=O.get(M);O.delete(M),U&&(k.name=U.name??k.name,k.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??k.local,k.privacy=k.privacy)}return k}async mergeAttributesIntoExistingTunnel(M,k,O){const U=O?.label??k.name;let q;(function(Z){Z[Z.None=0]="None",Z[Z.Fire=1]="Fire",Z[Z.Reopen=2]="Reopen"})(q||(q={}));let ie=q.None;switch(U!==M.name&&(M.name=U,ie=q.Fire),(O?.protocol||M.protocol!==_.TunnelProtocol.Http)&&O?.protocol!==M.protocol&&(k.source=M.source,ie=q.Reopen),k.privacy&&M.privacy!==k.privacy&&(ie=q.Reopen),ie){case q.Fire:{this._onForwardPort.fire();break}case q.Reopen:await this.close(M.remoteHost,M.remotePort,d.User),await this.doForward(k,O)}return g(this.remoteTunnels,k.remote.host,k.remote.port)}async name(M,k,O){const U=g(this.forwarded,M,k),q=f(M,k);if(U){U.name=O,await this.storeForwarded(),this._onPortName.fire({host:M,port:k});return}else this.detected.has(q)&&(this.detected.get(q).name=O,this._onPortName.fire({host:M,port:k}))}async close(M,k,O){const U=f(M,k),q=this.forwarded.get(U);return O===d.AutoForwardEnd&&q&&q.source.source===m.Auto&&this.sessionCachedProperties.set(U,{local:q.localPort,name:q.name,privacy:q.privacy}),await this.tunnelService.closeTunnel(M,k),this.onTunnelClosed({host:M,port:k},O)}address(M,k){const O=f(M,k);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(M){if(M)for(const k of M){const O=g(this._candidates??new Map,k.remoteAddress.host,k.remoteAddress.port),U=typeof k.localAddress=="string"?k.localAddress:f(k.localAddress.host,k.localAddress.port);this.detected.set(f(k.remoteAddress.host,k.remoteAddress.port),{remoteHost:k.remoteAddress.host,remotePort:k.remoteAddress.port,localAddress:U,protocol:_.TunnelProtocol.Http,localUri:this.makeLocalUri(U),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:_.TunnelPrivacyId.ConstantPrivate,source:{source:m.Extension,description:P.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(k.remoteAddress.host,k.remoteAddress.port,U,_.TunnelPrivacyId.ConstantPrivate,_.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(M){this._candidateFilter=M}async setCandidates(M){let k=M;this._candidateFilter&&(k=await this._candidateFilter(M));const O=this.updateInResponseToCandidates(k);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(U=>U.port).join(", ")}`),this._onCandidatesChanged.fire(O)}updateInResponseToCandidates(M){const k=this._candidates??new Map,O=new Map;return this._candidates=O,M.forEach(U=>{const q=f(U.host,U.port);O.set(q,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),k.has(q)&&k.delete(q);const ie=g(this.forwarded,U.host,U.port);ie&&(ie.runningProcess=U.detail,ie.hasRunningProcess=!0,ie.pid=U.pid)}),k.forEach((U,q)=>{const ie=c(q);if(!ie)return;const Z=g(this.forwarded,ie.host,ie.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0);const Q=g(this.detected,ie.host,ie.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),k}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const M=Array.from(this.forwarded.values()),k=await this.getAttributes(M.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(k)for(const O of M){const U=k.get(O.remotePort);(U?.protocol||O.protocol!==_.TunnelProtocol.Http)&&U?.protocol!==O.protocol&&await this.doForward({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},U),U&&U.label&&U.label!==O.name&&await this.name(O.remoteHost,O.remotePort,U.label)}}async getAttributes(M,k=!0){const O=new Map,U=new Map;M.forEach(Y=>{const ae=g(this._candidates??new Map,_.LOCALHOST_ADDRESSES[0],Y.port)??Y;if(ae){O.set(Y.port,ae);const ee=T(ae)?ae.pid:void 0;U.has(ee)||U.set(ee,[]),U.get(ee)?.push(Y.port)}});const q=new Map;if(M.forEach(Y=>{const ae=this.configPortsAttributes.getAttributes(Y.port,Y.host,O.get(Y.port)?.detail);ae&&q.set(Y.port,ae)}),this.portAttributesProviders.length===0||!k)return q.size>0?q:void 0;const ie=await Promise.all((0,F.flatten)(this.portAttributesProviders.map(Y=>Array.from(U.entries()).map(ae=>{const ee=ae[1],fe=O.get(ee[0]);return Y.providePortAttributes(ee,fe?.pid,fe?.detail,new i.CancellationTokenSource().token)})))),Z=new Map;if(ie.forEach(Y=>Y.forEach(ae=>{ae&&Z.set(ae.port,ae)})),!q&&!Z)return;const Q=new Map;return M.forEach(Y=>{const ae=q.get(Y.port),ee=Z.get(Y.port);Q.set(Y.port,{elevateIfNeeded:ae?.elevateIfNeeded,label:ae?.label,onAutoForward:ae?.onAutoForward??N.providedActionToAction(ee?.autoForwardAction),requireLocalPort:ae?.requireLocalPort,protocol:ae?.protocol})}),Q}addAttributesProvider(M){this.portAttributesProviders.push(M)}};e.TunnelModel=z,Ge([(0,p.debounce)(1e3)],z.prototype,"storeForwarded",null),e.TunnelModel=z=Ge([He(0,_.ITunnelService),He(1,y.IStorageService),He(2,C.IConfigurationService),He(3,b.IWorkbenchEnvironmentService),He(4,v.IRemoteAuthorityResolverService),He(5,l.IWorkspaceContextService),He(6,I.ILogService),He(7,L.IDialogService),He(8,o.IExtensionService),He(9,a.IContextKeyService)],z)}),define(Ce[94],De([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class P{constructor(A,w){this.line=A,this.character=w}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,w){return new P(0,0)}with(A){return new P(0,0)}}e.Position=P;class F{constructor(A,w,E,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new P(A,w),this.end=new P(E,C)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var p;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(p||(e.TextSearchCompleteMessageType=p={}))}),define(Ce[36],De([1,0,19,35,24,34,12,5,17,14,94,8]),function(me,e,P,F,p,R,A,w,E,C,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",y=" characters skipped \u27EB",_=(v.length+y.length+5)*2;e.ISearchService=(0,w.createDecorator)("searchService");var l;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(l||(e.SearchProviderType=l={}));var b;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(b||(e.QueryType=b={}));function o(Y){return!!Y.preview}e.resultIsMatch=o;function i(Y){return!!Y.resource}e.isFileMatch=i;function n(Y){return!!Y.message}e.isProgressMessage=n;var r;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=a;class t{constructor(ae,ee,fe,re){this.ranges=ee,this.webviewIndex=re;const G=Array.isArray(ee)?ee:[ee];if(fe&&fe.matchLines===1&&h(G)){ae=(0,A.getNLines)(ae,fe.matchLines);let B="",se=0,ye=0;const le=Math.floor(fe.charsPerLine/5),de=[];for(const ce of G){const he=Math.max(ce.startColumn-le,0),V=ce.startColumn+fe.charsPerLine;if(he>ye+le+_){const J=v+(he-ye)+y;B+=J+ae.slice(he,V),se+=he-(ye+J.length)}else B+=ae.slice(ye,V);de.push(new s(0,ce.startColumn-se,ce.endColumn-se)),ye=V}this.preview={text:B,matches:Array.isArray(this.ranges)?de:de[0]}}else{const B=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ae,matches:(0,P.mapArrayOrNot)(ee,se=>new u(se.startLineNumber-B,se.startColumn,se.endLineNumber-B,se.endColumn))}}}}e.TextSearchMatch=t;function h(Y){const ae=Y[0].startLineNumber;for(const ee of Y)if(ee.startLineNumber!==ae||ee.endLineNumber!==ae)return!1;return!0}class u{constructor(ae,ee,fe,re){this.startLineNumber=ae,this.startColumn=ee,this.endLineNumber=fe,this.endColumn=re}}e.SearchRange=u;class s extends u{constructor(ae,ee,fe){super(ae,ee,ae,fe)}}e.OneLineRange=s;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c||(e.ViewMode=c={}));var d;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function m(Y,ae=!0){const ee=Y&&Y.files&&Y.files.exclude,fe=ae&&Y&&Y.search&&Y.search.exclude;if(!ee&&!fe)return;if(!ee||!fe)return ee||fe;let re=Object.create(null);return re=p.mixin(re,p.deepClone(ee)),re=p.mixin(re,p.deepClone(fe),!0),re}e.getExcludes=m;function D(Y,ae){return Y.excludePattern&&F.match(Y.excludePattern,ae)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&F.match(Y.includePattern,ae)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ee=>{const fe=ee.folder.fsPath;if(R.isEqualOrParent(ae,fe)){const re=E.relative(fe,ae);return!ee.includePattern||!!F.match(ee.includePattern,re)}else return!1}):!1:!0}e.pathIncludedInQuery=D;var g;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class f extends Error{constructor(ae,ee){super(ae),this.code=ee}}e.SearchError=f;function S(Y){const ae=Y.message;if((0,C.isCancellationError)(Y))return new f(ae,g.canceled);try{const ee=JSON.parse(ae);return new f(ee.message,ee.code)}catch{return new f(ae,g.other)}}e.deserializeSearchError=S;function T(Y){const ae={message:Y.message,code:Y.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=T;function N(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=N;function z(Y){return Y.type==="success"}e.isSerializedSearchSuccess=z;function x(Y){return!!Y.path}e.isSerializedFileMatch=x;function M(Y,ae,ee=!0){const fe=Y.searchPath?Y.searchPath:Y.relativePath;return ee?(0,A.fuzzyContains)(fe,ae):F.match(ae,fe)}e.isFilePatternMatch=M;class k{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=k;function O(Y,ae){const ee={...Y||{},...ae||{}};return Object.keys(ee).filter(fe=>{const re=ee[fe];return typeof re=="boolean"&&re})}e.resolvePatternsForProvider=O;class U{constructor(ae,ee){this._parsedIncludeExpression=null,this._excludeExpression={...ae.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let fe=ae.includePattern;ee.includePattern&&(fe?fe={...fe,...ee.includePattern}:fe=ee.includePattern),fe&&(this._parsedIncludeExpression=F.parse(fe))}matchesExcludesSync(ae,ee,fe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,ee,fe))}includedInQuerySync(ae,ee,fe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ae,ee,fe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ae,ee,fe))}includedInQuery(ae,ee,fe){const re=this._parsedExcludeExpression(ae,ee,fe),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ae,ee,fe):!0;return(0,I.isThenable)(re)?re.then(B=>B?!1:G()):G()}hasSiblingExcludeClauses(){return q(this._excludeExpression)}}e.QueryGlobTester=U;function q(Y){for(const ae in Y)if(typeof Y[ae]!="boolean")return!0;return!1}function ie(Y){if(!Y)return;let ae;return ee=>(ae||(ae=(Y()||Promise.resolve([])).then(fe=>fe?Q(fe):{})),ae.then(fe=>!!fe[ee]))}e.hasSiblingPromiseFn=ie;function Z(Y){if(!Y)return;let ae;return ee=>{if(!ae){const fe=Y();ae=fe?Q(fe):{}}return!!ae[ee]}}e.hasSiblingFn=Z;function Q(Y){const ae={};for(const ee of Y)ae[ee]=!0;return ae}}),define(Ce[42],De([1,0,19,8,22,4,3,77,16,122,23,12,2,223,5,13,254,41,59,27,20,15,7,66,36,6,56]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h,u,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(z,x,M){return new L.ExtUri(k=>f(k,M)).isEqual(z,x)}function m(z,x,M){return d(z.uri,x.uri,M)?0:(0,I.compare)(z.uri.toString(),x.uri.toString())}function D(z,x,M){return z.index!==x.index?z.index<x.index?-1:1:d(z.uri,x.uri,M)?(0,I.compare)(z.name,x.name):(0,I.compare)(z.uri.toString(),x.uri.toString())}function g(z,x,M,k){const O=z.slice(0).sort((q,ie)=>M(q,ie,k)),U=x.slice(0).sort((q,ie)=>M(q,ie,k));return(0,P.delta)(O,U,(q,ie)=>M(q,ie,k))}function f(z,x){const M=x.getCapabilities(z.scheme);return!(M&&M&1024)}class S extends o.Workspace{static toExtHostWorkspace(x,M,k,O){if(!x)return{workspace:null,added:[],removed:[]};const{id:U,name:q,folders:ie,configuration:Z,transient:Q,isUntitled:Y}=x,ae=[],ee=M;M?ie.forEach((B,se)=>{const ye=v.URI.revive(B.uri),le=S._findFolder(k||M,ye,O);le?(le.name=B.name,le.index=B.index,ae.push(le)):ae.push({uri:ye,name:B.name,index:se})}):ae.push(...ie.map(({uri:B,name:se,index:ye})=>({uri:v.URI.revive(B),name:se,index:ye}))),ae.sort((B,se)=>B.index<se.index?-1:1);const fe=new S(U,q,ae,!!Q,Z?v.URI.revive(Z):null,!!Y,B=>f(B,O)),{added:re,removed:G}=g(ee?ee.workspaceFolders:[],fe.workspaceFolders,m,O);return{workspace:fe,added:re,removed:G}}static _findFolder(x,M,k){for(let O=0;O<x.folders.length;O++){const U=x.workspaceFolders[O];if(d(U.uri,M,k))return U}}constructor(x,M,k,O,U,q,ie){super(x,k.map(Z=>new o.WorkspaceFolder(Z)),O,U,ie),this._name=M,this._isUntitled=q,this._workspaceFolders=[],this._structure=w.TernarySearchTree.forUris(ie),k.forEach(Z=>{this._workspaceFolders.push(Z),this._structure.set(Z.uri,Z)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,M){return M&&this._structure.get(x)&&(x=(0,L.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let T=class{constructor(x,M,k,O,U){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new R.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=O,this._extHostFileSystemInfo=k,this._uriTransformerService=U,this._requestIdProvider=new C.Counter,this._barrier=new F.Barrier,this._proxy=x.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(s.MainContext.MainThreadMessageService);const q=M.workspace;this._confirmedWorkspace=q?new S(q.id,q.name,[],!!q.transient,q.configuration?v.URI.revive(q.configuration):null,!!q.isUntitled,ie=>f(ie,k)):void 0}$initializeWorkspace(x,M){this._trusted=M,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:E.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,M,k,...O){const U=[];if(Array.isArray(O)&&O.forEach(Y=>{v.URI.isUri(Y.uri)&&!U.some(ae=>d(ae.uri,Y.uri,this._extHostFileSystemInfo))&&U.push({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri)})}),this._unconfirmedWorkspace||[M,k].some(Y=>typeof Y!="number"||Y<0)||k===0&&U.length===0)return!1;const q=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+k>q.length)return!1;const ie=q.slice(0);ie.splice(M,k,...U.map(Y=>({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<ie.length;Y++){const ae=ie[Y];if(ie.some((ee,fe)=>fe!==Y&&d(ae.uri,ee.uri,this._extHostFileSystemInfo)))return!1}ie.forEach((Y,ae)=>Y.index=ae);const{added:Z,removed:Q}=g(q,ie,D,this._extHostFileSystemInfo);if(Z.length===0&&Q.length===0)return!1;if(this._proxy){const Y=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(Y,M,k,U).then(void 0,ae=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(b.Severity.Error,(0,y.localize)(0,null,Y,ae.toString()),ee,[])})}return this.trySetWorkspaceFolders(ie),!0}getWorkspaceFolder(x,M){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,M)}async getWorkspaceFolder2(x,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,M)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,M){let k,O="";if(typeof x=="string"?(k=v.URI.file(x),O=x):typeof x<"u"&&(k=x,O=x.fsPath),!k)return O;const U=this.getWorkspaceFolder(k,!0);if(!U)return O;typeof M>"u"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let q=(0,L.relativePath)(U.uri,k);return M&&U.name&&(q=`${U.name}/${q}`),q}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:M,added:k,removed:O}=S.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:k,removed:O}))}findFiles(x,M,k,O,U=p.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let q="",ie=!0;return M===null?ie=!1:M!==void 0&&(typeof M=="string"?q=M:q=M.pattern),this._findFilesImpl(x,void 0,{exclude:q,maxResults:k,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(x,M={},k,O=p.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${k.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,x,M,O)}async _findFilesImpl(x,M,k,O=p.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const U=typeof k.exclude=="string"?k.exclude:k.exclude?k.exclude.pattern:void 0,q={ignoreSymlinks:typeof k.followSymlinks=="boolean"?!k.followSymlinks:void 0,disregardIgnoreFiles:typeof k.useIgnoreFiles=="boolean"?!k.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof k.useGlobalIgnoreFiles=="boolean"?!k.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof k.useParentIgnoreFiles=="boolean"?!k.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof k.useDefaultExcludes=="boolean"?!k.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof k.useDefaultSearchExcludes=="boolean"?!k.useDefaultSearchExcludes:!1,maxResults:k.maxResults,excludePattern:U,shouldGlobSearch:typeof k.fuzzy=="boolean"?!k.fuzzy:!0,_reason:"startFileSearch"};let ie;if(x){const{includePattern:Z,folder:Q}=N(a.GlobPattern.from(x));ie=Q,q.includePattern=Z}else{const{includePattern:Z,folder:Q}=N(a.GlobPattern.from(M));ie=Q,q.filePattern=Z}return this._proxy.$startFileSearch(ie??null,q,O).then(Z=>Array.isArray(Z)?Z.map(Q=>v.URI.revive(Q)):[])}async findTextInFiles(x,M,k,O,U=p.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const q=this._requestIdProvider.getNext(),ie=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:Z,folder:Q}=N(a.GlobPattern.from(M.include)),Y=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ae={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:ie,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:Z,excludePattern:Y},ee=!1;if(this._activeSearchCallbacks[q]=fe=>{if(ee)return;const re=v.URI.revive(fe.resource);fe.results.forEach(G=>{const B=(0,c.revive)(G);(0,u.resultIsMatch)(B)?k({uri:re,preview:{text:B.preview.text,matches:(0,P.mapArrayOrNot)(B.preview.matches,se=>new t.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,P.mapArrayOrNot)(B.ranges,se=>new t.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):k({uri:re,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(x,Q??null,ae,q,U);return delete this._activeSearchCallbacks[q],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[q],fe}}$handleTextSearchResult(x,M){this._activeSearchCallbacks[M]?.(x)}async save(x){const M=await this._proxy.$save(x,{saveAs:!1});return v.URI.revive(M)}async saveAs(x){const M=await this._proxy.$save(x,{saveAs:!0});return v.URI.revive(M)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,M){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,M);const k=this._uriTransformerService.transformOutgoingScheme(x),O=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(O,k),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(x,M){this._logService.info("Getting edit session identifier for workspaceFolder",x);const k=await this.resolveWorkspaceFolder(v.URI.revive(x));if(!k){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",k);const O=this._editSessionIdentityProviders.get(k.uri.scheme);if(this._logService.info(`Provider for scheme ${k.uri.scheme} is defined: `,!!O),!O)return;const U=await O.provideEditSessionIdentity(k,M);if(this._logService.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(x,M,k,O){this._logService.info("Getting edit session identifier for workspaceFolder",x);const U=await this.resolveWorkspaceFolder(v.URI.revive(x));if(!U){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const q=this._editSessionIdentityProviders.get(U.uri.scheme);if(this._logService.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!q),!q)return;const ie=await q.provideEditSessionIdentityMatch?.(M,k,O);if(this._logService.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(x){return(M,k,O)=>{const U=function(ie){M.call(k,ie)};return U.extension=x,this._onWillCreateEditSessionIdentityEvent.event(U,void 0,O)}}async $onWillCreateEditSessionIdentity(x,M,k){const O=await this.resolveWorkspaceFolder(v.URI.revive(x));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:O},M,async(U,q)=>{const ie=Date.now();await Promise.resolve(U),Date.now()-ie>k&&this._logService.warn("SLOW edit session create-participant",q.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(x,M){if(this._canonicalUriProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._canonicalUriProviders.set(x,M);const k=this._uriTransformerService.transformOutgoingScheme(x),O=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(O,k),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete(x),this._proxy.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(x,M,k){const O=this._canonicalUriProviders.get(x.scheme);if(!O)return;const U=await O.provideCanonicalUri?.(v.URI.revive(x),M,k);if(U)return U}async $provideCanonicalUri(x,M,k){return this.provideCanonicalUri(v.URI.revive(x),{targetScheme:M},k)}};e.ExtHostWorkspace=T,e.ExtHostWorkspace=T=Ge([He(0,r.IExtHostRpcService),He(1,n.IExtHostInitDataService),He(2,i.IExtHostFileSystemInfo),He(3,l.ILogService),He(4,h.IURITransformerService)],T),e.IExtHostWorkspace=(0,_.createDecorator)("IExtHostWorkspace");function N(z){let x,M;return z&&(typeof z=="string"?x=z:(x=z.pattern,M=v.URI.revive(z.baseUri))),{includePattern:x,folder:M}}}),define(Ce[43],De([1,0,24,4,42,6,7,256,86,18,8,5,20,13,2]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(h,u){if(u){const s=u.split(".");let c=h;for(let d=0;c&&d<s.length;d++)c=c[s[d]];return c}}function b(h){return h instanceof _.URI}function o(h){return h&&h.uri instanceof _.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function n(h){return h&&h.uri instanceof _.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function r(h){if(b(h))return{resource:h};if(o(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(n(h))return{resource:h.uri};if(h===null)return{resource:null}}let a=class{constructor(u,s,c){this._proxy=u.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=c,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new t(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,s){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(u,s))}};e.ExtHostConfiguration=a,e.ExtHostConfiguration=a=Ge([He(0,v.IExtHostRpcService),He(1,p.IExtHostWorkspace),He(2,y.ILogService)],a);class t{constructor(u,s,c,d){this._onDidChangeConfiguration=new F.Emitter,this._proxy=u,this._logService=d,this._extHostWorkspace=s,this._configuration=w.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,s){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=w.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,c))}getConfiguration(u,s,c){const d=r(s)||{},m=this._toReadonlyValue(u?l(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,d,c?.identifier);function D(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(f){return typeof l(m,f)<"u"},get:(f,S)=>{this._validateConfigurationAccess(u?`${u}.${f}`:f,d,c?.identifier);let T=l(m,f);if(typeof T>"u")T=S;else{let N;const z=(x,M)=>{if((0,C.isObject)(x)){let k;const O=()=>{N=N||(0,P.deepClone)(m),k=k||l(N,M)};return new Proxy(x,{get:(U,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return O(),()=>k;if(N)return k=k||l(N,M),k[q];const ie=U[q];return typeof q=="string"?z(ie,`${M}.${q}`):ie},set:(U,q,ie)=>(O(),k&&(k[q]=ie),!0),deleteProperty:(U,q)=>(O(),k&&delete k[q],!0),defineProperty:(U,q,ie)=>(O(),k&&Object.defineProperty(k,q,ie),!0)})}return Array.isArray(x)?(0,P.deepClone)(x):x};T=z(T,f)}return T},update:(f,S,T,N)=>{f=u?`${u}.${f}`:f;const z=D(T);return S!==void 0?this._proxy.$updateConfigurationOption(z,f,S,d,N):this._proxy.$removeConfigurationOption(z,f,d,N)},inspect:f=>{f=u?`${u}.${f}`:f;const S=this._configuration.inspect(f,d,this._extHostWorkspace.workspace);if(S)return{key:f,defaultValue:(0,P.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,P.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,P.deepClone)(S.workspace?.value),workspaceFolderValue:(0,P.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,P.deepClone)(S.default?.override),globalLanguageValue:(0,P.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,P.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,P.deepClone)(S.workspaceFolder?.override),languageIds:(0,P.deepClone)(S.overrideIdentifiers)}}};return typeof m=="object"&&(0,P.mixin)(g,m,!1),Object.freeze(g)}_toReadonlyValue(u){const s=c=>(0,C.isObject)(c)?new Proxy(c,{get:(d,m)=>s(d[m]),set:(d,m,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(d,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(d,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return s(u)}_validateConfigurationAccess(u,s,c){const d=E.OVERRIDE_PROPERTY_REGEX.test(u)?4:this._configurationScopes.get(u),m=c?`[${c.value}] `:"";if(d===4){typeof s?.resource>"u"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){s?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,s){const c=new w.ConfigurationChangeEvent(u,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,m)=>c.affectsConfiguration(d,r(m))})}_toMap(u){return u.reduce((s,c)=>(s.set(c[0],c[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")}),define(Ce[95],De([1,0,2,8,4,6,7,42,72,43,22,46,20,27,5,16,11,13,91,298,14]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function x(k){if(k!=null)return k}z.from=x;function M(k){if(k!=null)return k}z.to=M})(a||(a={}));var t;(function(z){function x(k){if(k!=null)return k}z.from=x;function M(k){if(k!=null)return k}z.to=M})(t||(t={}));var h;(function(z){function x(k){if(k!=null)return k}z.from=x;function M(k){if(k!=null)return k}z.to=M})(h||(h={}));var u;(function(z){function x(O){if(O){const U=O;return U&&!!U.process}else return!1}z.is=x;function M(O){if(O==null)return;const U={process:O.process,args:O.args};return O.options&&(U.options=h.from(O.options)),U}z.from=M;function k(O){if(O!=null)return new A.ProcessExecution(O.process,O.args,O.options)}z.to=k})(u||(u={}));var s;(function(z){function x(k){if(k!=null)return k}z.from=x;function M(k){if(k!=null)return k}z.to=M})(s||(s={}));var c;(function(z){function x(O){if(O){const U=O;return U&&(!!U.commandLine||!!U.command)}else return!1}z.is=x;function M(O){if(O==null)return;const U={};return O.commandLine!==void 0?U.commandLine=O.commandLine:(U.command=O.command,U.args=O.args),O.options&&(U.options=s.from(O.options)),U}z.from=M;function k(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.ShellExecution(O.commandLine,O.options):new A.ShellExecution(O.command,O.args?O.args:[],O.options)}z.to=k})(c||(c={}));var d;(function(z){function x(O){if(O){const U=O;return U&&U.customExecution==="customExecution"}else return!1}z.is=x;function M(O){return{customExecution:"customExecution"}}z.from=M;function k(O,U){return U.get(O)}z.to=k})(d||(e.CustomExecutionDTO=d={}));var m;(function(z){function x(M,k){let O;return M.scope!==void 0&&typeof M.scope!="number"?O=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===A.TaskScope.Workspace&&k&&k.workspaceFile?O=k.workspaceFile:O=n.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:O}}z.from=x})(m||(e.TaskHandleDTO=m={}));var D;(function(z){function x(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}z.from=x})(D||(D={}));var g;(function(z){function x(O,U){if(O==null)return[];const q=[];for(const ie of O){const Z=M(ie,U);Z&&q.push(Z)}return q}z.fromMany=x;function M(O,U){if(O==null)return;let q;O.execution instanceof A.ProcessExecution?q=u.from(O.execution):O.execution instanceof A.ShellExecution?q=c.from(O.execution):O.execution&&O.execution instanceof A.CustomExecution&&(q=d.from(O.execution));const ie=a.from(O.definition);let Z;return O.scope?typeof O.scope=="number"?Z=O.scope:Z=O.scope.uri:Z=A.TaskScope.Workspace,!ie||!Z?void 0:{_id:O._id,definition:ie,name:O.name,source:{extensionId:U.identifier.value,label:O.source,scope:Z},execution:q,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=M;async function k(O,U,q){if(O==null)return;let ie;u.is(O.execution)?ie=u.to(O.execution):c.is(O.execution)?ie=c.to(O.execution):d.is(O.execution)&&(ie=d.to(O._id,q));const Z=a.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await U.resolveWorkspaceFolder(P.URI.revive(O.source.scope)):Q=A.TaskScope.Workspace),!Z||!Q)return;const Y=new A.Task(Z,Q,O.name,O.source.label,ie,O.problemMatchers);return O.isBackground!==void 0&&(Y.isBackground=O.isBackground),O.group!==void 0&&(Y.group=A.TaskGroup.from(O.group._id),Y.group&&O.group.isDefault&&(Y.group=new A.TaskGroup(Y.group.id,Y.group.label),O.group.isDefault===!0&&(Y.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Y.presentationOptions=t.to(O.presentationOptions)),O._id&&(Y._id=O._id),O.detail&&(Y.detail=O.detail),Y}z.to=k})(g||(e.TaskDTO=g={}));var f;(function(z){function x(k){return k}z.from=x;function M(k){if(k)return Object.assign(Object.create(null),k)}z.to=M})(f||(f={}));class S{#e;constructor(x,M,k){this._id=M,this._task=k,this.#e=x}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}let T=class{constructor(x,M,k,O,U,q,ie,Z){this._onDidExecuteTask=new p.Emitter,this._onDidTerminateTask=new p.Emitter,this._onDidTaskProcessStarted=new p.Emitter,this._onDidTaskProcessEnded=new p.Emitter,this._proxy=x.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=k,this._editorService=O,this._configurationService=U,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ie,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,M,k){if(!k)return new A.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:M,provider:k,extension:x}),this._proxy.$registerTaskProvider(O,M),new A.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(x,M){this._proxy.$registerTaskSystem(x,M)}fetchTasks(x){return this._proxy.$fetchTasks(f.from(x)).then(async M=>{const k=[];for(const O of M){const U=await g.to(O,this._workspaceProvider,this._providedCustomExecutions2);U&&k.push(U)}return k})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(M=>x.push(M)),x}terminateTask(x){if(!(x instanceof S))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,M,k){const O=this._providedCustomExecutions2.get(x.id);O&&(this._activeCustomExecutions2.set(x.id,O),this._terminalService.attachPtyToTerminal(M,await O.callback(k))),this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){if(!this._taskExecutionPromises.has(x.id))return;const M=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const M=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:M,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const M=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:x.exitCode})}$provideTasks(x,M){const k=this._handlers.get(x);if(!k)return Promise.reject(new Error("no handler found"));const O=[],U=(0,F.asPromise)(()=>k.provider.provideTasks(L.CancellationToken.None)).then(q=>this.provideTasksInternal(M,O,k,q));return new Promise(q=>{U.then(ie=>{Promise.all(O).then(()=>{q(ie)})})})}async $resolveTask(x,M){const k=this._handlers.get(x);if(!k)return Promise.reject(new Error("no handler found"));if(M.definition.type!==k.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${k.type}].`);const O=await g.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const U=await k.provider.resolveTask(O,L.CancellationToken.None);if(!U)return;this.checkDeprecation(U,k);const q=g.from(U,k.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(q.execution)&&await this.addCustomExecution(q,U,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,M,k){const O=await this._proxy.$createTaskId(x);!k&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,M.execution)),this._providedCustomExecutions2.set(O,M.execution)}async getTaskExecution(x,M){if(typeof x=="string"){const U=this._taskExecutionPromises.get(x);if(!U)throw new r.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return U}const k=this._taskExecutionPromises.get(x.id);if(k)return k;let O;return M?O=Promise.resolve(new S(this,x.id,M)):O=g.to(x.task,this._workspaceProvider,this._providedCustomExecutions2).then(U=>{if(!U)throw new r.ErrorNoTelemetry("Unexpected: Task does not exist.");return new S(this,x.id,U)}),this._taskExecutionPromises.set(x.id,O),O.then(U=>(this._taskExecutions.set(x.id,U),U))}checkDeprecation(x,M){x._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));const k=this._notProvidedCustomExecutions.values();let O=k.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=k.next()}};e.ExtHostTaskBase=T,e.ExtHostTaskBase=T=Ge([He(0,v.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,w.IExtHostWorkspace),He(3,E.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,o.ILogService),He(7,i.IExtHostApiDeprecationService)],T);let N=class extends T{constructor(x,M,k,O,U,q,ie,Z){super(x,M,k,O,U,q,ie,Z),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(x,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const k=g.from(M,x);if(k===void 0)throw new Error("Task is not valid");if(d.is(k.execution))await this.addCustomExecution(k,M,!1);else throw new r.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(k),M);return this._proxy.$executeTask(k).catch(U=>{throw new Error(U)}),O}provideTasksInternal(x,M,k,O){const U=[];if(O)for(const q of O){if(this.checkDeprecation(q,k),!q.definition||!x[q.definition.type]){const Z=q.source?q.source:"No task source";this._logService.warn(`The task [${Z}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=g.from(q,k.extension);ie&&d.is(ie.execution)?(U.push(ie),M.push(this.addCustomExecution(ie,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:k.extension}}async resolveTaskInternal(x){if(d.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,M,k){}};e.WorkerExtHostTask=N,e.WorkerExtHostTask=N=Ge([He(0,v.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,w.IExtHostWorkspace),He(3,E.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,o.ILogService),He(7,i.IExtHostApiDeprecationService)],N),e.IExtHostTask=(0,_.createDecorator)("IExtHostTask")}),define(Ce[362],De([1,0,36,29]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.genericCellMatchesToTextSearchMatches=e.rawCellPrefix=e.isINotebookFileMatchNoModel=void 0;function p(A){return"cellResults"in A}e.isINotebookFileMatchNoModel=p,e.rawCellPrefix="rawCell#";function R(A,w){let E=-1;const C=[];let L=[];return A.forEach(v=>{v.range.startLineNumber!==E&&L.length>0&&(C.push([...L]),L=[]),L.push(v),E=v.range.endLineNumber}),L.length>0&&C.push([...L]),C.map(v=>{const y=[],_=v[0].range.startLineNumber,l=v[v.length-1].range.endLineNumber;for(let b=_;b<=l;b++)y.push(w.getLineContent(b));return new P.TextSearchMatch(y.join(`
`)+`
`,v.map(b=>new F.Range(b.range.startLineNumber-1,b.range.startColumn-1,b.range.endLineNumber-1,b.range.endColumn-1)))})}e.genericCellMatchesToTextSearchMatches=R}),define(Ce[363],De([1,0,217,21,4,3,28,12,18,2,32,110,6,33,15,7,68,333,150,24,16,288,362,359]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}constructor(c,d,m,D,g,f){this._textDocumentsAndEditors=m,this._textDocuments=D,this._extHostFileSystem=g,this._extHostSearch=f,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new p.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new p.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new p.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new p.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=c.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const T=S.notebookEditor?.notebookUri,N=S.cell.handle,x=this._documents.get(T)?.getCell(N);if(x)return x.apiCell}if(S&&S.$mid===14){const T=S.uri,N=this._documents.get(T);if(N)return N.apiNotebook}return S}}),u._registerApiCommands(d)}getEditorById(c){const d=this._editors.get(c);if(!d)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(c){for(const[d,m]of this._editors)if(m.apiEditor===c)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,d){const m=this._documents.get(c);if(!m&&!d)throw new Error(`NO notebook document for '${c}'`);return m}static _convertNotebookRegistrationData(c,d){if(!d)return;const m=d.filenamePattern.map(D=>_.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(d.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:d.displayName,filenamePattern:m,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,d,m){const D=u._notebookStatusBarItemProviderHandlePool++,g=typeof m.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,g,d);let f;return g!==void 0&&(f=m.onDidChangeCellStatusBarItems(S=>this._notebookProxy.$emitCellStatusBarEvent(g))),new l.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,g),f?.dispose()})}async createNotebookDocument(c){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&_.NotebookData.from(c.content)});return C.URI.revive(d)}async openNotebookDocument(c){const d=this._documents.get(c);if(d)return d.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(c),D=this._documents.get(C.URI.revive(m));return(0,E.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(c,d){C.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let m;typeof d=="object"?m={position:_.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(_.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:m={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,m),g=D&&this._editors.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,d,m,D){const g=this._notebookStatusBarItemProviders.get(c),f=C.URI.revive(d),S=this._documents.get(f);if(!S||!g)return;const T=S.getCellFromIndex(m);if(!T)return;const N=await g.provideCellStatusBarItems(T.apiCell,D);if(!N)return;const z=new R.DisposableStore,x=this._statusBarCache.add([z]),k=(Array.isArray(N)?N:[N]).map(O=>_.NotebookStatusBarItem.from(O,this._commandsConverter,z));return{cacheId:x,items:k}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,d,m,D,g){if((0,w.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const f=this._handlePool++;return this._notebookSerializer.set(f,{viewType:d,serializer:m,options:D}),this._notebookProxy.$registerNotebookSerializer(f,{id:c.identifier,location:c.extensionLocation},d,_.NotebookDocumentContentOptions.from(D),u._convertNotebookRegistrationData(c,g)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(f)})}async $dataToNotebook(c,d,m){const D=this._notebookSerializer.get(c);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(d.buffer,m);return new b.SerializableObjectWithBuffers(_.NotebookData.from(g))}async $notebookToData(c,d,m){const D=this._notebookSerializer.get(c);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(_.NotebookData.to(d.value),m);return F.VSBuffer.wrap(g)}async $saveNotebook(c,d,m,D,g){const f=C.URI.revive(d),S=this._notebookSerializer.get(c);if(!S)throw new Error("NO serializer found");const T=this._documents.get(f);if(!T)throw new Error("Document NOT found");if(T.versionId!==m)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(f.scheme))throw new L.FileOperationError((0,P.localize)(0,null,this._resourceForError(f)),6);await this._validateWriteFile(f,D);const N={metadata:(0,n.filter)(T.apiNotebook.metadata,O=>!(S.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of T.apiNotebook.getCells()){const U=new l.NotebookCellData(O.kind,O.document.getText(),O.document.languageId,O.mime,S.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);U.metadata=(0,n.filter)(O.metadata,q=>!(S.options?.transientCellMetadata??{})[q]),N.cells.push(U)}const z=await S.serializer.serializeNotebook(N,g);await this._extHostFileSystem.value.writeFile(f,z);const x=this._extHostFileSystem.getFileSystemProviderExtUri(f.scheme),M=await this._extHostFileSystem.value.stat(f);return{name:x.basename(f),isFile:(M.type&L.FileType.File)!==0,isDirectory:(M.type&L.FileType.Directory)!==0,isSymbolicLink:(M.type&L.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&L.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(f.scheme),locked:!!((M.permissions??0)&L.FilePermission.Locked),etag:L.etag({mtime:M.mtime,size:M.size}),children:void 0}}async $searchInNotebooks(c,d,m,D,g){const f=this._notebookSerializer.get(c)?.serializer;if(!f)return{limitHit:!1,results:[]};const S=new A.ResourceSet;await(async(M,k,O)=>{await Promise.all(M.map(async U=>await Promise.all(U.filenamePatterns.map(q=>{const ie={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:q};return this._extHostSearch.doInternalFileSearchWithCustomCallback(ie,k,Z=>{Z.forEach(Q=>{S.has(Q)||D.some(ae=>U.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(ee=>(0,h.globMatchesResource)(ee,Q)))||S.add(Q)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(m,g,d);const N=new A.ResourceMap;let z=!1;const x=Array.from(S).map(async M=>{const k=[];try{if(g.isCancellationRequested)return;if(d.maxResults&&[...N.values()].reduce((ie,Z)=>ie+Z.cellResults.length,0)>d.maxResults){z=!0;return}const O=[],U=this._documents.get(M);if(U)U.apiNotebook.getCells().forEach(Z=>O.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(Q=>Q.items.map(Y=>Y.data.toString()))}));else{const ie=await this._extHostFileSystem.value.readFile(M),Z=F.VSBuffer.fromString(ie.toString()),Q=await f.deserializeNotebook(Z.buffer,g);if(g.isCancellationRequested)return;_.NotebookData.from(Q).cells.forEach(ae=>O.push({input:ae.source,outputs:ae.outputs.flatMap(ee=>ee.items.map(fe=>fe.valueBytes.toString()))}))}if(g.isCancellationRequested)return;O.forEach((ie,Z)=>{const Q=d.contentPattern.pattern,Y=new a.CellSearchModel(ie.input,void 0,ie.outputs),ae=Y.findInInputs(Q),ee=Y.findInOutputs(Q),fe=ee.flatMap(re=>(0,t.genericCellMatchesToTextSearchMatches)(re.matches,re.textBuffer)).map((re,G)=>(re.webviewIndex=G,re));if(ae.length>0||ee.length>0){const re={index:Z,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(ae,Y.inputTextBuffer),webviewResults:fe};k.push(re)}});const q={resource:M,cellResults:k};N.set(M,q);return}catch{return}});return await Promise.all(x),{limitHit:z,results:[...N.values()]}}async _validateWriteFile(c,d){const m=await this._extHostFileSystem.value.stat(c);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==L.ETAG_DISABLED&&typeof m.mtime=="number"&&typeof m.size=="number"&&d.mtime<m.mtime&&d.etag!==L.etag({mtime:d.mtime,size:m.size}))throw new L.FileOperationError((0,P.localize)(1,null),3,d)}_resourceForError(c){return c.scheme===r.Schemas.file?c.fsPath:c.toString()}_createExtHostEditor(c,d,m){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const D=new i.ExtHostNotebookEditor(d,this._notebookEditorsProxy,c,m.visibleRanges.map(_.NotebookRange.to),m.selections.map(_.NotebookRange.to),typeof m.viewColumn=="number"?_.ViewColumn.to(m.viewColumn):void 0);this._editors.set(d,D)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const m of c.value.removedDocuments){const D=C.URI.revive(m),g=this._documents.get(D);g&&(g.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(f=>f.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const f of this._editors.values())f.notebookData.uri.toString()===D.toString()&&this._editors.delete(f.id)}if(c.value.addedDocuments){const m=[];for(const D of c.value.addedDocuments){const g=C.URI.revive(D.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const f=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,g,D);m.push(...D.cells.map(S=>o.ExtHostCell.asModelAddData(S))),this._documents.get(g)?.dispose(),this._documents.set(g,f),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(f.apiNotebook)}}if(c.value.addedEditors)for(const m of c.value.addedEditors){if(this._editors.has(m.id))return;const D=C.URI.revive(m.documentUri),g=this._documents.get(D);g&&this._createExtHostEditor(g,m.id,m)}const d=[];if(c.value.removedEditors)for(const m of c.value.removedEditors){const D=this._editors.get(m);D&&(this._editors.delete(m),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),d.push(D))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const m=new Set;this._visibleNotebookEditors.forEach(D=>m.add(D.id));for(const D of this._editors.values()){const g=m.has(D.id);D._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._editors.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(c){const d=y.ApiCommandArgument.String.with("notebookType","A notebook type"),m=new y.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new y.ApiCommandArgument("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>F.VSBuffer.wrap(g))],new y.ApiCommandResult("Notebook Data",g=>_.NotebookData.to(g.value))),D=new y.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new y.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new b.SerializableObjectWithBuffers(_.NotebookData.from(g)))],new y.ApiCommandResult("Bytes",g=>g.buffer));c.registerApiCommand(m),c.registerApiCommand(D)}}e.ExtHostNotebookController=u}),define(Ce[364],De([1,0,17,22,40,35,23,38,36]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(v,y,_){this.config=v,this.provider=y,this.sessionToken=_,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&R.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const y=this.config.folderQueries||[];return new Promise((_,l)=>{const b=o=>{this.resultCount++,v(o)};if(this.isCanceled)return _({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const i=o.toString(),n=P.basename(i);this.globalExcludePattern&&this.globalExcludePattern(i,n)||this.matchFile(b,{base:o,basename:n})}),Promise.all(y.map(o=>this.searchInFolder(o,b))).then(o=>{_({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{l(new Error((0,p.toErrorMessage)(o)))})})}async searchInFolder(v,y){const _=new F.CancellationTokenSource,l=this.getSearchOptionsForFolder(v),b=this.initDirectoryTree(),o=new E.QueryGlobTester(this.config,v),i=!o.hasSiblingExcludeClauses();let n;try{this.activeCancellationTokens.add(_),n=w.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,_.token),a=n.elapsed(),t=w.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(h=>{const u=P.posix.relative(v.folder.path,h.path);if(i){const s=P.basename(h.path);this.matchFile(y,{base:v.folder,relativePath:u,basename:s});return}this.addDirectoryEntries(b,v.folder,u,y)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,o,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{_.dispose(),this.activeCancellationTokens.delete(_)}}getSearchOptionsForFolder(v){const y=(0,E.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),_=(0,E.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:_,includes:y,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},y,_,l){if(_===this.filePattern){const o=P.basename(this.filePattern);this.matchFile(l,{base:y,relativePath:this.filePattern,basename:o})}function b(o){const i=P.basename(o),n=P.dirname(o);let r=v[n];r||(r=v[n]=[],b(n)),r.push({base:y,relativePath:o,basename:i})}b(_)}matchDirectoryTree({rootEntries:v,pathToEntries:y},_,l){const b=this,o=this.filePattern;function i(n){const r=(0,E.hasSiblingFn)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const h=n[a],{relativePath:u,basename:s}=h;if(_.matchesExcludesSync(u,s,o!==s?r:void 0))continue;const c=y[u];if(c)i(c);else{if(u===o)continue;b.matchFile(l,h)}if(b.isLimitHit)break}}i(v)}matchFile(v,y){(!this.includePattern||y.relativePath&&this.includePattern(y.relativePath,y.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(y))}}class L{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(v,y,_,l){const b=this.getSessionTokenSource(v.cacheKey),o=new C(v,y,b&&b.token);let i=0;const n=r=>{i+=r.length,_(r.map(a=>this.rawMatchToSearchItem(a)))};return this.doSearch(o,L.BATCH_SIZE,n,l).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(v){this.getSessionTokenSource(v)?.cancel()}getSessionTokenSource(v){if(v)return this.sessions.has(v)||this.sessions.set(v,new F.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:A.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,y,_,l){const b=l.onCancellationRequested(()=>{v.cancel()}),o=n=>{n&&(i.push(n),y>0&&i.length>=y&&(_(i),i=[]))};let i=[];return v.search(o).then(n=>(i.length&&_(i),b.dispose(),n),n=>(i.length&&_(i),b.dispose(),Promise.reject(n)))}}e.FileSearchManager=L}),define(Ce[365],De([1,0,19,73,35,102,28,16,17,23,12,18,2,99,237,52,13,41,143,360,36]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(f,S,T,N,z){this.configurationService=f,this.workspaceContextService=S,this.editorGroupsService=T,this.logService=N,this.pathService=z}text(f,S,T={}){f=this.getContentPattern(f,T);const N=this.configurationService.getValue(),z=S&&S.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(S?.map(o.toWorkspaceFolder),T),type:2,contentPattern:f,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:N.search.usePCRE2||z||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(f,S){const T=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(f,S)&&(N.isCaseSensitive=!0),this.isMultiline(f)&&(N.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),N}file(f,S={}){return{...this.commonQuery(f,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}handleIncludeExclude(f,S){return f?(f=Array.isArray(f)?f.map(c):c(f),S?this.parseSearchPaths(f):{pattern:h(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],S={}){const T=this.handleIncludeExclude(S.includePattern,S.expandPatterns),N=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),z=f.length>1,x=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,S,N)):f.map(O=>this.getFolderQueryForRoot(O,S,N,z))).filter(O=>!!O),M={_reason:S._reason,folderQueries:x,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:N.pattern,includePattern:T.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const O=P.coalesce(P.flatten(this.editorGroupsService.groups.map(ie=>ie.editors.map(Z=>Z.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(ie=>(0,r.pathIncludedInQuery)(M,ie.fsPath)),q=this.commonQueryFromFileList(U);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...M,...q}}const k=S.extraFileResources&&S.extraFileResources.filter(O=>(0,r.pathIncludedInQuery)(M,O.fsPath));return M.extraFileResources=k&&k.length?k:void 0,M}commonQueryFromFileList(f){const S=[],T=new A.ResourceMap,N={};let z=!1;return f.forEach(x=>{if(x.scheme===w.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(x)){const k=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:E.dirname(x.fsPath)});let O=T.get(k);O||(z=!0,O={folder:k,includePattern:{}},S.push(O),T.set(k,O));const U=E.relative(k.fsPath,x.fsPath);(0,I.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else x.fsPath&&(z=!0,N[x.fsPath]=!0)}),{folderQueries:S,includePattern:N,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}isCaseSensitive(f,S){if(S.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,y.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const S=q=>E.isAbsolute(q)||/^\.\.?([\/\\]|$)/.test(q),N=(Array.isArray(f)?f:u(f)).map(q=>{const ie=this.pathService.resolvedUserHome;return ie?(0,R.untildify)(q,ie.scheme===w.Schemas.file?ie.fsPath:ie.path):q}),z=F.groupBy(N,q=>S(q)?"searchPaths":"exprSegments"),x=(z.exprSegments||[]).map(q=>L.rtrim(q,"/")).map(q=>L.rtrim(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),s(q))),M={},k=this.expandSearchPathPatterns(z.searchPaths||[]);k&&k.length&&(M.searchPaths=k);const O=P.flatten(x),U=h(...O);return U&&(M.pattern=U),M}getExcludesForFolder(f,S){return S.disregardExcludeSettings?void 0:(0,r.getExcludes)(f,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const S=f.flatMap(N=>{let{pathPortion:z,globPortion:x}=t(N);return x&&(x=d(x)),this.expandOneSearchPath(z).flatMap(k=>this.resolveOneSearchPathPattern(k,x))}),T=new Map;return S.forEach(N=>{const z=N.searchPath.toString(),x=T.get(z);x?N.pattern&&(x.pattern=x.pattern||{},x.pattern[N.pattern]=!0):T.set(z,{searchPath:N.searchPath,pattern:N.pattern?h(N.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(f){if(E.isAbsolute(f)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==w.Schemas.file?[{searchPath:S[0].uri.with({path:f})}]:[{searchPath:v.URI.file(E.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=c(f),f.startsWith("../")||f===".."){const N=E.posix.resolve(S.path,f);return[{searchPath:S.with({path:N})}]}const T=d(f);return[{searchPath:S,pattern:T}]}else{if(f==="./"||f===".\\")return[];{const S=f.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(z=>{const x=S.match(new RegExp(`^${L.escapeRegExpCharacters(z.name)}(?:/(.*)|$)`));return x?{match:x,folder:z}:null}).filter(I.isDefined);if(N.length)return N.map(z=>{const x=z.match[1];return{searchPath:z.folder.uri,pattern:x&&d(x)}});{const z=f.match(/\.[\/\\](.+)[\/\\]?/),x=z?z[1]:f,M=_.localize(0,null,x);throw new Error(M)}}}}resolveOneSearchPathPattern(f,S){const T=f.pattern&&S?`${f.pattern}/${S}`:f.pattern||S,N=[{searchPath:f.searchPath,pattern:T}];return T&&!T.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:T+"/**"}),N}getFolderQueryForSearchPath(f,S,T){const N=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(f.searchPath),S,T,!1);return N?{...N,includePattern:f.pattern}:null}getFolderQueryForRoot(f,S,T,N){let z;const x=v.URI.isUri(f)?f:f.uri;if(T.searchPaths){const q=T.searchPaths.filter(ie=>(0,C.isEqual)(ie.searchPath,x))[0];if(q&&!q.pattern)return null;q&&(z=q.pattern)}const M=this.configurationService.getValue({resource:x}),O={...this.getExcludesForFolder(M,S)||{},...z||{}},U=v.URI.isUri(f)?(0,C.basename)(f):f.name;return{folder:x,folderName:N?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!M.search.followSymlinks}}};e.QueryBuilder=a,e.QueryBuilder=a=Ge([He(0,l.IConfigurationService),He(1,o.IWorkspaceContextService),He(2,i.IEditorGroupsService),He(3,b.ILogService),He(4,n.IPathService)],a);function t(g){const f=g.match(/[\*\{\}\(\)\[\]\?]/);if(f){const S=f.index,T=g.substr(0,S).match(/[/|\\][^/\\]*$/);if(T){let N=g.substr(0,T.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:g.substr((T.index||0)+1)}}}return{pathPortion:g}}function h(...g){return g.length?g.reduce((f,S)=>(f[S]=!0,f),Object.create(null)):void 0}function u(g){return p.splitGlobAware(g,",").map(f=>f.trim()).filter(f=>!!f.length)}function s(g){return[`**/${g}/**`,`**/${g}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function c(g){return g.replace(/\\/g,"/")}function d(g){return c(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,f){g=P.distinct(g,N=>N.toString());const S=[],T=f.getWorkspace();return g&&g.forEach(N=>{let z;if(f.getWorkbenchState()===2)z=(0,C.relativePath)(T.folders[0].uri,N),z&&z!=="."&&(z="./"+z);else{const x=f.getWorkspaceFolder(N);if(x){const M=x.name;if(T.folders.filter(O=>O.name===M).length===1){const O=(0,C.relativePath)(x.uri,N);O===""?z=`./${x.name}`:z=`./${x.name}/${O}`}else z=N.fsPath}}z&&S.push(m(z))}),S}e.resolveResourcesForSearchIncludes=D}),define(Ce[366],De([1,0,23,2,22,14,5,365,36,41,8]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const I=7e3;function v(b,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const c of i)if(/^workspaceContains:/.test(c)){const d=c.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||b.forceUsingSearch?r.push(d):n.push(d)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:a,resolve:t}=(0,L.promiseWithResolvers)(),h=c=>t({activationEvent:c}),u=Promise.all(n.map(c=>y(b,c,h))).then(()=>{}),s=_(b,o.identifier,r,h);return Promise.all([u,s]).then(()=>{t(void 0)}),a}e.checkActivateWorkspaceContainsExtension=v;async function y(b,o,i){for(const n of b.folders)if(await b.exists(P.joinPath(F.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function _(b,o,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new p.CancellationTokenSource,a=b.checkExists(b.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),b.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},I);let h=!1;try{h=await a}catch(u){R.isCancellationError(u)||R.onUnexpectedError(u)}r.dispose(),clearTimeout(t),h&&n(`workspaceContains:${i.join(",")}`)}function l(b,o,i,n){const r=b.get(A.IInstantiationService),a=b.get(E.ISearchService),h=r.createInstance(w.QueryBuilder).file(o.map(u=>(0,C.toWorkspaceFolder)(F.URI.revive(u))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(h,n).then(u=>!!u.limitHit,u=>R.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=l}),define(Ce[47],De([1,0,214,17,58,23,8,3,77,2,13,6,43,294,117,42,26,145,14,25,21,273,7,64,5,27,93,20,106,70,46,4,366,116,275,16,114,38,11,115]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h,u,s,c,d,m,D,g,f,S,T,N,z,x,M,k,O){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let q=U=class extends w.Disposable{constructor(G,B,se,ye,le,de,ce,he,V,J,ue,ve){super(),this._extHostManagedSockets=ve,this._onDidChangeRemoteConnectionData=this._register(new f.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=B,this._extHostContext=se,this._initData=ce,this._extHostWorkspace=ye,this._extHostConfiguration=le,this._logService=de,this._extHostTunnelService=V,this._extHostTerminalService=J,this._extHostLocalizationService=ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new fe(this._initData.extensions.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const ke=new n.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,ae(this._globalRegistry,ke)),k.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Q(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Q(this._myRegistry)}`)),this._storage=new _.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=he,this._instaService=G.createChild(new m.ServiceCollection([_.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState])),this._activator=this._register(new y.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(we,Te,Oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(we,i.transformErrorForSerialization(Te),Oe)},actualActivateExtension:async(we,Te)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(we,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(we,Te),new y.HostExtension;const Oe=this._myRegistry.getExtensionDescription(we);return this._activateExtension(Oe,Te)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),p.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){i.onUnexpectedError(G)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._myRegistry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch{}await Promise.all(G)}terminate(G,B=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${G}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),i.setUnexpectedErrorHandler(ye=>{this._logService.error(ye)}),this._extHostContext.dispose();const se=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),se]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${B}`):this._logService.info(`Extension host exiting with code ${B}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(B)})}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}async getExtension(G){const B=await this._mainThreadExtensionsProxy.$getExtension(G);return B&&{...B,identifier:new n.ExtensionIdentifier(B.identifier.value),extensionLocation:C.URI.revive(B.extensionLocation)}}_activateByEvent(G,B){return this._activator.activateByEvent(G,B)}_activateById(G,B){return this._activator.activateById(G,B)}activateByIdWithErrors(G,B){return this._activateById(G,B).then(()=>{const se=this._activator.getActivatedExtension(G);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._myRegistry)}getExtensionExports(G){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(G).exports;try{return this._activator.getActivatedExtension(G).exports}catch{return null}}async _realPathExtensionUri(G){if(G.scheme===z.Schemas.file&&this._hostUtils.fsRealpath){const B=await this._hostUtils.fsRealpath(G.fsPath);return C.URI.file(B)}return G}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(G=>new ee(G))),this._extensionPathIndex}async _createExtensionPathIndex(G){const B=E.TernarySearchTree.forUris(se=>R.extUriBiasedIgnorePathCase.ignorePathCasing(se));return await Promise.all(G.map(async se=>{if(this._getEntryPoint(se)){const ye=await this._realPathExtensionUri(se.extensionLocation);B.set(ye,se)}})),B}_deactivate(G){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return B;const se=this._activator.getActivatedExtension(G);if(!se)return B;try{typeof se.module.deactivate=="function"&&(B=Promise.resolve(se.module.deactivate()).then(void 0,ye=>(this._logService.error(ye),Promise.resolve(void 0))))}catch(ye){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(ye)}try{(0,w.dispose)(se.subscriptions)}catch(ye){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(ye)}return B}async _activateExtension(G,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,B).then(se=>{const ye=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,B),this._logExtensionActivationTimes(G,B,"success",ye),se},se=>{throw this._logExtensionActivationTimes(G,B,"failure"),se})}_logExtensionActivationTimes(G,B,se,ye){const le=Z(G,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...ye||{},outcome:se})}_doActivateExtension(G,B){const se=Z(G,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ye=this._getEntryPoint(G);if(!ye)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${G.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this._logService.flush();const le=new y.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(G,(0,R.joinPath)(G.extensionLocation,ye),le),this._loadExtensionContext(G)]).then(de=>(p.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),U._callActivate(this._logService,G.identifier,de[0],de[1],le))).then(de=>(p.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),de))}_loadExtensionContext(G){const B=new a.ExtensionGlobalMemento(G,this._storage),se=new a.ExtensionMemento(G.identifier.value,!1,this._storage),ye=new N.ExtensionSecrets(G,this._secretState),le=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([B.whenReady,se.whenReady,this._storagePath.whenReady]).then(()=>{const ce=this;let he,V;const J=(0,b.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(n.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:se,secrets:ye,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ue){return F.join(G.extensionLocation.fsPath,ue)},get storagePath(){return ce._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return ce._storagePath.globalValue(G).fsPath},get logPath(){return F.join(ce._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return C.URI.joinPath(ce._initData.logsLocation,G.identifier.value)},get storageUri(){return ce._storagePath.workspaceValue(G)},get globalStorageUri(){return ce._storagePath.globalValue(G)},get extensionMode(){return le},get extension(){return he===void 0&&(he=new Y(ce,G.identifier,G,de,!1)),he},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(G,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!V){if(!J)return;const ue=f.Event.buffer(f.Event.fromDOMEventEmitter(J,"message",ve=>ve.data));J.start(),V={onDidReceiveMessage:ue,postMessage:J.postMessage.bind(J)}}return V}})})}static _callActivate(G,B,se,ye,le){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,B,se,ye,le).then(de=>new y.ActivatedExtension(!1,null,le.build(),se,de,ye.subscriptions))}static _callActivateOptional(G,B,se,ye,le){if(typeof se.activate=="function")try{le.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${B.value}`);const de=typeof global=="object"?global:self,ce=se.activate.apply(de,[ye]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ce).then(he=>(le.activateResolveStop(),he))}catch(de){return Promise.reject(de)}else return Promise.resolve(se)}_activateOneStartupFinished(G,B){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:B}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinishedDeferred(G,B=0){const ye=Date.now();(0,k.setTimeout0)(()=>{for(let le=B;le<G.length;le+=1){const de=G[le];for(const ce of de.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-ye>50){this._activateAllStartupFinishedDeferred(G,le);break}else this._activateOneStartupFinished(de,ce)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(p.getMarks()),this._extHostConfiguration.getConfigProvider().then(G=>{const B=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this._myRegistry.getAllExtensionDescriptions();if(B)this._activateAllStartupFinishedDeferred(se);else for(const ye of se)if(ye.activationEvents)for(const le of ye.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(ye,le)})}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,de=>{this._logService.error(de)});this._register(this._extHostWorkspace.onDidChangeWorkspace(de=>this._handleWorkspaceContainsEagerExtensions(de.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(B),ye=this._handleRemoteResolverEagerExtensions(),le=Promise.all([ye,G,se]).then(()=>{});return Promise.race([le,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),le}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(G,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,B){if(this.isActivated(B.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ye={logService:this._logService,folders:G.map(de=>de.uri),forceUsingSearch:se||!this._hostUtils.fsExists,exists:de=>this._hostUtils.fsExists(de.fsPath),checkExists:(de,ce,he)=>this._mainThreadWorkspaceProxy.$checkExists(de,ce,he)},le=await(0,S.checkActivateWorkspaceContainsExtension)(ye,B);if(le)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:le.activationEvent}).then(void 0,de=>this._logService.error(de))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:B}=this._initData.environment;if(!G||!B)throw new Error(P.localize(0,null));const se=await this._loadCommonJSModule(null,B,new y.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(P.localize(1,null,B.toString()));return new Promise((ye,le)=>{const de=(V,J)=>{V?(k.isCI&&this._logService.error("Test runner called back with error",V),le(V)):(k.isCI&&(J?this._logService.info(`Test runner called back with ${J} failures.`):this._logService.info("Test runner called back with successful outcome.")),ye(typeof J=="number"&&J>0?1:0))},ce=(0,R.originalFSPath)(B),he=se.run(ce,de);he&&he.then&&he.then(()=>{k.isCI&&this._logService.info("Test runner finished successfully."),ye(0)}).catch(V=>{k.isCI&&this._logService.error("Test runner finished with error",V),le(V instanceof Error&&V.stack?V.stack:String(V))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,B){return this._resolvers[G]=B,(0,w.toDisposable)(()=>{delete this._resolvers[G]})}async getRemoteExecServer(G){const{resolver:B}=await this._activateAndGetResolver(G);return B?.resolveExecServer?.(G,{resolveAttempt:0})}async _activateAndGetResolver(G){const B=G.indexOf("+");if(B===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=G.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(G,B){const se=M.StopWatch.create(!1),ye=()=>`[resolveAuthority(${(0,h.getRemoteAuthorityPrefix)(G)},${B})][${se.elapsed()}ms] `,le=W=>this._logService.info(`${ye()}${W}`),de=W=>this._logService.warn(`${ye()}${W}`),ce=(W,H=void 0)=>this._logService.error(`${ye()}${W}`,H),he=W=>{if(W instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},V=async W=>{le(`activating resolver for ${W}...`);const{resolver:H,authorityPrefix:X}=await this._activateAndGetResolver(W);if(!H)throw ce(`no resolver for ${X}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${X}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:X,remoteAuthority:W}},J=G.split(/@|%40/g).reverse();le(`activating remote resolvers ${J.join(" -> ")}`);let ue;try{ue=await Promise.all(J.map(V)).catch(async W=>{if(!(W instanceof t.RemoteAuthorityResolverError)||W._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return de(`resolving nested authorities failed: ${W.message}`),[await V(G)]})}catch(W){return he(W)}const ve=new A.IntervalTimer;ve.cancelAndSet(()=>le("waiting..."),1e3);let ke,we;for(const[W,{authorityPrefix:H,resolver:X,remoteAuthority:K}]of ue.entries())try{if(W===ue.length-1)le("invoking final resolve()..."),p.mark(`code/extHost/willResolveAuthority/${H}`),ke=await X.resolve(K,{resolveAttempt:B,execServer:we}),p.mark(`code/extHost/didResolveAuthorityOK/${H}`),le("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(X,t.ManagedResolvedAuthority.isManagedResolvedAuthority(ke)?ke:void 0));else{if(le(`invoking resolveExecServer() for ${K}`),p.mark(`code/extHost/willResolveExecServer/${H}`),we=await X.resolveExecServer?.(K,{resolveAttempt:B,execServer:we}),!we)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${K}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);p.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(pe){return p.mark(`code/extHost/didResolveAuthorityError/${H}`),ce("returned an error",pe),ve.dispose(),he(pe)}ve.dispose();const Te={environmentTunnels:ke.environmentTunnels,features:ke.tunnelFeatures?{elevation:ke.tunnelFeatures.elevation,privacyOptions:ke.tunnelFeatures.privacyOptions,protocol:ke.tunnelFeatures.protocol===void 0?!0:ke.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:ke.extensionHostEnv,isTrusted:ke.isTrusted,authenticationSession:ke.authenticationSessionForInitializingExtensions?{id:ke.authenticationSessionForInitializingExtensions.id,providerId:ke.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(ke)?"managed authority":`${ke.host}:${ke.port}`}`);let xe;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(ke)){const W=B;this._extHostManagedSockets.setFactory(W,ke.makeConnection),xe={authority:G,connectTo:new h.ManagedRemoteConnection(W),connectionToken:ke.connectionToken}}else xe={authority:G,connectTo:new h.WebSocketRemoteConnection(ke.host,ke.port),connectionToken:ke.connectionToken};return{type:"ok",value:{authority:xe,options:Oe,tunnelInformation:Te}}}async $getCanonicalURI(G,B){this._logService.info(`$getCanonicalURI invoked for authority (${(0,h.getRemoteAuthorityPrefix)(G)})`);const{resolver:se}=await this._activateAndGetResolver(G);if(!se)return null;const ye=C.URI.revive(B);if(typeof se.getCanonicalURI>"u")return ye;const le=await(0,A.asPromise)(()=>se.getCanonicalURI(ye));return le||ye}$startExtensionHost(G){G.toAdd.forEach(ye=>ye.extensionLocation=C.URI.revive(ye.extensionLocation));const{globalRegistry:B,myExtensions:se}=ie(this._activationEventsReader,this._globalRegistry,this._myRegistry,G);return this._globalRegistry.set(B.getAllExtensionDescriptions()),this._myRegistry.set(se),k.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Q(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Q(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(G,B){return B===1?this._almostReadyToRunExtensions.wait().then(se=>this._activateByEvent(G,!1)):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(G,!1))}async $activate(G,B){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(G)?(await this._activateById(G,B),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(de=>de.extensionLocation=C.URI.revive(de.extensionLocation));const{globalRegistry:B,myExtensions:se}=ie(this._activationEventsReader,this._globalRegistry,this._myRegistry,G),ye=await this._createExtensionPathIndex(se);return(await this.getExtensionPathIndex()).setSearchTree(ye),this._globalRegistry.set(B.getAllExtensionDescriptions()),this._myRegistry.set(se),k.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Q(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Q(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const B=r.VSBuffer.alloc(G),se=Math.random()%256;for(let ye=0;ye<G;ye++)B.writeUInt8(se,ye);return B}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=q,e.AbstractExtHostExtensionService=q=U=Ge([He(0,u.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,l.IExtHostWorkspace),He(4,v.IExtHostConfiguration),He(5,L.ILogService),He(6,s.IExtHostInitDataService),He(7,c.IExtensionStoragePaths),He(8,D.IExtHostTunnelService),He(9,g.IExtHostTerminalService),He(10,x.IExtHostLocalizationService),He(11,O.IExtHostManagedSockets)],q);function ie(re,G,B,se){re.addActivationEvents(se.addActivationEvents);const ye=new o.ExtensionDescriptionRegistry(re,G.getAllExtensionDescriptions());ye.deltaExtensions(se.toAdd,se.toRemove);const le=new n.ExtensionIdentifierSet(B.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of se.myToRemove)le.delete(ce);for(const ce of se.myToAdd)le.add(ce);const de=ae(ye,le);return{globalRegistry:ye,myExtensions:de}}function Z(re,G){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Q(re){return re.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(G,B,se,ye,le){this.#e=G,this.#t=B,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=F.normalize((0,R.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ye,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Y;function ae(re,G){return re.getAllExtensionDescriptions().filter(B=>G.has(B.identifier))}class ee{constructor(G){this._searchTree=G}setSearchTree(G){this._searchTree=G}findSubstr(G){return this._searchTree.findSubstr(G)}forEach(G){return this._searchTree.forEach(G)}}e.ExtensionPaths=ee;class fe{constructor(G){this._map=new n.ExtensionIdentifierMap,this.addActivationEvents(G)}readActivationEvents(G){return this._map.get(G.identifier)??[]}addActivationEvents(G){for(const B of Object.keys(G))this._map.set(B,G[B])}}}),define(Ce[367],De([1,0,58,2,6,43,26,25,20,27,5,47,13,12]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(r,a,t,h,u,s,c){this._apiFactory=r,this._extensionRegistry=a,this._instaService=t,this._extHostConfiguration=h,this._extHostExtensionService=u,this._initData=s,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),P.mark("code/extHost/willWaitForConfig");const r=await this._extHostConfiguration.getConfigProvider();P.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,a,this._extensionRegistry,r,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(i,a,this._initData.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this._factories.set(a,r);else this._factories.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this._alternatives.push(a=>r.alternativeModuleName(a))}};e.RequireInterceptor=l,e.RequireInterceptor=l=Ge([He(2,L.IInstantiationService),He(3,R.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,C.IExtHostInitDataService),He(6,v.ILogService)],l);let b=class{static{_=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&_.aliased.size){const a=(0,y.escapeRegExpCharacters)(this.forceForwardSlashes(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${u}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(r){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(r));if(!a)return;const[,t,h,u]=a,s=_.aliased.get(h);if(s!==void 0)return console.warn(`${h} as been renamed to ${s}, please update your imports`),t+s+u}forceForwardSlashes(r){return r.replace(/\\/g,"/")}};b=_=Ge([He(0,C.IExtHostInitDataService)],b);class o{constructor(r,a,t,h,u){this._apiFactory=r,this._extensionPaths=a,this._extensionRegistry=t,this._configProvider=h,this._logService=u,this.nodeModuleName="vscode",this._extApiImpl=new w.ExtensionIdentifierMap}load(r,a){const t=this._extensionPaths.findSubstr(a);if(t){let h=this._extApiImpl.get(t.identifier);return h||(h=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,h)),h}if(!this._defaultApiImpl){let h="";this._extensionPaths.forEach((u,s)=>h+=`	${s} -> ${u.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${h}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let i=class{constructor(r,a,t){this._extensionPaths=r,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(p.MainContext.MainThreadTelemetry);const h=t.getProxy(p.MainContext.MainThreadWindow);this._impl=(u,s)=>{const c=F.URI.parse(u);return s?this.callOriginal(u,s):c.scheme==="http"||c.scheme==="https"?h.$openUri(c,u,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?h.$openUri(c,u,{}):this.callOriginal(u,s)}}load(r,a,t){const h=this._extensionPaths.findSubstr(a);return h&&(this._extensionId=h.identifier.value,this.sendShimmingTelemetry()),this._original=t(r),this._impl}callOriginal(r,a){return this.sendNoForwardTelemetry(),this._original(r,a)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};i=Ge([He(2,E.IExtHostRpcService)],i)}),define(Ce[60],De([1,0,44,3,17,50,5,72,71,47,7,42,291,43]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class _ extends v.AbstractVariableResolverService{constructor(o,i,n,r,a,t,h){function u(){if(n){const s=n.activeEditor();if(s)return s.document.uri;const c=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof L.TextDiffTabInput||c.input instanceof L.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof L.TextTabInput||c.input instanceof L.NotebookEditorTabInput||c.input instanceof L.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:s=>{const c=t.folders.filter(d=>d.name===s);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,c)=>a.getConfiguration(void 0,s).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=u();if(s)return p.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const s=u();if(s){const c=i.getWorkspaceFolder(s);if(c)return p.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const s=n.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(n){const s=n.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>o.getExtension(s)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(R.env))}}let l=class extends F.Disposable{constructor(o,i,n,r,a){super(),this.extensionService=o,this.workspaceService=i,this.editorService=n,this.configurationService=r,this.editorTabs=a,this._resolver=new P.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),u={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{u.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new _(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,u,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=l,e.ExtHostVariableResolverProviderService=l=Ge([He(0,C.IExtHostExtensionService),He(1,I.IExtHostWorkspace),He(2,w.IExtHostDocumentsAndEditors),He(3,y.IExtHostConfiguration),He(4,E.IExtHostEditorTabs)],l)}),define(Ce[96],De([1,0,8,4,2,25,5,6,71,47,20,7,42,140,283,43,60,3,55,33,15]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(m,D,g,f,S,T,N){this._workspaceService=D,this._extensionService=g,this._configurationService=f,this._editorTabs=S,this._variableResolver=T,this._commands=N,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new F.Emitter,this._onDidTerminateDebugSession=new F.Emitter,this._onDidChangeActiveDebugSession=new F.Emitter,this._onDidReceiveDebugSessionCustomEvent=new F.Emitter,this._debugServiceProxy=m.getProxy(w.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new F.Emitter,this._onDidChangeStackFrameFocus=new F.Emitter,this._activeDebugConsole=new h(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(x=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}async $getVisualizerTreeItem(m,D){const g=this.hydrateVisualizationContext(D);if(!g)return;const f=await this._debugVisualizationTrees.get(m)?.getTreeItem?.(g);return f?this.convertVisualizerTreeItem(m,f):void 0}registerDebugVisualizationTree(m,D,g){const f=R.ExtensionIdentifier.toKey(m.identifier),S=this.extensionVisKey(f,D);if(this._debugVisualizationProviders.has(S))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationTrees.set(S,g),this._debugServiceProxy.$registerDebugVisualizerTree(S,!!g.editItem),(0,o.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(S),this._debugVisualizationTrees.delete(D)})}async $getVisualizerTreeItemChildren(m,D){const g=this._debugVisualizationElements.get(D)?.item;return g?(await this._debugVisualizationTrees.get(m)?.getChildren?.(g))?.map(S=>this.convertVisualizerTreeItem(m,S))||[]:[]}async $editVisualizerTreeItem(m,D){const g=this._debugVisualizationElements.get(m);if(!g)return;const f=await this._debugVisualizationTrees.get(g.provider)?.editItem?.(g.item,D);return this.convertVisualizerTreeItem(g.provider,f||g.item)}$disposeVisualizedTree(m){const D=this._debugVisualizationElements.get(m);if(!D)return;const g=[D.children];for(const f of g)if(f)for(const S of f)g.push(this._debugVisualizationElements.get(S)?.children),this._debugVisualizationElements.delete(S)}convertVisualizerTreeItem(m,D){let g=this._debugVisualizationTreeItemIds.get(D);return g||(g=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(D,g),this._debugVisualizationElements.set(g,{provider:m,item:D})),r.DebugTreeItem.from(D,g)}asDebugSourceUri(m,D){const g=m;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let f=`debug:${encodeURIComponent(g.path||"")}`,S="?";return D&&(f+=`${S}session=${encodeURIComponent(D.id)}`,S="&"),f+=`${S}ref=${g.sourceReference}`,p.URI.parse(f)}else{if(g.path)return p.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const D=[];for(const g of m.getAllExtensionDescriptions())if(g.contributes){const f=g.contributes.debuggers;if(f&&f.length>0)for(const S of f)(0,_.isDebuggerMainContribution)(S)&&D.push(S.type)}this._debugServiceProxy.$registerDebugTypes(D)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const m=[];return this._breakpoints.forEach(D=>m.push(D)),m}async $resolveDebugVisualizer(m,D){const g=this._visualizers.get(m);if(!g)throw new Error(`No debug visualizer found with id '${m}'`);let{v:f,provider:S,extensionId:T}=g;if(f.visualization||(f=await S.resolveDebugVisualization?.(f,D)||f,g.v=f),!f.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${S}'`);return this.serializeVisualization(T,f.visualization)}async $executeDebugVisualizerCommand(m){const D=this._visualizers.get(m);if(!D)throw new Error(`No debug visualizer found with id '${m}'`);const g=D.v.visualization;g&&"command"in g&&this._commands.executeCommand(g.command,...g.arguments||[])}hydrateVisualizationContext(m){const D=this._debugSessions.get(m.sessionId);return D&&{session:D.api,variable:m.variable,containerId:m.containerId,frameId:m.frameId,threadId:m.threadId}}async $provideDebugVisualizers(m,D,g,f){const S=this.hydrateVisualizationContext(g),T=this.extensionVisKey(m,D),N=this._debugVisualizationProviders.get(T);if(!S||!N)return[];const z=await N.provideDebugVisualization(S,f);return z?z.map(x=>{const M=++this._visualizerIdCounter;this._visualizers.set(M,{v:x,provider:N,extensionId:m});const k=x.iconPath?this.getIconPathOrClass(x.iconPath):void 0;return{id:M,name:x.name,iconClass:k?.iconClass,iconPath:k?.iconPath,visualization:this.serializeVisualization(m,x.visualization)}}):[]}$disposeDebugVisualizers(m){for(const D of m)this._visualizers.delete(D)}registerDebugVisualizationProvider(m,D,g){if(!m.contributes?.debugVisualizers?.some(T=>T.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const f=R.ExtensionIdentifier.toKey(m.identifier),S=this.extensionVisKey(f,D);if(this._debugVisualizationProviders.has(S))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationProviders.set(S,g),this._debugServiceProxy.$registerDebugVisualizer(f,D),(0,o.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(f,D),this._debugVisualizationProviders.delete(D)})}addBreakpoints(m){const D=m.filter(S=>{const T=S.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,S),!0)});this.fireBreakpointChanges(D,[],[]);const g=[],f=new Map;for(const S of D)if(S instanceof I.SourceBreakpoint){let T=f.get(S.location.uri.toString());T||(T={type:"sourceMulti",uri:S.location.uri,lines:[]},f.set(S.location.uri.toString(),T),g.push(T)),T.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character,mode:S.mode})}else S instanceof I.FunctionBreakpoint&&g.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName,mode:S.mode});return this._debugServiceProxy.$registerBreakpoints(g)}removeBreakpoints(m){const D=m.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],D,[]);const g=D.filter(T=>T instanceof I.SourceBreakpoint).map(T=>T.id),f=D.filter(T=>T instanceof I.FunctionBreakpoint).map(T=>T.id),S=D.filter(T=>T instanceof I.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(g,f,S)}startDebugging(m,D,g){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,D,g){if(!D)return new I.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:f,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,f),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(m,D,g){if(!g)return new I.Disposable(()=>{});if(!this.definesDebugType(m,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:f,factory:g}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,f),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==g),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(m,D){if(!D)return new I.Disposable(()=>{});const g=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:g,factory:D}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==D)})}async $runInTerminal(m,D){return Promise.resolve(void 0)}async $substituteVariables(m,D){let g;const f=await this.getFolder(m);return f&&(g={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(g,D)}createDebugAdapter(m,D){if(m.type==="implementation")return new s(m.implementation)}createSignService(){}async $startDASession(m,D){const g=this,f=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const T=this.convertToDto(S),N=this.createDebugAdapter(T,f);if(!N)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const z=N;return this._debugAdapters.set(m,z),this.getDebugAdapterTrackers(f).then(x=>(x&&this._debugAdaptersTrackers.set(m,x),z.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const k=M,O={type:"response",seq:0,command:k.command,request_seq:k.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(k.arguments.value);O.body={signature:U},z.sendResponse(O)}else throw new Error("no signer")}catch(U){O.success=!1,O.message=U.message,z.sendResponse(O)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(M),M=(0,_.convertToVSCPaths)(M,!0),g._debugServiceProxy.$acceptDAMessage(m,M)}),z.onError(M=>{x&&x.onError&&x.onError(M),this._debugServiceProxy.$acceptDAError(m,M.name,M.message,M.stack)}),z.onExit(M=>{x&&x.onExit&&x.onExit(M??void 0,void 0),this._debugServiceProxy.$acceptDAExit(m,M??void 0,void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),z.startSession()))})}$sendDAMessage(m,D){D=(0,_.convertToDAPaths)(D,!1);const g=this._debugAdaptersTrackers.get(m);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this._debugAdapters.get(m)?.sendMessage(D)}$stopDASession(m){const D=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),D&&D.onWillStopSession&&D.onWillStopSession();const g=this._debugAdapters.get(m);return this._debugAdapters.delete(m),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const D=[],g=[],f=[];if(m.added)for(const S of m.added){const T=S.id;if(T&&!this._breakpoints.has(T)){let N;if(S.type==="function")N=new I.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode);else if(S.type==="data")N=new I.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage,S.mode);else{const z=p.URI.revive(S.uri);N=new I.SourceBreakpoint(new I.Location(z,new I.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode)}(0,I.setBreakpointId)(N,T),this._breakpoints.set(T,N),D.push(N)}}if(m.removed)for(const S of m.removed){const T=this._breakpoints.get(S);T&&(this._breakpoints.delete(S),g.push(T))}if(m.changed){for(const S of m.changed)if(S.id){const T=this._breakpoints.get(S.id);if(T){if(T instanceof I.FunctionBreakpoint&&S.type==="function"){const N=T;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.functionName=S.functionName}else if(T instanceof I.SourceBreakpoint&&S.type==="source"){const N=T;N.enabled=S.enabled,N.condition=S.condition,N.hitCondition=S.hitCondition,N.logMessage=S.logMessage,N.location=new I.Location(p.URI.revive(S.uri),new I.Position(S.line,S.character))}f.push(T)}}}this.fireBreakpointChanges(D,g,f)}async $acceptStackFrameFocus(m){let D;const g=m.sessionId?await this.getSession(m.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");m.kind==="thread"?D=new I.ThreadFocus(g.api,m.threadId):D=new I.StackFrameFocus(g.api,m.threadId,m.frameId),this._stackFrameFocus=D,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(m,D,g){return(0,P.asPromise)(async()=>{const f=this.getConfigProviderByHandle(m);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(D);return f.provideDebugConfigurations(S,g)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(m,D,g,f){return(0,P.asPromise)(async()=>{const S=this.getConfigProviderByHandle(m);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(D);return S.resolveDebugConfiguration(T,g,f)})}$resolveDebugConfigurationWithSubstitutedVariables(m,D,g,f){return(0,P.asPromise)(async()=>{const S=this.getConfigProviderByHandle(m);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(D);return S.resolveDebugConfigurationWithSubstitutedVariables(T,g,f)})}async $provideDebugAdapter(m,D){const g=this.getAdapterDescriptorFactoryByHandle(m);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(D);return this.getAdapterDescriptor(g,f).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(m){const D=await this.getSession(m);this._onDidStartDebugSession.fire(D.api)}async $acceptDebugSessionTerminated(m){const D=await this.getSession(m);D&&(this._onDidTerminateDebugSession.fire(D.api),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(m,D){(await this.getSession(m))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(m,D){const f={session:(await this.getSession(m)).api,event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const D=this._adapterFactories.filter(g=>g.type===m);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(m){const D=this._adapterFactories.filter(g=>g.handle===m);if(D.length>0)return D[0].factory}getConfigProviderByHandle(m){const D=this._configProviders.filter(g=>g.handle===m);if(D.length>0)return D[0].provider}definesDebugType(m,D){if(m.contributes){const g=m.contributes.debuggers;if(g&&g.length>0){for(const f of g)if(f.label&&f.type&&f.type===D)return!0}}return!1}getDebugAdapterTrackers(m){const g=m.configuration.type,f=this._trackerFactories.filter(S=>S.type===g||S.type==="*").map(S=>(0,P.asPromise)(()=>S.factory.createDebugAdapterTracker(m.api)).then(T=>T,T=>null));return Promise.race([Promise.all(f).then(S=>{const T=S.filter(N=>!!N);if(T.length>0)return new u(T)}),new Promise(S=>setTimeout(()=>S(void 0),1e3))]).catch(S=>{})}async getAdapterDescriptor(m,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new I.DebugAdapterServer(g));if(m){const S=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>m.createDebugAdapterDescriptor(D.api,this.daExecutableFromPackage(D,S))).then(T=>{if(T)return T})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,f))}daExecutableFromPackage(m,D){}fireBreakpointChanges(m,D,g){(m.length>0||D.length>0||g.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:D,changed:g}))}async getSession(m){if(m)if(typeof m=="string"){const D=this._debugSessions.get(m);if(D)return D}else{let D=this._debugSessions.get(m.id);if(!D){const g=await this.getFolder(m.folderUri),f=m.parent?this._debugSessions.get(m.parent):void 0;D=new t(this._debugServiceProxy,m.id,m.type,m.name,g,m.configuration,f?.api),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(m){if(m){const D=p.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}extensionVisKey(m,D){return`${m}\0${D}`}serializeVisualization(m,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${m}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(m){const D=this.getIconUris(m);let g,f;return"id"in D?f=i.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:f}}getIconUris(m){if(m instanceof I.ThemeIcon)return{id:m.id};const D=typeof m=="object"&&"dark"in m?m.dark:m,g=typeof m=="object"&&"light"in m?m.light:m;return{dark:typeof D=="string"?p.URI.file(D):D,light:typeof g=="string"?p.URI.file(g):g}}};e.ExtHostDebugServiceBase=a,e.ExtHostDebugServiceBase=a=Ge([He(0,L.IExtHostRpcService),He(1,v.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,l.IExtHostConfiguration),He(4,E.IExtHostEditorTabs),He(5,b.IExtHostVariableResolverProvider),He(6,n.IExtHostCommands)],a);class t{constructor(m,D,g,f,S,T,N){this._debugServiceProxy=m,this._id=D,this._type=g,this._name=f,this._workspaceFolder=S,this._configuration=T,this._parentSession=N}get api(){const m=this;return this.apiSession??=Object.freeze({id:m._id,type:m._type,get name(){return m._name},set name(D){m._name=D,m._debugServiceProxy.$setDebugSessionName(m._id,D)},parentSession:m._parentSession,workspaceFolder:m._workspaceFolder,configuration:m._configuration,customRequest(D,g){return m._debugServiceProxy.$customDebugAdapterRequest(m._id,D,g)},getDebugProtocolBreakpoint(D){return m._debugServiceProxy.$getDebugProtocolBreakpoint(m._id,D.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(m){this._name=m}get configuration(){return this._configuration}}e.ExtHostDebugSession=t;class h{constructor(m){this.value=Object.freeze({append(D){m.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=h;class u{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(D=>D.onError?D.onError(m):void 0)}onExit(m,D){this.trackers.forEach(g=>g.onExit?g.onExit(m,D):void 0)}}class s extends y.AbstractDebugAdapter{constructor(m){super(),this.implementation=m,m.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends a{constructor(m,D,g,f,S,T,N){super(m,D,g,f,S,T,N)}};e.WorkerExtHostDebugService=c,e.WorkerExtHostDebugService=c=Ge([He(0,L.IExtHostRpcService),He(1,v.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,l.IExtHostConfiguration),He(4,E.IExtHostEditorTabs),He(5,b.IExtHostVariableResolverProvider),He(6,n.IExtHostCommands)],c)}),define(Ce[368],De([1,0,14,58,2,6,312,13,84,106,27,249,20,66,47,90]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class b{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(w.ILogService),t=n.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);P.setUnexpectedErrorHandler(h=>{r.error(h);const u=P.transformErrorForSerialization(h);t.$onUnexpectedError(u)})}static async installFullHandler(n){const r=n.get(w.ILogService),a=n.get(v.IExtHostRpcService),t=n.get(_.IExtHostExtensionService),h=n.get(l.IExtHostTelemetry),u=a.getProxy(R.MainContext.MainThreadExtensionService),s=a.getProxy(R.MainContext.MainThreadErrors),c=await t.getExtensionPathIndex(),d=new WeakMap;function m(f,S){if(d.has(f))return d.get(f).stack;let T="",N,z;for(const M of S)T+=`
	at ${M.toString()}`,z=M.getFileName(),!N&&z&&(N=c.findSubstr(p.URI.file(z)));const x=`${f.name||"Error"}: ${f.message||""}${T}`;return d.set(f,{extensionIdentifier:N?.identifier,stack:x}),x}const D=Symbol("prepareStackTrace wrapped");let g=m;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(f){if(f===m||!f||f[D]){g=f||m;return}g=function(S,T){return m(S,T),f.call(Error,S,T)},Object.assign(g,{[D]:!0})}}),P.setUnexpectedErrorHandler(f=>{r.error(f);const S=P.transformErrorForSerialization(f),T=d.get(f);if(!T?.extensionIdentifier){s.$onUnexpectedError(S);return}u.$onExtensionRuntimeError(T.extensionIdentifier,S);const N=h.onExtensionError(T.extensionIdentifier,f);r.trace("forwarded error to extension?",N,T)})}}e.ErrorHandler=b;class o{constructor(n,r,a,t,h){this._hostUtils=a,this._rpcProtocol=new A.RPCProtocol(n,null,t),r=o._transform(r,this._rpcProtocol);const u=new C.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());u.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...r,messagePorts:h}),u.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),u.set(y.IURITransformerService,new y.URITransformerService(t)),u.set(_.IHostUtils,a);const s=new I.InstantiationService(u,!0);s.invokeFunction(b.installEarlyHandler),this._logService=s.invokeFunction(c=>c.get(w.ILogService)),F.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",r),this._extensionService=s.invokeFunction(c=>c.get(_.IExtHostExtensionService)),this._extensionService.initialize(),s.invokeFunction(b.installFullHandler)}async asBrowserUri(n){const r=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService);return p.URI.revive(await r.$asBrowserUri(n))}terminate(n){this._extensionService.terminate(n)}static _transform(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=p.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=p.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>p.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=p.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=p.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=p.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=p.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=p.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=p.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=o}),define(Ce[369],De([1,0,8,11,224,243,138,96,71,47,20,46,7,60,42,284,285,43,33]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let n=class extends w.ExtHostDebugServiceBase{constructor(u,s,c,d,m,D,g,f){super(u,s,c,d,D,g,f),this._terminalService=m,this._integratedTerminalInstances=new t}createDebugAdapter(u,s){switch(u.type){case"server":return new l.SocketDebugAdapter(u);case"pipeServer":return new l.NamedPipeDebugAdapter(u);case"executable":return new l.ExecutableDebugAdapter(u,s.type)}return super.createDebugAdapter(u,s)}daExecutableFromPackage(u,s){const c=l.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),u.type);if(c)return new v.DebugAdapterExecutable(c.command,c.args,c.options)}createSignService(){return new A.SignService}async $runInTerminal(u,s){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const c=await this._configurationService.getConfigProvider(),d=this._terminalService.getDefaultShell(!0),m=this._terminalService.getDefaultShellArgs(!0),D=u.title||p.localize(0,null),g=JSON.stringify({shell:d,shellArgs:m});let f=await this._integratedTerminalInstances.checkout(g,D),S,T=!1;if(f)S=u.cwd;else{const M={shellPath:d,shellArgs:m,cwd:u.cwd,name:D,iconPath:new v.ThemeIcon("debug")};T=!0,f=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,g)}f.show(!0);const N=await f.processId;T?await new Promise(M=>setTimeout(M,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0||d.indexOf("cmd.exe")>=0?f.sendText("cls"):d.indexOf("bash")>=0?f.sendText("clear"):F.isWindows?f.sendText("cls"):f.sendText("clear"));const z=(0,b.prepareCommand)(d,u.args,!!u.argsCanBeInterpretedByShell,S,u.env);f.sendText(z);const x=this.onDidTerminateDebugSession(M=>{M.id===s&&(this._integratedTerminalInstances.free(f),x.dispose())});return N}else if(u.kind==="external")return a(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,s)}};e.ExtHostDebugService=n,e.ExtHostDebugService=n=Ge([He(0,L.IExtHostRpcService),He(1,_.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,o.IExtHostConfiguration),He(4,I.IExtHostTerminalService),He(5,E.IExtHostEditorTabs),He(6,y.IExtHostVariableResolverProvider),He(7,i.IExtHostCommands)],n);let r;function a(h,u){if(!r)if(F.isWindows)r=new R.WindowsExternalTerminalService;else if(F.isMacintosh)r=new R.MacExternalTerminalService;else if(F.isLinux)r=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=u.getConfiguration("terminal");return r.runInTerminal(h.title,h.cwd,h.args,h.env||{},s.external||{})}class t{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(u,s){const d=[...this._terminalInstances.entries()].map(([m,D])=>(0,P.createCancelablePromise)(async g=>{if(m.name!==s||D.lastUsedAt!==-1&&await(0,b.hasChildProcesses)(await m.processId))return null;const f=Date.now();return D.lastUsedAt+t.minUseDelay>f||g.isCancellationRequested||D.config!==u?null:(D.lastUsedAt=f,m)}));return await(0,P.firstParallel)(d,m=>!!m)}insert(u,s){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:s})}free(u){const s=this._terminalInstances.get(u);s&&(s.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}}),define(Ce[370],De([1,0,17,2,104,42,72,43,41,46,20,27,95,16,13,91,23,63,60]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let n=class extends v.ExtHostTaskBase{constructor(a,t,h,u,s,c,d,m,D){super(a,t,h,u,s,c,d,m),this.workspaceService=h,this.variableResolver=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const u=v.TaskHandleDTO.from(h,this.workspaceService),s=await this._proxy.$getTaskExecution(u);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(s,t);return this._proxy.$executeTask(u).catch(()=>{}),c}else{const u=v.TaskDTO.from(t,a);if(u===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(u.execution)&&await this.addCustomExecution(u,t,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(u),t);return this._proxy.$executeTask(u).catch(()=>{}),s}}provideTasksInternal(a,t,h,u){const s=[];if(u)for(const c of u){this.checkDeprecation(c,h),(!c.definition||!a[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const d=v.TaskDTO.from(c,h.extension);d&&(s.push(d),v.CustomExecutionDTO.is(d.execution)&&t.push(this.addCustomExecution(d,c,!0)))}return{tasks:s,extension:h.extension}}async resolveTaskInternal(a){return a}async getAFolder(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const h=F.URI.file((0,o.homedir)());t=new E.WorkspaceFolder({uri:h,name:b.basename(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const h=F.URI.revive(a),u={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(h),c=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),m=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(const D of t.variables)u.variables[D]=await d.resolveAsync(m,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(P.delimiter);for(let g=0;g<D.length;g++)D[g]=await d.resolveAsync(m,D[g])}u.process=await p.win32.findExecutable(await d.resolveAsync(m,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(m,t.process.cwd):void 0,D)}return u}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,h){return p.win32.findExecutable(a,t,h)}};e.ExtHostTask=n,e.ExtHostTask=n=Ge([He(0,L.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,R.IExtHostWorkspace),He(3,A.IExtHostDocumentsAndEditors),He(4,w.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,_.ILogService),He(7,l.IExtHostApiDeprecationService),He(8,i.IExtHostVariableResolverProvider)],n)}),define(Ce[371],De([1,0,63,60]),function(me,e,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class p extends F.ExtHostVariableResolverProviderService{homeDir(){return(0,P.homedir)()}}e.NodeExtHostVariableResolverProviderService=p}),define(Ce[155],De([1,0,19,8,22,40,16,17,23,2,36]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(i,n,r,a){this.query=i,this.provider=n,this.fileUtils=r,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(i,n){const r=this.query.folderQueries||[],a=new p.CancellationTokenSource(n);return new Promise((t,h)=>{this.collector=new y(i);let u=!1;const s=(c,d)=>{if(!u&&!this.isLimitHit){const m=this.resultSize(c);l(c)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,u=!0,a.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const D=this.resultSize(c);this.resultCount+=D,(D>0||!l(c))&&this.collector.add(c,d)}};Promise.all(r.map((c,d)=>this.searchInFolder(c,m=>s(m,d),a.token))).then(c=>{a.dispose(),this.collector.flush();const d=c.some(m=>!!m&&!!m.limitHit);t({limitHit:this.isLimitHit||d,messages:(0,P.flatten)(c.map(m=>m?.message?Array.isArray(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},c=>{a.dispose();const d=(0,R.toErrorMessage)(c);h(new Error(d))})})}resultSize(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}trimResultToSize(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async searchInFolder(i,n,r){const a=new L.QueryGlobTester(this.query,i),t=[],h={report:c=>{if(!this.validateProviderResult(c))return;const d=i.folder.scheme===A.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(c.uri))):void 0,m=E.relativePath(i.folder,c.uri);if(m){const D=a.includedInQuery(m,w.basename(m),d);(0,F.isThenable)(D)?t.push(D.then(g=>{g&&n(c)})):D&&n(c)}}},u=this.getSearchOptionsForFolder(i),s=await this.provider.provideTextSearchResults(v(this.query.contentPattern),u,h,r);return t.length&&await Promise.all(t),s}validateProviderResult(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(i){const n=(0,L.resolvePatternsForProvider)(this.query.includePattern,i.includePattern),r=(0,L.resolvePatternsForProvider)(this.query.excludePattern,i.excludePattern),a={folder:C.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.fileUtils.toCanonicalName(i.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=I;function v(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(i){this._onResult=i,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,n=>this.sendItems(n))}add(i,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!E.isEqual(this._currentUri,i.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:i.uri,results:[]}),this._currentFileMatch.results.push(_(i))}pushToCollector(){const i=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,i)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(i){this._onResult(i)}}e.TextSearchResultsCollector=y;function _(o){return l(o)?{preview:{matches:(0,P.mapArrayOrNot)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,P.mapArrayOrNot)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function l(o){return!!o.preview}e.extensionResultIsMatch=l;class b{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(i,n){this.maxBatchSize=i,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(i,n){i&&this.addItemToBatch(i,n)}addItems(i,n){i&&this.addItemsToBatch(i,n)}addItemToBatch(i,n){this.batch.push(i),this.batchSize+=n,this.onUpdate()}addItemsToBatch(i,n){this.batch=this.batch.concat(i),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b}),define(Ce[97],De([1,0,3,6,5,364,20,66,13,2,155]),function(me,e,P,F,p,R,A,w,E,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,p.createDecorator)("IExtHostSearch");let I=class{constructor(l,b,o){this.extHostRpc=l,this._uriTransformer=b,this._logService=o,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,b){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const o=this._handlePool++;return this._textSearchProvider.set(o,b),this._proxy.$registerTextSearchProvider(o,this._transformScheme(l)),(0,P.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(l,b){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const o=this._handlePool++;return this._fileSearchProvider.set(o,b),this._proxy.$registerFileSearchProvider(o,this._transformScheme(l)),(0,P.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(l,b,o,i){const n=v(o),r=this._fileSearchProvider.get(l);if(r)return this._fileSearchManager.fileSearch(n,r,a=>{this._proxy.$handleFileMatch(l,b,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,b,o){return{messages:[]}}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,b,o,i){const n=this._textSearchProvider.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const r=v(o);return this.createTextSearchManager(r,n).search(t=>this._proxy.$handleTextMatch(l,b,t),i)}$enableExtensionHostSearch(){}createTextSearchManager(l,b){return new L.TextSearchManager(l,b,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=I,e.ExtHostSearch=I=Ge([He(0,A.IExtHostRpcService),He(1,w.IURITransformerService),He(2,E.ILogService)],I);function v(_){return{..._,folderQueries:_.folderQueries&&_.folderQueries.map(y),extraFileResources:_.extraFileResources&&_.extraFileResources.map(l=>C.URI.revive(l))}}e.reviveQuery=v;function y(_){return{..._,folder:C.URI.revive(_.folder)}}}),define(Ce[372],De([1,0,22,14,4,3,16,39,2,132,192,173,79,25,32,13,65,87,268,6,314,343,91,315,320,300,321,322,323,301,289,33,324,43,325,96,148,326,303,316,327,328,72,71,317,47,329,69,330,59,27,344,345,318,304,331,332,114,115,305,363,334,274,335,346,336,153,306,337,338,339,20,340,97,116,341,307,342,117,93,95,90,46,347,348,319,349,350,70,15,7,308,66,309,92,351,352,147,42,282,113,26,94]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h,u,s,c,d,m,D,g,f,S,T,N,z,x,M,k,O,U,q,ie,Z,Q,Y,ae,ee,fe,re,G,B,se,ye,le,de,ce,he,V,J,ue,ve,ke,we,Te,Oe,xe,W,H,X,K,pe,Ee,Me,Ve,Ke,tt,st,lt,rt,Pe,ze,Ae,je,ne,oe,Ie,qe,Je,nt,Ne,vt,yt,kt,Mt,Qt,Pt,qt,Gt,Jt,ii,et,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Zt(ft){const Et=ft.get(G.IExtHostInitDataService),ei=ft.get(re.IExtHostFileSystemInfo),$t=ft.get(ee.IExtHostConsumerFileSystem),zt=ft.get(Y.IExtHostExtensionService),ht=ft.get(Gt.IExtHostWorkspace),Rt=ft.get(ze.IExtHostTelemetry),ti=ft.get(T.IExtHostConfiguration),Yt=ft.get(yt.IURITransformerService),Xe=ft.get(pe.IExtHostRpcService),Ft=ft.get(lt.IExtHostStorage),Bt=ft.get(rt.IExtensionStoragePaths),ni=ft.get(l.ILoggerService),mt=ft.get(l.ILogService),Nt=ft.get(Je.IExtHostTunnelService),Tt=ft.get(t.IExtHostApiDeprecationService),Wt=ft.get(qt.IExtHostWindow),ri=ft.get(Ve.IExtHostSecretState),Ut=ft.get(Z.IExtHostEditorTabs),Ht=ft.get(V.IExtHostManagedSockets);Xe.set(n.ExtHostContext.ExtHostFileSystemInfo,ei),Xe.set(n.ExtHostContext.ExtHostLogLevelServiceShape,ni),Xe.set(n.ExtHostContext.ExtHostWorkspace,ht),Xe.set(n.ExtHostContext.ExtHostConfiguration,ti),Xe.set(n.ExtHostContext.ExtHostExtensionService,zt),Xe.set(n.ExtHostContext.ExtHostStorage,Ft),Xe.set(n.ExtHostContext.ExtHostTunnelService,Nt),Xe.set(n.ExtHostContext.ExtHostWindow,Wt),Xe.set(n.ExtHostContext.ExtHostSecretState,ri),Xe.set(n.ExtHostContext.ExtHostTelemetry,Rt),Xe.set(n.ExtHostContext.ExtHostEditorTabs,Ut),Xe.set(n.ExtHostContext.ExtHostManagedSockets,Ht);const At=Xe.set(n.ExtHostContext.ExtHostDecorations,ft.get(x.IExtHostDecorations)),Dt=Xe.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(ie.IExtHostDocumentsAndEditors)),pt=Xe.set(n.ExtHostContext.ExtHostCommands,ft.get(f.IExtHostCommands)),It=Xe.set(n.ExtHostContext.ExtHostTerminalService,ft.get(Ae.IExtHostTerminalService)),St=Xe.set(n.ExtHostContext.ExtHostDebugService,ft.get(z.IExtHostDebugService)),ui=Xe.set(n.ExtHostContext.ExtHostSearch,ft.get(Me.IExtHostSearch)),Kt=Xe.set(n.ExtHostContext.ExtHostTask,ft.get(Pe.IExtHostTask)),pi=Xe.set(n.ExtHostContext.ExtHostOutputService,ft.get(xe.IExtHostOutputService)),Re=Xe.set(n.ExtHostContext.ExtHostLocalization,ft.get(he.IExtHostLocalizationService)),Ue=Xe.set(n.ExtHostContext.ExtHostUrls,new kt.ExtHostUrls(Xe)),Se=Xe.set(n.ExtHostContext.ExtHostDocuments,new q.ExtHostDocuments(Xe,Dt)),te=Xe.set(n.ExtHostContext.ExtHostDocumentContentProviders,new O.ExtHostDocumentContentProvider(Xe,Dt,mt)),Le=Xe.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new U.ExtHostDocumentSaveParticipant(mt,Se,Xe.getProxy(n.MainContext.MainThreadBulkEdits))),Be=Xe.set(n.ExtHostContext.ExtHostNotebook,new ue.ExtHostNotebookController(Xe,pt,Dt,Se,$t,ui)),Ze=Xe.set(n.ExtHostContext.ExtHostNotebookDocuments,new ke.ExtHostNotebookDocuments(Be)),Qe=Xe.set(n.ExtHostContext.ExtHostNotebookEditors,new we.ExtHostNotebookEditors(mt,Be)),at=Xe.set(n.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(Xe,Et,Be,pt,mt)),_t=Xe.set(n.ExtHostContext.ExtHostNotebookRenderers,new Oe.ExtHostNotebookRenderers(Xe,Be)),Vt=Xe.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new ve.ExtHostNotebookDocumentSaveParticipant(mt,Be,Xe.getProxy(n.MainContext.MainThreadBulkEdits))),Ct=Xe.set(n.ExtHostContext.ExtHostEditors,new ne.ExtHostEditors(Xe,Dt)),Lt=Xe.set(n.ExtHostContext.ExtHostTreeViews,new qe.ExtHostTreeViews(Xe.getProxy(n.MainContext.MainThreadTreeViews),pt,mt)),Xt=Xe.set(n.ExtHostContext.ExtHostEditorInsets,new g.ExtHostEditorInsets(Xe.getProxy(n.MainContext.MainThreadEditorInsets),Ct,Et.remote)),vi=Xe.set(n.ExtHostContext.ExtHostDiagnostics,new M.ExtHostDiagnostics(Xe,mt,ei,Dt)),bi=Xe.set(n.ExtHostContext.ExtHostLanguages,new ce.ExtHostLanguages(Xe,Se,pt.converter,Yt)),dt=Xe.set(n.ExtHostContext.ExtHostLanguageFeatures,new de.ExtHostLanguageFeatures(Xe,Yt,Se,pt,vi,mt,Tt,Rt)),Qi=Xe.set(n.ExtHostContext.ExtHostFileSystem,new ae.ExtHostFileSystem(Xe,dt)),ai=Xe.set(n.ExtHostContext.ExtHostFileSystemEventService,new fe.ExtHostFileSystemEventService(Xe,mt,Dt)),fi=Xe.set(n.ExtHostContext.ExtHostQuickOpen,(0,K.createExtHostQuickOpen)(Xe,ht,pt)),Si=Xe.set(n.ExtHostContext.ExtHostSCM,new Ee.ExtHostSCM(Xe,pt,Se,mt)),Ti=Xe.set(n.ExtHostContext.ExtHostQuickDiff,new X.ExtHostQuickDiff(Xe,Yt)),Yi=Xe.set(n.ExtHostContext.ExtHostShare,new Ke.ExtHostShare(Xe,Yt)),dn=Xe.set(n.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(Xe,pt,Se)),Ai=Xe.set(n.ExtHostContext.ExtHostProgress,new H.ExtHostProgress(Xe.getProxy(n.MainContext.MainThreadProgress))),Ri=Xe.set(n.ExtHostContext.ExtHostLabelService,new le.ExtHostLabelService(Xe)),_i=Xe.set(n.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Xe)),mi=Xe.set(n.ExtHostContext.ExtHostAuthentication,new h.ExtHostAuthentication(Xe)),Ji=Xe.set(n.ExtHostContext.ExtHostTimeline,new Ie.ExtHostTimeline(Xe,pt)),yi=Xe.set(n.ExtHostContext.ExtHostWebviews,new Mt.ExtHostWebviews(Xe,Et.remote,ht,mt,Tt)),Ci=Xe.set(n.ExtHostContext.ExtHostWebviewPanels,new Qt.ExtHostWebviewPanels(Xe,yi,ht)),Zi=Xe.set(n.ExtHostContext.ExtHostCustomEditors,new N.ExtHostCustomEditors(Xe,Se,Bt,yi,Ci)),hn=Xe.set(n.ExtHostContext.ExtHostWebviewViews,new Pt.ExtHostWebviewViews(Xe,yi)),Ei=Xe.set(n.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,mt,pt,Dt)),Li=Xe.set(n.ExtHostContext.ExtHostUriOpeners,new vt.ExtHostUriOpeners(Xe)),Oi=Xe.set(n.ExtHostContext.ExtHostProfileContentHandlers,new W.ExtHostProfileContentHandlers(Xe));Xe.set(n.ExtHostContext.ExtHostInteractive,new se.ExtHostInteractive(Xe,Be,Dt,pt,mt));const fn=Xe.set(n.ExtHostContext.ExtHostInlineChat,new B.ExtHostInteractiveEditor(Xe,pt,Se,mt)),Di=Xe.set(n.ExtHostContext.ExtHostChatProvider,new d.ExtHostChatProvider(Xe,mt,mi)),en=Xe.set(n.ExtHostContext.ExtHostChatAgents2,new c.ExtHostChatAgents2(Xe,mt,pt)),mn=Xe.set(n.ExtHostContext.ExtHostChatVariables,new m.ExtHostChatVariables(Xe)),wi=Xe.set(n.ExtHostContext.ExtHostChat,new s.ExtHostChat(Xe)),Fi=Xe.set(n.ExtHostContext.ExtHostAiRelatedInformation,new r.ExtHostRelatedInformation(Xe)),tn=Xe.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new Q.ExtHostAiEmbeddingVector(Xe)),Ni=Xe.set(n.ExtHostContext.ExtHostIssueReporter,new ye.ExtHostIssueReporter(Xe)),nn=Xe.set(n.ExtHostContext.ExtHostStatusBar,new st.ExtHostStatusBar(Xe,pt.converter)),Mi=Xe.set(n.ExtHostContext.ExtHostSpeech,new tt.ExtHostSpeech(Xe)),rn=Object.values(n.ExtHostContext);Xe.assertRegistered(rn);const di=new u.ExtHostBulkEdits(Xe,Dt),Ii=new D.ExtHostClipboard(Xe),Ui=new J.ExtHostMessageService(Xe,mt),si=new k.ExtHostDialogs(Xe);return a.ExtHostApiCommands.register(pt),function(We,ci,xi){function ot(ge){return(_e,$e,ct)=>{const wt=ge(Ot=>{try{_e.call($e,Ot)}catch(Gi){F.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Gi.toString()}`,{cause:Gi})),Rt.onExtensionError(We.identifier,Gi)}});return ct?.push(wt),wt}}const bt=function(){let ge=!We.isUnderDevelopment;function _e(){ge||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function $e(ct){if(Array.isArray(ct))ct.forEach($e);else if(typeof ct=="string")_e();else{const wt=ct;typeof wt.scheme>"u"&&_e(),typeof wt.exclusive=="boolean"&&(0,et.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return ct}}(),gn={getSession(ge,_e,$e){return mi.getSession(We,ge,_e,$e)},getSessions(ge,_e){return(0,et.checkProposedApiEnabled)(We,"authGetSessions"),mi.getSessions(We,ge,_e)},async hasSession(ge,_e){return(0,et.checkProposedApiEnabled)(We,"authSession"),!!await mi.getSession(We,ge,_e,{silent:!0})},get onDidChangeSessions(){return ot(mi.onDidChangeSessions)},registerAuthenticationProvider(ge,_e,$e,ct){return mi.registerAuthenticationProvider(ge,_e,$e,ct)}},sn={registerCommand(ge,_e,$e){return pt.registerCommand(!0,ge,_e,$e,void 0,We)},registerTextEditorCommand(ge,_e,$e){return pt.registerCommand(!0,ge,(...ct)=>{const wt=Ct.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return wt.edit(Ot=>{_e.apply($e,[wt,Ot,...ct])}).then(Ot=>{Ot||mt.warn("Edits from command "+ge+" were not applied.")},Ot=>{mt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,We)},registerDiffInformationCommand:(ge,_e,$e)=>((0,et.checkProposedApiEnabled)(We,"diffCommand"),pt.registerCommand(!0,ge,async(...ct)=>{const wt=Dt.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Ct.getDiffInformation(wt.id);_e.apply($e,[Ot,...ct])},void 0,void 0,We)),executeCommand(ge,..._e){return pt.executeCommand(ge,..._e)},getCommands(ge=!1){return pt.getCommands(ge)}},zi={get machineId(){return Et.telemetryInfo.machineId},get sessionId(){return Et.telemetryInfo.sessionId},get language(){return Et.environment.appLanguage},get appName(){return Et.environment.appName},get appRoot(){return Et.environment.appRoot?.fsPath??""},get appHost(){return Et.environment.appHost},get uriScheme(){return Et.environment.appUriScheme},get clipboard(){return Ii.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return ot(It.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.checkProposedApiEnabled)(We,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.checkProposedApiEnabled)(We,"telemetry"),ot(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ze.isNewAppInstall)(Et.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,_e){return ze.ExtHostTelemetryLogger.validateSender(ge),Rt.instantiateLogger(We,ge,_e)},openExternal(ge,_e){return Wt.openUri(ge,{allowTunneling:!!Et.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===Et.environment.appUriScheme)return Ue.createAppUri(ge);try{return await Wt.asExternalUri(ge,{allowTunneling:!!Et.remote.authority})}catch(_e){if((0,A.matchesScheme)(ge,A.Schemas.http)||(0,A.matchesScheme)(ge,A.Schemas.https))return ge;throw _e}},get remoteName(){return(0,b.getRemoteName)(Et.remote.authority)},get remoteAuthority(){return(0,et.checkProposedApiEnabled)(We,"resolvers"),Et.remote.authority},get uiKind(){return Et.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return ot(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler(ge){return(0,et.checkProposedApiEnabled)(We,"handleIssueUri"),Ni.registerIssueUriRequestHandler(We,ge)},registerIssueDataProvider(ge){return(0,et.checkProposedApiEnabled)(We,"handleIssueUri"),Ni.registerIssueDataProvider(We,ge)},get appQuality(){return(0,et.checkProposedApiEnabled)(We,"resolvers"),Et.quality},get appCommit(){return(0,et.checkProposedApiEnabled)(We,"resolvers"),Et.commit}};Et.environment.extensionTestsLocationURI||Object.freeze(zi);const pn={createTestController(ge,_e,$e){return Ei.createTestController(We,ge,_e,$e)},createTestObserver(){return(0,et.checkProposedApiEnabled)(We,"testObserver"),Ei.createTestObserver()},runTests(ge){return(0,et.checkProposedApiEnabled)(We,"testObserver"),Ei.runTests(ge)},get onDidChangeTestResults(){return(0,et.checkProposedApiEnabled)(We,"testObserver"),ot(Ei.onResultsChanged)},get testResults(){return(0,et.checkProposedApiEnabled)(We,"testObserver"),Ei.results}},Pi=Et.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,on={getExtension(ge,_e){(0,et.isProposedApiEnabled)(We,"extensionsAny")||(_e=!1);const $e=ci.mine.getExtensionDescription(ge);if($e)return new Y.Extension(zt,We.identifier,$e,Pi,!1);if(_e){const ct=ci.all.getExtensionDescription(ge);if(ct)return new Y.Extension(zt,We.identifier,ct,Pi,!0)}},get all(){const ge=[];for(const _e of ci.mine.getAllExtensionDescriptions())ge.push(new Y.Extension(zt,We.identifier,_e,Pi,!1));return ge},get allAcrossExtensionHosts(){(0,et.checkProposedApiEnabled)(We,"extensionsAny");const ge=new y.ExtensionIdentifierSet(ci.mine.getAllExtensionDescriptions().map($e=>$e.identifier)),_e=[];for(const $e of ci.all.getAllExtensionDescriptions()){const ct=!ge.has($e.identifier);_e.push(new Y.Extension(zt,We.identifier,$e,Pi,ct))}return _e},get onDidChange(){return(0,et.isProposedApiEnabled)(We,"extensionsAny")?ot(p.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):ot(ci.mine.onDidChange)}},Bi={createDiagnosticCollection(ge){return vi.createDiagnosticCollection(We.identifier,ge)},get onDidChangeDiagnostics(){return ot(vi.onDidChangeDiagnostics)},getDiagnostics:ge=>vi.getDiagnostics(ge),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(ge,_e){return bi.changeLanguage(ge.uri,_e)},match(ge,_e){const $e=nt.LanguageSelector.from(ge);let ct;return(0,L.targetsNotebooks)($e)&&(ct=Be.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Ot=>Ot.document===_e))?.apiNotebook),(0,L.score)($e,_e.uri,_e.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(ge,_e,$e){return dt.registerCodeActionProvider(We,bt(ge),_e,$e)},registerDocumentPasteEditProvider(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"documentPaste"),dt.registerDocumentPasteEditProvider(We,bt(ge),_e,$e)},registerCodeLensProvider(ge,_e){return dt.registerCodeLensProvider(We,bt(ge),_e)},registerDefinitionProvider(ge,_e){return dt.registerDefinitionProvider(We,bt(ge),_e)},registerDeclarationProvider(ge,_e){return dt.registerDeclarationProvider(We,bt(ge),_e)},registerImplementationProvider(ge,_e){return dt.registerImplementationProvider(We,bt(ge),_e)},registerTypeDefinitionProvider(ge,_e){return dt.registerTypeDefinitionProvider(We,bt(ge),_e)},registerHoverProvider(ge,_e){return dt.registerHoverProvider(We,bt(ge),_e,We.identifier)},registerEvaluatableExpressionProvider(ge,_e){return dt.registerEvaluatableExpressionProvider(We,bt(ge),_e,We.identifier)},registerInlineValuesProvider(ge,_e){return dt.registerInlineValuesProvider(We,bt(ge),_e,We.identifier)},registerDocumentHighlightProvider(ge,_e){return dt.registerDocumentHighlightProvider(We,bt(ge),_e)},registerMultiDocumentHighlightProvider(ge,_e){return dt.registerMultiDocumentHighlightProvider(We,bt(ge),_e)},registerLinkedEditingRangeProvider(ge,_e){return dt.registerLinkedEditingRangeProvider(We,bt(ge),_e)},registerReferenceProvider(ge,_e){return dt.registerReferenceProvider(We,bt(ge),_e)},registerRenameProvider(ge,_e){return dt.registerRenameProvider(We,bt(ge),_e)},registerNewSymbolNamesProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"newSymbolNamesProvider"),dt.registerNewSymbolNamesProvider(We,bt(ge),_e)},registerDocumentSymbolProvider(ge,_e,$e){return dt.registerDocumentSymbolProvider(We,bt(ge),_e,$e)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider(We,ge)},registerDocumentFormattingEditProvider(ge,_e){return dt.registerDocumentFormattingEditProvider(We,bt(ge),_e)},registerDocumentRangeFormattingEditProvider(ge,_e){return dt.registerDocumentRangeFormattingEditProvider(We,bt(ge),_e)},registerOnTypeFormattingEditProvider(ge,_e,$e,...ct){return dt.registerOnTypeFormattingEditProvider(We,bt(ge),_e,[$e].concat(ct))},registerDocumentSemanticTokensProvider(ge,_e,$e){return dt.registerDocumentSemanticTokensProvider(We,bt(ge),_e,$e)},registerDocumentRangeSemanticTokensProvider(ge,_e,$e){return dt.registerDocumentRangeSemanticTokensProvider(We,bt(ge),_e,$e)},registerSignatureHelpProvider(ge,_e,$e,...ct){return typeof $e=="object"?dt.registerSignatureHelpProvider(We,bt(ge),_e,$e):dt.registerSignatureHelpProvider(We,bt(ge),_e,typeof $e>"u"?[]:[$e,...ct])},registerCompletionItemProvider(ge,_e,...$e){return dt.registerCompletionItemProvider(We,bt(ge),_e,$e)},registerInlineCompletionItemProvider(ge,_e,$e){return _e.handleDidShowCompletionItem&&(0,et.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,et.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),$e&&(0,et.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(We,bt(ge),_e,$e)},registerInlineEditProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"inlineEdit"),dt.registerInlineEditProvider(We,bt(ge),_e)},registerDocumentLinkProvider(ge,_e){return dt.registerDocumentLinkProvider(We,bt(ge),_e)},registerColorProvider(ge,_e){return dt.registerColorProvider(We,bt(ge),_e)},registerFoldingRangeProvider(ge,_e){return dt.registerFoldingRangeProvider(We,bt(ge),_e)},registerSelectionRangeProvider(ge,_e){return dt.registerSelectionRangeProvider(We,ge,_e)},registerCallHierarchyProvider(ge,_e){return dt.registerCallHierarchyProvider(We,ge,_e)},registerTypeHierarchyProvider(ge,_e){return dt.registerTypeHierarchyProvider(We,ge,_e)},setLanguageConfiguration:(ge,_e)=>dt.setLanguageConfiguration(We,ge,_e),getTokenInformationAtPosition(ge,_e){return(0,et.checkProposedApiEnabled)(We,"tokenInformation"),bi.tokenAtPosition(ge,_e)},registerInlayHintsProvider(ge,_e){return dt.registerInlayHintsProvider(We,ge,_e)},createLanguageStatusItem(ge,_e){return bi.createLanguageStatusItem(We,ge,_e)},registerDocumentDropEditProvider(ge,_e,$e){return dt.registerDocumentOnDropEditProvider(We,ge,_e,(0,et.isProposedApiEnabled)(We,"dropMetadata")?$e:void 0)}},an={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(ge,_e,$e){E.URI.isUri(ge)&&ge.scheme===A.Schemas.vscodeRemote&&!ge.authority&&Tt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(E.URI.isUri(ge)?Promise.resolve(Wi.openTextDocument(ge)):Promise.resolve(ge));return Ct.showTextDocument(ct,_e,$e)},createTextEditorDecorationType(ge){return Ct.createTextEditorDecorationType(We,ge)},onDidChangeActiveTextEditor(ge,_e,$e){return ot(Ct.onDidChangeActiveTextEditor)(ge,_e,$e)},onDidChangeVisibleTextEditors(ge,_e,$e){return ot(Ct.onDidChangeVisibleTextEditors)(ge,_e,$e)},onDidChangeTextEditorSelection(ge,_e,$e){return ot(Ct.onDidChangeTextEditorSelection)(ge,_e,$e)},onDidChangeTextEditorOptions(ge,_e,$e){return ot(Ct.onDidChangeTextEditorOptions)(ge,_e,$e)},onDidChangeTextEditorVisibleRanges(ge,_e,$e){return ot(Ct.onDidChangeTextEditorVisibleRanges)(ge,_e,$e)},onDidChangeTextEditorViewColumn(ge,_e,$e){return ot(Ct.onDidChangeTextEditorViewColumn)(ge,_e,$e)},onDidCloseTerminal(ge,_e,$e){return ot(It.onDidCloseTerminal)(ge,_e,$e)},onDidOpenTerminal(ge,_e,$e){return ot(It.onDidOpenTerminal)(ge,_e,$e)},onDidChangeActiveTerminal(ge,_e,$e){return ot(It.onDidChangeActiveTerminal)(ge,_e,$e)},onDidChangeTerminalDimensions(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"terminalDimensions"),ot(It.onDidChangeTerminalDimensions)(ge,_e,$e)},onDidChangeTerminalState(ge,_e,$e){return ot(It.onDidChangeTerminalState)(ge,_e,$e)},onDidWriteTerminalData(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),ot(It.onDidWriteTerminalData)(ge,_e,$e)},onDidExecuteTerminalCommand(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"terminalExecuteCommandEvent"),ot(It.onDidExecuteTerminalCommand)(ge,_e,$e)},get state(){return Wt.getState(We)},onDidChangeWindowState(ge,_e,$e){return ot(Wt.onDidChangeWindowState)(ge,_e,$e)},showInformationMessage(ge,..._e){return Ui.showMessage(We,w.default.Info,ge,_e[0],_e.slice(1))},showWarningMessage(ge,..._e){return Ui.showMessage(We,w.default.Warning,ge,_e[0],_e.slice(1))},showErrorMessage(ge,..._e){return Ui.showMessage(We,w.default.Error,ge,_e[0],_e.slice(1))},showQuickPick(ge,_e,$e){return fi.showQuickPick(We,ge,_e,$e)},showWorkspaceFolderPick(ge){return fi.showWorkspaceFolderPick(ge)},showInputBox(ge,_e){return fi.showInput(ge,_e)},showOpenDialog(ge){return si.showOpenDialog(We,ge)},showSaveDialog(ge){return si.showSaveDialog(ge)},createStatusBarItem(ge,_e,$e){let ct,wt,Ot;return typeof ge=="string"?(ct=ge,wt=_e,Ot=$e):(wt=ge,Ot=_e),nn.createStatusBarEntry(We,ct,wt,Ot)},setStatusBarMessage(ge,_e){return nn.setStatusBarMessage(ge,_e)},withScmProgress(ge){return Tt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ai.withProgress(We,{location:Ne.ProgressLocation.SourceControl},(_e,$e)=>ge({report(ct){}}))},withProgress(ge,_e){return Ai.withProgress(We,ge,_e)},createOutputChannel(ge,_e){return pi.createOutputChannel(ge,_e,We)},createWebviewPanel(ge,_e,$e,ct){return Ci.createWebviewPanel(We,ge,_e,$e,ct)},createWebviewTextEditorInset(ge,_e,$e,ct){return(0,et.checkProposedApiEnabled)(We,"editorInsets"),Xt.createWebviewEditorInset(ge,_e,$e,ct,We)},createTerminal(ge,_e,$e){return typeof ge=="object"?"pty"in ge?It.createExtensionTerminal(ge):It.createTerminalFromOptions(ge):It.createTerminal(ge,_e,$e)},registerTerminalLinkProvider(ge){return It.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,_e){return It.registerProfileProvider(We,ge,_e)},registerTerminalQuickFixProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(ge,We.identifier.value,_e)},registerTreeDataProvider(ge,_e){return Lt.registerTreeDataProvider(ge,_e,We)},createTreeView(ge,_e){return Lt.createTreeView(ge,_e,We)},registerWebviewPanelSerializer:(ge,_e)=>Ci.registerWebviewPanelSerializer(We,ge,_e),registerCustomEditorProvider:(ge,_e,$e={})=>Zi.registerCustomEditorProvider(We,ge,_e,$e),registerFileDecorationProvider(ge){return At.registerFileDecorationProvider(ge,We)},registerUriHandler(ge){return Ue.registerUriHandler(We,ge)},createQuickPick(){return fi.createQuickPick(We)},createInputBox(){return fi.createInputBox(We)},get activeColorTheme(){return _i.activeColorTheme},onDidChangeActiveColorTheme(ge,_e,$e){return ot(_i.onDidChangeActiveColorTheme)(ge,_e,$e)},registerWebviewViewProvider(ge,_e,$e){return hn.registerWebviewViewProvider(We,ge,_e,$e?.webviewOptions)},get activeNotebookEditor(){return Be.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,_e,$e){return ot(Be.onDidChangeActiveNotebookEditor)(ge,_e,$e)},get visibleNotebookEditors(){return Be.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Be.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,_e,$e){return ot(Qe.onDidChangeNotebookEditorSelection)(ge,_e,$e)},onDidChangeNotebookEditorVisibleRanges(ge,_e,$e){return ot(Qe.onDidChangeNotebookEditorVisibleRanges)(ge,_e,$e)},showNotebookDocument(ge,_e){return Be.showNotebookDocument(ge,_e)},registerExternalUriOpener(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"externalUriOpener"),Li.registerExternalUriOpener(We.identifier,ge,_e,$e)},registerProfileContentHandler(ge,_e){return(0,et.checkProposedApiEnabled)(We,"profileContentHandlers"),Oi.registerProfileContentHandler(We,ge,_e)},registerQuickDiffProvider(ge,_e,$e,ct){return(0,et.checkProposedApiEnabled)(We,"quickDiffProvider"),Ti.registerQuickDiffProvider(bt(ge),_e,$e,ct)},get tabGroups(){return Ut.tabGroups},registerShareProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"shareProvider"),Yi.registerShareProvider(bt(ge),_e)}},Wi={get rootPath(){return Tt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ge){throw new F.ReadonlyError("rootPath")},getWorkspaceFolder(ge){return ht.getWorkspaceFolder(ge)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ge){throw new F.ReadonlyError("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ge){throw new F.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(ge,_e,...$e)=>ht.updateWorkspaceFolders(We,ge,_e||0,...$e),onDidChangeWorkspaceFolders:function(ge,_e,$e){return ot(ht.onDidChangeWorkspace)(ge,_e,$e)},asRelativePath:(ge,_e)=>ht.getRelativePath(ge,_e),findFiles:(ge,_e,$e,ct)=>ht.findFiles(ge,_e,$e,We.identifier,ct),findFiles2:(ge,_e,$e)=>((0,et.checkProposedApiEnabled)(We,"findFiles2"),ht.findFiles2(ge,_e,We.identifier,$e)),findTextInFiles:(ge,_e,$e,ct)=>{(0,et.checkProposedApiEnabled)(We,"findTextInFiles");let wt,Ot;return typeof _e=="object"?(wt=_e,Ot=$e):(wt={},Ot=_e,ct=$e),ht.findTextInFiles(ge,wt||{},Ot,We.identifier,ct)},save:ge=>ht.save(ge),saveAs:ge=>ht.saveAs(ge),saveAll:ge=>ht.saveAll(ge),applyEdit(ge,_e){return di.applyWorkspaceEdit(ge,We,_e)},createFileSystemWatcher:(ge,_e,$e,ct)=>{let wt;return typeof _e=="boolean"?wt={ignoreCreateEvents:!!_e,ignoreChangeEvents:!!$e,ignoreDeleteEvents:!!ct,correlate:!1}:_e&&((0,et.checkProposedApiEnabled)(We,"createFileSystemWatcher"),wt={..._e,correlate:!0}),ai.createFileSystemWatcher(ht,We,ge,wt)},get textDocuments(){return Se.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new F.ReadonlyError("textDocuments")},openTextDocument(ge){let _e;const $e=ge;if(typeof ge=="string")_e=Promise.resolve(E.URI.file(ge));else if(E.URI.isUri(ge))_e=Promise.resolve(ge);else if(!$e||typeof $e=="object")_e=Se.createDocumentData($e);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(ct=>(ct.scheme===A.Schemas.vscodeRemote&&!ct.authority&&Tt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Se.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:(ge,_e,$e)=>ot(Se.onDidAddDocument)(ge,_e,$e),onDidCloseTextDocument:(ge,_e,$e)=>ot(Se.onDidRemoveDocument)(ge,_e,$e),onDidChangeTextDocument:(ge,_e,$e)=>ot(Se.onDidChangeDocument)(ge,_e,$e),onDidSaveTextDocument:(ge,_e,$e)=>ot(Se.onDidSaveDocument)(ge,_e,$e),onWillSaveTextDocument:(ge,_e,$e)=>ot(Le.getOnWillSaveTextDocumentEvent(We))(ge,_e,$e),get notebookDocuments(){return Be.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,_e){let $e;if(E.URI.isUri(ge))$e=ge,await Be.openNotebookDocument(ge);else if(typeof ge=="string")$e=E.URI.revive(await Be.createNotebookDocument({viewType:ge,content:_e}));else throw new Error("Invalid arguments");return Be.getNotebookDocument($e).apiNotebook},onDidSaveNotebookDocument(ge,_e,$e){return ot(Ze.onDidSaveNotebookDocument)(ge,_e,$e)},onDidChangeNotebookDocument(ge,_e,$e){return ot(Ze.onDidChangeNotebookDocument)(ge,_e,$e)},onWillSaveNotebookDocument(ge,_e,$e){return ot(Vt.getOnWillSaveNotebookDocumentEvent(We))(ge,_e,$e)},get onDidOpenNotebookDocument(){return ot(Be.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Be.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,_e,$e,ct){return Be.registerNotebookSerializer(We,ge,_e,$e,(0,et.isProposedApiEnabled)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(ge,_e,$e)=>ot(xi.onDidChangeConfiguration)(ge,_e,$e),getConfiguration(ge,_e){return _e=arguments.length===1?void 0:_e,xi.getConfiguration(ge,_e,We)},registerTextDocumentContentProvider(ge,_e){return te.registerTextDocumentContentProvider(ge,_e)},registerTaskProvider:(ge,_e)=>(Tt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(We,ge,_e)),registerFileSystemProvider(ge,_e,$e){return(0,R.combinedDisposable)(Qi.registerFileSystemProvider(We,ge,_e,$e),$t.addFileSystemProvider(ge,_e,$e))},get fs(){return $t.value},registerFileSearchProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"fileSearchProvider"),ui.registerFileSearchProvider(ge,_e)),registerTextSearchProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"textSearchProvider"),ui.registerTextSearchProvider(ge,_e)),registerRemoteAuthorityResolver:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"resolvers"),zt.registerRemoteAuthorityResolver(ge,_e)),registerResourceLabelFormatter:ge=>((0,et.checkProposedApiEnabled)(We,"resolvers"),Ri.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,et.checkProposedApiEnabled)(We,"resolvers"),zt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,_e,$e)=>ot(ai.onDidCreateFile)(ge,_e,$e),onDidDeleteFiles:(ge,_e,$e)=>ot(ai.onDidDeleteFile)(ge,_e,$e),onDidRenameFiles:(ge,_e,$e)=>ot(ai.onDidRenameFile)(ge,_e,$e),onWillCreateFiles:(ge,_e,$e)=>ot(ai.getOnWillCreateFileEvent(We))(ge,_e,$e),onWillDeleteFiles:(ge,_e,$e)=>ot(ai.getOnWillDeleteFileEvent(We))(ge,_e,$e),onWillRenameFiles:(ge,_e,$e)=>ot(ai.getOnWillRenameFileEvent(We))(ge,_e,$e),openTunnel:ge=>((0,et.checkProposedApiEnabled)(We,"tunnels"),Nt.openTunnel(We,ge).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,et.checkProposedApiEnabled)(We,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(ge,_e,$e)=>((0,et.checkProposedApiEnabled)(We,"tunnels"),ot(Nt.onDidChangeTunnels)(ge,_e,$e)),registerPortAttributesProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"portsAttributes"),Nt.registerPortsAttributesProvider(ge,_e)),registerTunnelProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"tunnelFactory"),Nt.registerTunnelProvider(ge,_e)),registerTimelineProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"timeline"),Ji.registerTimelineProvider(ge,_e,We.identifier,pt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ge=>((0,et.checkProposedApiEnabled)(We,"workspaceTrust"),ht.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,_e,$e)=>ot(ht.onDidGrantWorkspaceTrust)(ge,_e,$e),registerEditSessionIdentityProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ge,_e)),onWillCreateEditSessionIdentity:(ge,_e,$e)=>((0,et.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ot(ht.getOnWillCreateEditSessionIdentityEvent(We))(ge,_e,$e)),registerCanonicalUriProvider:(ge,_e)=>((0,et.checkProposedApiEnabled)(We,"canonicalUriProvider"),ht.registerCanonicalUriProvider(ge,_e)),getCanonicalUri:(ge,_e,$e)=>((0,et.checkProposedApiEnabled)(We,"canonicalUriProvider"),ht.provideCanonicalUri(ge,_e,$e))},cn={get inputBox(){return Tt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(We)},createSourceControl(ge,_e,$e){return Si.createSourceControl(We,ge,_e,$e)}},vn={createCommentController(ge,_e){return dn.createCommentController(We,ge,_e)}},bn={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},registerDebugVisualizationProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"debugVisualization"),St.registerDebugVisualizationProvider(We,ge,_e)},registerDebugVisualizationTreeProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"debugVisualization"),St.registerDebugVisualizationTree(We,ge,_e)},onDidStartDebugSession(ge,_e,$e){return ot(St.onDidStartDebugSession)(ge,_e,$e)},onDidTerminateDebugSession(ge,_e,$e){return ot(St.onDidTerminateDebugSession)(ge,_e,$e)},onDidChangeActiveDebugSession(ge,_e,$e){return ot(St.onDidChangeActiveDebugSession)(ge,_e,$e)},onDidReceiveDebugSessionCustomEvent(ge,_e,$e){return ot(St.onDidReceiveDebugSessionCustomEvent)(ge,_e,$e)},onDidChangeBreakpoints(ge,_e,$e){return ot(St.onDidChangeBreakpoints)(ge,_e,$e)},onDidChangeStackFrameFocus(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"debugFocus"),ot(St.onDidChangeStackFrameFocus)(ge,_e,$e)},registerDebugConfigurationProvider(ge,_e,$e){return St.registerDebugConfigurationProvider(ge,_e,$e||Jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,_e){return St.registerDebugAdapterDescriptorFactory(We,ge,_e)},registerDebugAdapterTrackerFactory(ge,_e){return St.registerDebugAdapterTrackerFactory(ge,_e)},startDebugging(ge,_e,$e){return!$e||typeof $e=="object"&&"configuration"in $e?St.startDebugging(ge,_e,{parentSession:$e}):St.startDebugging(ge,_e,$e||{})},stopDebugging(ge){return St.stopDebugging(ge)},addBreakpoints(ge){return St.addBreakpoints(ge)},removeBreakpoints(ge){return St.removeBreakpoints(ge)},asDebugSourceUri(ge,_e){return St.asDebugSourceUri(ge,_e)}},ln={registerTaskProvider:(ge,_e)=>Kt.registerTaskProvider(We,ge,_e),fetchTasks:ge=>Kt.fetchTasks(ge),executeTask:ge=>Kt.executeTask(We,ge),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(ge,_e,$e)=>ot(Kt.onDidStartTask)(ge,_e,$e),onDidEndTask:(ge,_e,$e)=>ot(Kt.onDidEndTask)(ge,_e,$e),onDidStartTaskProcess:(ge,_e,$e)=>ot(Kt.onDidStartTaskProcess)(ge,_e,$e),onDidEndTaskProcess:(ge,_e,$e)=>ot(Kt.onDidEndTaskProcess)(ge,_e,$e)},un={createNotebookController(ge,_e,$e,ct,wt){return at.createNotebookController(We,ge,_e,$e,ct,(0,et.isProposedApiEnabled)(We,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,_e)=>Be.registerNotebookCellStatusBarItemProvider(We,ge,_e),createRendererMessaging(ge){return _t.createRendererMessaging(We,ge)},createNotebookControllerDetectionTask(ge){return(0,et.checkProposedApiEnabled)(We,"notebookKernelSource"),at.createNotebookControllerDetectionTask(We,ge)},registerKernelSourceActionProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"notebookKernelSource"),at.registerKernelSourceActionProvider(We,ge,_e)},onDidChangeNotebookCellExecutionState(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"notebookCellExecutionState"),ot(at.onDidChangeNotebookCellExecutionState)(ge,_e,$e)}},$i={t(...ge){if(typeof ge[0]=="string"){const _e=ge.shift(),$e=!ge||typeof ge[0]!="object"?ge:ge[0];return Re.getMessage(We.identifier.value,{message:_e,args:$e})}return Re.getMessage(We.identifier.value,ge[0])},get bundle(){return Re.getBundle(We.identifier.value)},get uri(){return Re.getBundleUri(We.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),fn.registerProvider(We,ge,_e)},registerInteractiveSessionProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),wi.registerChatProvider(We,ge,_e)},sendInteractiveRequestToProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),wi.sendInteractiveRequestToProvider(ge,_e)},transferChatSession(ge,_e){return(0,et.checkProposedApiEnabled)(We,"interactive"),wi.transferChatSession(ge,_e)}},Vi={getRelatedInformation(ge,_e){return(0,et.checkProposedApiEnabled)(We,"aiRelatedInformation"),Fi.getRelatedInformation(We,ge,_e)},registerRelatedInformationProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"aiRelatedInformation"),Fi.registerRelatedInformationProvider(We,ge,_e)},registerEmbeddingVectorProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"aiRelatedInformation"),tn.registerEmbeddingVectorProvider(We,ge,_e)}},ki={registerChatResponseProvider(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"chatProvider"),Di.registerLanguageModel(We,ge,_e,$e)},registerChatVariableResolver(ge,_e,$e){return(0,et.checkProposedApiEnabled)(We,"chatVariableResolver"),mn.registerVariableResolver(We,ge,_e,$e)},registerMappedEditsProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"mappedEditsProvider"),dt.registerMappedEditsProvider(We,ge,_e)},createChatParticipant(ge,_e){return(0,et.checkProposedApiEnabled)(We,"chatParticipant"),en.createChatAgent(We,ge,_e)}},ji={requestLanguageModelAccess(ge,_e){return(0,et.checkProposedApiEnabled)(We,"languageModels"),Di.requestLanguageModelAccess(We,ge,_e)},get languageModels(){return(0,et.checkProposedApiEnabled)(We,"languageModels"),Di.getLanguageModelIds()},onDidChangeLanguageModels:(ge,_e,$e)=>((0,et.checkProposedApiEnabled)(We,"languageModels"),Di.onDidChangeProviders(ge,_e,$e))},qi={registerSpeechProvider(ge,_e){return(0,et.checkProposedApiEnabled)(We,"speech"),Mi.registerProvider(We.identifier,ge,_e)}};return{version:Et.version,ai:Vi,authentication:gn,commands:sn,comments:vn,chat:ki,debug:bn,env:zi,extensions:on,interactive:Hi,l10n:$i,languages:Bi,lm:ji,notebooks:un,scm:cn,speech:qi,tasks:ln,tests:pn,window:an,workspace:Wi,Breakpoint:Ne.Breakpoint,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.ChatCompletionItem,CallHierarchyIncomingCall:Ne.CallHierarchyIncomingCall,CallHierarchyItem:Ne.CallHierarchyItem,CallHierarchyOutgoingCall:Ne.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:P.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:Ne.CodeAction,CodeActionKind:Ne.CodeActionKind,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.CodeLens,Color:Ne.Color,ColorInformation:Ne.ColorInformation,ColorPresentation:Ne.ColorPresentation,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.CompletionItem,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.CompletionList,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.CustomExecution,DebugAdapterExecutable:Ne.DebugAdapterExecutable,DebugAdapterInlineImplementation:Ne.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Ne.DebugAdapterNamedPipeServer,DebugAdapterServer:Ne.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.DebugVisualization,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.Diagnostic,DiagnosticRelatedInformation:Ne.DiagnosticRelatedInformation,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.Disposable,DocumentHighlight:Ne.DocumentHighlight,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.MultiDocumentHighlight,DocumentLink:Ne.DocumentLink,DocumentSymbol:Ne.DocumentSymbol,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.EvaluatableExpression,InlineValueText:Ne.InlineValueText,InlineValueVariableLookup:Ne.InlineValueVariableLookup,InlineValueEvaluatableExpression:Ne.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:p.Emitter,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.FileDecoration,FileDecoration2:Ne.FileDecoration,FileSystemError:Ne.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:Ne.FoldingRange,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.FunctionBreakpoint,InlineCompletionItem:Ne.InlineSuggestion,InlineCompletionList:Ne.InlineSuggestionList,Hover:Ne.Hover,IndentAction:I.IndentAction,Location:Ne.Location,MarkdownString:Ne.MarkdownString,OverviewRulerLane:v.OverviewRulerLane,ParameterInformation:Ne.ParameterInformation,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.Position,ProcessExecution:Ne.ProcessExecution,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.QuickInputButtons,Range:Ne.Range,RelativePattern:Ne.RelativePattern,Selection:Ne.Selection,SelectionRange:Ne.SelectionRange,SemanticTokens:Ne.SemanticTokens,SemanticTokensBuilder:Ne.SemanticTokensBuilder,SemanticTokensEdit:Ne.SemanticTokensEdit,SemanticTokensEdits:Ne.SemanticTokensEdits,SemanticTokensLegend:Ne.SemanticTokensLegend,ShellExecution:Ne.ShellExecution,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.SignatureHelp,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.SignatureInformation,SnippetString:Ne.SnippetString,SourceBreakpoint:Ne.SourceBreakpoint,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.SymbolInformation,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.Task,TaskGroup:Ne.TaskGroup,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.TerminalLink,TerminalQuickFixTerminalCommand:Ne.TerminalQuickFixCommand,TerminalQuickFixOpener:Ne.TerminalQuickFixOpener,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.TerminalProfile,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.TextEdit,SnippetTextEdit:Ne.SnippetTextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.ThemeColor,ThemeIcon:Ne.ThemeIcon,TreeItem:Ne.TreeItem,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.TypeHierarchyItem,UIKind:ii.UIKind,Uri:E.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.WorkspaceEdit,DocumentDropEdit:Ne.DocumentDropEdit,DocumentPasteEdit:Ne.DocumentPasteEdit,InlayHint:Ne.InlayHint,InlayHintLabelPart:Ne.InlayHintLabelPart,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.RemoteAuthorityResolverError,ResolvedAuthority:Ne.ResolvedAuthority,ManagedResolvedAuthority:Ne.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.TimelineItem,NotebookRange:Ne.NotebookRange,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.NotebookCellData,NotebookData:Ne.NotebookData,NotebookRendererScript:Ne.NotebookRendererScript,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.NotebookCellOutput,NotebookCellOutputItem:Ne.NotebookCellOutputItem,NotebookCellStatusBarItem:Ne.NotebookCellStatusBarItem,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.NotebookEdit,NotebookKernelSourceAction:Ne.NotebookKernelSourceAction,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.PortAttributes,LinkedEditingRanges:Ne.LinkedEditingRanges,TestResultState:Ne.TestResultState,TestRunRequest:Ne.TestRunRequest,TestMessage:Ne.TestMessage,TestTag:Ne.TestTag,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:xt.TextSearchCompleteMessageType,DataTransfer:Ne.DataTransfer,DataTransferItem:Ne.DataTransferItem,CoveredCount:Ne.CoveredCount,FileCoverage:Ne.FileCoverage,StatementCoverage:Ne.StatementCoverage,BranchCoverage:Ne.BranchCoverage,DeclarationCoverage:Ne.DeclarationCoverage,FunctionCoverage:Ne.DeclarationCoverage,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.TextTabInput,TabInputTextDiff:Ne.TextDiffTabInput,TabInputTextMerge:Ne.TextMergeTabInput,TabInputCustom:Ne.CustomEditorTabInput,TabInputNotebook:Ne.NotebookEditorTabInput,TabInputNotebookDiff:Ne.NotebookDiffEditorTabInput,TabInputWebview:Ne.WebviewEditorTabInput,TabInputTerminal:Ne.TerminalEditorTabInput,TabInputInteractiveWindow:Ne.InteractiveWindowInput,TabInputChat:Ne.ChatEditorTabInput,TelemetryTrustedValue:o.TelemetryTrustedValue,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.StackFrameFocus,ThreadFocus:Ne.ThreadFocus,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.ChatResponseMarkdownPart,ChatResponseFileTreePart:Ne.ChatResponseFileTreePart,ChatResponseAnchorPart:Ne.ChatResponseAnchorPart,ChatResponseProgressPart:Ne.ChatResponseProgressPart,ChatResponseReferencePart:Ne.ChatResponseReferencePart,ChatResponseCommandButtonPart:Ne.ChatResponseCommandButtonPart,ChatRequestTurn:Ne.ChatRequestTurn,ChatResponseTurn:Ne.ChatResponseTurn,LanguageModelSystemMessage:Ne.LanguageModelSystemMessage,LanguageModelUserMessage:Ne.LanguageModelUserMessage,LanguageModelAssistantMessage:Ne.LanguageModelAssistantMessage,NewSymbolName:Ne.NewSymbolName,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.InlineEdit,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}e.createApiFactoryAndRegisterActors=Zt}),define(Ce[373],De([1,0,84,153,42,148,43,33,72,46,95,96,97,117,70,91,147,69,59,116,90,71,146,13,60,114,115]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h,u,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,P.registerSingleton)(h.ILoggerService,t.ExtHostLoggerService,1),(0,P.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,1),(0,P.registerSingleton)(w.IExtHostCommands,w.ExtHostCommands,0),(0,P.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,P.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,P.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,P.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,P.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,0),(0,P.registerSingleton)(c.IExtHostManagedSockets,c.ExtHostManagedSockets,0),(0,P.registerSingleton)(i.IExtHostFileSystemInfo,i.ExtHostFileSystemInfo,0),(0,P.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService,1),(0,P.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,P.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,0),(0,P.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,P.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,P.registerSingleton)(_.IExtHostTunnelService,_.ExtHostTunnelService,0),(0,P.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow,0),(0,P.registerSingleton)(p.IExtHostWorkspace,p.ExtHostWorkspace,0),(0,P.registerSingleton)(n.IExtHostSecretState,n.ExtHostSecretState,0),(0,P.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry,0),(0,P.registerSingleton)(a.IExtHostEditorTabs,a.ExtHostEditorTabs,0),(0,P.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Ce[119],De([1,0,19,13,36,94]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function w(I,v,y,_){const l=(0,P.mapArrayOrNot)(y,E),b=new p.TextSearchMatch(v,l,_),o=b.preview.matches;return{ranges:(0,P.mapArrayOrNot)(l,C),uri:I,preview:{text:b.preview.text,matches:(0,P.mapArrayOrNot)(o,C)}}}e.createTextSearchResult=w;function E(I){return new p.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function C(I){return new R.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor(v,y){this.prefix=v,this.logService=y}appendLine(v){this.logService.debug(`${this.prefix}#search`,v)}};e.OutputChannel=L,e.OutputChannel=L=Ge([He(1,F.ILogService)],L)}),define(Ce[374],De([1,0,51,17,76,34,11,12,119,375]),function(me,e,P,F,p,R,A,w,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(n,r,a,t){const h=v(n,r,a,t),u=r.folder.fsPath;return{cmd:P.spawn(L,h.args,{cwd:u}),rgDiskPath:L,siblingClauses:h.siblingClauses,rgArgs:h,cwd:u}}e.spawnRipgrepCmd=I;function v(n,r,a,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];_([r],a,!1).forEach(s=>{const c=(0,E.anchorGlob)(s);if(h.push("-g",c),A.isMacintosh){const d=(0,p.normalizeNFD)(c);d!==c&&h.push("-g",d)}});const u=y([r],t,void 0,!1);return u.globArgs.forEach(s=>{const c=`!${(0,E.anchorGlob)(s)}`;if(h.push("-g",c),A.isMacintosh){const d=(0,p.normalizeNFD)(c);d!==c&&h.push("-g",d)}}),r.disregardIgnoreFiles!==!1?h.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),r.ignoreSymlinks||h.push("--follow"),n.exists&&h.push("--quiet"),h.push("--no-config"),r.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:u.siblingClauses}}function y(n,r,a,t=!0){const h=[];let u={};return n.forEach(s=>{const c=Object.assign({},s.excludePattern||{},r||{}),d=l(c,t?s.folder.fsPath:void 0,a);h.push(...d.globArgs),d.siblingClauses&&(u=Object.assign(u,d.siblingClauses))}),{globArgs:h,siblingClauses:u}}function _(n,r,a=!0){const t=[];return n.forEach(h=>{const u=Object.assign({},r||{},h.includePattern||{}),s=l(u,a?h.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function l(n,r,a){const t=[],h={};return Object.keys(n).forEach(u=>{if(a&&a.has(u)||!u)return;const s=n[u];u=o(r?b(r,u):u),u.startsWith("\\\\")?u="\\\\"+u.substr(2).replace(/\\/g,"/"):u=u.replace(/\\/g,"/"),typeof s=="boolean"&&s?(u.startsWith("\\\\")&&(u+="**"),t.push(i(u))):s&&s.when&&(h[u]=s)}),{globArgs:t,siblingClauses:h}}function b(n,r){return F.isAbsolute(r)?r:F.join(n,r)}e.getAbsoluteGlob=b;function o(n){return n=w.rtrim(n,"\\"),w.rtrim(n,"/")}function i(n){return R.getRoot(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.fixDriveC=i}),define(Ce[376],De([1,0,51,57,17,377,19,40,35,76,34,11,38,12,18,31,36,374,129]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const n=new Set;process.on("exit",()=>{n.forEach(u=>u())});class r{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&E.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=s.shouldGlobMatchFilePattern?null:(0,i.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&E.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(c=>{const d=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),m=c.folder.fsPath;s.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==m).forEach(D=>{(0,L.isEqualOrParent)(D,m)&&(d[p.relative(m,D)]=!0)}),this.folderExcludePatterns.set(m,new t(d,m))})}cancel(){this.isCanceled=!0,n.forEach(s=>s())}walk(s,c,d,m,D){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return D(null,this.isLimitHit);c.forEach(g=>{const f=p.basename(g.fsPath);this.globalExcludePattern&&this.globalExcludePattern(g.fsPath,f)||this.matchFile(d,{relativePath:g.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(s,(g,f)=>{this.call(this.cmdTraversal,this,g,d,m,S=>{if(S){const T=(0,w.toErrorMessage)(S);console.error(T),this.errors.push(T),f(S,void 0)}else f(null,void 0)})},(g,f)=>{this.fileWalkSW.stop();const S=g?A.coalesce(g)[0]:null;D(S,this.isLimitHit)})}parallel(s,c,d){const m=new Array(s.length),D=new Array(s.length);let g=!1,f=0;if(s.length===0)return d(null,[]);s.forEach((S,T)=>{c(S,(N,z)=>{if(N?(g=!0,m[T]=null,D[T]=N):(m[T]=z,D[T]=null),++f===s.length)return d(g?D:null,m)})})}call(s,c,...d){try{s.apply(c,d)}catch(m){d[d.length-1](m)}}cmdTraversal(s,c,d,m){const D=s.folder.fsPath,g=I.isMacintosh,f=()=>x&&x.kill();n.add(f);let S=U=>{n.delete(f),S=()=>{},m(U)},T="";const N=this.initDirectoryTree(),z=(0,o.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression),x=z.cmd,M=!Object.keys(z.siblingClauses).length,k=z.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let O=`${z.rgDiskPath} ${k}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),d({message:O}),this.cmdResultCount=0,this.collectStdout(x,"utf8",d,(U,q,ie)=>{if(U){S(U);return}if(this.isLimitHit){S();return}const Q=(T+(g?C.normalizeNFC(q||""):q)).split(`
`);if(ie){const Y=Q.length;Q[Y-1]=Q[Y-1].trim(),Q[Y-1]||Q.pop()}else T=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,M){for(const Y of Q)if(this.matchFile(c,{base:D,relativePath:Y,searchPath:this.getSearchPath(s,Y)}),this.isLimitHit){f();break}(ie||this.isLimitHit)&&S();return}this.addDirectoryEntries(s,N,D,Q,c),ie&&(this.matchDirectoryTree(N,D,c),S())})}spawnFindCmd(s){const c=this.folderExcludePatterns.get(s.folder.fsPath),d=c.getBasenameTerms(),m=c.getPathTerms(),D=["-L","."];if(d.length||m.length){D.push("-not","(","(");for(const g of d)D.push("-name",g),D.push("-o");for(const g of m)D.push("-path",g),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),P.spawn("find",D,{cwd:s.folder.fsPath})}readStdout(s,c,d){let m="";this.collectStdout(s,c,()=>{},(D,g,f)=>{if(D){d(D);return}m+=g,f&&d(null,m)})}collectStdout(s,c,d,m){let D=(S,T,N)=>{(S||N)&&(D=()=>{},this.cmdSW?.stop()),m(S,T,N)},g=!1;s.stdout?(this.forwardData(s.stdout,c,D),s.stdout.once("data",()=>g=!0)):d({message:"stdout is null"});let f;s.stderr?f=this.collectData(s.stderr):d({message:"stderr is null"}),s.on("error",S=>{D(S)}),s.on("close",S=>{let T;!g&&(T=this.decodeData(f,c))&&h(T)?D(new Error(`command failed with error code ${S}: ${this.decodeData(f,c)}`)):(this.exists&&S===0&&(this.isLimitHit=!0),D(null,"",!0))})}forwardData(s,c,d){const m=new R.StringDecoder(c);return s.on("data",D=>{d(null,m.write(D))}),m}collectData(s){const c=[];return s.on("data",d=>{c.push(d)}),c}decodeData(s,c){const d=new R.StringDecoder(c);return s.map(m=>d.write(m)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:c},d,m,D){m.indexOf(this.filePattern)!==-1&&this.matchFile(D,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const g=f=>{const S=p.basename(f),T=p.dirname(f);let N=c[T];N||(N=c[T]=[],g(T)),N.push({base:d,relativePath:f,basename:S,searchPath:this.getSearchPath(s,f)})};m.forEach(g)}matchDirectoryTree({rootEntries:s,pathToEntries:c},d,m){const D=this,g=this.folderExcludePatterns.get(d),f=this.filePattern;function S(T){D.directoriesWalked++;const N=(0,b.hasSiblingFn)(()=>T.map(z=>z.basename));for(let z=0,x=T.length;z<x;z++){const M=T[z],{relativePath:k,basename:O}=M;if(g.test(k,O,f!==O?N:void 0))continue;const U=c[k];if(U)S(U);else{if(D.filesWalked++,k===f)continue;D.matchFile(m,M)}if(D.isLimitHit)break}}S(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,c,d,m,D){const g=s.folder,f=(0,b.hasSiblingFn)(()=>d);this.parallel(d,(S,T)=>{if(this.isCanceled||this.isLimitHit)return T(null);const N=c?[c,S].join(p.sep):S;if(this.folderExcludePatterns.get(s.folder.fsPath).test(N,S,this.config.filePattern!==S?f:void 0))return T(null);const z=[g.fsPath,N].join(p.sep);F.lstat(z,(x,M)=>{if(x||this.isCanceled||this.isLimitHit)return T(null);this.statLinkIfNeeded(z,M,(k,O)=>k||this.isCanceled||this.isLimitHit?T(null):O.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(z,M,(U,q)=>U||this.isCanceled||this.isLimitHit||(q=q||"",this.walkedPaths[q])?T(null):(this.walkedPaths[q]=!0,l.Promises.readdir(z).then(ie=>{if(this.isCanceled||this.isLimitHit)return T(null);this.doWalk(s,N,ie,m,Z=>T(Z||null))},ie=>{T(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&_.isNumber(O.size)&&O.size>this.maxFilesize||this.matchFile(m,{base:g.fsPath,relativePath:N,searchPath:this.getSearchPath(s,N)}),T(null,void 0)))})},S=>{const T=S&&A.coalesce(S);return D(T&&T.length>0?T[0]:void 0)})}matchFile(s,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,p.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(c))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,b.isFilePatternMatch)(s,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,b.isFilePatternMatch)(s,this.filePattern,!1)}return!0}statLinkIfNeeded(s,c,d){return c.isSymbolicLink()?F.stat(s,d):d(null,c)}realPathIfNeeded(s,c,d){return c.isSymbolicLink()?F.realpath(s,(m,D)=>m?d(m):d(null,D)):d(null,s)}getSearchPath(s,c){return s.folderName?p.join(s.folderName,c):c}}e.FileWalker=r;class a{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new r(s)}search(s,c,d){this.walker.walk(this.folderQueries,this.extraFiles,s,c,(m,D)=>{d(m,{limitHit:D,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(s,c){this.expression=s,this.root=c,this.init(s)}init(s){let c,d;Object.keys(s).filter(m=>s[m]).forEach(m=>{p.isAbsolute(m)?(c=c||E.getEmptyExpression(),c[m]=s[m]):(d=d||E.getEmptyExpression(),d[m]=s[m])}),this.absoluteParsedExpr=c&&E.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=d&&E.parse(d,{trimForExclusions:!0})}test(s,c,d){return this.relativeParsedExpr&&this.relativeParsedExpr(s,c,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(p.join(this.root,s),c,d)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...E.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...E.getPathTerms(this.relativeParsedExpr)),s}}function h(u){const s=u.trim().split(`
`),c=s[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return y.uppercaseFirstLetter(s[s.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Ce[378],De([1,0,98,21,187,22]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(d=>d===c)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const w=512,E=512,C=512*8,L=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class v extends Error{constructor(d,m){super(d),this.decodeStreamErrorKind=m}}e.DecodeStreamError=v;class y{static async create(d){let m;if(d!==e.UTF8)m=(await(0,p.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const D=new TextDecoder;m={write(g){return D.decode(g,{stream:!0})},end(){return D.decode()}}}return new y(m)}constructor(d){this.iconvLiteDecoder=d}write(d){return this.iconvLiteDecoder.write(d)}end(){return this.iconvLiteDecoder.end()}}function _(c,d){const m=d.minBytesRequiredForDetection??d.guessEncoding?C:E;return new Promise((D,g)=>{const f=(0,P.newWriteableStream)(M=>M.join("")),S=[];let T=0,N;const z=new R.CancellationTokenSource,x=async()=>{try{const M=await s({buffer:F.VSBuffer.concat(S),bytesRead:T},d.guessEncoding);if(M.seemsBinary&&d.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);M.encoding=await d.overwriteEncoding(M.encoding),N=await y.create(M.encoding);const k=N.write(F.VSBuffer.concat(S).buffer);f.write(k),S.length=0,T=0,D({stream:f,detected:M})}catch(M){z.cancel(),f.destroy(),g(M)}};(0,P.listenStream)(c,{onData:async M=>{N?f.write(N.write(M.buffer)):(S.push(M),T+=M.byteLength,T>=m&&(c.pause(),await x(),setTimeout(()=>c.resume())))},onError:M=>f.error(M),onEnd:async()=>{N||await x(),f.end(N?.end())}},z.token)})}e.toDecodeStream=_;async function l(c,d,m){const g=(await(0,p.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),m);let f=!1,S=!1;return{read(){if(S)return null;const T=c.read();if(typeof T!="string"){if(S=!0,!f&&m?.addBOM)switch(d){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const N=g.end();return N&&N.length>0?(f=!0,F.VSBuffer.wrap(N)):null}return f=!0,F.VSBuffer.wrap(g.write(T))}}}e.toEncodeReadable=l;async function b(c){return(await(0,p.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}e.encodingExists=b;function o(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=o;function i(c,d){if(!c||d<e.UTF16be_BOM.length)return null;const m=c.readUInt8(0),D=c.readUInt8(1);if(m===e.UTF16be_BOM[0]&&D===e.UTF16be_BOM[1])return e.UTF16be;if(m===e.UTF16le_BOM[0]&&D===e.UTF16le_BOM[1])return e.UTF16le;if(d<e.UTF8_BOM.length)return null;const g=c.readUInt8(2);return m===e.UTF8_BOM[0]&&D===e.UTF8_BOM[1]&&g===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=i;const n=["ascii","utf-16","utf-32"];async function r(c){const d=await(0,p.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),m=c.slice(0,L),D=h(m.buffer),g=d.detect(D);if(!g||!g.encoding)return null;const f=g.encoding.toLowerCase();return 0<=n.indexOf(f)?null:t(g.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const d=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[d]||d}function h(c){let d="";for(let m=0;m<c.length;m++)d+=String.fromCharCode(c[m]);return d}function u(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=c.match(/windows(\d+)/);return d?"windows-"+d[1]:c}}}e.toCanonicalName=u;function s({buffer:c,bytesRead:d},m){let D=i(c,d),g=!1;if(D!==e.UTF16be&&D!==e.UTF16le&&c){let f=!0,S=!0,T=!1;for(let N=0;N<d&&N<w;N++){const z=N%2===1,x=c.readUInt8(N)===0;if(x&&(T=!0),f&&(z&&!x||!z&&x)&&(f=!1),S&&(z&&x||!z&&!x)&&(S=!1),x&&!f&&!S)break}T&&(f?D=e.UTF16le:S?D=e.UTF16be:g=!0)}return m&&!g&&!D&&c?r(c.slice(0,d)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:g,encoding:D}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[156],De([1,0,378,31,155]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends p.TextSearchManager{constructor(w,E,C=F,L="searchProcess"){super(w,E,{readdir:I=>C.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,P.toCanonicalName)(I)},L)}}e.NativeTextSearchManager=R}),define(Ce[157],De([1,0,51,394,377,19,73,35,12,2,36,94,395,375,119]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const l=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(f){this.outputChannel=f}provideTextSearchResults(f,S,T,N){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((z,x)=>{N.onCancellationRequested(()=>Q());const M=t(f,S),k=S.folder.fsPath,O=M.map(re=>re.match(/^-/)?re:`'${re}'`).join(" ");this.outputChannel.appendLine(`${l} ${O}
 - cwd: ${k}`);let U=P.spawn(l,M,{cwd:k});U.on("error",re=>{console.error(re),this.outputChannel.appendLine("Error: "+(re&&re.message)),x((0,L.serializeSearchError)(new L.SearchError(re&&re.message,L.SearchErrorCode.rgProcessError)))});let q=!1;const ie=new n(S.maxResults,S.folder,S.previewOptions);ie.on("result",re=>{q=!0,ae="",T.report(re)});let Z=!1;const Q=()=>{Z=!0,U?.kill(),ie?.cancel()};let Y=!1;ie.on("hitLimit",()=>{Y=!0,Q()});let ae="";U.stdout.on("data",re=>{ie.handleData(re),q||(ae+=re)});let ee=!1;U.stdout.once("data",()=>ee=!0);let fe="";U.stderr.on("data",re=>{const G=re.toString();this.outputChannel.appendLine(G),fe.length+G.length<1e6&&(fe+=G)}),U.on("close",()=>{if(this.outputChannel.appendLine(ee?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(q?"Got result from parser":"No result from parser"),ae&&this.outputChannel.appendLine(`Got data without result: ${ae}`),this.outputChannel.appendLine(""),Z)z({limitHit:Y});else{ie.flush(),U=null;let re;fe&&!ee&&(re=o(fe))?x((0,L.serializeSearchError)(new L.SearchError(re.message,re.code))):z({limitHit:Y})}})})}}e.RipgrepTextSearchEngine=b;function o(g){const f=g.split(`
`),S=f[0].trim();if(f.some(N=>N.startsWith("regex parse error")))return new L.SearchError(i(f),L.SearchErrorCode.regexParseError);const T=S.match(/grep config error: unknown encoding: (.*)/);if(T)return new L.SearchError(`Unknown encoding: ${T[1]}`,L.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new L.SearchError(S.charAt(0).toUpperCase()+S.substr(1),L.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new L.SearchError(S.charAt(0).toUpperCase()+S.substr(1),L.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new L.SearchError(S,L.SearchErrorCode.regexParseError)}function i(g){const f=["Regex parse error"],S=g.filter(T=>T.startsWith("PCRE2:"));if(S.length>=1){const T=S[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const N=T.split(":")[1];f.push(":"+N)}}return f.join("")}class n extends F.EventEmitter{constructor(f,S,T){super(),this.maxResults=f,this.root=S,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new p.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,S){return super.on(f,S),this}handleData(f){if(this.isDone)return;const S=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(S)}handleDecodedData(f){let S=f.indexOf(`
`);const T=this.remainder+f;if(S>=0)S+=this.remainder.length;else{this.remainder=T;return}let N=0;for(;S>=0;)this.handleLine(T.substring(N,S).trim()),N=S+1,S=T.indexOf(`
`,N);this.remainder=T.substring(N)}handleLine(f){if(this.isDone||!f)return;let S;try{S=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(S.type==="match"){const T=r(S.data.path),N=C.URI.joinPath(this.root,T),z=this.createTextSearchMatch(S.data,N);this.onResult(z),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const T=r(S.data.path),N=C.URI.joinPath(this.root,T);this.createTextSearchContext(S.data,N).forEach(x=>this.onResult(x))}}createTextSearchMatch(f,S){const T=f.line_number-1,N=r(f.lines),z=Buffer.from(N);let x=0,M=0,k=T;f.submatches.length===0&&f.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(f.submatches.map((U,q)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const ie=r(U.match),Z=z.slice(x,U.start).toString(),Q=a(Z),Y=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+M,ae=a(ie),ee=Q.numLines+k,fe=ae.numLines+ee,re=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+Y;return x=U.end,M=re,k=fe,new I.Range(ee,Y,fe,re)}));return(0,_.createTextSearchResult)(S,N,O,this.previewOptions)}createTextSearchContext(f,S){const T=r(f.lines),N=f.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((z,x)=>({text:z,uri:S,lineNumber:N+x}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=n;function r(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function a(g){const f=/\n/g;let S=0,T=-1,N;for(;N=f.exec(g);)S++,T=N.index;const z=T>=0?g.length-T-1:g.length;return{numLines:S,lastLineLength:z}}function t(g,f){const S=["--hidden","--no-require-git"];S.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:N}=(0,A.groupBy)(f.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const x=new Set;N.forEach(M=>{x.add(M)}),S.push("-g","!*"),x.forEach(M=>{h(M).map(_.anchorGlob).forEach(k=>{S.push("-g",k)})})}T&&T.length&&T.forEach(x=>{S.push("-g",x)}),f.excludes.map(_.anchorGlob).forEach(x=>S.push("-g",`!${x}`)),f.maxFileSize&&S.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),f.followSymlinks&&S.push("--follow"),f.encoding&&f.encoding!=="utf8"&&S.push("--encoding",f.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,E.escapeRegExpCharacters)(g.pattern),g.isRegExp=!0),f.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),g.isRegExp&&(g.pattern=u(g.pattern),S.push("--engine","auto"));let z;if(g.isWordMatch){const M=(0,E.createRegExp)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",M)}else if(g.isRegExp){let x=c(g.pattern);x=d(x),S.push("--regexp",x)}else z=g.pattern,S.push("--fixed-strings");return S.push("--no-config"),f.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),g.isMultiline&&S.push("--multiline"),f.beforeContext&&S.push("--before-context",f.beforeContext+""),f.afterContext&&S.push("--after-context",f.afterContext+""),S.push("--"),z&&S.push(z),S.push("."),S}e.getRgArgs=t;function h(g){return D(g).flatMap(S=>{const T=(0,w.splitGlobAware)(S,"/");return T.map((N,z)=>T.slice(0,z+1).join("/"))})}function u(g){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(f);)g=g.replace(f,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(S);)g=g.replace(S,"$1\\x{$2}");return g}e.unicodeEscapesToPCRE2=u;const s=g=>g.type==="Assertion"&&g.kind==="lookbehind";function c(g){let f;try{f=new v.RegExpParser().parsePattern(g)}catch{return g}let S="",T=0;const N=(M,k,O)=>{S+=g.slice(T,M)+O,T=k},z=[];return new v.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const k=z[0];if(!k)N(M.start,M.end,"\\r?\\n");else if(!z.some(s))if(k.type==="CharacterClass")if(k.negate){const O=g.slice(k.start+2,M.start)+g.slice(M.end,k.end-1);k.parent?.type==="Quantifier"?N(k.start,k.end,O?`[^${O}]`:"."):N(k.start,k.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=g.slice(k.start+1,M.start)+g.slice(M.end,k.end-1);N(k.start,k.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else k.type==="Quantifier"&&N(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){z.unshift(M)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(M){z.unshift(M)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(M){z.unshift(M)},onCharacterClassLeave(){z.shift()},onAssertionEnter(M){s(M)&&z.push(M)},onAssertionLeave(M){z[0]===M&&z.shift()}}).visit(f),S+=g.slice(T),S}e.fixRegexNewline=c;function d(g){return g.replace(/\n/g,"\\r?\\n")}e.fixNewline=d;function m(g){let f=!1,S=!1,T="",N="";for(let z=0;z<g.length;z++){const x=g[z];switch(x){case"\\":S?(f?N+="\\"+x:T+="\\"+x,S=!1):S=!0;break;case"{":if(S)f?N+=x:T+=x,S=!1;else{if(f)return{strInBraces:T+"{"+N+"{"+g.substring(z+1)};f=!0}break;case"}":if(S)f?N+=x:T+=x,S=!1;else{if(f)return{fixedStart:T,strInBraces:N,fixedEnd:g.substring(z+1)};T+=x}break;default:f?N+=(S?"\\":"")+x:T+=(S?"\\":"")+x,S=!1;break}}return{strInBraces:T+(f?"{"+N:"")}}function D(g){const{fixedStart:f,strInBraces:S,fixedEnd:T}=m(g);if(f===void 0||T===void 0)return[S];let N=(0,w.splitGlobAware)(S,",");N.length||(N=[""]);const z=D(T);return N.flatMap(x=>{const M=f+x;return z.map(k=>M+k)})}e.performBraceExpansionForRipgrep=D}),define(Ce[379],De([1,0,22,157,107,16]),function(me,e,P,F,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,L,I,v){const y=new F.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===R.Schemas.vscodeUserData){const _={...L,folder:L.folder.with({scheme:R.Schemas.file})},l=new p.Progress(b=>I.report({...b,uri:b.uri.with({scheme:L.folder.scheme})}));return this.withToken(v,b=>y.provideTextSearchResults(C,_,l,b))}else return this.withToken(v,_=>y.provideTextSearchResults(C,L,I,_))}async withToken(C,L){const I=w(C);this.inProgress.add(I);const v=await L(I.token);return this.inProgress.delete(I),v}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=A;function w(E){const C=new P.CancellationTokenSource;return E.onCancellationRequested(()=>C.cancel()),C}}),define(Ce[380],De([1,0,31,157,156]),function(me,e,P,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(E){this.query=E}search(E,C,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){L({message:y})}},v=new p.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(I),P);return new Promise((y,_)=>v.search(l=>{C(l.map(A))},E).then(l=>y({limitHit:l.limitHit,type:"success",stats:l.stats}),_))}}e.TextSearchEngineAdapter=R;function A(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce((E,C)=>{if(C.ranges){const L=C;return E+(Array.isArray(L.ranges)?L.ranges.length:1)}else return E+1},0)}}}),define(Ce[381],De([1,0,19,8,14,4,129,17,38,2,32,36,376,380]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class _{static{this.BATCH_SIZE=512}constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let a;const t=o(r),h=new R.Emitter({onDidAddFirstListener:()=>{a=(0,F.createCancelablePromise)(u=>this.doFileSearchWithEngine(v.Engine,t,s=>h.fire(s),u)),a.then(u=>h.fire(u),u=>h.fire({type:"error",error:{message:u.message,stack:u.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}textSearch(r){let a;const t=o(r),h=new R.Emitter({onDidAddFirstListener:()=>{a=(0,F.createCancelablePromise)(u=>this.ripgrepTextSearch(t,s=>h.fire(s),u)),a.then(u=>h.fire(u),u=>h.fire({type:"error",error:{message:u.message,stack:u.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}ripgrepTextSearch(r,a,t){return r.maxFileSize=this.getPlatformFileLimits().maxFileSize,new y.TextSearchEngineAdapter(r).search(t,a,a)}getPlatformFileLimits(){return{maxFileSize:16*L.ByteSize.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine(v.Engine,r,a,t)}doFileSearchWithEngine(r,a,t,h,u=_.BATCH_SIZE){let s=0;const c=m=>{Array.isArray(m)?(s+=m.length,t(m.map(D=>this.rawMatchToSearchItem(D)))):m.relativePath?(s++,t(this.rawMatchToSearchItem(m))):t(m)};if(a.sortByScore){let m=this.trySortedSearchFromCache(a,c,h);if(!m){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,g=new r(D);m=this.doSortedSearch(g,a,t,c,h)}return new Promise((D,g)=>{m.then(([f,S])=>{const T=S.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(T,t,u),D(f)},g)})}const d=new r(a);return this.doSearch(d,c,u,h).then(m=>({limitHit:m.limitHit,type:"success",stats:{detailStats:m.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,w.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,a,t,h,u){const s=new R.Emitter;let c=(0,F.createCancelablePromise)(m=>{let D=[];const g=f=>{Array.isArray(f)?D=f:(h(f),s.fire(f))};return this.doSearch(r,g,-1,m).then(f=>[f,D])}),d;if(a.cacheKey){d=this.getOrCreateCache(a.cacheKey);const m={promise:c,event:s.event,resolved:!1};d.resultsToSearchCache[a.filePattern||""]=m,c.then(()=>{m.resolved=!0},D=>{delete d.resultsToSearchCache[a.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([m,D])=>{const g=d?d.scorerCache:Object.create(null),f=(typeof a.maxResults!="number"||a.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(a,D,g,u).then(S=>{const T=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:m.stats,sortingTime:T,fromCache:!1,type:this.processType,workspaceFolderCount:a.folderQueries.length,resultCount:S.length},messages:m.messages,limitHit:m.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},S]})})}getOrCreateCache(r){const a=this.caches[r];return a||(this.caches[r]=new l)}trySortedSearchFromCache(r,a,t){const h=r.cacheKey&&this.caches[r.cacheKey];if(!h)return;const u=this.getResultsFromCache(h,r.filePattern||"",a,t);if(u)return u.then(([s,c,d])=>{const m=E.StopWatch.create(!1);return this.sortResults(r,c,h.scorerCache,t).then(D=>{const g=m.elapsed(),f={fromCache:!0,detailStats:d,type:this.processType,resultCount:c.length,sortingTime:g};return[{type:"success",limitHit:s.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:f},D]})})}sortResults(r,a,t,h){const u=(0,A.prepareQuery)(r.filePattern||""),s=(d,m)=>(0,A.compareItemsByFuzzyScore)(d,m,u,!0,b,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return P.topAsync(a,s,c,1e4,h)}sendProgress(r,a,t){if(t&&t>0)for(let h=0;h<r.length;h+=t)a(r.slice(h,h+t));else a(r)}getResultsFromCache(r,a,t,h){const u=E.StopWatch.create(!1),s=a.indexOf(w.sep)>=0;let c;for(const g in r.resultsToSearchCache)if(a.startsWith(g)){if(s&&g.indexOf(w.sep)<0&&g!=="")continue;const f=r.resultsToSearchCache[g];c={promise:this.preventCancellation(f.promise),event:f.event,resolved:f.resolved};break}if(!c)return null;const d=u.elapsed(),m=E.StopWatch.create(!1),D=c.event(t);return h&&h.onCancellationRequested(()=>{D.dispose()}),c.promise.then(([g,f])=>{if(h&&h.isCancellationRequested)throw(0,p.canceled)();const S=[],T=(0,A.prepareQuery)(a).normalizedLowercase;for(const N of f)(0,I.isFilePatternMatch)(N,T)&&S.push(N);return[g,S,{cacheWasResolved:c.resolved,cacheLookupTime:d,cacheFilterTime:m.elapsed(),cacheEntryCount:f.length}]})}doSearch(r,a,t,h){return new Promise((u,s)=>{let c=[];h?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(t?(c.push(d),t>0&&c.length>=t&&(a(c),c=[])):a(d))},d=>{a(d)},(d,m)=>{c.length&&a(c),d?(a({message:"Search finished. Error: "+d.message}),s(d)):(a({message:"Search finished. Stats: "+JSON.stringify(m.stats)}),u(m))})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.SearchService=_;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(n){return(0,w.basename)(n.relativePath)}getItemDescription(n){return(0,w.dirname)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>C.URI.revive(r))}}function i(n){return{...n,folder:C.URI.revive(n.folder)}}}),define(Ce[382],De([1,0,3,16,2,31,13,27,20,97,66,36,381,379,119,156]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends C.ExtHostSearch{constructor(i,n,r,a){super(i,r,a),this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new P.DisposableStore;const t=new _.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.RipgrepSearchProvider(t))),n.remote.isRemote&&n.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const i=new _.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(F.Schemas.file,new y.RipgrepSearchProvider(i))),this._disposables.add(this.registerInternalFileSearchProvider(F.Schemas.file,new v.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(i,n){const r=this._handlePool++;return this._internalFileSearchProvider=n,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(i)),(0,P.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,C.reviveQuery)(r);if(i===this._internalFileSearchHandle){const h=Date.now();return this.doInternalFileSearch(i,n,t,a).then(u=>{const s=Date.now()-h;return this._logService.debug(`Ext host file search time: ${s}ms`),u})}return super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,I.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){r(t.map(h=>p.URI.file(h.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(i,a,n)}async doInternalFileSearch(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this._proxy.$handleFileMatch(i,n,t)})}$clearCache(i){return this._internalFileSearchProvider?.clearCache(i),super.$clearCache(i)}createTextSearchManager(i,n){return new l.NativeTextSearchManager(i,n,void 0,"textSearchProvider")}};e.NativeExtHostSearch=b,e.NativeExtHostSearch=b=Ge([He(0,E.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,A.ILogService)],b)}),define(Ce[120],De([1,0,396,62,63,397,21,14,4,3,17,11,30,81,82]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class l{traceSocketEvent(f,S){_.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,S)}constructor(f,S=""){this._canWrite=!0,this.debugLabel=S,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,w.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(f){const S=T=>{this.traceSocketEvent("read",T),f(A.VSBuffer.wrap(T))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(f){const S=T=>{f({type:0,hadError:T,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(f){const S=()=>{f()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(f){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,w.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,w.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=l;var b;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var o;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(o||(o={}));class i extends C.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(f,S){this.socket.traceSocketEvent(f,S)}constructor(f,S,T,N){super(),this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:T?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new n(this,S,T,N,this._onData,(z,x)=>this._write(z,x))),this._register(this._flowManager.onError(z=>{console.error(z),(0,w.onUnexpectedError)(z),this._onClose.fire({type:0,hadError:!0,error:z})})),this._incomingData=new _.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(async z=>{this._flowManager.isProcessingReadQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(z)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let S=0;for(;S<f.byteLength;)this._flowManager.writeMessage(f.slice(S,Math.min(S+262144,f.byteLength)),{compressed:!0,opcode:2}),S+=262144}_write(f,{compressed:S,opcode:T}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const z=A.VSBuffer.alloc(N),x=S?64:0,M=T&15;if(z.writeUInt8(128|x|M,0),f.byteLength<126)z.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){z.writeUInt8(126,1);let k=1;z.writeUInt8(f.byteLength>>>8&255,++k),z.writeUInt8(f.byteLength>>>0&255,++k)}else{z.writeUInt8(127,1);let k=1;z.writeUInt8(0,++k),z.writeUInt8(0,++k),z.writeUInt8(0,++k),z.writeUInt8(0,++k),z.writeUInt8(f.byteLength>>>24&255,++k),z.writeUInt8(f.byteLength>>>16&255,++k),z.writeUInt8(f.byteLength>>>8&255,++k),z.writeUInt8(f.byteLength>>>0&255,++k)}this.socket.write(A.VSBuffer.concat([z,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),T=S.readUInt8(0),N=(T&128)>>>7,z=(T&64)>>>6,x=T&15,M=S.readUInt8(1),k=(M&128)>>>7,O=M&127;this._state.state=2,this._state.readLen=2+(k?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!z),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),T=S.readUInt8(1),N=(T&128)>>>7;let z=T&127,x=1;z===126?z=S.readUInt8(++x)*2**8+S.readUInt8(++x):z===127&&(z=S.readUInt8(++x)*0+S.readUInt8(++x)*0+S.readUInt8(++x)*0+S.readUInt8(++x)*0+S.readUInt8(++x)*2**24+S.readUInt8(++x)*2**16+S.readUInt8(++x)*2**8+S.readUInt8(++x));let M=0;N&&(M=S.readUInt8(++x)*2**24+S.readUInt8(++x)*2**16+S.readUInt8(++x)*2**8+S.readUInt8(++x)),this._state.state=3,this._state.readLen=z,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(S,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await E.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=i;class n extends C.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(f,S,T,N,z,x){super(),this._tracer=f,this._onData=z,this._writeFn=x,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new E.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new E.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,S?(this._zlibInflateStream=this._register(new r(this._tracer,N,T,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(f,S){this._writeQueue.push({data:f,options:S}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:f,options:S}=this._writeQueue.shift();if(this._zlibDeflateStream&&S.compressed){const T=await this._deflateMessage(this._zlibDeflateStream,f);this._writeFn(T,S)}else this._writeFn(f,{...S,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(f,S){return new Promise((T,N)=>{f.write(S),f.flush(z=>T(z))})}acceptFrame(f,S,T){this._readQueue.push({data:f,isCompressed:S,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const f=this._readQueue.shift();if(this._zlibInflateStream&&f.isCompressed){const S=await this._inflateFrame(this._zlibInflateStream,f.data,f.isLastFrameOfMessage);this._onData.fire(S)}else this._onData.fire(f.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(f,S,T){return new Promise((N,z)=>{f.write(S),T&&f.write(A.VSBuffer.fromByteArray([0,0,255,255])),f.flush(x=>N(x))})}}class r extends C.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}constructor(f,S,T,N){super(),this._tracer=f,this._recordInflateBytes=S,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,R.createInflateRaw)(N),this._zlibInflate.on("error",z=>{this._tracer.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibInflate.on("data",z=>{this._tracer.traceSocketEvent("zlibInflateData",z),this._pendingInflateData.push(A.VSBuffer.wrap(z))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(f){this._recordInflateBytes&&this._recordedInflateBytes.push(f.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",f),this._zlibInflate.write(f.buffer)}flush(f){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const S=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,f(S)})}}class a extends C.Disposable{constructor(f,S){super(),this._tracer=f,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,R.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(A.VSBuffer.wrap(T))})}write(f){this._tracer.traceSocketEvent("zlibDeflateWrite",f.buffer),this._zlibDeflate.write(f.buffer)}flush(f){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let S=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.byteLength-4),f(S)})}}function t(g,f){if(f===0)return;const S=g.byteLength>>>2;for(let k=0;k<S;k++){const O=g.readUInt32BE(k*4);g.writeUInt32BE(O^f,k*4)}const T=S*4,N=g.byteLength-T,z=f>>>24&255,x=f>>>16&255,M=f>>>8&255;N>=1&&g.writeUInt8(g.readUInt8(T)^z,T),N>=2&&g.writeUInt8(g.readUInt8(T+1)^x,T+1),N>=3&&g.writeUInt8(g.readUInt8(T+2)^M,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={2:107,1:103};function u(){const g=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const f=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,p.tmpdir)(),S=(0,L.join)(f,`vscode-ipc-${g}.sock`);return c(S),S}e.createRandomIPCHandle=u;function s(g,f,S){const N=(0,P.createHash)("sha256").update(g).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${S}-${f}-sock`;const z=S.substr(0,4),x=f.substr(0,6);let M;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${z}-${x}.sock`):M=(0,L.join)(g,`${z}-${x}.sock`),c(M),M}e.createStaticIPCHandle=s;function c(g){const f=h[I.platform];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class d extends y.IPCServer{static toClientConnectionEvent(f){const S=E.Event.fromNodeEventEmitter(f,"connection");return E.Event.map(S,T=>({protocol:new _.Protocol(new l(T,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(T,"close"))}))}constructor(f){super(d.toClientConnectionEvent(f)),this.server=f}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function m(g){return new Promise((f,S)=>{const T=(0,F.createServer)();T.on("error",S),T.listen(g,()=>{T.removeListener("error",S),f(new d(T))})})}e.serve=m;function D(g,f){return new Promise((S,T)=>{const N=(0,F.createConnection)(g,()=>{N.removeListener("error",T),S(_.Client.fromSocket(new l(N,`ipc-client${f}`),f))});N.once("error",T)})}e.connect=D}),define(Ce[383],De([1,0,62,63,167,120,8,3,11,52,13,136,258,259,109,88,21]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function o(t,h,u,s,c){let d;for(let m=3;m&&(d?.dispose(),d=await new i(t,h,u,s,c).waitForReady(),!(c&&p.BROWSER_RESTRICTED_PORTS[c]||!p.BROWSER_RESTRICTED_PORTS[d.tunnelLocalPort]));m--);return d}class i extends w.Disposable{constructor(h,u,s,c,d){super(),this.defaultTunnelHost=u,this.suggestedLocalPort=d,this.privacy=l.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=h,this._server=P.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=m=>this._onConnection(m),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){const h=this.suggestedLocalPort??this.tunnelRemotePort,u=(0,l.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,p.findFreePortFaster)(h,2,1e3,u),c=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(h){h.pause();const u=(0,l.isLocalhost)(this.tunnelRemoteHost)||(0,l.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,v.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),c=s.getSocket(),d=s.readEntireBuffer();s.dispose(),d.byteLength>0&&h.write(d.buffer),h.on("end",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),c.end()}),h.on("close",()=>c.end()),h.on("error",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),c instanceof R.NodeSocket?c.socket.destroy():c.end()}),c instanceof R.NodeSocket?this._mirrorNodeSocket(h,c):this._mirrorGenericSocket(h,c),h.localAddress&&this._socketsDispose.set(h.localAddress,()=>{h.end(),c.end()})}_mirrorGenericSocket(h,u){u.onClose(()=>h.destroy()),u.onEnd(()=>h.end()),u.onData(s=>h.write(s.buffer)),h.on("data",s=>u.write(b.VSBuffer.wrap(s))),h.resume()}_mirrorNodeSocket(h,u){const s=u.socket;s.on("end",()=>h.end()),s.on("close",()=>h.end()),s.on("error",()=>{h.destroy()}),s.pipe(h),h.pipe(s)}}e.NodeRemoteTunnel=i;let n=class extends l.AbstractTunnelService{constructor(h,u,s,c,d){super(u,d),this.remoteSocketFactoryService=h,this.signService=s,this.productService=c}isPortPrivileged(h){return(0,l.isPortPrivileged)(h,this.defaultTunnelHost,E.OS,F.release())}retainOrCreateTunnel(h,u,s,c,d,m,D,g){const f=this.getTunnelFromMap(u,s);if(f)return++f.refcount,f.value;if((0,l.isTunnelProvider)(h))return this.createWithProvider(h,u,s,d,m,D,g);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${s} on local port ${d}.`);const S={commit:this.productService.commit,quality:this.productService.quality,addressProvider:h,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},T=o(S,c,u,s,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,s,T),T}}};e.BaseTunnelService=n,e.BaseTunnelService=n=Ge([He(0,y.IRemoteSocketFactoryService),He(1,L.ILogService),He(2,_.ISignService),He(3,I.IProductService),He(4,C.IConfigurationService)],n);let r=class extends n{constructor(h,u,s,c,d){super(h,u,s,c,d)}};e.TunnelService=r,e.TunnelService=r=Ge([He(0,y.IRemoteSocketFactoryService),He(1,L.ILogService),He(2,_.ISignService),He(3,I.IProductService),He(4,C.IConfigurationService)],r);let a=class extends w.Disposable{constructor(h,u,s,c,d){super(),this.remoteSocketFactoryService=h,this.logService=u,this.productService=s,this.signService=c,this.configurationService=d,this._tunnelServices=new Map}async openTunnel(h,u,s,c,d,m,D,g,f){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${c} on local port ${m}.`),!this._tunnelServices.has(h)){const S=new r(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(S),this._tunnelServices.set(h,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this._tunnelServices.delete(h))})}return this._tunnelServices.get(h).openTunnel(u,s,c,d,m,D,g,f)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=Ge([He(0,y.IRemoteSocketFactoryService),He(1,L.ILogService),He(2,I.IProductService),He(3,_.ISignService),He(4,C.IConfigurationService)],a)}),define(Ce[384],De([1,0,120,278,57,33,2,13,41]),function(me,e,P,F,p,R,A,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(v,y,_){this._commands=v,this.logService=y,this._ipcHandlePath=_,this._server=F.createServer((l,b)=>this.onRequest(l,b)),this.setup().catch(l=>(y.error(l),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",v=>this.logService.error(v))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(v,y){const _=(b,o)=>{y.writeHead(b,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),i=>i&&this.logService.error(i))},l=[];v.setEncoding("utf8"),v.on("data",b=>l.push(b)),v.on("end",async()=>{try{const b=JSON.parse(l.join(""));let o;switch(b.type){case"open":o=await this.open(b);break;case"openExternal":o=await this.openExternal(b);break;case"status":o=await this.getStatus(b);break;case"extensionManagement":o=await this.manageExtensions(b);break;default:_(404,`Unknown message type: ${b.type}`);break}_(200,o)}catch(b){const o=b instanceof Error?b.message:JSON.stringify(b);_(500,o),this.logService.error("Error while processing pipe request",b)}})}async open(v){const{fileURIs:y,folderURIs:_,forceNewWindow:l,diffMode:b,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=v,h=[];if(Array.isArray(_))for(const d of _)try{h.push({folderUri:A.URI.parse(d)})}catch{}if(Array.isArray(y))for(const d of y)try{(0,E.hasWorkspaceFileExtension)(d)?h.push({workspaceUri:A.URI.parse(d)}):h.push({fileUri:A.URI.parse(d)})}catch{}const u=a?A.URI.file(a):void 0,c={forceNewWindow:l,diffMode:b,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!u&&!i,waitMarkerFileURI:u,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",h,c)}async openExternal(v){for(const y of v.uris){const _=A.URI.parse(y),l=_.scheme==="file"?_:y;await this._commands.executeCommand("_remoteCLI.openExternal",l)}}async manageExtensions(v){const y=l=>l?.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),_={list:v.list,install:y(v.install),uninstall:y(v.uninstall),force:v.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",_)}async getStatus(v){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&p.existsSync(this._ipcHandlePath)&&p.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let L=class extends C{constructor(v,y){super(v,y,(0,P.createRandomIPCHandle)())}};e.CLIServer=L,e.CLIServer=L=Ge([He(0,R.IExtHostCommands),He(1,w.ILogService)],L)}),define(Ce[385],De([1,0,58,372,367,277,47,354,2,16,7,384,103,310,353]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends p.RequireInterceptor{_installInterceptor(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(u,s,c){return u=t(u),i._factories.has(u)?i._factories.get(u).load(u,E.URI.file((0,v.realpathSync)(s.filename)),d=>r.apply(this,[d,s,c])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(h,u)=>a.call(this,t(h),u);const t=h=>{for(const u of i._alternatives){const s=u(h);if(s){h=s;break}}return h}}}class b extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const i=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(w.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this._instaService.createInstance(_.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(l,i,{mine:this._myRegistry,all:this._globalRegistry}).install(),P.mark("code/extHost/didInitAPI");const r=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,r,this,this._logService,this._mainThreadTelemetryProxy,this._initData),P.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(i){return i.main}async _loadCommonJSModule(i,n,r){if(n.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this._logService.flush();const t=i?.identifier.value;i&&await this._extHostLocalizationService.initializeLocalizedMessages(i);try{t&&P.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&P.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this._initData.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.ExtHostExtensionService=b}),define(Ce[386],De([1,0,51,21,4,3,122,11,23,2,31,13,257,64,109,88,383,27,20,70,361]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function a(f){const S=f.trim().split(`
`),T=[];return S.forEach(z=>{const x=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);x&&x.length>=3&&T.push({pid:parseInt(x[1],10),socket:parseInt(x[2],10)})}),T.reduce((z,x)=>(z[x.socket]=x,z),{})}e.getSockets=a;function t(...f){const S=[].concat(...f.map(u));return[...new Map(S.filter(T=>T.st==="0A").map(T=>{const N=T.local_address.split(":");return{socket:parseInt(T.inode,10),ip:h(N[0]),port:parseInt(N[1],16)}}).map(T=>[T.ip+":"+T.port,T])).values()]}e.loadListeningPorts=t;function h(f){let S="";if(f.length===8)for(let T=f.length-2;T>=0;T-=2)S+=parseInt(f.substr(T,2),16),T!==0&&(S+=".");else for(let T=0;T<f.length;T+=8){const N=f.substring(T,T+8);let z="";for(let x=8;x>=2;x-=2)z+=N.substring(x-2,x),(x===6||x===2)&&(z=parseInt(z,16).toString(16),S+=`${z}`,z="",T+x!==f.length-6&&(S+=":"))}return S}e.parseIpAddress=h;function u(f){const S=f.trim().split(`
`),T=S.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return S.map(z=>z.trim().split(/\s+/).reduce((x,M,k)=>(x[T[k]||k]=M,x),{}))}e.loadConnectionTable=u;function s(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function c(f){const S=f.trim().split(`
`),T=[];return S.forEach(N=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);z&&z.length>=4&&T.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),T}e.getRootProcesses=c;async function d(f,S,T){const N=T.reduce((x,M)=>(x[M.pid]=M,x),{}),z=[];return f.forEach(({socket:x,ip:M,port:k})=>{const O=S[x]?S[x].pid:void 0,U=O?N[O]?.cmd:void 0;O&&U&&!s(U)&&z.push({host:M,port:k,detail:U,pid:O})}),z}e.findPorts=d;function m(f,S,T){const N=new Map,z=c(S);for(const x of f){const M=T.get(x.port);if(M){N.set(x.port,M);continue}const k=z.find(O=>O.cmd.includes(`${x.port}`));if(k){let O=k,U;do U=z.find(q=>q.ppid===O.pid),U&&(O=U);while(U);N.set(x.port,{host:x.ip,port:x.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(x.port,{host:x.ip,port:x.port,ppid:Number.MAX_VALUE})}return N}e.tryFindRootPorts=m;let D=class extends n.ExtHostTunnelService{constructor(S,T,N,z){super(S,T,N),this.initData=T,this.signService=z,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,w.isLinux&&T.remote.isRemote&&T.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(S){if(S&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=S;let T;this._initialCandidates&&(T=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const N=new A.MovingAverage;let z=0;for(;this._candidateFindingEnabled;){const x=new Date().getTime(),M=(await this.findCandidatePorts()).filter(U=>(0,l.isLocalhost)(U.host)||(0,l.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(U=>U.port).join(", ")}`);const k=new Date().getTime()-x;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${k} ms.`),z++>3&&N.update(k),(!T||JSON.stringify(T)!==JSON.stringify(M))&&(T=M,await this._proxy.$onFoundNewCandidates(T));const O=this.calculateDelay(N.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(U=>setTimeout(()=>U(),O))}}calculateDelay(S){return Math.max(S*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(S=>S.port).join(", ")}`)}async findCandidatePorts(){let S="",T="";try{S=await L.Promises.readFile("/proc/net/tcp","utf8"),T=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(S,T),z=await new Promise(Z=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Y,ae)=>{Z(Y)})}),x=a(z),M=await L.Promises.readdir("/proc"),k=[];for(const Z of M)try{const Q=Number(Z),Y=E.joinPath(C.URI.file("/proc"),Z);if((await L.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(Q)){const ee=await L.Promises.readlink(E.joinPath(Y,"cwd").fsPath),fe=await L.Promises.readFile(E.joinPath(Y,"cmdline").fsPath,"utf8");k.push({pid:Q,cwd:ee,cmd:fe})}}catch{}const O=[],U=N.filter(Z=>{const Q=x[Z.socket];return Q||O.push(Z),Q}),q=d(U,x,k);let ie;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const Z=await new Promise(Q=>{(0,P.exec)("ps -F -A -l | grep root",(Y,ae,ee)=>{Q(ae)})});this._foundRootPorts=m(O,Z,this._foundRootPorts),ie=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ie.map(Q=>Q.port).join(", ")}`)}return q.then(Z=>ie?Z.concat(ie):Z)}makeManagedTunnelFactory(S){return async T=>{const N=new b.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(x,M,k,O){const U=await S.makeConnection();return g.connect(U,M,k,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.ManagedRemoteConnection(0),connectionToken:S.connectionToken})}},signService:this.signService},"localhost",T.remoteAddress.host||"localhost",T.remoteAddress.port,T.localAddressPort);await N.waitForReady();const z=new p.Emitter;return{localAddress:(0,r.parseAddress)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{N.dispose(),z.fire(),z.dispose()}}}}};e.NodeExtHostTunnelService=D,e.NodeExtHostTunnelService=D=Ge([He(0,i.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,I.ILogService),He(3,_.ISignService)],D);class g extends v.ManagedSocket{static connect(S,T,N,z){const x=new R.DisposableStore,M={onClose:x.add(new p.Emitter),onData:x.add(new p.Emitter),onEnd:x.add(new p.Emitter)};x.add(S.onDidReceiveMessage(O=>M.onData.fire(F.VSBuffer.wrap(O)))),x.add(S.onDidEnd(()=>M.onEnd.fire())),x.add(S.onDidClose(O=>M.onClose.fire({type:0,error:O,hadError:!!O})));const k=new g(S,z,M);return k._register(x),(0,v.connectManagedSocket)(k,T,N,z,M)}constructor(S,T,N){super(T,N),this.passing=S}write(S){this.passing.send(S.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(Ce[387],De([1,0,84,356,370,369,382,385,386,96,47,97,95,46,70,93,355,311,13,371,60,272,105,109,138]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o,i,n,r,a,t,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.registerSingleton)(L.IExtHostExtensionService,w.ExtHostExtensionService,0),(0,P.registerSingleton)(i.ILoggerService,o.ExtHostLoggerService,1),(0,P.registerSingleton)(i.ILogService,new t.SyncDescriptor(a.ExtHostLogService,[!1],!0)),(0,P.registerSingleton)(h.ISignService,u.SignService,1),(0,P.registerSingleton)(l.IExtensionStoragePaths,b.ExtensionStoragePaths,0),(0,P.registerSingleton)(C.IExtHostDebugService,R.ExtHostDebugService,0),(0,P.registerSingleton)(I.IExtHostSearch,A.NativeExtHostSearch,0),(0,P.registerSingleton)(v.IExtHostTask,p.ExtHostTask,0),(0,P.registerSingleton)(y.IExtHostTerminalService,F.ExtHostTerminalService,0),(0,P.registerSingleton)(_.IExtHostTunnelService,E.NodeExtHostTunnelService,0),(0,P.registerSingleton)(r.IExtHostVariableResolverProvider,n.NodeExtHostVariableResolverProviderService,0)}),define(Ce[398],De([1,0,62,399,58,14,82,120,255,113,368,21,31,103,8,132,279,293,373,387]),function(me,e,P,F,p,R,A,w,E,C,L,I,v,y,_,l,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,m=d._load;d._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const n=process.exit.bind(process),r=process.on.bind(process);function a(d){process.exit=function(m){if(d)n(m);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(m,D){m==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(m,D)}}let t=function(d){n()};function h(){const d=(0,o.readExtHostConnection)(process.env);if(d.type===3)return new Promise((m,D)=>{const g=f=>{const S=f[0],T=new A.BufferedEmitter;S.on("message",N=>T.fire(I.VSBuffer.wrap(N.data))),S.on("close",()=>{t("renderer closed the MessagePort")}),S.start(),m({onMessage:T.event,send:N=>S.postMessage(N.buffer)})};process.parentPort.on("message",f=>g(f.ports))});if(d.type===2)return new Promise((m,D)=>{let g=null;const f=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,T=3e5,N=new _.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (1)"),S),z=new _.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (2)"),T);process.on("message",(M,k)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){k.setNoDelay(!0);const O=I.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new w.NodeSocket(k,"extHost-socket");else{const q=I.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new w.WebSocketNodeSocket(new w.NodeSocket(k,"extHost-socket"),M.permessageDeflate,q,!1)}g?(N.cancel(),z.cancel(),g.beginAcceptReconnection(U,O),g.endAcceptReconnection(),g.sendResume()):(clearTimeout(f),g=new A.PersistentProtocol({socket:U,initialChunk:O}),g.sendResume(),g.onDidDispose(()=>t("renderer disconnected")),m(g),g.onSocketClose(()=>{N.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;N.isScheduled()&&z.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const m=d.pipeName;return new Promise((D,g)=>{const f=P.createConnection(m,()=>{f.removeListener("error",g);const S=new A.PersistentProtocol({socket:new w.NodeSocket(f,"extHost-renderer")});S.sendResume(),D(S)});f.once("error",g),f.on("close",()=>{t("renderer closed the socket")})})}}async function u(){const d=await h();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,d.onMessage(m=>{(0,C.isMessageOfType)(m,2)?(this._terminating=!0,t("received terminate message from renderer")):this._onMessage.fire(m)})}send(m){this._terminating||d.send(m)}async drain(){if(d.drain)return d.drain()}}}function s(d){return new Promise(m=>{const D=d.onMessage(g=>{D.dispose();const f=JSON.parse(g.toString()),S=f.commit,T=E.default.commit;if(S&&T&&S!==T&&n(55),f.parentPid){let N=0;setInterval(function(){try{process.kill(f.parentPid,0),N=0}catch(x){x&&x.code==="EPERM"?(N++,N>=3&&t(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):t(`parent process ${f.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(f.parentPid)}catch(x){(0,R.onUnexpectedError)(x)}}d.send((0,C.createMessageOfType)(0)),m({protocol:d,initData:f})});d.send((0,C.createMessageOfType)(1))})}async function c(){const d=[];process.on("unhandledRejection",(N,z)=>{d.push(z),setTimeout(()=>{const x=d.indexOf(z);x>=0&&z.catch(M=>{d.splice(x,1),(0,R.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),N&&(0,R.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const z=d.indexOf(N);z>=0&&d.splice(z,1)}),process.on("uncaughtException",function(N){(0,R.isSigPipeError)(N)||(0,R.onUnexpectedError)(N)}),p.mark("code/extHost/willConnectToRenderer");const m=await u();p.mark("code/extHost/didConnectToRenderer");const D=await s(m);p.mark("code/extHost/didWaitForInitData");const{initData:g}=D;a(!!g.environment.extensionTestsLocationURI),g.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,g.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return v.Promises.exists(z)}fsRealpath(z){return(0,y.realpath)(z)}};let S=null;g.remote.authority&&i.transformURIs&&(S=(0,b.createURITransformer)(g.remote.authority));const T=new L.ExtensionHostMain(D.protocol,g,f,S);t=N=>T.terminate(N)}c().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/workbench/api/node/extensionHostProcess.js.map
