/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(fe){for(var e=[],I=0,L=fe.length;I<L;I++)e[I]=Te[fe[I]];return e};define(Te[68],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(T){return(m,f,y)=>{let R=null,C=null;if(typeof y.value=="function"?(R="value",C=y.value):typeof y.get=="function"&&(R="get",C=y.get),!C)throw new Error("not supported");y[R]=T(C,f)}}function L(T,m,f){let y=null,R=null;if(typeof f.value=="function"?(y="value",R=f.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(y="get",R=f.get),!R)throw new Error("not supported");const C=`$memoize$${m}`;f[y]=function(...u){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[C]}}e.memoize=L;function P(T,m,f){return I((y,R)=>{const C=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=f?f():void 0),clearTimeout(this[C]),m&&(this[u]=m(this[u],...E),E=[this[u]]),this[C]=setTimeout(()=>{y.apply(this,E),this[u]=f?f():void 0},T)}})}e.debounce=P;function O(T,m,f){return I((y,R)=>{const C=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...s){if(this[u]||(this[u]=f?f():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),m&&(this[u]=m(this[u],...s)),this[p])return;const c=this[E]+T;c<=Date.now()?(this[E]=Date.now(),y.apply(this,[this[u]]),this[u]=f?f():void 0):(this[p]=!0,this[C]=setTimeout(()=>{this[p]=!1,this[E]=Date.now(),y.apply(this,[this[u]]),this[u]=f?f():void 0},c-Date.now()))}})}e.throttle=O}),define(Te[88],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class I{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=I,e.defaultGenerator=new I("id#")}),define(Te[120],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(i,v=!1){let l=0;const o=i.length;let S="",w=0,g=16,D=0;function h(B){let k=0,N=0;for(;k<B;){const $=i.charCodeAt(l);if($>=48&&$<=57)N=N*16+$-48;else if($>=65&&$<=70)N=N*16+$-65+10;else if($>=97&&$<=102)N=N*16+$-97+10;else break;l++,k++}return k<B&&(N=-1),N}function _(B){l=B,S="",w=0,g=16,D=0}function b(){const B=l;if(i.charCodeAt(l)===48)l++;else for(l++;l<i.length&&y(i.charCodeAt(l));)l++;if(l<i.length&&i.charCodeAt(l)===46)if(l++,l<i.length&&y(i.charCodeAt(l)))for(l++;l<i.length&&y(i.charCodeAt(l));)l++;else return D=3,i.substring(B,l);let k=l;if(l<i.length&&(i.charCodeAt(l)===69||i.charCodeAt(l)===101))if(l++,(l<i.length&&i.charCodeAt(l)===43||i.charCodeAt(l)===45)&&l++,l<i.length&&y(i.charCodeAt(l))){for(l++;l<i.length&&y(i.charCodeAt(l));)l++;k=l}else D=3;return i.substring(B,k)}function A(){let B="",k=l;for(;;){if(l>=o){B+=i.substring(k,l),D=2;break}const N=i.charCodeAt(l);if(N===34){B+=i.substring(k,l),l++;break}if(N===92){if(B+=i.substring(k,l),l++,l>=o){D=2;break}switch(i.charCodeAt(l++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const re=h(4);re>=0?B+=String.fromCharCode(re):D=4;break}default:D=5}k=l;continue}if(N>=0&&N<=31)if(f(N)){B+=i.substring(k,l),D=2;break}else D=6;l++}return B}function F(){if(S="",D=0,w=l,l>=o)return w=o,g=17;let B=i.charCodeAt(l);if(m(B)){do l++,S+=String.fromCharCode(B),B=i.charCodeAt(l);while(m(B));return g=15}if(f(B))return l++,S+=String.fromCharCode(B),B===13&&i.charCodeAt(l)===10&&(l++,S+=`
`),g=14;switch(B){case 123:return l++,g=1;case 125:return l++,g=2;case 91:return l++,g=3;case 93:return l++,g=4;case 58:return l++,g=6;case 44:return l++,g=5;case 34:return l++,S=A(),g=10;case 47:{const k=l-1;if(i.charCodeAt(l+1)===47){for(l+=2;l<o&&!f(i.charCodeAt(l));)l++;return S=i.substring(k,l),g=12}if(i.charCodeAt(l+1)===42){l+=2;const N=o-1;let $=!1;for(;l<N;){if(i.charCodeAt(l)===42&&i.charCodeAt(l+1)===47){l+=2,$=!0;break}l++}return $||(l++,D=1),S=i.substring(k,l),g=13}return S+=String.fromCharCode(B),l++,g=16}case 45:if(S+=String.fromCharCode(B),l++,l===o||!y(i.charCodeAt(l)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return S+=b(),g=11;default:for(;l<o&&j(B);)l++,B=i.charCodeAt(l);if(w!==l){switch(S=i.substring(w,l),S){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return S+=String.fromCharCode(B),l++,g=16}}function j(B){if(m(B)||f(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let B;do B=F();while(B>=12&&B<=15);return B}return{setPosition:_,getPosition:()=>l,scan:v?H:F,getToken:()=>g,getTokenValue:()=>S,getTokenOffset:()=>w,getTokenLength:()=>l-w,getTokenError:()=>D}}e.createScanner=T;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function y(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function C(i,v){const l=[],o=new Object;let S;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(h,_,b,A){w.value=h,w.offset=_,w.length=b,w.type=A,w.colonOffset=void 0,S=w}try{r(i,{onObjectBegin:(h,_)=>{if(v<=h)throw o;S=void 0,g=v>h,l.push("")},onObjectProperty:(h,_,b)=>{if(v<_||(D(h,_,b,"property"),l[l.length-1]=h,v<=_+b))throw o},onObjectEnd:(h,_)=>{if(v<=h)throw o;S=void 0,l.pop()},onArrayBegin:(h,_)=>{if(v<=h)throw o;S=void 0,l.push(0)},onArrayEnd:(h,_)=>{if(v<=h)throw o;S=void 0,l.pop()},onLiteralValue:(h,_,b)=>{if(v<_||(D(h,_,b,d(h)),v<=_+b))throw o},onSeparator:(h,_,b)=>{if(v<=_)throw o;if(h===":"&&S&&S.type==="property")S.colonOffset=_,g=!1,S=void 0;else if(h===","){const A=l[l.length-1];typeof A=="number"?l[l.length-1]=A+1:(g=!0,l[l.length-1]=""),S=void 0}}})}catch(h){if(h!==o)throw h}return{path:l,previousNode:S,isAtPropertyKey:g,matches:h=>{let _=0;for(let b=0;_<h.length&&b<l.length;b++)if(h[_]===l[b]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=C;function u(i,v=[],l=O.DEFAULT){let o=null,S=[];const w=[];function g(h){Array.isArray(S)?S.push(h):o!==null&&(S[o]=h)}return r(i,{onObjectBegin:()=>{const h={};g(h),w.push(S),S=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{S=w.pop()},onArrayBegin:()=>{const h=[];g(h),w.push(S),S=h,o=null},onArrayEnd:()=>{S=w.pop()},onLiteralValue:g,onError:(h,_,b)=>{v.push({error:h,offset:_,length:b})}},l),S[0]}e.parse=u;function E(i,v=[],l=O.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function S(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function w(h){return o.children.push(h),h}r(i,{onObjectBegin:h=>{o=w({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,_,b)=>{o=w({type:"property",offset:_,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:_,length:b,parent:o})},onObjectEnd:(h,_)=>{o.length=h+_-o.offset,o=o.parent,S(h+_)},onArrayBegin:(h,_)=>{o=w({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,_)=>{o.length=h+_-o.offset,o=o.parent,S(h+_)},onLiteralValue:(h,_,b)=>{w({type:d(h),offset:_,length:b,parent:o,value:h}),S(_+b)},onSeparator:(h,_,b)=>{o.type==="property"&&(h===":"?o.colonOffset=_:h===","&&S(_))},onError:(h,_,b)=>{v.push({error:h,offset:_,length:b})}},l);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=E;function p(i,v){if(!i)return;let l=i;for(const o of v)if(typeof o=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let S=!1;for(const w of l.children)if(Array.isArray(w.children)&&w.children[0].value===o){l=w.children[1],S=!0;break}if(!S)return}else{const S=o;if(l.type!=="array"||S<0||!Array.isArray(l.children)||S>=l.children.length)return;l=l.children[S]}return l}e.findNodeAtLocation=p;function s(i){if(!i.parent||!i.parent.children)return[];const v=s(i.parent);if(i.parent.type==="property"){const l=i.parent.children[0].value;v.push(l)}else if(i.parent.type==="array"){const l=i.parent.children.indexOf(i);l!==-1&&v.push(l)}return v}e.getNodePath=s;function c(i){switch(i.type){case"array":return i.children.map(c);case"object":{const v=Object.create(null);for(const l of i.children){const o=l.children[1];o&&(v[l.children[0].value]=c(o))}return v}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=c;function t(i,v,l=!1){return v>=i.offset&&v<i.offset+i.length||l&&v===i.offset+i.length}e.contains=t;function n(i,v,l=!1){if(t(i,v,l)){const o=i.children;if(Array.isArray(o))for(let S=0;S<o.length&&o[S].offset<=v;S++){const w=n(o[S],v,l);if(w)return w}return i}}e.findNodeAtOffset=n;function r(i,v,l=O.DEFAULT){const o=T(i,!1);function S(se){return se?()=>se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function w(se){return se?pe=>se(pe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const g=S(v.onObjectBegin),D=w(v.onObjectProperty),h=S(v.onObjectEnd),_=S(v.onArrayBegin),b=S(v.onArrayEnd),A=w(v.onLiteralValue),F=w(v.onSeparator),j=S(v.onComment),H=w(v.onError),B=l&&l.disallowComments,k=l&&l.allowTrailingComma;function N(){for(;;){const se=o.scan();switch(o.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(se){case 12:case 13:B?$(10):j();break;case 16:$(1);break;case 15:case 14:break;default:return se}}}function $(se,pe=[],ee=[]){if(H(se),pe.length+ee.length>0){let X=o.getToken();for(;X!==17;){if(pe.indexOf(X)!==-1){N();break}else if(ee.indexOf(X)!==-1)break;X=N()}}}function re(se){const pe=o.getTokenValue();return se?A(pe):D(pe),N(),!0}function le(){switch(o.getToken()){case 11:{let se=0;try{se=JSON.parse(o.getTokenValue()),typeof se!="number"&&($(2),se=0)}catch{$(2)}A(se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return N(),!0}function _e(){return o.getToken()!==10?($(3,[],[2,5]),!1):(re(!1),o.getToken()===6?(F(":"),N(),Ee()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ye(){g(),N();let se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(se||$(4,[],[]),F(","),N(),o.getToken()===2&&k)break}else se&&$(6,[],[]);_e()||$(4,[],[2,5]),se=!0}return h(),o.getToken()!==2?$(7,[2],[]):N(),!0}function de(){_(),N();let se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(se||$(4,[],[]),F(","),N(),o.getToken()===4&&k)break}else se&&$(6,[],[]);Ee()||$(4,[],[4,5]),se=!0}return b(),o.getToken()!==4?$(8,[4],[]):N(),!0}function Ee(){switch(o.getToken()){case 3:return de();case 1:return ye();case 10:return re(!0);default:return le()}}return N(),o.getToken()===17?l.allowEmptyContent?!0:($(4,[],[]),!1):Ee()?(o.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=r;function a(i,v){const l=T(i),o=[];let S,w=0,g;do switch(g=l.getPosition(),S=l.scan(),S){case 12:case 13:case 17:w!==g&&o.push(i.substring(w,g)),v!==void 0&&o.push(l.getTokenValue().replace(/[^\r\n]/g,v)),w=l.getPosition();break}while(S!==17);return o.join("")}e.stripComments=a;function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),function(fe,e){typeof define=="function"&&define.amd?define(Te[121],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(ke,we){for(var me=0;me<we.length;me++){var K=we[me];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ke,K.key,K)}}function I(ke,we,me){return we&&e(ke.prototype,we),me&&e(ke,me),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function L(ke,we){if(ke){if(typeof ke=="string")return P(ke,we);var me=Object.prototype.toString.call(ke).slice(8,-1);if(me==="Object"&&ke.constructor&&(me=ke.constructor.name),me==="Map"||me==="Set")return Array.from(ke);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return P(ke,we)}}function P(ke,we){(we==null||we>ke.length)&&(we=ke.length);for(var me=0,K=new Array(we);me<we;me++)K[me]=ke[me];return K}function O(ke,we){var me=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(me)return(me=me.call(ke)).next.bind(me);if(Array.isArray(ke)||(me=L(ke))||we&&ke&&typeof ke.length=="number"){me&&(ke=me);var K=0;return function(){return K>=ke.length?{done:!0}:{done:!1,value:ke[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=T();function m(ke){fe.defaults=ke}var f=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(we){return u[we]};function p(ke,we){if(we){if(f.test(ke))return ke.replace(y,E)}else if(R.test(ke))return ke.replace(C,E);return ke}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(ke){return ke.replace(s,function(we,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(ke,we){ke=typeof ke=="string"?ke:ke.source,we=we||"";var me={replace:function(J,ue){return ue=ue.source||ue,ue=ue.replace(t,"$1"),ke=ke.replace(J,ue),me},getRegex:function(){return new RegExp(ke,we)}};return me}var r=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(ke,we,me){if(ke){var K;try{K=decodeURIComponent(c(me)).replace(r,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}we&&!a.test(me)&&(me=S(we,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var i={},v=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function S(ke,we){i[" "+ke]||(v.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=h(ke,"/",!0)),ke=i[" "+ke];var me=ke.indexOf(":")===-1;return we.substring(0,2)==="//"?me?we:ke.replace(l,"$1")+we:we.charAt(0)==="/"?me?we:ke.replace(o,"$1")+we:ke+we}var w={exec:function(){}};function g(ke){for(var we=1,me,K;we<arguments.length;we++){me=arguments[we];for(K in me)Object.prototype.hasOwnProperty.call(me,K)&&(ke[K]=me[K])}return ke}function D(ke,we){var me=ke.replace(/\|/g,function(ue,he,Pe){for(var ge=!1,De=he;--De>=0&&Pe[De]==="\\";)ge=!ge;return ge?"|":" |"}),K=me.split(/ \|/),J=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>we)K.splice(we);else for(;K.length<we;)K.push("");for(;J<K.length;J++)K[J]=K[J].trim().replace(/\\\|/g,"|");return K}function h(ke,we,me){var K=ke.length;if(K===0)return"";for(var J=0;J<K;){var ue=ke.charAt(K-J-1);if(ue===we&&!me)J++;else if(ue!==we&&me)J++;else break}return ke.slice(0,K-J)}function _(ke,we){if(ke.indexOf(we[1])===-1)return-1;for(var me=ke.length,K=0,J=0;J<me;J++)if(ke[J]==="\\")J++;else if(ke[J]===we[0])K++;else if(ke[J]===we[1]&&(K--,K<0))return J;return-1}function b(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ke,we){if(we<1)return"";for(var me="";we>1;)we&1&&(me+=ke),we>>=1,ke+=ke;return me+ke}function F(ke,we,me,K){var J=we.href,ue=we.title?p(we.title):null,he=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){K.state.inLink=!0;var Pe={type:"link",raw:me,href:J,title:ue,text:he,tokens:K.inlineTokens(he)};return K.state.inLink=!1,Pe}return{type:"image",raw:me,href:J,title:ue,text:p(he)}}function j(ke,we){var me=ke.match(/^(\s+)(?:```)/);if(me===null)return we;var K=me[1];return we.split(`
`).map(function(J){var ue=J.match(/^\s+/);if(ue===null)return J;var he=ue[0];return he.length>=K.length?J.slice(K.length):J}).join(`
`)}var H=function(){function ke(me){this.options=me||fe.defaults}var we=ke.prototype;return we.space=function(K){var J=this.rules.block.newline.exec(K);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},we.code=function(K){var J=this.rules.block.code.exec(K);if(J){var ue=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:h(ue,`
`)}}},we.fences=function(K){var J=this.rules.block.fences.exec(K);if(J){var ue=J[0],he=j(ue,J[3]||"");return{type:"code",raw:ue,lang:J[2]?J[2].trim():J[2],text:he}}},we.heading=function(K){var J=this.rules.block.heading.exec(K);if(J){var ue=J[2].trim();if(/#$/.test(ue)){var he=h(ue,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ue=he.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:ue,tokens:this.lexer.inline(ue)}}},we.hr=function(K){var J=this.rules.block.hr.exec(K);if(J)return{type:"hr",raw:J[0]}},we.blockquote=function(K){var J=this.rules.block.blockquote.exec(K);if(J){var ue=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},we.list=function(K){var J=this.rules.block.list.exec(K);if(J){var ue,he,Pe,ge,De,Re,xe,M,x,q,W,te,oe=J[1].trim(),Ne=oe.length>1,$e={type:"list",raw:"",ordered:Ne,start:Ne?+oe.slice(0,-1):"",loose:!1,items:[]};oe=Ne?"\\d{1,9}\\"+oe.slice(-1):"\\"+oe,this.options.pedantic&&(oe=Ne?oe:"[*+-]");for(var We=new RegExp("^( {0,3}"+oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(te=!1,!(!(J=We.exec(K))||this.rules.block.hr.test(K)));){if(ue=J[0],K=K.substring(ue.length),M=J[2].split(`
`,1)[0],x=K.split(`
`,1)[0],this.options.pedantic?(ge=2,W=M.trimLeft()):(ge=J[2].search(/[^ ]/),ge=ge>4?1:ge,W=M.slice(ge),ge+=J[1].length),Re=!1,!M&&/^ *$/.test(x)&&(ue+=x+`
`,K=K.substring(x.length+1),te=!0),!te)for(var Je=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ut=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");K&&(q=K.split(`
`,1)[0],M=q,this.options.pedantic&&(M=M.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ut.test(M)||rt.test(M)||Je.test(M)||tt.test(K)));){if(M.search(/[^ ]/)>=ge||!M.trim())W+=`
`+M.slice(ge);else if(!Re)W+=`
`+M;else break;!Re&&!M.trim()&&(Re=!0),ue+=q+`
`,K=K.substring(q.length+1)}$e.loose||(xe?$e.loose=!0:/\n *\n *$/.test(ue)&&(xe=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(W),he&&(Pe=he[0]!=="[ ] ",W=W.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:ue,task:!!he,checked:Pe,loose:!1,text:W}),$e.raw+=ue}$e.items[$e.items.length-1].raw=ue.trimRight(),$e.items[$e.items.length-1].text=W.trimRight(),$e.raw=$e.raw.trimRight();var it=$e.items.length;for(De=0;De<it;De++){this.lexer.state.top=!1,$e.items[De].tokens=this.lexer.blockTokens($e.items[De].text,[]);var ot=$e.items[De].tokens.filter(function(et){return et.type==="space"}),ze=ot.every(function(et){for(var Y=et.raw.split(""),Q=0,ve=O(Y),He;!(He=ve()).done;){var Qe=He.value;if(Qe===`
`&&(Q+=1),Q>1)return!0}return!1});!$e.loose&&ot.length&&ze&&($e.loose=!0,$e.items[De].loose=!0)}return $e}},we.html=function(K){var J=this.rules.block.html.exec(K);if(J){var ue={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(J[0]):p(J[0]);ue.type="paragraph",ue.text=he,ue.tokens=this.lexer.inline(he)}return ue}},we.def=function(K){var J=this.rules.block.def.exec(K);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var ue=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:J[0],href:J[2],title:J[3]}}},we.table=function(K){var J=this.rules.block.table.exec(K);if(J){var ue={type:"table",header:D(J[1]).map(function(xe){return{text:xe}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=J[0];var he=ue.align.length,Pe,ge,De,Re;for(Pe=0;Pe<he;Pe++)/^ *-+: *$/.test(ue.align[Pe])?ue.align[Pe]="right":/^ *:-+: *$/.test(ue.align[Pe])?ue.align[Pe]="center":/^ *:-+ *$/.test(ue.align[Pe])?ue.align[Pe]="left":ue.align[Pe]=null;for(he=ue.rows.length,Pe=0;Pe<he;Pe++)ue.rows[Pe]=D(ue.rows[Pe],ue.header.length).map(function(xe){return{text:xe}});for(he=ue.header.length,ge=0;ge<he;ge++)ue.header[ge].tokens=this.lexer.inline(ue.header[ge].text);for(he=ue.rows.length,ge=0;ge<he;ge++)for(Re=ue.rows[ge],De=0;De<Re.length;De++)Re[De].tokens=this.lexer.inline(Re[De].text);return ue}}},we.lheading=function(K){var J=this.rules.block.lheading.exec(K);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:this.lexer.inline(J[1])}},we.paragraph=function(K){var J=this.rules.block.paragraph.exec(K);if(J){var ue=J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1];return{type:"paragraph",raw:J[0],text:ue,tokens:this.lexer.inline(ue)}}},we.text=function(K){var J=this.rules.block.text.exec(K);if(J)return{type:"text",raw:J[0],text:J[0],tokens:this.lexer.inline(J[0])}},we.escape=function(K){var J=this.rules.inline.escape.exec(K);if(J)return{type:"escape",raw:J[0],text:p(J[1])}},we.tag=function(K){var J=this.rules.inline.tag.exec(K);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):p(J[0]):J[0]}},we.link=function(K){var J=this.rules.inline.link.exec(K);if(J){var ue=J[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var he=h(ue.slice(0,-1),"\\");if((ue.length-he.length)%2===0)return}else{var Pe=_(J[2],"()");if(Pe>-1){var ge=J[0].indexOf("!")===0?5:4,De=ge+J[1].length+Pe;J[2]=J[2].substring(0,Pe),J[0]=J[0].substring(0,De).trim(),J[3]=""}}var Re=J[2],xe="";if(this.options.pedantic){var M=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);M&&(Re=M[1],xe=M[3])}else xe=J[3]?J[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(ue)?Re=Re.slice(1):Re=Re.slice(1,-1)),F(J,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},we.reflink=function(K,J){var ue;if((ue=this.rules.inline.reflink.exec(K))||(ue=this.rules.inline.nolink.exec(K))){var he=(ue[2]||ue[1]).replace(/\s+/g," ");if(he=J[he.toLowerCase()],!he||!he.href){var Pe=ue[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return F(ue,he,ue[0],this.lexer)}},we.emStrong=function(K,J,ue){ue===void 0&&(ue="");var he=this.rules.inline.emStrong.lDelim.exec(K);if(he&&!(he[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=he[1]||he[2]||"";if(!Pe||Pe&&(ue===""||this.rules.inline.punctuation.exec(ue))){var ge=he[0].length-1,De,Re,xe=ge,M=0,x=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(x.lastIndex=0,J=J.slice(-1*K.length+ge);(he=x.exec(J))!=null;)if(De=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!De){if(Re=De.length,he[3]||he[4]){xe+=Re;continue}else if((he[5]||he[6])&&ge%3&&!((ge+Re)%3)){M+=Re;continue}if(xe-=Re,!(xe>0)){if(Re=Math.min(Re,Re+xe+M),Math.min(ge,Re)%2){var q=K.slice(1,ge+he.index+Re);return{type:"em",raw:K.slice(0,ge+he.index+Re+1),text:q,tokens:this.lexer.inlineTokens(q)}}var W=K.slice(2,ge+he.index+Re-1);return{type:"strong",raw:K.slice(0,ge+he.index+Re+1),text:W,tokens:this.lexer.inlineTokens(W)}}}}}},we.codespan=function(K){var J=this.rules.inline.code.exec(K);if(J){var ue=J[2].replace(/\n/g," "),he=/[^ ]/.test(ue),Pe=/^ /.test(ue)&&/ $/.test(ue);return he&&Pe&&(ue=ue.substring(1,ue.length-1)),ue=p(ue,!0),{type:"codespan",raw:J[0],text:ue}}},we.br=function(K){var J=this.rules.inline.br.exec(K);if(J)return{type:"br",raw:J[0]}},we.del=function(K){var J=this.rules.inline.del.exec(K);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2])}},we.autolink=function(K,J){var ue=this.rules.inline.autolink.exec(K);if(ue){var he,Pe;return ue[2]==="@"?(he=p(this.options.mangle?J(ue[1]):ue[1]),Pe="mailto:"+he):(he=p(ue[1]),Pe=he),{type:"link",raw:ue[0],text:he,href:Pe,tokens:[{type:"text",raw:he,text:he}]}}},we.url=function(K,J){var ue;if(ue=this.rules.inline.url.exec(K)){var he,Pe;if(ue[2]==="@")he=p(this.options.mangle?J(ue[0]):ue[0]),Pe="mailto:"+he;else{var ge;do ge=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(ge!==ue[0]);he=p(ue[0]),ue[1]==="www."?Pe="http://"+he:Pe=he}return{type:"link",raw:ue[0],text:he,href:Pe,tokens:[{type:"text",raw:he,text:he}]}}},we.inlineText=function(K,J){var ue=this.rules.inline.text.exec(K);if(ue){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]:he=p(this.options.smartypants?J(ue[0]):ue[0]),{type:"text",raw:ue[0],text:he}}},ke}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=n(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=n(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=n(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=n(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=n(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=n(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=g({},B),B.gfm=g({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=n(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=n(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=g({},B.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:n(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var k={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};k._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",k.punctuation=n(k.punctuation).replace(/punctuation/g,k._punctuation).getRegex(),k.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,k.escapedEmSt=/\\\*|\\_/g,k._comment=n(B._comment).replace("(?:-->|$)","-->").getRegex(),k.emStrong.lDelim=n(k.emStrong.lDelim).replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimAst=n(k.emStrong.rDelimAst,"g").replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimUnd=n(k.emStrong.rDelimUnd,"g").replace(/punct/g,k._punctuation).getRegex(),k._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,k._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,k._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,k.autolink=n(k.autolink).replace("scheme",k._scheme).replace("email",k._email).getRegex(),k._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,k.tag=n(k.tag).replace("comment",k._comment).replace("attribute",k._attribute).getRegex(),k._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,k._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,k._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,k.link=n(k.link).replace("label",k._label).replace("href",k._href).replace("title",k._title).getRegex(),k.reflink=n(k.reflink).replace("label",k._label).replace("ref",B._label).getRegex(),k.nolink=n(k.nolink).replace("ref",B._label).getRegex(),k.reflinkSearch=n(k.reflinkSearch,"g").replace("reflink",k.reflink).replace("nolink",k.nolink).getRegex(),k.normal=g({},k),k.pedantic=g({},k.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",k._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",k._label).getRegex()}),k.gfm=g({},k.normal,{escape:n(k.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),k.gfm.url=n(k.gfm.url,"i").replace("email",k.gfm._extended_email).getRegex(),k.breaks=g({},k.gfm,{br:n(k.br).replace("{2,}","*").getRegex(),text:n(k.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(ke){var we="",me,K,J=ke.length;for(me=0;me<J;me++)K=ke.charCodeAt(me),Math.random()>.5&&(K="x"+K.toString(16)),we+="&#"+K+";";return we}var re=function(){function ke(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||fe.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:B.normal,inline:k.normal};this.options.pedantic?(K.block=B.pedantic,K.inline=k.pedantic):this.options.gfm&&(K.block=B.gfm,this.options.breaks?K.inline=k.breaks:K.inline=k.gfm),this.tokenizer.rules=K}ke.lex=function(K,J){var ue=new ke(J);return ue.lex(K)},ke.lexInline=function(K,J){var ue=new ke(J);return ue.inlineTokens(K)};var we=ke.prototype;return we.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},we.blockTokens=function(K,J){var ue=this;J===void 0&&(J=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(xe,M,x){return M+"    ".repeat(x.length)});for(var he,Pe,ge,De;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(xe){return(he=xe.call({lexer:ue},K,J))?(K=K.substring(he.raw.length),J.push(he),!0):!1}))){if(he=this.tokenizer.space(K)){K=K.substring(he.raw.length),he.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(he);continue}if(he=this.tokenizer.code(K)){K=K.substring(he.raw.length),Pe=J[J.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+he.raw,Pe.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):J.push(he);continue}if(he=this.tokenizer.fences(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.heading(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.hr(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.blockquote(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.list(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.html(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.def(K)){K=K.substring(he.raw.length),Pe=J[J.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+he.raw,Pe.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.lheading(K)){K=K.substring(he.raw.length),J.push(he);continue}if(ge=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var xe=1/0,M=K.slice(1),x=void 0;ue.options.extensions.startBlock.forEach(function(q){x=q.call({lexer:this},M),typeof x=="number"&&x>=0&&(xe=Math.min(xe,x))}),xe<1/0&&xe>=0&&(ge=K.substring(0,xe+1))}(),this.state.top&&(he=this.tokenizer.paragraph(ge))){Pe=J[J.length-1],De&&Pe.type==="paragraph"?(Pe.raw+=`
`+he.raw,Pe.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):J.push(he),De=ge.length!==K.length,K=K.substring(he.raw.length);continue}if(he=this.tokenizer.text(K)){K=K.substring(he.raw.length),Pe=J[J.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+he.raw,Pe.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):J.push(he);continue}if(K){var Re="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,J},we.inline=function(K,J){return J===void 0&&(J=[]),this.inlineQueue.push({src:K,tokens:J}),J},we.inlineTokens=function(K,J){var ue=this;J===void 0&&(J=[]);var he,Pe,ge,De=K,Re,xe,M;if(this.tokens.links){var x=Object.keys(this.tokens.links);if(x.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)x.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Re.index)+"["+A("a",Re[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Re.index)+"["+A("a",Re[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Re.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(xe||(M=""),xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(W){return(he=W.call({lexer:ue},K,J))?(K=K.substring(he.raw.length),J.push(he),!0):!1}))){if(he=this.tokenizer.escape(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.tag(K)){K=K.substring(he.raw.length),Pe=J[J.length-1],Pe&&he.type==="text"&&Pe.type==="text"?(Pe.raw+=he.raw,Pe.text+=he.text):J.push(he);continue}if(he=this.tokenizer.link(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(he.raw.length),Pe=J[J.length-1],Pe&&he.type==="text"&&Pe.type==="text"?(Pe.raw+=he.raw,Pe.text+=he.text):J.push(he);continue}if(he=this.tokenizer.emStrong(K,De,M)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.codespan(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.br(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.del(K)){K=K.substring(he.raw.length),J.push(he);continue}if(he=this.tokenizer.autolink(K,$)){K=K.substring(he.raw.length),J.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(K,$))){K=K.substring(he.raw.length),J.push(he);continue}if(ge=K,this.options.extensions&&this.options.extensions.startInline&&function(){var W=1/0,te=K.slice(1),oe=void 0;ue.options.extensions.startInline.forEach(function(Ne){oe=Ne.call({lexer:this},te),typeof oe=="number"&&oe>=0&&(W=Math.min(W,oe))}),W<1/0&&W>=0&&(ge=K.substring(0,W+1))}(),he=this.tokenizer.inlineText(ge,N)){K=K.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(M=he.raw.slice(-1)),xe=!0,Pe=J[J.length-1],Pe&&Pe.type==="text"?(Pe.raw+=he.raw,Pe.text+=he.text):J.push(he);continue}if(K){var q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return J},I(ke,null,[{key:"rules",get:function(){return{block:B,inline:k}}}]),ke}(),le=function(){function ke(me){this.options=me||fe.defaults}var we=ke.prototype;return we.code=function(K,J,ue){var he=(J||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(K,he);Pe!=null&&Pe!==K&&(ue=!0,K=Pe)}return K=K.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+p(he,!0)+'">'+(ue?K:p(K,!0))+`</code></pre>
`:"<pre><code>"+(ue?K:p(K,!0))+`</code></pre>
`},we.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},we.html=function(K){return K},we.heading=function(K,J,ue,he){if(this.options.headerIds){var Pe=this.options.headerPrefix+he.slug(ue);return"<h"+J+' id="'+Pe+'">'+K+"</h"+J+`>
`}return"<h"+J+">"+K+"</h"+J+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(K,J,ue){var he=J?"ol":"ul",Pe=J&&ue!==1?' start="'+ue+'"':"";return"<"+he+Pe+`>
`+K+"</"+he+`>
`},we.listitem=function(K){return"<li>"+K+`</li>
`},we.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(K){return"<p>"+K+`</p>
`},we.table=function(K,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+J+`</table>
`},we.tablerow=function(K){return`<tr>
`+K+`</tr>
`},we.tablecell=function(K,J){var ue=J.header?"th":"td",he=J.align?"<"+ue+' align="'+J.align+'">':"<"+ue+">";return he+K+("</"+ue+`>
`)},we.strong=function(K){return"<strong>"+K+"</strong>"},we.em=function(K){return"<em>"+K+"</em>"},we.codespan=function(K){return"<code>"+K+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(K){return"<del>"+K+"</del>"},we.link=function(K,J,ue){if(K=d(this.options.sanitize,this.options.baseUrl,K),K===null)return ue;var he='<a href="'+p(K)+'"';return J&&(he+=' title="'+J+'"'),he+=">"+ue+"</a>",he},we.image=function(K,J,ue){if(K=d(this.options.sanitize,this.options.baseUrl,K),K===null)return ue;var he='<img src="'+K+'" alt="'+ue+'"';return J&&(he+=' title="'+J+'"'),he+=this.options.xhtml?"/>":">",he},we.text=function(K){return K},ke}(),_e=function(){function ke(){}var we=ke.prototype;return we.strong=function(K){return K},we.em=function(K){return K},we.codespan=function(K){return K},we.del=function(K){return K},we.html=function(K){return K},we.text=function(K){return K},we.link=function(K,J,ue){return""+ue},we.image=function(K,J,ue){return""+ue},we.br=function(){return""},ke}(),ye=function(){function ke(){this.seen={}}var we=ke.prototype;return we.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(K,J){var ue=K,he=0;if(this.seen.hasOwnProperty(ue)){he=this.seen[K];do he++,ue=K+"-"+he;while(this.seen.hasOwnProperty(ue))}return J||(this.seen[K]=he,this.seen[ue]=0),ue},we.slug=function(K,J){J===void 0&&(J={});var ue=this.serialize(K);return this.getNextSafeSlug(ue,J.dryrun)},ke}(),de=function(){function ke(me){this.options=me||fe.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _e,this.slugger=new ye}ke.parse=function(K,J){var ue=new ke(J);return ue.parse(K)},ke.parseInline=function(K,J){var ue=new ke(J);return ue.parseInline(K)};var we=ke.prototype;return we.parse=function(K,J){J===void 0&&(J=!0);var ue="",he,Pe,ge,De,Re,xe,M,x,q,W,te,oe,Ne,$e,We,Je,tt,ut,rt,it=K.length;for(he=0;he<it;he++){if(W=K[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(rt=this.options.extensions.renderers[W.type].call({parser:this},W),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(W.type))){ue+=rt||"";continue}switch(W.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(W.tokens),W.depth,c(this.parseInline(W.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(W.text,W.lang,W.escaped);continue}case"table":{for(x="",M="",De=W.header.length,Pe=0;Pe<De;Pe++)M+=this.renderer.tablecell(this.parseInline(W.header[Pe].tokens),{header:!0,align:W.align[Pe]});for(x+=this.renderer.tablerow(M),q="",De=W.rows.length,Pe=0;Pe<De;Pe++){for(xe=W.rows[Pe],M="",Re=xe.length,ge=0;ge<Re;ge++)M+=this.renderer.tablecell(this.parseInline(xe[ge].tokens),{header:!1,align:W.align[ge]});q+=this.renderer.tablerow(M)}ue+=this.renderer.table(x,q);continue}case"blockquote":{q=this.parse(W.tokens),ue+=this.renderer.blockquote(q);continue}case"list":{for(te=W.ordered,oe=W.start,Ne=W.loose,De=W.items.length,q="",Pe=0;Pe<De;Pe++)We=W.items[Pe],Je=We.checked,tt=We.task,$e="",We.task&&(ut=this.renderer.checkbox(Je),Ne?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=ut+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=ut+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:ut}):$e+=ut),$e+=this.parse(We.tokens,Ne),q+=this.renderer.listitem($e,tt,Je);ue+=this.renderer.list(q,te,oe);continue}case"html":{ue+=this.renderer.html(W.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(W.tokens));continue}case"text":{for(q=W.tokens?this.parseInline(W.tokens):W.text;he+1<it&&K[he+1].type==="text";)W=K[++he],q+=`
`+(W.tokens?this.parseInline(W.tokens):W.text);ue+=J?this.renderer.paragraph(q):q;continue}default:{var ot='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return ue},we.parseInline=function(K,J){J=J||this.renderer;var ue="",he,Pe,ge,De=K.length;for(he=0;he<De;he++){if(Pe=K[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(ge=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){ue+=ge||"";continue}switch(Pe.type){case"escape":{ue+=J.text(Pe.text);break}case"html":{ue+=J.html(Pe.text);break}case"link":{ue+=J.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,J));break}case"image":{ue+=J.image(Pe.href,Pe.title,Pe.text);break}case"strong":{ue+=J.strong(this.parseInline(Pe.tokens,J));break}case"em":{ue+=J.em(this.parseInline(Pe.tokens,J));break}case"codespan":{ue+=J.codespan(Pe.text);break}case"br":{ue+=J.br();break}case"del":{ue+=J.del(this.parseInline(Pe.tokens,J));break}case"text":{ue+=J.text(Pe.text);break}default:{var Re='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return ue},ke}();function Ee(ke,we,me){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof we=="function"&&(me=we,we=null),we=g({},Ee.defaults,we||{}),b(we),me){var K=we.highlight,J;try{J=re.lex(ke,we)}catch(De){return me(De)}var ue=function(Re){var xe;if(!Re)try{we.walkTokens&&Ee.walkTokens(J,we.walkTokens),xe=de.parse(J,we)}catch(M){Re=M}return we.highlight=K,Re?me(Re):me(null,xe)};if(!K||K.length<3||(delete we.highlight,!J.length))return ue();var he=0;Ee.walkTokens(J,function(De){De.type==="code"&&(he++,setTimeout(function(){K(De.text,De.lang,function(Re,xe){if(Re)return ue(Re);xe!=null&&xe!==De.text&&(De.text=xe,De.escaped=!0),he--,he===0&&ue()})},0))}),he===0&&ue();return}function Pe(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+p(De.message+"",!0)+"</pre>";throw De}try{var ge=re.lex(ke,we);if(we.walkTokens){if(we.async)return Promise.all(Ee.walkTokens(ge,we.walkTokens)).then(function(){return de.parse(ge,we)}).catch(Pe);Ee.walkTokens(ge,we.walkTokens)}return de.parse(ge,we)}catch(De){Pe(De)}}Ee.options=Ee.setOptions=function(ke){return g(Ee.defaults,ke),m(Ee.defaults),Ee},Ee.getDefaults=T,Ee.defaults=fe.defaults,Ee.use=function(){for(var ke=arguments.length,we=new Array(ke),me=0;me<ke;me++)we[me]=arguments[me];var K=g.apply(void 0,[{}].concat(we)),J=Ee.defaults.extensions||{renderers:{},childTokens:{}},ue;we.forEach(function(he){if(he.extensions&&(ue=!0,he.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var De=J.renderers?J.renderers[ge.name]:null;De?J.renderers[ge.name]=function(){for(var Re=arguments.length,xe=new Array(Re),M=0;M<Re;M++)xe[M]=arguments[M];var x=ge.renderer.apply(this,xe);return x===!1&&(x=De.apply(this,xe)),x}:J.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[ge.level]?J[ge.level].unshift(ge.tokenizer):J[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?J.startBlock?J.startBlock.push(ge.start):J.startBlock=[ge.start]:ge.level==="inline"&&(J.startInline?J.startInline.push(ge.start):J.startInline=[ge.start]))}ge.childTokens&&(J.childTokens[ge.name]=ge.childTokens)})),he.renderer&&function(){var ge=Ee.defaults.renderer||new le,De=function(M){var x=ge[M];ge[M]=function(){for(var q=arguments.length,W=new Array(q),te=0;te<q;te++)W[te]=arguments[te];var oe=he.renderer[M].apply(ge,W);return oe===!1&&(oe=x.apply(ge,W)),oe}};for(var Re in he.renderer)De(Re);K.renderer=ge}(),he.tokenizer&&function(){var ge=Ee.defaults.tokenizer||new H,De=function(M){var x=ge[M];ge[M]=function(){for(var q=arguments.length,W=new Array(q),te=0;te<q;te++)W[te]=arguments[te];var oe=he.tokenizer[M].apply(ge,W);return oe===!1&&(oe=x.apply(ge,W)),oe}};for(var Re in he.tokenizer)De(Re);K.tokenizer=ge}(),he.walkTokens){var Pe=Ee.defaults.walkTokens;K.walkTokens=function(ge){var De=[];return De.push(he.walkTokens.call(this,ge)),Pe&&(De=De.concat(Pe.call(this,ge))),De}}ue&&(K.extensions=J),Ee.setOptions(K)})},Ee.walkTokens=function(ke,we){for(var me=[],K=function(){var Pe=ue.value;switch(me=me.concat(we.call(Ee,Pe)),Pe.type){case"table":{for(var ge=O(Pe.header),De;!(De=ge()).done;){var Re=De.value;me=me.concat(Ee.walkTokens(Re.tokens,we))}for(var xe=O(Pe.rows),M;!(M=xe()).done;)for(var x=M.value,q=O(x),W;!(W=q()).done;){var te=W.value;me=me.concat(Ee.walkTokens(te.tokens,we))}break}case"list":{me=me.concat(Ee.walkTokens(Pe.items,we));break}default:Ee.defaults.extensions&&Ee.defaults.extensions.childTokens&&Ee.defaults.extensions.childTokens[Pe.type]?Ee.defaults.extensions.childTokens[Pe.type].forEach(function(oe){me=me.concat(Ee.walkTokens(Pe[oe],we))}):Pe.tokens&&(me=me.concat(Ee.walkTokens(Pe.tokens,we)))}},J=O(ke),ue;!(ue=J()).done;)K();return me},Ee.parseInline=function(ke,we){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");we=g({},Ee.defaults,we||{}),b(we);try{var me=re.lexInline(ke,we);return we.walkTokens&&Ee.walkTokens(me,we.walkTokens),de.parseInline(me,we)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+p(K.message+"",!0)+"</pre>";throw K}},Ee.Parser=de,Ee.parser=de.parse,Ee.Renderer=le,Ee.TextRenderer=_e,Ee.Lexer=re,Ee.lexer=re.lex,Ee.Tokenizer=H,Ee.Slugger=ye,Ee.parse=Ee;var se=Ee.options,pe=Ee.setOptions,ee=Ee.use,X=Ee.walkTokens,V=Ee.parseInline,ne=Ee,Ie=de.parse,Fe=re.lex;fe.Lexer=re,fe.Parser=de,fe.Renderer=le,fe.Slugger=ye,fe.TextRenderer=_e,fe.Tokenizer=H,fe.getDefaults=T,fe.lexer=Fe,fe.marked=Ee,fe.options=se,fe.parse=ne,fe.parseInline=V,fe.parser=Ie,fe.setOptions=pe,fe.use=ee,fe.walkTokens=X,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Te[122],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function I(s){const c=O(s);if(c&&c.length>0)return new Uint32Array(c)}e.getKoreanAltChars=I;let L=0;const P=new Uint32Array(10);function O(s){if(L=0,T(s,C,4352),L>0||(T(s,u,4449),L>0)||(T(s,E,4520),L>0)||(T(s,p,12593),L))return P.subarray(0,L);if(s>=44032&&s<=55203){const c=s-44032,t=c%588,n=Math.floor(c/588),r=Math.floor(t/28),a=t%28-1;if(n<C.length?T(n,C,0):4352+n-12593<p.length&&T(4352+n,p,12593),r<u.length?T(r,u,0):4449+r-12593<p.length&&T(4449+r-12593,p,12593),a>=0&&(a<E.length?T(a,E,0):4520+a-12593<p.length&&T(4520+a-12593,p,12593)),L>0)return P.subarray(0,L)}}function T(s,c,t){s>=t&&s<t+c.length&&m(c[s-t])}function m(s){s!==0&&(P[L++]=s&255,s>>8&&(P[L++]=s>>8&255),s>>16&&(P[L++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var y;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(y||(y={}));var R;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Te[123],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(m,f,y){return Math.min(Math.max(m,f),y)}e.clamp=I;function L(m,f){return(f+m%f)%f}e.rot=L;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class O{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class T{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const y=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=y,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function fe(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function T(f){O.push(f,Date.now())}function m(){const f=[];for(let y=0;y<O.length;y+=2)f.push({name:O[y],startTime:O[y+1]});return f}return{mark:T,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(P+T.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function I(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:fe)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function I(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return fe[L].call(P.exports,P,P.exports,I),P.l=!0,P.exports}return I.m=fe,I.c=e,I.d=function(L,P,O){I.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:O})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,P){if(1&P&&(L=I(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var T in L)I.d(O,T,function(m){return L[m]}.bind(null,T));return O},I.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(P,"a",P),P},I.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},I.p="",I(I.s=0)}([function(fe,e,I){(function(L){var P;e=fe.exports=ee,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],y=0,R=y++;f[R]="0|[1-9]\\d*";var C=y++;f[C]="[0-9]+";var u=y++;f[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=y++;f[E]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var p=y++;f[p]="("+f[C]+")\\.("+f[C]+")\\.("+f[C]+")";var s=y++;f[s]="(?:"+f[R]+"|"+f[u]+")";var c=y++;f[c]="(?:"+f[C]+"|"+f[u]+")";var t=y++;f[t]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=y++;f[n]="(?:-?("+f[c]+"(?:\\."+f[c]+")*))";var r=y++;f[r]="[0-9A-Za-z-]+";var a=y++;f[a]="(?:\\+("+f[r]+"(?:\\."+f[r]+")*))";var d=y++,i="v?"+f[E]+f[t]+"?"+f[a]+"?";f[d]="^"+i+"$";var v="[v=\\s]*"+f[p]+f[n]+"?"+f[a]+"?",l=y++;f[l]="^"+v+"$";var o=y++;f[o]="((?:<|>)?=?)";var S=y++;f[S]=f[C]+"|x|X|\\*";var w=y++;f[w]=f[R]+"|x|X|\\*";var g=y++;f[g]="[v=\\s]*("+f[w]+")(?:\\.("+f[w]+")(?:\\.("+f[w]+")(?:"+f[t]+")?"+f[a]+"?)?)?";var D=y++;f[D]="[v=\\s]*("+f[S]+")(?:\\.("+f[S]+")(?:\\.("+f[S]+")(?:"+f[n]+")?"+f[a]+"?)?)?";var h=y++;f[h]="^"+f[o]+"\\s*"+f[g]+"$";var _=y++;f[_]="^"+f[o]+"\\s*"+f[D]+"$";var b=y++;f[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=y++;f[A]="(?:~>?)";var F=y++;f[F]="(\\s*)"+f[A]+"\\s+",m[F]=new RegExp(f[F],"g");var j=y++;f[j]="^"+f[A]+f[g]+"$";var H=y++;f[H]="^"+f[A]+f[D]+"$";var B=y++;f[B]="(?:\\^)";var k=y++;f[k]="(\\s*)"+f[B]+"\\s+",m[k]=new RegExp(f[k],"g");var N=y++;f[N]="^"+f[B]+f[g]+"$";var $=y++;f[$]="^"+f[B]+f[D]+"$";var re=y++;f[re]="^"+f[o]+"\\s*("+v+")$|^$";var le=y++;f[le]="^"+f[o]+"\\s*("+i+")$|^$";var _e=y++;f[_e]="(\\s*)"+f[o]+"\\s*("+v+"|"+f[g]+")",m[_e]=new RegExp(f[_e],"g");var ye=y++;f[ye]="^\\s*("+f[g]+")\\s+-\\s+("+f[g]+")\\s*$";var de=y++;f[de]="^\\s*("+f[D]+")\\s+-\\s+("+f[D]+")\\s*$";var Ee=y++;f[Ee]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)P(se,f[se]),m[se]||(m[se]=new RegExp(f[se]));function pe(x,q){if(x instanceof ee)return x;if(typeof x!="string"||x.length>O||!(q?m[l]:m[d]).test(x))return null;try{return new ee(x,q)}catch{return null}}function ee(x,q){if(x instanceof ee){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ee))return new ee(x,q);P("SemVer",x,q),this.loose=q;var W=x.trim().match(q?m[l]:m[d]);if(!W)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+W[1],this.minor=+W[2],this.patch=+W[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");W[4]?this.prerelease=W[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var oe=+te;if(oe>=0&&oe<T)return oe}return te}):this.prerelease=[],this.build=W[5]?W[5].split("."):[],this.format()}e.parse=pe,e.valid=function(x,q){var W=pe(x,q);return W?W.version:null},e.clean=function(x,q){var W=pe(x.trim().replace(/^[=v]+/,""),q);return W?W.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof ee||(x=new ee(x,this.loose)),this.compareMain(x)||this.comparePre(x)},ee.prototype.compareMain=function(x){return x instanceof ee||(x=new ee(x,this.loose)),V(this.major,x.major)||V(this.minor,x.minor)||V(this.patch,x.patch)},ee.prototype.comparePre=function(x){if(x instanceof ee||(x=new ee(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var W=this.prerelease[q],te=x.prerelease[q];if(P("prerelease compare",q,W,te),W===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(W===void 0)return-1;if(W!==te)return V(W,te)}while(++q)},ee.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var W=this.prerelease.length;--W>=0;)typeof this.prerelease[W]=="number"&&(this.prerelease[W]++,W=-2);W===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,q,W,te){typeof W=="string"&&(te=W,W=void 0);try{return new ee(x,W).inc(q,te).version}catch{return null}},e.diff=function(x,q){if(ke(x,q))return null;var W=pe(x),te=pe(q);if(W.prerelease.length||te.prerelease.length){for(var oe in W)if((oe==="major"||oe==="minor"||oe==="patch")&&W[oe]!==te[oe])return"pre"+oe;return"prerelease"}for(var oe in W)if((oe==="major"||oe==="minor"||oe==="patch")&&W[oe]!==te[oe])return oe},e.compareIdentifiers=V;var X=/^[0-9]+$/;function V(x,q){var W=X.test(x),te=X.test(q);return W&&te&&(x=+x,q=+q),W&&!te?-1:te&&!W?1:x<q?-1:x>q?1:0}function ne(x,q,W){return new ee(x,W).compare(new ee(q,W))}function Ie(x,q,W){return ne(x,q,W)>0}function Fe(x,q,W){return ne(x,q,W)<0}function ke(x,q,W){return ne(x,q,W)===0}function we(x,q,W){return ne(x,q,W)!==0}function me(x,q,W){return ne(x,q,W)>=0}function K(x,q,W){return ne(x,q,W)<=0}function J(x,q,W,te){var oe;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof W=="object"&&(W=W.version),oe=x===W;break;case"!==":typeof x=="object"&&(x=x.version),typeof W=="object"&&(W=W.version),oe=x!==W;break;case"":case"=":case"==":oe=ke(x,W,te);break;case"!=":oe=we(x,W,te);break;case">":oe=Ie(x,W,te);break;case">=":oe=me(x,W,te);break;case"<":oe=Fe(x,W,te);break;case"<=":oe=K(x,W,te);break;default:throw new TypeError("Invalid operator: "+q)}return oe}function ue(x,q){if(x instanceof ue){if(x.loose===q)return x;x=x.value}if(!(this instanceof ue))return new ue(x,q);P("comparator",x,q),this.loose=q,this.parse(x),this.semver===he?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(x,q){return V(q,x)},e.major=function(x,q){return new ee(x,q).major},e.minor=function(x,q){return new ee(x,q).minor},e.patch=function(x,q){return new ee(x,q).patch},e.compare=ne,e.compareLoose=function(x,q){return ne(x,q,!0)},e.rcompare=function(x,q,W){return ne(q,x,W)},e.sort=function(x,q){return x.sort(function(W,te){return e.compare(W,te,q)})},e.rsort=function(x,q){return x.sort(function(W,te){return e.rcompare(W,te,q)})},e.gt=Ie,e.lt=Fe,e.eq=ke,e.neq=we,e.gte=me,e.lte=K,e.cmp=J,e.Comparator=ue;var he={};function Pe(x,q){if(x instanceof Pe)return x.loose===q?x:new Pe(x.raw,q);if(x instanceof ue)return new Pe(x.value,q);if(!(this instanceof Pe))return new Pe(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(W){return this.parseRange(W.trim())},this).filter(function(W){return W.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ge(x){return!x||x.toLowerCase()==="x"||x==="*"}function De(x,q,W,te,oe,Ne,$e,We,Je,tt,ut,rt,it){return((q=ge(W)?"":ge(te)?">="+W+".0.0":ge(oe)?">="+W+"."+te+".0":">="+q)+" "+(We=ge(Je)?"":ge(tt)?"<"+(+Je+1)+".0.0":ge(ut)?"<"+Je+"."+(+tt+1)+".0":rt?"<="+Je+"."+tt+"."+ut+"-"+rt:"<="+We)).trim()}function Re(x,q){for(var W=0;W<x.length;W++)if(!x[W].test(q))return!1;if(q.prerelease.length){for(W=0;W<x.length;W++)if(P(x[W].semver),x[W].semver!==he&&x[W].semver.prerelease.length>0){var te=x[W].semver;if(te.major===q.major&&te.minor===q.minor&&te.patch===q.patch)return!0}return!1}return!0}function xe(x,q,W){try{q=new Pe(q,W)}catch{return!1}return q.test(x)}function M(x,q,W,te){var oe,Ne,$e,We,Je;switch(x=new ee(x,te),q=new Pe(q,te),W){case">":oe=Ie,Ne=K,$e=Fe,We=">",Je=">=";break;case"<":oe=Fe,Ne=me,$e=Ie,We="<",Je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(x,q,te))return!1;for(var tt=0;tt<q.set.length;++tt){var ut=q.set[tt],rt=null,it=null;if(ut.forEach(function(ot){ot.semver===he&&(ot=new ue(">=0.0.0")),rt=rt||ot,it=it||ot,oe(ot.semver,rt.semver,te)?rt=ot:$e(ot.semver,it.semver,te)&&(it=ot)}),rt.operator===We||rt.operator===Je||(!it.operator||it.operator===We)&&Ne(x,it.semver)||it.operator===Je&&$e(x,it.semver))return!1}return!0}ue.prototype.parse=function(x){var q=this.loose?m[re]:m[le],W=x.match(q);if(!W)throw new TypeError("Invalid comparator: "+x);this.operator=W[1],this.operator==="="&&(this.operator=""),W[2]?this.semver=new ee(W[2],this.loose):this.semver=he},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===he||(typeof x=="string"&&(x=new ee(x,this.loose)),J(x,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(x,q){if(!(x instanceof ue))throw new TypeError("a Comparator is required");var W;if(this.operator==="")return W=new Pe(x.value,q),xe(this.value,W,q);if(x.operator==="")return W=new Pe(this.value,q),xe(x.semver,W,q);var te=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Ne=this.semver.version===x.semver.version,$e=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),We=J(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Je=J(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return te||oe||Ne&&$e||We||Je},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),P("range",x,q);var W=q?m[de]:m[ye];x=x.replace(W,De),P("hyphen replace",x),x=x.replace(m[_e],"$1$2$3"),P("comparator trim",x,m[_e]),x=(x=(x=x.replace(m[F],"$1~")).replace(m[k],"$1^")).split(/\s+/).join(" ");var te=q?m[re]:m[le],oe=x.split(" ").map(function(Ne){return function($e,We){return P("comp",$e),$e=function(Je,tt){return Je.trim().split(/\s+/).map(function(ut){return function(rt,it){P("caret",rt,it);var ot=it?m[$]:m[N];return rt.replace(ot,function(ze,et,Y,Q,ve){var He;return P("caret",rt,ze,et,Y,Q,ve),ge(et)?He="":ge(Y)?He=">="+et+".0.0 <"+(+et+1)+".0.0":ge(Q)?He=et==="0"?">="+et+"."+Y+".0 <"+et+"."+(+Y+1)+".0":">="+et+"."+Y+".0 <"+(+et+1)+".0.0":ve?(P("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),He=et==="0"?Y==="0"?">="+et+"."+Y+"."+Q+ve+" <"+et+"."+Y+"."+(+Q+1):">="+et+"."+Y+"."+Q+ve+" <"+et+"."+(+Y+1)+".0":">="+et+"."+Y+"."+Q+ve+" <"+(+et+1)+".0.0"):(P("no pr"),He=et==="0"?Y==="0"?">="+et+"."+Y+"."+Q+" <"+et+"."+Y+"."+(+Q+1):">="+et+"."+Y+"."+Q+" <"+et+"."+(+Y+1)+".0":">="+et+"."+Y+"."+Q+" <"+(+et+1)+".0.0"),P("caret return",He),He})}(ut,tt)}).join(" ")}($e,We),P("caret",$e),$e=function(Je,tt){return Je.trim().split(/\s+/).map(function(ut){return function(rt,it){var ot=it?m[H]:m[j];return rt.replace(ot,function(ze,et,Y,Q,ve){var He;return P("tilde",rt,ze,et,Y,Q,ve),ge(et)?He="":ge(Y)?He=">="+et+".0.0 <"+(+et+1)+".0.0":ge(Q)?He=">="+et+"."+Y+".0 <"+et+"."+(+Y+1)+".0":ve?(P("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),He=">="+et+"."+Y+"."+Q+ve+" <"+et+"."+(+Y+1)+".0"):He=">="+et+"."+Y+"."+Q+" <"+et+"."+(+Y+1)+".0",P("tilde return",He),He})}(ut,tt)}).join(" ")}($e,We),P("tildes",$e),$e=function(Je,tt){return P("replaceXRanges",Je,tt),Je.split(/\s+/).map(function(ut){return function(rt,it){rt=rt.trim();var ot=it?m[_]:m[h];return rt.replace(ot,function(ze,et,Y,Q,ve,He){P("xRange",rt,ze,et,Y,Q,ve,He);var Qe=ge(Y),st=Qe||ge(Q),Oe=st||ge(ve);return et==="="&&Oe&&(et=""),Qe?ze=et===">"||et==="<"?"<0.0.0":"*":et&&Oe?(st&&(Q=0),Oe&&(ve=0),et===">"?(et=">=",st?(Y=+Y+1,Q=0,ve=0):Oe&&(Q=+Q+1,ve=0)):et==="<="&&(et="<",st?Y=+Y+1:Q=+Q+1),ze=et+Y+"."+Q+"."+ve):st?ze=">="+Y+".0.0 <"+(+Y+1)+".0.0":Oe&&(ze=">="+Y+"."+Q+".0 <"+Y+"."+(+Q+1)+".0"),P("xRange return",ze),ze})}(ut,tt)}).join(" ")}($e,We),P("xrange",$e),$e=function(Je,tt){return P("replaceStars",Je,tt),Je.trim().replace(m[Ee],"")}($e,We),P("stars",$e),$e}(Ne,q)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Ne){return!!Ne.match(te)})),oe=oe.map(function(Ne){return new ue(Ne,q)})},Pe.prototype.intersects=function(x,q){if(!(x instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(W){return W.every(function(te){return x.set.some(function(oe){return oe.every(function(Ne){return te.intersects(Ne,q)})})})})},e.toComparators=function(x,q){return new Pe(x,q).set.map(function(W){return W.map(function(te){return te.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new ee(x,this.loose));for(var q=0;q<this.set.length;q++)if(Re(this.set[q],x))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(x,q,W){var te=null,oe=null;try{var Ne=new Pe(q,W)}catch{return null}return x.forEach(function($e){Ne.test($e)&&(te&&oe.compare($e)!==-1||(oe=new ee(te=$e,W)))}),te},e.minSatisfying=function(x,q,W){var te=null,oe=null;try{var Ne=new Pe(q,W)}catch{return null}return x.forEach(function($e){Ne.test($e)&&(te&&oe.compare($e)!==1||(oe=new ee(te=$e,W)))}),te},e.validRange=function(x,q){try{return new Pe(x,q).range||"*"}catch{return null}},e.ltr=function(x,q,W){return M(x,q,"<",W)},e.gtr=function(x,q,W){return M(x,q,">",W)},e.outside=M,e.prerelease=function(x,q){var W=pe(x,q);return W&&W.prerelease.length?W.prerelease:null},e.intersects=function(x,q,W){return x=new Pe(x,W),q=new Pe(q,W),x.intersects(q)},e.coerce=function(x){if(x instanceof ee)return x;if(typeof x!="string")return null;var q=x.match(m[b]);return q==null?null:pe((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,I(1))},function(fe,e){var I,L,P=fe.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function m(c){if(I===setTimeout)return setTimeout(c,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch{L=T}})();var f,y=[],R=!1,C=-1;function u(){R&&f&&(R=!1,f.length?y=f.concat(y):C=-1,y.length&&E())}function E(){if(!R){var c=m(u);R=!0;for(var t=y.length;t;){for(f=y,y=[];++C<t;)f&&f[C].run();C=-1,t=y.length}f=null,R=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(c)}}function p(c,t){this.fun=c,this.array=t}function s(){}P.nextTick=function(c){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];y.push(new p(c,t)),y.length!==1||R||m(E)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Te[124],Ae([1,0,15,6]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(a){const d=a;return d?typeof d.read=="function":!1}e.isReadable=P;function O(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=O;function T(a){const d=a;return d?O(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function m(a,d){return new f(a,d)}e.newWriteableStream=m;class f{constructor(d,i){this.reducer=d,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(i=>i(d))}emitError(d){this.listeners.error.length===0?(0,I.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(i=>i(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,i){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(d,i){if(this.state.destroyed)return;let v;switch(d){case"data":v=this.listeners.data;break;case"end":v=this.listeners.end;break;case"error":v=this.listeners.error;break}if(v){const l=v.indexOf(i);l>=0&&v.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(v=>v())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,d){const i=[];let v;for(;(v=a.read())!==null;)i.push(v);return d(i)}e.consumeReadable=y;function R(a,d,i){const v=[];let l;for(;(l=a.read())!==null&&v.length<i;)v.push(l);return l===null&&v.length>0?d(v):{read:()=>{if(v.length>0)return v.shift();if(typeof l<"u"){const o=l;return l=void 0,o}return a.read()}}}e.peekReadable=R;function C(a,d){return new Promise((i,v)=>{const l=[];u(a,{onData:o=>{d&&l.push(o)},onError:o=>{d?v(o):i(void 0)},onEnd:()=>{i(d?d(l):void 0)}})})}e.consumeStream=C;function u(a,d,i){a.on("error",v=>{i?.isCancellationRequested||d.onError(v)}),a.on("end",()=>{i?.isCancellationRequested||d.onEnd()}),a.on("data",v=>{i?.isCancellationRequested||d.onData(v)})}e.listenStream=u;function E(a,d){return new Promise((i,v)=>{const l=new L.DisposableStore,o=[],S=D=>{if(o.push(D),o.length>d)return l.dispose(),a.pause(),i({stream:a,buffer:o,ended:!1})},w=D=>(l.dispose(),v(D)),g=()=>(l.dispose(),i({stream:a,buffer:o,ended:!0}));l.add((0,L.toDisposable)(()=>a.removeListener("error",w))),a.on("error",w),l.add((0,L.toDisposable)(()=>a.removeListener("end",g))),a.on("end",g),l.add((0,L.toDisposable)(()=>a.removeListener("data",S))),a.on("data",S)})}e.peekStream=E;function p(a,d){const i=m(d);return i.end(a),i}e.toStream=p;function s(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=s;function c(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}e.toReadable=c;function t(a,d,i){const v=m(i);return u(a,{onData:l=>v.write(d.data(l)),onError:l=>v.error(d.error?d.error(l):l),onEnd:()=>v.end()}),v}e.transform=t;function n(a,d,i){let v=!1;return{read:()=>{const l=d.read();return v?l:(v=!0,l!==null?i([a,l]):a)}}}e.prefixedReadable=n;function r(a,d,i){let v=!1;const l=m(i);return u(d,{onData:o=>v?l.write(o):(v=!0,l.write(i([a,o]))),onError:o=>l.error(o),onEnd:()=>{v||(v=!0,l.write(a)),l.end()}}),l}e.prefixedStream=r}),define(Te[24],Ae([1,0,40,124]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const P=typeof Buffer<"u",O=new I.Lazy(()=>new Uint8Array(256));let T,m;class f{static alloc(b){return P?new f(Buffer.allocUnsafe(b)):new f(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new f(b)}static fromString(b,A){return!(A?.dontUseNodeBuffer||!1)&&P?new f(Buffer.from(b)):(T||(T=new TextEncoder),new f(T.encode(b)))}static fromByteArray(b){const A=f.alloc(b.length);for(let F=0,j=b.length;F<j;F++)A.buffer[F]=b[F];return A}static concat(b,A){if(typeof A>"u"){A=0;for(let H=0,B=b.length;H<B;H++)A+=b[H].byteLength}const F=f.alloc(A);let j=0;for(let H=0,B=b.length;H<B;H++){const k=b[H];F.set(k,j),j+=k.byteLength}return F}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=f.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(b,A){return new f(this.buffer.subarray(b,A))}set(b,A){if(b instanceof f)this.buffer.set(b.buffer,A);else if(b instanceof Uint8Array)this.buffer.set(b,A);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),A);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,A){E(this.buffer,b,A)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,A){s(this.buffer,b,A)}readUInt8(b){return c(this.buffer,b)}writeUInt8(b,A){t(this.buffer,b,A)}indexOf(b,A=0){return y(this.buffer,b instanceof f?b.buffer:b,A)}}e.VSBuffer=f;function y(_,b,A=0){const F=b.byteLength,j=_.byteLength;if(F===0)return 0;if(F===1)return _.indexOf(b[0]);if(F>j-A)return-1;const H=O.value;H.fill(b.length);for(let $=0;$<b.length;$++)H[b[$]]=b.length-$-1;let B=A+b.length-1,k=B,N=-1;for(;B<j;)if(_[B]===b[k]){if(k===0){N=B;break}B--,k--}else B+=Math.max(b.length-k,H[_[B]]),k=b.length-1;return N}e.binaryIndexOf=y;function R(_,b){return _[b+0]<<0>>>0|_[b+1]<<8>>>0}e.readUInt16LE=R;function C(_,b,A){_[A+0]=b&255,b=b>>>8,_[A+1]=b&255}e.writeUInt16LE=C;function u(_,b){return _[b]*2**24+_[b+1]*2**16+_[b+2]*2**8+_[b+3]}e.readUInt32BE=u;function E(_,b,A){_[A+3]=b,b=b>>>8,_[A+2]=b,b=b>>>8,_[A+1]=b,b=b>>>8,_[A]=b}e.writeUInt32BE=E;function p(_,b){return _[b+0]<<0>>>0|_[b+1]<<8>>>0|_[b+2]<<16>>>0|_[b+3]<<24>>>0}e.readUInt32LE=p;function s(_,b,A){_[A+0]=b&255,b=b>>>8,_[A+1]=b&255,b=b>>>8,_[A+2]=b&255,b=b>>>8,_[A+3]=b&255}e.writeUInt32LE=s;function c(_,b){return _[b]}e.readUInt8=c;function t(_,b,A){_[A]=b}e.writeUInt8=t;function n(_){return L.consumeReadable(_,b=>f.concat(b))}e.readableToBuffer=n;function r(_){return L.toReadable(_)}e.bufferToReadable=r;function a(_){return L.consumeStream(_,b=>f.concat(b))}e.streamToBuffer=a;async function d(_){return _.ended?f.concat(_.buffer):f.concat([..._.buffer,await a(_.stream)])}e.bufferedStreamToBuffer=d;function i(_){return L.toStream(_,b=>f.concat(b))}e.bufferToStream=i;function v(_){return L.transform(_,{data:b=>typeof b=="string"?f.fromString(b):f.wrap(b)},b=>f.concat(b))}e.streamToBufferReadableStream=v;function l(_){return L.newWriteableStream(b=>f.concat(b),_)}e.newWriteableBufferStream=l;function o(_,b){return L.prefixedReadable(_,b,A=>f.concat(A))}e.prefixedBufferReadable=o;function S(_,b){return L.prefixedStream(_,b,A=>f.concat(A))}e.prefixedBufferStream=S;function w(_){let b=0,A=0,F=0;const j=new Uint8Array(Math.floor(_.length/4*3)),H=k=>{switch(A){case 3:j[F++]=b|k,A=0;break;case 2:j[F++]=b|k>>>2,b=k<<6,A=3;break;case 1:j[F++]=b|k>>>4,b=k<<4,A=2;break;default:b=k<<2,A=1}};for(let k=0;k<_.length;k++){const N=_.charCodeAt(k);if(N>=65&&N<=90)H(N-65);else if(N>=97&&N<=122)H(N-97+26);else if(N>=48&&N<=57)H(N-48+52);else if(N===43||N===45)H(62);else if(N===47||N===95)H(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${_[k]}`)}}const B=F;for(;A>0;)H(0);return f.wrap(j).slice(0,B)}e.decodeBase64=w;const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:_},b=!0,A=!1){const F=A?D:g;let j="";const H=_.byteLength%3;let B=0;for(;B<_.byteLength-H;B+=3){const k=_[B+0],N=_[B+1],$=_[B+2];j+=F[k>>>2],j+=F[(k<<4|N>>>4)&63],j+=F[(N<<2|$>>>6)&63],j+=F[$&63]}if(H===1){const k=_[B+0];j+=F[k>>>2],j+=F[k<<4&63],b&&(j+="==")}else if(H===2){const k=_[B+0],N=_[B+1];j+=F[k>>>2],j+=F[(k<<4|N>>>4)&63],j+=F[N<<2&63],b&&(j+="=")}return j}e.encodeBase64=h}),define(Te[125],Ae([1,0,28,122,13]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function O(...ge){return function(De,Re){for(let xe=0,M=ge.length;xe<M;xe++){const x=ge[xe](De,Re);if(x)return x}return null}}e.or=O,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,De,Re){if(!Re||Re.length<De.length)return null;let xe;return ge?xe=P.startsWithIgnoreCase(Re,De):xe=Re.indexOf(De)===0,xe?De.length>0?[{start:0,end:De.length}]:[]:null}function m(ge,De){const Re=De.toLowerCase().indexOf(ge.toLowerCase());return Re===-1?null:[{start:Re,end:Re+ge.length}]}e.matchesContiguousSubString=m;function f(ge,De){return y(ge.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=f;function y(ge,De,Re,xe){if(Re===ge.length)return[];if(xe===De.length)return null;if(ge[Re]===De[xe]){let M=null;return(M=y(ge,De,Re+1,xe+1))?a({start:xe,end:xe+1},M):null}return y(ge,De,Re,xe+1)}function R(ge){return 97<=ge&&ge<=122}function C(ge){return 65<=ge&&ge<=90}e.isUpper=C;function u(ge){return 48<=ge&&ge<=57}function E(ge){return ge===32||ge===9||ge===10||ge===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>p.add(ge.charCodeAt(0)));function s(ge){return E(ge)||p.has(ge)}function c(ge,De){return ge===De||s(ge)&&s(De)}const t=new Map;function n(ge){if(t.has(ge))return t.get(ge);let De;const Re=(0,L.getKoreanAltChars)(ge);return Re&&(De=Re),t.set(ge,De),De}function r(ge){return R(ge)||C(ge)||u(ge)}function a(ge,De){return De.length===0?De=[ge]:ge.end===De[0].start?De[0].start=ge.start:De.unshift(ge),De}function d(ge,De){for(let Re=De;Re<ge.length;Re++){const xe=ge.charCodeAt(Re);if(C(xe)||u(xe)||Re>0&&!r(ge.charCodeAt(Re-1)))return Re}return ge.length}function i(ge,De,Re,xe){if(Re===ge.length)return[];if(xe===De.length)return null;if(ge[Re]!==De[xe].toLowerCase())return null;{let M=null,x=xe+1;for(M=i(ge,De,Re+1,xe+1);!M&&(x=d(De,x))<De.length;)M=i(ge,De,Re+1,x),x++;return M===null?null:a({start:xe,end:xe+1},M)}}function v(ge){let De=0,Re=0,xe=0,M=0,x=0;for(let Ne=0;Ne<ge.length;Ne++)x=ge.charCodeAt(Ne),C(x)&&De++,R(x)&&Re++,r(x)&&xe++,u(x)&&M++;const q=De/ge.length,W=Re/ge.length,te=xe/ge.length,oe=M/ge.length;return{upperPercent:q,lowerPercent:W,alphaPercent:te,numericPercent:oe}}function l(ge){const{upperPercent:De,lowerPercent:Re}=ge;return Re===0&&De>.6}function o(ge){const{upperPercent:De,lowerPercent:Re,alphaPercent:xe,numericPercent:M}=ge;return Re>.2&&De<.8&&xe>.6&&M<.2}function S(ge){let De=0,Re=0,xe=0,M=0;for(let x=0;x<ge.length;x++)xe=ge.charCodeAt(x),C(xe)&&De++,R(xe)&&Re++,E(xe)&&M++;return(De===0||Re===0)&&M===0?ge.length<=30:De<=5}function w(ge,De){if(!De||(De=De.trim(),De.length===0)||!S(ge))return null;De.length>60&&(De=De.substring(0,60));const Re=v(De);if(!o(Re)){if(!l(Re))return null;De=De.toLowerCase()}let xe=null,M=0;for(ge=ge.toLowerCase();M<De.length&&(xe=i(ge,De,0,M))===null;)M=d(De,M+1);return xe}e.matchesCamelCase=w;function g(ge,De,Re=!1){if(!De||De.length===0)return null;let xe=null,M=0;for(ge=ge.toLowerCase(),De=De.toLowerCase();M<De.length&&(xe=D(ge,De,0,M,Re),xe===null);)M=h(De,M+1);return xe}e.matchesWords=g;function D(ge,De,Re,xe,M){let x=0;if(Re===ge.length)return[];if(xe===De.length)return null;if(!c(ge.charCodeAt(Re),De.charCodeAt(xe))){const te=n(ge.charCodeAt(Re));if(!te)return null;for(let oe=0;oe<te.length;oe++)if(!c(te[oe],De.charCodeAt(xe+oe)))return null;x+=te.length-1}let q=null,W=xe+x+1;if(q=D(ge,De,Re+1,W,M),!M)for(;!q&&(W=h(De,W))<De.length;)q=D(ge,De,Re+1,W,M),W++;if(!q)return null;if(ge.charCodeAt(Re)!==De.charCodeAt(xe)){const te=n(ge.charCodeAt(Re));if(!te)return q;for(let oe=0;oe<te.length;oe++)if(te[oe]!==De.charCodeAt(xe+oe))return q}return a({start:xe,end:xe+x+1},q)}function h(ge,De){for(let Re=De;Re<ge.length;Re++)if(s(ge.charCodeAt(Re))||Re>0&&s(ge.charCodeAt(Re-1)))return Re;return ge.length}const _=O(e.matchesPrefix,w,m),b=O(e.matchesPrefix,w,f),A=new I.LRUCache(1e4);function F(ge,De,Re=!1){if(typeof ge!="string"||typeof De!="string")return null;let xe=A.get(ge);xe||(xe=new RegExp(P.convertSimple2RegExpPattern(ge),"i"),A.set(ge,xe));const M=xe.exec(De);return M?[{start:M.index,end:M.index+M[0].length}]:Re?b(ge,De):_(ge,De)}e.matchesFuzzy=F;function j(ge,De){const Re=we(ge,ge.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?B(Re):null}e.matchesFuzzy2=j;function H(ge,De,Re,xe,M,x){const q=Math.min(13,ge.length);for(;Re<q;Re++){const W=we(ge,De,Re,xe,M,x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(W)return W}return[0,x]}e.anyScore=H;function B(ge){if(typeof ge>"u")return[];const De=[],Re=ge[1];for(let xe=ge.length-1;xe>1;xe--){const M=ge[xe]+Re,x=De[De.length-1];x&&x.end===M?x.end=M+1:De.push({start:M,end:M+1})}return De}e.createMatches=B;const k=128;function N(){const ge=[],De=[];for(let Re=0;Re<=k;Re++)De[Re]=0;for(let Re=0;Re<=k;Re++)ge.push(De.slice(0));return ge}function $(ge){const De=[];for(let Re=0;Re<=ge;Re++)De[Re]=0;return De}const re=$(2*k),le=$(2*k),_e=N(),ye=N(),de=N(),Ee=!1;function se(ge,De,Re,xe,M){function x(W,te,oe=" "){for(;W.length<te;)W=oe+W;return W}let q=` |   |${xe.split("").map(W=>x(W,3)).join("|")}
`;for(let W=0;W<=Re;W++)W===0?q+=" |":q+=`${De[W-1]}|`,q+=ge[W].slice(0,M+1).map(te=>x(te.toString(),3)).join("|")+`
`;return q}function pe(ge,De,Re,xe){ge=ge.substr(De),Re=Re.substr(xe),console.log(se(ye,ge,ge.length,Re,Re.length)),console.log(se(de,ge,ge.length,Re,Re.length)),console.log(se(_e,ge,ge.length,Re,Re.length))}function ee(ge,De){if(De<0||De>=ge.length)return!1;const Re=ge.codePointAt(De);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(Re)}}function X(ge,De){if(De<0||De>=ge.length)return!1;switch(ge.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function V(ge,De,Re){return De[ge]!==Re[ge]}function ne(ge,De,Re,xe,M,x,q=!1){for(;De<Re&&M<x;)ge[De]===xe[M]&&(q&&(re[De]=M),De+=1),M+=1;return De===Re}e.isPatternInWord=ne;var Ie;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Fe;(function(ge){ge.Default=[-100,0];function De(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}ge.isDefault=De})(Fe||(e.FuzzyScore=Fe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Re){this.firstMatchCanBeWeak=De,this.boostFullMatch=Re}}e.FuzzyScoreOptions=ke;function we(ge,De,Re,xe,M,x,q=ke.default){const W=ge.length>k?k:ge.length,te=xe.length>k?k:xe.length;if(Re>=W||x>=te||W-Re>te-x||!ne(De,Re,W,M,x,te,!0))return;me(W,te,Re,x,De,M);let oe=1,Ne=1,$e=Re,We=x;const Je=[!1];for(oe=1,$e=Re;$e<W;oe++,$e++){const ot=re[$e],ze=le[$e],et=$e+1<W?le[$e+1]:te;for(Ne=ot-x+1,We=ot;We<et;Ne++,We++){let Y=Number.MIN_SAFE_INTEGER,Q=!1;We<=ze&&(Y=K(ge,De,$e,Re,xe,M,We,te,x,_e[oe-1][Ne-1]===0,Je));let ve=0;Y!==Number.MAX_SAFE_INTEGER&&(Q=!0,ve=Y+ye[oe-1][Ne-1]);const He=We>ot,Qe=He?ye[oe][Ne-1]+(_e[oe][Ne-1]>0?-5:0):0,st=We>ot+1&&_e[oe][Ne-1]>0,Oe=st?ye[oe][Ne-2]+(_e[oe][Ne-2]>0?-5:0):0;if(st&&(!He||Oe>=Qe)&&(!Q||Oe>=ve))ye[oe][Ne]=Oe,de[oe][Ne]=3,_e[oe][Ne]=0;else if(He&&(!Q||Qe>=ve))ye[oe][Ne]=Qe,de[oe][Ne]=2,_e[oe][Ne]=0;else if(Q)ye[oe][Ne]=ve,de[oe][Ne]=1,_e[oe][Ne]=_e[oe-1][Ne-1]+1;else throw new Error("not possible")}}if(Ee&&pe(ge,Re,xe,x),!Je[0]&&!q.firstMatchCanBeWeak)return;oe--,Ne--;const tt=[ye[oe][Ne],x];let ut=0,rt=0;for(;oe>=1;){let ot=Ne;do{const ze=de[oe][ot];if(ze===3)ot=ot-2;else if(ze===2)ot=ot-1;else break}while(ot>=1);ut>1&&De[Re+oe-1]===M[x+Ne-1]&&!V(ot+x-1,xe,M)&&ut+1>_e[oe][ot]&&(ot=Ne),ot===Ne?ut++:ut=1,rt||(rt=ot),oe--,Ne=ot-1,tt.push(Ne)}te===W&&q.boostFullMatch&&(tt[0]+=2);const it=rt-W;return tt[0]-=it,tt}e.fuzzyScore=we;function me(ge,De,Re,xe,M,x){let q=ge-1,W=De-1;for(;q>=Re&&W>=xe;)M[q]===x[W]&&(le[q]=W,q--),W--}function K(ge,De,Re,xe,M,x,q,W,te,oe,Ne){if(De[Re]!==x[q])return Number.MIN_SAFE_INTEGER;let $e=1,We=!1;return q===Re-xe?$e=ge[Re]===M[q]?7:5:V(q,M,x)&&(q===0||!V(q-1,M,x))?($e=ge[Re]===M[q]?7:5,We=!0):ee(x,q)&&(q===0||!ee(x,q-1))?$e=5:(ee(x,q-1)||X(x,q-1))&&($e=5,We=!0),$e>1&&Re===xe&&(Ne[0]=!0),We||(We=V(q,M,x)||ee(x,q-1)||X(x,q-1)),Re===xe?q>te&&($e-=We?3:5):oe?$e+=We?2:0:$e+=We?0:1,q+1===W&&($e-=We?3:5),$e}function J(ge,De,Re,xe,M,x,q){return he(ge,De,Re,xe,M,x,!0,q)}e.fuzzyScoreGracefulAggressive=J;function ue(ge,De,Re,xe,M,x,q){return he(ge,De,Re,xe,M,x,!1,q)}e.fuzzyScoreGraceful=ue;function he(ge,De,Re,xe,M,x,q,W){let te=we(ge,De,Re,xe,M,x,W);if(te&&!q)return te;if(ge.length>=3){const oe=Math.min(7,ge.length-1);for(let Ne=Re+1;Ne<oe;Ne++){const $e=Pe(ge,Ne);if($e){const We=we($e,$e.toLowerCase(),Re,xe,M,x,W);We&&(We[0]-=3,(!te||We[0]>te[0])&&(te=We))}}}return te}function Pe(ge,De){if(De+1>=ge.length)return;const Re=ge[De],xe=ge[De+1];if(Re!==xe)return ge.slice(0,De)+xe+Re+ge.slice(De+2)}}),define(Te[32],Ae([1,0,13]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const O="error",T="warning",m="warn",f="info",y="ignore";function R(u){return u?I.equalsIgnoreCase(O,u)?P.Error:I.equalsIgnoreCase(T,u)||I.equalsIgnoreCase(m,u)?P.Warning:I.equalsIgnoreCase(f,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function C(u){switch(u){case P.Error:return O;case P.Warning:return T;case P.Info:return f;default:return y}}P.toString=C}(L||(L={})),e.default=L}),define(Te[126],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Te[50],Ae([1,0,18,13]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const p=E.charCodeAt(0),s=this._value.charCodeAt(this._pos);return p-s}value(){return this._value[this._pos]}}e.StringIterator=P;class O{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,L.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class T{constructor(E=!0,p=!0){this._splitOnBackslash=E,this._caseSensitive=p}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let p=E.length-1;p>=0;p--,this._valueLen--){const s=this._value.charCodeAt(p);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,L.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var m;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(m||(m={}));class f{constructor(E,p){this._ignorePathCasing=E,this._ignoreQueryAndFragment=p,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,L.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(R||(R={}));class C{static forUris(E=()=>!1,p=()=>!1){return new C(new f(E,p))}static forPaths(E=!1){return new C(new T(void 0,!E))}static forStrings(){return new C(new P)}static forConfigKeys(){return new C(new O)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,p){if(p){const s=p.slice(0);(0,I.shuffle)(s);for(const c of s)this.set(c,E)}else{const s=E.slice(0);(0,I.shuffle)(s);for(const c of s)this.set(c[0],c[1])}}set(E,p){const s=this._iter.reset(E);let c;this._root||(this._root=new y,this._root.segment=s.value());const t=[];for(c=this._root;;){const r=s.cmp(c.segment);if(r>0)c.left||(c.left=new y,c.left.segment=s.value()),t.push([-1,c]),c=c.left;else if(r<0)c.right||(c.right=new y,c.right.segment=s.value()),t.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new y,c.mid.segment=s.value()),t.push([0,c]),c=c.mid;else break}const n=c.value;c.value=p,c.key=E;for(let r=t.length-1;r>=0;r--){const a=t[r][1];a.updateHeight();const d=a.balanceFactor();if(d<-1||d>1){const i=t[r][0],v=t[r+1][0];if(i===1&&v===1)t[r][1]=a.rotateLeft();else if(i===-1&&v===-1)t[r][1]=a.rotateRight();else if(i===1&&v===-1)a.right=t[r+1][1]=t[r+1][1].rotateRight(),t[r][1]=a.rotateLeft();else if(i===-1&&v===1)a.left=t[r+1][1]=t[r+1][1].rotateLeft(),t[r][1]=a.rotateRight();else throw new Error;if(r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this._root=t[0][1]}}return n}get(E){return this._getNode(E)?.value}_getNode(E){const p=this._iter.reset(E);let s=this._root;for(;s;){const c=p.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else break}return s}has(E){const p=this._getNode(E);return!(p?.value===void 0&&p?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,p){const s=this._iter.reset(E),c=[];let t=this._root;for(;t;){const n=s.cmp(t.segment);if(n>0)c.push([-1,t]),t=t.left;else if(n<0)c.push([1,t]),t=t.right;else if(s.hasNext())s.next(),c.push([0,t]),t=t.mid;else break}if(t){if(p?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this._min(t.right);if(n.key){const{key:r,value:a,segment:d}=n;this._delete(n.key,!1),t.key=r,t.value=a,t.segment=d}}else{const n=t.left??t.right;if(c.length>0){const[r,a]=c[c.length-1];switch(r){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this._root=n}for(let n=c.length-1;n>=0;n--){const r=c[n][1];r.updateHeight();const a=r.balanceFactor();if(a>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),c[n][1]=r.rotateLeft()):a<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),c[n][1]=r.rotateRight()),n>0)switch(c[n-1][0]){case-1:c[n-1][1].left=c[n][1];break;case 1:c[n-1][1].right=c[n][1];break;case 0:c[n-1][1].mid=c[n][1];break}else this._root=c[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const p=this._iter.reset(E);let s=this._root,c;for(;s;){const t=p.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(p.hasNext())p.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(E){return this._findSuperstrOrElement(E,!1)}_findSuperstrOrElement(E,p){const s=this._iter.reset(E);let c=this._root;for(;c;){const t=s.cmp(c.segment);if(t>0)c=c.left;else if(t<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):p?c.value:void 0}}hasElementOrSubtree(E){return this._findSuperstrOrElement(E,!0)!==void 0}forEach(E){for(const[p,s]of this)E(s,p)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const p=[];return this._dfsEntries(E,p),p[Symbol.iterator]()}_dfsEntries(E,p){E&&(E.left&&this._dfsEntries(E.left,p),E.value&&p.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,p),E.right&&this._dfsEntries(E.right,p))}_isBalanced(){const E=p=>{if(!p)return!0;const s=p.balanceFactor();return s<-1||s>1?!1:E(p.left)&&E(p.right)};return E(this._root)}}e.TernarySearchTree=C}),define(Te[41],Ae([1,0,89]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(T){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}T.isThemeColor=m})(L||(e.ThemeColor=L={}));function P(T){return{id:T}}e.themeColorFromId=P;var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function f(n){const r=m.exec(n.id);if(!r)return f(I.Codicon.error);const[,a,d]=r,i=["codicon","codicon-"+a];return d&&i.push("codicon-modifier-"+d.substring(1)),i}T.asClassNameArray=f;function y(n){return f(n).join(" ")}T.asClassName=y;function R(n){return"."+f(n).join(".")}T.asCSSSelector=R;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}T.isThemeIcon=C;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function E(n){const r=u.exec(n);if(!r)return;const[,a]=r;return{id:a}}T.fromString=E;function p(n){return{id:n}}T.fromId=p;function s(n,r){let a=n.id;const d=a.lastIndexOf("~");return d!==-1&&(a=a.substring(0,d)),r&&(a=`${a}~${r}`),{id:a}}T.modify=s;function c(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}T.getModifier=c;function t(n,r){return n.id===r.id&&n.color?.id===r.color?.id}T.isEqual=t})(O||(e.ThemeIcon=O={}))}),define(Te[127],Ae([1,0,125,13,41]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const O="$(",T=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${T.source}`,"g");function f(t){return t.replace(m,(n,r)=>r?n:`\\${n}`)}e.escapeIcons=f;const y=new RegExp(`\\\\${T.source}`,"g");function R(t){return t.replace(y,n=>`\\${n}`)}e.markdownEscapeEscapedIcons=R;const C=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u(t){return t.indexOf(O)===-1?t:t.replace(C,(n,r,a,d)=>a?n:r||d||"")}e.stripIcons=u;function E(t){return t?t.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}e.getCodiconAriaLabel=E;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(t){p.lastIndex=0;let n="";const r=[];let a=0;for(;;){const d=p.lastIndex,i=p.exec(t),v=t.substring(d,i?.index);if(v.length>0){n+=v;for(let l=0;l<v.length;l++)r.push(a)}if(!i)break;a+=i[0].length}return{text:n,iconOffsets:r}}e.parseLabelWithIcons=s;function c(t,n,r=!1){const{text:a,iconOffsets:d}=n;if(!d||d.length===0)return(0,I.matchesFuzzy)(t,a,r);const i=(0,L.ltrim)(a," "),v=a.length-i.length,l=(0,I.matchesFuzzy)(t,i,r);if(l)for(const o of l){const S=d[o.start+v]+v;o.start+=S,o.end+=S}return l}e.matchesFuzzyIconAware=c}),define(Te[33],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return I.test(P)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const O=new Uint8Array(16),T=[];for(let m=0;m<256;m++)T.push(m.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,y="";return y+=T[O[f++]],y+=T[O[f++]],y+=T[O[f++]],y+=T[O[f++]],y+="-",y+=T[O[f++]],y+=T[O[f++]],y+="-",y+=T[O[f++]],y+=T[O[f++]],y+="-",y+=T[O[f++]],y+=T[O[f++]],y+="-",y+=T[O[f++]],y+=T[O[f++]],y+=T[O[f++]],y+=T[O[f++]],y+=T[O[f++]],y+=T[O[f++]],y}}()}),define(Te[128],Ae([1,0,18,51,33]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function O(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.createStringDataTransferItem=O;function T(C,u,E){const p={id:(0,P.generateUuid)(),name:C,uri:u,data:E};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.createFileDataTransferItem=T;class m{constructor(){this._entries=new Map}get size(){let u=0;for(const E of this._entries)u++;return u}has(u){return this._entries.has(this.toKey(u))}matches(u){const E=[...this._entries.keys()];return L.Iterable.some(this,([p,s])=>s.asFile())&&E.push("files"),R(f(u),E)}get(u){return this._entries.get(this.toKey(u))?.[0]}append(u,E){const p=this._entries.get(u);p?p.push(E):this._entries.set(this.toKey(u),[E])}replace(u,E){this._entries.set(this.toKey(u),[E])}delete(u){this._entries.delete(this.toKey(u))}*[Symbol.iterator](){for(const[u,E]of this._entries)for(const p of E)yield[u,p]}toKey(u){return f(u)}}e.VSDataTransfer=m;function f(C){return C.toLowerCase()}function y(C,u){return R(f(C),u.map(f))}e.matchesMimeType=y;function R(C,u){if(C==="*/*")return u.length>0;if(u.includes(C))return!0;const E=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[p,s,c]=E;return c==="*"?u.some(t=>t.startsWith(s+"/")):!1}e.UriList=Object.freeze({create:C=>(0,I.distinct)(C.map(u=>u.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.UriList.split(C).filter(u=>!u.startsWith("#"))})}),define(Te[129],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var I;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function L(P){let O=0,T=0,m=0,f=0;for(let y=0,R=P.length;y<R;y++){const C=P.charCodeAt(y);C===13?(O===0&&(T=y),O++,y+1<R&&P.charCodeAt(y+1)===10?(f|=2,y++):f|=3,m=y+1):C===10&&(f|=1,O===0&&(T=y),O++,m=y+1)}return O===0&&(T=P.length),[O,T,P.length-m,f]}e.countEOL=L}),define(Te[130],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[131],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class L{constructor(m){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=m.open,this.close=m.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(m.notIn))for(let f=0,y=m.notIn.length;f<y;f++)switch(m.notIn[f]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const y=m.findTokenIndexAtOffset(f-2),R=m.getStandardTokenType(y);return this.isOK(R)}_findNeutralCharacterInRange(m,f){for(let y=m;y<=f;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class P{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)O(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),O(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),O(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),O(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&O(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.AutoClosingPairs=P;function O(T,m,f){T.has(m)?T.get(m).push(f):T.set(m,[f])}}),define(Te[132],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.recomputeTreeMetadata=e.updateTreeMetadata=e.fixInsert=e.rbDelete=e.rightRotate=e.leftRotate=e.righttest=e.leftest=e.SENTINEL=e.NodeColor=e.TreeNode=void 0;class I{constructor(c,t){this.piece=c,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return P(this.right);let c=this;for(;c.parent!==e.SENTINEL&&c.parent.left!==c;)c=c.parent;return c.parent===e.SENTINEL?e.SENTINEL:c.parent}prev(){if(this.left!==e.SENTINEL)return O(this.left);let c=this;for(;c.parent!==e.SENTINEL&&c.parent.right!==c;)c=c.parent;return c.parent===e.SENTINEL?e.SENTINEL:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=I;var L;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(L||(e.NodeColor=L={})),e.SENTINEL=new I(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function P(s){for(;s.left!==e.SENTINEL;)s=s.left;return s}e.leftest=P;function O(s){for(;s.right!==e.SENTINEL;)s=s.right;return s}e.righttest=O;function T(s){return s===e.SENTINEL?0:s.size_left+s.piece.length+T(s.right)}function m(s){return s===e.SENTINEL?0:s.lf_left+s.piece.lineFeedCnt+m(s.right)}function f(){e.SENTINEL.parent=e.SENTINEL}function y(s,c){const t=c.right;t.size_left+=c.size_left+(c.piece?c.piece.length:0),t.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=t.left,t.left!==e.SENTINEL&&(t.left.parent=c),t.parent=c.parent,c.parent===e.SENTINEL?s.root=t:c.parent.left===c?c.parent.left=t:c.parent.right=t,t.left=c,c.parent=t}e.leftRotate=y;function R(s,c){const t=c.left;c.left=t.right,t.right!==e.SENTINEL&&(t.right.parent=c),t.parent=c.parent,c.size_left-=t.size_left+(t.piece?t.piece.length:0),c.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),c.parent===e.SENTINEL?s.root=t:c===c.parent.right?c.parent.right=t:c.parent.left=t,t.right=c,c.parent=t}e.rightRotate=R;function C(s,c){let t,n;if(c.left===e.SENTINEL?(n=c,t=n.right):c.right===e.SENTINEL?(n=c,t=n.left):(n=P(c.right),t=n.right),n===s.root){s.root=t,t.color=0,c.detach(),f(),s.root.parent=e.SENTINEL;return}const r=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===c?(t.parent=n.parent,p(s,t)):(n.parent===c?t.parent=n:t.parent=n.parent,p(s,t),n.left=c.left,n.right=c.right,n.parent=c.parent,n.color=c.color,c===s.root?s.root=n:c===c.parent.left?c.parent.left=n:c.parent.right=n,n.left!==e.SENTINEL&&(n.left.parent=n),n.right!==e.SENTINEL&&(n.right.parent=n),n.size_left=c.size_left,n.lf_left=c.lf_left,p(s,n)),c.detach(),t.parent.left===t){const d=T(t),i=m(t);if(d!==t.parent.size_left||i!==t.parent.lf_left){const v=d-t.parent.size_left,l=i-t.parent.lf_left;t.parent.size_left=d,t.parent.lf_left=i,E(s,t.parent,v,l)}}if(p(s,t.parent),r){f();return}let a;for(;t!==s.root&&t.color===0;)t===t.parent.left?(a=t.parent.right,a.color===1&&(a.color=0,t.parent.color=1,y(s,t.parent),a=t.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,t=t.parent):(a.right.color===0&&(a.left.color=0,a.color=1,R(s,a),a=t.parent.right),a.color=t.parent.color,t.parent.color=0,a.right.color=0,y(s,t.parent),t=s.root)):(a=t.parent.left,a.color===1&&(a.color=0,t.parent.color=1,R(s,t.parent),a=t.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,t=t.parent):(a.left.color===0&&(a.right.color=0,a.color=1,y(s,a),a=t.parent.left),a.color=t.parent.color,t.parent.color=0,a.left.color=0,R(s,t.parent),t=s.root));t.color=0,f()}e.rbDelete=C;function u(s,c){for(p(s,c);c!==s.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const t=c.parent.parent.right;t.color===1?(c.parent.color=0,t.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,y(s,c)),c.parent.color=0,c.parent.parent.color=1,R(s,c.parent.parent))}else{const t=c.parent.parent.left;t.color===1?(c.parent.color=0,t.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,R(s,c)),c.parent.color=0,c.parent.parent.color=1,y(s,c.parent.parent))}s.root.color=0}e.fixInsert=u;function E(s,c,t,n){for(;c!==s.root&&c!==e.SENTINEL;)c.parent.left===c&&(c.parent.size_left+=t,c.parent.lf_left+=n),c=c.parent}e.updateTreeMetadata=E;function p(s,c){let t=0,n=0;if(c!==s.root){for(;c!==s.root&&c===c.parent.right;)c=c.parent;if(c!==s.root)for(c=c.parent,t=T(c.left)-c.size_left,n=m(c.left)-c.lf_left,c.size_left+=t,c.lf_left+=n;c!==s.root&&(t!==0||n!==0);)c.parent.left===c&&(c.parent.size_left+=t,c.parent.lf_left+=n),c=c.parent}}e.recomputeTreeMetadata=p}),define(Te[90],Ae([1,0,91,29,92,132,93]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=e.createLineStarts=e.createLineStartsFast=void 0;const m=65535;function f(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class y{constructor(n,r,a,d,i){this.lineStarts=n,this.cr=r,this.lf=a,this.crlf=d,this.isBasicASCII=i}}function R(t,n=!0){const r=[0];let a=1;for(let d=0,i=t.length;d<i;d++){const v=t.charCodeAt(d);v===13?d+1<i&&t.charCodeAt(d+1)===10?(r[a++]=d+2,d++):r[a++]=d+1:v===10&&(r[a++]=d+1)}return n?f(r):r}e.createLineStartsFast=R;function C(t,n){t.length=0,t[0]=0;let r=1,a=0,d=0,i=0,v=!0;for(let o=0,S=n.length;o<S;o++){const w=n.charCodeAt(o);w===13?o+1<S&&n.charCodeAt(o+1)===10?(i++,t[r++]=o+2,o++):(a++,t[r++]=o+1):w===10?(d++,t[r++]=o+1):v&&w!==9&&(w<32||w>126)&&(v=!1)}const l=new y(f(t),a,d,i,v);return t.length=0,l}e.createLineStarts=C;class u{constructor(n,r,a,d,i){this.bufferIndex=n,this.start=r,this.end=a,this.lineFeedCnt=d,this.length=i}}e.Piece=u;class E{constructor(n,r){this.buffer=n,this.lineStarts=r}}e.StringBuffer=E;class p{constructor(n,r){this._pieces=[],this._tree=n,this._BOM=r,this._index=0,n.root!==O.SENTINEL&&n.iterate(n.root,a=>(a!==O.SENTINEL&&this._pieces.push(a.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class s{constructor(n){this._limit=n,this._cache=[]}get(n){for(let r=this._cache.length-1;r>=0;r--){const a=this._cache[r];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let r=this._cache.length-1;r>=0;r--){const a=this._cache[r];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(n)}validate(n){let r=!1;const a=this._cache;for(let d=0;d<a.length;d++){const i=a[d];if(i.node.parent===null||i.nodeStartOffset>=n){a[d]=null,r=!0;continue}}if(r){const d=[];for(const i of a)i!==null&&d.push(i);this._cache=d}}}class c{constructor(n,r,a){this.create(n,r,a)}create(n,r,a){this._buffers=[new E("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=O.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=r,this._EOLLength=r.length,this._EOLNormalized=a;let d=null;for(let i=0,v=n.length;i<v;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=R(n[i].buffer));const l=new u(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this._buffers.push(n[i]),d=this.rbInsertRight(d,l)}this._searchCache=new s(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(n){const r=m,a=r-Math.floor(r/3),d=a*2;let i="",v=0;const l=[];if(this.iterate(this.root,o=>{const S=this.getNodeContent(o),w=S.length;if(v<=a||v+w<d)return i+=S,v+=w,!0;const g=i.replace(/\r\n|\r|\n/g,n);return l.push(new E(g,R(g))),i=S,v=w,!0}),v>0){const o=i.replace(/\r\n|\r|\n/g,n);l.push(new E(o,R(o)))}this.create(l,n,!0)}getEOL(){return this._EOL}setEOL(n){this._EOL=n,this._EOLLength=this._EOL.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let r=0;return this.iterate(this.root,d=>{if(d===O.SENTINEL)return!0;const i=this.getNodeContent(d),v=i.length,l=n.nodeAt(r),o=n.nodeAt(r+v),S=n.getValueInRange2(l,o);return r+=v,i===S})}getOffsetAt(n,r){let a=0,d=this.root;for(;d!==O.SENTINEL;)if(d.left!==O.SENTINEL&&d.lf_left+1>=n)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=n){a+=d.size_left;const i=this.getAccumulatedValue(d,n-d.lf_left-2);return a+=i+r-1}else n-=d.lf_left+d.piece.lineFeedCnt,a+=d.size_left+d.piece.length,d=d.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let r=this.root,a=0;const d=n;for(;r!==O.SENTINEL;)if(r.size_left!==0&&r.size_left>=n)r=r.left;else if(r.size_left+r.piece.length>=n){const i=this.getIndexOf(r,n-r.size_left);if(a+=r.lf_left+i.index,i.index===0){const v=this.getOffsetAt(a+1,1),l=d-v;return new I.Position(a+1,l+1)}return new I.Position(a+1,i.remainder+1)}else if(n-=r.size_left+r.piece.length,a+=r.lf_left+r.piece.lineFeedCnt,r.right===O.SENTINEL){const i=this.getOffsetAt(a+1,1),v=d-n-i;return new I.Position(a+1,v+1)}else r=r.right;return new I.Position(1,1)}getValueInRange(n,r){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.nodeAt2(n.startLineNumber,n.startColumn),d=this.nodeAt2(n.endLineNumber,n.endColumn),i=this.getValueInRange2(a,d);return r?r!==this._EOL||!this._EOLNormalized?i.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this._EOLNormalized?i:i.replace(/\r\n|\r|\n/g,r):i}getValueInRange2(n,r){if(n.node===r.node){const l=n.node,o=this._buffers[l.piece.bufferIndex].buffer,S=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);return o.substring(S+n.remainder,S+r.remainder)}let a=n.node;const d=this._buffers[a.piece.bufferIndex].buffer,i=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);let v=d.substring(i+n.remainder,i+a.piece.length);for(a=a.next();a!==O.SENTINEL;){const l=this._buffers[a.piece.bufferIndex].buffer,o=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);if(a===r.node){v+=l.substring(o,o+r.remainder);break}else v+=l.substr(o,a.piece.length);a=a.next()}return v}getLinesContent(){const n=[];let r=0,a="",d=!1;return this.iterate(this.root,i=>{if(i===O.SENTINEL)return!0;const v=i.piece;let l=v.length;if(l===0)return!0;const o=this._buffers[v.bufferIndex].buffer,S=this._buffers[v.bufferIndex].lineStarts,w=v.start.line,g=v.end.line;let D=S[w]+v.start.column;if(d&&(o.charCodeAt(D)===10&&(D++,l--),n[r++]=a,a="",d=!1,l===0))return!0;if(w===g)return!this._EOLNormalized&&o.charCodeAt(D+l-1)===13?(d=!0,a+=o.substr(D,l-1)):a+=o.substr(D,l),!0;a+=this._EOLNormalized?o.substring(D,Math.max(D,S[w+1]-this._EOLLength)):o.substring(D,S[w+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=a;for(let h=w+1;h<g;h++)a=this._EOLNormalized?o.substring(S[h],S[h+1]-this._EOLLength):o.substring(S[h],S[h+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=a;return!this._EOLNormalized&&o.charCodeAt(S[g]+v.end.column-1)===13?(d=!0,v.end.column===0?r--:a=o.substr(S[g],v.end.column-1)):a=o.substr(S[g],v.end.column),!0}),d&&(n[r++]=a,a=""),n[r++]=a,n}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(n){return this._lastVisitedLine.lineNumber===n?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=n,n===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(n):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(n,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(n){if(n.remainder===n.node.piece.length){const r=n.node.next();if(!r)return 0;const a=this._buffers[r.piece.bufferIndex],d=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return a.buffer.charCodeAt(d)}else{const r=this._buffers[n.node.piece.bufferIndex],d=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return r.buffer.charCodeAt(d)}}getLineCharCode(n,r){const a=this.nodeAt2(n,r+1);return this._getCharCode(a)}getLineLength(n){if(n===this.getLineCount()){const r=this.getOffsetAt(n,1);return this.getLength()-r}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this._EOLLength}getCharCode(n){const r=this.nodeAt(n);return this._getCharCode(r)}findMatchesInNode(n,r,a,d,i,v,l,o,S,w,g){const D=this._buffers[n.piece.bufferIndex],h=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start),_=this.offsetInBuffer(n.piece.bufferIndex,i),b=this.offsetInBuffer(n.piece.bufferIndex,v);let A;const F={line:0,column:0};let j,H;r._wordSeparators?(j=D.buffer.substring(_,b),H=B=>B+_,r.reset(0)):(j=D.buffer,H=B=>B,r.reset(_));do if(A=r.next(j),A){if(H(A.index)>=b)return w;this.positionInBuffer(n,H(A.index)-h,F);const B=this.getLineFeedCnt(n.piece.bufferIndex,i,F),k=F.line===i.line?F.column-i.column+d:F.column+1,N=k+A[0].length;if(g[w++]=(0,T.createFindMatch)(new L.Range(a+B,k,a+B,N),A,o),H(A.index)+A[0].length>=b||w>=S)return w}while(A);return w}findMatchesLineByLine(n,r,a,d){const i=[];let v=0;const l=new T.Searcher(r.wordSeparators,r.regex);let o=this.nodeAt2(n.startLineNumber,n.startColumn);if(o===null)return[];const S=this.nodeAt2(n.endLineNumber,n.endColumn);if(S===null)return[];let w=this.positionInBuffer(o.node,o.remainder);const g=this.positionInBuffer(S.node,S.remainder);if(o.node===S.node)return this.findMatchesInNode(o.node,l,n.startLineNumber,n.startColumn,w,g,r,a,d,v,i),i;let D=n.startLineNumber,h=o.node;for(;h!==S.node;){const b=this.getLineFeedCnt(h.piece.bufferIndex,w,h.piece.end);if(b>=1){const F=this._buffers[h.piece.bufferIndex].lineStarts,j=this.offsetInBuffer(h.piece.bufferIndex,h.piece.start),H=F[w.line+b],B=D===n.startLineNumber?n.startColumn:1;if(v=this.findMatchesInNode(h,l,D,B,w,this.positionInBuffer(h,H-j),r,a,d,v,i),v>=d)return i;D+=b}const A=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const F=this.getLineContent(D).substring(A,n.endColumn-1);return v=this._findMatchesInLine(r,l,F,n.endLineNumber,A,v,i,a,d),i}if(v=this._findMatchesInLine(r,l,this.getLineContent(D).substr(A),D,A,v,i,a,d),v>=d)return i;D++,o=this.nodeAt2(D,1),h=o.node,w=this.positionInBuffer(o.node,o.remainder)}if(D===n.endLineNumber){const b=D===n.startLineNumber?n.startColumn-1:0,A=this.getLineContent(D).substring(b,n.endColumn-1);return v=this._findMatchesInLine(r,l,A,n.endLineNumber,b,v,i,a,d),i}const _=D===n.startLineNumber?n.startColumn:1;return v=this.findMatchesInNode(S.node,l,D,_,w,g,r,a,d,v,i),i}_findMatchesInLine(n,r,a,d,i,v,l,o,S){const w=n.wordSeparators;if(!o&&n.simpleSearch){const D=n.simpleSearch,h=D.length,_=a.length;let b=-h;for(;(b=a.indexOf(D,b+h))!==-1;)if((!w||(0,T.isValidMatch)(w,a,_,b,h))&&(l[v++]=new P.FindMatch(new L.Range(d,b+1+i,d,b+1+h+i),null),v>=S))return v;return v}let g;r.reset(0);do if(g=r.next(a),g&&(l[v++]=(0,T.createFindMatch)(new L.Range(d,g.index+1+i,d,g.index+1+g[0].length+i),g,o),v>=S))return v;while(g);return v}insert(n,r,a=!1){if(this._EOLNormalized=this._EOLNormalized&&a,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==O.SENTINEL){const{node:d,remainder:i,nodeStartOffset:v}=this.nodeAt(n),l=d.piece,o=l.bufferIndex,S=this.positionInBuffer(d,i);if(d.piece.bufferIndex===0&&l.end.line===this._lastChangeBufferPos.line&&l.end.column===this._lastChangeBufferPos.column&&v+l.length===n&&r.length<m){this.appendToNode(d,r),this.computeBufferMetadata();return}if(v===n)this.insertContentToNodeLeft(r,d),this._searchCache.validate(n);else if(v+d.piece.length>n){const w=[];let g=new u(l.bufferIndex,S,l.end,this.getLineFeedCnt(l.bufferIndex,S,l.end),this.offsetInBuffer(o,l.end)-this.offsetInBuffer(o,S));if(this.shouldCheckCRLF()&&this.endWithCR(r)&&this.nodeCharCodeAt(d,i)===10){const b={line:g.start.line+1,column:0};g=new u(g.bufferIndex,b,g.end,this.getLineFeedCnt(g.bufferIndex,b,g.end),g.length-1),r+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(r))if(this.nodeCharCodeAt(d,i-1)===13){const b=this.positionInBuffer(d,i-1);this.deleteNodeTail(d,b),r="\r"+r,d.piece.length===0&&w.push(d)}else this.deleteNodeTail(d,S);else this.deleteNodeTail(d,S);const D=this.createNewPieces(r);g.length>0&&this.rbInsertRight(d,g);let h=d;for(let _=0;_<D.length;_++)h=this.rbInsertRight(h,D[_]);this.deleteNodes(w)}else this.insertContentToNodeRight(r,d)}else{const d=this.createNewPieces(r);let i=this.rbInsertLeft(null,d[0]);for(let v=1;v<d.length;v++)i=this.rbInsertRight(i,d[v])}this.computeBufferMetadata()}delete(n,r){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",r<=0||this.root===O.SENTINEL)return;const a=this.nodeAt(n),d=this.nodeAt(n+r),i=a.node,v=d.node;if(i===v){const D=this.positionInBuffer(i,a.remainder),h=this.positionInBuffer(i,d.remainder);if(a.nodeStartOffset===n){if(r===i.piece.length){const _=i.next();(0,O.rbDelete)(this,i),this.validateCRLFWithPrevNode(_),this.computeBufferMetadata();return}this.deleteNodeHead(i,h),this._searchCache.validate(n),this.validateCRLFWithPrevNode(i),this.computeBufferMetadata();return}if(a.nodeStartOffset+i.piece.length===n+r){this.deleteNodeTail(i,D),this.validateCRLFWithNextNode(i),this.computeBufferMetadata();return}this.shrinkNode(i,D,h),this.computeBufferMetadata();return}const l=[],o=this.positionInBuffer(i,a.remainder);this.deleteNodeTail(i,o),this._searchCache.validate(n),i.piece.length===0&&l.push(i);const S=this.positionInBuffer(v,d.remainder);this.deleteNodeHead(v,S),v.piece.length===0&&l.push(v);const w=i.next();for(let D=w;D!==O.SENTINEL&&D!==v;D=D.next())l.push(D);const g=i.piece.length===0?i.prev():i;this.deleteNodes(l),this.validateCRLFWithNextNode(g),this.computeBufferMetadata()}insertContentToNodeLeft(n,r){const a=[];if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.startWithLF(r)){const v=r.piece,l={line:v.start.line+1,column:0},o=new u(v.bufferIndex,l,v.end,this.getLineFeedCnt(v.bufferIndex,l,v.end),v.length-1);r.piece=o,n+=`
`,(0,O.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&a.push(r)}const d=this.createNewPieces(n);let i=this.rbInsertLeft(r,d[d.length-1]);for(let v=d.length-2;v>=0;v--)i=this.rbInsertLeft(i,d[v]);this.validateCRLFWithPrevNode(i),this.deleteNodes(a)}insertContentToNodeRight(n,r){this.adjustCarriageReturnFromNext(n,r)&&(n+=`
`);const a=this.createNewPieces(n),d=this.rbInsertRight(r,a[0]);let i=d;for(let v=1;v<a.length;v++)i=this.rbInsertRight(i,a[v]);this.validateCRLFWithPrevNode(d)}positionInBuffer(n,r,a){const d=n.piece,i=n.piece.bufferIndex,v=this._buffers[i].lineStarts,o=v[d.start.line]+d.start.column+r;let S=d.start.line,w=d.end.line,g=0,D=0,h=0;for(;S<=w&&(g=S+(w-S)/2|0,h=v[g],g!==w);)if(D=v[g+1],o<h)w=g-1;else if(o>=D)S=g+1;else break;return a?(a.line=g,a.column=o-h,null):{line:g,column:o-h}}getLineFeedCnt(n,r,a){if(a.column===0)return a.line-r.line;const d=this._buffers[n].lineStarts;if(a.line===d.length-1)return a.line-r.line;const i=d[a.line+1],v=d[a.line]+a.column;if(i>v+1)return a.line-r.line;const l=v-1;return this._buffers[n].buffer.charCodeAt(l)===13?a.line-r.line+1:a.line-r.line}offsetInBuffer(n,r){return this._buffers[n].lineStarts[r.line]+r.column}deleteNodes(n){for(let r=0;r<n.length;r++)(0,O.rbDelete)(this,n[r])}createNewPieces(n){if(n.length>m){const w=[];for(;n.length>m;){const D=n.charCodeAt(m-1);let h;D===13||D>=55296&&D<=56319?(h=n.substring(0,m-1),n=n.substring(m-1)):(h=n.substring(0,m),n=n.substring(m));const _=R(h);w.push(new u(this._buffers.length,{line:0,column:0},{line:_.length-1,column:h.length-_[_.length-1]},_.length-1,h.length)),this._buffers.push(new E(h,_))}const g=R(n);return w.push(new u(this._buffers.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this._buffers.push(new E(n,g)),w}let r=this._buffers[0].buffer.length;const a=R(n,!1);let d=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===r&&r!==0&&this.startWithLF(n)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},d=this._lastChangeBufferPos;for(let w=0;w<a.length;w++)a[w]+=r+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(a.slice(1)),this._buffers[0].buffer+="_"+n,r+=1}else{if(r!==0)for(let w=0;w<a.length;w++)a[w]+=r;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(a.slice(1)),this._buffers[0].buffer+=n}const i=this._buffers[0].buffer.length,v=this._buffers[0].lineStarts.length-1,l=i-this._buffers[0].lineStarts[v],o={line:v,column:l},S=new u(0,d,o,this.getLineFeedCnt(0,d,o),i-r);return this._lastChangeBufferPos=o,[S]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(n,r=0){let a=this.root,d="";const i=this._searchCache.get2(n);if(i){a=i.node;const v=this.getAccumulatedValue(a,n-i.nodeStartLineNumber-1),l=this._buffers[a.piece.bufferIndex].buffer,o=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);if(i.nodeStartLineNumber+a.piece.lineFeedCnt===n)d=l.substring(o+v,o+a.piece.length);else{const S=this.getAccumulatedValue(a,n-i.nodeStartLineNumber);return l.substring(o+v,o+S-r)}}else{let v=0;const l=n;for(;a!==O.SENTINEL;)if(a.left!==O.SENTINEL&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const o=this.getAccumulatedValue(a,n-a.lf_left-2),S=this.getAccumulatedValue(a,n-a.lf_left-1),w=this._buffers[a.piece.bufferIndex].buffer,g=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this._searchCache.set({node:a,nodeStartOffset:v,nodeStartLineNumber:l-(n-1-a.lf_left)}),w.substring(g+o,g+S-r)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const o=this.getAccumulatedValue(a,n-a.lf_left-2),S=this._buffers[a.piece.bufferIndex].buffer,w=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);d=S.substring(w+o,w+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==O.SENTINEL;){const v=this._buffers[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const l=this.getAccumulatedValue(a,0),o=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return d+=v.substring(o,o+l-r),d}else{const l=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);d+=v.substr(l,a.piece.length)}a=a.next()}return d}computeBufferMetadata(){let n=this.root,r=1,a=0;for(;n!==O.SENTINEL;)r+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this._lineCnt=r,this._length=a,this._searchCache.validate(this._length)}getIndexOf(n,r){const a=n.piece,d=this.positionInBuffer(n,r),i=d.line-a.start.line;if(this.offsetInBuffer(a.bufferIndex,a.end)-this.offsetInBuffer(a.bufferIndex,a.start)===r){const v=this.getLineFeedCnt(n.piece.bufferIndex,a.start,d);if(v!==i)return{index:v,remainder:0}}return{index:i,remainder:d.column}}getAccumulatedValue(n,r){if(r<0)return 0;const a=n.piece,d=this._buffers[a.bufferIndex].lineStarts,i=a.start.line+r+1;return i>a.end.line?d[a.end.line]+a.end.column-d[a.start.line]-a.start.column:d[i]-d[a.start.line]-a.start.column}deleteNodeTail(n,r){const a=n.piece,d=a.lineFeedCnt,i=this.offsetInBuffer(a.bufferIndex,a.end),v=r,l=this.offsetInBuffer(a.bufferIndex,v),o=this.getLineFeedCnt(a.bufferIndex,a.start,v),S=o-d,w=l-i,g=a.length+w;n.piece=new u(a.bufferIndex,a.start,v,o,g),(0,O.updateTreeMetadata)(this,n,w,S)}deleteNodeHead(n,r){const a=n.piece,d=a.lineFeedCnt,i=this.offsetInBuffer(a.bufferIndex,a.start),v=r,l=this.getLineFeedCnt(a.bufferIndex,v,a.end),o=this.offsetInBuffer(a.bufferIndex,v),S=l-d,w=i-o,g=a.length+w;n.piece=new u(a.bufferIndex,v,a.end,l,g),(0,O.updateTreeMetadata)(this,n,w,S)}shrinkNode(n,r,a){const d=n.piece,i=d.start,v=d.end,l=d.length,o=d.lineFeedCnt,S=r,w=this.getLineFeedCnt(d.bufferIndex,d.start,S),g=this.offsetInBuffer(d.bufferIndex,r)-this.offsetInBuffer(d.bufferIndex,i);n.piece=new u(d.bufferIndex,d.start,S,w,g),(0,O.updateTreeMetadata)(this,n,g-l,w-o);const D=new u(d.bufferIndex,a,v,this.getLineFeedCnt(d.bufferIndex,a,v),this.offsetInBuffer(d.bufferIndex,v)-this.offsetInBuffer(d.bufferIndex,a)),h=this.rbInsertRight(n,D);this.validateCRLFWithPrevNode(h)}appendToNode(n,r){this.adjustCarriageReturnFromNext(r,n)&&(r+=`
`);const a=this.shouldCheckCRLF()&&this.startWithLF(r)&&this.endWithCR(n),d=this._buffers[0].buffer.length;this._buffers[0].buffer+=r;const i=R(r,!1);for(let h=0;h<i.length;h++)i[h]+=d;if(a){const h=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:d-h}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(i.slice(1));const v=this._buffers[0].lineStarts.length-1,l=this._buffers[0].buffer.length-this._buffers[0].lineStarts[v],o={line:v,column:l},S=n.piece.length+r.length,w=n.piece.lineFeedCnt,g=this.getLineFeedCnt(0,n.piece.start,o),D=g-w;n.piece=new u(n.piece.bufferIndex,n.piece.start,o,g,S),this._lastChangeBufferPos=o,(0,O.updateTreeMetadata)(this,n,r.length,D)}nodeAt(n){let r=this.root;const a=this._searchCache.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let d=0;for(;r!==O.SENTINEL;)if(r.size_left>n)r=r.left;else if(r.size_left+r.piece.length>=n){d+=r.size_left;const i={node:r,remainder:n-r.size_left,nodeStartOffset:d};return this._searchCache.set(i),i}else n-=r.size_left+r.piece.length,d+=r.size_left+r.piece.length,r=r.right;return null}nodeAt2(n,r){let a=this.root,d=0;for(;a!==O.SENTINEL;)if(a.left!==O.SENTINEL&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const i=this.getAccumulatedValue(a,n-a.lf_left-2),v=this.getAccumulatedValue(a,n-a.lf_left-1);return d+=a.size_left,{node:a,remainder:Math.min(i+r-1,v),nodeStartOffset:d}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const i=this.getAccumulatedValue(a,n-a.lf_left-2);if(i+r-1<=a.piece.length)return{node:a,remainder:i+r-1,nodeStartOffset:d};r-=a.piece.length-i;break}else n-=a.lf_left+a.piece.lineFeedCnt,d+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==O.SENTINEL;){if(a.piece.lineFeedCnt>0){const i=this.getAccumulatedValue(a,0),v=this.offsetOfNode(a);return{node:a,remainder:Math.min(r-1,i),nodeStartOffset:v}}else if(a.piece.length>=r-1){const i=this.offsetOfNode(a);return{node:a,remainder:r-1,nodeStartOffset:i}}else r-=a.piece.length;a=a.next()}return null}nodeCharCodeAt(n,r){if(n.piece.lineFeedCnt<1)return-1;const a=this._buffers[n.piece.bufferIndex],d=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start)+r;return a.buffer.charCodeAt(d)}offsetOfNode(n){if(!n)return 0;let r=n.size_left;for(;n!==this.root;)n.parent.right===n&&(r+=n.parent.size_left+n.parent.piece.length),n=n.parent;return r}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===O.SENTINEL||n.piece.lineFeedCnt===0)return!1;const r=n.piece,a=this._buffers[r.bufferIndex].lineStarts,d=r.start.line,i=a[d]+r.start.column;return d===a.length-1||a[d+1]>i+1?!1:this._buffers[r.bufferIndex].buffer.charCodeAt(i)===10}endWithCR(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===O.SENTINEL||n.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(n,n.piece.length-1)===13}validateCRLFWithPrevNode(n){if(this.shouldCheckCRLF()&&this.startWithLF(n)){const r=n.prev();this.endWithCR(r)&&this.fixCRLF(r,n)}}validateCRLFWithNextNode(n){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const r=n.next();this.startWithLF(r)&&this.fixCRLF(n,r)}}fixCRLF(n,r){const a=[],d=this._buffers[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:d[n.piece.end.line]-d[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const v=n.piece.length-1,l=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,i,l,v),(0,O.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&a.push(n);const o={line:r.piece.start.line+1,column:0},S=r.piece.length-1,w=this.getLineFeedCnt(r.piece.bufferIndex,o,r.piece.end);r.piece=new u(r.piece.bufferIndex,o,r.piece.end,w,S),(0,O.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&a.push(r);const g=this.createNewPieces(`\r
`);this.rbInsertRight(n,g[0]);for(let D=0;D<a.length;D++)(0,O.rbDelete)(this,a[D])}adjustCarriageReturnFromNext(n,r){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const a=r.next();if(this.startWithLF(a)){if(n+=`
`,a.piece.length===1)(0,O.rbDelete)(this,a);else{const d=a.piece,i={line:d.start.line+1,column:0},v=d.length-1,l=this.getLineFeedCnt(d.bufferIndex,i,d.end);a.piece=new u(d.bufferIndex,i,d.end,l,v),(0,O.updateTreeMetadata)(this,a,-1,-1)}return!0}}return!1}iterate(n,r){if(n===O.SENTINEL)return r(O.SENTINEL);const a=this.iterate(n.left,r);return a&&r(n)&&this.iterate(n.right,r)}getNodeContent(n){if(n===O.SENTINEL)return"";const r=this._buffers[n.piece.bufferIndex],a=n.piece,d=this.offsetInBuffer(a.bufferIndex,a.start),i=this.offsetInBuffer(a.bufferIndex,a.end);return r.buffer.substring(d,i)}getPieceContent(n){const r=this._buffers[n.bufferIndex],a=this.offsetInBuffer(n.bufferIndex,n.start),d=this.offsetInBuffer(n.bufferIndex,n.end);return r.buffer.substring(a,d)}rbInsertRight(n,r){const a=new O.TreeNode(r,1);if(a.left=O.SENTINEL,a.right=O.SENTINEL,a.parent=O.SENTINEL,a.size_left=0,a.lf_left=0,this.root===O.SENTINEL)this.root=a,a.color=0;else if(n.right===O.SENTINEL)n.right=a,a.parent=n;else{const i=(0,O.leftest)(n.right);i.left=a,a.parent=i}return(0,O.fixInsert)(this,a),a}rbInsertLeft(n,r){const a=new O.TreeNode(r,1);if(a.left=O.SENTINEL,a.right=O.SENTINEL,a.parent=O.SENTINEL,a.size_left=0,a.lf_left=0,this.root===O.SENTINEL)this.root=a,a.color=0;else if(n.left===O.SENTINEL)n.left=a,a.parent=n;else{const d=(0,O.righttest)(n.left);d.right=a,a.parent=d}return(0,O.fixInsert)(this,a),a}getContentOfSubTree(n){let r="";return this.iterate(n,a=>(r+=this.getNodeContent(a),!0)),r}}e.PieceTreeBase=c}),define(Te[133],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(O){if(O&&this._dragOperations.has(O)){const T=this._dragOperations.get(O);return this._dragOperations.delete(O),T}}addDragOperationTransfer(O,T){this._dragOperations.set(O,T)}}e.TreeViewsDnDService=I;class L{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=L}),define(Te[134],Ae([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Te[135],Ae([1,0,5,6,134]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class O extends L.Disposable{constructor(u,E="",p="",s=!0,c){super(),this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=u,this._label=E,this._cssClass=p,this._enabled=s,this._actionCallback=c}get id(){return this._id}get label(){return this._label}set label(u){this._setLabel(u)}_setLabel(u){this._label!==u&&(this._label=u,this._onDidChange.fire({label:u}))}get tooltip(){return this._tooltip||""}set tooltip(u){this._setTooltip(u)}_setTooltip(u){this._tooltip!==u&&(this._tooltip=u,this._onDidChange.fire({tooltip:u}))}get class(){return this._cssClass}set class(u){this._setClass(u)}_setClass(u){this._cssClass!==u&&(this._cssClass=u,this._onDidChange.fire({class:u}))}get enabled(){return this._enabled}set enabled(u){this._setEnabled(u)}_setEnabled(u){this._enabled!==u&&(this._enabled=u,this._onDidChange.fire({enabled:u}))}get checked(){return this._checked}set checked(u){this._setChecked(u)}_setChecked(u){this._checked!==u&&(this._checked=u,this._onDidChange.fire({checked:u}))}async run(u,E){this._actionCallback&&await this._actionCallback(u)}}e.Action=O;class T extends L.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new I.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(u,E){if(!u.enabled)return;this._onWillRun.fire({action:u});let p;try{await this.runAction(u,E)}catch(s){p=s}this._onDidRun.fire({action:u,error:p})}async runAction(u,E){await u.run(E)}}e.ActionRunner=T;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const p of u)p.length&&(E.length?E=[...E,new m,...p]:E=p);return E}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=m;class f{get actions(){return this._actions}constructor(u,E,p,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=s,this._actions=p}async run(){}}e.SubmenuAction=f;class y extends O{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,P.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=y;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...u)=>C.run(...u),tooltip:C.label}}e.toAction=R}),define(Te[136],Ae([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Te[137],Ae([1,0,136]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.getDurationString=e.fromNow=void 0;const L=60,P=L*60,O=P*24,T=O*7,m=O*30,f=O*365;function y(u,E,p,s){typeof u!="number"&&(u=u.getTime());const c=Math.round((new Date().getTime()-u)/1e3);if(c<-30)return(0,I.localize)(0,null,y(new Date().getTime()+c*1e3,!1));if(!s&&c<30)return(0,I.localize)(1,null);let t;return c<L?(t=c,E?t===1?p?(0,I.localize)(2,null,t):(0,I.localize)(3,null,t):p?(0,I.localize)(4,null,t):(0,I.localize)(5,null,t):t===1?p?(0,I.localize)(6,null,t):(0,I.localize)(7,null,t):p?(0,I.localize)(8,null,t):(0,I.localize)(9,null,t)):c<P?(t=Math.floor(c/L),E?t===1?p?(0,I.localize)(10,null,t):(0,I.localize)(11,null,t):p?(0,I.localize)(12,null,t):(0,I.localize)(13,null,t):t===1?p?(0,I.localize)(14,null,t):(0,I.localize)(15,null,t):p?(0,I.localize)(16,null,t):(0,I.localize)(17,null,t)):c<O?(t=Math.floor(c/P),E?t===1?p?(0,I.localize)(18,null,t):(0,I.localize)(19,null,t):p?(0,I.localize)(20,null,t):(0,I.localize)(21,null,t):t===1?p?(0,I.localize)(22,null,t):(0,I.localize)(23,null,t):p?(0,I.localize)(24,null,t):(0,I.localize)(25,null,t)):c<T?(t=Math.floor(c/O),E?t===1?(0,I.localize)(26,null,t):(0,I.localize)(27,null,t):t===1?(0,I.localize)(28,null,t):(0,I.localize)(29,null,t)):c<m?(t=Math.floor(c/T),E?t===1?p?(0,I.localize)(30,null,t):(0,I.localize)(31,null,t):p?(0,I.localize)(32,null,t):(0,I.localize)(33,null,t):t===1?p?(0,I.localize)(34,null,t):(0,I.localize)(35,null,t):p?(0,I.localize)(36,null,t):(0,I.localize)(37,null,t)):c<f?(t=Math.floor(c/m),E?t===1?p?(0,I.localize)(38,null,t):(0,I.localize)(39,null,t):p?(0,I.localize)(40,null,t):(0,I.localize)(41,null,t):t===1?p?(0,I.localize)(42,null,t):(0,I.localize)(43,null,t):p?(0,I.localize)(44,null,t):(0,I.localize)(45,null,t)):(t=Math.floor(c/f),E?t===1?p?(0,I.localize)(46,null,t):(0,I.localize)(47,null,t):p?(0,I.localize)(48,null,t):(0,I.localize)(49,null,t):t===1?p?(0,I.localize)(50,null,t):(0,I.localize)(51,null,t):p?(0,I.localize)(52,null,t):(0,I.localize)(53,null,t))}e.fromNow=y;function R(u,E){const p=Math.abs(u/1e3);return p<1?E?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):p<L?E?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):p<P?E?(0,I.localize)(58,null,Math.round(u/(1e3*L))):(0,I.localize)(59,null,Math.round(u/(1e3*L))):p<O?E?(0,I.localize)(60,null,Math.round(u/(1e3*P))):(0,I.localize)(61,null,Math.round(u/(1e3*P))):(0,I.localize)(62,null,Math.round(u/(1e3*O)))}e.getDurationString=R;function C(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(Te[138],Ae([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Te[34],Ae([1,0,18,16,138]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(C,u){return u&&(C.stack||C.stacktrace)?P.localize(0,null,m(C),T(C.stack)||T(C.stacktrace)):m(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function m(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?P.localize(1,null,C.message):C.message||P.localize(2,null)}function f(C=null,u=!1){if(!C)return P.localize(3,null);if(Array.isArray(C)){const E=I.coalesce(C),p=f(E[0],u);return E.length>1?P.localize(4,null,p,E.length):p}if(L.isString(C))return C;if(C.detail){const E=C.detail;if(E.error)return O(E.error,u);if(E.exception)return O(E.exception,u)}return C.stack?O(C,u):C.message?C.message:P.localize(5,null)}e.toErrorMessage=f;function y(C){const u=C;return u instanceof Error&&Array.isArray(u.actions)}e.isErrorWithActions=y;function R(C,u){let E;return typeof C=="string"?E=new Error(C):E=C,E.actions=u,E}e.createErrorWithActions=R}),define(Te[139],Ae([1,0,40,19]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new I.Lazy(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),O=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(D,h,_=!1){const b=D||"",A=h||"",F=P.value.collator.compare(b,A);return P.value.collatorIsNumeric&&F===0&&b!==A?b<A?-1:1:F}e.compareFileNames=m;function f(D,h){const _=O.value.collator;return D=D||"",h=h||"",a(_,D,h)}e.compareFileNamesDefault=f;function y(D,h){const _=O.value.collator;return D=D||"",h=h||"",l(D,h)||a(_,D,h)}e.compareFileNamesUpper=y;function R(D,h){const _=O.value.collator;return D=D||"",h=h||"",v(D,h)||a(_,D,h)}e.compareFileNamesLower=R;function C(D,h){return D=D||"",h=h||"",D===h?0:D<h?-1:1}e.compareFileNamesUnicode=C;function u(D,h){const[_,b]=n(D),[A,F]=n(h);let j=P.value.collator.compare(b,F);if(j===0){if(P.value.collatorIsNumeric&&b!==F)return b<F?-1:1;if(j=P.value.collator.compare(_,A),P.value.collatorIsNumeric&&j===0&&_!==A)return _<A?-1:1}return j}e.compareFileExtensions=u;function E(D,h){D=D||"",h=h||"";const _=r(D),b=r(h),A=O.value.collator,F=T.value.collator;return a(F,_,b)||a(A,D,h)}e.compareFileExtensionsDefault=E;function p(D,h){D=D||"",h=h||"";const _=r(D),b=r(h),A=O.value.collator,F=T.value.collator;return a(F,_,b)||l(D,h)||a(A,D,h)}e.compareFileExtensionsUpper=p;function s(D,h){D=D||"",h=h||"";const _=r(D),b=r(h),A=O.value.collator,F=T.value.collator;return a(F,_,b)||v(D,h)||a(A,D,h)}e.compareFileExtensionsLower=s;function c(D,h){D=D||"",h=h||"";const _=r(D).toLowerCase(),b=r(h).toLowerCase();return _!==b?_<b?-1:1:D!==h?D<h?-1:1:0}e.compareFileExtensionsUnicode=c;const t=/^(.*?)(\.([^.]*))?$/;function n(D,h=!1){const _=D?t.exec(D):[];let b=[_&&_[1]||"",_&&_[3]||""];return h&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function r(D){const h=D?t.exec(D):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function a(D,h,_){const b=D.compare(h,_);return b!==0?b:h.length!==_.length?h.length<_.length?-1:1:0}function d(D){const h=D.charAt(0);return h.toLocaleUpperCase()!==h}function i(D){const h=D.charAt(0);return h.toLocaleLowerCase()!==h}function v(D,h){return d(D)&&i(h)?-1:i(D)&&d(h)?1:0}function l(D,h){return i(D)&&d(h)?-1:d(D)&&i(h)?1:0}function o(D,h,_=!1){return _||(D=D&&D.toLowerCase(),h=h&&h.toLowerCase()),D===h?0:D<h?-1:1}function S(D,h,_=!1){const b=D.split(L.sep),A=h.split(L.sep),F=b.length-1,j=A.length-1;let H,B;for(let k=0;;k++){if(H=F===k,B=j===k,H&&B)return m(b[k],A[k],_);if(H)return-1;if(B)return 1;const N=o(b[k],A[k],_);if(N!==0)return N}}e.comparePaths=S;function w(D,h,_){const b=D.toLowerCase(),A=h.toLowerCase(),F=g(D,h,_);if(F)return F;const j=b.endsWith(_),H=A.endsWith(_);if(j!==H)return j?-1:1;const B=m(b,A);return B!==0?B:b.localeCompare(A)}e.compareAnything=w;function g(D,h,_){const b=D.toLowerCase(),A=h.toLowerCase(),F=b.startsWith(_),j=A.startsWith(_);if(F!==j)return F?-1:1;if(F&&j){if(b.length<A.length)return-1;if(b.length>A.length)return 1}return 0}e.compareByPrefix=g}),define(Te[45],Ae([1,0,19,21,13,16]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(w){return w===47||w===92}e.isPathSeparator=T;function m(w){return w.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=m;function f(w){return w.indexOf("/")===-1&&(w=m(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}e.toPosixPath=f;function y(w,g=I.posix.sep){if(!w)return"";const D=w.length,h=w.charCodeAt(0);if(T(h)){if(T(w.charCodeAt(1))&&!T(w.charCodeAt(2))){let b=3;const A=b;for(;b<D&&!T(w.charCodeAt(b));b++);if(A!==b&&!T(w.charCodeAt(b+1))){for(b+=1;b<D;b++)if(T(w.charCodeAt(b)))return w.slice(0,b+1).replace(/[\\/]/g,g)}}return g}else if(t(h)&&w.charCodeAt(1)===58)return T(w.charCodeAt(2))?w.slice(0,2)+g:w.slice(0,2);let _=w.indexOf("://");if(_!==-1){for(_+=3;_<D;_++)if(T(w.charCodeAt(_)))return w.slice(0,_+1)}return""}e.getRoot=y;function R(w){if(!L.isWindows||!w||w.length<5)return!1;let g=w.charCodeAt(0);if(g!==92||(g=w.charCodeAt(1),g!==92))return!1;let D=2;const h=D;for(;D<w.length&&(g=w.charCodeAt(D),g!==92);D++);return!(h===D||(g=w.charCodeAt(D+1),isNaN(g)||g===92))}e.isUNC=R;const C=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(w,g=L.isWindows){const D=g?C:u;return!(!w||w.length===0||/^\s+$/.test(w)||(D.lastIndex=0,D.test(w))||g&&E.test(w)||w==="."||w===".."||g&&w[w.length-1]==="."||g&&w.length!==w.trim().length||w.length>255)}e.isValidBasename=p;function s(w,g,D){const h=w===g;return!D||h?h:!w||!g?!1:(0,P.equalsIgnoreCase)(w,g)}e.isEqual=s;function c(w,g,D,h=I.sep){if(w===g)return!0;if(!w||!g||g.length>w.length)return!1;if(D){if(!(0,P.startsWithIgnoreCase)(w,g))return!1;if(g.length===w.length)return!0;let b=g.length;return g.charAt(g.length-1)===h&&b--,w.charAt(b)===h}return g.charAt(g.length-1)!==h&&(g+=h),w.indexOf(g)===0}e.isEqualOrParent=c;function t(w){return w>=65&&w<=90||w>=97&&w<=122}e.isWindowsDriveLetter=t;function n(w,g){return L.isWindows&&w.endsWith(":")&&(w+=I.sep),(0,I.isAbsolute)(w)||(w=(0,I.join)(g,w)),w=(0,I.normalize)(w),L.isWindows?(w=(0,P.rtrim)(w,I.sep),w.endsWith(":")&&(w+=I.sep)):(w=(0,P.rtrim)(w,I.sep),w||(w=I.sep)),w}e.sanitizeFilePath=n;function r(w){const g=(0,I.normalize)(w);return L.isWindows?w.length>3?!1:a(g)&&(w.length===2||g.charCodeAt(2)===92):g===I.posix.sep}e.isRootOrDriveLetter=r;function a(w,g=L.isWindows){return g?t(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function d(w,g=L.isWindows){return a(w,g)?w[0]:void 0}e.getDriveLetter=d;function i(w,g,D){return g.length>w.length?-1:w===g?0:(D&&(w=w.toLowerCase(),g=g.toLowerCase()),w.indexOf(g))}e.indexOfPath=i;function v(w){const g=w.split(":");let D,h,_;for(const b of g){const A=Number(b);(0,O.isNumber)(A)?h===void 0?h=A:_===void 0&&(_=A):D=D?[D,b].join(":"):b}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:h!==void 0?h:void 0,column:_!==void 0?_:h!==void 0?1:void 0}}e.parseLineAndColumnAware=v;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(w,g,D=8){let h="";for(let b=0;b<D;b++){let A;b===0&&L.isWindows&&!g&&(D===3||D===4)?A=o:A=l,h+=A.charAt(Math.floor(Math.random()*A.length))}let _;return g?_=`${g}-${h}`:_=h,w?(0,I.join)(w,_):_}e.randomPath=S}),define(Te[69],Ae([1,0,19]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const C=(0,I.extname)(R),u=L[C.toLowerCase()];return u!==void 0?u:T(R)}e.getMediaOrTextMime=O;function T(R){const C=(0,I.extname)(R);return P[C.toLowerCase()]}e.getMediaMime=T;function m(R){for(const C in P)if(P[C]===R)return C}e.getExtensionForMimeType=m;const f=/^(.+)\/(.+?)(;.+)?$/;function y(R,C){const u=f.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:C?void 0:R}e.normalizeMimeType=y}),define(Te[52],Ae([1,0,24,2]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(f){return JSON.stringify(f,T)}e.stringify=P;function O(f){let y=JSON.parse(f);return y=m(y),y}e.parse=O;function T(f,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function m(f,y=0){if(!f||y>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return L.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof I.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let R=0;R<f.length;++R)f[R]=m(f[R],y+1);else for(const R in f)Object.hasOwnProperty.call(f,R)&&(f[R]=m(f[R],y+1))}return f}e.revive=m}),define(Te[12],Ae([1,0,15,21,13,2]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var T;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.codeSetting="code-setting",u.codeFeature="code-feature"})(T||(e.Schemas=T={}));function m(u,E){return O.URI.isUri(u)?(0,P.equalsIgnoreCase)(u.scheme,E):(0,P.startsWithIgnoreCase)(u,E+":")}e.matchesScheme=m;function f(u,...E){return E.some(p=>m(u,p))}e.matchesSomeScheme=f,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${T.vscodeRemoteResource}`}set(E,p,s){this._hosts[E]=p,this._ports[E]=s}setConnectionToken(E,p){this._connectionTokens[E]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)try{return this._delegate(E)}catch(r){return I.onUnexpectedError(r),E}const p=E.authority;let s=this._hosts[p];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const c=this._ports[p],t=this._connectionTokens[p];let n=`path=${encodeURIComponent(E.path)}`;return typeof t=="string"&&(n+=`&${e.connectionTokenQueryName}=${encodeURIComponent(t)}`),O.URI.from({scheme:L.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${s}:${c}`,path:this._remoteResourcesPath,query:n})}}e.RemoteAuthorities=new y,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class R{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(E){const p=this.toUri(E,fe);return this.uriToBrowserUri(p)}uriToBrowserUri(E){return E.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===T.file&&(L.isNative||L.webWorkerOrigin===`${T.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?E.with({scheme:T.vscodeFileResource,authority:E.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(E){const p=this.toUri(E,fe);return this.uriToFileUri(p)}uriToFileUri(E){return E.scheme===T.vscodeFileResource?E.with({scheme:T.file,authority:E.authority!==R.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(E,p){return O.URI.isUri(E)?E:O.URI.parse(p.toUrl(E))}}e.FileAccess=new R;var C;(function(u){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(E.get("3"));const p="vscode-coi";function s(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:O.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const r=n?.get(p);if(r)return E.get(r)}u.getHeadersFromQuery=s;function c(t,n,r){if(!globalThis.crossOriginIsolated)return;const a=n&&r?"3":r?"2":"1";t instanceof URLSearchParams?t.set(p,a):t[p]=a}u.addSearchParam=c})(C||(e.COI=C={}))}),define(Te[25],Ae([1,0,45,12,19,21,13,2]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(E){return(0,m.uriToFsPath)(E,!0)}e.originalFSPath=f;class y{constructor(p){this._ignorePathCasing=p}compare(p,s,c=!1){return p===s?0:(0,T.compare)(this.getComparisonKey(p,c),this.getComparisonKey(s,c))}isEqual(p,s,c=!1){return p===s?!0:!p||!s?!1:this.getComparisonKey(p,c)===this.getComparisonKey(s,c)}getComparisonKey(p,s=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,s,c=!1){if(p.scheme===s.scheme){if(p.scheme===L.Schemas.file)return I.isEqualOrParent(f(p),f(s),this._ignorePathCasing(p))&&p.query===s.query&&(c||p.fragment===s.fragment);if((0,e.isEqualAuthority)(p.authority,s.authority))return I.isEqualOrParent(p.path,s.path,this._ignorePathCasing(p),"/")&&p.query===s.query&&(c||p.fragment===s.fragment)}return!1}joinPath(p,...s){return m.URI.joinPath(p,...s)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return P.posix.basename(p.path)}extname(p){return P.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let s;return p.scheme===L.Schemas.file?s=m.URI.file(P.dirname(f(p))).path:(s=P.posix.dirname(p.path),p.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),s="/")),p.with({path:s})}normalizePath(p){if(!p.path.length)return p;let s;return p.scheme===L.Schemas.file?s=m.URI.file(P.normalize(f(p))).path:s=P.posix.normalize(p.path),p.with({path:s})}relativePath(p,s){if(p.scheme!==s.scheme||!(0,e.isEqualAuthority)(p.authority,s.authority))return;if(p.scheme===L.Schemas.file){const n=P.relative(f(p),f(s));return O.isWindows?I.toSlashes(n):n}let c=p.path||"/";const t=s.path||"/";if(this._ignorePathCasing(p)){let n=0;for(const r=Math.min(c.length,t.length);n<r&&!(c.charCodeAt(n)!==t.charCodeAt(n)&&c.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);c=t.substr(0,n)+c.substr(n)}return P.posix.relative(c,t)}resolvePath(p,s){if(p.scheme===L.Schemas.file){const c=m.URI.file(P.resolve(f(p),s));return p.with({authority:c.authority,path:c.path})}return s=I.toPosixPath(s),p.with({path:P.posix.resolve(p.path,s)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,s){return p===s||p!==void 0&&s!==void 0&&(0,T.equalsIgnoreCase)(p,s)}hasTrailingPathSeparator(p,s=P.sep){if(p.scheme===L.Schemas.file){const c=f(p);return c.length>I.getRoot(c).length&&c[c.length-1]===s}else{const c=p.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,s=P.sep){return(0,e.hasTrailingPathSeparator)(p,s)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,s=P.sep){let c=!1;if(p.scheme===L.Schemas.file){const t=f(p);c=t!==void 0&&t.length===I.getRoot(t).length&&t[t.length-1]===s}else{s="/";const t=p.path;c=t.length===1&&t.charCodeAt(t.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(p,s)?p.with({path:p.path+"/"}):p}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(E=>E.scheme===L.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new y(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(E,p){const s=[];for(let c=0;c<E.length;c++){const t=p(E[c]);E.some((n,r)=>r===c?!1:(0,e.isEqualOrParent)(t,p(n)))||s.push(E[c])}return s}e.distinctParents=R;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function p(s){const c=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[a,d]=r.split(":");a&&d&&c.set(a,d)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&c.set(E.META_DATA_MIME,n),c}E.parseMetaData=p})(C||(e.DataUri=C={}));function u(E,p,s){if(p){let c=E.path;return c&&c[0]!==P.posix.sep&&(c=P.posix.sep+c),E.with({scheme:s,authority:p,path:c})}return E.with({scheme:s})}e.toLocalResource=u}),define(Te[11],Ae([1,0,22,15,5,6,25,21,126,40]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(me){return!!me&&typeof me.then=="function"}e.isThenable=R;function C(me){const K=new I.CancellationTokenSource,J=me(K.token),ue=new Promise((he,Pe)=>{const ge=K.token.onCancellationRequested(()=>{ge.dispose(),Pe(new L.CancellationError)});Promise.resolve(J).then(De=>{ge.dispose(),K.dispose(),he(De)},De=>{ge.dispose(),K.dispose(),Pe(De)})});return new class{cancel(){K.cancel(),K.dispose()}then(he,Pe){return ue.then(he,Pe)}catch(he){return this.then(void 0,he)}finally(he){return ue.finally(he)}}}e.createCancelablePromise=C;function u(me,K,J){return new Promise((ue,he)=>{const Pe=K.onCancellationRequested(()=>{Pe.dispose(),ue(J)});me.then(ue,he).finally(()=>Pe.dispose())})}e.raceCancellation=u;function E(me,K){return new Promise((J,ue)=>{const he=K.onCancellationRequested(()=>{he.dispose(),ue(new L.CancellationError)});me.then(J,ue).finally(()=>he.dispose())})}e.raceCancellationError=E;async function p(me){let K=-1;const J=me.map((ue,he)=>ue.then(Pe=>(K=he,Pe)));try{return await Promise.race(J)}finally{me.forEach((ue,he)=>{he!==K&&ue.cancel()})}}e.raceCancellablePromises=p;function s(me,K,J){let ue;const he=setTimeout(()=>{ue?.(void 0),J?.()},K);return Promise.race([me.finally(()=>clearTimeout(he)),new Promise(Pe=>ue=Pe)])}e.raceTimeout=s;function c(me){return new Promise((K,J)=>{const ue=me();R(ue)?ue.then(K,J):K(ue)})}e.asPromise=c;function t(){let me,K;return{promise:new Promise((ue,he)=>{me=ue,K=he}),resolve:me,reject:K}}e.promiseWithResolvers=t;class n{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const J=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ue=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ue};this.queuedPromise=new Promise(ue=>{this.activePromise.then(J,J).then(ue)})}return new Promise((J,ue)=>{this.queuedPromise.then(J,ue)})}return this.activePromise=K(),new Promise((J,ue)=>{this.activePromise.then(he=>{this.activePromise=null,J(he)},he=>{this.activePromise=null,ue(he)})})}dispose(){this.isDisposed=!0}}e.Throttler=n;class r{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=r;class a{constructor(){this.promiseMap=new Map}queue(K,J){const he=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get(K)===he&&this.promiseMap.delete(K)});return this.promiseMap.set(K,he),he}}e.SequencerByKey=a;const d=(me,K)=>{let J=!0;const ue=setTimeout(()=>{J=!1,K()},me);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ue),J=!1}}},i=me=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,me())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class v{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,J=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((he,Pe)=>{this.doResolve=he,this.doReject=Pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const he=this.task;return this.task=null,he()}}));const ue=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=J===f.MicrotaskDelay?i(ue):d(J,ue),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=v;class l{constructor(K){this.delayer=new v(K),this.throttler=new n}trigger(K,J){return this.delayer.trigger(()=>this.throttler.queue(K),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=l;class o{constructor(){this._isOpen=!1,this._promise=new Promise((K,J)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class S extends o{constructor(K){super(),this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function w(me,K){return K?new Promise((J,ue)=>{const he=setTimeout(()=>{Pe.dispose(),J()},me),Pe=K.onCancellationRequested(()=>{clearTimeout(he),Pe.dispose(),ue(new L.CancellationError)})}):C(J=>w(me,J))}e.timeout=w;function g(me,K=0,J){const ue=setTimeout(()=>{me(),J&&he.dispose()},K),he=(0,O.toDisposable)(()=>{clearTimeout(ue),J?.deleteAndLeak(he)});return J?.add(he),he}e.disposableTimeout=g;function D(me){const K=[];let J=0;const ue=me.length;function he(){return J<ue?me[J++]():null}function Pe(ge){ge!=null&&K.push(ge);const De=he();return De?De.then(Pe):Promise.resolve(K)}return Promise.resolve(null).then(Pe)}e.sequence=D;function h(me,K=ue=>!!ue,J=null){let ue=0;const he=me.length,Pe=()=>{if(ue>=he)return Promise.resolve(J);const ge=me[ue++];return Promise.resolve(ge()).then(Re=>K(Re)?Promise.resolve(Re):Pe())};return Pe()}e.first=h;function _(me,K=ue=>!!ue,J=null){if(me.length===0)return Promise.resolve(J);let ue=me.length;const he=()=>{ue=-1;for(const Pe of me)Pe.cancel?.()};return new Promise((Pe,ge)=>{for(const De of me)De.then(Re=>{--ue>=0&&K(Re)?(he(),Pe(Re)):ue===0&&Pe(J)}).catch(Re=>{--ue>=0&&(he(),ge(Re))})})}e.firstParallel=_;class b{constructor(K){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(K){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((J,ue)=>{this.outstandingPromises.push({factory:K,c:J,e:ue}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const J=K.factory();J.then(K.c,K.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class A extends b{constructor(){super(1)}}e.Queue=A;class F{constructor(){this.sequentializer=new de,this.tasks=0}queue(K){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,K())):this.sequentializer.run(this.tasks++,K())}}e.LimitedQueue=F;class j{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const K=new pe;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueSize(K,J=T.extUri){const ue=J.getComparisonKey(K);return this.queues.get(ue)?.size??0}queueFor(K,J,ue=T.extUri){const he=ue.getComparisonKey(K);let Pe=this.queues.get(he);if(!Pe){Pe=new A;const ge=this.drainListenerCount++,De=P.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.queues.delete(he),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ge),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(ge,De),this.queues.set(he,Pe)}return Pe.queue(J)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=j;class H{constructor(K,J){this._token=-1,typeof K=="function"&&typeof J=="number"&&this.setIfNotSet(K,J)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,J){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},J)}setIfNotSet(K,J){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},J))}}e.TimeoutTimer=H;class B{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(K,J,ue=globalThis){this.cancel();const he=ue.setInterval(()=>{K()},J);this.disposable=(0,O.toDisposable)(()=>{ue.clearInterval(he),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=B;class k{constructor(K,J){this.timeoutToken=-1,this.runner=K,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=k;class N{constructor(K,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=N;class $ extends k{constructor(K,J){super(K,J),this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner?.(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class re extends O.Disposable{constructor(K,J){super(),this.options=K,this.handler=J,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const J of K)this.pendingWork.push(J);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new k(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(me,K)=>{(0,m.setTimeout0)(()=>{if(J)return;const ue=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e._runWhenIdle=(me,K,J)=>{const ue=me.requestIdleCallback(K,typeof J=="number"?{timeout:J}:void 0);let he=!1;return{dispose(){he||(he=!0,me.cancelIdleCallback(ue))}}},e.runWhenGlobalIdle=me=>(0,e._runWhenIdle)(globalThis,me)}();class le{constructor(K,J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(ue){this._error=ue}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(K,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=le;class _e extends le{constructor(K){super(globalThis,K)}}e.GlobalIdleValue=_e;async function ye(me,K,J){let ue;for(let he=0;he<J;he++)try{return await me()}catch(Pe){ue=Pe,await w(K)}throw ue}e.retry=ye;class de{isRunning(K){return typeof K=="number"?this._running?.taskId===K:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(K,J,ue){return this._running={taskId:K,cancel:()=>ue?.(),promise:J},J.then(()=>this.doneRunning(K),()=>this.doneRunning(K)),J}doneRunning(K){this._running&&K===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const K=this._queued;this._queued=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this._queued)this._queued.run=K;else{const{promise:J,resolve:ue,reject:he}=t();this._queued={run:K,promise:J,promiseResolve:ue,promiseReject:he}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=de;class Ee{constructor(K,J=()=>Date.now()){this.interval=K,this.nowFn=J,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=Ee;var se;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(se||(se={}));class pe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((K,J)=>{this.completeCallback=K,this.errorCallback=J})}complete(K){return new Promise(J=>{this.completeCallback(K),this.outcome={outcome:0,value:K},J()})}error(K){return new Promise(J=>{this.errorCallback(K),this.outcome={outcome:1,value:K},J()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=pe;var ee;(function(me){async function K(ue){let he;const Pe=await Promise.all(ue.map(ge=>ge.then(De=>De,De=>{he||(he=De)})));if(typeof he<"u")throw he;return Pe}me.settled=K;function J(ue){return new Promise(async(he,Pe)=>{try{await ue(he,Pe)}catch(ge){Pe(ge)}})}me.withAsyncBody=J})(ee||(e.Promises=ee={}));class X{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(K){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=K.then(J=>(this._value=J,this._isResolved=!0,J),J=>{throw this._error=J,this._isResolved=!0,J})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=X;class V{constructor(K){this._compute=K,this._promise=new y.Lazy(()=>new X(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=V;var ne;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ne||(ne={}));class Ie{static fromArray(K){return new Ie(J=>{J.emitMany(K)})}static fromPromise(K){return new Ie(async J=>{J.emitMany(await K)})}static fromPromises(K){return new Ie(async J=>{await Promise.all(K.map(async ue=>J.emitOne(await ue)))})}static merge(K){return new Ie(async J=>{await Promise.all(K.map(async ue=>{for await(const he of ue)J.emitOne(he)}))})}static{this.EMPTY=Ie.fromArray([])}constructor(K){this._state=0,this._results=[],this._error=null,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const J={emitOne:ue=>this.emitOne(ue),emitMany:ue=>this.emitMany(ue),reject:ue=>this.reject(ue)};try{await Promise.resolve(K(J)),this.resolve()}catch(ue){this.reject(ue)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===1)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(K,J){return new Ie(async ue=>{for await(const he of K)ue.emitOne(J(he))})}map(K){return Ie.map(this,K)}static filter(K,J){return new Ie(async ue=>{for await(const he of K)J(he)&&ue.emitOne(he)})}filter(K){return Ie.filter(this,K)}static coalesce(K){return Ie.filter(K,J=>!!J)}coalesce(){return Ie.coalesce(this)}static async toPromise(K){const J=[];for await(const ue of K)J.push(ue);return J}toPromise(){return Ie.toPromise(this)}emitOne(K){this._state===0&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===0&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(K){this._state===0&&(this._state=2,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=Ie;class Fe extends Ie{constructor(K,J){super(J),this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Fe;function ke(me){const K=new I.CancellationTokenSource,J=me(K.token);return new Fe(K,async ue=>{const he=K.token.onCancellationRequested(()=>{he.dispose(),K.dispose(),ue.reject(new L.CancellationError)});try{for await(const Pe of J){if(K.token.isCancellationRequested)return;ue.emitOne(Pe)}he.dispose(),K.dispose()}catch(Pe){he.dispose(),K.dispose(),ue.reject(Pe)}})}e.createCancelableAsyncIterable=ke;class we{constructor(){this._deferred=new pe,this._asyncIterable=new Ie(ue=>{if(K){ue.reject(K);return}return J&&ue.emitMany(J),this._errorFn=he=>ue.reject(he),this._emitFn=he=>ue.emitOne(he),this._deferred.p});let K,J;this._emitFn=ue=>{J||(J=[]),J.push(ue)},this._errorFn=ue=>{K||(K=ue)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(K){this._errorFn(K),this._deferred.complete()}emitOne(K){this._emitFn(K)}}e.AsyncIterableSource=we}),define(Te[35],Ae([1,0,18,11,45,28,19,21,13]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",C="[^/\\\\]",u=/\//g;function E(le,_e){switch(le){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${_e?`|${R}${C}+`:""})*?`}}function p(le,_e){if(!le)return[];const ye=[];let de=!1,Ee=!1,se="";for(const pe of le){switch(pe){case _e:if(!de&&!Ee){ye.push(se),se="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":Ee=!0;break;case"]":Ee=!1;break}se+=pe}return se&&ye.push(se),ye}e.splitGlobAware=p;function s(le){if(!le)return"";let _e="";const ye=p(le,e.GLOB_SPLIT);if(ye.every(de=>de===e.GLOBSTAR))_e=".*";else{let de=!1;ye.forEach((Ee,se)=>{if(Ee===e.GLOBSTAR){if(de)return;_e+=E(2,se===ye.length-1)}else{let pe=!1,ee="",X=!1,V="";for(const ne of Ee){if(ne!=="}"&&pe){ee+=ne;continue}if(X&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.GLOB_SPLIT?Ie="":Ie=(0,f.escapeRegExpCharacters)(ne),V+=Ie;continue}switch(ne){case"{":pe=!0;continue;case"[":X=!0;continue;case"}":{const Fe=`(?:${p(ee,",").map(ke=>s(ke)).join("|")})`;_e+=Fe,pe=!1,ee="";break}case"]":{_e+="["+V+"]",X=!1,V="";break}case"?":_e+=C;continue;case"*":_e+=E(1);continue;default:_e+=(0,f.escapeRegExpCharacters)(ne)}}se<ye.length-1&&(ye[se+1]!==e.GLOBSTAR||se+2<ye.length)&&(_e+=R)}de=Ee===e.GLOBSTAR})}return _e}const c=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.LRUCache(1e4),v=function(){return!1},l=function(){return null};function o(le,_e){if(!le)return l;let ye;typeof le!="string"?ye=le.pattern:ye=le,ye=ye.trim();const de=`${ye}_${!!_e.trimForExclusions}`;let Ee=i.get(de);if(Ee)return S(Ee,le);let se;return c.test(ye)?Ee=g(ye.substr(4),ye):(se=t.exec(w(ye,_e)))?Ee=D(se[1],ye):(_e.trimForExclusions?r:n).test(ye)?Ee=h(ye,_e):(se=a.exec(w(ye,_e)))?Ee=_(se[1].substr(1),ye,!0):(se=d.exec(w(ye,_e)))?Ee=_(se[1],ye,!1):Ee=b(ye),i.set(de,Ee),S(Ee,le)}function S(le,_e){if(typeof _e=="string")return le;const ye=function(de,Ee){return(0,P.isEqualOrParent)(de,_e.base,!m.isLinux)?le((0,f.ltrim)(de.substr(_e.base.length),T.sep),Ee):null};return ye.allBasenames=le.allBasenames,ye.allPaths=le.allPaths,ye.basenames=le.basenames,ye.patterns=le.patterns,ye}function w(le,_e){return _e.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function g(le,_e){return function(ye,de){return typeof ye=="string"&&ye.endsWith(le)?_e:null}}function D(le,_e){const ye=`/${le}`,de=`\\${le}`,Ee=function(pe,ee){return typeof pe!="string"?null:ee?ee===le?_e:null:pe===le||pe.endsWith(ye)||pe.endsWith(de)?_e:null},se=[le];return Ee.basenames=se,Ee.patterns=[_e],Ee.allBasenames=se,Ee}function h(le,_e){const ye=$(le.slice(1,-1).split(",").map(ee=>o(ee,_e)).filter(ee=>ee!==l),le),de=ye.length;if(!de)return l;if(de===1)return ye[0];const Ee=function(ee,X){for(let V=0,ne=ye.length;V<ne;V++)if(ye[V](ee,X))return le;return null},se=ye.find(ee=>!!ee.allBasenames);se&&(Ee.allBasenames=se.allBasenames);const pe=ye.reduce((ee,X)=>X.allPaths?ee.concat(X.allPaths):ee,[]);return pe.length&&(Ee.allPaths=pe),Ee}function _(le,_e,ye){const de=T.sep===T.posix.sep,Ee=de?le:le.replace(u,T.sep),se=T.sep+Ee,pe=T.posix.sep+le;let ee;return ye?ee=function(X,V){return typeof X=="string"&&(X===Ee||X.endsWith(se)||!de&&(X===le||X.endsWith(pe)))?_e:null}:ee=function(X,V){return typeof X=="string"&&(X===Ee||!de&&X===le)?_e:null},ee.allPaths=[(ye?"*/":"./")+le],ee}function b(le){try{const _e=new RegExp(`^${s(le)}$`);return function(ye){return _e.lastIndex=0,typeof ye=="string"&&_e.test(ye)?le:null}}catch{return l}}function A(le,_e,ye){return!le||typeof _e!="string"?!1:F(le)(_e,void 0,ye)}e.match=A;function F(le,_e={}){if(!le)return v;if(typeof le=="string"||j(le)){const ye=o(le,_e);if(ye===l)return v;const de=function(Ee,se){return!!ye(Ee,se)};return ye.allBasenames&&(de.allBasenames=ye.allBasenames),ye.allPaths&&(de.allPaths=ye.allPaths),de}return k(le,_e)}e.parse=F;function j(le){const _e=le;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}e.isRelativePattern=j;function H(le){return le.allBasenames||[]}e.getBasenameTerms=H;function B(le){return le.allPaths||[]}e.getPathTerms=B;function k(le,_e){const ye=$(Object.getOwnPropertyNames(le).map(ee=>N(ee,le[ee],_e)).filter(ee=>ee!==l)),de=ye.length;if(!de)return l;if(!ye.some(ee=>!!ee.requiresSiblings)){if(de===1)return ye[0];const ee=function(ne,Ie){let Fe;for(let ke=0,we=ye.length;ke<we;ke++){const me=ye[ke](ne,Ie);if(typeof me=="string")return me;(0,L.isThenable)(me)&&(Fe||(Fe=[]),Fe.push(me))}return Fe?(async()=>{for(const ke of Fe){const we=await ke;if(typeof we=="string")return we}return null})():null},X=ye.find(ne=>!!ne.allBasenames);X&&(ee.allBasenames=X.allBasenames);const V=ye.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(ee.allPaths=V),ee}const Ee=function(ee,X,V){let ne,Ie;for(let Fe=0,ke=ye.length;Fe<ke;Fe++){const we=ye[Fe];we.requiresSiblings&&V&&(X||(X=(0,T.basename)(ee)),ne||(ne=X.substr(0,X.length-(0,T.extname)(ee).length)));const me=we(ee,X,ne,V);if(typeof me=="string")return me;(0,L.isThenable)(me)&&(Ie||(Ie=[]),Ie.push(me))}return Ie?(async()=>{for(const Fe of Ie){const ke=await Fe;if(typeof ke=="string")return ke}return null})():null},se=ye.find(ee=>!!ee.allBasenames);se&&(Ee.allBasenames=se.allBasenames);const pe=ye.reduce((ee,X)=>X.allPaths?ee.concat(X.allPaths):ee,[]);return pe.length&&(Ee.allPaths=pe),Ee}function N(le,_e,ye){if(_e===!1)return l;const de=o(le,ye);if(de===l)return l;if(typeof _e=="boolean")return de;if(_e){const Ee=_e.when;if(typeof Ee=="string"){const se=(pe,ee,X,V)=>{if(!V||!de(pe,ee))return null;const ne=Ee.replace("$(basename)",()=>X),Ie=V(ne);return(0,L.isThenable)(Ie)?Ie.then(Fe=>Fe?le:null):Ie?le:null};return se.requiresSiblings=!0,se}}return de}function $(le,_e){const ye=le.filter(ee=>!!ee.basenames);if(ye.length<2)return le;const de=ye.reduce((ee,X)=>{const V=X.basenames;return V?ee.concat(V):ee},[]);let Ee;if(_e){Ee=[];for(let ee=0,X=de.length;ee<X;ee++)Ee.push(_e)}else Ee=ye.reduce((ee,X)=>{const V=X.patterns;return V?ee.concat(V):ee},[]);const se=function(ee,X){if(typeof ee!="string")return null;if(!X){let ne;for(ne=ee.length;ne>0;ne--){const Ie=ee.charCodeAt(ne-1);if(Ie===47||Ie===92)break}X=ee.substr(ne)}const V=de.indexOf(X);return V!==-1?Ee[V]:null};se.basenames=de,se.patterns=Ee,se.allBasenames=de;const pe=le.filter(ee=>!ee.basenames);return pe.push(se),pe}function re(le,_e){return(0,I.equals)(le,_e,(ye,de)=>typeof ye=="string"&&typeof de=="string"?ye===de:typeof ye!="string"&&typeof de!="string"?ye.base===de.base&&ye.pattern===de.pattern:!1)}e.patternsEquals=re}),define(Te[53],Ae([1,0,15,127,25,13,2]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.appendEscapedMarkdownCodeBlockFence=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(n="",r=!1){if(this.value=n,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(n,r=0){return this.value+=u(this.supportThemeIcons?(0,L.escapeIcons)(n):n).replace(/([ \t]+)/g,(a,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,r){return this.value+=`
${E(r,n)}
`,this}appendLink(n,r,a){return this.value+="[",this.value+=this._escape(r,"]"),this.value+="](",this.value+=this._escape(String(n),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(n,r){const a=new RegExp((0,O.escapeRegExpCharacters)(r),"g");return n.replace(a,(d,i)=>n.charAt(i-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=f;function y(t){return R(t)?!t.value:Array.isArray(t)?t.every(y):!0}e.isEmptyMarkdownString=y;function R(t){return t instanceof f?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function C(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,P.isEqual)(T.URI.from(t.baseUri),T.URI.from(n.baseUri)))}e.markdownStringEqual=C;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=u;function E(t,n){const r=t.match(/^`+/gm)?.reduce((d,i)=>d.length>i.length?d:i).length??0,a=r>=3?r+1:3;return[`${"`".repeat(a)}${n}`,t,`${"`".repeat(a)}`].join(`
`)}e.appendEscapedMarkdownCodeBlockFence=E;function p(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function s(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=s;function c(t){const n=[],r=t.split("|").map(d=>d.trim());t=r[0];const a=r[1];if(a){const d=/height=(\d+)/.exec(a),i=/width=(\d+)/.exec(a),v=d?d[1]:"",l=i?i[1]:"",o=isFinite(parseInt(l)),S=isFinite(parseInt(v));o&&n.push(`width="${l}"`),S&&n.push(`height="${v}"`)}return{href:t,dimensions:n}}e.parseHrefAndDimensions=c}),define(Te[94],Ae([1,0,18,45,19,21,25,13]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(o,S){const{os:w,tildify:g,relative:D}=S;if(D){const b=y(o,D,w);if(typeof b=="string")return b}let h=o.fsPath;if(w===1&&!O.isWindows?h=h.replace(/\//g,"\\"):w!==1&&O.isWindows&&(h=h.replace(/\\/g,"/")),w!==1&&g?.userHome){const b=g.userHome.fsPath;let A;o.scheme!==g.userHome.scheme&&o.path[0]===P.posix.sep&&o.path[1]!==P.posix.sep?A=g.userHome.with({path:o.path}).fsPath:A=h,h=u(A,b,w)}return(w===1?P.win32:P.posix).normalize(R(h,w===1))}e.getPathLabel=f;function y(o,S,w){const g=w===1?P.win32:P.posix,D=w===3?T.extUri:T.extUriIgnorePathCase,h=S.getWorkspace(),_=(0,I.firstOrDefault)(h.folders);if(!_)return;o.scheme!==_.uri.scheme&&o.path[0]===P.posix.sep&&o.path[1]!==P.posix.sep&&(o=_.uri.with({path:o.path}));const b=S.getWorkspaceFolder(o);if(!b)return;let A;if(D.isEqual(b.uri,o)?A="":A=D.relativePath(b.uri,o)??"",A&&(A=g.normalize(A)),h.folders.length>1&&!S.noPrefix){const F=b.name?b.name:D.basenameOrAuthority(b.uri);A=A?`${F} \u2022 ${A}`:F}return A}function R(o,S=O.isWindows){return(0,L.hasDriveLetter)(o,S)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=R;let C=Object.create(null);function u(o,S,w=O.OS){if(w===1||!o||!S)return o;let g=C.original===S?C.normalized:void 0;g||(g=S,O.isWindows&&(g=(0,L.toSlashes)(g)),g=`${(0,m.rtrim)(g,P.posix.sep)}${P.posix.sep}`,C={original:S,normalized:g});let D=o;return O.isWindows&&(D=(0,L.toSlashes)(D)),(w===3?D.startsWith(g):(0,m.startsWithIgnoreCase)(D,g))?`~/${D.substr(g.length)}`:o}e.tildify=u;function E(o,S){return o.replace(/^~($|\/|\\)/,`${S}$1`)}e.untildify=E;const p="\u2026",s="\\\\",c="~";function t(o,S=P.sep){const w=new Array(o.length);let g=!1;for(let D=0;D<o.length;D++){const h=o[D];if(h===""){w[D]=`.${S}`;continue}if(!h){w[D]=h;continue}g=!0;let _="",b=h;b.indexOf(s)===0?(_=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(S)===0?(_=b.substr(0,b.indexOf(S)+S.length),b=b.substr(b.indexOf(S)+S.length)):b.indexOf(c)===0&&(_=b.substr(0,b.indexOf(c)+c.length),b=b.substr(b.indexOf(c)+c.length));const A=b.split(S);for(let F=1;g&&F<=A.length;F++)for(let j=A.length-F;g&&j>=0;j--){g=!1;let H=A.slice(j,j+F).join(S);for(let B=0;!g&&B<o.length;B++)if(B!==D&&o[B]&&o[B].indexOf(H)>-1){const k=j+F===A.length,N=j>0&&o[B].indexOf(S)>-1?S+H:H,$=o[B].endsWith(N);g=!k||$}if(!g){let B="";(A[0].endsWith(":")||_!=="")&&(j===1&&(j=0,F++,H=A[0]+S+H),j>0&&(B=A[0]+S),B=_+B),j>0&&(B=B+p+S),B=B+H,j+F<A.length&&(B=B+S+p),w[D]=B}}g&&(w[D]=h)}return w}e.shorten=t;var n;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function r(o,S=Object.create(null)){const w=[];let g=!1,D="";for(const h of o)if(h==="$"||g&&h==="{")D&&w.push({value:D,type:n.TEXT}),D="",g=!0;else if(h==="}"&&g){const _=S[D];if(typeof _=="string")_.length&&w.push({value:_,type:n.VARIABLE});else if(_){const b=w[w.length-1];(!b||b.type!==n.SEPARATOR)&&w.push({value:_.label,type:n.SEPARATOR})}D="",g=!1}else D+=h;return D&&!g&&w.push({value:D,type:n.TEXT}),w.filter((h,_)=>{if(h.type===n.SEPARATOR){const b=w[_-1],A=w[_+1];return[b,A].every(F=>F&&(F.type===n.VARIABLE||F.type===n.TEXT)&&F.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=r;function a(o,S){return O.isMacintosh||S?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):o.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function d(o,S){return O.isMacintosh||S?o.replace(/\(&&\w\)|&&/g,""):O.isWindows?o.replace(/&&|&/g,w=>w==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=d;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function v(o){if(o.endsWith("]")){const S=o.lastIndexOf(" [",o.length-2);if(S!==-1){const w=l(o.substring(0,S)),g=o.substring(S);return{name:w.name+g,parentPath:w.parentPath}}}return l(o)}e.splitRecentLabel=v;function l(o){const S=o.indexOf("/")!==-1?P.posix:P.win32,w=S.basename(o),g=S.dirname(o);return w.length?{name:w,parentPath:g}:{name:g,parentPath:""}}}),define(Te[140],Ae([1,0,24,2]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(C){return C.toJSON()}class O{constructor(u){this._uriTransformer=u}transformIncoming(u){const E=this._uriTransformer.transformIncoming(u);return E===u?u:P(L.URI.from(E))}transformOutgoing(u){const E=this._uriTransformer.transformOutgoing(u);return E===u?u:P(L.URI.from(E))}transformOutgoingURI(u){const E=this._uriTransformer.transformOutgoing(u);return E===u?u:L.URI.from(E)}transformOutgoingScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function T(C,u,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof L.URI)return u.transformOutgoing(C);for(const p in C)if(Object.hasOwnProperty.call(C,p)){const s=T(C[p],u,E+1);s!==null&&(C[p]=s)}}return null}function m(C,u){const E=T(C,u,0);return E===null?C:E}e.transformOutgoingURIs=m;function f(C,u,E,p){if(!C||p>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?L.URI.revive(u.transformIncoming(C)):u.transformIncoming(C);if(C instanceof I.VSBuffer)return null;for(const s in C)if(Object.hasOwnProperty.call(C,s)){const c=f(C[s],u,E,p+1);c!==null&&(C[s]=c)}}return null}function y(C,u){const E=f(C,u,!1,0);return E===null?C:E}e.transformIncomingURIs=y;function R(C,u){const E=f(C,u,!0,0);return E===null?C:E}e.transformAndReviveIncomingURIs=R}),define(Te[141],Ae([1,0,13,21,24]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=e.decodeUTF16LE=e.getPlatformTextDecoder=void 0;let O;function T(){return O||(O=new TextDecoder("UTF-16LE")),O}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let y;function R(){return y||(y=L.isLittleEndian()?T():f()),y}e.getPlatformTextDecoder=R;function C(p,s,c){const t=new Uint16Array(p.buffer,s,c);return c>0&&(t[0]===65279||t[0]===65534)?u(p,s,c):T().decode(t)}e.decodeUTF16LE=C;function u(p,s,c){const t=[];let n=0;for(let r=0;r<c;r++){const a=P.readUInt16LE(p,s);s+=2,t[n++]=String.fromCharCode(a)}return t.join("")}class E{constructor(s){this._capacity=s|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const s=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return R().decode(s)}_flushBuffer(){const s=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[s]:this._completedStrings[this._completedStrings.length]=s}appendCharCode(s){const c=this._capacity-this._bufferLength;c<=1&&(c===0||I.isHighSurrogate(s))&&this._flushBuffer(),this._buffer[this._bufferLength++]=s}appendASCIICharCode(s){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=s}appendString(s){const c=s.length;if(this._bufferLength+c>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=s;return}for(let t=0;t<c;t++)this._buffer[this._bufferLength++]=s.charCodeAt(t)}}e.StringBuilder=E}),define(Te[142],Ae([1,0,24,141]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressConsecutiveTextChanges=e.TextChange=void 0;function P(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,C,u){this.oldPosition=y,this.oldText=R,this.newPosition=C,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static _writeStringSize(y){return 4+2*y.length}static _writeString(y,R,C){const u=R.length;I.writeUInt32BE(y,u,C),C+=4;for(let E=0;E<u;E++)I.writeUInt16LE(y,R.charCodeAt(E),C),C+=2;return C}static _readString(y,R){const C=I.readUInt32BE(y,R);return R+=4,(0,L.decodeUTF16LE)(y,R,C)}writeSize(){return 8+O._writeStringSize(this.oldText)+O._writeStringSize(this.newText)}write(y,R){return I.writeUInt32BE(y,this.oldPosition,R),R+=4,I.writeUInt32BE(y,this.newPosition,R),R+=4,R=O._writeString(y,this.oldText,R),R=O._writeString(y,this.newText,R),R}static read(y,R,C){const u=I.readUInt32BE(y,R);R+=4;const E=I.readUInt32BE(y,R);R+=4;const p=O._readString(y,R);R+=O._writeStringSize(p);const s=O._readString(y,R);return R+=O._writeStringSize(s),C.push(new O(u,p,E,s)),R}}e.TextChange=O;function T(f,y){return f===null||f.length===0?y:new m(f,y).compress()}e.compressConsecutiveTextChanges=T;class m{constructor(y,R){this._prevEdits=y,this._currEdits=R,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let y=0,R=0,C=this._getPrev(y),u=this._getCurr(R);for(;y<this._prevLen||R<this._currLen;){if(C===null){this._acceptCurr(u),u=this._getCurr(++R);continue}if(u===null){this._acceptPrev(C),C=this._getPrev(++y);continue}if(u.oldEnd<=C.newPosition){this._acceptCurr(u),u=this._getCurr(++R);continue}if(C.newEnd<=u.oldPosition){this._acceptPrev(C),C=this._getPrev(++y);continue}if(u.oldPosition<C.newPosition){const[t,n]=m._splitCurr(u,C.newPosition-u.oldPosition);this._acceptCurr(t),u=n;continue}if(C.newPosition<u.oldPosition){const[t,n]=m._splitPrev(C,u.oldPosition-C.newPosition);this._acceptPrev(t),C=n;continue}let s,c;if(u.oldEnd===C.newEnd)s=C,c=u,C=this._getPrev(++y),u=this._getCurr(++R);else if(u.oldEnd<C.newEnd){const[t,n]=m._splitPrev(C,u.oldLength);s=t,c=u,C=n,u=this._getCurr(++R)}else{const[t,n]=m._splitCurr(u,C.newLength);s=C,c=t,C=this._getPrev(++y),u=n}this._result[this._resultLen++]=new O(s.oldPosition,s.oldText,c.newPosition,c.newText),this._prevDeltaOffset+=s.newLength-s.oldLength,this._currDeltaOffset+=c.newLength-c.oldLength}const E=m._merge(this._result);return m._removeNoOps(E)}_acceptCurr(y){this._result[this._resultLen++]=m._rebaseCurr(this._prevDeltaOffset,y),this._currDeltaOffset+=y.newLength-y.oldLength}_getCurr(y){return y<this._currLen?this._currEdits[y]:null}_acceptPrev(y){this._result[this._resultLen++]=m._rebasePrev(this._currDeltaOffset,y),this._prevDeltaOffset+=y.newLength-y.oldLength}_getPrev(y){return y<this._prevLen?this._prevEdits[y]:null}static _rebaseCurr(y,R){return new O(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static _rebasePrev(y,R){return new O(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static _splitPrev(y,R){const C=y.newText.substr(0,R),u=y.newText.substr(R);return[new O(y.oldPosition,y.oldText,y.newPosition,C),new O(y.oldEnd,"",y.newPosition+R,u)]}static _splitCurr(y,R){const C=y.oldText.substr(0,R),u=y.oldText.substr(R);return[new O(y.oldPosition,C,y.newPosition,y.newText),new O(y.oldPosition+R,u,y.newEnd,"")]}static _merge(y){if(y.length===0)return y;const R=[];let C=0,u=y[0];for(let E=1;E<y.length;E++){const p=y[E];u.oldEnd===p.oldPosition?u=new O(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(R[C++]=u,u=p)}return R[C++]=u,R}static _removeNoOps(y){if(y.length===0)return y;const R=[];let C=0;for(let u=0;u<y.length;u++){const E=y[u];E.oldText!==E.newText&&(R[C++]=E)}return R}}}),define(Te[143],Ae([1,0,35,19]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.targetsNotebooks=e.score=void 0;function P(T,m,f,y,R,C){if(Array.isArray(T)){let u=0;for(const E of T){const p=P(E,m,f,y,R,C);if(p===10)return p;p>u&&(u=p)}return u}else{if(typeof T=="string")return y?T==="*"?5:T===f?10:0:0;if(T){const{language:u,pattern:E,scheme:p,hasAccessToAllModels:s,notebookType:c}=T;if(!y&&!s)return 0;c&&R&&(m=R);let t=0;if(p)if(p===m.scheme)t=10;else if(p==="*")t=5;else return 0;if(u)if(u===f)t=10;else if(u==="*")t=Math.max(t,5);else return 0;if(c)if(c===C)t=10;else if(c==="*"&&C!==void 0)t=Math.max(t,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,L.normalize)(E.base)},n===m.fsPath||(0,I.match)(n,m.fsPath))t=10;else return 0}return t}else return 0}}e.score=P;function O(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(O):!!T.notebookType}e.targetsNotebooks=O}),define(Te[144],Ae([1,0,5,13,29,92,90,129,142,6]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class R extends y.Disposable{constructor(u,E,p,s,c,t,n){super(),this._onDidChangeContent=this._register(new I.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=E,this._mightContainNonBasicASCII=!t,this._mightContainRTL=s,this._mightContainUnusualLineTerminators=c,this._pieceTree=new T.PieceTreeBase(u,p,n)}equals(u){return!(u instanceof R)||this._BOM!==u._BOM||this.getEOL()!==u.getEOL()?!1:this._pieceTree.equal(u._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(u){return this._pieceTree.createSnapshot(u?this._BOM:"")}getOffsetAt(u,E){return this._pieceTree.getOffsetAt(u,E)}getPositionAt(u){return this._pieceTree.getPositionAt(u)}getRangeAt(u,E){const p=u+E,s=this.getPositionAt(u),c=this.getPositionAt(p);return new P.Range(s.lineNumber,s.column,c.lineNumber,c.column)}getValueInRange(u,E=0){if(u.isEmpty())return"";const p=this._getEndOfLine(E);return this._pieceTree.getValueInRange(u,p)}getValueLengthInRange(u,E=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),s=this.getOffsetAt(u.endLineNumber,u.endColumn);let c=0;const t=this._getEndOfLine(E),n=this.getEOL();if(t.length!==n.length){const r=t.length-n.length,a=u.endLineNumber-u.startLineNumber;c=r*a}return s-p+c}getCharacterCountInRange(u,E=0){if(this._mightContainNonBasicASCII){let p=0;const s=u.startLineNumber,c=u.endLineNumber;for(let t=s;t<=c;t++){const n=this.getLineContent(t),r=t===s?u.startColumn-1:0,a=t===c?u.endColumn-1:n.length;for(let d=r;d<a;d++)L.isHighSurrogate(n.charCodeAt(d))?(p=p+1,d=d+1):p=p+1}return p+=this._getEndOfLine(E).length*(c-s),p}return this.getValueLengthInRange(u,E)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(u){return this._pieceTree.getLineContent(u)}getLineCharCode(u,E){return this._pieceTree.getLineCharCode(u,E)}getCharCode(u){return this._pieceTree.getCharCode(u)}getLineLength(u){return this._pieceTree.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=L.firstNonWhitespaceIndex(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=L.lastNonWhitespaceIndex(this.getLineContent(u));return E===-1?0:E+2}_getEndOfLine(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this._pieceTree.setEOL(u)}applyEdits(u,E,p){let s=this._mightContainRTL,c=this._mightContainUnusualLineTerminators,t=this._mightContainNonBasicASCII,n=!0,r=[];for(let S=0;S<u.length;S++){const w=u[S];n&&w._isTracked&&(n=!1);const g=w.range;if(w.text){let A=!0;t||(A=!L.isBasicASCII(w.text),t=A),!s&&A&&(s=L.containsRTL(w.text)),!c&&A&&(c=L.containsUnusualLineTerminators(w.text))}let D="",h=0,_=0,b=0;if(w.text){let A;[h,_,b,A]=(0,m.countEOL)(w.text);const F=this.getEOL();A===0||A===(F===`\r
`?2:1)?D=w.text:D=w.text.replace(/\r\n|\r|\n/g,F)}r[S]={sortIndex:S,identifier:w.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:h,firstLineLength:_,lastLineLength:b,forceMoveMarkers:!!w.forceMoveMarkers,isAutoWhitespaceEdit:w.isAutoWhitespaceEdit||!1}}r.sort(R._sortOpsAscending);let a=!1;for(let S=0,w=r.length-1;S<w;S++){const g=r[S].range.getEndPosition(),D=r[S+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(r=this._reduceOperations(r));const d=p||E?R._getInverseEditRanges(r):[],i=[];if(E)for(let S=0;S<r.length;S++){const w=r[S],g=d[S];if(w.isAutoWhitespaceEdit&&w.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let h="";D===g.startLineNumber&&(h=this.getLineContent(w.range.startLineNumber),L.firstNonWhitespaceIndex(h)!==-1)||i.push({lineNumber:D,oldContent:h})}}let v=null;if(p){let S=0;v=[];for(let w=0;w<r.length;w++){const g=r[w],D=d[w],h=this.getValueInRange(g.range),_=g.rangeOffset+S;S+=g.text.length-h.length,v[w]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:h,textChange:new f.TextChange(g.rangeOffset,h,_,g.text)}}a||v.sort((w,g)=>w.sortIndex-g.sortIndex)}this._mightContainRTL=s,this._mightContainUnusualLineTerminators=c,this._mightContainNonBasicASCII=t;const l=this._doApplyEdits(r);let o=null;if(E&&i.length>0){i.sort((S,w)=>w.lineNumber-S.lineNumber),o=[];for(let S=0,w=i.length;S<w;S++){const g=i[S].lineNumber;if(S>0&&i[S-1].lineNumber===g)continue;const D=i[S].oldContent,h=this.getLineContent(g);h.length===0||h===D||L.firstNonWhitespaceIndex(h)!==-1||o.push(g)}}return this._onDidChangeContent.fire(),new O.ApplyEditsResult(v,l,o)}_reduceOperations(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const p=u[0].range,s=u[u.length-1].range,c=new P.Range(p.startLineNumber,p.startColumn,s.endLineNumber,s.endColumn);let t=p.startLineNumber,n=p.startColumn;const r=[];for(let l=0,o=u.length;l<o;l++){const S=u[l],w=S.range;E=E||S.forceMoveMarkers,r.push(this.getValueInRange(new P.Range(t,n,w.startLineNumber,w.startColumn))),S.text.length>0&&r.push(S.text),t=w.endLineNumber,n=w.endColumn}const a=r.join(""),[d,i,v]=(0,m.countEOL)(a);return{sortIndex:0,identifier:u[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:a,eolCount:d,firstLineLength:i,lastLineLength:v,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}_doApplyEdits(u){u.sort(R._sortOpsDescending);const E=[];for(let p=0;p<u.length;p++){const s=u[p],c=s.range.startLineNumber,t=s.range.startColumn,n=s.range.endLineNumber,r=s.range.endColumn;if(c===n&&t===r&&s.text.length===0)continue;s.text?(this._pieceTree.delete(s.rangeOffset,s.rangeLength),this._pieceTree.insert(s.rangeOffset,s.text,!0)):this._pieceTree.delete(s.rangeOffset,s.rangeLength);const a=new P.Range(c,t,n,r);E.push({range:a,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,p,s){return this._pieceTree.findMatchesLineByLine(u,E,p,s)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(u,E){const p=u.startLineNumber,s=u.startColumn,[c,t,n]=(0,m.countEOL)(E);let r;if(E.length>0){const a=c+1;a===1?r=new P.Range(p,s,p,s+t):r=new P.Range(p,s,p+a-1,n+1)}else r=new P.Range(p,s,p,s);return r}static _getInverseEditRanges(u){const E=[];let p=0,s=0,c=null;for(let t=0,n=u.length;t<n;t++){const r=u[t];let a,d;c?c.range.endLineNumber===r.range.startLineNumber?(a=p,d=s+(r.range.startColumn-c.range.endColumn)):(a=p+(r.range.startLineNumber-c.range.endLineNumber),d=r.range.startColumn):(a=r.range.startLineNumber,d=r.range.startColumn);let i;if(r.text.length>0){const v=r.eolCount+1;v===1?i=new P.Range(a,d,a,d+r.firstLineLength):i=new P.Range(a,d,a+v-1,r.lastLineLength+1)}else i=new P.Range(a,d,a,d);p=i.endLineNumber,s=i.endColumn,E.push(i),c=r}return E}static _sortOpsAscending(u,E){const p=P.Range.compareRangesUsingEnds(u.range,E.range);return p===0?u.sortIndex-E.sortIndex:p}static _sortOpsDescending(u,E){const p=P.Range.compareRangesUsingEnds(u.range,E.range);return p===0?E.sortIndex-u.sortIndex:-p}}e.PieceTreeTextBuffer=R}),define(Te[145],Ae([1,0,13,90,144]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class O{constructor(f,y,R,C,u,E,p,s,c){this._chunks=f,this._bom=y,this._cr=R,this._lf=C,this._crlf=u,this._containsRTL=E,this._containsUnusualLineTerminators=p,this._isBasicASCII=s,this._normalizeEOL=c}_getEOL(f){const y=this._cr+this._lf+this._crlf,R=this._cr+this._crlf;return y===0?f===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create(f){const y=this._getEOL(f),R=this._chunks;if(this._normalizeEOL&&(y===`\r
`&&(this._cr>0||this._lf>0)||y===`
`&&(this._cr>0||this._crlf>0)))for(let u=0,E=R.length;u<E;u++){const p=R[u].buffer.replace(/\r\n|\r|\n/g,y),s=(0,L.createLineStartsFast)(p);R[u]=new L.StringBuffer(p,s)}const C=new P.PieceTreeTextBuffer(R,this._bom,y,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:C,disposable:C}}getFirstLineText(f){return this._chunks[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class T{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(f){if(f.length===0)return;this.chunks.length===0&&I.startsWithUTF8BOM(f)&&(this.BOM=I.UTF8_BOM_CHARACTER,f=f.substr(1));const y=f.charCodeAt(f.length-1);y===13||y>=55296&&y<=56319?(this._acceptChunk1(f.substr(0,f.length-1),!1),this._hasPreviousChar=!0,this._previousChar=y):(this._acceptChunk1(f,!1),this._hasPreviousChar=!1,this._previousChar=y)}_acceptChunk1(f,y){!y&&f.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+f):this._acceptChunk2(f))}_acceptChunk2(f){const y=(0,L.createLineStarts)(this._tmpLineStarts,f);this.chunks.push(new L.StringBuffer(f,y.lineStarts)),this.cr+=y.cr,this.lf+=y.lf,this.crlf+=y.crlf,y.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=I.containsRTL(f)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=I.containsUnusualLineTerminators(f)))}finish(f=!0){return this._finish(),new O(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,f)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const f=this.chunks[this.chunks.length-1];f.buffer+=String.fromCharCode(this._previousChar);const y=(0,L.createLineStartsFast)(f.buffer);f.lineStarts=y,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=T}),define(Te[95],Ae([1,0,24,21]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(P||(P={}));function O(C){for(let u=0,E=C.length;u<E;u+=4){const p=C[u+0],s=C[u+1],c=C[u+2],t=C[u+3];C[u+0]=t,C[u+1]=c,C[u+2]=s,C[u+3]=p}}function T(C){const u=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return L.isLittleEndian()||O(u),I.VSBuffer.wrap(u)}function m(C){const u=C.buffer;if(L.isLittleEndian()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function f(C){const u=new Uint32Array(y(C));let E=0;if(u[E++]=C.id,C.type==="full")u[E++]=1,u[E++]=C.data.length,u.set(C.data,E),E+=C.data.length;else{u[E++]=2,u[E++]=C.deltas.length;for(const p of C.deltas)u[E++]=p.start,u[E++]=p.deleteCount,p.data?(u[E++]=p.data.length,u.set(p.data,E),E+=p.data.length):u[E++]=0}return T(u)}e.encodeSemanticTokensDto=f;function y(C){let u=0;if(u+=2,C.type==="full")u+=1+C.data.length;else{u+=1,u+=3*C.deltas.length;for(const E of C.deltas)E.data&&(u+=E.data.length)}return u}function R(C){const u=m(C);let E=0;const p=u[E++];if(u[E++]===1){const n=u[E++],r=u.subarray(E,E+n);return E+=n,{id:p,type:"full",data:r}}const c=u[E++],t=[];for(let n=0;n<c;n++){const r=u[E++],a=u[E++],d=u[E++];let i;d>0&&(i=u.subarray(E,E+d),E+=d),t[n]={start:r,deleteCount:a,data:i}}return{id:p,type:"delta",deltas:t}}e.decodeSemanticTokensDto=R}),define(Te[146],Ae([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Te[147],Ae([1,0,18,26,21,130,148,146]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(Q,ve,He,Qe){this.id=Q,this.name=ve,this.defaultValue=He,this.schema=Qe}applyUpdate(Q,ve){return E(Q,ve)}compute(Q,ve,He){return He}}class u{constructor(Q,ve){this.newValue=Q,this.didChange=ve}}e.ApplyUpdateResult=u;function E(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new u(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const He=Array.isArray(Y)&&Array.isArray(Q)&&I.equals(Y,Q);return new u(Q,!He)}let ve=!1;for(const He in Q)if(Q.hasOwnProperty(He)){const Qe=E(Y[He],Q[He]);Qe.didChange&&(Y[He]=Qe.newValue,ve=!0)}return new u(Y,ve)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ve){return E(Q,ve)}validate(Q){return this.defaultValue}}class s{constructor(Q,ve,He,Qe){this.id=Q,this.name=ve,this.defaultValue=He,this.schema=Qe}applyUpdate(Q,ve){return E(Q,ve)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ve,He){return He}}function c(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=c;class t extends s{constructor(Q,ve,He,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=He),super(Q,ve,He,Qe)}validate(Q){return c(Q,this.defaultValue)}}function n(Y,Q,ve,He){if(typeof Y>"u")return Q;let Qe=parseInt(Y,10);return isNaN(Qe)?Q:(Qe=Math.max(ve,Qe),Qe=Math.min(He,Qe),Qe|0)}e.clampedInt=n;class r extends s{static clampedInt(Q,ve,He,Qe){return n(Q,ve,He,Qe)}constructor(Q,ve,He,Qe,st,Oe=void 0){typeof Oe<"u"&&(Oe.type="integer",Oe.default=He,Oe.minimum=Qe,Oe.maximum=st),super(Q,ve,He,Oe),this.minimum=Qe,this.maximum=st}validate(Q){return r.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function a(Y,Q,ve,He){if(typeof Y>"u")return Q;const Qe=d.float(Y,Q);return d.clamp(Qe,ve,He)}e.clampedFloat=a;class d extends s{static clamp(Q,ve,He){return Q<ve?ve:Q>He?He:Q}static float(Q,ve){if(typeof Q=="number")return Q;if(typeof Q>"u")return ve;const He=parseFloat(Q);return isNaN(He)?ve:He}constructor(Q,ve,He,Qe,st){typeof st<"u"&&(st.type="number",st.default=He),super(Q,ve,He,st),this.validationFn=Qe}validate(Q){return this.validationFn(d.float(Q,this.defaultValue))}}class i extends s{static string(Q,ve){return typeof Q!="string"?ve:Q}constructor(Q,ve,He,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=He),super(Q,ve,He,Qe)}validate(Q){return i.string(Q,this.defaultValue)}}function v(Y,Q,ve,He){return typeof Y!="string"?Q:He&&Y in He?He[Y]:ve.indexOf(Y)===-1?Q:Y}e.stringSet=v;class l extends s{constructor(Q,ve,He,Qe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Qe,st.default=He),super(Q,ve,He,st),this._allowedValues=Qe}validate(Q){return v(Q,this.defaultValue,this._allowedValues)}}class o extends C{constructor(Q,ve,He,Qe,st,Oe,yt=void 0){typeof yt<"u"&&(yt.type="string",yt.enum=st,yt.default=Qe),super(Q,ve,He,yt),this._allowedValues=st,this._convert=Oe}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function S(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ve,He){return He===0?Q.accessibilitySupport:He}}class g extends C{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{insertSpace:c(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function h(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var _;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(_||(e.TextEditorCursorStyle=_={}));function b(Y){switch(Y){case _.Line:return"line";case _.Block:return"block";case _.Underline:return"underline";case _.LineThin:return"line-thin";case _.BlockOutline:return"block-outline";case _.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function A(Y){switch(Y){case"line":return _.Line;case"block":return _.Block;case"underline":return _.Underline;case"line-thin":return _.LineThin;case"block-outline":return _.BlockOutline;case"underline-thin":return _.UnderlineThin}}class F extends p{constructor(){super(141)}compute(Q,ve,He){const Qe=["monaco-editor"];return ve.get(39)&&Qe.push(ve.get(39)),Q.extraEditorClassName&&Qe.push(Q.extraEditorClassName),ve.get(74)==="default"?Qe.push("mouse-default"):ve.get(74)==="copy"&&Qe.push("mouse-copy"),ve.get(111)&&Qe.push("showUnused"),ve.get(139)&&Qe.push("showDeprecated"),Qe.join(" ")}}class j extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Q,ve,He){return He&&Q.emptySelectionClipboard}}class H extends C{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:m.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:m.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{cursorMoveOnType:c(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":v(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":v(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ve.loop,this.defaultValue.loop)}}}class B extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?B.OFF:Q==="true"?B.ON:Q:Q?B.ON:B.OFF}}e.EditorFontLigatures=B;class k extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",k.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?k.OFF:Q==="true"?k.TRANSLATE:Q:Q?k.TRANSLATE:k.OFF}compute(Q,ve,He){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=k;class N extends p{constructor(){super(50)}compute(Q,ve,He){return Q.fontInfo}}class $ extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Q){const ve=d.float(Q,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ve,6,100)}compute(Q,ve,He){return Q.fontInfo.fontSize}}class re extends C{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.MINIMUM_VALUE,maximum:re.MAXIMUM_VALUE,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(r.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,re.MINIMUM_VALUE,re.MAXIMUM_VALUE))}}class le extends C{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:He,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:He,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:He,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:He,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:He,description:m.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{multiple:v(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??v(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??v(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??v(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??v(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??v(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _e extends C{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:m.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:c(ve.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(ve.above,this.defaultValue.above)}}}var ye;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class de extends p{constructor(){super(144)}compute(Q,ve,He){return de.computeLayout(ve,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const ve=Q.height/Q.lineHeight,He=Math.floor(Q.paddingTop/Q.lineHeight);let Qe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Qe=Math.max(Qe,ve-1));const st=(He+Q.viewLineCount+Qe)/(Q.pixelRatio*Q.height),Oe=Math.floor(Q.viewLineCount/st);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Qe,desiredRatio:st,minimapLineCount:Oe}}static _computeMinimapLayout(Q,ve){const He=Q.outerWidth,Qe=Q.outerHeight,st=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const Oe=ve.stableMinimapLayoutInput,yt=Oe&&Q.outerHeight===Oe.outerHeight&&Q.lineHeight===Oe.lineHeight&&Q.typicalHalfwidthCharacterWidth===Oe.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Oe.pixelRatio&&Q.scrollBeyondLastLine===Oe.scrollBeyondLastLine&&Q.paddingTop===Oe.paddingTop&&Q.paddingBottom===Oe.paddingBottom&&Q.minimap.enabled===Oe.minimap.enabled&&Q.minimap.side===Oe.minimap.side&&Q.minimap.size===Oe.minimap.size&&Q.minimap.showSlider===Oe.minimap.showSlider&&Q.minimap.renderCharacters===Oe.minimap.renderCharacters&&Q.minimap.maxColumn===Oe.minimap.maxColumn&&Q.minimap.scale===Oe.minimap.scale&&Q.verticalScrollbarWidth===Oe.verticalScrollbarWidth&&Q.isViewportWrapping===Oe.isViewportWrapping,Wt=Q.lineHeight,Ft=Q.typicalHalfwidthCharacterWidth,Xt=Q.scrollBeyondLastLine,Qt=Q.minimap.renderCharacters;let Dt=st>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const qt=Q.minimap.maxColumn,jt=Q.minimap.size,Jt=Q.minimap.side,ii=Q.verticalScrollbarWidth,Ye=Q.viewLineCount,Mt=Q.remainingWidth,Zt=Q.isViewportWrapping,ft=Qt?2:3;let Et=Math.floor(st*Qe);const ei=Et/st;let zt=!1,Ut=!1,ht=ft*Dt,Tt=Dt/st,ti=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:kt,extraLinesBeyondLastLine:Bt,desiredRatio:ri,minimapLineCount:Nt}=de.computeContainedMinimapLineCount({viewLineCount:Ye,scrollBeyondLastLine:Xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Qe,lineHeight:Wt,pixelRatio:st});if(Ye/Nt>1)zt=!0,Ut=!0,Dt=1,ht=1,Tt=Dt/st;else{let Pt=!1,Ct=Dt+1;if(jt==="fit"){const pt=Math.ceil((kt+Ye+Bt)*ht);Zt&&yt&&Mt<=ve.stableFitRemainingWidth?(Pt=!0,Ct=ve.stableFitMaxMinimapScale):Pt=pt>Et}if(jt==="fill"||Pt){zt=!0;const pt=Dt;ht=Math.min(Wt*st,Math.max(1,Math.floor(1/ri))),Zt&&yt&&Mt<=ve.stableFitRemainingWidth&&(Ct=ve.stableFitMaxMinimapScale),Dt=Math.min(Ct,Math.max(1,Math.floor(ht/ft))),Dt>pt&&(ti=Math.min(2,Dt/pt)),Tt=Dt/st/ti,Et=Math.ceil(Math.max(Ot,kt+Ye+Bt)*ht),Zt?(ve.stableMinimapLayoutInput=Q,ve.stableFitRemainingWidth=Mt,ve.stableFitMaxMinimapScale=Dt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Yt=Math.floor(qt*Tt),qe=Math.min(Yt,Math.max(0,Math.floor((Mt-ii-2)*Tt/(Ft+Tt)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(st*qe);const xt=Lt/st;Lt=Math.floor(Lt*ti);const ni=Qt?1:2,mt=Jt==="left"?0:He-qe-ii;return{renderMinimap:ni,minimapLeft:mt,minimapWidth:qe,minimapHeightIsEditorHeight:zt,minimapIsSampling:Ut,minimapScale:Dt,minimapLineHeight:ht,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:Et,minimapCanvasOuterWidth:xt,minimapCanvasOuterHeight:ei}}static computeLayout(Q,ve){const He=ve.outerWidth|0,Qe=ve.outerHeight|0,st=ve.lineHeight|0,Oe=ve.lineNumbersDigitCount|0,yt=ve.typicalHalfwidthCharacterWidth,Wt=ve.maxDigitWidth,Ft=ve.pixelRatio,Xt=ve.viewLineCount,Qt=Q.get(136),Dt=Qt==="inherit"?Q.get(135):Qt,qt=Dt==="inherit"?Q.get(131):Dt,jt=Q.get(134),Jt=ve.isDominatedByLongLines,ii=Q.get(57),Ye=Q.get(68).renderType!==0,Mt=Q.get(69),Zt=Q.get(105),ft=Q.get(84),Et=Q.get(73),ei=Q.get(103),zt=ei.verticalScrollbarSize,Ut=ei.verticalHasArrows,ht=ei.arrowSize,Tt=ei.horizontalScrollbarSize,ti=Q.get(43),Yt=Q.get(110)!=="never";let qe=Q.get(66);ti&&Yt&&(qe+=16);let Lt=0;if(Ye){const wt=Math.max(Oe,Mt);Lt=Math.round(wt*Wt)}let xt=0;ii&&(xt=st*ve.glyphMarginDecorationLaneCount);let ni=0,mt=ni+xt,Ot=mt+Lt,kt=Ot+qe;const Bt=He-xt-Lt-qe;let ri=!1,Nt=!1,$t=-1;Dt==="inherit"&&Jt?(ri=!0,Nt=!0):qt==="on"||qt==="bounded"?Nt=!0:qt==="wordWrapColumn"&&($t=jt);const Pt=de._computeMinimapLayout({outerWidth:He,outerHeight:Qe,lineHeight:st,typicalHalfwidthCharacterWidth:yt,pixelRatio:Ft,scrollBeyondLastLine:Zt,paddingTop:ft.top,paddingBottom:ft.bottom,minimap:Et,verticalScrollbarWidth:zt,viewLineCount:Xt,remainingWidth:Bt,isViewportWrapping:Nt},ve.memory||new R);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(ni+=Pt.minimapWidth,mt+=Pt.minimapWidth,Ot+=Pt.minimapWidth,kt+=Pt.minimapWidth);const Ct=Bt-Pt.minimapWidth,pt=Math.max(1,Math.floor((Ct-zt-2)/yt)),It=Ut?ht:0;return Nt&&($t=Math.max(1,pt),qt==="bounded"&&($t=Math.min($t,jt))),{width:He,height:Qe,glyphMarginLeft:ni,glyphMarginWidth:xt,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Lt,decorationsLeft:Ot,decorationsWidth:qe,contentLeft:kt,contentWidth:Ct,minimap:Pt,viewportColumn:pt,isWordWrapMinified:ri,isViewportWrapping:Nt,wrappingColumn:$t,verticalScrollbarWidth:zt,horizontalScrollbarHeight:Tt,overviewRuler:{top:It,width:zt,height:Qe-2*It,right:0}}}}e.EditorLayoutInfoComputer=de;class Ee extends C{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Q){return v(Q,"simple",["simple","advanced"])}compute(Q,ve,He){return ve.get(2)===2?"advanced":He}}var se;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class pe extends C{constructor(){const Q={enabled:se.OnCode};super(65,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:Q.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:v(Q.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class ee extends C{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:m.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class X extends C{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:m.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:v(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:c(ve.padding,this.defaultValue.padding)}}}class V extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):r.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ve,He){return He<0?r.clampedInt(-He*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class ne extends d{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>d.clamp(Q,0,150),{markdownDescription:m.localize(66,null)})}compute(Q,ve,He){return Q.fontInfo.lineHeight}}class Ie extends C{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Q.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:m.localize(77,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),autohide:c(ve.autohide,this.defaultValue.autohide),size:v(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(ve.side,this.defaultValue.side,["right","left"]),showSlider:v(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Fe(Y){return Y==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class we extends C{constructor(){const Q={enabled:!0,cycle:!0};super(86,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:m.localize(81,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),cycle:c(ve.cycle,this.defaultValue.cycle)}}}class me extends p{constructor(){super(142)}compute(Q,ve,He){return Q.pixelRatio}}class K extends C{constructor(){const Q={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Q.strings,description:m.localize(85,null)},comments:{anyOf:ve,default:Q.comments,description:m.localize(86,null)},other:{anyOf:ve,default:Q.other,description:m.localize(87,null)}},default:Q,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ft=Q?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ve,comments:He,strings:Qe}=Q,st=["on","inline","off"];let Oe,yt,Wt;return typeof ve=="boolean"?Oe=ve?"on":"off":Oe=v(ve,this.defaultValue.other,st),typeof He=="boolean"?yt=He?"on":"off":yt=v(He,this.defaultValue.comments,st),typeof Qe=="boolean"?Wt=Qe?"on":"off":Wt=v(Qe,this.defaultValue.strings,st),{other:Oe,comments:yt,strings:Wt}}}var J;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(J||(e.RenderLineNumbersType=J={}));class ue extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(Q){let ve=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ve=4,He=Q):Q==="interval"?ve=3:Q==="relative"?ve=2:Q==="on"?ve=1:ve=0),{renderType:ve,renderFn:He}}}function he(Y){const Q=Y.get(98);return Q==="editable"?Y.get(91):Q!=="on"}e.filterValidationDecorations=he;class Pe extends C{constructor(){const Q=[],ve={type:"number",description:m.localize(94,null)};super(102,"rulers",Q,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:Q,description:m.localize(96,null)})}validate(Q){if(Array.isArray(Q)){const ve=[];for(const He of Q)if(typeof He=="number")ve.push({column:r.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Qe=He;ve.push({column:r.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return ve.sort((He,Qe)=>He.column-Qe.column),ve}return this.defaultValue}}class ge extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function De(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends C{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q,He=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(ve.vertical,this.defaultValue.vertical),horizontal:De(ve.horizontal,this.defaultValue.horizontal),useShadows:c(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,Qe,0,1e3),scrollByPage:c(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class xe extends C{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:m.localize(115,null)}})}applyUpdate(Q,ve){let He=!1;ve.allowedCharacters&&Q&&(L.equals(Q.allowedCharacters,ve.allowedCharacters)||(Q={...Q,allowedCharacters:ve.allowedCharacters},He=!0)),ve.allowedLocales&&Q&&(L.equals(Q.allowedLocales,ve.allowedLocales)||(Q={...Q,allowedLocales:ve.allowedLocales},He=!0));const Qe=super.applyUpdate(Q,ve);return He?new u(Qe.newValue,!0):Qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{nonBasicASCII:te(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,ve){if(typeof Q!="object"||!Q)return ve;const He={};for(const[Qe,st]of Object.entries(Q))st===!0&&(He[Qe]=!0);return He}}class M extends C{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:m.localize(122,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),mode:v(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:c(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(ve.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class x extends C{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:m.localize(129,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),showToolbar:v(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),keepOnBlur:c(ve.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:c(ve.backgroundColoring,this.defaultValue.backgroundColoring)}}}class q extends C{constructor(){const Q={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class W extends C{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:Q.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:Q.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Q.highlightActiveIndentation,description:m.localize(145,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{bracketPairs:te(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:te(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(Y,Q,ve){const He=ve.indexOf(Y);return He===-1?Q:ve[He]}class oe extends C{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:Q.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:Q.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{insertMode:v(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(ve.showIcons,this.defaultValue.showIcons),showStatusBar:c(ve.showStatusBar,this.defaultValue.showStatusBar),preview:c(ve.preview,this.defaultValue.preview),previewMode:v(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ve.showMethods,this.defaultValue.showMethods),showFunctions:c(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(ve.showFields,this.defaultValue.showFields),showVariables:c(ve.showVariables,this.defaultValue.showVariables),showClasses:c(ve.showClasses,this.defaultValue.showClasses),showStructs:c(ve.showStructs,this.defaultValue.showStructs),showInterfaces:c(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ve.showModules,this.defaultValue.showModules),showProperties:c(ve.showProperties,this.defaultValue.showProperties),showEvents:c(ve.showEvents,this.defaultValue.showEvents),showOperators:c(ve.showOperators,this.defaultValue.showOperators),showUnits:c(ve.showUnits,this.defaultValue.showUnits),showValues:c(ve.showValues,this.defaultValue.showValues),showConstants:c(ve.showConstants,this.defaultValue.showConstants),showEnums:c(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ve.showKeywords,this.defaultValue.showKeywords),showWords:c(ve.showWords,this.defaultValue.showWords),showColors:c(ve.showColors,this.defaultValue.showColors),showFiles:c(ve.showFiles,this.defaultValue.showFiles),showReferences:c(ve.showReferences,this.defaultValue.showReferences),showFolders:c(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ve.showSnippets,this.defaultValue.showSnippets),showUsers:c(ve.showUsers,this.defaultValue.showUsers),showIssues:c(ve.showIssues,this.defaultValue.showIssues)}}}class Ne extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var $e;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})($e||(e.WrappingIndent=$e={}));class We extends C{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(196,null),m.localize(197,null),m.localize(198,null),m.localize(199,null)],description:m.localize(200,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ve,He){return ve.get(2)===2?0:He}}class Je extends p{constructor(){super(145)}compute(Q,ve,He){const Qe=ve.get(144);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class tt extends C{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(203,null),m.localize(204,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),showDropSelector:v(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends C{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(207,null),m.localize(208,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:c(ve.enabled,this.defaultValue.enabled),showPasteSelector:v(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?it:P.isLinux?ot:rt,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var et;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSeparators=130]="wordSeparators",Y[Y.wordWrap=131]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=134]="wordWrapColumn",Y[Y.wordWrapOverride1=135]="wordWrapOverride1",Y[Y.wordWrapOverride2=136]="wordWrapOverride2",Y[Y.wrappingIndent=137]="wrappingIndent",Y[Y.wrappingStrategy=138]="wrappingStrategy",Y[Y.showDeprecated=139]="showDeprecated",Y[Y.inlayHints=140]="inlayHints",Y[Y.editorClassName=141]="editorClassName",Y[Y.pixelRatio=142]="pixelRatio",Y[Y.tabFocusMode=143]="tabFocusMode",Y[Y.layoutInfo=144]="layoutInfo",Y[Y.wrappingInfo=145]="wrappingInfo",Y[Y.defaultColorDecorators=146]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(209,null)})),acceptSuggestionOnEnter:ze(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(210,null),""],markdownDescription:m.localize(211,null)})),accessibilitySupport:ze(new w),accessibilityPageSize:ze(new r(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(212,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",m.localize(213,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:ze(new l(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),""],description:m.localize(217,null)})),autoClosingComments:ze(new l(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoClosingDelete:ze(new l(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(221,null),""],description:m.localize(222,null)})),autoClosingOvertype:ze(new l(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingQuotes:ze(new l(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(225,null),m.localize(226,null),""],description:m.localize(227,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new l(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),""],description:m.localize(237,null)})),bracketPairColorization:ze(new q),bracketPairGuides:ze(new W),stickyTabStops:ze(new t(116,"stickyTabStops",!1,{description:m.localize(238,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:m.localize(239,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:m.localize(240,null)})),codeLensFontSize:ze(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(241,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:m.localize(242,null)})),colorDecoratorActivatedOn:ze(new l(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),colorDecoratorsLimit:ze(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(247,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:m.localize(248,null)})),comments:ze(new g),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(249,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:m.localize(250,null)})),cursorSmoothCaretAnimation:ze(new l(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),cursorStyle:ze(new o(28,"cursorStyle",_.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:m.localize(255,null)})),cursorSurroundingLines:ze(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(256,null)})),cursorSurroundingLinesStyle:ze(new l(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],markdownDescription:m.localize(259,null)})),cursorWidth:ze(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(260,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:m.localize(261,null)})),emptySelectionClipboard:ze(new j),dropIntoEditor:ze(new tt),stickyScroll:ze(new ee),experimentalWhitespaceRendering:ze(new l(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new d(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:m.localize(266,null)})),find:ze(new H),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:m.localize(267,null)})),foldingStrategy:ze(new l(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:m.localize(271,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:m.localize(272,null)})),foldingMaximumRegions:ze(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(273,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(274,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(275,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new $),fontWeight:ze(new re),fontVariations:ze(new k),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:m.localize(276,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:m.localize(277,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:m.localize(278,null)})),gotoLocation:ze(new le),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:m.localize(279,null)})),hover:ze(new _e),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new d(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>d.clamp(Y,-5,20),{description:m.localize(280,null)})),lightbulb:ze(new pe),lineDecorationsWidth:ze(new V),lineHeight:ze(new ne),lineNumbers:ze(new ue),lineNumbersMinChars:ze(new r(69,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(70,"linkedEditing",!1,{description:m.localize(281,null)})),links:ze(new t(71,"links",!0,{description:m.localize(282,null)})),matchBrackets:ze(new l(72,"matchBrackets","always",["always","near","never"],{description:m.localize(283,null)})),minimap:ze(new Ie),mouseStyle:ze(new l(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new d(75,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:m.localize(284,null)})),mouseWheelZoom:ze(new t(76,"mouseWheelZoom",!1,{markdownDescription:P.isMacintosh?m.localize(285,null):m.localize(286,null)})),multiCursorMergeOverlapping:ze(new t(77,"multiCursorMergeOverlapping",!0,{description:m.localize(287,null)})),multiCursorModifier:ze(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),multiCursorPaste:ze(new l(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(291,null),m.localize(292,null)],markdownDescription:m.localize(293,null)})),multiCursorLimit:ze(new r(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(294,null)})),occurrencesHighlight:ze(new l(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(295,null),m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),overviewRulerBorder:ze(new t(82,"overviewRulerBorder",!0,{description:m.localize(299,null)})),overviewRulerLanes:ze(new r(83,"overviewRulerLanes",3,0,3)),padding:ze(new ke),pasteAs:ze(new ut),parameterHints:ze(new we),peekWidgetDefaultFocus:ze(new l(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(300,null),m.localize(301,null)],description:m.localize(302,null)})),definitionLinkOpensInPeek:ze(new t(88,"definitionLinkOpensInPeek",!1,{description:m.localize(303,null)})),quickSuggestions:ze(new K),quickSuggestionsDelay:ze(new r(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(304,null)})),readOnly:ze(new t(91,"readOnly",!1)),readOnlyMessage:ze(new ge),renameOnType:ze(new t(93,"renameOnType",!1,{description:m.localize(305,null),markdownDeprecationMessage:m.localize(306,null)})),renderControlCharacters:ze(new t(94,"renderControlCharacters",!0,{description:m.localize(307,null),restricted:!0})),renderFinalNewline:ze(new l(95,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:m.localize(308,null)})),renderLineHighlight:ze(new l(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(309,null)],description:m.localize(310,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(311,null)})),renderValidationDecorations:ze(new l(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new l(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(312,null),m.localize(313,null),m.localize(314,null),""],description:m.localize(315,null)})),revealHorizontalRightPadding:ze(new r(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(101,"roundedSelection",!0,{description:m.localize(316,null)})),rulers:ze(new Pe),scrollbar:ze(new Re),scrollBeyondLastColumn:ze(new r(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(317,null)})),scrollBeyondLastLine:ze(new t(105,"scrollBeyondLastLine",!0,{description:m.localize(318,null)})),scrollPredominantAxis:ze(new t(106,"scrollPredominantAxis",!0,{description:m.localize(319,null)})),selectionClipboard:ze(new t(107,"selectionClipboard",!0,{description:m.localize(320,null),included:P.isLinux})),selectionHighlight:ze(new t(108,"selectionHighlight",!0,{description:m.localize(321,null)})),selectOnLineNumbers:ze(new t(109,"selectOnLineNumbers",!0)),showFoldingControls:ze(new l(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),showUnused:ze(new t(111,"showUnused",!0,{description:m.localize(326,null)})),showDeprecated:ze(new t(139,"showDeprecated",!0,{description:m.localize(327,null)})),inlayHints:ze(new X),snippetSuggestions:ze(new l(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(328,null),m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new t(114,"smoothScrolling",!1,{description:m.localize(333,null)})),stopRenderingLineAfter:ze(new r(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new oe),inlineSuggest:ze(new M),inlineEdit:ze(new x),inlineCompletionsAccessibilityVerbose:ze(new t(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(334,null)})),suggestFontSize:ze(new r(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new r(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(121,"suggestOnTriggerCharacters",!0,{description:m.localize(337,null)})),suggestSelection:ze(new l(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),tabCompletion:ze(new l(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(342,null),m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),tabIndex:ze(new r(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new xe),unusualLineTerminators:ze(new l(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(346,null),m.localize(347,null),m.localize(348,null)],description:m.localize(349,null)})),useShadowDOM:ze(new t(127,"useShadowDOM",!0)),useTabStops:ze(new t(128,"useTabStops",!0,{description:m.localize(350,null)})),wordBreak:ze(new l(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(351,null),m.localize(352,null)],description:m.localize(353,null)})),wordSeparators:ze(new i(130,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:m.localize(354,null)})),wordWrap:ze(new l(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(355,null),m.localize(356,null),m.localize(357,null),m.localize(358,null)],description:m.localize(359,null)})),wordWrapBreakAfterCharacters:ze(new i(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new r(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(360,null)})),wordWrapOverride1:ze(new l(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new l(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new F),defaultColorDecorators:ze(new t(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(361,null)})),pixelRatio:ze(new me),tabFocusMode:ze(new t(143,"tabFocusMode",!1,{markdownDescription:m.localize(362,null)})),layoutInfo:ze(new de),wrappingInfo:ze(new Je),wrappingIndent:ze(new We),wrappingStrategy:ze(new Ee)}}),define(Te[149],Ae([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Te[150],Ae([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Te[151],Ae([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Te[152],Ae([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Te[153],Ae([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Te[154],Ae([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Te[155],Ae([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Te[156],Ae([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Te[157],Ae([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Te[158],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Te[159],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Te[160],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Te[161],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Te[162],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Te[163],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Te[164],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Te[165],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Te[166],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Te[167],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Te[168],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Te[169],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Te[170],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Te[171],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Te[172],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Te[173],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Te[174],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Te[175],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Te[176],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Te[177],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Te[178],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Te[179],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Te[180],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Te[181],Ae([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Te[182],Ae([1,0,15,151]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var P;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(P||(e.TokenType=P={}));function O(...y){switch(y.length){case 1:return(0,L.localize)(0,null,y[0]);case 2:return(0,L.localize)(1,null,y[0],y[1]);case 3:return(0,L.localize)(2,null,y[0],y[1],y[2]);default:return}}const T=(0,L.localize)(3,null),m=(0,L.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(R){return this._input=R,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const C=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:C})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const C=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:C})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(R){return this._isAtEnd()||this._input.charCodeAt(this._current)!==R?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(R){this._tokens.push({type:R,offset:this._start})}_error(R){const C=this._start,u=this._input.substring(this._start,this._current),E={type:19,offset:this._start,lexeme:u};this._errors.push({offset:C,lexeme:u,additionalInfo:R}),this._tokens.push(E)}_string(){this.stringRe.lastIndex=this._start;const R=this.stringRe.exec(this._input);if(R){this._current=this._start+R[0].length;const C=this._input.substring(this._start,this._current),u=f._keywords.get(C);u?this._addToken(u):this._tokens.push({type:17,lexeme:C,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let R=this._current,C=!1,u=!1;for(;;){if(R>=this._input.length){this._current=R,this._error(m);return}const p=this._input.charCodeAt(R);if(C)C=!1;else if(p===47&&!u){R++;break}else p===91?u=!0:p===92?C=!0:p===93&&(u=!1);R++}for(;R<this._input.length&&f._regexFlags.has(this._input.charCodeAt(R));)R++;this._current=R;const E=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:E,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(Te[183],Ae([1,0,25,32,153,297]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(t){return t=t.trim(),t==="*"||T.test(t)}e.isValidVersionStr=f;function y(t){if(!f(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(T);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.parseVersion=y;function R(t){if(!t)return null;const n=t.majorBase,r=t.majorMustEqual,a=t.minorBase;let d=t.minorMustEqual;const i=t.patchBase;let v=t.patchMustEqual;t.hasCaret&&(n===0||(d=!1),v=!1);let l=0;if(t.preRelease){const o=m.exec(t.preRelease);if(o){const[,S,w,g]=o;l=Date.UTC(Number(S),Number(w)-1,Number(g))}}return{majorBase:n,majorMustEqual:r,minorBase:a,minorMustEqual:d,patchBase:i,patchMustEqual:v,isMinimum:t.hasGreaterEquals,notBefore:l}}e.normalizeVersion=R;function C(t,n,r){let a;typeof t=="string"?a=R(y(t)):a=t;let d;n instanceof Date?d=n.getTime():typeof n=="string"&&(d=new Date(n).getTime());let i;if(typeof r=="string"?i=R(y(r)):i=r,!a||!i)return!1;const v=a.majorBase,l=a.minorBase,o=a.patchBase;let S=i.majorBase,w=i.minorBase,g=i.patchBase;const D=i.notBefore;let h=i.majorMustEqual,_=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?v>S?!0:v<S?!1:l>w?!0:l<w||d&&d<D?!1:o>=g:(v===1&&S===0&&(!h||!_||!b)&&(S=1,w=0,g=0,h=!0,_=!1,b=!1),v<S?!1:v>S?!h:l<w?!1:l>w?!_:o<g?!1:o>g?!b:!(d&&d<D))}e.isValidVersion=C;function u(t,n,r,a,d){const i=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return i.push([L.default.Error,P.localize(0,null)]),i;if(typeof a.name!="string")return i.push([L.default.Error,P.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([L.default.Error,P.localize(2,null,"version")]),i;if(!a.engines)return i.push([L.default.Error,P.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([L.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies<"u"&&!c(a.extensionDependencies))return i.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents<"u"){if(!c(a.activationEvents))return i.push([L.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof a.main>"u"&&typeof a.browser>"u")return i.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&i.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return i.push([L.default.Error,P.localize(9,null,"main")]),i;{const o=(0,I.joinPath)(r,a.main);(0,I.isEqualOrParent)(o,r)||i.push([L.default.Warning,P.localize(10,null,o.path,r.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return i.push([L.default.Error,P.localize(11,null,"browser")]),i;{const o=(0,I.joinPath)(r,a.browser);(0,I.isEqualOrParent)(o,r)||i.push([L.default.Warning,P.localize(12,null,o.path,r.path)])}}if(!O.valid(a.version))return i.push([L.default.Error,P.localize(13,null)]),i;const v=[];if(!E(t,n,a,d,v))for(const o of v)i.push([L.default.Error,o]);return i}e.validateExtensionManifest=u;function E(t,n,r,a,d){return a||typeof r.main>"u"&&typeof r.browser>"u"?!0:s(t,n,r.engines.vscode,d)}e.isValidExtensionVersion=E;function p(t,n,r){return t==="*"||s(n,r,t)}e.isEngineValid=p;function s(t,n,r,a=[]){const d=R(y(r));if(!d)return a.push(P.localize(14,null,r)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return a.push(P.localize(15,null,r)),!1}else if(!d.majorMustEqual)return a.push(P.localize(16,null,r)),!1;return C(t,n,d)?!0:(a.push(P.localize(17,null,t,r)),!1)}function c(t){if(!Array.isArray(t))return!1;for(let n=0,r=t.length;n<r;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Te[70],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(P,O=[],T=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=I}),define(Te[54],Ae([1,0,70]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(m,f,y){f instanceof I.SyncDescriptor||(f=new I.SyncDescriptor(f,[],!!y)),L.push([m,f])}e.registerSingleton=O;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Te[184],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const T of this._nodes.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const m=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(T);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(O){const T=this._hashFn(O);this._nodes.delete(T);for(const m of this._nodes.values())m.outgoing.delete(T),m.incoming.delete(T)}lookupOrInsertNode(O){const T=this._hashFn(O);let m=this._nodes.get(T);return m||(m=new I(T,O),this._nodes.set(T,m)),m}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[T,m]of this._nodes)O.push(`${T}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this._nodes){const m=new Set([O]),f=this._findCycle(T,m);if(f)return f}}_findCycle(O,T){for(const[m,f]of O.outgoing){if(T.has(m))return[...T,m].join(" -> ");T.add(m);const y=this._findCycle(f,T);if(y)return y;T.delete(m)}}}e.Graph=L}),define(Te[4],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=m})(I||(e._util=I={})),e.IInstantiationService=P("instantiationService");function L(T,m,f){m[I.DI_TARGET]===m?m[I.DI_DEPENDENCIES].push({id:T,index:f}):(m[I.DI_DEPENDENCIES]=[{id:T,index:f}],m[I.DI_TARGET]=m)}function P(T){if(I.serviceIds.has(T))return I.serviceIds.get(T);const m=function(f,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,f,R)};return m.toString=()=>T,I.serviceIds.set(T,m),m}e.createDecorator=P;function O(T){return T}e.refineServiceDecorator=O}),define(Te[46],Ae([1,0,16,2,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function O(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof L.URI)}e.isConfigurationOverrides=O;function T(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=T;var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function y(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.isConfigured=y;function R(t,n){const r=Object.create(null);for(const a in t)C(r,a,t[a],n);return r}e.toValuesTree=R;function C(t,n,r,a){const d=n.split("."),i=d.pop();let v=t;for(let l=0;l<d.length;l++){const o=d[l];let S=v[o];switch(typeof S){case"undefined":S=v[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${d.slice(0,l+1).join(".")} is ${JSON.stringify(S)}`);return}v=S}if(typeof v=="object"&&v!==null)try{v[i]=r}catch{a(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=C;function u(t,n){const r=n.split(".");E(t,r)}e.removeFromValueTree=u;function E(t,n){const r=n.shift();if(n.length===0){delete t[r];return}if(Object.keys(t).indexOf(r)!==-1){const a=t[r];typeof a=="object"&&!Array.isArray(a)&&(E(a,n),Object.keys(a).length===0&&delete t[r])}}function p(t,n,r){function a(v,l){let o=v;for(const S of l){if(typeof o!="object"||o===null)return;o=o[S]}return o}const d=n.split("."),i=a(t,d);return typeof i>"u"?r:i}e.getConfigurationValue=p;function s(t,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in t?I.isObject(t[a])&&I.isObject(n[a])?s(t[a],n[a],r):r&&(t[a]=n[a]):t[a]=n[a])})}e.merge=s;function c(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(Te[36],Ae([1,0,21,13,182,4,150,15]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",I.isMacintosh),f.set("isLinux",I.isLinux),f.set("isWindows",I.isWindows),f.set("isWeb",I.isWeb),f.set("isMacNative",I.isMacintosh&&!I.isWeb),f.set("isEdge",I.isEdge),f.set("isFirefox",I.isFirefox),f.set("isChrome",I.isChrome),f.set("isSafari",I.isSafari);function y(X,V){if(f.get(X)!==void 0)throw(0,m.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(X,V)}e.setConstant=y;const R=Object.prototype.hasOwnProperty;var C;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const u={regexParsingWithErrorRecovery:!0},E=(0,T.localize)(0,null),p=(0,T.localize)(1,null),s=(0,T.localize)(2,null),c=(0,T.localize)(3,null),t=(0,T.localize)(4,null),n=(0,T.localize)(5,null),r=(0,T.localize)(6,null),a=(0,T.localize)(7,null);class d{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(V=u){this._config=V,this._scanner=new P.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(V){if(V===""){this._parsingErrors.push({message:E,offset:0,lexeme:"",additionalInfo:p});return}this._tokens=this._scanner.reset(V).scan(),this._current=0,this._parsingErrors=[];try{const ne=this._expr();if(!this._isAtEnd()){const Ie=this._peek(),Fe=Ie.type===17?n:void 0;throw this._parsingErrors.push({message:t,offset:Ie.offset,lexeme:P.Scanner.getLexeme(Ie),additionalInfo:Fe}),d._parseError}return ne}catch(ne){if(ne!==d._parseError)throw ne;return}}_expr(){return this._or()}_or(){const V=[this._and()];for(;this._matchOne(16);){const ne=this._and();V.push(ne)}return V.length===1?V[0]:i.or(...V)}_and(){const V=[this._term()];for(;this._matchOne(15);){const ne=this._term();V.push(ne)}return V.length===1?V[0]:i.and(...V)}_term(){if(this._matchOne(2)){const V=this._peek();switch(V.type){case 11:return this._advance(),S.INSTANCE;case 12:return this._advance(),w.INSTANCE;case 0:{this._advance();const ne=this._expr();return this._consume(1,c),ne?.negate()}case 17:return this._advance(),A.create(V.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",V)}}return this._primary()}_primary(){const V=this._peek();switch(V.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const ne=this._expr();return this._consume(1,c),ne}case 17:{const ne=V.lexeme;if(this._advance(),this._matchOne(9)){const Fe=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Fe.type!==10)throw this._errExpectedButGot("REGEX",Fe);const ke=Fe.lexeme,we=ke.lastIndexOf("/"),me=we===ke.length-1?void 0:this._removeFlagsGY(ke.substring(we+1));let K;try{K=new RegExp(ke.substring(1,we),me)}catch{throw this._errExpectedButGot("REGEX",Fe)}return N.create(ne,K)}switch(Fe.type){case 10:case 19:{const ke=[Fe.lexeme];this._advance();let we=this._peek(),me=0;for(let Pe=0;Pe<Fe.lexeme.length;Pe++)Fe.lexeme.charCodeAt(Pe)===40?me++:Fe.lexeme.charCodeAt(Pe)===41&&me--;for(;!this._isAtEnd()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Pe=0;Pe<we.lexeme.length;Pe++)we.lexeme.charCodeAt(Pe)===40?me++:Fe.lexeme.charCodeAt(Pe)===41&&me--}if(me<0)break;ke.push(P.Scanner.getLexeme(we)),this._advance(),we=this._peek()}const K=ke.join(""),J=K.lastIndexOf("/"),ue=J===K.length-1?void 0:this._removeFlagsGY(K.substring(J+1));let he;try{he=new RegExp(K.substring(1,J),ue)}catch{throw this._errExpectedButGot("REGEX",Fe)}return i.regex(ne,he)}case 18:{const ke=Fe.lexeme;this._advance();let we=null;if(!(0,L.isFalsyOrWhitespace)(ke)){const me=ke.indexOf("/"),K=ke.lastIndexOf("/");if(me!==K&&me>=0){const J=ke.slice(me+1,K),ue=ke[K+1]==="i"?"i":"";try{we=new RegExp(J,ue)}catch{throw this._errExpectedButGot("REGEX",Fe)}}}if(we===null)throw this._errExpectedButGot("REGEX",Fe);return N.create(ne,we)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,s);const Fe=this._value();return i.notIn(ne,Fe)}switch(this._peek().type){case 3:{this._advance();const Fe=this._value();if(this._previous().type===18)return i.equals(ne,Fe);switch(Fe){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Fe)}}case 4:{this._advance();const Fe=this._value();if(this._previous().type===18)return i.notEquals(ne,Fe);switch(Fe){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Fe)}}case 5:return this._advance(),B.create(ne,this._value());case 6:return this._advance(),k.create(ne,this._value());case 7:return this._advance(),j.create(ne,this._value());case 8:return this._advance(),H.create(ne,this._value());case 13:return this._advance(),i.in(ne,this._value());default:return i.has(ne)}}case 20:throw this._parsingErrors.push({message:r,offset:V.offset,lexeme:"",additionalInfo:a}),d._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const V=this._peek();switch(V.type){case 17:case 18:return this._advance(),V.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(V){return V.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(V){return this._check(V)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(V,ne){if(this._check(V))return this._advance();throw this._errExpectedButGot(ne,this._peek())}_errExpectedButGot(V,ne,Ie){const Fe=(0,T.localize)(8,null,V,P.Scanner.getLexeme(ne)),ke=ne.offset,we=P.Scanner.getLexeme(ne);return this._parsingErrors.push({message:Fe,offset:ke,lexeme:we,additionalInfo:Ie}),d._parseError}_check(V){return this._peek().type===V}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=d;class i{static false(){return S.INSTANCE}static true(){return w.INSTANCE}static has(V){return g.create(V)}static equals(V,ne){return D.create(V,ne)}static notEquals(V,ne){return b.create(V,ne)}static regex(V,ne){return N.create(V,ne)}static in(V,ne){return h.create(V,ne)}static notIn(V,ne){return _.create(V,ne)}static not(V){return A.create(V)}static and(...V){return le.create(V,null,!0)}static or(...V){return _e.create(V,null,!0)}static greater(V,ne){return j.create(V,ne)}static greaterEquals(V,ne){return H.create(V,ne)}static smaller(V,ne){return B.create(V,ne)}static smallerEquals(V,ne){return k.create(V,ne)}static{this._parser=new d({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this._parser.parse(V)}}e.ContextKeyExpr=i;function v(X){const V=new d({regexParsingWithErrorRecovery:!1});return X.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,T.localize)(9,null,Ie.additionalInfo):(0,T.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.validateWhenClauses=v;function l(X,V){const ne=X?X.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.expressionsAreEqualWithConstantSubstitution=l;function o(X,V){return X.cmp(V)}class S{static{this.INSTANCE=new S}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=S;class w{static{this.INSTANCE=new w}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=w;class g{static create(V,ne=null){const Ie=f.get(V);return typeof Ie=="boolean"?Ie?w.INSTANCE:S.INSTANCE:new g(V,ne)}constructor(V,ne){this.key=V,this.negated=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:de(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?w.INSTANCE:S.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.negated||(this.negated=A.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class D{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?g.create(V,Ie):A.create(V,Ie);const Fe=f.get(V);return typeof Fe=="boolean"?ne===(Fe?"true":"false")?w.INSTANCE:S.INSTANCE:new D(V,ne,Ie)}constructor(V,ne,Ie){this.key=V,this.value=ne,this.negated=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){const V=f.get(this.key);if(typeof V=="boolean"){const ne=V?"true":"false";return this.value===ne?w.INSTANCE:S.INSTANCE}return this}evaluate(V){return V.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(V){return V.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class h{static create(V,ne){return new h(V,ne)}constructor(V,ne){this.key=V,this.valueKey=ne,this.type=10,this.negated=null}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.valueKey,V.key,V.valueKey)}equals(V){return V.type===this.type?this.key===V.key&&this.valueKey===V.valueKey:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.valueKey),Ie=V.getValue(this.key);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,Ie):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(V){return V.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class _{static create(V,ne){return new _(V,ne)}constructor(V,ne){this.key=V,this.valueKey=ne,this.type=11,this._negated=h.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this._negated.cmp(V._negated)}equals(V){return V.type===this.type?this._negated.equals(V._negated):!1}substituteConstants(){return this}evaluate(V){return!this._negated.evaluate(V)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(V){return V.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=_;class b{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?A.create(V,Ie):g.create(V,Ie);const Fe=f.get(V);return typeof Fe=="boolean"?ne===(Fe?"true":"false")?S.INSTANCE:w.INSTANCE:new b(V,ne,Ie)}constructor(V,ne,Ie){this.key=V,this.value=ne,this.negated=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){const V=f.get(this.key);if(typeof V=="boolean"){const ne=V?"true":"false";return this.value===ne?S.INSTANCE:w.INSTANCE}return this}evaluate(V){return V.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(V){return V.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class A{static create(V,ne=null){const Ie=f.get(V);return typeof Ie=="boolean"?Ie?S.INSTANCE:w.INSTANCE:new A(V,ne)}constructor(V,ne){this.key=V,this.negated=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:de(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?S.INSTANCE:w.INSTANCE:this}evaluate(V){return!V.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(V){return V.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=A;function F(X,V){if(typeof X=="string"){const ne=parseFloat(X);isNaN(ne)||(X=ne)}return typeof X=="string"||typeof X=="number"?V(X):S.INSTANCE}class j{static create(V,ne,Ie=null){return F(ne,Fe=>new j(V,Fe,Ie))}constructor(V,ne,Ie){this.key=V,this.value=ne,this.negated=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(V){return V.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=j;class H{static create(V,ne,Ie=null){return F(ne,Fe=>new H(V,Fe,Ie))}constructor(V,ne,Ie){this.key=V,this.value=ne,this.negated=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(V){return V.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=B.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=H;class B{static create(V,ne,Ie=null){return F(ne,Fe=>new B(V,Fe,Ie))}constructor(V,ne,Ie){this.key=V,this.value=ne,this.negated=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(V){return V.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=B;class k{static create(V,ne,Ie=null){return F(ne,Fe=>new k(V,Fe,Ie))}constructor(V,ne,Ie){this.key=V,this.value=ne,this.negated=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:Ee(this.key,this.value,V.key,V.value)}equals(V){return V.type===this.type?this.key===V.key&&this.value===V.value:!1}substituteConstants(){return this}evaluate(V){return typeof this.value=="string"?!1:parseFloat(V.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(V){return V.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=k;class N{static create(V,ne){return new N(V,ne)}constructor(V,ne){this.key=V,this.regexp=ne,this.type=7,this.negated=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.key<V.key)return-1;if(this.key>V.key)return 1;const ne=this.regexp?this.regexp.source:"",Ie=V.regexp?V.regexp.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.regexp?this.regexp.source:"",Ie=V.regexp?V.regexp.source:"";return this.key===V.key&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.key);return this.regexp?this.regexp.test(ne):!1}serialize(){const V=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${V}`}keys(){return[this.key]}map(V){return V.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=$.create(this)),this.negated}}e.ContextKeyRegexExpr=N;class ${static create(V){return new $(V)}constructor(V){this._actual=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this._actual.cmp(V._actual)}equals(V){return V.type===this.type?this._actual.equals(V._actual):!1}substituteConstants(){return this}evaluate(V){return!this._actual.evaluate(V)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(V){return new $(this._actual.map(V))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=$;function re(X){let V=null;for(let ne=0,Ie=X.length;ne<Ie;ne++){const Fe=X[ne].substituteConstants();if(X[ne]!==Fe&&V===null){V=[];for(let ke=0;ke<ne;ke++)V[ke]=X[ke]}V!==null&&(V[ne]=Fe)}return V===null?X:V}class le{static create(V,ne,Ie){return le._normalizeArr(V,ne,Ie)}constructor(V,ne){this.expr=V,this.negated=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Fe=o(this.expr[ne],V.expr[ne]);if(Fe!==0)return Fe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:le.create(V,this.negated,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static _normalizeArr(V,ne,Ie){const Fe=[];let ke=!1;for(const we of V)if(we){if(we.type===1){ke=!0;continue}if(we.type===0)return S.INSTANCE;if(we.type===6){Fe.push(...we.expr);continue}Fe.push(we)}if(Fe.length===0&&ke)return w.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(o);for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const we=Fe[Fe.length-1];if(we.type!==9)break;Fe.pop();const me=Fe.pop(),K=Fe.length===0,J=_e.create(we.expr.map(ue=>le.create([ue,me],null,Ie)),null,K);J&&(Fe.push(J),Fe.sort(o))}if(Fe.length===1)return Fe[0];if(Ie){for(let we=0;we<Fe.length;we++)for(let me=we+1;me<Fe.length;me++)if(Fe[we].negate().equals(Fe[me]))return S.INSTANCE;if(Fe.length===1)return Fe[0]}return new le(Fe,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new le(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.negated){const V=[];for(const ne of this.expr)V.push(ne.negate());this.negated=_e.create(V,this,!0)}return this.negated}}e.ContextKeyAndExpr=le;class _e{static create(V,ne,Ie){return _e._normalizeArr(V,ne,Ie)}constructor(V,ne){this.expr=V,this.negated=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Fe=o(this.expr[ne],V.expr[ne]);if(Fe!==0)return Fe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:_e.create(V,this.negated,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static _normalizeArr(V,ne,Ie){let Fe=[],ke=!1;if(V){for(let we=0,me=V.length;we<me;we++){const K=V[we];if(K){if(K.type===0){ke=!0;continue}if(K.type===1)return w.INSTANCE;if(K.type===9){Fe=Fe.concat(K.expr);continue}Fe.push(K)}}if(Fe.length===0&&ke)return S.INSTANCE;Fe.sort(o)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];if(Ie){for(let we=0;we<Fe.length;we++)for(let me=we+1;me<Fe.length;me++)if(Fe[we].negate().equals(Fe[me]))return w.INSTANCE;if(Fe.length===1)return Fe[0]}return new _e(Fe,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new _e(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.negated){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Fe=[];for(const ke of ee(ne))for(const we of ee(Ie))Fe.push(le.create([ke,we],null,!1));V.unshift(_e.create(Fe,null,!1))}this.negated=_e.create(V,this,!0)}return this.negated}}e.ContextKeyOrExpr=_e;class ye extends g{static{this._info=[]}static all(){return ye._info.values()}constructor(V,ne,Ie){super(V,null),this._defaultValue=ne,typeof Ie=="object"?ye._info.push({...Ie,key:V}):Ie!==!0&&ye._info.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this._defaultValue)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return D.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.RawContextKey=ye,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function de(X,V){return X<V?-1:X>V?1:0}function Ee(X,V,ne,Ie){return X<ne?-1:X>ne?1:V<Ie?-1:V>Ie?1:0}function se(X,V){if(X.type===0||V.type===1)return!0;if(X.type===9)return V.type===9?pe(X.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(se(X,ne))return!0;return!1}if(X.type===6){if(V.type===6)return pe(V.expr,X.expr);for(const ne of X.expr)if(se(ne,V))return!0;return!1}return X.equals(V)}e.implies=se;function pe(X,V){let ne=0,Ie=0;for(;ne<X.length&&Ie<V.length;){const Fe=X[ne].cmp(V[Ie]);if(Fe<0)return!1;Fe===0&&ne++,Ie++}return ne===X.length}function ee(X){return X.type===9?X.expr:[X]}}),define(Te[185],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(Te[96],Ae([1,0,152,4]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function P(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function O(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function T(r,a){switch(r){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":a==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function m(r,a){return a==="web"&&!r.includes("web")}e.isNotWebExtensionInWebTargetPlatform=m;function f(r,a,d){return m(a,d)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===d}e.isTargetPlatformCompatible=f;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=y;var R;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var u;(function(r){r.Install="install",r.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var E;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var p;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var s;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class c extends Error{constructor(a,d){super(a),this.code=d,this.name=d}}e.ExtensionManagementError=c;var t;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(t||(e.ExtensionGalleryErrorCode=t={}));class n extends Error{constructor(a,d){super(a),this.code=d,this.name=d}}e.ExtensionGalleryError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,I.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,I.localize2)(1,"Preferences")}),define(Te[42],Ae([1,0,50,19,13,16,2,154,4,21,12,40]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function u(se){return se.create===!0}e.isFileOpenForWriteOptions=u;var E;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function s(se){const pe=se;return!!pe&&typeof pe.onDidChange=="function"}e.isFileSystemWatcher=s;var c;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function t(se){return!!(se.capabilities&2)}e.hasReadWriteCapability=t;function n(se){return!!(se.capabilities&8)}e.hasFileFolderCopyCapability=n;function r(se){return!!(se.capabilities&131072)}e.hasFileCloneCapability=r;function a(se){return!!(se.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function d(se){return!!(se.capabilities&16)}e.hasFileReadStreamCapability=d;function i(se){return t(se)?!!(se.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function v(se){return t(se)?!!(se.capabilities&32768):!1}e.hasFileAtomicWriteCapability=v;function l(se){return!!(se.capabilities&65536)}e.hasFileAtomicDeleteCapability=l;function o(se){return!!(se.capabilities&2048)}e.hasReadonlyCapability=o;var S;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class w extends Error{static create(pe,ee){const X=new w(pe.toString(),ee);return h(X,ee),X}constructor(pe,ee){super(pe),this.code=ee}}e.FileSystemProviderError=w;function g(se,pe){return w.create(se,pe)}e.createFileSystemProviderError=g;function D(se){return se||g((0,m.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=D;function h(se,pe){return se.name=pe?`${pe} (FileSystemError)`:"FileSystemError",se}e.markAsFileSystemProviderError=h;function _(se){if(!se)return S.Unknown;if(se instanceof w)return se.code;const pe=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!pe)return S.Unknown;switch(pe[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=_;function b(se){if(se instanceof k)return se.fileOperationResult;switch(_(se)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 9;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=b;var A;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class F{constructor(pe,ee,X){this.resource=pe,this.operation=ee,this.target=X}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=F;var j;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class H{static{this.MIXED_CORRELATION=null}constructor(pe,ee){this.ignorePathCasing=ee,this.correlationId=void 0,this.added=new C.Lazy(()=>{const X=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.updated=new C.Lazy(()=>{const X=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.deleted=new C.Lazy(()=>{const X=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of pe){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.correlationId!==H.MIXED_CORRELATION&&(typeof X.cId=="number"?this.correlationId===void 0?this.correlationId=X.cId:this.correlationId!==X.cId&&(this.correlationId=H.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=H.MIXED_CORRELATION))}}contains(pe,...ee){return this.doContains(pe,{includeChildren:!1},...ee)}affects(pe,...ee){return this.doContains(pe,{includeChildren:!0},...ee)}doContains(pe,ee,...X){if(!pe)return!1;const V=X.length>0;return!!((!V||X.includes(1))&&(this.added.value.get(pe)||ee.includeChildren&&this.added.value.findSuperstr(pe))||(!V||X.includes(0))&&(this.updated.value.get(pe)||ee.includeChildren&&this.updated.value.findSuperstr(pe))||(!V||X.includes(2))&&(this.deleted.value.findSubstr(pe)||ee.includeChildren&&this.deleted.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.correlationId===pe}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=H;function B(se,pe,ee){return!se||!pe||se===pe||pe.length>se.length?!1:(pe.charAt(pe.length-1)!==L.sep&&(pe+=L.sep),ee?(0,P.startsWithIgnoreCase)(se,pe):se.indexOf(pe)===0)}e.isParent=B;class k extends Error{constructor(pe,ee,X){super(pe),this.fileOperationResult=ee,this.options=X}}e.FileOperationError=k;class N extends k{constructor(pe,ee,X,V){super(pe,ee,V),this.fileOperationResult=ee,this.size=X}}e.TooLargeFileOperationError=N;class $ extends k{constructor(pe,ee,X){super(pe,2,X),this.stat=ee}}e.NotModifiedSinceFileOperationError=$;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var le;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.ETAG_DISABLED="";function _e(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.etag=_e;async function ye(se,pe){if(!pe.hasProvider(T.URI.from({scheme:se.scheme})))return new Promise(ee=>{const X=pe.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(X.dispose(),ee())})})}e.whenProviderRegistered=ye;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(pe){return(0,O.isNumber)(pe)||(pe=0),pe<de.KB?(0,m.localize)(1,null,pe.toFixed(0)):pe<de.MB?(0,m.localize)(2,null,(pe/de.KB).toFixed(2)):pe<de.GB?(0,m.localize)(3,null,(pe/de.MB).toFixed(2)):pe<de.TB?(0,m.localize)(4,null,(pe/de.GB).toFixed(2)):(0,m.localize)(5,null,(pe/de.TB).toFixed(2))}}e.ByteSize=de;function Ee(se){const pe=typeof se=="string"||se?.scheme===R.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===R.Schemas.file?1024*de.MB:pe?10*de.MB:y.isWeb?50*de.MB:1024*de.MB}e.getLargeFileConfirmationLimit=Ee}),define(Te[71],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...P){this._entries=new Map;for(const[O,T]of P)this.set(O,T)}set(P,O){const T=this._entries.get(P);return this._entries.set(P,O),T}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=I}),define(Te[186],Ae([1,0,11,15,6,70,184,4,71,187]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class C extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class u{constructor(c=new f.ServiceCollection,t=!1,n,r=R){this._services=c,this._strict=t,this._parent=n,this._enableTracing=r,this._activeInstantiations=new Set,this._services.set(m.IInstantiationService,this),this._globalGraph=r?n?._globalGraph??new T.Graph(a=>a):void 0}createChild(c){return new u(c,this._strict,this,this._enableTracing)}invokeFunction(c,...t){const n=p.traceInvocation(this._enableTracing,c);let r=!1;try{return c({get:d=>{if(r)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(d,n);if(!i)throw new Error(`[invokeFunction] unknown service '${d}'`);return i}},...t)}finally{r=!0,n.stop()}}createInstance(c,...t){let n,r;return c instanceof O.SyncDescriptor?(n=p.traceCreation(this._enableTracing,c.ctor),r=this._createInstance(c.ctor,c.staticArguments.concat(t),n)):(n=p.traceCreation(this._enableTracing,c),r=this._createInstance(c,t,n)),n.stop(),r}_createInstance(c,t=[],n){const r=m._util.getServiceDependencies(c).sort((i,v)=>i.index-v.index),a=[];for(const i of r){const v=this._getOrCreateServiceInstance(i.id,n);v||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${i.id}.`,!1),a.push(v)}const d=r.length>0?r[0].index:t.length;if(t.length!==d){console.trace(`[createInstance] First service dependency of ${c.name} at position ${d+1} conflicts with ${t.length} static arguments`);const i=d-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,d)}return Reflect.construct(c,t.concat(a))}_setServiceInstance(c,t){if(this._services.get(c)instanceof O.SyncDescriptor)this._services.set(c,t);else if(this._parent)this._parent._setServiceInstance(c,t);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const t=this._services.get(c);return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):t}_getOrCreateServiceInstance(c,t){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const n=this._getServiceInstanceOrDescriptor(c);return n instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,n,t.branch(c,!0)):(t.branch(c,!1),n)}_safeCreateAndCacheServiceInstance(c,t,n){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,t,n)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,t,n){const r=new T.Graph(i=>i.id.toString());let a=0;const d=[{id:c,desc:t,_trace:n}];for(;d.length;){const i=d.pop();if(r.lookupOrInsertNode(i),a++>1e3)throw new C(r);for(const v of m._util.getServiceDependencies(i.desc.ctor)){const l=this._getServiceInstanceOrDescriptor(v.id);if(l||this._throwIfStrict(`[createInstance] ${c} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(v.id)),l instanceof O.SyncDescriptor){const o={id:v.id,desc:l,_trace:i._trace.branch(v.id,!0)};r.insertEdge(i,o),d.push(o)}}}for(;;){const i=r.roots();if(i.length===0){if(!r.isEmpty())throw new C(r);break}for(const{data:v}of i){if(this._getServiceInstanceOrDescriptor(v.id)instanceof O.SyncDescriptor){const o=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,o)}r.removeNode(v)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,t,n=[],r,a){if(this._services.get(c)instanceof O.SyncDescriptor)return this._createServiceInstance(c,t,n,r,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,t,n,r,a);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(c,t,n=[],r,a){if(r){const d=new u(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(c);const i=new Map,v=new I.GlobalIdleValue(()=>{const l=d._createInstance(t,n,a);for(const[o,S]of i){const w=l[o];if(typeof w=="function")for(const g of S)g.disposable=w.apply(l,g.listener)}return i.clear(),l});return new Proxy(Object.create(null),{get(l,o){if(!v.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let g=i.get(o);return g||(g=new y.LinkedList,i.set(o,g)),(h,_,b)=>{if(v.isInitialized)return v.value[o](h,_,b);{const A={listener:[h,_,b],disposable:void 0},F=g.push(A);return(0,P.toDisposable)(()=>{F(),A.disposable?.dispose()})}}}if(o in l)return l[o];const S=v.value;let w=S[o];return typeof w!="function"||(w=w.bind(S),l[o]=w),w},set(l,o,S){return v.value[o]=S,!0},getPrototypeOf(l){return t.prototype}})}else return this._createInstance(t,n,a)}_throwIfStrict(c,t){if(t&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=u;var E;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(E||(E={}));class p{static{this.all=new Set}static{this._None=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,t){return c?new p(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(c,t){return c?new p(1,t.name):p._None}static{this._totals=0}constructor(c,t){this.type=c,this.name=t,this._start=Date.now(),this._dep=[]}branch(c,t){const n=new p(3,c.toString());return this._dep.push([c,t,n]),n}stop(){const c=Date.now()-this._start;p._totals+=c;let t=!1;function n(a,d){const i=[],v=new Array(a+1).join("	");for(const[l,o,S]of d._dep)if(o&&S){t=!0,i.push(`${v}CREATES -> ${l}`);const w=n(a+1,S);w&&i.push(w)}else i.push(`${v}uses -> ${l}`);return i.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(c>2||t)&&p.all.add(r.join(`
`))}}e.Trace=p}),define(Te[14],Ae([1,0,34,5,97,6,28,21,25,16,2,36,4]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function E(){return new Date().toISOString()}function p(h){return(0,y.isNumber)(h)}e.isLogLevel=p;var s;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(s||(e.LogLevel=s={})),e.DEFAULT_LOG_LEVEL=s.Info;function c(h,_,b){switch(_){case s.Trace:h.trace(b);break;case s.Debug:h.debug(b);break;case s.Info:h.info(b);break;case s.Warning:h.warn(b);break;case s.Error:h.error(b);break;case s.Off:break;default:throw new Error(`Invalid log level ${_}`)}}e.log=c;function t(h,_=!1){let b="";for(let A=0;A<h.length;A++){let F=h[A];if(F instanceof Error&&(F=(0,I.toErrorMessage)(F,_)),typeof F=="object")try{F=JSON.stringify(F)}catch{}b+=(A>0?" ":"")+F}return b}class n extends O.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(_){this.level!==_&&(this.level=_,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(_){return this.level!==s.Off&&this.level<=_}}e.AbstractLogger=n;class r extends n{constructor(_){super(),this.logAlways=_}checkLogLevel(_){return this.logAlways||super.checkLogLevel(_)}trace(_,...b){this.checkLogLevel(s.Trace)&&this.log(s.Trace,t([_,...b],!0))}debug(_,...b){this.checkLogLevel(s.Debug)&&this.log(s.Debug,t([_,...b]))}info(_,...b){this.checkLogLevel(s.Info)&&this.log(s.Info,t([_,...b]))}warn(_,...b){this.checkLogLevel(s.Warning)&&this.log(s.Warning,t([_,...b]))}error(_,...b){if(this.checkLogLevel(s.Error))if(_ instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=_.stack,this.log(s.Error,t(A))}else this.log(s.Error,t([_,...b]))}flush(){}}e.AbstractMessageLogger=r;class a extends n{constructor(_=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(_),this.useColors=!m.isWindows}trace(_,...b){this.checkLogLevel(s.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,_,...b):console.log(`[main ${E()}]`,_,...b))}debug(_,...b){this.checkLogLevel(s.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,_,...b):console.log(`[main ${E()}]`,_,...b))}info(_,...b){this.checkLogLevel(s.Info)&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,_,...b):console.log(`[main ${E()}]`,_,...b))}warn(_,...b){this.checkLogLevel(s.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,_,...b):console.warn(`[main ${E()}]`,_,...b))}error(_,...b){this.checkLogLevel(s.Error)&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,_,...b):console.error(`[main ${E()}]`,_,...b))}flush(){}}e.ConsoleMainLogger=a;class d extends n{constructor(_=e.DEFAULT_LOG_LEVEL,b=!0){super(),this.useColors=b,this.setLevel(_)}trace(_,...b){this.checkLogLevel(s.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",_,...b):console.log(_,...b))}debug(_,...b){this.checkLogLevel(s.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",_,...b):console.log(_,...b))}info(_,...b){this.checkLogLevel(s.Info)&&(this.useColors?console.log("%c INFO","color: #33f",_,...b):console.log(_,...b))}warn(_,...b){this.checkLogLevel(s.Warning)&&(this.useColors?console.log("%c WARN","color: #993",_,...b):console.log(_,...b))}error(_,...b){this.checkLogLevel(s.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",_,...b):console.error(_,...b))}flush(){}}e.ConsoleLogger=d;class i extends n{constructor(_,b=e.DEFAULT_LOG_LEVEL){super(),this.adapter=_,this.setLevel(b)}trace(_,...b){this.checkLogLevel(s.Trace)&&this.adapter.log(s.Trace,[this.extractMessage(_),...b])}debug(_,...b){this.checkLogLevel(s.Debug)&&this.adapter.log(s.Debug,[this.extractMessage(_),...b])}info(_,...b){this.checkLogLevel(s.Info)&&this.adapter.log(s.Info,[this.extractMessage(_),...b])}warn(_,...b){this.checkLogLevel(s.Warning)&&this.adapter.log(s.Warning,[this.extractMessage(_),...b])}error(_,...b){this.checkLogLevel(s.Error)&&this.adapter.log(s.Error,[this.extractMessage(_),...b])}extractMessage(_){return typeof _=="string"?_:(0,I.toErrorMessage)(_,this.checkLogLevel(s.Trace))}flush(){}}e.AdapterLogger=i;class v extends n{constructor(_){super(),this.loggers=_,_.length&&this.setLevel(_[0].getLevel())}setLevel(_){for(const b of this.loggers)b.setLevel(_);super.setLevel(_)}trace(_,...b){for(const A of this.loggers)A.trace(_,...b)}debug(_,...b){for(const A of this.loggers)A.debug(_,...b)}info(_,...b){for(const A of this.loggers)A.info(_,...b)}warn(_,...b){for(const A of this.loggers)A.warn(_,...b)}error(_,...b){for(const A of this.loggers)A.error(_,...b)}flush(){for(const _ of this.loggers)_.flush()}dispose(){for(const _ of this.loggers)_.dispose();super.dispose()}}e.MultiplexLogger=v;class l extends O.Disposable{constructor(_,b,A){if(super(),this.logLevel=_,this.logsHome=b,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,A)for(const F of A)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(_){return(0,y.isString)(_)?[...this._loggers.values()].find(b=>b.info.id===_):this._loggers.get(_)}getLogger(_){return this.getLoggerEntry(_)?.logger}createLogger(_,b){const A=this.toResource(_),F=(0,y.isString)(_)?_:b?.id??(0,P.hash)(A.toString()).toString(16);let j=this._loggers.get(A)?.logger;const H=b?.logLevel==="always"?s.Trace:b?.logLevel;j||(j=this.doCreateLogger(A,H??this.getLogLevel(A)??this.logLevel,{...b,id:F}));const B={logger:j,info:{resource:A,id:F,logLevel:H,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(B.info),this._loggers.set(A,B),j}toResource(_){return(0,y.isString)(_)?(0,f.joinPath)(this.logsHome,`${_}.log`):_}setLogLevel(_,b){if(R.URI.isUri(_)){const A=_,F=b,j=this._loggers.get(A);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.logLevel?void 0:F,j.logger?.setLevel(F),this._loggers.set(j.info.resource,j),this._onDidChangeLogLevel.fire([A,F]))}else{this.logLevel=_;for(const[A,F]of this._loggers.entries())this._loggers.get(A)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(_,b){const A=this.getLoggerEntry(_);A&&b!==!A.info.hidden&&(A.info.hidden=!b,this._loggers.set(A.info.resource,A),this._onDidChangeVisibility.fire([A.info.resource,b]))}getLogLevel(_){let b;return _&&(b=this._loggers.get(_)?.info.logLevel),b??this.logLevel}registerLogger(_){const b=this._loggers.get(_.resource);b?b.info.hidden!==_.hidden&&this.setVisibility(_.resource,!_.hidden):(this._loggers.set(_.resource,{info:_,logger:void 0}),this._onDidChangeLoggers.fire({added:[_],removed:[]}))}deregisterLogger(_){const b=this._loggers.get(_);b&&(b.logger&&b.logger.dispose(),this._loggers.delete(_),this._onDidChangeLoggers.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const _ of this._loggers.values())yield _.info}getRegisteredLogger(_){return this._loggers.get(_)?.info}dispose(){this._loggers.forEach(_=>_.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=l;class o{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(_){}getLevel(){return s.Info}trace(_,...b){}debug(_,...b){}info(_,...b){}warn(_,...b){}error(_,...b){}critical(_,...b){}dispose(){}flush(){}}e.NullLogger=o;class S extends o{}e.NullLogService=S;function w(h){if(h.verbose)return s.Trace;if(typeof h.logLevel=="string"){const _=D(h.logLevel.toLowerCase());if(_!==void 0)return _}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function g(h){switch(h){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.LogLevelToString=g;function D(h){switch(h){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.parseLogLevel=D,e.CONTEXT_LOG_LEVEL=new C.RawContextKey("logLevel",g(s.Info))}),define(Te[188],Ae([1,0,6,14]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends I.Disposable{constructor(T,m=[]){super(),this.logger=new L.MultiplexLogger([T,...m]),this._register(T.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...m){this.logger.trace(T,...m)}debug(T,...m){this.logger.debug(T,...m)}info(T,...m){this.logger.info(T,...m)}warn(T,...m){this.logger.warn(T,...m)}error(T,...m){this.logger.error(T,...m)}flush(){this.logger.flush()}}e.LogService=P}),define(Te[98],Ae([1,0,32,155,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var T;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(f){function y(p,s){return s-p}f.compare=y;const R=Object.create(null);R[f.Error]=(0,L.localize)(0,null),R[f.Warning]=(0,L.localize)(1,null),R[f.Info]=(0,L.localize)(2,null);function C(p){return R[p]||""}f.toString=C;function u(p){switch(p){case I.default.Error:return f.Error;case I.default.Warning:return f.Warning;case I.default.Info:return f.Info;case I.default.Ignore:return f.Hint}}f.fromSeverity=u;function E(p){switch(p){case f.Error:return I.default.Error;case f.Warning:return I.default.Warning;case f.Info:return I.default.Info;case f.Hint:return I.default.Ignore}}f.toSeverity=E}(T||(e.MarkerSeverity=T={}));var m;(function(f){const y="";function R(u){return C(u,!0)}f.makeKey=R;function C(u,E){const p=[y];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(y),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(y),u.severity!==void 0&&u.severity!==null?p.push(T.toString(u.severity)):p.push(y),u.message&&E?p.push(u.message.replace("\xA6","\\\xA6")):p.push(y),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(y),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(y),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(y),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(y),p.push(y),p.join("\xA6")}f.makeKeyOptionalMessage=C})(m||(e.IMarkerData=m={})),e.IMarkerService=(0,P.createDecorator)("markerService")}),define(Te[189],Ae([1,0,5,32,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.isNotificationSource=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,P.createDecorator)("notificationService");var O;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var T;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function m(C){if(C){const u=C;return typeof u.id=="string"&&typeof u.label=="string"}return!1}e.isNotificationSource=m;var f;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class y{constructor(){this.progress=new R,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.NoOpNotification=y;class R{infinite(){}done(){}total(u){}worked(u){}}e.NoOpProgress=R}),define(Te[190],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(fe,e,I,L){var P=arguments.length,O=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(fe,e,I,L);else for(var m=fe.length-1;m>=0;m--)(T=fe[m])&&(O=(P<3?T(O):P>3?T(e,I,O):T(e,I))||O);return P>3&&O&&Object.defineProperty(e,I,O),O},Ve=this&&this.__param||function(fe,e){return function(I,L){e(I,L,fe)}};define(Te[99],Ae([1,0,11,22,6,4]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var T;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(u){this.callback=u}report(u){this._value=u,this.callback(this._value)}}e.Progress=m;class f{get value(){return this._value}constructor(u){this.callback=u}report(u){this._asyncQueue?this._asyncQueue.push(u):this._asyncQueue=[u],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const u=this._asyncQueue.shift();this._value=u,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const u=this._drainListener;this._drainListener=void 0,u?.()}}drain(){return this._processingAsyncQueue?new Promise(u=>{const E=this._drainListener;this._drainListener=()=>{E?.(),u()}}):Promise.resolve()}}e.AsyncProgress=f;let y=class extends P.Disposable{constructor(u,E){super(),this.deferred=new I.DeferredPromise,E.withProgress(u,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(u){this.reporter?this.reporter.report(u):this.lastStep=u}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ge([Ve(1,e.IProgressService)],y);class R extends P.Disposable{constructor(u){super(),this.progressIndicator=u,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(u){this.stop();const E=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},u),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:p.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(u){this.currentOperationId===u&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(Te[30],Ae([1,0,55,16]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(T,m){I.ok(L.isString(T)),I.ok(L.isObject(m)),I.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,m)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new P}),define(Te[72],Ae([1,0,5,30]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class O{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,y){this.schemasById[P(f)]=y,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new O;L.Registry.add(e.Extensions.JSONContribution,T)}),define(Te[56],Ae([1,0,18,5,16,149,46,72,30]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=f.Registry.as(m.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,v=!0){this.registerConfigurations([i],v)}registerConfigurations(i,v=!0){const l=new Set;this.doRegisterConfigurations(i,v,l),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(i){const v=new Set;this.doDeregisterConfigurations(i,v),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:v})}updateConfigurations({add:i,remove:v}){const l=new Set;this.doDeregisterConfigurations(v,l),this.doRegisterConfigurations(i,!1,l),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}registerDefaultConfigurations(i){const v=new Set;this.doRegisterDefaultConfigurations(i,v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:v,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,v){const l=[];for(const{overrides:o,source:S}of i)for(const w in o)if(v.add(w),e.OVERRIDE_PROPERTY_REGEX.test(w)){const g=this.configurationDefaultsOverrides.get(w),D=g?.valuesSources??new Map;if(S)for(const A of Object.keys(o[w]))D.set(A,S);const h={...g?.value||{},...o[w]};this.configurationDefaultsOverrides.set(w,{source:S,value:h,valuesSources:D});const _=(0,T.getLanguageTagSettingPlainKey)(w),b={type:"object",default:h,description:O.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:P.isString(S)?void 0:S,defaultValueSource:S};l.push(...s(w)),this.configurationProperties[w]=b,this.defaultLanguageConfigurationOverridesNode.properties[w]=b}else{this.configurationDefaultsOverrides.set(w,{value:o[w],source:S});const g=this.configurationProperties[w];g&&(this.updatePropertyDefaultValue(w,g),this.updateSchema(w,g))}this.doRegisterOverrideIdentifiers(l)}deregisterDefaultConfigurations(i){const v=new Set;this.doDeregisterDefaultConfigurations(i,v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:v,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,v){for(const{overrides:l,source:o}of i)for(const S in l){const w=this.configurationDefaultsOverrides.get(S),g=P.isString(o)?o:o?.id,D=P.isString(w?.source)?w?.source:w?.source?.id;if(g===D)if(v.add(S),this.configurationDefaultsOverrides.delete(S),e.OVERRIDE_PROPERTY_REGEX.test(S))delete this.configurationProperties[S],delete this.defaultLanguageConfigurationOverridesNode.properties[S];else{const h=this.configurationProperties[S];h&&(this.updatePropertyDefaultValue(S,h),this.updateSchema(S,h))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let v=!1;const l=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,l),v=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,l),v=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,l),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const v of i)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,v,l){i.forEach(o=>{this.validateAndRegisterProperties(o,v,o.extensionInfo,o.restrictedProperties,void 0,l),this.configurationContributors.push(o),this.registerJSONConfiguration(o)})}doDeregisterConfigurations(i,v){const l=o=>{if(o.properties)for(const S in o.properties){v.add(S);const w=this.configurationProperties[S];w?.policy?.name&&this.policyConfigurations.delete(w.policy.name),delete this.configurationProperties[S],this.removeFromSchema(S,o.properties[S])}o.allOf?.forEach(S=>l(S))};for(const o of i){l(o);const S=this.configurationContributors.indexOf(o);S!==-1&&this.configurationContributors.splice(S,1)}}validateAndRegisterProperties(i,v=!0,l,o,S=3,w){S=P.isUndefinedOrNull(i.scope)?S:i.scope;const g=i.properties;if(g)for(const h in g){const _=g[h];if(v&&r(h,_)){delete g[h];continue}if(_.source=l,_.defaultDefaultValue=g[h].default,this.updatePropertyDefaultValue(h,_),e.OVERRIDE_PROPERTY_REGEX.test(h)?_.scope=void 0:(_.scope=P.isUndefinedOrNull(_.scope)?S:_.scope,_.restricted=P.isUndefinedOrNull(_.restricted)?!!o?.includes(h):_.restricted),g[h].hasOwnProperty("included")&&!g[h].included){this.excludedConfigurationProperties[h]=g[h],delete g[h];continue}else this.configurationProperties[h]=g[h],g[h].policy?.name&&this.policyConfigurations.set(g[h].policy.name,h);!g[h].deprecationMessage&&g[h].markdownDeprecationMessage&&(g[h].deprecationMessage=g[h].markdownDeprecationMessage),w.add(h)}const D=i.allOf;if(D)for(const h of D)this.validateAndRegisterProperties(h,v,l,o,S,w)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const v=l=>{const o=l.properties;if(o)for(const w in o)this.updateSchema(w,o[w]);l.allOf?.forEach(v)};v(i)}updateSchema(i,v){switch(e.allSettings.properties[i]=v,v.scope){case 1:e.applicationSettings.properties[i]=v;break;case 2:e.machineSettings.properties[i]=v;break;case 6:e.machineOverridableSettings.properties[i]=v;break;case 3:e.windowSettings.properties[i]=v;break;case 4:e.resourceSettings.properties[i]=v;break;case 5:e.resourceSettings.properties[i]=v,this.resourceLanguageSettingsSchema.properties[i]=v;break}}removeFromSchema(i,v){switch(delete e.allSettings.properties[i],v.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const v=`[${i}]`,l={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,l),e.allSettings.properties[v]=l,e.applicationSettings.properties[v]=l,e.machineSettings.properties[v]=l,e.machineOverridableSettings.properties[v]=l,e.windowSettings.properties[v]=l,e.resourceSettings.properties[v]=l}}registerOverridePropertyPatternKey(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,v){const l=this.configurationDefaultsOverrides.get(i);let o=l?.value,S=l?.source;P.isUndefined(o)&&(o=v.defaultDefaultValue,S=void 0),P.isUndefined(o)&&(o=t(v.type)),v.default=o,v.defaultValueSource=S}}const E="\\[([^\\]]+)\\]",p=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(d){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let v=p.exec(d);for(;v?.length;){const l=v[1].trim();l&&i.push(l),v=p.exec(d)}}return(0,I.distinct)(i)}e.overrideIdentifiersFromKey=s;function c(d){return d.reduce((i,v)=>`${i}[${v}]`,"")}e.keyFromOverrideIdentifiers=c;function t(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const n=new u;f.Registry.add(e.Extensions.Configuration,n);function r(d,i){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?O.localize(7,null,d):n.getConfigurationProperties()[d]!==void 0?O.localize(8,null,d):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,d,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}e.validateProperty=r;function a(){const d=[],i=n.getConfigurationProperties();for(const v of Object.keys(i))d.push([v,i[v].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=a}),define(Te[191],Ae([1,0,18,5,120,6,28,26,16,2,46,56,30]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function E(v){return Object.isFrozen(v)?v:m.deepFreeze(v)}class p{constructor(l={},o=[],S=[],w){this._contents=l,this._keys=o,this._overrides=S,this.raw=w,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const l=this.raw.map(o=>{if(o instanceof p)return o;const S=new s("");return S.parseRaw(o),S.configurationModel});this._rawConfiguration=l.reduce((o,S)=>S===o?S:o.merge(S),l[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(l){return l?(0,R.getConfigurationValue)(this.contents,l):this.contents}inspect(l,o){const S=this;return{get value(){return E(S.rawConfiguration.getValue(l))},get override(){return o?E(S.rawConfiguration.getOverrideValue(l,o)):void 0},get merged(){return E(o?S.rawConfiguration.override(o).getValue(l):S.rawConfiguration.getValue(l))},get overrides(){const w=[];for(const{contents:g,identifiers:D,keys:h}of S.rawConfiguration.overrides){const _=new p(g,h).getValue(l);_!==void 0&&w.push({identifiers:D,value:_})}return w.length?E(w):void 0}}}getOverrideValue(l,o){const S=this.getContentsForOverrideIdentifer(o);return S?l?(0,R.getConfigurationValue)(S,l):S:void 0}getKeysForOverrideIdentifier(l){const o=[];for(const S of this.overrides)S.identifiers.includes(l)&&o.push(...S.keys);return I.distinct(o)}getAllOverrideIdentifiers(){const l=[];for(const o of this.overrides)l.push(...o.identifiers);return I.distinct(l)}override(l){let o=this.overrideConfigurations.get(l);return o||(o=this.createOverrideConfigurationModel(l),this.overrideConfigurations.set(l,o)),o}merge(...l){const o=m.deepClone(this.contents),S=m.deepClone(this.overrides),w=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of l)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(o,D.contents);for(const h of D.overrides){const[_]=S.filter(b=>I.equals(b.identifiers,h.identifiers));_?(this.mergeContents(_.contents,h.contents),_.keys.push(...h.keys),_.keys=I.distinct(_.keys)):S.push(m.deepClone(h))}for(const h of D.keys)w.indexOf(h)===-1&&w.push(h)}return new p(o,w,S,g.every(D=>D instanceof p)?void 0:g)}createOverrideConfigurationModel(l){const o=this.getContentsForOverrideIdentifer(l);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const S={};for(const w of I.distinct([...Object.keys(this.contents),...Object.keys(o)])){let g=this.contents[w];const D=o[w];D&&(typeof g=="object"&&typeof D=="object"?(g=m.deepClone(g),this.mergeContents(g,D)):g=D),S[w]=g}return new p(S,this.keys,this.overrides)}mergeContents(l,o){for(const S of Object.keys(o)){if(S in l&&f.isObject(l[S])&&f.isObject(o[S])){this.mergeContents(l[S],o[S]);continue}l[S]=m.deepClone(o[S])}}getContentsForOverrideIdentifer(l){let o=null,S=null;const w=g=>{g&&(S?this.mergeContents(S,g):S=m.deepClone(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===l?o=g.contents:g.identifiers.includes(l)&&w(g.contents);return w(o),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,o){this.updateValue(l,o,!0)}setValue(l,o){this.updateValue(l,o,!1)}removeValue(l){const o=this.keys.indexOf(l);o!==-1&&(this.keys.splice(o,1),(0,R.removeFromValueTree)(this.contents,l),C.OVERRIDE_PROPERTY_REGEX.test(l)&&this.overrides.splice(this.overrides.findIndex(S=>I.equals(S.identifiers,(0,C.overrideIdentifiersFromKey)(l))),1))}updateValue(l,o,S){(0,R.addToValueTree)(this.contents,l,o,w=>console.error(w)),S=S||this.keys.indexOf(l)===-1,S&&this.keys.push(l),C.OVERRIDE_PROPERTY_REGEX.test(l)&&this.overrides.push({identifiers:(0,C.overrideIdentifiersFromKey)(l),keys:Object.keys(this.contents[l]),contents:(0,R.toValuesTree)(this.contents[l],w=>console.error(w))})}}e.ConfigurationModel=p;class s{constructor(l){this._name=l,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(l,o){if(!f.isUndefinedOrNull(l)){const S=this.doParseContent(l);this.parseRaw(S,o)}}reparse(l){this._raw&&this.parseRaw(this._raw,l)}parseRaw(l,o){this._raw=l;const{contents:S,keys:w,overrides:g,restricted:D,hasExcludedProperties:h}=this.doParseRaw(l,o);this._configurationModel=new p(S,w,g,h?[l]:void 0),this._restrictedConfigurations=D||[]}doParseContent(l){let o={},S=null,w=[];const g=[],D=[];function h(b){Array.isArray(w)?w.push(b):S!==null&&(w[S]=b)}const _={onObjectBegin:()=>{const b={};h(b),g.push(w),w=b,S=null},onObjectProperty:b=>{S=b},onObjectEnd:()=>{w=g.pop()},onArrayBegin:()=>{const b=[];h(b),g.push(w),w=b,S=null},onArrayEnd:()=>{w=g.pop()},onLiteralValue:h,onError:(b,A,F)=>{D.push({error:b,offset:A,length:F})}};if(l)try{P.visit(l,_),o=w[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return o}doParseRaw(l,o){const S=u.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),w=this.filter(l,S,!0,o);l=w.raw;const g=(0,R.toValuesTree)(l,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),D=Object.keys(l),h=this.toOverrides(l,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:g,keys:D,overrides:h,restricted:w.restricted,hasExcludedProperties:w.hasExcludedProperties}}filter(l,o,S,w){let g=!1;if(!w?.scopes&&!w?.skipRestricted&&!w?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:g};const D={},h=[];for(const _ in l)if(C.OVERRIDE_PROPERTY_REGEX.test(_)&&S){const b=this.filter(l[_],o,!1,w);D[_]=b.raw,g=g||b.hasExcludedProperties,h.push(...b.restricted)}else{const b=o[_],A=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&h.push(_),!w.exclude?.includes(_)&&(w.include?.includes(_)||(A===void 0||w.scopes===void 0||w.scopes.includes(A))&&!(w.skipRestricted&&b?.restricted))?D[_]=l[_]:g=!0}return{raw:D,restricted:h,hasExcludedProperties:g}}toOverrides(l,o){const S=[];for(const w of Object.keys(l))if(C.OVERRIDE_PROPERTY_REGEX.test(w)){const g={};for(const D in l[w])g[D]=l[w][D];S.push({identifiers:(0,C.overrideIdentifiersFromKey)(w),keys:Object.keys(g),contents:(0,R.toValuesTree)(g,o)})}return S}}e.ConfigurationModelParser=s;class c extends O.Disposable{constructor(l,o,S,w){super(),this.userSettingsResource=l,this.parseOptions=o,this.fileService=w,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this._register(this.fileService.watch(S.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&S.isEqual(g.resource,l)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const l=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(l.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(l){return l&&(this.parseOptions=l),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class t{constructor(l,o,S,w,g,D,h,_,b,A,F,j,H){this.key=l,this.overrides=o,this._value=S,this.overrideIdentifiers=w,this.defaultConfiguration=g,this.policyConfiguration=D,this.applicationConfiguration=h,this.userConfiguration=_,this.localUserConfiguration=b,this.remoteUserConfiguration=A,this.workspaceConfiguration=F,this.folderConfigurationModel=j,this.memoryConfigurationModel=H}get value(){return E(this._value)}toInspectValue(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class n{constructor(l,o,S,w,g=new p,D=new p,h=new T.ResourceMap,_=new p,b=new T.ResourceMap){this._defaultConfiguration=l,this._policyConfiguration=o,this._applicationConfiguration=S,this._localUserConfiguration=w,this._remoteUserConfiguration=g,this._workspaceConfiguration=D,this._folderConfigurations=h,this._memoryConfiguration=_,this._memoryConfigurationByResource=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(l,o,S){return this.getConsolidatedConfigurationModel(l,o,S).getValue(l)}updateValue(l,o,S={}){let w;S.resource?(w=this._memoryConfigurationByResource.get(S.resource),w||(w=new p,this._memoryConfigurationByResource.set(S.resource,w))):w=this._memoryConfiguration,o===void 0?w.removeValue(l):w.setValue(l,o),S.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(l,o,S){const w=this.getConsolidatedConfigurationModel(l,o,S),g=this.getFolderConfigurationModelForResource(o.resource,S),D=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,h=new Set;for(const _ of w.overrides)for(const b of _.identifiers)w.getOverrideValue(l,b)!==void 0&&h.add(b);return new t(l,o,w.getValue(l),h.size?[...h]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this._workspaceConfiguration:void 0,g||void 0,D)}keys(l){const o=this.getFolderConfigurationModelForResource(void 0,l);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(l){this._defaultConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(l){this._policyConfiguration=l}updateApplicationConfiguration(l){this._applicationConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(l){this._localUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(l){this._remoteUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(l){this._workspaceConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(l,o){this._folderConfigurations.set(l,o),this._foldersConsolidatedConfigurations.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this._foldersConsolidatedConfigurations.delete(l)}compareAndUpdateDefaultConfiguration(l,o){const S=[];if(!o){const{added:w,updated:g,removed:D}=d(this._defaultConfiguration,l);o=[...w,...g,...D]}for(const w of o)for(const g of(0,C.overrideIdentifiersFromKey)(w)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(g),h=l.getKeysForOverrideIdentifier(g),_=[...h.filter(b=>D.indexOf(b)===-1),...D.filter(b=>h.indexOf(b)===-1),...D.filter(b=>!m.equals(this._defaultConfiguration.override(g).getValue(b),l.override(g).getValue(b)))];S.push([g,_])}return this.updateDefaultConfiguration(l),{keys:o,overrides:S}}compareAndUpdatePolicyConfiguration(l){const{added:o,updated:S,removed:w}=d(this._policyConfiguration,l),g=[...o,...S,...w];return g.length&&this.updatePolicyConfiguration(l),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:o,updated:S,removed:w,overrides:g}=d(this.applicationConfiguration,l),D=[...o,...S,...w];return D.length&&this.updateApplicationConfiguration(l),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(l){const{added:o,updated:S,removed:w,overrides:g}=d(this.localUserConfiguration,l),D=[...o,...S,...w];return D.length&&this.updateLocalUserConfiguration(l),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(l){const{added:o,updated:S,removed:w,overrides:g}=d(this.remoteUserConfiguration,l),D=[...o,...S,...w];return D.length&&this.updateRemoteUserConfiguration(l),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(l){const{added:o,updated:S,removed:w,overrides:g}=d(this.workspaceConfiguration,l),D=[...o,...S,...w];return D.length&&this.updateWorkspaceConfiguration(l),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(l,o){const S=this.folderConfigurations.get(l),{added:w,updated:g,removed:D,overrides:h}=d(S,o),_=[...w,...g,...D];return(_.length||!S)&&this.updateFolderConfiguration(l,o),{keys:_,overrides:h}}compareAndDeleteFolderConfiguration(l){const o=this.folderConfigurations.get(l);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:S,updated:w,removed:g,overrides:D}=d(o,void 0);return{keys:[...S,...w,...g],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(l,o,S){let w=this.getConsolidatedConfigurationModelForResource(o,S);return o.overrideIdentifier&&(w=w.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(l)!==void 0&&(w=w.merge(this._policyConfiguration)),w}getConsolidatedConfigurationModelForResource({resource:l},o){let S=this.getWorkspaceConsolidatedConfiguration();if(o&&l){const w=o.getFolder(l);w&&(S=this.getFolderConsolidatedConfiguration(w.uri)||S);const g=this._memoryConfigurationByResource.get(l);g&&(S=S.merge(g))}return S}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(l){let o=this._foldersConsolidatedConfigurations.get(l);if(!o){const S=this.getWorkspaceConsolidatedConfiguration(),w=this._folderConfigurations.get(l);w?(o=S.merge(w),this._foldersConsolidatedConfigurations.set(l,o)):o=S}return o}getFolderConfigurationModelForResource(l,o){if(o&&l){const S=o.getFolder(l);if(S)return this._folderConfigurations.get(S.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((l,o)=>{const{contents:S,overrides:w,keys:g}=this._folderConfigurations.get(o);return l.push([o,{contents:S,overrides:w,keys:g}]),l},[])}}allKeys(){const l=new Set;return this._defaultConfiguration.keys.forEach(o=>l.add(o)),this.userConfiguration.keys.forEach(o=>l.add(o)),this._workspaceConfiguration.keys.forEach(o=>l.add(o)),this._folderConfigurations.forEach(o=>o.keys.forEach(S=>l.add(S))),[...l.values()]}allOverrideIdentifiers(){const l=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(o=>l.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>l.add(o)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(o=>l.add(o)),this._folderConfigurations.forEach(o=>o.getAllOverrideIdentifiers().forEach(S=>l.add(S))),[...l.values()]}getAllKeysForOverrideIdentifier(l){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(l).forEach(S=>o.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(S=>o.add(S)),this._workspaceConfiguration.getKeysForOverrideIdentifier(l).forEach(S=>o.add(S)),this._folderConfigurations.forEach(S=>S.getKeysForOverrideIdentifier(l).forEach(w=>o.add(w))),[...o.values()]}static parse(l){const o=this.parseConfigurationModel(l.defaults),S=this.parseConfigurationModel(l.policy),w=this.parseConfigurationModel(l.application),g=this.parseConfigurationModel(l.user),D=this.parseConfigurationModel(l.workspace),h=l.folders.reduce((_,b)=>(_.set(y.URI.revive(b[0]),this.parseConfigurationModel(b[1])),_),new T.ResourceMap);return new n(o,S,w,g,new p,D,h,new p,new T.ResourceMap)}static parseConfigurationModel(l){return new p(l.contents,l.keys,l.overrides)}}e.Configuration=n;function r(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const l=new Set,o=new Map;for(const w of v)w.keys.forEach(g=>l.add(g)),w.overrides.forEach(([g,D])=>{const h=(0,T.getOrSet)(o,g,new Set);D.forEach(_=>h.add(_))});const S=[];return o.forEach((w,g)=>S.push([g,[...w.values()]])),{keys:[...l.values()],overrides:S}}e.mergeChanges=r;class a{constructor(l,o,S,w){this.change=l,this.previous=o,this.currentConfiguraiton=S,this.currentWorkspace=w,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const g of l.keys)this.affectedKeys.add(g);for(const[,g]of l.overrides)for(const D of g)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const g of this.affectedKeys)this._affectsConfigStr+=g+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=n.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(l,o){const S=this._marker+l,w=this._affectsConfigStr.indexOf(S);if(w<0)return!1;const g=w+S.length;if(g>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(g);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(o){const h=this.previousConfiguration?this.previousConfiguration.getValue(l,o,this.previous?.workspace):void 0,_=this.currentConfiguraiton.getValue(l,o,this.currentWorkspace);return!m.equals(h,_)}return!0}}e.ConfigurationChangeEvent=a;function d(v,l){const{added:o,removed:S,updated:w}=i(l?.rawConfiguration,v?.rawConfiguration),g=[],D=v?.getAllOverrideIdentifiers()||[],h=l?.getAllOverrideIdentifiers()||[];if(l){const _=h.filter(b=>!D.includes(b));for(const b of _)g.push([b,l.getKeysForOverrideIdentifier(b)])}if(v){const _=D.filter(b=>!h.includes(b));for(const b of _)g.push([b,v.getKeysForOverrideIdentifier(b)])}if(l&&v){for(const _ of D)if(h.includes(_)){const b=i({contents:v.getOverrideValue(void 0,_)||{},keys:v.getKeysForOverrideIdentifier(_)},{contents:l.getOverrideValue(void 0,_)||{},keys:l.getKeysForOverrideIdentifier(_)});g.push([_,[...b.added,...b.removed,...b.updated]])}}return{added:o,removed:S,updated:w,overrides:g}}function i(v,l){const o=v?l?v.keys.filter(g=>l.keys.indexOf(g)===-1):[...v.keys]:[],S=l?v?l.keys.filter(g=>v.keys.indexOf(g)===-1):[...l.keys]:[],w=[];if(v&&l){for(const g of l.keys)if(v.keys.indexOf(g)!==-1){const D=(0,R.getConfigurationValue)(l.contents,g),h=(0,R.getConfigurationValue)(v.contents,g);m.equals(D,h)||w.push(g)}}return{added:o,removed:S,updated:w}}}),define(Te[100],Ae([1,0,15,4]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class T{constructor(C,u){this.host=C,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends I.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof f&&C._code===m.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof f&&C._code===m.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof f&&C._code===m.NoResolverFound}static isInvalidAuthority(C){return C instanceof f&&C._code===m.InvalidAuthority}static isHandled(C){return C instanceof f&&C.isHandled}constructor(C,u=m.Unknown,E){super(C),this._message=C,this._code=u,this._detail=E,this.isHandled=u===m.NotAvailable&&E===!0,Object.setPrototypeOf(this,f.prototype)}}e.RemoteAuthorityResolverError=f;function y(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.getRemoteAuthorityPrefix=y}),define(Te[57],Ae([1,0,12]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===I.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function P(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.getRemoteName=P;function O(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=O;function T(y){const{host:R,port:C}=f(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.parseAuthorityWithPort=T;function m(y,R){let{host:C,port:u}=f(y);return typeof u>"u"&&(u=R),{host:C,port:u}}e.parseAuthorityWithOptionalPort=m;function f(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const u=y.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:y,port:void 0}}}),define(Te[20],Ae([1,0,13,4,57]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(T||(e.ExtensionType=T={}));var m;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.LINUX_PPC64LE="linux-ppc64le",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,t){if(typeof c>"u"||c===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof c=="string"||typeof t=="string"){const n=typeof c=="string"?c:c.value,r=typeof t=="string"?t:t.value;return I.equalsIgnoreCase(n,r)}return c._lower===t._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=f;class y{get size(){return this._set.size}constructor(c){if(this._set=new Set,c)for(const t of c)this.add(t)}add(c){this._set.add(f.toKey(c))}delete(c){return this._set.delete(f.toKey(c))}has(c){return this._set.has(f.toKey(c))}}e.ExtensionIdentifierSet=y;class R{constructor(){this._map=new Map}clear(){this._map.clear()}delete(c){this._map.delete(f.toKey(c))}get(c){return this._map.get(f.toKey(c))}has(c){return this._map.has(f.toKey(c))}set(c,t){this._map.set(f.toKey(c),t)}values(){return this._map.values()}forEach(c){this._map.forEach(c)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function C(s){return u(s)}e.isApplicationScopedExtension=C;function u(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=u;function E(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function p(s,c){if(c){const t=`onResolveRemoteAuthority:${(0,P.getRemoteName)(c)}`;return!!s.activationEvents?.includes(t)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Te[101],Ae([1,0,15,20]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class P{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,m){this._generators.set(T,m)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const m=Object.create(null);for(const f of T){const y=this.readActivationEvents(f);y.length>0&&(m[L.ExtensionIdentifier.toKey(f.identifier)]=y)}return m}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const m=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${L.ExtensionIdentifier.toKey(T.identifier)}`);if(!T.contributes)return m;for(const f in T.contributes){const y=this._generators.get(f);if(!y)continue;const R=T.contributes[f],C=Array.isArray(R)?R:[R];try{y(C,m)}catch(u){(0,I.onUnexpectedError)(u)}}return m}}e.ImplicitActivationEventsImpl=P,e.ImplicitActivationEvents=new P}),define(Te[192],Ae([1,0,21,73,33]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(f){if(I.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function T(f,y,R,C,u,E,p,s,c){const t=Object.create(null);t["common.machineId"]=E,t["common.sqmId"]=p,t.sessionID=(0,P.generateUuid)()+Date.now(),t.commitHash=C,t.version=u,t["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,I.PlatformToString)(I.platform),t["common.nodePlatform"]=L.platform,t["common.nodeArch"]=R,t["common.product"]=c||"desktop",s&&(t["common.msftInternal"]=s);let n=0;const r=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.isLinuxSnap&&(t["common.snap"]="true");const a=O(y);return a&&(t["common.platformDetail"]=a),t}e.resolveCommonProperties=T;function m(f){const y=L.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return f.some(C=>R===C)}e.verifyMicrosoftInternalDomain=m}),define(Te[193],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Te[58],Ae([1,0,26,16,57,192,193]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=f,e.NullTelemetryService=new f;class y{async publicLog(v,l,o){}async publicLogError(v,l,o){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(i,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=R;function C(i,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=C;function u(i){const v=i.getValue(T.TELEMETRY_SETTING_ID),l=i.getValue(T.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=u;function E(i){const v={},l={},o={};c(i,o);for(let S in o){S=S.length>150?S.substr(S.length-149):S;const w=o[S];typeof w=="number"?l[S]=w:typeof w=="boolean"?l[S]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${w.length}`),v[S]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(v[S]=w)}return{properties:v,measurements:l}}e.validateTelemetryData=E;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const v=(0,P.getRemoteName)(i);return p.has(v)?v:"other"}e.cleanRemoteAuthority=s;function c(i,v,l=0,o){if(i)for(const S of Object.getOwnPropertyNames(i)){const w=i[S],g=o?o+S:S;Array.isArray(w)?v[g]=(0,I.safeStringify)(w):w instanceof Date?v[g]=w.toISOString():(0,L.isObject)(w)?l<2?c(w,v,l+1,g+"."):v[g]=(0,I.safeStringify)(w):v[g]=w}}function t(i,v){const l=i.msftInternalDomains||[],o=v.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(l)||o}e.isInternalTelemetry=t;function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=n;function r(i,v){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const o=[];for(const D of v)for(;;){const h=D.exec(i);if(!h)break;o.push([h.index,D.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(l="";;){const D=w.exec(i);if(!D)break;const h=o.some(([_,b])=>D.index<b&&_<w.lastIndex);!S.test(D[0])&&!h&&(l+=i.substring(g,D.index)+"<REDACTED: user-file-path>",g=w.lastIndex)}return g<i.length&&(l+=i.substr(g)),l}function a(i){if(!i)return i;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of v)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function d(i,v){return(0,I.cloneAndChange)(i,l=>{if(l instanceof m||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let o=l.replaceAll("%20"," ");o=r(o,v);for(const S of v)o=o.replace(S,"");return o=a(o),o}})}e.cleanData=d}),define(Te[194],Ae([1,0,13,96,20,21,2,15,73,58]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(l,o){return l.uuid&&o.uuid?l.uuid===o.uuid:l.id===o.id?!0:(0,I.compareIgnoreCase)(l.id,o.id)===0}e.areSameExtensions=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const S=o.manifest?o.manifest.version:o.version,w=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,S,w)}static parse(o){const S=C.exec(o);return S&&S[1]&&S[2]?new u({id:S[1]},S[2],S[4]||void 0):null}constructor(o,S,w="undefined"){this.version=S,this.targetPlatform=w,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(l){const o=E.exec(l);return o&&o[1]?[c(o[1]),o[2]]:[c(l),void 0]}e.getIdAndVersion=p;function s(l,o){return`${l}.${o}`}e.getExtensionId=s;function c(l){return l.toLowerCase()}e.adoptToGalleryExtensionId=c;function t(l,o){return c(s(l??P.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=t;function n(l,o){const S=[],w=g=>{for(const D of S)if(D.some(h=>R(o(h),o(g))))return D;return null};for(const g of l){const D=w(g);D?D.push(g):S.push([g])}return S}e.groupByExtension=n;function r(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function a(l){return{id:new y.TelemetryTrustedValue(l.identifier.id),name:new y.TelemetryTrustedValue(l.name),galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),isSigned:l.isSigned,...l.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function d(l,o){const S=[],w=o.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const g=w.shift();if(g&&S.every(D=>!R(D.identifier,{id:g}))){const D=l.filter(h=>R(h.identifier,{id:g}));D.length===1&&(S.push(D[0]),w.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=d;async function i(l,o){if(!O.isLinux)return!1;let S;try{S=(await l.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{S=(await l.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){o.debug("Error while getting the os-release file.",(0,m.getErrorMessage)(g))}}return!!S&&(S.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(l,o){const S=await i(l,o),w=(0,L.getTargetPlatform)(S?"alpine":O.platform,f.arch);return o.debug("ComputeTargetPlatform:",w),w}e.computeTargetPlatform=v}),define(Te[195],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function I(f){return[...f.entries()]}e.serializeEnvironmentVariableCollection=I;function L(f){return f?[...f.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function P(f){return new Map(f)}e.deserializeEnvironmentVariableCollection=P;function O(f){return new Map(f??[])}e.deserializeEnvironmentDescriptionMap=O;function T(f){return Array.from(f.entries()).map(y=>[y[0],I(y[1].map),L(y[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function m(f){return new Map(f.map(y=>[y[0],{map:P(y[1]),descriptionMap:O(y[2])}]))}e.deserializeEnvironmentVariableCollections=m}),define(Te[196],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class I{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,O,T=5){const m=O(f=>{const y=typeof f=="string"?f:f.data;let R=this._terminalBufferMap.get(P);if(R){R.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(P),T);R={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(P),m.dispose()}},this._terminalBufferMap.set(P,R)});return m}stopBuffering(P){this._terminalBufferMap.get(P)?.dispose()}flushBuffer(P){const O=this._terminalBufferMap.get(P);O&&(this._terminalBufferMap.delete(P),this._callback(P,O.data.join("")))}}e.TerminalDataBufferer=I}),define(Te[197],Ae([1,0,11,89,41,5,16,2,156,72,30]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var C;(function(a){function d(i,v){let l=i.defaults;for(;P.ThemeIcon.isThemeIcon(l);){const o=p.getIcon(l.id);if(!o)return;l=o.defaults}return l}a.getDefinition=d})(C||(e.IconContribution=C={}));var u;(function(a){function d(v){return{weight:v.weight,style:v.style,src:v.src.map(l=>({format:l.format,location:l.location.toString()}))}}a.toJSONObject=d;function i(v){const l=o=>(0,T.isString)(o)?o:void 0;if(v&&Array.isArray(v.src)&&v.src.every(o=>(0,T.isString)(o.format)&&(0,T.isString)(o.location)))return{weight:l(v.weight),style:l(v.style),src:v.src.map(o=>({format:o.format,location:m.URI.parse(o.location)}))}}a.fromJSONObject=i})(u||(e.IconFontDefinition=u={}));class E{constructor(){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(d,i,v,l){const o=this.iconsById[d];if(o){if(v&&!o.description){o.description=v,this.iconSchema.properties[d].markdownDescription=`${v} $(${d})`;const g=this.iconReferenceSchema.enum.indexOf(d);g!==-1&&(this.iconReferenceSchema.enumDescriptions[g]=v),this._onDidChange.fire()}return o}const S={id:d,description:v,defaults:i,deprecationMessage:l};this.iconsById[d]=S;const w={$ref:"#/definitions/icons"};return l&&(w.deprecationMessage=l),v&&(w.markdownDescription=`${v}: $(${d})`),this.iconSchema.properties[d]=w,this.iconReferenceSchema.enum.push(d),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:d}}deregisterIcon(d){delete this.iconsById[d],delete this.iconSchema.properties[d];const i=this.iconReferenceSchema.enum.indexOf(d);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(d=>this.iconsById[d])}getIcon(d){return this.iconsById[d]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(d,i){const v=this.iconFontsById[d];return v||(this.iconFontsById[d]=i,this._onDidChange.fire(),i)}deregisterIconFont(d){delete this.iconFontsById[d]}getIconFont(d){return this.iconFontsById[d]}toString(){const d=(o,S)=>o.id.localeCompare(S.id),i=o=>{for(;P.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`},v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of l.filter(S=>!!S.description).sort(d))v.push(`|<i class="${i(o)}"></i>|${o.id}|${P.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const o of l.filter(S=>!P.ThemeIcon.isThemeIcon(S.defaults)).sort(d))v.push(`|<i class="${i(o)}"></i>|${o.id}|`);return v.join(`
`)}}const p=new E;R.Registry.add(e.Extensions.IconContribution,p);function s(a,d,i,v){return p.registerIcon(a,d,i,v)}e.registerIcon=s;function c(){return p}e.getIconRegistry=c;function t(){const a=(0,L.getCodiconFontCharacters)();for(const d in a){const i="\\"+a[d].toString(16);p.registerIcon(d,{fontCharacter:i})}}t(),e.iconsSchemaId="vscode://schemas/icons";const n=R.Registry.as(y.Extensions.JSONContribution);n.registerSchema(e.iconsSchemaId,p.getIconSchema());const r=new I.RunOnceScheduler(()=>n.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.widgetClose=s("widget-close",L.Codicon.close,(0,f.localize)(2,null)),e.gotoPreviousLocation=s("goto-previous-location",L.Codicon.arrowUp,(0,f.localize)(3,null)),e.gotoNextLocation=s("goto-next-location",L.Codicon.arrowDown,(0,f.localize)(4,null)),e.syncing=P.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=P.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(Te[198],Ae([1,0,5,46,4,14]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var T;(function(c){c.Http="http",c.Https="https"})(T||(e.TunnelProtocol=T={}));var m;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(m||(e.TunnelPrivacyId=m={}));function f(c){return!!c.forwardPort}e.isTunnelProvider=f;var y;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=u;function E(c,t,n,r){if(n===1)return!1;if(n===2&&u(t)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(a?.length===4&&parseInt(a[1])>=18)return!1}return c<1024}e.isPortPrivileged=E;class p{constructor(t,n,r){this.remoteAddress=t,this.localAddress=n,this._dispose=r,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let s=class{constructor(t,n){this.logService=t,this.configurationService=n,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions,this._canChangeProtocol=t.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],n=Array.from(this._tunnels.values());for(const r of n){const a=Array.from(r.values());for(const d of a){const i=await d.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this._tunnels.values()){for(const{value:n}of t.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,n,r,a,d){this.addTunnelToMap(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:r,privacy:a,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(u(t)||C(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const r=this.getTunnelFromMap(t,n);if(r)return++r.refcount,r.value}openTunnel(t,n,r,a,d,i=!1,v,l){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${d}.`);const o=this._tunnelProvider??t;if(!o)return;if(n||(n="localhost"),a||(a=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(r)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.retainOrCreateTunnel(o,n,r,a,d,i,v,l);return S?S.then(w=>{if(w){if(typeof w=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(n,r),w}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(n,r);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.makeTunnel(w);return(w.tunnelRemoteHost!==n||w.tunnelRemotePort!==r)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),v&&w.privacy!==v&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(g),g}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this._tunnels.get(t.tunnelRemoteHost);if(n){const r=n.get(t.tunnelRemotePort);r&&(r.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async tryDisposeTunnel(t,n,r){if(r.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const a=r.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(n),a}}async closeTunnel(t,n){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const r=this._tunnels.get(t);if(r&&r.has(n)){const a=r.get(n);a.refcount=0,await this.tryDisposeTunnel(t,n,a)}}addTunnelToMap(t,n,r){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(n,{refcount:1,value:r})}async removeEmptyOrErrorTunnelFromMap(t,n){const r=this._tunnels.get(t);if(r){const a=r.get(n),d=a?await a.value:void 0;(!d||typeof d=="string")&&r.delete(n),r.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,n){const r=[t];C(t)?(r.push(...e.LOCALHOST_ADDRESSES),r.push(...e.ALL_INTERFACES_ADDRESSES)):u(t)&&r.push(...e.ALL_INTERFACES_ADDRESSES);const a=r.map(d=>this._tunnels.get(d));for(const d of a){const i=d?.get(n);if(i)return i}}canTunnel(t){return!!R(t)}createWithProvider(t,n,r,a,d,i,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${a}.`);const l=r;this._factoryInProgress.add(l);const o=a===void 0?r:a,S={elevationRequired:d?this.isPortPrivileged(o):!1},w={remoteAddress:{host:n,port:r},localAddressPort:a,privacy:i,public:i?i!==m.Private:void 0,protocol:v},g=t.forwardPort(w,S);return g?(this.addTunnelToMap(n,r,g),g.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),g}};e.AbstractTunnelService=s,e.AbstractTunnelService=s=Ge([Ve(0,O.ILogService),Ve(1,L.IConfigurationService)],s)}),define(Te[199],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,I.createDecorator)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Te[200],Ae([1,0,12]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function L(f){return f.scheme!==I.Schemas.file&&f.scheme!==I.Schemas.vscodeRemote}e.isVirtualResource=L;function P(f){if(f.folders.length)return f.folders.every(y=>L(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&L(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=P;function O(f){return P(f)?.scheme}e.getVirtualWorkspaceScheme=O;function T(f){return P(f)?.authority}e.getVirtualWorkspaceAuthority=T;function m(f){return P(f)!==void 0}e.isVirtualWorkspace=m}),define(Te[47],Ae([1,0,157,19,50,25,2,4,12]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,m.createDecorator)("contextService");function y(o){const S=o;return typeof S?.id=="string"&&T.URI.isUri(S.uri)}e.isSingleFolderWorkspaceIdentifier=y;function R(o){return typeof o?.id=="string"&&!y(o)&&!u(o)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(o,S){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,L.basename)(o)}:S?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const w=o;return w.configuration?{id:w.id,configPath:w.configuration}:w.folders.length===1?{id:w.id,uri:w.folders[0].uri}:{id:w.id}}e.toWorkspaceIdentifier=C;function u(o){const S=o;return typeof S?.id=="string"&&T.URI.isUri(S.configPath)}e.isWorkspaceIdentifier=u;function E(o){const S=o;if(S?.uri)return{id:S.id,uri:T.URI.revive(S.uri)};const w=o;if(w?.configPath)return{id:w.id,configPath:T.URI.revive(w.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var p;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function s(o){const S=o;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=s;function c(o){const S=o;return!!(S&&typeof S=="object"&&T.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=c;class t{constructor(S,w,g,D,h){this._id=S,this._transient=g,this._configuration=D,this._ignorePathCasing=h,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=w}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=t;class n{constructor(S,w){this.raw=w,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,O.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function r(o){return new n({uri:o,index:0,name:(0,O.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=r,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(o,S){return O.extUriBiasedIgnorePathCase.isEqualOrParent(o,S.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function d(o){let S;return T.URI.isUri(o)?S=o:S=o.configuration,S?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=d,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function v(o,S){return!a(o,S)&&!d(o)}e.isSavedWorkspace=v;function l(o){return(typeof o=="string"?(0,L.extname)(o):(0,O.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(Te[74],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class I{static{this.enableDebugLogging=!1}constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const O=this._idPool++;return this._data.set(O,P),this.logDebugInfo(),O}get(P,O){return this._data.has(P)?this._data.get(P)[O]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){I.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=I}),define(Te[43],Ae([1,0,12,25,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class O{constructor(){this._systemSchemes=new Set(Object.keys(I.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(m=>{const f=this._providerInfo.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this._providerInfo.delete(m.scheme):this._providerInfo.set(m.scheme,f)}isFreeScheme(m){return!this._providerInfo.has(m)&&!this._systemSchemes.has(m)}getCapabilities(m){return this._providerInfo.get(m)}}e.ExtHostFileSystemInfo=O,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(Te[27],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,I.createDecorator)("IExtHostInitDataService")}),define(Te[201],Ae([1,0,163,14,188,27]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends P.LogService{constructor(f,y,R){const C=R.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",u=R.remote.isRemote?(0,I.localize)(0,null):f?(0,I.localize)(1,null):(0,I.localize)(2,null);super(y.createLogger(C,{name:u}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=Ge([Ve(1,L.ILoggerService),Ve(2,O.IExtHostInitDataService)],T)}),define(Te[202],Ae([1,0,11]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,m,f){this._deferredPromises=new Map,this._id=T,this._shared=m,this._storage=f,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new I.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of y.values())R.complete()}catch(R){for(const C of y.values())C.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,m){let f=this._value[T];return typeof f>"u"&&(f=m),f}update(T,m){this._value[T]=m;const f=this._deferredPromises.get(T);if(f!==void 0)return f.p;const y=new I.DeferredPromise;return this._deferredPromises.set(T,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class P extends L{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,m){super(T.identifier.value,!0,m),this._extension=T}}e.ExtensionGlobalMemento=P}),define(Te[203],Ae([1,0,5,2]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class P{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new I.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,m,f,y){const C=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptModelChanged(m.value,f,y);this._onDidChangeNotebookDocument.fire(C)}$acceptDirtyStateChanged(T,m){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T)).acceptDirty(m)}$acceptModelSaved(T){const m=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(T));this._onDidSaveNotebookDocument.fire(m.apiNotebook)}}e.ExtHostNotebookDocuments=P}),define(Te[17],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class L{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=L}),define(Te[204],Ae([1,0,20,5]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{#e;constructor(T,m){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=I.ExtensionIdentifier.toKey(T.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this._id&&this._onDidChange.fire({key:f.key})})}get(T){return this.#e.get(this._id,T)}store(T,m){return this.#e.store(this._id,T,m)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=P}),define(Te[59],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,I.createDecorator)("IURITransformerService");class L{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(Te[205],Ae([1,0,24]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(f){let y=this.buffers.indexOf(f);return y<0&&(y=this.buffers.length,this.buffers.push(f)),y}}function P(m,f){if(f.serializeBuffersForPostMessage){const y=new L,C=JSON.stringify(m,(E,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(p)};if(ArrayBuffer.isView(p)){const s=O(p);if(s)return{$$vscode_array_buffer_reference$$:!0,index:y.add(p.buffer),view:{type:s,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),u=y.buffers.map(E=>{const p=new Uint8Array(E);return I.VSBuffer.wrap(p)});return{message:C,buffers:u}}else return{message:JSON.stringify(m),buffers:[]}}e.serializeWebviewMessage=P;function O(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(m,f){const y=f.map(u=>{const E=new ArrayBuffer(u.byteLength);return new Uint8Array(E).set(u.buffer),E}),R=f.length?(u,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const p=E,{index:s}=p,c=y[s];if(p.view)switch(p.view.type){case 1:return new Int8Array(c,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return E}:void 0;return{message:JSON.parse(m,R),arrayBuffers:y}}e.deserializeWebviewMessage=T}),define(Te[102],Ae([1,0,172,16,2,6,4,30,42,12,34,135,32]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffListEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var p;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function s(ee){const X=ee;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.isEditorPaneWithSelection=s;function c(ee,X,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===X&&ee.matches(ne.input))return ne.getViewState()}e.findViewStateForEditor=c;function t(ee){if(g(ee))return!1;const X=ee;return P.URI.isUri(X?.resource)}e.isResourceEditorInput=t;function n(ee){if(g(ee))return!1;const X=ee;return X?.original!==void 0&&X.modified!==void 0}e.isResourceDiffEditorInput=n;function r(ee){if(g(ee))return!1;const X=ee;return!X||X.resources&&!Array.isArray(X.resources)?!1:!!X.resources||!!X.multiDiffSource}e.isResourceDiffListEditorInput=r;function a(ee){if(g(ee)||n(ee))return!1;const X=ee;return X?.primary!==void 0&&X.secondary!==void 0}e.isResourceSideBySideEditorInput=a;function d(ee){if(g(ee))return!1;const X=ee;return X?X.resource===void 0||X.resource.scheme===y.Schemas.untitled||X.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;function i(ee){if(g(ee))return!1;const X=ee;return P.URI.isUri(X?.base?.resource)&&P.URI.isUri(X?.input1?.resource)&&P.URI.isUri(X?.input2?.resource)&&P.URI.isUri(X?.result?.resource)}e.isResourceMergeEditorInput=i;var v;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(v||(e.Verbosity=v={}));var l;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class o{constructor(){this.mapIdToSaveSource=new Map}registerSource(X,V){let ne=this.mapIdToSaveSource.get(X);return ne||(ne={source:X,label:V},this.mapIdToSaveSource.set(X,ne)),ne.source}getSourceLabel(X){return this.mapIdToSaveSource.get(X)?.label??X}}e.SaveSourceRegistry=new o;var S;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad",ee[ee.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(S||(e.EditorInputCapabilities=S={}));class w extends O.Disposable{}e.AbstractEditorInput=w;function g(ee){return ee instanceof w}e.isEditorInput=g;function D(ee){const X=ee;return P.URI.isUri(X?.preferredResource)}function h(ee){const X=ee;return g(X?.primary)&&g(X?.secondary)}e.isSideBySideEditorInput=h;function _(ee){const X=ee;return g(X?.modified)&&g(X?.original)}e.isDiffEditorInput=_;function b(ee,X,V,ne,Ie){return pe(ne,[(0,C.toAction)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Fe={...V,limits:{size:Number.MAX_VALUE}};ee.openEditor(X,Fe)}}),(0,C.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.createTooLargeFileError=b;function A(ee){return g(ee?.editor)}e.isEditorInputWithOptions=A;function F(ee){const X=ee;return A(ee)&&X?.group!==void 0}e.isEditorInputWithOptionsAndGroup=F;function j(ee){const X=ee;return typeof X?.groupId=="number"&&g(X.editor)}e.isEditorIdentifier=j;var H;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var B;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_STICKY=11]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=12]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var k;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(k||(e.SideBySideEditor=k={}));class N{getOriginalUri(X,V){if(!X)return;if(i(X))return e.EditorResourceAccessor.getOriginalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Fe}=this.getSideEditors(X);if(Ie&&Fe){if(V?.supportSideBySide===k.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===k.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===k.PRIMARY?Ie:Fe}}if(n(X)||r(X)||a(X)||i(X))return;const ne=D(X)?X.preferredResource:X.resource;return!ne||!V||!V.filterByScheme?ne:this.filterUri(ne,V.filterByScheme)}getSideEditors(X){return h(X)||a(X)?{primary:X.primary,secondary:X.secondary}:_(X)||n(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,V){if(!X)return;if(i(X))return e.EditorResourceAccessor.getCanonicalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Fe}=this.getSideEditors(X);if(Ie&&Fe){if(V?.supportSideBySide===k.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===k.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===k.PRIMARY?Ie:Fe}}if(n(X)||r(X)||a(X)||i(X))return;const ne=X.resource;return!ne||!V||!V.filterByScheme?ne:this.filterUri(ne,V.filterByScheme)}filterUri(X,V){if(Array.isArray(V)){if(V.some(ne=>X.scheme===ne))return X}else if(V===X.scheme)return X}}var $;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})($||(e.EditorCloseMethod=$={}));function re(ee,X,V,ne){if(!ee.isSticky(X))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===$.MOUSE||V===$.KEYBOARD;case"mouse":return V===$.MOUSE;case"keyboard":return V===$.KEYBOARD}return!1}e.preventEditorClose=re,e.EditorResourceAccessor=new N;var le;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class _e{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(X){const V=this.instantiationService=X.get(T.IInstantiationService);for(const[ne,Ie]of this.editorSerializerConstructors)this.createEditorSerializer(ne,Ie,V);this.editorSerializerConstructors.clear()}createEditorSerializer(X,V,ne){const Ie=ne.createInstance(V);this.editorSerializerInstances.set(X,Ie)}registerFileEditorFactory(X){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=X}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(X,V){if(this.editorSerializerConstructors.has(X)||this.editorSerializerInstances.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.instantiationService?this.createEditorSerializer(X,V,this.instantiationService):this.editorSerializerConstructors.set(X,V),(0,O.toDisposable)(()=>{this.editorSerializerConstructors.delete(X),this.editorSerializerInstances.delete(X)})}getEditorSerializer(X){return this.editorSerializerInstances.get(typeof X=="string"?X:X.typeId)}}m.Registry.add(e.EditorExtensions.EditorFactory,new _e);async function ye(ee,X,V){return!ee||!ee.length?[]:await Promise.all(ee.map(async ne=>{const Ie=P.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await X.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let ke=ne.exists,we=ne.type;if(typeof ke!="boolean"||typeof we!="number")try{we=(await X.stat(Ie)).isDirectory?f.FileType.Directory:f.FileType.Unknown,ke=!0}catch(K){V.error(K),ke=!1}if(!ke&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(we===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const me={...ne.options,pinned:!0};return ke?{resource:Ie,options:me}:{resource:Ie,options:me,forceUntitled:!0}}))}e.pathsToEditors=ye;var de;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function Ee(ee){const X=ee;if(!X)return!1;const V=X;if(V.modified)return Ee(V.modified);const ne=X;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.isTextEditorViewState=Ee;function se(ee){return(0,R.isErrorWithActions)(ee)}e.isEditorOpenError=se;function pe(ee,X,V){const ne=(0,R.createErrorWithActions)(ee,X);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.createEditorOpenError=pe}),define(Te[206],Ae([1,0,5,173,4,6,28,30,18,26,89,197]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,L.localize)(0,null),e.defaultViewIcon=(0,C.registerIcon)("default-view-icon",R.Codicon.window,(0,L.localize)(1,null));var u;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var E;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.ViewContainerLocations=[0,1,2];function p(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;class s extends O.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new I.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new I.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,f.flatten)([...this.viewContainers.values()])}registerViewContainer(l,o,S){const w=this.get(l.id);if(w)return w;const g=l;return g.openCommandActionDescriptor=S?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,T.getOrSet)(this.viewContainers,o,[]).push(g),S?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:o}),g}deregisterViewContainer(l){for(const o of this.viewContainers.keys()){const S=this.viewContainers.get(o),w=S?.indexOf(l);if(w!==-1){S?.splice(w,1),S.length===0&&this.viewContainers.delete(o),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:o});return}}}get(l){return this.all.filter(o=>o.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(o=>this.getViewContainers(o).filter(S=>S?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(o=>this.getViewContainerLocation(o)===l)}}m.Registry.add(u.ViewContainersRegistry,new s);var c;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(c||(e.ViewContentGroups=c={}));function t(v,l){const o=v.group??c.More,S=l.group??c.More;return o!==S?o.localeCompare(S):(v.order??5)-(l.order??5)}class n extends O.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new I.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new I.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new I.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new I.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(l,o){this.registerViews2([{views:l,viewContainer:o}])}registerViews2(l){l.forEach(({views:o,viewContainer:S})=>this.addViews(o,S)),this._onViewsRegistered.fire(l)}deregisterViews(l,o){const S=this.removeViews(l,o);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:o})}moveViews(l,o){for(const S of this._views.keys())if(S!==o){const w=this.removeViews(l,S);w.length&&(this.addViews(w,o),this._onDidChangeContainer.fire({views:w,from:S,to:o}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const o of this._viewContainers){const S=(this._views.get(o)||[]).filter(w=>w.id===l)[0];if(S)return S}return null}getViewContainer(l){for(const o of this._viewContainers)if((this._views.get(o)||[]).filter(w=>w.id===l)[0])return o;return null}registerViewWelcomeContent(l,o){return this._viewWelcomeContents.add(l,o),this._onDidChangeViewWelcomeContent.fire(l),(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(l,o),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,o){const S=new Map;for(const[w,g]of o)this._viewWelcomeContents.add(l,g),S.set(w,(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(l,g),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),S}getViewWelcomeContent(l){const o=[];return this._viewWelcomeContents.forEach(l,S=>o.push(S)),o.sort(t)}addViews(l,o){let S=this._views.get(o);S||(S=[],this._views.set(o,S),this._viewContainers.push(o));for(const w of l){if(this.getView(w.id)!==null)throw new Error((0,L.localize)(2,null,w.id));S.push(w)}}removeViews(l,o){const S=this._views.get(o);if(!S)return[];const w=[],g=[];for(const D of S)l.includes(D)?w.push(D):g.push(D);return w.length&&(g.length?this._views.set(o,g):(this._views.delete(o),this._viewContainers.splice(this._viewContainers.indexOf(o),1))),w}}m.Registry.add(u.ViewsRegistry,new n),e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var r;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class d{constructor(l,o){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,l),this._hasResolve=!!o,this.resolve=async S=>{if(o&&!this.resolved){const w=await o(S);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=d;class i extends Error{constructor(l){super((0,L.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.NoTreeViewError=i}),define(Te[207],Ae([1,0,2,29,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function O(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof I.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(L.Range.isIRange)}e.isIDocumentContext=O;function T(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(O)}e.isIUsedContext=T;var m;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.IChatService=(0,P.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Te[208],Ae([1,0,5,11,174]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new I.Emitter,this._onExit=new I.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(m){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=m}onEvent(m){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=m}onRequest(m){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=m}sendResponse(m){m.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.internalSend("response",m)}sendRequest(m,f,y,R){const C={command:m};if(f&&Object.keys(f).length>0&&(C.arguments=f),this.internalSend("request",C),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.pendingRequests.get(C.seq);if(E){this.pendingRequests.delete(C.seq);const p={type:"response",seq:0,request_seq:C.seq,success:!1,command:m,message:(0,P.localize)(0,null,R,m)};E(p)}},R)}return y&&this.pendingRequests.set(C.seq,y),C.seq}acceptMessage(m){this.messageCallback?this.messageCallback(m):(this.queue.push(m),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(m,f){return m.type!=="event"||f.type!=="event"}async processQueue(){let m;for(;this.queue.length;){if((!m||this.needsTaskBoundaryBetween(this.queue[0],m))&&await(0,L.timeout)(0),m=this.queue.shift(),!m)return;switch(m.type){case"event":this.eventCallback?.(m);break;case"request":this.requestCallback?.(m);break;case"response":{const f=m,y=this.pendingRequests.get(f.request_seq);y&&(this.pendingRequests.delete(f.request_seq),y(f));break}}}}internalSend(m,f){f.type=m,f.seq=this.sequence++,this.sendMessage(f)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const m=new Map;this.pendingRequests.forEach((f,y)=>m.set(y,f)),await(0,L.timeout)(500),m.forEach((f,y)=>{f({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=O}),define(Te[209],Ae([1,0,2,175,36,4]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:L.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new P.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:L.localize(22,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:L.localize(25,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new P.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(27,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:L.localize(28,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(30,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(31,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:L.localize(33,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:L.localize(34,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(35,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(36,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(37,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(44,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:L.localize(45,null)}),e.CONTEXT_VARIABLE_VALUE=new P.RawContextKey("variableValue",!1,{type:"string",description:L.localize(46,null)}),e.CONTEXT_VARIABLE_TYPE=new P.RawContextKey("variableType",!1,{type:"string",description:L.localize(47,null)}),e.CONTEXT_VARIABLE_NAME=new P.RawContextKey("variableName",!1,{type:"string",description:L.localize(48,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new P.RawContextKey("variableLanguage",!1,{type:"string",description:L.localize(49,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new P.RawContextKey("variableExtensionId",!1,{type:"string",description:L.localize(50,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(51,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:L.localize(52,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:L.localize(53,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(54,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(55,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(56,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(57,null)});const T=t=>L.localize(58,null,t);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(59,null)};var m;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(m||(e.State=m={}));function f(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=f;var y;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var C;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.IDebugService=(0,O.createDecorator)("debugService");var u;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(u||(e.BreakpointWidgetContext=u={}));var E;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var p;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(p||(e.DebugTreeItemCollapsibleState=p={}));var s;(function(t){t.deserialize=n=>n,t.serialize=n=>n})(s||(e.IDebugVisualizationTreeItem=s={}));var c;(function(t){t.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:I.URI.revive(n.iconPath.light),dark:I.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),t.serialize=n=>n})(c||(e.IDebugVisualization=c={}))}),define(Te[210],Ae([1,0,13,2,19,26,12,29,22,18]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function C(D,h,_){return D.replace(R,function(b,A){return h&&A.length>0&&A[0]!=="_"?b:_&&_.hasOwnProperty(A)?_[A]:b})}e.formatPII=C;function u(D){const h={};for(const _ of Object.keys(D))_.startsWith("!")||(h[_]=D[_]);return h}e.filterExceptionsFromTelemetry=u;function E(D){return D.configuration.request==="attach"&&!p(D)&&(!D.parentSession||E(D.parentSession))}e.isSessionAttach=E;function p(D){let h=D.configuration.type;if(h)return h==="vslsShare"&&(h=D.configuration.adapterProxy.configuration.type),(0,I.equalsIgnoreCase)(h,"extensionhost")||(0,I.equalsIgnoreCase)(h,"pwa-extensionhost")?D:D.parentSession?p(D.parentSession):void 0}e.getExtensionHostDebugSession=p;function s(D){return D.type&&(D.label||D.program||D.runtime)}e.isDebuggerMainContribution=s;function c(D,h,_){let b,A=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=F.exec(D);){const H=j.index+1,B=H+j[0].length;if(H<=h&&B>=_){b=j[0],A=H;break}}if(b){const H=/\w+/g;let B=null;for(;(B=H.exec(b))&&!(B.index+1+A+B[0].length>=_););B&&(b=b.substring(0,H.lastIndex))}return b?{start:A,end:A+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=c;async function t(D,h,_,b){if(D.evaluatableExpressionProvider.has(h)){const A=D.evaluatableExpressionProvider.ordered(h),F=(0,y.coalesce)(await Promise.all(A.map(async j=>{try{return await j.provideEvaluatableExpression(h,_,b??f.CancellationToken.None)}catch{return}})));if(F.length>0){let j=F[0].expression;const H=F[0].range;return j||(j=h.getLineContent(_.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:j}}}else{const A=h.getLineContent(_.lineNumber),{start:F,end:j}=c(A,_.column,_.column),H=A.substring(F-1,j);return{matchingExpression:H,range:new m.Range(_.lineNumber,F,_.lineNumber,F+H.length)}}return null}e.getEvaluatableExpressionAtPosition=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(D){return!!(D&&D.match(n))}e.isUri=r;function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(r(D.path))return L.URI.parse(D.path);if((0,P.isAbsolute)(D.path))return L.URI.file(D.path)}return D.path}function d(D){if(typeof D.path=="object"){const h=L.URI.revive(D.path);if(h)return h.scheme===T.Schemas.file?h.fsPath:h.toString()}return D.path}function i(D,h){const _=h?a:d,b=(0,O.deepClone)(D);return l(b,(A,F)=>{A&&F&&(F.path=_(F))}),b}e.convertToDAPaths=i;function v(D,h){const _=h?a:d,b=(0,O.deepClone)(D);return l(b,(A,F)=>{!A&&F&&(F.path=_(F))}),b}e.convertToVSCPaths=v;function l(D,h){switch(D.type){case"event":{const _=D;switch(_.event){case"output":h(!1,_.body.source);break;case"loadedSource":h(!1,_.body.source);break;case"breakpoint":h(!1,_.body.breakpoint.source);break;default:break}break}case"request":{const _=D;switch(_.command){case"setBreakpoints":h(!0,_.arguments.source);break;case"breakpointLocations":h(!0,_.arguments.source);break;case"source":h(!0,_.arguments.source);break;case"gotoTargets":h(!0,_.arguments.source);break;case"launchVSCode":_.arguments.args.forEach(b=>h(!1,b));break;default:break}break}case"response":{const _=D;if(_.success&&_.body)switch(_.command){case"stackTrace":_.body.stackFrames.forEach(b=>h(!1,b.source));break;case"loadedSources":_.body.sources.forEach(b=>h(!1,b));break;case"scopes":_.body.scopes.forEach(b=>h(!1,b.source));break;case"setFunctionBreakpoints":_.body.breakpoints.forEach(b=>h(!1,b.source));break;case"setBreakpoints":_.body.breakpoints.forEach(b=>h(!1,b.source));break;case"disassemble":_.body?.instructions.forEach(A=>h(!1,A.location));break;default:break}break}}}function o(D){return D.filter(h=>!h.presentation?.hidden).sort((h,_)=>h.presentation?_.presentation?h.presentation.group?_.presentation.group?h.presentation.group!==_.presentation.group?h.presentation.group.localeCompare(_.presentation.group):S(h.presentation.order,_.presentation.order):-1:_.presentation.group?1:S(h.presentation.order,_.presentation.order):-1:_.presentation?1:0)}e.getVisibleAndSorted=o;function S(D,h){return typeof D!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:D-h}async function w(D,h){const _=D.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(_!=="none"&&(await h.saveAll(),_==="allEditorsInActiveGroup")){const b=h.activeEditorPane;b&&b.input.resource?.scheme===T.Schemas.untitled&&await h.save({editor:b.input,groupId:b.group.id})}await D.reloadConfiguration()}e.saveAllBeforeDebugStart=w;const g=(D,h)=>!D||!h?D===h:D.name===h.name&&D.path===h.path&&D.sourceReference===h.sourceReference;e.sourcesEqual=g}),define(Te[211],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.INotebookExecutionService=(0,I.createDecorator)("INotebookExecutionService")}),define(Te[212],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var L;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.INotebookKernelService=(0,I.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,I.createDecorator)("INotebookKernelHistoryService")}),define(Te[213],Ae([1,0,6,29,145,93]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class T extends I.Disposable{constructor(f,y,R){super(),this._source=f,this._inputTextBuffer=y,this._outputs=R,this._outputTextBuffers=void 0}_getFullModelRange(f){const y=f.getLineCount();return new L.Range(1,1,y,this._getLineMaxColumn(f,y))}_getLineMaxColumn(f,y){if(y<1||y>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(y)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const f=new P.PieceTreeTextBufferBuilder;f.acceptChunk(this._source);const y=f.finish(!0),{textBuffer:R,disposable:C}=y.create(1);this._inputTextBuffer=R,this._register(C)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(f=>{const y=new P.PieceTreeTextBufferBuilder;y.acceptChunk(f);const R=y.finish(!0),{textBuffer:C,disposable:u}=R.create(1);return this._register(u),C})),this._outputTextBuffers}findInInputs(f){const R=new O.SearchParams(f,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs(f){const R=new O.SearchParams(f,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const u=C.findMatchesLineByLine(this._getFullModelRange(C),R,!0,5e3);if(u.length!==0)return{textBuffer:C,matches:u}}).filter(C=>!!C):[]}}e.CellSearchModel=T}),define(Te[48],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var L;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(T,m,f=T.parent){if(T._isRoot)return new P([m]);const y=[T.id];for(let R=f;R&&R.id!==m;R=R.parent)y.push(R.id);return y.push(m),new P(y.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const m=T.indexOf("\0");return m===-1?T:T.slice(0,m)}static fromString(T){return new P(T.split("\0"))}static join(T,m){return new P([...T.path,m])}static joinToString(T,m){return T.toString()+"\0"+m}static parentId(T){const m=T.lastIndexOf("\0");return m===-1?void 0:T.slice(0,m)}static localId(T){const m=T.lastIndexOf("\0");return m===-1?T:T.slice(m+1)}static isChild(T,m){return m.startsWith(T)&&m[T.length]==="\0"}static compare(T,m){return T===m?0:P.isChild(T,m)?2:P.isChild(m,T)?3:1}constructor(T,m=T.length){if(this.path=T,this.viewEnd=m,T.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.viewEnd>1?new P(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new P(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new P(this.path,T)}compare(T){if(typeof T=="string")return P.compare(this.toString(),T);for(let m=0;m<T.viewEnd&&m<this.viewEnd;m++)if(T.path[m]!==this.path[m])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=P}),define(Te[60],Ae([1,0,2,91,29,48]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var m;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=k=>"runId"in k;e.isStartControllerTests=y;var R;(function(k){k.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),k.deserialize=(N,$)=>({range:P.Range.lift($.range),uri:N.asCanonicalUri(I.URI.revive($.uri))})})(R||(e.IRichLocation=R={}));var C;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(C||(e.TestMessageType=C={}));var u;(function(k){k.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&R.serialize(N.location)}),k.deserialize=(N,$)=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&R.deserialize(N,$.location)})})(u||(e.ITestErrorMessage=u={}));const E=(k,N)=>`${N?"s":"e"}${k}`;e.getMarkId=E;var p;(function(k){k.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&R.serialize(N.location)}),k.deserialize=(N,$)=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&R.deserialize(N,$.location)})})(p||(e.ITestOutputMessage=p={}));var s;(function(k){k.serialize=N=>N.type===0?u.serialize(N):p.serialize(N),k.deserialize=(N,$)=>$.type===0?u.deserialize(N,$):p.deserialize(N,$)})(s||(e.ITestMessage=s={}));var c;(function(k){k.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),k.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(s.serialize)}),k.deserialize=(N,$)=>({state:$.state,duration:$.duration,messages:$.messages.map(re=>s.deserialize(N,re))})})(c||(e.ITestTaskState=c={}));const t="\0",n=(k,N)=>k+t+N;e.namespaceTestTag=n;const r=k=>{const N=k.indexOf(t);return{ctrlId:k.slice(0,N),tagId:k.slice(N+1)}};e.denamespaceTestTag=r;var a;(function(k){k.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),k.deserialize=(N,$)=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?N.asCanonicalUri(I.URI.revive($.uri)):void 0,range:$.range?P.Range.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(a||(e.ITestItem=a={}));var d;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var i;(function(k){k.serialize=N=>({expand:N.expand,item:a.serialize(N.item)}),k.deserialize=(N,$)=>({controllerId:O.TestId.root($.item.extId),expand:$.expand,item:a.deserialize(N,$.item)})})(i||(e.InternalTestItem=i={}));var v;(function(k){k.serialize=N=>{let $;return N.item&&($={},N.item.label!==void 0&&($.label=N.item.label),N.item.tags!==void 0&&($.tags=N.item.tags),N.item.busy!==void 0&&($.busy=N.item.busy),N.item.uri!==void 0&&($.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&($.range=N.item.range?.toJSON()),N.item.description!==void 0&&($.description=N.item.description),N.item.error!==void 0&&($.error=N.item.error),N.item.sortText!==void 0&&($.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:$}},k.deserialize=N=>{let $;return N.item&&($={},N.item.label!==void 0&&($.label=N.item.label),N.item.tags!==void 0&&($.tags=N.item.tags),N.item.busy!==void 0&&($.busy=N.item.busy),N.item.range!==void 0&&($.range=N.item.range?P.Range.lift(N.item.range):null),N.item.description!==void 0&&($.description=N.item.description),N.item.error!==void 0&&($.error=N.item.error),N.item.sortText!==void 0&&($.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:$}}})(v||(e.ITestItemUpdate=v={}));const l=(k,N)=>{N.expand!==void 0&&(k.expand=N.expand),N.item!==void 0&&(k.item=k.item?Object.assign(k.item,N.item):N.item)};e.applyTestItemUpdate=l;var o;(function(k){k.serializeWithoutMessages=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(c.serializeWithoutMessages)}),k.serialize=N=>({...i.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(c.serialize)}),k.deserialize=(N,$)=>({...i.deserialize(N,$),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(re=>c.deserialize(N,re)),retired:!0})})(o||(e.TestResultItem=o={}));var S;(function(k){k.empty=()=>({covered:0,total:0}),k.sum=(N,$)=>{N.covered+=$.covered,N.total+=$.total}})(S||(e.ICoveredCount=S={}));var w;(function(k){k.serialize=N=>({statement:N.statement,branch:N.branch,declaration:N.declaration,details:N.details?.map(_.serialize),uri:N.uri.toJSON()}),k.deserialize=(N,$)=>({statement:$.statement,branch:$.branch,declaration:$.declaration,details:$.details?.map(_.deserialize),uri:N.asCanonicalUri(I.URI.revive($.uri))})})(w||(e.IFileCoverage=w={}));function g(k){return{...k,location:k.location?.toJSON()}}function D(k){return k.location=k.location?L.Position.isIPosition(k.location)?L.Position.lift(k.location):P.Range.lift(k.location):void 0,k}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var h;(function(k){k[k.Declaration=0]="Declaration",k[k.Statement=1]="Statement",k[k.Branch=2]="Branch"})(h||(e.DetailType=h={}));var _;(function(k){k.serialize=N=>N.type===0?A.serialize(N):F.serialize(N),k.deserialize=N=>N.type===0?A.deserialize(N):F.deserialize(N)})(_||(e.CoverageDetails=_={}));var b;(function(k){k.serialize=g,k.deserialize=D})(b||(e.IBranchCoverage=b={}));var A;(function(k){k.serialize=g,k.deserialize=D})(A||(e.IDeclarationCoverage=A={}));var F;(function(k){k.serialize=N=>({...g(N),branches:N.branches?.map(b.serialize)}),k.deserialize=N=>({...D(N),branches:N.branches?.map(b.deserialize)})})(F||(e.IStatementCoverage=F={}));var j;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var H;(function(k){k.deserialize=(N,$)=>$.op===0?{op:$.op,item:i.deserialize(N,$.item)}:$.op===1?{op:$.op,item:v.deserialize($.item)}:$.op===2?{op:$.op,uri:N.asCanonicalUri(I.URI.revive($.uri)),docv:$.docv}:$,k.serialize=N=>N.op===0?{op:N.op,item:i.serialize(N.item)}:N.op===1?{op:N.op,item:v.serialize(N.item)}:N})(H||(e.TestsDiffOp=H={}));class B{constructor(N){this.uriIdentity=N,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(N){const $=this.createChangeCollector();for(const re of N)switch(re.op){case 0:this.add(i.deserialize(this.uriIdentity,re.item),$);break;case 1:this.update(v.deserialize(re.item),$);break;case 3:this.remove(re.itemId,$);break;case 5:this.retireTest(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this._tags.set(re.tag.id,re.tag);break;case 7:this._tags.delete(re.id);break}$.complete?.()}add(N,$){const re=O.TestId.parentId(N.item.extId)?.toString();let le;if(!re)le=this.createItem(N),this.roots.add(le),this.items.set(N.item.extId,le);else if(this.items.has(re)){const _e=this.items.get(re);_e.children.add(N.item.extId),le=this.createItem(N,_e),this.items.set(N.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return $.add?.(le),N.expand===2&&this.busyControllerCount++,le}update(N,$){const re=this.items.get(N.extId);if(re)return N.expand!==void 0&&(re.expand===2&&this.busyControllerCount--,N.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(re,N),$.update?.(re),re}remove(N,$){const re=this.items.get(N);if(!re)return;const le=O.TestId.parentId(re.item.extId)?.toString();le?this.items.get(le).children.delete(re.item.extId):this.roots.delete(re);const _e=[[N]];for(;_e.length;)for(const ye of _e.pop()){const de=this.items.get(ye);de&&(_e.push(de.children),this.items.delete(ye),$.remove?.(de,de!==re),de.expand===2&&this.busyControllerCount--)}}retireTest(N){}updatePendingRoots(N){this.pendingRootCount+=N}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=B}),define(Te[75],Ae([1,0,11,5,6,55,60,48]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const y=(n,r)=>n===r,C=Object.entries({range:(n,r)=>n===r?!0:!n||!r?!1:n.equalsRange(r),busy:y,label:y,description:y,error:y,sortText:y,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.includes(a)))}),u=(n,r)=>{let a;for(const[d,i]of C)i(n[d],r[d])||(a?a[d]=r[d]:a={[d]:r[d]});return a};class E extends P.Disposable{get root(){return this.options.root}constructor(r){super(),this.options=r,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const a of this.tree.values())this.updateExpandability(a)}get resolveHandler(){return this._resolveHandler}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){switch(r.op){case 2:{for(const a of this.diff)if(a.op===2&&a.uri===r.uri){a.docv=r.docv;return}break}case 1:{const a=this.diff[this.diff.length-1];if(a){if(a.op===1&&a.item.extId===r.item.extId){(0,T.applyTestItemUpdate)(a.item,r.item);return}if(a.op===0&&a.item.item.extId===r.item.extId){(0,T.applyTestItemUpdate)(a.item,r.item);return}}break}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,a){const d=this.tree.get(r);if(d){if((d.expandLevels===void 0||a>d.expandLevels)&&(d.expandLevels=a),d.expand===1){const i=this.resolveChildren(d);return i.isOpen()?this.expandChildren(d,a-1):i.wait().then(()=>this.expandChildren(d,a-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,a-1)):this.expandChildren(d,a-1)}}dispose(){for(const r of this.tree.values())this.options.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,a){switch(a.op){case 3:this.removeItem(m.TestId.joinToString(r.fullId,a.id));break;case 0:this.upsertItem(a.item,r);break;case 5:for(const d of a.ops)this.onTestItemEvent(r,d);break;case 1:this.diffTagRefs(a.new,a.old,r.fullId.toString());break;case 2:this.updateExpandability(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:a.update}});break;case 6:this.documentSynced(r.actual.uri);break;default:(0,O.assertNever)(a)}}documentSynced(r){r&&this.pushDiff({op:2,uri:r,docv:this.options.getDocumentVersion(r)})}upsertItem(r,a){const d=m.TestId.fromExtHostTestItem(r,this.root.id,a?.actual),i=this.options.getApiFor(r);i.parent&&i.parent!==a?.actual&&this.options.getChildren(i.parent).delete(r.id);let v=this.tree.get(d.toString());if(!v){v={fullId:d,actual:r,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},r.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(r,a),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:v.expand,item:this.options.toITestItem(r)}}),this.connectItemAndChildren(r,v,a);return}if(v.actual===r){this.connectItem(r,v,a);return}if(v.actual.uri?.toString()!==r.uri?.toString())return this.removeItem(d.toString()),this.upsertItem(r,a);const l=this.options.getChildren(v.actual),o=v.actual,S=u(this.options.toITestItem(o),this.options.toITestItem(r));this.options.getApiFor(o).listener=void 0,v.actual=r,v.expand=0,S&&(S.hasOwnProperty("tags")&&(this.diffTagRefs(r.tags,o.tags,d.toString()),delete S.tags),this.onTestItemEvent(v,{op:4,update:S})),this.connectItemAndChildren(r,v,a);for(const[w,g]of l)this.options.getChildren(r).get(g.id)||this.removeItem(m.TestId.joinToString(d,g.id));this.documentSynced(v.actual.uri)}diffTagRefs(r,a,d){const i=new Set(a.map(v=>v.id));for(const v of r)i.delete(v.id)||this.incrementTagRefs(v);this.pushDiff({op:1,item:{extId:d,item:{tags:r.map(v=>(0,T.namespaceTestTag)(this.options.controllerId,v.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(r){const a=this.tags.get(r.id);a?a.refCount++:(this.tags.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,r.id)}}))}decrementTagRefs(r){const a=this.tags.get(r);a&&!--a.refCount&&(this.tags.delete(r),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,r)}))}setItemParent(r,a){this.options.getApiFor(r).parent=a&&a.actual!==this.root?a.actual:void 0}connectItem(r,a,d){this.setItemParent(r,d);const i=this.options.getApiFor(r);i.parent=d?.actual,i.listener=v=>this.onTestItemEvent(a,v),this.updateExpandability(a)}connectItemAndChildren(r,a,d){this.connectItem(r,a,d);for(const[i,v]of this.options.getChildren(r))this.upsertItem(v,a)}updateExpandability(r){let a;this._resolveHandler?r.resolveBarrier?a=r.resolveBarrier.isOpen()?3:2:a=r.actual.canResolveChildren?1:0:a=0,a!==r.expand&&(r.expand=a,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:a}}),a===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,a){if(a<0)return;const d=[];for(const[i,v]of this.options.getChildren(r.actual)){const l=this.expand(m.TestId.joinToString(r.fullId,v.id),a);(0,I.isThenable)(l)&&d.push(l)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const v=new I.Barrier;return v.open(),v}r.expand=2,this.pushExpandStateUpdate(r);const a=r.resolveBarrier=new I.Barrier,d=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,v)};let i;try{i=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(v){d(v)}return(0,I.isThenable)(i)?i.catch(d).then(()=>{a.open(),this.updateExpandability(r)}):(a.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}removeItem(r){const a=this.tree.get(r);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const d=[a];for(;d.length;){const i=d.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const v of i.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(i.fullId.toString());for(const[v,l]of this.options.getChildren(i.actual))d.push(this.tree.get(m.TestId.joinToString(i.fullId,l.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.TestItemCollection=E;class p extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.DuplicateTestItemError=p;class s extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=s;class c extends Error{constructor(r,a,d){super(`TestItem with ID "${r}" is from controller "${a}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=c;const t=(n,r,a)=>{let d=new Map;return{get size(){return d.size},forEach(i,v){for(const l of d.values())i.call(v,l,this)},[Symbol.iterator](){return d.entries()},replace(i){const v=new Map,l=new Set(d.keys()),o={op:5,ops:[]};for(const S of i){if(!(S instanceof a))throw new s(S.id);const w=r(S).controllerId;if(w!==n.controllerId)throw new c(S.id,w,n.controllerId);if(v.has(S.id))throw new p(S.id);v.set(S.id,S),l.delete(S.id),o.ops.push({op:0,item:S})}for(const S of l.keys())o.ops.push({op:3,id:S});n.listener?.(o),d=v},add(i){if(!(i instanceof a))throw new s(i.id);d.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){d.delete(i)&&n.listener?.({op:3,id:i})},get(i){return d.get(i)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=t}),define(Te[103],Ae([1,0,75]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,P=(T,m)=>{const f={controllerId:m};return L.set(T,f),f};e.createPrivateApiFor=P;const O=T=>{const m=L.get(T);if(!m)throw new I.InvalidTestItemError(T?.id||"<unknown>");return m};e.getPrivateApiFor=O}),define(Te[76],Ae([1,0,12,2]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function P(m,f){return m.scheme===I.Schemas.http||m.scheme===I.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===I.Schemas.file&&(m=L.URI.from({scheme:I.Schemas.vscodeRemote,authority:f.authority,path:m.path})),L.URI.from({scheme:I.Schemas.https,authority:`${m.scheme}+${O(m.authority)}.${e.webviewRootResourceAuthority}`,path:m.path,fragment:m.fragment,query:m.query}))}e.asWebviewUri=P;function O(m){return m.replace(/./g,f=>{const y=f.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?f:"-"+y.toString(16).padStart(4,"0")})}function T(m){return m.replace(/-([0-9a-f]{4})/g,(f,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=T}),define(Te[214],Ae([1,0,5,6,76]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(m,f,y){this._proxy=m,this._editors=f,this._remoteInfo=y,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(f.onDidChangeVisibleTextEditors(()=>{const R=f.getVisibleTextEditors();for(const C of this._insets.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this._insets.forEach(m=>m.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(m,f,y,R,C){let u;for(const r of this._editors.getVisibleTextEditors(!0))if(r.value===m){u=r;break}if(!u)throw new Error("not a visible editor");const E=this,p=this._handlePool++,s=new I.Emitter,c=new I.Emitter,t=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(r){return(0,P.asWebviewUri)(r,E._remoteInfo)}get cspSource(){return P.webviewGenericCspSource}set options(r){this._options=r,E._proxy.$setOptions(p,r)}get options(){return this._options}set html(r){this._html=r,E._proxy.$setHtml(p,r)}get html(){return this._html}get onDidReceiveMessage(){return s.event}postMessage(r){return E._proxy.$postMessage(p,r)}},n=new class{constructor(){this.editor=m,this.line=f,this.height=y,this.webview=t,this.onDidDispose=c.event}dispose(){E._insets.has(p)&&(E._insets.delete(p),E._proxy.$disposeEditorInset(p),c.fire(),c.dispose(),s.dispose())}};return this._proxy.$createEditorInset(p,u.id,u.value.document.uri,f+1,y,R||{},C.identifier,C.extensionLocation),this._insets.set(p,{editor:m,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(m){const f=this._insets.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this._insets.get(m)?.onDidReceiveMessage.fire(f)}}e.ExtHostEditorInsets=O}),define(Te[104],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,I.createDecorator)("IAuthenticationService")}),define(Te[215],Ae([1,0,4]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService");var L;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class P extends Error{constructor(T,m){super(m),this.variable=T}}e.VariableError=P}),define(Te[216],Ae([1,0,19,73,16,26,21,94,178,215,13]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,p,s,c){this._contributedVariables=new Map,this._context=E,this._labelService=p,this._userHomePromise=s,c&&(this._envVariablesPromise=c.then(t=>this.prepareEnv(t)))}prepareEnv(E){if(T.isWindows){const p=Object.create(null);return Object.keys(E).forEach(s=>{p[s.toLowerCase()]=E[s]}),p}return E}resolveWithEnvironment(E,p,s){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},p?p.uri:void 0,s)}async resolveAsync(E,p){const s={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(s,E?E.uri:void 0,p)}async resolveAnyBase(E,p,s,c){const t=O.deepClone(p);T.isWindows&&t.windows?Object.keys(t.windows).forEach(r=>t[r]=t.windows[r]):T.isMacintosh&&t.osx?Object.keys(t.osx).forEach(r=>t[r]=t.osx[r]):T.isLinux&&t.linux&&Object.keys(t.linux).forEach(r=>t[r]=t.linux[r]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(n,E?E.uri:void 0,t,s,c)}async resolveAnyAsync(E,p,s){return this.resolveAnyBase(E,p,s)}async resolveAnyMap(E,p,s){const c=new Map;return{newConfig:await this.resolveAnyBase(E,p,s,c),resolvedVariables:c}}resolveWithInteractionReplace(E,p,s,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,p,s,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,p){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,p)}async recursiveResolve(E,p,s,c,t){if(P.isString(s))return this.resolveString(E,p,s,c,t);if(Array.isArray(s))return Promise.all(s.map(n=>this.recursiveResolve(E,p,n,c,t)));if(P.isObject(s)){const n=Object.create(null),r=await Promise.all(Object.keys(s).map(async a=>[await this.resolveString(E,p,a,c,t),await this.recursiveResolve(E,p,s[a],c,t)]));for(const[a,d]of r)n[a]=d;return n}return s}resolveString(E,p,s,c,t){return(0,R.replaceAsync)(s,C.VARIABLE_REGEXP,async(n,r)=>{if(r.includes(C.VARIABLE_LHS))return n;let a=await this.evaluateSingleVariable(E,n,r,p,c);return t?.set(r,a),a!==n&&P.isString(a)&&a.match(C.VARIABLE_REGEXP)&&(a=await this.resolveString(E,p,a,c,t)),a})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,p,s,c,t){let n;const r=s.split(":");r.length>1&&(s=r[0],n=r[1]);const a=v=>{const l=this._context.getFilePath();if(l)return(0,m.normalizeDriveLetter)(l);throw new y.VariableError(v,(0,f.localize)(0,null,p))},d=v=>{const l=a(v);if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return(0,m.normalizeDriveLetter)(o)}throw new y.VariableError(v,(0,f.localize)(1,null,p,I.basename(l)))},i=v=>{if(n){const l=this._context.getFolderUri(n);if(l)return l;throw new y.VariableError(v,(0,f.localize)(2,null,p,n))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new y.VariableError(v,(0,f.localize)(3,null,p)):new y.VariableError(v,(0,f.localize)(4,null,p))};switch(s){case"env":if(n){if(E.env){const v=E.env[T.isWindows?n.toLowerCase():n];if(P.isString(v))return v}return""}throw new y.VariableError(y.VariableKind.Env,(0,f.localize)(5,null,p));case"config":if(n){const v=this._context.getConfigurationValue(c,n);if(P.isUndefinedOrNull(v))throw new y.VariableError(y.VariableKind.Config,(0,f.localize)(6,null,p,n));if(P.isObject(v))throw new y.VariableError(y.VariableKind.Config,(0,f.localize)(7,null,p,n));return v}throw new y.VariableError(y.VariableKind.Config,(0,f.localize)(8,null,p));case"command":return this.resolveFromMap(y.VariableKind.Command,p,n,t,"command");case"input":return this.resolveFromMap(y.VariableKind.Input,p,n,t,"input");case"extensionInstallFolder":if(n){const v=await this._context.getExtension(n);if(!v)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,p,n));return this.fsPath(v.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,p));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,m.normalizeDriveLetter)(this.fsPath(i(y.VariableKind.WorkspaceFolder)));case"cwd":return c||n?(0,m.normalizeDriveLetter)(this.fsPath(i(y.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.normalizeDriveLetter)(I.basename(this.fsPath(i(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,f.localize)(11,null,p))}case"lineNumber":{const v=this._context.getLineNumber();if(v)return v;throw new y.VariableError(y.VariableKind.LineNumber,(0,f.localize)(12,null,p))}case"selectedText":{const v=this._context.getSelectedText();if(v)return v;throw new y.VariableError(y.VariableKind.SelectedText,(0,f.localize)(13,null,p))}case"file":return a(y.VariableKind.File);case"fileWorkspaceFolder":return d(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.basename(d(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||n?I.relative(this.fsPath(i(y.VariableKind.RelativeFile)),a(y.VariableKind.RelativeFile)):a(y.VariableKind.RelativeFile);case"relativeFileDirname":{const v=I.dirname(a(y.VariableKind.RelativeFileDirname));if(c||n){const l=I.relative(this.fsPath(i(y.VariableKind.RelativeFileDirname)),v);return l.length===0?".":l}return v}case"fileDirname":return I.dirname(a(y.VariableKind.FileDirname));case"fileExtname":return I.extname(a(y.VariableKind.FileExtname));case"fileBasename":return I.basename(a(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=I.basename(a(y.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-I.extname(v).length)}case"fileDirnameBasename":return I.basename(I.dirname(a(y.VariableKind.FileDirnameBasename)));case"execPath":{const v=this._context.getExecPath();return v||p}case"execInstallFolder":{const v=this._context.getAppRoot();return v||p}case"pathSeparator":case"/":return I.sep;default:try{const v=n?`${s}:${n}`:s;return this.resolveFromMap(y.VariableKind.Unknown,p,v,t,void 0)}catch{return p}}}}resolveFromMap(E,p,s,c,t){if(s&&c){const n=t===void 0?c[s]:c[t+":"+s];if(typeof n=="string")return n;throw new y.VariableError(E,(0,f.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=C}),define(Te[105],Ae([1,0,4,102]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var m;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function y(p){const s=p;return(0,L.isEditorInput)(s?.editor)&&(0,L.isEditorInput)(s?.replacement)}e.isEditorReplacement=y;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function u(p){const s=p;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.isEditorGroup=u;function E(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(Te[217],Ae([1,0,4,105]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function P(O){const T=O;return typeof O=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=P}),define(Te[218],Ae([1,0,4,185]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,I.refineServiceDecorator)(L.IEnvironmentService)}),define(Te[106],Ae([1,0,20,5,19,6,11]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class m{constructor(n,r){this.versionId=n,this.removedDueToLooping=r}}e.DeltaExtensionsResult=m;class f{static isHostExtension(n,r,a){if(r.getExtensionDescription(n))return!1;const d=a.getExtensionDescription(n);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(n,r){this._activationEventsReader=n,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(s),this._extensionsMap=new I.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const r=this._activationEventsReader.readActivationEvents(n);for(const a of r)this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(n)}}set(n){return this._extensionDescriptions=n,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(n,r){this._extensionDescriptions=c(this._extensionDescriptions,r),this._extensionDescriptions=this._extensionDescriptions.concat(n);const a=f._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=c(this._extensionDescriptions,a.map(d=>d.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new m(this._versionId,a)}static _findLoopingExtensions(n){const r=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(l){this._nodesSet.has(l)||(this._nodesSet.add(l),this._nodesArr.push(l))}addArc(l,o){this.addNode(l),this.addNode(o),this._arcs.has(l)?this._arcs.get(l).push(o):this._arcs.set(l,[o])}getArcs(l){return this._arcs.has(l)?this._arcs.get(l):[]}hasOnlyGoodArcs(l,o){const S=r.getArcs(l);for(let w=0;w<S.length;w++)if(!o.has(S[w]))return!1;return!0}getNodes(){return this._nodesArr}},a=new I.ExtensionIdentifierMap;for(const l of n)if(a.set(l.identifier,l),l.extensionDependencies)for(const o of l.extensionDependencies)r.addArc(I.ExtensionIdentifier.toKey(l.identifier),I.ExtensionIdentifier.toKey(o));const d=new Set;r.getNodes().filter(l=>r.getArcs(l).length===0).forEach(l=>d.add(l));const i=r.getNodes().filter(l=>!d.has(l));let v;do{v=!1;for(let l=0;l<i.length;l++){const o=i[l];r.hasOnlyGoodArcs(o,d)&&(i.splice(l,1),l--,d.add(o),v=!0)}}while(v);return i.map(l=>a.get(l))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const r=this._activationMap.get(n);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(n){const r=this._extensionsMap.get(n);return r||void 0}getExtensionDescriptionByUUID(n){for(const r of this._extensionsArr)if(r.uuid===n)return r}getExtensionDescriptionByIdOrUUID(n,r){return this.getExtensionDescription(n)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.ExtensionDescriptionRegistry=f;class y{constructor(n,r){this.versionId=n,this.extensions=r}}e.ExtensionDescriptionRegistrySnapshot=y;class R{constructor(n){this._lock=new E,this._actual=new f(n,[])}async acquireLock(n){const r=await this._lock.acquire(n);return new C(this,r)}deltaExtensions(n,r,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(r,a)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,r){return this._actual.getExtensionDescriptionByIdOrUUID(n,r)}}e.LockableExtensionDescriptionRegistry=R;class C extends O.Disposable{constructor(n,r){super(),this._registry=n,this._isDisposed=!1,this._register(r)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=C;class u{constructor(n){this.name=n;const r=(0,T.promiseWithResolvers)();this.promise=r.promise,this._resolve=r.resolve}resolve(n){this._resolve(n)}}class E{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const r=new u(n);return this._pendingCustomers.push(r),this._advance(),r.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let r=!0;const a=setTimeout(()=>{r&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{r&&(clearTimeout(a),r=!1,this._isLocked=!1,this._advance())};n.resolve((0,O.toDisposable)(d))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function s(t,n){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(r!==a)return r-a;const d=P.posix.basename(t.extensionLocation.path),i=P.posix.basename(n.extensionLocation.path);return d<i?-1:d>i?1:0}function c(t,n){const r=new I.ExtensionIdentifierSet(n);return t.filter(a=>!r.has(a.identifier))}}),define(Te[77],Ae([1,0,24]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function T(y){const R=I.VSBuffer.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=T;function m(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=m;var f;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Te[61],Ae([1,0,4,5,14,27,77,57,58,26,2,6,166]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class extends C.Disposable{constructor(t,n){super(),this.initData=t,this.loggerService=n,this._onDidChangeTelemetryEnabled=this._register(new L.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new L.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=R.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=n.createLogger(this.extHostTelemetryLogFile,{id:f.extensionTelemetryLogChannelId,name:(0,u.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(n.onDidChangeLogLevel(r=>{(0,P.isLogLevel)(r)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(t,n,r){const a=this.getTelemetryDetails(),d=new p(n,r,t,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(t),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),i=this._telemetryLoggers.get(t.identifier.value)??[];return this._telemetryLoggers.set(t.identifier.value,[...i,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(t,n,r){this._level=t,this._telemetryIsSupported=n,this._productConfig=r??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,n["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,n["common.sqmid"]=this.initData.telemetryInfo.sqmId,n["common.vscodeversion"]=this.initData.version,n["common.isnewappinstall"]=s(this.initData.telemetryInfo.firstSessionDate),n["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:n["common.uikind"]="web";break;case T.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.getRemoteName)((0,f.cleanRemoteAuthority)(this.initData.remote.authority)),n}$onDidChangeTelemetryLevel(t){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=t;const n=this.getTelemetryDetails();this._telemetryLoggers.forEach((r,a)=>{const d=r.filter(i=>!i.isDisposed);d.length===0?this._telemetryLoggers.delete(a):this._telemetryLoggers.set(a,d)}),this._telemetryLoggers.forEach(r=>{for(const a of r)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(t,n){const a=this._telemetryLoggers.get(t.value)?.filter(i=>!i.isDisposed);if(!a)return this._telemetryLoggers.delete(t.value),!1;let d=!1;for(const i of a)i.ignoreUnhandledExtHostErrors||(i.logError(n),d=!0);return d}};e.ExtHostTelemetry=E,e.ExtHostTelemetry=E=Ge([Ve(0,O.IExtHostInitDataService),Ve(1,P.ILoggerService)],E);class p{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,r,a,d,i,v){this._extension=r,this._logger=a,this._inLoggingOnlyMode=d,this._commonProperties=i,this._onDidChangeEnableStates=new L.Emitter,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=n?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=n?.additionalCommonProperties,this._sender=t,this._telemetryEnablements={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(t,n){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:t,isErrorsEnabled:n},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,f.cleanData)(n,[]),this._additionalCommonProperties&&(n=(0,y.mixin)(n,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(n=(0,y.mixin)(n,this._commonProperties)),"properties"in t?t.properties=n:t=n,t}logEvent(t,n){this._sender&&(this._extension.publisher==="vscode"?t=this._extension.name+"/"+t:t=this._extension.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(t,n),this._logger.trace(t,n))}logUsage(t,n){this._telemetryEnablements.isUsageEnabled&&this.logEvent(t,n)}logError(t,n){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof t=="string")this.logEvent(t,n);else{const r={name:t.name,message:t.message,stack:t.stack,cause:t.cause},a=(0,f.cleanData)(r,[]),d=new Error(a.message,{cause:a.cause});d.stack=a.stack,d.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(d,n),this._logger.trace("exception",n)}}get apiTelemetryLogger(){if(!this._apiObject){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return t._telemetryEnablements.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t._onDidChangeEnableStates.event.bind(t)};this._apiObject=Object.freeze(n)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let t=this._sender;this._sender=void 0,Promise.resolve(t.flush()).then(t=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=p;function s(c){const t=Date.now()-new Date(c).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=s,e.IExtHostTelemetry=(0,I.createDecorator)("IExtHostTelemetry")}),define(Te[23],Ae([1,0,5,2,194,101,20,4]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,m.createDecorator)("extensionService");class f{constructor(d){this.dependency=d}}e.MissingExtensionDependency=f;var y;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(d,i,v){this._versionId=d,this._allExtensions=i.slice(0),this._myExtensions=v.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(d,i,v){if(this._versionId>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this._versionId})`);const l=[],o=[],S=[],w=[],g=C(this._allExtensions),D=C(i),h=(j,H)=>j.extensionLocation.toString()===H.extensionLocation.toString()||j.isBuiltin===H.isBuiltin||j.isUserBuiltin===H.isUserBuiltin||j.isUnderDevelopment===H.isUnderDevelopment;for(const j of this._allExtensions){const H=D.get(j.identifier);if(!H){l.push(j.identifier),g.delete(j.identifier);continue}if(!h(j,H)){l.push(j.identifier),g.delete(j.identifier);continue}}for(const j of i){const H=g.get(j.identifier);if(!H){o.push(j);continue}if(!h(H,j)){l.push(H.identifier),g.delete(H.identifier);continue}}const _=new T.ExtensionIdentifierSet(this._myExtensions),b=new T.ExtensionIdentifierSet(v);for(const j of this._myExtensions)b.has(j)||S.push(j);for(const j of v)_.has(j)||w.push(j);const A=O.ImplicitActivationEvents.createActivationEventsMap(o),F={versionId:d,toRemove:l,toAdd:o,addActivationEvents:A,myToRemove:S,myToAdd:w};return this.delta(F),F}delta(d){if(this._versionId>=d.versionId)return null;const{toRemove:i,toAdd:v,myToRemove:l,myToAdd:o}=d,S=new T.ExtensionIdentifierSet(i),w=new T.ExtensionIdentifierSet(l);for(let g=0;g<this._allExtensions.length;g++)S.has(this._allExtensions[g].identifier)&&(this._allExtensions.splice(g,1),g--);for(let g=0;g<this._myExtensions.length;g++)w.has(this._myExtensions[g])&&(this._myExtensions.splice(g,1),g--);for(const g of v)this._allExtensions.push(g);for(const g of o)this._myExtensions.push(g);return this._myActivationEvents=null,d}containsExtension(d){for(const i of this._myExtensions)if(T.ExtensionIdentifier.equals(i,d))return!0;return!1}containsActivationEvent(d){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(d)}_readMyActivationEvents(){const d=new Set;for(const i of this._allExtensions){if(!this.containsExtension(i.identifier))continue;const v=O.ImplicitActivationEvents.readActivationEvents(i);for(const l of v)d.add(l)}return d}}e.ExtensionHostExtensions=R;function C(a){const d=new T.ExtensionIdentifierMap;for(const i of a)d.set(i.identifier,i);return d}function u(a,d){return a.enabledApiProposals?a.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=u;function E(a,d){if(!u(a,d))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=E;class p{constructor(d,i,v,l){this.codeLoadingTime=d,this.activateCallTime=i,this.activateResolvedTime=v,this.activationReason=l}}e.ActivationTimes=p;class s{constructor(d,i){this.description=d,this.value=i}}e.ExtensionPointContribution=s;var c;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function t(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=t;function n(a,d){return{identifier:new T.ExtensionIdentifier((0,P.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!d,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.toExtensionDescription=n;class r{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,i){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=r}),define(Te[219],Ae([1,0,15,106,20,23,14,11]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(t,n,r,a){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=r,this.activateResolvedTime=a}}e.ExtensionActivationTimes=f;class y{constructor(t){this._startup=t,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(t,n){return t===-1||n===-1?-1:n-t}build(){return new f(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class R{constructor(t,n,r,a,d,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=r,this.module=a,this.exports=d,this.subscriptions=i}}e.ActivatedExtension=R;class C extends R{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class u extends R{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=u;class E extends R{constructor(t){super(!0,t,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(t,n,r,a){this._logService=a,this._registry=t,this._globalRegistry=n,this._host=r,this._operations=new P.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[t,n]of this._operations)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,r]of this._operations)t.push(r.wait());await Promise.all(t)}isActivated(t){const n=this._operations.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this._operations.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this._alreadyActivatedEvents[t])return;const r=this._registry.getExtensionDescriptionsForActivationEvent(t);await this._activateExtensions(r.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:t}}))),this._alreadyActivatedEvents[t]=!0}activateById(t,n){const r=this._registry.getExtensionDescription(t);if(!r)throw new Error(`Extension '${t}' is not known`);return this._activateExtensions([{id:r.identifier,reason:n}])}async _activateExtensions(t){const n=t.filter(r=>!this.isActivated(r.id)).map(r=>this._handleActivationRequest(r));await Promise.all(n.map(r=>r.wait()))}_handleActivationRequest(t){if(this._operations.has(t.id))return this._operations.get(t.id);if(this._isHostExtension(t.id))return this._createAndSaveOperation(t,null,[],null);const n=this._registry.getExtensionDescription(t.id);if(!n){const d=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this._createAndSaveOperation(t,null,[],new E(d));return this._host.onExtensionActivationError(t.id,d,new O.MissingExtensionDependency(t.id.value)),i}const r=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const d of a){if(this._isResolvedExtension(d))continue;const i=this._operations.get(d);if(i){r.push(i);continue}if(this._isHostExtension(d)){r.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(d).identifier,reason:t.reason}));continue}const v=this._registry.getExtensionDescription(d);if(v){if(!v.main&&!v.browser)continue;r.push(this._handleActivationRequest({id:v.identifier,reason:t.reason}));continue}const l=n.displayName||n.identifier.value,o=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${d}'`),S=this._createAndSaveOperation(t,n.displayName,[],new E(o));return this._host.onExtensionActivationError(n.identifier,o,new O.MissingExtensionDependency(d)),S}return this._createAndSaveOperation(t,n.displayName,r,null)}_createAndSaveOperation(t,n,r,a){const d=new s(t.id,n,t.reason,r,a,this._host,this._logService);return this._operations.set(t.id,d),d}_isHostExtension(t){return L.ExtensionDescriptionRegistry.isHostExtension(t,this._registry,this._globalRegistry)}_isResolvedExtension(t){const n=this._globalRegistry.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.ExtensionsActivator=p,e.ExtensionsActivator=p=Ge([Ve(3,T.ILogService)],p);let s=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(t,n,r,a,d,i,v){this._id=t,this._displayName=n,this._reason=r,this._deps=a,this._value=d,this._host=i,this._logService=v,this._barrier=new m.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let t=0;t<this._deps.length;t++){const n=this._deps[t];if(n.value&&!n.value.activationFailed){this._deps.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);r.detail=n.value.activationFailedError,this._value=new E(r),this._host.onExtensionActivationError(this._id,r,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(t=>t.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this._id.value}' failed: ${t.message}.`:n.message=`Activating extension '${this._id.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this._value=new E(n),this._isDisposed&&I.isCancellationError(t))return;this._host.onExtensionActivationError(this._id,n,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(t)}}};s=Ge([Ve(6,T.ILogService)],s)}),define(Te[220],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Te[221],Ae([1,0,180,15,32,96,72,30,20,220,190,101]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const u=m.Registry.as(T.Extensions.JSONContribution);class E{constructor(d,i,v){this._messageHandler=d,this._extension=i,this._extensionPointId=v}_msg(d,i){this._messageHandler({type:d,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(P.default.Error,d)}warn(d){this._msg(P.default.Warning,d)}info(d){this._msg(P.default.Info,d)}}e.ExtensionMessageCollector=E;class p{static _toSet(d){const i=new f.ExtensionIdentifierSet;for(let v=0,l=d.length;v<l;v++)i.add(d[v].description.identifier);return i}static compute(d,i){if(!d||!d.length)return new p(i,[]);if(!i||!i.length)return new p([],d);const v=this._toSet(d),l=this._toSet(i),o=i.filter(w=>!v.has(w.description.identifier)),S=d.filter(w=>!l.has(w.description.identifier));return new p(o,S)}constructor(d,i){this.added=d,this.removed=i}}e.ExtensionPointUserDelta=p;class s{constructor(d,i){this.name=d,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=p.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,L.onUnexpectedError)(d)}}}e.ExtensionPoint=s;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:I.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const i=new s(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,i),d.activationEventsGenerator&&C.ImplicitActivationEvents.register(d.extensionPoint,d.activationEventsGenerator),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,u.registerSchema(t,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=n;const r={ExtensionsRegistry:"ExtensionsRegistry"};m.Registry.add(r.ExtensionsRegistry,new n),e.ExtensionsRegistry=m.Registry.as(r.ExtensionsRegistry),u.registerSchema(t,e.schema),u.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Te[222],Ae([1,0,176,16,26,221,36,5]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var y;(function(u){function E(p,s,c){if(!p)return;const t=L.isString(p.type)?p.type:void 0;if(!t||t.length===0){c.error(I.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const r of p.required)L.isString(r)&&n.push(r);return{extensionId:s.value,taskType:t,required:n,properties:p.properties?P.deepClone(p.properties):{},when:p.when?T.ContextKeyExpr.deserialize(p.when):void 0}}u.from=E})(y||(y={}));const R=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const p of u)p.type&&E.push(`onTaskType:${p.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:f}});class C{constructor(){this._onDefinitionsChanged=new m.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,p)=>{R.setHandler((s,c)=>{this._schema=void 0;try{for(const t of c.removed){const n=t.value;for(const r of n)this.taskTypes&&r.type&&this.taskTypes[r.type]&&delete this.taskTypes[r.type]}for(const t of c.added){const n=t.value;for(const r of n){const a=y.from(r,t.description.identifier,t.collector);a&&(this.taskTypes[a.taskType]=a)}}(c.removed.length>0||c.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const p of this.all()){const s={type:"object",additionalProperties:!1};p.required.length>0&&(s.required=p.required.slice(0)),p.properties!==void 0?s.properties=P.deepClone(p.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[p.taskType]},E.push(s)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new C}),define(Te[223],Ae([1,0,177,16,25,26,36,222]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,I.localize(0,null)),e.TASKS_CATEGORY=I.localize2(2,"Tasks");var f;(function(k){k[k.Escape=1]="Escape",k[k.Strong=2]="Strong",k[k.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(k){function N($){if(!$)return k.Strong;switch($.toLowerCase()){case"escape":return k.Escape;case"strong":return k.Strong;case"weak":return k.Weak;default:return k.Strong}}k.from=N}(f||(e.ShellQuoting=f={}));var y;(function(k){k.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(k){k[k.Always=1]="Always",k[k.Silent=2]="Silent",k[k.Never=3]="Never"})(R||(e.RevealKind=R={})),function(k){function N($){switch($.toLowerCase()){case"always":return k.Always;case"silent":return k.Silent;case"never":return k.Never;default:return k.Always}}k.fromString=N}(R||(e.RevealKind=R={}));var C;(function(k){k[k.Never=1]="Never",k[k.OnProblem=2]="OnProblem",k[k.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(k){function N($){switch($.toLowerCase()){case"always":return k.Always;case"never":return k.Never;case"onproblem":return k.OnProblem;default:return k.OnProblem}}k.fromString=N}(C||(e.RevealProblemKind=C={}));var u;(function(k){k[k.Shared=1]="Shared",k[k.Dedicated=2]="Dedicated",k[k.New=3]="New"})(u||(e.PanelKind=u={})),function(k){function N($){switch($.toLowerCase()){case"shared":return k.Shared;case"dedicated":return k.Dedicated;case"new":return k.New;default:return k.Shared}}k.fromString=N}(u||(e.PanelKind=u={}));var E;(function(k){k.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var p;(function(k){k[k.Shell=1]="Shell",k[k.Process=2]="Process",k[k.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(k){function N(re){switch(re.toLowerCase()){case"shell":return k.Shell;case"process":return k.Process;case"customExecution":return k.CustomExecution;default:return k.Process}}k.fromString=N;function $(re){switch(re){case k.Shell:return"shell";case k.Process:return"process";case k.CustomExecution:return"customExecution";default:return"process"}}k.toString=$}(p||(e.RuntimeType=p={}));var s;(function(k){function N($){return L.isString($)?$:$.value}k.value=N})(s||(e.CommandString=s={}));var c;(function(k){k.Clean={_id:"clean",isDefault:!1},k.Build={_id:"build",isDefault:!1},k.Rebuild={_id:"rebuild",isDefault:!1},k.Test={_id:"test",isDefault:!1};function N(re){return re===k.Clean._id||re===k.Build._id||re===k.Rebuild._id||re===k.Test._id}k.is=N;function $(re){if(re!==void 0)return L.isString(re)?N(re)?{_id:re,isDefault:!1}:void 0:re}k.from=$})(c||(e.TaskGroup=c={}));var t;(function(k){k[k.Global=1]="Global",k[k.Workspace=2]="Workspace",k[k.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(k){k.Workspace="workspace",k.Extension="extension",k.InMemory="inMemory",k.WorkspaceFile="workspaceFile",k.User="user";function N($){switch($){case k.User:return 2;case k.WorkspaceFile:return 5;default:return 6}}k.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var r;(function(k){k.parallel="parallel",k.sequence="sequence"})(r||(e.DependsOrder=r={}));var a;(function(k){k[k.default=1]="default",k[k.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var d;(function(k){k.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class i{constructor(N,$,re,le,_e,ye){this._label="",this._id=N,$&&(this._label=$),re&&(this.type=re),this.runOptions=le,this.configurationProperties=_e,this._source=ye}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.getFolderId(),id:this._id};return JSON.stringify(N)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,$=!1){if(N===void 0)return!1;if(L.isString(N))return N===this._label||N===this.configurationProperties.identifier||$&&N===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),N&&(this._taskLoadMessages=this._taskLoadMessages.concat(N))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class v extends i{constructor(N,$,re,le,_e,ye,de,Ee){super(N,re,void 0,de,Ee,$),this.command={},this._source=$,this.hasDefinedMatchers=ye,_e&&(this.command=_e)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case p.Shell:$="shell";break;case p.Process:$="process";break;case p.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(N){return N instanceof v}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.getFolderId();if(!N)return;let $=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&($+=this._source.kind);const re={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:$};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(N){return new v(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.CustomTask=v;class l extends i{constructor(N,$,re,le,_e,ye,de){super(N,re,le,ye,de,$),this._source=$,this.configures=_e}static is(N){return N instanceof l}fromObject(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.getFolderId();if(!N)return;let $=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&($+=this._source.kind);const re={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:$};return JSON.stringify(re)}}e.ConfiguringTask=l;class o extends i{constructor(N,$,re,le,_e,ye,de,Ee,se){super(N,re,le,Ee,se,$),this.defines=_e,this.hasDefinedMatchers=de,this.command=ye,this.icon=se.icon,this.hide=se.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.getFolderId(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.ContributedTask=o;class S extends i{constructor(N,$,re,le,_e,ye){super(N,re,le,_e,ye,$),this._source=$}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(N){return new S(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.InMemoryTask=S;var w;(function(k){k[k.Process=1]="Process",k[k.Terminal=2]="Terminal"})(w||(e.ExecutionEngine=w={})),function(k){k._default=k.Terminal}(w||(e.ExecutionEngine=w={}));var g;(function(k){k[k.V0_1_0=1]="V0_1_0",k[k.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(N){this._order=new Map;for(let $=0;$<N.length;$++)this._order.set(N[$].uri.toString(),$)}compare(N,$){const re=N.getWorkspaceFolder(),le=$.getWorkspaceFolder();if(re&&le){let _e=this._order.get(re.uri.toString());_e=_e===void 0?0:_e+1;let ye=this._order.get(le.uri.toString());return ye=ye===void 0?0:ye+1,_e===ye?N._label.localeCompare($._label):_e-ye}else return!re&&le?-1:re&&!le?1:0}}e.TaskSorter=D;var h;(function(k){k.DependsOnStarted="dependsOnStarted",k.AcquiredInput="acquiredInput",k.Start="start",k.ProcessStarted="processStarted",k.Active="active",k.Inactive="inactive",k.Changed="changed",k.Terminated="terminated",k.ProcessEnded="processEnded",k.End="end"})(h||(e.TaskEventKind=h={}));var _;(function(k){k.SingleRun="singleRun",k.Background="background"})(_||(e.TaskRunType=_={}));var b;(function(k){k[k.System=0]="System",k[k.User=1]="User",k[k.FolderOpen=2]="FolderOpen",k[k.ConfigurationChange=3]="ConfigurationChange",k[k.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var A;(function(k){function N(Ee){return{taskId:Ee._id,taskName:Ee.configurationProperties.name,runType:Ee.configurationProperties.isBackground?"background":"singleRun",group:Ee.configurationProperties.group,__task:Ee}}function $(Ee,se,pe){return{...N(Ee),kind:"start",terminalId:se,resolvedVariables:pe}}k.start=$;function re(Ee,se,pe){return{...N(Ee),kind:"processStarted",terminalId:se,processId:pe}}k.processStarted=re;function le(Ee,se,pe){return{...N(Ee),kind:"processEnded",terminalId:se,exitCode:pe}}k.processEnded=le;function _e(Ee,se,pe){return{...N(Ee),kind:"terminated",exitReason:pe,terminalId:se}}k.terminated=_e;function ye(Ee,se,pe){return{...N(se),kind:Ee,terminalId:pe}}k.general=ye;function de(){return{kind:"changed"}}k.changed=de})(A||(e.TaskEvent=A={}));var F;(function(k){function N(re){const le=Object.keys(re).sort();let _e="";for(const ye of le){let de=re[ye];de instanceof Object?de=N(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),_e+=ye+","+de+","}return _e}function $(re){const _e={_key:N(re),type:re.taskType};return Object.assign(_e,re),_e}k.create=$})(F||(e.KeyedTaskIdentifier=F={}));var j;(function(k){k.AutoDetect="task.autoDetect",k.SaveBeforeRun="task.saveBeforeRun",k.ShowDecorations="task.showDecorations",k.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",k.SlowProviderWarning="task.slowProviderWarning",k.QuickOpenHistory="task.quickOpen.history",k.QuickOpenDetail="task.quickOpen.detail",k.QuickOpenSkip="task.quickOpen.skip",k.QuickOpenShowAll="task.quickOpen.showAll",k.AllowAutomaticTasks="task.allowAutomaticTasks",k.Reconnection="task.reconnection",k.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var H;(function(k){k.Tasks="tasks",k.SuppressTaskName="tasks.suppressTaskName",k.Windows="tasks.windows",k.Osx="tasks.osx",k.Linux="tasks.linux",k.ShowOutput="tasks.showOutput",k.IsShellCommand="tasks.isShellCommand",k.ServiceTestSetting="tasks.service.testSetting"})(H||(e.TasksSchemaProperties=H={}));var B;(function(k){function N($,re){const le=m.TaskDefinitionRegistry.get($.type);if(le===void 0){const Ee=O.deepClone($);return delete Ee._key,F.create(Ee)}const _e=Object.create(null);_e.type=le.taskType;const ye=new Set;le.required.forEach(Ee=>ye.add(Ee));const de=le.properties;for(const Ee of Object.keys(de)){const se=$[Ee];if(se!=null)_e[Ee]=se;else if(ye.has(Ee)){const pe=de[Ee];if(pe.default!==void 0)_e[Ee]=O.deepClone(pe.default);else switch(pe.type){case"boolean":_e[Ee]=!1;break;case"number":case"integer":_e[Ee]=0;break;case"string":_e[Ee]="";break;default:re.error(I.localize(1,null,JSON.stringify($,void 0,0),Ee));return}}}return F.create(_e)}k.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Te[224],Ae([1,0,15]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,m)=>{this._actualOk=T,this._actualErr=m,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,I.onUnexpectedError)(T))}then(T,m){return this._ensureActual().then(T,m)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=L;class P extends L{constructor(){super(),this._hasErr=!0,this._err=new I.CancellationError}}e.CanceledLazyPromise=P}),define(Te[49],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++I.count}}e.ProxyIdentifier=I;const L=[];function P(m){const f=new I(m);return L[f.nid]=f,f}e.createProxyIdentifier=P;function O(m){return L[m].sid}e.getStringIdentifierForProxy=O;class T{constructor(f){this.value=f}}e.SerializableObjectWithBuffers=T}),define(Te[3],Ae([1,0,49]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var T;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var m;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var y;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this._n=0}static mixin(c){return c._id=C._n++,c}}e.IdObject=C;var u;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var p;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents2:(0,I.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,I.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,I.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,I.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,I.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,I.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,I.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,I.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,I.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,I.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,I.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,I.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Te[78],Ae([1,0,4,14,3,17]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,I.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(f,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=f.getProxy(P.MainContext.MainThreadTelemetry)}report(f,y,R){const C=this.getUsageKey(f,y);this._reportedUsages.has(C)||(this._reportedUsages.add(C),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${f}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:f}))}getUsageKey(f,y){return`${f}-${y.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=Ge([Ve(0,O.IExtHostRpcService),Ve(1,L.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(m,f,y){}})}),define(Te[225],Ae([1,0,51,6,3]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class O{static{this._pool=0}constructor(f,y){this.extension=f,this.provider=y,this.handle=O._pool++}}class T{static{this._nextId=0}constructor(f){this._chatProvider=new Map,this._chatSessions=new Map,this._proxy=f.getProxy(P.MainContext.MainThreadChat)}registerChatProvider(f,y,R){const C=new O(f,R);return this._chatProvider.set(C.handle,C),this._proxy.$registerChatProvider(C.handle,y),(0,L.toDisposable)(()=>{this._proxy.$unregisterChatProvider(C.handle),this._chatProvider.delete(C.handle)})}transferChatSession(f,y){const R=I.Iterable.find(this._chatSessions.keys(),C=>this._chatSessions.get(C)===f)??0;typeof R=="number"&&this._proxy.$transferChatSession(R,y)}sendInteractiveRequestToProvider(f,y){this._proxy.$sendRequestToProvider(f,y)}async $prepareChat(f,y){const R=this._chatProvider.get(f);if(!R)return;const C=await R.provider.prepareSession(y);if(!C)return;const u=T._nextId++;return this._chatSessions.set(u,C),{id:u,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession(f){this._chatSessions.delete(f)}}e.ExtHostChat=T}),define(Te[226],Ae([1,0,3]),function(fe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(O){const T=O.getProxy(I.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(m){return T.$writeText(m)}})}}e.ExtHostClipboard=L}),define(Te[227],Ae([1,0,26,3,27,17]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(R,C){this._mainThreadConsole=R.getProxy(L.MainContext.MainThreadConsole),this._includeStack=C.consoleForward.includeStack,this._logNative=C.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,C){const u=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u._handleConsoleCall(R,C,E,arguments)}})}_handleConsoleCall(R,C,u,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:C,arguments:f(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,u,E)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=Ge([Ve(0,O.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],T);const m=1e5;function f(y,R){const C=[];if(y.length)for(let u=0;u<y.length;u++){let E=y[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const p=E;p.stack?E=p.stack:E=p.toString()}C.push(E)}if(R){const u=new Error().stack;u&&C.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.safeStringify)(C);return u.length>m?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Te[228],Ae([1,0,2,3,23]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(m){this._proxy=m.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,P.checkProposedApiEnabled)(m,"showLocal"),this._proxy.$showOpenDialog(f).then(y=>y?y.map(R=>I.URI.revive(R)):void 0)}showSaveDialog(m){return this._proxy.$showSaveDialog(m).then(f=>f?I.URI.revive(f):void 0)}}e.ExtHostDialogs=O}),define(Te[229],Ae([1,0,6,3]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const m=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(m,T),(0,I.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(m)})}}e.ExtHostLabelService=P}),define(Te[79],Ae([1,0,21,13,2,4,14,3,27,17]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(u,E,p){this.logService=p,this.bundleCache=new Map,this._proxy=E.getProxy(m.MainContext.MainThreadLocalization),this.currentLanguage=u.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===I.LANGUAGE_DEFAULT}getMessage(u,E){const{message:p,args:s,comment:c}=E;if(this.isDefaultLanguage)return(0,L.format2)(p,s??{});let t=p;c&&c.length>0&&(t+=`/${Array.isArray(c)?c.join(""):c}`);const n=this.bundleCache.get(u)?.contents[t];return n||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,L.format2)(n??p,s??{})}getBundle(u){return this.bundleCache.get(u)?.contents}getBundleUri(u){return this.bundleCache.get(u)?.uri}async initializeLocalizedMessages(u){if(this.isDefaultLanguage||!u.l10n&&!u.isBuiltin||this.bundleCache.has(u.identifier.value))return;let E;const p=await this.getBundleLocation(u);if(!p){this.logService.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const s=await this._proxy.$fetchBundleContents(p),c=JSON.parse(s);E=u.isBuiltin?c.contents?.bundle:c}catch(s){this.logService.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${s.message}`);return}E&&this.bundleCache.set(u.identifier.value,{contents:E,uri:p})}async getBundleLocation(u){if(u.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(u.identifier.value,this.currentLanguage);return P.URI.revive(E)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=R,e.ExtHostLocalizationService=R=Ge([Ve(0,f.IExtHostInitDataService),Ve(1,y.IExtHostRpcService),Ve(2,T.ILogService)],R),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(Te[230],Ae([1,0,14,3,27,17,2,52]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(C,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,m.revive)(E))),this._proxy=C.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(C,u){u?this.setLogLevel(T.URI.revive(u),C):this.setLogLevel(C)}setVisibility(C,u){super.setVisibility(C,u),this._proxy.$setVisibility(C,u)}doCreateLogger(C,u,E){return new y(this._proxy,C,u,E)}};e.ExtHostLoggerService=f,e.ExtHostLoggerService=f=Ge([Ve(0,O.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],f);class y extends I.AbstractMessageLogger{constructor(C,u,E,p){super(p?.logLevel==="always"),this.proxy=C,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.proxy.$createLogger(u,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,u){const E=[[C,u]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(C){this.proxy.$log(this.file,C)}flush(){this.proxy.$flush(this.file)}}}),define(Te[80],Ae([1,0,3,4,6,17,24]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,L.createDecorator)("IExtHostManagedSockets");let m=class{constructor(C){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadManagedSockets)}setFactory(C,u){for(const E of this._managedRemoteSockets.values())E.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new f(C,u),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(C){if(!this._factory||this._factory.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const u=++this._remoteSocketIdCounter,E=await this._factory.makeConnection(),p=new P.DisposableStore;return this._managedRemoteSockets.set(u,new y(u,E,p)),p.add((0,P.toDisposable)(()=>this._managedRemoteSockets.delete(u))),p.add(E.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(u),p.dispose()})),p.add(E.onDidClose(s=>{this._proxy.$onDidManagedSocketClose(u,s?.stack??s?.message),p.dispose()})),p.add(E.onDidReceiveMessage(s=>this._proxy.$onDidManagedSocketHaveData(u,T.VSBuffer.wrap(s)))),u}$remoteSocketWrite(C,u){this._managedRemoteSockets.get(C)?.actual.send(u.buffer)}$remoteSocketEnd(C){const u=this._managedRemoteSockets.get(C);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(C){await this._managedRemoteSockets.get(C)?.actual.drain?.()}};e.ExtHostManagedSockets=m,e.ExtHostManagedSockets=m=Ge([Ve(0,O.IExtHostRpcService)],m);class f{constructor(C,u){this.socketFactoryId=C,this.makeConnection=u}}class y extends P.Disposable{constructor(C,u,E){super(),this.socketId=C,this.actual=u,this._register(E)}}}),define(Te[231],Ae([1,0,3,14,23]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(m){return m&&m.title}let T=class{constructor(f,y){this._logService=y,this._proxy=f.getProxy(I.MainContext.MainThreadMessageService)}showMessage(f,y,R,C,u){const E={source:{identifier:f.identifier,label:f.displayName||f.name}};let p;typeof C=="string"||O(C)?p=[C,...u]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,p=u),E.useCustom&&(0,P.checkProposedApiEnabled)(f,"resolvers");const s=[];let c=!1;for(let t=0;t<p.length;t++){const n=p[t];if(typeof n=="string")s.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:r,isCloseAffordance:a}=n;s.push({title:r,isCloseAffordance:!!a,handle:t}),a&&(c?this._logService.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):c=!0)}else this._logService.warn(`[${f.identifier}] Invalid message item:`,n)}return this._proxy.$showMessage(y,R,E,s).then(t=>{if(typeof t=="number")return p[t]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=Ge([Ve(1,L.ILogService)],T)}),define(Te[232],Ae([1,0,6,16,2,23,3]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class m{constructor(y){this.handlers=new Map,this.proxy=y.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,R,C){if((0,O.checkProposedApiEnabled)(y,"profileContentHandlers"),this.handlers.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.handlers.set(R,C),this.proxy.$registerProfileContentHandler(R,C.name,C.description,y.identifier.value),(0,I.toDisposable)(()=>{this.handlers.delete(R),this.proxy.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,C,u){const E=this.handlers.get(y);if(!E)throw new Error(`Unknown handler with id: ${y}`);return E.saveProfile(R,C,u)}async $readProfile(y,R,C){const u=this.handlers.get(y);if(!u)throw new Error(`Unknown handler with id: ${y}`);return u.readProfile((0,L.isString)(R)?R:P.URI.revive(R),C)}}e.ExtHostProfileContentHandlers=m}),define(Te[81],Ae([1,0,3,5,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(m){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=m.getProxy(I.MainContext.MainThreadSecretState)}async $onDidChangePassword(m){this._onDidChangePassword.fire(m)}get(m,f){return this._proxy.$getPassword(m,f)}store(m,f,y){return this._proxy.$setPassword(m,f,y)}delete(m,f){return this._proxy.$deletePassword(m,f)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(Te[233],Ae([1,0,22,6,3]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class O{static{this.ID_POOL=1}constructor(m){this.providers=new Map,this.sessions=new Map,this.proxy=m.getProxy(P.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(m,f,y){const R=this.providers.get(m);if(!R)return;const C=new L.DisposableStore,u=new I.CancellationTokenSource;this.sessions.set(f,u);const E=C.add(R.provideSpeechToTextSession(u.token,y?{language:y}:void 0));C.add(E.onDidChange(p=>{u.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(f,p)})),C.add(u.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(m){this.sessions.get(m)?.dispose(!0),this.sessions.delete(m)}async $createKeywordRecognitionSession(m,f){const y=this.providers.get(m);if(!y)return;const R=new L.DisposableStore,C=new I.CancellationTokenSource;this.sessions.set(f,C);const u=R.add(y.provideKeywordRecognitionSession(C.token));R.add(u.onDidChange(E=>{C.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(f,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(m){this.sessions.get(m)?.dispose(!0),this.sessions.delete(m)}registerProvider(m,f,y){const R=O.ID_POOL++;return this.providers.set(R,y),this.proxy.$registerProvider(R,f,{extension:m,displayName:m.value}),(0,L.toDisposable)(()=>{this.proxy.$unregisterProvider(R),this.providers.delete(R)})}}e.ExtHostSpeech=O}),define(Te[82],Ae([1,0,3,5,4]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(m,f){this._logService=f,this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=m.getProxy(I.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this._proxy.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,y){const R=await this._proxy.$initializeExtensionStorage(m,f);let C;return R&&(C=this.safeParseValue(m,f,R)),C||y}setValue(m,f,y){return this._proxy.$setValue(m,f,y)}$acceptValue(m,f,y){const R=this.safeParseValue(m,f,y);R&&this._onDidChangeStorage.fire({shared:m,key:f,value:R})}safeParseValue(m,f,y){try{return JSON.parse(y)}catch(R){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${R}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(Te[234],Ae([1,0,6,12,2,3]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}constructor(f){this._openers=new Map,this._proxy=f.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(f,y,R,C){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const u=C.schemes.find(E=>!T.supportedSchemes.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,R),this._proxy.$registerUriOpener(y,C.schemes,f,C.label),(0,I.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(f,y,R){const C=this._openers.get(f);if(!C)throw new Error(`Unknown opener with id: ${f}`);const u=P.URI.revive(y);return C.canOpenExternalUri(u,R)}async $openUri(f,y,R){const C=this._openers.get(f);if(!C)throw new Error(`Unknown opener id: '${f}'`);return C.openExternalUri(P.URI.revive(y.resolvedUri),{sourceUri:P.URI.revive(y.sourceUri)},R)}}e.ExtHostUriOpeners=T}),define(Te[235],Ae([1,0,3,2,6,15,20]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class m{static{this.HandlePool=0}constructor(y){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUrls)}registerUriHandler(y,R){const C=y.identifier;if(this.handles.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const u=m.HandlePool++;return this.handles.add(C),this.handlers.set(u,R),this._proxy.$registerUriHandler(u,C,y.displayName||y.name),(0,P.toDisposable)(()=>{this.handles.delete(C),this.handlers.delete(u),this._proxy.$unregisterUriHandler(u)})}$handleExternalUri(y,R){const C=this.handlers.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(L.URI.revive(R))}catch(u){(0,O.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(y){return L.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=m}),define(Te[62],Ae([1,0,5,6,12,26,2,183,205,76,3]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(a,d,i,v,l,o,S){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new I.Emitter,this._onDidDispose=this.#d.event,this.#e=a,this.#t=d,this.#o=i,this.#n=v,this.#s=l,this.#r=o,this.#u=u(o),this.#h=E(o),this.#i=S}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#l=!0,(0,y.asWebviewUri)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let d=a.toString();return d.endsWith("/")||(d+="/"),d+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(a){this.assertNotDisposed(),this.#a!==a&&(this.#a=a,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(a)))}get options(){return this.assertNotDisposed(),this.#o}set options(a){this.assertNotDisposed(),O.equals(this.#o,a)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const d=(0,f.serializeWebviewMessage)(a,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(a){if(!this.#h)return a;const d=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,l,o,S,w,g)=>{const D=T.URI.from({scheme:S||"file",path:decodeURIComponent(w)}),h=(0,y.asWebviewUri)(D,{isRemote:d,authority:i}).toString();return`${l}${h}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,l,o,S,w,g)=>{const D=T.URI.from({scheme:S||"file",path:decodeURIComponent(w)}),h=(0,y.asWebviewUri)(D,{isRemote:d,authority:i}).toString();return`${l}${h}${g}`})}}e.ExtHostWebview=C;function u(r){try{const a=(0,m.normalizeVersion)((0,m.parseVersion)(r.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function E(r){try{const a=(0,m.normalizeVersion)((0,m.parseVersion)(r.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class p extends L.Disposable{constructor(a,d,i,v,l){super(),this.remoteInfo=d,this.workspace=i,this._logService=v,this._deprecationService=l,this._webviews=new Map,this._webviewProxy=a.getProxy(R.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const a of this._webviews.values())a.dispose();this._webviews.clear()}$onMessage(a,d,i){const v=this.getWebview(a);if(v){const{message:l}=(0,f.deserializeWebviewMessage)(d,i.value);v._onMessageEmitter.fire(l)}}$onMissingCsp(a,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,d,i){const v=new C(a,this._webviewProxy,t(d),this.remoteInfo,this.workspace,i,this._deprecationService);this._webviews.set(a,v);const l=v._onDidDispose(()=>{l.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this._webviews.delete(a)}getWebview(a){return this._webviews.get(a)}}e.ExtHostWebviews=p;function s(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=s;function c(r,a,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||n(r,a)}}e.serializeWebviewOptions=c;function t(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(a=>T.URI.from(a))}}function n(r,a){return[...(a?.getWorkspaceFolders()||[]).map(d=>d.uri),r.extensionLocation]}}),define(Te[107],Ae([1,0,5,3,2,12,13,4,17,23]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class{static{R=this}static{this.InitialState={focused:!0,active:!0}}getState(E){const p=this._state;return{get focused(){return p.focused},get active(){return(0,y.checkProposedApiEnabled)(E,"windowActivity"),p.active}}}constructor(E){this._onDidChangeWindowState=new I.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=R.InitialState,this._proxy=E.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:p,isActive:s})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,p){p!==this._state[E]&&(this._state={...this._state,[E]:p},this._onDidChangeWindowState.fire(this._state))}openUri(E,p){let s;if(typeof E=="string"){s=E;try{E=P.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,T.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,s,p)}async asExternalUri(E,p){if((0,T.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this._proxy.$asExternalUri(E,p);return P.URI.from(s)}};e.ExtHostWindow=C,e.ExtHostWindow=C=R=Ge([Ve(0,f.IExtHostRpcService)],C),e.IExtHostWindow=(0,m.createDecorator)("IExtHostWindow")}),define(Te[236],Ae([1,0,227,27,17]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let O=class extends I.AbstractExtHostConsoleForwarder{constructor(m,f){super(m,f)}_nativeConsoleLogMessage(m,f,y){f.apply(console,y)}};e.ExtHostConsoleForwarder=O,e.ExtHostConsoleForwarder=O=Ge([Ve(0,P.IExtHostRpcService),Ve(1,L.IExtHostInitDataService)],O)}),define(Te[237],Ae([1,0,11,24,22,15,5,6,140,224,49]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(b,A){try{return JSON.stringify(b,A)}catch{return"null"}}const E="$$ref$$",p={[E]:-1};class s{constructor(A,F){this.jsonString=A,this.referencedBuffers=F}}function c(b,A=null,F=!1){const j=[];return{jsonString:(F?u:JSON.stringify)(b,(B,k)=>{if(typeof k>"u")return p;if(typeof k=="object"){if(k instanceof L.VSBuffer){const N=j.push(k)-1;return{[E]:N}}if(A)return A(B,k)}return k}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=c;function t(b,A,F){return JSON.parse(b,(j,H)=>{if(H){const B=H[E];if(typeof B=="number")return A[B];if(F&&H.$mid===1)return F.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=t;function n(b,A){return JSON.stringify(b,A)}function r(b){return b?(A,F)=>F&&F.$mid===1?b.transformOutgoing(F):F:null}var a;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var d;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const i=()=>{},v=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class o extends m.Disposable{static{C=v}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(A,F=null,j=null){super(),this[C]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=F,this._uriTransformer=j,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let H=0,B=R.ProxyIdentifier.count;H<B;H++)this._locals[H]=null,this._proxies[H]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new I.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(H=>this._receiveOneMessage(H))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{const F=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],F.resolveErr(O.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,f.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:F,sid:j}=A;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,j)),this._proxies[F]}_createProxy(A,F){const j={get:(H,B)=>(typeof B=="string"&&!H[B]&&B.charCodeAt(0)===36&&(H[B]=(...k)=>this._remoteCall(A,B,k)),B===l?F:H[B])};return new Proxy(Object.create(null),j)}set(A,F){return this._locals[A.nid]=F,F}assertRegistered(A){for(let F=0,j=A.length;F<j;F++){const H=A[F];if(!this._locals[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}_receiveOneMessage(A){if(this._isDisposed)return;const F=A.byteLength,j=w.read(A,0),H=j.readUInt8(),B=j.readUInt32();switch(H){case 1:case 2:{let{rpcId:k,method:N,args:$}=D.deserializeRequestJSONArgs(j);this._uriTransformer&&($=(0,f.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(F,B,k,N,$,H===2);break}case 3:case 4:{let{rpcId:k,method:N,args:$}=D.deserializeRequestMixedArgs(j);this._uriTransformer&&($=(0,f.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(F,B,k,N,$,H===4);break}case 5:{this._logger?.logIncoming(F,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(F,B);break}case 7:{this._receiveReply(F,B,void 0);break}case 9:{let k=D.deserializeReplyOKJSON(j);this._uriTransformer&&(k=(0,f.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReply(F,B,k);break}case 10:{const k=D.deserializeReplyOKJSONWithBuffers(j,this._uriTransformer);this._receiveReply(F,B,k);break}case 8:{const k=D.deserializeReplyOKVSBuffer(j);this._receiveReply(F,B,k);break}case 11:{let k=D.deserializeReplyErrError(j);this._uriTransformer&&(k=(0,f.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReplyErr(F,B,k);break}case 12:{this._receiveReplyErr(F,B,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,F,j,H,B,k){this._logger?.logIncoming(A,F,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(j)}.${H}(`,B);const N=String(F);let $,re;if(k){const _e=new P.CancellationTokenSource;B.push(_e.token),$=this._invokeHandler(j,H,B),re=()=>_e.cancel()}else $=this._invokeHandler(j,H,B),re=i;this._cancelInvokedHandlers[N]=re;const le=D.serializeAcknowledged(F);this._logger?.logOutgoing(le.byteLength,F,1,"ack"),this._protocol.send(le),$.then(_e=>{delete this._cancelInvokedHandlers[N];const ye=D.serializeReplyOK(F,_e,this._uriReplacer);this._logger?.logOutgoing(ye.byteLength,F,1,"reply:",_e),this._protocol.send(ye)},_e=>{delete this._cancelInvokedHandlers[N];const ye=D.serializeReplyErr(F,_e);this._logger?.logOutgoing(ye.byteLength,F,1,"replyErr:",_e),this._protocol.send(ye)})}_receiveCancel(A,F){this._logger?.logIncoming(A,F,1,"receiveCancel");const j=String(F);this._cancelInvokedHandlers[j]?.()}_receiveReply(A,F,j){this._logger?.logIncoming(A,F,0,"receiveReply:",j);const H=String(F);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const B=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H],B.resolveOk(j)}_receiveReplyErr(A,F,j){this._logger?.logIncoming(A,F,0,"receiveReplyErr:",j);const H=String(F);if(!this._pendingRPCReplies.hasOwnProperty(H))return;const B=this._pendingRPCReplies[H];delete this._pendingRPCReplies[H];let k;j&&(j.$isError?(k=new Error,k.name=j.name,k.message=j.message,k.stack=j.stack):k=j),B.resolveErr(k)}_invokeHandler(A,F,j){try{return Promise.resolve(this._doInvokeHandler(A,F,j))}catch(H){return Promise.reject(H)}}_doInvokeHandler(A,F,j){const H=this._locals[A];if(!H)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(A));const B=H[F];if(typeof B!="function")throw new Error("Unknown method "+F+" on actor "+(0,R.getStringIdentifierForProxy)(A));return B.apply(H,j)}_remoteCall(A,F,j){if(this._isDisposed)return new y.CanceledLazyPromise;let H=null;if(j.length>0&&P.CancellationToken.isCancellationToken(j[j.length-1])&&(H=j.pop()),H&&H.isCancellationRequested)return Promise.reject(O.canceled());const B=D.serializeRequestArguments(j,this._uriReplacer),k=++this._lastMessageId,N=String(k),$=new y.LazyPromise,re=new m.DisposableStore;H&&re.add(H.onCancellationRequested(()=>{const _e=D.serializeCancel(k);this._logger?.logOutgoing(_e.byteLength,k,0,"cancel"),this._protocol.send(D.serializeCancel(k))})),this._pendingRPCReplies[N]=new S($,re),this._onWillSendRequest(k);const le=D.serializeRequest(k,A,F,B,!!H);return this._logger?.logOutgoing(le.byteLength,k,0,`request: ${(0,R.getStringIdentifierForProxy)(A)}.${F}(`,j),this._protocol.send(le),$}}e.RPCProtocol=o;class S{constructor(A,F){this._promise=A,this._disposable=F}resolveOk(A){this._promise.resolveOk(A),this._disposable.dispose()}resolveErr(A){this._promise.resolveErr(A),this._disposable.dispose()}}class w{static alloc(A,F,j){const H=new w(L.VSBuffer.alloc(j+1+4),0);return H.writeUInt8(A),H.writeUInt32(F),H}static read(A,F){return new w(A,F)}get buffer(){return this._buff}constructor(A,F){this._buff=A,this._offset=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const j=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,j}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,j}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,F}static sizeMixedArray(A){let F=0;F+=1;for(let j=0,H=A.length;j<H;j++){const B=A[j];switch(F+=1,B.type){case 1:F+=this.sizeLongString(B.value);break;case 2:F+=this.sizeVSBuffer(B.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(B.value);for(let k=0;k<B.buffers.length;++k)F+=this.sizeVSBuffer(B.buffers[k]);break;case 4:break}}return F}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let F=0,j=A.length;F<j;F++){const H=A[F];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let B=0;B<H.buffers.length;++B)this.writeBuffer(H.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const F=new Array(A);for(let j=0;j<A;j++)switch(this.readUInt8()){case 1:F[j]=this.readLongString();break;case 2:F[j]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),k=this.readLongString(),N=[];for(let $=0;$<B;++$)N.push(this.readVSBuffer());F[j]=new R.SerializableObjectWithBuffers(t(k,N,null));break}case 4:F[j]=void 0;break}return F}}var g;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(g||(g={}));class D{static _useMixedArgSerialization(A){for(let F=0,j=A.length;F<j;F++)if(A[F]instanceof L.VSBuffer||A[F]instanceof R.SerializableObjectWithBuffers||typeof A[F]>"u")return!0;return!1}static serializeRequestArguments(A,F){if(this._useMixedArgSerialization(A)){const j=[];for(let H=0,B=A.length;H<B;H++){const k=A[H];if(k instanceof L.VSBuffer)j[H]={type:2,value:k};else if(typeof k>"u")j[H]={type:4};else if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:$}=c(k.value,F);j[H]={type:3,value:L.VSBuffer.fromString(N),buffers:$}}else j[H]={type:1,value:L.VSBuffer.fromString(n(k,F))}}return{type:1,args:j}}return{type:0,args:n(A,F)}}static serializeRequest(A,F,j,H,B){switch(H.type){case 0:return this._requestJSONArgs(A,F,j,H.args,B);case 1:return this._requestMixedArgs(A,F,j,H.args,B)}}static _requestJSONArgs(A,F,j,H,B){const k=L.VSBuffer.fromString(j),N=L.VSBuffer.fromString(H);let $=0;$+=w.sizeUInt8(),$+=w.sizeShortString(k),$+=w.sizeLongString(N);const re=w.alloc(B?2:1,A,$);return re.writeUInt8(F),re.writeShortString(k),re.writeLongString(N),re.buffer}static deserializeRequestJSONArgs(A){const F=A.readUInt8(),j=A.readShortString(),H=A.readLongString();return{rpcId:F,method:j,args:JSON.parse(H)}}static _requestMixedArgs(A,F,j,H,B){const k=L.VSBuffer.fromString(j);let N=0;N+=w.sizeUInt8(),N+=w.sizeShortString(k),N+=w.sizeMixedArray(H);const $=w.alloc(B?4:3,A,N);return $.writeUInt8(F),$.writeShortString(k),$.writeMixedArray(H),$.buffer}static deserializeRequestMixedArgs(A){const F=A.readUInt8(),j=A.readShortString(),H=A.readMixedArray(),B=new Array(H.length);for(let k=0,N=H.length;k<N;k++){const $=H[k];typeof $=="string"?B[k]=JSON.parse($):B[k]=$}return{rpcId:F,method:j,args:B}}static serializeAcknowledged(A){return w.alloc(5,A,0).buffer}static serializeCancel(A){return w.alloc(6,A,0).buffer}static serializeReplyOK(A,F,j){if(typeof F>"u")return this._serializeReplyOKEmpty(A);if(F instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,F);if(F instanceof R.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:B}=c(F.value,j,!0);return this._serializeReplyOKJSONWithBuffers(A,H,B)}else return this._serializeReplyOKJSON(A,u(F,j))}static _serializeReplyOKEmpty(A){return w.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,F){let j=0;j+=w.sizeVSBuffer(F);const H=w.alloc(8,A,j);return H.writeVSBuffer(F),H.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,F){const j=L.VSBuffer.fromString(F);let H=0;H+=w.sizeLongString(j);const B=w.alloc(9,A,H);return B.writeLongString(j),B.buffer}static _serializeReplyOKJSONWithBuffers(A,F,j){const H=L.VSBuffer.fromString(F);let B=0;B+=w.sizeUInt32,B+=w.sizeLongString(H);for(const N of j)B+=w.sizeVSBuffer(N);const k=w.alloc(10,A,B);k.writeUInt32(j.length),k.writeLongString(H);for(const N of j)k.writeBuffer(N);return k.buffer}static deserializeReplyOKJSON(A){const F=A.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(A,F){const j=A.readUInt32(),H=A.readLongString(),B=[];for(let k=0;k<j;++k)B.push(A.readVSBuffer());return new R.SerializableObjectWithBuffers(t(H,B,F))}static serializeReplyErr(A,F){const j=F?u(O.transformErrorForSerialization(F),null):void 0;if(typeof j!="string")return this._serializeReplyErrEmpty(A);const H=L.VSBuffer.fromString(j);let B=0;B+=w.sizeLongString(H);const k=w.alloc(11,A,B);return k.writeLongString(H),k.buffer}static deserializeReplyErrError(A){const F=A.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(A){return w.alloc(12,A,0).buffer}}var h;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var _;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(_||(_={}))}),define(Te[238],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const I=function(O){const T=m=>{globalThis.removeEventListener("message",T);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(y,R){f.postMessage(y,R)}},onmessage:{get(){return f.onmessage},set(y){f.onmessage=y}}}),f.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",T)}.toString();class L extends EventTarget{constructor(O,T,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${I})('${T}'))`,y=new Blob([f],{type:"application/javascript"}),R=URL.createObjectURL(y),C=new MessageChannel,u=R,E={type:"_newWorker",id:u,port:C.port2,url:R,options:m};O(E,[C.port2]),this.postMessage=C.port1.postMessage.bind(C.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),C.port1.close(),C.port2.close()},Object.defineProperties(this,{onmessage:{get(){return C.port1.onmessage},set(p){C.port1.onmessage=p}},onmessageerror:{get(){return C.port1.onmessageerror},set(p){C.port1.onmessageerror=p}}}),C.port1.addEventListener("messageerror",p=>{const s=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(s)}),C.port1.addEventListener("message",p=>{const s=new MessageEvent("message",{data:p.data});this.dispatchEvent(s)}),C.port1.start()}}e.NestedWorker=L}),define(Te[239],Ae([1,0,24,28,12,54,4]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.generate=e.parse=e.INotebookDocumentService=void 0,e.INotebookDocumentService=(0,T.createDecorator)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),y=7;function R(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const p=E.fragment.indexOf("s");if(p<0)return;const s=parseInt(E.fragment.substring(0,p).replace(f,""),y),c=(0,I.decodeBase64)(E.fragment.substring(p+1)).toString();if(!isNaN(s))return{handle:s,notebook:E.with({scheme:c,fragment:null})}}e.parse=R;function C(E,p){const s=p.toString(y),t=`${s.length<m.length?m[s.length-1]:"z"}${s}s${(0,I.encodeBase64)(I.VSBuffer.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:t})}e.generate=C;class u{constructor(){this._documents=new L.ResourceMap}getNotebook(p){if(p.scheme===P.Schemas.vscodeNotebookCell){const s=R(p);if(s){const c=this._documents.get(s.notebook);if(c)return c}}return this._documents.get(p)}addNotebookDocument(p){this._documents.set(p.uri,p)}removeNotebookDocument(p){this._documents.delete(p.uri)}}e.NotebookDocumentWorkbenchService=u,(0,O.registerSingleton)(e.INotebookDocumentService,u,1)}),define(Te[83],Ae([1,0,24,35,51,69,12,19,21,36,239]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var C;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(C||(e.CellKind=C={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var u;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var p;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var s;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var c;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var t;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var r;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var a;(function($){$.scheme=T.Schemas.vscodeNotebookCell;function re(se,pe){return(0,R.generate)(se,pe)}$.generate=re;function le(se){return(0,R.parse)(se)}$.parse=le;function _e(se,pe){return se.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${se.scheme!==T.Schemas.file?se.scheme:""}`})}$.generateCellOutputUri=_e;function ye(se){if(se.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!pe)return;const ee=pe[1]&&pe[1]!==""?pe[1]:void 0,X=pe[2];return{outputId:ee,notebook:se.with({scheme:X||T.Schemas.file,fragment:null})}}$.parseCellOutputUri=ye;function de(se,pe,ee){return $.generate(se,pe).with({scheme:ee})}$.generateCellPropertyUri=de;function Ee(se,pe){if(se.scheme===pe)return $.parse(se.with({scheme:$.scheme}))}$.parseCellPropertyUri=Ee})(a||(e.CellUri=a={}));const d=$=>f.isWindows?$.replace(/\//g,"\\"):$;class i{constructor(re=[],le=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=le,this.order=[...new Set(re)].map(_e=>({pattern:_e,matches:L.parse(d(_e))}))}sort(re){const le=new Map(P.Iterable.map(re,ye=>[ye,d(ye)]));let _e=[];for(const{matches:ye}of this.order)for(const[de,Ee]of le)if(ye(Ee)){_e.push(de),le.delete(de);break}return le.size&&(_e=_e.concat([...le.keys()].sort((ye,de)=>this.defaultOrder.indexOf(ye)-this.defaultOrder.indexOf(de)))),_e}prioritize(re,le){const _e=this.findIndex(re);if(_e===-1){this.order.unshift({pattern:re,matches:L.parse(d(re))});return}const ye=new Set(le.map(Ee=>this.findIndex(Ee,_e)));ye.delete(-1);const de=Array.from(ye).sort();this.order.splice(_e+1,0,...de.map(Ee=>this.order[Ee]));for(let Ee=de.length-1;Ee>=0;Ee--)this.order.splice(de[Ee],1)}toArray(){return this.order.map(re=>re.pattern)}findIndex(re,le=this.order.length){const _e=d(re);for(let ye=0;ye<le;ye++)if(this.order[ye].matches(_e))return ye;return-1}}e.MimeTypeDisplayOrder=i;function v($,re,le,_e=(ye,de)=>ye===de){const ye=[];function de(pe,ee,X){if(ee===0&&X.length===0)return;const V=ye[ye.length-1];V&&V.start+V.deleteCount===pe?(V.deleteCount+=ee,V.toInsert.push(...X)):ye.push({start:pe,deleteCount:ee,toInsert:X})}let Ee=0,se=0;for(;;){if(Ee===$.length){de(Ee,0,re.slice(se));break}if(se===re.length){de(Ee,$.length-Ee,[]);break}const pe=$[Ee],ee=re[se];if(_e(pe,ee)){Ee+=1,se+=1;continue}le(ee)?(de(Ee,1,[]),Ee+=1):(de(Ee,0,[ee]),se+=1)}return ye}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtLineBoundary","none");var l;(function($){$.default="default",$.option="option"})(l||(e.NotebookEditorPriority=l={}));function o($){const re=$;return!!((typeof re.include=="string"||L.isRelativePattern(re.include))&&(typeof re.exclude=="string"||L.isRelativePattern(re.exclude)))}e.isDocumentExcludePattern=o;function S($,re,le){if(Array.isArray($.viewType)&&$.viewType.indexOf(re)>=0||$.viewType===re)return!0;if($.filenamePattern){const _e=o($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,ye=o($.filenamePattern)?$.filenamePattern.exclude:void 0;if(L.match(_e,(0,m.basename)(le.fsPath).toLowerCase()))return!(ye&&L.match(ye,(0,m.basename)(le.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=S,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var w;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class g{static{this._prefix="notebook/"}static create(re){return`${g._prefix}${re}`}static parse(re){if(re.startsWith(g._prefix))return re.substring(g._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=g;function D($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=D;const h=new TextDecoder;function _($){const re=[];let le=!1;for(const Ee of $)(re.length===0||le)&&(re.push(Ee),le=!0);let _e=F(re);const ye=I.VSBuffer.concat(re.map(Ee=>I.VSBuffer.wrap(Ee))),de=N(ye);return _e=_e||de.byteLength!==ye.byteLength,{data:de,didCompression:_e}}e.compressOutputItemStreams=_,e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const b=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map($=>$.charCodeAt(0)),A=10;function F($){let re=!1;return $.forEach((le,_e)=>{if(_e===0||le.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ye=$[_e-1],de=le.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(de[0]===b[0]&&de[1]===b[1]&&de[2]===b[2]){const Ee=ye.lastIndexOf(A);if(Ee===-1)return;re=!0,$[_e-1]=ye.subarray(0,Ee),$[_e]=le.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),re}function j($){let re=$;do $=re,re=$.replace(/[^\n]\x08/gm,"");while(re.length<$.length);return $}function H($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const re=$.match(/^(.*)\r+/m)[1];let le=$.match(/\r+(.*)$/m)[1];le=le+re.slice(le.length,re.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return $}const B=8,k=13;function N($){return!$.buffer.includes(B)&&!$.buffer.includes(k)?$:I.VSBuffer.fromString(H(j(h.decode($.buffer))))}}),define(Te[7],Ae([1,0,18,15,53,28,69,13,16,2,33,20,42,100,83]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p){"use strict";var s,c,t,n,r,a,d,i,v,l,o,S,w,g,D,h,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelAssistantMessage=e.LanguageModelUserMessage=e.LanguageModelSystemMessage=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function b(z){return Object.assign(z,{apply:function(...ie){if(ie.length===0)return Reflect.construct(z,[]);{const Ce=ie.length===1?[]:ie[1];return Reflect.construct(z,Ce,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(z,[]);{const[Ce,...Ke]=ie;return Reflect.construct(z,Ke,Ce.constructor)}}})}var A;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var F;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let j=s=class{static from(...U){let ie=U;return new s(function(){if(ie){for(const Ce of ie)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();ie=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=j,e.Disposable=j=s=Ge([b],j);let H=c=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ce=1;Ce<U.length;Ce++){const Ke=U[Ce];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ce=1;Ce<U.length;Ce++){const Ke=U[Ce];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof c)return!0;const{line:ie,character:Ce}=U;return typeof ie=="number"&&typeof Ce=="number"}static of(U){if(U instanceof c)return U;if(this.isPosition(U))return new c(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(U,ie){if(U<0)throw(0,L.illegalArgument)("line must be non-negative");if(ie<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=U,this._character=ie}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,L.illegalArgument)();let Ce;return typeof U>"u"?Ce=0:typeof U=="number"?Ce=U:(Ce=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),Ce===0&&ie===0?this:new c(this.line+Ce,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,L.illegalArgument)();let Ce;return typeof U>"u"?Ce=this.line:typeof U=="number"?Ce=U:(Ce=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),Ce===this.line&&ie===this.character?this:new c(Ce,ie)}toJSON(){return{line:this.line,character:this.character}}};e.Position=H,e.Position=H=c=Ge([b],H);let B=t=class{static isRange(U){return U instanceof t?!0:U?H.isPosition(U.start)&&H.isPosition(U.end):!1}static of(U){if(U instanceof t)return U;if(this.isRange(U))return new t(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(U,ie,Ce,Ke){let Ze,lt;if(typeof U=="number"&&typeof ie=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(Ze=new H(U,ie),lt=new H(Ce,Ke)):H.isPosition(U)&&H.isPosition(ie)&&(Ze=H.of(U),lt=H.of(ie)),!Ze||!lt)throw new Error("Invalid arguments");Ze.isBefore(lt)?(this._start=Ze,this._end=lt):(this._start=lt,this._end=Ze)}contains(U){return t.isRange(U)?this.contains(U.start)&&this.contains(U.end):H.isPosition(U)?!(H.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ie=H.Max(U.start,this._start),Ce=H.Min(U.end,this._end);if(!ie.isAfter(Ce))return new t(ie,Ce)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=H.Min(U.start,this._start),Ce=H.Max(U.end,this.end);return new t(ie,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,L.illegalArgument)();let Ce;return U?H.isPosition(U)?Ce=U:(Ce=U.start||this.start,ie=U.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&ie.isEqual(this.end)?this:new t(Ce,ie)}toJSON(){return[this.start,this.end]}};e.Range=B,e.Range=B=t=Ge([b],B);let k=n=class extends B{static isSelection(U){return U instanceof n?!0:U?B.isRange(U)&&H.isPosition(U.anchor)&&H.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(U,ie,Ce,Ke){let Ze,lt;if(typeof U=="number"&&typeof ie=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(Ze=new H(U,ie),lt=new H(Ce,Ke)):H.isPosition(U)&&H.isPosition(ie)&&(Ze=H.of(U),lt=H.of(ie)),!Ze||!lt)throw new Error("Invalid arguments");super(Ze,lt),this._anchor=Ze,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=k,e.Selection=k=n=Ge([b],k);const N=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,L.illegalArgument)("connectionToken")};class ${static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,ie,Ce){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,L.illegalArgument)("port");typeof Ce<"u"&&N(Ce),this.host=U,this.port=Math.round(ie),this.connectionToken=Ce}}e.ResolvedAuthority=$;class re{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,ie){this.makeConnection=U,this.connectionToken=ie,typeof ie<"u"&&N(ie)}}e.ManagedResolvedAuthority=re;class le extends Error{static NotAvailable(U,ie){return new le(U,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new le(U,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=E.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(U),this._message=U,this._code=ie,this._detail=Ce,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var _e;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(_e||(e.EndOfLine=_e={}));var ye;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ye||(e.EnvironmentVariableMutatorType=ye={}));let de=r=class{static isTextEdit(U){return U instanceof r?!0:U?B.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new r(U,ie)}static insert(U,ie){return r.replace(new B(U,U),ie)}static delete(U){return r.replace(U,"")}static setEndOfLine(U){const ie=new r(new B(new H(0,0),new H(0,0)),"");return ie.newEol=U,ie}get range(){return this._range}set range(U){if(U&&!B.isRange(U))throw(0,L.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,L.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,L.illegalArgument)("newEol");this._newEol=U}constructor(U,ie){this._range=U,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=de,e.TextEdit=de=r=Ge([b],de);let Ee=a=class{static isNotebookCellEdit(U){return U instanceof a?!0:U?di.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new a(U,ie)}static insertCells(U,ie){return new a(new di(U,U),ie)}static deleteCells(U){return new a(U,[])}static updateCellMetadata(U,ie){const Ce=new a(new di(U,U),[]);return Ce.newCellMetadata=ie,Ce}static updateNotebookMetadata(U){const ie=new a(new di(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};e.NotebookEdit=Ee,e.NotebookEdit=Ee=a=Ge([b],Ee);class se{static isSnippetTextEdit(U){return U instanceof se?!0:U?B.isRange(U.range)&&X.isSnippetString(U.snippet):!1}static replace(U,ie){return new se(U,ie)}static insert(U,ie){return se.replace(new B(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=se;var pe;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ie,Ce,Ke){this._edits.push({_type:1,from:U,to:ie,options:Ce,metadata:Ke})}createFile(U,ie,Ce){this._edits.push({_type:1,from:void 0,to:U,options:ie,metadata:Ce})}deleteFile(U,ie,Ce){this._edits.push({_type:1,from:U,to:void 0,options:ie,metadata:Ce})}replaceNotebookMetadata(U,ie,Ce){this._edits.push({_type:3,metadata:Ce,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(U,ie,Ce,Ke){const Ze=ie.start,lt=ie.end;(Ze!==lt||Ce.length>0)&&this._edits.push({_type:5,uri:U,index:Ze,count:lt-Ze,cells:Ce,metadata:Ke})}replaceNotebookCellMetadata(U,ie,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:U,edit:{editType:3,index:ie,metadata:Ce}})}replace(U,ie,Ce,Ke){this._edits.push({_type:2,uri:U,edit:new de(ie,Ce),metadata:Ke})}insert(U,ie,Ce,Ke){this.replace(U,new B(ie,ie),Ce,Ke)}delete(U,ie,Ce){this.replace(U,ie,"",Ce)}has(U){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const Ce of ie){if(!Ce)continue;let Ke,Ze;Array.isArray(Ce)?(Ke=Ce[0],Ze=Ce[1]):Ke=Ce,Ee.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(U,Ke.range.start,Ke.newCellMetadata,Ze):Ke.newNotebookMetadata?this.replaceNotebookMetadata(U,Ke.newNotebookMetadata,Ze):this.replaceNotebookCells(U,Ke.range,Ke.newCells,Ze):se.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Ze}):this._edits.push({_type:2,uri:U,edit:Ke,metadata:Ze})}else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this._edits[Ce]=void 0);break}}(0,I.coalesceInPlace)(this._edits)}}get(U){const ie=[];for(const Ce of this._edits)Ce._type===2&&Ce.uri.toString()===U.toString()&&ie.push(Ce.edit);return ie}entries(){const U=new O.ResourceMap;for(const ie of this._edits)if(ie._type===2){let Ce=U.get(ie.uri);Ce||(Ce=[ie.uri,[]],U.set(ie.uri,Ce)),Ce[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ee,e.WorkspaceEdit=ee=Ge([b],ee);let X=d=class{static isSnippetString(U){return U instanceof d?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this._tabstop=1,this.value=U||""}appendText(U){return this.value+=d._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this._tabstop++){if(typeof U=="function"){const Ce=new d;Ce._tabstop=this._tabstop,U(Ce),this._tabstop=Ce._tabstop,U=Ce.value}else U=d._escape(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this._tabstop++){const Ce=U.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const Ce=new d;Ce._tabstop=this._tabstop,ie(Ce),this._tabstop=Ce._tabstop,ie=Ce.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.SnippetString=X,e.SnippetString=X=d=Ge([b],X);var V;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(U){return U instanceof i?!0:U?B.isRange(U.range)&&y.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(B.isRange(ie))this.range=B.of(ie);else if(H.isPosition(ie))this.range=new B(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Ie,e.Location=Ie=i=Ge([b],Ie);let Fe=class{static is(U){return U?typeof U.message=="string"&&U.location&&B.isRange(U.location.range)&&y.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};e.DiagnosticRelatedInformation=Fe,e.DiagnosticRelatedInformation=Fe=Ge([b],Fe);let ke=class{constructor(U,ie,Ce=ne.Error){if(!B.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=Ce}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,I.equals)(U.tags,ie.tags)&&(0,I.equals)(U.relatedInformation,ie.relatedInformation,Fe.isEqual)}};e.Diagnostic=ke,e.Diagnostic=ke=Ge([b],ke);let we=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};e.Hover=we,e.Hover=we=Ge([b],we);var me;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let K=class{constructor(U,ie=me.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.DocumentHighlight=K,e.DocumentHighlight=K=Ge([b],K);let J=class{constructor(U,ie){this.uri=U,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(U=>U.toJSON())}}};e.MultiDocumentHighlight=J,e.MultiDocumentHighlight=J=Ge([b],J);var ue;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var he;(function(z){z[z.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let Pe=v=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,Ce,Ke,Ze){this.name=U,this.kind=ie,this.containerName=Ze,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof Ie?this.location=Ke:Ce instanceof B&&(this.location=new Ie(Ke,Ce)),v.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Pe,e.SymbolInformation=Pe=v=Ge([b],Pe);let ge=l=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(l.validate)}constructor(U,ie,Ce,Ke,Ze){this.name=U,this.detail=ie,this.kind=Ce,this.range=Ke,this.selectionRange=Ze,this.children=[],l.validate(this)}};e.DocumentSymbol=ge,e.DocumentSymbol=ge=l=Ge([b],ge);var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let Re=class{constructor(U,ie){this.title=U,this.kind=ie}};e.CodeAction=Re,e.CodeAction=Re=Ge([b],Re);let xe=class{static{o=this}static{this.sep="."}constructor(U){this.value=U}append(U){return new o(this.value?this.value+o.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+o.sep)}};e.CodeActionKind=xe,e.CodeActionKind=xe=o=Ge([b],xe),xe.Empty=new xe(""),xe.QuickFix=xe.Empty.append("quickfix"),xe.Refactor=xe.Empty.append("refactor"),xe.RefactorExtract=xe.Refactor.append("extract"),xe.RefactorInline=xe.Refactor.append("inline"),xe.RefactorMove=xe.Refactor.append("move"),xe.RefactorRewrite=xe.Refactor.append("rewrite"),xe.Source=xe.Empty.append("source"),xe.SourceOrganizeImports=xe.Source.append("organizeImports"),xe.SourceFixAll=xe.Source.append("fixAll"),xe.Notebook=xe.Empty.append("notebook");let M=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=M,e.SelectionRange=M=Ge([b],M);class x{constructor(U,ie,Ce,Ke,Ze,lt){this.kind=U,this.name=ie,this.detail=Ce,this.uri=Ke,this.range=Ze,this.selectionRange=lt}}e.CallHierarchyItem=x;class q{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=q;class W{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=W;var te;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(te||(e.LanguageStatusSeverity=te={}));let oe=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};e.CodeLens=oe,e.CodeLens=oe=Ge([b],oe);let Ne=S=class{#e;static isMarkdownString(U){return U instanceof S?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){this.#e=new P.MarkdownString(U,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,ie){return this.#e.appendCodeblock(ie??"",U),this}};e.MarkdownString=Ne,e.MarkdownString=Ne=S=Ge([b],Ne);let $e=class{constructor(U,ie){this.label=U,this.documentation=ie}};e.ParameterInformation=$e,e.ParameterInformation=$e=Ge([b],$e);let We=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};e.SignatureInformation=We,e.SignatureInformation=We=Ge([b],We);let Je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Je,e.SignatureHelp=Je=Ge([b],Je);var tt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var ut;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ut||(e.InlayHintKind=ut={}));let rt=class{constructor(U){this.value=U}};e.InlayHintLabelPart=rt,e.InlayHintLabelPart=rt=Ge([b],rt);let it=class{constructor(U,ie,Ce){this.position=U,this.label=ie,this.kind=Ce}};e.InlayHint=it,e.InlayHint=it=Ge([b],it);var ot;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot||(e.CompletionTriggerKind=ot={}));var ze;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(ze||(e.CompletionItemKind=ze={}));var et;(function(z){z[z.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let Y=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Y,e.CompletionItem=Y=Ge([b],Y);let Q=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};e.CompletionList=Q,e.CompletionList=Q=Ge([b],Q);let ve=class{constructor(U,ie,Ce){this.insertText=U,this.range=ie,this.command=Ce}};e.InlineSuggestion=ve,e.InlineSuggestion=ve=Ge([b],ve);let He=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.InlineSuggestionList=He,e.InlineSuggestionList=He=Ge([b],He);var Qe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var st;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Oe(z,U){return`${C.ExtensionIdentifier.toKey(z)}.${U}`}e.asStatusBarItemIdentifier=Oe;var yt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Wt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var Ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Xt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var Qt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Qt||(e.TextDocumentChangeReason=Qt={}));var Dt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var qt;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(z){function U(ie){switch(ie){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=U}(qt||(e.SyntaxTokenType=qt={}));let jt=class{constructor(U,ie){if(ie&&!y.URI.isUri(ie))throw(0,L.illegalArgument)("target");if(!B.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.target=ie}};e.DocumentLink=jt,e.DocumentLink=jt=Ge([b],jt);let Jt=class{constructor(U,ie,Ce,Ke){this.red=U,this.green=ie,this.blue=Ce,this.alpha=Ke}};e.Color=Jt,e.Color=Jt=Ge([b],Jt);let ii=class{constructor(U,ie){if(ie&&!(ie instanceof Jt))throw(0,L.illegalArgument)("color");if(!B.isRange(U)||U.isEmpty)throw(0,L.illegalArgument)("range");this.range=U,this.color=ie}};e.ColorInformation=ii,e.ColorInformation=ii=Ge([b],ii);let Ye=class{constructor(U){if(!U||typeof U!="string")throw(0,L.illegalArgument)("label");this.label=U}};e.ColorPresentation=Ye,e.ColorPresentation=Ye=Ge([b],Ye);var Mt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Mt||(e.ColorFormat=Mt={}));var Zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Zt||(e.SourceControlInputBoxValidationType=Zt={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft||(e.TerminalExitReason=ft={}));class Et{constructor(U,ie,Ce){if(this.startIndex=U,this.length=ie,this.tooltip=Ce,typeof U!="number"||U<0)throw(0,L.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,L.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=Et;class ei{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=ei;class zt{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=zt;var Ut;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class ht{constructor(U){if(this.options=U,typeof U!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=ht;var Tt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var ti;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(ti||(e.TaskPanelKind=ti={}));let Yt=class{static{w=this}static{this.Clean=new w("clean","Clean")}static{this.Build=new w("build","Build")}static{this.Rebuild=new w("rebuild","Rebuild")}static{this.Test=new w("test","Test")}static from(U){switch(U){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,L.illegalArgument)("name");this._id=U}get id(){return this._id}};e.TaskGroup=Yt,e.TaskGroup=Yt=w=Ge([b],Yt);function qe(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let Lt=class{constructor(U,ie,Ce){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=U,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Ce):this._options=ie)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,L.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)U.push(ie);return qe(U)}};e.ProcessExecution=Lt,e.ProcessExecution=Lt=Ge([b],Lt);let xt=class{constructor(U,ie,Ce){if(this._args=[],Array.isArray(ie)){if(!U)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U,this._args=ie,this._options=Ce}else{if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,L.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)U.push(typeof ie=="string"?ie:ie.value);return qe(U)}};e.ShellExecution=xt,e.ShellExecution=xt=Ge([b],xt);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var mt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(mt||(e.TaskScope=mt={}));class Ot{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=Ot;let kt=class{static{g=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(U,ie,Ce,Ke,Ze,lt){this.__deprecated=!1,this._definition=this.definition=U;let gt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Ce,this.execution=Ke,gt=Ze,this.__deprecated=!0):ie===mt.Global||ie===mt.Workspace?(this.target=ie,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=Ze,gt=lt):(this.target=ie,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=Ze,gt=lt),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Lt?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof xt?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ie=this._definition.type;(g.EmptyType===ie||g.ProcessType===ie||g.ShellType===ie||g.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};e.Task=kt,e.Task=kt=g=Ge([b],kt);var Bt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var ri;(function(z){function U(ie){const Ce=ie;return(0,f.isNumber)(Ce.value)?Ce.tooltip&&!(0,f.isString)(Ce.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ce.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ce.value),!1)}z.isViewBadge=U})(ri||(e.ViewBadge=ri={}));let Nt=D=class{static isTreeItem(U,ie){const Ce=U;if(Ce.checkboxState!==void 0){const Ke=(0,f.isNumber)(Ce.checkboxState)?Ce.checkboxState:(0,f.isObject)(Ce.checkboxState)&&(0,f.isNumber)(Ce.checkboxState.state)?Ce.checkboxState.state:void 0,Ze=!(0,f.isNumber)(Ce.checkboxState)&&(0,f.isObject)(Ce.checkboxState)?Ce.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Pt.Checked&&Ke!==Pt.Unchecked||Ze!==void 0&&!(0,f.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",Ce.checkboxState),!1}if(U instanceof D)return!0;if(Ce.label!==void 0&&!(0,f.isString)(Ce.label)&&!Ce.label?.label)return console.log("INVALID tree item, invalid label",Ce.label),!1;if(Ce.id!==void 0&&!(0,f.isString)(Ce.id))return console.log("INVALID tree item, invalid id",Ce.id),!1;if(Ce.iconPath!==void 0&&!(0,f.isString)(Ce.iconPath)&&!y.URI.isUri(Ce.iconPath)&&(!Ce.iconPath||!(0,f.isString)(Ce.iconPath.id))){const Ke=Ce.iconPath;if(!Ke||!(0,f.isString)(Ke.light)&&!y.URI.isUri(Ke.light)&&!(0,f.isString)(Ke.dark)&&!y.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ce.iconPath),!1}return Ce.description!==void 0&&!(0,f.isString)(Ce.description)&&typeof Ce.description!="boolean"?(console.log("INVALID tree item, invalid description",Ce.description),!1):Ce.resourceUri!==void 0&&!y.URI.isUri(Ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ce.resourceUri),!1):Ce.tooltip!==void 0&&!(0,f.isString)(Ce.tooltip)&&!(Ce.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",Ce.tooltip),!1):Ce.command!==void 0&&!Ce.command.command?(console.log("INVALID tree item, invalid command",Ce.command),!1):Ce.collapsibleState!==void 0&&Ce.collapsibleState<$t.None&&Ce.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ce.collapsibleState),!1):Ce.contextValue!==void 0&&!(0,f.isString)(Ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ce.contextValue),!1):Ce.accessibilityInformation!==void 0&&!Ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ce.accessibilityInformation),!1):!0}constructor(U,ie=$t.None){this.collapsibleState=ie,y.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.TreeItem=Nt,e.TreeItem=Nt=D=Ge([b],Nt);var $t;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Pt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let Ct=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.DataTransferItem=Ct,e.DataTransferItem=Ct=Ge([b],Ct);class pt extends Ct{}e.InternalDataTransferItem=pt;class It extends pt{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.InternalFileDataTransferItem=It;class wt{constructor(U,ie,Ce,Ke){this.name=U,this.uri=ie,this._itemId=Ce,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=wt;let ui=class{#e=new Map;constructor(U){for(const[ie,Ce]of U??[]){const Ke=this.#e.get(this.#t(ie));Ke?Ke.push(Ce):this.#e.set(this.#t(ie),[Ce])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,ie){this.#e.set(this.#t(U),[ie])}forEach(U,ie){for(const[Ce,Ke]of this.#e)for(const Ze of Ke)U.call(ie,Ze,Ce,this)}*[Symbol.iterator](){for(const[U,ie]of this.#e)for(const Ce of ie)yield[U,Ce]}#t(U){return U.toLowerCase()}};e.DataTransfer=ui,e.DataTransfer=ui=Ge([b],ui);let Kt=class{constructor(U){this.insertText=U}};e.DocumentDropEdit=Kt,e.DocumentDropEdit=Kt=Ge([b],Kt);let pi=class{constructor(U,ie){this.label=ie,this.insertText=U}};e.DocumentPasteEdit=pi,e.DocumentPasteEdit=pi=Ge([b],pi);let be=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.ThemeIcon=be,e.ThemeIcon=be=Ge([b],be),be.File=new be("file"),be.Folder=new be("folder");let Le=class{constructor(U){this.id=U}};e.ThemeColor=Le,e.ThemeColor=Le=Ge([b],Le);var ae;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ae||(e.ConfigurationTarget=ae={}));let G=class{get base(){return this._base}set base(U){this._base=U,this._baseUri=y.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!y.URI.isUri(U)&&!y.URI.isUri(U.uri)))throw(0,L.illegalArgument)("base");if(typeof ie!="string")throw(0,L.illegalArgument)("pattern");typeof U=="string"?this.baseUri=y.URI.file(U):y.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=G,e.RelativePattern=G=Ge([b],G);const Se=new WeakMap;function Me(z,U){Se.set(z,U)}e.setBreakpointId=Me;let Xe=class{constructor(U,ie,Ce,Ke,Ze){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ze=="string"&&(this.mode=Ze)}get id(){return this._id||(this._id=Se.get(this)??(0,R.generateUuid)()),this._id}};e.Breakpoint=Xe,e.Breakpoint=Xe=Ge([b],Xe);let je=class extends Xe{constructor(U,ie,Ce,Ke,Ze,lt){if(super(ie,Ce,Ke,Ze,lt),U===null)throw(0,L.illegalArgument)("location");this.location=U}};e.SourceBreakpoint=je,e.SourceBreakpoint=je=Ge([b],je);let at=class extends Xe{constructor(U,ie,Ce,Ke,Ze,lt){super(ie,Ce,Ke,Ze,lt),this.functionName=U}};e.FunctionBreakpoint=at,e.FunctionBreakpoint=at=Ge([b],at);let _t=class extends Xe{constructor(U,ie,Ce,Ke,Ze,lt,gt,Vt){if(super(Ke,Ze,lt,gt,Vt),!ie)throw(0,L.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=Ce}};e.DataBreakpoint=_t,e.DataBreakpoint=_t=Ge([b],_t);let Ht=class{constructor(U,ie,Ce){this.command=U,this.args=ie||[],this.options=Ce}};e.DebugAdapterExecutable=Ht,e.DebugAdapterExecutable=Ht=Ge([b],Ht);let St=class{constructor(U,ie){this.port=U,this.host=ie}};e.DebugAdapterServer=St,e.DebugAdapterServer=St=Ge([b],St);let At=class{constructor(U){this.path=U}};e.DebugAdapterNamedPipeServer=At,e.DebugAdapterNamedPipeServer=At=Ge([b],At);let Gt=class{constructor(U){this.implementation=U}};e.DebugAdapterInlineImplementation=Gt,e.DebugAdapterInlineImplementation=Gt=Ge([b],Gt);let vi=class{constructor(U,ie,Ce){this.session=U,this.threadId=ie,this.frameId=Ce}};e.StackFrameFocus=vi,e.StackFrameFocus=vi=Ge([b],vi);let Ei=class{constructor(U,ie){this.session=U,this.threadId=ie}};e.ThreadFocus=Ei,e.ThreadFocus=Ei=Ge([b],Ei);let dt=class{constructor(U,ie){this.range=U,this.expression=ie}};e.EvaluatableExpression=dt,e.EvaluatableExpression=dt=Ge([b],dt);var Qi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ai=class{constructor(U,ie){this.range=U,this.text=ie}};e.InlineValueText=ai,e.InlineValueText=ai=Ge([b],ai);let fi=class{constructor(U,ie,Ce=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=Ce}};e.InlineValueVariableLookup=fi,e.InlineValueVariableLookup=fi=Ge([b],fi);let _i=class{constructor(U,ie){this.range=U,this.expression=ie}};e.InlineValueEvaluatableExpression=_i,e.InlineValueEvaluatableExpression=_i=Ge([b],_i);let Ti=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};e.InlineValueContext=Ti,e.InlineValueContext=Ti=Ge([b],Ti);var Yi;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));class dn{constructor(U,ie){this.newSymbolName=U,this.tags=ie}}e.NewSymbolName=dn;var Ai;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Ri=h=class extends Error{static FileExists(U){return new h(U,u.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(U){return new h(U,u.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(U){return new h(U,u.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(U){return new h(U,u.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(U){return new h(U,u.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(U){return new h(U,u.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(U,ie=u.FileSystemProviderErrorCode.Unknown,Ce){super(y.URI.isUri(U)?U.toString(!0):U),this.code=Ce?.name??"Unknown",(0,u.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}};e.FileSystemError=Ri,e.FileSystemError=Ri=h=Ge([b],Ri);let Si=class{constructor(U,ie,Ce){this.start=U,this.end=ie,this.kind=Ce}};e.FoldingRange=Si,e.FoldingRange=Si=Ge([b],Si);var mi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(mi||(e.FoldingRangeKind=mi={}));var Ji;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var yi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(yi||(e.CommentMode=yi={}));var Ci;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Ci||(e.CommentState=Ci={}));var Zi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Zi||(e.CommentThreadState=Zi={}));class hn{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=hn;function bi(z){return typeof z>"u"||(0,f.isStringArray)(z)}class Li{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ie=0,Ce=U.tokenTypes.length;ie<Ce;ie++)this._tokenTypeStrToInt.set(U.tokenTypes[ie],ie);for(let ie=0,Ce=U.tokenModifiers.length;ie<Ce;ie++)this._tokenModifierStrToInt.set(U.tokenModifiers[ie],ie)}}push(U,ie,Ce,Ke,Ze){if(typeof U=="number"&&typeof ie=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this._pushEncoded(U,ie,Ce,Ke,Ze);if(B.isRange(U)&&typeof ie=="string"&&bi(Ce))return this._push(U,ie,Ce);throw(0,L.illegalArgument)()}_push(U,ie,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Ze=U.start.character,lt=U.end.character-U.start.character,gt=this._tokenTypeStrToInt.get(ie);let Vt=0;if(Ce)for(const oi of Ce){if(!this._tokenModifierStrToInt.has(oi))throw new Error("`tokenModifier` is not in the provided legend");const li=this._tokenModifierStrToInt.get(oi);Vt|=1<<li>>>0}this._pushEncoded(Ke,Ze,lt,gt,Vt)}_pushEncoded(U,ie,Ce,Ke,Ze){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Vt=this._data.length/5|0;let oi=0,li=0;for(let hi=0;hi<Vt;hi++){let gi=this._data[5*hi],Gi=this._data[5*hi+1];gi===0?(gi=oi,Gi+=li):gi+=oi,this._data[5*hi]=gi,this._data[5*hi+1]=Gi,oi=gi,li=Gi}}let lt=U,gt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=Ze,this._prevLine=U,this._prevChar=ie}static _sortAndDeltaEncode(U){const ie=[],Ce=U.length/5|0;for(let gt=0;gt<Ce;gt++)ie[gt]=gt;ie.sort((gt,Vt)=>{const oi=U[5*gt],li=U[5*Vt];if(oi===li){const hi=U[5*gt+1],gi=U[5*Vt+1];return hi-gi}return oi-li});const Ke=new Uint32Array(U.length);let Ze=0,lt=0;for(let gt=0;gt<Ce;gt++){const Vt=5*ie[gt],oi=U[Vt+0],li=U[Vt+1],hi=U[Vt+2],gi=U[Vt+3],Gi=U[Vt+4],Pn=oi-Ze,Jn=Pn===0?li-lt:li,Xi=5*gt;Ke[Xi+0]=Pn,Ke[Xi+1]=Jn,Ke[Xi+2]=hi,Ke[Xi+3]=gi,Ke[Xi+4]=Gi,Ze=oi,lt=li}return Ke}build(U){return this._dataIsSortedAndDeltaEncoded?new Oi(new Uint32Array(this._data),U):new Oi(Li._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Li;class Oi{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Oi;class fn{constructor(U,ie,Ce){this.start=U,this.deleteCount=ie,this.data=Ce}}e.SemanticTokensEdit=fn;class Ii{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Ii;var en;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class mn{constructor(U){this.name=U}}e.DebugVisualization=mn;let wi=class{static{this.Back={iconPath:new be("arrow-left")}}constructor(){}};e.QuickInputButtons=wi,e.QuickInputButtons=wi=Ge([b],wi);var Ni;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ni||(e.QuickPickItemKind=Ni={}));var tn;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var Fi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Fi||(e.ExtensionKind=Fi={}));class nn{static validate(U){if(typeof U.badge=="string"){let ie=(0,m.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,m.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!be.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,Ce){this.badge=U,this.tooltip=ie,this.color=Ce}}e.FileDecoration=nn;let Mi=class{constructor(U){this.kind=U}};e.ColorTheme=Mi,e.ColorTheme=Mi=Ge([b],Mi);var rn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class di{static isNotebookRange(U){return U instanceof di?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(U,ie){if(U<0)throw(0,L.illegalArgument)("start must be positive");if(ie<0)throw(0,L.illegalArgument)("end must be positive");U<=ie?(this._start=U,this._end=ie):(this._start=ie,this._end=U)}with(U){let ie=this._start,Ce=this._end;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(Ce=U.end),ie===this._start&&Ce===this._end?this:new di(ie,Ce)}}e.NotebookRange=di;class Di{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>Di.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,Ce,Ke,Ze,lt,gt){this.kind=U,this.value=ie,this.languageId=Ce,this.mime=Ke,this.outputs=Ze??[],this.metadata=lt,this.executionSummary=gt,Di.validate(this)}}e.NotebookCellData=Di;class Ui{constructor(U){this.cells=U}}e.NotebookData=Ui;class si{static isNotebookCellOutputItem(U){return U instanceof si?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return si.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return si.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return si.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new si(U,ie)}static#e=new TextEncoder;static text(U,ie=T.Mimes.text){const Ce=si.#e.encode(String(U));return new si(Ce,ie)}static json(U,ie="text/x-json"){const Ce=JSON.stringify(U,void 0,"	");return si.text(Ce,ie)}constructor(U,ie){this.data=U,this.mime=ie;const Ce=(0,T.normalizeMimeType)(ie,!0);if(!Ce)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}}e.NotebookCellOutputItem=si;class Ue{static isNotebookCellOutput(U){return U instanceof Ue?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const Ce=new Set,Ke=new Set;for(let Ze=0;Ze<U.length;Ze++){const lt=U[Ze],gt=(0,T.normalizeMimeType)(lt.mime);if(!Ce.has(gt)||(0,p.isTextStreamMime)(gt)){Ce.add(gt);continue}Ke.add(Ze),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Ze,lt)=>!Ke.has(lt))}constructor(U,ie,Ce){this.items=Ue.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ce):(this.id=(0,R.generateUuid)(),this.metadata=ie??Ce)}}e.NotebookCellOutput=Ue;var ci;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(ci||(e.NotebookCellKind=ci={}));var xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var nt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(nt||(e.NotebookCellStatusBarAlignment=nt={}));var vt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(vt||(e.NotebookEditorRevealType=vt={}));class gn{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=gn;var sn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var Bi;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Bi||(e.NotebookControllerAffinity2=Bi={}));class pn{constructor(U,ie=[]){this.uri=U,this.provides=(0,I.asArray)(ie)}}e.NotebookRendererScript=pn;class ki{constructor(U){this.label=U}}e.NotebookKernelSourceAction=ki;var on;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let zi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};e.TimelineItem=zi,e.TimelineItem=zi=Ge([b],zi);var an;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var $i;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})($i||(e.ExtensionRuntime=$i={}));var cn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class vn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=vn;class En{constructor(U){this._autoForwardAction=U}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=En;var ln;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(ln||(e.TestResultState=ln={}));var un;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Hi=class{constructor(U=void 0,ie=void 0,Ce=void 0,Ke=!1){this.include=U,this.exclude=ie,this.profile=Ce,this.continuous=Ke}};e.TestRunRequest=Hi,e.TestRunRequest=Hi=Ge([b],Hi);let Vi=_=class{static diff(U,ie,Ce){const Ke=new _(U);return Ke.expectedOutput=ie,Ke.actualOutput=Ce,Ke}constructor(U){this.message=U}};e.TestMessage=Vi,e.TestMessage=Vi=_=Ge([b],Vi);let Wi=class{constructor(U){this.id=U}};e.TestTag=Wi,e.TestTag=Wi=Ge([b],Wi);class Pi{constructor(U,ie){this.covered=U,this.total=ie}}e.CoveredCount=Pi;const qi=z=>{if(z&&z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`)};class ji{static fromDetails(U,ie){const Ce=new Pi(0,0),Ke=new Pi(0,0),Ze=new Pi(0,0);for(const gt of ie)if("branches"in gt){Ce.total+=1,Ce.covered+=gt.executed?1:0;for(const Vt of gt.branches)Ke.total+=1,Ke.covered+=Vt.executed?1:0}else Ze.total+=1,Ze.covered+=gt.executed?1:0;const lt=new ji(U,Ce,Ke.total>0?Ke:void 0,Ze.total>0?Ze:void 0);return lt.detailedCoverage=ie,lt}constructor(U,ie,Ce,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=Ce,this.declarationCoverage=Ke,qi(ie),qi(Ce),qi(Ke)}}e.FileCoverage=ji;class Z{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ie,Ce=[]){this.executed=U,this.location=ie,this.branches=Ce}}e.StatementCoverage=Z;class ce{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ie,Ce){this.executed=U,this.location=ie,this.label=Ce}}e.BranchCoverage=ce;class Be{get executionCount(){return+this.executed}set executionCount(U){this.executed=U}constructor(U,ie,Ce){this.name=U,this.executed=ie,this.location=Ce}}e.DeclarationCoverage=Be;var ct;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(ct||(e.ExternalUriOpenerPriority=ct={}));var bt;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bt||(e.WorkspaceTrustState=bt={}));var Rt;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Rt||(e.PortAutoForwardAction=Rt={}));class Ki{constructor(U,ie,Ce,Ke,Ze,lt){this.kind=U,this.name=ie,this.detail=Ce,this.uri=Ke,this.range=Ze,this.selectionRange=lt}}e.TypeHierarchyItem=Ki;class Tn{constructor(U){this.uri=U}}e.TextTabInput=Tn;class An{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=An;class Rn{constructor(U,ie,Ce,Ke){this.base=U,this.input1=ie,this.input2=Ce,this.result=Ke}}e.TextMergeTabInput=Rn;class Ln{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=Ln;class On{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=On;class Nn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=Nn;class Fn{constructor(U,ie,Ce){this.original=U,this.modified=ie,this.notebookType=Ce}}e.NotebookDiffEditorTabInput=Fn;class Mn{constructor(){}}e.TerminalEditorTabInput=Mn;class Un{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=Un;class xn{constructor(U){this.providerId=U}}e.ChatEditorTabInput=xn;var bn;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(wn||(e.ChatCopyKind=wn={}));var _n;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(_n||(e.ChatVariableLevel=_n={}));class Bn{constructor(U,ie){this.label=U,this.values=ie}}e.ChatCompletionItem=Bn;var Sn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var yn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(yn||(e.ChatResultFeedbackKind=yn={}));class zn{constructor(U){this.value=typeof U=="string"?new Ne(U):U}}e.ChatResponseMarkdownPart=zn;class $n{constructor(U,ie){this.value=U,this.baseUri=ie}}e.ChatResponseFileTreePart=$n;class Hn{constructor(U,ie){this.value=U,this.title=ie}}e.ChatResponseAnchorPart=Hn;class Vn{constructor(U){this.value=U}}e.ChatResponseProgressPart=Vn;class Wn{constructor(U){this.value=U}}e.ChatResponseCommandButtonPart=Wn;class qn{constructor(U){this.value=U}}e.ChatResponseReferencePart=qn;class jn{constructor(U,ie,Ce,Ke){this.prompt=U,this.command=ie,this.variables=Ce,this.participant=Ke}}e.ChatRequestTurn=jn;class Kn{constructor(U,ie,Ce,Ke){this.response=U,this.result=ie,this.participant=Ce,this.command=Ke}}e.ChatResponseTurn=Kn;class Gn{constructor(U){this.content=U}}e.LanguageModelSystemMessage=Gn;class Xn{constructor(U,ie){this.content=U,this.name=ie}}e.LanguageModelUserMessage=Xn;class Qn{constructor(U){this.content=U}}e.LanguageModelAssistantMessage=Qn;var Cn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var In;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}));var Dn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Dn||(e.KeywordRecognitionStatus=Dn={}));class Yn{constructor(U,ie){this.text=U,this.range=ie}}e.InlineEdit=Yn;var kn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(kn||(e.InlineEditTriggerKind=kn={}))}),define(Te[240],Ae([1,0,3,7]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class P{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(I.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,m,f){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const y=this._relatedInformationProviders.get(T);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(m,f)??[]}getRelatedInformation(T,m,f){return this._proxy.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(T,m,f){const y=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(y,f),this._proxy.$registerAiRelatedInformationProvider(y,m),new L.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(y),this._relatedInformationProviders.delete(y)})}}e.ExtHostRelatedInformation=P}),define(Te[241],Ae([1,0,5,3,7,20,104]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class m{constructor(R){this._authenticationProviders=new Map,this._onDidChangeSessions=new I.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new f,this._getSessionsTaskSingler=new f,this._proxy=R.getProxy(L.MainContext.MainThreadAuthentication)}async getSession(R,C,u,E={}){const p=O.ExtensionIdentifier.toKey(R.identifier),s=[...u].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${p} ${C} ${s}`,async()=>{await this._proxy.$ensureProvider(C);const c=R.displayName||R.name;return this._proxy.$getSession(C,u,p,c,E)})}async getSessions(R,C,u){const E=O.ExtensionIdentifier.toKey(R.identifier),p=[...u].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${E} ${p}`,async()=>{await this._proxy.$ensureProvider(C);const s=R.displayName||R.name;return this._proxy.$getSessions(C,u,E,s)})}async removeSession(R,C){const u=this._authenticationProviders.get(R);return u?u.provider.removeSession(C):this._proxy.$removeSession(R,C)}registerAuthenticationProvider(R,C,u,E){if(this._authenticationProviders.get(R))throw new Error(`An authentication provider with id '${R}' is already registered.`);this._authenticationProviders.set(R,{label:C,provider:u,options:E??{supportsMultipleAccounts:!1}});const p=u.onDidChangeSessions(s=>this._proxy.$sendDidChangeSessions(R,s));return this._proxy.$registerAuthenticationProvider(R,C,E?.supportsMultipleAccounts??!1),new P.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(R),this._proxy.$unregisterAuthenticationProvider(R)})}$createSession(R,C,u){const E=this._authenticationProviders.get(R);if(E)return Promise.resolve(E.provider.createSession(C,u));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$removeSession(R,C){const u=this._authenticationProviders.get(R);if(u)return Promise.resolve(u.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$getSessions(R,C){const u=this._authenticationProviders.get(R);if(u)return Promise.resolve(u.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$onDidChangeAuthenticationSessions(R,C){return R.startsWith(T.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:R,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=m;class f{constructor(){this._inFlightPromises=new Map}getOrCreate(R,C){const u=this._inFlightPromises.get(R);if(u)return u;const E=C().finally(()=>this._inFlightPromises.delete(R));return this._inFlightPromises.set(R,E),E}}}),define(Te[108],Ae([1,0,2,3,7,4,17,14,18,13,19,23]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class{static{u=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(s,c){this._logService=c,this._provider=new Map,this._proxy=s.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(s,c){const t=u._handlePool++;this._provider.set(t,{provider:s,extensionDescription:c}),this._proxy.$registerDecorationProvider(t,c.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(r=>{if(!r){this._proxy.$onDidChange(t,null);return}const a=(0,f.asArray)(r);if(a.length<=u._maxEventSize){this._proxy.$onDidChange(t,a);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,a.length);const d=a.map(l=>({uri:l,rank:(0,y.count)(l.path,"/")})),i=(0,f.groupBy)(d,(l,o)=>l.rank-o.rank||(0,y.compare)(l.uri.path,o.uri.path)),v=[];e:for(const l of i){let o;for(const S of l){const w=(0,R.dirname)(S.uri.path);if(o!==w&&(o=w,v.push(S.uri)>=u._maxEventSize))break e}}this._proxy.$onDidChange(t,v)});return new P.Disposable(()=>{n?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(s,c,t){if(!this._provider.has(s))return Object.create(null);const n=Object.create(null),{provider:r,extensionDescription:a}=this._provider.get(s);return await Promise.all(c.map(async d=>{try{const{uri:i,id:v}=d,l=await Promise.resolve(r.provideFileDecoration(I.URI.revive(i),t));if(!l)return;try{P.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,C.checkProposedApiEnabled)(a,"codiconDecoration"),n[v]=[l.propagate,l.tooltip,l.badge,l.color]}catch(o){this._logService.warn(`INVALID decoration from extension '${a.identifier.value}': ${o}`)}}catch(i){this._logService.error(i)}})),n}};e.ExtHostDecorations=E,e.ExtHostDecorations=E=u=Ge([Ve(0,T.IExtHostRpcService),Ve(1,m.ILogService)],E),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")}),define(Te[242],Ae([1,0,15,2,7,3,12,22,13]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{static{this._handlePool=0}constructor(C,u,E){this._documentsAndEditors=u,this._logService=E,this._documentContentProviders=new Map,this._proxy=C.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,u){if(Object.keys(T.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=y._handlePool++;this._documentContentProviders.set(E,u),this._proxy.$registerTextContentProvider(E,C);let p;if(typeof u.onDidChange=="function"){let s;p=u.onDidChange(async c=>{if(c.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(c))return;s&&await s;const t=this.$provideTextDocumentContent(E,c).then(async n=>{if(!n&&typeof n!="string")return;const r=this._documentsAndEditors.getDocument(c);if(!r)return;const a=(0,f.splitLines)(n);if(!r.equalLines(a))return this._proxy.$onVirtualDocumentChange(c,n)}).catch(I.onUnexpectedError).finally(()=>{s===t&&(s=void 0)});s=t})}return new P.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(C,u){const E=this._documentContentProviders.get(C);return E?Promise.resolve(E.provideTextDocumentContent(L.URI.revive(u),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=y}),define(Te[109],Ae([1,0,55,12,13,298,148,7,18]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const y=new Map;function R(p,s){s?y.set(p,s):y.delete(p)}e.setWordDefinitionFor=R;function C(p){return y.get(p)}class u extends O.MirrorTextModel{constructor(s,c,t,n,r,a,d){super(c,t,n,r),this._proxy=s,this._languageId=a,this._isDirty=d,this._isDisposed=!1}dispose(){(0,I.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,f.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===L.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},save(){return s._save()},getText(c){return c?s._getTextInRange(c):s.getText()},get eol(){return s._eol===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(c){return s._lineAt(c)},offsetAt(c){return s._offsetAt(c)},positionAt(c){return s._positionAt(c)},validateRange(c){return s._validateRange(c)},validatePosition(c){return s._validatePosition(c)},getWordRangeAtPosition(c,t){return s._getWordRangeAtPosition(c,t)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,I.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,I.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const c=this._validateRange(s);if(c.isEmpty)return"";if(c.isSingleLine)return this._lines[c.start.line].substring(c.start.character,c.end.character);const t=this._eol,n=c.start.line,r=c.end.line,a=[];a.push(this._lines[n].substring(c.start.character));for(let d=n+1;d<r;d++)a.push(this._lines[d]);return a.push(this._lines[r].substring(0,c.end.character)),a.join(t)}_lineAt(s){let c;if(s instanceof m.Position?c=s.line:typeof s=="number"&&(c=s),typeof c!="number"||c<0||c>=this._lines.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new E(c,this._lines[c],c===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const c=this._lineStarts.getIndexOf(s),t=this._lines[c.index].length;return new m.Position(c.index,Math.min(c.remainder,t))}_validateRange(s){if(!(s instanceof m.Range))throw new Error("Invalid argument");const c=this._validatePosition(s.start),t=this._validatePosition(s.end);return c===s.start&&t===s.end?s:new m.Range(c.line,c.character,t.line,t.character)}_validatePosition(s){if(!(s instanceof m.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:c,character:t}=s,n=!1;if(c<0)c=0,t=0,n=!0;else if(c>=this._lines.length)c=this._lines.length-1,t=this._lines[c].length,n=!0;else{const r=this._lines[c].length;t<0?(t=0,n=!0):t>r&&(t=r,n=!0)}return n?new m.Position(c,t):s}_getWordRangeAtPosition(s,c){const t=this._validatePosition(s);if(!c)c=C(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const n=(0,T.getWordAtText)(t.character+1,(0,T.ensureValidWordDefinition)(c),this._lines[t.line],0);if(n)return new m.Range(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.ExtHostDocumentData=u;class E{constructor(s,c,t){this._line=s,this._text=c,this._isLastLine=t}get lineNumber(){return this._line}get text(){return this._text}get range(){return new m.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new m.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(Te[243],Ae([1,0,3,7]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class P{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(I.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,m,f){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const y=this._AiEmbeddingVectorProviders.get(T);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector(m,f);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(T,m,f){const y=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(y,f),this._proxy.$registerAiEmbeddingVectorProvider(m,y),new L.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(y),this._AiEmbeddingVectorProviders.delete(y)})}}e.ExtHostAiEmbeddingVector=P}),define(Te[63],Ae([1,0,3,42,7,24,4,17,43,6,11,25,12]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let p=E=class{constructor(c,t){this._fileSystemProvider=new Map,this._writeQueue=new R.ResourceQueue,this._proxy=c.getProxy(I.MainContext.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(r){try{let a;const d=n._fileSystemProvider.get(r.scheme);return d?(await n._proxy.$ensureActivation(r.scheme),a=await d.impl.stat(r)):a=await n._proxy.$stat(r),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){E._handleError(a)}},async readDirectory(r){try{const a=n._fileSystemProvider.get(r.scheme);return a?(await n._proxy.$ensureActivation(r.scheme),(await a.impl.readDirectory(r)).slice()):await n._proxy.$readdir(r)}catch(a){return E._handleError(a)}},async createDirectory(r){try{const a=n._fileSystemProvider.get(r.scheme);return a&&!a.isReadonly?(await n._proxy.$ensureActivation(r.scheme),await n.mkdirp(a.impl,a.extUri,r)):await n._proxy.$mkdir(r)}catch(a){return E._handleError(a)}},async readFile(r){try{const a=n._fileSystemProvider.get(r.scheme);return a?(await n._proxy.$ensureActivation(r.scheme),(await a.impl.readFile(r)).slice()):(await n._proxy.$readFile(r)).buffer}catch(a){return E._handleError(a)}},async writeFile(r,a){try{const d=n._fileSystemProvider.get(r.scheme);return d&&!d.isReadonly?(await n._proxy.$ensureActivation(r.scheme),await n.mkdirp(d.impl,d.extUri,d.extUri.dirname(r)),await n._writeQueue.queueFor(r,()=>Promise.resolve(d.impl.writeFile(r,a,{create:!0,overwrite:!0})))):await n._proxy.$writeFile(r,O.VSBuffer.wrap(a))}catch(d){return E._handleError(d)}},async delete(r,a){try{const d=n._fileSystemProvider.get(r.scheme);return d&&!d.isReadonly&&!a?.useTrash?(await n._proxy.$ensureActivation(r.scheme),await d.impl.delete(r,{recursive:!1,...a})):await n._proxy.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(d){return E._handleError(d)}},async rename(r,a,d){try{return await n._proxy.$rename(r,a,{overwrite:!1,...d})}catch(i){return E._handleError(i)}},async copy(r,a,d){try{return await n._proxy.$copy(r,a,{overwrite:!1,...d})}catch(i){return E._handleError(i)}},isWritableFileSystem(r){const a=t.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}async mkdirp(c,t,n){const r=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await c.stat(n)).type&L.FileType.Directory))throw P.FileSystemError.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.toFileSystemProviderErrorCode(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(t.basename(n)),n=t.dirname(n)}for(let a=r.length-1;a>=0;a--){n=t.joinPath(n,r[a]);try{await c.createDirectory(n)}catch(d){if(L.toFileSystemProviderErrorCode(d)!==L.FileSystemProviderErrorCode.FileExists)throw d}}}static _handleError(c){if(c instanceof P.FileSystemError)throw c;if(c instanceof L.FileSystemProviderError)switch(c.code){case L.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(c.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(c.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(c.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(c.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(c.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(c.message);default:throw new P.FileSystemError(c.message,c.name)}if(!(c instanceof Error))throw new P.FileSystemError(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw P.FileSystemError.Unavailable(c.message);switch(c.name){case L.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(c.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(c.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(c.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(c.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(c.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(c.message);default:throw new P.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,t,n){return this._fileSystemProvider.set(c,{impl:t,extUri:n?.isCaseSensitive?C.extUri:C.extUriIgnorePathCase,isReadonly:!!n?.isReadonly}),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(c))}getFileSystemProviderExtUri(c){return this._fileSystemProvider.get(c)?.extUri??C.extUri}};e.ExtHostConsumerFileSystem=p,e.ExtHostConsumerFileSystem=p=E=Ge([Ve(0,m.IExtHostRpcService),Ve(1,f.IExtHostFileSystemInfo)],p),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Te[244],Ae([1,0,3,7]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class P{constructor(T){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,m){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const f=this._IssueUriRequestHandlers.get(T);if(!f)throw new Error("Issue request handler not found");const y=await f.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(T,m){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const f=this._IssueDataProviders.get(T);if(!f)throw new Error("Issue data provider not found");const y=await f.provideIssueData(m);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(T,m){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const f=this._IssueDataProviders.get(T);if(!f)throw new Error("Issue data provider not found");const y=await f.provideIssueTemplate(m);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(T,m){const f=T.identifier.value;return this._IssueUriRequestHandlers.set(f,m),this._proxy.$registerIssueUriRequestHandler(f),new L.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(f),this._IssueUriRequestHandlers.delete(f)})}registerIssueDataProvider(T,m){const f=T.identifier.value;return this._IssueDataProviders.set(f,m),this._proxy.$registerIssueDataProvider(f),new L.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(f),this._IssueDataProviders.delete(f)})}}e.ExtHostIssueReporter=P}),define(Te[84],Ae([1,0,4,27,14,63,2]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,I.createDecorator)("IExtensionStoragePaths");let m=class{constructor(y,R,C){this._logService=R,this._extHostFileSystem=C,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(y){return T.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,R=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(C){this._logService.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this._value)return T.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return T.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=m,e.ExtensionStoragePaths=m=Ge([Ve(0,L.IExtHostInitDataService),Ve(1,P.ILogService),Ve(2,O.IExtHostConsumerFileSystem)],m)}),define(Te[245],Ae([1,0,7,17,5]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=class{constructor(m){this._actual=new I.ColorTheme(I.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(m){let f;switch(m){case"light":f=I.ColorThemeKind.Light;break;case"hcDark":f=I.ColorThemeKind.HighContrast;break;case"hcLight":f=I.ColorThemeKind.HighContrastLight;break;default:f=I.ColorThemeKind.Dark}this._actual=new I.ColorTheme(f),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=O,e.ExtHostTheming=O=Ge([Ve(0,L.IExtHostRpcService)],O)}),define(Te[85],Ae([1,0,22,5,6,169,4,14,198,3,27,17,7]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class E extends f.DisposableTunnel{}var p;(function(c){function t(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:r.protocol}}c.fromApiTunnel=t;function n(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==f.TunnelPrivacyId.ConstantPrivate&&r.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}c.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let s=class extends P.Disposable{constructor(t,n,r){super(),this.logService=r,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new L.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadTunnelService)}async openTunnel(t,n){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const r=await this._proxy.$openTunnel(n,t.displayName);if(r){const a=new E(r.remoteAddress,r.localAddress,()=>this._proxy.$closeTunnel(r.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(t,n){const r=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(r,{selector:t,provider:n}),this._proxy.$registerPortsAttributesProvider(t,r),new u.Disposable(()=>{this._portAttributesProviders.delete(r),this._proxy.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(t,n,r,a,d){const i=[];for(const l of t){const o=this._portAttributesProviders.get(l);if(!o)return[];i.push(...await Promise.all(n.map(async S=>{let w;try{w=await o.provider.providePortAttributes({port:S,pid:r,commandLine:a},d)}catch{w=await o.provider.providePortAttributes(S,r,a,d)}return{providedAttributes:w,port:S}})))}const v=i.filter(l=>!!l.providedAttributes);return v.length>0?v.map(l=>({autoForwardAction:l.providedAttributes.autoForwardAction,port:l.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(a,d)=>await t.provideTunnel(a,d,new I.CancellationTokenSource().token)??void 0;const r=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(r),Promise.resolve((0,P.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this._showCandidatePort=t.showCandidatePort,this._proxy.$setCandidateFilter());const r=t.tunnelFactory??(n?this.makeManagedTunnelFactory(n):void 0);if(r){this._forwardPortProvider=r;let a=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const d=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this._proxy.$setTunnelProvider(d)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(t){}async $closeTunnel(t,n){if(this._extensionTunnels.has(t.host)){const r=this._extensionTunnels.get(t.host);r.has(t.port)&&(n&&r.get(t.port).disposeListener.dispose(),await r.get(t.port).tunnel.dispose(),r.delete(t.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(t,n){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this._forwardPortProvider(t,n);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const a=await r;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(t.remoteAddress.host)||this._extensionTunnels.set(t.remoteAddress.host,new Map);const d=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:a,disposeListener:d}),p.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(a=>this._showCandidatePort(a.host,a.port,a.detail??""))),r=t.filter((a,d)=>n[d]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(a=>a.port).join(", ")} to ${r.map(a=>a.port).join(", ")}`),r}};e.ExtHostTunnelService=s,e.ExtHostTunnelService=s=Ge([Ve(0,C.IExtHostRpcService),Ve(1,R.IExtHostInitDataService),Ve(2,m.ILogService)],s)}),define(Te[8],Ae([1,0,18,24,128,246,53,28,121,52,69,26,25,16,2,29,86,98,103,102,83,48,60,217,23,7]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var S;(function(be){function Le(G){const{selectionStartLineNumber:Se,selectionStartColumn:Me,positionLineNumber:Xe,positionColumn:je}=G,at=new o.Position(Se-1,Me-1),_t=new o.Position(Xe-1,je-1);return new o.Selection(at,_t)}be.to=Le;function ae(G){const{anchor:Se,active:Me}=G;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}be.from=ae})(S||(e.Selection=S={}));var w;(function(be){function Le(G){if(!G)return;const{start:Se,end:Me}=G;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}be.from=Le;function ae(G){if(!G)return;const{startLineNumber:Se,startColumn:Me,endLineNumber:Xe,endColumn:je}=G;return new o.Range(Se-1,Me-1,Xe-1,je-1)}be.to=ae})(w||(e.Range=w={}));var g;(function(be){function Le(G){return{uri:G.uri,range:w.from(G.range)}}be.from=Le;function ae(G){return new o.Location(p.URI.revive(G.uri),w.to(G.range))}be.to=ae})(g||(e.Location=g={}));var D;(function(be){function Le(ae){switch(ae){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}be.to=Le})(D||(e.TokenType=D={}));var h;(function(be){function Le(G){return new o.Position(G.lineNumber-1,G.column-1)}be.to=Le;function ae(G){return{lineNumber:G.line+1,column:G.character+1}}be.from=ae})(h||(e.Position=h={}));var _;(function(be){function Le(Se,Me,Xe){return(0,I.coalesce)((0,I.asArray)(Se).map(je=>ae(je,Me,Xe)))}be.from=Le;function ae(Se,Me,Xe){if(typeof Se=="string")return{$serialized:!0,language:Se,isBuiltin:Xe?.isBuiltin};if(Se)return{$serialized:!0,language:Se.language,scheme:G(Se.scheme,Me),pattern:Q.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType,isBuiltin:Xe?.isBuiltin}}function G(Se,Me){return Me&&typeof Se=="string"?Me.transformOutgoingScheme(Se):Se}})(_||(e.DocumentSelector=_={}));var b;(function(be){function Le(G){switch(G){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}be.from=Le;function ae(G){switch(G){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}be.to=ae})(b||(e.DiagnosticTag=b={}));var A;(function(be){function Le(G){let Se;return G.code&&((0,E.isString)(G.code)||(0,E.isNumber)(G.code)?Se=String(G.code):Se={value:String(G.code.value),target:G.code.target}),{...w.from(G.range),message:G.message,source:G.source,code:Se,severity:j.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(F.from),tags:Array.isArray(G.tags)?(0,I.coalesce)(G.tags.map(b.from)):void 0}}be.from=Le;function ae(G){const Se=new o.Diagnostic(w.to(G),G.message,j.to(G.severity));return Se.source=G.source,Se.code=(0,E.isString)(G.code)?G.code:G.code?.value,Se.relatedInformation=G.relatedInformation&&G.relatedInformation.map(F.to),Se.tags=G.tags&&(0,I.coalesce)(G.tags.map(b.to)),Se}be.to=ae})(A||(e.Diagnostic=A={}));var F;(function(be){function Le(G){return{...w.from(G.location.range),message:G.message,resource:G.location.uri}}be.from=Le;function ae(G){return new o.DiagnosticRelatedInformation(new o.Location(G.resource,w.to(G)),G.message)}be.to=ae})(F||(e.DiagnosticRelatedInformation=F={}));var j;(function(be){function Le(G){switch(G){case o.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}be.from=Le;function ae(G){switch(G){case t.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}be.to=ae})(j||(e.DiagnosticSeverity=j={}));var H;(function(be){function Le(G){return typeof G=="number"&&G>=o.ViewColumn.One?G-1:G===o.ViewColumn.Beside?v.SIDE_GROUP:v.ACTIVE_GROUP}be.from=Le;function ae(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(H||(e.ViewColumn=H={}));function B(be){return typeof be.range<"u"}function k(be){return be.length===0?!0:!!B(be[0])}e.isDecorationOptionsArr=k;var N;(function(be){function Le(je){return je.map(be.from)}be.fromMany=Le;function ae(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function G(je){let at;if(ae(je)){const{language:At,value:Gt}=je;at={value:"```"+At+`
`+Gt+"\n```\n"}}else o.MarkdownString.isMarkdownString(je)?at={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?at={value:je}:at={value:""};const _t=Object.create(null);at.uris=_t;const Ht=At=>{try{let Gt=p.URI.parse(At,!0);Gt=Gt.with({query:Se(Gt.query,_t)}),_t[At]=Gt}catch{}return""},St=new f.marked.Renderer;return St.link=Ht,St.image=At=>typeof At=="string"?Ht(T.parseHrefAndDimensions(At).href):"",(0,f.marked)(at.value,{renderer:St}),at}be.from=G;function Se(je,at){if(!je)return je;let _t;try{_t=(0,y.parse)(je)}catch{}if(!_t)return je;let Ht=!1;return _t=(0,C.cloneAndChange)(_t,St=>{if(p.URI.isUri(St)){const At=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[At]=St,Ht=!0,At}else return}),Ht?JSON.stringify(_t):je}function Me(je){const at=new o.MarkdownString(je.value,je.supportThemeIcons);return at.isTrusted=je.isTrusted,at.supportHtml=je.supportHtml,at.baseUri=je.baseUri?p.URI.from(je.baseUri):void 0,at}be.to=Me;function Xe(je){if(je)return typeof je=="string"?je:be.from(je)}be.fromStrict=Xe})(N||(e.MarkdownString=N={}));function $(be){return k(be)?be.map(Le=>({range:w.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?N.fromMany(Le.hoverMessage):Le.hoverMessage?N.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):be.map(Le=>({range:w.from(Le)}))}e.fromRangeOrRangeWithMessage=$;function re(be){return typeof be>"u"?be:typeof be=="string"?p.URI.file(be):be}e.pathOrURIToURI=re;var le;(function(be){function Le(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?re(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Le})(le||(e.ThemableDecorationAttachmentRenderOptions=le={}));var _e;(function(be){function Le(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?re(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?le.from(ae.before):void 0,after:ae.after?le.from(ae.after):void 0}}be.from=Le})(_e||(e.ThemableDecorationRenderOptions=_e={}));var ye;(function(be){function Le(ae){if(typeof ae>"u")return ae;switch(ae){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Le})(ye||(e.DecorationRangeBehavior=ye={}));var de;(function(be){function Le(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ye.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?_e.from(ae.light):void 0,dark:ae.dark?_e.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?re(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?le.from(ae.before):void 0,after:ae.after?le.from(ae.after):void 0}}be.from=Le})(de||(e.DecorationRenderOptions=de={}));var Ee;(function(be){function Le(G){return{text:G.newText,eol:G.newEol&&it.from(G.newEol),range:w.from(G.range)}}be.from=Le;function ae(G){const Se=new o.TextEdit(w.to(G.range),G.text);return Se.newEol=typeof G.eol>"u"?void 0:it.to(G.eol),Se}be.to=ae})(Ee||(e.TextEdit=Ee={}));var se;(function(be){function Le(G,Se){const Me={edits:[]};if(G instanceof o.WorkspaceEdit){const Xe=new m.ResourceSet;for(const je of G._allEntries())je._type===1&&p.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of G._allEntries())if(je._type===1){let at;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?at={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(je.options.contents))}:at={type:"dataTransferItem",id:je.options.contents._itemId}),Me.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:at},metadata:je.metadata})}else je._type===2?Me.edits.push({resource:je.uri,textEdit:Ee.from(je.edit),versionId:Xe.has(je.uri)?void 0:Se?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?Me.edits.push({resource:je.uri,textEdit:{range:w.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Se?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Me.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Me.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Se?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(Ft.from)}})}return Me}be.from=Le;function ae(G){const Se=new o.WorkspaceEdit,Me=new m.ResourceMap;for(const Xe of G.edits)if(Xe.textEdit){const je=Xe,at=p.URI.revive(je.resource),_t=w.to(je.textEdit.range),Ht=je.textEdit.text,St=je.textEdit.insertAsSnippet;let At;St?At=o.SnippetTextEdit.replace(_t,new o.SnippetString(Ht)):At=o.TextEdit.replace(_t,Ht);const Gt=Me.get(at);Gt?Gt.push(At):Me.set(at,[At])}else Se.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,je]of Me)Se.set(Xe,je);return Se}be.to=ae})(se||(e.WorkspaceEdit=se={}));var pe;(function(be){const Le=Object.create(null);Le[o.SymbolKind.File]=0,Le[o.SymbolKind.Module]=1,Le[o.SymbolKind.Namespace]=2,Le[o.SymbolKind.Package]=3,Le[o.SymbolKind.Class]=4,Le[o.SymbolKind.Method]=5,Le[o.SymbolKind.Property]=6,Le[o.SymbolKind.Field]=7,Le[o.SymbolKind.Constructor]=8,Le[o.SymbolKind.Enum]=9,Le[o.SymbolKind.Interface]=10,Le[o.SymbolKind.Function]=11,Le[o.SymbolKind.Variable]=12,Le[o.SymbolKind.Constant]=13,Le[o.SymbolKind.String]=14,Le[o.SymbolKind.Number]=15,Le[o.SymbolKind.Boolean]=16,Le[o.SymbolKind.Array]=17,Le[o.SymbolKind.Object]=18,Le[o.SymbolKind.Key]=19,Le[o.SymbolKind.Null]=20,Le[o.SymbolKind.EnumMember]=21,Le[o.SymbolKind.Struct]=22,Le[o.SymbolKind.Event]=23,Le[o.SymbolKind.Operator]=24,Le[o.SymbolKind.TypeParameter]=25;function ae(Se){return typeof Le[Se]=="number"?Le[Se]:6}be.from=ae;function G(Se){for(const Me in Le)if(Le[Me]===Se)return Number(Me);return o.SymbolKind.Property}be.to=G})(pe||(e.SymbolKind=pe={}));var ee;(function(be){function Le(G){switch(G){case o.SymbolTag.Deprecated:return 1}}be.from=Le;function ae(G){switch(G){case 1:return o.SymbolTag.Deprecated}}be.to=ae})(ee||(e.SymbolTag=ee={}));var X;(function(be){function Le(G){return{name:G.name,kind:pe.from(G.kind),tags:G.tags&&G.tags.map(ee.from),containerName:G.containerName,location:ke.from(G.location)}}be.from=Le;function ae(G){const Se=new o.SymbolInformation(G.name,pe.to(G.kind),G.containerName,ke.to(G.location));return Se.tags=G.tags&&G.tags.map(ee.to),Se}be.to=ae})(X||(e.WorkspaceSymbol=X={}));var V;(function(be){function Le(G){const Se={name:G.name||"!!MISSING: name!!",detail:G.detail,range:w.from(G.range),selectionRange:w.from(G.selectionRange),kind:pe.from(G.kind),tags:G.tags?.map(ee.from)??[]};return G.children&&(Se.children=G.children.map(Le)),Se}be.from=Le;function ae(G){const Se=new o.DocumentSymbol(G.name,G.detail,pe.to(G.kind),w.to(G.range),w.to(G.selectionRange));return(0,I.isNonEmptyArray)(G.tags)&&(Se.tags=G.tags.map(ee.to)),G.children&&(Se.children=G.children.map(ae)),Se}be.to=ae})(V||(e.DocumentSymbol=V={}));var ne;(function(be){function Le(G){const Se=new o.CallHierarchyItem(pe.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),w.to(G.range),w.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}be.to=Le;function ae(G,Se,Me){if(Se=Se??G._sessionId,Me=Me??G._itemId,Se===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Me,name:G.name,detail:G.detail,kind:pe.from(G.kind),uri:G.uri,range:w.from(G.range),selectionRange:w.from(G.selectionRange),tags:G.tags?.map(ee.from)}}be.from=ae})(ne||(e.CallHierarchyItem=ne={}));var Ie;(function(be){function Le(ae){return new o.CallHierarchyIncomingCall(ne.to(ae.from),ae.fromRanges.map(G=>w.to(G)))}be.to=Le})(Ie||(e.CallHierarchyIncomingCall=Ie={}));var Fe;(function(be){function Le(ae){return new o.CallHierarchyOutgoingCall(ne.to(ae.to),ae.fromRanges.map(G=>w.to(G)))}be.to=Le})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var ke;(function(be){function Le(G){return{range:G.range&&w.from(G.range),uri:G.uri}}be.from=Le;function ae(G){return new o.Location(p.URI.revive(G.uri),w.to(G.range))}be.to=ae})(ke||(e.location=ke={}));var we;(function(be){function Le(G){const Se=G,Me=G;return{originSelectionRange:Se.originSelectionRange?w.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Me.uri,range:w.from(Se.targetRange?Se.targetRange:Me.range),targetSelectionRange:Se.targetSelectionRange?w.from(Se.targetSelectionRange):void 0}}be.from=Le;function ae(G){return{targetUri:p.URI.revive(G.uri),targetRange:w.to(G.range),targetSelectionRange:G.targetSelectionRange?w.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?w.to(G.originSelectionRange):void 0}}be.to=ae})(we||(e.DefinitionLink=we={}));var me;(function(be){function Le(G){return{range:w.from(G.range),contents:N.fromMany(G.contents)}}be.from=Le;function ae(G){return new o.Hover(G.contents.map(N.to),w.to(G.range))}be.to=ae})(me||(e.Hover=me={}));var K;(function(be){function Le(G){return{range:w.from(G.range),expression:G.expression}}be.from=Le;function ae(G){return new o.EvaluatableExpression(w.to(G.range),G.expression)}be.to=ae})(K||(e.EvaluatableExpression=K={}));var J;(function(be){function Le(G){if(G instanceof o.InlineValueText)return{type:"text",range:w.from(G.range),text:G.text};if(G instanceof o.InlineValueVariableLookup)return{type:"variable",range:w.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Le;function ae(G){switch(G.type){case"text":return{range:w.to(G.range),text:G.text};case"variable":return{range:w.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:w.to(G.range),expression:G.expression}}}be.to=ae})(J||(e.InlineValue=J={}));var ue;(function(be){function Le(G){return{frameId:G.frameId,stoppedLocation:w.from(G.stoppedLocation)}}be.from=Le;function ae(G){return new o.InlineValueContext(G.frameId,w.to(G.stoppedLocation))}be.to=ae})(ue||(e.InlineValueContext=ue={}));var he;(function(be){function Le(G){return{range:w.from(G.range),kind:G.kind}}be.from=Le;function ae(G){return new o.DocumentHighlight(w.to(G.range),G.kind)}be.to=ae})(he||(e.DocumentHighlight=he={}));var Pe;(function(be){function Le(G){return{uri:G.uri,highlights:G.highlights.map(he.from)}}be.from=Le;function ae(G){return new o.MultiDocumentHighlight(p.URI.revive(G.uri),G.highlights.map(he.to))}be.to=ae})(Pe||(e.MultiDocumentHighlight=Pe={}));var ge;(function(be){function Le(ae){switch(ae){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}be.to=Le})(ge||(e.CompletionTriggerKind=ge={}));var De;(function(be){function Le(ae){return{triggerKind:ge.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Le})(De||(e.CompletionContext=De={}));var Re;(function(be){function Le(G){switch(G){case o.CompletionItemTag.Deprecated:return 1}}be.from=Le;function ae(G){switch(G){case 1:return o.CompletionItemTag.Deprecated}}be.to=ae})(Re||(e.CompletionItemTag=Re={}));var xe;(function(be){const Le=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ae(Me){return Le.get(Me)??9}be.from=ae;const G=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Se(Me){return G.get(Me)??o.CompletionItemKind.Property}be.to=Se})(xe||(e.CompletionItemKind=xe={}));var M;(function(be){function Le(ae,G){const Se=new o.CompletionItem(ae.label);return Se.insertText=ae.insertText,Se.kind=xe.to(ae.kind),Se.tags=ae.tags?.map(Re.to),Se.detail=ae.detail,Se.documentation=T.isMarkdownString(ae.documentation)?N.to(ae.documentation):ae.documentation,Se.sortText=ae.sortText,Se.filterText=ae.filterText,Se.preselect=ae.preselect,Se.commitCharacters=ae.commitCharacters,s.Range.isIRange(ae.range)?Se.range=w.to(ae.range):typeof ae.range=="object"&&(Se.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Se.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Se.insertText=new o.SnippetString(ae.insertText):(Se.insertText=ae.insertText,Se.textEdit=Se.range instanceof o.Range?new o.TextEdit(Se.range,Se.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Se.additionalTextEdits=ae.additionalTextEdits.map(Me=>Ee.to(Me))),Se.command=G&&ae.command?G.fromInternal(ae.command):void 0,Se}be.to=Le})(M||(e.CompletionItem=M={}));var x;(function(be){function Le(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:N.fromStrict(G.documentation)}}be.from=Le;function ae(G){return{label:G.label,documentation:T.isMarkdownString(G.documentation)?N.to(G.documentation):G.documentation}}be.to=ae})(x||(e.ParameterInformation=x={}));var q;(function(be){function Le(G){return{label:G.label,documentation:N.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(x.from):[],activeParameter:G.activeParameter}}be.from=Le;function ae(G){return{label:G.label,documentation:T.isMarkdownString(G.documentation)?N.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(x.to):[],activeParameter:G.activeParameter}}be.to=ae})(q||(e.SignatureInformation=q={}));var W;(function(be){function Le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}be.from=Le;function ae(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}be.to=ae})(W||(e.SignatureHelp=W={}));var te;(function(be){function Le(ae,G){const Se=new o.InlayHint(h.to(G.position),typeof G.label=="string"?G.label:G.label.map(oe.to.bind(void 0,ae)),G.kind&&Ne.to(G.kind));return Se.textEdits=G.textEdits&&G.textEdits.map(Ee.to),Se.tooltip=T.isMarkdownString(G.tooltip)?N.to(G.tooltip):G.tooltip,Se.paddingLeft=G.paddingLeft,Se.paddingRight=G.paddingRight,Se}be.to=Le})(te||(e.InlayHint=te={}));var oe;(function(be){function Le(ae,G){const Se=new o.InlayHintLabelPart(G.label);return Se.tooltip=T.isMarkdownString(G.tooltip)?N.to(G.tooltip):G.tooltip,c.Command.is(G.command)&&(Se.command=ae.fromInternal(G.command)),G.location&&(Se.location=ke.to(G.location)),Se}be.to=Le})(oe||(e.InlayHintLabelPart=oe={}));var Ne;(function(be){function Le(G){return G}be.from=Le;function ae(G){return G}be.to=ae})(Ne||(e.InlayHintKind=Ne={}));var $e;(function(be){function Le(G){return{range:w.from(G.range),url:G.target,tooltip:G.tooltip}}be.from=Le;function ae(G){let Se;if(G.url)try{Se=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new o.DocumentLink(w.to(G.range),Se)}be.to=ae})($e||(e.DocumentLink=$e={}));var We;(function(be){function Le(G){const Se=new o.ColorPresentation(G.label);return G.textEdit&&(Se.textEdit=Ee.to(G.textEdit)),G.additionalTextEdits&&(Se.additionalTextEdits=G.additionalTextEdits.map(Me=>Ee.to(Me))),Se}be.to=Le;function ae(G){return{label:G.label,textEdit:G.textEdit?Ee.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Se=>Ee.from(Se)):void 0}}be.from=ae})(We||(e.ColorPresentation=We={}));var Je;(function(be){function Le(G){return new o.Color(G[0],G[1],G[2],G[3])}be.to=Le;function ae(G){return[G.red,G.green,G.blue,G.alpha]}be.from=ae})(Je||(e.Color=Je={}));var tt;(function(be){function Le(G){return{range:w.from(G.range)}}be.from=Le;function ae(G){return new o.SelectionRange(w.to(G.range))}be.to=ae})(tt||(e.SelectionRange=tt={}));var ut;(function(be){function Le(ae){switch(ae){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}be.to=Le})(ut||(e.TextDocumentSaveReason=ut={}));var rt;(function(be){function Le(G){switch(G){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Le;function ae(G){switch(G){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}be.to=ae})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(be){function Le(G){if(G===o.EndOfLine.CRLF)return 1;if(G===o.EndOfLine.LF)return 0}be.from=Le;function ae(G){if(G===1)return o.EndOfLine.CRLF;if(G===0)return o.EndOfLine.LF}be.to=ae})(it||(e.EndOfLine=it={}));var ot;(function(be){function Le(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Le})(ot||(e.ProgressLocation=ot={}));var ze;(function(be){function Le(G){const Se={start:G.start+1,end:G.end+1};return G.kind&&(Se.kind=et.from(G.kind)),Se}be.from=Le;function ae(G){const Se={start:G.start-1,end:G.end-1};return G.kind&&(Se.kind=et.to(G.kind)),Se}be.to=ae})(ze||(e.FoldingRange=ze={}));var et;(function(be){function Le(G){if(G)switch(G){case o.FoldingRangeKind.Comment:return c.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return c.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return c.FoldingRangeKind.Region}}be.from=Le;function ae(G){if(G)switch(G.value){case c.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}be.to=ae})(et||(e.FoldingRangeKind=et={}));var Y;(function(be){function Le(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?r.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}be.from=Le})(Y||(e.TextEditorOpenOptions=Y={}));var Q;(function(be){function Le(Me){return Me instanceof o.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ae(Me)||G(Me)?new o.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}be.from=Le;function ae(Me){const Xe=Me;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function G(Me){const Xe=Me;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Se(Me){return typeof Me=="string"?Me:new o.RelativePattern(p.URI.revive(Me.baseUri),Me.pattern)}be.to=Se})(Q||(e.GlobPattern=Q={}));var ve;(function(be){function Le(ae){if(ae){if(Array.isArray(ae))return ae.map(Le);if(typeof ae=="string")return ae;{const G=ae;return{language:G.language,scheme:G.scheme,pattern:Q.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}be.from=Le})(ve||(e.LanguageSelector=ve={}));var He;(function(be){function Le(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Se=>Array.isArray(Se)&&Se.every(Me=>Me&&typeof Me=="object"&&"uri"in Me&&p.URI.isUri(Me.uri)&&"version"in Me&&typeof Me.version=="number"&&"ranges"in Me&&Array.isArray(Me.ranges)&&Me.ranges.every(Xe=>Xe instanceof o.Range)))}be.is=Le;function ae(G){return{documents:G.documents.map(Se=>Se.map(Me=>({uri:p.URI.from(Me.uri),version:Me.version,ranges:Me.ranges.map(Xe=>w.from(Xe))})))}}be.from=ae})(He||(e.MappedEditsContext=He={}));var Qe;(function(be){function Le(G){return{start:G.start,end:G.end}}be.from=Le;function ae(G){return new o.NotebookRange(G.start,G.end)}be.to=ae})(Qe||(e.NotebookRange=Qe={}));var st;(function(be){function Le(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}be.to=Le;function ae(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}be.from=ae})(st||(e.NotebookCellExecutionSummary=st={}));var Oe;(function(be){function Le(ae){if(ae===a.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ae===a.NotebookCellExecutionState.Pending)return;if(ae===a.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Le})(Oe||(e.NotebookCellExecutionState=Oe={}));var yt;(function(be){function Le(G){switch(G){case o.NotebookCellKind.Markup:return a.CellKind.Markup;case o.NotebookCellKind.Code:default:return a.CellKind.Code}}be.from=Le;function ae(G){switch(G){case a.CellKind.Markup:return o.NotebookCellKind.Markup;case a.CellKind.Code:default:return o.NotebookCellKind.Code}}be.to=ae})(yt||(e.NotebookCellKind=yt={}));var Wt;(function(be){function Le(G){const Se={metadata:G.metadata??Object.create(null),cells:[]};for(const Me of G.cells)o.NotebookCellData.validate(Me),Se.cells.push(Ft.from(Me));return Se}be.from=Le;function ae(G){const Se=new o.NotebookData(G.cells.map(Ft.to));return(0,E.isEmptyObject)(G.metadata)||(Se.metadata=G.metadata),Se}be.to=ae})(Wt||(e.NotebookData=Wt={}));var Ft;(function(be){function Le(G){return{cellKind:yt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:st.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Qt.from):[]}}be.from=Le;function ae(G){return new o.NotebookCellData(yt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Qt.to):void 0,G.metadata,G.internalMetadata?st.to(G.internalMetadata):void 0)}be.to=ae})(Ft||(e.NotebookCellData=Ft={}));var Xt;(function(be){function Le(G){return{mime:G.mime,valueBytes:L.VSBuffer.wrap(G.data)}}be.from=Le;function ae(G){return new o.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}be.to=ae})(Xt||(e.NotebookCellOutputItem=Xt={}));var Qt;(function(be){function Le(G){return{outputId:G.id,items:G.items.map(Xt.from),metadata:G.metadata}}be.from=Le;function ae(G){const Se=G.items.map(Xt.to);return new o.NotebookCellOutput(Se,G.outputId,G.metadata)}be.to=ae})(Qt||(e.NotebookCellOutput=Qt={}));var Dt;(function(be){function Le(Se){return G(Se)?{include:Q.from(Se.include)??void 0,exclude:Q.from(Se.exclude)??void 0}:Q.from(Se)??void 0}be.from=Le;function ae(Se){return G(Se)?{include:Q.to(Se.include),exclude:Q.to(Se.exclude)}:Q.to(Se)}be.to=ae;function G(Se){const Me=Se;return Me?!(0,E.isUndefinedOrNull)(Me.include)&&!(0,E.isUndefinedOrNull)(Me.exclude):!1}})(Dt||(e.NotebookExclusiveDocumentPattern=Dt={}));var qt;(function(be){function Le(ae,G,Se){const Me=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Me,Se),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Le})(qt||(e.NotebookStatusBarItem=qt={}));var jt;(function(be){function Le(ae,G,Se){const Me=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:G.toInternal(Me,Se),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Le})(jt||(e.NotebookKernelSourceAction=jt={}));var Jt;(function(be){function Le(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Le})(Jt||(e.NotebookDocumentContentOptions=Jt={}));var ii;(function(be){function Le(G){return{uri:G.uri,provides:G.provides}}be.from=Le;function ae(G){return new o.NotebookRendererScript(p.URI.revive(G.uri),G.provides)}be.to=ae})(ii||(e.NotebookRendererScript=ii={}));var Ye;(function(be){function Le(G){return{message:N.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:w.from(G.location.range),uri:G.location.uri}}}be.from=Le;function ae(G){const Se=new o.TestMessage(typeof G.message=="string"?G.message:N.to(G.message));return Se.actualOutput=G.actual,Se.expectedOutput=G.expected,Se.contextValue=G.contextValue,Se.location=G.location?ke.to(G.location):void 0,Se}be.to=ae})(Ye||(e.TestMessage=Ye={}));var Mt;(function(be){be.namespace=i.namespaceTestTag,be.denamespace=i.denamespaceTestTag})(Mt||(e.TestTag=Mt={}));var Zt;(function(be){function Le(G){const Se=(0,n.getPrivateApiFor)(G).controllerId;return{extId:d.TestId.fromExtHostTestItem(G,Se).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Me=>Mt.namespace(Se,Me.id)),range:s.Range.lift(w.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&N.fromStrict(G.error)||null}}be.from=Le;function ae(G){return{parent:void 0,error:void 0,id:d.TestId.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Se=>{const{tagId:Me}=Mt.denamespace(Se);return new o.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:w.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}be.toPlain=ae})(Zt||(e.TestItem=Zt={})),function(be){function Le(G){return{id:G.id}}be.from=Le;function ae(G){return new o.TestTag(G.id)}be.to=ae}(Mt||(e.TestTag=Mt={}));var ft;(function(be){const Le=(G,Se)=>{const Me=[];for(const[je,at]of Se)d.TestId.compare(at.item.extId,je)===2&&(Se.delete(je),Me.push(at));const Xe={...Zt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(at=>at.type===0).map(Ye.to)})),children:Me.map(je=>Le(je,Se))};for(const je of Xe.children)je.parent=Xe;return Xe};function ae(G){const Se=[],Me=new Map;for(const Xe of G.items){Me.set(Xe.item.extId,Xe);const je=d.TestId.root(Xe.item.extId);G.request.targets.some(at=>at.controllerId===je&&at.testIds.includes(Xe.item.extId))&&Se.push(Xe)}return{completedAt:G.completedAt,results:Se.map(Xe=>Le(Xe,Me))}}be.to=ae})(ft||(e.TestResults=ft={}));var Et;(function(be){function Le(Me){return{covered:Me.covered,total:Me.total}}function ae(Me){return"line"in Me?h.from(Me):w.from(Me)}function G(Me){return"branches"in Me?{count:Me.executed,location:ae(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ae(Xe.location),label:Xe.label})):void 0}:{type:0,name:Me.name,count:Me.executed,location:ae(Me.location)}}be.fromDetailed=G;function Se(Me){return{uri:Me.uri,statement:Le(Me.statementCoverage),branch:Me.branchCoverage&&Le(Me.branchCoverage),declaration:Me.declarationCoverage&&Le(Me.declarationCoverage),details:Me.detailedCoverage?.map(G)}}be.fromFile=Se})(Et||(e.TestCoverage=Et={}));var ei;(function(be){function Le(ae){switch(ae){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}be.to=Le})(ei||(e.CodeActionTriggerKind=ei={}));var zt;(function(be){function Le(G){const Se=new o.TypeHierarchyItem(pe.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),w.to(G.range),w.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}be.to=Le;function ae(G,Se,Me){if(Se=Se??G._sessionId,Me=Me??G._itemId,Se===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Me,kind:pe.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:w.from(G.range),selectionRange:w.from(G.selectionRange),tags:G.tags?.map(ee.from)}}be.from=ae})(zt||(e.TypeHierarchyItem=zt={}));var Ut;(function(be){function Le(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Le})(Ut||(e.ViewBadge=Ut={}));var ht;(function(be){function Le(Me,Xe,je){const at=Xe.fileData;return at?new o.InternalFileDataTransferItem(new o.DataTransferFile(at.name,p.URI.revive(at.uri),at.id,(0,O.createSingleCallFunction)(()=>je(at.id)))):Me===R.Mimes.uriList&&Xe.uriListData?new o.InternalDataTransferItem(Se(Xe.uriListData)):new o.InternalDataTransferItem(Xe.asString)}be.to=Le;async function ae(Me,Xe){const je=await Xe.asString();if(Me===R.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:G(je)};const at=Xe.asFile();return{asString:je,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}be.from=ae;function G(Me){return P.UriList.split(Me).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Se(Me){return P.UriList.create(Me.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(ht||(e.DataTransferItem=ht={}));var Tt;(function(be){function Le(G,Se){const Me=G.items.map(([Xe,je])=>[Xe,ht.to(Xe,je,Se)]);return new o.DataTransfer(Me)}be.toDataTransfer=Le;async function ae(G){const Se={items:[]},Me=[];for(const[Xe,je]of G)Me.push((async()=>{Se.items.push([Xe,await ht.from(Xe,je)])})());return await Promise.all(Me),Se}be.from=ae})(Tt||(e.DataTransfer=Tt={}));var ti;(function(be){function Le(G,Se){return{kind:"reply",agentId:G.participant??Se?.agentId??"",subCommand:G.command??Se?.command,message:G.prompt,title:G.label}}be.from=Le;function ae(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}be.to=ae})(ti||(e.ChatFollowup=ti={}));var Yt;(function(be){function Le(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Le})(Yt||(e.ChatInlineFollowup=Yt={}));var qe;(function(be){function Le(G){switch(G.role){case 0:return new o.LanguageModelSystemMessage(G.content);case 1:return new o.LanguageModelUserMessage(G.content);case 2:return new o.LanguageModelAssistantMessage(G.content)}}be.to=Le;function ae(G){if(G instanceof o.LanguageModelSystemMessage)return{role:0,content:G.content};if(G instanceof o.LanguageModelUserMessage)return{role:1,content:G.content};if(G instanceof o.LanguageModelAssistantMessage)return{role:2,content:G.content};throw new Error("Invalid LanguageModelMessage")}be.from=ae})(qe||(e.LanguageModelMessage=qe={}));var Lt;(function(be){function Le(Se){const Me={};for(const Xe of Object.keys(Se))Me[Xe]=Se[Xe].map(be.to);return Me}be.objectTo=Le;function ae(Se){return{level:xt.to(Se.level),kind:Se.kind,value:(0,p.isUriComponents)(Se.value)?p.URI.revive(Se.value):Se.value,description:Se.description}}be.to=ae;function G(Se){return{level:xt.from(Se.level),kind:Se.kind,value:Se.value,description:Se.description}}be.from=G})(Lt||(e.ChatVariable=Lt={}));var xt;(function(be){function Le(G){switch(G){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}be.to=Le;function ae(G){switch(G){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}be.from=ae})(xt||(e.ChatVariableLevel=xt={}));var ni;(function(be){function Le(ae){switch(ae){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Le})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var mt;(function(be){function Le(G){return{kind:"markdownContent",content:N.from(G.value)}}be.to=Le;function ae(G){return new o.ChatResponseMarkdownPart(N.to(G.content))}be.from=ae})(mt||(e.ChatResponseMarkdownPart=mt={}));var Ot;(function(be){function Le(G){const{value:Se,baseUri:Me}=G;function Xe(je,at){return je.map(_t=>{const Ht=p.URI.joinPath(at,_t.name);return{label:_t.name,uri:Ht,children:_t.children&&Xe(_t.children,Ht)}})}return{kind:"treeData",treeData:{label:(0,u.basename)(Me),uri:Me,children:Xe(Se,Me)}}}be.to=Le;function ae(G){const Se=(0,y.revive)(G.treeData);function Me(at){return at.map(_t=>({name:_t.label,children:_t.children&&Me(_t.children)}))}const Xe=Se.uri,je=Se.children?Me(Se.children):[];return new o.ChatResponseFileTreePart(je,Xe)}be.from=ae})(Ot||(e.ChatResponseFilesPart=Ot={}));var kt;(function(be){function Le(G){return{kind:"inlineReference",name:G.title,inlineReference:p.URI.isUri(G.value)?G.value:g.from(G.value)}}be.to=Le;function ae(G){const Se=(0,y.revive)(G);return new o.ChatResponseAnchorPart(p.URI.isUri(Se.inlineReference)?Se.inlineReference:g.to(Se.inlineReference),G.name)}be.from=ae})(kt||(e.ChatResponseAnchorPart=kt={}));var Bt;(function(be){function Le(G){return{kind:"progressMessage",content:N.from(G.value)}}be.to=Le;function ae(G){return new o.ChatResponseProgressPart(G.content.value)}be.from=ae})(Bt||(e.ChatResponseProgressPart=Bt={}));var ri;(function(be){function Le(G,Se,Me){return{kind:"command",command:Se.toInternal(G.value,Me)??{command:G.value.command,title:G.value.title}}}be.to=Le;function ae(G,Se){return new o.ChatResponseCommandButtonPart(Se.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}be.from=ae})(ri||(e.ChatResponseCommandButtonPart=ri={}));var Nt;(function(be){function Le(G){return{kind:"reference",reference:p.URI.isUri(G.value)?G.value:g.from(G.value)}}be.to=Le;function ae(G){const Se=(0,y.revive)(G);return new o.ChatResponseReferencePart(p.URI.isUri(Se.reference)?Se.reference:g.to(Se.reference))}be.from=ae})(Nt||(e.ChatResponseReferencePart=Nt={}));var $t;(function(be){function Le(Se){return Se instanceof o.ChatResponseMarkdownPart?mt.to(Se):Se instanceof o.ChatResponseAnchorPart?kt.to(Se):Se instanceof o.ChatResponseReferencePart?Nt.to(Se):Se instanceof o.ChatResponseProgressPart?Bt.to(Se):Se instanceof o.ChatResponseFileTreePart?Ot.to(Se):{kind:"content",content:""}}be.to=Le;function ae(Se,Me){switch(Se.kind){case"reference":return Nt.from(Se);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(Se,Me)}}be.from=ae;function G(Se,Me){switch(Se.kind){case"markdownContent":return mt.from(Se);case"inlineReference":return kt.from(Se);case"progressMessage":return;case"treeData":return Ot.from(Se);case"command":return ri.from(Se,Me)}}be.fromContent=G})($t||(e.ChatResponsePart=$t={}));var Pt;(function(be){function Le(Se,Me){return"markdownContent"in Me?((0,l.checkProposedApiEnabled)(Se,"chatParticipantAdditions"),{content:N.from(Me.markdownContent),kind:"markdownContent"}):"content"in Me?"vulnerabilities"in Me&&Me.vulnerabilities?((0,l.checkProposedApiEnabled)(Se,"chatParticipantAdditions"),{content:Me.content,vulnerabilities:Me.vulnerabilities,kind:"vulnerability"}):typeof Me.content=="string"?{content:Me.content,kind:"content"}:((0,l.checkProposedApiEnabled)(Se,"chatParticipantAdditions"),{content:N.from(Me.content),kind:"markdownContent"}):"documents"in Me?{documents:Me.documents.map(Xe=>({uri:Xe.uri,version:Xe.version,ranges:Xe.ranges.map(je=>w.from(je))})),kind:"usedContext"}:"reference"in Me?{reference:"uri"in Me.reference?{uri:Me.reference.uri,range:w.from(Me.reference.range)}:Me.reference,kind:"reference"}:"inlineReference"in Me?{inlineReference:"uri"in Me.inlineReference?{uri:Me.inlineReference.uri,range:w.from(Me.inlineReference.range)}:Me.inlineReference,name:Me.title,kind:"inlineReference"}:"participant"in Me?((0,l.checkProposedApiEnabled)(Se,"chatParticipantAdditions"),{agentName:Me.participant,command:Me.command,kind:"agentDetection"}):"message"in Me?{content:N.from(Me.message),kind:"progressMessage"}:void 0}be.from=Le;function ae(Se){switch(Se.kind){case"markdownContent":case"inlineReference":case"treeData":return be.to(Se);case"content":return{content:Se.content};case"usedContext":return{documents:Se.documents.map(Me=>({uri:p.URI.revive(Me.uri),version:Me.version,ranges:Me.ranges.map(Xe=>w.to(Xe))}))};case"reference":return{reference:(0,p.isUriComponents)(Se.reference)?p.URI.revive(Se.reference):g.to(Se.reference)};case"agentDetection":return;case"progressMessage":return{message:Se.content.value};case"vulnerability":return{content:Se.content,vulnerabilities:Se.vulnerabilities};default:return}}be.to=ae;function G(Se,Me){switch(Se.kind){case"markdownContent":return{content:Se.content.value};case"inlineReference":return{inlineReference:(0,p.isUriComponents)(Se.inlineReference)?p.URI.revive(Se.inlineReference):g.to(Se.inlineReference),title:Se.name};case"command":return{command:Me.fromInternal(Se.command)??{command:Se.command.id,title:Se.command.title}};default:return}}be.toProgressContent=G})(Pt||(e.ChatResponseProgress=Pt={}));var Ct;(function(be){function Le(ae){return{prompt:ae.message,command:ae.command,variables:ae.variables.variables.map(pt.to)}}be.to=Le})(Ct||(e.ChatAgentRequest=Ct={}));var pt;(function(be){function Le(ae){return{name:ae.name,range:[ae.range.start,ae.range.endExclusive],values:ae.values.map(Lt.to)}}be.to=Le})(pt||(e.ChatAgentResolvedVariable=pt={}));var It;(function(be){function Le(ae){return{label:ae.label,values:ae.values.map(Lt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Le})(It||(e.ChatAgentCompletionItem=It={}));var wt;(function(be){function Le(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}be.to=Le})(wt||(e.ChatAgentResult=wt={}));var ui;(function(be){function Le(ae,G,Se){if(G.action.kind==="vote")return;const Me=wt.to(ae);return G.action.kind==="command"?{action:{kind:"command",commandButton:Pt.toProgressContent(G.action.commandButton,Se)},result:Me}:G.action.kind==="followUp"?{action:{kind:"followUp",followup:ti.to(G.action.followup)},result:Me}:{action:G.action,result:Me}}be.to=Le})(ui||(e.ChatAgentUserActionEvent=ui={}));var Kt;(function(be){function Le(ae,G,Se){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:G.toInternal(ae,Se)}be.from=Le})(Kt||(e.TerminalQuickFix=Kt={}));var pi;(function(be){function Le(ae,G){return{id:G,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}be.from=Le})(pi||(e.DebugTreeItem=pi={}))}),define(Te[247],Ae([1,0,3,17,8]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let O=class{constructor(m,f){this._proxy=m.getProxy(I.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:y=>f.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,y){const R=P.WorkspaceEdit.from(m,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.ExtHostBulkEdits=O,e.ExtHostBulkEdits=O=Ge([Ve(0,L.IExtHostRpcService)],O)}),define(Te[248],Ae([1,0,18,11,34,5,51,6,64,16,2,158,20,3,8,7,207,23]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class n{constructor(i,v,l,o,S,w){this._extension=i,this._request=v,this._proxy=l,this._logService=o,this._commandsConverter=S,this._sessionDisposables=w,this._stopWatch=f.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let v=function(o){if(i._isClosed){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,o),S}};const i=this;this._stopWatch.reset();const l=o=>{typeof this._firstProgress>"u"&&"content"in o&&(this._firstProgress=this._stopWatch.elapsed()),this._proxy.$handleProgressChunk(this._request.requestId,o)};this._apiObject={markdown(o){v(this.markdown);const S=new s.ChatResponseMarkdownPart(o),w=p.ChatResponseMarkdownPart.to(S);return l(w),this},filetree(o,S){v(this.filetree);const w=new s.ChatResponseFileTreePart(o,S),g=p.ChatResponseFilesPart.to(w);return l(g),this},anchor(o,S){v(this.anchor);const w=new s.ChatResponseAnchorPart(o,S),g=p.ChatResponseAnchorPart.to(w);return l(g),this},button(o){v(this.anchor);const S=new s.ChatResponseCommandButtonPart(o),w=p.ChatResponseCommandButtonPart.to(S,i._commandsConverter,i._sessionDisposables);return l(w),this},progress(o){v(this.progress);const S=new s.ChatResponseProgressPart(o),w=p.ChatResponseProgressPart.to(S);return l(w),this},reference(o){v(this.reference);const S=new s.ChatResponseReferencePart(o),w=p.ChatResponseReferencePart.to(S);return l(w),this},push(o){v(this.push);const S=p.ChatResponsePart.to(o);return l(S),this},report(o){if(v(this.report),"placeholder"in o&&"resolvedContent"in o)return;const S=p.ChatResponseProgress.from(i._extension,o);if(!S){i._logService.error("Unknown progress type: "+JSON.stringify(o));return}return l(S),this}}}return this._apiObject}}class r{static{this._idPool=0}constructor(i,v,l){this._logService=v,this.commands=l,this._agents=new Map,this._sessionDisposables=new m.DisposableMap,this._proxy=i.getProxy(E.MainContext.MainThreadChatAgents2)}createChatAgent(i,v,l){const o=r._idPool++,S=new a(i,v,this._proxy,o,l);return this._agents.set(o,S),this._proxy.$registerAgent(o,i.identifier,v,{}),S.apiAgent}async $invokeAgent(i,v,l,o){const S=this._agents.get(i);if(!S)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let w=this._sessionDisposables.get(v.sessionId);w||(w=new m.DisposableStore,this._sessionDisposables.set(v.sessionId,w));const g=new n(S.extension,v,this._proxy,this._logService,this.commands.converter,w);try{const D=await this.prepareHistoryTurns(v.agentId,l),h=S.invoke(p.ChatAgentRequest.to(v),{history:D},g.apiObject,o);return await(0,L.raceCancellation)(Promise.resolve(h).then(_=>{if(_?.metadata)try{JSON.stringify(_.metadata)}catch(b){const A=`result.metadata MUST be JSON.stringify-able. Got error: ${b.message}`;return this._logService.error(`[${S.extension.identifier.value}] [@${S.id}] ${A}`,S.extension),{errorDetails:{message:A},timings:g.timings}}return{errorDetails:_?.errorDetails,timings:g.timings,metadata:_?.metadata}}),o)}catch(D){return this._logService.error(D,S.extension),{errorDetails:{message:(0,C.localize)(0,null,(0,P.toErrorMessage)(D)),responseIsIncomplete:!0}}}finally{g.close()}}async prepareHistoryTurns(i,v){const l=[];for(const o of v.history){const S=p.ChatAgentResult.to(o.result),w=i===o.request.agentId?S:{...S,metadata:void 0};l.push(new s.ChatRequestTurn(o.request.message,o.request.command,o.request.variables.variables.map(p.ChatAgentResolvedVariable.to),{extensionId:"",name:o.request.agentId}));const g=(0,I.coalesce)(o.response.map(D=>p.ChatResponsePart.fromContent(D,this.commands.converter)));l.push(new s.ChatResponseTurn(g,w,{extensionId:"",name:o.request.agentId},o.request.command))}return l}$releaseSession(i){this._sessionDisposables.deleteAndDispose(i)}async $provideSlashCommands(i,v,l){const o=this._agents.get(i);if(!o)return[];const S=await this.prepareHistoryTurns(o.id,v);try{return await o.provideSlashCommands({history:S},l)}catch(w){const g=(0,P.toErrorMessage)(w);return this._logService.error(`[${o.extension.identifier.value}] [@${o.id}] Error while providing slash commands: ${g}`),[]}}async $provideFollowups(i,v,l,o){const S=this._agents.get(v);if(!S)return Promise.resolve([]);const w=p.ChatAgentResult.to(l);return(await S.provideFollowups(w,o)).filter(g=>{const D=!g.participant||T.Iterable.some(this._agents.values(),h=>h.id===g.participant&&u.ExtensionIdentifier.equals(h.extension.identifier,S.extension.identifier));return D||this._logService.warn(`[@${S.id}] ChatFollowup refers to an invalid participant: ${g.participant}`),D}).map(g=>p.ChatFollowup.from(g,i))}$acceptFeedback(i,v,l,o){const S=this._agents.get(i);if(!S)return;const w=p.ChatAgentResult.to(v);let g;switch(l){case c.InteractiveSessionVoteDirection.Down:g=s.ChatResultFeedbackKind.Unhelpful;break;case c.InteractiveSessionVoteDirection.Up:g=s.ChatResultFeedbackKind.Helpful;break}S.acceptFeedback(Object.freeze(o?{result:w,kind:g,reportIssue:o}:{result:w,kind:g}))}$acceptAction(i,v,l){const o=this._agents.get(i);if(!o||l.action.kind==="vote")return;const S=p.ChatAgentUserActionEvent.to(v,l,this.commands.converter);S&&o.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(i,v,l){const o=this._agents.get(i);return o?(await o.invokeCompletionProvider(v,l)).map(p.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(i,v){const l=this._agents.get(i);if(l)return await l.provideWelcomeMessage(v)}async $provideSampleQuestions(i,v){const l=this._agents.get(i);if(l)return(await l.provideSampleQuestions(v)).map(o=>p.ChatFollowup.from(o,void 0))}}e.ExtHostChatAgents2=r;class a{constructor(i,v,l,o,S){this.extension=i,this.id=v,this._proxy=l,this._handle=o,this._requestHandler=S,this._onDidReceiveFeedback=new O.Emitter,this._onDidPerformAction=new O.Emitter}acceptFeedback(i){this._onDidReceiveFeedback.fire(i)}acceptAction(i){this._onDidPerformAction.fire(i)}async invokeCompletionProvider(i,v){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(i,v)??[]:[]}async provideSlashCommands(i,v){if(!this._commandProvider)return[];const l=await this._commandProvider.provideCommands(i,v);return l?l.map(o=>("isSticky2"in o&&(0,t.checkProposedApiEnabled)(this.extension,"chatParticipantAdditions"),{name:o.name,description:o.description??"",followupPlaceholder:o.isSticky2?.placeholder,isSticky:o.isSticky2?.isSticky??o.isSticky,sampleRequest:o.sampleRequest})):[]}async provideFollowups(i,v){if(!this._followupProvider)return[];const l=await this._followupProvider.provideFollowups(i,v);return l?l.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(i){if(!this._welcomeMessageProvider)return[];const v=await this._welcomeMessageProvider.provideWelcomeMessage(i);return v?v.map(l=>typeof l=="string"?l:p.MarkdownString.from(l)):[]}async provideSampleQuestions(i){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const v=await this._welcomeMessageProvider.provideSampleQuestions(i);return v||[]}get apiAgent(){let i=!1,v=!1;const l=()=>{i||v||(v=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof R.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof s.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._commandProvider!==void 0,hasFollowups:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:p.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:p.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:p.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting,isSticky:this._isSticky}),v=!1}))},o=this;return{get name(){return o.id},get description(){return o._description??""},set description(S){o._description=S,l()},get fullName(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._fullName??o.extension.displayName??o.extension.name},set fullName(S){(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._fullName=S,l()},get iconPath(){return o._iconPath},set iconPath(S){o._iconPath=S,l()},get requestHandler(){return o._requestHandler},set requestHandler(S){(0,y.assertType)(typeof S=="function","Invalid request handler"),o._requestHandler=S},get commandProvider(){return o._commandProvider},set commandProvider(S){o._commandProvider=S,l()},get followupProvider(){return o._followupProvider},set followupProvider(S){o._followupProvider=S,l()},get isDefault(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._isDefault},set isDefault(S){(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._isDefault=S,l()},get helpTextPrefix(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._helpTextPrefix},set helpTextPrefix(S){if((0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),!o._isDefault)throw new Error("helpTextPrefix is only available on the default chat agent");o._helpTextPrefix=S,l()},get helpTextVariablesPrefix(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._helpTextVariablesPrefix},set helpTextVariablesPrefix(S){if((0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),!o._isDefault)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");o._helpTextVariablesPrefix=S,l()},get helpTextPostfix(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._helpTextPostfix},set helpTextPostfix(S){if((0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),!o._isDefault)throw new Error("helpTextPostfix is only available on the default chat agent");o._helpTextPostfix=S,l()},get isSecondary(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._isSecondary},set isSecondary(S){(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._isSecondary=S,l()},get sampleRequest(){return o._sampleRequest},set sampleRequest(S){o._sampleRequest=S,l()},get supportIssueReporting(){return(0,t.checkProposedApiEnabled)(o.extension,"chatParticipantAdditions"),o._supportIssueReporting},set supportIssueReporting(S){(0,t.checkProposedApiEnabled)(o.extension,"chatParticipantAdditions"),o._supportIssueReporting=S,l()},get onDidReceiveFeedback(){return o._onDidReceiveFeedback.event},set participantVariableProvider(S){if((0,t.checkProposedApiEnabled)(o.extension,"chatParticipantAdditions"),o._agentVariableProvider=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");o._proxy.$registerAgentCompletionsProvider(o._handle,S.triggerCharacters)}else o._proxy.$unregisterAgentCompletionsProvider(o._handle)},get participantVariableProvider(){return(0,t.checkProposedApiEnabled)(o.extension,"chatParticipantAdditions"),o._agentVariableProvider},set welcomeMessageProvider(S){(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._welcomeMessageProvider=S,l()},get welcomeMessageProvider(){return(0,t.checkProposedApiEnabled)(o.extension,"defaultChatParticipant"),o._welcomeMessageProvider},onDidPerformAction:(0,t.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,get isSticky(){return o._isSticky},set isSticky(S){o._isSticky=S,l()},dispose(){i=!0,o._commandProvider=void 0,o._followupProvider=void 0,o._onDidReceiveFeedback.dispose(),o._proxy.$unregisterAgent(o._handle)}}}invoke(i,v,l,o){return this._requestHandler(i,v,l,o)}}}),define(Te[249],Ae([1,0,22,6,3,8,99,20,11,5,159,104,34]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class E{constructor(t,n){this.option=t,this.stream=new f.AsyncIterableSource,this.stream=n??new f.AsyncIterableSource}}class p{constructor(t,n){this.cts=n,this._responseStreams=new Map,this._defaultStream=new f.AsyncIterableSource,this._isDone=!1;const r=this;this.apiObject={result:t,stream:r._defaultStream.asyncIterable},t.then(()=>{for(const a of this._streams())a.resolve()}).catch(a=>{a instanceof Error||(a=new Error((0,u.toErrorMessage)(a),{cause:a}));for(const d of this._streams())d.reject(a)}).finally(()=>{this._isDone=!0})}*_streams(){if(this._responseStreams.size>0)for(const[,t]of this._responseStreams)yield t.stream;else yield this._defaultStream}handleFragment(t){if(this._isDone)return;let n=this._responseStreams.get(t.index);n||(this._responseStreams.size===0?n=new E(t.index,this._defaultStream):n=new E(t.index),this._responseStreams.set(t.index,n)),n.stream.emitOne(t.part)}}class s{static{this._idPool=1}constructor(t,n,r){this._logService=n,this._extHostAuthentication=r,this._onDidChangeModelAccess=new y.Emitter,this._onDidChangeProviders=new y.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._languageModelIds=new Set,this._modelAccessList=new m.ExtensionIdentifierMap,this._pendingRequest=new Map,this._proxy=t.getProxy(P.MainContext.MainThreadChatProvider)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(t,n,r,a){const d=s._idPool++;this._languageModels.set(d,{extension:t.identifier,provider:r});let i;return a.auth&&(i={providerLabel:t.displayName||t.name,accountLabel:typeof a.auth=="object"?a.auth.label:void 0}),this._proxy.$registerProvider(d,n,{extension:t.identifier,model:a.name??"",auth:i}),(0,L.toDisposable)(()=>{this._languageModels.delete(d),this._proxy.$unregisterProvider(d)})}async $provideLanguageModelResponse(t,n,r,a,d,i){const v=this._languageModels.get(t);if(!v)return;const l=new T.Progress(async o=>{if(i.isCancellationRequested){this._logService.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(n,{index:o.index,part:o.part})});return v.provider.provideLanguageModelResponse2(a.map(O.LanguageModelMessage.to),d,m.ExtensionIdentifier.toKey(r),l,i)}$updateLanguageModels(t){const n=[],r=[];if(t.added)for(const a of t.added)this._languageModelIds.add(a),n.push(a);if(t.removed)for(const a of t.removed){this._languageModelIds.delete(a),r.push(a);for(const[d,i]of this._pendingRequest)i.languageModelId===a&&(i.res.cts.cancel(),this._pendingRequest.delete(d))}this._onDidChangeProviders.fire(Object.freeze({added:Object.freeze(n),removed:Object.freeze(r)}))}getLanguageModelIds(){return Array.from(this._languageModelIds)}$updateModelAccesslist(t){const n=new Array;for(const{from:r,to:a,enabled:d}of t){const i=this._modelAccessList.get(r)??new m.ExtensionIdentifierSet;if(i.has(a)!==d){d?i.add(a):i.delete(a),this._modelAccessList.set(r,i);const l={from:r,to:a};n.push(l),this._onDidChangeModelAccess.fire(l)}}}async requestLanguageModelAccess(t,n,r){const a=t.identifier,d=r?.justification,i=await this._proxy.$prepareChatAccess(a,n,d);if(!i)throw new Error(`Language model '${n}' NOT found`);this._isUsingAuth(a,i)&&await this._getAuthAccess(t,{identifier:i.extension,displayName:i.auth.providerLabel},d);const v=this;return{get model(){return i.model},get isRevoked(){return v._isUsingAuth(a,i)&&!v._modelAccessList.get(a)?.has(i.extension)||!v._languageModelIds.has(n)},get onDidChangeAccess(){const l=y.Event.filter(v._onDidChangeProviders.event,S=>S.removed.includes(n)),o=y.Event.filter(v._onDidChangeModelAccess.event,S=>m.ExtensionIdentifier.equals(S.from,a)&&m.ExtensionIdentifier.equals(S.to,i.extension));return y.Event.signal(y.Event.any(l,o))},makeChatRequest(l,o,S){if(v._isUsingAuth(a,i)&&!v._modelAccessList.get(a)?.has(i.extension))throw new Error("Access to chat has been revoked");if(!v._languageModelIds.has(n))throw new Error("Language Model has been removed");const w=new I.CancellationTokenSource(S),g=Math.random()*1e6|0,D=v._proxy.$fetchResponse(a,n,g,l.map(O.LanguageModelMessage.from),o??{},w.token),h=new p(D,w);return v._pendingRequest.set(g,{languageModelId:n,res:h}),D.finally(()=>{v._pendingRequest.delete(g),w.dispose()}),h.apiObject}}}async $handleResponseFragment(t,n){const r=this._pendingRequest.get(t);r&&r.res.handleFragment(n)}async _getAuthAccess(t,n,r){const a=C.INTERNAL_AUTH_PROVIDER_PREFIX+n.identifier.value;if(!await this._extHostAuthentication.getSession(t,a,[],{silent:!0}))try{const i=r?(0,R.localize)(0,null,n.displayName,r):(0,R.localize)(1,null,n.displayName);await this._extHostAuthentication.getSession(t,a,[],{forceNewSession:{detail:i}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:t.identifier,to:n.identifier,enabled:!0}])}_isUsingAuth(t,n){return!!n.auth&&!m.ExtensionIdentifier.equals(n.extension,t)}}e.ExtHostChatProvider=s}),define(Te[250],Ae([1,0,15,6,3,8,7,23]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class f{static{this._idPool=0}constructor(C){this._resolver=new Map,this._proxy=C.getProxy(P.MainContext.MainThreadChatVariables)}async $resolveVariable(C,u,E,p){const s=this._resolver.get(C);if(s)try{if(s.resolver.resolve2){(0,m.checkProposedApiEnabled)(s.extension,"chatParticipantAdditions");const c=new y(u,this._proxy),t=await s.resolver.resolve2(s.data.name,{prompt:E},c.apiObject,p);if(t)return t.map(O.ChatVariable.from)}else{const c=await s.resolver.resolve(s.data.name,{prompt:E},p);if(c)return c.map(O.ChatVariable.from)}}catch(c){(0,I.onUnexpectedExternalError)(c)}}registerVariableResolver(C,u,E,p){const s=f._idPool++;return this._resolver.set(s,{extension:C,data:{name:u,description:E},resolver:p}),this._proxy.$registerVariable(s,{name:u,description:E}),(0,L.toDisposable)(()=>{this._resolver.delete(s),this._proxy.$unregisterVariable(s)})}}e.ExtHostChatVariables=f;class y{constructor(C,u){this._requestId=C,this._proxy=u,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let u=function(p){if(C._isClosed){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,p),s}};const C=this,E=p=>{this._proxy.$handleProgressChunk(this._requestId,p)};this._apiObject={progress(p){u(this.progress);const s=new T.ChatResponseProgressPart(p),c=O.ChatResponseProgressPart.to(s);return E(c),this},reference(p){u(this.reference);const s=new T.ChatResponseReferencePart(p),c=O.ChatResponseReferencePart.to(s);return E(c),this},push(p){u(this.push);const s=O.ChatResponsePart.to(p);return E(s),this}}}return this._apiObject}}}),define(Te[251],Ae([1,0,11,68,5,6,2,86,20,8,7,3,23]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(p,s,c){const t=p.getProxy(C.MainContext.MainThreadComments);class n{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new f.ExtensionIdentifierMap,s.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const g=this._commentControllers.get(w.handle);return g?g.value:w}else if(w&&w.$mid===7){const g=this._commentControllers.get(w.commentControlHandle);if(!g)return w;const D=g.getCommentThread(w.commentThreadHandle);return D?D.value:w}else if(w&&(w.$mid===9||w.$mid===8)){const g=this._commentControllers.get(w.thread.commentControlHandle);if(!g)return w;const D=g.getCommentThread(w.thread.commentThreadHandle);return D?w.$mid===8?D.value:{thread:D.value,text:w.text}:w}else if(w&&w.$mid===10){const g=this._commentControllers.get(w.thread.commentControlHandle);if(!g)return w;const D=g.getCommentThread(w.thread.commentThreadHandle);if(!D)return w;const h=w.commentUniqueId,_=D.getCommentByUniqueId(h);return _||w}else if(w&&w.$mid===11){const g=this._commentControllers.get(w.thread.commentControlHandle);if(!g)return w;const D=g.getCommentThread(w.thread.commentThreadHandle);if(!D)return w;const h=w.text,_=w.commentUniqueId,b=D.getCommentByUniqueId(_);return b?(typeof b.body=="string"?b.body=h:b.body=new R.MarkdownString(h),b):w}return w}})}createCommentController(w,g,D){const h=n.handlePool++,_=new a(w,h,g,D);this._commentControllers.set(_.handle,_);const b=this._commentControllersByExtension.get(w.identifier)||[];return b.push(_),this._commentControllersByExtension.set(w.identifier,b),_.value}async $createCommentThreadTemplate(w,g,D){const h=this._commentControllers.get(w);h&&h.$createCommentThreadTemplate(g,D)}async $setActiveComment(w,g){const D=this._commentControllers.get(w);D&&D.$setActiveComment(g??void 0)}async $updateCommentThreadTemplate(w,g,D){const h=this._commentControllers.get(w);h&&h.$updateCommentThreadTemplate(g,D)}$deleteCommentThread(w,g){this._commentControllers.get(w)?.$deleteCommentThread(g)}$provideCommentingRanges(w,g,D){const h=this._commentControllers.get(w);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const _=c.getDocument(T.URI.revive(g));return(0,I.asPromise)(async()=>{const b=await h.commentingRangeProvider.provideCommentingRanges(_,D);let A;return Array.isArray(b)?A={ranges:b,fileComments:!1}:b?A={ranges:b.ranges||[],fileComments:b.fileComments||!1}:A=b??void 0,A}).then(b=>{let A;return b&&(A={ranges:b.ranges.map(F=>y.Range.from(F)),fileComments:b.fileComments}),A})}$toggleReaction(w,g,D,h,_){const b=this._commentControllers.get(w);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,I.asPromise)(()=>{const A=b.getCommentThread(g);if(A){const F=A.getCommentByUniqueId(h.uniqueIdInThread);if(b!==void 0&&F&&b.reactionHandler)return b.reactionHandler(F,v(_))}return Promise.resolve(void 0)})}}class r{static{this._handlePool=0}set threadId(w){this._id=w}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(w){(w===void 0!=(this._range===void 0)||!w||!this._range||!w.isEqual(this._range))&&(this._range=w,this.modifications.range=w,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(w){this._canReply!==w&&(this._canReply=w,this.modifications.canReply=w,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(w){this._label=w,this.modifications.label=w,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(w){this._contextValue=w,this.modifications.contextValue=w,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(w){this._comments=w,this.modifications.comments=w,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(w){this._collapseState=w,this.modifications.collapsibleState=w,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(w){this._state=w,this.modifications.state=w,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(w,g,D,h,_,b,A,F){this._commentControllerHandle=g,this._id=D,this._uri=h,this._range=_,this._comments=b,this.extensionDescription=A,this._isTemplate=F,this.handle=r._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputDisposables.value=new O.DisposableStore,this._id===void 0&&(this._id=`${w}.${this.handle}`),t.$createCommentThread(g,this.handle,this._id,this._uri,y.Range.from(this._range),A.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{t.$deleteCommentThread(g,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(H){j.range=H},get comments(){return j.comments},set comments(H){j.comments=H},get collapsibleState(){return j.collapsibleState},set collapsibleState(H){j.collapsibleState=H},get canReply(){return j.canReply},set canReply(H){j.canReply=H},get contextValue(){return j.contextValue},set contextValue(H){j.contextValue=H},get label(){return j.label},set label(H){j.label=H},get state(){return j.state},set state(H){j.state=H},dispose:()=>{j.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new O.DisposableStore);const w=D=>Object.prototype.hasOwnProperty.call(this.modifications,D),g={};w("range")&&(g.range=y.Range.from(this._range)),w("label")&&(g.label=this.label),w("contextValue")&&(g.contextValue=this.contextValue??null),w("comments")&&(g.comments=this._comments.map(D=>d(this,D,this._commentsMap,this.extensionDescription))),w("collapsibleState")&&(g.collapseState=l(this._collapseState)),w("canReply")&&(g.canReply=this.canReply),w("state")&&(g.state=o(this._state)),w("isTemplate")&&(g.isTemplate=this._isTemplate),this.modifications={},t.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(w){for(const g of this._commentsMap){const D=g[0],h=g[1];if(w===h)return D}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(w=>w.dispose())}}Ge([(0,L.debounce)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(w){this._commentingRangeProvider=w,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(w){this._reactionHandler=w,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this._options}set options(w){this._options=w,t.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,u.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,u.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(w,g,D,h){this._extension=w,this._handle=g,this._id=D,this._label=h,this._threads=new Map,t.$registerCommentController(this.handle,D,h,this._extension.identifier.value);const _=this;this.value=Object.freeze({id:_.id,label:_.label,get options(){return _.options},set options(b){_.options=b},get commentingRangeProvider(){return _.commentingRangeProvider},set commentingRangeProvider(b){_.commentingRangeProvider=b},get reactionHandler(){return _.reactionHandler},set reactionHandler(b){_.reactionHandler=b},get activeCommentThread(){return _.activeCommentThread},createCommentThread(b,A,F){return _.createCommentThread(b,A,F).value},dispose:()=>{_.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(w,g,D){g===void 0&&(0,u.checkProposedApiEnabled)(this._extension,"fileComments");const h=new r(this.id,this.handle,void 0,w,g,D,this._extension,!1);return this._threads.set(h.handle,h),h}$setActiveComment(w){if(!w){this._activeComment=void 0,this._activeThread=void 0;return}const g=this._threads.get(w.commentThreadHandle);g&&(this._activeComment=w.uniqueIdInThread?g.getCommentByUniqueId(w.uniqueIdInThread):void 0,this._activeThread=g)}$createCommentThreadTemplate(w,g){const D=new r(this.id,this.handle,void 0,T.URI.revive(w),y.Range.to(g),[],this._extension,!0);return D.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this._threads.set(D.handle,D),D}$updateCommentThreadTemplate(w,g){const D=this._threads.get(w);D&&(D.range=y.Range.to(g))}$deleteCommentThread(w){this._threads.get(w)?.dispose(),this._threads.delete(w)}getCommentThread(w){return this._threads.get(w)}dispose(){this._threads.forEach(w=>{w.dispose()}),this._localDisposables.forEach(w=>w.dispose())}}function d(S,w,g,D){let h=g.get(w);return h||(h=++S.commentHandle,g.set(w,h)),w.state!==void 0&&(0,u.checkProposedApiEnabled)(D,"commentsDraftState"),w.reactions?.some(_=>_.reactors!==void 0)&&(0,u.checkProposedApiEnabled)(D,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:h,body:typeof w.body=="string"?w.body:y.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(_=>i(_)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function i(S){return{label:S.label,iconPath:S.iconPath?y.pathOrURIToURI(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(w=>w.name):S.reactors}}function v(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?T.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(w=>({name:w}))}}function l(S){if(S!==void 0)switch(S){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function o(S){if(S!==void 0)switch(S){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.createExtHostComments=E}),define(Te[252],Ae([1,0,22,97,6,12,25,2,8,62,74,3,7]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(v,l){this.document=v,this._storagePath=l,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(v){return this._edits.add([v])}async undo(v,l){await this.getEdit(v).undo(),l||this.disposeBackup()}async redo(v,l){await this.getEdit(v).redo(),l||this.disposeBackup()}disposeEdits(v){for(const l of v)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const v=d(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,v)}updateBackup(v){this._backup?.delete(),this._backup=v}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(v){const l=this._edits.get(v,0);if(!l)throw new Error("No edit found");return l}}class p{constructor(){this._documents=new Map}get(v,l){return this._documents.get(this.key(v,l))}add(v,l,o){const S=this.key(v,l.uri);if(this._documents.has(S))throw new Error(`Document already exists for viewType:${v} resource:${l.uri}`);const w=new E(l,o);return this._documents.set(S,w),w}delete(v,l){const o=this.key(v,l.uri);this._documents.delete(o)}key(v,l){return`${v}@@@${l}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class c{constructor(){this._providers=new Map}addTextProvider(v,l,o){return this.add(0,v,l,o)}addCustomProvider(v,l,o){return this.add(1,v,l,o)}get(v){return this._providers.get(v)}add(v,l,o,S){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:v,extension:o,provider:S}),new u.Disposable(()=>this._providers.delete(l))}}class t{constructor(v,l,o,S,w){this._extHostDocuments=l,this._extensionStoragePaths=o,this._extHostWebview=S,this._extHostWebviewPanels=w,this._editorProviders=new c,this._documents=new p,this._proxy=v.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(v,l,o,S){const w=new P.DisposableStore;return r(o)?(w.add(this._editorProviders.addTextProvider(l,v,o)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(v),l,S.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(v))):(w.add(this._editorProviders.addCustomProvider(l,v,o)),n(o)&&w.add(o.onDidChangeCustomDocument(g=>{const D=this.getCustomDocumentEntry(l,g.document.uri);if(a(g)){const h=D.addEdit(g);this._proxy.$onDidEdit(g.document.uri,l,h,g.label)}else this._proxy.$onContentChange(g.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(v),l,S.webviewOptions||{},!!S.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(v))),u.Disposable.from(w,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(v,l,o,S,w){const g=this._editorProviders.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${l}'`);const D=m.URI.revive(v),h=await g.provider.openCustomDocument(D,{backupId:o,untitledDocumentData:S?.buffer},w);let _;return n(g.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(l,h,_),{editable:n(g.provider)}}async $disposeCustomDocument(v,l){const o=this._editorProviders.get(l);if(!o)throw new Error(`No provider found for '${l}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${l}'`);const S=m.URI.revive(v),{document:w}=this.getCustomDocumentEntry(l,S);this._documents.delete(l,w),w.dispose()}async $resolveCustomEditor(v,l,o,S,w,g){const D=this._editorProviders.get(o);if(!D)throw new Error(`No provider found for '${o}'`);const h=f.ViewColumn.to(w),_=this._extHostWebview.createNewWebview(l,S.contentOptions,D.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(l,o,S.title,h,S.options,_,S.active),A=m.URI.revive(v);switch(D.type){case 1:{const{document:F}=this.getCustomDocumentEntry(o,A);return D.provider.resolveCustomEditor(F,b,g)}case 0:{const F=this._extHostDocuments.getDocument(A);return D.provider.resolveCustomTextEditor(F,b,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,l,o){this.getCustomDocumentEntry(l,v).disposeEdits(o)}async $onMoveCustomEditor(v,l,o){const S=this._editorProviders.get(o);if(!S)throw new Error(`No provider found for '${o}'`);if(!S.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const w=this._extHostWebviewPanels.getWebviewPanel(v);if(!w)throw new Error("No webview found");const g=m.URI.revive(l),D=this._extHostDocuments.getDocument(g);await S.provider.moveCustomTextEditor(D,w,I.CancellationToken.None)}async $undo(v,l,o,S){return this.getCustomDocumentEntry(l,v).undo(o,S)}async $redo(v,l,o,S){return this.getCustomDocumentEntry(l,v).redo(o,S)}async $revert(v,l,o){const S=this.getCustomDocumentEntry(l,v);await this.getCustomEditorProvider(l).revertCustomDocument(S.document,o),S.disposeBackup()}async $onSave(v,l,o){const S=this.getCustomDocumentEntry(l,v);await this.getCustomEditorProvider(l).saveCustomDocument(S.document,o),S.disposeBackup()}async $onSaveAs(v,l,o,S){const w=this.getCustomDocumentEntry(l,v);return this.getCustomEditorProvider(l).saveCustomDocumentAs(w.document,m.URI.revive(o),S)}async $backup(v,l,o){const S=this.getCustomDocumentEntry(l,v),g=await this.getCustomEditorProvider(l).backupCustomDocument(S.document,{destination:S.getNewBackupUri()},o);return S.updateBackup(g),g.id}getCustomDocumentEntry(v,l){const o=this._documents.get(v,m.URI.revive(l));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(v){const o=this._editorProviders.get(v)?.provider;if(!o||!n(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=t;function n(i){return!!i.onDidChangeCustomDocument}function r(i){return typeof i.resolveCustomTextEditor=="function"}function a(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function d(i){const v=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,L.hash)(v)+""}}),define(Te[253],Ae([1,0,160,98,2,3,7,8,5,14,28,43]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class E{#e;#t;#i;constructor(c,t,n,r,a,d,i,v){this._name=c,this._owner=t,this._maxDiagnosticsTotal=n,this._maxDiagnosticsPerFile=r,this._modelVersionIdProvider=a,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(r,n),this.#i=new R.ResourceMap(l=>d.getComparisonKey(l)),this.#e=i,this.#t=v}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,t){if(!c){this.clear();return}this._checkDisposed();let n=[];if(P.URI.isUri(c)){if(!t){this.delete(c);return}this.#i.set(c,t.slice()),n=[c]}else if(Array.isArray(c)){n=[];let d;c=[...c].sort(E._compareIndexedTuplesByUri);for(const i of c){const[v,l]=i;if((!d||v.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=v,n.push(v),this.#i.set(v,[])),l)this.#i.get(v)?.push(...l);else{const o=this.#i.get(v);o&&(o.length=0)}}}if(this.#t.fire(n),!this.#e)return;const r=[];let a=0;for(const d of n){let i=[];const v=this.#i.get(d);if(v)if(v.length>this._maxDiagnosticsPerFile){i=[];const l=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const S of v)if(S.severity===l[o]&&i.push({...m.Diagnostic.from(S),modelVersionId:this._modelVersionIdProvider(d)})===this._maxDiagnosticsPerFile)break e;i.push({severity:L.MarkerSeverity.Info,message:(0,I.localize)(0,null,v.length-this._maxDiagnosticsPerFile),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=v.map(l=>({...m.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(d)}));if(r.push([d,i]),a+=i.length,a>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,r)}delete(c){this._checkDisposed(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(c,t){this._checkDisposed();for(const[n,r]of this)c.call(t,n,r,this)}*[Symbol.iterator](){this._checkDisposed();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this._checkDisposed();const t=this.#i.get(c);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this.#i.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,t){return c[0].toString()<t[0].toString()?-1:c[0].toString()>t[0].toString()?1:0}}e.DiagnosticCollection=E;let p=class{static{u=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*u._maxDiagnosticsPerFile}static _mapper(c){const t=new R.ResourceMap;for(const n of c)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(c,t,n,r){this._logService=t,this._fileSystemInfoService=n,this._extHostDocumentsAndEditors=r,this._collections=new Map,this._onDidChangeDiagnostics=new f.DebounceEmitter({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this._onDidChangeDiagnostics.event,u._mapper),this._proxy=c.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(c,t){const{_collections:n,_proxy:r,_onDidChangeDiagnostics:a,_logService:d,_fileSystemInfoService:i,_extHostDocumentsAndEditors:v}=this,l=new class{$changeMany(w,g){r.$changeMany(w,g),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,w,g.length===0?"CLEARING":g)}$clear(w){r.$clear(w),d.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,w)}dispose(){r.dispose()}};let o;if(!t)t="_generated_diagnostic_collection_name_#"+u._idPool++,o=t;else if(!n.has(t))o=t;else{this._logService.warn(`DiagnosticCollection with name '${t}' does already exist.`);do o=t+u._idPool++;while(n.has(o))}return new class extends E{constructor(){super(t,o,u._maxDiagnosticsTotal,u._maxDiagnosticsPerFile,w=>v.getDocument(w)?.version,i.extUri,l,a),n.set(o,this)}dispose(){super.dispose(),n.delete(o)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const t=new Map,n=[];for(const r of this._collections.values())r.forEach((a,d)=>{let i=t.get(a.toString());typeof i>"u"&&(i=n.length,t.set(a.toString(),i),n.push([a,[]])),n[i][1]=n[i][1].concat(...d)});return n}}_getDiagnostics(c){let t=[];for(const n of this._collections.values())n.has(c)&&(t=t.concat(n.get(c)));return t}$acceptMarkersChange(c){if(!this._mirrorCollection){const t="_generated_mirror",n=new E(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(t,n),this._mirrorCollection=n}for(const[t,n]of c)this._mirrorCollection.set(P.URI.revive(t),n.map(m.Diagnostic.to))}};e.ExtHostDiagnostics=p,e.ExtHostDiagnostics=p=u=Ge([Ve(1,y.ILogService),Ve(2,C.IExtHostFileSystemInfo)],p)}),define(Te[254],Ae([1,0,2,15,7,8,187]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class m{constructor(y,R,C,u={timeout:1500,errors:3}){this._logService=y,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(y){return(R,C,u)=>{const p={dispose:this._callbacks.push([R,C,y])};return Array.isArray(u)&&u.push(p),p}}async $participateInSave(y,R){const C=I.URI.revive(y);let u=!1;const E=setTimeout(()=>u=!0,this._thresholds.timeout),p=[];try{for(const s of[...this._callbacks]){if(u)break;const c=this._documents.getDocument(C),t=await this._deliverEventAsyncAndBlameBadListeners(s,{document:c,reason:O.TextDocumentSaveReason.to(R)});p.push(t)}}finally{clearTimeout(E)}return p}_deliverEventAsyncAndBlameBadListeners([y,R,C],u){const E=this._badListeners.get(y);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,y,R,u).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const s=this._badListeners.get(y);this._badListeners.set(y,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(y,R,C,u){const E=[],p=Date.now(),{document:s,reason:c}=u,{version:t}=s,n=Object.freeze({document:s,reason:c,waitUntil(r){if(Object.isFrozen(E))throw(0,L.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(r))}});try{R.apply(C,[n])}catch(r){return Promise.reject(r)}return Object.freeze(E),new Promise((r,a)=>{const d=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(d),r(i)}).catch(i=>{clearTimeout(d),a(i)})}).then(r=>{const a={edits:[]};for(const d of r)if(Array.isArray(d)&&d.every(i=>i instanceof P.TextEdit))for(const{newText:i,newEol:v,range:l}of d)a.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:l&&O.Range.from(l),text:i,eol:v&&O.EndOfLine.from(v)}});if(a.edits.length!==0)return t===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=m}),define(Te[255],Ae([1,0,5,6,2,3,109,8,16,26,7]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(E,p){this._onDidAddDocument=new I.Emitter,this._onDidRemoveDocument=new I.Emitter,this._onDidChangeDocument=new I.Emitter,this._onDidSaveDocument=new I.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(O.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const c of s)this._onDidRemoveDocument.fire(c.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const c of s)this._onDidAddDocument.fire(c.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const p=this._documentsAndEditors.getDocument(E);if(p)return p}getDocument(E){const p=this.getDocumentData(E);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return p.document}ensureDocumentData(E){const p=this._documentsAndEditors.getDocument(E);if(p)return Promise.resolve(p);let s=this._documentLoader.get(E.toString());return s||(s=this._proxy.$tryOpenDocument(E).then(c=>{this._documentLoader.delete(E.toString());const t=P.URI.revive(c);return(0,f.assertIsDefined)(this._documentsAndEditors.getDocument(t))},c=>(this._documentLoader.delete(E.toString()),Promise.reject(c))),this._documentLoader.set(E.toString(),s)),s}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(E,p){const s=P.URI.revive(E),c=this._documentsAndEditors.getDocument(s);if(!c)throw new Error("unknown document");this._onDidRemoveDocument.fire(c.document),c._acceptLanguageId(p),this._onDidAddDocument.fire(c.document)}$acceptModelSaved(E){const p=P.URI.revive(E),s=this._documentsAndEditors.getDocument(p);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(E,p){const s=P.URI.revive(E),c=this._documentsAndEditors.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(p),this._onDidChangeDocument.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,p,s){const c=P.URI.revive(E),t=this._documentsAndEditors.getDocument(c);if(!t)throw new Error("unknown document");t._acceptIsDirty(s),t.onEvents(p);let n;p.isUndoing?n=R.TextDocumentChangeReason.Undo:p.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:t.document,contentChanges:p.changes.map(r=>({range:m.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(E,p){(0,T.setWordDefinitionFor)(E,p)}}e.ExtHostDocuments=C}),define(Te[65],Ae([1,0,256,5,16,2,4,3,17,8,7]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class C{constructor(c,t,n){this._activeTabIdGetter=n,this._parentGroup=t,this.acceptDtoUpdate(c)}get apiObject(){if(!this._apiObject){const c=this,t={get isActive(){return c._dto.id===c._activeTabIdGetter()},get label(){return c._dto.label},get input(){return c._input},get isDirty(){return c._dto.isDirty},get isPinned(){return c._dto.isPinned},get isPreview(){return c._dto.isPreview},get group(){return c._parentGroup.apiObject}};this._apiObject=Object.freeze(t)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(c){this._dto=c,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new R.TextTabInput(O.URI.revive(this._dto.input.uri));case 2:return new R.TextDiffTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified));case 3:return new R.TextMergeTabInput(O.URI.revive(this._dto.input.base),O.URI.revive(this._dto.input.input1),O.URI.revive(this._dto.input.input2),O.URI.revive(this._dto.input.result));case 6:return new R.CustomEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new R.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new R.NotebookEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(O.URI.revive(this._dto.input.uri),O.URI.revive(this._dto.input.inputBoxUri));case 10:return new R.ChatEditorTabInput(this._dto.input.providerId);default:return}}}class u{constructor(c,t){this._tabs=[],this._activeTabId="",this._dto=c,this._activeGroupIdGetter=t;for(const n of c.tabs)n.isActive&&(this._activeTabId=n.id),this._tabs.push(new C(n,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const c=this,t={get isActive(){return c._dto.groupId===c._activeGroupIdGetter()},get viewColumn(){return y.ViewColumn.to(c._dto.viewColumn)},get activeTab(){return c._tabs.find(n=>n.tabId===c._activeTabId)?.apiObject},get tabs(){return Object.freeze(c._tabs.map(n=>n.apiObject))}};this._apiObject=Object.freeze(t)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(c){this._dto=c}acceptTabOperation(c){if(c.kind===0){const n=new C(c.tabDto,this,()=>this.activeTabId());return this._tabs.splice(c.index,0,n),c.tabDto.isActive&&(this._activeTabId=n.tabId),n}else if(c.kind===1){const n=this._tabs.splice(c.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return n.tabId===this._activeTabId&&(this._activeTabId=""),n}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this._tabs.splice(c.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this._tabs.splice(c.index,0,n),n}const t=this._tabs.find(n=>n.tabId===c.tabDto.id);if(!t)throw new Error("INVALID tab");return c.tabDto.isActive?this._activeTabId=c.tabDto.id:this._activeTabId===c.tabDto.id&&!c.tabDto.isActive&&(this._activeTabId=""),t.acceptDtoUpdate(c.tabDto),t}activeTabId(){return this._activeTabId}}let E=class{constructor(c){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=c.getProxy(m.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const c=this,t={onDidChangeTabGroups:c._onDidChangeTabGroups.event,onDidChangeTabs:c._onDidChangeTabs.event,get all(){return Object.freeze(c._extHostTabGroups.map(n=>n.apiObject))},get activeTabGroup(){const n=c._activeGroupId;return(0,P.assertIsDefined)(c._extHostTabGroups.find(a=>a.groupId===n)?.apiObject)},close:async(n,r)=>{const a=Array.isArray(n)?n:[n];return a.length?p(a[0])?this._closeGroups(a,r):this._closeTabs(a,r):!0}};this._apiObject=Object.freeze(t)}return this._apiObject}$acceptEditorTabModel(c){const t=new Set(this._extHostTabGroups.map(l=>l.groupId)),n=new Set(c.map(l=>l.groupId)),r=(0,I.diffSets)(t,n),a=this._extHostTabGroups.filter(l=>r.removed.includes(l.groupId)).map(l=>l.apiObject),d=[],i=[];this._extHostTabGroups=c.map(l=>{const o=new u(l,()=>this._activeGroupId);return r.added.includes(o.groupId)?d.push(o.apiObject):i.push(o.apiObject),o});const v=(0,P.assertIsDefined)(c.find(l=>l.isActive===!0)?.groupId);v!==void 0&&this._activeGroupId!==v&&(this._activeGroupId=v),this._onDidChangeTabGroups.fire(Object.freeze({opened:d,closed:a,changed:i}))}$acceptTabGroupUpdate(c){const t=this._extHostTabGroups.find(n=>n.groupId===c.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(c),c.isActive&&(this._activeGroupId=c.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const t=this._extHostTabGroups.find(r=>r.groupId===c.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(c);switch(c.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}_findExtHostTabFromApi(c){for(const t of this._extHostTabGroups)for(const n of t.tabs)if(n.apiObject===c)return n}_findExtHostTabGroupFromApi(c){return this._extHostTabGroups.find(t=>t.apiObject===c)}async _closeTabs(c,t){const n=[];for(const r of c){const a=this._findExtHostTabFromApi(r);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this._proxy.$closeTab(n,t)}async _closeGroups(c,t){const n=[];for(const r of c){const a=this._findExtHostTabGroupFromApi(r);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this._proxy.$closeGroup(n,t)}};e.ExtHostEditorTabs=E,e.ExtHostEditorTabs=E=Ge([Ve(0,f.IExtHostRpcService)],E);function p(s){return s.tabs!==void 0}}),define(Te[257],Ae([1,0,2,3,6,7,8,299,13,24,23,53]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class u{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const c=this._schemes.indexOf(s);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),c=[];let t,n,r=14,a=14;for(const d of s){let i=t?(0,f.commonPrefixLength)(t,d):0;for(i===0?n=1:n=a;i<d.length;i++)i+1===d.length?(r=a,a=9):a+=1,c.push([n,d.toUpperCase().charCodeAt(i),a]),c.push([n,d.toLowerCase().charCodeAt(i),a]),n=a;t=d,a=r}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new m.StateMachine(c)}}provideDocumentLinks(s){this._initStateMachine();const c=[],t=m.LinkComputer.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const n of t){const r=T.DocumentLink.to(n);r.target&&c.push(r)}return c}}class E{constructor(s,c){this._extHostLanguageFeatures=c,this._linkProvider=new u,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(s,c,t,n={}){if(E._validateFileSystemProvider(t),this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(s,"*",this._linkProvider));const r=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(r,t);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof t.copy=="function"&&(a+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.checkProposedApiEnabled)(s,"fsChunks"),a+=4);let d;n.isReadonly&&(0,C.isMarkdownString)(n.isReadonly)&&n.isReadonly.value!==""&&(d={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this._proxy.$registerFileSystemProvider(r,c,a,d).catch(v=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${c}`),console.error(v)});const i=t.onDidChangeFile(v=>{const l=[];for(const o of v){const{uri:S,type:w}=o;if(S.scheme!==c)continue;let g;switch(w){case O.FileChangeType.Changed:g=0;break;case O.FileChangeType.Created:g=1;break;case O.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:S,type:g})}this._proxy.$onFileSystemChange(r,l)});return(0,P.toDisposable)(()=>{i.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(r),this._proxy.$unregisterProvider(r)})}static _validateFileSystemProvider(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(s){const{type:c,ctime:t,mtime:n,size:r,permissions:a}=s;return{type:c,ctime:t,mtime:n,size:r,permissions:a}}$stat(s,c){return Promise.resolve(this._getFsProvider(s).stat(I.URI.revive(c))).then(t=>E._asIStat(t))}$readdir(s,c){return Promise.resolve(this._getFsProvider(s).readDirectory(I.URI.revive(c)))}$readFile(s,c){return Promise.resolve(this._getFsProvider(s).readFile(I.URI.revive(c))).then(t=>y.VSBuffer.wrap(t))}$writeFile(s,c,t,n){return Promise.resolve(this._getFsProvider(s).writeFile(I.URI.revive(c),t.buffer,n))}$delete(s,c,t){return Promise.resolve(this._getFsProvider(s).delete(I.URI.revive(c),t))}$rename(s,c,t,n){return Promise.resolve(this._getFsProvider(s).rename(I.URI.revive(c),I.URI.revive(t),n))}$copy(s,c,t,n){const r=this._getFsProvider(s);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(I.URI.revive(c),I.URI.revive(t),n))}$mkdir(s,c){return Promise.resolve(this._getFsProvider(s).createDirectory(I.URI.revive(c)))}$watch(s,c,t,n){const r=this._getFsProvider(s).watch(I.URI.revive(t),n);this._watches.set(c,r)}$unwatch(s,c){const t=this._watches.get(c);t&&(t.dispose(),this._watches.delete(c))}$open(s,c,t){const n=this._getFsProvider(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(c),t))}$close(s,c){const t=this._getFsProvider(s);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(c))}$read(s,c,t,n){const r=this._getFsProvider(s);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const a=y.VSBuffer.alloc(n);return Promise.resolve(r.read(c,t,a.buffer,0,n)).then(d=>a.slice(0,d))}$write(s,c,t,n){const r=this._getFsProvider(s);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(c,t,n.buffer,0,n.byteLength))}_getFsProvider(s){const c=this._fsProvider.get(s);if(!c){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return c}}e.ExtHostFileSystem=E}),define(Te[258],Ae([1,0,5,35,2,3,8,7,40]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(E,p,s,c,t,n){this.session=Math.random(),this._onDidCreate=new I.Emitter,this._onDidChange=new I.Emitter,this._onDidDelete=new I.Emitter,this._config=0,n?.ignoreCreateEvents&&(this._config+=1),n?.ignoreChangeEvents&&(this._config+=2),n?.ignoreDeleteEvents&&(this._config+=4);const r=(0,L.parse)(t),a=typeof t=="string",d=n?.correlate,i=c(v=>{if(!(typeof v.session=="number"&&v.session!==this.session)&&!(d&&typeof v.session>"u")){if(!n?.ignoreCreateEvents)for(const l of v.created){const o=P.URI.revive(l);r(o.fsPath)&&(!a||p.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!n?.ignoreChangeEvents)for(const l of v.changed){const o=P.URI.revive(l);r(o.fsPath)&&(!a||p.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!n?.ignoreDeleteEvents)for(const l of v.deleted){const o=P.URI.revive(l);r(o.fsPath)&&(!a||p.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}}});this._disposable=m.Disposable.from(this.ensureWatching(E,s,t,n,n?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(E,p,s,c,t){const n=m.Disposable.from();if(typeof s=="string")return n;const r=E.getProxy(O.MainContext.MainThreadFileSystemEventService);let a=!1;return(s.pattern.includes(L.GLOBSTAR)||s.pattern.includes(L.GLOB_SPLIT))&&(a=!0),r.$watch(p.identifier.value,this.session,s.baseUri,{recursive:a,excludes:c?.excludes??[]},!!t),m.Disposable.from({dispose:()=>r.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(E){this._events=E,this.session=this._events.session,this._created=new f.Lazy(()=>this._events.created.map(P.URI.revive)),this._changed=new f.Lazy(()=>this._events.changed.map(P.URI.revive)),this._deleted=new f.Lazy(()=>this._events.deleted.map(P.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class C{constructor(E,p,s){this._mainContext=E,this._logService=p,this._extHostDocumentsAndEditors=s,this._onFileSystemEvent=new I.Emitter,this._onDidRenameFile=new I.Emitter,this._onDidCreateFile=new I.Emitter,this._onDidDeleteFile=new I.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(E,p,s,c){return new y(this._mainContext,E,p,this._onFileSystemEvent.event,T.GlobPattern.from(s),c)}$onFileEvent(E){this._onFileSystemEvent.fire(new R(E))}$onDidRunFileOperation(E,p){switch(E){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(E){return this._createWillExecuteEvent(E,this._onWillRenameFile)}getOnWillCreateFileEvent(E){return this._createWillExecuteEvent(E,this._onWillCreateFile)}getOnWillDeleteFileEvent(E){return this._createWillExecuteEvent(E,this._onWillDeleteFile)}_createWillExecuteEvent(E,p){return(s,c,t)=>{const n=function(a){s.call(c,a)};return n.extension=E,p.event(n,void 0,t)}}async $onWillRunFileOperation(E,p,s,c){switch(E){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(t=>({oldUri:P.URI.revive(t.source),newUri:P.URI.revive(t.target)}))},s,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(t=>P.URI.revive(t.target))},s,c);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(t=>P.URI.revive(t.target))},s,c)}}async _fireWillEvent(E,p,s,c){const t=new Set,n=[];if(await E.fireAsync(p,c,async(a,d)=>{const i=Date.now(),v=await Promise.resolve(a);v instanceof m.WorkspaceEdit&&(n.push([d.extension,v]),t.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-i>s&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),c.isCancellationRequested||n.length===0)return;const r={edits:[]};for(const[,a]of n){const{edits:d}=T.WorkspaceEdit.from(a,{getTextDocumentVersion:i=>this._extHostDocumentsAndEditors.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(d)}return{edit:r,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=C}),define(Te[259],Ae([1,0,18,11,22,15,88,6,26,64,13,16,2,29,300,86,95,162,20,8,7,23,74,3]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class l{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentSymbols(M,x){const q=this._documents.getDocument(M),W=await this._provider.provideDocumentSymbols(q,x);if(!(0,I.isFalsyOrEmpty)(W))return W[0]instanceof a.DocumentSymbol?W.map(r.DocumentSymbol.from):l._asDocumentSymbolTree(W)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((W,te)=>{let oe=W.location.range.start.compareTo(te.location.range.start);return oe===0&&(oe=te.location.range.end.compareTo(W.location.range.end)),oe});const x=[],q=[];for(const W of M){const te={name:W.name||"!!MISSING: name!!",kind:r.SymbolKind.from(W.kind),tags:W.tags?.map(r.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:r.Range.from(W.location.range),selectionRange:r.Range.from(W.location.range),children:[]};for(;;){if(q.length===0){q.push(te),x.push(te);break}const oe=q[q.length-1];if(E.Range.containsRange(oe.range,te.range)&&!E.Range.equalsRange(oe.range,te.range)){oe.children?.push(te),q.push(te);break}q.pop()}}return x}}class o{constructor(M,x,q,W,te,oe){this._documents=M,this._commands=x,this._provider=q,this._extension=W,this._extTelemetry=te,this._logService=oe,this._cache=new i.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,x){const q=this._documents.getDocument(M),W=await this._provider.provideCodeLenses(q,x);if(!W||x.isCancellationRequested)return;const te=this._cache.add(W),oe=new m.DisposableStore;this._disposables.set(te,oe);const Ne={cacheId:te,lenses:[]};for(let $e=0;$e<W.length;$e++)Ne.lenses.push({cacheId:[te,$e],range:r.Range.from(W[$e].range),command:this._commands.toInternal(W[$e].command,oe)});return Ne}async resolveCodeLens(M,x){const q=M.cacheId&&this._cache.get(...M.cacheId);if(!q)return;let W;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?W=q:W=await this._provider.resolveCodeLens(q,x),W||(W=q),x.isCancellationRequested)return;const te=M.cacheId&&this._disposables.get(M.cacheId[0]);if(te){if(!W.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,oe),this._logService.error(oe);return}return M.command=this._commands.toInternal(W.command,te),M}}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}function S(xe){return Array.isArray(xe)?xe.map(r.DefinitionLink.from):xe?[r.DefinitionLink.from(xe)]:[]}class w{constructor(M,x){this._documents=M,this._provider=x}async provideDefinition(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideDefinition(W,te,q);return S(oe)}}class g{constructor(M,x){this._documents=M,this._provider=x}async provideDeclaration(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideDeclaration(W,te,q);return S(oe)}}class D{constructor(M,x){this._documents=M,this._provider=x}async provideImplementation(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideImplementation(W,te,q);return S(oe)}}class h{constructor(M,x){this._documents=M,this._provider=x}async provideTypeDefinition(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideTypeDefinition(W,te,q);return S(oe)}}class _{constructor(M,x){this._documents=M,this._provider=x}async provideHover(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideHover(W,te,q);if(!(!oe||(0,I.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=W.getWordRangeAtPosition(te)),oe.range||(oe.range=new a.Range(te,te)),r.Hover.from(oe)}}class b{constructor(M,x){this._documents=M,this._provider=x}async provideEvaluatableExpression(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideEvaluatableExpression(W,te,q);if(oe)return r.EvaluatableExpression.from(oe)}}class A{constructor(M,x){this._documents=M,this._provider=x}async provideInlineValues(M,x,q,W){const te=this._documents.getDocument(M),oe=await this._provider.provideInlineValues(te,r.Range.to(x),r.InlineValueContext.to(q),W);if(Array.isArray(oe))return oe.map(Ne=>r.InlineValue.from(Ne))}}class F{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentHighlights(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideDocumentHighlights(W,te,q);if(Array.isArray(oe))return oe.map(r.DocumentHighlight.from)}}class j{constructor(M,x){this._documents=M,this._provider=x}async provideMultiDocumentHighlights(M,x,q,W){const te=this._documents.getDocument(M),oe=q.map(We=>this._documents.getDocument(We)),Ne=r.Position.to(x),$e=await this._provider.provideMultiDocumentHighlights(te,Ne,oe,W);if(Array.isArray($e))return $e.map(r.MultiDocumentHighlight.from)}}class H{constructor(M,x){this._documents=M,this._provider=x}async provideLinkedEditingRanges(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.provideLinkedEditingRanges(W,te,q);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,I.coalesce)(oe.ranges.map(r.Range.from)),wordPattern:oe.wordPattern}}}class B{constructor(M,x){this._documents=M,this._provider=x}async provideReferences(M,x,q,W){const te=this._documents.getDocument(M),oe=r.Position.to(x),Ne=await this._provider.provideReferences(te,oe,q,W);if(Array.isArray(Ne))return Ne.map(r.location.from)}}class k{static{this._maxCodeActionsPerFile=1e3}constructor(M,x,q,W,te,oe,Ne){this._documents=M,this._commands=x,this._diagnostics=q,this._provider=W,this._logService=te,this._extension=oe,this._apiDeprecation=Ne,this._cache=new i.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,x,q,W){const te=this._documents.getDocument(M),oe=p.Selection.isISelection(x)?r.Selection.to(x):r.Range.to(x),Ne=[];for(const rt of this._diagnostics.getDiagnostics(M))if(oe.intersection(rt.range)&&Ne.push(rt)>k._maxCodeActionsPerFile)break;const $e={diagnostics:Ne,only:q.only?new a.CodeActionKind(q.only):void 0,triggerKind:r.CodeActionTriggerKind.to(q.trigger)},We=await this._provider.provideCodeActions(te,oe,$e,W);if(!(0,I.isNonEmptyArray)(We)||W.isCancellationRequested)return;const Je=this._cache.add(We),tt=new m.DisposableStore;this._disposables.set(Je,tt);const ut=[];for(let rt=0;rt<We.length;rt++){const it=We[rt];if(it)if(k._isCommand(it))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:it.title,command:this._commands.toInternal(it,tt)});else{$e.only&&(it.kind?$e.only.contains(it.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${$e.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${$e.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=it.ranges??[];ut.push({cacheId:[Je,rt],title:it.title,command:it.command&&this._commands.toInternal(it.command,tt),diagnostics:it.diagnostics&&it.diagnostics.map(r.Diagnostic.from),edit:it.edit&&r.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,d.isProposedApiEnabled)(this._extension,"codeActionAI")?it.isAI:!1,ranges:(0,d.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,I.coalesce)(ot.map(r.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:Je,actions:ut}}async resolveCodeAction(M,x){const[q,W]=M,te=this._cache.get(q,W);if(!te||k._isCommand(te))return{};if(!this._provider.resolveCodeAction)return{};const oe=await this._provider.resolveCodeAction(te,x)??te;let Ne;oe.edit&&(Ne=r.WorkspaceEdit.from(oe.edit,void 0));let $e;if(oe.command){const We=this._disposables.get(q);We&&($e=this._commands.toInternal(oe.command,We))}return{edit:Ne,command:$e}}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}class N{static toInternalProviderId(M,x){return M+"."+x}constructor(M,x,q,W,te){this._proxy=M,this._documents=x,this._provider=q,this._handle=W,this._extension=te}async prepareDocumentPaste(M,x,q,W){if(!this._provider.prepareDocumentPaste)return;const te=this._documents.getDocument(M),oe=x.map(We=>r.Range.to(We)),Ne=r.DataTransfer.toDataTransfer(q,()=>{throw new O.NotImplementedError});if(await this._provider.prepareDocumentPaste(te,oe,Ne,W),W.isCancellationRequested)return;const $e=Array.from(Ne).filter(([,We])=>!(We instanceof a.InternalDataTransferItem));return r.DataTransfer.from($e)}async providePasteEdits(M,x,q,W,te){if(!this._provider.provideDocumentPasteEdits)return;const oe=this._documents.getDocument(x),Ne=q.map(Je=>r.Range.to(Je)),$e=r.DataTransfer.toDataTransfer(W,async Je=>(await this._proxy.$resolvePasteFileData(this._handle,M,Je)).buffer),We=await this._provider.provideDocumentPasteEdits(oe,Ne,$e,te);if(We)return{label:We.label??(0,t.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:We.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:N.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?r.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ${constructor(M,x){this._documents=M,this._provider=x}async provideDocumentFormattingEdits(M,x,q){const W=this._documents.getDocument(M),te=await this._provider.provideDocumentFormattingEdits(W,x,q);if(Array.isArray(te))return te.map(r.TextEdit.from)}}class re{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentRangeFormattingEdits(M,x,q,W){const te=this._documents.getDocument(M),oe=r.Range.to(x),Ne=await this._provider.provideDocumentRangeFormattingEdits(te,oe,q,W);if(Array.isArray(Ne))return Ne.map(r.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,x,q,W){(0,C.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this._documents.getDocument(M),oe=x.map(r.Range.to),Ne=await this._provider.provideDocumentRangesFormattingEdits(te,oe,q,W);if(Array.isArray(Ne))return Ne.map(r.TextEdit.from)}}class le{constructor(M,x){this._documents=M,this._provider=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,x,q,W,te){const oe=this._documents.getDocument(M),Ne=r.Position.to(x),$e=await this._provider.provideOnTypeFormattingEdits(oe,Ne,q,W,te);if(Array.isArray($e))return $e.map(r.TextEdit.from)}}class _e{constructor(M,x){this._provider=M,this._logService=x,this._cache=new i.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,x){const q=await this._provider.provideWorkspaceSymbols(M,x);if(!(0,I.isNonEmptyArray)(q))return{symbols:[]};const W=this._cache.add(q),te={cacheId:W,symbols:[]};for(let oe=0;oe<q.length;oe++){const Ne=q[oe];if(!Ne||!Ne.name){this._logService.warn("INVALID SymbolInformation",Ne);continue}te.symbols.push({...r.WorkspaceSymbol.from(Ne),cacheId:[W,oe]})}return te}async resolveWorkspaceSymbol(M,x){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const q=this._cache.get(...M.cacheId);if(q){const W=await this._provider.resolveWorkspaceSymbol(q,x);return W&&(0,f.mixin)(M,r.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class ye{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,x,q){this._documents=M,this._provider=x,this._logService=q}async provideRenameEdits(M,x,q,W){const te=this._documents.getDocument(M),oe=r.Position.to(x);try{const Ne=await this._provider.provideRenameEdits(te,oe,q,W);return Ne?r.WorkspaceEdit.from(Ne):void 0}catch(Ne){const $e=ye._asMessage(Ne);return $e?{rejectReason:$e,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(M,x,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument(M),te=r.Position.to(x);try{const oe=await this._provider.prepareRename(W,te,q);let Ne,$e;if(a.Range.isRange(oe)?(Ne=oe,$e=W.getText(oe)):(0,C.isObject)(oe)&&(Ne=oe.range,$e=oe.placeholder),!Ne||!$e)return;if(Ne.start.line>te.line||Ne.end.line<te.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:r.Range.from(Ne),text:$e}}catch(oe){const Ne=ye._asMessage(oe);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class de{constructor(M,x,q){this._documents=M,this._provider=x,this._logService=q}async provideNewSymbolNames(M,x,q){const W=this._documents.getDocument(M),te=r.Range.to(x);try{const oe=await this._provider.provideNewSymbolNames(W,te,q);return oe?oe.map(Ne=>typeof Ne=="string"?{newSymbolName:Ne}:{newSymbolName:Ne.newSymbolName,tags:Ne.tags}):void 0}catch(oe){this._logService.error(de._asMessage(oe)??JSON.stringify(oe,null,"	"));return}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Ee{constructor(M,x){this.resultId=M,this.tokens=x}}class se{constructor(M,x){this._documents=M,this._provider=x,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,x,q){const W=this._documents.getDocument(M),te=x!==0?this._previousResults.get(x):null;let oe=typeof te?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,te.resultId,q):await this._provider.provideDocumentSemanticTokens(W,q);return te&&this._previousResults.delete(x),oe?(oe=se._fixProvidedSemanticTokens(oe),this._send(se._convertToEdits(te,oe),oe)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return se._isSemanticTokens(M)?se._isCorrectSemanticTokens(M)?M:new a.SemanticTokens(new Uint32Array(M.data),M.resultId):se._isSemanticTokensEdits(M)?se._isCorrectSemanticTokensEdits(M)?M:new a.SemanticTokensEdits(M.edits.map(x=>new a.SemanticTokensEdit(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const x of M.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,x){if(!se._isSemanticTokens(x)||!M||!M.tokens)return x;const q=M.tokens,W=q.length,te=x.data,oe=te.length;let Ne=0;const $e=Math.min(W,oe);for(;Ne<$e&&q[Ne]===te[Ne];)Ne++;if(Ne===W&&Ne===oe)return new a.SemanticTokensEdits([],x.resultId);let We=0;const Je=$e-Ne;for(;We<Je&&q[W-We-1]===te[oe-We-1];)We++;return new a.SemanticTokensEdits([{start:Ne,deleteCount:W-Ne-We,data:te.subarray(Ne,oe-We)}],x.resultId)}_send(M,x){if(se._isSemanticTokens(M)){const q=this._nextResultId++;return this._previousResults.set(q,new Ee(M.resultId,M.data)),(0,c.encodeSemanticTokensDto)({id:q,type:"full",data:M.data})}if(se._isSemanticTokensEdits(M)){const q=this._nextResultId++;return se._isSemanticTokens(x)?this._previousResults.set(q,new Ee(x.resultId,x.data)):this._previousResults.set(q,new Ee(M.resultId)),(0,c.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(M.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}class pe{constructor(M,x){this._documents=M,this._provider=x}async provideDocumentRangeSemanticTokens(M,x,q){const W=this._documents.getDocument(M),te=await this._provider.provideDocumentRangeSemanticTokens(W,r.Range.to(x),q);return te?this._send(te):null}_send(M){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}class ee{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,x,q,W,te){this._documents=M,this._commands=x,this._provider=q,this._apiDeprecation=W,this._extension=te,this._cache=new i.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(M,x,q,W){const te=this._documents.getDocument(M),oe=r.Position.to(x),Ne=te.getWordRangeAtPosition(oe)||new a.Range(oe,oe),$e=Ne.with({end:oe}),We=new y.StopWatch,Je=await this._provider.provideCompletionItems(te,oe,W,r.CompletionContext.to(q));if(!Je||W.isCancellationRequested)return;const tt=Array.isArray(Je)?new a.CompletionList(Je):Je,ut=ee.supportsResolving(this._provider)?this._cache.add(tt.items):this._cache.add([]),rt=new m.DisposableStore;this._disposables.set(ut,rt);const it=[],ot={x:ut,b:it,a:{replace:r.Range.from(Ne),insert:r.Range.from($e)},c:tt.isIncomplete||void 0,d:We.elapsed()};for(let ze=0;ze<tt.items.length;ze++){const et=tt.items[ze],Y=this._convertCompletionItem(et,[ut,ze],$e,Ne);it.push(Y)}return ot}async resolveCompletionItem(M,x){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...M);if(!q)return;const W=this._convertCompletionItem(q,M),te=await this._provider.resolveCompletionItem(q,x);if(!te)return;const oe=this._convertCompletionItem(te,M);return(W.h!==oe.h||W.i!==oe.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(W.n!==oe.n||W.o!==oe.o||!(0,f.equals)(W.p,oe.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...W,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,x,q,W){const te=this._disposables.get(x[0]);if(!te)throw Error("DisposableStore is missing...");const oe=this._commands.toInternal(M.command,te),Ne={x,a:M.label,b:M.kind!==void 0?r.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(r.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:r.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(r.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=M.textEdit.newText):typeof M.insertText=="string"?Ne.h=M.insertText:M.insertText instanceof a.SnippetString&&(Ne.h=M.insertText.value,Ne.i|=4);let $e;return M.textEdit?$e=M.textEdit.range:M.range&&($e=M.range),a.Range.isRange($e)?Ne.j=r.Range.from($e):$e&&(!q?.isEqual($e.inserting)||!W?.isEqual($e.replacing))&&(Ne.j={insert:r.Range.from($e.inserting),replace:r.Range.from($e.replacing)}),Ne}}class X{async provideInlineCompletions(M,x,q,W){}disposeCompletions(M){}handleDidShowCompletionItem(M,x,q){}handlePartialAccept(M,x,q){}}class V extends X{constructor(M,x,q,W){super(),this._extension=M,this._documents=x,this._provider=q,this._commands=W,this._references=new Ie,this._isAdditionsProposedApiEnabled=(0,d.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[s.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,d.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,x,q,W){const te=this._documents.getDocument(M),oe=r.Position.to(x),Ne=await this._provider.provideInlineCompletionItems(te,oe,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:r.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},W);if(!Ne||W.isCancellationRequested)return;const $e=Array.isArray(Ne)?Ne:Ne.items,We=this._isAdditionsProposedApiEnabled?Array.isArray(Ne)?[]:Ne.commands||[]:[],Je=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let tt;return{pid:this._references.createReferenceId({dispose(){tt?.dispose()},items:$e}),items:$e.map((rt,it)=>{let ot;rt.command&&(tt||(tt=new m.DisposableStore),ot=this._commands.toInternal(rt.command,tt));const ze=rt.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:rt.filterText,range:rt.range?r.Range.from(rt.range):void 0,command:ot,idx:it,completeBracketPairs:this._isAdditionsProposedApiEnabled?rt.completeBracketPairs:!1}}),commands:We.map(rt=>(tt||(tt=new m.DisposableStore),this._commands.toInternal(rt,tt))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,x,q){const W=this._references.get(M)?.items[x];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W,q)}handlePartialAccept(M,x,q){const W=this._references.get(M)?.items[x];W&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(W,q)}}class ne{async provideInlineEdits(M,x,q){const W=this._documents.getDocument(M),te=await this._provider.provideInlineEdit(W,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[x.triggerKind]},q);if(!te||q.isCancellationRequested)return;let oe;const Ne=this._references.createReferenceId({dispose(){oe?.dispose()},item:te});let $e;te.accepted&&(oe||(oe=new m.DisposableStore),$e=this._commands.toInternal(te.accepted,oe));let We;return te.rejected&&(oe||(oe=new m.DisposableStore),We=this._commands.toInternal(te.rejected,oe)),{pid:Ne,text:te.text,range:r.Range.from(te.range),accepted:$e,rejected:We}}disposeEdit(M){this._references.disposeReferenceId(M)?.dispose()}constructor(M,x,q,W){this._documents=x,this._provider=q,this._commands=W,this._references=new Ie,this.languageTriggerKindToVSCodeTriggerKind={[s.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class Ie{constructor(){this._references=new Map,this._idPool=1}createReferenceId(M){const x=this._idPool++;return this._references.set(x,M),x}disposeReferenceId(M){const x=this._references.get(M);return this._references.delete(M),x}get(M){return this._references.get(M)}}class Fe{constructor(M,x){this._documents=M,this._provider=x,this._cache=new i.Cache("SignatureHelp")}async provideSignatureHelp(M,x,q,W){const te=this._documents.getDocument(M),oe=r.Position.to(x),Ne=this.reviveContext(q),$e=await this._provider.provideSignatureHelp(te,oe,W,Ne);if($e){const We=this._cache.add([$e]);return{...r.SignatureHelp.from($e),id:We}}}reviveContext(M){let x;if(M.activeSignatureHelp){const q=r.SignatureHelp.to(M.activeSignatureHelp),W=this._cache.get(M.activeSignatureHelp.id,0);W?(x=W,x.activeSignature=q.activeSignature,x.activeParameter=q.activeParameter):x=q}return{...M,activeSignatureHelp:x}}releaseSignatureHelp(M){this._cache.delete(M)}}class ke{constructor(M,x,q,W,te){this._documents=M,this._commands=x,this._provider=q,this._logService=W,this._extension=te,this._cache=new i.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,x,q){const W=this._documents.getDocument(M),te=r.Range.to(x),oe=await this._provider.provideInlayHints(W,te,q);if(!Array.isArray(oe)||oe.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`);return}if(q.isCancellationRequested)return;const Ne=this._cache.add(oe);this._disposables.set(Ne,new m.DisposableStore);const $e={hints:[],cacheId:Ne};for(let We=0;We<oe.length;We++)this._isValidInlayHint(oe[We],te)&&$e.hints.push(this._convertInlayHint(oe[We],[Ne,We]));return this._logService.trace(`[InlayHints] ${$e.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`),$e}async resolveInlayHint(M,x){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...M);if(!q)return;const W=await this._provider.resolveInlayHint(q,x);if(W&&this._isValidInlayHint(W))return this._convertInlayHint(W,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,x){return M.label.length===0||Array.isArray(M.label)&&M.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(x&&!x.contains(M.position))}_convertInlayHint(M,x){const q=this._disposables.get(x[0]);if(!q)throw Error("DisposableStore is missing...");const W={label:"",cacheId:x,tooltip:r.MarkdownString.fromStrict(M.tooltip),position:r.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(r.TextEdit.from),kind:M.kind&&r.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};if(typeof M.label=="string")W.label=M.label;else{const te=[];W.label=te;for(const oe of M.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Ne={label:oe.value,tooltip:r.MarkdownString.fromStrict(oe.tooltip)};a.Location.isLocation(oe.location)&&(Ne.location=r.location.from(oe.location)),oe.command&&(Ne.command=this._commands.toInternal(oe.command,q)),te.push(Ne)}}return W}}class we{constructor(M,x){this._documents=M,this._provider=x,this._cache=new i.Cache("DocumentLink")}async provideLinks(M,x){const q=this._documents.getDocument(M),W=await this._provider.provideDocumentLinks(q,x);if(!(!Array.isArray(W)||W.length===0)&&!x.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(we._validateLink).map(r.DocumentLink.from)};{const te=this._cache.add(W),oe={links:[],cacheId:te};for(let Ne=0;Ne<W.length;Ne++){if(!we._validateLink(W[Ne]))continue;const $e=r.DocumentLink.from(W[Ne]);$e.cacheId=[te,Ne],oe.links.push($e)}return oe}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,x){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...M);if(!q)return;const W=await this._provider.resolveDocumentLink(q,x);if(!(!W||!we._validateLink(W)))return r.DocumentLink.from(W)}releaseLinks(M){this._cache.delete(M)}}class me{constructor(M,x){this._documents=M,this._provider=x}async provideColors(M,x){const q=this._documents.getDocument(M),W=await this._provider.provideDocumentColors(q,x);return Array.isArray(W)?W.map(oe=>({color:r.Color.from(oe.color),range:r.Range.from(oe.range)})):[]}async provideColorPresentations(M,x,q){const W=this._documents.getDocument(M),te=r.Range.to(x.range),oe=r.Color.to(x.color),Ne=await this._provider.provideColorPresentations(oe,{document:W,range:te},q);if(Array.isArray(Ne))return Ne.map(r.ColorPresentation.from)}}class K{constructor(M,x){this._documents=M,this._provider=x}async provideFoldingRanges(M,x,q){const W=this._documents.getDocument(M),te=await this._provider.provideFoldingRanges(W,x,q);if(Array.isArray(te))return te.map(r.FoldingRange.from)}}class J{constructor(M,x,q){this._documents=M,this._provider=x,this._logService=q}async provideSelectionRanges(M,x,q){const W=this._documents.getDocument(M),te=x.map(r.Position.to),oe=await this._provider.provideSelectionRanges(W,te,q);if(!(0,I.isNonEmptyArray)(oe))return[];if(oe.length!==te.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let $e=0;$e<te.length;$e++){const We=[];Ne.push(We);let Je=te[$e],tt=oe[$e];for(;;){if(!tt.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(We.push(r.SelectionRange.from(tt)),!tt.parent)break;Je=tt.range,tt=tt.parent}}return Ne}}class ue{constructor(M,x){this._documents=M,this._provider=x,this._idPool=new T.IdGenerator(""),this._cache=new Map}async prepareSession(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.prepareCallHierarchy(W,te,q);if(!oe)return;const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(oe)?oe.map($e=>this._cacheAndConvertItem(Ne,$e)):[this._cacheAndConvertItem(Ne,oe)]}async provideCallsTo(M,x,q){const W=this._itemFromCache(M,x);if(!W)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyIncomingCalls(W,q);if(te)return te.map(oe=>({from:this._cacheAndConvertItem(M,oe.from),fromRanges:oe.fromRanges.map(Ne=>r.Range.from(Ne))}))}async provideCallsFrom(M,x,q){const W=this._itemFromCache(M,x);if(!W)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyOutgoingCalls(W,q);if(te)return te.map(oe=>({to:this._cacheAndConvertItem(M,oe.to),fromRanges:oe.fromRanges.map(Ne=>r.Range.from(Ne))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,x){const q=this._cache.get(M),W=r.CallHierarchyItem.from(x,M,q.size.toString(36));return q.set(W._itemId,x),W}_itemFromCache(M,x){return this._cache.get(M)?.get(x)}}class he{constructor(M,x){this._documents=M,this._provider=x,this._idPool=new T.IdGenerator(""),this._cache=new Map}async prepareSession(M,x,q){const W=this._documents.getDocument(M),te=r.Position.to(x),oe=await this._provider.prepareTypeHierarchy(W,te,q);if(!oe)return;const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(oe)?oe.map($e=>this._cacheAndConvertItem(Ne,$e)):[this._cacheAndConvertItem(Ne,oe)]}async provideSupertypes(M,x,q){const W=this._itemFromCache(M,x);if(!W)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySupertypes(W,q);if(te)return te.map(oe=>this._cacheAndConvertItem(M,oe))}async provideSubtypes(M,x,q){const W=this._itemFromCache(M,x);if(!W)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySubtypes(W,q);if(te)return te.map(oe=>this._cacheAndConvertItem(M,oe))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,x){const q=this._cache.get(M),W=r.TypeHierarchyItem.from(x,M,q.size.toString(36));return q.set(W._itemId,x),W}_itemFromCache(M,x){return this._cache.get(M)?.get(x)}}class Pe{static toInternalProviderId(M,x){return M+"."+x}constructor(M,x,q,W,te){this._proxy=M,this._documents=x,this._provider=q,this._handle=W,this._extension=te}async provideDocumentOnDropEdits(M,x,q,W,te){const oe=this._documents.getDocument(x),Ne=r.Position.to(q),$e=r.DataTransfer.toDataTransfer(W,async Je=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,Je)).buffer),We=await this._provider.provideDocumentDropEdits(oe,Ne,$e,te);if(We)return{label:We.label??(0,t.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:We.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:Pe.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?r.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ge{constructor(M,x){this._documents=M,this._provider=x}async provideMappedEdits(M,x,q,W){const te=u.URI.revive(M),oe=this._documents.getDocument(te),Ne=q.documents.map(Je=>Je.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(ut=>r.Range.to(ut))}))),$e={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},We=await this._provider.provideMappedEdits(oe,x,$e,W);return We?r.WorkspaceEdit.from(We):null}}class De{constructor(M,x){this.adapter=M,this.extension=x}}class Re{static{this._handlePool=0}constructor(M,x,q,W,te,oe,Ne,$e){this._uriTransformer=x,this._documents=q,this._commands=W,this._diagnostics=te,this._logService=oe,this._apiDeprecation=Ne,this._extensionTelemetry=$e,this._adapter=new Map,this._proxy=M.getProxy(v.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(M,x){return r.DocumentSelector.from(M,this._uriTransformer,x)}_createDisposable(M){return new a.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return Re._handlePool++}async _withAdapter(M,x,q,W,te,oe=!1){const Ne=this._adapter.get(M);if(!Ne||!(Ne.adapter instanceof x))return W;const $e=Date.now();oe||this._logService.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const We=q(Ne.adapter,Ne.extension);return Promise.resolve(We).catch(Je=>{(0,O.isCancellationError)(Je)||(this._logService.error(`[${Ne.extension.identifier.value}] provider FAILED`),this._logService.error(Je),this._extensionTelemetry.onExtensionError(Ne.extension.identifier,Je))}).finally(()=>{oe||this._logService.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-$e}ms`)}),P.CancellationToken.isCancellationToken(te)?(0,L.raceCancellationError)(We,te):We}_addNewAdapter(M,x){const q=this._nextHandle();return this._adapter.set(q,new De(M,x)),q}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,x,q,W){const te=this._addNewAdapter(new l(this._documents,q),M),oe=W&&W.label||Re._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(te,this._transformDocumentSelector(x,M),oe),this._createDisposable(te)}$provideDocumentSymbols(M,x,q){return this._withAdapter(M,l,W=>W.provideDocumentSymbols(u.URI.revive(x),q),void 0,q)}registerCodeLensProvider(M,x,q){const W=this._nextHandle(),te=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new De(new o(this._documents,this._commands.converter,q,M,this._extensionTelemetry,this._logService),M)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(x,M),te);let oe=this._createDisposable(W);if(te!==void 0){const Ne=q.onDidChangeCodeLenses($e=>this._proxy.$emitCodeLensEvent(te));oe=a.Disposable.from(oe,Ne)}return oe}$provideCodeLenses(M,x,q){return this._withAdapter(M,o,W=>W.provideCodeLenses(u.URI.revive(x),q),void 0,q)}$resolveCodeLens(M,x,q){return this._withAdapter(M,o,W=>W.resolveCodeLens(x,q),void 0,void 0)}$releaseCodeLenses(M,x){this._withAdapter(M,o,q=>Promise.resolve(q.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(M,x,q){const W=this._addNewAdapter(new w(this._documents,q),M);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideDefinition(M,x,q,W){return this._withAdapter(M,w,te=>te.provideDefinition(u.URI.revive(x),q,W),[],W)}registerDeclarationProvider(M,x,q){const W=this._addNewAdapter(new g(this._documents,q),M);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideDeclaration(M,x,q,W){return this._withAdapter(M,g,te=>te.provideDeclaration(u.URI.revive(x),q,W),[],W)}registerImplementationProvider(M,x,q){const W=this._addNewAdapter(new D(this._documents,q),M);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideImplementation(M,x,q,W){return this._withAdapter(M,D,te=>te.provideImplementation(u.URI.revive(x),q,W),[],W)}registerTypeDefinitionProvider(M,x,q){const W=this._addNewAdapter(new h(this._documents,q),M);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideTypeDefinition(M,x,q,W){return this._withAdapter(M,h,te=>te.provideTypeDefinition(u.URI.revive(x),q,W),[],W)}registerHoverProvider(M,x,q,W){const te=this._addNewAdapter(new _(this._documents,q),M);return this._proxy.$registerHoverProvider(te,this._transformDocumentSelector(x,M)),this._createDisposable(te)}$provideHover(M,x,q,W){return this._withAdapter(M,_,te=>te.provideHover(u.URI.revive(x),q,W),void 0,W)}registerEvaluatableExpressionProvider(M,x,q,W){const te=this._addNewAdapter(new b(this._documents,q),M);return this._proxy.$registerEvaluatableExpressionProvider(te,this._transformDocumentSelector(x,M)),this._createDisposable(te)}$provideEvaluatableExpression(M,x,q,W){return this._withAdapter(M,b,te=>te.provideEvaluatableExpression(u.URI.revive(x),q,W),void 0,W)}registerInlineValuesProvider(M,x,q,W){const te=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new A(this._documents,q),M);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(x,M),te);let Ne=this._createDisposable(oe);if(te!==void 0){const $e=q.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(te));Ne=a.Disposable.from(Ne,$e)}return Ne}$provideInlineValues(M,x,q,W,te){return this._withAdapter(M,A,oe=>oe.provideInlineValues(u.URI.revive(x),q,W,te),void 0,te)}registerDocumentHighlightProvider(M,x,q){const W=this._addNewAdapter(new F(this._documents,q),M);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}registerMultiDocumentHighlightProvider(M,x,q){const W=this._addNewAdapter(new j(this._documents,q),M);return this._proxy.$registerMultiDocumentHighlightProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideDocumentHighlights(M,x,q,W){return this._withAdapter(M,F,te=>te.provideDocumentHighlights(u.URI.revive(x),q,W),void 0,W)}$provideMultiDocumentHighlights(M,x,q,W,te){return this._withAdapter(M,j,oe=>oe.provideMultiDocumentHighlights(u.URI.revive(x),q,W.map(Ne=>u.URI.revive(Ne)),te),void 0,te)}registerLinkedEditingRangeProvider(M,x,q){const W=this._addNewAdapter(new H(this._documents,q),M);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideLinkedEditingRanges(M,x,q,W){return this._withAdapter(M,H,async te=>{const oe=await te.provideLinkedEditingRanges(u.URI.revive(x),q,W);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Re._serializeRegExp(oe.wordPattern):void 0}},void 0,W)}registerReferenceProvider(M,x,q){const W=this._addNewAdapter(new B(this._documents,q),M);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideReferences(M,x,q,W,te){return this._withAdapter(M,B,oe=>oe.provideReferences(u.URI.revive(x),q,W,te),void 0,te)}registerCodeActionProvider(M,x,q,W){const te=new m.DisposableStore,oe=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,q,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(x,M),{providedKinds:W?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:W?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this._commands.converter.toInternal(Ne.command,te)}))},Re._extLabel(M),!!q.resolveCodeAction),te.add(this._createDisposable(oe)),te}$provideCodeActions(M,x,q,W,te){return this._withAdapter(M,k,oe=>oe.provideCodeActions(u.URI.revive(x),q,W,te),void 0,te)}$resolveCodeAction(M,x,q){return this._withAdapter(M,k,W=>W.resolveCodeAction(x,q),{},void 0)}$releaseCodeActions(M,x){this._withAdapter(M,k,q=>Promise.resolve(q.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(M,x,q){const W=this._addNewAdapter(new $(this._documents,q),M);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(x,M),M.identifier,M.displayName||M.name),this._createDisposable(W)}$provideDocumentFormattingEdits(M,x,q,W){return this._withAdapter(M,$,te=>te.provideDocumentFormattingEdits(u.URI.revive(x),q,W),void 0,W)}registerDocumentRangeFormattingEditProvider(M,x,q){const W=typeof q.provideDocumentRangesFormattingEdits=="function",te=this._addNewAdapter(new re(this._documents,q),M);return this._proxy.$registerRangeFormattingSupport(te,this._transformDocumentSelector(x,M),M.identifier,M.displayName||M.name,W),this._createDisposable(te)}$provideDocumentRangeFormattingEdits(M,x,q,W,te){return this._withAdapter(M,re,oe=>oe.provideDocumentRangeFormattingEdits(u.URI.revive(x),q,W,te),void 0,te)}$provideDocumentRangesFormattingEdits(M,x,q,W,te){return this._withAdapter(M,re,oe=>oe.provideDocumentRangesFormattingEdits(u.URI.revive(x),q,W,te),void 0,te)}registerOnTypeFormattingEditProvider(M,x,q,W){const te=this._addNewAdapter(new le(this._documents,q),M);return this._proxy.$registerOnTypeFormattingSupport(te,this._transformDocumentSelector(x,M),W,M.identifier),this._createDisposable(te)}$provideOnTypeFormattingEdits(M,x,q,W,te,oe){return this._withAdapter(M,le,Ne=>Ne.provideOnTypeFormattingEdits(u.URI.revive(x),q,W,te,oe),void 0,oe)}registerWorkspaceSymbolProvider(M,x){const q=this._addNewAdapter(new _e(x,this._logService),M);return this._proxy.$registerNavigateTypeSupport(q,typeof x.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(M,x,q){return this._withAdapter(M,_e,W=>W.provideWorkspaceSymbols(x,q),{symbols:[]},q)}$resolveWorkspaceSymbol(M,x,q){return this._withAdapter(M,_e,W=>W.resolveWorkspaceSymbol(x,q),void 0,void 0)}$releaseWorkspaceSymbols(M,x){this._withAdapter(M,_e,q=>q.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(M,x,q){const W=this._addNewAdapter(new ye(this._documents,q,this._logService),M);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(x,M),ye.supportsResolving(q)),this._createDisposable(W)}$provideRenameEdits(M,x,q,W,te){return this._withAdapter(M,ye,oe=>oe.provideRenameEdits(u.URI.revive(x),q,W,te),void 0,te)}$resolveRenameLocation(M,x,q,W){return this._withAdapter(M,ye,te=>te.resolveRenameLocation(u.URI.revive(x),q,W),void 0,W)}registerNewSymbolNamesProvider(M,x,q){const W=this._addNewAdapter(new de(this._documents,q,this._logService),M);return this._proxy.$registerNewSymbolNamesProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideNewSymbolNames(M,x,q,W){return this._withAdapter(M,de,te=>te.provideNewSymbolNames(u.URI.revive(x),q,W),void 0,W)}registerDocumentSemanticTokensProvider(M,x,q,W){const te=this._addNewAdapter(new se(this._documents,q),M),oe=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(te,this._transformDocumentSelector(x,M),W,oe);let Ne=this._createDisposable(te);if(oe){const $e=q.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(oe));Ne=a.Disposable.from(Ne,$e)}return Ne}$provideDocumentSemanticTokens(M,x,q,W){return this._withAdapter(M,se,te=>te.provideDocumentSemanticTokens(u.URI.revive(x),q,W),null,W)}$releaseDocumentSemanticTokens(M,x){this._withAdapter(M,se,q=>q.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,x,q,W){const te=this._addNewAdapter(new pe(this._documents,q),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(te,this._transformDocumentSelector(x,M),W),this._createDisposable(te)}$provideDocumentRangeSemanticTokens(M,x,q,W){return this._withAdapter(M,pe,te=>te.provideDocumentRangeSemanticTokens(u.URI.revive(x),q,W),null,W)}registerCompletionItemProvider(M,x,q,W){const te=this._addNewAdapter(new ee(this._documents,this._commands.converter,q,this._apiDeprecation,M),M);return this._proxy.$registerCompletionsProvider(te,this._transformDocumentSelector(x,M),W,ee.supportsResolving(q),M.identifier),this._createDisposable(te)}$provideCompletionItems(M,x,q,W,te){return this._withAdapter(M,ee,oe=>oe.provideCompletionItems(u.URI.revive(x),q,W,te),void 0,te)}$resolveCompletionItem(M,x,q){return this._withAdapter(M,ee,W=>W.resolveCompletionItem(x,q),void 0,q)}$releaseCompletionItems(M,x){this._withAdapter(M,ee,q=>q.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(M,x,q,W){const te=new V(M,this._documents,q,this._commands.converter),oe=this._addNewAdapter(te,M);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(x,M),te.supportsHandleEvents,n.ExtensionIdentifier.toKey(M.identifier.value),W?.yieldTo?.map(Ne=>n.ExtensionIdentifier.toKey(Ne))||[]),this._createDisposable(oe)}$provideInlineCompletions(M,x,q,W,te){return this._withAdapter(M,X,oe=>oe.provideInlineCompletions(u.URI.revive(x),q,W,te),void 0,te)}$handleInlineCompletionDidShow(M,x,q,W){this._withAdapter(M,X,async te=>{te.handleDidShowCompletionItem(x,q,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,x,q,W){this._withAdapter(M,X,async te=>{te.handlePartialAccept(x,q,W)},void 0,void 0)}$freeInlineCompletionsList(M,x){this._withAdapter(M,X,async q=>{q.disposeCompletions(x)},void 0,void 0)}registerInlineEditProvider(M,x,q){const W=new ne(M,this._documents,q,this._commands.converter),te=this._addNewAdapter(W,M);return this._proxy.$registerInlineEditProvider(te,this._transformDocumentSelector(x,M),M.identifier),this._createDisposable(te)}$provideInlineEdit(M,x,q,W){return this._withAdapter(M,ne,te=>te.provideInlineEdits(u.URI.revive(x),q,W),void 0,W)}$freeInlineEdit(M,x){this._withAdapter(M,ne,async q=>{q.disposeEdit(x)},void 0,void 0)}registerSignatureHelpProvider(M,x,q,W){const te=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,oe=this._addNewAdapter(new Fe(this._documents,q),M);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(x,M),te),this._createDisposable(oe)}$provideSignatureHelp(M,x,q,W,te){return this._withAdapter(M,Fe,oe=>oe.provideSignatureHelp(u.URI.revive(x),q,W,te),void 0,te)}$releaseSignatureHelp(M,x){this._withAdapter(M,Fe,q=>q.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(M,x,q){const W=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new ke(this._documents,this._commands.converter,q,this._logService,M),M);this._proxy.$registerInlayHintsProvider(te,this._transformDocumentSelector(x,M),typeof q.resolveInlayHint=="function",W,Re._extLabel(M));let oe=this._createDisposable(te);if(W!==void 0){const Ne=q.onDidChangeInlayHints($e=>this._proxy.$emitInlayHintsEvent(W));oe=a.Disposable.from(oe,Ne)}return oe}$provideInlayHints(M,x,q,W){return this._withAdapter(M,ke,te=>te.provideInlayHints(u.URI.revive(x),q,W),void 0,W)}$resolveInlayHint(M,x,q){return this._withAdapter(M,ke,W=>W.resolveInlayHint(x,q),void 0,q)}$releaseInlayHints(M,x){this._withAdapter(M,ke,q=>q.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(M,x,q){const W=this._addNewAdapter(new we(this._documents,q),M);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(x,M),typeof q.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks(M,x,q){return this._withAdapter(M,we,W=>W.provideLinks(u.URI.revive(x),q),void 0,q,x.scheme==="output")}$resolveDocumentLink(M,x,q){return this._withAdapter(M,we,W=>W.resolveLink(x,q),void 0,void 0,!0)}$releaseDocumentLinks(M,x){this._withAdapter(M,we,q=>q.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(M,x,q){const W=this._addNewAdapter(new me(this._documents,q),M);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideDocumentColors(M,x,q){return this._withAdapter(M,me,W=>W.provideColors(u.URI.revive(x),q),[],q)}$provideColorPresentations(M,x,q,W){return this._withAdapter(M,me,te=>te.provideColorPresentations(u.URI.revive(x),q,W),void 0,W)}registerFoldingRangeProvider(M,x,q){const W=this._nextHandle(),te=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new De(new K(this._documents,q),M)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(x,M),M.identifier,te);let oe=this._createDisposable(W);if(te!==void 0){const Ne=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(te));oe=a.Disposable.from(oe,Ne)}return oe}$provideFoldingRanges(M,x,q,W){return this._withAdapter(M,K,te=>te.provideFoldingRanges(u.URI.revive(x),q,W),void 0,W)}registerSelectionRangeProvider(M,x,q){const W=this._addNewAdapter(new J(this._documents,q,this._logService),M);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideSelectionRanges(M,x,q,W){return this._withAdapter(M,J,te=>te.provideSelectionRanges(u.URI.revive(x),q,W),[],W)}registerCallHierarchyProvider(M,x,q){const W=this._addNewAdapter(new ue(this._documents,q),M);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$prepareCallHierarchy(M,x,q,W){return this._withAdapter(M,ue,te=>Promise.resolve(te.prepareSession(u.URI.revive(x),q,W)),void 0,W)}$provideCallHierarchyIncomingCalls(M,x,q,W){return this._withAdapter(M,ue,te=>te.provideCallsTo(x,q,W),void 0,W)}$provideCallHierarchyOutgoingCalls(M,x,q,W){return this._withAdapter(M,ue,te=>te.provideCallsFrom(x,q,W),void 0,W)}$releaseCallHierarchy(M,x){this._withAdapter(M,ue,q=>Promise.resolve(q.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(M,x,q){const W=this._addNewAdapter(new he(this._documents,q),M);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$prepareTypeHierarchy(M,x,q,W){return this._withAdapter(M,he,te=>Promise.resolve(te.prepareSession(u.URI.revive(x),q,W)),void 0,W)}$provideTypeHierarchySupertypes(M,x,q,W){return this._withAdapter(M,he,te=>te.provideSupertypes(x,q,W),void 0,W)}$provideTypeHierarchySubtypes(M,x,q,W){return this._withAdapter(M,he,te=>te.provideSubtypes(x,q,W),void 0,W)}$releaseTypeHierarchy(M,x){this._withAdapter(M,he,q=>Promise.resolve(q.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(M,x,q,W){const te=this._nextHandle();this._adapter.set(te,new De(new Pe(this._proxy,this._documents,q,te,M),M));const oe=(0,d.isProposedApiEnabled)(M,"dropMetadata")&&W?Pe.toInternalProviderId(M.identifier.value,W.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(te,this._transformDocumentSelector(x,M),oe,(0,d.isProposedApiEnabled)(M,"dropMetadata")?W:void 0),this._createDisposable(te)}$provideDocumentOnDropEdits(M,x,q,W,te,oe){return this._withAdapter(M,Pe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(x,u.URI.revive(q),W,te,oe)),void 0,void 0)}registerMappedEditsProvider(M,x,q){const W=this._addNewAdapter(new ge(this._documents,q),M);return this._proxy.$registerMappedEditsProvider(W,this._transformDocumentSelector(x,M)),this._createDisposable(W)}$provideMappedEdits(M,x,q,W,te){return this._withAdapter(M,ge,oe=>Promise.resolve(oe.provideMappedEdits(x,q,W,te)),null,te)}registerDocumentPasteEditProvider(M,x,q,W){const te=this._nextHandle();this._adapter.set(te,new De(new N(this._proxy,this._documents,q,te,M),M));const oe=N.toInternalProviderId(M.identifier.value,W.id);return this._proxy.$registerPasteEditProvider(te,this._transformDocumentSelector(x,M),oe,{supportsCopy:!!q.prepareDocumentPaste,supportsPaste:!!q.provideDocumentPasteEdits,copyMimeTypes:W.copyMimeTypes,pasteMimeTypes:W.pasteMimeTypes}),this._createDisposable(te)}$prepareDocumentPaste(M,x,q,W,te){return this._withAdapter(M,N,oe=>oe.prepareDocumentPaste(u.URI.revive(x),q,W,te),void 0,te)}$providePasteEdits(M,x,q,W,te,oe){return this._withAdapter(M,N,Ne=>Ne.providePasteEdits(x,u.URI.revive(q),W,te,oe),void 0,oe)}static _serializeRegExp(M){return{pattern:M.source,flags:M.flags}}static _serializeIndentationRule(M){return{decreaseIndentPattern:Re._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?Re._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?Re._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:Re._serializeRegExp(M.beforeText),afterText:M.afterText?Re._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?Re._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(Re._serializeOnEnterRule)}static _serializeAutoClosingPair(M){return{open:M.open,close:M.close,notIn:M.notIn?M.notIn.map(x=>a.SyntaxTokenType.toString(x)):void 0}}static _serializeAutoClosingPairs(M){return M.map(Re._serializeAutoClosingPair)}setLanguageConfiguration(M,x,q){const{wordPattern:W}=q;if(W&&(0,R.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(x,W):this._documents.setWordDefinitionFor(x,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const te=this._nextHandle(),oe={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?Re._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?Re._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?Re._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport,autoClosingPairs:q.autoClosingPairs?Re._serializeAutoClosingPairs(q.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(te,x,oe),this._createDisposable(te)}$setWordDefinitions(M){for(const x of M)this._documents.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.ExtHostLanguageFeatures=Re}),define(Te[260],Ae([1,0,3,8,7,32,11,6,23]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(C,u,E,p){this._documents=u,this._commands=E,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=C.getProxy(I.MainContext.MainThreadLanguages)}$acceptLanguageIds(C){this._languageIds=C}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(C,u){await this._proxy.$changeLanguage(C,u);const E=this._documents.getDocumentData(C);if(!E)throw new Error(`document '${C.toString()}' NOT found`);return E.document}async tokenAtPosition(C,u){const E=C.version,p=L.Position.from(u),s=await this._proxy.$tokensAtPosition(C.uri,p),c={type:P.StandardTokenType.Other,range:C.getWordRangeAtPosition(u)??new P.Range(u.line,u.character,u.line,u.character)};if(!s)return c;const t={range:L.Range.to(s.range),type:L.TokenType.to(s.type)};return!t.range.contains(u)||E!==C.version?c:t}createLanguageStatusItem(C,u,E){const p=this._handlePool++,s=this._proxy,c=this._ids,t=`${C.identifier.value}/${u}`;if(c.has(t))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);c.add(t);const n={selector:E,id:u,name:C.displayName??C.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const a=new m.DisposableStore,d=()=>{if(r?.dispose(),!c.has(t)){console.warn(`LanguageStatusItem (${u}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,T.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(p,{id:t,name:n.name??C.displayName??C.name,source:C.displayName??C.name,selector:L.DocumentSelector.from(n.selector,this._uriTransformer),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?O.default.Error:n.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:n.command&&this._commands.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){a.dispose(),r?.dispose(),s.$removeLanguageStatus(p),c.delete(t)},get id(){return n.id},get name(){return n.name},set name(v){n.name=v,d()},get selector(){return n.selector},set selector(v){n.selector=v,d()},get text(){return n.text},set text(v){n.text=v,d()},set text2(v){(0,f.checkProposedApiEnabled)(C,"languageStatusText"),n.text=v,d()},get text2(){return(0,f.checkProposedApiEnabled)(C,"languageStatusText"),n.text},get detail(){return n.detail},set detail(v){n.detail=v,d()},get severity(){return n.severity},set severity(v){n.severity=v,d()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(v){n.accessibilityInformation=v,d()},get command(){return n.command},set command(v){n.command=v,d()},get busy(){return n.busy},set busy(v){n.busy=v,d()}};return d(),i}}e.ExtHostLanguages=y}),define(Te[261],Ae([1,0,12,2,8,7,83]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class m{constructor(C,u,E,p){this.start=C,this.deletedCount=u,this.deletedItems=E,this.items=p}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,u,E){this.notebook=C,this._extHostDocument=u,this._cellData=E,this.handle=E.handle,this.uri=L.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(P.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const C=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:P.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return C._mime},set mime(p){C._mime=p},get outputs(){return C._outputs.slice(0)},get metadata(){return C._metadata},get executionSummary(){return C._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(C){this._outputs=C.map(P.NotebookCellOutput.to)}setOutputItems(C,u,E){const p=E.map(P.NotebookCellOutputItem.to),s=this._outputs.find(c=>c.id===C);if(s&&(u||(s.items.length=0),s.items.push(...p),s.items.length>1&&s.items.every(c=>T.isTextStreamMime(c.mime)))){const c=new Map,t=[];s.items.forEach(n=>{let r;c.has(n.mime)?r=c.get(n.mime):(r=[],c.set(n.mime,r),t.push(n.mime)),r.push(n.data)}),s.items.length=0,t.forEach(n=>{const r=T.compressOutputItemStreams(c.get(n));s.items.push({mime:n,data:r.data.buffer})})}}setMetadata(C){this._metadata=Object.freeze(C)}setInternalMetadata(C){this._internalMetadata=C,this._previousResult=Object.freeze(P.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.ExtHostCell=f;class y{static{this._handlePool=0}constructor(C,u,E,p,s){this._proxy=C,this._textDocumentsAndEditors=u,this._textDocuments=E,this.uri=p,this.handle=y._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=s.viewType,this._metadata=Object.freeze(s.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,s.cells]],!0,void 0),this._versionId=s.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const C=this,u={get uri(){return C.uri},get version(){return C._versionId},get notebookType(){return C._notebookType},get isDirty(){return C._isDirty},get isUntitled(){return C.uri.scheme===I.Schemas.untitled},get isClosed(){return C._disposed},get metadata(){return C._metadata},get cellCount(){return C._cells.length},cellAt(E){return E=C._validateIndex(E),C._cells[E].apiCell},getCells(E){return(E?C._getCells(E):C._cells).map(s=>s.apiCell)},save(){return C._save()}};this._notebook=Object.freeze(u)}return this._notebook}acceptDocumentPropertiesChanged(C){C.metadata&&(this._metadata=Object.freeze({...this._metadata,...C.metadata}))}acceptDirty(C){this._isDirty=C}acceptModelChanged(C,u,E){this._versionId=C.versionId,this._isDirty=u,this.acceptDocumentPropertiesChanged({metadata:E});const p={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},s=[];for(const t of C.rawEvents)t.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(t.changes,!1,p.contentChanges):t.kind===T.NotebookCellsChangeType.Move?this._moveCells(t.index,t.length,t.newIdx,p.contentChanges):t.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(t.index,t.outputs),s.push({cell:this._cells[t.index].apiCell,outputs:this._cells[t.index].apiCell.outputs})):t.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(t.index,t.outputId,t.append,t.outputItems),s.push({cell:this._cells[t.index].apiCell,outputs:this._cells[t.index].apiCell.outputs})):t.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(t.index,t.language),s.push({cell:this._cells[t.index].apiCell,document:this._cells[t.index].apiCell.document})):t.kind===T.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this._cells[t.index].apiCell,document:this._cells[t.index].apiCell.document}):t.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(t.index,t.mime):t.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(t.index,t.metadata),s.push({cell:this._cells[t.index].apiCell,metadata:this._cells[t.index].apiCell.metadata})):t.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(t.index,t.internalMetadata),s.push({cell:this._cells[t.index].apiCell,executionSummary:this._cells[t.index].apiCell.executionSummary}));const c=new Map;for(let t=0;t<s.length;t++){const n=s[t],r=c.get(n.cell);if(r===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});c.set(n.cell,a-1)}else p.cellChanges[r]={...p.cellChanges[r],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(C){return C=C|0,C<0?0:C>=this._cells.length?this._cells.length-1:C}_validateRange(C){let u=C.start|0,E=C.end|0;return u<0&&(u=0),E>this._cells.length&&(E=this._cells.length),C.with({start:u,end:E})}_getCells(C){C=this._validateRange(C);const u=[];for(let E=C.start;E<C.end;E++)u.push(this._cells[E]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(C,u,E){if(this._disposed)return;const p=[],s=[],c=[];if(C.reverse().forEach(t=>{const r=t[2].map(i=>{const v=new f(this,this._textDocumentsAndEditors,i);return u||s.push(f.asModelAddData(i)),v}),a=new m(t[0],t[1],[],r),d=this._cells.splice(t[0],t[1],...r);for(const i of d)c.push(i.uri),a.deletedItems.push(i.apiCell);p.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:c}),E)for(const t of p)E.push(t.asApiEvent())}_moveCells(C,u,E,p){const s=this._cells.splice(C,u);this._cells.splice(E,0,...s);const c=[new m(C,u,s.map(t=>t.apiCell),[]),new m(E,0,[],s)];for(const t of c)p.push(t.asApiEvent())}_setCellOutputs(C,u){this._cells[C].setOutputs(u)}_setCellOutputItems(C,u,E,p){this._cells[C].setOutputItems(u,E,p)}_changeCellLanguage(C,u){const E=this._cells[C];E.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelLanguageChanged(E.uri,u)}_changeCellMime(C,u){const E=this._cells[C];E.apiCell.mime=u}_changeCellMetadata(C,u){this._cells[C].setMetadata(u)}_changeCellInternalMetadata(C,u){this._cells[C].setInternalMetadata(u)}getCellFromApiCell(C){return this._cells.find(u=>u.apiCell===C)}getCellFromIndex(C){return this._cells[C]}getCell(C){return this._cells.find(u=>u.handle===C)}getCellIndex(C){return this._cells.indexOf(C)}}e.ExtHostNotebookDocument=y}),define(Te[262],Ae([1,0,5,2,8,7]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(f,y,R,C={timeout:1500,errors:3}){this._logService=f,this._notebooksAndEditors=y,this._mainThreadBulkEdits=R,this._thresholds=C,this._onWillSaveNotebookDocumentEvent=new I.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(y,R,C)=>{const u=function(p){y.call(R,p)};return u.extension=f,this._onWillSaveNotebookDocumentEvent.event(u,void 0,C)}}async $participateInSave(f,y,R){const C=L.URI.revive(f),u=this._notebooksAndEditors.getNotebookDocument(C);if(!u)throw new Error("Unable to resolve notebook document");const E=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:u.apiNotebook,reason:P.TextDocumentSaveReason.to(y)},R,async(s,c)=>{const t=Date.now(),n=await await Promise.resolve(s);Date.now()-t>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof O.WorkspaceEdit?E.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(E.length===0)return!0;const p={edits:[]};for(const s of E){const{edits:c}=P.WorkspaceEdit.from(s);p.edits=p.edits.concat(c)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Te[110],Ae([1,0,15,8,7]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,y,R,C,u){this.id=m,this._proxy=f,this.notebookData=y,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=C,this._visibleRanges=R,this._viewColumn=u}get apiEditor(){if(!this._editor){const m=this;this._editor={get notebook(){return m.notebookData.apiNotebook},get selection(){return m._selections[0]},set selection(f){this.selections=[f]},get selections(){return m._selections},set selections(f){if(!Array.isArray(f)||!f.every(P.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");m._selections=f,m._trySetSelections(f)},get visibleRanges(){return m._visibleRanges},revealRange(f,y){m._proxy.$tryRevealRange(m.id,L.NotebookRange.from(f),y??P.NotebookEditorRevealType.Default)},get viewColumn(){return m._viewColumn}},O.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(m){this._visible=m}_acceptVisibleRanges(m){this._visibleRanges=m}_acceptSelections(m){this._selections=m}_trySetSelections(m){this._proxy.$trySetSelections(this.id,m.map(L.NotebookRange.from))}_acceptViewColumn(m){this._viewColumn=m}}e.ExtHostNotebookEditor=O}),define(Te[263],Ae([1,0,5,14,8]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let O=class{constructor(m,f){this._logService=m,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new I.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(m,f){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const y=this._notebooksAndEditors.getEditorById(m);f.visibleRanges&&y._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&y._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),f.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this._notebooksAndEditors.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(m[f]))}};e.ExtHostNotebookEditors=O,e.ExtHostNotebookEditors=O=Ge([Ve(0,L.ILogService)],O)}),define(Te[264],Ae([1,0,5,3,110]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(m,f){this._extHostNotebook=f,this._rendererMessageEmitters=new Map,this.proxy=m.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(m,f,y){const R=this._extHostNotebook.getEditorById(m);this._rendererMessageEmitters.get(f)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(R=>R.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(R,C,u)=>this.getOrCreateEmitterFor(f).event(R,C,u),postMessage:(R,C)=>{P.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const u=C&&P.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);return this.proxy.$postMessage(u?.id,f,R)}}}getOrCreateEmitterFor(m){let f=this._rendererMessageEmitters.get(m);return f||(f=new I.Emitter({onDidRemoveLastListener:()=>{f?.dispose(),this._rendererMessageEmitters.delete(m)}}),this._rendererMessageEmitters.set(m,f),f)}}e.ExtHostNotebookRenderers=O}),define(Te[265],Ae([1,0,8,99,22,68,15]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class m{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}async withProgress(C,u,E){const p=this._handles++,{title:s,location:c,cancellable:t}=u,n={label:C.displayName||C.name,id:C.identifier.value};return this._proxy.$startProgress(p,{location:I.ProgressLocation.from(c),title:s,source:n,cancellable:t},C.isUnderDevelopment?void 0:C.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(p,E,!!t)}_withProgress(C,u,E){let p;E&&(p=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,p));const s=t=>{this._proxy.$progressEnd(t),this._mapHandleToCancellationSource.delete(t),p?.dispose()};let c;try{c=u(new y(this._proxy,C),E&&p?p.token:P.CancellationToken.None)}catch(t){throw s(C),t}return c.then(t=>s(C),t=>s(C)),c}$acceptProgressCanceled(C){const u=this._mapHandleToCancellationSource.get(C);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=m;function f(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class y extends L.Progress{constructor(C,u){super(E=>this.throttledReport(E)),this._proxy=C,this._handle=u}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}Ge([(0,O.throttle)(100,(R,C)=>f(R,C),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(Te[266],Ae([1,0,2,3,11,8]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(f,y){this.uriTransformer=y,this.providers=new Map,this.proxy=f.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(f,y,R){const C=I.URI.revive(y),u=this.providers.get(f);return u?(0,P.asPromise)(()=>u.provideOriginalResource(C,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(f,y,R,C){const u=T.handlePool++;return this.providers.set(u,y),this.proxy.$registerQuickDiffProvider(u,O.DocumentSelector.from(f,this.uriTransformer),R,C),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(u),this.providers.delete(u)}}}}e.ExtHostQuickDiff=T}),define(Te[267],Ae([1,0,22,5,6,3,2,7,15,18,32,41,23,8]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(s,c,t){const n=s.getProxy(O.MainContext.MainThreadQuickOpen);class r{constructor(g,D){this._sessions=new Map,this._instances=0,this._workspace=g,this._commands=D}showQuickPick(g,D,h,_=I.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(D),A=++this._instances,F=n.$show(A,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},_),j={},H=F.then(()=>j);return Promise.race([H,b]).then(B=>{if(B===j)return;const k=(0,u.isProposedApiEnabled)(g,"quickPickItemTooltip");return b.then(N=>{const $=[];for(let re=0;re<N.length;re++){const le=N[re];if(typeof le=="string")$.push({label:le,handle:re});else if(le.kind===m.QuickPickItemKind.Separator)$.push({type:"separator",label:le.label});else{le.tooltip&&!k&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const _e=le.iconPath?l(le.iconPath):void 0;$.push({label:le.label,iconPath:_e?.iconPath,iconClass:_e?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:k?E.MarkdownString.fromStrict(le.tooltip):void 0,handle:re})}}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=re=>{h.onDidSelectItem(N[re])}),n.$setItems(A,$),F.then(re=>{if(typeof re=="number")return N[re];if(Array.isArray(re))return re.map(le=>N[le])})})}).then(void 0,B=>{if(!(0,f.isCancellationError)(B))return n.$setError(A,B),Promise.reject(B)})}$onItemSelected(g){this._onDidSelectItem?.(g)}showInput(g,D=I.CancellationToken.None){return this._validateInput=g?.validateInput,n.$input(g,typeof this._validateInput=="function",D).then(void 0,h=>{if(!(0,f.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(g){if(!this._validateInput)return;const D=await this._validateInput(g);if(!D||typeof D=="string")return D;let h;switch(D.severity){case m.InputBoxValidationSeverity.Info:h=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:h=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:h=R.default.Error;break;default:h=D.message?R.default.Error:R.default.Ignore;break}return{content:D.message,severity:h}}async showWorkspaceFolderPick(g,D=I.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!h)return;const _=await this._workspace.getWorkspaceFolders2();if(_)return _.find(b=>b.uri.toString()===h.uri.toString())}createQuickPick(g){const D=new o(g,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(g){const D=new S(g,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}$onDidChangeValue(g,D){this._sessions.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this._sessions.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const h=this._sessions.get(g);h instanceof o&&h._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const h=this._sessions.get(g);h instanceof o&&h._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this._sessions.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,h){const _=this._sessions.get(g);_ instanceof o&&_._fireDidTriggerItemButton(D,h)}$onDidHide(g){this._sessions.get(g)?._fireDidHide()}}class a{static{this._nextId=1}constructor(g,D){this._extensionId=g,this._onDidDispose=D,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new L.Emitter,this._onDidChangeValueEmitter=new L.Emitter,this._onDidTriggerButtonEmitter=new L.Emitter,this._onDidHideEmitter=new L.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(g){this._title=g,this.update({title:g})}get step(){return this._steps}set step(g){this._steps=g,this.update({step:g})}get totalSteps(){return this._totalSteps}set totalSteps(g){this._totalSteps=g,this.update({totalSteps:g})}get enabled(){return this._enabled}set enabled(g){this._enabled=g,this.update({enabled:g})}get busy(){return this._busy}set busy(g){this._busy=g,this.update({busy:g})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(g){this._ignoreFocusOut=g,this.update({ignoreFocusOut:g})}get value(){return this._value}set value(g){this._value=g,this.update({value:g})}get placeholder(){return this._placeholder}set placeholder(g){this._placeholder=g,this.update({placeholder:g})}get buttons(){return this._buttons}set buttons(g){this._buttons=g.slice(),this._handlesToButtons.clear(),g.forEach((D,h)=>{const _=D===m.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(_,D)}),this.update({buttons:g.map((D,h)=>({...l(D.iconPath),tooltip:D.tooltip,handle:D===m.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(g){this._value=g,this._onDidChangeValueEmitter.fire(g)}_fireDidTriggerButton(g){const D=this._handlesToButtons.get(g);D&&this._onDidTriggerButtonEmitter.fire(D)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),n.$dispose(this._id))}update(g){if(!this._disposed){for(const D of Object.keys(g)){const h=g[D];this._pendingUpdate[D]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){n.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function d(w){if(w instanceof m.ThemeIcon)return{id:w.id};const g=v(w),D=i(w);return{dark:typeof g=="string"?T.URI.file(g):g,light:typeof D=="string"?T.URI.file(D):D}}function i(w){return typeof w=="object"&&"light"in w?w.light:w}function v(w){return typeof w=="object"&&"dark"in w?w.dark:w}function l(w){const g=d(w);let D,h;return"id"in g?h=C.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:h}}class o extends a{constructor(g,D){super(g.identifier,D),this.extension=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new L.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new L.Emitter,this._onDidTriggerItemButtonEmitter=new L.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(g){this._items=g.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),g.forEach((_,b)=>{this._handlesToItems.set(b,_),this._itemsToHandles.set(_,b)});const D=(0,u.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),h=[];for(let _=0;_<g.length;_++){const b=g[_];if(b.kind===m.QuickPickItemKind.Separator)h.push({type:"separator",label:b.label});else{b.tooltip&&!D&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const A=b.iconPath?l(b.iconPath):void 0;h.push({handle:_,label:b.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((F,j)=>({...l(F.iconPath),tooltip:F.tooltip,handle:j}))})}}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(g){this._canSelectMany=g,this.update({canSelectMany:g})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(g){this._matchOnDescription=g,this.update({matchOnDescription:g})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(g){this._matchOnDetail=g,this.update({matchOnDetail:g})}get sortByLabel(){return this._sortByLabel}set sortByLabel(g){this._sortByLabel=g,this.update({sortByLabel:g})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(g){this._keepScrollPosition=g,this.update({keepScrollPosition:g})}get activeItems(){return this._activeItems}set activeItems(g){this._activeItems=g.filter(D=>this._itemsToHandles.has(D)),this.update({activeItems:this._activeItems.map(D=>this._itemsToHandles.get(D))})}get selectedItems(){return this._selectedItems}set selectedItems(g){this._selectedItems=g.filter(D=>this._itemsToHandles.has(D)),this.update({selectedItems:this._selectedItems.map(D=>this._itemsToHandles.get(D))})}_fireDidChangeActive(g){const D=(0,y.coalesce)(g.map(h=>this._handlesToItems.get(h)));this._activeItems=D,this._onDidChangeActiveEmitter.fire(D)}_fireDidChangeSelection(g){const D=(0,y.coalesce)(g.map(h=>this._handlesToItems.get(h)));this._selectedItems=D,this._onDidChangeSelectionEmitter.fire(D)}_fireDidTriggerItemButton(g,D){const h=this._handlesToItems.get(g);if(!h||!h.buttons||!h.buttons.length)return;const _=h.buttons[D];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:h})}}class S extends a{constructor(g,D){super(g.identifier,D),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(g){this._password=g,this.update({password:g})}get prompt(){return this._prompt}set prompt(g){this._prompt=g,this.update({prompt:g})}get valueSelection(){return this._valueSelection}set valueSelection(g){this._valueSelection=g,this.update({valueSelection:g})}get validationMessage(){return this._validationMessage}set validationMessage(g){this._validationMessage=g,g?typeof g=="string"?this.update({validationMessage:g,severity:R.default.Error}):this.update({validationMessage:g.message,severity:g.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new r(c,t)}e.createExtHostQuickOpen=p}),define(Te[268],Ae([1,0,2,5,68,6,11,3,18,139,14,20,41,8,23,12,21]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(A){return A instanceof I.URI}function r(A,F){return A.scheme===s.Schemas.file&&F.scheme===s.Schemas.file&&c.isLinux?A.toString()===F.toString():A.toString().toLowerCase()===F.toString().toLowerCase()}function a(A){if(A)return typeof A.iconPath=="string"?I.URI.file(A.iconPath):I.URI.isUri(A.iconPath)||u.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function d(A){if(A.icon){if(I.URI.isUri(A.icon))return A.icon;if(u.ThemeIcon.isThemeIcon(A.icon))return A.icon;{const F=A.icon;return{light:F.light,dark:F.dark}}}else return}function i(A,F){if(!A.iconPath&&!F.iconPath)return 0;if(A.iconPath){if(!F.iconPath)return 1}else return-1;const j=typeof A.iconPath=="string"?A.iconPath:I.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,H=typeof F.iconPath=="string"?F.iconPath:I.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,y.comparePaths)(j,H)}function v(A,F){let j=0;if(A.strikeThrough!==F.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==F.faded)return A.faded?1:-1;if(A.tooltip!==F.tooltip)return(A.tooltip||"").localeCompare(F.tooltip||"");if(j=i(A,F),j!==0)return j;if(A.light&&F.light)j=i(A.light,F.light);else{if(A.light)return 1;if(F.light)return-1}if(j!==0)return j;if(A.dark&&F.dark)j=i(A.dark,F.dark);else{if(A.dark)return 1;if(F.dark)return-1}return j}function l(A,F){if(A.command!==F.command)return A.command<F.command?-1:1;if(A.title!==F.title)return A.title<F.title?-1:1;if(A.tooltip!==F.tooltip){if(A.tooltip!==void 0&&F.tooltip!==void 0)return A.tooltip<F.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(A.arguments===F.arguments)return 0;if(A.arguments)if(F.arguments){if(A.arguments.length!==F.arguments.length)return A.arguments.length-F.arguments.length}else return 1;else return-1;for(let j=0;j<A.arguments.length;j++){const H=A.arguments[j],B=F.arguments[j];if(H!==B&&!(n(H)&&n(B)&&r(H,B)))return H<B?-1:1}return 0}function o(A,F){let j=(0,y.comparePaths)(A.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(j!==0)return j;if(A.command&&F.command)j=l(A.command,F.command);else{if(A.command)return 1;if(F.command)return-1}if(j!==0)return j;if(A.decorations&&F.decorations)j=v(A.decorations,F.decorations);else{if(A.decorations)return 1;if(F.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)j=(0,y.comparePaths)(A.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)j=(0,y.comparePaths)(A.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return j}function S(A,F){for(let j=0;j<A.length;j++)if(A[j]!==F[j])return!1;return!0}function w(A,F){return A.command===F.command&&A.title===F.title&&A.tooltip===F.tooltip&&(A.arguments&&F.arguments?S(A.arguments,F.arguments):A.arguments===F.arguments)}function g(A,F){return(0,f.equals)(A,F,w)}class D{#e;#t;get value(){return this._value}set value(F){F=F??"",this.#e.$setInputBoxValue(this._sourceControlHandle,F),this.updateValue(F)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(F){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,F),this._placeholder=F}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(F){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=F,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!F)}get enabled(){return this._enabled}set enabled(F){F=!!F,this._enabled!==F&&(this._enabled=F,this.#e.$setInputBoxEnablement(this._sourceControlHandle,F))}get visible(){return this._visible}set visible(F){F=!!F,this._visible!==F&&(this._visible=F,this.#e.$setInputBoxVisibility(this._sourceControlHandle,F))}get document(){return(0,p.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(F,j,H,B,k){this._extension=F,this._sourceControlHandle=B,this._documentUri=k,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=j,this.#e=H}showValidationMessage(F,j){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,F,j)}$onInputBoxValueChange(F){this.updateValue(F)}updateValue(F){this._value=F,this._onDidChange.fire(F)}}e.ExtHostSCMInputBox=D;class h{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(F){this._label=F,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,F)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(F){this._hideWhenEmpty=F,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(F){this._resourceStates=[...F],this._onDidUpdateResourceStates.fire()}constructor(F,j,H,B,k,N,$){this._proxy=F,this._commands=j,this._sourceControlHandle=H,this._id=B,this._label=k,this.multiDiffEditorEnableViewChanges=N,this._extension=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}getResourceState(F){return this._resourceStatesMap.get(F)}$executeResourceCommand(F,j){const H=this._resourceStatesCommandsMap.get(F);return H?(0,T.asPromise)(()=>this._commands.executeCommand(H.command,...H.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this._resourceStates].sort(o),H=(0,f.sortedDiff)(this._resourceSnapshot,F,o).map(N=>{const $=N.toInsert.map(re=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,re);const _e=re.resourceUri;let ye;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const me=new O.DisposableStore;ye=this._commands.converter.toInternal(re.command,me),this._resourceStatesDisposablesMap.set(le,me)}else this._resourceStatesCommandsMap.set(le,re.command);const de=(0,p.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),Ee=de?re.multiDiffEditorOriginalUri:void 0,se=de?re.multiFileDiffEditorModifiedUri:void 0,pe=a(re.decorations),ee=re.decorations&&a(re.decorations.light)||pe,X=re.decorations&&a(re.decorations.dark)||pe,V=[ee,X],ne=re.decorations&&re.decorations.tooltip||"",Ie=re.decorations&&!!re.decorations.strikeThrough,Fe=re.decorations&&!!re.decorations.faded,ke=re.contextValue||"";return{rawResource:[le,_e,V,ne,Ie,Fe,ke,ye,Ee,se],handle:le}});return{start:N.start,deleteCount:N.deleteCount,toInsert:$}}),B=H.map(({start:N,deleteCount:$,toInsert:re})=>[N,$,re.map(le=>le.rawResource)]),k=H.reverse();for(const{start:N,deleteCount:$,toInsert:re}of k){const le=re.map(ye=>ye.handle),_e=this._handlesSnapshot.splice(N,$,...le);for(const ye of _e)this._resourceStatesMap.delete(ye),this._resourceStatesCommandsMap.delete(ye),this._resourceStatesDisposablesMap.get(ye)?.dispose(),this._resourceStatesDisposablesMap.delete(ye)}return this._resourceSnapshot=F,B}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class _{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(F){this._count!==F&&(this._count=F,this.#e.$updateSourceControl(this.handle,{count:F}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(F){this._quickDiffProvider=F;let j;(0,p.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(j=F?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!F,quickDiffLabel:j})}get historyProvider(){return(0,p.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(F){(0,p.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=F,this._historyProviderDisposable.value=new O.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!F}),F&&this._historyProviderDisposable.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(F){F!==this._commitTemplate&&(this._commitTemplate=F,this.#e.$updateSourceControl(this.handle,{commitTemplate:F}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(F){this._acceptInputDisposables.value=new O.DisposableStore,this._acceptInputCommand=F;const j=this._commands.converter.toInternal(F,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:j})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(F){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new O.DisposableStore,this._actionButton=F;const j=F!==void 0?{command:this._commands.converter.toInternal(F.command,this._actionButtonDisposables.value),secondaryCommands:F.secondaryCommands?.map(H=>H.map(B=>this._commands.converter.toInternal(B,this._actionButtonDisposables.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:j??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(F){if(this._statusBarCommands&&F&&g(this._statusBarCommands,F))return;this._statusBarDisposables.value=new O.DisposableStore,this._statusBarCommands=F;const j=(F||[]).map(H=>this._commands.converter.toInternal(H,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:j})}get selected(){return this._selected}constructor(F,j,H,B,k,N,$){this._extension=F,this._commands=B,this._id=k,this._label=N,this._rootUri=$,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new O.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new O.MutableDisposable,this._statusBarDisposables=new O.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=_._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=H;const re=I.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${k}/scm${this.handle}/input`,query:$?`rootUri=${encodeURIComponent($.toString())}`:void 0});this._inputBox=new D(F,j,this.#e,this.handle,re),this.#e.$registerSourceControl(this.handle,k,N,$,re)}createResourceGroup(F,j,H){const B=(0,p.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&H?.multiDiffEditorEnableViewChanges===!0,k=new h(this.#e,this._commands,this.handle,F,j,B,this._extension),N=L.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,N),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const F=[],j=[];for(const[H,B]of this.createdResourceGroups){B.dispose();const k=H.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(H),this.eventuallyUpdateResourceStates()});L.Event.once(H.onDidDispose)(()=>{this.updatedResourceGroups.delete(H),k.dispose(),this._groups.delete(H.handle),this.#e.$unregisterGroup(this.handle,H.handle)}),F.push([H.handle,H.id,H.label,H.features,H.multiDiffEditorEnableViewChanges]);const N=H._takeResourceStateSnapshot();N.length>0&&j.push([H.handle,N]),this._groups.set(H.handle,H)}this.#e.$registerGroups(this.handle,F,j),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const F=[];this.updatedResourceGroups.forEach(j=>{const H=j._takeResourceStateSnapshot();H.length!==0&&F.push([j.handle,H])}),F.length>0&&this.#e.$spliceResourceStates(this.handle,F),this.updatedResourceGroups.clear()}getResourceGroup(F){return this._groups.get(F)}setSelectionState(F){this._selected=F,this._onDidChangeSelection.fire(F)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ge([(0,P.debounce)(100)],_.prototype,"eventuallyAddResourceGroups",null),Ge([(0,P.debounce)(100)],_.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{t=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(F,j,H,B){this._commands=j,this._extHostDocuments=H,this.logService=B,this._sourceControls=new Map,this._sourceControlsByExtension=new C.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=F.getProxy(m.MainContext.MainThreadSCM),this._telemetry=F.getProxy(m.MainContext.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const N=this._sourceControls.get(k.sourceControlHandle);if(!N)return k;const $=N.getResourceGroup(k.groupHandle);return $?$.getResourceState(k.handle):k}else if(k&&k.$mid===4){const N=this._sourceControls.get(k.sourceControlHandle);return N?N.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const N=this._sourceControls.get(k.handle);return N||k}return k}})}createSourceControl(F,j,H,B){this.logService.trace("ExtHostSCM#createSourceControl",F.identifier.value,j,H,B),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const k=t._handlePool++,N=new _(F,this._extHostDocuments,this._proxy,this._commands,j,H,B);this._sourceControls.set(k,N);const $=this._sourceControlsByExtension.get(F.identifier)||[];return $.push(N),this._sourceControlsByExtension.set(F.identifier,$),N}getLastInputBox(F){this.logService.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const j=this._sourceControlsByExtension.get(F.identifier),H=j&&j[j.length-1];return H&&H.inputBox}$provideOriginalResource(F,j,H){const B=I.URI.revive(j);this.logService.trace("ExtHostSCM#$provideOriginalResource",F,B.toString());const k=this._sourceControls.get(F);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(B,H)).then(N=>N||null)}$onInputBoxValueChange(F,j){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",F);const H=this._sourceControls.get(F);return H&&H.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(F,j,H,B){this.logService.trace("ExtHostSCM#$executeResourceCommand",F,j,H);const k=this._sourceControls.get(F);if(!k)return Promise.resolve(void 0);const N=k.getResourceGroup(j);return N?N.$executeResourceCommand(H,B):Promise.resolve(void 0)}$validateInput(F,j,H){this.logService.trace("ExtHostSCM#$validateInput",F);const B=this._sourceControls.get(F);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>B.inputBox.validateInput(j,H)).then(k=>{if(!k)return Promise.resolve(void 0);const N=E.MarkdownString.fromStrict(k.message);return N?Promise.resolve([N,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this._sourceControls.get(F)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,j,H,B){return await this._sourceControls.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,H,B)??void 0}async $provideHistoryItems(F,j,H,B){return(await this._sourceControls.get(F)?.historyProvider?.provideHistoryItems(j,H,B))?.map($=>({...$,icon:d($)}))??void 0}async $provideHistoryItemSummary(F,j,H,B){const k=this._sourceControls.get(F)?.historyProvider;if(typeof k?.provideHistoryItemSummary!="function")return;const N=await k.provideHistoryItemSummary(j,H,B);return N?{...N,icon:d(N)}:void 0}async $provideHistoryItemChanges(F,j,H,B){return await this._sourceControls.get(F)?.historyProvider?.provideHistoryItemChanges(j,H,B)??void 0}};e.ExtHostSCM=b,e.ExtHostSCM=b=t=Ge([Ve(3,R.ILogService)],b)}),define(Te[269],Ae([1,0,3,8,2]),function(fe,e,I,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{static{this.handlePool=0}constructor(m,f){this.uriTransformer=f,this.providers=new Map,this.proxy=m.getProxy(I.MainContext.MainThreadShare)}async $provideShare(m,f,y){return await this.providers.get(m)?.provideShare({selection:L.Range.to(f.selection),resourceUri:P.URI.revive(f.resourceUri)},y)??void 0}registerShareProvider(m,f){const y=O.handlePool++;return this.providers.set(y,f),this.proxy.$registerShareProvider(y,L.DocumentSelector.from(m,this.uriTransformer),f.id,f.label,f.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(y),this.providers.delete(y)}}}}e.ExtHostShare=O}),define(Te[270],Ae([1,0,7,3,165,6,8,16]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class f{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new I.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,p,s,c,t=I.StatusBarAlignment.Left,n){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new O.DisposableStore,this.#e=u,this.#t=E,c&&s){this._entryId=(0,I.asStatusBarItemIdentifier)(s.identifier,c);const r=p.get(this._entryId);r&&(t=r.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=r.priority,this._visible=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this._entryId=String(f.ID_GEN++);this._extension=s,this._id=c,this._alignment=t,this._priority=this.validatePriority(n)}validatePriority(u){if((0,m.isNumber)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!f.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new O.DisposableStore,typeof u=="string"?this._command={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this._latestCommandRegistration)}:u?this._command={fromApi:u,internal:this.#t.toInternal(u,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let E;this._name?E=this._name:E=(0,P.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=f.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const s=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,u,this._extension?.identifier.value,E,this._text,s,this._command?.internal,p,this._backgroundColor,this._alignment===I.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=f;class y{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,P.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const E={message:u};return this._messages.unshift(E),this._update(),new I.Disposable(()=>{const p=this._messages.indexOf(E);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(u,E){this._existingItems=new Map,this._proxy=u.getProxy(L.MainContext.MainThreadStatusBar),this._commands=E,this._statusMessage=new y(this)}$acceptStaticEntries(u){for(const E of u)this._existingItems.set(E.entryId,E)}createStatusBarEntry(u,E,p,s){return new f(this._proxy,this._commands,this._existingItems,u,E,p,s)}setStatusBarMessage(u,E){const p=this._statusMessage.setMessage(u);let s;return typeof E=="number"?s=setTimeout(()=>p.dispose(),E):typeof E<"u"&&E.then(()=>p.dispose(),()=>p.dispose()),new I.Disposable(()=>{p.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=R}),define(Te[111],Ae([1,0,29,103,48,75,60,8,2]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(r,a,d,i)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(l){if(!d(v,l)){const o=v;v=l,r.listener?.(i(l,o))}}}},R=(r,a)=>r===a,C={range:(r,a)=>r===a?!0:!r||!a?!1:r.isEqual(a),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,a)=>!(r.length!==a.length||r.some(d=>!a.find(i=>d.id===i.id)))},u=r=>a=>({op:4,update:r(a)}),E=(r,a)=>({range:(()=>{let d;const i=u(v=>({range:I.Range.lift(m.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return d},set(v){r.listener?.({op:6}),C.range(d,v)||(d=v,r.listener?.(i(v)))}}})(),label:y(r,a,C.label,u(d=>({label:d}))),description:y(r,void 0,C.description,u(d=>({description:d}))),sortText:y(r,void 0,C.sortText,u(d=>({sortText:d}))),canResolveChildren:y(r,!1,C.canResolveChildren,d=>({op:2,state:d})),busy:y(r,!1,C.busy,u(d=>({busy:d}))),error:y(r,void 0,C.error,u(d=>({error:m.MarkdownString.fromStrict(d)||null}))),tags:y(r,[],C.tags,(d,i)=>({op:1,new:d.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),p=r=>{const a=P.TestId.fromString(r.extId),d=new c(a.controllerId,a.localId,r.label,f.URI.revive(r.uri)||void 0);return d.range=m.Range.to(r.range||void 0),d.description=r.description||void 0,d.sortText=r.sortText||void 0,d.tags=r.tags.map(i=>m.TestTag.to({id:(0,T.denamespaceTestTag)(i).tagId})),d},s=r=>{let a;for(const d of r.tests){const i=p(d.item);(0,L.getPrivateApiFor)(i).parent=a,a=i}return a};e.toItemFromContext=s;class c{constructor(a,d,i,v){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const l=(0,L.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof t?void 0:l.parent}},children:{value:(0,O.createTestItemChildren)(l,L.getPrivateApiFor,c),enumerable:!0,writable:!1},...E(l,i)})}}e.TestItemImpl=c;class t extends c{constructor(a,d){super(a,a,d,void 0),this._isRoot=!0}}e.TestItemRootImpl=t;class n extends O.TestItemCollection{constructor(a,d,i){super({controllerId:a,getDocumentVersion:v=>v&&i.getDocument(v)?.version,getApiFor:L.getPrivateApiFor,getChildren:v=>v.children,root:new t(a,d),toITestItem:m.TestItem.from})}}e.ExtHostTestItemCollection=n}),define(Te[31],Ae([1,0,16,7,8,26,3,18,14,52,29,91,2,6,4,17,111,24,49,34,64,58,61,33]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{#e;#t;#i;constructor(h,_,b){this._commands=new Map,this._apiCommands=new Map,this.#e=h.getProxy(T.MainContext.MainThreadCommands),this._logService=_,this.#i=b,this.#t=h.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new o(this,A=>{const F=this._apiCommands.get(A);return F?.result===w.Void?F:void 0},_),this._argumentProcessors=[{processArgument(A){return(0,y.revive)(A)}},{processArgument(A){return(0,O.cloneAndChange)(A,function(F){if(R.Range.isIRange(F))return P.Range.to(F);if(C.Position.isIPosition(F))return P.Position.to(F);if(R.Range.isIRange(F.range)&&u.URI.isUri(F.uri))return P.location.to(F);if(F instanceof t.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(h){this._argumentProcessors.push(h)}registerApiCommand(h){const _=this.registerCommand(!1,h.id,async(...b)=>{const A=h.args.map((j,H)=>{if(!j.validate(b[H]))throw new Error(`Invalid argument '${j.name}' when running '${h.id}', received: ${typeof b[H]=="object"?JSON.stringify(b[H],null,"	"):b[H]} `);return j.convert(b[H])}),F=await this.executeCommand(h.internalId,...A);return h.result.convert(F,b,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this._apiCommands.set(h.id,h),new L.Disposable(()=>{_.dispose(),this._apiCommands.delete(h.id)})}registerCommand(h,_,b,A,F,j){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:b,thisArg:A,metadata:F,extension:j}),h&&this.#e.$registerCommand(_),new L.Disposable(()=>{this._commands.delete(_)&&h&&this.#e.$unregisterCommand(_)})}executeCommand(h,..._){return this._logService.trace("ExtHostCommands#executeCommand",h),this._doExecuteCommand(h,_,!0)}async _doExecuteCommand(h,_,b){if(this._commands.has(h))return this.#e.$fireCommandActivationEvent(h),this._executeContributedCommand(h,_,!1);{let A=!1;const F=(0,O.cloneAndChange)(_,function(j){if(j instanceof L.Position)return P.Position.from(j);if(j instanceof L.Range)return P.Range.from(j);if(j instanceof L.Location)return P.location.from(j);if(L.NotebookRange.isNotebookRange(j))return P.NotebookRange.from(j);if(j instanceof ArrayBuffer)return A=!0,t.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return A=!0,t.VSBuffer.wrap(j);if(j instanceof t.VSBuffer)return A=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(h,A?new n.SerializableObjectWithBuffers(F):F,b);return(0,y.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(h,_,!1);throw j}}}async _executeContributedCommand(h,_,b){const A=this._commands.get(h);if(!A)throw new Error("Unknown command");const{callback:F,thisArg:j,metadata:H}=A;if(H?.args)for(let k=0;k<H.args.length;k++)try{(0,I.validateConstraint)(_[k],H.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${H.args[k].name}' - ${H.args[k].description}`)}const B=a.StopWatch.create();try{return await F.apply(j,_)}catch(k){if(h===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(..._);N&&(h=N.command)}if(this._logService.error(k,h,A.extension?.identifier),!b)throw k;if(A.extension?.identifier){const N=this.#i.onExtensionError(A.extension.identifier,k);this._logService.trace("forwarded error to extension?",N,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.toErrorMessage)(k)),this.id=h,this.source=A.extension?.displayName??A.extension?.name}}}finally{this._reportTelemetry(A,h,B.elapsed())}}_reportTelemetry(h,_,b){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new d.TelemetryTrustedValue(_),duration:b})}$executeContributedCommand(h,..._){this._logService.trace("ExtHostCommands#$executeContributedCommand",h);const b=this._commands.get(h);return b?(_=_.map(A=>this._argumentProcessors.reduce((F,j)=>j.processArgument(F,b.extension?.identifier),A)),this._executeContributedCommand(h,_,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this._logService.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(_=>(h&&(_=_.filter(b=>b[0]!=="_")),_))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[_,b]of this._commands){const{metadata:A}=b;A&&(h[_]=A)}return Promise.resolve(h)}};e.ExtHostCommands=l,e.ExtHostCommands=l=Ge([Ve(0,s.IExtHostRpcService),Ve(1,f.ILogService),Ve(2,i.IExtHostTelemetry)],l),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class o{constructor(h,_,b){this._commands=h,this._lookupApiCommand=_,this._logService=b,this.delegatingCommandId=`__vsc${(0,v.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(h,_){if(!h)return;const b={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return b;const A=this._lookupApiCommand(h.command);if(A)b.id=A.internalId,b.arguments=A.args.map((F,j)=>F.convert(h.arguments&&h.arguments[j]));else if((0,m.isNonEmptyArray)(h.arguments)){const F=`${h.command} /${++this._cachIdPool}`;this._cache.set(F,h),_.add((0,E.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),b.$ident=F,b.id=this.delegatingCommandId,b.arguments=[F],this._logService.trace("CommandsConverter#CREATE",h.command,F)}return b}fromInternal(h){return typeof h.$ident=="string"?this._cache.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this._cache.get(h[0])}_executeConvertedCommand(...h){const _=this.getActualCommand(...h);return this._logService.trace("CommandsConverter#EXECUTE",h[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.CommandsConverter=o;class S{static{this.Uri=new S("uri","Uri of a text document",h=>u.URI.isUri(h),h=>h)}static{this.Position=new S("position","A position in a text document",h=>L.Position.isPosition(h),P.Position.from)}static{this.Range=new S("range","A range in a text document",h=>L.Range.isRange(h),P.Range.from)}static{this.Selection=new S("selection","A selection in a text document",h=>L.Selection.isSelection(h),P.Selection.from)}static{this.Number=new S("number","",h=>typeof h=="number",h=>h)}static{this.String=new S("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=S.Arr(S.String)}static Arr(h){return new S(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,_=>Array.isArray(_)&&_.every(b=>h.validate(b)),_=>_.map(b=>h.convert(b)))}static{this.CallHierarchyItem=new S("item","A call hierarchy item",h=>h instanceof L.CallHierarchyItem,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new S("item","A type hierarchy item",h=>h instanceof L.TypeHierarchyItem,P.TypeHierarchyItem.from)}static{this.TestItem=new S("testItem","A VSCodium TestItem",h=>h instanceof c.TestItemImpl,P.TestItem.from)}constructor(h,_,b,A){this.name=h,this.description=_,this.validate=b,this.convert=A}optional(){return new S(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,_){return new S(h??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S;class w{static{this.Void=new w("no result",h=>h)}constructor(h,_){this.description=h,this.convert=_}}e.ApiCommandResult=w;class g{constructor(h,_,b,A,F){this.id=h,this.internalId=_,this.description=b,this.args=A,this.result=F}}e.ApiCommand=g}),define(Te[271],Ae([1,0,18,12,2,86,95,36,31,8,7]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new f.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(y.DocumentHighlight.to))),new f.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,c)=>{if((0,I.isFalsyOrEmpty)(s))return;class t extends R.SymbolInformation{static to(r){const a=new t(r.name,y.SymbolKind.to(r.kind),r.containerName||"",new R.Location(c[0],y.Range.to(r.range)));return a.detail=r.detail,a.range=a.location.range,a.selectionRange=y.Range.to(r.selectionRange),a.children=r.children?r.children.map(t.to):[],a}}return s.map(t.to)})),new f.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.ApiCommandArgument.Uri,new f.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new f.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new f.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range,new f.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new f.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new f.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,new f.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new f.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new f.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new f.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(y.location.to))),new f.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(y.Hover.to))),new f.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.ApiCommandArgument.Uri,new f.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(c=>R.Position.isPosition(c)),s=>s.map(y.Position.from))],new f.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(c=>{let t;for(const n of c.reverse())t=new R.SelectionRange(y.Range.to(n),t);return t}))),new f.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.ApiCommandArgument.String.with("query","Search string")],new f.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(y.WorkspaceSymbol.to))),new f.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(y.CallHierarchyItem.to))),new f.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.ApiCommandArgument.CallHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(y.CallHierarchyIncomingCall.to))),new f.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.ApiCommandArgument.CallHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(y.CallHierarchyOutgoingCall.to))),new f.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:y.Range.to(s.range),placeholder:s.text}})),new f.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,f.ApiCommandArgument.String.with("newName","The new symbol name")],new f.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return y.WorkspaceEdit.to(s)}})),new f.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(y.DocumentLink.to))),new f.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new R.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new f.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const c=(0,T.decodeSemanticTokensDto)(s);if(c.type==="full")return new R.SemanticTokens(c.data,void 0)})),new f.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range.optional()],new f.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new R.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new f.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range],new f.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const c=(0,T.decodeSemanticTokensDto)(s);if(c.type==="full")return new R.SemanticTokens(c.data,void 0)})),new f.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,f.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,c,t)=>{if(!s)return new R.CompletionList([]);const n=s.suggestions.map(r=>y.CompletionItem.to(r,t));return new R.CompletionList(n,s.incomplete)})),new f.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position,f.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return y.SignatureHelp.to(s)})),new f.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,c,t)=>E(n=>new R.CodeLens(y.Range.to(n.range),n.command&&t.fromInternal(n.command)))(s))),new f.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.ApiCommandArgument.Uri,new f.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>R.Range.isRange(s),s=>R.Selection.isSelection(s)?y.Selection.from(s):y.Range.from(s)),f.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),f.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,c,t)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const r=new R.CodeAction(n.title,n.kind?new R.CodeActionKind(n.kind):void 0);return n.edit&&(r.edit=y.WorkspaceEdit.to(n.edit)),n.command&&(r.command=t.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(s))),new f.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(c=>new R.ColorInformation(y.Range.to(c.range),y.Color.to(c.color))):[])),new f.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.ApiCommandArgument("color","The color to show and insert",s=>s instanceof R.Color,y.Color.from),new f.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:y.Range.from(s.range)}))],new f.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(y.ColorPresentation.to):[])),new f.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range],new f.ApiCommandResult("A promise that resolves to an array of Inlay objects",(s,c,t)=>s.map(y.InlayHint.to.bind(void 0,t)))),new f.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.ApiCommandArgument.Uri],new f.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(s,c)=>{if(s)return s.map(y.FoldingRange.to)})),new f.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(c=>y.NotebookExclusiveDocumentPattern.to(c))})))),new f.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Range,new f.ApiCommandArgument("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof R.Range,s=>y.InlineValueContext.from(s))],new f.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(y.InlineValue.to))),new f.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,L.matchesSomeScheme)(s,L.Schemas.http,L.Schemas.https),s=>s),new f.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[y.ViewColumn.from(s),void 0]:[y.ViewColumn.from(s.viewColumn),y.TextEditorOpenOptions.from(s)])).optional(),f.ApiCommandArgument.String.with("label","").optional()],f.ApiCommandResult.Void),new f.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.ApiCommandArgument.Uri.with("resource","Resource to open"),f.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new f.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[y.ViewColumn.from(s),void 0]:[y.ViewColumn.from(s.viewColumn),y.TextEditorOpenOptions.from(s)])).optional()],f.ApiCommandResult.Void),new f.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),f.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),f.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new f.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[y.ViewColumn.from(s.viewColumn),y.TextEditorOpenOptions.from(s)]).optional()],f.ApiCommandResult.Void),new f.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new f.ApiCommandArgument("resourceList","List of resources to compare",s=>{for(const c of s){if(c.length!==3)return!1;const[t,n,r]=c;if(!P.URI.isUri(t)||!P.URI.isUri(n)&&n!==void 0&&n!==null||!P.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},s=>s)],f.ApiCommandResult.Void),new f.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.Position],new f.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(y.TypeHierarchyItem.to))),new f.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.ApiCommandArgument.TypeHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(y.TypeHierarchyItem.to))),new f.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.ApiCommandArgument.TypeHierarchyItem],new f.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(y.TypeHierarchyItem.to))),new f.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.ApiCommandArgument.TestItem],f.ApiCommandResult.Void),new f.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.ApiCommandResult.Void),new f.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.ApiCommandArgument.String.with("name","The context key name"),new f.ApiCommandArgument("value","The context key value",()=>!0,s=>s)],f.ApiCommandResult.Void),new f.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.ApiCommandArgument.Uri,f.ApiCommandArgument.StringArray,new f.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",s=>y.MappedEditsContext.is(s),s=>y.MappedEditsContext.from(s))],new f.ApiCommandResult("A promise that resolves to a workspace edit or null",s=>s?y.WorkspaceEdit.to(s):null))];class u{static register(c){C.forEach(c.registerApiCommand,c),this._registerValidateWhenClausesCommand(c)}static _registerValidateWhenClausesCommand(c){c.registerCommand(!1,"_validateWhenClauses",m.validateWhenClauses)}}e.ExtHostApiCommands=u;function E(s){return c=>{if(Array.isArray(c))return c.map(s)}}function p(s){if(!Array.isArray(s))return;const c=[];for(const t of s)O.isLocationLink(t)?c.push(y.DefinitionLink.to(t)):c.push(y.location.to(t));return c}}),define(Te[272],Ae([1,0,11,6,2,3,31,8,7]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(E,p){this.extension=E,this.provider=p,this.handle=y._pool++}}class R{constructor(E){this.session=E,this.responses=[]}}class C{static{this._nextId=0}constructor(E,p,s,c){this._documents=s,this._logService=c,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=E.getProxy(O.MainContext.MainThreadInlineChat),p.registerApiCommand(new T.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new T.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?m.Range.from(t.initialRange):void 0,initialSelection:f.Selection.isSelection(t.initialSelection)?m.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?m.Position.from(t.position):void 0}})],T.ApiCommandResult.Void))}registerProvider(E,p,s){const c=new y(E,p);return this._inputProvider.set(c.handle,c),this._proxy.$registerInteractiveEditorProvider(c.handle,s?.label??E.displayName??E.name,E.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",s?.supportReportIssue??!1),(0,L.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(c.handle),this._inputProvider.delete(c.handle)})}async $prepareSession(E,p,s,c){const t=this._inputProvider.get(E);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this._documents.getDocument(P.URI.revive(p)),r=m.Selection.to(s),a=await t.provider.prepareInteractiveEditorSession({document:n,selection:r},c);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=C._nextId++;return this._inputSessions.set(d,new R(a)),{id:d,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(E,p,s,c){const t=this._inputProvider.get(E);if(!t)return;const n=this._inputSessions.get(p.id);if(!n)return;const r={prompt:s.prompt,selection:m.Selection.to(s.selection),wholeRange:m.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this._documents.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let a=!1;const d={report:async D=>{if(!s.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||c.isCancellationRequested||await this._proxy.$handleProgressChunk(s.requestId,{message:D.message,edits:D.edits?.map(m.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:f.MarkdownString.isMarkdownString(D.content)?D.content.value:D.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,r,d,c));let v;try{v=await(0,I.raceCancellation)(i,c)}finally{a=!0}if(!v)return;const l=n.responses.push(v)-1,o={wholeRange:m.Range.from(v.wholeRange),placeholder:v.placeholder};if(!C._isEditResponse(v))return{...o,id:l,type:"editorEdit",message:m.MarkdownString.from(v.contents),edits:[]};const{edits:S,contents:w}=v,g=w!==void 0?m.MarkdownString.from(w):void 0;return S instanceof f.WorkspaceEdit?{...o,id:l,type:"bulkEdit",edits:m.WorkspaceEdit.from(S),message:g}:{...o,id:l,type:"editorEdit",edits:S.map(m.TextEdit.from),message:g}}async $provideFollowups(E,p,s,c){const t=this._inputProvider.get(E),n=this._inputSessions.get(p),r=n?.responses[s];if(t&&r&&t.provider.provideFollowups){const a=Promise.resolve(t.provider.provideFollowups(n.session,r,c));return(await(0,I.raceCancellation)(a,c))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(E,p,s,c){const t=this._inputProvider.get(E),n=this._inputSessions.get(p),r=n?.responses[s];if(t&&r){const a=m.InteractiveEditorResponseFeedbackKind.to(c);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,r,a)}}$releaseSession(E,p){}static _isEditResponse(E){return typeof E=="object"&&typeof E.edits=="object"}}e.ExtHostInteractiveEditor=C}),define(Te[273],Ae([1,0,2,31]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class P{constructor(T,m,f,y,R){this._extHostNotebooks=m,this._textDocumentsAndEditors=f,this._commands=y;const C=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",u=>!0,u=>u),new L.ApiCommandArgument("resource","Interactive resource Uri",u=>!0,u=>u),new L.ApiCommandArgument("controllerId","Notebook controller Id",u=>!0,u=>u),new L.ApiCommandArgument("title","Interactive editor title",u=>!0,u=>u)],new L.ApiCommandResult("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this._commands.registerApiCommand(C)}$willAddInteractiveDocument(T,m,f,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=P}),define(Te[274],Ae([1,0,18,11,22,5,6,28,2,20,14,3,31,8,7,76,211,23,49,212]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let a=class{constructor(g,D,h,_,b){this._initData=D,this._extHostNotebook=h,this._commands=_,this._logService=b,this._activeExecutions=new m.ResourceMap,this._activeNotebookExecutions=new m.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=g.getProxy(C.MainContext.MainThreadNotebookKernels);const A=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",j=>!0,j=>{if(j&&"notebookEditor"in j&&"id"in j){const H=this._extHostNotebook.getIdByEditor(j.notebookEditor);return{id:j.id,extension:j.extension,notebookEditorId:H}}else if(j&&"notebookEditor"in j){const H=this._extHostNotebook.getIdByEditor(j.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${j.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return j})],u.ApiCommandResult.Void),F=new u.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.ApiCommandArgument.Uri],new u.ApiCommandResult("A promise that resolves to an array of variables",(j,H)=>j.map(B=>({name:B.name,value:B.value,type:B.type,editable:!1}))));this._commands.registerApiCommand(A),this._commands.registerApiCommand(F)}createNotebookController(g,D,h,_,b,A){for(const pe of this._kernelData.values())if(pe.controller.id===D&&y.ExtensionIdentifier.equals(g.identifier,pe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const F=this._handlePool++,j=this;this._logService.trace(`NotebookController[${F}], CREATED by ${g.identifier.value}, ${D}`);const H=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${g.identifier}'`);let B=!1;const k=new O.Emitter,N=new O.Emitter,$={id:S(g.identifier,D),notebookType:h,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:_||g.identifier.value,preloads:A?A.map(E.NotebookRendererScript.from):[]};let re=b??H,le,_e;this._proxy.$addKernel(F,$).catch(pe=>{console.log(pe),B=!0});let ye=0;const de=()=>{if(B)return;const pe=++ye;Promise.resolve().then(()=>{pe===ye&&this._proxy.$updateKernel(F,$)})},Ee=new m.ResourceMap,se={get id(){return D},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:k.event,get label(){return $.label},set label(pe){$.label=pe??g.displayName??g.name,de()},get detail(){return $.detail??""},set detail(pe){$.detail=pe,de()},get description(){return $.description??""},set description(pe){$.description=pe,de()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(pe){$.supportedLanguages=pe,de()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){$.supportsExecutionOrder=pe,de()},get rendererScripts(){return $.preloads?$.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(pe){re=pe??H},get interruptHandler(){return le},set interruptHandler(pe){le=pe,$.supportsInterrupt=!!pe,de()},set variableProvider(pe){(0,t.checkProposedApiEnabled)(g,"notebookVariableProvider"),_e=pe,$.hasVariableProvider=!!pe,pe?.onDidChangeVariables(ee=>j._proxy.$variablesUpdated(ee.uri)),de()},get variableProvider(){return _e},createNotebookCellExecution(pe){if(B)throw new Error("notebook controller is DISPOSED");if(!Ee.has(pe.notebook.uri))throw j._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ee.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return j._createNotebookCellExecution(pe,S(g.identifier,this.id))},createNotebookExecution(pe){if((0,t.checkProposedApiEnabled)(g,"notebookExecution"),B)throw new Error("notebook controller is DISPOSED");if(!Ee.has(pe.uri))throw j._logService.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ee.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return j._createNotebookExecution(pe,S(g.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${F}], DISPOSED`),B=!0,this._kernelData.delete(F),k.dispose(),N.dispose(),this._proxy.$removeKernel(F))},updateNotebookAffinity(pe,ee){ee===p.NotebookControllerAffinity2.Hidden&&(0,t.checkProposedApiEnabled)(g,"notebookControllerAffinityHidden"),j._proxy.$updateNotebookPriority(F,pe.uri,ee)},onDidReceiveMessage:N.event,postMessage(pe,ee){return(0,t.checkProposedApiEnabled)(g,"notebookMessaging"),j._proxy.$postMessage(F,ee&&j._extHostNotebook.getIdByEditor(ee),pe)},asWebviewUri(pe){return(0,t.checkProposedApiEnabled)(g,"notebookMessaging"),(0,s.asWebviewUri)(pe,j._initData.remote)}};return this._kernelData.set(F,{extensionId:g.identifier,controller:se,onDidReceiveMessage:N,onDidChangeSelection:k,associatedNotebooks:Ee}),se}getIdByController(g){for(const[D,h]of this._kernelData)if(h.controller===g)return S(h.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const h=this._kernelDetectionTaskHandlePool++,_=this;this._logService.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${g.identifier.value}`),this._proxy.$addKernelDetectionTask(h,D);const b={dispose:()=>{this._kernelDetectionTask.delete(h),_._proxy.$removeKernelDetectionTask(h)}};return this._kernelDetectionTask.set(h,b),b}registerKernelSourceActionProvider(g,D,h){const _=this._kernelSourceActionProviderHandlePool++,b=typeof h.onDidChangeNotebookKernelSourceActions=="function"?_:void 0,A=this;this._kernelSourceActionProviders.set(_,h),this._logService.trace(`NotebookKernelSourceActionProvider[${_}], CREATED by ${g.identifier.value}`),this._proxy.$addKernelSourceActionProvider(_,_,D);let F;return b!==void 0&&(F=h.onDidChangeNotebookKernelSourceActions(j=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this._kernelSourceActionProviders.delete(_),A._proxy.$removeKernelSourceActionProvider(_,_),F?.dispose()}}}async $provideKernelSourceActions(g,D){const h=this._kernelSourceActionProviders.get(g);if(h){const _=new T.DisposableStore;return(await h.provideNotebookKernelSourceActions(D)??[]).map(A=>E.NotebookKernelSourceAction.from(A,this._commands.converter,_))}return[]}$acceptNotebookAssociation(g,D,h){const _=this._kernelData.get(g);if(_){const b=this._extHostNotebook.getNotebookDocument(f.URI.revive(D));h?_.associatedNotebooks.set(b.uri,!0):_.associatedNotebooks.delete(b.uri),this._logService.trace(`NotebookController[${g}] ASSOCIATE notebook`,b.uri.toString(),h),_.onDidChangeSelection.fire({selected:h,notebook:b.apiNotebook})}}async $executeCells(g,D,h){const _=this._kernelData.get(g);if(!_)return;const b=this._extHostNotebook.getNotebookDocument(f.URI.revive(D)),A=[];for(const F of h){const j=b.getCell(F);j&&A.push(j.apiCell)}try{this._logService.trace(`NotebookController[${g}] EXECUTE cells`,b.uri.toString(),A.length),await _.controller.executeHandler.call(_.controller,A,b.apiNotebook,_.controller)}catch(F){this._logService.error(`NotebookController[${g}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(g,D,h){const _=this._kernelData.get(g);if(!_)return;const b=this._extHostNotebook.getNotebookDocument(f.URI.revive(D));if(_.controller.interruptHandler)await _.controller.interruptHandler.call(_.controller,b.apiNotebook);else for(const A of h){const F=b.getCell(A);F&&this._activeExecutions.get(F.uri)?.cancel()}if(_.controller.interruptHandler){const A=this._activeNotebookExecutions.get(b.uri);h.length&&Array.isArray(A)&&A.length&&A.forEach(F=>F.dispose())}}async $provideVariables(g,D,h,_,b,A,F){const j=this._kernelData.get(g);if(!j)return;const H=this._extHostNotebook.getNotebookDocument(f.URI.revive(h)),B=j.controller.variableProvider;if(!B)return;let k;if(_!==void 0){if(k=this.variableStore[_],!k)return}else this.variableStore={};const N=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,$=B.provideVariables(H.apiNotebook,k,N,A,F);let re=0;for await(const le of $){if(F.isCancellationRequested)return;const _e={id:this.id++,name:le.variable.name,value:le.variable.value,type:le.variable.type,hasNamedChildren:le.hasNamedChildren,indexedChildrenCount:le.indexedChildrenCount,extensionId:j.extensionId.value};if(this.variableStore[_e.id]=le.variable,this._proxy.$receiveVariable(D,_e),re++>=r.variablePageSize)return}}$acceptKernelMessageFromRenderer(g,D,h){const _=this._kernelData.get(g);if(!_)return;const b=this._extHostNotebook.getEditorById(D);_.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:h}))}$cellExecutionChanged(g,D,h){const b=this._extHostNotebook.getNotebookDocument(f.URI.revive(g)).getCell(D);if(b){const A=h?E.NotebookCellExecutionState.to(h):p.NotebookCellExecutionState.Idle;A!==void 0&&this._onDidChangeCellExecutionState.fire({cell:b.apiCell,state:A})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const _=this._extHostNotebook.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!_)throw new Error("invalid cell");if(this._activeExecutions.has(_.uri))throw new Error(`duplicate execution for ${_.uri}`);const b=new i(D,_,this._proxy);this._activeExecutions.set(_.uri,b);const A=b.onDidChangeState(()=>{b.state===d.Resolved&&(b.dispose(),A.dispose(),this._activeExecutions.delete(_.uri))});return b.asApiObject()}_createNotebookExecution(g,D){const h=this._extHostNotebook.getNotebookDocument(g.uri),_=g.getCells().find(F=>{const j=h.getCellFromApiCell(F);return j&&this._activeExecutions.has(j.uri)});if(_)throw new Error(`duplicate cell execution for ${_.document.uri}`);if(this._activeNotebookExecutions.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const b=new l(D,h,this._proxy),A=b.onDidChangeState(()=>{b.state===v.Resolved&&(b.dispose(),A.dispose(),this._activeNotebookExecutions.delete(h.uri))});return this._activeNotebookExecutions.set(h.uri,[b,A]),b.asApiObject()}};e.ExtHostNotebookKernels=a,e.ExtHostNotebookKernels=a=Ge([Ve(4,R.ILogService)],a);var d;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(d||(d={}));class i extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(g,D,h){super(),this._cell=D,this._proxy=h,this._handle=i.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new o(10,_=>this.update(_)),this._executionOrder=D.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,g,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(g){await this._collector.addItem(g)}async update(g){const D=Array.isArray(g)?g:[g];return this._proxy.$updateExecution(this._handle,new n.SerializableObjectWithBuffers(D))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(g){let D=this._cell;if(g&&(D=this._cell.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}validateAndConvertOutputs(g){return g.map(D=>{const h=p.NotebookCellOutput.ensureUniqueMimeTypes(D.items,!0);return h===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:h,id:D.id,metadata:D.metadata})})}async updateOutputs(g,D,h){const _=this.cellIndexToHandle(D),b=this.validateAndConvertOutputs((0,I.asArray)(g));return this.updateSoon({editType:c.CellExecutionUpdateType.Output,cellHandle:_,append:h,outputs:b})}async updateOutputItems(g,D,h){return g=p.NotebookCellOutput.ensureUniqueMimeTypes((0,I.asArray)(g),!0),this.updateSoon({editType:c.CellExecutionUpdateType.OutputItems,items:g.map(E.NotebookCellOutputItem.from),outputId:D.id,append:h})}asApiObject(){const g=this;return Object.freeze({get token(){return g._tokenSource.token},get cell(){return g._cell.apiCell},get executionOrder(){return g._executionOrder},set executionOrder(h){g._executionOrder=h,g.update([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:g._executionOrder}])},start(h){if(g._state===d.Resolved||g._state===d.Started)throw new Error("Cannot call start again");g._state=d.Started,g._onDidChangeState.fire(),g.update({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,_){if(g._state===d.Resolved)throw new Error("Cannot call resolve twice");g._state=d.Resolved,g._onDidChangeState.fire(),g._collector.flush(),g._proxy.$completeExecution(g._handle,new n.SerializableObjectWithBuffers({runEndTime:_,lastRunSuccess:h}))},clearOutput(h){return g.verifyStateForOutput(),g.updateOutputs([],h,!1)},appendOutput(h,_){return g.verifyStateForOutput(),g.updateOutputs(h,_,!0)},replaceOutput(h,_){return g.verifyStateForOutput(),g.updateOutputs(h,_,!1)},appendOutputItems(h,_){return g.verifyStateForOutput(),g.updateOutputItems(h,_,!0)},replaceOutputItems(h,_){return g.verifyStateForOutput(),g.updateOutputItems(h,_,!1)}})}}var v;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(v||(v={}));class l extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(g,D,h){super(),this._notebook=D,this._proxy=h,this._handle=l.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,g,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===v.Resolved||this._state===v.Started)throw new Error("Cannot call start again");this._state=v.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===v.Resolved)throw new Error("Cannot call resolve twice");this._state=v.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class o{constructor(g,D){this.delay=g,this.callback=D,this.batch=[],this.startedTimer=Date.now()}addItem(g){return this.batch.push(g),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const g=this.currentDeferred;this.currentDeferred=void 0;const D=this.batch;return this.batch=[],this.callback(D).finally(()=>g.complete())}}function S(w,g){return`${w.value}/${g}`}e.createKernelId=S}),define(Te[66],Ae([1,0,5,3,4,2,17,6,7,167,15,195,22,33,196,41,11,8,31]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class r{constructor(h,_,b,A){this._proxy=h,this._id=_,this._creationOptions=b,this._name=A,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const F=this;this.value={get name(){return F._name||""},get processId(){return F._pidPromise},get creationOptions(){return F._creationOptions},get exitStatus(){return F._exitStatus},get state(){return F._state},get selection(){return F._selection},sendText(j,H=!0){F._checkDisposed(),F._proxy.$sendText(F._id,j,H)},show(j){F._checkDisposed(),F._proxy.$show(F._id,j)},hide(){F._checkDisposed(),F._proxy.$hide(F._id)},dispose(){F._disposed||(F._disposed=!0,F._proxy.$dispose(F._id))},get dimensions(){if(!(F._cols===void 0||F._rows===void 0))return{columns:F._cols,rows:F._rows}}}}async create(h,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??_?.cwd??void 0,env:h.env??void 0,icon:S(h.iconPath)??void 0,color:s.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:_?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:_?.useShellEnvironment??void 0,location:_?.location||this._serializeParentTerminal(h.location,_?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,_,b,A,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:A,color:s.ThemeColor.isThemeColor(F)?F.id:void 0,location:_?.location||this._serializeParentTerminal(h,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(h,_){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&_?{parentTerminal:_}:"viewColumn"in h?{viewColumn:t.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(h){this._name=h}setExitStatus(h,_){this._exitStatus=Object.freeze({code:h,reason:_})}setDimensions(h,_){return h===this._cols&&_===this._rows||h===0||_===0?!1:(this._cols=h,this._rows=_,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(h){this._selection=h}_setProcessId(h){this._pidPromiseComplete?(this._pidPromiseComplete(h),this._pidPromiseComplete=void 0):this._pidPromise.then(_=>{_!==h&&(this._pidPromise=Promise.resolve(h))})}}e.ExtHostTerminal=r;class a{get onProcessReady(){return this._onProcessReady.event}constructor(h){this._pty=h,this.id=0,this.shouldPersist=!1,this._onProcessData=new I.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new I.Emitter,this._onDidChangeProperty=new I.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new I.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,_){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${_}`)}async start(){}shutdown(){this._pty.close()}input(h){this._pty.handleInput?.(h)}resize(h,_){this._pty.setDimensions?.({columns:h,rows:_})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this._pty.onDidWrite(_=>this._onProcessData.fire(_)),this._pty.onDidClose?.((_=void 0)=>{this._onProcessExit.fire(_===void 0?void 0:_)}),this._pty.onDidOverrideDimensions?.(_=>{_&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:_.columns,rows:_.rows}})}),this._pty.onDidChangeName?.(_=>{this._onDidChangeProperty.fire({type:"title",value:_})}),this._pty.open(h||void 0),h&&this._pty.setDimensions?.(h),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,i=class extends m.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(h=>h.value)}constructor(h,_,b){super(),this._extHostCommands=_,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new m.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new I.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new I.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new I.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new I.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new I.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new I.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=b.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(h),this._extHostCommands.registerArgumentProcessor({processArgument:A=>{const F=j=>{const H=j;return this._getTerminalById(H.instanceId)?.value};switch(A?.$mid){case 15:return F(A);default:{if(Array.isArray(A))for(let j=0;j<A.length&&A[j].$mid===15;j++)A[j]=F(A[j]);return A}}}}),this._register({dispose:()=>{for(const[A,F]of this._terminalProcesses)F.shutdown(!0)}})}getDefaultShell(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(h){return(h?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(h,_){const b=new r(this._proxy,(0,E.generateUuid)(),h,h.name),A=new a(h.pty);return b.createExtensionTerminal(h.location,_,this._serializeParentTerminal(h,_).resolvedExtHostIdentifier,S(h.iconPath),w(h.color)).then(F=>{const j=this._setupExtHostProcessListeners(F,A);this._terminalProcessDisposables[F]=j}),this._terminals.push(b),b.value}_serializeParentTerminal(h,_){if(_=_||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const b=h.location.parentTerminal;if(b){const A=this._terminals.find(F=>F.value===b);A&&(_.resolvedExtHostIdentifier=A._id)}}else h.location&&typeof h.location!="object"?_.location=h.location:_.location&&typeof _.location=="object"&&"splitActiveTerminal"in _.location&&(_.location={splitActiveTerminal:!0});return _}attachPtyToTerminal(h,_){if(!this._getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const A=new a(_),F=this._setupExtHostProcessListeners(h,A);this._terminalProcessDisposables[h]=F}async $acceptActiveTerminalChanged(h){const _=this._activeTerminal;if(h===null){this._activeTerminal=void 0,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(h);b&&(this._activeTerminal=b,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(h,_){const b=this._getTerminalById(h);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:_})}async $acceptTerminalDimensions(h,_,b){const A=this._getTerminalById(h);A&&A.setDimensions(_,b)&&this._onDidChangeTerminalDimensions.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(h,_){const b=this._getTerminalById(h);b&&this._onDidExecuteCommand.fire({terminal:b.value,..._})}async $acceptTerminalMaximumDimensions(h,_,b){this._terminalProcesses.get(h)?.resize(_,b)}async $acceptTerminalTitleChange(h,_){const b=this._getTerminalById(h);b&&(b.name=_)}async $acceptTerminalClosed(h,_,b){const A=this._getTerminalObjectIndexById(this._terminals,h);if(A!==null){const F=this._terminals.splice(A,1)[0];F.setExitStatus(_,b),this._onDidCloseTerminal.fire(F.value)}}$acceptTerminalOpened(h,_,b,A){if(_){const H=this._getTerminalObjectIndexById(this._terminals,_);if(H!==null){this._terminals[H]._id=h,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const F={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:O.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},j=new r(this._proxy,h,F,b);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(h,_){this._getTerminalById(h)?._setProcessId(_)}async $startExtensionTerminal(h,_){const b=this._getTerminalById(h);if(!b)return{message:(0,y.localize)(0,null,h)};b.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async H=>{H===b.value&&(j.dispose(),F())})});const A=this._terminalProcesses.get(h);A?A.startSendingEvents(_):this._extensionTerminalAwaitingStart[h]={initialDimensions:_}}_setupExtHostProcessListeners(h,_){const b=new m.DisposableStore;b.add(_.onProcessReady(F=>this._proxy.$sendProcessReady(h,F.pid,F.cwd,F.windowsPty))),b.add(_.onDidChangeProperty(F=>this._proxy.$sendProcessProperty(h,F))),this._bufferer.startBuffering(h,_.onProcessData),b.add(_.onProcessExit(F=>this._onProcessExit(h,F))),this._terminalProcesses.set(h,_);const A=this._extensionTerminalAwaitingStart[h];return A&&_ instanceof a&&(_.startSendingEvents(A.initialDimensions),delete this._extensionTerminalAwaitingStart[h]),b}$acceptProcessAckDataEvent(h,_){this._terminalProcesses.get(h)?.acknowledgeDataEvent(_)}$acceptProcessInput(h,_){this._terminalProcesses.get(h)?.input(_)}$acceptTerminalInteraction(h){const _=this._getTerminalById(h);_?.setInteractedWith()&&this._onDidChangeTerminalState.fire(_.value)}$acceptTerminalSelection(h,_){this._getTerminalById(h)?.setSelection(_)}$acceptProcessResize(h,_,b){try{this._terminalProcesses.get(h)?.resize(_,b)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(h,_){this._terminalProcesses.get(h)?.shutdown(_)}$acceptProcessRequestInitialCwd(h){this._terminalProcesses.get(h)?.getInitialCwd().then(_=>this._proxy.$sendProcessProperty(h,{type:"initialCwd",value:_}))}$acceptProcessRequestCwd(h){this._terminalProcesses.get(h)?.getCwd().then(_=>this._proxy.$sendProcessProperty(h,{type:"cwd",value:_}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this._linkProviders.add(h),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new f.Disposable(()=>{this._linkProviders.delete(h),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(h,_,b){if(this._profileProviders.has(_))throw new Error(`Terminal profile provider "${_}" already registered`);return this._profileProviders.set(_,b),this._proxy.$registerProfileProvider(_,h.identifier.value),new f.Disposable(()=>{this._profileProviders.delete(_),this._proxy.$unregisterProfileProvider(_)})}registerTerminalQuickFixProvider(h,_,b){if(this._quickFixProviders.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this._quickFixProviders.set(h,b),this._proxy.$registerQuickFixProvider(h,_),new f.Disposable(()=>{this._quickFixProviders.delete(h),this._proxy.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,_){const b=new u.CancellationTokenSource().token;if(b.isCancellationRequested)return;const A=this._quickFixProviders.get(h);if(!A)return;const F=await A.provideTerminalQuickFixes(_,b);if(F===null||Array.isArray(F)&&F.length===0)return;const j=new m.DisposableStore;if(this._lastQuickFixCommands.value=j,!Array.isArray(F))return F?t.TerminalQuickFix.from(F,this._extHostCommands.converter,j):void 0;const H=[];for(const B of F){const k=t.TerminalQuickFix.from(B,this._extHostCommands.converter,j);k&&H.push(k)}return H}async $createContributedProfileTerminal(h,_){const b=new u.CancellationTokenSource().token;let A=await this._profileProviders.get(h)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,_);return}this.createTerminalFromOptions(A.options,_)}}async $provideLinks(h,_){const b=this._getTerminalById(h);if(!b)return[];this._terminalLinkCache.delete(h),this._terminalLinkCancellationSource.get(h)?.dispose(!0);const F=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(h,F);const j=[],H={terminal:b.value,line:_},B=[];for(const $ of this._linkProviders)B.push(c.Promises.withAsyncBody(async re=>{F.token.onCancellationRequested(()=>re({provider:$,links:[]}));const le=await $.provideTerminalLinks(H,F.token)||[];F.token.isCancellationRequested||re({provider:$,links:le})}));const k=await Promise.all(B);if(F.token.isCancellationRequested)return[];const N=new Map;for(const $ of k)$&&$.links.length>0&&j.push(...$.links.map(re=>{const le={id:d++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return N.set(le.id,{provider:$.provider,link:re}),le}));return this._terminalLinkCache.set(h,N),j}$activateLink(h,_){const b=this._terminalLinkCache.get(h)?.get(_);b&&b.provider.handleTerminalLink(b.link)}_onProcessExit(h,_){this._bufferer.stopBuffering(h),this._terminalProcesses.delete(h),delete this._extensionTerminalAwaitingStart[h];const b=this._terminalProcessDisposables[h];b&&(b.dispose(),delete this._terminalProcessDisposables[h]),this._proxy.$sendProcessExit(h,_)}_getTerminalById(h){return this._getTerminalObjectById(this._terminals,h)}_getTerminalObjectById(h,_){const b=this._getTerminalObjectIndexById(h,_);return b!==null?h[b]:null}_getTerminalObjectIndexById(h,_){const b=h.findIndex(A=>A._id===_);return b===-1?null:b}getEnvironmentVariableCollection(h){let _=this._environmentVariableCollections.get(h.identifier.value);return _||(_=new v,this._setEnvironmentVariableCollection(h.identifier.value,_)),_.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(h,_){const b=(0,C.serializeEnvironmentVariableCollection)(_.map),A=(0,C.serializeEnvironmentDescriptionMap)(_.descriptionMap);this._proxy.$setEnvironmentVariableCollection(h,_.persistent,b.length===0?void 0:b,A)}$initEnvironmentVariableCollections(h){h.forEach(_=>{const b=_[0],A=new v(_[1]);this._setEnvironmentVariableCollection(b,A)})}$acceptDefaultProfile(h,_){const b=this._defaultProfile;this._defaultProfile=h,this._defaultAutomationProfile=_,b?.path!==h.path&&this._onDidChangeShell.fire(h.path)}_setEnvironmentVariableCollection(h,_){this._environmentVariableCollections.set(h,_),_.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(h,_)})}};e.BaseExtHostTerminalService=i,e.BaseExtHostTerminalService=i=Ge([Ve(1,n.IExtHostCommands),Ve(2,T.IExtHostRpcService)],i);class v{get persistent(){return this._persistent}set persistent(h){this._persistent=h,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(h){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new I.Emitter,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const _=this.getScopeKey(h);let b=this.scopedCollections.get(_);return b||(b=new l(this,h),this.scopedCollections.set(_,b),b.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),b}replace(h,_,b,A){this._setIfDiffers(h,{value:_,type:f.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:A})}append(h,_,b,A){this._setIfDiffers(h,{value:_,type:f.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:A})}prepend(h,_,b,A){this._setIfDiffers(h,{value:_,type:f.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:A})}_setIfDiffers(h,_){if(_.options&&_.options.applyAtProcessCreation===!1&&!_.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.getKey(h,_.scope),A=this.map.get(b),F=_.options?{applyAtProcessCreation:_.options.applyAtProcessCreation??!1,applyAtShellIntegration:_.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==_.value||A.type!==_.type||A.options?.applyAtProcessCreation!==F.applyAtProcessCreation||A.options?.applyAtShellIntegration!==F.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==_.scope?.workspaceFolder?.index){const j=this.getKey(h,_.scope),H={variable:h,..._,options:F};this.map.set(j,H),this._onDidChangeCollection.fire()}}get(h,_){const b=this.getKey(h,_),A=this.map.get(b);return A?g(A):void 0}getKey(h,_){const b=this.getScopeKey(_);return b.length?`${h}:::${b}`:h}getScopeKey(h){return this.getWorkspaceKey(h?.workspaceFolder)??""}getWorkspaceKey(h){return h?h.uri.toString():void 0}getVariableMap(h){const _=new Map;for(const[b,A]of this.map)this.getScopeKey(A.scope)===this.getScopeKey(h)&&_.set(A.variable,g(A));return _}delete(h,_){const b=this.getKey(h,_);this.map.delete(b),this._onDidChangeCollection.fire()}clear(h){if(h?.workspaceFolder){for(const[_,b]of this.map)b.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(_);this.clearDescription(h)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(h,_){const b=this.getScopeKey(_),A=this.descriptionMap.get(b);if(!A||A.description!==h){let F;typeof h=="string"?F=h:F=h?.value.split(`

`)[0];const j={description:F,scope:_};this.descriptionMap.set(b,j),this._onDidChangeCollection.fire()}}getDescription(h){const _=this.getScopeKey(h);return this.descriptionMap.get(_)?.description}clearDescription(h){const _=this.getScopeKey(h);this.descriptionMap.delete(_)}}class l{get persistent(){return this.collection.persistent}set persistent(h){this.collection.persistent=h}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(h,_){this.collection=h,this.scope=_,this._onDidChangeCollection=new I.Emitter}getScoped(h){return this.collection.getScopedEnvironmentVariableCollection(h)}replace(h,_,b){this.collection.replace(h,_,b,this.scope)}append(h,_,b){this.collection.append(h,_,b,this.scope)}prepend(h,_,b){this.collection.prepend(h,_,b,this.scope)}get(h){return this.collection.get(h,this.scope)}forEach(h,_){this.collection.getVariableMap(this.scope).forEach((b,A)=>h.call(_,A,b,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(h){this.collection.delete(h,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(h){this.collection.setDescription(h,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let o=class extends i{constructor(h,_){super(!1,h,_)}createTerminal(h,_,b){throw new R.NotSupportedError}createTerminalFromOptions(h,_){throw new R.NotSupportedError}};e.WorkerExtHostTerminalService=o,e.WorkerExtHostTerminalService=o=Ge([Ve(0,n.IExtHostCommands),Ve(1,T.IExtHostRpcService)],o);function S(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function w(D){return s.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const h={...D};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Te[275],Ae([1,0,11,24,22,5,246,97,6,26,16,33,14,3,17,111,8,7,48,75,60,23]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class extends f.Disposable{constructor(B,k,N,$){super(),this.editors=$,this.resultsChangedEmitter=this._register(new O.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new O.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(E.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new S(this.proxy,k),N.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const le=re,_e=le.tests[le.tests.length-1].item.extId;return this.controllers.get(n.TestId.root(_e))?.collection.tree.get(_e)?.actual??(0,s.toItemFromContext)(re)}case 18:{const{extId:le,message:_e}=re;return{test:this.controllers.get(n.TestId.root(le))?.collection.tree.get(le)?.actual,message:c.TestMessage.to(_e)}}default:return re}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await N.executeCommand("_testing.getExplorerSelection"),le=_e=>{const ye=this.controllers.get(n.TestId.root(_e));if(ye)return n.TestId.isRoot(_e)?ye.controller:ye.collection.tree.get(_e)?.actual};return{include:re?.include.map(le).filter(R.isDefined)||[],exclude:re?.exclude.map(le).filter(R.isDefined)||[]}})}createTestController(B,k,N,$){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const re=new f.DisposableStore,le=re.add(new s.ExtHostTestItemCollection(k,N,this.editors));le.root.label=N;const _e=new Map,ye=new Set,de=this.proxy,Ee={items:le.root.children,get label(){return N},set label(pe){N=pe,le.root.label=pe,de.$updateController(k,{label:N})},get refreshHandler(){return $},set refreshHandler(pe){$=pe,de.$updateController(k,{canRefresh:!!pe})},get id(){return k},createRunProfile:(pe,ee,X,V,ne,Ie)=>{let Fe=(0,m.hash)(pe);for(;_e.has(Fe);)Fe++;return new F(this.proxy,_e,ye,this.defaultProfilesChangedEmitter.event,k,Fe,pe,ee,X,V,ne,Ie)},createTestItem(pe,ee,X){return new s.TestItemImpl(k,pe,ee,X)},createTestRun:(pe,ee,X=!0)=>this.runTracker.createTestRun(B,k,le,pe,ee,X),invalidateTestResults:pe=>{if(pe===void 0)this.proxy.$markTestRetired(void 0);else{const ee=pe instanceof Array?pe:[pe];this.proxy.$markTestRetired(ee.map(X=>n.TestId.fromExtHostTestItem(X,k).toString()))}},set resolveHandler(pe){le.resolveHandler=pe},get resolveHandler(){return le.resolveHandler},dispose:()=>{re.dispose()}};de.$registerTestController(k,N,!!$),re.add((0,f.toDisposable)(()=>de.$unregisterTestController(k)));const se={controller:Ee,collection:le,profiles:_e,extension:B,activeProfiles:ye};return this.controllers.set(k,se),re.add((0,f.toDisposable)(()=>this.controllers.delete(k))),re.add(le.onDidGenerateDiff(pe=>de.$publishDiff(k,pe.map(a.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.observer.checkout()}async runTests(B,k=P.CancellationToken.None){const N=w(B);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(N.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(re=>n.TestId.fromExtHostTestItem(re,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:j[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:B.exclude?.map(re=>re.id)},k)}$syncTests(){for(const{collection:B}of this.controllers.values())B.flushDiff();return Promise.resolve()}async $provideFileCoverage(B,k,N){return await this.runTracker.getCoverageReport(B,k)?.provideFileCoverage(N)??[]}async $resolveFileCoverage(B,k,N,$){return await this.runTracker.getCoverageReport(B,k)?.resolveFileCoverage(N,$)??[]}$configureRunProfile(B,k){this.controllers.get(B)?.profiles.get(k)?.configureHandler?.()}$setDefaultRunProfiles(B){const k=new Map;for(const[N,$]of Object.entries(B)){const re=this.controllers.get(N);if(!re)continue;const le=new Map,_e=$.filter(de=>!re.activeProfiles.has(de)),ye=[...re.activeProfiles].filter(de=>!$.includes(de));for(const de of _e)le.set(de,!0),re.activeProfiles.add(de);for(const de of ye)le.set(de,!1),re.activeProfiles.delete(de);le.size&&k.set(N,le)}this.defaultProfilesChangedEmitter.fire(k)}async $refreshTests(B,k){await this.controllers.get(B)?.controller.refreshHandler?.(k)}$publishTestResults(B){this.results=Object.freeze(B.map(k=>(0,y.deepFreeze)(c.TestResults.to(k))).concat(this.results).sort((k,N)=>N.completedAt-k.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,k){const N=this.controllers.get(n.TestId.fromString(B).controllerId)?.collection;N&&(await N.expand(B,k<0?1/0:k),N.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(k=>a.TestsDiffOp.deserialize({asCanonicalUri:N=>N},k)))}async $runControllerTests(B,k){return Promise.all(B.map(N=>this.runControllerTestRequest(N,!1,k)))}async $startContinuousRun(B,k){const N=new P.CancellationTokenSource(k),$=await Promise.all(B.map(re=>this.runControllerTestRequest(re,!0,N.token)));return!k.isCancellationRequested&&!$.some(re=>re.error)&&await new Promise(re=>k.onCancellationRequested(re)),N.dispose(!0),$}async runControllerTestRequest(B,k,N){const $=this.controllers.get(B.controllerId);if(!$)return{};const{collection:re,profiles:le,extension:_e}=$,ye=le.get(B.profileId);if(!ye)return{};const de=B.testIds.map(ee=>re.tree.get(ee)).filter(R.isDefined),Ee=B.excludeExtIds.map(ee=>$.collection.tree.get(ee)).filter(R.isDefined).filter(ee=>de.some(X=>X.fullId.compare(ee.fullId)===2));if(!de.length)return{};const se=new t.TestRunRequest(de.some(ee=>ee.actual instanceof s.TestItemRootImpl)?void 0:de.map(ee=>ee.actual),Ee.map(ee=>ee.actual),ye,k),pe=(0,a.isStartControllerTests)(B)&&this.runTracker.prepareForMainThreadTestRun(se,g.fromInternal(B,$.collection),_e,N);try{return await ye.runHandler(se,N),{}}catch(ee){return{error:String(ee)}}finally{pe&&(pe.hasRunningTasks&&!N.isCancellationRequested&&await O.Event.toPromise(pe.onEnd),pe.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};e.ExtHostTesting=i,e.ExtHostTesting=i=Ge([Ve(0,p.IExtHostRpcService),Ve(1,u.ILogService)],i);const v=1e4;var l;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(l||(l={}));class o extends f.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(B,k,N,$,re){super(),this.dto=B,this.proxy=k,this.extension=N,this.logService=$,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.coverageEmitter=this._register(new O.Emitter),this.onDidCoverage=this.coverageEmitter.event,this.onEnd=this.endEmitter.event,this.cts=this._register(new P.CancellationTokenSource(re));const le=this._register(new I.RunOnceScheduler(()=>this.forciblyEndTasks(),v));this._register(this.cts.token.onCancellationRequested(()=>le.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}createRun(B){const k=this.dto.id,N=this.dto.controllerId,$=(0,C.generateUuid)(),re=this.extension,le=this.coverageEmitter;let _e;const ye=pe=>(ee,...X)=>{if(Ee){this.logService.warn(`Setting the state of test "${ee.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(ee)&&(this.ensureTestIsKnown(ee),pe(ee,...X))},de=(pe,ee)=>{const X=ee instanceof Array?ee.map(c.TestMessage.from):[c.TestMessage.from(ee)];if(pe.uri&&pe.range){const V={range:c.Range.from(pe.range),uri:pe.uri};for(const ne of X)ne.location=ne.location||V}this.proxy.$appendTestMessagesInRun(k,$,n.TestId.fromExtHostTestItem(pe,N).toString(),X)};let Ee=!1;const se={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return _e?.provider},set coverageProvider(pe){(0,d.checkProposedApiEnabled)(re,"testCoverage"),_e=pe&&new D(pe),le.fire({taskId:$,runId:k,coverage:_e})},enqueued:ye(pe=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,N).toString(),1)}),skipped:ye(pe=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,N).toString(),5)}),started:ye(pe=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,N).toString(),2)}),errored:ye((pe,ee,X)=>{de(pe,ee),this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,N).toString(),6,X)}),failed:ye((pe,ee,X)=>{de(pe,ee),this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,N).toString(),4,X)}),passed:ye((pe,ee)=>{this.proxy.$updateTestStateInRun(k,$,n.TestId.fromExtHostTestItem(pe,this.dto.controllerId).toString(),3,ee)}),appendOutput:(pe,ee,X)=>{Ee||(X&&(this.dto.isIncluded(X)?this.ensureTestIsKnown(X):X=void 0),this.proxy.$appendOutputToRun(k,$,L.VSBuffer.fromString(pe),ee&&c.location.from(ee),X&&n.TestId.fromExtHostTestItem(X,N).toString()))},end:()=>{Ee||(Ee=!0,this.proxy.$finishedTestRunTask(k,$),this.tasks.delete($),this.tasks.size||this.markEnded())}};return this.tasks.set($,{run:se}),this.proxy.$startedTestRunTask(k,{id:$,name:B,running:!0}),se}forciblyEndTasks(){for(const{run:B}of this.tasks.values())B.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(B){if(!(B instanceof s.TestItemImpl))throw new r.InvalidTestItemError(B.id);if(this.sharedTestIds.has(n.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const k=[],N=this.dto.colllection.root;for(;;){const $=c.TestItem.from(B);if(k.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),B===N))break;B=B.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,k)}dispose(){this.markEnded(),super.dispose()}}class S{get trackers(){return this.tracked.values()}constructor(B,k){this.proxy=B,this.logService=k,this.tracked=new Map,this.coverageReports=[]}getCoverageReport(B,k){return this.coverageReports.find(N=>N.runId===B)?.coverage.get(k)}prepareForMainThreadTestRun(B,k,N,$){return this.getTracker(B,k,N,$)}cancelRunById(B){for(const k of this.tracked.values())if(k.id===B){k.cancel();return}}cancelAllRuns(){for(const B of this.tracked.values())B.cancel()}createTestRun(B,k,N,$,re,le){const _e=this.tracked.get($);if(_e)return _e.createRun(re);const ye=g.fromPublic(k,N,$,le),de=w($);this.proxy.$startedExtensionTestRun({controllerId:k,continuous:!!$.continuous,profile:de&&{group:j[de.kind],id:de.profileId},exclude:$.exclude?.map(se=>n.TestId.fromExtHostTestItem(se,N.root.id).toString())??[],id:ye.id,include:$.include?.map(se=>n.TestId.fromExtHostTestItem(se,N.root.id).toString())??[N.root.id],persist:le});const Ee=this.getTracker($,ye,B);return O.Event.once(Ee.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ye.id),Ee.dispose()}),Ee.createRun(re)}getTracker(B,k,N,$){const re=new o(k,this.proxy,N,this.logService,$);this.tracked.set(B,re);let le;const _e=re.onDidCoverage(({runId:ye,taskId:de,coverage:Ee})=>{le||(le={runId:ye,coverage:new Map},this.coverageReports.unshift(le),this.coverageReports.length>a.KEEP_N_LAST_COVERAGE_REPORTS&&this.coverageReports.pop()),le.coverage.set(de,Ee),this.proxy.$signalCoverageAvailable(ye,de,!!Ee)});return O.Event.once(re.onEnd)(()=>{this.tracked.delete(B),_e.dispose()}),re}}e.TestRunCoordinator=S;const w=H=>{if(H.profile){if(!(H.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class g{static fromPublic(B,k,N,$){return new g(B,(0,C.generateUuid)(),N.include?.map(re=>n.TestId.fromExtHostTestItem(re,B).toString())??[B],N.exclude?.map(re=>n.TestId.fromExtHostTestItem(re,B).toString())??[],$,k)}static fromInternal(B,k){return new g(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,k)}constructor(B,k,N,$,re,le){this.controllerId=B,this.id=k,this.isPersisted=re,this.colllection=le,this.includePrefix=N.map(_e=>_e+"\0"),this.excludePrefix=$.map(_e=>_e+"\0")}isIncluded(B){const k=n.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(k===N||k.startsWith(N))return!1;for(const N of this.includePrefix)if(k===N||k.startsWith(N))return!0;return!1}}e.TestRunDto=g;class D{constructor(B){this.provider=B}async provideFileCoverage(B){this.fileCoverage||(this.fileCoverage=(async()=>this.provider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(k){throw this.fileCoverage=void 0,k}}async resolveFileCoverage(B,k){const N=await this.fileCoverage;let $=N?.[B];return!this.provider||!N||!$?[]:($.detailedCoverage||($=N[B]=await this.provider.resolveFileCoverage?.($,k)??$),$.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(B){this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(B){this.added.add(B)}update(B){Object.assign(B.revived,c.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}this.updated.delete(B);const k=n.TestId.parentId(B.item.extId);if(k&&this.alreadyRemoved.has(k.toString())){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:k,removed:N}=this;return{get added(){return[...B].map($=>$.revived)},get updated(){return[...k].map($=>$.revived)},get removed(){return[...N].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class _ extends a.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,k){return{...B,revived:c.TestItem.toPlain(B.item),depth:k?k.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}class b{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(k=>k.revived)},dispose:(0,T.createSingleCallFunction)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new _({asCanonicalUri:k=>k});return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}const A=(H,B,k,N)=>{k?Object.assign(k,N):B.$updateTestRunConfig(H.controllerId,H.profileId,N)};class F{#e;#t;#i;#n;#s;get label(){return this._label}set label(B){B!==this._label&&(this._label=B,A(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(B){B!==this._supportsContinuousRun&&(this._supportsContinuousRun=B,A(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),A(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,A(this,this.#e,this.#n,{tag:B?c.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,A(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return O.Event.chain(this.#i,B=>B.map(k=>k.get(this.controllerId)?.get(this.profileId)).filter(R.isDefined))}constructor(B,k,N,$,re,le,_e,ye,de,Ee=!1,se=void 0,pe=!1){this.controllerId=re,this.profileId=le,this._label=_e,this.kind=ye,this.runHandler=de,this._tag=se,this._supportsContinuousRun=pe,this.#e=B,this.#s=k,this.#t=N,this.#i=$,k.set(le,this);const ee=j[ye];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);Ee&&N.add(le),this.#n={profileId:le,controllerId:re,tag:se?c.TestTag.namespace(this.controllerId,se.id):null,label:_e,group:ee,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=F;const j={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Te[112],Ae([1,0,55,15,88,8,7]),function(fe,e,I,L,P,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class m{static{this._Keys=new P.IdGenerator("TextEditorDecorationType")}constructor(u,E,p){const s=m._Keys.nextId();u.$registerTextEditorDecorationType(E.identifier,s,O.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:s,dispose(){u.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=m;class f{constructor(u,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,E){this._throwIfFinalized();let p=null;if(u instanceof T.Position)p=new T.Range(u,u);else if(u instanceof T.Range)p=u;else throw new Error("Unrecognized location");this._pushEdit(p,E,!1)}insert(u,E){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),E,!0)}delete(u){this._throwIfFinalized();let E=null;if(u instanceof T.Range)E=u;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(u,E,p){const s=this._document.validateRange(u);this._collectedEdits.push({range:s,text:E,forceMoveMarkers:p})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}class y{constructor(u,E,p,s){this._proxy=u,this._id=E,this._accept(p),this._logService=s;const c=this;this.value={get tabSize(){return c._tabSize},set tabSize(t){c._setTabSize(t)},get indentSize(){return c._indentSize},set indentSize(t){c._setIndentSize(t)},get insertSpaces(){return c._insertSpaces},set insertSpaces(t){c._setInsertSpaces(t)},get cursorStyle(){return c._cursorStyle},set cursorStyle(t){c._setCursorStyle(t)},get lineNumbers(){return c._lineNumbers},set lineNumbers(t){c._setLineNumbers(t)}}}_accept(u){this._tabSize=u.tabSize,this._indentSize=u.indentSize,this._originalIndentSize=u.originalIndentSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(u){const E=this._validateTabSize(u);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateIndentSize(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}_setIndentSize(u){const E=this._validateIndentSize(u);if(E!==null){if(typeof E=="number"){if(this._originalIndentSize===E)return;this._indentSize=E,this._originalIndentSize=E}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:E}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:!!u}_setInsertSpaces(u){const E=this._validateInsertSpaces(u);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let p=!1;if(typeof u.tabSize<"u"){const s=this._validateTabSize(u.tabSize);s==="auto"?(p=!0,E.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,p=!0,E.tabSize=s)}if(typeof u.indentSize<"u"){const s=this._validateIndentSize(u.indentSize);s==="tabSize"?(p=!0,E.indentSize=s):typeof s=="number"&&this._originalIndentSize!==s&&(this._indentSize=s,this._originalIndentSize=s,p=!0,E.indentSize=s)}if(typeof u.insertSpaces<"u"){const s=this._validateInsertSpaces(u.insertSpaces);s==="auto"?(p=!0,E.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,p=!0,E.insertSpaces=s)}typeof u.cursorStyle<"u"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,p=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,p=!0,E.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(u,E){E.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=y;class R{constructor(u,E,p,s,c,t,n,r){this.id=u,this._proxy=E,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._options=new y(this._proxy,this.id,t,p),this._visibleRanges=n,this._viewColumn=r;const a=this;this.value=Object.freeze({get document(){return s.value},set document(d){throw new L.ReadonlyError("document")},get selection(){return a._selections&&a._selections[0]},set selection(d){if(!(d instanceof T.Selection))throw(0,L.illegalArgument)("selection");a._selections=[d],a._trySetSelection()},get selections(){return a._selections},set selections(d){if(!Array.isArray(d)||d.some(i=>!(i instanceof T.Selection)))throw(0,L.illegalArgument)("selections");a._selections=d,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(d){throw new L.ReadonlyError("visibleRanges")},get options(){return a._options.value},set options(d){a._disposed||a._options.assign(d)},get viewColumn(){return a._viewColumn},set viewColumn(d){throw new L.ReadonlyError("viewColumn")},edit(d,i={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new f(s.value,i);return d(v),a._applyEdit(v)},insertSnippet(d,i,v={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!i||Array.isArray(i)&&i.length===0)l=a._selections.map(o=>O.Range.from(o));else if(i instanceof T.Position){const{lineNumber:o,column:S}=O.Position.from(i);l=[{startLineNumber:o,startColumn:S,endLineNumber:o,endColumn:S}]}else if(i instanceof T.Range)l=[O.Range.from(i)];else{l=[];for(const o of i)if(o instanceof T.Range)l.push(O.Range.from(o));else{const{lineNumber:S,column:w}=O.Position.from(o);l.push({startLineNumber:S,startColumn:w,endLineNumber:S,endColumn:w})}}return E.$tryInsertSnippet(u,s.value.version,d.value,l,v)},setDecorations(d,i){const v=i.length===0;v&&!a._hasDecorationsForKey.has(d.key)||(v?a._hasDecorationsForKey.delete(d.key):a._hasDecorationsForKey.add(d.key),a._runOnProxy(()=>{if(O.isDecorationOptionsArr(i))return E.$trySetDecorations(u,d.key,O.fromRangeOrRangeWithMessage(i));{const l=new Array(4*i.length);for(let o=0,S=i.length;o<S;o++){const w=i[o];l[4*o]=w.start.line+1,l[4*o+1]=w.start.character+1,l[4*o+2]=w.end.line+1,l[4*o+3]=w.end.character+1}return E.$trySetDecorationsFast(u,d.key,l)}}))},revealRange(d,i){a._runOnProxy(()=>E.$tryRevealRange(u,O.Range.from(d),i||T.TextEditorRevealType.Default))},show(d){E.$tryShowEditor(u,O.ViewColumn.from(d))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,I.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,I.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,I.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(O.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const p=E.edits.map(c=>c.range);p.sort((c,t)=>c.end.line===t.end.line?c.end.character===t.end.character?c.start.line===t.start.line?c.start.character-t.start.character:c.start.line-t.start.line:c.end.character-t.end.character:c.end.line-t.end.line);for(let c=0,t=p.length-1;c<t;c++){const n=p[c].end;if(p[c+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=E.edits.map(c=>({range:O.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,s,{setEndOfLine:typeof E.setEndOfLine=="number"?O.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=R}),define(Te[67],Ae([1,0,55,5,6,2,4,3,109,17,112,8,14,28,12,51,40]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class t{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let n=class{constructor(a,d){this._extHostRpc=a,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const d=[],i=[],v=[];if(a.removedDocuments)for(const l of a.removedDocuments){const o=O.URI.revive(l),S=this._documents.get(o);S?.unref()&&(this._documents.delete(o),d.push(S.value))}if(a.addedDocuments)for(const l of a.addedDocuments){const o=O.URI.revive(l.uri);let S=this._documents.get(o);if(S&&o.scheme!==p.Schemas.vscodeNotebookCell&&o.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);S||(S=new t(new f.ExtHostDocumentData(this._extHostRpc.getProxy(m.MainContext.MainThreadDocuments),o,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty)),this._documents.set(o,S),i.push(S.value)),S.ref()}if(a.removedEditors)for(const l of a.removedEditors){const o=this._editors.get(l);this._editors.delete(l),o&&v.push(o)}if(a.addedEditors)for(const l of a.addedEditors){const o=O.URI.revive(l.documentUri);I.ok(this._documents.has(o),`document '${o}' does not exist`),I.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const S=this._documents.get(o).value,w=new R.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(m.MainContext.MainThreadTextEditors),this._logService,new c.Lazy(()=>S.document),l.selections.map(C.Selection.to),l.options,l.visibleRanges.map(g=>C.Range.to(g)),typeof l.editorPosition=="number"?C.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,w)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,P.dispose)(d),(0,P.dispose)(v),a.removedDocuments&&this._onDidRemoveDocuments.fire(d),a.addedDocuments&&this._onDidAddDocuments.fire(i),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return s.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const d=this._editors.get(this._activeEditorId);return a?d:d?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=n,e.ExtHostDocumentsAndEditors=n=Ge([Ve(0,y.IExtHostRpcService),Ve(1,u.ILogService)],n),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Te[276],Ae([1,0,18,5,3,112,8,7]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class f{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new L.Emitter,this._onDidChangeTextEditorOptions=new L.Emitter,this._onDidChangeTextEditorVisibleRanges=new L.Emitter,this._onDidChangeTextEditorViewColumn=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(u=>u.value)}async showTextDocument(R,C,u){let E;typeof C=="number"?E={position:T.ViewColumn.from(C),preserveFocus:u}:typeof C=="object"?E={position:T.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?T.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(R.uri,E),s=p&&this._extHostDocumentsAndEditors.getEditor(p);if(s)return s.value;throw p?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new O.TextEditorDecorationType(this._proxy,R,C).value}$acceptEditorPropertiesChanged(R,C){const u=this._extHostDocumentsAndEditors.getEditor(R);if(!u)throw new Error("unknown text editor");if(C.options&&u._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(T.Selection.to);u._acceptSelections(E)}if(C.visibleRanges){const E=I.coalesce(C.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(E)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...C.options,lineNumbers:T.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=m.TextEditorSelectionChangeKind.fromValue(C.selections.source),p=C.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:p,kind:E})}if(C.visibleRanges){const E=I.coalesce(C.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const C in R){const u=this._extHostDocumentsAndEditors.getEditor(C);if(!u)throw new Error("Unknown text editor");const E=T.ViewColumn.to(R[C]);u.value.viewColumn!==E&&(u._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=f}),define(Te[277],Ae([1,0,2,4,3,6,7,8,20,16]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class R{constructor(E,p){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(s,c)=>{if(s&&s.$mid===12)if(this._providers.get(s.source)&&f.ExtensionIdentifier.equals(c,this._providers.get(s.source)?.extension)){const t=s.uri===void 0?void 0:I.URI.revive(s.uri);return this._itemsBySourceAndUriMap.get(s.source)?.get(C(t))?.get(s.handle)}else return;return s}})}async $getTimeline(E,p,s,c){return this._providers.get(E)?.provider.provideTimeline(I.URI.revive(p),s,c)}registerTimelineProvider(E,p,s,c){const t=new O.DisposableStore,n=this.convertTimelineItem(p.id,c,t).bind(this);let r;p.onDidChange&&(r=p.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:p.id}),this));const a=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...p,scheme:E,onDidChange:void 0,async provideTimeline(d,i,v){i?.resetCache&&(t.clear(),a.get(p.id)?.clear());const l=await p.provideTimeline(d,i,v);if(l==null)return;const o=n(d,i);return{...l,source:p.id,items:l.items.map(o)}},dispose(){for(const d of a.values())d.get(p.id)?.clear();r?.dispose(),t.dispose()}},s)}convertTimelineItem(E,p,s){return(c,t)=>{let n;if(t?.cacheResults){let r=this._itemsBySourceAndUriMap.get(E);r===void 0&&(r=new Map,this._itemsBySourceAndUriMap.set(E,r));const a=C(c);n=r.get(a),n===void 0&&(n=new Map,r.set(a,n))}return r=>{const{iconPath:a,...d}=r,i=`${E}|${r.id??r.timestamp}`;n?.set(i,r);let v,l,o;r.iconPath&&(a instanceof T.ThemeIcon?o={id:a.id,color:a.color}:I.URI.isUri(a)?(v=a,l=a):{light:v,dark:l}=a);let S;return T.MarkdownString.isMarkdownString(d.tooltip)?S=m.MarkdownString.from(d.tooltip):(0,y.isString)(d.tooltip)?S=d.tooltip:T.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=m.MarkdownString.from(d.detail)):(0,y.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=d.detail),{...d,id:d.id??void 0,handle:i,source:E,command:r.command?p.toInternal(r.command,s):void 0,icon:v,iconDark:l,themeIcon:o,tooltip:S,accessibilityInformation:r.accessibilityInformation}}}}registerTimelineProviderCore(E,p){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,{provider:E,extension:p}),(0,O.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=R;function C(u){return u?.toString()}}),define(Te[278],Ae([1,0,168,25,2,5,6,206,11,7,16,18,8,53,22,133,23]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function t(a,d){if((0,R.isString)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let i;return Array.isArray(a.highlights)&&(i=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),i=i.length?i:void 0),{label:a.label,highlights:i}}}class n extends T.Disposable{constructor(d,i,v){super(),this._proxy=d,this.commands=i,this.logService=v,this.treeViews=new Map,this.treeDragAndDropService=new s.TreeViewsDnDService;function l(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:o=>l(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(S=>l(S)?this.convertArgument(S):S):o})}registerTreeDataProvider(d,i,v){const l=this.createTreeView(d,{treeDataProvider:i},v);return{dispose:()=>l.dispose()}}createTreeView(d,i,v){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=i.dragAndDropController?.dropMimeTypes??[],o=i.dragAndDropController?.dragMimeTypes??[],S=!!i.dragAndDropController?.handleDrag,w=!!i.dragAndDropController?.handleDrop,g=this.createExtHostTreeView(d,i,v),D={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:l,dragMimeTypes:o,hasHandleDrag:S,hasHandleDrop:w,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},h=this._proxy.$registerTreeViewDataProvider(d,D),_={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,c.checkProposedApiEnabled)(v,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,c.checkProposedApiEnabled)(v,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(b){(0,E.isMarkdownString)(b)&&(0,c.checkProposedApiEnabled)(v,"treeViewMarkdownMessage"),g.message=b},get title(){return g.title},set title(b){g.title=b},get description(){return g.description},set description(b){g.description=b},get badge(){return g.badge},set badge(b){b!==void 0&&y.ViewBadge.isViewBadge(b)?g.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(g.badge=void 0)},reveal:(b,A)=>g.reveal(b,A),dispose:async()=>{await h,this.treeViews.delete(d),g.dispose()}};return this._register(_),_}$getChildren(d,i){const v=this.treeViews.get(d);return v?v.getChildren(i):Promise.reject(new m.NoTreeViewError(d))}async $handleDrop(d,i,v,l,o,S,w,g){const D=this.treeViews.get(d);if(!D)return Promise.reject(new m.NoTreeViewError(d));const h=u.DataTransfer.toDataTransfer(v,async _=>(await this._proxy.$resolveDropFileData(d,i,_)).buffer);return w===d&&g&&await this.addAdditionalTransferItems(h,D,g,o,S),D.onDrop(h,l,o)}async addAdditionalTransferItems(d,i,v,l,o){const S=this.treeDragAndDropService.removeDragOperationTransfer(o);if(S)(await S)?.forEach((w,g)=>{w&&d.set(g,w)});else if(o&&i.handleDrag){const w=i.handleDrag(v,d,l);this.treeDragAndDropService.addDragOperationTransfer(o,w),await w}return d}async $handleDrag(d,i,v,l){const o=this.treeViews.get(d);if(!o)return Promise.reject(new m.NoTreeViewError(d));const S=await this.addAdditionalTransferItems(new y.DataTransfer,o,i,l,v);if(!(!S||l.isCancellationRequested))return u.DataTransfer.from(S)}async $hasResolve(d){const i=this.treeViews.get(d);if(!i)throw new m.NoTreeViewError(d);return i.hasResolve}$resolve(d,i,v){const l=this.treeViews.get(d);if(!l)throw new m.NoTreeViewError(d);return l.resolveTreeItem(i,v)}$setExpanded(d,i,v){const l=this.treeViews.get(d);if(!l)throw new m.NoTreeViewError(d);l.setExpanded(i,v)}$setSelectionAndFocus(d,i,v){const l=this.treeViews.get(d);if(!l)throw new m.NoTreeViewError(d);l.setSelectionAndFocus(i,v)}$setVisible(d,i){const v=this.treeViews.get(d);if(!v){if(!i)return;throw new m.NoTreeViewError(d)}v.setVisible(i)}$changeCheckboxState(d,i){const v=this.treeViews.get(d);if(!v)throw new m.NoTreeViewError(d);v.setCheckboxState(i)}createExtHostTreeView(d,i,v){const l=this._register(new r(d,i,this._proxy,this.commands.converter,this.logService,v));return this.treeViews.set(d,l),l}convertArgument(d){const i=this.treeViews.get(d.$treeViewId);return i&&"$treeItemHandle"in d?i.getExtensionElement(d.$treeItemHandle):i&&"$focusedTreeItem"in d&&d.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=n;class r extends T.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,R.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,i,v,l,o,S){if(super(),this.viewId=d,this.proxy=v,this.commands=l,this.logService=o,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new O.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,S.contributes&&S.contributes.views)for(const h in S.contributes.views)for(const _ of S.contributes.views[h])_.id===d&&(this._title=_.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let w,g;const D=O.Event.debounce(this._onDidChangeData.event,(h,_)=>(h||(h={message:!1,elements:[]}),_.element!==!1&&(w||(w=new Promise(b=>g=b),this.refreshPromise=this.refreshPromise.then(()=>w)),Array.isArray(_.element)?h.elements.push(..._.element):h.elements.push(_.element)),_.message&&(h.message=!0),h),200,!0);this._register(D(({message:h,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=g;return w=null,this.refresh(_).then(()=>b())})),h&&this.proxy.$setMessage(this.viewId,u.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(d){const i=d?this.getExtensionElement(d):void 0;if(d&&!i)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(d);return v||(v=await this.fetchChildrenNodes(i)),v?v.map(l=>l.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,i){i=i||{select:!0,focus:!1};const v=(0,R.isUndefinedOrNull)(i.select)?!0:i.select,l=(0,R.isUndefinedOrNull)(i.focus)?!1:i.focus,o=(0,R.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(S=>this.resolveTreeNode(d,S[S.length-1]).then(w=>this.proxy.$reveal(this.viewId,{item:w.item,parentChain:S.map(g=>g.item)},{select:v,focus:l,expand:o})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:l,expand:o})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=u.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,i){const v=this.getExtensionElement(d);v&&(i?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelectionAndFocus(d,i){const v=!(0,C.equals)(this._selectedHandles,d);this._selectedHandles=d;const l=this._focusedHandle!==i;this._focusedHandle=i,v&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),l&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const i=(await Promise.all(d.map(async v=>{const l=this.getExtensionElement(v.treeItemHandle);return l?{extensionItem:l,treeItem:await this.dataProvider.getTreeItem(l),newState:v.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);i.forEach(v=>{v.treeItem.checkboxState=v.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(v=>[v.extensionItem,v.newState])})}async handleDrag(d,i,v){const l=[];for(const o of d){const S=this.getExtensionElement(o);S&&l.push(S)}if(!(!this.dndController?.handleDrag||l.length===0))return await this.dndController.handleDrag(l,i,v),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,i,v){const l=i?this.getExtensionElement(i):void 0;if(!(!l&&i||!this.dndController?.handleDrop))return(0,f.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(l,d,v):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,i){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(d);if(v){const l=this.nodes.get(v);if(l){const o=await this.dataProvider.resolveTreeItem(l.extensionItem,v,i)??l.extensionItem;return this.validateTreeItem(o),l.item.tooltip=this.getTooltip(o.tooltip),l.item.command=this.getCommand(l.disposableStore,o.command),l.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(i=>i?this.resolveUnknownParentChain(i).then(v=>this.resolveTreeNode(i,v[v.length-1]).then(l=>(v.push(l),v))):Promise.resolve([]))}resolveParent(d){const i=this.nodes.get(d);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,f.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,i){const v=this.nodes.get(d);return v?Promise.resolve(v):(0,f.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(l=>this.createHandle(d,l,i,!0)).then(l=>this.getChildren(i?i.item.handle:void 0).then(()=>{const o=this.getExtensionElement(l);if(o){const S=this.nodes.get(o);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${l} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(d){if(d){let i;if(typeof d=="string"){const v=this.getExtensionElement(d);i=v?this.nodes.get(v):void 0}else i=d;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const i=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=d?this.nodes.get(d):void 0,l=await this.dataProvider.getChildren(d);if(i.token.isCancellationRequested)return;const o=(0,C.coalesce)(l||[]),S=await Promise.all((0,C.coalesce)(o).map(g=>this.dataProvider.getTreeItem(g)));if(i.token.isCancellationRequested)return;const w=S.map((g,D)=>g?this.createAndRegisterTreeNode(o[D],g,v):null);return(0,C.coalesce)(w)}finally{i.dispose()}}refresh(d){if(d.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(d);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const i=new Set,v=d.map(o=>this.nodes.get(o));for(const o of v)if(o&&!i.has(o.item.handle)){let S=o;for(;S&&S.parent&&v.findIndex(w=>S&&S.parent&&w&&w.item.handle===S.parent.item.handle)===-1;){const w=this.elements.get(S.parent.item.handle);S=w?this.nodes.get(w):void 0}S&&!S.parent&&i.add(o.item.handle)}const l=[];return i.forEach(o=>{const S=this.elements.get(o);if(S){const w=this.nodes.get(S);w&&(!w.parent||!i.has(w.parent.item.handle))&&l.push(o)}}),l}refreshHandles(d){const i={};return Promise.all(d.map(v=>this.refreshNode(v).then(l=>{l&&(i[v]=l.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(d){const i=this.getExtensionElement(d);if(i){const v=this.nodes.get(i);if(v)return this.clearChildren(i),(0,f.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(l=>{if(l){const o=this.createTreeNode(i,l,v.parent);return this.updateNodeCache(i,o,v,v.parent),v.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,i,v){const l=this.createTreeNode(d,i,v);if(i.id&&this.elements.has(l.item.handle))throw new Error((0,I.localize)(0,null,i.id));return this.addNodeToCache(d,l),this.addNodeToParentCache(l,v),l}getTooltip(d){return y.MarkdownString.isMarkdownString(d)?u.MarkdownString.from(d):d}getCommand(d,i){return i?{...this.commands.toInternal(i,d),originalId:i.command}:void 0}getCheckbox(d){if(d.checkboxState===void 0)return;let i,v,l;return typeof d.checkboxState=="number"?i=d.checkboxState:(i=d.checkboxState.state,v=d.checkboxState.tooltip,l=d.checkboxState.accessibilityInformation),{isChecked:i===y.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:l}}validateTreeItem(d){if(!y.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,i,v){this.validateTreeItem(i);const l=this._register(new T.DisposableStore),o=this.createHandle(d,i,v),S=this.getLightIconPath(i);return{item:{handle:o,parentHandle:v?v.item.handle:void 0,label:t(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(l,i.command),contextValue:i.contextValue,icon:S,iconDark:this.getDarkIconPath(i)||S,themeIcon:this.getThemeIcon(i),collapsibleState:(0,R.isUndefinedOrNull)(i.collapsibleState)?y.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:v,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(d){return d.iconPath instanceof y.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:i,label:v,resourceUri:l},o,S){if(i)return`${r.ID_HANDLE_PREFIX}/${i}`;const w=t(v,this.extension),g=o?o.item.handle:r.LABEL_HANDLE_PREFIX;let D=w?w.label:l?(0,L.basename)(l):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const h=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,_=this.getChildrenNodes(o)||[];let b,A=0;do{if(b=`${g}/${A}:${D}`,S||!this.elements.has(b)||h===b)break;A++}while(A<=_.length);return b}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon))return typeof d.iconPath=="string"||P.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return P.URI.isUri(d)?d:P.URI.file(d)}addNodeToCache(d,i){this.elements.set(i.item.handle,d),this.nodes.set(d,i)}updateNodeCache(d,i,v,l){this.elements.delete(i.item.handle),this.nodes.delete(d),i.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(d,i);const o=this.getChildrenNodes(l)||[],S=o.filter(w=>w.item.handle===v.item.handle)[0];S&&o.splice(o.indexOf(S),1,i)}addNodeToParentCache(d,i){i?(i.children||(i.children=[]),i.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const i=this.nodes.get(d);if(i){if(i.children)for(const v of i.children){const l=this.elements.get(v.item.handle);l&&this.clear(l)}i.children=void 0}}else this.clearAll()}clear(d){const i=this.nodes.get(d);if(i){if(i.children)for(const v of i.children){const l=this.elements.get(v.item.handle);l&&this.clear(l)}this.nodes.delete(d),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Te[279],Ae([1,0,5,6,2,33,8,62,3,7]),function(fe,e,I,L,P,O,T,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class R extends L.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(p,s,c,t){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new I.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new I.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=p,this.#t=s,this.#n=c,this.#i=t.viewType,this.#s=t.panelOptions,this.#o=t.viewColumn,this.#r=t.title,this.#l=t.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(p){this.assertNotDisposed(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(p){this.assertNotDisposed(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(p){this.#u||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#l=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(p,s){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:T.ViewColumn.from(p),preserveFocus:!!s})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class C extends L.Disposable{static newHandle(){return(0,O.generateUuid)()}constructor(p,s,c){super(),this.webviews=s,this.workspace=c,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(f.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(p=>p.dispose()),this._webviewPanels.clear()}createWebviewPanel(p,s,c,t,n={}){const r=typeof t=="object"?t.viewColumn:t,a={viewColumn:T.ViewColumn.from(r),preserveFocus:typeof t=="object"&&!!t.preserveFocus},d=(0,m.shouldSerializeBuffersForPostMessage)(p),i=C.newHandle();this._proxy.$createWebviewPanel((0,m.toExtensionData)(p),i,s,{title:c,panelOptions:u(n),webviewOptions:(0,m.serializeWebviewOptions)(p,this.workspace,n),serializeBuffersForPostMessage:d},a);const v=this.webviews.createNewWebview(i,n,p);return this.createNewWebviewPanel(i,s,c,r,n,v,!0)}$onDidChangeWebviewPanelViewStates(p){const s=Object.keys(p);s.sort((c,t)=>{const n=p[c],r=p[t];return n.active?1:r.active?-1:+n.visible-+r.visible});for(const c of s){const t=this.getWebviewPanel(c);if(!t)continue;const n=p[c];t._updateViewState({active:n.active,visible:n.visible,viewColumn:T.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,s,c){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:c,extension:p}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,m.shouldSerializeBuffersForPostMessage)(p)}),new y.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(p,s,c,t){const n=this._serializers.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:r,extension:a}=n,d=this.webviews.createNewWebview(p,c.webviewOptions,a),i=this.createNewWebviewPanel(p,s,c.title,t,c.panelOptions,d,c.active);await r.deserializeWebviewPanel(i,c.state)}createNewWebviewPanel(p,s,c,t,n,r,a){const d=new R(p,this._proxy,r,{viewType:s,title:c,viewColumn:t,panelOptions:n,active:a});return this._webviewPanels.set(p,d),d}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=C;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Te[280],Ae([1,0,5,6,62,8,3,7]),function(fe,e,I,L,P,O,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends L.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,u,E,p,s,c){super(),this.#s=!1,this.#l=this._register(new I.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new I.Emitter),this.onDidDispose=this.#u.event,this.#i=E,this.#a=p,this.#e=C,this.#t=u,this.#n=s,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(C){this.assertNotDisposed(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.assertNotDisposed(),this.#o}set description(C){this.assertNotDisposed(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(C){this.assertNotDisposed(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.assertNotDisposed(),this.#t.$show(this.#e,!!C)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(C,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(C,u,E,p){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:E,extension:C}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(C),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(C)}),new m.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(C,u,E,p,s){const c=this._viewProviders.get(u);if(!c)throw new Error(`No view provider found for '${u}'`);const{provider:t,extension:n}=c,r=this._extHostWebview.createNewWebview(C,{},n),a=new f(C,this._proxy,u,E,r,!0);this._webviewViews.set(C,a),await t.resolveWebviewView(a,{state:p},s)}async $onDidChangeWebviewViewVisibility(C,u){this.getWebviewView(C)._setVisible(u)}async $disposeWebviewView(C){const u=this.getWebviewView(C);this._webviewViews.delete(C),u.dispose(),this._extHostWebview.deleteWebview(C)}getWebviewView(C){const u=this._webviewViews.get(C);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=y}),define(Te[281],Ae([1,0,5,30,36,4]),function(fe,e,I,L,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new P.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new P.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new P.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var T;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.channels=new Map,this._onDidRegisterChannel=new I.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new I.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(y){this.channels.has(y.id)||(this.channels.set(y.id,y),this._onDidRegisterChannel.fire(y.id))}getChannels(){const y=[];return this.channels.forEach(R=>y.push(R)),y}getChannel(y){return this.channels.get(y)}removeChannel(y){this.channels.delete(y),this._onDidRemoveChannel.fire(y)}}L.Registry.add(e.Extensions.OutputChannels,new m),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new P.RawContextKey("activeOutputChannel","")}),define(Te[113],Ae([1,0,3,4,17,20,14,281,63,27,43,137,24,16,42,5,6]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class t extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(d,i,v,l,o){super(),this.id=d,this.name=i,this.logger=v,this.proxy=l,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(v.getLevel()),this._register(v.onDidChangeLogLevel(S=>this.setLevel(S)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Clear,d)}replace(d){const i=this.offset;this.info(d),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(d,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:i))}hide(){this.proxy.$close(this.id)}log(d,i){this.offset+=u.VSBuffer.fromString(i).byteLength,(0,T.log)(this.logger,d,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class n extends t{appendLine(d){this.append(d)}}let r=class{constructor(d,i,v,l,o,S){this.initData=i,this.extHostFileSystem=v,this.extHostFileSystemInfo=l,this.loggerService=o,this.logService=S,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(I.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[i,v]of this.channels)v.visible=i===this.visibleChannelId}createOutputChannel(d,i,v){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const l=typeof i=="object"&&i.log,o=(0,E.isString)(i)?i:void 0;if((0,E.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let S;const w=this.initData.environment.extensionLogLevel?.find(([D])=>O.ExtensionIdentifier.equals(v.identifier,D))?.[1];w&&(S=(0,T.parseLogLevel)(w));const g=l?this.doCreateLogOutputChannel(d,S,v):this.doCreateOutputChannel(d,o,v);return g.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),l?this.createExtHostLogOutputChannel(d,S??this.logService.getLevel(),g):this.createExtHostOutputChannel(d,g)}async doCreateOutputChannel(d,i,v){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const l=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),S=this.loggerService.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),w=await this.proxy.$register(d,o,i,v.identifier.value);return new t(w,d,S,this.proxy,v)}async doCreateLogOutputChannel(d,i,v){const l=await this.createExtensionLogDirectory(v),o=d.replace(/[\\/:\*\?"<>\|]/g,""),S=this.extHostFileSystemInfo.extUri.joinPath(l,`${o}.log`),w=`${v.identifier.value}.${o}`,g=this.loggerService.createLogger(S,{id:w,name:d,logLevel:i,extensionId:v.identifier.value});return new n(w,d,g,this.proxy,v)}createExtensionLogDirectory(d){let i=this.extensionLogDirectoryPromise.get(d.identifier.value);if(!i){const v=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,d.identifier.value);this.extensionLogDirectoryPromise.set(d.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(v)}catch(l){if((0,p.toFileSystemProviderErrorCode)(l)!==p.FileSystemProviderErrorCode.FileExists)throw l}return v})())}return i}createExtHostOutputChannel(d,i){let v=!1;const l=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return d},append(o){l(),i.then(S=>S.append(o))},appendLine(o){l(),i.then(S=>S.appendLine(o))},clear(){l(),i.then(o=>o.clear())},replace(o){l(),i.then(S=>S.replace(o))},show(o,S){l(),i.then(w=>w.show(o,S))},hide(){l(),i.then(o=>o.hide())},dispose(){v=!0,i.then(o=>o.dispose())}}}createExtHostLogOutputChannel(d,i,v){const l=new c.DisposableStore,o=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},S=l.add(new s.Emitter);function w(g){i=g,S.fire(g)}return v.then(g=>{l.add(g),g.logLevel!==i&&w(g.logLevel),l.add(g.onDidChangeLogLevel(D=>w(D)))}),{...this.createExtHostOutputChannel(d,v),get logLevel(){return i},onDidChangeLogLevel:S.event,trace(g,...D){o(),v.then(h=>h.trace(g,...D))},debug(g,...D){o(),v.then(h=>h.debug(g,...D))},info(g,...D){o(),v.then(h=>h.info(g,...D))},warn(g,...D){o(),v.then(h=>h.warn(g,...D))},error(g,...D){o(),v.then(h=>h.error(g,...D))},dispose(){l.dispose()}}}};e.ExtHostOutputService=r,e.ExtHostOutputService=r=Ge([Ve(0,P.IExtHostRpcService),Ve(1,y.IExtHostInitDataService),Ve(2,f.IExtHostConsumerFileSystem),Ve(3,R.IExtHostFileSystemInfo),Ve(4,T.ILoggerService),Ve(5,T.ILogService)],r),e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(Te[114],Ae([1,0,4,11]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await P.getRoundTripTime();if(f===void 0)return;O=Math.min(O,f/2),await(0,L.timeout)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(O):T=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:T,current:O,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:typeof T>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(Te[282],Ae([1,0,171,56,30,47,46,6,5,114,21,26,11]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new f.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const p=new E;P.Registry.add(e.Extensions.ConfigurationMigration,p);let s=class extends m.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,r){super(),this.configurationService=n,this.workspaceService=r,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async a=>{for(const d of a.added)await this.migrateConfigurationsForFolder(d,p.migrations)})),this.migrateConfigurations(p.migrations),this._register(p.onDidRegisterConfigurationMigration(a=>this.migrateConfigurations(a)))}async migrateConfigurations(n){await this.migrateConfigurationsForFolder(void 0,n);for(const r of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(r,n)}async migrateConfigurationsForFolder(n,r){await Promise.all([r.map(a=>this.migrateConfigurationsForFolderAndOverride(a,n?.uri))])}async migrateConfigurationsForFolderAndOverride(n,r){const a=this.configurationService.inspect(n.key,{resource:r}),d=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,v]of d){const l=a[i];if(!l)continue;const o=[];if(l.value!==void 0){const S=await this.runMigration(n,i,l.value,r,void 0);for(const w of S??[])o.push([w,[]])}for(const{identifiers:S,value:w}of l.overrides??[])if(w!==void 0){const g=await this.runMigration(n,i,w,r,S);for(const D of g??[])o.push([D,S])}o.length&&await Promise.allSettled(o.map(async([[S,w],g])=>this.configurationService.updateValue(S,w.value,{resource:r,overrideIdentifiers:g},v)))}}async runMigration(n,r,a,d,i){const v=o=>{const w=this.configurationService.inspect(o,{resource:d})[r];if(w)return i?w.overrides?.find(({identifiers:g})=>(0,C.equals)(g,i))?.value:w.value},l=await n.migrateFn(a,v);return Array.isArray(l)?l:[[n.key,l]]}};e.ConfigurationMigrationWorkbenchContribution=s,e.ConfigurationMigrationWorkbenchContribution=s=Ge([Ve(0,T.IConfigurationService),Ve(1,O.IWorkspaceContextService)],s);let c=class extends m.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.remoteAgentService=n,this._ready=new u.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!R.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==1)return;P.Registry.as(L.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.DynamicWorkbenchSecurityConfiguration=c,e.DynamicWorkbenchSecurityConfiguration=c=Ge([Ve(0,y.IRemoteAgentService)],c)}),define(Te[283],Ae([1,0,35,12,19,25,179,282,56,4,30]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.globMatchesResource=e.priorityToRank=e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.IEditorResolverService=(0,y.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const C=R.Registry.as(f.Extensions.Configuration),u={...m.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(u);var E;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(E||(e.RegisteredEditorPriority=E={}));var p;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function s(t){switch(t){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.priorityToRank=s;function c(t,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const d=typeof t=="string"&&t.indexOf(P.posix.sep)>=0?`${n.scheme}:${n.path}`:(0,O.basename)(n);return I.match(typeof t=="string"?t.toLowerCase():t,d.toLowerCase())}e.globMatchesResource=c}),define(Te[284],Ae([1,0,45,12,19,21,25,2,4,200,47,218,114]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,f.createDecorator)("pathService");let p=E=class{constructor(c,t,n,r){this.localUserHome=c,this.remoteAgentService=t,this.environmentService=n,this.contextService=r,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||O.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome??c})()}hasValidBasename(c,t,n){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(r=>this.doHasValidBasename(c,r,t)):this.doHasValidBasename(c,t,n)}doHasValidBasename(c,t,n){return c.scheme===L.Schemas.file||c.scheme===L.Schemas.vscodeRemote?(0,I.isValidBasename)(n??(0,T.basename)(c),t===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,t){if(c.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,y.getVirtualWorkspaceScheme)(t.getWorkspace());if(n)return n;const r=t.getWorkspace().folders[0];if(r)return r.uri.scheme;const a=t.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?P.win32:P.posix)}async fileURI(c){let t="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const r=c.indexOf("/",2);r===-1?(t=c.substring(2),c="/"):(t=c.substring(2,r),c=c.substring(r)||"/")}return m.URI.from({scheme:L.Schemas.file,authority:t,path:c,query:"",fragment:""})}};e.AbstractPathService=p,e.AbstractPathService=p=E=Ge([Ve(1,u.IRemoteAgentService),Ve(2,C.IWorkbenchEnvironmentService),Ve(3,R.IWorkspaceContextService)],p)}),define(Te[115],Ae([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class I{constructor(T,m){this.line=T,this.character=m}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,m){return new I(0,0)}with(T){return new I(0,0)}}e.Position=I;class L{constructor(T,m,f,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(T,m),this.end=new I(f,y)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Te[44],Ae([1,0,18,35,26,45,13,4,19,15,115,11]),function(fe,e,I,L,P,O,T,m,f,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",E=" characters skipped \u27EB",p=(u.length+E.length+5)*2;e.ISearchService=(0,m.createDecorator)("searchService");var s;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(s||(e.SearchProviderType=s={}));var c;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(c||(e.QueryType=c={}));function t(de){return!!de.preview}e.resultIsMatch=t;function n(de){return!!de.resource}e.isFileMatch=n;function r(de){return!!de.message}e.isProgressMessage=r;var a;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class d{constructor(Ee){this.resource=Ee,this.results=[]}}e.FileMatch=d;class i{constructor(Ee,se,pe,ee){this.ranges=se,this.webviewIndex=ee;const X=Array.isArray(se)?se:[se];if(pe&&pe.matchLines===1&&v(X)){Ee=(0,T.getNLines)(Ee,pe.matchLines);let V="",ne=0,Ie=0;const Fe=Math.floor(pe.charsPerLine/5),ke=[];for(const we of X){const me=Math.max(we.startColumn-Fe,0),K=we.startColumn+pe.charsPerLine;if(me>Ie+Fe+p){const J=u+(me-Ie)+E;V+=J+Ee.slice(me,K),ne+=me-(Ie+J.length)}else V+=Ee.slice(Ie,K);ke.push(new o(0,we.startColumn-ne,we.endColumn-ne)),Ie=K}this.preview={text:V,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:Ee,matches:(0,I.mapArrayOrNot)(se,ne=>new l(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.TextSearchMatch=i;function v(de){const Ee=de[0].startLineNumber;for(const se of de)if(se.startLineNumber!==Ee||se.endLineNumber!==Ee)return!1;return!0}class l{constructor(Ee,se,pe,ee){this.startLineNumber=Ee,this.startColumn=se,this.endLineNumber=pe,this.endColumn=ee}}e.SearchRange=l;class o extends l{constructor(Ee,se,pe){super(Ee,se,Ee,pe)}}e.OneLineRange=o;var S;(function(de){de.List="list",de.Tree="tree"})(S||(e.ViewMode=S={}));var w;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(w||(e.SearchSortOrder=w={}));function g(de,Ee=!0){const se=de&&de.files&&de.files.exclude,pe=Ee&&de&&de.search&&de.search.exclude;if(!se&&!pe)return;if(!se||!pe)return se||pe;let ee=Object.create(null);return ee=P.mixin(ee,P.deepClone(se)),ee=P.mixin(ee,P.deepClone(pe),!0),ee}e.getExcludes=g;function D(de,Ee){return de.excludePattern&&L.match(de.excludePattern,Ee)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&L.match(de.includePattern,Ee)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(se=>{const pe=se.folder.fsPath;if(O.isEqualOrParent(Ee,pe)){const ee=f.relative(pe,Ee);return!se.includePattern||!!L.match(se.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=D;var h;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class _ extends Error{constructor(Ee,se){super(Ee),this.code=se}}e.SearchError=_;function b(de){const Ee=de.message;if((0,y.isCancellationError)(de))return new _(Ee,h.canceled);try{const se=JSON.parse(Ee);return new _(se.message,se.code)}catch{return new _(Ee,h.other)}}e.deserializeSearchError=b;function A(de){const Ee={message:de.message,code:de.code};return new Error(JSON.stringify(Ee))}e.serializeSearchError=A;function F(de){return de.type==="error"?!0:de.type==="success"}e.isSerializedSearchComplete=F;function j(de){return de.type==="success"}e.isSerializedSearchSuccess=j;function H(de){return!!de.path}e.isSerializedFileMatch=H;function B(de,Ee,se=!0){const pe=de.searchPath?de.searchPath:de.relativePath;return se?(0,T.fuzzyContains)(pe,Ee):L.match(Ee,pe)}e.isFilePatternMatch=B;class k{constructor(Ee){this.path=Ee,this.results=[]}addMatch(Ee){this.results.push(Ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=k;function N(de,Ee){const se={...de||{},...Ee||{}};return Object.keys(se).filter(pe=>{const ee=se[pe];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=N;class ${constructor(Ee,se){this._parsedIncludeExpression=null,this._excludeExpression={...Ee.excludePattern||{},...se.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let pe=Ee.includePattern;se.includePattern&&(pe?pe={...pe,...se.includePattern}:pe=se.includePattern),pe&&(this._parsedIncludeExpression=L.parse(pe))}matchesExcludesSync(Ee,se,pe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,se,pe))}includedInQuerySync(Ee,se,pe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,se,pe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Ee,se,pe))}includedInQuery(Ee,se,pe){const ee=this._parsedExcludeExpression(Ee,se,pe),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Ee,se,pe):!0;return(0,C.isThenable)(ee)?ee.then(V=>V?!1:X()):X()}hasSiblingExcludeClauses(){return re(this._excludeExpression)}}e.QueryGlobTester=$;function re(de){for(const Ee in de)if(typeof de[Ee]!="boolean")return!0;return!1}function le(de){if(!de)return;let Ee;return se=>(Ee||(Ee=(de()||Promise.resolve([])).then(pe=>pe?ye(pe):{})),Ee.then(pe=>!!pe[se]))}e.hasSiblingPromiseFn=le;function _e(de){if(!de)return;let Ee;return se=>{if(!Ee){const pe=de();Ee=pe?ye(pe):{}}return!!Ee[se]}}e.hasSiblingFn=_e;function ye(de){const Ee={};for(const se of de)Ee[se]=!0;return Ee}}),define(Te[37],Ae([1,0,18,11,22,5,6,50,12,123,25,13,2,170,4,14,189,47,43,27,17,8,7,59,44,3,52]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v,l,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function w(j,H,B){return new R.ExtUri(k=>_(k,B)).isEqual(j,H)}function g(j,H,B){return w(j.uri,H.uri,B)?0:(0,C.compare)(j.uri.toString(),H.uri.toString())}function D(j,H,B){return j.index!==H.index?j.index<H.index?-1:1:w(j.uri,H.uri,B)?(0,C.compare)(j.name,H.name):(0,C.compare)(j.uri.toString(),H.uri.toString())}function h(j,H,B,k){const N=j.slice(0).sort((re,le)=>B(re,le,k)),$=H.slice(0).sort((re,le)=>B(re,le,k));return(0,I.delta)(N,$,(re,le)=>B(re,le,k))}function _(j,H){const B=H.getCapabilities(j.scheme);return!(B&&B&1024)}class b extends t.Workspace{static toExtHostWorkspace(H,B,k,N){if(!H)return{workspace:null,added:[],removed:[]};const{id:$,name:re,folders:le,configuration:_e,transient:ye,isUntitled:de}=H,Ee=[],se=B;B?le.forEach((V,ne)=>{const Ie=u.URI.revive(V.uri),Fe=b._findFolder(k||B,Ie,N);Fe?(Fe.name=V.name,Fe.index=V.index,Ee.push(Fe)):Ee.push({uri:Ie,name:V.name,index:ne})}):Ee.push(...le.map(({uri:V,name:ne,index:Ie})=>({uri:u.URI.revive(V),name:ne,index:Ie}))),Ee.sort((V,ne)=>V.index<ne.index?-1:1);const pe=new b($,re,Ee,!!ye,_e?u.URI.revive(_e):null,!!de,V=>_(V,N)),{added:ee,removed:X}=h(se?se.workspaceFolders:[],pe.workspaceFolders,g,N);return{workspace:pe,added:ee,removed:X}}static _findFolder(H,B,k){for(let N=0;N<H.folders.length;N++){const $=H.workspaceFolders[N];if(w($.uri,B,k))return $}}constructor(H,B,k,N,$,re,le){super(H,k.map(_e=>new t.WorkspaceFolder(_e)),N,$,le),this._name=B,this._isUntitled=re,this._workspaceFolders=[],this._structure=m.TernarySearchTree.forUris(le),k.forEach(_e=>{this._workspaceFolders.push(_e),this._structure.set(_e.uri,_e)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(H,B){return B&&this._structure.get(H)&&(H=(0,R.dirname)(H)),this._structure.findSubstr(H)}resolveWorkspaceFolder(H){return this._structure.get(H)}}let A=class{constructor(H,B,k,N,$){this._onDidChangeWorkspace=new O.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new O.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new O.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=N,this._extHostFileSystemInfo=k,this._uriTransformerService=$,this._requestIdProvider=new y.Counter,this._barrier=new L.Barrier,this._proxy=H.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=H.getProxy(o.MainContext.MainThreadMessageService);const re=B.workspace;this._confirmedWorkspace=re?new b(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,le=>_(le,k)):void 0}$initializeWorkspace(H,B){this._trusted=B,this.$acceptWorkspaceData(H),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:f.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(H,B,k,...N){const $=[];if(Array.isArray(N)&&N.forEach(de=>{u.URI.isUri(de.uri)&&!$.some(Ee=>w(Ee.uri,de.uri,this._extHostFileSystemInfo))&&$.push({uri:de.uri,name:de.name||(0,R.basenameOrAuthority)(de.uri)})}),this._unconfirmedWorkspace||[B,k].some(de=>typeof de!="number"||de<0)||k===0&&$.length===0)return!1;const re=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+k>re.length)return!1;const le=re.slice(0);le.splice(B,k,...$.map(de=>({uri:de.uri,name:de.name||(0,R.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<le.length;de++){const Ee=le[de];if(le.some((se,pe)=>pe!==de&&w(Ee.uri,se.uri,this._extHostFileSystemInfo)))return!1}le.forEach((de,Ee)=>de.index=Ee);const{added:_e,removed:ye}=h(re,le,D,this._extHostFileSystemInfo);if(_e.length===0&&ye.length===0)return!1;if(this._proxy){const de=H.displayName||H.name;this._proxy.$updateWorkspaceFolders(de,B,k,$).then(void 0,Ee=>{this._unconfirmedWorkspace=void 0;const se={source:{identifier:H.identifier,label:H.displayName||H.name}};this._messageService.$showMessage(c.Severity.Error,(0,E.localize)(0,null,de,Ee.toString()),se,[])})}return this.trySetWorkspaceFolders(le),!0}getWorkspaceFolder(H,B){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,B)}async getWorkspaceFolder2(H,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(H,B)}async resolveWorkspaceFolder(H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(H)}getPath(){if(!this._actualWorkspace)return;const{folders:H}=this._actualWorkspace;if(H.length!==0)return H[0].uri.fsPath}getRelativePath(H,B){let k,N="";if(typeof H=="string"?(k=u.URI.file(H),N=H):typeof H<"u"&&(k=H,N=H.fsPath),!k)return N;const $=this.getWorkspaceFolder(k,!0);if(!$)return N;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let re=(0,R.relativePath)($.uri,k);return B&&$.name&&(re=`${$.name}/${re}`),re}trySetWorkspaceFolders(H){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:H,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(H){const{workspace:B,added:k,removed:N}=b.toExtHostWorkspace(H,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:k,removed:N}))}findFiles(H,B,k,N,$=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let re="",le=!0;return B===null?le=!1:B!==void 0&&(typeof B=="string"?re=B:re=B.pattern),this._findFilesImpl(H,void 0,{exclude:re,maxResults:k,useDefaultExcludes:le,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},$)}findFiles2(H,B={},k,N=P.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${k.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,H,B,N)}async _findFilesImpl(H,B,k,N=P.CancellationToken.None){if(N&&N.isCancellationRequested)return Promise.resolve([]);const $=typeof k.exclude=="string"?k.exclude:k.exclude?k.exclude.pattern:void 0,re={ignoreSymlinks:typeof k.followSymlinks=="boolean"?!k.followSymlinks:void 0,disregardIgnoreFiles:typeof k.useIgnoreFiles=="boolean"?!k.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof k.useGlobalIgnoreFiles=="boolean"?!k.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof k.useParentIgnoreFiles=="boolean"?!k.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof k.useDefaultExcludes=="boolean"?!k.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof k.useDefaultSearchExcludes=="boolean"?!k.useDefaultSearchExcludes:!1,maxResults:k.maxResults,excludePattern:$,shouldGlobSearch:typeof k.fuzzy=="boolean"?!k.fuzzy:!0,_reason:"startFileSearch"};let le;if(H){const{includePattern:_e,folder:ye}=F(d.GlobPattern.from(H));le=ye,re.includePattern=_e}else{const{includePattern:_e,folder:ye}=F(d.GlobPattern.from(B));le=ye,re.filePattern=_e}return this._proxy.$startFileSearch(le??null,re,N).then(_e=>Array.isArray(_e)?_e.map(ye=>u.URI.revive(ye)):[])}async findTextInFiles(H,B,k,N,$=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const re=this._requestIdProvider.getNext(),le=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:_e,folder:ye}=F(d.GlobPattern.from(B.include)),de=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,Ee={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:le,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:_e,excludePattern:de},se=!1;if(this._activeSearchCallbacks[re]=pe=>{if(se)return;const ee=u.URI.revive(pe.resource);pe.results.forEach(X=>{const V=(0,S.revive)(X);(0,l.resultIsMatch)(V)?k({uri:ee,preview:{text:V.preview.text,matches:(0,I.mapArrayOrNot)(V.preview.matches,ne=>new i.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,I.mapArrayOrNot)(V.ranges,ne=>new i.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):k({uri:ee,text:V.text,lineNumber:V.lineNumber})})},$.isCancellationRequested)return{};try{const pe=await this._proxy.$startTextSearch(H,ye??null,Ee,re,$);return delete this._activeSearchCallbacks[re],pe||{}}catch(pe){throw delete this._activeSearchCallbacks[re],pe}}$handleTextSearchResult(H,B){this._activeSearchCallbacks[B]?.(H)}async save(H){const B=await this._proxy.$save(H,{saveAs:!1});return u.URI.revive(B)}async saveAs(H){const B=await this._proxy.$save(H,{saveAs:!0});return u.URI.revive(B)}saveAll(H){return this._proxy.$saveAll(H)}resolveProxy(H){return this._proxy.$resolveProxy(H)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(H){return this._proxy.$requestWorkspaceTrust(H)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(H,B){if(this._editSessionIdentityProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._editSessionIdentityProviders.set(H,B);const k=this._uriTransformerService.transformOutgoingScheme(H),N=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(N,k),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(H),this._proxy.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(H,B){this._logService.info("Getting edit session identifier for workspaceFolder",H);const k=await this.resolveWorkspaceFolder(u.URI.revive(H));if(!k){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",k);const N=this._editSessionIdentityProviders.get(k.uri.scheme);if(this._logService.info(`Provider for scheme ${k.uri.scheme} is defined: `,!!N),!N)return;const $=await N.provideEditSessionIdentity(k,B);if(this._logService.info("Provider returned edit session identifier: ",$),!!$)return $}async $provideEditSessionIdentityMatch(H,B,k,N){this._logService.info("Getting edit session identifier for workspaceFolder",H);const $=await this.resolveWorkspaceFolder(u.URI.revive(H));if(!$){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const re=this._editSessionIdentityProviders.get($.uri.scheme);if(this._logService.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!re),!re)return;const le=await re.provideEditSessionIdentityMatch?.(B,k,N);if(this._logService.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(H){return(B,k,N)=>{const $=function(le){B.call(k,le)};return $.extension=H,this._onWillCreateEditSessionIdentityEvent.event($,void 0,N)}}async $onWillCreateEditSessionIdentity(H,B,k){const N=await this.resolveWorkspaceFolder(u.URI.revive(H));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:N},B,async($,re)=>{const le=Date.now();await Promise.resolve($),Date.now()-le>k&&this._logService.warn("SLOW edit session create-participant",re.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(H,B){if(this._canonicalUriProviders.has(H))throw new Error(`A provider has already been registered for scheme ${H}`);this._canonicalUriProviders.set(H,B);const k=this._uriTransformerService.transformOutgoingScheme(H),N=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(N,k),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(H),this._proxy.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(H,B,k){const N=this._canonicalUriProviders.get(H.scheme);if(!N)return;const $=await N.provideCanonicalUri?.(u.URI.revive(H),B,k);if($)return $}async $provideCanonicalUri(H,B,k){return this.provideCanonicalUri(u.URI.revive(H),{targetScheme:B},k)}};e.ExtHostWorkspace=A,e.ExtHostWorkspace=A=Ge([Ve(0,a.IExtHostRpcService),Ve(1,r.IExtHostInitDataService),Ve(2,n.IExtHostFileSystemInfo),Ve(3,s.ILogService),Ve(4,v.IURITransformerService)],A),e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function F(j){let H,B;return j&&(typeof j=="string"?H=j:(H=j.pattern,B=u.URI.revive(j.baseUri))),{includePattern:H,folder:B}}}),define(Te[38],Ae([1,0,26,5,37,3,7,191,56,16,11,4,17,14,2]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(v,l){if(l){const o=l.split(".");let S=v;for(let w=0;S&&w<o.length;w++)S=S[o[w]];return S}}function c(v){return v instanceof p.URI}function t(v){return v&&v.uri instanceof p.URI&&v.languageId&&typeof v.languageId=="string"}function n(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function r(v){return v&&v.uri instanceof p.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(c(v))return{resource:v};if(t(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(n(v))return{overrideIdentifier:v.languageId};if(r(v))return{resource:v.uri};if(v===null)return{resource:null}}let d=class{constructor(l,o,S){this._proxy=l.getProxy(O.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=S,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new i(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,o){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(l,o))}};e.ExtHostConfiguration=d,e.ExtHostConfiguration=d=Ge([Ve(0,u.IExtHostRpcService),Ve(1,P.IExtHostWorkspace),Ve(2,E.ILogService)],d);class i{constructor(l,o,S,w){this._onDidChangeConfiguration=new L.Emitter,this._proxy=l,this._logService=w,this._extHostWorkspace=o,this._configuration=m.Configuration.parse(S),this._configurationScopes=this._toMap(S.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,o){const S={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=m.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,S))}getConfiguration(l,o,S){const w=a(o)||{},g=this._toReadonlyValue(l?s(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,w,S?.identifier);function D(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(_){return typeof s(g,_)<"u"},get:(_,b)=>{this._validateConfigurationAccess(l?`${l}.${_}`:_,w,S?.identifier);let A=s(g,_);if(typeof A>"u")A=b;else{let F;const j=(H,B)=>{if((0,y.isObject)(H)){let k;const N=()=>{F=F||(0,I.deepClone)(g),k=k||s(F,B)};return new Proxy(H,{get:($,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return N(),()=>k;if(F)return k=k||s(F,B),k[re];const le=$[re];return typeof re=="string"?j(le,`${B}.${re}`):le},set:($,re,le)=>(N(),k&&(k[re]=le),!0),deleteProperty:($,re)=>(N(),k&&delete k[re],!0),defineProperty:($,re,le)=>(N(),k&&Object.defineProperty(k,re,le),!0)})}return Array.isArray(H)?(0,I.deepClone)(H):H};A=j(A,_)}return A},update:(_,b,A,F)=>{_=l?`${l}.${_}`:_;const j=D(A);return b!==void 0?this._proxy.$updateConfigurationOption(j,_,b,w,F):this._proxy.$removeConfigurationOption(j,_,w,F)},inspect:_=>{_=l?`${l}.${_}`:_;const b=this._configuration.inspect(_,w,this._extHostWorkspace.workspace);if(b)return{key:_,defaultValue:(0,I.deepClone)(b.policy?.value??b.default?.value),globalValue:(0,I.deepClone)(b.user?.value??b.application?.value),workspaceValue:(0,I.deepClone)(b.workspace?.value),workspaceFolderValue:(0,I.deepClone)(b.workspaceFolder?.value),defaultLanguageValue:(0,I.deepClone)(b.default?.override),globalLanguageValue:(0,I.deepClone)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,I.deepClone)(b.workspace?.override),workspaceFolderLanguageValue:(0,I.deepClone)(b.workspaceFolder?.override),languageIds:(0,I.deepClone)(b.overrideIdentifiers)}}};return typeof g=="object"&&(0,I.mixin)(h,g,!1),Object.freeze(h)}_toReadonlyValue(l){const o=S=>(0,y.isObject)(S)?new Proxy(S,{get:(w,g)=>o(w[g]),set:(w,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(w,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(w,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return o(l)}_validateConfigurationAccess(l,o,S){const w=f.OVERRIDE_PROPERTY_REGEX.test(l)?4:this._configurationScopes.get(l),g=S?`[${S.value}] `:"";if(w===4){typeof o?.resource>"u"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){o?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,o){const S=new m.ConfigurationChangeEvent(l,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,g)=>S.affectsConfiguration(w,a(g))})}_toMap(l){return l.reduce((o,S)=>(o.set(S[0],S[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")}),define(Te[116],Ae([1,0,2,11,5,3,7,37,67,38,22,66,17,27,4,12,21,14,78,223,15]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(j){function H(k){if(k!=null)return k}j.from=H;function B(k){if(k!=null)return k}j.to=B})(d||(d={}));var i;(function(j){function H(k){if(k!=null)return k}j.from=H;function B(k){if(k!=null)return k}j.to=B})(i||(i={}));var v;(function(j){function H(k){if(k!=null)return k}j.from=H;function B(k){if(k!=null)return k}j.to=B})(v||(v={}));var l;(function(j){function H(N){if(N){const $=N;return $&&!!$.process}else return!1}j.is=H;function B(N){if(N==null)return;const $={process:N.process,args:N.args};return N.options&&($.options=v.from(N.options)),$}j.from=B;function k(N){if(N!=null)return new T.ProcessExecution(N.process,N.args,N.options)}j.to=k})(l||(l={}));var o;(function(j){function H(k){if(k!=null)return k}j.from=H;function B(k){if(k!=null)return k}j.to=B})(o||(o={}));var S;(function(j){function H(N){if(N){const $=N;return $&&(!!$.commandLine||!!$.command)}else return!1}j.is=H;function B(N){if(N==null)return;const $={};return N.commandLine!==void 0?$.commandLine=N.commandLine:($.command=N.command,$.args=N.args),N.options&&($.options=o.from(N.options)),$}j.from=B;function k(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new T.ShellExecution(N.commandLine,N.options):new T.ShellExecution(N.command,N.args?N.args:[],N.options)}j.to=k})(S||(S={}));var w;(function(j){function H(N){if(N){const $=N;return $&&$.customExecution==="customExecution"}else return!1}j.is=H;function B(N){return{customExecution:"customExecution"}}j.from=B;function k(N,$){return $.get(N)}j.to=k})(w||(e.CustomExecutionDTO=w={}));var g;(function(j){function H(B,k){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===T.TaskScope.Workspace&&k&&k.workspaceFile?N=k.workspaceFile:N=r.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:N}}j.from=H})(g||(e.TaskHandleDTO=g={}));var D;(function(j){function H(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}j.from=H})(D||(D={}));var h;(function(j){function H(N,$){if(N==null)return[];const re=[];for(const le of N){const _e=B(le,$);_e&&re.push(_e)}return re}j.fromMany=H;function B(N,$){if(N==null)return;let re;N.execution instanceof T.ProcessExecution?re=l.from(N.execution):N.execution instanceof T.ShellExecution?re=S.from(N.execution):N.execution&&N.execution instanceof T.CustomExecution&&(re=w.from(N.execution));const le=d.from(N.definition);let _e;return N.scope?typeof N.scope=="number"?_e=N.scope:_e=N.scope.uri:_e=T.TaskScope.Workspace,!le||!_e?void 0:{_id:N._id,definition:le,name:N.name,source:{extensionId:$.identifier.value,label:N.source,scope:_e},execution:re,isBackground:N.isBackground,group:D.from(N.group),presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}j.from=B;async function k(N,$,re){if(N==null)return;let le;l.is(N.execution)?le=l.to(N.execution):S.is(N.execution)?le=S.to(N.execution):w.is(N.execution)&&(le=w.to(N._id,re));const _e=d.to(N.definition);let ye;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?ye=N.source.scope:ye=await $.resolveWorkspaceFolder(I.URI.revive(N.source.scope)):ye=T.TaskScope.Workspace),!_e||!ye)return;const de=new T.Task(_e,ye,N.name,N.source.label,le,N.problemMatchers);return N.isBackground!==void 0&&(de.isBackground=N.isBackground),N.group!==void 0&&(de.group=T.TaskGroup.from(N.group._id),de.group&&N.group.isDefault&&(de.group=new T.TaskGroup(de.group.id,de.group.label),N.group.isDefault===!0&&(de.group.isDefault=N.group.isDefault))),N.presentationOptions&&(de.presentationOptions=i.to(N.presentationOptions)),N._id&&(de._id=N._id),N.detail&&(de.detail=N.detail),de}j.to=k})(h||(e.TaskDTO=h={}));var _;(function(j){function H(k){return k}j.from=H;function B(k){if(k)return Object.assign(Object.create(null),k)}j.to=B})(_||(_={}));class b{#e;constructor(H,B,k){this._id=B,this._task=k,this.#e=H}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}let A=class{constructor(H,B,k,N,$,re,le,_e){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=H.getProxy(O.MainContext.MainThreadTask),this._workspaceProvider=k,this._editorService=N,this._configurationService=$,this._terminalService=re,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=le,this._deprecationService=_e,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,B,k){if(!k)return new T.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:B,provider:k,extension:H}),this._proxy.$registerTaskProvider(N,B),new T.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(H,B){this._proxy.$registerTaskSystem(H,B)}fetchTasks(H){return this._proxy.$fetchTasks(_.from(H)).then(async B=>{const k=[];for(const N of B){const $=await h.to(N,this._workspaceProvider,this._providedCustomExecutions2);$&&k.push($)}return k})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(B=>H.push(B)),H}terminateTask(H){if(!(H instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,B,k){const N=this._providedCustomExecutions2.get(H.id);N&&(this._activeCustomExecutions2.set(H.id,N),this._terminalService.attachPtyToTerminal(B,await N.callback(k))),this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){if(!this._taskExecutionPromises.has(H.id))return;const B=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const B=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:B,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const B=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:H.exitCode})}$provideTasks(H,B){const k=this._handlers.get(H);if(!k)return Promise.reject(new Error("no handler found"));const N=[],$=(0,L.asPromise)(()=>k.provider.provideTasks(R.CancellationToken.None)).then(re=>this.provideTasksInternal(B,N,k,re));return new Promise(re=>{$.then(le=>{Promise.all(N).then(()=>{re(le)})})})}async $resolveTask(H,B){const k=this._handlers.get(H);if(!k)return Promise.reject(new Error("no handler found"));if(B.definition.type!==k.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${k.type}].`);const N=await h.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const $=await k.provider.resolveTask(N,R.CancellationToken.None);if(!$)return;this.checkDeprecation($,k);const re=h.from($,k.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if($.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(re.execution)&&await this.addCustomExecution(re,$,!0),await this.resolveTaskInternal(re)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,B,k){const N=await this._proxy.$createTaskId(H);!k&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,B.execution)),this._providedCustomExecutions2.set(N,B.execution)}async getTaskExecution(H,B){if(typeof H=="string"){const $=this._taskExecutionPromises.get(H);if(!$)throw new a.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return $}const k=this._taskExecutionPromises.get(H.id);if(k)return k;let N;return B?N=Promise.resolve(new b(this,H.id,B)):N=h.to(H.task,this._workspaceProvider,this._providedCustomExecutions2).then($=>{if(!$)throw new a.ErrorNoTelemetry("Unexpected: Task does not exist.");return new b(this,H.id,$)}),this._taskExecutionPromises.set(H.id,N),N.then($=>(this._taskExecutions.set(H.id,$),$))}checkDeprecation(H,B){H._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));const k=this._notProvidedCustomExecutions.values();let N=k.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=k.next()}};e.ExtHostTaskBase=A,e.ExtHostTaskBase=A=Ge([Ve(0,u.IExtHostRpcService),Ve(1,E.IExtHostInitDataService),Ve(2,m.IExtHostWorkspace),Ve(3,f.IExtHostDocumentsAndEditors),Ve(4,y.IExtHostConfiguration),Ve(5,C.IExtHostTerminalService),Ve(6,t.ILogService),Ve(7,n.IExtHostApiDeprecationService)],A);let F=class extends A{constructor(H,B,k,N,$,re,le,_e){super(H,B,k,N,$,re,le,_e),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(H,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const k=h.from(B,H);if(k===void 0)throw new Error("Task is not valid");if(w.is(k.execution))await this.addCustomExecution(k,B,!1);else throw new a.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(k),B);return this._proxy.$executeTask(k).catch($=>{throw new Error($)}),N}provideTasksInternal(H,B,k,N){const $=[];if(N)for(const re of N){if(this.checkDeprecation(re,k),!re.definition||!H[re.definition.type]){const _e=re.source?re.source:"No task source";this._logService.warn(`The task [${_e}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=h.from(re,k.extension);le&&w.is(le.execution)?($.push(le),B.push(this.addCustomExecution(le,re,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:$,extension:k.extension}}async resolveTaskInternal(H){if(w.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,B,k){}};e.WorkerExtHostTask=F,e.WorkerExtHostTask=F=Ge([Ve(0,u.IExtHostRpcService),Ve(1,E.IExtHostInitDataService),Ve(2,m.IExtHostWorkspace),Ve(3,f.IExtHostDocumentsAndEditors),Ve(4,y.IExtHostConfiguration),Ve(5,C.IExtHostTerminalService),Ve(6,t.ILogService),Ve(7,n.IExtHostApiDeprecationService)],F),e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Te[285],Ae([1,0,44,29]),function(fe,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.genericCellMatchesToTextSearchMatches=e.rawCellPrefix=e.isINotebookFileMatchNoModel=void 0;function P(T){return"cellResults"in T}e.isINotebookFileMatchNoModel=P,e.rawCellPrefix="rawCell#";function O(T,m){let f=-1;const y=[];let R=[];return T.forEach(u=>{u.range.startLineNumber!==f&&R.length>0&&(y.push([...R]),R=[]),R.push(u),f=u.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(u=>{const E=[],p=u[0].range.startLineNumber,s=u[u.length-1].range.endLineNumber;for(let c=p;c<=s;c++)E.push(m.getLineContent(c));return new I.TextSearchMatch(E.join(`
`)+`
`,u.map(c=>new L.Range(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.genericCellMatchesToTextSearchMatches=O}),define(Te[286],Ae([1,0,164,24,5,6,28,13,16,2,42,74,3,31,8,7,49,261,110,26,12,213,285,283]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(S=>S.apiEditor)}constructor(S,w,g,D,h,_){this._textDocumentsAndEditors=g,this._textDocuments=D,this._extHostFileSystem=h,this._extHostSearch=_,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new C.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=S.getProxy(u.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=S.getProxy(u.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=S.getProxy(u.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===13){const A=b.notebookEditor?.notebookUri,F=b.cell.handle,H=this._documents.get(A)?.getCell(F);if(H)return H.apiCell}if(b&&b.$mid===14){const A=b.uri,F=this._documents.get(A);if(F)return F.apiNotebook}return b}}),l._registerApiCommands(w)}getEditorById(S){const w=this._editors.get(S);if(!w)throw new Error(`unknown text editor: ${S}. known editors: ${[...this._editors.keys()]} `);return w}getIdByEditor(S){for(const[w,g]of this._editors)if(g.apiEditor===S)return w}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(S,w){const g=this._documents.get(S);if(!g&&!w)throw new Error(`NO notebook document for '${S}'`);return g}static _convertNotebookRegistrationData(S,w){if(!w)return;const g=w.filenamePattern.map(D=>p.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(w.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:w.displayName,filenamePattern:g,exclusive:w.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,w,g){const D=l._notebookStatusBarItemProviderHandlePool++,h=typeof g.onDidChangeCellStatusBarItems=="function"?l._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,h,w);let _;return h!==void 0&&(_=g.onDidChangeCellStatusBarItems(b=>this._notebookProxy.$emitCellStatusBarEvent(h))),new s.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,h),_?.dispose()})}async createNotebookDocument(S){const w=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:S.viewType,content:S.content&&p.NotebookData.from(S.content)});return y.URI.revive(w)}async openNotebookDocument(S){const w=this._documents.get(S);if(w)return w.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(S),D=this._documents.get(y.URI.revive(g));return(0,f.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(S,w){y.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let g;typeof w=="object"?g={position:p.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(p.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:g={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(S.uri,S.notebookType,g),h=D&&this._editors.get(D)?.apiEditor;if(h)return h;throw D?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,w,g,D){const h=this._notebookStatusBarItemProviders.get(S),_=y.URI.revive(w),b=this._documents.get(_);if(!b||!h)return;const A=b.getCellFromIndex(g);if(!A)return;const F=await h.provideCellStatusBarItems(A.apiCell,D);if(!F)return;const j=new O.DisposableStore,H=this._statusBarCache.add([j]),k=(Array.isArray(F)?F:[F]).map(N=>p.NotebookStatusBarItem.from(N,this._commandsConverter,j));return{cacheId:H,items:k}}$releaseNotebookCellStatusBarItems(S){this._statusBarCache.delete(S)}registerNotebookSerializer(S,w,g,D,h){if((0,m.isFalsyOrWhitespace)(w))throw new Error("viewType cannot be empty or just whitespace");const _=this._handlePool++;return this._notebookSerializer.set(_,{viewType:w,serializer:g,options:D}),this._notebookProxy.$registerNotebookSerializer(_,{id:S.identifier,location:S.extensionLocation},w,p.NotebookDocumentContentOptions.from(D),l._convertNotebookRegistrationData(S,h)),(0,O.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(_)})}async $dataToNotebook(S,w,g){const D=this._notebookSerializer.get(S);if(!D)throw new Error("NO serializer found");const h=await D.serializer.deserializeNotebook(w.buffer,g);return new c.SerializableObjectWithBuffers(p.NotebookData.from(h))}async $notebookToData(S,w,g){const D=this._notebookSerializer.get(S);if(!D)throw new Error("NO serializer found");const h=await D.serializer.serializeNotebook(p.NotebookData.to(w.value),g);return L.VSBuffer.wrap(h)}async $saveNotebook(S,w,g,D,h){const _=y.URI.revive(w),b=this._notebookSerializer.get(S);if(!b)throw new Error("NO serializer found");const A=this._documents.get(_);if(!A)throw new Error("Document NOT found");if(A.versionId!==g)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(_.scheme))throw new R.FileOperationError((0,I.localize)(0,null,this._resourceForError(_)),6);await this._validateWriteFile(_,D);const F={metadata:(0,r.filter)(A.apiNotebook.metadata,N=>!(b.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of A.apiNotebook.getCells()){const $=new s.NotebookCellData(N.kind,N.document.getText(),N.document.languageId,N.mime,b.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);$.metadata=(0,r.filter)(N.metadata,re=>!(b.options?.transientCellMetadata??{})[re]),F.cells.push($)}const j=await b.serializer.serializeNotebook(F,h);await this._extHostFileSystem.value.writeFile(_,j);const H=this._extHostFileSystem.getFileSystemProviderExtUri(_.scheme),B=await this._extHostFileSystem.value.stat(_);return{name:H.basename(_),isFile:(B.type&R.FileType.File)!==0,isDirectory:(B.type&R.FileType.Directory)!==0,isSymbolicLink:(B.type&R.FileType.SymbolicLink)!==0,mtime:B.mtime,ctime:B.ctime,size:B.size,readonly:!!((B.permissions??0)&R.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(_.scheme),locked:!!((B.permissions??0)&R.FilePermission.Locked),etag:R.etag({mtime:B.mtime,size:B.size}),children:void 0}}async $searchInNotebooks(S,w,g,D,h){const _=this._notebookSerializer.get(S)?.serializer;if(!_)return{limitHit:!1,results:[]};const b=new T.ResourceSet;await(async(B,k,N)=>{await Promise.all(B.map(async $=>await Promise.all($.filenamePatterns.map(re=>{const le={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:re};return this._extHostSearch.doInternalFileSearchWithCustomCallback(le,k,_e=>{_e.forEach(ye=>{b.has(ye)||D.some(Ee=>$.isFromSettings&&!Ee.isFromSettings?!1:Ee.filenamePatterns.some(se=>(0,v.globMatchesResource)(se,ye)))||b.add(ye)})}).catch(_e=>{if(_e.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _e})}))))})(g,h,w);const F=new T.ResourceMap;let j=!1;const H=Array.from(b).map(async B=>{const k=[];try{if(h.isCancellationRequested)return;if(w.maxResults&&[...F.values()].reduce((le,_e)=>le+_e.cellResults.length,0)>w.maxResults){j=!0;return}const N=[],$=this._documents.get(B);if($)$.apiNotebook.getCells().forEach(_e=>N.push({input:_e.document.getText(),outputs:_e.outputs.flatMap(ye=>ye.items.map(de=>de.data.toString()))}));else{const le=await this._extHostFileSystem.value.readFile(B),_e=L.VSBuffer.fromString(le.toString()),ye=await _.deserializeNotebook(_e.buffer,h);if(h.isCancellationRequested)return;p.NotebookData.from(ye).cells.forEach(Ee=>N.push({input:Ee.source,outputs:Ee.outputs.flatMap(se=>se.items.map(pe=>pe.valueBytes.toString()))}))}if(h.isCancellationRequested)return;N.forEach((le,_e)=>{const ye=w.contentPattern.pattern,de=new d.CellSearchModel(le.input,void 0,le.outputs),Ee=de.findInInputs(ye),se=de.findInOutputs(ye),pe=se.flatMap(ee=>(0,i.genericCellMatchesToTextSearchMatches)(ee.matches,ee.textBuffer)).map((ee,X)=>(ee.webviewIndex=X,ee));if(Ee.length>0||se.length>0){const ee={index:_e,contentResults:(0,i.genericCellMatchesToTextSearchMatches)(Ee,de.inputTextBuffer),webviewResults:pe};k.push(ee)}});const re={resource:B,cellResults:k};F.set(B,re);return}catch{return}});return await Promise.all(H),{limitHit:j,results:[...F.values()]}}async _validateWriteFile(S,w){const g=await this._extHostFileSystem.value.stat(S);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==R.ETAG_DISABLED&&typeof g.mtime=="number"&&typeof g.size=="number"&&w.mtime<g.mtime&&w.etag!==R.etag({mtime:w.mtime,size:g.size}))throw new R.FileOperationError((0,I.localize)(1,null),3,w)}_resourceForError(S){return S.scheme===a.Schemas.file?S.fsPath:S.toString()}_createExtHostEditor(S,w,g){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const D=new n.ExtHostNotebookEditor(w,this._notebookEditorsProxy,S,g.visibleRanges.map(p.NotebookRange.to),g.selections.map(p.NotebookRange.to),typeof g.viewColumn=="number"?p.ViewColumn.to(g.viewColumn):void 0);this._editors.set(w,D)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const g of S.value.removedDocuments){const D=y.URI.revive(g),h=this._documents.get(D);h&&(h.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(h.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===D.toString()&&this._editors.delete(_.id)}if(S.value.addedDocuments){const g=[];for(const D of S.value.addedDocuments){const h=y.URI.revive(D.uri);if(this._documents.has(h))throw new Error(`adding EXISTING notebook ${h} `);const _=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,h,D);g.push(...D.cells.map(b=>t.ExtHostCell.asModelAddData(b))),this._documents.get(h)?.dispose(),this._documents.set(h,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(S.value.addedEditors)for(const g of S.value.addedEditors){if(this._editors.has(g.id))return;const D=y.URI.revive(g.documentUri),h=this._documents.get(D);h&&this._createExtHostEditor(h,g.id,g)}const w=[];if(S.value.removedEditors)for(const g of S.value.removedEditors){const D=this._editors.get(g);D&&(this._editors.delete(g),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),w.push(D))}if(S.value.visibleEditors){this._visibleNotebookEditors=S.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const g=new Set;this._visibleNotebookEditors.forEach(D=>g.add(D.id));for(const D of this._editors.values()){const h=g.has(D.id);D._acceptVisibility(h)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this._activeNotebookEditor=void 0:S.value.newActiveEditor&&(this._editors.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(S){const w=E.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new E.ApiCommandArgument("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>L.VSBuffer.wrap(h))],new E.ApiCommandResult("Notebook Data",h=>p.NotebookData.to(h.value))),D=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new c.SerializableObjectWithBuffers(p.NotebookData.from(h)))],new E.ApiCommandResult("Bytes",h=>h.buffer));S.registerApiCommand(g),S.registerApiCommand(D)}}e.ExtHostNotebookController=l}),define(Te[287],Ae([1,0,19,22,34,35,25,64,44]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(u,E,p){this.config=u,this.provider=E,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&O.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&O.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const E=this.config.folderQueries||[];return new Promise((p,s)=>{const c=t=>{this.resultCount++,u(t)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(t=>{const n=t.toString(),r=I.basename(n);this.globalExcludePattern&&this.globalExcludePattern(n,r)||this.matchFile(c,{base:t,basename:r})}),Promise.all(E.map(t=>this.searchInFolder(t,c))).then(t=>{p({limitHit:this.isLimitHit,stats:t[0]||void 0})},t=>{s(new Error((0,P.toErrorMessage)(t)))})})}async searchInFolder(u,E){const p=new L.CancellationTokenSource,s=this.getSearchOptionsForFolder(u),c=this.initDirectoryTree(),t=new f.QueryGlobTester(this.config,u),n=!t.hasSiblingExcludeClauses();let r;try{this.activeCancellationTokens.add(p),r=m.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,p.token),d=r.elapsed(),i=m.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(v=>{const l=I.posix.relative(u.folder.path,v.path);if(n){const o=I.basename(v.path);this.matchFile(E,{base:u.folder,relativePath:l,basename:o});return}this.addDirectoryEntries(c,u.folder,l,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,t,E),{providerTime:d,postProcessTime:i.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(u){const E=(0,f.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),p=(0,f.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},E,p,s){if(p===this.filePattern){const t=I.basename(this.filePattern);this.matchFile(s,{base:E,relativePath:this.filePattern,basename:t})}function c(t){const n=I.basename(t),r=I.dirname(t);let a=u[r];a||(a=u[r]=[],c(r)),a.push({base:E,relativePath:t,basename:n})}c(p)}matchDirectoryTree({rootEntries:u,pathToEntries:E},p,s){const c=this,t=this.filePattern;function n(r){const a=(0,f.hasSiblingFn)(()=>r.map(d=>d.basename));for(let d=0,i=r.length;d<i;d++){const v=r[d],{relativePath:l,basename:o}=v;if(p.matchesExcludesSync(l,o,t!==o?a:void 0))continue;const S=E[l];if(S)n(S);else{if(l===t)continue;c.matchFile(s,v)}if(c.isLimitHit)break}}n(u)}matchFile(u,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(E))}}class R{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(u,E,p,s){const c=this.getSessionTokenSource(u.cacheKey),t=new y(u,E,c&&c.token);let n=0;const r=a=>{n+=a.length,p(a.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(t,R.BATCH_SIZE,r,s).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(u){this.getSessionTokenSource(u)?.cancel()}getSessionTokenSource(u){if(u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,E,p,s){const c=s.onCancellationRequested(()=>{u.cancel()}),t=r=>{r&&(n.push(r),E>0&&n.length>=E&&(p(n),n=[]))};let n=[];return u.search(t).then(r=>(n.length&&p(n),c.dispose(),r),r=>(n.length&&p(n),c.dispose(),Promise.reject(r)))}}e.FileSearchManager=R}),define(Te[288],Ae([1,0,18,256,35,94,28,12,19,25,13,16,2,93,181,46,14,47,105,284,44]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(_,b,A,F,j){this.configurationService=_,this.workspaceContextService=b,this.editorGroupsService=A,this.logService=F,this.pathService=j}text(_,b,A={}){_=this.getContentPattern(_,A);const F=this.configurationService.getValue(),j=b&&b.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(b?.map(t.toWorkspaceFolder),A),type:2,contentPattern:_,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:F.search.usePCRE2||j||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}getContentPattern(_,b){const A=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const F={..._,wordSeparators:A.editor.wordSeparators};return this.isCaseSensitive(_,b)&&(F.isCaseSensitive=!0),this.isMultiline(_)&&(F.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),F}file(_,b={}){return{...this.commonQuery(_,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}handleIncludeExclude(_,b){return _?(_=Array.isArray(_)?_.map(S):S(_),b?this.parseSearchPaths(_):{pattern:v(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],b={}){const A=this.handleIncludeExclude(b.includePattern,b.expandPatterns),F=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),j=_.length>1,H=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,b,F)):_.map(N=>this.getFolderQueryForRoot(N,b,F,j))).filter(N=>!!N),B={_reason:b._reason,folderQueries:H,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:F.pattern,includePattern:A.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const N=I.coalesce(I.flatten(this.editorGroupsService.groups.map(le=>le.editors.map(_e=>_e.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const $=N.filter(le=>(0,a.pathIncludedInQuery)(B,le.fsPath)),re=this.commonQueryFromFileList($);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...B,...re}}const k=b.extraFileResources&&b.extraFileResources.filter(N=>(0,a.pathIncludedInQuery)(B,N.fsPath));return B.extraFileResources=k&&k.length?k:void 0,B}commonQueryFromFileList(_){const b=[],A=new T.ResourceMap,F={};let j=!1;return _.forEach(H=>{if(H.scheme===m.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(H)){const k=this.workspaceContextService.getWorkspaceFolder(H)?.uri??H.with({path:f.dirname(H.fsPath)});let N=A.get(k);N||(j=!0,N={folder:k,includePattern:{}},b.push(N),A.set(k,N));const $=f.relative(k.fsPath,H.fsPath);(0,C.assertIsDefined)(N.includePattern)[$.replace(/\\/g,"/")]=!0}else H.fsPath&&(j=!0,F[H.fsPath]=!0)}),{folderQueries:b,includePattern:F,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}isCaseSensitive(_,b){if(b.isSmartCase){if(_.isRegExp){if(R.containsUppercaseCharacter(_.pattern,!0))return!0}else if(R.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,E.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const b=re=>f.isAbsolute(re)||/^\.\.?([\/\\]|$)/.test(re),F=(Array.isArray(_)?_:l(_)).map(re=>{const le=this.pathService.resolvedUserHome;return le?(0,O.untildify)(re,le.scheme===m.Schemas.file?le.fsPath:le.path):re}),j=L.groupBy(F,re=>b(re)?"searchPaths":"exprSegments"),H=(j.exprSegments||[]).map(re=>R.rtrim(re,"/")).map(re=>R.rtrim(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),o(re))),B={},k=this.expandSearchPathPatterns(j.searchPaths||[]);k&&k.length&&(B.searchPaths=k);const N=I.flatten(H),$=v(...N);return $&&(B.pattern=$),B}getExcludesForFolder(_,b){return b.disregardExcludeSettings?void 0:(0,a.getExcludes)(_,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const b=_.flatMap(F=>{let{pathPortion:j,globPortion:H}=i(F);return H&&(H=w(H)),this.expandOneSearchPath(j).flatMap(k=>this.resolveOneSearchPathPattern(k,H))}),A=new Map;return b.forEach(F=>{const j=F.searchPath.toString(),H=A.get(j);H?F.pattern&&(H.pattern=H.pattern||{},H.pattern[F.pattern]=!0):A.set(j,{searchPath:F.searchPath,pattern:F.pattern?v(F.pattern):void 0})}),Array.from(A.values())}expandOneSearchPath(_){if(f.isAbsolute(_)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==m.Schemas.file?[{searchPath:b[0].uri.with({path:_})}]:[{searchPath:u.URI.file(f.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=S(_),_.startsWith("../")||_===".."){const F=f.posix.resolve(b.path,_);return[{searchPath:b.with({path:F})}]}const A=w(_);return[{searchPath:b,pattern:A}]}else{if(_==="./"||_===".\\")return[];{const b=_.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(j=>{const H=b.match(new RegExp(`^${R.escapeRegExpCharacters(j.name)}(?:/(.*)|$)`));return H?{match:H,folder:j}:null}).filter(C.isDefined);if(F.length)return F.map(j=>{const H=j.match[1];return{searchPath:j.folder.uri,pattern:H&&w(H)}});{const j=_.match(/\.[\/\\](.+)[\/\\]?/),H=j?j[1]:_,B=p.localize(0,null,H);throw new Error(B)}}}}resolveOneSearchPathPattern(_,b){const A=_.pattern&&b?`${_.pattern}/${b}`:_.pattern||b,F=[{searchPath:_.searchPath,pattern:A}];return A&&!A.endsWith("**")&&F.push({searchPath:_.searchPath,pattern:A+"/**"}),F}getFolderQueryForSearchPath(_,b,A){const F=this.getFolderQueryForRoot((0,t.toWorkspaceFolder)(_.searchPath),b,A,!1);return F?{...F,includePattern:_.pattern}:null}getFolderQueryForRoot(_,b,A,F){let j;const H=u.URI.isUri(_)?_:_.uri;if(A.searchPaths){const re=A.searchPaths.filter(le=>(0,y.isEqual)(le.searchPath,H))[0];if(re&&!re.pattern)return null;re&&(j=re.pattern)}const B=this.configurationService.getValue({resource:H}),N={...this.getExcludesForFolder(B,b)||{},...j||{}},$=u.URI.isUri(_)?(0,y.basename)(_):_.name;return{folder:H,folderName:F?$:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!B.search.followSymlinks}}};e.QueryBuilder=d,e.QueryBuilder=d=Ge([Ve(0,s.IConfigurationService),Ve(1,t.IWorkspaceContextService),Ve(2,n.IEditorGroupsService),Ve(3,c.ILogService),Ve(4,r.IPathService)],d);function i(h){const _=h.match(/[\*\{\}\(\)\[\]\?]/);if(_){const b=_.index,A=h.substr(0,b).match(/[/|\\][^/\\]*$/);if(A){let F=h.substr(0,A.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:h.substr((A.index||0)+1)}}}return{pathPortion:h}}function v(...h){return h.length?h.reduce((_,b)=>(_[b]=!0,_),Object.create(null)):void 0}function l(h){return P.splitGlobAware(h,",").map(_=>_.trim()).filter(_=>!!_.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function S(h){return h.replace(/\\/g,"/")}function w(h){return S(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(h){return h.replace(/([?*[\]])/g,"[$1]")}function D(h,_){h=I.distinct(h,F=>F.toString());const b=[],A=_.getWorkspace();return h&&h.forEach(F=>{let j;if(_.getWorkbenchState()===2)j=(0,y.relativePath)(A.folders[0].uri,F),j&&j!=="."&&(j="./"+j);else{const H=_.getWorkspaceFolder(F);if(H){const B=H.name;if(A.folders.filter(N=>N.name===B).length===1){const N=(0,y.relativePath)(H.uri,F);N===""?j=`./${H.name}`:j=`./${H.name}/${N}`}else j=F.fsPath}}j&&b.push(g(j))}),b}e.resolveResourcesForSearchIncludes=D}),define(Te[289],Ae([1,0,25,2,22,15,4,288,44,47,11]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const C=7e3;function u(c,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const r=[],a=[];for(const S of n)if(/^workspaceContains:/.test(S)){const w=S.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||c.forceUsingSearch?a.push(w):r.push(w)}if(r.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:d,resolve:i}=(0,R.promiseWithResolvers)(),v=S=>i({activationEvent:S}),l=Promise.all(r.map(S=>E(c,S,v))).then(()=>{}),o=p(c,t.identifier,a,v);return Promise.all([l,o]).then(()=>{i(void 0)}),d}e.checkActivateWorkspaceContainsExtension=u;async function E(c,t,n){for(const r of c.folders)if(await c.exists(I.joinPath(L.URI.revive(r),t))){n(`workspaceContains:${t}`);return}}async function p(c,t,n,r){if(n.length===0)return Promise.resolve(void 0);const a=new P.CancellationTokenSource,d=c.checkExists(c.folders,n,a.token),i=setTimeout(async()=>{a.cancel(),c.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},C);let v=!1;try{v=await d}catch(l){O.isCancellationError(l)||O.onUnexpectedError(l)}a.dispose(),clearTimeout(i),v&&r(`workspaceContains:${n.join(",")}`)}function s(c,t,n,r){const a=c.get(T.IInstantiationService),d=c.get(f.ISearchService),v=a.createInstance(m.QueryBuilder).file(t.map(l=>(0,y.toWorkspaceFolder)(L.URI.revive(l))),{_reason:"checkExists",includePattern:n,exists:!0});return d.fileSearch(v,r).then(l=>!!l.limitHit,l=>O.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=s}),define(Te[39],Ae([1,0,161,19,87,25,11,6,50,2,14,3,38,219,82,37,23,106,15,20,24,202,7,100,4,27,84,17,71,85,66,5,289,81,204,12,79,64,21,80]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v,l,o,S,w,g,D,h,_,b,A,F,j,H,B,k,N){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let re=$=class extends m.Disposable{constructor(X,V,ne,Ie,Fe,ke,we,me,K,J,ue,he){super(),this._extHostManagedSockets=he,this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=V,this._extHostContext=ne,this._initData=we,this._extHostWorkspace=Ie,this._extHostConfiguration=Fe,this._logService=ke,this._extHostTunnelService=K,this._extHostTerminalService=J,this._extHostLocalizationService=ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new pe(this._initData.extensions.activationEvents),this._globalRegistry=new t.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Pe=new r.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new t.ExtensionDescriptionRegistry(this._activationEventsReader,Ee(this._globalRegistry,Pe)),k.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${ye(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${ye(this._myRegistry)}`)),this._storage=new p.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=me,this._instaService=X.createChild(new g.ServiceCollection([p.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState])),this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ge,De,Re)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ge,n.transformErrorForSerialization(De),Re)},actualActivateExtension:async(ge,De)=>{if(t.ExtensionDescriptionRegistry.isHostExtension(ge,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ge,De),new E.HostExtension;const Re=this._myRegistry.getExtensionDescription(ge);return this._activateExtension(Re,De)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){n.onUnexpectedError(X)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._myRegistry.getAllExtensionDescriptions().map(Fe=>Fe.identifier).filter(Fe=>this.isActivated(Fe)).map(Fe=>this._deactivate(Fe))}catch{}await Promise.all(X)}terminate(X,V=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${X}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),n.setUnexpectedErrorHandler(Ie=>{this._logService.error(Ie)}),this._extHostContext.dispose();const ne=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),ne]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`):this._logService.info(`Extension host exiting with code ${V}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(V)})}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}async getExtension(X){const V=await this._mainThreadExtensionsProxy.$getExtension(X);return V&&{...V,identifier:new r.ExtensionIdentifier(V.identifier.value),extensionLocation:y.URI.revive(V.extensionLocation)}}_activateByEvent(X,V){return this._activator.activateByEvent(X,V)}_activateById(X,V){return this._activator.activateById(X,V)}activateByIdWithErrors(X,V){return this._activateById(X,V).then(()=>{const ne=this._activator.getActivatedExtension(X);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._myRegistry)}getExtensionExports(X){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(X).exports;try{return this._activator.getActivatedExtension(X).exports}catch{return null}}async _realPathExtensionUri(X){if(X.scheme===j.Schemas.file&&this._hostUtils.fsRealpath){const V=await this._hostUtils.fsRealpath(X.fsPath);return y.URI.file(V)}return X}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(X=>new se(X))),this._extensionPathIndex}async _createExtensionPathIndex(X){const V=f.TernarySearchTree.forUris(ne=>O.extUriBiasedIgnorePathCase.ignorePathCasing(ne));return await Promise.all(X.map(async ne=>{if(this._getEntryPoint(ne)){const Ie=await this._realPathExtensionUri(ne.extensionLocation);V.set(Ie,ne)}})),V}_deactivate(X){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return V;const ne=this._activator.getActivatedExtension(X);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this._logService.error(Ie),Promise.resolve(void 0))))}catch(Ie){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(Ie)}try{(0,m.dispose)(ne.subscriptions)}catch(Ie){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this._logService.error(Ie)}return V}async _activateExtension(X,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,V).then(ne=>{const Ie=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this._logExtensionActivationTimes(X,V,"success",Ie),ne},ne=>{throw this._logExtensionActivationTimes(X,V,"failure"),ne})}_logExtensionActivationTimes(X,V,ne,Ie){const Fe=_e(X,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Fe,...Ie||{},outcome:ne})}_doActivateExtension(X,V){const ne=_e(X,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const Ie=this._getEntryPoint(X);if(!Ie)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this._logService.flush();const Fe=new E.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(X,(0,O.joinPath)(X.extensionLocation,Ie),Fe),this._loadExtensionContext(X)]).then(ke=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),$._callActivate(this._logService,X.identifier,ke[0],ke[1],Fe))).then(ke=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),ke))}_loadExtensionContext(X){const V=new d.ExtensionGlobalMemento(X,this._storage),ne=new d.ExtensionMemento(X.identifier.value,!1,this._storage),Ie=new F.ExtensionSecrets(X,this._secretState),Fe=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ke=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let me,K;const J=(0,c.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(r.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(ue){return L.join(X.extensionLocation.fsPath,ue)},get storagePath(){return we._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return we._storagePath.globalValue(X).fsPath},get logPath(){return L.join(we._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return y.URI.joinPath(we._initData.logsLocation,X.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(X)},get globalStorageUri(){return we._storagePath.globalValue(X)},get extensionMode(){return Fe},get extension(){return me===void 0&&(me=new de(we,X.identifier,X,ke,!1)),me},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(X,"extensionRuntime"),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!K){if(!J)return;const ue=_.Event.buffer(_.Event.fromDOMEventEmitter(J,"message",he=>he.data));J.start(),K={onDidReceiveMessage:ue,postMessage:J.postMessage.bind(J)}}return K}})})}static _callActivate(X,V,ne,Ie,Fe){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,V,ne,Ie,Fe).then(ke=>new E.ActivatedExtension(!1,null,Fe.build(),ne,ke,Ie.subscriptions))}static _callActivateOptional(X,V,ne,Ie,Fe){if(typeof ne.activate=="function")try{Fe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const ke=typeof global=="object"?global:self,we=ne.activate.apply(ke,[Ie]);return Fe.activateCallStop(),Fe.activateResolveStart(),Promise.resolve(we).then(me=>(Fe.activateResolveStop(),me))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(ne)}_activateOneStartupFinished(X,V){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinishedDeferred(X,V=0){const Ie=Date.now();(0,k.setTimeout0)(()=>{for(let Fe=V;Fe<X.length;Fe+=1){const ke=X[Fe];for(const we of ke.activationEvents??[])if(we==="onStartupFinished")if(Date.now()-Ie>50){this._activateAllStartupFinishedDeferred(X,Fe);break}else this._activateOneStartupFinished(ke,we)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks()),this._extHostConfiguration.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this._myRegistry.getAllExtensionDescriptions();if(V)this._activateAllStartupFinishedDeferred(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Fe of Ie.activationEvents)Fe==="onStartupFinished"&&this._activateOneStartupFinished(Ie,Fe)})}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,ke=>{this._logService.error(ke)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ke=>this._handleWorkspaceContainsEagerExtensions(ke.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(V),Ie=this._handleRemoteResolverEagerExtensions(),Fe=Promise.all([Ie,X,ne]).then(()=>{});return Promise.race([Fe,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Fe}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(X,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,V){if(this.isActivated(V.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ie={logService:this._logService,folders:X.map(ke=>ke.uri),forceUsingSearch:ne||!this._hostUtils.fsExists,exists:ke=>this._hostUtils.fsExists(ke.fsPath),checkExists:(ke,we,me)=>this._mainThreadWorkspaceProxy.$checkExists(ke,we,me)},Fe=await(0,b.checkActivateWorkspaceContainsExtension)(Ie,V);if(Fe)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Fe.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this._initData.environment;if(!X||!V)throw new Error(I.localize(0,null));const ne=await this._loadCommonJSModule(null,V,new E.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(I.localize(1,null,V.toString()));return new Promise((Ie,Fe)=>{const ke=(K,J)=>{K?(k.isCI&&this._logService.error("Test runner called back with error",K),Fe(K)):(k.isCI&&(J?this._logService.info(`Test runner called back with ${J} failures.`):this._logService.info("Test runner called back with successful outcome.")),Ie(typeof J=="number"&&J>0?1:0))},we=(0,O.originalFSPath)(V),me=ne.run(we,ke);me&&me.then&&me.then(()=>{k.isCI&&this._logService.info("Test runner finished successfully."),Ie(0)}).catch(K=>{k.isCI&&this._logService.error("Test runner finished with error",K),Fe(K instanceof Error&&K.stack?K.stack:String(K))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this._resolvers[X]=V,(0,m.toDisposable)(()=>{delete this._resolvers[X]})}async getRemoteExecServer(X){const{resolver:V}=await this._activateAndGetResolver(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async _activateAndGetResolver(X){const V=X.indexOf("+");if(V===-1)throw new i.RemoteAuthorityResolverError("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=X.substr(0,V);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(X,V){const ne=B.StopWatch.create(!1),Ie=()=>`[resolveAuthority(${(0,v.getRemoteAuthorityPrefix)(X)},${V})][${ne.elapsed()}ms] `,Fe=M=>this._logService.info(`${Ie()}${M}`),ke=M=>this._logService.warn(`${Ie()}${M}`),we=(M,x=void 0)=>this._logService.error(`${Ie()}${M}`,x),me=M=>{if(M instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:M._code,message:M._message,detail:M._detail}};throw M},K=async M=>{Fe(`activating resolver for ${M}...`);const{resolver:x,authorityPrefix:q}=await this._activateAndGetResolver(M);if(!x)throw we(`no resolver for ${q}`),new i.RemoteAuthorityResolverError(`No remote extension installed to resolve ${q}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:x,authorityPrefix:q,remoteAuthority:M}},J=X.split(/@|%40/g).reverse();Fe(`activating remote resolvers ${J.join(" -> ")}`);let ue;try{ue=await Promise.all(J.map(K)).catch(async M=>{if(!(M instanceof i.RemoteAuthorityResolverError)||M._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw M;return ke(`resolving nested authorities failed: ${M.message}`),[await K(X)]})}catch(M){return me(M)}const he=new T.IntervalTimer;he.cancelAndSet(()=>Fe("waiting..."),1e3);let Pe,ge;for(const[M,{authorityPrefix:x,resolver:q,remoteAuthority:W}]of ue.entries())try{if(M===ue.length-1)Fe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${x}`),Pe=await q.resolve(W,{resolveAttempt:V,execServer:ge}),P.mark(`code/extHost/didResolveAuthorityOK/${x}`),Fe("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(q,i.ManagedResolvedAuthority.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(Fe(`invoking resolveExecServer() for ${W}`),P.mark(`code/extHost/willResolveExecServer/${x}`),ge=await q.resolveExecServer?.(W,{resolveAttempt:V,execServer:ge}),!ge)throw new i.RemoteAuthorityResolverError(`Exec server was not available for ${W}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${x}`)}}catch(te){return P.mark(`code/extHost/didResolveAuthorityError/${x}`),we("returned an error",te),he.dispose(),me(te)}he.dispose();const De={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},Re={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};Fe(`returned ${i.ManagedResolvedAuthority.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let xe;if(i.ManagedResolvedAuthority.isManagedResolvedAuthority(Pe)){const M=V;this._extHostManagedSockets.setFactory(M,Pe.makeConnection),xe={authority:X,connectTo:new v.ManagedRemoteConnection(M),connectionToken:Pe.connectionToken}}else xe={authority:X,connectTo:new v.WebSocketRemoteConnection(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:xe,options:Re,tunnelInformation:De}}}async $getCanonicalURI(X,V){this._logService.info(`$getCanonicalURI invoked for authority (${(0,v.getRemoteAuthorityPrefix)(X)})`);const{resolver:ne}=await this._activateAndGetResolver(X);if(!ne)return null;const Ie=y.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Fe=await(0,T.asPromise)(()=>ne.getCanonicalURI(Ie));return Fe||Ie}$startExtensionHost(X){X.toAdd.forEach(Ie=>Ie.extensionLocation=y.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=le(this._activationEventsReader,this._globalRegistry,this._myRegistry,X);return this._globalRegistry.set(V.getAllExtensionDescriptions()),this._myRegistry.set(ne),k.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${ye(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${ye(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(X,V){return V===1?this._almostReadyToRunExtensions.wait().then(ne=>this._activateByEvent(X,!1)):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(X,!1))}async $activate(X,V){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(X)?(await this._activateById(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(ke=>ke.extensionLocation=y.URI.revive(ke.extensionLocation));const{globalRegistry:V,myExtensions:ne}=le(this._activationEventsReader,this._globalRegistry,this._myRegistry,X),Ie=await this._createExtensionPathIndex(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this._globalRegistry.set(V.getAllExtensionDescriptions()),this._myRegistry.set(ne),k.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${ye(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${ye(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=a.VSBuffer.alloc(X),ne=Math.random()%256;for(let Ie=0;Ie<X;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=re,e.AbstractExtHostExtensionService=re=$=Ge([Ve(0,l.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,w.IExtHostRpcService),Ve(3,s.IExtHostWorkspace),Ve(4,u.IExtHostConfiguration),Ve(5,R.ILogService),Ve(6,o.IExtHostInitDataService),Ve(7,S.IExtensionStoragePaths),Ve(8,D.IExtHostTunnelService),Ve(9,h.IExtHostTerminalService),Ve(10,H.IExtHostLocalizationService),Ve(11,N.IExtHostManagedSockets)],re);function le(ee,X,V,ne){ee.addActivationEvents(ne.addActivationEvents);const Ie=new t.ExtensionDescriptionRegistry(ee,X.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Fe=new r.ExtensionIdentifierSet(V.getAllExtensionDescriptions().map(we=>we.identifier));for(const we of ne.myToRemove)Fe.delete(we);for(const we of ne.myToAdd)Fe.add(we);const ke=Ee(Ie,Fe);return{globalRegistry:Ie,myExtensions:ke}}function _e(ee,X){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function ye(ee){return ee.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class de{#e;#t;#i;constructor(X,V,ne,Ie,Fe){this.#e=X,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=L.normalize((0,O.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=de;function Ee(ee,X){return ee.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class se{constructor(X){this._searchTree=X}setSearchTree(X){this._searchTree=X}findSubstr(X){return this._searchTree.findSubstr(X)}forEach(X){return this._searchTree.forEach(X)}}e.ExtensionPaths=se;class pe{constructor(X){this._map=new r.ExtensionIdentifierMap,this.addActivationEvents(X)}readActivationEvents(X){return this._map.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this._map.set(V,X[V])}}}),define(Te[290],Ae([1,0,87,2,3,38,23,20,17,27,4,39,14,13]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(a,d,i,v,l,o,S){this._apiFactory=a,this._extensionRegistry=d,this._instaService=i,this._extHostConfiguration=v,this._extHostExtensionService=l,this._initData=o,this._logService=S,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),I.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new t(this._apiFactory,d,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(c)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(n,d,this._initData.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const d of a.nodeModuleName)this._factories.set(d,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(d=>a.alternativeModuleName(d))}};e.RequireInterceptor=s,e.RequireInterceptor=s=Ge([Ve(2,R.IInstantiationService),Ve(3,O.IExtHostConfiguration),Ve(4,C.IExtHostExtensionService),Ve(5,y.IExtHostInitDataService),Ve(6,u.ILogService)],s);let c=class{static{p=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&p.aliased.size){const d=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(a.environment.appRoot.fsPath)),i="[a-z0-9_.-]",v=`@${i}+\\/${i}+|${i}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${d}/${l}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.re)return;const d=this.re.exec(this.forceForwardSlashes(a));if(!d)return;const[,i,v,l]=d,o=p.aliased.get(v);if(o!==void 0)return console.warn(`${v} as been renamed to ${o}, please update your imports`),i+o+l}forceForwardSlashes(a){return a.replace(/\\/g,"/")}};c=p=Ge([Ve(0,y.IExtHostInitDataService)],c);class t{constructor(a,d,i,v,l){this._apiFactory=a,this._extensionPaths=d,this._extensionRegistry=i,this._configProvider=v,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new m.ExtensionIdentifierMap}load(a,d){const i=this._extensionPaths.findSubstr(d);if(i){let v=this._extApiImpl.get(i.identifier);return v||(v=this._apiFactory(i,this._extensionRegistry,this._configProvider),this._extApiImpl.set(i.identifier,v)),v}if(!this._defaultApiImpl){let v="";this._extensionPaths.forEach((l,o)=>v+=`	${o} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${v}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let n=class{constructor(a,d,i){this._extensionPaths=a,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=i.getProxy(P.MainContext.MainThreadTelemetry);const v=i.getProxy(P.MainContext.MainThreadWindow);this._impl=(l,o)=>{const S=L.URI.parse(l);return o?this.callOriginal(l,o):S.scheme==="http"||S.scheme==="https"?v.$openUri(S,l,{allowTunneling:!0}):S.scheme==="mailto"||S.scheme===this._appUriScheme?v.$openUri(S,l,{}):this.callOriginal(l,o)}}load(a,d,i){const v=this._extensionPaths.findSubstr(d);return v&&(this._extensionId=v.identifier.value,this.sendShimmingTelemetry()),this._original=i(a),this._impl}callOriginal(a,d){return this.sendNoForwardTelemetry(),this._original(a,d)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};n=Ge([Ve(2,f.IExtHostRpcService)],n)}),define(Te[117],Ae([1,0,40,6,19,73,4,67,65,39,7,37,216,38]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class p extends u.AbstractVariableResolverService{constructor(t,n,r,a,d,i,v){function l(){if(r){const o=r.activeEditor();if(o)return o.document.uri;const S=a.tabGroups.all.find(w=>w.isActive)?.activeTab;if(S!==void 0){if(S.input instanceof R.TextDiffTabInput||S.input instanceof R.NotebookDiffEditorTabInput)return S.input.modified;if(S.input instanceof R.TextTabInput||S.input instanceof R.NotebookEditorTabInput||S.input instanceof R.CustomEditorTabInput)return S.input.uri}}}super({getFolderUri:o=>{const S=i.folders.filter(w=>w.name===o);if(S&&S.length>0)return S[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(o,S)=>d.getConfiguration(void 0,o).get(S),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=l();if(o)return P.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const o=l();if(o){const S=n.getWorkspaceFolder(o);if(S)return P.normalize(S.uri.fsPath)}}},getSelectedText:()=>{if(r){const o=r.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(r){const o=r.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>t.getExtension(o)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(O.env))}}let s=class extends L.Disposable{constructor(t,n,r,a,d){super(),this.extensionService=t,this.workspaceService=n,this.editorService=r,this.configurationService=a,this.editorTabs=d,this._resolver=new I.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),l={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{l.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,l,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=s,e.ExtHostVariableResolverProviderService=s=Ge([Ve(0,y.IExtHostExtensionService),Ve(1,C.IExtHostWorkspace),Ve(2,m.IExtHostDocumentsAndEditors),Ve(3,E.IExtHostConfiguration),Ve(4,f.IExtHostEditorTabs)],s)}),define(Te[118],Ae([1,0,11,5,2,20,4,3,65,39,17,7,37,208,210,38,117,6,41,31,8]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(g,D,h,_,b,A,F){this._workspaceService=D,this._extensionService=h,this._configurationService=_,this._editorTabs=b,this._variableResolver=A,this._commands=F,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new L.Emitter,this._onDidTerminateDebugSession=new L.Emitter,this._onDidChangeActiveDebugSession=new L.Emitter,this._onDidReceiveDebugSessionCustomEvent=new L.Emitter,this._debugServiceProxy=g.getProxy(m.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new L.Emitter,this._onDidChangeStackFrameFocus=new L.Emitter,this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(j=>{j.onDidChange(H=>{this.registerAllDebugTypes(j)}),this.registerAllDebugTypes(j)})}async $getVisualizerTreeItem(g,D){const h=this.hydrateVisualizationContext(D);if(!h)return;const _=await this._debugVisualizationTrees.get(g)?.getTreeItem?.(h);return _?this.convertVisualizerTreeItem(g,_):void 0}registerDebugVisualizationTree(g,D,h){const _=O.ExtensionIdentifier.toKey(g.identifier),b=this.extensionVisKey(_,D);if(this._debugVisualizationProviders.has(b))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationTrees.set(b,h),this._debugServiceProxy.$registerDebugVisualizerTree(b,!!h.editItem),(0,t.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(b),this._debugVisualizationTrees.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const h=this._debugVisualizationElements.get(D)?.item;return h?(await this._debugVisualizationTrees.get(g)?.getChildren?.(h))?.map(b=>this.convertVisualizerTreeItem(g,b))||[]:[]}async $editVisualizerTreeItem(g,D){const h=this._debugVisualizationElements.get(g);if(!h)return;const _=await this._debugVisualizationTrees.get(h.provider)?.editItem?.(h.item,D);return this.convertVisualizerTreeItem(h.provider,_||h.item)}$disposeVisualizedTree(g){const D=this._debugVisualizationElements.get(g);if(!D)return;const h=[D.children];for(const _ of h)if(_)for(const b of _)h.push(this._debugVisualizationElements.get(b)?.children),this._debugVisualizationElements.delete(b)}convertVisualizerTreeItem(g,D){let h=this._debugVisualizationTreeItemIds.get(D);return h||(h=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(D,h),this._debugVisualizationElements.set(h,{provider:g,item:D})),a.DebugTreeItem.from(D,h)}asDebugSourceUri(g,D){const h=g;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let _=`debug:${encodeURIComponent(h.path||"")}`,b="?";return D&&(_+=`${b}session=${encodeURIComponent(D.id)}`,b="&"),_+=`${b}ref=${h.sourceReference}`,P.URI.parse(_)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const D=[];for(const h of g.getAllExtensionDescriptions())if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0)for(const b of _)(0,p.isDebuggerMainContribution)(b)&&D.push(b.type)}this._debugServiceProxy.$registerDebugTypes(D)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const g=[];return this._breakpoints.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const h=this._visualizers.get(g);if(!h)throw new Error(`No debug visualizer found with id '${g}'`);let{v:_,provider:b,extensionId:A}=h;if(_.visualization||(_=await b.resolveDebugVisualization?.(_,D)||_,h.v=_),!_.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${b}'`);return this.serializeVisualization(A,_.visualization)}async $executeDebugVisualizerCommand(g){const D=this._visualizers.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const h=D.v.visualization;h&&"command"in h&&this._commands.executeCommand(h.command,...h.arguments||[])}hydrateVisualizationContext(g){const D=this._debugSessions.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,h,_){const b=this.hydrateVisualizationContext(h),A=this.extensionVisKey(g,D),F=this._debugVisualizationProviders.get(A);if(!b||!F)return[];const j=await F.provideDebugVisualization(b,_);return j?j.map(H=>{const B=++this._visualizerIdCounter;this._visualizers.set(B,{v:H,provider:F,extensionId:g});const k=H.iconPath?this.getIconPathOrClass(H.iconPath):void 0;return{id:B,name:H.name,iconClass:k?.iconClass,iconPath:k?.iconPath,visualization:this.serializeVisualization(g,H.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this._visualizers.delete(D)}registerDebugVisualizationProvider(g,D,h){if(!g.contributes?.debugVisualizers?.some(A=>A.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const _=O.ExtensionIdentifier.toKey(g.identifier),b=this.extensionVisKey(_,D);if(this._debugVisualizationProviders.has(b))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationProviders.set(b,h),this._debugServiceProxy.$registerDebugVisualizer(_,D),(0,t.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(_,D),this._debugVisualizationProviders.delete(D)})}addBreakpoints(g){const D=g.filter(b=>{const A=b.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,b),!0)});this.fireBreakpointChanges(D,[],[]);const h=[],_=new Map;for(const b of D)if(b instanceof C.SourceBreakpoint){let A=_.get(b.location.uri.toString());A||(A={type:"sourceMulti",uri:b.location.uri,lines:[]},_.set(b.location.uri.toString(),A),h.push(A)),A.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character,mode:b.mode})}else b instanceof C.FunctionBreakpoint&&h.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName,mode:b.mode});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(g){const D=g.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],D,[]);const h=D.filter(A=>A instanceof C.SourceBreakpoint).map(A=>A.id),_=D.filter(A=>A instanceof C.FunctionBreakpoint).map(A=>A.id),b=D.filter(A=>A instanceof C.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(h,_,b)}startDebugging(g,D,h){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,D,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,h){if(!D)return new C.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:_,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,h,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,_),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(g,D,h){if(!h)return new C.Disposable(()=>{});if(!this.definesDebugType(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:_,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,_),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new C.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:h,factory:D}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let h;const _=await this.getFolder(g);return _&&(h={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(h,D)}createDebugAdapter(g,D){if(g.type==="implementation")return new o(g.implementation)}createSignService(){}async $startDASession(g,D){const h=this,_=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const A=this.convertToDto(b),F=this.createDebugAdapter(A,_);if(!F)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const j=F;return this._debugAdapters.set(g,j),this.getDebugAdapterTrackers(_).then(H=>(H&&this._debugAdaptersTrackers.set(g,H),j.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const k=B,N={type:"response",seq:0,command:k.command,request_seq:k.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(k.arguments.value);N.body={signature:$},j.sendResponse(N)}else throw new Error("no signer")}catch($){N.success=!1,N.message=$.message,j.sendResponse(N)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(B),B=(0,p.convertToVSCPaths)(B,!0),h._debugServiceProxy.$acceptDAMessage(g,B)}),j.onError(B=>{H&&H.onError&&H.onError(B),this._debugServiceProxy.$acceptDAError(g,B.name,B.message,B.stack)}),j.onExit(B=>{H&&H.onExit&&H.onExit(B??void 0,void 0),this._debugServiceProxy.$acceptDAExit(g,B??void 0,void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),j.startSession()))})}$sendDAMessage(g,D){D=(0,p.convertToDAPaths)(D,!1);const h=this._debugAdaptersTrackers.get(g);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(D),this._debugAdapters.get(g)?.sendMessage(D)}$stopDASession(g){const D=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const h=this._debugAdapters.get(g);return this._debugAdapters.delete(g),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],h=[],_=[];if(g.added)for(const b of g.added){const A=b.id;if(A&&!this._breakpoints.has(A)){let F;if(b.type==="function")F=new C.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode);else if(b.type==="data")F=new C.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage,b.mode);else{const j=P.URI.revive(b.uri);F=new C.SourceBreakpoint(new C.Location(j,new C.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode)}(0,C.setBreakpointId)(F,A),this._breakpoints.set(A,F),D.push(F)}}if(g.removed)for(const b of g.removed){const A=this._breakpoints.get(b);A&&(this._breakpoints.delete(b),h.push(A))}if(g.changed){for(const b of g.changed)if(b.id){const A=this._breakpoints.get(b.id);if(A){if(A instanceof C.FunctionBreakpoint&&b.type==="function"){const F=A;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.functionName=b.functionName}else if(A instanceof C.SourceBreakpoint&&b.type==="source"){const F=A;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.location=new C.Location(P.URI.revive(b.uri),new C.Position(b.line,b.character))}_.push(A)}}}this.fireBreakpointChanges(D,h,_)}async $acceptStackFrameFocus(g){let D;const h=g.sessionId?await this.getSession(g.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");g.kind==="thread"?D=new C.ThreadFocus(h.api,g.threadId):D=new C.StackFrameFocus(h.api,g.threadId,g.frameId),this._stackFrameFocus=D,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(g,D,h){return(0,I.asPromise)(async()=>{const _=this.getConfigProviderByHandle(g);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(D);return _.provideDebugConfigurations(b,h)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(g,D,h,_){return(0,I.asPromise)(async()=>{const b=this.getConfigProviderByHandle(g);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(D);return b.resolveDebugConfiguration(A,h,_)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,h,_){return(0,I.asPromise)(async()=>{const b=this.getConfigProviderByHandle(g);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(D);return b.resolveDebugConfigurationWithSubstitutedVariables(A,h,_)})}async $provideDebugAdapter(g,D){const h=this.getAdapterDescriptorFactoryByHandle(g);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(D);return this.getAdapterDescriptor(h,_).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(g){const D=await this.getSession(g);this._onDidStartDebugSession.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.getSession(g);D&&(this._onDidTerminateDebugSession.fire(D.api),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.getSession(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const _={session:(await this.getSession(g)).api,event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(g){if(g instanceof C.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof C.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const D=this._adapterFactories.filter(h=>h.type===g);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(g){const D=this._adapterFactories.filter(h=>h.handle===g);if(D.length>0)return D[0].factory}getConfigProviderByHandle(g){const D=this._configProviders.filter(h=>h.handle===g);if(D.length>0)return D[0].provider}definesDebugType(g,D){if(g.contributes){const h=g.contributes.debuggers;if(h&&h.length>0){for(const _ of h)if(_.label&&_.type&&_.type===D)return!0}}return!1}getDebugAdapterTrackers(g){const h=g.configuration.type,_=this._trackerFactories.filter(b=>b.type===h||b.type==="*").map(b=>(0,I.asPromise)(()=>b.factory.createDebugAdapterTracker(g.api)).then(A=>A,A=>null));return Promise.race([Promise.all(_).then(b=>{const A=b.filter(F=>!!F);if(A.length>0)return new l(A)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async getAdapterDescriptor(g,D){const h=D.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new C.DebugAdapterServer(h));if(g){const b=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>g.createDebugAdapterDescriptor(D.api,this.daExecutableFromPackage(D,b))).then(A=>{if(A)return A})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,_))}daExecutableFromPackage(g,D){}fireBreakpointChanges(g,D,h){(g.length>0||D.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:D,changed:h}))}async getSession(g){if(g)if(typeof g=="string"){const D=this._debugSessions.get(g);if(D)return D}else{let D=this._debugSessions.get(g.id);if(!D){const h=await this.getFolder(g.folderUri),_=g.parent?this._debugSessions.get(g.parent):void 0;D=new i(this._debugServiceProxy,g.id,g.type,g.name,h,g.configuration,_?.api),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(g){if(g){const D=P.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}extensionVisKey(g,D){return`${g}\0${D}`}serializeVisualization(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(g){const D=this.getIconUris(g);let h,_;return"id"in D?_=n.ThemeIcon.asClassName(D):h=D,{iconPath:h,iconClass:_}}getIconUris(g){if(g instanceof C.ThemeIcon)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,h=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?P.URI.file(D):D,light:typeof h=="string"?P.URI.file(h):h}}};e.ExtHostDebugServiceBase=d,e.ExtHostDebugServiceBase=d=Ge([Ve(0,R.IExtHostRpcService),Ve(1,u.IExtHostWorkspace),Ve(2,y.IExtHostExtensionService),Ve(3,s.IExtHostConfiguration),Ve(4,f.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider),Ve(6,r.IExtHostCommands)],d);class i{constructor(g,D,h,_,b,A,F){this._debugServiceProxy=g,this._id=D,this._type=h,this._name=_,this._workspaceFolder=b,this._configuration=A,this._parentSession=F}get api(){const g=this;return this.apiSession??=Object.freeze({id:g._id,type:g._type,get name(){return g._name},set name(D){g._name=D,g._debugServiceProxy.$setDebugSessionName(g._id,D)},parentSession:g._parentSession,workspaceFolder:g._workspaceFolder,configuration:g._configuration,customRequest(D,h){return g._debugServiceProxy.$customDebugAdapterRequest(g._id,D,h)},getDebugProtocolBreakpoint(D){return g._debugServiceProxy.$getDebugProtocolBreakpoint(g._id,D.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(g){this._name=g}get configuration(){return this._configuration}}e.ExtHostDebugSession=i;class v{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=v;class l{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.trackers.forEach(h=>h.onExit?h.onExit(g,D):void 0)}}class o extends E.AbstractDebugAdapter{constructor(g){super(),this.implementation=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let S=class extends d{constructor(g,D,h,_,b,A,F){super(g,D,h,_,b,A,F)}};e.WorkerExtHostDebugService=S,e.WorkerExtHostDebugService=S=Ge([Ve(0,R.IExtHostRpcService),Ve(1,u.IExtHostWorkspace),Ve(2,y.IExtHostExtensionService),Ve(3,s.IExtHostConfiguration),Ve(4,f.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider),Ve(6,r.IExtHostCommands)],S)}),define(Te[291],Ae([1,0,15,87,2,3,237,14,54,71,27,186,17,59,39,61]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class c{static async installEarlyHandler(r){Error.stackTraceLimit=100;const a=r.get(m.ILogService),i=r.get(u.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{a.error(v);const l=I.transformErrorForSerialization(v);i.$onUnexpectedError(l)})}static async installFullHandler(r){const a=r.get(m.ILogService),d=r.get(u.IExtHostRpcService),i=r.get(p.IExtHostExtensionService),v=r.get(s.IExtHostTelemetry),l=d.getProxy(O.MainContext.MainThreadExtensionService),o=d.getProxy(O.MainContext.MainThreadErrors),S=await i.getExtensionPathIndex(),w=new WeakMap;function g(_,b){if(w.has(_))return w.get(_).stack;let A="",F,j;for(const B of b)A+=`
	at ${B.toString()}`,j=B.getFileName(),!F&&j&&(F=S.findSubstr(P.URI.file(j)));const H=`${_.name||"Error"}: ${_.message||""}${A}`;return w.set(_,{extensionIdentifier:F?.identifier,stack:H}),H}const D=Symbol("prepareStackTrace wrapped");let h=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(_){if(_===g||!_||_[D]){h=_||g;return}h=function(b,A){return g(b,A),_.call(Error,b,A)},Object.assign(h,{[D]:!0})}}),I.setUnexpectedErrorHandler(_=>{a.error(_);const b=I.transformErrorForSerialization(_),A=w.get(_);if(!A?.extensionIdentifier){o.$onUnexpectedError(b);return}l.$onExtensionRuntimeError(A.extensionIdentifier,b);const F=v.onExtensionError(A.extensionIdentifier,_);a.trace("forwarded error to extension?",F,A)})}}e.ErrorHandler=c;class t{constructor(r,a,d,i,v){this._hostUtils=d,this._rpcProtocol=new T.RPCProtocol(r,null,i),a=t._transform(a,this._rpcProtocol);const l=new y.ServiceCollection(...(0,f.getSingletonServiceDescriptors)());l.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...a,messagePorts:v}),l.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),l.set(E.IURITransformerService,new E.URITransformerService(i)),l.set(p.IHostUtils,d);const o=new C.InstantiationService(l,!0);o.invokeFunction(c.installEarlyHandler),this._logService=o.invokeFunction(S=>S.get(m.ILogService)),L.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",a),this._extensionService=o.invokeFunction(S=>S.get(p.IExtHostExtensionService)),this._extensionService.initialize(),o.invokeFunction(c.installFullHandler)}async asBrowserUri(r){const a=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(r))}terminate(r){this._extensionService.terminate(r)}static _transform(r,a){r.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(a.transformIncomingURIs(i.extensionLocation))}),r.environment.appRoot=P.URI.revive(a.transformIncomingURIs(r.environment.appRoot));const d=r.environment.extensionDevelopmentLocationURI;return d&&(r.environment.extensionDevelopmentLocationURI=d.map(i=>P.URI.revive(a.transformIncomingURIs(i)))),r.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=P.URI.revive(a.transformIncomingURIs(r.logsLocation)),r.workspace=a.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=t}),define(Te[292],Ae([1,0,18,11,22,34,12,19,25,2,44]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(n,r,a,d){this.query=n,this.provider=r,this.fileUtils=a,this.processType=d,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(n,r){const a=this.query.folderQueries||[],d=new P.CancellationTokenSource(r);return new Promise((i,v)=>{this.collector=new E(n);let l=!1;const o=(S,w)=>{if(!l&&!this.isLimitHit){const g=this.resultSize(S);s(S)&&typeof this.query.maxResults=="number"&&this.resultCount+g>this.query.maxResults&&(this.isLimitHit=!0,l=!0,d.cancel(),S=this.trimResultToSize(S,this.query.maxResults-this.resultCount));const D=this.resultSize(S);this.resultCount+=D,(D>0||!s(S))&&this.collector.add(S,w)}};Promise.all(a.map((S,w)=>this.searchInFolder(S,g=>o(g,w),d.token))).then(S=>{d.dispose(),this.collector.flush();const w=S.some(g=>!!g&&!!g.limitHit);i({limitHit:this.isLimitHit||w,messages:(0,I.flatten)(S.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.processType}})},S=>{d.dispose();const w=(0,O.toErrorMessage)(S);v(new Error(w))})})}resultSize(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}trimResultToSize(n,r){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],d=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,r),preview:{matches:d.slice(0,r),text:n.preview.text},uri:n.uri}}async searchInFolder(n,r,a){const d=new R.QueryGlobTester(this.query,n),i=[],v={report:S=>{if(!this.validateProviderResult(S))return;const w=n.folder.scheme===T.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(f.dirname(S.uri))):void 0,g=f.relativePath(n.folder,S.uri);if(g){const D=d.includedInQuery(g,m.basename(g),w);(0,L.isThenable)(D)?i.push(D.then(h=>{h&&r(S)})):D&&r(S)}}},l=this.getSearchOptionsForFolder(n),o=await this.provider.provideTextSearchResults(u(this.query.contentPattern),l,v,a);return i.length&&await Promise.all(i),o}validateProviderResult(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(n){const r=(0,R.resolvePatternsForProvider)(this.query.includePattern,n.includePattern),a=(0,R.resolvePatternsForProvider)(this.query.excludePattern,n.excludePattern),d={folder:y.URI.from(n.folder),excludes:a,includes:r,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.fileUtils.toCanonicalName(n.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return d.usePCRE2=this.query.usePCRE2,d}}e.TextSearchManager=C;function u(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class E{constructor(n){this._onResult=n,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new c(512,r=>this.sendItems(r))}add(n,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!f.isEqual(this._currentUri,n.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:n.uri,results:[]}),this._currentFileMatch.results.push(p(n))}pushToCollector(){const n=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,n)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(n){this._onResult(n)}}e.TextSearchResultsCollector=E;function p(t){return s(t)?{preview:{matches:(0,I.mapArrayOrNot)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,I.mapArrayOrNot)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function s(t){return!!t.preview}e.extensionResultIsMatch=s;class c{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(n,r){this.maxBatchSize=n,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(n,r){n&&this.addItemToBatch(n,r)}addItems(n,r){n&&this.addItemsToBatch(n,r)}addItemToBatch(n,r){this.batch.push(n),this.batchSize+=r,this.onUpdate()}addItemsToBatch(n,r){this.batch=this.batch.concat(n),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<c.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},c.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=c}),define(Te[119],Ae([1,0,6,3,4,287,17,59,14,2,292]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let C=class{constructor(s,c,t){this.extHostRpc=s,this._uriTransformer=c,this._logService=t,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new O.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,c){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const t=this._handlePool++;return this._textSearchProvider.set(t,c),this._proxy.$registerTextSearchProvider(t,this._transformScheme(s)),(0,I.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(t),this._proxy.$unregisterProvider(t)})}registerFileSearchProvider(s,c){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const t=this._handlePool++;return this._fileSearchProvider.set(t,c),this._proxy.$registerFileSearchProvider(t,this._transformScheme(s)),(0,I.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(t),this._proxy.$unregisterProvider(t)})}$provideFileSearchResults(s,c,t,n){const r=u(t),a=this._fileSearchProvider.get(s);if(a)return this._fileSearchManager.fileSearch(r,a,d=>{this._proxy.$handleFileMatch(s,c,d.map(i=>i.resource))},n);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,c,t){return{messages:[]}}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,c,t,n){const r=this._textSearchProvider.get(s);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const a=u(t);return this.createTextSearchManager(a,r).search(i=>this._proxy.$handleTextMatch(s,c,i),n)}$enableExtensionHostSearch(){}createTextSearchManager(s,c){return new R.TextSearchManager(s,c,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.ExtHostSearch=C,e.ExtHostSearch=C=Ge([Ve(0,T.IExtHostRpcService),Ve(1,m.IURITransformerService),Ve(2,f.ILogService)],C);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(E),extraFileResources:p.extraFileResources&&p.extraFileResources.map(s=>y.URI.revive(s))}}e.reviveQuery=u;function E(p){return{...p,folder:y.URI.revive(p.folder)}}}),define(Te[293],Ae([1,0,22,15,5,6,12,32,2,147,143,131,92,20,42,14,57,58,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,38,252,118,108,253,228,242,254,255,67,65,243,39,257,63,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,61,66,275,276,245,277,278,85,8,7,234,59,235,62,279,280,107,37,209,77,23,115]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v,l,o,S,w,g,D,h,_,b,A,F,j,H,B,k,N,$,re,le,_e,ye,de,Ee,se,pe,ee,X,V,ne,Ie,Fe,ke,we,me,K,J,ue,he,Pe,ge,De,Re,xe,M,x,q,W,te,oe,Ne,$e,We,Je,tt,ut,rt,it,ot,ze,et,Y,Q,ve,He,Qe,st,Oe,yt,Wt,Ft,Xt,Qt,Dt,qt,jt,Jt,ii,Ye,Mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Zt(ft){const Et=ft.get(X.IExtHostInitDataService),ei=ft.get(ee.IExtHostFileSystemInfo),zt=ft.get(se.IExtHostConsumerFileSystem),Ut=ft.get(de.IExtHostExtensionService),ht=ft.get(jt.IExtHostWorkspace),Tt=ft.get(ot.IExtHostTelemetry),ti=ft.get(A.IExtHostConfiguration),Yt=ft.get(Wt.IURITransformerService),qe=ft.get(te.IExtHostRpcService),Lt=ft.get(ut.IExtHostStorage),xt=ft.get(rt.IExtensionStoragePaths),ni=ft.get(s.ILoggerService),mt=ft.get(s.ILogService),Ot=ft.get(Qe.IExtHostTunnelService),kt=ft.get(i.IExtHostApiDeprecationService),Bt=ft.get(qt.IExtHostWindow),ri=ft.get($e.IExtHostSecretState),Nt=ft.get(_e.IExtHostEditorTabs),$t=ft.get(K.IExtHostManagedSockets);qe.set(r.ExtHostContext.ExtHostFileSystemInfo,ei),qe.set(r.ExtHostContext.ExtHostLogLevelServiceShape,ni),qe.set(r.ExtHostContext.ExtHostWorkspace,ht),qe.set(r.ExtHostContext.ExtHostConfiguration,ti),qe.set(r.ExtHostContext.ExtHostExtensionService,Ut),qe.set(r.ExtHostContext.ExtHostStorage,Lt),qe.set(r.ExtHostContext.ExtHostTunnelService,Ot),qe.set(r.ExtHostContext.ExtHostWindow,Bt),qe.set(r.ExtHostContext.ExtHostSecretState,ri),qe.set(r.ExtHostContext.ExtHostTelemetry,Tt),qe.set(r.ExtHostContext.ExtHostEditorTabs,Nt),qe.set(r.ExtHostContext.ExtHostManagedSockets,$t);const Pt=qe.set(r.ExtHostContext.ExtHostDecorations,ft.get(H.IExtHostDecorations)),Ct=qe.set(r.ExtHostContext.ExtHostDocumentsAndEditors,ft.get(le.IExtHostDocumentsAndEditors)),pt=qe.set(r.ExtHostContext.ExtHostCommands,ft.get(_.IExtHostCommands)),It=qe.set(r.ExtHostContext.ExtHostTerminalService,ft.get(ze.IExtHostTerminalService)),wt=qe.set(r.ExtHostContext.ExtHostDebugService,ft.get(j.IExtHostDebugService)),ui=qe.set(r.ExtHostContext.ExtHostSearch,ft.get(Ne.IExtHostSearch)),Kt=qe.set(r.ExtHostContext.ExtHostTask,ft.get(it.IExtHostTask)),pi=qe.set(r.ExtHostContext.ExtHostOutputService,ft.get(xe.IExtHostOutputService)),be=qe.set(r.ExtHostContext.ExtHostLocalization,ft.get(me.IExtHostLocalizationService)),Le=qe.set(r.ExtHostContext.ExtHostUrls,new Ft.ExtHostUrls(qe)),ae=qe.set(r.ExtHostContext.ExtHostDocuments,new re.ExtHostDocuments(qe,Ct)),G=qe.set(r.ExtHostContext.ExtHostDocumentContentProviders,new N.ExtHostDocumentContentProvider(qe,Ct,mt)),Se=qe.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new $.ExtHostDocumentSaveParticipant(mt,ae,qe.getProxy(r.MainContext.MainThreadBulkEdits))),Me=qe.set(r.ExtHostContext.ExtHostNotebook,new ue.ExtHostNotebookController(qe,pt,Ct,ae,zt,ui)),Xe=qe.set(r.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(Me)),je=qe.set(r.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(mt,Me)),at=qe.set(r.ExtHostContext.ExtHostNotebookKernels,new De.ExtHostNotebookKernels(qe,Et,Me,pt,mt)),_t=qe.set(r.ExtHostContext.ExtHostNotebookRenderers,new Re.ExtHostNotebookRenderers(qe,Me)),Ht=qe.set(r.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new he.ExtHostNotebookDocumentSaveParticipant(mt,Me,qe.getProxy(r.MainContext.MainThreadBulkEdits))),St=qe.set(r.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(qe,Ct)),At=qe.set(r.ExtHostContext.ExtHostTreeViews,new He.ExtHostTreeViews(qe.getProxy(r.MainContext.MainThreadTreeViews),pt,mt)),Gt=qe.set(r.ExtHostContext.ExtHostEditorInsets,new h.ExtHostEditorInsets(qe.getProxy(r.MainContext.MainThreadEditorInsets),St,Et.remote)),vi=qe.set(r.ExtHostContext.ExtHostDiagnostics,new B.ExtHostDiagnostics(qe,mt,ei,Ct)),Ei=qe.set(r.ExtHostContext.ExtHostLanguages,new we.ExtHostLanguages(qe,ae,pt.converter,Yt)),dt=qe.set(r.ExtHostContext.ExtHostLanguageFeatures,new ke.ExtHostLanguageFeatures(qe,Yt,ae,pt,vi,mt,kt,Tt)),Qi=qe.set(r.ExtHostContext.ExtHostFileSystem,new Ee.ExtHostFileSystem(qe,dt)),ai=qe.set(r.ExtHostContext.ExtHostFileSystemEventService,new pe.ExtHostFileSystemEventService(qe,mt,Ct)),fi=qe.set(r.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(qe,ht,pt)),_i=qe.set(r.ExtHostContext.ExtHostSCM,new oe.ExtHostSCM(qe,pt,ae,mt)),Ti=qe.set(r.ExtHostContext.ExtHostQuickDiff,new q.ExtHostQuickDiff(qe,Yt)),Yi=qe.set(r.ExtHostContext.ExtHostShare,new We.ExtHostShare(qe,Yt)),dn=qe.set(r.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(qe,pt,ae)),Ai=qe.set(r.ExtHostContext.ExtHostProgress,new x.ExtHostProgress(qe.getProxy(r.MainContext.MainThreadProgress))),Ri=qe.set(r.ExtHostContext.ExtHostLabelService,new Fe.ExtHostLabelService(qe)),Si=qe.set(r.ExtHostContext.ExtHostTheming,new Q.ExtHostTheming(qe)),mi=qe.set(r.ExtHostContext.ExtHostAuthentication,new v.ExtHostAuthentication(qe)),Ji=qe.set(r.ExtHostContext.ExtHostTimeline,new ve.ExtHostTimeline(qe,pt)),yi=qe.set(r.ExtHostContext.ExtHostWebviews,new Xt.ExtHostWebviews(qe,Et.remote,ht,mt,kt)),Ci=qe.set(r.ExtHostContext.ExtHostWebviewPanels,new Qt.ExtHostWebviewPanels(qe,yi,ht)),Zi=qe.set(r.ExtHostContext.ExtHostCustomEditors,new F.ExtHostCustomEditors(qe,ae,xt,yi,Ci)),hn=qe.set(r.ExtHostContext.ExtHostWebviewViews,new Dt.ExtHostWebviewViews(qe,yi)),bi=qe.set(r.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(qe,mt,pt,Ct)),Li=qe.set(r.ExtHostContext.ExtHostUriOpeners,new yt.ExtHostUriOpeners(qe)),Oi=qe.set(r.ExtHostContext.ExtHostProfileContentHandlers,new M.ExtHostProfileContentHandlers(qe));qe.set(r.ExtHostContext.ExtHostInteractive,new ne.ExtHostInteractive(qe,Me,Ct,pt,mt));const fn=qe.set(r.ExtHostContext.ExtHostInlineChat,new V.ExtHostInteractiveEditor(qe,pt,ae,mt)),Ii=qe.set(r.ExtHostContext.ExtHostChatProvider,new w.ExtHostChatProvider(qe,mt,mi)),en=qe.set(r.ExtHostContext.ExtHostChatAgents2,new S.ExtHostChatAgents2(qe,mt,pt)),mn=qe.set(r.ExtHostContext.ExtHostChatVariables,new g.ExtHostChatVariables(qe)),wi=qe.set(r.ExtHostContext.ExtHostChat,new o.ExtHostChat(qe)),Ni=qe.set(r.ExtHostContext.ExtHostAiRelatedInformation,new a.ExtHostRelatedInformation(qe)),tn=qe.set(r.ExtHostContext.ExtHostAiEmbeddingVector,new ye.ExtHostAiEmbeddingVector(qe)),Fi=qe.set(r.ExtHostContext.ExtHostIssueReporter,new Ie.ExtHostIssueReporter(qe)),nn=qe.set(r.ExtHostContext.ExtHostStatusBar,new tt.ExtHostStatusBar(qe,pt.converter)),Mi=qe.set(r.ExtHostContext.ExtHostSpeech,new Je.ExtHostSpeech(qe)),rn=Object.values(r.ExtHostContext);qe.assertRegistered(rn);const di=new l.ExtHostBulkEdits(qe,Ct),Di=new D.ExtHostClipboard(qe),Ui=new J.ExtHostMessageService(qe,mt),si=new k.ExtHostDialogs(qe);return d.ExtHostApiCommands.register(pt),function(Ue,ci,xi){function nt(Z){return(ce,Be,ct)=>{const bt=Z(Rt=>{try{ce.call(Be,Rt)}catch(Ki){L.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Ki.toString()}`,{cause:Ki})),Tt.onExtensionError(Ue.identifier,Ki)}});return ct?.push(bt),bt}}const vt=function(){let Z=!Ue.isUnderDevelopment;function ce(){Z||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Be(ct){if(Array.isArray(ct))ct.forEach(Be);else if(typeof ct=="string")ce();else{const bt=ct;typeof bt.scheme>"u"&&ce(),typeof bt.exclusive=="boolean"&&(0,Ye.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return ct}}(),gn={getSession(Z,ce,Be){return mi.getSession(Ue,Z,ce,Be)},getSessions(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"authGetSessions"),mi.getSessions(Ue,Z,ce)},async hasSession(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"authSession"),!!await mi.getSession(Ue,Z,ce,{silent:!0})},get onDidChangeSessions(){return nt(mi.onDidChangeSessions)},registerAuthenticationProvider(Z,ce,Be,ct){return mi.registerAuthenticationProvider(Z,ce,Be,ct)}},sn={registerCommand(Z,ce,Be){return pt.registerCommand(!0,Z,ce,Be,void 0,Ue)},registerTextEditorCommand(Z,ce,Be){return pt.registerCommand(!0,Z,(...ct)=>{const bt=St.getActiveTextEditor();if(!bt){mt.warn("Cannot execute "+Z+" because there is no active text editor.");return}return bt.edit(Rt=>{ce.apply(Be,[bt,Rt,...ct])}).then(Rt=>{Rt||mt.warn("Edits from command "+Z+" were not applied.")},Rt=>{mt.warn("An error occurred while running command "+Z,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(Z,ce,Be)=>((0,Ye.checkProposedApiEnabled)(Ue,"diffCommand"),pt.registerCommand(!0,Z,async(...ct)=>{const bt=Ct.activeEditor(!0);if(!bt){mt.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Rt=await St.getDiffInformation(bt.id);ce.apply(Be,[Rt,...ct])},void 0,void 0,Ue)),executeCommand(Z,...ce){return pt.executeCommand(Z,...ce)},getCommands(Z=!1){return pt.getCommands(Z)}},Bi={get machineId(){return Et.telemetryInfo.machineId},get sessionId(){return Et.telemetryInfo.sessionId},get language(){return Et.environment.appLanguage},get appName(){return Et.environment.appName},get appRoot(){return Et.environment.appRoot?.fsPath??""},get appHost(){return Et.environment.appHost},get uriScheme(){return Et.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return nt(It.onDidChangeShell)},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Tt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(Ue,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(Ue,"telemetry"),nt(Tt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.isNewAppInstall)(Et.telemetryInfo.firstSessionDate)},createTelemetryLogger(Z,ce){return ot.ExtHostTelemetryLogger.validateSender(Z),Tt.instantiateLogger(Ue,Z,ce)},openExternal(Z,ce){return Bt.openUri(Z,{allowTunneling:!!Et.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===Et.environment.appUriScheme)return Le.createAppUri(Z);try{return await Bt.asExternalUri(Z,{allowTunneling:!!Et.remote.authority})}catch(ce){if((0,T.matchesScheme)(Z,T.Schemas.http)||(0,T.matchesScheme)(Z,T.Schemas.https))return Z;throw ce}},get remoteName(){return(0,c.getRemoteName)(Et.remote.authority)},get remoteAuthority(){return(0,Ye.checkProposedApiEnabled)(Ue,"resolvers"),Et.remote.authority},get uiKind(){return Et.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return nt(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler(Z){return(0,Ye.checkProposedApiEnabled)(Ue,"handleIssueUri"),Fi.registerIssueUriRequestHandler(Ue,Z)},registerIssueDataProvider(Z){return(0,Ye.checkProposedApiEnabled)(Ue,"handleIssueUri"),Fi.registerIssueDataProvider(Ue,Z)},get appQuality(){return(0,Ye.checkProposedApiEnabled)(Ue,"resolvers"),Et.quality},get appCommit(){return(0,Ye.checkProposedApiEnabled)(Ue,"resolvers"),Et.commit}};Et.environment.extensionTestsLocationURI||Object.freeze(Bi);const pn={createTestController(Z,ce,Be){return bi.createTestController(Ue,Z,ce,Be)},createTestObserver(){return(0,Ye.checkProposedApiEnabled)(Ue,"testObserver"),bi.createTestObserver()},runTests(Z){return(0,Ye.checkProposedApiEnabled)(Ue,"testObserver"),bi.runTests(Z)},get onDidChangeTestResults(){return(0,Ye.checkProposedApiEnabled)(Ue,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Ye.checkProposedApiEnabled)(Ue,"testObserver"),bi.results}},ki=Et.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,on={getExtension(Z,ce){(0,Ye.isProposedApiEnabled)(Ue,"extensionsAny")||(ce=!1);const Be=ci.mine.getExtensionDescription(Z);if(Be)return new de.Extension(Ut,Ue.identifier,Be,ki,!1);if(ce){const ct=ci.all.getExtensionDescription(Z);if(ct)return new de.Extension(Ut,Ue.identifier,ct,ki,!0)}},get all(){const Z=[];for(const ce of ci.mine.getAllExtensionDescriptions())Z.push(new de.Extension(Ut,Ue.identifier,ce,ki,!1));return Z},get allAcrossExtensionHosts(){(0,Ye.checkProposedApiEnabled)(Ue,"extensionsAny");const Z=new E.ExtensionIdentifierSet(ci.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),ce=[];for(const Be of ci.all.getAllExtensionDescriptions()){const ct=!Z.has(Be.identifier);ce.push(new de.Extension(Ut,Ue.identifier,Be,ki,ct))}return ce},get onDidChange(){return(0,Ye.isProposedApiEnabled)(Ue,"extensionsAny")?nt(P.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):nt(ci.mine.onDidChange)}},zi={createDiagnosticCollection(Z){return vi.createDiagnosticCollection(Ue.identifier,Z)},get onDidChangeDiagnostics(){return nt(vi.onDidChangeDiagnostics)},getDiagnostics:Z=>vi.getDiagnostics(Z),getLanguages(){return Ei.getLanguages()},setTextDocumentLanguage(Z,ce){return Ei.changeLanguage(Z.uri,ce)},match(Z,ce){const Be=st.LanguageSelector.from(Z);let ct;return(0,R.targetsNotebooks)(Be)&&(ct=Me.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Rt=>Rt.document===ce))?.apiNotebook),(0,R.score)(Be,ce.uri,ce.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(Z,ce,Be){return dt.registerCodeActionProvider(Ue,vt(Z),ce,Be)},registerDocumentPasteEditProvider(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,vt(Z),ce,Be)},registerCodeLensProvider(Z,ce){return dt.registerCodeLensProvider(Ue,vt(Z),ce)},registerDefinitionProvider(Z,ce){return dt.registerDefinitionProvider(Ue,vt(Z),ce)},registerDeclarationProvider(Z,ce){return dt.registerDeclarationProvider(Ue,vt(Z),ce)},registerImplementationProvider(Z,ce){return dt.registerImplementationProvider(Ue,vt(Z),ce)},registerTypeDefinitionProvider(Z,ce){return dt.registerTypeDefinitionProvider(Ue,vt(Z),ce)},registerHoverProvider(Z,ce){return dt.registerHoverProvider(Ue,vt(Z),ce,Ue.identifier)},registerEvaluatableExpressionProvider(Z,ce){return dt.registerEvaluatableExpressionProvider(Ue,vt(Z),ce,Ue.identifier)},registerInlineValuesProvider(Z,ce){return dt.registerInlineValuesProvider(Ue,vt(Z),ce,Ue.identifier)},registerDocumentHighlightProvider(Z,ce){return dt.registerDocumentHighlightProvider(Ue,vt(Z),ce)},registerMultiDocumentHighlightProvider(Z,ce){return dt.registerMultiDocumentHighlightProvider(Ue,vt(Z),ce)},registerLinkedEditingRangeProvider(Z,ce){return dt.registerLinkedEditingRangeProvider(Ue,vt(Z),ce)},registerReferenceProvider(Z,ce){return dt.registerReferenceProvider(Ue,vt(Z),ce)},registerRenameProvider(Z,ce){return dt.registerRenameProvider(Ue,vt(Z),ce)},registerNewSymbolNamesProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"newSymbolNamesProvider"),dt.registerNewSymbolNamesProvider(Ue,vt(Z),ce)},registerDocumentSymbolProvider(Z,ce,Be){return dt.registerDocumentSymbolProvider(Ue,vt(Z),ce,Be)},registerWorkspaceSymbolProvider(Z){return dt.registerWorkspaceSymbolProvider(Ue,Z)},registerDocumentFormattingEditProvider(Z,ce){return dt.registerDocumentFormattingEditProvider(Ue,vt(Z),ce)},registerDocumentRangeFormattingEditProvider(Z,ce){return dt.registerDocumentRangeFormattingEditProvider(Ue,vt(Z),ce)},registerOnTypeFormattingEditProvider(Z,ce,Be,...ct){return dt.registerOnTypeFormattingEditProvider(Ue,vt(Z),ce,[Be].concat(ct))},registerDocumentSemanticTokensProvider(Z,ce,Be){return dt.registerDocumentSemanticTokensProvider(Ue,vt(Z),ce,Be)},registerDocumentRangeSemanticTokensProvider(Z,ce,Be){return dt.registerDocumentRangeSemanticTokensProvider(Ue,vt(Z),ce,Be)},registerSignatureHelpProvider(Z,ce,Be,...ct){return typeof Be=="object"?dt.registerSignatureHelpProvider(Ue,vt(Z),ce,Be):dt.registerSignatureHelpProvider(Ue,vt(Z),ce,typeof Be>"u"?[]:[Be,...ct])},registerCompletionItemProvider(Z,ce,...Be){return dt.registerCompletionItemProvider(Ue,vt(Z),ce,Be)},registerInlineCompletionItemProvider(Z,ce,Be){return ce.handleDidShowCompletionItem&&(0,Ye.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Ye.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),Be&&(0,Ye.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,vt(Z),ce,Be)},registerInlineEditProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"inlineEdit"),dt.registerInlineEditProvider(Ue,vt(Z),ce)},registerDocumentLinkProvider(Z,ce){return dt.registerDocumentLinkProvider(Ue,vt(Z),ce)},registerColorProvider(Z,ce){return dt.registerColorProvider(Ue,vt(Z),ce)},registerFoldingRangeProvider(Z,ce){return dt.registerFoldingRangeProvider(Ue,vt(Z),ce)},registerSelectionRangeProvider(Z,ce){return dt.registerSelectionRangeProvider(Ue,Z,ce)},registerCallHierarchyProvider(Z,ce){return dt.registerCallHierarchyProvider(Ue,Z,ce)},registerTypeHierarchyProvider(Z,ce){return dt.registerTypeHierarchyProvider(Ue,Z,ce)},setLanguageConfiguration:(Z,ce)=>dt.setLanguageConfiguration(Ue,Z,ce),getTokenInformationAtPosition(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"tokenInformation"),Ei.tokenAtPosition(Z,ce)},registerInlayHintsProvider(Z,ce){return dt.registerInlayHintsProvider(Ue,Z,ce)},createLanguageStatusItem(Z,ce){return Ei.createLanguageStatusItem(Ue,Z,ce)},registerDocumentDropEditProvider(Z,ce,Be){return dt.registerDocumentOnDropEditProvider(Ue,Z,ce,(0,Ye.isProposedApiEnabled)(Ue,"dropMetadata")?Be:void 0)}},an={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(Z,ce,Be){f.URI.isUri(Z)&&Z.scheme===T.Schemas.vscodeRemote&&!Z.authority&&kt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(f.URI.isUri(Z)?Promise.resolve($i.openTextDocument(Z)):Promise.resolve(Z));return St.showTextDocument(ct,ce,Be)},createTextEditorDecorationType(Z){return St.createTextEditorDecorationType(Ue,Z)},onDidChangeActiveTextEditor(Z,ce,Be){return nt(St.onDidChangeActiveTextEditor)(Z,ce,Be)},onDidChangeVisibleTextEditors(Z,ce,Be){return nt(St.onDidChangeVisibleTextEditors)(Z,ce,Be)},onDidChangeTextEditorSelection(Z,ce,Be){return nt(St.onDidChangeTextEditorSelection)(Z,ce,Be)},onDidChangeTextEditorOptions(Z,ce,Be){return nt(St.onDidChangeTextEditorOptions)(Z,ce,Be)},onDidChangeTextEditorVisibleRanges(Z,ce,Be){return nt(St.onDidChangeTextEditorVisibleRanges)(Z,ce,Be)},onDidChangeTextEditorViewColumn(Z,ce,Be){return nt(St.onDidChangeTextEditorViewColumn)(Z,ce,Be)},onDidCloseTerminal(Z,ce,Be){return nt(It.onDidCloseTerminal)(Z,ce,Be)},onDidOpenTerminal(Z,ce,Be){return nt(It.onDidOpenTerminal)(Z,ce,Be)},onDidChangeActiveTerminal(Z,ce,Be){return nt(It.onDidChangeActiveTerminal)(Z,ce,Be)},onDidChangeTerminalDimensions(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"terminalDimensions"),nt(It.onDidChangeTerminalDimensions)(Z,ce,Be)},onDidChangeTerminalState(Z,ce,Be){return nt(It.onDidChangeTerminalState)(Z,ce,Be)},onDidWriteTerminalData(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),nt(It.onDidWriteTerminalData)(Z,ce,Be)},onDidExecuteTerminalCommand(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"terminalExecuteCommandEvent"),nt(It.onDidExecuteTerminalCommand)(Z,ce,Be)},get state(){return Bt.getState(Ue)},onDidChangeWindowState(Z,ce,Be){return nt(Bt.onDidChangeWindowState)(Z,ce,Be)},showInformationMessage(Z,...ce){return Ui.showMessage(Ue,m.default.Info,Z,ce[0],ce.slice(1))},showWarningMessage(Z,...ce){return Ui.showMessage(Ue,m.default.Warning,Z,ce[0],ce.slice(1))},showErrorMessage(Z,...ce){return Ui.showMessage(Ue,m.default.Error,Z,ce[0],ce.slice(1))},showQuickPick(Z,ce,Be){return fi.showQuickPick(Ue,Z,ce,Be)},showWorkspaceFolderPick(Z){return fi.showWorkspaceFolderPick(Z)},showInputBox(Z,ce){return fi.showInput(Z,ce)},showOpenDialog(Z){return si.showOpenDialog(Ue,Z)},showSaveDialog(Z){return si.showSaveDialog(Z)},createStatusBarItem(Z,ce,Be){let ct,bt,Rt;return typeof Z=="string"?(ct=Z,bt=ce,Rt=Be):(bt=Z,Rt=ce),nn.createStatusBarEntry(Ue,ct,bt,Rt)},setStatusBarMessage(Z,ce){return nn.setStatusBarMessage(Z,ce)},withScmProgress(Z){return kt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ai.withProgress(Ue,{location:Oe.ProgressLocation.SourceControl},(ce,Be)=>Z({report(ct){}}))},withProgress(Z,ce){return Ai.withProgress(Ue,Z,ce)},createOutputChannel(Z,ce){return pi.createOutputChannel(Z,ce,Ue)},createWebviewPanel(Z,ce,Be,ct){return Ci.createWebviewPanel(Ue,Z,ce,Be,ct)},createWebviewTextEditorInset(Z,ce,Be,ct){return(0,Ye.checkProposedApiEnabled)(Ue,"editorInsets"),Gt.createWebviewEditorInset(Z,ce,Be,ct,Ue)},createTerminal(Z,ce,Be){return typeof Z=="object"?"pty"in Z?It.createExtensionTerminal(Z):It.createTerminalFromOptions(Z):It.createTerminal(Z,ce,Be)},registerTerminalLinkProvider(Z){return It.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,ce){return It.registerProfileProvider(Ue,Z,ce)},registerTerminalQuickFixProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(Z,Ue.identifier.value,ce)},registerTreeDataProvider(Z,ce){return At.registerTreeDataProvider(Z,ce,Ue)},createTreeView(Z,ce){return At.createTreeView(Z,ce,Ue)},registerWebviewPanelSerializer:(Z,ce)=>Ci.registerWebviewPanelSerializer(Ue,Z,ce),registerCustomEditorProvider:(Z,ce,Be={})=>Zi.registerCustomEditorProvider(Ue,Z,ce,Be),registerFileDecorationProvider(Z){return Pt.registerFileDecorationProvider(Z,Ue)},registerUriHandler(Z){return Le.registerUriHandler(Ue,Z)},createQuickPick(){return fi.createQuickPick(Ue)},createInputBox(){return fi.createInputBox(Ue)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(Z,ce,Be){return nt(Si.onDidChangeActiveColorTheme)(Z,ce,Be)},registerWebviewViewProvider(Z,ce,Be){return hn.registerWebviewViewProvider(Ue,Z,ce,Be?.webviewOptions)},get activeNotebookEditor(){return Me.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ce,Be){return nt(Me.onDidChangeActiveNotebookEditor)(Z,ce,Be)},get visibleNotebookEditors(){return Me.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(Me.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(Z,ce,Be){return nt(je.onDidChangeNotebookEditorSelection)(Z,ce,Be)},onDidChangeNotebookEditorVisibleRanges(Z,ce,Be){return nt(je.onDidChangeNotebookEditorVisibleRanges)(Z,ce,Be)},showNotebookDocument(Z,ce){return Me.showNotebookDocument(Z,ce)},registerExternalUriOpener(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"externalUriOpener"),Li.registerExternalUriOpener(Ue.identifier,Z,ce,Be)},registerProfileContentHandler(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Oi.registerProfileContentHandler(Ue,Z,ce)},registerQuickDiffProvider(Z,ce,Be,ct){return(0,Ye.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ti.registerQuickDiffProvider(vt(Z),ce,Be,ct)},get tabGroups(){return Nt.tabGroups},registerShareProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"shareProvider"),Yi.registerShareProvider(vt(Z),ce)}},$i={get rootPath(){return kt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(Z){throw new L.ReadonlyError("rootPath")},getWorkspaceFolder(Z){return ht.getWorkspaceFolder(Z)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(Z){throw new L.ReadonlyError("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(Z){throw new L.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(Z,ce,...Be)=>ht.updateWorkspaceFolders(Ue,Z,ce||0,...Be),onDidChangeWorkspaceFolders:function(Z,ce,Be){return nt(ht.onDidChangeWorkspace)(Z,ce,Be)},asRelativePath:(Z,ce)=>ht.getRelativePath(Z,ce),findFiles:(Z,ce,Be,ct)=>ht.findFiles(Z,ce,Be,Ue.identifier,ct),findFiles2:(Z,ce,Be)=>((0,Ye.checkProposedApiEnabled)(Ue,"findFiles2"),ht.findFiles2(Z,ce,Ue.identifier,Be)),findTextInFiles:(Z,ce,Be,ct)=>{(0,Ye.checkProposedApiEnabled)(Ue,"findTextInFiles");let bt,Rt;return typeof ce=="object"?(bt=ce,Rt=Be):(bt={},Rt=ce,ct=Be),ht.findTextInFiles(Z,bt||{},Rt,Ue.identifier,ct)},save:Z=>ht.save(Z),saveAs:Z=>ht.saveAs(Z),saveAll:Z=>ht.saveAll(Z),applyEdit(Z,ce){return di.applyWorkspaceEdit(Z,Ue,ce)},createFileSystemWatcher:(Z,ce,Be,ct)=>{let bt;return typeof ce=="boolean"?bt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ct,correlate:!1}:ce&&((0,Ye.checkProposedApiEnabled)(Ue,"createFileSystemWatcher"),bt={...ce,correlate:!0}),ai.createFileSystemWatcher(ht,Ue,Z,bt)},get textDocuments(){return ae.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw new L.ReadonlyError("textDocuments")},openTextDocument(Z){let ce;const Be=Z;if(typeof Z=="string")ce=Promise.resolve(f.URI.file(Z));else if(f.URI.isUri(Z))ce=Promise.resolve(Z);else if(!Be||typeof Be=="object")ce=ae.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ct=>(ct.scheme===T.Schemas.vscodeRemote&&!ct.authority&&kt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),ae.ensureDocumentData(ct).then(bt=>bt.document)))},onDidOpenTextDocument:(Z,ce,Be)=>nt(ae.onDidAddDocument)(Z,ce,Be),onDidCloseTextDocument:(Z,ce,Be)=>nt(ae.onDidRemoveDocument)(Z,ce,Be),onDidChangeTextDocument:(Z,ce,Be)=>nt(ae.onDidChangeDocument)(Z,ce,Be),onDidSaveTextDocument:(Z,ce,Be)=>nt(ae.onDidSaveDocument)(Z,ce,Be),onWillSaveTextDocument:(Z,ce,Be)=>nt(Se.getOnWillSaveTextDocumentEvent(Ue))(Z,ce,Be),get notebookDocuments(){return Me.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,ce){let Be;if(f.URI.isUri(Z))Be=Z,await Me.openNotebookDocument(Z);else if(typeof Z=="string")Be=f.URI.revive(await Me.createNotebookDocument({viewType:Z,content:ce}));else throw new Error("Invalid arguments");return Me.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(Z,ce,Be){return nt(Xe.onDidSaveNotebookDocument)(Z,ce,Be)},onDidChangeNotebookDocument(Z,ce,Be){return nt(Xe.onDidChangeNotebookDocument)(Z,ce,Be)},onWillSaveNotebookDocument(Z,ce,Be){return nt(Ht.getOnWillSaveNotebookDocumentEvent(Ue))(Z,ce,Be)},get onDidOpenNotebookDocument(){return nt(Me.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(Me.onDidCloseNotebookDocument)},registerNotebookSerializer(Z,ce,Be,ct){return Me.registerNotebookSerializer(Ue,Z,ce,Be,(0,Ye.isProposedApiEnabled)(Ue,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(Z,ce,Be)=>nt(xi.onDidChangeConfiguration)(Z,ce,Be),getConfiguration(Z,ce){return ce=arguments.length===1?void 0:ce,xi.getConfiguration(Z,ce,Ue)},registerTextDocumentContentProvider(Z,ce){return G.registerTextDocumentContentProvider(Z,ce)},registerTaskProvider:(Z,ce)=>(kt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,Z,ce)),registerFileSystemProvider(Z,ce,Be){return(0,O.combinedDisposable)(Qi.registerFileSystemProvider(Ue,Z,ce,Be),zt.addFileSystemProvider(Z,ce,Be))},get fs(){return zt.value},registerFileSearchProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"fileSearchProvider"),ui.registerFileSearchProvider(Z,ce)),registerTextSearchProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"textSearchProvider"),ui.registerTextSearchProvider(Z,ce)),registerRemoteAuthorityResolver:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"resolvers"),Ut.registerRemoteAuthorityResolver(Z,ce)),registerResourceLabelFormatter:Z=>((0,Ye.checkProposedApiEnabled)(Ue,"resolvers"),Ri.$registerResourceLabelFormatter(Z)),getRemoteExecServer:Z=>((0,Ye.checkProposedApiEnabled)(Ue,"resolvers"),Ut.getRemoteExecServer(Z)),onDidCreateFiles:(Z,ce,Be)=>nt(ai.onDidCreateFile)(Z,ce,Be),onDidDeleteFiles:(Z,ce,Be)=>nt(ai.onDidDeleteFile)(Z,ce,Be),onDidRenameFiles:(Z,ce,Be)=>nt(ai.onDidRenameFile)(Z,ce,Be),onWillCreateFiles:(Z,ce,Be)=>nt(ai.getOnWillCreateFileEvent(Ue))(Z,ce,Be),onWillDeleteFiles:(Z,ce,Be)=>nt(ai.getOnWillDeleteFileEvent(Ue))(Z,ce,Be),onWillRenameFiles:(Z,ce,Be)=>nt(ai.getOnWillRenameFileEvent(Ue))(Z,ce,Be),openTunnel:Z=>((0,Ye.checkProposedApiEnabled)(Ue,"tunnels"),Ot.openTunnel(Ue,Z).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Ye.checkProposedApiEnabled)(Ue,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(Z,ce,Be)=>((0,Ye.checkProposedApiEnabled)(Ue,"tunnels"),nt(Ot.onDidChangeTunnels)(Z,ce,Be)),registerPortAttributesProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"portsAttributes"),Ot.registerPortsAttributesProvider(Z,ce)),registerTunnelProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"tunnelFactory"),Ot.registerTunnelProvider(Z,ce)),registerTimelineProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"timeline"),Ji.registerTimelineProvider(Z,ce,Ue.identifier,pt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:Z=>((0,Ye.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ce,Be)=>nt(ht.onDidGrantWorkspaceTrust)(Z,ce,Be),registerEditSessionIdentityProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(Z,ce)),onWillCreateEditSessionIdentity:(Z,ce,Be)=>((0,Ye.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),nt(ht.getOnWillCreateEditSessionIdentityEvent(Ue))(Z,ce,Be)),registerCanonicalUriProvider:(Z,ce)=>((0,Ye.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),ht.registerCanonicalUriProvider(Z,ce)),getCanonicalUri:(Z,ce,Be)=>((0,Ye.checkProposedApiEnabled)(Ue,"canonicalUriProvider"),ht.provideCanonicalUri(Z,ce,Be))},cn={get inputBox(){return kt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),_i.getLastInputBox(Ue)},createSourceControl(Z,ce,Be){return _i.createSourceControl(Ue,Z,ce,Be)}},vn={createCommentController(Z,ce){return dn.createCommentController(Ue,Z,ce)}},En={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},get stackFrameFocus(){return wt.stackFrameFocus},registerDebugVisualizationProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"debugVisualization"),wt.registerDebugVisualizationProvider(Ue,Z,ce)},registerDebugVisualizationTreeProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"debugVisualization"),wt.registerDebugVisualizationTree(Ue,Z,ce)},onDidStartDebugSession(Z,ce,Be){return nt(wt.onDidStartDebugSession)(Z,ce,Be)},onDidTerminateDebugSession(Z,ce,Be){return nt(wt.onDidTerminateDebugSession)(Z,ce,Be)},onDidChangeActiveDebugSession(Z,ce,Be){return nt(wt.onDidChangeActiveDebugSession)(Z,ce,Be)},onDidReceiveDebugSessionCustomEvent(Z,ce,Be){return nt(wt.onDidReceiveDebugSessionCustomEvent)(Z,ce,Be)},onDidChangeBreakpoints(Z,ce,Be){return nt(wt.onDidChangeBreakpoints)(Z,ce,Be)},onDidChangeStackFrameFocus(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"debugFocus"),nt(wt.onDidChangeStackFrameFocus)(Z,ce,Be)},registerDebugConfigurationProvider(Z,ce,Be){return wt.registerDebugConfigurationProvider(Z,ce,Be||Jt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ce){return wt.registerDebugAdapterDescriptorFactory(Ue,Z,ce)},registerDebugAdapterTrackerFactory(Z,ce){return wt.registerDebugAdapterTrackerFactory(Z,ce)},startDebugging(Z,ce,Be){return!Be||typeof Be=="object"&&"configuration"in Be?wt.startDebugging(Z,ce,{parentSession:Be}):wt.startDebugging(Z,ce,Be||{})},stopDebugging(Z){return wt.stopDebugging(Z)},addBreakpoints(Z){return wt.addBreakpoints(Z)},removeBreakpoints(Z){return wt.removeBreakpoints(Z)},asDebugSourceUri(Z,ce){return wt.asDebugSourceUri(Z,ce)}},ln={registerTaskProvider:(Z,ce)=>Kt.registerTaskProvider(Ue,Z,ce),fetchTasks:Z=>Kt.fetchTasks(Z),executeTask:Z=>Kt.executeTask(Ue,Z),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(Z,ce,Be)=>nt(Kt.onDidStartTask)(Z,ce,Be),onDidEndTask:(Z,ce,Be)=>nt(Kt.onDidEndTask)(Z,ce,Be),onDidStartTaskProcess:(Z,ce,Be)=>nt(Kt.onDidStartTaskProcess)(Z,ce,Be),onDidEndTaskProcess:(Z,ce,Be)=>nt(Kt.onDidEndTaskProcess)(Z,ce,Be)},un={createNotebookController(Z,ce,Be,ct,bt){return at.createNotebookController(Ue,Z,ce,Be,ct,(0,Ye.isProposedApiEnabled)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,ce)=>Me.registerNotebookCellStatusBarItemProvider(Ue,Z,ce),createRendererMessaging(Z){return _t.createRendererMessaging(Ue,Z)},createNotebookControllerDetectionTask(Z){return(0,Ye.checkProposedApiEnabled)(Ue,"notebookKernelSource"),at.createNotebookControllerDetectionTask(Ue,Z)},registerKernelSourceActionProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"notebookKernelSource"),at.registerKernelSourceActionProvider(Ue,Z,ce)},onDidChangeNotebookCellExecutionState(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),nt(at.onDidChangeNotebookCellExecutionState)(Z,ce,Be)}},Hi={t(...Z){if(typeof Z[0]=="string"){const ce=Z.shift(),Be=!Z||typeof Z[0]!="object"?Z:Z[0];return be.getMessage(Ue.identifier.value,{message:ce,args:Be})}return be.getMessage(Ue.identifier.value,Z[0])},get bundle(){return be.getBundle(Ue.identifier.value)},get uri(){return be.getBundleUri(Ue.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"interactive"),fn.registerProvider(Ue,Z,ce)},registerInteractiveSessionProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"interactive"),wi.registerChatProvider(Ue,Z,ce)},sendInteractiveRequestToProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"interactive"),wi.sendInteractiveRequestToProvider(Z,ce)},transferChatSession(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"interactive"),wi.transferChatSession(Z,ce)}},Wi={getRelatedInformation(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"aiRelatedInformation"),Ni.getRelatedInformation(Ue,Z,ce)},registerRelatedInformationProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"aiRelatedInformation"),Ni.registerRelatedInformationProvider(Ue,Z,ce)},registerEmbeddingVectorProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"aiRelatedInformation"),tn.registerEmbeddingVectorProvider(Ue,Z,ce)}},Pi={registerChatResponseProvider(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"chatProvider"),Ii.registerLanguageModel(Ue,Z,ce,Be)},registerChatVariableResolver(Z,ce,Be){return(0,Ye.checkProposedApiEnabled)(Ue,"chatVariableResolver"),mn.registerVariableResolver(Ue,Z,ce,Be)},registerMappedEditsProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"mappedEditsProvider"),dt.registerMappedEditsProvider(Ue,Z,ce)},createChatParticipant(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"chatParticipant"),en.createChatAgent(Ue,Z,ce)}},qi={requestLanguageModelAccess(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"languageModels"),Ii.requestLanguageModelAccess(Ue,Z,ce)},get languageModels(){return(0,Ye.checkProposedApiEnabled)(Ue,"languageModels"),Ii.getLanguageModelIds()},onDidChangeLanguageModels:(Z,ce,Be)=>((0,Ye.checkProposedApiEnabled)(Ue,"languageModels"),Ii.onDidChangeProviders(Z,ce,Be))},ji={registerSpeechProvider(Z,ce){return(0,Ye.checkProposedApiEnabled)(Ue,"speech"),Mi.registerProvider(Ue.identifier,Z,ce)}};return{version:Et.version,ai:Wi,authentication:gn,commands:sn,comments:vn,chat:Pi,debug:En,env:Bi,extensions:on,interactive:Vi,l10n:Hi,languages:zi,lm:qi,notebooks:un,scm:cn,speech:ji,tasks:ln,tests:pn,window:an,workspace:$i,Breakpoint:Oe.Breakpoint,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatResultFeedbackKind:Oe.ChatResultFeedbackKind,ChatVariableLevel:Oe.ChatVariableLevel,ChatCompletionItem:Oe.ChatCompletionItem,CallHierarchyIncomingCall:Oe.CallHierarchyIncomingCall,CallHierarchyItem:Oe.CallHierarchyItem,CallHierarchyOutgoingCall:Oe.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.CodeAction,CodeActionKind:Oe.CodeActionKind,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.CodeLens,Color:Oe.Color,ColorInformation:Oe.ColorInformation,ColorPresentation:Oe.ColorPresentation,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.CompletionItem,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.CompletionList,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.CustomExecution,DebugAdapterExecutable:Oe.DebugAdapterExecutable,DebugAdapterInlineImplementation:Oe.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Oe.DebugAdapterNamedPipeServer,DebugAdapterServer:Oe.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Jt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.DebugVisualization,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.Diagnostic,DiagnosticRelatedInformation:Oe.DiagnosticRelatedInformation,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.Disposable,DocumentHighlight:Oe.DocumentHighlight,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.MultiDocumentHighlight,DocumentLink:Oe.DocumentLink,DocumentSymbol:Oe.DocumentSymbol,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.EvaluatableExpression,InlineValueText:Oe.InlineValueText,InlineValueVariableLookup:Oe.InlineValueVariableLookup,InlineValueEvaluatableExpression:Oe.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:P.Emitter,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.FileDecoration,FileDecoration2:Oe.FileDecoration,FileSystemError:Oe.FileSystemError,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Oe.FoldingRange,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.FunctionBreakpoint,InlineCompletionItem:Oe.InlineSuggestion,InlineCompletionList:Oe.InlineSuggestionList,Hover:Oe.Hover,IndentAction:C.IndentAction,Location:Oe.Location,MarkdownString:Oe.MarkdownString,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Oe.ParameterInformation,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.Position,ProcessExecution:Oe.ProcessExecution,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.QuickInputButtons,Range:Oe.Range,RelativePattern:Oe.RelativePattern,Selection:Oe.Selection,SelectionRange:Oe.SelectionRange,SemanticTokens:Oe.SemanticTokens,SemanticTokensBuilder:Oe.SemanticTokensBuilder,SemanticTokensEdit:Oe.SemanticTokensEdit,SemanticTokensEdits:Oe.SemanticTokensEdits,SemanticTokensLegend:Oe.SemanticTokensLegend,ShellExecution:Oe.ShellExecution,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.SignatureHelp,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.SignatureInformation,SnippetString:Oe.SnippetString,SourceBreakpoint:Oe.SourceBreakpoint,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.SymbolInformation,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.Task,TaskGroup:Oe.TaskGroup,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.TerminalLink,TerminalQuickFixTerminalCommand:Oe.TerminalQuickFixCommand,TerminalQuickFixOpener:Oe.TerminalQuickFixOpener,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.TerminalProfile,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.TextEdit,SnippetTextEdit:Oe.SnippetTextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.ThemeColor,ThemeIcon:Oe.ThemeIcon,TreeItem:Oe.TreeItem,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.TypeHierarchyItem,UIKind:ii.UIKind,Uri:f.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.WorkspaceEdit,DocumentDropEdit:Oe.DocumentDropEdit,DocumentPasteEdit:Oe.DocumentPasteEdit,InlayHint:Oe.InlayHint,InlayHintLabelPart:Oe.InlayHintLabelPart,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.RemoteAuthorityResolverError,ResolvedAuthority:Oe.ResolvedAuthority,ManagedResolvedAuthority:Oe.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.TimelineItem,NotebookRange:Oe.NotebookRange,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.NotebookCellData,NotebookData:Oe.NotebookData,NotebookRendererScript:Oe.NotebookRendererScript,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.NotebookCellOutput,NotebookCellOutputItem:Oe.NotebookCellOutputItem,NotebookCellStatusBarItem:Oe.NotebookCellStatusBarItem,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.NotebookEdit,NotebookKernelSourceAction:Oe.NotebookKernelSourceAction,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.PortAttributes,LinkedEditingRanges:Oe.LinkedEditingRanges,TestResultState:Oe.TestResultState,TestRunRequest:Oe.TestRunRequest,TestMessage:Oe.TestMessage,TestTag:Oe.TestTag,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Mt.TextSearchCompleteMessageType,DataTransfer:Oe.DataTransfer,DataTransferItem:Oe.DataTransferItem,CoveredCount:Oe.CoveredCount,FileCoverage:Oe.FileCoverage,StatementCoverage:Oe.StatementCoverage,BranchCoverage:Oe.BranchCoverage,DeclarationCoverage:Oe.DeclarationCoverage,FunctionCoverage:Oe.DeclarationCoverage,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.TextTabInput,TabInputTextDiff:Oe.TextDiffTabInput,TabInputTextMerge:Oe.TextMergeTabInput,TabInputCustom:Oe.CustomEditorTabInput,TabInputNotebook:Oe.NotebookEditorTabInput,TabInputNotebookDiff:Oe.NotebookDiffEditorTabInput,TabInputWebview:Oe.WebviewEditorTabInput,TabInputTerminal:Oe.TerminalEditorTabInput,TabInputInteractiveWindow:Oe.InteractiveWindowInput,TabInputChat:Oe.ChatEditorTabInput,TelemetryTrustedValue:t.TelemetryTrustedValue,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatCopyKind:Oe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.StackFrameFocus,ThreadFocus:Oe.ThreadFocus,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Oe.ChatResponseMarkdownPart,ChatResponseFileTreePart:Oe.ChatResponseFileTreePart,ChatResponseAnchorPart:Oe.ChatResponseAnchorPart,ChatResponseProgressPart:Oe.ChatResponseProgressPart,ChatResponseReferencePart:Oe.ChatResponseReferencePart,ChatResponseCommandButtonPart:Oe.ChatResponseCommandButtonPart,ChatRequestTurn:Oe.ChatRequestTurn,ChatResponseTurn:Oe.ChatResponseTurn,LanguageModelSystemMessage:Oe.LanguageModelSystemMessage,LanguageModelUserMessage:Oe.LanguageModelUserMessage,LanguageModelAssistantMessage:Oe.LanguageModelAssistantMessage,NewSymbolName:Oe.NewSymbolName,NewSymbolNameTag:Oe.NewSymbolNameTag,InlineEdit:Oe.InlineEdit,InlineEditTriggerKind:Oe.InlineEditTriggerKind}}}e.createApiFactoryAndRegisterActors=Zt}),define(Te[294],Ae([1,0,54,113,37,108,38,31,67,66,116,118,119,82,85,78,107,63,43,81,61,65,230,14,117,79,80]),function(fe,e,I,L,P,O,T,m,f,y,R,C,u,E,p,s,c,t,n,r,a,d,i,v,l,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,I.registerSingleton)(v.ILoggerService,i.ExtHostLoggerService,1),(0,I.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService,1),(0,I.registerSingleton)(m.IExtHostCommands,m.ExtHostCommands,0),(0,I.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,I.registerSingleton)(t.IExtHostConsumerFileSystem,t.ExtHostConsumerFileSystem,0),(0,I.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService,0),(0,I.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,0),(0,I.registerSingleton)(f.IExtHostDocumentsAndEditors,f.ExtHostDocumentsAndEditors,0),(0,I.registerSingleton)(S.IExtHostManagedSockets,S.ExtHostManagedSockets,0),(0,I.registerSingleton)(n.IExtHostFileSystemInfo,n.ExtHostFileSystemInfo,0),(0,I.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,I.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch,0),(0,I.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,I.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,I.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,I.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,I.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow,0),(0,I.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace,0),(0,I.registerSingleton)(r.IExtHostSecretState,r.ExtHostSecretState,0),(0,I.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,0),(0,I.registerSingleton)(d.IExtHostEditorTabs,d.ExtHostEditorTabs,0),(0,I.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(Te[295],Ae([1,0,293,39,2,290,7,11,236]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends O.RequireInterceptor{_installInterceptor(){}getModule(E,p){for(const s of this._alternatives){const c=s(E);if(c){E=c;break}}if(this._factories.has(E))return this._factories.get(E).load(E,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(f.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(y,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,p,s){p=p.with({path:C(p.path,".js")});const c=E?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const t=P.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),n=await fetch(t.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),n.status!==200)throw new Error(n.statusText);const r=await n.text(),a=`${p.toString(!0)}#vscode-extension`,d=`${r}
//# sourceURL=${a}`;let i;try{i=new Function("module","exports","require",d)}catch(S){throw console.error(c?`Loading code for extension ${c} failed: ${S.message}`:`Loading code failed: ${S.message}`),console.error(`${p.toString(!0)}${typeof S.line=="number"?` line ${S.line}`:""}${typeof S.column=="number"?` column ${S.column}`:""}`),console.error(S),S}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const v={},l={exports:v},o=S=>{const w=this._fakeModules.getModule(S,p);if(w===void 0)throw new Error(`Cannot load module '${S}'`);return w};try{return s.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),i(l,v,o),l.exports!==v?l.exports:v}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),s.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+E;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,m.timeout)(10)}}e.ExtHostExtensionService=R;function C(u,E){return u.endsWith(E)?u:u+E}}),define(Te[296],Ae([1,0,70,54,14,39,201,84,295]),function(fe,e,I,L,P,O,T,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.registerSingleton)(P.ILogService,new I.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,L.registerSingleton)(O.IExtHostExtensionService,f.ExtHostExtensionService,0),(0,L.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths,0)}),define(Te[301],Ae([1,0,24,5,77,291,238,19,87,12,2,294,296]),function(fe,e,I,L,P,O,T,m,f,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const C=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(i){return/^(file|vscode-remote):/i.test(i)}const p=fetch.bind(self);function s(i){self.fetch=async function(v,l){return v instanceof Request||E(String(v))&&(v=(await i(R.URI.parse(String(v)))).toString(!0)),p(v,l)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,l,o,S,w){(async()=>(E(l.toString())&&(l=(await i(R.URI.parse(l.toString()))).toString(!0)),super.open(v,l,o??!0,S,w)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(v,l){if(/^file:/i.test(v.toString()))v=y.FileAccess.uriToBrowserUri(R.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const S=`(${function(h){function _(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const b=fetch.bind(self);self.fetch=function(F,j){return F instanceof Request?b(F,j):b(_(F),j)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,j,H,B,k){return super.open(F,_(j),H??!0,B,k)}};const A=importScripts.bind(self);self.importScripts=(...F)=>{A(...F.map(_))},A(h)}.toString()}('${v}'))`;l=l||{},l.name=`${name} -> ${l.name||m.basename(v.toString())}`;const w=new Blob([S],{type:"application/javascript"}),g=URL.createObjectURL(w);return new i(g,l)}}else self.Worker=class extends T.NestedWorker{constructor(i,v){super(u,i,{name:m.basename(i.toString()),...v})}};const c=new class{constructor(){this.pid=void 0}exit(i){C()}};class t{constructor(){const v=new MessageChannel,l=new L.Emitter;let o=!1;u(v.port2,[v.port2]),v.port1.onmessage=S=>{const{data:w}=S;if(!(w instanceof ArrayBuffer)){console.warn("UNKNOWN data received",w);return}const g=I.VSBuffer.wrap(new Uint8Array(w,0,w.byteLength));if((0,P.isMessageOfType)(g,2)){o=!0,r("received terminate message from renderer");return}l.fire(g)},this.protocol={onMessage:l.event,send:S=>{if(!o){const w=S.buffer.buffer.slice(S.buffer.byteOffset,S.buffer.byteOffset+S.buffer.byteLength);v.port1.postMessage(w,[w])}}}}}function n(i){return new Promise(v=>{const l=i.onMessage(o=>{l.dispose();const S=JSON.parse(o.toString());i.send((0,P.createMessageOfType)(0)),v({protocol:i,initData:S})});i.send((0,P.createMessageOfType)(1))})}let r=i=>C();function a(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function d(){f.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(v){a(v)&&n(i.protocol).then(l=>{f.mark("code/extHost/didWaitForInitData");const o=new O.ExtensionHostMain(l.protocol,l.initData,c,null,v.data);s(S=>o.asBrowserUri(S)),r=S=>o.terminate(S)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/workbench/api/worker/extensionHostWorker.js.map
