/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(W){for(var e=[],P=0,y=W.length;P<y;P++)e[P]=q[W[P]];return e};define(q[23],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class P{static get(){const S=new Map,O=new Map,s=new Map,g=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function c(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let m=[];typeof W=="function"&&typeof W.getStats=="function"&&(m=W.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of m)switch(a.type){case 10:t(S,a);break;case 11:case 12:c(S,a);break;case 21:t(O,a);break;case 22:c(O,a);break;case 33:t(s,a);break;case 34:c(s,a);break;case 31:t(g,a);break;case 32:c(g,a);break}let f=0;s.forEach(a=>f+=a);function o(a){const i=[];return a.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:o(S),amdInvoke:o(O),nodeRequire:o(s),nodeEval:o(g),nodeRequireTotal:f}}static toMarkdownTable(S,O){let s="";const g=[];return S.forEach((t,c)=>{g[c]=t.length}),O.forEach(t=>{t.forEach((c,m)=>{typeof c>"u"&&(c=t[m]="-");const f=c.toString().length;g[m]=Math.max(f,g[m])})}),S.forEach((t,c)=>{s+=`| ${t+" ".repeat(g[c]-t.toString().length)} `}),s+=`|
`,S.forEach((t,c)=>{s+=`| ${"-".repeat(g[c])} `}),s+=`|
`,O.forEach(t=>{t.forEach((c,m)=>{typeof c<"u"&&(s+=`| ${c+" ".repeat(g[m]-c.toString().length)} `)}),s+=`|
`}),s}}e.LoaderStats=P}),define(q[4],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFunctionName=e.getDebugName=e.DebugNameData=void 0;class P{constructor(i,n,r){this.owner=i,this.debugNameSource=n,this.referenceFn=r}getDebugName(i){return O(i,this)}}e.DebugNameData=P;const y=new Map,S=new WeakMap;function O(a,i){const n=S.get(a);if(n)return n;const r=s(a,i);if(r){let h=y.get(r)??0;h++,y.set(r,h);const T=h===1?r:`${r}#${h}`;return S.set(a,T),T}}e.getDebugName=O;function s(a,i){const n=S.get(a);if(n)return n;const r=i.owner?m(i.owner)+".":"";let h;const T=i.debugNameSource;if(T!==void 0)if(typeof T=="function"){if(h=T(),h!==void 0)return r+h}else return r+T;const I=i.referenceFn;if(I!==void 0&&(h=o(I),h!==void 0))return r+h;if(i.owner!==void 0){const p=g(i.owner,a);if(p!==void 0)return r+p}}function g(a,i){for(const n in a)if(a[n]===i)return n}const t=new Map,c=new WeakMap;function m(a){const i=c.get(a);if(i)return i;const n=f(a);let r=t.get(n)??0;r++,t.set(n,r);const h=r===1?n:`${n}#${r}`;return c.set(a,h),h}function f(a){const i=a.constructor;return i?i.name:"Object"}function o(a){const i=a.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(i);return(r?r[1]:void 0)?.trim()}e.getFunctionName=o}),define(q[5],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let P;function y(n){P=n}e.setLogger=y;function S(){return P}e.getLogger=S;class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return s([g(a("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[g(" "),c(m(r.oldValue,70),{color:"red",strikeThrough:!0}),g(" "),c(m(r.newValue,60),{color:"green"})]:[g(" (unchanged)")]:[g(" "),c(m(r.newValue,60),{color:"green"}),g(" (initial)")]}handleObservableChanged(r,h){console.log(...this.textToConsoleArgs([t("observable value changed"),c(r.debugName,{color:"BlueViolet"}),...this.formatInfo(h)]))}formatChanges(r){if(r.size!==0)return c(" (changed deps: "+[...r].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const h=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(T,I)=>(this.changedObservablesSets.get(r).add(T),h.apply(r,[T,I]))}handleDerivedRecomputed(r,h){const T=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([t("derived recomputed"),c(r.debugName,{color:"BlueViolet"}),...this.formatInfo(h),this.formatChanges(T),{data:[{fn:r._computeFn}]}])),T.clear()}handleFromEventObservableTriggered(r,h){console.log(...this.textToConsoleArgs([t("observable from event triggered"),c(r.debugName,{color:"BlueViolet"}),...this.formatInfo(h),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const h=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(T,I)=>(this.changedObservablesSets.get(r).add(T),h.apply(r,[T,I]))}handleAutorunTriggered(r){const h=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([t("autorun"),c(r.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:r._runFn}]}])),h.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let h=r.getDebugName();h===void 0&&(h=""),console.log(...this.textToConsoleArgs([t("transaction"),c(h,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function s(n){const r=new Array,h=[];let T="";function I(w){if("length"in w)for(const u of w)u&&I(u);else"text"in w?(T+=`%c${w.text}`,r.push(w.style),w.data&&h.push(...w.data)):"data"in w&&h.push(...w.data)}I(n);const p=[T,...r];return p.push(...h),p}function g(n){return c(n,{color:"black"})}function t(n){return c(i(`${n}: `,10),{color:"black",bold:!0})}function c(n,r={color:"black"}){function h(I){return Object.entries(I).reduce((p,[w,u])=>`${p}${w}:${u};`,"")}const T={color:r.color};return r.strikeThrough&&(T["text-decoration"]="line-through"),r.bold&&(T["font-weight"]="bold"),{text:n,style:h(T)}}function m(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?f(n,r):o(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function f(n,r){let h="[ ",T=!0;for(const I of n){if(T||(h+=", "),h.length-5>r){h+="...";break}T=!1,h+=`${m(I,r-h.length)}`}return h+=" ]",h}function o(n,r){let h="{ ",T=!0;for(const[I,p]of Object.entries(n)){if(T||(h+=", "),h.length-5>r){h+="...";break}T=!1,h+=`${I}: ${m(p,r-h.length)}`}return h+=" }",h}function a(n,r){let h="";for(let T=1;T<=r;T++)h+=n;return h}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(q[7],V([0,1,24,2,4,5]),function(W,e,P,y,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutorunObserver=e.autorunDelta=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorunOpts=e.autorun=void 0;function s(i){return new a(new S.DebugNameData(void 0,void 0,i),i,void 0,void 0)}e.autorun=s;function g(i,n){return new a(new S.DebugNameData(i.owner,i.debugName,i.debugReferenceFn??n),n,void 0,void 0)}e.autorunOpts=g;function t(i,n){return new a(new S.DebugNameData(i.owner,i.debugName,i.debugReferenceFn??n),n,i.createEmptyChangeSummary,i.handleChange)}e.autorunHandleChanges=t;function c(i,n){const r=new y.DisposableStore,h=t({owner:i.owner,debugName:i.debugName,debugReferenceFn:i.debugReferenceFn,createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(T,I)=>{r.clear(),n(T,I,r)});return(0,y.toDisposable)(()=>{h.dispose(),r.dispose()})}e.autorunWithStoreHandleChanges=c;function m(i){const n=new y.DisposableStore,r=g({owner:void 0,debugName:void 0,debugReferenceFn:i},h=>{n.clear(),i(h,n)});return(0,y.toDisposable)(()=>{r.dispose(),n.dispose()})}e.autorunWithStore=m;function f(i,n){let r;return g({debugReferenceFn:n},h=>{const T=i.read(h),I=r;r=T,n({lastValue:I,newValue:T})})}e.autorunDelta=f;var o;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(o||(o={}));class a{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(n,r,h,T){this._debugNameData=n,this._runFn=r,this.createChangeSummary=h,this._handleChange=T,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,O.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,y.trackDisposable)(this)}dispose(){this.disposed=!0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),(0,y.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n,this.state=3;const r=this.disposed;try{if(!r){(0,O.getLogger)()?.handleAutorunTriggered(this);const h=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,h)}}finally{r||(0,O.getLogger)()?.handleAutorunFinished(this);for(const h of this.dependenciesToBeRemoved)h.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,P.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(n){this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(this.state=1)}handleChange(n,r){this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(!this._handleChange||this._handleChange({changedObservable:n,change:r,didChange:T=>T===n},this.changeSummary))&&(this.state=2)}readObservable(n){if(this.disposed)return n.get();n.addObserver(this);const r=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),r}}e.AutorunObserver=a,function(i){i.Observer=a}(s||(e.autorun=s={}))}),define(q[6],V([0,1,4,5]),function(W,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.TransactionImpl=e.subtransaction=e.asyncTransaction=e.globalTransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerivedOpts=e._setKeepObserved=e._setRecomputeInitiallyAndOnChange=void 0;let S;function O(u){S=u}e._setRecomputeInitiallyAndOnChange=O;let s;function g(u){s=u}e._setKeepObserved=g;let t;function c(u){t=u}e._setDerivedOpts=c;class m{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,_){const M=_===void 0?void 0:b,z=_===void 0?b:_;return t({owner:M,debugName:()=>{const d=(0,P.getFunctionName)(z);if(d!==void 0)return d;const A=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(z.toString());if(A)return`${this.debugName}.${A[2]}`;if(!M)return`${this.debugName} (mapped)`}},d=>z(this.read(d),d))}recomputeInitiallyAndOnChange(b,_){return b.add(S(this,_)),this}keepObserved(b){return b.add(s(this)),this}}e.ConvenientObservable=m;class f extends m{constructor(){super(...arguments),this.observers=new Set}addObserver(b){const _=this.observers.size;this.observers.add(b),_===0&&this.onFirstObserverAdded()}removeObserver(b){this.observers.delete(b)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=f;function o(u,b){const _=new h(u,b);try{u(_)}finally{_.finish()}}e.transaction=o;let a;function i(u){if(a)u(a);else{const b=new h(u,void 0);a=b;try{u(b)}finally{b.finish(),a=void 0}}}e.globalTransaction=i;async function n(u,b){const _=new h(u,b);try{await u(_)}finally{_.finish()}}e.asyncTransaction=n;function r(u,b,_){u?b(u):o(b,_)}e.subtransaction=r;class h{constructor(b,_){this._fn=b,this._getDebugName=_,this.updatingObservers=[],(0,y.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,P.getFunctionName)(this._fn)}updateObserver(b,_){this.updatingObservers.push({observer:b,observable:_}),b.beginUpdate(_)}finish(){const b=this.updatingObservers;for(let _=0;_<b.length;_++){const{observer:M,observable:z}=b[_];M.endUpdate(z)}this.updatingObservers=null,(0,y.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=h;function T(u,b){return typeof u=="string"?new I(void 0,u,b):new I(u,void 0,b)}e.observableValue=T;class I extends f{get debugName(){return new P.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"ObservableValue"}constructor(b,_,M){super(),this._owner=b,this._debugName=_,this._value=M}get(){return this._value}set(b,_,M){if(this._value===b)return;let z;_||(_=z=new h(()=>{},()=>`Setting ${this.debugName}`));try{const d=this._value;this._setValue(b),(0,y.getLogger)()?.handleObservableChanged(this,{oldValue:d,newValue:b,change:M,didChange:!0,hadValue:!0});for(const E of this.observers)_.updateObserver(E,this),E.handleChange(this,M)}finally{z&&z.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(b){this._value=b}}e.ObservableValue=I;function p(u,b){return typeof u=="string"?new w(void 0,u,b):new w(u,void 0,b)}e.disposableObservableValue=p;class w extends I{_setValue(b){this._value!==b&&(this._value&&this._value.dispose(),this._value=b)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=w}),define(q[8],V([0,1,24,2,6,4,5]),function(W,e,P,y,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedDisposable=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.defaultEqualityComparer=void 0;const g=(n,r)=>n===r;e.defaultEqualityComparer=g;function t(n,r){return r!==void 0?new i(new O.DebugNameData(n,void 0,r),r,void 0,void 0,void 0,e.defaultEqualityComparer):new i(new O.DebugNameData(void 0,void 0,n),n,void 0,void 0,void 0,e.defaultEqualityComparer)}e.derived=t;function c(n,r){return new i(new O.DebugNameData(n.owner,n.debugName,n.debugReferenceFn),r,void 0,void 0,n.onLastObserverRemoved,n.equalityComparer??e.defaultEqualityComparer)}e.derivedOpts=c,(0,S._setDerivedOpts)(c);function m(n,r){return new i(new O.DebugNameData(n.owner,n.debugName,void 0),r,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??e.defaultEqualityComparer)}e.derivedHandleChanges=m;function f(n,r){let h,T;r===void 0?(h=n,T=void 0):(T=n,h=r);const I=new y.DisposableStore;return new i(new O.DebugNameData(T,void 0,h),p=>(I.clear(),h(p,I)),void 0,void 0,()=>I.dispose(),e.defaultEqualityComparer)}e.derivedWithStore=f;function o(n,r){let h,T;r===void 0?(h=n,T=void 0):(T=n,h=r);const I=new y.DisposableStore;return new i(new O.DebugNameData(T,void 0,h),p=>{I.clear();const w=h(p);return w&&I.add(w),w},void 0,void 0,()=>I.dispose(),e.defaultEqualityComparer)}e.derivedDisposable=o;var a;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(a||(a={}));class i extends S.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(r,h,T,I,p=void 0,w){super(),this._debugNameData=r,this._computeFn=h,this.createChangeSummary=T,this._handleChange=I,this._handleLastObserverRemoved=p,this._equalityComparator=w,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,s.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const r of this.dependencies)r.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const r=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),r}else{do{if(this.state===1){for(const r of this.dependencies)if(r.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const r=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=r;const h=this.state!==0,T=this.value;this.state=3;const I=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,I)}finally{for(const w of this.dependenciesToBeRemoved)w.removeObserver(this);this.dependenciesToBeRemoved.clear()}const p=h&&!this._equalityComparator(T,this.value);if((0,s.getLogger)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.value,change:void 0,didChange:p,hadValue:h}),p)for(const w of this.observers)w.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.updateCount++;const h=this.updateCount===1;if(this.state===3&&(this.state=1,!h))for(const T of this.observers)T.handlePossibleChange(this);if(h)for(const T of this.observers)T.beginUpdate(this)}endUpdate(r){if(this.updateCount--,this.updateCount===0){const h=[...this.observers];for(const T of h)T.endUpdate(this)}(0,P.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(r){if(this.state===3&&this.dependencies.has(r)&&!this.dependenciesToBeRemoved.has(r)){this.state=1;for(const h of this.observers)h.handlePossibleChange(this)}}handleChange(r,h){if(this.dependencies.has(r)&&!this.dependenciesToBeRemoved.has(r)){const T=this._handleChange?this._handleChange({changedObservable:r,change:h,didChange:p=>p===r},this.changeSummary):!0,I=this.state===3;if(T&&(this.state===1||I)&&(this.state=2,I))for(const p of this.observers)p.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const h=r.get();return this.dependencies.add(r),this.dependenciesToBeRemoved.delete(r),h}addObserver(r){const h=!this.observers.has(r)&&this.updateCount>0;super.addObserver(r),h&&r.beginUpdate(this)}removeObserver(r){const h=this.observers.has(r)&&this.updateCount>0;super.removeObserver(r),h&&r.endUpdate(this)}}e.Derived=i}),define(q[25],V([0,1,2,7,6,4,8,5]),function(W,e,P,y,S,O,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapObservableArrayCached=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.KeepAliveObserver=e.recomputeInitiallyAndOnChange=e.keepObserved=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.observableFromPromise=e.constObservable=void 0;function t(z){return new c(z)}e.constObservable=t;class c extends S.ConvenientObservable{constructor(d){super(),this.value=d}get debugName(){return this.toString()}get(){return this.value}addObserver(d){}removeObserver(d){}toString(){return`Const: ${this.value}`}}function m(z){const d=(0,S.observableValue)("promiseValue",{});return z.then(E=>{d.set({value:E},void 0)}),d}e.observableFromPromise=m;function f(z,d){return new o(z,d)}e.observableFromEvent=f;class o extends S.BaseObservable{constructor(d,E){super(),this.event=d,this._getValue=E,this.hasValue=!1,this.handleEvent=A=>{const U=this._getValue(A),L=this.value,v=!this.hasValue||L!==U;let D=!1;v&&(this.value=U,this.hasValue&&(D=!0,(0,S.subtransaction)(o.globalTransaction,B=>{(0,g.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:L,newValue:U,change:void 0,didChange:v,hadValue:this.hasValue});for(const K of this.observers)B.updateObserver(K,this),K.handleChange(this,void 0)},()=>{const B=this.getDebugName();return"Event fired"+(B?`: ${B}`:"")})),this.hasValue=!0),D||(0,g.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:L,newValue:U,change:void 0,didChange:v,hadValue:this.hasValue})}}getDebugName(){return(0,O.getFunctionName)(this._getValue)}get debugName(){const d=this.getDebugName();return"From Event"+(d?`: ${d}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=o,function(z){z.Observer=o;function d(E,A){let U=!1;o.globalTransaction===void 0&&(o.globalTransaction=E,U=!0);try{A()}finally{U&&(o.globalTransaction=void 0)}}z.batchEventsGlobally=d}(f||(e.observableFromEvent=f={}));function a(z,d){return new i(z,d)}e.observableSignalFromEvent=a;class i extends S.BaseObservable{constructor(d,E){super(),this.debugName=d,this.event=E,this.handleEvent=()=>{(0,S.transaction)(A=>{for(const U of this.observers)A.updateObserver(U,this),U.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function n(z){return typeof z=="string"?new r(z):new r(void 0,z)}e.observableSignal=n;class r extends S.BaseObservable{get debugName(){return new O.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}constructor(d,E){super(),this._debugName=d,this._owner=E}trigger(d,E){if(!d){(0,S.transaction)(A=>{this.trigger(A,E)},()=>`Trigger signal ${this.debugName}`);return}for(const A of this.observers)d.updateObserver(A,this),A.handleChange(this,E)}get(){}}function h(z,d,E){const A=(0,S.observableValue)("debounced",void 0);let U;return E.add((0,y.autorun)(L=>{const v=z.read(L);U&&clearTimeout(U),U=setTimeout(()=>{(0,S.transaction)(D=>{A.set(v,D)})},d)})),A}e.debouncedObservable=h;function T(z,d,E){const A=(0,S.observableValue)("triggeredRecently",!1);let U;return E.add(z(()=>{A.set(!0,void 0),U&&clearTimeout(U),U=setTimeout(()=>{A.set(!1,void 0)},d)})),A}e.wasEventTriggeredRecently=T;function I(z){const d=new w(!1,void 0);return z.addObserver(d),(0,P.toDisposable)(()=>{z.removeObserver(d)})}e.keepObserved=I,(0,S._setKeepObserved)(I);function p(z,d){const E=new w(!0,d);return z.addObserver(E),d?d(z.get()):z.reportChanges(),(0,P.toDisposable)(()=>{z.removeObserver(E)})}e.recomputeInitiallyAndOnChange=p,(0,S._setRecomputeInitiallyAndOnChange)(p);class w{constructor(d,E){this._forceRecompute=d,this._handleValue=E,this._counter=0}beginUpdate(d){this._counter++}endUpdate(d){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(d.get()):d.reportChanges())}handlePossibleChange(d){}handleChange(d,E){}}e.KeepAliveObserver=w;function u(z){let d;return(0,s.derived)(A=>(d=z(A,d),d))}e.derivedObservableWithCache=u;function b(z,d){let E;const A=(0,S.observableValue)("derivedObservableWithWritableCache.counter",0),U=(0,s.derived)(z,L=>(A.read(L),E=d(L,E),E));return Object.assign(U,{clearCache:L=>{E=void 0,A.set(A.get()+1,L)}})}e.derivedObservableWithWritableCache=b;function _(z,d,E,A){let U=new M(E,A);return(0,s.derivedOpts)({debugReferenceFn:E,owner:z,onLastObserverRemoved:()=>{U.dispose(),U=new M(E)}},v=>(U.setItems(d.read(v)),U.getItems()))}e.mapObservableArrayCached=_;class M{constructor(d,E){this._map=d,this._keySelector=E,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(d=>d.store.dispose()),this._cache.clear()}setItems(d){const E=[],A=new Set(this._cache.keys());for(const U of d){const L=this._keySelector?this._keySelector(U):U;let v=this._cache.get(L);if(v)A.delete(L);else{const D=new P.DisposableStore;v={out:this._map(U,D),store:D},this._cache.set(L,v)}E.push(v.out)}for(const U of A)this._cache.get(U).store.dispose(),this._cache.delete(U);this._items=E}getItems(){return this._items}}}),define(q[26],V([0,1,7,6,8,27,4]),function(W,e,P,y,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.ObservableLazyPromise=e.PromiseResult=e.ObservablePromise=e.ObservableLazy=void 0;class g{get cachedValue(){return this._value}constructor(i){this._computeValue=i,this._value=(0,y.observableValue)(this,void 0)}getValue(){let i=this._value.get();return i||(i=this._computeValue(),this._value.set(i,void 0)),i}}e.ObservableLazy=g;class t{constructor(i){this._value=(0,y.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=i.then(n=>((0,y.transaction)(r=>{this._value.set(new c(n,void 0),r)}),n),n=>{throw(0,y.transaction)(r=>{this._value.set(new c(void 0,n),r)}),n})}}e.ObservablePromise=t;class c{constructor(i,n){this.data=i,this.error=n}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.PromiseResult=c;class m{constructor(i){this._computePromise=i,this._lazyValue=new g(()=>new t(this._computePromise())),this.cachedPromiseResult=(0,S.derived)(this,n=>this._lazyValue.cachedValue.read(n)?.promiseResult.read(n))}getPromise(){return this._lazyValue.getValue().promise}}e.ObservableLazyPromise=m;function f(a,i,n){return new Promise((r,h)=>{let T=!0,I=!1;const p=a.map(u=>({isFinished:i(u),error:n?n(u):!1,state:u})),w=(0,P.autorun)(u=>{const{isFinished:b,error:_,state:M}=p.read(u);(b||_)&&(T?I=!0:w.dispose(),_?h(_===!0?M:_):r(M))});T=!1,I&&w.dispose()})}e.waitForState=f;function o(a,i){let n,r;i===void 0?(n=a,r=void 0):(r=a,n=i);let h;return new S.Derived(new s.DebugNameData(r,void 0,n),T=>(h&&h.dispose(!0),h=new O.CancellationTokenSource,n(T,h.token)),void 0,void 0,()=>h?.dispose(),S.defaultEqualityComparer)}e.derivedWithCancellationToken=o}),define(q[12],V([0,1,6,8,7,25,26,5]),function(W,e,P,y,S,O,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return y.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return y.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return y.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return y.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return S.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return S.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return S.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return S.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return S.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return S.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.observableSignalFromEvent}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.wasEventTriggeredRecently}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return s.ObservableLazy}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return s.ObservableLazyPromise}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return s.ObservablePromise}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return s.PromiseResult}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return s.waitForState}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return s.derivedWithCancellationToken}}),!1&&(0,g.setLogger)(new g.ConsoleObservableLogger)}),define(q[28],V([0,1,9,2]),function(W,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=S;function O(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=O;function s(p){const w=p;return w?O(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=s;function g(p,w){return new t(p,w)}e.newWriteableStream=g;class t{constructor(w,u){this.reducer=w,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(u=>u(w))}emitError(w){this.listeners.error.length===0?(0,P.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(u=>u(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,u){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(w,u){if(this.state.destroyed)return;let b;switch(w){case"data":b=this.listeners.data;break;case"end":b=this.listeners.end;break;case"error":b=this.listeners.error;break}if(b){const _=b.indexOf(u);_>=0&&b.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(b=>b())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(p,w){const u=[];let b;for(;(b=p.read())!==null;)u.push(b);return w(u)}e.consumeReadable=c;function m(p,w,u){const b=[];let _;for(;(_=p.read())!==null&&b.length<u;)b.push(_);return _===null&&b.length>0?w(b):{read:()=>{if(b.length>0)return b.shift();if(typeof _<"u"){const M=_;return _=void 0,M}return p.read()}}}e.peekReadable=m;function f(p,w){return new Promise((u,b)=>{const _=[];o(p,{onData:M=>{w&&_.push(M)},onError:M=>{w?b(M):u(void 0)},onEnd:()=>{u(w?w(_):void 0)}})})}e.consumeStream=f;function o(p,w,u){p.on("error",b=>{u?.isCancellationRequested||w.onError(b)}),p.on("end",()=>{u?.isCancellationRequested||w.onEnd()}),p.on("data",b=>{u?.isCancellationRequested||w.onData(b)})}e.listenStream=o;function a(p,w){return new Promise((u,b)=>{const _=new y.DisposableStore,M=[],z=A=>{if(M.push(A),M.length>w)return _.dispose(),p.pause(),u({stream:p,buffer:M,ended:!1})},d=A=>(_.dispose(),b(A)),E=()=>(_.dispose(),u({stream:p,buffer:M,ended:!0}));_.add((0,y.toDisposable)(()=>p.removeListener("error",d))),p.on("error",d),_.add((0,y.toDisposable)(()=>p.removeListener("end",E))),p.on("end",E),_.add((0,y.toDisposable)(()=>p.removeListener("data",z))),p.on("data",z)})}e.peekStream=a;function i(p,w){const u=g(w);return u.end(p),u}e.toStream=i;function n(){const p=g(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=n;function r(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=r;function h(p,w,u){const b=g(u);return o(p,{onData:_=>b.write(w.data(_)),onError:_=>b.error(w.error?w.error(_):_),onEnd:()=>b.end()}),b}e.transform=h;function T(p,w,u){let b=!1;return{read:()=>{const _=w.read();return b?_:(b=!0,_!==null?u([p,_]):p)}}}e.prefixedReadable=T;function I(p,w,u){let b=!1;const _=g(u);return o(w,{onData:M=>b?_.write(M):(b=!0,_.write(u([p,M]))),onError:M=>_.error(M),onEnd:()=>{b||(b=!0,_.write(p)),_.end()}}),_}e.prefixedStream=I}),define(q[13],V([0,1,29,28]),function(W,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const S=typeof Buffer<"u",O=new P.Lazy(()=>new Uint8Array(256));let s,g;class t{static alloc(v){return S?new t(Buffer.allocUnsafe(v)):new t(new Uint8Array(v))}static wrap(v){return S&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new t(v)}static fromString(v,D){return!(D?.dontUseNodeBuffer||!1)&&S?new t(Buffer.from(v)):(s||(s=new TextEncoder),new t(s.encode(v)))}static fromByteArray(v){const D=t.alloc(v.length);for(let B=0,K=v.length;B<K;B++)D.buffer[B]=v[B];return D}static concat(v,D){if(typeof D>"u"){D=0;for(let G=0,H=v.length;G<H;G++)D+=v[G].byteLength}const B=t.alloc(D);let K=0;for(let G=0,H=v.length;G<H;G++){const j=v[G];B.set(j,K),K+=j.byteLength}return B}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=t.alloc(this.byteLength);return v.set(this),v}toString(){return S?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(v,D){return new t(this.buffer.subarray(v,D))}set(v,D){if(v instanceof t)this.buffer.set(v.buffer,D);else if(v instanceof Uint8Array)this.buffer.set(v,D);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),D);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return o(this.buffer,v)}writeUInt32BE(v,D){a(this.buffer,v,D)}readUInt32LE(v){return i(this.buffer,v)}writeUInt32LE(v,D){n(this.buffer,v,D)}readUInt8(v){return r(this.buffer,v)}writeUInt8(v,D){h(this.buffer,v,D)}indexOf(v,D=0){return c(this.buffer,v instanceof t?v.buffer:v,D)}}e.VSBuffer=t;function c(L,v,D=0){const B=v.byteLength,K=L.byteLength;if(B===0)return 0;if(B===1)return L.indexOf(v[0]);if(B>K-D)return-1;const G=O.value;G.fill(v.length);for(let J=0;J<v.length;J++)G[v[J]]=v.length-J-1;let H=D+v.length-1,j=H,$=-1;for(;H<K;)if(L[H]===v[j]){if(j===0){$=H;break}H--,j--}else H+=Math.max(v.length-j,G[L[H]]),j=v.length-1;return $}e.binaryIndexOf=c;function m(L,v){return L[v+0]<<0>>>0|L[v+1]<<8>>>0}e.readUInt16LE=m;function f(L,v,D){L[D+0]=v&255,v=v>>>8,L[D+1]=v&255}e.writeUInt16LE=f;function o(L,v){return L[v]*2**24+L[v+1]*2**16+L[v+2]*2**8+L[v+3]}e.readUInt32BE=o;function a(L,v,D){L[D+3]=v,v=v>>>8,L[D+2]=v,v=v>>>8,L[D+1]=v,v=v>>>8,L[D]=v}e.writeUInt32BE=a;function i(L,v){return L[v+0]<<0>>>0|L[v+1]<<8>>>0|L[v+2]<<16>>>0|L[v+3]<<24>>>0}e.readUInt32LE=i;function n(L,v,D){L[D+0]=v&255,v=v>>>8,L[D+1]=v&255,v=v>>>8,L[D+2]=v&255,v=v>>>8,L[D+3]=v&255}e.writeUInt32LE=n;function r(L,v){return L[v]}e.readUInt8=r;function h(L,v,D){L[D]=v}e.writeUInt8=h;function T(L){return y.consumeReadable(L,v=>t.concat(v))}e.readableToBuffer=T;function I(L){return y.toReadable(L)}e.bufferToReadable=I;function p(L){return y.consumeStream(L,v=>t.concat(v))}e.streamToBuffer=p;async function w(L){return L.ended?t.concat(L.buffer):t.concat([...L.buffer,await p(L.stream)])}e.bufferedStreamToBuffer=w;function u(L){return y.toStream(L,v=>t.concat(v))}e.bufferToStream=u;function b(L){return y.transform(L,{data:v=>typeof v=="string"?t.fromString(v):t.wrap(v)},v=>t.concat(v))}e.streamToBufferReadableStream=b;function _(L){return y.newWriteableStream(v=>t.concat(v),L)}e.newWriteableBufferStream=_;function M(L,v){return y.prefixedReadable(L,v,D=>t.concat(D))}e.prefixedBufferReadable=M;function z(L,v){return y.prefixedStream(L,v,D=>t.concat(D))}e.prefixedBufferStream=z;function d(L){let v=0,D=0,B=0;const K=new Uint8Array(Math.floor(L.length/4*3)),G=j=>{switch(D){case 3:K[B++]=v|j,D=0;break;case 2:K[B++]=v|j>>>2,v=j<<6,D=3;break;case 1:K[B++]=v|j>>>4,v=j<<4,D=2;break;default:v=j<<2,D=1}};for(let j=0;j<L.length;j++){const $=L.charCodeAt(j);if($>=65&&$<=90)G($-65);else if($>=97&&$<=122)G($-97+26);else if($>=48&&$<=57)G($-48+52);else if($===43||$===45)G(62);else if($===47||$===95)G(63);else{if($===61)break;throw new SyntaxError(`Unexpected base64 character ${L[j]}`)}}const H=B;for(;D>0;)G(0);return t.wrap(K).slice(0,H)}e.decodeBase64=d;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:L},v=!0,D=!1){const B=D?A:E;let K="";const G=L.byteLength%3;let H=0;for(;H<L.byteLength-G;H+=3){const j=L[H+0],$=L[H+1],J=L[H+2];K+=B[j>>>2],K+=B[(j<<4|$>>>4)&63],K+=B[($<<2|J>>>6)&63],K+=B[J&63]}if(G===1){const j=L[H+0];K+=B[j>>>2],K+=B[j<<4&63],v&&(K+="==")}else if(G===2){const j=L[H+0],$=L[H+1];K+=B[j>>>2],K+=B[(j<<4|$>>>4)&63],K+=B[$<<2&63],v&&(K+="=")}return K}e.encodeBase64=U}),define(q[30],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(q[14],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var P;(function(S){S[S.Unknown=0]="Unknown",S[S.Invalid=3]="Invalid",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function y(S){let O=0,s=0,g=0,t=0;for(let c=0,m=S.length;c<m;c++){const f=S.charCodeAt(c);f===13?(O===0&&(s=c),O++,c+1<m&&S.charCodeAt(c+1)===10?(t|=2,c++):t|=3,g=c+1):f===10&&(t|=1,O===0&&(s=c),O++,g=c+1)}return O===0&&(s=S.length),[O,s,S.length-g,t]}e.countEOL=y}),define(q[15],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var y;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(y||(e.FontStyle=y={}));var S;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(S||(e.ColorId=S={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class g{static getLanguageId(c){return(c&255)>>>0}static getTokenType(c){return(c&768)>>>8}static containsBalancedBrackets(c){return(c&1024)!==0}static getFontStyle(c){return(c&30720)>>>11}static getForeground(c){return(c&16744448)>>>15}static getBackground(c){return(c&4278190080)>>>24}static getClassNameFromMetadata(c){let f="mtk"+this.getForeground(c);const o=this.getFontStyle(c);return o&1&&(f+=" mtki"),o&2&&(f+=" mtkb"),o&4&&(f+=" mtku"),o&8&&(f+=" mtks"),f}static getInlineStyleFromMetadata(c,m){const f=this.getForeground(c),o=this.getFontStyle(c);let a=`color: ${m[f]};`;o&1&&(a+="font-style: italic;"),o&2&&(a+="font-weight: bold;");let i="";return o&4&&(i+=" underline"),o&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(c){const m=this.getForeground(c),f=this.getFontStyle(c);return{foreground:m,italic:!!(f&1),bold:!!(f&2),underline:!!(f&4),strikethrough:!!(f&8)}}}e.TokenMetadata=g}),define(q[31],V([0,1,32]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class y{constructor(s){this._default=s,this._store=[]}get(s){return s<this._store.length?this._store[s]:this._default}set(s,g){for(;s>=this._store.length;)this._store[this._store.length]=this._default;this._store[s]=g}replace(s,g,t){if(s>=this._store.length)return;if(g===0){this.insert(s,t);return}else if(t===0){this.delete(s,g);return}const c=this._store.slice(0,s),m=this._store.slice(s+g),f=S(t,this._default);this._store=c.concat(f,m)}delete(s,g){g===0||s>=this._store.length||this._store.splice(s,g)}insert(s,g){if(g===0||s>=this._store.length)return;const t=[];for(let c=0;c<g;c++)t[c]=this._default;this._store=(0,P.arrayInsert)(this._store,s,t)}}e.FixedArray=y;function S(O,s){const g=[];for(let t=0;t<O;t++)g[t]=s;return g}}),define(q[10],V([0,1,15]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class y{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(s,g){const t=y.defaultTokenMetadata,c=new Uint32Array(2);return c[0]=s.length,c[1]=t,new y(c,s,g)}constructor(s,g,t){this._lineTokensBrand=void 0,this._tokens=s,this._tokensCount=this._tokens.length>>>1,this._text=g,this._languageIdCodec=t}equals(s){return s instanceof y?this.slicedEquals(s,0,this._tokensCount):!1}slicedEquals(s,g,t){if(this._text!==s._text||this._tokensCount!==s._tokensCount)return!1;const c=g<<1,m=c+(t<<1);for(let f=c;f<m;f++)if(this._tokens[f]!==s._tokens[f])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(s){return s>0?this._tokens[s-1<<1]:0}getMetadata(s){return this._tokens[(s<<1)+1]}getLanguageId(s){const g=this._tokens[(s<<1)+1],t=P.TokenMetadata.getLanguageId(g);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(s){const g=this._tokens[(s<<1)+1];return P.TokenMetadata.getTokenType(g)}getForeground(s){const g=this._tokens[(s<<1)+1];return P.TokenMetadata.getForeground(g)}getClassName(s){const g=this._tokens[(s<<1)+1];return P.TokenMetadata.getClassNameFromMetadata(g)}getInlineStyle(s,g){const t=this._tokens[(s<<1)+1];return P.TokenMetadata.getInlineStyleFromMetadata(t,g)}getPresentation(s){const g=this._tokens[(s<<1)+1];return P.TokenMetadata.getPresentationFromMetadata(g)}getEndOffset(s){return this._tokens[s<<1]}findTokenIndexAtOffset(s){return y.findIndexInTokensArray(this._tokens,s)}inflate(){return this}sliceAndInflate(s,g,t){return new S(this,s,g,t)}static convertToEndOffset(s,g){const c=(s.length>>>1)-1;for(let m=0;m<c;m++)s[m<<1]=s[m+1<<1];s[c<<1]=g}static findIndexInTokensArray(s,g){if(s.length<=2)return 0;let t=0,c=(s.length>>>1)-1;for(;t<c;){const m=t+Math.floor((c-t)/2),f=s[m<<1];if(f===g)return m+1;f<g?t=m+1:f>g&&(c=m)}return t}withInserted(s){if(s.length===0)return this;let g=0,t=0,c="";const m=new Array;let f=0;for(;;){const o=g<this._tokensCount?this._tokens[g<<1]:-1,a=t<s.length?s[t]:null;if(o!==-1&&(a===null||o<=a.offset)){c+=this._text.substring(f,o);const i=this._tokens[(g<<1)+1];m.push(c.length,i),g++,f=o}else if(a){if(a.offset>f){c+=this._text.substring(f,a.offset);const i=this._tokens[(g<<1)+1];m.push(c.length,i),f=a.offset}c+=a.text,m.push(c.length,a.tokenMetadata),t++}else break}return new y(new Uint32Array(m),c,this._languageIdCodec)}}e.LineTokens=y;class S{constructor(s,g,t,c){this._source=s,this._startOffset=g,this._endOffset=t,this._deltaOffset=c,this._firstTokenIndex=s.findTokenIndexAtOffset(g),this._tokensCount=0;for(let m=this._firstTokenIndex,f=s.getCount();m<f&&!(s.getStartOffset(m)>=t);m++)this._tokensCount++}getMetadata(s){return this._source.getMetadata(this._firstTokenIndex+s)}getLanguageId(s){return this._source.getLanguageId(this._firstTokenIndex+s)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(s){return s instanceof S?this._startOffset===s._startOffset&&this._endOffset===s._endOffset&&this._deltaOffset===s._deltaOffset&&this._source.slicedEquals(s._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(s){return this._source.getForeground(this._firstTokenIndex+s)}getEndOffset(s){const g=this._source.getEndOffset(this._firstTokenIndex+s);return Math.min(this._endOffset,g)-this._startOffset+this._deltaOffset}getClassName(s){return this._source.getClassName(this._firstTokenIndex+s)}getInlineStyle(s,g){return this._source.getInlineStyle(this._firstTokenIndex+s,g)}getPresentation(s){return this._source.getPresentation(this._firstTokenIndex+s)}findTokenIndexAtOffset(s){return this._source.findTokenIndexAtOffset(s+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(q[33],V([0,1,10]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class y{static deleteBeginning(s,g){return s===null||s===e.EMPTY_LINE_TOKENS?s:y.delete(s,0,g)}static deleteEnding(s,g){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const t=S(s),c=t[t.length-2];return y.delete(s,g,c)}static delete(s,g,t){if(s===null||s===e.EMPTY_LINE_TOKENS||g===t)return s;const c=S(s),m=c.length>>>1;if(g===0&&c[c.length-2]===t)return e.EMPTY_LINE_TOKENS;const f=P.LineTokens.findIndexInTokensArray(c,g),o=f>0?c[f-1<<1]:0,a=c[f<<1];if(t<a){const T=t-g;for(let I=f;I<m;I++)c[I<<1]-=T;return s}let i,n;o!==g?(c[f<<1]=g,i=f+1<<1,n=g):(i=f<<1,n=o);const r=t-g;for(let T=f+1;T<m;T++){const I=c[T<<1]-r;I>n&&(c[i++]=I,c[i++]=c[(T<<1)+1],n=I)}if(i===c.length)return s;const h=new Uint32Array(i);return h.set(c.subarray(0,i),0),h.buffer}static append(s,g){if(g===e.EMPTY_LINE_TOKENS)return s;if(s===e.EMPTY_LINE_TOKENS)return g;if(s===null)return s;if(g===null)return null;const t=S(s),c=S(g),m=c.length>>>1,f=new Uint32Array(t.length+c.length);f.set(t,0);let o=t.length;const a=t[t.length-2];for(let i=0;i<m;i++)f[o++]=c[i<<1]+a,f[o++]=c[(i<<1)+1];return f.buffer}static insert(s,g,t){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const c=S(s),m=c.length>>>1;let f=P.LineTokens.findIndexInTokensArray(c,g);f>0&&c[f-1<<1]===g&&f--;for(let o=f;o<m;o++)c[o<<1]+=t;return s}}e.ContiguousTokensEditing=y;function S(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.toUint32Array=S}),define(q[34],V([0,1,32,13,47,14,33,16]),function(W,e,P,y,S,O,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(m,f,o){const a=new Uint32Array(m.buffer),i=(0,y.readUInt32BE)(m,f);f+=4;const n=(0,y.readUInt32BE)(m,f);f+=4;const r=[];for(let h=0;h<n;h++){const T=(0,y.readUInt32BE)(m,f);f+=4,r.push(a.subarray(f/4,f/4+T/4)),f+=T}return o.push(new t(i,r)),f}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(m,f){this._startLineNumber=m,this._tokens=f}getLineRange(){return new g.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(m){return this._tokens[m-this._startLineNumber]}appendLineTokens(m){this._tokens.push(m)}serializeSize(){let m=0;m+=4,m+=4;for(let f=0;f<this._tokens.length;f++){const o=this._tokens[f];if(!(o instanceof Uint32Array))throw new Error("Not supported!");m+=4,m+=o.byteLength}return m}serialize(m,f){(0,y.writeUInt32BE)(m,this._startLineNumber,f),f+=4,(0,y.writeUInt32BE)(m,this._tokens.length,f),f+=4;for(let o=0;o<this._tokens.length;o++){const a=this._tokens[o];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,y.writeUInt32BE)(m,a.byteLength,f),f+=4,m.set(new Uint8Array(a.buffer),f),f+=a.byteLength}return f}applyEdit(m,f){const[o,a]=(0,O.countEOL)(f);this._acceptDeleteRange(m),this._acceptInsertText(new S.Position(m.startLineNumber,m.startColumn),o,a)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber&&m.startColumn===m.endColumn)return;const f=m.startLineNumber-this._startLineNumber,o=m.endLineNumber-this._startLineNumber;if(o<0){const a=o-f;this._startLineNumber-=a;return}if(!(f>=this._tokens.length)){if(f<0&&o>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(f===o){this._tokens[f]=s.ContiguousTokensEditing.delete(this._tokens[f],m.startColumn-1,m.endColumn-1);return}if(f>=0)if(this._tokens[f]=s.ContiguousTokensEditing.deleteEnding(this._tokens[f],m.startColumn-1),o<this._tokens.length){const a=s.ContiguousTokensEditing.deleteBeginning(this._tokens[o],m.endColumn-1);this._tokens[f]=s.ContiguousTokensEditing.append(this._tokens[f],a),this._tokens.splice(f+1,o-f)}else this._tokens[f]=s.ContiguousTokensEditing.append(this._tokens[f],null),this._tokens=this._tokens.slice(0,f+1);else{const a=-f;this._startLineNumber-=a,this._tokens[o]=s.ContiguousTokensEditing.deleteBeginning(this._tokens[o],m.endColumn-1),this._tokens=this._tokens.slice(o)}}}_acceptInsertText(m,f,o){if(f===0&&o===0)return;const a=m.lineNumber-this._startLineNumber;if(a<0){this._startLineNumber+=f;return}if(!(a>=this._tokens.length)){if(f===0){this._tokens[a]=s.ContiguousTokensEditing.insert(this._tokens[a],m.column-1,o);return}this._tokens[a]=s.ContiguousTokensEditing.deleteEnding(this._tokens[a],m.column-1),this._tokens[a]=s.ContiguousTokensEditing.insert(this._tokens[a],m.column-1,o),this._insertLines(m.lineNumber,f)}}_insertLines(m,f){if(f===0)return;const o=[];for(let a=0;a<f;a++)o[a]=null;this._tokens=P.arrayInsert(this._tokens,m,o)}}e.ContiguousMultilineTokens=t}),define(q[17],V([0,1,13,34]),function(W,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class S{static deserialize(s){let g=0;const t=(0,P.readUInt32BE)(s,g);g+=4;const c=[];for(let m=0;m<t;m++)g=y.ContiguousMultilineTokens.deserialize(s,g,c);return c}constructor(){this._tokens=[]}add(s,g){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(g);return}}this._tokens.push(new y.ContiguousMultilineTokens(s,[g]))}finalize(){return this._tokens}serialize(){const s=this._serializeSize(),g=new Uint8Array(s);return this._serialize(g),g}_serializeSize(){let s=0;s+=4;for(let g=0;g<this._tokens.length;g++)s+=this._tokens[g].serializeSize();return s}_serialize(s){let g=0;(0,P.writeUInt32BE)(s,this._tokens.length,g),g+=4;for(let t=0;t<this._tokens.length;t++)g=this._tokens[t].serialize(s,g)}}e.ContiguousMultilineTokensBuilder=S}),define(q[35],V([0,1,36,3,18,48]),function(W,e,P,y,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function s(d){return d===47||d===92}e.isPathSeparator=s;function g(d){return d.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=g;function t(d){return d.indexOf("/")===-1&&(d=g(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=t;function c(d,E=P.posix.sep){if(!d)return"";const A=d.length,U=d.charCodeAt(0);if(s(U)){if(s(d.charCodeAt(1))&&!s(d.charCodeAt(2))){let v=3;const D=v;for(;v<A&&!s(d.charCodeAt(v));v++);if(D!==v&&!s(d.charCodeAt(v+1))){for(v+=1;v<A;v++)if(s(d.charCodeAt(v)))return d.slice(0,v+1).replace(/[\\/]/g,E)}}return E}else if(h(U)&&d.charCodeAt(1)===58)return s(d.charCodeAt(2))?d.slice(0,2)+E:d.slice(0,2);let L=d.indexOf("://");if(L!==-1){for(L+=3;L<A;L++)if(s(d.charCodeAt(L)))return d.slice(0,L+1)}return""}e.getRoot=c;function m(d){if(!y.isWindows||!d||d.length<5)return!1;let E=d.charCodeAt(0);if(E!==92||(E=d.charCodeAt(1),E!==92))return!1;let A=2;const U=A;for(;A<d.length&&(E=d.charCodeAt(A),E!==92);A++);return!(U===A||(E=d.charCodeAt(A+1),isNaN(E)||E===92))}e.isUNC=m;const f=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(d,E=y.isWindows){const A=E?f:o;return!(!d||d.length===0||/^\s+$/.test(d)||(A.lastIndex=0,A.test(d))||E&&a.test(d)||d==="."||d===".."||E&&d[d.length-1]==="."||E&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=i;function n(d,E,A){const U=d===E;return!A||U?U:!d||!E?!1:(0,S.equalsIgnoreCase)(d,E)}e.isEqual=n;function r(d,E,A,U=P.sep){if(d===E)return!0;if(!d||!E||E.length>d.length)return!1;if(A){if(!(0,S.startsWithIgnoreCase)(d,E))return!1;if(E.length===d.length)return!0;let v=E.length;return E.charAt(E.length-1)===U&&v--,d.charAt(v)===U}return E.charAt(E.length-1)!==U&&(E+=U),d.indexOf(E)===0}e.isEqualOrParent=r;function h(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=h;function T(d,E){return y.isWindows&&d.endsWith(":")&&(d+=P.sep),(0,P.isAbsolute)(d)||(d=(0,P.join)(E,d)),d=(0,P.normalize)(d),y.isWindows?(d=(0,S.rtrim)(d,P.sep),d.endsWith(":")&&(d+=P.sep)):(d=(0,S.rtrim)(d,P.sep),d||(d=P.sep)),d}e.sanitizeFilePath=T;function I(d){const E=(0,P.normalize)(d);return y.isWindows?d.length>3?!1:p(E)&&(d.length===2||E.charCodeAt(2)===92):E===P.posix.sep}e.isRootOrDriveLetter=I;function p(d,E=y.isWindows){return E?h(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(d,E=y.isWindows){return p(d,E)?d[0]:void 0}e.getDriveLetter=w;function u(d,E,A){return E.length>d.length?-1:d===E?0:(A&&(d=d.toLowerCase(),E=E.toLowerCase()),d.indexOf(E))}e.indexOfPath=u;function b(d){const E=d.split(":");let A,U,L;for(const v of E){const D=Number(v);(0,O.isNumber)(D)?U===void 0?U=D:L===void 0&&(L=D):A=A?[A,v].join(":"):v}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:U!==void 0?U:void 0,column:L!==void 0?L:U!==void 0?1:void 0}}e.parseLineAndColumnAware=b;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(d,E,A=8){let U="";for(let v=0;v<A;v++){let D;v===0&&y.isWindows&&!E&&(A===3||A===4)?D=M:D=_,U+=D.charAt(Math.floor(Math.random()*D.length))}let L;return E?L=`${E}-${U}`:L=U,d?(0,P.join)(d,L):L}e.randomPath=z}),define(q[19],V([0,1,9,3,18,11]),function(W,e,P,y,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var s;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm",o.codeSetting="code-setting",o.codeFeature="code-feature"})(s||(e.Schemas=s={}));function g(o,a){return O.URI.isUri(o)?(0,S.equalsIgnoreCase)(o.scheme,a):(0,S.startsWithIgnoreCase)(o,a+":")}e.matchesScheme=g;function t(o,...a){return a.some(i=>g(o,i))}e.matchesSomeScheme=t,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class c{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a){this._remoteResourcesPath=`${a}/${s.vscodeRemoteResource}`}set(a,i,n){this._hosts[a]=i,this._ports[a]=n}setConnectionToken(a,i){this._connectionTokens[a]=i}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(I){return P.onUnexpectedError(I),a}const i=a.authority;let n=this._hosts[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this._ports[i],h=this._connectionTokens[i];let T=`path=${encodeURIComponent(a.path)}`;return typeof h=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),O.URI.from({scheme:y.isWeb?this._preferredWebSchema:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new c,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class m{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(a){const i=this.toUri(a,W);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===s.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===s.file&&(y.isNative||y.webWorkerOrigin===`${s.vscodeFileResource}://${m.FALLBACK_AUTHORITY}`)?a.with({scheme:s.vscodeFileResource,authority:a.authority||m.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const i=this.toUri(a,W);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===s.vscodeFileResource?a.with({scheme:s.file,authority:a.authority!==m.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,i){return O.URI.isUri(a)?a:O.URI.parse(i.toUrl(a))}}e.FileAccess=new m;var f;(function(o){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(h){let T;typeof h=="string"?T=new URL(h).searchParams:h instanceof URL?T=h.searchParams:O.URI.isUri(h)&&(T=new URL(h.toString(!0)).searchParams);const I=T?.get(i);if(I)return a.get(I)}o.getHeadersFromQuery=n;function r(h,T,I){if(!globalThis.crossOriginIsolated)return;const p=T&&I?"3":I?"2":"1";h instanceof URLSearchParams?h.set(i,p):h[i]=p}o.addSearchParam=r})(f||(e.COI=f={}))}),define(q[37],V([0,1,23,19,3,11]),function(W,e,P,y,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class s{constructor(o,a,i){this.id=o,this.dependencies=a,this.callback=i}}class g{static{this.INSTANCE=new g}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(o,a,i)=>{typeof o!="string"&&(i=a,a=o,o=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this._defineCalls.push(new s(o,a,i))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){if(o.startsWith(window.location.origin)||o.startsWith("vscode-file://vscode-app"))return o;throw new Error(`[trusted_script_src] Invalid script url: ${o}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){return o}})))}async load(o){this._initialize();const a=await(this._isWebWorker?this._workerLoadScript(o):this._isRenderer?this._rendererLoadScript(o):this._nodeJSLoadScript(o));if(!a)throw new Error(`Did not receive a define call from script ${o}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${o}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}_rendererLoadScript(o){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",h),n.removeEventListener("error",T)},h=I=>{r(),a(this._defineCalls.pop())},T=I=>{r(),i(I)};n.addEventListener("load",h),n.addEventListener("error",T),this._amdPolicy&&(o=this._amdPolicy.createScriptURL(o)),n.setAttribute("src",o),window.document.getElementsByTagName("head")[0].appendChild(n)})}_workerLoadScript(o){return new Promise((a,i)=>{try{this._amdPolicy&&(o=this._amdPolicy.createScriptURL(o)),importScripts(o),a(this._defineCalls.pop())}catch(n){i(n)}})}async _nodeJSLoadScript(o){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=O.URI.parse(o).fsPath,h=a.readFileSync(r).toString(),T=n.wrap(h.replace(/^#!.*/,""));return new i.Script(T).runInThisContext().apply(),this._defineCalls.pop()}catch(a){throw a}}}const t=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function m(f,o,a){if(P.isESM){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[f]&&(f=c[f]);const i=`${f}/${o}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const I=`${a&&!S.isWeb?y.nodeModulesAsarPath:y.nodeModulesPath}/${i}`;n=y.FileAccess.asBrowserUri(I).toString(!0)}const r=g.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{W([f],i,n)})}e.importAMDNodeModule=m}),define(q[20],V([0,1,35,19,36,3,18,11]),function(W,e,P,y,S,O,s,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(a){return(0,g.uriToFsPath)(a,!0)}e.originalFSPath=t;class c{constructor(i){this._ignorePathCasing=i}compare(i,n,r=!1){return i===n?0:(0,s.compare)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===y.Schemas.file)return P.isEqualOrParent(t(i),t(n),this._ignorePathCasing(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.isEqualAuthority)(i.authority,n.authority))return P.isEqualOrParent(i.path,n.path,this._ignorePathCasing(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return g.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return S.posix.basename(i.path)}extname(i){return S.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===y.Schemas.file?n=g.URI.file(S.dirname(t(i))).path:(n=S.posix.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===y.Schemas.file?n=g.URI.file(S.normalize(t(i))).path:n=S.posix.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.isEqualAuthority)(i.authority,n.authority))return;if(i.scheme===y.Schemas.file){const T=S.relative(t(i),t(n));return O.isWindows?P.toSlashes(T):T}let r=i.path||"/";const h=n.path||"/";if(this._ignorePathCasing(i)){let T=0;for(const I=Math.min(r.length,h.length);T<I&&!(r.charCodeAt(T)!==h.charCodeAt(T)&&r.charAt(T).toLowerCase()!==h.charAt(T).toLowerCase());T++);r=h.substr(0,T)+r.substr(T)}return S.posix.relative(r,h)}resolvePath(i,n){if(i.scheme===y.Schemas.file){const r=g.URI.file(S.resolve(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=P.toPosixPath(n),i.with({path:S.posix.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.equalsIgnoreCase)(i,n)}hasTrailingPathSeparator(i,n=S.sep){if(i.scheme===y.Schemas.file){const r=t(i);return r.length>P.getRoot(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=S.sep){return(0,e.hasTrailingPathSeparator)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=S.sep){let r=!1;if(i.scheme===y.Schemas.file){const h=t(i);r=h!==void 0&&h.length===P.getRoot(h).length&&h[h.length-1]===n}else{n="/";const h=i.path;r=h.length===1&&h.charCodeAt(h.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(i,n)?i.with({path:i.path+"/"}):i}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(a=>a.scheme===y.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new c(a=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function m(a,i){const n=[];for(let r=0;r<a.length;r++){const h=i(a[r]);a.some((T,I)=>I===r?!1:(0,e.isEqualOrParent)(h,i(T)))||n.push(a[r])}return n}e.distinctParents=m;var f;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(I=>{const[p,w]=I.split(":");p&&w&&r.set(p,w)});const T=n.path.substring(0,n.path.indexOf(";"));return T&&r.set(a.META_DATA_MIME,T),r}a.parseMetaData=i})(f||(e.DataUri=f={}));function o(a,i,n){if(i){let r=a.path;return r&&r[0]!==S.posix.sep&&(r=S.posix.sep+r),a.with({scheme:n,authority:i,path:r})}return a.with({scheme:n})}e.toLocalResource=o}),define(q[21],V([0,1,27,9,38,2,20,3,30,29]),function(W,e,P,y,S,O,s,g,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.promiseWithResolvers=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(R){return!!R&&typeof R.then=="function"}e.isThenable=m;function f(R){const l=new P.CancellationTokenSource,k=R(l.token),C=new Promise((N,F)=>{const Y=l.token.onCancellationRequested(()=>{Y.dispose(),F(new y.CancellationError)});Promise.resolve(k).then(Z=>{Y.dispose(),l.dispose(),N(Z)},Z=>{Y.dispose(),l.dispose(),F(Z)})});return new class{cancel(){l.cancel(),l.dispose()}then(N,F){return C.then(N,F)}catch(N){return this.then(void 0,N)}finally(N){return C.finally(N)}}}e.createCancelablePromise=f;function o(R,l,k){return new Promise((C,N)=>{const F=l.onCancellationRequested(()=>{F.dispose(),C(k)});R.then(C,N).finally(()=>F.dispose())})}e.raceCancellation=o;function a(R,l){return new Promise((k,C)=>{const N=l.onCancellationRequested(()=>{N.dispose(),C(new y.CancellationError)});R.then(k,C).finally(()=>N.dispose())})}e.raceCancellationError=a;async function i(R){let l=-1;const k=R.map((C,N)=>C.then(F=>(l=N,F)));try{return await Promise.race(k)}finally{R.forEach((C,N)=>{N!==l&&C.cancel()})}}e.raceCancellablePromises=i;function n(R,l,k){let C;const N=setTimeout(()=>{C?.(void 0),k?.()},l);return Promise.race([R.finally(()=>clearTimeout(N)),new Promise(F=>C=F)])}e.raceTimeout=n;function r(R){return new Promise((l,k)=>{const C=R();m(C)?C.then(l,k):l(C)})}e.asPromise=r;function h(){let R,l;return{promise:new Promise((C,N)=>{R=C,l=N}),resolve:R,reject:l}}e.promiseWithResolvers=h;class T{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const k=()=>{if(this.queuedPromise=null,this.isDisposed)return;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(k,k).then(C)})}return new Promise((k,C)=>{this.queuedPromise.then(k,C)})}return this.activePromise=l(),new Promise((k,C)=>{this.activePromise.then(N=>{this.activePromise=null,k(N)},N=>{this.activePromise=null,C(N)})})}dispose(){this.isDisposed=!0}}e.Throttler=T;class I{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}e.Sequencer=I;class p{constructor(){this.promiseMap=new Map}queue(l,k){const N=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.promiseMap.get(l)===N&&this.promiseMap.delete(l)});return this.promiseMap.set(l,N),N}}e.SequencerByKey=p;const w=(R,l)=>{let k=!0;const C=setTimeout(()=>{k=!1,l()},R);return{isTriggered:()=>k,dispose:()=>{clearTimeout(C),k=!1}}},u=R=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,R())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class b{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,k=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,F)=>{this.doResolve=N,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}}));const C=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=k===t.MicrotaskDelay?u(C):w(k,C),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=b;class _{constructor(l){this.delayer=new b(l),this.throttler=new T}trigger(l,k){return this.delayer.trigger(()=>this.throttler.queue(l),k)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=_;class M{constructor(){this._isOpen=!1,this._promise=new Promise((l,k)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=M;class z extends M{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=z;function d(R,l){return l?new Promise((k,C)=>{const N=setTimeout(()=>{F.dispose(),k()},R),F=l.onCancellationRequested(()=>{clearTimeout(N),F.dispose(),C(new y.CancellationError)})}):f(k=>d(R,k))}e.timeout=d;function E(R,l=0,k){const C=setTimeout(()=>{R(),k&&N.dispose()},l),N=(0,O.toDisposable)(()=>{clearTimeout(C),k?.deleteAndLeak(N)});return k?.add(N),N}e.disposableTimeout=E;function A(R){const l=[];let k=0;const C=R.length;function N(){return k<C?R[k++]():null}function F(Y){Y!=null&&l.push(Y);const Z=N();return Z?Z.then(F):Promise.resolve(l)}return Promise.resolve(null).then(F)}e.sequence=A;function U(R,l=C=>!!C,k=null){let C=0;const N=R.length,F=()=>{if(C>=N)return Promise.resolve(k);const Y=R[C++];return Promise.resolve(Y()).then(X=>l(X)?Promise.resolve(X):F())};return F()}e.first=U;function L(R,l=C=>!!C,k=null){if(R.length===0)return Promise.resolve(k);let C=R.length;const N=()=>{C=-1;for(const F of R)F.cancel?.()};return new Promise((F,Y)=>{for(const Z of R)Z.then(X=>{--C>=0&&l(X)?(N(),F(X)):C===0&&F(k)}).catch(X=>{--C>=0&&(N(),Y(X))})})}e.firstParallel=L;class v{constructor(l){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((k,C)=>{this.outstandingPromises.push({factory:l,c:k,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const k=l.factory();k.then(l.c,l.e),k.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=v;class D extends v{constructor(){super(1)}}e.Queue=D;class B{constructor(){this.sequentializer=new te,this.tasks=0}queue(l){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,l())):this.sequentializer.run(this.tasks++,l())}}e.LimitedQueue=B;class K{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const l=new x;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueSize(l,k=s.extUri){const C=k.getComparisonKey(l);return this.queues.get(C)?.size??0}queueFor(l,k,C=s.extUri){const N=C.getComparisonKey(l);let F=this.queues.get(N);if(!F){F=new D;const Y=this.drainListenerCount++,Z=S.Event.once(F.onDrained)(()=>{F?.dispose(),this.queues.delete(N),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Y),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(Y,Z),this.queues.set(N,F)}return F.queue(k)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=K;class G{constructor(l,k){this._token=-1,typeof l=="function"&&typeof k=="number"&&this.setIfNotSet(l,k)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,k){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},k)}setIfNotSet(l,k){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},k))}}e.TimeoutTimer=G;class H{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(l,k,C=globalThis){this.cancel();const N=C.setInterval(()=>{l()},k);this.disposable=(0,O.toDisposable)(()=>{C.clearInterval(N),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=H;class j{constructor(l,k){this.timeoutToken=-1,this.runner=l,this.timeout=k,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class ${constructor(l,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=k,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=$;class J extends j{constructor(l,k){super(l,k),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class oe extends O.Disposable{constructor(l,k){super(),this.options=l,this.handler=k,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const k of l)this.pendingWork.push(k);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(R,l)=>{(0,g.setTimeout0)(()=>{if(k)return;const C=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let k=!1;return{dispose(){k||(k=!0)}}}:e._runWhenIdle=(R,l,k)=>{const C=R.requestIdleCallback(l,typeof k=="number"?{timeout:k}:void 0);let N=!1;return{dispose(){N||(N=!0,R.cancelIdleCallback(C))}}},e.runWhenGlobalIdle=R=>(0,e._runWhenIdle)(globalThis,R)}();class ee{constructor(l,k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(C){this._error=C}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(l,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class ue extends ee{constructor(l){super(globalThis,l)}}e.GlobalIdleValue=ue;async function le(R,l,k){let C;for(let N=0;N<k;N++)try{return await R()}catch(F){C=F,await d(l)}throw C}e.retry=le;class te{isRunning(l){return typeof l=="number"?this._running?.taskId===l:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(l,k,C){return this._running={taskId:l,cancel:()=>C?.(),promise:k},k.then(()=>this.doneRunning(l),()=>this.doneRunning(l)),k}doneRunning(l){this._running&&l===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const l=this._queued;this._queued=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this._queued)this._queued.run=l;else{const{promise:k,resolve:C,reject:N}=h();this._queued={run:l,promise:k,promiseResolve:C,promiseReject:N}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=te;class de{constructor(l,k=()=>Date.now()){this.interval=l,this.nowFn=k,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}e.IntervalCounter=de;var ne;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,k)=>{this.completeCallback=l,this.errorCallback=k})}complete(l){return new Promise(k=>{this.completeCallback(l),this.outcome={outcome:0,value:l},k()})}error(l){return new Promise(k=>{this.errorCallback(l),this.outcome={outcome:1,value:l},k()})}cancel(){return this.error(new y.CancellationError)}}e.DeferredPromise=x;var ie;(function(R){async function l(C){let N;const F=await Promise.all(C.map(Y=>Y.then(Z=>Z,Z=>{N||(N=Z)})));if(typeof N<"u")throw N;return F}R.settled=l;function k(C){return new Promise(async(N,F)=>{try{await C(N,F)}catch(Y){F(Y)}})}R.withAsyncBody=k})(ie||(e.Promises=ie={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(l){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=l.then(k=>(this._value=k,this._isResolved=!0,k),k=>{throw this._error=k,this._isResolved=!0,k})}requireValue(){if(!this._isResolved)throw new y.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class ce{constructor(l){this._compute=l,this._promise=new c.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=ce;var se;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(se||(se={}));class Q{static fromArray(l){return new Q(k=>{k.emitMany(l)})}static fromPromise(l){return new Q(async k=>{k.emitMany(await l)})}static fromPromises(l){return new Q(async k=>{await Promise.all(l.map(async C=>k.emitOne(await C)))})}static merge(l){return new Q(async k=>{await Promise.all(l.map(async C=>{for await(const N of C)k.emitOne(N)}))})}static{this.EMPTY=Q.fromArray([])}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const k={emitOne:C=>this.emitOne(C),emitMany:C=>this.emitMany(C),reject:C=>this.reject(C)};try{await Promise.resolve(l(k)),this.resolve()}catch(C){this.reject(C)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,k){return new Q(async C=>{for await(const N of l)C.emitOne(k(N))})}map(l){return Q.map(this,l)}static filter(l,k){return new Q(async C=>{for await(const N of l)k(N)&&C.emitOne(N)})}filter(l){return Q.filter(this,l)}static coalesce(l){return Q.filter(l,k=>!!k)}coalesce(){return Q.coalesce(this)}static async toPromise(l){const k=[];for await(const C of l)k.push(C);return k}toPromise(){return Q.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class ae extends Q{constructor(l,k){super(k),this._source=l}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function he(R){const l=new P.CancellationTokenSource,k=R(l.token);return new ae(l,async C=>{const N=l.token.onCancellationRequested(()=>{N.dispose(),l.dispose(),C.reject(new y.CancellationError)});try{for await(const F of k){if(l.token.isCancellationRequested)return;C.emitOne(F)}N.dispose(),l.dispose()}catch(F){N.dispose(),l.dispose(),C.reject(F)}})}e.createCancelableAsyncIterable=he;class fe{constructor(){this._deferred=new x,this._asyncIterable=new Q(C=>{if(l){C.reject(l);return}return k&&C.emitMany(k),this._errorFn=N=>C.reject(N),this._emitFn=N=>C.emitOne(N),this._deferred.p});let l,k;this._emitFn=C=>{k||(k=[]),k.push(C)},this._errorFn=C=>{l||(l=C)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(l){this._errorFn(l),this._deferred.complete()}emitOne(l){this._emitFn(l)}}e.AsyncIterableSource=fe}),define(q[22],V([0,1,39]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(O){return this===O}};function y(O,s){return new P.TokenizationResult([new P.Token(0,"",O)],s)}e.nullTokenize=y;function S(O,s){const g=new Uint32Array(2);return g[0]=0,g[1]=(O<<0|0|0|32768|2<<24)>>>0,new P.EncodedTokenizationResult(g,s===null?e.NullState:s)}e.nullTokenizeEncoded=S}),define(q[40],V([0,1,21,9,3,41,14,16,49,22,31,17,10]),function(W,e,P,y,S,O,s,g,t,c,m,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var a;(function(w){w[w.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(u,b){this.tokenizationSupport=b,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new r(u)}getStartState(u){return this.store.getStartState(u,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=i;class n extends i{constructor(u,b,_,M){super(u,b),this._textModel=_,this._languageIdCodec=M}updateTokensUntilLine(u,b){const _=this._textModel.getLanguageId();for(;;){const M=this.getFirstInvalidLine();if(!M||M.lineNumber>b)break;const z=this._textModel.getLineContent(M.lineNumber),d=I(this._languageIdCodec,_,this.tokenizationSupport,z,!0,M.startState);u.add(M.lineNumber,d.tokens),this.store.setEndState(M.lineNumber,d.endState)}}getTokenTypeIfInsertingCharacter(u,b){const _=this.getStartState(u.lineNumber);if(!_)return 0;const M=this._textModel.getLanguageId(),z=this._textModel.getLineContent(u.lineNumber),d=z.substring(0,u.column-1)+b+z.substring(u.column-1),E=I(this._languageIdCodec,M,this.tokenizationSupport,d,!0,_),A=new o.LineTokens(E.tokens,d,this._languageIdCodec);if(A.getCount()===0)return 0;const U=A.findTokenIndexAtOffset(u.column-1);return A.getStandardTokenType(U)}tokenizeLineWithEdit(u,b,_){const M=u.lineNumber,z=u.column,d=this.getStartState(M);if(!d)return null;const E=this._textModel.getLineContent(M),A=E.substring(0,z-1)+_+E.substring(z-1+b),U=this._textModel.getLanguageIdAtPosition(M,0),L=I(this._languageIdCodec,U,this.tokenizationSupport,A,!0,d);return new o.LineTokens(L.tokens,A,this._languageIdCodec)}isCheapToTokenize(u){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return u<b||u===b&&this._textModel.getLineLength(u)<2048}tokenizeHeuristically(u,b,_){if(_<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(u,_),{heuristicTokens:!1};let M=this.guessStartState(b);const z=this._textModel.getLanguageId();for(let d=b;d<=_;d++){const E=this._textModel.getLineContent(d),A=I(this._languageIdCodec,z,this.tokenizationSupport,E,!0,M);u.add(d,A.tokens),M=A.endState}return{heuristicTokens:!0}}guessStartState(u){let b=this._textModel.getLineFirstNonWhitespaceColumn(u);const _=[];let M=null;for(let E=u-1;b>1&&E>=1;E--){const A=this._textModel.getLineFirstNonWhitespaceColumn(E);if(A!==0&&A<b&&(_.push(this._textModel.getLineContent(E)),b=A,M=this.getStartState(E),M))break}M||(M=this.tokenizationSupport.getInitialState()),_.reverse();const z=this._textModel.getLanguageId();let d=M;for(const E of _)d=I(this._languageIdCodec,z,this.tokenizationSupport,E,!1,d).endState;return d}}e.TokenizerWithStateStoreAndTextModel=n;class r{constructor(u){this.lineCount=u,this._tokenizationStateStore=new h,this._invalidEndStatesLineNumbers=new T,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,u+1))}getEndState(u){return this._tokenizationStateStore.getEndState(u)}setEndState(u,b){if(!b)throw new y.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(u);const _=this._tokenizationStateStore.setEndState(u,b);return _&&u<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(u+1,u+2)),_}acceptChange(u,b){this.lineCount+=b-u.length,this._tokenizationStateStore.acceptChange(u,b),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(u.startLineNumber,u.endLineNumberExclusive),b)}acceptChanges(u){for(const b of u){const[_]=(0,s.countEOL)(b.text);this.acceptChange(new g.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),_+1)}}invalidateEndStateRange(u){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(u.startLineNumber,u.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(u,b){return u===1?b:this.getEndState(u-1)}getFirstInvalidLine(u){const b=this.getFirstInvalidEndStateLineNumber();if(b===null)return null;const _=this.getStartState(b,u);if(!_)throw new y.BugIndicatingError("Start state must be defined");return{lineNumber:b,startState:_}}}e.TrackingTokenizationStateStore=r;class h{constructor(){this._lineEndStates=new m.FixedArray(null)}getEndState(u){return this._lineEndStates.get(u)}setEndState(u,b){const _=this._lineEndStates.get(u);return _&&_.equals(b)?!1:(this._lineEndStates.set(u,b),!0)}acceptChange(u,b){let _=u.length;b>0&&_>0&&(_--,b--),this._lineEndStates.replace(u.startLineNumber,_,b)}acceptChanges(u){for(const b of u){const[_]=(0,s.countEOL)(b.text);this.acceptChange(new g.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),_+1)}}}e.TokenizationStateStore=h;class T{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const u=this._ranges[0];return u.start+1===u.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(u.start+1,u.endExclusive),u.start}delete(u){const b=this._ranges.findIndex(_=>_.contains(u));if(b!==-1){const _=this._ranges[b];_.start===u?_.endExclusive===u+1?this._ranges.splice(b,1):this._ranges[b]=new t.OffsetRange(u+1,_.endExclusive):_.endExclusive===u+1?this._ranges[b]=new t.OffsetRange(_.start,u):this._ranges.splice(b,1,new t.OffsetRange(_.start,u),new t.OffsetRange(u+1,_.endExclusive))}}addRange(u){t.OffsetRange.addRange(u,this._ranges)}addRangeAndResize(u,b){let _=0;for(;!(_>=this._ranges.length||u.start<=this._ranges[_].endExclusive);)_++;let M=_;for(;!(M>=this._ranges.length||u.endExclusive<this._ranges[M].start);)M++;const z=b-u.length;for(let d=M;d<this._ranges.length;d++)this._ranges[d]=this._ranges[d].delta(z);if(_===M){const d=new t.OffsetRange(u.start,u.start+b);d.isEmpty||this._ranges.splice(_,0,d)}else{const d=Math.min(u.start,this._ranges[_].start),E=Math.max(u.endExclusive,this._ranges[M-1].endExclusive),A=new t.OffsetRange(d,E+z);A.isEmpty?this._ranges.splice(_,M-_):this._ranges.splice(_,M-_,A)}}toString(){return this._ranges.map(u=>u.toString()).join(" + ")}}e.RangePriorityQueueImpl=T;function I(w,u,b,_,M,z){let d=null;if(b)try{d=b.tokenizeEncoded(_,M,z.clone())}catch(E){(0,y.onUnexpectedError)(E)}return d||(d=(0,c.nullTokenizeEncoded)(w.encodeLanguageId(u),z)),o.LineTokens.convertToEndOffset(d.tokens,_.length),d}class p{constructor(u,b){this._tokenizerWithStateStore=u,this._backgroundTokenStore=b,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,P.runWhenGlobalIdle)(u=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(u)}))}_backgroundTokenizeWithDeadline(u){const b=Date.now()+u.timeRemaining(),_=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<b?(0,S.setTimeout0)(_):this._beginBackgroundTokenization())};_()}_backgroundTokenizeForAtLeast1ms(){const u=this._tokenizerWithStateStore._textModel.getLineCount(),b=new f.ContiguousMultilineTokensBuilder,_=O.StopWatch.create(!1);do if(_.elapsed()>1||this._tokenizeOneInvalidLine(b)>=u)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(b.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(u){const b=this._tokenizerWithStateStore?.getFirstInvalidLine();return b?(this._tokenizerWithStateStore.updateTokensUntilLine(u,b.lineNumber),b.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(u,b){this._tokenizerWithStateStore.store.invalidateEndStateRange(new g.LineRange(u,b))}}e.DefaultBackgroundTokenizer=p}),define(q[42],V([0,1,38,2,41,15,39]),function(W,e,P,y,S,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class g extends y.Disposable{constructor(c,m,f,o,a,i,n){super(),this._grammar=c,this._initialState=m,this._containsEmbeddedLanguages=f,this._createBackgroundTokenizer=o,this._backgroundTokenizerShouldOnlyVerifyTokens=a,this._reportTokenizationTime=i,this._reportSlowTokenization=n,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new P.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(c,m,f){throw new Error("Not supported!")}createBackgroundTokenizer(c,m){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(c,m)}tokenizeEncoded(c,m,f){const o=Math.random()*1e4<1,a=this._reportSlowTokenization||o,i=a?new S.StopWatch(!0):void 0,n=this._grammar.tokenizeLine2(c,f,500);if(a){const h=i.elapsed();(o||h>32)&&this._reportTokenizationTime(h,c.length,o)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${c.substring(0,100)}`),new s.EncodedTokenizationResult(n.tokens,f);if(this._containsEmbeddedLanguages){const h=this._seenLanguages,T=n.tokens;for(let I=0,p=T.length>>>1;I<p;I++){const w=T[(I<<1)+1],u=O.TokenMetadata.getLanguageId(w);h[u]||(h[u]=!0,this._onDidEncounterLanguage.fire(u))}}let r;return f.equals(n.ruleStack)?r=f:r=n.ruleStack,new s.EncodedTokenizationResult(n.tokens,r)}}e.TextMateTokenizationSupport=g}),define(q[43],V([0,1,22,2,12]),function(W,e,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class O extends y.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(g,t,c){super(),this._encodedLanguageId=g,this._actual=t,this._maxTokenizationLineLength=c,this._register((0,S.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(g,t,c){throw new Error("Not supported!")}tokenizeEncoded(g,t,c){return g.length>=this._maxTokenizationLineLength.get()?(0,P.nullTokenizeEncoded)(this._encodedLanguageId,c):this._actual.tokenizeEncoded(g,t,c)}createBackgroundTokenizer(g,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(g,t)}}e.TokenizationSupportWithLineLimit=O}),define(q[44],V([0,1,37,21,12,3,16,50,40,17,10,42,43]),function(W,e,P,y,S,O,s,g,t,c,m,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class a extends g.MirrorTextModel{constructor(r,h,T,I,p,w,u,b){super(r,h,T,I),this._host=p,this._languageId=w,this._encodedLanguageId=u,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,S.observableValue)(this,-1),this._tokenizeDebouncer=new y.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(b,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(r,h){this._languageId=r,this._encodedLanguageId=h,this._resetTokenization()}onEvents(r){super.onEvents(r),this._tokenizerWithStateStore?.store.acceptChanges(r.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(r){this._maxTokenizationLineLength.set(r,void 0)}retokenize(r,h){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new s.LineRange(r,h)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const r=this._languageId,h=this._encodedLanguageId,T=await this._host.getOrCreateGrammar(r,h);if(!(this._isDisposed||r!==this._languageId||h!==this._encodedLanguageId||!T)){if(T.grammar){const I=new o.TokenizationSupportWithLineLimit(this._encodedLanguageId,new f.TextMateTokenizationSupport(T.grammar,T.initialState,!1,void 0,()=>!1,(p,w,u)=>{this._host.reportTokenizationTime(p,r,T.sourceExtensionId,w,u)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,I)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:h}=await(0,P.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=h}const r=new Date().getTime();for(;;){let h=0;const T=new c.ContiguousMultilineTokensBuilder,I=new i;for(;;){const u=this._tokenizerWithStateStore.getFirstInvalidLine();if(u===null||h>200)break;h++;const b=this._lines[u.lineNumber-1],_=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(b,!0,u.startState);if(this._tokenizerWithStateStore.store.setEndState(u.lineNumber,_.endState)){const z=this._diffStateStacksRefEqFn(u.startState,_.endState);I.setState(u.lineNumber,z)}else I.setState(u.lineNumber,null);if(m.LineTokens.convertToEndOffset(_.tokens,b.length),T.add(u.lineNumber,_.tokens),new Date().getTime()-r>20)break}if(h===0)break;const p=I.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,T.serialize(),p),new Date().getTime()-r>20){(0,O.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=a;class i{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(r,h){r===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(h):this._stateDeltas.push({startLineNumber:r,stateDeltas:[h]}),this._lastStartLineNumber=r}getStateDeltas(){return this._stateDeltas}}}),define(q[45],V([0,1,20]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class y{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(O){if(this._scopeNameToLanguageRegistration[O.scopeName]){const s=this._scopeNameToLanguageRegistration[O.scopeName];P.isEqual(s.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${O.location.toString()}`)}this._scopeNameToLanguageRegistration[O.scopeName]=O}getGrammarDefinition(O){return this._scopeNameToLanguageRegistration[O]||null}}e.TMScopeRegistry=y}),define(q[46],V([0,1,2,45]),function(W,e,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class S extends P.Disposable{constructor(s,g,t,c){super(),this._host=s,this._initialState=t.INITIAL,this._scopeRegistry=new y.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:c,loadGrammar:async m=>{const f=this._scopeRegistry.getGrammarDefinition(m);if(!f)return this._host.logTrace(`No grammar found for scope ${m}`),null;const o=f.location;try{const a=await this._host.readFile(o);return t.parseRawGrammar(a,o.path)}catch(a){return this._host.logError(`Unable to load and parse grammar for scope ${m} from ${o}`,a),null}},getInjections:m=>{const f=m.split(".");let o=[];for(let a=1;a<=f.length;a++){const i=f.slice(0,a).join(".");o=[...o,...this._injections[i]||[]]}return o}}));for(const m of g){if(this._scopeRegistry.register(m),m.injectTo){for(const f of m.injectTo){let o=this._injections[f];o||(this._injections[f]=o=[]),o.push(m.scopeName)}if(m.embeddedLanguages)for(const f of m.injectTo){let o=this._injectedEmbeddedLanguages[f];o||(this._injectedEmbeddedLanguages[f]=o=[]),o.push(m.embeddedLanguages)}}m.language&&this._languageToScope.set(m.language,m.scopeName)}}has(s){return this._languageToScope.has(s)}setTheme(s,g){this._grammarRegistry.setTheme(s,g)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(s,g){const t=this._languageToScope.get(s);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const c=this._scopeRegistry.getGrammarDefinition(t);if(!c)throw new Error(e.missingTMGrammarErrorMessage);const m=c.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const a=this._injectedEmbeddedLanguages[t];for(const i of a)for(const n of Object.keys(i))m[n]=i[n]}const f=Object.keys(m).length>0;let o;try{o=await this._grammarRegistry.loadGrammarWithConfiguration(t,g,{embeddedLanguages:m,tokenTypes:c.tokenTypes,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):a}return{languageId:s,grammar:o,initialState:this._initialState,containsEmbeddedLanguages:f,sourceExtensionId:c.sourceExtensionId}}}e.TMGrammarFactory=S}),define(q[51],V([0,1,11,46,44]),function(W,e,P,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(g,t){return new s(g,t)}e.create=O;class s{constructor(t,c){this._createData=c,this._models=new Map,this._grammarCache=[],this._host=t.host;const m=c.grammarDefinitions.map(f=>({location:P.URI.revive(f.location),language:f.language,scopeName:f.scopeName,embeddedLanguages:f.embeddedLanguages,tokenTypes:f.tokenTypes,injectTo:f.injectTo,balancedBracketSelectors:f.balancedBracketSelectors,unbalancedBracketSelectors:f.unbalancedBracketSelectors,sourceExtensionId:f.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(m)}async _loadTMGrammarFactory(t){const c=this._createData.textmateMainUri,m=await new Promise((n,r)=>{W([c],n,r)}),f=await new Promise((n,r)=>{W([this._createData.onigurumaMainUri],n,r)}),a=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await f.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>f.createOnigScanner(n),createOnigString:n=>f.createOnigString(n)});return new y.TMGrammarFactory({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this._host.readFile(n)},t,m,i)}acceptNewModel(t){const c=P.URI.revive(t.uri),m=this;this._models.set(t.controllerId,new S.TextMateWorkerTokenizer(c,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(f,o){const a=await m._grammarFactory;return a?(m._grammarCache[o]||(m._grammarCache[o]=a.createGrammar(f,o)),m._grammarCache[o]):Promise.resolve(null)},setTokensAndStates(f,o,a){m._host.setTokensAndStates(t.controllerId,f,o,a)},reportTokenizationTime(f,o,a,i,n){m._host.reportTokenizationTime(f,o,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,c){this._models.get(t).onEvents(c)}retokenize(t,c,m){this._models.get(t).retokenize(c,m)}acceptModelLanguageChanged(t,c,m){this._models.get(t).onLanguageId(c,m)}acceptRemovedModel(t){const c=this._models.get(t);c&&(c.dispose(),this._models.delete(t))}async acceptTheme(t,c){(await this._grammarFactory)?.setTheme(t,c)}acceptMaxTokenizationLineLength(t,c){this._models.get(t).acceptMaxTokenizationLineLength(c)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f7ed6417a7cfae92f98129384c13b505bb9cfc53/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
